/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],oe=function(Q){for(var e=[],n=0,A=Q.length;n<A;n++)e[n]=re[Q[n]];return e};define(re[136],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=A,e.$hb=S,e.$ib=R,e.$jb=j,e.$kb=k,e.$lb=u,e.$nb=d,e.$ob=p,e.$pb=v,e.$qb=$,e.$rb=f;function n(y,w){const b=A(y,w);if(b!==-1)return y[b]}function A(y,w,b=y.length-1){for(let g=b;g>=0;g--){const h=y[g];if(w(h))return g}return-1}function S(y,w){const b=R(y,w);return b===-1?void 0:y[b]}function R(y,w,b=0,g=y.length){let h=b,E=g;for(;h<E;){const a=Math.floor((h+E)/2);w(y[a])?h=a+1:E=a}return h-1}function j(y,w){const b=k(y,w);return b===y.length?void 0:y[b]}function k(y,w,b=0,g=y.length){let h=b,E=g;for(;h<E;){const a=Math.floor((h+E)/2);w(y[a])?E=a:h=a+1}return h}function u(y,w,b=0,g=y.length){const h=k(y,w,b,g);return h===y.length?-1:h}class c{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(c.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!w(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const b=R(this.e,w,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$mb=c;function d(y,w){if(y.length===0)return;let b=y[0];for(let g=1;g<y.length;g++){const h=y[g];w(h,b)>0&&(b=h)}return b}function p(y,w){if(y.length===0)return;let b=y[0];for(let g=1;g<y.length;g++){const h=y[g];w(h,b)>=0&&(b=h)}return b}function v(y,w){return d(y,(b,g)=>-w(b,g))}function $(y,w){if(y.length===0)return-1;let b=0;for(let g=1;g<y.length;g++){const h=y[g];w(h,y[b])>0&&(b=g)}return b}function f(y,w){for(const b of y){const g=w(b);if(g!==void 0)return g}}}),define(re[137],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=A,e.$M=S,e.$N=R;function n(j,k){const u=Object.create(null);for(const c of j){const d=k(c);let p=u[d];p||(p=u[d]=[]),p.push(c)}return u}function A(j,k){const u=[],c=[];for(const d of j)k.has(d)||u.push(d);for(const d of k)j.has(d)||c.push(d);return{removed:u,added:c}}function S(j,k){const u=[],c=[];for(const[d,p]of j)k.has(d)||u.push(p);for(const[d,p]of k)j.has(d)||c.push(p);return{removed:u,added:c}}function R(j,k){const u=new Set;for(const c of k)j.has(c)&&u.add(c);return u}}),define(re[138],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_t=e.$$t=e.$0t=e.$9t=void 0;function n(k,u){const c=Math.pow(10,u);return Math.round(k*c)/c}class A{constructor(u,c,d,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=n(Math.max(Math.min(1,p),0),3)}static equals(u,c){return u.r===c.r&&u.g===c.g&&u.b===c.b&&u.a===c.a}}e.$9t=A;class S{constructor(u,c,d,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,d),0),3),this.a=n(Math.max(Math.min(1,p),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.l===c.l&&u.a===c.a}static fromRGBA(u){const c=u.r/255,d=u.g/255,p=u.b/255,v=u.a,$=Math.max(c,d,p),f=Math.min(c,d,p);let y=0,w=0;const b=(f+$)/2,g=$-f;if(g>0){switch(w=Math.min(b<=.5?g/(2*b):g/(2-2*b),1),$){case c:y=(d-p)/g+(d<p?6:0);break;case d:y=(p-c)/g+2;break;case p:y=(c-d)/g+4;break}y*=60,y=Math.round(y)}return new S(y,w,b,v)}static i(u,c,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?u+(c-u)*6*d:d<1/2?c:d<2/3?u+(c-u)*(2/3-d)*6:u}static toRGBA(u){const c=u.h/360,{s:d,l:p,a:v}=u;let $,f,y;if(d===0)$=f=y=p;else{const w=p<.5?p*(1+d):p+d-p*d,b=2*p-w;$=S.i(b,w,c+1/3),f=S.i(b,w,c),y=S.i(b,w,c-1/3)}return new A(Math.round($*255),Math.round(f*255),Math.round(y*255),v)}}e.$0t=S;class R{constructor(u,c,d,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,d),0),3),this.a=n(Math.max(Math.min(1,p),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.v===c.v&&u.a===c.a}static fromRGBA(u){const c=u.r/255,d=u.g/255,p=u.b/255,v=Math.max(c,d,p),$=Math.min(c,d,p),f=v-$,y=v===0?0:f/v;let w;return f===0?w=0:v===c?w=((d-p)/f%6+6)%6:v===d?w=(p-c)/f+2:w=(c-d)/f+4,new R(Math.round(w*60),y,v,u.a)}static toRGBA(u){const{h:c,s:d,v:p,a:v}=u,$=p*d,f=$*(1-Math.abs(c/60%2-1)),y=p-$;let[w,b,g]=[0,0,0];return c<60?(w=$,b=f):c<120?(w=f,b=$):c<180?(b=$,g=f):c<240?(b=f,g=$):c<300?(w=f,g=$):c<=360&&(w=$,g=f),w=Math.round((w+y)*255),b=Math.round((b+y)*255),g=Math.round((g+y)*255),new A(w,b,g,v)}}e.$$t=R;class j{static fromHex(u){return j.Format.CSS.parseHex(u)||j.red}static equals(u,c){return!u&&!c?!0:!u||!c?!1:u.equals(c)}get hsla(){return this.i?this.i:S.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof A)this.rgba=u;else if(u instanceof S)this.i=u,this.rgba=S.toRGBA(u);else if(u instanceof R)this.j=u,this.rgba=R.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&A.equals(this.rgba,u.rgba)&&S.equals(this.hsla,u.hsla)&&R.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=j.k(this.rgba.r),c=j.k(this.rgba.g),d=j.k(this.rgba.b),p=.2126*u+.7152*c+.0722*d;return n(p,4)}static k(u){const c=u/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(u){const c=this.getRelativeLuminance(),d=u.getRelativeLuminance();return c>d?(c+.05)/(d+.05):(d+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const c=this.getRelativeLuminance(),d=u.getRelativeLuminance();return c>d}isDarkerThan(u){const c=this.getRelativeLuminance(),d=u.getRelativeLuminance();return c<d}lighten(u){return new j(new S(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new j(new S(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:c,g:d,b:p,a:v}=this.rgba;return new j(new A(c,d,p,v*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new j(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const c=u.rgba,d=this.rgba.a,p=c.a,v=d+p*(1-d);if(v<1e-6)return j.transparent;const $=this.rgba.r*d/v+c.r*p*(1-d)/v,f=this.rgba.g*d/v+c.g*p*(1-d)/v,y=this.rgba.b*d/v+c.b*p*(1-d)/v;return new j(new A($,f,y,v))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:c,g:d,b:p,a:v}=this.rgba;return new j(new A(u.rgba.r-v*(u.rgba.r-c),u.rgba.g-v*(u.rgba.g-d),u.rgba.b-v*(u.rgba.b-p),1))}flatten(...u){const c=u.reduceRight((d,p)=>j.o(p,d));return j.o(this,c)}static o(u,c){const d=1-u.rgba.a;return new j(new A(d*c.rgba.r+u.rgba.a*u.rgba.r,d*c.rgba.g+u.rgba.a*u.rgba.g,d*c.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=j.Format.CSS.format(this)),this.u}static getLighterColor(u,c,d){if(u.isLighterThan(c))return u;d=d||.5;const p=u.getRelativeLuminance(),v=c.getRelativeLuminance();return d=d*(v-p)/v,u.lighten(d)}static getDarkerColor(u,c,d){if(u.isDarkerThan(c))return u;d=d||.5;const p=u.getRelativeLuminance(),v=c.getRelativeLuminance();return d=d*(p-v)/p,u.darken(d)}static{this.white=new j(new A(255,255,255,1))}static{this.black=new j(new A(0,0,0,1))}static{this.red=new j(new A(255,0,0,1))}static{this.blue=new j(new A(0,0,255,1))}static{this.green=new j(new A(0,255,0,1))}static{this.cyan=new j(new A(0,255,255,1))}static{this.lightgrey=new j(new A(211,211,211,1))}static{this.transparent=new j(new A(0,0,0,0))}}e.$_t=j,function(k){let u;(function(c){let d;(function(p){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}p.formatRGB=v;function $(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}p.formatRGBA=$;function f(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}p.formatHSL=f;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}p.formatHSLA=y;function w(t){const r=t.toString(16);return r.length!==2?"0"+r:r}function b(t){return`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}`}p.formatHex=b;function g(t,r=!1){return r&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}${w(Math.round(t.rgba.a*255))}`}p.formatHexA=g;function h(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}p.format=h;function E(t){const r=t.length;if(r===0||t.charCodeAt(0)!==35)return null;if(r===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new k(new A(s,i,o,1))}if(r===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),l=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new k(new A(s,i,o,l/255))}if(r===4){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3));return new k(new A(16*s+s,16*i+i,16*o+o))}if(r===5){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3)),l=a(t.charCodeAt(4));return new k(new A(16*s+s,16*i+i,16*o+o,(16*l+l)/255))}return null}p.parseHex=E;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=c.CSS||(c.CSS={}))})(u=k.Format||(k.Format={}))}(j||(e.$_t=j={}))}),define(re[51],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=A,e.$6h=S,e.$7h=R;function n(j){return(k,u,c)=>{let d=null,p=null;if(typeof c.value=="function"?(d="value",p=c.value):typeof c.get=="function"&&(d="get",p=c.get),!p)throw new Error("not supported");c[d]=j(p,u)}}function A(j,k,u){let c=null,d=null;if(typeof u.value=="function"?(c="value",d=u.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",d=u.get),!d)throw new Error("not supported");const p=`$memoize$${k}`;u[c]=function(...v){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,v)}),this[p]}}function S(j,k,u){return n((c,d)=>{const p=`$debounce$${d}`,v=`$debounce$result$${d}`;return function(...$){this[v]||(this[v]=u?u():void 0),clearTimeout(this[p]),k&&(this[v]=k(this[v],...$),$=[this[v]]),this[p]=setTimeout(()=>{c.apply(this,$),this[v]=u?u():void 0},j)}})}function R(j,k,u){return n((c,d)=>{const p=`$throttle$timer$${d}`,v=`$throttle$result$${d}`,$=`$throttle$lastRun$${d}`,f=`$throttle$pending$${d}`;return function(...y){if(this[v]||(this[v]=u?u():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),k&&(this[v]=k(this[v],...y)),this[f])return;const w=this[$]+j;w<=Date.now()?(this[$]=Date.now(),c.apply(this,[this[v]]),this[v]=u?u():void 0):(this[f]=!0,this[p]=setTimeout(()=>{this[f]=!1,this[$]=Date.now(),c.apply(this,[this[v]]),this[v]=u?u():void 0},w-Date.now()))}})}}),define(re[15],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=A,e.$Z=S,e.$1=R,e.$2=j,e.$3=k,e.$4=c,e.$6=p,e.$7=v,e.$8=$,e.$0=y;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function A(a){e.$X.setUnexpectedErrorHandler(a)}function S(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(a){c(a)||e.$X.onUnexpectedError(a)}function j(a){c(a)||e.$X.onUnexpectedExternalError(a)}function k(a){if(a instanceof Error){const{name:t,message:r}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:s,noTelemetry:h.isErrorNoTelemetry(a)}}return a}const u="Canceled";function c(a){return a instanceof d?!0:a instanceof Error&&a.name===u&&a.message===u}class d extends Error{constructor(){super(u),this.name=this.message}}e.$5=d;function p(){const a=new Error(u);return a.name=a.message,a}function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function $(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class f extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=f;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=w;class b extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=b;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const r=new h;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$cb=E}),define(re[22],oe([0,1,15,136]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=S,e.$tb=R,e.$ub=j,e.$vb=k,e.$wb=u,e.$xb=c,e.$yb=d,e.$zb=p,e.$Ab=v,e.$Bb=$,e.$Cb=f,e.$Db=y,e.$Eb=w,e.top=b,e.$Gb=g,e.$Hb=E,e.$Ib=a,e.$Jb=t,e.$Kb=r,e.$Lb=s,e.$Mb=i,e.$Nb=o,e.$Ob=l,e.$Pb=m,e.$Qb=P,e.$Rb=D,e.$Sb=I,e.$Tb=O,e.$Ub=M,e.$Vb=W,e.$Wb=N,e.$Xb=T,e.$Yb=U,e.$Zb=ie,e.$1b=te,e.$2b=ae,e.$3b=K,e.$4b=J,e.$5b=q,e.$6b=H,e.$7b=ce,e.$0b=Y;function S(B,Z=0){return B[B.length-(1+Z)]}function R(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function j(B,Z,x=(ee,G)=>ee===G){if(B===Z)return!0;if(!B||!Z||B.length!==Z.length)return!1;for(let ee=0,G=B.length;ee<G;ee++)if(!x(B[ee],Z[ee]))return!1;return!0}function k(B,Z){const x=B.length-1;Z<x&&(B[Z]=B[x]),B.pop()}function u(B,Z,x){return c(B.length,ee=>x(B[ee],Z))}function c(B,Z){let x=0,ee=B-1;for(;x<=ee;){const G=(x+ee)/2|0,ue=Z(G);if(ue<0)x=G+1;else if(ue>0)ee=G-1;else return G}return-(x+1)}function d(B,Z,x){if(B=B|0,B>=Z.length)throw new TypeError("invalid index");const ee=Z[Math.floor(Z.length*Math.random())],G=[],ue=[],fe=[];for(const we of Z){const Ee=x(we,ee);Ee<0?G.push(we):Ee>0?ue.push(we):fe.push(we)}return B<G.length?d(B,G,x):B<G.length+fe.length?fe[0]:d(B-(G.length+fe.length),ue,x)}function p(B,Z){const x=[];let ee;for(const G of B.slice(0).sort(Z))!ee||Z(ee[0],G)!==0?(ee=[G],x.push(ee)):ee.push(G);return x}function*v(B,Z){let x,ee;for(const G of B)ee!==void 0&&Z(ee,G)?x.push(G):(x&&(yield x),x=[G]),ee=G;x&&(yield x)}function $(B,Z){for(let x=0;x<=B.length;x++)Z(x===0?void 0:B[x-1],x===B.length?void 0:B[x])}function f(B,Z){for(let x=0;x<B.length;x++)Z(x===0?void 0:B[x-1],B[x],x+1===B.length?void 0:B[x+1])}function y(B,Z,x){const ee=[];function G(we,Ee,Oe){if(Ee===0&&Oe.length===0)return;const ye=ee[ee.length-1];ye&&ye.start+ye.deleteCount===we?(ye.deleteCount+=Ee,ye.toInsert.push(...Oe)):ee.push({start:we,deleteCount:Ee,toInsert:Oe})}let ue=0,fe=0;for(;;){if(ue===B.length){G(ue,0,Z.slice(fe));break}if(fe===Z.length){G(ue,B.length-ue,[]);break}const we=B[ue],Ee=Z[fe],Oe=x(we,Ee);Oe===0?(ue+=1,fe+=1):Oe<0?(G(ue,1,[]),ue+=1):Oe>0&&(G(ue,0,[Ee]),fe+=1)}return ee}function w(B,Z,x){const ee=y(B,Z,x),G=[],ue=[];for(const fe of ee)G.push(...B.slice(fe.start,fe.start+fe.deleteCount)),ue.push(...fe.toInsert);return{removed:G,added:ue}}function b(B,Z,x){if(x===0)return[];const ee=B.slice(0,x).sort(Z);return h(B,Z,ee,x,B.length),ee}function g(B,Z,x,ee,G){return x===0?Promise.resolve([]):new Promise((ue,fe)=>{(async()=>{const we=B.length,Ee=B.slice(0,x).sort(Z);for(let Oe=x,ye=Math.min(x+ee,we);Oe<we;Oe=ye,ye=Math.min(ye+ee,we)){if(Oe>x&&await new Promise(ve=>setTimeout(ve)),G&&G.isCancellationRequested)throw new n.$5;h(B,Z,Ee,Oe,ye)}return Ee})().then(ue,fe)})}function h(B,Z,x,ee,G){for(const ue=x.length;ee<G;ee++){const fe=B[ee];if(Z(fe,x[ue-1])<0){x.pop();const we=(0,A.$kb)(x,Ee=>Z(fe,Ee)<0);x.splice(we,0,fe)}}}function E(B){return B.filter(Z=>!!Z)}function a(B){let Z=0;for(let x=0;x<B.length;x++)B[x]&&(B[Z]=B[x],Z+=1);B.length=Z}function t(B,Z,x){B.splice(x,0,B.splice(Z,1)[0])}function r(B){return!Array.isArray(B)||B.length===0}function s(B){return Array.isArray(B)&&B.length>0}function i(B,Z=x=>x){const x=new Set;return B.filter(ee=>{const G=Z(ee);return x.has(G)?!1:(x.add(G),!0)})}function o(B){const Z=new Set;return x=>{const ee=B(x);return Z.has(ee)?!1:(Z.add(ee),!0)}}function l(B,Z){return B.length>0?B[0]:Z}function m(B,Z){return B.length>0?B[B.length-1]:Z}function P(B,Z,x=(ee,G)=>ee===G){let ee=0;for(let G=0,ue=Math.min(B.length,Z.length);G<ue&&x(B[G],Z[G]);G++)ee++;return ee}function D(B,Z){let x=typeof Z=="number"?B:0;typeof Z=="number"?x=B:(x=0,Z=B);const ee=[];if(x<=Z)for(let G=x;G<Z;G++)ee.push(G);else for(let G=x;G>Z;G--)ee.push(G);return ee}function I(B,Z,x){return B.reduce((ee,G)=>(ee[Z(G)]=x?x(G):G,ee),Object.create(null))}function O(B,Z){return B.push(Z),()=>M(B,Z)}function M(B,Z){const x=B.indexOf(Z);if(x>-1)return B.splice(x,1),Z}function W(B,Z,x){const ee=B.slice(0,Z),G=B.slice(Z);return ee.concat(x,G)}function N(B,Z){let x;if(typeof Z=="number"){let ee=Z;x=()=>{const G=Math.sin(ee++)*179426549;return G-Math.floor(G)}}else x=Math.random;for(let ee=B.length-1;ee>0;ee-=1){const G=Math.floor(x()*(ee+1)),ue=B[ee];B[ee]=B[G],B[G]=ue}}function T(B,Z){const x=B.indexOf(Z);x>-1&&(B.splice(x,1),B.unshift(Z))}function U(B,Z){const x=B.indexOf(Z);x>-1&&(B.splice(x,1),B.push(Z))}function ie(B,Z){for(const x of Z)B.push(x)}function te(B,Z){return Array.isArray(B)?B.map(Z):Z(B)}function ae(B){return Array.isArray(B)?B:[B]}function K(B){return B[Math.floor(Math.random()*B.length)]}function J(B,Z,x){const ee=L(B,Z),G=B.length,ue=x.length;B.length=G+ue;for(let fe=G-1;fe>=ee;fe--)B[fe+ue]=B[fe];for(let fe=0;fe<ue;fe++)B[fe+ee]=x[fe]}function q(B,Z,x,ee){const G=L(B,Z);let ue=B.splice(G,x);return ue===void 0&&(ue=[]),J(B,G,ee),ue}function L(B,Z){return Z<0?Math.max(Z+B.length,0):Math.min(Z,B.length)}var z;(function(B){function Z(ue){return ue<0}B.isLessThan=Z;function x(ue){return ue<=0}B.isLessThanOrEqual=x;function ee(ue){return ue>0}B.isGreaterThan=ee;function G(ue){return ue===0}B.isNeitherLessOrGreaterThan=G,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(z||(e.CompareResult=z={}));function H(B,Z){return(x,ee)=>Z(B(x),B(ee))}function ce(...B){return(Z,x)=>{for(const ee of B){const G=ee(Z,x);if(!z.isNeitherLessOrGreaterThan(G))return G}return z.neitherLessOrGreaterThan}}const V=(B,Z)=>B-Z;e.$8b=V;const le=(B,Z)=>(0,e.$8b)(B?1:0,Z?1:0);e.$9b=le;function Y(B){return(Z,x)=>-B(Z,x)}class C{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let x=this.c;for(;x<this.g.length&&Z(this.g[x]);)x++;const ee=x===this.c?null:this.g.slice(this.c,x);return this.c=x,ee}takeFromEndWhile(Z){let x=this.d;for(;x>=0&&Z(this.g[x]);)x--;const ee=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const x=this.g.slice(this.c,this.c+Z);return this.c+=Z,x}}e.$$b=C;class F{static{this.empty=new F(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(x=>(Z(x),!0))}toArray(){const Z=[];return this.iterate(x=>(Z.push(x),!0)),Z}filter(Z){return new F(x=>this.iterate(ee=>Z(ee)?x(ee):!0))}map(Z){return new F(x=>this.iterate(ee=>x(Z(ee))))}some(Z){let x=!1;return this.iterate(ee=>(x=Z(ee),!x)),x}findFirst(Z){let x;return this.iterate(ee=>Z(ee)?(x=ee,!1):!0),x}findLast(Z){let x;return this.iterate(ee=>(Z(ee)&&(x=ee),!0)),x}findLastMaxBy(Z){let x,ee=!0;return this.iterate(G=>((ee||z.isGreaterThan(Z(G,x)))&&(ee=!1,x=G),!0)),x}}e.$_b=F;class _{constructor(Z){this.c=Z}static createSortPermutation(Z,x){const ee=Array.from(Z.keys()).sort((G,ue)=>x(Z[G],Z[ue]));return new _(ee)}apply(Z){return Z.map((x,ee)=>Z[this.c[ee]])}inverse(){const Z=this.c.slice();for(let x=0;x<this.c.length;x++)Z[this.c[x]]=x;return new _(Z)}}e.$ac=_}),define(re[139],oe([0,1,15]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=A,e.$ed=S,e.$fd=R,e.$gd=j,e.$hd=k,e.$id=u;function A(c,d){if(!c)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function S(c,d="Unreachable"){throw new Error(d)}function R(c,d="unexpected state"){if(!c)throw new n.$cb(`Assertion Failed: ${d}`)}function j(c){c||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function k(c){if(!c()){debugger;c(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function u(c,d){let p=0;for(;p<c.length-1;){const v=c[p],$=c[p+1];if(!d(v,$))return!1;p++}return!0}}),define(re[86],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(A,S){const R=this;let j=!1,k;return function(){if(j)return k;if(j=!0,S)try{k=A.apply(R,arguments)}finally{S()}else k=A.apply(R,arguments);return k}}}),define(re[71],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(A){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}A.is=S;const R=Object.freeze([]);function j(){return R}A.empty=j;function*k(t){yield t}A.single=k;function u(t){return S(t)?t:k(t)}A.wrap=u;function c(t){return t||R}A.from=c;function*d(t){for(let r=t.length-1;r>=0;r--)yield t[r]}A.reverse=d;function p(t){return!t||t[Symbol.iterator]().next().done===!0}A.isEmpty=p;function v(t){return t[Symbol.iterator]().next().value}A.first=v;function $(t,r){for(const s of t)if(r(s))return!0;return!1}A.some=$;function f(t,r){for(const s of t)if(r(s))return s}A.find=f;function*y(t,r){for(const s of t)r(s)&&(yield s)}A.filter=y;function*w(t,r){let s=0;for(const i of t)yield r(i,s++)}A.map=w;function*b(...t){for(const r of t)yield*r}A.concat=b;function g(t,r,s){let i=s;for(const o of t)i=r(i,o);return i}A.reduce=g;function*h(t,r,s=t.length){for(r<0&&(r+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);r<s;r++)yield t[r]}A.slice=h;function E(t,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,t];const i=t[Symbol.iterator]();for(let o=0;o<r;o++){const l=i.next();if(l.done)return[s,A.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return i}}]}A.consume=E;async function a(t){const r=[];for await(const s of t)r.push(s);return Promise.resolve(r)}A.asyncToArray=a})(n||(e.Iterable=n={}))}),define(re[42],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Ln=j,e.$Mn=p,e.$Nn=v,e.$On=$,e.$Pn=f,e.$Qn=y,e.$Rn=w,e.$Sn=b,e.$Tn=g,e.$Un=h,e.$Vn=E,e.$Wn=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function j(t,r=!1){let s=0;const i=t.length;let o="",l=0,m=16,P=0;function D(U){let ie=0,te=0;for(;ie<U;){const ae=t.charCodeAt(s);if(ae>=48&&ae<=57)te=te*16+ae-48;else if(ae>=65&&ae<=70)te=te*16+ae-65+10;else if(ae>=97&&ae<=102)te=te*16+ae-97+10;else break;s++,ie++}return ie<U&&(te=-1),te}function I(U){s=U,o="",l=0,m=16,P=0}function O(){const U=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&c(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&c(t.charCodeAt(s)))for(s++;s<t.length&&c(t.charCodeAt(s));)s++;else return P=3,t.substring(U,s);let ie=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&c(t.charCodeAt(s))){for(s++;s<t.length&&c(t.charCodeAt(s));)s++;ie=s}else P=3;return t.substring(U,ie)}function M(){let U="",ie=s;for(;;){if(s>=i){U+=t.substring(ie,s),P=2;break}const te=t.charCodeAt(s);if(te===34){U+=t.substring(ie,s),s++;break}if(te===92){if(U+=t.substring(ie,s),s++,s>=i){P=2;break}switch(t.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const K=D(4);K>=0?U+=String.fromCharCode(K):P=4;break}default:P=5}ie=s;continue}if(te>=0&&te<=31)if(u(te)){U+=t.substring(ie,s),P=2;break}else P=6;s++}return U}function W(){if(o="",P=0,l=s,s>=i)return l=i,m=17;let U=t.charCodeAt(s);if(k(U)){do s++,o+=String.fromCharCode(U),U=t.charCodeAt(s);while(k(U));return m=15}if(u(U))return s++,o+=String.fromCharCode(U),U===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),m=14;switch(U){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,o=M(),m=10;case 47:{const ie=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!u(t.charCodeAt(s));)s++;return o=t.substring(ie,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const te=i-1;let ae=!1;for(;s<te;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ae=!0;break}s++}return ae||(s++,P=1),o=t.substring(ie,s),m=13}return o+=String.fromCharCode(U),s++,m=16}case 45:if(o+=String.fromCharCode(U),s++,s===i||!c(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),m=11;default:for(;s<i&&N(U);)s++,U=t.charCodeAt(s);if(l!==s){switch(o=t.substring(l,s),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(U),s++,m=16}}function N(U){if(k(U)||u(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let U;do U=W();while(U>=12&&U<=15);return U}return{setPosition:I,getPosition:()=>s,scan:r?T:W,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>P}}function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var d;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(d||(d={}));function p(t,r){const s=[],i=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function P(D,I,O,M){l.value=D,l.offset=I,l.length=O,l.type=M,l.colonOffset=void 0,o=l}try{h(t,{onObjectBegin:(D,I)=>{if(r<=D)throw i;o=void 0,m=r>D,s.push("")},onObjectProperty:(D,I,O)=>{if(r<I||(P(D,I,O,"property"),s[s.length-1]=D,r<=I+O))throw i},onObjectEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onArrayBegin:(D,I)=>{if(r<=D)throw i;o=void 0,s.push(0)},onArrayEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onLiteralValue:(D,I,O)=>{if(r<I||(P(D,I,O,a(D)),r<=I+O))throw i},onSeparator:(D,I,O)=>{if(r<=I)throw i;if(D===":"&&o&&o.type==="property")o.colonOffset=I,m=!1,o=void 0;else if(D===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(m=!0,s[s.length-1]=""),o=void 0}}})}catch(D){if(D!==i)throw D}return{path:s,previousNode:o,isAtPropertyKey:m,matches:D=>{let I=0;for(let O=0;I<D.length&&O<s.length;O++)if(D[I]===s[O]||D[I]==="*")I++;else if(D[I]!=="**")return!1;return I===D.length}}}function v(t,r=[],s=R.DEFAULT){let i=null,o=[];const l=[];function m(D){Array.isArray(o)?o.push(D):i!==null&&(o[i]=D)}return h(t,{onObjectBegin:()=>{const D={};m(D),l.push(o),o=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const D=[];m(D),l.push(o),o=D,i=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:m,onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s),o[0]}function $(t,r=[],s=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function l(D){return i.children.push(D),D}h(t,{onObjectBegin:D=>{i=l({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,I,O)=>{i=l({type:"property",offset:I,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:I,length:O,parent:i})},onObjectEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onArrayBegin:(D,I)=>{i=l({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onLiteralValue:(D,I,O)=>{l({type:a(D),offset:I,length:O,parent:i,value:D}),o(I+O)},onSeparator:(D,I,O)=>{i.type==="property"&&(D===":"?i.colonOffset=I:D===","&&o(I))},onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s);const P=i.children[0];return P&&delete P.parent,P}function f(t,r){if(!t)return;let s=t;for(const i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===i){s=l.children[1],o=!0;break}if(!o)return}else{const o=i;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const r=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=w(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function b(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}function g(t,r,s=!1){if(b(t,r,s)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const l=g(i[o],r,s);if(l)return l}return t}}function h(t,r,s=R.DEFAULT){const i=j(t,!1);function o(ce){return ce?()=>ce(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(ce){return ce?V=>ce(V,i.getTokenOffset(),i.getTokenLength()):()=>!0}const m=o(r.onObjectBegin),P=l(r.onObjectProperty),D=o(r.onObjectEnd),I=o(r.onArrayBegin),O=o(r.onArrayEnd),M=l(r.onLiteralValue),W=l(r.onSeparator),N=o(r.onComment),T=l(r.onError),U=s&&s.disallowComments,ie=s&&s.allowTrailingComma;function te(){for(;;){const ce=i.scan();switch(i.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:U||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(ce){case 12:case 13:U?ae(10):N();break;case 16:ae(1);break;case 15:case 14:break;default:return ce}}}function ae(ce,V=[],le=[]){if(T(ce),V.length+le.length>0){let Y=i.getToken();for(;Y!==17;){if(V.indexOf(Y)!==-1){te();break}else if(le.indexOf(Y)!==-1)break;Y=te()}}}function K(ce){const V=i.getTokenValue();return ce?M(V):P(V),te(),!0}function J(){switch(i.getToken()){case 11:{let ce=0;try{ce=JSON.parse(i.getTokenValue()),typeof ce!="number"&&(ae(2),ce=0)}catch{ae(2)}M(ce);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return te(),!0}function q(){return i.getToken()!==10?(ae(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(W(":"),te(),H()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function L(){m(),te();let ce=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ce||ae(4,[],[]),W(","),te(),i.getToken()===2&&ie)break}else ce&&ae(6,[],[]);q()||ae(4,[],[2,5]),ce=!0}return D(),i.getToken()!==2?ae(7,[2],[]):te(),!0}function z(){I(),te();let ce=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ce||ae(4,[],[]),W(","),te(),i.getToken()===4&&ie)break}else ce&&ae(6,[],[]);H()||ae(4,[],[4,5]),ce=!0}return O(),i.getToken()!==4?ae(8,[4],[]):te(),!0}function H(){switch(i.getToken()){case 3:return z();case 1:return L();case 10:return K(!0);default:return J()}}return te(),i.getToken()===17?s.allowEmptyContent?!0:(ae(4,[],[]),!1):H()?(i.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}function E(t,r){const s=j(t),i=[];let o,l=0,m;do switch(m=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:l!==m&&i.push(t.substring(l,m)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),l=s.getPosition();break}while(o!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(re[140],oe([0,1,42]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=A,e.$Yn=S,e.$Zn=k,e.$1n=u;function A(c,d,p){let v,$,f,y,w;if(d){for(y=d.offset,w=y+d.length,f=y;f>0&&!u(c,f-1);)f--;let m=w;for(;m<c.length&&!u(c,m);)m++;$=c.substring(f,m),v=j($,p)}else $=c,v=0,f=0,y=0,w=c.length;const b=k(p,c);let g=!1,h=0,E;p.insertSpaces?E=R(" ",p.tabSize||4):E="	";const a=(0,n.$Ln)($,!1);let t=!1;function r(){return b+R(E,v+h)}function s(){let m=a.scan();for(g=!1;m===15||m===14;)g=g||m===14,m=a.scan();return t=m===16||a.getTokenError()!==0,m}const i=[];function o(m,P,D){!t&&P<w&&D>y&&c.substring(P,D)!==m&&i.push({offset:P,length:D-P,content:m})}let l=s();if(l!==17){const m=a.getTokenOffset()+f,P=R(E,v);o(P,f,m)}for(;l!==17;){let m=a.getTokenOffset()+a.getTokenLength()+f,P=s(),D="";for(;!g&&(P===12||P===13);){const O=a.getTokenOffset()+f;o(" ",m,O),m=a.getTokenOffset()+a.getTokenLength()+f,D=P===12?r():"",P=s()}if(P===2)l!==1&&(h--,D=r());else if(P===4)l!==3&&(h--,D=r());else{switch(l){case 3:case 1:h++,D=r();break;case 5:case 12:D=r();break;case 13:g?D=r():D=" ";break;case 6:D=" ";break;case 10:if(P===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?D=" ":P!==5&&P!==17&&(t=!0);break;case 16:t=!0;break}g&&(P===12||P===13)&&(D=r())}const I=a.getTokenOffset()+f;o(D,m,I),l=P}return i}function S(c,d){const p=JSON.stringify(c,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?p.replace(/\r\n|\r|\n/g,d.eol):p}function R(c,d){let p="";for(let v=0;v<d;v++)p+=c;return p}function j(c,d){let p=0,v=0;const $=d.tabSize||4;for(;p<c.length;){const f=c.charAt(p);if(f===" ")v++;else if(f==="	")v+=$;else break;p++}return Math.floor(v/$)}function k(c,d){for(let p=0;p<d.length;p++){const v=d.charAt(p);if(v==="\r")return p+1<d.length&&d.charAt(p+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return c&&c.eol||`
`}function u(c,d){return`\r
`.indexOf(c.charAt(d))!==-1}}),define(re[103],oe([0,1,42,140]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=S,e.$3n=R,e.$4n=j,e.$5n=k,e.$6n=u;function S(c,d,p){return R(c,d,void 0,p)}function R(c,d,p,v,$){const f=d.slice(),y=[],w=(0,n.$On)(c,y);let b,g;for(;f.length>0&&(g=f.pop(),b=(0,n.$Pn)(w,f),b===void 0&&p!==void 0);)typeof g=="string"?p={[g]:p}:p=[p];if(b)if(b.type==="object"&&typeof g=="string"&&Array.isArray(b.children)){const h=(0,n.$Pn)(b,[g]);if(h!==void 0)if(p===void 0){if(!h.parent)throw new Error("Malformed AST");const E=b.children.indexOf(h.parent);let a,t=h.parent.offset+h.parent.length;if(E>0){const r=b.children[E-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return j(c,{offset:a,length:t-a,content:""},v)}else return j(c,{offset:h.offset,length:h.length,content:JSON.stringify(p)},v);else{if(p===void 0)return[];const E=`${JSON.stringify(g)}: ${JSON.stringify(p)}`,a=$?$(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+E}}else b.children.length===0?t={offset:b.offset+1,length:0,content:E}:t={offset:b.offset+1,length:0,content:E+","};return j(c,t,v)}}else if(b.type==="array"&&typeof g=="number"&&Array.isArray(b.children))if(p!==void 0){const h=`${JSON.stringify(p)}`;let E;if(b.children.length===0||g===0)E={offset:b.offset+1,length:0,content:b.children.length===0?h:h+","};else{const a=g===-1||g>b.children.length?b.children.length:g,t=b.children[a-1];E={offset:t.offset+t.length,length:0,content:","+h}}return j(c,E,v)}else{const h=g,E=b.children[h];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===h){const t=b.children[h-1],r=t.offset+t.length,s=b.offset+b.length;a={offset:r,length:s-2-r,content:""}}else a={offset:E.offset,length:b.children[h+1].offset-E.offset,content:""};return j(c,a,v)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${b.type}`);else return p===void 0?[]:j(c,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(p)},v)}function j(c,d,p){let v=k(c,d),$=d.offset,f=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;$>0&&!(0,A.$1n)(v,$-1);)$--;for(;f<v.length&&!(0,A.$1n)(v,f);)f++}const y=(0,A.$Xn)(v,{offset:$,length:f-$},p);for(let b=y.length-1;b>=0;b--){const g=y[b];v=k(v,g),$=Math.min($,g.offset),f=Math.max(f,g.offset+g.length),f+=g.content.length-g.length}const w=c.length-(v.length-f)-$;return[{offset:$,length:w,content:v.substring($,f)}]}function k(c,d){return c.substring(0,d.offset)+d.content+c.substring(d.offset+d.length)}function u(c,d){const p=d.slice(0).sort(($,f)=>{const y=$.offset-f.offset;return y===0?$.length-f.length:y});let v=c.length;for(let $=p.length-1;$>=0;$--){const f=p[$];if(f.offset+f.length<=v)c=k(c,f);else throw new Error("Overlapping edit");v=f.offset}return c}}),define(re[62],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(re[104],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(R){this.element=R,this.next=n.Undefined,this.prev=n.Undefined}}class A{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let R=this.a;for(;R!==n.Undefined;){const j=R.next;R.prev=n.Undefined,R.next=n.Undefined,R=j}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,j){const k=new n(R);if(this.a===n.Undefined)this.a=k,this.b=k;else if(j){const c=this.b;this.b=k,k.prev=c,c.next=k}else{const c=this.a;this.a=k,k.next=c,c.prev=k}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(k))}}shift(){if(this.a!==n.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==n.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==n.Undefined&&R.next!==n.Undefined){const j=R.prev;j.next=R.next,R.next.prev=j}else R.prev===n.Undefined&&R.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):R.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):R.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==n.Undefined;)yield R.element,R=R.next}}e.$5c=A}),define(re[32],oe([0,1]),function(Q,e){"use strict";var n,A,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=j,e.$zc=k,e.$Ic=E;function R(a,t,r){let s=a.get(t);return s===void 0&&(s=r,a.set(t,s)),s}function j(a){const t=[];return a.forEach((r,s)=>{t.push(`${s} => ${r}`)}),`Map(${a.size}) {${t.join(", ")}}`}function k(a){const t=[];return a.forEach(r=>{t.push(r)}),`Set(${a.size}) {${t.join(", ")}}`}class u{constructor(t,r){this.uri=t,this.value=r}}function c(a){return Array.isArray(a)}class d{static{this.c=t=>t.toString()}constructor(t,r){if(this[n]="ResourceMap",t instanceof d)this.d=new Map(t.d),this.e=r??d.c;else if(c(t)){this.d=new Map,this.e=r??d.c;for(const[s,i]of t)this.set(s,i)}else this.d=new Map,this.e=t??d.c}set(t,r){return this.d.set(this.e(t),new u(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[s,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=d;class p{constructor(t,r){this[A]="ResourceSet",!t||typeof t=="function"?this.c=new d(t):(this.c=new d(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((s,i)=>t.call(r,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=p;var v;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class ${constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const s=this.c.get(t);if(s)return r!==0&&this.m(s,r),s.value}set(t,r,s=0){let i=this.c.get(t);if(i)i.value=r,s!==0&&this.m(i,s);else{switch(i={key:t,value:r,next:void 0,previous:void 0},s){case 0:this.k(i);break;case 1:this.j(i);break;case 2:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const s=this.g;let i=this.d;for(;i;){if(r?t.bind(r)(i.value,i.key,this):t(i.value,i.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.key,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}values(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.value,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}entries(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:[s.key,s.value],done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.next,s--;this.d=r,this.f=s,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.previous,s--;this.e=r,this.f=s,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,s=t.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const s=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(s.previous=i,i.next=s),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const s=t.next,i=t.previous;t===this.d?(s.previous=void 0,this.d=s):(s.previous=i,i.next=s),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,s)=>{t.push([s,r])}),t}fromJSON(t){this.clear();for(const[r,s]of t)this.set(r,s)}}e.$Cc=$;class f extends ${constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class y extends f{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Dc=y;class w extends f{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Ec=w;class b{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Fc=b;class g{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,s]of t)this.set(r,s)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((s,i)=>{t.call(r,s,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=g;class h{constructor(){this.c=new Map}add(t,r){let s=this.c.get(t);s||(s=new Set,this.c.set(t,s)),s.add(r)}delete(t,r){const s=this.c.get(t);s&&(s.delete(r),s.size===0&&this.c.delete(t))}forEach(t,r){const s=this.c.get(t);s&&s.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Hc=h;function E(a,t){if(a===t)return!0;if(a.size!==t.size)return!1;for(const[r,s]of a)if(!t.has(r)||t.get(r)!==s)return!1;for(const[r]of t)if(!a.has(r))return!1;return!0}}),define(re[2],oe([0,1,22,137,32,86,71]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=d,e.$Lc=p,e.$Mc=v,e.$Nc=y,e.$Oc=w,e.$Pc=b,e.$Qc=g,e.$Rc=h,e.$Sc=E,e.$3c=D;const k=!1;let u=null;class c{constructor(){this.b=new Map}static{this.a=0}c(M){let W=this.b.get(M);return W||(W={parent:null,source:null,isSingleton:!1,value:M,idx:c.a++},this.b.set(M,W)),W}trackDisposable(M){const W=this.c(M);W.source||(W.source=new Error().stack)}setParent(M,W){const N=this.c(M);N.parent=W}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,W){const N=W.get(M);if(N)return N;const T=M.parent?this.f(this.c(M.parent),W):M;return W.set(M,T),T}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,M).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(M=10,W){let N;if(W)N=W;else{const ae=new Map,K=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,ae).isSingleton);if(K.length===0)return;const J=new Set(K.map(q=>q.value));if(N=K.filter(q=>!(q.parent&&J.has(q.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function T(ae){function K(q,L){for(;q.length>0&&L.some(z=>typeof z=="string"?z===q[0]:q[0].match(z));)q.shift()}const J=ae.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return K(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const U=new S.$Hc;for(const ae of N){const K=T(ae);for(let J=0;J<=K.length;J++)U.add(K.slice(0,J).join(`
`),ae)}N.sort((0,n.$6b)(ae=>ae.idx,n.$8b));let ie="",te=0;for(const ae of N.slice(0,M)){te++;const K=T(ae),J=[];for(let q=0;q<K.length;q++){let L=K[q];L=`(shared with ${U.get(K.slice(0,q+1).join(`
`)).size}/${N.length} leaks) at ${L}`;const H=U.get(K.slice(0,q).join(`
`)),ce=(0,A.$K)([...H].map(V=>T(V)[q]),V=>V);delete ce[K[q]];for(const[V,le]of Object.entries(ce))J.unshift(`    - stacktraces of ${le.length} other leaks continue with ${V}`);J.unshift(L)}ie+=`


==================== Leaking disposable ${te}/${N.length}: ${ae.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return N.length>M&&(ie+=`


... and ${N.length-M} more leaking disposables

`),{leaks:N,details:ie}}}e.$Jc=c;function d(O){u=O}if(k){const O="__is_disposable_tracked__";d(new class{trackDisposable(M){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[O]||console.log(W)},3e3)}setParent(M,W){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsSingleton(M){}})}function p(O){return u?.trackDisposable(O),O}function v(O){u?.markAsDisposed(O)}function $(O,M){u?.setParent(O,M)}function f(O,M){if(u)for(const W of O)u.setParent(W,M)}function y(O){return u?.markAsSingleton(O),O}function w(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function b(O){if(j.Iterable.is(O)){const M=[];for(const W of O)if(W)try{W.dispose()}catch(N){M.push(N)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function g(O){for(const M of O)w(M)&&M.dispose();return[]}function h(...O){const M=E(()=>b(O));return f(O,M),M}function E(O){const M=p({dispose:(0,R.$db)(()=>{v(M),O()})});return M}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return $(M,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),$(M,null))}}e.$Tc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,p(this),$(this.q,this)}dispose(){v(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Uc=t;class r{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&$(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&$(M,null),M}}e.$Vc=r;class s{constructor(M){this.a=new r,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class i{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=i;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(M){let W=M;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,v(this))},this}}e.$Yc=o;class l{constructor(){this.a=new Map}acquire(M,...W){let N=this.a.get(M);N||(N={counter:0,object:this.b(M,...W)},this.a.set(M,N));const{object:T}=N,U=(0,R.$db)(()=>{--N.counter===0&&(this.c(M,N.object),this.a.delete(M))});return N.counter++,{object:T,dispose:U}}}e.$Zc=l;class m{constructor(M){this.a=M}async acquire(M,...W){const N=this.a.acquire(M,...W);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(T){throw N.dispose(),T}}}e.$1c=m;class P{constructor(M){this.object=M}dispose(){}}e.$2c=P;function D(O){const M=new a;try{O(M)}finally{M.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,W,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(M)?.dispose(),this.a.set(M,W)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=I}),define(re[72],oe([0,1,32]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=void 0,e.$fm=S,e.$gm=j;const A=new n.$Dc(1e4);function S(c){return u(c,"NFC",A)}const R=new n.$Dc(1e4);function j(c){return u(c,"NFD",R)}const k=/[^\u0000-\u0080]/;function u(c,d,p){if(!c)return c;const v=p.get(c);if(v)return v;let $;return k.test(c)?$=c.normalize(d):$=c,p.set(c,$),$}e.$hm=function(){const c=/[\u0300-\u036f]/g;return function(d){return j(d).replace(c,"")}}()}),define(re[141],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=void 0,e.$Fm=n,e.rot=A;function n(k,u,c){return Math.min(Math.max(k,u),c)}function A(k,u){return(u+k%u)%u}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$Hm=S;class R{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Im=R;class j{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jm=j}),function(){function Q(S){const R=[];typeof S=="number"&&R.push("code/timeOrigin",S);function j(u){R.push(u,Date.now())}function k(){const u=[];for(let c=0;c<R.length;c+=2)u.push({name:R[c],startTime:R[c+1]});return u}return{mark:j,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const j of performance.getEntriesByType("mark"))R.push({name:j.name,startTime:Math.round(S+j.startTime)});return R}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function n(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=n(A))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var A in n)(typeof exports=="object"?exports:Q)[A]=n[A]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function n(A){if(e[A])return e[A].exports;var S=e[A]={i:A,l:!1,exports:{}};return Q[A].call(S.exports,S,S.exports,n),S.l=!0,S.exports}return n.m=Q,n.c=e,n.d=function(A,S,R){n.o(A,S)||Object.defineProperty(A,S,{enumerable:!0,get:R})},n.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},n.t=function(A,S){if(1&S&&(A=n(A)),8&S||4&S&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(n.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&S&&typeof A!="string")for(var j in A)n.d(R,j,function(k){return A[k]}.bind(null,j));return R},n.n=function(A){var S=A&&A.__esModule?function(){return A.default}:function(){return A};return n.d(S,"a",S),S},n.o=function(A,S){return Object.prototype.hasOwnProperty.call(A,S)},n.p="",n(n.s=0)}([function(Q,e,n){(function(A){var S;e=Q.exports=le,S=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],u=e.src=[],c=0,d=c++;u[d]="0|[1-9]\\d*";var p=c++;u[p]="[0-9]+";var v=c++;u[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=c++;u[$]="("+u[d]+")\\.("+u[d]+")\\.("+u[d]+")";var f=c++;u[f]="("+u[p]+")\\.("+u[p]+")\\.("+u[p]+")";var y=c++;u[y]="(?:"+u[d]+"|"+u[v]+")";var w=c++;u[w]="(?:"+u[p]+"|"+u[v]+")";var b=c++;u[b]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var g=c++;u[g]="(?:-?("+u[w]+"(?:\\."+u[w]+")*))";var h=c++;u[h]="[0-9A-Za-z-]+";var E=c++;u[E]="(?:\\+("+u[h]+"(?:\\."+u[h]+")*))";var a=c++,t="v?"+u[$]+u[b]+"?"+u[E]+"?";u[a]="^"+t+"$";var r="[v=\\s]*"+u[f]+u[g]+"?"+u[E]+"?",s=c++;u[s]="^"+r+"$";var i=c++;u[i]="((?:<|>)?=?)";var o=c++;u[o]=u[p]+"|x|X|\\*";var l=c++;u[l]=u[d]+"|x|X|\\*";var m=c++;u[m]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[b]+")?"+u[E]+"?)?)?";var P=c++;u[P]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[g]+")?"+u[E]+"?)?)?";var D=c++;u[D]="^"+u[i]+"\\s*"+u[m]+"$";var I=c++;u[I]="^"+u[i]+"\\s*"+u[P]+"$";var O=c++;u[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=c++;u[M]="(?:~>?)";var W=c++;u[W]="(\\s*)"+u[M]+"\\s+",k[W]=new RegExp(u[W],"g");var N=c++;u[N]="^"+u[M]+u[m]+"$";var T=c++;u[T]="^"+u[M]+u[P]+"$";var U=c++;u[U]="(?:\\^)";var ie=c++;u[ie]="(\\s*)"+u[U]+"\\s+",k[ie]=new RegExp(u[ie],"g");var te=c++;u[te]="^"+u[U]+u[m]+"$";var ae=c++;u[ae]="^"+u[U]+u[P]+"$";var K=c++;u[K]="^"+u[i]+"\\s*("+r+")$|^$";var J=c++;u[J]="^"+u[i]+"\\s*("+t+")$|^$";var q=c++;u[q]="(\\s*)"+u[i]+"\\s*("+r+"|"+u[m]+")",k[q]=new RegExp(u[q],"g");var L=c++;u[L]="^\\s*("+u[m]+")\\s+-\\s+("+u[m]+")\\s*$";var z=c++;u[z]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var H=c++;u[H]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)S(ce,u[ce]),k[ce]||(k[ce]=new RegExp(u[ce]));function V(X,he){if(X instanceof le)return X;if(typeof X!="string"||X.length>R||!(he?k[s]:k[a]).test(X))return null;try{return new le(X,he)}catch{return null}}function le(X,he){if(X instanceof le){if(X.loose===he)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof le))return new le(X,he);S("SemVer",X,he),this.loose=he;var ge=X.trim().match(he?k[s]:k[a]);if(!ge)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var De=+Se;if(De>=0&&De<j)return De}return Se}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=V,e.valid=function(X,he){var ge=V(X,he);return ge?ge.version:null},e.clean=function(X,he){var ge=V(X.trim().replace(/^[=v]+/,""),he);return ge?ge.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(X){return S("SemVer.compare",this.version,this.loose,X),X instanceof le||(X=new le(X,this.loose)),this.compareMain(X)||this.comparePre(X)},le.prototype.compareMain=function(X){return X instanceof le||(X=new le(X,this.loose)),C(this.major,X.major)||C(this.minor,X.minor)||C(this.patch,X.patch)},le.prototype.comparePre=function(X){if(X instanceof le||(X=new le(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var he=0;do{var ge=this.prerelease[he],Se=X.prerelease[he];if(S("prerelease compare",he,ge,Se),ge===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(ge===void 0)return-1;if(ge!==Se)return C(ge,Se)}while(++he)},le.prototype.inc=function(X,he){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,he,ge,Se){typeof ge=="string"&&(Se=ge,ge=void 0);try{return new le(X,ge).inc(he,Se).version}catch{return null}},e.diff=function(X,he){if(Z(X,he))return null;var ge=V(X),Se=V(he);if(ge.prerelease.length||Se.prerelease.length){for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Se[De])return"pre"+De;return"prerelease"}for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Se[De])return De},e.compareIdentifiers=C;var Y=/^[0-9]+$/;function C(X,he){var ge=Y.test(X),Se=Y.test(he);return ge&&Se&&(X=+X,he=+he),ge&&!Se?-1:Se&&!ge?1:X<he?-1:X>he?1:0}function F(X,he,ge){return new le(X,ge).compare(new le(he,ge))}function _(X,he,ge){return F(X,he,ge)>0}function B(X,he,ge){return F(X,he,ge)<0}function Z(X,he,ge){return F(X,he,ge)===0}function x(X,he,ge){return F(X,he,ge)!==0}function ee(X,he,ge){return F(X,he,ge)>=0}function G(X,he,ge){return F(X,he,ge)<=0}function ue(X,he,ge,Se){var De;switch(he){case"===":typeof X=="object"&&(X=X.version),typeof ge=="object"&&(ge=ge.version),De=X===ge;break;case"!==":typeof X=="object"&&(X=X.version),typeof ge=="object"&&(ge=ge.version),De=X!==ge;break;case"":case"=":case"==":De=Z(X,ge,Se);break;case"!=":De=x(X,ge,Se);break;case">":De=_(X,ge,Se);break;case">=":De=ee(X,ge,Se);break;case"<":De=B(X,ge,Se);break;case"<=":De=G(X,ge,Se);break;default:throw new TypeError("Invalid operator: "+he)}return De}function fe(X,he){if(X instanceof fe){if(X.loose===he)return X;X=X.value}if(!(this instanceof fe))return new fe(X,he);S("comparator",X,he),this.loose=he,this.parse(X),this.semver===we?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(X,he){return C(he,X)},e.major=function(X,he){return new le(X,he).major},e.minor=function(X,he){return new le(X,he).minor},e.patch=function(X,he){return new le(X,he).patch},e.compare=F,e.compareLoose=function(X,he){return F(X,he,!0)},e.rcompare=function(X,he,ge){return F(he,X,ge)},e.sort=function(X,he){return X.sort(function(ge,Se){return e.compare(ge,Se,he)})},e.rsort=function(X,he){return X.sort(function(ge,Se){return e.rcompare(ge,Se,he)})},e.gt=_,e.lt=B,e.eq=Z,e.neq=x,e.gte=ee,e.lte=G,e.cmp=ue,e.Comparator=fe;var we={};function Ee(X,he){if(X instanceof Ee)return X.loose===he?X:new Ee(X.raw,he);if(X instanceof fe)return new Ee(X.value,he);if(!(this instanceof Ee))return new Ee(X,he);if(this.loose=he,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Oe(X){return!X||X.toLowerCase()==="x"||X==="*"}function ye(X,he,ge,Se,De,Ne,Me,Fe,Be,He,Xe,Te,xe){return((he=Oe(ge)?"":Oe(Se)?">="+ge+".0.0":Oe(De)?">="+ge+"."+Se+".0":">="+he)+" "+(Fe=Oe(Be)?"":Oe(He)?"<"+(+Be+1)+".0.0":Oe(Xe)?"<"+Be+"."+(+He+1)+".0":Te?"<="+Be+"."+He+"."+Xe+"-"+Te:"<="+Fe)).trim()}function ve(X,he){for(var ge=0;ge<X.length;ge++)if(!X[ge].test(he))return!1;if(he.prerelease.length){for(ge=0;ge<X.length;ge++)if(S(X[ge].semver),X[ge].semver!==we&&X[ge].semver.prerelease.length>0){var Se=X[ge].semver;if(Se.major===he.major&&Se.minor===he.minor&&Se.patch===he.patch)return!0}return!1}return!0}function Ce(X,he,ge){try{he=new Ee(he,ge)}catch{return!1}return he.test(X)}function me(X,he,ge,Se){var De,Ne,Me,Fe,Be;switch(X=new le(X,Se),he=new Ee(he,Se),ge){case">":De=_,Ne=G,Me=B,Fe=">",Be=">=";break;case"<":De=B,Ne=ee,Me=_,Fe="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(X,he,Se))return!1;for(var He=0;He<he.set.length;++He){var Xe=he.set[He],Te=null,xe=null;if(Xe.forEach(function(Ge){Ge.semver===we&&(Ge=new fe(">=0.0.0")),Te=Te||Ge,xe=xe||Ge,De(Ge.semver,Te.semver,Se)?Te=Ge:Me(Ge.semver,xe.semver,Se)&&(xe=Ge)}),Te.operator===Fe||Te.operator===Be||(!xe.operator||xe.operator===Fe)&&Ne(X,xe.semver)||xe.operator===Be&&Me(X,xe.semver))return!1}return!0}fe.prototype.parse=function(X){var he=this.loose?k[K]:k[J],ge=X.match(he);if(!ge)throw new TypeError("Invalid comparator: "+X);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new le(ge[2],this.loose):this.semver=we},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(X){return S("Comparator.test",X,this.loose),this.semver===we||(typeof X=="string"&&(X=new le(X,this.loose)),ue(X,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(X,he){if(!(X instanceof fe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(X.value,he),Ce(this.value,ge,he);if(X.operator==="")return ge=new Ee(this.value,he),Ce(X.semver,ge,he);var Se=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Ne=this.semver.version===X.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Fe=ue(this.semver,"<",X.semver,he)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),Be=ue(this.semver,">",X.semver,he)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return Se||De||Ne&&Me||Fe||Be},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(X){var he=this.loose;X=X.trim(),S("range",X,he);var ge=he?k[z]:k[L];X=X.replace(ge,ye),S("hyphen replace",X),X=X.replace(k[q],"$1$2$3"),S("comparator trim",X,k[q]),X=(X=(X=X.replace(k[W],"$1~")).replace(k[ie],"$1^")).split(/\s+/).join(" ");var Se=he?k[K]:k[J],De=X.split(" ").map(function(Ne){return function(Me,Fe){return S("comp",Me),Me=function(Be,He){return Be.trim().split(/\s+/).map(function(Xe){return function(Te,xe){S("caret",Te,xe);var Ge=xe?k[ae]:k[te];return Te.replace(Ge,function(se,de,$e,be,je){var Le;return S("caret",Te,se,de,$e,be,je),Oe(de)?Le="":Oe($e)?Le=">="+de+".0.0 <"+(+de+1)+".0.0":Oe(be)?Le=de==="0"?">="+de+"."+$e+".0 <"+de+"."+(+$e+1)+".0":">="+de+"."+$e+".0 <"+(+de+1)+".0.0":je?(S("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Le=de==="0"?$e==="0"?">="+de+"."+$e+"."+be+je+" <"+de+"."+$e+"."+(+be+1):">="+de+"."+$e+"."+be+je+" <"+de+"."+(+$e+1)+".0":">="+de+"."+$e+"."+be+je+" <"+(+de+1)+".0.0"):(S("no pr"),Le=de==="0"?$e==="0"?">="+de+"."+$e+"."+be+" <"+de+"."+$e+"."+(+be+1):">="+de+"."+$e+"."+be+" <"+de+"."+(+$e+1)+".0":">="+de+"."+$e+"."+be+" <"+(+de+1)+".0.0"),S("caret return",Le),Le})}(Xe,He)}).join(" ")}(Me,Fe),S("caret",Me),Me=function(Be,He){return Be.trim().split(/\s+/).map(function(Xe){return function(Te,xe){var Ge=xe?k[T]:k[N];return Te.replace(Ge,function(se,de,$e,be,je){var Le;return S("tilde",Te,se,de,$e,be,je),Oe(de)?Le="":Oe($e)?Le=">="+de+".0.0 <"+(+de+1)+".0.0":Oe(be)?Le=">="+de+"."+$e+".0 <"+de+"."+(+$e+1)+".0":je?(S("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Le=">="+de+"."+$e+"."+be+je+" <"+de+"."+(+$e+1)+".0"):Le=">="+de+"."+$e+"."+be+" <"+de+"."+(+$e+1)+".0",S("tilde return",Le),Le})}(Xe,He)}).join(" ")}(Me,Fe),S("tildes",Me),Me=function(Be,He){return S("replaceXRanges",Be,He),Be.split(/\s+/).map(function(Xe){return function(Te,xe){Te=Te.trim();var Ge=xe?k[I]:k[D];return Te.replace(Ge,function(se,de,$e,be,je,Le){S("xRange",Te,se,de,$e,be,je,Le);var Qe=Oe($e),Ze=Qe||Oe(be),_e=Ze||Oe(je);return de==="="&&_e&&(de=""),Qe?se=de===">"||de==="<"?"<0.0.0":"*":de&&_e?(Ze&&(be=0),_e&&(je=0),de===">"?(de=">=",Ze?($e=+$e+1,be=0,je=0):_e&&(be=+be+1,je=0)):de==="<="&&(de="<",Ze?$e=+$e+1:be=+be+1),se=de+$e+"."+be+"."+je):Ze?se=">="+$e+".0.0 <"+(+$e+1)+".0.0":_e&&(se=">="+$e+"."+be+".0 <"+$e+"."+(+be+1)+".0"),S("xRange return",se),se})}(Xe,He)}).join(" ")}(Me,Fe),S("xrange",Me),Me=function(Be,He){return S("replaceStars",Be,He),Be.trim().replace(k[H],"")}(Me,Fe),S("stars",Me),Me}(Ne,he)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Ne){return!!Ne.match(Se)})),De=De.map(function(Ne){return new fe(Ne,he)})},Ee.prototype.intersects=function(X,he){if(!(X instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Se){return X.set.some(function(De){return De.every(function(Ne){return Se.intersects(Ne,he)})})})})},e.toComparators=function(X,he){return new Ee(X,he).set.map(function(ge){return ge.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new le(X,this.loose));for(var he=0;he<this.set.length;he++)if(ve(this.set[he],X))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(X,he,ge){var Se=null,De=null;try{var Ne=new Ee(he,ge)}catch{return null}return X.forEach(function(Me){Ne.test(Me)&&(Se&&De.compare(Me)!==-1||(De=new le(Se=Me,ge)))}),Se},e.minSatisfying=function(X,he,ge){var Se=null,De=null;try{var Ne=new Ee(he,ge)}catch{return null}return X.forEach(function(Me){Ne.test(Me)&&(Se&&De.compare(Me)!==1||(De=new le(Se=Me,ge)))}),Se},e.validRange=function(X,he){try{return new Ee(X,he).range||"*"}catch{return null}},e.ltr=function(X,he,ge){return me(X,he,"<",ge)},e.gtr=function(X,he,ge){return me(X,he,">",ge)},e.outside=me,e.prerelease=function(X,he){var ge=V(X,he);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(X,he,ge){return X=new Ee(X,ge),he=new Ee(he,ge),X.intersects(he)},e.coerce=function(X){if(X instanceof le)return X;if(typeof X!="string")return null;var he=X.match(k[O]);return he==null?null:V((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,n(1))},function(Q,e){var n,A,S=Q.exports={};function R(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function k(w){if(n===setTimeout)return setTimeout(w,0);if((n===R||!n)&&setTimeout)return n=setTimeout,setTimeout(w,0);try{return n(w,0)}catch{try{return n.call(null,w,0)}catch{return n.call(this,w,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:R}catch{n=R}try{A=typeof clearTimeout=="function"?clearTimeout:j}catch{A=j}})();var u,c=[],d=!1,p=-1;function v(){d&&u&&(d=!1,u.length?c=u.concat(c):p=-1,c.length&&$())}function $(){if(!d){var w=k(v);d=!0;for(var b=c.length;b;){for(u=c,c=[];++p<b;)u&&u[p].run();p=-1,b=c.length}u=null,d=!1,function(g){if(A===clearTimeout)return clearTimeout(g);if((A===j||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(g);try{A(g)}catch{try{return A.call(null,g)}catch{return A.call(this,g)}}}(w)}}function f(w,b){this.fun=w,this.array=b}function y(){}S.nextTick=function(w){var b=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)b[g-1]=arguments[g];c.push(new f(w,b)),c.length!==1||d||k($)},f.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=y,S.addListener=y,S.once=y,S.off=y,S.removeListener=y,S.removeAllListeners=y,S.emit=y,S.prependListener=y,S.prependOnceListener=y,S.listeners=function(w){return[]},S.binding=function(w){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(w){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(re[142],oe([0,1]),function(Q,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;class A{constructor(k,u,c){this.level=k,this.key=u,this.value=c,this.forward=[]}}const S=void 0;class R{constructor(k,u=2**16){this.comparator=k,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new A(this.c,S,S)}get size(){return this.f}clear(){this.e=new A(this.c,S,S),this.f=0}has(k){return!!R.g(this,k,this.comparator)}get(k){return R.g(this,k,this.comparator)?.value}set(k,u){return R.h(this,k,u,this.comparator)&&(this.f+=1),this}delete(k){const u=R.k(this,k,this.comparator);return u&&(this.f-=1),u}forEach(k,u){let c=this.e.forward[0];for(;c;)k.call(u,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",u=this.e.forward[0];for(;u;)k+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return k}static g(k,u,c){let d=k.e;for(let p=k.d-1;p>=0;p--)for(;d.forward[p]&&c(d.forward[p].key,u)<0;)d=d.forward[p];if(d=d.forward[0],d&&c(d.key,u)===0)return d}static h(k,u,c,d){const p=[];let v=k.e;for(let $=k.d-1;$>=0;$--){for(;v.forward[$]&&d(v.forward[$].key,u)<0;)v=v.forward[$];p[$]=v}if(v=v.forward[0],v&&d(v.key,u)===0)return v.value=c,!1;{const $=R.j(k);if($>k.d){for(let f=k.d;f<$;f++)p[f]=k.e;k.d=$}v=new A($,u,c);for(let f=0;f<$;f++)v.forward[f]=p[f].forward[f],p[f].forward[f]=v;return!0}}static j(k,u=.5){let c=1;for(;Math.random()<u&&c<k.c;)c+=1;return c}static k(k,u,c){const d=[];let p=k.e;for(let v=k.d-1;v>=0;v--){for(;p.forward[v]&&c(p.forward[v].key,u)<0;)p=p.forward[v];d[v]=p}if(p=p.forward[0],!p||c(p.key,u)!==0)return!1;for(let v=0;v<k.d&&d[v].forward[v]===p;v++)d[v].forward[v]=p.forward[v];for(;k.d>0&&k.e.forward[k.d-1]===S;)k.d-=1;return!0}}e.$Fs=R}),define(re[73],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(R){return new A(R)}constructor(R){this.c=n&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=A}),define(re[3],oe([0,1,15,86,2,104,73]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=$;const k=!1,u=!1,c=!1;var d;(function(T){T.None=()=>S.$Uc.None;function U(ye){if(c){const{onDidAddListener:ve}=ye,Ce=y.create();let me=0;ye.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ce.print()),ve?.()}}}function ie(ye,ve){return V(ye,()=>{},0,void 0,!0,void 0,ve)}T.defer=ie;function te(ye){return(ve,Ce=null,me)=>{let X=!1,he;return he=ye(ge=>{if(!X)return he?he.dispose():X=!0,ve.call(Ce,ge)},null,me),X&&he.dispose(),he}}T.once=te;function ae(ye,ve,Ce){return H((me,X=null,he)=>ye(ge=>me.call(X,ve(ge)),null,he),Ce)}T.map=ae;function K(ye,ve,Ce){return H((me,X=null,he)=>ye(ge=>{ve(ge),me.call(X,ge)},null,he),Ce)}T.forEach=K;function J(ye,ve,Ce){return H((me,X=null,he)=>ye(ge=>ve(ge)&&me.call(X,ge),null,he),Ce)}T.filter=J;function q(ye){return ye}T.signal=q;function L(...ye){return(ve,Ce=null,me)=>{const X=(0,S.$Rc)(...ye.map(he=>he(ge=>ve.call(Ce,ge))));return ce(X,me)}}T.any=L;function z(ye,ve,Ce,me){let X=Ce;return ae(ye,he=>(X=ve(X,he),X),me)}T.reduce=z;function H(ye,ve){let Ce;const me={onWillAddFirstListener(){Ce=ye(X.fire,X)},onDidRemoveLastListener(){Ce?.dispose()}};ve||U(me);const X=new r(me);return ve?.add(X),X.event}function ce(ye,ve){return ve instanceof Array?ve.push(ye):ve&&ve.add(ye),ye}function V(ye,ve,Ce=100,me=!1,X=!1,he,ge){let Se,De,Ne,Me=0,Fe;const Be={leakWarningThreshold:he,onWillAddFirstListener(){Se=ye(Xe=>{Me++,De=ve(De,Xe),me&&!Ne&&(He.fire(De),De=void 0),Fe=()=>{const Te=De;De=void 0,Ne=void 0,(!me||Me>1)&&He.fire(Te),Me=0},typeof Ce=="number"?(clearTimeout(Ne),Ne=setTimeout(Fe,Ce)):Ne===void 0&&(Ne=0,queueMicrotask(Fe))})},onWillRemoveListener(){X&&Me>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,Se.dispose()}};ge||U(Be);const He=new r(Be);return ge?.add(He),He.event}T.debounce=V;function le(ye,ve=0,Ce){return T.debounce(ye,(me,X)=>me?(me.push(X),me):[X],ve,void 0,!0,void 0,Ce)}T.accumulate=le;function Y(ye,ve=(me,X)=>me===X,Ce){let me=!0,X;return J(ye,he=>{const ge=me||!ve(he,X);return me=!1,X=he,ge},Ce)}T.latch=Y;function C(ye,ve,Ce){return[T.filter(ye,ve,Ce),T.filter(ye,me=>!ve(me),Ce)]}T.split=C;function F(ye,ve=!1,Ce=[],me){let X=Ce.slice(),he=ye(De=>{X?X.push(De):Se.fire(De)});me&&me.add(he);const ge=()=>{X?.forEach(De=>Se.fire(De)),X=null},Se=new r({onWillAddFirstListener(){he||(he=ye(De=>Se.fire(De)),me&&me.add(he))},onDidAddFirstListener(){X&&(ve?setTimeout(ge):ge())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return me&&me.add(Se),Se.event}T.buffer=F;function _(ye,ve){return(me,X,he)=>{const ge=ve(new Z);return ye(function(Se){const De=ge.evaluate(Se);De!==B&&me.call(X,De)},void 0,he)}}T.chain=_;const B=Symbol("HaltChainable");class Z{constructor(){this.f=[]}map(ve){return this.f.push(ve),this}forEach(ve){return this.f.push(Ce=>(ve(Ce),Ce)),this}filter(ve){return this.f.push(Ce=>ve(Ce)?Ce:B),this}reduce(ve,Ce){let me=Ce;return this.f.push(X=>(me=ve(me,X),me)),this}latch(ve=(Ce,me)=>Ce===me){let Ce=!0,me;return this.f.push(X=>{const he=Ce||!ve(X,me);return Ce=!1,me=X,he?X:B}),this}evaluate(ve){for(const Ce of this.f)if(ve=Ce(ve),ve===B)break;return ve}}function x(ye,ve,Ce=me=>me){const me=(...Se)=>ge.fire(Ce(...Se)),X=()=>ye.on(ve,me),he=()=>ye.removeListener(ve,me),ge=new r({onWillAddFirstListener:X,onDidRemoveLastListener:he});return ge.event}T.fromNodeEventEmitter=x;function ee(ye,ve,Ce=me=>me){const me=(...Se)=>ge.fire(Ce(...Se)),X=()=>ye.addEventListener(ve,me),he=()=>ye.removeEventListener(ve,me),ge=new r({onWillAddFirstListener:X,onDidRemoveLastListener:he});return ge.event}T.fromDOMEventEmitter=ee;function G(ye){return new Promise(ve=>te(ye)(ve))}T.toPromise=G;function ue(ye){const ve=new r;return ye.then(Ce=>{ve.fire(Ce)},()=>{ve.fire(void 0)}).finally(()=>{ve.dispose()}),ve.event}T.fromPromise=ue;function fe(ye,ve,Ce){return ve(Ce),ye(me=>ve(me))}T.runAndSubscribe=fe;class we{constructor(ve,Ce){this._observable=ve,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{ve.addObserver(this)},onDidRemoveLastListener:()=>{ve.removeObserver(this)}};Ce||U(me),this.emitter=new r(me),Ce&&Ce.add(this.emitter)}beginUpdate(ve){this.f++}handlePossibleChange(ve){}handleChange(ve,Ce){this.g=!0}endUpdate(ve){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(ye,ve){return new we(ye,ve).emitter.event}T.fromObservable=Ee;function Oe(ye){return(ve,Ce,me)=>{let X=0,he=!1;const ge={beginUpdate(){X++},endUpdate(){X--,X===0&&(ye.reportChanges(),he&&(he=!1,ve.call(Ce)))},handlePossibleChange(){},handleChange(){he=!0}};ye.addObserver(ge),ye.reportChanges();const Se={dispose(){ye.removeObserver(ge)}};return me instanceof S.$Tc?me.add(Se):Array.isArray(me)&&me.push(Se),Se}}T.fromObservableLight=Oe})(d||(e.Event=d={}));class p{static{this.all=new Set}static{this.f=0}constructor(U){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${U}_${p.f++}`,p.all.add(this)}start(U){this.g=new j.$be,this.listenerCount=U}stop(){if(this.g){const U=this.g.elapsed();this.durations.push(U),this.elapsedOverall+=U,this.invocationCount+=1,this.g=void 0}}}e.$de=p;let v=-1;function $(T){const U=v;return v=T,{dispose(){v=U}}}class f{constructor(U,ie,te=Math.random().toString(18).slice(2,5)){this.h=U,this.threshold=ie,this.name=te,this.g=0}dispose(){this.f?.clear()}check(U,ie){const te=this.threshold;if(te<=0||ie<te)return;this.f||(this.f=new Map);const ae=this.f.get(U.value)||0;if(this.f.set(U.value,ae+1),this.g-=1,this.g<=0){this.g=te*.5;const[K,J]=this.getMostFrequentStack(),q=`[${this.name}] potential listener LEAK detected, having ${ie} listeners already. MOST frequent listener (${J}):`;console.warn(q),console.warn(K);const L=new w(q,K);this.h(L)}return()=>{const K=this.f.get(U.value)||0;this.f.set(U.value,K-1)}}getMostFrequentStack(){if(!this.f)return;let U,ie=0;for(const[te,ae]of this.f)(!U||ie<ae)&&(U=[te,ae],ie=ae);return U}}class y{static create(){const U=new Error;return new y(U.stack??"")}constructor(U){this.value=U}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w extends Error{constructor(U,ie){super(U),this.name="ListenerLeakError",this.stack=ie}}e.$fe=w;class b extends Error{constructor(U,ie){super(U),this.name="ListenerRefusalError",this.stack=ie}}e.$ge=b;let g=0;class h{constructor(U){this.value=U,this.id=g++}}const E=2,a=(T,U)=>{if(T instanceof h)U(T);else for(let ie=0;ie<T.length;ie++){const te=T[ie];te&&U(te)}},t=k?new FinalizationRegistry(T=>{typeof T=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(T))}):void 0;class r{constructor(U){this.w=0,this.f=U,this.g=v>0||this.f?.leakWarningThreshold?new f(U?.onListenerError??n.$1,this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(u){const U=this.t;queueMicrotask(()=>{a(U,ie=>ie.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(U,ie,te)=>{if(this.g&&this.w>this.g.threshold*3){const L=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w}/${this.g.threshold})`;console.warn(L);const z=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],H=new b(`${L}. HINT: Stack shows most frequent listener (${z[1]}-times)`,z[0]);return(this.f?.onListenerError||n.$1)(H),S.$Uc.None}if(this.m)return S.$Uc.None;ie&&(U=U.bind(ie));const ae=new h(U);let K,J;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ae.stack=y.create(),K=this.g.check(ae.stack,this.w+1)),u&&(ae.stack=J??y.create()),this.t?this.t instanceof h?(this.u??=new i,this.t=[this.t,ae]):this.t.push(ae):(this.f?.onWillAddFirstListener?.(this),this.t=ae,this.f?.onDidAddFirstListener?.(this)),this.w++;const q=(0,S.$Sc)(()=>{t?.unregister(q),K?.(),this.x(ae)});if(te instanceof S.$Tc?te.add(q):Array.isArray(te)&&te.push(q),t){const L=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(q,L,q)}return q},this.q}x(U){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const ie=this.t,te=ie.indexOf(U);if(te===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,ie[te]=void 0;const ae=this.u.current===this;if(this.w*E<=ie.length){let K=0;for(let J=0;J<ie.length;J++)ie[J]?ie[K++]=ie[J]:ae&&(this.u.end--,K<this.u.i&&this.u.i--);ie.length=K}}y(U,ie){if(!U)return;const te=this.f?.onListenerError||n.$1;if(!te){U.value(ie);return}try{U.value(ie)}catch(ae){te(ae)}}z(U){const ie=U.current.t;for(;U.i<U.end;)this.y(ie[U.i++],U.value);U.reset()}fire(U){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,U);else{const ie=this.u;ie.enqueue(this,U,this.t.length),this.z(ie)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=r;const s=()=>new i;e.$ie=s;class i{constructor(){this.i=-1,this.end=0}enqueue(U,ie,te){this.i=0,this.end=te,this.current=U,this.value=ie}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(U,ie,te){if(this.t)for(this.h||(this.h=new R.$5c),a(this.t,ae=>this.h.push([ae.value,U]));this.h.size>0&&!ie.isCancellationRequested;){const[ae,K]=this.h.shift(),J=[],q={...K,token:ie,waitUntil:L=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");te&&(L=te(L,ae)),J.push(L)}};try{ae(q)}catch(L){(0,n.$1)(L);continue}Object.freeze(J),await Promise.allSettled(J).then(L=>{for(const z of L)z.status==="rejected"&&(0,n.$1)(z.reason)})}}}e.$je=o;class l extends r{get isPaused(){return this.h!==0}constructor(U){super(U),this.h=0,this.s=new R.$5c,this.A=U?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const U=Array.from(this.s);this.s.clear(),super.fire(this.A(U))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(U){this.w&&(this.h!==0?this.s.push(U):super.fire(U))}}e.$ke=l;class m extends l{constructor(U){super(U),this.k=U.delay??100}fire(U){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(U)}}e.$le=m;class P extends r{constructor(U){super(U),this.h=[],this.k=U?.merge}fire(U){this.hasListeners()&&(this.h.push(U),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ie=>super.fire(ie)),this.h=[]}))}}e.$me=P;class D{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(U){const ie={event:U,listener:null};this.h.push(ie),this.g&&this.m(ie);const te=()=>{this.g&&this.o(ie);const ae=this.h.indexOf(ie);this.h.splice(ae,1)};return(0,S.$Sc)((0,A.$db)(te))}j(){this.g=!0,this.h.forEach(U=>this.m(U))}k(){this.g=!1,this.h.forEach(U=>this.o(U))}m(U){U.listener=U.event(ie=>this.f.fire(ie))}o(U){U.listener?.dispose(),U.listener=null}dispose(){this.f.dispose();for(const U of this.h)U.listener?.dispose();this.h=[]}}e.$ne=D;class I{constructor(U,ie,te,ae){this.f=new S.$Tc;const K=this.f.add(new D),J=this.f.add(new S.$4c);function q(L){J.set(L,K.add(ae(L)))}for(const L of U)q(L);this.f.add(ie(L=>{q(L)})),this.f.add(te(L=>{J.deleteAndDispose(L)})),this.event=K.event}dispose(){this.f.dispose()}}e.$oe=I;class O{constructor(){this.f=[]}wrapEvent(U,ie,te){return(ae,K,J)=>U(q=>{const L=this.f[this.f.length-1];if(!ie){L?L.buffers.push(()=>ae.call(K,q)):ae.call(K,q);return}const z=L;if(!z){ae.call(K,ie(te,q));return}z.items??=[],z.items.push(q),z.buffers.length===0&&L.buffers.push(()=>{z.reducedResult??=te?z.items.reduce(ie,te):z.items.reduce(ie),ae.call(K,z.reducedResult)})},void 0,J)}bufferEvents(U){const ie={buffers:new Array};this.f.push(ie);const te=U();return this.f.pop(),ie.buffers.forEach(ae=>ae()),te}}e.$pe=O;class M{constructor(){this.f=!1,this.g=d.None,this.h=S.$Uc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(U){this.g=U,this.f&&(this.h.dispose(),this.h=U(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=M;class W{static const(U){return new N(U)}constructor(U){this.g=U,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(U){U!==this.g&&(this.g=U,this.f.fire(void 0))}}e.$re=W;class N{constructor(U){this.value=U,this.onDidChange=d.None}}}),define(re[23],oe([0,1,3]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=k;const A=Object.freeze(function(u,c){const d=setTimeout(u.bind(c),0);return{dispose(){clearTimeout(d)}}});var S;(function(u){function c(d){return d===u.None||d===u.Cancelled||d instanceof R?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}u.isCancellationToken=c,u.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),u.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(S||(e.CancellationToken=S={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new n.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=S.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=S.None}}e.$se=j;function k(u){const c=new j;return u.add({dispose(){c.cancel()}}),c.token}}),define(re[143],oe([0,1,23]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=S;class A{constructor(u){this.b=u,this.a=null}get(){if(this.a)return this.a;const u=new n.$se,c=this.b(u.token);return this.a={promise:c,dispose:()=>{this.a=null,u.cancel(),u.dispose()}},this.a}}e.$5e=A;function S(k){return k}class R{constructor(u,c){this.a=void 0,this.b=void 0,typeof u=="function"?(this.c=u,this.d=S):(this.c=c,this.d=u.getCacheKey)}get(u){const c=this.d(u);return this.b!==c&&(this.b=c,this.a=this.c(u)),this.a}}e.$7e=R;class j{get cachedValues(){return this.a}constructor(u,c){this.a=new Map,this.b=new Map,typeof u=="function"?(this.c=u,this.d=S):(this.c=c,this.d=u.getCacheKey)}get(u){const c=this.d(u);if(this.b.has(c))return this.b.get(c);const d=this.c(u);return this.a.set(u,d),this.b.set(c,d),d}}e.$8e=j}),define(re[63],oe([0,1,15,2]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=S,e.$ve=R,e.$we=j,e.$xe=k,e.$ye=c,e.$ze=d,e.$Ae=p,e.$Be=v,e.$Ce=$,e.$De=f,e.$Ee=y,e.$Fe=w,e.$Ge=b,e.$He=g,e.$Ie=h;function S(E){const a=E;return a?typeof a.read=="function":!1}function R(E){const a=E;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function j(E){const a=E;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function k(E,a){return new u(E,a)}class u{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(E,a){const t=[];let r;for(;(r=E.read())!==null;)t.push(r);return a(t)}function d(E,a,t){const r=[];let s;for(;(s=E.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return E.read()}}}function p(E,a){return new Promise((t,r)=>{const s=[];v(E,{onData:i=>{a&&s.push(i)},onError:i=>{a?r(i):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}function v(E,a,t){E.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),E.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),E.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}function $(E,a){return new Promise((t,r)=>{const s=new A.$Tc,i=[],o=P=>{if(i.push(P),i.length>a)return s.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},l=P=>(s.dispose(),r(P)),m=()=>(s.dispose(),t({stream:E,buffer:i,ended:!0}));s.add((0,A.$Sc)(()=>E.removeListener("error",l))),E.on("error",l),s.add((0,A.$Sc)(()=>E.removeListener("end",m))),E.on("end",m),s.add((0,A.$Sc)(()=>E.removeListener("data",o))),E.on("data",o)})}function f(E,a){const t=k(a);return t.end(E),t}function y(){const E=k(()=>{throw new Error("not supported")});return E.end(),E}function w(E){let a=!1;return{read:()=>a?null:(a=!0,E)}}function b(E,a,t){const r=k(t);return v(E,{onData:s=>r.write(a.data(s)),onError:s=>r.error(a.error?a.error(s):s),onEnd:()=>r.end()}),r}function g(E,a,t){let r=!1;return{read:()=>{const s=a.read();return r?s:(r=!0,s!==null?t([E,s]):E)}}}function h(E,a,t){let r=!1;const s=k(t);return v(a,{onData:i=>r?s.write(i):(r=!0,s.write(t([E,i]))),onError:i=>s.error(i),onEnd:()=>{r||(r=!0,s.write(E)),s.end()}}),s}}),define(re[17],oe([0,1,62,63]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=c,e.$Le=d,e.$Me=p,e.$Ne=v,e.$Oe=$,e.$Pe=f,e.$Qe=y,e.$Re=w,e.$Se=b,e.$Te=g,e.$Ue=h,e.$Ve=E,e.$We=a,e.$Xe=t,e.$Ye=r,e.$Ze=s,e.$1e=i,e.$2e=o,e.$3e=l,e.$4e=D;const S=typeof Buffer<"u",R=new n.$V(()=>new Uint8Array(256));let j,k;class u{static alloc(O){return S?new u(Buffer.allocUnsafe(O)):new u(new Uint8Array(O))}static wrap(O){return S&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new u(O)}static fromString(O,M){return!(M?.dontUseNodeBuffer||!1)&&S?new u(Buffer.from(O)):(j||(j=new TextEncoder),new u(j.encode(O)))}static fromByteArray(O){const M=u.alloc(O.length);for(let W=0,N=O.length;W<N;W++)M.buffer[W]=O[W];return M}static concat(O,M){if(typeof M>"u"){M=0;for(let T=0,U=O.length;T<U;T++)M+=O[T].byteLength}const W=u.alloc(M);let N=0;for(let T=0,U=O.length;T<U;T++){const ie=O[T];W.set(ie,N),N+=ie.byteLength}return W}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=u.alloc(this.byteLength);return O.set(this),O}toString(){return S?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(O,M){return new u(this.buffer.subarray(O,M))}set(O,M){if(O instanceof u)this.buffer.set(O.buffer,M);else if(O instanceof Uint8Array)this.buffer.set(O,M);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),M);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return v(this.buffer,O)}writeUInt32BE(O,M){$(this.buffer,O,M)}readUInt32LE(O){return f(this.buffer,O)}writeUInt32LE(O,M){y(this.buffer,O,M)}readUInt8(O){return w(this.buffer,O)}writeUInt8(O,M){b(this.buffer,O,M)}indexOf(O,M=0){return c(this.buffer,O instanceof u?O.buffer:O,M)}}e.$Je=u;function c(I,O,M=0){const W=O.byteLength,N=I.byteLength;if(W===0)return 0;if(W===1)return I.indexOf(O[0]);if(W>N-M)return-1;const T=R.value;T.fill(O.length);for(let ae=0;ae<O.length;ae++)T[O[ae]]=O.length-ae-1;let U=M+O.length-1,ie=U,te=-1;for(;U<N;)if(I[U]===O[ie]){if(ie===0){te=U;break}U--,ie--}else U+=Math.max(O.length-ie,T[I[U]]),ie=O.length-1;return te}function d(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0}function p(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255}function v(I,O){return I[O]*2**24+I[O+1]*2**16+I[O+2]*2**8+I[O+3]}function $(I,O,M){I[M+3]=O,O=O>>>8,I[M+2]=O,O=O>>>8,I[M+1]=O,O=O>>>8,I[M]=O}function f(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0|I[O+2]<<16>>>0|I[O+3]<<24>>>0}function y(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255,O=O>>>8,I[M+2]=O&255,O=O>>>8,I[M+3]=O&255}function w(I,O){return I[O]}function b(I,O,M){I[M]=O}function g(I){return A.$ye(I,O=>u.concat(O))}function h(I){return A.$Fe(I)}function E(I){return A.$Ae(I,O=>u.concat(O))}async function a(I){return I.ended?u.concat(I.buffer):u.concat([...I.buffer,await E(I.stream)])}function t(I){return A.$De(I,O=>u.concat(O))}function r(I){return A.$Ge(I,{data:O=>typeof O=="string"?u.fromString(O):u.wrap(O)},O=>u.concat(O))}function s(I){return A.$xe(O=>u.concat(O),I)}function i(I,O){return A.$He(I,O,M=>u.concat(M))}function o(I,O){return A.$Ie(I,O,M=>u.concat(M))}function l(I){let O=0,M=0,W=0;const N=new Uint8Array(Math.floor(I.length/4*3)),T=ie=>{switch(M){case 3:N[W++]=O|ie,M=0;break;case 2:N[W++]=O|ie>>>2,O=ie<<6,M=3;break;case 1:N[W++]=O|ie>>>4,O=ie<<4,M=2;break;default:O=ie<<2,M=1}};for(let ie=0;ie<I.length;ie++){const te=I.charCodeAt(ie);if(te>=65&&te<=90)T(te-65);else if(te>=97&&te<=122)T(te-97+26);else if(te>=48&&te<=57)T(te-48+52);else if(te===43||te===45)T(62);else if(te===47||te===95)T(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${I[ie]}`)}}const U=W;for(;M>0;)T(0);return u.wrap(N).slice(0,U)}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:I},O=!0,M=!1){const W=M?P:m;let N="";const T=I.byteLength%3;let U=0;for(;U<I.byteLength-T;U+=3){const ie=I[U+0],te=I[U+1],ae=I[U+2];N+=W[ie>>>2],N+=W[(ie<<4|te>>>4)&63],N+=W[(te<<2|ae>>>6)&63],N+=W[ae&63]}if(T===1){const ie=I[U+0];N+=W[ie>>>2],N+=W[ie<<4&63],O&&(N+="==")}else if(T===2){const ie=I[U+0],te=I[U+1];N+=W[ie>>>2],N+=W[(ie<<4|te>>>4)&63],N+=W[te<<2&63],O&&(N+="=")}return N}}),define(re[25],oe([0,1,143,62]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=S,e.$_e=j,e.$af=u,e.$bf=c,e.$cf=d,e.$df=p,e.$ef=v,e.$ff=$,e.$gf=f,e.$hf=y,e.$if=w,e.$jf=b,e.$kf=g,e.$lf=h,e.$mf=E,e.$nf=a,e.$of=t,e.$pf=r,e.$qf=s,e.$rf=i,e.$sf=o,e.$tf=l,e.$uf=m,e.$vf=P,e.$wf=D,e.$xf=I,e.$yf=O,e.$zf=M,e.$Af=W,e.$Bf=N,e.$Cf=T,e.$Df=U,e.$Ef=ie,e.$Ff=te,e.$Gf=ae,e.$Hf=K,e.$If=J,e.$Lf=H,e.$Mf=ce,e.$Nf=V,e.$Of=le,e.$Pf=F,e.$Qf=B,e.$Sf=Z,e.$Tf=x,e.$Uf=ee,e.$Vf=G,e.$Wf=fe,e.$Xf=we,e.$Yf=Oe,e.$1f=ye,e.$2f=ve,e.$3f=Ce,e.$4f=me,e.$5f=X,e.$6f=he,e.$7f=ge,e.$8f=Se,e.$9f=Be;function S(se){return!se||typeof se!="string"?!0:se.trim().length===0}const R=/{(\d+)}/g;function j(se,...de){return de.length===0?se:se.replace(R,function($e,be){const je=parseInt(be,10);return isNaN(je)||je<0||je>=de.length?$e:de[je]})}const k=/{([^}]+)}/g;function u(se,de){return Object.keys(de).length===0?se:se.replace(k,($e,be)=>de[be]??$e)}function c(se){return se.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function d(se){return se.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function p(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function v(se,de){let $e=0,be=se.indexOf(de);for(;be!==-1;)$e++,be=se.indexOf(de,be+de.length);return $e}function $(se,de,$e="\u2026"){return se.length<=de?se:`${se.substr(0,de)}${$e}`}function f(se,de,$e="\u2026"){if(se.length<=de)return se;const be=Math.ceil(de/2)-$e.length/2,je=Math.floor(de/2)-$e.length/2;return`${se.substr(0,be)}${$e}${se.substr(se.length-je)}`}function y(se,de=" "){const $e=w(se,de);return b($e,de)}function w(se,de){if(!se||!de)return se;const $e=de.length;if($e===0||se.length===0)return se;let be=0;for(;se.indexOf(de,be)===be;)be=be+$e;return se.substring(be)}function b(se,de){if(!se||!de)return se;const $e=de.length,be=se.length;if($e===0||be===0)return se;let je=be,Le=-1;for(;Le=se.lastIndexOf(de,je-1),!(Le===-1||Le+$e!==je);){if(Le===0)return"";je=Le}return se.substring(0,je)}function g(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(se){return se.replace(/\*/g,"")}function E(se,de,$e={}){if(!se)throw new Error("Cannot create regex from empty string");de||(se=p(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let be="";return $e.global&&(be+="g"),$e.matchCase||(be+="i"),$e.multiline&&(be+="m"),$e.unicode&&(be+="u"),new RegExp(se,be)}function a(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function t(se){return se.split(/\r\n|\r|\n/)}function r(se){const de=[],$e=se.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil($e.length/2);be++)de.push($e[2*be]+($e[2*be+1]??""));return de}function s(se){for(let de=0,$e=se.length;de<$e;de++){const be=se.charCodeAt(de);if(be!==32&&be!==9)return de}return-1}function i(se,de=0,$e=se.length){for(let be=de;be<$e;be++){const je=se.charCodeAt(be);if(je!==32&&je!==9)return se.substring(de,be)}return se.substring(de,$e)}function o(se,de=se.length-1){for(let $e=de;$e>=0;$e--){const be=se.charCodeAt($e);if(be!==32&&be!==9)return $e}return-1}function l(se,de,$e){const be=[];let je=0;for(const Le of se.matchAll(de)){if(be.push(se.slice(je,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");je=Le.index+Le[0].length,be.push($e(Le[0],...Le.slice(1),Le.index,se,Le.groups))}return be.push(se.slice(je)),Promise.all(be).then(Le=>Le.join(""))}function m(se,de){return se<de?-1:se>de?1:0}function P(se,de,$e=0,be=se.length,je=0,Le=de.length){for(;$e<be&&je<Le;$e++,je++){const _e=se.charCodeAt($e),st=de.charCodeAt(je);if(_e<st)return-1;if(_e>st)return 1}const Qe=be-$e,Ze=Le-je;return Qe<Ze?-1:Qe>Ze?1:0}function D(se,de){return I(se,de,0,se.length,0,de.length)}function I(se,de,$e=0,be=se.length,je=0,Le=de.length){for(;$e<be&&je<Le;$e++,je++){let _e=se.charCodeAt($e),st=de.charCodeAt(je);if(_e===st)continue;if(_e>=128||st>=128)return P(se.toLowerCase(),de.toLowerCase(),$e,be,je,Le);M(_e)&&(_e-=32),M(st)&&(st-=32);const Ye=_e-st;if(Ye!==0)return Ye}const Qe=be-$e,Ze=Le-je;return Qe<Ze?-1:Qe>Ze?1:0}function O(se){return se>=48&&se<=57}function M(se){return se>=97&&se<=122}function W(se){return se>=65&&se<=90}function N(se,de){return se.length===de.length&&I(se,de)===0}function T(se,de){const $e=de.length;return de.length>se.length?!1:I(se,de,0,$e)===0}function U(se,de){const $e=Math.min(se.length,de.length);let be;for(be=0;be<$e;be++)if(se.charCodeAt(be)!==de.charCodeAt(be))return be;return $e}function ie(se,de){const $e=Math.min(se.length,de.length);let be;const je=se.length-1,Le=de.length-1;for(be=0;be<$e;be++)if(se.charCodeAt(je-be)!==de.charCodeAt(Le-be))return be;return $e}function te(se){return 55296<=se&&se<=56319}function ae(se){return 56320<=se&&se<=57343}function K(se,de){return(se-55296<<10)+(de-56320)+65536}function J(se,de,$e){const be=se.charCodeAt($e);if(te(be)&&$e+1<de){const je=se.charCodeAt($e+1);if(ae(je))return K(be,je)}return be}function q(se,de){const $e=se.charCodeAt(de-1);if(ae($e)&&de>1){const be=se.charCodeAt(de-2);if(te(be))return K(be,$e)}return $e}class L{get offset(){return this.e}constructor(de,$e=0){this.c=de,this.d=de.length,this.e=$e}setOffset(de){this.e=de}prevCodePoint(){const de=q(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=J(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Jf=L;class z{get offset(){return this.c.offset}constructor(de,$e=0){this.c=new L(de,$e)}nextGraphemeLength(){const de=Me.getInstance(),$e=this.c,be=$e.offset;let je=de.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Le=$e.offset,Qe=de.getGraphemeBreakType($e.nextCodePoint());if(De(je,Qe)){$e.setOffset(Le);break}je=Qe}return $e.offset-be}prevGraphemeLength(){const de=Me.getInstance(),$e=this.c,be=$e.offset;let je=de.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Le=$e.offset,Qe=de.getGraphemeBreakType($e.prevCodePoint());if(De(Qe,je)){$e.setOffset(Le);break}je=Qe}return be-$e.offset}eol(){return this.c.eol()}}e.$Kf=z;function H(se,de){return new z(se,de).nextGraphemeLength()}function ce(se,de){return new z(se,de).prevGraphemeLength()}function V(se,de){de>0&&ae(se.charCodeAt(de))&&de--;const $e=de+H(se,de);return[$e-ce(se,$e),$e]}function le(se){const de=new z(se);let $e=0;for(;!de.eol();)$e++,de.nextGraphemeLength();return $e}let Y;function C(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(se){return Y||(Y=C()),Y.test(se)}const _=/^[\t\n\r\x20-\x7E]*$/;function B(se){return _.test(se)}e.$Rf=/[\u2028\u2029]/;function Z(se){return e.$Rf.test(se)}function x(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ee(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function G(se,de,$e=""){const be=se.trimStart();if(be.length<de)return be;const je=/\b/g;let Le=0;for(;je.test(be)&&!(be.length-je.lastIndex<de);)Le=je.lastIndex,je.lastIndex+=1;return Le===0?be:$e+be.substring(Le).trimStart()}const ue=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*fe(se){let de=0;for(const $e of se.matchAll(ue))de!==$e.index&&(yield{isCode:!1,str:se.substring(de,$e.index)}),yield{isCode:!0,str:$e[0]},de=$e.index+$e[0].length;de!==se.length&&(yield{isCode:!1,str:se.substring(de)})}function we(se){return se&&(se=se.replace(ue,"")),se}const Ee=/\\\[.*?\\\]/g;function Oe(se){return we(se).replace(Ee,"")}e.$Zf="\uFEFF";function ye(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}function ve(se){return ye(se)?se.substr(1):se}function Ce(se,de){if(!se||!de||se.length<de.length)return!1;const $e=de.length,be=se.toLowerCase();let je=0,Le=-1;for(;je<$e;){const Qe=be.indexOf(de[je],Le+1);if(Qe<0)return!1;Le=Qe,je++}return!0}function me(se,de=!1){return se?(de&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function X(se){return se.charAt(0).toUpperCase()+se.slice(1)}function he(se,de=1){if(de===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),de--;while(de>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function ge(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}function Se(se){return Me.getInstance().getGraphemeBreakType(se)}function De(se,de){return se===0?de!==5&&de!==7:se===2&&de===3?!1:se===4||se===2||se===3||de===4||de===2||de===3?!0:!(se===8&&(de===8||de===9||de===11||de===12)||(se===11||se===9)&&(de===9||de===10)||(se===12||se===10)&&de===10||de===5||de===13||de===7||se===1||se===13&&de===14||se===6&&de===6)}var Ne;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(e.GraphemeBreakType=Ne={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=Fe()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const $e=this.d,be=$e.length/3;let je=1;for(;je<=be;)if(de<$e[3*je])je=2*je;else if(de>$e[3*je+1])je=2*je+1;else return $e[3*je+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(se,de){if(se===0)return 0;const $e=He(se,de);if($e!==void 0)return $e;const be=new L(de,se);return be.prevCodePoint(),be.offset}function He(se,de){const $e=new L(de,se);let be=$e.prevCodePoint();for(;Xe(be)||be===65039||be===8419;){if($e.offset===0)return;be=$e.prevCodePoint()}if(!ee(be))return;let je=$e.offset;return je>0&&$e.prevCodePoint()===8205&&(je=$e.offset),je}function Xe(se){return 127995<=se&&se<=127999}var Te;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.$0f="\xA0";class xe{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$7e({getCacheKey:JSON.stringify},de=>{function $e(Ye){const ot=new Map;for(let rt=0;rt<Ye.length;rt+=2)ot.set(Ye[rt],Ye[rt+1]);return ot}function be(Ye,ot){const rt=new Map(Ye);for(const[ct,lt]of ot)rt.set(ct,lt);return rt}function je(Ye,ot){if(!Ye)return ot;const rt=new Map;for(const[ct,lt]of Ye)ot.has(ct)&&rt.set(ct,lt);return rt}const Le=this.c.value;let Qe=de.filter(Ye=>!Ye.startsWith("_")&&Ye in Le);Qe.length===0&&(Qe=["_default"]);let Ze;for(const Ye of Qe){const ot=$e(Le[Ye]);Ze=je(Ze,ot)}const _e=$e(Le._common),st=be(_e,Ze);return new xe(st)})}static getInstance(de){return xe.d.get(Array.from(de))}static{this.e=new A.$V(()=>Object.keys(xe.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return xe.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}containsAmbiguousCharacter(de){for(let $e=0;$e<de.length;$e++){const be=de.codePointAt($e);if(typeof be=="number"&&this.isAmbiguous(be))return!0}return!1}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=xe;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(de){return Ge.e().has(de)}static containsInvisibleCharacter(de){for(let $e=0;$e<de.length;$e++){const be=de.codePointAt($e);if(typeof be=="number"&&Ge.isInvisibleCharacter(be))return!0}return!1}static get codePoints(){return Ge.e()}}e.$_f=Ge}),define(re[46],oe([0,1,25]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=A,e.$pj=S,e.$qj=R,e.$rj=k,e.$tj=y;function A(b){return S(b,0)}function S(b,g){switch(typeof b){case"object":return b===null?R(349,g):Array.isArray(b)?u(b,g):c(b,g);case"string":return k(b,g);case"boolean":return j(b,g);case"number":return R(b,g);case"undefined":return R(937,g);default:return R(617,g)}}function R(b,g){return(g<<5)-g+b|0}function j(b,g){return R(b?433:863,g)}function k(b,g){g=R(149417,g);for(let h=0,E=b.length;h<E;h++)g=R(b.charCodeAt(h),g);return g}function u(b,g){return g=R(104579,g),b.reduce((h,E)=>S(E,h),g)}function c(b,g){return g=R(181387,g),Object.keys(b).sort().reduce((h,E)=>(h=k(E,h),S(b[E],h)),g)}class d{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=S(g,this.g),this.g}}e.$sj=d;var p;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function v(b,g,h=32){const E=h-g,a=~((1<<E)-1);return(b<<g|(a&b)>>>E)>>>0}function $(b,g=0,h=b.byteLength,E=0){for(let a=0;a<h;a++)b[g+a]=E}function f(b,g,h="0"){for(;b.length<g;)b=h+b;return b}function y(b,g=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(h=>h.toString(16).padStart(2,"0")).join(""):f((b>>>0).toString(16),g/4)}class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const h=g.length;if(h===0)return;const E=this.p;let a=this.r,t=this.u,r,s;for(t!==0?(r=t,s=-1,t=0):(r=g.charCodeAt(0),s=0);;){let i=r;if(n.$Ff(r))if(s+1<h){const o=g.charCodeAt(s+1);n.$Gf(o)?(s++,i=n.$Hf(r,o)):i=65533}else{t=r;break}else n.$Gf(r)&&(i=65533);if(a=this.w(E,a,i),s++,s<h)r=g.charCodeAt(s);else break}this.r=a,this.u=t}w(g,h,E){return E<128?g[h++]=E:E<2048?(g[h++]=192|(E&1984)>>>6,g[h++]=128|(E&63)>>>0):E<65536?(g[h++]=224|(E&61440)>>>12,g[h++]=128|(E&4032)>>>6,g[h++]=128|(E&63)>>>0):(g[h++]=240|(E&1835008)>>>18,g[h++]=128|(E&258048)>>>12,g[h++]=128|(E&4032)>>>6,g[h++]=128|(E&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,g[0]=g[64],g[1]=g[65],g[2]=g[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=w.g,h=this.q;for(let m=0;m<64;m+=4)g.setUint32(m,h.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)g.setUint32(m,v(g.getUint32(m-12,!1)^g.getUint32(m-32,!1)^g.getUint32(m-56,!1)^g.getUint32(m-64,!1),1),!1);let E=this.h,a=this.l,t=this.m,r=this.n,s=this.o,i,o,l;for(let m=0;m<80;m++)m<20?(i=a&t|~a&r,o=1518500249):m<40?(i=a^t^r,o=1859775393):m<60?(i=a&t|a&r|t&r,o=2400959708):(i=a^t^r,o=3395469782),l=v(E,5)+i+s+o+g.getUint32(m*4,!1)&4294967295,s=r,r=t,t=v(a,30),a=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+s&4294967295}}e.$uj=w}),define(re[74],oe([0,1,25]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(A||(A={})),function(S){const R="error",j="warning",k="warn",u="info",c="ignore";function d(v){return v?n.$Bf(R,v)?S.Error:n.$Bf(j,v)||n.$Bf(k,v)?S.Warning:n.$Bf(u,v)?S.Info:S.Ignore:S.Ignore}S.fromValue=d;function p(v){switch(v){case S.Error:return R;case S.Warning:return j;case S.Info:return u;default:return c}}S.toString=p}(A||(A={})),e.default=A}),define(re[144],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(re[59],oe([0,1,22,25]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class S{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const f=$.charCodeAt(0),y=this.b.charCodeAt(this.c);return f-y}value(){return this.b[this.c]}}e.$Ci=S;class R{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,A.$vf)($,this.b,0,$.length,this.c,this.d):(0,A.$xf)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=R;class j{constructor($=!0,f=!0){this.f=$,this.g=f}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let f=$.length-1;f>=0;f--,this.c--){const y=this.b.charCodeAt(f);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,A.$vf)($,this.b,0,$.length,this.d,this.e):(0,A.$xf)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=j;var k;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(k||(k={}));class u{constructor($,f){this.f=$,this.g=f,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,A.$wf)($,this.c.scheme);if(this.d[this.e]===2)return(0,A.$wf)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,A.$uf)($,this.c.query);if(this.d[this.e]===5)return(0,A.$uf)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fi=u;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(d||(d={}));class p{static forUris($=()=>!1,f=()=>!1){return new p(new u($,f))}static forPaths($=!1){return new p(new j(void 0,!$))}static forStrings(){return new p(new S)}static forConfigKeys(){return new p(new R)}constructor($){this.b=$}clear(){this.c=void 0}fill($,f){if(f){const y=f.slice(0);(0,n.$Wb)(y);for(const w of y)this.set(w,$)}else{const y=$.slice(0);(0,n.$Wb)(y);for(const w of y)this.set(w[0],w[1])}}set($,f){const y=this.b.reset($);let w;this.c||(this.c=new c,this.c.segment=y.value());const b=[];for(w=this.c;;){const h=y.cmp(w.segment);if(h>0)w.left||(w.left=new c,w.left.segment=y.value()),b.push([-1,w]),w=w.left;else if(h<0)w.right||(w.right=new c,w.right.segment=y.value()),b.push([1,w]),w=w.right;else if(y.hasNext())y.next(),w.mid||(w.mid=new c,w.mid.segment=y.value()),b.push([0,w]),w=w.mid;else break}const g=w.value;w.value=f,w.key=$;for(let h=b.length-1;h>=0;h--){const E=b[h][1];E.updateHeight();const a=E.balanceFactor();if(a<-1||a>1){const t=b[h][0],r=b[h+1][0];if(t===1&&r===1)b[h][1]=E.rotateLeft();else if(t===-1&&r===-1)b[h][1]=E.rotateRight();else if(t===1&&r===-1)E.right=b[h+1][1]=b[h+1][1].rotateRight(),b[h][1]=E.rotateLeft();else if(t===-1&&r===1)E.left=b[h+1][1]=b[h+1][1].rotateLeft(),b[h][1]=E.rotateRight();else throw new Error;if(h>0)switch(b[h-1][0]){case-1:b[h-1][1].left=b[h][1];break;case 1:b[h-1][1].right=b[h][1];break;case 0:b[h-1][1].mid=b[h][1];break}else this.c=b[0][1]}}return g}get($){return this.d($)?.value}d($){const f=this.b.reset($);let y=this.c;for(;y;){const w=f.cmp(y.segment);if(w>0)y=y.left;else if(w<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else break}return y}has($){const f=this.d($);return!(f?.value===void 0&&f?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,f){const y=this.b.reset($),w=[];let b=this.c;for(;b;){const g=y.cmp(b.segment);if(g>0)w.push([-1,b]),b=b.left;else if(g<0)w.push([1,b]),b=b.right;else if(y.hasNext())y.next(),w.push([0,b]),b=b.mid;else break}if(b){if(f?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const g=this.f(b.right);if(g.key){const{key:h,value:E,segment:a}=g;this.e(g.key,!1),b.key=h,b.value=E,b.segment=a}}else{const g=b.left??b.right;if(w.length>0){const[h,E]=w[w.length-1];switch(h){case-1:E.left=g;break;case 0:E.mid=g;break;case 1:E.right=g;break}}else this.c=g}for(let g=w.length-1;g>=0;g--){const h=w[g][1];h.updateHeight();const E=h.balanceFactor();if(E>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),w[g][1]=h.rotateLeft()):E<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),w[g][1]=h.rotateRight()),g>0)switch(w[g-1][0]){case-1:w[g-1][1].left=w[g][1];break;case 1:w[g-1][1].right=w[g][1];break;case 0:w[g-1][1].mid=w[g][1];break}else this.c=w[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const f=this.b.reset($);let y=this.c,w;for(;y;){const b=f.cmp(y.segment);if(b>0)y=y.left;else if(b<0)y=y.right;else if(f.hasNext())f.next(),w=y.value||w,y=y.mid;else break}return y&&y.value||w}findSuperstr($){return this.g($,!1)}g($,f){const y=this.b.reset($);let w=this.c;for(;w;){const b=y.cmp(w.segment);if(b>0)w=w.left;else if(b<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else return w.mid?this.h(w.mid):f?w.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[f,y]of this)$(y,f)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const f=[];return this.j($,f),f[Symbol.iterator]()}j($,f){$&&($.left&&this.j($.left,f),$.value&&f.push([$.key,$.value]),$.mid&&this.j($.mid,f),$.right&&this.j($.right,f))}_isBalanced(){const $=f=>{if(!f)return!0;const y=f.balanceFactor();return y<-1||y>1?!1:$(f.left)&&$(f.right)};return $(this.c)}}e.$Gi=p}),define(re[12],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=n,e.$bg=A,e.$cg=S,e.$dg=R,e.$eg=j,e.$fg=k,e.$gg=u,e.$hg=c,e.$ig=d,e.$jg=p,e.$kg=v,e.$lg=$,e.$mg=f,e.$ng=w,e.$og=b,e.$pg=g,e.$qg=h,e.$rg=E;function n(a){return typeof a=="string"}function A(a){return Array.isArray(a)&&a.every(t=>n(t))}function S(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function j(a){return typeof a=="number"&&!isNaN(a)}function k(a){return!!a&&typeof a[Symbol.iterator]=="function"}function u(a){return a===!0||a===!1}function c(a){return typeof a>"u"}function d(a){return!p(a)}function p(a){return c(a)||a===null}function v(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function $(a){if(p(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function f(...a){const t=[];for(let r=0;r<a.length;r++){const s=a[r];if(p(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}const y=Object.prototype.hasOwnProperty;function w(a){if(!S(a))return!1;for(const t in a)if(y.call(a,t))return!1;return!0}function b(a){return typeof a=="function"}function g(...a){return a.length>0&&a.every(b)}function h(a,t){const r=Math.min(a.length,t.length);for(let s=0;s<r;s++)E(a[s],t[s])}function E(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(b(t)){try{if(a instanceof t)return}catch{}if(!p(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(re[105],oe([0,1,12]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=S,e.$Vj=R;const A=Object.create(null);function S(j,k){if((0,n.$ag)(k)){const u=A[k];if(u===void 0)throw new Error(`${j} references an unknown codicon: ${k}`);k=u}return A[j]=k,{id:j}}function R(){return A}}),define(re[145],oe([0,1,105]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0,e.$Wj={add:(0,n.$Uj)("add",6e4),plus:(0,n.$Uj)("plus",6e4),gistNew:(0,n.$Uj)("gist-new",6e4),repoCreate:(0,n.$Uj)("repo-create",6e4),lightbulb:(0,n.$Uj)("lightbulb",60001),lightBulb:(0,n.$Uj)("light-bulb",60001),repo:(0,n.$Uj)("repo",60002),repoDelete:(0,n.$Uj)("repo-delete",60002),gistFork:(0,n.$Uj)("gist-fork",60003),repoForked:(0,n.$Uj)("repo-forked",60003),gitPullRequest:(0,n.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Uj)("record-keys",60005),keyboard:(0,n.$Uj)("keyboard",60005),tag:(0,n.$Uj)("tag",60006),gitPullRequestLabel:(0,n.$Uj)("git-pull-request-label",60006),tagAdd:(0,n.$Uj)("tag-add",60006),tagRemove:(0,n.$Uj)("tag-remove",60006),person:(0,n.$Uj)("person",60007),personFollow:(0,n.$Uj)("person-follow",60007),personOutline:(0,n.$Uj)("person-outline",60007),personFilled:(0,n.$Uj)("person-filled",60007),gitBranch:(0,n.$Uj)("git-branch",60008),gitBranchCreate:(0,n.$Uj)("git-branch-create",60008),gitBranchDelete:(0,n.$Uj)("git-branch-delete",60008),sourceControl:(0,n.$Uj)("source-control",60008),mirror:(0,n.$Uj)("mirror",60009),mirrorPublic:(0,n.$Uj)("mirror-public",60009),star:(0,n.$Uj)("star",60010),starAdd:(0,n.$Uj)("star-add",60010),starDelete:(0,n.$Uj)("star-delete",60010),starEmpty:(0,n.$Uj)("star-empty",60010),comment:(0,n.$Uj)("comment",60011),commentAdd:(0,n.$Uj)("comment-add",60011),alert:(0,n.$Uj)("alert",60012),warning:(0,n.$Uj)("warning",60012),search:(0,n.$Uj)("search",60013),searchSave:(0,n.$Uj)("search-save",60013),logOut:(0,n.$Uj)("log-out",60014),signOut:(0,n.$Uj)("sign-out",60014),logIn:(0,n.$Uj)("log-in",60015),signIn:(0,n.$Uj)("sign-in",60015),eye:(0,n.$Uj)("eye",60016),eyeUnwatch:(0,n.$Uj)("eye-unwatch",60016),eyeWatch:(0,n.$Uj)("eye-watch",60016),circleFilled:(0,n.$Uj)("circle-filled",60017),primitiveDot:(0,n.$Uj)("primitive-dot",60017),closeDirty:(0,n.$Uj)("close-dirty",60017),debugBreakpoint:(0,n.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Uj)("primitive-square",60018),edit:(0,n.$Uj)("edit",60019),pencil:(0,n.$Uj)("pencil",60019),info:(0,n.$Uj)("info",60020),issueOpened:(0,n.$Uj)("issue-opened",60020),gistPrivate:(0,n.$Uj)("gist-private",60021),gitForkPrivate:(0,n.$Uj)("git-fork-private",60021),lock:(0,n.$Uj)("lock",60021),mirrorPrivate:(0,n.$Uj)("mirror-private",60021),close:(0,n.$Uj)("close",60022),removeClose:(0,n.$Uj)("remove-close",60022),x:(0,n.$Uj)("x",60022),repoSync:(0,n.$Uj)("repo-sync",60023),sync:(0,n.$Uj)("sync",60023),clone:(0,n.$Uj)("clone",60024),desktopDownload:(0,n.$Uj)("desktop-download",60024),beaker:(0,n.$Uj)("beaker",60025),microscope:(0,n.$Uj)("microscope",60025),vm:(0,n.$Uj)("vm",60026),deviceDesktop:(0,n.$Uj)("device-desktop",60026),file:(0,n.$Uj)("file",60027),fileText:(0,n.$Uj)("file-text",60027),more:(0,n.$Uj)("more",60028),ellipsis:(0,n.$Uj)("ellipsis",60028),kebabHorizontal:(0,n.$Uj)("kebab-horizontal",60028),mailReply:(0,n.$Uj)("mail-reply",60029),reply:(0,n.$Uj)("reply",60029),organization:(0,n.$Uj)("organization",60030),organizationFilled:(0,n.$Uj)("organization-filled",60030),organizationOutline:(0,n.$Uj)("organization-outline",60030),newFile:(0,n.$Uj)("new-file",60031),fileAdd:(0,n.$Uj)("file-add",60031),newFolder:(0,n.$Uj)("new-folder",60032),fileDirectoryCreate:(0,n.$Uj)("file-directory-create",60032),trash:(0,n.$Uj)("trash",60033),trashcan:(0,n.$Uj)("trashcan",60033),history:(0,n.$Uj)("history",60034),clock:(0,n.$Uj)("clock",60034),folder:(0,n.$Uj)("folder",60035),fileDirectory:(0,n.$Uj)("file-directory",60035),symbolFolder:(0,n.$Uj)("symbol-folder",60035),logoGithub:(0,n.$Uj)("logo-github",60036),markGithub:(0,n.$Uj)("mark-github",60036),github:(0,n.$Uj)("github",60036),terminal:(0,n.$Uj)("terminal",60037),console:(0,n.$Uj)("console",60037),repl:(0,n.$Uj)("repl",60037),zap:(0,n.$Uj)("zap",60038),symbolEvent:(0,n.$Uj)("symbol-event",60038),error:(0,n.$Uj)("error",60039),stop:(0,n.$Uj)("stop",60039),variable:(0,n.$Uj)("variable",60040),symbolVariable:(0,n.$Uj)("symbol-variable",60040),array:(0,n.$Uj)("array",60042),symbolArray:(0,n.$Uj)("symbol-array",60042),symbolModule:(0,n.$Uj)("symbol-module",60043),symbolPackage:(0,n.$Uj)("symbol-package",60043),symbolNamespace:(0,n.$Uj)("symbol-namespace",60043),symbolObject:(0,n.$Uj)("symbol-object",60043),symbolMethod:(0,n.$Uj)("symbol-method",60044),symbolFunction:(0,n.$Uj)("symbol-function",60044),symbolConstructor:(0,n.$Uj)("symbol-constructor",60044),symbolBoolean:(0,n.$Uj)("symbol-boolean",60047),symbolNull:(0,n.$Uj)("symbol-null",60047),symbolNumeric:(0,n.$Uj)("symbol-numeric",60048),symbolNumber:(0,n.$Uj)("symbol-number",60048),symbolStructure:(0,n.$Uj)("symbol-structure",60049),symbolStruct:(0,n.$Uj)("symbol-struct",60049),symbolParameter:(0,n.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Uj)("symbol-type-parameter",60050),symbolKey:(0,n.$Uj)("symbol-key",60051),symbolText:(0,n.$Uj)("symbol-text",60051),symbolReference:(0,n.$Uj)("symbol-reference",60052),goToFile:(0,n.$Uj)("go-to-file",60052),symbolEnum:(0,n.$Uj)("symbol-enum",60053),symbolValue:(0,n.$Uj)("symbol-value",60053),symbolRuler:(0,n.$Uj)("symbol-ruler",60054),symbolUnit:(0,n.$Uj)("symbol-unit",60054),activateBreakpoints:(0,n.$Uj)("activate-breakpoints",60055),archive:(0,n.$Uj)("archive",60056),arrowBoth:(0,n.$Uj)("arrow-both",60057),arrowDown:(0,n.$Uj)("arrow-down",60058),arrowLeft:(0,n.$Uj)("arrow-left",60059),arrowRight:(0,n.$Uj)("arrow-right",60060),arrowSmallDown:(0,n.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Uj)("arrow-small-up",60064),arrowUp:(0,n.$Uj)("arrow-up",60065),bell:(0,n.$Uj)("bell",60066),bold:(0,n.$Uj)("bold",60067),book:(0,n.$Uj)("book",60068),bookmark:(0,n.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Uj)("briefcase",60076),broadcast:(0,n.$Uj)("broadcast",60077),browser:(0,n.$Uj)("browser",60078),bug:(0,n.$Uj)("bug",60079),calendar:(0,n.$Uj)("calendar",60080),caseSensitive:(0,n.$Uj)("case-sensitive",60081),check:(0,n.$Uj)("check",60082),checklist:(0,n.$Uj)("checklist",60083),chevronDown:(0,n.$Uj)("chevron-down",60084),chevronLeft:(0,n.$Uj)("chevron-left",60085),chevronRight:(0,n.$Uj)("chevron-right",60086),chevronUp:(0,n.$Uj)("chevron-up",60087),chromeClose:(0,n.$Uj)("chrome-close",60088),chromeMaximize:(0,n.$Uj)("chrome-maximize",60089),chromeMinimize:(0,n.$Uj)("chrome-minimize",60090),chromeRestore:(0,n.$Uj)("chrome-restore",60091),circleOutline:(0,n.$Uj)("circle-outline",60092),circle:(0,n.$Uj)("circle",60092),debugBreakpointUnverified:(0,n.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Uj)("circle-slash",60093),circuitBoard:(0,n.$Uj)("circuit-board",60094),clearAll:(0,n.$Uj)("clear-all",60095),clippy:(0,n.$Uj)("clippy",60096),closeAll:(0,n.$Uj)("close-all",60097),cloudDownload:(0,n.$Uj)("cloud-download",60098),cloudUpload:(0,n.$Uj)("cloud-upload",60099),code:(0,n.$Uj)("code",60100),collapseAll:(0,n.$Uj)("collapse-all",60101),colorMode:(0,n.$Uj)("color-mode",60102),commentDiscussion:(0,n.$Uj)("comment-discussion",60103),creditCard:(0,n.$Uj)("credit-card",60105),dash:(0,n.$Uj)("dash",60108),dashboard:(0,n.$Uj)("dashboard",60109),database:(0,n.$Uj)("database",60110),debugContinue:(0,n.$Uj)("debug-continue",60111),debugDisconnect:(0,n.$Uj)("debug-disconnect",60112),debugPause:(0,n.$Uj)("debug-pause",60113),debugRestart:(0,n.$Uj)("debug-restart",60114),debugStart:(0,n.$Uj)("debug-start",60115),debugStepInto:(0,n.$Uj)("debug-step-into",60116),debugStepOut:(0,n.$Uj)("debug-step-out",60117),debugStepOver:(0,n.$Uj)("debug-step-over",60118),debugStop:(0,n.$Uj)("debug-stop",60119),debug:(0,n.$Uj)("debug",60120),deviceCameraVideo:(0,n.$Uj)("device-camera-video",60121),deviceCamera:(0,n.$Uj)("device-camera",60122),deviceMobile:(0,n.$Uj)("device-mobile",60123),diffAdded:(0,n.$Uj)("diff-added",60124),diffIgnored:(0,n.$Uj)("diff-ignored",60125),diffModified:(0,n.$Uj)("diff-modified",60126),diffRemoved:(0,n.$Uj)("diff-removed",60127),diffRenamed:(0,n.$Uj)("diff-renamed",60128),diff:(0,n.$Uj)("diff",60129),diffSidebyside:(0,n.$Uj)("diff-sidebyside",60129),discard:(0,n.$Uj)("discard",60130),editorLayout:(0,n.$Uj)("editor-layout",60131),emptyWindow:(0,n.$Uj)("empty-window",60132),exclude:(0,n.$Uj)("exclude",60133),extensions:(0,n.$Uj)("extensions",60134),eyeClosed:(0,n.$Uj)("eye-closed",60135),fileBinary:(0,n.$Uj)("file-binary",60136),fileCode:(0,n.$Uj)("file-code",60137),fileMedia:(0,n.$Uj)("file-media",60138),filePdf:(0,n.$Uj)("file-pdf",60139),fileSubmodule:(0,n.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Uj)("file-symlink-file",60142),fileZip:(0,n.$Uj)("file-zip",60143),files:(0,n.$Uj)("files",60144),filter:(0,n.$Uj)("filter",60145),flame:(0,n.$Uj)("flame",60146),foldDown:(0,n.$Uj)("fold-down",60147),foldUp:(0,n.$Uj)("fold-up",60148),fold:(0,n.$Uj)("fold",60149),folderActive:(0,n.$Uj)("folder-active",60150),folderOpened:(0,n.$Uj)("folder-opened",60151),gear:(0,n.$Uj)("gear",60152),gift:(0,n.$Uj)("gift",60153),gistSecret:(0,n.$Uj)("gist-secret",60154),gist:(0,n.$Uj)("gist",60155),gitCommit:(0,n.$Uj)("git-commit",60156),gitCompare:(0,n.$Uj)("git-compare",60157),compareChanges:(0,n.$Uj)("compare-changes",60157),gitMerge:(0,n.$Uj)("git-merge",60158),githubAction:(0,n.$Uj)("github-action",60159),githubAlt:(0,n.$Uj)("github-alt",60160),globe:(0,n.$Uj)("globe",60161),grabber:(0,n.$Uj)("grabber",60162),graph:(0,n.$Uj)("graph",60163),gripper:(0,n.$Uj)("gripper",60164),heart:(0,n.$Uj)("heart",60165),home:(0,n.$Uj)("home",60166),horizontalRule:(0,n.$Uj)("horizontal-rule",60167),hubot:(0,n.$Uj)("hubot",60168),inbox:(0,n.$Uj)("inbox",60169),issueReopened:(0,n.$Uj)("issue-reopened",60171),issues:(0,n.$Uj)("issues",60172),italic:(0,n.$Uj)("italic",60173),jersey:(0,n.$Uj)("jersey",60174),json:(0,n.$Uj)("json",60175),kebabVertical:(0,n.$Uj)("kebab-vertical",60176),key:(0,n.$Uj)("key",60177),law:(0,n.$Uj)("law",60178),lightbulbAutofix:(0,n.$Uj)("lightbulb-autofix",60179),linkExternal:(0,n.$Uj)("link-external",60180),link:(0,n.$Uj)("link",60181),listOrdered:(0,n.$Uj)("list-ordered",60182),listUnordered:(0,n.$Uj)("list-unordered",60183),liveShare:(0,n.$Uj)("live-share",60184),loading:(0,n.$Uj)("loading",60185),location:(0,n.$Uj)("location",60186),mailRead:(0,n.$Uj)("mail-read",60187),mail:(0,n.$Uj)("mail",60188),markdown:(0,n.$Uj)("markdown",60189),megaphone:(0,n.$Uj)("megaphone",60190),mention:(0,n.$Uj)("mention",60191),milestone:(0,n.$Uj)("milestone",60192),gitPullRequestMilestone:(0,n.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Uj)("mortar-board",60193),move:(0,n.$Uj)("move",60194),multipleWindows:(0,n.$Uj)("multiple-windows",60195),mute:(0,n.$Uj)("mute",60196),noNewline:(0,n.$Uj)("no-newline",60197),note:(0,n.$Uj)("note",60198),octoface:(0,n.$Uj)("octoface",60199),openPreview:(0,n.$Uj)("open-preview",60200),package:(0,n.$Uj)("package",60201),paintcan:(0,n.$Uj)("paintcan",60202),pin:(0,n.$Uj)("pin",60203),play:(0,n.$Uj)("play",60204),run:(0,n.$Uj)("run",60204),plug:(0,n.$Uj)("plug",60205),preserveCase:(0,n.$Uj)("preserve-case",60206),preview:(0,n.$Uj)("preview",60207),project:(0,n.$Uj)("project",60208),pulse:(0,n.$Uj)("pulse",60209),question:(0,n.$Uj)("question",60210),quote:(0,n.$Uj)("quote",60211),radioTower:(0,n.$Uj)("radio-tower",60212),reactions:(0,n.$Uj)("reactions",60213),references:(0,n.$Uj)("references",60214),refresh:(0,n.$Uj)("refresh",60215),regex:(0,n.$Uj)("regex",60216),remoteExplorer:(0,n.$Uj)("remote-explorer",60217),remote:(0,n.$Uj)("remote",60218),remove:(0,n.$Uj)("remove",60219),replaceAll:(0,n.$Uj)("replace-all",60220),replace:(0,n.$Uj)("replace",60221),repoClone:(0,n.$Uj)("repo-clone",60222),repoForcePush:(0,n.$Uj)("repo-force-push",60223),repoPull:(0,n.$Uj)("repo-pull",60224),repoPush:(0,n.$Uj)("repo-push",60225),report:(0,n.$Uj)("report",60226),requestChanges:(0,n.$Uj)("request-changes",60227),rocket:(0,n.$Uj)("rocket",60228),rootFolderOpened:(0,n.$Uj)("root-folder-opened",60229),rootFolder:(0,n.$Uj)("root-folder",60230),rss:(0,n.$Uj)("rss",60231),ruby:(0,n.$Uj)("ruby",60232),saveAll:(0,n.$Uj)("save-all",60233),saveAs:(0,n.$Uj)("save-as",60234),save:(0,n.$Uj)("save",60235),screenFull:(0,n.$Uj)("screen-full",60236),screenNormal:(0,n.$Uj)("screen-normal",60237),searchStop:(0,n.$Uj)("search-stop",60238),server:(0,n.$Uj)("server",60240),settingsGear:(0,n.$Uj)("settings-gear",60241),settings:(0,n.$Uj)("settings",60242),shield:(0,n.$Uj)("shield",60243),smiley:(0,n.$Uj)("smiley",60244),sortPrecedence:(0,n.$Uj)("sort-precedence",60245),splitHorizontal:(0,n.$Uj)("split-horizontal",60246),splitVertical:(0,n.$Uj)("split-vertical",60247),squirrel:(0,n.$Uj)("squirrel",60248),starFull:(0,n.$Uj)("star-full",60249),starHalf:(0,n.$Uj)("star-half",60250),symbolClass:(0,n.$Uj)("symbol-class",60251),symbolColor:(0,n.$Uj)("symbol-color",60252),symbolConstant:(0,n.$Uj)("symbol-constant",60253),symbolEnumMember:(0,n.$Uj)("symbol-enum-member",60254),symbolField:(0,n.$Uj)("symbol-field",60255),symbolFile:(0,n.$Uj)("symbol-file",60256),symbolInterface:(0,n.$Uj)("symbol-interface",60257),symbolKeyword:(0,n.$Uj)("symbol-keyword",60258),symbolMisc:(0,n.$Uj)("symbol-misc",60259),symbolOperator:(0,n.$Uj)("symbol-operator",60260),symbolProperty:(0,n.$Uj)("symbol-property",60261),wrench:(0,n.$Uj)("wrench",60261),wrenchSubaction:(0,n.$Uj)("wrench-subaction",60261),symbolSnippet:(0,n.$Uj)("symbol-snippet",60262),tasklist:(0,n.$Uj)("tasklist",60263),telescope:(0,n.$Uj)("telescope",60264),textSize:(0,n.$Uj)("text-size",60265),threeBars:(0,n.$Uj)("three-bars",60266),thumbsdown:(0,n.$Uj)("thumbsdown",60267),thumbsup:(0,n.$Uj)("thumbsup",60268),tools:(0,n.$Uj)("tools",60269),triangleDown:(0,n.$Uj)("triangle-down",60270),triangleLeft:(0,n.$Uj)("triangle-left",60271),triangleRight:(0,n.$Uj)("triangle-right",60272),triangleUp:(0,n.$Uj)("triangle-up",60273),twitter:(0,n.$Uj)("twitter",60274),unfold:(0,n.$Uj)("unfold",60275),unlock:(0,n.$Uj)("unlock",60276),unmute:(0,n.$Uj)("unmute",60277),unverified:(0,n.$Uj)("unverified",60278),verified:(0,n.$Uj)("verified",60279),versions:(0,n.$Uj)("versions",60280),vmActive:(0,n.$Uj)("vm-active",60281),vmOutline:(0,n.$Uj)("vm-outline",60282),vmRunning:(0,n.$Uj)("vm-running",60283),watch:(0,n.$Uj)("watch",60284),whitespace:(0,n.$Uj)("whitespace",60285),wholeWord:(0,n.$Uj)("whole-word",60286),window:(0,n.$Uj)("window",60287),wordWrap:(0,n.$Uj)("word-wrap",60288),zoomIn:(0,n.$Uj)("zoom-in",60289),zoomOut:(0,n.$Uj)("zoom-out",60290),listFilter:(0,n.$Uj)("list-filter",60291),listFlat:(0,n.$Uj)("list-flat",60292),listSelection:(0,n.$Uj)("list-selection",60293),selection:(0,n.$Uj)("selection",60293),listTree:(0,n.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Uj)("symbol-string",60301),debugReverseContinue:(0,n.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Uj)("debug-step-back",60303),debugRestartFrame:(0,n.$Uj)("debug-restart-frame",60304),debugAlt:(0,n.$Uj)("debug-alt",60305),callIncoming:(0,n.$Uj)("call-incoming",60306),callOutgoing:(0,n.$Uj)("call-outgoing",60307),menu:(0,n.$Uj)("menu",60308),expandAll:(0,n.$Uj)("expand-all",60309),feedback:(0,n.$Uj)("feedback",60310),gitPullRequestReviewer:(0,n.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Uj)("ungroup-by-ref-type",60312),account:(0,n.$Uj)("account",60313),gitPullRequestAssignee:(0,n.$Uj)("git-pull-request-assignee",60313),bellDot:(0,n.$Uj)("bell-dot",60314),debugConsole:(0,n.$Uj)("debug-console",60315),library:(0,n.$Uj)("library",60316),output:(0,n.$Uj)("output",60317),runAll:(0,n.$Uj)("run-all",60318),syncIgnored:(0,n.$Uj)("sync-ignored",60319),pinned:(0,n.$Uj)("pinned",60320),githubInverted:(0,n.$Uj)("github-inverted",60321),serverProcess:(0,n.$Uj)("server-process",60322),serverEnvironment:(0,n.$Uj)("server-environment",60323),pass:(0,n.$Uj)("pass",60324),issueClosed:(0,n.$Uj)("issue-closed",60324),stopCircle:(0,n.$Uj)("stop-circle",60325),playCircle:(0,n.$Uj)("play-circle",60326),record:(0,n.$Uj)("record",60327),debugAltSmall:(0,n.$Uj)("debug-alt-small",60328),vmConnect:(0,n.$Uj)("vm-connect",60329),cloud:(0,n.$Uj)("cloud",60330),merge:(0,n.$Uj)("merge",60331),export:(0,n.$Uj)("export",60332),graphLeft:(0,n.$Uj)("graph-left",60333),magnet:(0,n.$Uj)("magnet",60334),notebook:(0,n.$Uj)("notebook",60335),redo:(0,n.$Uj)("redo",60336),checkAll:(0,n.$Uj)("check-all",60337),pinnedDirty:(0,n.$Uj)("pinned-dirty",60338),passFilled:(0,n.$Uj)("pass-filled",60339),circleLargeFilled:(0,n.$Uj)("circle-large-filled",60340),circleLarge:(0,n.$Uj)("circle-large",60341),circleLargeOutline:(0,n.$Uj)("circle-large-outline",60341),combine:(0,n.$Uj)("combine",60342),gather:(0,n.$Uj)("gather",60342),table:(0,n.$Uj)("table",60343),variableGroup:(0,n.$Uj)("variable-group",60344),typeHierarchy:(0,n.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Uj)("git-pull-request-create",60348),runAbove:(0,n.$Uj)("run-above",60349),runBelow:(0,n.$Uj)("run-below",60350),notebookTemplate:(0,n.$Uj)("notebook-template",60351),debugRerun:(0,n.$Uj)("debug-rerun",60352),workspaceTrusted:(0,n.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Uj)("workspace-unknown",60355),terminalCmd:(0,n.$Uj)("terminal-cmd",60356),terminalDebian:(0,n.$Uj)("terminal-debian",60357),terminalLinux:(0,n.$Uj)("terminal-linux",60358),terminalPowershell:(0,n.$Uj)("terminal-powershell",60359),terminalTmux:(0,n.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Uj)("terminal-ubuntu",60361),terminalBash:(0,n.$Uj)("terminal-bash",60362),arrowSwap:(0,n.$Uj)("arrow-swap",60363),copy:(0,n.$Uj)("copy",60364),personAdd:(0,n.$Uj)("person-add",60365),filterFilled:(0,n.$Uj)("filter-filled",60366),wand:(0,n.$Uj)("wand",60367),debugLineByLine:(0,n.$Uj)("debug-line-by-line",60368),inspect:(0,n.$Uj)("inspect",60369),layers:(0,n.$Uj)("layers",60370),layersDot:(0,n.$Uj)("layers-dot",60371),layersActive:(0,n.$Uj)("layers-active",60372),compass:(0,n.$Uj)("compass",60373),compassDot:(0,n.$Uj)("compass-dot",60374),compassActive:(0,n.$Uj)("compass-active",60375),azure:(0,n.$Uj)("azure",60376),issueDraft:(0,n.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Uj)("git-pull-request-draft",60379),debugAll:(0,n.$Uj)("debug-all",60380),debugCoverage:(0,n.$Uj)("debug-coverage",60381),runErrors:(0,n.$Uj)("run-errors",60382),folderLibrary:(0,n.$Uj)("folder-library",60383),debugContinueSmall:(0,n.$Uj)("debug-continue-small",60384),beakerStop:(0,n.$Uj)("beaker-stop",60385),graphLine:(0,n.$Uj)("graph-line",60386),graphScatter:(0,n.$Uj)("graph-scatter",60387),pieChart:(0,n.$Uj)("pie-chart",60388),bracket:(0,n.$Uj)("bracket",60175),bracketDot:(0,n.$Uj)("bracket-dot",60389),bracketError:(0,n.$Uj)("bracket-error",60390),lockSmall:(0,n.$Uj)("lock-small",60391),azureDevops:(0,n.$Uj)("azure-devops",60392),verifiedFilled:(0,n.$Uj)("verified-filled",60393),newline:(0,n.$Uj)("newline",60394),layout:(0,n.$Uj)("layout",60395),layoutActivitybarLeft:(0,n.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Uj)("layout-panel-right",60401),layoutPanel:(0,n.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Uj)("layout-statusbar",60405),layoutMenubar:(0,n.$Uj)("layout-menubar",60406),layoutCentered:(0,n.$Uj)("layout-centered",60407),target:(0,n.$Uj)("target",60408),indent:(0,n.$Uj)("indent",60409),recordSmall:(0,n.$Uj)("record-small",60410),errorSmall:(0,n.$Uj)("error-small",60411),terminalDecorationError:(0,n.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Uj)("layout-sidebar-left-off",60418),blank:(0,n.$Uj)("blank",60419),heartFilled:(0,n.$Uj)("heart-filled",60420),map:(0,n.$Uj)("map",60421),mapHorizontal:(0,n.$Uj)("map-horizontal",60421),foldHorizontal:(0,n.$Uj)("fold-horizontal",60421),mapFilled:(0,n.$Uj)("map-filled",60422),mapHorizontalFilled:(0,n.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Uj)("circle-small",60423),bellSlash:(0,n.$Uj)("bell-slash",60424),bellSlashDot:(0,n.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Uj)("search-fuzzy",60429),commentDraft:(0,n.$Uj)("comment-draft",60430),send:(0,n.$Uj)("send",60431),sparkle:(0,n.$Uj)("sparkle",60432),insert:(0,n.$Uj)("insert",60433),mic:(0,n.$Uj)("mic",60434),thumbsdownFilled:(0,n.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Uj)("thumbsup-filled",60436),coffee:(0,n.$Uj)("coffee",60437),snake:(0,n.$Uj)("snake",60438),game:(0,n.$Uj)("game",60439),vr:(0,n.$Uj)("vr",60440),chip:(0,n.$Uj)("chip",60441),piano:(0,n.$Uj)("piano",60442),music:(0,n.$Uj)("music",60443),micFilled:(0,n.$Uj)("mic-filled",60444),repoFetch:(0,n.$Uj)("repo-fetch",60445),copilot:(0,n.$Uj)("copilot",60446),lightbulbSparkle:(0,n.$Uj)("lightbulb-sparkle",60447),robot:(0,n.$Uj)("robot",60448),sparkleFilled:(0,n.$Uj)("sparkle-filled",60449),diffSingle:(0,n.$Uj)("diff-single",60450),diffMultiple:(0,n.$Uj)("diff-multiple",60451),surroundWith:(0,n.$Uj)("surround-with",60452),share:(0,n.$Uj)("share",60453),gitStash:(0,n.$Uj)("git-stash",60454),gitStashApply:(0,n.$Uj)("git-stash-apply",60455),gitStashPop:(0,n.$Uj)("git-stash-pop",60456),vscode:(0,n.$Uj)("vscode",60457),vscodeInsiders:(0,n.$Uj)("vscode-insiders",60458),codeOss:(0,n.$Uj)("code-oss",60459),runCoverage:(0,n.$Uj)("run-coverage",60460),runAllCoverage:(0,n.$Uj)("run-all-coverage",60461),coverage:(0,n.$Uj)("coverage",60462),githubProject:(0,n.$Uj)("github-project",60463),mapVertical:(0,n.$Uj)("map-vertical",60464),foldVertical:(0,n.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Uj)("fold-vertical-filled",60465),goToSearch:(0,n.$Uj)("go-to-search",60466),percentage:(0,n.$Uj)("percentage",60467),sortPercentage:(0,n.$Uj)("sort-percentage",60467),attach:(0,n.$Uj)("attach",60468)}}),define(re[75],oe([0,1,105,145]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=void 0,e.$Xj=S;function S(){return Object.values(e.$Zj)}e.$Yj={dialogError:(0,n.$Uj)("dialog-error","error"),dialogWarning:(0,n.$Uj)("dialog-warning","warning"),dialogInfo:(0,n.$Uj)("dialog-info","info"),dialogClose:(0,n.$Uj)("dialog-close","close"),treeItemExpanded:(0,n.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Uj)("tree-item-loading","loading"),menuSelection:(0,n.$Uj)("menu-selection","check"),menuSubmenu:(0,n.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Uj)("toolbar-more","more"),quickInputBack:(0,n.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Uj)("drop-down-button",60084),symbolCustomColor:(0,n.$Uj)("symbol-customcolor",60252),exportIcon:(0,n.$Uj)("export",60332),workspaceUnspecified:(0,n.$Uj)("workspace-unspecified",60355),newLine:(0,n.$Uj)("newline",60394),thumbsDownFilled:(0,n.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Uj)("thumbsup-filled",60436),gitFetch:(0,n.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Uj)("debug-breakpoint-pending",60377)},e.$Zj={...A.$Wj,...e.$Yj}}),define(re[35],oe([0,1,12]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=A,e.$8n=S,e.$9n=j,e.$0n=u,e.$$n=c,e.$_n=d,e.$ao=p,e.$bo=v,e.$co=$,e.$do=f,e.$eo=y,e.$fo=w,e.$go=b;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([E,a])=>{h[E]=a&&typeof a=="object"?A(a):a}),h}function S(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const E=h.shift();Object.freeze(E);for(const a in E)if(R.call(E,a)){const t=E[a];typeof t=="object"&&!Object.isFrozen(t)&&!(0,n.$dg)(t)&&h.push(t)}}return g}const R=Object.prototype.hasOwnProperty;function j(g,h){return k(g,h,new Set)}function k(g,h,E){if((0,n.$jg)(g))return g;const a=h(g);if(typeof a<"u")return a;if(Array.isArray(g)){const t=[];for(const r of g)t.push(k(r,h,E));return t}if((0,n.$cg)(g)){if(E.has(g))throw new Error("Cannot clone recursive data-structure");E.add(g);const t={};for(const r in g)R.call(g,r)&&(t[r]=k(g[r],h,E));return E.delete(g),t}return g}function u(g,h,E=!0){return(0,n.$cg)(g)?((0,n.$cg)(h)&&Object.keys(h).forEach(a=>{a in g?E&&((0,n.$cg)(g[a])&&(0,n.$cg)(h[a])?u(g[a],h[a],E):g[a]=h[a]):g[a]=h[a]}),g):h}function c(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let E,a;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(E=0;E<g.length;E++)if(!c(g[E],h[E]))return!1}else{const t=[];for(a in g)t.push(a);t.sort();const r=[];for(a in h)r.push(a);if(r.sort(),!c(t,r))return!1;for(E=0;E<t.length;E++)if(!c(g[t[E]],h[t[E]]))return!1}return!0}function d(g){const h=new Set;return JSON.stringify(g,(E,a)=>{if((0,n.$cg)(a)||Array.isArray(a)){if(h.has(a))return"[Circular]";h.add(a)}return typeof a=="bigint"?`[BigInt ${a.toString()}]`:a})}function p(g,h){const E=Object.create(null);return!g||!h||Object.keys(h).forEach(t=>{const r=g[t],s=h[t];c(r,s)||(E[t]=s)}),E}function v(g,h){const E=h.toLowerCase(),a=Object.keys(g).find(t=>t.toLowerCase()===E);return a?g[a]:g[h]}function $(g,h){const E=Object.create(null);for(const[a,t]of Object.entries(g))h(a,t)&&(E[a]=t);return E}function f(g){let h=[];for(;Object.prototype!==g;)h=h.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return h}function y(g){const h=[];for(const E of f(g))typeof g[E]=="function"&&h.push(E);return h}function w(g,h){const E=t=>function(){const r=Array.prototype.slice.call(arguments,0);return h(t,r)},a={};for(const t of g)a[t]=E(t);return a}function b(g,h){const E={};for(const[a,t]of Object.entries(g))E[a]=h(t,a);return E}}),define(re[106],oe([0,1,75]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=S;var A;(function(j){function k(u){return u&&typeof u=="object"&&typeof u.id=="string"}j.isThemeColor=k})(A||(e.ThemeColor=A={}));function S(j){return{id:j}}var R;(function(j){j.iconNameSegment="[A-Za-z0-9]+",j.iconNameExpression="[A-Za-z0-9-]+",j.iconModifierExpression="~[A-Za-z]+",j.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${j.iconNameExpression})(${j.iconModifierExpression})?$`);function u(g){const h=k.exec(g.id);if(!h)return u(n.$Zj.error);const[,E,a]=h,t=["codicon","codicon-"+E];return a&&t.push("codicon-modifier-"+a.substring(1)),t}j.asClassNameArray=u;function c(g){return u(g).join(" ")}j.asClassName=c;function d(g){return"."+u(g).join(".")}j.asCSSSelector=d;function p(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||A.isThemeColor(g.color))}j.isThemeIcon=p;const v=new RegExp(`^\\$\\((${j.iconNameExpression}(?:${j.iconModifierExpression})?)\\)$`);function $(g){const h=v.exec(g);if(!h)return;const[,E]=h;return{id:E}}j.fromString=$;function f(g){return{id:g}}j.fromId=f;function y(g,h){let E=g.id;const a=E.lastIndexOf("~");return a!==-1&&(E=E.substring(0,a)),h&&(E=`${E}~${h}`),{id:E}}j.modify=y;function w(g){const h=g.id.lastIndexOf("~");if(h!==-1)return g.id.substring(h+1)}j.getModifier=w;function b(g,h){return g.id===h.id&&g.color?.id===h.color?.id}j.isEqual=b})(R||(e.ThemeIcon=R={}))}),define(re[33],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=A;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(S){return n.test(S)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(k){for(let u=0;u<k.length;u++)k[u]=Math.floor(Math.random()*256);return k};const R=new Uint8Array(16),j=[];for(let k=0;k<256;k++)j.push(k.toString(16).padStart(2,"0"));return function(){S(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let u=0,c="";return c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+="-",c+=j[R[u++]],c+=j[R[u++]],c+="-",c+=j[R[u++]],c+=j[R[u++]],c+="-",c+=j[R[u++]],c+=j[R[u++]],c+="-",c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c}}()}),define(re[146],oe([0,1,87,43,86]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fW=R;async function R(j,k){if(await new Promise((d,p)=>{const v=A.createReadStream(j),$=n.createHash("sha256");v.pipe($);const f=(0,S.$db)((y,w)=>{v.removeAllListeners(),$.removeAllListeners(),y?p(y):d(w)});v.once("error",f),v.once("end",f),$.once("error",f),$.once("data",y=>f(void 0,y.toString("hex")))})!==k)throw new Error("Hash mismatch")}}),define(re[147],oe([0,1,26]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=R;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(j){const k=j.replace(/\-/g,":").toLowerCase();return!A.has(k)}function R(){const j=(0,n.networkInterfaces)();for(const k in j){const u=j[k];if(u){for(const{mac:c}of u)if(S(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(re[107],oe([0,1,88]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=A,e.$1g=R;function A(k,u,c,d=1){let p=!1;return new Promise(v=>{const $=setTimeout(()=>{if(!p)return p=!0,v(0)},c);S(k,u,d,f=>{if(!p)return p=!0,clearTimeout($),v(f)})})}function S(k,u,c,d){if(u===0)return d(0);const p=new n.Socket;p.once("connect",()=>(j(p),S(k+c,u-1,c,d))),p.once("data",()=>{}),p.once("error",v=>(j(p),v.code!=="ECONNREFUSED"?S(k+c,u-1,c,d):d(k))),p.connect(k,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(k,u,c,d="127.0.0.1"){let p=!1,v,$=1;const f=n.createServer({pauseOnConnect:!0});function y(w,b){p||(p=!0,f.removeAllListeners(),f.close(),v&&clearTimeout(v),b(w))}return new Promise(w=>{v=setTimeout(()=>{y(0,w)},c),f.on("listening",()=>{y(k,w)}),f.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&$<u?(k++,$++,f.listen(k,d)):y(0,w)}),f.on("close",()=>{y(0,w)}),f.listen(k,d)})}function j(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(u){console.error(u)}}}),function(){function Q(){function e(){return process.uncHostAllowlist}function n(u){const c=new Set;if(Array.isArray(u))for(const d of u)typeof d=="string"&&c.add(d);return Array.from(c)}function A(){const u=e();return u?Array.from(u):[]}function S(u){if(process.platform!=="win32")return;const c=e();if(c)if(typeof u=="string")c.add(u.toLowerCase());else for(const d of n(u))S(d)}function R(u){if(typeof u!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let d;for(const p of c){if(u.indexOf(p)!==0)continue;const $=u.indexOf("\\",p.length);if($===-1)continue;const f=u.substring(p.length,$);if(f){d=f;break}}return d}function j(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function k(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:S,getUNCHost:R,disableUNCAccessRestrictions:j,isUNCAccessRestrictionsDisabled:k}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Q()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Q():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(re[148],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lW=e.$kW=void 0,e.$kW="vscode:contextmenu",e.$lW="vscode:onCloseContextMenu"}),define(re[149],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sW=void 0;class n{constructor(S,R){this.a=S,this.onMessage=R}send(S){try{this.a.send("vscode:message",S.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$sW=n}),define(re[150],oe([11,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(re[151],oe([0,1,150]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=c,e.$7m=d,e.$8m=p;const A=60,S=A*60,R=S*24,j=R*7,k=R*30,u=R*365;function c(v,$,f,y){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,n.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,n.localize)(1,null);let b;return w<A?(b=w,$?b===1?f?(0,n.localize)(2,null,b):(0,n.localize)(3,null,b):f?(0,n.localize)(4,null,b):(0,n.localize)(5,null,b):b===1?f?(0,n.localize)(6,null,b):(0,n.localize)(7,null,b):f?(0,n.localize)(8,null,b):(0,n.localize)(9,null,b)):w<S?(b=Math.floor(w/A),$?b===1?f?(0,n.localize)(10,null,b):(0,n.localize)(11,null,b):f?(0,n.localize)(12,null,b):(0,n.localize)(13,null,b):b===1?f?(0,n.localize)(14,null,b):(0,n.localize)(15,null,b):f?(0,n.localize)(16,null,b):(0,n.localize)(17,null,b)):w<R?(b=Math.floor(w/S),$?b===1?f?(0,n.localize)(18,null,b):(0,n.localize)(19,null,b):f?(0,n.localize)(20,null,b):(0,n.localize)(21,null,b):b===1?f?(0,n.localize)(22,null,b):(0,n.localize)(23,null,b):f?(0,n.localize)(24,null,b):(0,n.localize)(25,null,b)):w<j?(b=Math.floor(w/R),$?b===1?(0,n.localize)(26,null,b):(0,n.localize)(27,null,b):b===1?(0,n.localize)(28,null,b):(0,n.localize)(29,null,b)):w<k?(b=Math.floor(w/j),$?b===1?f?(0,n.localize)(30,null,b):(0,n.localize)(31,null,b):f?(0,n.localize)(32,null,b):(0,n.localize)(33,null,b):b===1?f?(0,n.localize)(34,null,b):(0,n.localize)(35,null,b):f?(0,n.localize)(36,null,b):(0,n.localize)(37,null,b)):w<u?(b=Math.floor(w/k),$?b===1?f?(0,n.localize)(38,null,b):(0,n.localize)(39,null,b):f?(0,n.localize)(40,null,b):(0,n.localize)(41,null,b):b===1?f?(0,n.localize)(42,null,b):(0,n.localize)(43,null,b):f?(0,n.localize)(44,null,b):(0,n.localize)(45,null,b)):(b=Math.floor(w/u),$?b===1?f?(0,n.localize)(46,null,b):(0,n.localize)(47,null,b):f?(0,n.localize)(48,null,b):(0,n.localize)(49,null,b):b===1?f?(0,n.localize)(50,null,b):(0,n.localize)(51,null,b):f?(0,n.localize)(52,null,b):(0,n.localize)(53,null,b))}function d(v,$){const f=Math.abs(v/1e3);return f<1?$?(0,n.localize)(54,null,v):(0,n.localize)(55,null,v):f<A?$?(0,n.localize)(56,null,Math.round(v)/1e3):(0,n.localize)(57,null,Math.round(v)/1e3):f<S?$?(0,n.localize)(58,null,Math.round(v/(1e3*A))):(0,n.localize)(59,null,Math.round(v/(1e3*A))):f<R?$?(0,n.localize)(60,null,Math.round(v/(1e3*S))):(0,n.localize)(61,null,Math.round(v/(1e3*S))):(0,n.localize)(62,null,Math.round(v/(1e3*R)))}function p(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(re[152],oe([11,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(re[47],oe([0,1,22,12,152]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=u,e.$mj=c,e.$nj=d;function R(p,v){return v&&(p.stack||p.stacktrace)?S.localize(0,null,k(p),j(p.stack)||j(p.stacktrace)):k(p)}function j(p){return Array.isArray(p)?p.join(`
`):p}function k(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?S.localize(1,null,p.message):p.message||S.localize(2,null)}function u(p=null,v=!1){if(!p)return S.localize(3,null);if(Array.isArray(p)){const $=n.$Hb(p),f=u($[0],v);return $.length>1?S.localize(4,null,f,$.length):f}if(A.$ag(p))return p;if(p.detail){const $=p.detail;if($.error)return R($.error,v);if($.exception)return R($.exception,v)}return p.stack?R(p,v):p.message?p.message:S.localize(5,null)}function c(p){const v=p;return v instanceof Error&&Array.isArray(v.actions)}function d(p,v){let $;return typeof p=="string"?$=new Error(p):$=p,$.actions=v,$}}),define(re[153],oe([11,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(re[154],oe([0,1,153]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=A;function A(S){switch(S){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(re[155],oe([11,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,155]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=P,e.$J=D,e.$g="en";let A=!1,S=!1,R=!1,j=!1,k=!1,u=!1,c=!1,d=!1,p=!1,v=!1,$,f=e.$g,y=e.$g,w,b;const g=globalThis;let h;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?h=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(h=process);const E=typeof h?.versions?.electron=="string",a=E&&h?.type==="renderer";if(typeof h=="object"){A=h.platform==="win32",S=h.platform==="darwin",R=h.platform==="linux",j=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,c=E,p=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,f=e.$g;const I=h.env.VSCODE_NLS_CONFIG;if(I)try{const O=JSON.parse(I),M=O.availableLanguages["*"];$=O.locale,y=O.osLocale,f=M||e.$g,w=O._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!a?(b=navigator.userAgent,A=b.indexOf("Windows")>=0,S=b.indexOf("Macintosh")>=0,d=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=b.indexOf("Linux")>=0,v=b?.indexOf("Mobi")>=0,u=!0,$=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,f=$,y=navigator.language):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;S?s=1:A?s=3:R&&(s=2),e.$i=A,e.$j=S,e.$k=R,e.$l=j,e.$m=k,e.$n=c,e.$o=u,e.$p=u&&typeof g.importScripts=="function",e.$q=e.$p?g.origin:void 0,e.$r=d,e.$s=v,e.$t=p,e.$u=s,e.$v=b,e.$w=f;var i;(function(I){function O(){return e.$w}I.value=O;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=M;function W(){return e.$w==="en"}I.isDefault=W})(i||(e.Language=i={})),e.$x=$,e.$y=y,e.$z=w,e.$A=typeof g.postMessage=="function"&&!g.importScripts,e.$B=(()=>{if(e.$A){const I=[];g.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let W=0,N=I.length;W<N;W++){const T=I[W];if(T.id===M.data.vscodeScheduleAsyncWork){I.splice(W,1),T.callback();return}}});let O=0;return M=>{const W=++O;I.push({id:W,callback:M}),g.postMessage({vscodeScheduleAsyncWork:W},"*")}}return I=>setTimeout(I)})();var o;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=S||d?2:A?1:3;let l=!0,m=!1;function P(){if(!m){m=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,l=new Uint16Array(I.buffer)[0]===513}return l}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function D(I){return parseFloat(I)>=20}}),define(re[36],oe([0,1,4]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let A;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const R=S.process;A={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$dc=A.platform,e.$ec=A.arch}),define(re[9],oe([0,1,36]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const A=65,S=97,R=90,j=122,k=46,u=47,c=92,d=58,p=63;class v extends Error{constructor(r,s,i){let o;typeof s=="string"&&s.indexOf("not ")===0?(o="must not be",s=s.replace(/^not /,"")):o="must be";const l=r.indexOf(".")!==-1?"property":"argument";let m=`The "${r}" ${l} ${o} of type ${s}`;m+=`. Received type ${typeof i}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function $(t,r){if(t===null||typeof t!="object")throw new v(r,"Object",t)}function f(t,r){if(typeof t!="string")throw new v(r,"string",t)}const y=n.$dc==="win32";function w(t){return t===u||t===c}function b(t){return t===u}function g(t){return t>=A&&t<=R||t>=S&&t<=j}function h(t,r,s,i){let o="",l=0,m=-1,P=0,D=0;for(let I=0;I<=t.length;++I){if(I<t.length)D=t.charCodeAt(I);else{if(i(D))break;D=u}if(i(D)){if(!(m===I-1||P===1))if(P===2){if(o.length<2||l!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const O=o.lastIndexOf(s);O===-1?(o="",l=0):(o=o.slice(0,O),l=o.length-1-o.lastIndexOf(s)),m=I,P=0;continue}else if(o.length!==0){o="",l=0,m=I,P=0;continue}}r&&(o+=o.length>0?`${s}..`:"..",l=2)}else o.length>0?o+=`${s}${t.slice(m+1,I)}`:o=t.slice(m+1,I),l=I-m-1;m=I,P=0}else D===k&&P!==-1?++P:P=-1}return o}function E(t,r){$(r,"pathObject");const s=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${i}`:`${s}${t}${i}`:i}e.$fc={resolve(...t){let r="",s="",i=!1;for(let o=t.length-1;o>=-1;o--){let l;if(o>=0){if(l=t[o],f(l,"path"),l.length===0)continue}else r.length===0?l=n.cwd():(l=n.env[`=${r}`]||n.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==r.toLowerCase()&&l.charCodeAt(2)===c)&&(l=`${r}\\`));const m=l.length;let P=0,D="",I=!1;const O=l.charCodeAt(0);if(m===1)w(O)&&(P=1,I=!0);else if(w(O))if(I=!0,w(l.charCodeAt(1))){let M=2,W=M;for(;M<m&&!w(l.charCodeAt(M));)M++;if(M<m&&M!==W){const N=l.slice(W,M);for(W=M;M<m&&w(l.charCodeAt(M));)M++;if(M<m&&M!==W){for(W=M;M<m&&!w(l.charCodeAt(M));)M++;(M===m||M!==W)&&(D=`\\\\${N}\\${l.slice(W,M)}`,P=M)}}}else P=1;else g(O)&&l.charCodeAt(1)===d&&(D=l.slice(0,2),P=2,m>2&&w(l.charCodeAt(2))&&(I=!0,P=3));if(D.length>0)if(r.length>0){if(D.toLowerCase()!==r.toLowerCase())continue}else r=D;if(i){if(r.length>0)break}else if(s=`${l.slice(P)}\\${s}`,i=I,I&&r.length>0)break}return s=h(s,!i,"\\",w),i?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){f(t,"path");const r=t.length;if(r===0)return".";let s=0,i,o=!1;const l=t.charCodeAt(0);if(r===1)return b(l)?"\\":t;if(w(l))if(o=!0,w(t.charCodeAt(1))){let P=2,D=P;for(;P<r&&!w(t.charCodeAt(P));)P++;if(P<r&&P!==D){const I=t.slice(D,P);for(D=P;P<r&&w(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&!w(t.charCodeAt(P));)P++;if(P===r)return`\\\\${I}\\${t.slice(D)}\\`;P!==D&&(i=`\\\\${I}\\${t.slice(D,P)}`,s=P)}}}else s=1;else g(l)&&t.charCodeAt(1)===d&&(i=t.slice(0,2),s=2,r>2&&w(t.charCodeAt(2))&&(o=!0,s=3));let m=s<r?h(t.slice(s),!o,"\\",w):"";return m.length===0&&!o&&(m="."),m.length>0&&w(t.charCodeAt(r-1))&&(m+="\\"),i===void 0?o?`\\${m}`:m:o?`${i}\\${m}`:`${i}${m}`},isAbsolute(t){f(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return w(s)||r>2&&g(s)&&t.charCodeAt(1)===d&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let l=0;l<t.length;++l){const m=t[l];f(m,"path"),m.length>0&&(r===void 0?r=s=m:r+=`\\${m}`)}if(r===void 0)return".";let i=!0,o=0;if(typeof s=="string"&&w(s.charCodeAt(0))){++o;const l=s.length;l>1&&w(s.charCodeAt(1))&&(++o,l>2&&(w(s.charCodeAt(2))?++o:i=!1))}if(i){for(;o<r.length&&w(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.$fc.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r)return"";const s=e.$fc.resolve(t),i=e.$fc.resolve(r);if(s===i||(t=s.toLowerCase(),r=i.toLowerCase(),t===r))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===c;)o++;let l=t.length;for(;l-1>o&&t.charCodeAt(l-1)===c;)l--;const m=l-o;let P=0;for(;P<r.length&&r.charCodeAt(P)===c;)P++;let D=r.length;for(;D-1>P&&r.charCodeAt(D-1)===c;)D--;const I=D-P,O=m<I?m:I;let M=-1,W=0;for(;W<O;W++){const T=t.charCodeAt(o+W);if(T!==r.charCodeAt(P+W))break;T===c&&(M=W)}if(W!==O){if(M===-1)return i}else{if(I>O){if(r.charCodeAt(P+W)===c)return i.slice(P+W+1);if(W===2)return i.slice(P+W)}m>O&&(t.charCodeAt(o+W)===c?M=W:W===2&&(M=3)),M===-1&&(M=0)}let N="";for(W=o+M+1;W<=l;++W)(W===l||t.charCodeAt(W)===c)&&(N+=N.length===0?"..":"\\..");return P+=M,N.length>0?`${N}${i.slice(P,D)}`:(i.charCodeAt(P)===c&&++P,i.slice(P,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===c){if(r.charCodeAt(1)===c){const s=r.charCodeAt(2);if(s!==p&&s!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===d&&r.charCodeAt(2)===c)return`\\\\?\\${r}`;return t},dirname(t){f(t,"path");const r=t.length;if(r===0)return".";let s=-1,i=0;const o=t.charCodeAt(0);if(r===1)return w(o)?t:".";if(w(o)){if(s=i=1,w(t.charCodeAt(1))){let P=2,D=P;for(;P<r&&!w(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&w(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&!w(t.charCodeAt(P));)P++;if(P===r)return t;P!==D&&(s=i=P+1)}}}}else g(o)&&t.charCodeAt(1)===d&&(s=r>2&&w(t.charCodeAt(2))?3:2,i=s);let l=-1,m=!0;for(let P=r-1;P>=i;--P)if(w(t.charCodeAt(P))){if(!m){l=P;break}}else m=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let s=0,i=-1,o=!0,l;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===d&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let m=r.length-1,P=-1;for(l=t.length-1;l>=s;--l){const D=t.charCodeAt(l);if(w(D)){if(!o){s=l+1;break}}else P===-1&&(o=!1,P=l+1),m>=0&&(D===r.charCodeAt(m)?--m===-1&&(i=l):(m=-1,i=P))}return s===i?i=P:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=s;--l)if(w(t.charCodeAt(l))){if(!o){s=l+1;break}}else i===-1&&(o=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){f(t,"path");let r=0,s=-1,i=0,o=-1,l=!0,m=0;t.length>=2&&t.charCodeAt(1)===d&&g(t.charCodeAt(0))&&(r=i=2);for(let P=t.length-1;P>=r;--P){const D=t.charCodeAt(P);if(w(D)){if(!l){i=P+1;break}continue}o===-1&&(l=!1,o=P+1),D===k?s===-1?s=P:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||o===-1||m===0||m===1&&s===o-1&&s===i+1?"":t.slice(s,o)},format:E.bind(null,"\\"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let i=0,o=t.charCodeAt(0);if(s===1)return w(o)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(w(o)){if(i=1,w(t.charCodeAt(1))){let M=2,W=M;for(;M<s&&!w(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&w(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&!w(t.charCodeAt(M));)M++;M===s?i=M:M!==W&&(i=M+1)}}}}else if(g(o)&&t.charCodeAt(1)===d){if(s<=2)return r.root=r.dir=t,r;if(i=2,w(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let l=-1,m=i,P=-1,D=!0,I=t.length-1,O=0;for(;I>=i;--I){if(o=t.charCodeAt(I),w(o)){if(!D){m=I+1;break}continue}P===-1&&(D=!1,P=I+1),o===k?l===-1?l=I:O!==1&&(O=1):l!==-1&&(O=-1)}return P!==-1&&(l===-1||O===0||O===1&&l===P-1&&l===m+1?r.base=r.name=t.slice(m,P):(r.name=t.slice(m,l),r.base=t.slice(m,P),r.ext=t.slice(l,P))),m>0&&m!==i?r.dir=t.slice(0,m-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(y){const t=/\\/g;return()=>{const r=n.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...t){let r="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const o=i>=0?t[i]:a();f(o,"path"),o.length!==0&&(r=`${o}/${r}`,s=o.charCodeAt(0)===u)}return r=h(r,!s,"/",b),s?`/${r}`:r.length>0?r:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===u,s=t.charCodeAt(t.length-1)===u;return t=h(t,!r,"/",b),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===u},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const i=t[s];f(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const s=1,i=t.length,o=i-s,l=1,m=r.length-l,P=o<m?o:m;let D=-1,I=0;for(;I<P;I++){const M=t.charCodeAt(s+I);if(M!==r.charCodeAt(l+I))break;M===u&&(D=I)}if(I===P)if(m>P){if(r.charCodeAt(l+I)===u)return r.slice(l+I+1);if(I===0)return r.slice(l+I)}else o>P&&(t.charCodeAt(s+I)===u?D=I:I===0&&(D=0));let O="";for(I=s+D+1;I<=i;++I)(I===i||t.charCodeAt(I)===u)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(l+D)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===u;let s=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===u){if(!i){s=o;break}}else i=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let s=0,i=-1,o=!0,l;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let m=r.length-1,P=-1;for(l=t.length-1;l>=0;--l){const D=t.charCodeAt(l);if(D===u){if(!o){s=l+1;break}}else P===-1&&(o=!1,P=l+1),m>=0&&(D===r.charCodeAt(m)?--m===-1&&(i=l):(m=-1,i=P))}return s===i?i=P:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===u){if(!o){s=l+1;break}}else i===-1&&(o=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){f(t,"path");let r=-1,s=0,i=-1,o=!0,l=0;for(let m=t.length-1;m>=0;--m){const P=t.charCodeAt(m);if(P===u){if(!o){s=m+1;break}continue}i===-1&&(o=!1,i=m+1),P===k?r===-1?r=m:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||i===-1||l===0||l===1&&r===i-1&&r===s+1?"":t.slice(r,i)},format:E.bind(null,"/"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===u;let i;s?(r.root="/",i=1):i=0;let o=-1,l=0,m=-1,P=!0,D=t.length-1,I=0;for(;D>=i;--D){const O=t.charCodeAt(D);if(O===u){if(!P){l=D+1;break}continue}m===-1&&(P=!1,m=D+1),O===k?o===-1?o=D:I!==1&&(I=1):o!==-1&&(I=-1)}if(m!==-1){const O=l===0&&s?1:l;o===-1||I===0||I===1&&o===m-1&&o===l+1?r.base=r.name=t.slice(O,m):(r.name=t.slice(O,o),r.base=t.slice(O,m),r.ext=t.slice(o,m))}return l>0?r.dir=t.slice(0,l-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=y?e.$fc.normalize:e.$gc.normalize,e.$ic=y?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=y?e.$fc.join:e.$gc.join,e.$kc=y?e.$fc.resolve:e.$gc.resolve,e.$lc=y?e.$fc.relative:e.$gc.relative,e.$mc=y?e.$fc.dirname:e.$gc.dirname,e.$nc=y?e.$fc.basename:e.$gc.basename,e.$oc=y?e.$fc.extname:e.$gc.extname,e.$pc=y?e.$fc.format:e.$gc.format,e.$qc=y?e.$fc.parse:e.$gc.parse,e.$rc=y?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=y?e.$fc.sep:e.$gc.sep,e.$tc=y?e.$fc.delimiter:e.$gc.delimiter}),define(re[31],oe([0,1,9,4,25,12]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=j,e.$tg=k,e.$ug=u,e.$vg=c,e.$wg=d,e.$xg=f,e.$yg=y,e.$zg=w,e.$Ag=b,e.$Bg=g,e.$Cg=h,e.$Dg=E,e.$Eg=a,e.$Fg=t,e.$Gg=r,e.$Hg=s,e.$Ig=l;function j(m){return m===47||m===92}function k(m){return m.replace(/[\\/]/g,n.$gc.sep)}function u(m){return m.indexOf("/")===-1&&(m=k(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}function c(m,P=n.$gc.sep){if(!m)return"";const D=m.length,I=m.charCodeAt(0);if(j(I)){if(j(m.charCodeAt(1))&&!j(m.charCodeAt(2))){let M=3;const W=M;for(;M<D&&!j(m.charCodeAt(M));M++);if(W!==M&&!j(m.charCodeAt(M+1))){for(M+=1;M<D;M++)if(j(m.charCodeAt(M)))return m.slice(0,M+1).replace(/[\\/]/g,P)}}return P}else if(b(I)&&m.charCodeAt(1)===58)return j(m.charCodeAt(2))?m.slice(0,2)+P:m.slice(0,2);let O=m.indexOf("://");if(O!==-1){for(O+=3;O<D;O++)if(j(m.charCodeAt(O)))return m.slice(0,O+1)}return""}function d(m){if(!A.$i||!m||m.length<5)return!1;let P=m.charCodeAt(0);if(P!==92||(P=m.charCodeAt(1),P!==92))return!1;let D=2;const I=D;for(;D<m.length&&(P=m.charCodeAt(D),P!==92);D++);return!(I===D||(P=m.charCodeAt(D+1),isNaN(P)||P===92))}const p=/[\\/:\*\?"<>\|]/g,v=/[/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(m,P=A.$i){const D=P?p:v;return!(!m||m.length===0||/^\s+$/.test(m)||(D.lastIndex=0,D.test(m))||P&&$.test(m)||m==="."||m===".."||P&&m[m.length-1]==="."||P&&m.length!==m.trim().length||m.length>255)}function y(m,P,D){const I=m===P;return!D||I?I:!m||!P?!1:(0,S.$Bf)(m,P)}function w(m,P,D,I=n.sep){if(m===P)return!0;if(!m||!P||P.length>m.length)return!1;if(D){if(!(0,S.$Cf)(m,P))return!1;if(P.length===m.length)return!0;let M=P.length;return P.charAt(P.length-1)===I&&M--,m.charAt(M)===I}return P.charAt(P.length-1)!==I&&(P+=I),m.indexOf(P)===0}function b(m){return m>=65&&m<=90||m>=97&&m<=122}function g(m,P){return A.$i&&m.endsWith(":")&&(m+=n.sep),(0,n.$ic)(m)||(m=(0,n.$jc)(P,m)),m=(0,n.$hc)(m),h(m)}function h(m){return A.$i?(m=(0,S.$jf)(m,n.sep),m.endsWith(":")&&(m+=n.sep)):(m=(0,S.$jf)(m,n.sep),m||(m=n.sep)),m}function E(m){const P=(0,n.$hc)(m);return A.$i?m.length>3?!1:a(P)&&(m.length===2||P.charCodeAt(2)===92):P===n.$gc.sep}function a(m,P=A.$i){return P?b(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}function t(m,P=A.$i){return a(m,P)?m[0]:void 0}function r(m,P,D){return P.length>m.length?-1:m===P?0:(D&&(m=m.toLowerCase(),P=P.toLowerCase()),m.indexOf(P))}function s(m){const P=m.split(":");let D,I,O;for(const M of P){const W=Number(M);(0,R.$eg)(W)?I===void 0?I=W:O===void 0&&(O=W):D=D?[D,M].join(":"):M}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:O!==void 0?O:I!==void 0?1:void 0}}const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(m,P,D=8){let I="";for(let M=0;M<D;M++){let W;M===0&&A.$i&&!P&&(D===3||D===4)?W=o:W=i,I+=W.charAt(Math.floor(Math.random()*W.length))}let O;return P?O=`${P}-${I}`:O=I,m?(0,n.$jc)(m,O):O}}),define(re[76],oe([0,1,4]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=R,e.$rm=j;var A;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(A||(e.Source=A={}));var S;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function R(k,...u){const c=u.reduce((v,$)=>(v[$]=!0,v),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(v=>!c[v]).forEach(v=>{for(let $=0;$<d.length;$++)if(v.search(d[$])!==-1){delete k[v];break}})}function j(k){k&&(delete k.DEBUG,n.$j&&delete k.DYLD_LIBRARY_PATH,n.$k&&delete k.LD_PRELOAD)}}),define(re[7],oe([0,1,9,4]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=f,e.$wc=E;const S=/^\w[\w\d+.-]*$/,R=/^\//,j=/^\/\//;function k(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!S.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(i,o){return!i&&!o?"file":i}function c(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==p&&(o=p+o):o=p;break}return o}const d="",p="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class ${static isUri(o){return o instanceof $?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,l,m,P,D,I=!1){typeof o=="object"?(this.scheme=o.scheme||d,this.authority=o.authority||d,this.path=o.path||d,this.query=o.query||d,this.fragment=o.fragment||d):(this.scheme=u(o,I),this.authority=l||d,this.path=c(this.scheme,m||d),this.query=P||d,this.fragment=D||d,k(this,I))}get fsPath(){return E(this,!1)}with(o){if(!o)return this;let{scheme:l,authority:m,path:P,query:D,fragment:I}=o;return l===void 0?l=this.scheme:l===null&&(l=d),m===void 0?m=this.authority:m===null&&(m=d),P===void 0?P=this.path:P===null&&(P=d),D===void 0?D=this.query:D===null&&(D=d),I===void 0?I=this.fragment:I===null&&(I=d),l===this.scheme&&m===this.authority&&P===this.path&&D===this.query&&I===this.fragment?this:new w(l,m,P,D,I)}static parse(o,l=!1){const m=v.exec(o);return m?new w(m[2]||d,s(m[4]||d),s(m[5]||d),s(m[7]||d),s(m[9]||d),l):new w(d,d,d,d,d)}static file(o){let l=d;if(A.$i&&(o=o.replace(/\\/g,p)),o[0]===p&&o[1]===p){const m=o.indexOf(p,2);m===-1?(l=o.substring(2),o=p):(l=o.substring(2,m),o=o.substring(m)||p)}return new w("file",l,o,d,d)}static from(o,l){return new w(o.scheme,o.authority,o.path,o.query,o.fragment,l)}static joinPath(o,...l){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return A.$i&&o.scheme==="file"?m=$.file(n.$fc.join(E(o,!0),...l)).path:m=n.$gc.join(o.path,...l),o.with({path:m})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof $)return o;{const l=new w(o);return l._formatted=o.external??null,l._fsPath=o._sep===y?o.fsPath??null:null,l}}else return o}}e.URI=$;function f(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const y=A.$i?1:void 0;class w extends ${constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=y),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const b={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function g(i,o,l){let m,P=-1;for(let D=0;D<i.length;D++){const I=i.charCodeAt(D);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||o&&I===47||l&&I===91||l&&I===93||l&&I===58)P!==-1&&(m+=encodeURIComponent(i.substring(P,D)),P=-1),m!==void 0&&(m+=i.charAt(D));else{m===void 0&&(m=i.substr(0,D));const O=b[I];O!==void 0?(P!==-1&&(m+=encodeURIComponent(i.substring(P,D)),P=-1),m+=O):P===-1&&(P=D)}}return P!==-1&&(m+=encodeURIComponent(i.substring(P))),m!==void 0?m:i}function h(i){let o;for(let l=0;l<i.length;l++){const m=i.charCodeAt(l);m===35||m===63?(o===void 0&&(o=i.substr(0,l)),o+=b[m]):o!==void 0&&(o+=i[l])}return o!==void 0?o:i}function E(i,o){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,A.$i&&(l=l.replace(/\//g,"\\")),l}function a(i,o){const l=o?h:g;let m="",{scheme:P,authority:D,path:I,query:O,fragment:M}=i;if(P&&(m+=P,m+=":"),(D||P==="file")&&(m+=p,m+=p),D){let W=D.indexOf("@");if(W!==-1){const N=D.substr(0,W);D=D.substr(W+1),W=N.lastIndexOf(":"),W===-1?m+=l(N,!1,!1):(m+=l(N.substr(0,W),!1,!1),m+=":",m+=l(N.substr(W+1),!1,!0)),m+="@"}D=D.toLowerCase(),W=D.lastIndexOf(":"),W===-1?m+=l(D,!1,!0):(m+=l(D.substr(0,W),!1,!0),m+=D.substr(W))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const W=I.charCodeAt(1);W>=65&&W<=90&&(I=`/${String.fromCharCode(W+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const W=I.charCodeAt(0);W>=65&&W<=90&&(I=`${String.fromCharCode(W+32)}:${I.substr(2)}`)}m+=l(I,!0,!1)}return O&&(m+="?",m+=l(O,!1,!1)),M&&(m+="#",m+=o?M:g(M,!1,!1)),m}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(r)?i.replace(r,o=>t(o)):i}}),define(re[156],oe([0,1,7]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=A,e.$3q=S,e.$4q=R,e.log=k;function A(c){const d=c;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function S(c){const d=[];let p;try{const v=JSON.parse(c.arguments),$=v[v.length-1];$&&$.__$stack&&(v.pop(),p=$.__$stack),d.push(...v)}catch{d.push("Unable to log remote console arguments",c.arguments)}return{args:d,stack:p}}function R(c){if(typeof c!="string")return R(S(c).stack);const d=c;if(d){const p=j(d),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(v&&v.length===4)return{uri:n.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function j(c){if(!c)return c;const d=c.indexOf(`
`);return d===-1?c:c.substring(0,d)}function k(c,d){const{args:p,stack:v}=S(c),$=typeof p[0]=="string"&&p.length===1;let f=j(v);f&&(f=`(${f.trim()})`);let y=[];if(typeof p[0]=="string"?f&&$?y=[`%c[${d}] %c${p[0]} %c${f}`,u("blue"),u(""),u("grey")]:y=[`%c[${d}] %c${p[0]}`,u("blue"),u(""),...p.slice(1)]:y=[`%c[${d}]%`,u("blue"),...p],f&&!$&&y.push(f),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}function u(c){return`color: ${c}`}}),define(re[77],oe([0,1,17,7]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=S,e.$9h=R,e.$0h=k;function S(u){return JSON.stringify(u,j)}function R(u){let c=JSON.parse(u);return c=k(c),c}function j(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function k(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return A.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof n.$Je||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let d=0;d<u.length;++d)u[d]=k(u[d],c+1);else for(const d in u)Object.hasOwnProperty.call(u,d)&&(u[d]=k(u[d],c+1))}return u}}),define(re[13],oe([0,1,15,4,25,7,9]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=u,e.$Kg=c,e.$Og=p;var k;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(k||(e.Schemas=k={}));function u(f,y){return R.URI.isUri(f)?(0,S.$Bf)(f.scheme,y):(0,S.$Cf)(f,y+":")}function c(f,...y){return y.some(w=>u(f,w))}e.$Lg="vscode-tkn",e.$Mg="tkn";class d{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y,w){this.f=p(y,w)}getServerRootPath(){return this.f}get g(){return j.$gc.join(this.f,k.vscodeRemoteResource)}set(y,w,b){this.a[y]=w,this.b[y]=b}setConnectionToken(y,w){this.c[y]=w}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)try{return this.e(y)}catch(a){return n.$1(a),y}const w=y.authority;let b=this.a[w];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const g=this.b[w],h=this.c[w];let E=`path=${encodeURIComponent(y.path)}`;return typeof h=="string"&&(E+=`&${e.$Mg}=${encodeURIComponent(h)}`),R.URI.from({scheme:A.$o?this.d:k.vscodeRemoteResource,authority:`${b}:${g}`,path:this.g,query:E})}}e.$Ng=new d;function p(f,y){return j.$gc.join(y??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class v{static{this.a=e.$Tg}asBrowserUri(y){const w=this.b(y,Q);return this.uriToBrowserUri(w)}uriToBrowserUri(y){return y.scheme===k.vscodeRemote?e.$Ng.rewrite(y):y.scheme===k.file&&(A.$m||A.$q===`${k.vscodeFileResource}://${v.a}`)?y.with({scheme:k.vscodeFileResource,authority:y.authority||v.a,query:null,fragment:null}):y}asFileUri(y){const w=this.b(y,Q);return this.uriToFileUri(w)}uriToFileUri(y){return y.scheme===k.vscodeFileResource?y.with({scheme:k.file,authority:y.authority!==v.a?y.authority:null,query:null,fragment:null}):y}b(y,w){return R.URI.isUri(y)?y:R.URI.parse(w.toUrl(y))}}e.$Ug=new v;var $;(function(f){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(y.get("3"));const w="vscode-coi";function b(h){let E;typeof h=="string"?E=new URL(h).searchParams:h instanceof URL?E=h.searchParams:R.URI.isUri(h)&&(E=new URL(h.toString(!0)).searchParams);const a=E?.get(w);if(a)return y.get(a)}f.getHeadersFromQuery=b;function g(h,E,a){if(!globalThis.crossOriginIsolated)return;const t=E&&a?"3":a?"2":"1";h instanceof URLSearchParams?h.set(w,t):h[w]=t}f.addSearchParam=g})($||(e.COI=$={}))}),define(re[19],oe([0,1,31,13,9,4,25,7]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=u,e.$kh=d,e.$lh=v;function u($){return(0,k.$wc)($,!0)}class c{constructor(f){this.a=f}compare(f,y,w=!1){return f===y?0:(0,j.$uf)(this.getComparisonKey(f,w),this.getComparisonKey(y,w))}isEqual(f,y,w=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,w)===this.getComparisonKey(y,w)}getComparisonKey(f,y=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,y,w=!1){if(f.scheme===y.scheme){if(f.scheme===A.Schemas.file)return n.$zg(u(f),u(y),this.a(f))&&f.query===y.query&&(w||f.fragment===y.fragment);if((0,e.$gh)(f.authority,y.authority))return n.$zg(f.path,y.path,this.a(f),"/")&&f.query===y.query&&(w||f.fragment===y.fragment)}return!1}joinPath(f,...y){return k.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.$$g)(f)||f.authority}basename(f){return S.$gc.basename(f.path)}extname(f){return S.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===A.Schemas.file?y=k.URI.file(S.$mc(u(f))).path:(y=S.$gc.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===A.Schemas.file?y=k.URI.file(S.$hc(u(f))).path:y=S.$gc.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.$gh)(f.authority,y.authority))return;if(f.scheme===A.Schemas.file){const g=S.$lc(u(f),u(y));return R.$i?n.$tg(g):g}let w=f.path||"/";const b=y.path||"/";if(this.a(f)){let g=0;for(const h=Math.min(w.length,b.length);g<h&&!(w.charCodeAt(g)!==b.charCodeAt(g)&&w.charAt(g).toLowerCase()!==b.charAt(g).toLowerCase());g++);w=b.substr(0,g)+w.substr(g)}return S.$gc.relative(w,b)}resolvePath(f,y){if(f.scheme===A.Schemas.file){const w=k.URI.file(S.$kc(u(f),y));return f.with({authority:w.authority,path:w.path})}return y=n.$ug(y),f.with({path:S.$gc.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,j.$Bf)(f,y)}hasTrailingPathSeparator(f,y=S.sep){if(f.scheme===A.Schemas.file){const w=u(f);return w.length>n.$vg(w).length&&w[w.length-1]===y}else{const w=f.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=S.sep){return(0,e.$hh)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=S.sep){let w=!1;if(f.scheme===A.Schemas.file){const b=u(f);w=b!==void 0&&b.length===n.$vg(b).length&&b[b.length-1]===y}else{y="/";const b=f.path;w=b.length===1&&b.charCodeAt(b.length-1)===47}return!w&&!(0,e.$hh)(f,y)?f.with({path:f.path+"/"}):f}}e.$3g=c,e.$4g=new c(()=>!1),e.$5g=new c($=>$.scheme===A.Schemas.file?!R.$k:!0),e.$6g=new c($=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function d($,f){const y=[];for(let w=0;w<$.length;w++){const b=f($[w]);$.some((g,h)=>h===w?!1:(0,e.$8g)(b,f(g)))||y.push($[w])}return y}var p;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function f(y){const w=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(h=>{const[E,a]=h.split(":");E&&a&&w.set(E,a)});const g=y.path.substring(0,y.path.indexOf(";"));return g&&w.set($.META_DATA_MIME,g),w}$.parseMetaData=f})(p||(e.DataUri=p={}));function v($,f,y){if(f){let w=$.path;return w&&w[0]!==S.$gc.sep&&(w=S.$gc.sep+w),$.with({scheme:y,authority:f,path:w})}return $.with({scheme:y})}}),define(re[8],oe([0,1,23,15,3,2,19,4,144,62]),function(Q,e,n,A,S,R,j,k,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=d,e.$nh=p,e.$oh=v,e.$ph=$,e.$qh=f,e.$rh=y,e.$sh=w,e.$th=b,e.$Bh=l,e.$Ch=m,e.$Dh=P,e.$Eh=D,e.$Fh=I,e.$Uh=L,e.$3h=Z;function d(ee){return!!ee&&typeof ee.then=="function"}function p(ee){const G=new n.$se,ue=ee(G.token),fe=new Promise((we,Ee)=>{const Oe=G.token.onCancellationRequested(()=>{Oe.dispose(),Ee(new A.$5)});Promise.resolve(ue).then(ye=>{Oe.dispose(),G.dispose(),we(ye)},ye=>{Oe.dispose(),G.dispose(),Ee(ye)})});return new class{cancel(){G.cancel(),G.dispose()}then(we,Ee){return fe.then(we,Ee)}catch(we){return this.then(void 0,we)}finally(we){return fe.finally(we)}}}function v(ee,G,ue){return new Promise((fe,we)=>{const Ee=G.onCancellationRequested(()=>{Ee.dispose(),fe(ue)});ee.then(fe,we).finally(()=>Ee.dispose())})}function $(ee,G){return new Promise((ue,fe)=>{const we=G.onCancellationRequested(()=>{we.dispose(),fe(new A.$5)});ee.then(ue,fe).finally(()=>we.dispose())})}async function f(ee){let G=-1;const ue=ee.map((fe,we)=>fe.then(Ee=>(G=we,Ee)));try{return await Promise.race(ue)}finally{ee.forEach((fe,we)=>{we!==G&&fe.cancel()})}}function y(ee,G,ue){let fe;const we=setTimeout(()=>{fe?.(void 0),ue?.()},G);return Promise.race([ee.finally(()=>clearTimeout(we)),new Promise(Ee=>fe=Ee)])}function w(ee){return new Promise((G,ue)=>{const fe=ee();d(fe)?fe.then(G,ue):G(fe)})}function b(){let ee,G;return{promise:new Promise((fe,we)=>{ee=fe,G=we}),resolve:ee,reject:G}}class g{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const ue=()=>{if(this.b=null,this.f)return;const fe=this.queue(this.d);return this.d=null,fe};this.b=new Promise(fe=>{this.a.then(ue,ue).then(fe)})}return new Promise((ue,fe)=>{this.b.then(ue,fe)})}return this.a=G(),new Promise((ue,fe)=>{this.a.then(we=>{this.a=null,ue(we)},we=>{this.a=null,fe(we)})})}dispose(){this.f=!0}}e.$uh=g;class h{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$vh=h;class E{constructor(){this.a=new Map}queue(G,ue){const we=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.a.get(G)===we&&this.a.delete(G)});return this.a.set(G,we),we}}e.$wh=E;const a=(ee,G)=>{let ue=!0;const fe=setTimeout(()=>{ue=!1,G()},ee);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(fe),ue=!1}}},t=ee=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,ee())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class r{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,ue=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((we,Ee)=>{this.d=we,this.f=Ee}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const fe=()=>{this.a=null,this.d?.(null)};return this.a=ue===u.$ce?t(fe):a(ue,fe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=r;class s{constructor(G){this.a=new r(G),this.b=new g}trigger(G,ue){return this.a.trigger(()=>this.b.queue(G),ue)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=s;class i{constructor(){this.a=!1,this.b=new Promise((G,ue)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=i;class o extends i{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$Ah=o;function l(ee,G){return G?new Promise((ue,fe)=>{const we=setTimeout(()=>{Ee.dispose(),ue()},ee),Ee=G.onCancellationRequested(()=>{clearTimeout(we),Ee.dispose(),fe(new A.$5)})}):p(ue=>l(ee,ue))}function m(ee,G=0,ue){const fe=setTimeout(()=>{ee(),ue&&we.dispose()},G),we=(0,R.$Sc)(()=>{clearTimeout(fe),ue?.deleteAndLeak(we)});return ue?.add(we),we}function P(ee){const G=[];let ue=0;const fe=ee.length;function we(){return ue<fe?ee[ue++]():null}function Ee(Oe){Oe!=null&&G.push(Oe);const ye=we();return ye?ye.then(Ee):Promise.resolve(G)}return Promise.resolve(null).then(Ee)}function D(ee,G=fe=>!!fe,ue=null){let fe=0;const we=ee.length,Ee=()=>{if(fe>=we)return Promise.resolve(ue);const Oe=ee[fe++];return Promise.resolve(Oe()).then(ve=>G(ve)?Promise.resolve(ve):Ee())};return Ee()}function I(ee,G=fe=>!!fe,ue=null){if(ee.length===0)return Promise.resolve(ue);let fe=ee.length;const we=()=>{fe=-1;for(const Ee of ee)Ee.cancel?.()};return new Promise((Ee,Oe)=>{for(const ye of ee)ye.then(ve=>{--fe>=0&&G(ve)?(we(),Ee(ve)):fe===0&&Ee(ue)}).catch(ve=>{--fe>=0&&(we(),Oe(ve))})})}class O{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new S.$he}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ue,fe)=>{this.g.push({factory:G,c:ue,e:fe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const ue=G.factory();ue.then(G.c,G.e),ue.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=O;class M extends O{constructor(){super(1)}}e.$Hh=M;class W{constructor(){this.a=new z,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$Ih=W;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new V;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,ue=j.$4g){const fe=ue.getComparisonKey(G);return this.a.get(fe)?.size??0}queueFor(G,ue,fe=j.$4g){const we=fe.getComparisonKey(G);let Ee=this.a.get(we);if(!Ee){Ee=new M;const Oe=this.f++,ye=S.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(Oe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(Oe,ye),this.a.set(we,Ee)}return Ee.queue(ue)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=N;class T{constructor(G,ue){this.a=-1,typeof G=="function"&&typeof ue=="number"&&this.setIfNotSet(G,ue)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,ue){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},ue)}setIfNotSet(G,ue){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},ue))}}e.$Kh=T;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,ue,fe=globalThis){this.cancel();const we=fe.setInterval(()=>{G()},ue);this.d=(0,R.$Sc)(()=>{fe.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$Lh=U;class ie{constructor(G,ue){this.b=-1,this.a=G,this.d=ue,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=ie;class te{constructor(G,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.a=G,this.b=ue,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=te;class ae extends ie{constructor(G,ue){super(G,ue),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$Oh=ae;class K extends R.$Uc{constructor(G,ue){super(),this.g=G,this.h=ue,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ue of G)this.a.push(ue);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(ee,G)=>{(0,k.$B)(()=>{if(ue)return;const fe=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let ue=!1;return{dispose(){ue||(ue=!0)}}}:e.$Rh=(ee,G,ue)=>{const fe=ee.requestIdleCallback(G,typeof ue=="number"?{timeout:ue}:void 0);let we=!1;return{dispose(){we||(we=!0,ee.cancelIdleCallback(fe))}}},e.$Qh=ee=>(0,e.$Rh)(globalThis,ee)}();class J{constructor(G,ue){this.g=!1,this.d=()=>{try{this.j=ue()}catch(fe){this.l=fe}finally{this.g=!0}},this.f=(0,e.$Rh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=J;class q extends J{constructor(G){super(globalThis,G)}}e.$Th=q;async function L(ee,G,ue){let fe;for(let we=0;we<ue;we++)try{return await ee()}catch(Ee){fe=Ee,await l(G)}throw fe}class z{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,ue,fe){return this.a={taskId:G,cancel:()=>fe?.(),promise:ue},ue.then(()=>this.d(G),()=>this.d(G)),ue}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:ue,resolve:fe,reject:we}=b();this.b={run:G,promise:ue,promiseResolve:fe,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=z;class H{constructor(G,ue=()=>Date.now()){this.d=G,this.f=ue,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Wh=H;var ce;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(ce||(ce={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,ue)=>{this.a=G,this.b=ue})}complete(G){return new Promise(ue=>{this.a(G),this.d={outcome:0,value:G},ue()})}error(G){return new Promise(ue=>{this.b(G),this.d={outcome:1,value:G},ue()})}cancel(){return this.error(new A.$5)}}e.$Xh=V;var le;(function(ee){async function G(fe){let we;const Ee=await Promise.all(fe.map(Oe=>Oe.then(ye=>ye,ye=>{we||(we=ye)})));if(typeof we<"u")throw we;return Ee}ee.settled=G;function ue(fe){return new Promise(async(we,Ee)=>{try{await fe(we,Ee)}catch(Oe){Ee(Oe)}})}ee.withAsyncBody=ue})(le||(e.Promises=le={}));class Y{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(ue=>(this.a=ue,this.d=!0,ue),ue=>{throw this.b=ue,this.d=!0,ue})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=Y;class C{constructor(G){this.b=G,this.a=new c.$V(()=>new Y(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=C;var F;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(F||(F={}));class _{static fromArray(G){return new _(ue=>{ue.emitMany(G)})}static fromPromise(G){return new _(async ue=>{ue.emitMany(await G)})}static fromPromises(G){return new _(async ue=>{await Promise.all(G.map(async fe=>ue.emitOne(await fe)))})}static merge(G){return new _(async ue=>{await Promise.all(G.map(async fe=>{for await(const we of fe)ue.emitOne(we)}))})}static{this.EMPTY=_.fromArray([])}constructor(G,ue){this.a=0,this.b=[],this.d=null,this.f=ue,this.g=new S.$he,queueMicrotask(async()=>{const fe={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(G(fe)),this.k()}catch(we){this.l(we)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(G,ue){return new _(async fe=>{for await(const we of G)fe.emitOne(ue(we))})}map(G){return _.map(this,G)}static filter(G,ue){return new _(async fe=>{for await(const we of G)ue(we)&&fe.emitOne(we)})}filter(G){return _.filter(this,G)}static coalesce(G){return _.filter(G,ue=>!!ue)}coalesce(){return _.coalesce(this)}static async toPromise(G){const ue=[];for await(const fe of G)ue.push(fe);return ue}toPromise(){return _.toPromise(this)}h(G){this.a===0&&(this.b.push(G),this.g.fire())}j(G){this.a===0&&(this.b=this.b.concat(G),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(G){this.a===0&&(this.a=2,this.d=G,this.g.fire())}}e.$1h=_;class B extends _{constructor(G,ue){super(ue),this.m=G}cancel(){this.m.cancel()}}e.$2h=B;function Z(ee){const G=new n.$se,ue=ee(G.token);return new B(G,async fe=>{const we=G.token.onCancellationRequested(()=>{we.dispose(),G.dispose(),fe.reject(new A.$5)});try{for await(const Ee of ue){if(G.token.isCancellationRequested)return;fe.emitOne(Ee)}we.dispose(),G.dispose()}catch(Ee){we.dispose(),G.dispose(),fe.reject(Ee)}})}class x{constructor(G){this.a=new V,this.b=new _(we=>{if(ue){we.reject(ue);return}return fe&&we.emitMany(fe),this.d=Ee=>we.reject(Ee),this.f=Ee=>we.emitOne(Ee),this.a.p},G);let ue,fe;this.f=we=>{fe||(fe=[]),fe.push(we)},this.d=we=>{ue||(ue=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$4h=x}),define(re[108],oe([0,1,22,8,31,32,9,4,25]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=c,e.$sk=f,e.$tk=M,e.$uk=W,e.$vk=N,e.$wk=T,e.$xk=U,e.$yk=K;function c(){return Object.create(null)}e.$qk="**",e.$rk="/";const d="[/\\\\]",p="[^/\\\\]",v=/\//g;function $(J,q){switch(J){case 0:return"";case 1:return`${p}*?`;default:return`(?:${d}|${p}+${d}${q?`|${d}${p}+`:""})*?`}}function f(J,q){if(!J)return[];const L=[];let z=!1,H=!1,ce="";for(const V of J){switch(V){case q:if(!z&&!H){L.push(ce),ce="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":H=!0;break;case"]":H=!1;break}ce+=V}return ce&&L.push(ce),L}function y(J){if(!J)return"";let q="";const L=f(J,e.$rk);if(L.every(z=>z===e.$qk))q=".*";else{let z=!1;L.forEach((H,ce)=>{if(H===e.$qk){if(z)return;q+=$(2,ce===L.length-1)}else{let V=!1,le="",Y=!1,C="";for(const F of H){if(F!=="}"&&V){le+=F;continue}if(Y&&(F!=="]"||!C)){let _;F==="-"?_=F:(F==="^"||F==="!")&&!C?_="^":F===e.$rk?_="":_=(0,u.$df)(F),C+=_;continue}switch(F){case"{":V=!0;continue;case"[":Y=!0;continue;case"}":{const B=`(?:${f(le,",").map(Z=>y(Z)).join("|")})`;q+=B,V=!1,le="";break}case"]":{q+="["+C+"]",Y=!1,C="";break}case"?":q+=p;continue;case"*":q+=$(1);continue;default:q+=(0,u.$df)(F)}}ce<L.length-1&&(L[ce+1]!==e.$qk||ce+2<L.length)&&(q+=d)}z=H===e.$qk})}return q}const w=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),r=function(){return!1},s=function(){return null};function i(J,q){if(!J)return s;let L;typeof J!="string"?L=J.pattern:L=J,L=L.trim();const z=`${L}_${!!q.trimForExclusions}`;let H=t.get(z);if(H)return o(H,J);let ce;return w.test(L)?H=m(L.substr(4),L):(ce=b.exec(l(L,q)))?H=P(ce[1],L):(q.trimForExclusions?h:g).test(L)?H=D(L,q):(ce=E.exec(l(L,q)))?H=I(ce[1].substr(1),L,!0):(ce=a.exec(l(L,q)))?H=I(ce[1],L,!1):H=O(L),t.set(z,H),o(H,J)}function o(J,q){if(typeof q=="string")return J;const L=function(z,H){return(0,S.$zg)(z,q.base,!k.$k)?J((0,u.$if)(z.substr(q.base.length),j.sep),H):null};return L.allBasenames=J.allBasenames,L.allPaths=J.allPaths,L.basenames=J.basenames,L.patterns=J.patterns,L}function l(J,q){return q.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function m(J,q){return function(L,z){return typeof L=="string"&&L.endsWith(J)?q:null}}function P(J,q){const L=`/${J}`,z=`\\${J}`,H=function(V,le){return typeof V!="string"?null:le?le===J?q:null:V===J||V.endsWith(L)||V.endsWith(z)?q:null},ce=[J];return H.basenames=ce,H.patterns=[q],H.allBasenames=ce,H}function D(J,q){const L=ae(J.slice(1,-1).split(",").map(le=>i(le,q)).filter(le=>le!==s),J),z=L.length;if(!z)return s;if(z===1)return L[0];const H=function(le,Y){for(let C=0,F=L.length;C<F;C++)if(L[C](le,Y))return J;return null},ce=L.find(le=>!!le.allBasenames);ce&&(H.allBasenames=ce.allBasenames);const V=L.reduce((le,Y)=>Y.allPaths?le.concat(Y.allPaths):le,[]);return V.length&&(H.allPaths=V),H}function I(J,q,L){const z=j.sep===j.$gc.sep,H=z?J:J.replace(v,j.sep),ce=j.sep+H,V=j.$gc.sep+J;let le;return L?le=function(Y,C){return typeof Y=="string"&&(Y===H||Y.endsWith(ce)||!z&&(Y===J||Y.endsWith(V)))?q:null}:le=function(Y,C){return typeof Y=="string"&&(Y===H||!z&&Y===J)?q:null},le.allPaths=[(L?"*/":"./")+J],le}function O(J){try{const q=new RegExp(`^${y(J)}$`);return function(L){return q.lastIndex=0,typeof L=="string"&&q.test(L)?J:null}}catch{return s}}function M(J,q,L){return!J||typeof q!="string"?!1:W(J)(q,void 0,L)}function W(J,q={}){if(!J)return r;if(typeof J=="string"||N(J)){const L=i(J,q);if(L===s)return r;const z=function(H,ce){return!!L(H,ce)};return L.allBasenames&&(z.allBasenames=L.allBasenames),L.allPaths&&(z.allPaths=L.allPaths),z}return ie(J,q)}function N(J){const q=J;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function T(J){return J.allBasenames||[]}function U(J){return J.allPaths||[]}function ie(J,q){const L=ae(Object.getOwnPropertyNames(J).map(le=>te(le,J[le],q)).filter(le=>le!==s)),z=L.length;if(!z)return s;if(!L.some(le=>!!le.requiresSiblings)){if(z===1)return L[0];const le=function(F,_){let B;for(let Z=0,x=L.length;Z<x;Z++){const ee=L[Z](F,_);if(typeof ee=="string")return ee;(0,A.$mh)(ee)&&(B||(B=[]),B.push(ee))}return B?(async()=>{for(const Z of B){const x=await Z;if(typeof x=="string")return x}return null})():null},Y=L.find(F=>!!F.allBasenames);Y&&(le.allBasenames=Y.allBasenames);const C=L.reduce((F,_)=>_.allPaths?F.concat(_.allPaths):F,[]);return C.length&&(le.allPaths=C),le}const H=function(le,Y,C){let F,_;for(let B=0,Z=L.length;B<Z;B++){const x=L[B];x.requiresSiblings&&C&&(Y||(Y=(0,j.$nc)(le)),F||(F=Y.substr(0,Y.length-(0,j.$oc)(le).length)));const ee=x(le,Y,F,C);if(typeof ee=="string")return ee;(0,A.$mh)(ee)&&(_||(_=[]),_.push(ee))}return _?(async()=>{for(const B of _){const Z=await B;if(typeof Z=="string")return Z}return null})():null},ce=L.find(le=>!!le.allBasenames);ce&&(H.allBasenames=ce.allBasenames);const V=L.reduce((le,Y)=>Y.allPaths?le.concat(Y.allPaths):le,[]);return V.length&&(H.allPaths=V),H}function te(J,q,L){if(q===!1)return s;const z=i(J,L);if(z===s)return s;if(typeof q=="boolean")return z;if(q){const H=q.when;if(typeof H=="string"){const ce=(V,le,Y,C)=>{if(!C||!z(V,le))return null;const F=H.replace("$(basename)",()=>Y),_=C(F);return(0,A.$mh)(_)?_.then(B=>B?J:null):_?J:null};return ce.requiresSiblings=!0,ce}}return z}function ae(J,q){const L=J.filter(le=>!!le.basenames);if(L.length<2)return J;const z=L.reduce((le,Y)=>{const C=Y.basenames;return C?le.concat(C):le},[]);let H;if(q){H=[];for(let le=0,Y=z.length;le<Y;le++)H.push(q)}else H=L.reduce((le,Y)=>{const C=Y.patterns;return C?le.concat(C):le},[]);const ce=function(le,Y){if(typeof le!="string")return null;if(!Y){let F;for(F=le.length;F>0;F--){const _=le.charCodeAt(F-1);if(_===47||_===92)break}Y=le.substr(F)}const C=z.indexOf(Y);return C!==-1?H[C]:null};ce.basenames=z,ce.patterns=H,ce.allBasenames=z;const V=J.filter(le=>!le.basenames);return V.push(ce),V}function K(J,q){return(0,n.$ub)(J,q,(L,z)=>typeof L=="string"&&typeof z=="string"?L===z:typeof L!="string"&&typeof z!="string"?L.base===z.base&&L.pattern===z.pattern:!1)}}),define(re[48],oe([0,1,22,31,9,4,19,25]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jw=u,e.$Kw=d,e.$Lw=v,e.$Mw=$,e.$Nw=b,e.$Ow=h,e.$Pw=E,e.$Qw=a,e.$Rw=t,e.$Sw=r;function u(i,o){const{os:l,tildify:m,relative:P}=o;if(P){const O=c(i,P,l);if(typeof O=="string")return O}let D=i.fsPath;if(l===1&&!R.$i?D=D.replace(/\//g,"\\"):l!==1&&R.$i&&(D=D.replace(/\\/g,"/")),l!==1&&m?.userHome){const O=m.userHome.fsPath;let M;i.scheme!==m.userHome.scheme&&i.path[0]===S.$gc.sep&&i.path[1]!==S.$gc.sep?M=m.userHome.with({path:i.path}).fsPath:M=D,D=v(M,O,l)}return(l===1?S.$fc:S.$gc).normalize(d(D,l===1))}function c(i,o,l){const m=l===1?S.$fc:S.$gc,P=l===3?j.$4g:j.$6g,D=o.getWorkspace(),I=(0,n.$Ob)(D.folders);if(!I)return;i.scheme!==I.uri.scheme&&i.path[0]===S.$gc.sep&&i.path[1]!==S.$gc.sep&&(i=I.uri.with({path:i.path}));const O=o.getWorkspaceFolder(i);if(!O)return;let M;if(P.isEqual(O.uri,i)?M="":M=P.relativePath(O.uri,i)??"",M&&(M=m.normalize(M)),D.folders.length>1&&!o.noPrefix){const W=O.name?O.name:P.basenameOrAuthority(O.uri);M=M?`${W} \u2022 ${M}`:W}return M}function d(i,o=R.$i){return(0,A.$Eg)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}let p=Object.create(null);function v(i,o,l=R.OS){if(l===1||!i||!o)return i;let m=p.original===o?p.normalized:void 0;m||(m=o,R.$i&&(m=(0,A.$tg)(m)),m=`${(0,k.$jf)(m,S.$gc.sep)}${S.$gc.sep}`,p={original:o,normalized:m});let P=i;return R.$i&&(P=(0,A.$tg)(P)),(l===3?P.startsWith(m):(0,k.$Cf)(P,m))?`~/${P.substr(m.length)}`:i}function $(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}const f="\u2026",y="\\\\",w="~";function b(i,o=S.sep){const l=new Array(i.length);let m=!1;for(let P=0;P<i.length;P++){const D=i[P];if(D===""){l[P]=`.${o}`;continue}if(!D){l[P]=D;continue}m=!0;let I="",O=D;O.indexOf(y)===0?(I=O.substr(0,O.indexOf(y)+y.length),O=O.substr(O.indexOf(y)+y.length)):O.indexOf(o)===0?(I=O.substr(0,O.indexOf(o)+o.length),O=O.substr(O.indexOf(o)+o.length)):O.indexOf(w)===0&&(I=O.substr(0,O.indexOf(w)+w.length),O=O.substr(O.indexOf(w)+w.length));const M=O.split(o);for(let W=1;m&&W<=M.length;W++)for(let N=M.length-W;m&&N>=0;N--){m=!1;let T=M.slice(N,N+W).join(o);for(let U=0;!m&&U<i.length;U++)if(U!==P&&i[U]&&i[U].indexOf(T)>-1){const ie=N+W===M.length,te=N>0&&i[U].indexOf(o)>-1?o+T:T,ae=i[U].endsWith(te);m=!ie||ae}if(!m){let U="";(M[0].endsWith(":")||I!=="")&&(N===1&&(N=0,W++,T=M[0]+o+T),N>0&&(U=M[0]+o),U=I+U),N>0&&(U=U+f+o),U=U+T,N+W<M.length&&(U=U+o+f),l[P]=U}}m&&(l[P]=D)}return l}var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function h(i,o=Object.create(null)){const l=[];let m=!1,P="";for(const D of i)if(D==="$"||m&&D==="{")P&&l.push({value:P,type:g.TEXT}),P="",m=!0;else if(D==="}"&&m){const I=o[P];if(typeof I=="string")I.length&&l.push({value:I,type:g.VARIABLE});else if(I){const O=l[l.length-1];(!O||O.type!==g.SEPARATOR)&&l.push({value:I.label,type:g.SEPARATOR})}P="",m=!1}else P+=D;return P&&!m&&l.push({value:P,type:g.TEXT}),l.filter((D,I)=>{if(D.type===g.SEPARATOR){const O=l[I-1],M=l[I+1];return[O,M].every(W=>W&&(W.type===g.VARIABLE||W.type===g.TEXT)&&W.value.length>0)}return!0}).map(D=>D.value).join("")}function E(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function a(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,""):R.$i?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function r(i){if(i.endsWith("]")){const o=i.lastIndexOf(" [",i.length-2);if(o!==-1){const l=s(i.substring(0,o)),m=i.substring(o);return{name:l.name+m,parentPath:l.parentPath}}}return s(i)}function s(i){const o=i.indexOf("/")!==-1?S.$gc:S.$fc,l=o.basename(i),m=o.dirname(i);return l.length?{name:l,parentPath:m}:{name:m,parentPath:""}}}),define(re[157],oe([0,1,17,7]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=void 0,e.$En=k,e.$Fn=c,e.$Gn=d;function S(p){return p.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const $=this.a.transformIncoming(v);return $===v?v:S(A.URI.from($))}transformOutgoing(v){const $=this.a.transformOutgoing(v);return $===v?v:S(A.URI.from($))}transformOutgoingURI(v){const $=this.a.transformOutgoing(v);return $===v?v:A.URI.from($)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Cn=R,e.$Dn=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function j(p,v,$){if(!p||$>200)return null;if(typeof p=="object"){if(p instanceof A.URI)return v.transformOutgoing(p);for(const f in p)if(Object.hasOwnProperty.call(p,f)){const y=j(p[f],v,$+1);y!==null&&(p[f]=y)}}return null}function k(p,v){const $=j(p,v,0);return $===null?p:$}function u(p,v,$,f){if(!p||f>200)return null;if(typeof p=="object"){if(p.$mid===1)return $?A.URI.revive(v.transformIncoming(p)):v.transformIncoming(p);if(p instanceof n.$Je)return null;for(const y in p)if(Object.hasOwnProperty.call(p,y)){const w=u(p[y],v,$,f+1);w!==null&&(p[y]=w)}}return null}function c(p,v){const $=u(p,v,!1,0);return $===null?p:$}function d(p,v){const $=u(p,v,!0,0);return $===null?p:$}}),define(re[89],oe([0,1,26,59,33,147,4]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$Jn=u,e.$Kn=p,e.$In=new class{c(v){return this.a||(this.a=A.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,$=0;const f=(0,n.networkInterfaces)();for(const y in f){const w=f[y];if(w)for(const{mac:b,internal:g}of w)g||($+=1,this.c(b.toUpperCase())&&(v+=1))}this.b=$>0?v/$:0}return this.b}};let k;async function u(v){return k||(k=(async()=>await c(v)||S.$Wg())()),k}async function c(v){try{const $=await new Promise((y,w)=>{Q(["crypto"],y,w)}),f=(0,R.$Hn)();return $.createHash("sha256").update(f,"utf8").digest("hex")}catch($){v($);return}}const d="Software\\Microsoft\\SQMClient";async function p(v){if(j.$i){const $=await new Promise((f,y)=>{Q(["@vscode/windows-registry"],f,y)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(f){return v(f),""}}return""}}),define(re[21],oe([0,1,43,26,158,8,31,72,9,4,19,7]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=h,e.whenDeleted=t,e.configureFlushOnWrite=l,e.writeFileSync=P;var v;(function(te){te[te.UNLINK=0]="UNLINK",te[te.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function $(te,ae=v.UNLINK,K){if((0,j.$Dg)(te))throw new Error("rimraf - will refuse to recursively delete root");return ae===v.UNLINK?y(te):f(te,K)}async function f(te,ae=(0,j.$Ig)((0,A.tmpdir)())){try{try{await n.promises.rename(te,ae)}catch(K){return K.code==="ENOENT"?void 0:y(te)}y(ae).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function y(te){return(0,S.promisify)(n.rm)(te,{recursive:!0,force:!0,maxRetries:3})}function w(te){if((0,j.$Dg)(te))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(te,{recursive:!0,force:!0,maxRetries:3})}async function b(te,ae){return E(await(ae?g(te):(0,S.promisify)(n.readdir)(te)))}async function g(te){try{return await(0,S.promisify)(n.readdir)(te,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const ae=[],K=await b(te);for(const J of K){let q=!1,L=!1,z=!1;try{const H=await e.Promises.lstat((0,u.$jc)(te,J));q=H.isFile(),L=H.isDirectory(),z=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ae.push({name:J,isFile:()=>q,isDirectory:()=>L,isSymbolicLink:()=>z})}return ae}function h(te){return E(n.readdirSync(te))}function E(te){return te.map(ae=>typeof ae=="string"?c.$j?(0,k.$fm)(ae):ae:(ae.name=c.$j?(0,k.$fm)(ae.name):ae.name,ae))}async function a(te){const ae=await b(te),K=[];for(const J of ae)await r.existsDirectory((0,u.$jc)(te,J))&&K.push(J);return K}function t(te,ae=1e3){return new Promise(K=>{let J=!1;const q=setInterval(()=>{J||(J=!0,n.access(te,L=>{J=!1,L&&(clearInterval(q),K(void 0))}))},ae)})}var r;(function(te){async function ae(q){let L;try{if(L=await e.Promises.lstat(q),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(c.$i&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw H}throw z}}te.stat=ae;async function K(q){try{const{stat:L,symbolicLink:z}=await te.stat(q);return L.isFile()&&z?.dangling!==!0}catch{}return!1}te.existsFile=K;async function J(q){try{const{stat:L,symbolicLink:z}=await te.stat(q);return L.isDirectory()&&z?.dangling!==!0}catch{}return!1}te.existsDirectory=J})(r||(e.SymlinkSupport=r={}));const s=new R.$Jh;function i(te,ae,K){return s.queueFor(p.URI.file(te),()=>{const J=D(K);return new Promise((q,L)=>m(te,ae,J,z=>z?L(z):q()))},d.$5g)}let o=!0;function l(te){o=te}function m(te,ae,K,J){if(!o)return n.writeFile(te,ae,{mode:K.mode,flag:K.flag},J);n.open(te,K.flag,K.mode,(q,L)=>{if(q)return J(q);n.writeFile(L,ae,z=>{if(z)return n.close(L,()=>J(z));n.fdatasync(L,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),l(!1)),n.close(L,ce=>J(ce))))})})}function P(te,ae,K){const J=D(K);if(!o)return n.writeFileSync(te,ae,{mode:J.mode,flag:J.flag});const q=n.openSync(te,J.flag,J.mode);try{n.writeFileSync(q,ae);try{n.fdatasyncSync(q)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),l(!1)}}finally{n.closeSync(q)}}function D(te){return te?{mode:typeof te.mode=="number"?te.mode:438,flag:typeof te.flag=="string"?te.flag:"w"}:{mode:438,flag:"w"}}async function I(te,ae,K=6e4){if(te!==ae)try{c.$i&&typeof K=="number"?await O(te,ae,Date.now(),K):await(0,S.promisify)(n.rename)(te,ae)}catch(J){if(te.toLowerCase()!==ae.toLowerCase()&&J.code==="EXDEV"||te.endsWith("."))await M(te,ae,{preserveSymlinks:!1}),await $(te,v.MOVE);else throw J}}async function O(te,ae,K,J,q=0){try{return await(0,S.promisify)(n.rename)(te,ae)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-K>=J)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${L}`),L;if(q===0){let z=!1;try{const{stat:H}=await r.stat(ae);H.isFile()||(z=!0)}catch{}if(z)throw L}return await(0,R.$Bh)(Math.min(100,q*10)),O(te,ae,K,J,q+1)}}async function M(te,ae,K){return N(te,ae,{root:{source:te,target:ae},options:K,handledSourcePaths:new Set})}const W=511;async function N(te,ae,K){if(K.handledSourcePaths.has(te))return;K.handledSourcePaths.add(te);const{stat:J,symbolicLink:q}=await r.stat(te);if(q){if(K.options.preserveSymlinks)try{return await ie(te,ae,K)}catch{}if(q.dangling)return}return J.isDirectory()?T(te,ae,J.mode&W,K):U(te,ae,J.mode&W)}async function T(te,ae,K,J){await e.Promises.mkdir(ae,{recursive:!0,mode:K});const q=await b(te);for(const L of q)await N((0,u.$jc)(te,L),(0,u.$jc)(ae,L),J)}async function U(te,ae,K){await e.Promises.copyFile(te,ae),await e.Promises.chmod(ae,K)}async function ie(te,ae,K){let J=await e.Promises.readlink(te);(0,j.$zg)(J,K.root.source,!c.$k)&&(J=(0,u.$jc)(K.root.target,J.substr(K.root.source.length+1))),await e.Promises.symlink(J,ae)}e.Promises=new class{get access(){return(0,S.promisify)(n.access)}get stat(){return(0,S.promisify)(n.stat)}get lstat(){return(0,S.promisify)(n.lstat)}get utimes(){return(0,S.promisify)(n.utimes)}get read(){return(te,ae,K,J,q)=>new Promise((L,z)=>{n.read(te,ae,K,J,q,(H,ce,V)=>H?z(H):L({bytesRead:ce,buffer:V}))})}get readFile(){return(0,S.promisify)(n.readFile)}get write(){return(te,ae,K,J,q)=>new Promise((L,z)=>{n.write(te,ae,K,J,q,(H,ce,V)=>H?z(H):L({bytesWritten:ce,buffer:V}))})}get appendFile(){return(0,S.promisify)(n.appendFile)}get fdatasync(){return(0,S.promisify)(n.fdatasync)}get truncate(){return(0,S.promisify)(n.truncate)}get copyFile(){return(0,S.promisify)(n.copyFile)}get open(){return(0,S.promisify)(n.open)}get close(){return(0,S.promisify)(n.close)}get symlink(){return(0,S.promisify)(n.symlink)}get readlink(){return(0,S.promisify)(n.readlink)}get chmod(){return(0,S.promisify)(n.chmod)}get mkdir(){return(0,S.promisify)(n.mkdir)}get unlink(){return(0,S.promisify)(n.unlink)}get rmdir(){return(0,S.promisify)(n.rmdir)}get realpath(){return(0,S.promisify)(n.realpath)}async exists(te){try{return await e.Promises.access(te),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return $}get rename(){return I}get copy(){return M}}}),define(re[109],oe([0,1,43,9,4,25,21]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=k,e.$$q=u,e.$_q=c,e.$ar=d;function k(v){if(S.$k)return v;const $=(0,A.$mc)(v);if(v===$)return v;const f=((0,A.$nc)(v)||v).toLowerCase();try{const w=(0,j.readdirSync)($).filter(b=>b.toLowerCase()===f);if(w.length===1){const b=k($);if(b)return(0,A.$jc)(b,w[0])}else if(w.length>1){const b=w.indexOf(f);if(b>=0){const g=k($);if(g)return(0,A.$jc)(g,w[b])}}}catch{}return null}async function u(v,$){if(S.$k)return v;const f=(0,A.$mc)(v);if(v===f)return v;const y=((0,A.$nc)(v)||v).toLowerCase();try{if($?.isCancellationRequested)return null;const b=(await j.Promises.readdir(f)).filter(g=>g.toLowerCase()===y);if(b.length===1){const g=await u(f,$);if(g)return(0,A.$jc)(g,b[0])}else if(b.length>1){const g=b.indexOf(y);if(g>=0){const h=await u(f,$);if(h)return(0,A.$jc)(h,b[g])}}}catch{}return null}async function c(v){try{return await j.Promises.realpath(v)}catch{const f=p(v);return await j.Promises.access(f,n.constants.R_OK),f}}function d(v){try{return n.realpathSync(v)}catch{const f=p(v);return n.accessSync(f,n.constants.R_OK),f}}function p(v){return(0,R.$jf)((0,A.$hc)(v),A.sep)}}),define(re[110],oe([0,1,26,9,21]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=g,e.$pm=h;const R=/^\d+$/,j=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var u;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=1:d=0;class p{constructor(a,t,r){this.exePath=a,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:E=!1}={}){return E?c===0?process.env["ProgramFiles(x86)"]||null:d===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:E=!1,findPreview:a=!1}={}){const t=v({useAlternateBitness:E});if(!t)return null;const r=A.$jc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(r))return null;let s=-1,i=null;for(const m of await S.Promises.readdir(r)){let P=-1;if(a){const I=m.indexOf("-");if(I<0)continue;const O=m.substring(0,I);if(!R.test(O)||m.substring(I+1)!=="preview")continue;P=parseInt(O,10)}else{if(!R.test(m))continue;P=parseInt(m,10)}if(P<=s)continue;const D=A.$jc(r,m,"pwsh.exe");await S.SymlinkSupport.existsFile(D)&&(i=D,s=P)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new p(i,`PowerShell${l}${o}`,!0)}async function f({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const a=A.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=E?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const s of await S.Promises.readdir(a))if(t.test(s)){const i=A.$jc(a,s,"pwsh.exe");return new p(i,r)}return null}function y(){const E=A.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new p(E,".NET Core PowerShell Global Tool")}function w(){const E=A.$jc(process.env.windir,c===1&&d!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(E,"Windows PowerShell",!0)}async function*b(){let E=await $();E&&(yield E),E=await $({useAlternateBitness:!0}),E&&(yield E),E=await f(),E&&(yield E),E=y(),E&&(yield E),E=await $({findPreview:!0}),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await $({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=w(),E&&(yield E)}async function*g(){for await(const E of b())await E.exists()&&(yield E)}async function h(){for await(const E of g())return E;return null}}),define(re[90],oe([0,1,9,4,36,76,12,21]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$sm=u,e.$tm=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function u(p=S.env){return p.comspec||"cmd.exe"}function c(p){let v=[],$=!1;const f=function(y){if($){v.push(y);return}(!p.send(y,b=>{if(b&&console.error(b),$=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(h=>f(h))}})||A.$i)&&($=!0)};return{send:f}}var d;(function(p){async function v($,f,y){if(n.$ic($))return $;if(f===void 0&&(f=S.cwd()),n.$mc($)!=="."||(y===void 0&&j.$ag(S.env.PATH)&&(y=S.env.PATH.split(n.$tc)),y===void 0||y.length===0))return n.$jc(f,$);async function b(g){if(await k.Promises.exists(g)){let h;try{h=await k.Promises.stat(g)}catch(E){E.message.startsWith("EACCES")&&(h=await k.Promises.lstat(g))}return h?!h.isDirectory():!1}return!1}for(const g of y){let h;if(n.$ic(g)?h=n.$jc(g,$):h=n.$jc(f,g,$),await b(h))return h;let E=h+".com";if(await b(E)||(E=h+".exe",await b(E)))return E}return n.$jc(f,$)}p.findExecutable=v})(d||(e.win32=d={}))}),define(re[111],oe([0,1,49,13]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=S;function S(j){return new Promise((k,u)=>{let c;const d=new Map;function p($,f,y,w,b){const g=d.get(f);if($===j||g){const h={name:v(y),cmd:y,pid:$,ppid:f,load:w,mem:b};d.set($,h),$===j&&(c=h),g&&(g.children||(g.children=[]),g.children.push(h),g.children.length>1&&(g.children=g.children.sort((E,a)=>E.pid-a.pid)))}}function v($){const f=/--utility-sub-type=network/i,y=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if(y.exec($))return"electron-crash-reporter";if(w.exec($))return"winpty-agent";if(b.exec($))return"conpty-agent";let h=g.exec($);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?f.exec($)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const E=/[a-zA-Z-]+\.js/g;let a="";do h=E.exec($),h&&(a+=h+" ");while(h);return a&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${a})`:$}if(process.platform==="win32"){const $=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,y)=>{Q(["@vscode/windows-process-tree"],f,y)}).then(f=>{f.getProcessList(j,y=>{if(!y){u(new Error(`Root process ${j} not found`));return}f.getProcessCpuUsage(y,w=>{const b=new Map;w.forEach(g=>{const h=$(g.commandLine||"");b.set(g.pid,{name:v(h),cmd:h,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),c=b.get(j),c?(b.forEach(g=>{const h=b.get(g.ppid);h&&(h.children||(h.children=[]),h.children.push(g))}),b.forEach(g=>{g.children&&(g.children=g.children.sort((h,E)=>h.pid-E.pid))}),k(c)):u(new Error(`Root process ${j} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let $=function(){let f=[c];const y=[];for(;f.length;){const b=f.shift();b&&(y.push(b.pid),b.children&&(f=f.concat(b.children)))}let w=JSON.stringify(A.$Ug.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+y.join(" "),(0,n.exec)(w,{},(b,g,h)=>{if(b||h)u(b||new Error(h.toString()));else{const E=g.toString().split(`
`);for(let a=0;a<y.length;a++){const t=d.get(y[a]);t.load=parseFloat(E[a])}if(!c){u(new Error(`Root process ${j} not found`));return}k(c)}})};(0,n.exec)("which ps",{},(f,y,w)=>{if(f||w)if(process.platform!=="linux")u(f||new Error(w.toString()));else{const b=JSON.stringify(A.$Ug.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(b,{},(g,h,E)=>{g||E?u(g||new Error(E.toString())):(R(h,p),$())})}else{const b=y.toString().trim();(0,n.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,E,a)=>{h||a&&!a.includes("screen size is bogus")?u(h||new Error(a.toString())):(R(E,p),process.platform==="linux"?$():c?k(c):u(new Error(`Root process ${j} not found`)))})}})}})}function R(j,k){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=j.toString().split(`
`);for(const d of c){const p=u.exec(d.trim());p&&p.length===6&&k(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(re[112],oe([0,1,26,4,110,90]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=j;async function j(p,v){return p===1?A.$i?d():R.$sm(v):u(p,v)}let k=null;function u(p,v){if(A.$k&&p===2||A.$j&&p===3)return"/bin/bash";if(!k){let $;if(A.$i)$="/bin/bash";else{if($=v.SHELL,!$)try{$=(0,n.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}k=$}return k}let c=null;async function d(){return c||(c=(await(0,S.$pm)()).exePath),c}});var ke=this&&this.__decorate||function(Q,e,n,A){var S=arguments.length,R=S<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,n):A,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(Q,e,n,A);else for(var k=Q.length-1;k>=0;k--)(j=Q[k])&&(R=(S<3?j(R):S>3?j(e,n,R):j(e,n))||R);return S>3&&R&&Object.defineProperty(e,n,R),R};define(re[44],oe([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=l,e.$bi=m,e.$gi=W,e.$hi=N;var $;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})($||($={}));function f(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y||(y={}));function w(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(b||(b={}));function g(q){let L=0;for(let z=0;;z+=7){const H=q.read(1);if(L|=(H.buffer[0]&127)<<z,!(H.buffer[0]&128))return L}}const h=s(0);function E(q,L){if(L===0){q.write(h);return}let z=0;for(let ce=L;ce!==0;ce=ce>>>7)z++;const H=S.$Je.alloc(z);for(let ce=0;L!==0;ce++)H.buffer[ce]=L&127,L=L>>>7,L>0&&(H.buffer[ce]|=128);q.write(H)}class a{constructor(L){this.b=L,this.a=0}read(L){const z=this.b.slice(this.a,this.a+L);return this.a+=z.byteLength,z}}e.$$h=a;class t{constructor(){this.a=[]}get buffer(){return S.$Je.concat(this.a)}write(L){this.a.push(L)}}e.$_h=t;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function s(q){const L=S.$Je.alloc(1);return L.writeUInt8(q,0),L}const i={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},o=typeof Buffer<"u";function l(q,L){if(typeof L>"u")q.write(i.Undefined);else if(typeof L=="string"){const z=S.$Je.fromString(L);q.write(i.String),E(q,z.byteLength),q.write(z)}else if(o&&Buffer.isBuffer(L)){const z=S.$Je.wrap(L);q.write(i.Buffer),E(q,z.byteLength),q.write(z)}else if(L instanceof S.$Je)q.write(i.VSBuffer),E(q,L.byteLength),q.write(L);else if(Array.isArray(L)){q.write(i.Array),E(q,L.length);for(const z of L)l(q,z)}else if(typeof L=="number"&&(L|0)===L)q.write(i.Uint),E(q,L);else{const z=S.$Je.fromString(JSON.stringify(L));q.write(i.Object),E(q,z.byteLength),q.write(z)}}function m(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(g(q)).toString();case r.Buffer:return q.read(g(q)).buffer;case r.VSBuffer:return q.read(g(q));case r.Array:{const z=g(q),H=[];for(let ce=0;ce<z;ce++)H.push(m(q));return H}case r.Object:return JSON.parse(q.read(g(q)).toString());case r.Int:return g(q)}}class P{constructor(L,z,H=null,ce=1e3){this.h=L,this.j=z,this.k=H,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(V=>this.q(V)),this.m({type:200})}registerChannel(L,z){this.b.set(L,z),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const z=this.o([L.type]);this.k?.logOutgoing(z,0,1,w(L.type));return}case 201:case 202:case 204:case 203:{const z=this.o([L.type,L.id],L.data);this.k?.logOutgoing(z,L.id,1,w(L.type),L.data);return}}}o(L,z=void 0){const H=new t;return l(H,L),l(H,z),this.p(H.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const z=new a(L),H=m(z),ce=m(z),V=H[0];switch(V){case 100:return this.k?.logIncoming(L.byteLength,H[1],1,`${f(V)}: ${H[2]}.${H[3]}`,ce),this.s({type:V,id:H[1],channelName:H[2],name:H[3],arg:ce});case 102:return this.k?.logIncoming(L.byteLength,H[1],1,`${f(V)}: ${H[2]}.${H[3]}`,ce),this.t({type:V,id:H[1],channelName:H[2],name:H[3],arg:ce});case 101:return this.k?.logIncoming(L.byteLength,H[1],1,`${f(V)}`),this.u({type:V,id:H[1]});case 103:return this.k?.logIncoming(L.byteLength,H[1],1,`${f(V)}`),this.u({type:V,id:H[1]})}}s(L){const z=this.b.get(L.channelName);if(!z){this.v(L);return}const H=new R.$se;let ce;try{ce=z.call(this.j,L.name,L.arg,H.token)}catch(Y){ce=Promise.reject(Y)}const V=L.id;ce.then(Y=>{this.m({id:V,data:Y,type:201})},Y=>{Y instanceof Error?this.m({id:V,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.m({id:V,data:Y,type:203})}).finally(()=>{le.dispose(),this.d.delete(L.id)});const le=(0,c.$Sc)(()=>H.cancel());this.d.set(L.id,le)}t(L){const z=this.b.get(L.channelName);if(!z){this.v(L);return}const H=L.id,V=z.listen(this.j,L.name,L.arg)(le=>this.m({id:H,data:le,type:204}));this.d.set(L.id,V)}u(L){const z=this.d.get(L.id);z&&(z.dispose(),this.d.delete(L.id))}v(L){let z=this.g.get(L.channelName);z||(z=[],this.g.set(L.channelName,z));const H=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:L,timeoutTimer:H})}w(L){const z=this.g.get(L);if(z){for(const H of z)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$ci=P;var D;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class I{constructor(L,z=null){this.l=L,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=z}getChannel(L){const z=this;return{call(H,ce,V){return z.a?Promise.reject(new k.$5):z.m(L,H,ce,V)},listen(H,ce){return z.a?u.Event.None:z.o(L,H,ce)}}}m(L,z,H,ce=R.CancellationToken.None){const V=this.g++,Y={id:V,type:100,channelName:L,name:z,arg:H};if(ce.isCancellationRequested)return Promise.reject(new k.$5);let C;return new Promise((_,B)=>{if(ce.isCancellationRequested)return B(new k.$5);const Z=()=>{const ue=fe=>{switch(fe.type){case 201:this.f.delete(V),_(fe.data);break;case 202:{this.f.delete(V);const we=new Error(fe.data.message);we.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,we.name=fe.data.name,B(we);break}case 203:this.f.delete(V),B(fe.data);break}};this.f.set(V,ue),this.p(Y)};let x=null;this.b===b.Idle?Z():(x=(0,A.$nh)(ue=>this.u()),x.then(()=>{x=null,Z()}));const ee=()=>{x?(x.cancel(),x=null):this.p({id:V,type:101}),B(new k.$5)},G=ce.onCancellationRequested(ee);C=(0,c.$Rc)((0,c.$Sc)(ee),G),this.d.add(C)}).finally(()=>{C.dispose(),this.d.delete(C)})}o(L,z,H){const ce=this.g++,le={id:ce,type:102,channelName:L,name:z,arg:H};let Y=null;const C=new u.$he({onWillAddFirstListener:()=>{Y=(0,A.$nh)(_=>this.u()),Y.then(()=>{Y=null,this.d.add(C),this.p(le)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.d.delete(C),this.p({id:ce,type:103}))}}),F=_=>C.fire(_.data);return this.f.set(ce,F),C.event}p(L){switch(L.type){case 100:case 102:{const z=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(z,L.id,0,`${f(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const z=this.q([L.type,L.id]);this.j?.logOutgoing(z,L.id,0,f(L.type));return}}}q(L,z=void 0){const H=new t;return l(H,L),l(H,z),this.r(H.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const z=new a(L),H=m(z),ce=m(z),V=H[0];switch(V){case 200:return this.j?.logIncoming(L.byteLength,0,0,w(V)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,H[1],0,w(V),ce),this.t({type:H[0],id:H[1],data:ce})}}t(L){if(L.type===200){this.b=b.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$di=I,ke([j.$5h],I.prototype,"onDidInitializePromise",null);class O{get connections(){const L=[];return this.f.forEach(z=>L.push(z)),L}constructor(L,z,H){this.a=new Map,this.f=new Set,this.g=new u.$he,this.onDidAddConnection=this.g.event,this.h=new u.$he,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(L(({protocol:ce,onDidClientDisconnect:V})=>{const le=u.Event.once(ce.onMessage);this.j.add(le(Y=>{const C=new a(Y),F=m(C),_=new P(ce,F,z,H),B=new I(ce,z);this.a.forEach((x,ee)=>_.registerChannel(ee,x));const Z={channelServer:_,channelClient:B,ctx:F};this.f.add(Z),this.g.fire(Z),this.j.add(V(()=>{_.dispose(),B.dispose(),this.f.delete(Z),this.h.fire(Z)}))}))}))}getChannel(L,z){const H=this;return{call(ce,V,le){let Y;if((0,v.$og)(z)){const F=(0,n.$3b)(H.connections.filter(z));Y=F?Promise.resolve(F):u.Event.toPromise(u.Event.filter(H.onDidAddConnection,z))}else Y=z.routeCall(H,ce,V);const C=Y.then(F=>F.channelClient.getChannel(L));return W(C).call(ce,V,le)},listen(ce,V){if((0,v.$og)(z))return H.k(L,z,ce,V);const le=z.routeEvent(H,ce,V).then(Y=>Y.channelClient.getChannel(L));return W(le).listen(ce,V)}}}k(L,z,H,ce){const V=this;let le;const Y=new u.$he({onWillAddFirstListener:()=>{le=new c.$Tc;const C=new u.$ne,F=new Map,_=Z=>{const ee=Z.channelClient.getChannel(L).listen(H,ce),G=C.add(ee);F.set(Z,G)},B=Z=>{const x=F.get(Z);x&&(x.dispose(),F.delete(Z))};V.connections.filter(z).forEach(_),u.Event.filter(V.onDidAddConnection,z)(_,void 0,le),V.onDidRemoveConnection(B,void 0,le),C.event(Y.fire,Y,le),le.add(C)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return Y.event}registerChannel(L,z){this.a.set(L,z);for(const H of this.f)H.channelServer.registerChannel(L,z)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=O;class M{constructor(L,z,H=null){const ce=new t;l(ce,z),L.send(ce.buffer),this.a=new I(L,H),this.d=new P(L,z,H)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,z){this.d.registerChannel(L,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=M;function W(q){return{call(L,z,H){return q.then(ce=>ce.call(L,z,H))},listen(L,z){const H=new u.$qe;return q.then(ce=>H.input=ce.listen(L,z)),H.event}}}function N(q){let L=!1;return{call(z,H,ce){return L?q.call(z,H,ce):(0,A.$Bh)(0).then(()=>L=!0).then(()=>q.call(z,H,ce))},listen(z,H){if(L)return q.listen(z,H);const ce=new u.$qe;return(0,A.$Bh)(0).then(()=>L=!0).then(()=>ce.input=q.listen(z,H)),ce.event}}}class T{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const z of L.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await u.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$ii=T;var U;(function(q){function L(V,le,Y){const C=V,F=Y&&Y.disableMarshalling,_=new Map;for(const B in C)H(B)&&_.set(B,u.Event.buffer(C[B],!0,void 0,le));return new class{listen(B,Z,x){const ee=_.get(Z);if(ee)return ee;const G=C[Z];if(typeof G=="function"){if(ce(Z))return G.call(C,x);if(H(Z))return _.set(Z,u.Event.buffer(C[Z],!0,void 0,le)),_.get(Z)}throw new k.$bb(`Event not found: ${Z}`)}call(B,Z,x){const ee=C[Z];if(typeof ee=="function"){if(!F&&Array.isArray(x))for(let ue=0;ue<x.length;ue++)x[ue]=(0,d.$0h)(x[ue]);let G=ee.apply(C,x);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new k.$bb(`Method not found: ${Z}`)}}}q.fromService=L;function z(V,le){const Y=le&&le.disableMarshalling;return new Proxy({},{get(C,F){if(typeof F=="string")return le?.properties?.has(F)?le.properties.get(F):ce(F)?function(_){return V.listen(F,_)}:H(F)?V.listen(F):async function(..._){let B;le&&!(0,v.$jg)(le.context)?B=[le.context,..._]:B=_;const Z=await V.call(F,B);return Y?Z:(0,d.$0h)(Z)};throw new k.$bb(`Property not found: ${String(F)}`)}})}q.toService=z;function H(V){return V[0]==="o"&&V[1]==="n"&&p.$Af(V.charCodeAt(2))}function ce(V){return/^onDynamic/.test(V)&&p.$Af(V.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const L=q.toString();if(L!=="[object Object]")return L}return q}function ae(q){return Array.isArray(q)?q.map(te):te(q)}function K(q,L,z,H,ce,V,le){le=ae(le);const Y=ie[ce],C=Y[H%Y.length];let F=[`%c[${q}]%c[${String(L).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(V)?(F=F.concat(le),F.push(")")):F.push(le),console.log.apply(console,F)}class J{constructor(L,z){this.d=L,this.f=z,this.a=0,this.b=0}logOutgoing(L,z,H,ce,V){this.b+=L,K(this.d,this.b,L,z,H,ce,V)}logIncoming(L,z,H,ce,V){this.a+=L,K(this.f,this.a,L,z,H,ce,V)}}e.$ji=J}),define(re[159],oe([0,1,17,3,44]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qW=e.$pW=void 0;class R{constructor(u){this.a=u,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$Je.wrap(c.data):n.$Je.alloc(0)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}e.$pW=R;class j extends S.$fi{constructor(u,c){const d=new R(u);super(d,c),this.b=d}dispose(){this.b.disconnect(),super.dispose()}}e.$qW=j}),define(re[113],oe([0,1,17,3,2,44]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var j;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(j||(e.SocketDiagnosticsEventType=j={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let l=0;function m(D,I){if(!o.has(D)){const O=String(++l);o.set(D,O)}return o.get(D)}function P(D,I,O,M){if(!i.enableDiagnostics)return;const W=m(D,I);if(M instanceof n.$Je||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const N=n.$Je.alloc(M.byteLength);N.set(M),i.records.push({timestamp:Date.now(),id:W,label:I,type:O,buff:N})}else i.records.push({timestamp:Date.now(),id:W,label:I,type:O,data:M})}i.traceSocketEvent=P})(k||(e.SocketDiagnostics=k={}));var u;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u||(e.SocketCloseEventType=u={}));let c=null;function d(){return c||(c=n.$Je.alloc(0)),c}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,l){if(o===0)return d();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const I=this.a[0];return l&&(this.a.shift(),this.b-=o),I}if(this.a[0].byteLength>o){const I=this.a[0].slice(0,o);return l&&(this.a[0]=this.a[0].slice(o),this.b-=o),I}const m=n.$Je.alloc(o);let P=0,D=0;for(;o>0;){const I=this.a[D];if(I.byteLength>o){const O=I.slice(0,o);m.set(O,P),P+=o,l&&(this.a[D]=I.slice(o),this.b-=o),o-=o}else m.set(I,P),P+=I.byteLength,l?(this.a.shift(),this.b-=I.byteLength):D++,o-=I.byteLength}return m}}e.$ki=p;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function $(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class y{constructor(o,l,m,P){this.type=o,this.id=l,this.ack=m,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends S.$Uc{constructor(o){super(),this.f=this.B(new A.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new p,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,P=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new y(m,P,D,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$Je.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:$(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(l,o.data)}g(o,l){const m=this.f===0;return this.d.push(o,l),this.f+=o.byteLength+l.byteLength,m}h(){const o=n.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,l){this.g(o,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class g extends S.$Uc{constructor(o){super(),this.f=new A.$he,this.onMessage=this.f.event,this.g=new A.$he,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new b(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new y(1,0,0,o))}}e.$li=g;class h extends R.$fi{static fromSocket(o,l){return new h(new g(o),l)}get onDidDispose(){return this.b.onDidDispose}constructor(o,l,m=null){super(o,l,m),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$mi=h;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$ni=E;class a{constructor(o){this.data=o,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let o=0,l=this.a;for(;l;)l=l.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let l=0,m=this.a;for(;m;)o[l++]=m.data,m=m.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const l=new a(o);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const o=Date.now();for(let l=0;l<r.a;l++)this.c[l]=o-1e3*l;setInterval(()=>{for(let l=r.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),l=(1+r.a)*1e3;let m=0;for(let P=0;P<r.a;P++)o-this.c[P]<=l&&m++;return 1-m/r.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??r.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Tc,this.o=o.socket,this.p=this.r.add(new b(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new y(5,0,0,d());this.p.write(o),this.p.flush()}sendPause(){const o=new y(7,0,0,d());this.p.write(o)}sendResume(){const o=new y(8,0,0,d());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,l){this.a=!0,this.r.dispose(),this.r=new S.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new b(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new y(3,0,this.h,d());this.p.write(o);const l=this.b.toArray();for(let m=0,P=l.length;m<P;m++)this.p.write(l[m]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const l=this.b.peek();if(l&&l.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new y(6,0,0,d())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let m=0,P=l.length;m<P;m++)this.p.write(l[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const l=++this.c;this.h=this.g;const m=new y(1,l,this.h,o);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(o){const l=new y(2,0,0,o);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),l=Date.now()-o.writtenTime,m=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(l>=2e4&&m>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:m});return}const D=Math.max(2e4-l,2e4-m,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new y(3,0,this.h,d());this.p.write(o)}D(){this.h=this.g;const o=new y(9,0,this.h,d());this.p.write(o)}}e.$oi=s}),define(re[37],oe([0,1,14,15,13]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mW=void 0;class R{constructor(){this.a=new WeakMap}on(k,u){const c=(d,...p)=>{this.b(k,d)&&u(d,...p)};return this.a.set(u,c),n.ipcMain.on(k,c),this}once(k,u){return n.ipcMain.once(k,(c,...d)=>{this.b(k,c)&&u(c,...d)}),this}handle(k,u){return n.ipcMain.handle(k,(c,...d)=>this.b(k,c)?u(c,...d):Promise.reject(`Invalid channel '${k}' or sender for ipcMain.handle() usage.`)),this}removeHandler(k){return n.ipcMain.removeHandler(k),this}removeListener(k,u){const c=this.a.get(u);return c&&(n.ipcMain.removeListener(k,c),this.a.delete(u)),this}b(k,u){if(!k||!k.startsWith("vscode:"))return(0,A.$1)(`Refused to handle ipcMain event for channel '${k}' because the channel is unknown.`),!1;const c=u.senderFrame,d=c.url;if(!d||d==="about:blank")return!0;let p="unknown";try{p=new URL(d).host}catch{return(0,A.$1)(`Refused to handle ipcMain event for channel '${k}' because of a malformed URL '${d}'.`),!1}return p!==S.$Tg?((0,A.$1)(`Refused to handle ipcMain event for channel '${k}' because of a bad origin of '${p}'.`),!1):c.parent!==null?((0,A.$1)(`Refused to handle ipcMain event for channel '${k}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.$mW=new R}),define(re[160],oe([0,1,14,37,148]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nW=R;function R(){A.$mW.on(S.$kW,(k,u,c,d,p)=>{const v=j(k,d,c);v.popup({x:p?p.x:void 0,y:p?p.y:void 0,positioningItem:p?p.positioningItem:void 0,callback:()=>{v&&k.sender.send(S.$lW,u)}})})}function j(k,u,c){const d=new n.Menu;return c.forEach(p=>{let v;p.type==="separator"?v=new n.MenuItem({type:p.type}):Array.isArray(p.submenu)?v=new n.MenuItem({submenu:j(k,u,p.submenu),label:p.label}):v=new n.MenuItem({label:p.label,type:p.type,accelerator:p.accelerator,checked:p.checked,enabled:p.enabled,visible:p.visible,click:($,f,y)=>k.sender.send(u,p.id,y)}),d.append(v)}),d}}),define(re[161],oe([0,1,37,17,3,2,44,149]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tW=void 0;function u(d,p){const v=S.Event.fromNodeEventEmitter(n.$mW,p,(f,y)=>({event:f,message:y})),$=S.Event.filter(v,({event:f})=>f.sender.id===d);return S.Event.map($,({message:f})=>f&&A.$Je.wrap(f))}class c extends j.$ei{static{this.b=new Map}static d(){const p=S.Event.fromNodeEventEmitter(n.$mW,"vscode:hello",({sender:v})=>v);return S.Event.map(p,v=>{const $=v.id;c.b.get($)?.dispose();const y=new S.$he;c.b.set($,(0,R.$Sc)(()=>y.fire()));const w=u($,"vscode:message"),b=S.Event.any(S.Event.signal(u($,"vscode:disconnect")),y.event);return{protocol:new k.$sW(v,w),onDidClientDisconnect:b}})}constructor(){super(c.d())}}e.$tW=c}),define(re[114],oe([0,1,37,3,33,159]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uW=void 0,e.$vW=k;class j extends R.$qW{constructor(c,d){super({addEventListener:(p,v)=>c.addListener(p,v),removeEventListener:(p,v)=>c.removeListener(p,v),postMessage:p=>c.postMessage(p),start:()=>c.start(),close:()=>c.close()},d)}}e.$uW=j;async function k(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,S.$Wg)();u.webContents.send("vscode:createMessageChannel",c);const d=A.Event.fromNodeEventEmitter(n.$mW,"vscode:createMessageChannelResult",(v,$)=>({nonce:$,port:v.ports[0]})),{port:p}=await A.Event.toPromise(A.Event.once(A.Event.filter(d,v=>v.nonce===c)));return p}}),define(re[162],oe([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=void 0;class f extends $.$ci{constructor(b){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",g=>S.$Je.wrap(Buffer.from(g,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$6q=f;class y{constructor(b,g){this.i=b,this.j=g,this.c=new Set,this.g=new Map,this.h=new u.$he,this.onDidProcessExit=this.h.event;const h=g&&g.timeout?g.timeout:6e4;this.b=new A.$xh(h),this.d=null,this.f=null}getChannel(b){const g=this;return{call(h,E,a){return g.k(b,h,E,a)},listen(h,E){return g.l(b,h,E)}}}k(b,g,h,E=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const a=this.n(b),t=(0,A.$nh)(i=>a.call(g,h,i)),r=E.onCancellationRequested(()=>t.cancel()),s=(0,c.$Sc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{r.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(b,g,h){if(!this.b)return u.Event.None;this.b.cancel();let E;const a=new u.$he({onWillAddFirstListener:()=>{E=this.n(b).listen(g,h)(a.fire,a),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,d.$7n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,v.$rm)(g.env),this.d=(0,n.fork)(this.i,b,g);const h=new u.$he,a=u.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,j.$2q)(l)){(0,j.log)(l,`IPC Library: ${this.j.serverName}`);return}h.fire(S.$Je.wrap(Buffer.from(l,"base64")))}),t=this.j.useQueue?(0,p.$tm)(this.d):this.d,r=l=>this.d&&this.d.connected&&t.send(l.buffer.toString("base64")),s=h.event,i={send:r,onMessage:s};this.f=new $.$di(i);const o=()=>this.o();process.once("exit",o),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,m)=>{process.removeListener("exit",o),a.dispose(),this.c.forEach(P=>(0,c.$Pc)(P)),this.c.clear(),l!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+m),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:m})})}return this.f}n(b){let g=this.g.get(b);return g||(g=this.m.getChannel(b),this.g.set(b,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7q=y}),define(re[115],oe([0,1,8,3,2,77,12]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.StorageState=e.StorageHint=void 0,e.$2p=u;var k;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function u(v){const $=v;return $?.changed instanceof Map||$?.deleted instanceof Set}var c;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(c||(e.StorageState=c={}));class d extends S.$Uc{static{this.a=100}constructor($,f=Object.create(null)){super(),this.r=$,this.s=f,this.b=this.B(new A.$ke),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$yh(d.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((f,y)=>this.w(y,f)),$.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w($,f){if(this.c===c.Closed)return;let y=!1;(0,j.$jg)(f)?y=this.f.delete($):this.f.get($)!==f&&(this.f.set($,f),y=!0),y&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,f){const y=this.f.get($);return(0,j.$jg)(y)?f:y}getBoolean($,f){const y=this.get($);return(0,j.$jg)(y)?f:y==="true"}getNumber($,f){const y=this.get($);return(0,j.$jg)(y)?f:parseInt(y,10)}getObject($,f){const y=this.get($);return(0,j.$jg)(y)?f:(0,R.$9h)(y)}async set($,f,y=!1){if(this.c===c.Closed)return;if((0,j.$jg)(f))return this.delete($,y);const w=(0,j.$cg)(f)||Array.isArray(f)?(0,R.$8h)(f):String(f);if(this.f.get($)!==w)return this.f.set($,w),this.j.set($,w),this.h.delete($),this.b.fire({key:$,external:y}),this.D()}async delete($,f=!1){if(!(this.c===c.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:f}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===c.Closed||this.m))return this.D($)}async D($){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$3p=d;class p{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((f,y)=>this.a.set(y,f)),$.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$4p=p}),define(re[163],oe([0,1,8,3,32,9,21]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RW=void 0;class k{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return A.Event.None}static{this.a=2e3}static{this.b=256}constructor(d,p=Object.create(null)){this.g=d,this.h=p,this.c=(0,R.$nc)(this.g),this.d=new u(this.h.logging),this.f=this.n(this.g)}async getItems(){const d=await this.f,p=new Map;return(await this.s(d,"SELECT * FROM ItemTable")).forEach($=>p.set($.key,$.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${p.size} rows`),p}async updateItems(d){const p=await this.f;return this.j(p,d)}j(d,p){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${p.insert?(0,S.$yc)(p.insert):"0"}), delete(${p.delete?(0,S.$zc)(p.delete):"0"})`),this.t(d,()=>{const v=p.insert,$=p.delete;if(v&&v.size>0){const f=[];f.push([]);let y=0;v.forEach((w,b)=>{let g=f[y];g.length>k.b&&(y++,g=[],f.push(g)),g.push(b,w)}),f.forEach(w=>{this.u(d,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,b=>b.run(w),()=>{const b=[];let g=0;return v.forEach((h,E)=>{b.push(E),g+=h.length}),`Keys: ${b.join(", ")} Length: ${g}`})})}if($&&$.size){const f=[];f.push([]);let y=0;$.forEach(w=>{let b=f[y];b.length>k.b&&(y++,b=[],f.push(b)),b.push(w)}),f.forEach(w=>{this.u(d,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,b=>b.run(w),()=>{const b=[];return $.forEach(g=>{b.push(g)}),`Keys: ${b.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const d=await this.f;return this.q(d,"VACUUM")}async close(d){this.d.trace(`[storage ${this.c}] close()`);const p=await this.f;return this.k(p,d)}k(d,p){return new Promise((v,$)=>{d.db.close(f=>(f&&this.o(d,`[storage ${this.c}] close(): ${f}`),this.g===k.IN_MEMORY_PATH?v():!d.isErroneous&&!d.isInMemory?this.l().then(v,y=>(this.d.error(`[storage ${this.c}] backup(): ${y}`),v())):typeof p=="function"?j.Promises.unlink(this.g).then(()=>this.p(this.g).then(y=>{const w=()=>this.k(y,void 0);return this.j(y,{insert:p()}).then(()=>w(),b=>(w(),Promise.reject(b)))})).then(v,$):$(f||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const d=this.m(this.g);return j.Promises.copy(this.g,d,{preserveSymlinks:!1})}m(d){return`${d}.backup`}async checkIntegrity(d){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${d})`);const p=await this.f,v=await this.r(p,d?"PRAGMA integrity_check":"PRAGMA quick_check"),$=d?v.integrity_check:v.quick_check;return p.isErroneous?`${$} (last error: ${p.lastError})`:p.isInMemory?`${$} (in-memory!)`:$}async n(d,p=!0){this.d.trace(`[storage ${this.c}] open(${d}, retryOnBusy: ${p})`);try{return await this.p(d)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&p)return await(0,n.$Bh)(k.a),this.n(d,!1);try{await j.Promises.unlink(d);try{await j.Promises.rename(this.m(d),d,!1)}catch{}return await this.p(d)}catch($){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${$}`),this.p(k.IN_MEMORY_PATH)}}}o(d,p){d.isErroneous=!0,d.lastError=p,this.d.error(p)}p(d){return new Promise((p,v)=>{new Promise(($,f)=>{Q(["@vscode/sqlite3"],$,f)}).then($=>{const f={db:new(this.d.isTracing?$.verbose().Database:$.Database)(d,y=>y?f.db&&y.code!=="SQLITE_CANTOPEN"?f.db.close(()=>v(y)):v(y):this.q(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>p(f),w=>f.db.close(()=>v(w)))),isInMemory:d===k.IN_MEMORY_PATH};f.db.on("error",y=>this.o(f,`[storage ${this.c}] Error (event): ${y}`)),this.d.isTracing&&f.db.on("trace",y=>this.d.trace(`[storage ${this.c}] Trace (event): ${y}`))},v)})}q(d,p){return new Promise((v,$)=>{d.db.exec(p,f=>f?(this.o(d,`[storage ${this.c}] exec(): ${f}`),$(f)):v())})}r(d,p){return new Promise((v,$)=>{d.db.get(p,(f,y)=>f?(this.o(d,`[storage ${this.c}] get(): ${f}`),$(f)):v(y))})}s(d,p){return new Promise((v,$)=>{d.db.all(p,(f,y)=>f?(this.o(d,`[storage ${this.c}] all(): ${f}`),$(f)):v(y))})}t(d,p){return new Promise((v,$)=>{d.db.serialize(()=>{d.db.run("BEGIN TRANSACTION"),p(),d.db.run("END TRANSACTION",f=>f?(this.o(d,`[storage ${this.c}] transaction(): ${f}`),$(f)):v())})})}u(d,p,v,$){const f=d.db.prepare(p),y=w=>{this.o(d,`[storage ${this.c}] prepare(): ${w} (${p}). Details: ${$()}`)};f.on("error",y),v(f),f.finalize(w=>{w&&y(w),f.removeListener("error",y)})}}e.$RW=k;class u{static{this.a="VSCODE_TRACE_STORAGE"}constructor(d){d&&typeof d.logTrace=="function"&&process.env[u.a]&&(this.b=d.logTrace),d&&typeof d.logError=="function"&&(this.c=d.logError)}get isTracing(){return!!this.b}trace(d){this.b?.(d)}error(d){this.c?.(d)}}}),define(re[164],oe([11,10]),function(Q,e){return Q.create("vs/code/electron-main/app",e)}),define(re[165],oe([11,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[166],oe([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(re[167],oe([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(re[168],oe([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/common/dialogs",e)}),define(re[169],oe([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(re[170],oe([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(re[171],oe([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(re[172],oe([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[173],oe([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[174],oe([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[175],oe([11,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[176],oe([11,10]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(re[177],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(re[178],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(re[179],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(re[180],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(re[181],oe([11,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[182],oe([11,10]),function(Q,e){return Q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(re[183],oe([11,10]),function(Q,e){return Q.create("vs/platform/log/common/log",e)}),define(re[184],oe([11,10]),function(Q,e){return Q.create("vs/platform/menubar/electron-main/menubar",e)}),define(re[185],oe([11,10]),function(Q,e){return Q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(re[186],oe([11,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(re[187],oe([11,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(re[188],oe([11,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[189],oe([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[190],oe([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[191],oe([11,10]),function(Q,e){return Q.create("vs/platform/update/common/update.config.contribution",e)}),define(re[192],oe([11,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[193],oe([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(re[194],oe([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(re[195],oe([11,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(re[196],oe([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(re[197],oe([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(re[198],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fb=n,e.$_fb=A;function n(S){return S&&S.hasOwnProperty("folderUri")}function A(S){return S&&S.hasOwnProperty("workspace")}}),define(re[199],oe([0,1,7]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=A,e.$Kcc=S,e.$Lcc=R;function A(j){return typeof j?.backupFolder=="string"}function S(j){let k=[];try{Array.isArray(j.workspaces)&&(k=j.workspaces.map(u=>({workspace:{id:u.id,configPath:n.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return k}function R(j){let k=[];try{Array.isArray(j.folders)&&(k=j.folders.map(u=>({folderUri:n.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return k}}),define(re[200],oe([0,1,15,167]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var S;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(S||(e.TokenType=S={}));function R(...c){switch(c.length){case 1:return(0,A.localize)(0,null,c[0]);case 2:return(0,A.localize)(1,null,c[0],c[1]);case 3:return(0,A.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,A.localize)(3,null),k=(0,A.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return d.isTripleEq?"===":"==";case 4:return d.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return d.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return d.lexeme;case 18:return d.lexeme;case 19:return d.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const p=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:p})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const p=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:p})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const p=this.d,v=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:v};this.g.push({offset:p,lexeme:v,additionalInfo:d}),this.f.push($)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const p=this.c.substring(this.d,this.e),v=u.b.get(p);v?this.k(v):this.f.push({type:17,lexeme:p,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,p=!1,v=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(k);return}const f=this.c.charCodeAt(d);if(p)p=!1;else if(f===47&&!v){d++;break}else f===91?v=!0:f===92?p=!0:f===93&&(v=!1);d++}for(;d<this.c.length&&u.a.has(this.c.charCodeAt(d));)d++;this.e=d;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=u}),define(re[201],oe([0,1,3,2]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=void 0;class S{constructor(){this.a=new n.$he,this.b=new n.$he,this.c=new n.$he,this.d=new n.$he}static{this.ChannelName="extensionhostdebugservice"}call(k,u,c){switch(u){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(k,u,c){switch(u){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$No=S;class R extends A.$Uc{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,u,c){this.b.call("attach",[k,u,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,u){this.b.call("terminate",[k,u])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,u){return this.b.call("openExtensionDevelopmentHostWindow",[k,u])}}e.$Oo=R}),define(re[202],oe([0,1,151,51,13,9,36,19,7]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=void 0,e.$$m=d,e.$_m=p,e.$9m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,R.$mc)(S.$Ug.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,R.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,k.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,n.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$jc)(this.userDataPath,"logs",$)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$bh)(u.URI.file((0,R.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=j.env.VSCODE_PORTABLE;return $?u.URI.file((0,R.$jc)($,"argv.json")):(0,k.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,R.$kc)($):(0,R.$hc)((0,R.$jc)(S.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?u.URI.file((0,R.$kc)($)):u.URI.file((0,R.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,R.$kc)($);const f=j.env.VSCODE_EXTENSIONS;if(f)return f;const y=j.env.VSCODE_PORTABLE;return y?(0,R.$jc)(y,"extensions"):(0,k.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(f=>/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,R.$hc)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?u.URI.parse($):u.URI.file((0,R.$hc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$9m.test($))}get extensionLogLevel(){const $=[];for(const f of this.args.log||[]){const y=e.$9m.exec(f);y&&y[1]&&y[2]&&$.push([y[1],y[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,k.$bh)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=j.env.VSCODE_PORTABLE;return $?u.URI.file((0,R.$jc)($,"policy.json")):(0,k.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,f,y){this.a=$,this.b=f,this.c=y,this.editSessionId=this.args.editSessionId}}e.$0m=c,ke([A.$5h],c.prototype,"appRoot",null),ke([A.$5h],c.prototype,"userHome",null),ke([A.$5h],c.prototype,"userDataPath",null),ke([A.$5h],c.prototype,"appSettingsHome",null),ke([A.$5h],c.prototype,"tmpDir",null),ke([A.$5h],c.prototype,"cacheHome",null),ke([A.$5h],c.prototype,"stateResource",null),ke([A.$5h],c.prototype,"userRoamingDataHome",null),ke([A.$5h],c.prototype,"userDataSyncHome",null),ke([A.$5h],c.prototype,"sync",null),ke([A.$5h],c.prototype,"machineSettingsResource",null),ke([A.$5h],c.prototype,"workspaceStorageHome",null),ke([A.$5h],c.prototype,"localHistoryHome",null),ke([A.$5h],c.prototype,"keyboardLayoutResource",null),ke([A.$5h],c.prototype,"argvResource",null),ke([A.$5h],c.prototype,"isExtensionDevelopment",null),ke([A.$5h],c.prototype,"untitledWorkspacesHome",null),ke([A.$5h],c.prototype,"builtinExtensionsPath",null),ke([A.$5h],c.prototype,"extensionsPath",null),ke([A.$5h],c.prototype,"extensionDevelopmentLocationURI",null),ke([A.$5h],c.prototype,"extensionDevelopmentKind",null),ke([A.$5h],c.prototype,"extensionTestsLocationURI",null),ke([A.$5h],c.prototype,"debugExtensionHost",null),ke([A.$5h],c.prototype,"logLevel",null),ke([A.$5h],c.prototype,"extensionLogLevel",null),ke([A.$5h],c.prototype,"serviceMachineIdResource",null),ke([A.$5h],c.prototype,"disableTelemetry",null),ke([A.$5h],c.prototype,"disableWorkspaceTrust",null),ke([A.$5h],c.prototype,"useInMemorySecretStorage",null),ke([A.$5h],c.prototype,"policyFile",null);function d(v,$){return p(v["inspect-extensions"],v["inspect-brk-extensions"],5870,$,v.debugId,v.extensionEnvironment)}function p(v,$,f,y,w,b){const h=Number($||v)||(y?null:f),E=h?!!$:!1;let a;if(b)try{a=JSON.parse(b)}catch{}return{port:h,break:E,debugId:w,env:a}}}),define(re[116],oe([0,1,313,4,170]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0,e.$xm=k,e.$ym=c,e.$zm=$,e.$Am=f;const R={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$vm=["tunnel","serve-web"],e.$wm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(y,w,b=j){const g=y.find(l=>l.length>0&&l[0]!=="-"),h={},E=["_"],a=[],t={};let r;for(const l in w){const m=w[l];m.type==="subcommand"?l===g&&(r=m):(m.alias&&(h[l]=m.alias),m.type==="string"||m.type==="string[]"?(E.push(l),m.deprecates&&E.push(...m.deprecates)):m.type==="boolean"&&(a.push(l),m.deprecates&&a.push(...m.deprecates)),m.global&&(t[l]=m))}if(r&&g){const l=t;for(const I in r.options)l[I]=r.options[I];const m=y.filter(I=>I!==g),P=b.getSubcommandReporter?b.getSubcommandReporter(g):void 0,D=k(m,l,P);return{[g]:D,_:[]}}const s=n(y,{string:E,boolean:a,alias:h}),i={},o=s;i._=s._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(const l in w){const m=w[l];if(m.type==="subcommand")continue;m.alias&&delete o[m.alias];let P=o[l];if(m.deprecates)for(const D of m.deprecates)o.hasOwnProperty(D)&&(P||(P=o[D],P&&b.onDeprecatedOption(D,m.deprecationMessage||(0,S.localize)(39,null,l))),delete o[D]);if(typeof P<"u"){if(m.type==="string[]"){if(Array.isArray(P)||(P=[P]),!m.allowEmptyValue){const D=P.filter(I=>I.length>0);D.length!==P.length&&(b.onEmptyValue(l),P=D.length>0?D:void 0)}}else m.type==="string"&&(Array.isArray(P)?(P=P.pop(),b.onMultipleValues(l,P)):!P&&!m.allowEmptyValue&&(b.onEmptyValue(l),P=void 0));i[l]=P,m.deprecationMessage&&b.onDeprecatedOption(l,m.deprecationMessage)}delete o[l]}for(const l in o)b.onUnknownOption(l);return i}function u(y,w){let b="";return w.args&&(Array.isArray(w.args)?b=` <${w.args.join("> <")}>`:b=` <${w.args}>`),w.alias?`-${w.alias} --${y}${b}`:`--${y}${b}`}function c(y,w){const b=[];for(const g in y){const h=y[g],E=u(g,h);b.push([E,h.description])}return d(b,w)}function d(y,w){const g=y.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(w-g<25)return y.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const h=w-g-1,E=[];for(const a of y){const t=a[0],r=v(a[1],h),s=p(g-t.length-2);E.push("  "+t+s+r[0]);for(let i=1;i<r.length;i++)E.push(p(g)+r[i])}return E}function p(y){return" ".repeat(y)}function v(y,w){const b=[];for(;y.length;){const g=y.length<w?y.length:y.lastIndexOf(" ",w),h=y.slice(0,g).trim();y=y.slice(g),b.push(h)}return b}function $(y,w,b,g,h){const E=process.stdout.isTTY&&process.stdout.columns||80,a=h?.noInputFiles!==!0?`[${(0,S.localize)(40,null)}...]`:"",t=[`${y} ${b}`];t.push(""),t.push(`${(0,S.localize)(41,null)}: ${w} [${(0,S.localize)(42,null)}]${a}`),t.push(""),h?.noPipe!==!0&&(A.$i?t.push((0,S.localize)(43,null,w)):t.push((0,S.localize)(44,null,w)),t.push(""));const r={},s=[];for(const i in g){const o=g[i];if(o.type==="subcommand")o.description&&s.push({command:i,description:o.description});else if(o.description&&o.cat){let l=r[o.cat];l||(r[o.cat]=l={}),l[i]=o}}for(const i in r){const o=i,l=r[o];l&&(t.push(R[o]),t.push(...c(l,E)),t.push(""))}return s.length&&(t.push((0,S.localize)(45,null)),t.push(...d(s.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}function f(y,w){return`${y||(0,S.localize)(46,null)}
${w||(0,S.localize)(47,null)}
${process.arch}`}}),define(re[203],oe([0,1,88,201,116]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class R extends A.$No{constructor(k){super(),this.f=k}call(k,u,c){return u==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(k,u,c)}async g(k,u){const c=(0,S.$xm)(k,S.$wm);c.debugRenderer=u;const d=c.extensionDevelopmentPath;if(!d)return{success:!1};const[p]=await this.f.openExtensionDevelopmentHostWindow(d,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!u)return{success:!0};const v=p.win;if(!v)return{success:!0};const $=v.webContents.debugger;let f=$.isAttached()?1/0:0;const y=(0,n.createServer)(w=>{f++===0&&$.attach();let b=!1;const g=a=>{b||w.write(JSON.stringify(a)+"\0")},h=(a,t,r,s)=>g({method:t,params:r,sessionId:s});v.on("close",()=>{$.removeListener("message",h),w.end(),b=!0}),$.addListener("message",h);let E=Buffer.alloc(0);w.on("data",a=>{E=Buffer.concat([E,a]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let r;try{const s=E.slice(0,t).toString("utf8");E=E.slice(t+1),r=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}$.sendCommand(r.method,r.params,r.sessionId).then(s=>g({id:r.id,sessionId:r.sessionId,result:s})).catch(s=>g({id:r.id,sessionId:r.sessionId,error:{code:0,message:s.message}}))}}),w.on("error",a=>{console.error("error on cdp pipe:",a)}),w.on("close",()=>{b=!0,--f===0&&$.detach()})});return await new Promise(w=>y.listen(0,w)),v.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$ldc=R}),define(re[64],oe([0,1,314,171,116]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=k,e.$Cm=u,e.$Dm=c,e.$Em=d;function R(p,v){const $=(h,E)=>{console.warn((0,A.localize)(0,null,h,E))},f=h=>{console.warn((0,A.localize)(1,null,h))},y=(h,E)=>{console.warn((0,A.localize)(2,null,h,E))},w=h=>({onUnknownOption:E=>{S.$vm.includes(h)||console.warn((0,A.localize)(3,null,E,h))},onMultipleValues:$,onEmptyValue:f,onDeprecatedOption:y,getSubcommandReporter:S.$vm.includes(h)?w:void 0}),b={onUnknownOption:h=>{console.warn((0,A.localize)(4,null,h))},onMultipleValues:$,onEmptyValue:f,onDeprecatedOption:y,getSubcommandReporter:w},g=(0,S.$xm)(p,S.$wm,v?b:void 0);return g.goto&&g._.forEach(h=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,A.localize)(5,null))),g}function j(p){const v=p.findIndex($=>!/^-/.test($));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function k(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=j(v)||[]);const $=!d(process.env);return R(v,$)}function u(p){let[,,...v]=p;return process.env.VSCODE_DEV&&(v=j(v)||[]),R(v,!0)}function c(p,...v){const $=p.indexOf("--");return $===-1?p.push(...v):p.splice($,0,...v),p}function d(p){return p.VSCODE_CLI==="1"}}),function(){"use strict";function Q(e,n,A){function S(j,k){const u=R(j,k),c=[u];return e.isAbsolute(u)||c.unshift(A),e.resolve(...c)}function R(j,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,k);const d=j["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(p,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,k)}return{getUserDataPath:S}}if(typeof define=="function")define(re[204],oe([117,26,36]),function(e,n,A){return Q(e,n,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=Q(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[91],oe([0,1,26,202,204]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=void 0,e.$bn=j,e.$cn=k;class R extends A.$0m{constructor(c,d){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,S.getUserDataPath)(c,d.nameShort)},d)}}e.$an=R;function j(u,c){return(0,A.$_m)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}function k(u,c){return(0,A.$_m)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}}),define(re[205],oe([0,1,43,26,31]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=R;function R(j){const k=(0,S.$Ig)((0,A.tmpdir)());try{return(0,n.writeFileSync)(k,""),j&&console.log(`Marker file for --wait created: ${k}`),k}catch(u){j&&console.error(`Failed to create marker file for --wait: ${u}`);return}}}),define(re[206],oe([0,1,12,173]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=S;function S(j,k,u,c){try{R(j,k,u,c)}catch(d){j.error(d?.message??d)}return k}function R(j,k,u,c){const d=(p,v,$)=>{const f=p[v];if((0,n.$ag)(f)){const y=f,w=y.length;if(w>1&&y[0]==="%"&&y[w-1]==="%"){const b=y.substr(1,w-2);let g=u[b];g===void 0&&c&&(g=c[b]);const h=typeof g=="string"?g:g?.message,E=c?.[b],a=typeof E=="string"?E:E?.message;if(!h){a||j.warn(`[${k.name}]: ${(0,A.localize)(0,null,b)}`);return}if($&&(v==="title"||v==="category")&&a&&a!==h){const t={value:h,original:a};p[v]=t}else p[v]=h}}else if((0,n.$cg)(f))for(const y in f)f.hasOwnProperty(y)&&(y==="commands"?d(f,y,!0):d(f,y,$));else if(Array.isArray(f))for(let y=0;y<f.length;y++)d(f,y,$)};for(const p in k)k.hasOwnProperty(p)&&d(k,p)}}),define(re[207],oe([0,1,19,74,175,208]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=u,e.$Np=c,e.$Op=d,e.$Pp=p,e.$Qp=v,e.$Rp=$,e.$Sp=f;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function u(b){return b=b.trim(),b==="*"||j.test(b)}function c(b){if(!u(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=b.match(j);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}function d(b){if(!b)return null;const g=b.majorBase,h=b.majorMustEqual,E=b.minorBase;let a=b.minorMustEqual;const t=b.patchBase;let r=b.patchMustEqual;b.hasCaret&&(g===0||(a=!1),r=!1);let s=0;if(b.preRelease){const i=k.exec(b.preRelease);if(i){const[,o,l,m]=i;s=Date.UTC(Number(o),Number(l)-1,Number(m))}}return{majorBase:g,majorMustEqual:h,minorBase:E,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:b.hasGreaterEquals,notBefore:s}}function p(b,g,h){let E;typeof b=="string"?E=d(c(b)):E=b;let a;g instanceof Date?a=g.getTime():typeof g=="string"&&(a=new Date(g).getTime());let t;if(typeof h=="string"?t=d(c(h)):t=h,!E||!t)return!1;const r=E.majorBase,s=E.minorBase,i=E.patchBase;let o=t.majorBase,l=t.minorBase,m=t.patchBase;const P=t.notBefore;let D=t.majorMustEqual,I=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:s>l?!0:s<l||a&&a<P?!1:i>=m:(r===1&&o===0&&(!D||!I||!O)&&(o=1,l=0,m=0,D=!0,I=!1,O=!1),r<o?!1:r>o?!D:s<l?!1:s>l?!I:i<m?!1:i>m?!O:!(a&&a<P))}function v(b,g,h,E,a){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([A.default.Error,S.localize(0,null)]),t;if(typeof E.name!="string")return t.push([A.default.Error,S.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([A.default.Error,S.localize(2,null,"version")]),t;if(!E.engines)return t.push([A.default.Error,S.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([A.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!w(E.extensionDependencies))return t.push([A.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!w(E.activationEvents))return t.push([A.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([A.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([A.default.Warning,S.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([A.default.Error,S.localize(9,null,"main")]),t;{const i=(0,n.$bh)(h,E.main);(0,n.$8g)(i,h)||t.push([A.default.Warning,S.localize(10,null,i.path,h.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([A.default.Error,S.localize(11,null,"browser")]),t;{const i=(0,n.$bh)(h,E.browser);(0,n.$8g)(i,h)||t.push([A.default.Warning,S.localize(12,null,i.path,h.path)])}}if(!R.valid(E.version))return t.push([A.default.Error,S.localize(13,null)]),t;const r=[];if(!$(b,g,E,a,r))for(const i of r)t.push([A.default.Error,i]);return t}function $(b,g,h,E,a){return E||typeof h.main>"u"&&typeof h.browser>"u"?!0:y(b,g,h.engines.vscode,a)}function f(b,g,h){return b==="*"||y(g,h,b)}function y(b,g,h,E=[]){const a=d(c(h));if(!a)return E.push(S.localize(14,null,h)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return E.push(S.localize(15,null,h)),!1}else if(!a.majorMustEqual)return E.push(S.localize(16,null,h)),!1;return p(b,g,a)?!0:(E.push(S.localize(17,null,b,h)),!1)}function w(b){if(!Array.isArray(b))return!1;for(let g=0,h=b.length;g<h;g++)if(typeof b[g]!="string")return!1;return!0}}),define(re[209],oe([0,1,17,33]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=S;async function S(R,j,k){let u=k&&k.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const d=(await j.readFile(R.serviceMachineIdResource)).value.toString();u=(0,A.$Vg)(d)?d:null}catch{u=null}if(!u){u=(0,A.$Wg)();try{await j.writeFile(R.serviceMachineIdResource,n.$Je.fromString(u))}catch{}}return k?.store("storage.serviceMachineId",u,-1,1),u}}),define(re[78],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class n{constructor(S,R=[],j=!1){this.ctor=S,this.staticArguments=R,this.supportsDelayedInstantiation=j}}e.$xi=n}),define(re[210],oe([0,1,78]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ds=R,e.$Es=j;const A=[];var S;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function R(k,u,c){u instanceof n.$xi||(u=new n.$xi(u,[],!!c)),A.push([k,u])}function j(){return A}}),define(re[211],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;class n{constructor(R,j){this.key=R,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$gr=n;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const j of this.a.values())j.outgoing.size===0&&R.push(j);return R}insertEdge(R,j){const k=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(j);k.outgoing.set(u.key,u),u.incoming.set(k.key,k)}removeNode(R){const j=this.b(R);this.a.delete(j);for(const k of this.a.values())k.outgoing.delete(j),k.incoming.delete(j)}lookupOrInsertNode(R){const j=this.b(R);let k=this.a.get(j);return k||(k=new n(j,R),this.a.set(j,k)),k}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[j,k]of this.a)R.push(`${j}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,j]of this.a){const k=new Set([R]),u=this.c(j,k);if(u)return u}}c(R,j){for(const[k,u]of R.outgoing){if(j.has(k))return[...j,k].join(" -> ");j.add(k);const c=this.c(u,j);if(c)return c;j.delete(k)}}}e.$hr=A}),define(re[6],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=S,e.$Bi=R;var n;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function k(u){return u[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=k})(n||(e._util=n={})),e.$zi=S("instantiationService");function A(j,k,u){k[n.DI_TARGET]===k?k[n.DI_DEPENDENCIES].push({id:j,index:u}):(k[n.DI_DEPENDENCIES]=[{id:j,index:u}],k[n.DI_TARGET]=k)}function S(j){if(n.serviceIds.has(j))return n.serviceIds.get(j);const k=function(u,c,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(k,u,d)};return k.toString=()=>j,n.serviceIds.set(j,k),k}function R(j){return j}}),define(re[79],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0,e.$Ddc=(0,n.$Ai)("auxiliaryWindowsMainService")}),define(re[65],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0,e.$Mcc=(0,n.$Ai)("backupMainService")}),define(re[18],oe([0,1,12,7,6]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=R,e.$9i=j,e.$0i=u,e.$$i=c,e.$_i=d,e.$aj=p,e.$bj=v,e.$cj=f,e.$dj=y,e.$ej=w,e.$7i=(0,S.$Ai)("configurationService");function R(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof A.URI)}function j(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof A.URI)}var k;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function u(b){switch(b){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function c(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function d(b,g){const h=Object.create(null);for(const E in b)p(h,E,b[E],g);return h}function p(b,g,h,E){const a=g.split("."),t=a.pop();let r=b;for(let s=0;s<a.length;s++){const i=a[s];let o=r[i];switch(typeof o){case"undefined":o=r[i]=Object.create(null);break;case"object":if(o===null){E(`Ignoring ${g} as ${a.slice(0,s+1).join(".")} is null`);return}break;default:E(`Ignoring ${g} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[t]=h}catch{E(`Ignoring ${g} as ${a.join(".")} is ${JSON.stringify(r)}`)}else E(`Ignoring ${g} as ${a.join(".")} is ${JSON.stringify(r)}`)}function v(b,g){const h=g.split(".");$(b,h)}function $(b,g){const h=g.shift();if(g.length===0){delete b[h];return}if(Object.keys(b).indexOf(h)!==-1){const E=b[h];typeof E=="object"&&!Array.isArray(E)&&($(E,g),Object.keys(E).length===0&&delete b[h])}}function f(b,g,h){function E(r,s){let i=r;for(const o of s){if(typeof i!="object"||i===null)return;i=i[o]}return i}const a=g.split("."),t=E(b,a);return typeof t>"u"?h:t}function y(b,g,h){Object.keys(g).forEach(E=>{E!=="__proto__"&&(E in b?n.$cg(b[E])&&n.$cg(g[E])?y(b[E],g[E],h):h&&(b[E]=g[E]):b[E]=g[E])})}function w(b){return b.replace(/[\[\]]/g,"")}}),define(re[118],oe([0,1,4,25,200,6,166,15]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=c,e.$zj=r,e.$Aj=s,e.$Tj=ce;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",n.$j),u.set("isLinux",n.$k),u.set("isWindows",n.$i),u.set("isWeb",n.$o),u.set("isMacNative",n.$j&&!n.$o),u.set("isEdge",n.$H),u.set("isFirefox",n.$F),u.set("isChrome",n.$E),u.set("isSafari",n.$G);function c(Y,C){if(u.get(Y)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(Y,C)}const d=Object.prototype.hasOwnProperty;var p;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const v={regexParsingWithErrorRecovery:!0},$=(0,j.localize)(0,null),f=(0,j.localize)(1,null),y=(0,j.localize)(2,null),w=(0,j.localize)(3,null),b=(0,j.localize)(4,null),g=(0,j.localize)(5,null),h=(0,j.localize)(6,null),E=(0,j.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(C=v){this.k=C,this.d=new S.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(C){if(C===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(C).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const _=this.D(),B=_.type===17?g:void 0;throw this.h.push({message:b,offset:_.offset,lexeme:S.$vj.getLexeme(_),additionalInfo:B}),a.c}return F}catch(F){if(F!==a.c)throw F;return}}l(){return this.m()}m(){const C=[this.o()];for(;this.y(16);){const F=this.o();C.push(F)}return C.length===1?C[0]:t.or(...C)}o(){const C=[this.s()];for(;this.y(15);){const F=this.s();C.push(F)}return C.length===1?C[0]:t.and(...C)}s(){if(this.y(2)){const C=this.D();switch(C.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,w),F?.negate()}case 17:return this.z(),M.create(C.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.D();switch(C.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,w),F}case 17:{const F=C.lexeme;if(this.z(),this.y(9)){const B=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),B.type!==10)throw this.B("REGEX",B);const Z=B.lexeme,x=Z.lastIndexOf("/"),ee=x===Z.length-1?void 0:this.w(Z.substring(x+1));let G;try{G=new RegExp(Z.substring(1,x),ee)}catch{throw this.B("REGEX",B)}return te.create(F,G)}switch(B.type){case 10:case 19:{const Z=[B.lexeme];this.z();let x=this.D(),ee=0;for(let Ee=0;Ee<B.lexeme.length;Ee++)B.lexeme.charCodeAt(Ee)===40?ee++:B.lexeme.charCodeAt(Ee)===41&&ee--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let Ee=0;Ee<x.lexeme.length;Ee++)x.lexeme.charCodeAt(Ee)===40?ee++:B.lexeme.charCodeAt(Ee)===41&&ee--}if(ee<0)break;Z.push(S.$vj.getLexeme(x)),this.z(),x=this.D()}const G=Z.join(""),ue=G.lastIndexOf("/"),fe=ue===G.length-1?void 0:this.w(G.substring(ue+1));let we;try{we=new RegExp(G.substring(1,ue),fe)}catch{throw this.B("REGEX",B)}return t.regex(F,we)}case 18:{const Z=B.lexeme;this.z();let x=null;if(!(0,A.$$e)(Z)){const ee=Z.indexOf("/"),G=Z.lastIndexOf("/");if(ee!==G&&ee>=0){const ue=Z.slice(ee+1,G),fe=Z[G+1]==="i"?"i":"";try{x=new RegExp(ue,fe)}catch{throw this.B("REGEX",B)}}}if(x===null)throw this.B("REGEX",B);return te.create(F,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const B=this.u();return t.notIn(F,B)}switch(this.D().type){case 3:{this.z();const B=this.u();if(this.x().type===18)return t.equals(F,B);switch(B){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,B)}}case 4:{this.z();const B=this.u();if(this.x().type===18)return t.notEquals(F,B);switch(B){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,B)}}case 5:return this.z(),U.create(F,this.u());case 6:return this.z(),ie.create(F,this.u());case 7:return this.z(),N.create(F,this.u());case 8:return this.z(),T.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:h,offset:C.offset,lexeme:"",additionalInfo:E}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const C=this.D();switch(C.type){case 17:case 18:return this.z(),C.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(C){return C.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(C){return this.C(C)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(C,F){if(this.C(C))return this.z();throw this.B(F,this.D())}B(C,F,_){const B=(0,j.localize)(8,null,C,S.$vj.getLexeme(F)),Z=F.offset,x=S.$vj.getLexeme(F);return this.h.push({message:B,offset:Z,lexeme:x,additionalInfo:_}),a.c}C(C){return this.D().type===C}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$xj=a;class t{static false(){return o.INSTANCE}static true(){return l.INSTANCE}static has(C){return m.create(C)}static equals(C,F){return P.create(C,F)}static notEquals(C,F){return O.create(C,F)}static regex(C,F){return te.create(C,F)}static in(C,F){return D.create(C,F)}static notIn(C,F){return I.create(C,F)}static not(C){return M.create(C)}static and(...C){return J.create(C,null,!0)}static or(...C){return q.create(C,null,!0)}static greater(C,F){return N.create(C,F)}static greaterEquals(C,F){return T.create(C,F)}static smaller(C,F){return U.create(C,F)}static smallerEquals(C,F){return ie.create(C,F)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(C){return C==null?void 0:this.c.parse(C)}}e.$yj=t;function r(Y){const C=new a({regexParsingWithErrorRecovery:!1});return Y.map(F=>(C.parse(F),C.lexingErrors.length>0?C.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,j.localize)(9,null,_.additionalInfo):(0,j.localize)(10,null),offset:_.offset,length:_.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(Y,C){const F=Y?Y.substituteConstants():void 0,_=C?C.substituteConstants():void 0;return!F&&!_?!0:!F||!_?!1:F.equals(_)}function i(Y,C){return Y.cmp(C)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return l.INSTANCE}}e.$Bj=o;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return o.INSTANCE}}e.$Cj=l;class m{static create(C,F=null){const _=u.get(C);return typeof _=="boolean"?_?l.INSTANCE:o.INSTANCE:new m(C,F)}constructor(C,F){this.key=C,this.c=F,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:z(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=u.get(this.key);return typeof C=="boolean"?C?l.INSTANCE:o.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Dj=m;class P{static create(C,F,_=null){if(typeof F=="boolean")return F?m.create(C,_):M.create(C,_);const B=u.get(C);return typeof B=="boolean"?F===(B?"true":"false")?l.INSTANCE:o.INSTANCE:new P(C,F,_)}constructor(C,F,_){this.c=C,this.d=F,this.f=_,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=u.get(this.c);if(typeof C=="boolean"){const F=C?"true":"false";return this.d===F?l.INSTANCE:o.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ej=P;class D{static create(C,F){return new D(C,F)}constructor(C,F){this.d=C,this.f=F,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:H(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const F=C.getValue(this.f),_=C.getValue(this.d);return Array.isArray(F)?F.includes(_):typeof _=="string"&&typeof F=="object"&&F!==null?d.call(F,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$Fj=D;class I{static create(C,F){return new I(C,F)}constructor(C,F){this.d=C,this.f=F,this.type=11,this.c=D.create(C,F)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=I;class O{static create(C,F,_=null){if(typeof F=="boolean")return F?M.create(C,_):m.create(C,_);const B=u.get(C);return typeof B=="boolean"?F===(B?"true":"false")?o.INSTANCE:l.INSTANCE:new O(C,F,_)}constructor(C,F,_){this.c=C,this.d=F,this.f=_,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=u.get(this.c);if(typeof C=="boolean"){const F=C?"true":"false";return this.d===F?o.INSTANCE:l.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Hj=O;class M{static create(C,F=null){const _=u.get(C);return typeof _=="boolean"?_?o.INSTANCE:l.INSTANCE:new M(C,F)}constructor(C,F){this.c=C,this.d=F,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:z(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=u.get(this.c);return typeof C=="boolean"?C?o.INSTANCE:l.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$Ij=M;function W(Y,C){if(typeof Y=="string"){const F=parseFloat(Y);isNaN(F)||(Y=F)}return typeof Y=="string"||typeof Y=="number"?C(Y):o.INSTANCE}class N{static create(C,F,_=null){return W(F,B=>new N(C,B,_))}constructor(C,F,_){this.c=C,this.d=F,this.f=_,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Jj=N;class T{static create(C,F,_=null){return W(F,B=>new T(C,B,_))}constructor(C,F,_){this.c=C,this.d=F,this.f=_,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Kj=T;class U{static create(C,F,_=null){return W(F,B=>new U(C,B,_))}constructor(C,F,_){this.c=C,this.d=F,this.f=_,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Lj=U;class ie{static create(C,F,_=null){return W(F,B=>new ie(C,B,_))}constructor(C,F,_){this.c=C,this.d=F,this.f=_,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:H(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Mj=ie;class te{static create(C,F){return new te(C,F)}constructor(C,F){this.d=C,this.f=F,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const F=this.f?this.f.source:"",_=C.f?C.f.source:"";return F<_?-1:F>_?1:0}equals(C){if(C.type===this.type){const F=this.f?this.f.source:"",_=C.f?C.f.source:"";return this.d===C.d&&F===_}return!1}substituteConstants(){return this}evaluate(C){const F=C.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$Nj=te;class ae{static create(C){return new ae(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(C){return new ae(this.c.map(C))}negate(){return this.c}}e.$Oj=ae;function K(Y){let C=null;for(let F=0,_=Y.length;F<_;F++){const B=Y[F].substituteConstants();if(Y[F]!==B&&C===null){C=[];for(let Z=0;Z<F;Z++)C[Z]=Y[Z]}C!==null&&(C[F]=B)}return C===null?Y:C}class J{static create(C,F,_){return J.d(C,F,_)}constructor(C,F){this.expr=C,this.c=F,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const B=i(this.expr[F],C.expr[F]);if(B!==0)return B}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(C.expr[F]))return!1;return!0}return!1}substituteConstants(){const C=K(this.expr);return C===this.expr?this:J.create(C,this.c,!1)}evaluate(C){for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].evaluate(C))return!1;return!0}static d(C,F,_){const B=[];let Z=!1;for(const x of C)if(x){if(x.type===1){Z=!0;continue}if(x.type===0)return o.INSTANCE;if(x.type===6){B.push(...x.expr);continue}B.push(x)}if(B.length===0&&Z)return l.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(i);for(let x=1;x<B.length;x++)B[x-1].equals(B[x])&&(B.splice(x,1),x--);if(B.length===1)return B[0];for(;B.length>1;){const x=B[B.length-1];if(x.type!==9)break;B.pop();const ee=B.pop(),G=B.length===0,ue=q.create(x.expr.map(fe=>J.create([fe,ee],null,_)),null,G);ue&&(B.push(ue),B.sort(i))}if(B.length===1)return B[0];if(_){for(let x=0;x<B.length;x++)for(let ee=x+1;ee<B.length;ee++)if(B[x].negate().equals(B[ee]))return o.INSTANCE;if(B.length===1)return B[0]}return new J(B,F)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const F of this.expr)C.push(...F.keys());return C}map(C){return new J(this.expr.map(F=>F.map(C)),null)}negate(){if(!this.c){const C=[];for(const F of this.expr)C.push(F.negate());this.c=q.create(C,this,!0)}return this.c}}e.$Pj=J;class q{static create(C,F,_){return q.d(C,F,_)}constructor(C,F){this.expr=C,this.c=F,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const B=i(this.expr[F],C.expr[F]);if(B!==0)return B}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(C.expr[F]))return!1;return!0}return!1}substituteConstants(){const C=K(this.expr);return C===this.expr?this:q.create(C,this.c,!1)}evaluate(C){for(let F=0,_=this.expr.length;F<_;F++)if(this.expr[F].evaluate(C))return!0;return!1}static d(C,F,_){let B=[],Z=!1;if(C){for(let x=0,ee=C.length;x<ee;x++){const G=C[x];if(G){if(G.type===0){Z=!0;continue}if(G.type===1)return l.INSTANCE;if(G.type===9){B=B.concat(G.expr);continue}B.push(G)}}if(B.length===0&&Z)return o.INSTANCE;B.sort(i)}if(B.length!==0){if(B.length===1)return B[0];for(let x=1;x<B.length;x++)B[x-1].equals(B[x])&&(B.splice(x,1),x--);if(B.length===1)return B[0];if(_){for(let x=0;x<B.length;x++)for(let ee=x+1;ee<B.length;ee++)if(B[x].negate().equals(B[ee]))return l.INSTANCE;if(B.length===1)return B[0]}return new q(B,F)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const F of this.expr)C.push(...F.keys());return C}map(C){return new q(this.expr.map(F=>F.map(C)),null)}negate(){if(!this.c){const C=[];for(const F of this.expr)C.push(F.negate());for(;C.length>1;){const F=C.shift(),_=C.shift(),B=[];for(const Z of le(F))for(const x of le(_))B.push(J.create([Z,x],null,!1));C.unshift(q.create(B,null,!1))}this.c=q.create(C,this,!0)}return this.c}}e.$Qj=q;class L extends m{static{this.d=[]}static all(){return L.d.values()}constructor(C,F,_){super(C,null),this.f=F,typeof _=="object"?L.d.push({..._,key:C}):_!==!0&&L.d.push({key:C,description:_,type:F!=null?typeof F:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return P.create(this.key,C)}notEqualsTo(C){return O.create(this.key,C)}}e.$Rj=L,e.$Sj=(0,R.$Ai)("contextKeyService");function z(Y,C){return Y<C?-1:Y>C?1:0}function H(Y,C,F,_){return Y<F?-1:Y>F?1:C<_?-1:C>_?1:0}function ce(Y,C){if(Y.type===0||C.type===1)return!0;if(Y.type===9)return C.type===9?V(Y.expr,C.expr):!1;if(C.type===9){for(const F of C.expr)if(ce(Y,F))return!0;return!1}if(Y.type===6){if(C.type===6)return V(C.expr,Y.expr);for(const F of Y.expr)if(ce(F,C))return!0;return!1}return Y.equals(C)}function V(Y,C){let F=0,_=0;for(;F<Y.length&&_<C.length;){const B=Y[F].cmp(C[_]);if(B<0)return!1;B===0&&F++,_++}return F===Y.length}function le(Y){return Y.type===9?Y.expr:[Y]}}),define(re[92],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$hn=e.ID=void 0,e.$in=A,e.ID="diagnosticsService",e.$hn=(0,n.$Ai)(e.ID);function A(R){return!!R.hostName&&!!R.errorMessage}class S{async getPerformanceInfo(j,k){return{}}async getSystemInfo(j,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(j,k){return""}async getWorkspaceFileExtensions(j){return{extensions:[]}}async reportWorkspaceStats(j){}}e.$jn=S}),define(re[119],oe([0,1,19,74,168,6,48,4,35]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Vw=e.$Uw=e.$Tw=void 0,e.$Ww=$,e.$Xw=f,e.$Tw=(0,R.$Ai)("dialogService");var c;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(c||(c={}));class d{a(w){return this.d(w,c.Confirmation)}b(w){return this.d(w,c.Prompt)}c(w){return this.d(w,c.Input)}d(w,b){const g=[];switch(b){case c.Confirmation:{const h=w;h.primaryButton?g.push(h.primaryButton):g.push((0,S.localize)(0,null)),h.cancelButton?g.push(h.cancelButton):g.push((0,S.localize)(1,null));break}case c.Prompt:{const h=w;Array.isArray(h.buttons)&&h.buttons.length>0&&g.push(...h.buttons.map(E=>E.label)),h.cancelButton&&(h.cancelButton===!0?g.push((0,S.localize)(2,null)):typeof h.cancelButton=="string"?g.push(h.cancelButton):h.cancelButton.label?g.push(h.cancelButton.label):g.push((0,S.localize)(3,null))),g.length===0&&g.push((0,S.localize)(4,null));break}case c.Input:{const h=w;h.primaryButton?g.push(h.primaryButton):g.push((0,S.localize)(5,null)),h.cancelButton?g.push(h.cancelButton):g.push((0,S.localize)(6,null));break}}return g}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===A.default.Info?"info":w===A.default.Error?"error":w===A.default.Warning?"warning":"none"}f(w,b,g){const h=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&h.push(w.cancelButton);let E=h[b]?.run({checkboxChecked:g});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:g}}}e.$Uw=d,e.$Vw=(0,R.$Ai)("fileDialogService");var p;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(p||(e.ConfirmResult=p={}));const v=10;function $(y){const w=[];return w.push(...y.slice(0,v).map(b=>typeof b=="string"?b:(0,n.$$g)(b))),y.length>v&&(y.length-v===1?w.push((0,S.localize)(7,null)):w.push((0,S.localize)(8,null,y.length-v))),w.push(""),w.join(`
`)}function f(y,w){const b=(0,u.$7n)(y);let g=(b.buttons??[]).map(t=>(0,j.$Qw)(t)),h=(y.buttons||[]).map((t,r)=>r),E=0,a=b.cancelId??g.length-1;if(g.length>1){const t=typeof a=="number"?g[a]:void 0;if(k.$k||k.$j){if(typeof t=="string"&&g.length>1&&a!==1){g.splice(a,1),g.splice(1,0,t);const r=h[a];h.splice(a,1),h.splice(1,0,r),a=1}k.$k&&g.length>1&&(g=g.reverse(),h=h.reverse(),E=g.length-1,typeof t=="string"&&(a=E-1))}else if(k.$i&&typeof t=="string"&&g.length>1&&a!==g.length-1){g.splice(a,1),g.push(t);const r=h[a];h.splice(a,1),h.push(r),a=g.length-1}}return b.buttons=g,b.defaultId=E,b.cancelId=a,b.noLink=!0,b.title=b.title||w.nameLong,{options:b,buttonIndeces:h}}}),define(re[120],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$eX=e.$dX=void 0,e.$fX=R,e.$gX=j,e.$dX=(0,n.$Ai)("encryptionService"),e.$eX=(0,n.$Ai)("encryptionMainService");var A;(function(k){k.kwallet="kwallet",k.kwallet5="kwallet5",k.gnomeLibsecret="gnome-libsecret",k.basic="basic"})(A||(e.PasswordStoreCLIOption=A={}));var S;(function(k){k.unknown="unknown",k.basicText="basic_text",k.gnomeAny="gnome_any",k.gnomeLibsecret="gnome_libsecret",k.gnomeKeyring="gnome_keyring",k.kwallet="kwallet",k.kwallet5="kwallet5",k.kwallet6="kwallet6",k.dplib="dpapi",k.keychainAccess="keychain_access"})(S||(e.KnownStorageProvider=S={}));function R(k){return k==="kwallet"||k==="kwallet5"||k==="kwallet6"}function j(k){return k==="gnome_any"||k==="gnome_libsecret"||k==="gnome_keyring"}}),define(re[38],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,n.$Ai)("environmentService"),e.$Ii=(0,n.$Bi)(e.$Hi)}),define(re[121],oe([0,1,172,6]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.ExtensionManagementErrorCode=e.$ap=e.ExtensionGalleryErrorCode=e.$_o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0,e.$6o=R,e.$7o=j,e.$8o=k,e.$9o=u,e.$0o=c,e.$$o=d,e.$Yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Zo=new RegExp(e.$Yo),e.$1o="__web_extension",e.$2o="skipWalkthrough",e.$3o="extensionInstallSource",e.$4o="dependecyOrPackExtensionInstall",e.$5o="clientTargetPlatform";var S;(function(h){h.COMMAND="command",h.SETTINGS_SYNC="settingsSync"})(S||(e.ExtensionInstallSource=S={}));function R(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function j(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function k(h,E){switch(h){case 3:return E==="x64"?"win32-x64":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function u(h,E){return E==="web"&&!h.includes("web")}function c(h,E,a){return u(E,a)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===a}function d(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var p;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var $;(function(h){h.Install="install",h.Uninstall="uninstall"})($||(e.StatisticType=$={}));var f;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$_o=(0,A.$Ai)("extensionGalleryService");var y;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed",h.DownloadFailedWriting="DownloadFailedWriting"})(y||(e.ExtensionGalleryErrorCode=y={}));class w extends Error{constructor(E,a){super(E),this.code=a,this.name=a}}e.$ap=w;var b;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.DownloadFailedWriting="DownloadFailedWriting",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.ScanningExtension="ScanningExtension",h.ReadUninstalled="ReadUninstalled",h.UnsetUninstalled="UnsetUninstalled",h.Delete="Delete",h.Rename="Rename",h.IntializeDefaultProfile="IntializeDefaultProfile",h.AddToProfile="AddToProfile",h.InstalledExtensionNotFound="InstalledExtensionNotFound",h.PostInstall="PostInstall",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Cancelled="Cancelled",h.Unknown="Unknown",h.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));class g extends Error{constructor(E,a){super(E),this.code=a,this.name=a}}e.$bp=g,e.$cp=(0,A.$Ai)("extensionManagementService"),e.$dp="extensionsIdentifiers/disabled",e.$ep="extensionsIdentifiers/enabled",e.$fp=(0,A.$Ai)("IGlobalExtensionEnablementService"),e.$gp=(0,A.$Ai)("IExtensionTipsService"),e.$hp=(0,n.localize2)(0,"Extensions"),e.$ip=(0,n.localize2)(1,"Preferences")}),define(re[212],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=e.$sdc=void 0,e.$sdc=(0,n.$Ai)("extensionHostStarter"),e.$tdc="extensionHostStarter"}),define(re[213],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=e.$87b=void 0,e.$87b=(0,n.$Ai)("externalTerminal"),e.$97b="Terminal.app"}),define(re[214],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=void 0,e.$vdc=(0,n.$Ai)("externalTerminal")}),define(re[215],oe([0,1,49,51,13,9,4,76,21,90,176,213]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=e.$wdc=void 0;const v=d.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends ${static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,c.$sm(),t)}spawnTerminal(a,t,r,s){const i=t.windowsExec||f.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=R.$nc(i,".exe").toLowerCase();if(o==="cmder")return a.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return i.indexOf(" ")>=0&&l.push('""'),l.push(i),o==="wt"&&l.push("-d ."),new Promise((m,P)=>{const D=b(process),I=a.spawn(r,l,{cwd:s,env:D,detached:!0});I.on("error",P),I.on("exit",()=>m())})}async runInTerminal(a,t,r,s,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows(),l=await f.f();return new Promise((m,P)=>{const D=`"${t} - ${v}"`,I=`"${r.join('" "')}" & pause`,O=Object.assign({},b(process),s);Object.keys(O).filter(U=>O[U]===null).forEach(U=>delete O[U]);const M={cwd:t,env:O,windowsVerbatimArguments:!0};let W,N;R.$nc(o,".exe")==="wt"?(W=o,N=["-d",".",f.b,"/c",I]):l?(W=l,N=["-d",".",o,"/c",I]):(W=f.b,N=["/c","start",D,"/wait",o,"/c",`"${I}"`]),n.spawn(W,N,M).on("error",U=>{P(g(U))}),m(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const a=await c.win32.findExecutable("wt");return await u.Promises.exists(a)?a:void 0}catch{return}}}e.$wdc=f,ke([A.$5h],f,"f",null);class y extends ${static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.osxExec||p.$97b;return new Promise((l,m)=>{if(o===p.$97b||o==="iTerm.app"){const P=o===p.$97b?"TerminalHelper":"iTermHelper",I=[S.$Ug.asFileUri(`vs/workbench/contrib/externalTerminal/node/${P}.scpt`).fsPath,"-t",a||v,"-w",t];for(const W of r)I.push("-a"),I.push(W);if(s){const W=Object.assign({},b(process),s);for(const N in W){const T=W[N];T===null?(I.push("-u"),I.push(N)):(I.push("-e"),I.push(`${N}=${T}`))}}let O="";const M=n.spawn(y.b,I);M.on("error",W=>{m(g(W))}),M.stderr.on("data",W=>{O+=W.toString()}),M.on("exit",W=>{if(W===0)l(void 0);else if(O){const N=O.split(`
`,1);m(new Error(N[0]))}else m(new Error(d.localize(1,null,P,W)))})}else m(new Error(d.localize(2,null,o)))})}spawnTerminal(a,t,r){const s=t.osxExec||p.$97b;return new Promise((i,o)=>{const l=["-a",s];r&&l.push(r);const m=b(process),P=a.spawn("/usr/bin/open",l,{cwd:r,env:m});P.on("error",o),P.on("exit",()=>i())})}}e.$xdc=y;class w extends ${static{this.b=d.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,m)=>{const P=[];o.then(D=>{D.indexOf("gnome-terminal")>=0?P.push("-x"):P.push("-e"),P.push("bash"),P.push("-c");const I=`${h(r)}; echo; read -p "${w.b}" -n1;`;P.push(`''${I}''`);const O=Object.assign({},b(process),s);Object.keys(O).filter(T=>O[T]===null).forEach(T=>delete O[T]);const M={cwd:t,env:O};let W="";const N=n.spawn(D,P,M);N.on("error",T=>{m(g(T))}),N.stderr.on("data",T=>{W+=T.toString()}),N.on("exit",T=>{if(T===0)l(void 0);else if(W){const U=W.split(`
`,1);m(new Error(U[0]))}else m(new Error(d.localize(4,null,D,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!j.$k)w.d=Promise.resolve("xterm");else{const a=await u.Promises.exists("/etc/debian_version");w.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w.d}spawnTerminal(a,t,r){const s=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{s.then(l=>{const m=b(process),P=a.spawn(l,[],{cwd:r,env:m});P.on("error",o),P.on("exit",()=>i())})})}}e.$ydc=w;function b(E){const a={...E.env};return(0,k.$qm)(a),a}function g(E){return"errno"in E&&E.errno==="ENOENT"&&"path"in E&&typeof E.path=="string"?new Error(d.localize(5,null,E.path)):E}function h(E){let a="";for(const t of E)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(re[16],oe([0,1,59,9,25,12,7,178,6,4,13,62]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=v,e.$9k=w,e.$0k=g,e.$$k=h,e.$_k=E,e.$al=a,e.$bl=t,e.$cl=r,e.$dl=s,e.$el=i,e.$fl=o,e.$hl=P,e.$il=D,e.$jl=I,e.$kl=O,e.$ll=M,e.$ol=ie,e.$Al=L,e.$Bl=z,e.$Dl=ce,e.$7k=(0,u.$Ai)("fileService");function v(V){return V.create===!0}var $;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var f;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var y;(function(V){V[V.UPDATED=2]="UPDATED",V[V.ADDED=4]="ADDED",V[V.DELETED=8]="DELETED"})(y||(e.FileChangeFilter=y={}));function w(V){const le=V;return!!le&&typeof le.onDidChange=="function"}var b;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function g(V){return!!(V.capabilities&2)}function h(V){return!!(V.capabilities&8)}function E(V){return!!(V.capabilities&131072)}function a(V){return!!(V.capabilities&4)}function t(V){return!!(V.capabilities&16)}function r(V){return g(V)?!!(V.capabilities&16384):!1}function s(V){return g(V)?!!(V.capabilities&32768):!1}function i(V){return!!(V.capabilities&65536)}function o(V){return!!(V.capabilities&2048)}var l;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class m extends Error{static create(le,Y){const C=new m(le.toString(),Y);return I(C,Y),C}constructor(le,Y){super(le),this.code=Y}}e.$gl=m;function P(V,le){return m.create(V,le)}function D(V){return V||P((0,k.localize)(0,null),l.Unknown)}function I(V,le){return V.name=le?`${le} (FileSystemError)`:"FileSystemError",V}function O(V){if(!V)return l.Unknown;if(V instanceof m)return V.code;const le=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!le)return l.Unknown;switch(le[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function M(V){if(V instanceof te)return V.fileOperationResult;switch(O(V)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}var W;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(W||(e.FileOperation=W={}));class N{constructor(le,Y,C){this.resource=le,this.operation=Y,this.target=C}isOperation(le){return this.operation===le}}e.$ml=N;var T;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class U{static{this.a=null}constructor(le,Y){this.c=Y,this.b=void 0,this.d=new p.$V(()=>{const C=n.$Gi.forUris(()=>this.c);return C.fill(this.rawAdded.map(F=>[F,!0])),C}),this.f=new p.$V(()=>{const C=n.$Gi.forUris(()=>this.c);return C.fill(this.rawUpdated.map(F=>[F,!0])),C}),this.g=new p.$V(()=>{const C=n.$Gi.forUris(()=>this.c);return C.fill(this.rawDeleted.map(F=>[F,!0])),C}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const C of le){switch(C.type){case 1:this.rawAdded.push(C.resource);break;case 0:this.rawUpdated.push(C.resource);break;case 2:this.rawDeleted.push(C.resource);break}this.b!==U.a&&(typeof C.cId=="number"?this.b===void 0?this.b=C.cId:this.b!==C.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(le,...Y){return this.h(le,{includeChildren:!1},...Y)}affects(le,...Y){return this.h(le,{includeChildren:!0},...Y)}h(le,Y,...C){if(!le)return!1;const F=C.length>0;return!!((!F||C.includes(1))&&(this.d.value.get(le)||Y.includeChildren&&this.d.value.findSuperstr(le))||(!F||C.includes(0))&&(this.f.value.get(le)||Y.includeChildren&&this.f.value.findSuperstr(le))||(!F||C.includes(2))&&(this.g.value.findSubstr(le)||Y.includeChildren&&this.g.value.findSuperstr(le)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(le){return this.b===le}hasCorrelation(){return typeof this.b=="number"}}e.$nl=U;function ie(V,le,Y){return!V||!le||V===le||le.length>V.length?!1:(le.charAt(le.length-1)!==A.sep&&(le+=A.sep),Y?(0,S.$Cf)(V,le):V.indexOf(le)===0)}class te extends Error{constructor(le,Y,C){super(le),this.fileOperationResult=Y,this.options=C}}e.$pl=te;class ae extends te{constructor(le,Y,C,F){super(le,Y,F),this.fileOperationResult=Y,this.size=C}}e.$ql=ae;class K extends te{constructor(le,Y,C){super(le,2,C),this.stat=Y}}e.$rl=K;var J;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var q;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$zl="";function L(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}async function z(V,le){if(!le.hasProvider(j.URI.from({scheme:V.scheme})))return new Promise(Y=>{const C=le.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&(C.dispose(),Y())})})}class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(le){return(0,R.$eg)(le)||(le=0),le<H.KB?(0,k.localize)(1,null,le.toFixed(0)):le<H.MB?(0,k.localize)(2,null,(le/H.KB).toFixed(2)):le<H.GB?(0,k.localize)(3,null,(le/H.MB).toFixed(2)):le<H.TB?(0,k.localize)(4,null,(le/H.GB).toFixed(2)):(0,k.localize)(5,null,(le/H.TB).toFixed(2))}}e.$Cl=H;function ce(V){const le=typeof V=="string"||V?.scheme===d.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===d.Schemas.file?1024*H.MB:le?10*H.MB:c.$o?50*H.MB:1024*H.MB}}),define(re[122],oe([0,1,17,15,179,16]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=j;async function j(d,p,v,$,f,y){let w;try{await k(d,p,v,$,f,y)}catch(b){w=b}finally{w&&f.errorTransformer&&(w=f.errorTransformer(w)),typeof w<"u"&&v.error(w),v.end()}}async function k(d,p,v,$,f,y){u(y);const w=await d.open(p,{create:!1});try{u(y);let b=0,g=0,h=f&&typeof f.length=="number"?f.length:void 0,E=n.$Je.alloc(Math.min(f.bufferSize,typeof h=="number"?h:f.bufferSize)),a=f&&typeof f.position=="number"?f.position:0,t=0;do g=await d.read(w,a,E.buffer,t,E.byteLength-t),a+=g,t+=g,b+=g,typeof h=="number"&&(h-=g),t===E.byteLength&&(await v.write($(E)),E=n.$Je.alloc(Math.min(f.bufferSize,typeof h=="number"?h:f.bufferSize)),t=0);while(g>0&&(typeof h!="number"||h>0)&&u(y)&&c(b,f));if(t>0){let r=t;typeof h=="number"&&(r=Math.min(t,h)),v.write($(E.slice(0,r)))}}catch(b){throw(0,R.$il)(b)}finally{await d.close(w)}}function u(d){if(d.isCancellationRequested)throw(0,A.$6)();return!0}function c(d,p){if(typeof p?.limits?.size=="number"&&d>p.limits.size)throw(0,R.$hl)((0,S.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[60],oe([0,1,108,2,9,4,7,16]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0,e.$Pq=u,e.$Qq=c,e.$Uq=$,e.$Vq=f,e.$Wq=y,e.$Xq=w,e.$Yq=g,e.$Zq=h;function u(E){return typeof E.correlationId=="number"}function c(E){return E.recursive===!0}class d extends A.$Uc{static{this.a=3}static{this.b=10}constructor(a,t,r,s){super(),this.m=a,this.n=t,this.r=r,this.s=s,this.f=this.B(new A.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const a=new A.$Tc;this.f.value=a,this.c=this.t(a),this.c.setVerboseLogging(this.r),a.add(this.c.onDidChangeFile(t=>this.m(t))),a.add(this.c.onDidLogMessage(t=>this.n(t))),a.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(a,t){if(this.s.restartOnError&&this.g?.length)if(t){const r=this.h.get(t.path)??0;r<d.a?(this.z(`restarting watcher from error in watch request (retrying request): ${a} (${JSON.stringify(t)})`),this.h.set(t.path,r+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${a} (${JSON.stringify(t)})`),this.y(this.g.filter(s=>s.path!==t.path)))}else this.j<d.b?(this.z(`restarting watcher after unknown global error: ${a}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${a}`);else this.z(a)}y(a){this.u(),this.watch(a)}async watch(a){this.g=a,await this.c?.watch(a)}async setVerboseLogging(a){this.r=a,await this.c?.setVerboseLogging(a)}z(a){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${a}`})}C(a){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${a}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Rq=d;class p extends d{constructor(a,t,r){super(a,t,r,{type:"node.js",restartOnError:!1})}}e.$Sq=p;class v extends d{constructor(a,t,r){super(a,t,r,{type:"universal",restartOnError:!0})}}e.$Tq=v;function $(E){return E.map(a=>({type:a.type,resource:j.URI.revive(a.resource),cId:a.cId}))}function f(E){const a=new b;for(const t of E)a.processEvent(t);return a.coalesce()}function y(E,a){return typeof a=="string"&&!a.startsWith(n.$qk)&&!(0,S.$ic)(a)?{base:E,pattern:a}:a}function w(E,a){const t=[];for(const r of a)t.push((0,n.$uk)(y(E,r)));return t}class b{constructor(){this.a=new Set,this.b=new Map}c(a){return R.$k?a.resource.fsPath:a.resource.fsPath.toLowerCase()}processEvent(a){const t=this.b.get(this.c(a));let r=!1;if(t){const s=t.type,i=a.type;t.resource.fsPath!==a.resource.fsPath&&(a.type===2||a.type===1)?r=!0:s===1&&i===2?(this.b.delete(this.c(a)),this.a.delete(t)):s===2&&i===1?t.type=0:s===1&&i===0||(t.type=i)}else r=!0;r&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?(a.push(r),!1):!0).sort((r,s)=>r.resource.fsPath.length-s.resource.fsPath.length).filter(r=>t.some(s=>(0,k.$ol)(r.resource.fsPath,s,!R.$k))?!1:(t.push(r.resource.fsPath),!0)).concat(a)}}function g(E,a){if(typeof a=="number")switch(E.type){case 1:return(a&4)===0;case 2:return(a&8)===0;case 0:return(a&2)===0}return!1}function h(E){if(typeof E=="number"){const a=[];return E&4&&a.push("Added"),E&8&&a.push("Deleted"),E&2&&a.push("Updated"),a.length===0?"<all>":`[${a.join(", ")}]`}return"<none>"}}),define(re[216],oe([0,1,17,47,15,3,2,63,33,16,60]),function(Q,e,n,A,S,R,j,k,u,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=e.$ZP=void 0,e.$ZP="localFilesystem";class p extends j.$Uc{constructor($,f){super(),this.a=$,this.b=f,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$he),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$he),this.onDidWatchError=this.g.event,this.h=(0,u.$Wg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,f){const{buffer:y}=await this.a.call("readFile",[$,f]);return y}readFileStream($,f,y){const w=(0,k.$xe)(g=>n.$Je.concat(g.map(h=>n.$Je.wrap(h))).buffer),b=new j.$Tc;return b.add(this.a.listen("readFileStream",[$,f])(g=>{if(g instanceof n.$Je)w.write(g.buffer);else{if(g==="end")w.end();else{let h;if(g instanceof Error)h=g;else{const E=g;h=(0,c.$hl)(E.message??(0,A.$lj)(E),E.code??c.FileSystemProviderErrorCode.Unknown)}w.error(h),w.end()}b.dispose()}})),b.add(y.onCancellationRequested(()=>{w.error((0,S.$6)()),w.end(),b.dispose()})),w}writeFile($,f,y){return this.a.call("writeFile",[$,n.$Je.wrap(f),y])}open($,f){return this.a.call("open",[$,f])}close($){return this.a.call("close",[$])}async read($,f,y,w,b){const[g,h]=await this.a.call("read",[$,f,b]);return y.set(g.buffer.slice(0,h),w),h}write($,f,y,w,b){return this.a.call("write",[$,f,n.$Je.wrap(y),w,b])}mkdir($){return this.a.call("mkdir",[$])}delete($,f){return this.a.call("delete",[$,f])}rename($,f,y){return this.a.call("rename",[$,f,y])}copy($,f,y){return this.a.call("copy",[$,f,y])}cloneFile($,f){return this.a.call("cloneFile",[$,f])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const f=$;this.f.fire((0,d.$Uq)(f))}else{const f=$;this.g.fire(f)}}))}watch($,f){const y=(0,u.$Wg)();return this.a.call("watch",[this.h,y,$,f]),(0,j.$Sc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$1P=p}),define(re[217],oe([0,1,43,2,60,3,7,8]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class u extends A.$Uc{constructor(){super(),this.a=this.B(new R.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new A.$4c),this.m=new Set,this.n=5007,this.r=new k.$Xh,this.P=!1,this.B(this.f(d=>this.s(d)))}s(d){this.t(d)&&this.w(d)}t(d){return(0,S.$Pq)(d)}async watch(d){this.r.isSettled||this.r.complete(),this.r=new k.$Xh;try{this.h.clear(),this.g.clear();for(const p of d)this.t(p)?this.h.set(p.correlationId,p):this.g.add(p);for(const[p]of this.j)this.h.has(p)||(this.j.deleteAndDispose(p),this.m.delete(p));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))])}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async w(d){if(this.j.has(d.correlationId))return;const p=new A.$Tc;this.j.set(d.correlationId,p),await this.r.p,!p.isDisposed&&(this.z(d,p),this.u())}y(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.u()}z(d,p){this.C(d,p)?(this.N(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.D(d,p),this.m.add(d.correlationId))}C(d,p){const v=this.M?.subscribe(d.path,($,f)=>{p.isDisposed||($?this.z(d,p):f?.type===1&&this.F(d))});return v?(p.add(v),!0):!1}D(d,p){let v=!1;const $=(f,y)=>{if(p.isDisposed)return;const w=this.G(f),b=this.G(y),g=v;v=w,!w&&(b||g)&&this.F(d)};this.N(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.watchFile)(d.path,{persistent:!1,interval:this.n},$)}catch(f){this.O(`fs.watchFile() failed with error ${f} on path ${d.path} (correlationId: ${d.correlationId})`)}p.add((0,A.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.unwatchFile)(d.path,$)}catch(f){this.O(`fs.unwatchFile() failed with error ${f} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}F(d){this.N(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const p={resource:j.URI.file(d.path),type:1,cId:d.correlationId};this.a.fire([p]),this.H(p,d),this.y(d)}G(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(d,p){if(this.P){const v=` >> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.I(v,p)}}I(d,p){this.P&&this.N(`${d}${typeof p.correlationId=="number"?` <${p.correlationId}> `:""}`)}J(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,S.$Zq)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.P=d}}e.$9q=u}),define(re[218],oe([0,1,43,8,23,31,2,72,9,4,19,7,109,21,60]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0,e.$cr=w;class y extends j.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(g,h,E,a,t,r){super(),this.s=g,this.t=h,this.u=E,this.w=a,this.y=t,this.z=r,this.c=this.B(new A.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new A.$Oh(s=>this.M(s),y.b)),this.g=(0,f.$Xq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$Xq)(this.s.path,this.s.includes):void 0,this.j=(0,f.$Pq)(this.s)?this.s.filter:void 0,this.m=new S.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const g=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const h=await $.Promises.stat(g);if(this.m.token.isCancellationRequested)return;this.B(await this.G(g,h.isDirectory()))}catch(g){g.code!=="ENOENT"?this.O(g):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${g})`),this.D()}}D(){this.r=!0,this.w?.()}async F(g){let h=g.path;try{h=await $.Promises.realpath(g.path),g.path===h&&(h=await(0,v.$$q)(g.path,this.m.token)??g.path),g.path!==h&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${h})`)}catch{}return h}async G(g,h){const E=new j.$Tc;return this.H(g,h,E)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(g,h,E)),E}H(g,h,E){if(h)return!1;const a=p.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,s)=>{if(!E.isDisposed)if(r){const i=await this.G(g,h);E.isDisposed?i.dispose():E.add(i)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:a,type:s.type,cId:this.s.correlationId},!0)});return t?(E.add(t),!0):!1}async I(g,h,E){if(c.$j&&(0,R.$zg)(g,"/Volumes/",!0)){this.O(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new S.$se(this.m.token);E.add((0,j.$Sc)(()=>a.dispose(!0)));const t=new j.$Tc;E.add(t);try{const r=p.URI.file(this.s.path),s=(0,u.$nc)(g),i=(0,n.watch)(g);t.add((0,j.$Sc)(()=>{i.removeAllListeners(),i.close()})),this.Q(`Started watching: '${g}'`);const o=new Set;if(h)try{for(const m of await $.Promises.readdir(g))o.add(m)}catch(m){this.O(m)}if(a.token.isCancellationRequested)return;const l=new Map;t.add((0,j.$Sc)(()=>{for(const[,m]of l)m.dispose();l.clear()})),i.on("error",(m,P)=>{a.token.isCancellationRequested||(this.O(`Failed to watch ${g} for changes using fs.watch() (${m}, ${P})`),this.D())}),i.on("change",(m,P)=>{if(a.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${m}"] ${P}`);let D="";if(P&&(D=P.toString(),c.$j&&(D=(0,k.$fm)(D))),!(!D||m!=="change"&&m!=="rename"))if(h)if(m==="rename"){l.get(D)?.dispose();const I=setTimeout(async()=>{if(l.delete(D),D===s&&!await $.Promises.exists(g)){this.J(r);return}if(a.token.isCancellationRequested)return;const O=await this.N((0,u.$jc)(g,D));if(a.token.isCancellationRequested)return;let M;O?o.has(D)?M=0:(M=1,o.add(D)):(o.delete(D),M=2),this.L({resource:(0,d.$bh)(r,D),type:M,cId:this.s.correlationId})},y.a);l.set(D,(0,j.$Sc)(()=>clearTimeout(I)))}else{let I;o.has(D)?I=0:(I=1,o.add(D)),this.L({resource:(0,d.$bh)(r,D),type:I,cId:this.s.correlationId})}else if(m==="rename"||D!==s){const I=setTimeout(async()=>{const O=await $.Promises.exists(g);a.token.isCancellationRequested||(O?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(g,!1))):this.J(r))},y.a);t.clear(),t.add((0,j.$Sc)(()=>clearTimeout(I)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){a.token.isCancellationRequested||this.O(`Failed to watch ${g} for changes using fs.watch() (${r.toString()})`),this.D()}}J(g){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:g,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(g,h=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!h&&this.g.some(E=>E(g.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${g.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(E=>E(g.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${g.resource.fsPath}`):this.f.work(g))}M(g){const h=(0,f.$Vq)(g),E=[];for(const t of h){if((0,f.$Yq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}E.push(t)}if(E.length===0)return;if(this.z)for(const t of E)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(E)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${E.length}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(g){if(c.$k)return $.Promises.exists(g);try{const h=(0,u.$nc)(g);return(await $.Promises.readdir((0,u.$mc)(g))).some(a=>a===h)}catch(h){return this.Q(h),!1}}setVerboseLogging(g){this.z=g}O(g){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}P(g){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}Q(g){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}R(g){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${g}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$br=y;async function w(b,g,h,E,a=512){const t=await $.Promises.open(b,"r"),r=Buffer.allocUnsafe(a),s=new S.$se(E);let i,o=!1;const l={path:b,excludes:[],recursive:!1},m=new y(l,void 0,P=>{(async()=>{for(const{type:D}of P)if(D===0){if(o)return;o=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:I}=await $.Promises.read(t,r,0,a,null);if(!I||s.token.isCancellationRequested)break;g(r.slice(0,I))}}catch(I){i=new Error(I),s.dispose(!0)}finally{o=!1}}})()});return await m.ready,h(),new Promise((P,D)=>{s.token.onCancellationRequested(async()=>{m.dispose();try{await $.Promises.close(t)}catch(I){i=new Error(I)}i?D(i):P()})})}}),define(re[219],oe([0,1,3,108,217,4,218,31]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class u extends S.$9q{constructor(d){super(),this.M=d,this.onDidError=n.Event.None,this.watchers=new Set}async L(d){d=this.X(d);const p=[],v=new Set(Array.from(this.watchers));for(const $ of d){const f=this.S($);f&&(0,A.$yk)(f.request.excludes,$.excludes)&&(0,A.$yk)(f.request.includes,$.includes)?v.delete(f):p.push($)}p.length&&this.N(`Request to start watching: ${p.map($=>this.J($)).join(",")}`),v.size&&this.N(`Request to stop watching: ${Array.from(v).map($=>this.J($.request)).join(",")}`);for(const $ of v)this.W($);for(const $ of p)this.U($)}S(d){for(const p of this.watchers)if(typeof d.correlationId=="number"||typeof p.request.correlationId=="number"){if(p.request.correlationId===d.correlationId)return p}else if((0,k.$yg)(p.request.path,d.path,!R.$k))return p}U(d){const p=new j.$br(d,this.M,$=>this.a.fire($),()=>this.c.fire(d),$=>this.b.fire($),this.P),v={request:d,instance:p};this.watchers.add(v)}async stop(){await super.stop();for(const d of this.watchers)this.W(d)}W(d){this.N("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}X(d){const p=new Map;for(const v of d){const $=R.$k?v.path:v.path.toLowerCase();let f=p.get(v.correlationId);f||(f=new Map,p.set(v.correlationId,f)),f.has($)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(v)}`),f.set($,v)}return Array.from(p.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(d){super.setVerboseLogging(d);for(const p of this.watchers)p.instance.setVerboseLogging(d)}N(d,p){this.P&&this.b.fire({type:"trace",message:this.$(d,p)})}O(d){this.b.fire({type:"warn",message:this.$(d)})}$(d,p){return p?`[File Watcher (node.js)] ${d} (${this.J(p.request)})`:`[File Watcher (node.js)] ${d}`}}e.$dr=u}),define(re[220],oe([0,1,60,219]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;class S extends n.$Sq{constructor(j,k,u){super(j,k,u),this.u()}t(j){return j.add(new A.$dr(void 0))}}e.$er=S}),define(re[221],oe([0,1,13,44,162,60]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class j extends R.$Tq{constructor(u,c,d){super(u,c,d),this.u()}t(u){const c=u.add(new S.$7q(n.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:d,signal:p})=>this.w(`terminated by itself with code ${d}, signal: ${p} (ETERM)`))),A.ProxyChannel.toService((0,A.$hi)(c.getChannel("watcher")))}}e.$8q=j}),define(re[93],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class n{constructor(...S){this.a=new Map;for(const[R,j]of S)this.set(R,j)}set(S,R){const j=this.a.get(S);return this.a.set(S,R),j}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$yi=n}),define(re[222],oe([0,1,8,15,2,78,211,6,93,104]),function(Q,e,n,A,S,R,j,k,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;const d=!1;class p extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class v{constructor(w=new u.$yi,b=!1,g,h=d){this.i=w,this.j=b,this.k=g,this.l=h,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$zi,this),this._globalGraph=h?g?._globalGraph??new j.$hr(E=>E):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Pc)(this.h),this.h.clear();for(const w of this.g)(0,S.$Oc)(w)&&w.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(w,b){this.m();const g=new class extends v{dispose(){this.h.delete(g),super.dispose()}}(w,this.j,this,this.l);return this.h.add(g),b?.add(g),g}invokeFunction(w,...b){this.m();const g=f.traceInvocation(this.l,w);let h=!1;try{return w({get:a=>{if(h)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(a,g);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...b)}finally{h=!0,g.stop()}}createInstance(w,...b){this.m();let g,h;return w instanceof R.$xi?(g=f.traceCreation(this.l,w.ctor),h=this.o(w.ctor,w.staticArguments.concat(b),g)):(g=f.traceCreation(this.l,w),h=this.o(w,b,g)),g.stop(),h}o(w,b=[],g){const h=k._util.getServiceDependencies(w).sort((t,r)=>t.index-r.index),E=[];for(const t of h){const r=this.s(t.id,g);r||this.y(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(r)}const a=h.length>0?h[0].index:b.length;if(b.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${b.length} static arguments`);const t=a-b.length;t>0?b=b.concat(new Array(t)):b=b.slice(0,a)}return Reflect.construct(w,b.concat(E))}q(w,b){if(this.i.get(w)instanceof R.$xi)this.i.set(w,b);else if(this.k)this.k.q(w,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(w){const b=this.i.get(w);return!b&&this.k?this.k.r(w):b}s(w,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const g=this.r(w);return g instanceof R.$xi?this.u(w,g,b.branch(w,!0)):(b.branch(w,!1),g)}u(w,b,g){if(this.t.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.t.add(w);try{return this.v(w,b,g)}finally{this.t.delete(w)}}v(w,b,g){const h=new j.$hr(t=>t.id.toString());let E=0;const a=[{id:w,desc:b,_trace:g}];for(;a.length;){const t=a.pop();if(h.lookupOrInsertNode(t),E++>1e3)throw new p(h);for(const r of k._util.getServiceDependencies(t.desc.ctor)){const s=this.r(r.id);if(s||this.y(`[createInstance] ${w} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof R.$xi){const i={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};h.insertEdge(t,i),a.push(i)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new p(h);break}for(const{data:r}of t){if(this.r(r.id)instanceof R.$xi){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}h.removeNode(r)}}return this.r(w)}w(w,b,g=[],h,E){if(this.i.get(w)instanceof R.$xi)return this.x(w,b,g,h,E,this.g);if(this.k)return this.k.w(w,b,g,h,E);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(w,b,g=[],h,E,a){if(h){const t=new v(void 0,this.j,this,this.l);t.c=String(w);const r=new Map,s=new n.$Th(()=>{const i=t.o(b,g,E);for(const[o,l]of r){const m=i[o];if(typeof m=="function")for(const P of l)P.disposable=m.apply(i,P.listener)}return r.clear(),a.add(i),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let P=r.get(o);return P||(P=new c.$5c,r.set(o,P)),(I,O,M)=>{if(s.isInitialized)return s.value[o](I,O,M);{const W={listener:[I,O,M],disposable:void 0},N=P.push(W);return(0,S.$Sc)(()=>{N(),W.disposable?.dispose()})}}}if(o in i)return i[o];const l=s.value;let m=l[o];return typeof m!="function"||(m=m.bind(l),i[o]=m),m},set(i,o,l){return s.value[o]=l,!0},getPrototypeOf(i){return b.prototype}})}else{const t=this.o(b,g,E);return a.add(t),t}}y(w,b){if(b&&console.warn(w),this.j)throw new Error(w)}}e.$ir=v;var $;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})($||($={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,b){return w?new f(2,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(w,b){return w?new f(1,b.name):f.c}static{this.f=0}constructor(w,b){this.type=w,this.name=b,this.g=Date.now(),this.h=[]}branch(w,b){const g=new f(3,w.toString());return this.h.push([w,b,g]),g}stop(){const w=Date.now()-this.g;f.f+=w;let b=!1;function g(E,a){const t=[],r=new Array(E+1).join("	");for(const[s,i,o]of a.h)if(i&&o){b=!0,t.push(`${r}CREATES -> ${s}`);const l=g(E+1,o);l&&t.push(l)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(w>2||b)&&f.all.add(h.join(`
`))}}e.$jr=f}),define(re[223],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7W=e.IssueSource=e.IssueType=void 0;var A;(function(R){R[R.Bug=0]="Bug",R[R.PerformanceIssue=1]="PerformanceIssue",R[R.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={}));var S;(function(R){R.VSCode="vscode",R.Extension="extension",R.Marketplace="marketplace"})(S||(e.IssueSource=S={})),e.$7W=(0,n.$Ai)("issueService")}),define(re[5],oe([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=y,e.log=b,e.$ik=m,e.$jk=P,e.$kk=D,e.$lk=I,e.$7j=(0,$.$Ai)("logService"),e.$8j=(0,$.$Ai)("loggerService");function f(){return new Date().toISOString()}function y(O){return(0,d.$eg)(O)}var w;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$0j=w.Info;function b(O,M,W){switch(M){case w.Trace:O.trace(W);break;case w.Debug:O.debug(W);break;case w.Info:O.info(W);break;case w.Warning:O.warn(W);break;case w.Error:O.error(W);break;case w.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function g(O,M=!1){let W="";for(let N=0;N<O.length;N++){let T=O[N];if(T instanceof Error&&(T=(0,A.$lj)(T,M)),typeof T=="object")try{T=JSON.stringify(T)}catch{}W+=(N>0?" ":"")+T}return W}class h extends j.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new S.$he),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==w.Off&&this.b<=M}}e.$_j=h;class E extends h{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...W){this.f(w.Trace)&&this.g(w.Trace,g([M,...W],!0))}debug(M,...W){this.f(w.Debug)&&this.g(w.Debug,g([M,...W]))}info(M,...W){this.f(w.Info)&&this.g(w.Info,g([M,...W]))}warn(M,...W){this.f(w.Warning)&&this.g(w.Warning,g([M,...W]))}error(M,...W){if(this.f(w.Error))if(M instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=M.stack,this.g(w.Error,g(N))}else this.g(w.Error,g([M,...W]))}flush(){}}e.$ak=E;class a extends h{constructor(M=e.$0j){super(),this.setLevel(M),this.g=!u.$i}trace(M,...W){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}debug(M,...W){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}info(M,...W){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}warn(M,...W){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,M,...W):console.warn(`[main ${f()}]`,M,...W))}error(M,...W){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,M,...W):console.error(`[main ${f()}]`,M,...W))}flush(){}}e.$bk=a;class t extends h{constructor(M=e.$0j,W=!0){super(),this.g=W,this.setLevel(M)}trace(M,...W){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...W):console.log(M,...W))}debug(M,...W){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...W):console.log(M,...W))}info(M,...W){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...W):console.log(M,...W))}warn(M,...W){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...W):console.log(M,...W))}error(M,...W){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...W):console.error(M,...W))}flush(){}}e.$ck=t;class r extends h{constructor(M,W=e.$0j){super(),this.g=M,this.setLevel(W)}trace(M,...W){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(M),...W])}debug(M,...W){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(M),...W])}info(M,...W){this.f(w.Info)&&this.g.log(w.Info,[this.h(M),...W])}warn(M,...W){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(M),...W])}error(M,...W){this.f(w.Error)&&this.g.log(w.Error,[this.h(M),...W])}h(M){return typeof M=="string"?M:(0,A.$lj)(M,this.f(w.Trace))}flush(){}}e.$dk=r;class s extends h{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const W of this.g)W.setLevel(M);super.setLevel(M)}trace(M,...W){for(const N of this.g)N.trace(M,...W)}debug(M,...W){for(const N of this.g)N.debug(M,...W)}info(M,...W){for(const N of this.g)N.info(M,...W)}warn(M,...W){for(const N of this.g)N.warn(M,...W)}error(M,...W){for(const N of this.g)N.error(M,...W)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose();super.dispose()}}e.$ek=s;class i extends j.$Uc{constructor(M,W,N){if(super(),this.h=M,this.j=W,this.b=new k.$Ac,this.c=this.B(new S.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$he),this.onDidChangeVisibility=this.g.event,N)for(const T of N)this.b.set(T.resource,{logger:void 0,info:T})}m(M){return(0,d.$ag)(M)?[...this.b.values()].find(W=>W.info.id===M):this.b.get(M)}getLogger(M){return this.m(M)?.logger}createLogger(M,W){const N=this.n(M),T=(0,d.$ag)(M)?M:W?.id??(0,R.$oj)(N.toString()).toString(16);let U=this.b.get(N)?.logger;const ie=W?.logLevel==="always"?w.Trace:W?.logLevel;U||(U=this.s(N,ie??this.getLogLevel(N)??this.h,{...W,id:T}));const te={logger:U,info:{resource:N,id:T,logLevel:ie,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(te.info),this.b.set(N,te),U}n(M){return(0,d.$ag)(M)?(0,c.$bh)(this.j,`${M}.log`):M}setLogLevel(M,W){if(p.URI.isUri(M)){const N=M,T=W,U=this.b.get(N);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([N,T]))}else{this.h=M;for(const[N,T]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,W){const N=this.m(M);N&&W!==!N.info.hidden&&(N.info.hidden=!W,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,W]))}getLogLevel(M){let W;return M&&(W=this.b.get(M)?.info.logLevel),W??this.h}registerLogger(M){const W=this.b.get(M.resource);W?W.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const W=this.b.get(M);W&&(W.logger&&W.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=i;class o{constructor(){this.onDidChangeLogLevel=new S.$he().event}setLevel(M){}getLevel(){return w.Info}trace(M,...W){}debug(M,...W){}info(M,...W){}warn(M,...W){}error(M,...W){}critical(M,...W){}dispose(){}flush(){}}e.$gk=o;class l extends o{}e.$hk=l;function m(O){if(O.verbose)return w.Trace;if(typeof O.logLevel=="string"){const M=I(O.logLevel.toLowerCase());if(M!==void 0)return M}return e.$0j}function P(O){switch(O){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function D(O){switch(O){case w.Trace:return{original:"Trace",value:n.localize(0,null)};case w.Debug:return{original:"Debug",value:n.localize(1,null)};case w.Info:return{original:"Info",value:n.localize(2,null)};case w.Warning:return{original:"Warning",value:n.localize(3,null)};case w.Error:return{original:"Error",value:n.localize(4,null)};case w.Off:return{original:"Off",value:n.localize(5,null)}}}function I(O){switch(O){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$mk=new v.$Rj("logLevel",P(w.Info))});var ne=this&&this.__param||function(Q,e){return function(n,A){e(n,A,Q)}};define(re[224],oe([0,1,14,4,5]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;const R=n.safeStorage;let j=class{constructor(u){this.a=u,n.app.commandLine.getSwitchValue("password-store")==="basic"&&R.setUsePlainTextEncryption?.(!0)}async encrypt(u){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(R.encryptString(u));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(u){let c;try{if(c=JSON.parse(u),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${u}`);const d=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const p=R.decryptString(d);return this.a.trace("[EncryptionMainService] Decrypted value."),p}catch(d){throw this.a.error(d),d}}isEncryptionAvailable(){return Promise.resolve(R.isEncryptionAvailable())}getKeyStorageProvider(){if(A.$i)return Promise.resolve("dpapi");if(A.$j)return Promise.resolve("keychain_access");if(R.getSelectedStorageBackend)try{const u=R.getSelectedStorageBackend();return Promise.resolve(u)}catch(u){this.a.error(u)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(A.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(A.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!R.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");R.setUsePlainTextEncryption(!0)}};e.$rdc=j,e.$rdc=j=ke([ne(0,S.$7j)],j)}),define(re[225],oe([0,1,22,8,15,3,31,2,9,60,5]),function(Q,e,n,A,S,R,j,k,u,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;class p extends k.$Uc{constructor($,f){super(),this.a=$,this.b=f,this.c=this.B(new R.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$yh(0)),this.w=[],this.y=this.B(new A.$yh(0))}watch($,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n($,f):this.z($,f)}n($,f){const y={path:this.J($),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},w=(0,n.$Tb)(this.j,y);return this.r(),(0,k.$Sc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,S.$1)($))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,c.$Uq)(f)),f=>this.G(f),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const f of this.j)(0,c.$Qq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const f of this.j)(0,c.$Qq)(f)&&$.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,f){const y={path:this.J($),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},w=(0,n.$Tb)(this.w,y);return this.C(),(0,k.$Sc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,S.$1)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,c.$Uq)($)),$=>this.G($),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,u.$hc)($.fsPath)}J($){const f=this.I($);return(0,j.$Cg)(f)}}e.$1q=p}),define(re[226],oe([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let a=class extends c.$Uc{static{E=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new j.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$he),this.Y=this.B(new j.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$Jh)}registerProvider(r,s){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${r}`);const i=new c.$Tc;return this.h.set(r,s),this.c.fire({added:!0,scheme:r,provider:s}),i.add(s.onDidChangeFile(o=>{const l=new w.$nl(o,!this.S(s));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(o=>this.Z.fire(new Error(o)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:r}))),(0,c.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:s}),this.h.delete(r),(0,c.$Pc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const s=[];this.f.fire({scheme:r,join(i){s.push(i)}}),!this.h.has(r)&&await A.Promises.settled(s)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,s){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return u.Iterable.map(this.h,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async j(r){if(!(0,$.$fh)(r))throw new w.$pl((0,y.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const s=this.h.get(r.scheme);if(!s){const i=new h.$bb;throw i.message=(0,y.localize)(1,null,r.toString()),i}return s}async m(r){const s=await this.j(r);if((0,w.$al)(s)||(0,w.$0k)(s)||(0,w.$bl)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const s=await this.j(r);if((0,w.$al)(s)||(0,w.$0k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.s(r,s)}catch(i){throw(0,w.$kl)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$pl((0,y.localize)(2,null,this.sb(r)),1):(0,w.$il)(i)}}async s(r,s){const i=await this.j(r),o=this.S(i),l=s?.resolveTo,m=s?.resolveSingleChildDescendants,P=s?.resolveMetadata,D=await i.stat(r);let I;return this.t(i,r,D,void 0,!!P,(O,M)=>(I||(I=d.$Gi.forUris(()=>!o),I.set(r,!0),l&&I.fill(!0,l)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&m?M===1:!1))}async t(r,s,i,o,l,m){const{providerExtUri:P}=this.R(r),D={resource:s,name:P.basename(s),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Al)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&m(D,o)){try{const I=await r.readdir(s),O=await A.Promises.settled(I.map(async([M,W])=>{try{const N=P.joinPath(s,M),T=l?await r.stat(N):{type:W};return await this.t(r,N,T,I.length,l,m)}catch(N){return this.b.trace(N),null}}));D.children=(0,n.$Hb)(O)}catch(I){this.b.trace(I),D.children=[]}return D}return D}async resolveAll(r){return A.Promises.settled(r.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const s=await this.j(r),i=await s.stat(r);return this.t(s,r,i,void 0,!0,()=>!1)}async exists(r){const s=await this.j(r);try{return!!await s.stat(r)}catch{return!1}}async canCreateFile(r,s){try{await this.u(r,s)}catch(i){return i}return!0}async u(r,s){if(!s?.overwrite&&await this.exists(r))throw new w.$pl((0,y.localize)(3,null,this.sb(r)),3,s)}async createFile(r,s=S.$Je.fromString(""),i){await this.u(r,i);const o=await this.writeFile(r,s);return this.r.fire(new w.$ml(r,0,o)),o}async writeFile(r,s,i){const o=this.qb(await this.n(r),r),{providerExtUri:l}=this.R(o);let m=i;if((0,w.$dl)(o)&&!m?.atomic){const P=o.enforceAtomicWriteFile?.(r);P&&(m={...i,atomic:P})}try{await this.w(o,r,m)||await this.U(o,l.dirname(r));let D;if((0,w.$0k)(o)&&!(s instanceof S.$Je))if((0,f.$ve)(s)){const I=await(0,f.$Ce)(s,3);I.ended?D=S.$Je.concat(I.buffer):D=I}else D=(0,f.$ze)(s,I=>S.$Je.concat(I),3);else D=s;!(0,w.$al)(o)||(0,w.$0k)(o)&&D instanceof S.$Je||(0,w.$0k)(o)&&(0,w.$dl)(o)&&m?.atomic?await this.hb(o,r,m,D):await this.db(o,r,m,D instanceof S.$Je?(0,S.$Ue)(D):D),this.r.fire(new w.$ml(r,4))}catch(P){throw new w.$pl((0,y.localize)(4,null,this.sb(r),(0,w.$il)(P).toString()),(0,w.$ll)(P),m)}return this.resolve(r,{resolveMetadata:!0})}async w(r,s,i){const o=!!i?.unlock;if(o&&!(r.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(s)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(s)));if(!(r.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(s)));if(o)throw new Error((0,y.localize)(8,null,this.sb(s)))}let m;try{m=await r.stat(s)}catch{return}if(m.type&w.FileType.Directory)throw new w.$pl((0,y.localize)(9,null,this.sb(s)),0,i);if(this.rb(s,m),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$zl&&typeof m.mtime=="number"&&typeof m.size=="number"&&i.mtime<m.mtime&&i.etag!==(0,w.$Al)({mtime:i.mtime,size:m.size}))throw new w.$pl((0,y.localize)(10,null),3,i);return m}async readFile(r,s,i){const o=await this.m(r);return s?.atomic?this.z(o,r,s,i):this.C(o,r,s,i)}async z(r,s,i,o){return new Promise((l,m)=>{this.cb.queueFor(s,async()=>{try{const P=await this.C(r,s,i,o);l(P)}catch(P){m(P)}},this.R(r).providerExtUri)})}async C(r,s,i,o){const l=await this.D(r,s,{...i,preferUnbuffered:!0},o);return{...l,value:await(0,S.$Ve)(l.value)}}async readFileStream(r,s,i){const o=await this.m(r);return this.D(o,r,s,i)}async D(r,s,i,o){const l=new R.$se(o);let m=i;(0,w.$cl)(r)&&r.enforceAtomicReadFile?.(s)&&(m={...i,atomic:!0});const P=this.J(s,m).then(I=>I,I=>{throw l.dispose(!0),I});let D;try{return typeof m?.etag=="string"&&m.etag!==w.$zl&&await P,m?.atomic&&(0,w.$cl)(r)||!((0,w.$al)(r)||(0,w.$bl)(r))||(0,w.$0k)(r)&&m?.preferUnbuffered?D=this.I(r,s,m):(0,w.$bl)(r)?D=this.G(r,s,l.token,m):D=this.H(r,s,l.token,m),D.on("end",()=>l.dispose()),D.on("error",()=>l.dispose()),{...await P,value:D}}catch(I){throw D&&await(0,f.$Ae)(D),this.F(I,s,m)}}F(r,s,i){const o=(0,y.localize)(11,null,this.sb(s),(0,w.$il)(r).toString());return r instanceof w.$rl?new w.$rl(o,r.stat,i):r instanceof w.$ql?new w.$ql(o,r.fileOperationResult,r.size,r.options):new w.$pl(o,(0,w.$ll)(r),i)}G(r,s,i,o=Object.create(null)){const l=r.readFileStream(s,o,i);return(0,f.$Ge)(l,{data:m=>m instanceof S.$Je?m:S.$Je.wrap(m),error:m=>this.F(m,s,o)},m=>S.$Je.concat(m))}H(r,s,i,o=Object.create(null)){const l=(0,S.$Ze)();return(0,b.$Nq)(r,s,l,m=>m,{...o,bufferSize:this.a,errorTransformer:m=>this.F(m,s,o)},i),l}I(r,s,i){const o=(0,f.$xe)(l=>S.$Je.concat(l));return(async()=>{try{let l;i?.atomic&&(0,w.$cl)(r)?l=await r.readFile(s,{atomic:!0}):l=await r.readFile(s),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.L(s,l.byteLength,i),o.end(S.$Je.wrap(l))}catch(l){o.error(l),o.end()}})(),o}async J(r,s){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new w.$pl((0,y.localize)(12,null,this.sb(r)),0,s);if(typeof s?.etag=="string"&&s.etag!==w.$zl&&s.etag===i.etag)throw new w.$rl((0,y.localize)(13,null),i,s);return this.L(r,i.size,s),i}L(r,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new w.$ql((0,y.localize)(14,null,this.sb(r)),7,s,i)}async canMove(r,s,i){return this.M(r,s,"move",i)}async canCopy(r,s,i){return this.M(r,s,"copy",i)}async M(r,s,i,o){if(r.toString()!==s.toString())try{const l=i==="move"?this.qb(await this.n(r),r):await this.m(r),m=this.qb(await this.n(s),s);await this.Q(l,r,m,s,i,o)}catch(l){return l}return!0}async move(r,s,i){const o=this.qb(await this.n(r),r),l=this.qb(await this.n(s),s),m=await this.N(o,r,l,s,"move",!!i),P=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new w.$ml(r,m==="move"?2:3,P)),P}async copy(r,s,i){const o=await this.m(r),l=this.qb(await this.n(s),s),m=await this.N(o,r,l,s,"copy",!!i),P=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new w.$ml(r,m==="copy"?3:2,P)),P}async N(r,s,i,o,l,m){if(s.toString()===o.toString())return l;const{exists:P,isSameResourceWithDifferentPathCase:D}=await this.Q(r,s,i,o,l,m);if(P&&!D&&m&&await this.del(o,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(o)),l==="copy"){if(r===i&&(0,w.$$k)(r))await r.copy(s,o,{overwrite:m});else{const I=await this.resolve(s);I.isDirectory?await this.P(r,I,i,o):await this.O(r,s,i,o)}return l}else return r===i?(await r.rename(s,o,{overwrite:m}),l):(await this.N(r,s,i,o,"copy",m),await this.del(s,{recursive:!0}),"copy")}async O(r,s,i,o){if((0,w.$al)(r)&&(0,w.$al)(i))return this.jb(r,s,i,o);if((0,w.$al)(r)&&(0,w.$0k)(i))return this.pb(r,s,i,o);if((0,w.$0k)(r)&&(0,w.$al)(i))return this.nb(r,s,i,o);if((0,w.$0k)(r)&&(0,w.$0k)(i))return this.lb(r,s,i,o)}async P(r,s,i,o){await i.mkdir(o),Array.isArray(s.children)&&await A.Promises.settled(s.children.map(async l=>{const m=this.R(i).providerExtUri.joinPath(o,l.name);return l.isDirectory?this.P(r,await this.resolve(l.resource),i,m):this.O(r,l.resource,i,m)}))}async Q(r,s,i,o,l,m){let P=!1;if(r===i){const{providerExtUri:I,isPathCaseSensitive:O}=this.R(r);if(O||(P=I.isEqual(s,o)),P&&l==="copy")throw new Error((0,y.localize)(15,null,this.sb(s),this.sb(o)));if(!P&&I.isEqualOrParent(o,s))throw new Error((0,y.localize)(16,null,this.sb(s),this.sb(o)))}const D=await this.exists(o);if(D&&!P){if(!m)throw new w.$pl((0,y.localize)(17,null,this.sb(s),this.sb(o)),4);if(r===i){const{providerExtUri:I}=this.R(r);if(I.isEqualOrParent(s,o))throw new Error((0,y.localize)(18,null,this.sb(s),this.sb(o)))}}return{exists:D,isSameResourceWithDifferentPathCase:P}}R(r){const s=this.S(r);return{providerExtUri:s?$.$4g:$.$6g,isPathCaseSensitive:s}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.qb(await this.j(r),r);await this.U(s,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$ml(r,0,i)),i}async U(r,s){const i=[],{providerExtUri:o}=this.R(r);for(;!o.isEqual(s,o.dirname(s));)try{if(!((await r.stat(s)).type&w.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(s)));break}catch(l){if((0,w.$kl)(l)!==w.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(o.basename(s)),s=o.dirname(s)}for(let l=i.length-1;l>=0;l--){s=o.joinPath(s,i[l]);try{await r.mkdir(s)}catch(m){if((0,w.$kl)(m)!==w.FileSystemProviderErrorCode.FileExists)throw m}}}async canDelete(r,s){try{await this.W(r,s)}catch(i){return i}return!0}async W(r,s){const i=this.qb(await this.j(r),r),o=!!s?.useTrash;if(o&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(r)));const l=s?.atomic;if(l&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(r)));if(o&&l)throw new Error((0,y.localize)(22,null,this.sb(r)));let m;try{m=await i.stat(r)}catch{}if(m)this.rb(r,m);else throw new w.$pl((0,y.localize)(23,null,this.sb(r)),1);if(!!!s?.recursive){const D=await this.resolve(r);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(r)))}return i}async del(r,s){const i=await this.W(r,s);let o=s;if((0,w.$el)(i)&&!o?.atomic){const D=i.enforceAtomicDelete?.(r);D&&(o={...s,atomic:D})}const l=!!o?.useTrash,m=!!o?.recursive,P=o?.atomic??!1;await i.delete(r,{recursive:m,useTrash:l,atomic:P}),this.r.fire(new w.$ml(r,1))}async cloneFile(r,s){const i=await this.j(r),o=this.qb(await this.n(s),s);if(!(i===o&&this.R(i).providerExtUri.isEqual(r,s)))return i===o&&(0,w.$_k)(i)?i.cloneFile(r,s):(await this.U(o,this.R(o).providerExtUri.dirname(s)),i===o&&(0,w.$$k)(i)?this.cb.queueFor(r,()=>i.copy(r,s,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,o,s),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,s){return this.watch(r,{...s,correlationId:E.ab++})}watch(r,s={recursive:!1,excludes:[]}){const i=new c.$Tc;let o=!1,l=()=>{o=!0};i.add((0,c.$Sc)(()=>l())),(async()=>{try{const P=await this.bb(r,s);o?(0,c.$Pc)(P):l=()=>(0,c.$Pc)(P)}catch(P){this.b.error(P)}})();const m=s.correlationId;if(typeof m=="number"){const P=i.add(new j.$he);return i.add(this.X.event(I=>{I.correlates(m)&&P.fire(I)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(r,s){const i=await this.j(r),o=(0,k.$oj)([this.R(i).providerExtUri.getComparisonKey(r),s]);let l=this.$.get(o);return l||(l={count:0,disposable:i.watch(r,s)},this.$.set(o,l)),l.count+=1,(0,c.$Sc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Pc)(l.disposable),this.$.delete(o)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,c.$Pc)(r.disposable);this.$.clear()}async db(r,s,i,o){return this.cb.queueFor(s,async()=>{const l=await r.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,f.$ve)(o)||(0,f.$we)(o)?await this.eb(r,l,o):await this.fb(r,l,o)}catch(m){throw(0,w.$il)(m)}finally{await r.close(l)}},this.R(r).providerExtUri)}async eb(r,s,i){let o=0,l;if((0,f.$we)(i)){if(i.buffer.length>0){const m=S.$Je.concat(i.buffer);await this.gb(r,s,m,m.byteLength,o,0),o+=m.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise((m,P)=>{(0,f.$Be)(l,{onData:async D=>{l.pause();try{await this.gb(r,s,D,D.byteLength,o,0)}catch(I){return P(I)}o+=D.byteLength,setTimeout(()=>l.resume())},onError:D=>P(D),onEnd:()=>m()})})}async fb(r,s,i){let o=0,l;for(;(l=i.read())!==null;)await this.gb(r,s,l,l.byteLength,o,0),o+=l.byteLength}async gb(r,s,i,o,l,m){let P=0;for(;P<o;){const D=await r.write(s,l+P,i.buffer,m+P,o-P);P+=D}}async hb(r,s,i,o){return this.cb.queueFor(s,()=>this.ib(r,s,i,o),this.R(r).providerExtUri)}async ib(r,s,i,o){let l;o instanceof S.$Je?l=o:(0,f.$ve)(o)?l=await(0,S.$Ve)(o):(0,f.$we)(o)?l=await(0,S.$We)(o):l=(0,S.$Te)(o),await r.writeFile(s,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,s,i,o){return this.cb.queueFor(o,()=>this.kb(r,s,i,o),this.R(i).providerExtUri)}async kb(r,s,i,o){let l,m;try{l=await r.open(s,{create:!1}),m=await i.open(o,{create:!0,unlock:!1});const P=S.$Je.alloc(this.a);let D=0,I=0,O=0;do O=await r.read(l,D,P.buffer,I,P.byteLength-I),await this.gb(i,m,P,O,D,I),D+=O,I+=O,I===P.byteLength&&(I=0);while(O>0)}catch(P){throw(0,w.$il)(P)}finally{await A.Promises.settled([typeof l=="number"?r.close(l):Promise.resolve(),typeof m=="number"?i.close(m):Promise.resolve()])}}async lb(r,s,i,o){return this.cb.queueFor(o,()=>this.mb(r,s,i,o),this.R(i).providerExtUri)}async mb(r,s,i,o){return i.writeFile(o,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,s,i,o){return this.cb.queueFor(o,()=>this.ob(r,s,i,o),this.R(i).providerExtUri)}async ob(r,s,i,o){const l=await i.open(o,{create:!0,unlock:!1});try{const m=await r.readFile(s);await this.gb(i,l,S.$Je.wrap(m),m.byteLength,0,0)}catch(m){throw(0,w.$il)(m)}finally{await i.close(l)}}async pb(r,s,i,o){const l=await(0,S.$Ve)(this.H(r,s,R.CancellationToken.None));await this.hb(i,o,void 0,l)}qb(r,s){if(r.capabilities&2048)throw new w.$pl((0,y.localize)(25,null,this.sb(s)),6);return r}rb(r,s){if((s.permissions??0)&w.FilePermission.Readonly)throw new w.$pl((0,y.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===p.Schemas.file?r.fsPath:r.toString(!0)}};e.$Oq=a,e.$Oq=a=E=ke([ne(0,g.$7j)],a)}),define(re[94],oe([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0,(()=>{try{(0,A.gracefulify)(n)}catch(r){console.error(`Error enabling graceful-fs: ${(0,h.$lj)(r)}`)}})();class t extends g.$1q{static{this.L=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=k.Event.None,this.P=new R.$Ac(o=>v.$5g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,p.$k&&(this.M|=1024)),this.M}async stat(s){try{const{stat:i,symbolicLink:o}=await f.SymlinkSupport.stat(this.I(s));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await f.Promises.readdir(this.I(s),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async l=>{try{let m;l.isSymbolicLink()?m=(await this.stat((0,v.$bh)(s,l.name))).type:m=this.O(l),o.push([l.name,m])}catch(m){this.a.trace(m)}})),o}catch(i){throw this.hb(i)}}O(s,i){let o;return i?.dangling?o=w.FileType.Unknown:s.isFile()?o=w.FileType.File:s.isDirectory()?o=w.FileType.Directory:o=w.FileType.Unknown,i&&(o|=w.FileType.SymbolicLink),o}async Q(s){const i=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const l=new S.$zh;return this.P.set(s,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(s)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(s,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),o=await this.Q(s));const l=this.I(s);return await f.Promises.readFile(l)}catch(l){throw this.hb(l)}finally{o?.dispose()}}R(s){t.L&&this.a.trace(s)}readFileStream(s,i,o){const l=(0,$.$xe)(m=>j.$Je.concat(m.map(P=>j.$Je.wrap(P))).buffer);return(0,b.$Nq)(this,s,l,m=>m.buffer,{...i,bufferSize:256*1024},o),l}async writeFile(s,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(s)?this.U(s,(0,v.$bh)((0,v.$ah)(s),`${(0,v.$$g)(s)}${o.atomic.postfix}`),i,o):this.W(s,i,o)}async S(s){try{const i=this.I(s),{symbolicLink:o}=await f.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(s,i,o,l){const m=new c.$Tc;try{m.add(await this.Q(s)),m.add(await this.Q(i)),await this.W(i,o,l,!0);try{await this.rename(i,s,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{m.dispose()}}async W(s,i,o,l){let m;try{const P=this.I(s);if(!o.create||!o.overwrite){if(await f.Promises.exists(P)){if(!o.overwrite)throw(0,w.$hl)((0,y.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,w.$hl)((0,y.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(s,{create:!0,unlock:o.unlock},l),await this.write(m,0,i,0,i.byteLength)}catch(P){throw await this.ib(s,P)}finally{typeof m=="number"&&await this.close(m)}}static{this.$=!0}static configureFlushOnWrite(s){t.$=s}async open(s,i,o){const l=this.I(s);let m;(0,w.$8k)(i)&&!o&&(m=await this.Q(s));let P;try{if((0,w.$8k)(i)&&i.unlock)try{const{stat:I}=await f.SymlinkSupport.stat(l);I.mode&128||await f.Promises.chmod(l,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let D;if((0,w.$8k)(i)){if(p.$i)try{await f.Promises.truncate(l,0),D="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}D||(D="w")}else D="r";P=await f.Promises.open(l,D)}catch(D){throw m?.dispose(),(0,w.$8k)(i)?await this.ib(s,D):this.hb(D)}if(this.X.set(P,0),(0,w.$8k)(i)&&this.Z.set(P,s),m){const D=this.Y.get(P);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${l})`),this.Y.set(P,m),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${l})`),D.dispose())}return P}async close(s){const i=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&t.$)try{await f.Promises.fdatasync(s)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await f.Promises.close(s)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(s)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,o,l,m){const P=this.ab(s,i);let D=null;try{D=(await f.Promises.read(s,o,l,m,P)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(s,P,D)}return D}ab(s,i){return i===this.X.get(s)?null:i}bb(s,i,o){const l=this.X.get(s);typeof l=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(s,l+o):this.X.delete(s)))}async write(s,i,o,l,m){return(0,S.$Uh)(()=>this.cb(s,i,o,l,m),100,3)}async cb(s,i,o,l,m){const P=this.ab(s,i);let D=null;try{D=(await f.Promises.write(s,o,l,m,P)).bytesWritten}catch(I){throw await this.ib(this.Z.get(s),I)}finally{this.bb(s,P,D)}return D}async mkdir(s){try{await f.Promises.mkdir(this.I(s))}catch(i){throw this.hb(i)}}async delete(s,i){try{const o=this.I(s);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,d.$jc)((0,d.$mc)(o),`${(0,d.$nc)(o)}${i.atomic.postfix}`)),await f.Promises.rm(o,f.RimRafMode.MOVE,l)}else try{await f.Promises.unlink(o)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let m=!1;try{const{stat:P,symbolicLink:D}=await f.SymlinkSupport.stat(o);m=P.isDirectory()&&!D}catch{}if(m)await f.Promises.rmdir(o);else throw l}else throw l}}catch(o){throw this.hb(o)}}async rename(s,i,o){const l=this.I(s),m=this.I(i);if(l!==m)try{await this.db(s,i,"move",o.overwrite),await f.Promises.rename(l,m)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,d.$nc)(l),(0,d.$nc)((0,d.$mc)(m)),P.toString()))),this.hb(P)}}async copy(s,i,o){const l=this.I(s),m=this.I(i);if(l!==m)try{await this.db(s,i,"copy",o.overwrite),await f.Promises.copy(l,m,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,d.$nc)(l),(0,d.$nc)((0,d.$mc)(m)),P.toString()))),this.hb(P)}}async db(s,i,o,l){const m=this.I(s),P=this.I(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,u.$yg)(m,P,!0)),D){if(o==="copy")throw(0,w.$hl)((0,y.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const O=await this.N(s);if(!O)throw(0,w.$hl)((0,y.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const M=await this.N(i);if(M){if(!l)throw(0,w.$hl)((0,y.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);O.type&w.FileType.File&&M.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.eb(s,i,!1)}async eb(s,i,o){const l=this.I(s),m=this.I(i),P=!!(this.capabilities&1024);if((0,u.$yg)(l,m,!P))return;const D=new c.$Tc;try{D.add(await this.Q(s)),D.add(await this.Q(i)),o&&await f.Promises.mkdir((0,d.$mc)(m),{recursive:!0}),await f.Promises.copyFile(l,m)}catch(I){if(I.code==="ENOENT"&&!o)return this.eb(s,i,!0);throw this.hb(I)}finally{D.dispose()}}t(s,i,o){return new E.$8q(l=>s(l),l=>i(l),o)}F(s,i,o){return new a.$er(l=>s(l),l=>i(l),o)}hb(s){if(s instanceof w.$gl)return s;let i=s,o;switch(s.code){case"ENOENT":o=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=w.FileSystemProviderErrorCode.Unknown;break;default:o=w.FileSystemProviderErrorCode.Unknown}return(0,w.$hl)(i,o)}async ib(s,i){let o=this.hb(i);if(s&&o.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await f.SymlinkSupport.stat(this.I(s));l.mode&128||(o=(0,w.$hl)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return o}}e.$fr=t}),define(re[227],oe([0,1,3,94,2,17,63,23]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=e.$Ps=void 0;class u extends S.$Uc{constructor(p,v){super(),this.a=p,this.b=v,this.F=new Map,this.G=new Map}call(p,v,$){const f=this.c(p);switch(v){case"stat":return this.g(f,$[0]);case"readdir":return this.h(f,$[0]);case"open":return this.r(f,$[0],$[1]);case"close":return this.s($[0]);case"read":return this.t($[0],$[1],$[2]);case"readFile":return this.j(f,$[0],$[1]);case"write":return this.u($[0],$[1],$[2],$[3],$[4]);case"writeFile":return this.n(f,$[0],$[1],$[2]);case"rename":return this.z(f,$[0],$[1],$[2]);case"copy":return this.C(f,$[0],$[1],$[2]);case"cloneFile":return this.D(f,$[0],$[1]);case"mkdir":return this.w(f,$[0]);case"delete":return this.y(f,$[0],$[1]);case"watch":return this.I(f,$[0],$[1],$[2],$[3]);case"unwatch":return this.J($[0],$[1])}throw new Error(`IPC Command ${v} not found`)}listen(p,v,$){const f=this.c(p);switch(v){case"fileChange":return this.H(f,$[0]);case"readFileStream":return this.m(f,$[0],$[1])}throw new Error(`Unknown event ${v}`)}g(p,v){const $=this.f(p,v,!0);return this.a.stat($)}h(p,v){const $=this.f(p,v);return this.a.readdir($)}async j(p,v,$){const f=this.f(p,v,!0),y=await this.a.readFile(f,$);return R.$Je.wrap(y)}m(p,v,$){const f=this.f(p,v,!0),y=new k.$se,w=new n.$he({onDidRemoveLastListener:()=>{y.cancel()}}),b=this.a.readFileStream(f,$,y.token);return(0,j.$Be)(b,{onData:g=>w.fire(R.$Je.wrap(g)),onError:g=>w.fire(g),onEnd:()=>{w.fire("end"),w.dispose(),y.dispose()}}),w.event}n(p,v,$,f){const y=this.f(p,v);return this.a.writeFile(y,$.buffer,f)}r(p,v,$){const f=this.f(p,v,!0);return this.a.open(f,$)}s(p){return this.a.close(p)}async t(p,v,$){const f=R.$Je.alloc($),w=await this.a.read(p,v,f.buffer,0,$);return[f,w]}u(p,v,$,f,y){return this.a.write(p,v,$.buffer,f,y)}w(p,v){const $=this.f(p,v);return this.a.mkdir($)}y(p,v,$){const f=this.f(p,v);return this.a.delete(f,$)}z(p,v,$,f){const y=this.f(p,v),w=this.f(p,$);return this.a.rename(y,w,f)}C(p,v,$,f){const y=this.f(p,v),w=this.f(p,$);return this.a.copy(y,w,f)}D(p,v,$){const f=this.f(p,v),y=this.f(p,$);return this.a.cloneFile(f,y)}H(p,v){const $=new n.$he({onWillAddFirstListener:()=>{this.F.set(v,this.L(p,$))},onDidRemoveLastListener:()=>{(0,S.$Pc)(this.F.get(v)),this.F.delete(v)}});return $.event}async I(p,v,$,f,y){const w=this.F.get(v);if(w){const b=this.f(p,f),g=w.watch($,b,y);this.G.set(v+$,g)}}async J(p,v){const $=p+v,f=this.G.get($);f&&((0,S.$Pc)(f),this.G.delete($))}dispose(){super.dispose();for(const[,p]of this.G)p.dispose();this.G.clear();for(const[,p]of this.F)p.dispose();this.F.clear()}}e.$Ps=u;class c extends S.$Uc{constructor(p,v,$,f){super(),this.c=p,this.f=$,this.g=f,this.a=new Map,this.b=this.B(new A.$fr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(p){const v=this.B(new n.$he);this.B(v.event($=>{p.fire($.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile($=>v.fire($))),this.B(this.b.onDidWatchError($=>p.fire($)))}j(p){}m(p){}watch(p,v,$){const f=this.m(this.g);return Array.isArray(f)&&($.excludes=[...$.excludes,...f]),this.a.set(p,this.b.watch(v,$)),(0,S.$Sc)(()=>{(0,S.$Pc)(this.a.get(p)),this.a.delete(p)})}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),super.dispose()}}e.$Qs=c}),define(re[228],oe([0,1,14,180,4,7,16,9,227,157,47]),function(Q,e,n,A,S,R,j,k,u,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class p extends u.$Ps{constructor(f,y,w){super(f,y),this.M=w}c(f){return c.$Dn}f(f,y){return R.URI.revive(y)}async y(f,y,w){if(!w.useTrash)return super.y(f,y,w);const b=this.f(f,y),g=(0,k.$hc)(b.fsPath);try{await n.shell.trashItem(g)}catch(h){throw(0,j.$hl)(S.$i?(0,A.localize)(0,null,(0,k.$nc)(g),(0,d.$lj)(h)):(0,A.localize)(1,null,(0,k.$nc)(g),(0,d.$lj)(h)),j.FileSystemProviderErrorCode.Unknown)}}L(f,y){return new v(f,y,this.b,this.M)}}e.$zdc=p;class v extends u.$Qs{watch(f,y,w){if(w.recursive)throw(0,j.$hl)("Recursive file watching is not supported from main process for performance reasons.",j.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,w)}}}),define(re[229],oe([0,1,5]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;class A extends n.$ak{constructor(R=n.$0j){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(j=>{this.n?.setLevel(j)}))}set logger(R){this.n=R;for(const{level:j,message:k}of this.m)(0,n.log)(R,j,k);this.m=[]}g(R,j){this.n?(0,n.log)(this.n,R,j):this.getLevel()<=R&&this.m.push({level:R,message:j})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$oac=A}),define(re[230],oe([0,1,7,3,5,2]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=void 0;class j extends S.$fk{constructor(p,v,$,f,y){super(v,$,f),this.r=p,this.t=y,this.B(y.listen("onDidChangeLogLevel",p)(w=>{(0,S.$9j)(w)?super.setLogLevel(w):super.setLogLevel(n.URI.revive(w[0]),w[1])})),this.B(y.listen("onDidChangeVisibility",p)(([w,b])=>super.setVisibility(n.URI.revive(w),b))),this.B(y.listen("onDidChangeLoggers",p)(({added:w,removed:b})=>{for(const g of w)super.registerLogger({...g,resource:n.URI.revive(g.resource)});for(const g of b)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new S.$dk({log:(p,v)=>{this.t.call("consoleLog",[p,v])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,v){super.setLogLevel(p,v),this.t.call("setLogLevel",[p,v])}setVisibility(p,v){super.setVisibility(p,v),this.t.call("setVisibility",[this.n(p),v])}s(p,v,$){return new k(this.t,p,v,$,this.r)}static setLogLevel(p,v,$){return p.call("setLogLevel",[v,$])}}e.$fs=j;class k extends S.$ak{constructor(p,v,$,f,y){super(f?.logLevel==="always"),this.r=p,this.s=v,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[v,f,y]).then(()=>{this.u(this.n),this.m=!0})}g(p,v){const $=[[p,v]];this.m?this.u($):this.n.push(...$)}u(p){this.r.call("log",[this.s,p])}}class u{constructor(p,v){this.a=p,this.b=v}listen(p,v){const $=this.b(p);switch(v){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(y=>this.c(y,$)),removed:[...f.removed].map(y=>this.c(y,$))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,f=>[$.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,f=>(0,S.$9j)(f)?f:[$.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${v}`)}async call(p,v,$){const f=this.b(p);switch(v){case"setLogLevel":return(0,S.$9j)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,f)))}throw new Error(`Call not found: ${v}`)}c(p,v){return{...p,resource:v.transformOutgoingURI(p.resource)}}}e.$gs=u;class c extends R.$Uc{constructor(p,v){super(),v.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel($=>v.call("setLogLevel",[$]))),v.call("getRegisteredLoggers").then($=>{for(const f of $)p.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(v.listen("onDidChangeVisibility")(([$,f])=>p.setVisibility(n.URI.revive($),f))),this.B(v.listen("onDidChangeLoggers")(({added:$,removed:f})=>{for(const y of $)p.registerLogger({...y,resource:n.URI.revive(y.resource)});for(const y of f)p.deregisterLogger(y.resource)}))}}e.$hs=c}),define(re[231],oe([0,1,2,5]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;class S extends n.$Uc{constructor(j,k=[]){super(),this.a=new A.$ek([j,...k]),this.B(j.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...k){this.a.trace(j,...k)}debug(j,...k){this.a.debug(j,...k)}info(j,...k){this.a.info(j,...k)}warn(j,...k){this.a.warn(j,...k)}error(j,...k){this.a.error(j,...k)}flush(){this.a.flush()}}e.$fQ=S}),define(re[232],oe([0,1,32,7,5]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class R{constructor(k){this.b=k,this.a=new n.$Ac}listen(k,u,c){switch(u){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${u}`)}async call(k,u,c){switch(u){case"createLogger":this.c(A.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(A.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,S.$9j)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(A.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:A.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(c[0]))}throw new Error(`Call not found: ${u}`)}c(k,u,c){this.a.set(k,this.b.createLogger(k,u,c))}d(k,u){let c=console.log;switch(k){case S.LogLevel.Error:c=console.error;break;case S.LogLevel.Warning:c=console.warn;break;case S.LogLevel.Info:c=console.info;break}c.call(console,...u)}e(k,u){const c=this.a.get(k);if(!c)throw new Error("Create the logger before logging");for(const[d,p]of u)(0,S.log)(c,d,p)}}e.$uec=R}),define(re[233],oe([0,1,16,5]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=void 0;var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S||(S={}));async function R(c,d,p,v,$){try{const f=await new Promise((w,b)=>{Q(["@vscode/spdlog"],w,b)});f.setFlushOn(S.Trace);const y=await f.createAsyncRotatingLogger(c,d,p,v);return $?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(f){console.error(f)}return null}function j(c,d,p){switch(d){case A.LogLevel.Trace:c.trace(p);break;case A.LogLevel.Debug:c.debug(p);break;case A.LogLevel.Info:c.info(p);break;case A.LogLevel.Warning:c.warn(p);break;case A.LogLevel.Error:c.error(p);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function k(c,d){switch(d){case A.LogLevel.Trace:c.setLevel(S.Trace);break;case A.LogLevel.Debug:c.setLevel(S.Debug);break;case A.LogLevel.Info:c.setLevel(S.Info);break;case A.LogLevel.Warning:c.setLevel(S.Warning);break;case A.LogLevel.Error:c.setLevel(S.Error);break;case A.LogLevel.Off:c.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class u extends A.$ak{constructor(d,p,v,$,f){super(),this.m=[],this.setLevel(f),this.n=this.s(d,p,v,$),this.B(this.onDidChangeLogLevel(y=>{this.r&&k(this.r,y)}))}async s(d,p,v,$){const f=v?6:1,y=30/f*n.$Cl.MB,w=await R(d,p,y,f,$);if(w){this.r=w,k(this.r,this.getLevel());for(const{level:b,message:g}of this.m)j(this.r,b,g);this.m=[]}}g(d,p){this.r?j(this.r,d,p):this.getLevel()<=d&&this.m.push({level:d,message:p})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$7P=u}),define(re[234],oe([0,1,33,5,233]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=void 0;class R extends A.$fk{s(k,u,c){return new S.$7P((0,n.$Wg)(),k.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$8P=R}),define(re[67],oe([0,1,32,3,6,5,234]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=e.$7cc=void 0,e.$7cc=(0,S.$Bi)(R.$8j);class k extends j.$8P{constructor(){super(...arguments),this.u=new n.$Ac}createLogger(c,d,p){p!==void 0&&this.u.set(this.n(c),p);try{return super.createLogger(c,d)}catch(v){throw this.u.delete(this.n(c)),v}}registerLogger(c,d){d!==void 0&&this.u.set(c.resource,d),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const d=[];for(const p of super.getRegisteredLoggers())c===this.u.get(p.resource)&&d.push(p);return d}getOnDidChangeLogLevelEvent(c){return A.Event.filter(this.onDidChangeLogLevel,d=>(0,R.$9j)(d)||this.w(d[0],c))}getOnDidChangeVisibilityEvent(c){return A.Event.filter(this.onDidChangeVisibility,([d])=>this.w(d,c))}getOnDidChangeLoggersEvent(c){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,d=>({added:[...d.added].filter(v=>this.w(v.resource,c)),removed:[...d.removed].filter(v=>this.w(v.resource,c))})),d=>d.added.length>0||d.removed.length>0)}deregisterLoggers(c){for(const[d,p]of this.u)p===c&&this.deregisterLogger(d)}w(c,d){const p=this.u.get(c);return p===void 0||p===d}dispose(){super.dispose(),this.u.clear()}}e.$8cc=k}),define(re[235],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=n,e.$Ndc=A,e.$Odc=S,e.$Pdc=R;function n(j){return j.submenu!==void 0}function A(j){return j.id==="vscode.menubar.separator"}function S(j){return j.uri!==void 0}function R(j){return!n(j)&&!A(j)&&!S(j)}}),define(re[39],oe([0,1,3,71,2,6]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=void 0,e.$jo=(0,R.$Ai)("policy");class j extends S.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const d=Object.keys(this.f).length;return this.f={...c,...this.f},d!==Object.keys(this.f).length&&await this.j(c),A.Iterable.reduce(this.g.entries(),(p,[v,$])=>({...p,[v]:$}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(c,[d,p])=>({...c,[d]:{definition:p,value:this.g.get(d)}}),{})}}e.$ko=j;class k{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$lo=k}),define(re[236],oe([0,1,8,3,71,12,16,5,39]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;function c(p,v){const $=[];for(const f of new Set(S.Iterable.concat(p.keys(),v.keys())))p.get(f)!==v.get(f)&&$.push(f);return $}let d=class extends u.$ko{constructor(v,$,f){super(),this.m=v,this.n=$,this.s=f,this.c=this.B(new n.$yh(500));const y=A.Event.filter($.onDidFilesChange,w=>w.affects(v));this.B($.watch(v)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const $=await this.n.readFile(this.m),f=JSON.parse($.value.toString());if(!(0,R.$cg)(f))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(f))this.f[y]&&v.set(y,f[y])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return v}async w(){const v=await this.u(),$=c(this.g,v);this.g=v,$.length>0&&this.h.fire($)}};e.$Nec=d,e.$Nec=d=ke([ne(1,j.$7k),ne(2,k.$7j)],d)}),define(re[237],oe([0,1,3,2,39]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=e.$lec=void 0;class R{constructor(u){this.b=u,this.a=new A.$Tc}listen(u,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,d=>d.reduce((p,v)=>({...p,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(u,c,d){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(d)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$lec=R;class j extends S.$ko{constructor(u,c){super(),this.a=c;for(const d in u){const{definition:p,value:v}=u[d];this.f[d]=p,v!==void 0&&this.g.set(d,v)}this.a.listen("onDidChange")(d=>{for(const p in d){const v=d[p];v===null?this.g.delete(p):this.g.set(p,v)}this.h.fire(Object.keys(d))})}async j(u){const c=await this.a.call("updatePolicyDefinitions",u);for(const d in c)this.g.set(d,c[d])}}e.$mec=j}),define(re[238],oe([0,1,39,8,2,5]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;let j=class extends n.$ko{constructor(u,c){super(),this.m=u,this.n=c,this.a=new A.$uh,this.b=this.B(new S.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:c}=await new Promise((d,p)=>{Q(["@vscode/policy-watcher"],d,p)});await this.a.queue(()=>new Promise((d,p)=>{try{this.b.value=c(this.n,u,v=>{this.t(v),d()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),p(v)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const c in u){const d=u[c];d===void 0?this.g.delete(c):this.g.set(c,d)}this.h.fire(Object.keys(u))}};e.$Mec=j,e.$Mec=j=ke([ne(0,R.$7j)],j)}),define(re[80],oe([0,1,36]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const R=S.context.configuration();if(R)A=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:R.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(re[27],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,n.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(re[239],oe([0,1,8,5]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;let S=class{constructor(j,k,u){this.a=j,this.b=k,this.c=u}async inspect(j){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$Bh)(j);const u=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),u.profile}async d(){const j=this.a.webContents.debugger;j.attach(),await j.sendCommand("Profiler.enable")}async e(){const j=this.a.webContents.debugger;await j.sendCommand("Profiler.disable"),j.detach()}};e.$Cdc=S,e.$Cdc=S=ke([ne(2,A.$7j)],S)}),define(re[81],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0,e.$Pcc=(0,n.$Ai)("protocolMainService")}),define(re[45],oe([0,1,139,12]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=void 0;class S{constructor(){this.a=new Map}add(j,k){n.ok(A.$ag(j)),n.ok(A.$cg(k)),n.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,k)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$ho=new S}),define(re[240],oe([0,1,3,45]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=void 0,e.$io={JSONContribution:"base.contributions.json"};function S(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class R{constructor(){this.b=new n.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[S(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const j=new R;A.$ho.add(e.$io.JSONContribution,j)}),define(re[52],oe([0,1,22,3,12,165,18,240,45]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ConfigurationScope=e.$mo=e.EditPresentationTypes=void 0,e.$xo=y,e.$yo=w,e.$zo=b,e.$Ao=h,e.$Bo=E;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$mo={Configuration:"base.contributions.configuration"};var d;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to="vscode://schemas/settings/resourceLanguage",e.$uo="vscode://schemas/settings/configurationDefaults";const p=u.$ho.as(k.$io.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.$he,this.onDidSchemaChange=this.i.event,this.j=new A.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.$to,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.n(t,r,s),p.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.o(t,r),p.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.o(r,s),this.n(t,!1,s),p.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const s=[];for(const{overrides:i,source:o}of t)for(const l in i)if(r.add(l),e.$wo.test(l)){const m=this.a.get(l),P=m?.valuesSources??new Map;if(o)for(const M of Object.keys(i[l]))P.set(M,o);const D={...m?.value||{},...i[l]};this.a.set(l,{source:o,value:D,valuesSources:P});const I=(0,j.$ej)(l),O={type:"object",default:D,description:R.localize(1,null,I),$ref:e.$to,defaultDefaultValue:D,source:S.$ag(o)?void 0:o,defaultValueSource:o};s.push(...y(l)),this.d[l]=O,this.b.properties[l]=O}else{this.a.set(l,{value:i[l],source:o});const m=this.d[l];m&&(this.w(l,m),this.r(l,m))}this.m(s)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:s,source:i}of t)for(const o in s){const l=this.a.get(o),m=S.$ag(i)?i:i?.id,P=S.$ag(l?.source)?l?.source:l?.source?.id;if(m===P)if(r.add(o),this.a.delete(o),e.$wo.test(o))delete this.d[o],delete this.b.properties[o];else{const D=this.d[o];D&&(this.w(o,D),this.r(o,D))}}this.u()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,s){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(t,r){const s=i=>{if(i.properties)for(const o in i.properties){r.add(o);const l=this.d[o];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[o],this.s(o,i.properties[o])}i.allOf?.forEach(o=>s(o))};for(const i of t){s(i);const o=this.c.indexOf(i);o!==-1&&this.c.splice(o,1)}}p(t,r=!0,s,i,o=3,l){o=S.$jg(t.scope)?o:t.scope;const m=t.properties;if(m)for(const D in m){const I=m[D];if(r&&h(D,I)){delete m[D];continue}if(I.source=s,I.defaultDefaultValue=m[D].default,this.w(D,I),e.$wo.test(D)?I.scope=void 0:(I.scope=S.$jg(I.scope)?o:I.scope,I.restricted=S.$jg(I.restricted)?!!i?.includes(D):I.restricted),m[D].hasOwnProperty("included")&&!m[D].included){this.f[D]=m[D],delete m[D];continue}else this.d[D]=m[D],m[D].policy?.name&&this.e.set(m[D].policy.name,D);!m[D].deprecationMessage&&m[D].markdownDeprecationMessage&&(m[D].deprecationMessage=m[D].markdownDeprecationMessage),l.add(D)}const P=t.allOf;if(P)for(const D of P)this.p(D,r,s,i,o,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=s=>{const i=s.properties;if(i)for(const l in i)this.r(l,i[l]);s.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$no.properties[t]=r,r.scope){case 1:e.$oo.properties[t]=r;break;case 2:e.$po.properties[t]=r;break;case 6:e.$qo.properties[t]=r;break;case 3:e.$ro.properties[t]=r;break;case 4:e.$so.properties[t]=r;break;case 5:e.$so.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$no.properties[t],r.scope){case 1:delete e.$oo.properties[t];break;case 2:delete e.$po.properties[t];break;case 6:delete e.$qo.properties[t];break;case 3:delete e.$ro.properties[t];break;case 4:case 5:delete e.$so.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$to};this.w(r,s),e.$no.properties[r]=s,e.$oo.properties[r]=s,e.$po.properties[r]=s,e.$qo.properties[r]=s,e.$ro.properties[r]=s,e.$so.properties[r]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$to};e.$no.patternProperties[e.$vo]=t,e.$oo.patternProperties[e.$vo]=t,e.$po.patternProperties[e.$vo]=t,e.$qo.patternProperties[e.$vo]=t,e.$ro.patternProperties[e.$vo]=t,e.$so.patternProperties[e.$vo]=t,this.i.fire()}w(t,r){const s=this.a.get(t);let i=s?.value,o=s?.source;S.$hg(i)&&(i=r.defaultDefaultValue,o=void 0),S.$hg(i)&&(i=b(r.type)),r.default=i,r.defaultValueSource=o}}const $="\\[([^\\]]+)\\]",f=new RegExp($,"g");e.$vo=`^(${$})+$`,e.$wo=new RegExp(e.$vo);function y(a){const t=[];if(e.$wo.test(a)){let r=f.exec(a);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=f.exec(a)}}return(0,n.$Mb)(t)}function w(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}function b(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new v;u.$ho.add(e.$mo.Configuration,g);function h(a,t){return a.trim()?e.$wo.test(a)?R.localize(7,null,a):g.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function E(){const a=[],t=g.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(re[123],oe([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Go=h;function $(r){return Object.isFrozen(r)?r:k.$8n(r)}class f{static createEmptyModel(s){return new f({},[],[],void 0,s)}constructor(s,i,o,l,m){this.b=s,this.c=i,this.d=o,this.raw=l,this.f=m,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof f)return i;const o=new y("",this.f);return o.parseRaw(i),o.configurationModel});this.g=s.reduce((i,o)=>o===i?o:i.merge(o),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,d.$cj)(this.contents,s):this.contents}inspect(s,i){const o=this;return{get value(){return $(o.rawConfiguration.getValue(s))},get override(){return i?$(o.rawConfiguration.getOverrideValue(s,i)):void 0},get merged(){return $(i?o.rawConfiguration.override(i).getValue(s):o.rawConfiguration.getValue(s))},get overrides(){const l=[];for(const{contents:m,identifiers:P,keys:D}of o.rawConfiguration.overrides){const I=new f(m,D,[],void 0,o.f).getValue(s);I!==void 0&&l.push({identifiers:P,value:I})}return l.length?$(l):void 0}}}getOverrideValue(s,i){const o=this.j(i);return o?s?(0,d.$cj)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const o of this.overrides)o.identifiers.includes(s)&&i.push(...o.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return n.$Mb(s)}override(s){let i=this.a.get(s);return i||(i=this.h(s),this.a.set(s,i)),i}merge(...s){const i=k.$7n(this.contents),o=k.$7n(this.overrides),l=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const P of s)if(m.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(i,P.contents);for(const D of P.overrides){const[I]=o.filter(O=>n.$ub(O.identifiers,D.identifiers));I?(this.i(I.contents,D.contents),I.keys.push(...D.keys),I.keys=n.$Mb(I.keys)):o.push(k.$7n(D))}for(const D of P.keys)l.indexOf(D)===-1&&l.push(D)}return new f(i,l,o,m.every(P=>P instanceof f)?void 0:m,this.f)}h(s){const i=this.j(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const l of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let m=this.contents[l];const P=i[l];P&&(typeof m=="object"&&typeof P=="object"?(m=k.$7n(m),this.i(m,P)):m=P),o[l]=m}return new f(o,this.keys,this.overrides,void 0,this.f)}i(s,i){for(const o of Object.keys(i)){if(o in s&&u.$cg(s[o])&&u.$cg(i[o])){this.i(s[o],i[o]);continue}s[o]=k.$7n(i[o])}}j(s){let i=null,o=null;const l=m=>{m&&(o?this.i(o,m):o=k.$7n(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===s?i=m.contents:m.identifiers.includes(s)&&l(m.contents);return l(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.k(s,i,!0)}setValue(s,i){this.k(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,d.$bj)(this.contents,s),p.$wo.test(s)&&this.overrides.splice(this.overrides.findIndex(o=>n.$ub(o.identifiers,(0,p.$xo)(s))),1))}k(s,i,o){(0,d.$aj)(this.contents,s,i,l=>this.f.error(l)),o=o||this.keys.indexOf(s)===-1,o&&this.keys.push(s),p.$wo.test(s)&&this.overrides.push({identifiers:(0,p.$xo)(s),keys:Object.keys(this.contents[s]),contents:(0,d.$_i)(this.contents[s],l=>this.f.error(l))})}}e.$Co=f;class y{constructor(s,i){this.f=s,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!u.$jg(s)){const o=this.h(s);this.parseRaw(o,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:o,keys:l,overrides:m,restricted:P,hasExcludedProperties:D}=this.i(s,i);this.b=new f(o,l,m,D?[s]:void 0,this.g),this.c=P||[]}h(s){let i={},o=null,l=[];const m=[],P=[];function D(O){Array.isArray(l)?l.push(O):o!==null&&(l[o]=O)}const I={onObjectBegin:()=>{const O={};D(O),m.push(l),l=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{l=m.pop()},onArrayBegin:()=>{const O=[];D(O),m.push(l),l=O,o=null},onArrayEnd:()=>{l=m.pop()},onLiteralValue:D,onError:(O,M,W)=>{P.push({error:O,offset:M,length:W})}};if(s)try{S.$Un(s,I),i=l[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}i(s,i){const o=v.$ho.as(p.$mo.Configuration).getConfigurationProperties(),l=this.j(s,o,!0,i);s=l.raw;const m=(0,d.$_i)(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`)),P=Object.keys(s),D=this.l(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:m,keys:P,overrides:D,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(s,i,o,l){let m=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:m};const P={},D=[];for(const I in s)if(p.$wo.test(I)&&o){const O=this.j(s[I],i,!1,l);P[I]=O.raw,m=m||O.hasExcludedProperties,D.push(...O.restricted)}else{const O=i[I],M=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&D.push(I),!l.exclude?.includes(I)&&(l.include?.includes(I)||(M===void 0||l.scopes===void 0||l.scopes.includes(M))&&!(l.skipRestricted&&O?.restricted))?P[I]=s[I]:m=!0}return{raw:P,restricted:D,hasExcludedProperties:m}}l(s,i){const o=[];for(const l of Object.keys(s))if(p.$wo.test(l)){const m={};for(const P in s[l])m[P]=s[l][P];o.push({identifiers:(0,p.$xo)(l),keys:Object.keys(m),contents:(0,d.$_i)(m,i)})}return o}}e.$Do=y;class w extends R.$Uc{constructor(s,i,o,l,m){super(),this.c=s,this.f=i,this.g=l,this.h=m,this.b=this.B(new A.$he),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),m),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(0)||P.isOperation(3)||P.isOperation(1)||P.isOperation(4))&&o.isEqual(P.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Eo=w;class b{constructor(s,i,o,l,m,P,D,I,O,M,W,N,T){this.a=s,this.b=i,this.c=o,this.overrideIdentifiers=l,this.d=m,this.f=P,this.g=D,this.h=I,this.i=O,this.j=M,this.k=W,this.l=N,this.m=T}get value(){return $(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class g{constructor(s,i,o,l,m,P,D,I,O,M){this.j=s,this.l=i,this.m=o,this.n=l,this.p=m,this.q=P,this.r=D,this.s=I,this.t=O,this.u=M,this.h=null,this.i=new j.$Ac,this.v=null}getValue(s,i,o){return this.w(s,i,o).getValue(s)}updateValue(s,i,o={}){let l;o.resource?(l=this.t.get(o.resource),l||(l=f.createEmptyModel(this.u),this.t.set(o.resource,l))):l=this.s,i===void 0?l.removeValue(s):l.setValue(s,i),o.resource||(this.h=null)}inspect(s,i,o){const l=this.w(s,i,o),m=this.A(i.resource,o),P=i.resource?this.t.get(i.resource)||this.s:this.s,D=new Set;for(const I of l.overrides)for(const O of I.identifiers)l.getOverrideValue(s,O)!==void 0&&D.add(O);return new b(s,i,l.getValue(s),D.size?[...D]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,m||void 0,P)}keys(s){const i=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,i){this.r.set(s,i),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const o=[];if(!i){const{added:l,updated:m,removed:P}=a(this.j,s);i=[...l,...m,...P]}for(const l of i)for(const m of(0,p.$xo)(l)){const P=this.j.getKeysForOverrideIdentifier(m),D=s.getKeysForOverrideIdentifier(m),I=[...D.filter(O=>P.indexOf(O)===-1),...P.filter(O=>D.indexOf(O)===-1),...P.filter(O=>!k.$$n(this.j.override(m).getValue(O),s.override(m).getValue(O)))];o.push([m,I])}return this.updateDefaultConfiguration(s),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:o,removed:l}=a(this.l,s),m=[...i,...o,...l];return m.length&&this.updatePolicyConfiguration(s),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:o,removed:l,overrides:m}=a(this.applicationConfiguration,s),P=[...i,...o,...l];return P.length&&this.updateApplicationConfiguration(s),{keys:P,overrides:m}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:o,removed:l,overrides:m}=a(this.localUserConfiguration,s),P=[...i,...o,...l];return P.length&&this.updateLocalUserConfiguration(s),{keys:P,overrides:m}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:o,removed:l,overrides:m}=a(this.remoteUserConfiguration,s),P=[...i,...o,...l];return P.length&&this.updateRemoteUserConfiguration(s),{keys:P,overrides:m}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:o,removed:l,overrides:m}=a(this.workspaceConfiguration,s),P=[...i,...o,...l];return P.length&&this.updateWorkspaceConfiguration(s),{keys:P,overrides:m}}compareAndUpdateFolderConfiguration(s,i){const o=this.folderConfigurations.get(s),{added:l,updated:m,removed:P,overrides:D}=a(o,i),I=[...l,...m,...P];return(I.length||!o)&&this.updateFolderConfiguration(s,i),{keys:I,overrides:D}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:l,removed:m,overrides:P}=a(i,void 0);return{keys:[...o,...l,...m],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,i,o){let l=this.x(i,o);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(l=l.merge(this.l)),l}x({resource:s},i){let o=this.y();if(i&&s){const l=i.getFolder(s);l&&(o=this.z(l.uri)||o);const m=this.t.get(s);m&&(o=o.merge(m))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let i=this.i.get(s);if(!i){const o=this.y(),l=this.r.get(s);l?(i=o.merge(l),this.i.set(s,i)):i=o}return i}A(s,i){if(i&&s){const o=i.getFolder(s);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,i)=>{const{contents:o,overrides:l,keys:m}=this.r.get(i);return s.push([i,{contents:o,overrides:l,keys:m}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.q.keys.forEach(i=>s.add(i)),this.r.forEach(i=>i.keys.forEach(o=>s.add(o))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}D(s){const i=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.q.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(l=>i.add(l))),[...i.values()]}static parse(s,i){const o=this.E(s.defaults,i),l=this.E(s.policy,i),m=this.E(s.application,i),P=this.E(s.user,i),D=this.E(s.workspace,i),I=s.folders.reduce((O,M)=>(O.set(c.URI.revive(M[0]),this.E(M[1],i)),O),new j.$Ac);return new g(o,l,m,P,f.createEmptyModel(i),D,I,f.createEmptyModel(i),new j.$Ac,i)}static E(s,i){return new f(s.contents,s.keys,s.overrides,void 0,i)}}e.$Fo=g;function h(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,i=new Map;for(const l of r)l.keys.forEach(m=>s.add(m)),l.overrides.forEach(([m,P])=>{const D=(0,j.$xc)(i,m,new Set);P.forEach(I=>D.add(I))});const o=[];return i.forEach((l,m)=>o.push([m,[...l.values()]])),{keys:[...s.values()],overrides:o}}class E{constructor(s,i,o,l,m){this.change=s,this.f=i,this.g=o,this.h=l,this.i=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of s.keys)this.affectedKeys.add(P);for(const[,P]of s.overrides)for(const D of P)this.affectedKeys.add(D);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=g.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,i){const o=this.a+s,l=this.d.indexOf(o);if(l<0)return!1;const m=l+o.length;if(m>=this.d.length)return!1;const P=this.d.charCodeAt(m);if(P!==this.b&&P!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,I=this.g.getValue(s,i,this.h);return!k.$$n(D,I)}return!0}}e.$Ho=E;function a(r,s){const{added:i,removed:o,updated:l}=t(s?.rawConfiguration,r?.rawConfiguration),m=[],P=r?.getAllOverrideIdentifiers()||[],D=s?.getAllOverrideIdentifiers()||[];if(s){const I=D.filter(O=>!P.includes(O));for(const O of I)m.push([O,s.getKeysForOverrideIdentifier(O)])}if(r){const I=P.filter(O=>!D.includes(O));for(const O of I)m.push([O,r.getKeysForOverrideIdentifier(O)])}if(s&&r){for(const I of P)if(D.includes(I)){const O=t({contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)},{contents:s.getOverrideValue(void 0,I)||{},keys:s.getKeysForOverrideIdentifier(I)});m.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:o,updated:l,overrides:m}}function t(r,s){const i=r?s?r.keys.filter(m=>s.keys.indexOf(m)===-1):[...r.keys]:[],o=s?r?s.keys.filter(m=>r.keys.indexOf(m)===-1):[...s.keys]:[],l=[];if(r&&s){for(const m of s.keys)if(r.keys.indexOf(m)!==-1){const P=(0,d.$cj)(s.contents,m),D=(0,d.$cj)(r.contents,m);k.$$n(P,D)||l.push(m)}}return{added:i,removed:o,updated:l}}}),define(re[241],oe([0,1,22,3,2,35,12,123,52,5,39,45]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=void 0;class v extends S.$Uc{get configurationModel(){return this.b}constructor(w){super(),this.c=w,this.a=this.B(new A.$he),this.onDidChangeConfiguration=this.a.event,this.b=k.$Co.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(p.$ho.as(u.$mo.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:b})=>this.f(Array.from(w),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(w,b){this.j(w,p.$ho.as(u.$mo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}g(){return{}}h(){this.b=k.$Co.createEmptyModel(this.c);const w=p.$ho.as(u.$mo.Configuration).getConfigurationProperties();this.j(Object.keys(w),w)}j(w,b){const g=this.g();for(const h of w){const E=g[h],a=b[h];E!==void 0?this.b.addValue(h,E):a?this.b.addValue(h,a.default):this.b.removeValue(h)}}}e.$Io=v;class ${constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=k.$Co.createEmptyModel(new c.$hk)}async initialize(){return this.configurationModel}}e.$Jo=$;let f=class extends S.$Uc{get configurationModel(){return this.b}constructor(w,b,g){super(),this.c=w,this.f=b,this.g=g,this.a=this.B(new A.$he),this.onDidChangeConfiguration=this.a.event,this.b=k.$Co.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const b={},g=[],h=p.$ho.as(u.$mo.Configuration).getConfigurationProperties();for(const E of w){const a=h[E];if(!a){g.push(E);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}g.push(E),b[a.policy.name]={type:a.type}}}return(0,j.$ng)(b)||await this.f.updatePolicyDefinitions(b),g}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const b=p.$ho.as(u.$mo.Configuration).getPolicyConfigurations(),g=(0,n.$Hb)(w.map(h=>b.get(h)));this.m(g,!0)}m(w,b){this.g.trace("PolicyConfiguration#update",w);const g=p.$ho.as(u.$mo.Configuration).getConfigurationProperties(),h=[],E=this.b.isEmpty();for(const a of w){const t=g[a]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(E?r!==void 0:!(0,R.$$n)(this.b.getValue(a),r))&&h.push([a,r])}else this.b.getValue(a)!==void 0&&h.push([a,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const a=this.b;this.b=k.$Co.createEmptyModel(this.g);for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,r]of h)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);b&&this.a.fire(this.b)}}};e.$Ko=f,e.$Ko=f=ke([ne(1,d.$jo),ne(2,c.$7j)],f)}),define(re[242],oe([0,1,22,8,17,3,42,103,2,32,35,4,19,18,123,52,241,39]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=void 0;class g extends u.$Uc{constructor(a,t,r,s){super(),this.m=a,this.n=s,this.h=this.B(new R.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$Io(s)),this.c=r instanceof b.$lo?new w.$Jo:this.B(new w.$Ko(this.b,r,s)),this.f=this.B(new f.$Eo(this.m,{},v.$5g,t,s)),this.a=new f.$Fo(this.b.configurationModel,this.c.configurationModel,f.$Co.createEmptyModel(s),f.$Co.createEmptyModel(s),f.$Co.createEmptyModel(s),f.$Co.createEmptyModel(s),new c.$Ac,f.$Co.createEmptyModel(s),new c.$Ac,s),this.j=new h(a,t,this),this.g=this.B(new A.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:o})=>this.s(i,o))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$Fo(a,t,f.$Co.createEmptyModel(this.n),r,f.$Co.createEmptyModel(this.n),f.$Co.createEmptyModel(this.n),new c.$Ac,f.$Co.createEmptyModel(this.n),new c.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const r=typeof a=="string"?a:void 0,s=(0,$.$8i)(a)?a:(0,$.$8i)(t)?t:{};return this.a.getValue(r,s,void 0)}async updateValue(a,t,r,s,i){const o=(0,$.$9i)(r)?r:(0,$.$8i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,l=o?s:r;if(l!==void 0&&l!==3&&l!==2)throw new Error(`Unable to write ${a} to target ${l}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,n.$Mb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const m=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(m.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,d.$$n)(t,m.defaultValue)&&(t=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const D=o.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(O=>(0,n.$ub)([...O.identifiers].sort(),D));I&&(o.overrideIdentifiers=I.identifiers)}const P=o?.overrideIdentifiers?.length?[(0,y.$yo)(o.overrideIdentifiers),a]:[a];await this.j.write(P,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,t,2)}s(a,t){const r=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(s,r,7)}t(a){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,t,7)}u(a,t,r){const s=new f.$Ho(a,{data:t},this.a,void 0,this.n);s.source=r,this.h.fire(s)}}e.$Lo=g;class h{constructor(a,t,r){this.b=a,this.c=t,this.d=r,this.a=new A.$Hh}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===1)r="{}";else throw o}const s=[];if((0,j.$Nn)(r,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,a,t);r=(0,k.$6n)(r,i),await this.c.writeFile(this.b,S.$Je.fromString(r))}f(a,t,r){const{tabSize:s,insertSpaces:i,eol:o}=this.h;if(!t.length){const l=JSON.stringify(r,null,i?" ".repeat(s):"	");return[{content:l,length:l.length,offset:0}]}return(0,k.$3n)(a,t,r,{tabSize:s,insertSpaces:i,eol:o})}get h(){if(!this.g){let a=p.OS===3||p.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(re[243],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=e.$Aec=e.$zec=void 0,e.$zec="request",e.$Aec="remoteResourceHandler";class n{async routeCall(S,R,j){if(R!==e.$zec)throw new Error(`Call not found: ${R}`);const k=j[0];if(k?.authority){const u=S.connections.find(c=>c.ctx===k.authority);if(u)return u}throw new Error("Caller not found")}routeEvent(S,R){throw new Error(`Event not found: ${R}`)}}e.$Bec=n}),define(re[244],oe([0,1,15,6]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=c,e.$Ll=(0,A.$Ai)("remoteAuthorityResolverService");var S;(function(d){d[d.WebSocket=0]="WebSocket",d[d.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class R{constructor(p){this.id=p,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ml=R;class j{constructor(p,v){this.host=p,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=j;var k;(function(d){d.Unknown="Unknown",d.NotAvailable="NotAvailable",d.TemporarilyNotAvailable="TemporarilyNotAvailable",d.NoResolverFound="NoResolverFound",d.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class u extends n.$bb{static isNotAvailable(p){return p instanceof u&&p._code===k.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof u&&p._code===k.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof u&&p._code===k.NoResolverFound}static isInvalidAuthority(p){return p instanceof u&&p._code===k.InvalidAuthority}static isHandled(p){return p instanceof u&&p.isHandled}constructor(p,v=k.Unknown,$){super(p),this._message=p,this._code=v,this._detail=$,this.isHandled=v===k.NotAvailable&&$===!0,Object.setPrototypeOf(this,u.prototype)}}e.$Ol=u;function c(d){const p=d.indexOf("+");return p===-1?d:d.substring(0,p)}}),define(re[245],oe([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ul=P,e.$Vl=D,e.$Wl=O;const f=30*1e3;var y;(function(Y){Y[Y.Management=1]="Management",Y[Y.ExtensionHost=2]="ExtensionHost",Y[Y.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function w(Y){switch(Y){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function b(Y){const C=new S.$se;return setTimeout(()=>C.cancel(),Y),C.token}function g(Y,C){if(Y.isCancellationRequested||C.isCancellationRequested)return S.CancellationToken.Cancelled;const F=new S.$se;return Y.onCancellationRequested(()=>F.cancel()),C.onCancellationRequested(()=>F.cancel()),F.token}class h{get didTimeout(){return this.c==="timedout"}constructor(C){this.c="pending",this.d=new k.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$th)(),C.isCancellationRequested?this.h():this.d.add(C.onCancellationRequested(()=>this.h()))}registerDisposable(C){this.c==="pending"?this.d.add(C):C.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const C=new Error("Time limit reached");return C.code="ETIMEDOUT",C.syscall="connect",C}resolve(C){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(C))}reject(C){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(C))}}function E(Y,C){const F=new h(C);return F.registerDisposable(Y.onControlMessage(_=>{const B=JSON.parse(_.toString()),Z=L(B);Z?F.reject(Z):F.resolve(B)})),F.promise}function a(Y,C,F,_,B,Z,x,ee){const G=new h(ee),ue=d.$be.create(!1);return Y.info(`Creating a socket (${x})...`),c.mark(`code/willCreateSocket/${Z}`),C.connect(F,_,B,x).then(fe=>{G.didTimeout?(c.mark(`code/didCreateSocketError/${Z}`),Y.info(`Creating a socket (${x}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(c.mark(`code/didCreateSocketOK/${Z}`),Y.info(`Creating a socket (${x}) was successful after ${ue.elapsed()} ms.`),G.resolve(fe))},fe=>{c.mark(`code/didCreateSocketError/${Z}`),Y.info(`Creating a socket (${x}) returned an error after ${ue.elapsed()} ms.`),Y.error(fe),G.reject(fe)}),G.promise}function t(Y,C){const F=new h(C);return Y.then(_=>{F.didTimeout||F.resolve(_)},_=>{F.didTimeout||F.reject(_)}),F.promise}async function r(Y,C,F,_){const B=V(Y,C);Y.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await a(Y.logService,Y.remoteSocketFactoryService,Y.connectTo,u.$Ng.getServerRootPath(),`reconnectionToken=${Y.reconnectionToken}&reconnection=${Y.reconnectionProtocol?"true":"false"}`,w(C),`renderer-${w(C)}-${Y.reconnectionToken}`,_)}catch(fe){throw Y.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),Y.logService.error(fe),fe}Y.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let x,ee;Y.reconnectionProtocol?(Y.reconnectionProtocol.beginAcceptReconnection(Z,null),x=Y.reconnectionProtocol,ee=!1):(x=new v.$oi({socket:Z}),ee=!0),Y.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const G=await t(Y.signService.createNewMessage((0,p.$Wg)()),_),ue={type:"auth",auth:Y.connectionToken||"00000000000000000000",data:G.data};x.sendControl(A.$Je.fromString(JSON.stringify(ue)));try{const fe=await E(x,g(_,b(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(Y.logService.trace(`${B} 4/6. received SignRequest control message.`),!await t(Y.signService.validate(G,fe.signedData),_)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const Ee=await t(Y.signService.sign(fe.data),_),Oe={type:"connectionType",commit:Y.commit,signedData:Ee,desiredConnectionType:C};return F&&(Oe.args=F),Y.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(A.$Je.fromString(JSON.stringify(Oe))),{protocol:x,ownsProtocol:ee}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(Y.logService.error(`${B} the handshake timed out. Error:`),Y.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(Y.logService.error(`${B} received error control message when negotiating connection. Error:`),Y.logService.error(fe)),ee&&q(x),fe}}async function s(Y,C,F,_){const B=Date.now(),Z=V(Y,C),{protocol:x,ownsProtocol:ee}=await r(Y,C,F,_),G=new h(_);return G.registerDisposable(x.onControlMessage(ue=>{const fe=JSON.parse(ue.toString()),we=L(fe);we?(Y.logService.error(`${Z} received error control message when negotiating connection. Error:`),Y.logService.error(we),ee&&q(x),G.reject(we)):(Y.reconnectionProtocol?.endAcceptReconnection(),Y.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${le(B)}!`),G.resolve({protocol:x,firstMessage:fe}))})),G.promise}async function i(Y,C){const{protocol:F}=await s(Y,1,void 0,C);return{protocol:F}}async function o(Y,C,F){const{protocol:_,firstMessage:B}=await s(Y,2,C,F),Z=B&&B.debugPort;return{protocol:_,debugPort:Z}}async function l(Y,C,F){const _=Date.now(),B=V(Y,3),{protocol:Z}=await r(Y,3,C,F);return Y.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${le(_)}!`),Z}async function m(Y,C,F){const{connectTo:_,connectionToken:B}=await Y.addressProvider.getAddress();return{commit:Y.commit,quality:Y.quality,connectTo:_,connectionToken:B,reconnectionToken:C,reconnectionProtocol:F,remoteSocketFactoryService:Y.remoteSocketFactoryService,signService:Y.signService,logService:Y.logService}}async function P(Y,C,F){return I(Y,async _=>{const{protocol:B}=await i(_,S.CancellationToken.None);return new K(Y,C,F,_.reconnectionToken,B)})}async function D(Y,C){return I(Y,async F=>{const{protocol:_,debugPort:B}=await o(F,C,S.CancellationToken.None);return new J(Y,C,F.reconnectionToken,_,B)})}async function I(Y,C){for(let _=1;;_++)try{const B=(0,p.$Wg)(),Z=await m(Y,B,null);return await C(Z)}catch(B){if(_<5)Y.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),Y.logService.error(B);else throw Y.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Y.logService.error(B),ae.triggerPermanentFailure(0,0,$.$Ol.isHandled(B)),B}}async function O(Y,C,F){const _=await m(Y,(0,p.$Wg)(),null);return await l(_,{host:C,port:F},S.CancellationToken.None)}function M(Y){return(0,n.$nh)(C=>new Promise((F,_)=>{const B=setTimeout(F,Y*1e3);C.onCancellationRequested(()=>{clearTimeout(B),F()})}))}var W;(function(Y){Y[Y.ConnectionLost=0]="ConnectionLost",Y[Y.ReconnectionWait=1]="ReconnectionWait",Y[Y.ReconnectionRunning=2]="ReconnectionRunning",Y[Y.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Y[Y.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class N{constructor(C,F){this.reconnectionToken=C,this.millisSinceLastIncomingData=F,this.type=0}}e.$Xl=N;class T{constructor(C,F,_,B){this.reconnectionToken=C,this.millisSinceLastIncomingData=F,this.durationSeconds=_,this.c=B,this.type=1}skipWait(){this.c.cancel()}}e.$Yl=T;class U{constructor(C,F,_){this.reconnectionToken=C,this.millisSinceLastIncomingData=F,this.attempt=_,this.type=2}}e.$Zl=U;class ie{constructor(C,F,_){this.reconnectionToken=C,this.millisSinceLastIncomingData=F,this.attempt=_,this.type=4}}e.$1l=ie;class te{constructor(C,F,_,B){this.reconnectionToken=C,this.millisSinceLastIncomingData=F,this.attempt=_,this.handled=B,this.type=3}}e.$2l=te;class ae extends k.$Uc{static triggerPermanentFailure(C,F,_){this._permanentFailure=!0,this.f=C,this.g=F,this.h=_,this.j.forEach(B=>B.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(C=>C.y())}static debugPauseSocketWriting(){this.j.forEach(C=>C.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ae._permanentFailure}constructor(C,F,_,B,Z){super(),this.t=C,this.u=F,this.reconnectionToken=_,this.protocol=B,this.w=Z,this.m=this.B(new j.$he),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ie(this.reconnectionToken,0,0)),this.B(B.onSocketClose(x=>{const ee=ce(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${ee} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(B.onSocketTimeout(x=>{const ee=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),ae.j.push(this),this.B((0,k.$Sc)(()=>{const x=ae.j.indexOf(this);x>=0&&ae.j.splice(x,1)})),this.n&&this.D(ae.f,ae.g,ae.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const C=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${C} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const B=_<F.length?F[_]:F[F.length-1];try{if(B>0){const x=M(B);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,x)),this.u.logService.info(`${C} waiting for ${B} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${C} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${C} resolving connection...`);const Z=await m(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${C} connecting to ${Z.connectTo}...`),await this.G(Z,b(f)),this.u.logService.info(`${C} reconnected!`),this.m.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${C} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${C} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if($.$Ol.isTemporarilyNotAvailable(Z)){this.u.logService.info(`${C} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.u.logService.info(`${C} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if((0,R.$4)(Z)){this.u.logService.info(`${C} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Z);continue}if(Z instanceof $.$Ol){this.u.logService.error(`${C} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,$.$Ol.isHandled(Z));break}this.u.logService.error(`${C} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Z),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(C,F,_){this.w?ae.triggerPermanentFailure(C,F,_):this.D(C,F,_)}D(C,F,_){this.m.fire(new te(this.reconnectionToken,C,F,_)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$3l=ae;class K extends ae{constructor(C,F,_,B,Z){super(1,C,B,Z,!0),this.client=this.B(new v.$mi(Z,{remoteAuthority:F,clientId:_},C.ipcLogger))}async G(C,F){await i(C,F)}}e.$4l=K;class J extends ae{constructor(C,F,_,B,Z){super(2,C,_,B,!1),this.H=F,this.debugPort=Z}async G(C,F){await o(C,this.H,F)}}e.$5l=J;function q(Y){try{Y.acceptDisconnect();const C=Y.getSocket();Y.dispose(),C.dispose()}catch(C){(0,R.$1)(C)}}function L(Y){if(Y&&Y.type==="error"){const C=new Error(`Connection error: ${Y.reason}`);return C.code="VSCODE_CONNECTION_ERROR",C}return null}function z(Y,C){for(;Y.length<C;)Y+=" ";return Y}function H(Y,C){return`[remote-connection][${z(w(Y),13)}][${C.substr(0,5)}\u2026]`}function ce(Y,C,F){return`${H(Y,C)}[${F?"reconnect":"initial"}]`}function V(Y,C){return`${ce(C,Y.reconnectionToken,!!Y.reconnectionProtocol)}[${Y.connectTo}]`}function le(Y){return`${Date.now()-Y} ms`}}),define(re[68],oe([0,1,13]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=A,e.$Mm=S,e.$Nm=R,e.$Om=j;function A(u){return u.scheme===n.Schemas.vscodeRemote?u.authority:void 0}function S(u){if(!u)return;const c=u.indexOf("+");return c<0?u:u.substr(0,c)}function R(u){const{host:c,port:d}=k(u);if(typeof d>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:d}}function j(u,c){let{host:d,port:p}=k(u);return typeof p>"u"&&(p=c),{host:d,port:p}}function k(u){const c=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const d=u.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const p=u.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:u,port:void 0}}}),define(re[124],oe([0,1,25,6,68]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$Xm=e.$Wm=e.$Vm=e.TargetPlatform=e.ExtensionType=e.$Um=e.$Sm=e.$Rm=e.$Qm=e.$Pm=void 0,e.$Tm=R,e.$Ym=p,e.$Zm=v,e.$1m=$,e.$2m=f,e.$Pm="extensions.user.cache",e.$Qm="extensions.builtin.cache",e.$Rm="undefined_publisher",e.$Sm=["ui","workspace","web"];function R(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Um=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var j;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(j||(e.ExtensionType=j={}));var k;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class u{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,b){if(typeof w>"u"||w===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof w=="string"||typeof b=="string"){const g=typeof w=="string"?w:w.value,h=typeof b=="string"?b:b.value;return n.$Bf(g,h)}return w._lower===b._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Vm=u;class c{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const b of w)this.add(b)}add(w){this.c.add(u.toKey(w))}delete(w){return this.c.delete(u.toKey(w))}has(w){return this.c.has(u.toKey(w))}}e.$Wm=c;class d{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(u.toKey(w))}get(w){return this.c.get(u.toKey(w))}has(w){return this.c.has(u.toKey(w))}set(w,b){this.c.set(u.toKey(w),b)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xm=d;function p(y){return v(y)}function v(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function $(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function f(y,w){if(w){const b=`onResolveRemoteAuthority:${(0,S.$Mm)(w)}`;return!!y.activationEvents?.includes(b)}return!1}e.$3m=(0,A.$Ai)("IBuiltinExtensionsScannerService")}),define(re[246],oe([0,1,2,6]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql=(0,A.$Ai)("remoteSocketFactoryService");class S{constructor(){this.a={}}register(j,k){return this.a[j]??=[],this.a[j].push(k),(0,n.$Sc)(()=>{const u=this.a[j]?.indexOf(k);typeof u=="number"&&u>=0&&this.a[j]?.splice(u,1)})}b(j){return(this.a[j.type]||[]).find(u=>u.supports(j))}connect(j,k,u,c){const d=this.b(j);if(!d)throw new Error(`No socket factory found for ${j}`);return d.connect(j,k,u,c)}}e.$Rl=S}),define(re[247],oe([0,1,26,49,21,117]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=k;let j;async function k($=!1){return(j===void 0||$)&&(j=u()),j}async function u(){const $=c();if($===void 0)return!1;if($>=22e3){const f=p();if(f)return new Promise(y=>{A.execFile(f,["--status"],w=>y(!w))})}else{const f=v();if(f)try{if((await S.Promises.stat(f)).isFile())return!0}catch{}}return!1}function c(){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if($)return parseInt($[3])}function d($){const f=process.env.SystemRoot;if(f){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,y?"Sysnative":"System32",$)}}function p(){return d("wsl.exe")}function v(){return d("lxss\\LxssManager.dll")}}),define(re[53],oe([0,1,17,15,2,186,52,6,5,45]),function(Q,e,n,A,S,R,j,k,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0,e.$Vp=v,e.$Wp=$,e.$Xp=f,e.$Yp=y,e.$Zp=w,e.$1p=b,e.$Tp=(0,k.$Ai)("requestService");class d{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class p extends S.$Uc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,R.localize)(0,null),when:u.$mk.isEqualTo((0,u.$jk)(u.LogLevel.Trace)).serialize()})}async c(a,t,r){const s=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new d(t.headers??{}));try{const i=await r();return this.a.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,t.type,(0,A.$0)(i)),i}}}e.$Up=p;function v(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function $(E){return E.res.statusCode===204}async function f(E){return $(E)?null:(await(0,n.$Ve)(E.stream)).toString()}async function y(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);return f(E)}async function w(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);if($(E))return null;const t=(await(0,n.$Ve)(E.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function b(E){h(E)}let g;function h(E){const a=c.$ho.as(j.$mo.Configuration),t=g;g={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[g],remove:t?[t]:[]})}h(1)}),define(re[248],oe([0,1,17,23]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=void 0;class S{constructor(k){this.a=k}listen(k,u){throw new Error("Invalid listen")}call(k,u,c,d=A.CancellationToken.None){switch(u){case"request":return this.a.request(c[0],d).then(async({res:p,stream:v})=>{const $=await(0,n.$Ve)(v);return[{statusCode:p.statusCode,headers:p.headers},$]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$1r=S;class R{constructor(k){this.a=k}async request(k,u){const[c,d]=await this.a.call("request",[k],u);return{res:c,stream:(0,n.$Xe)(d)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$2r=R}),define(re[249],oe([0,1,250,12]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=R;function S(j,k){return j.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:j.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function R(j,k,u={}){const c=(0,n.parse)(j),d=u.proxyUrl||S(c,k);if(!d)return null;const p=(0,n.parse)(d);if(!/^https?:$/.test(p.protocol||""))return null;const v={host:p.hostname||"",port:(p.port?+p.port:0)||(p.protocol==="https"?443:80),auth:p.auth,rejectUnauthorized:(0,A.$gg)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise(($,f)=>{Q(["http-proxy-agent"],$,f)})).HttpProxyAgent(d,v):new(await new Promise(($,f)=>{Q(["https-proxy-agent"],$,f)})).HttpsProxyAgent(d,v)}}),define(re[251],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=e.$Vdc=void 0,e.$Vdc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Wdc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Xdc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[95],oe([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=y;let f;async function y(b,g,h,E){return h["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.$Em)(E)&&!h["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.$Em)(E)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=v.Promises.withAsyncBody(async(a,t)=>{const r=new R.$se;let s=1e4;const i=b.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,$.$Fm)(i,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),t(new Error((0,S.localize)(0,null)))},s);try{a(await w(g,r.token))}catch(l){!(0,k.$4)(l)&&!r.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,j.$lj)(l)))):a({})}finally{clearTimeout(o),r.dispose()}})),f)}async function w(b,g){const h=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",h);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",E);const a=(0,c.$Wg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",r);const s=await(0,d.$um)(u.OS,r);return b.trace("getUnixShellEnvironment#shell",s),new Promise((i,o)=>{if(g.isCancellationRequested)return o(new k.$5);const l=(0,A.$nc)(s);let m,P;const D="";/^pwsh(-preview)?$/.test(l)?(m=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,P=["-Login","-Command"]):l==="nu"?(m=`^'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,P=["-i","-l","-c"]):l==="xonsh"?(m=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,P=["-i","-l","-c"]):(m=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l==="tcsh"||l==="csh"?P=["-ic"]:P=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),m);const I=(0,n.spawn)(s,[...P,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(I.kill(),o(new k.$5))),I.on("error",W=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,j.$lj)(W)),o(W)});const O=[];I.stdout.on("data",W=>O.push(W));const M=[];I.stderr.on("data",W=>M.push(W)),I.on("close",(W,N)=>{const T=Buffer.concat(O).toString("utf8");b.trace("getUnixShellEnvironment#raw",T);const U=Buffer.concat(M).toString("utf8");if(U.trim()&&b.trace("getUnixShellEnvironment#stderr",U),W||N)return o(new Error((0,S.localize)(2,null,W,N)));const ie=t.exec(T),te=ie?ie[1]:"{}";try{const ae=JSON.parse(te);h?ae.ELECTRON_RUN_AS_NODE=h:delete ae.ELECTRON_RUN_AS_NODE,E?ae.ELECTRON_NO_ATTACH_CONSOLE=E:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",ae),i(ae)}catch(ae){b.error("getUnixShellEnvironment#errorCaught",(0,j.$lj)(ae)),o(ae)}})})}}),define(re[252],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(S){try{const R=await this.c();if(R){const j=String(n.a++);return this.b.set(j,R),{id:j,data:R.createNewMessage(S)}}}catch{}return{id:"",data:S}}async validate(S,R){if(!S.id)return!0;const j=this.b.get(S.id);if(!j)return!1;this.b.delete(S.id);try{return j.validate(R)==="ok"}catch{return!1}finally{j.dispose?.()}}async sign(S){try{return await this.d(S)}catch{}return S}}e.$Q_b=n}),define(re[96],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl="signService",e.$Tl=(0,n.$Ai)(e.$Sl)}),define(re[253],oe([0,1,252]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class A extends n.$Q_b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(j=>new j.signer().sign(R))}h(){return new Promise((R,j)=>Q(["vsda"],R,j))}}e.$Lec=A}),define(re[34],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=void 0,e.$9P=(0,n.$Ai)("stateReadService"),e.$0P=(0,n.$Ai)("stateService")}),define(re[125],oe([0,1,8,17,2,12,38,16,5]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=e.$_P=e.$$P=e.SaveStrategy=void 0;var c;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class d extends S.$Uc{constructor(f,y,w,b){super(),this.h=f,this.j=y,this.m=w,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new n.$yh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==1&&this.m.error(f)}}getItem(f,y){const w=this.a[f];return(0,R.$jg)(w)?y:w}setItem(f,y){this.setItems([{key:f,data:y}])}setItems(f){let y=!1;for(const{key:w,data:b}of f)this.a[w]!==b&&((0,R.$jg)(b)?(0,R.$hg)(this.a[w])||(this.a[w]=void 0,y=!0):(this.a[w]=b,y=!0));y&&this.s()}removeItem(f){(0,R.$hg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,A.$Je.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(y){this.m.error(y)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$$P=d;let p=class extends S.$Uc{constructor(f,y,w,b){super(),this.a=this.B(new d(y.stateResource,f,w,b))}async init(){await this.a.init()}getItem(f,y){return this.a.getItem(f,y)}};e.$_P=p,e.$_P=p=ke([ne(1,j.$Hi),ne(2,u.$7j),ne(3,k.$7k)],p);class v extends p{setItem(f,y){this.a.setItem(f,y)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$aQ=v}),define(re[126],oe([0,1,4,36,33]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=j,e.$kp=k;function R(u){if(n.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,c,d,p,v,$,f,y,w){const b=Object.create(null);b["common.machineId"]=$,b["common.sqmId"]=f,b.sessionID=(0,S.$Wg)()+Date.now(),b.commitHash=p,b.version=v,b["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,n.$h)(n.$u),b["common.nodePlatform"]=A.$dc,b["common.nodeArch"]=d,b["common.product"]=w||"desktop",y&&(b["common.msftInternal"]=y);let g=0;const h=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),n.$l&&(b["common.snap"]="true");const E=R(c);return E&&(b["common.platformDetail"]=E),b}function k(u){const c=A.env.USERDNSDOMAIN;if(!c)return!1;const d=c.toLowerCase();return u.some(p=>d===p)}}),define(re[28],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,n.$Ai)("telemetryService"),e.$7l=(0,n.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry",e.$bm="telemetry.telemetryLevel",e.$cm="telemetry.enableCrashReporter",e.$dm="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var S;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(re[254],oe([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0,e.$Ks=b,e.$Ls=h,e.$Ms=E;const w=new Map;async function b(t,r){const s=`${t}::${r.join(":")}`,i=w.get(s);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,m=new Map,P=2e4;function D(O,M,W,N){const T=M.substring(O.length+1);return A.Promises.withAsyncBody(async U=>{let ie;try{ie=await d.Promises.readdir(M,{withFileTypes:!0})}catch{U();return}if(N.count>=P){N.count+=ie.length,N.maxReached=!0,U();return}let te=ie.length;if(te===0){U();return}let ae=ie;N.count+ie.length>P&&(N.maxReached=!0,te=P-N.count,ae=ie.slice(0,te)),N.count+=ie.length;for(const K of ae)if(K.isDirectory()){if(W.includes(K.name)||await D(O,(0,j.$jc)(M,K.name),W,N),--te===0){U();return}}else{const J=K.name.lastIndexOf(".");if(J>=0){const q=K.name.substring(J+1);q&&l.set(q,(l.get(q)??0)+1)}for(const q of o)q.relativePathPattern?.test(T)!==!1&&q.filePattern.test(K.name)&&m.set(q.tag,(m.get(q.tag)??0)+1);if(--te===0){U();return}}})}const I=A.Promises.withAsyncBody(async O=>{const M={count:0,maxReached:!1};await D(t,t,r,M);const W=await E(t);O({configFiles:g(m),fileTypes:g(l),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:W})});return w.set(s,I),I}function g(t){return Array.from(t.entries(),([r,s])=>({name:r,count:s})).sort((r,s)=>s.count-r.count)}function h(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/$.$Cl.GB).toFixed(2)}GB (${(n.freemem()/$.$Cl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$In.value()*100)}%`},r=n.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function E(t){try{const r=new Map,s=(0,j.$jc)(t,".vscode","launch.json"),i=await d.Promises.readFile(s),o=[],l=(0,S.$Nn)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,S.$Wn)(l)==="object"&&l.configurations)for(const m of l.configurations){const P=m.type;P&&(r.has(P)?r.set(P,r.get(P)+1):r.set(P,1))}return g(r)}catch{return[]}}let a=class{constructor(r,s){this.c=r,this.d=s}f(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}g(r){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/$.$Cl.GB).toFixed(2)}GB (${(n.freemem()/$.$Cl.GB).toFixed(2)}GB free)`),k.$i||s.push(`Load (avg):       ${n.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(c.$In.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,p.$Js)(r.mainPID),this.k(r)]).then(async i=>{let[o,l]=i,m=this.m(r,o);return s.forEach(P=>{if((0,v.$in)(P))m+=`
${P.errorMessage}`,l+=`
${P.errorMessage}`;else if(m+=`

Remote: ${P.hostName}`,P.processes&&(m+=`
${this.m(r,P.processes)}`),P.workspaceMetadata){l+=`
|  Remote: ${P.hostName}`;for(const D of Object.keys(P.workspaceMetadata)){const I=P.workspaceMetadata[D];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),l+=`|    Folder (${D}): ${O}`,l+=this.h(I)}}}),{processInfo:m,workspaceInfo:l}})}async getSystemInfo(r,s){const{memory:i,vmHint:o,os:l,cpus:m}=h(),P={os:l,memory:i,cpus:m,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return k.$i||(P.load=`${n.loadavg().map(D=>Math.round(D)).join(", ")}`),k.$k&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(r,s){const i=[];return(0,p.$Js)(r.mainPID).then(async o=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,o)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),s.forEach(l=>{if((0,v.$in)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(r,l.processes)),l.workspaceMetadata)for(const m of Object.keys(l.workspaceMetadata)){const P=l.workspaceMetadata[m];let D=`${P.fileCount} files`;P.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${m}): ${D}`),i.push(this.h(P))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const s=[];let o=0;const l=(I,O)=>{const M=` ${I}(${O})`;o+M.length>60?(s.push(m),m="|                 ",o=m.length):o+=M.length,m+=M};let m="|      File types:";const P=10,D=r.fileTypes.length>P?P:r.fileTypes.length;for(let I=0;I<D;I++){const O=r.fileTypes[I];l(O.name,O.count)}if(s.push(m),r.configFiles.length>=0&&(m="|      Conf files:",o=0,r.configFiles.forEach(I=>{l(I.name,I.count)}),s.push(m)),r.launchConfigFiles.length>0){let I="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{const M=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;I+=M}),s.push(I)}return s.join(`
`)}j(r){const s=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const s=[],i=[];return r.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const m=u.URI.revive(l);if(m.scheme===R.Schemas.file){const P=m.fsPath;i.push(b(P,["node_modules",".git"]).then(D=>{let I=`${D.fileCount} files`;D.maxFilesReached&&(I=`more than ${I}`),s.push(`|    Folder (${(0,j.$nc)(P)}): ${I}`),s.push(this.h(D))}).catch(D=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${D.toString()})`)}))}else s.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,s){const i=new Map;r.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),r.pidToNames.forEach(({pid:l,name:m})=>i.set(l,m));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(r.mainPID,i,o,s,0),o.join(`
`)}n(r,s,i,o,l){const m=l===0;let P;m?P=o.pid===r?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?P=s.get(o.pid):P=`${"  ".repeat(l)} ${o.name}`;const D=process.platform==="win32"?o.mem:n.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(D/$.$Cl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(o.children)&&o.children.forEach(I=>this.n(r,s,i,I,l+1))}async getWorkspaceFileExtensions(r){const s=new Set;for(const{uri:i}of r.folders){const o=u.URI.revive(i);if(o.scheme!==R.Schemas.file)continue;const l=o.fsPath;try{(await b(l,["node_modules",".git"])).fileTypes.forEach(P=>s.add(P.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const i=u.URI.revive(s);if(i.scheme!==R.Schemas.file)continue;const o=i.fsPath;try{const l=await b(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(m=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:m.name,count:m.count})}),l.launchConfigFiles.forEach(m=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:m.name,count:m.count})}),l.configFiles.forEach(m=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};e.$Ns=a,e.$Ns=a=ke([ne(0,y.$6l),ne(1,f.$nk)],a)}),define(re[255],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=e.$1dc=void 0;class n{constructor(R){this.b=R}listen(R,j){throw new Error(`Event not found: ${j}`)}call(R,j,{eventName:k,data:u}){return this.b.forEach(c=>c.log(k,u)),Promise.resolve(null)}}e.$1dc=n;class A{constructor(R){this.b=R}log(R,j){return this.b.call("log",{eventName:R,data:j}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$2dc=A}),define(re[54],oe([0,1,35,12,68,126,28]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0,e.$sp=d,e.$tp=p,e.$up=v,e.$vp=$,e.$wp=y,e.$xp=b,e.$yp=g,e.$zp=a;class k{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$lp=k;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$mp=u,e.$np=new u;class c{async publicLog(r,s,i){}async publicLogError(r,s,i){}}e.$op=c,e.$pp="telemetry",e.$qp="extensionTelemetryLog",e.$rp={log:()=>null,flush:()=>Promise.resolve(null)};function d(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function p(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function v(t){const r=t.getValue(j.$bm),s=t.getValue(j.$cm);if(t.getValue(j.$dm)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function $(t){const r={},s={},i={};w(t,i);for(let o in i){o=o.length>150?o.substr(o.length-149):o;const l=i[o];typeof l=="number"?s[o]=l:typeof l=="boolean"?s[o]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${l.length}`),r[o]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(r[o]=l)}return{properties:r,measurements:s}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function y(t){if(!t)return"none";const r=(0,S.$Mm)(t);return f.has(r)?r:"other"}function w(t,r,s=0,i){if(t)for(const o of Object.getOwnPropertyNames(t)){const l=t[o],m=i?i+o:o;Array.isArray(l)?r[m]=(0,n.$_n)(l):l instanceof Date?r[m]=l.toISOString():(0,A.$cg)(l)?s<2?w(l,r,s+1,m+"."):r[m]=(0,n.$_n)(l):r[m]=l}}function b(t,r){const s=t.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,R.$kp)(s)||i}function g(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function h(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const i=[];for(const P of r)for(;;){const D=P.exec(t);if(!D)break;i.push([D.index,P.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(s="";;){const P=l.exec(t);if(!P)break;const D=i.some(([I,O])=>P.index<O&&I<l.lastIndex);!o.test(P[0])&&!D&&(s+=t.substring(m,P.index)+"<REDACTED: user-file-path>",m=l.lastIndex)}return m<t.length&&(s+=t.substr(m)),s}function E(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of r)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,r){return(0,n.$9n)(t,s=>{if(s instanceof k||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let i=s.replaceAll("%20"," ");i=h(i,r);for(const o of r)i=i.replace(o,"");return i=E(i),i}})}}),define(re[127],oe([0,1,25,121,124,4,7,15,36,54]),function(Q,e,n,A,S,R,j,k,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Bp=void 0,e.$Ap=d,e.$Cp=f,e.$Dp=y,e.$Ep=w,e.$Fp=b,e.$Gp=g,e.$Hp=h,e.$Ip=E,e.$Kp=a,e.$Lp=r;function d(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,n.$wf)(s.id,i.id)===0}const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const o=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,o,l)}static parse(i){const o=p.exec(i);return o&&o[1]&&o[2]?new v({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,l="undefined"){this.identifier=i,this.version=o,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?d(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Bp=v;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(s){const i=$.exec(s);return i&&i[1]?[w(i[1]),i[2]]:[w(s),void 0]}function y(s,i){return`${s}.${i}`}function w(s){return s.toLowerCase()}function b(s,i){return w(y(s??S.$Rm,i))}function g(s,i){const o=[],l=m=>{for(const P of o)if(P.some(D=>d(i(D),i(m))))return P;return null};for(const m of s){const P=l(m);P?P.push(m):o.push([m])}return o}function h(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function E(s){return{id:new c.$lp(s.identifier.id),name:new c.$lp(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Jp=new S.$Vm("pprice.better-merge");function a(s,i){const o=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const m=l.shift();if(m&&o.every(P=>!d(P.identifier,{id:m}))){const P=s.filter(D=>d(D.identifier,{id:m}));P.length===1&&(o.push(P[0]),l.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(s,i){if(!R.$k)return!1;let o;try{o=(await s.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){i.debug("Error while getting the os-release file.",(0,k.$0)(m))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,i){const o=await t(s,i),l=(0,A.$8o)(o?"alpine":R.$u,u.$ec);return i.debug("ComputeTargetPlatform:",l),l}}),define(re[256],oe([0,1,209,54]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=S;async function S(R,j,k,u,c,d,p){const v={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${j.nameShort})`};if((0,A.$sp)(j,k)&&(0,A.$up)(u)===3){const $=await(0,n.$aq)(k,c,d);v["X-Market-User-Id"]=$,v["VSCode-SessionId"]=p.machineId||$}return v}}),define(re[257],oe([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,g,h){this.k=g,this.l=h,this.d={},this.i=new n.$Tc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=3,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,R.$df)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$df)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(v.$bm)||E.affectsConfiguration(v.$dm)||E.affectsConfiguration(v.$cm))&&this.m()}))}setExperimentProperty(b,g){this.d[b]=g}m(){let b=(0,$.$up)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const h=g.usage?3:g.error?2:0;b=Math.min(b,h)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,g,h){this.g<g||(h=(0,A.$0n)(h,this.d),h=(0,$.$zp)(h,this.j),h=(0,A.$0n)(h,this.c),this.b.forEach(E=>E.log(b,h)))}publicLog(b,g){this.n(b,3,g)}publicLog2(b,g){this.publicLog(b,g)}publicLogError(b,g){this.h&&this.n(b,2,g)}publicLogError2(b,g){this.publicLogError(b,g)}};e.$6r=f,e.$6r=f=ke([ne(1,k.$7i),ne(2,d.$nk)],f);function y(){const w=(0,j.localize)(0,null,c.default.nameLong),b=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=S.$o?"":(0,j.localize)(3,null),h=(0,j.localize)(4,null),E=(0,j.localize)(5,null),a=(0,j.localize)(6,null),t=(0,j.localize)(7,null),r=`
|       | ${h} | ${E} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,j.localize)(8,null);return`
${w} ${b} ${g}

&nbsp;

${t}
${r}

&nbsp;

${s}
`}p.$ho.as(u.$mo.Configuration).registerConfiguration({id:v.$am,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[v.$bm]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.$ho.as(u.$mo.Configuration).registerConfiguration({id:v.$am,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[v.$dm]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${v.$bm}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[258],oe([0,1,4,89,28]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=R,e.$rec=j;async function R(k,u){let c=k.getItem(S.$$l);return(typeof c!="string"||n.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,A.$Jn)(u.error.bind(u))),c}async function j(k,u){let c=k.getItem(S.$_l);return typeof c!="string"&&(c=await(0,A.$Kn)(u.error.bind(u))),c}}),define(re[259],oe([0,1,28,258]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=S,e.$tec=R;async function S(j,k){const u=await(0,A.$qec)(j,k);return j.setItem(n.$$l,u),u}async function R(j,k){const u=await(0,A.$rec)(j,k);return j.setItem(n.$_l,u),u}}),define(re[128],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(re[260],oe([0,1,4,128]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;const S=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(d){this.collections=d,this.a=new Map,this.b=new Map,d.forEach((p,v)=>{this.d(p,v);const $=p.map.entries();let f=$.next();for(;!f.done;){const y=f.value[1],w=f.value[0];let b=this.a.get(w);if(b||(b=[],this.a.set(w,b)),b.length>0&&b[0].type===A.EnvironmentVariableMutatorType.Replace){f=$.next();continue}const g={extensionIdentifier:v,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};g.scope||delete g.scope,b.unshift(g),f=$.next()}})}async applyToProcessEnvironment(d,p,v){let $;n.$i&&($={},Object.keys(d).forEach(f=>$[f.toLowerCase()]=f));for(const[f,y]of this.getVariableMap(p)){const w=n.$i&&$[f.toLowerCase()]||f;for(const b of y){const g=v?await v(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case A.EnvironmentVariableMutatorType.Append:d[w]=(d[w]||"")+g;break;case A.EnvironmentVariableMutatorType.Prepend:d[w]=g+(d[w]||"");break;case A.EnvironmentVariableMutatorType.Replace:d[w]=g;break}if(b.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${S.get(b.type)}`;d[h]=(d[h]?d[h]+":":"")+f+"="+this.c(g)}}}}c(d){return d.replaceAll(":","\\x3a")}diff(d,p){const v=new Map,$=new Map,f=new Map;if(d.getVariableMap(p).forEach((y,w)=>{const b=this.getVariableMap(p).get(w),g=k(y,b);g&&v.set(w,g)}),this.getVariableMap(p).forEach((y,w)=>{const b=d.getVariableMap(p).get(w),g=k(y,b);g&&f.set(w,g)}),this.getVariableMap(p).forEach((y,w)=>{const b=d.getVariableMap(p).get(w),g=u(y,b);g&&$.set(w,g)}),!(v.size===0&&$.size===0&&f.size===0))return{added:v,changed:$,removed:f}}getVariableMap(d){const p=new Map;for(const v of this.a.values()){const $=v.filter(f=>j(f,d));$.length>0&&p.set($[0].variable,$)}return p}getDescriptionMap(d){const p=new Map;for(const v of this.b.values()){const $=v.filter(f=>j(f,d,!0));for(const f of $)p.set(f.extensionIdentifier,f.description)}return p}d(d,p){if(!d.descriptionMap)return;const v=d.descriptionMap.entries();let $=v.next();for(;!$.done;){const f=$.value[1],y=$.value[0];let w=this.b.get(y);w||(w=[],this.b.set(y,w));const b={extensionIdentifier:p,scope:f.scope,description:f.description};b.scope||delete b.scope,w.push(b),$=v.next()}}}e.$xs=R;function j(c,d,p=!1){return c.scope?!!(c.scope.workspaceFolder&&d?.workspaceFolder&&c.scope.workspaceFolder.index===d.workspaceFolder.index):p?d===c.scope:!0}function k(c,d){if(!d)return c;const p=new Set;d.forEach($=>p.add($.extensionIdentifier));const v=[];return c.forEach($=>{p.has($.extensionIdentifier)||v.push($)}),v.length===0?void 0:v}function u(c,d){if(!d)return;const p=new Map;d.forEach($=>p.set($.extensionIdentifier,$));const v=[];return c.forEach($=>{const f=p.get($.extensionIdentifier);f&&($.type!==f.type||$.value!==f.value||$.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&v.push(f)}),v.length===0?void 0:v}}),define(re[261],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=n,e.$ss=A,e.$ts=S,e.$us=R,e.$vs=j,e.$ws=k;function n(u){return[...u.entries()]}function A(u){return u?[...u.entries()]:[]}function S(u){return new Map(u)}function R(u){return new Map(u??[])}function j(u){return Array.from(u.entries()).map(c=>[c[0],n(c[1].map),A(c[1].descriptionMap)])}function k(u){return new Map(u.map(c=>[c[0],{map:S(c[1]),descriptionMap:R(c[2])}]))}}),define(re[262],oe([0,1,8,23,3,2,5]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;let k=class extends R.$Uc{constructor(c,d){super(),this.h=d,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$he),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,R.$Sc)(()=>{for(const p of this.f.values())(0,R.$Pc)(p)}))}createRequest(c){return new Promise((d,p)=>{const v=++this.a;this.c.set(v,d),this.g.fire({requestId:v,...c});const $=new A.$se;(0,n.$Bh)(this.b,$.token).then(()=>p(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,R.$Sc)(()=>$.cancel())])})}acceptReply(c,d){const p=this.c.get(c);p?(this.c.delete(c),(0,R.$Pc)(this.f.get(c)||[]),this.f.delete(c),p(d)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$is=k,e.$is=k=ke([ne(1,j.$7j)],k)}),define(re[129],oe([0,1,6,118,45]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=e.$ds=e.$cs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$bs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$as=void 0,e.$as=new A.$Rj("terminalTabFocusMode",!1,!0);var R;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var j;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var k;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(k||(e.PosixShellType=k={}));var u;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(u||(e.WindowsShellType=u={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var d;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(d||(e.TerminalIpcChannels=d={}));var p;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.$bs=(0,n.$Ai)("ptyService");var v;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var $;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})($||(e.TerminalLocation=$={}));var f;(function(a){a.TerminalView="view",a.Editor="editor"})(f||(e.TerminalLocationString=f={}));var y;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var w;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var b;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(b||(e.ProfileSource=b={}));var g;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(g||(e.ShellIntegrationStatus=g={}));var h;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$cs={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const r=this.b(t.remoteAuthority);if(this.a.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this.a.set(r,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$ho.add(e.$cs.Backend,new E),e.$ds=(0,n.$Ai)("localPtyService"),e.$es=(0,n.$Ai)("terminalLogService")}),define(re[263],oe([0,1,75,7,190,106]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=j,e.$ks=c,e.$ls=d,e.$ms=p;function j(v,$){const f=[{name:null,description:(0,S.localize)(0,null)}];return f.push(...v.map(y=>({name:y.profileName,description:k(y)}))),$&&f.push(...$.map(y=>({name:y.title,description:u(y)}))),{values:f.map(y=>y.name),markdownDescriptions:f.map(y=>y.description)}}function k(v){let $=`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Zj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?$+=`
- args: "${v.args}"`:$+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&($+=`
- overrideName: ${v.overrideName}`),v.color&&($+=`
- color: ${v.color}`),v.env&&($+=`
- env: ${JSON.stringify(v.env)}`),$}function u(v){return`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Zj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function c(v,$){if(!v&&!$)return!0;if(typeof v=="string"&&typeof $=="string")return v===$;if(Array.isArray(v)&&Array.isArray($)){if(v.length!==$.length)return!1;for(let f=0;f<v.length;f++)if(v[f]!==$[f])return!1;return!0}return!1}function d(v,$){if(!v&&!$)return!0;if(!v||!$)return!1;if(R.ThemeIcon.isThemeIcon(v)&&R.ThemeIcon.isThemeIcon($))return v.id===$.id&&v.color===$.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof $=="object"&&"light"in $&&"dark"in $){const f=v,y=$;if((A.URI.isUri(f.light)||p(f.light))&&(A.URI.isUri(f.dark)||p(f.dark))&&(A.URI.isUri(y.light)||p(y.light))&&(A.URI.isUri(y.dark)||p(y.dark)))return f.light.path===y.light.path&&f.dark.path===y.dark.path}if(A.URI.isUri(v)&&A.URI.isUri($)||p(v)||p($)){const f=v,y=$;return f.path===y.path&&f.scheme===y.scheme}return!1}function p(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}}),define(re[264],oe([0,1,75,4,189,52,45,263]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=void 0,e.$ps=$,e.$qs=y,e.$ns={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$os={type:"string",enum:Array.from((0,n.$Xj)(),w=>w.id),markdownEnumDescriptions:Array.from((0,n.$Xj)(),w=>`$(${w.id})`)};const u={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$os},color:{description:(0,S.localize)(3,null),...e.$ns},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...u}},d={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...u}};function p(w){const b=w===2?"linux":w===1?"osx":"windows";return(0,S.localize)(7,null,(0,A.$h)(w),'```json\n"terminal.integrated.profile.'+b+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:p(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...u}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...u}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:p(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...u}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:p(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...u}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,S.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,S.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,S.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function $(){j.$ho.as(R.$mo.Configuration).registerConfiguration(v),y()}let f;function y(w,b){const g=j.$ho.as(R.$mo.Configuration);let h;w&&(h=(0,k.$js)(w?.profiles,b));const E=f;f={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?h?.values:void 0,markdownEnumDescriptions:w?.os===3?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?h?.values:void 0,markdownEnumDescriptions:w?.os===2?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?h?.values:void 0,markdownEnumDescriptions:w?.os===1?h?.markdownDescriptions:void 0}}},g.updateConfigurations({add:[f],remove:E?[E]:[]})}}),define(re[265],oe([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=f,e.$zs=y,e.$As=w;function f(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let m=0;return l&&l.length===4&&(m=parseInt(l[3])),m}async function y(l,m,P,D=k.env,I=d.Promises.exists){if(R.$ic(l))return await I(l)?l:void 0;if(m===void 0&&(m=k.cwd()),R.$mc(l)!=="."){const N=R.$jc(m,l);return await I(N)?N:void 0}const M=(0,S.$bo)(D,"PATH");if(P===void 0&&(0,c.$ag)(M)&&(P=M.split(R.$tc)),P===void 0||P.length===0){const N=R.$jc(m,l);return await I(N)?N:void 0}for(const N of P){let T;if(R.$ic(N)?T=R.$jc(N,l):T=R.$jc(m,N,l),await I(T))return T;if(j.$i){let U=T+".com";if(await I(U)||(U=T+".exe",await I(U)))return U}}const W=R.$jc(m,l);return await I(W)?W:void 0}function w(l,m,P,D,I){const O=j.$i&&(!m.windowsEnableConpty||f()<18309);if(!m.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||O)return;const M=l.args,W=k.$dc==="win32"?R.$nc(l.executable).toLowerCase():R.$nc(l.executable),N=R.$mc(A.$Ug.asFileUri("").fsPath);let T;const U={VSCODE_INJECTION:"1"};if(m.shellIntegration.nonce&&(U.VSCODE_NONCE=m.shellIntegration.nonce),j.$i){if(W==="pwsh.exe"||W==="powershell.exe")return!M||i(M)?T=h.get(g.WindowsPwsh):s(M)&&(T=h.get(g.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,u.$_e)(T[T.length-1],N,""),m.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:U}):void 0;if(W==="bash.exe")return!M||M.length===0?T=h.get(g.Bash):o(M)&&(U.VSCODE_SHELL_LOGIN="1",b(m,U),T=h.get(g.Bash)),T?(T=[...T],T[T.length-1]=(0,u.$_e)(T[T.length-1],N),{newArgs:T,envMixin:U}):void 0;D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(W){case"bash":return!M||M.length===0?T=h.get(g.Bash):o(M)&&(U.VSCODE_SHELL_LOGIN="1",b(m,U),T=h.get(g.Bash)),T?(T=[...T],T[T.length-1]=(0,u.$_e)(T[T.length-1],N),{newArgs:T,envMixin:U}):void 0;case"fish":{const ie=P?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",te=R.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return U.XDG_DATA_DIRS=`${ie}:${te}`,b(m,U),{newArgs:void 0,envMixin:U}}case"pwsh":return!M||i(M)?T=h.get(g.Pwsh):s(M)&&(T=h.get(g.PwshLogin)),T?(m.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,u.$_e)(T[T.length-1],N,""),{newArgs:T,envMixin:U}):void 0;case"zsh":{if(!M||M.length===0?T=h.get(g.Zsh):o(M)?(T=h.get(g.ZshLogin),b(m,U)):(M===h.get(g.Zsh)||M===h.get(g.ZshLogin))&&(T=M),!T)return;T=[...T],T[T.length-1]=(0,u.$_e)(T[T.length-1],N);let ie;try{ie=n.userInfo().username}catch{ie="unknown"}const te=R.$jc(n.tmpdir(),`${ie}-${I.applicationName}-zsh`);U.ZDOTDIR=te;const ae=P?.ZDOTDIR??n.homedir()??"~";U.USER_ZDOTDIR=ae;const K=[];return K.push({source:R.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$jc(te,".zshrc")}),K.push({source:R.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$jc(te,".zprofile")}),K.push({source:R.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$jc(te,".zshenv")}),K.push({source:R.$jc(N,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$jc(te,".zlogin")}),{newArgs:T,envMixin:U,filesToCopy:K}}}D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function b(l,m){if(j.$j&&l.environmentVariableCollections){const P=(0,v.$ws)(l.environmentVariableCollections),I=new $.$xs(P).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),O=[];if(I)for(const M of I)M.type===p.EnvironmentVariableMutatorType.Prepend&&O.push(M.value);O.length>0&&(m.VSCODE_PATH_PREFIX=O.join(""))}}var g;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(g||(g={}));const h=new Map;h.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(g.Zsh,["-i"]),h.set(g.ZshLogin,["-il"]),h.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],a=["--login","-l"],t=["-i","--interactive"],r=["-nol","-nologo"];function s(l){return typeof l=="string"?E.includes(l.toLowerCase()):l.length===1&&E.includes(l[0].toLowerCase())||l.length===2&&(E.includes(l[0].toLowerCase())||E.includes(l[1].toLowerCase()))&&(r.includes(l[0].toLowerCase())||r.includes(l[1].toLowerCase()))}function i(l){return typeof l=="string"?r.includes(l.toLowerCase()):l.length===0||l?.length===1&&r.includes(l[0].toLowerCase())}function o(l){return typeof l!="string"&&(l=l.filter(m=>!t.includes(m.toLowerCase()))),l==="string"&&a.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&a.includes(l[0].toLowerCase())}}),define(re[266],oe([0,1,49,75,9,4,12,21,110,265,117]),function(Q,e,n,A,S,R,j,k,u,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=f;var p;(function(l){l.UnixShellsPath="/etc/shells"})(p||(p={}));let v,$=!0;function f(l,m,P,D,I=process.env,O,M,W,N){return O=O||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},R.$i?y(P,O,I,M,D.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:D.getValue("terminal.integrated.profiles.windows"),typeof m=="string"?m:D.getValue("terminal.integrated.defaultProfile.windows"),N,W):s(O,M,P,l&&typeof l=="object"?{...l}:D.getValue(R.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof m=="string"?m:D.getValue(R.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,W,I)}async function y(l,m,P,D,I,O,M,W,N){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let ie=!1;(0,c.$ys)()>=16299&&(ie=!0),await h(W);const te=new Map;if(l){te.set("PowerShell",{source:"PowerShell",icon:A.$Zj.terminalPowershell,isAutoDetected:!0}),te.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$Zj.terminalPowershell,isAutoDetected:!0}),te.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),te.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:A.$Zj.terminalCmd,isAutoDetected:!0}),te.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),te.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:A.$Zj.terminalBash,isAutoDetected:!0});const K=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;te.set("Cmder",{path:`${U}\\cmd.exe`,args:["/K",K],requiresPath:process.env.CMDER_ROOT?K:{path:K,isUnsafe:!0},isAutoDetected:!0})}i(O,te);const ae=await w(te.entries(),M,m,P,D,N);if(l&&I)try{const K=await t(`${U}\\${ie?"wsl":"bash"}.exe`,M);for(const J of K)(!O||!(J.profileName in O))&&ae.push(J)}catch{$&&(D?.trace("WSL is not installed, so could not detect WSL profiles"),$=!1)}return ae}async function w(l,m,P,D=process.env,I,O){const M=[];for(const[W,N]of l)M.push(b(W,N,m,P,D,I,O));return(await Promise.all(M)).filter(W=>!!W)}async function b(l,m,P,D,I=process.env,O,M){if(m===null)return;let W,N,T;if("source"in m&&!("path"in m)){const ae=v?.get(m.source);if(!ae)return;W=ae.paths,N=m.args||ae.args,m.icon?T=g(m.icon):ae.icon&&(T=ae.icon)}else W=Array.isArray(m.path)?m.path:[m.path],N=R.$i||Array.isArray(m.args)?m.args:void 0,T=g(m.icon);let U;if(M){const ae=W.map(J=>typeof J=="string"?J:J.path),K=await M(ae);U=new Array(W.length);for(let J=0;J<W.length;J++)typeof W[J]=="string"?U[J]=K[J]:U[J]={path:K[J],isUnsafe:!0}}else U=W.slice();let ie;if(m.requiresPath){let ae;if((0,j.$ag)(m.requiresPath)?ae=m.requiresPath:(ae=m.requiresPath.path,m.requiresPath.isUnsafe&&(ie=ae)),!await D.existsFile(ae))return}const te=await o(l,P,U,D,I,N,m.env,m.overrideName,m.isAutoDetected,ie);if(!te){O?.debug("Terminal profile not validated",l,W);return}return te.isAutoDetected=m.isAutoDetected,te.icon=T,te.color=m.color,te}function g(l){return typeof l=="string"?{id:l}:l}async function h(l){if(v&&!l)return;const[m,P]=await Promise.all([E(),l||a()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:m,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:P,icon:A.$Zj.terminalPowershell})}async function E(){const l=new Set,m=await(0,c.$zs)("git.exe");if(m){const I=(0,d.dirname)(m);l.add((0,d.resolve)(I,"../.."))}function P(I,O){O&&I.add(O)}P(l,process.env.ProgramW6432),P(l,process.env.ProgramFiles),P(l,process.env["ProgramFiles(X86)"]),P(l,`${process.env.LocalAppData}\\Program`);const D=[];for(const I of l)D.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function a(){const l=[];for await(const m of(0,u.$om)())l.push(m.exePath);return l}async function t(l,m){const P=[],D=await new Promise((M,W)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,T)=>{if(N)return W("Problem occurred when getting wsl distros");M(T)})});if(!D)return[];const I=new RegExp(/[\r?\n]/),O=D.split(I).filter(M=>M.trim().length>0&&M!=="");for(const M of O){if(M===""||M.startsWith("docker-desktop"))continue;const W=`${M} (WSL)`,N={profileName:W,path:l,args:["-d",`${M}`],isDefault:W===m,icon:r(M),isAutoDetected:!1};P.push(N)}return P}function r(l){return l.includes("Ubuntu")?A.$Zj.terminalUbuntu:l.includes("Debian")?A.$Zj.terminalDebian:A.$Zj.terminalLinux}async function s(l,m,P,D,I,O,M,W){const N=new Map;if(P&&await l.existsFile("/etc/shells")){const T=(await l.readFile("/etc/shells")).toString(),U=(O||T.split(`
`)).map(te=>{const ae=te.indexOf("#");return ae===-1?te:te.substring(0,ae)}).filter(te=>te.trim().length>0),ie=new Map;for(const te of U){let ae=(0,S.$nc)(te),K=ie.get(ae)||0;K++,K>1&&(ae=`${ae} (${K})`),ie.set(ae,K),N.set(ae,{path:te,isAutoDetected:!0})}}return i(D,N),await w(N.entries(),I,l,W,m,M)}function i(l,m){if(l)for(const[P,D]of Object.entries(l))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?m.delete(P):(D.icon=D.icon||m.get(P)?.icon,m.set(P,D))}async function o(l,m,P,D,I,O,M,W,N,T){if(P.length===0)return Promise.resolve(void 0);const U=P.shift();if(U==="")return o(l,m,P,D,I,O,M,W,N);const ie=typeof U!="string"&&U.isUnsafe,te=typeof U=="string"?U:U.path,ae={profileName:l,path:te,args:O,env:M,overrideName:W,isAutoDetected:N,isDefault:l===m,isUnsafePath:ie,requiresUnsafePath:T};if((0,S.$nc)(te)===te){const J=I.PATH?I.PATH.split(S.$tc):void 0,q=await(0,c.$zs)(te,void 0,J,void 0,D.existsFile);return q?(ae.path=q,ae.isFromPath=!0,ae):o(l,m,P,D,I,O)}return await D.existsFile((0,S.$hc)(te))?ae:o(l,m,P,D,I,O,M,W,N)}}),define(re[267],oe([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=void 0;var w;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let b=class extends A.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,E,a,t){super(),this.M=h,this.N=E,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$he),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$he),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$he),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$he),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$he),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$he),this.onProcessData=this.D.event,this.F=this.B(new n.$he),this.onProcessReady=this.F.event,this.G=this.B(new n.$he),this.onProcessReplay=this.G.event,this.H=this.B(new n.$he),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$he),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$he),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$he),this.onProcessExit=this.L.event,(0,v.$ps)(),this.B(this.M),this.B((0,A.$Sc)(()=>this.W())),this.j=this.B(new d.$is(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,c.$Km)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),E=h.client;this.O.getLevel()===k.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(E.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(r=>{this.u.fire(r.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${r.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const t=R.ProxyChannel.toService(E.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(r=>this.D.fire(r))),this.B(t.onProcessReady(r=>this.F.fire(r))),this.B(t.onProcessExit(r=>this.L.fire(r))),this.B(t.onDidChangeProperty(r=>this.J.fire(r))),this.B(t.onProcessReplay(r=>this.G.fire(r))),this.B(t.onProcessOrphanQuestion(r=>this.H.fire(r))),this.B(t.onDidRequestDetach(r=>this.I.fire(r))),this.B(new u.$hs(this.P,E.getChannel(p.TerminalIpcChannels.Logger))),this.a=h,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,t]}async createProcess(h,E,a,t,r,s,i,o,l,m,P){const D=setTimeout(()=>this.$(),p.HeartbeatConstants.CreateProcessTimeout),I=await this.f.createProcess(h,E,a,t,r,s,i,o,l,m,P);return clearTimeout(D),I}updateTitle(h,E,a){return this.f.updateTitle(h,E,a)}updateIcon(h,E,a,t){return this.f.updateIcon(h,E,a,t)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,E){return this.f.detachFromProcess(h,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,E){return this.f.shutdown(h,E)}input(h,E){return this.f.input(h,E)}processBinary(h,E){return this.f.processBinary(h,E)}resize(h,E,a){return this.f.resize(h,E,a)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,E){return this.f.acknowledgeDataEvent(h,E)}setUnicodeVersion(h,E){return this.f.setUnicodeVersion(h,E)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new y.$be,E=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...E]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,E){return this.f.installAutoReply(h,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,f.$um)(h??S.OS,process.env)}async getProfiles(h,E,a,t=!1){const r=await this.S();return(0,$.$Bs)(E,a,t,this.N,r,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,E){return this.f.getWslPath(h,E)}getRevivedPtyNewId(h,E){return this.f.getRevivedPtyNewId(h,E)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,E){return this.f.requestDetachInstance(h,E)}async acceptDetachInstanceReply(h,E){return this.f.acceptDetachInstanceReply(h,E)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,E,a){return this.f.reviveTerminalProcesses(h,E,a)}async refreshProperty(h,E){return this.f.refreshProperty(h,E)}async updateProperty(h,E,a){return this.f.updateProperty(h,E,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?p.HeartbeatConstants.ConnectingBeatInterval:p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,E){return this.j.createRequest({workspaceId:h,originalText:E})}async acceptPtyHostResolvedVariables(h,E){this.j.acceptReply(h,E)}};e.$Cs=b,e.$Cs=b=ke([ne(1,j.$7i),ne(2,k.$7j),ne(3,k.$8j)],b)}),define(re[69],oe([0,1,14,3,2,4,18,6,34]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0;const c="#FFFFFF",d="#1E1E1E",p="#000000",v="#FFFFFF",$="theme",f="themeBackground",y="windowSplash";var w;(function(g){g.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",g.SYSTEM_COLOR_THEME="window.systemColorTheme"})(w||(w={})),e.$Qcc=(0,k.$Ai)("themeMainService");let b=class extends S.$Uc{constructor(h,E){super(),this.b=h,this.c=E,this.a=this.B(new A.$he),this.onDidChangeColorScheme=this.a.event,R.$k||this.B(this.c.onDidChangeConfiguration(a=>{(a.affectsConfiguration(w.SYSTEM_COLOR_THEME)||a.affectsConfiguration(w.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(A.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(R.$k||this.c.getValue(w.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.c.getValue(w.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(R.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?p:v;let E=this.b.getItem(f,null);if(!E)switch(this.g()){case"vs":E=c;break;case"hc-black":E=p;break;case"hc-light":E=v;break;default:E=d}return R.$j&&E.toUpperCase()===d&&(E="#171717"),E}g(){switch(this.b.getItem($,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(h,E){this.b.setItems([{key:$,data:E.baseTheme},{key:f,data:E.colorInfo.background},{key:y,data:E}]),typeof h=="number"&&this.h(h,E),this.f()}h(h,E){for(const a of n.BrowserWindow.getAllWindows())if(a.id===h){a.setBackgroundColor(E.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(y)}};e.$Rcc=b,e.$Rcc=b=ke([ne(0,u.$0P),ne(1,j.$7i)],b)}),define(re[130],oe([0,1,3,7,18,6,5]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zw=e.$yw=e.$vw=e.$tw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$pw=e.$ow=void 0,e.$qw=c,e.$rw=p,e.$sw=v,e.$uw=$,e.$ww=f,e.$xw=y,e.$ow=(0,R.$Ai)("tunnelService"),e.$pw=(0,R.$Ai)("sharedTunnelsService");var k;(function(g){g.Http="http",g.Https="https"})(k||(e.TunnelProtocol=k={}));var u;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(u||(e.TunnelPrivacyId=u={}));function c(g){return!!g.forwardPort}var d;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function p(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(h)return{address:h[1],port:+h[2]}}function v(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const h=g.query.split("&");for(const E of h){const a=E.split("=")[1];if(/^https?:/.exec(a)){const t=p(A.URI.parse(a));if(t)return t}}}e.$tw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function $(g){return e.$tw.indexOf(g)>=0}e.$vw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(g){return e.$vw.indexOf(g)>=0}function y(g,h,E,a){if(E===1)return!1;if(E===2&&f(h)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return g<1024}class w{constructor(h,E,a){this.remoteAddress=h,this.localAddress=E,this.b=a,this.a=new n.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$yw=w;let b=class{constructor(h,E){this.k=h,this.l=E,this.a=new n.$he,this.onTunnelOpened=this.a.event,this.b=new n.$he,this.onTunnelClosed=this.b.event,this.c=new n.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],E=Array.from(this.e.values());for(const a of E){const t=Array.from(a.values());for(const r of t){const s=await r.value;s&&typeof s!="string"&&h.push(s)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:E}of h.values())await E.then(a=>typeof a!="string"?a?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,E,a,t,r){this.q(h,E,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:E,localAddress:a,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,E){(f(h)||$(h))&&(h=e.$tw[0]);const a=this.s(h,E);if(a)return++a.refcount,a.value}openTunnel(h,E,a,t,r,s=!1,i,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${a} on local port ${r}.`);const l=this.f??h;if(!l)return;if(E||(E="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const m=this.t(l,E,a,t,r,s,i,o);return m?m.then(P=>{if(P){if(typeof P=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(E,a),P}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(E,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(P);return(P.tunnelRemoteHost!==E||P.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&P.privacy!==i&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),m)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const E=this.e.get(h.tunnelRemoteHost);if(E){const a=E.get(h.tunnelRemotePort);a&&(a.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,a))}}}}async p(h,E,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${E}.`);const t=a.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(E),t}}async closeTunnel(h,E){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${E} `);const a=this.e.get(h);if(a&&a.has(E)){const t=a.get(E);t.refcount=0,await this.p(h,E,t)}}q(h,E,a){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(E,{refcount:1,value:a})}async r(h,E){const a=this.e.get(h);if(a){const t=a.get(E),r=t?await t.value:void 0;(!r||typeof r=="string")&&a.delete(E),a.size===0&&this.e.delete(h)}}s(h,E){const a=[h];$(h)?(a.push(...e.$tw),a.push(...e.$vw)):f(h)&&a.push(...e.$vw);const t=a.map(r=>this.e.get(r));for(const r of t){const s=r?.get(E);if(s)return s}}canTunnel(h){return!!p(h)}u(h,E,a,t,r,s,i){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${a} on local port ${t}.`);const o=a;this.j.add(o);const l=t===void 0?a:t,m={elevationRequired:r?this.isPortPrivileged(l):!1},P={remoteAddress:{host:E,port:a},localAddressPort:t,privacy:s,public:s?s!==u.Private:void 0,protocol:i},D=h.forwardPort(P,m);return D?(this.q(E,a,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),D}};e.$zw=b,e.$zw=b=ke([ne(0,j.$7j),ne(1,S.$7i)],b)}),define(re[50],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uX=e.$tX=e.DisablementReason=e.UpdateType=e.StateType=void 0;var A;(function(j){j.Uninitialized="uninitialized",j.Idle="idle",j.Disabled="disabled",j.CheckingForUpdates="checking for updates",j.AvailableForDownload="available for download",j.Downloading="downloading",j.Downloaded="downloaded",j.Updating="updating",j.Ready="ready"})(A||(e.StateType=A={}));var S;(function(j){j[j.Setup=0]="Setup",j[j.Archive=1]="Archive",j[j.Snap=2]="Snap"})(S||(e.UpdateType=S={}));var R;(function(j){j[j.NotBuilt=0]="NotBuilt",j[j.DisabledByEnvironment=1]="DisabledByEnvironment",j[j.ManuallyDisabled=2]="ManuallyDisabled",j[j.MissingConfiguration=3]="MissingConfiguration",j[j.InvalidConfiguration=4]="InvalidConfiguration",j[j.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$tX={Uninitialized:{type:"uninitialized"},Disabled:j=>({type:"disabled",reason:j}),Idle:(j,k)=>({type:"idle",updateType:j,error:k}),CheckingForUpdates:j=>({type:"checking for updates",explicit:j}),AvailableForDownload:j=>({type:"available for download",update:j}),Downloading:{type:"downloading"},Downloaded:j=>({type:"downloaded",update:j}),Updating:j=>({type:"updating",update:j}),Ready:j=>({type:"ready",update:j})},e.$uX=(0,n.$Ai)("updateService")}),define(re[268],oe([0,1,4,191,52,45]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$ho.as(S.$mo.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(re[269],oe([0,1,3,50]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=void 0;class S{constructor(k){this.a=k}listen(k,u){switch(u){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${u}`)}call(k,u,c){switch(u){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${u}`)}}e.$3dc=S;class R{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new n.$he,this.onStateChange=this.a.event,this.b=A.$tX.Uninitialized,this.c.listen("onStateChange")(u=>this.state=u),this.c.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.$4dc=R}),define(re[40],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,n.$Ai)("IUriIdentityService")}),define(re[270],oe([0,1,40,210,16,19,142,3,2]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class c{static{this._clock=0}constructor(v){this.uri=v,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let d=class{constructor(v){this.g=v,this.c=new u.$Tc,this.f=2**16;const $=new Map,f=y=>{let w=$.get(y.scheme);return w===void 0&&(w=v.hasProvider(y)&&!this.g.hasCapability(y,1024),$.set(y.scheme,w)),w};this.c.add(k.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(y=>{$.delete(y.scheme)})),this.extUri=new R.$3g(f),this.d=new j.$Fs((y,w)=>this.extUri.compare(y,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,R.$ch)(v));const $=this.d.get(v);return $?$.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new c(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((f,y)=>f[1].time<y[1].time?1:f[1].time>y[1].time?-1:0);c._clock=0,this.d.clear();const $=this.f*.5;for(let f=0;f<$;f++)this.d.set(v[f][0],v[f][1].touch())}};e.$Gs=d,e.$Gs=d=ke([ne(0,S.$7k)],d),(0,A.$Ds)(n.$El,d,1)}),define(re[131],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kX=void 0,e.$kX=(0,n.$Ai)("urlService")}),define(re[271],oe([0,1,7]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=e.$$dc=void 0;class A{constructor(k){this.a=k}listen(k,u){throw new Error(`Event not found: ${u}`)}call(k,u,c){switch(u){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${u}`)}}e.$$dc=A;class S{constructor(k){this.a=k}handleURL(k,u){return this.a.call("handleURL",[k.toJSON(),u])}}e.$_dc=S;class R{constructor(k,u){this.a=k,this.b=u}async routeCall(k,u,c,d){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(Array.isArray(c)&&c.length>0){const p=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",p.toString(!0)),p.query){const v=/\bwindowId=(\d+)/.exec(p.query);if(v){const $=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${$}"`,p.toString(!0));const f=new RegExp(`window:${$}`),y=k.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),f.test(w.ctx)));if(y)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",p.toString(!0)),y;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",p.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",p.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,u,c,d)}routeEvent(k,u){throw new Error(`Event not found: ${u}`)}}e.$aec=R}),define(re[272],oe([0,1,8,2,7,27]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mX=e.$lX=void 0;class j extends A.$Uc{constructor(){super(...arguments),this.a=new Set}open(c,d){const p=[...this.a.values()];return(0,n.$Eh)(p.map(v=>()=>v.handleURL(c,d)),void 0,!1).then(v=>v||!1)}registerHandler(c){return this.a.add(c),(0,A.$Sc)(()=>this.a.delete(c))}}e.$lX=j;let k=class extends j{constructor(c){super(),this.b=c}create(c){let{authority:d,path:p,query:v,fragment:$}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return d&&p&&p.indexOf("/")!==0&&(p=`/${p}`),S.URI.from({scheme:this.b.urlProtocol,authority:d,path:p,query:v,fragment:$})}};e.$mX=k,e.$mX=k=ke([ne(0,R.$nk)],k)}),define(re[273],oe([0,1,14,8,3,2,4,7]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class u extends R.$Uc{constructor(d,p,v,$,f,y){if(super(),this.c=p,this.f=y,this.a=[],this.b=0,d&&(y.trace("ElectronURLListener initialUrisToHandle:",d.map(g=>g.originalUrl)),this.a=d),j.$i){const g=$.isBuilt?[]:[`"${$.appRoot}"`];g.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,g)}const w=S.Event.map(S.Event.fromNodeEventEmitter(n.app,"open-url",(g,h)=>({event:g,url:h})),({event:g,url:h})=>(g.preventDefault(),h));this.B(w(g=>{const h=this.g(g);h&&this.c.open(h,{originalUrl:g})})),v.getWindows().filter(g=>g.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(S.Event.once(v.onDidSignalReadyWindow)(()=>this.h())))}g(d){try{return k.URI.parse(d)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const d=[];for(const p of this.a)await this.c.open(p.uri,{originalUrl:p.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",p.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",p.originalUrl),d.push(p));d.length!==0&&(this.a=d,(0,A.$Ch)(()=>this.h(),500,this.q))}}e.$bec=u}),define(re[274],oe([0,1,3,2,16,59,32]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class k extends A.$Uc{constructor(c,d,p,v,$,f){super(),this.f=c,this.g=d,this.h=p,this.j=v,this.m=$,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$he),this.onDidChangeFile=this.a.event,this.b=R.$Gi.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Bc(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,d){return this.g.open(this.t(c),d)}close(c){return this.g.close(c)}read(c,d,p,v,$){return this.g.read(c,d,p,v,$)}write(c,d,p,v,$){return this.g.write(c,d,p,v,$)}watch(c,d){this.b.set(c,c);const p=this.g.watch(this.t(c),d);return(0,A.$Sc)(()=>{this.b.delete(c),p.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,d,p){return this.g.rename(this.t(c),this.t(d),p)}readFile(c,d){return this.g.readFile(this.t(c),d)}readFileStream(c,d,p){return this.g.readFileStream(this.t(c),d,p)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,d,p){return this.g.writeFile(this.t(c),d,p)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,d){return this.g.delete(this.t(c),d)}copy(c,d,p){if((0,S.$$k)(this.g))return this.g.copy(this.t(c),this.t(d),p);throw new Error("copy not supported")}cloneFile(c,d){if((0,S.$_k)(this.g))return this.g.cloneFile(this.t(c),this.t(d));throw new Error("clone not supported")}s(c){const d=[];for(const p of c){if(p.resource.scheme!==this.f)continue;const v=this.u(p.resource);this.b.findSubstr(v)&&d.push({resource:v,type:p.type,cId:p.cId})}d.length&&(this.n.debug("User data changed"),this.a.fire(d))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Oec=k}),define(re[275],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0,e.$vec="utilityProcessWorker"}),define(re[276],oe([0,1,6]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0,e.$cec=(0,n.$Ai)("webviewManagerService")}),define(re[277],oe([0,1,14,2,13,7]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class j extends A.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const u=this.b.bind(this);n.protocol.registerFileProtocol(S.Schemas.vscodeWebview,u)}b(u,c){try{const d=R.URI.parse(u.url),p=j.a.get(d.path);if(typeof p=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${p}`,$=S.$Ug.asFileUri(v);return c({path:$.fsPath,headers:{...S.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$dec=j}),define(re[55],oe([0,1,4]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PD=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$GD=void 0,e.$HD=A,e.$ID=S,e.$JD=R,e.$KD=j,e.$LD=k,e.$MD=p,e.$ND=v,e.$OD=$,e.$QD=f,e.$RD=y,e.$SD=w,e.$GD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(b){return typeof b.parentId=="number"}function S(b){return!!b.workspaceUri}function R(b){return!!b.folderUri}function j(b){return!!b.fileUri}function k(b){const g=v(b),h=b.getValue("window.menuBarVisibility");return h==="default"||g&&h==="compact"||n.$j&&n.$m?"classic":h}var u;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(u||(e.TitleBarSetting=u={}));var c;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var d;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(d||(e.CustomTitleBarVisibility=d={}));function p(b,g){return!0}function v(b,g){return g||(g=$(b)),g==="native"}function $(b){if(n.$o)return"custom";const g=b.getValue("window");if(g){if(n.$j&&g.nativeTabs===!0||n.$j&&g.nativeFullScreen===!1)return"native";const a=g.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}e.$PD=35;function f(b){return!(!n.$i||n.$o||v(b))}function y(b){const g=b.getValue("window");return!g||typeof g.nativeFullScreen!="boolean"||g.nativeTabs?!0:g.nativeFullScreen!==!1}function w(b=0){return Math.pow(1.2,b)}}),define(re[82],oe([0,1,14]),function(Q,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$Gcc=e.$Fcc=e.UnloadReason=e.LoadReason=void 0;var A;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(A||(e.LoadReason=A={}));var S;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(S||(e.UnloadReason=S={}));const R=function(c=1){return{width:1024,height:768,mode:c}};e.$Fcc=R;const j=function(){const p=n.screen.getPrimaryDisplay().workArea,v=Math.max(p.x+p.width/2-800/2,0),$=Math.max(p.y+p.height/2-600/2,0);return{x:v,y:$,width:800,height:600,mode:1}};e.$Gcc=j;var k;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(k||(e.WindowMode=k={}));var u;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(u||(e.WindowError=u={}))}),define(re[278],oe([0,1,8,3,2]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class R extends S.$Uc{constructor({onDidOpenMainWindow:k,onDidFocusMainWindow:u,getActiveWindowId:c}){super(),this.a=this.B(new S.$Tc),A.Event.latch(A.Event.any(k,u))(this.f,this,this.a),this.b=(0,n.$nh)(()=>c()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$jec=R}),define(re[30],oe([0,1,195,9,59,19,7,6,13]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=c,e.$Li=d,e.$Oi=p,e.$Pi=v,e.$Qi=$,e.$Ri=y,e.$Si=w,e.$Vi=h,e.$1i=E,e.$2i=a,e.$4i=t,e.$5i=r,e.$6i=s,e.$Ji=(0,k.$Ai)("contextService");function c(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.uri)}function d(i){return typeof i?.id=="string"&&!c(i)&&!v(i)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function p(i,o){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.$nc)(i)}:o?e.$Mi:e.$Ni;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function v(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.configPath)}function $(i){const o=i;if(o?.uri)return{id:o.id,uri:j.URI.revive(o.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:j.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function y(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function w(i){const o=i;return!!(o&&typeof o=="object"&&j.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class b{constructor(o,l,m,P,D){this.h=o,this.j=m,this.k=P,this.l=D,this.c=S.$Gi.forUris(this.l,()=>!0),this.folders=l}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=S.$Gi.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=b;class g{constructor(o,l){this.raw=l,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,R.$bh)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=g;function h(i){return new g({uri:i,index:0,name:(0,R.$0g)(i)},{uri:i.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,n.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function E(i,o){return R.$5g.isEqualOrParent(i,o.untitledWorkspacesHome)}function a(i){let o;return j.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===u.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$3i}function r(i,o){return!E(i,o)&&!a(i)}function s(i){return(typeof i=="string"?(0,A.$oc)(i):(0,R.$_g)(i))===e.$Xi}}),define(re[56],oe([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=e.$Ncc=void 0,e.$Ncc=(0,v.$Ai)("dialogMainService");let w=class{constructor(g,h){this.d=g,this.e=h,this.a=new Map,this.b=new Map,this.c=new A.$Hh}pickFileFolder(g,h){return this.f({...g,pickFolders:!0,pickFiles:!0,title:(0,d.localize)(0,null)},h)}pickFolder(g,h){return this.f({...g,pickFolders:!0,title:(0,d.localize)(1,null)},h)}pickFile(g,h){return this.f({...g,pickFiles:!0,title:(0,d.localize)(2,null)},h)}pickWorkspace(g,h){const E=(0,d.localize)(3,null),a=(0,R.$Qw)((0,d.localize)(4,null)),t=y.$Yi;return this.f({...g,pickFiles:!0,title:E,filters:t,buttonLabel:a},h)}async f(g,h){const E={title:g.title,buttonLabel:g.buttonLabel,filters:g.filters,defaultPath:g.defaultPath};(typeof g.pickFiles=="boolean"||typeof g.pickFolders=="boolean")&&(E.properties=void 0,g.pickFiles&&g.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",g.pickFolders?"openDirectory":"openFile","createDirectory"]),u.$j&&E.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(E,(h||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(g){if(g){let h=this.b.get(g.id);return h||(h=new A.$Hh,this.b.set(g.id,h)),h}else return this.c}showMessageBox(g,h){return this.g(h).queue(async()=>{const{options:E,buttonIndeces:a}=(0,p.$Xw)(g,this.e);let t;return h?t=await n.dialog.showMessageBox(h,E):t=await n.dialog.showMessageBox(E),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(g,h){const E=this.j(g,h);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showSaveDialog(h,g):a=await n.dialog.showSaveDialog(g),a.filePath=this.h(a.filePath),a})}finally{(0,j.$Pc)(E)}}h(g){return g&&u.$j&&(g=(0,k.$fm)(g)),g}i(g){return g.map(h=>this.h(h))}async showOpenDialog(g,h){g.defaultPath&&(await c.Promises.exists(g.defaultPath)||(g.defaultPath=void 0));const E=this.j(g,h);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showOpenDialog(h,g):a=await n.dialog.showOpenDialog(g),a.filePaths=this.i(a.filePaths),a})}finally{(0,j.$Pc)(E)}}j(g,h){if(!h)return j.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",g);let E=this.a.get(h.id);E||(E=new Set,this.a.set(h.id,E));const a=(0,S.$oj)(g);if(!E.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",g),E.add(a),(0,j.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",g),E?.delete(a),E?.size===0&&this.a.delete(h.id)})}};e.$Occ=w,e.$Occ=w=ke([ne(0,$.$7j),ne(1,f.$nk)],w)}),define(re[279],oe([0,1,3,2,77,30]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class j extends A.$Uc{static{this.a=100}constructor(u,c){super(),this.f=u,this.g=c,this.b=this.B(new n.$he),this.c=new Map,this.h(c.applicationStorage,this.b)}h(u,c){this.B(n.Event.debounce(u.onDidChangeStorage,(d,p)=>(d?d.push(p):d=[p],d),j.a)(d=>{d.length&&c.fire(this.j(d,u))}))}j(u,c){const d=new Map,p=new Set;return u.forEach(v=>{const $=c.get(v.key);typeof $=="string"?d.set(v.key,$):p.add(v.key)}),{changed:Array.from(d.entries()),deleted:Array.from(p.values())}}listen(u,c,d){switch(c){case"onDidChangeStorage":{const p=d.profile?(0,S.$0h)(d.profile):void 0;if(!p)return this.b.event;let v=this.c.get(p.id);return v||(v=this.B(new n.$he),this.h(this.g.profileStorage(p),v),this.c.set(p.id,v)),v.event}}throw new Error(`Event not found: ${c}`)}async call(u,c,d){const p=d.profile?(0,S.$0h)(d.profile):void 0,v=(0,R.$Qi)(d.workspace),$=await this.m(p,v);switch(c){case"getItems":return Array.from($.items.entries());case"updateItems":{const f=d;if(f.insert)for(const[y,w]of f.insert)$.set(y,w);f.delete?.forEach(y=>$.delete(y));break}case"optimize":return $.optimize();case"isUsed":{const f=d.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${c}`)}}async m(u,c){let d;c?d=this.g.workspaceStorage(c):u?d=this.g.profileStorage(u):d=this.g.applicationStorage;try{await d.init()}catch(p){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":u?"profile":"application"} storage due to ${p}`)}return d}}e.$Zdc=j}),define(re[41],oe([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=E,e.$Hl=a,e.$Il=t;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function E(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&j.URI.isUri(o.location)&&j.URI.isUri(o.globalStorageHome)&&j.URI.isUri(o.settingsResource)&&j.URI.isUri(o.keybindingsResource)&&j.URI.isUri(o.tasksResource)&&j.URI.isUri(o.snippetsHome)&&j.URI.isUri(o.extensionsResource))}e.$Gl=(0,d.$Ai)("IUserDataProfilesService");function a(i,o){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:o}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:o}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:o}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:o}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:o}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:o}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:o}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:o}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,o,l,m,P,D){return{id:i,name:o,location:l,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:D&&P?.useDefaultFlags?.globalState?D.globalStorageHome:(0,R.$bh)(l,"globalStorage"),settingsResource:D&&P?.useDefaultFlags?.settings?D.settingsResource:(0,R.$bh)(l,"settings.json"),keybindingsResource:D&&P?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,R.$bh)(l,"keybindings.json"),tasksResource:D&&P?.useDefaultFlags?.tasks?D.tasksResource:(0,R.$bh)(l,"tasks.json"),snippetsHome:D&&P?.useDefaultFlags?.snippets?D.snippetsHome:(0,R.$bh)(l,"snippets"),extensionsResource:D&&P?.useDefaultFlags?.extensions?D.extensionsResource:(0,R.$bh)(l,"extensions.json"),cacheHome:(0,R.$bh)(m,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends S.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(o,l,m,P){super(),this.t=o,this.u=l,this.w=m,this.y=P,this.f=!0,this.h=this.B(new A.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(o){this.f!==o&&(this.z=void 0,this.f=o)}isEnabled(){return this.f}get C(){if(!this.z){const o=this.D(),l=[o];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,g.$ag)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}l.push(t((0,R.$$g)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},o))}}catch(D){this.y.error(D)}const m=new $.$Ac,P=new Map;if(l.length)try{const D=this.Q();if(D.workspaces)for(const[I,O]of Object.entries(D.workspaces)){const M=j.URI.parse(I),W=l.find(N=>N.id===O);W&&m.set(M,W)}if(D.emptyWindows)for(const[I,O]of Object.entries(D.emptyWindows)){const M=l.find(W=>W.id===O);M&&P.set(I,M)}}catch(D){this.y.error(D)}this.z={profiles:l,workspaces:m,emptyWindows:P}}return this.z}D(){const o=t("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...o,extensionsResource:this.S()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const l="Temp",m=new RegExp(`${(0,b.$df)(l)}\\s(\\d+)`);let P=0;for(const I of this.profiles){const O=m.exec(I.name),M=O?parseInt(O[1]):0;P=M>P?M:P}const D=`${l} ${P+1}`;return this.createProfile((0,n.$oj)((0,w.$Wg)()).toString(16),D,{transient:!0},o)}async createNamedProfile(o,l,m){return this.createProfile((0,n.$oj)((0,w.$Wg)()).toString(16),o,l,m)}async createProfile(o,l,m,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(o,l,m);return P&&await this.setProfileForWorkspace(P,D),D}async F(o,l,m){if(!(0,g.$ag)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(l);return P||(P=(async()=>{try{if(this.profiles.find(M=>M.name===l||M.id===o))throw new Error(`Profile with ${l} name already exists`);const I=t(o,l,(0,R.$bh)(this.profilesHome,o),this.g,m,this.defaultProfile);await this.u.createFolder(I.location);const O=[];return this.j.fire({profile:I,join(M){O.push(M)}}),await y.Promises.settled(O),this.I([I],[],[]),I}finally{this.r.delete(l)}})(),this.r.set(l,P)),P}async updateProfile(o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(P=>P.id===o.id);if(!m)throw new Error(`Profile '${o.name}' does not exist`);return m=t(m.id,l.name??m.name,m.location,this.g,{shortName:l.shortName??m.shortName,icon:l.icon===null?void 0:l.icon??m.icon,transient:l.transient??m.isTransient,useDefaultFlags:l.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.I([],[],[m]),m}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(P=>P.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);const m=[];this.m.fire({profile:l,join(P){m.push(P)}});try{await Promise.allSettled(m)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(P){(0,c.$ll)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(P=>P.id===l.id);if(!m)throw new Error(`Profile '${l.name}' does not exist`);this.L(o,m)}unsetWorkspace(o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(o,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const o=await this.u.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(l=>l.isDirectory&&this.profiles.every(m=>!this.w.extUri.isEqual(m.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(o.map(l=>this.removeProfile(l)))}getProfileForWorkspace(o){const l=this.G(o);return j.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(o){return(0,v.$Ki)(o)?o.uri:(0,v.$Pi)(o)?o.configPath:o.id}H(o){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,o.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,o.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,o.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,o.location)))}I(o,l,m){const P=[...this.profiles,...o],D=[];this.s.profiles=[];for(let I of P)I.isDefault||l.some(O=>I.id===O.id)||(I=m.find(O=>I.id===O.id)??I,I.isTransient?this.s.profiles.push(I):D.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(D),this.z=void 0,this.J(o,l,m)}J(o,l,m){this.h.fire({added:o,removed:l,updated:m,all:this.profiles})}L(o,l,m){m=l?.isTransient?!0:m,m||this.L(o,void 0,!0);const P=this.G(o),D=m?this.s:this.C;j.URI.isUri(P)?(D.workspaces.delete(P),l&&D.workspaces.set(P,l)):(D.emptyWindows.delete(P),l&&D.emptyWindows.set(P,l)),m||this.M()}M(){const o={};for(const[m,P]of this.C.workspaces.entries())o[m.toString()]=P.id;const l={};for(const[m,P]of this.C.emptyWindows.entries())l[m.toString()]=P.id;this.R({workspaces:o,emptyWindows:l}),this.z=void 0}N(o){const l={},m=this.D();if(o.workspaces)for(const[D,I]of Object.entries(o.workspaces)){const O=j.URI.parse(I);l[D]=this.w.extUri.isEqual(O,m.location)?m.id:this.w.extUri.basename(O)}const P={};if(o.emptyWindows)for(const[D,I]of Object.entries(o.emptyWindows)){const O=j.URI.parse(I);P[D]=this.w.extUri.isEqual(O,m.location)?m.id:this.w.extUri.basename(O)}return{workspaces:l,emptyWindows:P}}O(){return[]}P(o){throw new Error("not implemented")}Q(){return{}}R(o){throw new Error("not implemented")}S(){}};e.$Jl=r,e.$Jl=r=ke([ne(0,u.$Hi),ne(1,c.$7k),ne(2,f.$El),ne(3,p.$7j)],r);class s extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(o){this.a=o}Q(){return this.X}R(o){this.X=o}}e.$Kl=s}),define(re[83],oe([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class h extends Error{constructor(s,i){super(s),this.code=i}}e.$uq=h,e.$vq=(0,p.$Ai)("IExtensionsProfileScannerService");let E=class extends S.$Uc{constructor(s,i,o,l,m,P){super(),this.j=s,this.m=i,this.n=o,this.r=l,this.s=m,this.t=P,this.b=this.B(new R.$he),this.onAddExtensions=this.b.event,this.c=this.B(new R.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$he),this.onDidRemoveExtensions=this.g.event,this.h=new j.$Ac}scanProfileExtensions(s,i){return this.u(s,void 0,i)}async addExtensionsToProfile(s,i,o){const l=[],m=[];try{return await this.u(i,P=>{const D=[];if(o)D.push(...P);else for(const I of P)s.some(([O])=>(0,c.$Ap)(O.identifier,I.identifier)&&O.manifest.version!==I.version)?l.push(I):D.push(I);for(const[I,O]of s){const M=D.findIndex(N=>(0,c.$Ap)(N.identifier,I.identifier)&&N.version===I.manifest.version),W={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:O};M===-1?(m.push(W),D.push(W)):D.splice(M,1,W)}return m.length&&this.b.fire({extensions:m,profileLocation:i}),l.length&&this.f.fire({extensions:l,profileLocation:i}),D}),m.length&&this.c.fire({extensions:m,profileLocation:i}),l.length&&this.g.fire({extensions:l,profileLocation:i}),m}catch(P){throw m.length&&this.c.fire({extensions:m,error:P,profileLocation:i}),l.length&&this.g.fire({extensions:l,error:P,profileLocation:i}),P}}async updateMetadata(s,i){const o=[];return await this.u(i,l=>{const m=[];for(const P of l){const D=s.find(([I])=>(0,c.$Ap)(I.identifier,P.identifier)&&I.manifest.version===P.version);D&&(P.metadata={...P.metadata,...D[1]},o.push(P)),m.push(P)}return m}),o}async removeExtensionFromProfile(s,i){const o=[];try{await this.u(i,l=>{const m=[];for(const P of l)(0,c.$Ap)(P.identifier,s.identifier)?o.push(P):m.push(P);return o.length&&this.f.fire({extensions:o,profileLocation:i}),m}),o.length&&this.g.fire({extensions:o,profileLocation:i})}catch(l){throw o.length&&this.g.fire({extensions:o,error:l,profileLocation:i}),l}}async u(s,i,o){return this.F(s).queue(async()=>{let l=[],m;try{const P=await this.m.readFile(s);m=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,d.$ll)(P)!==1)throw P;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(m=await this.D()),!m&&o?.bailOutWhenFileNotFound)throw new h((0,w.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(m){Array.isArray(m)||this.w(s);let P=!1;for(const D of m){a(D)||this.w(s);let I;if((0,y.$ag)(D.relativeLocation)&&D.relativeLocation)I=this.z(D.relativeLocation);else if((0,y.$ag)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{I=k.URI.revive(D.location);const O=this.y(I);O&&(P=!0,D.relativeLocation=O)}(0,y.$hg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(P=!0,D.metadata.hasPreReleaseVersion=!0),l.push({identifier:D.identifier,location:I,version:D.version,metadata:D.metadata})}P&&await this.m.writeFile(s,A.$Je.fromString(JSON.stringify(m)))}if(i){l=i(l);const P=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(s,A.$Je.fromString(JSON.stringify(P)))}return l})}w(s){const i=new h(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let o;try{o=(await this.m.readFile(s)).value.toString()}catch(m){if((0,d.$ll)(m)===1)return;throw m}this.t.info("Migrating extensions from old default profile location",s.toString());let l;try{const m=JSON.parse(o);Array.isArray(m)&&m.every(P=>a(P))?l=m:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",m)}catch(m){this.t.error(m)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$Je.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(m){if((0,d.$ll)(m)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw m}try{await this.m.del(s)}catch(m){(0,d.$ll)(m)!==1&&this.t.error(m)}try{await this.m.del(i)}catch(m){(0,d.$ll)(m)!==1&&this.t.error(m)}return l})()),this.C}F(s){let i=this.h.get(s);return i||(i=new n.$Hh,this.h.set(s,i)),i}};e.$wq=E,e.$wq=E=ke([ne(1,d.$7k),ne(2,$.$Gl),ne(3,f.$El),ne(4,b.$6l),ne(5,v.$7j)],E);function a(r){return(0,y.$cg)(r)&&(0,u.$$o)(r.identifier)&&(t(r.location)||(0,y.$ag)(r.location)&&r.location)&&((0,y.$hg)(r.relativeLocation)||(0,y.$ag)(r.relativeLocation))&&r.version&&(0,y.$ag)(r.version)}function t(r){return r?(0,y.$ag)(r.path)&&(0,y.$ag)(r.scheme):!1}}),define(re[132],oe([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t,r,s,i,o,l,m,P,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Bq=e.$Aq=e.$zq=e.Translations=void 0,e.$Cq=ie;var M;(function(ae){function K(J,q){if(J===q)return!0;const L=Object.keys(J),z=new Set;for(const H of Object.keys(q))z.add(H);if(L.length!==z.size)return!1;for(const H of L){if(J[H]!==q[H])return!1;z.delete(H)}return z.size===0}ae.equals=K})(M||(e.Translations=M={})),e.$zq=(0,s.$Ai)("IExtensionsScannerService");let W=class extends c.$Uc{constructor(K,J,q,L,z,H,ce,V,le,Y,C,F){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=J,this.r=q,this.s=L,this.t=z,this.u=H,this.w=ce,this.y=V,this.z=le,this.C=Y,this.D=C,this.F=F,this.g=this.B(new l.$he),this.onDidChangeCache=this.g.event,this.h=(0,$.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Lp)(this.w,this.y)),this.G}async scanAllExtensions(K,J,q){const[L,z]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(J)]),H=q?await this.scanExtensionsUnderDevelopment(K,[...L,...z]):[];return this.L(L,z,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const J=[];J.push(this.M(!!K.useCache,K.language)),J.push(this.N(K.language,!!K.checkControlFile));const[q,L]=await Promise.all(J);return this.J([...q,...L],0,K,!1)}async scanUserExtensions(K){const J=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const q=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(J,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,q,K.productVersion??this.R()),z=K.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let H;try{H=await z.scanExtensions(L)}catch(ce){if(ce instanceof P.$uq&&ce.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await z.scanExtensions(L);else throw ce}return H=await this.J(H,1,K,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(K,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===d.Schemas.file).map(async L=>{const z=await this.P(L,!1,1,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(z)).map(ce=>(ce.type=J.find(V=>(0,E.$Ap)(V.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,z)))}))).flat();return this.J(q,"development",K,!0)}return[]}async scanExistingExtension(K,J,q){const L=await this.P(K,!1,J,!0,q.language,!0,void 0,q.productVersion??this.R()),z=await this.n.scanExtension(L);return!z||!q.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(K,J,q){const L=await this.P(K,!1,J,!0,q.language,!0,void 0,q.productVersion??this.R()),z=await this.n.scanOneOrMultipleExtensions(L);return this.J(z,J,q,!0)}async scanMultipleExtensions(K,J,q){const L=[];return await Promise.all(K.map(async z=>{const H=await this.scanOneOrMultipleExtensions(z,J,q);L.push(...H)})),this.J(L,J,q,!0)}async scanMetadata(K){const J=(0,$.$bh)(K,"package.json"),q=(await this.w.readFile(J)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(K,J){const q=(0,$.$bh)(K,"package.json"),L=(await this.w.readFile(q)).value.toString(),z=JSON.parse(L);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,z.__metadata={...z.__metadata,...J},await this.w.writeFile((0,$.$bh)(K,"package.json"),R.$Je.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof P.$uq&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$Je.fromString(JSON.stringify([])))}catch(J){(0,r.$ll)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,J,q,L){return q.includeAllVersions||(K=this.L(J===0?K:void 0,J===1?K:void 0,J==="development"?K:void 0,await this.getTargetPlatform(),L)),q.includeInvalid||(K=K.filter(z=>z.isValid)),K.sort((z,H)=>{const ce=p.$nc(z.location.fsPath),V=p.$nc(H.location.fsPath);return ce<V?-1:ce>V?1:0})}L(K,J,q,L,z){const H=(V,le,Y)=>{if(V.isValid&&!le.isValid)return!1;if(V.isValid===le.isValid){if(z&&f.gt(V.manifest.version,le.manifest.version))return this.y.debug(`Skipping extension ${le.location.path} with lower version ${le.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(f.eq(V.manifest.version,le.manifest.version)){if(V.type===0)return this.y.debug(`Skipping extension ${le.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===L)return this.y.debug(`Skipping extension ${le.location.path} from different target platform ${le.targetPlatform}`),!1}}return Y?this.y.warn(`Overwriting user extension ${V.location.path} with ${le.location.path}.`):this.y.debug(`Overwriting user extension ${V.location.path} with ${le.location.path}.`),!0},ce=new a.$Xm;return K?.forEach(V=>{const le=ce.get(V.identifier.id);(!le||H(le,V,!1))&&ce.set(V.identifier.id,V)}),J?.forEach(V=>{const le=ce.get(V.identifier.id);if(!le&&K&&V.type===0){this.y.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!le||H(le,V,!1))&&ce.set(V.identifier.id,V)}),q?.forEach(V=>{const le=ce.get(V.identifier.id);(!le||H(le,V,!0))&&ce.set(V.identifier.id,V),ce.set(V.identifier.id,V)}),[...ce.values()]}async M(K,J){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0,this.R()),z=await(K&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",z.length),z}async N(K,J){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const L=J?await this.O():{},z=[],H=b.URI.file(p.$hc(p.$jc(d.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const V of q){const le=L[V.name]||"marketplace";switch(le){case"disabled":break;case"marketplace":z.push((0,$.$bh)(H,V.name));break;default:z.push(b.URI.file(le));break}}const ce=await Promise.all(z.map(async V=>this.n.scanExtension(await this.P(V,!1,0,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,n.$Hb)(ce)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,J,q,L,z,H,ce,V){const le=await this.f(z??v.$w),Y=await this.Q(K),C=J&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=C?await this.Q(C):void 0;return new N(K,Y,C,F,J,ce,q,L,H,V.version,V.date,this.C.commit,!this.z.isBuilt,z,le)}async Q(K){try{const J=await this.w.stat(K);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Aq=W,e.$Aq=W=ke([ne(4,D.$Gl),ne(5,P.$vq),ne(6,r.$7k),ne(7,i.$7j),ne(8,h.$Hi),ne(9,o.$nk),ne(10,I.$El),ne(11,s.$zi)],W);class N{constructor(K,J,q,L,z,H,ce,V,le,Y,C,F,_,B,Z){this.location=K,this.mtime=J,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=L,this.profile=z,this.profileScanOptions=H,this.type=ce,this.excludeObsolete=V,this.validate=le,this.productVersion=Y,this.productDate=C,this.productCommit=F,this.devMode=_,this.language=B,this.translations=Z}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,J){return(0,$.$7g)(K.location,J.location)&&K.mtime===J.mtime&&(0,$.$7g)(K.applicationExtensionslocation,J.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&K.profile===J.profile&&S.$$n(K.profileScanOptions,J.profileScanOptions)&&K.type===J.type&&K.excludeObsolete===J.excludeObsolete&&K.validate===J.validate&&K.productVersion===J.productVersion&&K.productDate===J.productDate&&K.productCommit===J.productCommit&&K.devMode===J.devMode&&K.language===J.language&&M.equals(K.translations,J.translations)}}e.$Bq=N;let T=class extends c.$Uc{constructor(K,J,q,L,z){super(),this.f=K,this.g=J,this.h=q,this.j=L,this.m=z}async scanExtensions(K){const J=K.profile?await this.r(K):await this.n(K);let q={};if(K.excludeObsolete&&K.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(L)}catch{}return(0,w.$ng)(q)?J:J.filter(L=>!q[E.$Bp.create(L).toString()])}async n(K){const J=await this.j.resolve(K.location);if(!J.children?.length)return[];const q=await Promise.all(J.children.map(async L=>{if(!L.isDirectory||K.type===1&&(0,$.$$g)(L.resource).indexOf(".")===0)return null;const z=new N(L.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(z)}));return(0,n.$Hb)(q).sort((L,z)=>L.location.path<z.location.path?-1:1)}async r(K){let J=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){J=J.filter(L=>!L.metadata?.isApplicationScoped);const q=await this.s(K.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,K);J.push(...q)}return J}async s(K,J,q){const L=await this.g.scanProfileExtensions(K,q.profileScanOptions);if(!L.length)return[];const z=await Promise.all(L.map(async H=>{if(J(H)){const ce=new N(H.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(ce,H.metadata)}return null}));return(0,n.$Hb)(z)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,$.$bh)(K.location,"package.json"))){const J=await this.scanExtension(K);return J?[J]:[]}else return await this.scanExtensions(K)}catch(J){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,j.$0)(J)),[]}}async scanExtension(K,J){try{let q=await this.scanExtensionManifest(K.location);if(q){q.publisher||(q.publisher=a.$Rm),J=J??q.__metadata,delete q.__metadata;const L=(0,E.$Fp)(q.publisher,q.name),z=J?.id?{id:L,uuid:J.id}:{id:L},H=J?.isSystem?0:K.type,ce=H===0||!!J?.isBuiltin;q=await this.t(K.location,q,N.createNlsConfiguration(K));const V={type:H,identifier:z,manifest:q,location:K.location,isBuiltin:ce,targetPlatform:J?.targetPlatform??"undefined",publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return K.validate?this.validate(V,K):V}}catch(q){K.type!==0&&this.m.error(q)}return null}validate(K,J){let q=!0;const L=(0,t.$Qp)(J.productVersion,J.productDate,J.location,K.manifest,K.isBuiltin);for(const[z,H]of L)z===y.default.Error&&(q=!1,this.m.error(this.z(J.location,H)));return K.isValid=q,K.validations=L,K}async scanExtensionManifest(K){const J=(0,$.$bh)(K,"package.json");let q;try{q=(await this.j.readFile(J)).value.toString()}catch(z){return(0,r.$ll)(z)!==1&&this.m.error(this.z(K,(0,g.localize)(0,null,J.path,z.message))),null}let L;try{L=JSON.parse(q)}catch{const H=[];(0,k.$Nn)(q,H);for(const ce of H)this.m.error(this.z(K,(0,g.localize)(1,null,J.path,ce.offset,ce.length,(0,u.$xq)(ce.error))));return null}return(0,k.$Wn)(L)!=="object"?(this.m.error(this.z(K,(0,g.localize)(2,null,J.path))),null):L}async t(K,J,q){const L=await this.u(K,J,q);if(L)try{const z=[],H=await this.w(L.default,z);if(z.length>0)return z.forEach(V=>{this.m.error(this.z(K,(0,g.localize)(3,null,L.default?.path,(0,u.$xq)(V.error))))}),J;if((0,k.$Wn)(L)!=="object")return this.m.error(this.z(K,(0,g.localize)(4,null,L.default?.path))),J;const ce=L.values||Object.create(null);return(0,O.$yq)(this.m,J,ce,H)}catch{}return J}async u(K,J,q){const L=(0,$.$bh)(K,"package.nls.json"),z=(le,Y)=>{Y.forEach(C=>{this.m.error(this.z(K,(0,g.localize)(5,null,le?.path,(0,u.$xq)(C.error))))})},H=le=>{this.m.error(this.z(K,(0,g.localize)(6,null,le?.path)))},ce=`${J.publisher}.${J.name}`,V=q.translations[ce];if(V)try{const le=b.URI.file(V),Y=(await this.j.readFile(le)).value.toString(),C=[],F=(0,k.$Nn)(Y,C);return C.length>0?(z(le,C),{values:void 0,default:L}):(0,k.$Wn)(F)!=="object"?(H(le),{values:void 0,default:L}):{values:F.contents?F.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let Y;try{Y=await this.y(K,q)}catch{return}if(!Y.localized)return{values:void 0,default:Y.original};try{const C=(await this.j.readFile(Y.localized)).value.toString(),F=[],_=(0,k.$Nn)(C,F);return F.length>0?(z(Y.localized,F),{values:void 0,default:Y.original}):(0,k.$Wn)(_)!=="object"?(H(Y.localized),{values:void 0,default:Y.original}):{values:_,default:Y.original}}catch{return{values:void 0,default:Y.original}}}}async w(K,J){if(K)try{const q=(await this.j.readFile(K)).value.toString();return(0,k.$Nn)(q,J)}catch{}}y(K,J){return new Promise((q,L)=>{const z=H=>{const ce=(0,$.$bh)(K,`package.nls.${H}.json`);this.j.exists(ce).then(V=>{V&&q({localized:ce,original:(0,$.$bh)(K,"package.nls.json")});const le=H.lastIndexOf("-");le===-1?q({localized:(0,$.$bh)(K,"package.nls.json"),original:null}):(H=H.substring(0,le),z(H))})};if(J.devMode||J.pseudo||!J.language)return q({localized:(0,$.$bh)(K,"package.nls.json"),original:null});z(J.language)})}z(K,J){return`[${K.path}]: ${J}`}};T=ke([ne(1,P.$vq),ne(2,I.$El),ne(3,r.$7k),ne(4,i.$7j)],T);let U=class extends T{constructor(K,J,q,L,z,H,ce){super(J,L,z,H,ce),this.G=K,this.H=q,this.D=this.B(new A.$yh(3e3)),this.F=this.B(new l.$he),this.onDidChangeCache=this.F.event}async scanExtensions(K){const J=this.M(K),q=await this.I(J);if(this.C=K,q&&q.input&&N.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",K.location.toString()),this.D.trigger(()=>this.L()),q.result.map(z=>(z.location=b.URI.revive(z.location),z));const L=await super.scanExtensions(K);return await this.J(J,{input:K,result:L}),L}async I(K){try{const J=await this.j.readFile(K),q=JSON.parse(J.value.toString());return{result:q.result,input:(0,m.$0h)(q.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",K.path,(0,j.$0)(J))}return null}async J(K,J){try{await this.j.writeFile(K,R.$Je.fromString(JSON.stringify(J)))}catch(q){this.m.debug("Error while writing the extension cache file:",K.path,(0,j.$0)(q))}}async L(){if(!this.C)return;const K=this.M(this.C),J=await this.I(K);if(!J)return;const q=J.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$$n(L,q))try{this.m.info("Invalidating Cache",q,L),await this.j.del(K),this.F.fire()}catch(z){this.m.error(z)}}M(K){const J=this.N(K);return this.h.extUri.joinPath(J.cacheHome,K.type===0?a.$Qm:a.$Pm)}N(K){return K.type===0?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(K.location,J.extensionsResource))??this.G:this.H.defaultProfile}};U=ke([ne(2,D.$Gl),ne(3,P.$vq),ne(4,I.$El),ne(5,r.$7k),ne(6,i.$7j)],U);function ie(ae,K){const J=(0,E.$Dp)(ae.manifest.publisher,ae.manifest.name);return{id:J,identifier:new a.$Vm(J),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:K,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,publisherDisplayName:ae.publisherDisplayName,...ae.manifest}}class te extends W{constructor(K,J,q,L,z,H,ce,V,le,Y,C,F){super(K,J,(0,$.$bh)(q,".vscode-oss-dev","extensions","control.json"),L,z,H,ce,V,le,Y,C,F),this.S=(async()=>{if(v.$z)try{const _=await this.w.readFile(b.URI.file(v.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$Dq=te}),define(re[280],oe([0,1,5,41,40,28,83,16,38,7]),function(Q,e,n,A,S,R,j,k,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0;let d=class extends j.$wq{constructor(v,$,f,y,w,b){super(c.URI.file(v.extensionsPath),$,f,y,w,b)}};e.$eQ=d,e.$eQ=d=ke([ne(0,u.$Ii),ne(1,k.$7k),ne(2,A.$Gl),ne(3,S.$El),ne(4,R.$6l),ne(5,n.$7j)],d)}),define(re[281],oe([0,1,7,38,83,132,16,6,5,27,40,41]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;let v=class extends R.$Dq{constructor(f,y,w,b,g,h,E,a){super(n.URI.file(g.builtinExtensionsPath),n.URI.file(g.extensionsPath),g.userHome,f.defaultProfile,f,y,w,b,g,h,E,a)}};e.$nec=v,e.$nec=v=ke([ne(0,p.$Gl),ne(1,S.$vq),ne(2,j.$7k),ne(3,u.$7j),ne(4,A.$Ii),ne(5,c.$nk),ne(6,d.$El),ne(7,k.$zi)],v)}),define(re[282],oe([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;let f=class extends A.$Uc{constructor(w,b,g){super(),this.c=w,this.f=g,this.a=k.$Gi.forPaths(!j.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:S.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=n.session;w.protocol.registerFileProtocol(S.Schemas.vscodeFileResource,(b,g)=>this.j(b,g)),w.protocol.interceptFileProtocol(S.Schemas.file,(b,g)=>this.h(b,g)),this.B((0,A.$Sc)(()=>{w.protocol.unregisterProtocol(S.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(S.Schemas.file)}))}addValidFileRoot(w){const b=(0,R.$hc)(w);return this.a.get(b)?A.$Uc.None:(this.a.set(b,!0),(0,A.$Sc)(()=>this.a.delete(b)))}h(w,b){const g=u.URI.parse(w.url);return this.f.error(`Refused to load resource ${g.fsPath} from ${S.Schemas.file}: protocol (original URL: ${w.url})`),b({error:-3})}j(w,b){const g=this.m(w);let h;return this.c.crossOriginIsolated&&((0,R.$nc)(g)==="workbench.html"||(0,R.$nc)(g)==="workbench-dev.html"?h=S.COI.CoopAndCoep:h=S.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(g)?b({path:g,headers:h}):this.b.has((0,R.$oc)(g).toLowerCase())?b({path:g}):(this.f.error(`${S.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${S.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),b({error:-3}))}m(w){const b=u.URI.parse(w.url),g=S.$Ug.uriToFileUri(b);return(0,R.$hc)(g.fsPath)}createIPCObjectUrl(){let w;const b=u.URI.from({scheme:"vscode",path:(0,c.$Wg)()}),g=b.toString(),h=async()=>w;return d.$mW.handle(g,h),this.f.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:b,update:E=>w=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${g}.`),d.$mW.removeHandler(g)}}}};e.$Fec=f,e.$Fec=f=ke([ne(0,p.$Ii),ne(1,$.$Gl),ne(2,v.$7j)],f)}),define(re[97],oe([0,1,8,3,2,66,12,115,6,41]),function(Q,e,n,A,S,R,j,k,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$9p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7p=e.$6p=e.$5p=void 0,e.$8p=$,e.$0p=y,e.$_p=b,e.$5p="__$__isNewStorageMarker",e.$6p="__$__targetStorageMarker",e.$7p=(0,u.$Ai)("storageService");var d;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var p;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var v;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function $(g){const h=g.get(e.$6p);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}class f extends S.$Uc{static{this.a=60*1e3}constructor(h={flushInterval:f.a}){super(),this.m=h,this.b=this.B(new A.$ke),this.c=this.B(new A.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$he),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,E,a){return A.Event.filter(this.b.event,t=>t.scope===h&&(E===void 0||t.key===E),a)}n(){this.j.value=(0,n.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,E){const{key:a,external:t}=E;if(a===e.$6p){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:a,target:this.J(h)[a],external:t})}w(h){this.f.fire({reason:h})}get(h,E,a){return this.P(E)?.get(h,a)}getBoolean(h,E,a){return this.P(E)?.getBoolean(h,a)}getNumber(h,E,a){return this.P(E)?.getNumber(h,a)}getObject(h,E,a){return this.P(E)?.getObject(h,a)}storeAll(h,E){this.y(()=>{for(const a of h)this.store(a.key,a.value,a.scope,a.target,E)})}store(h,E,a,t,r=!1){if((0,j.$jg)(E)){this.remove(h,a,r);return}this.y(()=>{this.z(h,a,t),this.P(a)?.set(h,E,r)})}remove(h,E,a=!1){this.y(()=>{this.z(h,E,void 0),this.P(E)?.delete(h,a)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,E){const a=[],t=this.J(h);for(const r of Object.keys(t))t[r]===E&&a.push(r);return a}z(h,E,a,t=!1){const r=this.J(E);typeof a=="number"?r[h]!==a&&(r[h]=a,this.P(E)?.set(e.$6p,JSON.stringify(r),t)):typeof r[h]=="number"&&(delete r[h],this.P(E)?.set(e.$6p,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const E=this.P(h);return E?$(E):Object.create(null)}isNew(h){return this.getBoolean(e.$5p,h)===!0}async flush(h=d.NONE){this.f.fire({reason:h});const E=this.P(-1),a=this.P(0),t=this.P(1);switch(h){case d.NONE:await n.Promises.settled([E?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await n.Promises.settled([E?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return b(h,E,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,E){return this.w(d.NONE),(0,c.$Fl)(h)?this.R(h,E):this.S(h,E)}M(h,E){return!(h.id===E.id||y(E)&&y(h))}N(h,E,a){this.y(()=>{const t=new Set;for(const[r,s]of h)t.add(r),E.get(r)!==s&&this.u(a,{key:r,external:!0});for(const[r]of E.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$9p=f;function y(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class w extends f{constructor(){super(),this.U=this.B(new k.$3p(new k.$4p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$3p(new k.$4p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$3p(new k.$4p,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$$p=w;async function b(g,h,E,a,t,r){const s=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,o=new Map;g.forEach((M,W)=>{i.set(W,M),o.set(W,s(M))});const l=new Map,m=new Map;h.forEach((M,W)=>{l.set(W,M),m.set(W,s(M))});const P=new Map,D=new Map;E.forEach((M,W)=>{P.set(W,M),D.set(W,s(M))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const I=[];if(i.forEach((M,W)=>{I.push({key:W,value:M})}),console.table(I),console.groupEnd(),console.log(o),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];l.forEach((W,N)=>{M.push({key:N,value:W})}),console.table(M),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${r})`);const O=[];P.forEach((M,W)=>{O.push({key:W,value:M})}),console.table(O),console.groupEnd(),console.log(D)}}),define(re[283],oe([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=e.$cdc=e.$bdc=void 0;class b extends R.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(s,i){super(),this.m=s,this.n=i,this.b=this.B(new S.$he),this.onDidChangeStorage=this.b.event,this.c=this.B(new S.$he),this.onDidCloseStorage=this.c.event,this.f=this.B(new d.$3p(new d.$4p,{hint:d.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new A.$Xh,this.whenInit=this.h.p,this.j=d.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===d.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(o=>this.b.fire(o))),await this.s(s);const i=s.getBoolean($.$5p);i===void 0?s.set($.$5p,!0):i&&s.set($.$5p,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=d.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===v.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,i){return this.f.get(s,i)}set(s,i){return this.f.set(s,i)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new k.$be(!1);await this.w(),s.stop(),s.elapsed()>b.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([l,m])=>({key:l,length:m.length})),(l,m)=>m.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),o=(await this.n.stat(u.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=d.StorageState.Closed,await this.f.close()}}class g extends b{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,j.$jc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,g.y)}constructor(s,i,o,l){super(o,l),this.z=s,this.C=i}async t(){return new d.$3p(new p.$RW(this.path??p.$RW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:d.StorageHint.STORAGE_IN_MEMORY})}}class h extends g{constructor(s,i,o,l){super(s,i,o,l)}}e.$bdc=h;class E extends g{constructor(s,i,o,l){super(i.defaultProfile,s,o,l)}async s(s){await super.s(s),this.G(s)}G(s){s.get(f.$9l,void 0)===void 0&&s.set(f.$9l,new Date().toUTCString());const o=s.get(f.$8l,void 0),l=new Date().toUTCString();s.set(f.$0l,typeof o>"u"?null:o),s.set(f.$8l,l)}}e.$cdc=E;class a extends b{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,j.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,a.y)}constructor(s,i,o,l,m){super(o,m),this.C=s,this.D=i,this.F=l}async t(){const{storageFilePath:s,wasCreated:i}=await this.H();return new d.$3p(new p.$RW(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?d.StorageHint.STORAGE_IN_MEMORY:i?d.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:p.$RW.IN_MEMORY_PATH,wasCreated:!0};const s=(0,j.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),i=(0,j.$jc)(s,a.y);return await c.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:i,wasCreated:!0})}async I(s){let i;if((0,y.$Ki)(this.C)?i={folder:this.C.uri.toString()}:(0,y.$Pi)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const o=(0,j.$jc)(s,a.z);await c.Promises.exists(o)||await c.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.$ddc=a;class t extends b{get path(){}async t(){return new d.$3p(new d.$4p,{hint:d.StorageHint.STORAGE_IN_MEMORY})}}e.$edc=t}),define(re[284],oe([0,1,3,2,97]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;class R extends A.$Uc{constructor(k,u,c){super(),this.b=k,this.c=u,this.f=c;const d=this.B(new A.$Vc);this.a=this.B(new n.$he({onWillAddFirstListener:()=>d.value=this.g(),onDidRemoveLastListener:()=>d.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new A.$Tc;return k.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(u,c)=>(u?u.push(c.key):u=[c.key],u),100)(u=>this.h(u))),k.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(u,c)=>{u||(u=new Map);let d=u.get(c.profile.id);return d||u.set(c.profile.id,d={profile:c.profile,keys:[],storage:c.storage}),d.keys.push(c.key),u},100)(u=>this.j(u))),k}h(k){const u=k.includes(S.$6p)?[this.c.defaultProfile]:[],c=[];if(k=k.filter(d=>d!==S.$6p),k.length){const d=(0,S.$8p)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:k.map(p=>({key:p,scope:0,target:d[p]}))})}this.m(u,c)}j(k){const u=[],c=new Map;for(const[d,p]of k.entries()){p.keys.includes(S.$6p)&&u.push(p.profile);const v=p.keys.filter($=>$!==S.$6p);if(v.length){const $=(0,S.$8p)(p.storage.storage);c.set(d,{profile:p.profile,changes:v.map(f=>({key:f,scope:0,target:$[f]}))})}}this.m(u,[...c.values()])}m(k,u){(k.length||u.length)&&this.a.fire({valueChanges:u,targetChanges:k})}listen(k,u,c){switch(u){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${u}`)}async call(k,u){throw new Error(`Call not found: ${u}`)}}e.$pec=R}),define(re[285],oe([0,1,7,38,16,5,34,40,41,12,125]),function(Q,e,n,A,S,R,j,k,u,c,d){"use strict";var p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=void 0;let $=class extends u.$Jl{static{p=this}static{this.a="profileAssociationsMigration"}constructor(b,g,h,E,a){super(h,E,g,a),this.U=b,this.W=h}O(){return this.U.getItem(p.b,[]).map(g=>({...g,location:(0,c.$ag)(g.location)?this.w.extUri.joinPath(this.profilesHome,g.location):n.URI.revive(g.location)}))}Q(){const b=this.U.getItem(p.c,{});return this.U.getItem(p.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$bQ=$,e.$bQ=$=p=ke([ne(0,j.$9P),ne(1,k.$El),ne(2,A.$Ii),ne(3,S.$7k),ne(4,R.$7j)],$);let f=v=class extends ${constructor(b,g,h,E,a){super(b,g,h,E,a),this.$=b}P(b){b.length?this.$.setItem(v.b,b.map(g=>({...g,location:this.w.extUri.basename(g.location)}))):this.$.removeItem(v.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(v.c,b):this.$.removeItem(v.c)}Q(){const b="workspaceAndProfileInfo",g=this.$.getItem(b,void 0);if(g){this.$.removeItem(b);const E=g.reduce((a,{workspace:t,profile:r})=>(a[n.URI.revive(t).toString()]=n.URI.revive(r).toString(),a),{});this.$.setItem(v.c,{workspaces:E})}const h=super.Q();return this.$.getItem(v.a,!1)||(this.R(h),this.$.setItem(v.a,!0)),h}};e.$cQ=f,e.$cQ=f=v=ke([ne(0,j.$0P),ne(1,k.$El),ne(2,A.$Ii),ne(3,S.$7k),ne(4,R.$7j)],f);let y=class extends f{constructor(b,g,h,E){super(new d.$aQ(0,g,E,h),b,g,h,E)}async init(){return await this.$.init(),super.init()}};e.$dQ=y,e.$dQ=y=ke([ne(0,k.$El),ne(1,A.$Ii),ne(2,S.$7k),ne(3,R.$7j)],y)}),define(re[57],oe([0,1,38,16,6,5,40,41,285,34]),function(Q,e,n,A,S,R,j,k,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=e.$Vcc=void 0,e.$Vcc=(0,S.$Bi)(k.$Gl);let d=class extends u.$cQ{constructor(v,$,f,y,w){super(v,$,f,y,w)}getAssociatedEmptyWindows(){const v=[];for(const $ of this.C.emptyWindows.keys())v.push({id:$});return v}};e.$Wcc=d,e.$Wcc=d=ke([ne(0,c.$0P),ne(1,j.$El),ne(2,n.$Ii),ne(3,A.$7k),ne(4,R.$7j)],d)}),define(re[133],oe([0,1,19,7,30]),function(Q,e,n,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=R,e.$Ycc=j,e.$Zcc=k;async function R(u,c,d){for(const v of u){const $=v.openedWorkspace;if((0,S.$Pi)($)){const f=await d($);if(f){if(f.folders.some(y=>n.$5g.isEqualOrParent(c,y.uri)))return v}else if(n.$5g.isEqualOrParent(c,$.configPath))return v}}const p=u.filter(v=>(0,S.$Ki)(v.openedWorkspace)&&n.$5g.isEqualOrParent(c,v.openedWorkspace.uri));if(p.length)return p.sort((v,$)=>-(v.openedWorkspace.uri.path.length-$.openedWorkspace.uri.path.length))[0]}function j(u,c){for(const d of u)if((0,S.$Pi)(d.openedWorkspace)&&n.$5g.isEqual(d.openedWorkspace.configPath,c)||(0,S.$Ki)(d.openedWorkspace)&&n.$5g.isEqual(d.openedWorkspace.uri,c))return d}function k(u,c){const d=p=>c.some(v=>n.$5g.isEqual(A.URI.file(v),A.URI.file(p)));for(const p of u)if(p.config?.extensionDevelopmentPath?.some(v=>d(v)))return p}}),define(re[98],oe([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agb=void 0,e.$bgb=f,e.$cgb=y,e.$dgb=w,e.$egb=b,e.$fgb=E,e.$ggb=t,e.$hgb=r,e.$igb=m,e.$jgb=P,e.$agb=(0,p.$Ai)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}function y(D){return D.hasOwnProperty("folderUri")}function w(D){return D.hasOwnProperty("fileUri")}function b(D){return g(D)||h(D)}function g(D){const I=D;return typeof I?.path=="string"&&(!I.name||typeof I.name=="string")}function h(D){const I=D;return typeof I?.uri=="string"&&(!I.name||typeof I.name=="string")}function E(D,I,O,M,W){if(D.scheme!==M.scheme)return{name:O,uri:D.toString(!0)};let N=I?void 0:W.relativePath(M,D);if(N!==void 0)N.length===0?N=".":u.$i&&(N=a(N));else if(D.scheme===j.Schemas.file)N=D.fsPath,u.$i&&(N=a(N));else if(W.isEqualAuthority(D.authority,M.authority))N=D.path;else return{name:O,uri:D.toString(!0)};return{name:O,path:N}}function a(D){return D=(0,R.$Kw)(D),(0,n.$wg)(D)||(D=(0,n.$tg)(D)),D}function t(D,I,O){const M=[],W=new Set,N=O.dirname(I);for(const T of D){let U;if(g(T))T.path&&(U=O.resolvePath(N,T.path));else if(h(T))try{U=d.URI.parse(T.uri),U.path[0]!==k.$gc.sep&&(U=U.with({path:k.$gc.sep+U.path}))}catch(ie){console.warn(ie)}if(U){const ie=O.getComparisonKey(U);if(!W.has(ie)){W.add(ie);const te=T.name||O.basenameOrAuthority(U);M.push(new $.$Ui({uri:U,name:te,index:M.length},T))}}}return M}function r(D,I,O,M,W){const N=s(I,D),T=W.dirname(I),U=W.dirname(M),ie=[];for(const J of N.folders){const q=g(J)?W.resolvePath(T,J.path):d.URI.parse(J.uri);let L;O?L=!1:L=!g(J)||(0,k.$ic)(J.path),ie.push(E(q,L,J.name,U,W))}const te={insertSpaces:!1,tabSize:4,eol:u.$k||u.$j?`
`:`\r
`},ae=S.$3n(D,["folders"],ie,te);let K=S.$6n(D,ae);return(0,c.$gh)(N.remoteAuthority,(0,v.$Lm)(M))&&(K=S.$6n(K,S.$2n(K,["remoteAuthority"],te))),K}function s(D,I){const O=A.$Nn(I);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(M=>b(M));else throw new Error(`${D} looks like an invalid workspace file.`);return O}function i(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function o(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function m(D,I){const O={workspaces:[],files:[]};if(D){const M=function(N,T){for(let U=0;U<N.length;U++)try{T(N[U],U)}catch(ie){I.warn(`Error restoring recent entry ${JSON.stringify(N[U])}: ${ie.toString()}. Skip entry.`)}},W=D;Array.isArray(W.entries)&&M(W.entries,N=>{const T=N.label,U=N.remoteAuthority;i(N)?O.workspaces.push({label:T,remoteAuthority:U,workspace:{id:N.workspace.id,configPath:d.URI.parse(N.workspace.configPath)}}):o(N)?O.workspaces.push({label:T,remoteAuthority:U,folderUri:d.URI.parse(N.folderUri)}):l(N)&&O.files.push({label:T,remoteAuthority:U,fileUri:d.URI.parse(N.fileUri)})})}return O}function P(D){const I={entries:[]};for(const O of D.workspaces)y(O)?I.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):I.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of D.files)I.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return I}}),define(re[99],oe([0,1,87,13,4,19]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0,e.$2cc=j,e.$3cc=k,e.$4cc=u,e.$1cc=128/4;function j(c){function d(){let p=c.scheme===A.Schemas.file?(0,R.$2g)(c):c.toString();return S.$k||(p=p.toLowerCase()),(0,n.createHash)("md5").update(p).digest("hex")}return{id:d(),configPath:c}}function k(c,d){function p(){if(c.scheme!==A.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!d)return;let $;return S.$k?$=d.ino:S.$j?$=d.birthtime.getTime():S.$i&&(typeof d.birthtimeMs=="number"?$=Math.floor(d.birthtimeMs):$=d.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update($?String($):"").digest("hex")}const v=p();if(typeof v=="string")return{id:v,uri:c}}function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(re[100],oe([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=s,e.$ti=i,e.$vi=m,e.$wi=P;class y{traceSocketEvent(I,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}constructor(I,O=""){this.f=!0,this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,k.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const O=M=>{this.traceSocketEvent("read",M),I(j.$Je.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=M=>{I({type:0,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,k.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,k.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$pi=y;var w;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var b;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(b||(b={}));class g extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}constructor(I,O,M,W){super(),this.f=this.B(new u.$he),this.g=this.B(new u.$he),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new h(this,O,M,W,this.f,(N,T)=>this.m(N,T))),this.B(this.a.onError(N=>{console.error(N),(0,k.$1)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new f.$ki,this.B(this.socket.onData(N=>this.n(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let O=0;for(;O<I.byteLength;)this.a.writeMessage(I.slice(O,Math.min(O+262144,I.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(I,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let W=2;I.byteLength<126?W+=0:I.byteLength<2**16?W+=2:W+=8;const N=j.$Je.alloc(W),T=O?64:0,U=M&15;if(N.writeUInt8(128|T|U,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let ie=1;N.writeUInt8(I.byteLength>>>8&255,++ie),N.writeUInt8(I.byteLength>>>0&255,++ie)}else{N.writeUInt8(127,1);let ie=1;N.writeUInt8(0,++ie),N.writeUInt8(0,++ie),N.writeUInt8(0,++ie),N.writeUInt8(0,++ie),N.writeUInt8(I.byteLength>>>24&255,++ie),N.writeUInt8(I.byteLength>>>16&255,++ie),N.writeUInt8(I.byteLength>>>8&255,++ie),N.writeUInt8(I.byteLength>>>0&255,++ie)}this.socket.write(j.$Je.concat([N,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),W=(M&128)>>>7,N=(M&64)>>>6,T=M&15,U=O.readUInt8(1),ie=(U&128)>>>7,te=U&127;this.j.state=2,this.j.readLen=2+(ie?4:0)+(te===126?2:0)+(te===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),W=(M&128)>>>7;let N=M&127,T=1;N===126?N=O.readUInt8(++T)*2**8+O.readUInt8(++T):N===127&&(N=O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T));let U=0;W&&(U=O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T)),this.j.state=3,this.j.readLen=N,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$qi=g;class h extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:j.$Je.alloc(0)}constructor(I,O,M,W,N,T){super(),this.n=I,this.r=N,this.s=T,this.a=this.B(new u.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new u.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new u.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new E(this.n,W,M,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(I,O){this.g.push({data:I,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,I);this.s(M,O)}else this.s(I,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,O){return new Promise((M,W)=>{I.write(O),I.flush(N=>M(N))})}acceptFrame(I,O,M){this.h.push({data:I,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const O=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,O,M){return new Promise((W,N)=>{I.write(O),M&&I.write(j.$Je.fromByteArray([0,0,255,255])),I.flush(T=>W(T))})}}class E extends c.$Uc{get recordedInflateBytes(){return this.j?j.$Je.concat(this.f):j.$Je.alloc(0)}constructor(I,O,M,W){super(),this.h=I,this.j=O,this.a=this.B(new u.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(W),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(j.$Je.wrap(N))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent("zlibInflateWrite",I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=j.$Je.concat(this.g);this.g.length=0,I(O)})}}class a extends c.$Uc{constructor(I,O){super(),this.g=I,this.a=this.B(new u.$he),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(j.$Je.wrap(M))})}write(I){this.g.traceSocketEvent("zlibDeflateWrite",I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=j.$Je.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function t(D,I){if(I===0)return;const O=D.byteLength>>>2;for(let ie=0;ie<O;ie++){const te=D.readUInt32BE(ie*4);D.writeUInt32BE(te^I,ie*4)}const M=O*4,W=D.byteLength-M,N=I>>>24&255,T=I>>>16&255,U=I>>>8&255;W>=1&&D.writeUInt8(D.readUInt8(M)^N,M),W>=2&&D.writeUInt8(D.readUInt8(M+1)^T,M+1),W>=3&&D.writeUInt8(D.readUInt8(M+2)^U,M+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function s(){const D=(0,v.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const I=process.platform!=="darwin"&&e.$ri?e.$ri:(0,S.tmpdir)(),O=(0,d.$jc)(I,`vscode-ipc-${D}.sock`);return o(O),O}function i(D,I,O){const W=(0,n.createHash)("sha256").update(D).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${O}-${I}-sock`;const N=O.substr(0,4),T=I.substr(0,6);let U;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?U=(0,d.$jc)(e.$ri,`vscode-${W}-${N}-${T}.sock`):U=(0,d.$jc)(D,`${N}-${T}.sock`),o(U),U}function o(D){const I=r[p.$u];typeof I=="number"&&D.length>=I&&console.warn(`WARNING: IPC handle "${D}" is longer than ${I} chars, try a shorter --user-data-dir`)}class l extends $.$ei{static b(I){const O=u.Event.fromNodeEventEmitter(I,"connection");return u.Event.map(O,M=>({protocol:new f.$li(new y(M,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(M,"close"))}))}constructor(I){super(l.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=l;function m(D){return new Promise((I,O)=>{const M=(0,A.createServer)();M.on("error",O),M.listen(D,()=>{M.removeListener("error",O),I(new l(M))})})}function P(D,I){return new Promise((O,M)=>{const W=(0,A.createConnection)(D,()=>{W.removeListener("error",M),O(f.$mi.fromSocket(new y(W,`ipc-client${I}`),I))});W.once("error",M)})}}),define(re[24],oe([0,1,51,9,4,100,38,91,6]),function(Q,e,n,A,S,R,j,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=e.$Hcc=void 0,e.$Hcc=(0,u.$Bi)(j.$Hi);class c extends k.$an{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,A.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,A.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$ti)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(S.$k){for(const p in process.env)if(p.endsWith("_VSCODE_SNAP_ORIG")){const v=p.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[p]?process.env[v]=process.env[p]:delete process.env[v]}}}restoreSnapExportedVariables(){if(S.$k)for(const p in this.d)process.env[p]=this.d[p],delete this.d[p]}}e.$Icc=c,ke([n.$5h],c.prototype,"cachedLanguagesPath",null),ke([n.$5h],c.prototype,"backupHome",null),ke([n.$5h],c.prototype,"mainIPCHandle",null),ke([n.$5h],c.prototype,"mainLockfile",null),ke([n.$5h],c.prototype,"disableUpdates",null),ke([n.$5h],c.prototype,"crossOriginIsolated",null),ke([n.$5h],c.prototype,"codeCachePath",null),ke([n.$5h],c.prototype,"useCodeCache",null)}),define(re[287],oe([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let h=class{static{g=this}static{this.a="backupWorkspaces"}constructor(a,t,r,s){this.j=a,this.k=t,this.l=r,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.$5g,this.i={isEqual:(i,o)=>(0,A.$yg)(i,o,!j.$k)}}async initialize(){const a=this.m.getItem(g.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,c.$Kcc)(a)),this.e=await this.v((0,c.$Lcc)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==$.$tl.OFF}q(){return this.s()===$.$tl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||$.$tl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(s=>a.workspace.id===s.workspace.id)||(this.d.push(a),this.C());const r=(0,R.$jc)(this.c,a.workspace.id);return t?this.t(r,t).then(()=>r):r}async t(a,t){if(await u.Promises.exists(a)&&await this.z(a),await u.Promises.exists(t))try{await u.Promises.rename(t,a,!1)}catch(r){this.l.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,R.$jc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,R.$jc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,r=[];for(const s of a){const i=s.workspace;if(!(0,w.$Pi)(i))return[];if(!t.has(i.id)){t.add(i.id);const o=(0,R.$jc)(this.c,i.id);await this.B(o)?i.configPath.scheme!==S.Schemas.file||await u.Promises.exists(i.configPath.fsPath)?r.push(s):await this.z(o):await this.x(o)}}return r}async v(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.folderUri,o=this.h.getComparisonKey(i);if(!r.has(o)){r.add(o);const l=(0,R.$jc)(this.c,this.D(s));await this.B(l)?i.scheme!==S.Schemas.file||await u.Promises.exists(i.fsPath)?t.push(s):await this.z(l):await this.x(l)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const o=(0,R.$jc)(this.c,i);await this.B(o)?t.push(s):await this.x(o)}}return t}async x(a){try{await u.Promises.rm(a,u.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,b.$4cc)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,b.$4cc)();return{backupFolder:a.id}}async z(a){const t=this.y(),r=(0,R.$jc)(this.c,t.backupFolder);try{await u.Promises.rename(a,r,!1)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,c.$Jcc)(a)?t=(0,R.$jc)(this.c,a.backupFolder):(0,y.$$fb)(a)?t=(0,R.$jc)(this.c,this.D(a)):t=(0,R.$jc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await u.Promises.readdir(a);for(const r of t)try{if((await u.Promises.readdir((0,R.$jc)(a,r))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:r})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return r&&(s.remoteAuthority=r),s}),folders:this.e.map(({folderUri:t,remoteAuthority:r})=>{const s={folderUri:t.toString()};return r&&(s.remoteAuthority=r),s}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:r})=>{const s={backupFolder:t};return r&&(s.remoteAuthority=r),s})};this.m.setItem(g.a,a)}D(a){const t=a.folderUri;let r;return t.scheme===S.Schemas.file?r=j.$k?t.fsPath:t.fsPath.toLowerCase():r=t.toString().toLowerCase(),(0,n.createHash)("md5").update(r).digest("hex")}};e.$kdc=h,e.$kdc=h=g=ke([ne(0,p.$Hcc),ne(1,d.$7i),ne(2,f.$7j),ne(3,v.$0P)],h)}),define(re[20],oe([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.LifecycleMainPhase=e.ShutdownReason=e.$_cc=void 0,e.$_cc=(0,d.$Ai)("lifecycleMainService");var y;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var w;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let b=class extends j.$Uc{static{f=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(h,E,a){super(),this.F=h,this.G=E,this.H=a,this.c=this.B(new R.$he),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$he),this.onWillShutdown=this.f.event,this.g=this.B(new R.$he),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$he),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(f.b),this.m&&this.G.removeItem(f.b)}J(){const h=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",h);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!k.$j)&&n.app.quit()};n.app.addListener("window-all-closed",E),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",h),n.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(h){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:h,join(t,r){E.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(r.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await S.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===h)return;this.S(`lifecycle (main): phase changed (value: ${h})`),this.n=h;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(h){if(h<=this.n)return;let E=this.C.get(h);E||(E=new S.$zh,this.C.set(h,E)),await E.wait()}registerWindow(h){const E=new j.$Tc;this.t++,E.add(h.onWillLoad(t=>this.g.fire({window:h,workspace:t.workspace,reason:t.reason})));const a=(0,c.$lg)(h.win);E.add(R.Event.fromNodeEventEmitter(a,"close")(t=>{const r=h.id;if(this.r.has(r)){this.r.delete(r);return}this.S(`Lifecycle#window.on('close') - window ID ${h.id}`),t.preventDefault(),this.unload(h,1).then(s=>{if(s){this.r.delete(r);return}this.r.add(r),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${r}`),this.h.fire(h),h.close()})})),E.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.t--,E.dispose(),this.t===0&&(!k.$j||this.j)&&this.L(1)}))}registerAuxWindow(h){const E=(0,c.$lg)(h.win),a=new j.$Tc;a.add(R.Event.fromNodeEventEmitter(E,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${h.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(R.Event.fromNodeEventEmitter(E,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${h.id}`),a.dispose()}))}async reload(h,E){await this.unload(h,3)||h.reload(E)}unload(h,E){const a=this.z.get(h.id);if(a)return a;const t=this.M(h,E).finally(()=>{this.z.delete(h.id)});return this.z.set(h.id,t),t}async M(h,E){if(!h.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${h.id}`);const a=this.j?2:E,t=await this.P(h,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.N(t)):(await this.Q(h,a),!1)}N(h){return h?(this.O(!0),this.j=!1,!0):!1}O(h){this.w&&(this.w(h),this.w=void 0,this.u=void 0)}P(h,E){return new Promise(a=>{const t=this.s++,r=`vscode:ok${t}`,s=`vscode:cancel${t}`;A.$mW.once(r,()=>{a(!1)}),A.$mW.once(s,()=>{a(!0)}),h.send("vscode:onBeforeUnload",{okChannel:r,cancelChannel:s,reason:E})})}Q(h,E){return new Promise(a=>{const r=`vscode:reply${this.s++}`;A.$mW.once(r,()=>a()),h.send("vscode:onWillUnload",{replyChannel:r,reason:E})})}quit(h){return this.R(h).then(E=>{if(!E&&h)try{if(k.$i){const a=(0,u.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return E})}R(h){return this.S(`Lifecycle#quit() - begin (willRestart: ${h})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(h&&this.G.setItem(f.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(h){this.H.args["enable-smoke-test-driver"]?this.F.info(h):this.F.trace(h)}setRelaunchHandler(h){this.D=h}async relaunch(h){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(h?.addArgs&&E.push(...h.addArgs),h?.removeArgs)for(const r of h.removeArgs){const s=E.indexOf(r);s>=0&&E.splice(s,1)}const a=()=>{this.D?.handleRelaunch(h)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:E}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(h){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,S.$Bh)(1e3),(async()=>{for(const E of n.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let a;E.webContents&&!E.webContents.isDestroyed()?a=new Promise(t=>E.once("closed",t)):a=Promise.resolve(),E.destroy(),await a}})()]),n.app.exit(h)}};e.$adc=b,e.$adc=b=f=ke([ne(0,p.$7j),ne(1,v.$0P),ne(2,$.$Hcc)],b)}),define(re[288],oe([0,1,4,3,2,6,20]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=e.$Hdc=void 0,e.$Hdc=(0,R.$Ai)("keyboardLayoutMainService");let k=class extends S.$Uc{constructor(d){super(),this.a=this.B(new A.$he),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,d.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const d=await new Promise((p,v)=>{Q(["native-keymap"],p,v)});this.c=u(d),n.$t||d.onDidChangeKeyboardLayout(()=>{this.c=u(d),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Idc=k,e.$Idc=k=ke([ne(0,j.$_cc)],k);function u(c){const d=c.getKeyMap(),p=c.getCurrentKeyboardLayout();return{keyboardMapping:d,keyboardLayoutInfo:p}}}),define(re[289],oe([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0,e.$5r=w;let f=class extends p.$Up{constructor(g,h,E,a){super(a),this.m=g,this.n=h,this.r=E,this.s(),this.B(g.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const g=this.m.getValue("http");this.f=g?.proxy,this.g=!!g?.proxyStrictSSL,this.h=g?.proxyAuthorization}async request(g,h){const{f:E,g:a}=this;let t;try{t=await(0,c.$Km)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$0)(i)))}const r={...process.env,...t},s=g.agent?g.agent:await(0,v.$3r)(g.url||"",r,{proxyUrl:E,strictSSL:a});return g.agent=s,g.strictSSL=a,this.h&&(g.headers={...g.headers||{},"Proxy-Authorization":this.h}),this.c(g.isChromiumNetwork?"electron":"node",g,()=>w(g,h))}async resolveProxy(g){}async loadCertificates(){return(await new Promise((h,E)=>{Q(["@vscode/proxy-agent"],h,E)})).loadSystemCertificates({log:this.r})}};e.$4r=f,e.$4r=f=ke([ne(0,k.$7i),ne(1,u.$Ii),ne(2,d.$7j),ne(3,d.$8j)],f);async function y(b){return((0,n.parse)(b.url).protocol==="https:"?await new Promise((E,a)=>{Q(["https"],E,a)}):await new Promise((E,a)=>{Q(["http"],E,a)})).request}async function w(b,g){return A.Promises.withAsyncBody(async(h,E)=>{const a=(0,n.parse)(b.url),t=b.getRawRequest?b.getRawRequest(b):await y(b),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,j.$gg)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(r.auth=b.user+":"+b.password);const s=t(r,i=>{const o=(0,j.$eg)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)w({...b,url:i.headers.location,followRedirects:o-1},g).then(h,E);else{let l=i;!b.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,$.createGunzip)())),h({res:i,stream:(0,S.$Ye)(l)})}});s.on("error",E),b.timeout&&s.setTimeout(b.timeout),b.isChromiumNetwork&&s.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&s.write(b.data),s.end(),g.onCancellationRequested(()=>{s.abort(),E(new R.$5)})})}}),define(re[290],oe([0,1,14,289]),function(Q,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;function S(j){return n.net.request}class R extends A.$4r{request(k,u){return super.request({...k||{},getRawRequest:S,isChromiumNetwork:!0},u)}}e.$Kec=R}),define(re[84],oe([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=e.$hdc=e.$gdc=e.$fdc=void 0,e.$fdc=(0,k.$Ai)("storageMainService");let w=class extends S.$Uc{constructor(h,E,a,t,r,s){super(),this.c=h,this.f=E,this.g=a,this.h=t,this.j=r,this.m=s,this.a=void 0,this.b=this.B(new A.$he),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this.B(this.h.onWillShutdown(h=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=h.reason,h.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)h.join("profileStorage",E.close());for(const[,E]of this.w)h.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(h=>{h.join((async()=>{await this.j.exists(h.profile.globalStorageHome)||await this.j.createFolder(h.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(h=>{const E=this.t.get(h.profile.id);E&&h.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const h=new p.$cdc(this.n(),this.g,this.c,this.j);return this.B(A.Event.once(h.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),h}profileStorage(h){if((0,d.$0p)(h))return this.applicationStorage;let E=this.t.get(h.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${h.name})`),E=this.B(this.u(h)),this.t.set(h.id,E);const a=this.B(E.onDidChangeStorage(t=>this.b.fire({...t,storage:E,profile:h})));this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${h.name})`),this.t.delete(h.id),a.dispose()}))}return E}u(h){return this.a===2?new p.$edc(this.c,this.j):new p.$bdc(h,this.n(),this.c,this.j)}workspaceStorage(h){let E=this.w.get(h.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${h.id})`),E=this.B(this.y(h)),this.w.set(h.id,E),this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${h.id})`),this.w.delete(h.id)}))),E}y(h){return this.a===2?new p.$edc(this.c,this.j):new p.$ddc(h,this.n(),this.c,this.f,this.j)}isUsed(h){const E=n.URI.file(h);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),E))return!0;return!1}};e.$gdc=w,e.$gdc=w=ke([ne(0,c.$7j),ne(1,R.$Hi),ne(2,$.$Vcc),ne(3,u.$_cc),ne(4,j.$7k),ne(5,f.$El)],w),e.$hdc=(0,k.$Ai)("applicationStorageMainService");let b=class extends d.$9p{constructor(h,E){super(),this.s=h,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(h){if(h===-1)return this.U.applicationStorage.storage}Q(h){if(h===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$idc=b,e.$idc=b=ke([ne(0,v.$Gl),ne(1,e.$fdc)],b)}),define(re[291],oe([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=e.$Iec=e.$Hec=e.$Gec=void 0;async function b(t,r,s,i,o){let l;for(let m=3;m&&(l?.dispose(),l=await new g(t,r,s,i,o).waitForReady(),!(o&&S.$Zg[o]||!S.$Zg[l.tunnelLocalPort]));m--);return l}class g extends k.$Uc{constructor(r,s,i,o,l){super(),this.m=s,this.n=l,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=n.createServer(),this.c=new j.$zh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=m=>this.r(m),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=o,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,s=(0,y.$ww)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,S.$1g)(r,2,1e3,s),o=null;return this.b.listen(i,this.m),await this.c.wait(),o=this.b.address(),o||(i=0,this.b.listen(i,this.m),await this.c.wait(),o=this.b.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async r(r){r.pause();const s=(0,y.$uw)(this.tunnelRemoteHost)||(0,y.$ww)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$Wl)(this.a,s,this.tunnelRemotePort),o=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&r.write(l.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),o.end()}),r.on("close",()=>o.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),o instanceof R.$pi?o.socket.destroy():o.end()}),o instanceof R.$pi?this.t(r,o):this.s(r,o),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),o.end()})}s(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(i=>r.write(i.buffer)),r.on("data",i=>s.write(w.$Je.wrap(i))),r.resume()}t(r,s){const i=s.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.$Gec=g;let h=class extends y.$zw{constructor(r,s,i,o,l){super(s,l),this.v=r,this.w=i,this.y=o}isPortPrivileged(r){return(0,y.$xw)(r,this.m,u.OS,A.release())}t(r,s,i,o,l,m,P,D){const I=this.s(s,i);if(I)return++I.refcount,I.value;if((0,y.$qw)(r))return this.u(r,s,i,l,m,P,D);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${l}.`);const O={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},M=b(O,o,s,i,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,i,M),M}}};e.$Hec=h,e.$Hec=h=ke([ne(0,$.$Ql),ne(1,d.$7j),ne(2,f.$Tl),ne(3,p.$nk),ne(4,c.$7i)],h);let E=class extends h{constructor(r,s,i,o,l){super(r,s,i,o,l)}};e.$Iec=E,e.$Iec=E=ke([ne(0,$.$Ql),ne(1,d.$7j),ne(2,f.$Tl),ne(3,p.$nk),ne(4,c.$7i)],E);let a=class extends k.$Uc{constructor(r,s,i,o,l){super(),this.b=r,this.c=s,this.f=i,this.g=o,this.h=l,this.a=new Map}async openTunnel(r,s,i,o,l,m,P,D,I){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${o} on local port ${m}.`),!this.a.has(r)){const O=new E(this.b,this.c,this.g,this.f,this.h);this.B(O),this.a.set(r,O),O.onTunnelClosed(async()=>{(await O.tunnels).length===0&&(O.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(s,i,o,l,m,P,D,I)}};e.$Jec=a,e.$Jec=a=ke([ne(0,$.$Ql),ne(1,d.$7j),ne(2,p.$nk),ne(3,f.$Tl),ne(4,c.$7i)],a)}),define(re[101],oe([0,1,8,23,3,18,24,20,5,27,53,50]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0,e.$5dc=v;function v(f,y,w){return`${w.updateUrl}/api/update/${f}/${y}/${w.commit}`}let $=class{get state(){return this.b}d(y){this.j.info("update#setState",y.type),this.b=y,this.c.fire(y)}constructor(y,w,b,g,h,E){this.f=y,this.g=w,this.h=b,this.i=g,this.j=h,this.k=E,this.b=p.$tX.Uninitialized,this.c=new S.$he,this.onStateChange=this.c.event,y.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(p.$tX.Disabled(0));return}if(this.h.disableUpdates){this.d(p.$tX.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(p.$tX.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.g.getValue("update.mode"),w=this.m(y);if(!w){this.d(p.$tX.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(p.$tX.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const b=new URL(this.a);b.searchParams.set("prss","true"),this.a=b.toString()}if(this.d(p.$tX.Idle(this.q())),y==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,b=>this.j.error(b))}m(y){return y==="none"?void 0:this.k.quality}n(y=60*60*1e3){return(0,n.$Bh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(y){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(y)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(y){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(y){}q(){return 1}r(){}};e.$6dc=$,e.$6dc=$=ke([ne(0,k.$_cc),ne(1,R.$7i),ne(2,j.$Hcc),ne(3,d.$Tp),ne(4,u.$7j),ne(5,c.$nk)],$)}),define(re[292],oe([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;let w=class extends y.$6dc{get v(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"error",(g,h)=>h)}get w(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return S.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(g,h,E,a)=>({version:E,productVersion:E,timestamp:a}))}constructor(g,h,E,a,t,r,s){super(g,h,a,t,r,s),this.z=E,this.u=new j.$Tc,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.z.publicLog2("update:error",{messageHash:String((0,R.$oj)(String(g)))}),this.j.error("UpdateService error:",g);const h=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.d(f.$tX.Idle(1,h))}s(g){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const E=(0,y.$5dc)(h,g,this.k);try{n.autoUpdater.setFeedURL({url:E})}catch(a){this.j.error("Failed to set update feed URL",a);return}return E}t(g){this.d(f.$tX.CheckingForUpdates(g)),n.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(f.$tX.Downloading)}F(g){this.state.type==="downloading"&&(this.d(f.$tX.Downloaded(g)),this.z.publicLog2("update:downloaded",{version:g.version}),this.d(f.$tX.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$tX.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$7dc=w,ke([A.$5h],w.prototype,"v",null),ke([A.$5h],w.prototype,"w",null),ke([A.$5h],w.prototype,"x",null),ke([A.$5h],w.prototype,"y",null),e.$7dc=w=ke([ne(0,c.$_cc),ne(1,k.$7i),ne(2,$.$6l),ne(3,u.$Hcc),ne(4,v.$Tp),ne(5,d.$7j),ne(6,p.$nk)],w)}),define(re[293],oe([0,1,49,43,8,3,9,24,20,5,28,50]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;let v=class{get state(){return this.a}d(y){this.g.info("update#setState",y.type),this.a=y,this.b.fire(y)}constructor(y,w,b){if(this.f=y,this.g=b,this.a=p.$tX.Uninitialized,this.b=new R.$he,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(p.$tX.Idle(this.k())),this.h(30*1e3).then(void 0,g=>this.g.error(g))}h(y=60*60*1e3){return(0,S.$Bh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(y){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(y)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(y){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(y){}};v=ke([ne(0,u.$_cc),ne(1,k.$Hcc),ne(2,c.$7j)],v);let $=class extends v{constructor(y,w,b,g,h,E){super(b,g,h),this.o=y,this.p=w,this.q=E;const a=(0,A.watch)(j.$mc(this.o)),t=R.Event.fromNodeEventEmitter(a,"change",(o,l)=>l),r=R.Event.filter(t,o=>o==="current"),i=R.Event.debounce(r,(o,l)=>l,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(p.$tX.CheckingForUpdates(!1)),this.u().then(y=>{y?this.d(p.$tX.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$tX.Idle(2)))},y=>{this.g.error(y),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$tX.Idle(2,y.message||y))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+j.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const y=await new Promise((b,g)=>(0,A.realpath)(`${j.$mc(this.o)}/current`,(h,E)=>h?g(h):b(E))),w=j.$nc(y);return this.p!==w}isLatestVersion(){return this.u().then(void 0,y=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$9dc=$,e.$9dc=$=ke([ne(2,u.$_cc),ne(3,k.$Hcc),ne(4,c.$7j),ne(5,d.$6l)],$)}),define(re[29],oe([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Scc=void 0,e.$Tcc=f,e.$Ucc=y,e.$Scc=(0,S.$Ai)("windowsMainService");var $;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API"})($||(e.OpenContext=$={}));function f(b,g,h){const E=b.get(k.$Qcc),a=b.get(u.$nk),t=b.get(c.$7i),r=b.get(d.$Hcc),s=t.getValue("window"),i={backgroundColor:E.getBackgroundColor(),minWidth:j.$GD.WIDTH,minHeight:j.$GD.HEIGHT,title:a.nameLong,show:g.mode!==0&&g.mode!==3,x:g.x,y:g.y,width:g.width,height:g.height,webPreferences:{...h,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,j.$SD)(g.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(A.$k?i.icon=(0,p.$jc)(r.appRoot,"resources/linux/code.png"):A.$i&&!r.isBuilt&&(i.icon=(0,p.$jc)(r.appRoot,"resources/win32/code_150x150.png")),A.$j&&(i.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),A.$j&&!(0,j.$RD)(t)&&(i.fullscreenable=!1),A.$j&&s?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,j.$ND)(t)&&(i.titleBarStyle="hidden",A.$j||(i.frame=!1),(0,j.$QD)(t))){const m=E.getWindowSplash()?.colorInfo.titleBarBackground??E.getBackgroundColor(),P=v.$_t.fromHex(m).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:m,symbolColor:P}}return i}function y(b){let g,h=Number.MIN_VALUE;for(const E of b)E.lastFocusTime>h&&(h=E.lastFocusTime,g=E);return g}var w;(function(b){function g(E,a,t=n.screen.getAllDisplays()){if(E.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){E.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){E.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=h(t[0]);if(E.trace("window#validateWindowState: single monitor working area",i),i){let o=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};o(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),o()}return a}if(a.display&&a.mode===3){const i=t.find(o=>o.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){E.trace("window#validateWindowState: restoring fullscreen to previous display");const o=(0,R.$Fcc)(3);return o.x=i.bounds.x,o.y=i.bounds.y,o}}let r,s;try{r=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=h(r),E.trace("window#validateWindowState: multi-monitor working area",s)}catch(i){E.error("window#validateWindowState: error finding display for window state",i)}if(r&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;E.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=g;function h(E){if(E.workArea.width>0&&E.workArea.height>0)return E.workArea;if(E.bounds.width>0&&E.bounds.height>0)return E.bounds}})(w||(e.WindowStateValidator=w={}))}),define(re[294],oe([0,1,14,23,3,46,2,33,120,5,84,29]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;var v;(function(f){f[f.Initial=1]="Initial",f[f.StoredCredentialsUsed=2]="StoredCredentialsUsed",f[f.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let $=class extends j.$Uc{constructor(y,w,b,g){super(),this.g=y,this.h=w,this.j=b,this.m=g,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.n()}n(){const y=S.Event.fromNodeEventEmitter(n.app,"login",(w,b,g,h,E)=>({event:w,webContents:b,req:g,authInfo:h,callback:E}));this.B(y(this.r,this))}async r({event:y,authInfo:w,req:b,callback:g}){if(!w.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&b.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{h=await this.b}finally{this.b=void 0}}g(h?.username,h?.password)}async s(y){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(y);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(y){this.g.trace("auth#doResolveProxyCredentials - enter",y);const w=String((0,R.$oj)({scheme:y.scheme,host:y.host,port:y.port}));let b,g;try{const t=this.m.get(this.a+w,-1);if(t){const r=JSON.parse(await this.j.decrypt(t));b=r.username,g=r.password}}catch(t){this.g.error(t)}if(this.c!==v.StoredCredentialsUsed&&typeof b=="string"&&typeof g=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:b,password:g};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const E={authInfo:y,username:this.f?.username??b,password:this.f?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,k.$Wg)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,E),this.c=v.LoginDialogShown;const a=await new Promise(t=>{const r=async(s,i,o)=>{if(i===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",r),o){const l={username:o.username,password:o.password};try{if(o.remember){const m=await this.j.encrypt(JSON.stringify(l));this.m.store(this.a+w,m,-1,1)}else this.m.remove(this.a+w,-1)}catch(m){this.g.error(m)}t({username:l.username,password:l.password})}else t(void 0)};h.win?.webContents.on("ipc-message",r)});return this.f=a,a}};e.$jdc=$,e.$jdc=$=ke([ne(0,c.$7j),ne(1,p.$Scc),ne(2,u.$eX),ne(3,d.$hdc)],$)}),define(re[295],oe([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=e.$Kdc=e.ID=void 0,e.ID="launchMainService",e.$Kdc=(0,c.$Ai)(e.ID);let $=class{constructor(y,w,b,g){this.a=y,this.b=w,this.c=b,this.d=g}async start(y,w){this.a.trace("Received data from other instance: ",y,w),S.$j&&n.app.focus({steal:!0});const b=this.e(y);if(b.length){let g=Promise.resolve();if(this.b.getWindowCount()===0){const h=(0,A.$Ob)(await this.b.openEmptyWindow({context:4}));h&&(g=h.ready())}g.then(()=>{for(const{uri:h,originalUrl:E}of b)this.c.open(h,{originalUrl:E})})}else return this.f(y,w)}e(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,A.$Hb)(y._urls.map(w=>{try{return{uri:R.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(y,w){const b=(0,u.$Em)(w)?0:4;let g=[];const h=y.wait&&y.waitMarkerFilePath?R.URI.file(y.waitMarkerFilePath):void 0,E=y.remote||void 0,a={context:b,cli:y,userEnv:y["preserve-env"]||b===0?w:void 0,waitMarkerFileURI:h,remoteAuthority:E,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,a);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||a.forceProfile||a.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!S.$j}if(t)g=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,a),g=[r]):g=await this.b.open({...a,forceEmpty:!0})}}else g=await this.b.open({...a,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(h&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,j.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Ldc=$,e.$Ldc=$=ke([ne(0,d.$7j),ne(1,v.$Scc),ne(2,p.$kX),ne(3,k.$7i)],$)}),define(re[296],oe([0,1,2,20,57,30,8,29]),function(Q,e,n,A,S,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;let u=class extends n.$Uc{constructor(d,p,v){super(),this.a=p,this.b=v,this.B(d.onWillLoadWindow($=>{$.reason===2&&this.c($.window)})),this.B(d.onBeforeCloseWindow($=>this.c($))),this.B(new j.$Mh(()=>this.g(),30*1e3)).schedule()}async c(d){const p=this.f(d),v=this.a.getProfileForWorkspace(p);v?.isTransient&&(this.a.unsetWorkspace(p,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(d){return d.openedWorkspace??(0,R.$Oi)(d.backupPath,d.isExtensionDevelopmentHost)}g(){const d=this.a.getAssociatedEmptyWindows();if(d.length===0)return;const p=this.b.getWindows().map(v=>this.f(v));for(const v of d)p.some($=>$.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$oec=u,e.$oec=u=ke([ne(0,A.$_cc),ne(1,S.$Vcc),ne(2,k.$Scc)],u)}),define(re[61],oe([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=void 0;function g(a){return typeof a.responseWindowId=="number"}let h=class extends A.$Uc{static{b=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(b.b.values())}constructor(t,r,s){super(),this.w=t,this.y=r,this.z=s,this.c=String(++b.a),this.f=this.B(new S.$he),this.onStdout=this.f.event,this.g=this.B(new S.$he),this.onStderr=this.g.event,this.h=this.B(new S.$he),this.onMessage=this.h.event,this.j=this.B(new S.$he),this.onSpawn=this.j.event,this.m=this.B(new S.$he),this.onExit=this.m.event,this.n=this.B(new S.$he),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,r){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,r){case d.default.Error:this.w.error(s);break;case d.default.Warning:this.w.warn(s);break;case d.default.Info:this.w.trace(s);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",d.default.Error),!1):!0}start(t){const r=this.F(t);return r&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",d.default.Info),r}F(t){if(!this.D())return!1;this.t=t;const r=`${this.t.type}-${this.c}`,s=u.$Ug.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],o=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,m=this.t.forceAllocationsToV8Sandbox,P="pipe",D=this.G(t);return this.C("creating new...",d.default.Info),this.r=n.utilityProcess.fork(s,i,{serviceName:r,env:D,execArgv:o,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:m,stdio:P}),this.H(this.r,this.t,r),!0}G(t){const r=t.env?{...t.env}:{...(0,f.$7n)(process.env)};r.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(r.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),r.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,y.$i&&((0,w.isUNCAccessRestrictionsDisabled)()?r.NODE_DISABLE_UNC_ACCESS_CHECKS="1":r.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,$.$rm)(r);for(const s of Object.keys(r))r[s]=String(r[s]);return r}H(t,r,s){if(t.stdout){const i=new j.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stdout,"data")(o=>this.f.fire(typeof o=="string"?o:i.write(o))))}if(t.stderr){const i=new j.StringDecoder("utf-8");this.B(S.Event.fromNodeEventEmitter(t.stderr,"data")(o=>this.g.fire(typeof o=="string"?o:i.write(o))))}this.B(S.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(S.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&b.b.set(t.pid,{pid:t.pid,name:g(r)?`${r.type} [${r.responseWindowId}]`:r.type}),this.C("successfully created",d.default.Info),this.j.fire(t.pid)})),this.B(S.Event.fromNodeEventEmitter(t,"exit")(i=>{const o=this.I(i)?0:i;this.C(`received exit event with code ${o}`,d.default.Info),this.m.fire({pid:this.s,code:o,signal:"unknown"}),this.J()})),this.B(S.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,o)=>({event:i,details:o}))(({details:i})=>{i.type==="Utility"&&i.name===s&&!this.I(i.exitCode)&&(this.C(`crashed with code ${i.exitCode} and reason '${i.reason}'`,d.default.Error),this.y.publicLog2("utilityprocesscrash",{type:r.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.J())}))}once(t,r){const s=this.B(this.h.event(i=>{i===t&&(s.dispose(),r())}))}postMessage(t,r){return this.r?(this.r.postMessage(t,r),!0):!1}connect(t){const{port1:r,port2:s}=new n.MessageChannelMain;return this.postMessage(t,[s]),r}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",d.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",d.default.Info),this.r.kill()?(this.C("successfully killed the process",d.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",d.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&b.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",d.default.Info),await Promise.race([S.Event.toPromise(this.onExit),(0,k.$Bh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,d.default.Info),this.kill()))}};e.$mdc=h,e.$mdc=h=b=ke([ne(0,R.$7j),ne(1,p.$6l),ne(2,v.$_cc)],h);let E=class extends h{constructor(t,r,s,i){super(t,s,i),this.L=r}start(t){const r=this.L.getWindowById(t.responseWindowId);if(!r?.win||r.win.isDestroyed()||r.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",d.default.Error),!0;if(!super.F(t))return!1;this.M(r.win,t);const i=this.connect(t.payload);return r.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}M(t,r){r.windowLifecycleBound&&(this.B(S.Event.filter(this.z.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(S.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$ndc=E,e.$ndc=E=ke([ne(0,R.$7j),ne(1,c.$Scc),ne(2,p.$6l),ne(3,v.$_cc)],E)}),define(re[297],oe([0,1,15,3,5,20,8,61,29,28]),function(Q,e,n,A,S,R,j,k,u,c){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;let p=class{static{d=this}static{this.a=0}constructor($,f,y,w){this.d=$,this.f=f,this.g=y,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown(b=>{this.c=!0,b.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i($){const f=this.b.get($);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout($){return this.i($).onStdout}onDynamicStderr($){return this.i($).onStderr}onDynamicMessage($){return this.i($).onMessage}onDynamicExit($){return this.i($).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const $=String(++d.a),f=new k.$ndc(this.d,this.g,this.h,this.f);return this.b.set($,f),f.onExit(({pid:y,code:w,signal:b})=>{this.d.info(`Extension host with pid ${y} exited with code: ${w}, signal: ${b}.`),setTimeout(()=>{f.dispose(),this.b.delete($)}),setTimeout(()=>{try{process.kill(y,0),this.d.error(`Extension host with pid ${y} still exists, forcefully killing it...`),process.kill(y)}catch{}},1e3)}),{id:$}}async start($,f){if(this.c)throw(0,n.$6)();const y=this.i($);return y.start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:$}),{pid:await A.Event.toPromise(y.onSpawn)}}async enableInspectPort($){if(this.c)throw(0,n.$6)();const f=this.b.get($);return f?f.enableInspectPort():!1}async kill($){if(this.c)throw(0,n.$6)();const f=this.b.get($);f&&f.kill()}async _killAllNow(){for(const[,$]of this.b)$.kill()}async _waitForAllExit($){const f=[];for(const[,y]of this.b)f.push(y.waitForExit($));return j.Promises.settled(f).then(()=>{})}};e.$udc=p,e.$udc=p=d=ke([ne(0,S.$7j),ne(1,R.$_cc),ne(2,u.$Scc),ne(3,c.$6l)],p)}),define(re[298],oe([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251,3]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;let b=class extends S.$Uc{constructor(h,E,a,t,r,s,i,o){super(),this.g=h,this.h=E,this.j=a,this.m=t,this.n=r,this.r=s,this.s=i,this.t=o,this.a=new A.$zh,this.b=void 0,this.c=void 0,this.f=this.B(new w.$he),this.onDidCrash=this.f.event,this.z=void 0,this.C=void 0,this.u()}u(){n.$mW.on(y.$Wdc.request,(h,E)=>this.w(h,E,y.$Wdc.response)),n.$mW.on(y.$Xdc.request,(h,E)=>this.w(h,E,y.$Xdc.response)),this.B(this.n.onWillShutdown(()=>this.y()))}async w(h,E,a){this.r.trace(`[SharedProcess] onWindowConnection for: ${a}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(a);if(h.sender.isDestroyed())return t.close();h.sender.postMessage(a,E,[t])}y(){this.r.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(y.$Vdc.exit),this.b=void 0}whenReady(){return this.z||(this.z=(async()=>{await this.D;const h=new A.$Xh;this.b?.once(y.$Vdc.initDone,()=>h.complete()),await h.p,this.c?.dispose(),this.r.trace("[SharedProcess] Overall ready")})()),this.z}get D(){return this.C||(this.C=(async()=>{await this.a.wait(),this.F();const h=new A.$Xh;this.b?.once(y.$Vdc.ipcReady,()=>h.complete()),await h.p,this.r.trace("[SharedProcess] IPC ready")})()),this.C}F(){this.b=this.B(new p.$mdc(this.r,v.$np,this.n)),this.c=this.b.onMessage(a=>{typeof a.warning=="string"?this.r.warn(a.warning):typeof a.error=="string"&&this.r.error(a.error)});const h=(0,$.$cn)(this.j.args,this.j.isBuilt);let E;h.port&&(E=["--nolazy"],h.break?E.push(`--inspect-brk=${h.port}`):E.push(`--inspect=${h.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.G(),execArgv:E}),this.B(this.b.onCrash(()=>this.f.fire()))}G(){return{machineId:this.g,sqmId:this.h,codeCachePath:this.j.codeCachePath,profiles:{home:this.m.profilesHome,all:this.m.profiles},args:this.j.args,logLevel:this.s.getLogLevel(),loggers:this.s.getRegisteredLoggers(),policiesData:this.t.serialize()}}async connect(h){return await this.D,(0,f.$lg)(this.b).connect(h)}};e.$Ydc=b,e.$Ydc=b=ke([ne(2,R.$Hcc),ne(3,u.$Gl),ne(4,j.$_cc),ne(5,k.$7j),ne(6,d.$7cc),ne(7,c.$jo)],b)}),define(re[299],oe([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;let y=class extends d.$Uc{constructor(b,g,h,E,a){super(),this.f=b,this.g=g,this.h=h,this.j=E,this.m=a,this.a=void 0,this.b=new p.$he,this.onRequestConnection=this.b.event,this.c=new p.$he,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$mW.on("vscode:createPtyHostMessageChannel",(t,r)=>this.r(t,r)),this.B((0,d.$Sc)(()=>{c.$mW.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new k.$mdc(this.m,j.$np,this.j);const b=(0,A.$bn)(this.h.args,this.h.isBuilt),g=b.port?["--nolazy",`--inspect${b.break?"-brk":""}=${b.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:g,args:["--logsPath",this.h.logsHome.with({scheme:f.Schemas.file}).fsPath],env:this.n()});const h=this.a.connect(),E=new u.$uW(h,"ptyHost"),a=new d.$Tc;return a.add(E),a.add((0,d.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const b={...(0,v.$7n)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},g=this.g.getValue("terminal.integrated.developer.ptyHost.latency");g&&typeof g=="number"&&(b.VSCODE_LATENCY=String(g));const h=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return h&&typeof h=="number"&&(b.VSCODE_STARTUP_DELAY=String(h)),this.h.restoreSnapExportedVariables(),b}r(b,g){this.b.fire();const h=this.a.connect();if(b.sender.isDestroyed()){h.close();return}b.sender.postMessage("vscode:createPtyHostMessageChannelResult",g,[h])}};e.$yec=y,e.$yec=y=ke([ne(1,$.$7i),ne(2,n.$Hcc),ne(3,S.$_cc),ne(4,R.$7j)],y)}),define(re[300],oe([0,1,2,6,5,29,61,28,46,3,8,20]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=e.$wec=void 0,e.$wec=(0,A.$Ai)("utilityProcessWorker");let v=class extends n.$Uc{constructor(y,w,b,g){super(),this.b=y,this.c=w,this.f=b,this.g=g,this.a=new Map}async createWorker(y){const w=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const b=this.h(y);this.a.has(b)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(y));const g=new $(this.b,this.c,this.f,this.g,y);if(!g.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(b,g);const h=new d.$Xh;return c.Event.once(g.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(b),h.complete({reason:E})}),h.p}h(y){return(0,u.$oj)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const w=this.h(y),b=this.a.get(w);b&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),b.kill(),this.a.delete(w))}};e.$xec=v,e.$xec=v=ke([ne(0,S.$7j),ne(1,R.$Scc),ne(2,k.$6l),ne(3,p.$_cc)],v);let $=class extends n.$Uc{constructor(y,w,b,g,h){super(),this.c=y,this.f=w,this.g=b,this.h=g,this.j=h,this.a=this.B(new c.$he),this.onDidTerminate=this.a.event,this.b=new j.$ndc(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(y=>this.a.fire({code:y.code,signal:y.signal}))),this.B(this.b.onCrash(y=>this.a.fire({code:y.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};$=ke([ne(0,S.$7j),ne(1,R.$Scc),ne(2,k.$6l),ne(3,p.$_cc)],$)}),define(re[301],oe([0,1,14,3,2,277,29]),function(Q,e,n,A,S,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;let k=class extends S.$Uc{constructor(c){super(),this.b=c,this.a=this.B(new A.$he),this.onFoundInFrame=this.a.event,this.B(new R.$dec)}async setIgnoreMenuShortcuts(c,d){let p;if(typeof c.windowId=="number"){const{windowId:v}=c,$=this.b.getWindowById(v);if(!$?.win)throw new Error(`Invalid windowId: ${v}`);p=$.win.webContents}else{const{webContentsId:v}=c;if(p=n.webContents.fromId(v),!p)throw new Error(`Invalid webContentsId: ${v}`)}p.isDestroyed()||p.setIgnoreMenuShortcuts(d)}async findInFrame(c,d,p,v){const f=this.c(c,d);if(typeof f.findInFrame=="function"){f.findInFrame(p,{findNext:v.findNext,forward:v.forward});const y=(w,b)=>{b.finalUpdate&&(this.a.fire(b),f.removeListener("found-in-frame",y))};f.on("found-in-frame",y)}}async stopFindInFrame(c,d,p){const $=this.c(c,d);typeof $.stopFindInFrame=="function"&&$.stopFindInFrame(p.keepSelection?"keepSelection":"clearSelection")}c(c,d){const p=this.b.getWindowById(c.windowId);if(!p?.win)throw new Error(`Invalid windowId: ${c}`);const v=p.win.webContents.mainFrame.framesInSubtree.find($=>$.name===d);if(!v)throw new Error(`Unknown frame: ${d}`);return v}};e.$eec=k,e.$eec=k=ke([ne(0,j.$Scc)],k)}),define(re[302],oe([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0,e.$gec=w,e.$hec=g;let y=class extends A.$Uc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,r,s,i){super(),this.g=a,this.h=t,this.j=r,this.m=s,this.n=i,this.b=w(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const r=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);r&&(t.lastPluginDevelopmentHostWindow=this.w(r),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?S.$j&&!r.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.w(i);return o.uiState.mode===3&&(a.has(o.uiState.display)?S.$j&&o.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):a.add(o.uiState.display)),o}));const s=g(t);this.h.setItem(f.a,s),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",s)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(r=>{const s=(0,$.$Pi)(a.openedWorkspace)&&r.workspace?.id===a.openedWorkspace.id,i=(0,$.$Ki)(a.openedWorkspace)&&r.folderUri&&R.$5g.isEqual(r.folderUri,a.openedWorkspace.uri);(s||i)&&(r.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,$.$Pi)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,$.$Ki)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),r=this.n.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):s=!!(this.j.wasRestarted||r?.restoreFullscreen),s||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const m=a.workspace;if((0,$.$Pi)(m)){const D=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===m.id).map(I=>I.uiState);if(D.length)return D[0]}if((0,$.$Ki)(m)){const D=this.state.openedWindows.filter(I=>I.folderUri&&R.$5g.isEqual(I.folderUri,m.uri)).map(I=>I.uiState);if(D.length)return D[0]}else if(a.backupPath){const D=this.state.openedWindows.filter(I=>I.backupPath===a.backupPath).map(I=>I.uiState);if(D.length)return D[0]}const P=this.c||this.state.lastActiveWindow;if(!t&&P)return P.uiState}let r;const s=n.screen.getAllDisplays();if(s.length===1)r=s[0];else{if(S.$j){const m=n.screen.getCursorScreenPoint();r=n.screen.getDisplayNearestPoint(m)}!r&&t&&(r=n.screen.getDisplayMatching(t.getBounds())),r||(r=n.screen.getPrimaryDisplay()||s[0])}let i=(0,v.$Fcc)();i.x=Math.round(r.bounds.x+r.bounds.width/2-i.width/2),i.y=Math.round(r.bounds.y+r.bounds.height/2-i.height/2);const o=this.n.getValue("window");let l=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,l=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,l=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&t){const m=t.serializeWindowState();m.mode===3?i.mode=3:i={...m,zoomLevel:void 0},l=i.mode!==3&&o.newWindowDimensions==="offset"}}return l&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(r=>r.getBounds());for(;t.some(r=>r.x===a.x||r.y===a.y);)a.x+=30,a.y+=30;return a}};e.$fec=y,e.$fec=y=f=ke([ne(0,p.$Scc),ne(1,d.$0P),ne(2,u.$_cc),ne(3,c.$7j),ne(4,k.$7i)],y);function w(E){const a={openedWindows:[]},t=E||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=b(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=b(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(r=>b(r))),a}function b(E){const a={uiState:E.uiState};return E.backupPath&&(a.backupPath=E.backupPath),E.remoteAuthority&&(a.remoteAuthority=E.remoteAuthority),E.folder&&(a.folderUri=j.URI.parse(E.folder)),E.workspaceIdentifier&&(a.workspace={id:E.workspaceIdentifier.id,configPath:j.URI.parse(E.workspaceIdentifier.configURIPath)}),a}function g(E){return{lastActiveWindow:E.lastActiveWindow&&h(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&h(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(a=>h(a))}}function h(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(re[58],oe([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=e.$5cc=void 0,e.$5cc=(0,f.$Ai)("workspacesManagementMainService");let a=class extends R.$Uc{constructor(r,s,i,o,l){super(),this.g=r,this.h=s,this.j=i,this.m=o,this.n=l,this.a=this.B(new A.$he),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.$he),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await c.Promises.readdir(this.c.with({scheme:j.Schemas.file}).fsPath)).map(s=>(0,u.$bh)(this.c,s,g.$Zi));for(const s of r){const i=(0,E.$2cc)(s),o=await this.resolveLocalWorkspace(s);o?this.f.push({workspace:i,remoteAuthority:o.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.r(r,s=>c.Promises.readFile(s,"utf8"))}r(r,s){if(this.s(r)&&r.scheme===j.Schemas.file)try{const i=s(r.fsPath);return i instanceof Promise?i.then(o=>this.t(r,o),o=>{}):this.t(r,i)}catch{return}}s(r){return(0,g.$1i)(r,this.g)||(0,g.$6i)(r)}t(r,s){try{const i=this.u(r,s),o=(0,E.$2cc)(r);return{id:o.id,configPath:o.configPath,folders:(0,h.$ggb)(i.folders,o.configPath,u.$5g),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(r,s){const i=(0,S.$Nn)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(o=>(0,h.$egb)(o));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(r,s){const{workspace:i,storedWorkspace:o}=this.w(r,s),l=i.configPath.fsPath;return await c.Promises.mkdir((0,k.$mc)(l),{recursive:!0}),await c.Promises.writeFile(l,JSON.stringify(o,null,"	")),this.f.push({workspace:i,remoteAuthority:s}),i}w(r=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),o=(0,u.$bh)(this.c,i),l=(0,u.$bh)(o,g.$Zi),m=[];for(const P of r)m.push((0,h.$fgb)(P.uri,!0,P.name,o,u.$5g));return{workspace:(0,E.$2cc)(l),storedWorkspace:{folders:m,remoteAuthority:s}}}async getWorkspaceIdentifier(r){return(0,E.$2cc)(r)}isUntitledWorkspace(r){return(0,g.$1i)(r.configPath,this.g)}async deleteUntitledWorkspace(r){this.isUntitledWorkspace(r)&&(await this.y(r),this.j.isEnabled()&&this.j.unsetWorkspace(r),this.a.fire(r))}async y(r){const s=(0,u.$2g)(r.configPath);try{await c.Promises.rm((0,k.$mc)(s));const i=(0,k.$jc)(this.g.workspaceStorageHome.with({scheme:j.Schemas.file}).fsPath,r.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,k.$jc)(i,"obsolete"),""),this.f=this.f.filter(o=>o.workspace.id!==r.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,s,i){if(!r||!r.win||!r.isReady||!await this.z(r,s,i))return;const l=await this.C(r,(0,E.$2cc)(i));if(l)return this.b.fire({window:r,workspace:l.workspace}),l}async z(r,s,i){return i?(0,g.$Pi)(r.openedWorkspace)&&u.$5g.isEqual(r.openedWorkspace.configPath,i)?!1:(0,b.$Ycc)(s,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:(0,d.localize)(1,null,(0,u.$$g)(i)),detail:(0,d.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(r,s){if(!r.config)return;r.focus();let i;return r.config.extensionDevelopmentPath||(r.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority},r.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority})),(0,g.$Pi)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=s,r.config.backupPath=i,{workspace:s,backupPath:i}}};e.$6cc=a,e.$6cc=a=ke([ne(0,$.$Hcc),ne(1,y.$7j),ne(2,w.$Vcc),ne(3,p.$Mcc),ne(4,v.$Ncc)],a)}),define(re[134],oe([0,1,14,37,23,6,29,30,58,12,5,61]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=e.ID=void 0,e.ID="diagnosticsMainService",e.$pdc=(0,R.$Ai)(e.ID);let v=class{constructor(f,y,w){this.a=f,this.b=y,this.c=w}async getRemoteDiagnostics(f){const y=this.a.getWindows();return(await Promise.all(y.map(async b=>{const g=b.remoteAuthority;if(!g)return;const h=`vscode:getDiagnosticInfoResponse${b.id}`,E={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(a=>{b.sendWhenReady("vscode:getDiagnosticInfo",S.CancellationToken.None,{replyChannel:h,args:E}),A.$mW.once(h,(t,r)=>{r||a({hostName:g,errorMessage:`Unable to resolve connection to '${g}'.`}),a(r)}),setTimeout(()=>{a({hostName:g,errorMessage:`Connection to '${g}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const w of n.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(w.id);b?f.push(await this.d(b)):f.push(this.e(w))}const y=[];for(const{pid:w,name:b}of p.$mdc.getAll())y.push({pid:w,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:y,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const y=await this.f(f),w=(0,c.$lg)(f.win);return this.e(w,y,f.remoteAuthority)}e(f,y=[],w){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:y,remoteAuthority:w}}async f(f){const y=[],w=f.openedWorkspace;if((0,k.$Ki)(w))y.push(w.uri);else if((0,k.$Pi)(w)){const b=await this.b.resolveLocalWorkspace(w.configPath);b&&b.folders.forEach(h=>{y.push(h.uri)})}return y}};e.$qdc=v,e.$qdc=v=ke([ne(0,j.$Scc),ne(1,u.$5cc),ne(2,d.$7j)],v)}),define(re[70],oe([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t,r,s,i,o,l,m,P,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=e.$Edc=void 0,e.$Edc=(0,E.$Ai)("nativeHostMainService");let M=class extends u.$Uc{constructor(N,T,U,ie,te,ae,K,J,q){super(),this.a=N,this.b=T,this.c=U,this.f=ie,this.g=te,this.h=ae,this.j=K,this.m=J,this.n=q,this.onDidOpenMainWindow=k.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=k.Event.any(k.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:z,y:H})=>({windowId:L.id,x:z,y:H})),k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:z,y:H})=>({windowId:L.id,x:z,y:H}))),this.onDidMaximizeWindow=k.Event.any(k.Event.map(this.a.onDidMaximizeWindow,L=>L.id),k.Event.map(this.b.onDidMaximizeWindow,L=>L.id)),this.onDidUnmaximizeWindow=k.Event.any(k.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),k.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id)),this.onDidChangeWindowFullScreen=k.Event.any(k.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),k.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(L,z)=>z.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(L,z)=>z.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=k.Event.any(this.onDidBlurMainWindow,k.Event.map(k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(L,z)=>this.b.getWindowByWebContents(z.webContents)),L=>!!L),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=k.Event.any(this.onDidFocusMainWindow,k.Event.map(k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(L,z)=>this.b.getWindowByWebContents(z.webContents)),L=>!!L),L=>L.id)),this.onDidResumeOS=k.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new k.$he),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(L,z,H)=>H),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),k.Event.fromNodeEventEmitter(A.screen,"display-added"),k.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(N,T){const U=this.a.getWindows().map(te=>({id:te.id,workspace:te.openedWorkspace??(0,o.$Oi)(te.backupPath,te.isExtensionDevelopmentHost),title:te.win?.getTitle()??"",filename:te.getRepresentedFilename(),dirty:te.isDocumentEdited()})),ie=[];return T.includeAuxiliaryWindows&&ie.push(...this.b.getWindows().map(te=>({id:te.id,parentId:te.parentId,title:te.win?.getTitle()??"",filename:te.getRepresentedFilename()}))),[...U,...ie]}async getWindowCount(N){return this.a.getWindowCount()}async getActiveWindowId(N){const T=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(N,T,U){return Array.isArray(T)?this.s(N,T,U):this.t(N,T)}async s(N,T,U=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:N,urisToOpen:T,cli:this.g.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,mergeMode:U.mergeMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async t(N,T){await this.a.openEmptyWindow({context:5,contextWindowId:N},T)}async isFullScreen(N,T){return this.C(T?.targetWindowId,N)?.isFullScreen??!1}async toggleFullScreen(N,T){this.C(T?.targetWindowId,N)?.toggleFullScreen()}async handleTitleDoubleClick(N,T){this.C(T?.targetWindowId,N)?.handleTitleDoubleClick()}async getCursorScreenPoint(N){const T=A.screen.getCursorScreenPoint(),U=A.screen.getDisplayNearestPoint(T);return{point:T,display:U.bounds}}async isMaximized(N,T){return this.C(T?.targetWindowId,N)?.win?.isMaximized()??!1}async maximizeWindow(N,T){this.C(T?.targetWindowId,N)?.win?.maximize()}async unmaximizeWindow(N,T){this.C(T?.targetWindowId,N)?.win?.unmaximize()}async minimizeWindow(N,T){this.C(T?.targetWindowId,N)?.win?.minimize()}async moveWindowTop(N,T){this.C(T?.targetWindowId,N)?.win?.moveTop()}async positionWindow(N,T,U){const ie=this.C(U?.targetWindowId,N);if(ie?.win){if(ie.win.isFullScreen()){const te=k.Event.toPromise(k.Event.once(k.Event.fromNodeEventEmitter(ie.win,"leave-full-screen")));ie.win.setFullScreen(!1),await te}ie.win.setBounds(T)}}async updateWindowControls(N,T){this.C(T?.targetWindowId,N)?.updateWindowControls(T)}async focusWindow(N,T){this.C(T?.targetWindowId,N)?.focus({force:T?.force??!1})}async setMinimumSize(N,T,U){const ie=this.D(N);if(ie?.win){const[te,ae]=ie.win.getSize(),[K,J]=ie.win.getMinimumSize(),[q,L]=[T??K,U??J],[z,H]=[Math.max(te,q),Math.max(ae,L)];(K!==q||J!==L)&&ie.win.setMinimumSize(q,L),(te!==z||ae!==H)&&ie.win.setSize(z,H)}}async saveWindowSplash(N,T){this.m.saveWindowSplash(N,T)}async installShellCommand(N){const{source:T,target:U}=await this.u();try{const{symbolicLink:ie}=await y.SymlinkSupport.stat(T);if(ie&&!ie.dangling){const te=await(0,$.$_q)(T);if(U===te)return}await y.Promises.unlink(T)}catch(ie){if(ie.code!=="ENOENT")throw ie}try{await y.Promises.symlink(U,T)}catch(ie){if(ie.code!=="EACCES"&&ie.code!=="ENOENT")throw ie;const{response:te}=await this.showMessageBox(N,{type:"info",message:(0,b.localize)(0,null,this.j.nameShort),buttons:[(0,b.localize)(1,null),(0,b.localize)(2,null)]});if(te===1)throw new O.$5;try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(ae)}catch{throw new Error((0,b.localize)(3,null,T))}}}async uninstallShellCommand(N){const{source:T}=await this.u();try{await y.Promises.unlink(T)}catch(U){switch(U.code){case"EACCES":{const{response:ie}=await this.showMessageBox(N,{type:"info",message:(0,b.localize)(4,null,this.j.nameShort),buttons:[(0,b.localize)(5,null),(0,b.localize)(6,null)]});if(ie===1)throw new O.$5;try{const te=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(te)}catch{throw new Error((0,b.localize)(7,null,T))}break}case"ENOENT":break;default:throw U}}}async u(){const N=(0,d.$kc)(this.g.appRoot,"bin","code"),T=`/usr/local/bin/${this.j.applicationName}`;if(!await y.Promises.exists(N))throw new Error((0,b.localize)(8,null,N));return{source:T,target:N}}async showMessageBox(N,T){const U=this.C(T?.targetWindowId,N);return this.c.showMessageBox(T,U?.win??void 0)}async showSaveDialog(N,T){const U=this.C(T?.targetWindowId,N);return this.c.showSaveDialog(T,U?.win??void 0)}async showOpenDialog(N,T){const U=this.C(T?.targetWindowId,N);return this.c.showOpenDialog(T,U?.win??void 0)}async pickFileFolderAndOpen(N,T){const U=await this.c.pickFileFolder(T);U&&await this.w(await Promise.all(U.map(async ie=>await y.SymlinkSupport.existsDirectory(ie)?{folderUri:v.URI.file(ie)}:{fileUri:v.URI.file(ie)})),T,N)}async pickFolderAndOpen(N,T){const U=await this.c.pickFolder(T);U&&await this.w(U.map(ie=>({folderUri:v.URI.file(ie)})),T,N)}async pickFileAndOpen(N,T){const U=await this.c.pickFile(T);U&&await this.w(U.map(ie=>({fileUri:v.URI.file(ie)})),T,N)}async pickWorkspaceAndOpen(N,T){const U=await this.c.pickWorkspace(T);U&&await this.w(U.map(ie=>({workspaceUri:v.URI.file(ie)})),T,N)}async w(N,T,U){await this.a.open({context:3,contextWindowId:U,cli:this.g.args,urisToOpen:N,forceNewWindow:T.forceNewWindow})}async showItemInFolder(N,T){A.shell.showItemInFolder(T)}async setRepresentedFilename(N,T,U){this.C(U?.targetWindowId,N)?.setRepresentedFilename(T)}async setDocumentEdited(N,T,U){this.C(U?.targetWindowId,N)?.setDocumentEdited(T)}async openExternal(N,T){return this.g.unsetSnapExportedVariables(),A.shell.openExternal(T),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(N,T){return A.shell.trashItem(T)}async isAdmin(){let N;return p.$i?N=(await new Promise((T,U)=>{Q(["native-is-elevated"],T,U)}))():N=process.getuid?.()===0,N}async writeElevated(N,T,U,ie){const te=await new Promise((ae,K)=>{Q(["@vscode/sudo-prompt"],ae,K)});return new Promise((ae,K)=>{const J=[`"${this.z}"`];ie?.unlock&&J.push("--file-chmod"),J.push("--file-write",`"${T.fsPath}"`,`"${U.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:p.$j&&this.g.isBuilt?(0,d.$jc)((0,d.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};te.exec(J.join(" "),q,(L,z,H)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),H&&this.h.trace(`[sudo-prompt] received stderr: ${H}`),L?K(L):ae(void 0)})})}async isRunningUnderARM64Translation(){return p.$k||p.$i?!1:A.app.runningUnderARM64Translation}get z(){return p.$i?this.g.isBuilt?(0,d.$jc)((0,d.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,d.$jc)(this.g.appRoot,"scripts","code-cli.bat"):p.$k?this.g.isBuilt?(0,d.$jc)((0,d.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,d.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,d.$jc)(this.g.appRoot,"bin","code"):(0,d.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return f.$In.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return p.$i&&(0,P.$Bdc)()}async killProcess(N,T,U){process.kill(T,U)}async readClipboardText(N,T){return A.clipboard.readText(T)}async writeClipboardText(N,T,U){return A.clipboard.writeText(T,U)}async readClipboardFindText(N){return A.clipboard.readFindText()}async writeClipboardFindText(N,T){return A.clipboard.writeFindText(T)}async writeClipboardBuffer(N,T,U,ie){return A.clipboard.writeBuffer(T,Buffer.from(U.buffer),ie)}async readClipboardBuffer(N,T){return m.$Je.wrap(A.clipboard.readBuffer(T))}async hasClipboard(N,T,U){return A.clipboard.has(T,U)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(N,T){this.D(N)?.updateTouchBar(T)}async notifyReady(N){this.D(N)?.setReady()}async relaunch(N,T){return this.f.relaunch(T)}async reload(N,T){const U=this.D(N);if(U){if((0,o.$Pi)(U.openedWorkspace)){const ie=U.openedWorkspace.configPath;if(ie.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(ie))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.f.reload(U,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(N,T){return this.C(T?.targetWindowId,N)?.win?.close()}async quit(N){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.f.quit()}async exit(N,T){await this.f.kill(T)}async resolveProxy(N,T){return this.D(N)?.win?.webContents?.session?.resolveProxy(T)}async loadCertificates(N){return(await new Promise((U,ie)=>{Q(["@vscode/proxy-agent"],U,ie)})).loadSystemCertificates({log:this.h})}findFreePort(N,T,U,ie,te=1){return(0,w.$Yg)(T,U,ie,te)}async openDevTools(N,T){this.C(T?.targetWindowId,N)?.win?.webContents.openDevTools(T?.mode?{mode:T.mode,activate:T.activate}:void 0)}async toggleDevTools(N,T){this.C(T?.targetWindowId,N)?.win?.webContents.toggleDevTools()}async profileRenderer(N,T,U){const ie=this.D(N);if(!ie||!ie.win)throw new Error;return await new D.$Cdc(ie.win,T,this.h).inspect(U)}async windowsGetStringRegKey(N,T,U,ie){if(!p.$i)return;const te=await new Promise((ae,K)=>{Q(["@vscode/windows-registry"],ae,K)});try{return te.GetStringRegKey(T,U,ie)}catch{return}}C(N,T){return this.D(N)??this.F(N)??this.D(T)}D(N){if(typeof N=="number")return this.a.getWindowById(N)}F(N){if(typeof N!="number")return;const T=A.webContents.fromId(N);if(T)return this.b.getWindowByWebContents(T)}};e.$Fdc=M,ke([j.$5h],M.prototype,"z",null),e.$Fdc=M=ke([ne(0,i.$Scc),ne(1,I.$Ddc),ne(2,g.$Ncc),ne(3,a.$_cc),ne(4,h.$Hcc),ne(5,t.$7j),ne(6,r.$nk),ne(7,s.$Qcc),ne(8,l.$5cc)],M)}),define(re[303],oe([0,1,14,26,8,23,31,2,13,4,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t,r,s,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;const l="issue.processExplorerWindowState";let m=class{static{o=this}static{this.a="#1E1E1E"}constructor(I,O,M,W,N,T,U,ie,te,ae,K){this.g=I,this.h=O,this.i=M,this.j=W,this.k=N,this.l=T,this.m=U,this.n=ie,this.o=te,this.p=ae,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){p.$mW.on("vscode:listProcesses",async I=>{const O=[];try{O.push({name:(0,v.localize)(0,null),rootProcess:await(0,d.$Js)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,$.$in)(W)?O.push({name:W.hostName,rootProcess:W}):W.processes&&O.push({name:W.hostName,rootProcess:W.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.t(I,"vscode:listProcessesResponse",O)}),p.$mW.on("vscode:workbenchCommand",(I,O)=>{const{id:M,from:W,args:N}=O;let T;switch(W){case"processExplorer":T=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}T?.webContents.send("vscode:runAction",{id:M,from:W,args:N})}),p.$mW.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),p.$mW.on("vscode:pidToNameRequest",async I=>{const O=await this.k.getMainDiagnostics(),M=[];for(const W of O.windows)M.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:N}of r.$mdc.getAll())M.push([W,N]);this.t(I,"vscode:pidToNameResponse",M)})}async openReporter(I){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const O=new k.$Tc,M=O.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:h.default}),this.b.loadURL(u.$Ug.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,O.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,O.dispose())})}}async openProcessExplorer(I){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const O=new k.$Tc,M=O.add(this.n.createIPCObjectUrl()),W=this.p.getItem(l,void 0),N=P(W)?W:this.v(this.f,800,500);this.d=this.u(N,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:h.default}),this.d.loadURL(u.$Ug.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,O.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,O.dispose())});const T=()=>{if(!this.d)return;const U=this.d.getSize(),ie=this.d.getPosition();if(!U||!ie)return;const te={width:U[0],height:U[1],x:ie[0],y:ie[1]};this.p.setItem(l,te)};this.d.on("moved",T),this.d.on("resized",T)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await n.contentTracing.stopRecording(`${(0,j.$Ig)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null,I),buttons:[(0,v.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,O)}async $getSystemInfo(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,O)}async $getPerformanceInfo(){try{const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,O)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(6,null),buttons:[(0,v.localize)(7,null),(0,v.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(9,null),buttons:[(0,v.localize)(10,null),(0,v.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $sendReporterMenu(I,O){const M=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",N=new R.$se;return M.sendWhenReady(W,N.token,{replyChannel:W,extensionId:I,extensionName:O}),await(0,S.$rh)(new Promise(U=>p.$mW.once(`vscode:triggerReporterMenuResponse:${I}`,(ie,te)=>U(te))),5e3,()=>{this.i.error(`Error: Extension ${I} timed out waiting for menu response`),N.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,O,...M){I.sender.isDestroyed()||I.sender.send(O,...M)}u(I,O,M,W){const N=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:M.title,backgroundColor:M.backgroundColor||o.a,webPreferences:{preload:u.$Ug.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$SD)(M.zoomLevel),sandbox:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return N.setMenuBarVisibility(!1),N}v(I,O,M){let W;const N=n.screen.getAllDisplays();if(N.length===1)W=N[0];else{if(c.$j){const ie=n.screen.getCursorScreenPoint();W=n.screen.getDisplayNearestPoint(ie)}!W&&I&&(W=n.screen.getDisplayMatching(I.getBounds())),W||(W=n.screen.getPrimaryDisplay()||N[0])}const T=W.bounds,U={width:O,height:M,x:T.x+T.width/2-O/2,y:T.y+T.height/2-M/2};return T.width>0&&T.height>0&&(U.x<T.x&&(U.x=T.x),U.y<T.y&&(U.y=T.y),U.x>T.x+T.width&&(U.x=T.x),U.y>T.y+T.height&&(U.y=T.y),U.width>T.width&&(U.width=T.width),U.height>T.height&&(U.height=T.height)),U}};e.$Gdc=m,e.$Gdc=m=o=ke([ne(1,w.$Hcc),ne(2,b.$7j),ne(3,$.$hn),ne(4,f.$pdc),ne(5,y.$Ncc),ne(6,g.$Edc),ne(7,a.$Pcc),ne(8,E.$nk),ne(9,t.$0P),ne(10,i.$Scc)],m);function P(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(re[304],oe([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;let $=class extends v.$6dc{constructor(y,w,b,g,h,E,a,t){super(y,w,g,h,E,t),this.e=b,this.u=a}s(y){return(0,v.$5dc)(`linux-${process.arch}`,y,this.k)}t(y){this.a&&(this.d(p.$tX.CheckingForUpdates(y)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$Zp).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!y}),this.d(p.$tX.Idle(1))):this.d(p.$tX.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w);const b=y?w.message||w:void 0;this.d(p.$tX.Idle(1,b))}))}async o(y){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):y.update.url&&this.u.openExternal(void 0,y.update.url),this.d(p.$tX.Idle(1))}};e.$8dc=$,e.$8dc=$=ke([ne(0,R.$_cc),ne(1,A.$7i),ne(2,d.$6l),ne(3,S.$Hcc),ne(4,c.$Tp),ne(5,j.$7j),ne(6,k.$Edc),ne(7,u.$nk)],$)}),define(re[305],oe([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;async function s(m,P=1e3){for(;!m();)await(0,R.$Bh)(P)}let i;function o(){return typeof i>"u"&&(i=A.existsSync(c.$jc(c.$mc(process.execPath),"unins000.exe"))?0:1),i}let l=class extends r.$6dc{get cachePath(){const P=c.$jc((0,S.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return v.Promises.mkdir(P,{recursive:!0}).then(()=>P)}constructor(P,D,I,O,M,W,N,T,U){super(P,D,O,M,W,U),this.u=I,this.v=N,this.w=T,P.setRelaunchHandler(this)}handleRelaunch(P){return P?.addArgs||P?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$tX.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(P){let D=`win32-${process.arch}`;return o()===1?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,r.$5dc)(D,P,this.k)}t(P){this.a&&(this.d(t.$tX.CheckingForUpdates(P)),this.i.request({url:this.a},j.CancellationToken.None).then(E.$Zp).then(D=>{const I=o();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!P}),this.d(t.$tX.Idle(I)),Promise.resolve(null)):I===1?(this.d(t.$tX.AvailableForDownload(D)),Promise.resolve(null)):(this.d(t.$tX.Downloading),this.C(D.version).then(()=>this.B(D.version).then(O=>v.Promises.exists(O).then(M=>{if(M)return Promise.resolve(O);const W=`${O}.tmp`;return this.i.request({url:D.url},j.CancellationToken.None).then(N=>this.v.writeFile(d.URI.file(W),N.stream)).then(D.sha256hash?()=>(0,p.$fW)(W,D.sha256hash):()=>{}).then(()=>v.Promises.rename(W,O,!1)).then(()=>O)})).then(O=>{this.e={packagePath:O},this.d(t.$tX.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$tX.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,u.$oj)(String(D)))}),this.j.error(D);const I=P?D.message||D:void 0;this.d(t.$tX.Idle(o(),I))}))}async o(P){P.update.url&&this.w.openExternal(void 0,P.update.url),this.d(t.$tX.Idle(o()))}async B(P){const D=await this.cachePath;return c.$jc(D,`CodeSetup-${this.k.quality}-${P}.exe`)}async C(P=null){const D=P?W=>!new RegExp(`${this.k.quality}-${P}\\.exe$`).test(W):()=>!0,I=await this.cachePath,M=(await v.Promises.readdir(I)).filter(D).map(async W=>{try{await v.Promises.unlink(c.$jc(I,W))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const P=this.state.update;this.d(t.$tX.Updating(P));const D=await this.cachePath;this.e.updateFilePath=c.$jc(D,`CodeSetup-${this.k.quality}-${P.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$tX.Idle(o()))});const O=`${this.k.win32MutexName}-ready`,M=await new Promise((W,N)=>{Q(["@vscode/windows-mutex"],W,N)});s(()=>M.isActive(O)).then(()=>this.d(t.$tX.Ready(P)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(P){if(this.state.type!=="idle")return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown"};this.d(t.$tX.Downloading),this.e={packagePath:P},this.d(t.$tX.Downloaded(I)),D?this.k.target==="user"&&this.p():this.d(t.$tX.Ready(I))}};e.$0dc=l,ke([k.$5h],l.prototype,"cachePath",null),e.$0dc=l=ke([ne(0,w.$_cc),ne(1,$.$7i),ne(2,a.$6l),ne(3,f.$Hcc),ne(4,E.$Tp),ne(5,b.$7j),ne(6,y.$7k),ne(7,g.$Edc),ne(8,h.$nk)],l)}),define(re[135],oe([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t,r,s,i,o,l,m,P,D,I,O,M,W,N,T,U,ie,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=e.$9cc=void 0;var ae;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(ae||(ae={}));class K extends k.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(j.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(j.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(j.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(j.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(j.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(j.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const z=!(0,P.$ND)(this.r);if(d.$j&&z&&L.setSheetOffset((0,d.$J)((0,$.release)())?28:22),z&&(d.$i&&(0,P.$QD)(this.r)||d.$j)){const H=this.s.getItem(K.D);H?this.updateWindowControls({height:H}):this.updateWindowControls({height:P.$PD})}d.$i&&z&&L.hookWindowMessage(278,()=>{const[ce,V]=L.getPosition(),le=n.screen.getCursorScreenPoint(),Y=le.x-ce,C=le.y-V;return!(Y>30&&C>=0&&C<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:Y,y:C})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),d.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(L,z,H,ce){super(),this.r=L,this.s=z,this.t=H,this.u=ce,this.a=this.B(new j.$he),this.onDidClose=this.a.event,this.b=this.B(new j.$he),this.onDidMaximize=this.b.event,this.c=this.B(new j.$he),this.onDidUnmaximize=this.c.event,this.f=this.B(new j.$he),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new j.$he),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new j.$he),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,P.$QD)(this.r),this.G=void 0,this.H=void 0}w(L,z=n.screen.getAllDisplays().length>0){const H=this.r.getValue("window"),ce=d.$j&&H?.nativeTabs===!0;(d.$j||d.$i)&&z&&(!ce||n.BrowserWindow.getAllWindows().length===1)&&[L.width,L.height,L.x,L.y].every(V=>typeof V=="number")&&this.m?.setBounds({width:L.width,height:L.height,x:L.x,y:L.y}),(L.mode===0||L.mode===3)&&(this.m?.maximize(),L.mode===3&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(L){d.$j?this.win?.setRepresentedFilename(L):this.z=L}getRepresentedFilename(){return d.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(L){d.$j&&this.win?.setDocumentEdited(L),this.C=L}isDocumentEdited(){return d.$j?!!this.win?.isDocumentEdited():!!this.C}focus(L){d.$j&&L?.force&&n.app.focus({steal:!0});const z=this.win;z&&(z.isMinimized()&&z.restore(),z.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(d.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.D="windowControlHeight"}updateWindowControls(L){const z=this.win;if(z){if(L.height&&this.s.setItem(J.D,L.height),d.$i&&this.F)z.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(d.$j&&L.height!==void 0){const H=(L.height-15)/2;H?z.setWindowButtonPosition({x:H,y:H}):z.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(L,z){(0,P.$RD)(this.r)?this.J(L,z):this.M(L)}get isFullScreen(){if(d.$j&&typeof this.G=="boolean")return this.G;const L=this.win,z=L?.isFullScreen(),H=L?.isSimpleFullScreen();return!!(z||H)}J(L,z){const H=this.win;H?.isSimpleFullScreen()&&H?.setSimpleFullScreen(!1),this.L(L,z)}L(L,z){if(d.$j){this.G=L;const ce=this.H=new A.$Xh;(async()=>{const V=await Promise.race([ce.p,(0,A.$Bh)(1e4).then(()=>!1)]);this.H===ce&&(this.G=void 0,this.H=void 0,!V&&L&&z&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}M(L){const z=this.win;z?.isFullScreen()&&this.L(!1,!1),z?.setSimpleFullScreen(L),z?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$9cc=K;let J=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const L=this.hb.profiles.find(z=>z.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.hb.getProfileForWorkspace(this.config.workspace??(0,I.$Oi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(L,z,H,ce,V,le,Y,C,F,_,B,Z,x,ee,G,ue,fe,we,Ee,Oe,ye){super(_,Oe,ce,z),this.fb=H,this.gb=V,this.hb=le,this.ib=Y,this.jb=C,this.kb=F,this.lb=B,this.mb=Z,this.nb=x,this.ob=ee,this.pb=G,this.qb=ue,this.rb=fe,this.sb=we,this.tb=Ee,this.N=this.B(new j.$he),this.onWillLoad=this.N.event,this.O=this.B(new j.$he),this.onDidSignalReady=this.O.event,this.P=this.B(new j.$he),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=0;{const[ve,Ce]=this.Eb(L.state);this.U=ve,this.u.trace("window#ctor: using window state",ve);const me=ye.invokeFunction(D.$Tcc,this.U,{preload:u.$Ug.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(me),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Ce),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=2;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.X.push(L)})}get isReady(){return this.ub===2}get whenClosedOrLoaded(){return new Promise(L=>{function z(){H.dispose(),ce.dispose(),L()}const H=this.onDidClose(()=>z()),ce=this.onWillLoad(()=>z())})}vb(){this.B(j.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(1))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(z,H)=>H)(z=>this.yb(2,{...z}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(z,H,ce)=>({exitCode:H,reason:ce}))(({exitCode:z,reason:H})=>this.yb(3,{reason:H,exitCode:z}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(z=>z.preventDefault())),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",S.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",S.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(z=>this.Bb(z))),this.B(this.mb.onDidDeleteUntitledWorkspace(z=>this.Ab(z)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(z,H)=>{const ce=await this.xb();H({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,ce)})})}xb(){return this.wb||(this.wb=(0,s.$bq)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(L,z){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:L,reason:z?.reason,code:z?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:ce}=await this.pb.showMessageBox({type:"warning",buttons:[(0,v.localize)(0,null),(0,v.localize)(1,null),(0,v.localize)(2,null)],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),checkboxLabel:this.S?.workspace?(0,v.localize)(5,null):void 0},this.m);if(H!==2){const V=H===0;await this.zb(V,ce)}}else if(L===2){let H;z?H=(0,v.localize)(7,null,z.reason,z.exitCode??"<unknown>"):H=(0,v.localize)(6,null);const{response:ce,checkboxChecked:V}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,v.localize)(8,null):(0,v.localize)(9,null),(0,v.localize)(10,null)],message:H,detail:this.S?.workspace?(0,v.localize)(11,null):(0,v.localize)(12,null),checkboxLabel:this.S?.workspace?(0,v.localize)(13,null):void 0},this.m),le=ce===0;await this.zb(le,V)}break}}async zb(L,z){const H=this.S?.workspace;if(z&&H)try{const ce=this.kb.workspaceStorage(H);await ce.init(),ce.delete("memento/workbench.parts.editor"),await ce.close()}catch(ce){this.u.error(ce)}this.P.fire();try{if(L&&this.S){let ce,V;(0,I.$Ki)(H)?ce={folderUri:H.uri}:(0,I.$Pi)(H)?ce={workspaceUri:H.configPath}:V=!0,(0,ie.$Ob)(await this.tb.open({context:5,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ce?[ce]:void 0,forceEmpty:V,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(L){this.S?.workspace?.id===L.id&&(this.S.workspace=void 0)}Bb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const z=this.Gb();z!==this.W&&(this.W=z,this.Hb(z))}if(!L||L.affectsConfiguration("http.proxy")){let z=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.Z||H!==this.$)){this.Z=z,this.$=H;const ce=z||"",V=H?`${H},<local>`:"<local>";this.u.trace(`Setting proxy to '${ce}', bypassing '${V}'`),this.m.webContents.session.setProxy({proxyRules:ce,proxyBypassRules:V,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:ce,proxyBypassRules:V,pacScript:""})}}}addTabbedWindow(L){d.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,z=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!z.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(L,z),this.ub===0?this.S=L:this.db=L,this.ub=1,this.m.loadURL(u.$Ug.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new A.$Mh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:L.workspace,reason:z.isReload?3:H?2:1})}Cb(L,z){const H=(this.S??this.db)?.userEnv;if(H){const ce=(0,g.$Em)(H)&&!(0,g.$Em)(L.userEnv),V=this.isExtensionDevelopmentHost;(ce||V)&&(L.userEnv={...H,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),z.disableExtensions!==void 0&&(L["disable-extensions"]=z.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.lb.getWindowSplash(),L.zoomLevel=this.Jb(),L.isCustomZoomLevel=typeof this.ab=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),L.perfMarks=(0,c.getMarks)(),this.bb.update(L)}async reload(L){const z=Object.assign({},this.S);z.workspace=await this.Db(z),delete z.filesToOpenOrCreate,delete z.filesToDiff,delete z.filesToMerge,delete z.filesToWait,this.isExtensionDevelopmentHost&&L&&(z.verbose=L.verbose,z.debugId=L.debugId,z.extensionEnvironment=L.extensionEnvironment,z["inspect-extensions"]=L["inspect-extensions"],z["inspect-brk-extensions"]=L["inspect-brk-extensions"],z["extensions-dir"]=L["extensions-dir"]),z.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),z.isInitialStartup=!1,z.policiesData=this.gb.serialize(),z.continueOn=this.t.continueOn,z.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},z.logLevel=this.fb.getLogLevel(),z.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(z,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Db(L){if((0,I.$Pi)(L.workspace)){const z=L.workspace.configPath;if(z.scheme===u.Schemas.file&&!await this.ib.exists(z))return}else if((0,I.$Ki)(L.workspace)){const z=L.workspace.uri;if(z.scheme===u.Schemas.file&&!await this.ib.exists(z))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,M.$Fcc)();if(this.isFullScreen){let H;try{H=n.screen.getDisplayMatching(this.getBounds())}catch{}const ce=(0,M.$Fcc)();return{mode:3,display:H?H.id:void 0,width:this.U.width||ce.width,height:this.U.height||ce.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const L=Object.create(null);let z;if(!d.$j&&this.m.isMaximized()?z=0:z=1,z===0?L.mode=0:L.mode=1,z===1||z===0){let H;z===1?H=this.getBounds():H=this.m.getNormalBounds(),L.x=H.x,L.y=H.y,L.width=H.width,L.height=H.height}return L.zoomLevel=this.ab,L}Eb(L){(0,c.mark)("code/willRestoreCodeWindowState");let z=!1;if(L){this.ab=L.zoomLevel;try{const H=n.screen.getAllDisplays();z=H.length>1,L=D.WindowStateValidator.validateWindowState(this.u,L,H)}catch(H){this.u.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[L||(0,M.$Fcc)(),z]}getBounds(){const[L,z]=this.m.getPosition(),[H,ce]=this.m.getSize();return{x:L,y:z,width:H,height:ce}}I(L,z){super.I(L,z),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",S.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let L=(0,P.$LD)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Hb(L,z=!0){d.$j||(L==="toggle"&&z&&this.send("vscode:showInfoMessage",(0,v.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Ib(L)}):this.Ib(L))}Ib(L){const z=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!z),this.m.autoHideMenuBar=z;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.ab=L}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,z,...H){this.isReady?this.send(L,...H):this.ready().then(()=>{z.isCancellationRequested||this.send(L,...H)})}send(L,...z){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...z)}catch(H){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.Q}: ${(0,R.$lj)(H)}`)}}}updateTouchBar(L){d.$j&&this.Y.forEach((z,H)=>{const ce=L[H];z.segments=this.Mb(ce)})}Kb(){if(d.$j){for(let L=0;L<10;L++){const z=this.Lb();this.Y.push(z)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(L=[]){const z=this.Mb(L),H=new n.TouchBar.TouchBarSegmentedControl({segments:z,mode:"buttons",segmentStyle:"automatic",change:ce=>{this.sendWhenReady("vscode:runAction",S.CancellationToken.None,{id:H.segments[ce].id,from:"touchbar"})}});return H}Mb(L=[]){return L.map(H=>{let ce;H.icon&&!l.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===u.Schemas.file&&(ce=n.nativeImage.createFromPath(p.URI.revive(H.icon.dark).fsPath),ce.isEmpty()&&(ce=void 0));let V;return typeof H.title=="string"?V=H.title:V=H.title.value,{id:H.id,label:ce?void 0:V,icon:ce}})}matches(L){return this.m?.webContents.id===L.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$0cc=J,e.$0cc=J=ke([ne(1,a.$7j),ne(2,U.$7cc),ne(3,b.$Hcc),ne(4,W.$jo),ne(5,T.$Vcc),ne(6,h.$7k),ne(7,i.$hdc),ne(8,i.$fdc),ne(9,y.$7i),ne(10,m.$Qcc),ne(11,O.$5cc),ne(12,f.$Mcc),ne(13,o.$6l),ne(14,w.$Ncc),ne(15,E.$_cc),ne(16,t.$nk),ne(17,r.$Pcc),ne(18,D.$Scc),ne(19,N.$0P),ne(20,te.$zi)],J)}),define(re[306],oe([0,1,14,4,18,24,20,5,34,55,135]),function(Q,e,n,A,S,R,j,k,u,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;let p=class extends d.$9cc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor($,f,y,w,b,g){super(w,b,f,y),this.O=$,this.P=g,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow($){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),$&&!this.N&&(this.N=!0,this.w({x:$.x,y:$.y,width:$.width,height:$.height,mode:$.show===!1?0:1})))}Q(){if(this.m)return;const $=n.BrowserWindow.fromWebContents(this.O);$&&(this.u.trace("[aux window] Claimed browser window instance"),this.n($),$.setMenu(null),(A.$i||A.$k)&&(0,c.$ND)(this.r)&&$.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches($){return this.O.id===$.id}};e.$$cc=p,e.$$cc=p=ke([ne(1,R.$Hcc),ne(2,k.$7j),ne(3,S.$7i),ne(4,u.$0P),ne(5,j.$_cc)],p)}),define(re[307],oe([0,1,14,3,2,13,37,306,6,5,82,29]),function(Q,e,n,A,S,R,j,k,u,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;let v=class extends S.$Uc{constructor(f,y){super(),this.h=f,this.j=y,this.a=this.B(new A.$he),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new A.$he),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new A.$he),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new A.$he),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,y)=>{const w=this.getWindowByWebContents(y.webContents);if(w)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow();else{const b=new S.$Tc;b.add(A.Event.fromNodeEventEmitter(y.webContents,"did-create-window",(g,h)=>({browserWindow:g,details:h}))(({browserWindow:g,details:h})=>{const E=this.getWindowByWebContents(g.webContents);E&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),E.tryClaimWindow(h.options))})),b.add(A.Event.fromNodeEventEmitter(y,"closed")(()=>b.dispose()))}}),j.$mW.handle("vscode:registerAuxiliaryWindow",async(f,y)=>{const w=this.getWindowByWebContents(f.sender);return w&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=y),f.sender.id})}createWindow(f){return this.h.invokeFunction(p.$Tcc,this.n(f),{preload:R.$Ug.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const y={},w=f.features.split(",");for(const g of w){const[h,E]=g.split("=");switch(h){case"width":y.width=parseInt(E,10);break;case"height":y.height=parseInt(E,10);break;case"left":y.x=parseInt(E,10);break;case"top":y.y=parseInt(E,10);break;case"window-maximized":y.mode=0;break;case"window-fullscreen":y.mode=3;break}}const b=p.WindowStateValidator.validateWindowState(this.j,y)??(0,d.$Gcc)();return this.j.trace("[aux window] using window state",b),b}registerWindow(f){const y=new S.$Tc,w=this.h.createInstance(k.$$cc,f);this.g.set(w.id,w),y.add((0,S.$Sc)(()=>this.g.delete(w.id))),y.add(w.onDidMaximize(()=>this.a.fire(w))),y.add(w.onDidUnmaximize(()=>this.b.fire(w))),y.add(w.onDidEnterFullScreen(()=>this.c.fire({window:w,fullscreen:!0}))),y.add(w.onDidLeaveFullScreen(()=>this.c.fire({window:w,fullscreen:!1}))),y.add(w.onDidTriggerSystemContextMenu(({x:b,y:g})=>this.f.fire({window:w,x:b,y:g}))),A.Event.once(w.onDidClose)(()=>y.dispose())}getWindowByWebContents(f){const y=this.g.get(f.id);return y?.matches(f)?y:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,p.$Ucc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Cec=v,e.$Cec=v=ke([ne(0,u.$zi),ne(1,c.$7j)],v)}),define(re[85],oe([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,32,56]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=e.$Qdc=void 0,e.$Qdc=(0,f.$Ai)("workspacesHistoryMainService");let s=class extends k.$Uc{static{r=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(o,l,m,P,D){super(),this.f=o,this.g=l,this.h=m,this.j=P,this.m=D,this.c=this.B(new R.$he),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new S.$yh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){let l=[],m=[];for(const D of o)if((0,g.$bgb)(D))!this.g.isUntitledWorkspace(D.workspace)&&!this.w(l,D.workspace)&&l.push(D);else if((0,g.$cgb)(D))this.y(l,D.folderUri)||l.push(D);else{const I=this.z(m,D.fileUri),O=D.fileUri.scheme===u.Schemas.file&&r.G.indexOf((0,d.$$g)(D.fileUri))>=0;!I&&!O&&(m.push(D),c.$i&&D.fileUri.scheme===u.Schemas.file&&n.app.addRecentDocument(D.fileUri.fsPath))}const P=await this.r({workspaces:l,files:m});l=P.workspaces,m=P.files,l.length>r.a&&(l.length=r.a),m.length>r.a&&(m.length=r.a),await this.t({workspaces:l,files:m}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(o){const l=I=>{const O=this.u(I);for(const M of o)if(d.$5g.isEqual(M,O))return!1;return!0},m=await this.getRecentlyOpened(),P=m.workspaces.filter(l),D=m.files.filter(l);(P.length!==m.workspaces.length||D.length!==m.files.length)&&(await this.t({files:D,workspaces:P}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(o){if(o?.confirm){const{response:l}=await this.m.showMessageBox({type:"warning",buttons:[(0,$.localize)(0,null),(0,$.localize)(1,null)],message:(0,$.localize)(2,null),detail:(0,$.localize)(3,null),cancelId:1});if(l!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(o){const l=new a.$Ac(D=>d.$5g.getComparisonKey(D));if(o?.workspaces)for(const D of o.workspaces)l.set(this.u(D),D);const m=new a.$Ac(D=>d.$5g.getComparisonKey(D));if(o?.files)for(const D of o.files)m.set(this.u(D),D);const P=await this.s();for(const D of P.workspaces){const I=l.get(this.u(D));I?I.label=I.label??D.label:l.set(this.u(D),D)}for(const D of P.files){const I=m.get(this.u(D));I?I.label=I.label??D.label:m.set(this.u(D),D)}return{workspaces:[...l.values()],files:[...m.values()]}}async s(){await this.j.whenReady;let o;const l=this.j.get(r.b,-1);if(typeof l=="string")try{o=JSON.parse(l)}catch(m){this.f.error("Unexpected error parsing opened paths list",m)}return(0,g.$igb)(o,this.f)}async t(o){await this.j.whenReady,this.j.store(r.b,JSON.stringify((0,g.$jgb)(o)),-1,1)}u(o){return(0,g.$cgb)(o)?o.folderUri:(0,g.$dgb)(o)?o.fileUri:o.workspace.configPath}w(o,l){return!!o.find(m=>(0,g.$bgb)(m)&&m.workspace.id===l.id)}y(o,l){return!!o.find(m=>(0,g.$cgb)(m)&&d.$5g.isEqual(m.folderUri,l))}z(o,l){return!!o.find(m=>d.$5g.isEqual(m.fileUri,l))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,$.localize)(4,null),description:(0,$.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const l=[];for(const D of n.app.getJumpListSettings().removedItems){const I=D.args;if(I){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);O&&l.push(p.URI.parse(O[2]))}}await this.removeRecentlyOpened(l);let m=!1;const P=(0,A.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,r.F).map(D=>{const I=(0,g.$bgb)(D)?D.workspace:D.folderUri,{title:O,description:M}=this.L(I,D.label);let W;return p.URI.isUri(I)?W=`--folder-uri "${I.toString()}"`:(m=!0,W=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:M.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));P.length>0&&o.push({type:"custom",name:m?(0,$.localize)(6,null):(0,$.localize)(7,null),items:P})}o.push({type:"recent"});try{const l=n.app.setJumpList(o);l&&l!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${l}`)}catch(l){this.f.warn("updateWindowsJumpList#setJumpList",l)}}L(o,l){if(l)return{title:(0,j.$Sw)(l).name,description:l};if(p.URI.isUri(o))return{title:(0,d.$$g)(o),description:this.M(o)};if(this.g.isUntitledWorkspace(o))return{title:(0,$.localize)(8,null),description:""};let m=(0,d.$$g)(o.configPath);return m.endsWith(h.$Wi)&&(m=m.substr(0,m.length-h.$Wi.length-1)),{title:(0,$.localize)(9,null,m),description:this.M(o.configPath)}}M(o){return o.scheme==="file"?(0,j.$Kw)(o.fsPath):o.toString()}async N(){if(!c.$j)return;n.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),l=[];let m=0;for(let D=0;D<o.workspaces.length&&m<r.C;D++){const I=this.u(o.workspaces[D]);if(I.scheme===u.Schemas.file){const O=(0,d.$2g)(I);await v.Promises.exists(O)&&(l.push(O),m++)}}const P=[];for(let D=0;D<o.files.length&&m<r.D;D++){const I=this.u(o.files[D]);if(I.scheme===u.Schemas.file){const O=(0,d.$2g)(I);if(r.G.includes((0,d.$$g)(I))||l.includes(O))continue;await v.Promises.exists(O)&&(P.push(O),m++)}}P.reverse().forEach(D=>n.app.addRecentDocument(D)),l.reverse().forEach(D=>n.app.addRecentDocument(D))}};e.$Rdc=s,e.$Rdc=s=r=ke([ne(0,w.$7j),ne(1,E.$5cc),ne(2,y.$_cc),ne(3,b.$hdc),ne(4,t.$Ncc)],s)}),define(re[308],oe([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;const s="menu";let i=class{static{r=this}static{this.a="lastKnownMenubarData"}constructor(m,P,D,I,O,M,W,N,T,U,ie,te){this.n=m,this.o=P,this.p=D,this.q=I,this.r=O,this.s=M,this.t=W,this.u=N,this.v=T,this.w=U,this.x=ie,this.y=te,this.m=Object.create(null),this.g=new A.$Mh(()=>this.F(),0),this.h=new A.$Mh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(j.$j||(0,E.$ND)(P))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const m=this.t.getItem(r.a);m&&(m.menus&&(this.k=m.menus),m.keybindings&&(this.l=m.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,W,N)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(M,W,N)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(M,W,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:s}}),this.m["workbench.action.files.openFolder"]=(M,W,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:s}}),this.m["workbench.action.openWorkspace"]=(M,W,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(N),telemetryExtraData:{from:s}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const m=this.x.youTubeUrl;m&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(m,"openYouTubeUrl"));const P=this.x.requestFeatureUrl;P&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(P,"openUserVoiceUrl"));const D=this.x.reportIssueUrl;D&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(D,"openReportIssues"));const I=this.x.licenseUrl;I&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(j.$w){const M=I.indexOf("?")>0?"&":"?";this.ab(`${I}${M}lang=${j.$w}`,"openLicenseUrl")}else this.ab(I,"openLicenseUrl")});const O=this.x.privacyStatementUrl;O&&I&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(O,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(m=>this.G(m)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const m=this.o.getValue("window.enableMenuBarMnemonics");return typeof m!="boolean"?!0:m}get D(){if(!j.$j)return!1;const m=this.o.getValue("window.nativeTabs");return typeof m!="boolean"?!1:m}updateMenu(m,P){this.k=m.menus,this.l=m.keybindings,this.t.setItem(r.a,m),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(m){j.$j&&(m.oldCount===0&&m.newCount>0||m.oldCount>0&&m.newCount===0)&&(this.d=m.newCount===0,this.E())}H(){if(!j.$j)return;const m=n.BrowserWindow.getFocusedWindow();this.f=!m||!!this.y.getWindowByWebContents(m.webContents),this.E()}I(){const m=n.Menu.getApplicationMenu();if(m&&this.j.push(m),Object.keys(this.k).length===0){this.J(j.$j?new n.Menu:null);return}const P=new n.Menu;let D;if(j.$j){const O=new n.Menu;D=new n.MenuItem({label:this.x.nameShort,submenu:O}),this.K(O),P.append(D)}if(j.$j&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.cb(u.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(O)}if(this.M("File")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(1,null)),submenu:O});this.O(O,"File"),P.append(M)}if(this.M("Edit")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(2,null)),submenu:O});this.O(O,"Edit"),P.append(M)}if(this.M("Selection")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(3,null)),submenu:O});this.O(O,"Selection"),P.append(M)}if(this.M("View")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(4,null)),submenu:O});this.O(O,"View"),P.append(M)}if(this.M("Go")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(5,null)),submenu:O});this.O(O,"Go"),P.append(M)}if(this.M("Run")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(6,null)),submenu:O});this.O(O,"Run"),P.append(M)}if(this.M("Terminal")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(7,null)),submenu:O});this.O(O,"Terminal"),P.append(M)}let I;if(this.M("Window")){const O=new n.Menu;I=new n.MenuItem({label:this.cb(u.localize(8,null)),submenu:O,role:"window"}),this.U(O)}if(I&&P.append(I),this.M("Help")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(9,null)),submenu:O,role:"help"});this.O(O,"Help"),P.append(M)}P.items&&P.items.length>0?this.J(P):this.J(null),this.h.schedule()}J(m){if(n.Menu.setApplicationMenu(m),m)for(const P of this.y.getWindows())P.win?.setMenu(null)}K(m){const P=this.W(u.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),D=this.V();let I;if(this.M("Preferences")){const te=new n.Menu;this.O(te,"Preferences"),I=new n.MenuItem({label:this.cb(u.localize(11,null)),submenu:te})}const O=new n.Menu,M=new n.MenuItem({label:u.localize(12,null),role:"services",submenu:O}),W=new n.MenuItem({label:u.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new n.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),T=new n.MenuItem({label:u.localize(15,null),role:"unhide"}),U=new n.MenuItem(this.$("workbench.action.quit",{label:u.localize(16,null,this.x.nameLong),click:async(te,ae,K)=>{const J=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||J?.win?.isMinimized())&&await this.L(K)&&this.w.quit(void 0)}})),ie=[P];ie.push(...D),I&&ie.push(o(),I),ie.push(o(),M,o(),W,N,T,o(),U),ie.forEach(te=>m.append(te))}async L(m){if(this.p.getWindowCount()===0)return!0;const P=this.o.getValue("window.confirmBeforeClose");if(P==="always"||P==="keyboardOnly"&&this.S(m)){const{response:D}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[u.localize(17,null),u.localize(18,null)],message:u.localize(19,null)});return D===0}return!0}M(m){if(!j.$j&&!(0,E.$ND)(this.o))return!1;switch(m){case"File":case"Help":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[m];case"Window":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[m]}}N(m,P){P.forEach(D=>{if((0,f.$Ndc)(D))m.append(o());else if((0,f.$Mdc)(D)){const I=new n.Menu,O=new n.MenuItem({label:this.cb(D.label),submenu:I});this.N(I,D.submenu.items),m.append(O)}else(0,f.$Odc)(D)?m.append(this.Q(D)):(0,f.$Pdc)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.P(m),j.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[D.id]?m.append(new n.MenuItem(this.$(D.id,{label:this.cb(D.label),click:this.m[D.id]}))):m.append(this.W(D.label,D.id,!1,D.checked)):m.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)):m.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)))})}O(m,P){this.k&&this.k[P]&&this.N(m,this.k[P].items)}P(m){const P=this.V();P.length&&(P.forEach(D=>m.append(D)),m.append(o()))}Q(m){const P=k.URI.revive(m.uri),D=m.id,I=D==="openRecentFile"?{fileUri:P}:D==="openRecentWorkspace"?{workspaceUri:P}:{folderUri:P};return new n.MenuItem(this.$(D,{label:m.label,click:async(O,M,W)=>{const N=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[I],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:m.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([P])}},!1))}R(m){return!!(m&&(!j.$j&&(m.ctrlKey||m.shiftKey)||j.$j&&(m.metaKey||m.altKey)))}S(m){return!!(m.triggeredByAccelerator||m.altKey||m.ctrlKey||m.metaKey||m.shiftKey)}T(m,P,D){const I={label:this.cb(m),role:D,enabled:!0};return new n.MenuItem(this.Z(P,I))}U(m){const P=new n.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),D=new n.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),I=new n.MenuItem({label:u.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),O=this.W(u.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(o()),M.push(this.W(u.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[P,D,o(),O,...M,o(),I].forEach(W=>m.append(W))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(u.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(u.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return j.$j?[]:[new n.MenuItem({label:this.cb(u.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(u.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(m,P,D,I){const O=this.cb(m),M=typeof P=="function"?P:(ie,te,ae)=>{const K=ie?ie.userSettingsLabel:null;let J=P;Array.isArray(P)&&(J=this.R(ae)?P[1]:P[0]),K&&ae.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:K}):this.Y({type:"commandId",commandId:J})},W=typeof D=="boolean"?D:this.p.getWindowCount()>0,N=typeof I=="boolean"?I:!1,T={label:O,click:M,enabled:W};N&&(T.type="checkbox",T.checked=N);let U;return typeof P=="string"?U=P:Array.isArray(P)&&(U=P[0]),j.$j&&(U==="editor.action.clipboardCutAction"?T.role="cut":U==="editor.action.clipboardCopyAction"?T.role="copy":U==="editor.action.clipboardPasteAction"&&(T.role="paste"),U==="undo"?T.click=this.X(M,{inDevTools:ie=>ie.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):U==="redo"?T.click=this.X(M,{inDevTools:ie=>ie.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):U==="editor.action.selectAll"&&(T.click=this.X(M,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(U,T))}X(m,P){return(D,I,O)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return P.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return P.inDevTools(M.webContents.devToolsWebContents);m(D,I||M,O)}}Y(m){let P=n.BrowserWindow.getFocusedWindow();if(P){const I=this.y.getWindowByWebContents(P.webContents);I&&(P=this.p.getWindowById(I.parentId)?.win??null)}if(!P){const I=this.p.getLastActiveWindow();I?.win?.isMinimized()&&(P=I.win)}const D=P?this.p.getWindowById(P.id):void 0;if(D){if(this.v.trace("menubar#runActionInRenderer",m),j.$j&&!this.q.isBuilt&&!D.isReady&&(m.type==="commandId"&&m.commandId==="workbench.action.toggleDevTools"||m.type!=="commandId"&&m.userSettingsLabel==="alt+cmd+i"))return!1;if(m.type==="commandId"){const I={id:m.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",S.CancellationToken.None,I)}else{const I={userSettingsLabel:m.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",S.CancellationToken.None,I)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",m),!1}Z(m,P){const D=typeof m=="string"?this.l[m]:void 0;if(D?.label){if(D.isNative!==!1)P.accelerator=D.label,P.userSettingsLabel=D.userSettingsLabel;else if(typeof P.label=="string"){const I=P.label.indexOf("[");I>=0?P.label=`${P.label.substr(0,I)} [${D.label}]`:P.label=`${P.label} [${D.label}]`}}else P.accelerator=void 0;return P}$(m,P,D=!P.accelerator){D&&(P=this.Z(m,P));const I=P.click;return P.click=(O,M,W)=>{this.bb(m),I?.(O,M,W)},P}ab(m,P){this.w.openExternal(void 0,m),this.bb(P)}bb(m){this.r.publicLog2("workbenchActionExecuted",{id:m,from:s})}cb(m){return(0,R.$Pw)(m,!this.C)}};e.$Sdc=i,e.$Sdc=i=r=ke([ne(0,h.$uX),ne(1,d.$7i),ne(2,a.$Scc),ne(3,p.$Hcc),ne(4,g.$6l),ne(5,t.$Qdc),ne(6,b.$0P),ne(7,v.$_cc),ne(8,$.$7j),ne(9,y.$Edc),ne(10,w.$nk),ne(11,c.$Ddc)],i);function o(){return new n.MenuItem({type:"separator"})}}),define(re[309],oe([0,1,6,20,5,308]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=e.$Tdc=void 0,e.$Tdc=(0,n.$Ai)("menubarMainService");let j=class{constructor(u,c,d){this.b=u,this.c=c,this.d=d,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.$Sdc)}async updateMenubar(u,c){this.d.trace("menubarService#updateMenubar",u),(await this.a).updateMenu(c,u)}};e.$Udc=j,e.$Udc=j=ke([ne(0,n.$zi),ne(1,A.$_cc),ne(2,S.$7j)],j)}),define(re[310],oe([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t,r,s,i,o,l,m,P,D,I,O,M,W,N,T,U,ie,te,ae,K,J,q,L,z,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;function ce(Y){return(0,ie.$Pi)(Y?.workspace)}function V(Y){return(0,ie.$Ki)(Y?.workspace)}let le=class extends p.$Uc{constructor(C,F,_,B,Z,x,ee,G,ue,fe,we,Ee,Oe,ye,ve,Ce,me,X,he,ge){super(),this.s=C,this.t=F,this.u=_,this.w=B,this.z=Z,this.C=x,this.D=ee,this.F=G,this.G=ue,this.H=fe,this.I=we,this.J=Ee,this.L=Oe,this.M=ye,this.N=ve,this.O=Ce,this.P=me,this.Q=X,this.R=he,this.S=ge,this.a=this.B(new u.$he),this.onDidOpenWindow=this.a.event,this.b=this.B(new u.$he),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new u.$he),this.onDidDestroyWindow=this.c.event,this.f=this.B(new u.$he),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new u.$he),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new u.$he),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new u.$he),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new u.$he),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new U.$fec(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(C=>this.b.fire(C.window))),this.B(this.onDidSignalReadyWindow(C=>{if(C.config?.extensionDevelopmentPath||C.config?.extensionTestsPath){const F=new p.$Tc;if(F.add(u.Event.any(C.onDidClose,C.onDidDestroy)(()=>F.dispose())),C.config.extensionDevelopmentPath)for(const _ of C.config.extensionDevelopmentPath)F.add(this.Q.addValidFileRoot(_));C.config.extensionTestsPath&&F.add(this.Q.addValidFileRoot(C.config.extensionTestsPath))}}))}openEmptyWindow(C,F){const _=this.F.args,B=F?.remoteAuthority||void 0,Z=!0,x=F?.forceReuseWindow,ee=!x;return this.open({...C,cli:_,forceEmpty:Z,forceNewWindow:ee,forceReuseWindow:x,remoteAuthority:B})}openExistingWindow(C,F){C.focus(),this.W(F,[C])}async open(C){this.w.trace("windowsManager#open"),C.addMode&&(C.initialStartup||!this.getLastActiveWindow())&&(C.addMode=!1);const F=[],_=[],B=[],Z=[],x=[];let ee,G=0;const ue=await this.cb(C);this.w.trace("windowsManager#open pathsToOpen",ue);for(const ye of ue)V(ye)?C.addMode?F.push(ye):_.push(ye):ce(ye)?B.push(ye):ye.fileUri?(ee||(ee={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ye.remoteAuthority}),ee.filesToOpenOrCreate.push(ye)):ye.backupPath?x.push({backupFolder:(0,$.$nc)(ye.backupPath),remoteAuthority:ye.remoteAuthority}):G++;C.diffMode&&ee&&ee.filesToOpenOrCreate.length>=2&&(ee.filesToDiff=ee.filesToOpenOrCreate.slice(0,2),ee.filesToOpenOrCreate=[]),C.mergeMode&&ee&&ee.filesToOpenOrCreate.length===4&&(ee.filesToMerge=ee.filesToOpenOrCreate.slice(0,4),ee.filesToOpenOrCreate=[],ee.filesToDiff=[]),ee&&C.waitMarkerFileURI&&(ee.filesToWait={paths:(0,j.$Hb)([...ee.filesToDiff,ee.filesToMerge[3],...ee.filesToOpenOrCreate]),waitMarkerFileUri:C.waitMarkerFileURI}),C.initialStartup?(Z.push(...this.M.getUntitledWorkspaces()),B.push(...Z),x.push(...this.I.getEmptyWindowBackups())):x.length=0;const{windows:fe,filesOpenedInWindow:we}=await this.X(C,B,_,x,G,ee,F);if(this.w.trace(`windowsManager#open used window count ${fe.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${_.length}, emptyToRestore: ${x.length}, emptyToOpen: ${G})`),fe.length>1)if(we)we.focus();else{const ye=this.r.state.lastActiveWindow&&!C.forceEmpty&&!C.cli._.length&&!C.cli["file-uri"]&&!C.cli["folder-uri"]&&!(C.urisToOpen&&C.urisToOpen.length);let ve=!0,Ce=!0;if(ye){const me=fe.filter(X=>this.r.state.lastActiveWindow&&X.backupPath===this.r.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),ve=!1,Ce=!1)}if(ve)for(let me=fe.length-1;me>=0;me--){const X=fe[me];if(!(X.openedWorkspace&&Z.some(he=>X.openedWorkspace&&he.workspace.id===X.openedWorkspace.id)||X.backupPath&&x.some(he=>X.backupPath&&he.backupFolder===(0,$.$nc)(X.backupPath)))){X.focus(),Ce=!1;break}}Ce&&fe[fe.length-1].focus()}const Ee=ee&&ee.filesToDiff.length>0,Oe=ee&&ee.filesToMerge.length>0;if(!fe.some(ye=>ye.isExtensionDevelopmentHost)&&!Ee&&!Oe&&!C.noRecentEntry){const ye=[];for(const ve of ue)ce(ve)&&!ve.transient?ye.push({label:ve.label,workspace:ve.workspace,remoteAuthority:ve.remoteAuthority}):V(ve)?ye.push({label:ve.label,folderUri:ve.workspace.uri,remoteAuthority:ve.remoteAuthority}):ve.fileUri&&ye.push({label:ve.label,fileUri:ve.fileUri,remoteAuthority:ve.remoteAuthority});this.L.addRecentlyOpened(ye)}return this.W(C,fe),fe}W(C,F){const _=C.waitMarkerFileURI;C.context===0&&_&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(C,F,_,B,Z,x,ee){const G=[];let ue;function fe(me,X){G.push(me),X&&(ue=me,x=void 0)}let{openFolderInNewWindow:we,openFilesInNewWindow:Ee}=this.ob(C);if(!C.initialStartup&&ee.length>0){const me=ee[0].remoteAuthority,X=this.ub(me);X&&fe(this.$(X,ee.map(he=>he.workspace.uri)))}const Oe=_.length+F.length+B.length;if(x&&Oe===0){const me=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],X=this.getWindows().filter(ge=>x&&(0,b.$gh)(ge.remoteAuthority,x.remoteAuthority));let he;me?.fileUri&&!Ee&&((C.context===4||C.context===0||C.context===1)&&(he=await(0,T.$Xcc)(X,me.fileUri,async ge=>ge.configPath.scheme===v.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),he||(he=this.vb(X))),he?(0,ie.$Pi)(he.openedWorkspace)?F.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):(0,ie.$Ki)(he.openedWorkspace)?_.push({workspace:he.openedWorkspace,remoteAuthority:he.remoteAuthority}):fe(this.Y(C,he,x),!0):fe(await this.pb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:C.forceNewTabbedWindow,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile}),!0)}const ye=(0,j.$Mb)(F,me=>me.workspace.id);if(ye.length>0){const me=(0,j.$Hb)(ye.map(X=>(0,T.$Ycc)(this.getWindows(),X.workspace.configPath)));if(me.length>0){const X=me[0],he=(0,b.$gh)(x?.remoteAuthority,X.remoteAuthority)?x:void 0;fe(this.Y(C,X,he),!!he),we=!0}for(const X of ye){if(me.some(Se=>Se.openedWorkspace&&Se.openedWorkspace.id===X.workspace.id))continue;const he=X.remoteAuthority,ge=(0,b.$gh)(x?.remoteAuthority,he)?x:void 0;fe(await this.bb(C,X,we,ge),!!ge),we=!0}}const ve=(0,j.$Mb)(_,me=>b.$5g.getComparisonKey(me.workspace.uri));if(ve.length>0){const me=(0,j.$Hb)(ve.map(X=>(0,T.$Ycc)(this.getWindows(),X.workspace.uri)));if(me.length>0){const X=me[0],he=(0,b.$gh)(x?.remoteAuthority,X.remoteAuthority)?x:void 0;fe(this.Y(C,X,he),!!he),we=!0}for(const X of ve){if(me.some(Se=>(0,ie.$Ki)(Se.openedWorkspace)&&b.$5g.isEqual(Se.openedWorkspace.uri,X.workspace.uri)))continue;const he=X.remoteAuthority,ge=(0,b.$gh)(x?.remoteAuthority,he)?x:void 0;fe(await this.bb(C,X,we,ge),!!ge),we=!0}}const Ce=(0,j.$Mb)(B,me=>me.backupFolder);if(Ce.length>0)for(const me of Ce){const X=me.remoteAuthority,he=(0,b.$gh)(x?.remoteAuthority,X)?x:void 0;fe(await this.ab(C,!0,X,he,me),!!he),we=!0}if(G.length===0||x){x&&!Z&&Z++;const me=x?x.remoteAuthority:C.remoteAuthority;for(let X=0;X<Z;X++)fe(await this.ab(C,we,me,x),!!x),we=!0}return{windows:(0,j.$Mb)(G),filesOpenedInWindow:ue}}Y(C,F,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(F);const B={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:C?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",k.CancellationToken.None,B),F}Z(C){let F=C;const _=n.BrowserWindow.getFocusedWindow();if(_&&_.id!==C.id){const B=this.S.getWindowByWebContents(_.webContents);B&&B.parentId===C.id&&(F=B)}F.focus()}$(C,F){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),C.focus();const _={foldersToAdd:F};return C.sendWhenReady("vscode:addFolders",k.CancellationToken.None,_),C}ab(C,F,_,B,Z){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Z,remoteAuthority:_,filesToOpen:B,forceNewWindow:F});let x;return!F&&typeof C.contextWindowId=="number"&&(x=this.getWindowById(C.contextWindowId)),this.pb({userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:_,forceNewWindow:F,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:B,windowToUse:x,emptyWindowBackupInfo:Z,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}bb(C,F,_,B,Z){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:B}),!_&&!Z&&typeof C.contextWindowId=="number"&&(Z=this.getWindowById(C.contextWindowId)),this.pb({workspace:F.workspace,userEnv:C.userEnv,cli:C.cli,initialStartup:C.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:C.forceNewTabbedWindow,filesToOpen:B,windowToUse:Z,forceProfile:C.forceProfile,forceTempProfile:C.forceTempProfile})}async cb(C){let F,_=!1,B=!1;if(C.urisToOpen&&C.urisToOpen.length>0?(F=await this.db(C),_=!0):C.forceEmpty?F=[Object.create(null)]:C.cli._.length||C.cli["folder-uri"]||C.cli["file-uri"]?(F=await this.eb(C.cli),F.length===0&&F.push(Object.create(null)),_=!0):(F=await this.gb(),F.length===0&&F.push(Object.create(null)),B=!0),!C.addMode&&_){const Z=F.filter(x=>V(x));if(Z.length>1){const x=Z[0].remoteAuthority;if(Z.every(ee=>(0,b.$gh)(ee.remoteAuthority,x))){const ee=await this.M.createUntitledWorkspace(Z.map(G=>({uri:G.workspace.uri})));F.push({workspace:ee,remoteAuthority:x}),F=F.filter(G=>!V(G))}}}if(C.initialStartup&&!B&&this.J.getValue("window")?.restoreWindows==="preserve"){const Z=await this.gb();F.unshift(...Z.filter(x=>ce(x)||V(x)||x.backupPath))}return F}async db(C){const F={gotoLineMode:C.gotoLineMode,remoteAuthority:C.remoteAuthority},_=await Promise.all((0,j.$Hb)(C.urisToOpen||[]).map(async B=>{const Z=await this.ib(B,F);if(Z)return Z.label=B.label,Z;const x=this.kb(B);this.O.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:x.scheme===v.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:x.scheme===v.Schemas.file?(0,E.localize)(3,null,(0,d.$Jw)(x,{os:y.OS,tildify:this.F})):(0,E.localize)(4,null,x.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,j.$Hb)(_)}async eb(C){const F=[],_={ignoreFileNotFound:!0,gotoLineMode:C.goto,remoteAuthority:C.remote||void 0,forceOpenWorkspaceAsFile:C.diff&&C._.length===2||C.merge&&C._.length===4},B=C["folder-uri"];if(B){const ee=await Promise.all(B.map(G=>{const ue=this.fb(G);if(ue)return this.ib({folderUri:ue},_)}));F.push(...(0,j.$Hb)(ee))}const Z=C["file-uri"];if(Z){const ee=await Promise.all(Z.map(G=>{const ue=this.fb(G);if(ue)return this.ib((0,ie.$6i)(G)?{workspaceUri:ue}:{fileUri:ue},_)}));F.push(...(0,j.$Hb)(ee))}const x=await Promise.all(C._.map(ee=>_.remoteAuthority?this.nb(ee,_):this.lb(ee,_)));return F.push(...(0,j.$Hb)(x)),F}fb(C){try{const F=h.URI.parse(C);if(!F.scheme){this.w.error(`Invalid URI input string, scheme missing: ${C}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.w.error(`Invalid URI input string: ${C}, ${F.message}`)}}async gb(){const C=this.hb();switch(C){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];C!=="one"&&F.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&F.push(this.r.state.lastActiveWindow);const _=await Promise.all(F.map(async B=>{if(B.workspace){const Z=await this.ib({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});if(ce(Z))return Z}else if(B.folderUri){const Z=await this.ib({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});if(V(Z))return Z}else if(C!=="folders"&&B.backupPath)return{backupPath:B.backupPath,remoteAuthority:B.remoteAuthority}}));return(0,j.$Hb)(_)}}}hb(){let C;return this.H.wasRestarted?C="all":(C=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(C)||(C="all")),C}async ib(C,F=Object.create(null)){const _=this.kb(C);return _.scheme===v.Schemas.file?((0,M.$KD)(C)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,F)):this.jb(C,F)}jb(C,F){let _=this.kb(C);const B=(0,I.$Lm)(_)||F.remoteAuthority;if(_=(0,b.$ih)((0,b.$ch)(_)),(0,M.$KD)(C)){if(F.gotoLineMode){const{path:Z,line:x,column:ee}=(0,c.$Hg)(_.path);return{fileUri:_.with({path:Z}),options:{selection:x?{startLineNumber:x,startColumn:ee||1}:void 0},remoteAuthority:B}}return{fileUri:_,remoteAuthority:B}}else if((0,M.$ID)(C))return{workspace:(0,te.$2cc)(_),remoteAuthority:B};return{workspace:(0,te.$3cc)(_),remoteAuthority:B}}kb(C){return(0,M.$ID)(C)?C.workspaceUri:(0,M.$JD)(C)?C.folderUri:C.fileUri}async lb(C,F,_){let B,Z;F.gotoLineMode&&({path:C,line:B,column:Z}=(0,c.$Hg)(C)),C=(0,c.$Bg)((0,$.$hc)(C),(0,w.cwd)());try{const x=await A.Promises.stat(C);if(x.isFile()){if(!F.forceOpenWorkspaceAsFile){const ee=await this.M.resolveLocalWorkspace(h.URI.file(C));if(ee)return ee.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:ee.id,configPath:ee.configPath},type:i.FileType.File,exists:!0,remoteAuthority:ee.remoteAuthority,transient:ee.transient}}return{fileUri:h.URI.file(C),type:i.FileType.File,exists:!0,options:{selection:B?{startLineNumber:B,startColumn:Z||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,te.$3cc)(h.URI.file(C),x),type:i.FileType.Directory,exists:!0};if(!y.$i&&C==="/dev/null")return{fileUri:h.URI.file(C),type:i.FileType.File,exists:!0}}}catch(x){if(x.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(C,F);const ee=h.URI.file(C);if(this.L.removeRecentlyOpened([ee]),F.ignoreFileNotFound)return{fileUri:ee,type:i.FileType.File,exists:!1}}}async mb(C,F){const _=h.URI.file(C),{response:B,checkboxChecked:Z}=await this.O.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,_.authority),detail:(0,E.localize)(9,null,(0,d.$Jw)(_,{os:y.OS,tildify:this.F})),checkboxLabel:(0,E.localize)(10,null,_.authority),cancelId:1});if(B===0){if((0,S.addUNCHostToAllowlist)(_.authority),Z){const x={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(x.channel,x.args),this.sendToOpeningWindow(x.channel,x.args)}return this.lb(C,F,!0)}if(B===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(C,F)}nb(C,F){const _=C.charCodeAt(0),B=F.remoteAuthority;let Z,x;F.gotoLineMode&&({path:C,line:Z,column:x}=(0,c.$Hg)(C)),_!==47&&((0,c.$Ag)(_)&&C.charCodeAt(C.charCodeAt(1))===58&&(C=(0,c.$tg)(C)),C=`/${C}`);const ee=h.URI.from({scheme:v.Schemas.vscodeRemote,authority:B,path:C});if(C.charCodeAt(C.length-1)!==47){if((0,ie.$6i)(C))return F.forceOpenWorkspaceAsFile?{fileUri:ee,options:{selection:Z?{startLineNumber:Z,startColumn:x||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,te.$2cc)(ee),remoteAuthority:B};if(F.gotoLineMode||$.$gc.basename(C).indexOf(".")!==-1)return{fileUri:ee,options:{selection:Z?{startLineNumber:Z,startColumn:x||1}:void 0},remoteAuthority:B}}return{workspace:(0,te.$3cc)(ee),remoteAuthority:B}}ob(C){const F=this.J.getValue("window"),_=F?.openFoldersInNewWindow||"default",B=F?.openFilesInNewWindow||"off";let Z=(C.preferNewWindow||C.forceNewWindow)&&!C.forceReuseWindow;!C.forceNewWindow&&!C.forceReuseWindow&&(_==="on"||_==="off")&&(Z=_==="on");let x=!1;return C.forceNewWindow||C.forceReuseWindow?x=!!C.forceNewWindow&&!C.forceReuseWindow:(y.$j?C.context===1&&(x=!0):C.context!==3&&C.context!==2&&!(C.userEnv&&C.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!C.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(x=B==="on")),{openFolderInNewWindow:!!Z,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(C,F){const _=(0,T.$Zcc)(this.getWindows(),C);if(_)return this.H.reload(_,F.cli),_.focus(),[_];let B=F.cli["folder-uri"]||[],Z=F.cli["file-uri"]||[],x=F.cli._;if(!x.length&&!B.length&&!Z.length&&!F.cli.extensionTestsPath){const ue=this.r.state.lastPluginDevelopmentHostWindow,fe=ue?.workspace??ue?.folderUri;fe&&(h.URI.isUri(fe)?fe.scheme===v.Schemas.file?x=[fe.fsPath]:B=[fe.toString()]:fe.configPath.scheme===v.Schemas.file?x=[(0,b.$2g)(fe.configPath)]:Z=[fe.configPath.toString()])}let ee=F.remoteAuthority;for(const ue of C)if(ue.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const fe=h.URI.parse(ue),we=(0,I.$Lm)(fe);we&&(ee?(0,b.$gh)(we,ee)||this.w.error("more than one extension development path authority"):ee=we)}x=x.filter(ue=>{const fe=h.URI.file(ue);return(0,T.$Ycc)(this.getWindows(),fe)?!1:(0,b.$gh)((0,I.$Lm)(fe),ee)}),B=B.filter(ue=>{const fe=this.fb(ue);return fe&&(0,T.$Ycc)(this.getWindows(),fe)?!1:fe?(0,b.$gh)((0,I.$Lm)(fe),ee):!1}),Z=Z.filter(ue=>{const fe=this.fb(ue);return fe&&(0,T.$Ycc)(this.getWindows(),fe)?!1:fe?(0,b.$gh)((0,I.$Lm)(fe),ee):!1}),F.cli._=x,F.cli["folder-uri"]=B,F.cli["file-uri"]=Z;const G={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!x.length&&!B.length&&!Z.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:ee,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(G)}async pb(C){const F=this.J.getValue("window"),_=this.getLastActiveWindow(),B=_?.profile??this.G.defaultProfile;let Z;!C.forceNewWindow&&!C.forceNewTabbedWindow&&(Z=C.windowToUse||_,Z&&Z.focus());const x={...this.F.args,...C.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:C.emptyWindowBackupInfo?(0,$.$jc)(this.F.backupHome,C.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:B},homeDir:this.F.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:C.remoteAuthority,workspace:C.workspace,userEnv:{...this.u,...C.userEnv},filesToOpenOrCreate:C.filesToOpen?.filesToOpenOrCreate,filesToDiff:C.filesToOpen?.filesToDiff,filesToMerge:C.filesToOpen?.filesToMerge,filesToWait:C.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:v.Schemas.file}).fsPath,product:P.default,isInitialStartup:C.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Z){const ee=Z.config;!x.extensionDevelopmentPath&&ee?.extensionDevelopmentPath&&(x.extensionDevelopmentPath=ee.extensionDevelopmentPath,x.extensionDevelopmentKind=ee.extensionDevelopmentKind,x["enable-proposed-api"]=ee["enable-proposed-api"],x.verbose=ee.verbose,x["inspect-extensions"]=ee["inspect-extensions"],x["inspect-brk-extensions"]=ee["inspect-brk-extensions"],x.debugId=ee.debugId,x.extensionEnvironment=ee.extensionEnvironment,x["extensions-dir"]=ee["extensions-dir"],x["disable-extensions"]=ee["disable-extensions"]),x.loggers={global:x.loggers.global,window:ee?.loggers.window??x.loggers.window}}else{const ee=this.r.getNewWindowState(x);(0,f.mark)("code/willCreateCodeWindow");const G=Z=this.N.createInstance(W.$0cc,{state:ee,extensionDevelopmentPath:x.extensionDevelopmentPath,isExtensionTestHost:!!x.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),C.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(G),this.n.set(G.id,G),this.a.fire(G),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ue=new p.$Tc;ue.add(G.onDidSignalReady(()=>this.b.fire(G))),ue.add(u.Event.once(G.onDidClose)(()=>this.sb(G,ue))),ue.add(u.Event.once(G.onDidDestroy)(()=>this.tb(G))),ue.add(G.onDidMaximize(()=>this.g.fire(G))),ue.add(G.onDidUnmaximize(()=>this.h.fire(G))),ue.add(G.onDidEnterFullScreen(()=>this.j.fire({window:G,fullscreen:!0}))),ue.add(G.onDidLeaveFullScreen(()=>this.j.fire({window:G,fullscreen:!1}))),ue.add(G.onDidTriggerSystemContextMenu(({x:we,y:Ee})=>this.m.fire({window:G,x:we,y:Ee})));const fe=(0,g.$lg)(G.win?.webContents);fe.removeAllListeners("devtools-reload-page"),ue.add(u.Event.fromNodeEventEmitter(fe,"devtools-reload-page")(()=>this.H.reload(G))),this.H.registerWindow(G)}return x.windowId=Z.id,Z.isReady?this.H.unload(Z,4).then(async ee=>{ee||await this.qb(Z,x,C,B)}):await this.qb(Z,x,C,B),Z}async qb(C,F,_,B){if(F.extensionDevelopmentPath||((0,ie.$Pi)(F.workspace)?F.backupPath=this.I.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,ie.$Ki)(F.workspace)?F.backupPath=this.I.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,te.$4cc)().id,remoteAuthority:F.remoteAuthority})),this.G.isEnabled()){const Z=F.workspace??(0,ie.$Oi)(F.backupPath,!1),x=this.rb(_,Z,B),ee=x instanceof Promise?await x:x;F.profiles.profile=ee,F.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Z,ee)}C.load(F)}rb(C,F,_){return C.forceProfile?this.G.profiles.find(B=>B.name===C.forceProfile)??this.G.createNamedProfile(C.forceProfile):C.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(F)??_}sb(C,F){this.n.delete(C.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}tb(C){this.n.delete(C.id),this.c.fire(C)}getFocusedWindow(){const C=n.BrowserWindow.getFocusedWindow();if(C)return this.getWindowById(C.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(C){return this.vb(this.getWindows().filter(F=>(0,b.$gh)(F.remoteAuthority,C)))}vb(C){return(0,N.$Ucc)(C)}sendToFocused(C,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(C,k.CancellationToken.None,...F)}sendToOpeningWindow(C,...F){this.B(u.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(C,k.CancellationToken.None,...F)}))}sendToAll(C,F,_){for(const B of this.getWindows())_&&_.indexOf(B.id)>=0||B.sendWhenReady(C,k.CancellationToken.None,F)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(C){return this.n.get(C)}getWindowByWebContents(C){const F=n.BrowserWindow.fromWebContents(C);if(!F)return;const _=this.getWindowById(F.id);return _?.matches(C)?_:void 0}};e.$iec=le,e.$iec=le=ke([ne(3,m.$7j),ne(4,z.$7cc),ne(5,O.$0P),ne(6,q.$jo),ne(7,s.$Hcc),ne(8,L.$Vcc),ne(9,l.$_cc),ne(10,a.$Mcc),ne(11,t.$7i),ne(12,ae.$Qdc),ne(13,K.$5cc),ne(14,o.$zi),ne(15,r.$Ncc),ne(16,i.$7k),ne(17,D.$Pcc),ne(18,J.$Qcc),ne(19,H.$Ddc)],le)}),define(re[311],oe([0,1,65,29,85,58]),function(Q,e,n,A,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;let j=class{constructor(u,c,d,p){this.a=u,this.b=c,this.c=d,this.d=p,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(u,c){const d=this.b.getWindowById(u);if(d)return this.a.enterWorkspace(d,this.b.getWindows(),c)}createUntitledWorkspace(u,c,d){return this.a.createUntitledWorkspace(c,d)}deleteUntitledWorkspace(u,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(u,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(u){return this.c.getRecentlyOpened()}addRecentlyOpened(u,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(u,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(u){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$kec=j,e.$kec=j=ke([ne(0,R.$5cc),ne(1,A.$Scc),ne(2,S.$Qdc),ne(3,n.$Mcc)],j)}),define(re[312],oe([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t,r,s,i,o,l,m,P,D,I,O,M,W,N,T,U,ie,te,ae,K,J,q,L,z,H,ce,V,le,Y,C,F,_,B,Z,x,ee,G,ue,fe,we,Ee,Oe,ye,ve,Ce,me,X,he,ge,Se,De,Ne,Me,Fe,Be,He,Xe,Te,xe,Ge,se,de,$e,be,je,Le,Qe,Ze,_e,st,Ye,ot,rt,ct,lt,kt,St,Pt,ut,$t,jt,It,Dt,ht,At,wt,ft,Ct,Rt,dt,Ot,pt,Mt,bt){"use strict";var gt;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;let mt=class extends $.$Uc{static{gt=this}static{this.a={[f.Schemas.file]:"security.promptForLocalFileProtocolHandling",[f.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Pe,Ie,Re,pe,Ae,ze,qe,Je,We,Ue,Ve,Ke){super(),this.g=Pe,this.h=Ie,this.j=Re,this.m=pe,this.n=Ae,this.s=ze,this.t=qe,this.u=Je,this.w=We,this.y=Ue,this.z=Ve,this.C=Ke,this.D(),this.F()}D(){const Pe=We=>We?.startsWith(`${f.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((We,Ue,Ve,Ke)=>Pe(Ke.requestingUrl)?Ve(Ie.has(Ue)):Ve(!1)),n.session.defaultSession.setPermissionCheckHandler((We,Ue,Ve,Ke)=>Pe(Ke.requestingUrl)?Ie.has(Ue):!1);const Re=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,f.Schemas.vscodeManagedRemoteResource,"devtools"]),pe=We=>{for(let Ue=We;Ue;Ue=Ue.parent)if(Ue.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Ae=We=>We.resourceType==="xhr"||pe(We.frame),ze=We=>{const Ue=We.frame;if(!Ue||!this.b)return!1;const Ve=n.BrowserWindow.getAllWindows();for(const Ke of Ve)if(Ue.processId===Ke.webContents.mainFrame.processId)return!0;return!1},qe=(We,Ue)=>{if(We.path!=="/index.html")return!0;const Ve=Ue.frame;if(!Ve||!this.b)return!1;for(const Ke of this.b.getWindows())if(Ke.win&&Ve.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((We,Ue)=>{const Ve=g.URI.parse(We.url);return Ve.scheme===f.Schemas.vscodeWebview&&!qe(Ve,We)?(this.m.error("Blocked vscode-webview request",We.url),Ue({cancel:!0})):Ve.scheme===f.Schemas.vscodeFileResource&&!ze(We)?(this.m.error("Blocked vscode-file request",We.url),Ue({cancel:!0})):Ve.path.endsWith(".svg")&&!Re.has(Ve.scheme)?Ue({cancel:!Ae(We)}):Ue({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ue)=>{const Ve=We.responseHeaders,Ke=Ve["content-type"]||Ve["Content-Type"];if(Ke&&Array.isArray(Ke)){const et=g.URI.parse(We.url);if(et.path.endsWith(".svg")&&Re.has(et.scheme))return Ve["Content-Type"]=["image/svg+xml"],Ue({cancel:!1,responseHeaders:Ve});if(!et.path.endsWith(f.Schemas.vscodeRemoteResource)&&Ke.some(nt=>nt.toLowerCase().includes("image/svg")))return Ue({cancel:!Ae(We)})}return Ue({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ue)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=We.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],Ue({cancel:!1,responseHeaders:Ve})}return Ue({cancel:!1})});const Je=n.session.defaultSession;typeof Je.setCodeCachePath=="function"&&this.s.codeCachePath&&Je.setCodeCachePath((0,y.$jc)(this.s.codeCachePath,"chrome")),w.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,u.setUnexpectedErrorHandler)(Re=>this.H(Re)),process.on("uncaughtException",Re=>{(0,u.$Z)(Re)||(0,u.$1)(Re)}),process.on("unhandledRejection",Re=>(0,u.$1)(Re)),this.t.onWillShutdown(()=>this.dispose()),(0,E.$nW)(),n.app.on("accessibility-support-changed",(Re,pe)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",pe)}),n.app.on("activate",async(Re,pe)=>{this.m.trace("app#activate"),pe||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Re,pe)=>{pe?.opener?.url.startsWith(`${f.Schemas.vscodeFileResource}://${f.$Tg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(pe)),pe.on("will-navigate",Ae=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),pe.setWindowOpenHandler(Ae=>Ae.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ae)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ae.url}}`),this.f?.openExternal(void 0,Ae.url),{action:"deny"}))});let Pe=[],Ie;n.app.on("open-file",(Re,pe)=>{pe=(0,bt.$fm)(pe),this.m.trace("app#open-file: ",pe),Re.preventDefault(),Pe.push((0,be.$6i)(pe)?{workspaceUri:g.URI.file(pe)}:{fileUri:g.URI.file(pe)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ie=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),S.$mW.handle("vscode:fetchShellEnv",Re=>{const pe=this.b?.getWindowByWebContents(Re.sender);let Ae,ze;return pe?.config?(Ae=pe.config,ze={...process.env,...pe.config.userEnv}):(Ae=this.s.args,ze=process.env),this.X(Ae,ze,!1)}),S.$mW.handle("vscode:writeNlsFile",(Re,pe,Ae)=>{const ze=this.G([pe]);if(!ze||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(ze,j.$Je.fromString(Ae))}),S.$mW.handle("vscode:readNlsFile",async(Re,...pe)=>{const Ae=this.G(pe);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ae)).value.toString()}),S.$mW.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),S.$mW.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),S.$mW.on("vscode:reloadWindow",Re=>Re.sender.reload()),S.$mW.handle("vscode:notifyZoomLevel",async(Re,pe)=>{const Ae=this.b?.getWindowByWebContents(Re.sender);Ae&&Ae.notifyZoomLevel(pe)})}G(Pe){let Ie;for(const Re of Pe)typeof Re=="string"&&(typeof Ie!="string"?Ie=Re:Ie=(0,y.$jc)(Ie,Re));if(!(typeof Ie!="string"||!(0,y.$ic)(Ie)||!(0,c.$zg)(Ie,this.s.cachedLanguagesPath,!w.$k)))return g.URI.file(Ie)}H(Pe){if(Pe){const Ie={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.m.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.m.error(Pe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Pe=this.z.win32AppUserModelId;w.$i&&Pe&&n.app.setAppUserModelId(Pe);try{w.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.m.error(Ue)}const Ie=new t.$tW;this.t.onWillShutdown(Ue=>{Ue.reason===2&&Ie.dispose()}),this.m.trace("Resolving machine identifier...");const[Re,pe]=await Promise.all([(0,$t.$sec)(this.w,this.m),(0,$t.$tec)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Re}`);const{sharedProcessReady:Ae,sharedProcessClient:ze}=this.P(Re,pe),qe=await this.Q(Re,pe,Ae);this.B(qe.createInstance(s.$jdc)),this.B(qe.createInstance(St.$oec)),qe.invokeFunction(Ue=>this.R(Ue,Ie,ze));const Je=await qe.invokeFunction(Ue=>this.I(Ue,Ie));this.J(Ie),this.t.phase=2,await qe.invokeFunction(Ue=>this.S(Ue,Je)),this.t.phase=3,this.U(),this.B(new ut.$Mh(()=>{this.B((0,ut.$Qh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Pe,Ie){const Re=this.b=Pe.get(se.$Scc),pe=Pe.get(Fe.$kX),Ae=this.f=Pe.get(x.$Edc),ze=Pe.get(O.$Ncc),qe=this;pe.registerHandler({async handleURL(et,nt){return qe.O(Re,ze,pe,et,nt)}});const Je=this.B(new $e.$jec({onDidOpenMainWindow:Ae.onDidOpenMainWindow,onDidFocusMainWindow:Ae.onDidFocusMainWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),We=new a.$ii(et=>Je.getActiveClientId().then(nt=>et===nt)),Ue=new Be.$aec(We,this.m),Ve=Ie.getChannel("urlHandler",Ue);pe.registerHandler(new Be.$_dc(Ve));const Ke=await this.L(Re,ze);return this.B(new Xe.$bec(Ke?.urls,pe,Re,this.s,this.z,this.m)),Ke}J(Pe){const Ie=()=>({statusCode:404,data:"Not found"}),Re=new Ot.$V(()=>Pe.getChannel(dt.$Aec,new dt.$Bec));n.protocol.registerBufferProtocol(f.Schemas.vscodeManagedRemoteResource,(pe,Ae)=>{const ze=g.URI.parse(pe.url);if(!ze.authority.startsWith("window:"))return Ae(Ie());Re.value.call(dt.$zec,[ze]).then(qe=>Ae({...qe,data:Buffer.from(qe.body,"base64")}),qe=>{this.m.warn("error dispatching remote resource call",qe),Ae({statusCode:500,data:String(qe)})})})}async L(Pe,Ie){const Re=this.s.args["open-url"]?this.s.args._urls||[]:[];Re.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Re);const pe=global.getOpenUrls()||[];if(pe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",pe),Re.length+pe.length===0)return;const Ae=[...Re,...pe].map(Je=>{try{return{uri:g.URI.parse(Je),originalUrl:Je}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Je);return}}),ze=[],qe=[];for(const Je of Ae){if(!Je)continue;const We=this.N(Je.uri);if(We)if(await this.M(We,Pe,Ie)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Je.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Je.uri.toString(!0),We),ze.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Je.uri.toString(!0)),qe.push(Je)}return{urls:qe,openables:ze}}async M(Pe,Ie,Re){let pe,Ae;if((0,Ge.$ID)(Pe)?(pe=Pe.workspaceUri,Ae=(0,i.localize)(0,null,pe.scheme===f.Schemas.file?(0,v.$Jw)(pe,{os:w.OS,tildify:this.s}):pe.toString(!0),this.z.nameShort)):(0,Ge.$JD)(Pe)?(pe=Pe.folderUri,Ae=(0,i.localize)(1,null,pe.scheme===f.Schemas.file?(0,v.$Jw)(pe,{os:w.OS,tildify:this.s}):pe.toString(!0),this.z.nameShort)):(pe=Pe.fileUri,Ae=(0,i.localize)(2,null,pe.scheme===f.Schemas.file?(0,v.$Jw)(pe,{os:w.OS,tildify:this.s}):pe.toString(!0),this.z.nameShort)),pe.scheme!==f.Schemas.file&&pe.scheme!==f.Schemas.vscodeRemote||this.u.getValue(gt.a[pe.scheme])===!1)return!1;const{response:qe,checkboxChecked:Je}=await Re.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ae,detail:(0,i.localize)(5,null),checkboxLabel:pe.scheme===f.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(qe!==0)return!0;if(Je){const We={channel:"vscode:disablePromptForProtocolHandling",args:pe.scheme===f.Schemas.file?"local":"remote"};Ie.sendToFocused(We.channel,We.args),Ie.sendToOpeningWindow(We.channel,We.args)}return!1}N(Pe){if(Pe.path){if(Pe.authority===f.Schemas.file){const Ie=g.URI.file(Pe.fsPath);return(0,be.$6i)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Pe.authority===f.Schemas.vscodeRemote){const Ie=Pe.path.indexOf(y.$gc.sep,1);if(Ie!==-1){const Re=Pe.path.substring(1,Ie),pe=Pe.path.substring(Ie);let Ae=Pe.query;const ze=new URLSearchParams(Pe.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Ae=ze.toString());const qe=g.URI.from({scheme:f.Schemas.vscodeRemote,authority:Re,path:pe,query:Ae,fragment:Pe.fragment});return(0,be.$6i)(pe)?{workspaceUri:qe}:/:[\d]+$/.test(pe)?{fileUri:qe}:{folderUri:qe}}}}}async O(Pe,Ie,Re,pe,Ae){this.m.trace("app#handleProtocolUrl():",pe.toString(!0),Ae),pe.scheme===this.z.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:g.URI.parse(pe.query).path,query:""}));let ze=!1;const qe=new URLSearchParams(pe.query);qe.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),qe.delete("windowId"),pe=pe.with({query:qe.toString()}),ze=!0):w.$j&&Pe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),ze=!0);const Je=qe.get("continueOn");Je!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),qe.delete("continueOn"),pe=pe.with({query:qe.toString()}),this.s.continueOn=Je??void 0);const We=this.N(pe);return We?await this.M(We,Pe,Ie)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,pe.toString(!0)),(0,wt.$Ob)(await Pe.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,wt.$Ob)(await Pe.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,G.$Lm)(pe)}))?.ready(),Re.open(pe,Ae)):(this.m.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Ae),!1)}P(Pe,Ie){const Re=this.B(this.j.createInstance(ue.$Ydc,Pe,Ie));this.B(Re.onDidCrash(()=>this.b?.sendToFocused("vscode:reportSharedProcessCrash")));const pe=(async()=>{this.m.trace("Main->SharedProcess#connect");const ze=await Re.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new r.$uW(ze,"main")})();return{sharedProcessReady:(async()=>(await Re.whenReady(),pe))(),sharedProcessClient:pe}}async Q(Pe,Ie,Re){const pe=new V.$yi;switch(process.platform){case"win32":pe.set(he.$uX,new H.$xi(Me.$0dc));break;case"linux":w.$l?pe.set(he.$uX,new H.$xi(Ne.$9dc,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(he.$uX,new H.$xi(De.$8dc));break;case"darwin":pe.set(he.$uX,new H.$xi(Se.$7dc));break}pe.set(se.$Scc,new H.$xi(de.$iec,[Pe,Ie,this.h],!1)),pe.set(pt.$Ddc,new H.$xi(Mt.$Cec,void 0,!1));const Ae=new O.$Occ(this.m,this.z);pe.set(O.$Ncc,Ae),pe.set(F.$Kdc,new H.$xi(F.$Ldc,void 0,!1)),pe.set(I.$pdc,new H.$xi(I.$qdc,void 0,!1)),pe.set(D.$hn,a.ProxyChannel.toService((0,a.$gi)(Re.then(Ue=>Ue.getChannel("diagnostics"))))),pe.set(le.$7W,new H.$xi(Y.$Gdc,[this.h])),pe.set(M.$eX,new H.$xi(W.$rdc)),pe.set(C.$Hdc,new H.$xi(C.$Idc)),pe.set(x.$Edc,new H.$xi(x.$Fdc,void 0,!1)),pe.set(Te.$cec,new H.$xi(xe.$eec)),pe.set(Z.$Tdc,new H.$xi(Z.$Udc)),pe.set(ie.$sdc,new H.$xi(te.$udc)),pe.set(Oe.$fdc,new H.$xi(Oe.$gdc)),pe.set(Oe.$hdc,new H.$xi(Oe.$idc));const ze=new Ct.$yec({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),qe=new Rt.$Cs(ze,this.u,this.m,this.n);pe.set(ft.$ds,qe),w.$i?pe.set(ae.$vdc,new H.$xi(K.$wdc)):w.$j?pe.set(ae.$vdc,new H.$xi(K.$xdc)):w.$k&&pe.set(ae.$vdc,new H.$xi(K.$ydc));const Je=new l.$kdc(this.s,this.u,this.m,this.w);pe.set(o.$Mcc,Je);const We=new Ze.$6cc(this.s,this.m,this.C,Je,Ae);if(pe.set(Ze.$5cc,We),pe.set(je.$agb,new H.$xi(Qe.$kec,void 0,!1)),pe.set(Le.$Qdc,new H.$xi(Le.$Rdc,void 0,!1)),pe.set(Fe.$kX,new H.$xi(He.$mX,void 0,!1)),(0,X.$sp)(this.z,this.s)){const Ue=(0,X.$xp)(this.z,this.u),Ve=(0,a.$gi)(Re.then(at=>at.getChannel("telemetryAppender"))),Ke=new Ce.$2dc(Ve),et=(0,ye.$jp)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,Pe,Ie,Ue),nt=(0,X.$yp)(this.s),tt={appenders:[Ke],commonProperties:et,piiPaths:nt,sendErrorTelemetry:!0};pe.set(ve.$6l,new H.$xi(me.$6r,[tt],!1))}else pe.set(ve.$6l,X.$np);return pe.set(ct.$vq,new H.$xi(jt.$eQ,void 0,!0)),pe.set(lt.$zq,new H.$xi(kt.$nec,void 0,!0)),pe.set(ht.$wec,new H.$xi(ht.$xec,void 0,!0)),await ut.Promises.settled([Je.initialize(),We.initialize()]),this.j.createChild(pe)}R(Pe,Ie,Re){const pe=this.B(new $.$Tc),Ae=a.ProxyChannel.fromService(Pe.get(F.$Kdc),pe,{disableMarshalling:!0});this.g.registerChannel("launch",Ae);const ze=a.ProxyChannel.fromService(Pe.get(I.$pdc),pe,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const qe=pe.add(new st.$lec(Pe.get(_e.$jo)));Ie.registerChannel("policy",qe),Re.then(it=>it.registerChannel("policy",qe));const Je=this.y.getProvider(f.Schemas.file);(0,b.$kg)(Je instanceof z.$fr);const We=pe.add(new L.$zdc(Je,this.m,this.s));Ie.registerChannel(J.$ZP,We),Re.then(it=>it.registerChannel(J.$ZP,We));const Ue=a.ProxyChannel.fromService(Pe.get(Ye.$Vcc),pe);Ie.registerChannel("userDataProfiles",Ue),Re.then(it=>it.registerChannel("userDataProfiles",Ue));const Ve=new ot.$1r(Pe.get(rt.$Tp));Re.then(it=>it.registerChannel("request",Ve));const Ke=new ge.$3dc(Pe.get(he.$uX));Ie.registerChannel("update",Ke);const et=a.ProxyChannel.fromService(Pe.get(le.$7W),pe);Ie.registerChannel("issue",et);const nt=a.ProxyChannel.fromService(Pe.get(M.$eX),pe);Ie.registerChannel("encryption",nt);const tt=a.ProxyChannel.fromService(Pe.get(fe.$Tl),pe);Ie.registerChannel("sign",tt);const at=a.ProxyChannel.fromService(Pe.get(C.$Hdc),pe);Ie.registerChannel("keyboardLayout",at),this.f=Pe.get(x.$Edc);const yt=a.ProxyChannel.fromService(this.f,pe);Ie.registerChannel("nativeHost",yt),Re.then(it=>it.registerChannel("nativeHost",yt));const Lt=a.ProxyChannel.fromService(Pe.get(je.$agb),pe);Ie.registerChannel("workspaces",Lt);const Ft=a.ProxyChannel.fromService(Pe.get(Z.$Tdc),pe);Ie.registerChannel("menubar",Ft);const Wt=a.ProxyChannel.fromService(Pe.get(Fe.$kX),pe);Ie.registerChannel("url",Wt);const Ut=a.ProxyChannel.fromService(Pe.get(Te.$cec),pe);Ie.registerChannel("webview",Ut);const vt=pe.add(new Ee.$Zdc(this.m,Pe.get(Oe.$fdc)));Ie.registerChannel("storage",vt),Re.then(it=>it.registerChannel("storage",vt));const Nt=pe.add(new Pt.$pec(Pe.get(Oe.$fdc),Pe.get(Ye.$Vcc),this.m));Re.then(it=>it.registerChannel("profileStorageListener",Nt));const Tt=a.ProxyChannel.fromService(Pe.get(ft.$ds),pe);Ie.registerChannel(ft.TerminalIpcChannels.LocalPty,Tt);const zt=a.ProxyChannel.fromService(Pe.get(ae.$vdc),pe);Ie.registerChannel("externalTerminal",zt);const Et=new It.$uec(Pe.get(Dt.$7cc));Ie.registerChannel("logger",Et),Re.then(it=>it.registerChannel("logger",Et));const Bt=new P.$ldc(Pe.get(se.$Scc));Ie.registerChannel("extensionhostdebugservice",Bt);const qt=a.ProxyChannel.fromService(Pe.get(ie.$sdc),pe);Ie.registerChannel(ie.$tdc,qt);const Ht=a.ProxyChannel.fromService(Pe.get(ht.$wec),pe);Ie.registerChannel(At.$vec,Ht)}async S(Pe,Ie){const Re=this.b=Pe.get(se.$Scc);this.c=Pe.get(pt.$Ddc);const pe=(0,T.$Em)(process.env)?0:4,Ae=this.s.args;if(Ie){if(Ie.openables.length>0)return Re.open({context:pe,cli:Ae,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const tt of Ie.urls){const at=new URLSearchParams(tt.uri.query);if(at.get("windowId")==="_blank")return at.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:at.toString()}),Re.open({context:pe,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,qe=Ae._.length,Je=!!Ae["folder-uri"],We=!!Ae["file-uri"],Ue=Ae["skip-add-to-recently-opened"]===!0,Ve=Ae.wait&&Ae.waitMarkerFilePath?g.URI.file(Ae.waitMarkerFilePath):void 0,Ke=Ae.remote||void 0,et=Ae.profile,nt=Ae["profile-temp"];if(!qe&&!Je&&!We){if(Ae["new-window"]||et||nt)return Re.open({context:pe,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ue,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ke,forceProfile:et,forceTempProfile:nt});if(ze.length)return Re.open({context:1,cli:Ae,urisToOpen:ze.map(tt=>(tt=(0,bt.$fm)(tt),(0,be.$6i)(tt)?{workspaceUri:g.URI.file(tt)}:{fileUri:g.URI.file(tt)})),noRecentEntry:Ue,waitMarkerFileURI:Ve,initialStartup:!0})}return Re.open({context:pe,cli:Ae,forceNewWindow:Ae["new-window"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:Ue,waitMarkerFileURI:Ve,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:et,forceTempProfile:nt})}U(){this.W(),n.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(Pe,Ie)=>{Ie({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Pe=this.z.win32MutexName;if(w.$i&&Pe)try{const Ie=await new Promise((pe,Ae)=>{Q(["@vscode/windows-mutex"],pe,Ae)}),Re=new Ie.Mutex(Pe);d.Event.once(this.t.onWillShutdown)(()=>Re.release())}catch(Ie){this.m.error(Ie)}}async X(Pe,Ie,Re){try{return await(0,U.$Km)(this.u,this.m,Pe,Ie)}catch(pe){const Ae=(0,k.$lj)(pe);Re?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.m.error(Ae)}return{}}async Y(){try{const Ie=(await this.y.readFile(this.s.argvResource)).value.toString(),Re=JSON.parse((0,p.$Vn)(Ie)),Ae=(0,X.$up)(this.u)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.$Wg)()}"`,"}"],qe=Ie.substring(0,Ie.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,j.$Je.fromString(qe))}else{const ze=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);ze!==Ie&&await this.y.writeFile(this.s.argvResource,j.$Je.fromString(ze))}}catch(Pe){this.m.error(Pe)}}};e.$Dec=mt,e.$Dec=mt=gt=ke([ne(2,ce.$zi),ne(3,B.$7j),ne(4,B.$8j),ne(5,N.$Hcc),ne(6,_.$_cc),ne(7,m.$7i),ne(8,we.$0P),ne(9,q.$7k),ne(10,ee.$nk),ne(11,Ye.$Vcc)],mt)}),define(re[317],oe([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(Q,e,n,A,S,R,j,k,u,c,d,p,v,$,f,y,w,b,g,h,E,a,t,r,s,i,o,l,m,P,D,I,O,M,W,N,T,U,ie,te,ae,K,J,q,L,z,H,ce,V,le,Y,C,F,_,B,Z,x,ee,G,ue,fe,we,Ee,Oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(me){console.error(me.message),n.app.exit(1)}}async a(){(0,u.setUnexpectedErrorHandler)(Fe=>console.error(Fe));const[me,X,he,ge,Se,De,Ne,Me]=this.b();try{try{await this.d(he,Me,ge,Se,Ne)}catch(Fe){throw this.g(he,Ne,Fe),Fe}await me.invokeFunction(async Fe=>{const Be=Fe.get(U.$7j),He=Fe.get(N.$_cc),Xe=Fe.get(P.$7k),Te=Fe.get(U.$8j),xe=await this.f(Be,he,He,me,Ne,!0);return g.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Ge=>{Be.warn(`app#startup(): Error writing main lockfile: ${Ge.stack}`)}),De.logger=Te.createLogger("main",{name:(0,t.localize)(0,null)}),d.Event.once(He.onWillShutdown)(Ge=>{Xe.dispose(),ge.dispose(),Ge.join("instanceLockfile",g.Promises.unlink(he.mainLockfile).catch(()=>{}))}),me.createInstance(a.$Dec,xe,X).startup()})}catch(Fe){me.invokeFunction(this.j,Fe)}}b(){const me=new W.$yi,X=new Z.$Tc;process.once("exit",()=>X.dispose());const he={_serviceBrand:void 0,...ie.default};me.set(te.$nk,he);const ge=new o.$Icc(this.k(),he),Se=this.c(ge);me.set(o.$Hcc,ge);const De=new G.$8cc((0,U.$ik)(ge),ge.logsHome);me.set(G.$7cc,De);const Ne=new T.$oac(De.getLogLevel()),Me=X.add(new ue.$fQ(Ne,[new U.$bk(De.getLogLevel())]));me.set(U.$7j,Me);const Fe=new D.$Oq(Me);me.set(P.$7k,Fe);const Be=new I.$fr(Me);Fe.registerProvider(v.Schemas.file,Be);const He=new ee.$Gs(Fe);me.set(x.$El,He);const Xe=new we.$aQ(1,ge,Me,Fe);me.set(V.$9P,Xe),me.set(V.$0P,Xe);const Te=new C.$Wcc(Xe,He,ge,Fe,Me);me.set(C.$Vcc,Te),Fe.registerProvider(v.Schemas.vscodeUserData,new Ee.$Oec(v.Schemas.file,Be,v.Schemas.vscodeUserData,Te,He,Me));const xe=y.$i&&he.win32RegValueName?X.add(new _.$Mec(Me,he.win32RegValueName)):ge.policyFile?X.add(new B.$Nec(ge.policyFile,Fe,Me)):new F.$lo;me.set(F.$jo,xe);const Ge=new s.$Lo(Te.defaultProfile.settingsResource,Fe,xe,Me);return me.set(r.$7i,Ge),me.set(N.$_cc,new O.$xi(N.$adc,void 0,!1)),me.set(L.$Tp,new O.$xi(z.$Kec,void 0,!0)),me.set(Y.$Qcc,new O.$xi(Y.$Rcc)),me.set(H.$Tl,new O.$xi(ce.$Lec,void 0,!1)),me.set(J.$ow,new O.$xi(q.$Iec)),me.set(ae.$Pcc,new K.$Fec(ge,Te,Me)),[new M.$ir(me,!0),Se,ge,Ge,Xe,Ne,he,Te]}c(me){const X={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const ge=process.env[he];typeof ge=="string"&&(X[he]=ge)}),Object.assign(process.env,X),X}async d(me,X,he,ge,Se){await j.Promises.settled([Promise.all([this.e(me.extensionsPath),me.codeCachePath,me.logsHome.with({scheme:v.Schemas.file}).fsPath,X.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,me.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,me.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,me.backupHome].map(De=>De?g.Promises.mkdir(De,{recursive:!0}):void 0)),ge.init(),he.initialize()]),X.init()}e(me){if(y.$i){const X=(0,Oe.getUNCHost)(me);X&&(0,Oe.addUNCHostToAllowlist)(X)}return me}async f(me,X,he,ge,Se,De){let Ne;try{(0,f.mark)("code/willStartMainServer"),Ne=await(0,E.$vi)(X.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),d.Event.once(he.onWillShutdown)(()=>Ne.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(X,Se,Me),Me;let Fe;try{Fe=await(0,E.$wi)(X.mainIPCHandle,"main")}catch(Te){if(!De||y.$i||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.h((0,t.localize)(1,null,Se.nameShort),(0,t.localize)(2,null),Se),Te;try{(0,A.unlinkSync)(X.mainIPCHandle)}catch(xe){throw me.warn("Could not delete obsolete instance handle",xe),xe}return this.f(me,X,he,ge,Se,!1)}if(X.extensionTestsLocationURI&&!X.debugExtensionHost.break){const Te=`Running extension tests from the command line is currently only supported if no other instance of ${Se.nameShort} is running.`;throw me.error(Te),Fe.dispose(),new Error(Te)}let Be;!X.args.wait&&!X.args.status&&(Be=setTimeout(()=>{this.h((0,t.localize)(3,null,Se.nameShort),(0,t.localize)(4,null),Se)},1e4));const He=h.ProxyChannel.toService(Fe.getChannel("launch"),{disableMarshalling:!0}),Xe=h.ProxyChannel.toService(Fe.getChannel("diagnostics"),{disableMarshalling:!0});if(X.args.status)return ge.invokeFunction(async()=>{const Te=new i.$Ns(le.$np,Se),xe=await Xe.getMainDiagnostics(),Ge=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),se=await Te.getDiagnostics(xe,Ge);throw console.log(se),new u.$ab});throw y.$i&&await this.i(He,me),me.trace("Sending env to running instance..."),await He.start(X.args,process.env),Fe.dispose(),Be&&clearTimeout(Be),new u.$ab("Sent env to running instance. Terminating...")}if(X.args.status)throw console.log((0,t.localize)(5,null,Se.nameShort)),new u.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ne}g(me,X,he){if(he.code==="EACCES"||he.code==="EPERM"){const ge=(0,R.$Hb)([me.userDataPath,me.extensionsPath,E.$ri]).map(Se=>(0,p.$Jw)(S.URI.file(Se),{os:y.OS,tildify:me}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,k.$lj)(he),ge.join(`
`)),X)}}h(me,X,he){n.dialog.showMessageBoxSync((0,fe.$Xw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:me,detail:X},he).options)}async i(me,X){if(y.$i){const he=await me.getMainProcessId();X.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((ge,Se)=>{Q(["windows-foreground-love"],ge,Se)})).allowSetForegroundWindow(he)}catch(ge){X.error(ge)}}}j(me,X){const he=me.get(U.$7j),ge=me.get(N.$_cc);let Se=0;X&&(X.isExpected?X.message&&he.trace(X.message):(Se=1,X.stack?he.error(X.stack):he.error(`Startup error: ${X.toString()}`))),ge.kill(Se)}k(){const me=this.l((0,l.$Bm)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const X=(0,m.$Eec)(me.verbose);X&&((0,l.$Dm)(process.argv,"--waitMarkerFilePath",X),me.waitMarkerFilePath=X)}return me}l(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const X=this.m(me._,me.goto);me._=X}return me}m(me,X){const he=(0,w.cwd)(),ge=me.map(Ne=>{let Me=String(Ne),Fe;X&&(Fe=(0,c.$Hg)(Me),Me=Fe.path),Me&&(Me=this.n(he,Me));const Be=(0,c.$Bg)(Me,he),He=(0,$.$nc)(Be);return He&&!(0,c.$xg)(He)?null:X&&Fe?(Fe.path=Be,this.o(Fe)):Be}),Se=y.$i||y.$j,De=(0,R.$Mb)(ge,Ne=>Ne&&Se?Ne.toLowerCase():Ne||"");return(0,R.$Hb)(De)}n(me,X){return y.$i&&(X=(0,b.$jf)(X,'"')),X=(0,b.$hf)((0,b.$hf)(X," "),"	"),y.$i&&(X=(0,$.$kc)(me,X),X=(0,b.$jf)(X,".")),X}o(me){const X=[me.path];return typeof me.line=="number"&&X.push(String(me.line)),typeof me.column=="number"&&X.push(String(me.column)),X.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/code/electron-main/main.js.map
