/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/base/common/types","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],ve=function(se){for(var t=[],i=0,C=se.length;i<C;i++)t[i]=we[se[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:xt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:at,seal:gt,create:ri}=Object,{apply:Nt,construct:Rt}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,i,C){return t.apply(i,C)}),at||(at=function(t){return t}),gt||(gt=function(t){return t}),Rt||(Rt=function(t,i){return new t(...i)});const oi=dt(Array.prototype.forEach),zt=dt(Array.prototype.pop),yt=dt(Array.prototype.push),St=dt(String.prototype.toLowerCase),It=dt(String.prototype.toString),ai=dt(String.prototype.match),mt=dt(String.prototype.replace),li=dt(String.prototype.indexOf),hi=dt(String.prototype.trim),ct=dt(RegExp.prototype.test),Dt=ui(TypeError);function dt(se){return function(t){for(var i=arguments.length,C=new Array(i>1?i-1:0),B=1;B<i;B++)C[B-1]=arguments[B];return Nt(se,t,C)}}function ui(se){return function(){for(var t=arguments.length,i=new Array(t),C=0;C<t;C++)i[C]=arguments[C];return Rt(se,i)}}function He(se,t,i){var C;i=(C=i)!==null&&C!==void 0?C:St,xt&&xt(se,null);let B=t.length;for(;B--;){let U=t[B];if(typeof U=="string"){const E=i(U);E!==U&&(ii(t)||(t[B]=E),U=E)}se[U]=!0}return se}function pt(se){const t=ri(null);for(const[i,C]of Bt(se))t[i]=C;return t}function kt(se,t){for(;se!==null;){const C=si(se,t);if(C){if(C.get)return dt(C.get);if(typeof C.value=="function")return dt(C.value)}se=ni(se)}function i(C){return console.warn("fallback value for",C),null}return i}const Ut=at(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=at(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),jt=at(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=at(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Mt=at(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=at(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ht=at(["#text"]),Wt=at(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=at(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Vt=at(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),At=at(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=gt(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=gt(/<%[\w\W]*|[\w\W]*%>/gm),mi=gt(/\${[\w\W]*}/gm),bi=gt(/^data-[\-\w.\u00B7-\uFFFF]/),$i=gt(/^aria-[\-\w]+$/),qt=gt(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=gt(/^(?:\w+script|data):/i),wi=gt(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Kt=gt(/^html$/i);var Qt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Kt});const vi=()=>typeof window>"u"?null:window,yi=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let C=null;const B="data-tt-policy-suffix";i&&i.hasAttribute(B)&&(C=i.getAttribute(B));const U="dompurify"+(C?"#"+C:"");try{return t.createPolicy(U,{createHTML(E){return E},createScriptURL(E){return E}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function Gt(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Be=>Gt(Be);if(t.version="3.0.5",t.removed=[],!se||!se.document||se.document.nodeType!==9)return t.isSupported=!1,t;const i=se.document,C=i.currentScript;let{document:B}=se;const{DocumentFragment:U,HTMLTemplateElement:E,Node:A,Element:d,NodeFilter:g,NamedNodeMap:$=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:P,DOMParser:c,trustedTypes:l}=se,e=d.prototype,n=kt(e,"cloneNode"),o=kt(e,"nextSibling"),f=kt(e,"childNodes"),h=kt(e,"parentNode");if(typeof E=="function"){const Be=B.createElement("template");Be.content&&Be.content.ownerDocument&&(B=Be.content.ownerDocument)}let v,m="";const{implementation:b,createNodeIterator:r,createDocumentFragment:p,getElementsByTagName:S}=B,{importNode:F}=i;let I={};t.isSupported=typeof Bt=="function"&&typeof h=="function"&&b&&b.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:H,ERB_EXPR:w,TMPLIT_EXPR:j,DATA_ATTR:W,ARIA_ATTR:N,IS_SCRIPT_OR_DATA:x,ATTR_WHITESPACE:M}=Qt;let{IS_ALLOWED_URI:Q}=Qt,ie=null;const ue=He({},[...Ut,...Lt,...jt,...Mt,...Ht]);let G=null;const ee=He({},[...Wt,...Ot,...Vt,...At]);let de=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),ye=null,Ae=null,je=!0,le=!0,_=!1,fe=!0,he=!1,Fe=!1,Z=!1,pe=!1,Se=!1,Re=!1,re=!1,me=!0,J=!1;const O="user-content-";let u=!0,y=!1,a={},D=null;const R=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let s=null;const k=He({},["audio","video","img","source","image","track"]);let T=null;const L=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),z="http://www.w3.org/1998/Math/MathML",Y="http://www.w3.org/2000/svg",q="http://www.w3.org/1999/xhtml";let te=q,ce=!1,oe=null;const Te=He({},[z,Y,q],It);let ke;const Me=["application/xhtml+xml","text/html"],Ee="text/html";let Ne,Ue=null;const Ye=B.createElement("form"),_e=function(ge){return ge instanceof RegExp||ge instanceof Function},et=function(ge){if(!(Ue&&Ue===ge)){if((!ge||typeof ge!="object")&&(ge={}),ge=pt(ge),ke=Me.indexOf(ge.PARSER_MEDIA_TYPE)===-1?ke=Ee:ke=ge.PARSER_MEDIA_TYPE,Ne=ke==="application/xhtml+xml"?It:St,ie="ALLOWED_TAGS"in ge?He({},ge.ALLOWED_TAGS,Ne):ue,G="ALLOWED_ATTR"in ge?He({},ge.ALLOWED_ATTR,Ne):ee,oe="ALLOWED_NAMESPACES"in ge?He({},ge.ALLOWED_NAMESPACES,It):Te,T="ADD_URI_SAFE_ATTR"in ge?He(pt(L),ge.ADD_URI_SAFE_ATTR,Ne):L,s="ADD_DATA_URI_TAGS"in ge?He(pt(k),ge.ADD_DATA_URI_TAGS,Ne):k,D="FORBID_CONTENTS"in ge?He({},ge.FORBID_CONTENTS,Ne):R,ye="FORBID_TAGS"in ge?He({},ge.FORBID_TAGS,Ne):{},Ae="FORBID_ATTR"in ge?He({},ge.FORBID_ATTR,Ne):{},a="USE_PROFILES"in ge?ge.USE_PROFILES:!1,je=ge.ALLOW_ARIA_ATTR!==!1,le=ge.ALLOW_DATA_ATTR!==!1,_=ge.ALLOW_UNKNOWN_PROTOCOLS||!1,fe=ge.ALLOW_SELF_CLOSE_IN_ATTR!==!1,he=ge.SAFE_FOR_TEMPLATES||!1,Fe=ge.WHOLE_DOCUMENT||!1,Se=ge.RETURN_DOM||!1,Re=ge.RETURN_DOM_FRAGMENT||!1,re=ge.RETURN_TRUSTED_TYPE||!1,pe=ge.FORCE_BODY||!1,me=ge.SANITIZE_DOM!==!1,J=ge.SANITIZE_NAMED_PROPS||!1,u=ge.KEEP_CONTENT!==!1,y=ge.IN_PLACE||!1,Q=ge.ALLOWED_URI_REGEXP||qt,te=ge.NAMESPACE||q,de=ge.CUSTOM_ELEMENT_HANDLING||{},ge.CUSTOM_ELEMENT_HANDLING&&_e(ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(de.tagNameCheck=ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&_e(ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(de.attributeNameCheck=ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&typeof ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(de.allowCustomizedBuiltInElements=ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),he&&(le=!1),Re&&(Se=!0),a&&(ie=He({},[...Ht]),G=[],a.html===!0&&(He(ie,Ut),He(G,Wt)),a.svg===!0&&(He(ie,Lt),He(G,Ot),He(G,At)),a.svgFilters===!0&&(He(ie,jt),He(G,Ot),He(G,At)),a.mathMl===!0&&(He(ie,Mt),He(G,Vt),He(G,At))),ge.ADD_TAGS&&(ie===ue&&(ie=pt(ie)),He(ie,ge.ADD_TAGS,Ne)),ge.ADD_ATTR&&(G===ee&&(G=pt(G)),He(G,ge.ADD_ATTR,Ne)),ge.ADD_URI_SAFE_ATTR&&He(T,ge.ADD_URI_SAFE_ATTR,Ne),ge.FORBID_CONTENTS&&(D===R&&(D=pt(D)),He(D,ge.FORBID_CONTENTS,Ne)),u&&(ie["#text"]=!0),Fe&&He(ie,["html","head","body"]),ie.table&&(He(ie,["tbody"]),delete ye.tbody),ge.TRUSTED_TYPES_POLICY){if(typeof ge.TRUSTED_TYPES_POLICY.createHTML!="function")throw Dt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ge.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw Dt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');v=ge.TRUSTED_TYPES_POLICY,m=v.createHTML("")}else v===void 0&&(v=yi(l,C)),v!==null&&typeof m=="string"&&(m=v.createHTML(""));at&&at(ge),Ue=ge}},tt=He({},["mi","mo","mn","ms","mtext"]),We=He({},["foreignobject","desc","title","annotation-xml"]),X=He({},["title","style","font","a","script"]),ae=He({},Lt);He(ae,jt),He(ae,ci);const $e=He({},Mt);He($e,fi);const De=function(ge){let Ie=h(ge);(!Ie||!Ie.tagName)&&(Ie={namespaceURI:te,tagName:"template"});const Oe=St(ge.tagName),Ke=St(Ie.tagName);return oe[ge.namespaceURI]?ge.namespaceURI===Y?Ie.namespaceURI===q?Oe==="svg":Ie.namespaceURI===z?Oe==="svg"&&(Ke==="annotation-xml"||tt[Ke]):!!ae[Oe]:ge.namespaceURI===z?Ie.namespaceURI===q?Oe==="math":Ie.namespaceURI===Y?Oe==="math"&&We[Ke]:!!$e[Oe]:ge.namespaceURI===q?Ie.namespaceURI===Y&&!We[Ke]||Ie.namespaceURI===z&&!tt[Ke]?!1:!$e[Oe]&&(X[Oe]||!ae[Oe]):!!(ke==="application/xhtml+xml"&&oe[ge.namespaceURI]):!1},Le=function(ge){yt(t.removed,{element:ge});try{ge.parentNode.removeChild(ge)}catch{ge.remove()}},ze=function(ge,Ie){try{yt(t.removed,{attribute:Ie.getAttributeNode(ge),from:Ie})}catch{yt(t.removed,{attribute:null,from:Ie})}if(Ie.removeAttribute(ge),ge==="is"&&!G[ge])if(Se||Re)try{Le(Ie)}catch{}else try{Ie.setAttribute(ge,"")}catch{}},Qe=function(ge){let Ie,Oe;if(pe)ge="<remove></remove>"+ge;else{const ut=ai(ge,/^[\r\n\t ]+/);Oe=ut&&ut[0]}ke==="application/xhtml+xml"&&te===q&&(ge='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ge+"</body></html>");const Ke=v?v.createHTML(ge):ge;if(te===q)try{Ie=new c().parseFromString(Ke,ke)}catch{}if(!Ie||!Ie.documentElement){Ie=b.createDocument(te,"template",null);try{Ie.documentElement.innerHTML=ce?m:Ke}catch{}}const it=Ie.body||Ie.documentElement;return ge&&Oe&&it.insertBefore(B.createTextNode(Oe),it.childNodes[0]||null),te===q?S.call(Ie,Fe?"html":"body")[0]:Fe?Ie.documentElement:it},rt=function(ge){return r.call(ge.ownerDocument||ge,ge,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},nt=function(ge){return ge instanceof P&&(typeof ge.nodeName!="string"||typeof ge.textContent!="string"||typeof ge.removeChild!="function"||!(ge.attributes instanceof $)||typeof ge.removeAttribute!="function"||typeof ge.setAttribute!="function"||typeof ge.namespaceURI!="string"||typeof ge.insertBefore!="function"||typeof ge.hasChildNodes!="function")},ot=function(ge){return typeof A=="object"?ge instanceof A:ge&&typeof ge=="object"&&typeof ge.nodeType=="number"&&typeof ge.nodeName=="string"},Xe=function(ge,Ie,Oe){I[ge]&&oi(I[ge],Ke=>{Ke.call(t,Ie,Oe,Ue)})},ht=function(ge){let Ie;if(Xe("beforeSanitizeElements",ge,null),nt(ge))return Le(ge),!0;const Oe=Ne(ge.nodeName);if(Xe("uponSanitizeElement",ge,{tagName:Oe,allowedTags:ie}),ge.hasChildNodes()&&!ot(ge.firstElementChild)&&(!ot(ge.content)||!ot(ge.content.firstElementChild))&&ct(/<[/\w]/g,ge.innerHTML)&&ct(/<[/\w]/g,ge.textContent))return Le(ge),!0;if(!ie[Oe]||ye[Oe]){if(!ye[Oe]&&bt(Oe)&&(de.tagNameCheck instanceof RegExp&&ct(de.tagNameCheck,Oe)||de.tagNameCheck instanceof Function&&de.tagNameCheck(Oe)))return!1;if(u&&!D[Oe]){const Ke=h(ge)||ge.parentNode,it=f(ge)||ge.childNodes;if(it&&Ke){const ut=it.length;for(let Ze=ut-1;Ze>=0;--Ze)Ke.insertBefore(n(it[Ze],!0),o(ge))}}return Le(ge),!0}return ge instanceof d&&!De(ge)||(Oe==="noscript"||Oe==="noembed"||Oe==="noframes")&&ct(/<\/no(script|embed|frames)/i,ge.innerHTML)?(Le(ge),!0):(he&&ge.nodeType===3&&(Ie=ge.textContent,Ie=mt(Ie,H," "),Ie=mt(Ie,w," "),Ie=mt(Ie,j," "),ge.textContent!==Ie&&(yt(t.removed,{element:ge.cloneNode()}),ge.textContent=Ie)),Xe("afterSanitizeElements",ge,null),!1)},st=function(ge,Ie,Oe){if(me&&(Ie==="id"||Ie==="name")&&(Oe in B||Oe in Ye))return!1;if(!(le&&!Ae[Ie]&&ct(W,Ie))){if(!(je&&ct(N,Ie))){if(!G[Ie]||Ae[Ie]){if(!(bt(ge)&&(de.tagNameCheck instanceof RegExp&&ct(de.tagNameCheck,ge)||de.tagNameCheck instanceof Function&&de.tagNameCheck(ge))&&(de.attributeNameCheck instanceof RegExp&&ct(de.attributeNameCheck,Ie)||de.attributeNameCheck instanceof Function&&de.attributeNameCheck(Ie))||Ie==="is"&&de.allowCustomizedBuiltInElements&&(de.tagNameCheck instanceof RegExp&&ct(de.tagNameCheck,Oe)||de.tagNameCheck instanceof Function&&de.tagNameCheck(Oe))))return!1}else if(!T[Ie]){if(!ct(Q,mt(Oe,M,""))){if(!((Ie==="src"||Ie==="xlink:href"||Ie==="href")&&ge!=="script"&&li(Oe,"data:")===0&&s[ge])){if(!(_&&!ct(x,mt(Oe,M,"")))){if(Oe)return!1}}}}}}return!0},bt=function(ge){return ge.indexOf("-")>0},$t=function(ge){let Ie,Oe,Ke,it;Xe("beforeSanitizeAttributes",ge,null);const{attributes:ut}=ge;if(!ut)return;const Ze={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:G};for(it=ut.length;it--;){Ie=ut[it];const{name:ft,namespaceURI:wt}=Ie;if(Oe=ft==="value"?Ie.value:hi(Ie.value),Ke=Ne(ft),Ze.attrName=Ke,Ze.attrValue=Oe,Ze.keepAttr=!0,Ze.forceKeepAttr=void 0,Xe("uponSanitizeAttribute",ge,Ze),Oe=Ze.attrValue,Ze.forceKeepAttr||(ze(ft,ge),!Ze.keepAttr))continue;if(!fe&&ct(/\/>/i,Oe)){ze(ft,ge);continue}he&&(Oe=mt(Oe,H," "),Oe=mt(Oe,w," "),Oe=mt(Oe,j," "));const Ft=Ne(ge.nodeName);if(st(Ft,Ke,Oe)){if(J&&(Ke==="id"||Ke==="name")&&(ze(ft,ge),Oe=O+Oe),v&&typeof l=="object"&&typeof l.getAttributeType=="function"&&!wt)switch(l.getAttributeType(Ft,Ke)){case"TrustedHTML":{Oe=v.createHTML(Oe);break}case"TrustedScriptURL":{Oe=v.createScriptURL(Oe);break}}try{wt?ge.setAttributeNS(wt,ft,Oe):ge.setAttribute(ft,Oe),zt(t.removed)}catch{}}}Xe("afterSanitizeAttributes",ge,null)},Tt=function Be(ge){let Ie;const Oe=rt(ge);for(Xe("beforeSanitizeShadowDOM",ge,null);Ie=Oe.nextNode();)Xe("uponSanitizeShadowNode",Ie,null),!ht(Ie)&&(Ie.content instanceof U&&Be(Ie.content),$t(Ie));Xe("afterSanitizeShadowDOM",ge,null)};return t.sanitize=function(Be){let ge=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Ie,Oe,Ke,it;if(ce=!Be,ce&&(Be="<!-->"),typeof Be!="string"&&!ot(Be))if(typeof Be.toString=="function"){if(Be=Be.toString(),typeof Be!="string")throw Dt("dirty is not a string, aborting")}else throw Dt("toString is not a function");if(!t.isSupported)return Be;if(Z||et(ge),t.removed=[],typeof Be=="string"&&(y=!1),y){if(Be.nodeName){const ft=Ne(Be.nodeName);if(!ie[ft]||ye[ft])throw Dt("root node is forbidden and cannot be sanitized in-place")}}else if(Be instanceof A)Ie=Qe("<!---->"),Oe=Ie.ownerDocument.importNode(Be,!0),Oe.nodeType===1&&Oe.nodeName==="BODY"||Oe.nodeName==="HTML"?Ie=Oe:Ie.appendChild(Oe);else{if(!Se&&!he&&!Fe&&Be.indexOf("<")===-1)return v&&re?v.createHTML(Be):Be;if(Ie=Qe(Be),!Ie)return Se?null:re?m:""}Ie&&pe&&Le(Ie.firstChild);const ut=rt(y?Be:Ie);for(;Ke=ut.nextNode();)ht(Ke)||(Ke.content instanceof U&&Tt(Ke.content),$t(Ke));if(y)return Be;if(Se){if(Re)for(it=p.call(Ie.ownerDocument);Ie.firstChild;)it.appendChild(Ie.firstChild);else it=Ie;return(G.shadowroot||G.shadowrootmode)&&(it=F.call(i,it,!0)),it}let Ze=Fe?Ie.outerHTML:Ie.innerHTML;return Fe&&ie["!doctype"]&&Ie.ownerDocument&&Ie.ownerDocument.doctype&&Ie.ownerDocument.doctype.name&&ct(Kt,Ie.ownerDocument.doctype.name)&&(Ze="<!DOCTYPE "+Ie.ownerDocument.doctype.name+`>
`+Ze),he&&(Ze=mt(Ze,H," "),Ze=mt(Ze,w," "),Ze=mt(Ze,j," ")),v&&re?v.createHTML(Ze):Ze},t.setConfig=function(Be){et(Be),Z=!0},t.clearConfig=function(){Ue=null,Z=!1},t.isValidAttribute=function(Be,ge,Ie){Ue||et({});const Oe=Ne(Be),Ke=Ne(ge);return st(Oe,Ke,Ie)},t.addHook=function(Be,ge){typeof ge=="function"&&(I[Be]=I[Be]||[],yt(I[Be],ge))},t.removeHook=function(Be){if(I[Be])return zt(I[Be])},t.removeHooks=function(Be){I[Be]&&(I[Be]=[])},t.removeAllHooks=function(){I={}},t}var Di=Gt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(we[51],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$US=void 0,t.$VS=B;class i{constructor(E){this.domNode=E,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(E){const A=C(E);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(E){const A=C(E);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(E){const A=C(E);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(E){const A=C(E);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(E){const A=C(E);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(E){const A=C(E);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(E){const A=C(E);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(E){const A=C(E);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(E){const A=C(E);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(E){const A=C(E);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(E){const A=C(E);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(E){this.l!==E&&(this.l=E,this.domNode.style.fontFamily=this.l)}setFontWeight(E){this.m!==E&&(this.m=E,this.domNode.style.fontWeight=this.m)}setFontSize(E){const A=C(E);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(E){this.o!==E&&(this.o=E,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(E){this.p!==E&&(this.p=E,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(E){this.q!==E&&(this.q=E,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(E){this.r!==E&&(this.r=E,this.domNode.style.textDecoration=this.r)}setLineHeight(E){const A=C(E);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(E){const A=C(E);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(E){this.u!==E&&(this.u=E,this.domNode.className=this.u)}toggleClassName(E,A){this.domNode.classList.toggle(E,A),this.u=this.domNode.className}setDisplay(E){this.v!==E&&(this.v=E,this.domNode.style.display=this.v)}setPosition(E){this.w!==E&&(this.w=E,this.domNode.style.position=this.w)}setVisibility(E){this.x!==E&&(this.x=E,this.domNode.style.visibility=this.x)}setColor(E){this.y!==E&&(this.y=E,this.domNode.style.color=this.y)}setBackgroundColor(E){this.z!==E&&(this.z=E,this.domNode.style.backgroundColor=this.z)}setLayerHinting(E){this.A!==E&&(this.A=E,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(E){this.C!==E&&(this.C=E,this.domNode.style.boxShadow=E)}setContain(E){this.B!==E&&(this.B=E,this.domNode.style.contain=this.B)}setAttribute(E,A){this.domNode.setAttribute(E,A)}removeAttribute(E){this.domNode.removeAttribute(E)}appendChild(E){this.domNode.appendChild(E.domNode)}removeChild(E){this.domNode.removeChild(E.domNode)}}t.$US=i;function C(U){return typeof U=="number"?`${U}px`:U}function B(U){return new i(U)}}),define(we[79],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aR=void 0,t.$bR=U;const i=new WeakMap;function C(A){if(!A.parent||A.parent===A)return null;try{const d=A.location,g=A.parent.location;if(d.origin!=="null"&&g.origin!=="null"&&d.origin!==g.origin)return null}catch{return null}return A.parent}class B{static a(d){let g=i.get(d);if(!g){g=[],i.set(d,g);let $=d,P;do P=C($),P?g.push({window:new WeakRef($),iframeElement:$.frameElement||null}):g.push({window:new WeakRef($),iframeElement:null}),$=P;while($)}return g.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(d,g){if(!g||d===g)return{top:0,left:0};let $=0,P=0;const c=this.a(d);for(const l of c){const e=l.window.deref();if($+=e?.scrollY??0,P+=e?.scrollX??0,e===g||!l.iframeElement)break;const n=l.iframeElement.getBoundingClientRect();$+=n.top,P+=n.left}return{top:$,left:P}}}t.$aR=B;async function U(A,d){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const g=JSON.stringify({parentOrigin:A,salt:d}),P=new TextEncoder().encode(g),c=await crypto.subtle.digest("sha-256",P);return E(c)}function E(A){const g=Array.from(new Uint8Array(A)).map($=>$.toString(16).padStart(2,"0")).join("");return BigInt(`0x${g}`).toString(32).padStart(52,"0")}}),define(we[29],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2T=C,t.$3T=B;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null,triggerUpdatableHover:()=>{}};function C(U){i=U}function B(){return i}}),define(we[80],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ET=t.$DT=t.$CT=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(E){E[E.Copy=0]="Copy",E[E.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var C;(function(E){E.Over="drop-target",E.Before="drop-target-before",E.After="drop-target-after"})(C||(t.ListDragOverEffectPosition=C={})),t.$CT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class B extends Error{constructor(A,d){super(`ListError [${A}] ${d}`)}}t.$DT=B;class U{constructor(){this.c=new WeakMap}getHeight(A){return this.c.get(A)??this.d(A)}setDynamicHeight(A,d){d>0&&this.c.set(A,d)}}t.$ET=U}),define(we[81],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sT=void 0;class i{constructor(B){this.a=B}splice(B,U,E){this.a.forEach(A=>A.splice(B,U,E))}}t.$sT=i}),define(we[52],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1S=void 0;const i=20;class C{constructor(U,E,A,d,g,$){this.a=Math.round(E),this.b=Math.round(A),this.c=Math.round(U),this.d=d,this.e=g,this.f=$,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new C(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const E=Math.round(U);return this.d!==E?(this.d=E,this.m(),!0):!1}setScrollSize(U){const E=Math.round(U);return this.e!==E?(this.e=E,this.m(),!0):!1}setScrollPosition(U){const E=Math.round(U);return this.f!==E?(this.f=E,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,E,A,d,g){const $=Math.max(0,A-U),P=Math.max(0,$-2*E),c=d>0&&d>A;if(!c)return{computedAvailableSize:Math.round($),computedIsNeeded:c,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const l=Math.round(Math.max(i,Math.floor(A*P/d))),e=(P-l)/(d-A),n=g*e;return{computedAvailableSize:Math.round($),computedIsNeeded:c,computedSliderSize:Math.round(l),computedSliderRatio:e,computedSliderPosition:Math.round(n)}}m(){const U=C.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const E=U-this.c-this.i/2;return Math.round(E/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const E=U-this.c;let A=this.f;return E<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const E=this.k+U;return Math.round(E/this.j)}}t.$1S=C}),define(we[30],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BV=t.$AV=t.$zV=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var i;(function(d){d[d.Hidden=0]="Hidden",d[d.Visible=1]="Visible",d[d.Recurse=2]="Recurse"})(i||(t.TreeVisibility=i={}));var C;(function(d){d[d.Expanded=0]="Expanded",d[d.Collapsed=1]="Collapsed",d[d.PreserveOrExpanded=2]="PreserveOrExpanded",d[d.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(C||(t.ObjectTreeElementCollapseState=C={}));var B;(function(d){d[d.Unknown=0]="Unknown",d[d.Twistie=1]="Twistie",d[d.Element=2]="Element",d[d.Filter=3]="Filter"})(B||(t.TreeMouseEventTarget=B={}));var U;(function(d){d[d.Down=0]="Down",d[d.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$zV={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(d=!1){return{accept:!0,bubble:0,autoExpand:d}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(d=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:d}}};class E extends Error{constructor(g,$){super(`TreeError [${g}] ${$}`)}}t.$AV=E;class A{constructor(g){this.a=g,this.b=new WeakMap}map(g){let $=this.b.get(g);return $||($=this.a(g),this.b.set(g,$)),$}}t.$BV=A}),define(we[22],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QQ=void 0,t.$PQ=i,t.$RQ=C;function i(B,U){const E=B;typeof E.vscodeWindowId!="number"&&Object.defineProperty(E,"vscodeWindowId",{get:()=>U})}t.$QQ=window;function C(B){return B===t.$QQ?!1:typeof B?.vscodeWindowId=="number"}}),define(we[82],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=C,t.$hb=B,t.$ib=U,t.$jb=E,t.$kb=A,t.$lb=d,t.$nb=$,t.$ob=P,t.$pb=c,t.$qb=l,t.$rb=e;function i(n,o){const f=C(n,o);if(f!==-1)return n[f]}function C(n,o,f=n.length-1){for(let h=f;h>=0;h--){const v=n[h];if(o(v))return h}return-1}function B(n,o){const f=U(n,o);return f===-1?void 0:n[f]}function U(n,o,f=0,h=n.length){let v=f,m=h;for(;v<m;){const b=Math.floor((v+m)/2);o(n[b])?v=b+1:m=b}return v-1}function E(n,o){const f=A(n,o);return f===n.length?void 0:n[f]}function A(n,o,f=0,h=n.length){let v=f,m=h;for(;v<m;){const b=Math.floor((v+m)/2);o(n[b])?m=b:v=b+1}return v}function d(n,o,f=0,h=n.length){const v=A(n,o,f,h);return v===n.length?-1:v}class g{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(g.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!o(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const f=U(this.e,o,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}t.$mb=g;function $(n,o){if(n.length===0)return;let f=n[0];for(let h=1;h<n.length;h++){const v=n[h];o(v,f)>0&&(f=v)}return f}function P(n,o){if(n.length===0)return;let f=n[0];for(let h=1;h<n.length;h++){const v=n[h];o(v,f)>=0&&(f=v)}return f}function c(n,o){return $(n,(f,h)=>-o(f,h))}function l(n,o){if(n.length===0)return-1;let f=0;for(let h=1;h<n.length;h++){const v=n[h];o(v,n[f])>0&&(f=h)}return f}function e(n,o){for(const f of n){const h=o(f);if(h!==void 0)return h}}}),define(we[83],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=C,t.$M=B,t.$N=U;function i(E,A){const d=Object.create(null);for(const g of E){const $=A(g);let P=d[$];P||(P=d[$]=[]),P.push(g)}return d}function C(E,A){const d=[],g=[];for(const $ of E)A.has($)||d.push($);for(const $ of A)E.has($)||g.push($);return{removed:d,added:g}}function B(E,A){const d=[],g=[];for(const[$,P]of E)A.has($)||d.push(P);for(const[$,P]of A)E.has($)||g.push(P);return{removed:d,added:g}}function U(E,A){const d=new Set;for(const g of A)E.has(g)&&d.add(g);return d}}),define(we[84],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_t=t.$$t=t.$0t=t.$9t=void 0;function i(A,d){const g=Math.pow(10,d);return Math.round(A*g)/g}class C{constructor(d,g,$,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=i(Math.max(Math.min(1,P),0),3)}static equals(d,g){return d.r===g.r&&d.g===g.g&&d.b===g.b&&d.a===g.a}}t.$9t=C;class B{constructor(d,g,$,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.l=i(Math.max(Math.min(1,$),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(d,g){return d.h===g.h&&d.s===g.s&&d.l===g.l&&d.a===g.a}static fromRGBA(d){const g=d.r/255,$=d.g/255,P=d.b/255,c=d.a,l=Math.max(g,$,P),e=Math.min(g,$,P);let n=0,o=0;const f=(e+l)/2,h=l-e;if(h>0){switch(o=Math.min(f<=.5?h/(2*f):h/(2-2*f),1),l){case g:n=($-P)/h+($<P?6:0);break;case $:n=(P-g)/h+2;break;case P:n=(g-$)/h+4;break}n*=60,n=Math.round(n)}return new B(n,o,f,c)}static i(d,g,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?d+(g-d)*6*$:$<1/2?g:$<2/3?d+(g-d)*(2/3-$)*6:d}static toRGBA(d){const g=d.h/360,{s:$,l:P,a:c}=d;let l,e,n;if($===0)l=e=n=P;else{const o=P<.5?P*(1+$):P+$-P*$,f=2*P-o;l=B.i(f,o,g+1/3),e=B.i(f,o,g),n=B.i(f,o,g-1/3)}return new C(Math.round(l*255),Math.round(e*255),Math.round(n*255),c)}}t.$0t=B;class U{constructor(d,g,$,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=i(Math.max(Math.min(1,g),0),3),this.v=i(Math.max(Math.min(1,$),0),3),this.a=i(Math.max(Math.min(1,P),0),3)}static equals(d,g){return d.h===g.h&&d.s===g.s&&d.v===g.v&&d.a===g.a}static fromRGBA(d){const g=d.r/255,$=d.g/255,P=d.b/255,c=Math.max(g,$,P),l=Math.min(g,$,P),e=c-l,n=c===0?0:e/c;let o;return e===0?o=0:c===g?o=(($-P)/e%6+6)%6:c===$?o=(P-g)/e+2:o=(g-$)/e+4,new U(Math.round(o*60),n,c,d.a)}static toRGBA(d){const{h:g,s:$,v:P,a:c}=d,l=P*$,e=l*(1-Math.abs(g/60%2-1)),n=P-l;let[o,f,h]=[0,0,0];return g<60?(o=l,f=e):g<120?(o=e,f=l):g<180?(f=l,h=e):g<240?(f=e,h=l):g<300?(o=e,h=l):g<=360&&(o=l,h=e),o=Math.round((o+n)*255),f=Math.round((f+n)*255),h=Math.round((h+n)*255),new C(o,f,h,c)}}t.$$t=U;class E{static fromHex(d){return E.Format.CSS.parseHex(d)||E.red}static equals(d,g){return!d&&!g?!0:!d||!g?!1:d.equals(g)}get hsla(){return this.i?this.i:B.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof C)this.rgba=d;else if(d instanceof B)this.i=d,this.rgba=B.toRGBA(d);else if(d instanceof U)this.j=d,this.rgba=U.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&C.equals(this.rgba,d.rgba)&&B.equals(this.hsla,d.hsla)&&U.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=E.k(this.rgba.r),g=E.k(this.rgba.g),$=E.k(this.rgba.b),P=.2126*d+.7152*g+.0722*$;return i(P,4)}static k(d){const g=d/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(d){const g=this.getRelativeLuminance(),$=d.getRelativeLuminance();return g>$?(g+.05)/($+.05):($+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const g=this.getRelativeLuminance(),$=d.getRelativeLuminance();return g>$}isDarkerThan(d){const g=this.getRelativeLuminance(),$=d.getRelativeLuminance();return g<$}lighten(d){return new E(new B(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new E(new B(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:g,g:$,b:P,a:c}=this.rgba;return new E(new C(g,$,P,c*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new E(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const g=d.rgba,$=this.rgba.a,P=g.a,c=$+P*(1-$);if(c<1e-6)return E.transparent;const l=this.rgba.r*$/c+g.r*P*(1-$)/c,e=this.rgba.g*$/c+g.g*P*(1-$)/c,n=this.rgba.b*$/c+g.b*P*(1-$)/c;return new E(new C(l,e,n,c))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:g,g:$,b:P,a:c}=this.rgba;return new E(new C(d.rgba.r-c*(d.rgba.r-g),d.rgba.g-c*(d.rgba.g-$),d.rgba.b-c*(d.rgba.b-P),1))}flatten(...d){const g=d.reduceRight(($,P)=>E.o(P,$));return E.o(this,g)}static o(d,g){const $=1-d.rgba.a;return new E(new C($*g.rgba.r+d.rgba.a*d.rgba.r,$*g.rgba.g+d.rgba.a*d.rgba.g,$*g.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=E.Format.CSS.format(this)),this.u}static getLighterColor(d,g,$){if(d.isLighterThan(g))return d;$=$||.5;const P=d.getRelativeLuminance(),c=g.getRelativeLuminance();return $=$*(c-P)/c,d.lighten($)}static getDarkerColor(d,g,$){if(d.isDarkerThan(g))return d;$=$||.5;const P=d.getRelativeLuminance(),c=g.getRelativeLuminance();return $=$*(P-c)/P,d.darken($)}static{this.white=new E(new C(255,255,255,1))}static{this.black=new E(new C(0,0,0,1))}static{this.red=new E(new C(255,0,0,1))}static{this.blue=new E(new C(0,0,255,1))}static{this.green=new E(new C(0,255,0,1))}static{this.cyan=new E(new C(0,255,255,1))}static{this.lightgrey=new E(new C(211,211,211,1))}static{this.transparent=new E(new C(0,0,0,0))}}t.$_t=E,function(A){let d;(function(g){let $;(function(P){function c(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:A.Format.CSS.formatRGBA(r)}P.formatRGB=c;function l(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}P.formatRGBA=l;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(r)}P.formatHSL=e;function n(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}P.formatHSLA=n;function o(r){const p=r.toString(16);return p.length!==2?"0"+p:p}function f(r){return`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}`}P.formatHex=f;function h(r,p=!1){return p&&r.rgba.a===1?A.Format.CSS.formatHex(r):`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}${o(Math.round(r.rgba.a*255))}`}P.formatHexA=h;function v(r){return r.isOpaque()?A.Format.CSS.formatHex(r):A.Format.CSS.formatRGBA(r)}P.format=v;function m(r){const p=r.length;if(p===0||r.charCodeAt(0)!==35)return null;if(p===7){const S=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),F=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),I=16*b(r.charCodeAt(5))+b(r.charCodeAt(6));return new A(new C(S,F,I,1))}if(p===9){const S=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),F=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),I=16*b(r.charCodeAt(5))+b(r.charCodeAt(6)),H=16*b(r.charCodeAt(7))+b(r.charCodeAt(8));return new A(new C(S,F,I,H/255))}if(p===4){const S=b(r.charCodeAt(1)),F=b(r.charCodeAt(2)),I=b(r.charCodeAt(3));return new A(new C(16*S+S,16*F+F,16*I+I))}if(p===5){const S=b(r.charCodeAt(1)),F=b(r.charCodeAt(2)),I=b(r.charCodeAt(3)),H=b(r.charCodeAt(4));return new A(new C(16*S+S,16*F+F,16*I+I,(16*H+H)/255))}return null}P.parseHex=m;function b(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})($=g.CSS||(g.CSS={}))})(d=A.Format||(A.Format={}))}(E||(t.$_t=E={}))}),define(we[31],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5h=C,t.$6h=B,t.$7h=U;function i(E){return(A,d,g)=>{let $=null,P=null;if(typeof g.value=="function"?($="value",P=g.value):typeof g.get=="function"&&($="get",P=g.get),!P)throw new Error("not supported");g[$]=E(P,d)}}function C(E,A,d){let g=null,$=null;if(typeof d.value=="function"?(g="value",$=d.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(g="get",$=d.get),!$)throw new Error("not supported");const P=`$memoize$${A}`;d[g]=function(...c){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,c)}),this[P]}}function B(E,A,d){return i((g,$)=>{const P=`$debounce$${$}`,c=`$debounce$result$${$}`;return function(...l){this[c]||(this[c]=d?d():void 0),clearTimeout(this[P]),A&&(this[c]=A(this[c],...l),l=[this[c]]),this[P]=setTimeout(()=>{g.apply(this,l),this[c]=d?d():void 0},E)}})}function U(E,A,d){return i((g,$)=>{const P=`$throttle$timer$${$}`,c=`$throttle$result$${$}`,l=`$throttle$lastRun$${$}`,e=`$throttle$pending$${$}`;return function(...n){if(this[c]||(this[c]=d?d():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),A&&(this[c]=A(this[c],...n)),this[e])return;const o=this[l]+E;o<=Date.now()?(this[l]=Date.now(),g.apply(this,[this[c]]),this[c]=d?d():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[l]=Date.now(),g.apply(this,[this[c]]),this[c]=d?d():void 0},o-Date.now()))}})}}),define(we[85],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dt=void 0;class i{constructor(B,U,E,A){this.originalStart=B,this.originalLength=U,this.modifiedStart=E,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Dt=i}),define(we[6],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=C,t.$Z=B,t.$1=U,t.$2=E,t.$3=A,t.$4=g,t.$6=P,t.$7=c,t.$8=l,t.$0=n;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?v.isErrorNoTelemetry(r)?new v(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(p=>{p(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$W=i,t.$X=new i;function C(b){t.$X.setUnexpectedErrorHandler(b)}function B(b){if(!b||typeof b!="object")return!1;const r=b;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function U(b){g(b)||t.$X.onUnexpectedError(b)}function E(b){g(b)||t.$X.onUnexpectedExternalError(b)}function A(b){if(b instanceof Error){const{name:r,message:p}=b,S=b.stacktrace||b.stack;return{$isError:!0,name:r,message:p,stack:S,noTelemetry:v.isErrorNoTelemetry(b)}}return b}const d="Canceled";function g(b){return b instanceof $?!0:b instanceof Error&&b.name===d&&b.message===d}class $ extends Error{constructor(){super(d),this.name=this.message}}t.$5=$;function P(){const b=new Error(d);return b.name=b.message,b}function c(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}function l(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function n(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$$=o;class f extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$_=f;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=h;class v extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof v)return r;const p=new v;return p.message=r.message,p.stack=r.stack,p}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$bb=v;class m extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}t.$cb=m}),define(we[8],ve([1,0,6,82]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$9b=t.$8b=t.CompareResult=void 0,t.$sb=B,t.$tb=U,t.$ub=E,t.$vb=A,t.$wb=d,t.$xb=g,t.$yb=$,t.$zb=P,t.$Ab=c,t.$Bb=l,t.$Cb=e,t.$Db=n,t.$Eb=o,t.top=f,t.$Gb=h,t.$Hb=m,t.$Ib=b,t.$Jb=r,t.$Kb=p,t.$Lb=S,t.$Mb=F,t.$Nb=I,t.$Ob=H,t.$Pb=w,t.$Qb=j,t.$Rb=W,t.$Sb=N,t.$Tb=x,t.$Ub=M,t.$Vb=Q,t.$Wb=ie,t.$Xb=ue,t.$Yb=G,t.$Zb=ee,t.$1b=de,t.$2b=ye,t.$3b=Ae,t.$4b=je,t.$5b=le,t.$6b=he,t.$7b=Fe,t.$0b=Se;function B(J,O=0){return J[J.length-(1+O)]}function U(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}function E(J,O,u=(y,a)=>y===a){if(J===O)return!0;if(!J||!O||J.length!==O.length)return!1;for(let y=0,a=J.length;y<a;y++)if(!u(J[y],O[y]))return!1;return!0}function A(J,O){const u=J.length-1;O<u&&(J[O]=J[u]),J.pop()}function d(J,O,u){return g(J.length,y=>u(J[y],O))}function g(J,O){let u=0,y=J-1;for(;u<=y;){const a=(u+y)/2|0,D=O(a);if(D<0)u=a+1;else if(D>0)y=a-1;else return a}return-(u+1)}function $(J,O,u){if(J=J|0,J>=O.length)throw new TypeError("invalid index");const y=O[Math.floor(O.length*Math.random())],a=[],D=[],R=[];for(const s of O){const k=u(s,y);k<0?a.push(s):k>0?D.push(s):R.push(s)}return J<a.length?$(J,a,u):J<a.length+R.length?R[0]:$(J-(a.length+R.length),D,u)}function P(J,O){const u=[];let y;for(const a of J.slice(0).sort(O))!y||O(y[0],a)!==0?(y=[a],u.push(y)):y.push(a);return u}function*c(J,O){let u,y;for(const a of J)y!==void 0&&O(y,a)?u.push(a):(u&&(yield u),u=[a]),y=a;u&&(yield u)}function l(J,O){for(let u=0;u<=J.length;u++)O(u===0?void 0:J[u-1],u===J.length?void 0:J[u])}function e(J,O){for(let u=0;u<J.length;u++)O(u===0?void 0:J[u-1],J[u],u+1===J.length?void 0:J[u+1])}function n(J,O,u){const y=[];function a(s,k,T){if(k===0&&T.length===0)return;const L=y[y.length-1];L&&L.start+L.deleteCount===s?(L.deleteCount+=k,L.toInsert.push(...T)):y.push({start:s,deleteCount:k,toInsert:T})}let D=0,R=0;for(;;){if(D===J.length){a(D,0,O.slice(R));break}if(R===O.length){a(D,J.length-D,[]);break}const s=J[D],k=O[R],T=u(s,k);T===0?(D+=1,R+=1):T<0?(a(D,1,[]),D+=1):T>0&&(a(D,0,[k]),R+=1)}return y}function o(J,O,u){const y=n(J,O,u),a=[],D=[];for(const R of y)a.push(...J.slice(R.start,R.start+R.deleteCount)),D.push(...R.toInsert);return{removed:a,added:D}}function f(J,O,u){if(u===0)return[];const y=J.slice(0,u).sort(O);return v(J,O,y,u,J.length),y}function h(J,O,u,y,a){return u===0?Promise.resolve([]):new Promise((D,R)=>{(async()=>{const s=J.length,k=J.slice(0,u).sort(O);for(let T=u,L=Math.min(u+y,s);T<s;T=L,L=Math.min(L+y,s)){if(T>u&&await new Promise(z=>setTimeout(z)),a&&a.isCancellationRequested)throw new i.$5;v(J,O,k,T,L)}return k})().then(D,R)})}function v(J,O,u,y,a){for(const D=u.length;y<a;y++){const R=J[y];if(O(R,u[D-1])<0){u.pop();const s=(0,C.$kb)(u,k=>O(R,k)<0);u.splice(s,0,R)}}}function m(J){return J.filter(O=>!!O)}function b(J){let O=0;for(let u=0;u<J.length;u++)J[u]&&(J[O]=J[u],O+=1);J.length=O}function r(J,O,u){J.splice(u,0,J.splice(O,1)[0])}function p(J){return!Array.isArray(J)||J.length===0}function S(J){return Array.isArray(J)&&J.length>0}function F(J,O=u=>u){const u=new Set;return J.filter(y=>{const a=O(y);return u.has(a)?!1:(u.add(a),!0)})}function I(J){const O=new Set;return u=>{const y=J(u);return O.has(y)?!1:(O.add(y),!0)}}function H(J,O){return J.length>0?J[0]:O}function w(J,O){return J.length>0?J[J.length-1]:O}function j(J,O,u=(y,a)=>y===a){let y=0;for(let a=0,D=Math.min(J.length,O.length);a<D&&u(J[a],O[a]);a++)y++;return y}function W(J,O){let u=typeof O=="number"?J:0;typeof O=="number"?u=J:(u=0,O=J);const y=[];if(u<=O)for(let a=u;a<O;a++)y.push(a);else for(let a=u;a>O;a--)y.push(a);return y}function N(J,O,u){return J.reduce((y,a)=>(y[O(a)]=u?u(a):a,y),Object.create(null))}function x(J,O){return J.push(O),()=>M(J,O)}function M(J,O){const u=J.indexOf(O);if(u>-1)return J.splice(u,1),O}function Q(J,O,u){const y=J.slice(0,O),a=J.slice(O);return y.concat(u,a)}function ie(J,O){let u;if(typeof O=="number"){let y=O;u=()=>{const a=Math.sin(y++)*179426549;return a-Math.floor(a)}}else u=Math.random;for(let y=J.length-1;y>0;y-=1){const a=Math.floor(u()*(y+1)),D=J[y];J[y]=J[a],J[a]=D}}function ue(J,O){const u=J.indexOf(O);u>-1&&(J.splice(u,1),J.unshift(O))}function G(J,O){const u=J.indexOf(O);u>-1&&(J.splice(u,1),J.push(O))}function ee(J,O){for(const u of O)J.push(u)}function de(J,O){return Array.isArray(J)?J.map(O):O(J)}function ye(J){return Array.isArray(J)?J:[J]}function Ae(J){return J[Math.floor(Math.random()*J.length)]}function je(J,O,u){const y=_(J,O),a=J.length,D=u.length;J.length=a+D;for(let R=a-1;R>=y;R--)J[R+D]=J[R];for(let R=0;R<D;R++)J[R+y]=u[R]}function le(J,O,u,y){const a=_(J,O);let D=J.splice(a,u);return D===void 0&&(D=[]),je(J,a,y),D}function _(J,O){return O<0?Math.max(O+J.length,0):Math.min(O,J.length)}var fe;(function(J){function O(D){return D<0}J.isLessThan=O;function u(D){return D<=0}J.isLessThanOrEqual=u;function y(D){return D>0}J.isGreaterThan=y;function a(D){return D===0}J.isNeitherLessOrGreaterThan=a,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(fe||(t.CompareResult=fe={}));function he(J,O){return(u,y)=>O(J(u),J(y))}function Fe(...J){return(O,u)=>{for(const y of J){const a=y(O,u);if(!fe.isNeitherLessOrGreaterThan(a))return a}return fe.neitherLessOrGreaterThan}}const Z=(J,O)=>J-O;t.$8b=Z;const pe=(J,O)=>(0,t.$8b)(J?1:0,O?1:0);t.$9b=pe;function Se(J){return(O,u)=>-J(O,u)}class Re{constructor(O){this.g=O,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(O){let u=this.c;for(;u<this.g.length&&O(this.g[u]);)u++;const y=u===this.c?null:this.g.slice(this.c,u);return this.c=u,y}takeFromEndWhile(O){let u=this.d;for(;u>=0&&O(this.g[u]);)u--;const y=u===this.d?null:this.g.slice(u+1,this.d+1);return this.d=u,y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const O=this.g[this.c];return this.c++,O}removeLast(){const O=this.g[this.d];return this.d--,O}takeCount(O){const u=this.g.slice(this.c,this.c+O);return this.c+=O,u}}t.$$b=Re;class re{static{this.empty=new re(O=>{})}constructor(O){this.iterate=O}forEach(O){this.iterate(u=>(O(u),!0))}toArray(){const O=[];return this.iterate(u=>(O.push(u),!0)),O}filter(O){return new re(u=>this.iterate(y=>O(y)?u(y):!0))}map(O){return new re(u=>this.iterate(y=>u(O(y))))}some(O){let u=!1;return this.iterate(y=>(u=O(y),!u)),u}findFirst(O){let u;return this.iterate(y=>O(y)?(u=y,!1):!0),u}findLast(O){let u;return this.iterate(y=>(O(y)&&(u=y),!0)),u}findLastMaxBy(O){let u,y=!0;return this.iterate(a=>((y||fe.isGreaterThan(O(a,u)))&&(y=!1,u=a),!0)),u}}t.$_b=re;class me{constructor(O){this.c=O}static createSortPermutation(O,u){const y=Array.from(O.keys()).sort((a,D)=>u(O[a],O[D]));return new me(y)}apply(O){return O.map((u,y)=>O[this.c[y]])}inverse(){const O=this.c.slice();for(let u=0;u<this.c.length;u++)O[this.c[u]]=u;return new me(O)}}t.$ac=me}),define(we[37],ve([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=C,t.$ed=B,t.$fd=U,t.$gd=E,t.$hd=A,t.$id=d;function C(g,$){if(!g)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}function B(g,$="Unreachable"){throw new Error($)}function U(g,$="unexpected state"){if(!g)throw new i.$cb(`Assertion Failed: ${$}`)}function E(g){g||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function A(g){if(!g()){debugger;g(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function d(g,$){let P=0;for(;P<g.length-1;){const c=g[P],l=g[P+1];if(!$(c,l))return!1;P++}return!0}}),define(we[38],ve([1,0,8]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0,t.$7c=B,t.$8c=U,t.$9c=E,t.$0c=A,t.$$c=d,t.$_c=g;const C=(l,e)=>l===e;t.$6c=C;function B(l=t.$6c){return(e,n)=>i.$ub(e,n,l)}function U(){return(l,e)=>JSON.stringify(l)===JSON.stringify(e)}function E(){return(l,e)=>l.equals(e)}function A(l,e,n){return!l||!e?l===e:n(l,e)}function d(l,e){if(l===e)return!0;if(Array.isArray(l)&&Array.isArray(e)){if(l.length!==e.length)return!1;for(let n=0;n<l.length;n++)if(!d(l[n],e[n]))return!1;return!0}if(l&&typeof l=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(l)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const n=l,o=e,f=Object.keys(n),h=Object.keys(o),v=new Set(h);if(f.length!==h.length)return!1;for(const m of f)if(!v.has(m)||!d(n[m],o[m]))return!1;return!0}return!1}function g(l){return JSON.stringify(c(l))}let $=0;const P=new WeakMap;function c(l){if(Array.isArray(l))return l.map(c);if(l&&typeof l=="object")if(Object.getPrototypeOf(l)===Object.prototype){const e=l,n=Object.create(null);for(const o of Object.keys(e).sort())n[o]=c(e[o]);return n}else{let e=P.get(l);return e===void 0&&(e=$++,P.set(l,e)),e+"----2b76a038c20c4bcc"}return l}}),define(we[53],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(C,B){const U=this;let E=!1,A;return function(){if(E)return A;if(E=!0,B)try{A=C.apply(U,arguments)}finally{B()}else A=C.apply(U,arguments);return A}}}),define(we[86],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XO=t.$WO=void 0;class i{constructor(B){this.a=B,this.b=0}nextId(){return this.a+ ++this.b}}t.$WO=i,t.$XO=new i("id#")}),define(we[32],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(C){function B(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}C.is=B;const U=Object.freeze([]);function E(){return U}C.empty=E;function*A(r){yield r}C.single=A;function d(r){return B(r)?r:A(r)}C.wrap=d;function g(r){return r||U}C.from=g;function*$(r){for(let p=r.length-1;p>=0;p--)yield r[p]}C.reverse=$;function P(r){return!r||r[Symbol.iterator]().next().done===!0}C.isEmpty=P;function c(r){return r[Symbol.iterator]().next().value}C.first=c;function l(r,p){for(const S of r)if(p(S))return!0;return!1}C.some=l;function e(r,p){for(const S of r)if(p(S))return S}C.find=e;function*n(r,p){for(const S of r)p(S)&&(yield S)}C.filter=n;function*o(r,p){let S=0;for(const F of r)yield p(F,S++)}C.map=o;function*f(...r){for(const p of r)yield*p}C.concat=f;function h(r,p,S){let F=S;for(const I of r)F=p(F,I);return F}C.reduce=h;function*v(r,p,S=r.length){for(p<0&&(p+=r.length),S<0?S+=r.length:S>r.length&&(S=r.length);p<S;p++)yield r[p]}C.slice=v;function m(r,p=Number.POSITIVE_INFINITY){const S=[];if(p===0)return[S,r];const F=r[Symbol.iterator]();for(let I=0;I<p;I++){const H=F.next();if(H.done)return[S,C.empty()];S.push(H.value)}return[S,{[Symbol.iterator](){return F}}]}C.consume=m;async function b(r){const p=[];for await(const S of r)p.push(S);return Promise.resolve(p)}C.asyncToArray=b})(i||(t.Iterable=i={}))}),define(we[54],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Jr=t.$Ir=t.$Hr=t.$Gr=t.$Fr=t.ScanCode=t.KeyCode=void 0,t.$Kr=l;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var C;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(C||(t.ScanCode=C={}));class B{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(n,o){this._keyCodeToStr[n]=o,this._strToKeyCode[o.toLowerCase()]=n}keyCodeToStr(n){return this._keyCodeToStr[n]}strToKeyCode(n){return this._strToKeyCode[n.toLowerCase()]||0}}const U=new B,E=new B,A=new B;t.$Fr=new Array(230),t.$Gr={};const d=[],g=Object.create(null),$=Object.create(null);t.$Hr={lowerCaseToEnum:e=>$[e]||0,toEnum:e=>g[e]||0,toString:e=>d[e]||"None"},t.$Ir=[],t.$Jr=[];for(let e=0;e<=193;e++)t.$Ir[e]=-1;for(let e=0;e<=132;e++)t.$Jr[e]=-1;(function(){const e="",n=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],f=[];for(const h of n){const[v,m,b,r,p,S,F,I,H]=h;if(f[m]||(f[m]=!0,d[m]=b,g[b]=m,$[b.toLowerCase()]=m,v&&(t.$Ir[m]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$Jr[r]=m))),!o[r]){if(o[r]=!0,!p)throw new Error(`String representation missing for key code ${r} around scan code ${b}`);U.define(r,p),E.define(r,I||p),A.define(r,H||I||p)}S&&(t.$Fr[S]=r),F&&(t.$Gr[F]=r)}t.$Jr[3]=46})();var P;(function(e){function n(b){return U.keyCodeToStr(b)}e.toString=n;function o(b){return U.strToKeyCode(b)}e.fromString=o;function f(b){return E.keyCodeToStr(b)}e.toUserSettingsUS=f;function h(b){return A.keyCodeToStr(b)}e.toUserSettingsGeneral=h;function v(b){return E.strToKeyCode(b)||A.strToKeyCode(b)}e.fromUserSettings=v;function m(b){if(b>=98&&b<=113)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(b)}e.toElectronAccelerator=m})(P||(t.KeyCodeUtils=P={}));var c;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(c||(t.KeyMod=c={}));function l(e,n){const o=(n&65535)<<16>>>0;return(e|o)>>>0}}),define(we[87],ve([1,0,6]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rr=t.$Qr=t.$Pr=t.$Or=t.$Nr=void 0,t.$Lr=B,t.$Mr=U;var C;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(C||(C={}));function B(P,c){if(typeof P=="number"){if(P===0)return null;const l=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new d([U(l,c),U(e,c)]):new d([U(l,c)])}else{const l=[];for(let e=0;e<P.length;e++)l.push(U(P[e],c));return new d(l)}}function U(P,c){const l=!!(P&2048),e=!!(P&256),n=c===2?e:l,o=!!(P&1024),f=!!(P&512),h=c===2?l:e,v=P&255;return new E(n,o,f,h,v)}class E{constructor(c,l,e,n,o){this.ctrlKey=c,this.shiftKey=l,this.altKey=e,this.metaKey=n,this.keyCode=o}equals(c){return c instanceof E&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`K${c}${l}${e}${n}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new d([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Nr=E;class A{constructor(c,l,e,n,o){this.ctrlKey=c,this.shiftKey=l,this.altKey=e,this.metaKey=n,this.scanCode=o}equals(c){return c instanceof A&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",n=this.metaKey?"1":"0";return`S${c}${l}${e}${n}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Or=A;class d{constructor(c){if(c.length===0)throw(0,i.$7)("chords");this.chords=c}getHashCode(){let c="";for(let l=0,e=this.chords.length;l<e;l++)l!==0&&(c+=";"),c+=this.chords[l].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let l=0;l<this.chords.length;l++)if(!this.chords[l].equals(c.chords[l]))return!1;return!0}}t.$Pr=d;class g{constructor(c,l,e,n,o,f){this.ctrlKey=c,this.shiftKey=l,this.altKey=e,this.metaKey=n,this.keyLabel=o,this.keyAriaLabel=f}}t.$Qr=g;class ${}t.$Rr=$}),define(we[23],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(B){this.d=B,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(B){this.c=B}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),define(we[14],ve([1,0,23]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dT=A,t.$eT=d,t.$fT=g;let B=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const U=new i.$V(()=>B("mouse",!1)),E=new i.$V(()=>B("element",!1));function A($){B=$}function d($){return $==="element"?E.value:U.value}function g(){return B("element",!0)}}),define(we[55],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(U){this.element=U,this.next=i.Undefined,this.prev=i.Undefined}}class C{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let U=this.a;for(;U!==i.Undefined;){const E=U.next;U.prev=i.Undefined,U.next=i.Undefined,U=E}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,E){const A=new i(U);if(this.a===i.Undefined)this.a=A,this.b=A;else if(E){const g=this.b;this.b=A,A.prev=g,g.next=A}else{const g=this.a;this.a=A,A.next=g,g.prev=A}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(A))}}shift(){if(this.a!==i.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==i.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==i.Undefined&&U.next!==i.Undefined){const E=U.prev;E.next=U.next,U.next.prev=E}else U.prev===i.Undefined&&U.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):U.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):U.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==i.Undefined;)yield U.element,U=U.next}}t.$5c=C}),define(we[39],ve([1,0]),function(se,t){"use strict";var i,C,B;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=void 0,t.$xc=U,t.$yc=E,t.$zc=A,t.$Ic=m;function U(b,r,p){let S=b.get(r);return S===void 0&&(S=p,b.set(r,S)),S}function E(b){const r=[];return b.forEach((p,S)=>{r.push(`${S} => ${p}`)}),`Map(${b.size}) {${r.join(", ")}}`}function A(b){const r=[];return b.forEach(p=>{r.push(p)}),`Set(${b.size}) {${r.join(", ")}}`}class d{constructor(r,p){this.uri=r,this.value=p}}function g(b){return Array.isArray(b)}class ${static{this.c=r=>r.toString()}constructor(r,p){if(this[i]="ResourceMap",r instanceof $)this.d=new Map(r.d),this.e=p??$.c;else if(g(r)){this.d=new Map,this.e=p??$.c;for(const[S,F]of r)this.set(S,F)}else this.d=new Map,this.e=r??$.c}set(r,p){return this.d.set(this.e(r),new d(r,p)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,p){typeof p<"u"&&(r=r.bind(p));for(const[S,F]of this.d)r(F.value,F.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}t.$Ac=$;class P{constructor(r,p){this[C]="ResourceSet",!r||typeof r=="function"?this.c=new $(r):(this.c=new $(p),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,p){this.c.forEach((S,F)=>r.call(p,F,F,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=P;var c;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(c||(t.Touch=c={}));class l{constructor(){this[B]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,p=0){const S=this.c.get(r);if(S)return p!==0&&this.m(S,p),S.value}set(r,p,S=0){let F=this.c.get(r);if(F)F.value=p,S!==0&&this.m(F,S);else{switch(F={key:r,value:p,next:void 0,previous:void 0},S){case 0:this.k(F);break;case 1:this.j(F);break;case 2:this.k(F);break;default:this.k(F);break}this.c.set(r,F),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const p=this.c.get(r);if(p)return this.c.delete(r),this.l(p),this.f--,p.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,p){const S=this.g;let F=this.d;for(;F;){if(p?r.bind(p)(F.value,F.key,this):r(F.value,F.key,this),this.g!==S)throw new Error("LinkedMap got modified during iteration.");F=F.next}}keys(){const r=this,p=this.g;let S=this.d;const F={[Symbol.iterator](){return F},next(){if(r.g!==p)throw new Error("LinkedMap got modified during iteration.");if(S){const I={value:S.key,done:!1};return S=S.next,I}else return{value:void 0,done:!0}}};return F}values(){const r=this,p=this.g;let S=this.d;const F={[Symbol.iterator](){return F},next(){if(r.g!==p)throw new Error("LinkedMap got modified during iteration.");if(S){const I={value:S.value,done:!1};return S=S.next,I}else return{value:void 0,done:!0}}};return F}entries(){const r=this,p=this.g;let S=this.d;const F={[Symbol.iterator](){return F},next(){if(r.g!==p)throw new Error("LinkedMap got modified during iteration.");if(S){const I={value:[S.key,S.value],done:!1};return S=S.next,I}else return{value:void 0,done:!0}}};return F}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let p=this.d,S=this.size;for(;p&&S>r;)this.c.delete(p.key),p=p.next,S--;this.d=p,this.f=S,p&&(p.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let p=this.e,S=this.size;for(;p&&S>r;)this.c.delete(p.key),p=p.previous,S--;this.e=p,this.f=S,p&&(p.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const p=r.next,S=r.previous;if(!p||!S)throw new Error("Invalid list");p.previous=S,S.next=p}r.next=void 0,r.previous=void 0,this.g++}m(r,p){if(!this.d||!this.e)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(r===this.d)return;const S=r.next,F=r.previous;r===this.e?(F.next=void 0,this.e=F):(S.previous=F,F.next=S),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(p===2){if(r===this.e)return;const S=r.next,F=r.previous;r===this.d?(S.previous=void 0,this.d=S):(S.previous=F,F.next=S),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((p,S)=>{r.push([S,p])}),r}fromJSON(r){this.clear();for(const[p,S]of r)this.set(p,S)}}t.$Cc=l;class e extends l{constructor(r,p=1){super(),this.n=r,this.o=Math.min(Math.max(0,p),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,p=2){return super.get(r,p)}peek(r){return super.get(r,0)}set(r,p){return super.set(r,p,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class n extends e{constructor(r,p=1){super(r,p)}q(r){this.h(r)}set(r,p){return super.set(r,p),this.p(),this}}t.$Dc=n;class o extends e{constructor(r,p=1){super(r,p)}q(r){this.i(r)}set(r,p){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,p),this}}t.$Ec=o;class f{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let p=this.c.get(r)||0;return p===0?!1:(p--,p===0?this.c.delete(r):this.c.set(r,p),!0)}has(r){return this.c.has(r)}}t.$Fc=f;class h{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[p,S]of r)this.set(p,S)}clear(){this.c.clear(),this.d.clear()}set(r,p){this.c.set(r,p),this.d.set(p,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const p=this.c.get(r);return p===void 0?!1:(this.c.delete(r),this.d.delete(p),!0)}forEach(r,p){this.c.forEach((S,F)=>{r.call(p,S,F,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=h;class v{constructor(){this.c=new Map}add(r,p){let S=this.c.get(r);S||(S=new Set,this.c.set(r,S)),S.add(p)}delete(r,p){const S=this.c.get(r);S&&(S.delete(p),S.size===0&&this.c.delete(r))}forEach(r,p){const S=this.c.get(r);S&&S.forEach(p)}get(r){const p=this.c.get(r);return p||new Set}}t.$Hc=v;function m(b,r){if(b===r)return!0;if(b.size!==r.size)return!1;for(const[p,S]of b)if(!r.has(p)||r.get(p)!==S)return!1;for(const[p]of r)if(!b.has(p))return!1;return!0}}),define(we[2],ve([1,0,8,83,39,53,32]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=$,t.$Lc=P,t.$Mc=c,t.$Nc=n,t.$Oc=o,t.$Pc=f,t.$Qc=h,t.$Rc=v,t.$Sc=m,t.$3c=W;const A=!1;let d=null;class g{constructor(){this.b=new Map}static{this.a=0}c(M){let Q=this.b.get(M);return Q||(Q={parent:null,source:null,isSingleton:!1,value:M,idx:g.a++},this.b.set(M,Q)),Q}trackDisposable(M){const Q=this.c(M);Q.source||(Q.source=new Error().stack)}setParent(M,Q){const ie=this.c(M);ie.parent=Q}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,Q){const ie=Q.get(M);if(ie)return ie;const ue=M.parent?this.f(this.c(M.parent),Q):M;return Q.set(M,ue),ue}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,ie])=>ie.source!==null&&!this.f(ie,M).isSingleton).flatMap(([ie])=>ie)}computeLeakingDisposables(M=10,Q){let ie;if(Q)ie=Q;else{const ye=new Map,Ae=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,ye).isSingleton);if(Ae.length===0)return;const je=new Set(Ae.map(le=>le.value));if(ie=Ae.filter(le=>!(le.parent&&je.has(le.parent))),ie.length===0)throw new Error("There are cyclic diposable chains!")}if(!ie)return;function ue(ye){function Ae(le,_){for(;le.length>0&&_.some(fe=>typeof fe=="string"?fe===le[0]:le[0].match(fe));)le.shift()}const je=ye.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Ae(je,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),je.reverse()}const G=new B.$Hc;for(const ye of ie){const Ae=ue(ye);for(let je=0;je<=Ae.length;je++)G.add(Ae.slice(0,je).join(`
`),ye)}ie.sort((0,i.$6b)(ye=>ye.idx,i.$8b));let ee="",de=0;for(const ye of ie.slice(0,M)){de++;const Ae=ue(ye),je=[];for(let le=0;le<Ae.length;le++){let _=Ae[le];_=`(shared with ${G.get(Ae.slice(0,le+1).join(`
`)).size}/${ie.length} leaks) at ${_}`;const he=G.get(Ae.slice(0,le).join(`
`)),Fe=(0,C.$K)([...he].map(Z=>ue(Z)[le]),Z=>Z);delete Fe[Ae[le]];for(const[Z,pe]of Object.entries(Fe))je.unshift(`    - stacktraces of ${pe.length} other leaks continue with ${Z}`);je.unshift(_)}ee+=`


==================== Leaking disposable ${de}/${ie.length}: ${ye.value.constructor.name} ====================
${je.join(`
`)}
============================================================

`}return ie.length>M&&(ee+=`


... and ${ie.length-M} more leaking disposables

`),{leaks:ie,details:ee}}}t.$Jc=g;function $(x){d=x}if(A){const x="__is_disposable_tracked__";$(new class{trackDisposable(M){const Q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[x]||console.log(Q)},3e3)}setParent(M,Q){if(M&&M!==r.None)try{M[x]=!0}catch{}}markAsDisposed(M){if(M&&M!==r.None)try{M[x]=!0}catch{}}markAsSingleton(M){}})}function P(x){return d?.trackDisposable(x),x}function c(x){d?.markAsDisposed(x)}function l(x,M){d?.setParent(x,M)}function e(x,M){if(d)for(const Q of x)d.setParent(Q,M)}function n(x){return d?.markAsSingleton(x),x}function o(x){return typeof x=="object"&&x!==null&&typeof x.dispose=="function"&&x.dispose.length===0}function f(x){if(E.Iterable.is(x)){const M=[];for(const Q of x)if(Q)try{Q.dispose()}catch(ie){M.push(ie)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(x)?[]:x}else if(x)return x.dispose(),x}function h(x){for(const M of x)o(M)&&M.dispose();return[]}function v(...x){const M=m(()=>f(x));return e(x,M),M}function m(x){const M=P({dispose:(0,U.$db)(()=>{c(M),x()})});return M}class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(c(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return l(M,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),l(M,null))}}t.$Tc=b;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,P(this),l(this.q,this)}dispose(){c(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}t.$Uc=r;class p{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&l(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&l(M,null),M}}t.$Vc=p;class S{constructor(M){this.a=new p,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=S;class F{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=F;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(M){let Q=M;return this.unset=()=>Q=void 0,this.isset=()=>Q!==void 0,this.dispose=()=>{Q&&(Q(),Q=void 0,c(this))},this}}t.$Yc=I;class H{constructor(){this.a=new Map}acquire(M,...Q){let ie=this.a.get(M);ie||(ie={counter:0,object:this.b(M,...Q)},this.a.set(M,ie));const{object:ue}=ie,G=(0,U.$db)(()=>{--ie.counter===0&&(this.c(M,ie.object),this.a.delete(M))});return ie.counter++,{object:ue,dispose:G}}}t.$Zc=H;class w{constructor(M){this.a=M}async acquire(M,...Q){const ie=this.a.acquire(M,...Q);try{return{object:await ie.object,dispose:()=>ie.dispose()}}catch(ue){throw ie.dispose(),ue}}}t.$1c=w;class j{constructor(M){this.object=M}dispose(){}}t.$2c=j;function W(x){const M=new b;try{x(M)}finally{M.dispose()}}class N{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,Q,ie=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ie||this.a.get(M)?.dispose(),this.a.set(M,Q)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=N}),function(se,t){typeof define=="function"&&define.amd?define(we[88],ve([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(se=typeof globalThis<"u"?globalThis:se||self,t(se.marked={}))}(this,function(se){"use strict";function t(O,u){for(var y=0;y<u.length;y++){var a=u[y];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(O,a.key,a)}}function i(O,u,y){return u&&t(O.prototype,u),y&&t(O,y),Object.defineProperty(O,"prototype",{writable:!1}),O}function C(O,u){if(O){if(typeof O=="string")return B(O,u);var y=Object.prototype.toString.call(O).slice(8,-1);if(y==="Object"&&O.constructor&&(y=O.constructor.name),y==="Map"||y==="Set")return Array.from(O);if(y==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(y))return B(O,u)}}function B(O,u){(u==null||u>O.length)&&(u=O.length);for(var y=0,a=new Array(u);y<u;y++)a[y]=O[y];return a}function U(O,u){var y=typeof Symbol<"u"&&O[Symbol.iterator]||O["@@iterator"];if(y)return(y=y.call(O)).next.bind(y);if(Array.isArray(O)||(y=C(O))||u&&O&&typeof O.length=="number"){y&&(O=y);var a=0;return function(){return a>=O.length?{done:!0}:{done:!1,value:O[a++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=E();function A(O){se.defaults=O}var d=/[&<>"']/,g=/[&<>"']/g,$=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(u){return c[u]};function e(O,u){if(u){if(d.test(O))return O.replace(g,l)}else if($.test(O))return O.replace(P,l);return O}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(O){return O.replace(n,function(u,y){return y=y.toLowerCase(),y==="colon"?":":y.charAt(0)==="#"?y.charAt(1)==="x"?String.fromCharCode(parseInt(y.substring(2),16)):String.fromCharCode(+y.substring(1)):""})}var f=/(^|[^\[])\^/g;function h(O,u){O=typeof O=="string"?O:O.source,u=u||"";var y={replace:function(D,R){return R=R.source||R,R=R.replace(f,"$1"),O=O.replace(D,R),y},getRegex:function(){return new RegExp(O,u)}};return y}var v=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(O,u,y){if(O){var a;try{a=decodeURIComponent(o(y)).replace(v,"").toLowerCase()}catch{return null}if(a.indexOf("javascript:")===0||a.indexOf("vbscript:")===0||a.indexOf("data:")===0)return null}u&&!m.test(y)&&(y=I(u,y));try{y=encodeURI(y).replace(/%25/g,"%")}catch{return null}return y}var r={},p=/^[^:]+:\/*[^/]*$/,S=/^([^:]+:)[\s\S]*$/,F=/^([^:]+:\/*[^/]*)[\s\S]*$/;function I(O,u){r[" "+O]||(p.test(O)?r[" "+O]=O+"/":r[" "+O]=W(O,"/",!0)),O=r[" "+O];var y=O.indexOf(":")===-1;return u.substring(0,2)==="//"?y?u:O.replace(S,"$1")+u:u.charAt(0)==="/"?y?u:O.replace(F,"$1")+u:O+u}var H={exec:function(){}};function w(O){for(var u=1,y,a;u<arguments.length;u++){y=arguments[u];for(a in y)Object.prototype.hasOwnProperty.call(y,a)&&(O[a]=y[a])}return O}function j(O,u){var y=O.replace(/\|/g,function(R,s,k){for(var T=!1,L=s;--L>=0&&k[L]==="\\";)T=!T;return T?"|":" |"}),a=y.split(/ \|/),D=0;if(a[0].trim()||a.shift(),a.length>0&&!a[a.length-1].trim()&&a.pop(),a.length>u)a.splice(u);else for(;a.length<u;)a.push("");for(;D<a.length;D++)a[D]=a[D].trim().replace(/\\\|/g,"|");return a}function W(O,u,y){var a=O.length;if(a===0)return"";for(var D=0;D<a;){var R=O.charAt(a-D-1);if(R===u&&!y)D++;else if(R!==u&&y)D++;else break}return O.slice(0,a-D)}function N(O,u){if(O.indexOf(u[1])===-1)return-1;for(var y=O.length,a=0,D=0;D<y;D++)if(O[D]==="\\")D++;else if(O[D]===u[0])a++;else if(O[D]===u[1]&&(a--,a<0))return D;return-1}function x(O){O&&O.sanitize&&!O.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(O,u){if(u<1)return"";for(var y="";u>1;)u&1&&(y+=O),u>>=1,O+=O;return y+O}function Q(O,u,y,a){var D=u.href,R=u.title?e(u.title):null,s=O[1].replace(/\\([\[\]])/g,"$1");if(O[0].charAt(0)!=="!"){a.state.inLink=!0;var k={type:"link",raw:y,href:D,title:R,text:s,tokens:a.inlineTokens(s)};return a.state.inLink=!1,k}return{type:"image",raw:y,href:D,title:R,text:e(s)}}function ie(O,u){var y=O.match(/^(\s+)(?:```)/);if(y===null)return u;var a=y[1];return u.split(`
`).map(function(D){var R=D.match(/^\s+/);if(R===null)return D;var s=R[0];return s.length>=a.length?D.slice(a.length):D}).join(`
`)}var ue=function(){function O(y){this.options=y||se.defaults}var u=O.prototype;return u.space=function(a){var D=this.rules.block.newline.exec(a);if(D&&D[0].length>0)return{type:"space",raw:D[0]}},u.code=function(a){var D=this.rules.block.code.exec(a);if(D){var R=D[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:D[0],codeBlockStyle:"indented",text:this.options.pedantic?R:W(R,`
`)}}},u.fences=function(a){var D=this.rules.block.fences.exec(a);if(D){var R=D[0],s=ie(R,D[3]||"");return{type:"code",raw:R,lang:D[2]?D[2].trim():D[2],text:s}}},u.heading=function(a){var D=this.rules.block.heading.exec(a);if(D){var R=D[2].trim();if(/#$/.test(R)){var s=W(R,"#");(this.options.pedantic||!s||/ $/.test(s))&&(R=s.trim())}return{type:"heading",raw:D[0],depth:D[1].length,text:R,tokens:this.lexer.inline(R)}}},u.hr=function(a){var D=this.rules.block.hr.exec(a);if(D)return{type:"hr",raw:D[0]}},u.blockquote=function(a){var D=this.rules.block.blockquote.exec(a);if(D){var R=D[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:D[0],tokens:this.lexer.blockTokens(R,[]),text:R}}},u.list=function(a){var D=this.rules.block.list.exec(a);if(D){var R,s,k,T,L,z,Y,q,te,ce,oe,Te,ke=D[1].trim(),Me=ke.length>1,Ee={type:"list",raw:"",ordered:Me,start:Me?+ke.slice(0,-1):"",loose:!1,items:[]};ke=Me?"\\d{1,9}\\"+ke.slice(-1):"\\"+ke,this.options.pedantic&&(ke=Me?ke:"[*+-]");for(var Ne=new RegExp("^( {0,3}"+ke+")((?:[	 ][^\\n]*)?(?:\\n|$))");a&&(Te=!1,!(!(D=Ne.exec(a))||this.rules.block.hr.test(a)));){if(R=D[0],a=a.substring(R.length),q=D[2].split(`
`,1)[0],te=a.split(`
`,1)[0],this.options.pedantic?(T=2,oe=q.trimLeft()):(T=D[2].search(/[^ ]/),T=T>4?1:T,oe=q.slice(T),T+=D[1].length),z=!1,!q&&/^ *$/.test(te)&&(R+=te+`
`,a=a.substring(te.length+1),Te=!0),!Te)for(var Ue=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ye=new RegExp("^ {0,"+Math.min(3,T-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),_e=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,T-1)+"}#");a&&(ce=a.split(`
`,1)[0],q=ce,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(_e.test(q)||et.test(q)||Ue.test(q)||Ye.test(a)));){if(q.search(/[^ ]/)>=T||!q.trim())oe+=`
`+q.slice(T);else if(!z)oe+=`
`+q;else break;!z&&!q.trim()&&(z=!0),R+=ce+`
`,a=a.substring(ce.length+1)}Ee.loose||(Y?Ee.loose=!0:/\n *\n *$/.test(R)&&(Y=!0)),this.options.gfm&&(s=/^\[[ xX]\] /.exec(oe),s&&(k=s[0]!=="[ ] ",oe=oe.replace(/^\[[ xX]\] +/,""))),Ee.items.push({type:"list_item",raw:R,task:!!s,checked:k,loose:!1,text:oe}),Ee.raw+=R}Ee.items[Ee.items.length-1].raw=R.trimRight(),Ee.items[Ee.items.length-1].text=oe.trimRight(),Ee.raw=Ee.raw.trimRight();var tt=Ee.items.length;for(L=0;L<tt;L++){this.lexer.state.top=!1,Ee.items[L].tokens=this.lexer.blockTokens(Ee.items[L].text,[]);var We=Ee.items[L].tokens.filter(function(ae){return ae.type==="space"}),X=We.every(function(ae){for(var $e=ae.raw.split(""),De=0,Le=U($e),ze;!(ze=Le()).done;){var Qe=ze.value;if(Qe===`
`&&(De+=1),De>1)return!0}return!1});!Ee.loose&&We.length&&X&&(Ee.loose=!0,Ee.items[L].loose=!0)}return Ee}},u.html=function(a){var D=this.rules.block.html.exec(a);if(D){var R={type:"html",raw:D[0],pre:!this.options.sanitizer&&(D[1]==="pre"||D[1]==="script"||D[1]==="style"),text:D[0]};if(this.options.sanitize){var s=this.options.sanitizer?this.options.sanitizer(D[0]):e(D[0]);R.type="paragraph",R.text=s,R.tokens=this.lexer.inline(s)}return R}},u.def=function(a){var D=this.rules.block.def.exec(a);if(D){D[3]&&(D[3]=D[3].substring(1,D[3].length-1));var R=D[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:R,raw:D[0],href:D[2],title:D[3]}}},u.table=function(a){var D=this.rules.block.table.exec(a);if(D){var R={type:"table",header:j(D[1]).map(function(Y){return{text:Y}}),align:D[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:D[3]&&D[3].trim()?D[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(R.header.length===R.align.length){R.raw=D[0];var s=R.align.length,k,T,L,z;for(k=0;k<s;k++)/^ *-+: *$/.test(R.align[k])?R.align[k]="right":/^ *:-+: *$/.test(R.align[k])?R.align[k]="center":/^ *:-+ *$/.test(R.align[k])?R.align[k]="left":R.align[k]=null;for(s=R.rows.length,k=0;k<s;k++)R.rows[k]=j(R.rows[k],R.header.length).map(function(Y){return{text:Y}});for(s=R.header.length,T=0;T<s;T++)R.header[T].tokens=this.lexer.inline(R.header[T].text);for(s=R.rows.length,T=0;T<s;T++)for(z=R.rows[T],L=0;L<z.length;L++)z[L].tokens=this.lexer.inline(z[L].text);return R}}},u.lheading=function(a){var D=this.rules.block.lheading.exec(a);if(D)return{type:"heading",raw:D[0],depth:D[2].charAt(0)==="="?1:2,text:D[1],tokens:this.lexer.inline(D[1])}},u.paragraph=function(a){var D=this.rules.block.paragraph.exec(a);if(D){var R=D[1].charAt(D[1].length-1)===`
`?D[1].slice(0,-1):D[1];return{type:"paragraph",raw:D[0],text:R,tokens:this.lexer.inline(R)}}},u.text=function(a){var D=this.rules.block.text.exec(a);if(D)return{type:"text",raw:D[0],text:D[0],tokens:this.lexer.inline(D[0])}},u.escape=function(a){var D=this.rules.inline.escape.exec(a);if(D)return{type:"escape",raw:D[0],text:e(D[1])}},u.tag=function(a){var D=this.rules.inline.tag.exec(a);if(D)return!this.lexer.state.inLink&&/^<a /i.test(D[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(D[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(D[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(D[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:D[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(D[0]):e(D[0]):D[0]}},u.link=function(a){var D=this.rules.inline.link.exec(a);if(D){var R=D[2].trim();if(!this.options.pedantic&&/^</.test(R)){if(!/>$/.test(R))return;var s=W(R.slice(0,-1),"\\");if((R.length-s.length)%2===0)return}else{var k=N(D[2],"()");if(k>-1){var T=D[0].indexOf("!")===0?5:4,L=T+D[1].length+k;D[2]=D[2].substring(0,k),D[0]=D[0].substring(0,L).trim(),D[3]=""}}var z=D[2],Y="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(z);q&&(z=q[1],Y=q[3])}else Y=D[3]?D[3].slice(1,-1):"";return z=z.trim(),/^</.test(z)&&(this.options.pedantic&&!/>$/.test(R)?z=z.slice(1):z=z.slice(1,-1)),Q(D,{href:z&&z.replace(this.rules.inline._escapes,"$1"),title:Y&&Y.replace(this.rules.inline._escapes,"$1")},D[0],this.lexer)}},u.reflink=function(a,D){var R;if((R=this.rules.inline.reflink.exec(a))||(R=this.rules.inline.nolink.exec(a))){var s=(R[2]||R[1]).replace(/\s+/g," ");if(s=D[s.toLowerCase()],!s||!s.href){var k=R[0].charAt(0);return{type:"text",raw:k,text:k}}return Q(R,s,R[0],this.lexer)}},u.emStrong=function(a,D,R){R===void 0&&(R="");var s=this.rules.inline.emStrong.lDelim.exec(a);if(s&&!(s[3]&&R.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var k=s[1]||s[2]||"";if(!k||k&&(R===""||this.rules.inline.punctuation.exec(R))){var T=s[0].length-1,L,z,Y=T,q=0,te=s[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(te.lastIndex=0,D=D.slice(-1*a.length+T);(s=te.exec(D))!=null;)if(L=s[1]||s[2]||s[3]||s[4]||s[5]||s[6],!!L){if(z=L.length,s[3]||s[4]){Y+=z;continue}else if((s[5]||s[6])&&T%3&&!((T+z)%3)){q+=z;continue}if(Y-=z,!(Y>0)){if(z=Math.min(z,z+Y+q),Math.min(T,z)%2){var ce=a.slice(1,T+s.index+z);return{type:"em",raw:a.slice(0,T+s.index+z+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}var oe=a.slice(2,T+s.index+z-1);return{type:"strong",raw:a.slice(0,T+s.index+z+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}}}}},u.codespan=function(a){var D=this.rules.inline.code.exec(a);if(D){var R=D[2].replace(/\n/g," "),s=/[^ ]/.test(R),k=/^ /.test(R)&&/ $/.test(R);return s&&k&&(R=R.substring(1,R.length-1)),R=e(R,!0),{type:"codespan",raw:D[0],text:R}}},u.br=function(a){var D=this.rules.inline.br.exec(a);if(D)return{type:"br",raw:D[0]}},u.del=function(a){var D=this.rules.inline.del.exec(a);if(D)return{type:"del",raw:D[0],text:D[2],tokens:this.lexer.inlineTokens(D[2])}},u.autolink=function(a,D){var R=this.rules.inline.autolink.exec(a);if(R){var s,k;return R[2]==="@"?(s=e(this.options.mangle?D(R[1]):R[1]),k="mailto:"+s):(s=e(R[1]),k=s),{type:"link",raw:R[0],text:s,href:k,tokens:[{type:"text",raw:s,text:s}]}}},u.url=function(a,D){var R;if(R=this.rules.inline.url.exec(a)){var s,k;if(R[2]==="@")s=e(this.options.mangle?D(R[0]):R[0]),k="mailto:"+s;else{var T;do T=R[0],R[0]=this.rules.inline._backpedal.exec(R[0])[0];while(T!==R[0]);s=e(R[0]),R[1]==="www."?k="http://"+s:k=s}return{type:"link",raw:R[0],text:s,href:k,tokens:[{type:"text",raw:s,text:s}]}}},u.inlineText=function(a,D){var R=this.rules.inline.text.exec(a);if(R){var s;return this.lexer.state.inRawBlock?s=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(R[0]):e(R[0]):R[0]:s=e(this.options.smartypants?D(R[0]):R[0]),{type:"text",raw:R[0],text:s}}},O}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:H,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=h(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=h(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=h(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=h(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=h(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=w({},G),G.gfm=w({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=h(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=w({},G.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:H,paragraph:h(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:H,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:H,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=h(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=h(G._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=h(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=h(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=h(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=h(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=h(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=h(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=h(ee.reflink).replace("label",ee._label).replace("ref",G._label).getRegex(),ee.nolink=h(ee.nolink).replace("ref",G._label).getRegex(),ee.reflinkSearch=h(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=w({},ee),ee.pedantic=w({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=w({},ee.normal,{escape:h(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=h(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=w({},ee.gfm,{br:h(ee.br).replace("{2,}","*").getRegex(),text:h(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function de(O){return O.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ye(O){var u="",y,a,D=O.length;for(y=0;y<D;y++)a=O.charCodeAt(y),Math.random()>.5&&(a="x"+a.toString(16)),u+="&#"+a+";";return u}var Ae=function(){function O(y){this.tokens=[],this.tokens.links=Object.create(null),this.options=y||se.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var a={block:G.normal,inline:ee.normal};this.options.pedantic?(a.block=G.pedantic,a.inline=ee.pedantic):this.options.gfm&&(a.block=G.gfm,this.options.breaks?a.inline=ee.breaks:a.inline=ee.gfm),this.tokenizer.rules=a}O.lex=function(a,D){var R=new O(D);return R.lex(a)},O.lexInline=function(a,D){var R=new O(D);return R.inlineTokens(a)};var u=O.prototype;return u.lex=function(a){a=a.replace(/\r\n|\r/g,`
`),this.blockTokens(a,this.tokens);for(var D;D=this.inlineQueue.shift();)this.inlineTokens(D.src,D.tokens);return this.tokens},u.blockTokens=function(a,D){var R=this;D===void 0&&(D=[]),this.options.pedantic?a=a.replace(/\t/g,"    ").replace(/^ +$/gm,""):a=a.replace(/^( *)(\t+)/gm,function(Y,q,te){return q+"    ".repeat(te.length)});for(var s,k,T,L;a;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Y){return(s=Y.call({lexer:R},a,D))?(a=a.substring(s.raw.length),D.push(s),!0):!1}))){if(s=this.tokenizer.space(a)){a=a.substring(s.raw.length),s.raw.length===1&&D.length>0?D[D.length-1].raw+=`
`:D.push(s);continue}if(s=this.tokenizer.code(a)){a=a.substring(s.raw.length),k=D[D.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+s.raw,k.text+=`
`+s.text,this.inlineQueue[this.inlineQueue.length-1].src=k.text):D.push(s);continue}if(s=this.tokenizer.fences(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.heading(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.hr(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.blockquote(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.list(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.html(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.def(a)){a=a.substring(s.raw.length),k=D[D.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+s.raw,k.text+=`
`+s.raw,this.inlineQueue[this.inlineQueue.length-1].src=k.text):this.tokens.links[s.tag]||(this.tokens.links[s.tag]={href:s.href,title:s.title});continue}if(s=this.tokenizer.table(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.lheading(a)){a=a.substring(s.raw.length),D.push(s);continue}if(T=a,this.options.extensions&&this.options.extensions.startBlock&&function(){var Y=1/0,q=a.slice(1),te=void 0;R.options.extensions.startBlock.forEach(function(ce){te=ce.call({lexer:this},q),typeof te=="number"&&te>=0&&(Y=Math.min(Y,te))}),Y<1/0&&Y>=0&&(T=a.substring(0,Y+1))}(),this.state.top&&(s=this.tokenizer.paragraph(T))){k=D[D.length-1],L&&k.type==="paragraph"?(k.raw+=`
`+s.raw,k.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):D.push(s),L=T.length!==a.length,a=a.substring(s.raw.length);continue}if(s=this.tokenizer.text(a)){a=a.substring(s.raw.length),k=D[D.length-1],k&&k.type==="text"?(k.raw+=`
`+s.raw,k.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):D.push(s);continue}if(a){var z="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(z);break}else throw new Error(z)}}return this.state.top=!0,D},u.inline=function(a,D){return D===void 0&&(D=[]),this.inlineQueue.push({src:a,tokens:D}),D},u.inlineTokens=function(a,D){var R=this;D===void 0&&(D=[]);var s,k,T,L=a,z,Y,q;if(this.tokens.links){var te=Object.keys(this.tokens.links);if(te.length>0)for(;(z=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)te.includes(z[0].slice(z[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,z.index)+"["+M("a",z[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(z=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,z.index)+"["+M("a",z[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(z=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,z.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;a;)if(Y||(q=""),Y=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(oe){return(s=oe.call({lexer:R},a,D))?(a=a.substring(s.raw.length),D.push(s),!0):!1}))){if(s=this.tokenizer.escape(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.tag(a)){a=a.substring(s.raw.length),k=D[D.length-1],k&&s.type==="text"&&k.type==="text"?(k.raw+=s.raw,k.text+=s.text):D.push(s);continue}if(s=this.tokenizer.link(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.reflink(a,this.tokens.links)){a=a.substring(s.raw.length),k=D[D.length-1],k&&s.type==="text"&&k.type==="text"?(k.raw+=s.raw,k.text+=s.text):D.push(s);continue}if(s=this.tokenizer.emStrong(a,L,q)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.codespan(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.br(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.del(a)){a=a.substring(s.raw.length),D.push(s);continue}if(s=this.tokenizer.autolink(a,ye)){a=a.substring(s.raw.length),D.push(s);continue}if(!this.state.inLink&&(s=this.tokenizer.url(a,ye))){a=a.substring(s.raw.length),D.push(s);continue}if(T=a,this.options.extensions&&this.options.extensions.startInline&&function(){var oe=1/0,Te=a.slice(1),ke=void 0;R.options.extensions.startInline.forEach(function(Me){ke=Me.call({lexer:this},Te),typeof ke=="number"&&ke>=0&&(oe=Math.min(oe,ke))}),oe<1/0&&oe>=0&&(T=a.substring(0,oe+1))}(),s=this.tokenizer.inlineText(T,de)){a=a.substring(s.raw.length),s.raw.slice(-1)!=="_"&&(q=s.raw.slice(-1)),Y=!0,k=D[D.length-1],k&&k.type==="text"?(k.raw+=s.raw,k.text+=s.text):D.push(s);continue}if(a){var ce="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return D},i(O,null,[{key:"rules",get:function(){return{block:G,inline:ee}}}]),O}(),je=function(){function O(y){this.options=y||se.defaults}var u=O.prototype;return u.code=function(a,D,R){var s=(D||"").match(/\S*/)[0];if(this.options.highlight){var k=this.options.highlight(a,s);k!=null&&k!==a&&(R=!0,a=k)}return a=a.replace(/\n$/,"")+`
`,s?'<pre><code class="'+this.options.langPrefix+e(s,!0)+'">'+(R?a:e(a,!0))+`</code></pre>
`:"<pre><code>"+(R?a:e(a,!0))+`</code></pre>
`},u.blockquote=function(a){return`<blockquote>
`+a+`</blockquote>
`},u.html=function(a){return a},u.heading=function(a,D,R,s){if(this.options.headerIds){var k=this.options.headerPrefix+s.slug(R);return"<h"+D+' id="'+k+'">'+a+"</h"+D+`>
`}return"<h"+D+">"+a+"</h"+D+`>
`},u.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},u.list=function(a,D,R){var s=D?"ol":"ul",k=D&&R!==1?' start="'+R+'"':"";return"<"+s+k+`>
`+a+"</"+s+`>
`},u.listitem=function(a){return"<li>"+a+`</li>
`},u.checkbox=function(a){return"<input "+(a?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},u.paragraph=function(a){return"<p>"+a+`</p>
`},u.table=function(a,D){return D&&(D="<tbody>"+D+"</tbody>"),`<table>
<thead>
`+a+`</thead>
`+D+`</table>
`},u.tablerow=function(a){return`<tr>
`+a+`</tr>
`},u.tablecell=function(a,D){var R=D.header?"th":"td",s=D.align?"<"+R+' align="'+D.align+'">':"<"+R+">";return s+a+("</"+R+`>
`)},u.strong=function(a){return"<strong>"+a+"</strong>"},u.em=function(a){return"<em>"+a+"</em>"},u.codespan=function(a){return"<code>"+a+"</code>"},u.br=function(){return this.options.xhtml?"<br/>":"<br>"},u.del=function(a){return"<del>"+a+"</del>"},u.link=function(a,D,R){if(a=b(this.options.sanitize,this.options.baseUrl,a),a===null)return R;var s='<a href="'+e(a)+'"';return D&&(s+=' title="'+D+'"'),s+=">"+R+"</a>",s},u.image=function(a,D,R){if(a=b(this.options.sanitize,this.options.baseUrl,a),a===null)return R;var s='<img src="'+a+'" alt="'+R+'"';return D&&(s+=' title="'+D+'"'),s+=this.options.xhtml?"/>":">",s},u.text=function(a){return a},O}(),le=function(){function O(){}var u=O.prototype;return u.strong=function(a){return a},u.em=function(a){return a},u.codespan=function(a){return a},u.del=function(a){return a},u.html=function(a){return a},u.text=function(a){return a},u.link=function(a,D,R){return""+R},u.image=function(a,D,R){return""+R},u.br=function(){return""},O}(),_=function(){function O(){this.seen={}}var u=O.prototype;return u.serialize=function(a){return a.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},u.getNextSafeSlug=function(a,D){var R=a,s=0;if(this.seen.hasOwnProperty(R)){s=this.seen[a];do s++,R=a+"-"+s;while(this.seen.hasOwnProperty(R))}return D||(this.seen[a]=s,this.seen[R]=0),R},u.slug=function(a,D){D===void 0&&(D={});var R=this.serialize(a);return this.getNextSafeSlug(R,D.dryrun)},O}(),fe=function(){function O(y){this.options=y||se.defaults,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}O.parse=function(a,D){var R=new O(D);return R.parse(a)},O.parseInline=function(a,D){var R=new O(D);return R.parseInline(a)};var u=O.prototype;return u.parse=function(a,D){D===void 0&&(D=!0);var R="",s,k,T,L,z,Y,q,te,ce,oe,Te,ke,Me,Ee,Ne,Ue,Ye,_e,et,tt=a.length;for(s=0;s<tt;s++){if(oe=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[oe.type]&&(et=this.options.extensions.renderers[oe.type].call({parser:this},oe),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(oe.type))){R+=et||"";continue}switch(oe.type){case"space":continue;case"hr":{R+=this.renderer.hr();continue}case"heading":{R+=this.renderer.heading(this.parseInline(oe.tokens),oe.depth,o(this.parseInline(oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{R+=this.renderer.code(oe.text,oe.lang,oe.escaped);continue}case"table":{for(te="",q="",L=oe.header.length,k=0;k<L;k++)q+=this.renderer.tablecell(this.parseInline(oe.header[k].tokens),{header:!0,align:oe.align[k]});for(te+=this.renderer.tablerow(q),ce="",L=oe.rows.length,k=0;k<L;k++){for(Y=oe.rows[k],q="",z=Y.length,T=0;T<z;T++)q+=this.renderer.tablecell(this.parseInline(Y[T].tokens),{header:!1,align:oe.align[T]});ce+=this.renderer.tablerow(q)}R+=this.renderer.table(te,ce);continue}case"blockquote":{ce=this.parse(oe.tokens),R+=this.renderer.blockquote(ce);continue}case"list":{for(Te=oe.ordered,ke=oe.start,Me=oe.loose,L=oe.items.length,ce="",k=0;k<L;k++)Ne=oe.items[k],Ue=Ne.checked,Ye=Ne.task,Ee="",Ne.task&&(_e=this.renderer.checkbox(Ue),Me?Ne.tokens.length>0&&Ne.tokens[0].type==="paragraph"?(Ne.tokens[0].text=_e+" "+Ne.tokens[0].text,Ne.tokens[0].tokens&&Ne.tokens[0].tokens.length>0&&Ne.tokens[0].tokens[0].type==="text"&&(Ne.tokens[0].tokens[0].text=_e+" "+Ne.tokens[0].tokens[0].text)):Ne.tokens.unshift({type:"text",text:_e}):Ee+=_e),Ee+=this.parse(Ne.tokens,Me),ce+=this.renderer.listitem(Ee,Ye,Ue);R+=this.renderer.list(ce,Te,ke);continue}case"html":{R+=this.renderer.html(oe.text);continue}case"paragraph":{R+=this.renderer.paragraph(this.parseInline(oe.tokens));continue}case"text":{for(ce=oe.tokens?this.parseInline(oe.tokens):oe.text;s+1<tt&&a[s+1].type==="text";)oe=a[++s],ce+=`
`+(oe.tokens?this.parseInline(oe.tokens):oe.text);R+=D?this.renderer.paragraph(ce):ce;continue}default:{var We='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}}return R},u.parseInline=function(a,D){D=D||this.renderer;var R="",s,k,T,L=a.length;for(s=0;s<L;s++){if(k=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[k.type]&&(T=this.options.extensions.renderers[k.type].call({parser:this},k),T!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(k.type))){R+=T||"";continue}switch(k.type){case"escape":{R+=D.text(k.text);break}case"html":{R+=D.html(k.text);break}case"link":{R+=D.link(k.href,k.title,this.parseInline(k.tokens,D));break}case"image":{R+=D.image(k.href,k.title,k.text);break}case"strong":{R+=D.strong(this.parseInline(k.tokens,D));break}case"em":{R+=D.em(this.parseInline(k.tokens,D));break}case"codespan":{R+=D.codespan(k.text);break}case"br":{R+=D.br();break}case"del":{R+=D.del(this.parseInline(k.tokens,D));break}case"text":{R+=D.text(k.text);break}default:{var z='Token with "'+k.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return R},O}();function he(O,u,y){if(typeof O>"u"||O===null)throw new Error("marked(): input parameter is undefined or null");if(typeof O!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(O)+", string expected");if(typeof u=="function"&&(y=u,u=null),u=w({},he.defaults,u||{}),x(u),y){var a=u.highlight,D;try{D=Ae.lex(O,u)}catch(L){return y(L)}var R=function(z){var Y;if(!z)try{u.walkTokens&&he.walkTokens(D,u.walkTokens),Y=fe.parse(D,u)}catch(q){z=q}return u.highlight=a,z?y(z):y(null,Y)};if(!a||a.length<3||(delete u.highlight,!D.length))return R();var s=0;he.walkTokens(D,function(L){L.type==="code"&&(s++,setTimeout(function(){a(L.text,L.lang,function(z,Y){if(z)return R(z);Y!=null&&Y!==L.text&&(L.text=Y,L.escaped=!0),s--,s===0&&R()})},0))}),s===0&&R();return}function k(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(L.message+"",!0)+"</pre>";throw L}try{var T=Ae.lex(O,u);if(u.walkTokens){if(u.async)return Promise.all(he.walkTokens(T,u.walkTokens)).then(function(){return fe.parse(T,u)}).catch(k);he.walkTokens(T,u.walkTokens)}return fe.parse(T,u)}catch(L){k(L)}}he.options=he.setOptions=function(O){return w(he.defaults,O),A(he.defaults),he},he.getDefaults=E,he.defaults=se.defaults,he.use=function(){for(var O=arguments.length,u=new Array(O),y=0;y<O;y++)u[y]=arguments[y];var a=w.apply(void 0,[{}].concat(u)),D=he.defaults.extensions||{renderers:{},childTokens:{}},R;u.forEach(function(s){if(s.extensions&&(R=!0,s.extensions.forEach(function(T){if(!T.name)throw new Error("extension name required");if(T.renderer){var L=D.renderers?D.renderers[T.name]:null;L?D.renderers[T.name]=function(){for(var z=arguments.length,Y=new Array(z),q=0;q<z;q++)Y[q]=arguments[q];var te=T.renderer.apply(this,Y);return te===!1&&(te=L.apply(this,Y)),te}:D.renderers[T.name]=T.renderer}if(T.tokenizer){if(!T.level||T.level!=="block"&&T.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");D[T.level]?D[T.level].unshift(T.tokenizer):D[T.level]=[T.tokenizer],T.start&&(T.level==="block"?D.startBlock?D.startBlock.push(T.start):D.startBlock=[T.start]:T.level==="inline"&&(D.startInline?D.startInline.push(T.start):D.startInline=[T.start]))}T.childTokens&&(D.childTokens[T.name]=T.childTokens)})),s.renderer&&function(){var T=he.defaults.renderer||new je,L=function(q){var te=T[q];T[q]=function(){for(var ce=arguments.length,oe=new Array(ce),Te=0;Te<ce;Te++)oe[Te]=arguments[Te];var ke=s.renderer[q].apply(T,oe);return ke===!1&&(ke=te.apply(T,oe)),ke}};for(var z in s.renderer)L(z);a.renderer=T}(),s.tokenizer&&function(){var T=he.defaults.tokenizer||new ue,L=function(q){var te=T[q];T[q]=function(){for(var ce=arguments.length,oe=new Array(ce),Te=0;Te<ce;Te++)oe[Te]=arguments[Te];var ke=s.tokenizer[q].apply(T,oe);return ke===!1&&(ke=te.apply(T,oe)),ke}};for(var z in s.tokenizer)L(z);a.tokenizer=T}(),s.walkTokens){var k=he.defaults.walkTokens;a.walkTokens=function(T){var L=[];return L.push(s.walkTokens.call(this,T)),k&&(L=L.concat(k.call(this,T))),L}}R&&(a.extensions=D),he.setOptions(a)})},he.walkTokens=function(O,u){for(var y=[],a=function(){var k=R.value;switch(y=y.concat(u.call(he,k)),k.type){case"table":{for(var T=U(k.header),L;!(L=T()).done;){var z=L.value;y=y.concat(he.walkTokens(z.tokens,u))}for(var Y=U(k.rows),q;!(q=Y()).done;)for(var te=q.value,ce=U(te),oe;!(oe=ce()).done;){var Te=oe.value;y=y.concat(he.walkTokens(Te.tokens,u))}break}case"list":{y=y.concat(he.walkTokens(k.items,u));break}default:he.defaults.extensions&&he.defaults.extensions.childTokens&&he.defaults.extensions.childTokens[k.type]?he.defaults.extensions.childTokens[k.type].forEach(function(ke){y=y.concat(he.walkTokens(k[ke],u))}):k.tokens&&(y=y.concat(he.walkTokens(k.tokens,u)))}},D=U(O),R;!(R=D()).done;)a();return y},he.parseInline=function(O,u){if(typeof O>"u"||O===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof O!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(O)+", string expected");u=w({},he.defaults,u||{}),x(u);try{var y=Ae.lexInline(O,u);return u.walkTokens&&he.walkTokens(y,u.walkTokens),fe.parseInline(y,u)}catch(a){if(a.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(a.message+"",!0)+"</pre>";throw a}},he.Parser=fe,he.parser=fe.parse,he.Renderer=je,he.TextRenderer=le,he.Lexer=Ae,he.lexer=Ae.lex,he.Tokenizer=ue,he.Slugger=_,he.parse=he;var Fe=he.options,Z=he.setOptions,pe=he.use,Se=he.walkTokens,Re=he.parseInline,re=he,me=fe.parse,J=Ae.lex;se.Lexer=Ae,se.Parser=fe,se.Renderer=je,se.Slugger=_,se.TextRenderer=le,se.Tokenizer=ue,se.getDefaults=E,se.lexer=J,se.marked=he,se.options=Fe,se.parse=re,se.parseInline=Re,se.parser=me,se.setOptions=Z,se.use=pe,se.walkTokens=Se,Object.defineProperty(se,"__esModule",{value:!0})}),define(we[89],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zk=i;function i(n){const o=U(n);if(o&&o.length>0)return new Uint32Array(o)}let C=0;const B=new Uint32Array(10);function U(n){if(C=0,E(n,P,4352),C>0||(E(n,c,4449),C>0)||(E(n,l,4520),C>0)||(E(n,e,12593),C))return B.subarray(0,C);if(n>=44032&&n<=55203){const o=n-44032,f=o%588,h=Math.floor(o/588),v=Math.floor(f/28),m=f%28-1;if(h<P.length?E(h,P,0):4352+h-12593<e.length&&E(4352+h,e,12593),v<c.length?E(v,c,0):4449+v-12593<e.length&&E(4449+v-12593,e,12593),m>=0&&(m<l.length?E(m,l,0):4520+m-12593<e.length&&E(4520+m-12593,e,12593)),C>0)return B.subarray(0,C)}}function E(n,o,f){n>=f&&n<f+o.length&&A(o[n-f])}function A(n){n!==0&&(B[C++]=n&255,n>>8&&(B[C++]=n>>8&255),n>>16&&(B[C++]=n>>16&255))}var d;(function(n){n[n.InitialConsonant=4352]="InitialConsonant",n[n.Vowel=4449]="Vowel",n[n.FinalConsonant=4520]="FinalConsonant",n[n.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var g;(function(n){n[n.NUL=0]="NUL",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z"})(g||(g={}));var $;(function(n){n[n.fa=24934]="fa",n[n.fg=26470]="fg",n[n.fq=29030]="fq",n[n.fr=29286]="fr",n[n.ft=29798]="ft",n[n.fv=30310]="fv",n[n.fx=30822]="fx",n[n.hk=27496]="hk",n[n.hl=27752]="hl",n[n.ho=28520]="ho",n[n.ml=27757]="ml",n[n.nj=27246]="nj",n[n.nl=27758]="nl",n[n.np=28782]="np",n[n.qt=29809]="qt",n[n.rt=29810]="rt",n[n.sg=26483]="sg",n[n.sw=30579]="sw"})($||($={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),l=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(we[90],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QU=void 0;class i{constructor(B,U=0,E=B.length,A=U-1){this.a=B,this.b=U,this.c=E,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$QU=i}),define(we[91],ve([1,0,90]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SU=t.$RU=void 0;class C{constructor(E=[],A=10){this.h(E),this.b=A,this.d()}getHistory(){return this.j}add(E){this.a.delete(E),this.a.add(E),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(E){return this.a.has(E)}clear(){this.h([]),this.d()}d(){this.f();const E=this.j;this.c=new i.$QU(E,0,E.length,E.length)}f(){const E=this.j;E.length>this.b&&this.h(E.slice(E.length-this.b))}g(){const E=this.c.current();return E?this.j.indexOf(E):-1}h(E){this.a=new Set;for(const A of E)this.a.add(A)}get j(){const E=[];return this.a.forEach(A=>E.push(A)),E}}t.$RU=C;class B{get size(){return this.f}constructor(E,A=10){if(this.g=A,E.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:E[0],previous:void 0,next:void 0},this.a=new Set([E[0]]);for(let d=1;d<E.length;d++)this.add(E[d])}add(E){const A={value:E,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(E)?this.h(E):this.a.add(E);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(E){if(this.c.value===E)return E;const A=this.c.value;return this.a.delete(A),this.c.value=E,this.a.has(E)?this.h(E):this.a.add(E),A}prepend(E){if(this.f===this.g||this.a.has(E))return;const A={value:E,previous:void 0,next:this.b};this.b.previous=A,this.b=A,this.f++,this.a.add(E)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(E){return this.a.has(E)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let E=this.b;for(;E;)yield E.value,E=E.next}h(E){let A=this.b;for(;A!==this.c;)A.value===E&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.$SU=B}),define(we[40],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jm=t.$Im=t.$Hm=void 0,t.$Fm=i,t.rot=C;function i(A,d,g){return Math.min(Math.max(A,d),g)}function C(A,d){return(d+A%d)%d}class B{constructor(){this.a=0}getNext(){return this.a++}}t.$Hm=B;class U{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Im=U;class E{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const g=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Jm=E}),define(we[26],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=void 0,t.$bd=U,t.$cd=c;class i{constructor(e,n,o){this.owner=e,this.debugNameSource=n,this.referenceFn=o}getDebugName(e){return U(e,this)}}t.$ad=i;const C=new Map,B=new WeakMap;function U(l,e){const n=B.get(l);if(n)return n;const o=E(l,e);if(o){let f=C.get(o)??0;f++,C.set(o,f);const h=f===1?o:`${o}#${f}`;return B.set(l,h),h}}function E(l,e){const n=B.get(l);if(n)return n;const o=e.owner?$(e.owner)+".":"";let f;const h=e.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(f=h(),f!==void 0)return o+f}else return o+h;const v=e.referenceFn;if(v!==void 0&&(f=c(v),f!==void 0))return o+f;if(e.owner!==void 0){const m=A(e.owner,l);if(m!==void 0)return o+m}}function A(l,e){for(const n in l)if(l[n]===e)return n}const d=new Map,g=new WeakMap;function $(l){const e=g.get(l);if(e)return e;const n=P(l);let o=d.get(n)??0;o++,d.set(n,o);const f=o===1?n:`${n}#${o}`;return g.set(l,f),f}function P(l){const e=l.constructor;return e?e.name:"Object"}function c(l){const e=l.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(we[27],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jd=void 0,t.$Hd=C,t.$Id=B;let i;function C(n){i=n}function B(){return i}class U{constructor(){this.a=0,this.d=new WeakMap}b(o){return E([A(l("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[A(" "),g($(o.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),g($(o.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),g($(o.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(o,f){console.log(...this.b([d("observable value changed"),g(o.debugName,{color:"BlueViolet"}),...this.c(f)]))}formatChanges(o){if(o.size!==0)return g(" (changed deps: "+[...o].map(f=>f.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const f=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,v)=>(this.d.get(o).add(h),f.apply(o,[h,v]))}handleDerivedRecomputed(o,f){const h=this.d.get(o);console.log(...this.b([d("derived recomputed"),g(o.debugName,{color:"BlueViolet"}),...this.c(f),this.formatChanges(h),{data:[{fn:o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,f){console.log(...this.b([d("observable from event triggered"),g(o.debugName,{color:"BlueViolet"}),...this.c(f),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const f=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,v)=>(this.d.get(o).add(h),f.apply(o,[h,v]))}handleAutorunTriggered(o){const f=this.d.get(o);console.log(...this.b([d("autorun"),g(o.debugName,{color:"BlueViolet"}),this.formatChanges(f),{data:[{fn:o._runFn}]}])),f.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let f=o.getDebugName();f===void 0&&(f=""),console.log(...this.b([d("transaction"),g(f,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Jd=U;function E(n){const o=new Array,f=[];let h="";function v(b){if("length"in b)for(const r of b)r&&v(r);else"text"in b?(h+=`%c${b.text}`,o.push(b.style),b.data&&f.push(...b.data)):"data"in b&&f.push(...b.data)}v(n);const m=[h,...o];return m.push(...f),m}function A(n){return g(n,{color:"black"})}function d(n){return g(e(`${n}: `,10),{color:"black",bold:!0})}function g(n,o={color:"black"}){function f(v){return Object.entries(v).reduce((m,[b,r])=>`${m}${b}:${r};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:n,style:f(h)}}function $(n,o){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=o?`"${n}"`:`"${n.substr(0,o-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?P(n,o):c(n,o);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function P(n,o){let f="[ ",h=!0;for(const v of n){if(h||(f+=", "),f.length-5>o){f+="...";break}h=!1,f+=`${$(v,o-f.length)}`}return f+=" ]",f}function c(n,o){let f="{ ",h=!0;for(const[v,m]of Object.entries(n)){if(h||(f+=", "),f.length-5>o){f+="...";break}h=!1,f+=`${v}: ${$(m,o-f.length)}`}return f+=" }",f}function l(n,o){let f="";for(let h=1;h<=o;h++)f+=n;return f}function e(n,o){for(;n.length<o;)n+=" ";return n}}),define(we[41],ve([1,0,37,2,26,27]),function(se,t,i,C,B,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pd=void 0,t.$jd=E,t.$kd=A,t.$ld=d,t.$md=g,t.$nd=$,t.$od=P;function E(e){return new l(new B.$ad(void 0,void 0,e),e,void 0,void 0)}function A(e,n){return new l(new B.$ad(e.owner,e.debugName,e.debugReferenceFn??n),n,void 0,void 0)}function d(e,n){return new l(new B.$ad(e.owner,e.debugName,e.debugReferenceFn??n),n,e.createEmptyChangeSummary,e.handleChange)}function g(e,n){const o=new C.$Tc,f=d({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(h,v)=>{o.clear(),n(h,v,o)});return(0,C.$Sc)(()=>{f.dispose(),o.dispose()})}function $(e){const n=new C.$Tc,o=A({owner:void 0,debugName:void 0,debugReferenceFn:e},f=>{n.clear(),e(f,n)});return(0,C.$Sc)(()=>{o.dispose(),n.dispose()})}function P(e,n){let o;return A({debugReferenceFn:n},f=>{const h=e.read(f),v=o;o=h,n({lastValue:v,newValue:h})})}var c;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(c||(c={}));class l{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(n,o,f,h){this.h=n,this._runFn=o,this.i=f,this.j=h,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,U.$Id)()?.handleAutorunCreated(this),this.k(),(0,C.$Lc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,C.$Mc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const o=this.c;try{if(!o){(0,U.$Id)()?.handleAutorunTriggered(this);const f=this.g;this.g=this.i?.(),this._runFn(this,f)}}finally{o||(0,U.$Id)()?.handleAutorunFinished(this);for(const f of this.f)f.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,i.$hd)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,o){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:o,didChange:h=>h===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const o=n.get();return this.e.add(n),this.f.delete(n),o}}t.$pd=l,function(e){e.Observer=l}(E||(t.$jd=E={}))}),define(we[33],ve([1,0,38,26,27]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7d=t.$5d=t.$2d=t.$Wd=t.$Vd=void 0,t.$Sd=E,t.$Td=d,t.$Ud=$,t.$Xd=l,t.$Yd=n,t.$Zd=o,t.$1d=f,t.$3d=v,t.$4d=m,t.$6d=r;let U;function E(S){U=S}let A;function d(S){A=S}let g;function $(S){g=S}class P{get TChange(){return null}reportChanges(){this.get()}read(F){return F?F.readObservable(this):this.get()}map(F,I){const H=I===void 0?void 0:F,w=I===void 0?F:I;return g({owner:H,debugName:()=>{const j=(0,C.$cd)(w);if(j!==void 0)return j;const N=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(w.toString());if(N)return`${this.debugName}.${N[2]}`;if(!H)return`${this.debugName} (mapped)`},debugReferenceFn:w},j=>w(this.read(j),j))}recomputeInitiallyAndOnChange(F,I){return F.add(U(this,I)),this}keepObserved(F){return F.add(A(this)),this}get a(){return this.get()}}t.$Vd=P;class c extends P{constructor(){super(...arguments),this.b=new Set}addObserver(F){const I=this.b.size;this.b.add(F),I===0&&this.c()}removeObserver(F){this.b.delete(F)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Wd=c;function l(S,F){const I=new h(S,F);try{S(I)}finally{I.finish()}}let e;function n(S){if(e)S(e);else{const F=new h(S,void 0);e=F;try{S(F)}finally{F.finish(),e=void 0}}}async function o(S,F){const I=new h(S,F);try{await S(I)}finally{I.finish()}}function f(S,F,I){S?F(S):l(F,I)}class h{constructor(F,I){this._fn=F,this.b=I,this.a=[],(0,B.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,C.$cd)(this._fn)}updateObserver(F,I){this.a.push({observer:F,observable:I}),F.beginUpdate(I)}finish(){const F=this.a;for(let I=0;I<F.length;I++){const{observer:H,observable:w}=F[I];H.endUpdate(w)}this.a=null,(0,B.$Id)()?.handleEndTransaction()}}t.$2d=h;function v(S,F){let I;return typeof S=="string"?I=new C.$ad(void 0,S,void 0):I=new C.$ad(S,void 0,void 0),new b(I,F,i.$6c)}function m(S,F){return new b(new C.$ad(S.owner,S.debugName,void 0),F,S.equalsFn??i.$6c)}class b extends c{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(F,I,H){super(),this.e=F,this.g=H,this.d=I}get(){return this.d}set(F,I,H){if(H===void 0&&this.g(this.d,F))return;let w;I||(I=w=new h(()=>{},()=>`Setting ${this.debugName}`));try{const j=this.d;this.h(F),(0,B.$Id)()?.handleObservableChanged(this,{oldValue:j,newValue:F,change:H,didChange:!0,hadValue:!0});for(const W of this.b)I.updateObserver(W,this),W.handleChange(this,H)}finally{w&&w.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(F){this.d=F}}t.$5d=b;function r(S,F){let I;return typeof S=="string"?I=new C.$ad(void 0,S,void 0):I=new C.$ad(S,void 0,void 0),new p(I,F,i.$6c)}class p extends b{h(F){this.d!==F&&(this.d&&this.d.dispose(),this.d=F)}dispose(){this.d?.dispose()}}t.$7d=p}),define(we[42],ve([1,0,37,38,2,33,26,27]),function(se,t,i,C,B,U,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rd=t.$Qd=void 0,t.$Kd=d,t.$Ld=g,t.$Md=$,t.$Nd=P,t.$Od=c,t.$Pd=l;function d(f,h){return h!==void 0?new n(new E.$ad(f,void 0,h),h,void 0,void 0,void 0,C.$6c):new n(new E.$ad(void 0,void 0,f),f,void 0,void 0,void 0,C.$6c)}function g(f,h,v){return new o(new E.$ad(f,void 0,h),h,void 0,void 0,void 0,C.$6c,v)}function $(f,h){return new n(new E.$ad(f.owner,f.debugName,f.debugReferenceFn),h,void 0,void 0,f.onLastObserverRemoved,f.equalsFn??C.$6c)}(0,U.$Ud)($);function P(f,h){return new n(new E.$ad(f.owner,f.debugName,void 0),h,f.createEmptyChangeSummary,f.handleChange,void 0,f.equalityComparer??C.$6c)}function c(f,h){let v,m;h===void 0?(v=f,m=void 0):(m=f,v=h);const b=new B.$Tc;return new n(new E.$ad(m,void 0,v),r=>(b.clear(),v(r,b)),void 0,void 0,()=>b.dispose(),C.$6c)}function l(f,h){let v,m;h===void 0?(v=f,m=void 0):(m=f,v=h);const b=new B.$Tc;return new n(new E.$ad(m,void 0,v),r=>{b.clear();const p=v(r);return p&&b.add(p),p},void 0,void 0,()=>b.dispose(),C.$6c)}var e;(function(f){f[f.initial=0]="initial",f[f.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",f[f.stale=2]="stale",f[f.upToDate=3]="upToDate"})(e||(e={}));class n extends U.$Wd{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor(h,v,m,b,r=void 0,p){super(),this.m=h,this._computeFn=v,this.n=m,this.p=b,this.q=r,this.s=p,this.e=0,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,A.$Id)()?.handleDerivedCreated(this)}f(){this.e=0,this.g=void 0;for(const h of this.j)h.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const h=this._computeFn(this,this.n?.());return this.f(),h}else{do{if(this.e===1){for(const h of this.j)if(h.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.g}}u(){if(this.e===3)return;const h=this.k;this.k=this.j,this.j=h;const v=this.e!==0,m=this.g;this.e=3;const b=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,b)}finally{for(const p of this.k)p.removeObserver(this);this.k.clear()}const r=v&&!this.s(m,this.g);if((0,A.$Id)()?.handleDerivedRecomputed(this,{oldValue:m,newValue:this.g,change:void 0,didChange:r,hadValue:v}),r)for(const p of this.b)p.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(h){this.h++;const v=this.h===1;if(this.e===3&&(this.e=1,!v))for(const m of this.b)m.handlePossibleChange(this);if(v)for(const m of this.b)m.beginUpdate(this)}endUpdate(h){if(this.h--,this.h===0){const v=[...this.b];for(const m of v)m.endUpdate(this)}(0,i.$hd)(()=>this.h>=0)}handlePossibleChange(h){if(this.e===3&&this.j.has(h)&&!this.k.has(h)){this.e=1;for(const v of this.b)v.handlePossibleChange(this)}}handleChange(h,v){if(this.j.has(h)&&!this.k.has(h)){const m=this.p?this.p({changedObservable:h,change:v,didChange:r=>r===h},this.l):!0,b=this.e===3;if(m&&(this.e===1||b)&&(this.e=2,b))for(const r of this.b)r.handlePossibleChange(this)}}readObservable(h){h.addObserver(this);const v=h.get();return this.j.add(h),this.k.delete(h),v}addObserver(h){const v=!this.b.has(h)&&this.h>0;super.addObserver(h),v&&h.beginUpdate(this)}removeObserver(h){const v=this.b.has(h)&&this.h>0;super.removeObserver(h),v&&h.endUpdate(this)}}t.$Qd=n;class o extends n{constructor(h,v,m,b,r=void 0,p,S){super(h,v,m,b,r,p),this.set=S}}t.$Rd=o}),define(we[56],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(C){function B(d,g){if(d.start>=g.end||g.start>=d.end)return{start:0,end:0};const $=Math.max(d.start,g.start),P=Math.min(d.end,g.end);return P-$<=0?{start:0,end:0}:{start:$,end:P}}C.intersect=B;function U(d){return d.end-d.start<=0}C.isEmpty=U;function E(d,g){return!U(B(d,g))}C.intersects=E;function A(d,g){const $=[],P={start:d.start,end:Math.min(g.start,d.end)},c={start:Math.max(g.end,d.start),end:d.end};return U(P)||$.push(P),U(c)||$.push(c),$}C.relativeComplement=A})(i||(t.Range=i={}))}),define(we[92],ve([1,0,56]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wT=void 0,t.$tT=C,t.$uT=B,t.$vT=U;function C(d,g){const $=[];for(const P of g){if(d.start>=P.range.end)continue;if(d.end<P.range.start)break;const c=i.Range.intersect(d,P.range);i.Range.isEmpty(c)||$.push({range:c,size:P.size})}return $}function B({start:d,end:g},$){return{start:d+$,end:g+$}}function U(d){const g=[];let $=null;for(const P of d){const c=P.range.start,l=P.range.end,e=P.size;if($&&e===$.size){$.range.end=l;continue}$={range:{start:c,end:l},size:e},g.push($)}return g}function E(...d){return U(d.reduce((g,$)=>g.concat($),[]))}class A{get paddingTop(){return this.c}set paddingTop(g){this.b=this.b+g-this.c,this.c=g}constructor(g){this.a=[],this.b=0,this.c=0,this.c=g??0,this.b=this.c}splice(g,$,P=[]){const c=P.length-$,l=C({start:0,end:g},this.a),e=C({start:g+$,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:B(o.range,c),size:o.size})),n=P.map((o,f)=>({range:{start:g+f,end:g+f+1},size:o.size}));this.a=E(l,n,e),this.b=this.c+this.a.reduce((o,f)=>o+f.size*(f.range.end-f.range.start),0)}get count(){const g=this.a.length;return g?this.a[g-1].range.end:0}get size(){return this.b}indexAt(g){if(g<0)return-1;if(g<this.c)return 0;let $=0,P=this.c;for(const c of this.a){const l=c.range.end-c.range.start,e=P+l*c.size;if(g<e)return $+Math.floor((g-P)/c.size);$+=l,P=e}return $}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let $=0,P=0;for(const c of this.a){const l=c.range.end-c.range.start,e=P+l;if(g<e)return this.c+$+(g-P)*c.size;$+=l*c.size,P=e}return-1}}t.$wT=A}),define(we[93],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(U){return new C(U)}constructor(U){this.c=i&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$be=C}),define(we[3],ve([1,0,6,53,2,55,93]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$de=t.Event=void 0,t.$ee=l;const A=!1,d=!1,g=!1;var $;(function(ue){ue.None=()=>B.$Uc.None;function G(L){if(g){const{onDidAddListener:z}=L,Y=n.create();let q=0;L.onDidAddListener=()=>{++q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),z?.()}}}function ee(L,z){return Z(L,()=>{},0,void 0,!0,void 0,z)}ue.defer=ee;function de(L){return(z,Y=null,q)=>{let te=!1,ce;return ce=L(oe=>{if(!te)return ce?ce.dispose():te=!0,z.call(Y,oe)},null,q),te&&ce.dispose(),ce}}ue.once=de;function ye(L,z,Y){return he((q,te=null,ce)=>L(oe=>q.call(te,z(oe)),null,ce),Y)}ue.map=ye;function Ae(L,z,Y){return he((q,te=null,ce)=>L(oe=>{z(oe),q.call(te,oe)},null,ce),Y)}ue.forEach=Ae;function je(L,z,Y){return he((q,te=null,ce)=>L(oe=>z(oe)&&q.call(te,oe),null,ce),Y)}ue.filter=je;function le(L){return L}ue.signal=le;function _(...L){return(z,Y=null,q)=>{const te=(0,B.$Rc)(...L.map(ce=>ce(oe=>z.call(Y,oe))));return Fe(te,q)}}ue.any=_;function fe(L,z,Y,q){let te=Y;return ye(L,ce=>(te=z(te,ce),te),q)}ue.reduce=fe;function he(L,z){let Y;const q={onWillAddFirstListener(){Y=L(te.fire,te)},onDidRemoveLastListener(){Y?.dispose()}};z||G(q);const te=new p(q);return z?.add(te),te.event}function Fe(L,z){return z instanceof Array?z.push(L):z&&z.add(L),L}function Z(L,z,Y=100,q=!1,te=!1,ce,oe){let Te,ke,Me,Ee=0,Ne;const Ue={leakWarningThreshold:ce,onWillAddFirstListener(){Te=L(_e=>{Ee++,ke=z(ke,_e),q&&!Me&&(Ye.fire(ke),ke=void 0),Ne=()=>{const et=ke;ke=void 0,Me=void 0,(!q||Ee>1)&&Ye.fire(et),Ee=0},typeof Y=="number"?(clearTimeout(Me),Me=setTimeout(Ne,Y)):Me===void 0&&(Me=0,queueMicrotask(Ne))})},onWillRemoveListener(){te&&Ee>0&&Ne?.()},onDidRemoveLastListener(){Ne=void 0,Te.dispose()}};oe||G(Ue);const Ye=new p(Ue);return oe?.add(Ye),Ye.event}ue.debounce=Z;function pe(L,z=0,Y){return ue.debounce(L,(q,te)=>q?(q.push(te),q):[te],z,void 0,!0,void 0,Y)}ue.accumulate=pe;function Se(L,z=(q,te)=>q===te,Y){let q=!0,te;return je(L,ce=>{const oe=q||!z(ce,te);return q=!1,te=ce,oe},Y)}ue.latch=Se;function Re(L,z,Y){return[ue.filter(L,z,Y),ue.filter(L,q=>!z(q),Y)]}ue.split=Re;function re(L,z=!1,Y=[],q){let te=Y.slice(),ce=L(ke=>{te?te.push(ke):Te.fire(ke)});q&&q.add(ce);const oe=()=>{te?.forEach(ke=>Te.fire(ke)),te=null},Te=new p({onWillAddFirstListener(){ce||(ce=L(ke=>Te.fire(ke)),q&&q.add(ce))},onDidAddFirstListener(){te&&(z?setTimeout(oe):oe())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return q&&q.add(Te),Te.event}ue.buffer=re;function me(L,z){return(q,te,ce)=>{const oe=z(new O);return L(function(Te){const ke=oe.evaluate(Te);ke!==J&&q.call(te,ke)},void 0,ce)}}ue.chain=me;const J=Symbol("HaltChainable");class O{constructor(){this.f=[]}map(z){return this.f.push(z),this}forEach(z){return this.f.push(Y=>(z(Y),Y)),this}filter(z){return this.f.push(Y=>z(Y)?Y:J),this}reduce(z,Y){let q=Y;return this.f.push(te=>(q=z(q,te),q)),this}latch(z=(Y,q)=>Y===q){let Y=!0,q;return this.f.push(te=>{const ce=Y||!z(te,q);return Y=!1,q=te,ce?te:J}),this}evaluate(z){for(const Y of this.f)if(z=Y(z),z===J)break;return z}}function u(L,z,Y=q=>q){const q=(...Te)=>oe.fire(Y(...Te)),te=()=>L.on(z,q),ce=()=>L.removeListener(z,q),oe=new p({onWillAddFirstListener:te,onDidRemoveLastListener:ce});return oe.event}ue.fromNodeEventEmitter=u;function y(L,z,Y=q=>q){const q=(...Te)=>oe.fire(Y(...Te)),te=()=>L.addEventListener(z,q),ce=()=>L.removeEventListener(z,q),oe=new p({onWillAddFirstListener:te,onDidRemoveLastListener:ce});return oe.event}ue.fromDOMEventEmitter=y;function a(L){return new Promise(z=>de(L)(z))}ue.toPromise=a;function D(L){const z=new p;return L.then(Y=>{z.fire(Y)},()=>{z.fire(void 0)}).finally(()=>{z.dispose()}),z.event}ue.fromPromise=D;function R(L,z,Y){return z(Y),L(q=>z(q))}ue.runAndSubscribe=R;class s{constructor(z,Y){this._observable=z,this.f=0,this.g=!1;const q={onWillAddFirstListener:()=>{z.addObserver(this)},onDidRemoveLastListener:()=>{z.removeObserver(this)}};Y||G(q),this.emitter=new p(q),Y&&Y.add(this.emitter)}beginUpdate(z){this.f++}handlePossibleChange(z){}handleChange(z,Y){this.g=!0}endUpdate(z){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function k(L,z){return new s(L,z).emitter.event}ue.fromObservable=k;function T(L){return(z,Y,q)=>{let te=0,ce=!1;const oe={beginUpdate(){te++},endUpdate(){te--,te===0&&(L.reportChanges(),ce&&(ce=!1,z.call(Y)))},handlePossibleChange(){},handleChange(){ce=!0}};L.addObserver(oe),L.reportChanges();const Te={dispose(){L.removeObserver(oe)}};return q instanceof B.$Tc?q.add(Te):Array.isArray(q)&&q.push(Te),Te}}ue.fromObservableLight=T})($||(t.Event=$={}));class P{static{this.all=new Set}static{this.f=0}constructor(G){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${G}_${P.f++}`,P.all.add(this)}start(G){this.g=new E.$be,this.listenerCount=G}stop(){if(this.g){const G=this.g.elapsed();this.durations.push(G),this.elapsedOverall+=G,this.invocationCount+=1,this.g=void 0}}}t.$de=P;let c=-1;function l(ue){const G=c;return c=ue,{dispose(){c=G}}}class e{constructor(G,ee,de=Math.random().toString(18).slice(2,5)){this.h=G,this.threshold=ee,this.name=de,this.g=0}dispose(){this.f?.clear()}check(G,ee){const de=this.threshold;if(de<=0||ee<de)return;this.f||(this.f=new Map);const ye=this.f.get(G.value)||0;if(this.f.set(G.value,ye+1),this.g-=1,this.g<=0){this.g=de*.5;const[Ae,je]=this.getMostFrequentStack(),le=`[${this.name}] potential listener LEAK detected, having ${ee} listeners already. MOST frequent listener (${je}):`;console.warn(le),console.warn(Ae);const _=new o(le,Ae);this.h(_)}return()=>{const Ae=this.f.get(G.value)||0;this.f.set(G.value,Ae-1)}}getMostFrequentStack(){if(!this.f)return;let G,ee=0;for(const[de,ye]of this.f)(!G||ee<ye)&&(G=[de,ye],ee=ye);return G}}class n{static create(){const G=new Error;return new n(G.stack??"")}constructor(G){this.value=G}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o extends Error{constructor(G,ee){super(G),this.name="ListenerLeakError",this.stack=ee}}t.$fe=o;class f extends Error{constructor(G,ee){super(G),this.name="ListenerRefusalError",this.stack=ee}}t.$ge=f;let h=0;class v{constructor(G){this.value=G,this.id=h++}}const m=2,b=(ue,G)=>{if(ue instanceof v)G(ue);else for(let ee=0;ee<ue.length;ee++){const de=ue[ee];de&&G(de)}},r=A?new FinalizationRegistry(ue=>{typeof ue=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(ue))}):void 0;class p{constructor(G){this.w=0,this.f=G,this.g=c>0||this.f?.leakWarningThreshold?new e(G?.onListenerError??i.$1,this.f?.leakWarningThreshold??c):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(d){const G=this.t;queueMicrotask(()=>{b(G,ee=>ee.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(G,ee,de)=>{if(this.g&&this.w>this.g.threshold*3){const _=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w}/${this.g.threshold})`;console.warn(_);const fe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],he=new f(`${_}. HINT: Stack shows most frequent listener (${fe[1]}-times)`,fe[0]);return(this.f?.onListenerError||i.$1)(he),B.$Uc.None}if(this.m)return B.$Uc.None;ee&&(G=G.bind(ee));const ye=new v(G);let Ae,je;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ye.stack=n.create(),Ae=this.g.check(ye.stack,this.w+1)),d&&(ye.stack=je??n.create()),this.t?this.t instanceof v?(this.u??=new F,this.t=[this.t,ye]):this.t.push(ye):(this.f?.onWillAddFirstListener?.(this),this.t=ye,this.f?.onDidAddFirstListener?.(this)),this.w++;const le=(0,B.$Sc)(()=>{r?.unregister(le),Ae?.(),this.x(ye)});if(de instanceof B.$Tc?de.add(le):Array.isArray(de)&&de.push(le),r){const _=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(le,_,le)}return le},this.q}x(G){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const ee=this.t,de=ee.indexOf(G);if(de===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,ee[de]=void 0;const ye=this.u.current===this;if(this.w*m<=ee.length){let Ae=0;for(let je=0;je<ee.length;je++)ee[je]?ee[Ae++]=ee[je]:ye&&(this.u.end--,Ae<this.u.i&&this.u.i--);ee.length=Ae}}y(G,ee){if(!G)return;const de=this.f?.onListenerError||i.$1;if(!de){G.value(ee);return}try{G.value(ee)}catch(ye){de(ye)}}z(G){const ee=G.current.t;for(;G.i<G.end;)this.y(ee[G.i++],G.value);G.reset()}fire(G){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof v)this.y(this.t,G);else{const ee=this.u;ee.enqueue(this,G,this.t.length),this.z(ee)}this.j?.stop()}hasListeners(){return this.w>0}}t.$he=p;const S=()=>new F;t.$ie=S;class F{constructor(){this.i=-1,this.end=0}enqueue(G,ee,de){this.i=0,this.end=de,this.current=G,this.value=ee}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class I extends p{async fireAsync(G,ee,de){if(this.t)for(this.h||(this.h=new U.$5c),b(this.t,ye=>this.h.push([ye.value,G]));this.h.size>0&&!ee.isCancellationRequested;){const[ye,Ae]=this.h.shift(),je=[],le={...Ae,token:ee,waitUntil:_=>{if(Object.isFrozen(je))throw new Error("waitUntil can NOT be called asynchronous");de&&(_=de(_,ye)),je.push(_)}};try{ye(le)}catch(_){(0,i.$1)(_);continue}Object.freeze(je),await Promise.allSettled(je).then(_=>{for(const fe of _)fe.status==="rejected"&&(0,i.$1)(fe.reason)})}}}t.$je=I;class H extends p{get isPaused(){return this.h!==0}constructor(G){super(G),this.h=0,this.s=new U.$5c,this.A=G?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const G=Array.from(this.s);this.s.clear(),super.fire(this.A(G))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(G){this.w&&(this.h!==0?this.s.push(G):super.fire(G))}}t.$ke=H;class w extends H{constructor(G){super(G),this.k=G.delay??100}fire(G){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(G)}}t.$le=w;class j extends p{constructor(G){super(G),this.h=[],this.k=G?.merge}fire(G){this.hasListeners()&&(this.h.push(G),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ee=>super.fire(ee)),this.h=[]}))}}t.$me=j;class W{constructor(){this.g=!1,this.h=[],this.f=new p({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(G){const ee={event:G,listener:null};this.h.push(ee),this.g&&this.m(ee);const de=()=>{this.g&&this.o(ee);const ye=this.h.indexOf(ee);this.h.splice(ye,1)};return(0,B.$Sc)((0,C.$db)(de))}j(){this.g=!0,this.h.forEach(G=>this.m(G))}k(){this.g=!1,this.h.forEach(G=>this.o(G))}m(G){G.listener=G.event(ee=>this.f.fire(ee))}o(G){G.listener?.dispose(),G.listener=null}dispose(){this.f.dispose();for(const G of this.h)G.listener?.dispose();this.h=[]}}t.$ne=W;class N{constructor(G,ee,de,ye){this.f=new B.$Tc;const Ae=this.f.add(new W),je=this.f.add(new B.$4c);function le(_){je.set(_,Ae.add(ye(_)))}for(const _ of G)le(_);this.f.add(ee(_=>{le(_)})),this.f.add(de(_=>{je.deleteAndDispose(_)})),this.event=Ae.event}dispose(){this.f.dispose()}}t.$oe=N;class x{constructor(){this.f=[]}wrapEvent(G,ee,de){return(ye,Ae,je)=>G(le=>{const _=this.f[this.f.length-1];if(!ee){_?_.buffers.push(()=>ye.call(Ae,le)):ye.call(Ae,le);return}const fe=_;if(!fe){ye.call(Ae,ee(de,le));return}fe.items??=[],fe.items.push(le),fe.buffers.length===0&&_.buffers.push(()=>{fe.reducedResult??=de?fe.items.reduce(ee,de):fe.items.reduce(ee),ye.call(Ae,fe.reducedResult)})},void 0,je)}bufferEvents(G){const ee={buffers:new Array};this.f.push(ee);const de=G();return this.f.pop(),ee.buffers.forEach(ye=>ye()),de}}t.$pe=x;class M{constructor(){this.f=!1,this.g=$.None,this.h=B.$Uc.None,this.j=new p({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(G){this.g=G,this.f&&(this.h.dispose(),this.h=G(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$qe=M;class Q{static const(G){return new ie(G)}constructor(G){this.g=G,this.f=new p,this.onDidChange=this.f.event}get value(){return this.g}set value(G){G!==this.g&&(this.g=G,this.f.fire(void 0))}}t.$re=Q;class ie{constructor(G){this.value=G,this.onDidChange=$.None}}}),define(we[17],ve([1,0,22,3]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Q=t.$8Q=t.$7Q=t.$6Q=t.$5Q=t.$4Q=t.$3Q=t.$2Q=t.$WQ=void 0,t.$TQ=U,t.$UQ=E,t.$VQ=A,t.$XQ=d,t.$YQ=g,t.$ZQ=$,t.$1Q=P,t.$0Q=e,t.$$Q=n;class B{constructor(){this.a=new Map,this.b=new C.$he,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new C.$he,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new B}getZoomLevel(f){return this.a.get(this.f(f))??0}setZoomLevel(f,h){if(this.getZoomLevel(h)===f)return;const v=this.f(h);this.a.set(v,f),this.b.fire(v)}getZoomFactor(f){return this.c.get(this.f(f))??1}setZoomFactor(f,h){this.c.set(this.f(h),f)}setFullscreen(f,h){if(this.isFullscreen(h)===f)return;const v=this.f(h);this.e.set(v,f),this.d.fire(v)}isFullscreen(f){return!!this.e.get(this.f(f))}f(f){return f.vscodeWindowId}}function U(o,f,h){typeof f=="string"&&(f=o.matchMedia(f)),f.addEventListener("change",h)}function E(o,f){B.INSTANCE.setZoomLevel(o,f)}function A(o){return B.INSTANCE.getZoomLevel(o)}t.$WQ=B.INSTANCE.onDidChangeZoomLevel;function d(o){return B.INSTANCE.getZoomFactor(o)}function g(o,f){B.INSTANCE.setZoomFactor(o,f)}function $(o,f){B.INSTANCE.setFullscreen(o,f)}function P(o){return B.INSTANCE.isFullscreen(o)}t.$2Q=B.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.$3Q=c.indexOf("Firefox")>=0,t.$4Q=c.indexOf("AppleWebKit")>=0,t.$5Q=c.indexOf("Chrome")>=0,t.$6Q=!t.$5Q&&c.indexOf("Safari")>=0,t.$7Q=!t.$5Q&&!t.$6Q&&t.$4Q,t.$8Q=c.indexOf("Electron/")>=0,t.$9Q=c.indexOf("Android")>=0;let l=!1;if(typeof i.$QQ.matchMedia=="function"){const o=i.$QQ.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),f=i.$QQ.matchMedia("(display-mode: fullscreen)");l=o.matches,U(i.$QQ,o,({matches:h})=>{l&&f.matches||(l=h)})}function e(){return l}function n(){return navigator?.windowControlsOverlay?.visible}}),define(we[24],ve([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=void 0;class C{get event(){return this.a.event}constructor(U,E,A){const d=g=>this.a.fire(g);this.a=new i.$he({onWillAddFirstListener:()=>U.addEventListener(E,d,A),onDidRemoveLastListener:()=>U.removeEventListener(E,d,A)})}dispose(){this.a.dispose()}}t.$oT=C}),define(we[34],ve([1,0,3]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$se=t.CancellationToken=void 0,t.$te=A;const C=Object.freeze(function(d,g){const $=setTimeout(d.bind(g),0);return{dispose(){clearTimeout($)}}});var B;(function(d){function g($){return $===d.None||$===d.Cancelled||$ instanceof U?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}d.isCancellationToken=g,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(B||(t.CancellationToken=B={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new i.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(g){this.f=void 0,this.g=void 0,this.g=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=B.Cancelled}dispose(g=!1){g&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=B.None}}t.$se=E;function A(d){const g=new E;return d.add({dispose(){g.cancel()}}),g.token}}),define(we[94],ve([1,0,34]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8e=t.$7e=t.$5e=void 0,t.$6e=B;class C{constructor(d){this.b=d,this.a=null}get(){if(this.a)return this.a;const d=new i.$se,g=this.b(d.token);return this.a={promise:g,dispose:()=>{this.a=null,d.cancel(),d.dispose()}},this.a}}t.$5e=C;function B(A){return A}class U{constructor(d,g){this.a=void 0,this.b=void 0,typeof d=="function"?(this.c=d,this.d=B):(this.c=g,this.d=d.getCacheKey)}get(d){const g=this.d(d);return this.b!==g&&(this.b=g,this.a=this.c(d)),this.a}}t.$7e=U;class E{get cachedValues(){return this.a}constructor(d,g){this.a=new Map,this.b=new Map,typeof d=="function"?(this.c=d,this.d=B):(this.c=g,this.d=d.getCacheKey)}get(d){const g=this.d(d);if(this.b.has(g))return this.b.get(g);const $=this.c(d);return this.a.set(d,$),this.b.set(g,$),$}}t.$8e=E}),define(we[95],ve([1,0,41,33,42,34,26,38,6]),function(se,t,i,C,B,U,E,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$d=t.$0d=t.$9d=t.$8d=void 0,t.$_d=l,t.$ae=e;class g{get cachedValue(){return this.a}constructor(o){this.b=o,this.a=(0,C.$3d)(this,void 0)}getValue(){let o=this.a.get();return o||(o=this.b(),this.a.set(o,void 0)),o}}t.$8d=g;class ${constructor(o){this.a=(0,C.$3d)(this,void 0),this.promiseResult=this.a,this.promise=o.then(f=>((0,C.$Xd)(h=>{this.a.set(new P(f,void 0),h)}),f),f=>{throw(0,C.$Xd)(h=>{this.a.set(new P(void 0,f),h)}),f})}}t.$9d=$;class P{constructor(o,f){this.data=o,this.error=f}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$0d=P;class c{constructor(o){this.b=o,this.a=new g(()=>new $(this.b())),this.cachedPromiseResult=(0,B.$Kd)(this,f=>this.a.cachedValue.read(f)?.promiseResult.read(f))}getPromise(){return this.a.getValue().promise}}t.$$d=c;function l(n,o,f,h){return o||(o=v=>v!=null),new Promise((v,m)=>{let b=!0,r=!1;const p=n.map(F=>({isFinished:o(F),error:f?f(F):!1,state:F})),S=(0,i.$jd)(F=>{const{isFinished:I,error:H,state:w}=p.read(F);(I||H)&&(b?r=!0:S.dispose(),H?m(H===!0?w:H):v(w))});if(h){const F=h.onCancellationRequested(()=>{S.dispose(),F.dispose(),m(new d.$5)});if(h.isCancellationRequested){S.dispose(),F.dispose(),m(new d.$5);return}}b=!1,r&&S.dispose()})}function e(n,o){let f,h;o===void 0?(f=n,h=void 0):(h=n,f=o);let v;return new B.$Qd(new E.$ad(h,void 0,f),m=>(v&&v.dispose(!0),v=new U.$se,f(m,v.token)),void 0,void 0,()=>v?.dispose(),A.$6c)}}),define(we[96],ve([1,0,3,2,41,33,26,42,27]),function(se,t,i,C,B,U,E,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fd=t.$Bd=t.$td=void 0,t.$qd=g,t.$rd=P,t.$sd=c,t.$ud=e,t.$vd=o,t.$wd=h,t.$xd=v,t.$yd=m,t.$zd=b,t.$Ad=r,t.$Cd=S,t.$Dd=F,t.$Ed=I,t.$Gd=j;function g(W){return new $(W)}class $ extends U.$Vd{constructor(N){super(),this.b=N}get debugName(){return this.toString()}get(){return this.b}addObserver(N){}removeObserver(N){}toString(){return`Const: ${this.b}`}}function P(W){const N=(0,U.$3d)("promiseValue",{});return W.then(x=>{N.set({value:x},void 0)}),N}function c(W,N){return new l(W,N)}class l extends U.$Wd{constructor(N,x){super(),this.j=N,this._getValue=x,this.g=!1,this.n=M=>{const Q=this._getValue(M),ie=this.e,ue=!this.g||ie!==Q;let G=!1;ue&&(this.e=Q,this.g&&(G=!0,(0,U.$1d)(l.globalTransaction,ee=>{(0,d.$Id)()?.handleFromEventObservableTriggered(this,{oldValue:ie,newValue:Q,change:void 0,didChange:ue,hadValue:this.g});for(const de of this.b)ee.updateObserver(de,this),de.handleChange(this,void 0)},()=>{const ee=this.k();return"Event fired"+(ee?`: ${ee}`:"")})),this.g=!0),G||(0,d.$Id)()?.handleFromEventObservableTriggered(this,{oldValue:ie,newValue:Q,change:void 0,didChange:ue,hadValue:this.g})}}k(){return(0,E.$cd)(this._getValue)}get debugName(){const N=this.k();return"From Event"+(N?`: ${N}`:"")}c(){this.h=this.j(this.n)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.n(void 0),this.e):this._getValue(void 0)}}t.$td=l,function(W){W.Observer=l;function N(x,M){let Q=!1;l.globalTransaction===void 0&&(l.globalTransaction=x,Q=!0);try{M()}finally{Q&&(l.globalTransaction=void 0)}}W.batchEventsGlobally=N}(c||(t.$sd=c={}));function e(W,N){return new n(W,N)}class n extends U.$Wd{constructor(N,x){super(),this.debugName=N,this.g=x,this.j=()=>{(0,U.$Xd)(M=>{for(const Q of this.b)M.updateObserver(Q,this),Q.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function o(W){return typeof W=="string"?new f(W):new f(void 0,W)}class f extends U.$Wd{get debugName(){return new E.$ad(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(N,x){super(),this.e=N,this.g=x}trigger(N,x){if(!N){(0,U.$Xd)(M=>{this.trigger(M,x)},()=>`Trigger signal ${this.debugName}`);return}for(const M of this.b)N.updateObserver(M,this),M.handleChange(this,x)}get(){}}function h(W,N,x){const M=(0,U.$3d)("debounced",void 0);let Q;return x.add((0,B.$jd)(ie=>{const ue=W.read(ie);Q&&clearTimeout(Q),Q=setTimeout(()=>{(0,U.$Xd)(G=>{M.set(ue,G)})},N)})),M}function v(W,N){let x=!1,M,Q;return c(ie=>{const ue=(0,B.$jd)(G=>{const ee=W.read(G);x?(Q&&clearTimeout(Q),Q=setTimeout(()=>{M=ee,ie()},N)):(x=!0,M=ee)});return{dispose(){ue.dispose(),x=!1,M=void 0}}},()=>x?M:W.get())}function m(W,N,x){const M=(0,U.$3d)("triggeredRecently",!1);let Q;return x.add(W(()=>{M.set(!0,void 0),Q&&clearTimeout(Q),Q=setTimeout(()=>{M.set(!1,void 0)},N)})),M}function b(W){const N=new p(!1,void 0);return W.addObserver(N),(0,C.$Sc)(()=>{W.removeObserver(N)})}(0,U.$Td)(b);function r(W,N){const x=new p(!0,N);return W.addObserver(x),N?N(W.get()):W.reportChanges(),(0,C.$Sc)(()=>{W.removeObserver(x)})}(0,U.$Sd)(r);class p{constructor(N,x){this.b=N,this.c=x,this.a=0}beginUpdate(N){this.a++}endUpdate(N){this.a--,this.a===0&&this.b&&(this.c?this.c(N.get()):N.reportChanges())}handlePossibleChange(N){}handleChange(N,x){}}t.$Bd=p;function S(W,N){let x;return(0,A.$Kd)(W,Q=>(x=N(Q,x),x))}function F(W,N){let x;const M=o("derivedObservableWithWritableCache"),Q=(0,A.$Kd)(W,ie=>(M.read(ie),x=N(ie,x),x));return Object.assign(Q,{clearCache:ie=>{x=void 0,M.trigger(ie)},setCache:(ie,ue)=>{x=ie,M.trigger(ue)}})}function I(W,N,x,M){let Q=new H(x,M);return(0,A.$Md)({debugReferenceFn:x,owner:W,onLastObserverRemoved:()=>{Q.dispose(),Q=new H(x)}},ue=>(Q.setItems(N.read(ue)),Q.getItems()))}class H{constructor(N,x){this.c=N,this.e=x,this.a=new Map,this.b=[]}dispose(){this.a.forEach(N=>N.store.dispose()),this.a.clear()}setItems(N){const x=[],M=new Set(this.a.keys());for(const Q of N){const ie=this.e?this.e(Q):Q;let ue=this.a.get(ie);if(ue)M.delete(ie);else{const G=new C.$Tc;ue={out:this.c(Q,G),store:G},this.a.set(ie,ue)}x.push(ue.out)}for(const Q of M)this.a.get(Q).store.dispose(),this.a.delete(Q);this.b=x}getItems(){return this.b}}class w{constructor(N){this.observable=N}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Fd=w;function j(W,N){return N instanceof w?N.observable:c(N.onDidChange,()=>N.value)}}),define(we[57],ve([1,0,33,42,41,96,95,27]),function(se,t,i,C,B,U,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$3d}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$6d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$Xd}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$1d}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return C.$Kd}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return C.$Md}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return C.$Nd}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return C.$Od}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return B.$jd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return B.$od}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return B.$ld}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return B.$nd}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return B.$kd}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return B.$md}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return U.$qd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return U.$wd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return U.$Cd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return U.$Dd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return U.$zd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return U.$Ad}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return U.$sd}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return U.$rd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return U.$vd}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return U.$ud}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return U.$yd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return E.$8d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return E.$$d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return E.$9d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return E.$0d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return E.$_d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return E.$ae}}),!1&&(0,A.$Hd)(new A.$Jd)}),define(we[58],ve([1,0,3,2]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5s=t.$4s=t.$3s=t.$2s=t.ScrollbarVisibility=void 0;var B;(function(l){l[l.Auto=1]="Auto",l[l.Hidden=2]="Hidden",l[l.Visible=3]="Visible"})(B||(t.ScrollbarVisibility=B={}));class U{constructor(e,n,o,f,h,v,m){this.c=e,this._scrollStateBrand=void 0,this.c&&(n=n|0,o=o|0,f=f|0,h=h|0,v=v|0,m=m|0),this.rawScrollLeft=f,this.rawScrollTop=m,n<0&&(n=0),f+n>o&&(f=o-n),f<0&&(f=0),h<0&&(h=0),m+h>v&&(m=v-h),m<0&&(m=0),this.width=n,this.scrollWidth=o,this.scrollLeft=f,this.height=h,this.scrollHeight=v,this.scrollTop=m}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,n){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,n?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,n?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,n){const o=this.width!==e.width,f=this.scrollWidth!==e.scrollWidth,h=this.scrollLeft!==e.scrollLeft,v=this.height!==e.height,m=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:n,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:f,scrollLeftChanged:h,heightChanged:v,scrollHeightChanged:m,scrollTopChanged:b}}}t.$2s=U;class E extends C.$Uc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$he),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,n){const o=this.g.withScrollDimensions(e,n);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const n=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(n,!1)}setScrollPositionSmooth(e,n){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let f;n?f=new $(this.h.from,o,this.h.startTime,this.h.duration):f=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=f}else{const o=this.g.withScrollPosition(e);this.h=$.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),n=this.g.withScrollPosition(e);if(this.n(n,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,n){const o=this.g;o.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(o,n)))}}t.$3s=E;class A{constructor(e,n,o){this.scrollLeft=e,this.scrollTop=n,this.isDone=o}}t.$4s=A;function d(l,e){const n=e-l;return function(o){return l+n*c(o)}}function g(l,e,n){return function(o){return o<n?l(o/n):e((o-n)/(1-n))}}class ${constructor(e,n,o,f){this.from=e,this.to=n,this.duration=f,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,n,o){if(Math.abs(e-n)>2.5*o){let h,v;return e<n?(h=e+.75*o,v=n-.75*o):(h=e-.75*o,v=n+.75*o),g(d(e,h),d(v,n),.33)}return d(e,n)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const n=(e-this.startTime)/this.duration;if(n<1){const o=this.c(n),f=this.d(n);return new A(o,f,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,n,o){return $.start(e,n,o)}static start(e,n,o){o=o+10;const f=Date.now()-10;return new $(e,n,f,o)}}t.$5s=$;function P(l){return Math.pow(l,3)}function c(l){return 1-P(1-l)}}),define(we[97],ve([1,0,6,2]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ue=B,t.$ve=U,t.$we=E,t.$xe=A,t.$ye=g,t.$ze=$,t.$Ae=P,t.$Be=c,t.$Ce=l,t.$De=e,t.$Ee=n,t.$Fe=o,t.$Ge=f,t.$He=h,t.$Ie=v;function B(m){const b=m;return b?typeof b.read=="function":!1}function U(m){const b=m;return b?[b.on,b.pause,b.resume,b.destroy].every(r=>typeof r=="function"):!1}function E(m){const b=m;return b?U(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}function A(m,b){return new d(m,b)}class d{constructor(b,r){this.e=b,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(r=>r(b))}h(b){this.c.error.length===0?(0,i.$1)(b):this.c.error.slice(0).forEach(r=>r(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,r){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(b,r){if(this.a.destroyed)return;let p;switch(b){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const S=p.indexOf(r);S>=0&&p.splice(S,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(m,b){const r=[];let p;for(;(p=m.read())!==null;)r.push(p);return b(r)}function $(m,b,r){const p=[];let S;for(;(S=m.read())!==null&&p.length<r;)p.push(S);return S===null&&p.length>0?b(p):{read:()=>{if(p.length>0)return p.shift();if(typeof S<"u"){const F=S;return S=void 0,F}return m.read()}}}function P(m,b){return new Promise((r,p)=>{const S=[];c(m,{onData:F=>{b&&S.push(F)},onError:F=>{b?p(F):r(void 0)},onEnd:()=>{r(b?b(S):void 0)}})})}function c(m,b,r){m.on("error",p=>{r?.isCancellationRequested||b.onError(p)}),m.on("end",()=>{r?.isCancellationRequested||b.onEnd()}),m.on("data",p=>{r?.isCancellationRequested||b.onData(p)})}function l(m,b){return new Promise((r,p)=>{const S=new C.$Tc,F=[],I=j=>{if(F.push(j),F.length>b)return S.dispose(),m.pause(),r({stream:m,buffer:F,ended:!1})},H=j=>(S.dispose(),p(j)),w=()=>(S.dispose(),r({stream:m,buffer:F,ended:!0}));S.add((0,C.$Sc)(()=>m.removeListener("error",H))),m.on("error",H),S.add((0,C.$Sc)(()=>m.removeListener("end",w))),m.on("end",w),S.add((0,C.$Sc)(()=>m.removeListener("data",I))),m.on("data",I)})}function e(m,b){const r=A(b);return r.end(m),r}function n(){const m=A(()=>{throw new Error("not supported")});return m.end(),m}function o(m){let b=!1;return{read:()=>b?null:(b=!0,m)}}function f(m,b,r){const p=A(r);return c(m,{onData:S=>p.write(b.data(S)),onError:S=>p.error(b.error?b.error(S):S),onEnd:()=>p.end()}),p}function h(m,b,r){let p=!1;return{read:()=>{const S=b.read();return p?S:(p=!0,S!==null?r([m,S]):m)}}}function v(m,b,r){let p=!1;const S=A(r);return c(b,{onData:F=>p?S.write(F):(p=!0,S.write(r([m,F]))),onError:F=>S.error(F),onEnd:()=>{p||(p=!0,S.write(m)),S.end()}}),S}}),define(we[43],ve([1,0,23,97]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Je=void 0,t.$Ke=g,t.$Le=$,t.$Me=P,t.$Ne=c,t.$Oe=l,t.$Pe=e,t.$Qe=n,t.$Re=o,t.$Se=f,t.$Te=h,t.$Ue=v,t.$Ve=m,t.$We=b,t.$Xe=r,t.$Ye=p,t.$Ze=S,t.$1e=F,t.$2e=I,t.$3e=H,t.$4e=W;const B=typeof Buffer<"u",U=new i.$V(()=>new Uint8Array(256));let E,A;class d{static alloc(x){return B?new d(Buffer.allocUnsafe(x)):new d(new Uint8Array(x))}static wrap(x){return B&&!Buffer.isBuffer(x)&&(x=Buffer.from(x.buffer,x.byteOffset,x.byteLength)),new d(x)}static fromString(x,M){return!(M?.dontUseNodeBuffer||!1)&&B?new d(Buffer.from(x)):(E||(E=new TextEncoder),new d(E.encode(x)))}static fromByteArray(x){const M=d.alloc(x.length);for(let Q=0,ie=x.length;Q<ie;Q++)M.buffer[Q]=x[Q];return M}static concat(x,M){if(typeof M>"u"){M=0;for(let ue=0,G=x.length;ue<G;ue++)M+=x[ue].byteLength}const Q=d.alloc(M);let ie=0;for(let ue=0,G=x.length;ue<G;ue++){const ee=x[ue];Q.set(ee,ie),ie+=ee.byteLength}return Q}constructor(x){this.buffer=x,this.byteLength=this.buffer.byteLength}clone(){const x=d.alloc(this.byteLength);return x.set(this),x}toString(){return B?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(x,M){return new d(this.buffer.subarray(x,M))}set(x,M){if(x instanceof d)this.buffer.set(x.buffer,M);else if(x instanceof Uint8Array)this.buffer.set(x,M);else if(x instanceof ArrayBuffer)this.buffer.set(new Uint8Array(x),M);else if(ArrayBuffer.isView(x))this.buffer.set(new Uint8Array(x.buffer,x.byteOffset,x.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(x){return c(this.buffer,x)}writeUInt32BE(x,M){l(this.buffer,x,M)}readUInt32LE(x){return e(this.buffer,x)}writeUInt32LE(x,M){n(this.buffer,x,M)}readUInt8(x){return o(this.buffer,x)}writeUInt8(x,M){f(this.buffer,x,M)}indexOf(x,M=0){return g(this.buffer,x instanceof d?x.buffer:x,M)}}t.$Je=d;function g(N,x,M=0){const Q=x.byteLength,ie=N.byteLength;if(Q===0)return 0;if(Q===1)return N.indexOf(x[0]);if(Q>ie-M)return-1;const ue=U.value;ue.fill(x.length);for(let ye=0;ye<x.length;ye++)ue[x[ye]]=x.length-ye-1;let G=M+x.length-1,ee=G,de=-1;for(;G<ie;)if(N[G]===x[ee]){if(ee===0){de=G;break}G--,ee--}else G+=Math.max(x.length-ee,ue[N[G]]),ee=x.length-1;return de}function $(N,x){return N[x+0]<<0>>>0|N[x+1]<<8>>>0}function P(N,x,M){N[M+0]=x&255,x=x>>>8,N[M+1]=x&255}function c(N,x){return N[x]*2**24+N[x+1]*2**16+N[x+2]*2**8+N[x+3]}function l(N,x,M){N[M+3]=x,x=x>>>8,N[M+2]=x,x=x>>>8,N[M+1]=x,x=x>>>8,N[M]=x}function e(N,x){return N[x+0]<<0>>>0|N[x+1]<<8>>>0|N[x+2]<<16>>>0|N[x+3]<<24>>>0}function n(N,x,M){N[M+0]=x&255,x=x>>>8,N[M+1]=x&255,x=x>>>8,N[M+2]=x&255,x=x>>>8,N[M+3]=x&255}function o(N,x){return N[x]}function f(N,x,M){N[M]=x}function h(N){return C.$ye(N,x=>d.concat(x))}function v(N){return C.$Fe(N)}function m(N){return C.$Ae(N,x=>d.concat(x))}async function b(N){return N.ended?d.concat(N.buffer):d.concat([...N.buffer,await m(N.stream)])}function r(N){return C.$De(N,x=>d.concat(x))}function p(N){return C.$Ge(N,{data:x=>typeof x=="string"?d.fromString(x):d.wrap(x)},x=>d.concat(x))}function S(N){return C.$xe(x=>d.concat(x),N)}function F(N,x){return C.$He(N,x,M=>d.concat(M))}function I(N,x){return C.$Ie(N,x,M=>d.concat(M))}function H(N){let x=0,M=0,Q=0;const ie=new Uint8Array(Math.floor(N.length/4*3)),ue=ee=>{switch(M){case 3:ie[Q++]=x|ee,M=0;break;case 2:ie[Q++]=x|ee>>>2,x=ee<<6,M=3;break;case 1:ie[Q++]=x|ee>>>4,x=ee<<4,M=2;break;default:x=ee<<2,M=1}};for(let ee=0;ee<N.length;ee++){const de=N.charCodeAt(ee);if(de>=65&&de<=90)ue(de-65);else if(de>=97&&de<=122)ue(de-97+26);else if(de>=48&&de<=57)ue(de-48+52);else if(de===43||de===45)ue(62);else if(de===47||de===95)ue(63);else{if(de===61)break;throw new SyntaxError(`Unexpected base64 character ${N[ee]}`)}}const G=Q;for(;M>0;)ue(0);return d.wrap(ie).slice(0,G)}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function W({buffer:N},x=!0,M=!1){const Q=M?j:w;let ie="";const ue=N.byteLength%3;let G=0;for(;G<N.byteLength-ue;G+=3){const ee=N[G+0],de=N[G+1],ye=N[G+2];ie+=Q[ee>>>2],ie+=Q[(ee<<4|de>>>4)&63],ie+=Q[(de<<2|ye>>>6)&63],ie+=Q[ye&63]}if(ue===1){const ee=N[G+0];ie+=Q[ee>>>2],ie+=Q[ee<<4&63],x&&(ie+="==")}else if(ue===2){const ee=N[G+0],de=N[G+1];ie+=Q[ee>>>2],ie+=Q[(ee<<4|de>>>4)&63],ie+=Q[de<<2&63],x&&(ie+="=")}return ie}}),define(we[9],ve([1,0,94,23]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_f=t.$$f=t.$0f=t.GraphemeBreakType=t.$Zf=t.$Rf=t.$Kf=t.$Jf=void 0,t.$$e=B,t.$_e=E,t.$af=d,t.$bf=g,t.$cf=$,t.$df=P,t.$ef=c,t.$ff=l,t.$gf=e,t.$hf=n,t.$if=o,t.$jf=f,t.$kf=h,t.$lf=v,t.$mf=m,t.$nf=b,t.$of=r,t.$pf=p,t.$qf=S,t.$rf=F,t.$sf=I,t.$tf=H,t.$uf=w,t.$vf=j,t.$wf=W,t.$xf=N,t.$yf=x,t.$zf=M,t.$Af=Q,t.$Bf=ie,t.$Cf=ue,t.$Df=G,t.$Ef=ee,t.$Ff=de,t.$Gf=ye,t.$Hf=Ae,t.$If=je,t.$Lf=he,t.$Mf=Fe,t.$Nf=Z,t.$Of=pe,t.$Pf=re,t.$Qf=J,t.$Sf=O,t.$Tf=u,t.$Uf=y,t.$Vf=a,t.$Wf=R,t.$Xf=s,t.$Yf=T,t.$1f=L,t.$2f=z,t.$3f=Y,t.$4f=q,t.$5f=te,t.$6f=ce,t.$7f=oe,t.$8f=Te,t.$9f=Ue;function B(X){return!X||typeof X!="string"?!0:X.trim().length===0}const U=/{(\d+)}/g;function E(X,...ae){return ae.length===0?X:X.replace(U,function($e,De){const Le=parseInt(De,10);return isNaN(Le)||Le<0||Le>=ae.length?$e:ae[Le]})}const A=/{([^}]+)}/g;function d(X,ae){return Object.keys(ae).length===0?X:X.replace(A,($e,De)=>ae[De]??$e)}function g(X){return X.replace(/[<>"'&]/g,ae=>{switch(ae){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ae})}function $(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}function P(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(X,ae){let $e=0,De=X.indexOf(ae);for(;De!==-1;)$e++,De=X.indexOf(ae,De+ae.length);return $e}function l(X,ae,$e="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${$e}`}function e(X,ae,$e="\u2026"){if(X.length<=ae)return X;const De=Math.ceil(ae/2)-$e.length/2,Le=Math.floor(ae/2)-$e.length/2;return`${X.substr(0,De)}${$e}${X.substr(X.length-Le)}`}function n(X,ae=" "){const $e=o(X,ae);return f($e,ae)}function o(X,ae){if(!X||!ae)return X;const $e=ae.length;if($e===0||X.length===0)return X;let De=0;for(;X.indexOf(ae,De)===De;)De=De+$e;return X.substring(De)}function f(X,ae){if(!X||!ae)return X;const $e=ae.length,De=X.length;if($e===0||De===0)return X;let Le=De,ze=-1;for(;ze=X.lastIndexOf(ae,Le-1),!(ze===-1||ze+$e!==Le);){if(ze===0)return"";Le=ze}return X.substring(0,Le)}function h(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function v(X){return X.replace(/\*/g,"")}function m(X,ae,$e={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=P(X)),$e.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let De="";return $e.global&&(De+="g"),$e.matchCase||(De+="i"),$e.multiline&&(De+="m"),$e.unicode&&(De+="u"),new RegExp(X,De)}function b(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}function r(X){return X.split(/\r\n|\r|\n/)}function p(X){const ae=[],$e=X.split(/(\r\n|\r|\n)/);for(let De=0;De<Math.ceil($e.length/2);De++)ae.push($e[2*De]+($e[2*De+1]??""));return ae}function S(X){for(let ae=0,$e=X.length;ae<$e;ae++){const De=X.charCodeAt(ae);if(De!==32&&De!==9)return ae}return-1}function F(X,ae=0,$e=X.length){for(let De=ae;De<$e;De++){const Le=X.charCodeAt(De);if(Le!==32&&Le!==9)return X.substring(ae,De)}return X.substring(ae,$e)}function I(X,ae=X.length-1){for(let $e=ae;$e>=0;$e--){const De=X.charCodeAt($e);if(De!==32&&De!==9)return $e}return-1}function H(X,ae,$e){const De=[];let Le=0;for(const ze of X.matchAll(ae)){if(De.push(X.slice(Le,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Le=ze.index+ze[0].length,De.push($e(ze[0],...ze.slice(1),ze.index,X,ze.groups))}return De.push(X.slice(Le)),Promise.all(De).then(ze=>ze.join(""))}function w(X,ae){return X<ae?-1:X>ae?1:0}function j(X,ae,$e=0,De=X.length,Le=0,ze=ae.length){for(;$e<De&&Le<ze;$e++,Le++){const nt=X.charCodeAt($e),ot=ae.charCodeAt(Le);if(nt<ot)return-1;if(nt>ot)return 1}const Qe=De-$e,rt=ze-Le;return Qe<rt?-1:Qe>rt?1:0}function W(X,ae){return N(X,ae,0,X.length,0,ae.length)}function N(X,ae,$e=0,De=X.length,Le=0,ze=ae.length){for(;$e<De&&Le<ze;$e++,Le++){let nt=X.charCodeAt($e),ot=ae.charCodeAt(Le);if(nt===ot)continue;if(nt>=128||ot>=128)return j(X.toLowerCase(),ae.toLowerCase(),$e,De,Le,ze);M(nt)&&(nt-=32),M(ot)&&(ot-=32);const Xe=nt-ot;if(Xe!==0)return Xe}const Qe=De-$e,rt=ze-Le;return Qe<rt?-1:Qe>rt?1:0}function x(X){return X>=48&&X<=57}function M(X){return X>=97&&X<=122}function Q(X){return X>=65&&X<=90}function ie(X,ae){return X.length===ae.length&&N(X,ae)===0}function ue(X,ae){const $e=ae.length;return ae.length>X.length?!1:N(X,ae,0,$e)===0}function G(X,ae){const $e=Math.min(X.length,ae.length);let De;for(De=0;De<$e;De++)if(X.charCodeAt(De)!==ae.charCodeAt(De))return De;return $e}function ee(X,ae){const $e=Math.min(X.length,ae.length);let De;const Le=X.length-1,ze=ae.length-1;for(De=0;De<$e;De++)if(X.charCodeAt(Le-De)!==ae.charCodeAt(ze-De))return De;return $e}function de(X){return 55296<=X&&X<=56319}function ye(X){return 56320<=X&&X<=57343}function Ae(X,ae){return(X-55296<<10)+(ae-56320)+65536}function je(X,ae,$e){const De=X.charCodeAt($e);if(de(De)&&$e+1<ae){const Le=X.charCodeAt($e+1);if(ye(Le))return Ae(De,Le)}return De}function le(X,ae){const $e=X.charCodeAt(ae-1);if(ye($e)&&ae>1){const De=X.charCodeAt(ae-2);if(de(De))return Ae(De,$e)}return $e}class _{get offset(){return this.e}constructor(ae,$e=0){this.c=ae,this.d=ae.length,this.e=$e}setOffset(ae){this.e=ae}prevCodePoint(){const ae=le(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=je(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}t.$Jf=_;class fe{get offset(){return this.c.offset}constructor(ae,$e=0){this.c=new _(ae,$e)}nextGraphemeLength(){const ae=Ee.getInstance(),$e=this.c,De=$e.offset;let Le=ae.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const ze=$e.offset,Qe=ae.getGraphemeBreakType($e.nextCodePoint());if(ke(Le,Qe)){$e.setOffset(ze);break}Le=Qe}return $e.offset-De}prevGraphemeLength(){const ae=Ee.getInstance(),$e=this.c,De=$e.offset;let Le=ae.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const ze=$e.offset,Qe=ae.getGraphemeBreakType($e.prevCodePoint());if(ke(Qe,Le)){$e.setOffset(ze);break}Le=Qe}return De-$e.offset}eol(){return this.c.eol()}}t.$Kf=fe;function he(X,ae){return new fe(X,ae).nextGraphemeLength()}function Fe(X,ae){return new fe(X,ae).prevGraphemeLength()}function Z(X,ae){ae>0&&ye(X.charCodeAt(ae))&&ae--;const $e=ae+he(X,ae);return[$e-Fe(X,$e),$e]}function pe(X){const ae=new fe(X);let $e=0;for(;!ae.eol();)$e++,ae.nextGraphemeLength();return $e}let Se;function Re(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function re(X){return Se||(Se=Re()),Se.test(X)}const me=/^[\t\n\r\x20-\x7E]*$/;function J(X){return me.test(X)}t.$Rf=/[\u2028\u2029]/;function O(X){return t.$Rf.test(X)}function u(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}function y(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}function a(X,ae,$e=""){const De=X.trimStart();if(De.length<ae)return De;const Le=/\b/g;let ze=0;for(;Le.test(De)&&!(De.length-Le.lastIndex<ae);)ze=Le.lastIndex,Le.lastIndex+=1;return ze===0?De:$e+De.substring(ze).trimStart()}const D=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*R(X){let ae=0;for(const $e of X.matchAll(D))ae!==$e.index&&(yield{isCode:!1,str:X.substring(ae,$e.index)}),yield{isCode:!0,str:$e[0]},ae=$e.index+$e[0].length;ae!==X.length&&(yield{isCode:!1,str:X.substring(ae)})}function s(X){return X&&(X=X.replace(D,"")),X}const k=/\\\[.*?\\\]/g;function T(X){return s(X).replace(k,"")}t.$Zf="\uFEFF";function L(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}function z(X){return L(X)?X.substr(1):X}function Y(X,ae){if(!X||!ae||X.length<ae.length)return!1;const $e=ae.length,De=X.toLowerCase();let Le=0,ze=-1;for(;Le<$e;){const Qe=De.indexOf(ae[Le],ze+1);if(Qe<0)return!1;ze=Qe,Le++}return!0}function q(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}function te(X){return X.charAt(0).toUpperCase()+X.slice(1)}function ce(X,ae=1){if(ae===0)return"";let $e=-1;do $e=X.indexOf(`
`,$e+1),ae--;while(ae>0&&$e>=0);return $e===-1?X:(X[$e-1]==="\r"&&$e--,X.substr(0,$e))}function oe(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}function Te(X){return Ee.getInstance().getGraphemeBreakType(X)}function ke(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var Me;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(t.GraphemeBreakType=Me={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=Ne()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const $e=this.d,De=$e.length/3;let Le=1;for(;Le<=De;)if(ae<$e[3*Le])Le=2*Le;else if(ae>$e[3*Le+1])Le=2*Le+1;else return $e[3*Le+2];return 0}}function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(X,ae){if(X===0)return 0;const $e=Ye(X,ae);if($e!==void 0)return $e;const De=new _(ae,X);return De.prevCodePoint(),De.offset}function Ye(X,ae){const $e=new _(ae,X);let De=$e.prevCodePoint();for(;_e(De)||De===65039||De===8419;){if($e.offset===0)return;De=$e.prevCodePoint()}if(!y(De))return;let Le=$e.offset;return Le>0&&$e.prevCodePoint()===8205&&(Le=$e.offset),Le}function _e(X){return 127995<=X&&X<=127999}var et;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={})),t.$0f="\xA0";class tt{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$7e({getCacheKey:JSON.stringify},ae=>{function $e(Xe){const ht=new Map;for(let st=0;st<Xe.length;st+=2)ht.set(Xe[st],Xe[st+1]);return ht}function De(Xe,ht){const st=new Map(Xe);for(const[bt,$t]of ht)st.set(bt,$t);return st}function Le(Xe,ht){if(!Xe)return ht;const st=new Map;for(const[bt,$t]of Xe)ht.has(bt)&&st.set(bt,$t);return st}const ze=this.c.value;let Qe=ae.filter(Xe=>!Xe.startsWith("_")&&Xe in ze);Qe.length===0&&(Qe=["_default"]);let rt;for(const Xe of Qe){const ht=$e(ze[Xe]);rt=Le(rt,ht)}const nt=$e(ze._common),ot=De(nt,rt);return new tt(ot)})}static getInstance(ae){return tt.d.get(Array.from(ae))}static{this.e=new C.$V(()=>Object.keys(tt.c.value).filter(ae=>!ae.startsWith("_")))}static getLocales(){return tt.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}containsAmbiguousCharacter(ae){for(let $e=0;$e<ae.length;$e++){const De=ae.codePointAt($e);if(typeof De=="number"&&this.isAmbiguous(De))return!0}return!1}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$$f=tt;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(ae){return We.e().has(ae)}static containsInvisibleCharacter(ae){for(let $e=0;$e<ae.length;$e++){const De=ae.codePointAt($e);if(typeof De=="number"&&We.isInvisibleCharacter(De))return!0}return!1}static get codePoints(){return We.e()}}t.$_f=We}),define(we[44],ve([1,0,39,89,9]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nk=t.FuzzyScore=t.$Ck=t.$Bk=void 0,t.or=U,t.$Dk=A,t.$Ek=d,t.$Fk=P,t.$Gk=H,t.$Hk=w,t.$Ik=Q,t.$Jk=ie,t.$Kk=ue,t.$Lk=G,t.$Mk=re,t.$Ok=u,t.$Pk=D,t.$Qk=R;function U(...T){return function(L,z){for(let Y=0,q=T.length;Y<q;Y++){const te=T[Y](L,z);if(te)return te}return null}}t.$Bk=E.bind(void 0,!1),t.$Ck=E.bind(void 0,!0);function E(T,L,z){if(!z||z.length<L.length)return null;let Y;return T?Y=B.$Cf(z,L):Y=z.indexOf(L)===0,Y?L.length>0?[{start:0,end:L.length}]:[]:null}function A(T,L){const z=L.toLowerCase().indexOf(T.toLowerCase());return z===-1?null:[{start:z,end:z+T.length}]}function d(T,L){return g(T.toLowerCase(),L.toLowerCase(),0,0)}function g(T,L,z,Y){if(z===T.length)return[];if(Y===L.length)return null;if(T[z]===L[Y]){let q=null;return(q=g(T,L,z+1,Y+1))?m({start:Y,end:Y+1},q):null}return g(T,L,z,Y+1)}function $(T){return 97<=T&&T<=122}function P(T){return 65<=T&&T<=90}function c(T){return 48<=T&&T<=57}function l(T){return T===32||T===9||T===10||T===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(T=>e.add(T.charCodeAt(0)));function n(T){return l(T)||e.has(T)}function o(T,L){return T===L||n(T)&&n(L)}const f=new Map;function h(T){if(f.has(T))return f.get(T);let L;const z=(0,C.$zk)(T);return z&&(L=z),f.set(T,L),L}function v(T){return $(T)||P(T)||c(T)}function m(T,L){return L.length===0?L=[T]:T.end===L[0].start?L[0].start=T.start:L.unshift(T),L}function b(T,L){for(let z=L;z<T.length;z++){const Y=T.charCodeAt(z);if(P(Y)||c(Y)||z>0&&!v(T.charCodeAt(z-1)))return z}return T.length}function r(T,L,z,Y){if(z===T.length)return[];if(Y===L.length)return null;if(T[z]!==L[Y].toLowerCase())return null;{let q=null,te=Y+1;for(q=r(T,L,z+1,Y+1);!q&&(te=b(L,te))<L.length;)q=r(T,L,z+1,te),te++;return q===null?null:m({start:Y,end:Y+1},q)}}function p(T){let L=0,z=0,Y=0,q=0,te=0;for(let Me=0;Me<T.length;Me++)te=T.charCodeAt(Me),P(te)&&L++,$(te)&&z++,v(te)&&Y++,c(te)&&q++;const ce=L/T.length,oe=z/T.length,Te=Y/T.length,ke=q/T.length;return{upperPercent:ce,lowerPercent:oe,alphaPercent:Te,numericPercent:ke}}function S(T){const{upperPercent:L,lowerPercent:z}=T;return z===0&&L>.6}function F(T){const{upperPercent:L,lowerPercent:z,alphaPercent:Y,numericPercent:q}=T;return z>.2&&L<.8&&Y>.6&&q<.2}function I(T){let L=0,z=0,Y=0,q=0;for(let te=0;te<T.length;te++)Y=T.charCodeAt(te),P(Y)&&L++,$(Y)&&z++,l(Y)&&q++;return(L===0||z===0)&&q===0?T.length<=30:L<=5}function H(T,L){if(!L||(L=L.trim(),L.length===0)||!I(T))return null;L.length>60&&(L=L.substring(0,60));const z=p(L);if(!F(z)){if(!S(z))return null;L=L.toLowerCase()}let Y=null,q=0;for(T=T.toLowerCase();q<L.length&&(Y=r(T,L,0,q))===null;)q=b(L,q+1);return Y}function w(T,L,z=!1){if(!L||L.length===0)return null;let Y=null,q=0;for(T=T.toLowerCase(),L=L.toLowerCase();q<L.length&&(Y=j(T,L,0,q,z),Y===null);)q=W(L,q+1);return Y}function j(T,L,z,Y,q){let te=0;if(z===T.length)return[];if(Y===L.length)return null;if(!o(T.charCodeAt(z),L.charCodeAt(Y))){const Te=h(T.charCodeAt(z));if(!Te)return null;for(let ke=0;ke<Te.length;ke++)if(!o(Te[ke],L.charCodeAt(Y+ke)))return null;te+=Te.length-1}let ce=null,oe=Y+te+1;if(ce=j(T,L,z+1,oe,q),!q)for(;!ce&&(oe=W(L,oe))<L.length;)ce=j(T,L,z+1,oe,q),oe++;if(!ce)return null;if(T.charCodeAt(z)!==L.charCodeAt(Y)){const Te=h(T.charCodeAt(z));if(!Te)return ce;for(let ke=0;ke<Te.length;ke++)if(Te[ke]!==L.charCodeAt(Y+ke))return ce}return m({start:Y,end:Y+te+1},ce)}function W(T,L){for(let z=L;z<T.length;z++)if(n(T.charCodeAt(z))||z>0&&n(T.charCodeAt(z-1)))return z;return T.length}const N=U(t.$Ck,H,A),x=U(t.$Ck,H,d),M=new i.$Dc(1e4);function Q(T,L,z=!1){if(typeof T!="string"||typeof L!="string")return null;let Y=M.get(T);Y||(Y=new RegExp(B.$kf(T),"i"),M.set(T,Y));const q=Y.exec(L);return q?[{start:q.index,end:q.index+q[0].length}]:z?x(T,L):N(T,L)}function ie(T,L){const z=u(T,T.toLowerCase(),0,L,L.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?G(z):null}function ue(T,L,z,Y,q,te){const ce=Math.min(13,T.length);for(;z<ce;z++){const oe=u(T,L,z,Y,q,te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,te]}function G(T){if(typeof T>"u")return[];const L=[],z=T[1];for(let Y=T.length-1;Y>1;Y--){const q=T[Y]+z,te=L[L.length-1];te&&te.end===q?te.end=q+1:L.push({start:q,end:q+1})}return L}const ee=128;function de(){const T=[],L=[];for(let z=0;z<=ee;z++)L[z]=0;for(let z=0;z<=ee;z++)T.push(L.slice(0));return T}function ye(T){const L=[];for(let z=0;z<=T;z++)L[z]=0;return L}const Ae=ye(2*ee),je=ye(2*ee),le=de(),_=de(),fe=de(),he=!1;function Fe(T,L,z,Y,q){function te(oe,Te,ke=" "){for(;oe.length<Te;)oe=ke+oe;return oe}let ce=` |   |${Y.split("").map(oe=>te(oe,3)).join("|")}
`;for(let oe=0;oe<=z;oe++)oe===0?ce+=" |":ce+=`${L[oe-1]}|`,ce+=T[oe].slice(0,q+1).map(Te=>te(Te.toString(),3)).join("|")+`
`;return ce}function Z(T,L,z,Y){T=T.substr(L),z=z.substr(Y),console.log(Fe(_,T,T.length,z,z.length)),console.log(Fe(fe,T,T.length,z,z.length)),console.log(Fe(le,T,T.length,z,z.length))}function pe(T,L){if(L<0||L>=T.length)return!1;const z=T.codePointAt(L);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!B.$Uf(z)}}function Se(T,L){if(L<0||L>=T.length)return!1;switch(T.charCodeAt(L)){case 32:case 9:return!0;default:return!1}}function Re(T,L,z){return L[T]!==z[T]}function re(T,L,z,Y,q,te,ce=!1){for(;L<z&&q<te;)T[L]===Y[q]&&(ce&&(Ae[L]=q),L+=1),q+=1;return L===z}var me;(function(T){T[T.Diag=1]="Diag",T[T.Left=2]="Left",T[T.LeftLeft=3]="LeftLeft"})(me||(me={}));var J;(function(T){T.Default=[-100,0];function L(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}T.isDefault=L})(J||(t.FuzzyScore=J={}));class O{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(L,z){this.firstMatchCanBeWeak=L,this.boostFullMatch=z}}t.$Nk=O;function u(T,L,z,Y,q,te,ce=O.default){const oe=T.length>ee?ee:T.length,Te=Y.length>ee?ee:Y.length;if(z>=oe||te>=Te||oe-z>Te-te||!re(L,z,oe,q,te,Te,!0))return;y(oe,Te,z,te,L,q);let ke=1,Me=1,Ee=z,Ne=te;const Ue=[!1];for(ke=1,Ee=z;Ee<oe;ke++,Ee++){const We=Ae[Ee],X=je[Ee],ae=Ee+1<oe?je[Ee+1]:Te;for(Me=We-te+1,Ne=We;Ne<ae;Me++,Ne++){let $e=Number.MIN_SAFE_INTEGER,De=!1;Ne<=X&&($e=a(T,L,Ee,z,Y,q,Ne,Te,te,le[ke-1][Me-1]===0,Ue));let Le=0;$e!==Number.MAX_SAFE_INTEGER&&(De=!0,Le=$e+_[ke-1][Me-1]);const ze=Ne>We,Qe=ze?_[ke][Me-1]+(le[ke][Me-1]>0?-5:0):0,rt=Ne>We+1&&le[ke][Me-1]>0,nt=rt?_[ke][Me-2]+(le[ke][Me-2]>0?-5:0):0;if(rt&&(!ze||nt>=Qe)&&(!De||nt>=Le))_[ke][Me]=nt,fe[ke][Me]=3,le[ke][Me]=0;else if(ze&&(!De||Qe>=Le))_[ke][Me]=Qe,fe[ke][Me]=2,le[ke][Me]=0;else if(De)_[ke][Me]=Le,fe[ke][Me]=1,le[ke][Me]=le[ke-1][Me-1]+1;else throw new Error("not possible")}}if(he&&Z(T,z,Y,te),!Ue[0]&&!ce.firstMatchCanBeWeak)return;ke--,Me--;const Ye=[_[ke][Me],te];let _e=0,et=0;for(;ke>=1;){let We=Me;do{const X=fe[ke][We];if(X===3)We=We-2;else if(X===2)We=We-1;else break}while(We>=1);_e>1&&L[z+ke-1]===q[te+Me-1]&&!Re(We+te-1,Y,q)&&_e+1>le[ke][We]&&(We=Me),We===Me?_e++:_e=1,et||(et=We),ke--,Me=We-1,Ye.push(Me)}Te-te===oe&&ce.boostFullMatch&&(Ye[0]+=2);const tt=et-oe;return Ye[0]-=tt,Ye}function y(T,L,z,Y,q,te){let ce=T-1,oe=L-1;for(;ce>=z&&oe>=Y;)q[ce]===te[oe]&&(je[ce]=oe,ce--),oe--}function a(T,L,z,Y,q,te,ce,oe,Te,ke,Me){if(L[z]!==te[ce])return Number.MIN_SAFE_INTEGER;let Ee=1,Ne=!1;return ce===z-Y?Ee=T[z]===q[ce]?7:5:Re(ce,q,te)&&(ce===0||!Re(ce-1,q,te))?(Ee=T[z]===q[ce]?7:5,Ne=!0):pe(te,ce)&&(ce===0||!pe(te,ce-1))?Ee=5:(pe(te,ce-1)||Se(te,ce-1))&&(Ee=5,Ne=!0),Ee>1&&z===Y&&(Me[0]=!0),Ne||(Ne=Re(ce,q,te)||pe(te,ce-1)||Se(te,ce-1)),z===Y?ce>Te&&(Ee-=Ne?3:5):ke?Ee+=Ne?2:0:Ee+=Ne?0:1,ce+1===oe&&(Ee-=Ne?3:5),Ee}function D(T,L,z,Y,q,te,ce){return s(T,L,z,Y,q,te,!0,ce)}function R(T,L,z,Y,q,te,ce){return s(T,L,z,Y,q,te,!1,ce)}function s(T,L,z,Y,q,te,ce,oe){let Te=u(T,L,z,Y,q,te,oe);if(Te&&!ce)return Te;if(T.length>=3){const ke=Math.min(7,T.length-1);for(let Me=z+1;Me<ke;Me++){const Ee=k(T,Me);if(Ee){const Ne=u(Ee,Ee.toLowerCase(),z,Y,q,te,oe);Ne&&(Ne[0]-=3,(!Te||Ne[0]>Te[0])&&(Te=Ne))}}}return Te}function k(T,L){if(L+1>=T.length)return;const z=T[L],Y=T[L+1];if(z!==Y)return T.slice(0,L)+Y+z+T.slice(L+2)}}),define(we[59],ve([1,0,9]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uj=t.$sj=void 0,t.$oj=C,t.$pj=B,t.$qj=U,t.$rj=A,t.$tj=n;function C(f){return B(f,0)}function B(f,h){switch(typeof f){case"object":return f===null?U(349,h):Array.isArray(f)?d(f,h):g(f,h);case"string":return A(f,h);case"boolean":return E(f,h);case"number":return U(f,h);case"undefined":return U(937,h);default:return U(617,h)}}function U(f,h){return(h<<5)-h+f|0}function E(f,h){return U(f?433:863,h)}function A(f,h){h=U(149417,h);for(let v=0,m=f.length;v<m;v++)h=U(f.charCodeAt(v),h);return h}function d(f,h){return h=U(104579,h),f.reduce((v,m)=>B(m,v),h)}function g(f,h){return h=U(181387,h),Object.keys(f).sort().reduce((v,m)=>(v=A(m,v),B(f[m],v)),h)}class ${constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=B(h,this.g),this.g}}t.$sj=$;var P;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function c(f,h,v=32){const m=v-h,b=~((1<<m)-1);return(f<<h|(b&f)>>>m)>>>0}function l(f,h=0,v=f.byteLength,m=0){for(let b=0;b<v;b++)f[h+b]=m}function e(f,h,v="0"){for(;f.length<h;)f=v+f;return f}function n(f,h=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((f>>>0).toString(16),h/4)}class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const v=h.length;if(v===0)return;const m=this.p;let b=this.r,r=this.u,p,S;for(r!==0?(p=r,S=-1,r=0):(p=h.charCodeAt(0),S=0);;){let F=p;if(i.$Ff(p))if(S+1<v){const I=h.charCodeAt(S+1);i.$Gf(I)?(S++,F=i.$Hf(p,I)):F=65533}else{r=p;break}else i.$Gf(p)&&(F=65533);if(b=this.w(m,b,F),S++,S<v)p=h.charCodeAt(S);else break}this.r=b,this.u=r}w(h,v,m){return m<128?h[v++]=m:m<2048?(h[v++]=192|(m&1984)>>>6,h[v++]=128|(m&63)>>>0):m<65536?(h[v++]=224|(m&61440)>>>12,h[v++]=128|(m&4032)>>>6,h[v++]=128|(m&63)>>>0):(h[v++]=240|(m&1835008)>>>18,h[v++]=128|(m&258048)>>>12,h[v++]=128|(m&4032)>>>6,h[v++]=128|(m&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,h[0]=h[64],h[1]=h[65],h[2]=h[66]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),n(this.h)+n(this.l)+n(this.m)+n(this.n)+n(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=o.g,v=this.q;for(let w=0;w<64;w+=4)h.setUint32(w,v.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)h.setUint32(w,c(h.getUint32(w-12,!1)^h.getUint32(w-32,!1)^h.getUint32(w-56,!1)^h.getUint32(w-64,!1),1),!1);let m=this.h,b=this.l,r=this.m,p=this.n,S=this.o,F,I,H;for(let w=0;w<80;w++)w<20?(F=b&r|~b&p,I=1518500249):w<40?(F=b^r^p,I=1859775393):w<60?(F=b&r|b&p|r&p,I=2400959708):(F=b^r^p,I=3395469782),H=c(m,5)+F+S+I+h.getUint32(w*4,!1)&4294967295,S=p,p=r,r=c(b,30),b=m,m=H;this.h=this.h+m&4294967295,this.l=this.l+b&4294967295,this.m=this.m+r&4294967295,this.n=this.n+p&4294967295,this.o=this.o+S&4294967295}}t.$uj=o}),define(we[98],ve([1,0,85,59]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gt=t.$Et=void 0,t.$Ft=U;class B{constructor(c){this.a=c}getElements(){const c=this.a,l=new Int32Array(c.length);for(let e=0,n=c.length;e<n;e++)l[e]=c.charCodeAt(e);return l}}t.$Et=B;function U(P,c,l){return new $(new B(P),new B(c)).ComputeDiff(l).changes}class E{static Assert(c,l){if(!c)throw new Error(l)}}class A{static Copy(c,l,e,n,o){for(let f=0;f<o;f++)e[n+f]=c[l+f]}static Copy2(c,l,e,n,o){for(let f=0;f<o;f++)e[n+f]=c[l+f]}}var d;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$Dt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(c,l){this.b=Math.min(this.b,c),this.c=Math.min(this.c,l),this.d++}AddModifiedElement(c,l){this.b=Math.min(this.b,c),this.c=Math.min(this.c,l),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class ${constructor(c,l,e=null){this.a=e,this.b=c,this.c=l;const[n,o,f]=$.o(c),[h,v,m]=$.o(l);this.d=f&&m,this.e=n,this.f=o,this.g=h,this.h=v,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const l=c.getElements();if($.n(l)){const e=new Int32Array(l.length);for(let n=0,o=l.length;n<o;n++)e[n]=(0,C.$rj)(l[n],0);return[l,e,!0]}return l instanceof Int32Array?[[],l,!1]:[[],new Int32Array(l),!1]}p(c,l){return this.f[c]!==this.h[l]?!1:this.d?this.e[c]===this.g[l]:!0}q(c,l){if(!this.p(c,l))return!1;const e=$.r(this.b,c),n=$.r(this.c,l);return e===n}static r(c,l){return typeof c.getStrictElement=="function"?c.getStrictElement(l):null}s(c,l){return this.f[c]!==this.f[l]?!1:this.d?this.e[c]===this.e[l]:!0}u(c,l){return this.h[c]!==this.h[l]?!1:this.d?this.g[c]===this.g[l]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,l,e,n,o){const f=[!1];let h=this.w(c,l,e,n,f);return o&&(h=this.z(h)),{quitEarly:f[0],changes:h}}w(c,l,e,n,o){for(o[0]=!1;c<=l&&e<=n&&this.p(c,e);)c++,e++;for(;l>=c&&n>=e&&this.p(l,n);)l--,n--;if(c>l||e>n){let r;return e<=n?(E.Assert(c===l+1,"originalStart should only be one more than originalEnd"),r=[new i.$Dt(c,0,e,n-e+1)]):c<=l?(E.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.$Dt(c,l-c+1,e,0)]):(E.Assert(c===l+1,"originalStart should only be one more than originalEnd"),E.Assert(e===n+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const f=[0],h=[0],v=this.y(c,l,e,n,f,h,o),m=f[0],b=h[0];if(v!==null)return v;if(!o[0]){const r=this.w(c,m,e,b,o);let p=[];return o[0]?p=[new i.$Dt(m+1,l-(m+1)+1,b+1,n-(b+1)+1)]:p=this.w(m+1,l,b+1,n,o),this.H(r,p)}return[new i.$Dt(c,l-c+1,e,n-e+1)]}x(c,l,e,n,o,f,h,v,m,b,r,p,S,F,I,H,w,j){let W=null,N=null,x=new g,M=l,Q=e,ie=S[0]-H[0]-n,ue=-1073741824,G=this.k.length-1;do{const ee=ie+c;ee===M||ee<Q&&m[ee-1]<m[ee+1]?(r=m[ee+1],F=r-ie-n,r<ue&&x.MarkNextChange(),ue=r,x.AddModifiedElement(r+1,F),ie=ee+1-c):(r=m[ee-1]+1,F=r-ie-n,r<ue&&x.MarkNextChange(),ue=r-1,x.AddOriginalElement(r,F+1),ie=ee-1-c),G>=0&&(m=this.k[G],c=m[0],M=1,Q=m.length-1)}while(--G>=-1);if(W=x.getReverseChanges(),j[0]){let ee=S[0]+1,de=H[0]+1;if(W!==null&&W.length>0){const ye=W[W.length-1];ee=Math.max(ee,ye.getOriginalEnd()),de=Math.max(de,ye.getModifiedEnd())}N=[new i.$Dt(ee,p-ee+1,de,I-de+1)]}else{x=new g,M=f,Q=h,ie=S[0]-H[0]-v,ue=1073741824,G=w?this.m.length-1:this.m.length-2;do{const ee=ie+o;ee===M||ee<Q&&b[ee-1]>=b[ee+1]?(r=b[ee+1]-1,F=r-ie-v,r>ue&&x.MarkNextChange(),ue=r+1,x.AddOriginalElement(r+1,F+1),ie=ee+1-o):(r=b[ee-1],F=r-ie-v,r>ue&&x.MarkNextChange(),ue=r,x.AddModifiedElement(r+1,F+1),ie=ee-1-o),G>=0&&(b=this.m[G],o=b[0],M=1,Q=b.length-1)}while(--G>=-1);N=x.getChanges()}return this.H(W,N)}y(c,l,e,n,o,f,h){let v=0,m=0,b=0,r=0,p=0,S=0;c--,e--,o[0]=0,f[0]=0,this.k=[],this.m=[];const F=l-c+(n-e),I=F+1,H=new Int32Array(I),w=new Int32Array(I),j=n-e,W=l-c,N=c-e,x=l-n,Q=(W-j)%2===0;H[j]=c,w[W]=l,h[0]=!1;for(let ie=1;ie<=F/2+1;ie++){let ue=0,G=0;b=this.J(j-ie,ie,j,I),r=this.J(j+ie,ie,j,I);for(let de=b;de<=r;de+=2){de===b||de<r&&H[de-1]<H[de+1]?v=H[de+1]:v=H[de-1]+1,m=v-(de-j)-N;const ye=v;for(;v<l&&m<n&&this.p(v+1,m+1);)v++,m++;if(H[de]=v,v+m>ue+G&&(ue=v,G=m),!Q&&Math.abs(de-W)<=ie-1&&v>=w[de])return o[0]=v,f[0]=m,ye<=w[de]&&1447>0&&ie<=1448?this.x(j,b,r,N,W,p,S,x,H,w,v,l,o,m,n,f,Q,h):null}const ee=(ue-c+(G-e)-ie)/2;if(this.a!==null&&!this.a(ue,ee))return h[0]=!0,o[0]=ue,f[0]=G,ee>0&&1447>0&&ie<=1448?this.x(j,b,r,N,W,p,S,x,H,w,v,l,o,m,n,f,Q,h):(c++,e++,[new i.$Dt(c,l-c+1,e,n-e+1)]);p=this.J(W-ie,ie,W,I),S=this.J(W+ie,ie,W,I);for(let de=p;de<=S;de+=2){de===p||de<S&&w[de-1]>=w[de+1]?v=w[de+1]-1:v=w[de-1],m=v-(de-W)-x;const ye=v;for(;v>c&&m>e&&this.p(v,m);)v--,m--;if(w[de]=v,Q&&Math.abs(de-j)<=ie&&v<=H[de])return o[0]=v,f[0]=m,ye>=H[de]&&1447>0&&ie<=1448?this.x(j,b,r,N,W,p,S,x,H,w,v,l,o,m,n,f,Q,h):null}if(ie<=1447){let de=new Int32Array(r-b+2);de[0]=j-b+1,A.Copy2(H,b,de,1,r-b+1),this.k.push(de),de=new Int32Array(S-p+2),de[0]=W-p+1,A.Copy2(w,p,de,1,S-p+1),this.m.push(de)}}return this.x(j,b,r,N,W,p,S,x,H,w,v,l,o,m,n,f,Q,h)}z(c){for(let l=0;l<c.length;l++){const e=c[l],n=l<c.length-1?c[l+1].originalStart:this.f.length,o=l<c.length-1?c[l+1].modifiedStart:this.h.length,f=e.originalLength>0,h=e.modifiedLength>0;for(;e.originalStart+e.originalLength<n&&e.modifiedStart+e.modifiedLength<o&&(!f||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!h||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const m=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!m)break;e.originalStart++,e.modifiedStart++}const v=[null];if(l<c.length-1&&this.I(c[l],c[l+1],v)){c[l]=v[0],c.splice(l+1,1),l--;continue}}for(let l=c.length-1;l>=0;l--){const e=c[l];let n=0,o=0;if(l>0){const r=c[l-1];n=r.originalStart+r.originalLength,o=r.modifiedStart+r.modifiedLength}const f=e.originalLength>0,h=e.modifiedLength>0;let v=0,m=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const p=e.originalStart-r,S=e.modifiedStart-r;if(p<n||S<o||f&&!this.s(p,p+e.originalLength)||h&&!this.u(S,S+e.modifiedLength))break;const I=(p===n&&S===o?5:0)+this.G(p,e.originalLength,S,e.modifiedLength);I>m&&(m=I,v=r)}e.originalStart-=v,e.modifiedStart-=v;const b=[null];if(l>0&&this.I(c[l-1],c[l],b)){c[l-1]=b[0],c.splice(l,1),l++;continue}}if(this.d)for(let l=1,e=c.length;l<e;l++){const n=c[l-1],o=c[l],f=o.originalStart-n.originalStart-n.originalLength,h=n.originalStart,v=o.originalStart+o.originalLength,m=v-h,b=n.modifiedStart,r=o.modifiedStart+o.modifiedLength,p=r-b;if(f<5&&m<20&&p<20){const S=this.A(h,m,b,p,f);if(S){const[F,I]=S;(F!==n.originalStart+n.originalLength||I!==n.modifiedStart+n.modifiedLength)&&(n.originalLength=F-n.originalStart,n.modifiedLength=I-n.modifiedStart,o.originalStart=F+f,o.modifiedStart=I+f,o.originalLength=v-o.originalStart,o.modifiedLength=r-o.modifiedStart)}}}return c}A(c,l,e,n,o){if(l<o||n<o)return null;const f=c+l-o+1,h=e+n-o+1;let v=0,m=0,b=0;for(let r=c;r<f;r++)for(let p=e;p<h;p++){const S=this.B(r,p,o);S>0&&S>v&&(v=S,m=r,b=p)}return v>0?[m,b]:null}B(c,l,e){let n=0;for(let o=0;o<e;o++){if(!this.p(c+o,l+o))return 0;n+=this.e[c+o].length}return n}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,l){if(this.C(c)||this.C(c-1))return!0;if(l>0){const e=c+l;if(this.C(e-1)||this.C(e))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,l){if(this.E(c)||this.E(c-1))return!0;if(l>0){const e=c+l;if(this.E(e-1)||this.E(e))return!0}return!1}G(c,l,e,n){const o=this.D(c,l)?1:0,f=this.F(e,n)?1:0;return o+f}H(c,l){const e=[];if(c.length===0||l.length===0)return l.length>0?l:c;if(this.I(c[c.length-1],l[0],e)){const n=new Array(c.length+l.length-1);return A.Copy(c,0,n,0,c.length-1),n[c.length-1]=e[0],A.Copy(l,1,n,c.length,l.length-1),n}else{const n=new Array(c.length+l.length);return A.Copy(c,0,n,0,c.length),A.Copy(l,0,n,c.length,l.length),n}}I(c,l,e){if(E.Assert(c.originalStart<=l.originalStart,"Left change is not less than or equal to right change"),E.Assert(c.modifiedStart<=l.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=l.originalStart||c.modifiedStart+c.modifiedLength>=l.modifiedStart){const n=c.originalStart;let o=c.originalLength;const f=c.modifiedStart;let h=c.modifiedLength;return c.originalStart+c.originalLength>=l.originalStart&&(o=l.originalStart+l.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=l.modifiedStart&&(h=l.modifiedStart+l.modifiedLength-c.modifiedStart),e[0]=new i.$Dt(n,o,f,h),!0}else return e[0]=null,!1}J(c,l,e,n){if(c>=0&&c<n)return c;const o=e,f=n-e-1,h=l%2===0;if(c<0){const v=o%2===0;return h===v?0:1}else{const v=f%2===0;return h===v?n-1:n-2}}}t.$Gt=$}),define(we[60],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=void 0,t.$ce=Symbol("MicrotaskDelay")}),define(we[99],ve([1,0,8,9]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gi=t.$Fi=t.$Ei=t.$Di=t.$Ci=void 0;class B{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const e=l.charCodeAt(0),n=this.b.charCodeAt(this.c);return e-n}value(){return this.b[this.c]}}t.$Ci=B;class U{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,C.$vf)(l,this.b,0,l.length,this.c,this.d):(0,C.$xf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Di=U;class E{constructor(l=!0,e=!0){this.f=l,this.g=e}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let e=l.length-1;e>=0;e--,this.c--){const n=this.b.charCodeAt(e);if(!(n===47||this.f&&n===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,C.$vf)(l,this.b,0,l.length,this.d,this.e):(0,C.$xf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Ei=E;var A;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(A||(A={}));class d{constructor(l,e){this.f=l,this.g=e,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,C.$wf)(l,this.c.scheme);if(this.d[this.e]===2)return(0,C.$wf)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,C.$uf)(l,this.c.query);if(this.d[this.e]===5)return(0,C.$uf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Fi=d;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})($||($={}));class P{static forUris(l=()=>!1,e=()=>!1){return new P(new d(l,e))}static forPaths(l=!1){return new P(new E(void 0,!l))}static forStrings(){return new P(new B)}static forConfigKeys(){return new P(new U)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,e){if(e){const n=e.slice(0);(0,i.$Wb)(n);for(const o of n)this.set(o,l)}else{const n=l.slice(0);(0,i.$Wb)(n);for(const o of n)this.set(o[0],o[1])}}set(l,e){const n=this.b.reset(l);let o;this.c||(this.c=new g,this.c.segment=n.value());const f=[];for(o=this.c;;){const v=n.cmp(o.segment);if(v>0)o.left||(o.left=new g,o.left.segment=n.value()),f.push([-1,o]),o=o.left;else if(v<0)o.right||(o.right=new g,o.right.segment=n.value()),f.push([1,o]),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new g,o.mid.segment=n.value()),f.push([0,o]),o=o.mid;else break}const h=o.value;o.value=e,o.key=l;for(let v=f.length-1;v>=0;v--){const m=f[v][1];m.updateHeight();const b=m.balanceFactor();if(b<-1||b>1){const r=f[v][0],p=f[v+1][0];if(r===1&&p===1)f[v][1]=m.rotateLeft();else if(r===-1&&p===-1)f[v][1]=m.rotateRight();else if(r===1&&p===-1)m.right=f[v+1][1]=f[v+1][1].rotateRight(),f[v][1]=m.rotateLeft();else if(r===-1&&p===1)m.left=f[v+1][1]=f[v+1][1].rotateLeft(),f[v][1]=m.rotateRight();else throw new Error;if(v>0)switch(f[v-1][0]){case-1:f[v-1][1].left=f[v][1];break;case 1:f[v-1][1].right=f[v][1];break;case 0:f[v-1][1].mid=f[v][1];break}else this.c=f[0][1]}}return h}get(l){return this.d(l)?.value}d(l){const e=this.b.reset(l);let n=this.c;for(;n;){const o=e.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(e.hasNext())e.next(),n=n.mid;else break}return n}has(l){const e=this.d(l);return!(e?.value===void 0&&e?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,e){const n=this.b.reset(l),o=[];let f=this.c;for(;f;){const h=n.cmp(f.segment);if(h>0)o.push([-1,f]),f=f.left;else if(h<0)o.push([1,f]),f=f.right;else if(n.hasNext())n.next(),o.push([0,f]),f=f.mid;else break}if(f){if(e?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const h=this.f(f.right);if(h.key){const{key:v,value:m,segment:b}=h;this.e(h.key,!1),f.key=v,f.value=m,f.segment=b}}else{const h=f.left??f.right;if(o.length>0){const[v,m]=o[o.length-1];switch(v){case-1:m.left=h;break;case 0:m.mid=h;break;case 1:m.right=h;break}}else this.c=h}for(let h=o.length-1;h>=0;h--){const v=o[h][1];v.updateHeight();const m=v.balanceFactor();if(m>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),o[h][1]=v.rotateLeft()):m<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),o[h][1]=v.rotateRight()),h>0)switch(o[h-1][0]){case-1:o[h-1][1].left=o[h][1];break;case 1:o[h-1][1].right=o[h][1];break;case 0:o[h-1][1].mid=o[h][1];break}else this.c=o[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const e=this.b.reset(l);let n=this.c,o;for(;n;){const f=e.cmp(n.segment);if(f>0)n=n.left;else if(f<0)n=n.right;else if(e.hasNext())e.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(l){return this.g(l,!1)}g(l,e){const n=this.b.reset(l);let o=this.c;for(;o;){const f=n.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(n.hasNext())n.next(),o=o.mid;else return o.mid?this.h(o.mid):e?o.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[e,n]of this)l(n,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const e=[];return this.j(l,e),e[Symbol.iterator]()}j(l,e){l&&(l.left&&this.j(l.left,e),l.value&&e.push([l.key,l.value]),l.mid&&this.j(l.mid,e),l.right&&this.j(l.right,e))}_isBalanced(){const l=e=>{if(!e)return!0;const n=e.balanceFactor();return n<-1||n>1?!1:l(e.left)&&l(e.right)};return l(this.c)}}t.$Gi=P}),define(we[10],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ag=i,t.$bg=C,t.$cg=B,t.$dg=U,t.$eg=E,t.$fg=A,t.$gg=d,t.$hg=g,t.$ig=$,t.$jg=P,t.$kg=c,t.$lg=l,t.$mg=e,t.$ng=o,t.$og=f,t.$pg=h,t.$qg=v,t.$rg=m;function i(b){return typeof b=="string"}function C(b){return Array.isArray(b)&&b.every(r=>i(r))}function B(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}function U(b){const r=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof r}function E(b){return typeof b=="number"&&!isNaN(b)}function A(b){return!!b&&typeof b[Symbol.iterator]=="function"}function d(b){return b===!0||b===!1}function g(b){return typeof b>"u"}function $(b){return!P(b)}function P(b){return g(b)||b===null}function c(b,r){if(!b)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function l(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}function e(...b){const r=[];for(let p=0;p<b.length;p++){const S=b[p];if(P(S))throw new Error(`Assertion Failed: argument at index ${p} is undefined or null`);r.push(S)}return r}const n=Object.prototype.hasOwnProperty;function o(b){if(!B(b))return!1;for(const r in b)if(n.call(b,r))return!1;return!0}function f(b){return typeof b=="function"}function h(...b){return b.length>0&&b.every(f)}function v(b,r){const p=Math.min(b.length,r.length);for(let S=0;S<p;S++)m(b[S],r[S])}function m(b,r){if(i(r)){if(typeof b!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(f(r)){try{if(b instanceof r)return}catch{}if(!P(b)&&b.constructor===r||r.length===1&&r.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(we[45],ve([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=B,t.$Vj=U;const C=Object.create(null);function B(E,A){if((0,i.$ag)(A)){const d=C[A];if(d===void 0)throw new Error(`${E} references an unknown codicon: ${A}`);A=d}return C[E]=A,{id:E}}function U(){return C}}),define(we[100],ve([1,0,45]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wj=void 0,t.$Wj={add:(0,i.$Uj)("add",6e4),plus:(0,i.$Uj)("plus",6e4),gistNew:(0,i.$Uj)("gist-new",6e4),repoCreate:(0,i.$Uj)("repo-create",6e4),lightbulb:(0,i.$Uj)("lightbulb",60001),lightBulb:(0,i.$Uj)("light-bulb",60001),repo:(0,i.$Uj)("repo",60002),repoDelete:(0,i.$Uj)("repo-delete",60002),gistFork:(0,i.$Uj)("gist-fork",60003),repoForked:(0,i.$Uj)("repo-forked",60003),gitPullRequest:(0,i.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Uj)("record-keys",60005),keyboard:(0,i.$Uj)("keyboard",60005),tag:(0,i.$Uj)("tag",60006),gitPullRequestLabel:(0,i.$Uj)("git-pull-request-label",60006),tagAdd:(0,i.$Uj)("tag-add",60006),tagRemove:(0,i.$Uj)("tag-remove",60006),person:(0,i.$Uj)("person",60007),personFollow:(0,i.$Uj)("person-follow",60007),personOutline:(0,i.$Uj)("person-outline",60007),personFilled:(0,i.$Uj)("person-filled",60007),gitBranch:(0,i.$Uj)("git-branch",60008),gitBranchCreate:(0,i.$Uj)("git-branch-create",60008),gitBranchDelete:(0,i.$Uj)("git-branch-delete",60008),sourceControl:(0,i.$Uj)("source-control",60008),mirror:(0,i.$Uj)("mirror",60009),mirrorPublic:(0,i.$Uj)("mirror-public",60009),star:(0,i.$Uj)("star",60010),starAdd:(0,i.$Uj)("star-add",60010),starDelete:(0,i.$Uj)("star-delete",60010),starEmpty:(0,i.$Uj)("star-empty",60010),comment:(0,i.$Uj)("comment",60011),commentAdd:(0,i.$Uj)("comment-add",60011),alert:(0,i.$Uj)("alert",60012),warning:(0,i.$Uj)("warning",60012),search:(0,i.$Uj)("search",60013),searchSave:(0,i.$Uj)("search-save",60013),logOut:(0,i.$Uj)("log-out",60014),signOut:(0,i.$Uj)("sign-out",60014),logIn:(0,i.$Uj)("log-in",60015),signIn:(0,i.$Uj)("sign-in",60015),eye:(0,i.$Uj)("eye",60016),eyeUnwatch:(0,i.$Uj)("eye-unwatch",60016),eyeWatch:(0,i.$Uj)("eye-watch",60016),circleFilled:(0,i.$Uj)("circle-filled",60017),primitiveDot:(0,i.$Uj)("primitive-dot",60017),closeDirty:(0,i.$Uj)("close-dirty",60017),debugBreakpoint:(0,i.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Uj)("primitive-square",60018),edit:(0,i.$Uj)("edit",60019),pencil:(0,i.$Uj)("pencil",60019),info:(0,i.$Uj)("info",60020),issueOpened:(0,i.$Uj)("issue-opened",60020),gistPrivate:(0,i.$Uj)("gist-private",60021),gitForkPrivate:(0,i.$Uj)("git-fork-private",60021),lock:(0,i.$Uj)("lock",60021),mirrorPrivate:(0,i.$Uj)("mirror-private",60021),close:(0,i.$Uj)("close",60022),removeClose:(0,i.$Uj)("remove-close",60022),x:(0,i.$Uj)("x",60022),repoSync:(0,i.$Uj)("repo-sync",60023),sync:(0,i.$Uj)("sync",60023),clone:(0,i.$Uj)("clone",60024),desktopDownload:(0,i.$Uj)("desktop-download",60024),beaker:(0,i.$Uj)("beaker",60025),microscope:(0,i.$Uj)("microscope",60025),vm:(0,i.$Uj)("vm",60026),deviceDesktop:(0,i.$Uj)("device-desktop",60026),file:(0,i.$Uj)("file",60027),fileText:(0,i.$Uj)("file-text",60027),more:(0,i.$Uj)("more",60028),ellipsis:(0,i.$Uj)("ellipsis",60028),kebabHorizontal:(0,i.$Uj)("kebab-horizontal",60028),mailReply:(0,i.$Uj)("mail-reply",60029),reply:(0,i.$Uj)("reply",60029),organization:(0,i.$Uj)("organization",60030),organizationFilled:(0,i.$Uj)("organization-filled",60030),organizationOutline:(0,i.$Uj)("organization-outline",60030),newFile:(0,i.$Uj)("new-file",60031),fileAdd:(0,i.$Uj)("file-add",60031),newFolder:(0,i.$Uj)("new-folder",60032),fileDirectoryCreate:(0,i.$Uj)("file-directory-create",60032),trash:(0,i.$Uj)("trash",60033),trashcan:(0,i.$Uj)("trashcan",60033),history:(0,i.$Uj)("history",60034),clock:(0,i.$Uj)("clock",60034),folder:(0,i.$Uj)("folder",60035),fileDirectory:(0,i.$Uj)("file-directory",60035),symbolFolder:(0,i.$Uj)("symbol-folder",60035),logoGithub:(0,i.$Uj)("logo-github",60036),markGithub:(0,i.$Uj)("mark-github",60036),github:(0,i.$Uj)("github",60036),terminal:(0,i.$Uj)("terminal",60037),console:(0,i.$Uj)("console",60037),repl:(0,i.$Uj)("repl",60037),zap:(0,i.$Uj)("zap",60038),symbolEvent:(0,i.$Uj)("symbol-event",60038),error:(0,i.$Uj)("error",60039),stop:(0,i.$Uj)("stop",60039),variable:(0,i.$Uj)("variable",60040),symbolVariable:(0,i.$Uj)("symbol-variable",60040),array:(0,i.$Uj)("array",60042),symbolArray:(0,i.$Uj)("symbol-array",60042),symbolModule:(0,i.$Uj)("symbol-module",60043),symbolPackage:(0,i.$Uj)("symbol-package",60043),symbolNamespace:(0,i.$Uj)("symbol-namespace",60043),symbolObject:(0,i.$Uj)("symbol-object",60043),symbolMethod:(0,i.$Uj)("symbol-method",60044),symbolFunction:(0,i.$Uj)("symbol-function",60044),symbolConstructor:(0,i.$Uj)("symbol-constructor",60044),symbolBoolean:(0,i.$Uj)("symbol-boolean",60047),symbolNull:(0,i.$Uj)("symbol-null",60047),symbolNumeric:(0,i.$Uj)("symbol-numeric",60048),symbolNumber:(0,i.$Uj)("symbol-number",60048),symbolStructure:(0,i.$Uj)("symbol-structure",60049),symbolStruct:(0,i.$Uj)("symbol-struct",60049),symbolParameter:(0,i.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Uj)("symbol-type-parameter",60050),symbolKey:(0,i.$Uj)("symbol-key",60051),symbolText:(0,i.$Uj)("symbol-text",60051),symbolReference:(0,i.$Uj)("symbol-reference",60052),goToFile:(0,i.$Uj)("go-to-file",60052),symbolEnum:(0,i.$Uj)("symbol-enum",60053),symbolValue:(0,i.$Uj)("symbol-value",60053),symbolRuler:(0,i.$Uj)("symbol-ruler",60054),symbolUnit:(0,i.$Uj)("symbol-unit",60054),activateBreakpoints:(0,i.$Uj)("activate-breakpoints",60055),archive:(0,i.$Uj)("archive",60056),arrowBoth:(0,i.$Uj)("arrow-both",60057),arrowDown:(0,i.$Uj)("arrow-down",60058),arrowLeft:(0,i.$Uj)("arrow-left",60059),arrowRight:(0,i.$Uj)("arrow-right",60060),arrowSmallDown:(0,i.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Uj)("arrow-small-up",60064),arrowUp:(0,i.$Uj)("arrow-up",60065),bell:(0,i.$Uj)("bell",60066),bold:(0,i.$Uj)("bold",60067),book:(0,i.$Uj)("book",60068),bookmark:(0,i.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Uj)("briefcase",60076),broadcast:(0,i.$Uj)("broadcast",60077),browser:(0,i.$Uj)("browser",60078),bug:(0,i.$Uj)("bug",60079),calendar:(0,i.$Uj)("calendar",60080),caseSensitive:(0,i.$Uj)("case-sensitive",60081),check:(0,i.$Uj)("check",60082),checklist:(0,i.$Uj)("checklist",60083),chevronDown:(0,i.$Uj)("chevron-down",60084),chevronLeft:(0,i.$Uj)("chevron-left",60085),chevronRight:(0,i.$Uj)("chevron-right",60086),chevronUp:(0,i.$Uj)("chevron-up",60087),chromeClose:(0,i.$Uj)("chrome-close",60088),chromeMaximize:(0,i.$Uj)("chrome-maximize",60089),chromeMinimize:(0,i.$Uj)("chrome-minimize",60090),chromeRestore:(0,i.$Uj)("chrome-restore",60091),circleOutline:(0,i.$Uj)("circle-outline",60092),circle:(0,i.$Uj)("circle",60092),debugBreakpointUnverified:(0,i.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Uj)("circle-slash",60093),circuitBoard:(0,i.$Uj)("circuit-board",60094),clearAll:(0,i.$Uj)("clear-all",60095),clippy:(0,i.$Uj)("clippy",60096),closeAll:(0,i.$Uj)("close-all",60097),cloudDownload:(0,i.$Uj)("cloud-download",60098),cloudUpload:(0,i.$Uj)("cloud-upload",60099),code:(0,i.$Uj)("code",60100),collapseAll:(0,i.$Uj)("collapse-all",60101),colorMode:(0,i.$Uj)("color-mode",60102),commentDiscussion:(0,i.$Uj)("comment-discussion",60103),creditCard:(0,i.$Uj)("credit-card",60105),dash:(0,i.$Uj)("dash",60108),dashboard:(0,i.$Uj)("dashboard",60109),database:(0,i.$Uj)("database",60110),debugContinue:(0,i.$Uj)("debug-continue",60111),debugDisconnect:(0,i.$Uj)("debug-disconnect",60112),debugPause:(0,i.$Uj)("debug-pause",60113),debugRestart:(0,i.$Uj)("debug-restart",60114),debugStart:(0,i.$Uj)("debug-start",60115),debugStepInto:(0,i.$Uj)("debug-step-into",60116),debugStepOut:(0,i.$Uj)("debug-step-out",60117),debugStepOver:(0,i.$Uj)("debug-step-over",60118),debugStop:(0,i.$Uj)("debug-stop",60119),debug:(0,i.$Uj)("debug",60120),deviceCameraVideo:(0,i.$Uj)("device-camera-video",60121),deviceCamera:(0,i.$Uj)("device-camera",60122),deviceMobile:(0,i.$Uj)("device-mobile",60123),diffAdded:(0,i.$Uj)("diff-added",60124),diffIgnored:(0,i.$Uj)("diff-ignored",60125),diffModified:(0,i.$Uj)("diff-modified",60126),diffRemoved:(0,i.$Uj)("diff-removed",60127),diffRenamed:(0,i.$Uj)("diff-renamed",60128),diff:(0,i.$Uj)("diff",60129),diffSidebyside:(0,i.$Uj)("diff-sidebyside",60129),discard:(0,i.$Uj)("discard",60130),editorLayout:(0,i.$Uj)("editor-layout",60131),emptyWindow:(0,i.$Uj)("empty-window",60132),exclude:(0,i.$Uj)("exclude",60133),extensions:(0,i.$Uj)("extensions",60134),eyeClosed:(0,i.$Uj)("eye-closed",60135),fileBinary:(0,i.$Uj)("file-binary",60136),fileCode:(0,i.$Uj)("file-code",60137),fileMedia:(0,i.$Uj)("file-media",60138),filePdf:(0,i.$Uj)("file-pdf",60139),fileSubmodule:(0,i.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Uj)("file-symlink-file",60142),fileZip:(0,i.$Uj)("file-zip",60143),files:(0,i.$Uj)("files",60144),filter:(0,i.$Uj)("filter",60145),flame:(0,i.$Uj)("flame",60146),foldDown:(0,i.$Uj)("fold-down",60147),foldUp:(0,i.$Uj)("fold-up",60148),fold:(0,i.$Uj)("fold",60149),folderActive:(0,i.$Uj)("folder-active",60150),folderOpened:(0,i.$Uj)("folder-opened",60151),gear:(0,i.$Uj)("gear",60152),gift:(0,i.$Uj)("gift",60153),gistSecret:(0,i.$Uj)("gist-secret",60154),gist:(0,i.$Uj)("gist",60155),gitCommit:(0,i.$Uj)("git-commit",60156),gitCompare:(0,i.$Uj)("git-compare",60157),compareChanges:(0,i.$Uj)("compare-changes",60157),gitMerge:(0,i.$Uj)("git-merge",60158),githubAction:(0,i.$Uj)("github-action",60159),githubAlt:(0,i.$Uj)("github-alt",60160),globe:(0,i.$Uj)("globe",60161),grabber:(0,i.$Uj)("grabber",60162),graph:(0,i.$Uj)("graph",60163),gripper:(0,i.$Uj)("gripper",60164),heart:(0,i.$Uj)("heart",60165),home:(0,i.$Uj)("home",60166),horizontalRule:(0,i.$Uj)("horizontal-rule",60167),hubot:(0,i.$Uj)("hubot",60168),inbox:(0,i.$Uj)("inbox",60169),issueReopened:(0,i.$Uj)("issue-reopened",60171),issues:(0,i.$Uj)("issues",60172),italic:(0,i.$Uj)("italic",60173),jersey:(0,i.$Uj)("jersey",60174),json:(0,i.$Uj)("json",60175),kebabVertical:(0,i.$Uj)("kebab-vertical",60176),key:(0,i.$Uj)("key",60177),law:(0,i.$Uj)("law",60178),lightbulbAutofix:(0,i.$Uj)("lightbulb-autofix",60179),linkExternal:(0,i.$Uj)("link-external",60180),link:(0,i.$Uj)("link",60181),listOrdered:(0,i.$Uj)("list-ordered",60182),listUnordered:(0,i.$Uj)("list-unordered",60183),liveShare:(0,i.$Uj)("live-share",60184),loading:(0,i.$Uj)("loading",60185),location:(0,i.$Uj)("location",60186),mailRead:(0,i.$Uj)("mail-read",60187),mail:(0,i.$Uj)("mail",60188),markdown:(0,i.$Uj)("markdown",60189),megaphone:(0,i.$Uj)("megaphone",60190),mention:(0,i.$Uj)("mention",60191),milestone:(0,i.$Uj)("milestone",60192),gitPullRequestMilestone:(0,i.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Uj)("mortar-board",60193),move:(0,i.$Uj)("move",60194),multipleWindows:(0,i.$Uj)("multiple-windows",60195),mute:(0,i.$Uj)("mute",60196),noNewline:(0,i.$Uj)("no-newline",60197),note:(0,i.$Uj)("note",60198),octoface:(0,i.$Uj)("octoface",60199),openPreview:(0,i.$Uj)("open-preview",60200),package:(0,i.$Uj)("package",60201),paintcan:(0,i.$Uj)("paintcan",60202),pin:(0,i.$Uj)("pin",60203),play:(0,i.$Uj)("play",60204),run:(0,i.$Uj)("run",60204),plug:(0,i.$Uj)("plug",60205),preserveCase:(0,i.$Uj)("preserve-case",60206),preview:(0,i.$Uj)("preview",60207),project:(0,i.$Uj)("project",60208),pulse:(0,i.$Uj)("pulse",60209),question:(0,i.$Uj)("question",60210),quote:(0,i.$Uj)("quote",60211),radioTower:(0,i.$Uj)("radio-tower",60212),reactions:(0,i.$Uj)("reactions",60213),references:(0,i.$Uj)("references",60214),refresh:(0,i.$Uj)("refresh",60215),regex:(0,i.$Uj)("regex",60216),remoteExplorer:(0,i.$Uj)("remote-explorer",60217),remote:(0,i.$Uj)("remote",60218),remove:(0,i.$Uj)("remove",60219),replaceAll:(0,i.$Uj)("replace-all",60220),replace:(0,i.$Uj)("replace",60221),repoClone:(0,i.$Uj)("repo-clone",60222),repoForcePush:(0,i.$Uj)("repo-force-push",60223),repoPull:(0,i.$Uj)("repo-pull",60224),repoPush:(0,i.$Uj)("repo-push",60225),report:(0,i.$Uj)("report",60226),requestChanges:(0,i.$Uj)("request-changes",60227),rocket:(0,i.$Uj)("rocket",60228),rootFolderOpened:(0,i.$Uj)("root-folder-opened",60229),rootFolder:(0,i.$Uj)("root-folder",60230),rss:(0,i.$Uj)("rss",60231),ruby:(0,i.$Uj)("ruby",60232),saveAll:(0,i.$Uj)("save-all",60233),saveAs:(0,i.$Uj)("save-as",60234),save:(0,i.$Uj)("save",60235),screenFull:(0,i.$Uj)("screen-full",60236),screenNormal:(0,i.$Uj)("screen-normal",60237),searchStop:(0,i.$Uj)("search-stop",60238),server:(0,i.$Uj)("server",60240),settingsGear:(0,i.$Uj)("settings-gear",60241),settings:(0,i.$Uj)("settings",60242),shield:(0,i.$Uj)("shield",60243),smiley:(0,i.$Uj)("smiley",60244),sortPrecedence:(0,i.$Uj)("sort-precedence",60245),splitHorizontal:(0,i.$Uj)("split-horizontal",60246),splitVertical:(0,i.$Uj)("split-vertical",60247),squirrel:(0,i.$Uj)("squirrel",60248),starFull:(0,i.$Uj)("star-full",60249),starHalf:(0,i.$Uj)("star-half",60250),symbolClass:(0,i.$Uj)("symbol-class",60251),symbolColor:(0,i.$Uj)("symbol-color",60252),symbolConstant:(0,i.$Uj)("symbol-constant",60253),symbolEnumMember:(0,i.$Uj)("symbol-enum-member",60254),symbolField:(0,i.$Uj)("symbol-field",60255),symbolFile:(0,i.$Uj)("symbol-file",60256),symbolInterface:(0,i.$Uj)("symbol-interface",60257),symbolKeyword:(0,i.$Uj)("symbol-keyword",60258),symbolMisc:(0,i.$Uj)("symbol-misc",60259),symbolOperator:(0,i.$Uj)("symbol-operator",60260),symbolProperty:(0,i.$Uj)("symbol-property",60261),wrench:(0,i.$Uj)("wrench",60261),wrenchSubaction:(0,i.$Uj)("wrench-subaction",60261),symbolSnippet:(0,i.$Uj)("symbol-snippet",60262),tasklist:(0,i.$Uj)("tasklist",60263),telescope:(0,i.$Uj)("telescope",60264),textSize:(0,i.$Uj)("text-size",60265),threeBars:(0,i.$Uj)("three-bars",60266),thumbsdown:(0,i.$Uj)("thumbsdown",60267),thumbsup:(0,i.$Uj)("thumbsup",60268),tools:(0,i.$Uj)("tools",60269),triangleDown:(0,i.$Uj)("triangle-down",60270),triangleLeft:(0,i.$Uj)("triangle-left",60271),triangleRight:(0,i.$Uj)("triangle-right",60272),triangleUp:(0,i.$Uj)("triangle-up",60273),twitter:(0,i.$Uj)("twitter",60274),unfold:(0,i.$Uj)("unfold",60275),unlock:(0,i.$Uj)("unlock",60276),unmute:(0,i.$Uj)("unmute",60277),unverified:(0,i.$Uj)("unverified",60278),verified:(0,i.$Uj)("verified",60279),versions:(0,i.$Uj)("versions",60280),vmActive:(0,i.$Uj)("vm-active",60281),vmOutline:(0,i.$Uj)("vm-outline",60282),vmRunning:(0,i.$Uj)("vm-running",60283),watch:(0,i.$Uj)("watch",60284),whitespace:(0,i.$Uj)("whitespace",60285),wholeWord:(0,i.$Uj)("whole-word",60286),window:(0,i.$Uj)("window",60287),wordWrap:(0,i.$Uj)("word-wrap",60288),zoomIn:(0,i.$Uj)("zoom-in",60289),zoomOut:(0,i.$Uj)("zoom-out",60290),listFilter:(0,i.$Uj)("list-filter",60291),listFlat:(0,i.$Uj)("list-flat",60292),listSelection:(0,i.$Uj)("list-selection",60293),selection:(0,i.$Uj)("selection",60293),listTree:(0,i.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Uj)("symbol-string",60301),debugReverseContinue:(0,i.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Uj)("debug-step-back",60303),debugRestartFrame:(0,i.$Uj)("debug-restart-frame",60304),debugAlt:(0,i.$Uj)("debug-alt",60305),callIncoming:(0,i.$Uj)("call-incoming",60306),callOutgoing:(0,i.$Uj)("call-outgoing",60307),menu:(0,i.$Uj)("menu",60308),expandAll:(0,i.$Uj)("expand-all",60309),feedback:(0,i.$Uj)("feedback",60310),gitPullRequestReviewer:(0,i.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Uj)("ungroup-by-ref-type",60312),account:(0,i.$Uj)("account",60313),gitPullRequestAssignee:(0,i.$Uj)("git-pull-request-assignee",60313),bellDot:(0,i.$Uj)("bell-dot",60314),debugConsole:(0,i.$Uj)("debug-console",60315),library:(0,i.$Uj)("library",60316),output:(0,i.$Uj)("output",60317),runAll:(0,i.$Uj)("run-all",60318),syncIgnored:(0,i.$Uj)("sync-ignored",60319),pinned:(0,i.$Uj)("pinned",60320),githubInverted:(0,i.$Uj)("github-inverted",60321),serverProcess:(0,i.$Uj)("server-process",60322),serverEnvironment:(0,i.$Uj)("server-environment",60323),pass:(0,i.$Uj)("pass",60324),issueClosed:(0,i.$Uj)("issue-closed",60324),stopCircle:(0,i.$Uj)("stop-circle",60325),playCircle:(0,i.$Uj)("play-circle",60326),record:(0,i.$Uj)("record",60327),debugAltSmall:(0,i.$Uj)("debug-alt-small",60328),vmConnect:(0,i.$Uj)("vm-connect",60329),cloud:(0,i.$Uj)("cloud",60330),merge:(0,i.$Uj)("merge",60331),export:(0,i.$Uj)("export",60332),graphLeft:(0,i.$Uj)("graph-left",60333),magnet:(0,i.$Uj)("magnet",60334),notebook:(0,i.$Uj)("notebook",60335),redo:(0,i.$Uj)("redo",60336),checkAll:(0,i.$Uj)("check-all",60337),pinnedDirty:(0,i.$Uj)("pinned-dirty",60338),passFilled:(0,i.$Uj)("pass-filled",60339),circleLargeFilled:(0,i.$Uj)("circle-large-filled",60340),circleLarge:(0,i.$Uj)("circle-large",60341),circleLargeOutline:(0,i.$Uj)("circle-large-outline",60341),combine:(0,i.$Uj)("combine",60342),gather:(0,i.$Uj)("gather",60342),table:(0,i.$Uj)("table",60343),variableGroup:(0,i.$Uj)("variable-group",60344),typeHierarchy:(0,i.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Uj)("git-pull-request-create",60348),runAbove:(0,i.$Uj)("run-above",60349),runBelow:(0,i.$Uj)("run-below",60350),notebookTemplate:(0,i.$Uj)("notebook-template",60351),debugRerun:(0,i.$Uj)("debug-rerun",60352),workspaceTrusted:(0,i.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Uj)("workspace-unknown",60355),terminalCmd:(0,i.$Uj)("terminal-cmd",60356),terminalDebian:(0,i.$Uj)("terminal-debian",60357),terminalLinux:(0,i.$Uj)("terminal-linux",60358),terminalPowershell:(0,i.$Uj)("terminal-powershell",60359),terminalTmux:(0,i.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Uj)("terminal-ubuntu",60361),terminalBash:(0,i.$Uj)("terminal-bash",60362),arrowSwap:(0,i.$Uj)("arrow-swap",60363),copy:(0,i.$Uj)("copy",60364),personAdd:(0,i.$Uj)("person-add",60365),filterFilled:(0,i.$Uj)("filter-filled",60366),wand:(0,i.$Uj)("wand",60367),debugLineByLine:(0,i.$Uj)("debug-line-by-line",60368),inspect:(0,i.$Uj)("inspect",60369),layers:(0,i.$Uj)("layers",60370),layersDot:(0,i.$Uj)("layers-dot",60371),layersActive:(0,i.$Uj)("layers-active",60372),compass:(0,i.$Uj)("compass",60373),compassDot:(0,i.$Uj)("compass-dot",60374),compassActive:(0,i.$Uj)("compass-active",60375),azure:(0,i.$Uj)("azure",60376),issueDraft:(0,i.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Uj)("git-pull-request-draft",60379),debugAll:(0,i.$Uj)("debug-all",60380),debugCoverage:(0,i.$Uj)("debug-coverage",60381),runErrors:(0,i.$Uj)("run-errors",60382),folderLibrary:(0,i.$Uj)("folder-library",60383),debugContinueSmall:(0,i.$Uj)("debug-continue-small",60384),beakerStop:(0,i.$Uj)("beaker-stop",60385),graphLine:(0,i.$Uj)("graph-line",60386),graphScatter:(0,i.$Uj)("graph-scatter",60387),pieChart:(0,i.$Uj)("pie-chart",60388),bracket:(0,i.$Uj)("bracket",60175),bracketDot:(0,i.$Uj)("bracket-dot",60389),bracketError:(0,i.$Uj)("bracket-error",60390),lockSmall:(0,i.$Uj)("lock-small",60391),azureDevops:(0,i.$Uj)("azure-devops",60392),verifiedFilled:(0,i.$Uj)("verified-filled",60393),newline:(0,i.$Uj)("newline",60394),layout:(0,i.$Uj)("layout",60395),layoutActivitybarLeft:(0,i.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Uj)("layout-panel-right",60401),layoutPanel:(0,i.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Uj)("layout-statusbar",60405),layoutMenubar:(0,i.$Uj)("layout-menubar",60406),layoutCentered:(0,i.$Uj)("layout-centered",60407),target:(0,i.$Uj)("target",60408),indent:(0,i.$Uj)("indent",60409),recordSmall:(0,i.$Uj)("record-small",60410),errorSmall:(0,i.$Uj)("error-small",60411),terminalDecorationError:(0,i.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Uj)("layout-sidebar-left-off",60418),blank:(0,i.$Uj)("blank",60419),heartFilled:(0,i.$Uj)("heart-filled",60420),map:(0,i.$Uj)("map",60421),mapHorizontal:(0,i.$Uj)("map-horizontal",60421),foldHorizontal:(0,i.$Uj)("fold-horizontal",60421),mapFilled:(0,i.$Uj)("map-filled",60422),mapHorizontalFilled:(0,i.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Uj)("circle-small",60423),bellSlash:(0,i.$Uj)("bell-slash",60424),bellSlashDot:(0,i.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Uj)("search-fuzzy",60429),commentDraft:(0,i.$Uj)("comment-draft",60430),send:(0,i.$Uj)("send",60431),sparkle:(0,i.$Uj)("sparkle",60432),insert:(0,i.$Uj)("insert",60433),mic:(0,i.$Uj)("mic",60434),thumbsdownFilled:(0,i.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Uj)("thumbsup-filled",60436),coffee:(0,i.$Uj)("coffee",60437),snake:(0,i.$Uj)("snake",60438),game:(0,i.$Uj)("game",60439),vr:(0,i.$Uj)("vr",60440),chip:(0,i.$Uj)("chip",60441),piano:(0,i.$Uj)("piano",60442),music:(0,i.$Uj)("music",60443),micFilled:(0,i.$Uj)("mic-filled",60444),repoFetch:(0,i.$Uj)("repo-fetch",60445),copilot:(0,i.$Uj)("copilot",60446),lightbulbSparkle:(0,i.$Uj)("lightbulb-sparkle",60447),robot:(0,i.$Uj)("robot",60448),sparkleFilled:(0,i.$Uj)("sparkle-filled",60449),diffSingle:(0,i.$Uj)("diff-single",60450),diffMultiple:(0,i.$Uj)("diff-multiple",60451),surroundWith:(0,i.$Uj)("surround-with",60452),share:(0,i.$Uj)("share",60453),gitStash:(0,i.$Uj)("git-stash",60454),gitStashApply:(0,i.$Uj)("git-stash-apply",60455),gitStashPop:(0,i.$Uj)("git-stash-pop",60456),vscode:(0,i.$Uj)("vscode",60457),vscodeInsiders:(0,i.$Uj)("vscode-insiders",60458),codeOss:(0,i.$Uj)("code-oss",60459),runCoverage:(0,i.$Uj)("run-coverage",60460),runAllCoverage:(0,i.$Uj)("run-all-coverage",60461),coverage:(0,i.$Uj)("coverage",60462),githubProject:(0,i.$Uj)("github-project",60463),mapVertical:(0,i.$Uj)("map-vertical",60464),foldVertical:(0,i.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Uj)("fold-vertical-filled",60465),goToSearch:(0,i.$Uj)("go-to-search",60466),percentage:(0,i.$Uj)("percentage",60467),sortPercentage:(0,i.$Uj)("sort-percentage",60467),attach:(0,i.$Uj)("attach",60468)}}),define(we[18],ve([1,0,45,100]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zj=t.$Yj=void 0,t.$Xj=B;function B(){return Object.values(t.$Zj)}t.$Yj={dialogError:(0,i.$Uj)("dialog-error","error"),dialogWarning:(0,i.$Uj)("dialog-warning","warning"),dialogInfo:(0,i.$Uj)("dialog-info","info"),dialogClose:(0,i.$Uj)("dialog-close","close"),treeItemExpanded:(0,i.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Uj)("tree-item-loading","loading"),menuSelection:(0,i.$Uj)("menu-selection","check"),menuSubmenu:(0,i.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Uj)("toolbar-more","more"),quickInputBack:(0,i.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Uj)("drop-down-button",60084),symbolCustomColor:(0,i.$Uj)("symbol-customcolor",60252),exportIcon:(0,i.$Uj)("export",60332),workspaceUnspecified:(0,i.$Uj)("workspace-unspecified",60355),newLine:(0,i.$Uj)("newline",60394),thumbsDownFilled:(0,i.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Uj)("thumbsup-filled",60436),gitFetch:(0,i.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Uj)("debug-breakpoint-pending",60377)},t.$Zj={...C.$Wj,...t.$Yj}}),define(we[61],ve([1,0,10]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7n=C,t.$8n=B,t.$9n=E,t.$0n=d,t.$$n=g,t.$_n=$,t.$ao=P,t.$bo=c,t.$co=l,t.$do=e,t.$eo=n,t.$fo=o,t.$go=f;function C(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([m,b])=>{v[m]=b&&typeof b=="object"?C(b):b}),v}function B(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const b in m)if(U.call(m,b)){const r=m[b];typeof r=="object"&&!Object.isFrozen(r)&&!(0,i.$dg)(r)&&v.push(r)}}return h}const U=Object.prototype.hasOwnProperty;function E(h,v){return A(h,v,new Set)}function A(h,v,m){if((0,i.$jg)(h))return h;const b=v(h);if(typeof b<"u")return b;if(Array.isArray(h)){const r=[];for(const p of h)r.push(A(p,v,m));return r}if((0,i.$cg)(h)){if(m.has(h))throw new Error("Cannot clone recursive data-structure");m.add(h);const r={};for(const p in h)U.call(h,p)&&(r[p]=A(h[p],v,m));return m.delete(h),r}return h}function d(h,v,m=!0){return(0,i.$cg)(h)?((0,i.$cg)(v)&&Object.keys(v).forEach(b=>{b in h?m&&((0,i.$cg)(h[b])&&(0,i.$cg)(v[b])?d(h[b],v[b],m):h[b]=v[b]):h[b]=v[b]}),h):v}function g(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let m,b;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(m=0;m<h.length;m++)if(!g(h[m],v[m]))return!1}else{const r=[];for(b in h)r.push(b);r.sort();const p=[];for(b in v)p.push(b);if(p.sort(),!g(r,p))return!1;for(m=0;m<r.length;m++)if(!g(h[r[m]],v[r[m]]))return!1}return!0}function $(h){const v=new Set;return JSON.stringify(h,(m,b)=>{if((0,i.$cg)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return typeof b=="bigint"?`[BigInt ${b.toString()}]`:b})}function P(h,v){const m=Object.create(null);return!h||!v||Object.keys(v).forEach(r=>{const p=h[r],S=v[r];g(p,S)||(m[r]=S)}),m}function c(h,v){const m=v.toLowerCase(),b=Object.keys(h).find(r=>r.toLowerCase()===m);return b?h[b]:h[v]}function l(h,v){const m=Object.create(null);for(const[b,r]of Object.entries(h))v(b,r)&&(m[b]=r);return m}function e(h){let v=[];for(;Object.prototype!==h;)v=v.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return v}function n(h){const v=[];for(const m of e(h))typeof h[m]=="function"&&v.push(m);return v}function o(h,v){const m=r=>function(){const p=Array.prototype.slice.call(arguments,0);return v(r,p)},b={};for(const r of h)b[r]=m(r);return b}function f(h,v){const m={};for(const[b,r]of Object.entries(h))m[b]=v(r,b);return m}}),define(we[19],ve([1,0,18]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$1j=B;var C;(function(E){function A(d){return d&&typeof d=="object"&&typeof d.id=="string"}E.isThemeColor=A})(C||(t.ThemeColor=C={}));function B(E){return{id:E}}var U;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function d(h){const v=A.exec(h.id);if(!v)return d(i.$Zj.error);const[,m,b]=v,r=["codicon","codicon-"+m];return b&&r.push("codicon-modifier-"+b.substring(1)),r}E.asClassNameArray=d;function g(h){return d(h).join(" ")}E.asClassName=g;function $(h){return"."+d(h).join(".")}E.asCSSSelector=$;function P(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||C.isThemeColor(h.color))}E.isThemeIcon=P;const c=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function l(h){const v=c.exec(h);if(!v)return;const[,m]=v;return{id:m}}E.fromString=l;function e(h){return{id:h}}E.fromId=e;function n(h,v){let m=h.id;const b=m.lastIndexOf("~");return b!==-1&&(m=m.substring(0,b)),v&&(m=`${m}~${v}`),{id:m}}E.modify=n;function o(h){const v=h.id.lastIndexOf("~");if(v!==-1)return h.id.substring(v+1)}E.getModifier=o;function f(h,v){return h.id===v.id&&h.color?.id===v.color?.id}E.isEqual=f})(U||(t.ThemeIcon=U={}))}),define(we[62],ve([1,0,44,9,19]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rk=d,t.$Sk=$,t.$Tk=c,t.$Uk=l,t.$Vk=n,t.$Wk=o;const U="$(",E=new RegExp(`\\$\\(${B.ThemeIcon.iconNameExpression}(?:${B.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${E.source}`,"g");function d(f){return f.replace(A,(h,v)=>v?h:`\\${h}`)}const g=new RegExp(`\\\\${E.source}`,"g");function $(f){return f.replace(g,h=>`\\${h}`)}const P=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function c(f){return f.indexOf(U)===-1?f:f.replace(P,(h,v,m,b)=>m?h:v||b||"")}function l(f){return f?f.replace(/\$\((.*?)\)/g,(h,v)=>` ${v} `).trim():""}const e=new RegExp(`\\$\\(${B.ThemeIcon.iconNameCharacter}+\\)`,"g");function n(f){e.lastIndex=0;let h="";const v=[];let m=0;for(;;){const b=e.lastIndex,r=e.exec(f),p=f.substring(b,r?.index);if(p.length>0){h+=p;for(let S=0;S<p.length;S++)v.push(m)}if(!r)break;m+=r[0].length}return{text:h,iconOffsets:v}}function o(f,h,v=!1){const{text:m,iconOffsets:b}=h;if(!b||b.length===0)return(0,i.$Ik)(f,m,v);const r=(0,C.$if)(m," "),p=m.length-r.length,S=(0,i.$Ik)(f,r,v);if(S)for(const F of S){const I=b[F.start+p]+p;F.start+=I,F.end+=I}return S}}),define(we[101],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lW=t.$kW=void 0,t.$kW="vscode:contextmenu",t.$lW="vscode:onCloseContextMenu"}),define(we[102],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sW=void 0;class i{constructor(B,U){this.a=B,this.onMessage=U}send(B){try{this.a.send("vscode:message",B.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$sW=i}),define(we[35],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const i=globalThis.vscode;t.$O=i.ipcRenderer,t.$P=i.ipcMessagePort,t.$Q=i.webFrame,t.$R=i.process,t.$S=i.context}),define(we[103],ve([1,0,101,35]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oW=U;let B=0;function U(A,d,g){const $=[],P=B++,c=`vscode:onContextMenu${P}`,l=(e,n,o)=>{$[n].click?.(o)};C.$O.once(c,l),C.$O.once(i.$lW,(e,n)=>{n===P&&(C.$O.removeListener(c,l),g?.())}),C.$O.send(i.$kW,P,A.map(e=>E(e,$)),c,d)}function E(A,d){const g={id:d.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return d.push(A),Array.isArray(A.submenu)&&(g.submenu=A.submenu.map($=>E($,d))),g}}),define(we[63],ve([7]),{}),define(we[104],ve([7]),{}),define(we[105],ve([7]),{}),define(we[106],ve([7]),{}),define(we[107],ve([1,0,105,106]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(we[108],ve([7]),{}),define(we[109],ve([7]),{}),define(we[110],ve([7]),{}),define(we[111],ve([7]),{}),define(we[112],ve([7]),{}),define(we[113],ve([7]),{}),define(we[114],ve([7]),{}),define(we[115],ve([7]),{}),define(we[116],ve([7]),{}),define(we[117],ve([13,12]),function(se,t){return se.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(we[118],ve([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInput",t)}),define(we[119],ve([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(we[120],ve([13,12]),function(se,t){return se.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(we[121],ve([13,12]),function(se,t){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(we[122],ve([13,12]),function(se,t){return se.create("vs/base/browser/ui/tree/abstractTree",t)}),define(we[123],ve([13,12]),function(se,t){return se.create("vs/base/common/actions",t)}),define(we[46],ve([1,0,3,2,123]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jj=t.$ij=t.$hj=t.$gj=t.$fj=void 0,t.$kj=$;class U extends C.$Uc{constructor(c,l="",e="",n=!0,o){super(),this.j=this.B(new i.$he),this.onDidChange=this.j.event,this.z=!0,this.m=c,this.n=l,this.w=e,this.z=n,this.D=o}get id(){return this.m}get label(){return this.n}set label(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.j.fire({label:c}))}get tooltip(){return this.u||""}set tooltip(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.j.fire({tooltip:c}))}get class(){return this.w}set class(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.j.fire({class:c}))}get enabled(){return this.z}set enabled(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.j.fire({enabled:c}))}get checked(){return this.C}set checked(c){this.J(c)}J(c){this.C!==c&&(this.C=c,this.j.fire({checked:c}))}async run(c,l){this.D&&await this.D(c)}}t.$fj=U;class E extends C.$Uc{constructor(){super(...arguments),this.f=this.B(new i.$he),this.onWillRun=this.f.event,this.m=this.B(new i.$he),this.onDidRun=this.m.event}async run(c,l){if(!c.enabled)return;this.f.fire({action:c});let e;try{await this.u(c,l)}catch(n){e=n}this.m.fire({action:c,error:e})}async u(c,l){await c.run(l)}}t.$gj=E;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let l=[];for(const e of c)e.length&&(l.length?l=[...l,new A,...e]:l=e);return l}static{this.ID="vs.actions.separator"}async run(){}}t.$hj=A;class d{get actions(){return this.a}constructor(c,l,e,n){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=l,this.class=n,this.a=e}async run(){}}t.$ij=d;class g extends U{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,B.localize(0,null),void 0,!1)}}t.$jj=g;function $(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...c)=>P.run(...c),tooltip:P.label}}}),define(we[124],ve([13,12]),function(se,t){return se.create("vs/base/common/platform",t)}),define(we[5],ve([1,0,124]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=p,t.$D=j,t.$J=W,t.$g="en";let C=!1,B=!1,U=!1,E=!1,A=!1,d=!1,g=!1,$=!1,P=!1,c=!1,l,e=t.$g,n=t.$g,o,f;const h=globalThis;let v;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?v=h.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(v=process);const m=typeof v?.versions?.electron=="string",b=m&&v?.type==="renderer";if(typeof v=="object"){C=v.platform==="win32",B=v.platform==="darwin",U=v.platform==="linux",E=U&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,g=m,P=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=t.$g,e=t.$g;const N=v.env.VSCODE_NLS_CONFIG;if(N)try{const x=JSON.parse(N),M=x.availableLanguages["*"];l=x.locale,n=x.osLocale,e=M||t.$g,o=x._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!b?(f=navigator.userAgent,C=f.indexOf("Windows")>=0,B=f.indexOf("Macintosh")>=0,$=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=f.indexOf("Linux")>=0,c=f?.indexOf("Mobi")>=0,d=!0,l=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=l,n=navigator.language):console.error("Unable to resolve platform.");var r;(function(N){N[N.Web=0]="Web",N[N.Mac=1]="Mac",N[N.Linux=2]="Linux",N[N.Windows=3]="Windows"})(r||(t.Platform=r={}));function p(N){switch(N){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let S=0;B?S=1:C?S=3:U&&(S=2),t.$i=C,t.$j=B,t.$k=U,t.$l=E,t.$m=A,t.$n=g,t.$o=d,t.$p=d&&typeof h.importScripts=="function",t.$q=t.$p?h.origin:void 0,t.$r=$,t.$s=c,t.$t=P,t.$u=S,t.$v=f,t.$w=e;var F;(function(N){function x(){return t.$w}N.value=x;function M(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}N.isDefaultVariant=M;function Q(){return t.$w==="en"}N.isDefault=Q})(F||(t.Language=F={})),t.$x=l,t.$y=n,t.$z=o,t.$A=typeof h.postMessage=="function"&&!h.importScripts,t.$B=(()=>{if(t.$A){const N=[];h.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let Q=0,ie=N.length;Q<ie;Q++){const ue=N[Q];if(ue.id===M.data.vscodeScheduleAsyncWork){N.splice(Q,1),ue.callback();return}}});let x=0;return M=>{const Q=++x;N.push({id:Q,callback:M}),h.postMessage({vscodeScheduleAsyncWork:Q},"*")}}return N=>setTimeout(N)})();var I;(function(N){N[N.Windows=1]="Windows",N[N.Macintosh=2]="Macintosh",N[N.Linux=3]="Linux"})(I||(t.OperatingSystem=I={})),t.OS=B||$?2:C?1:3;let H=!0,w=!1;function j(){if(!w){w=!0;const N=new Uint8Array(2);N[0]=1,N[1]=2,H=new Uint16Array(N.buffer)[0]===513}return H}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function W(N){return parseFloat(N)>=20}}),define(we[125],ve([1,0,17,22,5]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_Q=t.KeyboardSupport=void 0;var U;(function(E){E[E.Always=0]="Always",E[E.FullScreen=1]="FullScreen",E[E.None=2]="None"})(U||(t.KeyboardSupport=U={})),t.$_Q={clipboard:{writeText:B.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:B.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:B.$m||i.$0Q()?0:navigator.keyboard||i.$6Q?1:2,touch:"ontouchstart"in C.$QQ||navigator.maxTouchPoints>0,pointerEvents:C.$QQ.PointerEvent&&("ontouchstart"in C.$QQ||navigator.maxTouchPoints>0)}}),define(we[15],ve([1,0,17,54,87,5]),function(se,t,i,C,B,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hR=void 0,t.$fR=P,t.$gR=c;function E(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return C.KeyCodeUtils.fromString(o)}const n=e.keyCode;if(n===3)return 7;if(i.$3Q)switch(n){case 59:return 85;case 60:if(U.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$j)return 57;break}else if(i.$4Q){if(U.$j&&n===93)return 57;if(!U.$j&&n===92)return 57}return C.$Fr[n]||0}const A=U.$j?256:2048,d=512,g=1024,$=U.$j?2048:256;function P(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function c(e){const n=[];return e.ctrlKey&&n.push("ctrl"),e.shiftKey&&n.push("shift"),e.altKey&&n.push("alt"),e.metaKey&&n.push("meta"),`modifiers: [${n.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${C.KeyCodeUtils.toString(e.keyCode)}')`}class l{constructor(n){this._standardKeyboardEventBrand=!0;const o=n;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=E(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(n){return this.a===n}c(){let n=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode);let o=0;return this.ctrlKey&&(o|=A),this.altKey&&(o|=d),this.shiftKey&&(o|=g),this.metaKey&&(o|=$),o|=n,o}d(){let n=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(n=this.keyCode),new B.$Nr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,n)}}t.$hR=l}),define(we[20],ve([1,0,17,79,5]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eR=t.$dR=t.$cR=void 0;class U{constructor(g,$){this.timestamp=Date.now(),this.browserEvent=$,this.leftButton=$.button===0,this.middleButton=$.button===1,this.rightButton=$.button===2,this.buttons=$.buttons,this.target=$.target,this.detail=$.detail||1,$.type==="dblclick"&&(this.detail=2),this.ctrlKey=$.ctrlKey,this.shiftKey=$.shiftKey,this.altKey=$.altKey,this.metaKey=$.metaKey,typeof $.pageX=="number"?(this.posx=$.pageX,this.posy=$.pageY):(this.posx=$.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=$.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const P=C.$aR.getPositionOfChildWindowRelativeToAncestorWindow(g,$.view);this.posx-=P.left,this.posy-=P.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$cR=U;class E extends U{constructor(g,$){super(g,$),this.dataTransfer=$.dataTransfer}}t.$dR=E;class A{constructor(g,$=0,P=0){this.browserEvent=g||null,this.target=g?g.target||g.targetNode||g.srcElement:null,this.deltaY=P,this.deltaX=$;let c=!1;if(i.$5Q){const l=navigator.userAgent.match(/Chrome\/(\d+)/);c=(l?parseInt(l[1]):123)<=122}if(g){const l=g,e=g,n=g.view?.devicePixelRatio||1;if(typeof l.wheelDeltaY<"u")c?this.deltaY=l.wheelDeltaY/(120*n):this.deltaY=l.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?i.$3Q&&!B.$j?this.deltaY=-g.deltaY/3:this.deltaY=-g.deltaY:this.deltaY=-g.deltaY/40}if(typeof l.wheelDeltaX<"u")i.$6Q&&B.$i?this.deltaX=-(l.wheelDeltaX/120):c?this.deltaX=l.wheelDeltaX/(120*n):this.deltaX=l.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-g.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?i.$3Q&&!B.$j?this.deltaX=-g.deltaX/3:this.deltaX=-g.deltaX:this.deltaX=-g.deltaX/40}this.deltaY===0&&this.deltaX===0&&g.wheelDelta&&(c?this.deltaY=g.wheelDelta/(120*n):this.deltaY=g.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$eR=A}),define(we[126],ve([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let C;const B=globalThis.vscode;if(typeof B<"u"&&typeof B.process<"u"){const U=B.process;C={get platform(){return U.platform},get arch(){return U.arch},get env(){return U.env},cwd(){return U.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=C.cwd,t.env=C.env,t.$dc=C.platform,t.$ec=C.arch}),define(we[25],ve([1,0,126]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const C=65,B=97,U=90,E=122,A=46,d=47,g=92,$=58,P=63;class c extends Error{constructor(p,S,F){let I;typeof S=="string"&&S.indexOf("not ")===0?(I="must not be",S=S.replace(/^not /,"")):I="must be";const H=p.indexOf(".")!==-1?"property":"argument";let w=`The "${p}" ${H} ${I} of type ${S}`;w+=`. Received type ${typeof F}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function l(r,p){if(r===null||typeof r!="object")throw new c(p,"Object",r)}function e(r,p){if(typeof r!="string")throw new c(p,"string",r)}const n=i.$dc==="win32";function o(r){return r===d||r===g}function f(r){return r===d}function h(r){return r>=C&&r<=U||r>=B&&r<=E}function v(r,p,S,F){let I="",H=0,w=-1,j=0,W=0;for(let N=0;N<=r.length;++N){if(N<r.length)W=r.charCodeAt(N);else{if(F(W))break;W=d}if(F(W)){if(!(w===N-1||j===1))if(j===2){if(I.length<2||H!==2||I.charCodeAt(I.length-1)!==A||I.charCodeAt(I.length-2)!==A){if(I.length>2){const x=I.lastIndexOf(S);x===-1?(I="",H=0):(I=I.slice(0,x),H=I.length-1-I.lastIndexOf(S)),w=N,j=0;continue}else if(I.length!==0){I="",H=0,w=N,j=0;continue}}p&&(I+=I.length>0?`${S}..`:"..",H=2)}else I.length>0?I+=`${S}${r.slice(w+1,N)}`:I=r.slice(w+1,N),H=N-w-1;w=N,j=0}else W===A&&j!==-1?++j:j=-1}return I}function m(r,p){l(p,"pathObject");const S=p.dir||p.root,F=p.base||`${p.name||""}${p.ext||""}`;return S?S===p.root?`${S}${F}`:`${S}${r}${F}`:F}t.$fc={resolve(...r){let p="",S="",F=!1;for(let I=r.length-1;I>=-1;I--){let H;if(I>=0){if(H=r[I],e(H,"path"),H.length===0)continue}else p.length===0?H=i.cwd():(H=i.env[`=${p}`]||i.cwd(),(H===void 0||H.slice(0,2).toLowerCase()!==p.toLowerCase()&&H.charCodeAt(2)===g)&&(H=`${p}\\`));const w=H.length;let j=0,W="",N=!1;const x=H.charCodeAt(0);if(w===1)o(x)&&(j=1,N=!0);else if(o(x))if(N=!0,o(H.charCodeAt(1))){let M=2,Q=M;for(;M<w&&!o(H.charCodeAt(M));)M++;if(M<w&&M!==Q){const ie=H.slice(Q,M);for(Q=M;M<w&&o(H.charCodeAt(M));)M++;if(M<w&&M!==Q){for(Q=M;M<w&&!o(H.charCodeAt(M));)M++;(M===w||M!==Q)&&(W=`\\\\${ie}\\${H.slice(Q,M)}`,j=M)}}}else j=1;else h(x)&&H.charCodeAt(1)===$&&(W=H.slice(0,2),j=2,w>2&&o(H.charCodeAt(2))&&(N=!0,j=3));if(W.length>0)if(p.length>0){if(W.toLowerCase()!==p.toLowerCase())continue}else p=W;if(F){if(p.length>0)break}else if(S=`${H.slice(j)}\\${S}`,F=N,N&&p.length>0)break}return S=v(S,!F,"\\",o),F?`${p}\\${S}`:`${p}${S}`||"."},normalize(r){e(r,"path");const p=r.length;if(p===0)return".";let S=0,F,I=!1;const H=r.charCodeAt(0);if(p===1)return f(H)?"\\":r;if(o(H))if(I=!0,o(r.charCodeAt(1))){let j=2,W=j;for(;j<p&&!o(r.charCodeAt(j));)j++;if(j<p&&j!==W){const N=r.slice(W,j);for(W=j;j<p&&o(r.charCodeAt(j));)j++;if(j<p&&j!==W){for(W=j;j<p&&!o(r.charCodeAt(j));)j++;if(j===p)return`\\\\${N}\\${r.slice(W)}\\`;j!==W&&(F=`\\\\${N}\\${r.slice(W,j)}`,S=j)}}}else S=1;else h(H)&&r.charCodeAt(1)===$&&(F=r.slice(0,2),S=2,p>2&&o(r.charCodeAt(2))&&(I=!0,S=3));let w=S<p?v(r.slice(S),!I,"\\",o):"";return w.length===0&&!I&&(w="."),w.length>0&&o(r.charCodeAt(p-1))&&(w+="\\"),F===void 0?I?`\\${w}`:w:I?`${F}\\${w}`:`${F}${w}`},isAbsolute(r){e(r,"path");const p=r.length;if(p===0)return!1;const S=r.charCodeAt(0);return o(S)||p>2&&h(S)&&r.charCodeAt(1)===$&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let p,S;for(let H=0;H<r.length;++H){const w=r[H];e(w,"path"),w.length>0&&(p===void 0?p=S=w:p+=`\\${w}`)}if(p===void 0)return".";let F=!0,I=0;if(typeof S=="string"&&o(S.charCodeAt(0))){++I;const H=S.length;H>1&&o(S.charCodeAt(1))&&(++I,H>2&&(o(S.charCodeAt(2))?++I:F=!1))}if(F){for(;I<p.length&&o(p.charCodeAt(I));)I++;I>=2&&(p=`\\${p.slice(I)}`)}return t.$fc.normalize(p)},relative(r,p){if(e(r,"from"),e(p,"to"),r===p)return"";const S=t.$fc.resolve(r),F=t.$fc.resolve(p);if(S===F||(r=S.toLowerCase(),p=F.toLowerCase(),r===p))return"";let I=0;for(;I<r.length&&r.charCodeAt(I)===g;)I++;let H=r.length;for(;H-1>I&&r.charCodeAt(H-1)===g;)H--;const w=H-I;let j=0;for(;j<p.length&&p.charCodeAt(j)===g;)j++;let W=p.length;for(;W-1>j&&p.charCodeAt(W-1)===g;)W--;const N=W-j,x=w<N?w:N;let M=-1,Q=0;for(;Q<x;Q++){const ue=r.charCodeAt(I+Q);if(ue!==p.charCodeAt(j+Q))break;ue===g&&(M=Q)}if(Q!==x){if(M===-1)return F}else{if(N>x){if(p.charCodeAt(j+Q)===g)return F.slice(j+Q+1);if(Q===2)return F.slice(j+Q)}w>x&&(r.charCodeAt(I+Q)===g?M=Q:Q===2&&(M=3)),M===-1&&(M=0)}let ie="";for(Q=I+M+1;Q<=H;++Q)(Q===H||r.charCodeAt(Q)===g)&&(ie+=ie.length===0?"..":"\\..");return j+=M,ie.length>0?`${ie}${F.slice(j,W)}`:(F.charCodeAt(j)===g&&++j,F.slice(j,W))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const p=t.$fc.resolve(r);if(p.length<=2)return r;if(p.charCodeAt(0)===g){if(p.charCodeAt(1)===g){const S=p.charCodeAt(2);if(S!==P&&S!==A)return`\\\\?\\UNC\\${p.slice(2)}`}}else if(h(p.charCodeAt(0))&&p.charCodeAt(1)===$&&p.charCodeAt(2)===g)return`\\\\?\\${p}`;return r},dirname(r){e(r,"path");const p=r.length;if(p===0)return".";let S=-1,F=0;const I=r.charCodeAt(0);if(p===1)return o(I)?r:".";if(o(I)){if(S=F=1,o(r.charCodeAt(1))){let j=2,W=j;for(;j<p&&!o(r.charCodeAt(j));)j++;if(j<p&&j!==W){for(W=j;j<p&&o(r.charCodeAt(j));)j++;if(j<p&&j!==W){for(W=j;j<p&&!o(r.charCodeAt(j));)j++;if(j===p)return r;j!==W&&(S=F=j+1)}}}}else h(I)&&r.charCodeAt(1)===$&&(S=p>2&&o(r.charCodeAt(2))?3:2,F=S);let H=-1,w=!0;for(let j=p-1;j>=F;--j)if(o(r.charCodeAt(j))){if(!w){H=j;break}}else w=!1;if(H===-1){if(S===-1)return".";H=S}return r.slice(0,H)},basename(r,p){p!==void 0&&e(p,"ext"),e(r,"path");let S=0,F=-1,I=!0,H;if(r.length>=2&&h(r.charCodeAt(0))&&r.charCodeAt(1)===$&&(S=2),p!==void 0&&p.length>0&&p.length<=r.length){if(p===r)return"";let w=p.length-1,j=-1;for(H=r.length-1;H>=S;--H){const W=r.charCodeAt(H);if(o(W)){if(!I){S=H+1;break}}else j===-1&&(I=!1,j=H+1),w>=0&&(W===p.charCodeAt(w)?--w===-1&&(F=H):(w=-1,F=j))}return S===F?F=j:F===-1&&(F=r.length),r.slice(S,F)}for(H=r.length-1;H>=S;--H)if(o(r.charCodeAt(H))){if(!I){S=H+1;break}}else F===-1&&(I=!1,F=H+1);return F===-1?"":r.slice(S,F)},extname(r){e(r,"path");let p=0,S=-1,F=0,I=-1,H=!0,w=0;r.length>=2&&r.charCodeAt(1)===$&&h(r.charCodeAt(0))&&(p=F=2);for(let j=r.length-1;j>=p;--j){const W=r.charCodeAt(j);if(o(W)){if(!H){F=j+1;break}continue}I===-1&&(H=!1,I=j+1),W===A?S===-1?S=j:w!==1&&(w=1):S!==-1&&(w=-1)}return S===-1||I===-1||w===0||w===1&&S===I-1&&S===F+1?"":r.slice(S,I)},format:m.bind(null,"\\"),parse(r){e(r,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return p;const S=r.length;let F=0,I=r.charCodeAt(0);if(S===1)return o(I)?(p.root=p.dir=r,p):(p.base=p.name=r,p);if(o(I)){if(F=1,o(r.charCodeAt(1))){let M=2,Q=M;for(;M<S&&!o(r.charCodeAt(M));)M++;if(M<S&&M!==Q){for(Q=M;M<S&&o(r.charCodeAt(M));)M++;if(M<S&&M!==Q){for(Q=M;M<S&&!o(r.charCodeAt(M));)M++;M===S?F=M:M!==Q&&(F=M+1)}}}}else if(h(I)&&r.charCodeAt(1)===$){if(S<=2)return p.root=p.dir=r,p;if(F=2,o(r.charCodeAt(2))){if(S===3)return p.root=p.dir=r,p;F=3}}F>0&&(p.root=r.slice(0,F));let H=-1,w=F,j=-1,W=!0,N=r.length-1,x=0;for(;N>=F;--N){if(I=r.charCodeAt(N),o(I)){if(!W){w=N+1;break}continue}j===-1&&(W=!1,j=N+1),I===A?H===-1?H=N:x!==1&&(x=1):H!==-1&&(x=-1)}return j!==-1&&(H===-1||x===0||x===1&&H===j-1&&H===w+1?p.base=p.name=r.slice(w,j):(p.name=r.slice(w,H),p.base=r.slice(w,j),p.ext=r.slice(H,j))),w>0&&w!==F?p.dir=r.slice(0,w-1):p.dir=p.root,p},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(n){const r=/\\/g;return()=>{const p=i.cwd().replace(r,"/");return p.slice(p.indexOf("/"))}}return()=>i.cwd()})();t.$gc={resolve(...r){let p="",S=!1;for(let F=r.length-1;F>=-1&&!S;F--){const I=F>=0?r[F]:b();e(I,"path"),I.length!==0&&(p=`${I}/${p}`,S=I.charCodeAt(0)===d)}return p=v(p,!S,"/",f),S?`/${p}`:p.length>0?p:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const p=r.charCodeAt(0)===d,S=r.charCodeAt(r.length-1)===d;return r=v(r,!p,"/",f),r.length===0?p?"/":S?"./":".":(S&&(r+="/"),p?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===d},join(...r){if(r.length===0)return".";let p;for(let S=0;S<r.length;++S){const F=r[S];e(F,"path"),F.length>0&&(p===void 0?p=F:p+=`/${F}`)}return p===void 0?".":t.$gc.normalize(p)},relative(r,p){if(e(r,"from"),e(p,"to"),r===p||(r=t.$gc.resolve(r),p=t.$gc.resolve(p),r===p))return"";const S=1,F=r.length,I=F-S,H=1,w=p.length-H,j=I<w?I:w;let W=-1,N=0;for(;N<j;N++){const M=r.charCodeAt(S+N);if(M!==p.charCodeAt(H+N))break;M===d&&(W=N)}if(N===j)if(w>j){if(p.charCodeAt(H+N)===d)return p.slice(H+N+1);if(N===0)return p.slice(H+N)}else I>j&&(r.charCodeAt(S+N)===d?W=N:N===0&&(W=0));let x="";for(N=S+W+1;N<=F;++N)(N===F||r.charCodeAt(N)===d)&&(x+=x.length===0?"..":"/..");return`${x}${p.slice(H+W)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const p=r.charCodeAt(0)===d;let S=-1,F=!0;for(let I=r.length-1;I>=1;--I)if(r.charCodeAt(I)===d){if(!F){S=I;break}}else F=!1;return S===-1?p?"/":".":p&&S===1?"//":r.slice(0,S)},basename(r,p){p!==void 0&&e(p,"ext"),e(r,"path");let S=0,F=-1,I=!0,H;if(p!==void 0&&p.length>0&&p.length<=r.length){if(p===r)return"";let w=p.length-1,j=-1;for(H=r.length-1;H>=0;--H){const W=r.charCodeAt(H);if(W===d){if(!I){S=H+1;break}}else j===-1&&(I=!1,j=H+1),w>=0&&(W===p.charCodeAt(w)?--w===-1&&(F=H):(w=-1,F=j))}return S===F?F=j:F===-1&&(F=r.length),r.slice(S,F)}for(H=r.length-1;H>=0;--H)if(r.charCodeAt(H)===d){if(!I){S=H+1;break}}else F===-1&&(I=!1,F=H+1);return F===-1?"":r.slice(S,F)},extname(r){e(r,"path");let p=-1,S=0,F=-1,I=!0,H=0;for(let w=r.length-1;w>=0;--w){const j=r.charCodeAt(w);if(j===d){if(!I){S=w+1;break}continue}F===-1&&(I=!1,F=w+1),j===A?p===-1?p=w:H!==1&&(H=1):p!==-1&&(H=-1)}return p===-1||F===-1||H===0||H===1&&p===F-1&&p===S+1?"":r.slice(p,F)},format:m.bind(null,"/"),parse(r){e(r,"path");const p={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return p;const S=r.charCodeAt(0)===d;let F;S?(p.root="/",F=1):F=0;let I=-1,H=0,w=-1,j=!0,W=r.length-1,N=0;for(;W>=F;--W){const x=r.charCodeAt(W);if(x===d){if(!j){H=W+1;break}continue}w===-1&&(j=!1,w=W+1),x===A?I===-1?I=W:N!==1&&(N=1):I!==-1&&(N=-1)}if(w!==-1){const x=H===0&&S?1:H;I===-1||N===0||N===1&&I===w-1&&I===H+1?p.base=p.name=r.slice(x,w):(p.name=r.slice(x,I),p.base=r.slice(x,w),p.ext=r.slice(I,w))}return H>0?p.dir=r.slice(0,H-1):S&&(p.dir="/"),p},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=n?t.$fc.normalize:t.$gc.normalize,t.$ic=n?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=n?t.$fc.join:t.$gc.join,t.$kc=n?t.$fc.resolve:t.$gc.resolve,t.$lc=n?t.$fc.relative:t.$gc.relative,t.$mc=n?t.$fc.dirname:t.$gc.dirname,t.$nc=n?t.$fc.basename:t.$gc.basename,t.$oc=n?t.$fc.extname:t.$gc.extname,t.$pc=n?t.$fc.format:t.$gc.format,t.$qc=n?t.$fc.parse:t.$gc.parse,t.$rc=n?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=n?t.$fc.sep:t.$gc.sep,t.$tc=n?t.$fc.delimiter:t.$gc.delimiter}),define(we[127],ve([1,0,25,5,9,10]),function(se,t,i,C,B,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sg=E,t.$tg=A,t.$ug=d,t.$vg=g,t.$wg=$,t.$xg=e,t.$yg=n,t.$zg=o,t.$Ag=f,t.$Bg=h,t.$Cg=v,t.$Dg=m,t.$Eg=b,t.$Fg=r,t.$Gg=p,t.$Hg=S,t.$Ig=H;function E(w){return w===47||w===92}function A(w){return w.replace(/[\\/]/g,i.$gc.sep)}function d(w){return w.indexOf("/")===-1&&(w=A(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function g(w,j=i.$gc.sep){if(!w)return"";const W=w.length,N=w.charCodeAt(0);if(E(N)){if(E(w.charCodeAt(1))&&!E(w.charCodeAt(2))){let M=3;const Q=M;for(;M<W&&!E(w.charCodeAt(M));M++);if(Q!==M&&!E(w.charCodeAt(M+1))){for(M+=1;M<W;M++)if(E(w.charCodeAt(M)))return w.slice(0,M+1).replace(/[\\/]/g,j)}}return j}else if(f(N)&&w.charCodeAt(1)===58)return E(w.charCodeAt(2))?w.slice(0,2)+j:w.slice(0,2);let x=w.indexOf("://");if(x!==-1){for(x+=3;x<W;x++)if(E(w.charCodeAt(x)))return w.slice(0,x+1)}return""}function $(w){if(!C.$i||!w||w.length<5)return!1;let j=w.charCodeAt(0);if(j!==92||(j=w.charCodeAt(1),j!==92))return!1;let W=2;const N=W;for(;W<w.length&&(j=w.charCodeAt(W),j!==92);W++);return!(N===W||(j=w.charCodeAt(W+1),isNaN(j)||j===92))}const P=/[\\/:\*\?"<>\|]/g,c=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(w,j=C.$i){const W=j?P:c;return!(!w||w.length===0||/^\s+$/.test(w)||(W.lastIndex=0,W.test(w))||j&&l.test(w)||w==="."||w===".."||j&&w[w.length-1]==="."||j&&w.length!==w.trim().length||w.length>255)}function n(w,j,W){const N=w===j;return!W||N?N:!w||!j?!1:(0,B.$Bf)(w,j)}function o(w,j,W,N=i.sep){if(w===j)return!0;if(!w||!j||j.length>w.length)return!1;if(W){if(!(0,B.$Cf)(w,j))return!1;if(j.length===w.length)return!0;let M=j.length;return j.charAt(j.length-1)===N&&M--,w.charAt(M)===N}return j.charAt(j.length-1)!==N&&(j+=N),w.indexOf(j)===0}function f(w){return w>=65&&w<=90||w>=97&&w<=122}function h(w,j){return C.$i&&w.endsWith(":")&&(w+=i.sep),(0,i.$ic)(w)||(w=(0,i.$jc)(j,w)),w=(0,i.$hc)(w),v(w)}function v(w){return C.$i?(w=(0,B.$jf)(w,i.sep),w.endsWith(":")&&(w+=i.sep)):(w=(0,B.$jf)(w,i.sep),w||(w=i.sep)),w}function m(w){const j=(0,i.$hc)(w);return C.$i?w.length>3?!1:b(j)&&(w.length===2||j.charCodeAt(2)===92):j===i.$gc.sep}function b(w,j=C.$i){return j?f(w.charCodeAt(0))&&w.charCodeAt(1)===58:!1}function r(w,j=C.$i){return b(w,j)?w[0]:void 0}function p(w,j,W){return j.length>w.length?-1:w===j?0:(W&&(w=w.toLowerCase(),j=j.toLowerCase()),w.indexOf(j))}function S(w){const j=w.split(":");let W,N,x;for(const M of j){const Q=Number(M);(0,U.$eg)(Q)?N===void 0?N=Q:x===void 0&&(x=Q):W=W?[W,M].join(":"):M}if(!W)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:W,line:N!==void 0?N:void 0,column:x!==void 0?x:N!==void 0?1:void 0}}const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function H(w,j,W=8){let N="";for(let M=0;M<W;M++){let Q;M===0&&C.$i&&!j&&(W===3||W===4)?Q=I:Q=F,N+=Q.charAt(Math.floor(Math.random()*Q.length))}let x;return j?x=`${j}-${N}`:x=N,w?(0,i.$jc)(w,x):x}}),define(we[128],ve([1,0,25]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ws=void 0,t.$Xs=U,t.$Ys=E,t.$Zs=A,t.$1s=g,t.$Ws=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U($){const P=(0,i.$oc)($),c=C[P.toLowerCase()];return c!==void 0?c:E($)}function E($){const P=(0,i.$oc)($);return B[P.toLowerCase()]}function A($){for(const P in B)if(B[P]===$)return P}const d=/^(.+)\/(.+?)(;.+)?$/;function g($,P){const c=d.exec($);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:P?void 0:$}}),define(we[16],ve([1,0,25,5]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$vc=e,t.$wc=m;const B=/^\w[\w\d+.-]*$/,U=/^\//,E=/^\/\//;function A(F,I){if(!F.scheme&&I)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${F.authority}", path: "${F.path}", query: "${F.query}", fragment: "${F.fragment}"}`);if(F.scheme&&!B.test(F.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(F.path){if(F.authority){if(!U.test(F.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(F.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(F,I){return!F&&!I?"file":F}function g(F,I){switch(F){case"https":case"http":case"file":I?I[0]!==P&&(I=P+I):I=P;break}return I}const $="",P="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(I){return I instanceof l?!0:I?typeof I.authority=="string"&&typeof I.fragment=="string"&&typeof I.path=="string"&&typeof I.query=="string"&&typeof I.scheme=="string"&&typeof I.fsPath=="string"&&typeof I.with=="function"&&typeof I.toString=="function":!1}constructor(I,H,w,j,W,N=!1){typeof I=="object"?(this.scheme=I.scheme||$,this.authority=I.authority||$,this.path=I.path||$,this.query=I.query||$,this.fragment=I.fragment||$):(this.scheme=d(I,N),this.authority=H||$,this.path=g(this.scheme,w||$),this.query=j||$,this.fragment=W||$,A(this,N))}get fsPath(){return m(this,!1)}with(I){if(!I)return this;let{scheme:H,authority:w,path:j,query:W,fragment:N}=I;return H===void 0?H=this.scheme:H===null&&(H=$),w===void 0?w=this.authority:w===null&&(w=$),j===void 0?j=this.path:j===null&&(j=$),W===void 0?W=this.query:W===null&&(W=$),N===void 0?N=this.fragment:N===null&&(N=$),H===this.scheme&&w===this.authority&&j===this.path&&W===this.query&&N===this.fragment?this:new o(H,w,j,W,N)}static parse(I,H=!1){const w=c.exec(I);return w?new o(w[2]||$,S(w[4]||$),S(w[5]||$),S(w[7]||$),S(w[9]||$),H):new o($,$,$,$,$)}static file(I){let H=$;if(C.$i&&(I=I.replace(/\\/g,P)),I[0]===P&&I[1]===P){const w=I.indexOf(P,2);w===-1?(H=I.substring(2),I=P):(H=I.substring(2,w),I=I.substring(w)||P)}return new o("file",H,I,$,$)}static from(I,H){return new o(I.scheme,I.authority,I.path,I.query,I.fragment,H)}static joinPath(I,...H){if(!I.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return C.$i&&I.scheme==="file"?w=l.file(i.$fc.join(m(I,!0),...H)).path:w=i.$gc.join(I.path,...H),I.with({path:w})}toString(I=!1){return b(this,I)}toJSON(){return this}static revive(I){if(I){if(I instanceof l)return I;{const H=new o(I);return H._formatted=I.external??null,H._fsPath=I._sep===n?I.fsPath??null:null,H}}else return I}}t.URI=l;function e(F){return!F||typeof F!="object"?!1:typeof F.scheme=="string"&&(typeof F.authority=="string"||typeof F.authority>"u")&&(typeof F.path=="string"||typeof F.path>"u")&&(typeof F.query=="string"||typeof F.query>"u")&&(typeof F.fragment=="string"||typeof F.fragment>"u")}const n=C.$i?1:void 0;class o extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(I=!1){return I?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const I={$mid:1};return this._fsPath&&(I.fsPath=this._fsPath,I._sep=n),this._formatted&&(I.external=this._formatted),this.path&&(I.path=this.path),this.scheme&&(I.scheme=this.scheme),this.authority&&(I.authority=this.authority),this.query&&(I.query=this.query),this.fragment&&(I.fragment=this.fragment),I}}const f={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function h(F,I,H){let w,j=-1;for(let W=0;W<F.length;W++){const N=F.charCodeAt(W);if(N>=97&&N<=122||N>=65&&N<=90||N>=48&&N<=57||N===45||N===46||N===95||N===126||I&&N===47||H&&N===91||H&&N===93||H&&N===58)j!==-1&&(w+=encodeURIComponent(F.substring(j,W)),j=-1),w!==void 0&&(w+=F.charAt(W));else{w===void 0&&(w=F.substr(0,W));const x=f[N];x!==void 0?(j!==-1&&(w+=encodeURIComponent(F.substring(j,W)),j=-1),w+=x):j===-1&&(j=W)}}return j!==-1&&(w+=encodeURIComponent(F.substring(j))),w!==void 0?w:F}function v(F){let I;for(let H=0;H<F.length;H++){const w=F.charCodeAt(H);w===35||w===63?(I===void 0&&(I=F.substr(0,H)),I+=f[w]):I!==void 0&&(I+=F[H])}return I!==void 0?I:F}function m(F,I){let H;return F.authority&&F.path.length>1&&F.scheme==="file"?H=`//${F.authority}${F.path}`:F.path.charCodeAt(0)===47&&(F.path.charCodeAt(1)>=65&&F.path.charCodeAt(1)<=90||F.path.charCodeAt(1)>=97&&F.path.charCodeAt(1)<=122)&&F.path.charCodeAt(2)===58?I?H=F.path.substr(1):H=F.path[1].toLowerCase()+F.path.substr(2):H=F.path,C.$i&&(H=H.replace(/\//g,"\\")),H}function b(F,I){const H=I?v:h;let w="",{scheme:j,authority:W,path:N,query:x,fragment:M}=F;if(j&&(w+=j,w+=":"),(W||j==="file")&&(w+=P,w+=P),W){let Q=W.indexOf("@");if(Q!==-1){const ie=W.substr(0,Q);W=W.substr(Q+1),Q=ie.lastIndexOf(":"),Q===-1?w+=H(ie,!1,!1):(w+=H(ie.substr(0,Q),!1,!1),w+=":",w+=H(ie.substr(Q+1),!1,!0)),w+="@"}W=W.toLowerCase(),Q=W.lastIndexOf(":"),Q===-1?w+=H(W,!1,!0):(w+=H(W.substr(0,Q),!1,!0),w+=W.substr(Q))}if(N){if(N.length>=3&&N.charCodeAt(0)===47&&N.charCodeAt(2)===58){const Q=N.charCodeAt(1);Q>=65&&Q<=90&&(N=`/${String.fromCharCode(Q+32)}:${N.substr(3)}`)}else if(N.length>=2&&N.charCodeAt(1)===58){const Q=N.charCodeAt(0);Q>=65&&Q<=90&&(N=`${String.fromCharCode(Q+32)}:${N.substr(2)}`)}w+=H(N,!0,!1)}return x&&(w+="?",w+=H(x,!1,!1)),M&&(w+="#",w+=I?M:h(M,!1,!1)),w}function r(F){try{return decodeURIComponent(F)}catch{return F.length>3?F.substr(0,3)+r(F.substr(3)):F}}const p=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(F){return F.match(p)?F.replace(p,I=>r(I)):F}}),define(we[64],ve([1,0,43,16]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8h=B,t.$9h=U,t.$0h=A;function B(d){return JSON.stringify(d,E)}function U(d){let g=JSON.parse(d);return g=A(g),g}function E(d,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function A(d,g=0){if(!d||g>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return C.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof i.$Je||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let $=0;$<d.length;++$)d[$]=A(d[$],g+1);else for(const $ in d)Object.hasOwnProperty.call(d,$)&&(d[$]=A(d[$],g+1))}return d}}),define(we[36],ve([1,0,6,5,9,16,25]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Ng=t.$Mg=t.$Lg=t.Schemas=void 0,t.$Jg=d,t.$Kg=g,t.$Og=P;var A;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(A||(t.Schemas=A={}));function d(e,n){return U.URI.isUri(e)?(0,B.$Bf)(e.scheme,n):(0,B.$Cf)(e,n+":")}function g(e,...n){return n.some(o=>d(e,o))}t.$Lg="vscode-tkn",t.$Mg="tkn";class ${constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(n){this.d=n}setDelegate(n){this.e=n}setServerRootPath(n,o){this.f=P(n,o)}getServerRootPath(){return this.f}get g(){return E.$gc.join(this.f,A.vscodeRemoteResource)}set(n,o,f){this.a[n]=o,this.b[n]=f}setConnectionToken(n,o){this.c[n]=o}getPreferredWebSchema(){return this.d}rewrite(n){if(this.e)try{return this.e(n)}catch(b){return i.$1(b),n}const o=n.authority;let f=this.a[o];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const h=this.b[o],v=this.c[o];let m=`path=${encodeURIComponent(n.path)}`;return typeof v=="string"&&(m+=`&${t.$Mg}=${encodeURIComponent(v)}`),U.URI.from({scheme:C.$o?this.d:A.vscodeRemoteResource,authority:`${f}:${h}`,path:this.g,query:m})}}t.$Ng=new $;function P(e,n){return E.$gc.join(n??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Pg="vs/../../extensions",t.$Qg="vs/../../node_modules",t.$Rg="vs/../../node_modules.asar",t.$Sg="vs/../../node_modules.asar.unpacked",t.$Tg="vscode-app";class c{static{this.a=t.$Tg}asBrowserUri(n){const o=this.b(n,se);return this.uriToBrowserUri(o)}uriToBrowserUri(n){return n.scheme===A.vscodeRemote?t.$Ng.rewrite(n):n.scheme===A.file&&(C.$m||C.$q===`${A.vscodeFileResource}://${c.a}`)?n.with({scheme:A.vscodeFileResource,authority:n.authority||c.a,query:null,fragment:null}):n}asFileUri(n){const o=this.b(n,se);return this.uriToFileUri(o)}uriToFileUri(n){return n.scheme===A.vscodeFileResource?n.with({scheme:A.file,authority:n.authority!==c.a?n.authority:null,query:null,fragment:null}):n}b(n,o){return U.URI.isUri(n)?n:U.URI.parse(o.toUrl(n))}}t.$Ug=new c;var l;(function(e){const n=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(n.get("3"));const o="vscode-coi";function f(v){let m;typeof v=="string"?m=new URL(v).searchParams:v instanceof URL?m=v.searchParams:U.URI.isUri(v)&&(m=new URL(v.toString(!0)).searchParams);const b=m?.get(o);if(b)return n.get(b)}e.getHeadersFromQuery=f;function h(v,m,b){if(!globalThis.crossOriginIsolated)return;const r=m&&b?"3":b?"2":"1";v instanceof URLSearchParams?v.set(o,r):v[o]=r}e.addSearchParam=h})(l||(t.COI=l={}))}),define(we[47],ve([1,0,127,36,25,5,9,16]),function(se,t,i,C,B,U,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=void 0,t.$2g=d,t.$kh=$,t.$lh=c;function d(l){return(0,A.$wc)(l,!0)}class g{constructor(e){this.a=e}compare(e,n,o=!1){return e===n?0:(0,E.$uf)(this.getComparisonKey(e,o),this.getComparisonKey(n,o))}isEqual(e,n,o=!1){return e===n?!0:!e||!n?!1:this.getComparisonKey(e,o)===this.getComparisonKey(n,o)}getComparisonKey(e,n=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,n,o=!1){if(e.scheme===n.scheme){if(e.scheme===C.Schemas.file)return i.$zg(d(e),d(n),this.a(e))&&e.query===n.query&&(o||e.fragment===n.fragment);if((0,t.$gh)(e.authority,n.authority))return i.$zg(e.path,n.path,this.a(e),"/")&&e.query===n.query&&(o||e.fragment===n.fragment)}return!1}joinPath(e,...n){return A.URI.joinPath(e,...n)}basenameOrAuthority(e){return(0,t.$$g)(e)||e.authority}basename(e){return B.$gc.basename(e.path)}extname(e){return B.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let n;return e.scheme===C.Schemas.file?n=A.URI.file(B.$mc(d(e))).path:(n=B.$gc.dirname(e.path),e.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),n="/")),e.with({path:n})}normalizePath(e){if(!e.path.length)return e;let n;return e.scheme===C.Schemas.file?n=A.URI.file(B.$hc(d(e))).path:n=B.$gc.normalize(e.path),e.with({path:n})}relativePath(e,n){if(e.scheme!==n.scheme||!(0,t.$gh)(e.authority,n.authority))return;if(e.scheme===C.Schemas.file){const h=B.$lc(d(e),d(n));return U.$i?i.$tg(h):h}let o=e.path||"/";const f=n.path||"/";if(this.a(e)){let h=0;for(const v=Math.min(o.length,f.length);h<v&&!(o.charCodeAt(h)!==f.charCodeAt(h)&&o.charAt(h).toLowerCase()!==f.charAt(h).toLowerCase());h++);o=f.substr(0,h)+o.substr(h)}return B.$gc.relative(o,f)}resolvePath(e,n){if(e.scheme===C.Schemas.file){const o=A.URI.file(B.$kc(d(e),n));return e.with({authority:o.authority,path:o.path})}return n=i.$ug(n),e.with({path:B.$gc.resolve(e.path,n)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,n){return e===n||e!==void 0&&n!==void 0&&(0,E.$Bf)(e,n)}hasTrailingPathSeparator(e,n=B.sep){if(e.scheme===C.Schemas.file){const o=d(e);return o.length>i.$vg(o).length&&o[o.length-1]===n}else{const o=e.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,n=B.sep){return(0,t.$hh)(e,n)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,n=B.sep){let o=!1;if(e.scheme===C.Schemas.file){const f=d(e);o=f!==void 0&&f.length===i.$vg(f).length&&f[f.length-1]===n}else{n="/";const f=e.path;o=f.length===1&&f.charCodeAt(f.length-1)===47}return!o&&!(0,t.$hh)(e,n)?e.with({path:e.path+"/"}):e}}t.$3g=g,t.$4g=new g(()=>!1),t.$5g=new g(l=>l.scheme===C.Schemas.file?!U.$k:!0),t.$6g=new g(l=>!0),t.$7g=t.$4g.isEqual.bind(t.$4g),t.$8g=t.$4g.isEqualOrParent.bind(t.$4g),t.$9g=t.$4g.getComparisonKey.bind(t.$4g),t.$0g=t.$4g.basenameOrAuthority.bind(t.$4g),t.$$g=t.$4g.basename.bind(t.$4g),t.$_g=t.$4g.extname.bind(t.$4g),t.$ah=t.$4g.dirname.bind(t.$4g),t.$bh=t.$4g.joinPath.bind(t.$4g),t.$ch=t.$4g.normalizePath.bind(t.$4g),t.$dh=t.$4g.relativePath.bind(t.$4g),t.$eh=t.$4g.resolvePath.bind(t.$4g),t.$fh=t.$4g.isAbsolutePath.bind(t.$4g),t.$gh=t.$4g.isEqualAuthority.bind(t.$4g),t.$hh=t.$4g.hasTrailingPathSeparator.bind(t.$4g),t.$ih=t.$4g.removeTrailingPathSeparator.bind(t.$4g),t.$jh=t.$4g.addTrailingPathSeparator.bind(t.$4g);function $(l,e){const n=[];for(let o=0;o<l.length;o++){const f=e(l[o]);l.some((h,v)=>v===o?!1:(0,t.$8g)(f,e(h)))||n.push(l[o])}return n}var P;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function e(n){const o=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(v=>{const[m,b]=v.split(":");m&&b&&o.set(m,b)});const h=n.path.substring(0,n.path.indexOf(";"));return h&&o.set(l.META_DATA_MIME,h),o}l.parseMetaData=e})(P||(t.DataUri=P={}));function c(l,e,n){if(e){let o=l.path;return o&&o[0]!==B.$gc.sep&&(o=B.$gc.sep+o),l.with({scheme:n,authority:e,path:o})}return l.with({scheme:n})}}),define(we[11],ve([1,0,34,6,3,2,47,5,60,23]),function(se,t,i,C,B,U,E,A,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4h=t.$2h=t.$1h=t.$Zh=t.$Yh=t.Promises=t.$Xh=t.$Wh=t.$Vh=t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=void 0,t.$mh=$,t.$nh=P,t.$oh=c,t.$ph=l,t.$qh=e,t.$rh=n,t.$sh=o,t.$th=f,t.$Bh=H,t.$Ch=w,t.$Dh=j,t.$Eh=W,t.$Fh=N,t.$Uh=_,t.$3h=O;function $(y){return!!y&&typeof y.then=="function"}function P(y){const a=new i.$se,D=y(a.token),R=new Promise((s,k)=>{const T=a.token.onCancellationRequested(()=>{T.dispose(),k(new C.$5)});Promise.resolve(D).then(L=>{T.dispose(),a.dispose(),s(L)},L=>{T.dispose(),a.dispose(),k(L)})});return new class{cancel(){a.cancel(),a.dispose()}then(s,k){return R.then(s,k)}catch(s){return this.then(void 0,s)}finally(s){return R.finally(s)}}}function c(y,a,D){return new Promise((R,s)=>{const k=a.onCancellationRequested(()=>{k.dispose(),R(D)});y.then(R,s).finally(()=>k.dispose())})}function l(y,a){return new Promise((D,R)=>{const s=a.onCancellationRequested(()=>{s.dispose(),R(new C.$5)});y.then(D,R).finally(()=>s.dispose())})}async function e(y){let a=-1;const D=y.map((R,s)=>R.then(k=>(a=s,k)));try{return await Promise.race(D)}finally{y.forEach((R,s)=>{s!==a&&R.cancel()})}}function n(y,a,D){let R;const s=setTimeout(()=>{R?.(void 0),D?.()},a);return Promise.race([y.finally(()=>clearTimeout(s)),new Promise(k=>R=k)])}function o(y){return new Promise((a,D)=>{const R=y();$(R)?R.then(a,D):a(R)})}function f(){let y,a;return{promise:new Promise((R,s)=>{y=R,a=s}),resolve:y,reject:a}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(a){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=a,!this.b){const D=()=>{if(this.b=null,this.f)return;const R=this.queue(this.d);return this.d=null,R};this.b=new Promise(R=>{this.a.then(D,D).then(R)})}return new Promise((D,R)=>{this.b.then(D,R)})}return this.a=a(),new Promise((D,R)=>{this.a.then(s=>{this.a=null,D(s)},s=>{this.a=null,R(s)})})}dispose(){this.f=!0}}t.$uh=h;class v{constructor(){this.a=Promise.resolve(null)}queue(a){return this.a=this.a.then(()=>a(),()=>a())}}t.$vh=v;class m{constructor(){this.a=new Map}queue(a,D){const s=(this.a.get(a)??Promise.resolve()).catch(()=>{}).then(D).finally(()=>{this.a.get(a)===s&&this.a.delete(a)});return this.a.set(a,s),s}}t.$wh=m;const b=(y,a)=>{let D=!0;const R=setTimeout(()=>{D=!1,a()},y);return{isTriggered:()=>D,dispose:()=>{clearTimeout(R),D=!1}}},r=y=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,y())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class p{constructor(a){this.defaultDelay=a,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(a,D=this.defaultDelay){this.g=a,this.h(),this.b||(this.b=new Promise((s,k)=>{this.d=s,this.f=k}).then(()=>{if(this.b=null,this.d=null,this.g){const s=this.g;return this.g=null,s()}}));const R=()=>{this.a=null,this.d?.(null)};return this.a=D===d.$ce?r(R):b(D,R),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$xh=p;class S{constructor(a){this.a=new p(a),this.b=new h}trigger(a,D){return this.a.trigger(()=>this.b.queue(a),D)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$yh=S;class F{constructor(){this.a=!1,this.b=new Promise((a,D)=>{this.d=a})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$zh=F;class I extends F{constructor(a){super(),this.f=setTimeout(()=>this.open(),a)}open(){clearTimeout(this.f),super.open()}}t.$Ah=I;function H(y,a){return a?new Promise((D,R)=>{const s=setTimeout(()=>{k.dispose(),D()},y),k=a.onCancellationRequested(()=>{clearTimeout(s),k.dispose(),R(new C.$5)})}):P(D=>H(y,D))}function w(y,a=0,D){const R=setTimeout(()=>{y(),D&&s.dispose()},a),s=(0,U.$Sc)(()=>{clearTimeout(R),D?.deleteAndLeak(s)});return D?.add(s),s}function j(y){const a=[];let D=0;const R=y.length;function s(){return D<R?y[D++]():null}function k(T){T!=null&&a.push(T);const L=s();return L?L.then(k):Promise.resolve(a)}return Promise.resolve(null).then(k)}function W(y,a=R=>!!R,D=null){let R=0;const s=y.length,k=()=>{if(R>=s)return Promise.resolve(D);const T=y[R++];return Promise.resolve(T()).then(z=>a(z)?Promise.resolve(z):k())};return k()}function N(y,a=R=>!!R,D=null){if(y.length===0)return Promise.resolve(D);let R=y.length;const s=()=>{R=-1;for(const k of y)k.cancel?.()};return new Promise((k,T)=>{for(const L of y)L.then(z=>{--R>=0&&a(z)?(s(),k(z)):R===0&&k(D)}).catch(z=>{--R>=0&&(s(),T(z))})})}class x{constructor(a){this.a=0,this.b=!1,this.f=a,this.g=[],this.d=0,this.h=new B.$he}whenIdle(){return this.size>0?B.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(a){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((D,R)=>{this.g.push({factory:a,c:D,e:R}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const a=this.g.shift();this.d++;const D=a.factory();D.then(a.c,a.e),D.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Gh=x;class M extends x{constructor(){super(1)}}t.$Hh=M;class Q{constructor(){this.a=new fe,this.b=0}queue(a){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,a())):this.a.run(this.b++,a())}}t.$Ih=Q;class ie{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const a=new Z;return this.b.add(a),a.p}g(){for(const[,a]of this.a)if(a.size>0)return!1;return!0}queueSize(a,D=E.$4g){const R=D.getComparisonKey(a);return this.a.get(R)?.size??0}queueFor(a,D,R=E.$4g){const s=R.getComparisonKey(a);let k=this.a.get(s);if(!k){k=new M;const T=this.f++,L=B.Event.once(k.onDrained)(()=>{k?.dispose(),this.a.delete(s),this.h(),this.d?.deleteAndDispose(T),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$4c),this.d.set(T,L),this.a.set(s,k)}return k.queue(D)}h(){this.g()&&this.j()}j(){for(const a of this.b)a.complete();this.b.clear()}dispose(){for(const[,a]of this.a)a.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Jh=ie;class ue{constructor(a,D){this.a=-1,typeof a=="function"&&typeof D=="number"&&this.setIfNotSet(a,D)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(a,D){this.cancel(),this.a=setTimeout(()=>{this.a=-1,a()},D)}setIfNotSet(a,D){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,a()},D))}}t.$Kh=ue;class G{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(a,D,R=globalThis){this.cancel();const s=R.setInterval(()=>{a()},D);this.d=(0,U.$Sc)(()=>{R.clearInterval(s),this.d=void 0})}dispose(){this.cancel()}}t.$Lh=G;class ee{constructor(a,D){this.b=-1,this.a=a,this.d=D,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(a=this.d){this.cancel(),this.b=setTimeout(this.f,a)}get delay(){return this.d}set delay(a){this.d=a}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Mh=ee;class de{constructor(a,D){D%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${D}ms is not a multiple of 1000ms.`),this.a=a,this.b=D,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(a=this.b){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(a/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Nh=de;class ye extends ee{constructor(a,D){super(a,D),this.j=[]}work(a){this.j.push(a),this.isScheduled()||this.schedule()}h(){const a=this.j;this.j=[],this.a?.(a)}dispose(){this.j=[],super.dispose()}}t.$Oh=ye;class Ae extends U.$Uc{constructor(a,D){super(),this.g=a,this.h=D,this.a=[],this.b=this.B(new U.$Vc),this.f=!1}get pending(){return this.a.length}work(a){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+a.length>this.g.maxBufferedWork)return!1}else if(this.pending+a.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const D of a)this.a.push(D);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Ph=Ae,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Rh=(y,a)=>{(0,A.$B)(()=>{if(D)return;const R=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,R-Date.now())}}))});let D=!1;return{dispose(){D||(D=!0)}}}:t.$Rh=(y,a,D)=>{const R=y.requestIdleCallback(a,typeof D=="number"?{timeout:D}:void 0);let s=!1;return{dispose(){s||(s=!0,y.cancelIdleCallback(R))}}},t.$Qh=y=>(0,t.$Rh)(globalThis,y)}();class je{constructor(a,D){this.g=!1,this.d=()=>{try{this.j=D()}catch(R){this.l=R}finally{this.g=!0}},this.f=(0,t.$Rh)(a,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Sh=je;class le extends je{constructor(a){super(globalThis,a)}}t.$Th=le;async function _(y,a,D){let R;for(let s=0;s<D;s++)try{return await y()}catch(k){R=k,await H(a)}throw R}class fe{isRunning(a){return typeof a=="number"?this.a?.taskId===a:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(a,D,R){return this.a={taskId:a,cancel:()=>R?.(),promise:D},D.then(()=>this.d(a),()=>this.d(a)),D}d(a){this.a&&a===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const a=this.b;this.b=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this.b)this.b.run=a;else{const{promise:D,resolve:R,reject:s}=f();this.b={run:a,promise:D,promiseResolve:R,promiseReject:s}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Vh=fe;class he{constructor(a,D=()=>Date.now()){this.d=a,this.f=D,this.a=0,this.b=0}increment(){const a=this.f();return a-this.a>this.d&&(this.a=a,this.b=0),this.b++,this.b}}t.$Wh=he;var Fe;(function(y){y[y.Resolved=0]="Resolved",y[y.Rejected=1]="Rejected"})(Fe||(Fe={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((a,D)=>{this.a=a,this.b=D})}complete(a){return new Promise(D=>{this.a(a),this.d={outcome:0,value:a},D()})}error(a){return new Promise(D=>{this.b(a),this.d={outcome:1,value:a},D()})}cancel(){return this.error(new C.$5)}}t.$Xh=Z;var pe;(function(y){async function a(R){let s;const k=await Promise.all(R.map(T=>T.then(L=>L,L=>{s||(s=L)})));if(typeof s<"u")throw s;return k}y.settled=a;function D(R){return new Promise(async(s,k)=>{try{await R(s,k)}catch(T){k(T)}})}y.withAsyncBody=D})(pe||(t.Promises=pe={}));class Se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(a){this.a=void 0,this.b=void 0,this.d=!1,this.promise=a.then(D=>(this.a=D,this.d=!0,D),D=>{throw this.b=D,this.d=!0,D})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Yh=Se;class Re{constructor(a){this.b=a,this.a=new g.$V(()=>new Se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Zh=Re;var re;(function(y){y[y.Initial=0]="Initial",y[y.DoneOK=1]="DoneOK",y[y.DoneError=2]="DoneError"})(re||(re={}));class me{static fromArray(a){return new me(D=>{D.emitMany(a)})}static fromPromise(a){return new me(async D=>{D.emitMany(await a)})}static fromPromises(a){return new me(async D=>{await Promise.all(a.map(async R=>D.emitOne(await R)))})}static merge(a){return new me(async D=>{await Promise.all(a.map(async R=>{for await(const s of R)D.emitOne(s)}))})}static{this.EMPTY=me.fromArray([])}constructor(a,D){this.a=0,this.b=[],this.d=null,this.f=D,this.g=new B.$he,queueMicrotask(async()=>{const R={emitOne:s=>this.h(s),emitMany:s=>this.j(s),reject:s=>this.l(s)};try{await Promise.resolve(a(R)),this.k()}catch(s){this.l(s)}finally{R.emitOne=void 0,R.emitMany=void 0,R.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(a<this.b.length)return{done:!1,value:this.b[a++]};if(this.a===1)return{done:!0,value:void 0};await B.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(a,D){return new me(async R=>{for await(const s of a)R.emitOne(D(s))})}map(a){return me.map(this,a)}static filter(a,D){return new me(async R=>{for await(const s of a)D(s)&&R.emitOne(s)})}filter(a){return me.filter(this,a)}static coalesce(a){return me.filter(a,D=>!!D)}coalesce(){return me.coalesce(this)}static async toPromise(a){const D=[];for await(const R of a)D.push(R);return D}toPromise(){return me.toPromise(this)}h(a){this.a===0&&(this.b.push(a),this.g.fire())}j(a){this.a===0&&(this.b=this.b.concat(a),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(a){this.a===0&&(this.a=2,this.d=a,this.g.fire())}}t.$1h=me;class J extends me{constructor(a,D){super(D),this.m=a}cancel(){this.m.cancel()}}t.$2h=J;function O(y){const a=new i.$se,D=y(a.token);return new J(a,async R=>{const s=a.token.onCancellationRequested(()=>{s.dispose(),a.dispose(),R.reject(new C.$5)});try{for await(const k of D){if(a.token.isCancellationRequested)return;R.emitOne(k)}s.dispose(),a.dispose()}catch(k){s.dispose(),a.dispose(),R.reject(k)}})}class u{constructor(a){this.a=new Z,this.b=new me(s=>{if(D){s.reject(D);return}return R&&s.emitMany(R),this.d=k=>s.reject(k),this.f=k=>s.emitOne(k),this.a.p},a);let D,R;this.f=s=>{R||(R=[]),R.push(s)},this.d=s=>{D||(D=s)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(a){this.d(a),this.a.complete()}emitOne(a){this.f(a)}}t.$4h=u}),define(we[4],ve([1,0,17,125,15,20,11,6,3,129,2,36,5,16,59,22]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l,e,n){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.$MS=t.$KS=t.$HS=t.DetectedFullscreenMode=t.Namespace=t.$fS=t.$dS=t.$7R=t.$CR=t.$wR=t.$uR=t.$tR=t.$sR=t.$nR=t.$mR=t.$lR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$jR=f,t.$kR=v,t.$oR=F,t.$pR=I,t.$qR=H,t.$rR=w,t.$vR=W,t.$xR=M,t.$yR=Q,t.$zR=ee,t.$AR=de,t.$BR=ye,t.$DR=le,t.$ER=_,t.$FR=fe,t.$GR=he,t.$HR=Fe,t.$IR=Z,t.$JR=pe,t.$KR=Se,t.$LR=Re,t.$MR=re,t.$NR=J,t.$OR=O,t.$PR=y,t.$QR=D,t.$RR=R,t.$SR=s,t.$TR=k,t.$UR=T,t.$VR=L,t.$WR=z,t.$XR=Y,t.$YR=q,t.$ZR=te,t.$1R=ce,t.$2R=oe,t.$3R=ke,t.$4R=Me,t.$5R=Ne,t.$6R=Ue,t.$8R=_e,t.$9R=et,t.$0R=$e,t.$$R=De,t.$_R=ze,t.$aS=Qe,t.$bS=rt,t.$cS=nt,t.$eS=ot,t.$gS=Xe,t.$hS=ht,t.$iS=bt,t.$jS=$t,t.$kS=Tt,t.$lS=Be,t.$mS=ge,t.$=it,t.$oS=ut,t.$pS=Ze,t.$qS=ft,t.$rS=wt,t.$sS=Xt,t.$tS=Si,t.$uS=ki,t.$vS=Ai,t.$wS=Ti,t.$xS=Fi,t.$yS=Ci,t.$zS=Ni,t.$AS=Ri,t.$BS=Ii,t.$CS=Jt,t.$DS=Li,t.$ES=ji,t.$FS=Mi,t.$GS=_t,t.$IS=Bi,t.$JS=zi,t.$LS=Ui,t.h=Vi,t.$OS=ti,t.$PS=Ki,o=function(){const V=new Map;(0,n.$PQ)(n.$QQ,1);const K={window:n.$QQ,disposables:new $.$Tc};V.set(n.$QQ.vscodeWindowId,K);const ne=new d.$he,be=new d.$he,Ce=new d.$he;function xe(Pe,Ve){return(typeof Pe=="number"?V.get(Pe):void 0)??(Ve?K:void 0)}return{onDidRegisterWindow:ne.event,onWillUnregisterWindow:Ce.event,onDidUnregisterWindow:be.event,registerWindow(Pe){if(V.has(Pe.vscodeWindowId))return $.$Uc.None;const Ve=new $.$Tc,qe={window:Pe,disposables:Ve.add(new $.$Tc)};return V.set(Pe.vscodeWindowId,qe),Ve.add((0,$.$Sc)(()=>{V.delete(Pe.vscodeWindowId),be.fire(Pe)})),Ve.add(v(Pe,t.$dS.BEFORE_UNLOAD,()=>{Ce.fire(Pe)})),ne.fire(qe),Ve},getWindows(){return V.values()},getWindowsCount(){return V.size},getWindowId(Pe){return Pe.vscodeWindowId},hasWindow(Pe){return V.has(Pe)},getWindowById:xe,getWindow(Pe){const Ve=Pe;if(Ve?.ownerDocument?.defaultView)return Ve.ownerDocument.defaultView.window;const qe=Pe;return qe?.view?qe.view.window:n.$QQ},getDocument(Pe){const Ve=Pe;return(0,t.getWindow)(Ve).document}}}(),t.registerWindow=o.registerWindow,t.getWindow=o.getWindow,t.getDocument=o.getDocument,t.getWindows=o.getWindows,t.getWindowsCount=o.getWindowsCount,t.getWindowId=o.getWindowId,t.getWindowById=o.getWindowById,t.hasWindow=o.hasWindow,t.onDidRegisterWindow=o.onDidRegisterWindow,t.onWillUnregisterWindow=o.onWillUnregisterWindow,t.onDidUnregisterWindow=o.onDidUnregisterWindow;function f(V){for(;V.firstChild;)V.firstChild.remove()}class h{constructor(K,ne,be,Ce){this.f=K,this.g=ne,this.d=be,this.j=Ce||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function v(V,K,ne,be){return new h(V,K,ne,be)}function m(V,K){return function(ne){return K(new U.$cR(V,ne))}}function b(V){return function(K){return V(new B.$hR(K))}}const r=function(K,ne,be,Ce){let xe=be;return ne==="click"||ne==="mousedown"||ne==="contextmenu"?xe=m((0,t.getWindow)(K),be):(ne==="keydown"||ne==="keypress"||ne==="keyup")&&(xe=b(be)),v(K,ne,xe,Ce)};t.$lR=r;const p=function(K,ne,be){const Ce=m((0,t.getWindow)(K),ne);return F(K,Ce,be)};t.$mR=p;const S=function(K,ne,be){const Ce=m((0,t.getWindow)(K),ne);return H(K,Ce,be)};t.$nR=S;function F(V,K,ne){return v(V,c.$r&&C.$_Q.pointerEvents?t.$dS.POINTER_DOWN:t.$dS.MOUSE_DOWN,K,ne)}function I(V,K,ne){return v(V,c.$r&&C.$_Q.pointerEvents?t.$dS.POINTER_MOVE:t.$dS.MOUSE_MOVE,K,ne)}function H(V,K,ne){return v(V,c.$r&&C.$_Q.pointerEvents?t.$dS.POINTER_UP:t.$dS.MOUSE_UP,K,ne)}function w(V,K,ne){return(0,E.$Rh)(V,K,ne)}class j extends E.$Sh{constructor(K,ne){super(K,ne)}}t.$sR=j;function W(V,K,ne,be){let Ce=0;const xe=V.setInterval(()=>{Ce++,(typeof be=="number"&&Ce>=be||K()===!0)&&Pe.dispose()},ne),Pe=(0,$.$Sc)(()=>{V.clearInterval(xe)});return Pe}class N extends E.$Lh{constructor(K){super(),this.f=K&&(0,t.getWindow)(K)}cancelAndSet(K,ne,be){return super.cancelAndSet(K,ne,be??this.f)}}t.$wR=N;class x{constructor(K,ne=0){this.d=K,this.priority=ne,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(K){(0,A.$1)(K)}}static sort(K,ne){return ne.priority-K.priority}}(function(){const V=new Map,K=new Map,ne=new Map,be=new Map,Ce=xe=>{ne.set(xe,!1);const Pe=V.get(xe)??[];for(K.set(xe,Pe),V.set(xe,[]),be.set(xe,!0);Pe.length>0;)Pe.sort(x.sort),Pe.shift().execute();be.set(xe,!1)};t.$uR=(xe,Pe,Ve=0)=>{const qe=(0,t.getWindowId)(xe),Ge=new x(Pe,Ve);let lt=V.get(qe);return lt||(lt=[],V.set(qe,lt)),lt.push(Ge),ne.get(qe)||(ne.set(qe,!0),xe.requestAnimationFrame(()=>Ce(qe))),Ge},t.$tR=(xe,Pe,Ve)=>{const qe=(0,t.getWindowId)(xe);if(be.get(qe)){const Ge=new x(Pe,Ve);let lt=K.get(qe);return lt||(lt=[],K.set(qe,lt)),lt.push(Ge),Ge}else return(0,t.$uR)(xe,Pe,Ve)}})();function M(V,K){return(0,t.$uR)(V,K,1e4)}function Q(V,K){return(0,t.$uR)(V,K,-1e4)}const ie=8,ue=function(V,K){return K};class G extends $.$Uc{constructor(K,ne,be,Ce=ue,xe=ie){super();let Pe=null,Ve=0;const qe=this.B(new E.$Kh),Ge=()=>{Ve=new Date().getTime(),be(Pe),Pe=null};this.B(v(K,ne,lt=>{Pe=Ce(Pe,lt);const Ct=new Date().getTime()-Ve;Ct>=xe?(qe.cancel(),Ge()):qe.setIfNotSet(Ge,xe-Ct)}))}}function ee(V,K,ne,be,Ce){return new G(V,K,ne,be,Ce)}function de(V){return(0,t.getWindow)(V).getComputedStyle(V,null)}function ye(V,K){const ne=(0,t.getWindow)(V),be=ne.document;if(V!==be.body)return new je(V.clientWidth,V.clientHeight);if(c.$r&&ne?.visualViewport)return new je(ne.visualViewport.width,ne.visualViewport.height);if(ne?.innerWidth&&ne.innerHeight)return new je(ne.innerWidth,ne.innerHeight);if(be.body&&be.body.clientWidth&&be.body.clientHeight)return new je(be.body.clientWidth,be.body.clientHeight);if(be.documentElement&&be.documentElement.clientWidth&&be.documentElement.clientHeight)return new je(be.documentElement.clientWidth,be.documentElement.clientHeight);if(K)return ye(K);throw new Error("Unable to figure out browser width and height")}class Ae{static d(K,ne){return parseFloat(ne)||0}static f(K,ne,be){const Ce=de(K),xe=Ce?Ce.getPropertyValue(ne):"0";return Ae.d(K,xe)}static getBorderLeftWidth(K){return Ae.f(K,"border-left-width","borderLeftWidth")}static getBorderRightWidth(K){return Ae.f(K,"border-right-width","borderRightWidth")}static getBorderTopWidth(K){return Ae.f(K,"border-top-width","borderTopWidth")}static getBorderBottomWidth(K){return Ae.f(K,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(K){return Ae.f(K,"padding-left","paddingLeft")}static getPaddingRight(K){return Ae.f(K,"padding-right","paddingRight")}static getPaddingTop(K){return Ae.f(K,"padding-top","paddingTop")}static getPaddingBottom(K){return Ae.f(K,"padding-bottom","paddingBottom")}static getMarginLeft(K){return Ae.f(K,"margin-left","marginLeft")}static getMarginTop(K){return Ae.f(K,"margin-top","marginTop")}static getMarginRight(K){return Ae.f(K,"margin-right","marginRight")}static getMarginBottom(K){return Ae.f(K,"margin-bottom","marginBottom")}}class je{static{this.None=new je(0,0)}constructor(K,ne){this.width=K,this.height=ne}with(K=this.width,ne=this.height){return K!==this.width||ne!==this.height?new je(K,ne):this}static is(K){return typeof K=="object"&&typeof K.height=="number"&&typeof K.width=="number"}static lift(K){return K instanceof je?K:new je(K.width,K.height)}static equals(K,ne){return K===ne?!0:!K||!ne?!1:K.width===ne.width&&K.height===ne.height}}t.$CR=je;function le(V){let K=V.offsetParent,ne=V.offsetTop,be=V.offsetLeft;for(;(V=V.parentNode)!==null&&V!==V.ownerDocument.body&&V!==V.ownerDocument.documentElement;){ne-=V.scrollTop;const Ce=k(V)?null:de(V);Ce&&(be-=Ce.direction!=="rtl"?V.scrollLeft:-V.scrollLeft),V===K&&(be+=Ae.getBorderLeftWidth(V),ne+=Ae.getBorderTopWidth(V),ne+=V.offsetTop,be+=V.offsetLeft,K=V.offsetParent)}return{left:be,top:ne}}function _(V,K,ne){typeof K=="number"&&(V.style.width=`${K}px`),typeof ne=="number"&&(V.style.height=`${ne}px`)}function fe(V,K,ne,be,Ce,xe="absolute"){typeof K=="number"&&(V.style.top=`${K}px`),typeof ne=="number"&&(V.style.right=`${ne}px`),typeof be=="number"&&(V.style.bottom=`${be}px`),typeof Ce=="number"&&(V.style.left=`${Ce}px`),V.style.position=xe}function he(V){const K=V.getBoundingClientRect(),ne=(0,t.getWindow)(V);return{left:K.left+ne.scrollX,top:K.top+ne.scrollY,width:K.width,height:K.height}}function Fe(V){let K=V,ne=1;do{const be=de(K).zoom;be!=null&&be!=="1"&&(ne*=be),K=K.parentElement}while(K!==null&&K!==K.ownerDocument.documentElement);return ne}function Z(V){const K=Ae.getMarginLeft(V)+Ae.getMarginRight(V);return V.offsetWidth+K}function pe(V){const K=Ae.getBorderLeftWidth(V)+Ae.getBorderRightWidth(V),ne=Ae.getPaddingLeft(V)+Ae.getPaddingRight(V);return V.offsetWidth-K-ne}function Se(V){const K=Ae.getMarginLeft(V)+Ae.getMarginRight(V);return V.scrollWidth+K}function Re(V){const K=Ae.getBorderTopWidth(V)+Ae.getBorderBottomWidth(V),ne=Ae.getPaddingTop(V)+Ae.getPaddingBottom(V);return V.offsetHeight-K-ne}function re(V){const K=Ae.getMarginTop(V)+Ae.getMarginBottom(V);return V.offsetHeight+K}function me(V,K){if(V===null)return 0;const ne=le(V),be=le(K);return ne.left-be.left}function J(V,K){const ne=K.map(Ce=>Math.max(Se(Ce),Z(Ce))+me(Ce,V)||0);return Math.max(...ne)}function O(V,K){return!!K?.contains(V)}const u="parentFlowToElementId";function y(V,K){V.dataset[u]=K.id}function a(V){const K=V.dataset[u];return typeof K=="string"?V.ownerDocument.getElementById(K):null}function D(V,K){let ne=V;for(;ne;){if(ne===K)return!0;if(ne instanceof HTMLElement){const be=a(ne);if(be){ne=be;continue}}ne=ne.parentNode}return!1}function R(V,K,ne){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V.classList.contains(K))return V;if(ne){if(typeof ne=="string"){if(V.classList.contains(ne))return null}else if(V===ne)return null}V=V.parentNode}return null}function s(V,K,ne){return!!R(V,K,ne)}function k(V){return V&&!!V.host&&!!V.mode}function T(V){return!!L(V)}function L(V){for(;V.parentNode;){if(V===V.ownerDocument?.body)return null;V=V.parentNode}return k(V)?V:null}function z(){let V=ce().activeElement;for(;V?.shadowRoot;)V=V.shadowRoot.activeElement;return V}function Y(V){return z()===V}function q(V){return O(z(),V)}function te(V){return V.ownerDocument===ce()}function ce(){return(0,t.getWindowsCount)()<=1?n.$QQ.document:Array.from((0,t.getWindows)()).map(({window:K})=>K.document).find(K=>K.hasFocus())??n.$QQ.document}function oe(){return ce().defaultView?.window??n.$QQ}const Te=new Map;function ke(V){return Te.has(V)}function Me(){return new Ee}class Ee{constructor(){this.d="",this.f=void 0}setStyle(K){K!==this.d&&(this.d=K,this.f?this.f.innerText=K:this.f=Ne(n.$QQ.document.head,ne=>ne.innerText=K))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ne(V=n.$QQ.document.head,K,ne){const be=document.createElement("style");if(be.type="text/css",be.media="screen",K?.(be),V.appendChild(be),ne&&ne.add((0,$.$Sc)(()=>V.removeChild(be))),V===n.$QQ.document.head){const Ce=new Set;Te.set(be,Ce);for(const{window:xe,disposables:Pe}of(0,t.getWindows)()){if(xe===n.$QQ)continue;const Ve=Pe.add(Ye(be,Ce,xe));ne?.add(Ve)}}return be}function Ue(V){const K=new $.$Tc;for(const[ne,be]of Te)K.add(Ye(ne,be,V));return K}function Ye(V,K,ne){const be=new $.$Tc,Ce=V.cloneNode(!0);ne.document.head.appendChild(Ce),be.add((0,$.$Sc)(()=>ne.document.head.removeChild(Ce)));for(const xe of ae(V))Ce.sheet?.insertRule(xe.cssText,Ce.sheet?.cssRules.length);return be.add(t.$7R.observe(V,be,{childList:!0})(()=>{Ce.textContent=V.textContent})),K.add(Ce),be.add((0,$.$Sc)(()=>K.delete(Ce))),be}t.$7R=new class{constructor(){this.mutationObservers=new Map}observe(V,K,ne){let be=this.mutationObservers.get(V);be||(be=new Map,this.mutationObservers.set(V,be));const Ce=(0,e.$oj)(ne);let xe=be.get(Ce);if(xe)xe.users+=1;else{const Pe=new d.$he,Ve=new MutationObserver(Ge=>Pe.fire(Ge));Ve.observe(V,ne);const qe=xe={users:1,observer:Ve,onDidMutate:Pe.event};K.add((0,$.$Sc)(()=>{qe.users-=1,qe.users===0&&(Pe.dispose(),Ve.disconnect(),be?.delete(Ce),be?.size===0&&this.mutationObservers.delete(V))})),be.set(Ce,xe)}return xe.onDidMutate}};function _e(V=n.$QQ.document.head){return tt("meta",V)}function et(V=n.$QQ.document.head){return tt("link",V)}function tt(V,K=n.$QQ.document.head){const ne=document.createElement(V);return K.appendChild(ne),ne}let We=null;function X(){return We||(We=Ne()),We}function ae(V){return V?.sheet?.rules?V.sheet.rules:V?.sheet?.cssRules?V.sheet.cssRules:[]}function $e(V,K,ne=X()){if(!(!ne||!K)){ne.sheet?.insertRule(`${V} {${K}}`,0);for(const be of Te.get(ne)??[])$e(V,K,be)}}function De(V,K=X()){if(!K)return;const ne=ae(K),be=[];for(let Ce=0;Ce<ne.length;Ce++){const xe=ne[Ce];Le(xe)&&xe.selectorText.indexOf(V)!==-1&&be.push(Ce)}for(let Ce=be.length-1;Ce>=0;Ce--)K.sheet?.deleteRule(be[Ce]);for(const Ce of Te.get(K)??[])De(V,Ce)}function Le(V){return typeof V.selectorText=="string"}function ze(V){return V instanceof MouseEvent||V instanceof(0,t.getWindow)(V).MouseEvent}function Qe(V){return V instanceof KeyboardEvent||V instanceof(0,t.getWindow)(V).KeyboardEvent}function rt(V){return V instanceof PointerEvent||V instanceof(0,t.getWindow)(V).PointerEvent}function nt(V){return V instanceof DragEvent||V instanceof(0,t.getWindow)(V).DragEvent}t.$dS={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$4Q?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$4Q?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$4Q?"webkitAnimationIteration":"animationiteration"};function ot(V){const K=V;return!!(K&&typeof K.preventDefault=="function"&&typeof K.stopPropagation=="function")}t.$fS={stop:(V,K)=>(V.preventDefault(),K&&V.stopPropagation(),V)};function Xe(V){const K=[];for(let ne=0;V&&V.nodeType===V.ELEMENT_NODE;ne++)K[ne]=V.scrollTop,V=V.parentNode;return K}function ht(V,K){for(let ne=0;V&&V.nodeType===V.ELEMENT_NODE;ne++)V.scrollTop!==K[ne]&&(V.scrollTop=K[ne]),V=V.parentNode}class st extends $.$Uc{static m(K){if(K instanceof HTMLElement){const ne=L(K),be=ne?ne.activeElement:K.ownerDocument.activeElement;return O(be,K)}else{const ne=K;return O(ne.document.activeElement,ne.document)}}constructor(K){super(),this.f=this.B(new d.$he),this.onDidFocus=this.f.event,this.g=this.B(new d.$he),this.onDidBlur=this.g.event;let ne=st.m(K),be=!1;const Ce=()=>{be=!1,ne||(ne=!0,this.f.fire())},xe=()=>{ne&&(be=!0,(K instanceof HTMLElement?(0,t.getWindow)(K):K).setTimeout(()=>{be&&(be=!1,ne=!1,this.g.fire())},0))};this.j=()=>{st.m(K)!==ne&&(ne?xe():Ce())},this.B(v(K,t.$dS.FOCUS,Ce,!0)),this.B(v(K,t.$dS.BLUR,xe,!0)),K instanceof HTMLElement&&(this.B(v(K,t.$dS.FOCUS_IN,()=>this.j())),this.B(v(K,t.$dS.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function bt(V){return new st(V)}function $t(V,K){return V.after(K),K}function Tt(V,...K){if(V.append(...K),K.length===1&&typeof K[0]!="string")return K[0]}function Be(V,K){return V.insertBefore(K,V.firstChild),K}function ge(V,...K){V.innerText="",Tt(V,...K)}const Ie=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Oe;(function(V){V.HTML="http://www.w3.org/1999/xhtml",V.SVG="http://www.w3.org/2000/svg"})(Oe||(t.Namespace=Oe={}));function Ke(V,K,ne,...be){const Ce=Ie.exec(K);if(!Ce)throw new Error("Bad use of emmet");const xe=Ce[1]||"div";let Pe;return V!==Oe.HTML?Pe=document.createElementNS(V,xe):Pe=document.createElement(xe),Ce[3]&&(Pe.id=Ce[3]),Ce[4]&&(Pe.className=Ce[4].replace(/\./g," ").trim()),ne&&Object.entries(ne).forEach(([Ve,qe])=>{typeof qe>"u"||(/^on\w+$/.test(Ve)?Pe[Ve]=qe:Ve==="selected"?qe&&Pe.setAttribute(Ve,"true"):Pe.setAttribute(Ve,qe))}),Pe.append(...be),Pe}function it(V,K,...ne){return Ke(Oe.HTML,V,K,...ne)}it.SVG=function(V,K,...ne){return Ke(Oe.SVG,V,K,...ne)};function ut(V,K){const ne=[];return V.forEach((be,Ce)=>{Ce>0&&(K instanceof Node?ne.push(K.cloneNode()):ne.push(document.createTextNode(K))),ne.push(be)}),ne}function Ze(V,...K){V?ft(...K):wt(...K)}function ft(...V){for(const K of V)K.style.display="",K.removeAttribute("aria-hidden")}function wt(...V){for(const K of V)K.style.display="none",K.setAttribute("aria-hidden","true")}function Ft(V,K){for(;V&&V.nodeType===V.ELEMENT_NODE;){if(V instanceof HTMLElement&&V.hasAttribute(K))return V;V=V.parentNode}return null}function Xt(V){!V||!V.hasAttribute("tabIndex")||(V.ownerDocument.activeElement===V&&Ft(V.parentElement,"tabIndex")?.focus(),V.removeAttribute("tabindex"))}function Si(V){return K=>{K.preventDefault(),K.stopPropagation(),V(K)}}function ki(V){return new Promise(K=>{if(V.document.readyState==="complete"||V.document&&V.document.body!==null)K(void 0);else{const be=()=>{V.window.removeEventListener("DOMContentLoaded",be,!1),K()};V.window.addEventListener("DOMContentLoaded",be,!1)}})}function Ai(V,K){const ne=V.devicePixelRatio*K;return Math.max(1,Math.floor(ne))/V.devicePixelRatio}function Ti(V){n.$QQ.open(V,"_blank","noopener")}const Yt=780,Zt=640;function Fi(V){const K=Math.floor(n.$QQ.screenLeft+n.$QQ.innerWidth/2-Yt/2),ne=Math.floor(n.$QQ.screenTop+n.$QQ.innerHeight/2-Zt/2);n.$QQ.open(V,"_blank",`width=${Yt},height=${Zt},top=${ne},left=${K}`)}function Ci(V,K=!0){const ne=n.$QQ.open();return ne?(K&&(ne.opener=null),ne.location.href=V,!0):!1}function Ni(V,K){const ne=()=>{K(),be=(0,t.$uR)(V,ne)};let be=(0,t.$uR)(V,ne);return(0,$.$Sc)(()=>be.dispose())}P.$Ng.setPreferredWebSchema(/^https:/.test(n.$QQ.location.href)?"https":"http");function Ri(V){return V?`url('${P.$Ug.uriToBrowserUri(V).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ii(V){return`'${V.replace(/'/g,"%27")}'`}function Jt(V,K){if(V!==void 0){const ne=V.match(/^\s*var\((.+)\)$/);if(ne){const be=ne[1].split(",",2);return be.length===2&&(K=Jt(be[1].trim(),K)),`var(${be[0]}, ${K})`}return V}return K}function Li(V,K){let ne;if(l.URI.isUri(V))ne=V.toString(!0);else{const xe=new Blob([V]);ne=URL.createObjectURL(xe),setTimeout(()=>URL.revokeObjectURL(ne))}const be=oe(),Ce=document.createElement("a");be.document.body.appendChild(Ce),Ce.download=K,Ce.href=ne,Ce.click(),setTimeout(()=>be.document.body.removeChild(Ce))}function ji(){return new Promise(V=>{const K=oe(),ne=document.createElement("input");K.document.body.appendChild(ne),ne.type="file",ne.multiple=!0,d.Event.once(d.Event.fromDOMEventEmitter(ne,"input"))(()=>{V(ne.files??void 0)}),ne.click(),setTimeout(()=>K.document.body.removeChild(ne))})}var Et;(function(V){V[V.DOCUMENT=1]="DOCUMENT",V[V.BROWSER=2]="BROWSER"})(Et||(t.DetectedFullscreenMode=Et={}));function Mi(V){return V.document.fullscreenElement||V.document.webkitFullscreenElement||V.document.webkitIsFullScreen?{mode:Et.DOCUMENT,guess:!1}:V.innerHeight===V.screen.height?{mode:Et.BROWSER,guess:!1}:(c.$j||c.$k)&&V.outerHeight===V.screen.height&&V.outerWidth===V.screen.width?{mode:Et.BROWSER,guess:!0}:null}function _t(V,K=!1){const ne=document.createElement("a");return g.addHook("afterSanitizeAttributes",be=>{for(const Ce of["href","src"])if(be.hasAttribute(Ce)){const xe=be.getAttribute(Ce);if(Ce==="href"&&xe.startsWith("#"))continue;if(ne.href=xe,!V.includes(ne.protocol.replace(/:$/,""))){if(K&&Ce==="src"&&ne.href.startsWith("data:"))continue;be.removeAttribute(Ce)}}}),(0,$.$Sc)(()=>{g.removeHook("afterSanitizeAttributes")})}const Oi=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.$HS=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Pi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(V,K){const ne=_t(Oi);try{const be=g.sanitize(K,Pi);V.innerHTML=be}finally{ne.dispose()}}function xi(V){const K=new Uint16Array(V.length);for(let Ce=0;Ce<K.length;Ce++)K[Ce]=V.charCodeAt(Ce);let ne="";const be=new Uint8Array(K.buffer);for(let Ce=0;Ce<be.length;Ce++)ne+=String.fromCharCode(be[Ce]);return ne}function zi(V){return btoa(xi(V))}class vt extends d.$he{constructor(){super(),this.o=new $.$Tc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(d.Event.runAndSubscribe(t.onDidRegisterWindow,({window:K,disposables:ne})=>this.C(K,ne),{window:n.$QQ,disposables:this.o}))}C(K,ne){ne.add(v(K,"keydown",be=>{if(be.defaultPrevented)return;const Ce=new B.$hR(be);if(!(Ce.keyCode===6&&be.repeat)){if(be.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(be.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(be.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(be.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Ce.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=be.altKey,this.A.ctrlKey=be.ctrlKey,this.A.metaKey=be.metaKey,this.A.shiftKey=be.shiftKey,this.A.lastKeyPressed&&(this.A.event=be,this.fire(this.A))}},!0)),ne.add(v(K,"keyup",be=>{be.defaultPrevented||(!be.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!be.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!be.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!be.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=be.altKey,this.A.ctrlKey=be.ctrlKey,this.A.metaKey=be.metaKey,this.A.shiftKey=be.shiftKey,this.A.lastKeyReleased&&(this.A.event=be,this.fire(this.A)))},!0)),ne.add(v(K.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ne.add(v(K.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ne.add(v(K.document.body,"mousemove",be=>{be.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ne.add(v(K,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return vt.B||(vt.B=new vt),vt.B}dispose(){super.dispose(),this.o.dispose()}}t.$KS=vt;function Ui(V){const K=document.cookie.match("(^|[^;]+)\\s*"+V+"\\s*=\\s*([^;]+)");return K?K.pop():void 0}class Hi extends $.$Uc{constructor(K,ne){super(),this.j=K,this.m=ne,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(v(this.j,t.$dS.DRAG_START,K=>{this.m.onDragStart?.(K)})),this.m.onDrag&&this.B(v(this.j,t.$dS.DRAG,K=>{this.m.onDrag?.(K)})),this.B(v(this.j,t.$dS.DRAG_ENTER,K=>{this.f++,this.g=K.timeStamp,this.m.onDragEnter?.(K)})),this.B(v(this.j,t.$dS.DRAG_OVER,K=>{K.preventDefault(),this.m.onDragOver?.(K,K.timeStamp-this.g)})),this.B(v(this.j,t.$dS.DRAG_LEAVE,K=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(K))})),this.B(v(this.j,t.$dS.DRAG_END,K=>{this.f=0,this.g=0,this.m.onDragEnd?.(K)})),this.B(v(this.j,t.$dS.DROP,K=>{this.f=0,this.g=0,this.m.onDrop?.(K)}))}}t.$MS=Hi;const Wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Vi(V,...K){let ne,be;Array.isArray(K[0])?(ne={},be=K[0]):(ne=K[0]||{},be=K[1]);const Ce=Wi.exec(V);if(!Ce||!Ce.groups)throw new Error("Bad use of h");const xe=Ce.groups.tag||"div",Pe=document.createElement(xe);Ce.groups.id&&(Pe.id=Ce.groups.id);const Ve=[];if(Ce.groups.class)for(const Ge of Ce.groups.class.split("."))Ge!==""&&Ve.push(Ge);if(ne.className!==void 0)for(const Ge of ne.className.split("."))Ge!==""&&Ve.push(Ge);Ve.length>0&&(Pe.className=Ve.join(" "));const qe={};if(Ce.groups.name&&(qe[Ce.groups.name]=Pe),be)for(const Ge of be)Ge instanceof HTMLElement?Pe.appendChild(Ge):typeof Ge=="string"?Pe.append(Ge):"root"in Ge&&(Object.assign(qe,Ge),Pe.appendChild(Ge.root));for(const[Ge,lt]of Object.entries(ne))if(Ge!=="className")if(Ge==="style")for(const[Ct,Pt]of Object.entries(lt))Pe.style.setProperty(ei(Ct),typeof Pt=="number"?Pt+"px":""+Pt);else Ge==="tabIndex"?Pe.tabIndex=lt:Pe.setAttribute(ei(Ge),lt.toString());return qe.root=Pe,qe}function ei(V){return V.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(V,K,ne){for(const{name:be,value:Ce}of V.attributes)(!ne||ne.includes(be))&&K.setAttribute(be,Ce)}function qi(V,K,ne){const be=V.getAttribute(ne);be?K.setAttribute(ne,be):K.removeAttribute(ne)}function Ki(V,K,ne){ti(V,K,ne);const be=new $.$Tc;return be.add(t.$7R.observe(V,be,{attributes:!0,attributeFilter:ne})(Ce=>{for(const xe of Ce)xe.type==="attributes"&&xe.attributeName&&qi(V,K,xe.attributeName)})),be}}),define(we[65],ve([1,0,4,2,128]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RS=t.$QS=void 0,t.$SS=E;class U extends C.$Uc{constructor(d,g){super(),this.B((0,i.$kR)(d,"dragover",$=>{$.preventDefault(),this.a||(this.a=setTimeout(()=>{g(),this.a=null},800))})),["dragleave","drop","dragend"].forEach($=>{this.B((0,i.$kR)(d,$,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$QS=U,t.$RS={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:B.$Ws.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function E(A,d,g,$,P){const c=document.createElement("div");if(c.className=g,c.textContent=d,P&&(c.style.color=P),$&&(c.style.background=$),A.dataTransfer){const l=(0,i.getWindow)(A).document;l.body.appendChild(c),A.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>l.body.removeChild(c),0)}}}),define(we[66],ve([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=C,t.$mT=B,t.$nT=U;function C(c,l={}){const e=U(l);return e.textContent=c,e}function B(c,l={}){const e=U(l);return d(e,g(c,!!l.renderCodeSegments),l.actionHandler,l.renderCodeSegments),e}function U(c){const l=c.inline?"span":"div",e=document.createElement(l);return c.className&&(e.className=c.className),e}class E{constructor(l){this.b=l,this.c=0}eos(){return this.c>=this.b.length}next(){const l=this.peek();return this.advance(),l}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(A||(A={}));function d(c,l,e,n){let o;if(l.type===2)o=document.createTextNode(l.content||"");else if(l.type===3)o=document.createElement("b");else if(l.type===4)o=document.createElement("i");else if(l.type===7&&n)o=document.createElement("code");else if(l.type===5&&e){const f=document.createElement("a");e.disposables.add(i.$lR(f,"click",h=>{e.callback(String(l.index),h)})),o=f}else l.type===8?o=document.createElement("br"):l.type===1&&(o=c);o&&c!==o&&c.appendChild(o),o&&Array.isArray(l.children)&&l.children.forEach(f=>{d(o,f,e,n)})}function g(c,l){const e={type:1,children:[]};let n=0,o=e;const f=[],h=new E(c);for(;!h.eos();){let v=h.next();const m=v==="\\"&&P(h.peek(),l)!==0;if(m&&(v=h.next()),!m&&$(v,l)&&v===h.peek()){h.advance(),o.type===2&&(o=f.pop());const b=P(v,l);if(o.type===b||o.type===5&&b===6)o=f.pop();else{const r={type:b,children:[]};b===5&&(r.index=n,n++),o.children.push(r),f.push(o),o=r}}else if(v===`
`)o.type===2&&(o=f.pop()),o.children.push({type:8});else if(o.type!==2){const b={type:2,content:v};o.children.push(b),f.push(o),o=b}else o.content+=v}return o.type===2&&(o=f.pop()),f.length,e}function $(c,l){return P(c,l)!==0}function P(c,l){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return l?7:0;default:return 0}}}),define(we[67],ve([1,0,4,2]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WS=void 0;class B{constructor(){this.a=new C.$Tc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(E,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const d=this.c;this.c=null,E&&d&&d(A)}isMonitoring(){return!!this.b}startMonitoring(E,A,d,g,$){this.isMonitoring()&&this.stopMonitoring(!1),this.b=g,this.c=$;let P=E;try{E.setPointerCapture(A),this.a.add((0,C.$Sc)(()=>{try{E.releasePointerCapture(A)}catch{}}))}catch{P=i.getWindow(E)}this.a.add(i.$kR(P,i.$dS.POINTER_MOVE,c=>{if(c.buttons!==d){this.stopMonitoring(!0);return}c.preventDefault(),this.b(c)})),this.a.add(i.$kR(P,i.$dS.POINTER_UP,c=>this.stopMonitoring(!0)))}}t.$WS=B});var Je=this&&this.__decorate||function(se,t,i,C){var B=arguments.length,U=B<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,i):C,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(se,t,i,C);else for(var A=se.length-1;A>=0;A--)(E=se[A])&&(U=(B<3?E(U):B>3?E(t,i,U):E(t,i))||U);return B>3&&U&&Object.defineProperty(t,i,U),U};define(we[28],ve([1,0,4,22,8,31,3,2,55]),function(se,t,i,C,B,U,E,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TS=t.EventType=void 0;var g;(function(P){P.Tap="-monaco-gesturetap",P.Change="-monaco-gesturechange",P.Start="-monaco-gesturestart",P.End="-monaco-gesturesend",P.Contextmenu="-monaco-gesturecontextmenu"})(g||(t.EventType=g={}));class $ extends A.$Uc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new d.$5c,this.m=new d.$5c,this.r={},this.n=null,this.s=0,this.B(E.Event.runAndSubscribe(i.onDidRegisterWindow,({window:c,disposables:l})=>{l.add(i.$kR(c.document,"touchstart",e=>this.w(e),{passive:!1})),l.add(i.$kR(c.document,"touchend",e=>this.z(c,e))),l.add(i.$kR(c.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:C.$QQ,disposables:this.q}))}static addTarget(c){if(!$.isTouchDevice())return A.$Uc.None;$.f||($.f=(0,A.$Nc)(new $));const l=$.f.j.push(c);return(0,A.$Sc)(l)}static ignoreTarget(c){if(!$.isTouchDevice())return A.$Uc.None;$.f||($.f=(0,A.$Nc)(new $));const l=$.f.m.push(c);return(0,A.$Sc)(l)}static isTouchDevice(){return"ontouchstart"in C.$QQ||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(c){const l=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,n=c.targetTouches.length;e<n;e++){const o=c.targetTouches.item(e);this.r[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:l,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[l],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const f=this.C(g.Start,o.target);f.pageX=o.pageX,f.pageY=o.pageY,this.D(f)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}z(c,l){const e=Date.now(),n=Object.keys(this.r).length;for(let o=0,f=l.changedTouches.length;o<f;o++){const h=l.changedTouches.item(o);if(!this.r.hasOwnProperty(String(h.identifier))){console.warn("move of an UNKNOWN touch",h);continue}const v=this.r[h.identifier],m=Date.now()-v.initialTimeStamp;if(m<$.g&&Math.abs(v.initialPageX-B.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-B.$sb(v.rollingPageY))<30){const b=this.C(g.Tap,v.initialTarget);b.pageX=B.$sb(v.rollingPageX),b.pageY=B.$sb(v.rollingPageY),this.D(b)}else if(m>=$.g&&Math.abs(v.initialPageX-B.$sb(v.rollingPageX))<30&&Math.abs(v.initialPageY-B.$sb(v.rollingPageY))<30){const b=this.C(g.Contextmenu,v.initialTarget);b.pageX=B.$sb(v.rollingPageX),b.pageY=B.$sb(v.rollingPageY),this.D(b)}else if(n===1){const b=B.$sb(v.rollingPageX),r=B.$sb(v.rollingPageY),p=B.$sb(v.rollingTimestamps)-v.rollingTimestamps[0],S=b-v.rollingPageX[0],F=r-v.rollingPageY[0],I=[...this.j].filter(H=>v.initialTarget instanceof Node&&H.contains(v.initialTarget));this.F(c,I,e,Math.abs(S)/p,S>0?1:-1,b,Math.abs(F)/p,F>0?1:-1,r)}this.D(this.C(g.End,v.initialTarget)),delete this.r[h.identifier]}this.h&&(l.preventDefault(),l.stopPropagation(),this.h=!1)}C(c,l){const e=document.createEvent("CustomEvent");return e.initEvent(c,!1,!0),e.initialTarget=l,e.tapCount=0,e}D(c){if(c.type===g.Tap){const l=new Date().getTime();let e=0;l-this.s>$.u?e=1:e=2,this.s=l,c.tapCount=e}else(c.type===g.Change||c.type===g.Contextmenu)&&(this.s=0);if(c.initialTarget instanceof Node){for(const e of this.m)if(e.contains(c.initialTarget))return;const l=[];for(const e of this.j)if(e.contains(c.initialTarget)){let n=0,o=c.initialTarget;for(;o&&o!==e;)n++,o=o.parentElement;l.push([n,e])}l.sort((e,n)=>e[0]-n[0]);for(const[e,n]of l)n.dispatchEvent(c),this.h=!0}}F(c,l,e,n,o,f,h,v,m){this.n=i.$uR(c,()=>{const b=Date.now(),r=b-e;let p=0,S=0,F=!0;n+=$.c*r,h+=$.c*r,n>0&&(F=!1,p=o*n*r),h>0&&(F=!1,S=v*h*r);const I=this.C(g.Change);I.translationX=p,I.translationY=S,l.forEach(H=>H.dispatchEvent(I)),F||this.F(c,l,b,n,o,f+p,h,v,m+S)})}G(c){const l=Date.now();for(let e=0,n=c.changedTouches.length;e<n;e++){const o=c.changedTouches.item(e);if(!this.r.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const f=this.r[o.identifier],h=this.C(g.Change,f.initialTarget);h.translationX=o.pageX-B.$sb(f.rollingPageX),h.translationY=o.pageY-B.$sb(f.rollingPageY),h.pageX=o.pageX,h.pageY=o.pageY,this.D(h),f.rollingPageX.length>3&&(f.rollingPageX.shift(),f.rollingPageY.shift(),f.rollingTimestamps.shift()),f.rollingPageX.push(o.pageX),f.rollingPageY.push(o.pageY),f.rollingTimestamps.push(l)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}}t.$TS=$,Je([U.$5h],$,"isTouchDevice",null)}),define(we[68],ve([1,0,4,104]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=g,t.$qT=$,t.$rT=P;const C=2e4;let B,U,E,A,d;function g(l){B=document.createElement("div"),B.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};U=e(),E=e();const n=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};A=n(),d=n(),l.appendChild(B)}function $(l){B&&(U.textContent!==l?(i.$jR(E),c(U,l)):(i.$jR(U),c(E,l)))}function P(l){B&&(A.textContent!==l?(i.$jR(d),c(A,l)):(i.$jR(A),c(d,l)))}function c(l,e){i.$jR(l),e.length>C&&(e=e.substr(0,C)),l.textContent=e,l.style.visibility="hidden",l.style.visibility="visible"}}),define(we[130],ve([1,0,4,19]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=U,t.$VT=E;const B=new RegExp(`(\\\\)?\\$\\((${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(A){const d=new Array;let g,$=0,P=0;for(;(g=B.exec(A))!==null;){P=g.index||0,$<P&&d.push(A.substring($,P)),$=(g.index||0)+g[0].length;const[,c,l]=g;d.push(c?`$(${l})`:E({id:l}))}return $<A.length&&d.push(A.substring($)),d}function E(A){const d=i.$("span");return d.classList.add(...C.ThemeIcon.asClassNameArray(A)),d}}),define(we[131],ve([1,0,4]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xT=void 0;function C(U){try{U.parentElement?.removeChild(U)}catch{}}class B{constructor(E){this.d=E,this.a=new Map,this.b=new Set,this.c=!1}alloc(E){let A=this.h(E).pop(),d=!1;if(A)d=this.b.has(A.domNode),d&&this.b.delete(A.domNode);else{const g=(0,i.$)(".monaco-list-row"),P=this.i(E).renderTemplate(g);A={domNode:g,templateId:E,templateData:P}}return{row:A,isReusingConnectedDomNode:d}}release(E){E&&this.f(E)}transact(E){if(this.c)throw new Error("Already in transaction");this.c=!0;try{E()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(E){const{domNode:A,templateId:d}=E;A&&(this.c?this.b.add(A):this.g(A)),this.h(d).push(E)}g(E){E.classList.remove("scrolling"),C(E)}h(E){let A=this.a.get(E);return A||(A=[],this.a.set(E,A)),A}dispose(){this.a.forEach((E,A)=>{for(const d of E)this.i(A).disposeTemplate(d.templateData),d.templateData=null}),this.a.clear(),this.b.clear()}i(E){const A=this.d.get(E);if(!A)throw new Error(`No renderer found for ${E}`);return A}}t.$xT=B}),define(we[132],ve([1,0,11,2]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2S=void 0;class B extends C.$Uc{constructor(E,A,d){super(),this.a=E,this.b=A,this.c=d,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Kh)}setVisibility(E){this.a!==E&&(this.a=E,this.s())}setShouldBeVisible(E){this.g=E,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const E=this.r();this.h!==E&&(this.h=E,this.ensureVisibility())}setIsNeeded(E){this.j!==E&&(this.j=E,this.ensureVisibility())}setDomNode(E){this.f=E,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(E){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(E?" fade":"")))}}t.$2S=B}),define(we[133],ve([1,0,4,28,8,3,2,5]),function(se,t,i,C,B,U,E,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5T=void 0;class d extends E.$Uc{constructor($,P,c,l){super(),this.f=0,this.b=l||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$he),this.h=c,this.j(),this.setOptions($,P)}j(){this.B(C.$TS.addTarget(this.a)),[C.EventType.Tap].forEach($=>{this.B(i.$kR(this.a,$,P=>{this.a.focus()}))}),this.B(i.$lR(this.a,"click",$=>{i.$fS.stop($,!0)})),this.B(i.$lR(this.a,"change",$=>{this.a.title=$.target.value,this.g.fire({index:$.target.selectedIndex,selected:$.target.value})})),this.B(i.$lR(this.a,"keydown",$=>{let P=!1;A.$j?($.keyCode===18||$.keyCode===16||$.keyCode===10)&&(P=!0):($.keyCode===18&&$.altKey||$.keyCode===10||$.keyCode===3)&&(P=!0),P&&$.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions($,P){(!this.c||!B.$ub(this.c,$))&&(this.c=$,this.a.options.length=0,this.c.forEach((c,l)=>{this.a.add(this.m(c.text,l,c.isDisabled))})),P!==void 0&&this.select(P)}select($){this.c.length===0?this.f=0:$>=0&&$<this.c.length?this.f=$:$>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel($){this.b.ariaLabel=$,this.a.setAttribute("aria-label",$)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable($){this.a.tabIndex=$?0:-1}render($){$.classList.add("select-container"),$.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style($){this.h=$,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m($,P,c){const l=document.createElement("option");return l.value=$,l.text=$,l.disabled=!!c,l}}t.$5T=d}),define(we[69],ve([1,0,30,8,11,60,98,3,32]),function(se,t,i,C,B,U,E,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EV=void 0,t.$CV=g,t.$DV=$;function g(l){return typeof l=="object"&&"visibility"in l&&"data"in l}function $(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}function P(l){return typeof l.collapsible=="boolean"}class c{constructor(e,n,o,f={}){this.p=e,this.q=n,this.rootRef=[],this.d=new A.$pe,this.f=new A.$he,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.$he,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new A.$he,this.onDidSplice=this.m.event,this.o=new B.$xh(U.$ce),this.h=typeof f.collapseByDefault>"u"?!1:f.collapseByDefault,this.j=f.allowNonCollapsibleParents??!1,this.k=f.filter,this.l=typeof f.autoExpandSingleChildren>"u"?!1:f.autoExpandSingleChildren,this.c={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,n,o=d.Iterable.empty(),f={}){if(e.length===0)throw new i.$AV(this.p,"Invalid tree location");f.diffIdentityProvider?this.s(f.diffIdentityProvider,e,n,o,f):this.t(e,n,o,f)}s(e,n,o,f=d.Iterable.empty(),h,v=h.diffDepth??0){const{parentNode:m}=this.H(n);if(!m.lastDiffIds)return this.t(n,o,f,h);const b=[...f],r=n[n.length-1],p=new E.$Gt({getElements:()=>m.lastDiffIds},{getElements:()=>[...m.children.slice(0,r),...b,...m.children.slice(r+o)].map(w=>e.getId(w.element).toString())}).ComputeDiff(!1);if(p.quitEarly)return m.lastDiffIds=void 0,this.t(n,o,b,h);const S=n.slice(0,-1),F=(w,j,W)=>{if(v>0)for(let N=0;N<W;N++)w--,j--,this.s(e,[...S,w,0],Number.MAX_SAFE_INTEGER,b[j].children,h,v-1)};let I=Math.min(m.children.length,r+o),H=b.length;for(const w of p.changes.sort((j,W)=>W.originalStart-j.originalStart))F(I,H,I-(w.originalStart+w.originalLength)),I=w.originalStart,H=w.modifiedStart-r,this.t([...S,I],w.originalLength,d.Iterable.slice(b,H,H+w.modifiedLength),h);F(I,H,I)}t(e,n,o=d.Iterable.empty(),{onDidCreateNode:f,onDidDeleteNode:h,diffIdentityProvider:v}){const{parentNode:m,listIndex:b,revealed:r,visible:p}=this.H(e),S=[],F=d.Iterable.map(o,Q=>this.x(Q,m,m.visible?1:0,r,S,f)),I=e[e.length-1];let H=0;for(let Q=I;Q>=0&&Q<m.children.length;Q--){const ie=m.children[Q];if(ie.visible){H=ie.visibleChildIndex;break}}const w=[];let j=0,W=0;for(const Q of F)w.push(Q),W+=Q.renderNodeCount,Q.visible&&(Q.visibleChildIndex=H+j++);const N=(0,C.$5b)(m.children,I,n,w);v?m.lastDiffIds?(0,C.$5b)(m.lastDiffIds,I,n,w.map(Q=>v.getId(Q.element).toString())):m.lastDiffIds=m.children.map(Q=>v.getId(Q.element).toString()):m.lastDiffIds=void 0;let x=0;for(const Q of N)Q.visible&&x++;if(x!==0)for(let Q=I+w.length;Q<m.children.length;Q++){const ie=m.children[Q];ie.visible&&(ie.visibleChildIndex-=x)}if(m.visibleChildrenCount+=j-x,r&&p){const Q=N.reduce((ie,ue)=>ie+(ue.visible?ue.renderNodeCount:0),0);this.C(m,W-Q),this.q.splice(b,Q,S)}if(N.length>0&&h){const Q=ie=>{h(ie),ie.children.forEach(Q)};N.forEach(Q)}this.m.fire({insertedNodes:w,deletedNodes:N});let M=m;for(;M;){if(M.visibility===2){this.o.trigger(()=>this.refilter());break}M=M.parent}}rerender(e){if(e.length===0)throw new i.$AV(this.p,"Invalid tree location");const{node:n,listIndex:o,revealed:f}=this.G(e);n.visible&&f&&this.q.splice(o,1,[n])}updateElementHeight(e,n){if(e.length===0)throw new i.$AV(this.p,"Invalid tree location");const{listIndex:o}=this.G(e);this.q.updateElementHeight(o,n)}has(e){return this.E(e)}getListIndex(e){const{listIndex:n,visible:o,revealed:f}=this.G(e);return o&&f?n:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,n){const o=this.F(e);typeof n>"u"&&(n=!o.collapsible);const f={collapsible:n};return this.d.bufferEvents(()=>this.u(e,f))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,n,o){const f=this.F(e);typeof n>"u"&&(n=!f.collapsed);const h={collapsed:n,recursive:o||!1};return this.d.bufferEvents(()=>this.u(e,h))}u(e,n){const{node:o,listIndex:f,revealed:h}=this.G(e),v=this.v(o,f,h,n);if(o!==this.c&&this.l&&v&&!P(n)&&o.collapsible&&!o.collapsed&&!n.recursive){let m=-1;for(let b=0;b<o.children.length;b++)if(o.children[b].visible)if(m>-1){m=-1;break}else m=b;m>-1&&this.u([...e,m],n)}return v}v(e,n,o,f){const h=this.w(e,f,!1);if(!o||!e.visible||!h)return h;const v=e.renderNodeCount,m=this.y(e),b=v-(n===-1?0:1);return this.q.splice(n+1,b,m.slice(1)),h}w(e,n,o){let f;if(e===this.c?f=!1:(P(n)?(f=e.collapsible!==n.collapsible,e.collapsible=n.collapsible):e.collapsible?(f=e.collapsed!==n.collapsed,e.collapsed=n.collapsed):f=!1,f&&this.f.fire({node:e,deep:o})),!P(n)&&n.recursive)for(const h of e.children)f=this.w(h,n,!0)||f;return f}expandTo(e){this.d.bufferEvents(()=>{let n=this.F(e);for(;n.parent;)n=n.parent,e=e.slice(0,e.length-1),n.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,n=this.A(this.c);this.q.splice(0,e,n),this.o.cancel()}x(e,n,o,f,h,v){const m={parent:n,element:e.element,children:[],depth:n.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},b=this.D(m,o);m.visibility=b,f&&h.push(m);const r=e.children||d.Iterable.empty(),p=f&&b!==0&&!m.collapsed;let S=0,F=1;for(const I of r){const H=this.x(I,m,b,p,h,v);m.children.push(H),F+=H.renderNodeCount,H.visible&&(H.visibleChildIndex=S++)}return this.j||(m.collapsible=m.collapsible||m.children.length>0),m.visibleChildrenCount=S,m.visible=b===2?S>0:b===1,m.visible?m.collapsed||(m.renderNodeCount=F):(m.renderNodeCount=0,f&&h.pop()),v?.(m),m}y(e){const n=e.renderNodeCount,o=[];return this.z(e,o),this.C(e.parent,o.length-n),o}z(e,n){if(e.visible===!1)return 0;if(n.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this.z(o,n);return this.g.fire(e),e.renderNodeCount}A(e){const n=e.renderNodeCount,o=[];return this.B(e,e.visible?1:0,o),this.C(e.parent,o.length-n),o}B(e,n,o,f=!0){let h;if(e!==this.c){if(h=this.D(e,n),h===0)return e.visible=!1,e.renderNodeCount=0,!1;f&&o.push(e)}const v=o.length;e.renderNodeCount=e===this.c?0:1;let m=!1;if(!e.collapsed||h!==0){let b=0;for(const r of e.children)m=this.B(r,h,o,f&&!e.collapsed)||m,r.visible&&(r.visibleChildIndex=b++);e.visibleChildrenCount=b}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=h===2?m:h===1,e.visibility=h),e.visible?e.collapsed||(e.renderNodeCount+=o.length-v):(e.renderNodeCount=0,f&&o.pop()),this.g.fire(e),e.visible}C(e,n){if(n!==0)for(;e;)e.renderNodeCount+=n,this.g.fire(e),e=e.parent}D(e,n){const o=this.k?this.k.filter(e.element,n):1;return typeof o=="boolean"?(e.filterData=void 0,o?1:0):g(o)?(e.filterData=o.data,$(o.visibility)):(e.filterData=void 0,$(o))}E(e,n=this.c){if(!e||e.length===0)return!0;const[o,...f]=e;return o<0||o>n.children.length?!1:this.E(f,n.children[o])}F(e,n=this.c){if(!e||e.length===0)return n;const[o,...f]=e;if(o<0||o>n.children.length)throw new i.$AV(this.p,"Invalid tree location");return this.F(f,n.children[o])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:n,listIndex:o,revealed:f,visible:h}=this.H(e),v=e[e.length-1];if(v<0||v>n.children.length)throw new i.$AV(this.p,"Invalid tree location");const m=n.children[v];return{node:m,listIndex:o,revealed:f,visible:h&&m.visible}}H(e,n=this.c,o=0,f=!0,h=!0){const[v,...m]=e;if(v<0||v>n.children.length)throw new i.$AV(this.p,"Invalid tree location");for(let b=0;b<v;b++)o+=n.children[b].renderNodeCount;return f=f&&!n.collapsed,h=h&&n.visible,m.length===0?{parentNode:n,listIndex:o,revealed:f,visible:h}:this.H(m,n.children[v],o+1,f,h)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const n=[];let o=e;for(;o.parent;)n.push(o.parent.children.indexOf(o)),o=o.parent;return n.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,C.$tb)(e)[0]}getFirstElementChild(e){const n=this.F(e);if(n.children.length!==0)return n.children[0].element}getLastElementAncestor(e=[]){const n=this.F(e);if(n.children.length!==0)return this.I(n)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$EV=c}),define(we[134],ve([1,0,69,30,32]),function(se,t,i,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LV=void 0;class U{get size(){return this.d.size}constructor(A,d,g={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$EV(A,d,null,g),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,g.sorter&&(this.j={compare($,P){return g.sorter.compare($.element,P.element)}}),this.h=g.identityProvider}setChildren(A,d=B.Iterable.empty(),g={}){const $=this.o(A);this.l($,this.m(d),g)}l(A,d=B.Iterable.empty(),g){const $=new Set,P=new Set,c=e=>{if(e.element===null)return;const n=e;if($.add(n.element),this.d.set(n.element,n),this.h){const o=this.h.getId(n.element).toString();P.add(o),this.f.set(o,n)}g.onDidCreateNode?.(n)},l=e=>{if(e.element===null)return;const n=e;if($.has(n.element)||this.d.delete(n.element),this.h){const o=this.h.getId(n.element).toString();P.has(o)||this.f.delete(o)}g.onDidDeleteNode?.(n)};this.c.splice([...A,0],Number.MAX_VALUE,d,{...g,onDidCreateNode:c,onDidDeleteNode:l})}m(A=B.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),B.Iterable.map(A,d=>{let g=this.d.get(d.element);if(!g&&this.h){const c=this.h.getId(d.element).toString();g=this.f.get(c)}if(!g){let c;return typeof d.collapsed>"u"?c=void 0:d.collapsed===C.ObjectTreeElementCollapseState.Collapsed||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:d.collapsed===C.ObjectTreeElementCollapseState.Expanded||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!d.collapsed,{...d,children:this.m(d.children),collapsed:c}}const $=typeof d.collapsible=="boolean"?d.collapsible:g.collapsible;let P;return typeof d.collapsed>"u"||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?P=g.collapsed:d.collapsed===C.ObjectTreeElementCollapseState.Collapsed?P=!0:d.collapsed===C.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!d.collapsed,{...d,collapsible:$,collapsed:P,children:this.m(d.children)}})}rerender(A){const d=this.o(A);this.c.rerender(d)}updateElementHeight(A,d){const g=this.o(A);this.c.updateElementHeight(g,d)}resort(A=null,d=!0){if(!this.j)return;const g=this.o(A),$=this.c.getNode(g);this.l(g,this.n($,d),{})}n(A,d,g=!0){let $=[...A.children];return(d||g)&&($=$.sort(this.j.compare.bind(this.j))),B.Iterable.map($,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,d,!1)}))}getFirstElementChild(A=null){const d=this.o(A);return this.c.getFirstElementChild(d)}getLastElementAncestor(A=null){const d=this.o(A);return this.c.getLastElementAncestor(d)}has(A){return this.d.has(A)}getListIndex(A){const d=this.o(A);return this.c.getListIndex(d)}getListRenderCount(A){const d=this.o(A);return this.c.getListRenderCount(d)}isCollapsible(A){const d=this.o(A);return this.c.isCollapsible(d)}setCollapsible(A,d){const g=this.o(A);return this.c.setCollapsible(g,d)}isCollapsed(A){const d=this.o(A);return this.c.isCollapsed(d)}setCollapsed(A,d,g){const $=this.o(A);return this.c.setCollapsed($,d,g)}expandTo(A){const d=this.o(A);this.c.expandTo(d)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const d=this.d.get(A);if(!d)throw new C.$AV(this.k,`Tree element not found: ${A}`);return d}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new C.$AV(this.k,"Invalid getParentNodeLocation call");const d=this.d.get(A);if(!d)throw new C.$AV(this.k,`Tree element not found: ${A}`);const g=this.c.getNodeLocation(d),$=this.c.getParentNodeLocation(g);return this.c.getNode($).element}o(A){if(A===null)return[];const d=this.d.get(A);if(!d)throw new C.$AV(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(d)}}t.$LV=U}),define(we[21],ve([1,0,4,15,20,28,2]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XS=void 0;class A extends E.$Uc{f(g,$){this.B(i.$kR(g,i.$dS.CLICK,P=>$(new B.$cR(i.getWindow(g),P))))}j(g,$){this.B(i.$kR(g,i.$dS.MOUSE_DOWN,P=>$(new B.$cR(i.getWindow(g),P))))}m(g,$){this.B(i.$kR(g,i.$dS.MOUSE_OVER,P=>$(new B.$cR(i.getWindow(g),P))))}u(g,$){this.B(i.$kR(g,i.$dS.MOUSE_LEAVE,P=>$(new B.$cR(i.getWindow(g),P))))}z(g,$){this.B(i.$kR(g,i.$dS.KEY_DOWN,P=>$(new C.$hR(P))))}C(g,$){this.B(i.$kR(g,i.$dS.KEY_UP,P=>$(new C.$hR(P))))}D(g,$){this.B(i.$kR(g,i.$dS.INPUT,$))}F(g,$){this.B(i.$kR(g,i.$dS.BLUR,$))}G(g,$){this.B(i.$kR(g,i.$dS.FOCUS,$))}H(g,$){this.B(i.$kR(g,i.$dS.CHANGE,$))}I(g){return U.$TS.ignoreTarget(g)}}t.$XS=A}),define(we[48],ve([1,0,67,21,11,19,4]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZS=t.$YS=void 0,t.$YS=11;class A extends C.$XS{constructor(g){super(),this.a=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(g.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$YS+"px",this.domNode.style.height=t.$YS+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this.g=this.B(new i.$WS),this.B(E.$lR(this.bgDomNode,E.$dS.POINTER_DOWN,$=>this.h($))),this.B(E.$lR(this.domNode,E.$dS.POINTER_DOWN,$=>this.h($))),this.b=this.B(new E.$wR),this.c=this.B(new B.$Kh)}h(g){if(!g.target||!(g.target instanceof Element))return;const $=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,E.getWindow(g))};this.a(),this.b.cancel(),this.c.cancelAndSet($,200),this.g.startMonitoring(g.target,g.pointerId,g.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),g.preventDefault()}}t.$ZS=A}),define(we[70],ve([1,0,4,51,67,48,132,21,5]),function(se,t,i,C,B,U,E,A,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3S=void 0;const g=140;class $ extends A.$XS{constructor(c){super(),this.g=c.lazyRender,this.a=c.host,this.b=c.scrollable,this.c=c.scrollByPage,this.h=c.scrollbarState,this.n=this.B(new E.$2S(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new B.$WS),this.s=!0,this.domNode=(0,C.$VS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$kR(this.domNode.domNode,i.$dS.POINTER_DOWN,l=>this.M(l)))}t(c){const l=this.B(new U.$ZS(c));this.domNode.domNode.appendChild(l.bgDomNode),this.domNode.domNode.appendChild(l.domNode)}w(c,l,e,n){this.slider=(0,C.$VS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(l),typeof e=="number"&&this.slider.setWidth(e),typeof n=="number"&&this.slider.setHeight(n),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$kR(this.slider.domNode,i.$dS.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.O(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}y(c){return this.h.setVisibleSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(c){return this.h.setScrollSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(c){return this.h.setScrollPosition(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(c){c.target===this.domNode.domNode&&this.N(c)}delegatePointerDown(c){const l=this.domNode.domNode.getClientRects()[0].top,e=l+this.h.getSliderPosition(),n=l+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.U(c);e<=o&&o<=n?c.button===0&&(c.preventDefault(),this.O(c)):this.N(c)}N(c){let l,e;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")l=c.offsetX,e=c.offsetY;else{const o=i.$GR(this.domNode.domNode);l=c.pageX-o.left,e=c.pageY-o.top}const n=this.S(l,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(n):this.h.getDesiredScrollPositionFromOffset(n)),c.button===0&&(c.preventDefault(),this.O(c))}O(c){if(!c.target||!(c.target instanceof Element))return;const l=this.U(c),e=this.W(c),n=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(c.target,c.pointerId,c.buttons,o=>{const f=this.W(o),h=Math.abs(f-e);if(d.$i&&h>g){this.P(n.getScrollPosition());return}const m=this.U(o)-l;this.P(n.getDesiredScrollPositionFromDelta(m))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(c){const l={};this.writeScrollPosition(l,c),this.b.setScrollPositionNow(l)}updateScrollbarSize(c){this.X(c),this.h.setScrollbarSize(c),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$3S=$}),define(we[135],ve([1,0,20,70,48,52,18]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4S=void 0;class A extends C.$3S{constructor(g,$,P){const c=g.getScrollDimensions(),l=g.getCurrentScrollPosition();if(super({lazyRender:$.lazyRender,host:P,scrollbarState:new U.$1S($.horizontalHasArrows?$.arrowSize:0,$.horizontal===2?0:$.horizontalScrollbarSize,$.vertical===2?0:$.verticalScrollbarSize,c.width,c.scrollWidth,l.scrollLeft),visibility:$.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:$.scrollByPage}),$.horizontalHasArrows){const e=($.arrowSize-B.$YS)/2,n=($.horizontalScrollbarSize-B.$YS)/2;this.t({className:"scra",icon:E.$Zj.scrollbarButtonLeft,top:n,left:e,bottom:void 0,right:void 0,bgWidth:$.arrowSize,bgHeight:$.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$eR(null,1,0))}),this.t({className:"scra",icon:E.$Zj.scrollbarButtonRight,top:n,left:void 0,bottom:void 0,right:e,bgWidth:$.arrowSize,bgHeight:$.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$eR(null,-1,0))})}this.w(Math.floor(($.horizontalScrollbarSize-$.horizontalSliderSize)/2),0,void 0,$.horizontalSliderSize)}R(g,$){this.slider.setWidth(g),this.slider.setLeft($)}Q(g,$){this.domNode.setWidth(g),this.domNode.setHeight($),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this.s=this.J(g.scrollWidth)||this.s,this.s=this.L(g.scrollLeft)||this.s,this.s=this.y(g.width)||this.s,this.s}S(g,$){return g}U(g){return g.pageX}W(g){return g.pageY}X(g){this.slider.setHeight(g)}writeScrollPosition(g,$){g.scrollLeft=$}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.n.setVisibility(g.horizontal),this.c=g.scrollByPage}}t.$4S=A}),define(we[136],ve([1,0,20,70,48,52,18]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5S=void 0;class A extends C.$3S{constructor(g,$,P){const c=g.getScrollDimensions(),l=g.getCurrentScrollPosition();if(super({lazyRender:$.lazyRender,host:P,scrollbarState:new U.$1S($.verticalHasArrows?$.arrowSize:0,$.vertical===2?0:$.verticalScrollbarSize,0,c.height,c.scrollHeight,l.scrollTop),visibility:$.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:$.scrollByPage}),$.verticalHasArrows){const e=($.arrowSize-B.$YS)/2,n=($.verticalScrollbarSize-B.$YS)/2;this.t({className:"scra",icon:E.$Zj.scrollbarButtonUp,top:e,left:n,bottom:void 0,right:void 0,bgWidth:$.verticalScrollbarSize,bgHeight:$.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$eR(null,0,1))}),this.t({className:"scra",icon:E.$Zj.scrollbarButtonDown,top:void 0,left:n,bottom:e,right:void 0,bgWidth:$.verticalScrollbarSize,bgHeight:$.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$eR(null,0,-1))})}this.w(0,Math.floor(($.verticalScrollbarSize-$.verticalSliderSize)/2),$.verticalSliderSize,void 0)}R(g,$){this.slider.setHeight(g),this.slider.setTop($)}Q(g,$){this.domNode.setWidth($),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this.s=this.J(g.scrollHeight)||this.s,this.s=this.L(g.scrollTop)||this.s,this.s=this.y(g.height)||this.s,this.s}S(g,$){return $}U(g){return g.pageY}W(g){return g.pageX}X(g){this.slider.setWidth(g)}writeScrollPosition(g,$){g.scrollTop=$}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(g.vertical),this.c=g.scrollByPage}}t.$5S=A}),define(we[71],ve([1,0,17,4,51,20,135,136,21,11,3,2,5,58,111]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0S=t.$9S=t.$8S=t.$7S=t.$6S=void 0;const e=500,n=50,o=!0;class f{constructor(F,I,H){this.timestamp=F,this.deltaX=I,this.deltaY=H,this.score=0}}class h{static{this.INSTANCE=new h}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let F=1,I=0,H=1,w=this.d;do{const j=w===this.c?F:Math.pow(2,-H);if(F-=j,I+=this.b[w].score*j,w===this.c)break;w=(this.a+w-1)%this.a,H++}while(!0);return I<=.5}acceptStandardWheelEvent(F){if(i.$5Q){const I=C.getWindow(F.browserEvent),H=(0,i.$XQ)(I);this.accept(Date.now(),F.deltaX*H,F.deltaY*H)}else this.accept(Date.now(),F.deltaX,F.deltaY)}accept(F,I,H){let w=null;const j=new f(F,I,H);this.c===-1&&this.d===-1?(this.b[0]=j,this.c=0,this.d=0):(w=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=j),j.score=this.f(j,w)}f(F,I){if(Math.abs(F.deltaX)>0&&Math.abs(F.deltaY)>0)return 1;let H=.5;if((!this.g(F.deltaX)||!this.g(F.deltaY))&&(H+=.25),I){const w=Math.abs(F.deltaX),j=Math.abs(F.deltaY),W=Math.abs(I.deltaX),N=Math.abs(I.deltaY),x=Math.max(Math.min(w,W),1),M=Math.max(Math.min(j,N),1),Q=Math.max(w,W),ie=Math.max(j,N);Q%x===0&&ie%M===0&&(H-=.5)}return Math.min(Math.max(H,0),1)}g(F){return Math.abs(Math.round(F)-F)<.01}}t.$6S=h;class v extends d.$XS{get options(){return this.a}constructor(F,I,H){super(),this.O=this.B(new $.$he),this.onScroll=this.O.event,this.P=this.B(new $.$he),this.onWillScroll=this.P.event,F.style.overflow="hidden",this.a=p(I),this.b=H,this.B(this.b.onScroll(j=>{this.P.fire(j),this.S(j),this.O.fire(j)}));const w={onMouseWheel:j=>this.R(j),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new A.$5S(this.b,this.a,w)),this.g=this.B(new E.$4S(this.b,this.a,w)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(F),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,B.$VS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,B.$VS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,B.$VS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,j=>this.Z(j)),this.u(this.t,j=>this.Y(j)),this.L=this.B(new g.$Kh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,P.$Pc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(F){this.c.delegatePointerDown(F)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(F){this.b.setScrollDimensions(F,!1)}updateClassName(F){this.a.className=F,c.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(F){typeof F.handleMouseWheel<"u"&&(this.a.handleMouseWheel=F.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof F.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=F.mouseWheelScrollSensitivity),typeof F.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=F.fastScrollSensitivity),typeof F.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=F.scrollPredominantAxis),typeof F.horizontal<"u"&&(this.a.horizontal=F.horizontal),typeof F.vertical<"u"&&(this.a.vertical=F.vertical),typeof F.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=F.horizontalScrollbarSize),typeof F.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=F.verticalScrollbarSize),typeof F.scrollByPage<"u"&&(this.a.scrollByPage=F.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(F){this.N=F}delegateScrollFromMouseWheelEvent(F){this.R(new U.$eR(F))}Q(F){if(this.w.length>0!==F&&(this.w=(0,P.$Pc)(this.w),F)){const H=w=>{this.R(new U.$eR(w))};this.w.push(C.$kR(this.t,C.$dS.MOUSE_WHEEL,H,{passive:!1}))}}R(F){if(F.browserEvent?.defaultPrevented)return;const I=h.INSTANCE;o&&I.acceptStandardWheelEvent(F);let H=!1;if(F.deltaY||F.deltaX){let j=F.deltaY*this.a.mouseWheelScrollSensitivity,W=F.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&W+j===0?W=j=0:Math.abs(j)>=Math.abs(W)?W=0:j=0),this.a.flipAxes&&([j,W]=[W,j]);const N=!c.$j&&F.browserEvent&&F.browserEvent.shiftKey;(this.a.scrollYToX||N)&&!W&&(W=j,j=0),F.browserEvent&&F.browserEvent.altKey&&(W=W*this.a.fastScrollSensitivity,j=j*this.a.fastScrollSensitivity);const x=this.b.getFutureScrollPosition();let M={};if(j){const Q=n*j,ie=x.scrollTop-(Q<0?Math.floor(Q):Math.ceil(Q));this.c.writeScrollPosition(M,ie)}if(W){const Q=n*W,ie=x.scrollLeft-(Q<0?Math.floor(Q):Math.ceil(Q));this.g.writeScrollPosition(M,ie)}M=this.b.validateScrollPosition(M),(x.scrollLeft!==M.scrollLeft||x.scrollTop!==M.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&I.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(M):this.b.setScrollPositionNow(M),H=!0)}let w=H;!w&&this.a.alwaysConsumeMouseWheel&&(w=!0),!w&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(w=!0),w&&(F.preventDefault(),F.stopPropagation())}S(F){this.M=this.g.onDidScroll(F)||this.M,this.M=this.c.onDidScroll(F)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const F=this.b.getCurrentScrollPosition(),I=F.scrollTop>0,H=F.scrollLeft>0,w=H?" left":"",j=I?" top":"",W=H||I?" top-left-corner":"";this.n.setClassName(`shadow${w}`),this.r.setClassName(`shadow${j}`),this.s.setClassName(`shadow${W}${j}${w}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(F){this.J=!1,this.ab()}Z(F){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$7S=v;class m extends v{constructor(F,I){I=I||{},I.mouseWheelSmoothScroll=!1;const H=new l.$3s({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:w=>C.$uR(C.getWindow(F),w)});super(F,I,H),this.B(H)}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$8S=m;class b extends v{constructor(F,I,H){super(F,I,H)}setScrollPosition(F){F.reuseAnimation?this.b.setScrollPositionSmooth(F,F.reuseAnimation):this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$9S=b;class r extends v{constructor(F,I){I=I||{},I.mouseWheelSmoothScroll=!1;const H=new l.$3s({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:w=>C.$uR(C.getWindow(F),w)});super(F,I,H),this.B(H),this.cb=F,this.B(this.onScroll(w=>{w.scrollTopChanged&&(this.cb.scrollTop=w.scrollTop),w.scrollLeftChanged&&(this.cb.scrollLeft=w.scrollLeft)})),this.scanDomNode()}setScrollPosition(F){this.b.setScrollPositionNow(F)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$0S=r;function p(S){const F={lazyRender:typeof S.lazyRender<"u"?S.lazyRender:!1,className:typeof S.className<"u"?S.className:"",useShadows:typeof S.useShadows<"u"?S.useShadows:!0,handleMouseWheel:typeof S.handleMouseWheel<"u"?S.handleMouseWheel:!0,flipAxes:typeof S.flipAxes<"u"?S.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof S.consumeMouseWheelIfScrollbarIsNeeded<"u"?S.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof S.alwaysConsumeMouseWheel<"u"?S.alwaysConsumeMouseWheel:!1,scrollYToX:typeof S.scrollYToX<"u"?S.scrollYToX:!1,mouseWheelScrollSensitivity:typeof S.mouseWheelScrollSensitivity<"u"?S.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof S.fastScrollSensitivity<"u"?S.fastScrollSensitivity:5,scrollPredominantAxis:typeof S.scrollPredominantAxis<"u"?S.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof S.mouseWheelSmoothScroll<"u"?S.mouseWheelSmoothScroll:!0,arrowSize:typeof S.arrowSize<"u"?S.arrowSize:11,listenOnDomNode:typeof S.listenOnDomNode<"u"?S.listenOnDomNode:null,horizontal:typeof S.horizontal<"u"?S.horizontal:1,horizontalScrollbarSize:typeof S.horizontalScrollbarSize<"u"?S.horizontalScrollbarSize:10,horizontalSliderSize:typeof S.horizontalSliderSize<"u"?S.horizontalSliderSize:0,horizontalHasArrows:typeof S.horizontalHasArrows<"u"?S.horizontalHasArrows:!1,vertical:typeof S.vertical<"u"?S.vertical:1,verticalScrollbarSize:typeof S.verticalScrollbarSize<"u"?S.verticalScrollbarSize:10,verticalHasArrows:typeof S.verticalHasArrows<"u"?S.verticalHasArrows:!1,verticalSliderSize:typeof S.verticalSliderSize<"u"?S.verticalSliderSize:0,scrollByPage:typeof S.scrollByPage<"u"?S.scrollByPage:!1};return F.horizontalSliderSize=typeof S.horizontalSliderSize<"u"?S.horizontalSliderSize:F.horizontalScrollbarSize,F.verticalSliderSize=typeof S.verticalSliderSize<"u"?S.verticalSliderSize:F.verticalScrollbarSize,c.$j&&(F.className+=" mac"),F}}),define(we[72],ve([1,0,65,4,24,28,71,8,11,31,3,2,56,58,92,131,6,40]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l,e,n,o,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BT=t.$AT=t.$zT=t.$yT=t.ListViewTargetSector=void 0;const h={CurrentDragAndDropData:void 0};var v;(function(H){H[H.TOP=0]="TOP",H[H.CENTER_TOP=1]="CENTER_TOP",H[H.CENTER_BOTTOM=2]="CENTER_BOTTOM",H[H.BOTTOM=3]="BOTTOM"})(v||(t.ListViewTargetSector=v={}));const m={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(H){return[H]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class b{get context(){return this.d}set context(w){this.d=w}constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$yT=b;class r{constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$zT=r;class p{constructor(){this.types=[],this.files=[]}update(w){if(w.types&&this.types.splice(0,this.types.length,...w.types),w.files){this.files.splice(0,this.files.length);for(let j=0;j<w.files.length;j++){const W=w.files.item(j);W&&(W.size||W.type)&&this.files.push(W)}}}getData(){return{types:this.types,files:this.files}}}t.$AT=p;function S(H,w){return Array.isArray(H)&&Array.isArray(w)?(0,A.$ub)(H,w):H===w}class F{constructor(w){w?.getSetSize?this.getSetSize=w.getSetSize.bind(w):this.getSetSize=(j,W,N)=>N,w?.getPosInSet?this.getPosInSet=w.getPosInSet.bind(w):this.getPosInSet=(j,W)=>W+1,w?.getRole?this.getRole=w.getRole.bind(w):this.getRole=j=>"listitem",w?.isChecked?this.isChecked=w.isChecked.bind(w):this.isChecked=j=>{}}}class I{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(w){if(w!==this.P){if(w&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=w,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const j of this.d)this.ab(j);this.X(),this.q.setScrollDimensions({width:(0,C.$JR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(w,j,W,N=m){if(this.R=j,this.domId=`list_id_${++I.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new d.$xh(50),this.v=!1,this.x=P.$Uc.None,this.y=0,this.G=!1,this.K=P.$Uc.None,this.L=P.$Uc.None,this.M=new P.$Tc,this.N=new $.$he,this.O=new $.$he,this.onDidChangeContentHeight=$.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=$.Event.latch(this.O.event,void 0,this.M),this.P=!1,N.horizontalScrolling&&N.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(N.paddingTop??0);for(const M of W)this.j.set(M.templateId,M);this.h=this.M.add(new n.$xT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof N.mouseSupport=="boolean"?N.mouseSupport:!0),this.P=N.horizontalScrolling??m.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof N.paddingBottom>"u"?0:N.paddingBottom,this.D=new F(N.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(N.transformOptimization??m.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(U.$TS.addTarget(this.o)),this.p=this.M.add(new l.$3s({forceIntegerValues:!0,smoothScrollDuration:N.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:M=>(0,C.$uR)((0,C.getWindow)(this.domNode),M)})),this.q=this.M.add(new E.$9S(this.o,{alwaysConsumeMouseWheel:N.alwaysConsumeMouseWheel??m.alwaysConsumeMouseWheel,horizontal:1,vertical:N.verticalScrollMode??m.verticalScrollMode,useShadows:N.useShadows??m.useShadows,mouseWheelScrollSensitivity:N.mouseWheelScrollSensitivity,fastScrollSensitivity:N.fastScrollSensitivity,scrollByPage:N.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),w.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,C.$kR)(this.o,U.EventType.Change,M=>this.jb(M))),this.M.add((0,C.$kR)(this.q.getDomNode(),"scroll",M=>M.target.scrollTop=0)),this.M.add((0,C.$kR)(this.domNode,"dragover",M=>this.lb(this.hb(M)))),this.M.add((0,C.$kR)(this.domNode,"drop",M=>this.nb(this.hb(M)))),this.M.add((0,C.$kR)(this.domNode,"dragleave",M=>this.mb(this.hb(M)))),this.M.add((0,C.$kR)(this.domNode,"dragend",M=>this.ob(M))),this.z=N.setRowLineHeight??m.setRowLineHeight,this.A=N.setRowHeight??m.setRowHeight,this.B=N.supportDynamicHeights??m.supportDynamicHeights,this.F=N.dnd??this.M.add(m.dnd),this.layout(N.initialSize?.height,N.initialSize?.width)}updateOptions(w){w.paddingBottom!==void 0&&(this.C=w.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),w.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(w.smoothScrolling?125:0),w.horizontalScrolling!==void 0&&(this.Q=w.horizontalScrolling);let j;if(w.scrollByPage!==void 0&&(j={...j??{},scrollByPage:w.scrollByPage}),w.mouseWheelScrollSensitivity!==void 0&&(j={...j??{},mouseWheelScrollSensitivity:w.mouseWheelScrollSensitivity}),w.fastScrollSensitivity!==void 0&&(j={...j??{},fastScrollSensitivity:w.fastScrollSensitivity}),j&&this.q.updateOptions(j),w.paddingTop!==void 0&&w.paddingTop!==this.g.paddingTop){const W=this.vb(this.k,this.m),N=w.paddingTop-this.g.paddingTop;this.g.paddingTop=w.paddingTop,this.Y(W,Math.max(0,this.k+N),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(w){this.q.delegateScrollFromMouseWheelEvent(w)}delegateVerticalScrollbarPointerDown(w){this.q.delegateVerticalScrollbarPointerDown(w)}updateElementHeight(w,j,W){if(w<0||w>=this.d.length)return;const N=this.d[w].size;if(typeof j>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[w].lastDynamicHeightWidth=void 0,j=N+this.xb(w)}if(N===j)return;const x=this.vb(this.k,this.m);let M=0;w<x.start||W!==null&&W>w&&W<x.end?M=j-N:M=0,this.g.splice(w,1,[{size:j}]),this.d[w].size=j,this.Y(x,Math.max(0,this.k+M),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(w){return new e.$wT(w)}splice(w,j,W=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(w,j,W)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(w,j,W=[]){const N=this.vb(this.k,this.m),x={start:w,end:w+j},M=c.Range.intersect(N,x),Q=new Map;for(let Z=M.end-1;Z>=M.start;Z--){const pe=this.d[Z];if(pe.dragStartDisposable.dispose(),pe.checkedDisposable.dispose(),pe.row){let Se=Q.get(pe.templateId);Se||(Se=[],Q.set(pe.templateId,Se));const Re=this.j.get(pe.templateId);Re&&Re.disposeElement&&Re.disposeElement(pe.element,Z,pe.row.templateData,pe.size),Se.unshift(pe.row)}pe.row=null,pe.stale=!0}const ie={start:w+j,end:this.d.length},ue=c.Range.intersect(ie,N),G=c.Range.relativeComplement(ie,N),ee=W.map(Z=>({id:String(this.f++),element:Z,templateId:this.R.getTemplateId(Z),size:this.R.getHeight(Z),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(Z),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.$Uc.None,checkedDisposable:P.$Uc.None,stale:!1}));let de;w===0&&j>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ee),de=this.d,this.d=ee):(this.g.splice(w,j,ee),de=this.d.splice(w,j,...ee));const ye=W.length-j,Ae=this.vb(this.k,this.m),je=(0,e.$uT)(ue,ye),le=c.Range.intersect(Ae,je);for(let Z=le.start;Z<le.end;Z++)this.bb(this.d[Z],Z);const _=c.Range.relativeComplement(je,Ae);for(const Z of _)for(let pe=Z.start;pe<Z.end;pe++)this.db(pe);const fe=G.map(Z=>(0,e.$uT)(Z,ye)),Fe=[{start:w,end:w+W.length},...fe].map(Z=>c.Range.intersect(Ae,Z)).reverse();for(const Z of Fe)for(let pe=Z.end-1;pe>=Z.start;pe--){const Se=this.d[pe],re=Q.get(Se.templateId)?.pop();this.Z(pe,re)}for(const Z of Q.values())for(const pe of Z)this.h.release(pe);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),de.map(Z=>Z.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,C.$uR)((0,C.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let w=0;for(const j of this.d)typeof j.width<"u"&&(w=Math.max(w,j.width));this.E=w,this.q.setScrollDimensions({scrollWidth:w===0?0:w+10}),this.O.fire(this.E)}updateWidth(w){if(!this.Q||typeof this.E>"u")return;const j=this.d[w];this.ab(j),typeof j.width<"u"&&j.width>this.E&&(this.E=j.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const w of this.d)w.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const w=this.firstVisibleIndex,j=this.g.positionAt(w),W=this.g.positionAt(w+1);return W!==-1&&(W-j)/2+j<this.scrollTop?w+1:w}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(w){return this.d[w].element}indexOf(w){return this.d.findIndex(j=>j.element===w)}domElement(w){const j=this.d[w].row;return j&&j.domNode}elementHeight(w){return this.d[w].size}elementTop(w){return this.g.positionAt(w)}indexAt(w){return this.g.indexAt(w)}indexAfter(w){return this.g.indexAfter(w)}layout(w,j){const W={height:typeof w=="number"?w:(0,C.$LR)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,W.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(W),typeof j<"u"&&(this.n=j,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof j=="number"?j:(0,C.$JR)(this.domNode)})}Y(w,j,W,N,x,M=!1){const Q=this.vb(j,W),ie=c.Range.relativeComplement(Q,w).reverse(),ue=c.Range.relativeComplement(w,Q);if(M){const G=c.Range.intersect(w,Q);for(let ee=G.start;ee<G.end;ee++)this.bb(this.d[ee],ee)}this.h.transact(()=>{for(const G of ue)for(let ee=G.start;ee<G.end;ee++)this.db(ee);for(const G of ie)for(let ee=G.end-1;ee>=G.start;ee--)this.Z(ee)}),N!==void 0&&(this.o.style.left=`-${N}px`),this.o.style.top=`-${j}px`,this.Q&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=j,this.m=W}Z(w,j){const W=this.d[w];if(!W.row)if(j)W.row=j,W.stale=!0;else{const ie=this.h.alloc(W.templateId);W.row=ie.row,W.stale||=ie.isReusingConnectedDomNode}const N=this.D.getRole(W.element)||"listitem";W.row.domNode.setAttribute("role",N);const x=this.D.isChecked(W.element);if(typeof x=="boolean")W.row.domNode.setAttribute("aria-checked",String(!!x));else if(x){const ie=ue=>W.row.domNode.setAttribute("aria-checked",String(!!ue));ie(x.value),W.checkedDisposable=x.onDidChange(()=>ie(x.value))}if(W.stale||!W.row.domNode.parentElement){const ie=this.d.at(w+1)?.row?.domNode??null;(W.row.domNode.parentElement!==this.o||W.row.domNode.nextElementSibling!==ie)&&this.o.insertBefore(W.row.domNode,ie),W.stale=!1}this.bb(W,w);const M=this.j.get(W.templateId);if(!M)throw new Error(`No renderer found for template id ${W.templateId}`);M?.renderElement(W.element,w,W.row.templateData,W.size);const Q=this.F.getDragURI(W.element);W.dragStartDisposable.dispose(),W.row.domNode.draggable=!!Q,Q&&(W.dragStartDisposable=(0,C.$kR)(W.row.domNode,"dragstart",ie=>this.kb(W.element,Q,ie))),this.Q&&(this.ab(W),this.W())}ab(w){if(!w.row||!w.row.domNode)return;w.row.domNode.style.width="fit-content",w.width=(0,C.$JR)(w.row.domNode);const j=(0,C.getWindow)(w.row.domNode).getComputedStyle(w.row.domNode);j.paddingLeft&&(w.width+=parseFloat(j.paddingLeft)),j.paddingRight&&(w.width+=parseFloat(j.paddingRight)),w.row.domNode.style.width=""}bb(w,j){w.row.domNode.style.top=`${this.elementTop(j)}px`,this.A&&(w.row.domNode.style.height=`${w.size}px`),this.z&&(w.row.domNode.style.lineHeight=`${w.size}px`),w.row.domNode.setAttribute("data-index",`${j}`),w.row.domNode.setAttribute("data-last-element",j===this.length-1?"true":"false"),w.row.domNode.setAttribute("data-parity",j%2===0?"even":"odd"),w.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(w.element,j,this.length))),w.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(w.element,j))),w.row.domNode.setAttribute("id",this.getElementDomId(j)),w.row.domNode.classList.toggle("drop-target",w.dropTarget)}db(w){const j=this.d[w];if(j.dragStartDisposable.dispose(),j.checkedDisposable.dispose(),j.row){const W=this.j.get(j.templateId);W&&W.disposeElement&&W.disposeElement(j.element,w,j.row.templateData,j.size),this.h.release(j.row),j.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(w,j){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:w,reuseAnimation:j})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(w){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:w})}get scrollTop(){return this.getScrollTop()}set scrollTop(w){this.setScrollTop(w)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return $.Event.map(this.M.add(new B.$oT(this.domNode,"click")).event,w=>this.eb(w),this.M)}get onMouseDblClick(){return $.Event.map(this.M.add(new B.$oT(this.domNode,"dblclick")).event,w=>this.eb(w),this.M)}get onMouseMiddleClick(){return $.Event.filter($.Event.map(this.M.add(new B.$oT(this.domNode,"auxclick")).event,w=>this.eb(w),this.M),w=>w.browserEvent.button===1,this.M)}get onMouseUp(){return $.Event.map(this.M.add(new B.$oT(this.domNode,"mouseup")).event,w=>this.eb(w),this.M)}get onMouseDown(){return $.Event.map(this.M.add(new B.$oT(this.domNode,"mousedown")).event,w=>this.eb(w),this.M)}get onMouseOver(){return $.Event.map(this.M.add(new B.$oT(this.domNode,"mouseover")).event,w=>this.eb(w),this.M)}get onMouseMove(){return $.Event.map(this.M.add(new B.$oT(this.domNode,"mousemove")).event,w=>this.eb(w),this.M)}get onMouseOut(){return $.Event.map(this.M.add(new B.$oT(this.domNode,"mouseout")).event,w=>this.eb(w),this.M)}get onContextMenu(){return $.Event.any($.Event.map(this.M.add(new B.$oT(this.domNode,"contextmenu")).event,w=>this.eb(w),this.M),$.Event.map(this.M.add(new B.$oT(this.domNode,U.EventType.Contextmenu)).event,w=>this.gb(w),this.M))}get onTouchStart(){return $.Event.map(this.M.add(new B.$oT(this.domNode,"touchstart")).event,w=>this.fb(w),this.M)}get onTap(){return $.Event.map(this.M.add(new B.$oT(this.o,U.EventType.Tap)).event,w=>this.gb(w),this.M)}eb(w){const j=this.ub(w.target||null),W=typeof j>"u"?void 0:this.d[j],N=W&&W.element;return{browserEvent:w,index:j,element:N}}fb(w){const j=this.ub(w.target||null),W=typeof j>"u"?void 0:this.d[j],N=W&&W.element;return{browserEvent:w,index:j,element:N}}gb(w){const j=this.ub(w.initialTarget||null),W=typeof j>"u"?void 0:this.d[j],N=W&&W.element;return{browserEvent:w,index:j,element:N}}hb(w){const j=this.ub(w.target||null),W=typeof j>"u"?void 0:this.d[j],N=W&&W.element,x=this.tb(w,j);return{browserEvent:w,index:j,element:N,sector:x}}ib(w){try{const j=this.vb(this.k,this.m);this.Y(j,w.scrollTop,w.height,w.scrollLeft,w.scrollWidth),this.B&&this.wb(w.scrollTop,w.height,w.inSmoothScrolling)}catch(j){throw console.error("Got bad scroll event:",w),j}}jb(w){w.preventDefault(),w.stopPropagation(),this.scrollTop-=w.translationY}kb(w,j,W){if(!W.dataTransfer)return;const N=this.F.getDragElements(w);if(W.dataTransfer.effectAllowed="copyMove",W.dataTransfer.setData(i.$RS.TEXT,j),W.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(N,W)),typeof x>"u"&&(x=String(N.length));const M=(0,C.$)(".monaco-drag-image");M.textContent=x;const ie=(ue=>{for(;ue&&!ue.classList.contains("monaco-workbench");)ue=ue.parentElement;return ue||this.domNode.ownerDocument})(this.domNode);ie.appendChild(M),W.dataTransfer.setDragImage(M,-10,-10),setTimeout(()=>ie.removeChild(M),0)}this.domNode.classList.add("dragging"),this.H=new b(N),h.CurrentDragAndDropData=new r(N),this.F.onDragStart?.(this.H,W)}lb(w){if(w.browserEvent.preventDefault(),this.L.dispose(),h.CurrentDragAndDropData&&h.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(w.browserEvent),!w.browserEvent.dataTransfer))return!1;if(!this.H)if(h.CurrentDragAndDropData)this.H=h.CurrentDragAndDropData;else{if(!w.browserEvent.dataTransfer.types)return!1;this.H=new p}const j=this.F.onDragOver(this.H,w.element,w.index,w.sector,w.browserEvent);if(this.G=typeof j=="boolean"?j:j.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;w.browserEvent.dataTransfer.dropEffect=typeof j!="boolean"&&j.effect?.type===0?"copy":"move";let W;typeof j!="boolean"&&j.feedback?W=j.feedback:typeof w.index>"u"?W=[-1]:W=[w.index],W=(0,A.$Mb)(W).filter(x=>x>=-1&&x<this.length).sort((x,M)=>x-M),W=W[0]===-1?[-1]:W;let N=typeof j!="boolean"&&j.effect&&j.effect.position?j.effect.position:"drop-target";if(S(this.I,W)&&this.J===N)return!0;if(this.I=W,this.J=N,this.K.dispose(),W[0]===-1)this.domNode.classList.add(N),this.o.classList.add(N),this.K=(0,P.$Sc)(()=>{this.domNode.classList.remove(N),this.o.classList.remove(N)});else{if(W.length>1&&N!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");N==="drop-target-after"&&W[0]<this.length-1&&(W[0]+=1,N="drop-target-before");for(const x of W){const M=this.d[x];M.dropTarget=!0,M.row?.domNode.classList.add(N)}this.K=(0,P.$Sc)(()=>{for(const x of W){const M=this.d[x];M.dropTarget=!1,M.row?.domNode.classList.remove(N)}})}return!0}mb(w){this.L.dispose(),this.L=(0,d.$Ch)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,w.element,w.index,w.browserEvent)}nb(w){if(!this.G)return;const j=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,h.CurrentDragAndDropData=void 0,!(!j||!w.browserEvent.dataTransfer)&&(w.browserEvent.preventDefault(),j.update(w.browserEvent.dataTransfer),this.F.drop(j,w.element,w.index,w.sector,w.browserEvent))}ob(w){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,h.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(w)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=P.$Uc.None}qb(w){if(!this.w){const j=(0,C.$DR)(this.domNode).top;this.w=(0,C.$zS)((0,C.getWindow)(this.domNode),this.rb.bind(this,j))}this.x.dispose(),this.x=(0,d.$Ch)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=w.pageY}rb(w){if(this.y===void 0)return;const j=this.y-w,W=this.renderHeight-35;j<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(j-35))):j>W&&(this.scrollTop+=Math.min(14,Math.floor(.3*(j-W))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(w,j){if(j===void 0)return;const W=w.offsetY/this.d[j].size,N=Math.floor(W/.25);return(0,f.$Fm)(N,0,3)}ub(w){const j=this.q.getDomNode();let W=w;for(;W instanceof HTMLElement&&W!==this.o&&j.contains(W);){const N=W.getAttribute("data-index");if(N){const x=Number(N);if(!isNaN(x))return x}W=W.parentElement}}vb(w,j){return{start:this.g.indexAt(w),end:this.g.indexAfter(w+j-1)}}wb(w,j,W){const N=this.vb(w,j);let x,M;w===this.elementTop(N.start)?(x=N.start,M=0):N.end-N.start>1&&(x=N.start+1,M=this.elementTop(x)-w);let Q=0;for(;;){const ie=this.vb(w,j);let ue=!1;for(let G=ie.start;G<ie.end;G++){const ee=this.xb(G);ee!==0&&this.g.splice(G,1,[this.d[G]]),Q+=ee,ue=ue||ee!==0}if(!ue){Q!==0&&this.V();const G=c.Range.relativeComplement(N,ie);for(const de of G)for(let ye=de.start;ye<de.end;ye++)this.d[ye].row&&this.db(ye);const ee=c.Range.relativeComplement(ie,N).reverse();for(const de of ee)for(let ye=de.end-1;ye>=de.start;ye--)this.Z(ye);for(let de=ie.start;de<ie.end;de++)this.d[de].row&&this.bb(this.d[de],de);if(typeof x=="number"){const de=this.p.getFutureScrollPosition().scrollTop-w,ye=this.elementTop(x)-M+de;this.setScrollTop(ye,W)}this.N.fire(this.contentHeight);return}}}xb(w){const j=this.d[w];if(this.R.getDynamicHeight){const M=this.R.getDynamicHeight(j.element);if(M!==null){const Q=j.size;return j.size=M,j.lastDynamicHeightWidth=this.n,M-Q}}if(!j.hasDynamicHeight||j.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(j.element))return 0;const W=j.size;if(j.row)return j.row.domNode.style.height="",j.size=j.row.domNode.offsetHeight,j.size===0&&!(0,C.$OR)(j.row.domNode,(0,C.getWindow)(j.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),j.lastDynamicHeightWidth=this.n,j.size-W;const{row:N}=this.h.alloc(j.templateId);N.domNode.style.height="",this.o.appendChild(N.domNode);const x=this.j.get(j.templateId);if(!x)throw new o.$cb("Missing renderer for templateId: "+j.templateId);return x.renderElement(j.element,w,N.templateData,void 0),j.size=N.domNode.offsetHeight,x.disposeElement?.(j.element,w,N.templateData,void 0),this.R.setDynamicHeight?.(j.element,j.size),j.lastDynamicHeightWidth=this.n,this.o.removeChild(N.domNode),this.h.release(N),j.size-W}getElementDomId(w){return`${this.domId}_${w}`}dispose(){for(const w of this.d)if(w.dragStartDisposable.dispose(),w.checkedDisposable.dispose(),w.row){const j=this.j.get(w.row.templateId);j&&(j.disposeElement?.(w.element,-1,w.row.templateData,void 0),j.disposeTemplate(w.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$BT=I,Je([g.$5h],I.prototype,"onMouseClick",null),Je([g.$5h],I.prototype,"onMouseDblClick",null),Je([g.$5h],I.prototype,"onMouseMiddleClick",null),Je([g.$5h],I.prototype,"onMouseUp",null),Je([g.$5h],I.prototype,"onMouseDown",null),Je([g.$5h],I.prototype,"onMouseOver",null),Je([g.$5h],I.prototype,"onMouseMove",null),Je([g.$5h],I.prototype,"onMouseOut",null),Je([g.$5h],I.prototype,"onContextMenu",null),Je([g.$5h],I.prototype,"onTouchStart",null),Je([g.$5h],I.prototype,"onTap",null)}),define(we[49],ve([1,0,4,24,15,28,68,81,8,11,84,31,3,44,2,40,5,10,80,72,20,57,110]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l,e,n,o,f,h,v,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TT=t.$ST=t.$RT=t.$QT=t.$NT=t.TypeNavigationMode=void 0,t.$FT=I,t.$GT=w,t.$HT=j,t.$IT=W,t.$JT=N,t.$KT=x,t.$LT=M,t.$MT=Q,t.$OT=ye,t.$PT=Ae;class r{constructor(u){this.d=u,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(u){return u}renderElement(u,y,a){const D=this.c.findIndex(R=>R.templateData===a);if(D>=0){const R=this.c[D];this.d.unrender(a),R.index=y}else{const R={index:y,templateData:a};this.c.push(R)}this.d.renderIndex(y,a)}splice(u,y,a){const D=[];for(const R of this.c)R.index<u?D.push(R):R.index>=u+y&&D.push({index:R.index+a-y,templateData:R.templateData});this.c=D}renderIndexes(u){for(const{index:y,templateData:a}of this.c)u.indexOf(y)>-1&&this.d.renderIndex(y,a)}disposeTemplate(u){const y=this.c.findIndex(a=>a.templateData===u);y<0||this.c.splice(y,1)}}class p{get name(){return this.g}get renderer(){return new r(this)}constructor(u){this.g=u,this.c=[],this.d=[],this.f=new c.$he,this.onChange=this.f.event}splice(u,y,a){const D=a.length-y,R=u+y,s=[];let k=0;for(;k<this.d.length&&this.d[k]<u;)s.push(this.d[k++]);for(let T=0;T<a.length;T++)a[T]&&s.push(T+u);for(;k<this.d.length&&this.d[k]>=R;)s.push(this.d[k++]+D);this.renderer.splice(u,y,a.length),this.h(s,s)}renderIndex(u,y){y.classList.toggle(this.g,this.contains(u))}unrender(u){u.classList.remove(this.g)}set(u,y){return this.h(u,[...u].sort(Se),y)}h(u,y,a){const D=this.c,R=this.d;this.c=u,this.d=y;const s=Z(R,u);return this.renderer.renderIndexes(s),this.f.fire({indexes:u,browserEvent:a}),D}get(){return this.c}contains(u){return(0,d.$wb)(this.d,u,Se)>=0}dispose(){(0,e.$Pc)(this.f)}}Je([P.$5h],p.prototype,"renderer",null);class S extends p{constructor(u){super("selected"),this.k=u}renderIndex(u,y){super.renderIndex(u,y),this.k&&(this.contains(u)?y.setAttribute("aria-selected","true"):y.setAttribute("aria-selected","false"))}}class F{constructor(u,y,a){this.c=u,this.d=y,this.f=a}splice(u,y,a){if(!this.f)return this.c.splice(u,y,new Array(a.length).fill(!1));const D=this.c.get().map(k=>this.f.getId(this.d.element(k)).toString());if(D.length===0)return this.c.splice(u,y,new Array(a.length).fill(!1));const R=new Set(D),s=a.map(k=>R.has(this.f.getId(k).toString()));this.c.splice(u,y,s)}}function I(O){return O.tagName==="INPUT"||O.tagName==="TEXTAREA"}function H(O,u){return O.classList.contains(u)?!0:O.classList.contains("monaco-list")||!O.parentElement?!1:H(O.parentElement,u)}function w(O){return H(O,"monaco-editor")}function j(O){return H(O,"monaco-custom-toggle")}function W(O){return H(O,"action-item")}function N(O){return H(O,"monaco-tl-twistie")}function x(O){return H(O,"monaco-tree-sticky-row")}function M(O){return O.classList.contains("monaco-tree-sticky-container")}function Q(O){return O.tagName==="A"&&O.classList.contains("monaco-button")||O.tagName==="DIV"&&O.classList.contains("monaco-button-dropdown")?!0:O.classList.contains("monaco-list")||!O.parentElement?!1:Q(O.parentElement)}class ie{get g(){return c.Event.chain(this.c.add(new C.$oT(this.k.domNode,"keydown")).event,u=>u.filter(y=>!I(y.target)).map(y=>new B.$hR(y)))}constructor(u,y,a){this.h=u,this.k=y,this.c=new e.$Tc,this.d=new e.$Tc,this.f=a.multipleSelectionSupport,this.c.add(this.g(D=>{switch(D.keyCode){case 3:return this.l(D);case 16:return this.o(D);case 18:return this.p(D);case 11:return this.q(D);case 12:return this.s(D);case 9:return this.u(D);case 31:this.f&&(o.$j?D.metaKey:D.ctrlKey)&&this.t(D)}}))}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.f=u.multipleSelectionSupport)}l(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection(this.h.getFocus(),u.browserEvent)}o(u){u.preventDefault(),u.stopPropagation(),this.h.focusPrevious(1,!1,u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}p(u){u.preventDefault(),u.stopPropagation(),this.h.focusNext(1,!1,u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}q(u){u.preventDefault(),u.stopPropagation(),this.h.focusPreviousPage(u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}s(u){u.preventDefault(),u.stopPropagation(),this.h.focusNextPage(u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}t(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection((0,d.$Rb)(this.h.length),u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(u){this.h.getSelection().length&&(u.preventDefault(),u.stopPropagation(),this.h.setSelection([],u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Je([P.$5h],ie.prototype,"g",null);var ue;(function(O){O[O.Automatic=0]="Automatic",O[O.Trigger=1]="Trigger"})(ue||(t.TypeNavigationMode=ue={}));var G;(function(O){O[O.Idle=0]="Idle",O[O.Typing=1]="Typing"})(G||(G={})),t.$NT=new class{mightProducePrintableCharacter(O){return O.ctrlKey||O.metaKey||O.altKey?!1:O.keyCode>=31&&O.keyCode<=56||O.keyCode>=21&&O.keyCode<=30||O.keyCode>=98&&O.keyCode<=107||O.keyCode>=85&&O.keyCode<=95}};class ee{constructor(u,y,a,D,R){this.o=u,this.p=y,this.q=a,this.s=D,this.t=R,this.c=!1,this.d=G.Idle,this.f=ue.Automatic,this.g=!1,this.h=-1,this.k=new e.$Tc,this.l=new e.$Tc,this.updateOptions(u.options)}updateOptions(u){u.typeNavigationEnabled??!0?this.u():this.v(),this.f=u.typeNavigationMode??ue.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let u=!1;const y=c.Event.chain(this.k.add(new C.$oT(this.p.domNode,"keydown")).event,R=>R.filter(s=>!I(s.target)).filter(()=>this.f===ue.Automatic||this.g).map(s=>new B.$hR(s)).filter(s=>u||this.s(s)).filter(s=>this.t.mightProducePrintableCharacter(s)).forEach(s=>i.$fS.stop(s,!0)).map(s=>s.browserEvent.key)),a=c.Event.debounce(y,()=>null,800,void 0,void 0,void 0,this.k);c.Event.reduce(c.Event.any(y,a),(R,s)=>s===null?null:(R||"")+s,void 0,this.k)(this.x,this,this.k),a(this.w,this,this.k),y(()=>u=!0,void 0,this.k),a(()=>u=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const u=this.o.getFocus();if(u.length>0&&u[0]===this.h){const y=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(u[0]));typeof y=="string"?(0,E.$qT)(y):y&&(0,E.$qT)(y.get())}this.h=-1}x(u){if(!u){this.d=G.Idle,this.g=!1;return}const y=this.o.getFocus(),a=y.length>0?y[0]:0,D=this.d===G.Idle?1:0;this.d=G.Typing;for(let R=0;R<this.o.length;R++){const s=(a+R+D)%this.o.length,k=this.q.getKeyboardNavigationLabel(this.p.element(s)),T=k&&k.toString();if(this.o.options.typeNavigationEnabled){if(typeof T<"u"){if((0,l.$Ck)(u,T)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}const L=(0,l.$Jk)(u,T);if(L&&L[0].end-L[0].start>1&&L.length===1){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}else if(typeof T>"u"||(0,l.$Ck)(u,T)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class de{constructor(u,y){this.d=u,this.f=y,this.c=new e.$Tc;const a=c.Event.chain(this.c.add(new C.$oT(y.domNode,"keydown")).event,R=>R.filter(s=>!I(s.target)).map(s=>new B.$hR(s)));c.Event.chain(a,R=>R.filter(s=>s.keyCode===2&&!s.ctrlKey&&!s.metaKey&&!s.shiftKey&&!s.altKey))(this.g,this,this.c)}g(u){if(u.target!==this.f.domNode)return;const y=this.d.getFocus();if(y.length===0)return;const a=this.f.domElement(y[0]);if(!a)return;const D=a.querySelector("[tabIndex]");if(!D||!(D instanceof HTMLElement)||D.tabIndex===-1)return;const R=(0,i.getWindow)(D).getComputedStyle(D);R.visibility==="hidden"||R.display==="none"||(u.preventDefault(),u.stopPropagation(),D.focus())}dispose(){this.c.dispose()}}function ye(O){return o.$j?O.browserEvent.metaKey:O.browserEvent.ctrlKey}function Ae(O){return O.browserEvent.shiftKey}function je(O){return(0,i.$_R)(O)&&O.button===2}const le={isSelectionSingleChangeEvent:ye,isSelectionRangeChangeEvent:Ae};class _{constructor(u){this.k=u,this.f=new e.$Tc,this.g=new c.$he,this.onPointer=this.g.event,u.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||le),this.d=typeof u.options.mouseSupport>"u"||!!u.options.mouseSupport,this.d&&(u.onMouseDown(this.s,this,this.f),u.onContextMenu(this.t,this,this.f),u.onMouseDblClick(this.v,this,this.f),u.onTouchStart(this.s,this,this.f),this.f.add(U.$TS.addTarget(u.getHTMLElement()))),c.Event.any(u.onMouseClick,u.onMouseMiddleClick,u.onTap)(this.u,this,this.f)}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.c=void 0,u.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||le))}o(u){return this.c?this.c.isSelectionSingleChangeEvent(u):!1}p(u){return this.c?this.c.isSelectionRangeChangeEvent(u):!1}q(u){return this.o(u)||this.p(u)}s(u){w(u.browserEvent.target)||(0,i.$WR)()!==u.browserEvent.target&&this.k.domFocus()}t(u){if(I(u.browserEvent.target)||w(u.browserEvent.target))return;const y=typeof u.index>"u"?[]:[u.index];this.k.setFocus(y,u.browserEvent)}u(u){if(!this.d||I(u.browserEvent.target)||w(u.browserEvent.target)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const y=u.index;if(typeof y>"u"){this.k.setFocus([],u.browserEvent),this.k.setSelection([],u.browserEvent),this.k.setAnchor(void 0);return}if(this.q(u))return this.w(u);this.k.setFocus([y],u.browserEvent),this.k.setAnchor(y),je(u.browserEvent)||this.k.setSelection([y],u.browserEvent),this.g.fire(u)}v(u){if(I(u.browserEvent.target)||w(u.browserEvent.target)||this.q(u)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const y=this.k.getFocus();this.k.setSelection(y,u.browserEvent)}w(u){const y=u.index;let a=this.k.getAnchor();if(this.p(u)){typeof a>"u"&&(a=this.k.getFocus()[0]??y,this.k.setAnchor(a));const D=Math.min(a,y),R=Math.max(a,y),s=(0,d.$Rb)(D,R+1),k=this.k.getSelection(),T=Fe(Z(k,[a]),a);if(T.length===0)return;const L=Z(s,pe(k,T));this.k.setSelection(L,u.browserEvent),this.k.setFocus([y],u.browserEvent)}else if(this.o(u)){const D=this.k.getSelection(),R=D.filter(s=>s!==y);this.k.setFocus([y]),this.k.setAnchor(y),D.length===R.length?this.k.setSelection([...R,y],u.browserEvent):this.k.setSelection(R,u.browserEvent)}}dispose(){this.f.dispose()}}t.$QT=_;class fe{constructor(u,y){this.c=u,this.d=y}style(u){const y=this.d&&`.${this.d}`,a=[];u.listBackground&&a.push(`.monaco-list${y} .monaco-list-rows { background: ${u.listBackground}; }`),u.listFocusBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.focused { background-color: ${u.listFocusBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.focused:hover { background-color: ${u.listFocusBackground}; }`)),u.listFocusForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),u.listActiveSelectionBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.selected { background-color: ${u.listActiveSelectionBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.selected:hover { background-color: ${u.listActiveSelectionBackground}; }`)),u.listActiveSelectionForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected { color: ${u.listActiveSelectionForeground}; }`),u.listActiveSelectionIconForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected .codicon { color: ${u.listActiveSelectionIconForeground}; }`),u.listFocusAndSelectionBackground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { background-color: ${u.listFocusAndSelectionBackground}; }
			`),u.listFocusAndSelectionForeground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { color: ${u.listFocusAndSelectionForeground}; }
			`),u.listInactiveFocusForeground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { color:  ${u.listInactiveFocusForeground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { color:  ${u.listInactiveFocusForeground}; }`)),u.listInactiveSelectionIconForeground&&a.push(`.monaco-list${y} .monaco-list-row.focused .codicon { color:  ${u.listInactiveSelectionIconForeground}; }`),u.listInactiveFocusBackground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { background-color:  ${u.listInactiveFocusBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { background-color:  ${u.listInactiveFocusBackground}; }`)),u.listInactiveSelectionBackground&&(a.push(`.monaco-list${y} .monaco-list-row.selected { background-color:  ${u.listInactiveSelectionBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.selected:hover { background-color:  ${u.listInactiveSelectionBackground}; }`)),u.listInactiveSelectionForeground&&a.push(`.monaco-list${y} .monaco-list-row.selected { color: ${u.listInactiveSelectionForeground}; }`),u.listHoverBackground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${u.listHoverBackground}; }`),u.listHoverForeground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${u.listHoverForeground}; }`);const D=(0,i.$CS)(u.listFocusAndSelectionOutline,(0,i.$CS)(u.listSelectionOutline,u.listFocusOutline??""));D&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused.selected { outline: 1px solid ${D}; outline-offset: -1px;}`),u.listFocusOutline&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${y}.last-focused .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
			`);const R=(0,i.$CS)(u.listSelectionOutline,u.listInactiveFocusOutline??"");R&&a.push(`.monaco-list${y} .monaco-list-row.focused.selected { outline: 1px dotted ${R}; outline-offset: -1px; }`),u.listSelectionOutline&&a.push(`.monaco-list${y} .monaco-list-row.selected { outline: 1px dotted ${u.listSelectionOutline}; outline-offset: -1px; }`),u.listInactiveFocusOutline&&a.push(`.monaco-list${y} .monaco-list-row.focused { outline: 1px dotted ${u.listInactiveFocusOutline}; outline-offset: -1px; }`),u.listHoverOutline&&a.push(`.monaco-list${y} .monaco-list-row:hover { outline: 1px dashed ${u.listHoverOutline}; outline-offset: -1px; }`),u.listDropOverBackground&&a.push(`
				.monaco-list${y}.drop-target,
				.monaco-list${y} .monaco-list-rows.drop-target,
				.monaco-list${y} .monaco-list-row.drop-target { background-color: ${u.listDropOverBackground} !important; color: inherit !important; }
			`),u.listDropBetweenBackground&&(a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${y} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`),a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${y} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`)),u.tableColumnsBorder&&a.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${u.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),u.tableOddRowsBackgroundColor&&a.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${u.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=a.join(`
`)}}t.$RT=fe,t.$ST={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:$.$_t.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:$.$_t.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:$.$_t.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const he={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Fe(O,u){const y=O.indexOf(u);if(y===-1)return[];const a=[];let D=y-1;for(;D>=0&&O[D]===u-(y-D);)a.push(O[D--]);for(a.reverse(),D=y;D<O.length&&O[D]===u+(D-y);)a.push(O[D++]);return a}function Z(O,u){const y=[];let a=0,D=0;for(;a<O.length||D<u.length;)if(a>=O.length)y.push(u[D++]);else if(D>=u.length)y.push(O[a++]);else if(O[a]===u[D]){y.push(O[a]),a++,D++;continue}else O[a]<u[D]?y.push(O[a++]):y.push(u[D++]);return y}function pe(O,u){const y=[];let a=0,D=0;for(;a<O.length||D<u.length;)if(a>=O.length)y.push(u[D++]);else if(D>=u.length)y.push(O[a++]);else if(O[a]===u[D]){a++,D++;continue}else O[a]<u[D]?y.push(O[a++]):D++;return y}const Se=(O,u)=>O-u;class Re{constructor(u,y){this.c=u,this.d=y}get templateId(){return this.c}renderTemplate(u){return this.d.map(y=>y.renderTemplate(u))}renderElement(u,y,a,D){let R=0;for(const s of this.d)s.renderElement(u,y,a[R++],D)}disposeElement(u,y,a,D){let R=0;for(const s of this.d)s.disposeElement?.(u,y,a[R],D),R+=1}disposeTemplate(u){let y=0;for(const a of this.d)a.disposeTemplate(u[y++])}}class re{constructor(u){this.c=u,this.templateId="a18n"}renderTemplate(u){return{container:u,disposables:new e.$Tc}}renderElement(u,y,a){const D=this.c.getAriaLabel(u),R=D&&typeof D!="string"?D:(0,b.constObservable)(D);a.disposables.add((0,b.autorun)(k=>{this.d(k.readObservable(R),a.container)}));const s=this.c.getAriaLevel&&this.c.getAriaLevel(u);typeof s=="number"?a.container.setAttribute("aria-level",`${s}`):a.container.removeAttribute("aria-level")}d(u,y){u?y.setAttribute("aria-label",u):y.removeAttribute("aria-label")}disposeElement(u,y,a,D){a.disposables.clear()}disposeTemplate(u){u.disposables.dispose()}}class me{constructor(u,y){this.c=u,this.d=y}getDragElements(u){const y=this.c.getSelectedElements();return y.indexOf(u)>-1?y:[u]}getDragURI(u){return this.d.getDragURI(u)}getDragLabel(u,y){if(this.d.getDragLabel)return this.d.getDragLabel(u,y)}onDragStart(u,y){this.d.onDragStart?.(u,y)}onDragOver(u,y,a,D,R){return this.d.onDragOver(u,y,a,D,R)}onDragLeave(u,y,a,D){this.d.onDragLeave?.(u,y,a,D)}onDragEnd(u){this.d.onDragEnd?.(u)}drop(u,y,a,D,R){this.d.drop(u,y,a,D,R)}dispose(){this.d.dispose()}}class J{get onDidChangeFocus(){return c.Event.map(this.g.wrapEvent(this.c.onChange),u=>this.G(u),this.y)}get onDidChangeSelection(){return c.Event.map(this.g.wrapEvent(this.d.onChange),u=>this.G(u),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let u=!1;const y=c.Event.chain(this.y.add(new C.$oT(this.k.domNode,"keydown")).event,R=>R.map(s=>new B.$hR(s)).filter(s=>u=s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$fS.stop(s,!0)).filter(()=>!1)),a=c.Event.chain(this.y.add(new C.$oT(this.k.domNode,"keyup")).event,R=>R.forEach(()=>u=!1).map(s=>new B.$hR(s)).filter(s=>s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>i.$fS.stop(s,!0)).map(({browserEvent:s})=>{const k=this.getFocus(),T=k.length?k[0]:void 0,L=typeof T<"u"?this.k.element(T):void 0,z=typeof T<"u"?this.k.domElement(T):this.k.domNode;return{index:T,element:L,anchor:z,browserEvent:s}})),D=c.Event.chain(this.k.onContextMenu,R=>R.filter(s=>!u).map(({element:s,index:k,browserEvent:T})=>({element:s,index:k,anchor:new m.$cR((0,i.getWindow)(this.k.domNode),T),browserEvent:T})));return c.Event.any(y,a,D)}get onKeyDown(){return this.y.add(new C.$oT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new C.$oT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new C.$oT(this.k.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.y.add(new C.$oT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.y.add(new C.$oT(this.k.domNode,"blur",!0)).event)}constructor(u,y,a,D,R=he){this.A=u,this.B=R,this.c=new p("focused"),this.f=new p("anchor"),this.g=new c.$pe,this.x="",this.y=new e.$Tc,this.z=new c.$he,this.onDidDispose=this.z.event;const s=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new S(s!=="listbox");const k=[this.c.renderer,this.d.renderer];this.u=R.accessibilityProvider,this.u&&(k.push(new re(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),D=D.map(L=>new Re(L.templateId,[...k,L]));const T={...R,dnd:R.dnd&&new me(this,R.dnd)};if(this.k=this.C(y,a,D,T),this.k.domNode.setAttribute("role",s),R.styleController)this.q=R.styleController(this.k.domId);else{const L=(0,i.$5R)(this.k.domNode);this.q=new fe(L,this.k.domId)}if(this.o=new A.$sT([new F(this.c,this.k,R.identityProvider),new F(this.d,this.k,R.identityProvider),new F(this.f,this.k,R.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new de(this,this.k)),(typeof R.keyboardSupport!="boolean"||R.keyboardSupport)&&(this.v=new ie(this,this.k,R),this.y.add(this.v)),R.keyboardNavigationLabelProvider){const L=R.keyboardNavigationDelegate||t.$NT;this.t=new ee(this,this.k,R.keyboardNavigationLabelProvider,R.keyboardNavigationEventFilter??(()=>!0),L),this.y.add(this.t)}this.w=this.D(R),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(u,y,a,D){return new v.$BT(u,y,a,D)}D(u){return new _(this)}updateOptions(u={}){this.B={...this.B,...u},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(u),this.v?.updateOptions(u),this.k.updateOptions(u)}get options(){return this.B}splice(u,y,a=[]){if(u<0||u>this.k.length)throw new h.$DT(this.A,`Invalid start index: ${u}`);if(y<0)throw new h.$DT(this.A,`Invalid delete count: ${y}`);y===0&&a.length===0||this.g.bufferEvents(()=>this.o.splice(u,y,a))}updateWidth(u){this.k.updateWidth(u)}updateElementHeight(u,y){this.k.updateElementHeight(u,y,null)}rerender(){this.k.rerender()}element(u){return this.k.element(u)}indexOf(u){return this.k.indexOf(u)}indexAt(u){return this.k.indexAt(u)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(u){this.k.setScrollTop(u)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(u){this.k.setScrollLeft(u)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(u){this.x=u,this.k.domNode.setAttribute("aria-label",u)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(u,y){this.k.layout(u,y)}triggerTypeNavigation(){this.t?.trigger()}setSelection(u,y){for(const a of u)if(a<0||a>=this.length)throw new h.$DT(this.A,`Invalid index ${a}`);this.d.set(u,y)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(u=>this.k.element(u))}setAnchor(u){if(typeof u>"u"){this.f.set([]);return}if(u<0||u>=this.length)throw new h.$DT(this.A,`Invalid index ${u}`);this.f.set([u])}getAnchor(){return(0,d.$Ob)(this.f.get(),void 0)}getAnchorElement(){const u=this.getAnchor();return typeof u>"u"?void 0:this.element(u)}setFocus(u,y){for(const a of u)if(a<0||a>=this.length)throw new h.$DT(this.A,`Invalid index ${a}`);this.c.set(u,y)}focusNext(u=1,y=!1,a,D){if(this.length===0)return;const R=this.c.get(),s=this.E(R.length>0?R[0]+u:0,y,D);s>-1&&this.setFocus([s],a)}focusPrevious(u=1,y=!1,a,D){if(this.length===0)return;const R=this.c.get(),s=this.F(R.length>0?R[0]-u:0,y,D);s>-1&&this.setFocus([s],a)}async focusNextPage(u,y){let a=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);a=a===0?0:a-1;const D=this.getFocus()[0];if(D!==a&&(D===void 0||a>D)){const R=this.F(a,!1,y);R>-1&&D!==R?this.setFocus([R],u):this.setFocus([a],u)}else{const R=this.k.getScrollTop();let s=R+this.k.renderHeight;a>D&&(s-=this.k.elementHeight(a)),this.k.setScrollTop(s),this.k.getScrollTop()!==R&&(this.setFocus([]),await(0,g.$Bh)(0),await this.focusNextPage(u,y))}}async focusPreviousPage(u,y,a=()=>0){let D;const R=a(),s=this.k.getScrollTop()+R;s===0?D=this.k.indexAt(s):D=this.k.indexAfter(s-1);const k=this.getFocus()[0];if(k!==D&&(k===void 0||k>=D)){const T=this.E(D,!1,y);T>-1&&k!==T?this.setFocus([T],u):this.setFocus([D],u)}else{const T=s;this.k.setScrollTop(s-this.k.renderHeight-R),this.k.getScrollTop()+a()!==T&&(this.setFocus([]),await(0,g.$Bh)(0),await this.focusPreviousPage(u,y,a))}}focusLast(u,y){if(this.length===0)return;const a=this.F(this.length-1,!1,y);a>-1&&this.setFocus([a],u)}focusFirst(u,y){this.focusNth(0,u,y)}focusNth(u,y,a){if(this.length===0)return;const D=this.E(u,!1,a);D>-1&&this.setFocus([D],y)}E(u,y=!1,a){for(let D=0;D<this.length;D++){if(u>=this.length&&!y)return-1;if(u=u%this.length,!a||a(this.element(u)))return u;u++}return-1}F(u,y=!1,a){for(let D=0;D<this.length;D++){if(u<0&&!y)return-1;if(u=(this.length+u%this.length)%this.length,!a||a(this.element(u)))return u;u--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(u=>this.k.element(u))}reveal(u,y,a=0){if(u<0||u>=this.length)throw new h.$DT(this.A,`Invalid index ${u}`);const D=this.k.getScrollTop(),R=this.k.elementTop(u),s=this.k.elementHeight(u);if((0,f.$eg)(y)){const k=s-this.k.renderHeight+a;this.k.setScrollTop(k*(0,n.$Fm)(y,0,1)+R-a)}else{const k=R+s,T=D+this.k.renderHeight;R<D+a&&k>=T||(R<D+a||k>=T&&s>=this.k.renderHeight?this.k.setScrollTop(R-a):k>=T&&this.k.setScrollTop(k-this.k.renderHeight))}}getRelativeTop(u,y=0){if(u<0||u>=this.length)throw new h.$DT(this.A,`Invalid index ${u}`);const a=this.k.getScrollTop(),D=this.k.elementTop(u),R=this.k.elementHeight(u);if(D<a+y||D+R>a+this.k.renderHeight)return null;const s=R-this.k.renderHeight+y;return Math.abs((a+y-D)/s)}isDOMFocused(){return(0,i.$XR)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(u){return this.k.getElementDomId(u)}getElementTop(u){return this.k.elementTop(u)}style(u){this.q.style(u)}G({indexes:u,browserEvent:y}){return{indexes:u,elements:u.map(a=>this.k.element(a)),browserEvent:y}}H(){const u=this.c.get();this.k.domNode.classList.toggle("element-focused",u.length>0),this.I()}I(){const u=this.c.get();if(u.length>0){let y;this.u?.getActiveDescendantId&&(y=this.u.getActiveDescendantId(this.k.element(u[0]))),this.k.domNode.setAttribute("aria-activedescendant",y||this.k.getElementDomId(u[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const u=this.d.get();this.k.domNode.classList.toggle("selection-none",u.length===0),this.k.domNode.classList.toggle("selection-single",u.length===1),this.k.domNode.classList.toggle("selection-multiple",u.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$TT=J,Je([P.$5h],J.prototype,"onDidChangeFocus",null),Je([P.$5h],J.prototype,"onDidChangeSelection",null),Je([P.$5h],J.prototype,"onContextMenu",null),Je([P.$5h],J.prototype,"onKeyDown",null),Je([P.$5h],J.prototype,"onKeyUp",null),Je([P.$5h],J.prototype,"onKeyPress",null),Je([P.$5h],J.prototype,"onDidFocus",null),Je([P.$5h],J.prototype,"onDidBlur",null)}),define(we[137],ve([1,0,6,62,47,9,16]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xk=t.MarkdownStringTextNewlineStyle=void 0,t.$Yk=g,t.$Zk=$,t.$1k=P,t.$2k=c,t.$3k=l,t.$4k=e,t.$5k=n,t.$6k=o;var A;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class d{constructor(h="",v=!1){if(this.value=h,typeof this.value!="string")throw(0,i.$7)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(h,v=0){return this.value+=c(this.supportThemeIcons?(0,C.$Rk)(h):h).replace(/([ \t]+)/g,(m,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,v){return this.value+=`
${l(v,h)}
`,this}appendLink(h,v,m){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(h),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(h,v){const m=new RegExp((0,U.$df)(v),"g");return h.replace(m,(b,r)=>h.charAt(r-1)!=="\\"?`\\${b}`:b)}}t.$Xk=d;function g(f){return $(f)?!f.value:Array.isArray(f)?f.every(g):!0}function $(f){return f instanceof d?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}function P(f,h){return f===h?!0:!f||!h?!1:f.value===h.value&&f.isTrusted===h.isTrusted&&f.supportThemeIcons===h.supportThemeIcons&&f.supportHtml===h.supportHtml&&(f.baseUri===h.baseUri||!!f.baseUri&&!!h.baseUri&&(0,B.$7g)(E.URI.from(f.baseUri),E.URI.from(h.baseUri)))}function c(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function l(f,h){const v=f.match(/^`+/gm)?.reduce((b,r)=>b.length>r.length?b:r).length??0,m=v>=3?v+1:3;return[`${"`".repeat(m)}${h}`,f,`${"`".repeat(m)}`].join(`
`)}function e(f){return f.replace(/"/g,"&quot;")}function n(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(f){const h=[],v=f.split("|").map(b=>b.trim());f=v[0];const m=v[1];if(m){const b=/height=(\d+)/.exec(m),r=/width=(\d+)/.exec(m),p=b?b[1]:"",S=r?r[1]:"",F=isFinite(parseInt(S)),I=isFinite(parseInt(p));F&&h.push(`width="${S}"`),I&&h.push(`height="${p}"`)}return{href:f,dimensions:h}}}),define(we[138],ve([1,0,4,129,24,66,15,20,130,6,3,137,62,86,23,2,88,64,36,61,47,9,16]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l,e,n,o,f,h,v,m,b,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XT=void 0,t.$WT=S,t.$YT=j,t.$ZT=W,t.$1T=de;const p=Object.freeze({image:(re,me,J)=>{let O=[],u=[];return re&&({href:re,dimensions:O}=(0,P.$6k)(re),u.push(`src="${(0,P.$4k)(re)}"`)),J&&u.push(`alt="${(0,P.$4k)(J)}"`),me&&u.push(`title="${(0,P.$4k)(me)}"`),O.length&&(u=u.concat(O)),"<img "+u.join(" ")+">"},paragraph:re=>`<p>${re}</p>`,link:(re,me,J)=>typeof re!="string"?"":(re===J&&(J=(0,P.$5k)(J)),me=typeof me=="string"?(0,P.$4k)((0,P.$5k)(me)):"",re=(0,P.$5k)(re),re=re.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${re}" title="${me||re}" draggable="false">${J}</a>`)});function S(re,me={},J={}){const O=new n.$Tc;let u=!1;const y=(0,U.$nT)(me),a=function(q){let te;try{te=(0,f.$9h)(decodeURIComponent(q))}catch{}return te?(te=(0,v.$9n)(te,ce=>{if(re.uris&&re.uris[ce])return r.URI.revive(re.uris[ce])}),encodeURIComponent(JSON.stringify(te))):q},D=function(q,te){const ce=re.uris&&re.uris[q];let oe=r.URI.revive(ce);return te?q.startsWith(h.Schemas.data+":")?q:(oe||(oe=r.URI.parse(q)),h.$Ug.uriToBrowserUri(oe).toString(!0)):!oe||r.URI.parse(q).toString()===oe.toString()?q:(oe.query&&(oe=oe.with({query:a(oe.query)})),oe.toString())},R=new o.marked.Renderer;R.image=p.image,R.link=p.link,R.paragraph=p.paragraph;const s=[],k=[];if(me.codeBlockRendererSync?R.code=(q,te)=>{const ce=l.$XO.nextId(),oe=me.codeBlockRendererSync(F(te),q);return k.push([ce,oe]),`<div class="code" data-code="${ce}">${(0,b.$cf)(q)}</div>`}:me.codeBlockRenderer&&(R.code=(q,te)=>{const ce=l.$XO.nextId(),oe=me.codeBlockRenderer(F(te),q);return s.push(oe.then(Te=>[ce,Te])),`<div class="code" data-code="${ce}">${(0,b.$cf)(q)}</div>`}),me.actionHandler){const q=function(oe){let Te=oe.target;if(!(Te.tagName!=="A"&&(Te=Te.parentElement,!Te||Te.tagName!=="A")))try{let ke=Te.dataset.href;ke&&(re.baseUri&&(ke=I(r.URI.from(re.baseUri),ke)),me.actionHandler.callback(ke,oe))}catch(ke){(0,g.$1)(ke)}finally{oe.preventDefault()}},te=me.actionHandler.disposables.add(new B.$oT(y,"click")),ce=me.actionHandler.disposables.add(new B.$oT(y,"auxclick"));me.actionHandler.disposables.add($.Event.any(te.event,ce.event)(oe=>{const Te=new A.$cR(i.getWindow(y),oe);!Te.leftButton&&!Te.middleButton||q(Te)})),me.actionHandler.disposables.add(i.$kR(y,"keydown",oe=>{const Te=new E.$hR(oe);!Te.equals(10)&&!Te.equals(3)||q(Te)}))}re.supportHtml||(J.sanitizer=q=>(re.isTrusted?q.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?q:"",J.sanitize=!0,J.silent=!0),J.renderer=R;let T=re.value??"";T.length>1e5&&(T=`${T.substr(0,1e5)}\u2026`),re.supportThemeIcons&&(T=(0,c.$Sk)(T));let L;if(me.fillInIncompleteTokens){const q={...o.marked.defaults,...J},te=o.marked.lexer(T,q),ce=de(te);L=o.marked.parser(ce,q)}else L=o.marked.parse(T,J);re.supportThemeIcons&&(L=(0,d.$UT)(L).map(te=>typeof te=="string"?te:te.outerHTML).join(""));const Y=new DOMParser().parseFromString(H(re,L),"text/html");if(Y.body.querySelectorAll("img, audio, video, source").forEach(q=>{const te=q.getAttribute("src");if(te){let ce=te;try{re.baseUri&&(ce=I(r.URI.from(re.baseUri),ce))}catch{}if(q.setAttribute("src",D(ce,!0)),me.remoteImageIsAllowed){const oe=r.URI.parse(ce);oe.scheme!==h.Schemas.file&&oe.scheme!==h.Schemas.data&&!me.remoteImageIsAllowed(oe)&&q.replaceWith(i.$("",void 0,q.outerHTML))}}}),Y.body.querySelectorAll("a").forEach(q=>{const te=q.getAttribute("href");if(q.setAttribute("href",""),!te||/^data:|javascript:/i.test(te)||/^command:/i.test(te)&&!re.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(te))q.replaceWith(...q.childNodes);else{let ce=D(te,!1);re.baseUri&&(ce=I(r.URI.from(re.baseUri),te)),q.dataset.href=ce}}),y.innerHTML=H(re,Y.body.innerHTML),s.length>0)Promise.all(s).then(q=>{if(u)return;const te=new Map(q),ce=y.querySelectorAll("div[data-code]");for(const oe of ce){const Te=te.get(oe.dataset.code??"");Te&&i.$mS(oe,Te)}me.asyncRenderCallback?.()});else if(k.length>0){const q=new Map(k),te=y.querySelectorAll("div[data-code]");for(const ce of te){const oe=q.get(ce.dataset.code??"");oe&&i.$mS(ce,oe)}}if(me.asyncRenderCallback)for(const q of y.getElementsByTagName("img")){const te=O.add(i.$kR(q,"load",()=>{te.dispose(),me.asyncRenderCallback()}))}return{element:y,dispose:()=>{u=!0,O.dispose()}}}function F(re){if(!re)return"";const me=re.split(/[\s+|:|,|\{|\?]/,1);return me.length?me[0]:re}function I(re,me){return/^\w[\w\d+.-]*:/.test(me)?me:re.path.endsWith("/")?(0,m.$eh)(re,me).toString():(0,m.$eh)((0,m.$ah)(re),me).toString()}function H(re,me){const{config:J,allowedSchemes:O}=w(re);C.addHook("uponSanitizeAttribute",(y,a)=>{if(a.attrName==="style"||a.attrName==="class"){if(y.tagName==="SPAN"){if(a.attrName==="style"){a.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(a.attrValue);return}else if(a.attrName==="class"){a.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(a.attrValue);return}}a.keepAttr=!1;return}else if(y.tagName==="INPUT"&&y.attributes.getNamedItem("type")?.value==="checkbox"){if(a.attrName==="type"&&a.attrValue==="checkbox"||a.attrName==="disabled"||a.attrName==="checked"){a.keepAttr=!0;return}a.keepAttr=!1}}),C.addHook("uponSanitizeElement",(y,a)=>{a.tagName==="input"&&(y.attributes.getNamedItem("type")?.value==="checkbox"?y.setAttribute("disabled",""):y.parentElement?.removeChild(y))});const u=i.$GS(O);try{return C.sanitize(me,{...J,RETURN_TRUSTED_TYPE:!0})}finally{C.removeHook("uponSanitizeAttribute"),u.dispose()}}t.$XT=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function w(re){const me=[h.Schemas.http,h.Schemas.https,h.Schemas.mailto,h.Schemas.data,h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemote,h.Schemas.vscodeRemoteResource];return re.isTrusted&&me.push(h.Schemas.command),{config:{ALLOWED_TAGS:[...i.$HS],ALLOWED_ATTR:t.$XT,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:me}}function j(re){return typeof re=="string"?re:W(re)}function W(re){let me=re.value??"";me.length>1e5&&(me=`${me.substr(0,1e5)}\u2026`);const J=o.marked.parse(me,{renderer:x.value}).replace(/&(#\d+|[a-zA-Z]+);/g,O=>N.get(O)??O);return H({isTrusted:!1},J).toString()}const N=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),x=new e.$V(()=>{const re=new o.marked.Renderer;return re.code=me=>me,re.blockquote=me=>me,re.html=me=>"",re.heading=(me,J,O)=>me+`
`,re.hr=()=>"",re.list=(me,J)=>me,re.listitem=me=>me+`
`,re.paragraph=me=>me+`
`,re.table=(me,J)=>me+J+`
`,re.tablerow=me=>me,re.tablecell=(me,J)=>me+" ",re.strong=me=>me,re.em=me=>me,re.codespan=me=>me,re.br=()=>`
`,re.del=me=>me,re.image=(me,J,O)=>"",re.text=me=>me,re.link=(me,J,O)=>O,re});function M(re){let me="";return re.forEach(J=>{me+=J.raw}),me}function Q(re){if(re.tokens)for(let me=re.tokens.length-1;me>=0;me--){const J=re.tokens[me];if(J.type==="text"){const O=J.raw.split(`
`),u=O[O.length-1];if(u.includes("`"))return je(re);if(u.includes("**"))return Z(re);if(u.match(/\*\w/))return le(re);if(u.match(/(^|\s)__\w/))return pe(re);if(u.match(/(^|\s)_\w/))return _(re);if(ie(u)||ue(u)&&re.tokens.slice(0,me).some(y=>y.type==="text"&&y.raw.match(/\[[^\]]*$/))){const y=re.tokens.slice(me+1);return y[0]?.type==="link"&&y[1]?.type==="text"&&y[1].raw.match(/^ *"[^"]*$/)||u.match(/^[^"]* +"[^"]*$/)?he(re):fe(re)}else if(u.match(/(^|\s)\[\w*/))return Fe(re)}}}function ie(re){return!!re.match(/(^|\s)\[.*\]\(\w*/)}function ue(re){return!!re.match(/^[^\[]*\]\([^\)]*$/)}function G(re){const me=re.items[re.items.length-1],J=me.tokens?me.tokens[me.tokens.length-1]:void 0;let O;if(J?.type==="text"&&!("inRawBlock"in me)&&(O=Q(J)),!O||O.type!=="paragraph")return;const u=M(re.items.slice(0,-1)),y=me.raw.slice(0,2)+M(me.tokens.slice(0,-1))+O.raw,a=o.marked.lexer(u+y)[0];if(a.type==="list")return a}const ee=3;function de(re){for(let me=0;me<ee;me++){const J=ye(re);if(J)re=J;else break}return re}function ye(re){let me,J;for(me=0;me<re.length;me++){const O=re[me];let u;if(O.type==="paragraph"&&(u=O.raw.match(/(\n|^)(````*)/))){const y=u[2];J=Ae(re.slice(me),y);break}if(O.type==="paragraph"&&O.raw.match(/(\n|^)\|/)){J=Re(re.slice(me));break}if(me===re.length-1&&O.type==="list"){const y=G(O);if(y){J=[y];break}}if(me===re.length-1&&O.type==="paragraph"){const y=Q(O);if(y){J=[y];break}}}if(J){const O=[...re.slice(0,me),...J];return O.links=re.links,O}return null}function Ae(re,me){const J=M(re);return o.marked.lexer(J+`
${me}`)}function je(re){return Se(re,"`")}function le(re){return Se(re,"*")}function _(re){return Se(re,"_")}function fe(re){return Se(re,")")}function he(re){return Se(re,'")')}function Fe(re){return Se(re,"](https://microsoft.com)")}function Z(re){return Se(re,"**")}function pe(re){return Se(re,"__")}function Se(re,me){const J=M(Array.isArray(re)?re:[re]);return o.marked.lexer(J+me)[0]}function Re(re){const me=M(re),J=me.split(`
`);let O,u=!1;for(let y=0;y<J.length;y++){const a=J[y].trim();if(typeof O>"u"&&a.match(/^\s*\|/)){const D=a.match(/(\|[^\|]+)(?=\||$)/g);D&&(O=D.length)}else if(typeof O=="number")if(a.match(/^\s*\|/)){if(y!==J.length-1)return;u=!0}else return}if(typeof O=="number"&&O>0){const y=u?J.slice(0,-1).join(`
`):me,a=!!y.match(/\|\s*$/),D=y+(a?"":"|")+`
|${" --- |".repeat(O)}`;return o.marked.lexer(D)}}}),define(we[139],ve([1,0,4,24,15,138,29,14,49,8,3,54,2,5,121,113]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4T=void 0;const n=i.$,o="selectOption.entry.template";class f{get templateId(){return o}renderTemplate(m){const b=Object.create(null);return b.root=m,b.text=i.$kS(m,n(".option-text")),b.detail=i.$kS(m,n(".option-detail")),b.decoratorRight=i.$kS(m,n(".option-decorator-right")),b}renderElement(m,b,r){const p=r,S=m.text,F=m.detail,I=m.decoratorRight,H=m.isDisabled;p.text.textContent=S,p.detail.textContent=F||"",p.decoratorRight.innerText=I||"",H?p.root.classList.add("option-disabled"):p.root.classList.remove("option-disabled")}disposeTemplate(m){}}class h extends c.$Uc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(m,b,r,p,S){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=p,this.g=S||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=h.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new $.$he,this.B(this.r),this.Q(),this.P(r),this.n=b||0,m&&this.setOptions(m,b),this.S()}O(m){!this.M&&m?this.M=this.B((0,E.$3T)().setupUpdatableHover((0,A.$eT)("mouse"),this.h,m)):this.M&&this.M.update(m)}getHeight(){return 22}getTemplateId(){return o}P(m){this.u=m,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$kS(this.w,n(".select-box-details-pane"));const b=i.$kS(this.w,n(".select-box-dropdown-container-width-control")),r=i.$kS(b,n(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$kS(r,this.D),this.G=0,this.y=i.$5R(this.w),this.w.setAttribute("draggable","true"),this.B(i.$kR(this.w,i.$dS.DRAG_START,p=>{i.$fS.stop(p,!0)}))}Q(){this.B(i.$lR(this.h,"change",b=>{this.n=b.target.selectedIndex,this.r.fire({index:b.target.selectedIndex,selected:b.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$kR(this.h,i.$dS.CLICK,b=>{i.$fS.stop(b),this.f?this.Z(!0):this.Y()})),this.B(i.$kR(this.h,i.$dS.MOUSE_DOWN,b=>{i.$fS.stop(b)}));let m;this.B(i.$kR(this.h,"touchstart",b=>{m=this.f})),this.B(i.$kR(this.h,"touchend",b=>{i.$fS.stop(b),m?this.Z(!0):this.Y()})),this.B(i.$kR(this.h,i.$dS.KEY_DOWN,b=>{const r=new B.$hR(b);let p=!1;l.$j?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(p=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(p=!0),p&&(this.Y(),i.$fS.stop(b,!0))}))}get onDidSelect(){return this.r.event}setOptions(m,b){g.$ub(this.m,m)||(this.m=m,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((r,p)=>{this.h.add(this.X(r.text,p,r.isDisabled)),typeof r.description=="string"&&(this.H=!0)})),b!==void 0&&(this.select(b),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(m){m>=0&&m<this.m.length?this.n=m:m>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(m){this.g.ariaLabel=m,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(m){this.h.tabIndex=m?0:-1}render(m){this.j=m,m.classList.add("select-container"),m.appendChild(this.h),this.U()}S(){const m=[];this.s.listFocusBackground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(m.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),m.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),m.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=m.join(`
`)}U(){const m=this.s.selectBackground??"",b=this.s.selectForeground??"",r=this.s.selectBorder??"";this.h.style.backgroundColor=m,this.h.style.color=b,this.h.style.borderColor=r}W(){const m=this.s.selectBackground??"",b=i.$CS(this.s.selectListBackground,m);this.C.style.backgroundColor=b,this.I.style.backgroundColor=b;const r=this.s.focusBorder??"";this.w.style.outlineColor=r,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(m,b,r){const p=document.createElement("option");return p.value=m,p.text=m,p.disabled=!!r,p}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:m=>this.ab(m,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:m=>this.ab(m),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(m){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),m&&this.h.focus(),this.u.hideContextView())}ab(m,b){return m.appendChild(this.w),this.cb(b),{dispose:()=>{try{m.removeChild(this.w)}catch{}}}}bb(){let m=0;return this.m.forEach((b,r)=>{this.jb(r),this.I.offsetHeight>m&&(m=this.I.offsetHeight)}),m}cb(m){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const b=i.getWindow(this.h),r=i.$GR(this.h),p=i.getWindow(this.h).getComputedStyle(this.h),S=parseFloat(p.getPropertyValue("--dropdown-padding-top"))+parseFloat(p.getPropertyValue("--dropdown-padding-bottom")),F=b.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),I=r.top-h.b,H=this.h.offsetWidth,w=this.db(this.D),j=Math.max(w,Math.round(H)).toString()+"px";this.w.style.width=j,this.z.getHTMLElement().style.height="",this.z.layout();let W=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const N=this.H?this.L:0,x=W+S+N,M=Math.floor((F-S-N)/this.getHeight()),Q=Math.floor((I-S-N)/this.getHeight());if(m)return r.top+r.height>b.innerHeight-22||r.top<h.b||M<1&&Q<1?!1:(M<h.c&&Q>M&&this.m.length>M?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>b.innerHeight-22||r.top<h.b||this.G===0&&M<1||this.G===1&&Q<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&M+Q<1)return this.Z(!0),!1;x>F&&(W=M*this.getHeight())}else x>I&&(W=Q*this.getHeight());return this.z.layout(W),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=W+S+"px",this.w.style.height=""):this.w.style.height=W+S+"px",this.jb(this.n),this.w.style.width=j,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(m){let b=0;if(m){let r=0,p=0;this.m.forEach((S,F)=>{const I=S.detail?S.detail.length:0,H=S.decoratorRight?S.decoratorRight.length:0,w=S.text.length+I+H;w>p&&(r=F,p=w)}),m.textContent=this.m[r].text+(this.m[r].decoratorRight?this.m[r].decoratorRight+" ":""),b=i.$IR(m)}return b}eb(m){if(this.z)return;this.C=i.$kS(m,n(".select-box-dropdown-list-container")),this.t=new f,this.z=new d.$TT("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:p=>{let S=p.text;return p.detail&&(S+=`. ${p.detail}`),p.decoratorRight&&(S+=`. ${p.decoratorRight}`),p.description&&(S+=`. ${p.description}`),S},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>l.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const b=this.B(new C.$oT(this.C,"keydown")),r=$.Event.chain(b.event,p=>p.filter(()=>this.z.length>0).map(S=>new B.$hR(S)));this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode===3))(this.lb,this)),this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode===2))(this.lb,this)),this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode===9))(this.kb,this)),this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode===16))(this.nb,this)),this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode===18))(this.mb,this)),this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode===12))(this.pb,this)),this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode===11))(this.ob,this)),this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode===14))(this.qb,this)),this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode===13))(this.rb,this)),this.B($.Event.chain(r,p=>p.filter(S=>S.keyCode>=21&&S.keyCode<=56||S.keyCode>=85&&S.keyCode<=113))(this.sb,this)),this.B(i.$kR(this.z.getHTMLElement(),i.$dS.POINTER_UP,p=>this.fb(p))),this.B(this.z.onMouseOver(p=>typeof p.index<"u"&&this.z.setFocus([p.index]))),this.B(this.z.onDidChangeFocus(p=>this.ib(p))),this.B(i.$kR(this.w,i.$dS.FOCUS_OUT,p=>{!this.f||i.$OR(p.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(m){if(!this.z.length)return;i.$fS.stop(m);const b=m.target;if(!b||b.classList.contains("slider"))return;const r=b.closest(".monaco-list-row");if(!r)return;const p=Number(r.getAttribute("data-index")),S=r.classList.contains("option-disabled");p>=0&&p<this.m.length&&!S&&(this.n=p,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(m,b){const r=S=>{for(let F=0;F<S.childNodes.length;F++){const I=S.childNodes.item(F);(I.tagName&&I.tagName.toLowerCase())==="img"?S.removeChild(I):r(I)}},p=(0,U.$WT)({value:m,supportThemeIcons:!0},{actionHandler:b});return p.element.classList.add("select-box-description-markdown"),r(p.element),p.element}ib(m){!this.f||!this.H||this.jb(m.indexes[0])}jb(m){this.I.innerText="";const b=this.m[m],r=b?.description??"",p=b?.descriptionIsMarkdown??!1;if(r){if(p){const S=b.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(r,S))}else this.I.innerText=r;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(m){i.$fS.stop(m),this.select(this.F),this.Z(!0)}lb(m){i.$fS.stop(m),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(m){if(this.n<this.m.length-1){i.$fS.stop(m,!0);const b=this.m[this.n+1].isDisabled;if(b&&this.m.length>this.n+2)this.n+=2;else{if(b)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(m){this.n>0&&(i.$fS.stop(m,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(m){i.$fS.stop(m),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(m){i.$fS.stop(m),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(m){i.$fS.stop(m),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(m){i.$fS.stop(m),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(m){const b=P.KeyCodeUtils.toString(m.keyCode);let r=-1;for(let p=0;p<this.m.length-1;p++)if(r=(p+this.n+1)%this.m.length,this.m[r].text.charAt(0).toUpperCase()===b&&!this.m[r].isDisabled){this.select(r),this.z.setFocus([r]),this.z.reveal(this.z.getFocus()[0]),i.$fS.stop(m);break}}dispose(){this.Z(!1),super.dispose()}}t.$4T=h}),define(we[140],ve([1,0,49,139,133,21,5,112]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7T=t.$6T=void 0,t.$6T={...i.$ST,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends U.$XS{constructor(g,$,P,c,l){super(),E.$j&&!l?.useCustomDrawn?this.a=new B.$5T(g,$,c,l):this.a=new C.$4T(g,$,P,c,l),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(g,$){this.a.setOptions(g,$)}select(g){this.a.select(g)}setAriaLabel(g){this.a.setAriaLabel(g)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(g){this.a.setFocusable(g)}render(g){this.a.render(g)}}t.$7T=A}),define(we[73],ve([1,0,17,65,4,28,14,140,46,2,5,10,117,29,63]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cU=t.$bU=t.$aU=void 0;class e extends g.$Uc{get action(){return this._action}constructor(h,v,m={}){super(),this.m=m,this._context=h||this,this._action=v,v instanceof d.$fj&&this.B(v.onDidChange(b=>{this.element&&this.t(b)}))}t(h){h.enabled!==void 0&&this.u(),h.checked!==void 0&&this.H(),h.class!==void 0&&this.G(),h.label!==void 0&&(this.w(),this.D()),h.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new d.$gj)),this.j}set actionRunner(h){this.j=h}isEnabled(){return this._action.enabled}setActionContext(h){this._context=h}render(h){const v=this.element=h;this.B(U.$TS.addTarget(h));const m=this.m&&this.m.draggable;m&&(h.draggable=!0,i.$3Q&&this.B((0,B.$kR)(h,B.$dS.DRAG_START,b=>b.dataTransfer?.setData(C.$RS.TEXT,this._action.label)))),this.B((0,B.$kR)(v,U.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,B.$kR)(v,B.$dS.MOUSE_DOWN,b=>{m||B.$fS.stop(b,!0),this._action.enabled&&b.button===0&&v.classList.add("active")})),$.$j&&this.B((0,B.$kR)(v,B.$dS.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,B.$kR)(v,B.$dS.CLICK,b=>{B.$fS.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,B.$kR)(v,B.$dS.DBLCLICK,b=>{B.$fS.stop(b,!0)})),[B.$dS.MOUSE_UP,B.$dS.MOUSE_OUT].forEach(b=>{this.B((0,B.$kR)(v,b,r=>{B.$fS.stop(r),v.classList.remove("active")}))})}onClick(h,v=!1){B.$fS.stop(h,!0);const m=P.$jg(this._context)?this.m?.useEventAsContext?h:{preserveFocus:v}:this._context;this.actionRunner.run(this._action,m)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(h){this.element&&(this.element.tabIndex=h?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const h=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=h;else if(!this.f&&h!==""){const v=this.m.hoverDelegate??(0,E.$eT)("element");this.f=this.q.add((0,l.$3T)().setupUpdatableHover(v,this.element,h))}else this.f&&this.f.update(h)}F(){if(this.element){const h=this.C()??"";this.element.setAttribute("aria-label",h)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$aU=e;class n extends e{constructor(h,v,m){super(h,v,m),this.m=m,this.m.icon=m.icon!==void 0?m.icon:!1,this.m.label=m.label!==void 0?m.label:!0,this.L=""}render(h){super.render(h),P.$kg(this.element);const v=document.createElement("a");if(v.classList.add("action-label"),v.setAttribute("role",this.M()),this.I=v,this.element.appendChild(v),this.m.label&&this.m.keybinding){const m=document.createElement("span");m.classList.add("keybinding"),m.textContent=this.m.keybinding,this.element.appendChild(m)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===d.$hj.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(h){this.I&&(this.I.tabIndex=h?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let h=null;return this.action.tooltip?h=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(h=this.action.label,this.m.keybinding&&(h=c.localize(0,null,h,this.m.keybinding))),h??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const h=this.C()??"";this.I.setAttribute("aria-label",h)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$bU=n;class o extends e{constructor(h,v,m,b,r,p,S){super(h,v),this.b=new A.$7T(m,b,r,p,S),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(h,v){this.b.setOptions(h,v)}select(h){this.b.select(h)}g(){this.B(this.b.onDidSelect(h=>this.n(h.selected,h.index)))}n(h,v){this.actionRunner.run(this._action,this.r(h,v))}r(h,v){return h}setFocusable(h){this.b.setFocusable(h)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(h){this.b.render(h)}}t.$cU=o}),define(we[74],ve([1,0,4,15,73,14,46,3,2,10,63]),function(se,t,i,C,B,U,E,A,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gT=t.ActionsOrientation=void 0,t.$hT=c;var $;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})($||(t.ActionsOrientation=$={}));class P extends d.$Uc{constructor(e,n={}){super(),this.j=this.B(new d.$Tc),this.s=this.B(new d.$4c),this.y=!1,this.z=!0,this.D=this.B(new A.$he),this.onDidBlur=this.D.event,this.F=this.B(new A.$he({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new A.$he),this.onDidRun=this.H.event,this.I=this.B(new A.$he),this.onWillRun=this.I.event,this.b=n,this.m=n.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=n.hoverDelegate??this.B((0,U.$fT)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new E.$gj,this.j.add(this.g)),this.j.add(this.g.onDidRun(h=>this.H.fire(h))),this.j.add(this.g.onWillRun(h=>this.I.fire(h))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let o,f;switch(this.n){case 0:o=[15],f=[17];break;case 1:o=[16],f=[18],this.domNode.className+=" vertical";break}this.B(i.$kR(this.domNode,i.$dS.KEY_DOWN,h=>{const v=new C.$hR(h);let m=!0;const b=typeof this.u=="number"?this.viewItems[this.u]:void 0;o&&(v.equals(o[0])||v.equals(o[1]))?m=this.Q():f&&(v.equals(f[0])||v.equals(f[1]))?m=this.P():v.equals(9)&&this.G?this.F.fire():v.equals(14)?m=this.N():v.equals(13)?m=this.O():v.equals(2)&&b instanceof B.$aU&&b.trapsArrowNavigation?m=this.P():this.L(v)?this.r.keyDown?this.S(v):this.y=!0:m=!1,m&&(v.preventDefault(),v.stopPropagation())})),this.B(i.$kR(this.domNode,i.$dS.KEY_UP,h=>{const v=new C.$hR(h);this.L(v)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(v)),v.preventDefault(),v.stopPropagation()):(v.equals(2)||v.equals(1026)||v.equals(16)||v.equals(18)||v.equals(15)||v.equals(17))&&this.M()})),this.w=this.B(i.$iS(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$WR()===this.domNode||!i.$OR(i.$WR(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const n=this.viewItems.find(o=>o instanceof B.$aU&&o.isEnabled());n instanceof B.$aU&&n.setFocusable(!0)}else this.viewItems.forEach(n=>{n instanceof B.$aU&&n.setFocusable(!1)})}L(e){let n=!1;return this.r.keys.forEach(o=>{n=n||e.equals(o)}),n}M(){for(let e=0;e<this.C.children.length;e++){const n=this.C.children[e];if(i.$OR(i.$WR(),n)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(n=>n.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(n=>this.H.fire(n))),this.j.add(this.g.onWillRun(n=>this.I.fire(n))),this.viewItems.forEach(n=>n.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(n=>n.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let n=0;n<this.C.childNodes.length;n++)if(this.C.childNodes[n]===e)return this.viewItems[n].action}}push(e,n={}){const o=Array.isArray(e)?e:[e];let f=g.$eg(n.index)?n.index:null;o.forEach(h=>{const v=document.createElement("li");v.className="action-item",v.setAttribute("role","presentation");let m;const b={hoverDelegate:this.f,...n};this.b.actionViewItemProvider&&(m=this.b.actionViewItemProvider(h,b)),m||(m=new B.$bU(this.context,h,b)),this.b.allowContextMenu||this.s.set(m,i.$kR(v,i.$dS.CONTEXT_MENU,r=>{i.$fS.stop(r,!0)})),m.actionRunner=this.g,m.setActionContext(this.context),m.render(v),this.z&&m instanceof B.$aU&&this.viewItems.length===0&&m.setFocusable(!0),f===null||f<0||f>=this.C.children.length?(this.C.appendChild(v),this.viewItems.push(m)):(this.C.insertBefore(v,this.C.children[f]),this.viewItems.splice(f,0,m),f++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const n=this.C.children.item(e);if(n)return n.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,d.$Pc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,d.$Pc)(this.viewItems),this.s.clearAndDisposeAll(),i.$jR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let n=!1,o;if(e===void 0?n=!0:typeof e=="number"?o=e:typeof e=="boolean"&&(n=e),n&&typeof this.u>"u"){const f=this.viewItems.findIndex(h=>h.isEnabled());this.u=f===-1?void 0:f,this.R(void 0,void 0,!0)}else o!==void 0&&(this.u=o),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const n=this.u;let o;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=n,!1;this.u=(this.u+1)%this.viewItems.length,o=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===E.$hj.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const n=this.u;let o;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=n,!1;this.u=this.viewItems.length-1}o=this.viewItems[this.u]}while(this.u!==n&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===E.$hj.ID));return this.R(!0),!0}R(e,n,o=!1){typeof this.u>"u"&&this.C.focus({preventScroll:n}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const f=this.u!==void 0?this.viewItems[this.u]:void 0;if(f){let h=!0;g.$og(f.focus)||(h=!1),this.b.focusOnlyEnabledItems&&g.$og(f.isEnabled)&&!f.isEnabled()&&(h=!1),f.action.id===E.$hj.ID&&(h=!1),h?(o||this.t!==this.u)&&(f.focus(e),this.t=this.u):(this.C.focus({preventScroll:n}),this.t=void 0),h&&f.showHover?.()}}S(e){if(typeof this.u>"u")return;const n=this.viewItems[this.u];if(n instanceof B.$aU){const o=n._context===null||n._context===void 0?e:n._context;this.run(n._action,o)}}async run(e,n){await this.g.run(e,n)}dispose(){this.m=void 0,this.viewItems=(0,d.$Pc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$gT=P;function c(l){if(!l.length)return l;let e=-1;for(let o=0;o<l.length;o++)if(l[o].id!==E.$hj.ID){e=o;break}if(e===-1)return[];l=l.slice(e);for(let o=l.length-1;o>=0&&l[o].id===E.$hj.ID;o--)l.splice(o,1);let n=!1;for(let o=l.length-1;o>=0;o--){const f=l[o].id===E.$hj.ID;f&&!n?l.splice(o,1):f?f&&(n=!1):n=!0}return l}}),define(we[75],ve([1,0,4,24,66,74,68,29,14,71,21,3,91,61,120,109]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VU=t.$UU=t.$TU=t.MessageType=void 0;const n=i.$;var o;(function(v){v[v.INFO=1]="INFO",v[v.WARNING=2]="WARNING",v[v.ERROR=3]="ERROR"})(o||(t.MessageType=o={})),t.$TU={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class f extends $.$XS{constructor(m,b,r){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new P.$he),this.onDidChange=this.P.event,this.Q=this.B(new P.$he),this.onDidHeightChange=this.Q.event,this.a=b,this.g=r,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$kS(m,n(".monaco-inputbox.idle"));const p=this.g.flexibleHeight?"textarea":"input",S=i.$kS(this.element,n(".ibwrapper"));if(this.b=i.$kS(S,n(p+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$kS(S,n("div.mirror")),this.y.innerText="\xA0",this.N=new g.$8S(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$kS(m,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(H=>this.b.scrollTop=H.scrollTop));const F=this.B(new C.$oT(m.ownerDocument,"selectionchange")),I=P.Event.filter(F.event,()=>m.ownerDocument.getSelection()?.anchorNode===S);this.B(I(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new U.$gT(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(m){this.n=m,this.b.setAttribute("placeholder",m)}setTooltip(m){this.r=m,this.O?this.O.update(m):this.O=this.B((0,A.$3T)().setupUpdatableHover((0,d.$eT)("mouse"),this.b,m))}setAriaLabel(m){this.s=m,m?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(m){this.b.value!==m&&(this.b.value=m,this.Z())}get step(){return this.b.step}set step(m){this.b.step=m}get height(){return typeof this.J=="number"?this.J:i.$MR(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$XR(this.b)}select(m=null){this.b.select(),m&&(this.b.setSelectionRange(m.start,m.end),m.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const m=this.b.selectionStart;if(m===null)return null;const b=this.b.selectionEnd??m;return{start:m,end:b}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(m){m?this.enable():this.disable()}get width(){return i.$IR(this.b)}set width(m){if(this.g.flexibleHeight&&this.g.flexibleWidth){let b=0;if(this.y){const r=parseFloat(this.y.style.paddingLeft||"")||0,p=parseFloat(this.y.style.paddingRight||"")||0;b=r+p}this.b.style.width=m-b+"px"}else this.b.style.width=m+"px";this.y&&(this.y.style.width=m+"px")}set paddingRight(m){this.b.style.width=`calc(100% - ${m}px)`,this.y&&(this.y.style.paddingRight=m+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const m=this.L,b=this.J,r=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:m,height:b}),this.N.setScrollPosition({scrollTop:r})}showMessage(m,b){if(this.w==="open"&&(0,l.$$n)(this.h,m))return;this.h=m,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(m.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$CS(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||b)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let m=null;return this.t&&(m=this.t(this.value),m?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(m)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),m?.type}stylesForType(m){const b=this.g.inputBoxStyles;switch(m){case 1:return{border:b.inputValidationInfoBorder,background:b.inputValidationInfoBackground,foreground:b.inputValidationInfoForeground};case 2:return{border:b.inputValidationWarningBorder,background:b.inputValidationWarningBackground,foreground:b.inputValidationWarningForeground};default:return{border:b.inputValidationErrorBorder,background:b.inputValidationErrorBackground,foreground:b.inputValidationErrorForeground}}}W(m){switch(m){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let m;const b=()=>m.style.width=i.$IR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:p=>{if(!this.h)return null;m=i.$kS(p,n(".monaco-inputbox-container")),b();const S={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,B.$mT)(this.h.content,S):(0,B.$lT)(this.h.content,S);F.classList.add(this.W(this.h.type));const I=this.stylesForType(this.h.type);return F.style.backgroundColor=I.background??"",F.style.color=I.foreground??"",F.style.border=I.border?`1px solid ${I.border}`:"",i.$kS(m,F),null},onHide:()=>{this.w="closed"},layout:b});let r;this.h.type===3?r=e.localize(0,null,this.h.content):this.h.type===2?r=e.localize(1,null,this.h.content):r=e.localize(2,null,this.h.content),E.$qT(r),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const m=this.value,r=m.charCodeAt(m.length-1)===10?" ":"";(m+r).replace(/\u000c/g,"")?this.y.textContent=m+r:this.y.innerText="\xA0",this.layout()}bb(){const m=this.g.inputBoxStyles,b=m.inputBackground??"",r=m.inputForeground??"",p=m.inputBorder??"";this.element.style.backgroundColor=b,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${i.$CS(p,"transparent")}`}layout(){if(!this.y)return;const m=this.L;this.L=i.$MR(this.y),m!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(m){const b=this.inputElement,r=b.selectionStart,p=b.selectionEnd,S=b.value;r!==null&&p!==null&&(this.value=S.substr(0,r)+m+S.substr(p),b.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$UU=f;class h extends f{constructor(m,b,r){const p=e.localize(3,null,"\u21C5"),S=e.localize(4,null,"\u21C5");super(m,b,r),this.eb=this.B(new P.$he),this.onDidFocus=this.eb.event,this.fb=this.B(new P.$he),this.onDidBlur=this.fb.event,this.cb=new c.$RU(r.history,100);const F=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.n.endsWith(p)&&!this.n.endsWith(S)&&this.cb.getHistory().length){const I=this.n.endsWith(")")?p:S,H=this.n+I;r.showPlaceholderOnFocus&&!i.$XR(this.b)?this.n=H:this.setPlaceHolder(H)}};this.db=new MutationObserver((I,H)=>{I.forEach(w=>{w.target.textContent||F()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>F()),this.F(this.b,()=>{const I=H=>{if(this.n.endsWith(H)){const w=this.n.slice(0,this.n.length-H.length);return r.showPlaceholderOnFocus?this.n=w:this.setPlaceHolder(w),!0}else return!1};I(S)||I(p)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(m){this.value&&(m||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(m){const b=this.getHistory();this.clearHistory(),m.forEach(r=>{this.cb.add(r)}),b.forEach(r=>{this.cb.add(r)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let m=this.kb();m&&(m=m===this.value?this.kb():m),this.value=m??"",E.$rT(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let m=this.jb();m&&(m=m===this.value?this.jb():m),m&&(this.value=m,E.$rT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(m){super.setPlaceHolder(m),this.setTooltip(m)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let m=this.cb.current();return m||(m=this.cb.last(),this.cb.next()),m}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$VU=h}),define(we[76],ve([1,0,73,21,18,19,3,4,14,29,114]),function(se,t,i,C,B,U,E,A,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_T=t.$$T=t.$0T=t.$9T=t.$8T=void 0,t.$8T={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class $ extends i.$aU{constructor(n,o,f){super(n,o,f),this.a=this.B(new P({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:f.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:f.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:f.toggleStyles?.inputActiveOptionForeground,hoverDelegate:f.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(n){this.element=n,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$9T=$;class P extends C.$XS{constructor(n){super(),this.a=this.B(new E.$he),this.onChange=this.a.event,this.b=this.B(new E.$he),this.onKeyDown=this.b.event,this.c=n,this.s=this.c.isChecked;const o=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,o.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&o.push(...this.c.actionClassName.split(" ")),this.s&&o.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,g.$3T)().setupUpdatableHover(n.hoverDelegate??(0,d.$eT)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...o),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,f=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),f.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,f=>{if(f.keyCode===10||f.keyCode===3){this.checked=!this.s,this.a.fire(!0),f.preventDefault(),f.stopPropagation();return}this.b.fire(f)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(n){this.s=n,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(n){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=n,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(n){this.t.update(n),this.domNode.setAttribute("aria-label",n)}set visible(n){this.domNode.style.display=n?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$0T=P;class c extends C.$XS{constructor(n,o,f){super(),this.g=n,this.h=o,this.a=this.B(new E.$he),this.onChange=this.a.event,this.b=this.B(new P({title:this.g,isChecked:this.h,icon:B.$Zj.check,actionClassName:"monaco-checkbox",...t.$8T})),this.domNode=this.b.domNode,this.c=f,this.n(),this.B(this.b.onChange(h=>{this.n(),this.a.fire(h)}))}get checked(){return this.b.checked}set checked(n){this.b.checked=n,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,A.$XR)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$$T=c;class l extends i.$aU{constructor(n,o,f){super(n,o,f),this.a=this.B(new c(this._action.label,!!this._action.checked,f.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(n){if(this.element=n,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const o=this.element.appendChild((0,A.$)("span.checkbox-label",void 0,this._action.label));this.B((0,A.$kR)(o,A.$dS.CLICK,f=>{this.a.checked=!this.a.checked,f.stopPropagation(),f.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(n){this.a.domNode.tabIndex=n?0:-1}}t.$_T=l}),define(we[141],ve([1,0,14,76,18,119]),function(se,t,i,C,B,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9U=t.$8U=t.$7U=void 0;const E=U.localize(0,null),A=U.localize(1,null),d=U.localize(2,null);class g extends C.$0T{constructor(l){super({icon:B.$Zj.caseSensitive,title:E+l.appendTitle,isChecked:l.isChecked,hoverDelegate:l.hoverDelegate??(0,i.$eT)("element"),inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$7U=g;class $ extends C.$0T{constructor(l){super({icon:B.$Zj.wholeWord,title:A+l.appendTitle,isChecked:l.isChecked,hoverDelegate:l.hoverDelegate??(0,i.$eT)("element"),inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$8U=$;class P extends C.$0T{constructor(l){super({icon:B.$Zj.regex,title:d+l.appendTitle,isChecked:l.isChecked,hoverDelegate:l.hoverDelegate??(0,i.$eT)("element"),inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$9U=P}),define(we[142],ve([1,0,4,141,75,21,3,118,2,14,108]),function(se,t,i,C,B,U,E,A,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0U=void 0;const $=A.localize(0,null);class P extends U.$XS{static{this.OPTION_CHANGE="optionChange"}constructor(l,e,n){super(),this.n=!0,this.s=!1,this.w=this.B(new d.$Vc),this.N=[],this.O=this.B(new E.$he),this.onDidOptionChange=this.O.event,this.P=this.B(new E.$he),this.onKeyDown=this.P.event,this.Q=this.B(new E.$he),this.onMouseDown=this.Q.event,this.R=this.B(new E.$he),this.onInput=this.R.event,this.S=this.B(new E.$he),this.onKeyUp=this.S.event,this.U=this.B(new E.$he),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new E.$he),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=n.placeholder||"",this.b=n.validation,this.c=n.label||$,this.h=!!n.showCommonFindToggles;const o=n.appendCaseSensitiveLabel||"",f=n.appendWholeWordsLabel||"",h=n.appendRegexLabel||"",v=n.history||[],m=!!n.flexibleHeight,b=!!n.flexibleWidth,r=n.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new B.$VU(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:v,showHistoryHint:n.showHistoryHint,flexibleHeight:m,flexibleWidth:b,flexibleMaxHeight:r,inputBoxStyles:n.inputBoxStyles}));const p=this.B((0,g.$fT)());if(this.h){this.J=this.B(new C.$9U({appendTitle:h,isChecked:!1,hoverDelegate:p,...n.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new C.$8U({appendTitle:f,isChecked:!1,hoverDelegate:p,...n.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new C.$7U({appendTitle:o,isChecked:!1,hoverDelegate:p,...n.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const S=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const I=S.indexOf(this.domNode.ownerDocument.activeElement);if(I>=0){let H=-1;F.equals(17)?H=(I+1)%S.length:F.equals(15)&&(I===0?H=S.length-1:H=I-1),F.equals(9)?(S[I].blur(),this.inputBox.focus()):H>=0&&S[H].focus(),i.$fS.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(n?.additionalToggles),this.y&&this.domNode.appendChild(this.y),l?.appendChild(this.domNode),this.B(i.$kR(this.inputBox.inputElement,"compositionstart",S=>{this.s=!0})),this.B(i.$kR(this.inputBox.inputElement,"compositionend",S=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,S=>this.P.fire(S)),this.C(this.inputBox.inputElement,S=>this.S.fire(S)),this.D(this.inputBox.inputElement,S=>this.R.fire()),this.j(this.inputBox.inputElement,S=>this.Q.fire(S))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(l){this.inputBox.layout(),this.X(l.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const l of this.N)l.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const l of this.N)l.disable()}setFocusInputOnOptionClick(l){this.n=l}setEnabled(l){l?this.enable():this.disable()}setAdditionalToggles(l){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new d.$Tc;for(const e of l??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(n=>{this.O.fire(n),!n&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(l=!1){l?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,n)=>e+n.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(l){this.inputBox.value!==l&&(this.inputBox.value=l)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(l){this.M&&(this.M.checked=l)}getWholeWords(){return this.L?.checked??!1}setWholeWords(l){this.L&&(this.L.checked=l)}getRegex(){return this.J?.checked??!1}setRegex(l){this.J&&(this.J.checked=l,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(l){this.inputBox.showMessage(l)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$0U=P}),define(we[143],ve([1,0,4,24,15,74,142,75,72,49,76,69,30,46,8,11,18,19,39,3,44,2,40,10,122,14,57,115]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l,e,n,o,f,h,v,m,b,r,p,S,F,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KV=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$JV=t.$IV=t.$HV=t.RenderIndentGuides=t.$GV=t.$FV=void 0;class H extends d.$yT{set context(s){this.c.context=s}get context(){return this.c.context}constructor(s){super(s.elements.map(k=>k.element)),this.c=s}}function w(R){return R instanceof d.$yT?new H(R):R}class j{constructor(s,k){this.d=s,this.f=k,this.b=b.$Uc.None,this.c=new b.$Tc}getDragURI(s){return this.f.getDragURI(s.element)}getDragLabel(s,k){if(this.f.getDragLabel)return this.f.getDragLabel(s.map(T=>T.element),k)}onDragStart(s,k){this.f.onDragStart?.(w(s),k)}onDragOver(s,k,T,L,z,Y=!0){const q=this.f.onDragOver(w(s),k&&k.element,T,L,z),te=this.a!==k;if(te&&(this.b.dispose(),this.a=k),typeof k>"u")return q;if(te&&typeof q!="boolean"&&q.autoExpand&&(this.b=(0,n.$Ch)(()=>{const Me=this.d(),Ee=Me.getNodeLocation(k);Me.isCollapsed(Ee)&&Me.setCollapsed(Ee,!1),this.a=void 0},500,this.c)),typeof q=="boolean"||!q.accept||typeof q.bubble>"u"||q.feedback){if(!Y){const Me=typeof q=="boolean"?q:q.accept,Ee=typeof q=="boolean"?void 0:q.effect;return{accept:Me,effect:Ee,feedback:[T]}}return q}if(q.bubble===1){const Me=this.d(),Ee=Me.getNodeLocation(k),Ne=Me.getParentNodeLocation(Ee),Ue=Me.getNode(Ne),Ye=Ne&&Me.getListIndex(Ne);return this.onDragOver(s,Ue,Ye,L,z,!1)}const ce=this.d(),oe=ce.getNodeLocation(k),Te=ce.getListIndex(oe),ke=ce.getListRenderCount(oe);return{...q,feedback:(0,e.$Rb)(Te,Te+ke)}}drop(s,k,T,L,z){this.b.dispose(),this.a=void 0,this.f.drop(w(s),k&&k.element,T,L,z)}onDragEnd(s){this.f.onDragEnd?.(s)}dispose(){this.c.dispose(),this.f.dispose()}}function W(R,s){return s&&{...s,identityProvider:s.identityProvider&&{getId(k){return s.identityProvider.getId(k.element)}},dnd:s.dnd&&new j(R,s.dnd),multipleSelectionController:s.multipleSelectionController&&{isSelectionSingleChangeEvent(k){return s.multipleSelectionController.isSelectionSingleChangeEvent({...k,element:k.element})},isSelectionRangeChangeEvent(k){return s.multipleSelectionController.isSelectionRangeChangeEvent({...k,element:k.element})}},accessibilityProvider:s.accessibilityProvider&&{...s.accessibilityProvider,getSetSize(k){const T=R(),L=T.getNodeLocation(k),z=T.getParentNodeLocation(L);return T.getNode(z).visibleChildrenCount},getPosInSet(k){return k.visibleChildIndex+1},isChecked:s.accessibilityProvider&&s.accessibilityProvider.isChecked?k=>s.accessibilityProvider.isChecked(k.element):void 0,getRole:s.accessibilityProvider&&s.accessibilityProvider.getRole?k=>s.accessibilityProvider.getRole(k.element):()=>"treeitem",getAriaLabel(k){return s.accessibilityProvider.getAriaLabel(k.element)},getWidgetAriaLabel(){return s.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:s.accessibilityProvider&&s.accessibilityProvider.getWidgetRole?()=>s.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:s.accessibilityProvider&&s.accessibilityProvider.getAriaLevel?k=>s.accessibilityProvider.getAriaLevel(k.element):k=>k.depth,getActiveDescendantId:s.accessibilityProvider.getActiveDescendantId&&(k=>s.accessibilityProvider.getActiveDescendantId(k.element))},keyboardNavigationLabelProvider:s.keyboardNavigationLabelProvider&&{...s.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(k){return s.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(k.element)}}}}class N{constructor(s){this.a=s}getHeight(s){return this.a.getHeight(s.element)}getTemplateId(s){return this.a.getTemplateId(s.element)}hasDynamicHeight(s){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(s.element)}setDynamicHeight(s,k){this.a.setDynamicHeight?.(s.element,k)}}t.$FV=N;class x{static lift(s){return s instanceof x?s:new x(s)}static empty(s=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:s})}constructor(s){if(this.focus=new Set(s.focus),this.selection=new Set(s.selection),s.expanded instanceof Array){this.expanded=Object.create(null);for(const k of s.expanded)this.expanded[k]=1}else this.expanded=s.expanded;this.expanded=s.expanded,this.scrollTop=s.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$GV=x;var M;(function(R){R.None="none",R.OnHover="onHover",R.Always="always"})(M||(t.RenderIndentGuides=M={}));class Q{get elements(){return this.b}constructor(s,k=[]){this.b=k,this.a=new b.$Tc,this.onDidChange=v.Event.forEach(s,T=>this.b=T,this.a)}dispose(){this.a.dispose()}}class ie{static{this.a=8}constructor(s,k,T,L,z,Y={}){this.o=s,this.p=k,this.q=L,this.s=z,this.b=new Map,this.c=new Map,this.d=ie.a,this.f=!1,this.g=!1,this.j=new Set,this.k=b.$Uc.None,this.m=new b.$Tc,this.templateId=s.templateId,this.updateOptions(Y),v.Event.map(T,q=>q.node)(this.u,this,this.m),s.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(s={}){if(typeof s.indent<"u"){const k=(0,r.$Fm)(s.indent,0,40);if(k!==this.d){this.d=k;for(const[T,L]of this.c)this.v(T,L)}}if(typeof s.renderIndentGuides<"u"){const k=s.renderIndentGuides!==M.None;if(k!==this.g){this.g=k;for(const[T,L]of this.c)this.w(T,L);if(this.k.dispose(),k){const T=new b.$Tc;this.q.onDidChange(this.x,this,T),this.k=T,this.x(this.q.elements)}}}typeof s.hideTwistiesOfChildlessElements<"u"&&(this.f=s.hideTwistiesOfChildlessElements)}renderTemplate(s){const k=(0,i.$kS)(s,(0,i.$)(".monaco-tl-row")),T=(0,i.$kS)(k,(0,i.$)(".monaco-tl-indent")),L=(0,i.$kS)(k,(0,i.$)(".monaco-tl-twistie")),z=(0,i.$kS)(k,(0,i.$)(".monaco-tl-contents")),Y=this.o.renderTemplate(z);return{container:s,indent:T,twistie:L,indentGuidesDisposable:b.$Uc.None,templateData:Y}}renderElement(s,k,T,L){this.c.set(s,T),this.b.set(s.element,s),this.v(s,T),this.o.renderElement(s,k,T.templateData,L)}disposeElement(s,k,T,L){T.indentGuidesDisposable.dispose(),this.o.disposeElement?.(s,k,T.templateData,L),typeof L=="number"&&(this.c.delete(s),this.b.delete(s.element))}disposeTemplate(s){this.o.disposeTemplate(s.templateData)}t(s){const k=this.b.get(s);k&&this.u(k)}u(s){const k=this.c.get(s);k&&(this.x(this.q.elements),this.v(s,k))}v(s,k){const T=ie.a+(s.depth-1)*this.d;k.twistie.style.paddingLeft=`${T}px`,k.indent.style.width=`${T+this.d-16}px`,s.collapsible?k.container.setAttribute("aria-expanded",String(!s.collapsed)):k.container.removeAttribute("aria-expanded"),k.twistie.classList.remove(...f.ThemeIcon.asClassNameArray(o.$Zj.treeItemExpanded));let L=!1;this.o.renderTwistie&&(L=this.o.renderTwistie(s.element,k.twistie)),s.collapsible&&(!this.f||s.visibleChildrenCount>0)?(L||k.twistie.classList.add(...f.ThemeIcon.asClassNameArray(o.$Zj.treeItemExpanded)),k.twistie.classList.add("collapsible"),k.twistie.classList.toggle("collapsed",s.collapsed)):k.twistie.classList.remove("collapsible","collapsed"),this.w(s,k)}w(s,k){if((0,i.$jR)(k.indent),k.indentGuidesDisposable.dispose(),!this.g)return;const T=new b.$Tc,L=this.p();for(;;){const z=L.getNodeLocation(s),Y=L.getParentNodeLocation(z);if(!Y)break;const q=L.getNode(Y),te=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(q)&&te.classList.add("active"),k.indent.childElementCount===0?k.indent.appendChild(te):k.indent.insertBefore(te,k.indent.firstElementChild),this.s.add(q,te),T.add((0,b.$Sc)(()=>this.s.delete(q,te))),s=q}k.indentGuidesDisposable=T}x(s){if(!this.g)return;const k=new Set,T=this.p();s.forEach(L=>{const z=T.getNodeLocation(L);try{const Y=T.getParentNodeLocation(z);L.collapsible&&L.children.length>0&&!L.collapsed?k.add(L):Y&&k.add(T.getNode(Y))}catch{}}),this.j.forEach(L=>{k.has(L)||this.s.forEach(L,z=>z.classList.remove("active"))}),k.forEach(L=>{this.j.has(L)||this.s.forEach(L,z=>z.classList.add("active"))}),this.j=k}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,b.$Pc)(this.m)}}t.$HV=ie;class ue{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(s){this.c=s,this.d=s.toLowerCase()}constructor(s,k,T){this.g=s,this.j=k,this.k=T,this.a=0,this.b=0,this.c="",this.d="",this.f=new b.$Tc,s.onWillRefilter(this.m,this,this.f)}filter(s,k){let T=1;if(this.k){const Y=this.k.filter(s,k);if(typeof Y=="boolean"?T=Y?1:0:(0,P.$CV)(Y)?T=(0,P.$DV)(Y.visibility):T=Y,T===0)return!1}if(this.a++,!this.c)return this.b++,{data:m.FuzzyScore.Default,visibility:T};const L=this.j.getKeyboardNavigationLabel(s),z=Array.isArray(L)?L:[L];for(const Y of z){const q=Y&&Y.toString();if(typeof q>"u")return{data:m.FuzzyScore.Default,visibility:T};let te;if(this.g.findMatchType===Ae.Contiguous){const ce=q.toLowerCase().indexOf(this.d);if(ce>-1){te=[Number.MAX_SAFE_INTEGER,0];for(let oe=this.d.length;oe>0;oe--)te.push(ce+oe-1)}}else te=(0,m.$Ok)(this.c,this.d,0,q,q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(te)return this.b++,z.length===1?{data:te,visibility:T}:{data:{label:q,score:te},visibility:T}}return this.g.findMode===ye.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(s):2:{data:m.FuzzyScore.Default,visibility:T}}m(){this.a=0,this.b=0}dispose(){(0,b.$Pc)(this.f)}}class G extends $.$0T{constructor(s){super({icon:o.$Zj.listFilter,title:(0,S.localize)(0,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,F.$eT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$IV=G;class ee extends $.$0T{constructor(s){super({icon:o.$Zj.searchFuzzy,title:(0,S.localize)(1,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,F.$eT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$JV=ee;const de={inputBoxStyles:A.$TU,toggleStyles:$.$8T,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ye;(function(R){R[R.Highlight=0]="Highlight",R[R.Filter=1]="Filter"})(ye||(t.TreeFindMode=ye={}));var Ae;(function(R){R[R.Fuzzy=0]="Fuzzy",R[R.Contiguous=1]="Contiguous"})(Ae||(t.TreeFindMatchType=Ae={}));class je extends b.$Uc{set mode(s){this.b.checked=s===ye.Filter,this.f.inputBox.setPlaceHolder(s===ye.Filter?(0,S.localize)(2,null):(0,S.localize)(3,null))}set matchType(s){this.c.checked=s===Ae.Fuzzy}get value(){return this.f.inputBox.value}set value(s){this.f.inputBox.value=s}constructor(s,k,T,L,z,Y){super(),this.t=k,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new v.$he,this.onDidDisable=this._onDidDisable.event,s.appendChild(this.a.root),this.B((0,b.$Sc)(()=>s.removeChild(this.a.root)));const q=Y?.styles??de;q.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=q.listFilterWidgetBackground),q.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${q.listFilterWidgetShadow}`);const te=this.B((0,F.$fT)());this.b=this.B(new G({...q.toggleStyles,isChecked:L===ye.Filter,hoverDelegate:te})),this.c=this.B(new ee({...q.toggleStyles,isChecked:z===Ae.Fuzzy,hoverDelegate:te})),this.onDidChangeMode=v.Event.map(this.b.onChange,()=>this.b.checked?ye.Filter:ye.Highlight,this.q),this.onDidChangeMatchType=v.Event.map(this.c.onChange,()=>this.c.checked?Ae.Fuzzy:Ae.Contiguous,this.q),this.f=this.B(new E.$0U(this.a.findInput,T,{label:(0,S.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:q.inputBoxStyles,toggleStyles:q.toggleStyles,history:Y?.history})),this.g=this.B(new U.$gT(this.a.actionbar)),this.mode=L;const ce=this.B(new C.$oT(this.f.inputBox.inputElement,"keydown")),oe=v.Event.chain(ce.event,Ee=>Ee.map(Ne=>new B.$hR(Ne)));this.B(oe(Ee=>{if(Ee.equals(3)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ee.equals(18)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ee.equals(16)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const Te=this.B(new l.$fj("close",(0,S.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(Te,{icon:!0,label:!1});const ke=this.B(new C.$oT(this.a.grab,"mousedown"));this.B(ke.event(Ee=>{const Ne=new b.$Tc,Ue=Ne.add(new C.$oT((0,i.getWindow)(Ee),"mousemove")),Ye=Ne.add(new C.$oT((0,i.getWindow)(Ee),"mouseup")),_e=this.m,et=Ee.pageX,tt=this.s,We=Ee.pageY;this.a.grab.classList.add("grabbing");const X=this.a.root.style.transition;this.a.root.style.transition="unset";const ae=$e=>{const De=$e.pageX-et;this.m=_e-De;const Le=$e.pageY-We;this.s=tt+Le,this.layout()};Ne.add(Ue.event(ae)),Ne.add(Ye.event($e=>{ae($e),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=X,Ne.dispose()}))}));const Me=v.Event.chain(this.B(new C.$oT(this.a.grab,"keydown")).event,Ee=>Ee.map(Ne=>new B.$hR(Ne)));this.B(Me(Ee=>{let Ne,Ue;if(Ee.keyCode===15?Ne=Number.POSITIVE_INFINITY:Ee.keyCode===17?Ne=0:Ee.keyCode===10&&(Ne=this.m===0?Number.POSITIVE_INFINITY:0),Ee.keyCode===16?Ue=0:Ee.keyCode===18&&(Ue=Number.POSITIVE_INFINITY),Ne!==void 0&&(Ee.preventDefault(),Ee.stopPropagation(),this.m=Ne,this.layout()),Ue!==void 0){Ee.preventDefault(),Ee.stopPropagation(),this.s=Ue;const Ye=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ye},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(s=this.j){this.j=s,this.m=(0,r.$Fm)(this.m,0,Math.max(0,s-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$Fm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(s){this.f.showMessage(s)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,n.$Bh)(300),super.dispose()}}class le{get pattern(){return this.b}get mode(){return this.d}set mode(s){s!==this.d&&(this.d=s,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(s))}get matchType(){return this.f}set matchType(s){s!==this.f&&(this.f=s,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(s))}constructor(s,k,T,L,z,Y={}){this.t=s,this.u=T,this.v=L,this.w=z,this.x=Y,this.b="",this.c="",this.j=0,this.k=new v.$he,this.onDidChangeMode=this.k.event,this.m=new v.$he,this.onDidChangeMatchType=this.m.event,this.o=new v.$he,this.onDidChangePattern=this.o.event,this.p=new v.$he,this.onDidChangeOpenState=this.p.event,this.q=new b.$Tc,this.s=new b.$Tc,this.d=s.options.defaultFindMode??ye.Highlight,this.f=s.options.defaultFindMatchType??Ae.Fuzzy,k.onDidSplice(this.z,this,this.s)}updateOptions(s={}){s.defaultFindMode!==void 0&&(this.mode=s.defaultFindMode),s.defaultFindMatchType!==void 0&&(this.matchType=s.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new je(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(s=>this.mode=s,void 0,this.q),this.g.onDidChangeMatchType(s=>this.matchType=s,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(s){this.b=s,this.o.fire(s),this.v.pattern=s,this.t.refilter(),s&&this.t.focusNext(0,!0,void 0,T=>!m.FuzzyScore.isDefault(T.filterData));const k=this.t.getFocus();if(k.length>0){const T=k[0];this.t.getRelativeTop(T)===null&&this.t.reveal(T,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const s=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&s?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,S.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(s){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!m.FuzzyScore.isDefault(s.filterData)}layout(s){this.j=s,this.g?.layout(s)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function _(R,s){return R.position===s.position&&fe(R,s)}function fe(R,s){return R.node.element===s.node.element&&R.startIndex===s.startIndex&&R.height===s.height&&R.endIndex===s.endIndex}class he{constructor(s=[]){this.stickyNodes=s}get count(){return this.stickyNodes.length}equal(s){return(0,e.$ub)(this.stickyNodes,s.stickyNodes,_)}lastNodePartiallyVisible(){if(this.count===0)return!1;const s=this.stickyNodes[this.count-1];if(this.count===1)return s.position!==0;const k=this.stickyNodes[this.count-2];return k.position+k.height!==s.position}animationStateChanged(s){if(!(0,e.$ub)(this.stickyNodes,s.stickyNodes,fe)||this.count===0)return!1;const k=this.stickyNodes[this.count-1],T=s.stickyNodes[s.count-1];return k.position!==T.position}}class Fe{constrainStickyScrollNodes(s,k,T){for(let L=0;L<s.length;L++){const z=s[L];if(z.position+z.height>T||L>=k)return s.slice(0,L)}return s}}class Z extends b.$Uc{constructor(s,k,T,L,z,Y={}){super(),this.g=s,this.j=k,this.m=T,this.s=z,this.c=.4;const q=this.validateStickySettings(Y);this.b=q.stickyScrollMaxItemCount,this.a=Y.stickyScrollDelegate??new Fe,this.f=this.B(new pe(T.getScrollableElement(),T,s,L,z,Y.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(T.onDidScroll(()=>this.u())),this.B(T.onDidChangeContentHeight(()=>this.u())),this.B(s.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(s){return this.f.getNode(s)}t(s){let k;if(s===0?k=this.m.firstVisibleIndex:k=this.m.indexAt(s+this.m.scrollTop),!(k<0||k>=this.m.length))return this.m.element(k)}u(){const s=this.t(0);if(!s||this.g.scrollTop===0){this.f.setState(void 0);return}const k=this.w(s);this.f.setState(k)}w(s){const k=[];let T=s,L=0,z=this.z(T,void 0,L);for(;z&&(k.push(z),L+=z.height,!(k.length<=this.b&&(T=this.y(z),!T)));)z=this.z(T,z.node,L);const Y=this.H(k);return Y.length?new he(Y):void 0}y(s){return this.t(s.position+s.height)}z(s,k,T){const L=this.F(s,k);if(L&&!(L===s&&(!this.J(s)||this.C(s,T))))return this.D(L,T)}C(s,k){const T=this.L(s),L=this.m.getElementTop(T),z=k;return this.m.scrollTop===L-z}D(s,k){const T=this.s.getHeight(s),{startIndex:L,endIndex:z}=this.M(s),Y=this.G(z,k,T);return{node:s,position:Y,height:T,startIndex:L,endIndex:z}}F(s,k=void 0){let T=s,L=this.I(T);for(;L;){if(L===k)return T;T=L,L=this.I(T)}if(k===void 0)return T}G(s,k,T){let L=this.m.getRelativeTop(s);if(L===null&&this.m.firstVisibleIndex===s&&s+1<this.m.length){const ce=this.s.getHeight(this.m.element(s)),oe=this.m.getRelativeTop(s+1);L=oe?oe-ce/this.m.renderHeight:null}if(L===null)return k;const z=this.m.element(s),Y=this.s.getHeight(z),te=L*this.m.renderHeight+Y;return k+T>te&&k<=te?te-T:k}H(s){if(s.length===0)return[];const k=this.m.renderHeight*this.c,T=s[s.length-1];if(s.length<=this.b&&T.position+T.height<=k)return s;const L=this.a.constrainStickyScrollNodes(s,this.b,k);if(!L.length)return[];const z=L[L.length-1];if(L.length>this.b||z.position+z.height>k)throw new Error("stickyScrollDelegate violates constraints");return L}I(s){const k=this.j.getNodeLocation(s),T=this.j.getParentNodeLocation(k);return T?this.j.getNode(T):void 0}J(s){const k=this.j.getNodeLocation(s);return this.j.getListRenderCount(k)>1}L(s){const k=this.j.getNodeLocation(s);return this.j.getListIndex(k)}M(s){const k=this.j.getNodeLocation(s),T=this.j.getListIndex(k);if(T<0)throw new Error("Node not found in tree");const L=this.j.getListRenderCount(k),z=T+L-1;return{startIndex:T,endIndex:z}}nodePositionTopBelowWidget(s){const k=[];let T=this.I(s);for(;T;)k.push(T),T=this.I(T);let L=0;for(let z=0;z<k.length&&z<this.b;z++)L+=this.s.getHeight(k[z]);return L}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(s={}){if(!s.stickyScrollMaxItemCount)return;const k=this.validateStickySettings(s);this.b!==k.stickyScrollMaxItemCount&&(this.b=k.stickyScrollMaxItemCount,this.u())}validateStickySettings(s){let k=7;return typeof s.stickyScrollMaxItemCount=="number"&&(k=Math.max(s.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:k}}}class pe{constructor(s,k,T,L,z,Y){this.g=k,this.j=T,this.k=L,this.m=z,this.o=Y,this.c=[],this.d=new b.$Tc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),s.appendChild(this.a);const q=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(q),this.f=new Se(this.a,k),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const s=this.b.stickyNodes[this.b.count-1];return s.position+s.height}get count(){return this.b?.count??0}getNode(s){return this.b?.stickyNodes.find(k=>k.node===s)}setState(s){const k=!!this.b&&this.b.count>0,T=!!s&&s.count>0;if(!k&&!T||k&&T&&this.b.equal(s))return;if(k!==T&&this.s(T),!T){this.b=void 0,this.c=[],this.d.clear();return}const L=s.stickyNodes[s.count-1];if(this.b&&s.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${L.position}px`;else{this.d.clear();const z=Array(s.count);for(let Y=s.count-1;Y>=0;Y--){const q=s.stickyNodes[Y],{element:te,disposable:ce}=this.p(q,Y,s.count);z[Y]=te,this.a.appendChild(te),this.d.add(ce)}this.f.updateElements(z,s),this.c=z}this.b=s,this.a.style.height=`${L.position+L.height}px`}p(s,k,T){const L=s.startIndex,z=document.createElement("div");z.style.top=`${s.position}px`,this.j.options.setRowHeight!==!1&&(z.style.height=`${s.height}px`),this.j.options.setRowLineHeight!==!1&&(z.style.lineHeight=`${s.height}px`),z.classList.add("monaco-tree-sticky-row"),z.classList.add("monaco-list-row"),z.setAttribute("data-index",`${L}`),z.setAttribute("data-parity",L%2===0?"even":"odd"),z.setAttribute("id",this.g.getElementID(L));const Y=this.q(z,s.node.element,k,T),q=this.m.getTemplateId(s.node),te=this.k.find(ke=>ke.templateId===q);if(!te)throw new Error(`No renderer found for template id ${q}`);let ce=s.node;ce===this.j.getNode(this.j.getNodeLocation(s.node))&&(ce=new Proxy(s.node,{}));const oe=te.renderTemplate(z);te.renderElement(ce,s.startIndex,oe,s.height);const Te=(0,b.$Sc)(()=>{Y.dispose(),te.disposeElement(ce,s.startIndex,oe,s.height),te.disposeTemplate(oe),z.remove()});return{element:z,disposable:Te}}q(s,k,T,L){if(!this.o)return b.$Uc.None;this.o.getSetSize&&s.setAttribute("aria-setsize",String(this.o.getSetSize(k,T,L))),this.o.getPosInSet&&s.setAttribute("aria-posinset",String(this.o.getPosInSet(k,T))),this.o.getRole&&s.setAttribute("role",this.o.getRole(k)??"treeitem");const z=this.o.getAriaLabel(k),Y=z&&typeof z!="string"?z:(0,I.constObservable)(z),q=(0,I.autorun)(ce=>{const oe=ce.readObservable(Y);oe?s.setAttribute("aria-label",oe):s.removeAttribute("aria-label")});typeof z=="string"||z&&s.setAttribute("aria-label",z.get());const te=this.o.getAriaLevel&&this.o.getAriaLevel(k);return typeof te=="number"&&s.setAttribute("aria-level",`${te}`),s.setAttribute("aria-selected",String(!1)),q}s(s){this.a.classList.toggle("empty",!s),s||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class Se extends b.$Uc{get m(){return this.j}set m(s){s!==this.j&&(this.f.fire(s),this.j=s)}constructor(s,k){super(),this.s=s,this.t=k,this.a=-1,this.b=[],this.f=new v.$he,this.onDidChangeHasFocus=this.f.event,this.g=new v.$he,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(T=>this.w(T))),this.B(this.t.onMouseDown(T=>this.y(T))),this.B(this.t.onContextMenu(T=>this.u(T)))}u(s){const k=s.browserEvent.target;if(!(0,g.$LT)(k)&&!(0,g.$KT)(k)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$aS)(s.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const Y=this.c.stickyNodes.findIndex(q=>q.node.element===s.element?.element);if(Y===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(Y);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const L=this.c.stickyNodes[this.a].node.element,z=this.b[this.a];this.g.fire({element:L,anchor:z,browserEvent:s.browserEvent,isStickyScroll:!0})}w(s){if(this.m&&this.c){if(s.key==="ArrowUp")this.z(Math.max(0,this.a-1)),s.preventDefault(),s.stopPropagation();else if(s.key==="ArrowDown"||s.key==="ArrowRight"){if(this.a>=this.c.count-1){const k=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([k]),this.C(k,this.c)}else this.z(this.a+1);s.preventDefault(),s.stopPropagation()}}}y(s){const k=s.browserEvent.target;!(0,g.$LT)(k)&&!(0,g.$KT)(k)||(s.browserEvent.preventDefault(),s.browserEvent.stopPropagation())}updateElements(s,k){if(k&&k.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(k&&k.count!==s.length)throw new Error("Sticky scroll focus received illigel state");const T=this.a;if(this.D(),this.b=s,this.c=k,k){const L=(0,r.$Fm)(T,0,k.count-1);this.F(L)}else this.m&&this.t.domFocus();this.s.tabIndex=k?0:-1}z(s){const k=this.c;if(!k)throw new Error("Cannot set focus when state is undefined");if(this.F(s),!(s<k.count-1)&&k.lastNodePartiallyVisible()){const T=k.stickyNodes[s];this.C(T.endIndex+1,k)}}C(s,k){const T=k.stickyNodes[k.count-1],L=k.count>1?k.stickyNodes[k.count-2]:void 0,z=this.t.getElementTop(s),Y=L?L.position+L.height+T.height:T.height;this.t.scrollTop=z-Y}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(s){if(0>s)throw new Error("addFocus() can not remove focus");if(!this.c&&s>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&s>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const k=this.a;k>=0&&this.G(this.b[k],!1),s>=0&&this.G(this.b[s],!0),this.a=s}G(s,k){this.I(s,k&&this.m),this.J(s,k)}H(s){this.a!==-1&&this.I(this.b[this.a],s)}I(s,k){s.classList.toggle("focused",k)}J(s,k){s.classList.toggle("passive-focused",k)}L(s){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",s)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function Re(R){let s=c.TreeMouseEventTarget.Unknown;return(0,i.$SR)(R.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?s=c.TreeMouseEventTarget.Twistie:(0,i.$SR)(R.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?s=c.TreeMouseEventTarget.Element:(0,i.$SR)(R.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(s=c.TreeMouseEventTarget.Filter),{browserEvent:R.browserEvent,element:R.element?R.element.element:null,target:s}}function re(R){const s=(0,g.$LT)(R.browserEvent.target);return{element:R.element?R.element.element:null,browserEvent:R.browserEvent,anchor:R.anchor,isStickyScroll:s}}function me(R,s){s(R),R.children.forEach(k=>me(k,s))}class J{get f(){return this.d||(this.d=this.m()),this.d}constructor(s,k){this.g=s,this.j=k,this.a=[],this.c=new v.$he,this.onDidChange=this.c.event}set(s,k){!k?.__forceEvent&&(0,e.$ub)(this.a,s)||this.k(s,!1,k)}k(s,k,T){if(this.a=[...s],this.b=void 0,this.d=void 0,!k){const L=this;this.c.fire({get elements(){return L.get()},browserEvent:T})}}get(){return this.b||(this.b=this.a.map(s=>s.element)),[...this.b]}getNodes(){return this.a}has(s){return this.f.has(s)}onDidModelSplice({insertedNodes:s,deletedNodes:k}){if(!this.j){const te=this.m(),ce=oe=>te.delete(oe);k.forEach(oe=>me(oe,ce)),this.set([...te.values()]);return}const T=new Set,L=te=>T.add(this.j.getId(te.element).toString());k.forEach(te=>me(te,L));const z=new Map,Y=te=>z.set(this.j.getId(te.element).toString(),te);s.forEach(te=>me(te,Y));const q=[];for(const te of this.a){const ce=this.j.getId(te.element).toString();if(!T.has(ce))q.push(te);else{const Te=z.get(ce);Te&&Te.visible&&q.push(Te)}}if(this.a.length>0&&q.length===0){const te=this.g();te&&q.push(te)}this.k(q,!0)}m(){const s=new Set;for(const k of this.a)s.add(k);return s}}class O extends g.$QT{constructor(s,k,T){super(s),this.x=k,this.y=T}u(s){if((0,g.$MT)(s.browserEvent.target)||(0,g.$FT)(s.browserEvent.target)||(0,g.$GT)(s.browserEvent.target)||s.browserEvent.isHandledByList)return;const k=s.element;if(!k)return super.u(s);if(this.p(s)||this.o(s))return super.u(s);const T=s.browserEvent.target,L=T.classList.contains("monaco-tl-twistie")||T.classList.contains("monaco-icon-label")&&T.classList.contains("folder-icon")&&s.browserEvent.offsetX<16,z=(0,g.$KT)(s.browserEvent.target);let Y=!1;if(z?Y=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?Y=this.x.expandOnlyOnTwistieClick(k.element):Y=!!this.x.expandOnlyOnTwistieClick,z)this.A(s,k);else{if(Y&&!L&&s.browserEvent.detail!==2)return super.u(s);if(!this.x.expandOnDoubleClick&&s.browserEvent.detail===2)return super.u(s)}if(k.collapsible&&(!z||L)){const q=this.x.getNodeLocation(k),te=s.browserEvent.altKey;if(this.x.setFocus([q]),this.x.toggleCollapsed(q,te),L){s.browserEvent.isHandledByList=!0;return}}z||super.u(s)}A(s,k){if((0,g.$HT)(s.browserEvent.target)||(0,g.$IT)(s.browserEvent.target))return;const T=this.y();if(!T)throw new Error("Sticky scroll controller not found");const L=this.k.indexOf(k),z=this.k.getElementTop(L),Y=T.nodePositionTopBelowWidget(k);this.x.scrollTop=z-Y,this.k.domFocus(),this.k.setFocus([L]),this.k.setSelection([L])}v(s){s.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||s.browserEvent.isHandledByList||super.v(s)}s(s){const k=s.browserEvent.target;if(!(0,g.$LT)(k)&&!(0,g.$KT)(k)){super.s(s);return}}t(s){const k=s.browserEvent.target;if(!(0,g.$LT)(k)&&!(0,g.$KT)(k)){super.t(s);return}}}class u extends g.$TT{constructor(s,k,T,L,z,Y,q,te){super(s,k,T,L,te),this.p=z,this.s=Y,this.K=q}D(s){return new O(this,s.tree,s.stickyScrollProvider)}splice(s,k,T=[]){if(super.splice(s,k,T),T.length===0)return;const L=[],z=[];let Y;T.forEach((q,te)=>{this.p.has(q)&&L.push(s+te),this.s.has(q)&&z.push(s+te),this.K.has(q)&&(Y=s+te)}),L.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...L])),z.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...z])),typeof Y=="number"&&super.setAnchor(Y)}setFocus(s,k,T=!1){super.setFocus(s,k),T||this.p.set(s.map(L=>this.element(L)),k)}setSelection(s,k,T=!1){super.setSelection(s,k),T||this.s.set(s.map(L=>this.element(L)),k)}setAnchor(s,k=!1){super.setAnchor(s),k||(typeof s>"u"?this.K.set([]):this.K.set([this.element(s)]))}}var y;(function(R){R[R.Tree=0]="Tree",R[R.StickyScroll=1]="StickyScroll"})(y||(t.AbstractTreePart=y={}));class a{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return v.Event.map(this.j.onMouseClick,Re)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.j.onMouseDblClick,Re),s=>s.target!==c.TreeMouseEventTarget.Filter)}get onMouseOver(){return v.Event.map(this.j.onMouseOver,Re)}get onMouseOut(){return v.Event.map(this.j.onMouseOut,Re)}get onContextMenu(){return v.Event.any(v.Event.filter(v.Event.map(this.j.onContextMenu,re),s=>!s.isStickyScroll),this.B?.onContextMenu??v.Event.None)}get onTap(){return v.Event.map(this.j.onTap,Re)}get onPointer(){return v.Event.map(this.j.onPointer,Re)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ye.Highlight}set findMode(s){this.z&&(this.z.mode=s)}get findMatchType(){return this.z?.matchType??Ae.Fuzzy}set findMatchType(s){this.z&&(this.z.matchType=s)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(s,k,T,L,z={}){this.G=s,this.H=z,this.y=new v.$pe,this.onDidChangeFindOpenState=v.Event.None,this.onDidChangeStickyScrollFocused=v.Event.None,this.D=new b.$Tc,this.E=new v.$he,this.onWillRefilter=this.E.event,this.F=new v.$he,this.onDidUpdateOptions=this.F.event,this.p=new N(T);const Y=new v.$qe,q=new v.$qe,te=this.D.add(new Q(q.event)),ce=new h.$Hc;this.k=L.map(Ee=>new ie(Ee,()=>this.o,Y.event,te,ce,z));for(const Ee of this.k)this.D.add(Ee);let oe;z.keyboardNavigationLabelProvider&&(oe=new ue(this,z.keyboardNavigationLabelProvider,z.filter),z={...z,filter:oe},this.D.add(oe)),this.q=new J(()=>this.j.getFocusedElements()[0],z.identityProvider),this.w=new J(()=>this.j.getSelectedElements()[0],z.identityProvider),this.x=new J(()=>this.j.getAnchorElement(),z.identityProvider),this.j=new u(s,k,this.p,this.k,this.q,this.w,this.x,{...W(()=>this.o,z),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(s,this.j,z),Y.input=this.o.onDidChangeCollapseState;const Te=v.Event.forEach(this.o.onDidSplice,Ee=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Ee),this.w.onDidModelSplice(Ee)})},this.D);Te(()=>null,null,this.D);const ke=this.D.add(new v.$he),Me=this.D.add(new n.$xh(0));if(this.D.add(v.Event.any(Te,this.q.onDidChange,this.w.onDidChange)(()=>{Me.trigger(()=>{const Ee=new Set;for(const Ne of this.q.getNodes())Ee.add(Ne);for(const Ne of this.w.getNodes())Ee.add(Ne);ke.fire([...Ee.values()])})})),q.input=ke.event,z.keyboardSupport!==!1){const Ee=v.Event.chain(this.j.onKeyDown,Ne=>Ne.filter(Ue=>!(0,g.$FT)(Ue.target)).map(Ue=>new B.$hR(Ue)));v.Event.chain(Ee,Ne=>Ne.filter(Ue=>Ue.keyCode===15))(this.J,this,this.D),v.Event.chain(Ee,Ne=>Ne.filter(Ue=>Ue.keyCode===17))(this.K,this,this.D),v.Event.chain(Ee,Ne=>Ne.filter(Ue=>Ue.keyCode===10))(this.L,this,this.D)}if((z.findWidgetEnabled??!0)&&z.keyboardNavigationLabelProvider&&z.contextViewProvider){const Ee=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new le(this,this.o,this.j,oe,z.contextViewProvider,Ee),this.A=Ne=>this.z.shouldAllowFocus(Ne),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=v.Event.None,this.onDidChangeFindMatchType=v.Event.None;z.enableStickyScroll&&(this.B=new Z(this,this.o,this.j,this.k,this.p,z),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$5R)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===M.Always)}updateOptions(s={}){this.H={...this.H,...s};for(const k of this.k)k.updateOptions(s);this.j.updateOptions(this.H),this.z?.updateOptions(s),this.I(s),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===M.Always)}get options(){return this.H}I(s){!this.B&&this.H.enableStickyScroll?(this.B=new Z(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=v.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(s)}updateWidth(s){const k=this.o.getListIndex(s);k!==-1&&this.j.updateWidth(k)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(s){this.j.scrollTop=s}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(s){this.j.scrollLeft=s}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let s=this.j.firstVisibleIndex;return this.B&&(s+=this.B.count),s<0||s>=this.j.length?void 0:this.j.element(s).element}get lastVisibleElement(){const s=this.j.lastVisibleIndex;return this.j.element(s).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(s){this.j.ariaLabel=s}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$XR)(this.getHTMLElement())}layout(s,k){this.j.layout(s,k),(0,p.$eg)(k)&&this.z?.layout(k)}style(s){const k=`.${this.j.domId}`,T=[];s.treeIndentGuidesStroke&&(T.push(`.monaco-list${k}:hover .monaco-tl-indent > .indent-guide, .monaco-list${k}.always .monaco-tl-indent > .indent-guide  { border-color: ${s.treeInactiveIndentGuidesStroke}; }`),T.push(`.monaco-list${k} .monaco-tl-indent > .indent-guide.active { border-color: ${s.treeIndentGuidesStroke}; }`));const L=s.treeStickyScrollBackground??s.listBackground;L&&(T.push(`.monaco-list${k} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${L}; }`),T.push(`.monaco-list${k} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${L}; }`)),s.treeStickyScrollBorder&&T.push(`.monaco-list${k} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${s.treeStickyScrollBorder}; }`),s.treeStickyScrollShadow&&T.push(`.monaco-list${k} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${s.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),s.listFocusForeground&&(T.push(`.monaco-list${k}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${s.listFocusForeground}; }`),T.push(`.monaco-list${k}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const z=(0,i.$CS)(s.listFocusAndSelectionOutline,(0,i.$CS)(s.listSelectionOutline,s.listFocusOutline??""));z&&(T.push(`.monaco-list${k}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${z}; outline-offset: -1px;}`),T.push(`.monaco-list${k}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),s.listFocusOutline&&(T.push(`.monaco-list${k}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),T.push(`.monaco-list${k}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),T.push(`.monaco-workbench.context-menu-visible .monaco-list${k}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),T.push(`.monaco-workbench.context-menu-visible .monaco-list${k}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),T.push(`.monaco-workbench.context-menu-visible .monaco-list${k}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=T.join(`
`),this.j.style(s)}getParentElement(s){const k=this.o.getParentNodeLocation(s);return this.o.getNode(k).element}getFirstElementChild(s){return this.o.getFirstElementChild(s)}getNode(s){return this.o.getNode(s)}getNodeLocation(s){return this.o.getNodeLocation(s)}collapse(s,k=!1){return this.o.setCollapsed(s,!0,k)}expand(s,k=!1){return this.o.setCollapsed(s,!1,k)}toggleCollapsed(s,k=!1){return this.o.setCollapsed(s,void 0,k)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(s){return this.o.isCollapsible(s)}setCollapsible(s,k){return this.o.setCollapsible(s,k)}isCollapsed(s){return this.o.isCollapsed(s)}expandTo(s){this.o.expandTo(s)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(s){if(typeof s>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const k=this.o.getNode(s);this.x.set([k]);const T=this.o.getListIndex(s);T>-1&&this.j.setAnchor(T,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(s,k){this.y.bufferEvents(()=>{const T=s.map(z=>this.o.getNode(z));this.w.set(T,k);const L=s.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setSelection(L,k,!0)})}getSelection(){return this.w.get()}setFocus(s,k){this.y.bufferEvents(()=>{const T=s.map(z=>this.o.getNode(z));this.q.set(T,k);const L=s.map(z=>this.o.getListIndex(z)).filter(z=>z>-1);this.j.setFocus(L,k,!0)})}focusNext(s=1,k=!1,T,L=(0,i.$aS)(T)&&T.altKey?void 0:this.A){this.j.focusNext(s,k,T,L)}focusPrevious(s=1,k=!1,T,L=(0,i.$aS)(T)&&T.altKey?void 0:this.A){this.j.focusPrevious(s,k,T,L)}focusNextPage(s,k=(0,i.$aS)(s)&&s.altKey?void 0:this.A){return this.j.focusNextPage(s,k)}focusPreviousPage(s,k=(0,i.$aS)(s)&&s.altKey?void 0:this.A){return this.j.focusPreviousPage(s,k,()=>this.B?.height??0)}focusLast(s,k=(0,i.$aS)(s)&&s.altKey?void 0:this.A){this.j.focusLast(s,k)}focusFirst(s,k=(0,i.$aS)(s)&&s.altKey?void 0:this.A){this.j.focusFirst(s,k)}getFocus(){return this.q.get()}getStickyScrollFocus(){const s=this.B?.getFocus();return s!==void 0?[s]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(s,k){this.o.expandTo(s);const T=this.o.getListIndex(s);if(T!==-1)if(!this.B)this.j.reveal(T,k);else{const L=this.B.nodePositionTopBelowWidget(this.getNode(s));this.j.reveal(T,k,L)}}getRelativeTop(s){const k=this.o.getListIndex(s);if(k===-1)return null;const T=this.B?.getNode(this.getNode(s));return this.j.getRelativeTop(k,T?.position??this.B?.height)}getViewState(s=this.options.identityProvider){if(!s)throw new c.$AV(this.G,"Can't get tree view state without an identity provider");const k=Y=>s.getId(Y).toString(),T=x.empty(this.scrollTop);for(const Y of this.getFocus())T.focus.add(k(Y));for(const Y of this.getSelection())T.selection.add(k(Y));const L=this.o.getNode(),z=[L];for(;z.length>0;){const Y=z.shift();Y!==L&&Y.collapsible&&(T.expanded[k(Y.element)]=Y.collapsed?0:1),z.push(...Y.children)}return T}J(s){s.preventDefault(),s.stopPropagation();const k=this.j.getFocusedElements();if(k.length===0)return;const T=k[0],L=this.o.getNodeLocation(T);if(!this.o.setCollapsed(L,!0)){const Y=this.o.getParentNodeLocation(L);if(!Y)return;const q=this.o.getListIndex(Y);this.j.reveal(q),this.j.setFocus([q])}}K(s){s.preventDefault(),s.stopPropagation();const k=this.j.getFocusedElements();if(k.length===0)return;const T=k[0],L=this.o.getNodeLocation(T);if(!this.o.setCollapsed(L,!1)){if(!T.children.some(te=>te.visible))return;const[Y]=this.j.getFocus(),q=Y+1;this.j.reveal(q),this.j.setFocus([q])}}L(s){s.preventDefault(),s.stopPropagation();const k=this.j.getFocusedElements();if(k.length===0)return;const T=k[0],L=this.o.getNodeLocation(T),z=s.browserEvent.altKey;this.o.setCollapsed(L,void 0,z)}navigate(s){return new D(this.j,this.o,s)}dispose(){(0,b.$Pc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$KV=a;class D{constructor(s,k,T){this.b=s,this.c=k,T?this.a=this.c.getListIndex(T):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(we[144],ve([1,0,143,134,30,32]),function(se,t,i,C,B,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VV=void 0;class E extends i.$KV{constructor(d,g,$,P,c,l={}){super(d,g,$,P,l),this.f=d,this.g=c,this.d=new Map,this.c=l.identityProvider}getInput(){return this.b}setInput(d,g){if(g&&!this.c)throw new B.$AV(this.f,"Can't restore tree view state without an identity provider");if(this.b=d,!d){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!g){this.m(d);return}const $=[],P=[],c=e=>{const n=this.c.getId(e).toString();return!g.expanded[n]},l=e=>{const n=this.c.getId(e.element).toString();g.focus.has(n)&&$.push(e.element),g.selection.has(n)&&P.push(e.element)};this.m(d,c,l),this.setFocus($),this.setSelection(P),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(d=this.b){if(typeof this.b>"u")throw new B.$AV(this.f,"Tree input not set");let g;this.c&&(g=$=>{const P=this.c.getId($).toString(),c=this.d.get(P);if(c)return c.collapsed}),this.m(d,g)}resort(d=this.b,g=!0){this.o.resort(d===this.b?null:d,g)}refresh(d){if(d===void 0){this.j.rerender();return}this.o.rerender(d)}m(d,g,$){let P;if(this.c){const c=new Set,l=$;$=e=>{const n=this.c.getId(e.element).toString();c.add(n),this.d.set(n,e),l?.(e)},P=e=>{const n=this.c.getId(e.element).toString();c.has(n)||this.d.delete(n)}}this.o.setChildren(d===this.b?null:d,this.s(d,g).elements,{onDidCreateNode:$,onDidDeleteNode:P})}s(d,g){const $=[...this.g.getChildren(d)];return{elements:U.Iterable.map($,c=>{const{elements:l,size:e}=this.s(c,g),n=this.g.hasChildren?this.g.hasChildren(c):void 0,o=e===0?void 0:g&&g(c);return{element:c,children:l,collapsible:n,collapsed:o}}),size:$.length}}M(d,g,$){return new C.$LV(d,g,$)}}t.$VV=E}),define(we[77],ve([1,0,8,11,43,34,31,6,3,2,64,9,10]),function(se,t,i,C,B,U,E,A,d,g,$,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ji=t.ProxyChannel=t.$ii=t.$fi=t.$ei=t.$di=t.RequestInitiator=t.$ci=t.$_h=t.$$h=void 0,t.$ai=H,t.$bi=w,t.$gi=Q,t.$hi=ie;var l;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(l||(l={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var n;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(n||(n={}));function o(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(f||(f={}));function h(le){let _=0;for(let fe=0;;fe+=7){const he=le.read(1);if(_|=(he.buffer[0]&127)<<fe,!(he.buffer[0]&128))return _}}const v=S(0);function m(le,_){if(_===0){le.write(v);return}let fe=0;for(let Fe=_;Fe!==0;Fe=Fe>>>7)fe++;const he=B.$Je.alloc(fe);for(let Fe=0;_!==0;Fe++)he.buffer[Fe]=_&127,_=_>>>7,_>0&&(he.buffer[Fe]|=128);le.write(he)}class b{constructor(_){this.b=_,this.a=0}read(_){const fe=this.b.slice(this.a,this.a+_);return this.a+=fe.byteLength,fe}}t.$$h=b;class r{constructor(){this.a=[]}get buffer(){return B.$Je.concat(this.a)}write(_){this.a.push(_)}}t.$_h=r;var p;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(p||(p={}));function S(le){const _=B.$Je.alloc(1);return _.writeUInt8(le,0),_}const F={Undefined:S(p.Undefined),String:S(p.String),Buffer:S(p.Buffer),VSBuffer:S(p.VSBuffer),Array:S(p.Array),Object:S(p.Object),Uint:S(p.Int)},I=typeof Buffer<"u";function H(le,_){if(typeof _>"u")le.write(F.Undefined);else if(typeof _=="string"){const fe=B.$Je.fromString(_);le.write(F.String),m(le,fe.byteLength),le.write(fe)}else if(I&&Buffer.isBuffer(_)){const fe=B.$Je.wrap(_);le.write(F.Buffer),m(le,fe.byteLength),le.write(fe)}else if(_ instanceof B.$Je)le.write(F.VSBuffer),m(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(F.Array),m(le,_.length);for(const fe of _)H(le,fe)}else if(typeof _=="number"&&(_|0)===_)le.write(F.Uint),m(le,_);else{const fe=B.$Je.fromString(JSON.stringify(_));le.write(F.Object),m(le,fe.byteLength),le.write(fe)}}function w(le){switch(le.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return le.read(h(le)).toString();case p.Buffer:return le.read(h(le)).buffer;case p.VSBuffer:return le.read(h(le));case p.Array:{const fe=h(le),he=[];for(let Fe=0;Fe<fe;Fe++)he.push(w(le));return he}case p.Object:return JSON.parse(le.read(h(le)).toString());case p.Int:return h(le)}}class j{constructor(_,fe,he=null,Fe=1e3){this.h=_,this.j=fe,this.k=he,this.l=Fe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Z=>this.q(Z)),this.m({type:200})}registerChannel(_,fe){this.b.set(_,fe),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const fe=this.o([_.type]);this.k?.logOutgoing(fe,0,1,o(_.type));return}case 201:case 202:case 204:case 203:{const fe=this.o([_.type,_.id],_.data);this.k?.logOutgoing(fe,_.id,1,o(_.type),_.data);return}}}o(_,fe=void 0){const he=new r;return H(he,_),H(he,fe),this.p(he.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const fe=new b(_),he=w(fe),Fe=w(fe),Z=he[0];switch(Z){case 100:return this.k?.logIncoming(_.byteLength,he[1],1,`${e(Z)}: ${he[2]}.${he[3]}`,Fe),this.s({type:Z,id:he[1],channelName:he[2],name:he[3],arg:Fe});case 102:return this.k?.logIncoming(_.byteLength,he[1],1,`${e(Z)}: ${he[2]}.${he[3]}`,Fe),this.t({type:Z,id:he[1],channelName:he[2],name:he[3],arg:Fe});case 101:return this.k?.logIncoming(_.byteLength,he[1],1,`${e(Z)}`),this.u({type:Z,id:he[1]});case 103:return this.k?.logIncoming(_.byteLength,he[1],1,`${e(Z)}`),this.u({type:Z,id:he[1]})}}s(_){const fe=this.b.get(_.channelName);if(!fe){this.v(_);return}const he=new U.$se;let Fe;try{Fe=fe.call(this.j,_.name,_.arg,he.token)}catch(Se){Fe=Promise.reject(Se)}const Z=_.id;Fe.then(Se=>{this.m({id:Z,data:Se,type:201})},Se=>{Se instanceof Error?this.m({id:Z,data:{message:Se.message,name:Se.name,stack:Se.stack?Se.stack.split?Se.stack.split(`
`):Se.stack:void 0},type:202}):this.m({id:Z,data:Se,type:203})}).finally(()=>{pe.dispose(),this.d.delete(_.id)});const pe=(0,g.$Sc)(()=>he.cancel());this.d.set(_.id,pe)}t(_){const fe=this.b.get(_.channelName);if(!fe){this.v(_);return}const he=_.id,Z=fe.listen(this.j,_.name,_.arg)(pe=>this.m({id:he,data:pe,type:204}));this.d.set(_.id,Z)}u(_){const fe=this.d.get(_.id);fe&&(fe.dispose(),this.d.delete(_.id))}v(_){let fe=this.g.get(_.channelName);fe||(fe=[],this.g.set(_.channelName,fe));const he=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);fe.push({request:_,timeoutTimer:he})}w(_){const fe=this.g.get(_);if(fe){for(const he of fe)switch(clearTimeout(he.timeoutTimer),he.request.type){case 100:this.s(he.request);break;case 102:this.t(he.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Pc)(this.d.values()),this.d.clear()}}t.$ci=j;var W;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(W||(t.RequestInitiator=W={}));class N{constructor(_,fe=null){this.l=_,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(he=>this.s(he)),this.j=fe}getChannel(_){const fe=this;return{call(he,Fe,Z){return fe.a?Promise.reject(new A.$5):fe.m(_,he,Fe,Z)},listen(he,Fe){return fe.a?d.Event.None:fe.o(_,he,Fe)}}}m(_,fe,he,Fe=U.CancellationToken.None){const Z=this.g++,Se={id:Z,type:100,channelName:_,name:fe,arg:he};if(Fe.isCancellationRequested)return Promise.reject(new A.$5);let Re;return new Promise((me,J)=>{if(Fe.isCancellationRequested)return J(new A.$5);const O=()=>{const D=R=>{switch(R.type){case 201:this.f.delete(Z),me(R.data);break;case 202:{this.f.delete(Z);const s=new Error(R.data.message);s.stack=Array.isArray(R.data.stack)?R.data.stack.join(`
`):R.data.stack,s.name=R.data.name,J(s);break}case 203:this.f.delete(Z),J(R.data);break}};this.f.set(Z,D),this.p(Se)};let u=null;this.b===f.Idle?O():(u=(0,C.$nh)(D=>this.u()),u.then(()=>{u=null,O()}));const y=()=>{u?(u.cancel(),u=null):this.p({id:Z,type:101}),J(new A.$5)},a=Fe.onCancellationRequested(y);Re=(0,g.$Rc)((0,g.$Sc)(y),a),this.d.add(Re)}).finally(()=>{Re.dispose(),this.d.delete(Re)})}o(_,fe,he){const Fe=this.g++,pe={id:Fe,type:102,channelName:_,name:fe,arg:he};let Se=null;const Re=new d.$he({onWillAddFirstListener:()=>{Se=(0,C.$nh)(me=>this.u()),Se.then(()=>{Se=null,this.d.add(Re),this.p(pe)})},onDidRemoveLastListener:()=>{Se?(Se.cancel(),Se=null):(this.d.delete(Re),this.p({id:Fe,type:103}))}}),re=me=>Re.fire(me.data);return this.f.set(Fe,re),Re.event}p(_){switch(_.type){case 100:case 102:{const fe=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(fe,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const fe=this.q([_.type,_.id]);this.j?.logOutgoing(fe,_.id,0,e(_.type));return}}}q(_,fe=void 0){const he=new r;return H(he,_),H(he,fe),this.r(he.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const fe=new b(_),he=w(fe),Fe=w(fe),Z=he[0];switch(Z){case 200:return this.j?.logIncoming(_.byteLength,0,0,o(Z)),this.t({type:he[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,he[1],0,o(Z),Fe),this.t({type:he[0],id:he[1],data:Fe})}}t(_){if(_.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Pc)(this.d.values()),this.d.clear()}}t.$di=N,Je([E.$5h],N.prototype,"onDidInitializePromise",null);class x{get connections(){const _=[];return this.f.forEach(fe=>_.push(fe)),_}constructor(_,fe,he){this.a=new Map,this.f=new Set,this.g=new d.$he,this.onDidAddConnection=this.g.event,this.h=new d.$he,this.onDidRemoveConnection=this.h.event,this.j=new g.$Tc,this.j.add(_(({protocol:Fe,onDidClientDisconnect:Z})=>{const pe=d.Event.once(Fe.onMessage);this.j.add(pe(Se=>{const Re=new b(Se),re=w(Re),me=new j(Fe,re,fe,he),J=new N(Fe,fe);this.a.forEach((u,y)=>me.registerChannel(y,u));const O={channelServer:me,channelClient:J,ctx:re};this.f.add(O),this.g.fire(O),this.j.add(Z(()=>{me.dispose(),J.dispose(),this.f.delete(O),this.h.fire(O)}))}))}))}getChannel(_,fe){const he=this;return{call(Fe,Z,pe){let Se;if((0,c.$og)(fe)){const re=(0,i.$3b)(he.connections.filter(fe));Se=re?Promise.resolve(re):d.Event.toPromise(d.Event.filter(he.onDidAddConnection,fe))}else Se=fe.routeCall(he,Fe,Z);const Re=Se.then(re=>re.channelClient.getChannel(_));return Q(Re).call(Fe,Z,pe)},listen(Fe,Z){if((0,c.$og)(fe))return he.k(_,fe,Fe,Z);const pe=fe.routeEvent(he,Fe,Z).then(Se=>Se.channelClient.getChannel(_));return Q(pe).listen(Fe,Z)}}}k(_,fe,he,Fe){const Z=this;let pe;const Se=new d.$he({onWillAddFirstListener:()=>{pe=new g.$Tc;const Re=new d.$ne,re=new Map,me=O=>{const y=O.channelClient.getChannel(_).listen(he,Fe),a=Re.add(y);re.set(O,a)},J=O=>{const u=re.get(O);u&&(u.dispose(),re.delete(O))};Z.connections.filter(fe).forEach(me),d.Event.filter(Z.onDidAddConnection,fe)(me,void 0,pe),Z.onDidRemoveConnection(J,void 0,pe),Re.event(Se.fire,Se,pe),pe.add(Re)},onDidRemoveLastListener:()=>{pe?.dispose(),pe=void 0}});return Se.event}registerChannel(_,fe){this.a.set(_,fe);for(const he of this.f)he.channelServer.registerChannel(_,fe)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ei=x;class M{constructor(_,fe,he=null){const Fe=new r;H(Fe,fe),_.send(Fe.buffer),this.a=new N(_,he),this.d=new j(_,fe,he)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,fe){this.d.registerChannel(_,fe)}dispose(){this.a.dispose(),this.d.dispose()}}t.$fi=M;function Q(le){return{call(_,fe,he){return le.then(Fe=>Fe.call(_,fe,he))},listen(_,fe){const he=new d.$qe;return le.then(Fe=>he.input=Fe.listen(_,fe)),he.event}}}function ie(le){let _=!1;return{call(fe,he,Fe){return _?le.call(fe,he,Fe):(0,C.$Bh)(0).then(()=>_=!0).then(()=>le.call(fe,he,Fe))},listen(fe,he){if(_)return le.listen(fe,he);const Fe=new d.$qe;return(0,C.$Bh)(0).then(()=>_=!0).then(()=>Fe.input=le.listen(fe,he)),Fe.event}}}class ue{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const fe of _.connections)if(await Promise.resolve(this.a(fe.ctx)))return Promise.resolve(fe);return await d.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$ii=ue;var G;(function(le){function _(Z,pe,Se){const Re=Z,re=Se&&Se.disableMarshalling,me=new Map;for(const J in Re)he(J)&&me.set(J,d.Event.buffer(Re[J],!0,void 0,pe));return new class{listen(J,O,u){const y=me.get(O);if(y)return y;const a=Re[O];if(typeof a=="function"){if(Fe(O))return a.call(Re,u);if(he(O))return me.set(O,d.Event.buffer(Re[O],!0,void 0,pe)),me.get(O)}throw new A.$bb(`Event not found: ${O}`)}call(J,O,u){const y=Re[O];if(typeof y=="function"){if(!re&&Array.isArray(u))for(let D=0;D<u.length;D++)u[D]=(0,$.$0h)(u[D]);let a=y.apply(Re,u);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new A.$bb(`Method not found: ${O}`)}}}le.fromService=_;function fe(Z,pe){const Se=pe&&pe.disableMarshalling;return new Proxy({},{get(Re,re){if(typeof re=="string")return pe?.properties?.has(re)?pe.properties.get(re):Fe(re)?function(me){return Z.listen(re,me)}:he(re)?Z.listen(re):async function(...me){let J;pe&&!(0,c.$jg)(pe.context)?J=[pe.context,...me]:J=me;const O=await Z.call(re,J);return Se?O:(0,$.$0h)(O)};throw new A.$bb(`Property not found: ${String(re)}`)}})}le.toService=fe;function he(Z){return Z[0]==="o"&&Z[1]==="n"&&P.$Af(Z.charCodeAt(2))}function Fe(Z){return/^onDynamic/.test(Z)&&P.$Af(Z.charCodeAt(9))}})(G||(t.ProxyChannel=G={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function de(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function ye(le){return Array.isArray(le)?le.map(de):de(le)}function Ae(le,_,fe,he,Fe,Z,pe){pe=ye(pe);const Se=ee[Fe],Re=Se[he%Se.length];let re=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(fe).padStart(5," ")}]%c${String(he).padStart(5," ")} - ${Z}`,"color: darkgreen","color: grey","color: grey",`color: ${Re}`];/\($/.test(Z)?(re=re.concat(pe),re.push(")")):re.push(pe),console.log.apply(console,re)}class je{constructor(_,fe){this.d=_,this.f=fe,this.a=0,this.b=0}logOutgoing(_,fe,he,Fe,Z){this.b+=_,Ae(this.d,this.b,_,fe,he,Fe,Z)}logIncoming(_,fe,he,Fe,Z){this.a+=_,Ae(this.f,this.a,_,fe,he,Fe,Z)}}t.$ji=je}),define(we[145],ve([1,0,43,3,77,102,35]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wW=void 0;class A extends B.$fi{static f(){const g=C.Event.fromNodeEventEmitter(E.$O,"vscode:message",($,P)=>i.$Je.wrap(P));return E.$O.send("vscode:hello"),new U.$sW(E.$O,g)}constructor(g){const $=A.f();super($,g),this.b=$}dispose(){this.b.disconnect(),super.dispose()}}t.$wW=A}),define(we[146],ve([13,12]),function(se,t){return se.create("vs/platform/files/common/files",t)}),define(we[147],ve([13,12]),function(se,t){return se.create("vs/platform/theme/common/iconRegistry",t)}),define(we[50],ve([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zi=t._util=void 0,t.$Ai=B,t.$Bi=U;var i;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function A(d){return d[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=A})(i||(t._util=i={})),t.$zi=B("instantiationService");function C(E,A,d){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:E,index:d}):(A[i.DI_DEPENDENCIES]=[{id:E,index:d}],A[i.DI_TARGET]=A)}function B(E){if(i.serviceIds.has(E))return i.serviceIds.get(E);const A=function(d,g,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(A,d,$)};return A.toString=()=>E,i.serviceIds.set(E,A),A}function U(E){return E}}),define(we[148],ve([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jn=t.$hn=t.ID=void 0,t.$in=C,t.ID="diagnosticsService",t.$hn=(0,i.$Ai)(t.ID);function C(U){return!!U.hostName&&!!U.errorMessage}class B{async getPerformanceInfo(E,A){return{}}async getSystemInfo(E,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(E,A){return""}async getWorkspaceFileExtensions(E){return{extensions:[]}}async reportWorkspaceStats(E){}}t.$jn=B}),define(we[149],ve([1,0,99,25,9,10,16,146,50,5,36,23]),function(se,t,i,C,B,U,E,A,d,g,$,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cl=t.$zl=t.FileKind=t.$yl=t.$xl=t.$wl=t.$vl=t.$ul=t.$tl=t.$sl=t.FileOperationResult=t.$rl=t.$ql=t.$pl=t.$nl=t.FileChangeType=t.$ml=t.FileOperation=t.$gl=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$7k=void 0,t.$8k=c,t.$9k=o,t.$0k=h,t.$$k=v,t.$_k=m,t.$al=b,t.$bl=r,t.$cl=p,t.$dl=S,t.$el=F,t.$fl=I,t.$hl=j,t.$il=W,t.$jl=N,t.$kl=x,t.$ll=M,t.$ol=ee,t.$Al=_,t.$Bl=fe,t.$Dl=Fe,t.$7k=(0,d.$Ai)("fileService");function c(Z){return Z.create===!0}var l;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(l||(t.FileType=l={}));var e;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var n;(function(Z){Z[Z.UPDATED=2]="UPDATED",Z[Z.ADDED=4]="ADDED",Z[Z.DELETED=8]="DELETED"})(n||(t.FileChangeFilter=n={}));function o(Z){const pe=Z;return!!pe&&typeof pe.onDidChange=="function"}var f;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(f||(t.FileSystemProviderCapabilities=f={}));function h(Z){return!!(Z.capabilities&2)}function v(Z){return!!(Z.capabilities&8)}function m(Z){return!!(Z.capabilities&131072)}function b(Z){return!!(Z.capabilities&4)}function r(Z){return!!(Z.capabilities&16)}function p(Z){return h(Z)?!!(Z.capabilities&16384):!1}function S(Z){return h(Z)?!!(Z.capabilities&32768):!1}function F(Z){return!!(Z.capabilities&65536)}function I(Z){return!!(Z.capabilities&2048)}var H;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(H||(t.FileSystemProviderErrorCode=H={}));class w extends Error{static create(pe,Se){const Re=new w(pe.toString(),Se);return N(Re,Se),Re}constructor(pe,Se){super(pe),this.code=Se}}t.$gl=w;function j(Z,pe){return w.create(Z,pe)}function W(Z){return Z||j((0,A.localize)(0,null),H.Unknown)}function N(Z,pe){return Z.name=pe?`${pe} (FileSystemError)`:"FileSystemError",Z}function x(Z){if(!Z)return H.Unknown;if(Z instanceof w)return Z.code;const pe=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!pe)return H.Unknown;switch(pe[1]){case H.FileExists:return H.FileExists;case H.FileIsADirectory:return H.FileIsADirectory;case H.FileNotADirectory:return H.FileNotADirectory;case H.FileNotFound:return H.FileNotFound;case H.FileTooLarge:return H.FileTooLarge;case H.FileWriteLocked:return H.FileWriteLocked;case H.NoPermissions:return H.NoPermissions;case H.Unavailable:return H.Unavailable}return H.Unknown}function M(Z){if(Z instanceof de)return Z.fileOperationResult;switch(x(Z)){case H.FileNotFound:return 1;case H.FileIsADirectory:return 0;case H.FileNotADirectory:return 9;case H.FileWriteLocked:return 5;case H.NoPermissions:return 6;case H.FileExists:return 4;case H.FileTooLarge:return 7;default:return 10}}var Q;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(Q||(t.FileOperation=Q={}));class ie{constructor(pe,Se,Re){this.resource=pe,this.operation=Se,this.target=Re}isOperation(pe){return this.operation===pe}}t.$ml=ie;var ue;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(ue||(t.FileChangeType=ue={}));class G{static{this.a=null}constructor(pe,Se){this.c=Se,this.b=void 0,this.d=new P.$V(()=>{const Re=i.$Gi.forUris(()=>this.c);return Re.fill(this.rawAdded.map(re=>[re,!0])),Re}),this.f=new P.$V(()=>{const Re=i.$Gi.forUris(()=>this.c);return Re.fill(this.rawUpdated.map(re=>[re,!0])),Re}),this.g=new P.$V(()=>{const Re=i.$Gi.forUris(()=>this.c);return Re.fill(this.rawDeleted.map(re=>[re,!0])),Re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Re of pe){switch(Re.type){case 1:this.rawAdded.push(Re.resource);break;case 0:this.rawUpdated.push(Re.resource);break;case 2:this.rawDeleted.push(Re.resource);break}this.b!==G.a&&(typeof Re.cId=="number"?this.b===void 0?this.b=Re.cId:this.b!==Re.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(pe,...Se){return this.h(pe,{includeChildren:!1},...Se)}affects(pe,...Se){return this.h(pe,{includeChildren:!0},...Se)}h(pe,Se,...Re){if(!pe)return!1;const re=Re.length>0;return!!((!re||Re.includes(1))&&(this.d.value.get(pe)||Se.includeChildren&&this.d.value.findSuperstr(pe))||(!re||Re.includes(0))&&(this.f.value.get(pe)||Se.includeChildren&&this.f.value.findSuperstr(pe))||(!re||Re.includes(2))&&(this.g.value.findSubstr(pe)||Se.includeChildren&&this.g.value.findSuperstr(pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(pe){return this.b===pe}hasCorrelation(){return typeof this.b=="number"}}t.$nl=G;function ee(Z,pe,Se){return!Z||!pe||Z===pe||pe.length>Z.length?!1:(pe.charAt(pe.length-1)!==C.sep&&(pe+=C.sep),Se?(0,B.$Cf)(Z,pe):Z.indexOf(pe)===0)}class de extends Error{constructor(pe,Se,Re){super(pe),this.fileOperationResult=Se,this.options=Re}}t.$pl=de;class ye extends de{constructor(pe,Se,Re,re){super(pe,Se,re),this.fileOperationResult=Se,this.size=Re}}t.$ql=ye;class Ae extends de{constructor(pe,Se,Re){super(pe,2,Re),this.stat=Se}}t.$rl=Ae;var je;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(je||(t.FileOperationResult=je={})),t.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$ul="files.associations",t.$vl="files.exclude",t.$wl="files.readonlyInclude",t.$xl="files.readonlyExclude",t.$yl="files.readonlyFromPermissions";var le;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(t.FileKind=le={})),t.$zl="";function _(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}async function fe(Z,pe){if(!pe.hasProvider(E.URI.from({scheme:Z.scheme})))return new Promise(Se=>{const Re=pe.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===Z.scheme&&re.added&&(Re.dispose(),Se())})})}class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize(pe){return(0,U.$eg)(pe)||(pe=0),pe<he.KB?(0,A.localize)(1,null,pe.toFixed(0)):pe<he.MB?(0,A.localize)(2,null,(pe/he.KB).toFixed(2)):pe<he.GB?(0,A.localize)(3,null,(pe/he.MB).toFixed(2)):pe<he.TB?(0,A.localize)(4,null,(pe/he.GB).toFixed(2)):(0,A.localize)(5,null,(pe/he.TB).toFixed(2))}}t.$Cl=he;function Fe(Z){const pe=typeof Z=="string"||Z?.scheme===$.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===$.Schemas.file?1024*he.MB:pe?10*he.MB:g.$o?50*he.MB:1024*he.MB}}),define(we[150],ve([1,0,50]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qec=t.$Pec=void 0,t.$Pec=(0,i.$Ai)("mainProcessService");class C{constructor(U,E){this.a=U,this.b=E}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,E){this.a.registerChannel(U,E)}}t.$Qec=C}),define(we[151],ve([1,0,2,145]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rec=void 0;class B extends i.$Uc{constructor(E){super(),this.a=this.B(new C.$wW(`window:${E}`))}getChannel(E){return this.a.getChannel(E)}registerChannel(E,A){this.a.registerChannel(E,A)}}t.$Rec=B});var Ei=this&&this.__param||function(se,t){return function(i,C){t(i,C,se)}};define(we[152],ve([1,0,77,150]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vec=void 0;let B=class{constructor(E,A){return this.windowId=E,i.ProxyChannel.toService(A.getChannel("nativeHost"),{context:E,properties:(()=>{const d=new Map;return d.set("windowId",E),d})()})}};t.$Vec=B,t.$Vec=B=Je([Ei(1,C.$Pec)],B)}),define(we[78],ve([1,0,37,10]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ho=void 0;class B{constructor(){this.a=new Map}add(E,A){i.ok(C.$ag(E)),i.ok(C.$cg(A)),i.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,A)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}t.$ho=new B}),define(we[153],ve([1,0,3,78]),function(se,t,i,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$io=void 0,t.$io={JSONContribution:"base.contributions.json"};function B(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class U{constructor(){this.b=new i.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,g){this.a[B(d)]=g,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const E=new U;C.$ho.add(t.$io.JSONContribution,E)}),define(we[154],ve([1,0,11,18,45,19,3,10,16,147,153,78]),function(se,t,i,C,B,U,E,A,d,g,$,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sx=t.$rx=t.$qx=t.$px=t.$ox=t.$nx=t.IconFontDefinition=t.IconContribution=t.$kx=void 0,t.$lx=o,t.$mx=f,t.$kx={IconContribution:"base.contributions.icons"};var c;(function(b){function r(p,S){let F=p.defaults;for(;U.ThemeIcon.isThemeIcon(F);){const I=n.getIcon(F.id);if(!I)return;F=I.defaults}return F}b.getDefinition=r})(c||(t.IconContribution=c={}));var l;(function(b){function r(S){return{weight:S.weight,style:S.style,src:S.src.map(F=>({format:F.format,location:F.location.toString()}))}}b.toJSONObject=r;function p(S){const F=I=>(0,A.$ag)(I)?I:void 0;if(S&&Array.isArray(S.src)&&S.src.every(I=>(0,A.$ag)(I.format)&&(0,A.$ag)(I.location)))return{weight:F(S.weight),style:F(S.style),src:S.src.map(I=>({format:I.format,location:d.URI.parse(I.location)}))}}b.fromJSONObject=p})(l||(t.IconFontDefinition=l={}));class e{constructor(){this.a=new E.$he,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${U.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,p,S,F){const I=this.b[r];if(I){if(S&&!I.description){I.description=S,this.d.properties[r].markdownDescription=`${S} $(${r})`;const j=this.e.enum.indexOf(r);j!==-1&&(this.e.enumDescriptions[j]=S),this.a.fire()}return I}const H={id:r,description:S,defaults:p,deprecationMessage:F};this.b[r]=H;const w={$ref:"#/definitions/icons"};return F&&(w.deprecationMessage=F),S&&(w.markdownDescription=`${S}: $(${r})`),this.d.properties[r]=w,this.e.enum.push(r),this.e.enumDescriptions.push(S||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const p=this.e.enum.indexOf(r);p!==-1&&(this.e.enum.splice(p,1),this.e.enumDescriptions.splice(p,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,p){const S=this.f[r];return S||(this.f[r]=p,this.a.fire(),p)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(I,H)=>I.id.localeCompare(H.id),p=I=>{for(;U.ThemeIcon.isThemeIcon(I.defaults);)I=this.b[I.defaults.id];return`codicon codicon-${I?I.id:""}`},S=[];S.push("| preview     | identifier                        | default codicon ID                | description"),S.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const F=Object.keys(this.b).map(I=>this.b[I]);for(const I of F.filter(H=>!!H.description).sort(r))S.push(`|<i class="${p(I)}"></i>|${I.id}|${U.ThemeIcon.isThemeIcon(I.defaults)?I.defaults.id:I.id}|${I.description||""}|`);S.push("| preview     | identifier                        "),S.push("| ----------- | --------------------------------- |");for(const I of F.filter(H=>!U.ThemeIcon.isThemeIcon(H.defaults)).sort(r))S.push(`|<i class="${p(I)}"></i>|${I.id}|`);return S.join(`
`)}}const n=new e;P.$ho.add(t.$kx.IconContribution,n);function o(b,r,p,S){return n.registerIcon(b,r,p,S)}function f(){return n}function h(){const b=(0,B.$Vj)();for(const r in b){const p="\\"+b[r].toString(16);n.registerIcon(r,{fontCharacter:p})}}h(),t.$nx="vscode://schemas/icons";const v=P.$ho.as($.$io.JSONContribution);v.registerSchema(t.$nx,n.getIconSchema());const m=new i.$Mh(()=>v.notifySchemaChanged(t.$nx),200);n.onDidChange(()=>{m.isScheduled()||m.schedule()}),t.$ox=o("widget-close",C.$Zj.close,(0,g.localize)(2,null)),t.$px=o("goto-previous-location",C.$Zj.arrowUp,(0,g.localize)(3,null)),t.$qx=o("goto-next-location",C.$Zj.arrowDown,(0,g.localize)(4,null)),t.$rx=U.ThemeIcon.modify(C.$Zj.sync,"spin"),t.$sx=U.ThemeIcon.modify(C.$Zj.loading,"spin")}),define(we[155],ve([1,0,4,3,2,19,154]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$W=void 0,t.$0W=A;function A(g){const $=new B.$Tc,P=$.add(new C.$he),c=(0,E.$mx)();return $.add(c.onDidChange(()=>P.fire())),g&&$.add(g.onDidProductIconThemeChange(()=>P.fire())),{dispose:()=>$.dispose(),onDidChange:P.event,getCSS(){const l=g?g.getProductIconTheme():new d,e={},n=[],o=[];for(const f of c.getIcons()){const h=l.getIcon(f);if(!h)continue;const v=h.font,m=`--vscode-icon-${f.id}-font-family`,b=`--vscode-icon-${f.id}-content`;v?(e[v.id]=v.definition,o.push(`${m}: ${(0,i.$BS)(v.id)};`,`${b}: '${h.fontCharacter}';`),n.push(`.codicon-${f.id}:before { content: '${h.fontCharacter}'; font-family: ${(0,i.$BS)(v.id)}; }`)):(o.push(`${b}: '${h.fontCharacter}'; ${m}: 'codicon';`),n.push(`.codicon-${f.id}:before { content: '${h.fontCharacter}'; }`))}for(const f in e){const h=e[f],v=h.weight?`font-weight: ${h.weight};`:"",m=h.style?`font-style: ${h.style};`:"",b=h.src.map(r=>`${(0,i.$AS)(r.location)} format('${r.format}')`).join(", ");n.push(`@font-face { src: ${b}; font-family: ${(0,i.$BS)(f)};${v}${m} font-display: block; }`)}return n.push(`:root { ${o.join(" ")} }`),n.join(`
`)}}}class d{getIcon($){const P=(0,E.$mx)();let c=$.defaults;for(;U.ThemeIcon.isThemeIcon(c);){const l=P.getIcon(c.id);if(!l)return;c=l.defaults}return c}}t.$$W=d}),define(we[156],ve([1,0,5]),function(se,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PD=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$GD=void 0,t.$HD=C,t.$ID=B,t.$JD=U,t.$KD=E,t.$LD=A,t.$MD=P,t.$ND=c,t.$OD=l,t.$QD=e,t.$RD=n,t.$SD=o,t.$GD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(f){return typeof f.parentId=="number"}function B(f){return!!f.workspaceUri}function U(f){return!!f.folderUri}function E(f){return!!f.fileUri}function A(f){const h=c(f),v=f.getValue("window.menuBarVisibility");return v==="default"||h&&v==="compact"||i.$j&&i.$m?"classic":v}var d;(function(f){f.TITLE_BAR_STYLE="window.titleBarStyle",f.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(d||(t.TitleBarSetting=d={}));var g;(function(f){f.NATIVE="native",f.CUSTOM="custom"})(g||(t.TitlebarStyle=g={}));var $;(function(f){f.AUTO="auto",f.WINDOWED="windowed",f.NEVER="never"})($||(t.CustomTitleBarVisibility=$={}));function P(f,h){return!0}function c(f,h){return h||(h=l(f)),h==="native"}function l(f){if(i.$o)return"custom";const h=f.getValue("window");if(h){if(i.$j&&h.nativeTabs===!0||i.$j&&h.nativeFullScreen===!1)return"native";const b=h.titleBarStyle;if(b==="native"||b==="custom")return b}return i.$k?"native":"custom"}t.$PD=35;function e(f){return!(!i.$i||i.$o||c(f))}function n(f){const h=f.getValue("window");return!h||typeof h.nativeFullScreen!="boolean"||h.nativeTabs?!0:h.nativeFullScreen!==!1}function o(f=0){return Math.pow(1.2,f)}}),define(we[157],ve([1,0,17,4,22,35,156]),function(se,t,i,C,B,U,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xec=t.$Wec=t.ApplyZoomTarget=void 0,t.$Yec=d,t.$Zec=$,t.$1ec=P;var A;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(A||(t.ApplyZoomTarget=A={})),t.$Wec=8,t.$Xec=-8;function d(c,l){c=Math.min(Math.max(c,t.$Xec),t.$Wec);const e=[];l===A.ACTIVE_WINDOW?e.push((0,C.$2R)()):l===A.ALL_WINDOWS?e.push(...Array.from((0,C.getWindows)()).map(({window:n})=>n)):e.push(l);for(const n of e)g(n)?.webFrame?.setZoomLevel(c),(0,i.$YQ)((0,E.$SD)(c),n),(0,i.$UQ)(c,n)}function g(c){if(c===B.$QQ)return{ipcRenderer:U.$O,webFrame:U.$Q};{const l=c;if(l?.vscode?.ipcRenderer&&l?.vscode?.webFrame)return l.vscode}}function $(c){d((0,i.$VQ)(typeof c=="number"?(0,C.$2R)():c)+1,c)}function P(c){d((0,i.$VQ)(typeof c=="number"?(0,C.$2R)():c)-1,c)}}),define(we[158],ve([1,0,12,4,144,11,103,35,148,149,151,152,155,157,15,22,116,107]),function(se,t,i,C,B,U,E,A,d,g,$,P,c,l,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=j;const o=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,f=/\s--inspect-port=(?<port>\d+)/;class h{getHeight(N){return 22}getTemplateId(N){return I(N)?"process":S(N)?"machine":(0,d.$in)(N)?"error":F(N)?"header":""}}class v{hasChildren(N){return(0,d.$in)(N)?!1:I(N)?!!N.children?.length:!0}getChildren(N){return I(N)?N.children?N.children:[]:(0,d.$in)(N)?[]:F(N)?N.processRoots.length>1?N.processRoots:[N.processRoots[0].rootProcess]:S(N)?[N.rootProcess]:[N.processes]}}class m{constructor(){this.templateId="header"}renderTemplate(N){const x=(0,C.$kS)(N,(0,C.$)(".row")),M=(0,C.$kS)(x,(0,C.$)(".nameLabel")),Q=(0,C.$kS)(x,(0,C.$)(".cpu")),ie=(0,C.$kS)(x,(0,C.$)(".memory")),ue=(0,C.$kS)(x,(0,C.$)(".pid"));return{name:M,CPU:Q,memory:ie,PID:ue}}renderElement(N,x,M,Q){M.name.textContent=(0,i.localize)(0,null),M.CPU.textContent=(0,i.localize)(1,null),M.PID.textContent=(0,i.localize)(2,null),M.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(N){}}class b{constructor(){this.templateId="machine"}renderTemplate(N){const x=Object.create(null),M=(0,C.$kS)(N,(0,C.$)(".row"));return x.name=(0,C.$kS)(M,(0,C.$)(".nameLabel")),x}renderElement(N,x,M,Q){M.name.textContent=N.element.name}disposeTemplate(N){}}class r{constructor(){this.templateId="error"}renderTemplate(N){const x=Object.create(null),M=(0,C.$kS)(N,(0,C.$)(".row"));return x.name=(0,C.$kS)(M,(0,C.$)(".nameLabel")),x}renderElement(N,x,M,Q){M.name.textContent=N.element.errorMessage}disposeTemplate(N){}}class p{constructor(N,x,M){this.a=N,this.b=x,this.c=M,this.templateId="process"}renderTemplate(N){const x=(0,C.$kS)(N,(0,C.$)(".row")),M=(0,C.$kS)(x,(0,C.$)(".nameLabel")),Q=(0,C.$kS)(x,(0,C.$)(".cpu")),ie=(0,C.$kS)(x,(0,C.$)(".memory")),ue=(0,C.$kS)(x,(0,C.$)(".pid"));return{name:M,CPU:Q,PID:ue,memory:ie}}renderElement(N,x,M,Q){const{element:ie}=N,ue=ie.pid.toFixed(0);let G=ie.name;this.c.has(ie.pid)&&(G=this.c.get(ie.pid)),M.name.textContent=G,M.name.title=ie.cmd,M.CPU.textContent=ie.load.toFixed(0),M.PID.textContent=ue,M.PID.parentElement.id=`pid-${ue}`;const ee=this.a==="win32"?ie.mem:this.b*(ie.mem/100);M.memory.textContent=(ee/g.$Cl.MB).toFixed(0)}disposeTemplate(N){}}function S(W){return!!W.name&&!!W.rootProcess}function F(W){return!!W.processRoots}function I(W){return!!W.pid}class H{constructor(N,x){this.f=x,this.b=new Map;const M=new $.$Rec(N);this.c=new P.$Vec(N,M),this.k(x.styles),this.g(x),A.$O.on("vscode:pidToNameResponse",(Q,ie)=>{this.b.clear();for(const[ue,G]of ie)this.b.set(ue,G)}),A.$O.on("vscode:listProcessesResponse",async(Q,ie)=>{ie.forEach((ue,G)=>{I(ue.rootProcess)&&(ue.rootProcess.name=G===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ie}}),this.d.layout(n.$QQ.innerHeight,n.$QQ.innerWidth)):await this.h(ie),this.m(0)}),this.a=Date.now(),A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")}g(N){n.$QQ.document.onkeydown=x=>{const M=N.platform==="darwin"?x.metaKey:x.ctrlKey;M&&x.keyCode===87&&(x.stopPropagation(),x.preventDefault(),A.$O.send("vscode:closeProcessExplorer")),M&&x.keyCode===187&&(0,l.$Zec)(n.$QQ),M&&x.keyCode===189&&(0,l.$1ec)(n.$QQ)}}async h(N){const x=n.$QQ.document.getElementById("process-list");if(!x)return;const{totalmem:M}=await this.c.getOSStatistics(),Q=[new p(this.f.platform,M,this.b),new m,new b,new r];this.d=new B.$VV("processExplorer",x,new h,Q,new v,{identityProvider:{getId:ie=>I(ie)?ie.pid.toString():(0,d.$in)(ie)?ie.hostName:F(ie)?"processes":S(ie)?ie.name:"header"}}),this.d.setInput({processes:{processRoots:N}}),this.d.layout(n.$QQ.innerHeight,n.$QQ.innerWidth),this.d.onKeyDown(ie=>{const ue=new e.$hR(ie);if(ue.keyCode===35&&ue.altKey){const G=this.n();Promise.all(G.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ie=>{I(ie.element)&&this.l(ie.element,!0)}),x.style.height=`${n.$QQ.innerHeight}px`,n.$QQ.addEventListener("resize",()=>{x.style.height=`${n.$QQ.innerHeight}px`,this.d?.layout(n.$QQ.innerHeight,n.$QQ.innerWidth)})}i(N){const x=o.exec(N);return x&&x.groups.port!=="0"||N.indexOf("node ")>=0||N.indexOf("node.exe")>=0}j(N){const x={type:"node",request:"attach",name:`process ${N.pid}`};let M=o.exec(N.cmd);M?x.port=Number(M.groups.port):x.processId=String(N.pid),M=f.exec(N.cmd),M&&(x.port=Number(M.groups.port)),A.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[x]})}k(N){const x=(0,C.$5R)(),M=[];N.listFocusBackground&&(M.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${N.listFocusBackground}; }`),M.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${N.listFocusBackground}; }`)),N.listFocusForeground&&M.push(`.monaco-list:focus .monaco-list-row.focused { color: ${N.listFocusForeground}; }`),N.listActiveSelectionBackground&&(M.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${N.listActiveSelectionBackground}; }`),M.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${N.listActiveSelectionBackground}; }`)),N.listActiveSelectionForeground&&M.push(`.monaco-list:focus .monaco-list-row.selected { color: ${N.listActiveSelectionForeground}; }`),N.listHoverBackground&&M.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${N.listHoverBackground}; }`),N.listHoverForeground&&M.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${N.listHoverForeground}; }`),N.listFocusOutline&&M.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${N.listFocusOutline}; outline-offset: -1px; }`),N.listHoverOutline&&M.push(`.monaco-list-row:hover { outline: 1px dashed ${N.listHoverOutline}; outline-offset: -1px; }`),N.scrollbarShadowColor&&M.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${N.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),N.scrollbarSliderBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${N.scrollbarSliderBackgroundColor};
				}
			`),N.scrollbarSliderHoverBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${N.scrollbarSliderHoverBackgroundColor};
				}
			`),N.scrollbarSliderActiveBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${N.scrollbarSliderActiveBackgroundColor};
				}
			`),x.textContent=M.join(`
`),N.color&&(n.$QQ.document.body.style.color=N.color)}l(N,x){const M=[],Q=Number(N.pid);x&&(M.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(Q,"SIGTERM")}}),M.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(Q,"SIGKILL")}}),M.push({type:"separator"})),M.push({label:(0,i.localize)(6,null),click:()=>{const ie=this.n();ie?.includes(Q)||(ie.length=0,ie.push(Q));const ue=ie?.map(G=>n.$QQ.document.getElementById(`pid-${G}`)).filter(G=>!!G);if(ue){const G=ue.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(G.join(`
`))}}}),M.push({label:(0,i.localize)(7,null),click:()=>{const ie=n.$QQ.document.getElementById("process-list");ie&&this.c.writeClipboardText(ie.innerText)}}),N&&x&&this.i(N.cmd)&&(M.push({type:"separator"}),M.push({label:(0,i.localize)(8,null),click:()=>{this.j(N)}})),(0,E.$oW)(M)}m(N){setTimeout(()=>{const x=Date.now(),M=N+x-this.a;this.a=x,M>1e3?(A.$O.send("vscode:pidToNameRequest"),A.$O.send("vscode:listProcesses")):this.m(M)},200)}n(){return this.d?.getSelection()?.map(N=>{if(!(!N||!("pid"in N)))return N.pid}).filter(N=>!!N)}}function w(){const W=(0,C.$5R)();W.id="codiconStyles";const N=(0,c.$0W)(void 0);function x(){W.textContent=N.getCSS()}const M=new U.$Mh(x,0);N.onDidChange(()=>M.schedule()),M.schedule()}function j(W){const N=W.data.platform==="win32"?"windows":W.data.platform==="linux"?"linux":"mac";n.$QQ.document.body.classList.add(N),w(),(0,l.$Yec)(W.data.zoomLevel,n.$QQ),new H(W.windowId,W.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
