/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],oe=function(Q){for(var e=[],N=0,A=Q.length;N<A;N++)e[N]=re[Q[N]];return e};define(re[74],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class N{static get(){const P=new Map,L=new Map,D=new Map,E=new Map;function l(w,p){w.has(p.detail)||w.set(p.detail,-p.timestamp)}function a(w,p){const R=w.get(p.detail);R&&(R>=0||w.set(p.detail,R+p.timestamp))}let h=[];typeof Q=="function"&&typeof Q.getStats=="function"&&(h=Q.getStats().slice(0).sort((w,p)=>w.timestamp-p.timestamp));for(const w of h)switch(w.type){case 10:l(P,w);break;case 11:case 12:a(P,w);break;case 21:l(L,w);break;case 22:a(L,w);break;case 33:l(D,w);break;case 34:a(D,w);break;case 31:l(E,w);break;case 32:a(E,w);break}let b=0;D.forEach(w=>b+=w);function y(w){const p=[];return w.forEach((R,d)=>p.push([d,R])),p}return{amdLoad:y(P),amdInvoke:y(L),nodeRequire:y(D),nodeEval:y(E),nodeRequireTotal:b}}static toMarkdownTable(P,L){let D="";const E=[];return P.forEach((l,a)=>{E[a]=l.length}),L.forEach(l=>{l.forEach((a,h)=>{typeof a>"u"&&(a=l[h]="-");const b=a.toString().length;E[h]=Math.max(b,E[h])})}),P.forEach((l,a)=>{D+=`| ${l+" ".repeat(E[a]-l.toString().length)} `}),D+=`|
`,P.forEach((l,a)=>{D+=`| ${"-".repeat(E[a])} `}),D+=`|
`,L.forEach(l=>{l.forEach((a,h)=>{typeof a<"u"&&(D+=`| ${a+" ".repeat(E[h]-a.toString().length)} `)}),D+=`|
`}),D}}e.$U=N}),define(re[55],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=A,e.$6h=P,e.$7h=L;function N(D){return(E,l,a)=>{let h=null,b=null;if(typeof a.value=="function"?(h="value",b=a.value):typeof a.get=="function"&&(h="get",b=a.get),!b)throw new Error("not supported");a[h]=D(b,l)}}function A(D,E,l){let a=null,h=null;if(typeof l.value=="function"?(a="value",h=l.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(a="get",h=l.get),!h)throw new Error("not supported");const b=`$memoize$${E}`;l[a]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,y)}),this[b]}}function P(D,E,l){return N((a,h)=>{const b=`$debounce$${h}`,y=`$debounce$result$${h}`;return function(...w){this[y]||(this[y]=l?l():void 0),clearTimeout(this[b]),E&&(this[y]=E(this[y],...w),w=[this[y]]),this[b]=setTimeout(()=>{a.apply(this,w),this[y]=l?l():void 0},D)}})}function L(D,E,l){return N((a,h)=>{const b=`$throttle$timer$${h}`,y=`$throttle$result$${h}`,w=`$throttle$lastRun$${h}`,p=`$throttle$pending$${h}`;return function(...R){if(this[y]||(this[y]=l?l():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),E&&(this[y]=E(this[y],...R)),this[p])return;const d=this[w]+D;d<=Date.now()?(this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=l?l():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[w]=Date.now(),a.apply(this,[this[y]]),this[y]=l?l():void 0},d-Date.now()))}})}}),define(re[75],oe([0,1,9]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=A,e.$ed=P,e.$fd=L,e.$gd=D,e.$hd=E,e.$id=l;function A(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function P(a,h="Unreachable"){throw new Error(h)}function L(a,h="unexpected state"){if(!a)throw new N.$cb(`Assertion Failed: ${h}`)}function D(a){a||(0,N.$1)(new N.$cb("Soft Assertion Failed"))}function E(a){if(!a()){debugger;a(),(0,N.$1)(new N.$cb("Assertion Failed"))}}function l(a,h){let b=0;for(;b<a.length-1;){const y=a[b],w=a[b+1];if(!h(y,w))return!1;b++}return!0}}),define(re[38],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Ln=D,e.$Mn=b,e.$Nn=y,e.$On=w,e.$Pn=p,e.$Qn=R,e.$Rn=d,e.$Sn=c,e.$Tn=$,e.$Un=m,e.$Vn=g,e.$Wn=f;var N;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var A;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function D(n,r=!1){let t=0;const i=n.length;let s="",o=0,u=16,S=0;function k(te){let le=0,ce=0;for(;le<te;){const ae=n.charCodeAt(t);if(ae>=48&&ae<=57)ce=ce*16+ae-48;else if(ae>=65&&ae<=70)ce=ce*16+ae-65+10;else if(ae>=97&&ae<=102)ce=ce*16+ae-97+10;else break;t++,le++}return le<te&&(ce=-1),ce}function I(te){t=te,s="",o=0,u=16,S=0}function j(){const te=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&a(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&a(n.charCodeAt(t)))for(t++;t<n.length&&a(n.charCodeAt(t));)t++;else return S=3,n.substring(te,t);let le=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&a(n.charCodeAt(t))){for(t++;t<n.length&&a(n.charCodeAt(t));)t++;le=t}else S=3;return n.substring(te,le)}function F(){let te="",le=t;for(;;){if(t>=i){te+=n.substring(le,t),S=2;break}const ce=n.charCodeAt(t);if(ce===34){te+=n.substring(le,t),t++;break}if(ce===92){if(te+=n.substring(le,t),t++,t>=i){S=2;break}switch(n.charCodeAt(t++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const W=k(4);W>=0?te+=String.fromCharCode(W):S=4;break}default:S=5}le=t;continue}if(ce>=0&&ce<=31)if(l(ce)){te+=n.substring(le,t),S=2;break}else S=6;t++}return te}function B(){if(s="",S=0,o=t,t>=i)return o=i,u=17;let te=n.charCodeAt(t);if(E(te)){do t++,s+=String.fromCharCode(te),te=n.charCodeAt(t);while(E(te));return u=15}if(l(te))return t++,s+=String.fromCharCode(te),te===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),u=14;switch(te){case 123:return t++,u=1;case 125:return t++,u=2;case 91:return t++,u=3;case 93:return t++,u=4;case 58:return t++,u=6;case 44:return t++,u=5;case 34:return t++,s=F(),u=10;case 47:{const le=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!l(n.charCodeAt(t));)t++;return s=n.substring(le,t),u=12}if(n.charCodeAt(t+1)===42){t+=2;const ce=i-1;let ae=!1;for(;t<ce;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,S=1),s=n.substring(le,t),u=13}return s+=String.fromCharCode(te),t++,u=16}case 45:if(s+=String.fromCharCode(te),t++,t===i||!a(n.charCodeAt(t)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),u=11;default:for(;t<i&&J(te);)t++,te=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(te),t++,u=16}}function J(te){if(E(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let te;do te=B();while(te>=12&&te<=15);return te}return{setPosition:I,getPosition:()=>t,scan:r?ne:B,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>S}}function E(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function a(n){return n>=48&&n<=57}var h;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(h||(h={}));function b(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function S(k,I,j,F){o.value=k,o.offset=I,o.length=j,o.type=F,o.colonOffset=void 0,s=o}try{m(n,{onObjectBegin:(k,I)=>{if(r<=k)throw i;s=void 0,u=r>k,t.push("")},onObjectProperty:(k,I,j)=>{if(r<I||(S(k,I,j,"property"),t[t.length-1]=k,r<=I+j))throw i},onObjectEnd:(k,I)=>{if(r<=k)throw i;s=void 0,t.pop()},onArrayBegin:(k,I)=>{if(r<=k)throw i;s=void 0,t.push(0)},onArrayEnd:(k,I)=>{if(r<=k)throw i;s=void 0,t.pop()},onLiteralValue:(k,I,j)=>{if(r<I||(S(k,I,j,f(k)),r<=I+j))throw i},onSeparator:(k,I,j)=>{if(r<=I)throw i;if(k===":"&&s&&s.type==="property")s.colonOffset=I,u=!1,s=void 0;else if(k===","){const F=t[t.length-1];typeof F=="number"?t[t.length-1]=F+1:(u=!0,t[t.length-1]=""),s=void 0}}})}catch(k){if(k!==i)throw k}return{path:t,previousNode:s,isAtPropertyKey:u,matches:k=>{let I=0;for(let j=0;I<k.length&&j<t.length;j++)if(k[I]===t[j]||k[I]==="*")I++;else if(k[I]!=="**")return!1;return I===k.length}}}function y(n,r=[],t=L.DEFAULT){let i=null,s=[];const o=[];function u(k){Array.isArray(s)?s.push(k):i!==null&&(s[i]=k)}return m(n,{onObjectBegin:()=>{const k={};u(k),o.push(s),s=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const k=[];u(k),o.push(s),s=k,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:u,onError:(k,I,j)=>{r.push({error:k,offset:I,length:j})}},t),s[0]}function w(n,r=[],t=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function o(k){return i.children.push(k),k}m(n,{onObjectBegin:k=>{i=o({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,I,j)=>{i=o({type:"property",offset:I,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:I,length:j,parent:i})},onObjectEnd:(k,I)=>{i.length=k+I-i.offset,i=i.parent,s(k+I)},onArrayBegin:(k,I)=>{i=o({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,I)=>{i.length=k+I-i.offset,i=i.parent,s(k+I)},onLiteralValue:(k,I,j)=>{o({type:f(k),offset:I,length:j,parent:i,value:k}),s(I+j)},onSeparator:(k,I,j)=>{i.type==="property"&&(k===":"?i.colonOffset=I:k===","&&s(I))},onError:(k,I,j)=>{r.push({error:k,offset:I,length:j})}},t);const S=i.children[0];return S&&delete S.parent,S}function p(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function R(n){if(!n.parent||!n.parent.children)return[];const r=R(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}function d(n){switch(n.type){case"array":return n.children.map(d);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=d(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}function c(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}function $(n,r,t=!1){if(c(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=$(i[s],r,t);if(o)return o}return n}}function m(n,r,t=L.DEFAULT){const i=D(n,!1);function s(U){return U?()=>U(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(U){return U?q=>U(q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=s(r.onObjectBegin),S=o(r.onObjectProperty),k=s(r.onObjectEnd),I=s(r.onArrayBegin),j=s(r.onArrayEnd),F=o(r.onLiteralValue),B=o(r.onSeparator),J=s(r.onComment),ne=o(r.onError),te=t&&t.disallowComments,le=t&&t.allowTrailingComma;function ce(){for(;;){const U=i.scan();switch(i.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:te||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(U){case 12:case 13:te?ae(10):J();break;case 16:ae(1);break;case 15:case 14:break;default:return U}}}function ae(U,q=[],V=[]){if(ne(U),q.length+V.length>0){let C=i.getToken();for(;C!==17;){if(q.indexOf(C)!==-1){ce();break}else if(V.indexOf(C)!==-1)break;C=ce()}}}function W(U){const q=i.getTokenValue();return U?F(q):S(q),ce(),!0}function K(){switch(i.getToken()){case 11:{let U=0;try{U=JSON.parse(i.getTokenValue()),typeof U!="number"&&(ae(2),U=0)}catch{ae(2)}F(U);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return ce(),!0}function x(){return i.getToken()!==10?(ae(3,[],[2,5]),!1):(W(!1),i.getToken()===6?(B(":"),ce(),Y()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function M(){u(),ce();let U=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(U||ae(4,[],[]),B(","),ce(),i.getToken()===2&&le)break}else U&&ae(6,[],[]);x()||ae(4,[],[2,5]),U=!0}return k(),i.getToken()!==2?ae(7,[2],[]):ce(),!0}function G(){I(),ce();let U=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(U||ae(4,[],[]),B(","),ce(),i.getToken()===4&&le)break}else U&&ae(6,[],[]);Y()||ae(4,[],[4,5]),U=!0}return j(),i.getToken()!==4?ae(8,[4],[]):ce(),!0}function Y(){switch(i.getToken()){case 3:return G();case 1:return M();case 10:return W(!0);default:return K()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):Y()?(i.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}function g(n,r){const t=D(n),i=[];let s,o=0,u;do switch(u=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==u&&i.push(n.substring(o,u)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}function f(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}}),define(re[76],oe([0,1,38]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=A,e.$Yn=P,e.$Zn=E,e.$1n=l;function A(a,h,b){let y,w,p,R,d;if(h){for(R=h.offset,d=R+h.length,p=R;p>0&&!l(a,p-1);)p--;let u=d;for(;u<a.length&&!l(a,u);)u++;w=a.substring(p,u),y=D(w,b)}else w=a,y=0,p=0,R=0,d=a.length;const c=E(b,a);let $=!1,m=0,g;b.insertSpaces?g=L(" ",b.tabSize||4):g="	";const f=(0,N.$Ln)(w,!1);let n=!1;function r(){return c+L(g,y+m)}function t(){let u=f.scan();for($=!1;u===15||u===14;)$=$||u===14,u=f.scan();return n=u===16||f.getTokenError()!==0,u}const i=[];function s(u,S,k){!n&&S<d&&k>R&&a.substring(S,k)!==u&&i.push({offset:S,length:k-S,content:u})}let o=t();if(o!==17){const u=f.getTokenOffset()+p,S=L(g,y);s(S,p,u)}for(;o!==17;){let u=f.getTokenOffset()+f.getTokenLength()+p,S=t(),k="";for(;!$&&(S===12||S===13);){const j=f.getTokenOffset()+p;s(" ",u,j),u=f.getTokenOffset()+f.getTokenLength()+p,k=S===12?r():"",S=t()}if(S===2)o!==1&&(m--,k=r());else if(S===4)o!==3&&(m--,k=r());else{switch(o){case 3:case 1:m++,k=r();break;case 5:case 12:k=r();break;case 13:$?k=r():k=" ";break;case 6:k=" ";break;case 10:if(S===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?k=" ":S!==5&&S!==17&&(n=!0);break;case 16:n=!0;break}$&&(S===12||S===13)&&(k=r())}const I=f.getTokenOffset()+p;s(k,u,I),o=S}return i}function P(a,h){const b=JSON.stringify(a,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?b.replace(/\r\n|\r|\n/g,h.eol):b}function L(a,h){let b="";for(let y=0;y<h;y++)b+=a;return b}function D(a,h){let b=0,y=0;const w=h.tabSize||4;for(;b<a.length;){const p=a.charAt(b);if(p===" ")y++;else if(p==="	")y+=w;else break;b++}return Math.floor(y/w)}function E(a,h){for(let b=0;b<h.length;b++){const y=h.charAt(b);if(y==="\r")return b+1<h.length&&h.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return a&&a.eol||`
`}function l(a,h){return`\r
`.indexOf(a.charAt(h))!==-1}}),define(re[77],oe([0,1,38,76]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=P,e.$3n=L,e.$4n=D,e.$5n=E,e.$6n=l;function P(a,h,b){return L(a,h,void 0,b)}function L(a,h,b,y,w){const p=h.slice(),R=[],d=(0,N.$On)(a,R);let c,$;for(;p.length>0&&($=p.pop(),c=(0,N.$Pn)(d,p),c===void 0&&b!==void 0);)typeof $=="string"?b={[$]:b}:b=[b];if(c)if(c.type==="object"&&typeof $=="string"&&Array.isArray(c.children)){const m=(0,N.$Pn)(c,[$]);if(m!==void 0)if(b===void 0){if(!m.parent)throw new Error("Malformed AST");const g=c.children.indexOf(m.parent);let f,n=m.parent.offset+m.parent.length;if(g>0){const r=c.children[g-1];f=r.offset+r.length}else f=c.offset+1,c.children.length>1&&(n=c.children[1].offset);return D(a,{offset:f,length:n-f,content:""},y)}else return D(a,{offset:m.offset,length:m.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const g=`${JSON.stringify($)}: ${JSON.stringify(b)}`,f=w?w(c.children.map(r=>r.children[0].value)):c.children.length;let n;if(f>0){const r=c.children[f-1];n={offset:r.offset+r.length,length:0,content:","+g}}else c.children.length===0?n={offset:c.offset+1,length:0,content:g}:n={offset:c.offset+1,length:0,content:g+","};return D(a,n,y)}}else if(c.type==="array"&&typeof $=="number"&&Array.isArray(c.children))if(b!==void 0){const m=`${JSON.stringify(b)}`;let g;if(c.children.length===0||$===0)g={offset:c.offset+1,length:0,content:c.children.length===0?m:m+","};else{const f=$===-1||$>c.children.length?c.children.length:$,n=c.children[f-1];g={offset:n.offset+n.length,length:0,content:","+m}}return D(a,g,y)}else{const m=$,g=c.children[m];let f;if(c.children.length===1)f={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===m){const n=c.children[m-1],r=n.offset+n.length,t=c.offset+c.length;f={offset:r,length:t-2-r,content:""}}else f={offset:g.offset,length:c.children[m+1].offset-g.offset,content:""};return D(a,f,y)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${c.type}`);else return b===void 0?[]:D(a,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(b)},y)}function D(a,h,b){let y=E(a,h),w=h.offset,p=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;w>0&&!(0,A.$1n)(y,w-1);)w--;for(;p<y.length&&!(0,A.$1n)(y,p);)p++}const R=(0,A.$Xn)(y,{offset:w,length:p-w},b);for(let c=R.length-1;c>=0;c--){const $=R[c];y=E(y,$),w=Math.min(w,$.offset),p=Math.max(p,$.offset+$.length),p+=$.content.length-$.length}const d=a.length-(y.length-p)-w;return[{offset:w,length:d,content:y.substring(w,p)}]}function E(a,h){return a.substring(0,h.offset)+h.content+a.substring(h.offset+h.length)}function l(a,h){const b=h.slice(0).sort((w,p)=>{const R=w.offset-p.offset;return R===0?w.length-p.length:R});let y=a.length;for(let w=b.length-1;w>=0;w--){const p=b[w];if(p.offset+p.length<=y)a=E(a,p);else throw new Error("Overlapping edit");y=p.offset}return a}}),define(re[78],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=void 0,e.$Fm=N,e.rot=A;function N(E,l,a){return Math.min(Math.max(E,l),a)}function A(E,l){return(l+E%l)%l}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Hm=P;class L{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Im=L;class D{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const a=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jm=D}),function(){function Q(P){const L=[];typeof P=="number"&&L.push("code/timeOrigin",P);function D(l){L.push(l,Date.now())}function E(){const l=[];for(let a=0;a<L.length;a+=2)l.push({name:L[a],startTime:L[a+1]});return l}return{mark:D,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(P+D.startTime)});return L}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function N(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=N(A))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var A in N)(typeof exports=="object"?exports:Q)[A]=N[A]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function N(A){if(e[A])return e[A].exports;var P=e[A]={i:A,l:!1,exports:{}};return Q[A].call(P.exports,P,P.exports,N),P.l=!0,P.exports}return N.m=Q,N.c=e,N.d=function(A,P,L){N.o(A,P)||Object.defineProperty(A,P,{enumerable:!0,get:L})},N.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},N.t=function(A,P){if(1&P&&(A=N(A)),8&P||4&P&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(N.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&P&&typeof A!="string")for(var D in A)N.d(L,D,function(E){return A[E]}.bind(null,D));return L},N.n=function(A){var P=A&&A.__esModule?function(){return A.default}:function(){return A};return N.d(P,"a",P),P},N.o=function(A,P){return Object.prototype.hasOwnProperty.call(A,P)},N.p="",N(N.s=0)}([function(Q,e,N){(function(A){var P;e=Q.exports=V,P=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],l=e.src=[],a=0,h=a++;l[h]="0|[1-9]\\d*";var b=a++;l[b]="[0-9]+";var y=a++;l[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=a++;l[w]="("+l[h]+")\\.("+l[h]+")\\.("+l[h]+")";var p=a++;l[p]="("+l[b]+")\\.("+l[b]+")\\.("+l[b]+")";var R=a++;l[R]="(?:"+l[h]+"|"+l[y]+")";var d=a++;l[d]="(?:"+l[b]+"|"+l[y]+")";var c=a++;l[c]="(?:-("+l[R]+"(?:\\."+l[R]+")*))";var $=a++;l[$]="(?:-?("+l[d]+"(?:\\."+l[d]+")*))";var m=a++;l[m]="[0-9A-Za-z-]+";var g=a++;l[g]="(?:\\+("+l[m]+"(?:\\."+l[m]+")*))";var f=a++,n="v?"+l[w]+l[c]+"?"+l[g]+"?";l[f]="^"+n+"$";var r="[v=\\s]*"+l[p]+l[$]+"?"+l[g]+"?",t=a++;l[t]="^"+r+"$";var i=a++;l[i]="((?:<|>)?=?)";var s=a++;l[s]=l[b]+"|x|X|\\*";var o=a++;l[o]=l[h]+"|x|X|\\*";var u=a++;l[u]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[c]+")?"+l[g]+"?)?)?";var S=a++;l[S]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[$]+")?"+l[g]+"?)?)?";var k=a++;l[k]="^"+l[i]+"\\s*"+l[u]+"$";var I=a++;l[I]="^"+l[i]+"\\s*"+l[S]+"$";var j=a++;l[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=a++;l[F]="(?:~>?)";var B=a++;l[B]="(\\s*)"+l[F]+"\\s+",E[B]=new RegExp(l[B],"g");var J=a++;l[J]="^"+l[F]+l[u]+"$";var ne=a++;l[ne]="^"+l[F]+l[S]+"$";var te=a++;l[te]="(?:\\^)";var le=a++;l[le]="(\\s*)"+l[te]+"\\s+",E[le]=new RegExp(l[le],"g");var ce=a++;l[ce]="^"+l[te]+l[u]+"$";var ae=a++;l[ae]="^"+l[te]+l[S]+"$";var W=a++;l[W]="^"+l[i]+"\\s*("+r+")$|^$";var K=a++;l[K]="^"+l[i]+"\\s*("+n+")$|^$";var x=a++;l[x]="(\\s*)"+l[i]+"\\s*("+r+"|"+l[u]+")",E[x]=new RegExp(l[x],"g");var M=a++;l[M]="^\\s*("+l[u]+")\\s+-\\s+("+l[u]+")\\s*$";var G=a++;l[G]="^\\s*("+l[S]+")\\s+-\\s+("+l[S]+")\\s*$";var Y=a++;l[Y]="(<|>)?=?\\s*\\*";for(var U=0;U<35;U++)P(U,l[U]),E[U]||(E[U]=new RegExp(l[U]));function q(H,_){if(H instanceof V)return H;if(typeof H!="string"||H.length>L||!(_?E[t]:E[f]).test(H))return null;try{return new V(H,_)}catch{return null}}function V(H,_){if(H instanceof V){if(H.loose===_)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof V))return new V(H,_);P("SemVer",H,_),this.loose=_;var ee=H.trim().match(_?E[t]:E[f]);if(!ee)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<D)return ve}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=q,e.valid=function(H,_){var ee=q(H,_);return ee?ee.version:null},e.clean=function(H,_){var ee=q(H.trim().replace(/^[=v]+/,""),_);return ee?ee.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(H){return P("SemVer.compare",this.version,this.loose,H),H instanceof V||(H=new V(H,this.loose)),this.compareMain(H)||this.comparePre(H)},V.prototype.compareMain=function(H){return H instanceof V||(H=new V(H,this.loose)),v(this.major,H.major)||v(this.minor,H.minor)||v(this.patch,H.patch)},V.prototype.comparePre=function(H){if(H instanceof V||(H=new V(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var _=0;do{var ee=this.prerelease[_],ge=H.prerelease[_];if(P("prerelease compare",_,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return v(ee,ge)}while(++_)},V.prototype.inc=function(H,_){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,_,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new V(H,ee).inc(_,ge).version}catch{return null}},e.diff=function(H,_){if(Z(H,_))return null;var ee=q(H),ge=q(_);if(ee.prerelease.length||ge.prerelease.length){for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return ve},e.compareIdentifiers=v;var C=/^[0-9]+$/;function v(H,_){var ee=C.test(H),ge=C.test(_);return ee&&ge&&(H=+H,_=+_),ee&&!ge?-1:ge&&!ee?1:H<_?-1:H>_?1:0}function O(H,_,ee){return new V(H,ee).compare(new V(_,ee))}function z(H,_,ee){return O(H,_,ee)>0}function T(H,_,ee){return O(H,_,ee)<0}function Z(H,_,ee){return O(H,_,ee)===0}function X(H,_,ee){return O(H,_,ee)!==0}function se(H,_,ee){return O(H,_,ee)>=0}function ue(H,_,ee){return O(H,_,ee)<=0}function he(H,_,ee,ge){var ve;switch(_){case"===":typeof H=="object"&&(H=H.version),typeof ee=="object"&&(ee=ee.version),ve=H===ee;break;case"!==":typeof H=="object"&&(H=H.version),typeof ee=="object"&&(ee=ee.version),ve=H!==ee;break;case"":case"=":case"==":ve=Z(H,ee,ge);break;case"!=":ve=X(H,ee,ge);break;case">":ve=z(H,ee,ge);break;case">=":ve=se(H,ee,ge);break;case"<":ve=T(H,ee,ge);break;case"<=":ve=ue(H,ee,ge);break;default:throw new TypeError("Invalid operator: "+_)}return ve}function pe(H,_){if(H instanceof pe){if(H.loose===_)return H;H=H.value}if(!(this instanceof pe))return new pe(H,_);P("comparator",H,_),this.loose=_,this.parse(H),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(H,_){return v(_,H)},e.major=function(H,_){return new V(H,_).major},e.minor=function(H,_){return new V(H,_).minor},e.patch=function(H,_){return new V(H,_).patch},e.compare=O,e.compareLoose=function(H,_){return O(H,_,!0)},e.rcompare=function(H,_,ee){return O(_,H,ee)},e.sort=function(H,_){return H.sort(function(ee,ge){return e.compare(ee,ge,_)})},e.rsort=function(H,_){return H.sort(function(ee,ge){return e.rcompare(ee,ge,_)})},e.gt=z,e.lt=T,e.eq=Z,e.neq=X,e.gte=se,e.lte=ue,e.cmp=he,e.Comparator=pe;var ye={};function fe(H,_){if(H instanceof fe)return H.loose===_?H:new fe(H.raw,_);if(H instanceof pe)return new fe(H.value,_);if(!(this instanceof fe))return new fe(H,_);if(this.loose=_,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function me(H){return!H||H.toLowerCase()==="x"||H==="*"}function de(H,_,ee,ge,ve,Ae,Pe,Le,Re,De,qe,je,Ne){return((_=me(ee)?"":me(ge)?">="+ee+".0.0":me(ve)?">="+ee+"."+ge+".0":">="+_)+" "+(Le=me(Re)?"":me(De)?"<"+(+Re+1)+".0.0":me(qe)?"<"+Re+"."+(+De+1)+".0":je?"<="+Re+"."+De+"."+qe+"-"+je:"<="+Le)).trim()}function we(H,_){for(var ee=0;ee<H.length;ee++)if(!H[ee].test(_))return!1;if(_.prerelease.length){for(ee=0;ee<H.length;ee++)if(P(H[ee].semver),H[ee].semver!==ye&&H[ee].semver.prerelease.length>0){var ge=H[ee].semver;if(ge.major===_.major&&ge.minor===_.minor&&ge.patch===_.patch)return!0}return!1}return!0}function Ee(H,_,ee){try{_=new fe(_,ee)}catch{return!1}return _.test(H)}function Ie(H,_,ee,ge){var ve,Ae,Pe,Le,Re;switch(H=new V(H,ge),_=new fe(_,ge),ee){case">":ve=z,Ae=ue,Pe=T,Le=">",Re=">=";break;case"<":ve=T,Ae=se,Pe=z,Le="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(H,_,ge))return!1;for(var De=0;De<_.set.length;++De){var qe=_.set[De],je=null,Ne=null;if(qe.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),je=je||ze,Ne=Ne||ze,ve(ze.semver,je.semver,ge)?je=ze:Pe(ze.semver,Ne.semver,ge)&&(Ne=ze)}),je.operator===Le||je.operator===Re||(!Ne.operator||Ne.operator===Le)&&Ae(H,Ne.semver)||Ne.operator===Re&&Pe(H,Ne.semver))return!1}return!0}pe.prototype.parse=function(H){var _=this.loose?E[W]:E[K],ee=H.match(_);if(!ee)throw new TypeError("Invalid comparator: "+H);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new V(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(H){return P("Comparator.test",H,this.loose),this.semver===ye||(typeof H=="string"&&(H=new V(H,this.loose)),he(H,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(H,_){if(!(H instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(H.value,_),Ee(this.value,ee,_);if(H.operator==="")return ee=new fe(this.value,_),Ee(H.semver,ee,_);var ge=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Ae=this.semver.version===H.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Le=he(this.semver,"<",H.semver,_)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Re=he(this.semver,">",H.semver,_)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return ge||ve||Ae&&Pe||Le||Re},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(H){var _=this.loose;H=H.trim(),P("range",H,_);var ee=_?E[G]:E[M];H=H.replace(ee,de),P("hyphen replace",H),H=H.replace(E[x],"$1$2$3"),P("comparator trim",H,E[x]),H=(H=(H=H.replace(E[B],"$1~")).replace(E[le],"$1^")).split(/\s+/).join(" ");var ge=_?E[W]:E[K],ve=H.split(" ").map(function(Ae){return function(Pe,Le){return P("comp",Pe),Pe=function(Re,De){return Re.trim().split(/\s+/).map(function(qe){return function(je,Ne){P("caret",je,Ne);var ze=Ne?E[ae]:E[ce];return je.replace(ze,function(Fe,be,Se,ke,Oe){var Ue;return P("caret",je,Fe,be,Se,ke,Oe),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(ke)?Ue=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Oe?(P("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+ke+Oe+" <"+be+"."+Se+"."+(+ke+1):">="+be+"."+Se+"."+ke+Oe+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+ke+Oe+" <"+(+be+1)+".0.0"):(P("no pr"),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+ke+" <"+be+"."+Se+"."+(+ke+1):">="+be+"."+Se+"."+ke+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+ke+" <"+(+be+1)+".0.0"),P("caret return",Ue),Ue})}(qe,De)}).join(" ")}(Pe,Le),P("caret",Pe),Pe=function(Re,De){return Re.trim().split(/\s+/).map(function(qe){return function(je,Ne){var ze=Ne?E[ne]:E[J];return je.replace(ze,function(Fe,be,Se,ke,Oe){var Ue;return P("tilde",je,Fe,be,Se,ke,Oe),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(ke)?Ue=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Oe?(P("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ue=">="+be+"."+Se+"."+ke+Oe+" <"+be+"."+(+Se+1)+".0"):Ue=">="+be+"."+Se+"."+ke+" <"+be+"."+(+Se+1)+".0",P("tilde return",Ue),Ue})}(qe,De)}).join(" ")}(Pe,Le),P("tildes",Pe),Pe=function(Re,De){return P("replaceXRanges",Re,De),Re.split(/\s+/).map(function(qe){return function(je,Ne){je=je.trim();var ze=Ne?E[I]:E[k];return je.replace(ze,function(Fe,be,Se,ke,Oe,Ue){P("xRange",je,Fe,be,Se,ke,Oe,Ue);var Ce=me(Se),Me=Ce||me(ke),Te=Me||me(Oe);return be==="="&&Te&&(be=""),Ce?Fe=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Me&&(ke=0),Te&&(Oe=0),be===">"?(be=">=",Me?(Se=+Se+1,ke=0,Oe=0):Te&&(ke=+ke+1,Oe=0)):be==="<="&&(be="<",Me?Se=+Se+1:ke=+ke+1),Fe=be+Se+"."+ke+"."+Oe):Me?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te&&(Fe=">="+Se+"."+ke+".0 <"+Se+"."+(+ke+1)+".0"),P("xRange return",Fe),Fe})}(qe,De)}).join(" ")}(Pe,Le),P("xrange",Pe),Pe=function(Re,De){return P("replaceStars",Re,De),Re.trim().replace(E[Y],"")}(Pe,Le),P("stars",Pe),Pe}(Ae,_)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Ae){return!!Ae.match(ge)})),ve=ve.map(function(Ae){return new pe(Ae,_)})},fe.prototype.intersects=function(H,_){if(!(H instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return H.set.some(function(ve){return ve.every(function(Ae){return ge.intersects(Ae,_)})})})})},e.toComparators=function(H,_){return new fe(H,_).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new V(H,this.loose));for(var _=0;_<this.set.length;_++)if(we(this.set[_],H))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(H,_,ee){var ge=null,ve=null;try{var Ae=new fe(_,ee)}catch{return null}return H.forEach(function(Pe){Ae.test(Pe)&&(ge&&ve.compare(Pe)!==-1||(ve=new V(ge=Pe,ee)))}),ge},e.minSatisfying=function(H,_,ee){var ge=null,ve=null;try{var Ae=new fe(_,ee)}catch{return null}return H.forEach(function(Pe){Ae.test(Pe)&&(ge&&ve.compare(Pe)!==1||(ve=new V(ge=Pe,ee)))}),ge},e.validRange=function(H,_){try{return new fe(H,_).range||"*"}catch{return null}},e.ltr=function(H,_,ee){return Ie(H,_,"<",ee)},e.gtr=function(H,_,ee){return Ie(H,_,">",ee)},e.outside=Ie,e.prerelease=function(H,_){var ee=q(H,_);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(H,_,ee){return H=new fe(H,ee),_=new fe(_,ee),H.intersects(_)},e.coerce=function(H){if(H instanceof V)return H;if(typeof H!="string")return null;var _=H.match(E[j]);return _==null?null:q((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,N(1))},function(Q,e){var N,A,P=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function E(d){if(N===setTimeout)return setTimeout(d,0);if((N===L||!N)&&setTimeout)return N=setTimeout,setTimeout(d,0);try{return N(d,0)}catch{try{return N.call(null,d,0)}catch{return N.call(this,d,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:L}catch{N=L}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var l,a=[],h=!1,b=-1;function y(){h&&l&&(h=!1,l.length?a=l.concat(a):b=-1,a.length&&w())}function w(){if(!h){var d=E(y);h=!0;for(var c=a.length;c;){for(l=a,a=[];++b<c;)l&&l[b].run();b=-1,c=a.length}l=null,h=!1,function($){if(A===clearTimeout)return clearTimeout($);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout($);try{A($)}catch{try{return A.call(null,$)}catch{return A.call(this,$)}}}(d)}}function p(d,c){this.fun=d,this.array=c}function R(){}P.nextTick=function(d){var c=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)c[$-1]=arguments[$];a.push(new p(d,c)),a.length!==1||h||E(w)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=R,P.addListener=R,P.once=R,P.off=R,P.removeListener=R,P.removeAllListeners=R,P.emit=R,P.prependListener=R,P.prependOnceListener=R,P.listeners=function(d){return[]},P.binding=function(d){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(d){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(re[79],oe([0,1]),function(Q,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;class A{constructor(E,l,a){this.level=E,this.key=l,this.value=a,this.forward=[]}}const P=void 0;class L{constructor(E,l=2**16){this.comparator=E,this[N]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(l)|0),this.e=new A(this.c,P,P)}get size(){return this.f}clear(){this.e=new A(this.c,P,P),this.f=0}has(E){return!!L.g(this,E,this.comparator)}get(E){return L.g(this,E,this.comparator)?.value}set(E,l){return L.h(this,E,l,this.comparator)&&(this.f+=1),this}delete(E){const l=L.k(this,E,this.comparator);return l&&(this.f-=1),l}forEach(E,l){let a=this.e.forward[0];for(;a;)E.call(l,a.value,a.key,this),a=a.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",l=this.e.forward[0];for(;l;)E+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return E}static g(E,l,a){let h=E.e;for(let b=E.d-1;b>=0;b--)for(;h.forward[b]&&a(h.forward[b].key,l)<0;)h=h.forward[b];if(h=h.forward[0],h&&a(h.key,l)===0)return h}static h(E,l,a,h){const b=[];let y=E.e;for(let w=E.d-1;w>=0;w--){for(;y.forward[w]&&h(y.forward[w].key,l)<0;)y=y.forward[w];b[w]=y}if(y=y.forward[0],y&&h(y.key,l)===0)return y.value=a,!1;{const w=L.j(E);if(w>E.d){for(let p=E.d;p<w;p++)b[p]=E.e;E.d=w}y=new A(w,l,a);for(let p=0;p<w;p++)y.forward[p]=b[p].forward[p],b[p].forward[p]=y;return!0}}static j(E,l=.5){let a=1;for(;Math.random()<l&&a<E.c;)a+=1;return a}static k(E,l,a){const h=[];let b=E.e;for(let y=E.d-1;y>=0;y--){for(;b.forward[y]&&a(b.forward[y].key,l)<0;)b=b.forward[y];h[y]=b}if(b=b.forward[0],!b||a(b.key,l)!==0)return!1;for(let y=0;y<E.d&&h[y].forward[y]===b;y++)h[y].forward[y]=b.forward[y];for(;E.d>0&&E.e.forward[E.d-1]===P;)E.d-=1;return!0}}e.$Fs=L}),define(re[46],oe([0,1,9,2]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=P,e.$ve=L,e.$we=D,e.$xe=E,e.$ye=a,e.$ze=h,e.$Ae=b,e.$Be=y,e.$Ce=w,e.$De=p,e.$Ee=R,e.$Fe=d,e.$Ge=c,e.$He=$,e.$Ie=m;function P(g){const f=g;return f?typeof f.read=="function":!1}function L(g){const f=g;return f?[f.on,f.pause,f.resume,f.destroy].every(n=>typeof n=="function"):!1}function D(g){const f=g;return f?L(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}function E(g,f){return new l(g,f)}class l{constructor(f,n){this.e=f,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(n=>n(f))}h(f){this.c.error.length===0?(0,N.$1)(f):this.c.error.slice(0).forEach(n=>n(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,n){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(f,n){if(this.a.destroyed)return;let r;switch(f){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(g,f){const n=[];let r;for(;(r=g.read())!==null;)n.push(r);return f(n)}function h(g,f,n){const r=[];let t;for(;(t=g.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?f(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return g.read()}}}function b(g,f){return new Promise((n,r)=>{const t=[];y(g,{onData:i=>{f&&t.push(i)},onError:i=>{f?r(i):n(void 0)},onEnd:()=>{n(f?f(t):void 0)}})})}function y(g,f,n){g.on("error",r=>{n?.isCancellationRequested||f.onError(r)}),g.on("end",()=>{n?.isCancellationRequested||f.onEnd()}),g.on("data",r=>{n?.isCancellationRequested||f.onData(r)})}function w(g,f){return new Promise((n,r)=>{const t=new A.$Tc,i=[],s=S=>{if(i.push(S),i.length>f)return t.dispose(),g.pause(),n({stream:g,buffer:i,ended:!1})},o=S=>(t.dispose(),r(S)),u=()=>(t.dispose(),n({stream:g,buffer:i,ended:!0}));t.add((0,A.$Sc)(()=>g.removeListener("error",o))),g.on("error",o),t.add((0,A.$Sc)(()=>g.removeListener("end",u))),g.on("end",u),t.add((0,A.$Sc)(()=>g.removeListener("data",s))),g.on("data",s)})}function p(g,f){const n=E(f);return n.end(g),n}function R(){const g=E(()=>{throw new Error("not supported")});return g.end(),g}function d(g){let f=!1;return{read:()=>f?null:(f=!0,g)}}function c(g,f,n){const r=E(n);return y(g,{onData:t=>r.write(f.data(t)),onError:t=>r.error(f.error?f.error(t):t),onEnd:()=>r.end()}),r}function $(g,f,n){let r=!1;return{read:()=>{const t=f.read();return r?t:(r=!0,t!==null?n([g,t]):g)}}}function m(g,f,n){let r=!1;const t=E(n);return y(f,{onData:i=>r?t.write(i):(r=!0,t.write(n([g,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(g)),t.end()}}),t}}),define(re[14],oe([0,1,169,46]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=a,e.$Le=h,e.$Me=b,e.$Ne=y,e.$Oe=w,e.$Pe=p,e.$Qe=R,e.$Re=d,e.$Se=c,e.$Te=$,e.$Ue=m,e.$Ve=g,e.$We=f,e.$Xe=n,e.$Ye=r,e.$Ze=t,e.$1e=i,e.$2e=s,e.$3e=o,e.$4e=k;const P=typeof Buffer<"u",L=new N.$V(()=>new Uint8Array(256));let D,E;class l{static alloc(j){return P?new l(Buffer.allocUnsafe(j)):new l(new Uint8Array(j))}static wrap(j){return P&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new l(j)}static fromString(j,F){return!(F?.dontUseNodeBuffer||!1)&&P?new l(Buffer.from(j)):(D||(D=new TextEncoder),new l(D.encode(j)))}static fromByteArray(j){const F=l.alloc(j.length);for(let B=0,J=j.length;B<J;B++)F.buffer[B]=j[B];return F}static concat(j,F){if(typeof F>"u"){F=0;for(let ne=0,te=j.length;ne<te;ne++)F+=j[ne].byteLength}const B=l.alloc(F);let J=0;for(let ne=0,te=j.length;ne<te;ne++){const le=j[ne];B.set(le,J),J+=le.byteLength}return B}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=l.alloc(this.byteLength);return j.set(this),j}toString(){return P?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(j,F){return new l(this.buffer.subarray(j,F))}set(j,F){if(j instanceof l)this.buffer.set(j.buffer,F);else if(j instanceof Uint8Array)this.buffer.set(j,F);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),F);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return y(this.buffer,j)}writeUInt32BE(j,F){w(this.buffer,j,F)}readUInt32LE(j){return p(this.buffer,j)}writeUInt32LE(j,F){R(this.buffer,j,F)}readUInt8(j){return d(this.buffer,j)}writeUInt8(j,F){c(this.buffer,j,F)}indexOf(j,F=0){return a(this.buffer,j instanceof l?j.buffer:j,F)}}e.$Je=l;function a(I,j,F=0){const B=j.byteLength,J=I.byteLength;if(B===0)return 0;if(B===1)return I.indexOf(j[0]);if(B>J-F)return-1;const ne=L.value;ne.fill(j.length);for(let ae=0;ae<j.length;ae++)ne[j[ae]]=j.length-ae-1;let te=F+j.length-1,le=te,ce=-1;for(;te<J;)if(I[te]===j[le]){if(le===0){ce=te;break}te--,le--}else te+=Math.max(j.length-le,ne[I[te]]),le=j.length-1;return ce}function h(I,j){return I[j+0]<<0>>>0|I[j+1]<<8>>>0}function b(I,j,F){I[F+0]=j&255,j=j>>>8,I[F+1]=j&255}function y(I,j){return I[j]*2**24+I[j+1]*2**16+I[j+2]*2**8+I[j+3]}function w(I,j,F){I[F+3]=j,j=j>>>8,I[F+2]=j,j=j>>>8,I[F+1]=j,j=j>>>8,I[F]=j}function p(I,j){return I[j+0]<<0>>>0|I[j+1]<<8>>>0|I[j+2]<<16>>>0|I[j+3]<<24>>>0}function R(I,j,F){I[F+0]=j&255,j=j>>>8,I[F+1]=j&255,j=j>>>8,I[F+2]=j&255,j=j>>>8,I[F+3]=j&255}function d(I,j){return I[j]}function c(I,j,F){I[F]=j}function $(I){return A.$ye(I,j=>l.concat(j))}function m(I){return A.$Fe(I)}function g(I){return A.$Ae(I,j=>l.concat(j))}async function f(I){return I.ended?l.concat(I.buffer):l.concat([...I.buffer,await g(I.stream)])}function n(I){return A.$De(I,j=>l.concat(j))}function r(I){return A.$Ge(I,{data:j=>typeof j=="string"?l.fromString(j):l.wrap(j)},j=>l.concat(j))}function t(I){return A.$xe(j=>l.concat(j),I)}function i(I,j){return A.$He(I,j,F=>l.concat(F))}function s(I,j){return A.$Ie(I,j,F=>l.concat(F))}function o(I){let j=0,F=0,B=0;const J=new Uint8Array(Math.floor(I.length/4*3)),ne=le=>{switch(F){case 3:J[B++]=j|le,F=0;break;case 2:J[B++]=j|le>>>2,j=le<<6,F=3;break;case 1:J[B++]=j|le>>>4,j=le<<4,F=2;break;default:j=le<<2,F=1}};for(let le=0;le<I.length;le++){const ce=I.charCodeAt(le);if(ce>=65&&ce<=90)ne(ce-65);else if(ce>=97&&ce<=122)ne(ce-97+26);else if(ce>=48&&ce<=57)ne(ce-48+52);else if(ce===43||ce===45)ne(62);else if(ce===47||ce===95)ne(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${I[le]}`)}}const te=B;for(;F>0;)ne(0);return l.wrap(J).slice(0,te)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:I},j=!0,F=!1){const B=F?S:u;let J="";const ne=I.byteLength%3;let te=0;for(;te<I.byteLength-ne;te+=3){const le=I[te+0],ce=I[te+1],ae=I[te+2];J+=B[le>>>2],J+=B[(le<<4|ce>>>4)&63],J+=B[(ce<<2|ae>>>6)&63],J+=B[ae&63]}if(ne===1){const le=I[te+0];J+=B[le>>>2],J+=B[le<<4&63],j&&(J+="==")}else if(ne===2){const le=I[te+0],ce=I[te+1];J+=B[le>>>2],J+=B[(le<<4|ce>>>4)&63],J+=B[ce<<2&63],j&&(J+="=")}return J}}),define(re[43],oe([0,1,31]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=A,e.$pj=P,e.$qj=L,e.$rj=E,e.$tj=R;function A(c){return P(c,0)}function P(c,$){switch(typeof c){case"object":return c===null?L(349,$):Array.isArray(c)?l(c,$):a(c,$);case"string":return E(c,$);case"boolean":return D(c,$);case"number":return L(c,$);case"undefined":return L(937,$);default:return L(617,$)}}function L(c,$){return($<<5)-$+c|0}function D(c,$){return L(c?433:863,$)}function E(c,$){$=L(149417,$);for(let m=0,g=c.length;m<g;m++)$=L(c.charCodeAt(m),$);return $}function l(c,$){return $=L(104579,$),c.reduce((m,g)=>P(g,m),$)}function a(c,$){return $=L(181387,$),Object.keys(c).sort().reduce((m,g)=>(m=E(g,m),P(c[g],m)),$)}class h{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=P($,this.g),this.g}}e.$sj=h;var b;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y(c,$,m=32){const g=m-$,f=~((1<<g)-1);return(c<<$|(f&c)>>>g)>>>0}function w(c,$=0,m=c.byteLength,g=0){for(let f=0;f<m;f++)c[$+f]=g}function p(c,$,m="0"){for(;c.length<$;)c=m+c;return c}function R(c,$=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(m=>m.toString(16).padStart(2,"0")).join(""):p((c>>>0).toString(16),$/4)}class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const m=$.length;if(m===0)return;const g=this.p;let f=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=$.charCodeAt(0),t=0);;){let i=r;if(N.$Ff(r))if(t+1<m){const s=$.charCodeAt(t+1);N.$Gf(s)?(t++,i=N.$Hf(r,s)):i=65533}else{n=r;break}else N.$Gf(r)&&(i=65533);if(f=this.w(g,f,i),t++,t<m)r=$.charCodeAt(t);else break}this.r=f,this.u=n}w($,m,g){return g<128?$[m++]=g:g<2048?($[m++]=192|(g&1984)>>>6,$[m++]=128|(g&63)>>>0):g<65536?($[m++]=224|(g&61440)>>>12,$[m++]=128|(g&4032)>>>6,$[m++]=128|(g&63)>>>0):($[m++]=240|(g&1835008)>>>18,$[m++]=128|(g&258048)>>>12,$[m++]=128|(g&4032)>>>6,$[m++]=128|(g&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=d.g,m=this.q;for(let u=0;u<64;u+=4)$.setUint32(u,m.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)$.setUint32(u,y($.getUint32(u-12,!1)^$.getUint32(u-32,!1)^$.getUint32(u-56,!1)^$.getUint32(u-64,!1),1),!1);let g=this.h,f=this.l,n=this.m,r=this.n,t=this.o,i,s,o;for(let u=0;u<80;u++)u<20?(i=f&n|~f&r,s=1518500249):u<40?(i=f^n^r,s=1859775393):u<60?(i=f&n|f&r|n&r,s=2400959708):(i=f^n^r,s=3395469782),o=y(g,5)+i+t+s+$.getUint32(u*4,!1)&4294967295,t=r,r=n,n=y(f,30),f=g,g=o;this.h=this.h+g&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$uj=d}),define(re[56],oe([0,1,31]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(A||(A={})),function(P){const L="error",D="warning",E="warn",l="info",a="ignore";function h(y){return y?N.$Bf(L,y)?P.Error:N.$Bf(D,y)||N.$Bf(E,y)?P.Warning:N.$Bf(l,y)?P.Info:P.Ignore:P.Ignore}P.fromValue=h;function b(y){switch(y){case P.Error:return L;case P.Warning:return D;case P.Info:return l;default:return a}}P.toString=b}(A||(A={})),e.default=A}),define(re[27],oe([0,1,3]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=A,e.$8n=P,e.$9n=D,e.$0n=l,e.$$n=a,e.$_n=h,e.$ao=b,e.$bo=y,e.$co=w,e.$do=p,e.$eo=R,e.$fo=d,e.$go=c;function A($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const m=Array.isArray($)?[]:{};return Object.entries($).forEach(([g,f])=>{m[g]=f&&typeof f=="object"?A(f):f}),m}function P($){if(!$||typeof $!="object")return $;const m=[$];for(;m.length>0;){const g=m.shift();Object.freeze(g);for(const f in g)if(L.call(g,f)){const n=g[f];typeof n=="object"&&!Object.isFrozen(n)&&!(0,N.$dg)(n)&&m.push(n)}}return $}const L=Object.prototype.hasOwnProperty;function D($,m){return E($,m,new Set)}function E($,m,g){if((0,N.$jg)($))return $;const f=m($);if(typeof f<"u")return f;if(Array.isArray($)){const n=[];for(const r of $)n.push(E(r,m,g));return n}if((0,N.$cg)($)){if(g.has($))throw new Error("Cannot clone recursive data-structure");g.add($);const n={};for(const r in $)L.call($,r)&&(n[r]=E($[r],m,g));return g.delete($),n}return $}function l($,m,g=!0){return(0,N.$cg)($)?((0,N.$cg)(m)&&Object.keys(m).forEach(f=>{f in $?g&&((0,N.$cg)($[f])&&(0,N.$cg)(m[f])?l($[f],m[f],g):$[f]=m[f]):$[f]=m[f]}),$):m}function a($,m){if($===m)return!0;if($==null||m===null||m===void 0||typeof $!=typeof m||typeof $!="object"||Array.isArray($)!==Array.isArray(m))return!1;let g,f;if(Array.isArray($)){if($.length!==m.length)return!1;for(g=0;g<$.length;g++)if(!a($[g],m[g]))return!1}else{const n=[];for(f in $)n.push(f);n.sort();const r=[];for(f in m)r.push(f);if(r.sort(),!a(n,r))return!1;for(g=0;g<n.length;g++)if(!a($[n[g]],m[n[g]]))return!1}return!0}function h($){const m=new Set;return JSON.stringify($,(g,f)=>{if((0,N.$cg)(f)||Array.isArray(f)){if(m.has(f))return"[Circular]";m.add(f)}return typeof f=="bigint"?`[BigInt ${f.toString()}]`:f})}function b($,m){const g=Object.create(null);return!$||!m||Object.keys(m).forEach(n=>{const r=$[n],t=m[n];a(r,t)||(g[n]=t)}),g}function y($,m){const g=m.toLowerCase(),f=Object.keys($).find(n=>n.toLowerCase()===g);return f?$[f]:$[m]}function w($,m){const g=Object.create(null);for(const[f,n]of Object.entries($))m(f,n)&&(g[f]=n);return g}function p($){let m=[];for(;Object.prototype!==$;)m=m.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return m}function R($){const m=[];for(const g of p($))typeof $[g]=="function"&&m.push(g);return m}function d($,m){const g=n=>function(){const r=Array.prototype.slice.call(arguments,0);return m(n,r)},f={};for(const n of $)f[n]=g(n);return f}function c($,m){const g={};for(const[f,n]of Object.entries($))g[f]=m(n,f);return g}}),define(re[28],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=A;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(P){return N.test(P)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(E){for(let l=0;l<E.length;l++)E[l]=Math.floor(Math.random()*256);return E};const L=new Uint8Array(16),D=[];for(let E=0;E<256;E++)D.push(E.toString(16).padStart(2,"0"));return function(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let l=0,a="";return a+=D[L[l++]],a+=D[L[l++]],a+=D[L[l++]],a+=D[L[l++]],a+="-",a+=D[L[l++]],a+=D[L[l++]],a+="-",a+=D[L[l++]],a+=D[L[l++]],a+="-",a+=D[L[l++]],a+=D[L[l++]],a+="-",a+=D[L[l++]],a+=D[L[l++]],a+=D[L[l++]],a+=D[L[l++]],a+=D[L[l++]],a+=D[L[l++]],a}}()}),define(re[80],oe([0,1,33]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=L;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(D){const E=D.replace(/\-/g,":").toLowerCase();return!A.has(E)}function L(){const D=(0,N.networkInterfaces)();for(const E in D){const l=D[E];if(l){for(const{mac:a}of l)if(P(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(re[81],oe([7,4]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(re[82],oe([0,1,81]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=a,e.$7m=h,e.$8m=b;const A=60,P=A*60,L=P*24,D=L*7,E=L*30,l=L*365;function a(y,w,p,R){typeof y!="number"&&(y=y.getTime());const d=Math.round((new Date().getTime()-y)/1e3);if(d<-30)return(0,N.localize)(0,null,a(new Date().getTime()+d*1e3,!1));if(!R&&d<30)return(0,N.localize)(1,null);let c;return d<A?(c=d,w?c===1?p?(0,N.localize)(2,null,c):(0,N.localize)(3,null,c):p?(0,N.localize)(4,null,c):(0,N.localize)(5,null,c):c===1?p?(0,N.localize)(6,null,c):(0,N.localize)(7,null,c):p?(0,N.localize)(8,null,c):(0,N.localize)(9,null,c)):d<P?(c=Math.floor(d/A),w?c===1?p?(0,N.localize)(10,null,c):(0,N.localize)(11,null,c):p?(0,N.localize)(12,null,c):(0,N.localize)(13,null,c):c===1?p?(0,N.localize)(14,null,c):(0,N.localize)(15,null,c):p?(0,N.localize)(16,null,c):(0,N.localize)(17,null,c)):d<L?(c=Math.floor(d/P),w?c===1?p?(0,N.localize)(18,null,c):(0,N.localize)(19,null,c):p?(0,N.localize)(20,null,c):(0,N.localize)(21,null,c):c===1?p?(0,N.localize)(22,null,c):(0,N.localize)(23,null,c):p?(0,N.localize)(24,null,c):(0,N.localize)(25,null,c)):d<D?(c=Math.floor(d/L),w?c===1?(0,N.localize)(26,null,c):(0,N.localize)(27,null,c):c===1?(0,N.localize)(28,null,c):(0,N.localize)(29,null,c)):d<E?(c=Math.floor(d/D),w?c===1?p?(0,N.localize)(30,null,c):(0,N.localize)(31,null,c):p?(0,N.localize)(32,null,c):(0,N.localize)(33,null,c):c===1?p?(0,N.localize)(34,null,c):(0,N.localize)(35,null,c):p?(0,N.localize)(36,null,c):(0,N.localize)(37,null,c)):d<l?(c=Math.floor(d/E),w?c===1?p?(0,N.localize)(38,null,c):(0,N.localize)(39,null,c):p?(0,N.localize)(40,null,c):(0,N.localize)(41,null,c):c===1?p?(0,N.localize)(42,null,c):(0,N.localize)(43,null,c):p?(0,N.localize)(44,null,c):(0,N.localize)(45,null,c)):(c=Math.floor(d/l),w?c===1?p?(0,N.localize)(46,null,c):(0,N.localize)(47,null,c):p?(0,N.localize)(48,null,c):(0,N.localize)(49,null,c):c===1?p?(0,N.localize)(50,null,c):(0,N.localize)(51,null,c):p?(0,N.localize)(52,null,c):(0,N.localize)(53,null,c))}function h(y,w){const p=Math.abs(y/1e3);return p<1?w?(0,N.localize)(54,null,y):(0,N.localize)(55,null,y):p<A?w?(0,N.localize)(56,null,Math.round(y)/1e3):(0,N.localize)(57,null,Math.round(y)/1e3):p<P?w?(0,N.localize)(58,null,Math.round(y/(1e3*A))):(0,N.localize)(59,null,Math.round(y/(1e3*A))):p<L?w?(0,N.localize)(60,null,Math.round(y/(1e3*P))):(0,N.localize)(61,null,Math.round(y/(1e3*P))):(0,N.localize)(62,null,Math.round(y/(1e3*L)))}function b(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(re[83],oe([7,4]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(re[34],oe([0,1,19,3,83]),function(Q,e,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=l,e.$mj=a,e.$nj=h;function L(b,y){return y&&(b.stack||b.stacktrace)?P.localize(0,null,E(b),D(b.stack)||D(b.stacktrace)):E(b)}function D(b){return Array.isArray(b)?b.join(`
`):b}function E(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?P.localize(1,null,b.message):b.message||P.localize(2,null)}function l(b=null,y=!1){if(!b)return P.localize(3,null);if(Array.isArray(b)){const w=N.$Hb(b),p=l(w[0],y);return w.length>1?P.localize(4,null,p,w.length):p}if(A.$ag(b))return b;if(b.detail){const w=b.detail;if(w.error)return L(w.error,y);if(w.exception)return L(w.exception,y)}return b.stack?L(b,y):b.message?b.message:P.localize(5,null)}function a(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}function h(b,y){let w;return typeof b=="string"?w=new Error(b):w=b,w.actions=y,w}}),define(re[84],oe([7,4]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(re[85],oe([0,1,84]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=A;function A(P){switch(P){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}}),define(re[57],oe([0,1,12]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=L,e.$rm=D;var A;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(A||(e.Source=A={}));var P;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function L(E,...l){const a=l.reduce((y,w)=>(y[w]=!0,y),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(y=>!a[y]).forEach(y=>{for(let w=0;w<h.length;w++)if(y.search(h[w])!==-1){delete E[y];break}})}function D(E){E&&(delete E.DEBUG,N.$j&&delete E.DYLD_LIBRARY_PATH,N.$k&&delete E.LD_PRELOAD)}}),define(re[86],oe([0,1,11]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=A,e.$3q=P,e.$4q=L,e.log=E;function A(a){const h=a;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function P(a){const h=[];let b;try{const y=JSON.parse(a.arguments),w=y[y.length-1];w&&w.__$stack&&(y.pop(),b=w.__$stack),h.push(...y)}catch{h.push("Unable to log remote console arguments",a.arguments)}return{args:h,stack:b}}function L(a){if(typeof a!="string")return L(P(a).stack);const h=a;if(h){const b=D(h),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:N.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}function D(a){if(!a)return a;const h=a.indexOf(`
`);return h===-1?a:a.substring(0,h)}function E(a,h){const{args:b,stack:y}=P(a),w=typeof b[0]=="string"&&b.length===1;let p=D(y);p&&(p=`(${p.trim()})`);let R=[];if(typeof b[0]=="string"?p&&w?R=[`%c[${h}] %c${b[0]} %c${p}`,l("blue"),l(""),l("grey")]:R=[`%c[${h}] %c${b[0]}`,l("blue"),l(""),...b.slice(1)]:R=[`%c[${h}]%`,l("blue"),...b],p&&!w&&R.push(p),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,R)}function l(a){return`color: ${a}`}}),define(re[47],oe([0,1,14,11]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=P,e.$9h=L,e.$0h=E;function P(l){return JSON.stringify(l,D)}function L(l){let a=JSON.parse(l);return a=E(a),a}function D(l,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function E(l,a=0){if(!l||a>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return A.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 17:return new Date(l.source)}if(l instanceof N.$Je||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let h=0;h<l.length;++h)l[h]=E(l[h],a+1);else for(const h in l)Object.hasOwnProperty.call(l,h)&&(l[h]=E(l[h],a+1))}return l}}),define(re[87],oe([0,1,74,15,12,11]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bE=h;class D{constructor(y,w,p){this.id=y,this.dependencies=w,this.callback=p}}class E{static{this.INSTANCE=new E}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(y,w,p)=>{typeof y!="string"&&(p=w,w=y,y=null),(typeof w!="object"||!Array.isArray(w))&&(p=w,w=null),this.c.push(new D(y,w,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){if(y.startsWith(window.location.origin)||y.startsWith("vscode-file://vscode-app"))return y;throw new Error(`[trusted_script_src] Invalid script url: ${y}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){return y}})))}async load(y){this.g();const w=await(this.a?this.i(y):this.b?this.h(y):this.j(y));if(!w)throw new Error(`Did not receive a define call from script ${y}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${y}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(y){return new Promise((w,p)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const d=()=>{R.removeEventListener("load",c),R.removeEventListener("error",$)},c=m=>{d(),w(this.c.pop())},$=m=>{d(),p(m)};R.addEventListener("load",c),R.addEventListener("error",$),this.f&&(y=this.f.createScriptURL(y)),R.setAttribute("src",y),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(y){return new Promise((w,p)=>{try{this.f&&(y=this.f.createScriptURL(y)),importScripts(y),w(this.c.pop())}catch(R){p(R)}})}async j(y){try{const w=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,d=L.URI.parse(y).fsPath,c=w.readFileSync(d).toString(),$=R.wrap(c.replace(/^#!.*/,""));return new p.Script($).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const l=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function h(b,y,w){if(N.$T){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[b]&&(b=a[b]);const p=`${b}/${y}`;if(l.has(p))return l.get(p);let R;if(/^\w[\w\d+.-]*:\/\//.test(p))R=p;else{const m=`${w&&!P.$o?A.$Rg:A.$Qg}/${p}`;R=A.$Ug.asBrowserUri(m).toString(!0)}const d=E.INSTANCE.load(R);return l.set(p,d),d}else return await new Promise((p,R)=>{Q([b],p,R)})}}),define(re[88],oe([0,1,33,48,28,80,12]),function(Q,e,N,A,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$Jn=l,e.$Kn=b,e.$In=new class{c(y){return this.a||(this.a=A.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,w=0;const p=(0,N.networkInterfaces)();for(const R in p){const d=p[R];if(d)for(const{mac:c,internal:$}of d)$||(w+=1,this.c(c.toUpperCase())&&(y+=1))}this.b=w>0?y/w:0}return this.b}};let E;async function l(y){return E||(E=(async()=>await a(y)||P.$Wg())()),E}async function a(y){try{const w=await new Promise((R,d)=>{Q(["crypto"],R,d)}),p=(0,L.$Hn)();return w.createHash("sha256").update(p,"utf8").digest("hex")}catch(w){y(w);return}}const h="Software\\Microsoft\\SQMClient";async function b(y){if(D.$i){const w=await new Promise((p,R)=>{Q(["@vscode/windows-registry"],p,R)});try{return w.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch(p){return y(p),""}}return""}}),define(re[89],oe([0,1,33,16,25]),function(Q,e,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=$,e.$pm=m;const L=/^\d+$/,D=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var l;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(l||(l={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=1:h=0;class b{constructor(f,n,r){this.exePath=f,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:g=!1}={}){return g?a===0?process.env["ProgramFiles(x86)"]||null:h===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:g=!1,findPreview:f=!1}={}){const n=y({useAlternateBitness:g});if(!n)return null;const r=A.$jc(n,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const u of await P.Promises.readdir(r)){let S=-1;if(f){const I=u.indexOf("-");if(I<0)continue;const j=u.substring(0,I);if(!L.test(j)||u.substring(I+1)!=="preview")continue;S=parseInt(j,10)}else{if(!L.test(u))continue;S=parseInt(u,10)}if(S<=t)continue;const k=A.$jc(r,u,"pwsh.exe");await P.SymlinkSupport.existsFile(k)&&(i=k,t=S)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",o=f?" Preview":"";return new b(i,`PowerShell${o}${s}`,!0)}async function p({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const f=A.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=g?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const t of await P.Promises.readdir(f))if(n.test(t)){const i=A.$jc(f,t,"pwsh.exe");return new b(i,r)}return null}function R(){const g=A.$jc(N.homedir(),".dotnet","tools","pwsh.exe");return new b(g,".NET Core PowerShell Global Tool")}function d(){const g=A.$jc(process.env.windir,a===1&&h!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(g,"Windows PowerShell",!0)}async function*c(){let g=await w();g&&(yield g),g=await w({useAlternateBitness:!0}),g&&(yield g),g=await p(),g&&(yield g),g=R(),g&&(yield g),g=await w({findPreview:!0}),g&&(yield g),g=await p({findPreview:!0}),g&&(yield g),g=await w({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=d(),g&&(yield g)}async function*$(){for await(const g of c())await g.exists()&&(yield g)}async function m(){for await(const g of $())return g;return null}}),define(re[58],oe([0,1,16,12,35,57,3,25]),function(Q,e,N,A,P,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$sm=l,e.$tm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function l(b=P.env){return b.comspec||"cmd.exe"}function a(b){let y=[],w=!1;const p=function(R){if(w){y.push(R);return}(!b.send(R,c=>{if(c&&console.error(c),w=!1,y.length>0){const $=y.slice(0);y=[],$.forEach(m=>p(m))}})||A.$i)&&(w=!0)};return{send:p}}var h;(function(b){async function y(w,p,R){if(N.$ic(w))return w;if(p===void 0&&(p=P.cwd()),N.$mc(w)!=="."||(R===void 0&&D.$ag(P.env.PATH)&&(R=P.env.PATH.split(N.$tc)),R===void 0||R.length===0))return N.$jc(p,w);async function c($){if(await E.Promises.exists($)){let m;try{m=await E.Promises.stat($)}catch(g){g.message.startsWith("EACCES")&&(m=await E.Promises.lstat($))}return m?!m.isDirectory():!1}return!1}for(const $ of R){let m;if(N.$ic($)?m=N.$jc($,w):m=N.$jc(p,$,w),await c(m))return m;let g=m+".com";if(await c(g)||(g=m+".exe",await c(g)))return g}return N.$jc(p,w)}b.findExecutable=y})(h||(e.win32=h={}))}),define(re[90],oe([0,1,33,12,89,58]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=D;async function D(b,y){return b===1?A.$i?h():L.$sm(y):l(b,y)}let E=null;function l(b,y){if(A.$k&&b===2||A.$j&&b===3)return"/bin/bash";if(!E){let w;if(A.$i)w="/bin/bash";else{if(w=y.SHELL,!w)try{w=(0,N.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}E=w}return E}let a=null;async function h(){return a||(a=(await(0,P.$pm)()).exePath),a}});var $e=this&&this.__decorate||function(Q,e,N,A){var P=arguments.length,L=P<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,N):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,N,A);else for(var E=Q.length-1;E>=0;E--)(D=Q[E])&&(L=(P<3?D(L):P>3?D(e,N,L):D(e,N))||L);return P>3&&L&&Object.defineProperty(e,N,L),L};define(re[59],oe([0,1,19,8,14,22,55,9,5,2,47,31,3]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=o,e.$bi=u,e.$gi=B,e.$hi=J;var w;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(w||(w={}));function p(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var R;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(R||(R={}));function d(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(c||(c={}));function $(x){let M=0;for(let G=0;;G+=7){const Y=x.read(1);if(M|=(Y.buffer[0]&127)<<G,!(Y.buffer[0]&128))return M}}const m=t(0);function g(x,M){if(M===0){x.write(m);return}let G=0;for(let U=M;U!==0;U=U>>>7)G++;const Y=P.$Je.alloc(G);for(let U=0;M!==0;U++)Y.buffer[U]=M&127,M=M>>>7,M>0&&(Y.buffer[U]|=128);x.write(Y)}class f{constructor(M){this.b=M,this.a=0}read(M){const G=this.b.slice(this.a,this.a+M);return this.a+=G.byteLength,G}}e.$$h=f;class n{constructor(){this.a=[]}get buffer(){return P.$Je.concat(this.a)}write(M){this.a.push(M)}}e.$_h=n;var r;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(r||(r={}));function t(x){const M=P.$Je.alloc(1);return M.writeUInt8(x,0),M}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(x,M){if(typeof M>"u")x.write(i.Undefined);else if(typeof M=="string"){const G=P.$Je.fromString(M);x.write(i.String),g(x,G.byteLength),x.write(G)}else if(s&&Buffer.isBuffer(M)){const G=P.$Je.wrap(M);x.write(i.Buffer),g(x,G.byteLength),x.write(G)}else if(M instanceof P.$Je)x.write(i.VSBuffer),g(x,M.byteLength),x.write(M);else if(Array.isArray(M)){x.write(i.Array),g(x,M.length);for(const G of M)o(x,G)}else if(typeof M=="number"&&(M|0)===M)x.write(i.Uint),g(x,M);else{const G=P.$Je.fromString(JSON.stringify(M));x.write(i.Object),g(x,G.byteLength),x.write(G)}}function u(x){switch(x.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return x.read($(x)).toString();case r.Buffer:return x.read($(x)).buffer;case r.VSBuffer:return x.read($(x));case r.Array:{const G=$(x),Y=[];for(let U=0;U<G;U++)Y.push(u(x));return Y}case r.Object:return JSON.parse(x.read($(x)).toString());case r.Int:return $(x)}}class S{constructor(M,G,Y=null,U=1e3){this.h=M,this.j=G,this.k=Y,this.l=U,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:200})}registerChannel(M,G){this.b.set(M,G),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const G=this.o([M.type]);this.k?.logOutgoing(G,0,1,d(M.type));return}case 201:case 202:case 204:case 203:{const G=this.o([M.type,M.id],M.data);this.k?.logOutgoing(G,M.id,1,d(M.type),M.data);return}}}o(M,G=void 0){const Y=new n;return o(Y,M),o(Y,G),this.p(Y.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const G=new f(M),Y=u(G),U=u(G),q=Y[0];switch(q){case 100:return this.k?.logIncoming(M.byteLength,Y[1],1,`${p(q)}: ${Y[2]}.${Y[3]}`,U),this.s({type:q,id:Y[1],channelName:Y[2],name:Y[3],arg:U});case 102:return this.k?.logIncoming(M.byteLength,Y[1],1,`${p(q)}: ${Y[2]}.${Y[3]}`,U),this.t({type:q,id:Y[1],channelName:Y[2],name:Y[3],arg:U});case 101:return this.k?.logIncoming(M.byteLength,Y[1],1,`${p(q)}`),this.u({type:q,id:Y[1]});case 103:return this.k?.logIncoming(M.byteLength,Y[1],1,`${p(q)}`),this.u({type:q,id:Y[1]})}}s(M){const G=this.b.get(M.channelName);if(!G){this.v(M);return}const Y=new L.$se;let U;try{U=G.call(this.j,M.name,M.arg,Y.token)}catch(C){U=Promise.reject(C)}const q=M.id;U.then(C=>{this.m({id:q,data:C,type:201})},C=>{C instanceof Error?this.m({id:q,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:q,data:C,type:203})}).finally(()=>{V.dispose(),this.d.delete(M.id)});const V=(0,a.$Sc)(()=>Y.cancel());this.d.set(M.id,V)}t(M){const G=this.b.get(M.channelName);if(!G){this.v(M);return}const Y=M.id,q=G.listen(this.j,M.name,M.arg)(V=>this.m({id:Y,data:V,type:204}));this.d.set(M.id,q)}u(M){const G=this.d.get(M.id);G&&(G.dispose(),this.d.delete(M.id))}v(M){let G=this.g.get(M.channelName);G||(G=[],this.g.set(M.channelName,G));const Y=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);G.push({request:M,timeoutTimer:Y})}w(M){const G=this.g.get(M);if(G){for(const Y of G)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$ci=S;var k;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class I{constructor(M,G=null){this.l=M,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=G}getChannel(M){const G=this;return{call(Y,U,q){return G.a?Promise.reject(new E.$5):G.m(M,Y,U,q)},listen(Y,U){return G.a?l.Event.None:G.o(M,Y,U)}}}m(M,G,Y,U=L.CancellationToken.None){const q=this.g++,C={id:q,type:100,channelName:M,name:G,arg:Y};if(U.isCancellationRequested)return Promise.reject(new E.$5);let v;return new Promise((z,T)=>{if(U.isCancellationRequested)return T(new E.$5);const Z=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(q),z(pe.data);break;case 202:{this.f.delete(q);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,T(ye);break}case 203:this.f.delete(q),T(pe.data);break}};this.f.set(q,he),this.p(C)};let X=null;this.b===c.Idle?Z():(X=(0,A.$nh)(he=>this.u()),X.then(()=>{X=null,Z()}));const se=()=>{X?(X.cancel(),X=null):this.p({id:q,type:101}),T(new E.$5)},ue=U.onCancellationRequested(se);v=(0,a.$Rc)((0,a.$Sc)(se),ue),this.d.add(v)}).finally(()=>{v.dispose(),this.d.delete(v)})}o(M,G,Y){const U=this.g++,V={id:U,type:102,channelName:M,name:G,arg:Y};let C=null;const v=new l.$he({onWillAddFirstListener:()=>{C=(0,A.$nh)(z=>this.u()),C.then(()=>{C=null,this.d.add(v),this.p(V)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(v),this.p({id:U,type:103}))}}),O=z=>v.fire(z.data);return this.f.set(U,O),v.event}p(M){switch(M.type){case 100:case 102:{const G=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(G,M.id,0,`${p(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const G=this.q([M.type,M.id]);this.j?.logOutgoing(G,M.id,0,p(M.type));return}}}q(M,G=void 0){const Y=new n;return o(Y,M),o(Y,G),this.r(Y.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const G=new f(M),Y=u(G),U=u(G),q=Y[0];switch(q){case 200:return this.j?.logIncoming(M.byteLength,0,0,d(q)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,Y[1],0,d(q),U),this.t({type:Y[0],id:Y[1],data:U})}}t(M){if(M.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$di=I,$e([D.$5h],I.prototype,"onDidInitializePromise",null);class j{get connections(){const M=[];return this.f.forEach(G=>M.push(G)),M}constructor(M,G,Y){this.a=new Map,this.f=new Set,this.g=new l.$he,this.onDidAddConnection=this.g.event,this.h=new l.$he,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(M(({protocol:U,onDidClientDisconnect:q})=>{const V=l.Event.once(U.onMessage);this.j.add(V(C=>{const v=new f(C),O=u(v),z=new S(U,O,G,Y),T=new I(U,G);this.a.forEach((X,se)=>z.registerChannel(se,X));const Z={channelServer:z,channelClient:T,ctx:O};this.f.add(Z),this.g.fire(Z),this.j.add(q(()=>{z.dispose(),T.dispose(),this.f.delete(Z),this.h.fire(Z)}))}))}))}getChannel(M,G){const Y=this;return{call(U,q,V){let C;if((0,y.$og)(G)){const O=(0,N.$3b)(Y.connections.filter(G));C=O?Promise.resolve(O):l.Event.toPromise(l.Event.filter(Y.onDidAddConnection,G))}else C=G.routeCall(Y,U,q);const v=C.then(O=>O.channelClient.getChannel(M));return B(v).call(U,q,V)},listen(U,q){if((0,y.$og)(G))return Y.k(M,G,U,q);const V=G.routeEvent(Y,U,q).then(C=>C.channelClient.getChannel(M));return B(V).listen(U,q)}}}k(M,G,Y,U){const q=this;let V;const C=new l.$he({onWillAddFirstListener:()=>{V=new a.$Tc;const v=new l.$ne,O=new Map,z=Z=>{const se=Z.channelClient.getChannel(M).listen(Y,U),ue=v.add(se);O.set(Z,ue)},T=Z=>{const X=O.get(Z);X&&(X.dispose(),O.delete(Z))};q.connections.filter(G).forEach(z),l.Event.filter(q.onDidAddConnection,G)(z,void 0,V),q.onDidRemoveConnection(T,void 0,V),v.event(C.fire,C,V),V.add(v)},onDidRemoveLastListener:()=>{V?.dispose(),V=void 0}});return C.event}registerChannel(M,G){this.a.set(M,G);for(const Y of this.f)Y.channelServer.registerChannel(M,G)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=j;class F{constructor(M,G,Y=null){const U=new n;o(U,G),M.send(U.buffer),this.a=new I(M,Y),this.d=new S(M,G,Y)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,G){this.d.registerChannel(M,G)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=F;function B(x){return{call(M,G,Y){return x.then(U=>U.call(M,G,Y))},listen(M,G){const Y=new l.$qe;return x.then(U=>Y.input=U.listen(M,G)),Y.event}}}function J(x){let M=!1;return{call(G,Y,U){return M?x.call(G,Y,U):(0,A.$Bh)(0).then(()=>M=!0).then(()=>x.call(G,Y,U))},listen(G,Y){if(M)return x.listen(G,Y);const U=new l.$qe;return(0,A.$Bh)(0).then(()=>M=!0).then(()=>U.input=x.listen(G,Y)),U.event}}}class ne{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const G of M.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await l.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$ii=ne;var te;(function(x){function M(q,V,C){const v=q,O=C&&C.disableMarshalling,z=new Map;for(const T in v)Y(T)&&z.set(T,l.Event.buffer(v[T],!0,void 0,V));return new class{listen(T,Z,X){const se=z.get(Z);if(se)return se;const ue=v[Z];if(typeof ue=="function"){if(U(Z))return ue.call(v,X);if(Y(Z))return z.set(Z,l.Event.buffer(v[Z],!0,void 0,V)),z.get(Z)}throw new E.$bb(`Event not found: ${Z}`)}call(T,Z,X){const se=v[Z];if(typeof se=="function"){if(!O&&Array.isArray(X))for(let he=0;he<X.length;he++)X[he]=(0,h.$0h)(X[he]);let ue=se.apply(v,X);return ue instanceof Promise||(ue=Promise.resolve(ue)),ue}throw new E.$bb(`Method not found: ${Z}`)}}}x.fromService=M;function G(q,V){const C=V&&V.disableMarshalling;return new Proxy({},{get(v,O){if(typeof O=="string")return V?.properties?.has(O)?V.properties.get(O):U(O)?function(z){return q.listen(O,z)}:Y(O)?q.listen(O):async function(...z){let T;V&&!(0,y.$jg)(V.context)?T=[V.context,...z]:T=z;const Z=await q.call(O,T);return C?Z:(0,h.$0h)(Z)};throw new E.$bb(`Property not found: ${String(O)}`)}})}x.toService=G;function Y(q){return q[0]==="o"&&q[1]==="n"&&b.$Af(q.charCodeAt(2))}function U(q){return/^onDynamic/.test(q)&&b.$Af(q.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const M=x.toString();if(M!=="[object Object]")return M}return x}function ae(x){return Array.isArray(x)?x.map(ce):ce(x)}function W(x,M,G,Y,U,q,V){V=ae(V);const C=le[U],v=C[Y%C.length];let O=[`%c[${x}]%c[${String(M).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${v}`];/\($/.test(q)?(O=O.concat(V),O.push(")")):O.push(V),console.log.apply(console,O)}class K{constructor(M,G){this.d=M,this.f=G,this.a=0,this.b=0}logOutgoing(M,G,Y,U,q){this.b+=M,W(this.d,this.b,M,G,Y,U,q)}logIncoming(M,G,Y,U,q){this.a+=M,W(this.f,this.a,M,G,Y,U,q)}}e.$ji=K}),define(re[91],oe([0,1,60,8,14,22,86,9,5,2,27,58,57,59]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=void 0;class p extends w.$ci{constructor(c){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",$=>P.$Je.wrap(Buffer.from($,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$6q=p;class R{constructor(c,$){this.i=c,this.j=$,this.c=new Set,this.g=new Map,this.h=new l.$he,this.onDidProcessExit=this.h.event;const m=$&&$.timeout?$.timeout:6e4;this.b=new A.$xh(m),this.d=null,this.f=null}getChannel(c){const $=this;return{call(m,g,f){return $.k(c,m,g,f)},listen(m,g){return $.l(c,m,g)}}}k(c,$,m,g=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const f=this.n(c),n=(0,A.$nh)(i=>f.call($,m,i)),r=g.onCancellationRequested(()=>n.cancel()),t=(0,a.$Sc)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(c,$,m){if(!this.b)return l.Event.None;this.b.cancel();let g;const f=new l.$he({onWillAddFirstListener:()=>{g=this.n(c).listen($,m)(f.fire,f),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,h.$7n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,y.$rm)($.env),this.d=(0,N.fork)(this.i,c,$);const m=new l.$he,f=l.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,D.$2q)(o)){(0,D.log)(o,`IPC Library: ${this.j.serverName}`);return}m.fire(P.$Je.wrap(Buffer.from(o,"base64")))}),n=this.j.useQueue?(0,b.$tm)(this.d):this.d,r=o=>this.d&&this.d.connected&&n.send(o.buffer.toString("base64")),t=m.event,i={send:r,onMessage:t};this.f=new w.$di(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",s),f.dispose(),this.c.forEach(S=>(0,a.$Pc)(S)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(c){let $=this.g.get(c);return $||($=this.m.getChannel(c),this.g.set(c,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7q=R}),define(re[92],oe([0,1,8,5,2,47,3]),function(Q,e,N,A,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.StorageState=e.StorageHint=void 0,e.$2p=l;var E;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function l(y){const w=y;return w?.changed instanceof Map||w?.deleted instanceof Set}var a;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(a||(e.StorageState=a={}));class h extends P.$Uc{static{this.a=100}constructor(w,p=Object.create(null)){super(),this.r=w,this.s=p,this.b=this.B(new A.$ke),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new N.$yh(h.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((p,R)=>this.w(R,p)),w.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(w,p){if(this.c===a.Closed)return;let R=!1;(0,D.$jg)(p)?R=this.f.delete(w):this.f.get(w)!==p&&(this.f.set(w,p),R=!0),R&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,p){const R=this.f.get(w);return(0,D.$jg)(R)?p:R}getBoolean(w,p){const R=this.get(w);return(0,D.$jg)(R)?p:R==="true"}getNumber(w,p){const R=this.get(w);return(0,D.$jg)(R)?p:parseInt(R,10)}getObject(w,p){const R=this.get(w);return(0,D.$jg)(R)?p:(0,L.$9h)(R)}async set(w,p,R=!1){if(this.c===a.Closed)return;if((0,D.$jg)(p))return this.delete(w,R);const d=(0,D.$cg)(p)||Array.isArray(p)?(0,L.$8h)(p):String(p);if(this.f.get(w)!==d)return this.f.set(w,d),this.j.set(w,d),this.h.delete(w),this.b.fire({key:w,external:R}),this.D()}async delete(w,p=!1){if(!(this.c===a.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:p}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===a.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$3p=h;class b{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((p,R)=>this.a.set(R,p)),w.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$4p=b}),define(re[93],oe([7,4]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(re[49],oe([0,1,61,8,16,3,25,93]),function(Q,e,N,A,P,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=void 0,e.zip=d,e.$pq=c,e.$qq=m,e.$mq="end of central directory record signature not found";const l=new RegExp(e.$mq);class a extends Error{constructor(f,n){let r=n.message;switch(f){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=f,this.cause=n}}e.$nq=a;function h(g){const f=g.externalFileAttributes>>16||33188;return[448,56,7].map(n=>f&n).reduce((n,r)=>n+r,f&61440)}function b(g){if(g instanceof a)return g;let f;return l.test(g.message)&&(f="CorruptZip"),new a(f,g)}function y(g,f,n,r,t,i){const s=P.$mc(f),o=P.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(E.localize(0,null,f)));const u=P.$jc(r,f);let S;return i.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(D.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((k,I)=>{if(!i.isCancellationRequested)try{S=(0,N.createWriteStream)(u,{mode:n}),S.once("close",()=>k()),S.once("error",I),g.once("error",I),g.pipe(S)}catch(j){I(j)}}))}function w(g,f,n,r){let t=(0,A.$nh)(()=>Promise.resolve()),i=0;const s=r.onCancellationRequested(()=>{t.cancel(),g.close()});return new Promise((o,u)=>{const S=new A.$vh,k=I=>{I.isCancellationRequested||(i++,g.readEntry())};g.once("error",u),g.once("close",()=>t.then(()=>{r.isCancellationRequested||g.entryCount===i?o():u(new a("Incomplete",new Error(E.localize(1,null,i,g.entryCount))))},u)),g.readEntry(),g.on("entry",I=>{if(r.isCancellationRequested)return;if(!n.sourcePathRegex.test(I.fileName)){k(r);return}const j=I.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(j)){const J=P.$jc(f,j);t=(0,A.$nh)(ne=>D.Promises.mkdir(J,{recursive:!0}).then(()=>k(ne)).then(void 0,u));return}const F=R(g,I),B=h(I);t=(0,A.$nh)(J=>S.queue(()=>F.then(ne=>y(ne,j,B,f,n,J).then(()=>k(J)))).then(null,u))})}).finally(()=>s.dispose())}async function p(g,f=!1){const{open:n}=await new Promise((r,t)=>{Q(["yauzl"],r,t)});return new Promise((r,t)=>{n(g,f?{lazyEntries:!0}:void 0,(i,s)=>{i?t(b(i)):r((0,L.$lg)(s))})})}function R(g,f){return new Promise((n,r)=>{g.openReadStream(f,(t,i)=>{t?r(b(t)):n((0,L.$lg)(i))})})}async function d(g,f){const{ZipFile:n}=await new Promise((r,t)=>{Q(["yazl"],r,t)});return new Promise((r,t)=>{const i=new n;f.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const s=(0,N.createWriteStream)(g);i.outputStream.pipe(s),i.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(g))})}function c(g,f,n={},r){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let i=p(g,!0);return n.overwrite&&(i=i.then(s=>D.Promises.rm(f).then(()=>s))),i.then(s=>w(s,f,{sourcePathRegex:t},r))}function $(g,f){return p(g).then(n=>new Promise((r,t)=>{n.on("entry",i=>{i.fileName===f&&R(n,i).then(s=>r(s),s=>t(s))}),n.once("close",()=>t(new Error(E.localize(2,null,f))))}))}function m(g,f){return $(g,f).then(n=>new Promise((r,t)=>{const i=[];n.once("error",t),n.on("data",s=>i.push(s)),n.on("end",()=>r(Buffer.concat(i)))}))}}),define(re[94],oe([7,4]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[95],oe([7,4]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(re[96],oe([7,4]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(re[97],oe([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[98],oe([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[99],oe([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(re[100],oe([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[101],oe([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[102],oe([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[103],oe([7,4]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[104],oe([7,4]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[105],oe([7,4]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(re[106],oe([7,4]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(re[107],oe([7,4]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[108],oe([7,4]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[109],oe([7,4]),function(Q,e){return Q.create("vs/platform/log/common/log",e)}),define(re[110],oe([7,4]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(re[111],oe([7,4]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(re[112],oe([7,4]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[113],oe([7,4]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[114],oe([7,4]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(re[115],oe([0,1,9,96]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var P;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(P||(e.TokenType=P={}));function L(...a){switch(a.length){case 1:return(0,A.localize)(0,null,a[0]);case 2:return(0,A.localize)(1,null,a[0],a[1]);case 3:return(0,A.localize)(2,null,a[0],a[1],a[2]);default:return}}const D=(0,A.localize)(3,null),E=(0,A.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return h.isTripleEq?"===":"==";case 4:return h.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return h.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return h.lexeme;case 18:return h.lexeme;case 19:return h.lexeme;case 20:return"EOF";default:throw(0,N.$8)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const b=this.d,y=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:y};this.g.push({offset:b,lexeme:y,additionalInfo:h}),this.f.push(w)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const b=this.c.substring(this.d,this.e),y=l.b.get(b);y?this.k(y):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,b=!1,y=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(E);return}const p=this.c.charCodeAt(h);if(b)b=!1;else if(p===47&&!y){h++;break}else p===91?y=!0:p===92?b=!0:p===93&&(y=!1);h++}for(;h<this.c.length&&l.a.has(this.c.charCodeAt(h));)h++;this.e=h;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=l}),define(re[116],oe([0,1,82,55,15,16,35,17,11]),function(Q,e,N,A,P,L,D,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=void 0,e.$$m=h,e.$_m=b,e.$9m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,L.$mc)(P.$Ug.asFileUri("").fsPath)}get userHome(){return l.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return l.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.b.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,E.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,N.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",w)}return l.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$bh)(l.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=D.env.VSCODE_PORTABLE;return w?l.URI.file((0,L.$jc)(w,"argv.json")):(0,E.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,L.$kc)(w):(0,L.$hc)((0,L.$jc)(P.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?l.URI.file((0,L.$kc)(w)):l.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,L.$kc)(w);const p=D.env.VSCODE_EXTENSIONS;if(p)return p;const R=D.env.VSCODE_PORTABLE;return R?(0,L.$jc)(R,"extensions"):(0,E.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(p=>/^[^:/?#]+?:\/\//.test(p)?l.URI.parse(p):l.URI.file((0,L.$hc)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?l.URI.parse(w):l.URI.file((0,L.$hc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$9m.test(w))}get extensionLogLevel(){const w=[];for(const p of this.args.log||[]){const R=e.$9m.exec(p);R&&R[1]&&R[2]&&w.push([R[1],R[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,E.$bh)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=D.env.VSCODE_PORTABLE;return w?l.URI.file((0,L.$jc)(w,"policy.json")):(0,E.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,p,R){this.a=w,this.b=p,this.c=R,this.editSessionId=this.args.editSessionId}}e.$0m=a,$e([A.$5h],a.prototype,"appRoot",null),$e([A.$5h],a.prototype,"userHome",null),$e([A.$5h],a.prototype,"userDataPath",null),$e([A.$5h],a.prototype,"appSettingsHome",null),$e([A.$5h],a.prototype,"tmpDir",null),$e([A.$5h],a.prototype,"cacheHome",null),$e([A.$5h],a.prototype,"stateResource",null),$e([A.$5h],a.prototype,"userRoamingDataHome",null),$e([A.$5h],a.prototype,"userDataSyncHome",null),$e([A.$5h],a.prototype,"sync",null),$e([A.$5h],a.prototype,"machineSettingsResource",null),$e([A.$5h],a.prototype,"workspaceStorageHome",null),$e([A.$5h],a.prototype,"localHistoryHome",null),$e([A.$5h],a.prototype,"keyboardLayoutResource",null),$e([A.$5h],a.prototype,"argvResource",null),$e([A.$5h],a.prototype,"isExtensionDevelopment",null),$e([A.$5h],a.prototype,"untitledWorkspacesHome",null),$e([A.$5h],a.prototype,"builtinExtensionsPath",null),$e([A.$5h],a.prototype,"extensionsPath",null),$e([A.$5h],a.prototype,"extensionDevelopmentLocationURI",null),$e([A.$5h],a.prototype,"extensionDevelopmentKind",null),$e([A.$5h],a.prototype,"extensionTestsLocationURI",null),$e([A.$5h],a.prototype,"debugExtensionHost",null),$e([A.$5h],a.prototype,"logLevel",null),$e([A.$5h],a.prototype,"extensionLogLevel",null),$e([A.$5h],a.prototype,"serviceMachineIdResource",null),$e([A.$5h],a.prototype,"disableTelemetry",null),$e([A.$5h],a.prototype,"disableWorkspaceTrust",null),$e([A.$5h],a.prototype,"useInMemorySecretStorage",null),$e([A.$5h],a.prototype,"policyFile",null);function h(y,w){return b(y["inspect-extensions"],y["inspect-brk-extensions"],5870,w,y.debugId,y.extensionEnvironment)}function b(y,w,p,R,d,c){const m=Number(w||y)||(R?null:p),g=m?!!w:!1;let f;if(c)try{f=JSON.parse(c)}catch{}return{port:m,break:g,debugId:d,env:f}}}),function(){"use strict";function Q(e,N,A){function P(D,E){const l=L(D,E),a=[l];return e.isAbsolute(l)||a.unshift(A),e.resolve(...a)}function L(D,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,E);const h=D["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(N.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,E)}return{getUserDataPath:P}}if(typeof define=="function")define(re[117],oe([170,33,35]),function(e,N,A){return Q(e,N,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=Q(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[118],oe([0,1,33,116,117]),function(Q,e,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=void 0,e.$bn=D,e.$cn=E;class L extends A.$0m{constructor(a,h){super(a,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,P.getUserDataPath)(a,h.nameShort)},h)}}e.$an=L;function D(l,a){return(0,A.$_m)(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,a,l.extensionEnvironment)}function E(l,a){return(0,A.$_m)(l["inspect-sharedprocess"],l["inspect-brk-sharedprocess"],5879,a,l.extensionEnvironment)}}),define(re[119],oe([0,1,3,100]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=P;function P(D,E,l,a){try{L(D,E,l,a)}catch(h){D.error(h?.message??h)}return E}function L(D,E,l,a){const h=(b,y,w)=>{const p=b[y];if((0,N.$ag)(p)){const R=p,d=R.length;if(d>1&&R[0]==="%"&&R[d-1]==="%"){const c=R.substr(1,d-2);let $=l[c];$===void 0&&a&&($=a[c]);const m=typeof $=="string"?$:$?.message,g=a?.[c],f=typeof g=="string"?g:g?.message;if(!m){f||D.warn(`[${E.name}]: ${(0,A.localize)(0,null,c)}`);return}if(w&&(y==="title"||y==="category")&&f&&f!==m){const n={value:m,original:f};b[y]=n}else b[y]=m}}else if((0,N.$cg)(p))for(const R in p)p.hasOwnProperty(R)&&(R==="commands"?h(p,R,!0):h(p,R,w));else if(Array.isArray(p))for(let R=0;R<p.length;R++)h(p,R,w)};for(const b in E)E.hasOwnProperty(b)&&h(E,b)}}),define(re[50],oe([0,1,17,56,104,44]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=l,e.$Np=a,e.$Op=h,e.$Pp=b,e.$Qp=y,e.$Rp=w,e.$Sp=p;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function l(c){return c=c.trim(),c==="*"||D.test(c)}function a(c){if(!l(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=c.match(D);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}function h(c){if(!c)return null;const $=c.majorBase,m=c.majorMustEqual,g=c.minorBase;let f=c.minorMustEqual;const n=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&($===0||(f=!1),r=!1);let t=0;if(c.preRelease){const i=E.exec(c.preRelease);if(i){const[,s,o,u]=i;t=Date.UTC(Number(s),Number(o)-1,Number(u))}}return{majorBase:$,majorMustEqual:m,minorBase:g,minorMustEqual:f,patchBase:n,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function b(c,$,m){let g;typeof c=="string"?g=h(a(c)):g=c;let f;$ instanceof Date?f=$.getTime():typeof $=="string"&&(f=new Date($).getTime());let n;if(typeof m=="string"?n=h(a(m)):n=m,!g||!n)return!1;const r=g.majorBase,t=g.minorBase,i=g.patchBase;let s=n.majorBase,o=n.minorBase,u=n.patchBase;const S=n.notBefore;let k=n.majorMustEqual,I=n.minorMustEqual,j=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||f&&f<S?!1:i>=u:(r===1&&s===0&&(!k||!I||!j)&&(s=1,o=0,u=0,k=!0,I=!1,j=!1),r<s?!1:r>s?!k:t<o?!1:t>o?!I:i<u?!1:i>u?!j:!(f&&f<S))}function y(c,$,m,g,f){const n=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return n.push([A.default.Error,P.localize(0,null)]),n;if(typeof g.name!="string")return n.push([A.default.Error,P.localize(1,null,"name")]),n;if(typeof g.version!="string")return n.push([A.default.Error,P.localize(2,null,"version")]),n;if(!g.engines)return n.push([A.default.Error,P.localize(3,null,"engines")]),n;if(typeof g.engines.vscode!="string")return n.push([A.default.Error,P.localize(4,null,"engines.vscode")]),n;if(typeof g.extensionDependencies<"u"&&!d(g.extensionDependencies))return n.push([A.default.Error,P.localize(5,null,"extensionDependencies")]),n;if(typeof g.activationEvents<"u"){if(!d(g.activationEvents))return n.push([A.default.Error,P.localize(6,null,"activationEvents")]),n;if(typeof g.main>"u"&&typeof g.browser>"u")return n.push([A.default.Error,P.localize(7,null,"activationEvents","main","browser")]),n}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&n.push([A.default.Warning,P.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return n.push([A.default.Error,P.localize(9,null,"main")]),n;{const i=(0,N.$bh)(m,g.main);(0,N.$8g)(i,m)||n.push([A.default.Warning,P.localize(10,null,i.path,m.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return n.push([A.default.Error,P.localize(11,null,"browser")]),n;{const i=(0,N.$bh)(m,g.browser);(0,N.$8g)(i,m)||n.push([A.default.Warning,P.localize(12,null,i.path,m.path)])}}if(!L.valid(g.version))return n.push([A.default.Error,P.localize(13,null)]),n;const r=[];if(!w(c,$,g,f,r))for(const i of r)n.push([A.default.Error,i]);return n}function w(c,$,m,g,f){return g||typeof m.main>"u"&&typeof m.browser>"u"?!0:R(c,$,m.engines.vscode,f)}function p(c,$,m){return c==="*"||R($,m,c)}function R(c,$,m,g=[]){const f=h(a(m));if(!f)return g.push(P.localize(14,null,m)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return g.push(P.localize(15,null,m)),!1}else if(!f.majorMustEqual)return g.push(P.localize(16,null,m)),!1;return b(c,$,f)?!0:(g.push(P.localize(17,null,c,m)),!1)}function d(c){if(!Array.isArray(c))return!1;for(let $=0,m=c.length;$<m;$++)if(typeof c[$]!="string")return!1;return!0}}),define(re[120],oe([0,1,14,28]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=P;async function P(L,D,E){let l=E&&E.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const h=(await D.readFile(L.serviceMachineIdResource)).value.toString();l=(0,A.$Vg)(h)?h:null}catch{l=null}if(!l){l=(0,A.$Wg)();try{await D.writeFile(L.serviceMachineIdResource,N.$Je.fromString(l))}catch{}}return E?.store("storage.serviceMachineId",l,-1,1),l}}),define(re[51],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class N{constructor(P,L=[],D=!1){this.ctor=P,this.staticArguments=L,this.supportsDelayedInstantiation=D}}e.$xi=N}),define(re[121],oe([0,1,51]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ds=L,e.$Es=D;const A=[];var P;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function L(E,l,a){l instanceof N.$xi||(l=new N.$xi(l,[],!!a)),A.push([E,l])}function D(){return A}}),define(re[122],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;class N{constructor(L,D){this.key=L,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$gr=N;class A{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const D of this.a.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const E=this.lookupOrInsertNode(L),l=this.lookupOrInsertNode(D);E.outgoing.set(l.key,l),l.incoming.set(E.key,E)}removeNode(L){const D=this.b(L);this.a.delete(D);for(const E of this.a.values())E.outgoing.delete(D),E.incoming.delete(D)}lookupOrInsertNode(L){const D=this.b(L);let E=this.a.get(D);return E||(E=new N(D,L),this.a.set(D,E)),E}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[D,E]of this.a)L.push(`${D}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,D]of this.a){const E=new Set([L]),l=this.c(D,E);if(l)return l}}c(L,D){for(const[E,l]of L.outgoing){if(D.has(E))return[...D,E].join(" -> ");D.add(E);const a=this.c(l,D);if(a)return a;D.delete(E)}}}e.$hr=A}),define(re[29],oe([0,1,3,11,10]),function(Q,e,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=L,e.$9i=D,e.$0i=l,e.$$i=a,e.$_i=h,e.$aj=b,e.$bj=y,e.$cj=p,e.$dj=R,e.$ej=d,e.$7i=(0,P.$Ai)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof A.URI)}function D(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof A.URI)}var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function l(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function h(c,$){const m=Object.create(null);for(const g in c)b(m,g,c[g],$);return m}function b(c,$,m,g){const f=$.split("."),n=f.pop();let r=c;for(let t=0;t<f.length;t++){const i=f[t];let s=r[i];switch(typeof s){case"undefined":s=r[i]=Object.create(null);break;case"object":if(s===null){g(`Ignoring ${$} as ${f.slice(0,t+1).join(".")} is null`);return}break;default:g(`Ignoring ${$} as ${f.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=m}catch{g(`Ignoring ${$} as ${f.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${$} as ${f.join(".")} is ${JSON.stringify(r)}`)}function y(c,$){const m=$.split(".");w(c,m)}function w(c,$){const m=$.shift();if($.length===0){delete c[m];return}if(Object.keys(c).indexOf(m)!==-1){const g=c[m];typeof g=="object"&&!Array.isArray(g)&&(w(g,$),Object.keys(g).length===0&&delete c[m])}}function p(c,$,m){function g(r,t){let i=r;for(const s of t){if(typeof i!="object"||i===null)return;i=i[s]}return i}const f=$.split("."),n=g(c,f);return typeof n>"u"?m:n}function R(c,$,m){Object.keys($).forEach(g=>{g!=="__proto__"&&(g in c?N.$cg(c[g])&&N.$cg($[g])?R(c[g],$[g],m):m&&(c[g]=$[g]):c[g]=$[g])})}function d(c){return c.replace(/[\[\]]/g,"")}}),define(re[123],oe([0,1,12,31,115,10,95,9]),function(Q,e,N,A,P,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=a,e.$zj=r,e.$Aj=t,e.$Tj=U;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",N.$j),l.set("isLinux",N.$k),l.set("isWindows",N.$i),l.set("isWeb",N.$o),l.set("isMacNative",N.$j&&!N.$o),l.set("isEdge",N.$H),l.set("isFirefox",N.$F),l.set("isChrome",N.$E),l.set("isSafari",N.$G);function a(C,v){if(l.get(C)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(C,v)}const h=Object.prototype.hasOwnProperty;var b;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const y={regexParsingWithErrorRecovery:!0},w=(0,D.localize)(0,null),p=(0,D.localize)(1,null),R=(0,D.localize)(2,null),d=(0,D.localize)(3,null),c=(0,D.localize)(4,null),$=(0,D.localize)(5,null),m=(0,D.localize)(6,null),g=(0,D.localize)(7,null);class f{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(v=y){this.k=v,this.d=new P.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(v){if(v===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(v).scan(),this.g=0,this.h=[];try{const O=this.l();if(!this.E()){const z=this.D(),T=z.type===17?$:void 0;throw this.h.push({message:c,offset:z.offset,lexeme:P.$vj.getLexeme(z),additionalInfo:T}),f.c}return O}catch(O){if(O!==f.c)throw O;return}}l(){return this.m()}m(){const v=[this.o()];for(;this.y(16);){const O=this.o();v.push(O)}return v.length===1?v[0]:n.or(...v)}o(){const v=[this.s()];for(;this.y(15);){const O=this.s();v.push(O)}return v.length===1?v[0]:n.and(...v)}s(){if(this.y(2)){const v=this.D();switch(v.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const O=this.l();return this.A(1,d),O?.negate()}case 17:return this.z(),F.create(v.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",v)}}return this.t()}t(){const v=this.D();switch(v.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const O=this.l();return this.A(1,d),O}case 17:{const O=v.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const Z=T.lexeme,X=Z.lastIndexOf("/"),se=X===Z.length-1?void 0:this.w(Z.substring(X+1));let ue;try{ue=new RegExp(Z.substring(1,X),se)}catch{throw this.B("REGEX",T)}return ce.create(O,ue)}switch(T.type){case 10:case 19:{const Z=[T.lexeme];this.z();let X=this.D(),se=0;for(let fe=0;fe<T.lexeme.length;fe++)T.lexeme.charCodeAt(fe)===40?se++:T.lexeme.charCodeAt(fe)===41&&se--;for(;!this.E()&&X.type!==15&&X.type!==16;){switch(X.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let fe=0;fe<X.lexeme.length;fe++)X.lexeme.charCodeAt(fe)===40?se++:T.lexeme.charCodeAt(fe)===41&&se--}if(se<0)break;Z.push(P.$vj.getLexeme(X)),this.z(),X=this.D()}const ue=Z.join(""),he=ue.lastIndexOf("/"),pe=he===ue.length-1?void 0:this.w(ue.substring(he+1));let ye;try{ye=new RegExp(ue.substring(1,he),pe)}catch{throw this.B("REGEX",T)}return n.regex(O,ye)}case 18:{const Z=T.lexeme;this.z();let X=null;if(!(0,A.$$e)(Z)){const se=Z.indexOf("/"),ue=Z.lastIndexOf("/");if(se!==ue&&se>=0){const he=Z.slice(se+1,ue),pe=Z[ue+1]==="i"?"i":"";try{X=new RegExp(he,pe)}catch{throw this.B("REGEX",T)}}}if(X===null)throw this.B("REGEX",T);return ce.create(O,X)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,R);const T=this.u();return n.notIn(O,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return n.equals(O,T);switch(T){case"true":return n.has(O);case"false":return n.not(O);default:return n.equals(O,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return n.notEquals(O,T);switch(T){case"true":return n.not(O);case"false":return n.has(O);default:return n.notEquals(O,T)}}case 5:return this.z(),te.create(O,this.u());case 6:return this.z(),le.create(O,this.u());case 7:return this.z(),J.create(O,this.u());case 8:return this.z(),ne.create(O,this.u());case 13:return this.z(),n.in(O,this.u());default:return n.has(O)}}case 20:throw this.h.push({message:m,offset:v.offset,lexeme:"",additionalInfo:g}),f.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const v=this.D();switch(v.type){case 17:case 18:return this.z(),v.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(v){return v.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(v){return this.C(v)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(v,O){if(this.C(v))return this.z();throw this.B(O,this.D())}B(v,O,z){const T=(0,D.localize)(8,null,v,P.$vj.getLexeme(O)),Z=O.offset,X=P.$vj.getLexeme(O);return this.h.push({message:T,offset:Z,lexeme:X,additionalInfo:z}),f.c}C(v){return this.D().type===v}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$xj=f;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(v){return u.create(v)}static equals(v,O){return S.create(v,O)}static notEquals(v,O){return j.create(v,O)}static regex(v,O){return ce.create(v,O)}static in(v,O){return k.create(v,O)}static notIn(v,O){return I.create(v,O)}static not(v){return F.create(v)}static and(...v){return K.create(v,null,!0)}static or(...v){return x.create(v,null,!0)}static greater(v,O){return J.create(v,O)}static greaterEquals(v,O){return ne.create(v,O)}static smaller(v,O){return te.create(v,O)}static smallerEquals(v,O){return le.create(v,O)}static{this.c=new f({regexParsingWithErrorRecovery:!1})}static deserialize(v){return v==null?void 0:this.c.parse(v)}}e.$yj=n;function r(C){const v=new f({regexParsingWithErrorRecovery:!1});return C.map(O=>(v.parse(O),v.lexingErrors.length>0?v.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,D.localize)(9,null,z.additionalInfo):(0,D.localize)(10,null),offset:z.offset,length:z.lexeme.length})):v.parsingErrors.length>0?v.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function t(C,v){const O=C?C.substituteConstants():void 0,z=v?v.substituteConstants():void 0;return!O&&!z?!0:!O||!z?!1:O.equals(z)}function i(C,v){return C.cmp(v)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return o.INSTANCE}}e.$Bj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return s.INSTANCE}}e.$Cj=o;class u{static create(v,O=null){const z=l.get(v);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new u(v,O)}constructor(v,O){this.key=v,this.c=O,this.type=2}cmp(v){return v.type!==this.type?this.type-v.type:G(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=l.get(this.key);return typeof v=="boolean"?v?o.INSTANCE:s.INSTANCE:this}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Dj=u;class S{static create(v,O,z=null){if(typeof O=="boolean")return O?u.create(v,z):F.create(v,z);const T=l.get(v);return typeof T=="boolean"?O===(T?"true":"false")?o.INSTANCE:s.INSTANCE:new S(v,O,z)}constructor(v,O,z){this.c=v,this.d=O,this.f=z,this.type=4}cmp(v){return v.type!==this.type?this.type-v.type:Y(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){const v=l.get(this.c);if(typeof v=="boolean"){const O=v?"true":"false";return this.d===O?o.INSTANCE:s.INSTANCE}return this}evaluate(v){return v.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(v){return v.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ej=S;class k{static create(v,O){return new k(v,O)}constructor(v,O){this.d=v,this.f=O,this.type=10,this.c=null}cmp(v){return v.type!==this.type?this.type-v.type:Y(this.d,this.f,v.d,v.f)}equals(v){return v.type===this.type?this.d===v.d&&this.f===v.f:!1}substituteConstants(){return this}evaluate(v){const O=v.getValue(this.f),z=v.getValue(this.d);return Array.isArray(O)?O.includes(z):typeof z=="string"&&typeof O=="object"&&O!==null?h.call(O,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(v){return v.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$Fj=k;class I{static create(v,O){return new I(v,O)}constructor(v,O){this.d=v,this.f=O,this.type=11,this.c=k.create(v,O)}cmp(v){return v.type!==this.type?this.type-v.type:this.c.cmp(v.c)}equals(v){return v.type===this.type?this.c.equals(v.c):!1}substituteConstants(){return this}evaluate(v){return!this.c.evaluate(v)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(v){return v.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=I;class j{static create(v,O,z=null){if(typeof O=="boolean")return O?F.create(v,z):u.create(v,z);const T=l.get(v);return typeof T=="boolean"?O===(T?"true":"false")?s.INSTANCE:o.INSTANCE:new j(v,O,z)}constructor(v,O,z){this.c=v,this.d=O,this.f=z,this.type=5}cmp(v){return v.type!==this.type?this.type-v.type:Y(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){const v=l.get(this.c);if(typeof v=="boolean"){const O=v?"true":"false";return this.d===O?s.INSTANCE:o.INSTANCE}return this}evaluate(v){return v.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(v){return v.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Hj=j;class F{static create(v,O=null){const z=l.get(v);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new F(v,O)}constructor(v,O){this.c=v,this.d=O,this.type=3}cmp(v){return v.type!==this.type?this.type-v.type:G(this.c,v.c)}equals(v){return v.type===this.type?this.c===v.c:!1}substituteConstants(){const v=l.get(this.c);return typeof v=="boolean"?v?s.INSTANCE:o.INSTANCE:this}evaluate(v){return!v.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(v){return v.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Ij=F;function B(C,v){if(typeof C=="string"){const O=parseFloat(C);isNaN(O)||(C=O)}return typeof C=="string"||typeof C=="number"?v(C):s.INSTANCE}class J{static create(v,O,z=null){return B(O,T=>new J(v,T,z))}constructor(v,O,z){this.c=v,this.d=O,this.f=z,this.type=12}cmp(v){return v.type!==this.type?this.type-v.type:Y(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){return this}evaluate(v){return typeof this.d=="string"?!1:parseFloat(v.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(v){return v.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$Jj=J;class ne{static create(v,O,z=null){return B(O,T=>new ne(v,T,z))}constructor(v,O,z){this.c=v,this.d=O,this.f=z,this.type=13}cmp(v){return v.type!==this.type?this.type-v.type:Y(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){return this}evaluate(v){return typeof this.d=="string"?!1:parseFloat(v.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(v){return v.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Kj=ne;class te{static create(v,O,z=null){return B(O,T=>new te(v,T,z))}constructor(v,O,z){this.c=v,this.d=O,this.f=z,this.type=14}cmp(v){return v.type!==this.type?this.type-v.type:Y(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){return this}evaluate(v){return typeof this.d=="string"?!1:parseFloat(v.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(v){return v.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Lj=te;class le{static create(v,O,z=null){return B(O,T=>new le(v,T,z))}constructor(v,O,z){this.c=v,this.d=O,this.f=z,this.type=15}cmp(v){return v.type!==this.type?this.type-v.type:Y(this.c,this.d,v.c,v.d)}equals(v){return v.type===this.type?this.c===v.c&&this.d===v.d:!1}substituteConstants(){return this}evaluate(v){return typeof this.d=="string"?!1:parseFloat(v.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(v){return v.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Mj=le;class ce{static create(v,O){return new ce(v,O)}constructor(v,O){this.d=v,this.f=O,this.type=7,this.c=null}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.d<v.d)return-1;if(this.d>v.d)return 1;const O=this.f?this.f.source:"",z=v.f?v.f.source:"";return O<z?-1:O>z?1:0}equals(v){if(v.type===this.type){const O=this.f?this.f.source:"",z=v.f?v.f.source:"";return this.d===v.d&&O===z}return!1}substituteConstants(){return this}evaluate(v){const O=v.getValue(this.d);return this.f?this.f.test(O):!1}serialize(){const v=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${v}`}keys(){return[this.d]}map(v){return v.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$Nj=ce;class ae{static create(v){return new ae(v)}constructor(v){this.c=v,this.type=8}cmp(v){return v.type!==this.type?this.type-v.type:this.c.cmp(v.c)}equals(v){return v.type===this.type?this.c.equals(v.c):!1}substituteConstants(){return this}evaluate(v){return!this.c.evaluate(v)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(v){return new ae(this.c.map(v))}negate(){return this.c}}e.$Oj=ae;function W(C){let v=null;for(let O=0,z=C.length;O<z;O++){const T=C[O].substituteConstants();if(C[O]!==T&&v===null){v=[];for(let Z=0;Z<O;Z++)v[Z]=C[Z]}v!==null&&(v[O]=T)}return v===null?C:v}class K{static create(v,O,z){return K.d(v,O,z)}constructor(v,O){this.expr=v,this.c=O,this.type=6}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const T=i(this.expr[O],v.expr[O]);if(T!==0)return T}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(v.expr[O]))return!1;return!0}return!1}substituteConstants(){const v=W(this.expr);return v===this.expr?this:K.create(v,this.c,!1)}evaluate(v){for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].evaluate(v))return!1;return!0}static d(v,O,z){const T=[];let Z=!1;for(const X of v)if(X){if(X.type===1){Z=!0;continue}if(X.type===0)return s.INSTANCE;if(X.type===6){T.push(...X.expr);continue}T.push(X)}if(T.length===0&&Z)return o.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(i);for(let X=1;X<T.length;X++)T[X-1].equals(T[X])&&(T.splice(X,1),X--);if(T.length===1)return T[0];for(;T.length>1;){const X=T[T.length-1];if(X.type!==9)break;T.pop();const se=T.pop(),ue=T.length===0,he=x.create(X.expr.map(pe=>K.create([pe,se],null,z)),null,ue);he&&(T.push(he),T.sort(i))}if(T.length===1)return T[0];if(z){for(let X=0;X<T.length;X++)for(let se=X+1;se<T.length;se++)if(T[X].negate().equals(T[se]))return s.INSTANCE;if(T.length===1)return T[0]}return new K(T,O)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(const O of this.expr)v.push(...O.keys());return v}map(v){return new K(this.expr.map(O=>O.map(v)),null)}negate(){if(!this.c){const v=[];for(const O of this.expr)v.push(O.negate());this.c=x.create(v,this,!0)}return this.c}}e.$Pj=K;class x{static create(v,O,z){return x.d(v,O,z)}constructor(v,O){this.expr=v,this.c=O,this.type=9}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const T=i(this.expr[O],v.expr[O]);if(T!==0)return T}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(v.expr[O]))return!1;return!0}return!1}substituteConstants(){const v=W(this.expr);return v===this.expr?this:x.create(v,this.c,!1)}evaluate(v){for(let O=0,z=this.expr.length;O<z;O++)if(this.expr[O].evaluate(v))return!0;return!1}static d(v,O,z){let T=[],Z=!1;if(v){for(let X=0,se=v.length;X<se;X++){const ue=v[X];if(ue){if(ue.type===0){Z=!0;continue}if(ue.type===1)return o.INSTANCE;if(ue.type===9){T=T.concat(ue.expr);continue}T.push(ue)}}if(T.length===0&&Z)return s.INSTANCE;T.sort(i)}if(T.length!==0){if(T.length===1)return T[0];for(let X=1;X<T.length;X++)T[X-1].equals(T[X])&&(T.splice(X,1),X--);if(T.length===1)return T[0];if(z){for(let X=0;X<T.length;X++)for(let se=X+1;se<T.length;se++)if(T[X].negate().equals(T[se]))return o.INSTANCE;if(T.length===1)return T[0]}return new x(T,O)}}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(const O of this.expr)v.push(...O.keys());return v}map(v){return new x(this.expr.map(O=>O.map(v)),null)}negate(){if(!this.c){const v=[];for(const O of this.expr)v.push(O.negate());for(;v.length>1;){const O=v.shift(),z=v.shift(),T=[];for(const Z of V(O))for(const X of V(z))T.push(K.create([Z,X],null,!1));v.unshift(x.create(T,null,!1))}this.c=x.create(v,this,!0)}return this.c}}e.$Qj=x;class M extends u{static{this.d=[]}static all(){return M.d.values()}constructor(v,O,z){super(v,null),this.f=O,typeof z=="object"?M.d.push({...z,key:v}):z!==!0&&M.d.push({key:v,description:z,type:O!=null?typeof O:void 0})}bindTo(v){return v.createKey(this.key,this.f)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(v){return S.create(this.key,v)}notEqualsTo(v){return j.create(this.key,v)}}e.$Rj=M,e.$Sj=(0,L.$Ai)("contextKeyService");function G(C,v){return C<v?-1:C>v?1:0}function Y(C,v,O,z){return C<O?-1:C>O?1:v<z?-1:v>z?1:0}function U(C,v){if(C.type===0||v.type===1)return!0;if(C.type===9)return v.type===9?q(C.expr,v.expr):!1;if(v.type===9){for(const O of v.expr)if(U(C,O))return!0;return!1}if(C.type===6){if(v.type===6)return q(v.expr,C.expr);for(const O of C.expr)if(U(O,v))return!0;return!1}return C.equals(v)}function q(C,v){let O=0,z=0;for(;O<C.length&&z<v.length;){const T=C[O].cmp(v[z]);if(T<0)return!1;T===0&&O++,z++}return O===C.length}function V(C){return C.type===9?C.expr:[C]}}),define(re[62],oe([0,1,10]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=void 0,e.$Po=(0,N.$Ai)("downloadService")}),define(re[18],oe([0,1,10]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,N.$Ai)("environmentService"),e.$Ii=(0,N.$Bi)(e.$Hi)}),define(re[20],oe([0,1,98,10]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.ExtensionManagementErrorCode=e.$ap=e.ExtensionGalleryErrorCode=e.$_o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0,e.$6o=L,e.$7o=D,e.$8o=E,e.$9o=l,e.$0o=a,e.$$o=h,e.$Yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Zo=new RegExp(e.$Yo),e.$1o="__web_extension",e.$2o="skipWalkthrough",e.$3o="extensionInstallSource",e.$4o="dependecyOrPackExtensionInstall",e.$5o="clientTargetPlatform";var P;(function(m){m.COMMAND="command",m.SETTINGS_SYNC="settingsSync"})(P||(e.ExtensionInstallSource=P={}));function L(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function D(m){switch(m){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function E(m,g){switch(m){case 3:return g==="x64"?"win32-x64":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function l(m,g){return g==="web"&&!m.includes("web")}function a(m,g,f){return l(g,f)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===f}function h(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}var b;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var y;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var w;(function(m){m.Install="install",m.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var p;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$_o=(0,A.$Ai)("extensionGalleryService");var R;(function(m){m.Timeout="Timeout",m.Cancelled="Cancelled",m.Failed="Failed",m.DownloadFailedWriting="DownloadFailedWriting"})(R||(e.ExtensionGalleryErrorCode=R={}));class d extends Error{constructor(g,f){super(g),this.code=f,this.name=f}}e.$ap=d;var c;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.DownloadSignature="DownloadSignature",m.DownloadFailedWriting="DownloadFailedWriting",m.UpdateMetadata="UpdateMetadata",m.Extract="Extract",m.Scanning="Scanning",m.ScanningExtension="ScanningExtension",m.ReadUninstalled="ReadUninstalled",m.UnsetUninstalled="UnsetUninstalled",m.Delete="Delete",m.Rename="Rename",m.IntializeDefaultProfile="IntializeDefaultProfile",m.AddToProfile="AddToProfile",m.InstalledExtensionNotFound="InstalledExtensionNotFound",m.PostInstall="PostInstall",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Signature="Signature",m.NotAllowed="NotAllowed",m.Gallery="Gallery",m.Cancelled="Cancelled",m.Unknown="Unknown",m.Internal="Internal"})(c||(e.ExtensionManagementErrorCode=c={}));class $ extends Error{constructor(g,f){super(g),this.code=f,this.name=f}}e.$bp=$,e.$cp=(0,A.$Ai)("extensionManagementService"),e.$dp="extensionsIdentifiers/disabled",e.$ep="extensionsIdentifiers/enabled",e.$fp=(0,A.$Ai)("IGlobalExtensionEnablementService"),e.$gp=(0,A.$Ai)("IExtensionTipsService"),e.$hp=(0,N.localize2)(0,"Extensions"),e.$ip=(0,N.localize2)(1,"Preferences")}),define(re[63],oe([0,1,14,9,106,13]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=D;async function D(h,b,y,w,p,R){let d;try{await E(h,b,y,w,p,R)}catch(c){d=c}finally{d&&p.errorTransformer&&(d=p.errorTransformer(d)),typeof d<"u"&&y.error(d),y.end()}}async function E(h,b,y,w,p,R){l(R);const d=await h.open(b,{create:!1});try{l(R);let c=0,$=0,m=p&&typeof p.length=="number"?p.length:void 0,g=N.$Je.alloc(Math.min(p.bufferSize,typeof m=="number"?m:p.bufferSize)),f=p&&typeof p.position=="number"?p.position:0,n=0;do $=await h.read(d,f,g.buffer,n,g.byteLength-n),f+=$,n+=$,c+=$,typeof m=="number"&&(m-=$),n===g.byteLength&&(await y.write(w(g)),g=N.$Je.alloc(Math.min(p.bufferSize,typeof m=="number"?m:p.bufferSize)),n=0);while($>0&&(typeof m!="number"||m>0)&&l(R)&&a(c,p));if(n>0){let r=n;typeof m=="number"&&(r=Math.min(n,m)),y.write(w(g.slice(0,r)))}}catch(c){throw(0,L.$il)(c)}finally{await h.close(d)}}function l(h){if(h.isCancellationRequested)throw(0,A.$6)();return!0}function a(h,b){if(typeof b?.limits?.size=="number"&&h>b.limits.size)throw(0,L.$hl)((0,P.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[124],oe([0,1,61,2,52,5,11,8]),function(Q,e,N,A,P,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class l extends A.$Uc{constructor(){super(),this.a=this.B(new L.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new L.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new A.$4c),this.m=new Set,this.n=5007,this.r=new E.$Xh,this.P=!1,this.B(this.f(h=>this.s(h)))}s(h){this.t(h)&&this.w(h)}t(h){return(0,P.$Pq)(h)}async watch(h){this.r.isSettled||this.r.complete(),this.r=new E.$Xh;try{this.h.clear(),this.g.clear();for(const b of h)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))])}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async w(h){if(this.j.has(h.correlationId))return;const b=new A.$Tc;this.j.set(h.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(h,b),this.u())}y(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.u()}z(h,b){this.C(h,b)?(this.N(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.D(h,b),this.m.add(h.correlationId))}C(h,b){const y=this.M?.subscribe(h.path,(w,p)=>{b.isDisposed||(w?this.z(h,b):p?.type===1&&this.F(h))});return y?(b.add(y),!0):!1}D(h,b){let y=!1;const w=(p,R)=>{if(b.isDisposed)return;const d=this.G(p),c=this.G(R),$=y;y=d,!d&&(c||$)&&this.F(h)};this.N(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,N.watchFile)(h.path,{persistent:!1,interval:this.n},w)}catch(p){this.O(`fs.watchFile() failed with error ${p} on path ${h.path} (correlationId: ${h.correlationId})`)}b.add((0,A.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,N.unwatchFile)(h.path,w)}catch(p){this.O(`fs.unwatchFile() failed with error ${p} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}F(h){this.N(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const b={resource:D.URI.file(h.path),type:1,cId:h.correlationId};this.a.fire([b]),this.H(b,h),this.y(h)}G(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(h,b){if(this.P){const y=` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.I(y,b)}}I(h,b){this.P&&this.N(`${h}${typeof b.correlationId=="number"?` <${b.correlationId}> `:""}`)}J(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,P.$Zq)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.P=h}}e.$9q=l}),define(re[125],oe([0,1,5,171,124,12,172,64]),function(Q,e,N,A,P,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class l extends P.$9q{constructor(h){super(),this.M=h,this.onDidError=N.Event.None,this.watchers=new Set}async L(h){h=this.X(h);const b=[],y=new Set(Array.from(this.watchers));for(const w of h){const p=this.S(w);p&&(0,A.$yk)(p.request.excludes,w.excludes)&&(0,A.$yk)(p.request.includes,w.includes)?y.delete(p):b.push(w)}b.length&&this.N(`Request to start watching: ${b.map(w=>this.J(w)).join(",")}`),y.size&&this.N(`Request to stop watching: ${Array.from(y).map(w=>this.J(w.request)).join(",")}`);for(const w of y)this.W(w);for(const w of b)this.U(w)}S(h){for(const b of this.watchers)if(typeof h.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===h.correlationId)return b}else if((0,E.$yg)(b.request.path,h.path,!L.$k))return b}U(h){const b=new D.$br(h,this.M,w=>this.a.fire(w),()=>this.c.fire(h),w=>this.b.fire(w),this.P),y={request:h,instance:b};this.watchers.add(y)}async stop(){await super.stop();for(const h of this.watchers)this.W(h)}W(h){this.N("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}X(h){const b=new Map;for(const y of h){const w=L.$k?y.path:y.path.toLowerCase();let p=b.get(y.correlationId);p||(p=new Map,b.set(y.correlationId,p)),p.has(w)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(y)}`),p.set(w,y)}return Array.from(b.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const b of this.watchers)b.instance.setVerboseLogging(h)}N(h,b){this.P&&this.b.fire({type:"trace",message:this.$(h,b)})}O(h){this.b.fire({type:"warn",message:this.$(h)})}$(h,b){return b?`[File Watcher (node.js)] ${h} (${this.J(b.request)})`:`[File Watcher (node.js)] ${h}`}}e.$dr=l}),define(re[126],oe([0,1,52,125]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;class P extends N.$Sq{constructor(D,E,l){super(D,E,l),this.u()}t(D){return D.add(new A.$dr(void 0))}}e.$er=P}),define(re[127],oe([0,1,15,59,91,52]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class D extends L.$Tq{constructor(l,a,h){super(l,a,h),this.u()}t(l){const a=l.add(new P.$7q(N.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(a.onDidProcessExit(({code:h,signal:b})=>this.w(`terminated by itself with code ${h}, signal: ${b} (ETERM)`))),A.ProxyChannel.toService((0,A.$hi)(a.getChannel("watcher")))}}e.$8q=D}),define(re[65],oe([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class N{constructor(...P){this.a=new Map;for(const[L,D]of P)this.set(L,D)}set(P,L){const D=this.a.get(P);return this.a.set(P,L),D}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$yi=N}),define(re[128],oe([0,1,8,9,2,51,122,10,65,173]),function(Q,e,N,A,P,L,D,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;const h=!1;class b extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class y{constructor(d=new l.$yi,c=!1,$,m=h){this.i=d,this.j=c,this.k=$,this.l=m,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(E.$zi,this),this._globalGraph=m?$?._globalGraph??new D.$hr(g=>g):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Pc)(this.h),this.h.clear();for(const d of this.g)(0,P.$Oc)(d)&&d.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(d,c){this.m();const $=new class extends y{dispose(){this.h.delete($),super.dispose()}}(d,this.j,this,this.l);return this.h.add($),c?.add($),$}invokeFunction(d,...c){this.m();const $=p.traceInvocation(this.l,d);let m=!1;try{return d({get:f=>{if(m)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const n=this.s(f,$);if(!n)throw new Error(`[invokeFunction] unknown service '${f}'`);return n}},...c)}finally{m=!0,$.stop()}}createInstance(d,...c){this.m();let $,m;return d instanceof L.$xi?($=p.traceCreation(this.l,d.ctor),m=this.o(d.ctor,d.staticArguments.concat(c),$)):($=p.traceCreation(this.l,d),m=this.o(d,c,$)),$.stop(),m}o(d,c=[],$){const m=E._util.getServiceDependencies(d).sort((n,r)=>n.index-r.index),g=[];for(const n of m){const r=this.s(n.id,$);r||this.y(`[createInstance] ${d.name} depends on UNKNOWN service ${n.id}.`,!1),g.push(r)}const f=m.length>0?m[0].index:c.length;if(c.length!==f){console.trace(`[createInstance] First service dependency of ${d.name} at position ${f+1} conflicts with ${c.length} static arguments`);const n=f-c.length;n>0?c=c.concat(new Array(n)):c=c.slice(0,f)}return Reflect.construct(d,c.concat(g))}q(d,c){if(this.i.get(d)instanceof L.$xi)this.i.set(d,c);else if(this.k)this.k.q(d,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(d){const c=this.i.get(d);return!c&&this.k?this.k.r(d):c}s(d,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const $=this.r(d);return $ instanceof L.$xi?this.u(d,$,c.branch(d,!0)):(c.branch(d,!1),$)}u(d,c,$){if(this.t.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.t.add(d);try{return this.v(d,c,$)}finally{this.t.delete(d)}}v(d,c,$){const m=new D.$hr(n=>n.id.toString());let g=0;const f=[{id:d,desc:c,_trace:$}];for(;f.length;){const n=f.pop();if(m.lookupOrInsertNode(n),g++>1e3)throw new b(m);for(const r of E._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${d} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof L.$xi){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};m.insertEdge(n,i),f.push(i)}}}for(;;){const n=m.roots();if(n.length===0){if(!m.isEmpty())throw new b(m);break}for(const{data:r}of n){if(this.r(r.id)instanceof L.$xi){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}m.removeNode(r)}}return this.r(d)}w(d,c,$=[],m,g){if(this.i.get(d)instanceof L.$xi)return this.x(d,c,$,m,g,this.g);if(this.k)return this.k.w(d,c,$,m,g);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(d,c,$=[],m,g,f){if(m){const n=new y(void 0,this.j,this,this.l);n.c=String(d);const r=new Map,t=new N.$Th(()=>{const i=n.o(c,$,g);for(const[s,o]of r){const u=i[s];if(typeof u=="function")for(const S of o)S.disposable=u.apply(i,S.listener)}return r.clear(),f.add(i),i});return new Proxy(Object.create(null),{get(i,s){if(!t.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let S=r.get(s);return S||(S=new a.$5c,r.set(s,S)),(I,j,F)=>{if(t.isInitialized)return t.value[s](I,j,F);{const B={listener:[I,j,F],disposable:void 0},J=S.push(B);return(0,P.$Sc)(()=>{J(),B.disposable?.dispose()})}}}if(s in i)return i[s];const o=t.value;let u=o[s];return typeof u!="function"||(u=u.bind(o),i[s]=u),u},set(i,s,o){return t.value[s]=o,!0},getPrototypeOf(i){return c.prototype}})}else{const n=this.o(c,$,g);return f.add(n),n}}y(d,c){if(c&&console.warn(d),this.j)throw new Error(d)}}e.$ir=y;var w;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(w||(w={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,c){return d?new p(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(d,c){return d?new p(1,c.name):p.c}static{this.f=0}constructor(d,c){this.type=d,this.name=c,this.g=Date.now(),this.h=[]}branch(d,c){const $=new p(3,d.toString());return this.h.push([d,c,$]),$}stop(){const d=Date.now()-this.g;p.f+=d;let c=!1;function $(g,f){const n=[],r=new Array(g+1).join("	");for(const[t,i,s]of f.h)if(i&&s){c=!0,n.push(`${r}CREATES -> ${t}`);const o=$(g+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(d>2||c)&&p.all.add(m.join(`
`))}}e.$jr=p});var ie=this&&this.__param||function(Q,e){return function(N,A){e(N,A,Q)}};define(re[66],oe([0,1,22,2,12,108,20,10]),function(Q,e,N,A,P,L,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=void 0,e.$Wr=l;function l(h){return h.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.$Xr=(0,E.$Ai)("languagePackService");let a=class extends A.$Uc{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new N.$se;setTimeout(()=>b.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const p=y.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(d=>d.startsWith("lp-"))).map(R=>{const d=R.properties.localizedLanguages?.[0],c=l(R);return{...this.f(c,d,R),extensionId:R.identifier.id,galleryExtension:R}});return p.push(this.f("en","English")),p}f(b,y,w){const p=y??b;let R;if(p!==b&&(R=`(${b})`),b.toLowerCase()===P.$w.toLowerCase()&&(R??="",R+=(0,L.localize)(0,null)),w?.installCount){R??="";const d=w.installCount;let c;d>1e6?c=`${Math.floor(d/1e5)/10}M`:d>1e3?c=`${Math.floor(d/1e3)}K`:c=String(d),R+=` $(cloud-download) ${c}`}return{id:b,label:p,description:R}}};e.$Yr=a,e.$Yr=a=$e([ie(0,D.$_o)],a)}),define(re[6],oe([0,1,109,34,5,43,2,30,12,17,3,11,123,10]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=R,e.log=c,e.$ik=u,e.$jk=S,e.$kk=k,e.$lk=I,e.$7j=(0,w.$Ai)("logService"),e.$8j=(0,w.$Ai)("loggerService");function p(){return new Date().toISOString()}function R(j){return(0,h.$eg)(j)}var d;(function(j){j[j.Off=0]="Off",j[j.Trace=1]="Trace",j[j.Debug=2]="Debug",j[j.Info=3]="Info",j[j.Warning=4]="Warning",j[j.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$0j=d.Info;function c(j,F,B){switch(F){case d.Trace:j.trace(B);break;case d.Debug:j.debug(B);break;case d.Info:j.info(B);break;case d.Warning:j.warn(B);break;case d.Error:j.error(B);break;case d.Off:break;default:throw new Error(`Invalid log level ${F}`)}}function $(j,F=!1){let B="";for(let J=0;J<j.length;J++){let ne=j[J];if(ne instanceof Error&&(ne=(0,A.$lj)(ne,F)),typeof ne=="object")try{ne=JSON.stringify(ne)}catch{}B+=(J>0?" ":"")+ne}return B}class m extends D.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new P.$he),this.onDidChangeLogLevel=this.c.event}setLevel(F){this.b!==F&&(this.b=F,this.c.fire(this.b))}getLevel(){return this.b}f(F){return this.b!==d.Off&&this.b<=F}}e.$_j=m;class g extends m{constructor(F){super(),this.h=F}f(F){return this.h||super.f(F)}trace(F,...B){this.f(d.Trace)&&this.g(d.Trace,$([F,...B],!0))}debug(F,...B){this.f(d.Debug)&&this.g(d.Debug,$([F,...B]))}info(F,...B){this.f(d.Info)&&this.g(d.Info,$([F,...B]))}warn(F,...B){this.f(d.Warning)&&this.g(d.Warning,$([F,...B]))}error(F,...B){if(this.f(d.Error))if(F instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=F.stack,this.g(d.Error,$(J))}else this.g(d.Error,$([F,...B]))}flush(){}}e.$ak=g;class f extends m{constructor(F=e.$0j){super(),this.setLevel(F),this.g=!l.$i}trace(F,...B){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,F,...B):console.log(`[main ${p()}]`,F,...B))}debug(F,...B){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,F,...B):console.log(`[main ${p()}]`,F,...B))}info(F,...B){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,F,...B):console.log(`[main ${p()}]`,F,...B))}warn(F,...B){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,F,...B):console.warn(`[main ${p()}]`,F,...B))}error(F,...B){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,F,...B):console.error(`[main ${p()}]`,F,...B))}flush(){}}e.$bk=f;class n extends m{constructor(F=e.$0j,B=!0){super(),this.g=B,this.setLevel(F)}trace(F,...B){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",F,...B):console.log(F,...B))}debug(F,...B){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",F,...B):console.log(F,...B))}info(F,...B){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",F,...B):console.log(F,...B))}warn(F,...B){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",F,...B):console.log(F,...B))}error(F,...B){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",F,...B):console.error(F,...B))}flush(){}}e.$ck=n;class r extends m{constructor(F,B=e.$0j){super(),this.g=F,this.setLevel(B)}trace(F,...B){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(F),...B])}debug(F,...B){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(F),...B])}info(F,...B){this.f(d.Info)&&this.g.log(d.Info,[this.h(F),...B])}warn(F,...B){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(F),...B])}error(F,...B){this.f(d.Error)&&this.g.log(d.Error,[this.h(F),...B])}h(F){return typeof F=="string"?F:(0,A.$lj)(F,this.f(d.Trace))}flush(){}}e.$dk=r;class t extends m{constructor(F){super(),this.g=F,F.length&&this.setLevel(F[0].getLevel())}setLevel(F){for(const B of this.g)B.setLevel(F);super.setLevel(F)}trace(F,...B){for(const J of this.g)J.trace(F,...B)}debug(F,...B){for(const J of this.g)J.debug(F,...B)}info(F,...B){for(const J of this.g)J.info(F,...B)}warn(F,...B){for(const J of this.g)J.warn(F,...B)}error(F,...B){for(const J of this.g)J.error(F,...B)}flush(){for(const F of this.g)F.flush()}dispose(){for(const F of this.g)F.dispose();super.dispose()}}e.$ek=t;class i extends D.$Uc{constructor(F,B,J){if(super(),this.h=F,this.j=B,this.b=new E.$Ac,this.c=this.B(new P.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$he),this.onDidChangeVisibility=this.g.event,J)for(const ne of J)this.b.set(ne.resource,{logger:void 0,info:ne})}m(F){return(0,h.$ag)(F)?[...this.b.values()].find(B=>B.info.id===F):this.b.get(F)}getLogger(F){return this.m(F)?.logger}createLogger(F,B){const J=this.n(F),ne=(0,h.$ag)(F)?F:B?.id??(0,L.$oj)(J.toString()).toString(16);let te=this.b.get(J)?.logger;const le=B?.logLevel==="always"?d.Trace:B?.logLevel;te||(te=this.s(J,le??this.getLogLevel(J)??this.h,{...B,id:ne}));const ce={logger:te,info:{resource:J,id:ne,logLevel:le,name:B?.name,hidden:B?.hidden,extensionId:B?.extensionId,when:B?.when}};return this.registerLogger(ce.info),this.b.set(J,ce),te}n(F){return(0,h.$ag)(F)?(0,a.$bh)(this.j,`${F}.log`):F}setLogLevel(F,B){if(b.URI.isUri(F)){const J=F,ne=B,te=this.b.get(J);te&&ne!==te.info.logLevel&&(te.info.logLevel=ne===this.h?void 0:ne,te.logger?.setLevel(ne),this.b.set(te.info.resource,te),this.f.fire([J,ne]))}else{this.h=F;for(const[J,ne]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&ne.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(F,B){const J=this.m(F);J&&B!==!J.info.hidden&&(J.info.hidden=!B,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,B]))}getLogLevel(F){let B;return F&&(B=this.b.get(F)?.info.logLevel),B??this.h}registerLogger(F){const B=this.b.get(F.resource);B?B.info.hidden!==F.hidden&&this.setVisibility(F.resource,!F.hidden):(this.b.set(F.resource,{info:F,logger:void 0}),this.c.fire({added:[F],removed:[]}))}deregisterLogger(F){const B=this.b.get(F);B&&(B.logger&&B.logger.dispose(),this.b.delete(F),this.c.fire({added:[],removed:[B.info]}))}*getRegisteredLoggers(){for(const F of this.b.values())yield F.info}getRegisteredLogger(F){return this.b.get(F)?.info}dispose(){this.b.forEach(F=>F.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=i;class s{constructor(){this.onDidChangeLogLevel=new P.$he().event}setLevel(F){}getLevel(){return d.Info}trace(F,...B){}debug(F,...B){}info(F,...B){}warn(F,...B){}error(F,...B){}critical(F,...B){}dispose(){}flush(){}}e.$gk=s;class o extends s{}e.$hk=o;function u(j){if(j.verbose)return d.Trace;if(typeof j.logLevel=="string"){const F=I(j.logLevel.toLowerCase());if(F!==void 0)return F}return e.$0j}function S(j){switch(j){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function k(j){switch(j){case d.Trace:return{original:"Trace",value:N.localize(0,null)};case d.Debug:return{original:"Debug",value:N.localize(1,null)};case d.Info:return{original:"Info",value:N.localize(2,null)};case d.Warning:return{original:"Warning",value:N.localize(3,null)};case d.Error:return{original:"Error",value:N.localize(4,null)};case d.Off:return{original:"Off",value:N.localize(5,null)}}}function I(j){switch(j){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$mk=new y.$Rj("logLevel",S(d.Info))}),define(re[129],oe([0,1,19,8,9,5,64,2,16,52,6]),function(Q,e,N,A,P,L,D,E,l,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;class b extends E.$Uc{constructor(w,p){super(),this.a=w,this.b=p,this.c=this.B(new L.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$yh(0)),this.w=[],this.y=this.B(new A.$yh(0))}watch(w,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(w,p):this.z(w,p)}n(w,p){const R={path:this.J(w),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},d=(0,N.$Tb)(this.j,R);return this.r(),(0,E.$Sc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,P.$1)(w))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,a.$Uq)(p)),p=>this.G(p),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const p of this.j)(0,a.$Qq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const p of this.j)(0,a.$Qq)(p)&&w.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,p){const R={path:this.J(w),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},d=(0,N.$Tb)(this.w,R);return this.C(),(0,E.$Sc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,P.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,a.$Uq)(w)),w=>this.G(w),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,l.$hc)(w.fsPath)}J(w){const p=this.I(w);return(0,D.$Cg)(p)}}e.$1q=b}),define(re[130],oe([0,1,19,8,14,22,5,43,67,2,48,15,131,17,46,105,13,63,6,9]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c,$,m){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let f=class extends a.$Uc{static{g=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new D.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$he),this.Y=this.B(new D.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$Jh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${r}`);const i=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),i.add(t.onDidChangeFile(s=>{const o=new d.$nl(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(i){t.push(i)}}),!this.h.has(r)&&await A.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return l.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,w.$fh)(r))throw new d.$pl((0,R.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const i=new m.$bb;throw i.message=(0,R.localize)(1,null,r.toString()),i}return t}async m(r){const t=await this.j(r);if((0,d.$al)(t)||(0,d.$0k)(t)||(0,d.$bl)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,d.$al)(t)||(0,d.$0k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(i){throw(0,d.$kl)(i)===d.FileSystemProviderErrorCode.FileNotFound?new d.$pl((0,R.localize)(2,null,this.sb(r)),1):(0,d.$il)(i)}}async s(r,t){const i=await this.j(r),s=this.S(i),o=t?.resolveTo,u=t?.resolveSingleChildDescendants,S=t?.resolveMetadata,k=await i.stat(r);let I;return this.t(i,r,k,void 0,!!S,(j,F)=>(I||(I=h.$Gi.forUris(()=>!s),I.set(r,!0),o&&I.fill(!0,o)),I.get(j.resource)||I.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&u?F===1:!1))}async t(r,t,i,s,o,u){const{providerExtUri:S}=this.R(r),k={resource:t,name:S.basename(t),isFile:(i.type&d.FileType.File)!==0,isDirectory:(i.type&d.FileType.Directory)!==0,isSymbolicLink:(i.type&d.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&d.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&d.FilePermission.Locked),etag:(0,d.$Al)({mtime:i.mtime,size:i.size}),children:void 0};if(k.isDirectory&&u(k,s)){try{const I=await r.readdir(t),j=await A.Promises.settled(I.map(async([F,B])=>{try{const J=S.joinPath(t,F),ne=o?await r.stat(J):{type:B};return await this.t(r,J,ne,I.length,o,u)}catch(J){return this.b.trace(J),null}}));k.children=(0,N.$Hb)(j)}catch(I){this.b.trace(I),k.children=[]}return k}return k}async resolveAll(r){return A.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),i=await t.stat(r);return this.t(t,r,i,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(i){return i}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new d.$pl((0,R.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=P.$Je.fromString(""),i){await this.u(r,i);const s=await this.writeFile(r,t);return this.r.fire(new d.$ml(r,0,s)),s}async writeFile(r,t,i){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let u=i;if((0,d.$dl)(s)&&!u?.atomic){const S=s.enforceAtomicWriteFile?.(r);S&&(u={...i,atomic:S})}try{await this.w(s,r,u)||await this.U(s,o.dirname(r));let k;if((0,d.$0k)(s)&&!(t instanceof P.$Je))if((0,p.$ve)(t)){const I=await(0,p.$Ce)(t,3);I.ended?k=P.$Je.concat(I.buffer):k=I}else k=(0,p.$ze)(t,I=>P.$Je.concat(I),3);else k=t;!(0,d.$al)(s)||(0,d.$0k)(s)&&k instanceof P.$Je||(0,d.$0k)(s)&&(0,d.$dl)(s)&&u?.atomic?await this.hb(s,r,u,k):await this.db(s,r,u,k instanceof P.$Je?(0,P.$Ue)(k):k),this.r.fire(new d.$ml(r,4))}catch(S){throw new d.$pl((0,R.localize)(4,null,this.sb(r),(0,d.$il)(S).toString()),(0,d.$ll)(S),u)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,i){const s=!!i?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,R.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,R.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,R.localize)(7,null,this.sb(t)));if(s)throw new Error((0,R.localize)(8,null,this.sb(t)))}let u;try{u=await r.stat(t)}catch{return}if(u.type&d.FileType.Directory)throw new d.$pl((0,R.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,u),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==d.$zl&&typeof u.mtime=="number"&&typeof u.size=="number"&&i.mtime<u.mtime&&i.etag!==(0,d.$Al)({mtime:i.mtime,size:u.size}))throw new d.$pl((0,R.localize)(10,null),3,i);return u}async readFile(r,t,i){const s=await this.m(r);return t?.atomic?this.z(s,r,t,i):this.C(s,r,t,i)}async z(r,t,i,s){return new Promise((o,u)=>{this.cb.queueFor(t,async()=>{try{const S=await this.C(r,t,i,s);o(S)}catch(S){u(S)}},this.R(r).providerExtUri)})}async C(r,t,i,s){const o=await this.D(r,t,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,P.$Ve)(o.value)}}async readFileStream(r,t,i){const s=await this.m(r);return this.D(s,r,t,i)}async D(r,t,i,s){const o=new L.$se(s);let u=i;(0,d.$cl)(r)&&r.enforceAtomicReadFile?.(t)&&(u={...i,atomic:!0});const S=this.J(t,u).then(I=>I,I=>{throw o.dispose(!0),I});let k;try{return typeof u?.etag=="string"&&u.etag!==d.$zl&&await S,u?.atomic&&(0,d.$cl)(r)||!((0,d.$al)(r)||(0,d.$bl)(r))||(0,d.$0k)(r)&&u?.preferUnbuffered?k=this.I(r,t,u):(0,d.$bl)(r)?k=this.G(r,t,o.token,u):k=this.H(r,t,o.token,u),k.on("end",()=>o.dispose()),k.on("error",()=>o.dispose()),{...await S,value:k}}catch(I){throw k&&await(0,p.$Ae)(k),this.F(I,t,u)}}F(r,t,i){const s=(0,R.localize)(11,null,this.sb(t),(0,d.$il)(r).toString());return r instanceof d.$rl?new d.$rl(s,r.stat,i):r instanceof d.$ql?new d.$ql(s,r.fileOperationResult,r.size,r.options):new d.$pl(s,(0,d.$ll)(r),i)}G(r,t,i,s=Object.create(null)){const o=r.readFileStream(t,s,i);return(0,p.$Ge)(o,{data:u=>u instanceof P.$Je?u:P.$Je.wrap(u),error:u=>this.F(u,t,s)},u=>P.$Je.concat(u))}H(r,t,i,s=Object.create(null)){const o=(0,P.$Ze)();return(0,c.$Nq)(r,t,o,u=>u,{...s,bufferSize:this.a,errorTransformer:u=>this.F(u,t,s)},i),o}I(r,t,i){const s=(0,p.$xe)(o=>P.$Je.concat(o));return(async()=>{try{let o;i?.atomic&&(0,d.$cl)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(t,o.byteLength,i),s.end(P.$Je.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new d.$pl((0,R.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==d.$zl&&t.etag===i.etag)throw new d.$rl((0,R.localize)(13,null),i,t);return this.L(r,i.size,t),i}L(r,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new d.$ql((0,R.localize)(14,null,this.sb(r)),7,t,i)}async canMove(r,t,i){return this.M(r,t,"move",i)}async canCopy(r,t,i){return this.M(r,t,"copy",i)}async M(r,t,i,s){if(r.toString()!==t.toString())try{const o=i==="move"?this.qb(await this.n(r),r):await this.m(r),u=this.qb(await this.n(t),t);await this.Q(o,r,u,t,i,s)}catch(o){return o}return!0}async move(r,t,i){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),u=await this.N(s,r,o,t,"move",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$ml(r,u==="move"?2:3,S)),S}async copy(r,t,i){const s=await this.m(r),o=this.qb(await this.n(t),t),u=await this.N(s,r,o,t,"copy",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$ml(r,u==="copy"?3:2,S)),S}async N(r,t,i,s,o,u){if(t.toString()===s.toString())return o;const{exists:S,isSameResourceWithDifferentPathCase:k}=await this.Q(r,t,i,s,o,u);if(S&&!k&&u&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),o==="copy"){if(r===i&&(0,d.$$k)(r))await r.copy(t,s,{overwrite:u});else{const I=await this.resolve(t);I.isDirectory?await this.P(r,I,i,s):await this.O(r,t,i,s)}return o}else return r===i?(await r.rename(t,s,{overwrite:u}),o):(await this.N(r,t,i,s,"copy",u),await this.del(t,{recursive:!0}),"copy")}async O(r,t,i,s){if((0,d.$al)(r)&&(0,d.$al)(i))return this.jb(r,t,i,s);if((0,d.$al)(r)&&(0,d.$0k)(i))return this.pb(r,t,i,s);if((0,d.$0k)(r)&&(0,d.$al)(i))return this.nb(r,t,i,s);if((0,d.$0k)(r)&&(0,d.$0k)(i))return this.lb(r,t,i,s)}async P(r,t,i,s){await i.mkdir(s),Array.isArray(t.children)&&await A.Promises.settled(t.children.map(async o=>{const u=this.R(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),i,u):this.O(r,o.resource,i,u)}))}async Q(r,t,i,s,o,u){let S=!1;if(r===i){const{providerExtUri:I,isPathCaseSensitive:j}=this.R(r);if(j||(S=I.isEqual(t,s)),S&&o==="copy")throw new Error((0,R.localize)(15,null,this.sb(t),this.sb(s)));if(!S&&I.isEqualOrParent(s,t))throw new Error((0,R.localize)(16,null,this.sb(t),this.sb(s)))}const k=await this.exists(s);if(k&&!S){if(!u)throw new d.$pl((0,R.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===i){const{providerExtUri:I}=this.R(r);if(I.isEqualOrParent(t,s))throw new Error((0,R.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:k,isSameResourceWithDifferentPathCase:S}}R(r){const t=this.S(r);return{providerExtUri:t?w.$4g:w.$6g,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new d.$ml(r,0,i)),i}async U(r,t){const i=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&d.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(t)));break}catch(o){if((0,d.$kl)(o)!==d.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(t)),t=s.dirname(t)}for(let o=i.length-1;o>=0;o--){t=s.joinPath(t,i[o]);try{await r.mkdir(t)}catch(u){if((0,d.$kl)(u)!==d.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(r,t){try{await this.W(r,t)}catch(i){return i}return!0}async W(r,t){const i=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,R.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(i.capabilities&65536))throw new Error((0,R.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,R.localize)(22,null,this.sb(r)));let u;try{u=await i.stat(r)}catch{}if(u)this.rb(r,u);else throw new d.$pl((0,R.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const k=await this.resolve(r);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(r)))}return i}async del(r,t){const i=await this.W(r,t);let s=t;if((0,d.$el)(i)&&!s?.atomic){const k=i.enforceAtomicDelete?.(r);k&&(s={...t,atomic:k})}const o=!!s?.useTrash,u=!!s?.recursive,S=s?.atomic??!1;await i.delete(r,{recursive:u,useTrash:o,atomic:S}),this.r.fire(new d.$ml(r,1))}async cloneFile(r,t){const i=await this.j(r),s=this.qb(await this.n(t),t);if(!(i===s&&this.R(i).providerExtUri.isEqual(r,t)))return i===s&&(0,d.$_k)(i)?i.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),i===s&&(0,d.$$k)(i)?this.cb.queueFor(r,()=>i.copy(r,t,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,s,t),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:g.ab++})}watch(r,t={recursive:!1,excludes:[]}){const i=new a.$Tc;let s=!1,o=()=>{s=!0};i.add((0,a.$Sc)(()=>o())),(async()=>{try{const S=await this.bb(r,t);s?(0,a.$Pc)(S):o=()=>(0,a.$Pc)(S)}catch(S){this.b.error(S)}})();const u=t.correlationId;if(typeof u=="number"){const S=i.add(new D.$he);return i.add(this.X.event(I=>{I.correlates(u)&&S.fire(I)})),{onDidChange:S.event,dispose:()=>i.dispose()}}return i}async bb(r,t){const i=await this.j(r),s=(0,E.$oj)([this.R(i).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:i.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,i,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,p.$ve)(s)||(0,p.$we)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(u){throw(0,d.$il)(u)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,i){let s=0,o;if((0,p.$we)(i)){if(i.buffer.length>0){const u=P.$Je.concat(i.buffer);await this.gb(r,t,u,u.byteLength,s,0),s+=u.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((u,S)=>{(0,p.$Be)(o,{onData:async k=>{o.pause();try{await this.gb(r,t,k,k.byteLength,s,0)}catch(I){return S(I)}s+=k.byteLength,setTimeout(()=>o.resume())},onError:k=>S(k),onEnd:()=>u()})})}async fb(r,t,i){let s=0,o;for(;(o=i.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,i,s,o,u){let S=0;for(;S<s;){const k=await r.write(t,o+S,i.buffer,u+S,s-S);S+=k}}async hb(r,t,i,s){return this.cb.queueFor(t,()=>this.ib(r,t,i,s),this.R(r).providerExtUri)}async ib(r,t,i,s){let o;s instanceof P.$Je?o=s:(0,p.$ve)(s)?o=await(0,P.$Ve)(s):(0,p.$we)(s)?o=await(0,P.$We)(s):o=(0,P.$Te)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,t,i,s){return this.cb.queueFor(s,()=>this.kb(r,t,i,s),this.R(i).providerExtUri)}async kb(r,t,i,s){let o,u;try{o=await r.open(t,{create:!1}),u=await i.open(s,{create:!0,unlock:!1});const S=P.$Je.alloc(this.a);let k=0,I=0,j=0;do j=await r.read(o,k,S.buffer,I,S.byteLength-I),await this.gb(i,u,S,j,k,I),k+=j,I+=j,I===S.byteLength&&(I=0);while(j>0)}catch(S){throw(0,d.$il)(S)}finally{await A.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async lb(r,t,i,s){return this.cb.queueFor(s,()=>this.mb(r,t,i,s),this.R(i).providerExtUri)}async mb(r,t,i,s){return i.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,i,s){return this.cb.queueFor(s,()=>this.ob(r,t,i,s),this.R(i).providerExtUri)}async ob(r,t,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const u=await r.readFile(t);await this.gb(i,o,P.$Je.wrap(u),u.byteLength,0,0)}catch(u){throw(0,d.$il)(u)}finally{await i.close(o)}}async pb(r,t,i,s){const o=await(0,P.$Ve)(this.H(r,t,L.CancellationToken.None));await this.hb(i,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new d.$pl((0,R.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&d.FilePermission.Readonly)throw new d.$pl((0,R.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===b.Schemas.file?r.fsPath:r.toString(!0)}};e.$Oq=f,e.$Oq=f=g=$e([ie(0,$.$7j)],f)}),define(re[132],oe([0,1,61,174,8,30,14,5,64,2,16,12,17,46,25,107,13,63,129,34,127,126]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c,$,m,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0,(()=>{try{(0,A.gracefulify)(N)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.$lj)(r)}`)}})();class n extends $.$1q{static{this.L=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=E.Event.None,this.P=new L.$Ac(s=>y.$5g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,b.$k&&(this.M|=1024)),this.M}async stat(t){try{const{stat:i,symbolicLink:s}=await p.SymlinkSupport.stat(this.I(t));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await p.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let u;o.isSymbolicLink()?u=(await this.stat((0,y.$bh)(t,o.name))).type:u=this.O(o),s.push([o.name,u])}catch(u){this.a.trace(u)}})),s}catch(i){throw this.hb(i)}}O(t,i){let s;return i?.dangling?s=d.FileType.Unknown:t.isFile()?s=d.FileType.File:t.isDirectory()?s=d.FileType.Directory:s=d.FileType.Unknown,i&&(s|=d.FileType.SymbolicLink),s}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new P.$zh;return this.P.set(t,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.Q(t));const o=this.I(t);return await p.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{s?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,s){const o=(0,w.$xe)(u=>D.$Je.concat(u.map(S=>D.$Je.wrap(S))).buffer);return(0,c.$Nq)(this,t,o,u=>u.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(t)?this.U(t,(0,y.$bh)((0,y.$ah)(t),`${(0,y.$$g)(t)}${s.atomic.postfix}`),i,s):this.W(t,i,s)}async S(t){try{const i=this.I(t),{symbolicLink:s}=await p.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(t,i,s,o){const u=new a.$Tc;try{u.add(await this.Q(t)),u.add(await this.Q(i)),await this.W(i,s,o,!0);try{await this.rename(i,t,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{u.dispose()}}async W(t,i,s,o){let u;try{const S=this.I(t);if(!s.create||!s.overwrite){if(await p.Promises.exists(S)){if(!s.overwrite)throw(0,d.$hl)((0,R.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,d.$hl)((0,R.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(u,0,i,0,i.byteLength)}catch(S){throw await this.ib(t,S)}finally{typeof u=="number"&&await this.close(u)}}static{this.$=!0}static configureFlushOnWrite(t){n.$=t}async open(t,i,s){const o=this.I(t);let u;(0,d.$8k)(i)&&!s&&(u=await this.Q(t));let S;try{if((0,d.$8k)(i)&&i.unlock)try{const{stat:I}=await p.SymlinkSupport.stat(o);I.mode&128||await p.Promises.chmod(o,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let k;if((0,d.$8k)(i)){if(b.$i)try{await p.Promises.truncate(o,0),k="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}k||(k="w")}else k="r";S=await p.Promises.open(o,k)}catch(k){throw u?.dispose(),(0,d.$8k)(i)?await this.ib(t,k):this.hb(k)}if(this.X.set(S,0),(0,d.$8k)(i)&&this.Z.set(S,t),u){const k=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${o})`),this.Y.set(S,u),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${o})`),k.dispose())}return S}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await p.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await p.Promises.close(t)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,u){const S=this.ab(t,i);let k=null;try{k=(await p.Promises.read(t,s,o,u,S)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(t,S,k)}return k}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,s){const o=this.X.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(t,o+s):this.X.delete(t)))}async write(t,i,s,o,u){return(0,P.$Uh)(()=>this.cb(t,i,s,o,u),100,3)}async cb(t,i,s,o,u){const S=this.ab(t,i);let k=null;try{k=(await p.Promises.write(t,s,o,u,S)).bytesWritten}catch(I){throw await this.ib(this.Z.get(t),I)}finally{this.bb(t,S,k)}return k}async mkdir(t){try{await p.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const s=this.I(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,h.$jc)((0,h.$mc)(s),`${(0,h.$nc)(s)}${i.atomic.postfix}`)),await p.Promises.rm(s,p.RimRafMode.MOVE,o)}else try{await p.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let u=!1;try{const{stat:S,symbolicLink:k}=await p.SymlinkSupport.stat(s);u=S.isDirectory()&&!k}catch{}if(u)await p.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.hb(s)}}async rename(t,i,s){const o=this.I(t),u=this.I(i);if(o!==u)try{await this.db(t,i,"move",s.overwrite),await p.Promises.rename(o,u)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(2,null,(0,h.$nc)(o),(0,h.$nc)((0,h.$mc)(u)),S.toString()))),this.hb(S)}}async copy(t,i,s){const o=this.I(t),u=this.I(i);if(o!==u)try{await this.db(t,i,"copy",s.overwrite),await p.Promises.copy(o,u,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(3,null,(0,h.$nc)(o),(0,h.$nc)((0,h.$mc)(u)),S.toString()))),this.hb(S)}}async db(t,i,s,o){const u=this.I(t),S=this.I(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,l.$yg)(u,S,!0)),k){if(s==="copy")throw(0,d.$hl)((0,R.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const j=await this.N(t);if(!j)throw(0,d.$hl)((0,R.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const F=await this.N(i);if(F){if(!o)throw(0,d.$hl)((0,R.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);j.type&d.FileType.File&&F.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,s){const o=this.I(t),u=this.I(i),S=!!(this.capabilities&1024);if((0,l.$yg)(o,u,!S))return;const k=new a.$Tc;try{k.add(await this.Q(t)),k.add(await this.Q(i)),s&&await p.Promises.mkdir((0,h.$mc)(u),{recursive:!0}),await p.Promises.copyFile(o,u)}catch(I){if(I.code==="ENOENT"&&!s)return this.eb(t,i,!0);throw this.hb(I)}finally{k.dispose()}}t(t,i,s){return new g.$8q(o=>t(o),o=>i(o),s)}F(t,i,s){return new f.$er(o=>t(o),o=>i(o),s)}hb(t){if(t instanceof d.$gl)return t;let i=t,s;switch(t.code){case"ENOENT":s=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=d.FileSystemProviderErrorCode.Unknown;break;default:s=d.FileSystemProviderErrorCode.Unknown}return(0,d.$hl)(i,s)}async ib(t,i){let s=this.hb(i);if(t&&s.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await p.SymlinkSupport.stat(this.I(t));o.mode&128||(s=(0,d.$hl)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$fr=n}),define(re[133],oe([0,1,2,6]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;class P extends N.$Uc{constructor(D,E=[]){super(),this.a=new A.$ek([D,...E]),this.B(D.onDidChangeLogLevel(l=>this.setLevel(l)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...E){this.a.trace(D,...E)}debug(D,...E){this.a.debug(D,...E)}info(D,...E){this.a.info(D,...E)}warn(D,...E){this.a.warn(D,...E)}error(D,...E){this.a.error(D,...E)}flush(){this.a.flush()}}e.$fQ=P}),define(re[134],oe([0,1,13,6]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=void 0;var P;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(P||(P={}));async function L(a,h,b,y,w){try{const p=await new Promise((d,c)=>{Q(["@vscode/spdlog"],d,c)});p.setFlushOn(P.Trace);const R=await p.createAsyncRotatingLogger(a,h,b,y);return w?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(p){console.error(p)}return null}function D(a,h,b){switch(h){case A.LogLevel.Trace:a.trace(b);break;case A.LogLevel.Debug:a.debug(b);break;case A.LogLevel.Info:a.info(b);break;case A.LogLevel.Warning:a.warn(b);break;case A.LogLevel.Error:a.error(b);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function E(a,h){switch(h){case A.LogLevel.Trace:a.setLevel(P.Trace);break;case A.LogLevel.Debug:a.setLevel(P.Debug);break;case A.LogLevel.Info:a.setLevel(P.Info);break;case A.LogLevel.Warning:a.setLevel(P.Warning);break;case A.LogLevel.Error:a.setLevel(P.Error);break;case A.LogLevel.Off:a.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class l extends A.$ak{constructor(h,b,y,w,p){super(),this.m=[],this.setLevel(p),this.n=this.s(h,b,y,w),this.B(this.onDidChangeLogLevel(R=>{this.r&&E(this.r,R)}))}async s(h,b,y,w){const p=y?6:1,R=30/p*N.$Cl.MB,d=await L(h,b,R,p,w);if(d){this.r=d,E(this.r,this.getLevel());for(const{level:c,message:$}of this.m)D(this.r,c,$);this.m=[]}}g(h,b){this.r?D(this.r,h,b):this.getLevel()<=h&&this.m.push({level:h,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$7P=l}),define(re[135],oe([0,1,28,6,134]),function(Q,e,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=void 0;class L extends A.$fk{s(E,l,a){return new P.$7P((0,N.$Wg)(),E.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,l)}}e.$8P=L}),define(re[39],oe([0,1,5,67,2,10]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=void 0,e.$jo=(0,L.$Ai)("policy");class D extends P.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new N.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const h=Object.keys(this.f).length;return this.f={...a,...this.f},h!==Object.keys(this.f).length&&await this.j(a),A.Iterable.reduce(this.g.entries(),(b,[y,w])=>({...b,[y]:w}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(a,[h,b])=>({...a,[h]:{definition:b,value:this.g.get(h)}}),{})}}e.$ko=D;class E{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$lo=E}),define(re[136],oe([0,1,8,5,67,3,13,6,39]),function(Q,e,N,A,P,L,D,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;function a(b,y){const w=[];for(const p of new Set(P.Iterable.concat(b.keys(),y.keys())))b.get(p)!==y.get(p)&&w.push(p);return w}let h=class extends l.$ko{constructor(y,w,p){super(),this.m=y,this.n=w,this.s=p,this.c=this.B(new N.$yh(500));const R=A.Event.filter(w.onDidFilesChange,d=>d.affects(y));this.B(w.watch(y)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const w=await this.n.readFile(this.m),p=JSON.parse(w.value.toString());if(!(0,L.$cg)(p))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(p))this.f[R]&&y.set(R,p[R])}catch(w){w.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",w)}return y}async w(){const y=await this.u(),w=a(this.g,y);this.g=y,w.length>0&&this.h.fire(w)}};e.$Nec=h,e.$Nec=h=$e([ie(1,D.$7k),ie(2,E.$7j)],h)}),define(re[137],oe([0,1,39,8,2,6]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;let D=class extends N.$ko{constructor(l,a){super(),this.m=l,this.n=a,this.a=new A.$uh,this.b=this.B(new P.$Vc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`);const{createWatcher:a}=await new Promise((h,b)=>{Q(["@vscode/policy-watcher"],h,b)});await this.a.queue(()=>new Promise((h,b)=>{try{this.b.value=a(this.n,l,y=>{this.t(y),h()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),b(y)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const a in l){const h=l[a];h===void 0?this.g.delete(a):this.g.set(a,h)}this.h.fire(Object.keys(l))}};e.$Mec=D,e.$Mec=D=$e([ie(0,L.$7j)],D)}),define(re[32],oe([0,1,10]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,N.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(re[36],oe([0,1,75,3]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=void 0;class P{constructor(){this.a=new Map}add(D,E){N.ok(A.$ag(D)),N.ok(A.$cg(E)),N.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,E)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$ho=new P}),define(re[138],oe([0,1,5,36]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=void 0,e.$io={JSONContribution:"base.contributions.json"};function P(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class L{constructor(){this.b=new N.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,a){this.a[P(l)]=a,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}}const D=new L;A.$ho.add(e.$io.JSONContribution,D)}),define(re[40],oe([0,1,19,5,3,94,29,138,36]),function(Q,e,N,A,P,L,D,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ConfigurationScope=e.$mo=e.EditPresentationTypes=void 0,e.$xo=R,e.$yo=d,e.$zo=c,e.$Ao=m,e.$Bo=g;var a;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$mo={Configuration:"base.contributions.configuration"};var h;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to="vscode://schemas/settings/resourceLanguage",e.$uo="vscode://schemas/settings/configurationDefaults";const b=l.$ho.as(E.$io.JSONContribution);class y{constructor(){this.h=new Set,this.i=new A.$he,this.onDidSchemaChange=this.i.event,this.j=new A.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$to,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),b.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),b.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),b.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.$wo.test(o)){const u=this.a.get(o),S=u?.valuesSources??new Map;if(s)for(const F of Object.keys(i[o]))S.set(F,s);const k={...u?.value||{},...i[o]};this.a.set(o,{source:s,value:k,valuesSources:S});const I=(0,D.$ej)(o),j={type:"object",default:k,description:L.localize(1,null,I),$ref:e.$to,defaultDefaultValue:k,source:P.$ag(s)?void 0:s,defaultValueSource:s};t.push(...R(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:i[o],source:s});const u=this.d[o];u&&(this.w(o,u),this.r(o,u))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.a.get(s),u=P.$ag(i)?i:i?.id,S=P.$ag(o?.source)?o?.source:o?.source?.id;if(u===S)if(r.add(s),this.a.delete(s),e.$wo.test(s))delete this.d[s],delete this.b.properties[s];else{const k=this.d[s];k&&(this.w(s,k),this.r(s,k))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,o){s=P.$jg(n.scope)?s:n.scope;const u=n.properties;if(u)for(const k in u){const I=u[k];if(r&&m(k,I)){delete u[k];continue}if(I.source=t,I.defaultDefaultValue=u[k].default,this.w(k,I),e.$wo.test(k)?I.scope=void 0:(I.scope=P.$jg(I.scope)?s:I.scope,I.restricted=P.$jg(I.restricted)?!!i?.includes(k):I.restricted),u[k].hasOwnProperty("included")&&!u[k].included){this.f[k]=u[k],delete u[k];continue}else this.d[k]=u[k],u[k].policy?.name&&this.e.set(u[k].policy.name,k);!u[k].deprecationMessage&&u[k].markdownDeprecationMessage&&(u[k].deprecationMessage=u[k].markdownDeprecationMessage),o.add(k)}const S=n.allOf;if(S)for(const k of S)this.p(k,r,t,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$no.properties[n]=r,r.scope){case 1:e.$oo.properties[n]=r;break;case 2:e.$po.properties[n]=r;break;case 6:e.$qo.properties[n]=r;break;case 3:e.$ro.properties[n]=r;break;case 4:e.$so.properties[n]=r;break;case 5:e.$so.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$no.properties[n],r.scope){case 1:delete e.$oo.properties[n];break;case 2:delete e.$po.properties[n];break;case 6:delete e.$qo.properties[n];break;case 3:delete e.$ro.properties[n];break;case 4:case 5:delete e.$so.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$to};this.w(r,t),e.$no.properties[r]=t,e.$oo.properties[r]=t,e.$po.properties[r]=t,e.$qo.properties[r]=t,e.$ro.properties[r]=t,e.$so.properties[r]=t}}v(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$to};e.$no.patternProperties[e.$vo]=n,e.$oo.patternProperties[e.$vo]=n,e.$po.patternProperties[e.$vo]=n,e.$qo.patternProperties[e.$vo]=n,e.$ro.patternProperties[e.$vo]=n,e.$so.patternProperties[e.$vo]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;P.$hg(i)&&(i=r.defaultDefaultValue,s=void 0),P.$hg(i)&&(i=c(r.type)),r.default=i,r.defaultValueSource=s}}const w="\\[([^\\]]+)\\]",p=new RegExp(w,"g");e.$vo=`^(${w})+$`,e.$wo=new RegExp(e.$vo);function R(f){const n=[];if(e.$wo.test(f)){let r=p.exec(f);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=p.exec(f)}}return(0,N.$Mb)(n)}function d(f){return f.reduce((n,r)=>`${n}[${r}]`,"")}function c(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new y;l.$ho.add(e.$mo.Configuration,$);function m(f,n){return f.trim()?e.$wo.test(f)?L.localize(7,null,f):$.getConfigurationProperties()[f]!==void 0?L.localize(8,null,f):n.policy?.name&&$.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,f,n.policy?.name,$.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}function g(){const f=[],n=$.getConfigurationProperties();for(const r of Object.keys(n))f.push([r,n[r].scope]);return f.push(["launch",4]),f.push(["task",4]),f}}),define(re[68],oe([0,1,19,5,38,2,30,27,3,11,29,40,36]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Go=m;function w(r){return Object.isFrozen(r)?r:E.$8n(r)}class p{static createEmptyModel(t){return new p({},[],[],void 0,t)}constructor(t,i,s,o,u){this.b=t,this.c=i,this.d=s,this.raw=o,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof p)return i;const s=new R("",this.f);return s.parseRaw(i),s.configurationModel});this.g=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,h.$cj)(this.contents,t):this.contents}inspect(t,i){const s=this;return{get value(){return w(s.rawConfiguration.getValue(t))},get override(){return i?w(s.rawConfiguration.getOverrideValue(t,i)):void 0},get merged(){return w(i?s.rawConfiguration.override(i).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:u,identifiers:S,keys:k}of s.rawConfiguration.overrides){const I=new p(u,k,[],void 0,s.f).getValue(t);I!==void 0&&o.push({identifiers:S,value:I})}return o.length?w(o):void 0}}}getOverrideValue(t,i){const s=this.j(i);return s?t?(0,h.$cj)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return N.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return N.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.h(t),this.a.set(t,i)),i}merge(...t){const i=E.$7n(this.contents),s=E.$7n(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const S of t)if(u.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(i,S.contents);for(const k of S.overrides){const[I]=s.filter(j=>N.$ub(j.identifiers,k.identifiers));I?(this.i(I.contents,k.contents),I.keys.push(...k.keys),I.keys=N.$Mb(I.keys)):s.push(E.$7n(k))}for(const k of S.keys)o.indexOf(k)===-1&&o.push(k)}return new p(i,o,s,u.every(S=>S instanceof p)?void 0:u,this.f)}h(t){const i=this.j(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of N.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[o];const S=i[o];S&&(typeof u=="object"&&typeof S=="object"?(u=E.$7n(u),this.i(u,S)):u=S),s[o]=u}return new p(s,this.keys,this.overrides,void 0,this.f)}i(t,i){for(const s of Object.keys(i)){if(s in t&&l.$cg(t[s])&&l.$cg(i[s])){this.i(t[s],i[s]);continue}t[s]=E.$7n(i[s])}}j(t){let i=null,s=null;const o=u=>{u&&(s?this.i(s,u):s=E.$7n(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===t?i=u.contents:u.identifiers.includes(t)&&o(u.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.k(t,i,!0)}setValue(t,i){this.k(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,h.$bj)(this.contents,t),b.$wo.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>N.$ub(s.identifiers,(0,b.$xo)(t))),1))}k(t,i,s){(0,h.$aj)(this.contents,t,i,o=>this.f.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),b.$wo.test(t)&&this.overrides.push({identifiers:(0,b.$xo)(t),keys:Object.keys(this.contents[t]),contents:(0,h.$_i)(this.contents[t],o=>this.f.error(o))})}}e.$Co=p;class R{constructor(t,i){this.f=t,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!l.$jg(t)){const s=this.h(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:o,overrides:u,restricted:S,hasExcludedProperties:k}=this.i(t,i);this.b=new p(s,o,u,k?[t]:void 0,this.g),this.c=S||[]}h(t){let i={},s=null,o=[];const u=[],S=[];function k(j){Array.isArray(o)?o.push(j):s!==null&&(o[s]=j)}const I={onObjectBegin:()=>{const j={};k(j),u.push(o),o=j,s=null},onObjectProperty:j=>{s=j},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const j=[];k(j),u.push(o),o=j,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:k,onError:(j,F,B)=>{S.push({error:j,offset:F,length:B})}};if(t)try{P.$Un(t,I),i=o[0]||{}}catch(j){this.g.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return i}i(t,i){const s=y.$ho.as(b.$mo.Configuration).getConfigurationProperties(),o=this.j(t,s,!0,i);t=o.raw;const u=(0,h.$_i)(t,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`)),S=Object.keys(t),k=this.l(t,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:u,keys:S,overrides:k,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,i,s,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:u};const S={},k=[];for(const I in t)if(b.$wo.test(I)&&s){const j=this.j(t[I],i,!1,o);S[I]=j.raw,u=u||j.hasExcludedProperties,k.push(...j.restricted)}else{const j=i[I],F=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&k.push(I),!o.exclude?.includes(I)&&(o.include?.includes(I)||(F===void 0||o.scopes===void 0||o.scopes.includes(F))&&!(o.skipRestricted&&j?.restricted))?S[I]=t[I]:u=!0}return{raw:S,restricted:k,hasExcludedProperties:u}}l(t,i){const s=[];for(const o of Object.keys(t))if(b.$wo.test(o)){const u={};for(const S in t[o])u[S]=t[o][S];s.push({identifiers:(0,b.$xo)(o),keys:Object.keys(u),contents:(0,h.$_i)(u,i)})}return s}}e.$Do=R;class d extends L.$Uc{constructor(t,i,s,o,u){super(),this.c=t,this.f=i,this.g=o,this.h=u,this.b=this.B(new A.$he),this.onDidChange=this.b.event,this.a=new R(this.c.toString(),u),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&s.isEqual(S.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Eo=d;class c{constructor(t,i,s,o,u,S,k,I,j,F,B,J,ne){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=o,this.d=u,this.f=S,this.g=k,this.h=I,this.i=j,this.j=F,this.k=B,this.l=J,this.m=ne}get value(){return w(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class ${constructor(t,i,s,o,u,S,k,I,j,F){this.j=t,this.l=i,this.m=s,this.n=o,this.p=u,this.q=S,this.r=k,this.s=I,this.t=j,this.u=F,this.h=null,this.i=new D.$Ac,this.v=null}getValue(t,i,s){return this.w(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this.t.get(s.resource),o||(o=p.createEmptyModel(this.u),this.t.set(s.resource,o))):o=this.s,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this.h=null)}inspect(t,i,s){const o=this.w(t,i,s),u=this.A(i.resource,s),S=i.resource?this.t.get(i.resource)||this.s:this.s,k=new Set;for(const I of o.overrides)for(const j of I.identifiers)o.getOverrideValue(t,j)!==void 0&&k.add(j);return new c(t,i,o.getValue(t),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,u||void 0,S)}keys(t){const i=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,i){this.r.set(t,i),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:u,removed:S}=f(this.j,t);i=[...o,...u,...S]}for(const o of i)for(const u of(0,b.$xo)(o)){const S=this.j.getKeysForOverrideIdentifier(u),k=t.getKeysForOverrideIdentifier(u),I=[...k.filter(j=>S.indexOf(j)===-1),...S.filter(j=>k.indexOf(j)===-1),...S.filter(j=>!E.$$n(this.j.override(u).getValue(j),t.override(u).getValue(j)))];s.push([u,I])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=f(this.l,t),u=[...i,...s,...o];return u.length&&this.updatePolicyConfiguration(t),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:u}=f(this.applicationConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateApplicationConfiguration(t),{keys:S,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:u}=f(this.localUserConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateLocalUserConfiguration(t),{keys:S,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:u}=f(this.remoteUserConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateRemoteUserConfiguration(t),{keys:S,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:u}=f(this.workspaceConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateWorkspaceConfiguration(t),{keys:S,overrides:u}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:o,updated:u,removed:S,overrides:k}=f(s,i),I=[...o,...u,...S];return(I.length||!s)&&this.updateFolderConfiguration(t,i),{keys:I,overrides:k}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:u,overrides:S}=f(i,void 0);return{keys:[...s,...o,...u],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,i,s){let o=this.x(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},i){let s=this.y();if(i&&t){const o=i.getFolder(t);o&&(s=this.z(o.uri)||s);const u=this.t.get(t);u&&(s=s.merge(u))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let i=this.i.get(t);if(!i){const s=this.y(),o=this.r.get(t);o?(i=s.merge(o),this.i.set(t,i)):i=s}return i}A(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:u}=this.r.get(i);return t.push([i,{contents:s,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.q.keys.forEach(i=>t.add(i)),this.r.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}D(t){const i=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.q.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t,i){const s=this.E(t.defaults,i),o=this.E(t.policy,i),u=this.E(t.application,i),S=this.E(t.user,i),k=this.E(t.workspace,i),I=t.folders.reduce((j,F)=>(j.set(a.URI.revive(F[0]),this.E(F[1],i)),j),new D.$Ac);return new $(s,o,u,S,p.createEmptyModel(i),k,I,p.createEmptyModel(i),new D.$Ac,i)}static E(t,i){return new p(t.contents,t.keys,t.overrides,void 0,i)}}e.$Fo=$;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,S])=>{const k=(0,D.$xc)(i,u,new Set);S.forEach(I=>k.add(I))});const s=[];return i.forEach((o,u)=>s.push([u,[...o.values()]])),{keys:[...t.values()],overrides:s}}class g{constructor(t,i,s,o,u){this.change=t,this.f=i,this.g=s,this.h=o,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of t.keys)this.affectedKeys.add(S);for(const[,S]of t.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=$.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,i){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const u=o+s.length;if(u>=this.d.length)return!1;const S=this.d.charCodeAt(u);if(S!==this.b&&S!==this.c)return!1;if(i){const k=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,I=this.g.getValue(t,i,this.h);return!E.$$n(k,I)}return!0}}e.$Ho=g;function f(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),u=[],S=r?.getAllOverrideIdentifiers()||[],k=t?.getAllOverrideIdentifiers()||[];if(t){const I=k.filter(j=>!S.includes(j));for(const j of I)u.push([j,t.getKeysForOverrideIdentifier(j)])}if(r){const I=S.filter(j=>!k.includes(j));for(const j of I)u.push([j,r.getKeysForOverrideIdentifier(j)])}if(t&&r){for(const I of S)if(k.includes(I)){const j=n({contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)},{contents:t.getOverrideValue(void 0,I)||{},keys:t.getKeysForOverrideIdentifier(I)});u.push([I,[...j.added,...j.removed,...j.updated]])}}return{added:i,removed:s,updated:o,overrides:u}}function n(r,t){const i=r?t?r.keys.filter(u=>t.keys.indexOf(u)===-1):[...r.keys]:[],s=t?r?t.keys.filter(u=>r.keys.indexOf(u)===-1):[...t.keys]:[],o=[];if(r&&t){for(const u of t.keys)if(r.keys.indexOf(u)!==-1){const S=(0,h.$cj)(t.contents,u),k=(0,h.$cj)(r.contents,u);E.$$n(S,k)||o.push(u)}}return{added:i,removed:s,updated:o}}}),define(re[139],oe([0,1,19,5,2,27,3,68,40,6,39,36]),function(Q,e,N,A,P,L,D,E,l,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=void 0;class y extends P.$Uc{get configurationModel(){return this.b}constructor(d){super(),this.c=d,this.a=this.B(new A.$he),this.onDidChangeConfiguration=this.a.event,this.b=E.$Co.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(b.$ho.as(l.$mo.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:c})=>this.f(Array.from(d),c))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(d,c){this.j(d,b.$ho.as(l.$mo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}g(){return{}}h(){this.b=E.$Co.createEmptyModel(this.c);const d=b.$ho.as(l.$mo.Configuration).getConfigurationProperties();this.j(Object.keys(d),d)}j(d,c){const $=this.g();for(const m of d){const g=$[m],f=c[m];g!==void 0?this.b.addValue(m,g):f?this.b.addValue(m,f.default):this.b.removeValue(m)}}}e.$Io=y;class w{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=E.$Co.createEmptyModel(new a.$hk)}async initialize(){return this.configurationModel}}e.$Jo=w;let p=class extends P.$Uc{get configurationModel(){return this.b}constructor(d,c,$){super(),this.c=d,this.f=c,this.g=$,this.a=this.B(new A.$he),this.onDidChangeConfiguration=this.a.event,this.b=E.$Co.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const c={},$=[],m=b.$ho.as(l.$mo.Configuration).getConfigurationProperties();for(const g of d){const f=m[g];if(!f){$.push(g);continue}if(f.policy){if(f.type!=="string"&&f.type!=="number"){this.g.warn(`Policy ${f.policy.name} has unsupported type ${f.type}`);continue}$.push(g),c[f.policy.name]={type:f.type}}}return(0,D.$ng)(c)||await this.f.updatePolicyDefinitions(c),$}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const c=b.$ho.as(l.$mo.Configuration).getPolicyConfigurations(),$=(0,N.$Hb)(d.map(m=>c.get(m)));this.m($,!0)}m(d,c){this.g.trace("PolicyConfiguration#update",d);const $=b.$ho.as(l.$mo.Configuration).getConfigurationProperties(),m=[],g=this.b.isEmpty();for(const f of d){const n=$[f]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(g?r!==void 0:!(0,L.$$n)(this.b.getValue(f),r))&&m.push([f,r])}else this.b.getValue(f)!==void 0&&m.push([f,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const f=this.b;this.b=E.$Co.createEmptyModel(this.g);for(const n of f.keys)this.b.setValue(n,f.getValue(n));for(const[n,r]of m)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);c&&this.a.fire(this.b)}}};e.$Ko=p,e.$Ko=p=$e([ie(1,h.$jo),ie(2,a.$7j)],p)}),define(re[140],oe([0,1,19,8,14,5,38,77,2,30,27,12,17,29,68,40,139,39]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=void 0;class $ extends l.$Uc{constructor(f,n,r,t){super(),this.m=f,this.n=t,this.h=this.B(new L.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Io(t)),this.c=r instanceof c.$lo?new d.$Jo:this.B(new d.$Ko(this.b,r,t)),this.f=this.B(new p.$Eo(this.m,{},y.$5g,n,t)),this.a=new p.$Fo(this.b.configurationModel,this.c.configurationModel,p.$Co.createEmptyModel(t),p.$Co.createEmptyModel(t),p.$Co.createEmptyModel(t),p.$Co.createEmptyModel(t),new a.$Ac,p.$Co.createEmptyModel(t),new a.$Ac,t),this.j=new m(f,n,this),this.g=this.B(new A.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:s})=>this.s(i,s))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[f,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$Fo(f,n,p.$Co.createEmptyModel(this.n),r,p.$Co.createEmptyModel(this.n),p.$Co.createEmptyModel(this.n),new a.$Ac,p.$Co.createEmptyModel(this.n),new a.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(f,n){const r=typeof f=="string"?f:void 0,t=(0,w.$8i)(f)?f:(0,w.$8i)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(f,n,r,t,i){const s=(0,w.$9i)(r)?r:(0,w.$8i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=s?t:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${f} to target ${o}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,N.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const u=this.inspect(f,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${f} because it is configured in system policy.`);if((0,h.$$n)(n,u.defaultValue)&&(n=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const k=s.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(j=>(0,N.$ub)([...j.identifiers].sort(),k));I&&(s.overrideIdentifiers=I.identifiers)}const S=s?.overrideIdentifiers?.length?[(0,R.$yo)(s.overrideIdentifiers),f]:[f];await this.j.write(S,n),await this.reloadConfiguration()}inspect(f,n={}){return this.a.inspect(f,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const f=await this.f.loadConfiguration();this.r(f)}r(f){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(f);this.u(r,n,2)}s(f,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(f,n);this.u(t,r,7)}t(f){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(f);this.u(r,n,7)}u(f,n,r){const t=new p.$Ho(f,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$Lo=$;class m{constructor(f,n,r){this.b=f,this.c=n,this.d=r,this.a=new A.$Hh}write(f,n){return this.a.queue(()=>this.e(f,n))}async e(f,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)r="{}";else throw s}const t=[];if((0,D.$Nn)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,f,n);r=(0,E.$6n)(r,i),await this.c.writeFile(this.b,P.$Je.fromString(r))}f(f,n,r){const{tabSize:t,insertSpaces:i,eol:s}=this.h;if(!n.length){const o=JSON.stringify(r,null,i?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,E.$3n)(f,n,r,{tabSize:t,insertSpaces:i,eol:s})}get h(){if(!this.g){let f=b.OS===3||b.OS===2?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(f=n),this.g={eol:f,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(re[69],oe([0,1,15]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=A,e.$Mm=P,e.$Nm=L,e.$Om=D;function A(l){return l.scheme===N.Schemas.vscodeRemote?l.authority:void 0}function P(l){if(!l)return;const a=l.indexOf("+");return a<0?l:l.substr(0,a)}function L(l){const{host:a,port:h}=E(l);if(typeof h>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:h}}function D(l,a){let{host:h,port:b}=E(l);return typeof b>"u"&&(b=a),{host:h,port:b}}function E(l){const a=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const h=l.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const b=l.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:l,port:void 0}}}),define(re[37],oe([0,1,31,10,69]),function(Q,e,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$Xm=e.$Wm=e.$Vm=e.TargetPlatform=e.ExtensionType=e.$Um=e.$Sm=e.$Rm=e.$Qm=e.$Pm=void 0,e.$Tm=L,e.$Ym=b,e.$Zm=y,e.$1m=w,e.$2m=p,e.$Pm="extensions.user.cache",e.$Qm="extensions.builtin.cache",e.$Rm="undefined_publisher",e.$Sm=["ui","workspace","web"];function L(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}e.$Um=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var D;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(D||(e.ExtensionType=D={}));var E;(function(R){R.WIN32_X64="win32-x64",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class l{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,c){if(typeof d>"u"||d===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof d=="string"||typeof c=="string"){const $=typeof d=="string"?d:d.value,m=typeof c=="string"?c:c.value;return N.$Bf($,m)}return d._lower===c._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Vm=l;class a{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const c of d)this.add(c)}add(d){this.c.add(l.toKey(d))}delete(d){return this.c.delete(l.toKey(d))}has(d){return this.c.has(l.toKey(d))}}e.$Wm=a;class h{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(l.toKey(d))}get(d){return this.c.get(l.toKey(d))}has(d){return this.c.has(l.toKey(d))}set(d,c){this.c.set(l.toKey(d),c)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xm=h;function b(R){return y(R)}function y(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}function w(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}function p(R,d){if(d){const c=`onResolveRemoteAuthority:${(0,P.$Mm)(d)}`;return!!R.activationEvents?.includes(c)}return!1}e.$3m=(0,A.$Ai)("IBuiltinExtensionsScannerService")}),define(re[141],oe([0,1,2,37,13]),function(Q,e,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;class L extends N.$Uc{constructor(E,l,a,h,b){super(),this.a=E,this.b=l,this.c=a,this.f=b,this.B(h.onDidInstallExtensions(y=>this.g(y))),this.B(h.onDidUninstallExtension(y=>this.h(y)))}g(E){for(const l of E)l.local&&this.invalidate(l.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const l of this.a.profiles)this.c.extUri.isEqual(l.extensionsResource,E)&&await this.j(l);else await this.j(this.a.defaultProfile)}async j(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,A.$Pm))}catch(l){(0,P.$ll)(l)!==1&&this.f.error(l)}}}e.$Iq=L}),define(re[45],oe([0,1,14,9,2,110,40,10,6,36]),function(Q,e,N,A,P,L,D,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0,e.$Vp=y,e.$Wp=w,e.$Xp=p,e.$Yp=R,e.$Zp=d,e.$1p=c,e.$Tp=(0,E.$Ai)("requestService");class h{constructor(f){this.b=f}toJSON(){if(!this.a){const f=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?f[n]="*****":f[n]=this.b[n];this.a=f}return this.a}}class b extends P.$Uc{constructor(f){super(),this.b=0,this.a=f.createLogger("network",{name:(0,L.localize)(0,null),when:l.$mk.isEqualTo((0,l.$jk)(l.LogLevel.Trace)).serialize()})}async c(f,n,r){const t=`${f} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new h(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,A.$0)(i)),i}}}e.$Up=b;function y(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}function w(g){return g.res.statusCode===204}async function p(g){return w(g)?null:(await(0,N.$Ve)(g.stream)).toString()}async function R(g){if(!y(g))throw new Error("Server returned "+g.res.statusCode);return p(g)}async function d(g){if(!y(g))throw new Error("Server returned "+g.res.statusCode);if(w(g))return null;const n=(await(0,N.$Ve)(g.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}function c(g){m(g)}let $;function m(g){const f=a.$ho.as(D.$mo.Configuration),n=$;$={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},f.updateConfigurations({add:[$],remove:n?[n]:[]})}m(1)}),define(re[142],oe([0,1,22,15,13,45]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0;let D=class{constructor(l,a){this.a=l,this.b=a}async download(l,a,h=N.CancellationToken.None){if(l.scheme===A.Schemas.file||l.scheme===A.Schemas.vscodeRemote){await this.b.copy(l,a);return}const b={type:"GET",url:l.toString(!0)},y=await this.a.request(b,h);if(y.res.statusCode===200)await this.b.writeFile(a,y.stream);else{const w=await(0,L.$Yp)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${w}`)}}};e.$uQ=D,e.$uQ=D=$e([ie(0,L.$Tp),ie(1,P.$7k)],D)}),define(re[143],oe([0,1,144,3]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=L;function P(D,E){return D.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:D.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function L(D,E,l={}){const a=(0,N.parse)(D),h=l.proxyUrl||P(a,E);if(!h)return null;const b=(0,N.parse)(h);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,A.$gg)(l.strictSSL)?l.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((w,p)=>{Q(["http-proxy-agent"],w,p)})).HttpProxyAgent(h,y):new(await new Promise((w,p)=>{Q(["https-proxy-agent"],w,p)})).HttpsProxyAgent(h,y)}}),define(re[145],oe([0,1,60,16,111,22,34,9,12,28,90,175,8,78]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=R;let p;async function R(c,$,m,g){return m["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.$i?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Em)(g)&&!m["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Em)(g)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=y.Promises.withAsyncBody(async(f,n)=>{const r=new L.$se;let t=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,w.$Fm)(i,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,P.localize)(0,null)))},t);try{f(await d($,r.token))}catch(o){!(0,E.$4)(o)&&!r.token.isCancellationRequested?n(new Error((0,P.localize)(1,null,(0,D.$lj)(o)))):f({})}finally{clearTimeout(s),r.dispose()}})),p)}async function d(c,$){const m=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",m);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",g);const f=(0,a.$Wg)().replace(/-/g,"").substr(0,12),n=new RegExp(f+"({.*})"+f),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,h.$um)(l.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if($.isCancellationRequested)return s(new E.$5);const o=(0,A.$nc)(t);let u,S;const k="";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${k} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,S=["-Login","-Command"]):o==="nu"?(u=`^'${process.execPath}' ${k} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,S=["-i","-l","-c"]):o==="xonsh"?(u=`import os, json; print("${f}", json.dumps(dict(os.environ)), "${f}")`,S=["-i","-l","-c"]):(u=`'${process.execPath}' ${k} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,o==="tcsh"||o==="csh"?S=["-ic"]:S=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),u);const I=(0,N.spawn)(t,[...S,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});$.onCancellationRequested(()=>(I.kill(),s(new E.$5))),I.on("error",B=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,D.$lj)(B)),s(B)});const j=[];I.stdout.on("data",B=>j.push(B));const F=[];I.stderr.on("data",B=>F.push(B)),I.on("close",(B,J)=>{const ne=Buffer.concat(j).toString("utf8");c.trace("getUnixShellEnvironment#raw",ne);const te=Buffer.concat(F).toString("utf8");if(te.trim()&&c.trace("getUnixShellEnvironment#stderr",te),B||J)return s(new Error((0,P.localize)(2,null,B,J)));const le=n.exec(ne),ce=le?le[1]:"{}";try{const ae=JSON.parse(ce);m?ae.ELECTRON_RUN_AS_NODE=m:delete ae.ELECTRON_RUN_AS_NODE,g?ae.ELECTRON_NO_ATTACH_CONSOLE=g:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),i(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,D.$lj)(ae)),s(ae)}})})}}),define(re[146],oe([0,1,10]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0P=e.$9P=void 0,e.$9P=(0,N.$Ai)("stateReadService"),e.$0P=(0,N.$Ai)("stateService")}),define(re[70],oe([0,1,8,14,2,3,18,13,6]),function(Q,e,N,A,P,L,D,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=e.$_P=e.$$P=e.SaveStrategy=void 0;var a;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class h extends P.$Uc{constructor(p,R,d,c){super(),this.h=p,this.j=R,this.m=d,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new N.$yh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.m.error(p)}}getItem(p,R){const d=this.a[p];return(0,L.$jg)(d)?R:d}setItem(p,R){this.setItems([{key:p,data:R}])}setItems(p){let R=!1;for(const{key:d,data:c}of p)this.a[d]!==c&&((0,L.$jg)(c)?(0,L.$hg)(this.a[d])||(this.a[d]=void 0,R=!0):(this.a[d]=c,R=!0));R&&this.s()}removeItem(p){(0,L.$hg)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,A.$Je.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$$P=h;let b=class extends P.$Uc{constructor(p,R,d,c){super(),this.a=this.B(new h(R.stateResource,p,d,c))}async init(){await this.a.init()}getItem(p,R){return this.a.getItem(p,R)}};e.$_P=b,e.$_P=b=$e([ie(1,D.$Hi),ie(2,l.$7j),ie(3,E.$7k)],b);class y extends b{setItem(p,R){this.a.setItem(p,R)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$aQ=y}),define(re[71],oe([0,1,12,35,28]),function(Q,e,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=D,e.$kp=E;function L(l){if(N.$u===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}function D(l,a,h,b,y,w,p,R,d){const c=Object.create(null);c["common.machineId"]=w,c["common.sqmId"]=p,c.sessionID=(0,P.$Wg)()+Date.now(),c.commitHash=b,c.version=y,c["common.platformVersion"]=(l||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,N.$h)(N.$u),c["common.nodePlatform"]=A.$dc,c["common.nodeArch"]=h,c["common.product"]=d||"desktop",R&&(c["common.msftInternal"]=R);let $=0;const m=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>$++,enumerable:!0}}),N.$l&&(c["common.snap"]="true");const g=L(a);return g&&(c["common.platformDetail"]=g),c}function E(l){const a=A.env.USERDNSDOMAIN;if(!a)return!1;const h=a.toLowerCase();return l.some(b=>h===b)}}),define(re[21],oe([0,1,10]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,N.$Ai)("telemetryService"),e.$7l=(0,N.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry",e.$bm="telemetry.telemetryLevel",e.$cm="telemetry.enableCrashReporter",e.$dm="telemetry.enableTelemetry";var A;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var P;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(re[72],oe([0,1,9,10,6,21]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.ExtensionSignatureVerificationCode=e.$fq=void 0,e.$fq=(0,A.$Ai)("IExtensionSignatureVerificationService");var D;(function(a){a.None="None",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.Success="Success",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(D||(e.ExtensionSignatureVerificationCode=D={}));class E extends Error{constructor(h){super(h),this.code=h}}e.$gq=E;let l=class{constructor(h,b){this.b=h,this.c=b}d(){return this.a||(this.a=new Promise((h,b)=>Q(["@vscode/vsce-sign"],async y=>h(y),b))),this.a}async verify(h,b,y,w){let p;const R=h.identifier.id;try{p=await this.d()}catch(m){return this.b.error("Could not load vsce-sign module",(0,N.$0)(m)),this.b.info(`Extension signature verification is not done: ${R}`),!1}const d=new Date().getTime();let c;try{this.b.trace(`Verifying extension signature for ${R}...`),c=await p.verify(b,y,this.b.getLevel()===P.LogLevel.Trace)}catch(m){c={code:"UnknownError",didExecute:!1,output:(0,N.$0)(m)}}const $=new Date().getTime()-d;if(this.b.info(`Extension signature verification result for ${R}: ${c.code}. Executed: ${c.didExecute}. Duration: ${$}ms.`),this.b.trace(`Extension signature verification output for ${R}:
${c.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:R,extensionVersion:h.version,code:c.code,internalCode:c.internalCode,duration:$,didExecute:c.didExecute,clientTargetPlatform:w}),c.code==="Success")return!0;throw new E(c.code)}};e.$hq=l,e.$hq=l=$e([ie(0,P.$7j),ie(1,L.$6l)],l)}),define(re[41],oe([0,1,27,3,69,71,21]),function(Q,e,N,A,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0,e.$sp=h,e.$tp=b,e.$up=y,e.$vp=w,e.$wp=R,e.$xp=c,e.$yp=$,e.$zp=f;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$lp=E;class l{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$mp=l,e.$np=new l;class a{async publicLog(r,t,i){}async publicLogError(r,t,i){}}e.$op=a,e.$pp="telemetry",e.$qp="extensionTelemetryLog",e.$rp={log:()=>null,flush:()=>Promise.resolve(null)};function h(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}function b(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function y(n){const r=n.getValue(D.$bm),t=n.getValue(D.$cm);if(n.getValue(D.$dm)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(n){const r={},t={},i={};d(n,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(n){if(!n)return"none";const r=(0,P.$Mm)(n);return p.has(r)?r:"other"}function d(n,r,t=0,i){if(n)for(const s of Object.getOwnPropertyNames(n)){const o=n[s],u=i?i+s:s;Array.isArray(o)?r[u]=(0,N.$_n)(o):o instanceof Date?r[u]=o.toISOString():(0,A.$cg)(o)?t<2?d(o,r,t+1,u+"."):r[u]=(0,N.$_n)(o):r[u]=o}}function c(n,r){const t=n.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,L.$kp)(t)||i}function $(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function m(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let t=n;const i=[];for(const S of r)for(;;){const k=S.exec(n);if(!k)break;i.push([k.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(t="";;){const S=o.exec(n);if(!S)break;const k=i.some(([I,j])=>S.index<j&&I<o.lastIndex);!s.test(S[0])&&!k&&(t+=n.substring(u,S.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<n.length&&(t+=n.substr(u)),t}function g(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(n))return`<REDACTED: ${t.label}>`;return n}function f(n,r){return(0,N.$9n)(n,t=>{if(t instanceof E||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let i=t.replaceAll("%20"," ");i=m(i,r);for(const s of r)i=i.replace(s,"");return i=g(i),i}})}}),define(re[26],oe([0,1,31,20,37,12,11,9,35,41]),function(Q,e,N,A,P,L,D,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Bp=void 0,e.$Ap=h,e.$Cp=p,e.$Dp=R,e.$Ep=d,e.$Fp=c,e.$Gp=$,e.$Hp=m,e.$Ip=g,e.$Kp=f,e.$Lp=r;function h(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,N.$wf)(t.id,i.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,s,o)}static parse(i){const s=b.exec(i);return s&&s[1]&&s[2]?new y({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.identifier=i,this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?h(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Bp=y;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(t){const i=w.exec(t);return i&&i[1]?[d(i[1]),i[2]]:[d(t),void 0]}function R(t,i){return`${t}.${i}`}function d(t){return t.toLowerCase()}function c(t,i){return d(R(t??P.$Rm,i))}function $(t,i){const s=[],o=u=>{for(const S of s)if(S.some(k=>h(i(k),i(u))))return S;return null};for(const u of t){const S=o(u);S?S.push(u):s.push([u])}return s}function m(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function g(t){return{id:new a.$lp(t.identifier.id),name:new a.$lp(t.name),version:t.version,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Jp=new P.$Vm("pprice.better-merge");function f(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&s.every(S=>!h(S.identifier,{id:u}))){const S=t.filter(k=>h(k.identifier,{id:u}));S.length===1&&(s.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function n(t,i){if(!L.$k)return!1;let s;try{s=(await t.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){i.debug("Error while getting the os-release file.",(0,E.$0)(u))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,A.$8o)(s?"alpine":L.$u,l.$ec);return i.debug("ComputeTargetPlatform:",o),o}}),define(re[147],oe([0,1,22,9,15,17,44,11,99,20,26,37]),function(Q,e,N,A,P,L,D,E,l,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;const y=R=>(0,l.localize)(0,null,R),w=(0,l.localize)(1,null,"ms-dotnettools.csharp");let p=class{constructor(d,c,$){this.a=d,this.b=c,this.d=$}get f(){}async listExtensions(d,c,$){let m=await this.b.getInstalled(1,$);const g=b.$Um.map(n=>n.toLowerCase());if(c&&c!==""){if(g.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(n=>n.manifest.categories?n.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),g.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,l.localize)(2,null,this.f)),m=m.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let f;for(const n of m)f!==n.identifier.id&&(f=n.identifier.id,this.a.info(d?`${f}@${n.manifest.version}`:f))}async installExtensions(d,c,$,m){const g=[];try{d.length&&this.a.info(this.f?(0,l.localize)(3,null,this.f):(0,l.localize)(4,null));const f=[],n=[],r=(i,s,o)=>{n.push({id:i,version:s!=="prerelease"?s:void 0,installOptions:{...$,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||$.installPreReleaseVersion}})};for(const i of d)if(i instanceof E.URI)f.push({vsix:i,installOptions:$});else{const[s,o]=(0,h.$Cp)(i);r(s,o,!1)}for(const i of c)if(i instanceof E.URI)f.push({vsix:i,installOptions:{...$,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,h.$Cp)(i);r(s,o,!0)}const t=await this.b.getInstalled(void 0,$.profileLocation);if(f.length&&await Promise.all(f.map(async({vsix:i,installOptions:s})=>{try{await this.h(i,s,m,t)}catch(o){this.a.error(o),g.push(i.toString())}})),n.length){const i=await this.g(n,t,m);g.push(...i)}}catch(f){throw this.a.error((0,l.localize)(5,null,(0,A.$0)(f))),f}if(g.length)throw new Error((0,l.localize)(6,null,g.join(", ")))}async updateExtensions(d){const c=await this.b.getInstalled(1,d),$=[];for(const n of c)n.identifier.uuid&&$.push({...n.identifier,preRelease:n.preRelease});this.a.trace((0,l.localize)(7,null,$.length));const m=await this.d.getExtensions($,{compatible:!0},N.CancellationToken.None),g=[];for(const n of m)for(const r of c)(0,h.$Ap)(r.identifier,n.identifier)&&(0,D.gt)(n.version,r.manifest.version)&&g.push({extension:n,options:{operation:3,installPreReleaseVersion:r.preRelease,profileLocation:d}});if(!g.length){this.a.info((0,l.localize)(8,null));return}this.a.info((0,l.localize)(9,null,g.map(n=>n.extension.identifier.id).join(", ")));const f=await this.b.installGalleryExtensions(g);for(const n of f)n.error?this.a.error((0,l.localize)(10,null,n.identifier.id,(0,A.$0)(n.error))):this.a.info((0,l.localize)(11,null,n.identifier.id,n.local?.manifest.version))}async g(d,c,$){if(d=d.filter(({id:n,version:r})=>{const t=c.find(i=>(0,h.$Ap)(i.identifier,{id:n}));if(t){if(!$&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,l.localize)(12,null,n,t.manifest.version,n)),!1;if(r&&t.manifest.version===r)return this.a.info((0,l.localize)(13,null,`${n}@${r}`)),!1}return!0}),!d.length)return[];const m=[],g=[],f=await this.j(d);if(await Promise.all(d.map(async({id:n,version:r,installOptions:t})=>{const i=f.get(n.toLowerCase());if(!i){this.a.error(`${y(r?`${n}@${r}`:n)}
${w}`),m.push(n);return}try{const o=await this.d.getManifest(i,N.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),m.push(n);return}const s=c.find(o=>(0,h.$Ap)(o.identifier,i.identifier));if(s){if(i.version===s.manifest.version){this.a.info((0,l.localize)(14,null,r?`${n}@${r}`:n));return}this.a.info((0,l.localize)(15,null,n,i.version))}t.isBuiltin?this.a.info(r?(0,l.localize)(16,null,n,r):(0,l.localize)(17,null,n)):this.a.info(r?(0,l.localize)(18,null,n,r):(0,l.localize)(19,null,n)),g.push({extension:i,options:{...t,installGivenVersion:!!r}})})),g.length){const n=await this.b.installGalleryExtensions(g);for(const r of n)r.error?(this.a.error((0,l.localize)(20,null,r.identifier.id,(0,A.$0)(r.error))),m.push(r.identifier.id)):this.a.info((0,l.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return m}async h(d,c,$,m){const g=await this.b.getManifest(d);if(!g)throw new Error("Invalid vsix");if(await this.l(g,$,c.profileLocation,m))try{await this.b.install(d,c),this.a.info((0,l.localize)(22,null,(0,L.$$g)(d)))}catch(n){if((0,A.$4)(n))this.a.info((0,l.localize)(23,null,(0,L.$$g)(d)));else throw n}}async j(d){const c=new Map,$=d.some(f=>f.installOptions.installPreReleaseVersion),m=await this.b.getTargetPlatform(),g=[];for(const f of d)a.$Zo.test(f.id)&&g.push({...f,preRelease:$});if(g.length){const f=await this.d.getExtensions(g,{targetPlatform:m},N.CancellationToken.None);for(const n of f)c.set(n.identifier.id.toLowerCase(),n)}return c}k(d){return!0}async l(d,c,$,m){if(!c){const g={id:(0,h.$Fp)(d.publisher,d.name)},f=m.find(n=>(0,h.$Ap)(g,n.identifier)&&(0,D.gt)(n.manifest.version,d.version));if(f)return this.a.info((0,l.localize)(24,null,f.identifier.id,f.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,c,$){const m=async f=>{if(f instanceof E.URI){const n=await this.b.getManifest(f);return(0,h.$Dp)(n.publisher,n.name)}return f},g=[];for(const f of d){const n=await m(f),t=(await this.b.getInstalled(void 0,$)).filter(i=>(0,h.$Ap)(i.identifier,{id:n}));if(!t.length)throw new Error(`${this.m(n)}
${w}`);if(t.some(i=>i.type===0)){this.a.info((0,l.localize)(25,null,n));return}if(!c&&t.some(i=>i.isBuiltin)){this.a.info((0,l.localize)(26,null,n));return}this.a.info((0,l.localize)(27,null,n));for(const i of t)await this.b.uninstall(i,{profileLocation:$}),g.push(i);this.f?this.a.info((0,l.localize)(28,null,n,this.f)):this.a.info((0,l.localize)(29,null,n))}}async locateExtension(d){const c=await this.b.getInstalled();d.forEach($=>{c.forEach(m=>{if(m.identifier.id===$&&m.location.scheme===P.Schemas.file){this.a.info(m.location.fsPath);return}})})}m(d){return this.f?(0,l.localize)(30,null,d,this.f):(0,l.localize)(31,null,d)}};e.$iq=p,e.$iq=p=$e([ie(1,a.$cp),ie(2,a.$_o)],p)}),define(re[148],oe([0,1,5,2,30,26,37]),function(Q,e,N,A,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class E extends A.$Uc{constructor(a,h,b,y,w,p,R){super(),this.f=a,this.g=h,this.h=b,this.j=y,this.m=w,this.n=p,this.r=R,this.a=this.B(new N.$he),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$4c),this.s().then(null,d=>R.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(h=>(this.c.set(h.id,(0,A.$Rc)(this.n.watch(this.m.extUri.dirname(h.extensionsResource)),this.n.watch(h.extensionsResource))),this.G(h.extensionsResource))))}catch(h){throw this.r.error(h),h}}async w(a){for(const h of a.extensions)this.I(this.L(h.identifier,h.version),a.profileLocation)}async y(a){for(const h of a.extensions){const b=this.L(h.identifier,h.version);a.error?this.J(b,a.profileLocation):this.I(b,a.profileLocation)}}async z(a){for(const h of a.extensions)this.J(this.L(h.identifier,h.version),a.profileLocation)}async C(a){const h=[],b=[];for(const y of a.extensions){const w=this.L(y.identifier,y.version);a.error?this.I(w,a.profileLocation):(this.J(w,a.profileLocation),this.b.has(w)||(this.r.debug("Extension is removed from all profiles",y.identifier.id,y.version),b.push(this.f.scanInstalledExtensionAtLocation(y.location).then(p=>{p?h.push(p):this.r.info("Extension not found at the location",y.location.toString())},p=>this.r.error(p)))))}try{await Promise.all(b),h.length&&await this.H(h)}catch(y){this.r.error(y)}}D(a){for(const h of this.h.profiles)a.contains(h.extensionsResource,0,1)&&this.F(h.extensionsResource)}async F(a){const h=[],b=[],y=await this.j.scanProfileExtensions(a),w=new Set,p=new Set;for(const[R,d]of this.b)d.has(a)&&p.add(R);for(const R of y){const d=this.L(R.identifier,R.version);w.add(d),p.has(d)||(h.push(R.identifier),this.I(d,a))}for(const R of p)if(!w.has(R)){const d=this.M(R);d&&(b.push(d.identifier),this.J(R,a))}(h.length||b.length)&&this.a.fire({added:h.length?{extensions:h,profileLocation:a}:void 0,removed:b.length?{extensions:b,profileLocation:a}:void 0})}async G(a){const h=await this.j.scanProfileExtensions(a);for(const b of h)this.I(this.L(b.identifier,b.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.L(b.identifier,b.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,h){let b=this.b.get(a);b||this.b.set(a,b=new P.$Bc(y=>this.m.extUri.getComparisonKey(y))),b.add(h)}J(a,h){const b=this.b.get(a);b&&b.delete(h),b?.size||this.b.delete(a)}L(a,h){return`${D.$Vm.toKey(a.id)}@${h}`}M(a){const[h,b]=(0,L.$Cp)(a);return b?{identifier:{id:h},version:b}:void 0}}e.$Jq=E}),define(re[149],oe([0,1,120,41]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=P;async function P(L,D,E,l,a,h,b){const y={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${D.nameShort})`};if((0,A.$sp)(D,E)&&(0,A.$up)(l)===3){const w=await(0,N.$aq)(E,a,h);y["X-Market-User-Id"]=w,y["VSCode-SessionId"]=b.machineId||w}return y}}),define(re[150],oe([0,1,176,19,8,2,15,16,25,18,20,26,6,66,11]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;let R=class extends w.$Yr{constructor(m,g,f,n){super(f),this.h=m,this.j=n,this.g=this.B(new d(g,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(m,g){const n=(await this.g.getLanguagePacks())[g];if(!n){this.j.warn(`No language pack found for ${g}`);return}const r=n.translations[m];return r?p.URI.file(r):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),g=Object.keys(m).map(f=>{const n=m[f];return{...this.f(f,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((f,n)=>f.label.localeCompare(n.label)),g}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const g=await this.g.getLanguagePacks();Object.keys(g).some(f=>g[f]&&g[f].extensions.some(n=>(0,b.$Ap)(n.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),f=await this.g.update(g);return!(0,A.$ub)(Object.keys(m),Object.keys(f))}};e.$Zr=R,e.$Zr=R=$e([ie(0,h.$cp),ie(1,a.$Ii),ie(2,h.$_o),ie(3,y.$7j)],R);let d=class extends L.$Uc{constructor(m,g){super(),this.j=g,this.c={},this.f=(0,E.$jc)(m.userDataPath,"languagepacks.json"),this.g=new P.$Hh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(g=>{Object.keys(g).forEach(f=>delete g[f]),this.m(g,...m)}).then(()=>this.c)}m(m,...g){for(const f of g)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.n(m,f);Object.keys(m).forEach(f=>this.r(m[f]))}n(m,g){const f=g.identifier,n=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const r of n)if(g.location.scheme===D.Schemas.file&&c(r)){let t=m[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=t);const i=t.extensions.filter(s=>(0,b.$Ap)(s.extensionIdentifier,f))[0];i?i.version=g.manifest.version:t.extensions.push({extensionIdentifier:f,version:g.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,E.$jc)(g.location.fsPath,s.path)}}r(m){if(m){const g=(0,N.createHash)("md5");for(const f of m.extensions)g.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=g.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let g=null;return l.Promises.readFile(this.f,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(g=m(f),f)).then(f=>{for(const r of Object.keys(f))f[r]||delete f[r];this.c=f,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),l.Promises.writeFile(this.f,n)}).then(()=>g,f=>this.j.error(f))})}};d=$e([ie(0,a.$Ii),ie(1,y.$7j)],d);function c($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const m of $.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(re[151],oe([0,1,87,9,27,41]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",E="https://mobile.events.data.microsoft.com/ping";async function l(h,b,y){const w=await(0,N.$bE)("@microsoft/1ds-core-js","dist/ms.core.js"),p=await(0,N.$bE)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new w.AppInsightsCore,d=new p.PostChannel,c={instrumentationKey:h,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(y){c.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:y};c.extensionConfig[d.identifier]=$}return R.initialize(c,[]),R.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),R}class a{constructor(b,y,w,p,R){this.e=b,this.f=y,this.g=w,this.h=R,this.c=D,this.d=E,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(b){if(this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=l(this.a,this.e,this.h)),this.b.then(y=>{b(y)},y=>{(0,A.$1)(y),console.error(y)})}}log(b,y){if(!this.a)return;y=(0,P.$0n)(y,this.g),y=(0,L.$vp)(y);const w=this.f+"/"+b;try{this.i(p=>{p.pluginVersionString=y?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.$5P=a}),define(re[152],oe([0,1,2,27,12,31,112,29,40,153,32,36,21,41]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0;let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,$,m){this.k=$,this.l=m,this.d={},this.i=new N.$Tc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,L.$df)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$df)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(y.$bm)||g.affectsConfiguration(y.$dm)||g.affectsConfiguration(y.$cm))&&this.m()}))}setExperimentProperty(c,$){this.d[c]=$}m(){let c=(0,w.$up)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const m=$.usage?3:$.error?2:0;c=Math.min(c,m)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,$,m){this.g<$||(m=(0,A.$0n)(m,this.d),m=(0,w.$zp)(m,this.j),m=(0,A.$0n)(m,this.c),this.b.forEach(g=>g.log(c,m)))}publicLog(c,$){this.n(c,3,$)}publicLog2(c,$){this.publicLog(c,$)}publicLogError(c,$){this.h&&this.n(c,2,$)}publicLogError2(c,$){this.publicLogError(c,$)}};e.$6r=p,e.$6r=p=$e([ie(1,E.$7i),ie(2,h.$nk)],p);function R(){const d=(0,D.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=P.$o?"":(0,D.localize)(3,null),m=(0,D.localize)(4,null),g=(0,D.localize)(5,null),f=(0,D.localize)(6,null),n=(0,D.localize)(7,null),r=`
|       | ${m} | ${g} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,D.localize)(8,null);return`
${d} ${c} ${$}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}b.$ho.as(l.$mo.Configuration).registerConfiguration({id:y.$am,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[y.$bm]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:R(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$ho.as(l.$mo.Configuration).registerConfiguration({id:y.$am,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.$dm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,D.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,D.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.$bm}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[154],oe([0,1,14,22,177,151]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=void 0;async function D(h,b){const y=await b.request(h,A.CancellationToken.None),w=(await(0,N.$Ve)(y.stream)).toString(),p=y.res.statusCode??200;return{headers:y.res.headers,statusCode:p,responseData:w}}async function E(h){const b={method:h.type,headers:h.headers};return new Promise((w,p)=>{const R=P.request(h.url??"",b,d=>{d.on("data",function(c){w({headers:d.headers,statusCode:d.statusCode??200,responseData:c.toString()})}),d.on("error",function(c){p(c)})});R.write(h.data,d=>{d&&p(d)}),R.end()})}async function l(h,b,y){const w=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),p={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:w};try{const R=h?await D(p,h):await E(p);y(R.statusCode,R.headers,R.responseData)}catch{y(0,{})}}class a extends L.$5P{constructor(b,y,w,p,R){const d={sendPOST:(c,$)=>{l(b,c,$)}};super(y,w,p,R,d)}}e.$6P=a}),define(re[155],oe([0,1,16,25]),function(Q,e,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=P;async function P(L,D){const E=Object.create(null),l=(h,b)=>{const y=JSON.parse(h);E[b]=y};if(D){const h=[],b=await A.Promises.readdir(D);for(const w of b)try{(await A.Promises.stat((0,N.$jc)(D,w))).isDirectory()&&h.push(w)}catch{}const y=[];for(const w of h)(await A.Promises.readdir((0,N.$jc)(D,w))).filter(R=>R==="telemetry.json").length===1&&y.push(w);for(const w of y){const p=(await A.Promises.readFile((0,N.$jc)(D,w,"telemetry.json"))).toString();l(p,w)}}let a=(await A.Promises.readFile((0,N.$jc)(L,"telemetry-core.json"))).toString();return l(a,"vscode-core"),a=(await A.Promises.readFile((0,N.$jc)(L,"telemetry-extensions.json"))).toString(),l(a,"vscode-extensions"),JSON.stringify(E,null,4)}}),define(re[156],oe([0,1,12,88,21]),function(Q,e,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=L,e.$rec=D;async function L(E,l){let a=E.getItem(P.$$l);return(typeof a!="string"||N.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,A.$Jn)(l.error.bind(l))),a}async function D(E,l){let a=E.getItem(P.$_l);return typeof a!="string"&&(a=await(0,A.$Kn)(l.error.bind(l))),a}}),define(re[23],oe([0,1,10]),function(Q,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,N.$Ai)("IUriIdentityService")}),define(re[157],oe([0,1,23,121,13,17,79,5,2]),function(Q,e,N,A,P,L,D,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class a{static{this._clock=0}constructor(y){this.uri=y,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let h=class{constructor(y){this.g=y,this.c=new l.$Tc,this.f=2**16;const w=new Map,p=R=>{let d=w.get(R.scheme);return d===void 0&&(d=y.hasProvider(R)&&!this.g.hasCapability(R,1024),w.set(R.scheme,d)),d};this.c.add(E.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(R=>{w.delete(R.scheme)})),this.extUri=new L.$3g(p),this.d=new D.$Fs((R,d)=>this.extUri.compare(R,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,L.$ch)(y));const w=this.d.get(y);return w?w.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new a(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((p,R)=>p[1].time<R[1].time?1:p[1].time>R[1].time?-1:0);a._clock=0,this.d.clear();const w=this.f*.5;for(let p=0;p<w;p++)this.d.set(y[p][0],y[p][1].touch())}};e.$Gs=h,e.$Gs=h=$e([ie(0,P.$7k)],h),(0,A.$Ds)(N.$El,h,1)}),define(re[158],oe([0,1,5,2,13,48,30]),function(Q,e,N,A,P,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class E extends A.$Uc{constructor(a,h,b,y,w,p){super(),this.f=a,this.g=h,this.h=b,this.j=y,this.m=w,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new N.$he),this.onDidChangeFile=this.a.event,this.b=L.$Gi.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,h){return this.g.open(this.t(a),h)}close(a){return this.g.close(a)}read(a,h,b,y,w){return this.g.read(a,h,b,y,w)}write(a,h,b,y,w){return this.g.write(a,h,b,y,w)}watch(a,h){this.b.set(a,a);const b=this.g.watch(this.t(a),h);return(0,A.$Sc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,h,b){return this.g.rename(this.t(a),this.t(h),b)}readFile(a,h){return this.g.readFile(this.t(a),h)}readFileStream(a,h,b){return this.g.readFileStream(this.t(a),h,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,h,b){return this.g.writeFile(this.t(a),h,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,h){return this.g.delete(this.t(a),h)}copy(a,h,b){if((0,P.$$k)(this.g))return this.g.copy(this.t(a),this.t(h),b);throw new Error("copy not supported")}cloneFile(a,h){if((0,P.$_k)(this.g))return this.g.cloneFile(this.t(a),this.t(h));throw new Error("clone not supported")}s(a){const h=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const y=this.u(b.resource);this.b.findSubstr(y)&&h.push({resource:y,type:b.type,cId:b.cId})}h.length&&(this.n.debug("User data changed"),this.a.fire(h))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Oec=E}),define(re[159],oe([0,1,114,16,48,17,11,10,15]),function(Q,e,N,A,P,L,D,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=a,e.$Li=h,e.$Oi=b,e.$Pi=y,e.$Qi=w,e.$Ri=R,e.$Si=d,e.$Vi=m,e.$1i=g,e.$2i=f,e.$4i=n,e.$5i=r,e.$6i=t,e.$Ji=(0,E.$Ai)("contextService");function a(i){const s=i;return typeof s?.id=="string"&&D.URI.isUri(s.uri)}function h(i){return typeof i?.id=="string"&&!a(i)&&!y(i)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function b(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.$nc)(i)}:s?e.$Mi:e.$Ni;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function y(i){const s=i;return typeof s?.id=="string"&&D.URI.isUri(s.configPath)}function w(i){const s=i;if(s?.uri)return{id:s.id,uri:D.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function R(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function d(i){const s=i;return!!(s&&typeof s=="object"&&D.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,u,S,k){this.h=s,this.j=u,this.k=S,this.l=k,this.c=P.$Gi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=P.$Gi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=c;class ${constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.$bh)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=$;function m(i){return new $({uri:i,index:0,name:(0,L.$0g)(i)},{uri:i.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,N.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function g(i,s){return L.$5g.isEqualOrParent(i,s.untitledWorkspacesHome)}function f(i){let s;return D.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===l.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.$3i}function r(i,s){return!g(i,s)&&!f(i)}function t(i){return(typeof i=="string"?(0,A.$oc)(i):(0,L.$_g)(i))===e.$Xi}}),define(re[24],oe([0,1,43,5,2,17,11,113,18,13,10,6,159,30,23,8,28,31,3]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=g,e.$Hl=f,e.$Il=n;var m;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function g(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&D.URI.isUri(s.location)&&D.URI.isUri(s.globalStorageHome)&&D.URI.isUri(s.settingsResource)&&D.URI.isUri(s.keybindingsResource)&&D.URI.isUri(s.tasksResource)&&D.URI.isUri(s.snippetsHome)&&D.URI.isUri(s.extensionsResource))}e.$Gl=(0,h.$Ai)("IUserDataProfilesService");function f(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:s}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function n(i,s,o,u,S,k){return{id:i,name:s,location:o,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:k&&S?.useDefaultFlags?.globalState?k.globalStorageHome:(0,L.$bh)(o,"globalStorage"),settingsResource:k&&S?.useDefaultFlags?.settings?k.settingsResource:(0,L.$bh)(o,"settings.json"),keybindingsResource:k&&S?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,L.$bh)(o,"keybindings.json"),tasksResource:k&&S?.useDefaultFlags?.tasks?k.tasksResource:(0,L.$bh)(o,"tasks.json"),snippetsHome:k&&S?.useDefaultFlags?.snippets?k.snippetsHome:(0,L.$bh)(o,"snippets"),extensionsResource:k&&S?.useDefaultFlags?.extensions?k.extensionsResource:(0,L.$bh)(o,"extensions.json"),cacheHome:(0,L.$bh)(u,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,u,S){super(),this.t=s,this.u=o,this.w=u,this.y=S,this.f=!0,this.h=this.B(new A.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,$.$ag)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}o.push(n((0,L.$$g)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},s))}}catch(k){this.y.error(k)}const u=new w.$Ac,S=new Map;if(o.length)try{const k=this.Q();if(k.workspaces)for(const[I,j]of Object.entries(k.workspaces)){const F=D.URI.parse(I),B=o.find(J=>J.id===j);B&&u.set(F,B)}if(k.emptyWindows)for(const[I,j]of Object.entries(k.emptyWindows)){const F=o.find(B=>B.id===j);F&&S.set(I,F)}}catch(k){this.y.error(k)}this.z={profiles:o,workspaces:u,emptyWindows:S}}return this.z}D(){const s=n("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",u=new RegExp(`${(0,c.$df)(o)}\\s(\\d+)`);let S=0;for(const I of this.profiles){const j=u.exec(I.name),F=j?parseInt(j[1]):0;S=F>S?F:S}const k=`${o} ${S+1}`;return this.createProfile((0,N.$oj)((0,d.$Wg)()).toString(16),k,{transient:!0},s)}async createNamedProfile(s,o,u){return this.createProfile((0,N.$oj)((0,d.$Wg)()).toString(16),s,o,u)}async createProfile(s,o,u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(s,o,u);return S&&await this.setProfileForWorkspace(S,k),k}async F(s,o,u){if(!(0,$.$ag)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(o);return S||(S=(async()=>{try{if(this.profiles.find(F=>F.name===o||F.id===s))throw new Error(`Profile with ${o} name already exists`);const I=n(s,o,(0,L.$bh)(this.profilesHome,s),this.g,u,this.defaultProfile);await this.u.createFolder(I.location);const j=[];return this.j.fire({profile:I,join(F){j.push(F)}}),await R.Promises.settled(j),this.I([I],[],[]),I}finally{this.r.delete(o)}})(),this.r.set(o,S)),S}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(S=>S.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=n(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,icon:o.icon===null?void 0:o.icon??u.icon,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(S=>S.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this.m.fire({profile:o,join(S){u.push(S)}});try{await Promise.allSettled(u)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(S){(0,a.$ll)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(S=>S.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,u)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return D.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,y.$Ki)(s)?s.uri:(0,y.$Pi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,u){const S=[...this.profiles,...s],k=[];this.s.profiles=[];for(let I of S)I.isDefault||o.some(j=>I.id===j.id)||(I=u.find(j=>I.id===j.id)??I,I.isTransient?this.s.profiles.push(I):k.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(k),this.z=void 0,this.J(s,o,u)}J(s,o,u){this.h.fire({added:s,removed:o,updated:u,all:this.profiles})}L(s,o,u){u=o?.isTransient?!0:u,u||this.L(s,void 0,!0);const S=this.G(s),k=u?this.s:this.C;D.URI.isUri(S)?(k.workspaces.delete(S),o&&k.workspaces.set(S,o)):(k.emptyWindows.delete(S),o&&k.emptyWindows.set(S,o)),u||this.M()}M(){const s={};for(const[u,S]of this.C.workspaces.entries())s[u.toString()]=S.id;const o={};for(const[u,S]of this.C.emptyWindows.entries())o[u.toString()]=S.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},u=this.D();if(s.workspaces)for(const[k,I]of Object.entries(s.workspaces)){const j=D.URI.parse(I);o[k]=this.w.extUri.isEqual(j,u.location)?u.id:this.w.extUri.basename(j)}const S={};if(s.emptyWindows)for(const[k,I]of Object.entries(s.emptyWindows)){const j=D.URI.parse(I);S[k]=this.w.extUri.isEqual(j,u.location)?u.id:this.w.extUri.basename(j)}return{workspaces:o,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Jl=r,e.$Jl=r=$e([ie(0,l.$Hi),ie(1,a.$7k),ie(2,p.$El),ie(3,b.$7j)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Kl=t}),define(re[53],oe([0,1,19,8,22,9,5,2,12,3,11,97,20,26,37,6,32,21,23,24]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$rq=void 0,e.$sq=f;let g=class extends E.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,s,o,u,S,k){super(),this.z=i,this.C=s,this.D=o,this.F=u,this.G=S,this.H=k,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$he),this.s=this.B(new D.$he),this.t=this.B(new D.$he),this.u=this.B(new D.$he),this.w=this.B(new D.$he),this.y=[],this.B((0,E.$Sc)(()=>{this.j.forEach(({task:I})=>I.cancel()),this.m.forEach(I=>I.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,y.$0o)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{const u=(await this.installGalleryExtensions([{extension:i,options:s}])).find(({identifier:S})=>(0,w.$Ap)(S,i.identifier));if(u?.local)return u?.local;throw u?.error?u.error:new y.$bp(`Unknown error while installing extension ${i.identifier.id}`,"Unknown")}catch(o){throw f(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new y.$bp(b.localize(0,null),"NotAllowed");const s=[],o=[];return await Promise.allSettled(i.map(async({extension:u,options:S})=>{try{const k=await this.N(u,!!S?.installGivenVersion,!!S?.installPreReleaseVersion,S.productVersion??{version:this.G.version,date:this.G.date});o.push({...k,options:S})}catch(k){s.push({identifier:u.identifier,operation:2,source:u,error:k})}})),o.length&&s.push(...await this.I(o)),s}async uninstall(i,s={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,s)}async toggleAppliationScope(i,s){if((0,p.$Ym)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,s));for(const u of this.H.profiles){const S=(await this.getInstalled(1,u.extensionsResource)).find(k=>(0,w.$Ap)(k.identifier,i.identifier));S?this.w.fire(S):this.u.fire({identifier:i.identifier,profileLocation:u.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,s,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const s=new Map,o=new Map,u=[],S=(I,j)=>`${w.$Bp.create(I).toString()}-${j.toString()}`,k=(I,j,F,B)=>{const J=this.Y(I,j,F),ne=`${(0,w.$Fp)(I.publisher,I.name)}-${F.profileLocation.toString()}`;o.set(ne,{task:J,root:B}),this.n.fire({identifier:J.identifier,source:j,profileLocation:F.profileLocation}),this.F.info("Installing extension:",J.identifier.id,F.profileLocation.toString()),h.URI.isUri(j)||this.j.set(S(j,F.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:I,extension:j,options:F}of i){const B=F.isApplicationScoped||F.isBuiltin||(0,p.$Ym)(I),J={...F,installOnlyNewlyAddedFromExtensionPack:F.installOnlyNewlyAddedFromExtensionPack??!h.URI.isUri(j),isApplicationScoped:B,profileLocation:B?this.H.defaultProfile.extensionsResource:F.profileLocation??this.X(),productVersion:F.productVersion??{version:this.G.version,date:this.G.date}},ne=h.URI.isUri(j)?void 0:this.j.get(S(j,J.profileLocation));ne?(this.F.info("Extension is already requested to install",ne.task.identifier.id,J.profileLocation.toString()),u.push(ne.task.waitUntilTaskIsFinished())):k(I,j,J,void 0)}return await Promise.all([...o.values()].map(async({task:I})=>{if(I.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",I.identifier.id);else try{const j=await this.M(I.identifier,I.manifest,!!I.options.installOnlyNewlyAddedFromExtensionPack,!!I.options.installPreReleaseVersion,I.options.profileLocation,I.options.productVersion),F=await this.getInstalled(void 0,I.options.profileLocation,I.options.productVersion),B={...I.options,context:{...I.options.context,[y.$4o]:!0}};for(const{gallery:J,manifest:ne}of(0,N.$Mb)(j,({gallery:te})=>te.identifier.id)){if(o.has(`${J.identifier.id.toLowerCase()}-${B.profileLocation.toString()}`))continue;const te=this.j.get(S(J,B.profileLocation));if(te){if(this.J(I,te.task)){const le=te.task.identifier;this.F.info("Waiting for already requested installing extension",le.id,I.identifier.id,B.profileLocation.toString()),te.waitingTasks.push(I),u.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,ce=>ce.some(ae=>(0,w.$Ap)(ae.identifier,le)))).then(ce=>{if(this.F.info("Finished waiting for already requested installing extension",le.id,I.identifier.id,B.profileLocation.toString()),!ce.find(W=>(0,w.$Ap)(W.identifier,le))?.local)throw new Error(`Extension ${le.id} is not installed`)}))}}else F.some(({identifier:le})=>(0,w.$Ap)(le,J.identifier))||k(ne,J,B,I)}}catch(j){if(h.URI.isUri(I.source))(0,N.$Lb)(I.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",I.identifier.id,j.message),(0,N.$Lb)(I.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",I.identifier.id,j.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",I.identifier.id),j}})),await this.L([...o.entries()].map(async([I,{task:j}])=>{const F=new Date().getTime();let B;try{B=await j.run(),await this.L(this.y.map(J=>J.postInstall(B,j.source,j.options,P.CancellationToken.None)),"PostInstall")}catch(J){const ne=f(J);throw h.URI.isUri(j.source)||n(this.C,j.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Ip)(j.source),error:ne,source:j.options.context?.[y.$3o]}),s.set(I,{error:ne,identifier:j.identifier,operation:j.operation,source:j.source,context:j.options.context,profileLocation:j.options.profileLocation,applicationScoped:j.options.isApplicationScoped}),this.F.error("Error while installing the extension",j.identifier.id,(0,L.$0)(ne),j.options.profileLocation.toString()),ne}if(!h.URI.isUri(j.source)){const J=j.operation===3,ne=J?void 0:(new Date().getTime()-j.source.lastUpdated)/1e3;if(n(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Ip)(j.source),verificationStatus:j.verificationStatus,duration:new Date().getTime()-F,durationSinceUpdate:ne,source:j.options.context?.[y.$3o]}),l.$o&&j.operation!==3)try{await this.z.reportStatistic(B.manifest.publisher,B.manifest.name,B.manifest.version,"install")}catch{}}s.set(I,{local:B,identifier:j.identifier,operation:j.operation,source:j.source,context:j.options.context,profileLocation:j.options.profileLocation,applicationScoped:B.isApplicationScoped})})),u.length&&await this.L(u),[...s.values()]}catch(I){const j=(J,ne,te)=>{const le=[];J.manifest.extensionDependencies?.length&&le.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&le.push(...J.manifest.extensionPack);for(const ce of le){if(te.includes(ce.toLowerCase()))continue;te.push(ce.toLowerCase());const ae=s.get(`${ce.toLowerCase()}-${ne.toString()}`);ae?.local&&(te=j(ae.local,ne,te))}return te},F=J=>({identifier:J.identifier,operation:2,source:J.source,context:J.options.context,profileLocation:J.options.profileLocation,error:I}),B=[];for(const[J,{task:ne,root:te}]of o){const le=s.get(J);le?le.local&&te&&!s.get(`${te.identifier.id.toLowerCase()}-${ne.options.profileLocation.toString()}`)?.local&&(B.push(this.Z(le.local,{versionOnly:!0,profileLocation:ne.options.profileLocation})),s.set(J,F(ne))):(ne.cancel(),s.set(J,F(ne)))}for(const[J,{task:ne}]of o){const te=s.get(J);if(!te?.local||ne.options.donotIncludePackAndDependencies)continue;j(te.local,ne.options.profileLocation,[te.local.identifier.id.toLowerCase()]).slice(1).some(ce=>o.has(`${ce.toLowerCase()}-${ne.options.profileLocation.toString()}`)&&!s.get(`${ce.toLowerCase()}-${ne.options.profileLocation.toString()}`)?.local)&&(B.push(this.Z(te.local,{versionOnly:!0,profileLocation:ne.options.profileLocation})),s.set(J,F(ne)))}throw B.length&&await Promise.allSettled(B.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(ne){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,L.$0)(ne))}})),I}finally{for(const{task:I}of o.values())I.source&&!h.URI.isUri(I.source)&&this.j.delete(S(I.source,I.options.profileLocation));if(s.size){const I=[...s.values()];for(const j of I)j.local&&this.F.info("Extension installed successfully:",j.identifier.id,j.profileLocation.toString());this.s.fire(I)}}}J(i,s){for(const[,{task:o,waitingTasks:u}]of this.j.entries())if(o===i&&(u.includes(s)||u.some(S=>this.J(S,s)))||o===s&&u[0]&&!this.J(i,u[0]))return!1;return!0}async L(i,s){const o=[],u=[],S=await Promise.allSettled(i);for(const I of S)I.status==="fulfilled"?o.push(I.value):u.push(f(I.reason,s));if(!u.length)return o;if(u.length===1)throw u[0];let k=new y.$bp("","Unknown");for(const I of u)k=new y.$bp(k.message?`${k.message}, ${I.message}`:I.message,I.code!=="Unknown"&&I.code!=="Internal"?I.code:k.code);throw k}async M(i,s,o,u,S,k){if(!this.z.isEnabled())return[];const I=await this.getInstalled(void 0,S,k),j=[],F=[],B=async(J,ne)=>{j.push(J);const te=ne.extensionDependencies||[],le=[...te];if(ne.extensionPack){const ce=o?I.find(ae=>(0,w.$Ap)(ae.identifier,J)):void 0;for(const ae of ne.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(W=>(0,w.$Ap)({id:W},{id:ae}))||le.every(W=>!(0,w.$Ap)({id:W},{id:ae}))&&le.push(ae)}if(le.length){const ce=le.filter(ae=>j.every(W=>!(0,w.$Ap)(W,{id:ae})));if(ce.length){const ae=await this.z.getExtensions(ce.map(W=>({id:W,preRelease:u})),P.CancellationToken.None);for(const W of ae){if(j.find(M=>(0,w.$Ap)(M,W.identifier)))continue;const K=te.some(M=>(0,w.$Ap)({id:M},W.identifier));let x;try{x=await this.N(W,!1,u,k)}catch(M){if(K)throw M;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,L.$0)(M));continue}F.push({gallery:x.extension,manifest:x.manifest}),await B(x.extension.identifier,x.manifest)}}}};return await B(i,s),F}async N(i,s,o,u){let S;const k=await this.getExtensionsControlManifest();if(k.malicious.some(F=>(0,w.$Ap)(i.identifier,F)))throw new y.$bp(b.localize(1,null,i.identifier.id),"Malicious");const I=k.deprecated[i.identifier.id.toLowerCase()];if(I?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${I.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:I.extension.id,preRelease:I.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:u},P.CancellationToken.None))[0],!S)throw new y.$bp(b.localize(2,null,i.identifier.id,I.extension.id),"Deprecated")}else{if(!await this.canInstall(i)){const F=await this.getTargetPlatform();throw new y.$bp(b.localize(3,null,i.identifier.id,this.G.nameLong,(0,y.$6o)(F)),"IncompatibleTargetPlatform")}if(S=await this.O(i,s,o,u),!S)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],P.CancellationToken.None))[0]?new y.$bp(b.localize(4,null,i.displayName??i.identifier.id),"ReleaseVersionNotFound"):new y.$bp(b.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),"Incompatible")}this.F.info("Getting Manifest...",S.identifier.id);const j=await this.z.getManifest(S,P.CancellationToken.None);if(j===null)throw new y.$bp(`Missing manifest for extension ${S.identifier.id}`,"Invalid");if(j.version!==S.version)throw new y.$bp(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,"Invalid");return{extension:S,manifest:j}}async O(i,s,o,u){const S=await this.getTargetPlatform();let k=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(k=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:S,compatible:!0,productVersion:u},P.CancellationToken.None))[0]||null),!k&&await this.z.isExtensionCompatible(i,o,S,u)&&(k=i),k||(s?k=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:S,compatible:!0,productVersion:u},P.CancellationToken.None))[0]||null:k=await this.z.getCompatibleExtension(i,o,S,u)),k}async P(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:s.profileLocation??this.X()},u=B=>`${B.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,S=this.m.get(u(i.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),S.waitUntilTaskIsFinished();const k=B=>{const J=this.Z(B,o);return this.m.set(u(J.extension.identifier),J),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${B.identifier.id}@${B.manifest.version}`),this.t.fire({identifier:B.identifier,profileLocation:o.profileLocation,applicationScoped:B.isApplicationScoped}),J},I=(B,J)=>{J?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,o.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${B.identifier.id}@${B.manifest.version}`,J.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${B.identifier.id}@${B.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${B.identifier.id}@${B.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Hp)(B),error:J}),this.u.fire({identifier:B.identifier,error:J?.code,profileLocation:o.profileLocation,applicationScoped:B.isApplicationScoped})},j=[],F=[];try{j.push(k(i));const B=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const J=this.S(i,B);for(const ne of J)this.m.has(u(ne.identifier))?this.F.info("Extensions is already requested to uninstall",ne.identifier.id):j.push(k(ne))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(j.map(J=>J.extension),B,i),await this.L(j.map(async J=>{try{if(await J.run(),await this.L(this.y.map(ne=>ne.postUninstall(J.extension,o,P.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}I(J.extension)}catch(ne){const te=f(ne);throw I(J.extension,te),te}finally{F.push(J)}}))}catch(B){const J=f(B);for(const ne of j){try{ne.cancel()}catch{}F.includes(ne)||I(ne.extension,J)}throw J}finally{for(const B of j)this.m.delete(u(B.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",B.extension.identifier.id)}}Q(i,s,o){for(const u of i){const S=this.U(u,s);if(S.length){const k=S.filter(I=>!i.some(j=>(0,w.$Ap)(j.identifier,I.identifier)));if(k.length)throw new Error(this.R(u,k,o))}}}R(i,s,o){return o===i?s.length===1?b.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?b.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}S(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const u=i.manifest.extensionPack?i.manifest.extensionPack:[];if(u.length){const S=s.filter(I=>!I.isBuiltin&&u.some(j=>(0,w.$Ap)({id:j},I.identifier))),k=[];for(const I of S)k.push(...this.S(I,s,o));return[...S,...k]}return[]}U(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(u=>(0,w.$Ap)({id:u},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$rq=g,e.$rq=g=$e([ie(0,y.$_o),ie(1,c.$6l),ie(2,$.$El),ie(3,R.$7j),ie(4,d.$nk),ie(5,m.$Gl)],g);function f(t,i){if(t instanceof y.$bp)return t;let s;return t instanceof y.$ap?s=new y.$bp(t.message,t.code==="DownloadFailedWriting"?"DownloadFailedWriting":"Gallery"):s=new y.$bp(t.message,(0,L.$4)(t)?"Cancelled":i??"Internal"),s.stack=t.stack,s}function n(t,i,{extensionData:s,verificationStatus:o,duration:u,error:S,source:k,durationSinceUpdate:I}){let j,F;(0,a.$ig)(o)&&(o===!0?o="Verified":(o===!1||(j="Signature",F=o),o="Unverified")),S&&(j=S.code,S.code==="Signature"&&(F=S.message)),t.publicLog(i,{...s,verificationStatus:o,success:!S,duration:u,errorcode:j,errorcodeDetail:F,durationSinceUpdate:I,source:k})}class r{constructor(){this.d=new A.$zh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,A.$nh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$nh)(i=>new Promise((s,o)=>{const u=i.onCancellationRequested(()=>{u.dispose(),o(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$tq=r}),define(re[42],oe([0,1,8,14,2,5,30,11,20,26,13,10,6,24,23,3,9,21]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class m extends Error{constructor(t,i){super(t),this.code=i}}e.$uq=m,e.$vq=(0,b.$Ai)("IExtensionsProfileScannerService");let g=class extends P.$Uc{constructor(t,i,s,o,u,S){super(),this.j=t,this.m=i,this.n=s,this.r=o,this.s=u,this.t=S,this.b=this.B(new L.$he),this.onAddExtensions=this.b.event,this.c=this.B(new L.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$he),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i,s){const o=[],u=[];try{return await this.u(i,S=>{const k=[];if(s)k.push(...S);else for(const I of S)t.some(([j])=>(0,a.$Ap)(j.identifier,I.identifier)&&j.manifest.version!==I.version)?o.push(I):k.push(I);for(const[I,j]of t){const F=k.findIndex(J=>(0,a.$Ap)(J.identifier,I.identifier)&&J.version===I.manifest.version),B={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:j};F===-1?(u.push(B),k.push(B)):k.splice(F,1,B)}return u.length&&this.b.fire({extensions:u,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),k}),u.length&&this.c.fire({extensions:u,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),u}catch(S){throw u.length&&this.c.fire({extensions:u,error:S,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:S,profileLocation:i}),S}}async updateMetadata(t,i){const s=[];return await this.u(i,o=>{const u=[];for(const S of o){const k=t.find(([I])=>(0,a.$Ap)(I.identifier,S.identifier)&&I.manifest.version===S.version);k&&(S.metadata={...S.metadata,...k[1]},s.push(S)),u.push(S)}return u}),s}async removeExtensionFromProfile(t,i){const s=[];try{await this.u(i,o=>{const u=[];for(const S of o)(0,a.$Ap)(S.identifier,t.identifier)?s.push(S):u.push(S);return s.length&&this.f.fire({extensions:s,profileLocation:i}),u}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async u(t,i,s){return this.F(t).queue(async()=>{let o=[],u;try{const S=await this.m.readFile(t);u=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,h.$ll)(S)!==1)throw S;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&s?.bailOutWhenFileNotFound)throw new m((0,d.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(u){Array.isArray(u)||this.w(t);let S=!1;for(const k of u){f(k)||this.w(t);let I;if((0,R.$ag)(k.relativeLocation)&&k.relativeLocation)I=this.z(k.relativeLocation);else if((0,R.$ag)(k.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${k.location}`);continue}else{I=E.URI.revive(k.location);const j=this.y(I);j&&(S=!0,k.relativeLocation=j)}(0,R.$hg)(k.metadata?.hasPreReleaseVersion)&&k.metadata?.preRelease&&(S=!0,k.metadata.hasPreReleaseVersion=!0),o.push({identifier:k.identifier,location:I,version:k.version,metadata:k.metadata})}S&&await this.m.writeFile(t,A.$Je.fromString(JSON.stringify(u)))}if(i){o=i(o);const S=o.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.y(k.location),metadata:k.metadata}));await this.m.writeFile(t,A.$Je.fromString(JSON.stringify(S)))}return o})}w(t){const i=new m(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(u){if((0,h.$ll)(u)===1)return;throw u}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const u=JSON.parse(s);Array.isArray(u)&&u.every(S=>f(S))?o=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$Je.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,h.$ll)(u)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(t)}catch(u){(0,h.$ll)(u)!==1&&this.t.error(u)}try{await this.m.del(i)}catch(u){(0,h.$ll)(u)!==1&&this.t.error(u)}return o})()),this.C}F(t){let i=this.h.get(t);return i||(i=new N.$Hh,this.h.set(t,i)),i}};e.$wq=g,e.$wq=g=$e([ie(1,h.$7k),ie(2,w.$Gl),ie(3,p.$El),ie(4,c.$6l),ie(5,y.$7j)],g);function f(r){return(0,R.$cg)(r)&&(0,l.$$o)(r.identifier)&&(n(r.location)||(0,R.$ag)(r.location)&&r.location)&&((0,R.$hg)(r.relativeLocation)||(0,R.$ag)(r.relativeLocation))&&r.version&&(0,R.$ag)(r.version)}function n(r){return r?(0,R.$ag)(r.path)&&(0,R.$ag)(r.scheme):!1}}),define(re[54],oe([0,1,19,8,27,14,9,38,85,2,15,16,12,17,44,56,3,11,101,18,26,37,50,13,10,6,32,5,47,42,24,23,119]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c,$,m,g,f,n,r,t,i,s,o,u,S,k,I,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Bq=e.$Aq=e.$zq=e.Translations=void 0,e.$Cq=le;var F;(function(ae){function W(K,x){if(K===x)return!0;const M=Object.keys(K),G=new Set;for(const Y of Object.keys(x))G.add(Y);if(M.length!==G.size)return!1;for(const Y of M){if(K[Y]!==x[Y])return!1;G.delete(Y)}return G.size===0}ae.equals=W})(F||(e.Translations=F={})),e.$zq=(0,t.$Ai)("IExtensionsScannerService");let B=class extends a.$Uc{constructor(W,K,x,M,G,Y,U,q,V,C,v,O){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=K,this.r=x,this.s=M,this.t=G,this.u=Y,this.w=U,this.y=q,this.z=V,this.C=C,this.D=v,this.F=O,this.g=this.B(new o.$he),this.onDidChangeCache=this.g.event,this.h=(0,w.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(ne,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Lp)(this.w,this.y)),this.G}async scanAllExtensions(W,K,x){const[M,G]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(K)]),Y=x?await this.scanExtensionsUnderDevelopment(W,[...M,...G]):[];return this.L(M,G,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const K=[];K.push(this.M(!!W.useCache,W.language)),K.push(this.N(W.language,!!W.checkControlFile));const[x,M]=await Promise.all(K);return this.J([...x,...M],0,W,!1)}async scanUserExtensions(W){const K=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const x=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(K,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,x,W.productVersion??this.R()),G=W.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let Y;try{Y=await G.scanExtensions(M)}catch(U){if(U instanceof S.$uq&&U.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Y=await G.scanExtensions(M);else throw U}return Y=await this.J(Y,1,W,!0),this.y.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(W,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const x=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===h.Schemas.file).map(async M=>{const G=await this.P(M,!1,1,!0,W.language,!1,void 0,W.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(G)).map(U=>(U.type=K.find(q=>(0,g.$Ap)(q.identifier,U.identifier))?.type??U.type,this.n.validate(U,G)))}))).flat();return this.J(x,"development",W,!0)}return[]}async scanExistingExtension(W,K,x){const M=await this.P(W,!1,K,!0,x.language,!0,void 0,x.productVersion??this.R()),G=await this.n.scanExtension(M);return!G||!x.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(W,K,x){const M=await this.P(W,!1,K,!0,x.language,!0,void 0,x.productVersion??this.R()),G=await this.n.scanOneOrMultipleExtensions(M);return this.J(G,K,x,!0)}async scanMultipleExtensions(W,K,x){const M=[];return await Promise.all(W.map(async G=>{const Y=await this.scanOneOrMultipleExtensions(G,K,x);M.push(...Y)})),this.J(M,K,x,!0)}async scanMetadata(W){const K=(0,w.$bh)(W,"package.json"),x=(await this.w.readFile(K)).value.toString();return JSON.parse(x).__metadata}async updateMetadata(W,K){const x=(0,w.$bh)(W,"package.json"),M=(await this.w.readFile(x)).value.toString(),G=JSON.parse(M);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,G.__metadata={...G.__metadata,...K},await this.w.writeFile((0,w.$bh)(W,"package.json"),L.$Je.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof S.$uq&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$Je.fromString(JSON.stringify([])))}catch(K){(0,r.$ll)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,K,x,M){return x.includeAllVersions||(W=this.L(K===0?W:void 0,K===1?W:void 0,K==="development"?W:void 0,await this.getTargetPlatform(),M)),x.includeInvalid||(W=W.filter(G=>G.isValid)),W.sort((G,Y)=>{const U=b.$nc(G.location.fsPath),q=b.$nc(Y.location.fsPath);return U<q?-1:U>q?1:0})}L(W,K,x,M,G){const Y=(q,V,C)=>{if(q.isValid&&!V.isValid)return!1;if(q.isValid===V.isValid){if(G&&p.gt(q.manifest.version,V.manifest.version))return this.y.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(p.eq(q.manifest.version,V.manifest.version)){if(q.type===0)return this.y.debug(`Skipping extension ${V.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===M)return this.y.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return C?this.y.warn(`Overwriting user extension ${q.location.path} with ${V.location.path}.`):this.y.debug(`Overwriting user extension ${q.location.path} with ${V.location.path}.`),!0},U=new f.$Xm;return W?.forEach(q=>{const V=U.get(q.identifier.id);(!V||Y(V,q,!1))&&U.set(q.identifier.id,q)}),K?.forEach(q=>{const V=U.get(q.identifier.id);if(!V&&W&&q.type===0){this.y.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!V||Y(V,q,!1))&&U.set(q.identifier.id,q)}),x?.forEach(q=>{const V=U.get(q.identifier.id);(!V||Y(V,q,!0))&&U.set(q.identifier.id,q),U.set(q.identifier.id,q)}),[...U.values()]}async M(W,K){this.y.trace("Started scanning system extensions");const x=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0,this.R()),G=await(W&&!x.devMode?this.j:this.n).scanExtensions(x);return this.y.trace("Scanned system extensions:",G.length),G}async N(W,K){const x=this.z.isBuilt?[]:this.C.builtInExtensions;if(!x?.length)return[];this.y.trace("Started scanning dev system extensions");const M=K?await this.O():{},G=[],Y=c.URI.file(b.$hc(b.$jc(h.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const q of x){const V=M[q.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":G.push((0,w.$bh)(Y,q.name));break;default:G.push(c.URI.file(V));break}}const U=await Promise.all(G.map(async q=>this.n.scanExtension(await this.P(q,!1,0,!0,W,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",U.length),(0,N.$Hb)(U)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,K,x,M,G,Y,U,q){const V=await this.f(G??y.$w),C=await this.Q(W),v=K&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=v?await this.Q(v):void 0;return new J(W,C,v,O,K,U,x,M,Y,q.version,q.date,this.C.commit,!this.z.isBuilt,G,V)}async Q(W){try{const K=await this.w.stat(W);if(typeof K.mtime=="number")return K.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Aq=B,e.$Aq=B=$e([ie(4,k.$Gl),ie(5,S.$vq),ie(6,r.$7k),ie(7,i.$7j),ie(8,m.$Hi),ie(9,s.$nk),ie(10,I.$El),ie(11,t.$zi)],B);class J{constructor(W,K,x,M,G,Y,U,q,V,C,v,O,z,T,Z){this.location=W,this.mtime=K,this.applicationExtensionslocation=x,this.applicationExtensionslocationMtime=M,this.profile=G,this.profileScanOptions=Y,this.type=U,this.excludeObsolete=q,this.validate=V,this.productVersion=C,this.productDate=v,this.productCommit=O,this.devMode=z,this.language=T,this.translations=Z}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,K){return(0,w.$7g)(W.location,K.location)&&W.mtime===K.mtime&&(0,w.$7g)(W.applicationExtensionslocation,K.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&W.profile===K.profile&&P.$$n(W.profileScanOptions,K.profileScanOptions)&&W.type===K.type&&W.excludeObsolete===K.excludeObsolete&&W.validate===K.validate&&W.productVersion===K.productVersion&&W.productDate===K.productDate&&W.productCommit===K.productCommit&&W.devMode===K.devMode&&W.language===K.language&&F.equals(W.translations,K.translations)}}e.$Bq=J;let ne=class extends a.$Uc{constructor(W,K,x,M,G){super(),this.f=W,this.g=K,this.h=x,this.j=M,this.m=G}async scanExtensions(W){const K=W.profile?await this.r(W):await this.n(W);let x={};if(W.excludeObsolete&&W.type===1)try{const M=(await this.j.readFile(this.f)).value.toString();x=JSON.parse(M)}catch{}return(0,d.$ng)(x)?K:K.filter(M=>!x[g.$Bp.create(M).toString()])}async n(W){const K=await this.j.resolve(W.location);if(!K.children?.length)return[];const x=await Promise.all(K.children.map(async M=>{if(!M.isDirectory||W.type===1&&(0,w.$$g)(M.resource).indexOf(".")===0)return null;const G=new J(M.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(G)}));return(0,N.$Hb)(x).sort((M,G)=>M.location.path<G.location.path?-1:1)}async r(W){let K=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){K=K.filter(M=>!M.metadata?.isApplicationScoped);const x=await this.s(W.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,W);K.push(...x)}return K}async s(W,K,x){const M=await this.g.scanProfileExtensions(W,x.profileScanOptions);if(!M.length)return[];const G=await Promise.all(M.map(async Y=>{if(K(Y)){const U=new J(Y.location,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(U,Y.metadata)}return null}));return(0,N.$Hb)(G)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,w.$bh)(W.location,"package.json"))){const K=await this.scanExtension(W);return K?[K]:[]}else return await this.scanExtensions(W)}catch(K){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,D.$0)(K)),[]}}async scanExtension(W,K){try{let x=await this.scanExtensionManifest(W.location);if(x){x.publisher||(x.publisher=f.$Rm),K=K??x.__metadata,delete x.__metadata;const M=(0,g.$Fp)(x.publisher,x.name),G=K?.id?{id:M,uuid:K.id}:{id:M},Y=K?.isSystem?0:W.type,U=Y===0||!!K?.isBuiltin;x=await this.t(W.location,x,J.createNlsConfiguration(W));const q={type:Y,identifier:G,manifest:x,location:W.location,isBuiltin:U,targetPlatform:K?.targetPlatform??"undefined",publisherDisplayName:K?.publisherDisplayName,metadata:K,isValid:!0,validations:[]};return W.validate?this.validate(q,W):q}}catch(x){W.type!==0&&this.m.error(x)}return null}validate(W,K){let x=!0;const M=(0,n.$Qp)(K.productVersion,K.productDate,K.location,W.manifest,W.isBuiltin);for(const[G,Y]of M)G===R.default.Error&&(x=!1,this.m.error(this.z(K.location,Y)));return W.isValid=x,W.validations=M,W}async scanExtensionManifest(W){const K=(0,w.$bh)(W,"package.json");let x;try{x=(await this.j.readFile(K)).value.toString()}catch(G){return(0,r.$ll)(G)!==1&&this.m.error(this.z(W,(0,$.localize)(0,null,K.path,G.message))),null}let M;try{M=JSON.parse(x)}catch{const Y=[];(0,E.$Nn)(x,Y);for(const U of Y)this.m.error(this.z(W,(0,$.localize)(1,null,K.path,U.offset,U.length,(0,l.$xq)(U.error))));return null}return(0,E.$Wn)(M)!=="object"?(this.m.error(this.z(W,(0,$.localize)(2,null,K.path))),null):M}async t(W,K,x){const M=await this.u(W,K,x);if(M)try{const G=[],Y=await this.w(M.default,G);if(G.length>0)return G.forEach(q=>{this.m.error(this.z(W,(0,$.localize)(3,null,M.default?.path,(0,l.$xq)(q.error))))}),K;if((0,E.$Wn)(M)!=="object")return this.m.error(this.z(W,(0,$.localize)(4,null,M.default?.path))),K;const U=M.values||Object.create(null);return(0,j.$yq)(this.m,K,U,Y)}catch{}return K}async u(W,K,x){const M=(0,w.$bh)(W,"package.nls.json"),G=(V,C)=>{C.forEach(v=>{this.m.error(this.z(W,(0,$.localize)(5,null,V?.path,(0,l.$xq)(v.error))))})},Y=V=>{this.m.error(this.z(W,(0,$.localize)(6,null,V?.path)))},U=`${K.publisher}.${K.name}`,q=x.translations[U];if(q)try{const V=c.URI.file(q),C=(await this.j.readFile(V)).value.toString(),v=[],O=(0,E.$Nn)(C,v);return v.length>0?(G(V,v),{values:void 0,default:M}):(0,E.$Wn)(O)!=="object"?(Y(V),{values:void 0,default:M}):{values:O.contents?O.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.j.exists(M))return;let C;try{C=await this.y(W,x)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const v=(await this.j.readFile(C.localized)).value.toString(),O=[],z=(0,E.$Nn)(v,O);return O.length>0?(G(C.localized,O),{values:void 0,default:C.original}):(0,E.$Wn)(z)!=="object"?(Y(C.localized),{values:void 0,default:C.original}):{values:z,default:C.original}}catch{return{values:void 0,default:C.original}}}}async w(W,K){if(W)try{const x=(await this.j.readFile(W)).value.toString();return(0,E.$Nn)(x,K)}catch{}}y(W,K){return new Promise((x,M)=>{const G=Y=>{const U=(0,w.$bh)(W,`package.nls.${Y}.json`);this.j.exists(U).then(q=>{q&&x({localized:U,original:(0,w.$bh)(W,"package.nls.json")});const V=Y.lastIndexOf("-");V===-1?x({localized:(0,w.$bh)(W,"package.nls.json"),original:null}):(Y=Y.substring(0,V),G(Y))})};if(K.devMode||K.pseudo||!K.language)return x({localized:(0,w.$bh)(W,"package.nls.json"),original:null});G(K.language)})}z(W,K){return`[${W.path}]: ${K}`}};ne=$e([ie(1,S.$vq),ie(2,I.$El),ie(3,r.$7k),ie(4,i.$7j)],ne);let te=class extends ne{constructor(W,K,x,M,G,Y,U){super(K,M,G,Y,U),this.G=W,this.H=x,this.D=this.B(new A.$yh(3e3)),this.F=this.B(new o.$he),this.onDidChangeCache=this.F.event}async scanExtensions(W){const K=this.M(W),x=await this.I(K);if(this.C=W,x&&x.input&&J.equals(x.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),x.result.map(G=>(G.location=c.URI.revive(G.location),G));const M=await super.scanExtensions(W);return await this.J(K,{input:W,result:M}),M}async I(W){try{const K=await this.j.readFile(W),x=JSON.parse(K.value.toString());return{result:x.result,input:(0,u.$0h)(x.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",W.path,(0,D.$0)(K))}return null}async J(W,K){try{await this.j.writeFile(W,L.$Je.fromString(JSON.stringify(K)))}catch(x){this.m.debug("Error while writing the extension cache file:",W.path,(0,D.$0)(x))}}async L(){if(!this.C)return;const W=this.M(this.C),K=await this.I(W);if(!K)return;const x=K.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!P.$$n(M,x))try{this.m.info("Invalidating Cache",x,M),await this.j.del(W),this.F.fire()}catch(G){this.m.error(G)}}M(W){const K=this.N(W);return this.h.extUri.joinPath(K.cacheHome,W.type===0?f.$Qm:f.$Pm)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(W.location,K.extensionsResource))??this.G:this.H.defaultProfile}};te=$e([ie(2,k.$Gl),ie(3,S.$vq),ie(4,I.$El),ie(5,r.$7k),ie(6,i.$7j)],te);function le(ae,W){const K=(0,g.$Dp)(ae.manifest.publisher,ae.manifest.name);return{id:K,identifier:new f.$Vm(K),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:W,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,publisherDisplayName:ae.publisherDisplayName,...ae.manifest}}class ce extends B{constructor(W,K,x,M,G,Y,U,q,V,C,v,O){super(W,K,(0,w.$bh)(x,".vscode-oss-dev","extensions","control.json"),M,G,Y,U,q,V,C,v,O),this.S=(async()=>{if(y.$z)try{const z=await this.w.readFile(c.URI.file(y.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(W){return this.S}}e.$Dq=ce}),define(re[160],oe([0,1,60,8,34,5,2,15,16,25,6,24]),function(Q,e,N,A,P,L,D,E,l,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let y=class extends D.$Uc{constructor(p,R){super(),this.b=p,this.f=R,this.a=new A.$Gh(5)}async postUninstall(p){const R=this.g(p,"uninstall");R&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(d)}}));try{await a.Promises.rm(this.m(p))}catch(d){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(d)}}g(p,R){const d=`vscode:${R}`;if(p.location.scheme===E.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[d]=="string"){const c=p.manifest.scripts[d].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${d} should be a node script`),null):{script:(0,l.$jc)(p.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(p,R,d,c,$){return new Promise((m,g)=>{const f=this.j(p,R,d,$);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?g(t):m(void 0)};f.on("error",t=>{r((0,P.$lj)(t)||"Unknown")}),f.on("exit",(t,i)=>{r(t?`post-${R} process exited with code ${t}`:void 0)}),c&&(n=setTimeout(()=>{n=null,f.kill(),g("timed out")},5e3))})}j(p,R,d,c){const $={silent:!0,execArgv:void 0},m=(0,N.fork)(p,[`--type=extension-post-${R}`,...d],$);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const g=L.Event.fromNodeEventEmitter(m.stdout,"data"),f=L.Event.fromNodeEventEmitter(m.stderr,"data");this.B(g(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${R}`,t))),this.B(f(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${R}`,t)));const n=L.Event.any(L.Event.map(g,t=>({data:`%c${t}`,format:[""]}),this.q),L.Event.map(f,t=>({data:`%c${t}`,format:["color: red"]}),this.q));return L.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),m}m(p){return(0,l.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.$Hq=y,e.$Hq=y=$e([ie(0,b.$Gl),ie(1,h.$7j)],y)}),define(re[73],oe([0,1,49,103,53,20]),function(Q,e,N,A,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=D,e.$Fq=E;function D(l){let a="Extract";return l instanceof N.$nq&&(l.type==="CorruptZip"?a="CorruptZip":l.type==="Incomplete"&&(a="IncompleteZip")),(0,P.$sq)(l,a)}async function E(l){let a;try{a=await(0,N.$qq)(l,"extension/package.json")}catch(h){throw D(h)}try{return JSON.parse(a.toString("utf8"))}catch{throw new L.$bp((0,A.localize)(0,null),"Invalid")}}}),define(re[161],oe([0,1,8,9,2,15,17,44,3,28,25,49,29,18,53,20,26,73,72,13,6,21]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c,$,m,g,f){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;let r=class extends P.$Uc{static{n=this}static{this.c=".sigzip"}constructor(i,s,o,u,S,k,I){super(),this.h=s,this.j=o,this.m=u,this.n=S,this.r=k,this.t=I,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,s,o,u){await this.g;const S=await this.w(i,s);let k=!1;if(o&&this.u(i)){let I;try{I=await this.y(i)}catch(j){try{await this.delete(S)}catch(F){this.t.error(F)}throw j}try{k=await this.n.verify(i,S.fsPath,I.fsPath,u)}catch(j){if(k=j.code,k==="PackageIsInvalidZip"||k==="SignatureArchiveIsInvalidZip"){try{await this.delete(S)}catch(F){this.t.error(F)}throw new R.$bp(b.$mq,"CorruptZip")}}finally{try{await this.delete(I)}catch(j){this.t.error(j)}}}return{location:S,verificationStatus:k}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,l.$gg)(s)?s:!0}async w(i,s){try{const o=(0,D.$bh)(this.extensionsDownloadDir,this.G(i)),u=await this.C(i,"vsix",async()=>{await this.z(i,o,S=>this.j.download(i,S,s));try{await this.D(o.fsPath,"extension/package.json")}catch(S){try{await this.h.del(o)}catch(k){this.t.warn(`Error while deleting: ${o.path}`,(0,A.$0)(k))}throw S}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:u}),o}catch(o){throw(0,p.$sq)(o,"Download")}}async y(i){try{const s=(0,D.$bh)(this.extensionsDownloadDir,`.${(0,a.$Wg)()}`),o=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,s);try{await this.D(s.fsPath,".signature.p7s")}catch(u){try{await this.h.del(s)}catch(S){this.t.warn(`Error while deleting: ${s.path}`,(0,A.$0)(S))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:o}),s}catch(s){throw(0,p.$sq)(s,"DownloadSignature")}}async z(i,s,o){if(await this.h.exists(s))return;if(s.scheme!==L.Schemas.file){await o(s);return}const u=(0,D.$bh)(this.extensionsDownloadDir,`.${(0,a.$Wg)()}`);try{await o(u)}catch(S){try{await this.h.del(u)}catch{}throw S}try{await h.Promises.rename(u.fsPath,s.fsPath,2*60*1e3)}catch(S){try{await this.h.del(u)}catch{}let k=!1;try{k=await this.h.exists(s)}catch{}if(k)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,A.$0)(S)}. Deleted the file from downloaded location`,u.path),S}}async C(i,s,o,u){let S=1;for(;;)try{return await o(),S}catch(k){if(S++>u)throw k;this.t.warn(`Failed downloading ${s}. ${(0,A.$0)(k)}. Retry again...`,i.identifier.id)}}async D(i,s){try{await(0,b.$qq)(i,s)}catch(o){throw(0,c.$Eq)(o)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const s=[],o=[],u=[];for(const I of i.children)if(I.name.endsWith(n.c))u.push(I.resource);else{const j=d.$Bp.parse(I.name);j&&o.push([j,I])}const S=(0,d.$Gp)(o,([I])=>I),k=[];for(const I of S)I.sort((j,F)=>E.rcompare(j[0].version,F[0].version)),s.push(...I.slice(1).map(j=>j[1].resource)),k.push(I[0][1]);k.sort((I,j)=>I.mtime-j.mtime),s.push(...k.slice(0,Math.max(0,k.length-this.f)).map(I=>I.resource)),s.push(...u),await N.Promises.settled(s.map(I=>(this.t.trace("Deleting from cache",I.path),this.h.del(I))))}}catch(i){this.t.error(i)}}G(i){return this.f?d.$Bp.create(i).toString().toLowerCase():(0,a.$Wg)()}};e.$Gq=r,e.$Gq=r=n=$e([ie(0,w.$Ii),ie(1,m.$7k),ie(2,R.$_o),ie(3,y.$7i),ie(4,$.$fq),ie(5,f.$6l),ie(6,g.$7j)],r)}),define(re[162],oe([0,1,8,14,22,34,9,5,43,2,30,15,16,17,44,3,11,28,25,49,102,62,18,53,20,26,42,54,161,160,73,141,148,50,13,10,6,32,21,23,24]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c,$,m,g,f,n,r,t,i,s,o,u,S,k,I,j,F,B,J,ne,te,le,ce,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=void 0,e.$Kq=(0,J.$Bi)(t.$cp);const W=".vsctmp";let K=class extends r.$rq{constructor(U,q,V,C,v,O,z,T,Z,X,se,ue){super(U,q,se,V,X,ue),this.eb=v,this.fb=O,this.gb=z,this.hb=T,this.ib=Z,this.db=new Map,this.tb=new h.$Bc;const he=this.B(T.createInstance(S.$Hq));this.ab=this.B(T.createInstance(x,ye=>he.postUninstall(ye))),this.bb=this.B(new I.$Iq(ue,Z,se,this,this.F)),this.cb=this.B(T.createInstance(u.$Gq));const pe=this.B(new j.$Jq(this,this.eb,ue,O,se,Z,V));this.B(pe.onDidChangeExtensionsByAnotherSource(ye=>this.sb(ye))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Lp)(this.ib,this.F)),this.jb}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const q=await this.rb(U),V=await(0,m.zip)((0,w.$bh)(this.cb.extensionsDownloadDir,(0,c.$Wg)()).fsPath,q);return d.URI.file(V)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:q,cleanup:V}=await this.lb(U),C=y.$kc(q.fsPath);try{return await(0,k.$Fq)(C)}finally{await V()}}getInstalled(U,q=this.H.defaultProfile.extensionsResource,V={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(U??null,q,V)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.ab.scanUserExtensionAtLocation(U)}async install(U,q={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:V,cleanup:C}=await this.lb(U);try{const v=await(0,k.$Fq)(y.$kc(V.fsPath)),O=(0,i.$Fp)(v.publisher,v.name);if(v.engines&&v.engines.vscode&&!(0,F.$Sp)(v.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,O,this.G.version));const T=(await this.I([{manifest:v,extension:V,options:q}])).find(({identifier:Z})=>(0,i.$Ap)(Z,{id:O}));if(T?.local)return T.local;throw T?.error?T.error:(0,r.$sq)(new Error(`Unknown error while installing extension ${O}`))}finally{await C()}}async installFromLocation(U,q){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const V=await this.ab.scanUserExtensionAtLocation(U);if(!V||!V.manifest.name||!V.manifest.version)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.wb([[V,{source:"resource"}]],q),this.F.info("Successfully installed extension",V.identifier.id,q.toString()),V}async installExtensionsFromProfile(U,q,V){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,q.toString(),V.toString());const C=(await this.getInstalled(1,q)).filter(v=>U.some(O=>(0,i.$Ap)(O,v.identifier)));if(C.length){const v=await Promise.all(C.map(O=>this.ab.scanMetadata(O,q)));await this.wb(C.map((O,z)=>[O,v[z]]),V),this.F.info("Successfully installed extensions",C.map(O=>O.identifier.id),V.toString())}return C}async updateMetadata(U,q,V=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0,q.hasPreReleaseVersion=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),U=await this.ab.updateMetadata(U,q,V),this.bb.invalidate(V),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const q=await this.getTargetPlatform(),[V]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:q,compatible:!0},P.CancellationToken.None);if(!V)throw new Error(g.localize(2,null));await this.ab.setUninstalled(U);try{await this.ab.removeUninstalledExtension(U)}catch(C){throw new Error(g.localize(3,null,(0,L.$lj)(C)))}return this.installFromGallery(V)}$(U,q,V,C){return this.ab.copyExtension(U,q,V,C)}copyExtensions(U,q){return this.ab.copyExtensions(U,q,{version:this.G.version,date:this.G.date})}markAsUninstalled(...U){return this.ab.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(U){this.F.error(U)}}async download(U,q,V){const{location:C}=await this.cb.download(U,q,!V);return C}async lb(U){if(U.scheme===b.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const q=(0,w.$bh)(this.cb.extensionsDownloadDir,(0,c.$Wg)());return await this.gb.download(U,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(C){this.F.error(C)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(U,q,V){const C=q instanceof d.URI?new i.$Bp({id:(0,i.$Fp)(U.publisher,U.name)},U.version):i.$Bp.create(q);return this.hb.createInstance(M,C,U,q,V,(v,O)=>{if(q instanceof d.URI)return this.qb(C,q,V,O);let z=this.db.get(C.toString());return z||(this.db.set(C.toString(),z=this.pb(C,q,v,V,O)),z.finally(()=>this.db.delete(C.toString()))),z},this.ab)}Z(U,q){return new G(U,q.profileLocation,this.fb)}async pb(U,q,V,C,v){const{verificationStatus:O,location:z}=await this.cb.download(q,V,!C.donotVerifySignature,C.context?.[t.$5o]);try{if(v.isCancellationRequested)throw new D.$5;return await(0,k.$Fq)(z.fsPath),{local:await this.ab.extractUserExtension(U,z.fsPath,{id:q.identifier.uuid,publisherId:q.publisherId,publisherDisplayName:q.publisherDisplayName,targetPlatform:q.properties.targetPlatform,isApplicationScoped:C.isApplicationScoped,isMachineScoped:C.isMachineScoped,isBuiltin:C.isBuiltin,isPreReleaseVersion:q.properties.isPreReleaseVersion,hasPreReleaseVersion:q.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:C.installGivenVersion?!0:!!C.pinned,preRelease:(0,R.$gg)(C.preRelease)?C.preRelease:C.installPreReleaseVersion||q.properties.isPreReleaseVersion,source:"gallery"},!1,v),verificationStatus:O}}catch(T){try{await this.cb.delete(z)}catch(Z){this.F.warn("Error while deleting the downloaded file",z.toString(),(0,D.$0)(Z))}throw(0,r.$sq)(T)}}async qb(U,q,V,C){return{local:await this.ab.extractUserExtension(U,y.$kc(q.fsPath),{isApplicationScoped:V.isApplicationScoped,isMachineScoped:V.isMachineScoped,isBuiltin:V.isBuiltin,installedTimestamp:Date.now(),pinned:V.installGivenVersion?!0:!!V.pinned,source:"vsix"},!0,C)}}async rb(U){const q=async C=>{let v=await $.Promises.readdir(C);v=v.map(T=>y.$jc(C,T));const O=await Promise.all(v.map(T=>$.Promises.stat(T)));let z=Promise.resolve([]);return O.forEach((T,Z)=>{const X=v[Z];T.isFile()&&(z=z.then(se=>[...se,X])),T.isDirectory()&&(z=z.then(se=>q(X).then(ue=>[...se,...ue])))}),z};return(await q(U.location.fsPath)).map(C=>({path:`extension/${y.$lc(U.location.fsPath,C)}`,localPath:C}))}async sb({added:U,removed:q}){if(q){const V=U&&this.D.extUri.isEqual(q.profileLocation,U.profileLocation)?q.extensions.filter(C=>U.extensions.every(v=>!(0,i.$Ap)(v,C))):q.extensions;for(const C of V)this.F.info("Extensions removed from another source",C.id,q.profileLocation.toString()),this.u.fire({identifier:C,profileLocation:q.profileLocation})}if(U){const C=(await this.getInstalled(1,U.profileLocation)).filter(v=>U.extensions.some(O=>(0,i.$Ap)(O,v.identifier)));this.s.fire(C.map(v=>(this.F.info("Extensions added from another source",v.identifier.id,U.profileLocation.toString()),{identifier:v.identifier,local:v,profileLocation:U.profileLocation,operation:1})))}}async ub(){this.B(this.ab.onExtract(q=>this.tb.add(q)));const U=await this.ib.resolve(this.eb.userExtensionsLocation);for(const q of U.children??[])q.isDirectory&&this.tb.add(q.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.vb(q)))}async vb(U){if(!U.affects(this.eb.userExtensionsLocation,1))return;const q=[];for(const V of U.rawAdded){if(this.tb.has(V)||!this.D.extUri.isEqual(this.D.extUri.dirname(V),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(V,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(V).startsWith(".")||!(await this.ib.stat(V)).isDirectory)continue;const C=await this.ab.scanUserExtensionAtLocation(V);C&&C.installedTimestamp===void 0&&(this.tb.add(V),q.push(C))}q.length&&(await this.wb(q.map(V=>[V,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(V=>V.identifier.id)))}async wb(U,q){const V=U.map(C=>C[0]);await this.xb(V),await this.fb.addExtensionsToProfile(U,q),this.s.fire(V.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:q})))}async xb(U){const q=await this.ab.getUninstalledExtensions();for(const V of U){const C=i.$Bp.create(V);q[C.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",C.id),await this.ab.setInstalled(C),this.F.info("Removed the extension from uninstalled list:",C.id))}}};e.$Lq=K,e.$Lq=K=$e([ie(0,t.$_o),ie(1,le.$6l),ie(2,ne.$7j),ie(3,n.$Ii),ie(4,o.$zq),ie(5,s.$vq),ie(6,f.$Po),ie(7,J.$zi),ie(8,B.$7k),ie(9,te.$nk),ie(10,ce.$El),ie(11,ae.$Gl)],K);let x=class extends a.$Uc{constructor(U,q,V,C,v,O){super(),this.j=U,this.m=q,this.n=V,this.s=C,this.t=v,this.u=O,this.h=this.B(new E.$he),this.onExtract=this.h.event,this.c=(0,w.$bh)(this.n.userExtensionsLocation,".obsolete"),this.g=new N.$Hh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,q,V){try{const C={includeInvalid:!0,profileLocation:q,productVersion:V};let v=[];return U===null||U===0?v.push(...await this.n.scanAllExtensions({includeInvalid:!0},C,!1)):U===1&&v.push(...await this.n.scanUserExtensions(C)),v=U!==null?v.filter(O=>O.type===U):v,await Promise.all(v.map(O=>this.F(O)))}catch(C){throw(0,r.$sq)(C,"Scanning")}}async scanAllUserExtensions(U){try{const q=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return await Promise.all(q.map(V=>this.F(V)))}catch(q){throw(0,r.$sq)(q,"Scanning")}}async scanUserExtensionAtLocation(U){try{const q=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(U,q,V,C,v){const O=U.toString(),z=d.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Wg)()}`)),T=d.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,O));let Z=await this.m.exists(T);if(Z&&C){try{await this.y(U.id,T,"removeExisting")}catch{throw new t.$bp(g.localize(4,null,T.fsPath,U.id),"Delete")}Z=!1}if(Z)try{await this.n.updateMetadata(T,V)}catch(X){throw(0,r.$sq)(X,"UpdateMetadata")}else try{if(v.isCancellationRequested)throw new D.$5;try{this.u.trace(`Started extracting the extension from ${q} to ${T.fsPath}`),await(0,m.$pq)(q,z.fsPath,{sourcePath:"extension",overwrite:!0},v),this.u.info(`Extracted extension to ${T}:`,U.id)}catch(X){throw(0,k.$Eq)(X)}try{await this.n.updateMetadata(z,V)}catch(X){throw(0,r.$sq)(X,"UpdateMetadata")}if(v.isCancellationRequested)throw new D.$5;try{this.u.trace(`Started renaming the extension from ${z.fsPath} to ${T.fsPath}`),await this.C(z.fsPath,T.fsPath),this.u.info("Renamed to",T.fsPath)}catch(X){if(X.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(X)}. Deleted from extracted location`,z),X}this.h.fire(T)}catch(X){try{await this.m.del(z,{recursive:!0})}catch{}throw X}return this.D(T,1)}async scanMetadata(U,q){return q?(await this.w(U,q))?.metadata:this.n.scanMetadata(U.location)}async w(U,q){return(await this.s.scanProfileExtensions(q)).find(C=>(0,i.$Ap)(C.identifier,U.identifier))}async updateMetadata(U,q,V){try{V?await this.s.updateMetadata([[U,q]],V):await this.n.updateMetadata(U.location,q)}catch(C){throw(0,r.$sq)(C,"UpdateMetadata")}return this.D(U.location,U.type,V)}async getUninstalledExtensions(){try{return await this.z()}catch(U){throw(0,r.$sq)(U,"ReadUninstalled")}}async setUninstalled(...U){const q=U.map(V=>i.$Bp.create(V));await this.z(V=>q.forEach(C=>{V[C.toString()]=!0,this.u.info("Marked extension as uninstalled",C.toString())}))}async setInstalled(U){try{await this.z(q=>delete q[U.toString()])}catch(q){throw(0,r.$sq)(q,"UnsetUninstalled")}}async removeExtension(U,q){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,q)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(q=>delete q[i.$Bp.create(U).toString()])}async copyExtension(U,q,V,C){const v=await this.w(U,q),O=await this.w(U,V);if(C={...v?.metadata,...C},O)if(this.t.extUri.isEqual(O.location,U.location))await this.s.updateMetadata([[U,{...O.metadata,...C}]],V);else{const z=await this.D(O.location,U.type,V);await this.s.removeExtensionFromProfile(z,V),await this.s.addExtensionsToProfile([[U,{...O.metadata,...C}]],V)}else await this.s.addExtensionsToProfile([[U,C]],V);return this.D(U.location,U.type,V)}async copyExtensions(U,q,V){const C=await this.scanExtensions(1,U,V),v=await Promise.all(C.filter(O=>!O.isApplicationScoped).map(async O=>[O,await this.scanMetadata(O,U)]));await this.s.addExtensionsToProfile(v,q)}async y(U,q,V){this.u.trace(`Deleting ${V} extension from disk`,U,q.fsPath);const C=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,l.$oj)((0,c.$Wg)()).toString(16)}${W}`);await this.C(q.fsPath,C.fsPath),await this.m.del(C,{recursive:!0}),this.u.info(`Deleted ${V} extension from disk`,U,q.fsPath)}z(U){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(C){if((0,B.$ll)(C)!==1)throw C}let V={};if(q)try{V=JSON.parse(q)}catch{}return U&&(U(V),Object.keys(V).length?await this.m.writeFile(this.c,A.$Je.fromString(JSON.stringify(V))):await this.m.del(this.c)),V})}async C(U,q){try{await $.Promises.rename(U,q,2*60*1e3)}catch(V){throw(0,r.$sq)(V,"Rename")}}async D(U,q,V){try{if(V){const v=(await this.n.scanUserExtensions({profileLocation:V})).find(O=>this.t.extUri.isEqual(O.location,U));if(v)return await this.F(v)}else{const C=await this.n.scanExistingExtension(U,q,{includeInvalid:!0});if(C)return await this.F(C)}throw new t.$bp(g.localize(5,null,U.path),"ScanningExtension")}catch(C){throw(0,r.$sq)(C,"ScanningExtension")}}async F(U){const q=await this.m.resolve(U.location);let V,C;return q.children&&(V=q.children.find(({name:v})=>/^readme(\.txt|\.md|)$/i.test(v))?.resource,C=q.children.find(({name:v})=>/^changelog(\.txt|\.md|)$/i.test(v))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:V,changelogUrl:C,publisherDisplayName:U.metadata?.publisherDisplayName,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!U.metadata?.hasPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned,isWorkspaceScoped:!1,source:U.metadata?.source??(U.identifier.uuid?"gallery":"vsix")}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),V=new Set;for(const v of q)U[i.$Bp.create(v).toString()]||V.add(v.identifier.id.toLowerCase());try{const v=(0,i.$Gp)(q,O=>O.identifier);await N.Promises.settled(v.map(async O=>{const z=O.sort((T,Z)=>p.rcompare(T.manifest.version,Z.manifest.version))[0];V.has(z.identifier.id.toLowerCase())||await this.j(await this.F(z))}))}catch(v){this.u.error(v)}const C=q.filter(v=>v.metadata&&U[i.$Bp.create(v).toString()]);await Promise.allSettled(C.map(v=>this.removeUninstalledExtension(v)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,B.$ll)(q)!==1&&this.u.error(q);return}if(U?.children)try{await Promise.allSettled(U.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(V){(0,B.$ll)(V)!==1&&this.u.error(V)}}}))}catch{}}};e.$Mq=x,e.$Mq=x=$e([ie(1,B.$7k),ie(2,o.$zq),ie(3,s.$vq),ie(4,ce.$El),ie(5,ne.$7j)],x);let M=class extends r.$tq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(U,q,V,C,v,O,z,T,Z,X,se,ue){super(),this.l=U,this.manifest=q,this.source=V,this.options=C,this.m=v,this.n=O,this.o=z,this.p=T,this.q=Z,this.s=X,this.t=se,this.u=ue,this.j=2,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(q=>(0,i.$Ap)(q.identifier,this.identifier))}async h(U){const q=await this.v();q&&(this.j=3);const V={isApplicationScoped:this.options.isApplicationScoped||q?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||q?.isMachineScoped,isBuiltin:this.options.isBuiltin||q?.isBuiltin,isSystem:q?.type===0?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??q?.pinned,source:this.source instanceof d.URI?"vsix":"gallery"};if(this.source instanceof d.URI)if(q){if(this.l.equals(new i.$Bp(q.identifier,q.manifest.version)))try{await this.n.removeExtension(q,"existing")}catch{throw new Error(g.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const z=await this.x(this.l);if(z)try{await this.n.removeExtension(z,"existing")}catch{throw new Error(g.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(V.id=this.source.identifier.uuid,V.publisherId=this.source.publisherId,V.publisherDisplayName=this.source.publisherDisplayName,V.targetPlatform=this.source.properties.targetPlatform,V.updated=!!q,V.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,V.hasPreReleaseVersion=q?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,V.preRelease=(0,R.$gg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||q?.preRelease,q&&q.type!==0&&q.manifest.version===this.source.version)return this.n.updateMetadata(q,V);const z=await this.x(this.l);if(z)return z}if(U.isCancellationRequested)throw(0,r.$sq)(new D.$5);const{local:C,verificationStatus:v}=await this.m(this.operation,U);if(this.k=v,this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(z){throw(0,r.$sq)(z,"IntializeDefaultProfile")}if(U.isCancellationRequested)throw(0,r.$sq)(new D.$5);try{await this.t.addExtensionsToProfile([[C,V]],this.options.profileLocation,!C.isValid)}catch(z){throw(0,r.$sq)(z,"AddToProfile")}const O=await this.v();if(!O)throw new t.$bp("Cannot find the installed extension","InstalledExtensionNotFound");return this.source instanceof d.URI&&this.y(C,U),O}async x(U){return(await this.n.getUninstalledExtensions())[U.toString()]?(this.u.trace("Removing the extension from uninstalled list:",U.id),await this.n.setInstalled(U),this.u.info("Removed the extension from uninstalled list:",U.id),(await this.n.scanAllUserExtensions(!0)).find(C=>i.$Bp.create(C).equals(U))):void 0}async y(U,q){try{let[V]=await this.p.getExtensions([{id:U.identifier.id,version:U.manifest.version}],q);if(V||([V]=await this.p.getExtensions([{id:U.identifier.id}],q)),V){const C={id:V.identifier.uuid,publisherDisplayName:V.publisherDisplayName,publisherId:V.publisherId,isPreReleaseVersion:V.properties.isPreReleaseVersion,hasPreReleaseVersion:U.hasPreReleaseVersion||V.properties.isPreReleaseVersion,preRelease:V.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(U,C,this.options.profileLocation)}}catch{}}};M=$e([ie(6,ce.$El),ie(7,t.$_o),ie(8,ae.$Gl),ie(9,o.$zq),ie(10,s.$vq),ie(11,ne.$7j)],M);class G extends r.$tq{constructor(U,q,V){super(),this.extension=U,this.j=q,this.k=V}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[163],oe([0,1,6,24,23,21,42,13,18,11]),function(Q,e,N,A,P,L,D,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0;let h=class extends D.$wq{constructor(y,w,p,R,d,c){super(a.URI.file(y.extensionsPath),w,p,R,d,c)}};e.$eQ=h,e.$eQ=h=$e([ie(0,l.$Ii),ie(1,E.$7k),ie(2,A.$Gl),ie(3,P.$El),ie(4,L.$6l),ie(5,N.$7j)],h)}),define(re[164],oe([0,1,11,18,42,54,13,10,6,32,23,24]),function(Q,e,N,A,P,L,D,E,l,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;let y=class extends L.$Dq{constructor(p,R,d,c,$,m,g,f){super(N.URI.file($.builtinExtensionsPath),N.URI.file($.extensionsPath),$.userHome,p.defaultProfile,p,R,d,c,$,m,g,f)}};e.$nec=y,e.$nec=y=$e([ie(0,b.$Gl),ie(1,P.$vq),ie(2,D.$7k),ie(3,l.$7j),ie(4,A.$Ii),ie(5,a.$nk),ie(6,h.$El),ie(7,E.$zi)],y)}),define(re[165],oe([0,1,8,5,2,131,3,92,10,24]),function(Q,e,N,A,P,L,D,E,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$9p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7p=e.$6p=e.$5p=void 0,e.$8p=w,e.$0p=R,e.$_p=c,e.$5p="__$__isNewStorageMarker",e.$6p="__$__targetStorageMarker",e.$7p=(0,l.$Ai)("storageService");var h;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var b;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var y;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function w($){const m=$.get(e.$6p);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}class p extends P.$Uc{static{this.a=60*1e3}constructor(m={flushInterval:p.a}){super(),this.m=m,this.b=this.B(new A.$ke),this.c=this.B(new A.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$he),this.onWillSaveState=this.f.event,this.h=this.B(new N.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,g,f){return A.Event.filter(this.b.event,n=>n.scope===m&&(g===void 0||n.key===g),f)}n(){this.j.value=(0,N.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,g){const{key:f,external:n}=g;if(f===e.$6p){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:f,target:this.J(m)[f],external:n})}w(m){this.f.fire({reason:m})}get(m,g,f){return this.P(g)?.get(m,f)}getBoolean(m,g,f){return this.P(g)?.getBoolean(m,f)}getNumber(m,g,f){return this.P(g)?.getNumber(m,f)}getObject(m,g,f){return this.P(g)?.getObject(m,f)}storeAll(m,g){this.y(()=>{for(const f of m)this.store(f.key,f.value,f.scope,f.target,g)})}store(m,g,f,n,r=!1){if((0,D.$jg)(g)){this.remove(m,f,r);return}this.y(()=>{this.z(m,f,n),this.P(f)?.set(m,g,r)})}remove(m,g,f=!1){this.y(()=>{this.z(m,g,void 0),this.P(g)?.delete(m,f)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,g){const f=[],n=this.J(m);for(const r of Object.keys(n))n[r]===g&&f.push(r);return f}z(m,g,f,n=!1){const r=this.J(g);typeof f=="number"?r[m]!==f&&(r[m]=f,this.P(g)?.set(e.$6p,JSON.stringify(r),n)):typeof r[m]=="number"&&(delete r[m],this.P(g)?.set(e.$6p,JSON.stringify(r),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const g=this.P(m);return g?w(g):Object.create(null)}isNew(m){return this.getBoolean(e.$5p,m)===!0}async flush(m=h.NONE){this.f.fire({reason:m});const g=this.P(-1),f=this.P(0),n=this.P(1);switch(m){case h.NONE:await N.Promises.settled([g?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await N.Promises.settled([g?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,f=this.P(1)?.items??new Map;return c(m,g,f,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,g){return this.w(h.NONE),(0,a.$Fl)(m)?this.R(m,g):this.S(m,g)}M(m,g){return!(m.id===g.id||R(g)&&R(m))}N(m,g,f){this.y(()=>{const n=new Set;for(const[r,t]of m)n.add(r),g.get(r)!==t&&this.u(f,{key:r,external:!0});for(const[r]of g.items)n.has(r)||this.u(f,{key:r,external:!0})})}}e.$9p=p;function R($){return $.isDefault||!!$.useDefaultFlags?.globalState}class d extends p{constructor(){super(),this.U=this.B(new E.$3p(new E.$4p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$3p(new E.$4p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$3p(new E.$4p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$$p=d;async function c($,m,g,f,n,r){const t=F=>{try{return JSON.parse(F)}catch{return F}},i=new Map,s=new Map;$.forEach((F,B)=>{i.set(B,F),s.set(B,t(F))});const o=new Map,u=new Map;m.forEach((F,B)=>{o.set(B,F),u.set(B,t(F))});const S=new Map,k=new Map;g.forEach((F,B)=>{S.set(B,F),k.set(B,t(F))}),console.group(f!==n?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const I=[];if(i.forEach((F,B)=>{I.push({key:B,value:F})}),console.table(I),console.groupEnd(),console.log(s),f!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const F=[];o.forEach((B,J)=>{F.push({key:J,value:B})}),console.table(F),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${r})`);const j=[];S.forEach((F,B)=>{j.push({key:B,value:F})}),console.table(j),console.groupEnd(),console.log(k)}}),define(re[166],oe([0,1,19,22,9,12,35,3,11,29,18,20,26,50,13,6,32,45,149,165,21,178]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c,$,m,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0,e.$cq=Y;const n=L.$o?"web":(0,b.$8o)(L.$u,D.$ec),r="X-Market-Search-Activity-Id";var t;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...O){return String(O.reduce((z,T)=>z|T,0))}var s;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class I{constructor(z=k){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,T=this.d.pageSize){return new I({...this.d,pageNumber:z,pageSize:T})}withFilter(z,...T){const Z=[...this.d.criteria,...T.length?T.map(X=>({filterType:z,value:X})):[{filterType:z}]];return new I({...this.d,criteria:Z})}withSortBy(z){return new I({...this.d,sortBy:z})}withSortOrder(z){return new I({...this.d,sortOrder:z})}withFlags(...z){return new I({...this.d,flags:z.reduce((T,Z)=>T|Z,0)})}withAssetTypes(...z){return new I({...this.d,assetTypes:z})}withSource(z){return new I({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:T,pageSize:Z,sortBy:X,sortOrder:se,flags:ue,assetTypes:he}=this.d;return{filters:[{criteria:z,pageNumber:T,pageSize:Z,sortBy:X,sortOrder:se}],assetTypes:he,flags:ue}}get searchText(){const z=this.d.criteria.filter(T=>T.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(O,z){const T=(O||[]).filter(Z=>Z.statisticName===z)[0];return T?T.value:0}function F(O){const z="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(Z=>Z.assetType.indexOf(z)===0).reduce((Z,X)=>{const se=ne(O,X.assetType);return se&&Z.push([X.assetType.substring(z.length),se]),Z},[])}function B(O){if(O.properties){const z=O.properties.filter(X=>X.key===o.Repository),T=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Z=z.filter(X=>T.test(X.value))[0];return Z?{uri:Z.value,fallbackUri:Z.value}:null}return ne(O,o.Repository)}function J(O){return{uri:`${O.fallbackAssetUri}/${o.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${o.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function ne(O,z){return O.files.filter(Z=>Z.assetType===z)[0]?{uri:`${O.assetUri}/${z}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${z}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function te(O,z){const T=O.properties?O.properties.filter(X=>X.key===z):[],Z=T.length>0&&T[0].value;return Z?Z.split(",").map(X=>(0,y.$Ep)(X)):[]}function le(O){const z=O.properties?O.properties.filter(T=>T.key===u.Engine):[];return z.length>0&&z[0].value||""}function ce(O){const z=O.properties?O.properties.filter(T=>T.key===u.PreRelease):[];return z.length>0&&z[0].value==="true"}function ae(O){const z=O.properties?O.properties.filter(Z=>Z.key===u.LocalizedLanguages):[],T=z.length>0&&z[0].value||"";return T?T.split(","):[]}function W(O){return O.properties?.find(z=>z.key===u.SponsorLink)?.value}function K(O){return O.properties?.find(z=>z.key===u.SupportLink)?.value}function x(O){return O.indexOf("preview")!==-1}function M(O){return O.targetPlatform?(0,b.$7o)(O.targetPlatform):"undefined"}function G(O){const z=(0,N.$Mb)(O.versions.map(M)),T=!!O.tags?.includes(b.$1o),Z=z.indexOf("web");return T?Z===-1&&z.push("web"):Z!==-1&&z.splice(Z,1),z}function Y(O,z){for(let T=0;T<O.length;T++){const Z=O[T];if(Z.version===O[T-1]?.version){let X=T;if(M(Z)===z)for(;X>0&&O[X-1].version===Z.version;)X--;X!==T&&(O.splice(T,1),O.splice(X,0,Z))}}return O}function U(O,z,T){O.telemetryData={index:z,querySource:T,queryActivityId:O.queryContext?.[r]}}function q(O,z,T,Z){const X=O.versions[0],se={manifest:ne(z,o.Manifest),readme:ne(z,o.Details),changelog:ne(z,o.Changelog),license:ne(z,o.License),repository:B(z),download:J(z),icon:ne(z,o.Icon),signature:ne(z,o.Signature),coreTranslations:F(z)};return{type:"gallery",identifier:{id:(0,y.$Fp)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:z.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(X),description:O.shortDescription??"",installCount:j(O.statistics,"install"),rating:j(O.statistics,"averagerating"),ratingCount:j(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:T,assets:se,properties:{dependencies:te(z,u.Dependency),extensionPack:te(z,u.ExtensionPack),engine:le(z),localizedLanguages:ae(z),targetPlatform:M(z),isPreReleaseVersion:ce(z)},hasPreReleaseVersion:ce(X),hasReleaseVersion:!0,preview:x(O.flags),isSigned:!!se.signature,queryContext:Z,supportLink:K(X)}}let V=class{constructor(z,T,Z,X,se,ue,he,pe){this.k=T,this.l=Z,this.n=X,this.o=se,this.q=ue,this.u=he,this.w=pe;const ye=he.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,$.$bq)(he.version,he,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,T,Z){const X=A.CancellationToken.isCancellationToken(T)?{}:T,se=A.CancellationToken.isCancellationToken(T)?T:Z,ue=[],he=[],pe=[],ye=[];let fe=!0;for(const we of z){we.uuid?he.push(we.uuid):ue.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!he.length&&!ue.length)return[];let me=new I().withPage(1,z.length);he.length&&(me=me.withFilter(s.ExtensionId,...he)),ue.length&&(me=me.withFilter(s.ExtensionName,...ue)),(X.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),X.source&&(me=me.withSource(X.source));const{extensions:de}=await this.z(me,{targetPlatform:X.targetPlatform??n,includePreRelease:pe,versions:ye,compatible:!!X.compatible,productVersion:X.productVersion??{version:this.u.version,date:this.u.date}},se);return X.source&&de.forEach((we,Ee)=>U(we,Ee,X.source)),de}async getCompatibleExtension(z,T,Z,X={version:this.u.version,date:this.u.date}){if((0,b.$9o)(z.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(z,T,Z))return z;const se=new I().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,z.identifier.uuid),{extensions:ue}=await this.z(se,{targetPlatform:Z,compatible:!0,includePreRelease:T,productVersion:X},A.CancellationToken.None);return ue[0]||null}async isExtensionCompatible(z,T,Z,X={version:this.u.version,date:this.u.date}){if(!(0,b.$0o)(z.properties.targetPlatform,z.allTargetPlatforms,Z)||!T&&z.properties.isPreReleaseVersion)return!1;let se=z.properties.engine;if(!se){const ue=await this.getManifest(z,A.CancellationToken.None);if(!ue)throw new Error("Manifest was not found");se=ue.engines.vscode}return(0,w.$Sp)(se,X.version,X.date)}async y(z,T,Z,X,se,ue,he={version:this.u.version,date:this.u.date}){if(!(0,b.$0o)(M(T),se,ue)||Z!=="any"&&ce(T)!==(Z==="prerelease"))return!1;if(X)try{const pe=await this.E(z,T);if(!(0,w.$Sp)(pe,he.version,he.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${T.version}.`,(0,P.$0)(pe)),!1}return!0}async query(z,T){let Z=z.text||"";const X=z.pageSize??50;let se=new I().withPage(1,X);Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(se=se.withFilter(s.Category,de||me),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(se=se.withFilter(s.Tag,de||me),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(s.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),se=se.withFilter(s.SearchText,Z)),se=se.withSortBy(0)):z.ids?se=se.withFilter(s.ExtensionId,...z.ids):z.names?se=se.withFilter(s.ExtensionName,...z.names):se=se.withSortBy(4),typeof z.sortBy=="number"&&(se=se.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(se=se.withSortOrder(z.sortOrder)),z.source&&(se=se.withSource(z.source));const ue=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:n,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,Ie)=>U(Ee,(fe.pageNumber-1)*fe.pageSize+Ie,z.source)),{extensions:de,total:we}},{extensions:he,total:pe}=await ue(se,T),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new P.$5;const{extensions:de}=await ue(se.withPage(fe+1),me);return de};return{firstPage:he,total:pe,pageSize:se.pageSize,getPage:ye}}async z(z,T,Z){const X=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),T.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:se,total:ue,context:he}=await this.B(z,Z);if(!(z.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of se){const we=await this.A(de,T,he);we&&me.push(we)}return{extensions:me,total:ue}}const ye=[],fe=new Map;for(let me=0;me<se.length;me++){const de=se[me],we={id:(0,y.$Fp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,E.$gg)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(H=>(0,y.$Ap)(H,we))?.includePreRelease;if(T.compatible&&(0,b.$9o)(G(de),T.targetPlatform))continue;const Ie=await this.A(de,T,he);!Ie||Ie.properties.isPreReleaseVersion&&(!Ee||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==T.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,Ie])}if(fe.size){const me=new f.$be,de=new I().withFlags(X&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,T,Z);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const Ie=fe.get(Ee.identifier.uuid);ye.push([Ie,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ue}}async A(z,T,Z){const X={id:(0,y.$Fp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},se=T.versions?.find(ye=>(0,y.$Ap)(ye,X))?.version,ue=(0,E.$gg)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(ye=>(0,y.$Ap)(ye,X))?.includePreRelease,he=G(z),pe=Y(z.versions,T.targetPlatform);if(T.compatible&&(0,b.$9o)(he,T.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(se&&fe.version!==se)){if(await this.y((0,y.$Fp)(z.publisher.publisherName,z.extensionName),fe,ue?"any":"release",T.compatible,he,T.targetPlatform,T.productVersion))return q(z,fe,he,Z);if(se&&fe.version===se)return null}}return se||T.compatible?null:q(z,z.versions[0],he)}async B(z,T){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(t.Unpublished));const Z=await this.j,X=JSON.stringify(z.raw),se={...Z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},ue=new f.$be;let he,pe,ye=0;try{if(he=await this.k.request({type:"POST",url:this.g&&z.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:se},T),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Zp)(he);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:he.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,P.$4)(fe)?"Cancelled":(0,P.$0)(fe).startsWith("XHR timeout")?"Timeout":"Failed";throw pe=new b.$ap((0,P.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(X.length),duration:ue.elapsed(),success:!!he&&(0,c.$Vp)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(z,T,Z,X){if(!this.isEnabled())return;const se=L.$o?this.x(`/itemName/${z}.${T}/version/${Z}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${T}/${Z}/stats?statType=${X}`),ue=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ue};try{await this.k.request({type:"POST",url:se,headers:pe},A.CancellationToken.None)}catch{}}async download(z,T,Z){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const X=(0,y.$Ip)(z),se=new Date().getTime(),ue=Z===2?"install":Z===3?"update":"",he=ue?{uri:`${z.assets.download.uri}${l.URI.parse(z.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${z.assets.download.fallbackUri}${l.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:z.assets.download,pe=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,ye=await this.D(z.identifier.id,he,o.VSIX,pe?{headers:pe}:void 0);try{await this.q.writeFile(T,ye.stream)}catch(fe){try{await this.q.del(T)}catch(me){this.l.warn(`Error while deleting the file ${T.toString()}`,(0,P.$0)(me))}throw new b.$ap((0,P.$0)(fe),"DownloadFailedWriting")}this.o.publicLog("galleryService:downloadVSIX",{...X,duration:new Date().getTime()-se})}async downloadSignatureArchive(z,T){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const Z=await this.D(z.identifier.id,z.assets.signature,o.Signature);try{await this.q.writeFile(T,Z.stream)}catch(X){try{await this.q.del(T)}catch(se){this.l.warn(`Error while deleting the file ${T.toString()}`,(0,P.$0)(se))}throw new b.$ap((0,P.$0)(X),"DownloadFailedWriting")}}async getReadme(z,T){if(z.assets.readme){const Z=await this.D(z.identifier.id,z.assets.readme,o.Details,{},T);return await(0,c.$Yp)(Z)||""}return""}async getManifest(z,T){if(z.assets.manifest){const Z=await this.D(z.identifier.id,z.assets.manifest,o.Manifest,{},T),X=await(0,c.$Yp)(Z);return X?JSON.parse(X):null}return null}async C(z,T,Z){const X=ne(T,o.Manifest);if(!X)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},ue=await this.D(z,X,o.Manifest,{headers:se});return await(0,c.$Zp)(ue)}async getCoreTranslation(z,T){const Z=z.assets.coreTranslations.filter(X=>X[0]===T.toUpperCase())[0];if(Z){const X=await this.D(z.identifier.id,Z[1],Z[0]),se=await(0,c.$Yp)(X);return se?JSON.parse(se):null}return null}async getChangelog(z,T){if(z.assets.changelog){const Z=await this.D(z.identifier.id,z.assets.changelog,o.Changelog,{},T);return await(0,c.$Yp)(Z)||""}return""}async getAllCompatibleVersions(z,T,Z){let X=new I().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?X=X.withFilter(s.ExtensionId,z.identifier.uuid):X=X.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:se}=await this.B(X,A.CancellationToken.None);if(!se.length)return[];const ue=G(se[0]);if((0,b.$9o)(ue,Z))return[];const he=[];await Promise.all(se[0].versions.map(async fe=>{try{await this.y(z.identifier.id,fe,T?"any":"release",!0,ue,Z)&&he.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of Y(he,Z))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:ce(fe)}));return pe}async D(z,T,Z,X={},se=A.CancellationToken.None){const ue=await this.j,he={type:"GET"},pe={...ue,...X.headers||{}};X={...X,...he,headers:pe};const ye=T.uri,fe=T.fallbackUri,me={...X,url:ye};try{const de=await this.k.request(me,se);if(de.res.statusCode===200)return de;const we=await(0,c.$Yp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,P.$4)(de))throw de;const we=(0,P.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:Z,message:we});const Ee={...X,url:fe};return this.k.request(Ee,se)}}async E(z,T){let Z=le(T);if(!Z){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:T.version});const X=await this.C(z,T,A.CancellationToken.None);if(!X)throw new Error("Manifest was not found");Z=X.engines.vscode}return Z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const T=await(0,c.$Zp)(z),Z=[],X={},se=[];if(T){for(const ue of T.malicious)Z.push({id:ue});if(T.migrateToPreRelease)for(const[ue,he]of Object.entries(T.migrateToPreRelease))(!he.engine||(0,w.$Sp)(he.engine,this.u.version,this.u.date))&&(X[ue.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(T.deprecated)for(const[ue,he]of Object.entries(T.deprecated))he&&(X[ue.toLowerCase()]=(0,E.$gg)(he)?{}:he);if(T.search)for(const ue of T.search)se.push(ue)}return{malicious:Z,deprecated:X,search:se}}};V=$e([ie(1,c.$Tp),ie(2,R.$7j),ie(3,h.$Hi),ie(4,g.$6l),ie(5,p.$7k),ie(6,d.$nk),ie(7,a.$7i)],V);let C=class extends V{constructor(z,T,Z,X,se,ue,he,pe){super(z,T,Z,X,se,ue,he,pe)}};e.$dq=C,e.$dq=C=$e([ie(0,m.$7p),ie(1,c.$Tp),ie(2,R.$7j),ie(3,h.$Hi),ie(4,g.$6l),ie(5,p.$7k),ie(6,d.$nk),ie(7,a.$7i)],C);let v=class extends V{constructor(z,T,Z,X,se,ue,he){super(void 0,z,T,Z,X,se,ue,he)}};e.$eq=v,e.$eq=v=$e([ie(0,c.$Tp),ie(1,R.$7j),ie(2,h.$Hi),ie(3,g.$6l),ie(4,p.$7k),ie(5,d.$nk),ie(6,a.$7i)],v)}),define(re[167],oe([0,1,11,18,13,6,146,23,24,3,70]),function(Q,e,N,A,P,L,D,E,l,a,h){"use strict";var b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=void 0;let w=class extends l.$Jl{static{b=this}static{this.a="profileAssociationsMigration"}constructor(c,$,m,g,f){super(m,g,$,f),this.U=c,this.W=m}O(){return this.U.getItem(b.b,[]).map($=>({...$,location:(0,a.$ag)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):N.URI.revive($.location)}))}Q(){const c=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(N.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$bQ=w,e.$bQ=w=b=$e([ie(0,D.$9P),ie(1,E.$El),ie(2,A.$Ii),ie(3,P.$7k),ie(4,L.$7j)],w);let p=y=class extends w{constructor(c,$,m,g,f){super(c,$,m,g,f),this.$=c}P(c){c.length?this.$.setItem(y.b,c.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(y.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(y.c,c):this.$.removeItem(y.c)}Q(){const c="workspaceAndProfileInfo",$=this.$.getItem(c,void 0);if($){this.$.removeItem(c);const g=$.reduce((f,{workspace:n,profile:r})=>(f[N.URI.revive(n).toString()]=N.URI.revive(r).toString(),f),{});this.$.setItem(y.c,{workspaces:g})}const m=super.Q();return this.$.getItem(y.a,!1)||(this.R(m),this.$.setItem(y.a,!0)),m}};e.$cQ=p,e.$cQ=p=y=$e([ie(0,D.$0P),ie(1,E.$El),ie(2,A.$Ii),ie(3,P.$7k),ie(4,L.$7j)],p);let R=class extends p{constructor(c,$,m,g){super(new h.$aQ(0,$,g,m),c,$,m,g)}async init(){return await this.$.init(),super.init()}};e.$dQ=R,e.$dQ=R=$e([ie(0,E.$El),ie(1,A.$Ii),ie(2,P.$7k),ie(3,L.$7j)],R)}),define(re[168],oe([0,1,144,8,14,9,3,29,18,145,6,45,143,179]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0,e.$5r=d;let p=class extends b.$Up{constructor($,m,g,f){super(f),this.m=$,this.n=m,this.r=g,this.s(),this.B($.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,m){const{f:g,g:f}=this;let n;try{n=await(0,a.$Km)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$0)(i)))}const r={...process.env,...n},t=$.agent?$.agent:await(0,y.$3r)($.url||"",r,{proxyUrl:g,strictSSL:f});return $.agent=t,$.strictSSL=f,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>d($,m))}async resolveProxy($){}async loadCertificates(){return(await new Promise((m,g)=>{Q(["@vscode/proxy-agent"],m,g)})).loadSystemCertificates({log:this.r})}};e.$4r=p,e.$4r=p=$e([ie(0,E.$7i),ie(1,l.$Ii),ie(2,h.$7j),ie(3,h.$8j)],p);async function R(c){return((0,N.parse)(c.url).protocol==="https:"?await new Promise((g,f)=>{Q(["https"],g,f)}):await new Promise((g,f)=>{Q(["http"],g,f)})).request}async function d(c,$){return A.Promises.withAsyncBody(async(m,g)=>{const f=(0,N.parse)(c.url),n=c.getRawRequest?c.getRawRequest(c):await R(c),r={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,D.$gg)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=n(r,i=>{const s=(0,D.$eg)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)d({...c,url:i.headers.location,followRedirects:s-1},$).then(m,g);else{let o=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,w.createGunzip)())),m({res:i,stream:(0,P.$Ye)(o)})}});t.on("error",g),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),$.onCancellationRequested(()=>{t.abort(),g(new L.$5)})})}}),define(re[180],oe([0,1,33,8,34,9,2,15,16,12,35,11,25,29,140,62,142,18,118,166,20,72,147,42,54,162,164,13,130,132,51,128,65,66,150,6,136,39,137,153,32,45,168,70,71,21,152,41,154,155,23,157,24,167,156,163,133,135,4,158,181]),function(Q,e,N,A,P,L,D,E,l,a,h,b,y,w,p,R,d,c,$,m,g,f,n,r,t,i,s,o,u,S,k,I,j,F,B,J,ne,te,le,ce,ae,W,K,x,M,G,Y,U,q,V,C,v,O,z,T,Z,X,se,ue,he,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends D.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const Ie=Ee.get(J.$7j),H=Ee.get(o.$7k),_=Ee.get(c.$Ii),ee=Ee.get(O.$Gl);Ie.info("CLI main",this.b),this.h(Ie),await this.j(_,H,ee,de),await Promise.all(we.map(ge=>{(0,A.$rh)(ge.flush(),1e3)}))})}async f(){const de=new j.$yi,we={_serviceBrand:void 0,...ce.default};de.set(ae.$nk,we);const Ee=new $.$an(this.b,we);de.set(c.$Ii,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:E.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?y.Promises.mkdir(be,{recursive:!0}):void 0));const Ie=new se.$8P((0,J.$ik)(Ee),Ee.logsHome);de.set(J.$8j,Ie);const H=this.B(Ie.createLogger("cli",{name:(0,ue.localize)(0,null)})),_=[];Ie.getLogLevel()===J.LogLevel.Trace&&_.push(new J.$ck(Ie.getLogLevel()));const ee=this.B(new X.$fQ(H,_));de.set(J.$7j,ee);const ge=this.B(new u.$Oq(ee));de.set(o.$7k,ge);const ve=this.B(new S.$fr(ee));ge.registerProvider(E.Schemas.file,ve);const Ae=new v.$Gs(ge);de.set(C.$El,Ae);const Pe=new x.$_P(1,Ee,ee,ge),Le=new z.$bQ(Pe,Ae,Ee,ge,ee);de.set(O.$Gl,Le),ge.registerProvider(E.Schemas.vscodeUserData,new he.$Oec(E.Schemas.file,ve,E.Schemas.vscodeUserData,Le,Ae,ee));const Re=a.$i&&we.win32RegValueName?this.B(new le.$Mec(ee,we.win32RegValueName)):Ee.policyFile?this.B(new ne.$Nec(Ee.policyFile,ge,ee)):new te.$lo;de.set(te.$jo,Re);const De=this.B(new p.$Lo(Le.defaultProfile.settingsResource,ge,Re,ee));de.set(w.$7i,De),await Promise.all([Pe.init(),De.initialize()]);let qe;try{qe=await(0,T.$qec)(Pe,ee)}catch(be){be.code!=="ENOENT"&&ee.error(be)}const je=await(0,T.$rec)(Pe,ee);Le.init(),de.set(C.$El,new v.$Gs(ge));const Ne=new K.$4r(De,Ee,ee,Ie);de.set(W.$Tp,Ne),de.set(R.$Po,new k.$xi(d.$uQ,void 0,!0)),de.set(r.$vq,new k.$xi(Z.$eQ,void 0,!0)),de.set(t.$zq,new k.$xi(s.$nec,void 0,!0)),de.set(f.$fq,new k.$xi(f.$hq,void 0,!0)),de.set(i.$Kq,new k.$xi(i.$Lq,void 0,!0)),de.set(g.$_o,new k.$xi(m.$eq,void 0,!0)),de.set(F.$Xr,new k.$xi(B.$Zr,void 0,!1));const ze=[],Fe=(0,U.$xp)(we,De);if((0,U.$sp)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new q.$6P(Ne,Fe,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,M.$jp)((0,N.release)(),(0,N.hostname)(),process.arch,we.commit,we.version,qe,je,Fe),piiPaths:(0,U.$yp)(Ee)};de.set(G.$6l,new k.$xi(Y.$6r,[be],!1))}else de.set(G.$6l,U.$np);return[new I.$ir(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,L.setUnexpectedErrorHandler)(we=>{const Ee=(0,P.$lj)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,L.$Z)(we)||(0,L.$1)(we)}),process.on("unhandledRejection",we=>(0,L.$1)(we))}async j(de,we,Ee,Ie){let H;if(de.args.profile&&(H=Ee.profiles.find(ee=>ee.name===de.args.profile),!H))throw new Error(`Profile '${de.args.profile}' not found.`);const _=(H??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Ie.createInstance(n.$iq,new J.$ck(J.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,_);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:_};return Ie.createInstance(n.$iq,new J.$ck(J.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ie.createInstance(n.$iq,new J.$ck(J.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,_);if(this.b["update-extensions"])return Ie.createInstance(n.$iq,new J.$ck(J.LogLevel.Info,!1)).updateExtensions(_);if(this.b["locate-extension"])return Ie.createInstance(n.$iq,new J.$ck(J.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,V.$afc)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?b.URI.file((0,l.$ic)(we)?we:(0,l.$jc)((0,h.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/code/node/cliProcessMain.js.map
