/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],R=0,L=se.length;R<L;R++)e[R]=le[se[R]];return e};define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class R{static get(){const A=new Map,j=new Map,D=new Map,I=new Map;function P(l,c){l.has(c.detail)||l.set(c.detail,-c.timestamp)}function d(l,c){const w=l.get(c.detail);w&&(w>=0||l.set(c.detail,w+c.timestamp))}let E=[];typeof se=="function"&&typeof se.getStats=="function"&&(E=se.getStats().slice(0).sort((l,c)=>l.timestamp-c.timestamp));for(const l of E)switch(l.type){case 10:P(A,l);break;case 11:case 12:d(A,l);break;case 21:P(j,l);break;case 22:d(j,l);break;case 33:P(D,l);break;case 34:d(D,l);break;case 31:P(I,l);break;case 32:d(I,l);break}let v=0;D.forEach(l=>v+=l);function y(l){const c=[];return l.forEach((w,$)=>c.push([$,w])),c}return{amdLoad:y(A),amdInvoke:y(j),nodeRequire:y(D),nodeEval:y(I),nodeRequireTotal:v}}static toMarkdownTable(A,j){let D="";const I=[];return A.forEach((P,d)=>{I[d]=P.length}),j.forEach(P=>{P.forEach((d,E)=>{typeof d>"u"&&(d=P[E]="-");const v=d.toString().length;I[E]=Math.max(v,I[E])})}),A.forEach((P,d)=>{D+=`| ${P+" ".repeat(I[d]-P.toString().length)} `}),D+=`|
`,A.forEach((P,d)=>{D+=`| ${"-".repeat(I[d])} `}),D+=`|
`,j.forEach(P=>{P.forEach((d,E)=>{typeof d<"u"&&(D+=`| ${d+" ".repeat(I[E]-d.toString().length)} `)}),D+=`|
`}),D}}e.$U=R}),define(le[127],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=R,e.$gb=L,e.$hb=A,e.$ib=j,e.$jb=D,e.$kb=I,e.$lb=P,e.$nb=E,e.$ob=v,e.$pb=y,e.$qb=l,e.$rb=c;function R(w,$){const f=L(w,$);if(f!==-1)return w[f]}function L(w,$,f=w.length-1){for(let u=f;u>=0;u--){const h=w[u];if($(h))return u}return-1}function A(w,$){const f=j(w,$);return f===-1?void 0:w[f]}function j(w,$,f=0,u=w.length){let h=f,g=u;for(;h<g;){const m=Math.floor((h+g)/2);$(w[m])?h=m+1:g=m}return h-1}function D(w,$){const f=I(w,$);return f===w.length?void 0:w[f]}function I(w,$,f=0,u=w.length){let h=f,g=u;for(;h<g;){const m=Math.floor((h+g)/2);$(w[m])?g=m:h=m+1}return h}function P(w,$,f=0,u=w.length){const h=I(w,$,f,u);return h===w.length?-1:h}class d{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(d.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!$(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const f=j(this.e,$,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$mb=d;function E(w,$){if(w.length===0)return;let f=w[0];for(let u=1;u<w.length;u++){const h=w[u];$(h,f)>0&&(f=h)}return f}function v(w,$){if(w.length===0)return;let f=w[0];for(let u=1;u<w.length;u++){const h=w[u];$(h,f)>=0&&(f=h)}return f}function y(w,$){return E(w,(f,u)=>-$(f,u))}function l(w,$){if(w.length===0)return-1;let f=0;for(let u=1;u<w.length;u++){const h=w[u];$(h,w[f])>0&&(f=u)}return f}function c(w,$){for(const f of w){const u=$(f);if(u!==void 0)return u}}}),define(le[128],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=R,e.$L=L,e.$M=A,e.$N=j;function R(D,I){const P=Object.create(null);for(const d of D){const E=I(d);let v=P[E];v||(v=P[E]=[]),v.push(d)}return P}function L(D,I){const P=[],d=[];for(const E of D)I.has(E)||P.push(E);for(const E of I)D.has(E)||d.push(E);return{removed:P,added:d}}function A(D,I){const P=[],d=[];for(const[E,v]of D)I.has(E)||P.push(v);for(const[E,v]of I)D.has(E)||d.push(v);return{removed:P,added:d}}function j(D,I){const P=new Set;for(const d of I)D.has(d)&&P.add(d);return P}}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=L,e.$6h=A,e.$7h=j;function R(D){return(I,P,d)=>{let E=null,v=null;if(typeof d.value=="function"?(E="value",v=d.value):typeof d.get=="function"&&(E="get",v=d.get),!v)throw new Error("not supported");d[E]=D(v,P)}}function L(D,I,P){let d=null,E=null;if(typeof P.value=="function"?(d="value",E=P.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(d="get",E=P.get),!E)throw new Error("not supported");const v=`$memoize$${I}`;P[d]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,y)}),this[v]}}function A(D,I,P){return R((d,E)=>{const v=`$debounce$${E}`,y=`$debounce$result$${E}`;return function(...l){this[y]||(this[y]=P?P():void 0),clearTimeout(this[v]),I&&(this[y]=I(this[y],...l),l=[this[y]]),this[v]=setTimeout(()=>{d.apply(this,l),this[y]=P?P():void 0},D)}})}function j(D,I,P){return R((d,E)=>{const v=`$throttle$timer$${E}`,y=`$throttle$result$${E}`,l=`$throttle$lastRun$${E}`,c=`$throttle$pending$${E}`;return function(...w){if(this[y]||(this[y]=P?P():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),I&&(this[y]=I(this[y],...w)),this[c])return;const $=this[l]+D;$<=Date.now()?(this[l]=Date.now(),d.apply(this,[this[y]]),this[y]=P?P():void 0):(this[c]=!0,this[v]=setTimeout(()=>{this[c]=!1,this[l]=Date.now(),d.apply(this,[this[y]]),this[y]=P?P():void 0},$-Date.now()))}})}}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=L,e.$Z=A,e.$1=j,e.$2=D,e.$3=I,e.$4=d,e.$6=v,e.$7=y,e.$8=l,e.$0=w;class R{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=R,e.$X=new R;function L(m){e.$X.setUnexpectedErrorHandler(m)}function A(m){if(!m||typeof m!="object")return!1;const t=m;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function j(m){d(m)||e.$X.onUnexpectedError(m)}function D(m){d(m)||e.$X.onUnexpectedExternalError(m)}function I(m){if(m instanceof Error){const{name:t,message:r}=m,s=m.stacktrace||m.stack;return{$isError:!0,name:t,message:r,stack:s,noTelemetry:h.isErrorNoTelemetry(m)}}return m}const P="Canceled";function d(m){return m instanceof E?!0:m instanceof Error&&m.name===P&&m.message===P}class E extends Error{constructor(){super(P),this.name=this.message}}e.$5=E;function v(){const m=new Error(P);return m.name=m.message,m}function y(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}function l(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function w(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}class $ extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=$;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=f;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const r=new h;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class g extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.$cb=g}),define(le[17],he([0,1,7,127]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=A,e.$tb=j,e.$ub=D,e.$vb=I,e.$wb=P,e.$xb=d,e.$yb=E,e.$zb=v,e.$Ab=y,e.$Bb=l,e.$Cb=c,e.$Db=w,e.$Eb=$,e.top=f,e.$Gb=u,e.$Hb=g,e.$Ib=m,e.$Jb=t,e.$Kb=r,e.$Lb=s,e.$Mb=n,e.$Nb=i,e.$Ob=o,e.$Pb=a,e.$Qb=p,e.$Rb=S,e.$Sb=b,e.$Tb=k,e.$Ub=C,e.$Vb=O,e.$Wb=M,e.$Xb=T,e.$Yb=F,e.$Zb=K,e.$1b=J,e.$2b=Q,e.$3b=H,e.$4b=X,e.$5b=W,e.$6b=re,e.$7b=Z,e.$0b=G;function A(q,_=0){return q[q.length-(1+_)]}function j(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}function D(q,_,ee=(ne,te)=>ne===te){if(q===_)return!0;if(!q||!_||q.length!==_.length)return!1;for(let ne=0,te=q.length;ne<te;ne++)if(!ee(q[ne],_[ne]))return!1;return!0}function I(q,_){const ee=q.length-1;_<ee&&(q[_]=q[ee]),q.pop()}function P(q,_,ee){return d(q.length,ne=>ee(q[ne],_))}function d(q,_){let ee=0,ne=q-1;for(;ee<=ne;){const te=(ee+ne)/2|0,ce=_(te);if(ce<0)ee=te+1;else if(ce>0)ne=te-1;else return te}return-(ee+1)}function E(q,_,ee){if(q=q|0,q>=_.length)throw new TypeError("invalid index");const ne=_[Math.floor(_.length*Math.random())],te=[],ce=[],fe=[];for(const $e of _){const we=ee($e,ne);we<0?te.push($e):we>0?ce.push($e):fe.push($e)}return q<te.length?E(q,te,ee):q<te.length+fe.length?fe[0]:E(q-(te.length+fe.length),ce,ee)}function v(q,_){const ee=[];let ne;for(const te of q.slice(0).sort(_))!ne||_(ne[0],te)!==0?(ne=[te],ee.push(ne)):ne.push(te);return ee}function*y(q,_){let ee,ne;for(const te of q)ne!==void 0&&_(ne,te)?ee.push(te):(ee&&(yield ee),ee=[te]),ne=te;ee&&(yield ee)}function l(q,_){for(let ee=0;ee<=q.length;ee++)_(ee===0?void 0:q[ee-1],ee===q.length?void 0:q[ee])}function c(q,_){for(let ee=0;ee<q.length;ee++)_(ee===0?void 0:q[ee-1],q[ee],ee+1===q.length?void 0:q[ee+1])}function w(q,_,ee){const ne=[];function te($e,we,Ee){if(we===0&&Ee.length===0)return;const be=ne[ne.length-1];be&&be.start+be.deleteCount===$e?(be.deleteCount+=we,be.toInsert.push(...Ee)):ne.push({start:$e,deleteCount:we,toInsert:Ee})}let ce=0,fe=0;for(;;){if(ce===q.length){te(ce,0,_.slice(fe));break}if(fe===_.length){te(ce,q.length-ce,[]);break}const $e=q[ce],we=_[fe],Ee=ee($e,we);Ee===0?(ce+=1,fe+=1):Ee<0?(te(ce,1,[]),ce+=1):Ee>0&&(te(ce,0,[we]),fe+=1)}return ne}function $(q,_,ee){const ne=w(q,_,ee),te=[],ce=[];for(const fe of ne)te.push(...q.slice(fe.start,fe.start+fe.deleteCount)),ce.push(...fe.toInsert);return{removed:te,added:ce}}function f(q,_,ee){if(ee===0)return[];const ne=q.slice(0,ee).sort(_);return h(q,_,ne,ee,q.length),ne}function u(q,_,ee,ne,te){return ee===0?Promise.resolve([]):new Promise((ce,fe)=>{(async()=>{const $e=q.length,we=q.slice(0,ee).sort(_);for(let Ee=ee,be=Math.min(ee+ne,$e);Ee<$e;Ee=be,be=Math.min(be+ne,$e)){if(Ee>ee&&await new Promise(ye=>setTimeout(ye)),te&&te.isCancellationRequested)throw new R.$5;h(q,_,we,Ee,be)}return we})().then(ce,fe)})}function h(q,_,ee,ne,te){for(const ce=ee.length;ne<te;ne++){const fe=q[ne];if(_(fe,ee[ce-1])<0){ee.pop();const $e=(0,L.$kb)(ee,we=>_(fe,we)<0);ee.splice($e,0,fe)}}}function g(q){return q.filter(_=>!!_)}function m(q){let _=0;for(let ee=0;ee<q.length;ee++)q[ee]&&(q[_]=q[ee],_+=1);q.length=_}function t(q,_,ee){q.splice(ee,0,q.splice(_,1)[0])}function r(q){return!Array.isArray(q)||q.length===0}function s(q){return Array.isArray(q)&&q.length>0}function n(q,_=ee=>ee){const ee=new Set;return q.filter(ne=>{const te=_(ne);return ee.has(te)?!1:(ee.add(te),!0)})}function i(q){const _=new Set;return ee=>{const ne=q(ee);return _.has(ne)?!1:(_.add(ne),!0)}}function o(q,_){return q.length>0?q[0]:_}function a(q,_){return q.length>0?q[q.length-1]:_}function p(q,_,ee=(ne,te)=>ne===te){let ne=0;for(let te=0,ce=Math.min(q.length,_.length);te<ce&&ee(q[te],_[te]);te++)ne++;return ne}function S(q,_){let ee=typeof _=="number"?q:0;typeof _=="number"?ee=q:(ee=0,_=q);const ne=[];if(ee<=_)for(let te=ee;te<_;te++)ne.push(te);else for(let te=ee;te>_;te--)ne.push(te);return ne}function b(q,_,ee){return q.reduce((ne,te)=>(ne[_(te)]=ee?ee(te):te,ne),Object.create(null))}function k(q,_){return q.push(_),()=>C(q,_)}function C(q,_){const ee=q.indexOf(_);if(ee>-1)return q.splice(ee,1),_}function O(q,_,ee){const ne=q.slice(0,_),te=q.slice(_);return ne.concat(ee,te)}function M(q,_){let ee;if(typeof _=="number"){let ne=_;ee=()=>{const te=Math.sin(ne++)*179426549;return te-Math.floor(te)}}else ee=Math.random;for(let ne=q.length-1;ne>0;ne-=1){const te=Math.floor(ee()*(ne+1)),ce=q[ne];q[ne]=q[te],q[te]=ce}}function T(q,_){const ee=q.indexOf(_);ee>-1&&(q.splice(ee,1),q.unshift(_))}function F(q,_){const ee=q.indexOf(_);ee>-1&&(q.splice(ee,1),q.push(_))}function K(q,_){for(const ee of _)q.push(ee)}function J(q,_){return Array.isArray(q)?q.map(_):_(q)}function Q(q){return Array.isArray(q)?q:[q]}function H(q){return q[Math.floor(Math.random()*q.length)]}function X(q,_,ee){const ne=B(q,_),te=q.length,ce=ee.length;q.length=te+ce;for(let fe=te-1;fe>=ne;fe--)q[fe+ce]=q[fe];for(let fe=0;fe<ce;fe++)q[fe+ne]=ee[fe]}function W(q,_,ee,ne){const te=B(q,_);let ce=q.splice(te,ee);return ce===void 0&&(ce=[]),X(q,te,ne),ce}function B(q,_){return _<0?Math.max(_+q.length,0):Math.min(_,q.length)}var ie;(function(q){function _(ce){return ce<0}q.isLessThan=_;function ee(ce){return ce<=0}q.isLessThanOrEqual=ee;function ne(ce){return ce>0}q.isGreaterThan=ne;function te(ce){return ce===0}q.isNeitherLessOrGreaterThan=te,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function re(q,_){return(ee,ne)=>_(q(ee),q(ne))}function Z(...q){return(_,ee)=>{for(const ne of q){const te=ne(_,ee);if(!ie.isNeitherLessOrGreaterThan(te))return te}return ie.neitherLessOrGreaterThan}}const z=(q,_)=>q-_;e.$8b=z;const x=(q,_)=>(0,e.$8b)(q?1:0,_?1:0);e.$9b=x;function G(q){return(_,ee)=>-q(_,ee)}class N{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let ee=this.c;for(;ee<this.g.length&&_(this.g[ee]);)ee++;const ne=ee===this.c?null:this.g.slice(this.c,ee);return this.c=ee,ne}takeFromEndWhile(_){let ee=this.d;for(;ee>=0&&_(this.g[ee]);)ee--;const ne=ee===this.d?null:this.g.slice(ee+1,this.d+1);return this.d=ee,ne}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const ee=this.g.slice(this.c,this.c+_);return this.c+=_,ee}}e.$$b=N;class U{static{this.empty=new U(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(ee=>(_(ee),!0))}toArray(){const _=[];return this.iterate(ee=>(_.push(ee),!0)),_}filter(_){return new U(ee=>this.iterate(ne=>_(ne)?ee(ne):!0))}map(_){return new U(ee=>this.iterate(ne=>ee(_(ne))))}some(_){let ee=!1;return this.iterate(ne=>(ee=_(ne),!ee)),ee}findFirst(_){let ee;return this.iterate(ne=>_(ne)?(ee=ne,!1):!0),ee}findLast(_){let ee;return this.iterate(ne=>(_(ne)&&(ee=ne),!0)),ee}findLastMaxBy(_){let ee,ne=!0;return this.iterate(te=>((ne||ie.isGreaterThan(_(te,ee)))&&(ne=!1,ee=te),!0)),ee}}e.$_b=U;class V{constructor(_){this.c=_}static createSortPermutation(_,ee){const ne=Array.from(_.keys()).sort((te,ce)=>ee(_[te],_[ce]));return new V(ne)}apply(_){return _.map((ee,ne)=>_[this.c[ne]])}inverse(){const _=this.c.slice();for(let ee=0;ee<this.c.length;ee++)_[this.c[ee]]=ee;return new V(_)}}e.$ac=V}),define(le[129],he([0,1,7]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.$ed=A,e.$fd=j,e.$gd=D,e.$hd=I,e.$id=P;function L(d,E){if(!d)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function A(d,E="Unreachable"){throw new Error(E)}function j(d,E="unexpected state"){if(!d)throw new R.$cb(`Assertion Failed: ${E}`)}function D(d){d||(0,R.$1)(new R.$cb("Soft Assertion Failed"))}function I(d){if(!d()){debugger;d(),(0,R.$1)(new R.$cb("Assertion Failed"))}}function P(d,E){let v=0;for(;v<d.length-1;){const y=d[v],l=d[v+1];if(!E(y,l))return!1;v++}return!0}}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=R;function R(L,A){const j=this;let D=!1,I;return function(){if(D)return I;if(D=!0,A)try{I=L.apply(j,arguments)}finally{A()}else I=L.apply(j,arguments);return I}}}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(L){function A(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=A;const j=Object.freeze([]);function D(){return j}L.empty=D;function*I(t){yield t}L.single=I;function P(t){return A(t)?t:I(t)}L.wrap=P;function d(t){return t||j}L.from=d;function*E(t){for(let r=t.length-1;r>=0;r--)yield t[r]}L.reverse=E;function v(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=v;function y(t){return t[Symbol.iterator]().next().value}L.first=y;function l(t,r){for(const s of t)if(r(s))return!0;return!1}L.some=l;function c(t,r){for(const s of t)if(r(s))return s}L.find=c;function*w(t,r){for(const s of t)r(s)&&(yield s)}L.filter=w;function*$(t,r){let s=0;for(const n of t)yield r(n,s++)}L.map=$;function*f(...t){for(const r of t)yield*r}L.concat=f;function u(t,r,s){let n=s;for(const i of t)n=r(n,i);return n}L.reduce=u;function*h(t,r,s=t.length){for(r<0&&(r+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);r<s;r++)yield t[r]}L.slice=h;function g(t,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,t];const n=t[Symbol.iterator]();for(let i=0;i<r;i++){const o=n.next();if(o.done)return[s,L.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return n}}]}L.consume=g;async function m(t){const r=[];for await(const s of t)r.push(s);return Promise.resolve(r)}L.asyncToArray=m})(R||(e.Iterable=R={}))}),define(le[35],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Ln=D,e.$Mn=v,e.$Nn=y,e.$On=l,e.$Pn=c,e.$Qn=w,e.$Rn=$,e.$Sn=f,e.$Tn=u,e.$Un=h,e.$Vn=g,e.$Wn=m;var R;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(R||(e.ScanError=R={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var j;(function(t){t.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function D(t,r=!1){let s=0;const n=t.length;let i="",o=0,a=16,p=0;function S(F){let K=0,J=0;for(;K<F;){const Q=t.charCodeAt(s);if(Q>=48&&Q<=57)J=J*16+Q-48;else if(Q>=65&&Q<=70)J=J*16+Q-65+10;else if(Q>=97&&Q<=102)J=J*16+Q-97+10;else break;s++,K++}return K<F&&(J=-1),J}function b(F){s=F,i="",o=0,a=16,p=0}function k(){const F=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&d(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&d(t.charCodeAt(s)))for(s++;s<t.length&&d(t.charCodeAt(s));)s++;else return p=3,t.substring(F,s);let K=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&d(t.charCodeAt(s))){for(s++;s<t.length&&d(t.charCodeAt(s));)s++;K=s}else p=3;return t.substring(F,K)}function C(){let F="",K=s;for(;;){if(s>=n){F+=t.substring(K,s),p=2;break}const J=t.charCodeAt(s);if(J===34){F+=t.substring(K,s),s++;break}if(J===92){if(F+=t.substring(K,s),s++,s>=n){p=2;break}switch(t.charCodeAt(s++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const H=S(4);H>=0?F+=String.fromCharCode(H):p=4;break}default:p=5}K=s;continue}if(J>=0&&J<=31)if(P(J)){F+=t.substring(K,s),p=2;break}else p=6;s++}return F}function O(){if(i="",p=0,o=s,s>=n)return o=n,a=17;let F=t.charCodeAt(s);if(I(F)){do s++,i+=String.fromCharCode(F),F=t.charCodeAt(s);while(I(F));return a=15}if(P(F))return s++,i+=String.fromCharCode(F),F===13&&t.charCodeAt(s)===10&&(s++,i+=`
`),a=14;switch(F){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,i=C(),a=10;case 47:{const K=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!P(t.charCodeAt(s));)s++;return i=t.substring(K,s),a=12}if(t.charCodeAt(s+1)===42){s+=2;const J=n-1;let Q=!1;for(;s<J;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,Q=!0;break}s++}return Q||(s++,p=1),i=t.substring(K,s),a=13}return i+=String.fromCharCode(F),s++,a=16}case 45:if(i+=String.fromCharCode(F),s++,s===n||!d(t.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=k(),a=11;default:for(;s<n&&M(F);)s++,F=t.charCodeAt(s);if(o!==s){switch(i=t.substring(o,s),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(F),s++,a=16}}function M(F){if(I(F)||P(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let F;do F=O();while(F>=12&&F<=15);return F}return{setPosition:b,getPosition:()=>s,scan:r?T:O,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>p}}function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function P(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function v(t,r){const s=[],n=new Object;let i;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function p(S,b,k,C){o.value=S,o.offset=b,o.length=k,o.type=C,o.colonOffset=void 0,i=o}try{h(t,{onObjectBegin:(S,b)=>{if(r<=S)throw n;i=void 0,a=r>S,s.push("")},onObjectProperty:(S,b,k)=>{if(r<b||(p(S,b,k,"property"),s[s.length-1]=S,r<=b+k))throw n},onObjectEnd:(S,b)=>{if(r<=S)throw n;i=void 0,s.pop()},onArrayBegin:(S,b)=>{if(r<=S)throw n;i=void 0,s.push(0)},onArrayEnd:(S,b)=>{if(r<=S)throw n;i=void 0,s.pop()},onLiteralValue:(S,b,k)=>{if(r<b||(p(S,b,k,m(S)),r<=b+k))throw n},onSeparator:(S,b,k)=>{if(r<=b)throw n;if(S===":"&&i&&i.type==="property")i.colonOffset=b,a=!1,i=void 0;else if(S===","){const C=s[s.length-1];typeof C=="number"?s[s.length-1]=C+1:(a=!0,s[s.length-1]=""),i=void 0}}})}catch(S){if(S!==n)throw S}return{path:s,previousNode:i,isAtPropertyKey:a,matches:S=>{let b=0;for(let k=0;b<S.length&&k<s.length;k++)if(S[b]===s[k]||S[b]==="*")b++;else if(S[b]!=="**")return!1;return b===S.length}}}function y(t,r=[],s=j.DEFAULT){let n=null,i=[];const o=[];function a(S){Array.isArray(i)?i.push(S):n!==null&&(i[n]=S)}return h(t,{onObjectBegin:()=>{const S={};a(S),o.push(i),i=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{const S=[];a(S),o.push(i),i=S,n=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:a,onError:(S,b,k)=>{r.push({error:S,offset:b,length:k})}},s),i[0]}function l(t,r=[],s=j.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function o(S){return n.children.push(S),S}h(t,{onObjectBegin:S=>{n=o({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,b,k)=>{n=o({type:"property",offset:b,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:b,length:k,parent:n})},onObjectEnd:(S,b)=>{n.length=S+b-n.offset,n=n.parent,i(S+b)},onArrayBegin:(S,b)=>{n=o({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,b)=>{n.length=S+b-n.offset,n=n.parent,i(S+b)},onLiteralValue:(S,b,k)=>{o({type:m(S),offset:b,length:k,parent:n,value:S}),i(b+k)},onSeparator:(S,b,k)=>{n.type==="property"&&(S===":"?n.colonOffset=b:S===","&&i(b))},onError:(S,b,k)=>{r.push({error:S,offset:b,length:k})}},s);const p=n.children[0];return p&&delete p.parent,p}function c(t,r){if(!t)return;let s=t;for(const n of r)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let i=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===n){s=o.children[1],i=!0;break}if(!i)return}else{const i=n;if(s.type!=="array"||i<0||!Array.isArray(s.children)||i>=s.children.length)return;s=s.children[i]}return s}function w(t){if(!t.parent||!t.parent.children)return[];const r=w(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const r=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(r[s.children[0].value]=$(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}function u(t,r,s=!1){if(f(t,r,s)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=r;i++){const o=u(n[i],r,s);if(o)return o}return t}}function h(t,r,s=j.DEFAULT){const n=D(t,!1);function i(Z){return Z?()=>Z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Z){return Z?z=>Z(z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=i(r.onObjectBegin),p=o(r.onObjectProperty),S=i(r.onObjectEnd),b=i(r.onArrayBegin),k=i(r.onArrayEnd),C=o(r.onLiteralValue),O=o(r.onSeparator),M=i(r.onComment),T=o(r.onError),F=s&&s.disallowComments,K=s&&s.allowTrailingComma;function J(){for(;;){const Z=n.scan();switch(n.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:F||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(Z){case 12:case 13:F?Q(10):M();break;case 16:Q(1);break;case 15:case 14:break;default:return Z}}}function Q(Z,z=[],x=[]){if(T(Z),z.length+x.length>0){let G=n.getToken();for(;G!==17;){if(z.indexOf(G)!==-1){J();break}else if(x.indexOf(G)!==-1)break;G=J()}}}function H(Z){const z=n.getTokenValue();return Z?C(z):p(z),J(),!0}function X(){switch(n.getToken()){case 11:{let Z=0;try{Z=JSON.parse(n.getTokenValue()),typeof Z!="number"&&(Q(2),Z=0)}catch{Q(2)}C(Z);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return J(),!0}function W(){return n.getToken()!==10?(Q(3,[],[2,5]),!1):(H(!1),n.getToken()===6?(O(":"),J(),re()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function B(){a(),J();let Z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Z||Q(4,[],[]),O(","),J(),n.getToken()===2&&K)break}else Z&&Q(6,[],[]);W()||Q(4,[],[2,5]),Z=!0}return S(),n.getToken()!==2?Q(7,[2],[]):J(),!0}function ie(){b(),J();let Z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Z||Q(4,[],[]),O(","),J(),n.getToken()===4&&K)break}else Z&&Q(6,[],[]);re()||Q(4,[],[4,5]),Z=!0}return k(),n.getToken()!==4?Q(8,[4],[]):J(),!0}function re(){switch(n.getToken()){case 3:return ie();case 1:return B();case 10:return H(!0);default:return X()}}return J(),n.getToken()===17?s.allowEmptyContent?!0:(Q(4,[],[]),!1):re()?(n.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}function g(t,r){const s=D(t),n=[];let i,o=0,a;do switch(a=s.getPosition(),i=s.scan(),i){case 12:case 13:case 17:o!==a&&n.push(t.substring(o,a)),r!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,r)),o=s.getPosition();break}while(i!==17);return n.join("")}function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[44],he([0,1,35]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=L,e.$Yn=A,e.$Zn=I,e.$1n=P;function L(d,E,v){let y,l,c,w,$;if(E){for(w=E.offset,$=w+E.length,c=w;c>0&&!P(d,c-1);)c--;let a=$;for(;a<d.length&&!P(d,a);)a++;l=d.substring(c,a),y=D(l,v)}else l=d,y=0,c=0,w=0,$=d.length;const f=I(v,d);let u=!1,h=0,g;v.insertSpaces?g=j(" ",v.tabSize||4):g="	";const m=(0,R.$Ln)(l,!1);let t=!1;function r(){return f+j(g,y+h)}function s(){let a=m.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=m.scan();return t=a===16||m.getTokenError()!==0,a}const n=[];function i(a,p,S){!t&&p<$&&S>w&&d.substring(p,S)!==a&&n.push({offset:p,length:S-p,content:a})}let o=s();if(o!==17){const a=m.getTokenOffset()+c,p=j(g,y);i(p,c,a)}for(;o!==17;){let a=m.getTokenOffset()+m.getTokenLength()+c,p=s(),S="";for(;!u&&(p===12||p===13);){const k=m.getTokenOffset()+c;i(" ",a,k),a=m.getTokenOffset()+m.getTokenLength()+c,S=p===12?r():"",p=s()}if(p===2)o!==1&&(h--,S=r());else if(p===4)o!==3&&(h--,S=r());else{switch(o){case 3:case 1:h++,S=r();break;case 5:case 12:S=r();break;case 13:u?S=r():S=" ";break;case 6:S=" ";break;case 10:if(p===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?S=" ":p!==5&&p!==17&&(t=!0);break;case 16:t=!0;break}u&&(p===12||p===13)&&(S=r())}const b=m.getTokenOffset()+c;i(S,a,b),o=p}return n}function A(d,E){const v=JSON.stringify(d,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?v.replace(/\r\n|\r|\n/g,E.eol):v}function j(d,E){let v="";for(let y=0;y<E;y++)v+=d;return v}function D(d,E){let v=0,y=0;const l=E.tabSize||4;for(;v<d.length;){const c=d.charAt(v);if(c===" ")y++;else if(c==="	")y+=l;else break;v++}return Math.floor(y/l)}function I(d,E){for(let v=0;v<E.length;v++){const y=E.charAt(v);if(y==="\r")return v+1<E.length&&E.charAt(v+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return d&&d.eol||`
`}function P(d,E){return`\r
`.indexOf(d.charAt(E))!==-1}}),define(le[62],he([0,1,35,44]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=A,e.$3n=j,e.$4n=D,e.$5n=I,e.$6n=P;function A(d,E,v){return j(d,E,void 0,v)}function j(d,E,v,y,l){const c=E.slice(),w=[],$=(0,R.$On)(d,w);let f,u;for(;c.length>0&&(u=c.pop(),f=(0,R.$Pn)($,c),f===void 0&&v!==void 0);)typeof u=="string"?v={[u]:v}:v=[v];if(f)if(f.type==="object"&&typeof u=="string"&&Array.isArray(f.children)){const h=(0,R.$Pn)(f,[u]);if(h!==void 0)if(v===void 0){if(!h.parent)throw new Error("Malformed AST");const g=f.children.indexOf(h.parent);let m,t=h.parent.offset+h.parent.length;if(g>0){const r=f.children[g-1];m=r.offset+r.length}else m=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return D(d,{offset:m,length:t-m,content:""},y)}else return D(d,{offset:h.offset,length:h.length,content:JSON.stringify(v)},y);else{if(v===void 0)return[];const g=`${JSON.stringify(u)}: ${JSON.stringify(v)}`,m=l?l(f.children.map(r=>r.children[0].value)):f.children.length;let t;if(m>0){const r=f.children[m-1];t={offset:r.offset+r.length,length:0,content:","+g}}else f.children.length===0?t={offset:f.offset+1,length:0,content:g}:t={offset:f.offset+1,length:0,content:g+","};return D(d,t,y)}}else if(f.type==="array"&&typeof u=="number"&&Array.isArray(f.children))if(v!==void 0){const h=`${JSON.stringify(v)}`;let g;if(f.children.length===0||u===0)g={offset:f.offset+1,length:0,content:f.children.length===0?h:h+","};else{const m=u===-1||u>f.children.length?f.children.length:u,t=f.children[m-1];g={offset:t.offset+t.length,length:0,content:","+h}}return D(d,g,y)}else{const h=u,g=f.children[h];let m;if(f.children.length===1)m={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===h){const t=f.children[h-1],r=t.offset+t.length,s=f.offset+f.length;m={offset:r,length:s-2-r,content:""}}else m={offset:g.offset,length:f.children[h+1].offset-g.offset,content:""};return D(d,m,y)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${f.type}`);else return v===void 0?[]:D(d,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(v)},y)}function D(d,E,v){let y=I(d,E),l=E.offset,c=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;l>0&&!(0,L.$1n)(y,l-1);)l--;for(;c<y.length&&!(0,L.$1n)(y,c);)c++}const w=(0,L.$Xn)(y,{offset:l,length:c-l},v);for(let f=w.length-1;f>=0;f--){const u=w[f];y=I(y,u),l=Math.min(l,u.offset),c=Math.max(c,u.offset+u.length),c+=u.content.length-u.length}const $=d.length-(y.length-c)-l;return[{offset:l,length:$,content:y.substring(l,c)}]}function I(d,E){return d.substring(0,E.offset)+E.content+d.substring(E.offset+E.length)}function P(d,E){const v=E.slice(0).sort((l,c)=>{const w=l.offset-c.offset;return w===0?l.length-c.length:w});let y=d.length;for(let l=v.length-1;l>=0;l--){const c=v[l];if(c.offset+c.length<=y)d=I(d,c);else throw new Error("Overlapping edit");y=c.offset}return d}}),define(le[53],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class R{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=R}),define(le[87],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class R{static{this.Undefined=new R(void 0)}constructor(j){this.element=j,this.next=R.Undefined,this.prev=R.Undefined}}class L{constructor(){this.a=R.Undefined,this.b=R.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===R.Undefined}clear(){let j=this.a;for(;j!==R.Undefined;){const D=j.next;j.prev=R.Undefined,j.next=R.Undefined,j=D}this.a=R.Undefined,this.b=R.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,D){const I=new R(j);if(this.a===R.Undefined)this.a=I,this.b=I;else if(D){const d=this.b;this.b=I,I.prev=d,d.next=I}else{const d=this.a;this.a=I,I.next=d,d.prev=I}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(I))}}shift(){if(this.a!==R.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==R.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==R.Undefined&&j.next!==R.Undefined){const D=j.prev;D.next=j.next,j.next.prev=D}else j.prev===R.Undefined&&j.next===R.Undefined?(this.a=R.Undefined,this.b=R.Undefined):j.next===R.Undefined?(this.b=this.b.prev,this.b.next=R.Undefined):j.prev===R.Undefined&&(this.a=this.a.next,this.a.prev=R.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==R.Undefined;)yield j.element,j=j.next}}e.$5c=L}),define(le[34],he([0,1]),function(se,e){"use strict";var R,L,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=j,e.$yc=D,e.$zc=I,e.$Ic=g;function j(m,t,r){let s=m.get(t);return s===void 0&&(s=r,m.set(t,s)),s}function D(m){const t=[];return m.forEach((r,s)=>{t.push(`${s} => ${r}`)}),`Map(${m.size}) {${t.join(", ")}}`}function I(m){const t=[];return m.forEach(r=>{t.push(r)}),`Set(${m.size}) {${t.join(", ")}}`}class P{constructor(t,r){this.uri=t,this.value=r}}function d(m){return Array.isArray(m)}class E{static{this.c=t=>t.toString()}constructor(t,r){if(this[R]="ResourceMap",t instanceof E)this.d=new Map(t.d),this.e=r??E.c;else if(d(t)){this.d=new Map,this.e=r??E.c;for(const[s,n]of t)this.set(s,n)}else this.d=new Map,this.e=t??E.c}set(t,r){return this.d.set(this.e(t),new P(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[s,n]of this.d)t(n.value,n.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=E;class v{constructor(t,r){this[L]="ResourceSet",!t||typeof t=="function"?this.c=new E(t):(this.c=new E(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((s,n)=>t.call(r,n,n,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=v;var y;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class l{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const s=this.c.get(t);if(s)return r!==0&&this.m(s,r),s.value}set(t,r,s=0){let n=this.c.get(t);if(n)n.value=r,s!==0&&this.m(n,s);else{switch(n={key:t,value:r,next:void 0,previous:void 0},s){case 0:this.k(n);break;case 1:this.j(n);break;case 2:this.k(n);break;default:this.k(n);break}this.c.set(t,n),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const s=this.g;let n=this.d;for(;n;){if(r?t.bind(r)(n.value,n.key,this):t(n.value,n.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const t=this,r=this.g;let s=this.d;const n={[Symbol.iterator](){return n},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const i={value:s.key,done:!1};return s=s.next,i}else return{value:void 0,done:!0}}};return n}values(){const t=this,r=this.g;let s=this.d;const n={[Symbol.iterator](){return n},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const i={value:s.value,done:!1};return s=s.next,i}else return{value:void 0,done:!0}}};return n}entries(){const t=this,r=this.g;let s=this.d;const n={[Symbol.iterator](){return n},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const i={value:[s.key,s.value],done:!1};return s=s.next,i}else return{value:void 0,done:!0}}};return n}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.next,s--;this.d=r,this.f=s,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.previous,s--;this.e=r,this.f=s,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,s=t.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const s=t.next,n=t.previous;t===this.e?(n.next=void 0,this.e=n):(s.previous=n,n.next=s),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const s=t.next,n=t.previous;t===this.d?(s.previous=void 0,this.d=s):(s.previous=n,n.next=s),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,s)=>{t.push([s,r])}),t}fromJSON(t){this.clear();for(const[r,s]of t)this.set(r,s)}}e.$Cc=l;class c extends l{constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class w extends c{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Dc=w;class $ extends c{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Ec=$;class f{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Fc=f;class u{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,s]of t)this.set(r,s)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((s,n)=>{t.call(r,s,n,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=u;class h{constructor(){this.c=new Map}add(t,r){let s=this.c.get(t);s||(s=new Set,this.c.set(t,s)),s.add(r)}delete(t,r){const s=this.c.get(t);s&&(s.delete(r),s.size===0&&this.c.delete(t))}forEach(t,r){const s=this.c.get(t);s&&s.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Hc=h;function g(m,t){if(m===t)return!0;if(m.size!==t.size)return!1;for(const[r,s]of m)if(!t.has(r)||t.get(r)!==s)return!1;for(const[r]of t)if(!m.has(r))return!1;return!0}}),define(le[2],he([0,1,17,128,34,86,61]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=E,e.$Lc=v,e.$Mc=y,e.$Nc=w,e.$Oc=$,e.$Pc=f,e.$Qc=u,e.$Rc=h,e.$Sc=g,e.$3c=S;const I=!1;let P=null;class d{constructor(){this.b=new Map}static{this.a=0}c(C){let O=this.b.get(C);return O||(O={parent:null,source:null,isSingleton:!1,value:C,idx:d.a++},this.b.set(C,O)),O}trackDisposable(C){const O=this.c(C);O.source||(O.source=new Error().stack)}setParent(C,O){const M=this.c(C);M.parent=O}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,O){const M=O.get(C);if(M)return M;const T=C.parent?this.f(this.c(C.parent),O):C;return O.set(C,T),T}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,C).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(C=10,O){let M;if(O)M=O;else{const Q=new Map,H=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,Q).isSingleton);if(H.length===0)return;const X=new Set(H.map(W=>W.value));if(M=H.filter(W=>!(W.parent&&X.has(W.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function T(Q){function H(W,B){for(;W.length>0&&B.some(ie=>typeof ie=="string"?ie===W[0]:W[0].match(ie));)W.shift()}const X=Q.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return H(X,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),X.reverse()}const F=new A.$Hc;for(const Q of M){const H=T(Q);for(let X=0;X<=H.length;X++)F.add(H.slice(0,X).join(`
`),Q)}M.sort((0,R.$6b)(Q=>Q.idx,R.$8b));let K="",J=0;for(const Q of M.slice(0,C)){J++;const H=T(Q),X=[];for(let W=0;W<H.length;W++){let B=H[W];B=`(shared with ${F.get(H.slice(0,W+1).join(`
`)).size}/${M.length} leaks) at ${B}`;const re=F.get(H.slice(0,W).join(`
`)),Z=(0,L.$K)([...re].map(z=>T(z)[W]),z=>z);delete Z[H[W]];for(const[z,x]of Object.entries(Z))X.unshift(`    - stacktraces of ${x.length} other leaks continue with ${z}`);X.unshift(B)}K+=`


==================== Leaking disposable ${J}/${M.length}: ${Q.value.constructor.name} ====================
${X.join(`
`)}
============================================================

`}return M.length>C&&(K+=`


... and ${M.length-C} more leaking disposables

`),{leaks:M,details:K}}}e.$Jc=d;function E(k){P=k}if(I){const k="__is_disposable_tracked__";E(new class{trackDisposable(C){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[k]||console.log(O)},3e3)}setParent(C,O){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsSingleton(C){}})}function v(k){return P?.trackDisposable(k),k}function y(k){P?.markAsDisposed(k)}function l(k,C){P?.setParent(k,C)}function c(k,C){if(P)for(const O of k)P.setParent(O,C)}function w(k){return P?.markAsSingleton(k),k}function $(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function f(k){if(D.Iterable.is(k)){const C=[];for(const O of k)if(O)try{O.dispose()}catch(M){C.push(M)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function u(k){for(const C of k)$(C)&&C.dispose();return[]}function h(...k){const C=g(()=>f(k));return c(k,C),C}function g(k){const C=v({dispose:(0,j.$db)(()=>{y(C),k()})});return C}class m{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(y(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return l(C,this),this.g?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),l(C,null))}}e.$Tc=m;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new m,v(this),l(this.q,this)}dispose(){y(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class r{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&l(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&l(C,null),C}}e.$Vc=r;class s{constructor(C){this.a=new r,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class n{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=n;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(C){let O=C;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,y(this))},this}}e.$Yc=i;class o{constructor(){this.a=new Map}acquire(C,...O){let M=this.a.get(C);M||(M={counter:0,object:this.b(C,...O)},this.a.set(C,M));const{object:T}=M,F=(0,j.$db)(()=>{--M.counter===0&&(this.c(C,M.object),this.a.delete(C))});return M.counter++,{object:T,dispose:F}}}e.$Zc=o;class a{constructor(C){this.a=C}async acquire(C,...O){const M=this.a.acquire(C,...O);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.$1c=a;class p{constructor(C){this.object=C}dispose(){}}e.$2c=p;function S(k){const C=new m;try{k(C)}finally{C.dispose()}}class b{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,O,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(C)?.dispose(),this.a.set(C,O)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=b}),define(le[88],he([0,1,34]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=void 0,e.$fm=A,e.$gm=D;const L=new R.$Dc(1e4);function A(d){return P(d,"NFC",L)}const j=new R.$Dc(1e4);function D(d){return P(d,"NFD",j)}const I=/[^\u0000-\u0080]/;function P(d,E,v){if(!d)return d;const y=v.get(d);if(y)return y;let l;return I.test(d)?l=d.normalize(E):l=d,v.set(d,l),l}e.$hm=function(){const d=/[\u0300-\u036f]/g;return function(E){return D(E).replace(d,"")}}()}),function(){function se(A){const j=[];typeof A=="number"&&j.push("code/timeOrigin",A);function D(P){j.push(P,Date.now())}function I(){const P=[];for(let d=0;d<j.length;d+=2)P.push({name:j[d],startTime:j[d+1]});return P}return{mark:D,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const D of performance.getEntriesByType("mark"))j.push({name:D.name,startTime:Math.round(A+D.startTime)});return j}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function R(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=R(L))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var L in R)(typeof exports=="object"?exports:se)[L]=R[L]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function R(L){if(e[L])return e[L].exports;var A=e[L]={i:L,l:!1,exports:{}};return se[L].call(A.exports,A,A.exports,R),A.l=!0,A.exports}return R.m=se,R.c=e,R.d=function(L,A,j){R.o(L,A)||Object.defineProperty(L,A,{enumerable:!0,get:j})},R.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},R.t=function(L,A){if(1&A&&(L=R(L)),8&A||4&A&&typeof L=="object"&&L&&L.__esModule)return L;var j=Object.create(null);if(R.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:L}),2&A&&typeof L!="string")for(var D in L)R.d(j,D,function(I){return L[I]}.bind(null,D));return j},R.n=function(L){var A=L&&L.__esModule?function(){return L.default}:function(){return L};return R.d(A,"a",A),A},R.o=function(L,A){return Object.prototype.hasOwnProperty.call(L,A)},R.p="",R(R.s=0)}([function(se,e,R){(function(L){var A;e=se.exports=x,A=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],P=e.src=[],d=0,E=d++;P[E]="0|[1-9]\\d*";var v=d++;P[v]="[0-9]+";var y=d++;P[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=d++;P[l]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var c=d++;P[c]="("+P[v]+")\\.("+P[v]+")\\.("+P[v]+")";var w=d++;P[w]="(?:"+P[E]+"|"+P[y]+")";var $=d++;P[$]="(?:"+P[v]+"|"+P[y]+")";var f=d++;P[f]="(?:-("+P[w]+"(?:\\."+P[w]+")*))";var u=d++;P[u]="(?:-?("+P[$]+"(?:\\."+P[$]+")*))";var h=d++;P[h]="[0-9A-Za-z-]+";var g=d++;P[g]="(?:\\+("+P[h]+"(?:\\."+P[h]+")*))";var m=d++,t="v?"+P[l]+P[f]+"?"+P[g]+"?";P[m]="^"+t+"$";var r="[v=\\s]*"+P[c]+P[u]+"?"+P[g]+"?",s=d++;P[s]="^"+r+"$";var n=d++;P[n]="((?:<|>)?=?)";var i=d++;P[i]=P[v]+"|x|X|\\*";var o=d++;P[o]=P[E]+"|x|X|\\*";var a=d++;P[a]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[f]+")?"+P[g]+"?)?)?";var p=d++;P[p]="[v=\\s]*("+P[i]+")(?:\\.("+P[i]+")(?:\\.("+P[i]+")(?:"+P[u]+")?"+P[g]+"?)?)?";var S=d++;P[S]="^"+P[n]+"\\s*"+P[a]+"$";var b=d++;P[b]="^"+P[n]+"\\s*"+P[p]+"$";var k=d++;P[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=d++;P[C]="(?:~>?)";var O=d++;P[O]="(\\s*)"+P[C]+"\\s+",I[O]=new RegExp(P[O],"g");var M=d++;P[M]="^"+P[C]+P[a]+"$";var T=d++;P[T]="^"+P[C]+P[p]+"$";var F=d++;P[F]="(?:\\^)";var K=d++;P[K]="(\\s*)"+P[F]+"\\s+",I[K]=new RegExp(P[K],"g");var J=d++;P[J]="^"+P[F]+P[a]+"$";var Q=d++;P[Q]="^"+P[F]+P[p]+"$";var H=d++;P[H]="^"+P[n]+"\\s*("+r+")$|^$";var X=d++;P[X]="^"+P[n]+"\\s*("+t+")$|^$";var W=d++;P[W]="(\\s*)"+P[n]+"\\s*("+r+"|"+P[a]+")",I[W]=new RegExp(P[W],"g");var B=d++;P[B]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=d++;P[ie]="^\\s*("+P[p]+")\\s+-\\s+("+P[p]+")\\s*$";var re=d++;P[re]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)A(Z,P[Z]),I[Z]||(I[Z]=new RegExp(P[Z]));function z(ae,de){if(ae instanceof x)return ae;if(typeof ae!="string"||ae.length>j||!(de?I[s]:I[m]).test(ae))return null;try{return new x(ae,de)}catch{return null}}function x(ae,de){if(ae instanceof x){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof x))return new x(ae,de);A("SemVer",ae,de),this.loose=de;var me=ae.trim().match(de?I[s]:I[m]);if(!me)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Re=+Ie;if(Re>=0&&Re<D)return Re}return Ie}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=z,e.valid=function(ae,de){var me=z(ae,de);return me?me.version:null},e.clean=function(ae,de){var me=z(ae.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(ae){return A("SemVer.compare",this.version,this.loose,ae),ae instanceof x||(ae=new x(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},x.prototype.compareMain=function(ae){return ae instanceof x||(ae=new x(ae,this.loose)),N(this.major,ae.major)||N(this.minor,ae.minor)||N(this.patch,ae.patch)},x.prototype.comparePre=function(ae){if(ae instanceof x||(ae=new x(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Ie=ae.prerelease[de];if(A("prerelease compare",de,me,Ie),me===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(me===void 0)return-1;if(me!==Ie)return N(me,Ie)}while(++de)},x.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,me,Ie){typeof me=="string"&&(Ie=me,me=void 0);try{return new x(ae,me).inc(de,Ie).version}catch{return null}},e.diff=function(ae,de){if(_(ae,de))return null;var me=z(ae),Ie=z(de);if(me.prerelease.length||Ie.prerelease.length){for(var Re in me)if((Re==="major"||Re==="minor"||Re==="patch")&&me[Re]!==Ie[Re])return"pre"+Re;return"prerelease"}for(var Re in me)if((Re==="major"||Re==="minor"||Re==="patch")&&me[Re]!==Ie[Re])return Re},e.compareIdentifiers=N;var G=/^[0-9]+$/;function N(ae,de){var me=G.test(ae),Ie=G.test(de);return me&&Ie&&(ae=+ae,de=+de),me&&!Ie?-1:Ie&&!me?1:ae<de?-1:ae>de?1:0}function U(ae,de,me){return new x(ae,me).compare(new x(de,me))}function V(ae,de,me){return U(ae,de,me)>0}function q(ae,de,me){return U(ae,de,me)<0}function _(ae,de,me){return U(ae,de,me)===0}function ee(ae,de,me){return U(ae,de,me)!==0}function ne(ae,de,me){return U(ae,de,me)>=0}function te(ae,de,me){return U(ae,de,me)<=0}function ce(ae,de,me,Ie){var Re;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Re=ae===me;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof me=="object"&&(me=me.version),Re=ae!==me;break;case"":case"=":case"==":Re=_(ae,me,Ie);break;case"!=":Re=ee(ae,me,Ie);break;case">":Re=V(ae,me,Ie);break;case">=":Re=ne(ae,me,Ie);break;case"<":Re=q(ae,me,Ie);break;case"<=":Re=te(ae,me,Ie);break;default:throw new TypeError("Invalid operator: "+de)}return Re}function fe(ae,de){if(ae instanceof fe){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof fe))return new fe(ae,de);A("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ae,de){return N(de,ae)},e.major=function(ae,de){return new x(ae,de).major},e.minor=function(ae,de){return new x(ae,de).minor},e.patch=function(ae,de){return new x(ae,de).patch},e.compare=U,e.compareLoose=function(ae,de){return U(ae,de,!0)},e.rcompare=function(ae,de,me){return U(de,ae,me)},e.sort=function(ae,de){return ae.sort(function(me,Ie){return e.compare(me,Ie,de)})},e.rsort=function(ae,de){return ae.sort(function(me,Ie){return e.rcompare(me,Ie,de)})},e.gt=V,e.lt=q,e.eq=_,e.neq=ee,e.gte=ne,e.lte=te,e.cmp=ce,e.Comparator=fe;var $e={};function we(ae,de){if(ae instanceof we)return ae.loose===de?ae:new we(ae.raw,de);if(ae instanceof fe)return new we(ae.value,de);if(!(this instanceof we))return new we(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ee(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function be(ae,de,me,Ie,Re,je,Oe,Te,Le,Fe,Ve,Ne,Me){return((de=Ee(me)?"":Ee(Ie)?">="+me+".0.0":Ee(Re)?">="+me+"."+Ie+".0":">="+de)+" "+(Te=Ee(Le)?"":Ee(Fe)?"<"+(+Le+1)+".0.0":Ee(Ve)?"<"+Le+"."+(+Fe+1)+".0":Ne?"<="+Le+"."+Fe+"."+Ve+"-"+Ne:"<="+Te)).trim()}function ye(ae,de){for(var me=0;me<ae.length;me++)if(!ae[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<ae.length;me++)if(A(ae[me].semver),ae[me].semver!==$e&&ae[me].semver.prerelease.length>0){var Ie=ae[me].semver;if(Ie.major===de.major&&Ie.minor===de.minor&&Ie.patch===de.patch)return!0}return!1}return!0}function Pe(ae,de,me){try{de=new we(de,me)}catch{return!1}return de.test(ae)}function Ce(ae,de,me,Ie){var Re,je,Oe,Te,Le;switch(ae=new x(ae,Ie),de=new we(de,Ie),me){case">":Re=V,je=te,Oe=q,Te=">",Le=">=";break;case"<":Re=q,je=ne,Oe=V,Te="<",Le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(ae,de,Ie))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var Ve=de.set[Fe],Ne=null,Me=null;if(Ve.forEach(function(qe){qe.semver===$e&&(qe=new fe(">=0.0.0")),Ne=Ne||qe,Me=Me||qe,Re(qe.semver,Ne.semver,Ie)?Ne=qe:Oe(qe.semver,Me.semver,Ie)&&(Me=qe)}),Ne.operator===Te||Ne.operator===Le||(!Me.operator||Me.operator===Te)&&je(ae,Me.semver)||Me.operator===Le&&Oe(ae,Me.semver))return!1}return!0}fe.prototype.parse=function(ae){var de=this.loose?I[H]:I[X],me=ae.match(de);if(!me)throw new TypeError("Invalid comparator: "+ae);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new x(me[2],this.loose):this.semver=$e},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(ae){return A("Comparator.test",ae,this.loose),this.semver===$e||(typeof ae=="string"&&(ae=new x(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(ae,de){if(!(ae instanceof fe))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new we(ae.value,de),Pe(this.value,me,de);if(ae.operator==="")return me=new we(this.value,de),Pe(ae.semver,me,de);var Ie=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),je=this.semver.version===ae.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Te=ce(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Le=ce(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ie||Re||je&&Oe||Te||Le},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),A("range",ae,de);var me=de?I[ie]:I[B];ae=ae.replace(me,be),A("hyphen replace",ae),ae=ae.replace(I[W],"$1$2$3"),A("comparator trim",ae,I[W]),ae=(ae=(ae=ae.replace(I[O],"$1~")).replace(I[K],"$1^")).split(/\s+/).join(" ");var Ie=de?I[H]:I[X],Re=ae.split(" ").map(function(je){return function(Oe,Te){return A("comp",Oe),Oe=function(Le,Fe){return Le.trim().split(/\s+/).map(function(Ve){return function(Ne,Me){A("caret",Ne,Me);var qe=Me?I[Q]:I[J];return Ne.replace(qe,function(oe,ue,ge,pe,ke){var De;return A("caret",Ne,oe,ue,ge,pe,ke),Ee(ue)?De="":Ee(ge)?De=">="+ue+".0.0 <"+(+ue+1)+".0.0":Ee(pe)?De=ue==="0"?">="+ue+"."+ge+".0 <"+ue+"."+(+ge+1)+".0":">="+ue+"."+ge+".0 <"+(+ue+1)+".0.0":ke?(A("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),De=ue==="0"?ge==="0"?">="+ue+"."+ge+"."+pe+ke+" <"+ue+"."+ge+"."+(+pe+1):">="+ue+"."+ge+"."+pe+ke+" <"+ue+"."+(+ge+1)+".0":">="+ue+"."+ge+"."+pe+ke+" <"+(+ue+1)+".0.0"):(A("no pr"),De=ue==="0"?ge==="0"?">="+ue+"."+ge+"."+pe+" <"+ue+"."+ge+"."+(+pe+1):">="+ue+"."+ge+"."+pe+" <"+ue+"."+(+ge+1)+".0":">="+ue+"."+ge+"."+pe+" <"+(+ue+1)+".0.0"),A("caret return",De),De})}(Ve,Fe)}).join(" ")}(Oe,Te),A("caret",Oe),Oe=function(Le,Fe){return Le.trim().split(/\s+/).map(function(Ve){return function(Ne,Me){var qe=Me?I[T]:I[M];return Ne.replace(qe,function(oe,ue,ge,pe,ke){var De;return A("tilde",Ne,oe,ue,ge,pe,ke),Ee(ue)?De="":Ee(ge)?De=">="+ue+".0.0 <"+(+ue+1)+".0.0":Ee(pe)?De=">="+ue+"."+ge+".0 <"+ue+"."+(+ge+1)+".0":ke?(A("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),De=">="+ue+"."+ge+"."+pe+ke+" <"+ue+"."+(+ge+1)+".0"):De=">="+ue+"."+ge+"."+pe+" <"+ue+"."+(+ge+1)+".0",A("tilde return",De),De})}(Ve,Fe)}).join(" ")}(Oe,Te),A("tildes",Oe),Oe=function(Le,Fe){return A("replaceXRanges",Le,Fe),Le.split(/\s+/).map(function(Ve){return function(Ne,Me){Ne=Ne.trim();var qe=Me?I[b]:I[S];return Ne.replace(qe,function(oe,ue,ge,pe,ke,De){A("xRange",Ne,oe,ue,ge,pe,ke,De);var Ue=Ee(ge),We=Ue||Ee(pe),Be=We||Ee(ke);return ue==="="&&Be&&(ue=""),Ue?oe=ue===">"||ue==="<"?"<0.0.0":"*":ue&&Be?(We&&(pe=0),Be&&(ke=0),ue===">"?(ue=">=",We?(ge=+ge+1,pe=0,ke=0):Be&&(pe=+pe+1,ke=0)):ue==="<="&&(ue="<",We?ge=+ge+1:pe=+pe+1),oe=ue+ge+"."+pe+"."+ke):We?oe=">="+ge+".0.0 <"+(+ge+1)+".0.0":Be&&(oe=">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0"),A("xRange return",oe),oe})}(Ve,Fe)}).join(" ")}(Oe,Te),A("xrange",Oe),Oe=function(Le,Fe){return A("replaceStars",Le,Fe),Le.trim().replace(I[re],"")}(Oe,Te),A("stars",Oe),Oe}(je,de)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(je){return!!je.match(Ie)})),Re=Re.map(function(je){return new fe(je,de)})},we.prototype.intersects=function(ae,de){if(!(ae instanceof we))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Ie){return ae.set.some(function(Re){return Re.every(function(je){return Ie.intersects(je,de)})})})})},e.toComparators=function(ae,de){return new we(ae,de).set.map(function(me){return me.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new x(ae,this.loose));for(var de=0;de<this.set.length;de++)if(ye(this.set[de],ae))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(ae,de,me){var Ie=null,Re=null;try{var je=new we(de,me)}catch{return null}return ae.forEach(function(Oe){je.test(Oe)&&(Ie&&Re.compare(Oe)!==-1||(Re=new x(Ie=Oe,me)))}),Ie},e.minSatisfying=function(ae,de,me){var Ie=null,Re=null;try{var je=new we(de,me)}catch{return null}return ae.forEach(function(Oe){je.test(Oe)&&(Ie&&Re.compare(Oe)!==1||(Re=new x(Ie=Oe,me)))}),Ie},e.validRange=function(ae,de){try{return new we(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,me){return Ce(ae,de,"<",me)},e.gtr=function(ae,de,me){return Ce(ae,de,">",me)},e.outside=Ce,e.prerelease=function(ae,de){var me=z(ae,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(ae,de,me){return ae=new we(ae,me),de=new we(de,me),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof x)return ae;if(typeof ae!="string")return null;var de=ae.match(I[k]);return de==null?null:z((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(se,e){var R,L,A=se.exports={};function j(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function I($){if(R===setTimeout)return setTimeout($,0);if((R===j||!R)&&setTimeout)return R=setTimeout,setTimeout($,0);try{return R($,0)}catch{try{return R.call(null,$,0)}catch{return R.call(this,$,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:j}catch{R=j}try{L=typeof clearTimeout=="function"?clearTimeout:D}catch{L=D}})();var P,d=[],E=!1,v=-1;function y(){E&&P&&(E=!1,P.length?d=P.concat(d):v=-1,d.length&&l())}function l(){if(!E){var $=I(y);E=!0;for(var f=d.length;f;){for(P=d,d=[];++v<f;)P&&P[v].run();v=-1,f=d.length}P=null,E=!1,function(u){if(L===clearTimeout)return clearTimeout(u);if((L===D||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(u);try{L(u)}catch{try{return L.call(null,u)}catch{return L.call(this,u)}}}($)}}function c($,f){this.fun=$,this.array=f}function w(){}A.nextTick=function($){var f=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)f[u-1]=arguments[u];d.push(new c($,f)),d.length!==1||E||I(l)},c.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=w,A.addListener=w,A.once=w,A.off=w,A.removeListener=w,A.removeAllListeners=w,A.emit=w,A.prependListener=w,A.prependOnceListener=w,A.listeners=function($){return[]},A.binding=function($){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function($){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(le[130],he([0,1]),function(se,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;class L{constructor(I,P,d){this.level=I,this.key=P,this.value=d,this.forward=[]}}const A=void 0;class j{constructor(I,P=2**16){this.comparator=I,this[R]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new L(this.c,A,A)}get size(){return this.f}clear(){this.e=new L(this.c,A,A),this.f=0}has(I){return!!j.g(this,I,this.comparator)}get(I){return j.g(this,I,this.comparator)?.value}set(I,P){return j.h(this,I,P,this.comparator)&&(this.f+=1),this}delete(I){const P=j.k(this,I,this.comparator);return P&&(this.f-=1),P}forEach(I,P){let d=this.e.forward[0];for(;d;)I.call(P,d.value,d.key,this),d=d.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",P=this.e.forward[0];for(;P;)I+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return I}static g(I,P,d){let E=I.e;for(let v=I.d-1;v>=0;v--)for(;E.forward[v]&&d(E.forward[v].key,P)<0;)E=E.forward[v];if(E=E.forward[0],E&&d(E.key,P)===0)return E}static h(I,P,d,E){const v=[];let y=I.e;for(let l=I.d-1;l>=0;l--){for(;y.forward[l]&&E(y.forward[l].key,P)<0;)y=y.forward[l];v[l]=y}if(y=y.forward[0],y&&E(y.key,P)===0)return y.value=d,!1;{const l=j.j(I);if(l>I.d){for(let c=I.d;c<l;c++)v[c]=I.e;I.d=l}y=new L(l,P,d);for(let c=0;c<l;c++)y.forward[c]=v[c].forward[c],v[c].forward[c]=y;return!0}}static j(I,P=.5){let d=1;for(;Math.random()<P&&d<I.c;)d+=1;return d}static k(I,P,d){const E=[];let v=I.e;for(let y=I.d-1;y>=0;y--){for(;v.forward[y]&&d(v.forward[y].key,P)<0;)v=v.forward[y];E[y]=v}if(v=v.forward[0],!v||d(v.key,P)!==0)return!1;for(let y=0;y<I.d&&E[y].forward[y]===v;y++)E[y].forward[y]=v.forward[y];for(;I.d>0&&I.e.forward[I.d-1]===A;)I.d-=1;return!0}}e.$Fs=j}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const R=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(j){return new L(j)}constructor(j){this.c=R&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=L}),define(le[3],he([0,1,7,86,2,87,63]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=l;const I=!1,P=!1,d=!1;var E;(function(T){T.None=()=>A.$Uc.None;function F(be){if(d){const{onDidAddListener:ye}=be,Pe=w.create();let Ce=0;be.onDidAddListener=()=>{++Ce===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Pe.print()),ye?.()}}}function K(be,ye){return z(be,()=>{},0,void 0,!0,void 0,ye)}T.defer=K;function J(be){return(ye,Pe=null,Ce)=>{let ae=!1,de;return de=be(me=>{if(!ae)return de?de.dispose():ae=!0,ye.call(Pe,me)},null,Ce),ae&&de.dispose(),de}}T.once=J;function Q(be,ye,Pe){return re((Ce,ae=null,de)=>be(me=>Ce.call(ae,ye(me)),null,de),Pe)}T.map=Q;function H(be,ye,Pe){return re((Ce,ae=null,de)=>be(me=>{ye(me),Ce.call(ae,me)},null,de),Pe)}T.forEach=H;function X(be,ye,Pe){return re((Ce,ae=null,de)=>be(me=>ye(me)&&Ce.call(ae,me),null,de),Pe)}T.filter=X;function W(be){return be}T.signal=W;function B(...be){return(ye,Pe=null,Ce)=>{const ae=(0,A.$Rc)(...be.map(de=>de(me=>ye.call(Pe,me))));return Z(ae,Ce)}}T.any=B;function ie(be,ye,Pe,Ce){let ae=Pe;return Q(be,de=>(ae=ye(ae,de),ae),Ce)}T.reduce=ie;function re(be,ye){let Pe;const Ce={onWillAddFirstListener(){Pe=be(ae.fire,ae)},onDidRemoveLastListener(){Pe?.dispose()}};ye||F(Ce);const ae=new r(Ce);return ye?.add(ae),ae.event}function Z(be,ye){return ye instanceof Array?ye.push(be):ye&&ye.add(be),be}function z(be,ye,Pe=100,Ce=!1,ae=!1,de,me){let Ie,Re,je,Oe=0,Te;const Le={leakWarningThreshold:de,onWillAddFirstListener(){Ie=be(Ve=>{Oe++,Re=ye(Re,Ve),Ce&&!je&&(Fe.fire(Re),Re=void 0),Te=()=>{const Ne=Re;Re=void 0,je=void 0,(!Ce||Oe>1)&&Fe.fire(Ne),Oe=0},typeof Pe=="number"?(clearTimeout(je),je=setTimeout(Te,Pe)):je===void 0&&(je=0,queueMicrotask(Te))})},onWillRemoveListener(){ae&&Oe>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,Ie.dispose()}};me||F(Le);const Fe=new r(Le);return me?.add(Fe),Fe.event}T.debounce=z;function x(be,ye=0,Pe){return T.debounce(be,(Ce,ae)=>Ce?(Ce.push(ae),Ce):[ae],ye,void 0,!0,void 0,Pe)}T.accumulate=x;function G(be,ye=(Ce,ae)=>Ce===ae,Pe){let Ce=!0,ae;return X(be,de=>{const me=Ce||!ye(de,ae);return Ce=!1,ae=de,me},Pe)}T.latch=G;function N(be,ye,Pe){return[T.filter(be,ye,Pe),T.filter(be,Ce=>!ye(Ce),Pe)]}T.split=N;function U(be,ye=!1,Pe=[],Ce){let ae=Pe.slice(),de=be(Re=>{ae?ae.push(Re):Ie.fire(Re)});Ce&&Ce.add(de);const me=()=>{ae?.forEach(Re=>Ie.fire(Re)),ae=null},Ie=new r({onWillAddFirstListener(){de||(de=be(Re=>Ie.fire(Re)),Ce&&Ce.add(de))},onDidAddFirstListener(){ae&&(ye?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Ce&&Ce.add(Ie),Ie.event}T.buffer=U;function V(be,ye){return(Ce,ae,de)=>{const me=ye(new _);return be(function(Ie){const Re=me.evaluate(Ie);Re!==q&&Ce.call(ae,Re)},void 0,de)}}T.chain=V;const q=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(ye){return this.f.push(ye),this}forEach(ye){return this.f.push(Pe=>(ye(Pe),Pe)),this}filter(ye){return this.f.push(Pe=>ye(Pe)?Pe:q),this}reduce(ye,Pe){let Ce=Pe;return this.f.push(ae=>(Ce=ye(Ce,ae),Ce)),this}latch(ye=(Pe,Ce)=>Pe===Ce){let Pe=!0,Ce;return this.f.push(ae=>{const de=Pe||!ye(ae,Ce);return Pe=!1,Ce=ae,de?ae:q}),this}evaluate(ye){for(const Pe of this.f)if(ye=Pe(ye),ye===q)break;return ye}}function ee(be,ye,Pe=Ce=>Ce){const Ce=(...Ie)=>me.fire(Pe(...Ie)),ae=()=>be.on(ye,Ce),de=()=>be.removeListener(ye,Ce),me=new r({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}T.fromNodeEventEmitter=ee;function ne(be,ye,Pe=Ce=>Ce){const Ce=(...Ie)=>me.fire(Pe(...Ie)),ae=()=>be.addEventListener(ye,Ce),de=()=>be.removeEventListener(ye,Ce),me=new r({onWillAddFirstListener:ae,onDidRemoveLastListener:de});return me.event}T.fromDOMEventEmitter=ne;function te(be){return new Promise(ye=>J(be)(ye))}T.toPromise=te;function ce(be){const ye=new r;return be.then(Pe=>{ye.fire(Pe)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}T.fromPromise=ce;function fe(be,ye,Pe){return ye(Pe),be(Ce=>ye(Ce))}T.runAndSubscribe=fe;class $e{constructor(ye,Pe){this._observable=ye,this.f=0,this.g=!1;const Ce={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};Pe||F(Ce),this.emitter=new r(Ce),Pe&&Pe.add(this.emitter)}beginUpdate(ye){this.f++}handlePossibleChange(ye){}handleChange(ye,Pe){this.g=!0}endUpdate(ye){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(be,ye){return new $e(be,ye).emitter.event}T.fromObservable=we;function Ee(be){return(ye,Pe,Ce)=>{let ae=0,de=!1;const me={beginUpdate(){ae++},endUpdate(){ae--,ae===0&&(be.reportChanges(),de&&(de=!1,ye.call(Pe)))},handlePossibleChange(){},handleChange(){de=!0}};be.addObserver(me),be.reportChanges();const Ie={dispose(){be.removeObserver(me)}};return Ce instanceof A.$Tc?Ce.add(Ie):Array.isArray(Ce)&&Ce.push(Ie),Ie}}T.fromObservableLight=Ee})(E||(e.Event=E={}));class v{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${v.f++}`,v.all.add(this)}start(F){this.g=new D.$be,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$de=v;let y=-1;function l(T){const F=y;return y=T,{dispose(){y=F}}}class c{constructor(F,K,J=Math.random().toString(18).slice(2,5)){this.h=F,this.threshold=K,this.name=J,this.g=0}dispose(){this.f?.clear()}check(F,K){const J=this.threshold;if(J<=0||K<J)return;this.f||(this.f=new Map);const Q=this.f.get(F.value)||0;if(this.f.set(F.value,Q+1),this.g-=1,this.g<=0){this.g=J*.5;const[H,X]=this.getMostFrequentStack(),W=`[${this.name}] potential listener LEAK detected, having ${K} listeners already. MOST frequent listener (${X}):`;console.warn(W),console.warn(H);const B=new $(W,H);this.h(B)}return()=>{const H=this.f.get(F.value)||0;this.f.set(F.value,H-1)}}getMostFrequentStack(){if(!this.f)return;let F,K=0;for(const[J,Q]of this.f)(!F||K<Q)&&(F=[J,Q],K=Q);return F}}class w{static create(){const F=new Error;return new w(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class $ extends Error{constructor(F,K){super(F),this.name="ListenerLeakError",this.stack=K}}e.$fe=$;class f extends Error{constructor(F,K){super(F),this.name="ListenerRefusalError",this.stack=K}}e.$ge=f;let u=0;class h{constructor(F){this.value=F,this.id=u++}}const g=2,m=(T,F)=>{if(T instanceof h)F(T);else for(let K=0;K<T.length;K++){const J=T[K];J&&F(J)}},t=I?new FinalizationRegistry(T=>{typeof T=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(T))}):void 0;class r{constructor(F){this.w=0,this.f=F,this.g=y>0||this.f?.leakWarningThreshold?new c(F?.onListenerError??R.$1,this.f?.leakWarningThreshold??y):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const F=this.t;queueMicrotask(()=>{m(F,K=>K.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,K,J)=>{if(this.g&&this.w>this.g.threshold*3){const B=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w}/${this.g.threshold})`;console.warn(B);const ie=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],re=new f(`${B}. HINT: Stack shows most frequent listener (${ie[1]}-times)`,ie[0]);return(this.f?.onListenerError||R.$1)(re),A.$Uc.None}if(this.m)return A.$Uc.None;K&&(F=F.bind(K));const Q=new h(F);let H,X;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Q.stack=w.create(),H=this.g.check(Q.stack,this.w+1)),P&&(Q.stack=X??w.create()),this.t?this.t instanceof h?(this.u??=new n,this.t=[this.t,Q]):this.t.push(Q):(this.f?.onWillAddFirstListener?.(this),this.t=Q,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,A.$Sc)(()=>{t?.unregister(W),H?.(),this.x(Q)});if(J instanceof A.$Tc?J.add(W):Array.isArray(J)&&J.push(W),t){const B=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(W,B,W)}return W},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const K=this.t,J=K.indexOf(F);if(J===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,K[J]=void 0;const Q=this.u.current===this;if(this.w*g<=K.length){let H=0;for(let X=0;X<K.length;X++)K[X]?K[H++]=K[X]:Q&&(this.u.end--,H<this.u.i&&this.u.i--);K.length=H}}y(F,K){if(!F)return;const J=this.f?.onListenerError||R.$1;if(!J){F.value(K);return}try{F.value(K)}catch(Q){J(Q)}}z(F){const K=F.current.t;for(;F.i<F.end;)this.y(K[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,F);else{const K=this.u;K.enqueue(this,F,this.t.length),this.z(K)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=r;const s=()=>new n;e.$ie=s;class n{constructor(){this.i=-1,this.end=0}enqueue(F,K,J){this.i=0,this.end=J,this.current=F,this.value=K}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends r{async fireAsync(F,K,J){if(this.t)for(this.h||(this.h=new j.$5c),m(this.t,Q=>this.h.push([Q.value,F]));this.h.size>0&&!K.isCancellationRequested;){const[Q,H]=this.h.shift(),X=[],W={...H,token:K,waitUntil:B=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");J&&(B=J(B,Q)),X.push(B)}};try{Q(W)}catch(B){(0,R.$1)(B);continue}Object.freeze(X),await Promise.allSettled(X).then(B=>{for(const ie of B)ie.status==="rejected"&&(0,R.$1)(ie.reason)})}}}e.$je=i;class o extends r{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new j.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ke=o;class a extends o{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$le=a;class p extends r{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(K=>super.fire(K)),this.h=[]}))}}e.$me=p;class S{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const K={event:F,listener:null};this.h.push(K),this.g&&this.m(K);const J=()=>{this.g&&this.o(K);const Q=this.h.indexOf(K);this.h.splice(Q,1)};return(0,A.$Sc)((0,L.$db)(J))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(K=>this.f.fire(K))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$ne=S;class b{constructor(F,K,J,Q){this.f=new A.$Tc;const H=this.f.add(new S),X=this.f.add(new A.$4c);function W(B){X.set(B,H.add(Q(B)))}for(const B of F)W(B);this.f.add(K(B=>{W(B)})),this.f.add(J(B=>{X.deleteAndDispose(B)})),this.event=H.event}dispose(){this.f.dispose()}}e.$oe=b;class k{constructor(){this.f=[]}wrapEvent(F,K,J){return(Q,H,X)=>F(W=>{const B=this.f[this.f.length-1];if(!K){B?B.buffers.push(()=>Q.call(H,W)):Q.call(H,W);return}const ie=B;if(!ie){Q.call(H,K(J,W));return}ie.items??=[],ie.items.push(W),ie.buffers.length===0&&B.buffers.push(()=>{ie.reducedResult??=J?ie.items.reduce(K,J):ie.items.reduce(K),Q.call(H,ie.reducedResult)})},void 0,X)}bufferEvents(F){const K={buffers:new Array};this.f.push(K);const J=F();return this.f.pop(),K.buffers.forEach(Q=>Q()),J}}e.$pe=k;class C{constructor(){this.f=!1,this.g=E.None,this.h=A.$Uc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=C;class O{static const(F){return new M(F)}constructor(F){this.g=F,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$re=O;class M{constructor(F){this.value=F,this.onDidChange=E.None}}}),define(le[26],he([0,1,3]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=I;const L=Object.freeze(function(P,d){const E=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(E)}}});var A;(function(P){function d(E){return E===P.None||E===P.Cancelled||E instanceof j?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(A||(e.CancellationToken=A={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new R.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=A.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=A.None}}e.$se=D;function I(P){const d=new D;return P.add({dispose(){d.cancel()}}),d.token}}),define(le[131],he([0,1,26]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=A;class L{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new R.$se,d=this.b(P.token);return this.a={promise:d,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$5e=L;function A(I){return I}class j{constructor(P,d){this.a=void 0,this.b=void 0,typeof P=="function"?(this.c=P,this.d=A):(this.c=d,this.d=P.getCacheKey)}get(P){const d=this.d(P);return this.b!==d&&(this.b=d,this.a=this.c(P)),this.a}}e.$7e=j;class D{get cachedValues(){return this.a}constructor(P,d){this.a=new Map,this.b=new Map,typeof P=="function"?(this.c=P,this.d=A):(this.c=d,this.d=P.getCacheKey)}get(P){const d=this.d(P);if(this.b.has(d))return this.b.get(d);const E=this.c(P);return this.a.set(P,E),this.b.set(d,E),E}}e.$8e=D}),define(le[50],he([0,1,7,2]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=A,e.$ve=j,e.$we=D,e.$xe=I,e.$ye=d,e.$ze=E,e.$Ae=v,e.$Be=y,e.$Ce=l,e.$De=c,e.$Ee=w,e.$Fe=$,e.$Ge=f,e.$He=u,e.$Ie=h;function A(g){const m=g;return m?typeof m.read=="function":!1}function j(g){const m=g;return m?[m.on,m.pause,m.resume,m.destroy].every(t=>typeof t=="function"):!1}function D(g){const m=g;return m?j(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}function I(g,m){return new P(g,m)}class P{constructor(m,t){this.e=m,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(t=>t(m))}h(m){this.c.error.length===0?(0,R.$1)(m):this.c.error.slice(0).forEach(t=>t(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,t){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(m,t){if(this.a.destroyed)return;let r;switch(m){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(g,m){const t=[];let r;for(;(r=g.read())!==null;)t.push(r);return m(t)}function E(g,m,t){const r=[];let s;for(;(s=g.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?m(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return g.read()}}}function v(g,m){return new Promise((t,r)=>{const s=[];y(g,{onData:n=>{m&&s.push(n)},onError:n=>{m?r(n):t(void 0)},onEnd:()=>{t(m?m(s):void 0)}})})}function y(g,m,t){g.on("error",r=>{t?.isCancellationRequested||m.onError(r)}),g.on("end",()=>{t?.isCancellationRequested||m.onEnd()}),g.on("data",r=>{t?.isCancellationRequested||m.onData(r)})}function l(g,m){return new Promise((t,r)=>{const s=new L.$Tc,n=[],i=p=>{if(n.push(p),n.length>m)return s.dispose(),g.pause(),t({stream:g,buffer:n,ended:!1})},o=p=>(s.dispose(),r(p)),a=()=>(s.dispose(),t({stream:g,buffer:n,ended:!0}));s.add((0,L.$Sc)(()=>g.removeListener("error",o))),g.on("error",o),s.add((0,L.$Sc)(()=>g.removeListener("end",a))),g.on("end",a),s.add((0,L.$Sc)(()=>g.removeListener("data",i))),g.on("data",i)})}function c(g,m){const t=I(m);return t.end(g),t}function w(){const g=I(()=>{throw new Error("not supported")});return g.end(),g}function $(g){let m=!1;return{read:()=>m?null:(m=!0,g)}}function f(g,m,t){const r=I(t);return y(g,{onData:s=>r.write(m.data(s)),onError:s=>r.error(m.error?m.error(s):s),onEnd:()=>r.end()}),r}function u(g,m,t){let r=!1;return{read:()=>{const s=m.read();return r?s:(r=!0,s!==null?t([g,s]):g)}}}function h(g,m,t){let r=!1;const s=I(t);return y(m,{onData:n=>r?s.write(n):(r=!0,s.write(t([g,n]))),onError:n=>s.error(n),onEnd:()=>{r||(r=!0,s.write(g)),s.end()}}),s}}),define(le[15],he([0,1,53,50]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=d,e.$Le=E,e.$Me=v,e.$Ne=y,e.$Oe=l,e.$Pe=c,e.$Qe=w,e.$Re=$,e.$Se=f,e.$Te=u,e.$Ue=h,e.$Ve=g,e.$We=m,e.$Xe=t,e.$Ye=r,e.$Ze=s,e.$1e=n,e.$2e=i,e.$3e=o,e.$4e=S;const A=typeof Buffer<"u",j=new R.$V(()=>new Uint8Array(256));let D,I;class P{static alloc(k){return A?new P(Buffer.allocUnsafe(k)):new P(new Uint8Array(k))}static wrap(k){return A&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new P(k)}static fromString(k,C){return!(C?.dontUseNodeBuffer||!1)&&A?new P(Buffer.from(k)):(D||(D=new TextEncoder),new P(D.encode(k)))}static fromByteArray(k){const C=P.alloc(k.length);for(let O=0,M=k.length;O<M;O++)C.buffer[O]=k[O];return C}static concat(k,C){if(typeof C>"u"){C=0;for(let T=0,F=k.length;T<F;T++)C+=k[T].byteLength}const O=P.alloc(C);let M=0;for(let T=0,F=k.length;T<F;T++){const K=k[T];O.set(K,M),M+=K.byteLength}return O}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=P.alloc(this.byteLength);return k.set(this),k}toString(){return A?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(k,C){return new P(this.buffer.subarray(k,C))}set(k,C){if(k instanceof P)this.buffer.set(k.buffer,C);else if(k instanceof Uint8Array)this.buffer.set(k,C);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),C);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return y(this.buffer,k)}writeUInt32BE(k,C){l(this.buffer,k,C)}readUInt32LE(k){return c(this.buffer,k)}writeUInt32LE(k,C){w(this.buffer,k,C)}readUInt8(k){return $(this.buffer,k)}writeUInt8(k,C){f(this.buffer,k,C)}indexOf(k,C=0){return d(this.buffer,k instanceof P?k.buffer:k,C)}}e.$Je=P;function d(b,k,C=0){const O=k.byteLength,M=b.byteLength;if(O===0)return 0;if(O===1)return b.indexOf(k[0]);if(O>M-C)return-1;const T=j.value;T.fill(k.length);for(let Q=0;Q<k.length;Q++)T[k[Q]]=k.length-Q-1;let F=C+k.length-1,K=F,J=-1;for(;F<M;)if(b[F]===k[K]){if(K===0){J=F;break}F--,K--}else F+=Math.max(k.length-K,T[b[F]]),K=k.length-1;return J}function E(b,k){return b[k+0]<<0>>>0|b[k+1]<<8>>>0}function v(b,k,C){b[C+0]=k&255,k=k>>>8,b[C+1]=k&255}function y(b,k){return b[k]*2**24+b[k+1]*2**16+b[k+2]*2**8+b[k+3]}function l(b,k,C){b[C+3]=k,k=k>>>8,b[C+2]=k,k=k>>>8,b[C+1]=k,k=k>>>8,b[C]=k}function c(b,k){return b[k+0]<<0>>>0|b[k+1]<<8>>>0|b[k+2]<<16>>>0|b[k+3]<<24>>>0}function w(b,k,C){b[C+0]=k&255,k=k>>>8,b[C+1]=k&255,k=k>>>8,b[C+2]=k&255,k=k>>>8,b[C+3]=k&255}function $(b,k){return b[k]}function f(b,k,C){b[C]=k}function u(b){return L.$ye(b,k=>P.concat(k))}function h(b){return L.$Fe(b)}function g(b){return L.$Ae(b,k=>P.concat(k))}async function m(b){return b.ended?P.concat(b.buffer):P.concat([...b.buffer,await g(b.stream)])}function t(b){return L.$De(b,k=>P.concat(k))}function r(b){return L.$Ge(b,{data:k=>typeof k=="string"?P.fromString(k):P.wrap(k)},k=>P.concat(k))}function s(b){return L.$xe(k=>P.concat(k),b)}function n(b,k){return L.$He(b,k,C=>P.concat(C))}function i(b,k){return L.$Ie(b,k,C=>P.concat(C))}function o(b){let k=0,C=0,O=0;const M=new Uint8Array(Math.floor(b.length/4*3)),T=K=>{switch(C){case 3:M[O++]=k|K,C=0;break;case 2:M[O++]=k|K>>>2,k=K<<6,C=3;break;case 1:M[O++]=k|K>>>4,k=K<<4,C=2;break;default:k=K<<2,C=1}};for(let K=0;K<b.length;K++){const J=b.charCodeAt(K);if(J>=65&&J<=90)T(J-65);else if(J>=97&&J<=122)T(J-97+26);else if(J>=48&&J<=57)T(J-48+52);else if(J===43||J===45)T(62);else if(J===47||J===95)T(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${b[K]}`)}}const F=O;for(;C>0;)T(0);return P.wrap(M).slice(0,F)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:b},k=!0,C=!1){const O=C?p:a;let M="";const T=b.byteLength%3;let F=0;for(;F<b.byteLength-T;F+=3){const K=b[F+0],J=b[F+1],Q=b[F+2];M+=O[K>>>2],M+=O[(K<<4|J>>>4)&63],M+=O[(J<<2|Q>>>6)&63],M+=O[Q&63]}if(T===1){const K=b[F+0];M+=O[K>>>2],M+=O[K<<4&63],k&&(M+="==")}else if(T===2){const K=b[F+0],J=b[F+1];M+=O[K>>>2],M+=O[(K<<4|J>>>4)&63],M+=O[J<<2&63],k&&(M+="=")}return M}}),define(le[27],he([0,1,131,53]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=A,e.$_e=D,e.$af=P,e.$bf=d,e.$cf=E,e.$df=v,e.$ef=y,e.$ff=l,e.$gf=c,e.$hf=w,e.$if=$,e.$jf=f,e.$kf=u,e.$lf=h,e.$mf=g,e.$nf=m,e.$of=t,e.$pf=r,e.$qf=s,e.$rf=n,e.$sf=i,e.$tf=o,e.$uf=a,e.$vf=p,e.$wf=S,e.$xf=b,e.$yf=k,e.$zf=C,e.$Af=O,e.$Bf=M,e.$Cf=T,e.$Df=F,e.$Ef=K,e.$Ff=J,e.$Gf=Q,e.$Hf=H,e.$If=X,e.$Lf=re,e.$Mf=Z,e.$Nf=z,e.$Of=x,e.$Pf=U,e.$Qf=q,e.$Sf=_,e.$Tf=ee,e.$Uf=ne,e.$Vf=te,e.$Wf=fe,e.$Xf=$e,e.$Yf=Ee,e.$1f=be,e.$2f=ye,e.$3f=Pe,e.$4f=Ce,e.$5f=ae,e.$6f=de,e.$7f=me,e.$8f=Ie,e.$9f=Le;function A(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const j=/{(\d+)}/g;function D(oe,...ue){return ue.length===0?oe:oe.replace(j,function(ge,pe){const ke=parseInt(pe,10);return isNaN(ke)||ke<0||ke>=ue.length?ge:ue[ke]})}const I=/{([^}]+)}/g;function P(oe,ue){return Object.keys(ue).length===0?oe:oe.replace(I,(ge,pe)=>ue[pe]??ge)}function d(oe){return oe.replace(/[<>"'&]/g,ue=>{switch(ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ue})}function E(oe){return oe.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}function v(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function y(oe,ue){let ge=0,pe=oe.indexOf(ue);for(;pe!==-1;)ge++,pe=oe.indexOf(ue,pe+ue.length);return ge}function l(oe,ue,ge="\u2026"){return oe.length<=ue?oe:`${oe.substr(0,ue)}${ge}`}function c(oe,ue,ge="\u2026"){if(oe.length<=ue)return oe;const pe=Math.ceil(ue/2)-ge.length/2,ke=Math.floor(ue/2)-ge.length/2;return`${oe.substr(0,pe)}${ge}${oe.substr(oe.length-ke)}`}function w(oe,ue=" "){const ge=$(oe,ue);return f(ge,ue)}function $(oe,ue){if(!oe||!ue)return oe;const ge=ue.length;if(ge===0||oe.length===0)return oe;let pe=0;for(;oe.indexOf(ue,pe)===pe;)pe=pe+ge;return oe.substring(pe)}function f(oe,ue){if(!oe||!ue)return oe;const ge=ue.length,pe=oe.length;if(ge===0||pe===0)return oe;let ke=pe,De=-1;for(;De=oe.lastIndexOf(ue,ke-1),!(De===-1||De+ge!==ke);){if(De===0)return"";ke=De}return oe.substring(0,ke)}function u(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(oe){return oe.replace(/\*/g,"")}function g(oe,ue,ge={}){if(!oe)throw new Error("Cannot create regex from empty string");ue||(oe=v(oe)),ge.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let pe="";return ge.global&&(pe+="g"),ge.matchCase||(pe+="i"),ge.multiline&&(pe+="m"),ge.unicode&&(pe+="u"),new RegExp(oe,pe)}function m(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function t(oe){return oe.split(/\r\n|\r|\n/)}function r(oe){const ue=[],ge=oe.split(/(\r\n|\r|\n)/);for(let pe=0;pe<Math.ceil(ge.length/2);pe++)ue.push(ge[2*pe]+(ge[2*pe+1]??""));return ue}function s(oe){for(let ue=0,ge=oe.length;ue<ge;ue++){const pe=oe.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}function n(oe,ue=0,ge=oe.length){for(let pe=ue;pe<ge;pe++){const ke=oe.charCodeAt(pe);if(ke!==32&&ke!==9)return oe.substring(ue,pe)}return oe.substring(ue,ge)}function i(oe,ue=oe.length-1){for(let ge=ue;ge>=0;ge--){const pe=oe.charCodeAt(ge);if(pe!==32&&pe!==9)return ge}return-1}function o(oe,ue,ge){const pe=[];let ke=0;for(const De of oe.matchAll(ue)){if(pe.push(oe.slice(ke,De.index)),De.index===void 0)throw new Error("match.index should be defined");ke=De.index+De[0].length,pe.push(ge(De[0],...De.slice(1),De.index,oe,De.groups))}return pe.push(oe.slice(ke)),Promise.all(pe).then(De=>De.join(""))}function a(oe,ue){return oe<ue?-1:oe>ue?1:0}function p(oe,ue,ge=0,pe=oe.length,ke=0,De=ue.length){for(;ge<pe&&ke<De;ge++,ke++){const Be=oe.charCodeAt(ge),Ke=ue.charCodeAt(ke);if(Be<Ke)return-1;if(Be>Ke)return 1}const Ue=pe-ge,We=De-ke;return Ue<We?-1:Ue>We?1:0}function S(oe,ue){return b(oe,ue,0,oe.length,0,ue.length)}function b(oe,ue,ge=0,pe=oe.length,ke=0,De=ue.length){for(;ge<pe&&ke<De;ge++,ke++){let Be=oe.charCodeAt(ge),Ke=ue.charCodeAt(ke);if(Be===Ke)continue;if(Be>=128||Ke>=128)return p(oe.toLowerCase(),ue.toLowerCase(),ge,pe,ke,De);C(Be)&&(Be-=32),C(Ke)&&(Ke-=32);const ze=Be-Ke;if(ze!==0)return ze}const Ue=pe-ge,We=De-ke;return Ue<We?-1:Ue>We?1:0}function k(oe){return oe>=48&&oe<=57}function C(oe){return oe>=97&&oe<=122}function O(oe){return oe>=65&&oe<=90}function M(oe,ue){return oe.length===ue.length&&b(oe,ue)===0}function T(oe,ue){const ge=ue.length;return ue.length>oe.length?!1:b(oe,ue,0,ge)===0}function F(oe,ue){const ge=Math.min(oe.length,ue.length);let pe;for(pe=0;pe<ge;pe++)if(oe.charCodeAt(pe)!==ue.charCodeAt(pe))return pe;return ge}function K(oe,ue){const ge=Math.min(oe.length,ue.length);let pe;const ke=oe.length-1,De=ue.length-1;for(pe=0;pe<ge;pe++)if(oe.charCodeAt(ke-pe)!==ue.charCodeAt(De-pe))return pe;return ge}function J(oe){return 55296<=oe&&oe<=56319}function Q(oe){return 56320<=oe&&oe<=57343}function H(oe,ue){return(oe-55296<<10)+(ue-56320)+65536}function X(oe,ue,ge){const pe=oe.charCodeAt(ge);if(J(pe)&&ge+1<ue){const ke=oe.charCodeAt(ge+1);if(Q(ke))return H(pe,ke)}return pe}function W(oe,ue){const ge=oe.charCodeAt(ue-1);if(Q(ge)&&ue>1){const pe=oe.charCodeAt(ue-2);if(J(pe))return H(pe,ge)}return ge}class B{get offset(){return this.e}constructor(ue,ge=0){this.c=ue,this.d=ue.length,this.e=ge}setOffset(ue){this.e=ue}prevCodePoint(){const ue=W(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=X(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.$Jf=B;class ie{get offset(){return this.c.offset}constructor(ue,ge=0){this.c=new B(ue,ge)}nextGraphemeLength(){const ue=Oe.getInstance(),ge=this.c,pe=ge.offset;let ke=ue.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const De=ge.offset,Ue=ue.getGraphemeBreakType(ge.nextCodePoint());if(Re(ke,Ue)){ge.setOffset(De);break}ke=Ue}return ge.offset-pe}prevGraphemeLength(){const ue=Oe.getInstance(),ge=this.c,pe=ge.offset;let ke=ue.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const De=ge.offset,Ue=ue.getGraphemeBreakType(ge.prevCodePoint());if(Re(Ue,ke)){ge.setOffset(De);break}ke=Ue}return pe-ge.offset}eol(){return this.c.eol()}}e.$Kf=ie;function re(oe,ue){return new ie(oe,ue).nextGraphemeLength()}function Z(oe,ue){return new ie(oe,ue).prevGraphemeLength()}function z(oe,ue){ue>0&&Q(oe.charCodeAt(ue))&&ue--;const ge=ue+re(oe,ue);return[ge-Z(oe,ge),ge]}function x(oe){const ue=new ie(oe);let ge=0;for(;!ue.eol();)ge++,ue.nextGraphemeLength();return ge}let G;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(oe){return G||(G=N()),G.test(oe)}const V=/^[\t\n\r\x20-\x7E]*$/;function q(oe){return V.test(oe)}e.$Rf=/[\u2028\u2029]/;function _(oe){return e.$Rf.test(oe)}function ee(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function ne(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function te(oe,ue,ge=""){const pe=oe.trimStart();if(pe.length<ue)return pe;const ke=/\b/g;let De=0;for(;ke.test(pe)&&!(pe.length-ke.lastIndex<ue);)De=ke.lastIndex,ke.lastIndex+=1;return De===0?pe:ge+pe.substring(De).trimStart()}const ce=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*fe(oe){let ue=0;for(const ge of oe.matchAll(ce))ue!==ge.index&&(yield{isCode:!1,str:oe.substring(ue,ge.index)}),yield{isCode:!0,str:ge[0]},ue=ge.index+ge[0].length;ue!==oe.length&&(yield{isCode:!1,str:oe.substring(ue)})}function $e(oe){return oe&&(oe=oe.replace(ce,"")),oe}const we=/\\\[.*?\\\]/g;function Ee(oe){return $e(oe).replace(we,"")}e.$Zf="\uFEFF";function be(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function ye(oe){return be(oe)?oe.substr(1):oe}function Pe(oe,ue){if(!oe||!ue||oe.length<ue.length)return!1;const ge=ue.length,pe=oe.toLowerCase();let ke=0,De=-1;for(;ke<ge;){const Ue=pe.indexOf(ue[ke],De+1);if(Ue<0)return!1;De=Ue,ke++}return!0}function Ce(oe,ue=!1){return oe?(ue&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function ae(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function de(oe,ue=1){if(ue===0)return"";let ge=-1;do ge=oe.indexOf(`
`,ge+1),ue--;while(ue>0&&ge>=0);return ge===-1?oe:(oe[ge-1]==="\r"&&ge--,oe.substr(0,ge))}function me(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function Ie(oe){return Oe.getInstance().getGraphemeBreakType(oe)}function Re(oe,ue){return oe===0?ue!==5&&ue!==7:oe===2&&ue===3?!1:oe===4||oe===2||oe===3||ue===4||ue===2||ue===3?!0:!(oe===8&&(ue===8||ue===9||ue===11||ue===12)||(oe===11||oe===9)&&(ue===9||ue===10)||(oe===12||oe===10)&&ue===10||ue===5||ue===13||ue===7||oe===1||oe===13&&ue===14||oe===6&&ue===6)}var je;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class Oe{static{this.c=null}static getInstance(){return Oe.c||(Oe.c=new Oe),Oe.c}constructor(){this.d=Te()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const ge=this.d,pe=ge.length/3;let ke=1;for(;ke<=pe;)if(ue<ge[3*ke])ke=2*ke;else if(ue>ge[3*ke+1])ke=2*ke+1;else return ge[3*ke+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(oe,ue){if(oe===0)return 0;const ge=Fe(oe,ue);if(ge!==void 0)return ge;const pe=new B(ue,oe);return pe.prevCodePoint(),pe.offset}function Fe(oe,ue){const ge=new B(ue,oe);let pe=ge.prevCodePoint();for(;Ve(pe)||pe===65039||pe===8419;){if(ge.offset===0)return;pe=ge.prevCodePoint()}if(!ne(pe))return;let ke=ge.offset;return ke>0&&ge.prevCodePoint()===8205&&(ke=ge.offset),ke}function Ve(oe){return 127995<=oe&&oe<=127999}var Ne;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.$0f="\xA0";class Me{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new R.$7e({getCacheKey:JSON.stringify},ue=>{function ge(ze){const Ye=new Map;for(let Xe=0;Xe<ze.length;Xe+=2)Ye.set(ze[Xe],ze[Xe+1]);return Ye}function pe(ze,Ye){const Xe=new Map(ze);for(const[tt,nt]of Ye)Xe.set(tt,nt);return Xe}function ke(ze,Ye){if(!ze)return Ye;const Xe=new Map;for(const[tt,nt]of ze)Ye.has(tt)&&Xe.set(tt,nt);return Xe}const De=this.c.value;let Ue=ue.filter(ze=>!ze.startsWith("_")&&ze in De);Ue.length===0&&(Ue=["_default"]);let We;for(const ze of Ue){const Ye=ge(De[ze]);We=ke(We,Ye)}const Be=ge(De._common),Ke=pe(Be,We);return new Me(Ke)})}static getInstance(ue){return Me.d.get(Array.from(ue))}static{this.e=new L.$V(()=>Object.keys(Me.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return Me.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}containsAmbiguousCharacter(ue){for(let ge=0;ge<ue.length;ge++){const pe=ue.codePointAt(ge);if(typeof pe=="number"&&this.isAmbiguous(pe))return!0}return!1}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=Me;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(ue){return qe.e().has(ue)}static containsInvisibleCharacter(ue){for(let ge=0;ge<ue.length;ge++){const pe=ue.codePointAt(ge);if(typeof pe=="number"&&qe.isInvisibleCharacter(pe))return!0}return!1}static get codePoints(){return qe.e()}}e.$_f=qe}),define(le[54],he([0,1,27]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=L,e.$pj=A,e.$qj=j,e.$rj=I,e.$tj=w;function L(f){return A(f,0)}function A(f,u){switch(typeof f){case"object":return f===null?j(349,u):Array.isArray(f)?P(f,u):d(f,u);case"string":return I(f,u);case"boolean":return D(f,u);case"number":return j(f,u);case"undefined":return j(937,u);default:return j(617,u)}}function j(f,u){return(u<<5)-u+f|0}function D(f,u){return j(f?433:863,u)}function I(f,u){u=j(149417,u);for(let h=0,g=f.length;h<g;h++)u=j(f.charCodeAt(h),u);return u}function P(f,u){return u=j(104579,u),f.reduce((h,g)=>A(g,h),u)}function d(f,u){return u=j(181387,u),Object.keys(f).sort().reduce((h,g)=>(h=I(g,h),A(f[g],h)),u)}class E{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=A(u,this.g),this.g}}e.$sj=E;var v;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function y(f,u,h=32){const g=h-u,m=~((1<<g)-1);return(f<<u|(m&f)>>>g)>>>0}function l(f,u=0,h=f.byteLength,g=0){for(let m=0;m<h;m++)f[u+m]=g}function c(f,u,h="0"){for(;f.length<u;)f=h+f;return f}function w(f,u=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(h=>h.toString(16).padStart(2,"0")).join(""):c((f>>>0).toString(16),u/4)}class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const h=u.length;if(h===0)return;const g=this.p;let m=this.r,t=this.u,r,s;for(t!==0?(r=t,s=-1,t=0):(r=u.charCodeAt(0),s=0);;){let n=r;if(R.$Ff(r))if(s+1<h){const i=u.charCodeAt(s+1);R.$Gf(i)?(s++,n=R.$Hf(r,i)):n=65533}else{t=r;break}else R.$Gf(r)&&(n=65533);if(m=this.w(g,m,n),s++,s<h)r=u.charCodeAt(s);else break}this.r=m,this.u=t}w(u,h,g){return g<128?u[h++]=g:g<2048?(u[h++]=192|(g&1984)>>>6,u[h++]=128|(g&63)>>>0):g<65536?(u[h++]=224|(g&61440)>>>12,u[h++]=128|(g&4032)>>>6,u[h++]=128|(g&63)>>>0):(u[h++]=240|(g&1835008)>>>18,u[h++]=128|(g&258048)>>>12,u[h++]=128|(g&4032)>>>6,u[h++]=128|(g&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=$.g,h=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,h.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,y(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let g=this.h,m=this.l,t=this.m,r=this.n,s=this.o,n,i,o;for(let a=0;a<80;a++)a<20?(n=m&t|~m&r,i=1518500249):a<40?(n=m^t^r,i=1859775393):a<60?(n=m&t|m&r|t&r,i=2400959708):(n=m^t^r,i=3395469782),o=y(g,5)+n+s+i+u.getUint32(a*4,!1)&4294967295,s=r,r=t,t=y(m,30),m=g,g=o;this.h=this.h+g&4294967295,this.l=this.l+m&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+s&4294967295}}e.$uj=$}),define(le[89],he([0,1,27]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(L||(L={})),function(A){const j="error",D="warning",I="warn",P="info",d="ignore";function E(y){return y?R.$Bf(j,y)?A.Error:R.$Bf(D,y)||R.$Bf(I,y)?A.Warning:R.$Bf(P,y)?A.Info:A.Ignore:A.Ignore}A.fromValue=E;function v(y){switch(y){case A.Error:return j;case A.Warning:return D;case A.Info:return P;default:return d}}A.toString=v}(L||(L={})),e.default=L}),define(le[132],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(le[51],he([0,1,17,27]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class A{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const c=l.charCodeAt(0),w=this.b.charCodeAt(this.c);return c-w}value(){return this.b[this.c]}}e.$Ci=A;class j{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,L.$vf)(l,this.b,0,l.length,this.c,this.d):(0,L.$xf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=j;class D{constructor(l=!0,c=!0){this.f=l,this.g=c}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let c=l.length-1;c>=0;c--,this.c--){const w=this.b.charCodeAt(c);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===47||this.f&&c===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,L.$vf)(l,this.b,0,l.length,this.d,this.e):(0,L.$xf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=D;var I;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(I||(I={}));class P{constructor(l,c){this.f=l,this.g=c,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,L.$wf)(l,this.c.scheme);if(this.d[this.e]===2)return(0,L.$wf)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,L.$uf)(l,this.c.query);if(this.d[this.e]===5)return(0,L.$uf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fi=P;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(E||(E={}));class v{static forUris(l=()=>!1,c=()=>!1){return new v(new P(l,c))}static forPaths(l=!1){return new v(new D(void 0,!l))}static forStrings(){return new v(new A)}static forConfigKeys(){return new v(new j)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,c){if(c){const w=c.slice(0);(0,R.$Wb)(w);for(const $ of w)this.set($,l)}else{const w=l.slice(0);(0,R.$Wb)(w);for(const $ of w)this.set($[0],$[1])}}set(l,c){const w=this.b.reset(l);let $;this.c||(this.c=new d,this.c.segment=w.value());const f=[];for($=this.c;;){const h=w.cmp($.segment);if(h>0)$.left||($.left=new d,$.left.segment=w.value()),f.push([-1,$]),$=$.left;else if(h<0)$.right||($.right=new d,$.right.segment=w.value()),f.push([1,$]),$=$.right;else if(w.hasNext())w.next(),$.mid||($.mid=new d,$.mid.segment=w.value()),f.push([0,$]),$=$.mid;else break}const u=$.value;$.value=c,$.key=l;for(let h=f.length-1;h>=0;h--){const g=f[h][1];g.updateHeight();const m=g.balanceFactor();if(m<-1||m>1){const t=f[h][0],r=f[h+1][0];if(t===1&&r===1)f[h][1]=g.rotateLeft();else if(t===-1&&r===-1)f[h][1]=g.rotateRight();else if(t===1&&r===-1)g.right=f[h+1][1]=f[h+1][1].rotateRight(),f[h][1]=g.rotateLeft();else if(t===-1&&r===1)g.left=f[h+1][1]=f[h+1][1].rotateLeft(),f[h][1]=g.rotateRight();else throw new Error;if(h>0)switch(f[h-1][0]){case-1:f[h-1][1].left=f[h][1];break;case 1:f[h-1][1].right=f[h][1];break;case 0:f[h-1][1].mid=f[h][1];break}else this.c=f[0][1]}}return u}get(l){return this.d(l)?.value}d(l){const c=this.b.reset(l);let w=this.c;for(;w;){const $=c.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(c.hasNext())c.next(),w=w.mid;else break}return w}has(l){const c=this.d(l);return!(c?.value===void 0&&c?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,c){const w=this.b.reset(l),$=[];let f=this.c;for(;f;){const u=w.cmp(f.segment);if(u>0)$.push([-1,f]),f=f.left;else if(u<0)$.push([1,f]),f=f.right;else if(w.hasNext())w.next(),$.push([0,f]),f=f.mid;else break}if(f){if(c?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const u=this.f(f.right);if(u.key){const{key:h,value:g,segment:m}=u;this.e(u.key,!1),f.key=h,f.value=g,f.segment=m}}else{const u=f.left??f.right;if($.length>0){const[h,g]=$[$.length-1];switch(h){case-1:g.left=u;break;case 0:g.mid=u;break;case 1:g.right=u;break}}else this.c=u}for(let u=$.length-1;u>=0;u--){const h=$[u][1];h.updateHeight();const g=h.balanceFactor();if(g>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),$[u][1]=h.rotateLeft()):g<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),$[u][1]=h.rotateRight()),u>0)switch($[u-1][0]){case-1:$[u-1][1].left=$[u][1];break;case 1:$[u-1][1].right=$[u][1];break;case 0:$[u-1][1].mid=$[u][1];break}else this.c=$[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const c=this.b.reset(l);let w=this.c,$;for(;w;){const f=c.cmp(w.segment);if(f>0)w=w.left;else if(f<0)w=w.right;else if(c.hasNext())c.next(),$=w.value||$,w=w.mid;else break}return w&&w.value||$}findSuperstr(l){return this.g(l,!1)}g(l,c){const w=this.b.reset(l);let $=this.c;for(;$;){const f=w.cmp($.segment);if(f>0)$=$.left;else if(f<0)$=$.right;else if(w.hasNext())w.next(),$=$.mid;else return $.mid?this.h($.mid):c?$.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[c,w]of this)l(w,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const c=[];return this.j(l,c),c[Symbol.iterator]()}j(l,c){l&&(l.left&&this.j(l.left,c),l.value&&c.push([l.key,l.value]),l.mid&&this.j(l.mid,c),l.right&&this.j(l.right,c))}_isBalanced(){const l=c=>{if(!c)return!0;const w=c.balanceFactor();return w<-1||w>1?!1:l(c.left)&&l(c.right)};return l(this.c)}}e.$Gi=v}),define(le[13],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=R,e.$bg=L,e.$cg=A,e.$dg=j,e.$eg=D,e.$fg=I,e.$gg=P,e.$hg=d,e.$ig=E,e.$jg=v,e.$kg=y,e.$lg=l,e.$mg=c,e.$ng=$,e.$og=f,e.$pg=u,e.$qg=h,e.$rg=g;function R(m){return typeof m=="string"}function L(m){return Array.isArray(m)&&m.every(t=>R(t))}function A(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}function j(m){const t=Object.getPrototypeOf(Uint8Array);return typeof m=="object"&&m instanceof t}function D(m){return typeof m=="number"&&!isNaN(m)}function I(m){return!!m&&typeof m[Symbol.iterator]=="function"}function P(m){return m===!0||m===!1}function d(m){return typeof m>"u"}function E(m){return!v(m)}function v(m){return d(m)||m===null}function y(m,t){if(!m)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function l(m){if(v(m))throw new Error("Assertion Failed: argument is undefined or null");return m}function c(...m){const t=[];for(let r=0;r<m.length;r++){const s=m[r];if(v(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}const w=Object.prototype.hasOwnProperty;function $(m){if(!A(m))return!1;for(const t in m)if(w.call(m,t))return!1;return!0}function f(m){return typeof m=="function"}function u(...m){return m.length>0&&m.every(f)}function h(m,t){const r=Math.min(m.length,t.length);for(let s=0;s<r;s++)g(m[s],t[s])}function g(m,t){if(R(t)){if(typeof m!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(m instanceof t)return}catch{}if(!v(m)&&m.constructor===t||t.length===1&&t.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=L,e.$8n=A,e.$9n=D,e.$0n=P,e.$$n=d,e.$_n=E,e.$ao=v,e.$bo=y,e.$co=l,e.$do=c,e.$eo=w,e.$fo=$,e.$go=f;function L(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const h=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,m])=>{h[g]=m&&typeof m=="object"?L(m):m}),h}function A(u){if(!u||typeof u!="object")return u;const h=[u];for(;h.length>0;){const g=h.shift();Object.freeze(g);for(const m in g)if(j.call(g,m)){const t=g[m];typeof t=="object"&&!Object.isFrozen(t)&&!(0,R.$dg)(t)&&h.push(t)}}return u}const j=Object.prototype.hasOwnProperty;function D(u,h){return I(u,h,new Set)}function I(u,h,g){if((0,R.$jg)(u))return u;const m=h(u);if(typeof m<"u")return m;if(Array.isArray(u)){const t=[];for(const r of u)t.push(I(r,h,g));return t}if((0,R.$cg)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const t={};for(const r in u)j.call(u,r)&&(t[r]=I(u[r],h,g));return g.delete(u),t}return u}function P(u,h,g=!0){return(0,R.$cg)(u)?((0,R.$cg)(h)&&Object.keys(h).forEach(m=>{m in u?g&&((0,R.$cg)(u[m])&&(0,R.$cg)(h[m])?P(u[m],h[m],g):u[m]=h[m]):u[m]=h[m]}),u):h}function d(u,h){if(u===h)return!0;if(u==null||h===null||h===void 0||typeof u!=typeof h||typeof u!="object"||Array.isArray(u)!==Array.isArray(h))return!1;let g,m;if(Array.isArray(u)){if(u.length!==h.length)return!1;for(g=0;g<u.length;g++)if(!d(u[g],h[g]))return!1}else{const t=[];for(m in u)t.push(m);t.sort();const r=[];for(m in h)r.push(m);if(r.sort(),!d(t,r))return!1;for(g=0;g<t.length;g++)if(!d(u[t[g]],h[t[g]]))return!1}return!0}function E(u){const h=new Set;return JSON.stringify(u,(g,m)=>{if((0,R.$cg)(m)||Array.isArray(m)){if(h.has(m))return"[Circular]";h.add(m)}return typeof m=="bigint"?`[BigInt ${m.toString()}]`:m})}function v(u,h){const g=Object.create(null);return!u||!h||Object.keys(h).forEach(t=>{const r=u[t],s=h[t];d(r,s)||(g[t]=s)}),g}function y(u,h){const g=h.toLowerCase(),m=Object.keys(u).find(t=>t.toLowerCase()===g);return m?u[m]:u[h]}function l(u,h){const g=Object.create(null);for(const[m,t]of Object.entries(u))h(m,t)&&(g[m]=t);return g}function c(u){let h=[];for(;Object.prototype!==u;)h=h.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return h}function w(u){const h=[];for(const g of c(u))typeof u[g]=="function"&&h.push(g);return h}function $(u,h){const g=t=>function(){const r=Array.prototype.slice.call(arguments,0);return h(t,r)},m={};for(const t of u)m[t]=g(t);return m}function f(u,h){const g={};for(const[m,t]of Object.entries(u))g[m]=h(t,m);return g}}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=L;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(A){return R.test(A)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(I){for(let P=0;P<I.length;P++)I[P]=Math.floor(Math.random()*256);return I};const j=new Uint8Array(16),D=[];for(let I=0;I<256;I++)D.push(I.toString(16).padStart(2,"0"));return function(){A(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let P=0,d="";return d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+="-",d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d+=D[j[P++]],d}}()}),define(le[133],he([0,1,37]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=j;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(D){const I=D.replace(/\-/g,":").toLowerCase();return!L.has(I)}function j(){const D=(0,R.networkInterfaces)();for(const I in D){const P=D[I];if(P){for(const{mac:d}of P)if(A(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[134],he([0,1,273,15]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gW=void 0;class A extends R.Transform{constructor(D){if(super(),typeof D=="number")this.b=D,this.c=1;else{const I=Buffer.isBuffer(D)?D:Buffer.from(D);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(D,I,P){this.a?this.a=Buffer.concat([this.a,D]):this.a=D;let d=0;for(;d<this.a.length;){const E=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,L.$Ke)(this.a,this.b,d);if(E===-1)break;this.push(this.a.slice(d,E+this.c)),d=E+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),P()}_flush(D){this.a&&this.push(this.a),D()}}e.$gW=A}),define(le[135],he([0,1,64]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=L,e.$1g=j;function L(I,P,d,E=1){let v=!1;return new Promise(y=>{const l=setTimeout(()=>{if(!v)return v=!0,y(0)},d);A(I,P,E,c=>{if(!v)return v=!0,clearTimeout(l),y(c)})})}function A(I,P,d,E){if(P===0)return E(0);const v=new R.Socket;v.once("connect",()=>(D(v),A(I+d,P-1,d,E))),v.once("data",()=>{}),v.once("error",y=>(D(v),y.code!=="ECONNREFUSED"?A(I+d,P-1,d,E):E(I))),v.connect(I,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(I,P,d,E="127.0.0.1"){let v=!1,y,l=1;const c=R.createServer({pauseOnConnect:!0});function w($,f){v||(v=!0,c.removeAllListeners(),c.close(),y&&clearTimeout(y),f($))}return new Promise($=>{y=setTimeout(()=>{w(0,$)},d),c.on("listening",()=>{w(I,$)}),c.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&l<P?(I++,l++,c.listen(I,E)):w(0,$)}),c.on("close",()=>{w(0,$)}),c.listen(I,E)})}function D(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(P){console.error(P)}}}),define(le[136],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yW=R;function R(L){return!!L.parentPort}}),define(le[137],he([11,10]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,137]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=d,e.$7m=E,e.$8m=v;const L=60,A=L*60,j=A*24,D=j*7,I=j*30,P=j*365;function d(y,l,c,w){typeof y!="number"&&(y=y.getTime());const $=Math.round((new Date().getTime()-y)/1e3);if($<-30)return(0,R.localize)(0,null,d(new Date().getTime()+$*1e3,!1));if(!w&&$<30)return(0,R.localize)(1,null);let f;return $<L?(f=$,l?f===1?c?(0,R.localize)(2,null,f):(0,R.localize)(3,null,f):c?(0,R.localize)(4,null,f):(0,R.localize)(5,null,f):f===1?c?(0,R.localize)(6,null,f):(0,R.localize)(7,null,f):c?(0,R.localize)(8,null,f):(0,R.localize)(9,null,f)):$<A?(f=Math.floor($/L),l?f===1?c?(0,R.localize)(10,null,f):(0,R.localize)(11,null,f):c?(0,R.localize)(12,null,f):(0,R.localize)(13,null,f):f===1?c?(0,R.localize)(14,null,f):(0,R.localize)(15,null,f):c?(0,R.localize)(16,null,f):(0,R.localize)(17,null,f)):$<j?(f=Math.floor($/A),l?f===1?c?(0,R.localize)(18,null,f):(0,R.localize)(19,null,f):c?(0,R.localize)(20,null,f):(0,R.localize)(21,null,f):f===1?c?(0,R.localize)(22,null,f):(0,R.localize)(23,null,f):c?(0,R.localize)(24,null,f):(0,R.localize)(25,null,f)):$<D?(f=Math.floor($/j),l?f===1?(0,R.localize)(26,null,f):(0,R.localize)(27,null,f):f===1?(0,R.localize)(28,null,f):(0,R.localize)(29,null,f)):$<I?(f=Math.floor($/D),l?f===1?c?(0,R.localize)(30,null,f):(0,R.localize)(31,null,f):c?(0,R.localize)(32,null,f):(0,R.localize)(33,null,f):f===1?c?(0,R.localize)(34,null,f):(0,R.localize)(35,null,f):c?(0,R.localize)(36,null,f):(0,R.localize)(37,null,f)):$<P?(f=Math.floor($/I),l?f===1?c?(0,R.localize)(38,null,f):(0,R.localize)(39,null,f):c?(0,R.localize)(40,null,f):(0,R.localize)(41,null,f):f===1?c?(0,R.localize)(42,null,f):(0,R.localize)(43,null,f):c?(0,R.localize)(44,null,f):(0,R.localize)(45,null,f)):(f=Math.floor($/P),l?f===1?c?(0,R.localize)(46,null,f):(0,R.localize)(47,null,f):c?(0,R.localize)(48,null,f):(0,R.localize)(49,null,f):f===1?c?(0,R.localize)(50,null,f):(0,R.localize)(51,null,f):c?(0,R.localize)(52,null,f):(0,R.localize)(53,null,f))}function E(y,l){const c=Math.abs(y/1e3);return c<1?l?(0,R.localize)(54,null,y):(0,R.localize)(55,null,y):c<L?l?(0,R.localize)(56,null,Math.round(y)/1e3):(0,R.localize)(57,null,Math.round(y)/1e3):c<A?l?(0,R.localize)(58,null,Math.round(y/(1e3*L))):(0,R.localize)(59,null,Math.round(y/(1e3*L))):c<j?l?(0,R.localize)(60,null,Math.round(y/(1e3*A))):(0,R.localize)(61,null,Math.round(y/(1e3*A))):(0,R.localize)(62,null,Math.round(y/(1e3*j)))}function v(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[138],he([11,10]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,13,138]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=P,e.$mj=d,e.$nj=E;function j(v,y){return y&&(v.stack||v.stacktrace)?A.localize(0,null,I(v),D(v.stack)||D(v.stacktrace)):I(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function I(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?A.localize(1,null,v.message):v.message||A.localize(2,null)}function P(v=null,y=!1){if(!v)return A.localize(3,null);if(Array.isArray(v)){const l=R.$Hb(v),c=P(l[0],y);return l.length>1?A.localize(4,null,c,l.length):c}if(L.$ag(v))return v;if(v.detail){const l=v.detail;if(l.error)return j(l.error,y);if(l.exception)return j(l.exception,y)}return v.stack?j(v,y):v.message?v.message:A.localize(5,null)}function d(v){const y=v;return y instanceof Error&&Array.isArray(y.actions)}function E(v,y){let l;return typeof v=="string"?l=new Error(v):l=v,l.actions=y,l}}),define(le[139],he([11,10]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[140],he([0,1,139]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=L;function L(A){switch(A){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}}),define(le[141],he([11,10]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,141]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=p,e.$J=S,e.$g="en";let L=!1,A=!1,j=!1,D=!1,I=!1,P=!1,d=!1,E=!1,v=!1,y=!1,l,c=e.$g,w=e.$g,$,f;const u=globalThis;let h;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?h=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(h=process);const g=typeof h?.versions?.electron=="string",m=g&&h?.type==="renderer";if(typeof h=="object"){L=h.platform==="win32",A=h.platform==="darwin",j=h.platform==="linux",D=j&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,d=g,v=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,c=e.$g;const b=h.env.VSCODE_NLS_CONFIG;if(b)try{const k=JSON.parse(b),C=k.availableLanguages["*"];l=k.locale,w=k.osLocale,c=C||e.$g,$=k._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!m?(f=navigator.userAgent,L=f.indexOf("Windows")>=0,A=f.indexOf("Macintosh")>=0,E=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=f.indexOf("Linux")>=0,y=f?.indexOf("Mobi")>=0,P=!0,l=R.getConfiguredDefaultLocale(R.localize(0,null))||e.$g,c=l,w=navigator.language):console.error("Unable to resolve platform.");var t;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;A?s=1:L?s=3:j&&(s=2),e.$i=L,e.$j=A,e.$k=j,e.$l=D,e.$m=I,e.$n=d,e.$o=P,e.$p=P&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=E,e.$s=y,e.$t=v,e.$u=s,e.$v=f,e.$w=c;var n;(function(b){function k(){return e.$w}b.value=k;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}b.isDefaultVariant=C;function O(){return e.$w==="en"}b.isDefault=O})(n||(e.Language=n={})),e.$x=l,e.$y=w,e.$z=$,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const b=[];u.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let O=0,M=b.length;O<M;O++){const T=b[O];if(T.id===C.data.vscodeScheduleAsyncWork){b.splice(O,1),T.callback();return}}});let k=0;return C=>{const O=++k;b.push({id:O,callback:C}),u.postMessage({vscodeScheduleAsyncWork:O},"*")}}return b=>setTimeout(b)})();var i;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=A||E?2:L?1:3;let o=!0,a=!1;function p(){if(!a){a=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,o=new Uint16Array(b.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function S(b){return parseFloat(b)>=20}}),define(le[36],he([0,1,5]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const j=A.process;L={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return R.$i?"win32":R.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(le[142],he([0,1,36]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZV=D;var L;(function(I){I.UNKNOWN="UNKNOWN",I.CINNAMON="CINNAMON",I.DEEPIN="DEEPIN",I.GNOME="GNOME",I.KDE3="KDE3",I.KDE4="KDE4",I.KDE5="KDE5",I.KDE6="KDE6",I.PANTHEON="PANTHEON",I.UNITY="UNITY",I.XFCE="XFCE",I.UKUI="UKUI",I.LXQT="LXQT"})(L||(L={}));const A="XDG_CURRENT_DESKTOP",j="KDE_SESSION_VERSION";function D(){const I=R.env[A];if(I){const d=I.split(":").map(E=>E.trim()).filter(E=>E.length>0);for(const E of d)switch(E){case"Unity":{const v=R.env.DESKTOP_SESSION;return v&&v.includes("gnome-fallback")?L.GNOME:L.UNITY}case"Deepin":return L.DEEPIN;case"GNOME":return L.GNOME;case"X-Cinnamon":return L.CINNAMON;case"KDE":{const v=R.env[j];return v==="5"?L.KDE5:v==="6"?L.KDE6:L.KDE4}case"Pantheon":return L.PANTHEON;case"XFCE":return L.XFCE;case"UKUI":return L.UKUI;case"LXQt":return L.LXQT}}const P=R.env.DESKTOP_SESSION;if(P)switch(P){case"deepin":return L.DEEPIN;case"gnome":case"mate":return L.GNOME;case"kde4":case"kde-plasma":return L.KDE4;case"kde":return j in R.env?L.KDE4:L.KDE3;case"xfce":case"xubuntu":return L.XFCE;case"ukui":return L.UKUI}return"GNOME_DESKTOP_SESSION_ID"in R.env?L.GNOME:"KDE_FULL_SESSION"in R.env?j in R.env?L.KDE4:L.KDE3:L.UNKNOWN}}),define(le[14],he([0,1,36]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,A=97,j=90,D=122,I=46,P=47,d=92,E=58,v=63;class y extends Error{constructor(r,s,n){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const o=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${o} ${i} of type ${s}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function l(t,r){if(t===null||typeof t!="object")throw new y(r,"Object",t)}function c(t,r){if(typeof t!="string")throw new y(r,"string",t)}const w=R.$dc==="win32";function $(t){return t===P||t===d}function f(t){return t===P}function u(t){return t>=L&&t<=j||t>=A&&t<=D}function h(t,r,s,n){let i="",o=0,a=-1,p=0,S=0;for(let b=0;b<=t.length;++b){if(b<t.length)S=t.charCodeAt(b);else{if(n(S))break;S=P}if(n(S)){if(!(a===b-1||p===1))if(p===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const k=i.lastIndexOf(s);k===-1?(i="",o=0):(i=i.slice(0,k),o=i.length-1-i.lastIndexOf(s)),a=b,p=0;continue}else if(i.length!==0){i="",o=0,a=b,p=0;continue}}r&&(i+=i.length>0?`${s}..`:"..",o=2)}else i.length>0?i+=`${s}${t.slice(a+1,b)}`:i=t.slice(a+1,b),o=b-a-1;a=b,p=0}else S===I&&p!==-1?++p:p=-1}return i}function g(t,r){l(r,"pathObject");const s=r.dir||r.root,n=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${n}`:`${s}${t}${n}`:n}e.$fc={resolve(...t){let r="",s="",n=!1;for(let i=t.length-1;i>=-1;i--){let o;if(i>=0){if(o=t[i],c(o,"path"),o.length===0)continue}else r.length===0?o=R.cwd():(o=R.env[`=${r}`]||R.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===d)&&(o=`${r}\\`));const a=o.length;let p=0,S="",b=!1;const k=o.charCodeAt(0);if(a===1)$(k)&&(p=1,b=!0);else if($(k))if(b=!0,$(o.charCodeAt(1))){let C=2,O=C;for(;C<a&&!$(o.charCodeAt(C));)C++;if(C<a&&C!==O){const M=o.slice(O,C);for(O=C;C<a&&$(o.charCodeAt(C));)C++;if(C<a&&C!==O){for(O=C;C<a&&!$(o.charCodeAt(C));)C++;(C===a||C!==O)&&(S=`\\\\${M}\\${o.slice(O,C)}`,p=C)}}}else p=1;else u(k)&&o.charCodeAt(1)===E&&(S=o.slice(0,2),p=2,a>2&&$(o.charCodeAt(2))&&(b=!0,p=3));if(S.length>0)if(r.length>0){if(S.toLowerCase()!==r.toLowerCase())continue}else r=S;if(n){if(r.length>0)break}else if(s=`${o.slice(p)}\\${s}`,n=b,b&&r.length>0)break}return s=h(s,!n,"\\",$),n?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){c(t,"path");const r=t.length;if(r===0)return".";let s=0,n,i=!1;const o=t.charCodeAt(0);if(r===1)return f(o)?"\\":t;if($(o))if(i=!0,$(t.charCodeAt(1))){let p=2,S=p;for(;p<r&&!$(t.charCodeAt(p));)p++;if(p<r&&p!==S){const b=t.slice(S,p);for(S=p;p<r&&$(t.charCodeAt(p));)p++;if(p<r&&p!==S){for(S=p;p<r&&!$(t.charCodeAt(p));)p++;if(p===r)return`\\\\${b}\\${t.slice(S)}\\`;p!==S&&(n=`\\\\${b}\\${t.slice(S,p)}`,s=p)}}}else s=1;else u(o)&&t.charCodeAt(1)===E&&(n=t.slice(0,2),s=2,r>2&&$(t.charCodeAt(2))&&(i=!0,s=3));let a=s<r?h(t.slice(s),!i,"\\",$):"";return a.length===0&&!i&&(a="."),a.length>0&&$(t.charCodeAt(r-1))&&(a+="\\"),n===void 0?i?`\\${a}`:a:i?`${n}\\${a}`:`${n}${a}`},isAbsolute(t){c(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return $(s)||r>2&&u(s)&&t.charCodeAt(1)===E&&$(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let o=0;o<t.length;++o){const a=t[o];c(a,"path"),a.length>0&&(r===void 0?r=s=a:r+=`\\${a}`)}if(r===void 0)return".";let n=!0,i=0;if(typeof s=="string"&&$(s.charCodeAt(0))){++i;const o=s.length;o>1&&$(s.charCodeAt(1))&&(++i,o>2&&($(s.charCodeAt(2))?++i:n=!1))}if(n){for(;i<r.length&&$(r.charCodeAt(i));)i++;i>=2&&(r=`\\${r.slice(i)}`)}return e.$fc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r)return"";const s=e.$fc.resolve(t),n=e.$fc.resolve(r);if(s===n||(t=s.toLowerCase(),r=n.toLowerCase(),t===r))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===d;)i++;let o=t.length;for(;o-1>i&&t.charCodeAt(o-1)===d;)o--;const a=o-i;let p=0;for(;p<r.length&&r.charCodeAt(p)===d;)p++;let S=r.length;for(;S-1>p&&r.charCodeAt(S-1)===d;)S--;const b=S-p,k=a<b?a:b;let C=-1,O=0;for(;O<k;O++){const T=t.charCodeAt(i+O);if(T!==r.charCodeAt(p+O))break;T===d&&(C=O)}if(O!==k){if(C===-1)return n}else{if(b>k){if(r.charCodeAt(p+O)===d)return n.slice(p+O+1);if(O===2)return n.slice(p+O)}a>k&&(t.charCodeAt(i+O)===d?C=O:O===2&&(C=3)),C===-1&&(C=0)}let M="";for(O=i+C+1;O<=o;++O)(O===o||t.charCodeAt(O)===d)&&(M+=M.length===0?"..":"\\..");return p+=C,M.length>0?`${M}${n.slice(p,S)}`:(n.charCodeAt(p)===d&&++p,n.slice(p,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===d){if(r.charCodeAt(1)===d){const s=r.charCodeAt(2);if(s!==v&&s!==I)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===E&&r.charCodeAt(2)===d)return`\\\\?\\${r}`;return t},dirname(t){c(t,"path");const r=t.length;if(r===0)return".";let s=-1,n=0;const i=t.charCodeAt(0);if(r===1)return $(i)?t:".";if($(i)){if(s=n=1,$(t.charCodeAt(1))){let p=2,S=p;for(;p<r&&!$(t.charCodeAt(p));)p++;if(p<r&&p!==S){for(S=p;p<r&&$(t.charCodeAt(p));)p++;if(p<r&&p!==S){for(S=p;p<r&&!$(t.charCodeAt(p));)p++;if(p===r)return t;p!==S&&(s=n=p+1)}}}}else u(i)&&t.charCodeAt(1)===E&&(s=r>2&&$(t.charCodeAt(2))?3:2,n=s);let o=-1,a=!0;for(let p=r-1;p>=n;--p)if($(t.charCodeAt(p))){if(!a){o=p;break}}else a=!1;if(o===-1){if(s===-1)return".";o=s}return t.slice(0,o)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let s=0,n=-1,i=!0,o;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,p=-1;for(o=t.length-1;o>=s;--o){const S=t.charCodeAt(o);if($(S)){if(!i){s=o+1;break}}else p===-1&&(i=!1,p=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(n=o):(a=-1,n=p))}return s===n?n=p:n===-1&&(n=t.length),t.slice(s,n)}for(o=t.length-1;o>=s;--o)if($(t.charCodeAt(o))){if(!i){s=o+1;break}}else n===-1&&(i=!1,n=o+1);return n===-1?"":t.slice(s,n)},extname(t){c(t,"path");let r=0,s=-1,n=0,i=-1,o=!0,a=0;t.length>=2&&t.charCodeAt(1)===E&&u(t.charCodeAt(0))&&(r=n=2);for(let p=t.length-1;p>=r;--p){const S=t.charCodeAt(p);if($(S)){if(!o){n=p+1;break}continue}i===-1&&(o=!1,i=p+1),S===I?s===-1?s=p:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||i===-1||a===0||a===1&&s===i-1&&s===n+1?"":t.slice(s,i)},format:g.bind(null,"\\"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let n=0,i=t.charCodeAt(0);if(s===1)return $(i)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if($(i)){if(n=1,$(t.charCodeAt(1))){let C=2,O=C;for(;C<s&&!$(t.charCodeAt(C));)C++;if(C<s&&C!==O){for(O=C;C<s&&$(t.charCodeAt(C));)C++;if(C<s&&C!==O){for(O=C;C<s&&!$(t.charCodeAt(C));)C++;C===s?n=C:C!==O&&(n=C+1)}}}}else if(u(i)&&t.charCodeAt(1)===E){if(s<=2)return r.root=r.dir=t,r;if(n=2,$(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;n=3}}n>0&&(r.root=t.slice(0,n));let o=-1,a=n,p=-1,S=!0,b=t.length-1,k=0;for(;b>=n;--b){if(i=t.charCodeAt(b),$(i)){if(!S){a=b+1;break}continue}p===-1&&(S=!1,p=b+1),i===I?o===-1?o=b:k!==1&&(k=1):o!==-1&&(k=-1)}return p!==-1&&(o===-1||k===0||k===1&&o===p-1&&o===a+1?r.base=r.name=t.slice(a,p):(r.name=t.slice(a,o),r.base=t.slice(a,p),r.ext=t.slice(o,p))),a>0&&a!==n?r.dir=t.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(w){const t=/\\/g;return()=>{const r=R.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>R.cwd()})();e.$gc={resolve(...t){let r="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const i=n>=0?t[n]:m();c(i,"path"),i.length!==0&&(r=`${i}/${r}`,s=i.charCodeAt(0)===P)}return r=h(r,!s,"/",f),s?`/${r}`:r.length>0?r:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===P,s=t.charCodeAt(t.length-1)===P;return t=h(t,!r,"/",f),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===P},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const n=t[s];c(n,"path"),n.length>0&&(r===void 0?r=n:r+=`/${n}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const s=1,n=t.length,i=n-s,o=1,a=r.length-o,p=i<a?i:a;let S=-1,b=0;for(;b<p;b++){const C=t.charCodeAt(s+b);if(C!==r.charCodeAt(o+b))break;C===P&&(S=b)}if(b===p)if(a>p){if(r.charCodeAt(o+b)===P)return r.slice(o+b+1);if(b===0)return r.slice(o+b)}else i>p&&(t.charCodeAt(s+b)===P?S=b:b===0&&(S=0));let k="";for(b=s+S+1;b<=n;++b)(b===n||t.charCodeAt(b)===P)&&(k+=k.length===0?"..":"/..");return`${k}${r.slice(o+S)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===P;let s=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===P){if(!n){s=i;break}}else n=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let s=0,n=-1,i=!0,o;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,p=-1;for(o=t.length-1;o>=0;--o){const S=t.charCodeAt(o);if(S===P){if(!i){s=o+1;break}}else p===-1&&(i=!1,p=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(n=o):(a=-1,n=p))}return s===n?n=p:n===-1&&(n=t.length),t.slice(s,n)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===P){if(!i){s=o+1;break}}else n===-1&&(i=!1,n=o+1);return n===-1?"":t.slice(s,n)},extname(t){c(t,"path");let r=-1,s=0,n=-1,i=!0,o=0;for(let a=t.length-1;a>=0;--a){const p=t.charCodeAt(a);if(p===P){if(!i){s=a+1;break}continue}n===-1&&(i=!1,n=a+1),p===I?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||n===-1||o===0||o===1&&r===n-1&&r===s+1?"":t.slice(r,n)},format:g.bind(null,"/"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===P;let n;s?(r.root="/",n=1):n=0;let i=-1,o=0,a=-1,p=!0,S=t.length-1,b=0;for(;S>=n;--S){const k=t.charCodeAt(S);if(k===P){if(!p){o=S+1;break}continue}a===-1&&(p=!1,a=S+1),k===I?i===-1?i=S:b!==1&&(b=1):i!==-1&&(b=-1)}if(a!==-1){const k=o===0&&s?1:o;i===-1||b===0||b===1&&i===a-1&&i===o+1?r.base=r.name=t.slice(k,a):(r.name=t.slice(k,i),r.base=t.slice(k,a),r.ext=t.slice(i,a))}return o>0?r.dir=t.slice(0,o-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=w?e.$fc.normalize:e.$gc.normalize,e.$ic=w?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=w?e.$fc.join:e.$gc.join,e.$kc=w?e.$fc.resolve:e.$gc.resolve,e.$lc=w?e.$fc.relative:e.$gc.relative,e.$mc=w?e.$fc.dirname:e.$gc.dirname,e.$nc=w?e.$fc.basename:e.$gc.basename,e.$oc=w?e.$fc.extname:e.$gc.extname,e.$pc=w?e.$fc.format:e.$gc.format,e.$qc=w?e.$fc.parse:e.$gc.parse,e.$rc=w?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=w?e.$fc.sep:e.$gc.sep,e.$tc=w?e.$fc.delimiter:e.$gc.delimiter}),define(le[40],he([0,1,14,5,27,13]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=D,e.$tg=I,e.$ug=P,e.$vg=d,e.$wg=E,e.$xg=c,e.$yg=w,e.$zg=$,e.$Ag=f,e.$Bg=u,e.$Cg=h,e.$Dg=g,e.$Eg=m,e.$Fg=t,e.$Gg=r,e.$Hg=s,e.$Ig=o;function D(a){return a===47||a===92}function I(a){return a.replace(/[\\/]/g,R.$gc.sep)}function P(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function d(a,p=R.$gc.sep){if(!a)return"";const S=a.length,b=a.charCodeAt(0);if(D(b)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let C=3;const O=C;for(;C<S&&!D(a.charCodeAt(C));C++);if(O!==C&&!D(a.charCodeAt(C+1))){for(C+=1;C<S;C++)if(D(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,p)}}return p}else if(f(b)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+p:a.slice(0,2);let k=a.indexOf("://");if(k!==-1){for(k+=3;k<S;k++)if(D(a.charCodeAt(k)))return a.slice(0,k+1)}return""}function E(a){if(!L.$i||!a||a.length<5)return!1;let p=a.charCodeAt(0);if(p!==92||(p=a.charCodeAt(1),p!==92))return!1;let S=2;const b=S;for(;S<a.length&&(p=a.charCodeAt(S),p!==92);S++);return!(b===S||(p=a.charCodeAt(S+1),isNaN(p)||p===92))}const v=/[\\/:\*\?"<>\|]/g,y=/[/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(a,p=L.$i){const S=p?v:y;return!(!a||a.length===0||/^\s+$/.test(a)||(S.lastIndex=0,S.test(a))||p&&l.test(a)||a==="."||a===".."||p&&a[a.length-1]==="."||p&&a.length!==a.trim().length||a.length>255)}function w(a,p,S){const b=a===p;return!S||b?b:!a||!p?!1:(0,A.$Bf)(a,p)}function $(a,p,S,b=R.sep){if(a===p)return!0;if(!a||!p||p.length>a.length)return!1;if(S){if(!(0,A.$Cf)(a,p))return!1;if(p.length===a.length)return!0;let C=p.length;return p.charAt(p.length-1)===b&&C--,a.charAt(C)===b}return p.charAt(p.length-1)!==b&&(p+=b),a.indexOf(p)===0}function f(a){return a>=65&&a<=90||a>=97&&a<=122}function u(a,p){return L.$i&&a.endsWith(":")&&(a+=R.sep),(0,R.$ic)(a)||(a=(0,R.$jc)(p,a)),a=(0,R.$hc)(a),h(a)}function h(a){return L.$i?(a=(0,A.$jf)(a,R.sep),a.endsWith(":")&&(a+=R.sep)):(a=(0,A.$jf)(a,R.sep),a||(a=R.sep)),a}function g(a){const p=(0,R.$hc)(a);return L.$i?a.length>3?!1:m(p)&&(a.length===2||p.charCodeAt(2)===92):p===R.$gc.sep}function m(a,p=L.$i){return p?f(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}function t(a,p=L.$i){return m(a,p)?a[0]:void 0}function r(a,p,S){return p.length>a.length?-1:a===p?0:(S&&(a=a.toLowerCase(),p=p.toLowerCase()),a.indexOf(p))}function s(a){const p=a.split(":");let S,b,k;for(const C of p){const O=Number(C);(0,j.$eg)(O)?b===void 0?b=O:k===void 0&&(k=O):S=S?[S,C].join(":"):C}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:b!==void 0?b:void 0,column:k!==void 0?k:b!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(a,p,S=8){let b="";for(let C=0;C<S;C++){let O;C===0&&L.$i&&!p&&(S===3||S===4)?O=i:O=n,b+=O.charAt(Math.floor(Math.random()*O.length))}let k;return p?k=`${p}-${b}`:k=b,a?(0,R.$jc)(a,k):k}}),define(le[143],he([0,1,14]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0,e.$Xs=j,e.$Ys=D,e.$Zs=I,e.$1s=d,e.$Ws=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(E){const v=(0,R.$oc)(E),y=L[v.toLowerCase()];return y!==void 0?y:D(E)}function D(E){const v=(0,R.$oc)(E);return A[v.toLowerCase()]}function I(E){for(const v in A)if(A[v]===E)return v}const P=/^(.+)\/(.+?)(;.+)?$/;function d(E,v){const y=P.exec(E);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:v?void 0:E}}),define(le[90],he([0,1,5]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=j,e.$rm=D;var L;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(L||(e.Source=L={}));var A;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function j(I,...P){const d=P.reduce((y,l)=>(y[l]=!0,y),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(y=>!d[y]).forEach(y=>{for(let l=0;l<E.length;l++)if(y.search(E[l])!==-1){delete I[y];break}})}function D(I){I&&(delete I.DEBUG,R.$j&&delete I.DYLD_LIBRARY_PATH,R.$k&&delete I.LD_PRELOAD)}}),define(le[8],he([0,1,14,5]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=c,e.$wc=g;const A=/^\w[\w\d+.-]*$/,j=/^\//,D=/^\/\//;function I(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!A.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!j.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(n,i){return!n&&!i?"file":n}function d(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==v&&(i=v+i):i=v;break}return i}const E="",v="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(i){return i instanceof l?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,a,p,S,b=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=P(i,b),this.authority=o||E,this.path=d(this.scheme,a||E),this.query=p||E,this.fragment=S||E,I(this,b))}get fsPath(){return g(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:a,path:p,query:S,fragment:b}=i;return o===void 0?o=this.scheme:o===null&&(o=E),a===void 0?a=this.authority:a===null&&(a=E),p===void 0?p=this.path:p===null&&(p=E),S===void 0?S=this.query:S===null&&(S=E),b===void 0?b=this.fragment:b===null&&(b=E),o===this.scheme&&a===this.authority&&p===this.path&&S===this.query&&b===this.fragment?this:new $(o,a,p,S,b)}static parse(i,o=!1){const a=y.exec(i);return a?new $(a[2]||E,s(a[4]||E),s(a[5]||E),s(a[7]||E),s(a[9]||E),o):new $(E,E,E,E,E)}static file(i){let o=E;if(L.$i&&(i=i.replace(/\\/g,v)),i[0]===v&&i[1]===v){const a=i.indexOf(v,2);a===-1?(o=i.substring(2),i=v):(o=i.substring(2,a),i=i.substring(a)||v)}return new $("file",o,i,E,E)}static from(i,o){return new $(i.scheme,i.authority,i.path,i.query,i.fragment,o)}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return L.$i&&i.scheme==="file"?a=l.file(R.$fc.join(g(i,!0),...o)).path:a=R.$gc.join(i.path,...o),i.with({path:a})}toString(i=!1){return m(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof l)return i;{const o=new $(i);return o._formatted=i.external??null,o._fsPath=i._sep===w?i.fsPath??null:null,o}}else return i}}e.URI=l;function c(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}const w=L.$i?1:void 0;class $ extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(i=!1){return i?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=w),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const f={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(n,i,o){let a,p=-1;for(let S=0;S<n.length;S++){const b=n.charCodeAt(S);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47||o&&b===91||o&&b===93||o&&b===58)p!==-1&&(a+=encodeURIComponent(n.substring(p,S)),p=-1),a!==void 0&&(a+=n.charAt(S));else{a===void 0&&(a=n.substr(0,S));const k=f[b];k!==void 0?(p!==-1&&(a+=encodeURIComponent(n.substring(p,S)),p=-1),a+=k):p===-1&&(p=S)}}return p!==-1&&(a+=encodeURIComponent(n.substring(p))),a!==void 0?a:n}function h(n){let i;for(let o=0;o<n.length;o++){const a=n.charCodeAt(o);a===35||a===63?(i===void 0&&(i=n.substr(0,o)),i+=f[a]):i!==void 0&&(i+=n[o])}return i!==void 0?i:n}function g(n,i){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,L.$i&&(o=o.replace(/\//g,"\\")),o}function m(n,i){const o=i?h:u;let a="",{scheme:p,authority:S,path:b,query:k,fragment:C}=n;if(p&&(a+=p,a+=":"),(S||p==="file")&&(a+=v,a+=v),S){let O=S.indexOf("@");if(O!==-1){const M=S.substr(0,O);S=S.substr(O+1),O=M.lastIndexOf(":"),O===-1?a+=o(M,!1,!1):(a+=o(M.substr(0,O),!1,!1),a+=":",a+=o(M.substr(O+1),!1,!0)),a+="@"}S=S.toLowerCase(),O=S.lastIndexOf(":"),O===-1?a+=o(S,!1,!0):(a+=o(S.substr(0,O),!1,!0),a+=S.substr(O))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const O=b.charCodeAt(1);O>=65&&O<=90&&(b=`/${String.fromCharCode(O+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const O=b.charCodeAt(0);O>=65&&O<=90&&(b=`${String.fromCharCode(O+32)}:${b.substr(2)}`)}a+=o(b,!0,!1)}return k&&(a+="?",a+=o(k,!1,!1)),C&&(a+="#",a+=i?C:u(C,!1,!1)),a}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(r)?n.replace(r,i=>t(i)):n}}),define(le[144],he([0,1,8]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=L,e.$3q=A,e.$4q=j,e.log=I;function L(d){const E=d;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function A(d){const E=[];let v;try{const y=JSON.parse(d.arguments),l=y[y.length-1];l&&l.__$stack&&(y.pop(),v=l.__$stack),E.push(...y)}catch{E.push("Unable to log remote console arguments",d.arguments)}return{args:E,stack:v}}function j(d){if(typeof d!="string")return j(A(d).stack);const E=d;if(E){const v=D(E),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:R.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}function D(d){if(!d)return d;const E=d.indexOf(`
`);return E===-1?d:d.substring(0,E)}function I(d,E){const{args:v,stack:y}=A(d),l=typeof v[0]=="string"&&v.length===1;let c=D(y);c&&(c=`(${c.trim()})`);let w=[];if(typeof v[0]=="string"?c&&l?w=[`%c[${E}] %c${v[0]} %c${c}`,P("blue"),P(""),P("grey")]:w=[`%c[${E}] %c${v[0]}`,P("blue"),P(""),...v.slice(1)]:w=[`%c[${E}]%`,P("blue"),...v],c&&!l&&w.push(c),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,w)}function P(d){return`color: ${d}`}}),define(le[66],he([0,1,15,8]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=A,e.$9h=j,e.$0h=I;function A(P){return JSON.stringify(P,D)}function j(P){let d=JSON.parse(P);return d=I(d),d}function D(P,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function I(P,d=0){if(!P||d>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return L.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 17:return new Date(P.source)}if(P instanceof R.$Je||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let E=0;E<P.length;++E)P[E]=I(P[E],d+1);else for(const E in P)Object.hasOwnProperty.call(P,E)&&(P[E]=I(P[E],d+1))}return P}}),define(le[23],he([0,1,7,5,27,8,14]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=P,e.$Kg=d,e.$Og=v;var I;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(I||(e.Schemas=I={}));function P(c,w){return j.URI.isUri(c)?(0,A.$Bf)(c.scheme,w):(0,A.$Cf)(c,w+":")}function d(c,...w){return w.some($=>P(c,$))}e.$Lg="vscode-tkn",e.$Mg="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w,$){this.f=v(w,$)}getServerRootPath(){return this.f}get g(){return D.$gc.join(this.f,I.vscodeRemoteResource)}set(w,$,f){this.a[w]=$,this.b[w]=f}setConnectionToken(w,$){this.c[w]=$}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(m){return R.$1(m),w}const $=w.authority;let f=this.a[$];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const u=this.b[$],h=this.c[$];let g=`path=${encodeURIComponent(w.path)}`;return typeof h=="string"&&(g+=`&${e.$Mg}=${encodeURIComponent(h)}`),j.URI.from({scheme:L.$o?this.d:I.vscodeRemoteResource,authority:`${f}:${u}`,path:this.g,query:g})}}e.$Ng=new E;function v(c,w){return D.$gc.join(w??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class y{static{this.a=e.$Tg}asBrowserUri(w){const $=this.b(w,se);return this.uriToBrowserUri($)}uriToBrowserUri(w){return w.scheme===I.vscodeRemote?e.$Ng.rewrite(w):w.scheme===I.file&&(L.$m||L.$q===`${I.vscodeFileResource}://${y.a}`)?w.with({scheme:I.vscodeFileResource,authority:w.authority||y.a,query:null,fragment:null}):w}asFileUri(w){const $=this.b(w,se);return this.uriToFileUri($)}uriToFileUri(w){return w.scheme===I.vscodeFileResource?w.with({scheme:I.file,authority:w.authority!==y.a?w.authority:null,query:null,fragment:null}):w}b(w,$){return j.URI.isUri(w)?w:j.URI.parse($.toUrl(w))}}e.$Ug=new y;var l;(function(c){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(w.get("3"));const $="vscode-coi";function f(h){let g;typeof h=="string"?g=new URL(h).searchParams:h instanceof URL?g=h.searchParams:j.URI.isUri(h)&&(g=new URL(h.toString(!0)).searchParams);const m=g?.get($);if(m)return w.get(m)}c.getHeadersFromQuery=f;function u(h,g,m){if(!globalThis.crossOriginIsolated)return;const t=g&&m?"3":m?"2":"1";h instanceof URLSearchParams?h.set($,t):h[$]=t}c.addSearchParam=u})(l||(e.COI=l={}))}),define(le[145],he([0,1,126,23,5,8]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bE=E;class D{constructor(y,l,c){this.id=y,this.dependencies=l,this.callback=c}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(y,l,c)=>{typeof y!="string"&&(c=l,l=y,y=null),(typeof l!="object"||!Array.isArray(l))&&(c=l,l=null),this.c.push(new D(y,l,c))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){if(y.startsWith(window.location.origin)||y.startsWith("vscode-file://vscode-app"))return y;throw new Error(`[trusted_script_src] Invalid script url: ${y}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(y){return y}})))}async load(y){this.g();const l=await(this.a?this.i(y):this.b?this.h(y):this.j(y));if(!l)throw new Error(`Did not receive a define call from script ${y}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${y}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(y){return new Promise((l,c)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const $=()=>{w.removeEventListener("load",f),w.removeEventListener("error",u)},f=h=>{$(),l(this.c.pop())},u=h=>{$(),c(h)};w.addEventListener("load",f),w.addEventListener("error",u),this.f&&(y=this.f.createScriptURL(y)),w.setAttribute("src",y),window.document.getElementsByTagName("head")[0].appendChild(w)})}i(y){return new Promise((l,c)=>{try{this.f&&(y=this.f.createScriptURL(y)),importScripts(y),l(this.c.pop())}catch(w){c(w)}})}async j(y){try{const l=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,$=j.URI.parse(y).fsPath,f=l.readFileSync($).toString(),u=w.wrap(f.replace(/^#!.*/,""));return new c.Script(u).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const P=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function E(v,y,l){if(R.$T){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[v]&&(v=d[v]);const c=`${v}/${y}`;if(P.has(c))return P.get(c);let w;if(/^\w[\w\d+.-]*:\/\//.test(c))w=c;else{const h=`${l&&!A.$o?L.$Rg:L.$Qg}/${c}`;w=L.$Ug.asBrowserUri(h).toString(!0)}const $=I.INSTANCE.load(w);return P.set(c,$),$}else return await new Promise((c,w)=>{se([v],c,w)})}}),define(le[21],he([0,1,40,23,14,5,27,8]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=P,e.$kh=E,e.$lh=y;function P(l){return(0,I.$wc)(l,!0)}class d{constructor(c){this.a=c}compare(c,w,$=!1){return c===w?0:(0,D.$uf)(this.getComparisonKey(c,$),this.getComparisonKey(w,$))}isEqual(c,w,$=!1){return c===w?!0:!c||!w?!1:this.getComparisonKey(c,$)===this.getComparisonKey(w,$)}getComparisonKey(c,w=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,w,$=!1){if(c.scheme===w.scheme){if(c.scheme===L.Schemas.file)return R.$zg(P(c),P(w),this.a(c))&&c.query===w.query&&($||c.fragment===w.fragment);if((0,e.$gh)(c.authority,w.authority))return R.$zg(c.path,w.path,this.a(c),"/")&&c.query===w.query&&($||c.fragment===w.fragment)}return!1}joinPath(c,...w){return I.URI.joinPath(c,...w)}basenameOrAuthority(c){return(0,e.$$g)(c)||c.authority}basename(c){return A.$gc.basename(c.path)}extname(c){return A.$gc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let w;return c.scheme===L.Schemas.file?w=I.URI.file(A.$mc(P(c))).path:(w=A.$gc.dirname(c.path),c.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),w="/")),c.with({path:w})}normalizePath(c){if(!c.path.length)return c;let w;return c.scheme===L.Schemas.file?w=I.URI.file(A.$hc(P(c))).path:w=A.$gc.normalize(c.path),c.with({path:w})}relativePath(c,w){if(c.scheme!==w.scheme||!(0,e.$gh)(c.authority,w.authority))return;if(c.scheme===L.Schemas.file){const u=A.$lc(P(c),P(w));return j.$i?R.$tg(u):u}let $=c.path||"/";const f=w.path||"/";if(this.a(c)){let u=0;for(const h=Math.min($.length,f.length);u<h&&!($.charCodeAt(u)!==f.charCodeAt(u)&&$.charAt(u).toLowerCase()!==f.charAt(u).toLowerCase());u++);$=f.substr(0,u)+$.substr(u)}return A.$gc.relative($,f)}resolvePath(c,w){if(c.scheme===L.Schemas.file){const $=I.URI.file(A.$kc(P(c),w));return c.with({authority:$.authority,path:$.path})}return w=R.$ug(w),c.with({path:A.$gc.resolve(c.path,w)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,w){return c===w||c!==void 0&&w!==void 0&&(0,D.$Bf)(c,w)}hasTrailingPathSeparator(c,w=A.sep){if(c.scheme===L.Schemas.file){const $=P(c);return $.length>R.$vg($).length&&$[$.length-1]===w}else{const $=c.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,w=A.sep){return(0,e.$hh)(c,w)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,w=A.sep){let $=!1;if(c.scheme===L.Schemas.file){const f=P(c);$=f!==void 0&&f.length===R.$vg(f).length&&f[f.length-1]===w}else{w="/";const f=c.path;$=f.length===1&&f.charCodeAt(f.length-1)===47}return!$&&!(0,e.$hh)(c,w)?c.with({path:c.path+"/"}):c}}e.$3g=d,e.$4g=new d(()=>!1),e.$5g=new d(l=>l.scheme===L.Schemas.file?!j.$k:!0),e.$6g=new d(l=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function E(l,c){const w=[];for(let $=0;$<l.length;$++){const f=c(l[$]);l.some((u,h)=>h===$?!1:(0,e.$8g)(f,c(u)))||w.push(l[$])}return w}var v;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function c(w){const $=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(h=>{const[g,m]=h.split(":");g&&m&&$.set(g,m)});const u=w.path.substring(0,w.path.indexOf(";"));return u&&$.set(l.META_DATA_MIME,u),$}l.parseMetaData=c})(v||(e.DataUri=v={}));function y(l,c,w){if(c){let $=l.path;return $&&$[0]!==A.$gc.sep&&($=A.$gc.sep+$),l.with({scheme:w,authority:c,path:$})}return l.with({scheme:w})}}),define(le[6],he([0,1,26,7,3,2,21,5,132,53]),function(se,e,R,L,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=E,e.$nh=v,e.$oh=y,e.$ph=l,e.$qh=c,e.$rh=w,e.$sh=$,e.$th=f,e.$Bh=o,e.$Ch=a,e.$Dh=p,e.$Eh=S,e.$Fh=b,e.$Uh=B,e.$3h=_;function E(ne){return!!ne&&typeof ne.then=="function"}function v(ne){const te=new R.$se,ce=ne(te.token),fe=new Promise(($e,we)=>{const Ee=te.token.onCancellationRequested(()=>{Ee.dispose(),we(new L.$5)});Promise.resolve(ce).then(be=>{Ee.dispose(),te.dispose(),$e(be)},be=>{Ee.dispose(),te.dispose(),we(be)})});return new class{cancel(){te.cancel(),te.dispose()}then($e,we){return fe.then($e,we)}catch($e){return this.then(void 0,$e)}finally($e){return fe.finally($e)}}}function y(ne,te,ce){return new Promise((fe,$e)=>{const we=te.onCancellationRequested(()=>{we.dispose(),fe(ce)});ne.then(fe,$e).finally(()=>we.dispose())})}function l(ne,te){return new Promise((ce,fe)=>{const $e=te.onCancellationRequested(()=>{$e.dispose(),fe(new L.$5)});ne.then(ce,fe).finally(()=>$e.dispose())})}async function c(ne){let te=-1;const ce=ne.map((fe,$e)=>fe.then(we=>(te=$e,we)));try{return await Promise.race(ce)}finally{ne.forEach((fe,$e)=>{$e!==te&&fe.cancel()})}}function w(ne,te,ce){let fe;const $e=setTimeout(()=>{fe?.(void 0),ce?.()},te);return Promise.race([ne.finally(()=>clearTimeout($e)),new Promise(we=>fe=we)])}function $(ne){return new Promise((te,ce)=>{const fe=ne();E(fe)?fe.then(te,ce):te(fe)})}function f(){let ne,te;return{promise:new Promise((fe,$e)=>{ne=fe,te=$e}),resolve:ne,reject:te}}class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const ce=()=>{if(this.b=null,this.f)return;const fe=this.queue(this.d);return this.d=null,fe};this.b=new Promise(fe=>{this.a.then(ce,ce).then(fe)})}return new Promise((ce,fe)=>{this.b.then(ce,fe)})}return this.a=te(),new Promise((ce,fe)=>{this.a.then($e=>{this.a=null,ce($e)},$e=>{this.a=null,fe($e)})})}dispose(){this.f=!0}}e.$uh=u;class h{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$vh=h;class g{constructor(){this.a=new Map}queue(te,ce){const $e=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(ce).finally(()=>{this.a.get(te)===$e&&this.a.delete(te)});return this.a.set(te,$e),$e}}e.$wh=g;const m=(ne,te)=>{let ce=!0;const fe=setTimeout(()=>{ce=!1,te()},ne);return{isTriggered:()=>ce,dispose:()=>{clearTimeout(fe),ce=!1}}},t=ne=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ne())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class r{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,ce=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise(($e,we)=>{this.d=$e,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const fe=()=>{this.a=null,this.d?.(null)};return this.a=ce===P.$ce?t(fe):m(ce,fe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=r;class s{constructor(te){this.a=new r(te),this.b=new u}trigger(te,ce){return this.a.trigger(()=>this.b.queue(te),ce)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=s;class n{constructor(){this.a=!1,this.b=new Promise((te,ce)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=n;class i extends n{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$Ah=i;function o(ne,te){return te?new Promise((ce,fe)=>{const $e=setTimeout(()=>{we.dispose(),ce()},ne),we=te.onCancellationRequested(()=>{clearTimeout($e),we.dispose(),fe(new L.$5)})}):v(ce=>o(ne,ce))}function a(ne,te=0,ce){const fe=setTimeout(()=>{ne(),ce&&$e.dispose()},te),$e=(0,j.$Sc)(()=>{clearTimeout(fe),ce?.deleteAndLeak($e)});return ce?.add($e),$e}function p(ne){const te=[];let ce=0;const fe=ne.length;function $e(){return ce<fe?ne[ce++]():null}function we(Ee){Ee!=null&&te.push(Ee);const be=$e();return be?be.then(we):Promise.resolve(te)}return Promise.resolve(null).then(we)}function S(ne,te=fe=>!!fe,ce=null){let fe=0;const $e=ne.length,we=()=>{if(fe>=$e)return Promise.resolve(ce);const Ee=ne[fe++];return Promise.resolve(Ee()).then(ye=>te(ye)?Promise.resolve(ye):we())};return we()}function b(ne,te=fe=>!!fe,ce=null){if(ne.length===0)return Promise.resolve(ce);let fe=ne.length;const $e=()=>{fe=-1;for(const we of ne)we.cancel?.()};return new Promise((we,Ee)=>{for(const be of ne)be.then(ye=>{--fe>=0&&te(ye)?($e(),we(ye)):fe===0&&we(ce)}).catch(ye=>{--fe>=0&&($e(),Ee(ye))})})}class k{constructor(te){this.a=0,this.b=!1,this.f=te,this.g=[],this.d=0,this.h=new A.$he}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(te){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ce,fe)=>{this.g.push({factory:te,c:ce,e:fe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const te=this.g.shift();this.d++;const ce=te.factory();ce.then(te.c,te.e),ce.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=k;class C extends k{constructor(){super(1)}}e.$Hh=C;class O{constructor(){this.a=new ie,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$Ih=O;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new z;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueSize(te,ce=D.$4g){const fe=ce.getComparisonKey(te);return this.a.get(fe)?.size??0}queueFor(te,ce,fe=D.$4g){const $e=fe.getComparisonKey(te);let we=this.a.get($e);if(!we){we=new C;const Ee=this.f++,be=A.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$4c),this.d.set(Ee,be),this.a.set($e,we)}return we.queue(ce)}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=M;class T{constructor(te,ce){this.a=-1,typeof te=="function"&&typeof ce=="number"&&this.setIfNotSet(te,ce)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,ce){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},ce)}setIfNotSet(te,ce){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},ce))}}e.$Kh=T;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,ce,fe=globalThis){this.cancel();const $e=fe.setInterval(()=>{te()},ce);this.d=(0,j.$Sc)(()=>{fe.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$Lh=F;class K{constructor(te,ce){this.b=-1,this.a=te,this.d=ce,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=K;class J{constructor(te,ce){ce%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ce}ms is not a multiple of 1000ms.`),this.a=te,this.b=ce,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=J;class Q extends K{constructor(te,ce){super(te,ce),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$Oh=Q;class H extends j.$Uc{constructor(te,ce){super(),this.g=te,this.h=ce,this.a=[],this.b=this.B(new j.$Vc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ce of te)this.a.push(ce);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(ne,te)=>{(0,I.$B)(()=>{if(ce)return;const fe=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,fe-Date.now())}}))});let ce=!1;return{dispose(){ce||(ce=!0)}}}:e.$Rh=(ne,te,ce)=>{const fe=ne.requestIdleCallback(te,typeof ce=="number"?{timeout:ce}:void 0);let $e=!1;return{dispose(){$e||($e=!0,ne.cancelIdleCallback(fe))}}},e.$Qh=ne=>(0,e.$Rh)(globalThis,ne)}();class X{constructor(te,ce){this.g=!1,this.d=()=>{try{this.j=ce()}catch(fe){this.l=fe}finally{this.g=!0}},this.f=(0,e.$Rh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=X;class W extends X{constructor(te){super(globalThis,te)}}e.$Th=W;async function B(ne,te,ce){let fe;for(let $e=0;$e<ce;$e++)try{return await ne()}catch(we){fe=we,await o(te)}throw fe}class ie{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,ce,fe){return this.a={taskId:te,cancel:()=>fe?.(),promise:ce},ce.then(()=>this.d(te),()=>this.d(te)),ce}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{const{promise:ce,resolve:fe,reject:$e}=f();this.b={run:te,promise:ce,promiseResolve:fe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=ie;class re{constructor(te,ce=()=>Date.now()){this.d=te,this.f=ce,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$Wh=re;var Z;(function(ne){ne[ne.Resolved=0]="Resolved",ne[ne.Rejected=1]="Rejected"})(Z||(Z={}));class z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,ce)=>{this.a=te,this.b=ce})}complete(te){return new Promise(ce=>{this.a(te),this.d={outcome:0,value:te},ce()})}error(te){return new Promise(ce=>{this.b(te),this.d={outcome:1,value:te},ce()})}cancel(){return this.error(new L.$5)}}e.$Xh=z;var x;(function(ne){async function te(fe){let $e;const we=await Promise.all(fe.map(Ee=>Ee.then(be=>be,be=>{$e||($e=be)})));if(typeof $e<"u")throw $e;return we}ne.settled=te;function ce(fe){return new Promise(async($e,we)=>{try{await fe($e,we)}catch(Ee){we(Ee)}})}ne.withAsyncBody=ce})(x||(e.Promises=x={}));class G{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(ce=>(this.a=ce,this.d=!0,ce),ce=>{throw this.b=ce,this.d=!0,ce})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=G;class N{constructor(te){this.b=te,this.a=new d.$V(()=>new G(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=N;var U;(function(ne){ne[ne.Initial=0]="Initial",ne[ne.DoneOK=1]="DoneOK",ne[ne.DoneError=2]="DoneError"})(U||(U={}));class V{static fromArray(te){return new V(ce=>{ce.emitMany(te)})}static fromPromise(te){return new V(async ce=>{ce.emitMany(await te)})}static fromPromises(te){return new V(async ce=>{await Promise.all(te.map(async fe=>ce.emitOne(await fe)))})}static merge(te){return new V(async ce=>{await Promise.all(te.map(async fe=>{for await(const $e of fe)ce.emitOne($e)}))})}static{this.EMPTY=V.fromArray([])}constructor(te,ce){this.a=0,this.b=[],this.d=null,this.f=ce,this.g=new A.$he,queueMicrotask(async()=>{const fe={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(te(fe)),this.k()}catch($e){this.l($e)}finally{fe.emitOne=void 0,fe.emitMany=void 0,fe.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(te,ce){return new V(async fe=>{for await(const $e of te)fe.emitOne(ce($e))})}map(te){return V.map(this,te)}static filter(te,ce){return new V(async fe=>{for await(const $e of te)ce($e)&&fe.emitOne($e)})}filter(te){return V.filter(this,te)}static coalesce(te){return V.filter(te,ce=>!!ce)}coalesce(){return V.coalesce(this)}static async toPromise(te){const ce=[];for await(const fe of te)ce.push(fe);return ce}toPromise(){return V.toPromise(this)}h(te){this.a===0&&(this.b.push(te),this.g.fire())}j(te){this.a===0&&(this.b=this.b.concat(te),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(te){this.a===0&&(this.a=2,this.d=te,this.g.fire())}}e.$1h=V;class q extends V{constructor(te,ce){super(ce),this.m=te}cancel(){this.m.cancel()}}e.$2h=q;function _(ne){const te=new R.$se,ce=ne(te.token);return new q(te,async fe=>{const $e=te.token.onCancellationRequested(()=>{$e.dispose(),te.dispose(),fe.reject(new L.$5)});try{for await(const we of ce){if(te.token.isCancellationRequested)return;fe.emitOne(we)}$e.dispose(),te.dispose()}catch(we){$e.dispose(),te.dispose(),fe.reject(we)}})}class ee{constructor(te){this.a=new z,this.b=new V($e=>{if(ce){$e.reject(ce);return}return fe&&$e.emitMany(fe),this.d=we=>$e.reject(we),this.f=we=>$e.emitOne(we),this.a.p},te);let ce,fe;this.f=$e=>{fe||(fe=[]),fe.push($e)},this.d=$e=>{ce||(ce=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$4h=ee}),define(le[91],he([0,1,17,6,40,34,14,5,27]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=d,e.$sk=c,e.$tk=C,e.$uk=O,e.$vk=M,e.$wk=T,e.$xk=F,e.$yk=H;function d(){return Object.create(null)}e.$qk="**",e.$rk="/";const E="[/\\\\]",v="[^/\\\\]",y=/\//g;function l(X,W){switch(X){case 0:return"";case 1:return`${v}*?`;default:return`(?:${E}|${v}+${E}${W?`|${E}${v}+`:""})*?`}}function c(X,W){if(!X)return[];const B=[];let ie=!1,re=!1,Z="";for(const z of X){switch(z){case W:if(!ie&&!re){B.push(Z),Z="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":re=!0;break;case"]":re=!1;break}Z+=z}return Z&&B.push(Z),B}function w(X){if(!X)return"";let W="";const B=c(X,e.$rk);if(B.every(ie=>ie===e.$qk))W=".*";else{let ie=!1;B.forEach((re,Z)=>{if(re===e.$qk){if(ie)return;W+=l(2,Z===B.length-1)}else{let z=!1,x="",G=!1,N="";for(const U of re){if(U!=="}"&&z){x+=U;continue}if(G&&(U!=="]"||!N)){let V;U==="-"?V=U:(U==="^"||U==="!")&&!N?V="^":U===e.$rk?V="":V=(0,P.$df)(U),N+=V;continue}switch(U){case"{":z=!0;continue;case"[":G=!0;continue;case"}":{const q=`(?:${c(x,",").map(_=>w(_)).join("|")})`;W+=q,z=!1,x="";break}case"]":{W+="["+N+"]",G=!1,N="";break}case"?":W+=v;continue;case"*":W+=l(1);continue;default:W+=(0,P.$df)(U)}}Z<B.length-1&&(B[Z+1]!==e.$qk||Z+2<B.length)&&(W+=E)}ie=re===e.$qk})}return W}const $=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new j.$Dc(1e4),r=function(){return!1},s=function(){return null};function n(X,W){if(!X)return s;let B;typeof X!="string"?B=X.pattern:B=X,B=B.trim();const ie=`${B}_${!!W.trimForExclusions}`;let re=t.get(ie);if(re)return i(re,X);let Z;return $.test(B)?re=a(B.substr(4),B):(Z=f.exec(o(B,W)))?re=p(Z[1],B):(W.trimForExclusions?h:u).test(B)?re=S(B,W):(Z=g.exec(o(B,W)))?re=b(Z[1].substr(1),B,!0):(Z=m.exec(o(B,W)))?re=b(Z[1],B,!1):re=k(B),t.set(ie,re),i(re,X)}function i(X,W){if(typeof W=="string")return X;const B=function(ie,re){return(0,A.$zg)(ie,W.base,!I.$k)?X((0,P.$if)(ie.substr(W.base.length),D.sep),re):null};return B.allBasenames=X.allBasenames,B.allPaths=X.allPaths,B.basenames=X.basenames,B.patterns=X.patterns,B}function o(X,W){return W.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function a(X,W){return function(B,ie){return typeof B=="string"&&B.endsWith(X)?W:null}}function p(X,W){const B=`/${X}`,ie=`\\${X}`,re=function(z,x){return typeof z!="string"?null:x?x===X?W:null:z===X||z.endsWith(B)||z.endsWith(ie)?W:null},Z=[X];return re.basenames=Z,re.patterns=[W],re.allBasenames=Z,re}function S(X,W){const B=Q(X.slice(1,-1).split(",").map(x=>n(x,W)).filter(x=>x!==s),X),ie=B.length;if(!ie)return s;if(ie===1)return B[0];const re=function(x,G){for(let N=0,U=B.length;N<U;N++)if(B[N](x,G))return X;return null},Z=B.find(x=>!!x.allBasenames);Z&&(re.allBasenames=Z.allBasenames);const z=B.reduce((x,G)=>G.allPaths?x.concat(G.allPaths):x,[]);return z.length&&(re.allPaths=z),re}function b(X,W,B){const ie=D.sep===D.$gc.sep,re=ie?X:X.replace(y,D.sep),Z=D.sep+re,z=D.$gc.sep+X;let x;return B?x=function(G,N){return typeof G=="string"&&(G===re||G.endsWith(Z)||!ie&&(G===X||G.endsWith(z)))?W:null}:x=function(G,N){return typeof G=="string"&&(G===re||!ie&&G===X)?W:null},x.allPaths=[(B?"*/":"./")+X],x}function k(X){try{const W=new RegExp(`^${w(X)}$`);return function(B){return W.lastIndex=0,typeof B=="string"&&W.test(B)?X:null}}catch{return s}}function C(X,W,B){return!X||typeof W!="string"?!1:O(X)(W,void 0,B)}function O(X,W={}){if(!X)return r;if(typeof X=="string"||M(X)){const B=n(X,W);if(B===s)return r;const ie=function(re,Z){return!!B(re,Z)};return B.allBasenames&&(ie.allBasenames=B.allBasenames),B.allPaths&&(ie.allPaths=B.allPaths),ie}return K(X,W)}function M(X){const W=X;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}function T(X){return X.allBasenames||[]}function F(X){return X.allPaths||[]}function K(X,W){const B=Q(Object.getOwnPropertyNames(X).map(x=>J(x,X[x],W)).filter(x=>x!==s)),ie=B.length;if(!ie)return s;if(!B.some(x=>!!x.requiresSiblings)){if(ie===1)return B[0];const x=function(U,V){let q;for(let _=0,ee=B.length;_<ee;_++){const ne=B[_](U,V);if(typeof ne=="string")return ne;(0,L.$mh)(ne)&&(q||(q=[]),q.push(ne))}return q?(async()=>{for(const _ of q){const ee=await _;if(typeof ee=="string")return ee}return null})():null},G=B.find(U=>!!U.allBasenames);G&&(x.allBasenames=G.allBasenames);const N=B.reduce((U,V)=>V.allPaths?U.concat(V.allPaths):U,[]);return N.length&&(x.allPaths=N),x}const re=function(x,G,N){let U,V;for(let q=0,_=B.length;q<_;q++){const ee=B[q];ee.requiresSiblings&&N&&(G||(G=(0,D.$nc)(x)),U||(U=G.substr(0,G.length-(0,D.$oc)(x).length)));const ne=ee(x,G,U,N);if(typeof ne=="string")return ne;(0,L.$mh)(ne)&&(V||(V=[]),V.push(ne))}return V?(async()=>{for(const q of V){const _=await q;if(typeof _=="string")return _}return null})():null},Z=B.find(x=>!!x.allBasenames);Z&&(re.allBasenames=Z.allBasenames);const z=B.reduce((x,G)=>G.allPaths?x.concat(G.allPaths):x,[]);return z.length&&(re.allPaths=z),re}function J(X,W,B){if(W===!1)return s;const ie=n(X,B);if(ie===s)return s;if(typeof W=="boolean")return ie;if(W){const re=W.when;if(typeof re=="string"){const Z=(z,x,G,N)=>{if(!N||!ie(z,x))return null;const U=re.replace("$(basename)",()=>G),V=N(U);return(0,L.$mh)(V)?V.then(q=>q?X:null):V?X:null};return Z.requiresSiblings=!0,Z}}return ie}function Q(X,W){const B=X.filter(x=>!!x.basenames);if(B.length<2)return X;const ie=B.reduce((x,G)=>{const N=G.basenames;return N?x.concat(N):x},[]);let re;if(W){re=[];for(let x=0,G=ie.length;x<G;x++)re.push(W)}else re=B.reduce((x,G)=>{const N=G.patterns;return N?x.concat(N):x},[]);const Z=function(x,G){if(typeof x!="string")return null;if(!G){let U;for(U=x.length;U>0;U--){const V=x.charCodeAt(U-1);if(V===47||V===92)break}G=x.substr(U)}const N=ie.indexOf(G);return N!==-1?re[N]:null};Z.basenames=ie,Z.patterns=re,Z.allBasenames=ie;const z=X.filter(x=>!x.basenames);return z.push(Z),z}function H(X,W){return(0,R.$ub)(X,W,(B,ie)=>typeof B=="string"&&typeof ie=="string"?B===ie:typeof B!="string"&&typeof ie!="string"?B.base===ie.base&&B.pattern===ie.pattern:!1)}}),define(le[92],he([0,1,15,8]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=void 0,e.$En=I,e.$Fn=d,e.$Gn=E;function A(v){return v.toJSON()}class j{constructor(y){this.a=y}transformIncoming(y){const l=this.a.transformIncoming(y);return l===y?y:A(L.URI.from(l))}transformOutgoing(y){const l=this.a.transformOutgoing(y);return l===y?y:A(L.URI.from(l))}transformOutgoingURI(y){const l=this.a.transformOutgoing(y);return l===y?y:L.URI.from(l)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Cn=j,e.$Dn=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function D(v,y,l){if(!v||l>200)return null;if(typeof v=="object"){if(v instanceof L.URI)return y.transformOutgoing(v);for(const c in v)if(Object.hasOwnProperty.call(v,c)){const w=D(v[c],y,l+1);w!==null&&(v[c]=w)}}return null}function I(v,y){const l=D(v,y,0);return l===null?v:l}function P(v,y,l,c){if(!v||c>200)return null;if(typeof v=="object"){if(v.$mid===1)return l?L.URI.revive(y.transformIncoming(v)):y.transformIncoming(v);if(v instanceof R.$Je)return null;for(const w in v)if(Object.hasOwnProperty.call(v,w)){const $=P(v[w],y,l,c+1);$!==null&&(v[w]=$)}}return null}function d(v,y){const l=P(v,y,!1,0);return l===null?v:l}function E(v,y){const l=P(v,y,!0,0);return l===null?v:l}}),define(le[146],he([0,1,37,51,32,133,5]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$Jn=P,e.$Kn=v,e.$In=new class{c(y){return this.a||(this.a=L.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,l=0;const c=(0,R.networkInterfaces)();for(const w in c){const $=c[w];if($)for(const{mac:f,internal:u}of $)u||(l+=1,this.c(f.toUpperCase())&&(y+=1))}this.b=l>0?y/l:0}return this.b}};let I;async function P(y){return I||(I=(async()=>await d(y)||A.$Wg())()),I}async function d(y){try{const l=await new Promise((w,$)=>{se(["crypto"],w,$)}),c=(0,j.$Hn)();return l.createHash("sha256").update(c,"utf8").digest("hex")}catch(l){y(l);return}}const E="Software\\Microsoft\\SQMClient";async function v(y){if(D.$i){const l=await new Promise((c,w)=>{se(["@vscode/windows-registry"],c,w)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(c){return y(c),""}}return""}}),define(le[147],he([0,1,41,148,14,36]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hW=E,e.$iW=v;const D="XDG_SESSION_TYPE",I="WAYLAND_DISPLAY",P="XDG_RUNTIME_DIR";var d;(function(y){y.Wayland="wayland",y.XWayland="xwayland",y.X11="x11",y.Unknown="unknown"})(d||(d={}));async function E(y){const l=j.env[D];if(l)return l==="wayland"||l==="x11"?l:"unknown";if(j.env[I]){const w=j.env[P];if(w){const $=(0,A.$jc)(w,"wayland-0");try{return await(0,L.access)($,R.constants.R_OK),"wayland"}catch(f){return y(f),"unknown"}}else return"unknown"}else return"x11"}function v(y,l){if(l)switch(l){case"auto":return y;case"x11":return y==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return y==="wayland"?"xwayland":"x11"}}),define(le[149],he([0,1,41,148,274,5]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=D;async function D(I){if(j.$j||j.$i)return;let P;for(const d of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{P=await(0,L.open)(d,R.constants.R_OK);break}catch{}if(!P){I("Unable to retrieve release information from known identifier paths.");return}try{const d=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const v of(0,A.createInterface)({input:P.createReadStream(),crlfDelay:1/0})){if(!v.includes("="))continue;const y=v.split("=")[0].toUpperCase().trim();if(d.has(y)){const l=v.split("=")[1].replace(/"/g,"").toLowerCase().trim();y==="ID"||y==="DISTRIB_ID"?E.id=l:y==="ID_LIKE"?E.id_like=l:(y==="VERSION_ID"||y==="DISTRIB_RELEASE")&&(E.version_id=l)}}return E}catch(d){I(d)}}}),define(le[31],he([0,1,41,37,275,6,40,88,14,5,21,8]),function(se,e,R,L,A,j,D,I,P,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=$,e.readdirSync=h,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=p;var y;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function l(J,Q=y.UNLINK,H){if((0,D.$Dg)(J))throw new Error("rimraf - will refuse to recursively delete root");return Q===y.UNLINK?w(J):c(J,H)}async function c(J,Q=(0,D.$Ig)((0,L.tmpdir)())){try{try{await R.promises.rename(J,Q)}catch(H){return H.code==="ENOENT"?void 0:w(J)}w(Q).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function w(J){return(0,A.promisify)(R.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function $(J){if((0,D.$Dg)(J))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}async function f(J,Q){return g(await(Q?u(J):(0,A.promisify)(R.readdir)(J)))}async function u(J){try{return await(0,A.promisify)(R.readdir)(J,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const Q=[],H=await f(J);for(const X of H){let W=!1,B=!1,ie=!1;try{const re=await e.Promises.lstat((0,P.$jc)(J,X));W=re.isFile(),B=re.isDirectory(),ie=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}Q.push({name:X,isFile:()=>W,isDirectory:()=>B,isSymbolicLink:()=>ie})}return Q}function h(J){return g(R.readdirSync(J))}function g(J){return J.map(Q=>typeof Q=="string"?d.$j?(0,I.$fm)(Q):Q:(Q.name=d.$j?(0,I.$fm)(Q.name):Q.name,Q))}async function m(J){const Q=await f(J),H=[];for(const X of Q)await r.existsDirectory((0,P.$jc)(J,X))&&H.push(X);return H}function t(J,Q=1e3){return new Promise(H=>{let X=!1;const W=setInterval(()=>{X||(X=!0,R.access(J,B=>{X=!1,B&&(clearInterval(W),H(void 0))}))},Q)})}var r;(function(J){async function Q(W){let B;try{if(B=await e.Promises.lstat(W),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(d.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw re}throw ie}}J.stat=Q;async function H(W){try{const{stat:B,symbolicLink:ie}=await J.stat(W);return B.isFile()&&ie?.dangling!==!0}catch{}return!1}J.existsFile=H;async function X(W){try{const{stat:B,symbolicLink:ie}=await J.stat(W);return B.isDirectory()&&ie?.dangling!==!0}catch{}return!1}J.existsDirectory=X})(r||(e.SymlinkSupport=r={}));const s=new j.$Jh;function n(J,Q,H){return s.queueFor(v.URI.file(J),()=>{const X=S(H);return new Promise((W,B)=>a(J,Q,X,ie=>ie?B(ie):W()))},E.$5g)}let i=!0;function o(J){i=J}function a(J,Q,H,X){if(!i)return R.writeFile(J,Q,{mode:H.mode,flag:H.flag},X);R.open(J,H.flag,H.mode,(W,B)=>{if(W)return X(W);R.writeFile(B,Q,ie=>{if(ie)return R.close(B,()=>X(ie));R.fdatasync(B,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),o(!1)),R.close(B,Z=>X(Z))))})})}function p(J,Q,H){const X=S(H);if(!i)return R.writeFileSync(J,Q,{mode:X.mode,flag:X.flag});const W=R.openSync(J,X.flag,X.mode);try{R.writeFileSync(W,Q);try{R.fdatasyncSync(W)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),o(!1)}}finally{R.closeSync(W)}}function S(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function b(J,Q,H=6e4){if(J!==Q)try{d.$i&&typeof H=="number"?await k(J,Q,Date.now(),H):await(0,A.promisify)(R.rename)(J,Q)}catch(X){if(J.toLowerCase()!==Q.toLowerCase()&&X.code==="EXDEV"||J.endsWith("."))await C(J,Q,{preserveSymlinks:!1}),await l(J,y.MOVE);else throw X}}async function k(J,Q,H,X,W=0){try{return await(0,A.promisify)(R.rename)(J,Q)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-H>=X)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${B}`),B;if(W===0){let ie=!1;try{const{stat:re}=await r.stat(Q);re.isFile()||(ie=!0)}catch{}if(ie)throw B}return await(0,j.$Bh)(Math.min(100,W*10)),k(J,Q,H,X,W+1)}}async function C(J,Q,H){return M(J,Q,{root:{source:J,target:Q},options:H,handledSourcePaths:new Set})}const O=511;async function M(J,Q,H){if(H.handledSourcePaths.has(J))return;H.handledSourcePaths.add(J);const{stat:X,symbolicLink:W}=await r.stat(J);if(W){if(H.options.preserveSymlinks)try{return await K(J,Q,H)}catch{}if(W.dangling)return}return X.isDirectory()?T(J,Q,X.mode&O,H):F(J,Q,X.mode&O)}async function T(J,Q,H,X){await e.Promises.mkdir(Q,{recursive:!0,mode:H});const W=await f(J);for(const B of W)await M((0,P.$jc)(J,B),(0,P.$jc)(Q,B),X)}async function F(J,Q,H){await e.Promises.copyFile(J,Q),await e.Promises.chmod(Q,H)}async function K(J,Q,H){let X=await e.Promises.readlink(J);(0,D.$zg)(X,H.root.source,!d.$k)&&(X=(0,P.$jc)(H.root.target,X.substr(H.root.source.length+1))),await e.Promises.symlink(X,Q)}e.Promises=new class{get access(){return(0,A.promisify)(R.access)}get stat(){return(0,A.promisify)(R.stat)}get lstat(){return(0,A.promisify)(R.lstat)}get utimes(){return(0,A.promisify)(R.utimes)}get read(){return(J,Q,H,X,W)=>new Promise((B,ie)=>{R.read(J,Q,H,X,W,(re,Z,z)=>re?ie(re):B({bytesRead:Z,buffer:z}))})}get readFile(){return(0,A.promisify)(R.readFile)}get write(){return(J,Q,H,X,W)=>new Promise((B,ie)=>{R.write(J,Q,H,X,W,(re,Z,z)=>re?ie(re):B({bytesWritten:Z,buffer:z}))})}get appendFile(){return(0,A.promisify)(R.appendFile)}get fdatasync(){return(0,A.promisify)(R.fdatasync)}get truncate(){return(0,A.promisify)(R.truncate)}get copyFile(){return(0,A.promisify)(R.copyFile)}get open(){return(0,A.promisify)(R.open)}get close(){return(0,A.promisify)(R.close)}get symlink(){return(0,A.promisify)(R.symlink)}get readlink(){return(0,A.promisify)(R.readlink)}get chmod(){return(0,A.promisify)(R.chmod)}get mkdir(){return(0,A.promisify)(R.mkdir)}get unlink(){return(0,A.promisify)(R.unlink)}get rmdir(){return(0,A.promisify)(R.rmdir)}get realpath(){return(0,A.promisify)(R.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return m}get writeFile(){return n}get rm(){return l}get rename(){return b}get copy(){return C}}}),define(le[150],he([0,1,41,14,5,27,31]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=I,e.$$q=P,e.$_q=d,e.$ar=E;function I(y){if(A.$k)return y;const l=(0,L.$mc)(y);if(y===l)return y;const c=((0,L.$nc)(y)||y).toLowerCase();try{const $=(0,D.readdirSync)(l).filter(f=>f.toLowerCase()===c);if($.length===1){const f=I(l);if(f)return(0,L.$jc)(f,$[0])}else if($.length>1){const f=$.indexOf(c);if(f>=0){const u=I(l);if(u)return(0,L.$jc)(u,$[f])}}}catch{}return null}async function P(y,l){if(A.$k)return y;const c=(0,L.$mc)(y);if(y===c)return y;const w=((0,L.$nc)(y)||y).toLowerCase();try{if(l?.isCancellationRequested)return null;const f=(await D.Promises.readdir(c)).filter(u=>u.toLowerCase()===w);if(f.length===1){const u=await P(c,l);if(u)return(0,L.$jc)(u,f[0])}else if(f.length>1){const u=f.indexOf(w);if(u>=0){const h=await P(c,l);if(h)return(0,L.$jc)(h,f[u])}}}catch{}return null}async function d(y){try{return await D.Promises.realpath(y)}catch{const c=v(y);return await D.Promises.access(c,R.constants.R_OK),c}}function E(y){try{return R.realpathSync(y)}catch{const c=v(y);return R.accessSync(c,R.constants.R_OK),c}}function v(y){return(0,j.$jf)((0,L.$hc)(y),L.sep)}}),define(le[151],he([0,1,14,5,36,90,13,31]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$sm=P,e.$tm=d,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function P(v=A.env){return v.comspec||"cmd.exe"}function d(v){let y=[],l=!1;const c=function(w){if(l){y.push(w);return}(!v.send(w,f=>{if(f&&console.error(f),l=!1,y.length>0){const u=y.slice(0);y=[],u.forEach(h=>c(h))}})||L.$i)&&(l=!0)};return{send:c}}var E;(function(v){async function y(l,c,w){if(R.$ic(l))return l;if(c===void 0&&(c=A.cwd()),R.$mc(l)!=="."||(w===void 0&&D.$ag(A.env.PATH)&&(w=A.env.PATH.split(R.$tc)),w===void 0||w.length===0))return R.$jc(c,l);async function f(u){if(await I.Promises.exists(u)){let h;try{h=await I.Promises.stat(u)}catch(g){g.message.startsWith("EACCES")&&(h=await I.Promises.lstat(u))}return h?!h.isDirectory():!1}return!1}for(const u of w){let h;if(R.$ic(u)?h=R.$jc(u,l):h=R.$jc(c,u,l),await f(h))return h;let g=h+".com";if(await f(g)||(g=h+".exe",await f(g)))return g}return R.$jc(c,l)}v.findExecutable=y})(E||(e.win32=E={}))}),define(le[152],he([0,1,67,23]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=A;function A(D){return new Promise((I,P)=>{let d;const E=new Map;function v(l,c,w,$,f){const u=E.get(c);if(l===D||u){const h={name:y(w),cmd:w,pid:l,ppid:c,load:$,mem:f};E.set(l,h),l===D&&(d=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((g,m)=>g.pid-m.pid)))}}function y(l){const c=/--utility-sub-type=network/i,w=/--crashes-directory/i,$=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(w.exec(l))return"electron-crash-reporter";if($.exec(l))return"winpty-agent";if(f.exec(l))return"conpty-agent";let h=u.exec(l);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?c.exec(l)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const g=/[a-zA-Z-]+\.js/g;let m="";do h=g.exec(l),h&&(m+=h+" ");while(h);return m&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${m})`:l}if(process.platform==="win32"){const l=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,w)=>{se(["@vscode/windows-process-tree"],c,w)}).then(c=>{c.getProcessList(D,w=>{if(!w){P(new Error(`Root process ${D} not found`));return}c.getProcessCpuUsage(w,$=>{const f=new Map;$.forEach(u=>{const h=l(u.commandLine||"");f.set(u.pid,{name:y(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),d=f.get(D),d?(f.forEach(u=>{const h=f.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),f.forEach(u=>{u.children&&(u.children=u.children.sort((h,g)=>h.pid-g.pid))}),I(d)):P(new Error(`Root process ${D} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let l=function(){let c=[d];const w=[];for(;c.length;){const f=c.shift();f&&(w.push(f.pid),f.children&&(c=c.concat(f.children)))}let $=JSON.stringify(L.$Ug.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+w.join(" "),(0,R.exec)($,{},(f,u,h)=>{if(f||h)P(f||new Error(h.toString()));else{const g=u.toString().split(`
`);for(let m=0;m<w.length;m++){const t=E.get(w[m]);t.load=parseFloat(g[m])}if(!d){P(new Error(`Root process ${D} not found`));return}I(d)}})};(0,R.exec)("which ps",{},(c,w,$)=>{if(c||$)if(process.platform!=="linux")P(c||new Error($.toString()));else{const f=JSON.stringify(L.$Ug.asFileUri("vs/base/node/ps.sh").fsPath);(0,R.exec)(f,{},(u,h,g)=>{u||g?P(u||new Error(g.toString())):(j(h,v),l())})}else{const f=w.toString().trim();(0,R.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,g,m)=>{h||m&&!m.includes("screen size is bogus")?P(h||new Error(m.toString())):(j(g,v),process.platform==="linux"?l():d?I(d):P(new Error(`Root process ${D} not found`)))})}})}})}function j(D,I){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=D.toString().split(`
`);for(const E of d){const v=P.exec(E.trim());v&&v.length===6&&I(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}});var ve=this&&this.__decorate||function(se,e,R,L){var A=arguments.length,j=A<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,R):L,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(se,e,R,L);else for(var I=se.length-1;I>=0;I--)(D=se[I])&&(j=(A<3?D(j):A>3?D(e,R,j):D(e,R))||j);return A>3&&j&&Object.defineProperty(e,R,j),j};define(le[42],he([0,1,17,6,15,26,85,7,3,2,66,27,13]),function(se,e,R,L,A,j,D,I,P,d,E,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=o,e.$bi=a,e.$gi=O,e.$hi=M;var l;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(l||(l={}));function c(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(w||(w={}));function $(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(f||(f={}));function u(W){let B=0;for(let ie=0;;ie+=7){const re=W.read(1);if(B|=(re.buffer[0]&127)<<ie,!(re.buffer[0]&128))return B}}const h=s(0);function g(W,B){if(B===0){W.write(h);return}let ie=0;for(let Z=B;Z!==0;Z=Z>>>7)ie++;const re=A.$Je.alloc(ie);for(let Z=0;B!==0;Z++)re.buffer[Z]=B&127,B=B>>>7,B>0&&(re.buffer[Z]|=128);W.write(re)}class m{constructor(B){this.b=B,this.a=0}read(B){const ie=this.b.slice(this.a,this.a+B);return this.a+=ie.byteLength,ie}}e.$$h=m;class t{constructor(){this.a=[]}get buffer(){return A.$Je.concat(this.a)}write(B){this.a.push(B)}}e.$_h=t;var r;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(r||(r={}));function s(W){const B=A.$Je.alloc(1);return B.writeUInt8(W,0),B}const n={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},i=typeof Buffer<"u";function o(W,B){if(typeof B>"u")W.write(n.Undefined);else if(typeof B=="string"){const ie=A.$Je.fromString(B);W.write(n.String),g(W,ie.byteLength),W.write(ie)}else if(i&&Buffer.isBuffer(B)){const ie=A.$Je.wrap(B);W.write(n.Buffer),g(W,ie.byteLength),W.write(ie)}else if(B instanceof A.$Je)W.write(n.VSBuffer),g(W,B.byteLength),W.write(B);else if(Array.isArray(B)){W.write(n.Array),g(W,B.length);for(const ie of B)o(W,ie)}else if(typeof B=="number"&&(B|0)===B)W.write(n.Uint),g(W,B);else{const ie=A.$Je.fromString(JSON.stringify(B));W.write(n.Object),g(W,ie.byteLength),W.write(ie)}}function a(W){switch(W.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return W.read(u(W)).toString();case r.Buffer:return W.read(u(W)).buffer;case r.VSBuffer:return W.read(u(W));case r.Array:{const ie=u(W),re=[];for(let Z=0;Z<ie;Z++)re.push(a(W));return re}case r.Object:return JSON.parse(W.read(u(W)).toString());case r.Int:return u(W)}}class p{constructor(B,ie,re=null,Z=1e3){this.h=B,this.j=ie,this.k=re,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(z=>this.q(z)),this.m({type:200})}registerChannel(B,ie){this.b.set(B,ie),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const ie=this.o([B.type]);this.k?.logOutgoing(ie,0,1,$(B.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([B.type,B.id],B.data);this.k?.logOutgoing(ie,B.id,1,$(B.type),B.data);return}}}o(B,ie=void 0){const re=new t;return o(re,B),o(re,ie),this.p(re.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const ie=new m(B),re=a(ie),Z=a(ie),z=re[0];switch(z){case 100:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(z)}: ${re[2]}.${re[3]}`,Z),this.s({type:z,id:re[1],channelName:re[2],name:re[3],arg:Z});case 102:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(z)}: ${re[2]}.${re[3]}`,Z),this.t({type:z,id:re[1],channelName:re[2],name:re[3],arg:Z});case 101:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(z)}`),this.u({type:z,id:re[1]});case 103:return this.k?.logIncoming(B.byteLength,re[1],1,`${c(z)}`),this.u({type:z,id:re[1]})}}s(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=new j.$se;let Z;try{Z=ie.call(this.j,B.name,B.arg,re.token)}catch(G){Z=Promise.reject(G)}const z=B.id;Z.then(G=>{this.m({id:z,data:G,type:201})},G=>{G instanceof Error?this.m({id:z,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.m({id:z,data:G,type:203})}).finally(()=>{x.dispose(),this.d.delete(B.id)});const x=(0,d.$Sc)(()=>re.cancel());this.d.set(B.id,x)}t(B){const ie=this.b.get(B.channelName);if(!ie){this.v(B);return}const re=B.id,z=ie.listen(this.j,B.name,B.arg)(x=>this.m({id:re,data:x,type:204}));this.d.set(B.id,z)}u(B){const ie=this.d.get(B.id);ie&&(ie.dispose(),this.d.delete(B.id))}v(B){let ie=this.g.get(B.channelName);ie||(ie=[],this.g.set(B.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:B,timeoutTimer:re})}w(B){const ie=this.g.get(B);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Pc)(this.d.values()),this.d.clear()}}e.$ci=p;var S;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class b{constructor(B,ie=null){this.l=B,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ie}getChannel(B){const ie=this;return{call(re,Z,z){return ie.a?Promise.reject(new I.$5):ie.m(B,re,Z,z)},listen(re,Z){return ie.a?P.Event.None:ie.o(B,re,Z)}}}m(B,ie,re,Z=j.CancellationToken.None){const z=this.g++,G={id:z,type:100,channelName:B,name:ie,arg:re};if(Z.isCancellationRequested)return Promise.reject(new I.$5);let N;return new Promise((V,q)=>{if(Z.isCancellationRequested)return q(new I.$5);const _=()=>{const ce=fe=>{switch(fe.type){case 201:this.f.delete(z),V(fe.data);break;case 202:{this.f.delete(z);const $e=new Error(fe.data.message);$e.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,$e.name=fe.data.name,q($e);break}case 203:this.f.delete(z),q(fe.data);break}};this.f.set(z,ce),this.p(G)};let ee=null;this.b===f.Idle?_():(ee=(0,L.$nh)(ce=>this.u()),ee.then(()=>{ee=null,_()}));const ne=()=>{ee?(ee.cancel(),ee=null):this.p({id:z,type:101}),q(new I.$5)},te=Z.onCancellationRequested(ne);N=(0,d.$Rc)((0,d.$Sc)(ne),te),this.d.add(N)}).finally(()=>{N.dispose(),this.d.delete(N)})}o(B,ie,re){const Z=this.g++,x={id:Z,type:102,channelName:B,name:ie,arg:re};let G=null;const N=new P.$he({onWillAddFirstListener:()=>{G=(0,L.$nh)(V=>this.u()),G.then(()=>{G=null,this.d.add(N),this.p(x)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(N),this.p({id:Z,type:103}))}}),U=V=>N.fire(V.data);return this.f.set(Z,U),N.event}p(B){switch(B.type){case 100:case 102:{const ie=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(ie,B.id,0,`${c(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const ie=this.q([B.type,B.id]);this.j?.logOutgoing(ie,B.id,0,c(B.type));return}}}q(B,ie=void 0){const re=new t;return o(re,B),o(re,ie),this.r(re.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const ie=new m(B),re=a(ie),Z=a(ie),z=re[0];switch(z){case 200:return this.j?.logIncoming(B.byteLength,0,0,$(z)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,re[1],0,$(z),Z),this.t({type:re[0],id:re[1],data:Z})}}t(B){if(B.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Pc)(this.d.values()),this.d.clear()}}e.$di=b,ve([D.$5h],b.prototype,"onDidInitializePromise",null);class k{get connections(){const B=[];return this.f.forEach(ie=>B.push(ie)),B}constructor(B,ie,re){this.a=new Map,this.f=new Set,this.g=new P.$he,this.onDidAddConnection=this.g.event,this.h=new P.$he,this.onDidRemoveConnection=this.h.event,this.j=new d.$Tc,this.j.add(B(({protocol:Z,onDidClientDisconnect:z})=>{const x=P.Event.once(Z.onMessage);this.j.add(x(G=>{const N=new m(G),U=a(N),V=new p(Z,U,ie,re),q=new b(Z,ie);this.a.forEach((ee,ne)=>V.registerChannel(ne,ee));const _={channelServer:V,channelClient:q,ctx:U};this.f.add(_),this.g.fire(_),this.j.add(z(()=>{V.dispose(),q.dispose(),this.f.delete(_),this.h.fire(_)}))}))}))}getChannel(B,ie){const re=this;return{call(Z,z,x){let G;if((0,y.$og)(ie)){const U=(0,R.$3b)(re.connections.filter(ie));G=U?Promise.resolve(U):P.Event.toPromise(P.Event.filter(re.onDidAddConnection,ie))}else G=ie.routeCall(re,Z,z);const N=G.then(U=>U.channelClient.getChannel(B));return O(N).call(Z,z,x)},listen(Z,z){if((0,y.$og)(ie))return re.k(B,ie,Z,z);const x=ie.routeEvent(re,Z,z).then(G=>G.channelClient.getChannel(B));return O(x).listen(Z,z)}}}k(B,ie,re,Z){const z=this;let x;const G=new P.$he({onWillAddFirstListener:()=>{x=new d.$Tc;const N=new P.$ne,U=new Map,V=_=>{const ne=_.channelClient.getChannel(B).listen(re,Z),te=N.add(ne);U.set(_,te)},q=_=>{const ee=U.get(_);ee&&(ee.dispose(),U.delete(_))};z.connections.filter(ie).forEach(V),P.Event.filter(z.onDidAddConnection,ie)(V,void 0,x),z.onDidRemoveConnection(q,void 0,x),N.event(G.fire,G,x),x.add(N)},onDidRemoveLastListener:()=>{x?.dispose(),x=void 0}});return G.event}registerChannel(B,ie){this.a.set(B,ie);for(const re of this.f)re.channelServer.registerChannel(B,ie)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=k;class C{constructor(B,ie,re=null){const Z=new t;o(Z,ie),B.send(Z.buffer),this.a=new b(B,re),this.d=new p(B,ie,re)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,ie){this.d.registerChannel(B,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=C;function O(W){return{call(B,ie,re){return W.then(Z=>Z.call(B,ie,re))},listen(B,ie){const re=new P.$qe;return W.then(Z=>re.input=Z.listen(B,ie)),re.event}}}function M(W){let B=!1;return{call(ie,re,Z){return B?W.call(ie,re,Z):(0,L.$Bh)(0).then(()=>B=!0).then(()=>W.call(ie,re,Z))},listen(ie,re){if(B)return W.listen(ie,re);const Z=new P.$qe;return(0,L.$Bh)(0).then(()=>B=!0).then(()=>Z.input=W.listen(ie,re)),Z.event}}}class T{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const ie of B.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await P.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$ii=T;var F;(function(W){function B(z,x,G){const N=z,U=G&&G.disableMarshalling,V=new Map;for(const q in N)re(q)&&V.set(q,P.Event.buffer(N[q],!0,void 0,x));return new class{listen(q,_,ee){const ne=V.get(_);if(ne)return ne;const te=N[_];if(typeof te=="function"){if(Z(_))return te.call(N,ee);if(re(_))return V.set(_,P.Event.buffer(N[_],!0,void 0,x)),V.get(_)}throw new I.$bb(`Event not found: ${_}`)}call(q,_,ee){const ne=N[_];if(typeof ne=="function"){if(!U&&Array.isArray(ee))for(let ce=0;ce<ee.length;ce++)ee[ce]=(0,E.$0h)(ee[ce]);let te=ne.apply(N,ee);return te instanceof Promise||(te=Promise.resolve(te)),te}throw new I.$bb(`Method not found: ${_}`)}}}W.fromService=B;function ie(z,x){const G=x&&x.disableMarshalling;return new Proxy({},{get(N,U){if(typeof U=="string")return x?.properties?.has(U)?x.properties.get(U):Z(U)?function(V){return z.listen(U,V)}:re(U)?z.listen(U):async function(...V){let q;x&&!(0,y.$jg)(x.context)?q=[x.context,...V]:q=V;const _=await z.call(U,q);return G?_:(0,E.$0h)(_)};throw new I.$bb(`Property not found: ${String(U)}`)}})}W.toService=ie;function re(z){return z[0]==="o"&&z[1]==="n"&&v.$Af(z.charCodeAt(2))}function Z(z){return/^onDynamic/.test(z)&&v.$Af(z.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const K=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const B=W.toString();if(B!=="[object Object]")return B}return W}function Q(W){return Array.isArray(W)?W.map(J):J(W)}function H(W,B,ie,re,Z,z,x){x=Q(x);const G=K[Z],N=G[re%G.length];let U=[`%c[${W}]%c[${String(B).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(z)?(U=U.concat(x),U.push(")")):U.push(x),console.log.apply(console,U)}class X{constructor(B,ie){this.d=B,this.f=ie,this.a=0,this.b=0}logOutgoing(B,ie,re,Z,z){this.b+=B,H(this.d,this.b,B,ie,re,Z,z)}logIncoming(B,ie,re,Z,z){this.a+=B,H(this.f,this.a,B,ie,re,Z,z)}}e.$ji=X}),define(le[68],he([0,1,15,3,2,42]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var I;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let o=0;function a(S,b){if(!i.has(S)){const k=String(++o);i.set(S,k)}return i.get(S)}function p(S,b,k,C){if(!n.enableDiagnostics)return;const O=a(S,b);if(C instanceof R.$Je||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const M=R.$Je.alloc(C.byteLength);M.set(C),n.records.push({timestamp:Date.now(),id:O,label:b,type:k,buff:M})}else n.records.push({timestamp:Date.now(),id:O,label:b,type:k,data:C})}n.traceSocketEvent=p})(I||(e.SocketDiagnostics=I={}));var P;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let d=null;function E(){return d||(d=R.$Je.alloc(0)),d}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,o){if(i===0)return E();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const b=this.a[0];return o&&(this.a.shift(),this.b-=i),b}if(this.a[0].byteLength>i){const b=this.a[0].slice(0,i);return o&&(this.a[0]=this.a[0].slice(i),this.b-=i),b}const a=R.$Je.alloc(i);let p=0,S=0;for(;i>0;){const b=this.a[S];if(b.byteLength>i){const k=b.slice(0,i);a.set(k,p),p+=i,o&&(this.a[S]=b.slice(i),this.b-=i),i-=i}else a.set(b,p),p+=b.byteLength,o?(this.a.shift(),this.b-=b.byteLength):S++,i-=b.byteLength}return a}}e.$ki=v;var y;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(y||(y={}));function l(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var c;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class w{constructor(i,o,a,p){this.type=i,this.id=o,this.ack=a,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends A.$Uc{constructor(i){super(),this.f=this.B(new L.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new v,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,p=this.g.id,S=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new w(a,p,S,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=R.$Je.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(o,i.data)}g(i,o){const a=this.f===0;return this.d.push(i,o),this.f+=i.byteLength+o.byteLength,a}h(){const i=R.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,o){this.g(i,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class u extends A.$Uc{constructor(i){super(),this.f=new L.$he,this.onMessage=this.f.event,this.g=new L.$he,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new f(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new w(1,0,0,i))}}e.$li=u;class h extends j.$fi{static fromSocket(i,o){return new h(new u(i),o)}get onDidDispose(){return this.b.onDidDispose}constructor(i,o,a=null){super(i,o,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$mi=h;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$ni=g;class m{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,o=this.a;for(;o;)o=o.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let o=0,a=this.a;for(;a;)i[o++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const o=new m(i);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const i=Date.now();for(let o=0;o<r.a;o++)this.c[o]=i-1e3*o;setInterval(()=>{for(let o=r.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),o=(1+r.a)*1e3;let a=0;for(let p=0;p<r.a;p++)i-this.c[p]<=o&&a++;return 1-a/r.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new g,this.onControlMessage=this.u.event,this.v=new g,this.onMessage=this.v.event,this.w=new g,this.onDidDispose=this.w.event,this.x=new g,this.onSocketClose=this.x.event,this.y=new g,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??r.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Tc,this.o=i.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new w(5,0,0,E());this.p.write(i),this.p.flush()}sendPause(){const i=new w(7,0,0,E());this.p.write(i)}sendResume(){const i=new w(8,0,0,E());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,o){this.a=!0,this.r.dispose(),this.r=new A.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new w(3,0,this.h,E());this.p.write(i);const o=this.b.toArray();for(let a=0,p=o.length;a<p;a++)this.p.write(o[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const o=this.b.peek();if(o&&o.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new w(6,0,0,E())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let a=0,p=o.length;a<p;a++)this.p.write(o[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const o=++this.c;this.h=this.g;const a=new w(1,o,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const o=new w(2,0,0,i);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),o=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,p=Date.now()-this.n;if(o>=2e4&&a>=2e4&&p>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:a});return}const S=Math.max(2e4-o,2e4-a,2e4-p,500);this.f=setTimeout(()=>{this.f=null,this.B()},S)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new w(3,0,this.h,E());this.p.write(i)}D(){this.h=this.g;const i=new w(9,0,this.h,E());this.p.write(i)}}e.$oi=s}),define(le[93],he([0,1,67,6,15,26,144,7,3,2,30,151,90,42]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=void 0;class c extends l.$ci{constructor(f){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",u=>A.$Je.wrap(Buffer.from(u,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$6q=c;class w{constructor(f,u){this.i=f,this.j=u,this.c=new Set,this.g=new Map,this.h=new P.$he,this.onDidProcessExit=this.h.event;const h=u&&u.timeout?u.timeout:6e4;this.b=new L.$xh(h),this.d=null,this.f=null}getChannel(f){const u=this;return{call(h,g,m){return u.k(f,h,g,m)},listen(h,g){return u.l(f,h,g)}}}k(f,u,h,g=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const m=this.n(f),t=(0,L.$nh)(n=>m.call(u,h,n)),r=g.onCancellationRequested(()=>t.cancel()),s=(0,d.$Sc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{r.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,u,h){if(!this.b)return P.Event.None;this.b.cancel();let g;const m=new P.$he({onWillAddFirstListener:()=>{g=this.n(f).listen(u,h)(m.fire,m),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,E.$7n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,y.$rm)(u.env),this.d=(0,R.fork)(this.i,f,u);const h=new P.$he,m=P.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,D.$2q)(o)){(0,D.log)(o,`IPC Library: ${this.j.serverName}`);return}h.fire(A.$Je.wrap(Buffer.from(o,"base64")))}),t=this.j.useQueue?(0,v.$tm)(this.d):this.d,r=o=>this.d&&this.d.connected&&t.send(o.buffer.toString("base64")),s=h.event,n={send:r,onMessage:s};this.f=new l.$di(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,a)=>{process.removeListener("exit",i),m.dispose(),this.c.forEach(p=>(0,d.$Pc)(p)),this.c.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:a})})}return this.f}n(f){let u=this.g.get(f);return u||(u=this.m.getChannel(f),this.g.set(f,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7q=w}),define(le[153],he([0,1,136,15,42,3,13,17]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zW=void 0,e.$AW=E;class P{constructor(y){this.a=y,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",l=>l.data?L.$Je.wrap(l.data):L.$Je.alloc(0)),y.start()}send(y){this.a.postMessage(y.buffer)}disconnect(){this.a.close()}}class d extends A.$ei{static b(y){(0,D.$kg)((0,R.$yW)(process),"Electron Utility Process");const l=new j.$he;return process.parentPort.on("message",c=>{if(y?.handledClientConnection(c))return;const w=(0,I.$Ob)(c.ports);w&&l.fire(w)}),j.Event.map(l.event,c=>({protocol:new P(c),onDidClientDisconnect:j.Event.fromNodeEventEmitter(c,"close")}))}constructor(y){super(d.b(y))}}e.$zW=d;function E(v,y,l){const c=w=>{w.data===y&&(v.removeListener("message",c),l())};v.on("message",c)}}),define(le[69],he([0,1,6,3,2,66,13]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.StorageState=e.StorageHint=void 0,e.$2p=P;var I;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function P(y){const l=y;return l?.changed instanceof Map||l?.deleted instanceof Set}var d;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(d||(e.StorageState=d={}));class E extends A.$Uc{static{this.a=100}constructor(l,c=Object.create(null)){super(),this.r=l,this.s=c,this.b=this.B(new L.$ke),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new R.$yh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((c,w)=>this.w(w,c)),l.deleted?.forEach(c=>this.w(c,void 0))}finally{this.b.resume()}}w(l,c){if(this.c===d.Closed)return;let w=!1;(0,D.$jg)(c)?w=this.f.delete(l):this.f.get(l)!==c&&(this.f.set(l,c),w=!0),w&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,c){const w=this.f.get(l);return(0,D.$jg)(w)?c:w}getBoolean(l,c){const w=this.get(l);return(0,D.$jg)(w)?c:w==="true"}getNumber(l,c){const w=this.get(l);return(0,D.$jg)(w)?c:parseInt(w,10)}getObject(l,c){const w=this.get(l);return(0,D.$jg)(w)?c:(0,j.$9h)(w)}async set(l,c,w=!1){if(this.c===d.Closed)return;if((0,D.$jg)(c))return this.delete(l,w);const $=(0,D.$cg)(c)||Array.isArray(c)?(0,j.$8h)(c):String(c);if(this.f.get(l)!==$)return this.f.set(l,$),this.j.set(l,$),this.h.delete(l),this.b.fire({key:l,external:w}),this.D()}async delete(l,c=!1){if(!(this.c===d.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:c}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(!(this.c===d.Closed||this.m))return this.D(l)}async D(l){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$3p=E;class v{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((c,w)=>this.a.set(w,c)),l.delete?.forEach(c=>this.a.delete(c))}async optimize(){}async close(){}}e.$4p=v}),define(le[154],he([11,10]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,41,6,14,13,31,154]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=void 0,e.zip=$,e.$pq=f,e.$qq=h,e.$mq="end of central directory record signature not found";const P=new RegExp(e.$mq);class d extends Error{constructor(m,t){let r=t.message;switch(m){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=m,this.cause=t}}e.$nq=d;function E(g){const m=g.externalFileAttributes>>16||33188;return[448,56,7].map(t=>m&t).reduce((t,r)=>t+r,m&61440)}function v(g){if(g instanceof d)return g;let m;return P.test(g.message)&&(m="CorruptZip"),new d(m,g)}function y(g,m,t,r,s,n){const i=A.$mc(m),o=A.$jc(r,i);if(!o.startsWith(r))return Promise.reject(new Error(I.localize(0,null,m)));const a=A.$jc(r,m);let p;return n.onCancellationRequested(()=>{p?.destroy()}),Promise.resolve(D.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((S,b)=>{if(!n.isCancellationRequested)try{p=(0,R.createWriteStream)(a,{mode:t}),p.once("close",()=>S()),p.once("error",b),g.once("error",b),g.pipe(p)}catch(k){b(k)}}))}function l(g,m,t,r){let s=(0,L.$nh)(()=>Promise.resolve()),n=0;const i=r.onCancellationRequested(()=>{s.cancel(),g.close()});return new Promise((o,a)=>{const p=new L.$vh,S=b=>{b.isCancellationRequested||(n++,g.readEntry())};g.once("error",a),g.once("close",()=>s.then(()=>{r.isCancellationRequested||g.entryCount===n?o():a(new d("Incomplete",new Error(I.localize(1,null,n,g.entryCount))))},a)),g.readEntry(),g.on("entry",b=>{if(r.isCancellationRequested)return;if(!t.sourcePathRegex.test(b.fileName)){S(r);return}const k=b.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(k)){const M=A.$jc(m,k);s=(0,L.$nh)(T=>D.Promises.mkdir(M,{recursive:!0}).then(()=>S(T)).then(void 0,a));return}const C=w(g,b),O=E(b);s=(0,L.$nh)(M=>p.queue(()=>C.then(T=>y(T,k,O,m,t,M).then(()=>S(M)))).then(null,a))})}).finally(()=>i.dispose())}async function c(g,m=!1){const{open:t}=await new Promise((r,s)=>{se(["yauzl"],r,s)});return new Promise((r,s)=>{t(g,m?{lazyEntries:!0}:void 0,(n,i)=>{n?s(v(n)):r((0,j.$lg)(i))})})}function w(g,m){return new Promise((t,r)=>{g.openReadStream(m,(s,n)=>{s?r(v(s)):t((0,j.$lg)(n))})})}async function $(g,m){const{ZipFile:t}=await new Promise((r,s)=>{se(["yazl"],r,s)});return new Promise((r,s)=>{const n=new t;m.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const i=(0,R.createWriteStream)(g);n.outputStream.pipe(i),n.outputStream.once("error",s),i.once("error",s),i.once("finish",()=>r(g))})}function f(g,m,t={},r){const s=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let n=c(g,!0);return t.overwrite&&(n=n.then(i=>D.Promises.rm(m).then(()=>i))),n.then(i=>l(i,m,{sourcePathRegex:s},r))}function u(g,m){return c(g).then(t=>new Promise((r,s)=>{t.on("entry",n=>{n.fileName===m&&w(t,n).then(i=>r(i),i=>s(i))}),t.once("close",()=>s(new Error(I.localize(2,null,m))))}))}function h(g,m){return u(g,m).then(t=>new Promise((r,s)=>{const n=[];t.once("error",s),t.on("data",i=>n.push(i)),t.on("end",()=>r(Buffer.concat(n)))}))}}),define(le[155],he([11,10]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[156],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[157],he([11,10]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[158],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[159],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[160],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[161],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[162],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[163],he([11,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[164],he([11,10]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[165],he([11,10]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[166],he([11,10]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[167],he([11,10]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[168],he([11,10]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[169],he([11,10]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[170],he([11,10]),function(se,e){return se.create("vs/platform/log/common/log",e)}),define(le[171],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[172],he([11,10]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[173],he([11,10]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[174],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[175],he([11,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[176],he([11,10]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[177],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[178],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[179],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[180],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[181],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[182],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[183],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[184],he([11,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[185],he([11,10]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[186],he([0,1,7,157]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var A;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(A||(e.TokenType=A={}));function j(...d){switch(d.length){case 1:return(0,L.localize)(0,null,d[0]);case 2:return(0,L.localize)(1,null,d[0],d[1]);case 3:return(0,L.localize)(2,null,d[0],d[1],d[2]);default:return}}const D=(0,L.localize)(3,null),I=(0,L.localize)(4,null);class P{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,R.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const v=this.d,y=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:y};this.g.push({offset:v,lexeme:y,additionalInfo:E}),this.f.push(l)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const v=this.c.substring(this.d,this.e),y=P.b.get(v);y?this.k(y):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,v=!1,y=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(I);return}const c=this.c.charCodeAt(E);if(v)v=!1;else if(c===47&&!y){E++;break}else c===91?y=!0:c===92?v=!0:c===93&&(y=!1);E++}for(;E<this.c.length&&P.a.has(this.c.charCodeAt(E));)E++;this.e=E;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=P}),define(le[187],he([0,1,65,85,23,14,36,21,8]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=void 0,e.$$m=E,e.$_m=v,e.$9m=/^([^.]+\..+)[:=](.+)$/;class d{get appRoot(){return(0,j.$mc)(A.$Ug.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,j.$jc)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,I.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,R.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$jc)(this.userDataPath,"logs",l)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$bh)(P.URI.file((0,j.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=D.env.VSCODE_PORTABLE;return l?P.URI.file((0,j.$jc)(l,"argv.json")):(0,I.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,j.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,j.$kc)(l):(0,j.$hc)((0,j.$jc)(A.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?P.URI.file((0,j.$kc)(l)):P.URI.file((0,j.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,j.$kc)(l);const c=D.env.VSCODE_EXTENSIONS;if(c)return c;const w=D.env.VSCODE_PORTABLE;return w?(0,j.$jc)(w,"extensions"):(0,I.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(c=>/^[^:/?#]+?:\/\//.test(c)?P.URI.parse(c):P.URI.file((0,j.$hc)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?P.URI.parse(l):P.URI.file((0,j.$hc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$9m.test(l))}get extensionLogLevel(){const l=[];for(const c of this.args.log||[]){const w=e.$9m.exec(c);w&&w[1]&&w[2]&&l.push([w[1],w[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,I.$bh)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=D.env.VSCODE_PORTABLE;return l?P.URI.file((0,j.$jc)(l,"policy.json")):(0,I.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,c,w){this.a=l,this.b=c,this.c=w,this.editSessionId=this.args.editSessionId}}e.$0m=d,ve([L.$5h],d.prototype,"appRoot",null),ve([L.$5h],d.prototype,"userHome",null),ve([L.$5h],d.prototype,"userDataPath",null),ve([L.$5h],d.prototype,"appSettingsHome",null),ve([L.$5h],d.prototype,"tmpDir",null),ve([L.$5h],d.prototype,"cacheHome",null),ve([L.$5h],d.prototype,"stateResource",null),ve([L.$5h],d.prototype,"userRoamingDataHome",null),ve([L.$5h],d.prototype,"userDataSyncHome",null),ve([L.$5h],d.prototype,"sync",null),ve([L.$5h],d.prototype,"machineSettingsResource",null),ve([L.$5h],d.prototype,"workspaceStorageHome",null),ve([L.$5h],d.prototype,"localHistoryHome",null),ve([L.$5h],d.prototype,"keyboardLayoutResource",null),ve([L.$5h],d.prototype,"argvResource",null),ve([L.$5h],d.prototype,"isExtensionDevelopment",null),ve([L.$5h],d.prototype,"untitledWorkspacesHome",null),ve([L.$5h],d.prototype,"builtinExtensionsPath",null),ve([L.$5h],d.prototype,"extensionsPath",null),ve([L.$5h],d.prototype,"extensionDevelopmentLocationURI",null),ve([L.$5h],d.prototype,"extensionDevelopmentKind",null),ve([L.$5h],d.prototype,"extensionTestsLocationURI",null),ve([L.$5h],d.prototype,"debugExtensionHost",null),ve([L.$5h],d.prototype,"logLevel",null),ve([L.$5h],d.prototype,"extensionLogLevel",null),ve([L.$5h],d.prototype,"serviceMachineIdResource",null),ve([L.$5h],d.prototype,"disableTelemetry",null),ve([L.$5h],d.prototype,"disableWorkspaceTrust",null),ve([L.$5h],d.prototype,"useInMemorySecretStorage",null),ve([L.$5h],d.prototype,"policyFile",null);function E(y,l){return v(y["inspect-extensions"],y["inspect-brk-extensions"],5870,l,y.debugId,y.extensionEnvironment)}function v(y,l,c,w,$,f){const h=Number(l||y)||(w?null:c),g=h?!!l:!1;let m;if(f)try{m=JSON.parse(f)}catch{}return{port:h,break:g,debugId:$,env:m}}}),function(){"use strict";function se(e,R,L){function A(D,I){const P=j(D,I),d=[P];return e.isAbsolute(P)||d.unshift(L),e.resolve(...d)}function j(D,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,I);const E=D["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(v,"AppData","Roaming")}break;case"darwin":d=e.join(R.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,I)}return{getUserDataPath:A}}if(typeof define=="function")define(le[188],he([276,37,36]),function(e,R,L){return se(e,R,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=se(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[189],he([0,1,37,187,188]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=void 0,e.$bn=D,e.$cn=I;class j extends L.$0m{constructor(d,E){super(d,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,A.getUserDataPath)(d,E.nameShort)},E)}}e.$an=j;function D(P,d){return(0,L.$_m)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,d,P.extensionEnvironment)}function I(P,d){return(0,L.$_m)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,d,P.extensionEnvironment)}}),define(le[190],he([0,1,13,160]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=A;function A(D,I,P,d){try{j(D,I,P,d)}catch(E){D.error(E?.message??E)}return I}function j(D,I,P,d){const E=(v,y,l)=>{const c=v[y];if((0,R.$ag)(c)){const w=c,$=w.length;if($>1&&w[0]==="%"&&w[$-1]==="%"){const f=w.substr(1,$-2);let u=P[f];u===void 0&&d&&(u=d[f]);const h=typeof u=="string"?u:u?.message,g=d?.[f],m=typeof g=="string"?g:g?.message;if(!h){m||D.warn(`[${I.name}]: ${(0,L.localize)(0,null,f)}`);return}if(l&&(y==="title"||y==="category")&&m&&m!==h){const t={value:h,original:m};v[y]=t}else v[y]=h}}else if((0,R.$cg)(c))for(const w in c)c.hasOwnProperty(w)&&(w==="commands"?E(c,w,!0):E(c,w,l));else if(Array.isArray(c))for(let w=0;w<c.length;w++)E(c,w,l)};for(const v in I)I.hasOwnProperty(v)&&E(I,v)}}),define(le[191],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=e.$Hfc=void 0;class R{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Hfc=R;class L{constructor(j){this.a=j}listen(j,D){throw new Error(`Event not found: ${D}`)}call(j,D,I){switch(D){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${D}`)}}e.$Ifc=L}),define(le[71],he([0,1,21,89,164,55]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=P,e.$Np=d,e.$Op=E,e.$Pp=v,e.$Qp=y,e.$Rp=l,e.$Sp=c;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function P(f){return f=f.trim(),f==="*"||D.test(f)}function d(f){if(!P(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=f.match(D);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}function E(f){if(!f)return null;const u=f.majorBase,h=f.majorMustEqual,g=f.minorBase;let m=f.minorMustEqual;const t=f.patchBase;let r=f.patchMustEqual;f.hasCaret&&(u===0||(m=!1),r=!1);let s=0;if(f.preRelease){const n=I.exec(f.preRelease);if(n){const[,i,o,a]=n;s=Date.UTC(Number(i),Number(o)-1,Number(a))}}return{majorBase:u,majorMustEqual:h,minorBase:g,minorMustEqual:m,patchBase:t,patchMustEqual:r,isMinimum:f.hasGreaterEquals,notBefore:s}}function v(f,u,h){let g;typeof f=="string"?g=E(d(f)):g=f;let m;u instanceof Date?m=u.getTime():typeof u=="string"&&(m=new Date(u).getTime());let t;if(typeof h=="string"?t=E(d(h)):t=h,!g||!t)return!1;const r=g.majorBase,s=g.minorBase,n=g.patchBase;let i=t.majorBase,o=t.minorBase,a=t.patchBase;const p=t.notBefore;let S=t.majorMustEqual,b=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?r>i?!0:r<i?!1:s>o?!0:s<o||m&&m<p?!1:n>=a:(r===1&&i===0&&(!S||!b||!k)&&(i=1,o=0,a=0,S=!0,b=!1,k=!1),r<i?!1:r>i?!S:s<o?!1:s>o?!b:n<a?!1:n>a?!k:!(m&&m<p))}function y(f,u,h,g,m){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([L.default.Error,A.localize(0,null)]),t;if(typeof g.name!="string")return t.push([L.default.Error,A.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([L.default.Error,A.localize(2,null,"version")]),t;if(!g.engines)return t.push([L.default.Error,A.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([L.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!$(g.extensionDependencies))return t.push([L.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!$(g.activationEvents))return t.push([L.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([L.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([L.default.Warning,A.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([L.default.Error,A.localize(9,null,"main")]),t;{const n=(0,R.$bh)(h,g.main);(0,R.$8g)(n,h)||t.push([L.default.Warning,A.localize(10,null,n.path,h.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([L.default.Error,A.localize(11,null,"browser")]),t;{const n=(0,R.$bh)(h,g.browser);(0,R.$8g)(n,h)||t.push([L.default.Warning,A.localize(12,null,n.path,h.path)])}}if(!j.valid(g.version))return t.push([L.default.Error,A.localize(13,null)]),t;const r=[];if(!l(f,u,g,m,r))for(const n of r)t.push([L.default.Error,n]);return t}function l(f,u,h,g,m){return g||typeof h.main>"u"&&typeof h.browser>"u"?!0:w(f,u,h.engines.vscode,m)}function c(f,u,h){return f==="*"||w(u,h,f)}function w(f,u,h,g=[]){const m=E(d(h));if(!m)return g.push(A.localize(14,null,h)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return g.push(A.localize(15,null,h)),!1}else if(!m.majorMustEqual)return g.push(A.localize(16,null,h)),!1;return v(f,u,m)?!0:(g.push(A.localize(17,null,f,h)),!1)}function $(f){if(!Array.isArray(f))return!1;for(let u=0,h=f.length;u<h;u++)if(typeof f[u]!="string")return!1;return!0}}),define(le[45],he([0,1,15,32]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=A;async function A(j,D,I){let P=I&&I.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const E=(await D.readFile(j.serviceMachineIdResource)).value.toString();P=(0,L.$Vg)(E)?E:null}catch{P=null}if(!P){P=(0,L.$Wg)();try{await D.writeFile(j.serviceMachineIdResource,R.$Je.fromString(P))}catch{}}return I?.store("storage.serviceMachineId",P,-1,1),P}}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class R{constructor(A,j=[],D=!1){this.ctor=A,this.staticArguments=j,this.supportsDelayedInstantiation=D}}e.$xi=R}),define(le[192],he([0,1,72]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ds=j,e.$Es=D;const L=[];var A;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function j(I,P,d){P instanceof R.$xi||(P=new R.$xi(P,[],!!d)),L.push([I,P])}function D(){return L}}),define(le[193],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;class R{constructor(j,D){this.key=j,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$gr=R;class L{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const D of this.a.values())D.outgoing.size===0&&j.push(D);return j}insertEdge(j,D){const I=this.lookupOrInsertNode(j),P=this.lookupOrInsertNode(D);I.outgoing.set(P.key,P),P.incoming.set(I.key,I)}removeNode(j){const D=this.b(j);this.a.delete(D);for(const I of this.a.values())I.outgoing.delete(D),I.incoming.delete(D)}lookupOrInsertNode(j){const D=this.b(j);let I=this.a.get(D);return I||(I=new R(D,j),this.a.set(D,I)),I}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[D,I]of this.a)j.push(`${D}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,D]of this.a){const I=new Set([j]),P=this.c(D,I);if(P)return P}}c(j,D){for(const[I,P]of j.outgoing){if(D.has(I))return[...D,I].join(" -> ");D.add(I);const d=this.c(P,D);if(d)return d;D.delete(I)}}}e.$hr=L}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=A,e.$Bi=j;var R;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function I(P){return P[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=I})(R||(e._util=R={})),e.$zi=A("instantiationService");function L(D,I,P){I[R.DI_TARGET]===I?I[R.DI_DEPENDENCIES].push({id:D,index:P}):(I[R.DI_DEPENDENCIES]=[{id:D,index:P}],I[R.DI_TARGET]=I)}function A(D){if(R.serviceIds.has(D))return R.serviceIds.get(D);const I=function(P,d,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(I,P,E)};return I.toString=()=>D,R.serviceIds.set(D,I),I}function j(D){return D}}),define(le[194],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0,e.$hfc=(0,R.$Ai)("checksumService")}),define(le[22],he([0,1,13,8,4]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=j,e.$9i=D,e.$0i=P,e.$$i=d,e.$_i=E,e.$aj=v,e.$bj=y,e.$cj=c,e.$dj=w,e.$ej=$,e.$7i=(0,A.$Ai)("configurationService");function j(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof L.URI)}function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof L.URI)}var I;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function P(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function d(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function E(f,u){const h=Object.create(null);for(const g in f)v(h,g,f[g],u);return h}function v(f,u,h,g){const m=u.split("."),t=m.pop();let r=f;for(let s=0;s<m.length;s++){const n=m[s];let i=r[n];switch(typeof i){case"undefined":i=r[n]=Object.create(null);break;case"object":if(i===null){g(`Ignoring ${u} as ${m.slice(0,s+1).join(".")} is null`);return}break;default:g(`Ignoring ${u} as ${m.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[t]=h}catch{g(`Ignoring ${u} as ${m.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${u} as ${m.join(".")} is ${JSON.stringify(r)}`)}function y(f,u){const h=u.split(".");l(f,h)}function l(f,u){const h=u.shift();if(u.length===0){delete f[h];return}if(Object.keys(f).indexOf(h)!==-1){const g=f[h];typeof g=="object"&&!Array.isArray(g)&&(l(g,u),Object.keys(g).length===0&&delete f[h])}}function c(f,u,h){function g(r,s){let n=r;for(const i of s){if(typeof n!="object"||n===null)return;n=n[i]}return n}const m=u.split("."),t=g(f,m);return typeof t>"u"?h:t}function w(f,u,h){Object.keys(u).forEach(g=>{g!=="__proto__"&&(g in f?R.$cg(f[g])&&R.$cg(u[g])?w(f[g],u[g],h):h&&(f[g]=u[g]):f[g]=u[g])})}function $(f){return f.replace(/[\[\]]/g,"")}}),define(le[94],he([0,1,5,27,186,4,156,7]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=d,e.$zj=r,e.$Aj=s,e.$Tj=Z;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",R.$j),P.set("isLinux",R.$k),P.set("isWindows",R.$i),P.set("isWeb",R.$o),P.set("isMacNative",R.$j&&!R.$o),P.set("isEdge",R.$H),P.set("isFirefox",R.$F),P.set("isChrome",R.$E),P.set("isSafari",R.$G);function d(G,N){if(P.get(G)!==void 0)throw(0,I.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(G,N)}const E=Object.prototype.hasOwnProperty;var v;(function(G){G[G.False=0]="False",G[G.True=1]="True",G[G.Defined=2]="Defined",G[G.Not=3]="Not",G[G.Equals=4]="Equals",G[G.NotEquals=5]="NotEquals",G[G.And=6]="And",G[G.Regex=7]="Regex",G[G.NotRegex=8]="NotRegex",G[G.Or=9]="Or",G[G.In=10]="In",G[G.NotIn=11]="NotIn",G[G.Greater=12]="Greater",G[G.GreaterEquals=13]="GreaterEquals",G[G.Smaller=14]="Smaller",G[G.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const y={regexParsingWithErrorRecovery:!0},l=(0,D.localize)(0,null),c=(0,D.localize)(1,null),w=(0,D.localize)(2,null),$=(0,D.localize)(3,null),f=(0,D.localize)(4,null),u=(0,D.localize)(5,null),h=(0,D.localize)(6,null),g=(0,D.localize)(7,null);class m{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(N=y){this.k=N,this.d=new A.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(N){if(N===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(N).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const V=this.D(),q=V.type===17?u:void 0;throw this.h.push({message:f,offset:V.offset,lexeme:A.$vj.getLexeme(V),additionalInfo:q}),m.c}return U}catch(U){if(U!==m.c)throw U;return}}l(){return this.m()}m(){const N=[this.o()];for(;this.y(16);){const U=this.o();N.push(U)}return N.length===1?N[0]:t.or(...N)}o(){const N=[this.s()];for(;this.y(15);){const U=this.s();N.push(U)}return N.length===1?N[0]:t.and(...N)}s(){if(this.y(2)){const N=this.D();switch(N.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,$),U?.negate()}case 17:return this.z(),C.create(N.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.D();switch(N.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const U=this.l();return this.A(1,$),U}case 17:{const U=N.lexeme;if(this.z(),this.y(9)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==10)throw this.B("REGEX",q);const _=q.lexeme,ee=_.lastIndexOf("/"),ne=ee===_.length-1?void 0:this.w(_.substring(ee+1));let te;try{te=new RegExp(_.substring(1,ee),ne)}catch{throw this.B("REGEX",q)}return J.create(U,te)}switch(q.type){case 10:case 19:{const _=[q.lexeme];this.z();let ee=this.D(),ne=0;for(let we=0;we<q.lexeme.length;we++)q.lexeme.charCodeAt(we)===40?ne++:q.lexeme.charCodeAt(we)===41&&ne--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:ne++;break;case 1:ne--;break;case 10:case 18:for(let we=0;we<ee.lexeme.length;we++)ee.lexeme.charCodeAt(we)===40?ne++:q.lexeme.charCodeAt(we)===41&&ne--}if(ne<0)break;_.push(A.$vj.getLexeme(ee)),this.z(),ee=this.D()}const te=_.join(""),ce=te.lastIndexOf("/"),fe=ce===te.length-1?void 0:this.w(te.substring(ce+1));let $e;try{$e=new RegExp(te.substring(1,ce),fe)}catch{throw this.B("REGEX",q)}return t.regex(U,$e)}case 18:{const _=q.lexeme;this.z();let ee=null;if(!(0,L.$$e)(_)){const ne=_.indexOf("/"),te=_.lastIndexOf("/");if(ne!==te&&ne>=0){const ce=_.slice(ne+1,te),fe=_[te+1]==="i"?"i":"";try{ee=new RegExp(ce,fe)}catch{throw this.B("REGEX",q)}}}if(ee===null)throw this.B("REGEX",q);return J.create(U,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const q=this.u();return t.notIn(U,q)}switch(this.D().type){case 3:{this.z();const q=this.u();if(this.x().type===18)return t.equals(U,q);switch(q){case"true":return t.has(U);case"false":return t.not(U);default:return t.equals(U,q)}}case 4:{this.z();const q=this.u();if(this.x().type===18)return t.notEquals(U,q);switch(q){case"true":return t.not(U);case"false":return t.has(U);default:return t.notEquals(U,q)}}case 5:return this.z(),F.create(U,this.u());case 6:return this.z(),K.create(U,this.u());case 7:return this.z(),M.create(U,this.u());case 8:return this.z(),T.create(U,this.u());case 13:return this.z(),t.in(U,this.u());default:return t.has(U)}}case 20:throw this.h.push({message:h,offset:N.offset,lexeme:"",additionalInfo:g}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const N=this.D();switch(N.type){case 17:case 18:return this.z(),N.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(N){return N.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(N){return this.C(N)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(N,U){if(this.C(N))return this.z();throw this.B(U,this.D())}B(N,U,V){const q=(0,D.localize)(8,null,N,A.$vj.getLexeme(U)),_=U.offset,ee=A.$vj.getLexeme(U);return this.h.push({message:q,offset:_,lexeme:ee,additionalInfo:V}),m.c}C(N){return this.D().type===N}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$xj=m;class t{static false(){return i.INSTANCE}static true(){return o.INSTANCE}static has(N){return a.create(N)}static equals(N,U){return p.create(N,U)}static notEquals(N,U){return k.create(N,U)}static regex(N,U){return J.create(N,U)}static in(N,U){return S.create(N,U)}static notIn(N,U){return b.create(N,U)}static not(N){return C.create(N)}static and(...N){return X.create(N,null,!0)}static or(...N){return W.create(N,null,!0)}static greater(N,U){return M.create(N,U)}static greaterEquals(N,U){return T.create(N,U)}static smaller(N,U){return F.create(N,U)}static smallerEquals(N,U){return K.create(N,U)}static{this.c=new m({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this.c.parse(N)}}e.$yj=t;function r(G){const N=new m({regexParsingWithErrorRecovery:!1});return G.map(U=>(N.parse(U),N.lexingErrors.length>0?N.lexingErrors.map(V=>({errorMessage:V.additionalInfo?(0,D.localize)(9,null,V.additionalInfo):(0,D.localize)(10,null),offset:V.offset,length:V.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(V=>({errorMessage:V.additionalInfo?`${V.message}. ${V.additionalInfo}`:V.message,offset:V.offset,length:V.lexeme.length})):[]))}function s(G,N){const U=G?G.substituteConstants():void 0,V=N?N.substituteConstants():void 0;return!U&&!V?!0:!U||!V?!1:U.equals(V)}function n(G,N){return G.cmp(N)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return o.INSTANCE}}e.$Bj=i;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return i.INSTANCE}}e.$Cj=o;class a{static create(N,U=null){const V=P.get(N);return typeof V=="boolean"?V?o.INSTANCE:i.INSTANCE:new a(N,U)}constructor(N,U){this.key=N,this.c=U,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:ie(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=P.get(this.key);return typeof N=="boolean"?N?o.INSTANCE:i.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Dj=a;class p{static create(N,U,V=null){if(typeof U=="boolean")return U?a.create(N,V):C.create(N,V);const q=P.get(N);return typeof q=="boolean"?U===(q?"true":"false")?o.INSTANCE:i.INSTANCE:new p(N,U,V)}constructor(N,U,V){this.c=N,this.d=U,this.f=V,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=P.get(this.c);if(typeof N=="boolean"){const U=N?"true":"false";return this.d===U?o.INSTANCE:i.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Ej=p;class S{static create(N,U){return new S(N,U)}constructor(N,U){this.d=N,this.f=U,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:re(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const U=N.getValue(this.f),V=N.getValue(this.d);return Array.isArray(U)?U.includes(V):typeof V=="string"&&typeof U=="object"&&U!==null?E.call(U,V):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Fj=S;class b{static create(N,U){return new b(N,U)}constructor(N,U){this.d=N,this.f=U,this.type=11,this.c=S.create(N,U)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=b;class k{static create(N,U,V=null){if(typeof U=="boolean")return U?C.create(N,V):a.create(N,V);const q=P.get(N);return typeof q=="boolean"?U===(q?"true":"false")?i.INSTANCE:o.INSTANCE:new k(N,U,V)}constructor(N,U,V){this.c=N,this.d=U,this.f=V,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=P.get(this.c);if(typeof N=="boolean"){const U=N?"true":"false";return this.d===U?i.INSTANCE:o.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$Hj=k;class C{static create(N,U=null){const V=P.get(N);return typeof V=="boolean"?V?i.INSTANCE:o.INSTANCE:new C(N,U)}constructor(N,U){this.c=N,this.d=U,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:ie(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=P.get(this.c);return typeof N=="boolean"?N?i.INSTANCE:o.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Ij=C;function O(G,N){if(typeof G=="string"){const U=parseFloat(G);isNaN(U)||(G=U)}return typeof G=="string"||typeof G=="number"?N(G):i.INSTANCE}class M{static create(N,U,V=null){return O(U,q=>new M(N,q,V))}constructor(N,U,V){this.c=N,this.d=U,this.f=V,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Jj=M;class T{static create(N,U,V=null){return O(U,q=>new T(N,q,V))}constructor(N,U,V){this.c=N,this.d=U,this.f=V,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Kj=T;class F{static create(N,U,V=null){return O(U,q=>new F(N,q,V))}constructor(N,U,V){this.c=N,this.d=U,this.f=V,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Lj=F;class K{static create(N,U,V=null){return O(U,q=>new K(N,q,V))}constructor(N,U,V){this.c=N,this.d=U,this.f=V,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:re(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Mj=K;class J{static create(N,U){return new J(N,U)}constructor(N,U){this.d=N,this.f=U,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const U=this.f?this.f.source:"",V=N.f?N.f.source:"";return U<V?-1:U>V?1:0}equals(N){if(N.type===this.type){const U=this.f?this.f.source:"",V=N.f?N.f.source:"";return this.d===N.d&&U===V}return!1}substituteConstants(){return this}evaluate(N){const U=N.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Nj=J;class Q{static create(N){return new Q(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(N){return new Q(this.c.map(N))}negate(){return this.c}}e.$Oj=Q;function H(G){let N=null;for(let U=0,V=G.length;U<V;U++){const q=G[U].substituteConstants();if(G[U]!==q&&N===null){N=[];for(let _=0;_<U;_++)N[_]=G[_]}N!==null&&(N[U]=q)}return N===null?G:N}class X{static create(N,U,V){return X.d(N,U,V)}constructor(N,U){this.expr=N,this.c=U,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let U=0,V=this.expr.length;U<V;U++){const q=n(this.expr[U],N.expr[U]);if(q!==0)return q}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let U=0,V=this.expr.length;U<V;U++)if(!this.expr[U].equals(N.expr[U]))return!1;return!0}return!1}substituteConstants(){const N=H(this.expr);return N===this.expr?this:X.create(N,this.c,!1)}evaluate(N){for(let U=0,V=this.expr.length;U<V;U++)if(!this.expr[U].evaluate(N))return!1;return!0}static d(N,U,V){const q=[];let _=!1;for(const ee of N)if(ee){if(ee.type===1){_=!0;continue}if(ee.type===0)return i.INSTANCE;if(ee.type===6){q.push(...ee.expr);continue}q.push(ee)}if(q.length===0&&_)return o.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(n);for(let ee=1;ee<q.length;ee++)q[ee-1].equals(q[ee])&&(q.splice(ee,1),ee--);if(q.length===1)return q[0];for(;q.length>1;){const ee=q[q.length-1];if(ee.type!==9)break;q.pop();const ne=q.pop(),te=q.length===0,ce=W.create(ee.expr.map(fe=>X.create([fe,ne],null,V)),null,te);ce&&(q.push(ce),q.sort(n))}if(q.length===1)return q[0];if(V){for(let ee=0;ee<q.length;ee++)for(let ne=ee+1;ne<q.length;ne++)if(q[ee].negate().equals(q[ne]))return i.INSTANCE;if(q.length===1)return q[0]}return new X(q,U)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const U of this.expr)N.push(...U.keys());return N}map(N){return new X(this.expr.map(U=>U.map(N)),null)}negate(){if(!this.c){const N=[];for(const U of this.expr)N.push(U.negate());this.c=W.create(N,this,!0)}return this.c}}e.$Pj=X;class W{static create(N,U,V){return W.d(N,U,V)}constructor(N,U){this.expr=N,this.c=U,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let U=0,V=this.expr.length;U<V;U++){const q=n(this.expr[U],N.expr[U]);if(q!==0)return q}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let U=0,V=this.expr.length;U<V;U++)if(!this.expr[U].equals(N.expr[U]))return!1;return!0}return!1}substituteConstants(){const N=H(this.expr);return N===this.expr?this:W.create(N,this.c,!1)}evaluate(N){for(let U=0,V=this.expr.length;U<V;U++)if(this.expr[U].evaluate(N))return!0;return!1}static d(N,U,V){let q=[],_=!1;if(N){for(let ee=0,ne=N.length;ee<ne;ee++){const te=N[ee];if(te){if(te.type===0){_=!0;continue}if(te.type===1)return o.INSTANCE;if(te.type===9){q=q.concat(te.expr);continue}q.push(te)}}if(q.length===0&&_)return i.INSTANCE;q.sort(n)}if(q.length!==0){if(q.length===1)return q[0];for(let ee=1;ee<q.length;ee++)q[ee-1].equals(q[ee])&&(q.splice(ee,1),ee--);if(q.length===1)return q[0];if(V){for(let ee=0;ee<q.length;ee++)for(let ne=ee+1;ne<q.length;ne++)if(q[ee].negate().equals(q[ne]))return o.INSTANCE;if(q.length===1)return q[0]}return new W(q,U)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const U of this.expr)N.push(...U.keys());return N}map(N){return new W(this.expr.map(U=>U.map(N)),null)}negate(){if(!this.c){const N=[];for(const U of this.expr)N.push(U.negate());for(;N.length>1;){const U=N.shift(),V=N.shift(),q=[];for(const _ of x(U))for(const ee of x(V))q.push(X.create([_,ee],null,!1));N.unshift(W.create(q,null,!1))}this.c=W.create(N,this,!0)}return this.c}}e.$Qj=W;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(N,U,V){super(N,null),this.f=U,typeof V=="object"?B.d.push({...V,key:N}):V!==!0&&B.d.push({key:N,description:V,type:U!=null?typeof U:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return p.create(this.key,N)}notEqualsTo(N){return k.create(this.key,N)}}e.$Rj=B,e.$Sj=(0,j.$Ai)("contextKeyService");function ie(G,N){return G<N?-1:G>N?1:0}function re(G,N,U,V){return G<U?-1:G>U?1:N<V?-1:N>V?1:0}function Z(G,N){if(G.type===0||N.type===1)return!0;if(G.type===9)return N.type===9?z(G.expr,N.expr):!1;if(N.type===9){for(const U of N.expr)if(Z(G,U))return!0;return!1}if(G.type===6){if(N.type===6)return z(N.expr,G.expr);for(const U of G.expr)if(Z(U,N))return!0;return!1}return G.equals(N)}function z(G,N){let U=0,V=0;for(;U<G.length&&V<N.length;){const q=G[U].cmp(N[V]);if(q<0)return!1;q===0&&U++,V++}return U===G.length}function x(G){return G.type===9?G.expr:[G]}}),define(le[95],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$hn=e.ID=void 0,e.$in=L,e.ID="diagnosticsService",e.$hn=(0,R.$Ai)(e.ID);function L(j){return!!j.hostName&&!!j.errorMessage}class A{async getPerformanceInfo(D,I){return{}}async getSystemInfo(D,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,I){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$jn=A}),define(le[96],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=void 0,e.$Po=(0,R.$Ai)("downloadService")}),define(le[16],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,R.$Ai)("environmentService"),e.$Ii=(0,R.$Bi)(e.$Hi)}),define(le[28],he([0,1,159,4]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.ExtensionManagementErrorCode=e.$ap=e.ExtensionGalleryErrorCode=e.$_o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0,e.$6o=j,e.$7o=D,e.$8o=I,e.$9o=P,e.$0o=d,e.$$o=E,e.$Yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Zo=new RegExp(e.$Yo),e.$1o="__web_extension",e.$2o="skipWalkthrough",e.$3o="extensionInstallSource",e.$4o="dependecyOrPackExtensionInstall",e.$5o="clientTargetPlatform";var A;(function(h){h.COMMAND="command",h.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function j(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function D(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function I(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function P(h,g){return g==="web"&&!h.includes("web")}function d(h,g,m){return P(g,m)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===m}function E(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var v;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var y;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var l;(function(h){h.Install="install",h.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var c;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$_o=(0,L.$Ai)("extensionGalleryService");var w;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed",h.DownloadFailedWriting="DownloadFailedWriting"})(w||(e.ExtensionGalleryErrorCode=w={}));class $ extends Error{constructor(g,m){super(g),this.code=m,this.name=m}}e.$ap=$;var f;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.DownloadFailedWriting="DownloadFailedWriting",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.ScanningExtension="ScanningExtension",h.ReadUninstalled="ReadUninstalled",h.UnsetUninstalled="UnsetUninstalled",h.Delete="Delete",h.Rename="Rename",h.IntializeDefaultProfile="IntializeDefaultProfile",h.AddToProfile="AddToProfile",h.InstalledExtensionNotFound="InstalledExtensionNotFound",h.PostInstall="PostInstall",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Cancelled="Cancelled",h.Unknown="Unknown",h.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));class u extends Error{constructor(g,m){super(g),this.code=m,this.name=m}}e.$bp=u,e.$cp=(0,L.$Ai)("extensionManagementService"),e.$dp="extensionsIdentifiers/disabled",e.$ep="extensionsIdentifiers/enabled",e.$fp=(0,L.$Ai)("IGlobalExtensionEnablementService"),e.$gp=(0,L.$Ai)("IExtensionTipsService"),e.$hp=(0,R.localize2)(0,"Extensions"),e.$ip=(0,R.localize2)(1,"Preferences")}),define(le[195],he([0,1,3,2,30,8,92,28]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=void 0;function P($,f){return $?j.URI.revive(f?f.transformIncoming($):$):void 0}function d($,f){return f?f.transformOutgoingURI($):$}function E($,f){f=f||D.$Dn;const u=$.manifest;return{...(0,D.$Gn)({...$,manifest:void 0},f),manifest:u}}function v($,f){return $?.profileLocation?(0,D.$Gn)($,f??D.$Dn):$}function y($,f){return f?(0,A.$9n)($,u=>u instanceof j.URI?f.transformOutgoingURI(u):void 0):$}class l{constructor(f,u){this.a=f,this.b=u,this.onInstallExtension=R.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=R.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,u){const h=this.b(f);switch(u){case"onInstallExtension":return R.Event.map(this.onInstallExtension,g=>({...g,profileLocation:g.profileLocation?d(g.profileLocation,h):g.profileLocation}));case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,g=>g.map(m=>({...m,local:m.local?y(m.local,h):m.local,profileLocation:m.profileLocation?d(m.profileLocation,h):m.profileLocation})));case"onUninstallExtension":return R.Event.map(this.onUninstallExtension,g=>({...g,profileLocation:g.profileLocation?d(g.profileLocation,h):g.profileLocation}));case"onDidUninstallExtension":return R.Event.map(this.onDidUninstallExtension,g=>({...g,profileLocation:g.profileLocation?d(g.profileLocation,h):g.profileLocation}));case"onDidUpdateExtensionMetadata":return R.Event.map(this.onDidUpdateExtensionMetadata,g=>y(g,h))}throw new Error("Invalid listen")}async call(f,u,h){const g=this.b(f);switch(u){case"zip":{const m=E(h[0],g),t=await this.a.zip(m);return d(t,g)}case"unzip":return this.a.unzip(P(h[0],g));case"install":return this.a.install(P(h[0],g),v(h[1],g));case"installFromLocation":return this.a.installFromLocation(P(h[0],g),P(h[1],g));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],P(h[1],g),P(h[2],g));case"getManifest":return this.a.getManifest(P(h[0],g));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],v(h[1],g));case"installGalleryExtensions":{const m=h[0];return this.a.installGalleryExtensions(m.map(({extension:t,options:r})=>({extension:t,options:v(r,g)??{}})))}case"uninstall":return this.a.uninstall(E(h[0],g),v(h[1],g));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(h[0],g));case"getInstalled":return(await this.a.getInstalled(h[0],P(h[1],g),h[2])).map(t=>y(t,g));case"toggleAppliationScope":{const m=await this.a.toggleAppliationScope(E(h[0],g),P(h[1],g));return y(m,g)}case"copyExtensions":return this.a.copyExtensions(P(h[0],g),P(h[1],g));case"updateMetadata":{const m=await this.a.updateMetadata(E(h[0],g),h[1],P(h[2],g));return y(m,g)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$jq=l;class c extends L.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new R.$he),this.f=this.B(new R.$he),this.g=this.B(new R.$he),this.h=this.B(new R.$he),this.j=this.B(new R.$he),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(h=>({...h,local:h.local?E(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(E(u,null))))}n(f,u){f.fire(u)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const u=await this.getTargetPlatform();return f.allTargetPlatforms.some(h=>(0,I.$0o)(h,f.allTargetPlatforms,u))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(u=>j.URI.revive(u)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,u){return Promise.resolve(this.m.call("install",[f,u])).then(h=>E(h,null))}installFromLocation(f,u){return Promise.resolve(this.m.call("installFromLocation",[f,u])).then(h=>E(h,null))}async installExtensionsFromProfile(f,u,h){return(await this.m.call("installExtensionsFromProfile",[f,u,h])).map(m=>E(m,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,u){return Promise.resolve(this.m.call("installFromGallery",[f,u])).then(h=>E(h,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(h=>({...h,local:h.local?E(h.local,null):h.local,source:this.r(h.source)?j.URI.revive(h.source):h.source,profileLocation:j.URI.revive(h.profileLocation)}))}uninstall(f,u){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,u]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(u=>E(u,null))}getInstalled(f=null,u,h){return Promise.resolve(this.m.call("getInstalled",[f,u,h])).then(g=>g.map(m=>E(m,null)))}updateMetadata(f,u,h){return Promise.resolve(this.m.call("updateMetadata",[f,u,h])).then(g=>E(g,null))}toggleAppliationScope(f,u){return this.m.call("toggleAppliationScope",[f,u]).then(h=>E(h,null))}copyExtensions(f,u){return this.m.call("copyExtensions",[f,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,u,h){const g=await this.m.call("download",[f,u,h]);return j.URI.revive(g)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$kq=c;class w{constructor(f){this.a=f}listen(f,u){throw new Error("Invalid listen")}call(f,u,h){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$lq=w}),define(le[97],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$14b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$Z4b=A;var L;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(L||(e.RecommendationSource=L={}));function A(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var j;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$14b=(0,R.$Ai)("IExtensionRecommendationNotificationService")}),define(le[12],he([0,1,51,14,27,13,8,166,4,5,23,53]),function(se,e,R,L,A,j,D,I,P,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=y,e.$9k=$,e.$0k=u,e.$$k=h,e.$_k=g,e.$al=m,e.$bl=t,e.$cl=r,e.$dl=s,e.$el=n,e.$fl=i,e.$hl=p,e.$il=S,e.$jl=b,e.$kl=k,e.$ll=C,e.$ol=K,e.$Al=B,e.$Bl=ie,e.$Dl=Z,e.$7k=(0,P.$Ai)("fileService");function y(z){return z.create===!0}var l;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var c;(function(z){z[z.Readonly=1]="Readonly",z[z.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var w;(function(z){z[z.UPDATED=2]="UPDATED",z[z.ADDED=4]="ADDED",z[z.DELETED=8]="DELETED"})(w||(e.FileChangeFilter=w={}));function $(z){const x=z;return!!x&&typeof x.onDidChange=="function"}var f;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileAtomicWrite=32768]="FileAtomicWrite",z[z.FileAtomicDelete=65536]="FileAtomicDelete",z[z.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function u(z){return!!(z.capabilities&2)}function h(z){return!!(z.capabilities&8)}function g(z){return!!(z.capabilities&131072)}function m(z){return!!(z.capabilities&4)}function t(z){return!!(z.capabilities&16)}function r(z){return u(z)?!!(z.capabilities&16384):!1}function s(z){return u(z)?!!(z.capabilities&32768):!1}function n(z){return!!(z.capabilities&65536)}function i(z){return!!(z.capabilities&2048)}var o;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsStorageQuota="EntryExceedsStorageQuota",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class a extends Error{static create(x,G){const N=new a(x.toString(),G);return b(N,G),N}constructor(x,G){super(x),this.code=G}}e.$gl=a;function p(z,x){return a.create(z,x)}function S(z){return z||p((0,I.localize)(0,null),o.Unknown)}function b(z,x){return z.name=x?`${x} (FileSystemError)`:"FileSystemError",z}function k(z){if(!z)return o.Unknown;if(z instanceof a)return z.code;const x=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!x)return o.Unknown;switch(x[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function C(z){if(z instanceof J)return z.fileOperationResult;switch(k(z)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}var O;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class M{constructor(x,G,N){this.resource=x,this.operation=G,this.target=N}isOperation(x){return this.operation===x}}e.$ml=M;var T;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class F{static{this.a=null}constructor(x,G){this.c=G,this.b=void 0,this.d=new v.$V(()=>{const N=R.$Gi.forUris(()=>this.c);return N.fill(this.rawAdded.map(U=>[U,!0])),N}),this.f=new v.$V(()=>{const N=R.$Gi.forUris(()=>this.c);return N.fill(this.rawUpdated.map(U=>[U,!0])),N}),this.g=new v.$V(()=>{const N=R.$Gi.forUris(()=>this.c);return N.fill(this.rawDeleted.map(U=>[U,!0])),N}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const N of x){switch(N.type){case 1:this.rawAdded.push(N.resource);break;case 0:this.rawUpdated.push(N.resource);break;case 2:this.rawDeleted.push(N.resource);break}this.b!==F.a&&(typeof N.cId=="number"?this.b===void 0?this.b=N.cId:this.b!==N.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(x,...G){return this.h(x,{includeChildren:!1},...G)}affects(x,...G){return this.h(x,{includeChildren:!0},...G)}h(x,G,...N){if(!x)return!1;const U=N.length>0;return!!((!U||N.includes(1))&&(this.d.value.get(x)||G.includeChildren&&this.d.value.findSuperstr(x))||(!U||N.includes(0))&&(this.f.value.get(x)||G.includeChildren&&this.f.value.findSuperstr(x))||(!U||N.includes(2))&&(this.g.value.findSubstr(x)||G.includeChildren&&this.g.value.findSuperstr(x)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(x){return this.b===x}hasCorrelation(){return typeof this.b=="number"}}e.$nl=F;function K(z,x,G){return!z||!x||z===x||x.length>z.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),G?(0,A.$Cf)(z,x):z.indexOf(x)===0)}class J extends Error{constructor(x,G,N){super(x),this.fileOperationResult=G,this.options=N}}e.$pl=J;class Q extends J{constructor(x,G,N,U){super(x,G,U),this.fileOperationResult=G,this.size=N}}e.$ql=Q;class H extends J{constructor(x,G,N){super(x,2,N),this.stat=G}}e.$rl=H;var X;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var W;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(W||(e.FileKind=W={})),e.$zl="";function B(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}async function ie(z,x){if(!x.hasProvider(D.URI.from({scheme:z.scheme})))return new Promise(G=>{const N=x.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===z.scheme&&U.added&&(N.dispose(),G())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(x){return(0,j.$eg)(x)||(x=0),x<re.KB?(0,I.localize)(1,null,x.toFixed(0)):x<re.MB?(0,I.localize)(2,null,(x/re.KB).toFixed(2)):x<re.GB?(0,I.localize)(3,null,(x/re.MB).toFixed(2)):x<re.TB?(0,I.localize)(4,null,(x/re.GB).toFixed(2)):(0,I.localize)(5,null,(x/re.TB).toFixed(2))}}e.$Cl=re;function Z(z){const x=typeof z=="string"||z?.scheme===E.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===E.Schemas.file?1024*re.MB:x?10*re.MB:d.$o?50*re.MB:1024*re.MB}});var Y=this&&this.__param||function(se,e){return function(R,L){e(R,L,se)}};define(le[196],he([0,1,73,50,12]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;let j=class{constructor(I){this.a=I}async checksum(I){const P=(await this.a.readFileStream(I)).value;return new Promise((d,E)=>{const v=(0,R.createHash)("sha256");(0,L.$Be)(P,{onData:y=>v.update(y.buffer),onError:y=>E(y),onEnd:()=>d(v.digest("base64").replace(/=+$/,""))})})}};e.$ifc=j,e.$ifc=j=ve([Y(0,A.$7k)],j)}),define(le[98],he([0,1,15,7,167,12]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=D;async function D(E,v,y,l,c,w){let $;try{await I(E,v,y,l,c,w)}catch(f){$=f}finally{$&&c.errorTransformer&&($=c.errorTransformer($)),typeof $<"u"&&y.error($),y.end()}}async function I(E,v,y,l,c,w){P(w);const $=await E.open(v,{create:!1});try{P(w);let f=0,u=0,h=c&&typeof c.length=="number"?c.length:void 0,g=R.$Je.alloc(Math.min(c.bufferSize,typeof h=="number"?h:c.bufferSize)),m=c&&typeof c.position=="number"?c.position:0,t=0;do u=await E.read($,m,g.buffer,t,g.byteLength-t),m+=u,t+=u,f+=u,typeof h=="number"&&(h-=u),t===g.byteLength&&(await y.write(l(g)),g=R.$Je.alloc(Math.min(c.bufferSize,typeof h=="number"?h:c.bufferSize)),t=0);while(u>0&&(typeof h!="number"||h>0)&&P(w)&&d(f,c));if(t>0){let r=t;typeof h=="number"&&(r=Math.min(t,h)),y.write(l(g.slice(0,r)))}}catch(f){throw(0,j.$il)(f)}finally{await E.close($)}}function P(E){if(E.isCancellationRequested)throw(0,L.$6)();return!0}function d(E,v){if(typeof v?.limits?.size=="number"&&E>v.limits.size)throw(0,j.$hl)((0,A.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[46],he([0,1,91,2,14,5,8,12]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0,e.$Pq=P,e.$Qq=d,e.$Uq=l,e.$Vq=c,e.$Wq=w,e.$Xq=$,e.$Yq=u,e.$Zq=h;function P(g){return typeof g.correlationId=="number"}function d(g){return g.recursive===!0}class E extends L.$Uc{static{this.a=3}static{this.b=10}constructor(m,t,r,s){super(),this.m=m,this.n=t,this.r=r,this.s=s,this.f=this.B(new L.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const m=new L.$Tc;this.f.value=m,this.c=this.t(m),this.c.setVerboseLogging(this.r),m.add(this.c.onDidChangeFile(t=>this.m(t))),m.add(this.c.onDidLogMessage(t=>this.n(t))),m.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(m,t){if(this.s.restartOnError&&this.g?.length)if(t){const r=this.h.get(t.path)??0;r<E.a?(this.z(`restarting watcher from error in watch request (retrying request): ${m} (${JSON.stringify(t)})`),this.h.set(t.path,r+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${m} (${JSON.stringify(t)})`),this.y(this.g.filter(s=>s.path!==t.path)))}else this.j<E.b?(this.z(`restarting watcher after unknown global error: ${m}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${m}`);else this.z(m)}y(m){this.u(),this.watch(m)}async watch(m){this.g=m,await this.c?.watch(m)}async setVerboseLogging(m){this.r=m,await this.c?.setVerboseLogging(m)}z(m){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${m}`})}C(m){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${m}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Rq=E;class v extends E{constructor(m,t,r){super(m,t,r,{type:"node.js",restartOnError:!1})}}e.$Sq=v;class y extends E{constructor(m,t,r){super(m,t,r,{type:"universal",restartOnError:!0})}}e.$Tq=y;function l(g){return g.map(m=>({type:m.type,resource:D.URI.revive(m.resource),cId:m.cId}))}function c(g){const m=new f;for(const t of g)m.processEvent(t);return m.coalesce()}function w(g,m){return typeof m=="string"&&!m.startsWith(R.$qk)&&!(0,A.$ic)(m)?{base:g,pattern:m}:m}function $(g,m){const t=[];for(const r of m)t.push((0,R.$uk)(w(g,r)));return t}class f{constructor(){this.a=new Set,this.b=new Map}c(m){return j.$k?m.resource.fsPath:m.resource.fsPath.toLowerCase()}processEvent(m){const t=this.b.get(this.c(m));let r=!1;if(t){const s=t.type,n=m.type;t.resource.fsPath!==m.resource.fsPath&&(m.type===2||m.type===1)?r=!0:s===1&&n===2?(this.b.delete(this.c(m)),this.a.delete(t)):s===2&&n===1?t.type=0:s===1&&n===0||(t.type=n)}else r=!0;r&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?(m.push(r),!1):!0).sort((r,s)=>r.resource.fsPath.length-s.resource.fsPath.length).filter(r=>t.some(s=>(0,I.$ol)(r.resource.fsPath,s,!j.$k))?!1:(t.push(r.resource.fsPath),!0)).concat(m)}}function u(g,m){if(typeof m=="number")switch(g.type){case 1:return(m&4)===0;case 2:return(m&8)===0;case 0:return(m&2)===0}return!1}function h(g){if(typeof g=="number"){const m=[];return g&4&&m.push("Added"),g&8&&m.push("Deleted"),g&2&&m.push("Updated"),m.length===0?"<all>":`[${m.join(", ")}]`}return"<none>"}}),define(le[197],he([0,1,15,38,7,3,2,50,32,12,46]),function(se,e,R,L,A,j,D,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=e.$ZP=void 0,e.$ZP="localFilesystem";class v extends D.$Uc{constructor(l,c){super(),this.a=l,this.b=c,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$he),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$he),this.onDidWatchError=this.g.event,this.h=(0,P.$Wg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,c){const{buffer:w}=await this.a.call("readFile",[l,c]);return w}readFileStream(l,c,w){const $=(0,I.$xe)(u=>R.$Je.concat(u.map(h=>R.$Je.wrap(h))).buffer),f=new D.$Tc;return f.add(this.a.listen("readFileStream",[l,c])(u=>{if(u instanceof R.$Je)$.write(u.buffer);else{if(u==="end")$.end();else{let h;if(u instanceof Error)h=u;else{const g=u;h=(0,d.$hl)(g.message??(0,L.$lj)(g),g.code??d.FileSystemProviderErrorCode.Unknown)}$.error(h),$.end()}f.dispose()}})),f.add(w.onCancellationRequested(()=>{$.error((0,A.$6)()),$.end(),f.dispose()})),$}writeFile(l,c,w){return this.a.call("writeFile",[l,R.$Je.wrap(c),w])}open(l,c){return this.a.call("open",[l,c])}close(l){return this.a.call("close",[l])}async read(l,c,w,$,f){const[u,h]=await this.a.call("read",[l,c,f]);return w.set(u.buffer.slice(0,h),$),h}write(l,c,w,$,f){return this.a.call("write",[l,c,R.$Je.wrap(w),$,f])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,c){return this.a.call("delete",[l,c])}rename(l,c,w){return this.a.call("rename",[l,c,w])}copy(l,c,w){return this.a.call("copy",[l,c,w])}cloneFile(l,c){return this.a.call("cloneFile",[l,c])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const c=l;this.f.fire((0,E.$Uq)(c))}else{const c=l;this.g.fire(c)}}))}watch(l,c){const w=(0,P.$Wg)();return this.a.call("watch",[this.h,w,l,c]),(0,D.$Sc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$1P=v}),define(le[198],he([0,1,41,2,46,3,8,6]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class P extends L.$Uc{constructor(){super(),this.a=this.B(new j.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new j.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new j.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new L.$4c),this.m=new Set,this.n=5007,this.r=new I.$Xh,this.P=!1,this.B(this.f(E=>this.s(E)))}s(E){this.t(E)&&this.w(E)}t(E){return(0,A.$Pq)(E)}async watch(E){this.r.isSettled||this.r.complete(),this.r=new I.$Xh;try{this.h.clear(),this.g.clear();for(const v of E)this.t(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(E=>!this.j.has(E.correlationId))])}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async w(E){if(this.j.has(E.correlationId))return;const v=new L.$Tc;this.j.set(E.correlationId,v),await this.r.p,!v.isDisposed&&(this.z(E,v),this.u())}y(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.u()}z(E,v){this.C(E,v)?(this.N(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.D(E,v),this.m.add(E.correlationId))}C(E,v){const y=this.M?.subscribe(E.path,(l,c)=>{v.isDisposed||(l?this.z(E,v):c?.type===1&&this.F(E))});return y?(v.add(y),!0):!1}D(E,v){let y=!1;const l=(c,w)=>{if(v.isDisposed)return;const $=this.G(c),f=this.G(w),u=y;y=$,!$&&(f||u)&&this.F(E)};this.N(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,R.watchFile)(E.path,{persistent:!1,interval:this.n},l)}catch(c){this.O(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}v.add((0,L.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,R.unwatchFile)(E.path,l)}catch(c){this.O(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}F(E){this.N(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const v={resource:D.URI.file(E.path),type:1,cId:E.correlationId};this.a.fire([v]),this.H(v,E),this.y(E)}G(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(E,v){if(this.P){const y=` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.I(y,v)}}I(E,v){this.P&&this.N(`${E}${typeof v.correlationId=="number"?` <${v.correlationId}> `:""}`)}J(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,A.$Zq)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.P=E}}e.$9q=P}),define(le[199],he([0,1,41,6,26,40,2,88,14,5,21,8,150,31,46]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0,e.$cr=$;class w extends D.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(u,h,g,m,t,r){super(),this.s=u,this.t=h,this.u=g,this.w=m,this.y=t,this.z=r,this.c=this.B(new L.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new L.$Oh(s=>this.M(s),w.b)),this.g=(0,c.$Xq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$Xq)(this.s.path,this.s.includes):void 0,this.j=(0,c.$Pq)(this.s)?this.s.filter:void 0,this.m=new A.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const u=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const h=await l.Promises.stat(u);if(this.m.token.isCancellationRequested)return;this.B(await this.G(u,h.isDirectory()))}catch(u){u.code!=="ENOENT"?this.O(u):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${u})`),this.D()}}D(){this.r=!0,this.w?.()}async F(u){let h=u.path;try{h=await l.Promises.realpath(u.path),u.path===h&&(h=await(0,y.$$q)(u.path,this.m.token)??u.path),u.path!==h&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${h})`)}catch{}return h}async G(u,h){const g=new D.$Tc;return this.H(u,h,g)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(u,h,g)),g}H(u,h,g){if(h)return!1;const m=v.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,s)=>{if(!g.isDisposed)if(r){const n=await this.G(u,h);g.isDisposed?n.dispose():g.add(n)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:m,type:s.type,cId:this.s.correlationId},!0)});return t?(g.add(t),!0):!1}async I(u,h,g){if(d.$j&&(0,j.$zg)(u,"/Volumes/",!0)){this.O(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const m=new A.$se(this.m.token);g.add((0,D.$Sc)(()=>m.dispose(!0)));const t=new D.$Tc;g.add(t);try{const r=v.URI.file(this.s.path),s=(0,P.$nc)(u),n=(0,R.watch)(u);t.add((0,D.$Sc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${u}'`);const i=new Set;if(h)try{for(const a of await l.Promises.readdir(u))i.add(a)}catch(a){this.O(a)}if(m.token.isCancellationRequested)return;const o=new Map;t.add((0,D.$Sc)(()=>{for(const[,a]of o)a.dispose();o.clear()})),n.on("error",(a,p)=>{m.token.isCancellationRequested||(this.O(`Failed to watch ${u} for changes using fs.watch() (${a}, ${p})`),this.D())}),n.on("change",(a,p)=>{if(m.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${a}"] ${p}`);let S="";if(p&&(S=p.toString(),d.$j&&(S=(0,I.$fm)(S))),!(!S||a!=="change"&&a!=="rename"))if(h)if(a==="rename"){o.get(S)?.dispose();const b=setTimeout(async()=>{if(o.delete(S),S===s&&!await l.Promises.exists(u)){this.J(r);return}if(m.token.isCancellationRequested)return;const k=await this.N((0,P.$jc)(u,S));if(m.token.isCancellationRequested)return;let C;k?i.has(S)?C=0:(C=1,i.add(S)):(i.delete(S),C=2),this.L({resource:(0,E.$bh)(r,S),type:C,cId:this.s.correlationId})},w.a);o.set(S,(0,D.$Sc)(()=>clearTimeout(b)))}else{let b;i.has(S)?b=0:(b=1,i.add(S)),this.L({resource:(0,E.$bh)(r,S),type:b,cId:this.s.correlationId})}else if(a==="rename"||S!==s){const b=setTimeout(async()=>{const k=await l.Promises.exists(u);m.token.isCancellationRequested||(k?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(u,!1))):this.J(r))},w.a);t.clear(),t.add((0,D.$Sc)(()=>clearTimeout(b)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){m.token.isCancellationRequested||this.O(`Failed to watch ${u} for changes using fs.watch() (${r.toString()})`),this.D()}}J(u){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:u,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(u,h=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!h&&this.g.some(g=>g(u.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${u.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(g=>g(u.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}M(u){const h=(0,c.$Vq)(u),g=[];for(const t of h){if((0,c.$Yq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}g.push(t)}if(g.length===0)return;if(this.z)for(const t of g)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(g)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(u){if(d.$k)return l.Promises.exists(u);try{const h=(0,P.$nc)(u);return(await l.Promises.readdir((0,P.$mc)(u))).some(m=>m===h)}catch(h){return this.Q(h),!1}}setVerboseLogging(u){this.z=u}O(u){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}P(u){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}Q(u){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}R(u){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${u}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$br=w;async function $(f,u,h,g,m=512){const t=await l.Promises.open(f,"r"),r=Buffer.allocUnsafe(m),s=new A.$se(g);let n,i=!1;const o={path:f,excludes:[],recursive:!1},a=new w(o,void 0,p=>{(async()=>{for(const{type:S}of p)if(S===0){if(i)return;i=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:b}=await l.Promises.read(t,r,0,m,null);if(!b||s.token.isCancellationRequested)break;u(r.slice(0,b))}}catch(b){n=new Error(b),s.dispose(!0)}finally{i=!1}}})()});return await a.ready,h(),new Promise((p,S)=>{s.token.onCancellationRequested(async()=>{a.dispose();try{await l.Promises.close(t)}catch(b){n=new Error(b)}n?S(n):p()})})}}),define(le[200],he([0,1,3,91,198,5,199,40]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class P extends A.$9q{constructor(E){super(),this.M=E,this.onDidError=R.Event.None,this.watchers=new Set}async L(E){E=this.X(E);const v=[],y=new Set(Array.from(this.watchers));for(const l of E){const c=this.S(l);c&&(0,L.$yk)(c.request.excludes,l.excludes)&&(0,L.$yk)(c.request.includes,l.includes)?y.delete(c):v.push(l)}v.length&&this.N(`Request to start watching: ${v.map(l=>this.J(l)).join(",")}`),y.size&&this.N(`Request to stop watching: ${Array.from(y).map(l=>this.J(l.request)).join(",")}`);for(const l of y)this.W(l);for(const l of v)this.U(l)}S(E){for(const v of this.watchers)if(typeof E.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===E.correlationId)return v}else if((0,I.$yg)(v.request.path,E.path,!j.$k))return v}U(E){const v=new D.$br(E,this.M,l=>this.a.fire(l),()=>this.c.fire(E),l=>this.b.fire(l),this.P),y={request:E,instance:v};this.watchers.add(y)}async stop(){await super.stop();for(const E of this.watchers)this.W(E)}W(E){this.N("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}X(E){const v=new Map;for(const y of E){const l=j.$k?y.path:y.path.toLowerCase();let c=v.get(y.correlationId);c||(c=new Map,v.set(y.correlationId,c)),c.has(l)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(y)}`),c.set(l,y)}return Array.from(v.values()).map(y=>Array.from(y.values())).flat()}async setVerboseLogging(E){super.setVerboseLogging(E);for(const v of this.watchers)v.instance.setVerboseLogging(E)}N(E,v){this.P&&this.b.fire({type:"trace",message:this.$(E,v)})}O(E){this.b.fire({type:"warn",message:this.$(E)})}$(E,v){return v?`[File Watcher (node.js)] ${E} (${this.J(v.request)})`:`[File Watcher (node.js)] ${E}`}}e.$dr=P}),define(le[201],he([0,1,46,200]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;class A extends R.$Sq{constructor(D,I,P){super(D,I,P),this.u()}t(D){return D.add(new L.$dr(void 0))}}e.$er=A}),define(le[202],he([0,1,23,42,93,46]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class D extends j.$Tq{constructor(P,d,E){super(P,d,E),this.u()}t(P){const d=P.add(new A.$7q(R.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(d.onDidProcessExit(({code:E,signal:v})=>this.w(`terminated by itself with code ${E}, signal: ${v} (ETERM)`))),L.ProxyChannel.toService((0,L.$hi)(d.getChannel("watcher")))}}e.$8q=D}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class R{constructor(...A){this.a=new Map;for(const[j,D]of A)this.set(j,D)}set(A,j){const D=this.a.get(A);return this.a.set(A,j),D}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$yi=R}),define(le[203],he([0,1,6,7,2,72,193,4,74,87]),function(se,e,R,L,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;const E=!1;class v extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class y{constructor($=new P.$yi,f=!1,u,h=E){this.i=$,this.j=f,this.k=u,this.l=h,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$zi,this),this._globalGraph=h?u?._globalGraph??new D.$hr(g=>g):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Pc)(this.h),this.h.clear();for(const $ of this.g)(0,A.$Oc)($)&&$.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild($,f){this.m();const u=new class extends y{dispose(){this.h.delete(u),super.dispose()}}($,this.j,this,this.l);return this.h.add(u),f?.add(u),u}invokeFunction($,...f){this.m();const u=c.traceInvocation(this.l,$);let h=!1;try{return $({get:m=>{if(h)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(m,u);if(!t)throw new Error(`[invokeFunction] unknown service '${m}'`);return t}},...f)}finally{h=!0,u.stop()}}createInstance($,...f){this.m();let u,h;return $ instanceof j.$xi?(u=c.traceCreation(this.l,$.ctor),h=this.o($.ctor,$.staticArguments.concat(f),u)):(u=c.traceCreation(this.l,$),h=this.o($,f,u)),u.stop(),h}o($,f=[],u){const h=I._util.getServiceDependencies($).sort((t,r)=>t.index-r.index),g=[];for(const t of h){const r=this.s(t.id,u);r||this.y(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(r)}const m=h.length>0?h[0].index:f.length;if(f.length!==m){console.trace(`[createInstance] First service dependency of ${$.name} at position ${m+1} conflicts with ${f.length} static arguments`);const t=m-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,m)}return Reflect.construct($,f.concat(g))}q($,f){if(this.i.get($)instanceof j.$xi)this.i.set($,f);else if(this.k)this.k.q($,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r($){const f=this.i.get($);return!f&&this.k?this.k.r($):f}s($,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const u=this.r($);return u instanceof j.$xi?this.u($,u,f.branch($,!0)):(f.branch($,!1),u)}u($,f,u){if(this.t.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.t.add($);try{return this.v($,f,u)}finally{this.t.delete($)}}v($,f,u){const h=new D.$hr(t=>t.id.toString());let g=0;const m=[{id:$,desc:f,_trace:u}];for(;m.length;){const t=m.pop();if(h.lookupOrInsertNode(t),g++>1e3)throw new v(h);for(const r of I._util.getServiceDependencies(t.desc.ctor)){const s=this.r(r.id);if(s||this.y(`[createInstance] ${$} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof j.$xi){const n={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};h.insertEdge(t,n),m.push(n)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new v(h);break}for(const{data:r}of t){if(this.r(r.id)instanceof j.$xi){const n=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,n)}h.removeNode(r)}}return this.r($)}w($,f,u=[],h,g){if(this.i.get($)instanceof j.$xi)return this.x($,f,u,h,g,this.g);if(this.k)return this.k.w($,f,u,h,g);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x($,f,u=[],h,g,m){if(h){const t=new y(void 0,this.j,this,this.l);t.c=String($);const r=new Map,s=new R.$Th(()=>{const n=t.o(f,u,g);for(const[i,o]of r){const a=n[i];if(typeof a=="function")for(const p of o)p.disposable=a.apply(n,p.listener)}return r.clear(),m.add(n),n});return new Proxy(Object.create(null),{get(n,i){if(!s.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let p=r.get(i);return p||(p=new d.$5c,r.set(i,p)),(b,k,C)=>{if(s.isInitialized)return s.value[i](b,k,C);{const O={listener:[b,k,C],disposable:void 0},M=p.push(O);return(0,A.$Sc)(()=>{M(),O.disposable?.dispose()})}}}if(i in n)return n[i];const o=s.value;let a=o[i];return typeof a!="function"||(a=a.bind(o),n[i]=a),a},set(n,i,o){return s.value[i]=o,!0},getPrototypeOf(n){return f.prototype}})}else{const t=this.o(f,u,g);return m.add(t),t}}y($,f){if(f&&console.warn($),this.j)throw new Error($)}}e.$ir=y;var l;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(l||(l={}));class c{static{this.all=new Set}static{this.c=new class extends c{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,f){return $?new c(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c.c}static traceCreation($,f){return $?new c(1,f.name):c.c}static{this.f=0}constructor($,f){this.type=$,this.name=f,this.g=Date.now(),this.h=[]}branch($,f){const u=new c(3,$.toString());return this.h.push([$,f,u]),u}stop(){const $=Date.now()-this.g;c.f+=$;let f=!1;function u(g,m){const t=[],r=new Array(g+1).join("	");for(const[s,n,i]of m.h)if(n&&i){f=!0,t.push(`${r}CREATES -> ${s}`);const o=u(g+1,i);o&&t.push(o)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${c.f.toFixed(2)}ms)`];($>2||f)&&c.all.add(h.join(`
`))}}e.$jr=c}),define(le[56],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=e.$Pec=void 0,e.$Pec=(0,R.$Ai)("mainProcessService");class L{constructor(j,D){this.a=j,this.b=D}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,D){this.a.registerChannel(j,D)}}e.$Qec=L}),define(le[75],he([0,1,26,2,5,169,28,4]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=void 0,e.$Wr=P;function P(E){return E.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Xr=(0,I.$Ai)("languagePackService");let d=class extends L.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new R.$se;setTimeout(()=>v.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const c=y.firstPage.filter(w=>w.properties.localizedLanguages?.length&&w.tags.some($=>$.startsWith("lp-"))).map(w=>{const $=w.properties.localizedLanguages?.[0],f=P(w);return{...this.f(f,$,w),extensionId:w.identifier.id,galleryExtension:w}});return c.push(this.f("en","English")),c}f(v,y,l){const c=y??v;let w;if(c!==v&&(w=`(${v})`),v.toLowerCase()===A.$w.toLowerCase()&&(w??="",w+=(0,j.localize)(0,null)),l?.installCount){w??="";const $=l.installCount;let f;$>1e6?f=`${Math.floor($/1e5)/10}M`:$>1e3?f=`${Math.floor($/1e3)}K`:f=String($),w+=` $(cloud-download) ${f}`}return{id:v,label:c,description:w}}};e.$Yr=d,e.$Yr=d=ve([Y(0,D.$_o)],d)}),define(le[204],he([0,1,2,75]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;let A=class extends R.$Uc{constructor(D){super(),this.a=D,this.b()}b(){this.a.update()}};e.$efc=A,e.$efc=A=ve([Y(0,L.$Xr)],A)}),define(le[9],he([0,1,170,38,3,54,2,34,5,21,13,8,94,4]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=w,e.log=f,e.$ik=a,e.$jk=p,e.$kk=S,e.$lk=b,e.$7j=(0,l.$Ai)("logService"),e.$8j=(0,l.$Ai)("loggerService");function c(){return new Date().toISOString()}function w(k){return(0,E.$eg)(k)}var $;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})($||(e.LogLevel=$={})),e.$0j=$.Info;function f(k,C,O){switch(C){case $.Trace:k.trace(O);break;case $.Debug:k.debug(O);break;case $.Info:k.info(O);break;case $.Warning:k.warn(O);break;case $.Error:k.error(O);break;case $.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function u(k,C=!1){let O="";for(let M=0;M<k.length;M++){let T=k[M];if(T instanceof Error&&(T=(0,L.$lj)(T,C)),typeof T=="object")try{T=JSON.stringify(T)}catch{}O+=(M>0?" ":"")+T}return O}class h extends D.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new A.$he),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==$.Off&&this.b<=C}}e.$_j=h;class g extends h{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...O){this.f($.Trace)&&this.g($.Trace,u([C,...O],!0))}debug(C,...O){this.f($.Debug)&&this.g($.Debug,u([C,...O]))}info(C,...O){this.f($.Info)&&this.g($.Info,u([C,...O]))}warn(C,...O){this.f($.Warning)&&this.g($.Warning,u([C,...O]))}error(C,...O){if(this.f($.Error))if(C instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=C.stack,this.g($.Error,u(M))}else this.g($.Error,u([C,...O]))}flush(){}}e.$ak=g;class m extends h{constructor(C=e.$0j){super(),this.setLevel(C),this.g=!P.$i}trace(C,...O){this.f($.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,C,...O):console.log(`[main ${c()}]`,C,...O))}debug(C,...O){this.f($.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,C,...O):console.log(`[main ${c()}]`,C,...O))}info(C,...O){this.f($.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,C,...O):console.log(`[main ${c()}]`,C,...O))}warn(C,...O){this.f($.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,C,...O):console.warn(`[main ${c()}]`,C,...O))}error(C,...O){this.f($.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,C,...O):console.error(`[main ${c()}]`,C,...O))}flush(){}}e.$bk=m;class t extends h{constructor(C=e.$0j,O=!0){super(),this.g=O,this.setLevel(C)}trace(C,...O){this.f($.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...O):console.log(C,...O))}debug(C,...O){this.f($.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...O):console.log(C,...O))}info(C,...O){this.f($.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...O):console.log(C,...O))}warn(C,...O){this.f($.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...O):console.log(C,...O))}error(C,...O){this.f($.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...O):console.error(C,...O))}flush(){}}e.$ck=t;class r extends h{constructor(C,O=e.$0j){super(),this.g=C,this.setLevel(O)}trace(C,...O){this.f($.Trace)&&this.g.log($.Trace,[this.h(C),...O])}debug(C,...O){this.f($.Debug)&&this.g.log($.Debug,[this.h(C),...O])}info(C,...O){this.f($.Info)&&this.g.log($.Info,[this.h(C),...O])}warn(C,...O){this.f($.Warning)&&this.g.log($.Warning,[this.h(C),...O])}error(C,...O){this.f($.Error)&&this.g.log($.Error,[this.h(C),...O])}h(C){return typeof C=="string"?C:(0,L.$lj)(C,this.f($.Trace))}flush(){}}e.$dk=r;class s extends h{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const O of this.g)O.setLevel(C);super.setLevel(C)}trace(C,...O){for(const M of this.g)M.trace(C,...O)}debug(C,...O){for(const M of this.g)M.debug(C,...O)}info(C,...O){for(const M of this.g)M.info(C,...O)}warn(C,...O){for(const M of this.g)M.warn(C,...O)}error(C,...O){for(const M of this.g)M.error(C,...O)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ek=s;class n extends D.$Uc{constructor(C,O,M){if(super(),this.h=C,this.j=O,this.b=new I.$Ac,this.c=this.B(new A.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$he),this.onDidChangeVisibility=this.g.event,M)for(const T of M)this.b.set(T.resource,{logger:void 0,info:T})}m(C){return(0,E.$ag)(C)?[...this.b.values()].find(O=>O.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,O){const M=this.n(C),T=(0,E.$ag)(C)?C:O?.id??(0,j.$oj)(M.toString()).toString(16);let F=this.b.get(M)?.logger;const K=O?.logLevel==="always"?$.Trace:O?.logLevel;F||(F=this.s(M,K??this.getLogLevel(M)??this.h,{...O,id:T}));const J={logger:F,info:{resource:M,id:T,logLevel:K,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(J.info),this.b.set(M,J),F}n(C){return(0,E.$ag)(C)?(0,d.$bh)(this.j,`${C}.log`):C}setLogLevel(C,O){if(v.URI.isUri(C)){const M=C,T=O,F=this.b.get(M);F&&T!==F.info.logLevel&&(F.info.logLevel=T===this.h?void 0:T,F.logger?.setLevel(T),this.b.set(F.info.resource,F),this.f.fire([M,T]))}else{this.h=C;for(const[M,T]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,O){const M=this.m(C);M&&O!==!M.info.hidden&&(M.info.hidden=!O,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,O]))}getLogLevel(C){let O;return C&&(O=this.b.get(C)?.info.logLevel),O??this.h}registerLogger(C){const O=this.b.get(C.resource);O?O.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const O=this.b.get(C);O&&(O.logger&&O.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=n;class i{constructor(){this.onDidChangeLogLevel=new A.$he().event}setLevel(C){}getLevel(){return $.Info}trace(C,...O){}debug(C,...O){}info(C,...O){}warn(C,...O){}error(C,...O){}critical(C,...O){}dispose(){}flush(){}}e.$gk=i;class o extends i{}e.$hk=o;function a(k){if(k.verbose)return $.Trace;if(typeof k.logLevel=="string"){const C=b(k.logLevel.toLowerCase());if(C!==void 0)return C}return e.$0j}function p(k){switch(k){case $.Trace:return"trace";case $.Debug:return"debug";case $.Info:return"info";case $.Warning:return"warn";case $.Error:return"error";case $.Off:return"off"}}function S(k){switch(k){case $.Trace:return{original:"Trace",value:R.localize(0,null)};case $.Debug:return{original:"Debug",value:R.localize(1,null)};case $.Info:return{original:"Info",value:R.localize(2,null)};case $.Warning:return{original:"Warning",value:R.localize(3,null)};case $.Error:return{original:"Error",value:R.localize(4,null)};case $.Off:return{original:"Off",value:R.localize(5,null)}}}function b(k){switch(k){case"trace":return $.Trace;case"debug":return $.Debug;case"info":return $.Info;case"warn":return $.Warning;case"error":return $.Error;case"critical":return $.Error;case"off":return $.Off}}e.$mk=new y.$Rj("logLevel",p($.Info))}),define(le[205],he([0,1,6,7,2,23,14,21,31,16,9]),function(se,e,R,L,A,j,D,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;let v=class extends A.$Uc{constructor(l,c){super(),this.a=l,this.b=c,this.B(new R.$Mh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,I.$$g)(this.a.logsHome),c=(0,I.$ah)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,f=(await P.Promises.readdir(c)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==l),u=f.slice(0,Math.max(0,f.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(h=>P.Promises.rm((0,D.$jc)(c,h)))))}catch(l){(0,L.$1)(l)}}};e.$ffc=v,e.$ffc=v=ve([Y(0,d.$Hi),Y(1,E.$7j)],v)}),define(le[206],he([0,1,17,6,7,3,40,2,14,46,9]),function(se,e,R,L,A,j,D,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;class v extends I.$Uc{constructor(l,c){super(),this.a=l,this.b=c,this.c=this.B(new j.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$yh(0)),this.w=[],this.y=this.B(new L.$yh(0))}watch(l,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(l,c):this.z(l,c)}n(l,c){const w={path:this.J(l),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},$=(0,R.$Tb)(this.j,w);return this.r(),(0,I.$Sc)(()=>{$(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(l=>(0,A.$1)(l))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,d.$Uq)(c)),c=>this.G(c),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const l=this.b?.watcher?.recursive?.usePolling;if(l===!0)for(const c of this.j)(0,d.$Qq)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(l))for(const c of this.j)(0,d.$Qq)(c)&&l.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(l,c){const w={path:this.J(l),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},$=(0,R.$Tb)(this.w,w);return this.C(),(0,I.$Sc)(()=>{$(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(l=>(0,A.$1)(l))}D(){return this.u||(this.u=this.B(this.F(l=>this.c.fire((0,d.$Uq)(l)),l=>this.G(l),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(l){l.type==="error"&&this.g.fire(l.message),this.H(l)}H(l){this.a[l.type](l.message)}I(l){return(0,P.$hc)(l.fsPath)}J(l){const c=this.I(l);return(0,D.$Cg)(c)}}e.$1q=v}),define(le[207],he([0,1,17,6,15,26,3,54,61,2,51,23,99,21,50,165,12,98,9,7]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let m=class extends d.$Uc{static{g=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new D.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$he),this.Y=this.B(new D.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new L.$Jh)}registerProvider(r,s){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${r}`);const n=new d.$Tc;return this.h.set(r,s),this.c.fire({added:!0,scheme:r,provider:s}),n.add(s.onDidChangeFile(i=>{const o=new $.$nl(i,!this.S(s));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof s.onDidWatchError=="function"&&n.add(s.onDidWatchError(i=>this.Z.fire(new Error(i)))),n.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:r}))),(0,d.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:s}),this.h.delete(r),(0,d.$Pc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const s=[];this.f.fire({scheme:r,join(n){s.push(n)}}),!this.h.has(r)&&await L.Promises.settled(s)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,s){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&s)}listCapabilities(){return P.Iterable.map(this.h,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async j(r){if(!(0,l.$fh)(r))throw new $.$pl((0,w.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const s=this.h.get(r.scheme);if(!s){const n=new h.$bb;throw n.message=(0,w.localize)(1,null,r.toString()),n}return s}async m(r){const s=await this.j(r);if((0,$.$al)(s)||(0,$.$0k)(s)||(0,$.$bl)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const s=await this.j(r);if((0,$.$al)(s)||(0,$.$0k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.s(r,s)}catch(n){throw(0,$.$kl)(n)===$.FileSystemProviderErrorCode.FileNotFound?new $.$pl((0,w.localize)(2,null,this.sb(r)),1):(0,$.$il)(n)}}async s(r,s){const n=await this.j(r),i=this.S(n),o=s?.resolveTo,a=s?.resolveSingleChildDescendants,p=s?.resolveMetadata,S=await n.stat(r);let b;return this.t(n,r,S,void 0,!!p,(k,C)=>(b||(b=E.$Gi.forUris(()=>!i),b.set(r,!0),o&&b.fill(!0,o)),b.get(k.resource)||b.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&a?C===1:!1))}async t(r,s,n,i,o,a){const{providerExtUri:p}=this.R(r),S={resource:s,name:p.basename(s),isFile:(n.type&$.FileType.File)!==0,isDirectory:(n.type&$.FileType.Directory)!==0,isSymbolicLink:(n.type&$.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&$.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Al)({mtime:n.mtime,size:n.size}),children:void 0};if(S.isDirectory&&a(S,i)){try{const b=await r.readdir(s),k=await L.Promises.settled(b.map(async([C,O])=>{try{const M=p.joinPath(s,C),T=o?await r.stat(M):{type:O};return await this.t(r,M,T,b.length,o,a)}catch(M){return this.b.trace(M),null}}));S.children=(0,R.$Hb)(k)}catch(b){this.b.trace(b),S.children=[]}return S}return S}async resolveAll(r){return L.Promises.settled(r.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const s=await this.j(r),n=await s.stat(r);return this.t(s,r,n,void 0,!0,()=>!1)}async exists(r){const s=await this.j(r);try{return!!await s.stat(r)}catch{return!1}}async canCreateFile(r,s){try{await this.u(r,s)}catch(n){return n}return!0}async u(r,s){if(!s?.overwrite&&await this.exists(r))throw new $.$pl((0,w.localize)(3,null,this.sb(r)),3,s)}async createFile(r,s=A.$Je.fromString(""),n){await this.u(r,n);const i=await this.writeFile(r,s);return this.r.fire(new $.$ml(r,0,i)),i}async writeFile(r,s,n){const i=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(i);let a=n;if((0,$.$dl)(i)&&!a?.atomic){const p=i.enforceAtomicWriteFile?.(r);p&&(a={...n,atomic:p})}try{await this.w(i,r,a)||await this.U(i,o.dirname(r));let S;if((0,$.$0k)(i)&&!(s instanceof A.$Je))if((0,c.$ve)(s)){const b=await(0,c.$Ce)(s,3);b.ended?S=A.$Je.concat(b.buffer):S=b}else S=(0,c.$ze)(s,b=>A.$Je.concat(b),3);else S=s;!(0,$.$al)(i)||(0,$.$0k)(i)&&S instanceof A.$Je||(0,$.$0k)(i)&&(0,$.$dl)(i)&&a?.atomic?await this.hb(i,r,a,S):await this.db(i,r,a,S instanceof A.$Je?(0,A.$Ue)(S):S),this.r.fire(new $.$ml(r,4))}catch(p){throw new $.$pl((0,w.localize)(4,null,this.sb(r),(0,$.$il)(p).toString()),(0,$.$ll)(p),a)}return this.resolve(r,{resolveMetadata:!0})}async w(r,s,n){const i=!!n?.unlock;if(i&&!(r.capabilities&8192))throw new Error((0,w.localize)(5,null,this.sb(s)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,w.localize)(6,null,this.sb(s)));if(!(r.capabilities&2))throw new Error((0,w.localize)(7,null,this.sb(s)));if(i)throw new Error((0,w.localize)(8,null,this.sb(s)))}let a;try{a=await r.stat(s)}catch{return}if(a.type&$.FileType.Directory)throw new $.$pl((0,w.localize)(9,null,this.sb(s)),0,n);if(this.rb(s,a),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==$.$zl&&typeof a.mtime=="number"&&typeof a.size=="number"&&n.mtime<a.mtime&&n.etag!==(0,$.$Al)({mtime:n.mtime,size:a.size}))throw new $.$pl((0,w.localize)(10,null),3,n);return a}async readFile(r,s,n){const i=await this.m(r);return s?.atomic?this.z(i,r,s,n):this.C(i,r,s,n)}async z(r,s,n,i){return new Promise((o,a)=>{this.cb.queueFor(s,async()=>{try{const p=await this.C(r,s,n,i);o(p)}catch(p){a(p)}},this.R(r).providerExtUri)})}async C(r,s,n,i){const o=await this.D(r,s,{...n,preferUnbuffered:!0},i);return{...o,value:await(0,A.$Ve)(o.value)}}async readFileStream(r,s,n){const i=await this.m(r);return this.D(i,r,s,n)}async D(r,s,n,i){const o=new j.$se(i);let a=n;(0,$.$cl)(r)&&r.enforceAtomicReadFile?.(s)&&(a={...n,atomic:!0});const p=this.J(s,a).then(b=>b,b=>{throw o.dispose(!0),b});let S;try{return typeof a?.etag=="string"&&a.etag!==$.$zl&&await p,a?.atomic&&(0,$.$cl)(r)||!((0,$.$al)(r)||(0,$.$bl)(r))||(0,$.$0k)(r)&&a?.preferUnbuffered?S=this.I(r,s,a):(0,$.$bl)(r)?S=this.G(r,s,o.token,a):S=this.H(r,s,o.token,a),S.on("end",()=>o.dispose()),S.on("error",()=>o.dispose()),{...await p,value:S}}catch(b){throw S&&await(0,c.$Ae)(S),this.F(b,s,a)}}F(r,s,n){const i=(0,w.localize)(11,null,this.sb(s),(0,$.$il)(r).toString());return r instanceof $.$rl?new $.$rl(i,r.stat,n):r instanceof $.$ql?new $.$ql(i,r.fileOperationResult,r.size,r.options):new $.$pl(i,(0,$.$ll)(r),n)}G(r,s,n,i=Object.create(null)){const o=r.readFileStream(s,i,n);return(0,c.$Ge)(o,{data:a=>a instanceof A.$Je?a:A.$Je.wrap(a),error:a=>this.F(a,s,i)},a=>A.$Je.concat(a))}H(r,s,n,i=Object.create(null)){const o=(0,A.$Ze)();return(0,f.$Nq)(r,s,o,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,s,i)},n),o}I(r,s,n){const i=(0,c.$xe)(o=>A.$Je.concat(o));return(async()=>{try{let o;n?.atomic&&(0,$.$cl)(r)?o=await r.readFile(s,{atomic:!0}):o=await r.readFile(s),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(s,o.byteLength,n),i.end(A.$Je.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async J(r,s){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new $.$pl((0,w.localize)(12,null,this.sb(r)),0,s);if(typeof s?.etag=="string"&&s.etag!==$.$zl&&s.etag===n.etag)throw new $.$rl((0,w.localize)(13,null),n,s);return this.L(r,n.size,s),n}L(r,s,n){if(typeof n?.limits?.size=="number"&&s>n.limits.size)throw new $.$ql((0,w.localize)(14,null,this.sb(r)),7,s,n)}async canMove(r,s,n){return this.M(r,s,"move",n)}async canCopy(r,s,n){return this.M(r,s,"copy",n)}async M(r,s,n,i){if(r.toString()!==s.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),a=this.qb(await this.n(s),s);await this.Q(o,r,a,s,n,i)}catch(o){return o}return!0}async move(r,s,n){const i=this.qb(await this.n(r),r),o=this.qb(await this.n(s),s),a=await this.N(i,r,o,s,"move",!!n),p=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new $.$ml(r,a==="move"?2:3,p)),p}async copy(r,s,n){const i=await this.m(r),o=this.qb(await this.n(s),s),a=await this.N(i,r,o,s,"copy",!!n),p=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new $.$ml(r,a==="copy"?3:2,p)),p}async N(r,s,n,i,o,a){if(s.toString()===i.toString())return o;const{exists:p,isSameResourceWithDifferentPathCase:S}=await this.Q(r,s,n,i,o,a);if(p&&!S&&a&&await this.del(i,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(i)),o==="copy"){if(r===n&&(0,$.$$k)(r))await r.copy(s,i,{overwrite:a});else{const b=await this.resolve(s);b.isDirectory?await this.P(r,b,n,i):await this.O(r,s,n,i)}return o}else return r===n?(await r.rename(s,i,{overwrite:a}),o):(await this.N(r,s,n,i,"copy",a),await this.del(s,{recursive:!0}),"copy")}async O(r,s,n,i){if((0,$.$al)(r)&&(0,$.$al)(n))return this.jb(r,s,n,i);if((0,$.$al)(r)&&(0,$.$0k)(n))return this.pb(r,s,n,i);if((0,$.$0k)(r)&&(0,$.$al)(n))return this.nb(r,s,n,i);if((0,$.$0k)(r)&&(0,$.$0k)(n))return this.lb(r,s,n,i)}async P(r,s,n,i){await n.mkdir(i),Array.isArray(s.children)&&await L.Promises.settled(s.children.map(async o=>{const a=this.R(n).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,a):this.O(r,o.resource,n,a)}))}async Q(r,s,n,i,o,a){let p=!1;if(r===n){const{providerExtUri:b,isPathCaseSensitive:k}=this.R(r);if(k||(p=b.isEqual(s,i)),p&&o==="copy")throw new Error((0,w.localize)(15,null,this.sb(s),this.sb(i)));if(!p&&b.isEqualOrParent(i,s))throw new Error((0,w.localize)(16,null,this.sb(s),this.sb(i)))}const S=await this.exists(i);if(S&&!p){if(!a)throw new $.$pl((0,w.localize)(17,null,this.sb(s),this.sb(i)),4);if(r===n){const{providerExtUri:b}=this.R(r);if(b.isEqualOrParent(s,i))throw new Error((0,w.localize)(18,null,this.sb(s),this.sb(i)))}}return{exists:S,isSameResourceWithDifferentPathCase:p}}R(r){const s=this.S(r);return{providerExtUri:s?l.$4g:l.$6g,isPathCaseSensitive:s}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.qb(await this.j(r),r);await this.U(s,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$ml(r,0,n)),n}async U(r,s){const n=[],{providerExtUri:i}=this.R(r);for(;!i.isEqual(s,i.dirname(s));)try{if(!((await r.stat(s)).type&$.FileType.Directory))throw new Error((0,w.localize)(19,null,this.sb(s)));break}catch(o){if((0,$.$kl)(o)!==$.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(i.basename(s)),s=i.dirname(s)}for(let o=n.length-1;o>=0;o--){s=i.joinPath(s,n[o]);try{await r.mkdir(s)}catch(a){if((0,$.$kl)(a)!==$.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(r,s){try{await this.W(r,s)}catch(n){return n}return!0}async W(r,s){const n=this.qb(await this.j(r),r),i=!!s?.useTrash;if(i&&!(n.capabilities&4096))throw new Error((0,w.localize)(20,null,this.sb(r)));const o=s?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,w.localize)(21,null,this.sb(r)));if(i&&o)throw new Error((0,w.localize)(22,null,this.sb(r)));let a;try{a=await n.stat(r)}catch{}if(a)this.rb(r,a);else throw new $.$pl((0,w.localize)(23,null,this.sb(r)),1);if(!!!s?.recursive){const S=await this.resolve(r);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,w.localize)(24,null,this.sb(r)))}return n}async del(r,s){const n=await this.W(r,s);let i=s;if((0,$.$el)(n)&&!i?.atomic){const S=n.enforceAtomicDelete?.(r);S&&(i={...s,atomic:S})}const o=!!i?.useTrash,a=!!i?.recursive,p=i?.atomic??!1;await n.delete(r,{recursive:a,useTrash:o,atomic:p}),this.r.fire(new $.$ml(r,1))}async cloneFile(r,s){const n=await this.j(r),i=this.qb(await this.n(s),s);if(!(n===i&&this.R(n).providerExtUri.isEqual(r,s)))return n===i&&(0,$.$_k)(n)?n.cloneFile(r,s):(await this.U(i,this.R(i).providerExtUri.dirname(s)),n===i&&(0,$.$$k)(n)?this.cb.queueFor(r,()=>n.copy(r,s,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,i,s),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,s){return this.watch(r,{...s,correlationId:g.ab++})}watch(r,s={recursive:!1,excludes:[]}){const n=new d.$Tc;let i=!1,o=()=>{i=!0};n.add((0,d.$Sc)(()=>o())),(async()=>{try{const p=await this.bb(r,s);i?(0,d.$Pc)(p):o=()=>(0,d.$Pc)(p)}catch(p){this.b.error(p)}})();const a=s.correlationId;if(typeof a=="number"){const p=n.add(new D.$he);return n.add(this.X.event(b=>{b.correlates(a)&&p.fire(b)})),{onDidChange:p.event,dispose:()=>n.dispose()}}return n}async bb(r,s){const n=await this.j(r),i=(0,I.$oj)([this.R(n).providerExtUri.getComparisonKey(r),s]);let o=this.$.get(i);return o||(o={count:0,disposable:n.watch(r,s)},this.$.set(i,o)),o.count+=1,(0,d.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,d.$Pc)(o.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,d.$Pc)(r.disposable);this.$.clear()}async db(r,s,n,i){return this.cb.queueFor(s,async()=>{const o=await r.open(s,{create:!0,unlock:n?.unlock??!1});try{(0,c.$ve)(i)||(0,c.$we)(i)?await this.eb(r,o,i):await this.fb(r,o,i)}catch(a){throw(0,$.$il)(a)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,s,n){let i=0,o;if((0,c.$we)(n)){if(n.buffer.length>0){const a=A.$Je.concat(n.buffer);await this.gb(r,s,a,a.byteLength,i,0),i+=a.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((a,p)=>{(0,c.$Be)(o,{onData:async S=>{o.pause();try{await this.gb(r,s,S,S.byteLength,i,0)}catch(b){return p(b)}i+=S.byteLength,setTimeout(()=>o.resume())},onError:S=>p(S),onEnd:()=>a()})})}async fb(r,s,n){let i=0,o;for(;(o=n.read())!==null;)await this.gb(r,s,o,o.byteLength,i,0),i+=o.byteLength}async gb(r,s,n,i,o,a){let p=0;for(;p<i;){const S=await r.write(s,o+p,n.buffer,a+p,i-p);p+=S}}async hb(r,s,n,i){return this.cb.queueFor(s,()=>this.ib(r,s,n,i),this.R(r).providerExtUri)}async ib(r,s,n,i){let o;i instanceof A.$Je?o=i:(0,c.$ve)(i)?o=await(0,A.$Ve)(i):(0,c.$we)(i)?o=await(0,A.$We)(i):o=(0,A.$Te)(i),await r.writeFile(s,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,s,n,i){return this.cb.queueFor(i,()=>this.kb(r,s,n,i),this.R(n).providerExtUri)}async kb(r,s,n,i){let o,a;try{o=await r.open(s,{create:!1}),a=await n.open(i,{create:!0,unlock:!1});const p=A.$Je.alloc(this.a);let S=0,b=0,k=0;do k=await r.read(o,S,p.buffer,b,p.byteLength-b),await this.gb(n,a,p,k,S,b),S+=k,b+=k,b===p.byteLength&&(b=0);while(k>0)}catch(p){throw(0,$.$il)(p)}finally{await L.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof a=="number"?n.close(a):Promise.resolve()])}}async lb(r,s,n,i){return this.cb.queueFor(i,()=>this.mb(r,s,n,i),this.R(n).providerExtUri)}async mb(r,s,n,i){return n.writeFile(i,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,s,n,i){return this.cb.queueFor(i,()=>this.ob(r,s,n,i),this.R(n).providerExtUri)}async ob(r,s,n,i){const o=await n.open(i,{create:!0,unlock:!1});try{const a=await r.readFile(s);await this.gb(n,o,A.$Je.wrap(a),a.byteLength,0,0)}catch(a){throw(0,$.$il)(a)}finally{await n.close(o)}}async pb(r,s,n,i){const o=await(0,A.$Ve)(this.H(r,s,j.CancellationToken.None));await this.hb(n,i,void 0,o)}qb(r,s){if(r.capabilities&2048)throw new $.$pl((0,w.localize)(25,null,this.sb(s)),6);return r}rb(r,s){if((s.permissions??0)&$.FilePermission.Readonly)throw new $.$pl((0,w.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===v.Schemas.file?r.fsPath:r.toString(!0)}};e.$Oq=m,e.$Oq=m=g=ve([Y(0,u.$7j)],m)}),define(le[208],he([0,1,41,277,6,34,15,3,40,2,14,5,21,50,31,168,12,98,206,38,202,201]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0,(()=>{try{(0,L.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,h.$lj)(r)}`)}})();class t extends u.$1q{static{this.L=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=I.Event.None,this.P=new j.$Ac(i=>y.$5g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,v.$k&&(this.M|=1024)),this.M}async stat(s){try{const{stat:n,symbolicLink:i}=await c.SymlinkSupport.stat(this.I(s));return{type:this.O(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:$.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await c.Promises.readdir(this.I(s),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,y.$bh)(s,o.name))).type:a=this.O(o),i.push([o.name,a])}catch(a){this.a.trace(a)}})),i}catch(n){throw this.hb(n)}}O(s,n){let i;return n?.dangling?i=$.FileType.Unknown:s.isFile()?i=$.FileType.File:s.isDirectory()?i=$.FileType.Directory:i=$.FileType.Unknown,n&&(i|=$.FileType.SymbolicLink),i}async Q(s){const n=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const o=new A.$zh;return this.P.set(s,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,d.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(s)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(s,n){let i;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),i=await this.Q(s));const o=this.I(s);return await c.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{i?.dispose()}}R(s){t.L&&this.a.trace(s)}readFileStream(s,n,i){const o=(0,l.$xe)(a=>D.$Je.concat(a.map(p=>D.$Je.wrap(p))).buffer);return(0,f.$Nq)(this,s,o,a=>a.buffer,{...n,bufferSize:256*1024},i),o}async writeFile(s,n,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(s)?this.U(s,(0,y.$bh)((0,y.$ah)(s),`${(0,y.$$g)(s)}${i.atomic.postfix}`),n,i):this.W(s,n,i)}async S(s){try{const n=this.I(s),{symbolicLink:i}=await c.SymlinkSupport.stat(n);if(i)return!1}catch{}return!0}async U(s,n,i,o){const a=new d.$Tc;try{a.add(await this.Q(s)),a.add(await this.Q(n)),await this.W(n,i,o,!0);try{await this.rename(n,s,{overwrite:!0})}catch(p){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw p}}finally{a.dispose()}}async W(s,n,i,o){let a;try{const p=this.I(s);if(!i.create||!i.overwrite){if(await c.Promises.exists(p)){if(!i.overwrite)throw(0,$.$hl)((0,w.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,$.$hl)((0,w.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:i.unlock},o),await this.write(a,0,n,0,n.byteLength)}catch(p){throw await this.ib(s,p)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(s){t.$=s}async open(s,n,i){const o=this.I(s);let a;(0,$.$8k)(n)&&!i&&(a=await this.Q(s));let p;try{if((0,$.$8k)(n)&&n.unlock)try{const{stat:b}=await c.SymlinkSupport.stat(o);b.mode&128||await c.Promises.chmod(o,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let S;if((0,$.$8k)(n)){if(v.$i)try{await c.Promises.truncate(o,0),S="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}S||(S="w")}else S="r";p=await c.Promises.open(o,S)}catch(S){throw a?.dispose(),(0,$.$8k)(n)?await this.ib(s,S):this.hb(S)}if(this.X.set(p,0),(0,$.$8k)(n)&&this.Z.set(p,s),a){const S=this.Y.get(p);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${p} (${o})`),this.Y.set(p,a),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${p} (${o})`),S.dispose())}return p}async close(s){const n=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&t.$)try{await c.Promises.fdatasync(s)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await c.Promises.close(s)}catch(i){throw this.hb(i)}finally{n&&(this.Y.get(s)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,i,o,a){const p=this.ab(s,n);let S=null;try{S=(await c.Promises.read(s,i,o,a,p)).bytesRead}catch(b){throw this.hb(b)}finally{this.bb(s,p,S)}return S}ab(s,n){return n===this.X.get(s)?null:n}bb(s,n,i){const o=this.X.get(s);typeof o=="number"&&(typeof n=="number"||(typeof i=="number"?this.X.set(s,o+i):this.X.delete(s)))}async write(s,n,i,o,a){return(0,A.$Uh)(()=>this.cb(s,n,i,o,a),100,3)}async cb(s,n,i,o,a){const p=this.ab(s,n);let S=null;try{S=(await c.Promises.write(s,i,o,a,p)).bytesWritten}catch(b){throw await this.ib(this.Z.get(s),b)}finally{this.bb(s,p,S)}return S}async mkdir(s){try{await c.Promises.mkdir(this.I(s))}catch(n){throw this.hb(n)}}async delete(s,n){try{const i=this.I(s);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,E.$jc)((0,E.$mc)(i),`${(0,E.$nc)(i)}${n.atomic.postfix}`)),await c.Promises.rm(i,c.RimRafMode.MOVE,o)}else try{await c.Promises.unlink(i)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let a=!1;try{const{stat:p,symbolicLink:S}=await c.SymlinkSupport.stat(i);a=p.isDirectory()&&!S}catch{}if(a)await c.Promises.rmdir(i);else throw o}else throw o}}catch(i){throw this.hb(i)}}async rename(s,n,i){const o=this.I(s),a=this.I(n);if(o!==a)try{await this.db(s,n,"move",i.overwrite),await c.Promises.rename(o,a)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,w.localize)(2,null,(0,E.$nc)(o),(0,E.$nc)((0,E.$mc)(a)),p.toString()))),this.hb(p)}}async copy(s,n,i){const o=this.I(s),a=this.I(n);if(o!==a)try{await this.db(s,n,"copy",i.overwrite),await c.Promises.copy(o,a,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,w.localize)(3,null,(0,E.$nc)(o),(0,E.$nc)((0,E.$mc)(a)),p.toString()))),this.hb(p)}}async db(s,n,i,o){const a=this.I(s),p=this.I(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,P.$yg)(a,p,!0)),S){if(i==="copy")throw(0,$.$hl)((0,w.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const k=await this.N(s);if(!k)throw(0,$.$hl)((0,w.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(n);if(C){if(!o)throw(0,$.$hl)((0,w.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);k.type&$.FileType.File&&C.type&$.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.eb(s,n,!1)}async eb(s,n,i){const o=this.I(s),a=this.I(n),p=!!(this.capabilities&1024);if((0,P.$yg)(o,a,!p))return;const S=new d.$Tc;try{S.add(await this.Q(s)),S.add(await this.Q(n)),i&&await c.Promises.mkdir((0,E.$mc)(a),{recursive:!0}),await c.Promises.copyFile(o,a)}catch(b){if(b.code==="ENOENT"&&!i)return this.eb(s,n,!0);throw this.hb(b)}finally{S.dispose()}}t(s,n,i){return new g.$8q(o=>s(o),o=>n(o),i)}F(s,n,i){return new m.$er(o=>s(o),o=>n(o),i)}hb(s){if(s instanceof $.$gl)return s;let n=s,i;switch(s.code){case"ENOENT":i=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=$.FileSystemProviderErrorCode.Unknown;break;default:i=$.FileSystemProviderErrorCode.Unknown}return(0,$.$hl)(n,i)}async ib(s,n){let i=this.hb(n);if(s&&i.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.I(s));o.mode&128||(i=(0,$.$hl)(n,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return i}}e.$fr=t}),define(le[100],he([0,1,3,2,4,9]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=void 0,e.$Efc=(0,A.$Ai)("sharedProcessLifecycleService");let D=class extends L.$Uc{constructor(P){super(),this.b=P,this.a=this.B(new R.$he),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Ffc=D,e.$Ffc=D=ve([Y(0,j.$7j)],D)}),define(le[209],he([0,1,8,3,9,2]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=void 0;class D extends A.$fk{constructor(v,y,l,c,w){super(y,l,c),this.r=v,this.t=w,this.B(w.listen("onDidChangeLogLevel",v)($=>{(0,A.$9j)($)?super.setLogLevel($):super.setLogLevel(R.URI.revive($[0]),$[1])})),this.B(w.listen("onDidChangeVisibility",v)(([$,f])=>super.setVisibility(R.URI.revive($),f))),this.B(w.listen("onDidChangeLoggers",v)(({added:$,removed:f})=>{for(const u of $)super.registerLogger({...u,resource:R.URI.revive(u.resource)});for(const u of f)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new A.$dk({log:(v,y)=>{this.t.call("consoleLog",[v,y])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,y){super.setLogLevel(v,y),this.t.call("setLogLevel",[v,y])}setVisibility(v,y){super.setVisibility(v,y),this.t.call("setVisibility",[this.n(v),y])}s(v,y,l){return new I(this.t,v,y,l,this.r)}static setLogLevel(v,y,l){return v.call("setLogLevel",[y,l])}}e.$fs=D;class I extends A.$ak{constructor(v,y,l,c,w){super(c?.logLevel==="always"),this.r=v,this.s=y,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[y,c,w]).then(()=>{this.u(this.n),this.m=!0})}g(v,y){const l=[[v,y]];this.m?this.u(l):this.n.push(...l)}u(v){this.r.call("log",[this.s,v])}}class P{constructor(v,y){this.a=v,this.b=y}listen(v,y){const l=this.b(v);switch(y){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(w=>this.c(w,l)),removed:[...c.removed].map(w=>this.c(w,l))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,c=>[l.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,c=>(0,A.$9j)(c)?c:[l.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${y}`)}async call(v,y,l){const c=this.b(v);switch(y){case"setLogLevel":return(0,A.$9j)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(R.URI.revive(c.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,c)))}throw new Error(`Call not found: ${y}`)}c(v,y){return{...v,resource:y.transformOutgoingURI(v.resource)}}}e.$gs=P;class d extends j.$Uc{constructor(v,y){super(),y.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(l=>y.call("setLogLevel",[l]))),y.call("getRegisteredLoggers").then(l=>{for(const c of l)v.registerLogger({...c,resource:R.URI.revive(c.resource)})}),this.B(y.listen("onDidChangeVisibility")(([l,c])=>v.setVisibility(R.URI.revive(l),c))),this.B(y.listen("onDidChangeLoggers")(({added:l,removed:c})=>{for(const w of l)v.registerLogger({...w,resource:R.URI.revive(w.resource)});for(const w of c)v.deregisterLogger(w.resource)}))}}e.$hs=d}),define(le[210],he([0,1,2,9]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;class A extends R.$Uc{constructor(D,I=[]){super(),this.a=new L.$ek([D,...I]),this.B(D.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...I){this.a.trace(D,...I)}debug(D,...I){this.a.debug(D,...I)}info(D,...I){this.a.info(D,...I)}warn(D,...I){this.a.warn(D,...I)}error(D,...I){this.a.error(D,...I)}flush(){this.a.flush()}}e.$fQ=A}),define(le[57],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0,e.$Adc=(0,R.$Ai)("nativeHostService")}),define(le[211],he([0,1,42,56]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;let A=class{constructor(D,I){return this.windowId=D,R.ProxyChannel.toService(I.getChannel("nativeHost"),{context:D,properties:(()=>{const P=new Map;return P.set("windowId",D),P})()})}};e.$Vec=A,e.$Vec=A=ve([Y(1,L.$Pec)],A)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=void 0,e.$jo=(0,j.$Ai)("policy");class D extends A.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new R.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const E=Object.keys(this.f).length;return this.f={...d,...this.f},E!==Object.keys(this.f).length&&await this.j(d),L.Iterable.reduce(this.g.entries(),(v,[y,l])=>({...v,[y]:l}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(d,[E,v])=>({...d,[E]:{definition:v,value:this.g.get(E)}}),{})}}e.$ko=D;class I{constructor(){this.onDidChange=R.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$lo=I}),define(le[212],he([0,1,3,2,58]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=e.$lec=void 0;class j{constructor(P){this.b=P,this.a=new L.$Tc}listen(P,d){switch(d){case"onDidChange":return R.Event.map(this.b.onDidChange,E=>E.reduce((v,y)=>({...v,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(P,d,E){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$lec=j;class D extends A.$ko{constructor(P,d){super(),this.a=d;for(const E in P){const{definition:v,value:y}=P[E];this.f[E]=v,y!==void 0&&this.g.set(E,y)}this.a.listen("onDidChange")(E=>{for(const v in E){const y=E[v];y===null?this.g.delete(v):this.g.set(v,y)}this.h.fire(Object.keys(E))})}async j(P){const d=await this.a.call("updatePolicyDefinitions",P);for(const E in d)this.g.set(E,d[E])}}e.$mec=D}),define(le[101],he([0,1,36]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const j=A.context.configuration();if(j)L=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:j.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(le[24],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,R.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(le[213],he([0,1,6,7,2,14,31,9,24]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;let d=class extends A.$Uc{constructor(v,y,l){super(),this.b=y,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,v&&this.B(new R.$Mh(()=>{this.f(v)},3e4)).schedule()}async f(v){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const y=Date.now(),l=(0,j.$mc)(v),c=(0,j.$nc)(v),w=await D.Promises.readdir(l);await Promise.all(w.map(async $=>{if($===c)return;const f=(0,j.$jc)(l,$),u=await D.Promises.stat(f);if(u.isDirectory()&&y-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${$}.`),D.Promises.rm(f)}))}catch(y){(0,L.$1)(y)}}};e.$cfc=d,e.$cfc=d=ve([Y(1,P.$nk),Y(2,I.$7j)],d)}),define(le[214],he([0,1,6,7,2,14,31,16,9,24]),function(se,e,R,L,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;let E=class extends A.$Uc{constructor(y,l,c){super(),this.b=y,this.c=l,this.f=c,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new R.$Mh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const y=Object.create(null),l=JSON.parse(await D.Promises.readFile((0,j.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(l)){const h=l[u];y[`${h.hash}.${u}`]=!0}const c=(0,j.$jc)(this.b.userDataPath,"clp");if(!await D.Promises.exists(c))return;const $=await D.Promises.readdir(c);for(const u of $){if(y[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await D.Promises.rm((0,j.$jc)(c,u))}const f=Date.now();for(const u of Object.keys(y)){const h=(0,j.$jc)(c,u),g=await D.Promises.readdir(h);for(const m of g){if(m==="tcf.json")continue;const t=(0,j.$jc)(h,m),r=await D.Promises.stat(t);r.isDirectory()&&f-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$jc)(u,m)}`),await D.Promises.rm(t))}}}catch(y){(0,L.$1)(y)}}};e.$dfc=E,e.$dfc=E=ve([Y(0,I.$Ii),Y(1,P.$7j),Y(2,d.$nk)],E)}),define(le[215],he([0,1,14,4]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$uG=void 0,e.$uG=(0,L.$Ai)("IV8InspectProfilingService");var A;(function(j){function D(P){return!!(P.samples&&P.timeDeltas)}j.isValidProfile=D;function I(P,d="noAbsolutePaths"){for(const E of P.nodes)E.callFrame&&E.callFrame.url&&((0,R.$ic)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,R.$jc)(d,(0,R.$nc)(E.callFrame.url)));return P}j.rewriteAbsolutePaths=I})(A||(e.Utils=A={}))}),define(le[216],he([0,1,32]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class L{constructor(){this.a=new Map}async startProfiling(j){const I=await(await new Promise((d,E)=>{se(["v8-inspect-profiler"],d,E)})).startProfiling({host:j.host,port:j.port,checkForPaused:!0}),P=(0,R.$Wg)();return this.a.set(P,I),P}async stopProfiling(j){const D=this.a.get(j);if(!D)throw new Error(`UNKNOWN session '${j}'`);const I=await D.stop();return this.a.delete(j),I.profile}}e.$ufc=L}),define(le[43],he([0,1,129,13]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=void 0;class A{constructor(){this.a=new Map}add(D,I){R.ok(L.$ag(D)),R.ok(L.$cg(I)),R.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,I)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$ho=new A}),define(le[102],he([0,1,3,43]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=void 0,e.$io={JSONContribution:"base.contributions.json"};function A(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class j{constructor(){this.b=new R.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,d){this.a[A(P)]=d,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const D=new j;L.$ho.add(e.$io.JSONContribution,D)}),define(le[47],he([0,1,17,3,13,155,22,102,43]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ConfigurationScope=e.$mo=e.EditPresentationTypes=void 0,e.$xo=w,e.$yo=$,e.$zo=f,e.$Ao=h,e.$Bo=g;var d;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$mo={Configuration:"base.contributions.configuration"};var E;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to="vscode://schemas/settings/resourceLanguage",e.$uo="vscode://schemas/settings/configurationDefaults";const v=P.$ho.as(I.$io.JSONContribution);class y{constructor(){this.h=new Set,this.i=new L.$he,this.onDidSchemaChange=this.i.event,this.j=new L.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$to,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.n(t,r,s),v.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.o(t,r),v.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.o(r,s),this.n(t,!1,s),v.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const s=[];for(const{overrides:n,source:i}of t)for(const o in n)if(r.add(o),e.$wo.test(o)){const a=this.a.get(o),p=a?.valuesSources??new Map;if(i)for(const C of Object.keys(n[o]))p.set(C,i);const S={...a?.value||{},...n[o]};this.a.set(o,{source:i,value:S,valuesSources:p});const b=(0,D.$ej)(o),k={type:"object",default:S,description:j.localize(1,null,b),$ref:e.$to,defaultDefaultValue:S,source:A.$ag(i)?void 0:i,defaultValueSource:i};s.push(...w(o)),this.d[o]=k,this.b.properties[o]=k}else{this.a.set(o,{value:n[o],source:i});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(s)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:s,source:n}of t)for(const i in s){const o=this.a.get(i),a=A.$ag(n)?n:n?.id,p=A.$ag(o?.source)?o?.source:o?.source?.id;if(a===p)if(r.add(i),this.a.delete(i),e.$wo.test(i))delete this.d[i],delete this.b.properties[i];else{const S=this.d[i];S&&(this.w(i,S),this.r(i,S))}}this.u()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,s){t.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,r){const s=n=>{if(n.properties)for(const i in n.properties){r.add(i);const o=this.d[i];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>s(i))};for(const n of t){s(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(t,r=!0,s,n,i=3,o){i=A.$jg(t.scope)?i:t.scope;const a=t.properties;if(a)for(const S in a){const b=a[S];if(r&&h(S,b)){delete a[S];continue}if(b.source=s,b.defaultDefaultValue=a[S].default,this.w(S,b),e.$wo.test(S)?b.scope=void 0:(b.scope=A.$jg(b.scope)?i:b.scope,b.restricted=A.$jg(b.restricted)?!!n?.includes(S):b.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.f[S]=a[S],delete a[S];continue}else this.d[S]=a[S],a[S].policy?.name&&this.e.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),o.add(S)}const p=t.allOf;if(p)for(const S of p)this.p(S,r,s,n,i,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=s=>{const n=s.properties;if(n)for(const o in n)this.r(o,n[o]);s.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$no.properties[t]=r,r.scope){case 1:e.$oo.properties[t]=r;break;case 2:e.$po.properties[t]=r;break;case 6:e.$qo.properties[t]=r;break;case 3:e.$ro.properties[t]=r;break;case 4:e.$so.properties[t]=r;break;case 5:e.$so.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$no.properties[t],r.scope){case 1:delete e.$oo.properties[t];break;case 2:delete e.$po.properties[t];break;case 6:delete e.$qo.properties[t];break;case 3:delete e.$ro.properties[t];break;case 4:case 5:delete e.$so.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,s={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$to};this.w(r,s),e.$no.properties[r]=s,e.$oo.properties[r]=s,e.$po.properties[r]=s,e.$qo.properties[r]=s,e.$ro.properties[r]=s,e.$so.properties[r]=s}}v(){const t={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$to};e.$no.patternProperties[e.$vo]=t,e.$oo.patternProperties[e.$vo]=t,e.$po.patternProperties[e.$vo]=t,e.$qo.patternProperties[e.$vo]=t,e.$ro.patternProperties[e.$vo]=t,e.$so.patternProperties[e.$vo]=t,this.i.fire()}w(t,r){const s=this.a.get(t);let n=s?.value,i=s?.source;A.$hg(n)&&(n=r.defaultDefaultValue,i=void 0),A.$hg(n)&&(n=f(r.type)),r.default=n,r.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",c=new RegExp(l,"g");e.$vo=`^(${l})+$`,e.$wo=new RegExp(e.$vo);function w(m){const t=[];if(e.$wo.test(m)){let r=c.exec(m);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=c.exec(m)}}return(0,R.$Mb)(t)}function $(m){return m.reduce((t,r)=>`${t}[${r}]`,"")}function f(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new y;P.$ho.add(e.$mo.Configuration,u);function h(m,t){return m.trim()?e.$wo.test(m)?j.localize(7,null,m):u.getConfigurationProperties()[m]!==void 0?j.localize(8,null,m):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?j.localize(9,null,m,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:j.localize(6,null)}function g(){const m=[],t=u.getConfigurationProperties();for(const r of Object.keys(t))m.push([r,t[r].scope]);return m.push(["launch",4]),m.push(["task",4]),m}}),define(le[76],he([0,1,17,3,35,2,34,30,13,8,22,47,43]),function(se,e,R,L,A,j,D,I,P,d,E,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Go=h;function l(r){return Object.isFrozen(r)?r:I.$8n(r)}class c{static createEmptyModel(s){return new c({},[],[],void 0,s)}constructor(s,n,i,o,a){this.b=s,this.c=n,this.d=i,this.raw=o,this.f=a,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof c)return n;const i=new w("",this.f);return i.parseRaw(n),i.configurationModel});this.g=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,E.$cj)(this.contents,s):this.contents}inspect(s,n){const i=this;return{get value(){return l(i.rawConfiguration.getValue(s))},get override(){return n?l(i.rawConfiguration.getOverrideValue(s,n)):void 0},get merged(){return l(n?i.rawConfiguration.override(n).getValue(s):i.rawConfiguration.getValue(s))},get overrides(){const o=[];for(const{contents:a,identifiers:p,keys:S}of i.rawConfiguration.overrides){const b=new c(a,S,[],void 0,i.f).getValue(s);b!==void 0&&o.push({identifiers:p,value:b})}return o.length?l(o):void 0}}}getOverrideValue(s,n){const i=this.j(n);return i?s?(0,E.$cj)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return R.$Mb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return R.$Mb(s)}override(s){let n=this.a.get(s);return n||(n=this.h(s),this.a.set(s,n)),n}merge(...s){const n=I.$7n(this.contents),i=I.$7n(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const p of s)if(a.push(...p.raw?.length?p.raw:[p]),!p.isEmpty()){this.i(n,p.contents);for(const S of p.overrides){const[b]=i.filter(k=>R.$ub(k.identifiers,S.identifiers));b?(this.i(b.contents,S.contents),b.keys.push(...S.keys),b.keys=R.$Mb(b.keys)):i.push(I.$7n(S))}for(const S of p.keys)o.indexOf(S)===-1&&o.push(S)}return new c(n,o,i,a.every(p=>p instanceof c)?void 0:a,this.f)}h(s){const n=this.j(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const o of R.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o];const p=n[o];p&&(typeof a=="object"&&typeof p=="object"?(a=I.$7n(a),this.i(a,p)):a=p),i[o]=a}return new c(i,this.keys,this.overrides,void 0,this.f)}i(s,n){for(const i of Object.keys(n)){if(i in s&&P.$cg(s[i])&&P.$cg(n[i])){this.i(s[i],n[i]);continue}s[i]=I.$7n(n[i])}}j(s){let n=null,i=null;const o=a=>{a&&(i?this.i(i,a):i=I.$7n(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===s?n=a.contents:a.identifiers.includes(s)&&o(a.contents);return o(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.k(s,n,!0)}setValue(s,n){this.k(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,E.$bj)(this.contents,s),v.$wo.test(s)&&this.overrides.splice(this.overrides.findIndex(i=>R.$ub(i.identifiers,(0,v.$xo)(s))),1))}k(s,n,i){(0,E.$aj)(this.contents,s,n,o=>this.f.error(o)),i=i||this.keys.indexOf(s)===-1,i&&this.keys.push(s),v.$wo.test(s)&&this.overrides.push({identifiers:(0,v.$xo)(s),keys:Object.keys(this.contents[s]),contents:(0,E.$_i)(this.contents[s],o=>this.f.error(o))})}}e.$Co=c;class w{constructor(s,n){this.f=s,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!P.$jg(s)){const i=this.h(s);this.parseRaw(i,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:i,keys:o,overrides:a,restricted:p,hasExcludedProperties:S}=this.i(s,n);this.b=new c(i,o,a,S?[s]:void 0,this.g),this.c=p||[]}h(s){let n={},i=null,o=[];const a=[],p=[];function S(k){Array.isArray(o)?o.push(k):i!==null&&(o[i]=k)}const b={onObjectBegin:()=>{const k={};S(k),a.push(o),o=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const k=[];S(k),a.push(o),o=k,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:S,onError:(k,C,O)=>{p.push({error:k,offset:C,length:O})}};if(s)try{A.$Un(s,b),n=o[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return n}i(s,n){const i=y.$ho.as(v.$mo.Configuration).getConfigurationProperties(),o=this.j(s,i,!0,n);s=o.raw;const a=(0,E.$_i)(s,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`)),p=Object.keys(s),S=this.l(s,b=>this.g.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:a,keys:p,overrides:S,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(s,n,i,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:a};const p={},S=[];for(const b in s)if(v.$wo.test(b)&&i){const k=this.j(s[b],n,!1,o);p[b]=k.raw,a=a||k.hasExcludedProperties,S.push(...k.restricted)}else{const k=n[b],C=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&S.push(b),!o.exclude?.includes(b)&&(o.include?.includes(b)||(C===void 0||o.scopes===void 0||o.scopes.includes(C))&&!(o.skipRestricted&&k?.restricted))?p[b]=s[b]:a=!0}return{raw:p,restricted:S,hasExcludedProperties:a}}l(s,n){const i=[];for(const o of Object.keys(s))if(v.$wo.test(o)){const a={};for(const p in s[o])a[p]=s[o][p];i.push({identifiers:(0,v.$xo)(o),keys:Object.keys(a),contents:(0,E.$_i)(a,n)})}return i}}e.$Do=w;class $ extends j.$Uc{constructor(s,n,i,o,a){super(),this.c=s,this.f=n,this.g=o,this.h=a,this.b=this.B(new L.$he),this.onDidChange=this.b.event,this.a=new w(this.c.toString(),a),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&i.isEqual(p.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Eo=$;class f{constructor(s,n,i,o,a,p,S,b,k,C,O,M,T){this.a=s,this.b=n,this.c=i,this.overrideIdentifiers=o,this.d=a,this.f=p,this.g=S,this.h=b,this.i=k,this.j=C,this.k=O,this.l=M,this.m=T}get value(){return l(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(s,n,i,o,a,p,S,b,k,C){this.j=s,this.l=n,this.m=i,this.n=o,this.p=a,this.q=p,this.r=S,this.s=b,this.t=k,this.u=C,this.h=null,this.i=new D.$Ac,this.v=null}getValue(s,n,i){return this.w(s,n,i).getValue(s)}updateValue(s,n,i={}){let o;i.resource?(o=this.t.get(i.resource),o||(o=c.createEmptyModel(this.u),this.t.set(i.resource,o))):o=this.s,n===void 0?o.removeValue(s):o.setValue(s,n),i.resource||(this.h=null)}inspect(s,n,i){const o=this.w(s,n,i),a=this.A(n.resource,i),p=n.resource?this.t.get(n.resource)||this.s:this.s,S=new Set;for(const b of o.overrides)for(const k of b.identifiers)o.getOverrideValue(s,k)!==void 0&&S.add(k);return new f(s,n,o.getValue(s),S.size?[...S]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.q:void 0,a||void 0,p)}keys(s){const n=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,n){this.r.set(s,n),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:o,updated:a,removed:p}=m(this.j,s);n=[...o,...a,...p]}for(const o of n)for(const a of(0,v.$xo)(o)){const p=this.j.getKeysForOverrideIdentifier(a),S=s.getKeysForOverrideIdentifier(a),b=[...S.filter(k=>p.indexOf(k)===-1),...p.filter(k=>S.indexOf(k)===-1),...p.filter(k=>!I.$$n(this.j.override(a).getValue(k),s.override(a).getValue(k)))];i.push([a,b])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:o}=m(this.l,s),a=[...n,...i,...o];return a.length&&this.updatePolicyConfiguration(s),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:o,overrides:a}=m(this.applicationConfiguration,s),p=[...n,...i,...o];return p.length&&this.updateApplicationConfiguration(s),{keys:p,overrides:a}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:o,overrides:a}=m(this.localUserConfiguration,s),p=[...n,...i,...o];return p.length&&this.updateLocalUserConfiguration(s),{keys:p,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:o,overrides:a}=m(this.remoteUserConfiguration,s),p=[...n,...i,...o];return p.length&&this.updateRemoteUserConfiguration(s),{keys:p,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:o,overrides:a}=m(this.workspaceConfiguration,s),p=[...n,...i,...o];return p.length&&this.updateWorkspaceConfiguration(s),{keys:p,overrides:a}}compareAndUpdateFolderConfiguration(s,n){const i=this.folderConfigurations.get(s),{added:o,updated:a,removed:p,overrides:S}=m(i,n),b=[...o,...a,...p];return(b.length||!i)&&this.updateFolderConfiguration(s,n),{keys:b,overrides:S}}compareAndDeleteFolderConfiguration(s){const n=this.folderConfigurations.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:o,removed:a,overrides:p}=m(n,void 0);return{keys:[...i,...o,...a],overrides:p}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,n,i){let o=this.x(n,i);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(o=o.merge(this.l)),o}x({resource:s},n){let i=this.y();if(n&&s){const o=n.getFolder(s);o&&(i=this.z(o.uri)||i);const a=this.t.get(s);a&&(i=i.merge(a))}return i}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let n=this.i.get(s);if(!n){const i=this.y(),o=this.r.get(s);o?(n=i.merge(o),this.i.set(s,n)):n=i}return n}A(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this.r.get(i.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,n)=>{const{contents:i,overrides:o,keys:a}=this.r.get(n);return s.push([n,{contents:i,overrides:o,keys:a}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.q.keys.forEach(n=>s.add(n)),this.r.forEach(n=>n.keys.forEach(i=>s.add(i))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}D(s){const n=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.q.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.r.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(o=>n.add(o))),[...n.values()]}static parse(s,n){const i=this.E(s.defaults,n),o=this.E(s.policy,n),a=this.E(s.application,n),p=this.E(s.user,n),S=this.E(s.workspace,n),b=s.folders.reduce((k,C)=>(k.set(d.URI.revive(C[0]),this.E(C[1],n)),k),new D.$Ac);return new u(i,o,a,p,c.createEmptyModel(n),S,b,c.createEmptyModel(n),new D.$Ac,n)}static E(s,n){return new c(s.contents,s.keys,s.overrides,void 0,n)}}e.$Fo=u;function h(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,n=new Map;for(const o of r)o.keys.forEach(a=>s.add(a)),o.overrides.forEach(([a,p])=>{const S=(0,D.$xc)(n,a,new Set);p.forEach(b=>S.add(b))});const i=[];return n.forEach((o,a)=>i.push([a,[...o.values()]])),{keys:[...s.values()],overrides:i}}class g{constructor(s,n,i,o,a){this.change=s,this.f=n,this.g=i,this.h=o,this.i=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const p of s.keys)this.affectedKeys.add(p);for(const[,p]of s.overrides)for(const S of p)this.affectedKeys.add(S);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,n){const i=this.a+s,o=this.d.indexOf(i);if(o<0)return!1;const a=o+i.length;if(a>=this.d.length)return!1;const p=this.d.charCodeAt(a);if(p!==this.b&&p!==this.c)return!1;if(n){const S=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,b=this.g.getValue(s,n,this.h);return!I.$$n(S,b)}return!0}}e.$Ho=g;function m(r,s){const{added:n,removed:i,updated:o}=t(s?.rawConfiguration,r?.rawConfiguration),a=[],p=r?.getAllOverrideIdentifiers()||[],S=s?.getAllOverrideIdentifiers()||[];if(s){const b=S.filter(k=>!p.includes(k));for(const k of b)a.push([k,s.getKeysForOverrideIdentifier(k)])}if(r){const b=p.filter(k=>!S.includes(k));for(const k of b)a.push([k,r.getKeysForOverrideIdentifier(k)])}if(s&&r){for(const b of p)if(S.includes(b)){const k=t({contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)},{contents:s.getOverrideValue(void 0,b)||{},keys:s.getKeysForOverrideIdentifier(b)});a.push([b,[...k.added,...k.removed,...k.updated]])}}return{added:n,removed:i,updated:o,overrides:a}}function t(r,s){const n=r?s?r.keys.filter(a=>s.keys.indexOf(a)===-1):[...r.keys]:[],i=s?r?s.keys.filter(a=>r.keys.indexOf(a)===-1):[...s.keys]:[],o=[];if(r&&s){for(const a of s.keys)if(r.keys.indexOf(a)!==-1){const p=(0,E.$cj)(s.contents,a),S=(0,E.$cj)(r.contents,a);I.$$n(p,S)||o.push(a)}}return{added:n,removed:i,updated:o}}}),define(le[217],he([0,1,17,3,2,30,13,76,47,9,58,43]),function(se,e,R,L,A,j,D,I,P,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=void 0;class y extends A.$Uc{get configurationModel(){return this.b}constructor($){super(),this.c=$,this.a=this.B(new L.$he),this.onDidChangeConfiguration=this.a.event,this.b=I.$Co.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(v.$ho.as(P.$mo.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:f})=>this.f(Array.from($),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f($,f){this.j($,v.$ho.as(P.$mo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}g(){return{}}h(){this.b=I.$Co.createEmptyModel(this.c);const $=v.$ho.as(P.$mo.Configuration).getConfigurationProperties();this.j(Object.keys($),$)}j($,f){const u=this.g();for(const h of $){const g=u[h],m=f[h];g!==void 0?this.b.addValue(h,g):m?this.b.addValue(h,m.default):this.b.removeValue(h)}}}e.$Io=y;class l{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=I.$Co.createEmptyModel(new d.$hk)}async initialize(){return this.configurationModel}}e.$Jo=l;let c=class extends A.$Uc{get configurationModel(){return this.b}constructor($,f,u){super(),this.c=$,this.f=f,this.g=u,this.a=this.B(new L.$he),this.onDidChangeConfiguration=this.a.event,this.b=I.$Co.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const f={},u=[],h=v.$ho.as(P.$mo.Configuration).getConfigurationProperties();for(const g of $){const m=h[g];if(!m){u.push(g);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.g.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}u.push(g),f[m.policy.name]={type:m.type}}}return(0,D.$ng)(f)||await this.f.updatePolicyDefinitions(f),u}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const f=v.$ho.as(P.$mo.Configuration).getPolicyConfigurations(),u=(0,R.$Hb)($.map(h=>f.get(h)));this.m(u,!0)}m($,f){this.g.trace("PolicyConfiguration#update",$);const u=v.$ho.as(P.$mo.Configuration).getConfigurationProperties(),h=[],g=this.b.isEmpty();for(const m of $){const t=u[m]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(g?r!==void 0:!(0,j.$$n)(this.b.getValue(m),r))&&h.push([m,r])}else this.b.getValue(m)!==void 0&&h.push([m,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const m=this.b;this.b=I.$Co.createEmptyModel(this.g);for(const t of m.keys)this.b.setValue(t,m.getValue(t));for(const[t,r]of h)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);f&&this.a.fire(this.b)}}};e.$Ko=c,e.$Ko=c=ve([Y(1,E.$jo),Y(2,d.$7j)],c)}),define(le[218],he([0,1,17,6,15,3,35,62,2,34,30,5,21,22,76,47,217,58]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=void 0;class u extends P.$Uc{constructor(m,t,r,s){super(),this.m=m,this.n=s,this.h=this.B(new j.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new $.$Io(s)),this.c=r instanceof f.$lo?new $.$Jo:this.B(new $.$Ko(this.b,r,s)),this.f=this.B(new c.$Eo(this.m,{},y.$5g,t,s)),this.a=new c.$Fo(this.b.configurationModel,this.c.configurationModel,c.$Co.createEmptyModel(s),c.$Co.createEmptyModel(s),c.$Co.createEmptyModel(s),c.$Co.createEmptyModel(s),new d.$Ac,c.$Co.createEmptyModel(s),new d.$Ac,s),this.j=new h(m,t,this),this.g=this.B(new L.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:i})=>this.s(n,i))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new c.$Fo(m,t,c.$Co.createEmptyModel(this.n),r,c.$Co.createEmptyModel(this.n),c.$Co.createEmptyModel(this.n),new d.$Ac,c.$Co.createEmptyModel(this.n),new d.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(m,t){const r=typeof m=="string"?m:void 0,s=(0,l.$8i)(m)?m:(0,l.$8i)(t)?t:{};return this.a.getValue(r,s,void 0)}async updateValue(m,t,r,s,n){const i=(0,l.$9i)(r)?r:(0,l.$8i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=i?s:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${m} to target ${o}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,R.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect(m,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${m} because it is configured in system policy.`);if((0,E.$$n)(t,a.defaultValue)&&(t=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const S=i.overrideIdentifiers.sort(),b=this.a.localUserConfiguration.overrides.find(k=>(0,R.$ub)([...k.identifiers].sort(),S));b&&(i.overrideIdentifiers=b.identifiers)}const p=i?.overrideIdentifiers?.length?[(0,w.$yo)(i.overrideIdentifiers),m]:[m];await this.j.write(p,t),await this.reloadConfiguration()}inspect(m,t={}){return this.a.inspect(m,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.r(m)}r(m){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(m);this.u(r,t,2)}s(m,t){const r=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(m,t);this.u(s,r,7)}t(m){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(m);this.u(r,t,7)}u(m,t,r){const s=new c.$Ho(m,{data:t},this.a,void 0,this.n);s.source=r,this.h.fire(s)}}e.$Lo=u;class h{constructor(m,t,r){this.b=m,this.c=t,this.d=r,this.a=new L.$Hh}write(m,t){return this.a.queue(()=>this.e(m,t))}async e(m,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)r="{}";else throw i}const s=[];if((0,D.$Nn)(r,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(r,m,t);r=(0,I.$6n)(r,n),await this.c.writeFile(this.b,A.$Je.fromString(r))}f(m,t,r){const{tabSize:s,insertSpaces:n,eol:i}=this.h;if(!t.length){const o=JSON.stringify(r,null,n?" ".repeat(s):"	");return[{content:o,length:o.length,offset:0}]}return(0,I.$3n)(m,t,r,{tabSize:s,insertSpaces:n,eol:i})}get h(){if(!this.g){let m=v.OS===3||v.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(m=t),this.g={eol:m,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[219],he([0,1,15,3,2,68]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$vb=e.$9vb=e.$8vb=void 0,e.$0vb=I;const D=(d,E,v)=>{const y=new Uint8Array(16);for(let w=0;w<16;w++)y[w]=Math.round(Math.random()*256);const l=(0,R.$4e)(R.$Je.wrap(y));return[`GET ws://localhost${d}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$8vb=D,e.$9vb=R.$Je.fromString(`\r
\r
`);async function I(d,E,v,y,l){d.write(R.$Je.fromString((0,e.$8vb)(E,v,y)));const c=new A.$Tc;try{return await new Promise((w,$)=>{let f;c.add(d.onData(u=>{f?f=R.$Je.concat([f,u],f.byteLength+u.byteLength):f=u;const h=f.indexOf(e.$9vb);if(h===-1)return;w(d),d.pauseData();const g=f.slice(h+e.$9vb.byteLength);g.byteLength&&l.onData.fire(g)})),c.add(d.onClose(u=>$(u??new Error("socket closed")))),c.add(d.onEnd(()=>$(new Error("socket ended"))))})}catch(w){throw d.dispose(),w}finally{c.dispose()}}class P extends A.$Uc{constructor(E,v){super(),this.g=E,this.a=this.B(new L.$ke),this.onData=(...y)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...y)),this.b=this.B(new L.$he),this.onDidDispose=this.b.event,this.f=!1,this.B(v.onData),this.B(v.onData.event(y=>this.a.fire(y))),this.onClose=this.B(v.onClose).event,this.onEnd=this.B(v.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(E,v){j.SocketDiagnostics.traceSocketEvent(this,this.g,E,v)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$$vb=P}),define(le[220],he([0,1,7,4]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=d,e.$Ll=(0,L.$Ai)("remoteAuthorityResolverService");var A;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class j{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ml=j;class D{constructor(v,y){this.host=v,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=D;var I;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class P extends R.$bb{static isNotAvailable(v){return v instanceof P&&v._code===I.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof P&&v._code===I.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof P&&v._code===I.NoResolverFound}static isInvalidAuthority(v){return v instanceof P&&v._code===I.InvalidAuthority}static isHandled(v){return v instanceof P&&v.isHandled}constructor(v,y=I.Unknown,l){super(v),this._message=v,this._code=y,this._detail=l,this.isHandled=y===I.NotAvailable&&l===!0,Object.setPrototypeOf(this,P.prototype)}}e.$Ol=P;function d(E){const v=E.indexOf("+");return v===-1?E:E.substring(0,v)}}),define(le[221],he([0,1,6,15,26,7,3,2,23,99,63,32,68,220]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ul=p,e.$Vl=S,e.$Wl=k;const c=30*1e3;var w;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function $(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(G){const N=new A.$se;return setTimeout(()=>N.cancel(),G),N.token}function u(G,N){if(G.isCancellationRequested||N.isCancellationRequested)return A.CancellationToken.Cancelled;const U=new A.$se;return G.onCancellationRequested(()=>U.cancel()),N.onCancellationRequested(()=>U.cancel()),U.token}class h{get didTimeout(){return this.c==="timedout"}constructor(N){this.c="pending",this.d=new I.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,R.$th)(),N.isCancellationRequested?this.h():this.d.add(N.onCancellationRequested(()=>this.h()))}registerDisposable(N){this.c==="pending"?this.d.add(N):N.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(N))}reject(N){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(N))}}function g(G,N){const U=new h(N);return U.registerDisposable(G.onControlMessage(V=>{const q=JSON.parse(V.toString()),_=B(q);_?U.reject(_):U.resolve(q)})),U.promise}function m(G,N,U,V,q,_,ee,ne){const te=new h(ne),ce=E.$be.create(!1);return G.info(`Creating a socket (${ee})...`),d.mark(`code/willCreateSocket/${_}`),N.connect(U,V,q,ee).then(fe=>{te.didTimeout?(d.mark(`code/didCreateSocketError/${_}`),G.info(`Creating a socket (${ee}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):(d.mark(`code/didCreateSocketOK/${_}`),G.info(`Creating a socket (${ee}) was successful after ${ce.elapsed()} ms.`),te.resolve(fe))},fe=>{d.mark(`code/didCreateSocketError/${_}`),G.info(`Creating a socket (${ee}) returned an error after ${ce.elapsed()} ms.`),G.error(fe),te.reject(fe)}),te.promise}function t(G,N){const U=new h(N);return G.then(V=>{U.didTimeout||U.resolve(V)},V=>{U.didTimeout||U.reject(V)}),U.promise}async function r(G,N,U,V){const q=z(G,N);G.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let _;try{_=await m(G.logService,G.remoteSocketFactoryService,G.connectTo,P.$Ng.getServerRootPath(),`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,$(N),`renderer-${$(N)}-${G.reconnectionToken}`,V)}catch(fe){throw G.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),G.logService.error(fe),fe}G.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let ee,ne;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(_,null),ee=G.reconnectionProtocol,ne=!1):(ee=new y.$oi({socket:_}),ne=!0),G.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const te=await t(G.signService.createNewMessage((0,v.$Wg)()),V),ce={type:"auth",auth:G.connectionToken||"00000000000000000000",data:te.data};ee.sendControl(L.$Je.fromString(JSON.stringify(ce)));try{const fe=await g(ee,u(V,f(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const be=new Error("Unexpected handshake message");throw be.code="VSCODE_CONNECTION_ERROR",be}if(G.logService.trace(`${q} 4/6. received SignRequest control message.`),!await t(G.signService.validate(te,fe.signedData),V)){const be=new Error("Refused to connect to unsupported server");throw be.code="VSCODE_CONNECTION_ERROR",be}const we=await t(G.signService.sign(fe.data),V),Ee={type:"connectionType",commit:G.commit,signedData:we,desiredConnectionType:N};return U&&(Ee.args=U),G.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(L.$Je.fromString(JSON.stringify(Ee))),{protocol:ee,ownsProtocol:ne}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(G.logService.error(`${q} the handshake timed out. Error:`),G.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${q} received error control message when negotiating connection. Error:`),G.logService.error(fe)),ne&&W(ee),fe}}async function s(G,N,U,V){const q=Date.now(),_=z(G,N),{protocol:ee,ownsProtocol:ne}=await r(G,N,U,V),te=new h(V);return te.registerDisposable(ee.onControlMessage(ce=>{const fe=JSON.parse(ce.toString()),$e=B(fe);$e?(G.logService.error(`${_} received error control message when negotiating connection. Error:`),G.logService.error($e),ne&&W(ee),te.reject($e)):(G.reconnectionProtocol?.endAcceptReconnection(),G.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${x(q)}!`),te.resolve({protocol:ee,firstMessage:fe}))})),te.promise}async function n(G,N){const{protocol:U}=await s(G,1,void 0,N);return{protocol:U}}async function i(G,N,U){const{protocol:V,firstMessage:q}=await s(G,2,N,U),_=q&&q.debugPort;return{protocol:V,debugPort:_}}async function o(G,N,U){const V=Date.now(),q=z(G,3),{protocol:_}=await r(G,3,N,U);return G.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${x(V)}!`),_}async function a(G,N,U){const{connectTo:V,connectionToken:q}=await G.addressProvider.getAddress();return{commit:G.commit,quality:G.quality,connectTo:V,connectionToken:q,reconnectionToken:N,reconnectionProtocol:U,remoteSocketFactoryService:G.remoteSocketFactoryService,signService:G.signService,logService:G.logService}}async function p(G,N,U){return b(G,async V=>{const{protocol:q}=await n(V,A.CancellationToken.None);return new H(G,N,U,V.reconnectionToken,q)})}async function S(G,N){return b(G,async U=>{const{protocol:V,debugPort:q}=await i(U,N,A.CancellationToken.None);return new X(G,N,U.reconnectionToken,V,q)})}async function b(G,N){for(let V=1;;V++)try{const q=(0,v.$Wg)(),_=await a(G,q,null);return await N(_)}catch(q){if(V<5)G.logService.error(`[remote-connection][attempt ${V}] An error occurred in initial connection! Will retry... Error:`),G.logService.error(q);else throw G.logService.error(`[remote-connection][attempt ${V}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),G.logService.error(q),Q.triggerPermanentFailure(0,0,l.$Ol.isHandled(q)),q}}async function k(G,N,U){const V=await a(G,(0,v.$Wg)(),null);return await o(V,{host:N,port:U},A.CancellationToken.None)}function C(G){return(0,R.$nh)(N=>new Promise((U,V)=>{const q=setTimeout(U,G*1e3);N.onCancellationRequested(()=>{clearTimeout(q),U()})}))}var O;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class M{constructor(N,U){this.reconnectionToken=N,this.millisSinceLastIncomingData=U,this.type=0}}e.$Xl=M;class T{constructor(N,U,V,q){this.reconnectionToken=N,this.millisSinceLastIncomingData=U,this.durationSeconds=V,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.$Yl=T;class F{constructor(N,U,V){this.reconnectionToken=N,this.millisSinceLastIncomingData=U,this.attempt=V,this.type=2}}e.$Zl=F;class K{constructor(N,U,V){this.reconnectionToken=N,this.millisSinceLastIncomingData=U,this.attempt=V,this.type=4}}e.$1l=K;class J{constructor(N,U,V,q){this.reconnectionToken=N,this.millisSinceLastIncomingData=U,this.attempt=V,this.handled=q,this.type=3}}e.$2l=J;class Q extends I.$Uc{static triggerPermanentFailure(N,U,V){this._permanentFailure=!0,this.f=N,this.g=U,this.h=V,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(N=>N.y())}static debugPauseSocketWriting(){this.j.forEach(N=>N.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Q._permanentFailure}constructor(N,U,V,q,_){super(),this.t=N,this.u=U,this.reconnectionToken=V,this.protocol=q,this.w=_,this.m=this.B(new D.$he),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new K(this.reconnectionToken,0,0)),this.B(q.onSocketClose(ee=>{const ne=Z(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${ne} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${ne} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${ne} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(ee=>{const ne=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),Q.j.push(this),this.B((0,I.$Sc)(()=>{const ee=Q.j.indexOf(this);ee>=0&&Q.j.splice(ee,1)})),this.n&&this.D(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const N=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let V=-1;do{V++;const q=V<U.length?U[V]:U[U.length-1];try{if(q>0){const ee=C(q);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,ee)),this.u.logService.info(`${N} waiting for ${q} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this.u.logService.info(`${N} resolving connection...`);const _=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${N} connecting to ${_.connectTo}...`),await this.G(_,f(c)),this.u.logService.info(`${N} reconnected!`),this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(V>360){this.u.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(l.$Ol.isTemporarilyNotAvailable(_)){this.u.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.u.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((0,j.$4)(_)){this.u.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if(_ instanceof l.$Ol){this.u.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,l.$Ol.isHandled(_));break}this.u.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!this.n&&!this.s)}C(N,U,V){this.w?Q.triggerPermanentFailure(N,U,V):this.D(N,U,V)}D(N,U,V){this.m.fire(new J(this.reconnectionToken,N,U,V)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$3l=Q;class H extends Q{constructor(N,U,V,q,_){super(1,N,q,_,!0),this.client=this.B(new y.$mi(_,{remoteAuthority:U,clientId:V},N.ipcLogger))}async G(N,U){await n(N,U)}}e.$4l=H;class X extends Q{constructor(N,U,V,q,_){super(2,N,V,q,!1),this.H=U,this.debugPort=_}async G(N,U){await i(N,this.H,U)}}e.$5l=X;function W(G){try{G.acceptDisconnect();const N=G.getSocket();G.dispose(),N.dispose()}catch(N){(0,j.$1)(N)}}function B(G){if(G&&G.type==="error"){const N=new Error(`Connection error: ${G.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function ie(G,N){for(;G.length<N;)G+=" ";return G}function re(G,N){return`[remote-connection][${ie($(G),13)}][${N.substr(0,5)}\u2026]`}function Z(G,N,U){return`${re(G,N)}[${U?"reconnect":"initial"}]`}function z(G,N){return`${Z(N,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.connectTo}]`}function x(G){return`${Date.now()-G} ms`}}),define(le[103],he([0,1,23]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=L,e.$Mm=A,e.$Nm=j,e.$Om=D;function L(P){return P.scheme===R.Schemas.vscodeRemote?P.authority:void 0}function A(P){if(!P)return;const d=P.indexOf("+");return d<0?P:P.substr(0,d)}function j(P){const{host:d,port:E}=I(P);if(typeof E>"u")throw new Error(`Invalid remote authority: ${P}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:d,port:E}}function D(P,d){let{host:E,port:v}=I(P);return typeof v>"u"&&(v=d),{host:E,port:v}}function I(P){const d=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(d)return{host:d[1],port:parseInt(d[2],10)};const E=P.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const v=P.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:P,port:void 0}}}),define(le[48],he([0,1,27,4,103]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$Xm=e.$Wm=e.$Vm=e.TargetPlatform=e.ExtensionType=e.$Um=e.$Sm=e.$Rm=e.$Qm=e.$Pm=void 0,e.$Tm=j,e.$Ym=v,e.$Zm=y,e.$1m=l,e.$2m=c,e.$Pm="extensions.user.cache",e.$Qm="extensions.builtin.cache",e.$Rm="undefined_publisher",e.$Sm=["ui","workspace","web"];function j(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$Um=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var D;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(D||(e.ExtensionType=D={}));var I;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class P{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,f){if(typeof $>"u"||$===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof $=="string"||typeof f=="string"){const u=typeof $=="string"?$:$.value,h=typeof f=="string"?f:f.value;return R.$Bf(u,h)}return $._lower===f._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$Vm=P;class d{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const f of $)this.add(f)}add($){this.c.add(P.toKey($))}delete($){return this.c.delete(P.toKey($))}has($){return this.c.has(P.toKey($))}}e.$Wm=d;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(P.toKey($))}get($){return this.c.get(P.toKey($))}has($){return this.c.has(P.toKey($))}set($,f){this.c.set(P.toKey($),f)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xm=E;function v(w){return y(w)}function y(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}function l(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}function c(w,$){if($){const f=`onResolveRemoteAuthority:${(0,A.$Mm)($)}`;return!!w.activationEvents?.includes(f)}return!1}e.$3m=(0,L.$Ai)("IBuiltinExtensionsScannerService")}),define(le[222],he([0,1,2,48,12]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;class j extends R.$Uc{constructor(I,P,d,E,v){super(),this.a=I,this.b=P,this.c=d,this.f=v,this.B(E.onDidInstallExtensions(y=>this.g(y))),this.B(E.onDidUninstallExtension(y=>this.h(y)))}g(I){for(const P of I)P.local&&this.invalidate(P.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const P of this.a.profiles)this.c.extUri.isEqual(P.extensionsResource,I)&&await this.j(P);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,L.$Pm))}catch(P){(0,A.$ll)(P)!==1&&this.f.error(P)}}}e.$Iq=j}),define(le[104],he([0,1,2,4]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql=(0,L.$Ai)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(D,I){return this.a[D]??=[],this.a[D].push(I),(0,R.$Sc)(()=>{const P=this.a[D]?.indexOf(I);typeof P=="number"&&P>=0&&this.a[D]?.splice(P,1)})}b(D){return(this.a[D.type]||[]).find(P=>P.supports(D))}connect(D,I,P,d){const E=this.b(D);if(!E)throw new Error(`No socket factory found for ${D}`);return E.connect(D,I,P,d)}}e.$Rl=A}),define(le[223],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=e.$rfc=void 0,e.$rfc=(0,R.$Ai)("sharedProcessTunnelService"),e.$sfc="sharedProcessTunnel"}),define(le[105],he([0,1,4,171]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=e.$Bfc=e.$Afc=e.$zfc=e.$yfc=e.TunnelStates=e.$xfc=e.$wfc=void 0,e.$wfc=(0,R.$Ai)("IRemoteTunnelService"),e.$xfc={active:!1};var A;(function(j){j.disconnected=D=>({type:"disconnected",onTokenFailed:D}),j.connected=(D,I)=>({type:"connected",info:D,serviceInstallFailed:I}),j.connecting=D=>({type:"connecting",progress:D}),j.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$yfc="remote.tunnels.access",e.$zfc=e.$yfc+".hostNameOverride",e.$Afc=e.$yfc+".preventSleep",e.$Bfc="remoteTunnelService",e.$Cfc=(0,L.localize)(0,null)}),define(le[59],he([0,1,15,7,2,173,47,4,9,43]),function(se,e,R,L,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0,e.$Vp=y,e.$Wp=l,e.$Xp=c,e.$Yp=w,e.$Zp=$,e.$1p=f,e.$Tp=(0,I.$Ai)("requestService");class E{constructor(m){this.b=m}toJSON(){if(!this.a){const m=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?m[t]="*****":m[t]=this.b[t];this.a=m}return this.a}}class v extends A.$Uc{constructor(m){super(),this.b=0,this.a=m.createLogger("network",{name:(0,j.localize)(0,null),when:P.$mk.isEqualTo((0,P.$jk)(P.LogLevel.Trace)).serialize()})}async c(m,t,r){const s=`${m} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new E(t.headers??{}));try{const n=await r();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,L.$0)(n)),n}}}e.$Up=v;function y(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}function l(g){return g.res.statusCode===204}async function c(g){return l(g)?null:(await(0,R.$Ve)(g.stream)).toString()}async function w(g){if(!y(g))throw new Error("Server returned "+g.res.statusCode);return c(g)}async function $(g){if(!y(g))throw new Error("Server returned "+g.res.statusCode);if(l(g))return null;const t=(await(0,R.$Ve)(g.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function f(g){h(g)}let u;function h(g){const m=d.$ho.as(D.$mo.Configuration),t=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},m.updateConfigurations({add:[u],remove:t?[t]:[]})}h(1)}),define(le[224],he([0,1,26,23,12,59]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=void 0;let D=class{constructor(P,d){this.a=P,this.b=d}async download(P,d,E=R.CancellationToken.None){if(P.scheme===L.Schemas.file||P.scheme===L.Schemas.vscodeRemote){await this.b.copy(P,d);return}const v={type:"GET",url:P.toString(!0)},y=await this.a.request(v,E);if(y.res.statusCode===200)await this.b.writeFile(d,y.stream);else{const l=await(0,j.$Yp)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${l}`)}}};e.$uQ=D,e.$uQ=D=ve([Y(0,j.$Tp),Y(1,A.$7k)],D)}),define(le[225],he([0,1,15,26]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=void 0;class A{constructor(I){this.a=I}listen(I,P){throw new Error("Invalid listen")}call(I,P,d,E=L.CancellationToken.None){switch(P){case"request":return this.a.request(d[0],E).then(async({res:v,stream:y})=>{const l=await(0,R.$Ve)(y);return[{statusCode:v.statusCode,headers:v.headers},l]});case"resolveProxy":return this.a.resolveProxy(d[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$1r=A;class j{constructor(I){this.a=I}async request(I,P){const[d,E]=await this.a.call("request",[I],P);return{res:d,stream:(0,R.$Xe)(E)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$2r=j}),define(le[226],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=e.$Vdc=void 0,e.$Vdc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Wdc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Xdc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[227],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;class R{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const j=await this.c();if(j){const D=String(R.a++);return this.b.set(D,j),{id:D,data:j.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,j){if(!A.id)return!0;const D=this.b.get(A.id);if(!D)return!1;this.b.delete(A.id);try{return D.validate(j)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$Q_b=R}),define(le[106],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl="signService",e.$Tl=(0,R.$Ai)(e.$Sl)}),define(le[228],he([0,1,227]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class L extends R.$Q_b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(D=>new D.signer().sign(j))}h(){return new Promise((j,D)=>se(["vsda"],j,D))}}e.$Lec=L}),define(le[77],he([0,1,3,2]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mLb=e.$lLb=e.$kLb=e.$jLb=void 0;class A extends L.$Uc{constructor(v,y,l){super(),this.a=v,this.b=y,this.c=l}async getItems(){const v={profile:this.b,workspace:this.c},y=await this.a.call("getItems",v);return new Map(y)}updateItems(v){const y={profile:this.b,workspace:this.c};return v.insert&&(y.insert=Array.from(v.insert.entries())),v.delete&&(y.delete=Array.from(v.delete.values())),this.a.call("updateItems",y)}optimize(){const v={profile:this.b,workspace:this.c};return this.a.call("optimize",v)}}class j extends A{constructor(v,y){super(v,y,void 0),this.f=this.B(new R.$he),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(v=>this.h(v)))}h(v){(Array.isArray(v.changed)||Array.isArray(v.deleted))&&this.f.fire({changed:v.changed?new Map(v.changed):void 0,deleted:v.deleted?new Set(v.deleted):void 0})}}class D extends j{constructor(v){super(v,void 0)}async close(){this.dispose()}}e.$jLb=D;class I extends j{constructor(v,y){super(v,y)}async close(){this.dispose()}}e.$kLb=I;class P extends A{constructor(v,y){super(v,void 0,y),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.$lLb=P;class d{constructor(v){this.a=v}isUsed(v){const y={payload:v,profile:void 0,workspace:void 0};return this.a.call("isUsed",y)}}e.$mLb=d}),define(le[107],he([0,1,5,36,32]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=D,e.$kp=I;function j(P){if(R.$u===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function D(P,d,E,v,y,l,c,w,$){const f=Object.create(null);f["common.machineId"]=l,f["common.sqmId"]=c,f.sessionID=(0,A.$Wg)()+Date.now(),f.commitHash=v,f.version=y,f["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,R.$h)(R.$u),f["common.nodePlatform"]=L.$dc,f["common.nodeArch"]=E,f["common.product"]=$||"desktop",w&&(f["common.msftInternal"]=w);let u=0;const h=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),R.$l&&(f["common.snap"]="true");const g=j(d);return g&&(f["common.platformDetail"]=g),f}function I(P){const d=L.env.USERDNSDOMAIN;if(!d)return!1;const E=d.toLowerCase();return P.some(v=>E===v)}}),define(le[18],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,R.$Ai)("telemetryService"),e.$7l=(0,R.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry",e.$bm="telemetry.telemetryLevel",e.$cm="telemetry.enableCrashReporter",e.$dm="telemetry.enableTelemetry";var L;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var A;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(le[229],he([0,1,37,6,35,23,14,5,8,146,31,152,95,12,24,18]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0,e.$Ks=f,e.$Ls=h,e.$Ms=g;const $=new Map;async function f(t,r){const s=`${t}::${r.join(":")}`,n=$.get(s);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,a=new Map,p=2e4;function S(k,C,O,M){const T=C.substring(k.length+1);return L.Promises.withAsyncBody(async F=>{let K;try{K=await E.Promises.readdir(C,{withFileTypes:!0})}catch{F();return}if(M.count>=p){M.count+=K.length,M.maxReached=!0,F();return}let J=K.length;if(J===0){F();return}let Q=K;M.count+K.length>p&&(M.maxReached=!0,J=p-M.count,Q=K.slice(0,J)),M.count+=K.length;for(const H of Q)if(H.isDirectory()){if(O.includes(H.name)||await S(k,(0,D.$jc)(C,H.name),O,M),--J===0){F();return}}else{const X=H.name.lastIndexOf(".");if(X>=0){const W=H.name.substring(X+1);W&&o.set(W,(o.get(W)??0)+1)}for(const W of i)W.relativePathPattern?.test(T)!==!1&&W.filePattern.test(H.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--J===0){F();return}}})}const b=L.Promises.withAsyncBody(async k=>{const C={count:0,maxReached:!1};await S(t,t,r,C);const O=await g(t);k({configFiles:u(a),fileTypes:u(o),fileCount:C.count,maxFilesReached:C.maxReached,launchConfigFiles:O})});return $.set(s,b),b}function u(t){return Array.from(t.entries(),([r,s])=>({name:r,count:s})).sort((r,s)=>s.count-r.count)}function h(){const t={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/l.$Cl.GB).toFixed(2)}GB (${(R.freemem()/l.$Cl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$In.value()*100)}%`},r=R.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function g(t){try{const r=new Map,s=(0,D.$jc)(t,".vscode","launch.json"),n=await E.Promises.readFile(s),i=[],o=(0,A.$Nn)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,A.$Wn)(o)==="object"&&o.configurations)for(const a of o.configurations){const p=a.type;p&&(r.has(p)?r.set(p,r.get(p)+1):r.set(p,1))}return u(r)}catch{return[]}}let m=class{constructor(r,s){this.c=r,this.d=s}f(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}g(r){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const n=R.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(R.totalmem()/l.$Cl.GB).toFixed(2)}GB (${(R.freemem()/l.$Cl.GB).toFixed(2)}GB free)`),I.$i||s.push(`Load (avg):       ${R.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round(d.$In.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,v.$Js)(r.mainPID),this.k(r)]).then(async n=>{let[i,o]=n,a=this.m(r,i);return s.forEach(p=>{if((0,y.$in)(p))a+=`
${p.errorMessage}`,o+=`
${p.errorMessage}`;else if(a+=`

Remote: ${p.hostName}`,p.processes&&(a+=`
${this.m(r,p.processes)}`),p.workspaceMetadata){o+=`
|  Remote: ${p.hostName}`;for(const S of Object.keys(p.workspaceMetadata)){const b=p.workspaceMetadata[S];let k=`${b.fileCount} files`;b.maxFilesReached&&(k=`more than ${k}`),o+=`|    Folder (${S}): ${k}`,o+=this.h(b)}}}),{processInfo:a,workspaceInfo:o}})}async getSystemInfo(r,s){const{memory:n,vmHint:i,os:o,cpus:a}=h(),p={os:o,memory:n,cpus:a,vmHint:i,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return I.$i||(p.load=`${R.loadavg().map(S=>Math.round(S)).join(", ")}`),I.$k&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(r,s){const n=[];return(0,v.$Js)(r.mainPID).then(async i=>(n.push(""),n.push(this.g(r)),n.push(""),n.push(this.m(r,i)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(r))),s.forEach(o=>{if((0,y.$in)(o))n.push(`
${o.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${o.hostName}`),n.push(this.f(o.machineInfo)),o.processes&&n.push(this.m(r,o.processes)),o.workspaceMetadata)for(const a of Object.keys(o.workspaceMetadata)){const p=o.workspaceMetadata[a];let S=`${p.fileCount} files`;p.maxFilesReached&&(S=`more than ${S}`),n.push(`Folder (${a}): ${S}`),n.push(this.h(p))}}),n.push(""),n.push(""),n.join(`
`)))}h(r){const s=[];let i=0;const o=(b,k)=>{const C=` ${b}(${k})`;i+C.length>60?(s.push(a),a="|                 ",i=a.length):i+=C.length,a+=C};let a="|      File types:";const p=10,S=r.fileTypes.length>p?p:r.fileTypes.length;for(let b=0;b<S;b++){const k=r.fileTypes[b];o(k.name,k.count)}if(s.push(a),r.configFiles.length>=0&&(a="|      Conf files:",i=0,r.configFiles.forEach(b=>{o(b.name,b.count)}),s.push(a)),r.launchConfigFiles.length>0){let b="|      Launch Configs:";r.launchConfigFiles.forEach(k=>{const C=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;b+=C}),s.push(b)}return s.join(`
`)}j(r){const s=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${r[n]}`).join(`
                  `)}k(r){const s=[],n=[];return r.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(o=>{const a=P.URI.revive(o);if(a.scheme===j.Schemas.file){const p=a.fsPath;n.push(f(p,["node_modules",".git"]).then(S=>{let b=`${S.fileCount} files`;S.maxFilesReached&&(b=`more than ${b}`),s.push(`|    Folder (${(0,D.$nc)(p)}): ${b}`),s.push(this.h(S))}).catch(S=>{s.push(`|      Error: Unable to collect workspace stats for folder ${p} (${S.toString()})`)}))}else s.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(r,s){const n=new Map;r.windows.forEach(o=>n.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:a})=>n.set(o,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.n(r.mainPID,n,i,s,0),i.join(`
`)}n(r,s,n,i,o){const a=o===0;let p;a?p=i.pid===r?`${this.d.applicationName} main`:"remote agent":s.has(i.pid)?p=s.get(i.pid):p=`${"  ".repeat(o)} ${i.name}`;const S=process.platform==="win32"?i.mem:R.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(S/l.$Cl.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(i.children)&&i.children.forEach(b=>this.n(r,s,n,b,o+1))}async getWorkspaceFileExtensions(r){const s=new Set;for(const{uri:n}of r.folders){const i=P.URI.revive(n);if(i.scheme!==j.Schemas.file)continue;const o=i.fsPath;try{(await f(o,["node_modules",".git"])).fileTypes.forEach(p=>s.add(p.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const n=P.URI.revive(s);if(n.scheme!==j.Schemas.file)continue;const i=n.fsPath;try{const o=await f(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Ns=m,e.$Ns=m=ve([Y(0,w.$6l),Y(1,c.$nk)],m)}),define(le[108],he([0,1,7,4,9,18]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=e.ExtensionSignatureVerificationCode=e.$fq=void 0,e.$fq=(0,L.$Ai)("IExtensionSignatureVerificationService");var D;(function(d){d.None="None",d.RequiredArgumentMissing="RequiredArgumentMissing",d.InvalidArgument="InvalidArgument",d.PackageIsUnreadable="PackageIsUnreadable",d.UnhandledException="UnhandledException",d.SignatureManifestIsMissing="SignatureManifestIsMissing",d.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",d.SignatureIsMissing="SignatureIsMissing",d.SignatureIsUnreadable="SignatureIsUnreadable",d.CertificateIsUnreadable="CertificateIsUnreadable",d.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",d.FileAlreadyExists="FileAlreadyExists",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",d.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",d.Success="Success",d.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",d.SignatureIsInvalid="SignatureIsInvalid",d.SignatureManifestIsInvalid="SignatureManifestIsInvalid",d.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",d.EntryIsMissing="EntryIsMissing",d.EntryIsTampered="EntryIsTampered",d.Untrusted="Untrusted",d.CertificateRevoked="CertificateRevoked",d.SignatureIsNotValid="SignatureIsNotValid",d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(D||(e.ExtensionSignatureVerificationCode=D={}));class I extends Error{constructor(E){super(E),this.code=E}}e.$gq=I;let P=class{constructor(E,v){this.b=E,this.c=v}d(){return this.a||(this.a=new Promise((E,v)=>se(["@vscode/vsce-sign"],async y=>E(y),v))),this.a}async verify(E,v,y,l){let c;const w=E.identifier.id;try{c=await this.d()}catch(h){return this.b.error("Could not load vsce-sign module",(0,R.$0)(h)),this.b.info(`Extension signature verification is not done: ${w}`),!1}const $=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${w}...`),f=await c.verify(v,y,this.b.getLevel()===A.LogLevel.Trace)}catch(h){f={code:"UnknownError",didExecute:!1,output:(0,R.$0)(h)}}const u=new Date().getTime()-$;if(this.b.info(`Extension signature verification result for ${w}: ${f.code}. Executed: ${f.didExecute}. Duration: ${u}ms.`),this.b.trace(`Extension signature verification output for ${w}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:w,extensionVersion:E.version,code:f.code,internalCode:f.internalCode,duration:u,didExecute:f.didExecute,clientTargetPlatform:l}),f.code==="Success")return!0;throw new I(f.code)}};e.$hq=P,e.$hq=P=ve([Y(0,A.$7j),Y(1,j.$6l)],P)}),define(le[109],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=e.$1dc=void 0;class R{constructor(j){this.b=j}listen(j,D){throw new Error(`Event not found: ${D}`)}call(j,D,{eventName:I,data:P}){return this.b.forEach(d=>d.log(I,P)),Promise.resolve(null)}}e.$1dc=R;class L{constructor(j){this.b=j}log(j,D){return this.b.call("log",{eventName:j,data:D}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$2dc=L}),define(le[49],he([0,1,30,13,103,107,18]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0,e.$sp=E,e.$tp=v,e.$up=y,e.$vp=l,e.$wp=w,e.$xp=f,e.$yp=u,e.$zp=m;class I{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$lp=I;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$mp=P,e.$np=new P;class d{async publicLog(r,s,n){}async publicLogError(r,s,n){}}e.$op=d,e.$pp="telemetry",e.$qp="extensionTelemetryLog",e.$rp={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function v(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function y(t){const r=t.getValue(D.$bm),s=t.getValue(D.$cm);if(t.getValue(D.$dm)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function l(t){const r={},s={},n={};$(t,n);for(let i in n){i=i.length>150?i.substr(i.length-149):i;const o=n[i];typeof o=="number"?s[i]=o:typeof o=="boolean"?s[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),r[i]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[i]=o)}return{properties:r,measurements:s}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function w(t){if(!t)return"none";const r=(0,A.$Mm)(t);return c.has(r)?r:"other"}function $(t,r,s=0,n){if(t)for(const i of Object.getOwnPropertyNames(t)){const o=t[i],a=n?n+i:i;Array.isArray(o)?r[a]=(0,R.$_n)(o):o instanceof Date?r[a]=o.toISOString():(0,L.$cg)(o)?s<2?$(o,r,s+1,a+"."):r[a]=(0,R.$_n)(o):r[a]=o}}function f(t,r){const s=t.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,j.$kp)(s)||n}function u(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function h(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const n=[];for(const p of r)for(;;){const S=p.exec(t);if(!S)break;n.push([S.index,p.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(s="";;){const p=o.exec(t);if(!p)break;const S=n.some(([b,k])=>p.index<k&&b<o.lastIndex);!i.test(p[0])&&!S&&(s+=t.substring(a,p.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<t.length&&(s+=t.substr(a)),s}function g(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of r)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function m(t,r){return(0,R.$9n)(t,s=>{if(s instanceof I||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let n=s.replaceAll("%20"," ");n=h(n,r);for(const i of r)n=n.replace(i,"");return n=g(n),n}})}}),define(le[33],he([0,1,27,28,48,5,8,7,36,49]),function(se,e,R,L,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Bp=void 0,e.$Ap=E,e.$Cp=c,e.$Dp=w,e.$Ep=$,e.$Fp=f,e.$Gp=u,e.$Hp=h,e.$Ip=g,e.$Kp=m,e.$Lp=r;function E(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,R.$wf)(s.id,n.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(n){const i=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new y(n.identifier,i,o)}static parse(n){const i=v.exec(n);return i&&i[1]&&i[2]?new y({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,o="undefined"){this.identifier=n,this.version=i,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof y?E(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Bp=y;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(s){const n=l.exec(s);return n&&n[1]?[$(n[1]),n[2]]:[$(s),void 0]}function w(s,n){return`${s}.${n}`}function $(s){return s.toLowerCase()}function f(s,n){return $(w(s??A.$Rm,n))}function u(s,n){const i=[],o=a=>{for(const p of i)if(p.some(S=>E(n(S),n(a))))return p;return null};for(const a of s){const p=o(a);p?p.push(a):i.push([a])}return i}function h(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function g(s){return{id:new d.$lp(s.identifier.id),name:new d.$lp(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Jp=new A.$Vm("pprice.better-merge");function m(s,n){const i=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&i.every(p=>!E(p.identifier,{id:a}))){const p=s.filter(S=>E(S.identifier,{id:a}));p.length===1&&(i.push(p[0]),o.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}async function t(s,n){if(!j.$k)return!1;let i;try{i=(await s.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,I.$0)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,n){const i=await t(s,n),o=(0,L.$8o)(i?"alpine":j.$u,P.$ec);return n.debug("ComputeTargetPlatform:",o),o}}),define(le[230],he([0,1,17,2,21,8,12,24,6,3,14,5,36,33]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=e.$Zbc=void 0;let c=class extends L.$Uc{constructor(h,g){super(),this.b=h,this.c=g,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,m])=>this.a.set(m.configPath,m))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const g=[];for(const[m,t]of this.a)if(!(t.configScheme&&t.configScheme!==h.scheme))try{const r=(await this.b.readFile((0,A.$bh)(h,m))).value.toString();for(const[s,n]of Object.entries(t.recommendations))(!n.contentPattern||new RegExp(n.contentPattern,"mig").test(r))&&g.push({extensionId:s,extensionName:n.name,configName:t.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled})}catch{}return g}};e.$Zbc=c,e.$Zbc=c=ve([Y(0,D.$7k),Y(1,I.$nk)],c);const w="extensionTips/promptedExecutableTips",$="extensionTips/lastPromptedMediumImpExeTime";class f extends c{constructor(h,g,m,t,r,s,n,i){super(n,i),this.r=h,this.s=g,this.t=m,this.u=t,this.w=r,this.z=s,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([o,a])=>{const p=[],S=[],b=[];Object.entries(a.recommendations).forEach(([k,C])=>{C.important?a.important?p.push({extensionId:k,extensionName:C.name,isExtensionPack:!!C.isExtensionPack}):S.push({extensionId:k,extensionName:C.name,isExtensionPack:!!C.isExtensionPack}):b.push({extensionId:k,extensionName:C.name,isExtensionPack:!!C.isExtensionPack})}),p.length&&this.g.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:p}),S.length&&this.h.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:S}),b.length&&this.j.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b})}),(0,P.$Ch)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),g=await this.O(this.h);return[...h,...g]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),g=await this.O(this.h),m=await this.u.getInstalled();this.m=this.D(h,m),this.n=this.D(g,m)}D(h,g){const m=new Map;h.forEach(i=>m.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:r}=this.N([...m.keys()],g);for(const i of t){const o=m.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:o.exeName})}for(const i of r){const o=m.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:o.exeName})}const s=this.L(),n=new Map;for(const i of r){const o=m.get(i);if(o&&(!s[o.exeName]||!s[o.exeName].includes(o.extensionId))){let a=n.get(o.exeName);a||(a=[],n.set(o.exeName,a)),a.push(o)}}return n}F(){if(this.m.size===0)return;const[h,g]=[...this.m.entries()][0];this.H(g).then(m=>{switch(m){case"reacted":this.M(g[0].exeName,g);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const t=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B(new L.$Vc);t.value=(0,P.$Ch)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),g=Date.now()-h,m=7*24*60*60*1e3;if(g<m){const s=this.B(new L.$Vc);s.value=(0,P.$Ch)(()=>{s.dispose(),this.G()},m-g);return}const[t,r]=[...this.n.entries()][0];this.H(r).then(s=>{switch(s){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(r[0].exeName,r);const n=this.B(new L.$Vc);n.value=(0,P.$Ch)(()=>{n.dispose(),this.G()},m);break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const n=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(n(()=>this.G()));break}case"toomany":{const n=this.B(new L.$Vc);n.value=(0,P.$Ch)(()=>{n.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const g=await this.u.getInstalled(1),m=h.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(r=>g.every(s=>!(0,l.$Ap)(s.identifier,{id:r})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:m,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber($,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store($,h,-1,1)}L(){return JSON.parse(this.w.get(w,-1,"{}"))}M(h,g){const m=this.L();m[h]=g.map(({extensionId:t})=>t.toLowerCase()),this.w.store(w,JSON.stringify(m),-1,0)}N(h,g){const m=[],t=[],r=g.reduce((s,n)=>(s.add(n.identifier.id.toLowerCase()),s),new Set);return h.forEach(s=>{r.has(s.toLowerCase())?m.push(s):t.push(s)}),{installed:m,uninstalled:t}}async O(h){const g=[],m=new Map;for(const t of h.keys()){const r=h.get(t);if(!r||!(0,R.$Lb)(r.recommendations))continue;const s=[];v.$i?r.windowsPath&&s.push(r.windowsPath.replace("%USERPROFILE%",()=>y.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>y.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>y.env.ProgramFiles).replace("%APPDATA%",()=>y.env.APPDATA).replace("%WINDIR%",()=>y.env.WINDIR)):(s.push((0,E.$jc)("/usr/local/bin",t)),s.push((0,E.$jc)("/usr/bin",t)),s.push((0,E.$jc)(this.r.fsPath,t)));for(const n of s){let i=m.get(n);if(i===void 0&&(i=await this.b.exists(j.URI.file(n)),m.set(n,i)),i)for(const{extensionId:o,extensionName:a,isExtensionPack:p,whenNotInstalled:S}of r.recommendations)g.push({extensionId:o,extensionName:a,isExtensionPack:p,exeName:t,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:S})}}return g}}e.$1bc=f}),define(le[231],he([0,1,26,33]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=A;async function A(j,D,I,P,d){try{const E=await j.getExtensionsControlManifest();if(!E.deprecated)return;const v=await j.getInstalled(1);for(const[y,l]of Object.entries(E.deprecated)){if(!l?.extension)continue;const{id:c,autoMigrate:w,preRelease:$}=l.extension;if(!w)continue;const f=v.find(h=>(0,L.$Ap)(h.identifier,{id:y}));if(!f)continue;const u=(await D.getExtensions([{id:c,preRelease:$}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!u){d.info(`Skipping migrating '${f.identifier.id}' extension because, the comaptible target '${c}' extension is not found`);continue}try{d.info(`Migrating '${f.identifier.id}' extension to '${c}' extension...`);const h=!P.getDisabledExtensions().some(m=>(0,L.$Ap)(m,f.identifier));await j.uninstall(f),d.info(`Uninstalled the unsupported extension '${f.identifier.id}'`);let g=v.find(m=>(0,L.$Ap)(m.identifier,{id:c}));(!g||!g.isPreReleaseVersion&&h)&&(g=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:f.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${g.identifier.id}'`),h||(await P.disableExtension(g.identifier),d.info(`Disabled the pre-release extension '${g.identifier.id}' because the unsupported extension '${f.identifier.id}' is disabled`)),w.storage&&(I.addToMigrationList((0,L.$Dp)(f.manifest.publisher,f.manifest.name),(0,L.$Dp)(g.manifest.publisher,g.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${f.identifier.id}' extension to '${c}' extension.`)}catch(h){d.error(h)}}}catch(E){d.error(E)}}}),define(le[232],he([0,1,3,2,34,33,48]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class I extends L.$Uc{constructor(d,E,v,y,l,c,w){super(),this.f=d,this.g=E,this.h=v,this.j=y,this.m=l,this.n=c,this.r=w,this.a=this.B(new R.$he),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.$4c),this.s().then(null,$=>w.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(E=>(this.c.set(E.id,(0,L.$Rc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w(d){for(const E of d.extensions)this.I(this.L(E.identifier,E.version),d.profileLocation)}async y(d){for(const E of d.extensions){const v=this.L(E.identifier,E.version);d.error?this.J(v,d.profileLocation):this.I(v,d.profileLocation)}}async z(d){for(const E of d.extensions)this.J(this.L(E.identifier,E.version),d.profileLocation)}async C(d){const E=[],v=[];for(const y of d.extensions){const l=this.L(y.identifier,y.version);d.error?this.I(l,d.profileLocation):(this.J(l,d.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",y.identifier.id,y.version),v.push(this.f.scanInstalledExtensionAtLocation(y.location).then(c=>{c?E.push(c):this.r.info("Extension not found at the location",y.location.toString())},c=>this.r.error(c)))))}try{await Promise.all(v),E.length&&await this.H(E)}catch(y){this.r.error(y)}}D(d){for(const E of this.h.profiles)d.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F(d){const E=[],v=[],y=await this.j.scanProfileExtensions(d),l=new Set,c=new Set;for(const[w,$]of this.b)$.has(d)&&c.add(w);for(const w of y){const $=this.L(w.identifier,w.version);l.add($),c.has($)||(E.push(w.identifier),this.I($,d))}for(const w of c)if(!l.has(w)){const $=this.M(w);$&&(v.push($.identifier),this.J(w,d))}(E.length||v.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:d}:void 0,removed:v.length?{extensions:v,profileLocation:d}:void 0})}async G(d){const E=await this.j.scanProfileExtensions(d);for(const v of E)this.I(this.L(v.identifier,v.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,E){let v=this.b.get(d);v||this.b.set(d,v=new A.$Bc(y=>this.m.extUri.getComparisonKey(y))),v.add(E)}J(d,E){const v=this.b.get(d);v&&v.delete(E),v?.size||this.b.delete(d)}L(d,E){return`${D.$Vm.toKey(d.id)}@${E}`}M(d){const[E,v]=(0,j.$Cp)(d);return v?{identifier:{id:E},version:v}:void 0}}e.$Jq=I}),define(le[233],he([0,1,45,49]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=A;async function A(j,D,I,P,d,E,v){const y={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${D.nameShort})`};if((0,L.$sp)(D,I)&&(0,L.$up)(P)===3){const l=await(0,R.$aq)(I,d,E);y["X-Market-User-Id"]=l,y["VSCode-SessionId"]=v.machineId||l}return y}}),define(le[234],he([0,1,73,17,6,2,23,14,31,16,28,33,9,75,8]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;let w=class extends l.$Yr{constructor(h,g,m,t){super(m),this.h=h,this.j=t,this.g=this.B(new $(g,t)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(h,g){const t=(await this.g.getLanguagePacks())[g];if(!t){this.j.warn(`No language pack found for ${g}`);return}const r=t.translations[h];return r?c.URI.file(r):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),g=Object.keys(h).map(m=>{const t=h[m];return{...this.f(m,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((m,t)=>m.label.localeCompare(t.label)),g}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const g=await this.g.getLanguagePacks();Object.keys(g).some(m=>g[m]&&g[m].extensions.some(t=>(0,v.$Ap)(t.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),m=await this.g.update(g);return!(0,L.$ub)(Object.keys(h),Object.keys(m))}};e.$Zr=w,e.$Zr=w=ve([Y(0,E.$cp),Y(1,d.$Ii),Y(2,E.$_o),Y(3,y.$7j)],w);let $=class extends j.$Uc{constructor(h,g){super(),this.j=g,this.c={},this.f=(0,I.$jc)(h.userDataPath,"languagepacks.json"),this.g=new A.$Hh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(g=>{Object.keys(g).forEach(m=>delete g[m]),this.m(g,...h)}).then(()=>this.c)}m(h,...g){for(const m of g)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.n(h,m);Object.keys(h).forEach(m=>this.r(h[m]))}n(h,g){const m=g.identifier,t=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const r of t)if(g.location.scheme===D.Schemas.file&&f(r)){let s=h[r.languageId];s||(s={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},h[r.languageId]=s);const n=s.extensions.filter(i=>(0,v.$Ap)(i.extensionIdentifier,m))[0];n?n.version=g.manifest.version:s.extensions.push({extensionIdentifier:m,version:g.manifest.version});for(const i of r.translations)s.translations[i.id]=(0,I.$jc)(g.location.fsPath,i.path)}}r(h){if(h){const g=(0,R.createHash)("md5");for(const m of h.extensions)g.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);h.hash=g.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let g=null;return P.Promises.readFile(this.f,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(g=h(m),m)).then(m=>{for(const r of Object.keys(m))m[r]||delete m[r];this.c=m,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),P.Promises.writeFile(this.f,t)}).then(()=>g,m=>this.j.error(m))})}};$=ve([Y(0,d.$Ii),Y(1,y.$7j)],$);function f(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const h of u.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(le[235],he([0,1,145,7,30,49]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function P(E,v,y){const l=await(0,R.$bE)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,R.$bE)("@microsoft/1ds-post-js","dist/ms.post.js"),w=new l.AppInsightsCore,$=new c.PostChannel,f={instrumentationKey:E,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(y){f.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:y};f.extensionConfig[$.identifier]=u}return w.initialize(f,[]),w.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),w}class d{constructor(v,y,l,c,w){this.e=v,this.f=y,this.g=l,this.h=w,this.c=D,this.d=I,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(y=>{v(y)},y=>{(0,L.$1)(y),console.error(y)})}}log(v,y){if(!this.a)return;y=(0,A.$0n)(y,this.g),y=(0,j.$vp)(y);const l=this.f+"/"+v;try{this.i(c=>{c.pluginVersionString=y?.properties.version??"Unknown",c.track({name:l,baseData:{name:l,properties:y?.properties,measurements:y?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(y=>{y.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$5P=d}),define(le[110],he([0,1,2,174,16,9,24,49]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=void 0;let P=class extends R.$Uc{constructor(E,v,y,l,c=""){super(),this.b=c;const w=v.getLogger(I.$pp);if(w)this.a=this.B(w);else{const f=(0,I.$tp)(l,y)?" (Not Sent)":"",u=()=>(0,I.$sp)(l,y)&&E.getLevel()===j.LogLevel.Trace;this.a=this.B(v.createLogger(I.$pp,{name:(0,L.localize)(0,null,f),hidden:!u()})),this.B(E.onDidChangeLogLevel(()=>v.setVisibility(I.$pp,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(E,v){this.a.trace(`${this.b}telemetry/${E}`,(0,I.$vp)(v))}};e.$nbc=P,e.$nbc=P=ve([Y(0,j.$7j),Y(1,j.$8j),Y(2,A.$Hi),Y(3,D.$nk)],P)}),define(le[111],he([0,1,2,30,5,27,175,22,47,101,24,43,18,49]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=void 0;let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,u,h){this.k=u,this.l=h,this.d={},this.i=new R.$Tc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,j.$df)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$df)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(y.$bm)||g.affectsConfiguration(y.$dm)||g.affectsConfiguration(y.$cm))&&this.m()}))}setExperimentProperty(f,u){this.d[f]=u}m(){let f=(0,l.$up)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const h=u.usage?3:u.error?2:0;f=Math.min(f,h)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,u,h){this.g<u||(h=(0,L.$0n)(h,this.d),h=(0,l.$zp)(h,this.j),h=(0,L.$0n)(h,this.c),this.b.forEach(g=>g.log(f,h)))}publicLog(f,u){this.n(f,3,u)}publicLog2(f,u){this.publicLog(f,u)}publicLogError(f,u){this.h&&this.n(f,2,u)}publicLogError2(f,u){this.publicLogError(f,u)}};e.$6r=c,e.$6r=c=ve([Y(1,I.$7i),Y(2,E.$nk)],c);function w(){const $=(0,D.localize)(0,null,d.default.nameLong),f=d.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=A.$o?"":(0,D.localize)(3,null),h=(0,D.localize)(4,null),g=(0,D.localize)(5,null),m=(0,D.localize)(6,null),t=(0,D.localize)(7,null),r=`
|       | ${h} | ${g} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,D.localize)(8,null);return`
${$} ${f} ${u}

&nbsp;

${t}
${r}

&nbsp;

${s}
`}v.$ho.as(P.$mo.Configuration).registerConfiguration({id:y.$am,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[y.$bm]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$ho.as(P.$mo.Configuration).registerConfiguration({id:y.$am,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.$dm]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,D.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,D.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.$bm}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[236],he([0,1,15,26,278,235]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=void 0;async function D(E,v){const y=await v.request(E,L.CancellationToken.None),l=(await(0,R.$Ve)(y.stream)).toString(),c=y.res.statusCode??200;return{headers:y.res.headers,statusCode:c,responseData:l}}async function I(E){const v={method:E.type,headers:E.headers};return new Promise((l,c)=>{const w=A.request(E.url??"",v,$=>{$.on("data",function(f){l({headers:$.headers,statusCode:$.statusCode??200,responseData:f.toString()})}),$.on("error",function(f){c(f)})});w.write(E.data,$=>{$&&c($)}),w.end()})}async function P(E,v,y){const l=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),c={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:l};try{const w=E?await D(c,E):await I(c);y(w.statusCode,w.headers,w.responseData)}catch{y(0,{})}}class d extends j.$5P{constructor(v,y,l,c,w){const $={sendPOST:(f,u)=>{P(v,f,u)}};super(y,l,c,w,$)}}e.$6P=d}),define(le[237],he([0,1,23,93,22,16,9,24,18,109,110,111]),function(se,e,R,L,A,j,D,I,P,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;let y=class{constructor(c,w,$,f,u,h){this.b=c,this.c=w,this.d=$,this.e=f,this.f=u,this.g=h,this.a=new Map}h(c){if(!this.a.has(c.id)){const w=Object.create(null);w["common.vscodemachineid"]=this.c.machineId,w["common.vscodesessionid"]=this.c.sessionId;const $=[c.id,JSON.stringify(w),c.aiKey],u=new L.$7q(R.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:$,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new d.$2dc(u),new E.$nbc(this.d,this.e,this.f,this.g,`[${c.id}] `)];this.a.set(c.id,new v.$6r({appenders:h,sendErrorTelemetry:c.sendErrorTelemetry},this.b,this.g))}return this.a.get(c.id)}publicLog(c,w,$){this.h(c).publicLog(w,$)}publicLogError(c,w,$){this.h(c).publicLogError(w,$)}};e.$jfc=y,e.$jfc=y=ve([Y(0,A.$7i),Y(1,P.$6l),Y(2,D.$7j),Y(3,D.$8j),Y(4,j.$Hi),Y(5,I.$nk)],y)}),define(le[78],he([0,1,3,8,22,4,9]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zw=e.$yw=e.$vw=e.$tw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$pw=e.$ow=void 0,e.$qw=d,e.$rw=v,e.$sw=y,e.$uw=l,e.$ww=c,e.$xw=w,e.$ow=(0,j.$Ai)("tunnelService"),e.$pw=(0,j.$Ai)("sharedTunnelsService");var I;(function(u){u.Http="http",u.Https="https"})(I||(e.TunnelProtocol=I={}));var P;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(P||(e.TunnelPrivacyId=P={}));function d(u){return!!u.forwardPort}var E;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function v(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(h)return{address:h[1],port:+h[2]}}function y(u){if(u.scheme!=="http"&&u.scheme!=="https"||!u.query)return;const h=u.query.split("&");for(const g of h){const m=g.split("=")[1];if(/^https?:/.exec(m)){const t=v(L.URI.parse(m));if(t)return t}}}e.$tw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(u){return e.$tw.indexOf(u)>=0}e.$vw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(u){return e.$vw.indexOf(u)>=0}function w(u,h,g,m){if(g===1)return!1;if(g===2&&c(h)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(t?.length===4&&parseInt(t[1])>=18)return!1}return u<1024}class ${constructor(h,g,m){this.remoteAddress=h,this.localAddress=g,this.b=m,this.a=new R.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$yw=$;let f=class{constructor(h,g){this.k=h,this.l=g,this.a=new R.$he,this.onTunnelOpened=this.a.event,this.b=new R.$he,this.onTunnelClosed=this.b.event,this.c=new R.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],g=Array.from(this.e.values());for(const m of g){const t=Array.from(m.values());for(const r of t){const s=await r.value;s&&typeof s!="string"&&h.push(s)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:g}of h.values())await g.then(m=>typeof m!="string"?m?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,g,m,t,r){this.q(h,g,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:g,localAddress:m,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,g){(c(h)||l(h))&&(h=e.$tw[0]);const m=this.s(h,g);if(m)return++m.refcount,m.value}openTunnel(h,g,m,t,r,s=!1,n,i){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${m} on local port ${r}.`);const o=this.f??h;if(!o)return;if(g||(g="localhost"),t||(t=this.m),this.f&&this.j.has(m)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(o,g,m,t,r,s,n,i);return a?a.then(p=>{if(p){if(typeof p=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(g,m),p}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(g,m);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(p);return(p.tunnelRemoteHost!==g||p.tunnelRemotePort!==m)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&p.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const g=this.e.get(h.tunnelRemoteHost);if(g){const m=g.get(h.tunnelRemotePort);m&&(m.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,m))}}}}async p(h,g,m){if(m.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${g}.`);const t=m.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(g),t}}async closeTunnel(h,g){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${g} `);const m=this.e.get(h);if(m&&m.has(g)){const t=m.get(g);t.refcount=0,await this.p(h,g,t)}}q(h,g,m){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(g,{refcount:1,value:m})}async r(h,g){const m=this.e.get(h);if(m){const t=m.get(g),r=t?await t.value:void 0;(!r||typeof r=="string")&&m.delete(g),m.size===0&&this.e.delete(h)}}s(h,g){const m=[h];l(h)?(m.push(...e.$tw),m.push(...e.$vw)):c(h)&&m.push(...e.$vw);const t=m.map(r=>this.e.get(r));for(const r of t){const s=r?.get(g);if(s)return s}}canTunnel(h){return!!v(h)}u(h,g,m,t,r,s,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${m} on local port ${t}.`);const i=m;this.j.add(i);const o=t===void 0?m:t,a={elevationRequired:r?this.isPortPrivileged(o):!1},p={remoteAddress:{host:g,port:m},localAddressPort:t,privacy:s,public:s?s!==P.Private:void 0,protocol:n},S=h.forwardPort(p,a);return S?(this.q(g,m,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(i)})):this.j.delete(i),S}};e.$zw=f,e.$zw=f=ve([Y(0,D.$7j),Y(1,A.$7i)],f)}),define(le[238],he([0,1,9,78,2,7,6]),function(se,e,R,L,A,j,D){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class P extends A.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new D.$Xh),this.b.p)}setAddress(v){this.a=v,this.b&&(this.b.complete(v),this.b=null)}setTunnel(v){this.B(v)}}let d=class extends A.$Uc{static{I=this}static{this.a=0}constructor(v,y){super(),this.f=v,this.g=y,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(v=>v.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(v,y,l,c,w,$,f){const u=new P,h=await Promise.resolve(this.f.openTunnel(v,u,l,c,w,$,f));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${c} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(y))throw this.c.delete(y),u.dispose(),await h.dispose(),(0,j.$6)();return u.setTunnel(h),this.b.set(y,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${y}: ${h.localAddress} (local) to ${l}:${c} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(v,y){const l=this.b.get(v);l&&l.setAddress(y)}async destroyTunnel(v){const y=this.b.get(v);if(y){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${v}.`),this.b.delete(v),await y.dispose();return}this.c.add(v)}};e.$tfc=d,e.$tfc=d=I=ve([Y(0,L.$pw),Y(1,R.$7j)],d)}),define(le[29],he([0,1,4]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,R.$Ai)("IUriIdentityService")}),define(le[239],he([0,1,29,192,12,21,130,3,2]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class d{static{this._clock=0}constructor(y){this.uri=y,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let E=class{constructor(y){this.g=y,this.c=new P.$Tc,this.f=2**16;const l=new Map,c=w=>{let $=l.get(w.scheme);return $===void 0&&($=y.hasProvider(w)&&!this.g.hasCapability(w,1024),l.set(w.scheme,$)),$};this.c.add(I.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(w=>{l.delete(w.scheme)})),this.extUri=new j.$3g(c),this.d=new D.$Fs((w,$)=>this.extUri.compare(w,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,j.$ch)(y));const l=this.d.get(y);return l?l.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new d(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((c,w)=>c[1].time<w[1].time?1:c[1].time>w[1].time?-1:0);d._clock=0,this.d.clear();const l=this.f*.5;for(let c=0;c<l;c++)this.d.set(y[c][0],y[c][1].touch())}};e.$Gs=E,e.$Gs=E=ve([Y(0,A.$7k)],E),(0,L.$Ds)(R.$El,E,1)}),define(le[240],he([0,1,3,2,12,51,34]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class I extends L.$Uc{constructor(d,E,v,y,l,c){super(),this.f=d,this.g=E,this.h=v,this.j=y,this.m=l,this.n=c,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new R.$he),this.onDidChangeFile=this.a.event,this.b=j.$Gi.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,E){return this.g.open(this.t(d),E)}close(d){return this.g.close(d)}read(d,E,v,y,l){return this.g.read(d,E,v,y,l)}write(d,E,v,y,l){return this.g.write(d,E,v,y,l)}watch(d,E){this.b.set(d,d);const v=this.g.watch(this.t(d),E);return(0,L.$Sc)(()=>{this.b.delete(d),v.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,E,v){return this.g.rename(this.t(d),this.t(E),v)}readFile(d,E){return this.g.readFile(this.t(d),E)}readFileStream(d,E,v){return this.g.readFileStream(this.t(d),E,v)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,E,v){return this.g.writeFile(this.t(d),E,v)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,E){return this.g.delete(this.t(d),E)}copy(d,E,v){if((0,A.$$k)(this.g))return this.g.copy(this.t(d),this.t(E),v);throw new Error("copy not supported")}cloneFile(d,E){if((0,A.$_k)(this.g))return this.g.cloneFile(this.t(d),this.t(E));throw new Error("clone not supported")}s(d){const E=[];for(const v of d){if(v.resource.scheme!==this.f)continue;const y=this.u(v.resource);this.b.findSubstr(y)&&E.push({resource:y,type:v.type,cId:v.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$Oec=I}),define(le[79],he([0,1,62]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=L,e.$2Kb=A,e.$3Kb=j;function L(D,I,P,d){const E=(0,R.$3n)(D,I,P,d)[0];return E&&(D=D.substring(0,E.offset)+E.content+D.substring(E.offset+E.length)),D}function A(D,I,P){let d=P;for(;d>=0;){if(D.charAt(d)===I.charAt(I.length-1)&&I.length===1)return d+1;if(d--,I.length===2&&d>=0&&D.charAt(d)===I.charAt(0))return d+2}return 0}function j(D,I,P){let d=P;for(;d>=0;)if(D.charAt(d)===I.charAt(I.length-1)&&I.length===1||(d++,I.length===2&&d>=0&&D.charAt(d)===I.charAt(1)))return d;return D.length-1}}),define(le[241],he([0,1,30,55,13]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4_b=j;function j(l,c,w,$,f,u){const h=[],g=[],m=[];if(!c){const F=l.filter(({identifier:K})=>f.every(J=>J.toLowerCase()!==K.id.toLowerCase()));return{local:{added:h,removed:g,updated:m},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}l=l.map(v),c=c.map(v),w=w?w.map(v):null;const t=new Map,r=F=>{F.uuid&&t.set(F.id.toLowerCase(),F.uuid)};l.forEach(({identifier:F})=>r(F)),c.forEach(({identifier:F})=>r(F)),w?.forEach(({identifier:F})=>r(F)),$?.forEach(({identifier:F})=>r(F)),u?.forEach(F=>r(F));const s=F=>{const K=F.identifier.uuid||t.get(F.identifier.id.toLowerCase());return K?`uuid:${K}`:`id:${F.identifier.id.toLowerCase()}`},n=(F,K)=>(F.set(s(K),K),F),i=l.reduce(n,new Map),o=c.reduce(n,new Map),a=c.reduce((F,K)=>n(F,(0,R.$7n)(K)),new Map),p=w?w.reduce(n,new Map):null,S=$.reduce(n,new Map),b=f.reduce((F,K)=>{const J=t.get(K.toLowerCase());return F.add(J?`uuid:${J}`:`id:${K.toLowerCase()}`)},new Set),k=u?u.reduce((F,{id:K,uuid:J})=>(J=J??t.get(K.toLowerCase()),F.add(J?`uuid:${J}`:`id:${K.toLowerCase()}`)),new Set):null,C=D(i,o,b,!1);if(C.added.size>0||C.removed.size>0||C.updated.size>0){const F=D(p,i,b,!1),K=D(p,o,b,!0),J=(Q,H,X,W)=>{let B,ie,re;return H.installed?(B=W.pinned,re=W.preRelease,B&&(ie=W.version)):(B=X.pinned,re=X.preRelease,B&&(ie=X.version)),B===void 0&&(B=H.pinned,B&&(ie=H.version)),re===void 0&&(re=H.preRelease),{...W,installed:H.installed||X.installed,pinned:B,preRelease:re,version:ie??(X.version&&(!H.installed||L.gt(X.version,H.version))?X.version:H.version),state:P(H,X,p?.get(Q))}};for(const Q of K.removed.values()){const H=i.get(Q);if(!H)continue;const X=(0,A.$lg)(p?.get(Q)),W=k&&!k.has(Q)&&X.installed;H.installed&&W?g.push(H.identifier):a.set(Q,H)}for(const Q of K.added.values()){const H=(0,A.$lg)(o.get(Q)),X=i.get(Q);if(X){if(C.updated.has(Q)){const W=J(Q,X,H,H);I(X,H,!1,!1)||m.push(y(W,Q)),a.set(Q,W)}}else H.installed&&h.push(y(H,Q))}for(const Q of K.updated.values()){const H=(0,A.$lg)(o.get(Q)),X=(0,A.$lg)(p?.get(Q)),W=i.get(Q);if(W)if(k&&!k.has(Q)&&X.installed&&W.installed&&!H.installed)g.push(W.identifier);else{const ie=J(Q,W,H,H);m.push(y(ie,Q)),a.set(Q,ie)}else H.installed&&h.push(y(H,Q))}for(const Q of F.added.values())K.added.has(Q)||a.set(Q,(0,A.$lg)(i.get(Q)));for(const Q of F.updated.values()){if(K.removed.has(Q)||K.updated.has(Q))continue;const H=(0,A.$lg)(i.get(Q)),X=(0,A.$lg)(o.get(Q));a.set(Q,J(Q,H,X,H))}for(const Q of F.removed.values())K.updated.has(Q)||K.removed.has(Q)||S.has(Q)||(0,A.$lg)(o.get(Q)).installed&&k&&(k.has(Q)||!(0,A.$lg)(p?.get(Q)).installed||a.delete(Q))}const O=[],M=D(o,a,new Set,!0),T=M.added.size>0||M.updated.size>0||M.removed.size>0;return T&&a.forEach((F,K)=>O.push(y(F,K))),{local:{added:h,removed:g,updated:m},remote:T?{added:[...M.added].map(F=>a.get(F)),updated:[...M.updated].map(F=>a.get(F)),removed:[...M.removed].map(F=>o.get(F)),all:O}:null}}function D(l,c,w,$){const f=l?[...l.keys()].filter(t=>!w.has(t)):[],u=[...c.keys()].filter(t=>!w.has(t)),h=u.filter(t=>!f.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),g=f.filter(t=>!u.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),m=new Set;for(const t of f){if(g.has(t))continue;const r=l.get(t),s=c.get(t);(!s||!I(r,s,$,!0))&&m.add(t)}return{added:h,removed:g,updated:m}}function I(l,c,w,$){return!(l.disabled!==c.disabled||!!l.isApplicationScoped!=!!c.isApplicationScoped||$&&l.installed!==c.installed||l.installed&&c.installed&&(l.preRelease!==c.preRelease||l.pinned!==c.pinned||c.pinned&&l.version!==c.version)||!E(l.state,c.state)||w&&l.version!==c.version)}function P(l,c,w){const $=l.state,f=c.state,u=w?.state;if(!c.version||$&&L.gt(l.version,c.version))return $;if(f&&L.gt(c.version,l.version)||!$)return f;if(!f)return $;const h=(0,R.$7n)($),g=u?d(u,f):{added:Object.keys(f).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set},m=u?d(u,$):{added:Object.keys($).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set};for(const t of[...g.added.values(),...g.updated.values()])h[t]=f[t];for(const t of g.removed.values())m.updated.has(t)||delete h[t];return h}function d(l,c){const w=Object.keys(l),$=Object.keys(c),f=$.filter(g=>!w.includes(g)).reduce((g,m)=>(g.add(m),g),new Set),u=w.filter(g=>!$.includes(g)).reduce((g,m)=>(g.add(m),g),new Set),h=new Set;for(const g of w){if(u.has(g))continue;const m=l[g],t=c[g];(0,R.$$n)(m,t)||h.add(g)}return{added:f,removed:u,updated:h}}function E(l={},c={}){const{added:w,removed:$,updated:f}=d(l,c);return w.size===0&&$.size===0&&f.size===0}function v(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function y(l,c){const w={...l,identifier:{id:l.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete w.disabled,l.installed||delete w.installed,l.state||delete w.state,l.isApplicationScoped||delete w.isApplicationScoped,w}}),define(le[112],he([0,1,17,22,4]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gNb=e.$fNb=void 0,e.$fNb=(0,A.$Ai)("IIgnoredExtensionsManagementService");let j=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,P){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return d=d.filter(E=>E!==I&&E!==`-${I}`),P&&d.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(I,P){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return d=d.filter(E=>E!==I&&E!==`-${I}`),P&&d.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(I){const P=I.filter(y=>y.isMachineScoped).map(y=>y.identifier.id.toLowerCase()),d=this.b().map(y=>y.toLowerCase()),E=[],v=[];if(Array.isArray(d))for(const y of d)y.startsWith("-")?v.push(y.substring(1)):E.push(y);return(0,R.$Mb)([...P,...E].filter(y=>!v.includes(y)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.$gNb=j,e.$gNb=j=ve([Y(0,L.$7i)],j)}),define(le[242],he([0,1,17,35,30,94,79]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=P;function I(g){return(0,L.$Nn)(g)||[]}async function P(g,m,t,r,s){const n=I(g),i=I(m),o=t?I(t):null,a=[...n,...i,...o||[]].map(J=>J.key),p=await s.resolveUserBindings(a),S=E(n,i,o,p);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const b=y(n),k=y(i),C=o?y(o):null,O=c(b,k,p),M=C?c(C,b,p):{added:[...b.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},T=C?c(C,k,p):{added:[...k.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},F=d(O,M,T);let K=g;for(const J of F.removed.values())F.conflicts.has(J)||(K=u(K,J,r));for(const J of F.added.values()){if(F.conflicts.has(J))continue;const Q=k.get(J);if(Q.some(H=>H.command!==`-${J}`&&S.conflicts.has(p[H.key]))){F.conflicts.add(J);continue}K=f(K,Q,r)}for(const J of F.updated.values()){if(F.conflicts.has(J))continue;const Q=k.get(J);if(Q.some(H=>H.command!==`-${J}`&&S.conflicts.has(p[H.key]))){F.conflicts.add(J);continue}K=h(K,J,Q,r)}return{mergeContent:K,hasChanges:!0,hasConflicts:F.conflicts.size>0}}function d(g,m,t){const r=new Set,s=new Set,n=new Set,i=new Set;for(const o of m.removed.values())t.updated.has(o)&&i.add(o);for(const o of t.removed.values())i.has(o)||(m.updated.has(o)?i.add(o):s.add(o));for(const o of m.added.values())i.has(o)||t.added.has(o)&&g.updated.has(o)&&i.add(o);for(const o of t.added.values())i.has(o)||(m.added.has(o)?g.updated.has(o)&&i.add(o):r.add(o));for(const o of m.updated.values())i.has(o)||t.updated.has(o)&&g.updated.has(o)&&i.add(o);for(const o of t.updated.values())i.has(o)||(m.updated.has(o)?g.updated.has(o)&&i.add(o):n.add(o));return{added:r,removed:s,updated:n,conflicts:i}}function E(g,m,t,r){const s=new Set,n=v(g,r),i=v(m,r),o=t?v(t,r):null,a=l(n,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const p=o?l(o,n):{added:[...n.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const S=o?l(o,i):{added:[...i.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:b,removed:k,updated:C,conflicts:O}=d(a,p,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:b,removed:k,updated:C,conflicts:O}}function v(g,m){const t=new Map;for(const r of g){const s=m[r.key];let n=t.get(s);n||(n=[],t.set(s,n)),n.push(r)}return t}function y(g){const m=new Map;for(const t of g){const r=t.command[0]==="-"?t.command.substring(1):t.command;let s=m.get(r);s||(s=[],m.set(r,s)),s.push(t)}return m}function l(g,m){const t=[...g.keys()],r=[...m.keys()],s=r.filter(o=>!t.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),n=t.filter(o=>!r.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),i=new Set;for(const o of t){if(n.has(o))continue;const a=g.get(o).map(S=>({...S,key:o})),p=m.get(o).map(S=>({...S,key:o}));(0,R.$ub)(a,p,(S,b)=>$(S,b))||i.add(o)}return{added:s,removed:n,updated:i}}function c(g,m,t){const r=[...g.keys()],s=[...m.keys()],n=s.filter(a=>!r.includes(a)).reduce((a,p)=>(a.add(p),a),new Set),i=r.filter(a=>!s.includes(a)).reduce((a,p)=>(a.add(p),a),new Set),o=new Set;for(const a of r){if(i.has(a))continue;const p=g.get(a).map(b=>({...b,key:t[b.key]})),S=m.get(a).map(b=>({...b,key:t[b.key]}));w(p,S)||o.add(a)}return{added:n,removed:i,updated:o}}function w(g,m){return!(!(0,R.$ub)(g.filter(({command:t})=>t[0]!=="-"),m.filter(({command:t})=>t[0]!=="-"),(t,r)=>$(t,r))||!(0,R.$ub)(g.filter(({command:t})=>t[0]==="-"),m.filter(({command:t})=>t[0]==="-"),(t,r)=>$(t,r)))}function $(g,m){if(g.command!==m.command||g.key!==m.key)return!1;const t=j.$yj.deserialize(g.when),r=j.$yj.deserialize(m.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!A.$$n(g.args,m.args))}function f(g,m,t){for(const r of m)g=D.edit(g,[-1],r,t);return g}function u(g,m,t){const r=I(g);for(let s=r.length-1;s>=0;s--)(r[s].command===m||r[s].command===`-${m}`)&&(g=D.edit(g,[s],void 0,t));return g}function h(g,m,t,r){const s=I(g),n=s.findIndex(i=>i.command===m||i.command===`-${m}`);for(let i=s.length-1;i>=0;i--)(s[i].command===m||s[i].command===`-${m}`)&&(g=D.edit(g,[i],void 0,r));for(let i=t.length-1;i>=0;i--)g=D.edit(g,[n],t[i],r);return g}}),define(le[243],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=R,e.$fac=A;function R(j,D,I){const P={},d={},E=new Set;if(!D)return{local:{added:P,updated:d,removed:[...E.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const v=L(j,D);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{local:{added:P,updated:d,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const y=L(I,j),l=L(I,D),c={},w={},$=new Set,f=new Set;for(const u of y.removed.values())l.updated.has(u)?P[u]=D[u]:$.add(u);for(const u of l.removed.values())f.has(u)||(y.updated.has(u)?f.add(u):E.add(u));for(const u of y.updated.values())f.has(u)||(l.updated.has(u)?v.updated.has(u)&&f.add(u):w[u]=j[u]);for(const u of l.updated.values())f.has(u)||(y.updated.has(u)?v.updated.has(u)&&f.add(u):j[u]!==void 0&&(d[u]=D[u]));for(const u of y.added.values())f.has(u)||(l.added.has(u)?v.updated.has(u)&&f.add(u):c[u]=j[u]);for(const u of l.added.values())f.has(u)||(y.added.has(u)?v.updated.has(u)&&f.add(u):P[u]=D[u]);return{local:{added:P,removed:[...E.values()],updated:d},remote:{added:c,removed:[...$.values()],updated:w},conflicts:[...f.values()]}}function L(j,D){const I=j?Object.keys(j):[],P=D?Object.keys(D):[],d=P.filter(y=>!I.includes(y)).reduce((y,l)=>(y.add(l),y),new Set),E=I.filter(y=>!P.includes(y)).reduce((y,l)=>(y.add(l),y),new Set),v=new Set;for(const y of I){if(E.has(y))continue;const l=j[y],c=D[y];l!==c&&v.add(y)}return{added:d,removed:E,updated:v}}function A(j,D){const{added:I,removed:P,updated:d}=L(j,D);return I.size===0&&P.size===0&&d.size===0}}),define(le[244],he([0,1,30]),function(se,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=L;function L(j,D,I,P){const d={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!D){const y=j.filter(({id:l})=>!P.includes(l));return y.length?E.added=y:E=null,{local:d,remote:E}}const v=A(j,D,P);if(v.added.length>0||v.removed.length>0||v.updated.length>0){const y=A(I,j,P),l=A(I,D,P);for(const c of l.removed){const w=j.find($=>$.id===c);w&&d.removed.push(w)}for(const c of l.added){const w=D.find($=>$.id===c);y.added.includes(c)?v.updated.includes(c)&&d.updated.push(w):d.added.push(w)}for(const c of l.updated)d.updated.push(D.find(w=>w.id===c));for(const c of y.added)l.added.includes(c)||E.added.push(j.find(w=>w.id===c));for(const c of y.updated)l.removed.includes(c)||l.updated.includes(c)||E.updated.push(j.find(w=>w.id===c));for(const c of y.removed){const w=D.find($=>$.id===c);w&&E.removed.push(w)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:d,remote:E}}function A(j,D,I){j=j?j.filter(({id:l})=>!I.includes(l)):[],D=D.filter(({id:l})=>!I.includes(l));const P=j.map(({id:l})=>l),d=D.map(({id:l})=>l),E=d.filter(l=>!P.includes(l)),v=P.filter(l=>!d.includes(l)),y=[];for(const{id:l,name:c,shortName:w,icon:$,useDefaultFlags:f}of j){if(v.includes(l))continue;const u=D.find(h=>h.id===l);(!u||u.name!==c||u.shortName!==w||u.icon!==$||!(0,R.$$n)(u.useDefaultFlags,f))&&y.push(l)}return{added:E,removed:v,updated:y}}}),define(le[25],he([0,1,17,13,181,47,28,4,102,43]),function(se,e,R,L,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmb=e.$Umb=e.$Tmb=e.$Smb=e.$Rmb=e.$Qmb=e.$Pmb=e.$Omb=e.$Nmb=e.$Lmb=e.MergeState=e.Change=e.SyncStatus=e.$Kmb=e.$Jmb=e.$Imb=e.UserDataSyncErrorCode=e.$Gmb=e.$Fmb=e.$Emb=e.$Dmb=e.$Cmb=e.$zmb=e.SyncResource=e.$wmb=e.$vmb=void 0,e.$tmb=E,e.$umb=v,e.$xmb=y,e.$ymb=l,e.$Amb=w,e.$Bmb=$,e.$Hmb=f,e.$Mmb=n;function E(){const i=d.$ho.as(j.$mo.Configuration).getConfigurationProperties();return Object.keys(i).filter(o=>!!i[o].disallowSyncIgnore)}function v(){const i=d.$ho.as(j.$mo.Configuration).getConfigurationProperties(),o=Object.keys(i).filter(S=>!!i[S].ignoreSync),a=Object.keys(i).filter(S=>i[S].scope===2||i[S].scope===6),p=E();return(0,R.$Mb)([...o,...a,...p])}e.$vmb="settingsSync",e.$wmb="settingsSync.keybindingsPerPlatform";function y(){const i="vscode://schemas/ignoredSettings",o=d.$ho.as(j.$mo.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$wmb]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:D.$Yo,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=d.$ho.as(P.$io.JSONContribution),p=()=>{const S=E(),b=v(),k=Object.keys(j.$no.properties).filter(M=>!b.includes(M)),C=b.filter(M=>!S.includes(M)),O={items:{type:"string",enum:[...k,...C.map(M=>`-${M}`)]}};a.registerSchema(i,O)};return o.onDidUpdateConfiguration(()=>p())}function l(i){return i&&(0,L.$cg)(i)&&(0,L.$ag)(i.id)&&Array.isArray(i.scopes)}var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.$zmb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function w(i,...o){return i?[i,...o]:o}function $(i,o,a,p){return p.joinPath(a.userDataSyncHome,...w(i,o,`lastSync${o}.json`))}e.$Cmb=(0,I.$Ai)("IUserDataSyncStoreManagementService"),e.$Dmb=(0,I.$Ai)("IUserDataSyncStoreService"),e.$Emb=(0,I.$Ai)("IUserDataSyncLocalStoreService"),e.$Fmb="x-operation-id",e.$Gmb="X-Execution-Id";function f(i){const o={};return o[e.$Gmb]=i,o}var u;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class h extends Error{constructor(o,a,p,S){super(o),this.code=a,this.resource=p,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Imb=h;class g extends h{constructor(o,a,p,S,b){super(o,p,void 0,b),this.url=a,this.serverCode=S}}e.$Jmb=g;class m extends h{constructor(o,a){super(o,a)}}e.$Kmb=m,function(i){function o(a){if(a instanceof i)return a;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(p&&p[1]){const S=p[2]==="unknown"?void 0:p[2],b=p[3]==="unknown"?void 0:p[3];return new i(a.message,p[1],S,b)}return new i(a.message,"Unknown")}i.toUserDataSyncError=o}(h||(e.$Imb=h={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var r;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(r||(e.Change=r={}));var s;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(s||(e.MergeState=s={})),e.$Lmb="sync.store.url.type";function n(i){return`sync.enable.${i}`}e.$Nmb=(0,I.$Ai)("IUserDataSyncEnablementService"),e.$Omb=(0,I.$Ai)("IUserDataSyncService"),e.$Pmb=(0,I.$Ai)("IUserDataSyncResourceProviderService"),e.$Qmb=(0,I.$Ai)("IUserDataAutoSyncService"),e.$Rmb=(0,I.$Ai)("IUserDataSyncUtilService"),e.$Smb=(0,I.$Ai)("IUserDataSyncLogService"),e.$Tmb="userDataSync",e.$Umb="vscode-userdata-sync",e.$Vmb="preview"}),define(le[245],he([0,1,30,25]),function(se,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xMb=A;function A(D,I,P,d,E){if(!I)return{remote:{added:Object.keys(D),removed:[],updated:[],all:Object.keys(D).length>0?D:null},local:{added:{},removed:[],updated:{}}};const v=j(D,I);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const y=P?j(P,I):{added:Object.keys(I).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},l=P?j(P,D):{added:Object.keys(D).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},w=R.$7n(I),$=!P;for(const u of l.added.values())u!==L.$Lmb&&$&&y.added.has(u)||(w[u]=D[u]);for(const u of l.updated.values())w[u]=D[u];for(const u of l.removed.values())d.unregistered.includes(u)||delete w[u];for(const u of y.added.values()){const h=I[u];if(d.machine.includes(u)){E.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(P&&l.added.has(u))continue;const g=D[u];g&&g.value===h.value||u===L.$Lmb&&$&&l.added.has(u)||(g?c.updated[u]=h:c.added[u]=h)}for(const u of y.updated.values()){const h=I[u];if(d.machine.includes(u)){E.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(u)||l.removed.has(u))continue;const g=D[u];g&&g.value===h.value||(c.updated[u]=h)}for(const u of y.removed.values()){if(d.machine.includes(u)){E.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}l.updated.has(u)||l.removed.has(u)||c.removed.push(u)}const f=j(I,w);return{local:c,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:w}}}function j(D,I){const P=Object.keys(D),d=Object.keys(I),E=d.filter(l=>!P.includes(l)).reduce((l,c)=>(l.add(c),l),new Set),v=P.filter(l=>!d.includes(l)).reduce((l,c)=>(l.add(c),l),new Set),y=new Set;for(const l of P){if(v.has(l))continue;const c=D[l],w=I[l];R.$$n(c,w)||y.add(l)}return{added:E,removed:v,updated:y}}}),define(le[246],he([0,1,17,35,62,44,30,79,25]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Kb=d,e.$5Kb=y,e.$6Kb=l,e.$7Kb=c,e.$8Kb=$,e.$9Kb=u;function d(a,p,S){let b=[];S?b=v(S):b=E(p);const k=[],C=[...(0,P.$tmb)()];if(Array.isArray(b))for(const O of b)O.startsWith("-")?C.push(O.substring(1)):k.push(O);return(0,R.$Mb)([...a,...k].filter(O=>!C.includes(O)))}function E(a){let p=a.inspect("settingsSync.ignoredSettings").userValue;return p!==void 0||(p=a.inspect("sync.ignoredSettings").userValue,p!==void 0)?p:a.getValue("settingsSync.ignoredSettings")||[]}function v(a){const p=(0,L.$Nn)(a);return p?p["settingsSync.ignoredSettings"]||p["sync.ignoredSettings"]||[]:[]}function y(a,p){const S=(0,L.$Nn)(a)||{};let b="{}";for(const k of Object.keys(S)){const C=(0,A.$3n)(b,[k],S[k],p);b=(0,A.$6n)(b,C)}return b}function l(a,p,S,b){if(S.length){const k=o(p),C=(0,L.$Nn)(p)||{},O=(0,L.$Nn)(a);if(!O)return a;const M=[];for(const T of S){const F=C[T],K=O[T];F===void 0?a=I.edit(a,[T],void 0,b):K!==void 0?a=I.edit(a,[T],F,b):M.push(t(T,k))}M.sort((T,F)=>T.startOffset-F.startOffset),M.forEach(T=>a=u(T.setting.key,p,a,b))}return a}function c(a,p,S,b,k,C){const O=l(a,p,b,C),M=S!==O,T=S!==p;if(!M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(T&&!M)return{conflictsSettings:[],localContent:l(p,a,b,C),remoteContent:null,hasConflicts:!1};if(S===null&&$(a)){const U=w(a,p,b)?null:l(p,a,b,C);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let F=a,K=p;const J=(0,L.$Nn)(a),Q=(0,L.$Nn)(p),H=S?(0,L.$Nn)(S):null,X=b.reduce((U,V)=>(U.add(V),U),new Set),W=f(J,Q,X),B=f(H,J,X),ie=f(H,Q,X),re=new Map,Z=new Set,z=U=>{Z.add(U);const V=k.filter(({key:q})=>q===U)[0];V?(F=I.edit(F,[U],V.value,C),K=I.edit(K,[U],V.value,C)):re.set(U,{key:U,localValue:J[U],remoteValue:Q[U]})};for(const U of B.removed.values())ie.updated.has(U)?z(U):K=I.edit(K,[U],void 0,C);for(const U of ie.removed.values())Z.has(U)||(B.updated.has(U)?z(U):F=I.edit(F,[U],void 0,C));for(const U of B.updated.values())Z.has(U)||(ie.updated.has(U)?W.updated.has(U)&&z(U):K=I.edit(K,[U],J[U],C));for(const U of ie.updated.values())Z.has(U)||(B.updated.has(U)?W.updated.has(U)&&z(U):F=I.edit(F,[U],Q[U],C));for(const U of B.added.values())Z.has(U)||(ie.added.has(U)?W.updated.has(U)&&z(U):K=u(U,F,K,C));for(const U of ie.added.values())Z.has(U)||(B.added.has(U)?W.updated.has(U)&&z(U):F=u(U,K,F,C));const x=re.size>0||!w(F,K,b),G=x||!w(F,a,[]),N=x||!w(K,p,[]);return{localContent:G?F:null,remoteContent:N?K:null,conflictsSettings:[...re.values()],hasConflicts:x}}function w(a,p,S){if(a===p)return!0;const b=(0,L.$Nn)(a),k=(0,L.$Nn)(p),C=S.reduce((T,F)=>(T.add(F),T),new Set),O=o(a).filter(T=>!(T.setting&&C.has(T.setting.key))),M=o(p).filter(T=>!(T.setting&&C.has(T.setting.key)));if(O.length!==M.length)return!1;for(let T=0;T<O.length;T++){const F=O[T],K=M[T];if(F.setting&&K.setting){if(F.setting.key!==K.setting.key||!D.$$n(b[F.setting.key],k[F.setting.key]))return!1}else if(!F.setting&&!K.setting){if(F.value!==K.value)return!1}else return!1}return!0}function $(a){return a?o(a).length===0:!0}function f(a,p,S){const b=a?Object.keys(a).filter(T=>!S.has(T)):[],k=Object.keys(p).filter(T=>!S.has(T)),C=k.filter(T=>!b.includes(T)).reduce((T,F)=>(T.add(F),T),new Set),O=b.filter(T=>!k.includes(T)).reduce((T,F)=>(T.add(F),T),new Set),M=new Set;if(a)for(const T of b){if(O.has(T))continue;const F=a[T],K=p[T];D.$$n(F,K)||M.add(T)}return{added:C,removed:O,updated:M}}function u(a,p,S,b){const k=(0,L.$Nn)(p),C=o(p),O=o(S),M=h(a,C,O);return g(S,a,k[a],M,O,b)}function h(a,p,S){const b=p.findIndex(C=>C.setting?.key===a),k=p[b-1];if(k){if(k.setting){const O=t(k.setting.key,S);if(O)return{index:S.indexOf(O),insertAfter:!0}}else{const O=r(b,p);if(O){const M=t(O.setting.key,S);if(M){const T=s(S.indexOf(M),S),F=n(p,O,p[b]);if(T){const K=n(S,M,T),J=i(F,K);return J?{index:S.indexOf(J),insertAfter:!0}:{index:S.indexOf(T),insertAfter:!1}}else{const K=n(S,M,S[S.length-1]),J=i(F,K);return J?{index:S.indexOf(J),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const C=p[b+1];if(C)if(C.setting){const O=t(C.setting.key,S);if(O)return{index:S.indexOf(O),insertAfter:!1}}else{const O=s(b,p);if(O){const M=t(O.setting.key,S);if(M){const T=r(S.indexOf(M),S),F=n(p,p[b],O);if(T){const K=n(S,T,M),J=i(F.reverse(),K.reverse());return J?{index:S.indexOf(J),insertAfter:!1}:{index:S.indexOf(T),insertAfter:!0}}else{const K=n(S,S[0],M),J=i(F.reverse(),K.reverse());return J?{index:S.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function g(a,p,S,b,k,C){let O;return b.index===-1?O=(0,A.$3n)(a,[p],S,C):O=m(a,p,S,b,k,C).map(M=>(0,A.$4n)(a,M,C)[0]),(0,A.$6n)(a,O)}function m(a,p,S,b,k,C){const O=`${JSON.stringify(p)}: ${JSON.stringify(S)}`,M=(0,j.$Zn)(C,a),T=k[b.index];if(b.insertAfter){const F=[];if(T.setting)F.push({offset:T.endOffset,length:0,content:","+O});else{const K=s(b.index,k),J=r(b.index,k),Q=J?.setting?.commaOffset;J&&Q===void 0&&F.push({offset:J.endOffset,length:0,content:","});const H=Q!==void 0&&Q>T.endOffset;F.push({offset:H?Q+1:T.endOffset,length:0,content:K?M+O+",":M+O})}return F}else{if(T.setting)return[{offset:T.startOffset,length:0,content:O+","}];const F=(k[b.index-1]&&!k[b.index-1].setting?M:"")+O+(s(b.index,k)?",":"")+M;return[{offset:T.startOffset,length:0,content:F}]}}function t(a,p){return p.filter(S=>S.setting?.key===a)[0]}function r(a,p){for(let S=a-1;S>=0;S--)if(p[S].setting)return p[S]}function s(a,p){for(let S=a+1;S<p.length;S++)if(p[S].setting)return p[S]}function n(a,p,S){const b=a.indexOf(p),k=a.indexOf(S);return a.filter((C,O)=>b<O&&O<k)}function i(a,p){if(a.length&&p.length){let S=0;for(;S<p.length&&S<a.length;S++)if(a[S].value!==p[S].value)return p[S-1];return p[S-1]}}function o(a){const p=[];let S=-1,b,k;const C={onObjectBegin:O=>{S++},onObjectProperty:(O,M,T)=>{S===0&&(b=M,k=O)},onObjectEnd:(O,M)=>{S--,S===0&&p.push({startOffset:b,endOffset:O+M,value:a.substring(b,O+M),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(O,M)=>{S++},onArrayEnd:(O,M)=>{S--,S===0&&p.push({startOffset:b,endOffset:O+M,value:a.substring(b,O+M),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(O,M,T)=>{S===0&&p.push({startOffset:b,endOffset:M+T,value:a.substring(b,M+T),setting:{key:k,commaOffset:void 0}})},onSeparator:(O,M,T)=>{if(S===0&&O===","){let F=p.length-1;for(;F>=0&&!p[F].setting;F--);const K=p[F];K&&p.splice(F,1,{startOffset:K.startOffset,endOffset:K.endOffset,value:K.value,setting:{key:K.setting.key,commaOffset:M}})}},onComment:(O,M)=>{S===0&&p.push({startOffset:O,endOffset:O+M,value:a.substring(O,O+M)})}};return(0,L.$Un)(a,C),p}}),define(le[80],he([0,1,3,2,4,25]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NKb=e.$MKb=void 0,e.$MKb=(0,A.$Ai)("IUserDataSyncAccountService");let D=class extends L.$Uc{get account(){return this.a}constructor(P,d){super(),this.g=P,this.h=d,this.b=this.B(new R.$he),this.onDidChangeAccount=this.b.event,this.c=this.B(new R.$he),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(E=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,E),this.updateAccount(void 0),E==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};e.$NKb=D,e.$NKb=D=ve([Y(0,j.$Dmb),Y(1,j.$Smb)],D)}),define(le[247],he([0,1,21,182,16,9,25]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hNb=void 0;let I=class extends j.$_j{constructor(d,E){super(),this.g=this.B(d.createLogger((0,R.$bh)(E.logsHome,`${D.$Tmb}.log`),{id:D.$Tmb,name:(0,L.localize)(0,null)}))}trace(d,...E){this.g.trace(d,...E)}debug(d,...E){this.g.debug(d,...E)}info(d,...E){this.g.info(d,...E)}warn(d,...E){this.g.warn(d,...E)}error(d,...E){this.g.error(d,...E)}flush(){this.g.flush()}};e.$hNb=I,e.$hNb=I=ve([Y(0,j.$8j),Y(1,A.$Hi)],I)}),define(le[248],he([0,1,6,3,2]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class j extends A.$Uc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:P,getActiveWindowId:d}){super(),this.a=this.B(new A.$Tc),L.Event.latch(L.Event.any(I,P))(this.f,this,this.a),this.b=(0,R.$nh)(()=>d()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$jec=j}),define(le[113],he([0,1,185,14,51,21,8,4,23]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=d,e.$Li=E,e.$Oi=v,e.$Pi=y,e.$Qi=l,e.$Ri=w,e.$Si=$,e.$Vi=h,e.$1i=g,e.$2i=m,e.$4i=t,e.$5i=r,e.$6i=s,e.$Ji=(0,I.$Ai)("contextService");function d(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}function E(n){return typeof n?.id=="string"&&!d(n)&&!y(n)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function v(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,L.$nc)(n)}:i?e.$Mi:e.$Ni;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function y(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}function l(n){const i=n;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}var c;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function w(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}function $(n){const i=n;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}class f{constructor(i,o,a,p,S){this.h=i,this.j=a,this.k=p,this.l=S,this.c=A.$Gi.forUris(this.l,()=>!0),this.folders=o}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=A.$Gi.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=f;class u{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,j.$bh)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=u;function h(n){return new u({uri:n,index:0,name:(0,j.$0g)(n)},{uri:n.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,R.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function g(n,i){return j.$5g.isEqualOrParent(n,i.untitledWorkspacesHome)}function m(n){let i;return D.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===P.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$3i}function r(n,i){return!g(n,i)&&!m(n)}function s(n){return(typeof n=="string"?(0,L.$oc)(n):(0,j.$_g)(n))===e.$Xi}}),define(le[19],he([0,1,54,3,2,21,8,176,16,12,4,9,113,34,29,6,32,27,13]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=g,e.$Hl=m,e.$Il=t;var h;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function g(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&D.URI.isUri(i.location)&&D.URI.isUri(i.globalStorageHome)&&D.URI.isUri(i.settingsResource)&&D.URI.isUri(i.keybindingsResource)&&D.URI.isUri(i.tasksResource)&&D.URI.isUri(i.snippetsHome)&&D.URI.isUri(i.extensionsResource))}e.$Gl=(0,E.$Ai)("IUserDataProfilesService");function m(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:D.URI.revive(n.location).with({scheme:i}),globalStorageHome:D.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:D.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:D.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:D.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:D.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:D.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:D.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function t(n,i,o,a,p,S){return{id:n,name:i,location:o,isDefault:!1,shortName:p?.shortName,icon:p?.icon,globalStorageHome:S&&p?.useDefaultFlags?.globalState?S.globalStorageHome:(0,j.$bh)(o,"globalStorage"),settingsResource:S&&p?.useDefaultFlags?.settings?S.settingsResource:(0,j.$bh)(o,"settings.json"),keybindingsResource:S&&p?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,j.$bh)(o,"keybindings.json"),tasksResource:S&&p?.useDefaultFlags?.tasks?S.tasksResource:(0,j.$bh)(o,"tasks.json"),snippetsHome:S&&p?.useDefaultFlags?.snippets?S.snippetsHome:(0,j.$bh)(o,"snippets"),extensionsResource:S&&p?.useDefaultFlags?.extensions?S.extensionsResource:(0,j.$bh)(o,"extensions.json"),cacheHome:(0,j.$bh)(a,n),useDefaultFlags:p?.useDefaultFlags,isTransient:p?.transient}}let r=class extends A.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,o,a,p){super(),this.t=i,this.u=o,this.w=a,this.y=p,this.f=!0,this.h=this.B(new L.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$Ac,emptyWindows:new Map},this.profilesHome=(0,j.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),o=[i];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,u.$ag)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}o.push(t((0,j.$$g)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},i))}}catch(S){this.y.error(S)}const a=new l.$Ac,p=new Map;if(o.length)try{const S=this.Q();if(S.workspaces)for(const[b,k]of Object.entries(S.workspaces)){const C=D.URI.parse(b),O=o.find(M=>M.id===k);O&&a.set(C,O)}if(S.emptyWindows)for(const[b,k]of Object.entries(S.emptyWindows)){const C=o.find(O=>O.id===k);C&&p.set(b,C)}}catch(S){this.y.error(S)}this.z={profiles:o,workspaces:a,emptyWindows:p}}return this.z}D(){const i=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const o="Temp",a=new RegExp(`${(0,f.$df)(o)}\\s(\\d+)`);let p=0;for(const b of this.profiles){const k=a.exec(b.name),C=k?parseInt(k[1]):0;p=C>p?C:p}const S=`${o} ${p+1}`;return this.createProfile((0,R.$oj)((0,$.$Wg)()).toString(16),S,{transient:!0},i)}async createNamedProfile(i,o,a){return this.createProfile((0,R.$oj)((0,$.$Wg)()).toString(16),i,o,a)}async createProfile(i,o,a,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(i,o,a);return p&&await this.setProfileForWorkspace(p,S),S}async F(i,o,a){if(!(0,u.$ag)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let p=this.r.get(o);return p||(p=(async()=>{try{if(this.profiles.find(C=>C.name===o||C.id===i))throw new Error(`Profile with ${o} name already exists`);const b=t(i,o,(0,j.$bh)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.u.createFolder(b.location);const k=[];return this.j.fire({profile:b,join(C){k.push(C)}}),await w.Promises.settled(k),this.I([b],[],[]),b}finally{this.r.delete(o)}})(),this.r.set(o,p)),p}async updateProfile(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(p=>p.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,o.name??a.name,a.location,this.g,{shortName:o.shortName??a.shortName,icon:o.icon===null?void 0:o.icon??a.icon,transient:o.transient??a.isTransient,useDefaultFlags:o.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(p=>p.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.m.fire({profile:o,join(p){a.push(p)}});try{await Promise.allSettled(a)}catch(p){this.y.error(p)}for(const p of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(p)?.id&&this.C.emptyWindows.delete(p);for(const p of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(p)?.id&&this.C.workspaces.delete(p);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(p){(0,d.$ll)(p)!==1&&this.y.error(p)}}async setProfileForWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(p=>p.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);this.L(i,a)}unsetWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.G(i);return D.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(i){return(0,y.$Ki)(i)?i.uri:(0,y.$Pi)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location)))}I(i,o,a){const p=[...this.profiles,...i],S=[];this.s.profiles=[];for(let b of p)b.isDefault||o.some(k=>b.id===k.id)||(b=a.find(k=>b.id===k.id)??b,b.isTransient?this.s.profiles.push(b):S.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags}));this.P(S),this.z=void 0,this.J(i,o,a)}J(i,o,a){this.h.fire({added:i,removed:o,updated:a,all:this.profiles})}L(i,o,a){a=o?.isTransient?!0:a,a||this.L(i,void 0,!0);const p=this.G(i),S=a?this.s:this.C;D.URI.isUri(p)?(S.workspaces.delete(p),o&&S.workspaces.set(p,o)):(S.emptyWindows.delete(p),o&&S.emptyWindows.set(p,o)),a||this.M()}M(){const i={};for(const[a,p]of this.C.workspaces.entries())i[a.toString()]=p.id;const o={};for(const[a,p]of this.C.emptyWindows.entries())o[a.toString()]=p.id;this.R({workspaces:i,emptyWindows:o}),this.z=void 0}N(i){const o={},a=this.D();if(i.workspaces)for(const[S,b]of Object.entries(i.workspaces)){const k=D.URI.parse(b);o[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}const p={};if(i.emptyWindows)for(const[S,b]of Object.entries(i.emptyWindows)){const k=D.URI.parse(b);p[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}return{workspaces:o,emptyWindows:p}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Jl=r,e.$Jl=r=ve([Y(0,P.$Hi),Y(1,d.$7k),Y(2,c.$El),Y(3,v.$7j)],r);class s extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Kl=s}),define(le[249],he([0,1,6,2,19]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;let j=class extends L.$Uc{constructor(I){super(),this.B(new R.$Mh(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$vfc=j,e.$vfc=j=ve([Y(0,A.$Gl)],j)}),define(le[81],he([0,1,17,6,26,7,3,2,5,13,8,158,28,33,48,9,24,18,29,19]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$rq=void 0,e.$sq=m;let g=class extends I.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,i,o,a,p,S){super(),this.z=n,this.C=i,this.D=o,this.F=a,this.G=p,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$he),this.s=this.B(new D.$he),this.t=this.B(new D.$he),this.u=this.B(new D.$he),this.w=this.B(new D.$he),this.y=[],this.B((0,I.$Sc)(()=>{this.j.forEach(({task:b})=>b.cancel()),this.m.forEach(b=>b.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const i=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,y.$0o)(o,n.allTargetPlatforms,i))}async installFromGallery(n,i={}){try{const a=(await this.installGalleryExtensions([{extension:n,options:i}])).find(({identifier:p})=>(0,l.$Ap)(p,n.identifier));if(a?.local)return a?.local;throw a?.error?a.error:new y.$bp(`Unknown error while installing extension ${n.identifier.id}`,"Unknown")}catch(o){throw m(o)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new y.$bp(v.localize(0,null),"NotAllowed");const i=[],o=[];return await Promise.allSettled(n.map(async({extension:a,options:p})=>{try{const S=await this.N(a,!!p?.installGivenVersion,!!p?.installPreReleaseVersion,p.productVersion??{version:this.G.version,date:this.G.date});o.push({...S,options:p})}catch(S){i.push({identifier:a.identifier,operation:2,source:a,error:S})}})),o.length&&i.push(...await this.I(o)),i}async uninstall(n,i={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.P(n,i)}async toggleAppliationScope(n,i){if((0,c.$Ym)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let o=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)||(o=await this.$(n,this.H.defaultProfile.extensionsResource,i));for(const a of this.H.profiles){const p=(await this.getInstalled(1,a.extensionsResource)).find(S=>(0,l.$Ap)(S.identifier,n.identifier));p?this.w.fire(p):this.u.fire({identifier:n.identifier,profileLocation:a.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(n,i,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.W(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const i=new Map,o=new Map,a=[],p=(b,k)=>`${l.$Bp.create(b).toString()}-${k.toString()}`,S=(b,k,C,O)=>{const M=this.Y(b,k,C),T=`${(0,l.$Fp)(b.publisher,b.name)}-${C.profileLocation.toString()}`;o.set(T,{task:M,root:O}),this.n.fire({identifier:M.identifier,source:k,profileLocation:C.profileLocation}),this.F.info("Installing extension:",M.identifier.id,C.profileLocation.toString()),E.URI.isUri(k)||this.j.set(p(k,C.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:b,extension:k,options:C}of n){const O=C.isApplicationScoped||C.isBuiltin||(0,c.$Ym)(b),M={...C,installOnlyNewlyAddedFromExtensionPack:C.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(k),isApplicationScoped:O,profileLocation:O?this.H.defaultProfile.extensionsResource:C.profileLocation??this.X(),productVersion:C.productVersion??{version:this.G.version,date:this.G.date}},T=E.URI.isUri(k)?void 0:this.j.get(p(k,M.profileLocation));T?(this.F.info("Extension is already requested to install",T.task.identifier.id,M.profileLocation.toString()),a.push(T.task.waitUntilTaskIsFinished())):S(b,k,M,void 0)}return await Promise.all([...o.values()].map(async({task:b})=>{if(b.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",b.identifier.id);else try{const k=await this.M(b.identifier,b.manifest,!!b.options.installOnlyNewlyAddedFromExtensionPack,!!b.options.installPreReleaseVersion,b.options.profileLocation,b.options.productVersion),C=await this.getInstalled(void 0,b.options.profileLocation,b.options.productVersion),O={...b.options,context:{...b.options.context,[y.$4o]:!0}};for(const{gallery:M,manifest:T}of(0,R.$Mb)(k,({gallery:F})=>F.identifier.id)){if(o.has(`${M.identifier.id.toLowerCase()}-${O.profileLocation.toString()}`))continue;const F=this.j.get(p(M,O.profileLocation));if(F){if(this.J(b,F.task)){const K=F.task.identifier;this.F.info("Waiting for already requested installing extension",K.id,b.identifier.id,O.profileLocation.toString()),F.waitingTasks.push(b),a.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,J=>J.some(Q=>(0,l.$Ap)(Q.identifier,K)))).then(J=>{if(this.F.info("Finished waiting for already requested installing extension",K.id,b.identifier.id,O.profileLocation.toString()),!J.find(H=>(0,l.$Ap)(H.identifier,K))?.local)throw new Error(`Extension ${K.id} is not installed`)}))}}else C.some(({identifier:K})=>(0,l.$Ap)(K,M.identifier))||S(T,M,O,b)}}catch(k){if(E.URI.isUri(b.source))(0,R.$Lb)(b.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",b.identifier.id,k.message),(0,R.$Lb)(b.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",b.identifier.id,k.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",b.identifier.id),k}})),await this.L([...o.entries()].map(async([b,{task:k}])=>{const C=new Date().getTime();let O;try{O=await k.run(),await this.L(this.y.map(M=>M.postInstall(O,k.source,k.options,A.CancellationToken.None)),"PostInstall")}catch(M){const T=m(M);throw E.URI.isUri(k.source)||t(this.C,k.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Ip)(k.source),error:T,source:k.options.context?.[y.$3o]}),i.set(b,{error:T,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.options.profileLocation,applicationScoped:k.options.isApplicationScoped}),this.F.error("Error while installing the extension",k.identifier.id,(0,j.$0)(T),k.options.profileLocation.toString()),T}if(!E.URI.isUri(k.source)){const M=k.operation===3,T=M?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(t(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Ip)(k.source),verificationStatus:k.verificationStatus,duration:new Date().getTime()-C,durationSinceUpdate:T,source:k.options.context?.[y.$3o]}),P.$o&&k.operation!==3)try{await this.z.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"install")}catch{}}i.set(b,{local:O,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.options.profileLocation,applicationScoped:O.isApplicationScoped})})),a.length&&await this.L(a),[...i.values()]}catch(b){const k=(M,T,F)=>{const K=[];M.manifest.extensionDependencies?.length&&K.push(...M.manifest.extensionDependencies),M.manifest.extensionPack?.length&&K.push(...M.manifest.extensionPack);for(const J of K){if(F.includes(J.toLowerCase()))continue;F.push(J.toLowerCase());const Q=i.get(`${J.toLowerCase()}-${T.toString()}`);Q?.local&&(F=k(Q.local,T,F))}return F},C=M=>({identifier:M.identifier,operation:2,source:M.source,context:M.options.context,profileLocation:M.options.profileLocation,error:b}),O=[];for(const[M,{task:T,root:F}]of o){const K=i.get(M);K?K.local&&F&&!i.get(`${F.identifier.id.toLowerCase()}-${T.options.profileLocation.toString()}`)?.local&&(O.push(this.Z(K.local,{versionOnly:!0,profileLocation:T.options.profileLocation})),i.set(M,C(T))):(T.cancel(),i.set(M,C(T)))}for(const[M,{task:T}]of o){const F=i.get(M);if(!F?.local||T.options.donotIncludePackAndDependencies)continue;k(F.local,T.options.profileLocation,[F.local.identifier.id.toLowerCase()]).slice(1).some(J=>o.has(`${J.toLowerCase()}-${T.options.profileLocation.toString()}`)&&!i.get(`${J.toLowerCase()}-${T.options.profileLocation.toString()}`)?.local)&&(O.push(this.Z(F.local,{versionOnly:!0,profileLocation:T.options.profileLocation})),i.set(M,C(T)))}throw O.length&&await Promise.allSettled(O.map(async M=>{try{await M.run(),this.F.info("Rollback: Uninstalled extension",M.extension.identifier.id)}catch(T){this.F.warn("Rollback: Error while uninstalling extension",M.extension.identifier.id,(0,j.$0)(T))}})),b}finally{for(const{task:b}of o.values())b.source&&!E.URI.isUri(b.source)&&this.j.delete(p(b.source,b.options.profileLocation));if(i.size){const b=[...i.values()];for(const k of b)k.local&&this.F.info("Extension installed successfully:",k.identifier.id,k.profileLocation.toString());this.s.fire(b)}}}J(n,i){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===n&&(a.includes(i)||a.some(p=>this.J(p,i)))||o===i&&a[0]&&!this.J(n,a[0]))return!1;return!0}async L(n,i){const o=[],a=[],p=await Promise.allSettled(n);for(const b of p)b.status==="fulfilled"?o.push(b.value):a.push(m(b.reason,i));if(!a.length)return o;if(a.length===1)throw a[0];let S=new y.$bp("","Unknown");for(const b of a)S=new y.$bp(S.message?`${S.message}, ${b.message}`:b.message,b.code!=="Unknown"&&b.code!=="Internal"?b.code:S.code);throw S}async M(n,i,o,a,p,S){if(!this.z.isEnabled())return[];const b=await this.getInstalled(void 0,p,S),k=[],C=[],O=async(M,T)=>{k.push(M);const F=T.extensionDependencies||[],K=[...F];if(T.extensionPack){const J=o?b.find(Q=>(0,l.$Ap)(Q.identifier,M)):void 0;for(const Q of T.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(H=>(0,l.$Ap)({id:H},{id:Q}))||K.every(H=>!(0,l.$Ap)({id:H},{id:Q}))&&K.push(Q)}if(K.length){const J=K.filter(Q=>k.every(H=>!(0,l.$Ap)(H,{id:Q})));if(J.length){const Q=await this.z.getExtensions(J.map(H=>({id:H,preRelease:a})),A.CancellationToken.None);for(const H of Q){if(k.find(B=>(0,l.$Ap)(B,H.identifier)))continue;const X=F.some(B=>(0,l.$Ap)({id:B},H.identifier));let W;try{W=await this.N(H,!1,a,S)}catch(B){if(X)throw B;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,j.$0)(B));continue}C.push({gallery:W.extension,manifest:W.manifest}),await O(W.extension.identifier,W.manifest)}}}};return await O(n,i),C}async N(n,i,o,a){let p;const S=await this.getExtensionsControlManifest();if(S.malicious.some(C=>(0,l.$Ap)(n.identifier,C)))throw new y.$bp(v.localize(1,null,n.identifier.id),"Malicious");const b=S.deprecated[n.identifier.id.toLowerCase()];if(b?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${b.extension.id}' extension instead.`),p=(await this.z.getExtensions([{id:b.extension.id,preRelease:b.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:a},A.CancellationToken.None))[0],!p)throw new y.$bp(v.localize(2,null,n.identifier.id,b.extension.id),"Deprecated")}else{if(!await this.canInstall(n)){const C=await this.getTargetPlatform();throw new y.$bp(v.localize(3,null,n.identifier.id,this.G.nameLong,(0,y.$6o)(C)),"IncompatibleTargetPlatform")}if(p=await this.O(n,i,o,a),!p)throw!o&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],A.CancellationToken.None))[0]?new y.$bp(v.localize(4,null,n.displayName??n.identifier.id),"ReleaseVersionNotFound"):new y.$bp(v.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),"Incompatible")}this.F.info("Getting Manifest...",p.identifier.id);const k=await this.z.getManifest(p,A.CancellationToken.None);if(k===null)throw new y.$bp(`Missing manifest for extension ${p.identifier.id}`,"Invalid");if(k.version!==p.version)throw new y.$bp(`Cannot install '${p.identifier.id}' extension because of version mismatch in Marketplace`,"Invalid");return{extension:p,manifest:k}}async O(n,i,o,a){const p=await this.getTargetPlatform();let S=null;return!i&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(S=(await this.z.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:p,compatible:!0,productVersion:a},A.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(n,o,p,a)&&(S=n),S||(i?S=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:p,compatible:!0,productVersion:a},A.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(n,o,p,a)),S}async P(n,i){const o={...i,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:i.profileLocation??this.X()},a=O=>`${O.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,p=this.m.get(a(n.identifier));if(p)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),p.waitUntilTaskIsFinished();const S=O=>{const M=this.Z(O,o);return this.m.set(a(M.extension.identifier),M),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${O.identifier.id}@${O.manifest.version}`),this.t.fire({identifier:O.identifier,profileLocation:o.profileLocation,applicationScoped:O.isApplicationScoped}),M},b=(O,M)=>{M?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,o.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${O.identifier.id}@${O.manifest.version}`,M.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${O.identifier.id}@${O.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${O.identifier.id}@${O.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Hp)(O),error:M}),this.u.fire({identifier:O.identifier,error:M?.code,profileLocation:o.profileLocation,applicationScoped:O.isApplicationScoped})},k=[],C=[];try{k.push(S(n));const O=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const M=this.S(n,O);for(const T of M)this.m.has(a(T.identifier))?this.F.info("Extensions is already requested to uninstall",T.identifier.id):k.push(S(T))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.Q(k.map(M=>M.extension),O,n),await this.L(k.map(async M=>{try{if(await M.run(),await this.L(this.y.map(T=>T.postUninstall(M.extension,o,A.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}b(M.extension)}catch(T){const F=m(T);throw b(M.extension,F),F}finally{C.push(M)}}))}catch(O){const M=m(O);for(const T of k){try{T.cancel()}catch{}C.includes(T)||b(T.extension,M)}throw M}finally{for(const O of k)this.m.delete(a(O.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",O.extension.identifier.id)}}Q(n,i,o){for(const a of n){const p=this.U(a,i);if(p.length){const S=p.filter(b=>!n.some(k=>(0,l.$Ap)(k.identifier,b.identifier)));if(S.length)throw new Error(this.R(a,S,o))}}}R(n,i,o){return o===n?i.length===1?v.localize(6,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?v.localize(7,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):v.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?v.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?v.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):v.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}S(n,i,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const p=i.filter(b=>!b.isBuiltin&&a.some(k=>(0,l.$Ap)({id:k},b.identifier))),S=[];for(const b of p)S.push(...this.S(b,i,o));return[...p,...S]}return[]}U(n,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,l.$Ap)({id:a},n.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(n){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,j.$0)(n)),{malicious:[],deprecated:{},search:[]}}}};e.$rq=g,e.$rq=g=ve([Y(0,y.$_o),Y(1,f.$6l),Y(2,u.$El),Y(3,w.$7j),Y(4,$.$nk),Y(5,h.$Gl)],g);function m(s,n){if(s instanceof y.$bp)return s;let i;return s instanceof y.$ap?i=new y.$bp(s.message,s.code==="DownloadFailedWriting"?"DownloadFailedWriting":"Gallery"):i=new y.$bp(s.message,(0,j.$4)(s)?"Cancelled":n??"Internal"),i.stack=s.stack,i}function t(s,n,{extensionData:i,verificationStatus:o,duration:a,error:p,source:S,durationSinceUpdate:b}){let k,C;(0,d.$ig)(o)&&(o===!0?o="Verified":(o===!1||(k="Signature",C=o),o="Unverified")),p&&(k=p.code,p.code==="Signature"&&(C=p.message)),s.publicLog(n,{...i,verificationStatus:o,success:!p,duration:a,errorcode:k,errorcodeDetail:C,durationSinceUpdate:b,source:S})}class r{constructor(){this.d=new L.$zh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,L.$nh)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.$nh)(n=>new Promise((i,o)=>{const a=n.onCancellationRequested(()=>{a.dispose(),o(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$tq=r}),define(le[52],he([0,1,6,15,2,3,34,8,28,33,12,4,9,19,29,13,7,18]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class h extends Error{constructor(s,n){super(s),this.code=n}}e.$uq=h,e.$vq=(0,v.$Ai)("IExtensionsProfileScannerService");let g=class extends A.$Uc{constructor(s,n,i,o,a,p){super(),this.j=s,this.m=n,this.n=i,this.r=o,this.s=a,this.t=p,this.b=this.B(new j.$he),this.onAddExtensions=this.b.event,this.c=this.B(new j.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$he),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(s,n){return this.u(s,void 0,n)}async addExtensionsToProfile(s,n,i){const o=[],a=[];try{return await this.u(n,p=>{const S=[];if(i)S.push(...p);else for(const b of p)s.some(([k])=>(0,d.$Ap)(k.identifier,b.identifier)&&k.manifest.version!==b.version)?o.push(b):S.push(b);for(const[b,k]of s){const C=S.findIndex(M=>(0,d.$Ap)(M.identifier,b.identifier)&&M.version===b.manifest.version),O={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:k};C===-1?(a.push(O),S.push(O)):S.splice(C,1,O)}return a.length&&this.b.fire({extensions:a,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),S}),a.length&&this.c.fire({extensions:a,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),a}catch(p){throw a.length&&this.c.fire({extensions:a,error:p,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:p,profileLocation:n}),p}}async updateMetadata(s,n){const i=[];return await this.u(n,o=>{const a=[];for(const p of o){const S=s.find(([b])=>(0,d.$Ap)(b.identifier,p.identifier)&&b.manifest.version===p.version);S&&(p.metadata={...p.metadata,...S[1]},i.push(p)),a.push(p)}return a}),i}async removeExtensionFromProfile(s,n){const i=[];try{await this.u(n,o=>{const a=[];for(const p of o)(0,d.$Ap)(p.identifier,s.identifier)?i.push(p):a.push(p);return i.length&&this.f.fire({extensions:i,profileLocation:n}),a}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(o){throw i.length&&this.g.fire({extensions:i,error:o,profileLocation:n}),o}}async u(s,n,i){return this.F(s).queue(async()=>{let o=[],a;try{const p=await this.m.readFile(s);a=JSON.parse(p.value.toString().trim()||"[]")}catch(p){if((0,E.$ll)(p)!==1)throw p;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&i?.bailOutWhenFileNotFound)throw new h((0,$.$0)(p),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(s);let p=!1;for(const S of a){m(S)||this.w(s);let b;if((0,w.$ag)(S.relativeLocation)&&S.relativeLocation)b=this.z(S.relativeLocation);else if((0,w.$ag)(S.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${S.location}`);continue}else{b=I.URI.revive(S.location);const k=this.y(b);k&&(p=!0,S.relativeLocation=k)}(0,w.$hg)(S.metadata?.hasPreReleaseVersion)&&S.metadata?.preRelease&&(p=!0,S.metadata.hasPreReleaseVersion=!0),o.push({identifier:S.identifier,location:b,version:S.version,metadata:S.metadata})}p&&await this.m.writeFile(s,L.$Je.fromString(JSON.stringify(a)))}if(n){o=n(o);const p=o.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.y(S.location),metadata:S.metadata}));await this.m.writeFile(s,L.$Je.fromString(JSON.stringify(p)))}return o})}w(s){const n=new h(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(s)).value.toString()}catch(a){if((0,E.$ll)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",s.toString());let o;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(p=>m(p))?o=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,L.$Je.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,E.$ll)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(s)}catch(a){(0,E.$ll)(a)!==1&&this.t.error(a)}try{await this.m.del(n)}catch(a){(0,E.$ll)(a)!==1&&this.t.error(a)}return o})()),this.C}F(s){let n=this.h.get(s);return n||(n=new R.$Hh,this.h.set(s,n)),n}};e.$wq=g,e.$wq=g=ve([Y(1,E.$7k),Y(2,l.$Gl),Y(3,c.$El),Y(4,f.$6l),Y(5,y.$7j)],g);function m(r){return(0,w.$cg)(r)&&(0,P.$$o)(r.identifier)&&(t(r.location)||(0,w.$ag)(r.location)&&r.location)&&((0,w.$hg)(r.relativeLocation)||(0,w.$ag)(r.relativeLocation))&&r.version&&(0,w.$ag)(r.version)}function t(r){return r?(0,w.$ag)(r.path)&&(0,w.$ag)(r.scheme):!1}}),define(le[82],he([0,1,17,6,30,15,7,35,140,2,23,14,5,21,55,89,13,8,161,16,33,48,71,12,4,9,24,3,66,52,19,29,190]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m,t,r,s,n,i,o,a,p,S,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Bq=e.$Aq=e.$zq=e.Translations=void 0,e.$Cq=K;var C;(function(Q){function H(X,W){if(X===W)return!0;const B=Object.keys(X),ie=new Set;for(const re of Object.keys(W))ie.add(re);if(B.length!==ie.size)return!1;for(const re of B){if(X[re]!==W[re])return!1;ie.delete(re)}return ie.size===0}Q.equals=H})(C||(e.Translations=C={})),e.$zq=(0,s.$Ai)("IExtensionsScannerService");let O=class extends d.$Uc{constructor(H,X,W,B,ie,re,Z,z,x,G,N,U){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=X,this.r=W,this.s=B,this.t=ie,this.u=re,this.w=Z,this.y=z,this.z=x,this.C=G,this.D=N,this.F=U,this.g=this.B(new o.$he),this.onDidChangeCache=this.g.event,this.h=(0,l.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(F,this.s,this.h)),this.m=this.B(this.F.createInstance(F,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Lp)(this.w,this.y)),this.G}async scanAllExtensions(H,X,W){const[B,ie]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(X)]),re=W?await this.scanExtensionsUnderDevelopment(H,[...B,...ie]):[];return this.L(B,ie,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const X=[];X.push(this.M(!!H.useCache,H.language)),X.push(this.N(H.language,!!H.checkControlFile));const[W,B]=await Promise.all(X);return this.J([...W,...B],0,H,!1)}async scanUserExtensions(H){const X=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const W=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(X,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,W,H.productVersion??this.R()),ie=H.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let re;try{re=await ie.scanExtensions(B)}catch(Z){if(Z instanceof p.$uq&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),re=await ie.scanExtensions(B);else throw Z}return re=await this.J(re,1,H,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(H,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===E.Schemas.file).map(async B=>{const ie=await this.P(B,!1,1,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(Z=>(Z.type=X.find(z=>(0,g.$Ap)(z.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,ie)))}))).flat();return this.J(W,"development",H,!0)}return[]}async scanExistingExtension(H,X,W){const B=await this.P(H,!1,X,!0,W.language,!0,void 0,W.productVersion??this.R()),ie=await this.n.scanExtension(B);return!ie||!W.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(H,X,W){const B=await this.P(H,!1,X,!0,W.language,!0,void 0,W.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(B);return this.J(ie,X,W,!0)}async scanMultipleExtensions(H,X,W){const B=[];return await Promise.all(H.map(async ie=>{const re=await this.scanOneOrMultipleExtensions(ie,X,W);B.push(...re)})),this.J(B,X,W,!0)}async scanMetadata(H){const X=(0,l.$bh)(H,"package.json"),W=(await this.w.readFile(X)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(H,X){const W=(0,l.$bh)(H,"package.json"),B=(await this.w.readFile(W)).value.toString(),ie=JSON.parse(B);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,ie.__metadata={...ie.__metadata,...X},await this.w.writeFile((0,l.$bh)(H,"package.json"),j.$Je.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof p.$uq&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$Je.fromString(JSON.stringify([])))}catch(X){(0,r.$ll)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,X,W,B){return W.includeAllVersions||(H=this.L(X===0?H:void 0,X===1?H:void 0,X==="development"?H:void 0,await this.getTargetPlatform(),B)),W.includeInvalid||(H=H.filter(ie=>ie.isValid)),H.sort((ie,re)=>{const Z=v.$nc(ie.location.fsPath),z=v.$nc(re.location.fsPath);return Z<z?-1:Z>z?1:0})}L(H,X,W,B,ie){const re=(z,x,G)=>{if(z.isValid&&!x.isValid)return!1;if(z.isValid===x.isValid){if(ie&&c.gt(z.manifest.version,x.manifest.version))return this.y.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${z.location.path} with version ${z.manifest.version}`),!1;if(c.eq(z.manifest.version,x.manifest.version)){if(z.type===0)return this.y.debug(`Skipping extension ${x.location.path} in favour of system extension ${z.location.path} with same version`),!1;if(z.targetPlatform===B)return this.y.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return G?this.y.warn(`Overwriting user extension ${z.location.path} with ${x.location.path}.`):this.y.debug(`Overwriting user extension ${z.location.path} with ${x.location.path}.`),!0},Z=new m.$Xm;return H?.forEach(z=>{const x=Z.get(z.identifier.id);(!x||re(x,z,!1))&&Z.set(z.identifier.id,z)}),X?.forEach(z=>{const x=Z.get(z.identifier.id);if(!x&&H&&z.type===0){this.y.debug(`Skipping obsolete system extension ${z.location.path}.`);return}(!x||re(x,z,!1))&&Z.set(z.identifier.id,z)}),W?.forEach(z=>{const x=Z.get(z.identifier.id);(!x||re(x,z,!0))&&Z.set(z.identifier.id,z),Z.set(z.identifier.id,z)}),[...Z.values()]}async M(H,X){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0,this.R()),ie=await(H&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(H,X){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const B=X?await this.O():{},ie=[],re=f.URI.file(v.$hc(v.$jc(E.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const z of W){const x=B[z.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":ie.push((0,l.$bh)(re,z.name));break;default:ie.push(f.URI.file(x));break}}const Z=await Promise.all(ie.map(async z=>this.n.scanExtension(await this.P(z,!1,0,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,R.$Hb)(Z)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,X,W,B,ie,re,Z,z){const x=await this.f(ie??y.$w),G=await this.Q(H),N=X&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,U=N?await this.Q(N):void 0;return new M(H,G,N,U,X,Z,W,B,re,z.version,z.date,this.C.commit,!this.z.isBuilt,ie,x)}async Q(H){try{const X=await this.w.stat(H);if(typeof X.mtime=="number")return X.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Aq=O,e.$Aq=O=ve([Y(4,S.$Gl),Y(5,p.$vq),Y(6,r.$7k),Y(7,n.$7j),Y(8,h.$Hi),Y(9,i.$nk),Y(10,b.$El),Y(11,s.$zi)],O);class M{constructor(H,X,W,B,ie,re,Z,z,x,G,N,U,V,q,_){this.location=H,this.mtime=X,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=B,this.profile=ie,this.profileScanOptions=re,this.type=Z,this.excludeObsolete=z,this.validate=x,this.productVersion=G,this.productDate=N,this.productCommit=U,this.devMode=V,this.language=q,this.translations=_}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,X){return(0,l.$7g)(H.location,X.location)&&H.mtime===X.mtime&&(0,l.$7g)(H.applicationExtensionslocation,X.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&H.profile===X.profile&&A.$$n(H.profileScanOptions,X.profileScanOptions)&&H.type===X.type&&H.excludeObsolete===X.excludeObsolete&&H.validate===X.validate&&H.productVersion===X.productVersion&&H.productDate===X.productDate&&H.productCommit===X.productCommit&&H.devMode===X.devMode&&H.language===X.language&&C.equals(H.translations,X.translations)}}e.$Bq=M;let T=class extends d.$Uc{constructor(H,X,W,B,ie){super(),this.f=H,this.g=X,this.h=W,this.j=B,this.m=ie}async scanExtensions(H){const X=H.profile?await this.r(H):await this.n(H);let W={};if(H.excludeObsolete&&H.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();W=JSON.parse(B)}catch{}return(0,$.$ng)(W)?X:X.filter(B=>!W[g.$Bp.create(B).toString()])}async n(H){const X=await this.j.resolve(H.location);if(!X.children?.length)return[];const W=await Promise.all(X.children.map(async B=>{if(!B.isDirectory||H.type===1&&(0,l.$$g)(B.resource).indexOf(".")===0)return null;const ie=new M(B.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ie)}));return(0,R.$Hb)(W).sort((B,ie)=>B.location.path<ie.location.path?-1:1)}async r(H){let X=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){X=X.filter(B=>!B.metadata?.isApplicationScoped);const W=await this.s(H.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,H);X.push(...W)}return X}async s(H,X,W){const B=await this.g.scanProfileExtensions(H,W.profileScanOptions);if(!B.length)return[];const ie=await Promise.all(B.map(async re=>{if(X(re)){const Z=new M(re.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(Z,re.metadata)}return null}));return(0,R.$Hb)(ie)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,l.$bh)(H.location,"package.json"))){const X=await this.scanExtension(H);return X?[X]:[]}else return await this.scanExtensions(H)}catch(X){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,D.$0)(X)),[]}}async scanExtension(H,X){try{let W=await this.scanExtensionManifest(H.location);if(W){W.publisher||(W.publisher=m.$Rm),X=X??W.__metadata,delete W.__metadata;const B=(0,g.$Fp)(W.publisher,W.name),ie=X?.id?{id:B,uuid:X.id}:{id:B},re=X?.isSystem?0:H.type,Z=re===0||!!X?.isBuiltin;W=await this.t(H.location,W,M.createNlsConfiguration(H));const z={type:re,identifier:ie,manifest:W,location:H.location,isBuiltin:Z,targetPlatform:X?.targetPlatform??"undefined",publisherDisplayName:X?.publisherDisplayName,metadata:X,isValid:!0,validations:[]};return H.validate?this.validate(z,H):z}}catch(W){H.type!==0&&this.m.error(W)}return null}validate(H,X){let W=!0;const B=(0,t.$Qp)(X.productVersion,X.productDate,X.location,H.manifest,H.isBuiltin);for(const[ie,re]of B)ie===w.default.Error&&(W=!1,this.m.error(this.z(X.location,re)));return H.isValid=W,H.validations=B,H}async scanExtensionManifest(H){const X=(0,l.$bh)(H,"package.json");let W;try{W=(await this.j.readFile(X)).value.toString()}catch(ie){return(0,r.$ll)(ie)!==1&&this.m.error(this.z(H,(0,u.localize)(0,null,X.path,ie.message))),null}let B;try{B=JSON.parse(W)}catch{const re=[];(0,I.$Nn)(W,re);for(const Z of re)this.m.error(this.z(H,(0,u.localize)(1,null,X.path,Z.offset,Z.length,(0,P.$xq)(Z.error))));return null}return(0,I.$Wn)(B)!=="object"?(this.m.error(this.z(H,(0,u.localize)(2,null,X.path))),null):B}async t(H,X,W){const B=await this.u(H,X,W);if(B)try{const ie=[],re=await this.w(B.default,ie);if(ie.length>0)return ie.forEach(z=>{this.m.error(this.z(H,(0,u.localize)(3,null,B.default?.path,(0,P.$xq)(z.error))))}),X;if((0,I.$Wn)(B)!=="object")return this.m.error(this.z(H,(0,u.localize)(4,null,B.default?.path))),X;const Z=B.values||Object.create(null);return(0,k.$yq)(this.m,X,Z,re)}catch{}return X}async u(H,X,W){const B=(0,l.$bh)(H,"package.nls.json"),ie=(x,G)=>{G.forEach(N=>{this.m.error(this.z(H,(0,u.localize)(5,null,x?.path,(0,P.$xq)(N.error))))})},re=x=>{this.m.error(this.z(H,(0,u.localize)(6,null,x?.path)))},Z=`${X.publisher}.${X.name}`,z=W.translations[Z];if(z)try{const x=f.URI.file(z),G=(await this.j.readFile(x)).value.toString(),N=[],U=(0,I.$Nn)(G,N);return N.length>0?(ie(x,N),{values:void 0,default:B}):(0,I.$Wn)(U)!=="object"?(re(x),{values:void 0,default:B}):{values:U.contents?U.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let G;try{G=await this.y(H,W)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const N=(await this.j.readFile(G.localized)).value.toString(),U=[],V=(0,I.$Nn)(N,U);return U.length>0?(ie(G.localized,U),{values:void 0,default:G.original}):(0,I.$Wn)(V)!=="object"?(re(G.localized),{values:void 0,default:G.original}):{values:V,default:G.original}}catch{return{values:void 0,default:G.original}}}}async w(H,X){if(H)try{const W=(await this.j.readFile(H)).value.toString();return(0,I.$Nn)(W,X)}catch{}}y(H,X){return new Promise((W,B)=>{const ie=re=>{const Z=(0,l.$bh)(H,`package.nls.${re}.json`);this.j.exists(Z).then(z=>{z&&W({localized:Z,original:(0,l.$bh)(H,"package.nls.json")});const x=re.lastIndexOf("-");x===-1?W({localized:(0,l.$bh)(H,"package.nls.json"),original:null}):(re=re.substring(0,x),ie(re))})};if(X.devMode||X.pseudo||!X.language)return W({localized:(0,l.$bh)(H,"package.nls.json"),original:null});ie(X.language)})}z(H,X){return`[${H.path}]: ${X}`}};T=ve([Y(1,p.$vq),Y(2,b.$El),Y(3,r.$7k),Y(4,n.$7j)],T);let F=class extends T{constructor(H,X,W,B,ie,re,Z){super(X,B,ie,re,Z),this.G=H,this.H=W,this.D=this.B(new L.$yh(3e3)),this.F=this.B(new o.$he),this.onDidChangeCache=this.F.event}async scanExtensions(H){const X=this.M(H),W=await this.I(X);if(this.C=H,W&&W.input&&M.equals(W.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),W.result.map(ie=>(ie.location=f.URI.revive(ie.location),ie));const B=await super.scanExtensions(H);return await this.J(X,{input:H,result:B}),B}async I(H){try{const X=await this.j.readFile(H),W=JSON.parse(X.value.toString());return{result:W.result,input:(0,a.$0h)(W.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",H.path,(0,D.$0)(X))}return null}async J(H,X){try{await this.j.writeFile(H,j.$Je.fromString(JSON.stringify(X)))}catch(W){this.m.debug("Error while writing the extension cache file:",H.path,(0,D.$0)(W))}}async L(){if(!this.C)return;const H=this.M(this.C),X=await this.I(H);if(!X)return;const W=X.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$$n(B,W))try{this.m.info("Invalidating Cache",W,B),await this.j.del(H),this.F.fire()}catch(ie){this.m.error(ie)}}M(H){const X=this.N(H);return this.h.extUri.joinPath(X.cacheHome,H.type===0?m.$Qm:m.$Pm)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(H.location,X.extensionsResource))??this.G:this.H.defaultProfile}};F=ve([Y(2,S.$Gl),Y(3,p.$vq),Y(4,b.$El),Y(5,r.$7k),Y(6,n.$7j)],F);function K(Q,H){const X=(0,g.$Dp)(Q.manifest.publisher,Q.manifest.name);return{id:X,identifier:new m.$Vm(X),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:H,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,publisherDisplayName:Q.publisherDisplayName,...Q.manifest}}class J extends O{constructor(H,X,W,B,ie,re,Z,z,x,G,N,U){super(H,X,(0,l.$bh)(W,".vscode-oss-dev","extensions","control.json"),B,ie,re,Z,z,x,G,N,U),this.S=(async()=>{if(y.$z)try{const V=await this.w.readFile(f.URI.file(y.$z));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Dq=J}),define(le[250],he([0,1,67,6,38,3,2,23,14,31,9,19]),function(se,e,R,L,A,j,D,I,P,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let y=class extends D.$Uc{constructor(c,w){super(),this.b=c,this.f=w,this.a=new L.$Gh(5)}async postUninstall(c){const w=this.g(c,"uninstall");w&&(this.f.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(w.script,"uninstall",w.args,!0,c),this.f.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.f.error($)}}));try{await d.Promises.rm(this.m(c))}catch($){this.f.error("Error while removing extension storage path",c.identifier.id),this.f.error($)}}g(c,w){const $=`vscode:${w}`;if(c.location.scheme===I.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[$]=="string"){const f=c.manifest.scripts[$].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(c.identifier.id,c.manifest.version,`${$} should be a node script`),null):{script:(0,P.$jc)(c.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(c,w,$,f,u){return new Promise((h,g)=>{const m=this.j(c,w,$,u);let t;const r=s=>{t&&(clearTimeout(t),t=null),s?g(s):h(void 0)};m.on("error",s=>{r((0,A.$lj)(s)||"Unknown")}),m.on("exit",(s,n)=>{r(s?`post-${w} process exited with code ${s}`:void 0)}),f&&(t=setTimeout(()=>{t=null,m.kill(),g("timed out")},5e3))})}j(c,w,$,f){const u={silent:!0,execArgv:void 0},h=(0,R.fork)(c,[`--type=extension-post-${w}`,...$],u);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const g=j.Event.fromNodeEventEmitter(h.stdout,"data"),m=j.Event.fromNodeEventEmitter(h.stderr,"data");this.B(g(s=>this.f.info(f.identifier.id,f.manifest.version,`post-${w}`,s))),this.B(m(s=>this.f.error(f.identifier.id,f.manifest.version,`post-${w}`,s)));const t=j.Event.any(j.Event.map(g,s=>({data:`%c${s}`,format:[""]}),this.q),j.Event.map(m,s=>({data:`%c${s}`,format:["color: red"]}),this.q));return j.Event.debounce(t,(s,n)=>s?{data:s.data+n.data,format:[...s.format,...n.format]}:{data:n.data,format:n.format},100,void 0,void 0,void 0,this.q)(s=>{console.group(f.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),h}m(c){return(0,P.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.$Hq=y,e.$Hq=y=ve([Y(0,v.$Gl),Y(1,E.$7j)],y)}),define(le[114],he([0,1,70,163,81,28]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=D,e.$Fq=I;function D(P){let d="Extract";return P instanceof R.$nq&&(P.type==="CorruptZip"?d="CorruptZip":P.type==="Incomplete"&&(d="IncompleteZip")),(0,A.$sq)(P,d)}async function I(P){let d;try{d=await(0,R.$qq)(P,"extension/package.json")}catch(E){throw D(E)}try{return JSON.parse(d.toString("utf8"))}catch{throw new j.$bp((0,L.localize)(0,null),"Invalid")}}}),define(le[251],he([0,1,6,7,2,23,21,55,13,32,31,70,22,16,81,28,33,114,108,12,9,18]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;let r=class extends A.$Uc{static{t=this}static{this.c=".sigzip"}constructor(n,i,o,a,p,S,b){super(),this.h=i,this.j=o,this.m=a,this.n=p,this.r=S,this.t=b,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(n,i,o,a){await this.g;const p=await this.w(n,i);let S=!1;if(o&&this.u(n)){let b;try{b=await this.y(n)}catch(k){try{await this.delete(p)}catch(C){this.t.error(C)}throw k}try{S=await this.n.verify(n,p.fsPath,b.fsPath,a)}catch(k){if(S=k.code,S==="PackageIsInvalidZip"||S==="SignatureArchiveIsInvalidZip"){try{await this.delete(p)}catch(C){this.t.error(C)}throw new w.$bp(v.$mq,"CorruptZip")}}finally{try{await this.delete(b)}catch(k){this.t.error(k)}}}return{location:p,verificationStatus:S}}u(n){if(!n.isSigned)return this.t.info(`Extension is not signed: ${n.identifier.id}`),!1;const i=this.m.getValue("extensions.verifySignature");return(0,P.$gg)(i)?i:!0}async w(n,i){try{const o=(0,D.$bh)(this.extensionsDownloadDir,this.G(n)),a=await this.C(n,"vsix",async()=>{await this.z(n,o,p=>this.j.download(n,p,i));try{await this.D(o.fsPath,"extension/package.json")}catch(p){try{await this.h.del(o)}catch(S){this.t.warn(`Error while deleting: ${o.path}`,(0,L.$0)(S))}throw p}},2);return a>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:n.identifier.id,attempts:a}),o}catch(o){throw(0,c.$sq)(o,"Download")}}async y(n){try{const i=(0,D.$bh)(this.extensionsDownloadDir,`.${(0,d.$Wg)()}`),o=await this.C(n,"sigzip",async()=>{await this.j.downloadSignatureArchive(n,i);try{await this.D(i.fsPath,".signature.p7s")}catch(a){try{await this.h.del(i)}catch(p){this.t.warn(`Error while deleting: ${i.path}`,(0,L.$0)(p))}throw a}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:n.identifier.id,attempts:o}),i}catch(i){throw(0,c.$sq)(i,"DownloadSignature")}}async z(n,i,o){if(await this.h.exists(i))return;if(i.scheme!==j.Schemas.file){await o(i);return}const a=(0,D.$bh)(this.extensionsDownloadDir,`.${(0,d.$Wg)()}`);try{await o(a)}catch(p){try{await this.h.del(a)}catch{}throw p}try{await E.Promises.rename(a.fsPath,i.fsPath,2*60*1e3)}catch(p){try{await this.h.del(a)}catch{}let S=!1;try{S=await this.h.exists(i)}catch{}if(S)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,i.path);else throw this.t.info(`Rename failed because of ${(0,L.$0)(p)}. Deleted the file from downloaded location`,a.path),p}}async C(n,i,o,a){let p=1;for(;;)try{return await o(),p}catch(S){if(p++>a)throw S;this.t.warn(`Failed downloading ${i}. ${(0,L.$0)(S)}. Retry again...`,n.identifier.id)}}async D(n,i){try{await(0,v.$qq)(n,i)}catch(o){throw(0,f.$Eq)(o)}}async delete(n){await this.g,await this.h.del(n)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const i=[],o=[],a=[];for(const b of n.children)if(b.name.endsWith(t.c))a.push(b.resource);else{const k=$.$Bp.parse(b.name);k&&o.push([k,b])}const p=(0,$.$Gp)(o,([b])=>b),S=[];for(const b of p)b.sort((k,C)=>I.rcompare(k[0].version,C[0].version)),i.push(...b.slice(1).map(k=>k[1].resource)),S.push(b[0][1]);S.sort((b,k)=>b.mtime-k.mtime),i.push(...S.slice(0,Math.max(0,S.length-this.f)).map(b=>b.resource)),i.push(...a),await R.Promises.settled(i.map(b=>(this.t.trace("Deleting from cache",b.path),this.h.del(b))))}}catch(n){this.t.error(n)}}G(n){return this.f?$.$Bp.create(n).toString().toLowerCase():(0,d.$Wg)()}};e.$Gq=r,e.$Gq=r=t=ve([Y(0,l.$Ii),Y(1,h.$7k),Y(2,w.$_o),Y(3,y.$7i),Y(4,u.$fq),Y(5,m.$6l),Y(6,g.$7j)],r)}),define(le[115],he([0,1,6,15,26,38,7,3,54,2,34,23,14,21,55,13,8,32,31,70,162,96,16,81,28,33,52,82,251,250,114,222,232,71,12,4,9,24,18,29,19]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m,t,r,s,n,i,o,a,p,S,b,k,C,O,M,T,F,K,J,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=void 0,e.$Kq=(0,M.$Bi)(s.$cp);const H=".vsctmp";let X=class extends r.$rq{constructor(Z,z,x,G,N,U,V,q,_,ee,ne,te){super(Z,z,ne,x,ee,te),this.eb=N,this.fb=U,this.gb=V,this.hb=q,this.ib=_,this.db=new Map,this.tb=new E.$Bc;const ce=this.B(q.createInstance(p.$Hq));this.ab=this.B(q.createInstance(W,$e=>ce.postUninstall($e))),this.bb=this.B(new b.$Iq(te,_,ne,this,this.F)),this.cb=this.B(q.createInstance(a.$Gq));const fe=this.B(new k.$Jq(this,this.eb,te,U,ne,_,x));this.B(fe.onDidChangeExtensionsByAnotherSource($e=>this.sb($e))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$Lp)(this.ib,this.F)),this.jb}async zip(Z){this.F.trace("ExtensionManagementService#zip",Z.identifier.id);const z=await this.rb(Z),x=await(0,h.zip)((0,l.$bh)(this.cb.extensionsDownloadDir,(0,f.$Wg)()).fsPath,z);return $.URI.file(x)}async unzip(Z){return this.F.trace("ExtensionManagementService#unzip",Z.toString()),(await this.install(Z)).identifier}async getManifest(Z){const{location:z,cleanup:x}=await this.lb(Z),G=y.$kc(z.fsPath);try{return await(0,S.$Fq)(G)}finally{await x()}}getInstalled(Z,z=this.H.defaultProfile.extensionsResource,x={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(Z??null,z,x)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Z){return this.ab.scanUserExtensionAtLocation(Z)}async install(Z,z={}){this.F.trace("ExtensionManagementService#install",Z.toString());const{location:x,cleanup:G}=await this.lb(Z);try{const N=await(0,S.$Fq)(y.$kc(x.fsPath)),U=(0,n.$Fp)(N.publisher,N.name);if(N.engines&&N.engines.vscode&&!(0,C.$Sp)(N.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,U,this.G.version));const q=(await this.I([{manifest:N,extension:x,options:z}])).find(({identifier:_})=>(0,n.$Ap)(_,{id:U}));if(q?.local)return q.local;throw q?.error?q.error:(0,r.$sq)(new Error(`Unknown error while installing extension ${U}`))}finally{await G()}}async installFromLocation(Z,z){this.F.trace("ExtensionManagementService#installFromLocation",Z.toString());const x=await this.ab.scanUserExtensionAtLocation(Z);if(!x||!x.manifest.name||!x.manifest.version)throw new Error(`Cannot find a valid extension from the location ${Z.toString()}`);return await this.wb([[x,{source:"resource"}]],z),this.F.info("Successfully installed extension",x.identifier.id,z.toString()),x}async installExtensionsFromProfile(Z,z,x){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Z,z.toString(),x.toString());const G=(await this.getInstalled(1,z)).filter(N=>Z.some(U=>(0,n.$Ap)(U,N.identifier)));if(G.length){const N=await Promise.all(G.map(U=>this.ab.scanMetadata(U,z)));await this.wb(G.map((U,V)=>[U,N[V]]),x),this.F.info("Successfully installed extensions",G.map(U=>U.identifier.id),x.toString())}return G}async updateMetadata(Z,z,x=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Z.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),Z=await this.ab.updateMetadata(Z,z,x),this.bb.invalidate(x),this.w.fire(Z),Z}async reinstallFromGallery(Z){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Z.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const z=await this.getTargetPlatform(),[x]=await this.z.getExtensions([{...Z.identifier,preRelease:Z.preRelease}],{targetPlatform:z,compatible:!0},A.CancellationToken.None);if(!x)throw new Error(g.localize(2,null));await this.ab.setUninstalled(Z);try{await this.ab.removeUninstalledExtension(Z)}catch(G){throw new Error(g.localize(3,null,(0,j.$lj)(G)))}return this.installFromGallery(x)}$(Z,z,x,G){return this.ab.copyExtension(Z,z,x,G)}copyExtensions(Z,z){return this.ab.copyExtensions(Z,z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...Z){return this.ab.setUninstalled(...Z)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(Z){this.F.error(Z)}}async download(Z,z,x){const{location:G}=await this.cb.download(Z,z,!x);return G}async lb(Z){if(Z.scheme===v.Schemas.file)return{location:Z,async cleanup(){}};this.F.trace("Downloading extension from",Z.toString());const z=(0,l.$bh)(this.cb.extensionsDownloadDir,(0,f.$Wg)());return await this.gb.download(Z,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(G){this.F.error(G)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(Z,z,x){const G=z instanceof $.URI?new n.$Bp({id:(0,n.$Fp)(Z.publisher,Z.name)},Z.version):n.$Bp.create(z);return this.hb.createInstance(B,G,Z,z,x,(N,U)=>{if(z instanceof $.URI)return this.qb(G,z,x,U);let V=this.db.get(G.toString());return V||(this.db.set(G.toString(),V=this.pb(G,z,N,x,U)),V.finally(()=>this.db.delete(G.toString()))),V},this.ab)}Z(Z,z){return new ie(Z,z.profileLocation,this.fb)}async pb(Z,z,x,G,N){const{verificationStatus:U,location:V}=await this.cb.download(z,x,!G.donotVerifySignature,G.context?.[s.$5o]);try{if(N.isCancellationRequested)throw new D.$5;return await(0,S.$Fq)(V.fsPath),{local:await this.ab.extractUserExtension(Z,V.fsPath,{id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName,targetPlatform:z.properties.targetPlatform,isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,preRelease:(0,w.$gg)(G.preRelease)?G.preRelease:G.installPreReleaseVersion||z.properties.isPreReleaseVersion,source:"gallery"},!1,N),verificationStatus:U}}catch(q){try{await this.cb.delete(V)}catch(_){this.F.warn("Error while deleting the downloaded file",V.toString(),(0,D.$0)(_))}throw(0,r.$sq)(q)}}async qb(Z,z,x,G){return{local:await this.ab.extractUserExtension(Z,y.$kc(z.fsPath),{isApplicationScoped:x.isApplicationScoped,isMachineScoped:x.isMachineScoped,isBuiltin:x.isBuiltin,installedTimestamp:Date.now(),pinned:x.installGivenVersion?!0:!!x.pinned,source:"vsix"},!0,G)}}async rb(Z){const z=async G=>{let N=await u.Promises.readdir(G);N=N.map(q=>y.$jc(G,q));const U=await Promise.all(N.map(q=>u.Promises.stat(q)));let V=Promise.resolve([]);return U.forEach((q,_)=>{const ee=N[_];q.isFile()&&(V=V.then(ne=>[...ne,ee])),q.isDirectory()&&(V=V.then(ne=>z(ee).then(te=>[...ne,...te])))}),V};return(await z(Z.location.fsPath)).map(G=>({path:`extension/${y.$lc(Z.location.fsPath,G)}`,localPath:G}))}async sb({added:Z,removed:z}){if(z){const x=Z&&this.D.extUri.isEqual(z.profileLocation,Z.profileLocation)?z.extensions.filter(G=>Z.extensions.every(N=>!(0,n.$Ap)(N,G))):z.extensions;for(const G of x)this.F.info("Extensions removed from another source",G.id,z.profileLocation.toString()),this.u.fire({identifier:G,profileLocation:z.profileLocation})}if(Z){const G=(await this.getInstalled(1,Z.profileLocation)).filter(N=>Z.extensions.some(U=>(0,n.$Ap)(U,N.identifier)));this.s.fire(G.map(N=>(this.F.info("Extensions added from another source",N.identifier.id,Z.profileLocation.toString()),{identifier:N.identifier,local:N,profileLocation:Z.profileLocation,operation:1})))}}async ub(){this.B(this.ab.onExtract(z=>this.tb.add(z)));const Z=await this.ib.resolve(this.eb.userExtensionsLocation);for(const z of Z.children??[])z.isDirectory&&this.tb.add(z.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.vb(z)))}async vb(Z){if(!Z.affects(this.eb.userExtensionsLocation,1))return;const z=[];for(const x of Z.rawAdded){if(this.tb.has(x)||!this.D.extUri.isEqual(this.D.extUri.dirname(x),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(x,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(x).startsWith(".")||!(await this.ib.stat(x)).isDirectory)continue;const G=await this.ab.scanUserExtensionAtLocation(x);G&&G.installedTimestamp===void 0&&(this.tb.add(x),z.push(G))}z.length&&(await this.wb(z.map(x=>[x,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(x=>x.identifier.id)))}async wb(Z,z){const x=Z.map(G=>G[0]);await this.xb(x),await this.fb.addExtensionsToProfile(Z,z),this.s.fire(x.map(G=>({local:G,identifier:G.identifier,operation:1,profileLocation:z})))}async xb(Z){const z=await this.ab.getUninstalledExtensions();for(const x of Z){const G=n.$Bp.create(x);z[G.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",G.id),await this.ab.setInstalled(G),this.F.info("Removed the extension from uninstalled list:",G.id))}}};e.$Lq=X,e.$Lq=X=ve([Y(0,s.$_o),Y(1,K.$6l),Y(2,T.$7j),Y(3,t.$Ii),Y(4,o.$zq),Y(5,i.$vq),Y(6,m.$Po),Y(7,M.$zi),Y(8,O.$7k),Y(9,F.$nk),Y(10,J.$El),Y(11,Q.$Gl)],X);let W=class extends d.$Uc{constructor(Z,z,x,G,N,U){super(),this.j=Z,this.m=z,this.n=x,this.s=G,this.t=N,this.u=U,this.h=this.B(new I.$he),this.onExtract=this.h.event,this.c=(0,l.$bh)(this.n.userExtensionsLocation,".obsolete"),this.g=new R.$Hh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Z,z,x){try{const G={includeInvalid:!0,profileLocation:z,productVersion:x};let N=[];return Z===null||Z===0?N.push(...await this.n.scanAllExtensions({includeInvalid:!0},G,!1)):Z===1&&N.push(...await this.n.scanUserExtensions(G)),N=Z!==null?N.filter(U=>U.type===Z):N,await Promise.all(N.map(U=>this.F(U)))}catch(G){throw(0,r.$sq)(G,"Scanning")}}async scanAllUserExtensions(Z){try{const z=await this.n.scanUserExtensions({includeAllVersions:!Z,includeInvalid:!0});return await Promise.all(z.map(x=>this.F(x)))}catch(z){throw(0,r.$sq)(z,"Scanning")}}async scanUserExtensionAtLocation(Z){try{const z=await this.n.scanExistingExtension(Z,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(Z,z,x,G,N){const U=Z.toString(),V=$.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,f.$Wg)()}`)),q=$.URI.file(y.$jc(this.n.userExtensionsLocation.fsPath,U));let _=await this.m.exists(q);if(_&&G){try{await this.y(Z.id,q,"removeExisting")}catch{throw new s.$bp(g.localize(4,null,q.fsPath,Z.id),"Delete")}_=!1}if(_)try{await this.n.updateMetadata(q,x)}catch(ee){throw(0,r.$sq)(ee,"UpdateMetadata")}else try{if(N.isCancellationRequested)throw new D.$5;try{this.u.trace(`Started extracting the extension from ${z} to ${q.fsPath}`),await(0,h.$pq)(z,V.fsPath,{sourcePath:"extension",overwrite:!0},N),this.u.info(`Extracted extension to ${q}:`,Z.id)}catch(ee){throw(0,S.$Eq)(ee)}try{await this.n.updateMetadata(V,x)}catch(ee){throw(0,r.$sq)(ee,"UpdateMetadata")}if(N.isCancellationRequested)throw new D.$5;try{this.u.trace(`Started renaming the extension from ${V.fsPath} to ${q.fsPath}`),await this.C(V.fsPath,q.fsPath),this.u.info("Renamed to",q.fsPath)}catch(ee){if(ee.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Z.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(ee)}. Deleted from extracted location`,V),ee}this.h.fire(q)}catch(ee){try{await this.m.del(V,{recursive:!0})}catch{}throw ee}return this.D(q,1)}async scanMetadata(Z,z){return z?(await this.w(Z,z))?.metadata:this.n.scanMetadata(Z.location)}async w(Z,z){return(await this.s.scanProfileExtensions(z)).find(G=>(0,n.$Ap)(G.identifier,Z.identifier))}async updateMetadata(Z,z,x){try{x?await this.s.updateMetadata([[Z,z]],x):await this.n.updateMetadata(Z.location,z)}catch(G){throw(0,r.$sq)(G,"UpdateMetadata")}return this.D(Z.location,Z.type,x)}async getUninstalledExtensions(){try{return await this.z()}catch(Z){throw(0,r.$sq)(Z,"ReadUninstalled")}}async setUninstalled(...Z){const z=Z.map(x=>n.$Bp.create(x));await this.z(x=>z.forEach(G=>{x[G.toString()]=!0,this.u.info("Marked extension as uninstalled",G.toString())}))}async setInstalled(Z){try{await this.z(z=>delete z[Z.toString()])}catch(z){throw(0,r.$sq)(z,"UnsetUninstalled")}}async removeExtension(Z,z){if(this.t.extUri.isEqualOrParent(Z.location,this.n.userExtensionsLocation))return this.y(Z.identifier.id,Z.location,z)}async removeUninstalledExtension(Z){await this.removeExtension(Z,"uninstalled"),await this.z(z=>delete z[n.$Bp.create(Z).toString()])}async copyExtension(Z,z,x,G){const N=await this.w(Z,z),U=await this.w(Z,x);if(G={...N?.metadata,...G},U)if(this.t.extUri.isEqual(U.location,Z.location))await this.s.updateMetadata([[Z,{...U.metadata,...G}]],x);else{const V=await this.D(U.location,Z.type,x);await this.s.removeExtensionFromProfile(V,x),await this.s.addExtensionsToProfile([[Z,{...U.metadata,...G}]],x)}else await this.s.addExtensionsToProfile([[Z,G]],x);return this.D(Z.location,Z.type,x)}async copyExtensions(Z,z,x){const G=await this.scanExtensions(1,Z,x),N=await Promise.all(G.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,Z)]));await this.s.addExtensionsToProfile(N,z)}async y(Z,z,x){this.u.trace(`Deleting ${x} extension from disk`,Z,z.fsPath);const G=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,P.$oj)((0,f.$Wg)()).toString(16)}${H}`);await this.C(z.fsPath,G.fsPath),await this.m.del(G,{recursive:!0}),this.u.info(`Deleted ${x} extension from disk`,Z,z.fsPath)}z(Z){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(G){if((0,O.$ll)(G)!==1)throw G}let x={};if(z)try{x=JSON.parse(z)}catch{}return Z&&(Z(x),Object.keys(x).length?await this.m.writeFile(this.c,L.$Je.fromString(JSON.stringify(x))):await this.m.del(this.c)),x})}async C(Z,z){try{await u.Promises.rename(Z,z,2*60*1e3)}catch(x){throw(0,r.$sq)(x,"Rename")}}async D(Z,z,x){try{if(x){const N=(await this.n.scanUserExtensions({profileLocation:x})).find(U=>this.t.extUri.isEqual(U.location,Z));if(N)return await this.F(N)}else{const G=await this.n.scanExistingExtension(Z,z,{includeInvalid:!0});if(G)return await this.F(G)}throw new s.$bp(g.localize(5,null,Z.path),"ScanningExtension")}catch(G){throw(0,r.$sq)(G,"ScanningExtension")}}async F(Z){const z=await this.m.resolve(Z.location);let x,G;return z.children&&(x=z.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,G=z.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource),{identifier:Z.identifier,type:Z.type,isBuiltin:Z.isBuiltin||!!Z.metadata?.isBuiltin,location:Z.location,manifest:Z.manifest,targetPlatform:Z.targetPlatform,validations:Z.validations,isValid:Z.isValid,readmeUrl:x,changelogUrl:G,publisherDisplayName:Z.metadata?.publisherDisplayName,publisherId:Z.metadata?.publisherId||null,isApplicationScoped:!!Z.metadata?.isApplicationScoped,isMachineScoped:!!Z.metadata?.isMachineScoped,isPreReleaseVersion:!!Z.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!Z.metadata?.hasPreReleaseVersion,preRelease:!!Z.metadata?.preRelease,installedTimestamp:Z.metadata?.installedTimestamp,updated:!!Z.metadata?.updated,pinned:!!Z.metadata?.pinned,isWorkspaceScoped:!1,source:Z.metadata?.source??(Z.identifier.uuid?"gallery":"vsix")}}async G(){const Z=await this.getUninstalledExtensions();if(Object.keys(Z).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Z));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),x=new Set;for(const N of z)Z[n.$Bp.create(N).toString()]||x.add(N.identifier.id.toLowerCase());try{const N=(0,n.$Gp)(z,U=>U.identifier);await R.Promises.settled(N.map(async U=>{const V=U.sort((q,_)=>c.rcompare(q.manifest.version,_.manifest.version))[0];x.has(V.identifier.id.toLowerCase())||await this.j(await this.F(V))}))}catch(N){this.u.error(N)}const G=z.filter(N=>N.metadata&&Z[n.$Bp.create(N).toString()]);await Promise.allSettled(G.map(N=>this.removeUninstalledExtension(N)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Z;try{Z=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,O.$ll)(z)!==1&&this.u.error(z);return}if(Z?.children)try{await Promise.allSettled(Z.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(x){(0,O.$ll)(x)!==1&&this.u.error(x)}}}))}catch{}}};e.$Mq=W,e.$Mq=W=ve([Y(1,O.$7k),Y(2,o.$zq),Y(3,i.$vq),Y(4,J.$El),Y(5,T.$7j)],W);let B=class extends r.$tq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(Z,z,x,G,N,U,V,q,_,ee,ne,te){super(),this.l=Z,this.manifest=z,this.source=x,this.options=G,this.m=N,this.n=U,this.o=V,this.p=q,this.q=_,this.s=ee,this.t=ne,this.u=te,this.j=2,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(z=>(0,n.$Ap)(z.identifier,this.identifier))}async h(Z){const z=await this.v();z&&(this.j=3);const x={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===0?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:this.source instanceof $.URI?"vsix":"gallery"};if(this.source instanceof $.URI)if(z){if(this.l.equals(new n.$Bp(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(g.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const V=await this.x(this.l);if(V)try{await this.n.removeExtension(V,"existing")}catch{throw new Error(g.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(x.id=this.source.identifier.uuid,x.publisherId=this.source.publisherId,x.publisherDisplayName=this.source.publisherDisplayName,x.targetPlatform=this.source.properties.targetPlatform,x.updated=!!z,x.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,x.hasPreReleaseVersion=z?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,x.preRelease=(0,w.$gg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||z?.preRelease,z&&z.type!==0&&z.manifest.version===this.source.version)return this.n.updateMetadata(z,x);const V=await this.x(this.l);if(V)return V}if(Z.isCancellationRequested)throw(0,r.$sq)(new D.$5);const{local:G,verificationStatus:N}=await this.m(this.operation,Z);if(this.k=N,this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(V){throw(0,r.$sq)(V,"IntializeDefaultProfile")}if(Z.isCancellationRequested)throw(0,r.$sq)(new D.$5);try{await this.t.addExtensionsToProfile([[G,x]],this.options.profileLocation,!G.isValid)}catch(V){throw(0,r.$sq)(V,"AddToProfile")}const U=await this.v();if(!U)throw new s.$bp("Cannot find the installed extension","InstalledExtensionNotFound");return this.source instanceof $.URI&&this.y(G,Z),U}async x(Z){return(await this.n.getUninstalledExtensions())[Z.toString()]?(this.u.trace("Removing the extension from uninstalled list:",Z.id),await this.n.setInstalled(Z),this.u.info("Removed the extension from uninstalled list:",Z.id),(await this.n.scanAllUserExtensions(!0)).find(G=>n.$Bp.create(G).equals(Z))):void 0}async y(Z,z){try{let[x]=await this.p.getExtensions([{id:Z.identifier.id,version:Z.manifest.version}],z);if(x||([x]=await this.p.getExtensions([{id:Z.identifier.id}],z)),x){const G={id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,hasPreReleaseVersion:Z.hasPreReleaseVersion||x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(Z,G,this.options.profileLocation)}}catch{}}};B=ve([Y(6,J.$El),Y(7,s.$_o),Y(8,Q.$Gl),Y(9,o.$zq),Y(10,i.$vq),Y(11,T.$7j)],B);class ie extends r.$tq{constructor(Z,z,x){super(),this.extension=Z,this.j=z,this.k=x}async h(Z){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[252],he([0,1,9,19,29,18,52,12,16,8]),function(se,e,R,L,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0;let E=class extends D.$wq{constructor(y,l,c,w,$,f){super(d.URI.file(y.extensionsPath),l,c,w,$,f)}};e.$eQ=E,e.$eQ=E=ve([Y(0,P.$Ii),Y(1,I.$7k),Y(2,L.$Gl),Y(3,A.$El),Y(4,j.$6l),Y(5,R.$7j)],E)}),define(le[253],he([0,1,8,16,52,82,12,4,9,24,29,19]),function(se,e,R,L,A,j,D,I,P,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;let y=class extends j.$Dq{constructor(c,w,$,f,u,h,g,m){super(R.URI.file(u.builtinExtensionsPath),R.URI.file(u.extensionsPath),u.userHome,c.defaultProfile,c,w,$,f,u,h,g,m)}};e.$nec=y,e.$nec=y=ve([Y(0,v.$Gl),Y(1,A.$vq),Y(2,D.$7k),Y(3,P.$7j),Y(4,L.$Ii),Y(5,d.$nk),Y(6,E.$El),Y(7,I.$zi)],y)}),define(le[20],he([0,1,6,3,2,99,13,69,4,19]),function(se,e,R,L,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$9p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7p=e.$6p=e.$5p=void 0,e.$8p=l,e.$0p=w,e.$_p=f,e.$5p="__$__isNewStorageMarker",e.$6p="__$__targetStorageMarker",e.$7p=(0,P.$Ai)("storageService");var E;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var v;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var y;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function l(u){const h=u.get(e.$6p);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}class c extends A.$Uc{static{this.a=60*1e3}constructor(h={flushInterval:c.a}){super(),this.m=h,this.b=this.B(new L.$ke),this.c=this.B(new L.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$he),this.onWillSaveState=this.f.event,this.h=this.B(new R.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,g,m){return L.Event.filter(this.b.event,t=>t.scope===h&&(g===void 0||t.key===g),m)}n(){this.j.value=(0,R.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,g){const{key:m,external:t}=g;if(m===e.$6p){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:m,target:this.J(h)[m],external:t})}w(h){this.f.fire({reason:h})}get(h,g,m){return this.P(g)?.get(h,m)}getBoolean(h,g,m){return this.P(g)?.getBoolean(h,m)}getNumber(h,g,m){return this.P(g)?.getNumber(h,m)}getObject(h,g,m){return this.P(g)?.getObject(h,m)}storeAll(h,g){this.y(()=>{for(const m of h)this.store(m.key,m.value,m.scope,m.target,g)})}store(h,g,m,t,r=!1){if((0,D.$jg)(g)){this.remove(h,m,r);return}this.y(()=>{this.z(h,m,t),this.P(m)?.set(h,g,r)})}remove(h,g,m=!1){this.y(()=>{this.z(h,g,void 0),this.P(g)?.delete(h,m)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,g){const m=[],t=this.J(h);for(const r of Object.keys(t))t[r]===g&&m.push(r);return m}z(h,g,m,t=!1){const r=this.J(g);typeof m=="number"?r[h]!==m&&(r[h]=m,this.P(g)?.set(e.$6p,JSON.stringify(r),t)):typeof r[h]=="number"&&(delete r[h],this.P(g)?.set(e.$6p,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const g=this.P(h);return g?l(g):Object.create(null)}isNew(h){return this.getBoolean(e.$5p,h)===!0}async flush(h=E.NONE){this.f.fire({reason:h});const g=this.P(-1),m=this.P(0),t=this.P(1);switch(h){case E.NONE:await R.Promises.settled([g?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await R.Promises.settled([g?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,m=this.P(1)?.items??new Map;return f(h,g,m,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,g){return this.w(E.NONE),(0,d.$Fl)(h)?this.R(h,g):this.S(h,g)}M(h,g){return!(h.id===g.id||w(g)&&w(h))}N(h,g,m){this.y(()=>{const t=new Set;for(const[r,s]of h)t.add(r),g.get(r)!==s&&this.u(m,{key:r,external:!0});for(const[r]of g.items)t.has(r)||this.u(m,{key:r,external:!0})})}}e.$9p=c;function w(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class $ extends c{constructor(){super(),this.U=this.B(new I.$3p(new I.$4p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$3p(new I.$4p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$3p(new I.$4p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$$p=$;async function f(u,h,g,m,t,r){const s=C=>{try{return JSON.parse(C)}catch{return C}},n=new Map,i=new Map;u.forEach((C,O)=>{n.set(O,C),i.set(O,s(C))});const o=new Map,a=new Map;h.forEach((C,O)=>{o.set(O,C),a.set(O,s(C))});const p=new Map,S=new Map;g.forEach((C,O)=>{p.set(O,C),S.set(O,s(C))}),console.group(m!==t?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const b=[];if(n.forEach((C,O)=>{b.push({key:O,value:C})}),console.table(b),console.groupEnd(),console.log(i),m!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];o.forEach((O,M)=>{C.push({key:M,value:O})}),console.table(C),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const k=[];p.forEach((C,O)=>{k.push({key:O,value:C})}),console.table(k),console.groupEnd(),console.log(S)}}),define(le[116],he([0,1,3,2,13,28,33,20]),function(se,e,R,L,A,j,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LKb=e.$KKb=void 0;let P=class extends L.$Uc{constructor(v,y){super(),this.a=new R.$he,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(v)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(y.onDidInstallExtensions(l=>l.forEach(({local:c,operation:w})=>{c&&w===4&&this.f(c.identifier)})))}async enableExtension(v,y){return this.f(v)?(this.a.fire({extensions:[v],source:y}),!0):!1}async disableExtension(v,y){return this.c(v)?(this.a.fire({extensions:[v],source:y}),!0):!1}getDisabledExtensions(){return this.h(j.$dp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(v){const y=this.getDisabledExtensions();return y.every(l=>!(0,D.$Ap)(l,v))?(y.push(v),this.g(y),!0):!1}f(v){const y=this.getDisabledExtensions();for(let l=0;l<y.length;l++){const c=y[l];if((0,D.$Ap)(c,v))return y.splice(l,1),this.g(y),!0}return!1}g(v){this.j(j.$dp,v)}h(v){return this.b.get(v,0)}j(v,y){this.b.set(v,y,0)}};e.$KKb=P,e.$KKb=P=ve([Y(0,I.$7p),Y(1,j.$cp)],P);class d extends L.$Uc{constructor(v){super(),this.c=v,this.a=Object.create(null),this.b=this.B(new R.$he),this.onDidChange=this.b.event,this.B(v.onDidChangeValue(0,void 0,this.B(new L.$Tc))(y=>this.f(y)))}get(v,y){let l;return y===0?((0,A.$jg)(this.a[v])&&(this.a[v]=this.g(v,y)),l=this.a[v]):l=this.g(v,y),JSON.parse(l)}set(v,y,l){const c=JSON.stringify(y.map(({id:$,uuid:f})=>({id:$,uuid:f})));this.g(v,l)!==c&&(l===0&&(y.length?this.a[v]=c:delete this.a[v]),this.h(v,y.length?c:void 0,l))}f(v){if(!(0,A.$jg)(this.a[v.key])&&this.g(v.key,v.scope)!==this.a[v.key]){const l=this.get(v.key,v.scope);delete this.a[v.key];const c=this.get(v.key,v.scope),w=l.filter(f=>!c.some(u=>(0,D.$Ap)(f,u))),$=c.filter(f=>!l.some(u=>(0,D.$Ap)(u,f)));(w.length||$.length)&&this.b.fire([...w,...$])}}g(v,y){return this.c.get(v,y,"[]")}h(v,y,l){y?this.c.store(v,y,l,1):this.c.remove(v,l)}}e.$LKb=d}),define(le[254],he([0,1,17,26,7,5,36,13,8,22,16,28,33,71,12,9,24,59,233,20,18,63]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=void 0,e.$cq=re;const t=j.$o?"web":(0,v.$8o)(j.$u,D.$ec),r="X-Market-Search-Activity-Id";var s;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function n(...U){return String(U.reduce((V,q)=>V|q,0))}var i;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class b{constructor(V=S){this.d=V}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(V,q=this.d.pageSize){return new b({...this.d,pageNumber:V,pageSize:q})}withFilter(V,...q){const _=[...this.d.criteria,...q.length?q.map(ee=>({filterType:V,value:ee})):[{filterType:V}]];return new b({...this.d,criteria:_})}withSortBy(V){return new b({...this.d,sortBy:V})}withSortOrder(V){return new b({...this.d,sortOrder:V})}withFlags(...V){return new b({...this.d,flags:V.reduce((q,_)=>q|_,0)})}withAssetTypes(...V){return new b({...this.d,assetTypes:V})}withSource(V){return new b({...this.d,source:V})}get raw(){const{criteria:V,pageNumber:q,pageSize:_,sortBy:ee,sortOrder:ne,flags:te,assetTypes:ce}=this.d;return{filters:[{criteria:V,pageNumber:q,pageSize:_,sortBy:ee,sortOrder:ne}],assetTypes:ce,flags:te}}get searchText(){const V=this.d.criteria.filter(q=>q.filterType===i.SearchText)[0];return V&&V.value?V.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(V=>String(V.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(U,V){const q=(U||[]).filter(_=>_.statisticName===V)[0];return q?q.value:0}function C(U){const V="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(_=>_.assetType.indexOf(V)===0).reduce((_,ee)=>{const ne=T(U,ee.assetType);return ne&&_.push([ee.assetType.substring(V.length),ne]),_},[])}function O(U){if(U.properties){const V=U.properties.filter(ee=>ee.key===o.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=V.filter(ee=>q.test(ee.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return T(U,o.Repository)}function M(U){return{uri:`${U.fallbackAssetUri}/${o.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${o.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function T(U,V){return U.files.filter(_=>_.assetType===V)[0]?{uri:`${U.assetUri}/${V}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${V}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function F(U,V){const q=U.properties?U.properties.filter(ee=>ee.key===V):[],_=q.length>0&&q[0].value;return _?_.split(",").map(ee=>(0,y.$Ep)(ee)):[]}function K(U){const V=U.properties?U.properties.filter(q=>q.key===a.Engine):[];return V.length>0&&V[0].value||""}function J(U){const V=U.properties?U.properties.filter(q=>q.key===a.PreRelease):[];return V.length>0&&V[0].value==="true"}function Q(U){const V=U.properties?U.properties.filter(_=>_.key===a.LocalizedLanguages):[],q=V.length>0&&V[0].value||"";return q?q.split(","):[]}function H(U){return U.properties?.find(V=>V.key===a.SponsorLink)?.value}function X(U){return U.properties?.find(V=>V.key===a.SupportLink)?.value}function W(U){return U.indexOf("preview")!==-1}function B(U){return U.targetPlatform?(0,v.$7o)(U.targetPlatform):"undefined"}function ie(U){const V=(0,R.$Mb)(U.versions.map(B)),q=!!U.tags?.includes(v.$1o),_=V.indexOf("web");return q?_===-1&&V.push("web"):_!==-1&&V.splice(_,1),V}function re(U,V){for(let q=0;q<U.length;q++){const _=U[q];if(_.version===U[q-1]?.version){let ee=q;if(B(_)===V)for(;ee>0&&U[ee-1].version===_.version;)ee--;ee!==q&&(U.splice(q,1),U.splice(ee,0,_))}}return U}function Z(U,V,q){U.telemetryData={index:V,querySource:q,queryActivityId:U.queryContext?.[r]}}function z(U,V,q,_){const ee=U.versions[0],ne={manifest:T(V,o.Manifest),readme:T(V,o.Details),changelog:T(V,o.Changelog),license:T(V,o.License),repository:O(V),download:M(V),icon:T(V,o.Icon),signature:T(V,o.Signature),coreTranslations:C(V)};return{type:"gallery",identifier:{id:(0,y.$Fp)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:V.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(ee),description:U.shortDescription??"",installCount:k(U.statistics,"install"),rating:k(U.statistics,"averagerating"),ratingCount:k(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:q,assets:ne,properties:{dependencies:F(V,a.Dependency),extensionPack:F(V,a.ExtensionPack),engine:K(V),localizedLanguages:Q(V),targetPlatform:B(V),isPreReleaseVersion:J(V)},hasPreReleaseVersion:J(ee),hasReleaseVersion:!0,preview:W(U.flags),isSigned:!!ne.signature,queryContext:_,supportLink:X(ee)}}let x=class{constructor(V,q,_,ee,ne,te,ce,fe){this.k=q,this.l=_,this.n=ee,this.o=ne,this.q=te,this.u=ce,this.w=fe;const $e=ce.extensionsGallery,we=$e?.servicePPEUrl&&fe.getValue("_extensionsGallery.enablePPE");this.d=we?$e.servicePPEUrl:$e?.serviceUrl,this.g=we?void 0:$e?.searchUrl,this.h=$e?.controlUrl,this.j=(0,u.$bq)(ce.version,ce,this.n,this.w,this.q,V,this.o)}x(V=""){return`${this.d}${V}`}isEnabled(){return!!this.d}async getExtensions(V,q,_){const ee=L.CancellationToken.isCancellationToken(q)?{}:q,ne=L.CancellationToken.isCancellationToken(q)?q:_,te=[],ce=[],fe=[],$e=[];let we=!0;for(const ye of V){ye.uuid?ce.push(ye.uuid):te.push(ye.id);const Pe=!!(ye.version||ye.preRelease);fe.push({id:ye.id,uuid:ye.uuid,includePreRelease:Pe}),ye.version&&$e.push({id:ye.id,uuid:ye.uuid,version:ye.version}),we=we&&!!ye.hasPreRelease&&!Pe}if(!ce.length&&!te.length)return[];let Ee=new b().withPage(1,V.length);ce.length&&(Ee=Ee.withFilter(i.ExtensionId,...ce)),te.length&&(Ee=Ee.withFilter(i.ExtensionName,...te)),(ee.queryAllVersions||we)&&(Ee=Ee.withFlags(Ee.flags,s.IncludeVersions)),ee.source&&(Ee=Ee.withSource(ee.source));const{extensions:be}=await this.z(Ee,{targetPlatform:ee.targetPlatform??t,includePreRelease:fe,versions:$e,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.u.version,date:this.u.date}},ne);return ee.source&&be.forEach((ye,Pe)=>Z(ye,Pe,ee.source)),be}async getCompatibleExtension(V,q,_,ee={version:this.u.version,date:this.u.date}){if((0,v.$9o)(V.allTargetPlatforms,_))return null;if(await this.isExtensionCompatible(V,q,_))return V;const ne=new b().withFlags(s.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,V.identifier.uuid),{extensions:te}=await this.z(ne,{targetPlatform:_,compatible:!0,includePreRelease:q,productVersion:ee},L.CancellationToken.None);return te[0]||null}async isExtensionCompatible(V,q,_,ee={version:this.u.version,date:this.u.date}){if(!(0,v.$0o)(V.properties.targetPlatform,V.allTargetPlatforms,_)||!q&&V.properties.isPreReleaseVersion)return!1;let ne=V.properties.engine;if(!ne){const te=await this.getManifest(V,L.CancellationToken.None);if(!te)throw new Error("Manifest was not found");ne=te.engines.vscode}return(0,l.$Sp)(ne,ee.version,ee.date)}async y(V,q,_,ee,ne,te,ce={version:this.u.version,date:this.u.date}){if(!(0,v.$0o)(B(q),ne,te)||_!=="any"&&J(q)!==(_==="prerelease"))return!1;if(ee)try{const fe=await this.E(V,q);if(!(0,l.$Sp)(fe,ce.version,ce.date))return!1}catch(fe){return this.l.error(`Error while getting the engine for the version ${q.version}.`,(0,A.$0)(fe)),!1}return!0}async query(V,q){let _=V.text||"";const ee=V.pageSize??50;let ne=new b().withPage(1,ee);_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,Ee,be)=>(ne=ne.withFilter(i.Category,be||Ee),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,Ee,be)=>(ne=ne.withFilter(i.Tag,be||Ee),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(i.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),ne=ne.withFilter(i.SearchText,_)),ne=ne.withSortBy(0)):V.ids?ne=ne.withFilter(i.ExtensionId,...V.ids):V.names?ne=ne.withFilter(i.ExtensionName,...V.names):ne=ne.withSortBy(4),typeof V.sortBy=="number"&&(ne=ne.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(ne=ne.withSortOrder(V.sortOrder)),V.source&&(ne=ne.withSource(V.source));const te=async(we,Ee)=>{const{extensions:be,total:ye}=await this.z(we,{targetPlatform:t,compatible:!1,includePreRelease:!!V.includePreRelease,productVersion:V.productVersion??{version:this.u.version,date:this.u.date}},Ee);return be.forEach((Pe,Ce)=>Z(Pe,(we.pageNumber-1)*we.pageSize+Ce,V.source)),{extensions:be,total:ye}},{extensions:ce,total:fe}=await te(ne,q),$e=async(we,Ee)=>{if(Ee.isCancellationRequested)throw new A.$5;const{extensions:be}=await te(ne.withPage(we+1),Ee);return be};return{firstPage:ce,total:fe,pageSize:ne.pageSize,getPage:$e}}async z(V,q,_){const ee=V.flags;V.flags&s.IncludeLatestVersionOnly&&V.flags&s.IncludeVersions&&(V=V.withFlags(V.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(V.flags&s.IncludeLatestVersionOnly)&&!(V.flags&s.IncludeVersions)&&(V=V.withFlags(V.flags,s.IncludeLatestVersionOnly)),q.versions?.length&&(V=V.withFlags(V.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),V=V.withFlags(V.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:ne,total:te,context:ce}=await this.B(V,_);if(!(V.flags&s.IncludeLatestVersionOnly)){const Ee=[];for(const be of ne){const ye=await this.A(be,q,ce);ye&&Ee.push(ye)}return{extensions:Ee,total:te}}const $e=[],we=new Map;for(let Ee=0;Ee<ne.length;Ee++){const be=ne[Ee],ye={id:(0,y.$Fp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Pe=(0,I.$gg)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ae=>(0,y.$Ap)(ae,ye))?.includePreRelease;if(q.compatible&&(0,v.$9o)(ie(be),q.targetPlatform))continue;const Ce=await this.A(be,q,ce);!Ce||Ce.properties.isPreReleaseVersion&&(!Pe||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==q.targetPlatform&&Ce.hasPreReleaseVersion?we.set(be.extensionId,Ee):$e.push([Ee,Ce])}if(we.size){const Ee=new m.$be,be=new b().withFlags(ee&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,we.size).withFilter(i.ExtensionId,...we.keys()),{extensions:ye}=await this.z(be,q,_);this.o.publicLog2("galleryService:additionalQuery",{duration:Ee.elapsed(),count:we.size});for(const Pe of ye){const Ce=we.get(Pe.identifier.uuid);$e.push([Ce,Pe])}}return{extensions:$e.sort((Ee,be)=>Ee[0]-be[0]).map(([,Ee])=>Ee),total:te}}async A(V,q,_){const ee={id:(0,y.$Fp)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},ne=q.versions?.find($e=>(0,y.$Ap)($e,ee))?.version,te=(0,I.$gg)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find($e=>(0,y.$Ap)($e,ee))?.includePreRelease,ce=ie(V),fe=re(V.versions,q.targetPlatform);if(q.compatible&&(0,v.$9o)(ce,q.targetPlatform))return null;for(let $e=0;$e<fe.length;$e++){const we=fe[$e];if(!(ne&&we.version!==ne)){if(await this.y((0,y.$Fp)(V.publisher.publisherName,V.extensionName),we,te?"any":"release",q.compatible,ce,q.targetPlatform,q.productVersion))return z(V,we,ce,_);if(ne&&we.version===ne)return null}}return ne||q.compatible?null:z(V,V.versions[0],ce)}async B(V,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");V=V.withFlags(V.flags,s.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(s.Unpublished));const _=await this.j,ee=JSON.stringify(V.raw),ne={..._,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},te=new m.$be;let ce,fe,$e=0;try{if(ce=await this.k.request({type:"POST",url:this.g&&V.criteria.some(Ee=>Ee.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:ne},q),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:$e};const we=await(0,f.$Zp)(ce);if(we){const Ee=we.results[0],be=Ee.extensions,ye=Ee.resultMetadata&&Ee.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return $e=ye&&ye.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:$e,context:{[r]:ce.res.headers.activityid}}}return{galleryExtensions:[],total:$e}}catch(we){const Ee=(0,A.$4)(we)?"Cancelled":(0,A.$0)(we).startsWith("XHR timeout")?"Timeout":"Failed";throw fe=new v.$ap((0,A.$0)(we),Ee),fe}finally{this.o.publicLog2("galleryService:query",{...V.telemetryData,requestBodySize:String(ee.length),duration:te.elapsed(),success:!!ce&&(0,f.$Vp)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:fe?.code,count:String($e)})}}async reportStatistic(V,q,_,ee){if(!this.isEnabled())return;const ne=j.$o?this.x(`/itemName/${V}.${q}/version/${_}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${V}/extensions/${q}/${_}/stats?statType=${ee}`),te=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",fe={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:ne,headers:fe},L.CancellationToken.None)}catch{}}async download(V,q,_){this.l.trace("ExtensionGalleryService#download",V.identifier.id);const ee=(0,y.$Ip)(V),ne=new Date().getTime(),te=_===2?"install":_===3?"update":"",ce=te?{uri:`${V.assets.download.uri}${P.URI.parse(V.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${V.assets.download.fallbackUri}${P.URI.parse(V.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:V.assets.download,fe=V.queryContext?.[r]?{[r]:V.queryContext[r]}:void 0,$e=await this.D(V.identifier.id,ce,o.VSIX,fe?{headers:fe}:void 0);try{await this.q.writeFile(q,$e.stream)}catch(we){try{await this.q.del(q)}catch(Ee){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,A.$0)(Ee))}throw new v.$ap((0,A.$0)(we),"DownloadFailedWriting")}this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:new Date().getTime()-ne})}async downloadSignatureArchive(V,q){if(!V.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",V.identifier.id);const _=await this.D(V.identifier.id,V.assets.signature,o.Signature);try{await this.q.writeFile(q,_.stream)}catch(ee){try{await this.q.del(q)}catch(ne){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,A.$0)(ne))}throw new v.$ap((0,A.$0)(ee),"DownloadFailedWriting")}}async getReadme(V,q){if(V.assets.readme){const _=await this.D(V.identifier.id,V.assets.readme,o.Details,{},q);return await(0,f.$Yp)(_)||""}return""}async getManifest(V,q){if(V.assets.manifest){const _=await this.D(V.identifier.id,V.assets.manifest,o.Manifest,{},q),ee=await(0,f.$Yp)(_);return ee?JSON.parse(ee):null}return null}async C(V,q,_){const ee=T(q,o.Manifest);if(!ee)throw new Error("Manifest was not found");const ne={"Accept-Encoding":"gzip"},te=await this.D(V,ee,o.Manifest,{headers:ne});return await(0,f.$Zp)(te)}async getCoreTranslation(V,q){const _=V.assets.coreTranslations.filter(ee=>ee[0]===q.toUpperCase())[0];if(_){const ee=await this.D(V.identifier.id,_[1],_[0]),ne=await(0,f.$Yp)(ee);return ne?JSON.parse(ne):null}return null}async getChangelog(V,q){if(V.assets.changelog){const _=await this.D(V.identifier.id,V.assets.changelog,o.Changelog,{},q);return await(0,f.$Yp)(_)||""}return""}async getAllCompatibleVersions(V,q,_){let ee=new b().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);V.identifier.uuid?ee=ee.withFilter(i.ExtensionId,V.identifier.uuid):ee=ee.withFilter(i.ExtensionName,V.identifier.id);const{galleryExtensions:ne}=await this.B(ee,L.CancellationToken.None);if(!ne.length)return[];const te=ie(ne[0]);if((0,v.$9o)(te,_))return[];const ce=[];await Promise.all(ne[0].versions.map(async we=>{try{await this.y(V.identifier.id,we,q?"any":"release",!0,te,_)&&ce.push(we)}catch{}}));const fe=[],$e=new Set;for(const we of re(ce,_))$e.has(we.version)||($e.add(we.version),fe.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:J(we)}));return fe}async D(V,q,_,ee={},ne=L.CancellationToken.None){const te=await this.j,ce={type:"GET"},fe={...te,...ee.headers||{}};ee={...ee,...ce,headers:fe};const $e=q.uri,we=q.fallbackUri,Ee={...ee,url:$e};try{const be=await this.k.request(Ee,ne);if(be.res.statusCode===200)return be;const ye=await(0,f.$Yp)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${ye}`)}catch(be){if((0,A.$4)(be))throw be;const ye=(0,A.$0)(be);this.o.publicLog2("galleryService:cdnFallback",{extension:V,assetType:_,message:ye});const Pe={...ee,url:we};return this.k.request(Pe,ne)}}async E(V,q){let _=K(q);if(!_){this.o.publicLog2("galleryService:engineFallback",{extension:V,version:q.version});const ee=await this.C(V,q,L.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");_=ee.engines.vscode}return _}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const V=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(V.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,f.$Zp)(V),_=[],ee={},ne=[];if(q){for(const te of q.malicious)_.push({id:te});if(q.migrateToPreRelease)for(const[te,ce]of Object.entries(q.migrateToPreRelease))(!ce.engine||(0,l.$Sp)(ce.engine,this.u.version,this.u.date))&&(ee[te.toLowerCase()]={disallowInstall:!0,extension:{id:ce.id,displayName:ce.displayName,autoMigrate:{storage:!!ce.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[te,ce]of Object.entries(q.deprecated))ce&&(ee[te.toLowerCase()]=(0,I.$gg)(ce)?{}:ce);if(q.search)for(const te of q.search)ne.push(te)}return{malicious:_,deprecated:ee,search:ne}}};x=ve([Y(1,f.$Tp),Y(2,w.$7j),Y(3,E.$Hi),Y(4,g.$6l),Y(5,c.$7k),Y(6,$.$nk),Y(7,d.$7i)],x);let G=class extends x{constructor(V,q,_,ee,ne,te,ce,fe){super(V,q,_,ee,ne,te,ce,fe)}};e.$dq=G,e.$dq=G=ve([Y(0,h.$7p),Y(1,f.$Tp),Y(2,w.$7j),Y(3,E.$Hi),Y(4,g.$6l),Y(5,c.$7k),Y(6,$.$nk),Y(7,d.$7i)],G);let N=class extends x{constructor(V,q,_,ee,ne,te,ce){super(void 0,V,q,_,ee,ne,te,ce)}};e.$eq=N,e.$eq=N=ve([Y(0,f.$Tp),Y(1,w.$7j),Y(2,E.$Hi),Y(3,g.$6l),Y(4,c.$7k),Y(5,$.$nk),Y(6,d.$7i)],N)}),define(le[83],he([0,1,4,3,2,20,33,24,17,9,13]),function(se,e,R,L,A,j,D,I,P,d,E){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=void 0,e.$aw=(0,R.$Ai)("IExtensionStorageService");const y=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends A.$Uc{static{v=this}static{this.a=512*1024}static b(w){return`extensionKeys/${(0,D.$Ep)(w.id)}@${w.version}`}static c(w){const $=y.exec(w);if($&&$[1])return{id:$[1],version:$[2]}}static async removeOutdatedExtensionVersions(w,$){const f=await w.getInstalled(),u=[];for(const[h,g]of v.f($)){const m=f.find(t=>(0,D.$Ap)(t.identifier,{id:h}))?.manifest.version;for(const t of g)m!==t&&u.push(v.b({id:h,version:t}))}for(const h of u)$.remove(h,0)}static f(w){const $=new Map,f=w.keys(0,1);for(const u of f){const h=v.c(u);if(h){let g=$.get(h.id.toLowerCase());g||$.set(h.id.toLowerCase(),g=[]),g.push(h.version)}}return $}constructor(w,$,f){super(),this.j=w,this.m=$,this.n=f,this.g=this.B(new L.$he),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=v.f(w),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$Tc))(u=>this.r(u)))}r(w){if(this.h.has(w.key.toLowerCase())){this.g.fire();return}const $=v.c(w.key);if($){if(this.j.get(w.key,0)===void 0)this.h.delete($.id.toLowerCase());else{let f=this.h.get($.id.toLowerCase());f||this.h.set($.id.toLowerCase(),f=[]),f.push($.version),this.g.fire()}return}}s(w){if((0,E.$ag)(w))return w;const $=w.manifest?w.manifest.publisher:w.publisher,f=w.manifest?w.manifest.name:w.name;return(0,D.$Dp)($,f)}getExtensionState(w,$){const f=this.s(w),u=this.getExtensionStateRaw(w,$);if(u)try{return JSON.parse(u)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${$}): ${h}`)}}getExtensionStateRaw(w,$){const f=this.s(w),u=this.j.get(f,$?0:1);return u&&u?.length>v.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${$}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(w,$,f){const u=this.s(w);$===void 0?this.j.remove(u,f?0:1):this.j.store(u,JSON.stringify($),f?0:1,1)}setKeysForSync(w,$){this.j.store(v.b(w),JSON.stringify($),0,1)}getKeysForSync(w){const $=this.m.extensionSyncedKeys?.[w.id.toLowerCase()],f=this.j.get(v.b(w),0),u=f?JSON.parse(f):void 0;return u&&$?(0,P.$Mb)([...u,...$]):u||$}addToMigrationList(w,$){if(w!==$){const f=this.t.filter(u=>!u.includes(w)&&!u.includes($));f.push([w,$]),this.t=f}}getSourceExtensionToMigrate(w){const $=this.t.find(([,f])=>w===f);return $?$[0]:void 0}get t(){const w=this.j.get("extensionStorage.migrationList",-1,"[]");try{const $=JSON.parse(w);if(Array.isArray($))return $}catch{}return[]}set t(w){w.length?this.j.store("extensionStorage.migrationList",JSON.stringify(w),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$bw=l,e.$bw=l=v=ve([Y(0,j.$7p),Y(1,I.$nk),Y(2,d.$7j)],l)}),define(le[255],he([0,1,2,28,83,231,115,9,20]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;let d=class extends R.$Uc{constructor(v,y,l,c,w,$){super(),v.cleanUp(),(0,j.$g5b)(v,y,l,c,$),A.$bw.removeOutdatedExtensionVersions(v,w)}};e.$Dfc=d,e.$Dfc=d=ve([Y(0,D.$Kq),Y(1,L.$_o),Y(2,A.$aw),Y(3,L.$fp),Y(4,P.$7p),Y(5,I.$7j)],d)}),define(le[256],he([0,1,28,12,24,16,97,57,20,18,230]),function(se,e,R,L,A,j,D,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;let v=class extends E.$1bc{constructor(l,c,w,$,f,u,h,g){super(l.userHome,f,c,w,$,u,h,g)}};e.$Kfc=v,e.$Kfc=v=ve([Y(0,j.$Ii),Y(1,d.$6l),Y(2,R.$cp),Y(3,P.$7p),Y(4,I.$Adc),Y(5,D.$14b),Y(6,L.$7k),Y(7,A.$nk)],v)}),define(le[257],he([0,1,105,3,18,16,2,9,14,67,24,5,6,100,22,172,37,20,13,134,21]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;const m=[R.$zfc,R.$Afc],t="remoteTunnelSession",r="remoteTunnelIsService";let s=class extends D.$Uc{constructor(a,p,S,b,k,C,O){super(),this.y=a,this.z=p,this.C=S,this.D=C,this.F=O,this.f=new L.$he,this.onDidTokenFailed=this.f.event,this.g=new L.$he,this.onDidChangeTunnelStatus=this.g.event,this.h=new L.$he,this.onDidChangeMode=this.h.event,this.n=R.$xfc,this.w=!1,this.I=(M,T)=>{T?this.j.error(M):this.j.info(M)},this.j=this.B(b.createLogger((0,g.$bh)(S.logsHome,`${R.$Bfc}.log`),{id:R.$Bfc,name:R.$Cfc})),this.t=new y.$xh(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,I.$jk)(M)))),this.B(k.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(C.onDidChangeConfiguration(M=>{m.some(T=>M.affectsConfiguration(T))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=R.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){i(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(p){this.j.error(p)}return this.s}J(){if(!this.u){let a;v.$j?a=this.C.appRoot:a=(0,P.$mc)((0,P.$mc)(this.C.appRoot)),this.u=(0,P.$jc)(a,"bin",`${this.z.tunnelApplicationName}${v.$i?".exe":""}`)}return this.u}async startTunnel(a){if(i(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(p){this.j.error(p)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(R.$xfc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(p){this.j.error(p)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(R.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",p=!1;const S=(T,F)=>{F?this.j.error(T):a+=T,!this.C.isBuilt&&T.startsWith("   Compiling")&&this.G(R.TunnelStates.connecting((0,w.localize)(0,null)))},b=this.O("status",["status"],S);this.r=b;try{if(await b,this.r!==b)return;let T;try{T=JSON.parse(a.trim().split(`
`).find(F=>F.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(R.TunnelStates.disconnected());return}if(p=T.service_installed,this.j.info(T.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!T.tunnel&&!this.n.active){this.G(R.TunnelStates.disconnected());return}}catch(T){this.j.error(T),this.G(R.TunnelStates.disconnected());return}finally{this.r===b&&(this.r=void 0)}const k=this.n.active?this.n.session:void 0;if(k&&k.token){const T=k.token;this.G(R.TunnelStates.connecting((0,w.localize)(1,null,k.accountLabel,k.providerId)));const F=(J,Q)=>{J=J.replaceAll(T,"*".repeat(4)),S(J,Q)},K=this.O("login",["user","login","--provider",k.providerId,"--access-token",T,"--log",(0,I.$jk)(this.j.getLevel())],F);this.r=K;try{if(await K,this.r!==K)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire(k),this.G(R.TunnelStates.disconnected(k));return}}const C=this.Q();C?this.G(R.TunnelStates.connecting((0,w.localize)(2,null,C))):this.G(R.TunnelStates.connecting((0,w.localize)(3,null)));const O=["--accept-server-license-terms","--log",(0,I.$jk)(this.j.getLevel())];C?O.push("--name",C):O.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!p&&(M=await this.M(O)===!1),this.N(k,O,M)}async M(a){let p;try{p=await this.O("serviceInstall",["service","install",...a])}catch(S){this.j.error(S),p=1}if(p!==0){const S=(0,w.localize)(4,null);return this.j.warn(S),this.G(R.TunnelStates.connecting(S)),!1}return!0}async N(a,p,S){p.push("--parent-process-id",String(process.pid)),this.P()&&p.push("--no-sleep");let b=!1;const k=this.O("tunnel",p,(C,O)=>{O?this.j.error(C):this.j.info(C),C.includes("Connected to an existing tunnel process")&&(b=!0);const M=C.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const T={link:M[1],domain:M[2],tunnelName:M[4],isAttached:b};this.G(R.TunnelStates.connected(T,S))}else C.match(/error refreshing token/)&&(k.cancel(),this.f.fire(a),this.G(R.TunnelStates.disconnected(a)))});this.r=k,k.finally(()=>{k===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=R.$xfc,this.G(R.TunnelStates.disconnected()))})}O(a,p,S=this.I){return(0,y.$nh)(b=>new Promise((k,C)=>{b.isCancellationRequested&&k(-1);let O;const M=["ignore","pipe","pipe"];if(b.onCancellationRequested(()=>{O&&(this.j.info(`${a} terminating(${O.pid})`),O.kill())}),!this.C.isBuilt)S(`Building tunnel CLI from sources and run
`,!1),S(`${a} Spawning: cargo run -- tunnel ${p.join(" ")}
`,!1),O=(0,d.spawn)("cargo",["run","--","tunnel",...p],{cwd:(0,P.$jc)(this.C.appRoot,"cli"),stdio:M});else{S(`Running tunnel CLI
`,!1);const T=this.J();S(`${a} Spawning: ${T} tunnel ${p.join(" ")}
`,!1),O=(0,d.spawn)(T,["tunnel",...p],{cwd:(0,$.homedir)(),stdio:M})}O.stdout.pipe(new h.$gW(`
`)).on("data",T=>{if(O){const F=T.toString();S(F,!1)}}),O.stderr.pipe(new h.$gW(`
`)).on("data",T=>{if(O){const F=T.toString();S(F,!0)}}),O.on("exit",T=>{O&&(S(`${a} exit(${O.pid}): + ${T} `,!1),O=void 0,k(T||0))}),O.on("error",T=>{O&&(S(`${a} error(${O.pid}): + ${T} `,!0),O=void 0,C())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(R.$Afc)}Q(){let a=this.D.getValue(R.$zfc)||(0,$.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(t,-1),p=this.F.getBoolean(r,-1,!1);if(a){const S=JSON.parse(a);if(S&&(0,u.$ag)(S.accountLabel)&&(0,u.$ag)(S.sessionId)&&(0,u.$ag)(S.providerId))return{active:!0,session:S,asService:p};this.j.error("Problems restoring session from storage, invalid format",S)}}catch(a){this.j.error("Problems restoring session from storage",a)}return R.$xfc}S(a){if(a.active){const p={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(t,JSON.stringify(p),-1,1),this.F.store(r,a.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(r,-1)}};e.$Gfc=s,e.$Gfc=s=ve([Y(0,A.$6l),Y(1,E.$nk),Y(2,j.$Ii),Y(3,I.$8j),Y(4,l.$Efc),Y(5,c.$7i),Y(6,f.$7p)],s);function n(o,a){return o&&a?o.sessionId===a.sessionId&&o.providerId===a.providerId&&o.token===a.token:o===a}const i=(o,a)=>o.active!==a.active?!1:o.active&&a.active?o.asService===a.asService&&n(o.session,a.session):!0}),define(le[258],he([0,1,6,2,23,21,69,20,77,19]),function(se,e,R,L,A,j,D,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class E extends I.$9p{constructor(y,l,c,w){super(),this.bb=y,this.cb=l,this.db=c,this.eb=w,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new L.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new L.$Tc),this.ab=this.hb(this.bb)}fb(){const y=this.B(new P.$jLb(this.db.getChannel("storage"))),l=this.B(new D.$3p(y));return this.B(l.onDidChangeStorage(c=>this.u(-1,c))),l}gb(y){this.X.clear(),this.W=y;let l;if((0,I.$0p)(y))l=this.U;else{const c=this.X.add(new P.$kLb(this.db.getChannel("storage"),y));l=this.X.add(new D.$3p(c))}return this.X.add(l.onDidChangeStorage(c=>this.u(0,c))),l}hb(y){this.$.clear(),this.Z=y?.id;let l;if(y){const c=this.$.add(new P.$lLb(this.db.getChannel("storage"),y));l=this.$.add(new D.$3p(c)),this.$.add(l.onDidChangeStorage(w=>this.u(1,w)))}return l}async O(){await R.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(y){switch(y){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(y){switch(y){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$bh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(y){if(!this.M(this.W,y))return;const l=this.Y,c=l.items;l!==this.U&&await l.close(),this.Y=this.gb(y),await this.Y.init(),this.N(c,this.Y,0)}async S(y,l){const c=this.ab,w=c?.items??new Map;await c?.close(),this.ab=this.hb(y),await this.ab.init(),this.N(w,this.ab,1)}hasScope(y){return(0,d.$Fl)(y)?this.W.id===y.id:this.Z===y.id}}e.$Lfc=E}),define(le[259],he([0,1,3,2,19,92]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=e.$lQ=void 0;class D{constructor(d,E){this.a=d,this.b=E}listen(d,E){const v=this.b(d);switch(E){case"onDidChangeProfiles":return R.Event.map(this.a.onDidChangeProfiles,y=>({all:y.all.map(l=>(0,j.$En)({...l},v)),added:y.added.map(l=>(0,j.$En)({...l},v)),removed:y.removed.map(l=>(0,j.$En)({...l},v)),updated:y.updated.map(l=>(0,j.$En)({...l},v))}))}throw new Error(`Invalid listen ${E}`)}async call(d,E,v){const y=this.b(d);switch(E){case"createProfile":{const l=await this.a.createProfile(v[0],v[1],v[2]);return(0,j.$En)({...l},y)}case"updateProfile":{let l=(0,A.$Hl)((0,j.$Fn)(v[0],y),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,v[1]),(0,j.$En)({...l},y)}case"removeProfile":{const l=(0,A.$Hl)((0,j.$Fn)(v[0],y),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${E}`)}}e.$lQ=D;class I extends L.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,E,v){super(),this.profilesHome=E,this.f=v,this.a=[],this.b=this.B(new R.$he),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(y=>(0,A.$Hl)(y,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(y=>{const l=y.added.map($=>(0,A.$Hl)($,this.profilesHome.scheme)),c=y.removed.map($=>(0,A.$Hl)($,this.profilesHome.scheme)),w=y.updated.map($=>(0,A.$Hl)($,this.profilesHome.scheme));this.a=y.all.map($=>(0,A.$Hl)($,this.profilesHome.scheme)),this.b.fire({added:l,removed:c,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,E,v){const y=await this.f.call("createNamedProfile",[d,E,v]);return(0,A.$Hl)(y,this.profilesHome.scheme)}async createProfile(d,E,v,y){const l=await this.f.call("createProfile",[d,E,v,y]);return(0,A.$Hl)(l,this.profilesHome.scheme)}async createTransientProfile(d){const E=await this.f.call("createTransientProfile",[d]);return(0,A.$Hl)(E,this.profilesHome.scheme)}async setProfileForWorkspace(d,E){await this.f.call("setProfileForWorkspace",[d,E])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,E){const v=await this.f.call("updateProfile",[d,E]);return(0,A.$Hl)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$mQ=I}),define(le[60],he([0,1,2,69,4,20,3,77,19]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pLb=e.$oLb=e.$nLb=void 0,e.$nLb=(0,A.$Ai)("IUserDataProfileStorageService");let d=class extends R.$Uc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async c=>this.b(c))}async updateStorageData(l,c,w){return this.withProfileScopedStorageService(l,async $=>this.c($,c,w))}async withProfileScopedStorageService(l,c){if(this.a.hasScope(l))return c(this.a);const w=await this.g(l),$=new v(w);try{await $.initialize();const f=await c($);return await $.flush(),f}finally{$.dispose(),await this.f(w)}}b(l){const c=new Map,w=$=>{for(const f of l.keys(0,$))c.set(f,{value:l.get(f,0),target:$})};return w(0),w(1),c}c(l,c,w){l.storeAll(Array.from(c.entries()).map(([$,f])=>({key:$,value:f,scope:0,target:w})),!0)}async f(l){try{await l.close()}finally{(0,R.$Oc)(l)&&l.dispose()}}};e.$oLb=d,e.$oLb=d=ve([Y(0,j.$7p)],d);class E extends d{constructor(l,c,w,$){super(w),this.j=l;const f=l.getChannel("profileStorageListener"),u=this.B(new R.$Vc);this.h=this.B(new D.$he({onWillAddFirstListener:()=>{u.value=f.listen("onDidChange")(h=>{$.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(g=>(0,P.$Hl)(g,c.profilesHome.scheme)),valueChanges:h.valueChanges.map(g=>({...g,profile:(0,P.$Hl)(g.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(l){const c=this.j.getChannel("storage");return(0,j.$0p)(l)?new I.$jLb(c):new I.$kLb(c,l)}}e.$pLb=E;class v extends j.$9p{constructor(l){super({flushInterval:100}),this.s=this.B(new L.$3p(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[260],he([0,1,20,9,19,56,60]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;let I=class extends D.$pLb{constructor(d,E,v,y){super(d,E,v,y)}};e.$qfc=I,e.$qfc=I=ve([Y(0,j.$Pec),Y(1,A.$Gl),Y(2,R.$7p),Y(3,L.$7j)],I)}),define(le[39],he([0,1,17,6,15,26,3,35,2,27,13,177,22,16,12,9,45,20,18,29,25,19]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wMb=e.$vMb=e.$uMb=e.$tMb=void 0,e.$qMb=t,e.$rMb=r,e.$sMb=s;function t(p){return!!(p&&p.ref!==void 0&&typeof p.ref=="string"&&p.ref!==""&&p.syncData!==void 0&&(p.syncData===null||r(p.syncData)))}function r(p){return!!(p&&p.version!==void 0&&typeof p.version=="number"&&p.content!==void 0&&typeof p.content=="string"&&(Object.keys(p).length===2||Object.keys(p).length===3&&p.machineId!==void 0&&typeof p.machineId=="string"))}function s(p,S){return`${(0,d.$5f)(p)}${S.isDefault?"":` (${S.name})`}`}let n=class extends P.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(S,b,k,C,O,M,T,F,K,J,Q,H){super(),this.syncResource=S,this.collection=b,this.G=k,this.H=C,this.I=O,this.J=M,this.L=T,this.M=F,this.N=K,this.O=J,this.P=Q,this.c=null,this.m="idle",this.n=this.B(new D.$he),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new D.$he),this.onDidChangeConflicts=this.t.event,this.u=this.B(new L.$yh(50)),this.w=this.B(new D.$he),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=s(S.syncResource,S.profile),this.h=H.extUri,this.f=this.h.joinPath(C.userDataSyncHome,...(0,g.$Amb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource)),this.g=this.h.joinPath(this.f,g.$Vmb),this.y=(0,g.$Bmb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource,C,this.h),this.j=(0,$.$aq)(C,k,O)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const S=await this.c;this.c=null;const b=await this.Y(S.remoteUserData,S.lastSyncUserData,!0,this.ob());this.S(b)}else{this.O.trace(`${this.D}: Checking for local changes...`);const S=await this.getLastSyncUserData();(S?await this.ub(S):!0)&&this.w.fire()}}S(S){this.m!==S&&(this.m=S,this.n.fire(S))}async sync(S,b={}){await this.U(S,!0,this.ob(),b)}async preview(S,b,k={}){return this.U(S,!1,b,k)}async apply(S,b={}){try{this.F={...b};const k=await this.ab(S);return this.S(k),this.c}finally{this.F={}}}async U(S,b,k,C){try{if(this.F={...C},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let O="idle";try{const M=await this.getLastSyncUserData(),T=await this.X(S,M);return O=await this.Y(T,M,b,k),O==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(O)}}finally{this.F={}}}async replace(S){const b=this.kb(S);if(!b)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const k=await this.getLastSyncUserData(),C=await this.X(null,k),O=await this.W(C),M=await this.qb({ref:C.ref,syncData:b},k,O,this.ob(),j.CancellationToken.None),T=[];for(const F of M){const K=await this.sb(F,F.remoteResource,void 0,j.CancellationToken.None),{remoteChange:J}=await this.sb(F,F.previewResource,F.remoteContent,j.CancellationToken.None);T.push([F,{...K,remoteChange:J!==0?J:2}])}await this.tb(C,k,T,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(S){const b=await this.j;return!!S.syncData?.machineId&&S.syncData.machineId===b}async X(S,b){if(b){const k=S?S[this.resource]:void 0;if(b.ref===k||k===void 0&&b.syncData===null)return b}return this.getRemoteUserData(b)}async Y(S,b,k,C){if(S.syncData&&S.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new g.$Imb((0,v.localize)(0,null,this.resource,this.pb,S.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(S,b,k,C)}catch(O){if(O instanceof g.$Imb)switch(O.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(S,b,k,C);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),S=await this.getRemoteUserData(null),b=await this.getLastSyncUserData(),this.Y(S,b,k,C)}throw O}}async Z(S,b,k,C){try{const O=await this.W(S),M=!O&&b===null&&this.gb()!==void 0,T=k&&!M;this.c||(this.c=(0,L.$nh)(K=>this.eb(S,b,O,T,C,K)));let F=await this.c;if(k&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const K of F.resourcePreviews)F=await this.accept(K.remoteResource)||F}return this.cb(F.resourcePreviews),F.resourcePreviews.some(({mergeState:K})=>K==="conflict")?"hasConflicts":k?await this.ab(!1):"syncing"}catch(O){throw this.c=null,O}}async merge(S){return await this.$(S,async b=>{const k=await this.rb(b,j.CancellationToken.None);await this.G.writeFile(b.previewResource,A.$Je.fromString(k?.content||""));const C=k&&!k.hasConflicts?await this.sb(b,b.previewResource,void 0,j.CancellationToken.None):void 0;return b.acceptResult=C,b.mergeState=k.hasConflicts?"conflict":C?"accepted":"preview",b.localChange=C?C.localChange:k.localChange,b.remoteChange=C?C.remoteChange:k.remoteChange,b}),this.c}async accept(S,b){return await this.$(S,async k=>{const C=await this.sb(k,S,b,j.CancellationToken.None);return k.acceptResult=C,k.mergeState="accepted",k.localChange=C.localChange,k.remoteChange=C.remoteChange,k}),this.c}async discard(S){return await this.$(S,async b=>{const k=await this.rb(b,j.CancellationToken.None);return await this.G.writeFile(b.previewResource,A.$Je.fromString(k.content||"")),b.acceptResult=void 0,b.mergeState="preview",b.localChange=k.localChange,b.remoteChange=k.remoteChange,b}),this.c}async $(S,b){if(!this.c)return;let k=await this.c;const C=k.resourcePreviews.findIndex(({localResource:O,remoteResource:M,previewResource:T})=>this.h.isEqual(O,S)||this.h.isEqual(M,S)||this.h.isEqual(T,S));C!==-1&&(this.c=(0,L.$nh)(async O=>{const M=[...k.resourcePreviews];return M[C]=await b(M[C]),{...k,resourcePreviews:M}}),k=await this.c,this.cb(k.resourcePreviews),k.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(S){if(!this.c)return"idle";const b=await this.c;return b.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":b.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.tb(b.remoteUserData,b.lastSyncUserData,b.resourcePreviews.map(k=>[k,k.acceptResult]),S),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(S){const b=S.filter(({mergeState:k})=>k==="conflict");(0,R.$ub)(this.s,b,(k,C)=>this.h.isEqual(k.previewResource,C.previewResource))||(this.s=b,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const S=await this.getLastSyncUserData();return!!S&&S.syncData!==null}async db(S){const b=this.c?await this.c:null;if(b)for(const k of b.resourcePreviews){if(this.h.isEqual(k.acceptedResource,S))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,S))return k.remoteContent;if(this.h.isEqual(k.localResource,S))return k.localContent;if(this.h.isEqual(k.baseResource,S))return k.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(S){(0,c.$ll)(S)!==1&&this.O.error(S)}}async eb(S,b,k,C,O,M){const T=await this.qb(S,b,k,O,M),F=[];for(const K of T){const J=K.previewResource.with({scheme:g.$Umb,authority:"accepted"});if(K.localChange===0&&K.remoteChange===0)F.push({...K,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=C?await this.rb(K,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(K.previewResource,A.$Je.fromString(Q?.content||""));const H=Q&&!Q.hasConflicts?await this.sb(K,K.previewResource,void 0,M):void 0;F.push({...K,acceptResult:H,mergeState:Q?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:Q?Q.localChange:K.localChange,remoteChange:H?H.remoteChange:Q?Q.remoteChange:K.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:S,lastSyncUserData:b,resourcePreviews:F,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let S=this.gb();if(S||(S=await this.jb()),!S)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const b=JSON.parse(S),k=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!b.version&&!!k&&b.version!==k,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${b.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let C,O=1;for(;C===void 0&&O++<6;)try{const M=await this.hb();M&&(M.ref===b.ref?C=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof c.$pl&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof g.$Imb)throw M;this.O.error(M,O)}}if(C===void 0)try{const M=await this.J.resolveResourceContent(this.resource,b.ref,this.collection,this.F);C=M===null?null:this.kb(M),await this.ib({ref:b.ref,syncData:C})}catch(M){if(M instanceof g.$Imb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return C===void 0?null:{...b,syncData:C}}async fb(S,b={}){if(b.ref||b.version)throw new Error("Cannot have core properties as additional");const k=this.M.getResourceSyncStateVersion(this.resource),C={ref:S.ref,version:k,...b};this.I.store(this.z,JSON.stringify(C),-1,1),await this.ib(S)}gb(){return this.I.get(this.z,-1)}async hb(){const S=(await this.G.readFile(this.y)).value.toString();try{const b=S?JSON.parse(S):void 0;if(t(b))return b}catch(b){this.O.error(b)}}async ib(S){await this.G.writeFile(this.y,A.$Je.fromString(JSON.stringify(S)))}async jb(){try{const S=await this.G.readFile(this.y),b=JSON.parse(S.value.toString());await this.G.del(this.y),b.ref&&b.content!==void 0?(this.I.store(this.z,JSON.stringify({...b,content:void 0}),-1,1),await this.ib({ref:b.ref,syncData:b.content===null?null:JSON.parse(b.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,b)}catch(S){S instanceof c.$pl&&S.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(S)}return this.I.get(this.z,-1)}async getRemoteUserData(S){const{ref:b,content:k}=await this.lb(S);let C=null;return k!==null&&(C=this.kb(k)),{ref:b,syncData:C}}kb(S){try{const b=JSON.parse(S);if(r(b))return b}catch(b){this.O.error(b)}throw new g.$Imb((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(S){const b=S?{ref:S.ref,content:S.syncData?JSON.stringify(S.syncData):null}:null;return this.J.readResource(this.resource,b,this.collection,this.F)}async mb(S,b){const k=await this.j,C={version:this.pb,machineId:k,content:S};try{return b=await this.J.writeResource(this.resource,JSON.stringify(C),b,this.collection,this.F),{ref:b,syncData:C}}catch(O){throw O instanceof g.$Imb&&O.code==="TooLarge"&&(O=new g.$Imb(O.message,O.code,this.resource)),O}}async nb(S){const b={version:this.pb,content:S};return this.L.writeResource(this.resource,JSON.stringify(b),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(g.$vmb)}};e.$tMb=n,e.$tMb=n=ve([Y(2,c.$7k),Y(3,l.$Hi),Y(4,f.$7p),Y(5,g.$Dmb),Y(6,g.$Emb),Y(7,g.$Nmb),Y(8,u.$6l),Y(9,g.$Smb),Y(10,y.$7i),Y(11,h.$El)],n);let i=class extends n{constructor(S,b,k,C,O,M,T,F,K,J,Q,H,X){super(b,k,C,O,M,T,F,K,J,Q,H,X),this.r=S,this.B(this.G.watch(this.h.dirname(S))),this.B(this.G.onDidFilesChange(W=>this.yb(W)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(S,b,k){try{b?await this.G.writeFile(this.r,A.$Je.fromString(S),k?void 0:b):await this.G.createFile(this.r,A.$Je.fromString(S),{overwrite:k})}catch(C){throw C instanceof c.$pl&&C.fileOperationResult===1||C instanceof c.$pl&&C.fileOperationResult===3?new g.$Imb(C.message,"LocalPreconditionFailed"):C}}async xb(){try{await this.G.del(this.r)}catch(S){if(!(S instanceof c.$pl&&S.fileOperationResult===1))throw S}}yb(S){S.contains(this.r)&&this.Q()}};e.$uMb=i,e.$uMb=i=ve([Y(3,c.$7k),Y(4,l.$Hi),Y(5,f.$7p),Y(6,g.$Dmb),Y(7,g.$Emb),Y(8,g.$Nmb),Y(9,u.$6l),Y(10,g.$Smb),Y(11,y.$7i),Y(12,h.$El)],i);let o=class extends i{constructor(S,b,k,C,O,M,T,F,K,J,Q,H,X,W){super(S,b,k,C,O,M,T,F,K,J,Q,X,W),this.zb=H,this.Bb=void 0}Ab(S,b){const k=[],C=(0,I.$Nn)(S,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,E.$hg)(C)&&b!==Array.isArray(C)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$vMb=o,e.$vMb=o=ve([Y(3,c.$7k),Y(4,l.$Hi),Y(5,f.$7p),Y(6,g.$Dmb),Y(7,g.$Emb),Y(8,g.$Nmb),Y(9,u.$6l),Y(10,g.$Smb),Y(11,g.$Rmb),Y(12,y.$7i),Y(13,h.$El)],o);let a=class{constructor(S,b,k,C,O,M,T){this.resource=S,this.g=b,this.h=k,this.j=C,this.k=O,this.l=M,this.d=T.extUri,this.f=(0,g.$Bmb)(void 0,this.resource,k,this.d)}async initialize({ref:S,content:b}){if(!b){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(b);if(k)try{await this.o({ref:S,syncData:k})}catch(C){this.j.error(C)}}m(S){try{const b=JSON.parse(S);if(r(b))return b}catch(b){this.j.error(b)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(S,b={}){if(b.ref||b.version)throw new Error("Cannot have core properties as additional");const k={ref:S.ref,version:void 0,...b};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,A.$Je.fromString(JSON.stringify(S)))}};e.$wMb=a,e.$wMb=a=ve([Y(1,m.$Gl),Y(2,l.$Hi),Y(3,w.$7j),Y(4,c.$7k),Y(5,f.$7p),Y(6,h.$El)],a)}),define(le[117],he([0,1,6,26,7,3,44,2,27,22,16,116,28,33,83,48,12,4,74,9,20,18,29,19,39,241,112,25,60]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m,t,r,s,n,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_b=e.$8_b=e.$7_b=void 0,e.$5_b=S,e.$6_b=b;async function p(M,T){const F=JSON.parse(M.content);if(M.version===1||M.version===2){const K=(await T.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of F)M.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),M.version===2&&K.every(Q=>!(0,l.$Ap)(Q.identifier,J.identifier))&&(J.installed=!0)}return F}function S(M){return JSON.parse(M.content)}function b(M,T){return M.sort((F,K)=>!F.identifier.uuid&&K.identifier.uuid?-1:F.identifier.uuid&&!K.identifier.uuid?1:(0,P.$uf)(F.identifier.id,K.identifier.id)),T?(0,D.$Yn)(M,{}):JSON.stringify(M)}let k=class extends s.$tMb{constructor(T,F,K,J,Q,H,X,W,B,ie,re,Z,z,x,G,N,U){super({syncResource:"extensions",profile:T},F,J,K,Q,H,X,Z,z,ie,re,G),this.Cb=W,this.Db=B,this.Eb=U,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$Umb,authority:"base"}),this.yb=this.wb.with({scheme:o.$Umb,authority:"local"}),this.zb=this.wb.with({scheme:o.$Umb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$Umb,authority:"accepted"}),this.Bb=this.Eb.createInstance(C),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,V=>V.some(({local:q})=>!!q)),j.Event.filter(this.Cb.onDidUninstallExtension,V=>!V.error),j.Event.filter(N.onDidChange,V=>V.valueChanges.some(({profile:q,changes:_})=>this.syncResource.profile.id===q.id&&_.some(ee=>ee.key===y.$dp))),x.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(T,F){const K=T.syncData?await p(T.syncData,this.Cb):null,J=F?.skippedExtensions??[],Q=F?.builtinExtensions??null,H=F?.syncData?await p(F.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile);K?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:ie}=(0,n.$4_b)(X,K,H,J,W,Q),re={local:B,remote:ie,content:this.Hb(X,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:ie!==null?2:0},Z=this.Ob(X,!1);return[{skippedExtensions:J,builtinExtensions:Q,baseResource:this.xb,baseContent:H?this.Ob(H,!1):Z,localResource:this.yb,localContent:Z,localExtensions:X,remoteResource:this.zb,remoteExtensions:K,remoteContent:K?this.Ob(K,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(T){const F=T.syncData?await p(T.syncData,this.Cb):null,{localExtensions:K,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,n.$4_b)(K,F,F,T.skippedExtensions||[],J,T.builtinExtensions||[]);return Q!==null}Hb(T,F,K,J){const Q=[...F,...K],H=new Set,X=W=>{H.add(W.id.toLowerCase()),W.uuid&&H.add(W.uuid)};Q.forEach(({identifier:W})=>X(W)),J.forEach(X);for(const W of T)H.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&H.has(W.identifier.uuid)||Q.push(W);return this.Ob(Q,!1)}async rb(T,F){return{...T.previewResult,hasConflicts:!1}}async sb(T,F,K,J){if(this.h.isEqual(F,this.yb))return this.Kb(T);if(this.h.isEqual(F,this.zb))return this.Lb(T);if(this.h.isEqual(F,this.wb))return T.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Kb(T){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(F),J=(0,n.$4_b)(T.localExtensions,null,null,T.skippedExtensions,K,T.builtinExtensions),{local:Q,remote:H}=J;return{content:T.localContent,local:Q,remote:H,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(T){const F=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),K=this.Db.getIgnoredExtensions(F),J=T.remoteContent?JSON.parse(T.remoteContent):null;if(J!==null){const Q=(0,n.$4_b)(T.localExtensions,J,T.localExtensions,[],K,T.builtinExtensions),{local:H,remote:X}=Q;return{content:T.remoteContent,local:H,remote:X,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:X!==null?2:0}}else return{content:T.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(T,F,K,J){let{skippedExtensions:Q,builtinExtensions:H,localExtensions:X}=K[0][0];const{local:W,remote:B,localChange:ie,remoteChange:re}=K[0][1];if(ie===0&&re===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(X)),Q=await this.Bb.updateLocalExtensions(W.added,W.removed,W.updated,Q,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const Z=JSON.stringify(B.all);T=await this.mb(Z,J?null:T.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(z=>z.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(z=>z.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(z=>z.identifier.id))}.`:""}`)}F?.ref!==T.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(X,H),await this.fb(T,{skippedExtensions:Q,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(Z=>Z.identifier.id))}.`:""}`))}Nb(T,F){const K=new Set,J=[];for(const Q of T)K.add(Q.identifier.id.toLowerCase()),Q.installed||J.push(Q.identifier);if(F)for(const Q of F)K.has(Q.id.toLowerCase())||J.push(Q);return J}async resolveContent(T){if(this.h.isEqual(this.zb,T)||this.h.isEqual(this.xb,T)||this.h.isEqual(this.yb,T)||this.h.isEqual(this.Ab,T)){const F=await this.db(T);return F&&this.Ob(JSON.parse(F),!0)}return null}Ob(T,F){return b(T,F)}async hasLocalData(){try{const{localExtensions:T}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(T.some(F=>F.installed||F.disabled))return!0}catch{}return!1}};e.$7_b=k,e.$7_b=k=ve([Y(2,E.$Hi),Y(3,$.$7k),Y(4,g.$7p),Y(5,o.$Dmb),Y(6,o.$Emb),Y(7,y.$cp),Y(8,i.$fNb),Y(9,o.$Smb),Y(10,d.$7i),Y(11,o.$Nmb),Y(12,m.$6l),Y(13,c.$aw),Y(14,t.$El),Y(15,a.$nLb),Y(16,f.$zi)],k);let C=class{constructor(T,F,K,J,Q,H){this.a=T,this.b=F,this.c=K,this.d=J,this.f=Q,this.g=H}async getLocalExtensions(T){const F=await this.a.getInstalled(void 0,T.extensionsResource),K=this.d.getIgnoredExtensions(F);return{localExtensions:await this.j(T,async(Q,H)=>{const X=Q.getDisabledExtensions();return F.map(W=>{const{identifier:B,isBuiltin:ie,manifest:re,preRelease:Z,pinned:z,isApplicationScoped:x}=W,G={identifier:B,preRelease:Z,version:re.version,pinned:!!z};x&&!(0,w.$Ym)(re)&&(G.isApplicationScoped=x),X.some(N=>(0,l.$Ap)(N,B))&&(G.disabled=!0),ie||(G.installed=!0);try{const N=H.getKeysForSync({id:B.id,version:re.version});if(N){const U=H.getExtensionState(W,!0)||{};G.state=Object.keys(U).reduce((V,q)=>(N.includes(q)&&(V[q]=U[q]),V),{})}}catch(N){this.g.info(`${(0,s.$sMb)("extensions",T)}: Error while parsing extension state`,(0,A.$0)(N))}return G})}),ignoredExtensions:K}}async updateLocalExtensions(T,F,K,J,Q){const H=(0,s.$sMb)("extensions",Q),X=[],W=new Map,B=[],ie=[],re=await this.a.getInstalled(void 0,Q.extensionsResource);if((T.length||K.length)&&await this.j(Q,async(x,G)=>{await R.Promises.settled([...T,...K].map(async N=>{const U=re.find(_=>(0,l.$Ap)(_.identifier,N.identifier));if(U&&U.isBuiltin){N.state&&U.manifest.version===N.version&&this.h(N.state,U,U.manifest.version,G),x.getDisabledExtensions().some(ee=>(0,l.$Ap)(ee,N.identifier))!==!!N.disabled&&(N.disabled?(this.g.trace(`${H}: Disabling extension...`,N.identifier.id),await x.disableExtension(N.identifier),this.g.info(`${H}: Disabled extension`,N.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,N.identifier.id),await x.enableExtension(N.identifier),this.g.info(`${H}: Enabled extension`,N.identifier.id))),B.push(N.identifier);return}const V=N.pinned?N.version:void 0,q=(await this.c.getExtensions([{...N.identifier,version:V,preRelease:V?void 0:N.preRelease}],L.CancellationToken.None))[0];if(N.state&&(U?U.manifest.version===N.version:q)&&this.h(N.state,U||q,U?.manifest.version,G),q)try{x.getDisabledExtensions().some(ee=>(0,l.$Ap)(ee,N.identifier))!==!!N.disabled&&(N.disabled?(this.g.trace(`${H}: Disabling extension...`,N.identifier.id,q.version),await x.disableExtension(q.identifier),this.g.info(`${H}: Disabled extension`,N.identifier.id,q.version)):(this.g.trace(`${H}: Enabling extension...`,N.identifier.id,q.version),await x.enableExtension(q.identifier),this.g.info(`${H}: Enabled extension`,N.identifier.id,q.version))),(!U||U.preRelease!==N.preRelease||U.pinned!==N.pinned||V&&U.manifest.version!==V)&&(await this.a.canInstall(q)?(X.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:N.pinned&&!!N.version,pinned:N.pinned,installPreReleaseVersion:N.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:N.isApplicationScoped,context:{[y.$2o]:!0,[y.$3o]:"settingsSync"}}}),W.set(q.identifier.id.toLowerCase(),N)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),ie.push(N)))}catch(_){ie.push(N),this.g.error(_),this.g.info(`${H}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else ie.push(N),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,N.identifier.id)}))}),F.length){const x=re.filter(({identifier:G,isBuiltin:N})=>!N&&F.some(U=>(0,l.$Ap)(G,U)));await R.Promises.settled(x.map(async G=>{this.g.trace(`${H}: Uninstalling local extension...`,G.identifier.id),await this.a.uninstall(G,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,G.identifier.id),B.push(G.identifier)}))}const Z=await this.a.installGalleryExtensions(X);for(const{identifier:x,local:G,error:N,source:U}of Z){const V=U;if(G)this.g.info(`${H}: Installed extension.`,x.id,V.version),B.push(x);else{const q=W.get(x.id.toLowerCase());q&&(ie.push(q),this.g.info(`${H}: Skipped synchronizing extension`,V.displayName||V.identifier.id)),N instanceof y.$bp&&["Incompatible","IncompatibleTargetPlatform"].includes(N.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,V.displayName||V.identifier.id):N&&this.g.error(N)}}const z=[];for(const x of J)B.some(G=>(0,l.$Ap)(G,x.identifier))||z.push(x);for(const x of ie)z.some(G=>(0,l.$Ap)(G.identifier,x.identifier))||z.push(x);return z}h(T,F,K,J){const Q=J.getExtensionState(F,!0)||{},H=K?J.getKeysForSync({id:F.identifier.id,version:K}):void 0;H?H.forEach(X=>{Q[X]=T[X]}):Object.keys(T).forEach(X=>Q[X]=T[X]),J.setExtensionState(F,Q,!0)}async j(T,F){return this.b.withProfileScopedStorageService(T,async K=>{const J=new I.$Tc,Q=J.add(this.f.createChild(new u.$yi([g.$7p,K]))),H=J.add(Q.createInstance(v.$KKb)),X=J.add(Q.createInstance(c.$bw));try{return await F(H,X)}finally{J.dispose()}})}};e.$8_b=C,e.$8_b=C=ve([Y(0,y.$cp),Y(1,a.$nLb),Y(2,y.$_o),Y(3,i.$fNb),Y(4,f.$zi),Y(5,o.$Smb)],C);let O=class extends s.$wMb{constructor(T,F,K,J,Q,H,X,W){super("extensions",J,Q,H,K,X,W),this.p=T,this.q=F}async t(T){return T.syncData?await p(T.syncData,this.p):null}u(T,F){const K=[],J=[],Q=[];for(const H of T){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const X=F.find(W=>(0,l.$Ap)(W.identifier,H.identifier));X?(K.push(X),H.disabled&&Q.push(H.identifier)):H.installed&&(J.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&Q.push(H.identifier))}return{installedExtensions:K,newExtensions:J,disabledExtensions:Q,remoteExtensions:T}}};e.$9_b=O,e.$9_b=O=ve([Y(0,y.$cp),Y(1,i.$fNb),Y(2,$.$7k),Y(3,r.$Gl),Y(4,E.$Hi),Y(5,h.$7j),Y(6,g.$7p),Y(7,t.$El)],O)}),define(le[118],he([0,1,15,7,3,35,44,5,32,22,16,12,9,45,20,18,29,39,79,245,25,19,60,4]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CMb=e.$BMb=e.$AMb=e.$zMb=void 0,e.$yMb=i;const s="globalState.argv.",n=["locale"];function i(k,C){const O=k.storage?Object.keys(k.storage).sort():[],M={};return O.forEach(T=>M[T]=k.storage[T]),k.storage=M,C?(0,D.$Yn)(k,{}):JSON.stringify(k)}const o=1;let a=class extends f.$tMb{constructor(C,O,M,T,F,K,J,Q,H,X,W,B,ie,re){super({syncResource:"globalState",profile:C},O,T,Q,B,F,K,H,X,J,W,ie),this.Bb=M,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:g.$Umb,authority:"base"}),this.xb=this.vb.with({scheme:g.$Umb,authority:"local"}),this.yb=this.vb.with({scheme:g.$Umb,authority:"remote"}),this.zb=this.vb.with({scheme:g.$Umb,authority:"accepted"}),this.Ab=re.createInstance(p),this.B(T.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(T.onDidFilesChange,Z=>Z.contains(this.H.argvResource)),A.Event.filter(M.onDidChange,Z=>!!(Z.targetChanges.some(z=>this.syncResource.profile.id===z.id)||Z.valueChanges.some(({profile:z,changes:x})=>this.syncResource.profile.id===z.id&&x.some(G=>G.target===0)))))(()=>this.Q()))}async qb(C,O,M){const T=C.syncData?JSON.parse(C.syncData.content):null;O=O===null&&M?C:O;const F=O&&O.syncData?JSON.parse(O.syncData.content):null,K=await this.Ab.getLocalGlobalState(this.syncResource.profile);T?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(F),{local:Q,remote:H}=(0,h.$xMb)(K.storage,T?T.storage:null,F?F.storage:null,J,this.O),X={content:null,local:Q,remote:H,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:H.all!==null?2:0},W=i(K,!1);return[{baseResource:this.wb,baseContent:F?i(F,!1):W,localResource:this.xb,localContent:W,localUserData:K,remoteResource:this.yb,remoteContent:T?i(T,!1):null,previewResource:this.vb,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(C){const O=C.syncData?JSON.parse(C.syncData.content):null;if(O===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),T=await this.Jb(O),{remote:F}=(0,h.$xMb)(M.storage,O.storage,O.storage,T,this.O);return F.all!==null}async rb(C,O){return{...C.previewResult,hasConflicts:!1}}async sb(C,O,M,T){if(this.h.isEqual(O,this.xb))return this.Gb(C);if(this.h.isEqual(O,this.yb))return this.Hb(C);if(this.h.isEqual(O,this.vb))return C.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async Gb(C){return{content:C.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(C.localUserData.storage),removed:[],updated:[],all:C.localUserData.storage},localChange:0,remoteChange:2}}async Hb(C){if(C.remoteContent!==null){const O=JSON.parse(C.remoteContent),{local:M,remote:T}=(0,h.$xMb)(C.localUserData.storage,O.storage,null,C.storageKeys,this.O);return{content:C.remoteContent,local:M,remote:T,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:C.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(C,O,M,T){const{localUserData:F}=M[0][0],{local:K,remote:J,localChange:Q,remoteChange:H}=M[0][1];if(Q===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Q!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(F)),await this.Ab.writeLocalGlobalState(K,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const X=JSON.stringify({storage:J.all});C=await this.mb(X,T?null:C.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}O?.ref!==C.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(C),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(C){if(this.h.isEqual(this.yb,C)||this.h.isEqual(this.wb,C)||this.h.isEqual(this.xb,C)||this.h.isEqual(this.zb,C)){const O=await this.db(C);return O&&i(JSON.parse(O),!0)}return null}async hasLocalData(){try{const{storage:C}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(C).length>1||C[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(C){const O=await this.Bb.readStorageData(this.syncResource.profile),M=[],T=[];for(const[J,Q]of O)Q.target===0?M.push(J):Q.target===1&&T.push(J);const F=[...M,...T],K=C?.storage?Object.keys(C.storage).filter(J=>!J.startsWith(s)&&!F.includes(J)&&O.get(J)!==void 0):[];if(!I.$o){const J=[...g.$zmb.map(Q=>(0,g.$Mmb)(Q)),g.$Lmb];K.push(...J),T.push(...J)}return{user:M,machine:T,unregistered:K}}};e.$zMb=a,e.$zMb=a=ve([Y(2,t.$nLb),Y(3,v.$7k),Y(4,g.$Dmb),Y(5,g.$Emb),Y(6,g.$Smb),Y(7,E.$Hi),Y(8,g.$Nmb),Y(9,w.$6l),Y(10,d.$7i),Y(11,c.$7p),Y(12,$.$El),Y(13,r.$zi)],a);let p=class{constructor(C,O,M,T){this.a=C,this.b=O,this.c=M,this.d=T}async getLocalGlobalState(C){const O={};if(C.isDefault){const T=await this.f(),F=(0,j.$Nn)(T);for(const K of n)F[K]!==void 0&&(O[`${s}${K}`]={version:1,value:F[K]})}const M=await this.c.readStorageData(C);for(const[T,F]of M)F.value&&F.target===0&&(O[T]={version:1,value:F.value});return{storage:O}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const C=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),C.value.toString()}catch(C){this.d.debug((0,L.$0)(C))}return"{}"}async writeLocalGlobalState({added:C,removed:O,updated:M},T){const F=(0,f.$sMb)("globalState",T),K={},J=new Map,Q=await this.c.readStorageData(T),H=(X,W)=>{for(const B of X){if(B.startsWith(s)){K[B.substring(s.length)]=W?W[B].value:void 0;continue}if(W){const ie=W[B];ie.value!==Q.get(B)?.value&&J.set(B,ie.value)}else Q.get(B)!==void 0&&J.set(B,void 0)}};if(H(Object.keys(C),C),H(Object.keys(M),M),H(O),Object.keys(K).length){this.d.trace(`${F}: Updating locale...`);const X=await this.f();let W=X;for(const B of Object.keys(K))W=(0,u.edit)(W,[B],K[B],{});X!==W&&(this.d.trace(`${F}: Updating locale...`),await this.a.writeFile(this.b.argvResource,R.$Je.fromString(W)),this.d.info(`${F}: Updated locale.`)),this.d.info(`${F}: Updated locale`)}J.size&&(this.d.trace(`${F}: Updating global state...`),await this.c.updateStorageData(T,J,0),this.d.info(`${F}: Updated global state`,[...J.keys()]))}};e.$AMb=p,e.$AMb=p=ve([Y(0,v.$7k),Y(1,E.$Hi),Y(2,t.$nLb),Y(3,g.$Smb)],p);let S=class extends f.$wMb{constructor(C,O,M,T,F,K){super("globalState",M,T,F,O,C,K)}async o(C){const O=C.syncData?JSON.parse(C.syncData.content):null;if(!O){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},T={};for(const F of Object.keys(O.storage))F.startsWith(s)?M[F.substring(s.length)]=O.storage[F].value:this.l.get(F,0)===void 0&&(T[F]=O.storage[F].value);if(Object.keys(M).length){let F="{}";try{F=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const K of Object.keys(M))F=(0,u.edit)(F,[K],M[K],{});await this.k.writeFile(this.h.argvResource,R.$Je.fromString(F))}if(Object.keys(T).length){const F=[];for(const K of Object.keys(T))F.push({key:K,value:T[K],scope:0,target:0});this.l.storeAll(F,!0)}}};e.$BMb=S,e.$BMb=S=ve([Y(0,c.$7p),Y(1,v.$7k),Y(2,m.$Gl),Y(3,E.$Hi),Y(4,g.$Smb),Y(5,$.$El)],S);let b=class{constructor(C,O,M,T,F){this.a=C,this.b=O,this.c=M,this.d=T,this.f=F}getSyncStoreType(C){return this.h(C)?.storage[g.$Lmb]?.value}async sync(C){const O=(0,g.$Hmb)((0,P.$Wg)());try{return await this.g(C,O)}catch(M){if(M instanceof g.$Imb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(C,O)}throw M}}async g(C,O){const M=await this.a.readResource("globalState",null,void 0,O),T=this.h(M)||{storage:{}};T.storage[g.$Lmb]={value:C,version:o};const F=await(0,l.$aq)(this.c,this.d,this.b),K={version:o,machineId:F,content:i(T,!1)};await this.a.writeResource("globalState",JSON.stringify(K),M.ref,void 0,O)}h({content:C}){if(!C)return null;const O=JSON.parse(C);if((0,f.$rMb)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};e.$CMb=b,e.$CMb=b=ve([Y(1,c.$7p),Y(2,E.$Hi),Y(3,v.$7k),Y(4,y.$7j)],b)}),define(le[119],he([0,1,17,15,3,35,5,13,178,22,16,12,20,18,29,19,39,242,25]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aac=e.$__b=void 0,e.$$_b=h;function h(t,r,s){try{const n=JSON.parse(t);if(!r)return(0,I.$hg)(n.all)?null:n.all;switch(D.OS){case 2:return(0,I.$hg)(n.mac)?null:n.mac;case 3:return(0,I.$hg)(n.linux)?null:n.linux;case 1:return(0,I.$hg)(n.windows)?null:n.windows}}catch(n){return s.error(n),null}}let g=class extends $.$vMb{constructor(r,s,n,i,o,a,p,S,b,k,C,O,M){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},s,S,b,k,n,i,p,O,o,C,a,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$Umb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$Umb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$Umb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$Umb,authority:"accepted"}),this.B(A.Event.filter(a.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(r,s,n,i){const o=r.syncData?h(r.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;s=s===null&&n?r:s;const a=s?this.Ob(s):null,p=await this.vb(),S=await this.Cb();let b=null,k=!1,C=!1,O=!1;if(o){let F=p?p.value.toString():"[]";if(F=F||"[]",this.Ab(F,!0))throw new u.$Imb((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==F||a!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const K=await(0,f.$0_b)(F,o,a,S,this.zb);K.hasChanges&&(b=K.mergeContent,O=K.hasConflicts,k=O||K.mergeContent!==F,C=O||K.mergeContent!==o)}}else p&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),b=p.value.toString(),C=!0);const M={content:O?a:b,localChange:k?p?2:1:0,remoteChange:C?2:0,hasConflicts:O},T=p?p.value.toString():null;return[{fileContent:p,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:T,localChange:M.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(r){const s=this.Ob(r);if(s===null)return!0;const n=await this.vb(),i=n?n.value.toString():"",o=await this.Cb(),a=await(0,f.$0_b)(i||"[]",s,s,o,this.zb);return a.hasConflicts||a.mergeContent!==s}async rb(r,s){return r.previewResult}async sb(r,s,n,i){if(this.h.isEqual(s,this.Gb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(s,this.Hb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(s,this.Eb))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(r,s,n,i){const{fileContent:o}=n[0][0];let{content:a,localChange:p,remoteChange:S}=n[0][1];if(p===0&&S===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$Imb((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(p!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(a||"[]",o,i),this.O.info(`${this.D}: Updated local keybindings`)),S!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const b=this.Pb(a||"[]",r.syncData?.content);r=await this.mb(b,i?null:r.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}s?.ref!==r.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(r,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.vb();if(r){const s=(0,j.$Nn)(r.value.toString());if((0,R.$Lb)(s))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Hb,r)||this.h.isEqual(this.Fb,r)||this.h.isEqual(this.Gb,r)||this.h.isEqual(this.Ib,r)?this.db(r):null}Ob(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Qb()?null:h(r.syncData.content,this.Qb(),this.O)}Pb(r,s){let n={};try{n=JSON.parse(s||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete n.all:n.all=r,D.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}Qb(){return!!this.P.getValue(u.$wmb)}};e.$__b=g,e.$__b=g=ve([Y(2,u.$Dmb),Y(3,u.$Emb),Y(4,u.$Smb),Y(5,d.$7i),Y(6,u.$Nmb),Y(7,v.$7k),Y(8,E.$Hi),Y(9,y.$7p),Y(10,u.$Rmb),Y(11,l.$6l),Y(12,c.$El)],g);let m=class extends $.$wMb{constructor(r,s,n,i,o,a){super("keybindings",s,n,i,r,o,a)}async o(r){const s=r.syncData?this.p(r.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,L.$Je.fromString(s)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,j.$Nn)(r.value.toString());return!(0,R.$Lb)(s)}catch(r){return r.fileOperationResult===1}}p(r){try{return h(r,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$aac=m,e.$aac=m=ve([Y(0,v.$7k),Y(1,w.$Gl),Y(2,E.$Hi),Y(3,u.$Smb),Y(4,y.$7p),Y(5,c.$El)],m)}),define(le[120],he([0,1,15,3,179,22,76,16,28,12,20,18,29,19,39,246,25]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dac=e.$cac=void 0,e.$bac=u;function f(m){return m&&m.settings&&typeof m.settings=="string"&&Object.keys(m).length===1}function u(m){const t=JSON.parse(m);return f(t)?t:{settings:m}}let h=class extends c.$vMb{constructor(t,r,s,n,i,o,a,p,S,b,k,C,O,M){super(t.settingsResource,{syncResource:"settings",profile:t},r,s,n,i,o,a,k,C,p,S,b,M),this.Eb=O,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:$.$Umb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$Umb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$Umb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$Umb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),s=await this.X(t,r),n=this.Lb(s),i=new D.$Do($.$vmb,this.O);return n?.settings&&i.parse(n.settings),i.configurationModel.getValue($.$vmb)||{}}async qb(t,r,s){const n=await this.vb(),i=await this.Cb(),o=this.Lb(t);r=r===null&&s?t:r;const a=r?this.Lb(r):null,p=await this.Pb();let S=null,b=!1,k=!1,C=!1;if(o){let F=n?n.value.toString().trim():"{}";F=F||"{}",this.Qb(F),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const K=(0,w.$7Kb)(F,o.settings,a?a.settings:null,p,[],i);S=K.localContent||K.remoteContent,b=K.localContent!==null,k=K.remoteContent!==null,C=K.hasConflicts}else n&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=n.value.toString().trim()||"{}",this.Qb(S),k=!0);const O=n?n.value.toString():null,M=a?.settings??null,T={content:C?M:S,localChange:b?2:0,remoteChange:k?2:0,hasConflicts:C};return[{fileContent:n,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:O,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async ub(t){const r=this.Lb(t);if(r===null)return!0;const s=await this.vb(),n=s?s.value.toString().trim():"",i=await this.Pb(),o=await this.Cb();return(0,w.$7Kb)(n||"{}",r.settings,r.settings,i,[],o).remoteContent!==null}async rb(t,r){const s=await this.Cb(),n=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,w.$6Kb)(t.previewResult.content,"{}",n,s):null}}async sb(t,r,s,n){const i=await this.Cb(),o=await this.Pb();if(this.h.isEqual(r,this.localResource))return{content:t.fileContent?(0,w.$6Kb)(t.fileContent.value.toString(),"{}",o,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,w.$6Kb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(r,this.previewResource))return s===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:s!==null?(0,w.$6Kb)(s,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async tb(t,r,s,n){const{fileContent:i}=s[0][0];let{content:o,localChange:a,remoteChange:p}=s[0][1];if(a===0&&p===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(o,i,n),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),p!==0){const S=await this.Cb(),b=this.Lb(t),k=await this.Pb(o);o=(0,w.$6Kb)(o,b?b.settings:"{}",k,S),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(o)),n?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,w.$8Kb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let r=await super.db(t);if(r){const s=await this.Cb(),n=await this.Pb();r=(0,w.$6Kb)(r,"{}",n,s)}return r}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return u(t)}catch(r){this.O.error(r)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const s=this.B(L.Event.any(L.Event.filter(this.Eb.onDidInstallExtensions,n=>n.some(({local:i})=>!!i)),L.Event.filter(this.Eb.onDidUninstallExtension,n=>!n.error))(()=>{s.dispose(),this.Ob=void 0}))}const r=await this.Ob;return(0,w.$4Kb)(r,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new $.$Imb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$cac=h,e.$cac=h=ve([Y(2,d.$7k),Y(3,I.$Hi),Y(4,E.$7p),Y(5,$.$Dmb),Y(6,$.$Emb),Y(7,$.$Smb),Y(8,$.$Rmb),Y(9,j.$7i),Y(10,$.$Nmb),Y(11,v.$6l),Y(12,P.$cp),Y(13,y.$El)],h);let g=class extends c.$wMb{constructor(t,r,s,n,i,o){super("settings",r,s,n,t,i,o)}async o(t){const r=t.syncData?this.p(t.syncData.content):null;if(!r){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,R.$Je.fromString(r.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,w.$8Kb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return u(t)}catch(r){this.j.error(r)}return null}};e.$dac=g,e.$dac=g=ve([Y(0,d.$7k),Y(1,l.$Gl),Y(2,I.$Hi),Y(3,$.$Smb),Y(4,E.$7p),Y(5,y.$El)],g)}),define(le[121],he([0,1,15,3,30,22,16,12,20,18,29,19,39,243,25]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=e.$hac=void 0,e.$gac=w;function w(u){return JSON.parse(u.content)}let $=class extends y.$tMb{constructor(h,g,m,t,r,s,n,i,o,a,p,S){super({syncResource:"snippets",profile:h},g,t,m,r,s,n,a,p,i,o,S),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch(m.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(L.Event.filter(this.G.onDidFilesChange,b=>b.affects(this.vb))(()=>this.Q()))}async qb(h,g,m){const t=await this.Hb(),r=this.Gb(t),s=h.syncData?this.Fb(h.syncData):null;g=g===null&&m?h:g;const n=g&&g.syncData?this.Fb(g.syncData):null;s?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,l.$eac)(r,s,n);return this.Bb(i,t,s||{},n||{})}async ub(h){const g=h.syncData?this.Fb(h.syncData):null;if(g===null)return!0;const m=await this.Hb(),t=this.Gb(m),r=(0,l.$eac)(t,g,g);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async rb(h,g){return h.previewResult}async sb(h,g,m,t){if(this.h.isEqualOrParent(g,this.g.with({scheme:c.$Umb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(g,this.g.with({scheme:c.$Umb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(g,this.g))return m===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:m,localChange:m===null?h.fileContent!==null?3:0:2,remoteChange:m===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async tb(h,g,m,t){const r=m.map(([s,n])=>({...s,acceptResult:n}));r.every(({localChange:s,remoteChange:n})=>s===0&&n===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),r.some(({localChange:s})=>s!==0)&&(await this.Cb(r),await this.Db(r,t)),r.some(({remoteChange:s})=>s!==0)&&(h=await this.Eb(r,h,t)),g?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:s}of r)try{await this.G.del(s)}catch{}}Bb(h,g,m,t){const r=new Map;for(const s of Object.keys(h.local.added)){const n={content:h.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};r.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"remote"}),remoteContent:m[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"accepted"})})}for(const s of Object.keys(h.local.updated)){const n={content:h.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},i=g[s]?g[s].value.toString():null;r.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"local"}),fileContent:g[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"remote"}),remoteContent:m[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"accepted"})})}for(const s of h.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=g[s]?g[s].value.toString():null;r.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"local"}),fileContent:g[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"accepted"})})}for(const s of Object.keys(h.remote.added)){const n={content:h.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},i=g[s]?g[s].value.toString():null;r.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"local"}),fileContent:g[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"accepted"})})}for(const s of Object.keys(h.remote.updated)){const n={content:h.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},i=g[s]?g[s].value.toString():null;r.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"local"}),fileContent:g[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"remote"}),remoteContent:m[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"accepted"})})}for(const s of h.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"remote"}),remoteContent:m[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"accepted"})})}for(const s of h.conflicts){const n={content:t[s]??null,hasConflicts:!0,localChange:g[s]?2:1,remoteChange:m[s]?2:1},i=g[s]?g[s].value.toString():null;r.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"local"}),fileContent:g[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"remote"}),remoteContent:m[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"accepted"})})}for(const s of Object.keys(g))if(!r.has(s)){const n={content:g[s]?g[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=g[s]?g[s].value.toString():null;r.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"local"}),fileContent:g[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"remote"}),remoteContent:m[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:c.$Umb,authority:"accepted"})})}return[...r.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:c.$Umb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:c.$Umb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:c.$Umb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:c.$Umb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const g={};for(const m of h)m.fileContent&&(g[this.h.basename(m.localResource)]=m.fileContent);await this.nb(JSON.stringify(this.Gb(g)))}async Db(h,g){for(const{fileContent:m,acceptResult:t,localResource:r,remoteResource:s,localChange:n}of h)if(n!==0){const i=s?this.h.basename(s):this.h.basename(r),o=this.h.joinPath(this.vb,i);n===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):n===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,R.$Je.fromString(t.content),{overwrite:g}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,R.$Je.fromString(t.content),g?void 0:m),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(h,g,m){const t=g.syncData?this.Fb(g.syncData):{},r=(0,A.$7n)(t);for(const{acceptResult:s,localResource:n,remoteResource:i,remoteChange:o}of h)if(o!==0){const a=n?this.h.basename(n):this.h.basename(i);o===3?delete r[a]:r[a]=s.content}return(0,l.$fac)(t,r)||(this.O.trace(`${this.D}: Updating remote snippets...`),g=await this.mb(JSON.stringify(r),m?null:g.ref),this.O.info(`${this.D}: Updated remote snippets`)),g}Fb(h){return w(h)}Gb(h){const g={};for(const m of Object.keys(h))g[m]=h[m].value.toString();return g}async Hb(){const h={};let g;try{g=await this.G.resolve(this.vb)}catch(m){if(m instanceof I.$pl&&m.fileOperationResult===1)return h;throw m}for(const m of g.children||[]){const t=m.resource,r=this.h.extname(t);if(r===".json"||r===".code-snippets"){const s=this.h.relativePath(this.vb,t),n=await this.G.readFile(t);h[s]=n}}return h}};e.$hac=$,e.$hac=$=ve([Y(2,D.$Hi),Y(3,I.$7k),Y(4,P.$7p),Y(5,c.$Dmb),Y(6,c.$Emb),Y(7,c.$Smb),Y(8,j.$7i),Y(9,c.$Nmb),Y(10,d.$6l),Y(11,E.$El)],$);let f=class extends y.$wMb{constructor(h,g,m,t,r,s){super("snippets",g,m,t,h,r,s)}async o(h){const g=h.syncData?JSON.parse(h.syncData.content):null;if(!g){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(g)){const r=g[t];if(r){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(s,R.$Je.fromString(r)),this.j.info("Created snippet",this.d.basename(s))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$iac=f,e.$iac=f=ve([Y(0,I.$7k),Y(1,v.$Gl),Y(2,D.$Hi),Y(3,c.$Smb),Y(4,P.$7p),Y(5,E.$El)],f)}),define(le[122],he([0,1,15,22,16,12,20,18,29,19,39,25]),function(se,e,R,L,A,j,D,I,P,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=e.$kac=void 0,e.$jac=y;function y($,f){try{return JSON.parse($).tasks??null}catch(u){return f.error(u),null}}let l=class extends E.$uMb{constructor(f,u,h,g,m,t,r,s,n,i,o,a){super(f.tasksResource,{syncResource:"tasks",profile:f},u,s,n,i,h,g,r,o,m,t,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:v.$Umb,authority:"base"}),this.Cb=this.Ab.with({scheme:v.$Umb,authority:"local"}),this.Db=this.Ab.with({scheme:v.$Umb,authority:"remote"}),this.Eb=this.Ab.with({scheme:v.$Umb,authority:"accepted"})}async qb(f,u,h,g){const m=f.syncData?y(f.syncData.content,this.O):null;u=u===null&&h?f:u;const t=u?.syncData?y(u.syncData.content,this.O):null,r=await this.vb();let s=null,n=!1,i=!1,o=!1;if(f.syncData){const S=r?r.value.toString():null;if(!t||t!==S||t!==m){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const b=w(S,m,t);s=b.content,o=b.hasConflicts,n=b.hasLocalChanged,i=b.hasRemoteChanged}}else r&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=r.value.toString(),i=!0);const a={content:o?t:s,localChange:n?r?2:1:0,remoteChange:i?2:0,hasConflicts:o},p=r?r.value.toString():null;return[{fileContent:r,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:p,localChange:a.localChange,remoteResource:this.Db,remoteContent:m,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(f){const u=f?.syncData?y(f.syncData.content,this.O):null;if(u===null)return!0;const h=await this.vb(),g=h?h.value.toString():null,m=w(g,u,u);return m.hasLocalChanged||m.hasRemoteChanged}async rb(f,u){return f.previewResult}async sb(f,u,h,g){if(this.h.isEqual(u,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:f.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return h===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(f,u,h,g){const{fileContent:m}=h[0][0],{content:t,localChange:r,remoteChange:s}=h[0][1];if(r===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),r!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),m&&await this.nb(JSON.stringify(this.Kb(m.value.toString()))),t?await this.wb(t,m,g):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),s!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const n=JSON.stringify(this.Kb(t));f=await this.mb(n,g?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$kac=l,e.$kac=l=ve([Y(2,v.$Dmb),Y(3,v.$Emb),Y(4,v.$Smb),Y(5,L.$7i),Y(6,v.$Nmb),Y(7,j.$7k),Y(8,A.$Hi),Y(9,D.$7p),Y(10,I.$6l),Y(11,P.$El)],l);let c=class extends E.$wMb{constructor(f,u,h,g,m,t){super("tasks",u,h,g,f,m,t),this.c=this.g.defaultProfile.tasksResource}async o(f){const u=f.syncData?y(f.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,R.$Je.fromString(u)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$lac=c,e.$lac=c=ve([Y(0,j.$7k),Y(1,d.$Gl),Y(2,A.$Hi),Y(3,v.$Smb),Y(4,D.$7p),Y(5,P.$El)],c);function w($,f,u){if($===null&&f===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if($===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=u!==$,g=u!==f;return!h&&!g?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!g?{content:$,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:g&&!h?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:$,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[123],he([0,1,44,22,16,12,20,18,29,19,39,244,25]),function(se,e,R,L,A,j,D,I,P,d,E,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0,e.$6bc=c,e.$7bc=w;let l=class extends E.$tMb{constructor(f,u,h,g,m,t,r,s,n,i,o,a,p){super({syncResource:"profiles",profile:f},u,g,m,t,r,s,o,a,n,i,p),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:y.$Umb,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.$Umb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.$Umb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.$Umb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?w(f.syncData):null}async getRemoteSyncedProfiles(f){const u=await this.getLastSyncUserData(),h=await this.X(f,u);return h?.syncData?w(h.syncData):null}async qb(f,u,h){if(!this.vb.isEnabled())throw new y.$Imb("Cannot sync profiles because they are disabled","LocalError");const g=f.syncData?w(f.syncData):null,m=u?.syncData?w(u.syncData):null,t=this.Db(),{local:r,remote:s}=(0,v.$4bc)(t,g,m,[]),n={local:r,remote:s,content:m?this.Eb(m):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:s!==null?2:0},i=c(t,!1);return[{baseResource:this.baseResource,baseContent:m?this.Eb(m):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:g?this.Eb(g):null,remoteProfiles:g,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const u=f?.syncData?w(f.syncData):null,h=this.Db(),{remote:g}=(0,v.$4bc)(h,u,u,[]);return!!g?.added.length||!!g?.removed.length||!!g?.updated.length}async rb(f,u){return{...f.previewResult,hasConflicts:!1}}async sb(f,u,h,g){if(this.h.isEqual(u,this.localResource))return this.Ab(f);if(this.h.isEqual(u,this.remoteResource))return this.Bb(f);if(this.h.isEqual(u,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(f){const u=this.Db(),h=(0,v.$4bc)(u,null,null,[]),{local:g,remote:m}=h;return{content:f.localContent,local:g,remote:m,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?2:0,remoteChange:m!==null?2:0}}async Bb(f){const u=f.remoteContent?JSON.parse(f.remoteContent):null,h=[],g=[];for(const m of this.Db()){const t=u?.find(r=>r.id===m.id);t&&(h.push({id:m.id,name:m.name,collection:t.collection}),g.push(m))}if(u!==null){const m=(0,v.$4bc)(g,u,h,[]),{local:t,remote:r}=m;return{content:f.remoteContent,local:t,remote:r,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(f,u,h,g){const{local:m,remote:t,localChange:r,remoteChange:s}=h[0][1];r===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const n=h[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new y.$Imb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0&&(await this.nb(c(this.Db(),!1)),await Promise.all(m.removed.map(async i=>{this.O.trace(`${this.D}: Removing '${i.name}' profile...`),await this.vb.removeProfile(i),this.O.info(`${this.D}: Removed profile '${i.name}'.`)})),await Promise.all(m.added.map(async i=>{this.O.trace(`${this.D}: Creating '${i.name}' profile...`),await this.vb.createProfile(i.id,i.name,{shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${i.name}'.`)})),await Promise.all(m.updated.map(async i=>{const o=this.vb.profiles.find(a=>a.id===i.id);o?(this.O.trace(`${this.D}: Updating '${i.name}' profile...`),await this.vb.updateProfile(o,{name:i.name,shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${i.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${i.id}' to update.`)}))),s!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],o=n.length+(t?.added.length??0)<=20;if(o)for(const a of t?.added||[]){const p=await this.J.createCollection(this.F);i.push(p),n.push({id:a.id,name:a.name,collection:p,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])n.splice(n.findIndex(({id:p})=>a.id===p),1);for(const a of t?.updated||[]){const p=n.find(({id:S})=>a.id===S);p&&n.splice(n.indexOf(p),1,{...p,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{f=await this.updateRemoteProfiles(n,g?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const p of i)await this.J.deleteCollection(p,this.F)}throw a}for(const a of t?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,u){return this.mb(this.Eb(f),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const u=await this.db(f);return u&&(0,R.$Yn)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((u,h)=>u.name.localeCompare(h.name)))}};e.$5bc=l,e.$5bc=l=ve([Y(2,d.$Gl),Y(3,j.$7k),Y(4,A.$Hi),Y(5,D.$7p),Y(6,y.$Dmb),Y(7,y.$Emb),Y(8,y.$Smb),Y(9,L.$7i),Y(10,y.$Nmb),Y(11,I.$6l),Y(12,P.$El)],l);function c($,f){const u=[...$].sort((h,g)=>h.name.localeCompare(g.name)).map(h=>({id:h.id,name:h.name}));return f?(0,R.$Yn)(u,{}):JSON.stringify(u)}function w($){return JSON.parse($.content)}}),define(le[261],he([0,1,3,2,5,16,20,18,25]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;const d="sync.enable";let E=class extends L.$Uc{constructor(y,l,c,w){super(),this.c=y,this.f=l,this.g=c,this.h=w,this.a=new R.$he,this.onDidChangeEnablement=this.a.event,this.b=new R.$he,this.onDidChangeResourceEnablement=this.b.event,this.B(y.onDidChangeValue(-1,void 0,this.B(new L.$Tc))($=>this.m($)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(y){y&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:y}),this.c.store(d,y,-1,1))}isResourceEnabled(y){return this.c.getBoolean((0,P.$Mmb)(y),-1,!0)}setResourceEnablement(y,l){if(this.isResourceEnabled(y)!==l){const c=(0,P.$Mmb)(y);this.j(c,l)}}getResourceSyncStateVersion(y){}j(y,l){this.c.store(y,l,-1,A.$o?0:1)}m(y){if(d===y.key){this.a.fire(this.isEnabled());return}const l=P.$zmb.filter(c=>(0,P.$Mmb)(c)===y.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$Rbc=E,e.$Rbc=E=ve([Y(0,D.$7p),Y(1,I.$6l),Y(2,j.$Hi),Y(3,P.$Cmb)],E)}),define(le[262],he([0,1,6,15,65,2,21,22,16,12,19,25]),function(se,e,R,L,A,j,D,I,P,d,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;let y=class extends j.$Uc{constructor(c,w,$,f,u){super(),this.a=c,this.b=w,this.c=$,this.f=f,this.g=u,this.h()}async h(){for(const w of this.g.profiles)for(const $ of v.$zmb)try{await this.m(this.j($,w.isDefault?void 0:w.id))}catch(f){this.f.error(f)}let c;try{c=await this.b.resolve(this.a.userDataSyncHome)}catch(w){(0,d.$ll)(w)!==1&&this.f.error(w);return}if(c.children){for(const w of c.children)if(w.isDirectory&&!this.g.profiles.some($=>$.id===w.name))try{this.f.info("Deleting non existing profile from backup",w.resource.path),await this.b.del(w.resource,{recursive:!0})}catch($){this.f.error($)}}}async getAllResourceRefs(c,w,$){const f=this.j(c,w,$);try{const u=await this.b.resolve(f);if(u.children)return u.children.filter(g=>g.isFile&&!g.name.startsWith("lastSync")).sort().reverse().map(g=>({ref:g.name,created:this.n(g)}))}catch(u){if((0,d.$ll)(u)!==1)throw u}return[]}async resolveResourceContent(c,w,$,f){const u=this.j(c,$,f),h=(0,D.$bh)(u,w);try{return(await this.b.readFile(h)).value.toString()}catch(g){return this.f.error(g),null}}async writeResource(c,w,$,f,u){const h=this.j(c,f,u),g=(0,D.$bh)(h,`${(0,A.$8m)($).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(g,L.$Je.fromString(w))}catch(m){this.f.error(m)}}j(c,w,$=this.a.userDataSyncHome){return(0,D.$bh)($,...w?[w,c]:[c])}async m(c){try{try{if(!await this.b.exists(c))return}catch{return}const w=await this.b.resolve(c);if(w.children){const $=w.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=$.filter(g=>Date.now()-this.n(g)>f);const h=$.length-u.length;h<10&&(u=u.slice(10-h)),await R.Promises.settled(u.map(async g=>{this.f.info("Deleting from backup",g.resource.path),await this.b.del(g.resource)}))}}catch(w){this.f.error(w)}}n(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.$3bc=y,e.$3bc=y=ve([Y(0,P.$Hi),Y(1,d.$7k),Y(2,I.$7i),Y(3,v.$Smb),Y(4,E.$Gl)],y)}),define(le[84],he([0,1,3,2,5,27,183,16,12,4,24,45,20,25]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$smb=e.$qmb=void 0,e.$rmb=m,e.$qmb=(0,d.$Ai)("IUserDataSyncMachinesService");const w="sync.currentMachineName",$="Safari",f="Chrome",u="Edge",h="Firefox",g="Android";function m(s){switch(s){case $:case f:case u:case h:case g:case(0,A.$h)(0):return!0}return!1}function t(){return A.$G?$:A.$E?f:A.$H?u:A.$F?h:A.$I?g:(0,A.$h)(A.$o?0:A.$u)}let r=class extends L.$Uc{static{c=this}static{this.a=1}static{this.b="machines"}constructor(n,i,o,a,p,S){super(),this.h=o,this.j=a,this.m=p,this.n=S,this.c=this.B(new R.$he),this.onDidChange=this.c.event,this.g=null,this.f=(0,v.$aq)(n,i,o)}async getMachines(n){const i=await this.f;return(await this.s(n)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(n){const i=await this.f,o=await this.s(n);o.machines.some(({id:a})=>a===i)||(o.machines.push({id:i,name:this.r(o.machines),platform:t()}),await this.t(o))}async removeCurrentMachine(n){const i=await this.f,o=await this.s(n),a=o.machines.filter(({id:p})=>p!==i);a.length!==o.machines.length&&(o.machines=a,await this.t(o))}async renameMachine(n,i,o){const a=await this.s(o),p=a.machines.find(({id:S})=>S===n);if(p){p.name=i,await this.t(a);const S=await this.f;n===S&&this.h.store(w,i,-1,1)}}async setEnablements(n){const i=await this.s();for(const[o,a]of n){const p=i.machines.find(S=>S.id===o);p&&(p.disabled=a?void 0:!0)}await this.t(i)}r(n){const i=this.h.get(w,-1);if(i)return i;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$df)(o)}\\s#(\\d+)`);let p=0;for(const S of n){const b=a.exec(S.name),k=b?parseInt(b[1]):0;p=k>p?k:p}return`${o} #${p+1}`}async s(n){this.g=await this.u(n);const i=this.w(this.g);if(i.version!==c.a)throw new Error((0,D.localize)(0,null,this.n.nameLong));return i}async t(n){const i=JSON.stringify(n),o=await this.j.writeResource(c.b,i,this.g?.ref||null);this.g={ref:o,content:i},this.c.fire()}async u(n){if(this.g){const i=n&&n.latest?n.latest[c.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(c.b,this.g)}w(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(i){this.m.error(i)}return{version:c.a,machines:[]}}};e.$smb=r,e.$smb=r=c=ve([Y(0,I.$Hi),Y(1,P.$7k),Y(2,y.$7p),Y(3,l.$Dmb),Y(4,l.$Smb),Y(5,E.$nk)],r)}),define(le[263],he([0,1,6,65,38,7,3,2,5,21,8,180,24,20,18,25,80,84]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0;const u="sync.disableMachineEventually",h="sync.sessionId",g="sync.storeUrl",m="sync.productQuality";let t=class extends I.$Uc{get n(){const n=this.H.get(g,-1);return n?E.URI.parse(n):void 0}set n(n){n?this.H.store(g,n.toString(),-1,1):this.H.remove(g,-1)}get s(){return this.H.get(m,-1)}set s(n){n?this.H.store(m,n,-1,1):this.H.remove(m,-1)}constructor(n,i,o,a,p,S,b,k,C,O){super(),this.u=i,this.w=o,this.y=a,this.z=p,this.C=S,this.D=b,this.F=k,this.G=C,this.H=O,this.a=this.B(new I.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new D.$he),this.onError=this.h.event,this.S=[],this.f=this.B(new R.$yh(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=n.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,d.$7g)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(b.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(p.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(D.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:n,message:i}=this.L();n?this.a.value===void 0&&(this.a.value=new r(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.$8m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(n,i,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),n?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),i)this.M(!1);else throw a}}M(n){this.y.isEnabled()!==n&&(this.y.setEnablement(n),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(n){if(!n){this.b=0;return}const i=w.$Imb.toUserDataSyncError(n);i instanceof w.$Kmb&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?P.$o&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(u,!0,-1,1),await(0,R.$Bh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(n,i,o){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...n),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$9bc=t,e.$9bc=t=ve([Y(0,y.$nk),Y(1,w.$Cmb),Y(2,w.$Dmb),Y(3,w.$Nmb),Y(4,w.$Omb),Y(5,w.$Smb),Y(6,$.$MKb),Y(7,c.$6l),Y(8,f.$qmb),Y(9,l.$7p)],t);class r extends I.$Uc{static{this.a="Interval"}constructor(n,i,o,a,p,S,b,k,C){super(),this.m=n,this.n=i,this.r=o,this.s=a,this.u=p,this.w=S,this.y=b,this.z=k,this.C=C,this.b=this.B(new I.$Vc),this.c=this.B(new D.$he),this.onDidStartSync=this.c.event,this.f=this.B(new D.$he),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}D(){this.b.value=(0,R.$Ch)(()=>{this.sync(r.a,!1),this.b.value=void 0},this.n)}sync(n,i){const o=(0,R.$nh)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(p){if((0,j.$4)(p))return}return this.H(n,i,a)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$7g)(this.m,this.r.userDataSyncStore?.url)}async G(){const n=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!n&&(!(0,d.$7g)(i.defaultUrl,n.defaultUrl)||!(0,d.$7g)(i.insidersUrl,n.insidersUrl)||!(0,d.$7g)(i.stableUrl,n.stableUrl))}async H(n,i,o){this.y.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let a;try{await this.I(i,o)}catch(p){if(this.y.error(p),a=p,w.$Imb.toUserDataSyncError(p).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,o),a=void 0}catch(S){this.y.error(S),a=S}}this.f.fire(a)}async I(n,i){if(this.h=await this.u.createSyncTask(this.g,n),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new w.$Kmb((0,v.localize)(0,null),"DefaultServiceChanged"):new w.$Kmb((0,v.localize)(1,null),"ServiceChanged"):new w.$Kmb((0,v.localize)(2,null),"TurnedOff");const o=this.C.get(h,-1);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new w.$Kmb((0,v.localize)(3,null),"DefaultServiceChanged"):new w.$Kmb((0,v.localize)(4,null),"ServiceChanged"):new w.$Kmb((0,v.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const p=a.find(b=>b.isCurrent);if(p?.disabled)throw new w.$Kmb((0,v.localize)(6,null),"TurnedOff");const S=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-S}),this.g===null)try{this.g=await this.s.manifest(null)}catch(b){throw new w.$Kmb((0,A.$lj)(b),b instanceof w.$Imb?b.code:"Unknown")}this.g&&this.g.session!==o&&this.C.store(h,this.g.session,-1,1),!i.isCancellationRequested&&(p||await this.w.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}}),define(le[264],he([0,1,8,184,16,12,45,20,29,25,19,39,121,120,119,22,122,117,118,4,123,44,27]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;let s=class{static{r=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(i,o,a,p,S,b,k,C,O,M){this.e=i,this.f=o,this.g=a,this.h=S,this.i=b,this.j=k,this.k=C,this.l=O,this.n=M,this.d=p.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const o=this.L(i.content,"profiles");return(0,g.$7bc)(o)}return[]}async getLocalSyncedProfiles(i){const o=await this.f.getAllResourceRefs("profiles",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("profiles",o[0].ref,void 0,i);if(a){const p=this.L(a,"profiles");return(0,g.$7bc)(p)}}return[]}async getLocalSyncedMachines(i){const o=await this.f.getAllResourceRefs("machines",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("machines",o[0].ref,void 0,i);if(a)return JSON.parse(a).machines.map(S=>({...S,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,o){return(await this.e.getAllResourceRefs(i,o?.collection)).map(({created:p,ref:S})=>({created:p,uri:this.J({remote:!0,syncResource:i,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:S,node:void 0})}))}async getLocalSyncResourceHandles(i,o,a){return(await this.f.getAllResourceRefs(i,o?.collection,a)).map(({created:S,ref:b})=>({created:S,uri:this.J({remote:!1,syncResource:i,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:b,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:i}){const o=this.K(i),a=o?this.k.profiles.find(p=>p.id===o.profile):void 0;return o&&a?{profile:a,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:i}){const o=this.K(i);if(!o)return[];const a=this.k.profiles.find(p=>p.id===o.profile);switch(o.syncResource){case"settings":return this.s(i,a);case"keybindings":return this.u(i,a);case"tasks":return this.w(i,a);case"snippets":return this.y(i,a);case"globalState":return this.D(i,a);case"extensions":return this.A(i,a);case"profiles":return this.G(i,a);case"workspaceState":return[]}}async getMachineId({uri:i}){const o=this.K(i);if(o){if(o.remote){if(o.ref){const{content:a}=await this.M(o.syncResource,o.ref,o.collection);if(a)return this.L(a,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const a=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(a)return this.L(a,o.syncResource)?.machineId}return}return(0,D.$aq)(this.h,this.j,this.i)}}async resolveContent(i){const o=this.K(i);if(!o||o.node===r.a)return null;if(o.ref){const a=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&a?this.q(o.syncResource,a,o.node):a}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(i,o,a,p,S){if(i){const{content:b}=await this.M(o,p,a);return b}return this.f.resolveResourceContent(o,p,a,S)}q(i,o,a){const p=this.L(o,i);switch(i){case"settings":return this.t(p,a);case"keybindings":return this.v(p,a);case"tasks":return this.x(p,a);case"snippets":return this.z(p,a);case"globalState":return this.E(p,a);case"extensions":return this.B(p,a);case"profiles":return this.H(p,a);case"workspaceState":return null}}async r(i,o){const a=this.k.profiles.find(p=>p.id===o);if(!a)return null;switch(i){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(i,o){const a=this.d.joinPath(i,"settings.json"),p=o?o.settingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:p}]}t(i,o){switch(o){case"settings.json":return(0,l.$bac)(i.content).settings}return null}u(i,o){const a=this.d.joinPath(i,"keybindings.json"),p=o?o.keybindingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:p}]}v(i,o){switch(o){case"keybindings.json":return(0,c.$$_b)(i.content,!!this.l.getValue(d.$wmb),this.g)}return null}w(i,o){const a=this.d.joinPath(i,"tasks.json"),p=o?o.tasksResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:p}]}x(i,o){switch(o){case"tasks.json":return(0,$.$jac)(i.content,this.g)}return null}async y(i,o){const a=await this.resolveContent(i);if(a){const p=this.L(a,"snippets");if(p){const S=(0,y.$gac)(p),b=[];for(const k of Object.keys(S)){const C=this.d.joinPath(i,k),O=o?this.d.joinPath(o.snippetsHome,k):this.d.joinPath(i,r.a);b.push({resource:C,comparableResource:O})}return b}}return[]}z(i,o){return(0,y.$gac)(i)[o]||null}A(i,o){const a=this.d.joinPath(i,"extensions.json"),p=o?this.J({remote:!1,syncResource:"extensions",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:p}]}B(i,o){switch(o){case"extensions.json":return(0,f.$6_b)((0,f.$5_b)(i),!0)}return null}async C(i){const{localExtensions:o}=await this.n.createInstance(f.$8_b).getLocalExtensions(i);return(0,f.$6_b)(o,!0)}D(i,o){const a=this.d.joinPath(i,"globalState.json"),p=o?this.J({remote:!1,syncResource:"globalState",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:p}]}E(i,o){switch(o){case"globalState.json":return(0,u.$yMb)(JSON.parse(i.content),!0)}return null}async F(i){const o=await this.n.createInstance(u.$AMb).getLocalGlobalState(i);return(0,u.$yMb)(o,!0)}G(i,o){const a=this.d.joinPath(i,"profiles.json"),p=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:p}]}H(i,o){switch(o){case"profiles.json":return(0,m.$Yn)(JSON.parse(i.content),{})}return null}async I(i){return(0,g.$6bc)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(i){const o=i.remote?r.b:r.c,a=[];return i.location&&(a.push(`scheme:${i.location.scheme}`),a.push(`authority:${i.location.authority}`),a.push((0,t.$hf)(i.location.path,"/"))),a.push(`syncResource:${i.syncResource}`),a.push(`profile:${i.profile}`),i.collection&&a.push(`collection:${i.collection}`),i.ref&&a.push(`ref:${i.ref}`),i.node&&a.push(i.node),this.d.joinPath(R.URI.from({scheme:d.$Umb,authority:o,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...a)}K(i){if(i.scheme!==d.$Umb)return;const o=[];for(;i.path!=="/";)o.unshift(this.d.basename(i)),i=this.d.dirname(i);if(o.length<2)return;const a=i.authority===r.b;let p,S;const b=[];let k,C,O,M,T;for(;o.length;){const F=o.shift();F.startsWith("scheme:")?p=F.substring(7):F.startsWith("authority:")?S=F.substring(10):F.startsWith("syncResource:")?k=F.substring(13):F.startsWith("profile:")?C=F.substring(8):F.startsWith("collection:")?O=F.substring(11):F.startsWith("ref:")?M=F.substring(4):k?T=F:b.push(F)}return{remote:a,syncResource:k,profile:C,collection:O,ref:M,node:T,location:p&&S!==void 0?this.d.joinPath(R.URI.from({scheme:p,authority:S,query:i.query,fragment:i.fragment,path:"/"}),...b):void 0}}L(i,o){try{const a=JSON.parse(i);if((0,v.$rMb)(a))return a}catch(a){this.g.error(a)}throw new d.$Imb((0,L.localize)(0,null),"IncompatibleRemoteContent",o)}async M(i,o,a){const p=await this.e.resolveResourceContent(i,o,a);return{ref:o,content:p}}};e.$Dcc=s,e.$Dcc=s=r=ve([Y(0,d.$Dmb),Y(1,d.$Emb),Y(2,d.$Smb),Y(3,P.$El),Y(4,A.$Hi),Y(5,I.$7p),Y(6,j.$7k),Y(7,E.$Gl),Y(8,w.$7i),Y(9,h.$zi)],s)}),define(le[265],he([0,1,17,6,26,38,3,2,21,13,32,22,28,12,4,20,18,19,117,118,119,120,121,122,123,25]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m,t,r,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;const i="sync.lastSyncTime";let o=class extends I.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(k,C,O,M,T,F,K,J,Q,H,X){super(),this.C=k,this.D=C,this.F=O,this.G=M,this.H=T,this.I=F,this.J=K,this.L=J,this.M=Q,this.N=H,this.O=X,this.f="uninitialized",this.g=this.B(new D.$he),this.onDidChangeStatus=this.g.event,this.h=this.B(new D.$he),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new D.$he),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new D.$he),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new D.$he),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new D.$he),this.onDidResetLocal=this.w.event,this.y=this.B(new D.$he),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=O.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(i,-1,void 0),this.B((0,I.$Sc)(()=>this.cb())),this.B(new L.$Mh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(k,C){this.db(),this.H.info("Sync started.");const O=new Date().getTime(),M=(0,E.$Wg)();try{const J=(0,n.$Hmb)(M);C&&(J["Cache-Control"]="no-cache"),k=await this.D.manifest(k,J)}catch(J){const Q=n.$Imb.toUserDataSyncError(J);throw S(Q,M,this.F,this.I),Q}const T=!1,F=this;let K;return{manifest:k,async run(){if(T)throw new Error("Can run a task only once");K=(0,L.$nh)(J=>F.P(k,!1,M,J)),await K.finally(()=>K=void 0),F.H.info(`Sync done. Took ${new Date().getTime()-O}ms`),F.ab()},stop(){return K?.cancel(),F.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new n.$Imb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const k=new Date().getTime(),C=(0,E.$Wg)(),O=(0,n.$Hmb)(C);let M;try{M=await this.D.manifest(null,O)}catch(K){const J=n.$Imb.toUserDataSyncError(K);throw S(J,C,this.F,this.I),J}await this.resetLocal();const T=this,F=new A.$se;return{id:C,async merge(){return T.P(M,!0,C,F.token)},async apply(){try{try{await T.R(M,C,F.token)}catch(K){if(n.$Imb.toUserDataSyncError(K).code==="MethodNotFound")T.H.info("Client is making invalid requests. Cleaning up data..."),await T.cleanUpRemoteData(),T.H.info("Applying manual sync again..."),await T.R(M,C,F.token);else throw K}}catch(K){throw T.H.error(K),K}T.H.info(`Sync done. Took ${new Date().getTime()-k}ms`),T.ab()},async stop(){F.cancel(),await T.U(),await T.resetLocal()}}}async P(k,C,O,M){this.n=[];try{this.status!=="hasConflicts"&&this.Z("syncing");const T=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(T,k,C,O,M));const F=T.enabled.find(K=>K.resource==="profiles");if(F){const K=await F.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(K,k,C,O,M)}}finally{this.status!=="hasConflicts"&&this.Z("idle"),this.r.fire(this.n)}}async Q(k,C,O,M,T){for(const F of k){if(T.isCancellationRequested)return;const K=this.M.profiles.find(Q=>Q.id===F.id);if(!K){this.H.error(`Profile with id:${F.id} and name: ${F.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",F.name);const J=this.getOrCreateActiveProfileSynchronizer(K,F);this.n.push(...await this.S(J,C,O,M,T))}for(const[F,K]of this.z.entries())this.M.profiles.some(J=>J.id===K[0].profile.id)||(await K[0].resetLocal(),K[1].dispose(),this.z.delete(F))}async R(k,C,O){const M=this.bb();for(const Q of M){if(O.isCancellationRequested)return;await Q.apply(C,O)}const T=M.find(Q=>Q.profile.isDefault);if(!T)return;const F=T.enabled.find(Q=>Q.resource==="profiles");if(!F)return;const J=(await F.getRemoteSyncedProfiles(k?.latest??null)||[]).filter(Q=>M.every(H=>H.profile.id!==Q.id));J.length&&await this.Q(J,k,!1,C,O)}async S(k,C,O,M,T){return(await k.sync(C,O,M,T)).map(([K,J])=>({profile:k.profile,syncResource:K,error:J}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.bb().map(k=>k.stop()))}async resolveContent(k){const C=await this.N.resolveContent(k);if(C)return C;for(const O of this.bb())for(const M of O.enabled){const T=await M.resolveContent(k);if(T)return T}return null}async replace(k){this.db();const C=this.N.resolveUserDataSyncResource(k);if(!C)return;const O=await this.resolveContent(k.uri);O&&await this.X(C.profile,async M=>{if(C.syncResource===M.resource)return await M.replace(O),!0})}async accept(k,C,O,M){this.db(),await this.X(k.profile,async T=>{if(k.syncResource===T.resource)return await T.accept(C,O),M&&await T.apply((0,d.$gg)(M)?!1:M.force,(0,n.$Hmb)((0,E.$Wg)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async C=>{if(C.resource!=="globalState"&&await C.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async C=>{if(await C.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(k){this.H.error(k)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(i,-1);for(const[k]of this.z.values())try{await k.resetLocal()}catch(C){this.H.error(C)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const k=this.J.keys(-1,1),C=[];for(const M of k){if(!M.endsWith(".lastSyncUserData"))continue;const T=M.split(".");T.length===3&&C.push([M,T[0]])}if(!C.length)return;const O=new I.$Tc;try{let M=this.z.get(this.M.defaultProfile.id)?.[0];M||(M=O.add(this.G.createInstance(a,this.M.defaultProfile,void 0)));const T=M.enabled.find(J=>J.resource==="profiles");if(!T)return;const K=(await T.getLastSyncedProfiles())?.map(J=>J.collection)??[];for(const[J,Q]of C)K.includes(Q)||(this.H.info(`Removing last sync state for stale profile: ${Q}`),this.J.remove(J,-1))}finally{O.dispose()}}async cleanUpRemoteData(){const k=await this.N.getRemoteSyncedProfiles(),C=k.map(F=>F.collection),O=await this.D.getAllCollections(),M=O.filter(F=>!C.includes(F));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(F=>this.D.deleteCollection(F))),this.H.info("Deleted redundant collections on server"));const T=k.filter(F=>O.includes(F.collection));if(T.length!==k.length){const F=this.G.createInstance(s.$5bc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await F.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await F.updateRemoteProfiles(T,null),this.H.info("Updated remote profiles on server")}finally{F.dispose()}}}async saveRemoteActivityData(k){this.db();const C=await this.D.getActivityData();await this.C.writeFile(k,C)}async extractActivityData(k,C){const O=(await this.C.readFile(k)).value.toString(),M=JSON.parse(O);if(M.resources)for(const T in M.resources)for(const F of M.resources[T])await this.O.writeResource(T,F.content,new Date(F.created*1e3),void 0,C);if(M.collections)for(const T in M.collections)for(const F in M.collections[T].resources)for(const K of M.collections[T].resources?.[F]??[])await this.O.writeResource(F,K.content,new Date(K.created*1e3),T,C)}async X(k,C){const O=new I.$Tc;try{const M=this.z.get(k.id);if(M){const Q=await this.Y(M[0],C,O);return(0,d.$hg)(Q)?null:Q}if(k.isDefault){const Q=O.add(this.G.createInstance(a,k,void 0)),H=await this.Y(Q,C,O);return(0,d.$hg)(H)?null:H}if(this.M.isEnabled())return null;const T=O.add(this.G.createInstance(s.$5bc,k,void 0)),F=await this.D.manifest(null),J=(await T.getRemoteSyncedProfiles(F?.latest??null)||[]).find(Q=>Q.id===k.id);if(J){const Q=O.add(this.G.createInstance(a,k,J.collection)),H=await this.Y(Q,C,O);return(0,d.$hg)(H)?null:H}return null}finally{O.dispose()}}async Y(k,C,O){const M=[...k.enabled,...k.disabled.reduce((T,F)=>(F!=="workspaceState"&&T.push(O.add(k.createSynchronizer(F))),T),[])];for(const T of M){const F=await C(T);if(!(0,d.$hg)(F))return F}}Z(k){const C=this.f;this.f!==k&&(this.f=k,this.g.fire(k),C==="hasConflicts"&&this.ab())}$(){const k=this.bb().map(C=>C.conflicts).flat();(0,R.$ub)(this.j,k,(C,O)=>C.profile.id===O.profile.id&&C.syncResource===O.syncResource&&(0,R.$ub)(C.conflicts,O.conflicts,(M,T)=>(0,P.$7g)(M.previewResource,T.previewResource)))||(this.j=k,this.m.fire(k))}ab(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(i,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(k,C){let O=this.z.get(k.id);if(O&&O[0].collection!==C?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.z.delete(k.id)),!O){const M=new I.$Tc,T=M.add(this.G.createInstance(a,k,C?.collection));M.add(T.onDidChangeStatus(F=>this.Z(F))),M.add(T.onDidChangeConflicts(F=>this.$())),M.add(T.onDidChangeLocal(F=>this.h.fire(F))),this.z.set(k.id,O=[T,M])}return O[0]}bb(){const k=[];for(const[C]of this.z.values())k.push(C);return k}cb(){this.z.forEach(([,k])=>k.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$8bc=o,e.$8bc=o=ve([Y(0,l.$7k),Y(1,n.$Dmb),Y(2,n.$Cmb),Y(3,c.$zi),Y(4,n.$Smb),Y(5,$.$6l),Y(6,w.$7p),Y(7,n.$Nmb),Y(8,f.$Gl),Y(9,n.$Pmb),Y(10,n.$Emb)],o);let a=class extends I.$Uc{get enabled(){return this.f.sort((k,C)=>k[1]-C[1]).map(([k])=>k)}get disabled(){return n.$zmb.filter(k=>!this.r.isResourceEnabled(k))}get status(){return this.g}get conflicts(){return this.m}constructor(k,C,O,M,T,F,K,J,Q,H){super(),this.profile=k,this.collection=C,this.r=O,this.t=M,this.u=T,this.w=F,this.y=K,this.z=J,this.C=Q,this.D=H,this.f=[],this.g="idle",this.h=this.B(new D.$he),this.onDidChangeStatus=this.h.event,this.j=this.B(new D.$he),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new D.$he),this.onDidChangeConflicts=this.n.event,this.B(O.onDidChangeResourceEnablement(([X,W])=>this.F(X,W))),this.B((0,I.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,X])=>X.dispose())));for(const X of n.$zmb)O.isResourceEnabled(X)&&this.G(X)}F(k,C){C?this.G(k):this.H(k)}G(k){if(this.f.some(([T])=>T.resource===k))return;if(k==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(k==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||k==="workspaceState")return;if(k!=="profiles"&&this.profile.useDefaultFlags?.[k]){this.z.debug(`Skipping syncing ${k} in ${this.profile.name} because it is already synced by default profile`);return}const C=new I.$Tc,O=C.add(this.createSynchronizer(k));C.add(O.onDidChangeStatus(()=>this.L())),C.add(O.onDidChangeConflicts(()=>this.M())),C.add(O.onDidChangeLocal(()=>this.j.fire(k)));const M=this.N(k);this.f.push([O,M,C])}H(k){const C=this.f.findIndex(([O])=>O.resource===k);if(C!==-1){const[[O,,M]]=this.f.splice(C,1);M.dispose(),this.L(),Promise.allSettled([O.stop(),O.resetLocal()]).then(null,T=>this.z.error(T))}}createSynchronizer(k){switch(k){case"settings":return this.t.createInstance(m.$cac,this.profile,this.collection);case"keybindings":return this.t.createInstance(g.$__b,this.profile,this.collection);case"snippets":return this.t.createInstance(t.$hac,this.profile,this.collection);case"tasks":return this.t.createInstance(r.$kac,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$zMb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$7_b,this.profile,this.collection);case"profiles":return this.t.createInstance(s.$5bc,this.profile,this.collection)}}async sync(k,C,O,M){if(M.isCancellationRequested)return[];const T=this.enabled;if(!T.length)return[];try{const F=[],K=(0,n.$Hmb)(O),J=(this.collection?k?.collections?.[this.collection]?.latest:k?.latest)??null,Q=C?await this.I(J):{};for(const H of T){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(C){const X=await H.preview(J,Q,K);if(X)for(const W of X.resourcePreviews)(W.localChange!==0||W.remoteChange!==0)&&W.mergeState==="preview"&&await H.merge(W.previewResource)}else await H.sync(J,K)}catch(X){const W=n.$Imb.toUserDataSyncError(X);if(S(W,O,this.w,this.y),p(X))throw W;this.z.error(X),this.z.error(`${H.resource}: ${(0,j.$lj)(X)}`),F.push([H.resource,W])}}return F}finally{this.L()}}async apply(k,C){const O=(0,n.$Hmb)(k);for(const M of this.enabled){if(C.isCancellationRequested)return;try{await M.apply(!1,O)}catch(T){const F=n.$Imb.toUserDataSyncError(T);if(S(F,k,this.w,this.y),p(T))throw F;this.z.error(T),this.z.error(`${M.resource}: ${(0,j.$lj)(T)}`)}}}async stop(){for(const k of this.enabled)try{k.status!=="idle"&&await k.stop()}catch(C){this.z.error(C)}}async resetLocal(){for(const k of this.enabled)try{await k.resetLocal()}catch(C){this.z.error(`${k.resource}: ${(0,j.$lj)(C)}`),this.z.error(C)}}async I(k){if(!this.profile.isDefault)return{};const C=this.D.getValue(n.$vmb),O=this.enabled.find(M=>M instanceof m.$cac);if(O){const M=await O.getRemoteUserDataSyncConfiguration(k);return{...C,...M}}return C}J(k){this.g!==k&&(this.g=k,this.h.fire(k))}L(){return this.M(),this.enabled.some(k=>k.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(k=>k.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const k=this.enabled.filter(C=>C.status==="hasConflicts").filter(C=>C.conflicts.conflicts.length>0).map(C=>C.conflicts);(0,R.$ub)(this.m,k,(C,O)=>C.syncResource===O.syncResource&&(0,R.$ub)(C.conflicts,O.conflicts,(M,T)=>(0,P.$7g)(M.previewResource,T.previewResource)))||(this.m=k,this.n.fire(k))}N(k){switch(k){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ve([Y(2,n.$Nmb),Y(3,c.$zi),Y(4,y.$_o),Y(5,n.$Cmb),Y(6,$.$6l),Y(7,n.$Smb),Y(8,f.$Gl),Y(9,v.$7i)],a);function p(b){if(b instanceof n.$Imb)switch(b.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function S(b,k,C,O){O.publicLog2("sync/error",{code:b.code,serverCode:b instanceof n.$Jmb?String(b.serverCode):void 0,url:b instanceof n.$Jmb?b.url:void 0,resource:b.resource,executionId:k,service:C.userDataSyncStore.url.toString()})}}),define(le[266],he([0,1,3,2,8,19,25]),function(se,e,R,L,A,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=e.$ofc=void 0;function I(y,l){return{...y,profile:(0,j.$Hl)(y.profile,l.profilesHome.scheme)}}function P(y){return{created:y.created,uri:A.URI.revive(y.uri)}}class d{constructor(l,c,w){this.c=l,this.d=c,this.f=w,this.a=new Map,this.b=new R.$he}listen(l,c){switch(c){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call(l,c,w){try{return await this.g(l,c,w)}catch($){throw this.f.error($),$}}async g(l,c,w){switch(c){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(w[0]));case"accept":return this.c.accept(I(w[0],this.d),A.URI.revive(w[1]),w[2],w[3]);case"replace":return this.c.replace(P(w[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(w[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(w[0]),A.URI.revive(w[1]));case"createManualSyncTask":return this.i()}if(c.startsWith("manualSync/")){const $=c.substring(11),f=w[0],u=this.h(f);switch(w=w.slice(1),$){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(l){const c=this.a.get(this.j(l));if(!c)throw new Error(`Manual sync taks not found: ${l}`);return c}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$ofc=d;let E=class extends L.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,c){super(),this.n=c,this.b="uninitialized",this.c=this.B(new R.$he),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new R.$he),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new R.$he),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new R.$he),this.onSyncErrors=this.m.event,this.a={call(w,$,f){return l.call(w,$,f).then(null,u=>{throw D.$Imb.toUserDataSyncError(u)})},listen(w,$){return l.listen(w,$)}},this.a.call("_getInitialData").then(([w,$,f])=>{this.s(w),this.t($),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(w=>this.t(w))),this.B(this.a.listen("onSyncErrors")(w=>this.m.fire(w.map($=>({...$,error:D.$Imb.toUserDataSyncError($.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),c=this;return new v(l,{async call($,f,u){return c.a.call(`manualSync/${$}`,[l,...Array.isArray(f)?f:[f]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,c,w,$){return this.a.call("accept",[l,c,w,$])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,c){return this.a.call("extractActivityData",[l,c])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map(c=>({syncResource:c.syncResource,profile:(0,j.$Hl)(c.profile,this.n.profilesHome.scheme),conflicts:c.conflicts.map(w=>({...w,baseResource:A.URI.revive(w.baseResource),localResource:A.URI.revive(w.localResource),remoteResource:A.URI.revive(w.remoteResource),previewResource:A.URI.revive(w.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$pfc=E,e.$pfc=E=ve([Y(1,j.$Gl)],E);class v extends L.$Uc{constructor(l,c){super(),this.id=l,this.a=c}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[124],he([0,1,6,26,7,3,2,143,5,21,13,8,32,22,16,12,24,59,45,20,25]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pMb=e.$oMb=e.$nMb=e.$mMb=e.$lMb=void 0;const m="configurationSync.store",t="sync.previous.store",r="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",i=100,o=1e3*60*5;let a=class extends D.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(g.$Lmb,-1)}set c(O){this.h.store(g.$Lmb,O,-1,P.$o?0:1)}constructor(O,M,T){super(),this.f=O,this.g=M,this.h=T,this.a=this.B(new j.$he),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const F=this.B(new D.$Tc);this.B(j.Event.filter(T.onDidChangeValue(-1,g.$Lmb,F),()=>this.c!==this.userDataSyncStore?.type,F)(()=>this.j()))}j(){this.b=this.m(this.f[m]),this.a.fire()}m(O){if(O&&(O=P.$o&&O.web?{...O,...O.web}:O,(0,E.$ag)(O.url)&&(0,E.$cg)(O.authenticationProviders)&&Object.keys(O.authenticationProviders).every(M=>Array.isArray(O.authenticationProviders[M].scopes)))){const M=O,T=!!M.canSwitch,F=M.url===M.insidersUrl?"insiders":"stable",K=(T?this.c:void 0)||F,J=K==="insiders"?M.insidersUrl:K==="stable"?M.stableUrl:M.url;return{url:v.URI.parse(J),type:K,defaultType:F,defaultUrl:v.URI.parse(M.url),stableUrl:v.URI.parse(M.stableUrl),insidersUrl:v.URI.parse(M.insidersUrl),canSwitch:T,authenticationProviders:Object.keys(M.authenticationProviders).reduce((Q,H)=>(Q.push({id:H,scopes:M.authenticationProviders[H].scopes}),Q),[])}}}};e.$lMb=a,e.$lMb=a=ve([Y(0,$.$nk),Y(1,l.$7i),Y(2,h.$7p)],a);let p=class extends a{constructor(O,M,T){super(O,M,T);const F=this.h.get(t,-1);F&&(this.n=JSON.parse(F));const K=this.f[m];K?this.h.store(t,JSON.stringify(K),-1,1):this.h.remove(t,-1)}async switch(O){O!==this.c&&(this.c=O,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$mMb=p,e.$mMb=p=ve([Y(0,$.$nk),Y(1,l.$7i),Y(2,h.$7p)],p);let S=class extends D.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(O,M,T,F,K,J,Q){super(),this.n=T,this.r=F,this.s=Q,this.g=this.B(new j.$he),this.onTokenFailed=this.g.event,this.h=this.B(new j.$he),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$he),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(O),this.c=(0,u.$aq)(K,J,Q).then(H=>{const X={"X-Client-Name":`${M.applicationName}${P.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(X["X-Client-Commit"]=M.commit),X}),this.f=new k(i,o,this.n,this.r),this.u(),this.B((0,D.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(O,M){this.b={token:O,type:M}}t(O){this.a=O?(0,d.$bh)(O,"v1"):void 0}u(){const O=this.s.getNumber(r,-1);O&&Date.now()<O&&this.y(new Date(O))}y(O){this.j?.getTime()!==O?.getTime()&&(this.j=O,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(r,this.j.getTime(),-1,1),this.w=(0,R.$nh)(M=>(0,R.$Bh)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(r,-1),this.m.fire())}async getAllCollections(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$bh)(this.a,"collection").toString();O={...O},O["Content-Type"]="application/json";const T=await this.D(M,{type:"GET",headers:O},[],L.CancellationToken.None);return(await(0,f.$Zp)(T))?.map(({id:F})=>F)||[]}async createCollection(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$bh)(this.a,"collection").toString();O={...O},O["Content-Type"]=I.$Ws.text;const T=await this.D(M,{type:"POST",headers:O},[],L.CancellationToken.None),F=await(0,f.$Yp)(T);if(!F)throw new g.$Jmb("Server did not return the collection id",M,"NoCollection",T.res.statusCode,T.res.headers[g.$Fmb]);return F}async deleteCollection(O,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=O?(0,d.$bh)(this.a,"collection",O).toString():(0,d.$bh)(this.a,"collection").toString();M={...M},await this.D(T,{type:"DELETE",headers:M},[],L.CancellationToken.None)}async getAllResourceRefs(O,M){if(!this.a)throw new Error("No settings sync store url configured.");const T=this.z(this.a,M,O),F={},K=await this.D(T.toString(),{type:"GET",headers:F},[],L.CancellationToken.None);return(await(0,f.$Zp)(K)||[]).map(({url:Q,created:H})=>({ref:(0,d.$dh)(T,T.with({path:Q})),created:H*1e3}))}async resolveResourceContent(O,M,T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,d.$bh)(this.z(this.a,T,O),M).toString();F={...F},F["Cache-Control"]="no-cache";const J=await this.D(K,{type:"GET",headers:F},[],L.CancellationToken.None);return await(0,f.$Yp)(J)}async deleteResource(O,M,T){if(!this.a)throw new Error("No settings sync store url configured.");const F=M!==null?(0,d.$bh)(this.z(this.a,T,O),M).toString():this.z(this.a,T,O).toString(),K={};await this.D(F,{type:"DELETE",headers:K},[],L.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,d.$bh)(this.a,"resource").toString(),M={"Content-Type":I.$Ws.text};await this.D(O,{type:"DELETE",headers:M},[],L.CancellationToken.None)}async readResource(O,M,T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=(0,d.$bh)(this.z(this.a,T,O),"latest").toString();F={...F},F["Cache-Control"]="no-cache",M&&(F["If-None-Match"]=M.ref);const J=await this.D(K,{type:"GET",headers:F},[304],L.CancellationToken.None);let Q=null;if(J.res.statusCode===304&&(Q=M),Q===null){const H=J.res.headers.etag;if(!H)throw new g.$Jmb("Server did not return the ref",K,"NoRef",J.res.statusCode,J.res.headers[g.$Fmb]);const X=await(0,f.$Yp)(J);if(!X&&J.res.statusCode===304)throw new g.$Jmb("Empty response",K,"EmptyResponse",J.res.statusCode,J.res.headers[g.$Fmb]);Q={ref:H,content:X}}return Q}async writeResource(O,M,T,F,K={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,F,O).toString();K={...K},K["Content-Type"]=I.$Ws.text,T&&(K["If-Match"]=T);const Q=await this.D(J,{type:"POST",data:M,headers:K},[],L.CancellationToken.None),H=Q.res.headers.etag;if(!H)throw new g.$Jmb("Server did not return the ref",J,"NoRef",Q.res.statusCode,Q.res.headers[g.$Fmb]);return H}async manifest(O,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$bh)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",O&&(M["If-None-Match"]=O.ref);const F=await this.D(T,{type:"GET",headers:M},[304],L.CancellationToken.None);let K=null;if(F.res.statusCode===304&&(K=O),!K){const Q=F.res.headers.etag;if(!Q)throw new g.$Jmb("Server did not return the ref",T,"NoRef",F.res.statusCode,F.res.headers[g.$Fmb]);const H=await(0,f.$Yp)(F);if(!H&&F.res.statusCode===304)throw new g.$Jmb("Empty response",T,"EmptyResponse",F.res.statusCode,F.res.headers[g.$Fmb]);H&&(K={...JSON.parse(H),ref:Q})}const J=this.s.get(s,-1);return J&&K&&J!==K.session&&this.C(),K===null&&J&&this.C(),K&&this.s.store(s,K.session,-1,1),K}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,d.$bh)(this.a,"download").toString(),M={},T=await this.D(O,{type:"GET",headers:M},[],L.CancellationToken.None);if(!(0,f.$Vp)(T))throw new g.$Jmb("Server returned "+T.res.statusCode,O,"EmptyResponse",T.res.statusCode,T.res.headers[g.$Fmb]);if((0,f.$Wp)(T))throw new g.$Jmb("Empty response",O,"EmptyResponse",T.res.statusCode,T.res.headers[g.$Fmb]);return T.stream}z(O,M,T){return M?(0,d.$bh)(O,"collection",M,"resource",T):(0,d.$bh)(O,"resource",T)}C(){this.s.remove(s,-1),this.s.remove(n,-1)}async D(O,M,T,F){if(!this.b)throw new g.$Jmb("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new g.$Jmb(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const K=await this.c;M.headers={...M.headers||{},...K,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:O,type:M.type,headers:{...M.headers,authorization:void 0}});let J;try{J=await this.f.request(O,M,F)}catch(B){if(!(B instanceof g.$Jmb)){let ie="RequestFailed";const re=(0,A.$0)(B).toLowerCase();re.includes("xhr timeout")?ie="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?ie="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":re.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,A.$4)(B)&&(ie="RequestCanceled"),B=new g.$Jmb(`Connection refused for the request '${O}'.`,O,ie,void 0,void 0)}throw this.r.info("Request failed",O),B}const Q=J.res.headers[g.$Fmb],H={url:O,status:J.res.statusCode,"execution-id":M.headers[g.$Gmb],"operation-id":Q},X=(0,f.$Vp)(J)||J.res.statusCode&&T.includes(J.res.statusCode);let W="";if(X?this.r.trace("Request succeeded",H):(W=await(0,f.$Xp)(J)||"",this.r.info("Request failed",H,W)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new g.$Jmb(`${M.type} request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",J.res.statusCode,Q);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new g.$Jmb(`${M.type} request '${O}' failed because the access is forbidden (403).`,O,"Forbidden",J.res.statusCode,Q)}if(this.h.fire(),J.res.statusCode===404)throw new g.$Jmb(`${M.type} request '${O}' failed because the requested resource is not found (404).`,O,"NotFound",J.res.statusCode,Q);if(J.res.statusCode===405)throw new g.$Jmb(`${M.type} request '${O}' failed because the requested endpoint is not found (405). ${W}`,O,"MethodNotFound",J.res.statusCode,Q);if(J.res.statusCode===409)throw new g.$Jmb(`${M.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",J.res.statusCode,Q);if(J.res.statusCode===410)throw new g.$Jmb(`${M.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",J.res.statusCode,Q);if(J.res.statusCode===412)throw new g.$Jmb(`${M.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",J.res.statusCode,Q);if(J.res.statusCode===413)throw new g.$Jmb(`${M.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",J.res.statusCode,Q);if(J.res.statusCode===426)throw new g.$Jmb(`${M.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",J.res.statusCode,Q);if(J.res.statusCode===429){const B=J.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new g.$Jmb(`${M.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",J.res.statusCode,Q)):new g.$Jmb(`${M.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",J.res.statusCode,Q)}if(!X)throw new g.$Jmb("Server returned "+J.res.statusCode,O,"Unknown",J.res.statusCode,Q);return J}F(O){let M=this.s.get(n,-1);M===void 0&&(M=(0,y.$Wg)(),this.s.store(n,M,-1,1)),O["X-Machine-Session-Id"]=M;const T=this.s.get(s,-1);T!==void 0&&(O["X-User-Session-Id"]=T)}};e.$nMb=S,e.$nMb=S=ve([Y(1,$.$nk),Y(2,f.$Tp),Y(3,g.$Smb),Y(4,c.$Hi),Y(5,w.$7k),Y(6,h.$7p)],S);let b=class extends S{constructor(O,M,T,F,K,J,Q){super(O.userDataSyncStore?.url,M,T,F,K,J,Q),this.B(O.onDidChangeUserDataSyncStore(()=>this.t(O.userDataSyncStore?.url)))}};e.$oMb=b,e.$oMb=b=ve([Y(0,g.$Cmb),Y(1,$.$nk),Y(2,f.$Tp),Y(3,g.$Smb),Y(4,c.$Hi),Y(5,w.$7k),Y(6,h.$7p)],b);class k{constructor(O,M,T,F){this.c=O,this.d=M,this.f=T,this.g=F,this.a=[],this.b=void 0}request(O,M,T){if(this.h()&&this.i(),M.url=O,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new g.$Jmb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(O),this.f.request(M,T)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$pMb=k}),define(le[267],he([0,1,3,2,8,22,24,20,124]),function(se,e,R,L,A,j,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=e.$mfc=e.$lfc=e.$kfc=void 0;class d{constructor(c){this.a=c}listen(c,w){switch(w){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${w}`)}call(c,w,$){switch(w){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$kfc=d;class E extends L.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(c){super(),this.c=c,this.b=this.B(new R.$he),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(w=>{this.a=w,this.B(this.c.listen("onDidChangeAccount")($=>{this.a=$,this.b.fire($)}))})}updateAccount(c){return this.c.call("updateAccount",c)}}e.$lfc=E;class v{constructor(c){this.a=c}listen(c,w){switch(w){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${w}`)}call(c,w,$){switch(w){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$mfc=v;let y=class extends P.$lMb{constructor(c,w,$,f){super(w,$,f),this.n=c,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(c){return this.n.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.n.call("getPreviousUserDataSyncStore");return this.r(c)}r(c){return{url:A.URI.revive(c.url),type:c.type,defaultUrl:A.URI.revive(c.defaultUrl),insidersUrl:A.URI.revive(c.insidersUrl),stableUrl:A.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.$nfc=y,e.$nfc=y=ve([Y(1,D.$nk),Y(2,j.$7i),Y(3,I.$7p)],y)}),define(le[268],he([0,1,3,57,24,20,18,263,25,80,84]),function(se,e,R,L,A,j,D,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;let v=class extends I.$9bc{constructor(l,c,w,$,f,u,h,g,m,t,r){super(l,c,w,$,f,h,g,m,t,r),this.B(R.Event.debounce(R.Event.any(R.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),R.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(s,n)=>s?[...s,n]:[n],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$Jfc=v,e.$Jfc=v=ve([Y(0,A.$nk),Y(1,P.$Cmb),Y(2,P.$Dmb),Y(3,P.$Nmb),Y(4,P.$Omb),Y(5,L.$Adc),Y(6,P.$Smb),Y(7,d.$MKb),Y(8,D.$6l),Y(9,E.$qmb),Y(10,j.$7p)],v)}),define(le[269],he([0,1,73,23,5,21]),function(se,e,R,L,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0,e.$2cc=D,e.$3cc=I,e.$4cc=P,e.$1cc=128/4;function D(d){function E(){let v=d.scheme===L.Schemas.file?(0,j.$2g)(d):d.toString();return A.$k||(v=v.toLowerCase()),(0,R.createHash)("md5").update(v).digest("hex")}return{id:E(),configPath:d}}function I(d,E){function v(){if(d.scheme!==L.Schemas.file)return(0,R.createHash)("md5").update(d.toString()).digest("hex");if(!E)return;let l;return A.$k?l=E.ino:A.$j?l=E.birthtime.getTime():A.$i&&(typeof E.birthtimeMs=="number"?l=Math.floor(E.birthtimeMs):l=E.birthtime.getTime()),(0,R.createHash)("md5").update(d.fsPath).update(l?String(l):"").digest("hex")}const y=v();if(typeof y=="string")return{id:y,uri:d}}function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[270],he([0,1,6,7,2,14,31,16,9,77,113,269,57,56,23]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;let w=class extends A.$Uc{constructor(f,u,h,g){super(),this.a=f,this.b=u,this.c=h,this.f=g,this.B(new R.$Mh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,u=await D.Promises.readdir(f),h=new d.$mLb(this.f.getChannel("storage"));await Promise.all(u.map(async g=>{const m=(0,j.$jc)(f,g);g.length===v.$1cc||g===E.$Mi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(s=>s.workspace?.id===g)||await h.isUsed(m)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await D.Promises.rm(m))}))}catch(f){(0,L.$1)(f)}}};e.$gfc=w,e.$gfc=w=ve([Y(0,I.$Ii),Y(1,P.$7j),Y(2,y.$Adc),Y(3,l.$Pec)],w)}),define(le[125],he([0,1,73,64,37,279,15,7,3,2,14,5,32,42,68]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=s,e.$ti=n,e.$vi=a,e.$wi=p;class w{traceSocketEvent(b,k){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,k)}constructor(b,k=""){this.f=!0,this.debugLabel=k,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,I.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const k=C=>{this.traceSocketEvent("read",C),b(D.$Je.wrap(C))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(b){const k=C=>{b({type:0,hadError:C,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(b){const k=()=>{b()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,I.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,I.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$pi=w;var $;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var f;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(f||(f={}));class u extends d.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,k){this.socket.traceSocketEvent(b,k)}constructor(b,k,C,O){super(),this.f=this.B(new P.$he),this.g=this.B(new P.$he),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:C?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new h(this,k,C,O,this.f,(M,T)=>this.m(M,T))),this.B(this.a.onError(M=>{console.error(M),(0,I.$1)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new c.$ki,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let k=0;for(;k<b.byteLength;)this.a.writeMessage(b.slice(k,Math.min(k+262144,b.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(b,{compressed:k,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let O=2;b.byteLength<126?O+=0:b.byteLength<2**16?O+=2:O+=8;const M=D.$Je.alloc(O),T=k?64:0,F=C&15;if(M.writeUInt8(128|T|F,0),b.byteLength<126)M.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){M.writeUInt8(126,1);let K=1;M.writeUInt8(b.byteLength>>>8&255,++K),M.writeUInt8(b.byteLength>>>0&255,++K)}else{M.writeUInt8(127,1);let K=1;M.writeUInt8(0,++K),M.writeUInt8(0,++K),M.writeUInt8(0,++K),M.writeUInt8(0,++K),M.writeUInt8(b.byteLength>>>24&255,++K),M.writeUInt8(b.byteLength>>>16&255,++K),M.writeUInt8(b.byteLength>>>8&255,++K),M.writeUInt8(b.byteLength>>>0&255,++K)}this.socket.write(D.$Je.concat([M,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),C=k.readUInt8(0),O=(C&128)>>>7,M=(C&64)>>>6,T=C&15,F=k.readUInt8(1),K=(F&128)>>>7,J=F&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),C=k.readUInt8(1),O=(C&128)>>>7;let M=C&127,T=1;M===126?M=k.readUInt8(++T)*2**8+k.readUInt8(++T):M===127&&(M=k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T));let F=0;O&&(F=k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T)),this.j.state=3,this.j.readLen=M,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$qi=u;class h extends d.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$Je.alloc(0)}constructor(b,k,C,O,M,T){super(),this.n=b,this.r=M,this.s=T,this.a=this.B(new P.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new P.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new g(this.n,O,C,{windowBits:15})),this.f=this.B(new m(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(b,k){this.g.push({data:b,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:k}=this.g.shift();if(this.f&&k.compressed){const C=await this.w(this.f,b);this.s(C,k)}else this.s(b,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,k){return new Promise((C,O)=>{b.write(k),b.flush(M=>C(M))})}acceptFrame(b,k,C){this.h.push({data:b,isCompressed:k,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const k=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,k,C){return new Promise((O,M)=>{b.write(k),C&&b.write(D.$Je.fromByteArray([0,0,255,255])),b.flush(T=>O(T))})}}class g extends d.$Uc{get recordedInflateBytes(){return this.j?D.$Je.concat(this.f):D.$Je.alloc(0)}constructor(b,k,C,O){super(),this.h=b,this.j=k,this.a=this.B(new P.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(O),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(D.$Je.wrap(M))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent("zlibInflateWrite",b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=D.$Je.concat(this.g);this.g.length=0,b(k)})}}class m extends d.$Uc{constructor(b,k){super(),this.g=b,this.a=this.B(new P.$he),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(D.$Je.wrap(C))})}write(b){this.g.traceSocketEvent("zlibDeflateWrite",b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=D.$Je.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),b(k)})}}function t(S,b){if(b===0)return;const k=S.byteLength>>>2;for(let K=0;K<k;K++){const J=S.readUInt32BE(K*4);S.writeUInt32BE(J^b,K*4)}const C=k*4,O=S.byteLength-C,M=b>>>24&255,T=b>>>16&255,F=b>>>8&255;O>=1&&S.writeUInt8(S.readUInt8(C)^M,C),O>=2&&S.writeUInt8(S.readUInt8(C+1)^T,C+1),O>=3&&S.writeUInt8(S.readUInt8(C+2)^F,C+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function s(){const S=(0,y.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const b=process.platform!=="darwin"&&e.$ri?e.$ri:(0,A.tmpdir)(),k=(0,E.$jc)(b,`vscode-ipc-${S}.sock`);return i(k),k}function n(S,b,k){const O=(0,R.createHash)("sha256").update(S).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${k}-${b}-sock`;const M=k.substr(0,4),T=b.substr(0,6);let F;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?F=(0,E.$jc)(e.$ri,`vscode-${O}-${M}-${T}.sock`):F=(0,E.$jc)(S,`${M}-${T}.sock`),i(F),F}function i(S){const b=r[v.$u];typeof b=="number"&&S.length>=b&&console.warn(`WARNING: IPC handle "${S}" is longer than ${b} chars, try a shorter --user-data-dir`)}class o extends l.$ei{static b(b){const k=P.Event.fromNodeEventEmitter(b,"connection");return P.Event.map(k,C=>({protocol:new c.$li(new w(C,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(C,"close"))}))}constructor(b){super(o.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=o;function a(S){return new Promise((b,k)=>{const C=(0,L.createServer)();C.on("error",k),C.listen(S,()=>{C.removeListener("error",k),b(new o(C))})})}function p(S,b){return new Promise((k,C)=>{const O=(0,L.createConnection)(S,()=>{O.removeListener("error",C),k(c.$mi.fromSocket(new w(O,`ipc-client${b}`),b))});O.once("error",C)})}}),define(le[271],he([0,1,64,125,219]),function(se,e,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0,e.$Mfc=new class{supports(j){return!0}connect({host:j,port:D},I,P,d){return new Promise((E,v)=>{const y=R.createConnection({host:j,port:D},()=>{y.removeListener("error",v),y.write((0,A.$8vb)(I,P,d));const l=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",l),E(new L.$pi(y,d)))};y.on("data",l)});y.setNoDelay(!0),y.once("error",v)})}}}),define(le[272],he([0,1,64,37,135,125,6,2,5,22,9,24,221,104,106,78,15]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=e.$Iec=e.$Hec=e.$Gec=void 0;async function f(t,r,s,n,i){let o;for(let a=3;a&&(o?.dispose(),o=await new u(t,r,s,n,i).waitForReady(),!(i&&A.$Zg[i]||!A.$Zg[o.tunnelLocalPort]));a--);return o}class u extends I.$Uc{constructor(r,s,n,i,o){super(),this.m=s,this.n=o,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=R.createServer(),this.c=new D.$zh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,s=(0,w.$ww)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,A.$1g)(r,2,1e3,s),i=null;return this.b.listen(n,this.m),await this.c.wait(),i=this.b.address(),i||(n=0,this.b.listen(n,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(r){r.pause();const s=(0,w.$uw)(this.tunnelRemoteHost)||(0,w.$ww)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,y.$Wl)(this.a,s,this.tunnelRemotePort),i=n.getSocket(),o=n.readEntireBuffer();n.dispose(),o.byteLength>0&&r.write(o.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),i.end()}),r.on("close",()=>i.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),i instanceof j.$pi?i.socket.destroy():i.end()}),i instanceof j.$pi?this.t(r,i):this.s(r,i),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),i.end()})}s(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(n=>r.write(n.buffer)),r.on("data",n=>s.write($.$Je.wrap(n))),r.resume()}t(r,s){const n=s.socket;n.on("end",()=>r.end()),n.on("close",()=>r.end()),n.on("error",()=>{r.destroy()}),n.pipe(r),r.pipe(n)}}e.$Gec=u;let h=class extends w.$zw{constructor(r,s,n,i,o){super(s,o),this.v=r,this.w=n,this.y=i}isPortPrivileged(r){return(0,w.$xw)(r,this.m,P.OS,L.release())}t(r,s,n,i,o,a,p,S){const b=this.s(s,n);if(b)return++b.refcount,b.value;if((0,w.$qw)(r))return this.u(r,s,n,o,a,p,S);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${o}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=f(k,i,s,n,o);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,n,C),C}}};e.$Hec=h,e.$Hec=h=ve([Y(0,l.$Ql),Y(1,E.$7j),Y(2,c.$Tl),Y(3,v.$nk),Y(4,d.$7i)],h);let g=class extends h{constructor(r,s,n,i,o){super(r,s,n,i,o)}};e.$Iec=g,e.$Iec=g=ve([Y(0,l.$Ql),Y(1,E.$7j),Y(2,c.$Tl),Y(3,v.$nk),Y(4,d.$7i)],g);let m=class extends I.$Uc{constructor(r,s,n,i,o){super(),this.b=r,this.c=s,this.f=n,this.g=i,this.h=o,this.a=new Map}async openTunnel(r,s,n,i,o,a,p,S,b){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${i} on local port ${a}.`),!this.a.has(r)){const k=new g(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(r,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(s,n,i,o,a,p,S,b)}};e.$Jec=m,e.$Jec=m=ve([Y(0,l.$Ql),Y(1,E.$7j),Y(2,v.$nk),Y(3,c.$Tl),Y(4,d.$7i)],m)}),define(le[280],he([0,1,37,38,7,2,23,8,17,3,42,153,213,214,204,205,270,194,196,22,218,95,229,96,224,16,116,254,28,108,195,115,97,12,207,208,72,4,203,74,75,234,9,209,101,24,59,20,107,18,109,110,111,49,237,83,112,25,80,262,267,247,84,261,265,266,124,60,260,248,106,228,78,272,223,238,29,239,5,240,197,216,215,82,253,19,52,212,58,259,236,249,105,264,255,10,210,100,257,252,225,191,57,211,268,256,56,258,104,271,189,226,149,142,147]),function(se,e,R,L,A,j,D,I,P,d,E,v,y,l,c,w,$,f,u,h,g,m,t,r,s,n,i,o,a,p,S,b,k,C,O,M,T,F,K,J,Q,H,X,W,B,ie,re,Z,z,x,G,N,U,V,q,_,ee,ne,te,ce,fe,$e,we,Ee,be,ye,Pe,Ce,ae,de,me,Ie,Re,je,Oe,Te,Le,Fe,Ve,Ne,Me,qe,oe,ue,ge,pe,ke,De,Ue,We,Be,Ke,ze,Ye,Xe,tt,nt,mt,Pt,Ct,It,Rt,Dt,Ot,At,jt,wt,Lt,pt,Nt,Mt,ot,Ft,Tt,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=yt;class Ut extends j.$Uc{constructor(Se){super(),this.f=Se,this.a=this.B(new v.$zW(this)),this.b=void 0,this.c=this.B(new d.$he),this.g()}g(){let Se=!1;const Ae=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,v.$AW)(process.parentPort,ot.$Vdc.exit,Ae)}async init(){const Se=await this.h();(0,ne.$xmb)(),Se.invokeFunction(Ae=>{const Ge=Ae.get(X.$7j),He=Ae.get(x.$6l),Ze=Ae.get(pe.$Gl);Ge.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ae),this.m(Ge),this.n(He,Ze),this.B(Ze.onDidChangeProfiles(()=>this.n(He,Ze))),this.r(He,Ge)}),this.B((0,j.$Rc)(Se.createInstance(y.$cfc,this.f.codeCachePath),Se.createInstance(l.$dfc),Se.createInstance($.$gfc),Se.createInstance(w.$ffc),Se.createInstance(c.$efc),Se.createInstance(Xe.$Dfc),Se.createInstance(Ke.$vfc)))}async h(){const Se=new J.$yi,Ae={_serviceBrand:void 0,...B.default};Se.set(ie.$nk,Ae);const Ge=new E.$ii(Qe=>Qe==="main"),He=new wt.$Qec(this.a,Ge);Se.set(wt.$Pec,He);const Ze=this.f.policiesData?new De.$mec(this.f.policiesData,He.getChannel("policy")):new Ue.$lo;Se.set(Ue.$jo,Ze);const Je=new Mt.$an(this.f.args,Ae);Se.set(n.$Ii,Je);const it=new W.$fs(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Qe=>({...Qe,resource:I.URI.revive(Qe.resource)})),He.getChannel("logger"));Se.set(X.$8j,it);const ct=this.B(it.createLogger("sharedprocess",{name:(0,tt.localize)(0,null)})),ft=this.B(new X.$ck(ct.getLevel())),xe=this.B(new nt.$fQ(ct,[ft]));Se.set(X.$7j,xe),this.b=this.B(new mt.$Ffc(xe)),Se.set(mt.$Efc,this.b);const _e=this.B(new O.$Oq(xe));Se.set(C.$7k,_e);const dt=this.B(new M.$fr(xe));_e.registerProvider(D.Schemas.file,dt);const lt=new Fe.$Gs(_e);Se.set(Le.$El,lt);const et=this.B(new We.$mQ(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));Se.set(pe.$Gl,et);const gt=this.B(new Ne.$Oec(D.Schemas.file,this.B(new Me.$1P(He.getChannel(Me.$ZP),{pathCaseSensitive:Ve.$k})),D.Schemas.vscodeUserData,et,lt,xe));_e.registerProvider(D.Schemas.vscodeUserData,gt);const st=this.B(new g.$Lo(et.defaultProfile.settingsResource,_e,Ze,xe));Se.set(h.$7i,st);const $t=new Lt.$Lfc(void 0,{defaultProfile:et.defaultProfile,currentProfile:et.defaultProfile},He,Je);Se.set(Z.$7p,$t),this.B((0,j.$Sc)(()=>$t.flush())),await Promise.all([st.initialize(),$t.initialize()]);const vt=new It.$2r(He.getChannel("request"));Se.set(re.$Tp,vt),Se.set(f.$hfc,new T.$xi(u.$ifc,void 0,!1)),Se.set(oe.$uG,new T.$xi(qe.$ufc,void 0,!1));const Et=new Ot.$Vec(-1,He);Se.set(Dt.$Adc,Et),Se.set(r.$Po,new T.$xi(s.$uQ,void 0,!0));const zt=this.B(new de.$jec(Et)),Bt=new E.$ii(Qe=>zt.getActiveClientId().then(ut=>Qe===ut));Se.set(k.$14b,new Rt.$Hfc(this.a.getChannel("extensionRecommendationNotification",Bt)));let ht;const rt=[],St=(0,V.$xp)(Ae,st);if((0,V.$sp)(Ae,Je)){const Qe=new N.$nbc(xe,it,Je,Ae);if(rt.push(Qe),!(0,V.$tp)(Ae,Je)&&Ae.aiConfig?.ariaKey){const ut=new Be.$6P(vt,St,"monacoworkbench",null,Ae.aiConfig.ariaKey);this.B((0,j.$Sc)(()=>ut.flush())),rt.push(ut)}ht=new U.$6r({appenders:rt,commonProperties:(0,z.$jp)((0,R.release)(),(0,R.hostname)(),process.arch,Ae.commit,Ae.version,this.f.machineId,this.f.sqmId,St),sendErrorTelemetry:!0,piiPaths:(0,V.$yp)(Je)},st,Ae)}else{ht=V.$np;const Qe=V.$rp;rt.push(Qe)}this.a.registerChannel("telemetryAppender",new G.$1dc(rt)),Se.set(x.$6l,ht);const Vt=new q.$jfc(st,ht,xe,it,Je,Ae);Se.set(x.$7l,Vt),Se.set(ke.$vq,new T.$xi(Ct.$eQ,void 0,!0)),Se.set(ue.$zq,new T.$xi(ge.$nec,void 0,!0)),Se.set(p.$fq,new T.$xi(p.$hq,void 0,!0)),Se.set(b.$Kq,new T.$xi(b.$Lq,void 0,!0)),Se.set(a.$_o,new T.$xi(o.$dq,void 0,!0)),Se.set(a.$gp,new T.$xi(jt.$Kfc,void 0,!1)),Se.set(Q.$Xr,new T.$xi(H.$Zr,void 0,!1)),Se.set(m.$hn,new T.$xi(t.$Ns,void 0,!1)),Se.set(te.$MKb,new T.$xi(te.$NKb,void 0,!0)),Se.set(ne.$Smb,new T.$xi($e.$hNb,void 0,!0)),Se.set(ne.$Rmb,E.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Se.set(a.$fp,new T.$xi(i.$KKb,void 0,!1)),Se.set(ee.$fNb,new T.$xi(ee.$gNb,void 0,!0)),Se.set(_.$aw,new T.$xi(_.$bw)),Se.set(ne.$Cmb,new T.$xi(Pe.$mMb,void 0,!0)),Se.set(ne.$Dmb,new T.$xi(Pe.$oMb,void 0,!0)),Se.set(we.$qmb,new T.$xi(we.$smb,void 0,!0)),Se.set(ne.$Emb,new T.$xi(ce.$3bc,void 0,!1)),Se.set(ne.$Nmb,new T.$xi(Ee.$Rbc,void 0,!0)),Se.set(ne.$Omb,new T.$xi(be.$8bc,void 0,!1)),Se.set(Ce.$nLb,new T.$xi(ae.$qfc,void 0,!0)),Se.set(ne.$Pmb,new T.$xi(Ye.$Dcc,void 0,!0)),Se.set(me.$Tl,new T.$xi(Ie.$Lec,void 0,!1));const kt=new pt.$Rl;return Se.set(pt.$Ql,kt),kt.register(0,Nt.$Mfc),Se.set(Re.$pw,new T.$xi(je.$Jec)),Se.set(Oe.$rfc,new T.$xi(Te.$tfc)),Se.set(ze.$wfc,new T.$xi(Pt.$Gfc)),new K.$ir(Se)}j(Se){const Ae=new S.$jq(Se.get(a.$cp),()=>null);this.a.registerChannel("extensions",Ae);const Ge=E.ProxyChannel.fromService(Se.get(Q.$Xr),this.q);this.a.registerChannel("languagePacks",Ge);const He=E.ProxyChannel.fromService(Se.get(m.$hn),this.q);this.a.registerChannel("diagnostics",He);const Ze=new S.$lq(Se.get(a.$gp));this.a.registerChannel("extensionTipsService",Ze);const Je=E.ProxyChannel.fromService(Se.get(f.$hfc),this.q);this.a.registerChannel("checksum",Je);const it=E.ProxyChannel.fromService(Se.get(oe.$uG),this.q);this.a.registerChannel("v8InspectProfiling",it);const ct=E.ProxyChannel.fromService(Se.get(we.$qmb),this.q);this.a.registerChannel("userDataSyncMachines",ct);const ft=E.ProxyChannel.fromService(Se.get(x.$7l),this.q);this.a.registerChannel("customEndpointTelemetry",ft);const xe=new fe.$kfc(Se.get(te.$MKb));this.a.registerChannel("userDataSyncAccount",xe);const _e=new fe.$mfc(Se.get(ne.$Cmb));this.a.registerChannel("userDataSyncStoreManagement",_e);const dt=new ye.$ofc(Se.get(ne.$Omb),Se.get(pe.$Gl),Se.get(X.$7j));this.a.registerChannel("userDataSync",dt);const lt=this.B(Se.get(F.$zi).createInstance(At.$Jfc));this.a.registerChannel("userDataAutoSync",E.ProxyChannel.fromService(lt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",E.ProxyChannel.fromService(Se.get(ne.$Pmb),this.q));const et=E.ProxyChannel.fromService(Se.get(Oe.$rfc),this.q);this.a.registerChannel(Oe.$sfc,et);const gt=E.ProxyChannel.fromService(Se.get(ze.$wfc),this.q);this.a.registerChannel("remoteTunnel",gt)}m(Se){process.on("uncaughtException",Ae=>(0,A.$1)(Ae)),process.on("unhandledRejection",Ae=>(0,A.$1)(Ae)),(0,A.setUnexpectedErrorHandler)(Ae=>{const Ge=(0,L.$lj)(Ae,!0);Ge&&Se.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}n(Se,Ae){Se.publicLog2("profilesInfo",{count:Ae.profiles.length})}async r(Se,Ae){if(Ve.$k){const[Ge,He]=await Promise.all([(0,Ft.$Xg)(Ae.error.bind(Ae)),(0,bt.$hW)(Ae.error.bind(Ae))]),Ze=(0,Tt.$ZV)(),Je=(0,bt.$iW)(He,this.f.args["ozone-platform"]);Ge&&Se.publicLog2("clientPlatformInfo",{platformId:Ge.id,platformVersionId:Ge.version_id,platformIdLike:Ge.id_like,desktopEnvironment:Ze,displayProtocol:He,codeDisplayProtocol:Je})}}handledClientConnection(Se){if(Se.data!==ot.$Xdc.response)return!1;const Ae=(0,P.$Ob)(Se.ports);return Ae?(this.c.fire(Ae),!0):!1}}async function yt(at){try{const Se=new Ut(at);process.parentPort.postMessage(ot.$Vdc.ipcReady),await Se.init(),process.parentPort.postMessage(ot.$Vdc.initDone)}catch(Se){process.parentPort.postMessage({error:Se.toString()})}}const qt=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",at=>{clearTimeout(qt),yt(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
