/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/base/common/async","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],de=function(oe){for(var e=[],w=0,L=oe.length;w<L;w++)e[w]=fe[oe[w]];return e};define(fe[40],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=w,e.$gb=L,e.$hb=C,e.$ib=D,e.$jb=R,e.$kb=P,e.$lb=l,e.$nb=y,e.$ob=u,e.$pb=E,e.$qb=a,e.$rb=c;function w(g,f){const s=L(g,f);if(s!==-1)return g[s]}function L(g,f,s=g.length-1){for(let n=s;n>=0;n--){const m=g[n];if(f(m))return n}return-1}function C(g,f){const s=D(g,f);return s===-1?void 0:g[s]}function D(g,f,s=0,n=g.length){let m=s,p=n;for(;m<p;){const i=Math.floor((m+p)/2);f(g[i])?m=i+1:p=i}return m-1}function R(g,f){const s=P(g,f);return s===g.length?void 0:g[s]}function P(g,f,s=0,n=g.length){let m=s,p=n;for(;m<p;){const i=Math.floor((m+p)/2);f(g[i])?p=i:m=i+1}return m}function l(g,f,s=0,n=g.length){const m=P(g,f,s,n);return m===g.length?-1:m}class r{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(r.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!f(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const s=D(this.e,f,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=r;function y(g,f){if(g.length===0)return;let s=g[0];for(let n=1;n<g.length;n++){const m=g[n];f(m,s)>0&&(s=m)}return s}function u(g,f){if(g.length===0)return;let s=g[0];for(let n=1;n<g.length;n++){const m=g[n];f(m,s)>=0&&(s=m)}return s}function E(g,f){return y(g,(s,n)=>-f(s,n))}function a(g,f){if(g.length===0)return-1;let s=0;for(let n=1;n<g.length;n++){const m=g[n];f(m,g[s])>0&&(s=n)}return s}function c(g,f){for(const s of g){const n=f(s);if(n!==void 0)return n}}}),define(fe[41],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=w,e.$L=L,e.$M=C,e.$N=D;function w(R,P){const l=Object.create(null);for(const r of R){const y=P(r);let u=l[y];u||(u=l[y]=[]),u.push(r)}return l}function L(R,P){const l=[],r=[];for(const y of R)P.has(y)||l.push(y);for(const y of P)R.has(y)||r.push(y);return{removed:l,added:r}}function C(R,P){const l=[],r=[];for(const[y,u]of R)P.has(y)||l.push(u);for(const[y,u]of P)R.has(y)||r.push(u);return{removed:l,added:r}}function D(R,P){const l=new Set;for(const r of P)R.has(r)&&l.add(r);return l}}),define(fe[14],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=L,e.$6h=C,e.$7h=D;function w(R){return(P,l,r)=>{let y=null,u=null;if(typeof r.value=="function"?(y="value",u=r.value):typeof r.get=="function"&&(y="get",u=r.get),!u)throw new Error("not supported");r[y]=R(u,l)}}function L(R,P,l){let r=null,y=null;if(typeof l.value=="function"?(r="value",y=l.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(r="get",y=l.get),!y)throw new Error("not supported");const u=`$memoize$${P}`;l[r]=function(...E){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,E)}),this[u]}}function C(R,P,l){return w((r,y)=>{const u=`$debounce$${y}`,E=`$debounce$result$${y}`;return function(...a){this[E]||(this[E]=l?l():void 0),clearTimeout(this[u]),P&&(this[E]=P(this[E],...a),a=[this[E]]),this[u]=setTimeout(()=>{r.apply(this,a),this[E]=l?l():void 0},R)}})}function D(R,P,l){return w((r,y)=>{const u=`$throttle$timer$${y}`,E=`$throttle$result$${y}`,a=`$throttle$lastRun$${y}`,c=`$throttle$pending$${y}`;return function(...g){if(this[E]||(this[E]=l?l():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),P&&(this[E]=P(this[E],...g)),this[c])return;const f=this[a]+R;f<=Date.now()?(this[a]=Date.now(),r.apply(this,[this[E]]),this[E]=l?l():void 0):(this[c]=!0,this[u]=setTimeout(()=>{this[c]=!1,this[a]=Date.now(),r.apply(this,[this[E]]),this[E]=l?l():void 0},f-Date.now()))}})}}),define(fe[7],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=L,e.$Z=C,e.$1=D,e.$2=R,e.$3=P,e.$4=r,e.$6=u,e.$7=E,e.$8=a,e.$0=g;class w{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=w,e.$X=new w;function L(i){e.$X.setUnexpectedErrorHandler(i)}function C(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(i){r(i)||e.$X.onUnexpectedError(i)}function R(i){r(i)||e.$X.onUnexpectedExternalError(i)}function P(i){if(i instanceof Error){const{name:t,message:o}=i,k=i.stacktrace||i.stack;return{$isError:!0,name:t,message:o,stack:k,noTelemetry:m.isErrorNoTelemetry(i)}}return i}const l="Canceled";function r(i){return i instanceof y?!0:i instanceof Error&&i.name===l&&i.message===l}class y extends Error{constructor(){super(l),this.name=this.message}}e.$5=y;function u(){const i=new Error(l);return i.name=i.message,i}function E(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function a(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function g(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const o=new m;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=m;class p extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype)}}e.$cb=p}),define(fe[16],de([0,1,7,40]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=C,e.$tb=D,e.$ub=R,e.$vb=P,e.$wb=l,e.$xb=r,e.$yb=y,e.$zb=u,e.$Ab=E,e.$Bb=a,e.$Cb=c,e.$Db=g,e.$Eb=f,e.top=s,e.$Gb=n,e.$Hb=p,e.$Ib=i,e.$Jb=t,e.$Kb=o,e.$Lb=k,e.$Mb=$,e.$Nb=S,e.$Ob=v,e.$Pb=b,e.$Qb=U,e.$Rb=Z,e.$Sb=T,e.$Tb=I,e.$Ub=d,e.$Vb=N,e.$Wb=A,e.$Xb=M,e.$Yb=q,e.$Zb=_,e.$1b=V,e.$2b=x,e.$3b=re,e.$4b=he,e.$5b=X,e.$6b=ee,e.$7b=le,e.$0b=te;function C(j,Y=0){return j[j.length-(1+Y)]}function D(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}function R(j,Y,H=(G,O)=>G===O){if(j===Y)return!0;if(!j||!Y||j.length!==Y.length)return!1;for(let G=0,O=j.length;G<O;G++)if(!H(j[G],Y[G]))return!1;return!0}function P(j,Y){const H=j.length-1;Y<H&&(j[Y]=j[H]),j.pop()}function l(j,Y,H){return r(j.length,G=>H(j[G],Y))}function r(j,Y){let H=0,G=j-1;for(;H<=G;){const O=(H+G)/2|0,J=Y(O);if(J<0)H=O+1;else if(J>0)G=O-1;else return O}return-(H+1)}function y(j,Y,H){if(j=j|0,j>=Y.length)throw new TypeError("invalid index");const G=Y[Math.floor(Y.length*Math.random())],O=[],J=[],ie=[];for(const ae of Y){const be=H(ae,G);be<0?O.push(ae):be>0?J.push(ae):ie.push(ae)}return j<O.length?y(j,O,H):j<O.length+ie.length?ie[0]:y(j-(O.length+ie.length),J,H)}function u(j,Y){const H=[];let G;for(const O of j.slice(0).sort(Y))!G||Y(G[0],O)!==0?(G=[O],H.push(G)):G.push(O);return H}function*E(j,Y){let H,G;for(const O of j)G!==void 0&&Y(G,O)?H.push(O):(H&&(yield H),H=[O]),G=O;H&&(yield H)}function a(j,Y){for(let H=0;H<=j.length;H++)Y(H===0?void 0:j[H-1],H===j.length?void 0:j[H])}function c(j,Y){for(let H=0;H<j.length;H++)Y(H===0?void 0:j[H-1],j[H],H+1===j.length?void 0:j[H+1])}function g(j,Y,H){const G=[];function O(ae,be,Pe){if(be===0&&Pe.length===0)return;const me=G[G.length-1];me&&me.start+me.deleteCount===ae?(me.deleteCount+=be,me.toInsert.push(...Pe)):G.push({start:ae,deleteCount:be,toInsert:Pe})}let J=0,ie=0;for(;;){if(J===j.length){O(J,0,Y.slice(ie));break}if(ie===Y.length){O(J,j.length-J,[]);break}const ae=j[J],be=Y[ie],Pe=H(ae,be);Pe===0?(J+=1,ie+=1):Pe<0?(O(J,1,[]),J+=1):Pe>0&&(O(J,0,[be]),ie+=1)}return G}function f(j,Y,H){const G=g(j,Y,H),O=[],J=[];for(const ie of G)O.push(...j.slice(ie.start,ie.start+ie.deleteCount)),J.push(...ie.toInsert);return{removed:O,added:J}}function s(j,Y,H){if(H===0)return[];const G=j.slice(0,H).sort(Y);return m(j,Y,G,H,j.length),G}function n(j,Y,H,G,O){return H===0?Promise.resolve([]):new Promise((J,ie)=>{(async()=>{const ae=j.length,be=j.slice(0,H).sort(Y);for(let Pe=H,me=Math.min(H+G,ae);Pe<ae;Pe=me,me=Math.min(me+G,ae)){if(Pe>H&&await new Promise(ge=>setTimeout(ge)),O&&O.isCancellationRequested)throw new w.$5;m(j,Y,be,Pe,me)}return be})().then(J,ie)})}function m(j,Y,H,G,O){for(const J=H.length;G<O;G++){const ie=j[G];if(Y(ie,H[J-1])<0){H.pop();const ae=(0,L.$kb)(H,be=>Y(ie,be)<0);H.splice(ae,0,ie)}}}function p(j){return j.filter(Y=>!!Y)}function i(j){let Y=0;for(let H=0;H<j.length;H++)j[H]&&(j[Y]=j[H],Y+=1);j.length=Y}function t(j,Y,H){j.splice(H,0,j.splice(Y,1)[0])}function o(j){return!Array.isArray(j)||j.length===0}function k(j){return Array.isArray(j)&&j.length>0}function $(j,Y=H=>H){const H=new Set;return j.filter(G=>{const O=Y(G);return H.has(O)?!1:(H.add(O),!0)})}function S(j){const Y=new Set;return H=>{const G=j(H);return Y.has(G)?!1:(Y.add(G),!0)}}function v(j,Y){return j.length>0?j[0]:Y}function b(j,Y){return j.length>0?j[j.length-1]:Y}function U(j,Y,H=(G,O)=>G===O){let G=0;for(let O=0,J=Math.min(j.length,Y.length);O<J&&H(j[O],Y[O]);O++)G++;return G}function Z(j,Y){let H=typeof Y=="number"?j:0;typeof Y=="number"?H=j:(H=0,Y=j);const G=[];if(H<=Y)for(let O=H;O<Y;O++)G.push(O);else for(let O=H;O>Y;O--)G.push(O);return G}function T(j,Y,H){return j.reduce((G,O)=>(G[Y(O)]=H?H(O):O,G),Object.create(null))}function I(j,Y){return j.push(Y),()=>d(j,Y)}function d(j,Y){const H=j.indexOf(Y);if(H>-1)return j.splice(H,1),Y}function N(j,Y,H){const G=j.slice(0,Y),O=j.slice(Y);return G.concat(H,O)}function A(j,Y){let H;if(typeof Y=="number"){let G=Y;H=()=>{const O=Math.sin(G++)*179426549;return O-Math.floor(O)}}else H=Math.random;for(let G=j.length-1;G>0;G-=1){const O=Math.floor(H()*(G+1)),J=j[G];j[G]=j[O],j[O]=J}}function M(j,Y){const H=j.indexOf(Y);H>-1&&(j.splice(H,1),j.unshift(Y))}function q(j,Y){const H=j.indexOf(Y);H>-1&&(j.splice(H,1),j.push(Y))}function _(j,Y){for(const H of Y)j.push(H)}function V(j,Y){return Array.isArray(j)?j.map(Y):Y(j)}function x(j){return Array.isArray(j)?j:[j]}function re(j){return j[Math.floor(Math.random()*j.length)]}function he(j,Y,H){const G=z(j,Y),O=j.length,J=H.length;j.length=O+J;for(let ie=O-1;ie>=G;ie--)j[ie+J]=j[ie];for(let ie=0;ie<J;ie++)j[ie+G]=H[ie]}function X(j,Y,H,G){const O=z(j,Y);let J=j.splice(O,H);return J===void 0&&(J=[]),he(j,O,G),J}function z(j,Y){return Y<0?Math.max(Y+j.length,0):Math.min(Y,j.length)}var Q;(function(j){function Y(J){return J<0}j.isLessThan=Y;function H(J){return J<=0}j.isLessThanOrEqual=H;function G(J){return J>0}j.isGreaterThan=G;function O(J){return J===0}j.isNeitherLessOrGreaterThan=O,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function ee(j,Y){return(H,G)=>Y(j(H),j(G))}function le(...j){return(Y,H)=>{for(const G of j){const O=G(Y,H);if(!Q.isNeitherLessOrGreaterThan(O))return O}return Q.neitherLessOrGreaterThan}}const W=(j,Y)=>j-Y;e.$8b=W;const ce=(j,Y)=>(0,e.$8b)(j?1:0,Y?1:0);e.$9b=ce;function te(j){return(Y,H)=>-j(Y,H)}class h{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let H=this.c;for(;H<this.g.length&&Y(this.g[H]);)H++;const G=H===this.c?null:this.g.slice(this.c,H);return this.c=H,G}takeFromEndWhile(Y){let H=this.d;for(;H>=0&&Y(this.g[H]);)H--;const G=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,G}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const H=this.g.slice(this.c,this.c+Y);return this.c+=Y,H}}e.$$b=h;class F{static{this.empty=new F(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(H=>(Y(H),!0))}toArray(){const Y=[];return this.iterate(H=>(Y.push(H),!0)),Y}filter(Y){return new F(H=>this.iterate(G=>Y(G)?H(G):!0))}map(Y){return new F(H=>this.iterate(G=>H(Y(G))))}some(Y){let H=!1;return this.iterate(G=>(H=Y(G),!H)),H}findFirst(Y){let H;return this.iterate(G=>Y(G)?(H=G,!1):!0),H}findLast(Y){let H;return this.iterate(G=>(Y(G)&&(H=G),!0)),H}findLastMaxBy(Y){let H,G=!0;return this.iterate(O=>((G||Q.isGreaterThan(Y(O,H)))&&(G=!1,H=O),!0)),H}}e.$_b=F;class ne{constructor(Y){this.c=Y}static createSortPermutation(Y,H){const G=Array.from(Y.keys()).sort((O,J)=>H(Y[O],Y[J]));return new ne(G)}apply(Y){return Y.map((H,G)=>Y[this.c[G]])}inverse(){const Y=this.c.slice();for(let H=0;H<this.c.length;H++)Y[this.c[H]]=H;return new ne(Y)}}e.$ac=ne}),define(fe[42],de([0,1,7]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.$ed=C,e.$fd=D,e.$gd=R,e.$hd=P,e.$id=l;function L(r,y){if(!r)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}function C(r,y="Unreachable"){throw new Error(y)}function D(r,y="unexpected state"){if(!r)throw new w.$cb(`Assertion Failed: ${y}`)}function R(r){r||(0,w.$1)(new w.$cb("Soft Assertion Failed"))}function P(r){if(!r()){debugger;r(),(0,w.$1)(new w.$cb("Assertion Failed"))}}function l(r,y){let u=0;for(;u<r.length-1;){const E=r[u],a=r[u+1];if(!y(E,a))return!1;u++}return!0}}),define(fe[29],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=w;function w(L,C){const D=this;let R=!1,P;return function(){if(R)return P;if(R=!0,C)try{P=L.apply(D,arguments)}finally{C()}else P=L.apply(D,arguments);return P}}}),define(fe[43],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(L){function C(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=C;const D=Object.freeze([]);function R(){return D}L.empty=R;function*P(t){yield t}L.single=P;function l(t){return C(t)?t:P(t)}L.wrap=l;function r(t){return t||D}L.from=r;function*y(t){for(let o=t.length-1;o>=0;o--)yield t[o]}L.reverse=y;function u(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=u;function E(t){return t[Symbol.iterator]().next().value}L.first=E;function a(t,o){for(const k of t)if(o(k))return!0;return!1}L.some=a;function c(t,o){for(const k of t)if(o(k))return k}L.find=c;function*g(t,o){for(const k of t)o(k)&&(yield k)}L.filter=g;function*f(t,o){let k=0;for(const $ of t)yield o($,k++)}L.map=f;function*s(...t){for(const o of t)yield*o}L.concat=s;function n(t,o,k){let $=k;for(const S of t)$=o($,S);return $}L.reduce=n;function*m(t,o,k=t.length){for(o<0&&(o+=t.length),k<0?k+=t.length:k>t.length&&(k=t.length);o<k;o++)yield t[o]}L.slice=m;function p(t,o=Number.POSITIVE_INFINITY){const k=[];if(o===0)return[k,t];const $=t[Symbol.iterator]();for(let S=0;S<o;S++){const v=$.next();if(v.done)return[k,L.empty()];k.push(v.value)}return[k,{[Symbol.iterator](){return $}}]}L.consume=p;async function i(t){const o=[];for await(const k of t)o.push(k);return Promise.resolve(o)}L.asyncToArray=i})(w||(e.Iterable=w={}))}),define(fe[22],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class w{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=w}),define(fe[44],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class w{static{this.Undefined=new w(void 0)}constructor(D){this.element=D,this.next=w.Undefined,this.prev=w.Undefined}}class L{constructor(){this.a=w.Undefined,this.b=w.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===w.Undefined}clear(){let D=this.a;for(;D!==w.Undefined;){const R=D.next;D.prev=w.Undefined,D.next=w.Undefined,D=R}this.a=w.Undefined,this.b=w.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,R){const P=new w(D);if(this.a===w.Undefined)this.a=P,this.b=P;else if(R){const r=this.b;this.b=P,P.prev=r,r.next=P}else{const r=this.a;this.a=P,P.next=r,r.prev=P}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(P))}}shift(){if(this.a!==w.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==w.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==w.Undefined&&D.next!==w.Undefined){const R=D.prev;R.next=D.next,D.next.prev=R}else D.prev===w.Undefined&&D.next===w.Undefined?(this.a=w.Undefined,this.b=w.Undefined):D.next===w.Undefined?(this.b=this.b.prev,this.b.next=w.Undefined):D.prev===w.Undefined&&(this.a=this.a.next,this.a.prev=w.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==w.Undefined;)yield D.element,D=D.next}}e.$5c=L}),define(fe[25],de([0,1]),function(oe,e){"use strict";var w,L,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=D,e.$yc=R,e.$zc=P,e.$Ic=p;function D(i,t,o){let k=i.get(t);return k===void 0&&(k=o,i.set(t,k)),k}function R(i){const t=[];return i.forEach((o,k)=>{t.push(`${k} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}function P(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}class l{constructor(t,o){this.uri=t,this.value=o}}function r(i){return Array.isArray(i)}class y{static{this.c=t=>t.toString()}constructor(t,o){if(this[w]="ResourceMap",t instanceof y)this.d=new Map(t.d),this.e=o??y.c;else if(r(t)){this.d=new Map,this.e=o??y.c;for(const[k,$]of t)this.set(k,$)}else this.d=new Map,this.e=t??y.c}set(t,o){return this.d.set(this.e(t),new l(t,o)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[k,$]of this.d)t($.value,$.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=y;class u{constructor(t,o){this[L]="ResourceSet",!t||typeof t=="function"?this.c=new y(t):(this.c=new y(o),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,o){this.c.forEach((k,$)=>t.call(o,$,$,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=u;var E;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class a{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,o=0){const k=this.c.get(t);if(k)return o!==0&&this.m(k,o),k.value}set(t,o,k=0){let $=this.c.get(t);if($)$.value=o,k!==0&&this.m($,k);else{switch($={key:t,value:o,next:void 0,previous:void 0},k){case 0:this.k($);break;case 1:this.j($);break;case 2:this.k($);break;default:this.k($);break}this.c.set(t,$),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.c.get(t);if(o)return this.c.delete(t),this.l(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,o){const k=this.g;let $=this.d;for(;$;){if(o?t.bind(o)($.value,$.key,this):t($.value,$.key,this),this.g!==k)throw new Error("LinkedMap got modified during iteration.");$=$.next}}keys(){const t=this,o=this.g;let k=this.d;const $={[Symbol.iterator](){return $},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(k){const S={value:k.key,done:!1};return k=k.next,S}else return{value:void 0,done:!0}}};return $}values(){const t=this,o=this.g;let k=this.d;const $={[Symbol.iterator](){return $},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(k){const S={value:k.value,done:!1};return k=k.next,S}else return{value:void 0,done:!0}}};return $}entries(){const t=this,o=this.g;let k=this.d;const $={[Symbol.iterator](){return $},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(k){const S={value:[k.key,k.value],done:!1};return k=k.next,S}else return{value:void 0,done:!0}}};return $}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.d,k=this.size;for(;o&&k>t;)this.c.delete(o.key),o=o.next,k--;this.d=o,this.f=k,o&&(o.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.e,k=this.size;for(;o&&k>t;)this.c.delete(o.key),o=o.previous,k--;this.e=o,this.f=k,o&&(o.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const o=t.next,k=t.previous;if(!o||!k)throw new Error("Invalid list");o.previous=k,k.next=o}t.next=void 0,t.previous=void 0,this.g++}m(t,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this.d)return;const k=t.next,$=t.previous;t===this.e?($.next=void 0,this.e=$):(k.previous=$,$.next=k),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(o===2){if(t===this.e)return;const k=t.next,$=t.previous;t===this.d?(k.previous=void 0,this.d=k):(k.previous=$,$.next=k),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((o,k)=>{t.push([k,o])}),t}fromJSON(t){this.clear();for(const[o,k]of t)this.set(o,k)}}e.$Cc=a;class c extends a{constructor(t,o=1){super(),this.n=t,this.o=Math.min(Math.max(0,o),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends c{constructor(t,o=1){super(t,o)}q(t){this.h(t)}set(t,o){return super.set(t,o),this.p(),this}}e.$Dc=g;class f extends c{constructor(t,o=1){super(t,o)}q(t){this.i(t)}set(t,o){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,o),this}}e.$Ec=f;class s{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let o=this.c.get(t)||0;return o===0?!1:(o--,o===0?this.c.delete(t):this.c.set(t,o),!0)}has(t){return this.c.has(t)}}e.$Fc=s;class n{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[o,k]of t)this.set(o,k)}clear(){this.c.clear(),this.d.clear()}set(t,o){this.c.set(t,o),this.d.set(o,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const o=this.c.get(t);return o===void 0?!1:(this.c.delete(t),this.d.delete(o),!0)}forEach(t,o){this.c.forEach((k,$)=>{t.call(o,k,$,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=n;class m{constructor(){this.c=new Map}add(t,o){let k=this.c.get(t);k||(k=new Set,this.c.set(t,k)),k.add(o)}delete(t,o){const k=this.c.get(t);k&&(k.delete(o),k.size===0&&this.c.delete(t))}forEach(t,o){const k=this.c.get(t);k&&k.forEach(o)}get(t){const o=this.c.get(t);return o||new Set}}e.$Hc=m;function p(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[o,k]of i)if(!t.has(o)||t.get(o)!==k)return!1;for(const[o]of t)if(!i.has(o))return!1;return!0}}),define(fe[2],de([0,1,16,41,25,29,43]),function(oe,e,w,L,C,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=y,e.$Lc=u,e.$Mc=E,e.$Nc=g,e.$Oc=f,e.$Pc=s,e.$Qc=n,e.$Rc=m,e.$Sc=p,e.$3c=Z;const P=!1;let l=null;class r{constructor(){this.b=new Map}static{this.a=0}c(d){let N=this.b.get(d);return N||(N={parent:null,source:null,isSingleton:!1,value:d,idx:r.a++},this.b.set(d,N)),N}trackDisposable(d){const N=this.c(d);N.source||(N.source=new Error().stack)}setParent(d,N){const A=this.c(d);A.parent=N}markAsDisposed(d){this.b.delete(d)}markAsSingleton(d){this.c(d).isSingleton=!0}f(d,N){const A=N.get(d);if(A)return A;const M=d.parent?this.f(this.c(d.parent),N):d;return N.set(d,M),M}getTrackedDisposables(){const d=new Map;return[...this.b.entries()].filter(([,A])=>A.source!==null&&!this.f(A,d).isSingleton).flatMap(([A])=>A)}computeLeakingDisposables(d=10,N){let A;if(N)A=N;else{const x=new Map,re=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,x).isSingleton);if(re.length===0)return;const he=new Set(re.map(X=>X.value));if(A=re.filter(X=>!(X.parent&&he.has(X.parent))),A.length===0)throw new Error("There are cyclic diposable chains!")}if(!A)return;function M(x){function re(X,z){for(;X.length>0&&z.some(Q=>typeof Q=="string"?Q===X[0]:X[0].match(Q));)X.shift()}const he=x.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return re(he,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),he.reverse()}const q=new C.$Hc;for(const x of A){const re=M(x);for(let he=0;he<=re.length;he++)q.add(re.slice(0,he).join(`
`),x)}A.sort((0,w.$6b)(x=>x.idx,w.$8b));let _="",V=0;for(const x of A.slice(0,d)){V++;const re=M(x),he=[];for(let X=0;X<re.length;X++){let z=re[X];z=`(shared with ${q.get(re.slice(0,X+1).join(`
`)).size}/${A.length} leaks) at ${z}`;const ee=q.get(re.slice(0,X).join(`
`)),le=(0,L.$K)([...ee].map(W=>M(W)[X]),W=>W);delete le[re[X]];for(const[W,ce]of Object.entries(le))he.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${W}`);he.unshift(z)}_+=`


==================== Leaking disposable ${V}/${A.length}: ${x.value.constructor.name} ====================
${he.join(`
`)}
============================================================

`}return A.length>d&&(_+=`


... and ${A.length-d} more leaking disposables

`),{leaks:A,details:_}}}e.$Jc=r;function y(I){l=I}if(P){const I="__is_disposable_tracked__";y(new class{trackDisposable(d){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[I]||console.log(N)},3e3)}setParent(d,N){if(d&&d!==t.None)try{d[I]=!0}catch{}}markAsDisposed(d){if(d&&d!==t.None)try{d[I]=!0}catch{}}markAsSingleton(d){}})}function u(I){return l?.trackDisposable(I),I}function E(I){l?.markAsDisposed(I)}function a(I,d){l?.setParent(I,d)}function c(I,d){if(l)for(const N of I)l.setParent(N,d)}function g(I){return l?.markAsSingleton(I),I}function f(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function s(I){if(R.Iterable.is(I)){const d=[];for(const N of I)if(N)try{N.dispose()}catch(A){d.push(A)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function n(I){for(const d of I)f(d)&&d.dispose();return[]}function m(...I){const d=p(()=>s(I));return c(I,d),d}function p(I){const d=u({dispose:(0,D.$db)(()=>{E(d),I()})});return d}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,u(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return a(d,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(d),d}delete(d){if(d){if(d===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(d),d.dispose()}}deleteAndLeak(d){d&&this.f.has(d)&&(this.f.delete(d),a(d,null))}}e.$Tc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,u(this),a(this.q,this)}dispose(){E(this),this.q.dispose()}B(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(d)}}e.$Uc=t;class o{constructor(){this.b=!1,u(this)}get value(){return this.b?void 0:this.a}set value(d){this.b||d===this.a||(this.a?.dispose(),d&&a(d,this),this.a=d)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const d=this.a;return this.a=void 0,d&&a(d,null),d}}e.$Vc=o;class k{constructor(d){this.a=new o,this.b=!1,this.a.value=d}get value(){return this.a.value}set value(d){this.b||d===this.a.value||(this.a.value=d)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=k;class ${constructor(d){this.b=d,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=$;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,u(this)}set(d){let N=d;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,E(this))},this}}e.$Yc=S;class v{constructor(){this.a=new Map}acquire(d,...N){let A=this.a.get(d);A||(A={counter:0,object:this.b(d,...N)},this.a.set(d,A));const{object:M}=A,q=(0,D.$db)(()=>{--A.counter===0&&(this.c(d,A.object),this.a.delete(d))});return A.counter++,{object:M,dispose:q}}}e.$Zc=v;class b{constructor(d){this.a=d}async acquire(d,...N){const A=this.a.acquire(d,...N);try{return{object:await A.object,dispose:()=>A.dispose()}}catch(M){throw A.dispose(),M}}}e.$1c=b;class U{constructor(d){this.object=d}dispose(){}}e.$2c=U;function Z(I){const d=new i;try{I(d)}finally{d.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,u(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(d){return this.a.has(d)}get size(){return this.a.size}get(d){return this.a.get(d)}set(d,N,A=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),A||this.a.get(d)?.dispose(),this.a.set(d,N)}deleteAndDispose(d){this.a.get(d)?.dispose(),this.a.delete(d)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=T}),define(fe[45],de([0,1,25]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=void 0,e.$fm=C,e.$gm=R;const L=new w.$Dc(1e4);function C(r){return l(r,"NFC",L)}const D=new w.$Dc(1e4);function R(r){return l(r,"NFD",D)}const P=/[^\u0000-\u0080]/;function l(r,y,u){if(!r)return r;const E=u.get(r);if(E)return E;let a;return P.test(r)?a=r.normalize(y):a=r,u.set(r,a),a}e.$hm=function(){const r=/[\u0300-\u036f]/g;return function(y){return R(y).replace(r,"")}}()}),function(){function oe(C){const D=[];typeof C=="number"&&D.push("code/timeOrigin",C);function R(l){D.push(l,Date.now())}function P(){const l=[];for(let r=0;r<D.length;r+=2)l.push({name:D[r],startTime:D[r+1]});return l}return{mark:R,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const R of performance.getEntriesByType("mark"))D.push({name:R.name,startTime:Math.round(C+R.startTime)});return D}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=w(L))}(),define(fe[46],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const w=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(D){return new L(D)}constructor(D){this.c=w&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=L}),define(fe[4],de([0,1,7,29,2,44,46]),function(oe,e,w,L,C,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=a;const P=!1,l=!1,r=!1;var y;(function(M){M.None=()=>C.$Uc.None;function q(me){if(r){const{onDidAddListener:ge}=me,pe=g.create();let we=0;me.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),ge?.()}}}function _(me,ge){return W(me,()=>{},0,void 0,!0,void 0,ge)}M.defer=_;function V(me){return(ge,pe=null,we)=>{let ve=!1,Ce;return Ce=me(ke=>{if(!ve)return Ce?Ce.dispose():ve=!0,ge.call(pe,ke)},null,we),ve&&Ce.dispose(),Ce}}M.once=V;function x(me,ge,pe){return ee((we,ve=null,Ce)=>me(ke=>we.call(ve,ge(ke)),null,Ce),pe)}M.map=x;function re(me,ge,pe){return ee((we,ve=null,Ce)=>me(ke=>{ge(ke),we.call(ve,ke)},null,Ce),pe)}M.forEach=re;function he(me,ge,pe){return ee((we,ve=null,Ce)=>me(ke=>ge(ke)&&we.call(ve,ke),null,Ce),pe)}M.filter=he;function X(me){return me}M.signal=X;function z(...me){return(ge,pe=null,we)=>{const ve=(0,C.$Rc)(...me.map(Ce=>Ce(ke=>ge.call(pe,ke))));return le(ve,we)}}M.any=z;function Q(me,ge,pe,we){let ve=pe;return x(me,Ce=>(ve=ge(ve,Ce),ve),we)}M.reduce=Q;function ee(me,ge){let pe;const we={onWillAddFirstListener(){pe=me(ve.fire,ve)},onDidRemoveLastListener(){pe?.dispose()}};ge||q(we);const ve=new o(we);return ge?.add(ve),ve.event}function le(me,ge){return ge instanceof Array?ge.push(me):ge&&ge.add(me),me}function W(me,ge,pe=100,we=!1,ve=!1,Ce,ke){let Le,Se,je,Ae=0,Ue;const We={leakWarningThreshold:Ce,onWillAddFirstListener(){Le=me(Ge=>{Ae++,Se=ge(Se,Ge),we&&!je&&(Te.fire(Se),Se=void 0),Ue=()=>{const He=Se;Se=void 0,je=void 0,(!we||Ae>1)&&Te.fire(He),Ae=0},typeof pe=="number"?(clearTimeout(je),je=setTimeout(Ue,pe)):je===void 0&&(je=0,queueMicrotask(Ue))})},onWillRemoveListener(){ve&&Ae>0&&Ue?.()},onDidRemoveLastListener(){Ue=void 0,Le.dispose()}};ke||q(We);const Te=new o(We);return ke?.add(Te),Te.event}M.debounce=W;function ce(me,ge=0,pe){return M.debounce(me,(we,ve)=>we?(we.push(ve),we):[ve],ge,void 0,!0,void 0,pe)}M.accumulate=ce;function te(me,ge=(we,ve)=>we===ve,pe){let we=!0,ve;return he(me,Ce=>{const ke=we||!ge(Ce,ve);return we=!1,ve=Ce,ke},pe)}M.latch=te;function h(me,ge,pe){return[M.filter(me,ge,pe),M.filter(me,we=>!ge(we),pe)]}M.split=h;function F(me,ge=!1,pe=[],we){let ve=pe.slice(),Ce=me(Se=>{ve?ve.push(Se):Le.fire(Se)});we&&we.add(Ce);const ke=()=>{ve?.forEach(Se=>Le.fire(Se)),ve=null},Le=new o({onWillAddFirstListener(){Ce||(Ce=me(Se=>Le.fire(Se)),we&&we.add(Ce))},onDidAddFirstListener(){ve&&(ge?setTimeout(ke):ke())},onDidRemoveLastListener(){Ce&&Ce.dispose(),Ce=null}});return we&&we.add(Le),Le.event}M.buffer=F;function ne(me,ge){return(we,ve,Ce)=>{const ke=ge(new Y);return me(function(Le){const Se=ke.evaluate(Le);Se!==j&&we.call(ve,Se)},void 0,Ce)}}M.chain=ne;const j=Symbol("HaltChainable");class Y{constructor(){this.f=[]}map(ge){return this.f.push(ge),this}forEach(ge){return this.f.push(pe=>(ge(pe),pe)),this}filter(ge){return this.f.push(pe=>ge(pe)?pe:j),this}reduce(ge,pe){let we=pe;return this.f.push(ve=>(we=ge(we,ve),we)),this}latch(ge=(pe,we)=>pe===we){let pe=!0,we;return this.f.push(ve=>{const Ce=pe||!ge(ve,we);return pe=!1,we=ve,Ce?ve:j}),this}evaluate(ge){for(const pe of this.f)if(ge=pe(ge),ge===j)break;return ge}}function H(me,ge,pe=we=>we){const we=(...Le)=>ke.fire(pe(...Le)),ve=()=>me.on(ge,we),Ce=()=>me.removeListener(ge,we),ke=new o({onWillAddFirstListener:ve,onDidRemoveLastListener:Ce});return ke.event}M.fromNodeEventEmitter=H;function G(me,ge,pe=we=>we){const we=(...Le)=>ke.fire(pe(...Le)),ve=()=>me.addEventListener(ge,we),Ce=()=>me.removeEventListener(ge,we),ke=new o({onWillAddFirstListener:ve,onDidRemoveLastListener:Ce});return ke.event}M.fromDOMEventEmitter=G;function O(me){return new Promise(ge=>V(me)(ge))}M.toPromise=O;function J(me){const ge=new o;return me.then(pe=>{ge.fire(pe)},()=>{ge.fire(void 0)}).finally(()=>{ge.dispose()}),ge.event}M.fromPromise=J;function ie(me,ge,pe){return ge(pe),me(we=>ge(we))}M.runAndSubscribe=ie;class ae{constructor(ge,pe){this._observable=ge,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{ge.addObserver(this)},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};pe||q(we),this.emitter=new o(we),pe&&pe.add(this.emitter)}beginUpdate(ge){this.f++}handlePossibleChange(ge){}handleChange(ge,pe){this.g=!0}endUpdate(ge){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function be(me,ge){return new ae(me,ge).emitter.event}M.fromObservable=be;function Pe(me){return(ge,pe,we)=>{let ve=0,Ce=!1;const ke={beginUpdate(){ve++},endUpdate(){ve--,ve===0&&(me.reportChanges(),Ce&&(Ce=!1,ge.call(pe)))},handlePossibleChange(){},handleChange(){Ce=!0}};me.addObserver(ke),me.reportChanges();const Le={dispose(){me.removeObserver(ke)}};return we instanceof C.$Tc?we.add(Le):Array.isArray(we)&&we.push(Le),Le}}M.fromObservableLight=Pe})(y||(e.Event=y={}));class u{static{this.all=new Set}static{this.f=0}constructor(q){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${q}_${u.f++}`,u.all.add(this)}start(q){this.g=new R.$be,this.listenerCount=q}stop(){if(this.g){const q=this.g.elapsed();this.durations.push(q),this.elapsedOverall+=q,this.invocationCount+=1,this.g=void 0}}}e.$de=u;let E=-1;function a(M){const q=E;return E=M,{dispose(){E=q}}}class c{constructor(q,_,V=Math.random().toString(18).slice(2,5)){this.h=q,this.threshold=_,this.name=V,this.g=0}dispose(){this.f?.clear()}check(q,_){const V=this.threshold;if(V<=0||_<V)return;this.f||(this.f=new Map);const x=this.f.get(q.value)||0;if(this.f.set(q.value,x+1),this.g-=1,this.g<=0){this.g=V*.5;const[re,he]=this.getMostFrequentStack(),X=`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${he}):`;console.warn(X),console.warn(re);const z=new f(X,re);this.h(z)}return()=>{const re=this.f.get(q.value)||0;this.f.set(q.value,re-1)}}getMostFrequentStack(){if(!this.f)return;let q,_=0;for(const[V,x]of this.f)(!q||_<x)&&(q=[V,x],_=x);return q}}class g{static create(){const q=new Error;return new g(q.stack??"")}constructor(q){this.value=q}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f extends Error{constructor(q,_){super(q),this.name="ListenerLeakError",this.stack=_}}e.$fe=f;class s extends Error{constructor(q,_){super(q),this.name="ListenerRefusalError",this.stack=_}}e.$ge=s;let n=0;class m{constructor(q){this.value=q,this.id=n++}}const p=2,i=(M,q)=>{if(M instanceof m)q(M);else for(let _=0;_<M.length;_++){const V=M[_];V&&q(V)}},t=P?new FinalizationRegistry(M=>{typeof M=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(M))}):void 0;class o{constructor(q){this.w=0,this.f=q,this.g=E>0||this.f?.leakWarningThreshold?new c(q?.onListenerError??w.$1,this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new u(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(l){const q=this.t;queueMicrotask(()=>{i(q,_=>_.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(q,_,V)=>{if(this.g&&this.w>this.g.threshold*3){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w}/${this.g.threshold})`;console.warn(z);const Q=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new s(`${z}. HINT: Stack shows most frequent listener (${Q[1]}-times)`,Q[0]);return(this.f?.onListenerError||w.$1)(ee),C.$Uc.None}if(this.m)return C.$Uc.None;_&&(q=q.bind(_));const x=new m(q);let re,he;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(x.stack=g.create(),re=this.g.check(x.stack,this.w+1)),l&&(x.stack=he??g.create()),this.t?this.t instanceof m?(this.u??=new $,this.t=[this.t,x]):this.t.push(x):(this.f?.onWillAddFirstListener?.(this),this.t=x,this.f?.onDidAddFirstListener?.(this)),this.w++;const X=(0,C.$Sc)(()=>{t?.unregister(X),re?.(),this.x(x)});if(V instanceof C.$Tc?V.add(X):Array.isArray(V)&&V.push(X),t){const z=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(X,z,X)}return X},this.q}x(q){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const _=this.t,V=_.indexOf(q);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,_[V]=void 0;const x=this.u.current===this;if(this.w*p<=_.length){let re=0;for(let he=0;he<_.length;he++)_[he]?_[re++]=_[he]:x&&(this.u.end--,re<this.u.i&&this.u.i--);_.length=re}}y(q,_){if(!q)return;const V=this.f?.onListenerError||w.$1;if(!V){q.value(_);return}try{q.value(_)}catch(x){V(x)}}z(q){const _=q.current.t;for(;q.i<q.end;)this.y(_[q.i++],q.value);q.reset()}fire(q){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,q);else{const _=this.u;_.enqueue(this,q,this.t.length),this.z(_)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=o;const k=()=>new $;e.$ie=k;class ${constructor(){this.i=-1,this.end=0}enqueue(q,_,V){this.i=0,this.end=V,this.current=q,this.value=_}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends o{async fireAsync(q,_,V){if(this.t)for(this.h||(this.h=new D.$5c),i(this.t,x=>this.h.push([x.value,q]));this.h.size>0&&!_.isCancellationRequested;){const[x,re]=this.h.shift(),he=[],X={...re,token:_,waitUntil:z=>{if(Object.isFrozen(he))throw new Error("waitUntil can NOT be called asynchronous");V&&(z=V(z,x)),he.push(z)}};try{x(X)}catch(z){(0,w.$1)(z);continue}Object.freeze(he),await Promise.allSettled(he).then(z=>{for(const Q of z)Q.status==="rejected"&&(0,w.$1)(Q.reason)})}}}e.$je=S;class v extends o{get isPaused(){return this.h!==0}constructor(q){super(q),this.h=0,this.s=new D.$5c,this.A=q?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const q=Array.from(this.s);this.s.clear(),super.fire(this.A(q))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(q){this.w&&(this.h!==0?this.s.push(q):super.fire(q))}}e.$ke=v;class b extends v{constructor(q){super(q),this.k=q.delay??100}fire(q){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(q)}}e.$le=b;class U extends o{constructor(q){super(q),this.h=[],this.k=q?.merge}fire(q){this.hasListeners()&&(this.h.push(q),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(_=>super.fire(_)),this.h=[]}))}}e.$me=U;class Z{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(q){const _={event:q,listener:null};this.h.push(_),this.g&&this.m(_);const V=()=>{this.g&&this.o(_);const x=this.h.indexOf(_);this.h.splice(x,1)};return(0,C.$Sc)((0,L.$db)(V))}j(){this.g=!0,this.h.forEach(q=>this.m(q))}k(){this.g=!1,this.h.forEach(q=>this.o(q))}m(q){q.listener=q.event(_=>this.f.fire(_))}o(q){q.listener?.dispose(),q.listener=null}dispose(){this.f.dispose();for(const q of this.h)q.listener?.dispose();this.h=[]}}e.$ne=Z;class T{constructor(q,_,V,x){this.f=new C.$Tc;const re=this.f.add(new Z),he=this.f.add(new C.$4c);function X(z){he.set(z,re.add(x(z)))}for(const z of q)X(z);this.f.add(_(z=>{X(z)})),this.f.add(V(z=>{he.deleteAndDispose(z)})),this.event=re.event}dispose(){this.f.dispose()}}e.$oe=T;class I{constructor(){this.f=[]}wrapEvent(q,_,V){return(x,re,he)=>q(X=>{const z=this.f[this.f.length-1];if(!_){z?z.buffers.push(()=>x.call(re,X)):x.call(re,X);return}const Q=z;if(!Q){x.call(re,_(V,X));return}Q.items??=[],Q.items.push(X),Q.buffers.length===0&&z.buffers.push(()=>{Q.reducedResult??=V?Q.items.reduce(_,V):Q.items.reduce(_),x.call(re,Q.reducedResult)})},void 0,he)}bufferEvents(q){const _={buffers:new Array};this.f.push(_);const V=q();return this.f.pop(),_.buffers.forEach(x=>x()),V}}e.$pe=I;class d{constructor(){this.f=!1,this.g=y.None,this.h=C.$Uc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(q){this.g=q,this.f&&(this.h.dispose(),this.h=q(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=d;class N{static const(q){return new A(q)}constructor(q){this.g=q,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(q){q!==this.g&&(this.g=q,this.f.fire(void 0))}}e.$re=N;class A{constructor(q){this.value=q,this.onDidChange=y.None}}}),define(fe[17],de([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=P;const L=Object.freeze(function(l,r){const y=setTimeout(l.bind(r),0);return{dispose(){clearTimeout(y)}}});var C;(function(l){function r(y){return y===l.None||y===l.Cancelled||y instanceof D?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}l.isCancellationToken=r,l.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),l.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(C||(e.CancellationToken=C={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new w.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=C.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=C.None}}e.$se=R;function P(l){const r=new R;return l.add({dispose(){r.cancel()}}),r.token}}),define(fe[47],de([0,1,17]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=C;class L{constructor(l){this.b=l,this.a=null}get(){if(this.a)return this.a;const l=new w.$se,r=this.b(l.token);return this.a={promise:r,dispose:()=>{this.a=null,l.cancel(),l.dispose()}},this.a}}e.$5e=L;function C(P){return P}class D{constructor(l,r){this.a=void 0,this.b=void 0,typeof l=="function"?(this.c=l,this.d=C):(this.c=r,this.d=l.getCacheKey)}get(l){const r=this.d(l);return this.b!==r&&(this.b=r,this.a=this.c(l)),this.a}}e.$7e=D;class R{get cachedValues(){return this.a}constructor(l,r){this.a=new Map,this.b=new Map,typeof l=="function"?(this.c=l,this.d=C):(this.c=r,this.d=l.getCacheKey)}get(l){const r=this.d(l);if(this.b.has(r))return this.b.get(r);const y=this.c(l);return this.a.set(l,y),this.b.set(r,y),y}}e.$8e=R}),define(fe[48],de([0,1,7,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=C,e.$ve=D,e.$we=R,e.$xe=P,e.$ye=r,e.$ze=y,e.$Ae=u,e.$Be=E,e.$Ce=a,e.$De=c,e.$Ee=g,e.$Fe=f,e.$Ge=s,e.$He=n,e.$Ie=m;function C(p){const i=p;return i?typeof i.read=="function":!1}function D(p){const i=p;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function R(p){const i=p;return i?D(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function P(p,i){return new l(p,i)}class l{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,w.$1)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let o;switch(i){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const k=o.indexOf(t);k>=0&&o.splice(k,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(p,i){const t=[];let o;for(;(o=p.read())!==null;)t.push(o);return i(t)}function y(p,i,t){const o=[];let k;for(;(k=p.read())!==null&&o.length<t;)o.push(k);return k===null&&o.length>0?i(o):{read:()=>{if(o.length>0)return o.shift();if(typeof k<"u"){const $=k;return k=void 0,$}return p.read()}}}function u(p,i){return new Promise((t,o)=>{const k=[];E(p,{onData:$=>{i&&k.push($)},onError:$=>{i?o($):t(void 0)},onEnd:()=>{t(i?i(k):void 0)}})})}function E(p,i,t){p.on("error",o=>{t?.isCancellationRequested||i.onError(o)}),p.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),p.on("data",o=>{t?.isCancellationRequested||i.onData(o)})}function a(p,i){return new Promise((t,o)=>{const k=new L.$Tc,$=[],S=U=>{if($.push(U),$.length>i)return k.dispose(),p.pause(),t({stream:p,buffer:$,ended:!1})},v=U=>(k.dispose(),o(U)),b=()=>(k.dispose(),t({stream:p,buffer:$,ended:!0}));k.add((0,L.$Sc)(()=>p.removeListener("error",v))),p.on("error",v),k.add((0,L.$Sc)(()=>p.removeListener("end",b))),p.on("end",b),k.add((0,L.$Sc)(()=>p.removeListener("data",S))),p.on("data",S)})}function c(p,i){const t=P(i);return t.end(p),t}function g(){const p=P(()=>{throw new Error("not supported")});return p.end(),p}function f(p){let i=!1;return{read:()=>i?null:(i=!0,p)}}function s(p,i,t){const o=P(t);return E(p,{onData:k=>o.write(i.data(k)),onError:k=>o.error(i.error?i.error(k):k),onEnd:()=>o.end()}),o}function n(p,i,t){let o=!1;return{read:()=>{const k=i.read();return o?k:(o=!0,k!==null?t([p,k]):p)}}}function m(p,i,t){let o=!1;const k=P(t);return E(i,{onData:$=>o?k.write($):(o=!0,k.write(t([p,$]))),onError:$=>k.error($),onEnd:()=>{o||(o=!0,k.write(p)),k.end()}}),k}}),define(fe[18],de([0,1,22,48]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=r,e.$Le=y,e.$Me=u,e.$Ne=E,e.$Oe=a,e.$Pe=c,e.$Qe=g,e.$Re=f,e.$Se=s,e.$Te=n,e.$Ue=m,e.$Ve=p,e.$We=i,e.$Xe=t,e.$Ye=o,e.$Ze=k,e.$1e=$,e.$2e=S,e.$3e=v,e.$4e=Z;const C=typeof Buffer<"u",D=new w.$V(()=>new Uint8Array(256));let R,P;class l{static alloc(I){return C?new l(Buffer.allocUnsafe(I)):new l(new Uint8Array(I))}static wrap(I){return C&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new l(I)}static fromString(I,d){return!(d?.dontUseNodeBuffer||!1)&&C?new l(Buffer.from(I)):(R||(R=new TextEncoder),new l(R.encode(I)))}static fromByteArray(I){const d=l.alloc(I.length);for(let N=0,A=I.length;N<A;N++)d.buffer[N]=I[N];return d}static concat(I,d){if(typeof d>"u"){d=0;for(let M=0,q=I.length;M<q;M++)d+=I[M].byteLength}const N=l.alloc(d);let A=0;for(let M=0,q=I.length;M<q;M++){const _=I[M];N.set(_,A),A+=_.byteLength}return N}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=l.alloc(this.byteLength);return I.set(this),I}toString(){return C?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(I,d){return new l(this.buffer.subarray(I,d))}set(I,d){if(I instanceof l)this.buffer.set(I.buffer,d);else if(I instanceof Uint8Array)this.buffer.set(I,d);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),d);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return E(this.buffer,I)}writeUInt32BE(I,d){a(this.buffer,I,d)}readUInt32LE(I){return c(this.buffer,I)}writeUInt32LE(I,d){g(this.buffer,I,d)}readUInt8(I){return f(this.buffer,I)}writeUInt8(I,d){s(this.buffer,I,d)}indexOf(I,d=0){return r(this.buffer,I instanceof l?I.buffer:I,d)}}e.$Je=l;function r(T,I,d=0){const N=I.byteLength,A=T.byteLength;if(N===0)return 0;if(N===1)return T.indexOf(I[0]);if(N>A-d)return-1;const M=D.value;M.fill(I.length);for(let x=0;x<I.length;x++)M[I[x]]=I.length-x-1;let q=d+I.length-1,_=q,V=-1;for(;q<A;)if(T[q]===I[_]){if(_===0){V=q;break}q--,_--}else q+=Math.max(I.length-_,M[T[q]]),_=I.length-1;return V}function y(T,I){return T[I+0]<<0>>>0|T[I+1]<<8>>>0}function u(T,I,d){T[d+0]=I&255,I=I>>>8,T[d+1]=I&255}function E(T,I){return T[I]*2**24+T[I+1]*2**16+T[I+2]*2**8+T[I+3]}function a(T,I,d){T[d+3]=I,I=I>>>8,T[d+2]=I,I=I>>>8,T[d+1]=I,I=I>>>8,T[d]=I}function c(T,I){return T[I+0]<<0>>>0|T[I+1]<<8>>>0|T[I+2]<<16>>>0|T[I+3]<<24>>>0}function g(T,I,d){T[d+0]=I&255,I=I>>>8,T[d+1]=I&255,I=I>>>8,T[d+2]=I&255,I=I>>>8,T[d+3]=I&255}function f(T,I){return T[I]}function s(T,I,d){T[d]=I}function n(T){return L.$ye(T,I=>l.concat(I))}function m(T){return L.$Fe(T)}function p(T){return L.$Ae(T,I=>l.concat(I))}async function i(T){return T.ended?l.concat(T.buffer):l.concat([...T.buffer,await p(T.stream)])}function t(T){return L.$De(T,I=>l.concat(I))}function o(T){return L.$Ge(T,{data:I=>typeof I=="string"?l.fromString(I):l.wrap(I)},I=>l.concat(I))}function k(T){return L.$xe(I=>l.concat(I),T)}function $(T,I){return L.$He(T,I,d=>l.concat(d))}function S(T,I){return L.$Ie(T,I,d=>l.concat(d))}function v(T){let I=0,d=0,N=0;const A=new Uint8Array(Math.floor(T.length/4*3)),M=_=>{switch(d){case 3:A[N++]=I|_,d=0;break;case 2:A[N++]=I|_>>>2,I=_<<6,d=3;break;case 1:A[N++]=I|_>>>4,I=_<<4,d=2;break;default:I=_<<2,d=1}};for(let _=0;_<T.length;_++){const V=T.charCodeAt(_);if(V>=65&&V<=90)M(V-65);else if(V>=97&&V<=122)M(V-97+26);else if(V>=48&&V<=57)M(V-48+52);else if(V===43||V===45)M(62);else if(V===47||V===95)M(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${T[_]}`)}}const q=N;for(;d>0;)M(0);return l.wrap(A).slice(0,q)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function Z({buffer:T},I=!0,d=!1){const N=d?U:b;let A="";const M=T.byteLength%3;let q=0;for(;q<T.byteLength-M;q+=3){const _=T[q+0],V=T[q+1],x=T[q+2];A+=N[_>>>2],A+=N[(_<<4|V>>>4)&63],A+=N[(V<<2|x>>>6)&63],A+=N[x&63]}if(M===1){const _=T[q+0];A+=N[_>>>2],A+=N[_<<4&63],I&&(A+="==")}else if(M===2){const _=T[q+0],V=T[q+1];A+=N[_>>>2],A+=N[(_<<4|V>>>4)&63],A+=N[V<<2&63],I&&(A+="=")}return A}}),define(fe[9],de([0,1,47,22]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=C,e.$_e=R,e.$af=l,e.$bf=r,e.$cf=y,e.$df=u,e.$ef=E,e.$ff=a,e.$gf=c,e.$hf=g,e.$if=f,e.$jf=s,e.$kf=n,e.$lf=m,e.$mf=p,e.$nf=i,e.$of=t,e.$pf=o,e.$qf=k,e.$rf=$,e.$sf=S,e.$tf=v,e.$uf=b,e.$vf=U,e.$wf=Z,e.$xf=T,e.$yf=I,e.$zf=d,e.$Af=N,e.$Bf=A,e.$Cf=M,e.$Df=q,e.$Ef=_,e.$Ff=V,e.$Gf=x,e.$Hf=re,e.$If=he,e.$Lf=ee,e.$Mf=le,e.$Nf=W,e.$Of=ce,e.$Pf=F,e.$Qf=j,e.$Sf=Y,e.$Tf=H,e.$Uf=G,e.$Vf=O,e.$Wf=ie,e.$Xf=ae,e.$Yf=Pe,e.$1f=me,e.$2f=ge,e.$3f=pe,e.$4f=we,e.$5f=ve,e.$6f=Ce,e.$7f=ke,e.$8f=Le,e.$9f=We;function C(B){return!B||typeof B!="string"?!0:B.trim().length===0}const D=/{(\d+)}/g;function R(B,...K){return K.length===0?B:B.replace(D,function(se,ue){const ye=parseInt(ue,10);return isNaN(ye)||ye<0||ye>=K.length?se:K[ye]})}const P=/{([^}]+)}/g;function l(B,K){return Object.keys(K).length===0?B:B.replace(P,(se,ue)=>K[ue]??se)}function r(B){return B.replace(/[<>"'&]/g,K=>{switch(K){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return K})}function y(B){return B.replace(/[<>&]/g,function(K){switch(K){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return K}})}function u(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function E(B,K){let se=0,ue=B.indexOf(K);for(;ue!==-1;)se++,ue=B.indexOf(K,ue+K.length);return se}function a(B,K,se="\u2026"){return B.length<=K?B:`${B.substr(0,K)}${se}`}function c(B,K,se="\u2026"){if(B.length<=K)return B;const ue=Math.ceil(K/2)-se.length/2,ye=Math.floor(K/2)-se.length/2;return`${B.substr(0,ue)}${se}${B.substr(B.length-ye)}`}function g(B,K=" "){const se=f(B,K);return s(se,K)}function f(B,K){if(!B||!K)return B;const se=K.length;if(se===0||B.length===0)return B;let ue=0;for(;B.indexOf(K,ue)===ue;)ue=ue+se;return B.substring(ue)}function s(B,K){if(!B||!K)return B;const se=K.length,ue=B.length;if(se===0||ue===0)return B;let ye=ue,Ee=-1;for(;Ee=B.lastIndexOf(K,ye-1),!(Ee===-1||Ee+se!==ye);){if(Ee===0)return"";ye=Ee}return B.substring(0,ye)}function n(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function m(B){return B.replace(/\*/g,"")}function p(B,K,se={}){if(!B)throw new Error("Cannot create regex from empty string");K||(B=u(B)),se.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let ue="";return se.global&&(ue+="g"),se.matchCase||(ue+="i"),se.multiline&&(ue+="m"),se.unicode&&(ue+="u"),new RegExp(B,ue)}function i(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}function t(B){return B.split(/\r\n|\r|\n/)}function o(B){const K=[],se=B.split(/(\r\n|\r|\n)/);for(let ue=0;ue<Math.ceil(se.length/2);ue++)K.push(se[2*ue]+(se[2*ue+1]??""));return K}function k(B){for(let K=0,se=B.length;K<se;K++){const ue=B.charCodeAt(K);if(ue!==32&&ue!==9)return K}return-1}function $(B,K=0,se=B.length){for(let ue=K;ue<se;ue++){const ye=B.charCodeAt(ue);if(ye!==32&&ye!==9)return B.substring(K,ue)}return B.substring(K,se)}function S(B,K=B.length-1){for(let se=K;se>=0;se--){const ue=B.charCodeAt(se);if(ue!==32&&ue!==9)return se}return-1}function v(B,K,se){const ue=[];let ye=0;for(const Ee of B.matchAll(K)){if(ue.push(B.slice(ye,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ye=Ee.index+Ee[0].length,ue.push(se(Ee[0],...Ee.slice(1),Ee.index,B,Ee.groups))}return ue.push(B.slice(ye)),Promise.all(ue).then(Ee=>Ee.join(""))}function b(B,K){return B<K?-1:B>K?1:0}function U(B,K,se=0,ue=B.length,ye=0,Ee=K.length){for(;se<ue&&ye<Ee;se++,ye++){const Ie=B.charCodeAt(se),Oe=K.charCodeAt(ye);if(Ie<Oe)return-1;if(Ie>Oe)return 1}const Me=ue-se,Ne=Ee-ye;return Me<Ne?-1:Me>Ne?1:0}function Z(B,K){return T(B,K,0,B.length,0,K.length)}function T(B,K,se=0,ue=B.length,ye=0,Ee=K.length){for(;se<ue&&ye<Ee;se++,ye++){let Ie=B.charCodeAt(se),Oe=K.charCodeAt(ye);if(Ie===Oe)continue;if(Ie>=128||Oe>=128)return U(B.toLowerCase(),K.toLowerCase(),se,ue,ye,Ee);d(Ie)&&(Ie-=32),d(Oe)&&(Oe-=32);const De=Ie-Oe;if(De!==0)return De}const Me=ue-se,Ne=Ee-ye;return Me<Ne?-1:Me>Ne?1:0}function I(B){return B>=48&&B<=57}function d(B){return B>=97&&B<=122}function N(B){return B>=65&&B<=90}function A(B,K){return B.length===K.length&&T(B,K)===0}function M(B,K){const se=K.length;return K.length>B.length?!1:T(B,K,0,se)===0}function q(B,K){const se=Math.min(B.length,K.length);let ue;for(ue=0;ue<se;ue++)if(B.charCodeAt(ue)!==K.charCodeAt(ue))return ue;return se}function _(B,K){const se=Math.min(B.length,K.length);let ue;const ye=B.length-1,Ee=K.length-1;for(ue=0;ue<se;ue++)if(B.charCodeAt(ye-ue)!==K.charCodeAt(Ee-ue))return ue;return se}function V(B){return 55296<=B&&B<=56319}function x(B){return 56320<=B&&B<=57343}function re(B,K){return(B-55296<<10)+(K-56320)+65536}function he(B,K,se){const ue=B.charCodeAt(se);if(V(ue)&&se+1<K){const ye=B.charCodeAt(se+1);if(x(ye))return re(ue,ye)}return ue}function X(B,K){const se=B.charCodeAt(K-1);if(x(se)&&K>1){const ue=B.charCodeAt(K-2);if(V(ue))return re(ue,se)}return se}class z{get offset(){return this.e}constructor(K,se=0){this.c=K,this.d=K.length,this.e=se}setOffset(K){this.e=K}prevCodePoint(){const K=X(this.c,this.e);return this.e-=K>=65536?2:1,K}nextCodePoint(){const K=he(this.c,this.d,this.e);return this.e+=K>=65536?2:1,K}eol(){return this.e>=this.d}}e.$Jf=z;class Q{get offset(){return this.c.offset}constructor(K,se=0){this.c=new z(K,se)}nextGraphemeLength(){const K=Ae.getInstance(),se=this.c,ue=se.offset;let ye=K.getGraphemeBreakType(se.nextCodePoint());for(;!se.eol();){const Ee=se.offset,Me=K.getGraphemeBreakType(se.nextCodePoint());if(Se(ye,Me)){se.setOffset(Ee);break}ye=Me}return se.offset-ue}prevGraphemeLength(){const K=Ae.getInstance(),se=this.c,ue=se.offset;let ye=K.getGraphemeBreakType(se.prevCodePoint());for(;se.offset>0;){const Ee=se.offset,Me=K.getGraphemeBreakType(se.prevCodePoint());if(Se(Me,ye)){se.setOffset(Ee);break}ye=Me}return ue-se.offset}eol(){return this.c.eol()}}e.$Kf=Q;function ee(B,K){return new Q(B,K).nextGraphemeLength()}function le(B,K){return new Q(B,K).prevGraphemeLength()}function W(B,K){K>0&&x(B.charCodeAt(K))&&K--;const se=K+ee(B,K);return[se-le(B,se),se]}function ce(B){const K=new Q(B);let se=0;for(;!K.eol();)se++,K.nextGraphemeLength();return se}let te;function h(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(B){return te||(te=h()),te.test(B)}const ne=/^[\t\n\r\x20-\x7E]*$/;function j(B){return ne.test(B)}e.$Rf=/[\u2028\u2029]/;function Y(B){return e.$Rf.test(B)}function H(B){return B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}function G(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129008||B>=129280&&B<=129535||B>=129648&&B<=129782}function O(B,K,se=""){const ue=B.trimStart();if(ue.length<K)return ue;const ye=/\b/g;let Ee=0;for(;ye.test(ue)&&!(ue.length-ye.lastIndex<K);)Ee=ye.lastIndex,ye.lastIndex+=1;return Ee===0?ue:se+ue.substring(Ee).trimStart()}const J=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ie(B){let K=0;for(const se of B.matchAll(J))K!==se.index&&(yield{isCode:!1,str:B.substring(K,se.index)}),yield{isCode:!0,str:se[0]},K=se.index+se[0].length;K!==B.length&&(yield{isCode:!1,str:B.substring(K)})}function ae(B){return B&&(B=B.replace(J,"")),B}const be=/\\\[.*?\\\]/g;function Pe(B){return ae(B).replace(be,"")}e.$Zf="\uFEFF";function me(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}function ge(B){return me(B)?B.substr(1):B}function pe(B,K){if(!B||!K||B.length<K.length)return!1;const se=K.length,ue=B.toLowerCase();let ye=0,Ee=-1;for(;ye<se;){const Me=ue.indexOf(K[ye],Ee+1);if(Me<0)return!1;Ee=Me,ye++}return!0}function we(B,K=!1){return B?(K&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}function ve(B){return B.charAt(0).toUpperCase()+B.slice(1)}function Ce(B,K=1){if(K===0)return"";let se=-1;do se=B.indexOf(`
`,se+1),K--;while(K>0&&se>=0);return se===-1?B:(B[se-1]==="\r"&&se--,B.substr(0,se))}function ke(B){return B=B%(2*26),B<26?String.fromCharCode(97+B):String.fromCharCode(65+B-26)}function Le(B){return Ae.getInstance().getGraphemeBreakType(B)}function Se(B,K){return B===0?K!==5&&K!==7:B===2&&K===3?!1:B===4||B===2||B===3||K===4||K===2||K===3?!0:!(B===8&&(K===8||K===9||K===11||K===12)||(B===11||B===9)&&(K===9||K===10)||(B===12||B===10)&&K===10||K===5||K===13||K===7||B===1||B===13&&K===14||B===6&&K===6)}var je;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=Ue()}getGraphemeBreakType(K){if(K<32)return K===10?3:K===13?2:4;if(K<127)return 0;const se=this.d,ue=se.length/3;let ye=1;for(;ye<=ue;)if(K<se[3*ye])ye=2*ye;else if(K>se[3*ye+1])ye=2*ye+1;else return se[3*ye+2];return 0}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(B,K){if(B===0)return 0;const se=Te(B,K);if(se!==void 0)return se;const ue=new z(K,B);return ue.prevCodePoint(),ue.offset}function Te(B,K){const se=new z(K,B);let ue=se.prevCodePoint();for(;Ge(ue)||ue===65039||ue===8419;){if(se.offset===0)return;ue=se.prevCodePoint()}if(!G(ue))return;let ye=se.offset;return ye>0&&se.prevCodePoint()===8205&&(ye=se.offset),ye}function Ge(B){return 127995<=B&&B<=127999}var He;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.$0f="\xA0";class Be{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new w.$7e({getCacheKey:JSON.stringify},K=>{function se(De){const ze=new Map;for(let Re=0;Re<De.length;Re+=2)ze.set(De[Re],De[Re+1]);return ze}function ue(De,ze){const Re=new Map(De);for(const[Ve,Xe]of ze)Re.set(Ve,Xe);return Re}function ye(De,ze){if(!De)return ze;const Re=new Map;for(const[Ve,Xe]of De)ze.has(Ve)&&Re.set(Ve,Xe);return Re}const Ee=this.c.value;let Me=K.filter(De=>!De.startsWith("_")&&De in Ee);Me.length===0&&(Me=["_default"]);let Ne;for(const De of Me){const ze=se(Ee[De]);Ne=ye(Ne,ze)}const Ie=se(Ee._common),Oe=ue(Ie,Ne);return new Be(Oe)})}static getInstance(K){return Be.d.get(Array.from(K))}static{this.e=new L.$V(()=>Object.keys(Be.c.value).filter(K=>!K.startsWith("_")))}static getLocales(){return Be.e.value}constructor(K){this.f=K}isAmbiguous(K){return this.f.has(K)}containsAmbiguousCharacter(K){for(let se=0;se<K.length;se++){const ue=K.codePointAt(se);if(typeof ue=="number"&&this.isAmbiguous(ue))return!0}return!1}getPrimaryConfusable(K){return this.f.get(K)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=Be;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(K){return qe.e().has(K)}static containsInvisibleCharacter(K){for(let se=0;se<K.length;se++){const ue=K.codePointAt(se);if(typeof ue=="number"&&qe.isInvisibleCharacter(ue))return!0}return!1}static get codePoints(){return qe.e()}}e.$_f=qe}),define(fe[49],de([0,1,9]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=L,e.$pj=C,e.$qj=D,e.$rj=P,e.$tj=g;function L(s){return C(s,0)}function C(s,n){switch(typeof s){case"object":return s===null?D(349,n):Array.isArray(s)?l(s,n):r(s,n);case"string":return P(s,n);case"boolean":return R(s,n);case"number":return D(s,n);case"undefined":return D(937,n);default:return D(617,n)}}function D(s,n){return(n<<5)-n+s|0}function R(s,n){return D(s?433:863,n)}function P(s,n){n=D(149417,n);for(let m=0,p=s.length;m<p;m++)n=D(s.charCodeAt(m),n);return n}function l(s,n){return n=D(104579,n),s.reduce((m,p)=>C(p,m),n)}function r(s,n){return n=D(181387,n),Object.keys(s).sort().reduce((m,p)=>(m=P(p,m),C(s[p],m)),n)}class y{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=C(n,this.g),this.g}}e.$sj=y;var u;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function E(s,n,m=32){const p=m-n,i=~((1<<p)-1);return(s<<n|(i&s)>>>p)>>>0}function a(s,n=0,m=s.byteLength,p=0){for(let i=0;i<m;i++)s[n+i]=p}function c(s,n,m="0"){for(;s.length<n;)s=m+s;return s}function g(s,n=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(m=>m.toString(16).padStart(2,"0")).join(""):c((s>>>0).toString(16),n/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const m=n.length;if(m===0)return;const p=this.p;let i=this.r,t=this.u,o,k;for(t!==0?(o=t,k=-1,t=0):(o=n.charCodeAt(0),k=0);;){let $=o;if(w.$Ff(o))if(k+1<m){const S=n.charCodeAt(k+1);w.$Gf(S)?(k++,$=w.$Hf(o,S)):$=65533}else{t=o;break}else w.$Gf(o)&&($=65533);if(i=this.w(p,i,$),k++,k<m)o=n.charCodeAt(k);else break}this.r=i,this.u=t}w(n,m,p){return p<128?n[m++]=p:p<2048?(n[m++]=192|(p&1984)>>>6,n[m++]=128|(p&63)>>>0):p<65536?(n[m++]=224|(p&61440)>>>12,n[m++]=128|(p&4032)>>>6,n[m++]=128|(p&63)>>>0):(n[m++]=240|(p&1835008)>>>18,n[m++]=128|(p&258048)>>>12,n[m++]=128|(p&4032)>>>6,n[m++]=128|(p&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=f.g,m=this.q;for(let b=0;b<64;b+=4)n.setUint32(b,m.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)n.setUint32(b,E(n.getUint32(b-12,!1)^n.getUint32(b-32,!1)^n.getUint32(b-56,!1)^n.getUint32(b-64,!1),1),!1);let p=this.h,i=this.l,t=this.m,o=this.n,k=this.o,$,S,v;for(let b=0;b<80;b++)b<20?($=i&t|~i&o,S=1518500249):b<40?($=i^t^o,S=1859775393):b<60?($=i&t|i&o|t&o,S=2400959708):($=i^t^o,S=3395469782),v=E(p,5)+$+k+S+n.getUint32(b*4,!1)&4294967295,k=o,o=t,t=E(i,30),i=p,p=v;this.h=this.h+p&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+k&4294967295}}e.$uj=f}),define(fe[50],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(fe[51],de([0,1,16,9]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class C{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const c=a.charCodeAt(0),g=this.b.charCodeAt(this.c);return c-g}value(){return this.b[this.c]}}e.$Ci=C;class D{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,L.$vf)(a,this.b,0,a.length,this.c,this.d):(0,L.$xf)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=D;class R{constructor(a=!0,c=!0){this.f=a,this.g=c}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let c=a.length-1;c>=0;c--,this.c--){const g=this.b.charCodeAt(c);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===47||this.f&&c===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,L.$vf)(a,this.b,0,a.length,this.d,this.e):(0,L.$xf)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=R;var P;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(P||(P={}));class l{constructor(a,c){this.f=a,this.g=c,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,L.$wf)(a,this.c.scheme);if(this.d[this.e]===2)return(0,L.$wf)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,L.$uf)(a,this.c.query);if(this.d[this.e]===5)return(0,L.$uf)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fi=l;class r{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class u{static forUris(a=()=>!1,c=()=>!1){return new u(new l(a,c))}static forPaths(a=!1){return new u(new R(void 0,!a))}static forStrings(){return new u(new C)}static forConfigKeys(){return new u(new D)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,c){if(c){const g=c.slice(0);(0,w.$Wb)(g);for(const f of g)this.set(f,a)}else{const g=a.slice(0);(0,w.$Wb)(g);for(const f of g)this.set(f[0],f[1])}}set(a,c){const g=this.b.reset(a);let f;this.c||(this.c=new r,this.c.segment=g.value());const s=[];for(f=this.c;;){const m=g.cmp(f.segment);if(m>0)f.left||(f.left=new r,f.left.segment=g.value()),s.push([-1,f]),f=f.left;else if(m<0)f.right||(f.right=new r,f.right.segment=g.value()),s.push([1,f]),f=f.right;else if(g.hasNext())g.next(),f.mid||(f.mid=new r,f.mid.segment=g.value()),s.push([0,f]),f=f.mid;else break}const n=f.value;f.value=c,f.key=a;for(let m=s.length-1;m>=0;m--){const p=s[m][1];p.updateHeight();const i=p.balanceFactor();if(i<-1||i>1){const t=s[m][0],o=s[m+1][0];if(t===1&&o===1)s[m][1]=p.rotateLeft();else if(t===-1&&o===-1)s[m][1]=p.rotateRight();else if(t===1&&o===-1)p.right=s[m+1][1]=s[m+1][1].rotateRight(),s[m][1]=p.rotateLeft();else if(t===-1&&o===1)p.left=s[m+1][1]=s[m+1][1].rotateLeft(),s[m][1]=p.rotateRight();else throw new Error;if(m>0)switch(s[m-1][0]){case-1:s[m-1][1].left=s[m][1];break;case 1:s[m-1][1].right=s[m][1];break;case 0:s[m-1][1].mid=s[m][1];break}else this.c=s[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const c=this.b.reset(a);let g=this.c;for(;g;){const f=c.cmp(g.segment);if(f>0)g=g.left;else if(f<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else break}return g}has(a){const c=this.d(a);return!(c?.value===void 0&&c?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,c){const g=this.b.reset(a),f=[];let s=this.c;for(;s;){const n=g.cmp(s.segment);if(n>0)f.push([-1,s]),s=s.left;else if(n<0)f.push([1,s]),s=s.right;else if(g.hasNext())g.next(),f.push([0,s]),s=s.mid;else break}if(s){if(c?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:m,value:p,segment:i}=n;this.e(n.key,!1),s.key=m,s.value=p,s.segment=i}}else{const n=s.left??s.right;if(f.length>0){const[m,p]=f[f.length-1];switch(m){case-1:p.left=n;break;case 0:p.mid=n;break;case 1:p.right=n;break}}else this.c=n}for(let n=f.length-1;n>=0;n--){const m=f[n][1];m.updateHeight();const p=m.balanceFactor();if(p>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),f[n][1]=m.rotateLeft()):p<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),f[n][1]=m.rotateRight()),n>0)switch(f[n-1][0]){case-1:f[n-1][1].left=f[n][1];break;case 1:f[n-1][1].right=f[n][1];break;case 0:f[n-1][1].mid=f[n][1];break}else this.c=f[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const c=this.b.reset(a);let g=this.c,f;for(;g;){const s=c.cmp(g.segment);if(s>0)g=g.left;else if(s<0)g=g.right;else if(c.hasNext())c.next(),f=g.value||f,g=g.mid;else break}return g&&g.value||f}findSuperstr(a){return this.g(a,!1)}g(a,c){const g=this.b.reset(a);let f=this.c;for(;f;){const s=g.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(g.hasNext())g.next(),f=f.mid;else return f.mid?this.h(f.mid):c?f.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[c,g]of this)a(g,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const c=[];return this.j(a,c),c[Symbol.iterator]()}j(a,c){a&&(a.left&&this.j(a.left,c),a.value&&c.push([a.key,a.value]),a.mid&&this.j(a.mid,c),a.right&&this.j(a.right,c))}_isBalanced(){const a=c=>{if(!c)return!0;const g=c.balanceFactor();return g<-1||g>1?!1:a(c.left)&&a(c.right)};return a(this.c)}}e.$Gi=u}),define(fe[10],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=w,e.$bg=L,e.$cg=C,e.$dg=D,e.$eg=R,e.$fg=P,e.$gg=l,e.$hg=r,e.$ig=y,e.$jg=u,e.$kg=E,e.$lg=a,e.$mg=c,e.$ng=f,e.$og=s,e.$pg=n,e.$qg=m,e.$rg=p;function w(i){return typeof i=="string"}function L(i){return Array.isArray(i)&&i.every(t=>w(t))}function C(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function D(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function R(i){return typeof i=="number"&&!isNaN(i)}function P(i){return!!i&&typeof i[Symbol.iterator]=="function"}function l(i){return i===!0||i===!1}function r(i){return typeof i>"u"}function y(i){return!u(i)}function u(i){return r(i)||i===null}function E(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function a(i){if(u(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function c(...i){const t=[];for(let o=0;o<i.length;o++){const k=i[o];if(u(k))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(k)}return t}const g=Object.prototype.hasOwnProperty;function f(i){if(!C(i))return!1;for(const t in i)if(g.call(i,t))return!1;return!0}function s(i){return typeof i=="function"}function n(...i){return i.length>0&&i.every(s)}function m(i,t){const o=Math.min(i.length,t.length);for(let k=0;k<o;k++)p(i[k],t[k])}function p(i,t){if(w(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(i instanceof t)return}catch{}if(!u(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(fe[30],de([0,1,10]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=L,e.$8n=C,e.$9n=R,e.$0n=l,e.$$n=r,e.$_n=y,e.$ao=u,e.$bo=E,e.$co=a,e.$do=c,e.$eo=g,e.$fo=f,e.$go=s;function L(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const m=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([p,i])=>{m[p]=i&&typeof i=="object"?L(i):i}),m}function C(n){if(!n||typeof n!="object")return n;const m=[n];for(;m.length>0;){const p=m.shift();Object.freeze(p);for(const i in p)if(D.call(p,i)){const t=p[i];typeof t=="object"&&!Object.isFrozen(t)&&!(0,w.$dg)(t)&&m.push(t)}}return n}const D=Object.prototype.hasOwnProperty;function R(n,m){return P(n,m,new Set)}function P(n,m,p){if((0,w.$jg)(n))return n;const i=m(n);if(typeof i<"u")return i;if(Array.isArray(n)){const t=[];for(const o of n)t.push(P(o,m,p));return t}if((0,w.$cg)(n)){if(p.has(n))throw new Error("Cannot clone recursive data-structure");p.add(n);const t={};for(const o in n)D.call(n,o)&&(t[o]=P(n[o],m,p));return p.delete(n),t}return n}function l(n,m,p=!0){return(0,w.$cg)(n)?((0,w.$cg)(m)&&Object.keys(m).forEach(i=>{i in n?p&&((0,w.$cg)(n[i])&&(0,w.$cg)(m[i])?l(n[i],m[i],p):n[i]=m[i]):n[i]=m[i]}),n):m}function r(n,m){if(n===m)return!0;if(n==null||m===null||m===void 0||typeof n!=typeof m||typeof n!="object"||Array.isArray(n)!==Array.isArray(m))return!1;let p,i;if(Array.isArray(n)){if(n.length!==m.length)return!1;for(p=0;p<n.length;p++)if(!r(n[p],m[p]))return!1}else{const t=[];for(i in n)t.push(i);t.sort();const o=[];for(i in m)o.push(i);if(o.sort(),!r(t,o))return!1;for(p=0;p<t.length;p++)if(!r(n[t[p]],m[t[p]]))return!1}return!0}function y(n){const m=new Set;return JSON.stringify(n,(p,i)=>{if((0,w.$cg)(i)||Array.isArray(i)){if(m.has(i))return"[Circular]";m.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function u(n,m){const p=Object.create(null);return!n||!m||Object.keys(m).forEach(t=>{const o=n[t],k=m[t];r(o,k)||(p[t]=k)}),p}function E(n,m){const p=m.toLowerCase(),i=Object.keys(n).find(t=>t.toLowerCase()===p);return i?n[i]:n[m]}function a(n,m){const p=Object.create(null);for(const[i,t]of Object.entries(n))m(i,t)&&(p[i]=t);return p}function c(n){let m=[];for(;Object.prototype!==n;)m=m.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return m}function g(n){const m=[];for(const p of c(n))typeof n[p]=="function"&&m.push(p);return m}function f(n,m){const p=t=>function(){const o=Array.prototype.slice.call(arguments,0);return m(t,o)},i={};for(const t of n)i[t]=p(t);return i}function s(n,m){const p={};for(const[i,t]of Object.entries(n))p[i]=m(t,i);return p}}),define(fe[52],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=L;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(C){return w.test(C)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(P){for(let l=0;l<P.length;l++)P[l]=Math.floor(Math.random()*256);return P};const D=new Uint8Array(16),R=[];for(let P=0;P<256;P++)R.push(P.toString(16).padStart(2,"0"));return function(){C(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let l=0,r="";return r+=R[D[l++]],r+=R[D[l++]],r+=R[D[l++]],r+=R[D[l++]],r+="-",r+=R[D[l++]],r+=R[D[l++]],r+="-",r+=R[D[l++]],r+=R[D[l++]],r+="-",r+=R[D[l++]],r+=R[D[l++]],r+="-",r+=R[D[l++]],r+=R[D[l++]],r+=R[D[l++]],r+=R[D[l++]],r+=R[D[l++]],r+=R[D[l++]],r}}()}),define(fe[31],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yW=w;function w(L){return!!L.parentPort}}),define(fe[53],de([13,11]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(fe[54],de([0,1,53]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=r,e.$7m=y,e.$8m=u;const L=60,C=L*60,D=C*24,R=D*7,P=D*30,l=D*365;function r(E,a,c,g){typeof E!="number"&&(E=E.getTime());const f=Math.round((new Date().getTime()-E)/1e3);if(f<-30)return(0,w.localize)(0,null,r(new Date().getTime()+f*1e3,!1));if(!g&&f<30)return(0,w.localize)(1,null);let s;return f<L?(s=f,a?s===1?c?(0,w.localize)(2,null,s):(0,w.localize)(3,null,s):c?(0,w.localize)(4,null,s):(0,w.localize)(5,null,s):s===1?c?(0,w.localize)(6,null,s):(0,w.localize)(7,null,s):c?(0,w.localize)(8,null,s):(0,w.localize)(9,null,s)):f<C?(s=Math.floor(f/L),a?s===1?c?(0,w.localize)(10,null,s):(0,w.localize)(11,null,s):c?(0,w.localize)(12,null,s):(0,w.localize)(13,null,s):s===1?c?(0,w.localize)(14,null,s):(0,w.localize)(15,null,s):c?(0,w.localize)(16,null,s):(0,w.localize)(17,null,s)):f<D?(s=Math.floor(f/C),a?s===1?c?(0,w.localize)(18,null,s):(0,w.localize)(19,null,s):c?(0,w.localize)(20,null,s):(0,w.localize)(21,null,s):s===1?c?(0,w.localize)(22,null,s):(0,w.localize)(23,null,s):c?(0,w.localize)(24,null,s):(0,w.localize)(25,null,s)):f<R?(s=Math.floor(f/D),a?s===1?(0,w.localize)(26,null,s):(0,w.localize)(27,null,s):s===1?(0,w.localize)(28,null,s):(0,w.localize)(29,null,s)):f<P?(s=Math.floor(f/R),a?s===1?c?(0,w.localize)(30,null,s):(0,w.localize)(31,null,s):c?(0,w.localize)(32,null,s):(0,w.localize)(33,null,s):s===1?c?(0,w.localize)(34,null,s):(0,w.localize)(35,null,s):c?(0,w.localize)(36,null,s):(0,w.localize)(37,null,s)):f<l?(s=Math.floor(f/P),a?s===1?c?(0,w.localize)(38,null,s):(0,w.localize)(39,null,s):c?(0,w.localize)(40,null,s):(0,w.localize)(41,null,s):s===1?c?(0,w.localize)(42,null,s):(0,w.localize)(43,null,s):c?(0,w.localize)(44,null,s):(0,w.localize)(45,null,s)):(s=Math.floor(f/l),a?s===1?c?(0,w.localize)(46,null,s):(0,w.localize)(47,null,s):c?(0,w.localize)(48,null,s):(0,w.localize)(49,null,s):s===1?c?(0,w.localize)(50,null,s):(0,w.localize)(51,null,s):c?(0,w.localize)(52,null,s):(0,w.localize)(53,null,s))}function y(E,a){const c=Math.abs(E/1e3);return c<1?a?(0,w.localize)(54,null,E):(0,w.localize)(55,null,E):c<L?a?(0,w.localize)(56,null,Math.round(E)/1e3):(0,w.localize)(57,null,Math.round(E)/1e3):c<C?a?(0,w.localize)(58,null,Math.round(E/(1e3*L))):(0,w.localize)(59,null,Math.round(E/(1e3*L))):c<D?a?(0,w.localize)(60,null,Math.round(E/(1e3*C))):(0,w.localize)(61,null,Math.round(E/(1e3*C))):(0,w.localize)(62,null,Math.round(E/(1e3*D)))}function u(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(fe[55],de([13,11]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(fe[56],de([0,1,16,10,55]),function(oe,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=l,e.$mj=r,e.$nj=y;function D(u,E){return E&&(u.stack||u.stacktrace)?C.localize(0,null,P(u),R(u.stack)||R(u.stacktrace)):P(u)}function R(u){return Array.isArray(u)?u.join(`
`):u}function P(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?C.localize(1,null,u.message):u.message||C.localize(2,null)}function l(u=null,E=!1){if(!u)return C.localize(3,null);if(Array.isArray(u)){const a=w.$Hb(u),c=l(a[0],E);return a.length>1?C.localize(4,null,c,a.length):c}if(L.$ag(u))return u;if(u.detail){const a=u.detail;if(a.error)return D(a.error,E);if(a.exception)return D(a.exception,E)}return u.stack?D(u,E):u.message?u.message:C.localize(5,null)}function r(u){const E=u;return E instanceof Error&&Array.isArray(E.actions)}function y(u,E){let a;return typeof u=="string"?a=new Error(u):a=u,a.actions=E,a}}),define(fe[57],de([13,11]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(fe[3],de([0,1,57]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=U,e.$J=Z,e.$g="en";let L=!1,C=!1,D=!1,R=!1,P=!1,l=!1,r=!1,y=!1,u=!1,E=!1,a,c=e.$g,g=e.$g,f,s;const n=globalThis;let m;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?m=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(m=process);const p=typeof m?.versions?.electron=="string",i=p&&m?.type==="renderer";if(typeof m=="object"){L=m.platform==="win32",C=m.platform==="darwin",D=m.platform==="linux",R=D&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,r=p,u=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=e.$g,c=e.$g;const T=m.env.VSCODE_NLS_CONFIG;if(T)try{const I=JSON.parse(T),d=I.availableLanguages["*"];a=I.locale,g=I.osLocale,c=d||e.$g,f=I._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!i?(s=navigator.userAgent,L=s.indexOf("Windows")>=0,C=s.indexOf("Macintosh")>=0,y=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=s.indexOf("Linux")>=0,E=s?.indexOf("Mobi")>=0,l=!0,a=w.getConfiguredDefaultLocale(w.localize(0,null))||e.$g,c=a,g=navigator.language):console.error("Unable to resolve platform.");var t;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let k=0;C?k=1:L?k=3:D&&(k=2),e.$i=L,e.$j=C,e.$k=D,e.$l=R,e.$m=P,e.$n=r,e.$o=l,e.$p=l&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=y,e.$s=E,e.$t=u,e.$u=k,e.$v=s,e.$w=c;var $;(function(T){function I(){return e.$w}T.value=I;function d(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}T.isDefaultVariant=d;function N(){return e.$w==="en"}T.isDefault=N})($||(e.Language=$={})),e.$x=a,e.$y=g,e.$z=f,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const T=[];n.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let N=0,A=T.length;N<A;N++){const M=T[N];if(M.id===d.data.vscodeScheduleAsyncWork){T.splice(N,1),M.callback();return}}});let I=0;return d=>{const N=++I;T.push({id:N,callback:d}),n.postMessage({vscodeScheduleAsyncWork:N},"*")}}return T=>setTimeout(T)})();var S;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(S||(e.OperatingSystem=S={})),e.OS=C||y?2:L?1:3;let v=!0,b=!1;function U(){if(!b){b=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,v=new Uint16Array(T.buffer)[0]===513}return v}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function Z(T){return parseFloat(T)>=20}}),define(fe[15],de([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const D=C.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return w.$i?"win32":w.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(fe[5],de([0,1,15]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,C=97,D=90,R=122,P=46,l=47,r=92,y=58,u=63;class E extends Error{constructor(o,k,$){let S;typeof k=="string"&&k.indexOf("not ")===0?(S="must not be",k=k.replace(/^not /,"")):S="must be";const v=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${v} ${S} of type ${k}`;b+=`. Received type ${typeof $}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function a(t,o){if(t===null||typeof t!="object")throw new E(o,"Object",t)}function c(t,o){if(typeof t!="string")throw new E(o,"string",t)}const g=w.$dc==="win32";function f(t){return t===l||t===r}function s(t){return t===l}function n(t){return t>=L&&t<=D||t>=C&&t<=R}function m(t,o,k,$){let S="",v=0,b=-1,U=0,Z=0;for(let T=0;T<=t.length;++T){if(T<t.length)Z=t.charCodeAt(T);else{if($(Z))break;Z=l}if($(Z)){if(!(b===T-1||U===1))if(U===2){if(S.length<2||v!==2||S.charCodeAt(S.length-1)!==P||S.charCodeAt(S.length-2)!==P){if(S.length>2){const I=S.lastIndexOf(k);I===-1?(S="",v=0):(S=S.slice(0,I),v=S.length-1-S.lastIndexOf(k)),b=T,U=0;continue}else if(S.length!==0){S="",v=0,b=T,U=0;continue}}o&&(S+=S.length>0?`${k}..`:"..",v=2)}else S.length>0?S+=`${k}${t.slice(b+1,T)}`:S=t.slice(b+1,T),v=T-b-1;b=T,U=0}else Z===P&&U!==-1?++U:U=-1}return S}function p(t,o){a(o,"pathObject");const k=o.dir||o.root,$=o.base||`${o.name||""}${o.ext||""}`;return k?k===o.root?`${k}${$}`:`${k}${t}${$}`:$}e.$fc={resolve(...t){let o="",k="",$=!1;for(let S=t.length-1;S>=-1;S--){let v;if(S>=0){if(v=t[S],c(v,"path"),v.length===0)continue}else o.length===0?v=w.cwd():(v=w.env[`=${o}`]||w.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==o.toLowerCase()&&v.charCodeAt(2)===r)&&(v=`${o}\\`));const b=v.length;let U=0,Z="",T=!1;const I=v.charCodeAt(0);if(b===1)f(I)&&(U=1,T=!0);else if(f(I))if(T=!0,f(v.charCodeAt(1))){let d=2,N=d;for(;d<b&&!f(v.charCodeAt(d));)d++;if(d<b&&d!==N){const A=v.slice(N,d);for(N=d;d<b&&f(v.charCodeAt(d));)d++;if(d<b&&d!==N){for(N=d;d<b&&!f(v.charCodeAt(d));)d++;(d===b||d!==N)&&(Z=`\\\\${A}\\${v.slice(N,d)}`,U=d)}}}else U=1;else n(I)&&v.charCodeAt(1)===y&&(Z=v.slice(0,2),U=2,b>2&&f(v.charCodeAt(2))&&(T=!0,U=3));if(Z.length>0)if(o.length>0){if(Z.toLowerCase()!==o.toLowerCase())continue}else o=Z;if($){if(o.length>0)break}else if(k=`${v.slice(U)}\\${k}`,$=T,T&&o.length>0)break}return k=m(k,!$,"\\",f),$?`${o}\\${k}`:`${o}${k}`||"."},normalize(t){c(t,"path");const o=t.length;if(o===0)return".";let k=0,$,S=!1;const v=t.charCodeAt(0);if(o===1)return s(v)?"\\":t;if(f(v))if(S=!0,f(t.charCodeAt(1))){let U=2,Z=U;for(;U<o&&!f(t.charCodeAt(U));)U++;if(U<o&&U!==Z){const T=t.slice(Z,U);for(Z=U;U<o&&f(t.charCodeAt(U));)U++;if(U<o&&U!==Z){for(Z=U;U<o&&!f(t.charCodeAt(U));)U++;if(U===o)return`\\\\${T}\\${t.slice(Z)}\\`;U!==Z&&($=`\\\\${T}\\${t.slice(Z,U)}`,k=U)}}}else k=1;else n(v)&&t.charCodeAt(1)===y&&($=t.slice(0,2),k=2,o>2&&f(t.charCodeAt(2))&&(S=!0,k=3));let b=k<o?m(t.slice(k),!S,"\\",f):"";return b.length===0&&!S&&(b="."),b.length>0&&f(t.charCodeAt(o-1))&&(b+="\\"),$===void 0?S?`\\${b}`:b:S?`${$}\\${b}`:`${$}${b}`},isAbsolute(t){c(t,"path");const o=t.length;if(o===0)return!1;const k=t.charCodeAt(0);return f(k)||o>2&&n(k)&&t.charCodeAt(1)===y&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,k;for(let v=0;v<t.length;++v){const b=t[v];c(b,"path"),b.length>0&&(o===void 0?o=k=b:o+=`\\${b}`)}if(o===void 0)return".";let $=!0,S=0;if(typeof k=="string"&&f(k.charCodeAt(0))){++S;const v=k.length;v>1&&f(k.charCodeAt(1))&&(++S,v>2&&(f(k.charCodeAt(2))?++S:$=!1))}if($){for(;S<o.length&&f(o.charCodeAt(S));)S++;S>=2&&(o=`\\${o.slice(S)}`)}return e.$fc.normalize(o)},relative(t,o){if(c(t,"from"),c(o,"to"),t===o)return"";const k=e.$fc.resolve(t),$=e.$fc.resolve(o);if(k===$||(t=k.toLowerCase(),o=$.toLowerCase(),t===o))return"";let S=0;for(;S<t.length&&t.charCodeAt(S)===r;)S++;let v=t.length;for(;v-1>S&&t.charCodeAt(v-1)===r;)v--;const b=v-S;let U=0;for(;U<o.length&&o.charCodeAt(U)===r;)U++;let Z=o.length;for(;Z-1>U&&o.charCodeAt(Z-1)===r;)Z--;const T=Z-U,I=b<T?b:T;let d=-1,N=0;for(;N<I;N++){const M=t.charCodeAt(S+N);if(M!==o.charCodeAt(U+N))break;M===r&&(d=N)}if(N!==I){if(d===-1)return $}else{if(T>I){if(o.charCodeAt(U+N)===r)return $.slice(U+N+1);if(N===2)return $.slice(U+N)}b>I&&(t.charCodeAt(S+N)===r?d=N:N===2&&(d=3)),d===-1&&(d=0)}let A="";for(N=S+d+1;N<=v;++N)(N===v||t.charCodeAt(N)===r)&&(A+=A.length===0?"..":"\\..");return U+=d,A.length>0?`${A}${$.slice(U,Z)}`:($.charCodeAt(U)===r&&++U,$.slice(U,Z))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===r){if(o.charCodeAt(1)===r){const k=o.charCodeAt(2);if(k!==u&&k!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(n(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===r)return`\\\\?\\${o}`;return t},dirname(t){c(t,"path");const o=t.length;if(o===0)return".";let k=-1,$=0;const S=t.charCodeAt(0);if(o===1)return f(S)?t:".";if(f(S)){if(k=$=1,f(t.charCodeAt(1))){let U=2,Z=U;for(;U<o&&!f(t.charCodeAt(U));)U++;if(U<o&&U!==Z){for(Z=U;U<o&&f(t.charCodeAt(U));)U++;if(U<o&&U!==Z){for(Z=U;U<o&&!f(t.charCodeAt(U));)U++;if(U===o)return t;U!==Z&&(k=$=U+1)}}}}else n(S)&&t.charCodeAt(1)===y&&(k=o>2&&f(t.charCodeAt(2))?3:2,$=k);let v=-1,b=!0;for(let U=o-1;U>=$;--U)if(f(t.charCodeAt(U))){if(!b){v=U;break}}else b=!1;if(v===-1){if(k===-1)return".";v=k}return t.slice(0,v)},basename(t,o){o!==void 0&&c(o,"ext"),c(t,"path");let k=0,$=-1,S=!0,v;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(k=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,U=-1;for(v=t.length-1;v>=k;--v){const Z=t.charCodeAt(v);if(f(Z)){if(!S){k=v+1;break}}else U===-1&&(S=!1,U=v+1),b>=0&&(Z===o.charCodeAt(b)?--b===-1&&($=v):(b=-1,$=U))}return k===$?$=U:$===-1&&($=t.length),t.slice(k,$)}for(v=t.length-1;v>=k;--v)if(f(t.charCodeAt(v))){if(!S){k=v+1;break}}else $===-1&&(S=!1,$=v+1);return $===-1?"":t.slice(k,$)},extname(t){c(t,"path");let o=0,k=-1,$=0,S=-1,v=!0,b=0;t.length>=2&&t.charCodeAt(1)===y&&n(t.charCodeAt(0))&&(o=$=2);for(let U=t.length-1;U>=o;--U){const Z=t.charCodeAt(U);if(f(Z)){if(!v){$=U+1;break}continue}S===-1&&(v=!1,S=U+1),Z===P?k===-1?k=U:b!==1&&(b=1):k!==-1&&(b=-1)}return k===-1||S===-1||b===0||b===1&&k===S-1&&k===$+1?"":t.slice(k,S)},format:p.bind(null,"\\"),parse(t){c(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const k=t.length;let $=0,S=t.charCodeAt(0);if(k===1)return f(S)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(f(S)){if($=1,f(t.charCodeAt(1))){let d=2,N=d;for(;d<k&&!f(t.charCodeAt(d));)d++;if(d<k&&d!==N){for(N=d;d<k&&f(t.charCodeAt(d));)d++;if(d<k&&d!==N){for(N=d;d<k&&!f(t.charCodeAt(d));)d++;d===k?$=d:d!==N&&($=d+1)}}}}else if(n(S)&&t.charCodeAt(1)===y){if(k<=2)return o.root=o.dir=t,o;if($=2,f(t.charCodeAt(2))){if(k===3)return o.root=o.dir=t,o;$=3}}$>0&&(o.root=t.slice(0,$));let v=-1,b=$,U=-1,Z=!0,T=t.length-1,I=0;for(;T>=$;--T){if(S=t.charCodeAt(T),f(S)){if(!Z){b=T+1;break}continue}U===-1&&(Z=!1,U=T+1),S===P?v===-1?v=T:I!==1&&(I=1):v!==-1&&(I=-1)}return U!==-1&&(v===-1||I===0||I===1&&v===U-1&&v===b+1?o.base=o.name=t.slice(b,U):(o.name=t.slice(b,v),o.base=t.slice(b,U),o.ext=t.slice(v,U))),b>0&&b!==$?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(g){const t=/\\/g;return()=>{const o=w.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>w.cwd()})();e.$gc={resolve(...t){let o="",k=!1;for(let $=t.length-1;$>=-1&&!k;$--){const S=$>=0?t[$]:i();c(S,"path"),S.length!==0&&(o=`${S}/${o}`,k=S.charCodeAt(0)===l)}return o=m(o,!k,"/",s),k?`/${o}`:o.length>0?o:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===l,k=t.charCodeAt(t.length-1)===l;return t=m(t,!o,"/",s),t.length===0?o?"/":k?"./":".":(k&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===l},join(...t){if(t.length===0)return".";let o;for(let k=0;k<t.length;++k){const $=t[k];c($,"path"),$.length>0&&(o===void 0?o=$:o+=`/${$}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(c(t,"from"),c(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const k=1,$=t.length,S=$-k,v=1,b=o.length-v,U=S<b?S:b;let Z=-1,T=0;for(;T<U;T++){const d=t.charCodeAt(k+T);if(d!==o.charCodeAt(v+T))break;d===l&&(Z=T)}if(T===U)if(b>U){if(o.charCodeAt(v+T)===l)return o.slice(v+T+1);if(T===0)return o.slice(v+T)}else S>U&&(t.charCodeAt(k+T)===l?Z=T:T===0&&(Z=0));let I="";for(T=k+Z+1;T<=$;++T)(T===$||t.charCodeAt(T)===l)&&(I+=I.length===0?"..":"/..");return`${I}${o.slice(v+Z)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===l;let k=-1,$=!0;for(let S=t.length-1;S>=1;--S)if(t.charCodeAt(S)===l){if(!$){k=S;break}}else $=!1;return k===-1?o?"/":".":o&&k===1?"//":t.slice(0,k)},basename(t,o){o!==void 0&&c(o,"ext"),c(t,"path");let k=0,$=-1,S=!0,v;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,U=-1;for(v=t.length-1;v>=0;--v){const Z=t.charCodeAt(v);if(Z===l){if(!S){k=v+1;break}}else U===-1&&(S=!1,U=v+1),b>=0&&(Z===o.charCodeAt(b)?--b===-1&&($=v):(b=-1,$=U))}return k===$?$=U:$===-1&&($=t.length),t.slice(k,$)}for(v=t.length-1;v>=0;--v)if(t.charCodeAt(v)===l){if(!S){k=v+1;break}}else $===-1&&(S=!1,$=v+1);return $===-1?"":t.slice(k,$)},extname(t){c(t,"path");let o=-1,k=0,$=-1,S=!0,v=0;for(let b=t.length-1;b>=0;--b){const U=t.charCodeAt(b);if(U===l){if(!S){k=b+1;break}continue}$===-1&&(S=!1,$=b+1),U===P?o===-1?o=b:v!==1&&(v=1):o!==-1&&(v=-1)}return o===-1||$===-1||v===0||v===1&&o===$-1&&o===k+1?"":t.slice(o,$)},format:p.bind(null,"/"),parse(t){c(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const k=t.charCodeAt(0)===l;let $;k?(o.root="/",$=1):$=0;let S=-1,v=0,b=-1,U=!0,Z=t.length-1,T=0;for(;Z>=$;--Z){const I=t.charCodeAt(Z);if(I===l){if(!U){v=Z+1;break}continue}b===-1&&(U=!1,b=Z+1),I===P?S===-1?S=Z:T!==1&&(T=1):S!==-1&&(T=-1)}if(b!==-1){const I=v===0&&k?1:v;S===-1||T===0||T===1&&S===b-1&&S===v+1?o.base=o.name=t.slice(I,b):(o.name=t.slice(I,S),o.base=t.slice(I,b),o.ext=t.slice(S,b))}return v>0?o.dir=t.slice(0,v-1):k&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=g?e.$fc.normalize:e.$gc.normalize,e.$ic=g?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=g?e.$fc.join:e.$gc.join,e.$kc=g?e.$fc.resolve:e.$gc.resolve,e.$lc=g?e.$fc.relative:e.$gc.relative,e.$mc=g?e.$fc.dirname:e.$gc.dirname,e.$nc=g?e.$fc.basename:e.$gc.basename,e.$oc=g?e.$fc.extname:e.$gc.extname,e.$pc=g?e.$fc.format:e.$gc.format,e.$qc=g?e.$fc.parse:e.$gc.parse,e.$rc=g?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=g?e.$fc.sep:e.$gc.sep,e.$tc=g?e.$fc.delimiter:e.$gc.delimiter}),define(fe[32],de([0,1,5,3,9,10]),function(oe,e,w,L,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=R,e.$tg=P,e.$ug=l,e.$vg=r,e.$wg=y,e.$xg=c,e.$yg=g,e.$zg=f,e.$Ag=s,e.$Bg=n,e.$Cg=m,e.$Dg=p,e.$Eg=i,e.$Fg=t,e.$Gg=o,e.$Hg=k,e.$Ig=v;function R(b){return b===47||b===92}function P(b){return b.replace(/[\\/]/g,w.$gc.sep)}function l(b){return b.indexOf("/")===-1&&(b=P(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function r(b,U=w.$gc.sep){if(!b)return"";const Z=b.length,T=b.charCodeAt(0);if(R(T)){if(R(b.charCodeAt(1))&&!R(b.charCodeAt(2))){let d=3;const N=d;for(;d<Z&&!R(b.charCodeAt(d));d++);if(N!==d&&!R(b.charCodeAt(d+1))){for(d+=1;d<Z;d++)if(R(b.charCodeAt(d)))return b.slice(0,d+1).replace(/[\\/]/g,U)}}return U}else if(s(T)&&b.charCodeAt(1)===58)return R(b.charCodeAt(2))?b.slice(0,2)+U:b.slice(0,2);let I=b.indexOf("://");if(I!==-1){for(I+=3;I<Z;I++)if(R(b.charCodeAt(I)))return b.slice(0,I+1)}return""}function y(b){if(!L.$i||!b||b.length<5)return!1;let U=b.charCodeAt(0);if(U!==92||(U=b.charCodeAt(1),U!==92))return!1;let Z=2;const T=Z;for(;Z<b.length&&(U=b.charCodeAt(Z),U!==92);Z++);return!(T===Z||(U=b.charCodeAt(Z+1),isNaN(U)||U===92))}const u=/[\\/:\*\?"<>\|]/g,E=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(b,U=L.$i){const Z=U?u:E;return!(!b||b.length===0||/^\s+$/.test(b)||(Z.lastIndex=0,Z.test(b))||U&&a.test(b)||b==="."||b===".."||U&&b[b.length-1]==="."||U&&b.length!==b.trim().length||b.length>255)}function g(b,U,Z){const T=b===U;return!Z||T?T:!b||!U?!1:(0,C.$Bf)(b,U)}function f(b,U,Z,T=w.sep){if(b===U)return!0;if(!b||!U||U.length>b.length)return!1;if(Z){if(!(0,C.$Cf)(b,U))return!1;if(U.length===b.length)return!0;let d=U.length;return U.charAt(U.length-1)===T&&d--,b.charAt(d)===T}return U.charAt(U.length-1)!==T&&(U+=T),b.indexOf(U)===0}function s(b){return b>=65&&b<=90||b>=97&&b<=122}function n(b,U){return L.$i&&b.endsWith(":")&&(b+=w.sep),(0,w.$ic)(b)||(b=(0,w.$jc)(U,b)),b=(0,w.$hc)(b),m(b)}function m(b){return L.$i?(b=(0,C.$jf)(b,w.sep),b.endsWith(":")&&(b+=w.sep)):(b=(0,C.$jf)(b,w.sep),b||(b=w.sep)),b}function p(b){const U=(0,w.$hc)(b);return L.$i?b.length>3?!1:i(U)&&(b.length===2||U.charCodeAt(2)===92):U===w.$gc.sep}function i(b,U=L.$i){return U?s(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function t(b,U=L.$i){return i(b,U)?b[0]:void 0}function o(b,U,Z){return U.length>b.length?-1:b===U?0:(Z&&(b=b.toLowerCase(),U=U.toLowerCase()),b.indexOf(U))}function k(b){const U=b.split(":");let Z,T,I;for(const d of U){const N=Number(d);(0,D.$eg)(N)?T===void 0?T=N:I===void 0&&(I=N):Z=Z?[Z,d].join(":"):d}if(!Z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:Z,line:T!==void 0?T:void 0,column:I!==void 0?I:T!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",S="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(b,U,Z=8){let T="";for(let d=0;d<Z;d++){let N;d===0&&L.$i&&!U&&(Z===3||Z===4)?N=S:N=$,T+=N.charAt(Math.floor(Math.random()*N.length))}let I;return U?I=`${U}-${T}`:I=T,b?(0,w.$jc)(b,I):I}}),define(fe[33],de([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=D,e.$rm=R;var L;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(L||(e.Source=L={}));var C;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function D(P,...l){const r=l.reduce((E,a)=>(E[a]=!0,E),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(E=>!r[E]).forEach(E=>{for(let a=0;a<y.length;a++)if(E.search(y[a])!==-1){delete P[E];break}})}function R(P){P&&(delete P.DEBUG,w.$j&&delete P.DYLD_LIBRARY_PATH,w.$k&&delete P.LD_PRELOAD)}}),define(fe[6],de([0,1,5,3]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=c,e.$wc=p;const C=/^\w[\w\d+.-]*$/,D=/^\//,R=/^\/\//;function P($,S){if(!$.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${$.authority}", path: "${$.path}", query: "${$.query}", fragment: "${$.fragment}"}`);if($.scheme&&!C.test($.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if($.path){if($.authority){if(!D.test($.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test($.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l($,S){return!$&&!S?"file":$}function r($,S){switch($){case"https":case"http":case"file":S?S[0]!==u&&(S=u+S):S=u;break}return S}const y="",u="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(S){return S instanceof a?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,v,b,U,Z,T=!1){typeof S=="object"?(this.scheme=S.scheme||y,this.authority=S.authority||y,this.path=S.path||y,this.query=S.query||y,this.fragment=S.fragment||y):(this.scheme=l(S,T),this.authority=v||y,this.path=r(this.scheme,b||y),this.query=U||y,this.fragment=Z||y,P(this,T))}get fsPath(){return p(this,!1)}with(S){if(!S)return this;let{scheme:v,authority:b,path:U,query:Z,fragment:T}=S;return v===void 0?v=this.scheme:v===null&&(v=y),b===void 0?b=this.authority:b===null&&(b=y),U===void 0?U=this.path:U===null&&(U=y),Z===void 0?Z=this.query:Z===null&&(Z=y),T===void 0?T=this.fragment:T===null&&(T=y),v===this.scheme&&b===this.authority&&U===this.path&&Z===this.query&&T===this.fragment?this:new f(v,b,U,Z,T)}static parse(S,v=!1){const b=E.exec(S);return b?new f(b[2]||y,k(b[4]||y),k(b[5]||y),k(b[7]||y),k(b[9]||y),v):new f(y,y,y,y,y)}static file(S){let v=y;if(L.$i&&(S=S.replace(/\\/g,u)),S[0]===u&&S[1]===u){const b=S.indexOf(u,2);b===-1?(v=S.substring(2),S=u):(v=S.substring(2,b),S=S.substring(b)||u)}return new f("file",v,S,y,y)}static from(S,v){return new f(S.scheme,S.authority,S.path,S.query,S.fragment,v)}static joinPath(S,...v){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return L.$i&&S.scheme==="file"?b=a.file(w.$fc.join(p(S,!0),...v)).path:b=w.$gc.join(S.path,...v),S.with({path:b})}toString(S=!1){return i(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof a)return S;{const v=new f(S);return v._formatted=S.external??null,v._fsPath=S._sep===g?S.fsPath??null:null,v}}else return S}}e.URI=a;function c($){return!$||typeof $!="object"?!1:typeof $.scheme=="string"&&(typeof $.authority=="string"||typeof $.authority>"u")&&(typeof $.path=="string"||typeof $.path>"u")&&(typeof $.query=="string"||typeof $.query>"u")&&(typeof $.fragment=="string"||typeof $.fragment>"u")}const g=L.$i?1:void 0;class f extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(S=!1){return S?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const S={$mid:1};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=g),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const s={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n($,S,v){let b,U=-1;for(let Z=0;Z<$.length;Z++){const T=$.charCodeAt(Z);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||S&&T===47||v&&T===91||v&&T===93||v&&T===58)U!==-1&&(b+=encodeURIComponent($.substring(U,Z)),U=-1),b!==void 0&&(b+=$.charAt(Z));else{b===void 0&&(b=$.substr(0,Z));const I=s[T];I!==void 0?(U!==-1&&(b+=encodeURIComponent($.substring(U,Z)),U=-1),b+=I):U===-1&&(U=Z)}}return U!==-1&&(b+=encodeURIComponent($.substring(U))),b!==void 0?b:$}function m($){let S;for(let v=0;v<$.length;v++){const b=$.charCodeAt(v);b===35||b===63?(S===void 0&&(S=$.substr(0,v)),S+=s[b]):S!==void 0&&(S+=$[v])}return S!==void 0?S:$}function p($,S){let v;return $.authority&&$.path.length>1&&$.scheme==="file"?v=`//${$.authority}${$.path}`:$.path.charCodeAt(0)===47&&($.path.charCodeAt(1)>=65&&$.path.charCodeAt(1)<=90||$.path.charCodeAt(1)>=97&&$.path.charCodeAt(1)<=122)&&$.path.charCodeAt(2)===58?S?v=$.path.substr(1):v=$.path[1].toLowerCase()+$.path.substr(2):v=$.path,L.$i&&(v=v.replace(/\//g,"\\")),v}function i($,S){const v=S?m:n;let b="",{scheme:U,authority:Z,path:T,query:I,fragment:d}=$;if(U&&(b+=U,b+=":"),(Z||U==="file")&&(b+=u,b+=u),Z){let N=Z.indexOf("@");if(N!==-1){const A=Z.substr(0,N);Z=Z.substr(N+1),N=A.lastIndexOf(":"),N===-1?b+=v(A,!1,!1):(b+=v(A.substr(0,N),!1,!1),b+=":",b+=v(A.substr(N+1),!1,!0)),b+="@"}Z=Z.toLowerCase(),N=Z.lastIndexOf(":"),N===-1?b+=v(Z,!1,!0):(b+=v(Z.substr(0,N),!1,!0),b+=Z.substr(N))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const N=T.charCodeAt(1);N>=65&&N<=90&&(T=`/${String.fromCharCode(N+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const N=T.charCodeAt(0);N>=65&&N<=90&&(T=`${String.fromCharCode(N+32)}:${T.substr(2)}`)}b+=v(T,!0,!1)}return I&&(b+="?",b+=v(I,!1,!1)),d&&(b+="#",b+=S?d:n(d,!1,!1)),b}function t($){try{return decodeURIComponent($)}catch{return $.length>3?$.substr(0,3)+t($.substr(3)):$}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function k($){return $.match(o)?$.replace(o,S=>t(S)):$}}),define(fe[58],de([0,1,6]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=L,e.$3q=C,e.$4q=D,e.log=P;function L(r){const y=r;return y&&typeof y.type=="string"&&typeof y.severity=="string"}function C(r){const y=[];let u;try{const E=JSON.parse(r.arguments),a=E[E.length-1];a&&a.__$stack&&(E.pop(),u=a.__$stack),y.push(...E)}catch{y.push("Unable to log remote console arguments",r.arguments)}return{args:y,stack:u}}function D(r){if(typeof r!="string")return D(C(r).stack);const y=r;if(y){const u=R(y),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(E&&E.length===4)return{uri:w.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}function R(r){if(!r)return r;const y=r.indexOf(`
`);return y===-1?r:r.substring(0,y)}function P(r,y){const{args:u,stack:E}=C(r),a=typeof u[0]=="string"&&u.length===1;let c=R(E);c&&(c=`(${c.trim()})`);let g=[];if(typeof u[0]=="string"?c&&a?g=[`%c[${y}] %c${u[0]} %c${c}`,l("blue"),l(""),l("grey")]:g=[`%c[${y}] %c${u[0]}`,l("blue"),l(""),...u.slice(1)]:g=[`%c[${y}]%`,l("blue"),...u],c&&!a&&g.push(c),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,g)}function l(r){return`color: ${r}`}}),define(fe[59],de([0,1,18,6]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=C,e.$9h=D,e.$0h=P;function C(l){return JSON.stringify(l,R)}function D(l){let r=JSON.parse(l);return r=P(r),r}function R(l,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:r.flags}:r}function P(l,r=0){if(!l||r>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return L.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 17:return new Date(l.source)}if(l instanceof w.$Je||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let y=0;y<l.length;++y)l[y]=P(l[y],r+1);else for(const y in l)Object.hasOwnProperty.call(l,y)&&(l[y]=P(l[y],r+1))}return l}}),define(fe[19],de([0,1,7,3,9,6,5]),function(oe,e,w,L,C,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=l,e.$Kg=r,e.$Og=u;var P;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(P||(e.Schemas=P={}));function l(c,g){return D.URI.isUri(c)?(0,C.$Bf)(c.scheme,g):(0,C.$Cf)(c,g+":")}function r(c,...g){return g.some(f=>l(c,f))}e.$Lg="vscode-tkn",e.$Mg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,f){this.f=u(g,f)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,P.vscodeRemoteResource)}set(g,f,s){this.a[g]=f,this.b[g]=s}setConnectionToken(g,f){this.c[g]=f}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(i){return w.$1(i),g}const f=g.authority;let s=this.a[f];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[f],m=this.c[f];let p=`path=${encodeURIComponent(g.path)}`;return typeof m=="string"&&(p+=`&${e.$Mg}=${encodeURIComponent(m)}`),D.URI.from({scheme:L.$o?this.d:P.vscodeRemoteResource,authority:`${s}:${n}`,path:this.g,query:p})}}e.$Ng=new y;function u(c,g){return R.$gc.join(g??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class E{static{this.a=e.$Tg}asBrowserUri(g){const f=this.b(g,oe);return this.uriToBrowserUri(f)}uriToBrowserUri(g){return g.scheme===P.vscodeRemote?e.$Ng.rewrite(g):g.scheme===P.file&&(L.$m||L.$q===`${P.vscodeFileResource}://${E.a}`)?g.with({scheme:P.vscodeFileResource,authority:g.authority||E.a,query:null,fragment:null}):g}asFileUri(g){const f=this.b(g,oe);return this.uriToFileUri(f)}uriToFileUri(g){return g.scheme===P.vscodeFileResource?g.with({scheme:P.file,authority:g.authority!==E.a?g.authority:null,query:null,fragment:null}):g}b(g,f){return D.URI.isUri(g)?g:D.URI.parse(f.toUrl(g))}}e.$Ug=new E;var a;(function(c){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(g.get("3"));const f="vscode-coi";function s(m){let p;typeof m=="string"?p=new URL(m).searchParams:m instanceof URL?p=m.searchParams:D.URI.isUri(m)&&(p=new URL(m.toString(!0)).searchParams);const i=p?.get(f);if(i)return g.get(i)}c.getHeadersFromQuery=s;function n(m,p,i){if(!globalThis.crossOriginIsolated)return;const t=p&&i?"3":i?"2":"1";m instanceof URLSearchParams?m.set(f,t):m[f]=t}c.addSearchParam=n})(a||(e.COI=a={}))}),define(fe[23],de([0,1,32,19,5,3,9,6]),function(oe,e,w,L,C,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=l,e.$kh=y,e.$lh=E;function l(a){return(0,P.$wc)(a,!0)}class r{constructor(c){this.a=c}compare(c,g,f=!1){return c===g?0:(0,R.$uf)(this.getComparisonKey(c,f),this.getComparisonKey(g,f))}isEqual(c,g,f=!1){return c===g?!0:!c||!g?!1:this.getComparisonKey(c,f)===this.getComparisonKey(g,f)}getComparisonKey(c,g=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,g,f=!1){if(c.scheme===g.scheme){if(c.scheme===L.Schemas.file)return w.$zg(l(c),l(g),this.a(c))&&c.query===g.query&&(f||c.fragment===g.fragment);if((0,e.$gh)(c.authority,g.authority))return w.$zg(c.path,g.path,this.a(c),"/")&&c.query===g.query&&(f||c.fragment===g.fragment)}return!1}joinPath(c,...g){return P.URI.joinPath(c,...g)}basenameOrAuthority(c){return(0,e.$$g)(c)||c.authority}basename(c){return C.$gc.basename(c.path)}extname(c){return C.$gc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let g;return c.scheme===L.Schemas.file?g=P.URI.file(C.$mc(l(c))).path:(g=C.$gc.dirname(c.path),c.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),g="/")),c.with({path:g})}normalizePath(c){if(!c.path.length)return c;let g;return c.scheme===L.Schemas.file?g=P.URI.file(C.$hc(l(c))).path:g=C.$gc.normalize(c.path),c.with({path:g})}relativePath(c,g){if(c.scheme!==g.scheme||!(0,e.$gh)(c.authority,g.authority))return;if(c.scheme===L.Schemas.file){const n=C.$lc(l(c),l(g));return D.$i?w.$tg(n):n}let f=c.path||"/";const s=g.path||"/";if(this.a(c)){let n=0;for(const m=Math.min(f.length,s.length);n<m&&!(f.charCodeAt(n)!==s.charCodeAt(n)&&f.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);f=s.substr(0,n)+f.substr(n)}return C.$gc.relative(f,s)}resolvePath(c,g){if(c.scheme===L.Schemas.file){const f=P.URI.file(C.$kc(l(c),g));return c.with({authority:f.authority,path:f.path})}return g=w.$ug(g),c.with({path:C.$gc.resolve(c.path,g)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,g){return c===g||c!==void 0&&g!==void 0&&(0,R.$Bf)(c,g)}hasTrailingPathSeparator(c,g=C.sep){if(c.scheme===L.Schemas.file){const f=l(c);return f.length>w.$vg(f).length&&f[f.length-1]===g}else{const f=c.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,g=C.sep){return(0,e.$hh)(c,g)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,g=C.sep){let f=!1;if(c.scheme===L.Schemas.file){const s=l(c);f=s!==void 0&&s.length===w.$vg(s).length&&s[s.length-1]===g}else{g="/";const s=c.path;f=s.length===1&&s.charCodeAt(s.length-1)===47}return!f&&!(0,e.$hh)(c,g)?c.with({path:c.path+"/"}):c}}e.$3g=r,e.$4g=new r(()=>!1),e.$5g=new r(a=>a.scheme===L.Schemas.file?!D.$k:!0),e.$6g=new r(a=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function y(a,c){const g=[];for(let f=0;f<a.length;f++){const s=c(a[f]);a.some((n,m)=>m===f?!1:(0,e.$8g)(s,c(n)))||g.push(a[f])}return g}var u;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function c(g){const f=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(m=>{const[p,i]=m.split(":");p&&i&&f.set(p,i)});const n=g.path.substring(0,g.path.indexOf(";"));return n&&f.set(a.META_DATA_MIME,n),f}a.parseMetaData=c})(u||(e.DataUri=u={}));function E(a,c,g){if(c){let f=a.path;return f&&f[0]!==C.$gc.sep&&(f=C.$gc.sep+f),a.with({scheme:g,authority:c,path:f})}return a.with({scheme:g})}}),define(fe[12],de([0,1,17,7,4,2,23,3,50,22]),function(oe,e,w,L,C,D,R,P,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=y,e.$nh=u,e.$oh=E,e.$ph=a,e.$qh=c,e.$rh=g,e.$sh=f,e.$th=s,e.$Bh=v,e.$Ch=b,e.$Dh=U,e.$Eh=Z,e.$Fh=T,e.$Uh=z,e.$3h=Y;function y(G){return!!G&&typeof G.then=="function"}function u(G){const O=new w.$se,J=G(O.token),ie=new Promise((ae,be)=>{const Pe=O.token.onCancellationRequested(()=>{Pe.dispose(),be(new L.$5)});Promise.resolve(J).then(me=>{Pe.dispose(),O.dispose(),ae(me)},me=>{Pe.dispose(),O.dispose(),be(me)})});return new class{cancel(){O.cancel(),O.dispose()}then(ae,be){return ie.then(ae,be)}catch(ae){return this.then(void 0,ae)}finally(ae){return ie.finally(ae)}}}function E(G,O,J){return new Promise((ie,ae)=>{const be=O.onCancellationRequested(()=>{be.dispose(),ie(J)});G.then(ie,ae).finally(()=>be.dispose())})}function a(G,O){return new Promise((J,ie)=>{const ae=O.onCancellationRequested(()=>{ae.dispose(),ie(new L.$5)});G.then(J,ie).finally(()=>ae.dispose())})}async function c(G){let O=-1;const J=G.map((ie,ae)=>ie.then(be=>(O=ae,be)));try{return await Promise.race(J)}finally{G.forEach((ie,ae)=>{ae!==O&&ie.cancel()})}}function g(G,O,J){let ie;const ae=setTimeout(()=>{ie?.(void 0),J?.()},O);return Promise.race([G.finally(()=>clearTimeout(ae)),new Promise(be=>ie=be)])}function f(G){return new Promise((O,J)=>{const ie=G();y(ie)?ie.then(O,J):O(ie)})}function s(){let G,O;return{promise:new Promise((ie,ae)=>{G=ie,O=ae}),resolve:G,reject:O}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(O){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=O,!this.b){const J=()=>{if(this.b=null,this.f)return;const ie=this.queue(this.d);return this.d=null,ie};this.b=new Promise(ie=>{this.a.then(J,J).then(ie)})}return new Promise((J,ie)=>{this.b.then(J,ie)})}return this.a=O(),new Promise((J,ie)=>{this.a.then(ae=>{this.a=null,J(ae)},ae=>{this.a=null,ie(ae)})})}dispose(){this.f=!0}}e.$uh=n;class m{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.$vh=m;class p{constructor(){this.a=new Map}queue(O,J){const ae=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(J).finally(()=>{this.a.get(O)===ae&&this.a.delete(O)});return this.a.set(O,ae),ae}}e.$wh=p;const i=(G,O)=>{let J=!0;const ie=setTimeout(()=>{J=!1,O()},G);return{isTriggered:()=>J,dispose:()=>{clearTimeout(ie),J=!1}}},t=G=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,G())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class o{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,J=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((ae,be)=>{this.d=ae,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const ae=this.g;return this.g=null,ae()}}));const ie=()=>{this.a=null,this.d?.(null)};return this.a=J===l.$ce?t(ie):i(J,ie),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=o;class k{constructor(O){this.a=new o(O),this.b=new n}trigger(O,J){return this.a.trigger(()=>this.b.queue(O),J)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=k;class ${constructor(){this.a=!1,this.b=new Promise((O,J)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=$;class S extends ${constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.$Ah=S;function v(G,O){return O?new Promise((J,ie)=>{const ae=setTimeout(()=>{be.dispose(),J()},G),be=O.onCancellationRequested(()=>{clearTimeout(ae),be.dispose(),ie(new L.$5)})}):u(J=>v(G,J))}function b(G,O=0,J){const ie=setTimeout(()=>{G(),J&&ae.dispose()},O),ae=(0,D.$Sc)(()=>{clearTimeout(ie),J?.deleteAndLeak(ae)});return J?.add(ae),ae}function U(G){const O=[];let J=0;const ie=G.length;function ae(){return J<ie?G[J++]():null}function be(Pe){Pe!=null&&O.push(Pe);const me=ae();return me?me.then(be):Promise.resolve(O)}return Promise.resolve(null).then(be)}function Z(G,O=ie=>!!ie,J=null){let ie=0;const ae=G.length,be=()=>{if(ie>=ae)return Promise.resolve(J);const Pe=G[ie++];return Promise.resolve(Pe()).then(ge=>O(ge)?Promise.resolve(ge):be())};return be()}function T(G,O=ie=>!!ie,J=null){if(G.length===0)return Promise.resolve(J);let ie=G.length;const ae=()=>{ie=-1;for(const be of G)be.cancel?.()};return new Promise((be,Pe)=>{for(const me of G)me.then(ge=>{--ie>=0&&O(ge)?(ae(),be(ge)):ie===0&&be(J)}).catch(ge=>{--ie>=0&&(ae(),Pe(ge))})})}class I{constructor(O){this.a=0,this.b=!1,this.f=O,this.g=[],this.d=0,this.h=new C.$he}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(O){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((J,ie)=>{this.g.push({factory:O,c:J,e:ie}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const O=this.g.shift();this.d++;const J=O.factory();J.then(O.c,O.e),J.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=I;class d extends I{constructor(){super(1)}}e.$Hh=d;class N{constructor(){this.a=new Q,this.b=0}queue(O){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,O())):this.a.run(this.b++,O())}}e.$Ih=N;class A{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const O=new W;return this.b.add(O),O.p}g(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueSize(O,J=R.$4g){const ie=J.getComparisonKey(O);return this.a.get(ie)?.size??0}queueFor(O,J,ie=R.$4g){const ae=ie.getComparisonKey(O);let be=this.a.get(ae);if(!be){be=new d;const Pe=this.f++,me=C.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete(ae),this.h(),this.d?.deleteAndDispose(Pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$4c),this.d.set(Pe,me),this.a.set(ae,be)}return be.queue(J)}h(){this.g()&&this.j()}j(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=A;class M{constructor(O,J){this.a=-1,typeof O=="function"&&typeof J=="number"&&this.setIfNotSet(O,J)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,J){this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},J)}setIfNotSet(O,J){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},J))}}e.$Kh=M;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(O,J,ie=globalThis){this.cancel();const ae=ie.setInterval(()=>{O()},J);this.d=(0,D.$Sc)(()=>{ie.clearInterval(ae),this.d=void 0})}dispose(){this.cancel()}}e.$Lh=q;class _{constructor(O,J){this.b=-1,this.a=O,this.d=J,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=_;class V{constructor(O,J){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.a=O,this.b=J,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=V;class x extends _{constructor(O,J){super(O,J),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.$Oh=x;class re extends D.$Uc{constructor(O,J){super(),this.g=O,this.h=J,this.a=[],this.b=this.B(new D.$Vc),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const J of O)this.a.push(J);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(G,O)=>{(0,P.$B)(()=>{if(J)return;const ie=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$Rh=(G,O,J)=>{const ie=G.requestIdleCallback(O,typeof J=="number"?{timeout:J}:void 0);let ae=!1;return{dispose(){ae||(ae=!0,G.cancelIdleCallback(ie))}}},e.$Qh=G=>(0,e.$Rh)(globalThis,G)}();class he{constructor(O,J){this.g=!1,this.d=()=>{try{this.j=J()}catch(ie){this.l=ie}finally{this.g=!0}},this.f=(0,e.$Rh)(O,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=he;class X extends he{constructor(O){super(globalThis,O)}}e.$Th=X;async function z(G,O,J){let ie;for(let ae=0;ae<J;ae++)try{return await G()}catch(be){ie=be,await v(O)}throw ie}class Q{isRunning(O){return typeof O=="number"?this.a?.taskId===O:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(O,J,ie){return this.a={taskId:O,cancel:()=>ie?.(),promise:J},J.then(()=>this.d(O),()=>this.d(O)),J}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}queue(O){if(this.b)this.b.run=O;else{const{promise:J,resolve:ie,reject:ae}=s();this.b={run:O,promise:J,promiseResolve:ie,promiseReject:ae}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=Q;class ee{constructor(O,J=()=>Date.now()){this.d=O,this.f=J,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.$Wh=ee;var le;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(le||(le={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((O,J)=>{this.a=O,this.b=J})}complete(O){return new Promise(J=>{this.a(O),this.d={outcome:0,value:O},J()})}error(O){return new Promise(J=>{this.b(O),this.d={outcome:1,value:O},J()})}cancel(){return this.error(new L.$5)}}e.$Xh=W;var ce;(function(G){async function O(ie){let ae;const be=await Promise.all(ie.map(Pe=>Pe.then(me=>me,me=>{ae||(ae=me)})));if(typeof ae<"u")throw ae;return be}G.settled=O;function J(ie){return new Promise(async(ae,be)=>{try{await ie(ae,be)}catch(Pe){be(Pe)}})}G.withAsyncBody=J})(ce||(e.Promises=ce={}));class te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(O){this.a=void 0,this.b=void 0,this.d=!1,this.promise=O.then(J=>(this.a=J,this.d=!0,J),J=>{throw this.b=J,this.d=!0,J})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=te;class h{constructor(O){this.b=O,this.a=new r.$V(()=>new te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=h;var F;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(F||(F={}));class ne{static fromArray(O){return new ne(J=>{J.emitMany(O)})}static fromPromise(O){return new ne(async J=>{J.emitMany(await O)})}static fromPromises(O){return new ne(async J=>{await Promise.all(O.map(async ie=>J.emitOne(await ie)))})}static merge(O){return new ne(async J=>{await Promise.all(O.map(async ie=>{for await(const ae of ie)J.emitOne(ae)}))})}static{this.EMPTY=ne.fromArray([])}constructor(O,J){this.a=0,this.b=[],this.d=null,this.f=J,this.g=new C.$he,queueMicrotask(async()=>{const ie={emitOne:ae=>this.h(ae),emitMany:ae=>this.j(ae),reject:ae=>this.l(ae)};try{await Promise.resolve(O(ie)),this.k()}catch(ae){this.l(ae)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(O,J){return new ne(async ie=>{for await(const ae of O)ie.emitOne(J(ae))})}map(O){return ne.map(this,O)}static filter(O,J){return new ne(async ie=>{for await(const ae of O)J(ae)&&ie.emitOne(ae)})}filter(O){return ne.filter(this,O)}static coalesce(O){return ne.filter(O,J=>!!J)}coalesce(){return ne.coalesce(this)}static async toPromise(O){const J=[];for await(const ie of O)J.push(ie);return J}toPromise(){return ne.toPromise(this)}h(O){this.a===0&&(this.b.push(O),this.g.fire())}j(O){this.a===0&&(this.b=this.b.concat(O),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(O){this.a===0&&(this.a=2,this.d=O,this.g.fire())}}e.$1h=ne;class j extends ne{constructor(O,J){super(J),this.m=O}cancel(){this.m.cancel()}}e.$2h=j;function Y(G){const O=new w.$se,J=G(O.token);return new j(O,async ie=>{const ae=O.token.onCancellationRequested(()=>{ae.dispose(),O.dispose(),ie.reject(new L.$5)});try{for await(const be of J){if(O.token.isCancellationRequested)return;ie.emitOne(be)}ae.dispose(),O.dispose()}catch(be){ae.dispose(),O.dispose(),ie.reject(be)}})}class H{constructor(O){this.a=new W,this.b=new ne(ae=>{if(J){ae.reject(J);return}return ie&&ae.emitMany(ie),this.d=be=>ae.reject(be),this.f=be=>ae.emitOne(be),this.a.p},O);let J,ie;this.f=ae=>{ie||(ie=[]),ie.push(ae)},this.d=ae=>{J||(J=ae)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(O){this.d(O),this.a.complete()}emitOne(O){this.f(O)}}e.$4h=H}),define(fe[60],de([0,1,18,6]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=void 0,e.$En=P,e.$Fn=r,e.$Gn=y;function C(u){return u.toJSON()}class D{constructor(E){this.a=E}transformIncoming(E){const a=this.a.transformIncoming(E);return a===E?E:C(L.URI.from(a))}transformOutgoing(E){const a=this.a.transformOutgoing(E);return a===E?E:C(L.URI.from(a))}transformOutgoingURI(E){const a=this.a.transformOutgoing(E);return a===E?E:L.URI.from(a)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Cn=D,e.$Dn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function R(u,E,a){if(!u||a>200)return null;if(typeof u=="object"){if(u instanceof L.URI)return E.transformOutgoing(u);for(const c in u)if(Object.hasOwnProperty.call(u,c)){const g=R(u[c],E,a+1);g!==null&&(u[c]=g)}}return null}function P(u,E){const a=R(u,E,0);return a===null?u:a}function l(u,E,a,c){if(!u||c>200)return null;if(typeof u=="object"){if(u.$mid===1)return a?L.URI.revive(E.transformIncoming(u)):E.transformIncoming(u);if(u instanceof w.$Je)return null;for(const g in u)if(Object.hasOwnProperty.call(u,g)){const f=l(u[g],E,a,c+1);f!==null&&(u[g]=f)}}return null}function r(u,E){const a=l(u,E,!1,0);return a===null?u:a}function y(u,E){const a=l(u,E,!0,0);return a===null?u:a}}),define(fe[24],de([0,1,106,20,107,12,32,45,5,3,23,6]),function(oe,e,w,L,C,D,R,P,l,r,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=m,e.whenDeleted=t,e.configureFlushOnWrite=v,e.writeFileSync=U;var E;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(E||(e.RimRafMode=E={}));async function a(V,x=E.UNLINK,re){if((0,R.$Dg)(V))throw new Error("rimraf - will refuse to recursively delete root");return x===E.UNLINK?g(V):c(V,re)}async function c(V,x=(0,R.$Ig)((0,L.tmpdir)())){try{try{await w.promises.rename(V,x)}catch(re){return re.code==="ENOENT"?void 0:g(V)}g(x).catch(re=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function g(V){return(0,C.promisify)(w.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function f(V){if((0,R.$Dg)(V))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function s(V,x){return p(await(x?n(V):(0,C.promisify)(w.readdir)(V)))}async function n(V){try{return await(0,C.promisify)(w.readdir)(V,{withFileTypes:!0})}catch(he){console.warn("[node.js fs] readdir with filetypes failed with error: ",he)}const x=[],re=await s(V);for(const he of re){let X=!1,z=!1,Q=!1;try{const ee=await e.Promises.lstat((0,l.$jc)(V,he));X=ee.isFile(),z=ee.isDirectory(),Q=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}x.push({name:he,isFile:()=>X,isDirectory:()=>z,isSymbolicLink:()=>Q})}return x}function m(V){return p(w.readdirSync(V))}function p(V){return V.map(x=>typeof x=="string"?r.$j?(0,P.$fm)(x):x:(x.name=r.$j?(0,P.$fm)(x.name):x.name,x))}async function i(V){const x=await s(V),re=[];for(const he of x)await o.existsDirectory((0,l.$jc)(V,he))&&re.push(he);return re}function t(V,x=1e3){return new Promise(re=>{let he=!1;const X=setInterval(()=>{he||(he=!0,w.access(V,z=>{he=!1,z&&(clearInterval(X),re(void 0))}))},x)})}var o;(function(V){async function x(X){let z;try{if(z=await e.Promises.lstat(X),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(r.$i&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ee}throw Q}}V.stat=x;async function re(X){try{const{stat:z,symbolicLink:Q}=await V.stat(X);return z.isFile()&&Q?.dangling!==!0}catch{}return!1}V.existsFile=re;async function he(X){try{const{stat:z,symbolicLink:Q}=await V.stat(X);return z.isDirectory()&&Q?.dangling!==!0}catch{}return!1}V.existsDirectory=he})(o||(e.SymlinkSupport=o={}));const k=new D.$Jh;function $(V,x,re){return k.queueFor(u.URI.file(V),()=>{const he=Z(re);return new Promise((X,z)=>b(V,x,he,Q=>Q?z(Q):X()))},y.$5g)}let S=!0;function v(V){S=V}function b(V,x,re,he){if(!S)return w.writeFile(V,x,{mode:re.mode,flag:re.flag},he);w.open(V,re.flag,re.mode,(X,z)=>{if(X)return he(X);w.writeFile(z,x,Q=>{if(Q)return w.close(z,()=>he(Q));w.fdatasync(z,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),v(!1)),w.close(z,le=>he(le))))})})}function U(V,x,re){const he=Z(re);if(!S)return w.writeFileSync(V,x,{mode:he.mode,flag:he.flag});const X=w.openSync(V,he.flag,he.mode);try{w.writeFileSync(X,x);try{w.fdatasyncSync(X)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),v(!1)}}finally{w.closeSync(X)}}function Z(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function T(V,x,re=6e4){if(V!==x)try{r.$i&&typeof re=="number"?await I(V,x,Date.now(),re):await(0,C.promisify)(w.rename)(V,x)}catch(he){if(V.toLowerCase()!==x.toLowerCase()&&he.code==="EXDEV"||V.endsWith("."))await d(V,x,{preserveSymlinks:!1}),await a(V,E.MOVE);else throw he}}async function I(V,x,re,he,X=0){try{return await(0,C.promisify)(w.rename)(V,x)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-re>=he)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${z}`),z;if(X===0){let Q=!1;try{const{stat:ee}=await o.stat(x);ee.isFile()||(Q=!0)}catch{}if(Q)throw z}return await(0,D.$Bh)(Math.min(100,X*10)),I(V,x,re,he,X+1)}}async function d(V,x,re){return A(V,x,{root:{source:V,target:x},options:re,handledSourcePaths:new Set})}const N=511;async function A(V,x,re){if(re.handledSourcePaths.has(V))return;re.handledSourcePaths.add(V);const{stat:he,symbolicLink:X}=await o.stat(V);if(X){if(re.options.preserveSymlinks)try{return await _(V,x,re)}catch{}if(X.dangling)return}return he.isDirectory()?M(V,x,he.mode&N,re):q(V,x,he.mode&N)}async function M(V,x,re,he){await e.Promises.mkdir(x,{recursive:!0,mode:re});const X=await s(V);for(const z of X)await A((0,l.$jc)(V,z),(0,l.$jc)(x,z),he)}async function q(V,x,re){await e.Promises.copyFile(V,x),await e.Promises.chmod(x,re)}async function _(V,x,re){let he=await e.Promises.readlink(V);(0,R.$zg)(he,re.root.source,!r.$k)&&(he=(0,l.$jc)(re.root.target,he.substr(re.root.source.length+1))),await e.Promises.symlink(he,x)}e.Promises=new class{get access(){return(0,C.promisify)(w.access)}get stat(){return(0,C.promisify)(w.stat)}get lstat(){return(0,C.promisify)(w.lstat)}get utimes(){return(0,C.promisify)(w.utimes)}get read(){return(V,x,re,he,X)=>new Promise((z,Q)=>{w.read(V,x,re,he,X,(ee,le,W)=>ee?Q(ee):z({bytesRead:le,buffer:W}))})}get readFile(){return(0,C.promisify)(w.readFile)}get write(){return(V,x,re,he,X)=>new Promise((z,Q)=>{w.write(V,x,re,he,X,(ee,le,W)=>ee?Q(ee):z({bytesWritten:le,buffer:W}))})}get appendFile(){return(0,C.promisify)(w.appendFile)}get fdatasync(){return(0,C.promisify)(w.fdatasync)}get truncate(){return(0,C.promisify)(w.truncate)}get copyFile(){return(0,C.promisify)(w.copyFile)}get open(){return(0,C.promisify)(w.open)}get close(){return(0,C.promisify)(w.close)}get symlink(){return(0,C.promisify)(w.symlink)}get readlink(){return(0,C.promisify)(w.readlink)}get chmod(){return(0,C.promisify)(w.chmod)}get mkdir(){return(0,C.promisify)(w.mkdir)}get unlink(){return(0,C.promisify)(w.unlink)}get rmdir(){return(0,C.promisify)(w.rmdir)}get realpath(){return(0,C.promisify)(w.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return i}get writeFile(){return $}get rm(){return a}get rename(){return T}get copy(){return d}}}),define(fe[61],de([0,1,20,5,24]),function(oe,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=n,e.$pm=m;const D=/^\d+$/,R=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var l;(function(p){p[p.x64=0]="x64",p[p.x86=1]="x86",p[p.ARM=2]="ARM"})(l||(l={}));let r;switch(process.arch){case"ia32":r=1;break;case"arm":case"arm64":r=2;break;default:r=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class u{constructor(i,t,o){this.exePath=i,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await C.SymlinkSupport.existsFile(this.exePath)),this.a}}function E({useAlternateBitness:p=!1}={}){return p?r===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function a({useAlternateBitness:p=!1,findPreview:i=!1}={}){const t=E({useAlternateBitness:p});if(!t)return null;const o=L.$jc(t,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(o))return null;let k=-1,$=null;for(const b of await C.Promises.readdir(o)){let U=-1;if(i){const T=b.indexOf("-");if(T<0)continue;const I=b.substring(0,T);if(!D.test(I)||b.substring(T+1)!=="preview")continue;U=parseInt(I,10)}else{if(!D.test(b))continue;U=parseInt(b,10)}if(U<=k)continue;const Z=L.$jc(o,b,"pwsh.exe");await C.SymlinkSupport.existsFile(Z)&&($=Z,k=U)}if(!$)return null;const S=t.includes("x86")?" (x86)":"",v=i?" Preview":"";return new u($,`PowerShell${v}${S}`,!0)}async function c({findPreview:p}={}){if(!process.env.LOCALAPPDATA)return null;const i=L.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=p?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const k of await C.Promises.readdir(i))if(t.test(k)){const $=L.$jc(i,k,"pwsh.exe");return new u($,o)}return null}function g(){const p=L.$jc(w.homedir(),".dotnet","tools","pwsh.exe");return new u(p,".NET Core PowerShell Global Tool")}function f(){const p=L.$jc(process.env.windir,r===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(p,"Windows PowerShell",!0)}async function*s(){let p=await a();p&&(yield p),p=await a({useAlternateBitness:!0}),p&&(yield p),p=await c(),p&&(yield p),p=g(),p&&(yield p),p=await a({findPreview:!0}),p&&(yield p),p=await c({findPreview:!0}),p&&(yield p),p=await a({useAlternateBitness:!0,findPreview:!0}),p&&(yield p),p=f(),p&&(yield p)}async function*n(){for await(const p of s())await p.exists()&&(yield p)}async function m(){for await(const p of n())return p;return null}}),define(fe[34],de([0,1,5,3,15,33,10,24]),function(oe,e,w,L,C,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$sm=l,e.$tm=r,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function l(u=C.env){return u.comspec||"cmd.exe"}function r(u){let E=[],a=!1;const c=function(g){if(a){E.push(g);return}(!u.send(g,s=>{if(s&&console.error(s),a=!1,E.length>0){const n=E.slice(0);E=[],n.forEach(m=>c(m))}})||L.$i)&&(a=!0)};return{send:c}}var y;(function(u){async function E(a,c,g){if(w.$ic(a))return a;if(c===void 0&&(c=C.cwd()),w.$mc(a)!=="."||(g===void 0&&R.$ag(C.env.PATH)&&(g=C.env.PATH.split(w.$tc)),g===void 0||g.length===0))return w.$jc(c,a);async function s(n){if(await P.Promises.exists(n)){let m;try{m=await P.Promises.stat(n)}catch(p){p.message.startsWith("EACCES")&&(m=await P.Promises.lstat(n))}return m?!m.isDirectory():!1}return!1}for(const n of g){let m;if(w.$ic(n)?m=w.$jc(n,a):m=w.$jc(c,n,a),await s(m))return m;let p=m+".com";if(await s(p)||(p=m+".exe",await s(p)))return p}return w.$jc(c,a)}u.findExecutable=E})(y||(e.win32=y={}))}),define(fe[62],de([0,1,26,19]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=C;function C(R){return new Promise((P,l)=>{let r;const y=new Map;function u(a,c,g,f,s){const n=y.get(c);if(a===R||n){const m={name:E(g),cmd:g,pid:a,ppid:c,load:f,mem:s};y.set(a,m),a===R&&(r=m),n&&(n.children||(n.children=[]),n.children.push(m),n.children.length>1&&(n.children=n.children.sort((p,i)=>p.pid-i.pid)))}}function E(a){const c=/--utility-sub-type=network/i,g=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,s=/conhost\.exe.+--headless/i,n=/--type=([a-zA-Z-]+)/;if(g.exec(a))return"electron-crash-reporter";if(f.exec(a))return"winpty-agent";if(s.exec(a))return"conpty-agent";let m=n.exec(a);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?c.exec(a)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const p=/[a-zA-Z-]+\.js/g;let i="";do m=p.exec(a),m&&(i+=m+" ");while(m);return i&&a.indexOf("node ")<0&&a.indexOf("node.exe")<0?`electron-nodejs (${i})`:a}if(process.platform==="win32"){const a=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,g)=>{oe(["@vscode/windows-process-tree"],c,g)}).then(c=>{c.getProcessList(R,g=>{if(!g){l(new Error(`Root process ${R} not found`));return}c.getProcessCpuUsage(g,f=>{const s=new Map;f.forEach(n=>{const m=a(n.commandLine||"");s.set(n.pid,{name:E(m),cmd:m,pid:n.pid,ppid:n.ppid,load:n.cpu||0,mem:n.memory||0})}),r=s.get(R),r?(s.forEach(n=>{const m=s.get(n.ppid);m&&(m.children||(m.children=[]),m.children.push(n))}),s.forEach(n=>{n.children&&(n.children=n.children.sort((m,p)=>m.pid-p.pid))}),P(r)):l(new Error(`Root process ${R} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let a=function(){let c=[r];const g=[];for(;c.length;){const s=c.shift();s&&(g.push(s.pid),s.children&&(c=c.concat(s.children)))}let f=JSON.stringify(L.$Ug.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+g.join(" "),(0,w.exec)(f,{},(s,n,m)=>{if(s||m)l(s||new Error(m.toString()));else{const p=n.toString().split(`
`);for(let i=0;i<g.length;i++){const t=y.get(g[i]);t.load=parseFloat(p[i])}if(!r){l(new Error(`Root process ${R} not found`));return}P(r)}})};(0,w.exec)("which ps",{},(c,g,f)=>{if(c||f)if(process.platform!=="linux")l(c||new Error(f.toString()));else{const s=JSON.stringify(L.$Ug.asFileUri("vs/base/node/ps.sh").fsPath);(0,w.exec)(s,{},(n,m,p)=>{n||p?l(n||new Error(p.toString())):(D(m,u),a())})}else{const s=g.toString().trim();(0,w.exec)(`${s} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,p,i)=>{m||i&&!i.includes("screen size is bogus")?l(m||new Error(i.toString())):(D(p,u),process.platform==="linux"?a():r?P(r):l(new Error(`Root process ${R} not found`)))})}})}})}function D(R,P){const l=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=R.toString().split(`
`);for(const y of r){const u=l.exec(y.trim());u&&u.length===6&&P(parseInt(u[1]),parseInt(u[2]),u[5],parseFloat(u[3]),parseFloat(u[4]))}}}),define(fe[63],de([0,1,20,3,61,34]),function(oe,e,w,L,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=R;async function R(u,E){return u===1?L.$i?y():D.$sm(E):l(u,E)}let P=null;function l(u,E){if(L.$k&&u===2||L.$j&&u===3)return"/bin/bash";if(!P){let a;if(L.$i)a="/bin/bash";else{if(a=E.SHELL,!a)try{a=(0,w.userInfo)().shell}catch{}a||(a="sh"),a==="/bin/false"&&(a="/bin/bash")}P=a}return P}let r=null;async function y(){return r||(r=(await(0,C.$pm)()).exePath),r}});var $e=this&&this.__decorate||function(oe,e,w,L){var C=arguments.length,D=C<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,w):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(oe,e,w,L);else for(var P=oe.length-1;P>=0;P--)(R=oe[P])&&(D=(C<3?R(D):C>3?R(e,w,D):R(e,w))||D);return C>3&&D&&Object.defineProperty(e,w,D),D};define(fe[27],de([0,1,16,12,18,17,14,7,4,2,59,9,10]),function(oe,e,w,L,C,D,R,P,l,r,y,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=v,e.$bi=b,e.$gi=N,e.$hi=A;var a;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(a||(a={}));function c(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(g||(g={}));function f(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(s||(s={}));function n(X){let z=0;for(let Q=0;;Q+=7){const ee=X.read(1);if(z|=(ee.buffer[0]&127)<<Q,!(ee.buffer[0]&128))return z}}const m=k(0);function p(X,z){if(z===0){X.write(m);return}let Q=0;for(let le=z;le!==0;le=le>>>7)Q++;const ee=C.$Je.alloc(Q);for(let le=0;z!==0;le++)ee.buffer[le]=z&127,z=z>>>7,z>0&&(ee.buffer[le]|=128);X.write(ee)}class i{constructor(z){this.b=z,this.a=0}read(z){const Q=this.b.slice(this.a,this.a+z);return this.a+=Q.byteLength,Q}}e.$$h=i;class t{constructor(){this.a=[]}get buffer(){return C.$Je.concat(this.a)}write(z){this.a.push(z)}}e.$_h=t;var o;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(o||(o={}));function k(X){const z=C.$Je.alloc(1);return z.writeUInt8(X,0),z}const $={Undefined:k(o.Undefined),String:k(o.String),Buffer:k(o.Buffer),VSBuffer:k(o.VSBuffer),Array:k(o.Array),Object:k(o.Object),Uint:k(o.Int)},S=typeof Buffer<"u";function v(X,z){if(typeof z>"u")X.write($.Undefined);else if(typeof z=="string"){const Q=C.$Je.fromString(z);X.write($.String),p(X,Q.byteLength),X.write(Q)}else if(S&&Buffer.isBuffer(z)){const Q=C.$Je.wrap(z);X.write($.Buffer),p(X,Q.byteLength),X.write(Q)}else if(z instanceof C.$Je)X.write($.VSBuffer),p(X,z.byteLength),X.write(z);else if(Array.isArray(z)){X.write($.Array),p(X,z.length);for(const Q of z)v(X,Q)}else if(typeof z=="number"&&(z|0)===z)X.write($.Uint),p(X,z);else{const Q=C.$Je.fromString(JSON.stringify(z));X.write($.Object),p(X,Q.byteLength),X.write(Q)}}function b(X){switch(X.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return X.read(n(X)).toString();case o.Buffer:return X.read(n(X)).buffer;case o.VSBuffer:return X.read(n(X));case o.Array:{const Q=n(X),ee=[];for(let le=0;le<Q;le++)ee.push(b(X));return ee}case o.Object:return JSON.parse(X.read(n(X)).toString());case o.Int:return n(X)}}class U{constructor(z,Q,ee=null,le=1e3){this.h=z,this.j=Q,this.k=ee,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(W=>this.q(W)),this.m({type:200})}registerChannel(z,Q){this.b.set(z,Q),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case 200:{const Q=this.o([z.type]);this.k?.logOutgoing(Q,0,1,f(z.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([z.type,z.id],z.data);this.k?.logOutgoing(Q,z.id,1,f(z.type),z.data);return}}}o(z,Q=void 0){const ee=new t;return v(ee,z),v(ee,Q),this.p(ee.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const Q=new i(z),ee=b(Q),le=b(Q),W=ee[0];switch(W){case 100:return this.k?.logIncoming(z.byteLength,ee[1],1,`${c(W)}: ${ee[2]}.${ee[3]}`,le),this.s({type:W,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case 102:return this.k?.logIncoming(z.byteLength,ee[1],1,`${c(W)}: ${ee[2]}.${ee[3]}`,le),this.t({type:W,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case 101:return this.k?.logIncoming(z.byteLength,ee[1],1,`${c(W)}`),this.u({type:W,id:ee[1]});case 103:return this.k?.logIncoming(z.byteLength,ee[1],1,`${c(W)}`),this.u({type:W,id:ee[1]})}}s(z){const Q=this.b.get(z.channelName);if(!Q){this.v(z);return}const ee=new D.$se;let le;try{le=Q.call(this.j,z.name,z.arg,ee.token)}catch(te){le=Promise.reject(te)}const W=z.id;le.then(te=>{this.m({id:W,data:te,type:201})},te=>{te instanceof Error?this.m({id:W,data:{message:te.message,name:te.name,stack:te.stack?te.stack.split?te.stack.split(`
`):te.stack:void 0},type:202}):this.m({id:W,data:te,type:203})}).finally(()=>{ce.dispose(),this.d.delete(z.id)});const ce=(0,r.$Sc)(()=>ee.cancel());this.d.set(z.id,ce)}t(z){const Q=this.b.get(z.channelName);if(!Q){this.v(z);return}const ee=z.id,W=Q.listen(this.j,z.name,z.arg)(ce=>this.m({id:ee,data:ce,type:204}));this.d.set(z.id,W)}u(z){const Q=this.d.get(z.id);Q&&(Q.dispose(),this.d.delete(z.id))}v(z){let Q=this.g.get(z.channelName);Q||(Q=[],this.g.set(z.channelName,Q));const ee=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:z,timeoutTimer:ee})}w(z){const Q=this.g.get(z);if(Q){for(const ee of Q)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$ci=U;var Z;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(Z||(e.RequestInitiator=Z={}));class T{constructor(z,Q=null){this.l=z,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=Q}getChannel(z){const Q=this;return{call(ee,le,W){return Q.a?Promise.reject(new P.$5):Q.m(z,ee,le,W)},listen(ee,le){return Q.a?l.Event.None:Q.o(z,ee,le)}}}m(z,Q,ee,le=D.CancellationToken.None){const W=this.g++,te={id:W,type:100,channelName:z,name:Q,arg:ee};if(le.isCancellationRequested)return Promise.reject(new P.$5);let h;return new Promise((ne,j)=>{if(le.isCancellationRequested)return j(new P.$5);const Y=()=>{const J=ie=>{switch(ie.type){case 201:this.f.delete(W),ne(ie.data);break;case 202:{this.f.delete(W);const ae=new Error(ie.data.message);ae.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,ae.name=ie.data.name,j(ae);break}case 203:this.f.delete(W),j(ie.data);break}};this.f.set(W,J),this.p(te)};let H=null;this.b===s.Idle?Y():(H=(0,L.$nh)(J=>this.u()),H.then(()=>{H=null,Y()}));const G=()=>{H?(H.cancel(),H=null):this.p({id:W,type:101}),j(new P.$5)},O=le.onCancellationRequested(G);h=(0,r.$Rc)((0,r.$Sc)(G),O),this.d.add(h)}).finally(()=>{h.dispose(),this.d.delete(h)})}o(z,Q,ee){const le=this.g++,ce={id:le,type:102,channelName:z,name:Q,arg:ee};let te=null;const h=new l.$he({onWillAddFirstListener:()=>{te=(0,L.$nh)(ne=>this.u()),te.then(()=>{te=null,this.d.add(h),this.p(ce)})},onDidRemoveLastListener:()=>{te?(te.cancel(),te=null):(this.d.delete(h),this.p({id:le,type:103}))}}),F=ne=>h.fire(ne.data);return this.f.set(le,F),h.event}p(z){switch(z.type){case 100:case 102:{const Q=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(Q,z.id,0,`${c(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const Q=this.q([z.type,z.id]);this.j?.logOutgoing(Q,z.id,0,c(z.type));return}}}q(z,Q=void 0){const ee=new t;return v(ee,z),v(ee,Q),this.r(ee.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const Q=new i(z),ee=b(Q),le=b(Q),W=ee[0];switch(W){case 200:return this.j?.logIncoming(z.byteLength,0,0,f(W)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(z.byteLength,ee[1],0,f(W),le),this.t({type:ee[0],id:ee[1],data:le})}}t(z){if(z.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$di=T,$e([R.$5h],T.prototype,"onDidInitializePromise",null);class I{get connections(){const z=[];return this.f.forEach(Q=>z.push(Q)),z}constructor(z,Q,ee){this.a=new Map,this.f=new Set,this.g=new l.$he,this.onDidAddConnection=this.g.event,this.h=new l.$he,this.onDidRemoveConnection=this.h.event,this.j=new r.$Tc,this.j.add(z(({protocol:le,onDidClientDisconnect:W})=>{const ce=l.Event.once(le.onMessage);this.j.add(ce(te=>{const h=new i(te),F=b(h),ne=new U(le,F,Q,ee),j=new T(le,Q);this.a.forEach((H,G)=>ne.registerChannel(G,H));const Y={channelServer:ne,channelClient:j,ctx:F};this.f.add(Y),this.g.fire(Y),this.j.add(W(()=>{ne.dispose(),j.dispose(),this.f.delete(Y),this.h.fire(Y)}))}))}))}getChannel(z,Q){const ee=this;return{call(le,W,ce){let te;if((0,E.$og)(Q)){const F=(0,w.$3b)(ee.connections.filter(Q));te=F?Promise.resolve(F):l.Event.toPromise(l.Event.filter(ee.onDidAddConnection,Q))}else te=Q.routeCall(ee,le,W);const h=te.then(F=>F.channelClient.getChannel(z));return N(h).call(le,W,ce)},listen(le,W){if((0,E.$og)(Q))return ee.k(z,Q,le,W);const ce=Q.routeEvent(ee,le,W).then(te=>te.channelClient.getChannel(z));return N(ce).listen(le,W)}}}k(z,Q,ee,le){const W=this;let ce;const te=new l.$he({onWillAddFirstListener:()=>{ce=new r.$Tc;const h=new l.$ne,F=new Map,ne=Y=>{const G=Y.channelClient.getChannel(z).listen(ee,le),O=h.add(G);F.set(Y,O)},j=Y=>{const H=F.get(Y);H&&(H.dispose(),F.delete(Y))};W.connections.filter(Q).forEach(ne),l.Event.filter(W.onDidAddConnection,Q)(ne,void 0,ce),W.onDidRemoveConnection(j,void 0,ce),h.event(te.fire,te,ce),ce.add(h)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return te.event}registerChannel(z,Q){this.a.set(z,Q);for(const ee of this.f)ee.channelServer.registerChannel(z,Q)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=I;class d{constructor(z,Q,ee=null){const le=new t;v(le,Q),z.send(le.buffer),this.a=new T(z,ee),this.d=new U(z,Q,ee)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,Q){this.d.registerChannel(z,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=d;function N(X){return{call(z,Q,ee){return X.then(le=>le.call(z,Q,ee))},listen(z,Q){const ee=new l.$qe;return X.then(le=>ee.input=le.listen(z,Q)),ee.event}}}function A(X){let z=!1;return{call(Q,ee,le){return z?X.call(Q,ee,le):(0,L.$Bh)(0).then(()=>z=!0).then(()=>X.call(Q,ee,le))},listen(Q,ee){if(z)return X.listen(Q,ee);const le=new l.$qe;return(0,L.$Bh)(0).then(()=>z=!0).then(()=>le.input=X.listen(Q,ee)),le.event}}}class M{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const Q of z.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await l.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ii=M;var q;(function(X){function z(W,ce,te){const h=W,F=te&&te.disableMarshalling,ne=new Map;for(const j in h)ee(j)&&ne.set(j,l.Event.buffer(h[j],!0,void 0,ce));return new class{listen(j,Y,H){const G=ne.get(Y);if(G)return G;const O=h[Y];if(typeof O=="function"){if(le(Y))return O.call(h,H);if(ee(Y))return ne.set(Y,l.Event.buffer(h[Y],!0,void 0,ce)),ne.get(Y)}throw new P.$bb(`Event not found: ${Y}`)}call(j,Y,H){const G=h[Y];if(typeof G=="function"){if(!F&&Array.isArray(H))for(let J=0;J<H.length;J++)H[J]=(0,y.$0h)(H[J]);let O=G.apply(h,H);return O instanceof Promise||(O=Promise.resolve(O)),O}throw new P.$bb(`Method not found: ${Y}`)}}}X.fromService=z;function Q(W,ce){const te=ce&&ce.disableMarshalling;return new Proxy({},{get(h,F){if(typeof F=="string")return ce?.properties?.has(F)?ce.properties.get(F):le(F)?function(ne){return W.listen(F,ne)}:ee(F)?W.listen(F):async function(...ne){let j;ce&&!(0,E.$jg)(ce.context)?j=[ce.context,...ne]:j=ne;const Y=await W.call(F,j);return te?Y:(0,y.$0h)(Y)};throw new P.$bb(`Property not found: ${String(F)}`)}})}X.toService=Q;function ee(W){return W[0]==="o"&&W[1]==="n"&&u.$Af(W.charCodeAt(2))}function le(W){return/^onDynamic/.test(W)&&u.$Af(W.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const _=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const z=X.toString();if(z!=="[object Object]")return z}return X}function x(X){return Array.isArray(X)?X.map(V):V(X)}function re(X,z,Q,ee,le,W,ce){ce=x(ce);const te=_[le],h=te[ee%te.length];let F=[`%c[${X}]%c[${String(z).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test(W)?(F=F.concat(ce),F.push(")")):F.push(ce),console.log.apply(console,F)}class he{constructor(z,Q){this.d=z,this.f=Q,this.a=0,this.b=0}logOutgoing(z,Q,ee,le,W){this.b+=z,re(this.d,this.b,z,Q,ee,le,W)}logIncoming(z,Q,ee,le,W){this.a+=z,re(this.f,this.a,z,Q,ee,le,W)}}e.$ji=he}),define(fe[64],de([0,1,26,12,18,17,58,7,4,2,30,34,33,27]),function(oe,e,w,L,C,D,R,P,l,r,y,u,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=void 0;class c extends a.$ci{constructor(s){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",n=>C.$Je.wrap(Buffer.from(n,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$6q=c;class g{constructor(s,n){this.i=s,this.j=n,this.c=new Set,this.g=new Map,this.h=new l.$he,this.onDidProcessExit=this.h.event;const m=n&&n.timeout?n.timeout:6e4;this.b=new L.$xh(m),this.d=null,this.f=null}getChannel(s){const n=this;return{call(m,p,i){return n.k(s,m,p,i)},listen(m,p){return n.l(s,m,p)}}}k(s,n,m,p=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const i=this.n(s),t=(0,L.$nh)($=>i.call(n,m,$)),o=p.onCancellationRequested(()=>t.cancel()),k=(0,r.$Sc)(()=>t.cancel());return this.c.add(k),t.finally(()=>{o.dispose(),this.c.delete(k),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,n,m){if(!this.b)return l.Event.None;this.b.cancel();let p;const i=new l.$he({onWillAddFirstListener:()=>{p=this.n(s).listen(n,m)(i.fire,i),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,y.$7n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(v=>!/^--inspect(-brk)?=/.test(v)).filter(v=>!v.startsWith("--vscode-"))),(0,E.$rm)(n.env),this.d=(0,w.fork)(this.i,s,n);const m=new l.$he,i=l.Event.fromNodeEventEmitter(this.d,"message",v=>v)(v=>{if((0,R.$2q)(v)){(0,R.log)(v,`IPC Library: ${this.j.serverName}`);return}m.fire(C.$Je.wrap(Buffer.from(v,"base64")))}),t=this.j.useQueue?(0,u.$tm)(this.d):this.d,o=v=>this.d&&this.d.connected&&t.send(v.buffer.toString("base64")),k=m.event,$={send:o,onMessage:k};this.f=new a.$di($);const S=()=>this.o();process.once("exit",S),this.d.on("error",v=>console.warn('IPC "'+this.j.serverName+'" errored with '+v)),this.d.on("exit",(v,b)=>{process.removeListener("exit",S),i.dispose(),this.c.forEach(U=>(0,r.$Pc)(U)),this.c.clear(),v!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+v+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:v,signal:b})})}return this.f}n(s){let n=this.g.get(s);return n||(n=this.m.getChannel(s),this.g.set(s,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7q=g}),define(fe[65],de([0,1,31,18,27,4,10,16]),function(oe,e,w,L,C,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zW=void 0,e.$AW=y;class l{constructor(E){this.a=E,this.onMessage=D.Event.fromNodeEventEmitter(this.a,"message",a=>a.data?L.$Je.wrap(a.data):L.$Je.alloc(0)),E.start()}send(E){this.a.postMessage(E.buffer)}disconnect(){this.a.close()}}class r extends C.$ei{static b(E){(0,R.$kg)((0,w.$yW)(process),"Electron Utility Process");const a=new D.$he;return process.parentPort.on("message",c=>{if(E?.handledClientConnection(c))return;const g=(0,P.$Ob)(c.ports);g&&a.fire(g)}),D.Event.map(a.event,c=>({protocol:new l(c),onDidClientDisconnect:D.Event.fromNodeEventEmitter(c,"close")}))}constructor(E){super(r.b(E))}}e.$zW=r;function y(u,E,a){const c=g=>{g.data===E&&(u.removeListener("message",c),a())};u.on("message",c)}}),define(fe[66],de([13,11]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(fe[67],de([13,11]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(fe[68],de([13,11]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(fe[69],de([13,11]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(fe[70],de([13,11]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(fe[71],de([13,11]),function(oe,e){return oe.create("vs/platform/terminal/node/ptyService",e)}),define(fe[72],de([13,11]),function(oe,e){return oe.create("vs/platform/terminal/node/terminalProcess",e)}),define(fe[73],de([0,1,7,67]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var C;(function(r){r[r.LParen=0]="LParen",r[r.RParen=1]="RParen",r[r.Neg=2]="Neg",r[r.Eq=3]="Eq",r[r.NotEq=4]="NotEq",r[r.Lt=5]="Lt",r[r.LtEq=6]="LtEq",r[r.Gt=7]="Gt",r[r.GtEq=8]="GtEq",r[r.RegexOp=9]="RegexOp",r[r.RegexStr=10]="RegexStr",r[r.True=11]="True",r[r.False=12]="False",r[r.In=13]="In",r[r.Not=14]="Not",r[r.And=15]="And",r[r.Or=16]="Or",r[r.Str=17]="Str",r[r.QuotedStr=18]="QuotedStr",r[r.Error=19]="Error",r[r.EOF=20]="EOF"})(C||(e.TokenType=C={}));function D(...r){switch(r.length){case 1:return(0,L.localize)(0,null,r[0]);case 2:return(0,L.localize)(1,null,r[0],r[1]);case 3:return(0,L.localize)(2,null,r[0],r[1],r[2]);default:return}}const R=(0,L.localize)(3,null),P=(0,L.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,w.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const u=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:u})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const u=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:u})}else this.h(126)?this.k(9):this.l(D("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(D("&&"));break;case 124:this.h(124)?this.k(16):this.l(D("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,E=this.c.substring(this.d,this.e),a={type:19,offset:this.d,lexeme:E};this.g.push({offset:u,lexeme:E,additionalInfo:y}),this.f.push(a)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),E=l.b.get(u);E?this.k(E):this.f.push({type:17,lexeme:u,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,E=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(P);return}const c=this.c.charCodeAt(y);if(u)u=!1;else if(c===47&&!E){y++;break}else c===91?E=!0:c===92?u=!0:c===93&&(E=!1);y++}for(;y<this.c.length&&l.a.has(this.c.charCodeAt(y));)y++;this.e=y;const a=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=l}),define(fe[74],de([0,1,54,14,19,5,15,23,6]),function(oe,e,w,L,C,D,R,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=void 0,e.$$m=y,e.$_m=u,e.$9m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,D.$mc)(C.$Ug.asFileUri("").fsPath)}get userHome(){return l.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return l.URI.file((0,D.$jc)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.b.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,P.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const a=(0,w.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$jc)(this.userDataPath,"logs",a)}return l.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$bh)(l.URI.file((0,D.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=R.env.VSCODE_PORTABLE;return a?l.URI.file((0,D.$jc)(a,"argv.json")):(0,P.$bh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,D.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,D.$kc)(a):(0,D.$hc)((0,D.$jc)(C.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const a=this.args["extensions-download-dir"];return a?l.URI.file((0,D.$kc)(a)):l.URI.file((0,D.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,D.$kc)(a);const c=R.env.VSCODE_EXTENSIONS;if(c)return c;const g=R.env.VSCODE_PORTABLE;return g?(0,D.$jc)(g,"extensions"):(0,P.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(c=>/^[^:/?#]+?:\/\//.test(c)?l.URI.parse(c):l.URI.file((0,D.$hc)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?l.URI.parse(a):l.URI.file((0,D.$hc)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(a=>!e.$9m.test(a))}get extensionLogLevel(){const a=[];for(const c of this.args.log||[]){const g=e.$9m.exec(c);g&&g[1]&&g[2]&&a.push([g[1],g[2]])}return a.length?a:void 0}get serviceMachineIdResource(){return(0,P.$bh)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const a=R.env.VSCODE_PORTABLE;return a?l.URI.file((0,D.$jc)(a,"policy.json")):(0,P.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(a){this.args.continueOn=a}get args(){return this.a}constructor(a,c,g){this.a=a,this.b=c,this.c=g,this.editSessionId=this.args.editSessionId}}e.$0m=r,$e([L.$5h],r.prototype,"appRoot",null),$e([L.$5h],r.prototype,"userHome",null),$e([L.$5h],r.prototype,"userDataPath",null),$e([L.$5h],r.prototype,"appSettingsHome",null),$e([L.$5h],r.prototype,"tmpDir",null),$e([L.$5h],r.prototype,"cacheHome",null),$e([L.$5h],r.prototype,"stateResource",null),$e([L.$5h],r.prototype,"userRoamingDataHome",null),$e([L.$5h],r.prototype,"userDataSyncHome",null),$e([L.$5h],r.prototype,"sync",null),$e([L.$5h],r.prototype,"machineSettingsResource",null),$e([L.$5h],r.prototype,"workspaceStorageHome",null),$e([L.$5h],r.prototype,"localHistoryHome",null),$e([L.$5h],r.prototype,"keyboardLayoutResource",null),$e([L.$5h],r.prototype,"argvResource",null),$e([L.$5h],r.prototype,"isExtensionDevelopment",null),$e([L.$5h],r.prototype,"untitledWorkspacesHome",null),$e([L.$5h],r.prototype,"builtinExtensionsPath",null),$e([L.$5h],r.prototype,"extensionsPath",null),$e([L.$5h],r.prototype,"extensionDevelopmentLocationURI",null),$e([L.$5h],r.prototype,"extensionDevelopmentKind",null),$e([L.$5h],r.prototype,"extensionTestsLocationURI",null),$e([L.$5h],r.prototype,"debugExtensionHost",null),$e([L.$5h],r.prototype,"logLevel",null),$e([L.$5h],r.prototype,"extensionLogLevel",null),$e([L.$5h],r.prototype,"serviceMachineIdResource",null),$e([L.$5h],r.prototype,"disableTelemetry",null),$e([L.$5h],r.prototype,"disableWorkspaceTrust",null),$e([L.$5h],r.prototype,"useInMemorySecretStorage",null),$e([L.$5h],r.prototype,"policyFile",null);function y(E,a){return u(E["inspect-extensions"],E["inspect-brk-extensions"],5870,a,E.debugId,E.extensionEnvironment)}function u(E,a,c,g,f,s){const m=Number(a||E)||(g?null:c),p=m?!!a:!1;let i;if(s)try{i=JSON.parse(s)}catch{}return{port:m,break:p,debugId:f,env:i}}}),define(fe[75],de([0,1,108,3,68]),function(oe,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0,e.$xm=P,e.$ym=r,e.$zm=a,e.$Am=c;const D={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.$vm=["tunnel","serve-web"],e.$wm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,C.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,C.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(g,f,s=R){const n=g.find(v=>v.length>0&&v[0]!=="-"),m={},p=["_"],i=[],t={};let o;for(const v in f){const b=f[v];b.type==="subcommand"?v===n&&(o=b):(b.alias&&(m[v]=b.alias),b.type==="string"||b.type==="string[]"?(p.push(v),b.deprecates&&p.push(...b.deprecates)):b.type==="boolean"&&(i.push(v),b.deprecates&&i.push(...b.deprecates)),b.global&&(t[v]=b))}if(o&&n){const v=t;for(const T in o.options)v[T]=o.options[T];const b=g.filter(T=>T!==n),U=s.getSubcommandReporter?s.getSubcommandReporter(n):void 0,Z=P(b,v,U);return{[n]:Z,_:[]}}const k=w(g,{string:p,boolean:i,alias:m}),$={},S=k;$._=k._.map(v=>String(v)).filter(v=>v.length>0),delete S._;for(const v in f){const b=f[v];if(b.type==="subcommand")continue;b.alias&&delete S[b.alias];let U=S[v];if(b.deprecates)for(const Z of b.deprecates)S.hasOwnProperty(Z)&&(U||(U=S[Z],U&&s.onDeprecatedOption(Z,b.deprecationMessage||(0,C.localize)(39,null,v))),delete S[Z]);if(typeof U<"u"){if(b.type==="string[]"){if(Array.isArray(U)||(U=[U]),!b.allowEmptyValue){const Z=U.filter(T=>T.length>0);Z.length!==U.length&&(s.onEmptyValue(v),U=Z.length>0?Z:void 0)}}else b.type==="string"&&(Array.isArray(U)?(U=U.pop(),s.onMultipleValues(v,U)):!U&&!b.allowEmptyValue&&(s.onEmptyValue(v),U=void 0));$[v]=U,b.deprecationMessage&&s.onDeprecatedOption(v,b.deprecationMessage)}delete S[v]}for(const v in S)s.onUnknownOption(v);return $}function l(g,f){let s="";return f.args&&(Array.isArray(f.args)?s=` <${f.args.join("> <")}>`:s=` <${f.args}>`),f.alias?`-${f.alias} --${g}${s}`:`--${g}${s}`}function r(g,f){const s=[];for(const n in g){const m=g[n],p=l(n,m);s.push([p,m.description])}return y(s,f)}function y(g,f){const n=g.reduce((i,t)=>Math.max(i,t[0].length),12)+2+1;if(f-n<25)return g.reduce((i,t)=>i.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const m=f-n-1,p=[];for(const i of g){const t=i[0],o=E(i[1],m),k=u(n-t.length-2);p.push("  "+t+k+o[0]);for(let $=1;$<o.length;$++)p.push(u(n)+o[$])}return p}function u(g){return" ".repeat(g)}function E(g,f){const s=[];for(;g.length;){const n=g.length<f?g.length:g.lastIndexOf(" ",f),m=g.slice(0,n).trim();g=g.slice(n),s.push(m)}return s}function a(g,f,s,n,m){const p=process.stdout.isTTY&&process.stdout.columns||80,i=m?.noInputFiles!==!0?`[${(0,C.localize)(40,null)}...]`:"",t=[`${g} ${s}`];t.push(""),t.push(`${(0,C.localize)(41,null)}: ${f} [${(0,C.localize)(42,null)}]${i}`),t.push(""),m?.noPipe!==!0&&(L.$i?t.push((0,C.localize)(43,null,f)):t.push((0,C.localize)(44,null,f)),t.push(""));const o={},k=[];for(const $ in n){const S=n[$];if(S.type==="subcommand")S.description&&k.push({command:$,description:S.description});else if(S.description&&S.cat){let v=o[S.cat];v||(o[S.cat]=v={}),v[$]=S}}for(const $ in o){const S=$,v=o[S];v&&(t.push(D[S]),t.push(...r(v,p)),t.push(""))}return k.length&&(t.push((0,C.localize)(45,null)),t.push(...y(k.map($=>[$.command,$.description]),p)),t.push("")),t.join(`
`)}function c(g,f){return`${g||(0,C.localize)(46,null)}
${f||(0,C.localize)(47,null)}
${process.arch}`}}),function(){"use strict";function oe(e,w,L){function C(R,P){const l=D(R,P),r=[l];return e.isAbsolute(l)||r.unshift(L),e.resolve(...r)}function D(R,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,P);const y=R["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(u,"AppData","Roaming")}break;case"darwin":r=e.join(w.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,P)}return{getUserDataPath:C}}if(typeof define=="function")define(fe[76],de([77,20,15]),function(e,w,L){return oe(e,w,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("os");module.exports=oe(e,w,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(fe[78],de([0,1,20,74,76]),function(oe,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=void 0,e.$bn=R,e.$cn=P;class D extends L.$0m{constructor(r,y){super(r,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,C.getUserDataPath)(r,y.nameShort)},y)}}e.$an=D;function R(l,r){return(0,L.$_m)(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,r,l.extensionEnvironment)}function P(l,r){return(0,L.$_m)(l["inspect-sharedprocess"],l["inspect-brk-sharedprocess"],5879,r,l.extensionEnvironment)}}),define(fe[21],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=C,e.$Bi=D;var w;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function P(l){return l[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=P})(w||(e._util=w={})),e.$zi=C("instantiationService");function L(R,P,l){P[w.DI_TARGET]===P?P[w.DI_DEPENDENCIES].push({id:R,index:l}):(P[w.DI_DEPENDENCIES]=[{id:R,index:l}],P[w.DI_TARGET]=P)}function C(R){if(w.serviceIds.has(R))return w.serviceIds.get(R);const P=function(l,r,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(P,l,y)};return P.toString=()=>R,w.serviceIds.set(R,P),P}function D(R){return R}}),define(fe[35],de([0,1,3,9,73,21,66,7]),function(oe,e,w,L,C,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=r,e.$zj=o,e.$Aj=k,e.$Tj=le;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",w.$j),l.set("isLinux",w.$k),l.set("isWindows",w.$i),l.set("isWeb",w.$o),l.set("isMacNative",w.$j&&!w.$o),l.set("isEdge",w.$H),l.set("isFirefox",w.$F),l.set("isChrome",w.$E),l.set("isSafari",w.$G);function r(te,h){if(l.get(te)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(te,h)}const y=Object.prototype.hasOwnProperty;var u;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const E={regexParsingWithErrorRecovery:!0},a=(0,R.localize)(0,null),c=(0,R.localize)(1,null),g=(0,R.localize)(2,null),f=(0,R.localize)(3,null),s=(0,R.localize)(4,null),n=(0,R.localize)(5,null),m=(0,R.localize)(6,null),p=(0,R.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(h=E){this.k=h,this.d=new C.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(h){if(h===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(h).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const ne=this.D(),j=ne.type===17?n:void 0;throw this.h.push({message:s,offset:ne.offset,lexeme:C.$vj.getLexeme(ne),additionalInfo:j}),i.c}return F}catch(F){if(F!==i.c)throw F;return}}l(){return this.m()}m(){const h=[this.o()];for(;this.y(16);){const F=this.o();h.push(F)}return h.length===1?h[0]:t.or(...h)}o(){const h=[this.s()];for(;this.y(15);){const F=this.s();h.push(F)}return h.length===1?h[0]:t.and(...h)}s(){if(this.y(2)){const h=this.D();switch(h.type){case 11:return this.z(),S.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,f),F?.negate()}case 17:return this.z(),d.create(h.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",h)}}return this.t()}t(){const h=this.D();switch(h.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,f),F}case 17:{const F=h.lexeme;if(this.z(),this.y(9)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==10)throw this.B("REGEX",j);const Y=j.lexeme,H=Y.lastIndexOf("/"),G=H===Y.length-1?void 0:this.w(Y.substring(H+1));let O;try{O=new RegExp(Y.substring(1,H),G)}catch{throw this.B("REGEX",j)}return V.create(F,O)}switch(j.type){case 10:case 19:{const Y=[j.lexeme];this.z();let H=this.D(),G=0;for(let be=0;be<j.lexeme.length;be++)j.lexeme.charCodeAt(be)===40?G++:j.lexeme.charCodeAt(be)===41&&G--;for(;!this.E()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:G++;break;case 1:G--;break;case 10:case 18:for(let be=0;be<H.lexeme.length;be++)H.lexeme.charCodeAt(be)===40?G++:j.lexeme.charCodeAt(be)===41&&G--}if(G<0)break;Y.push(C.$vj.getLexeme(H)),this.z(),H=this.D()}const O=Y.join(""),J=O.lastIndexOf("/"),ie=J===O.length-1?void 0:this.w(O.substring(J+1));let ae;try{ae=new RegExp(O.substring(1,J),ie)}catch{throw this.B("REGEX",j)}return t.regex(F,ae)}case 18:{const Y=j.lexeme;this.z();let H=null;if(!(0,L.$$e)(Y)){const G=Y.indexOf("/"),O=Y.lastIndexOf("/");if(G!==O&&G>=0){const J=Y.slice(G+1,O),ie=Y[O+1]==="i"?"i":"";try{H=new RegExp(J,ie)}catch{throw this.B("REGEX",j)}}}if(H===null)throw this.B("REGEX",j);return V.create(F,H)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const j=this.u();return t.notIn(F,j)}switch(this.D().type){case 3:{this.z();const j=this.u();if(this.x().type===18)return t.equals(F,j);switch(j){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,j)}}case 4:{this.z();const j=this.u();if(this.x().type===18)return t.notEquals(F,j);switch(j){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,j)}}case 5:return this.z(),q.create(F,this.u());case 6:return this.z(),_.create(F,this.u());case 7:return this.z(),A.create(F,this.u());case 8:return this.z(),M.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:m,offset:h.offset,lexeme:"",additionalInfo:p}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const h=this.D();switch(h.type){case 17:case 18:return this.z(),h.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(h){return h.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(h){return this.C(h)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(h,F){if(this.C(h))return this.z();throw this.B(F,this.D())}B(h,F,ne){const j=(0,R.localize)(8,null,h,C.$vj.getLexeme(F)),Y=F.offset,H=C.$vj.getLexeme(F);return this.h.push({message:j,offset:Y,lexeme:H,additionalInfo:ne}),i.c}C(h){return this.D().type===h}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$xj=i;class t{static false(){return S.INSTANCE}static true(){return v.INSTANCE}static has(h){return b.create(h)}static equals(h,F){return U.create(h,F)}static notEquals(h,F){return I.create(h,F)}static regex(h,F){return V.create(h,F)}static in(h,F){return Z.create(h,F)}static notIn(h,F){return T.create(h,F)}static not(h){return d.create(h)}static and(...h){return he.create(h,null,!0)}static or(...h){return X.create(h,null,!0)}static greater(h,F){return A.create(h,F)}static greaterEquals(h,F){return M.create(h,F)}static smaller(h,F){return q.create(h,F)}static smallerEquals(h,F){return _.create(h,F)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(h){return h==null?void 0:this.c.parse(h)}}e.$yj=t;function o(te){const h=new i({regexParsingWithErrorRecovery:!1});return te.map(F=>(h.parse(F),h.lexingErrors.length>0?h.lexingErrors.map(ne=>({errorMessage:ne.additionalInfo?(0,R.localize)(9,null,ne.additionalInfo):(0,R.localize)(10,null),offset:ne.offset,length:ne.lexeme.length})):h.parsingErrors.length>0?h.parsingErrors.map(ne=>({errorMessage:ne.additionalInfo?`${ne.message}. ${ne.additionalInfo}`:ne.message,offset:ne.offset,length:ne.lexeme.length})):[]))}function k(te,h){const F=te?te.substituteConstants():void 0,ne=h?h.substituteConstants():void 0;return!F&&!ne?!0:!F||!ne?!1:F.equals(ne)}function $(te,h){return te.cmp(h)}class S{static{this.INSTANCE=new S}constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return v.INSTANCE}}e.$Bj=S;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}substituteConstants(){return this}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return S.INSTANCE}}e.$Cj=v;class b{static create(h,F=null){const ne=l.get(h);return typeof ne=="boolean"?ne?v.INSTANCE:S.INSTANCE:new b(h,F)}constructor(h,F){this.key=h,this.c=F,this.type=2}cmp(h){return h.type!==this.type?this.type-h.type:Q(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}substituteConstants(){const h=l.get(this.key);return typeof h=="boolean"?h?v.INSTANCE:S.INSTANCE:this}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.$Dj=b;class U{static create(h,F,ne=null){if(typeof F=="boolean")return F?b.create(h,ne):d.create(h,ne);const j=l.get(h);return typeof j=="boolean"?F===(j?"true":"false")?v.INSTANCE:S.INSTANCE:new U(h,F,ne)}constructor(h,F,ne){this.c=h,this.d=F,this.f=ne,this.type=4}cmp(h){return h.type!==this.type?this.type-h.type:ee(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){const h=l.get(this.c);if(typeof h=="boolean"){const F=h?"true":"false";return this.d===F?v.INSTANCE:S.INSTANCE}return this}evaluate(h){return h.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(h){return h.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ej=U;class Z{static create(h,F){return new Z(h,F)}constructor(h,F){this.d=h,this.f=F,this.type=10,this.c=null}cmp(h){return h.type!==this.type?this.type-h.type:ee(this.d,this.f,h.d,h.f)}equals(h){return h.type===this.type?this.d===h.d&&this.f===h.f:!1}substituteConstants(){return this}evaluate(h){const F=h.getValue(this.f),ne=h.getValue(this.d);return Array.isArray(F)?F.includes(ne):typeof ne=="string"&&typeof F=="object"&&F!==null?y.call(F,ne):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(h){return h.mapIn(this.d,this.f)}negate(){return this.c||(this.c=T.create(this.d,this.f)),this.c}}e.$Fj=Z;class T{static create(h,F){return new T(h,F)}constructor(h,F){this.d=h,this.f=F,this.type=11,this.c=Z.create(h,F)}cmp(h){return h.type!==this.type?this.type-h.type:this.c.cmp(h.c)}equals(h){return h.type===this.type?this.c.equals(h.c):!1}substituteConstants(){return this}evaluate(h){return!this.c.evaluate(h)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(h){return h.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=T;class I{static create(h,F,ne=null){if(typeof F=="boolean")return F?d.create(h,ne):b.create(h,ne);const j=l.get(h);return typeof j=="boolean"?F===(j?"true":"false")?S.INSTANCE:v.INSTANCE:new I(h,F,ne)}constructor(h,F,ne){this.c=h,this.d=F,this.f=ne,this.type=5}cmp(h){return h.type!==this.type?this.type-h.type:ee(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){const h=l.get(this.c);if(typeof h=="boolean"){const F=h?"true":"false";return this.d===F?S.INSTANCE:v.INSTANCE}return this}evaluate(h){return h.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(h){return h.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Hj=I;class d{static create(h,F=null){const ne=l.get(h);return typeof ne=="boolean"?ne?S.INSTANCE:v.INSTANCE:new d(h,F)}constructor(h,F){this.c=h,this.d=F,this.type=3}cmp(h){return h.type!==this.type?this.type-h.type:Q(this.c,h.c)}equals(h){return h.type===this.type?this.c===h.c:!1}substituteConstants(){const h=l.get(this.c);return typeof h=="boolean"?h?S.INSTANCE:v.INSTANCE:this}evaluate(h){return!h.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(h){return h.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Ij=d;function N(te,h){if(typeof te=="string"){const F=parseFloat(te);isNaN(F)||(te=F)}return typeof te=="string"||typeof te=="number"?h(te):S.INSTANCE}class A{static create(h,F,ne=null){return N(F,j=>new A(h,j,ne))}constructor(h,F,ne){this.c=h,this.d=F,this.f=ne,this.type=12}cmp(h){return h.type!==this.type?this.type-h.type:ee(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(h){return h.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Jj=A;class M{static create(h,F,ne=null){return N(F,j=>new M(h,j,ne))}constructor(h,F,ne){this.c=h,this.d=F,this.f=ne,this.type=13}cmp(h){return h.type!==this.type?this.type-h.type:ee(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(h){return h.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Kj=M;class q{static create(h,F,ne=null){return N(F,j=>new q(h,j,ne))}constructor(h,F,ne){this.c=h,this.d=F,this.f=ne,this.type=14}cmp(h){return h.type!==this.type?this.type-h.type:ee(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(h){return h.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Lj=q;class _{static create(h,F,ne=null){return N(F,j=>new _(h,j,ne))}constructor(h,F,ne){this.c=h,this.d=F,this.f=ne,this.type=15}cmp(h){return h.type!==this.type?this.type-h.type:ee(this.c,this.d,h.c,h.d)}equals(h){return h.type===this.type?this.c===h.c&&this.d===h.d:!1}substituteConstants(){return this}evaluate(h){return typeof this.d=="string"?!1:parseFloat(h.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(h){return h.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Mj=_;class V{static create(h,F){return new V(h,F)}constructor(h,F){this.d=h,this.f=F,this.type=7,this.c=null}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.d<h.d)return-1;if(this.d>h.d)return 1;const F=this.f?this.f.source:"",ne=h.f?h.f.source:"";return F<ne?-1:F>ne?1:0}equals(h){if(h.type===this.type){const F=this.f?this.f.source:"",ne=h.f?h.f.source:"";return this.d===h.d&&F===ne}return!1}substituteConstants(){return this}evaluate(h){const F=h.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const h=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${h}`}keys(){return[this.d]}map(h){return h.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$Nj=V;class x{static create(h){return new x(h)}constructor(h){this.c=h,this.type=8}cmp(h){return h.type!==this.type?this.type-h.type:this.c.cmp(h.c)}equals(h){return h.type===this.type?this.c.equals(h.c):!1}substituteConstants(){return this}evaluate(h){return!this.c.evaluate(h)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(h){return new x(this.c.map(h))}negate(){return this.c}}e.$Oj=x;function re(te){let h=null;for(let F=0,ne=te.length;F<ne;F++){const j=te[F].substituteConstants();if(te[F]!==j&&h===null){h=[];for(let Y=0;Y<F;Y++)h[Y]=te[Y]}h!==null&&(h[F]=j)}return h===null?te:h}class he{static create(h,F,ne){return he.d(h,F,ne)}constructor(h,F){this.expr=h,this.c=F,this.type=6}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let F=0,ne=this.expr.length;F<ne;F++){const j=$(this.expr[F],h.expr[F]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let F=0,ne=this.expr.length;F<ne;F++)if(!this.expr[F].equals(h.expr[F]))return!1;return!0}return!1}substituteConstants(){const h=re(this.expr);return h===this.expr?this:he.create(h,this.c,!1)}evaluate(h){for(let F=0,ne=this.expr.length;F<ne;F++)if(!this.expr[F].evaluate(h))return!1;return!0}static d(h,F,ne){const j=[];let Y=!1;for(const H of h)if(H){if(H.type===1){Y=!0;continue}if(H.type===0)return S.INSTANCE;if(H.type===6){j.push(...H.expr);continue}j.push(H)}if(j.length===0&&Y)return v.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort($);for(let H=1;H<j.length;H++)j[H-1].equals(j[H])&&(j.splice(H,1),H--);if(j.length===1)return j[0];for(;j.length>1;){const H=j[j.length-1];if(H.type!==9)break;j.pop();const G=j.pop(),O=j.length===0,J=X.create(H.expr.map(ie=>he.create([ie,G],null,ne)),null,O);J&&(j.push(J),j.sort($))}if(j.length===1)return j[0];if(ne){for(let H=0;H<j.length;H++)for(let G=H+1;G<j.length;G++)if(j[H].negate().equals(j[G]))return S.INSTANCE;if(j.length===1)return j[0]}return new he(j,F)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(const F of this.expr)h.push(...F.keys());return h}map(h){return new he(this.expr.map(F=>F.map(h)),null)}negate(){if(!this.c){const h=[];for(const F of this.expr)h.push(F.negate());this.c=X.create(h,this,!0)}return this.c}}e.$Pj=he;class X{static create(h,F,ne){return X.d(h,F,ne)}constructor(h,F){this.expr=h,this.c=F,this.type=9}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let F=0,ne=this.expr.length;F<ne;F++){const j=$(this.expr[F],h.expr[F]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let F=0,ne=this.expr.length;F<ne;F++)if(!this.expr[F].equals(h.expr[F]))return!1;return!0}return!1}substituteConstants(){const h=re(this.expr);return h===this.expr?this:X.create(h,this.c,!1)}evaluate(h){for(let F=0,ne=this.expr.length;F<ne;F++)if(this.expr[F].evaluate(h))return!0;return!1}static d(h,F,ne){let j=[],Y=!1;if(h){for(let H=0,G=h.length;H<G;H++){const O=h[H];if(O){if(O.type===0){Y=!0;continue}if(O.type===1)return v.INSTANCE;if(O.type===9){j=j.concat(O.expr);continue}j.push(O)}}if(j.length===0&&Y)return S.INSTANCE;j.sort($)}if(j.length!==0){if(j.length===1)return j[0];for(let H=1;H<j.length;H++)j[H-1].equals(j[H])&&(j.splice(H,1),H--);if(j.length===1)return j[0];if(ne){for(let H=0;H<j.length;H++)for(let G=H+1;G<j.length;G++)if(j[H].negate().equals(j[G]))return v.INSTANCE;if(j.length===1)return j[0]}return new X(j,F)}}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(const F of this.expr)h.push(...F.keys());return h}map(h){return new X(this.expr.map(F=>F.map(h)),null)}negate(){if(!this.c){const h=[];for(const F of this.expr)h.push(F.negate());for(;h.length>1;){const F=h.shift(),ne=h.shift(),j=[];for(const Y of ce(F))for(const H of ce(ne))j.push(he.create([Y,H],null,!1));h.unshift(X.create(j,null,!1))}this.c=X.create(h,this,!0)}return this.c}}e.$Qj=X;class z extends b{static{this.d=[]}static all(){return z.d.values()}constructor(h,F,ne){super(h,null),this.f=F,typeof ne=="object"?z.d.push({...ne,key:h}):ne!==!0&&z.d.push({key:h,description:ne,type:F!=null?typeof F:void 0})}bindTo(h){return h.createKey(this.key,this.f)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(h){return U.create(this.key,h)}notEqualsTo(h){return I.create(this.key,h)}}e.$Rj=z,e.$Sj=(0,D.$Ai)("contextKeyService");function Q(te,h){return te<h?-1:te>h?1:0}function ee(te,h,F,ne){return te<F?-1:te>F?1:h<ne?-1:h>ne?1:0}function le(te,h){if(te.type===0||h.type===1)return!0;if(te.type===9)return h.type===9?W(te.expr,h.expr):!1;if(h.type===9){for(const F of h.expr)if(le(te,F))return!0;return!1}if(te.type===6){if(h.type===6)return W(h.expr,te.expr);for(const F of te.expr)if(le(F,h))return!0;return!1}return te.equals(h)}function W(te,h){let F=0,ne=0;for(;F<te.length&&ne<h.length;){const j=te[F].cmp(h[ne]);if(j<0)return!1;j===0&&F++,ne++}return F===te.length}function ce(te){return te.type===9?te.expr:[te]}}),define(fe[79],de([0,1,51,5,9,10,6,69,21,3,19,22]),function(oe,e,w,L,C,D,R,P,l,r,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=E,e.$9k=f,e.$0k=n,e.$$k=m,e.$_k=p,e.$al=i,e.$bl=t,e.$cl=o,e.$dl=k,e.$el=$,e.$fl=S,e.$hl=U,e.$il=Z,e.$jl=T,e.$kl=I,e.$ll=d,e.$ol=_,e.$Al=z,e.$Bl=Q,e.$Dl=le,e.$7k=(0,l.$Ai)("fileService");function E(W){return W.create===!0}var a;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(a||(e.FileType=a={}));var c;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var g;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function f(W){const ce=W;return!!ce&&typeof ce.onDidChange=="function"}var s;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function n(W){return!!(W.capabilities&2)}function m(W){return!!(W.capabilities&8)}function p(W){return!!(W.capabilities&131072)}function i(W){return!!(W.capabilities&4)}function t(W){return!!(W.capabilities&16)}function o(W){return n(W)?!!(W.capabilities&16384):!1}function k(W){return n(W)?!!(W.capabilities&32768):!1}function $(W){return!!(W.capabilities&65536)}function S(W){return!!(W.capabilities&2048)}var v;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class b extends Error{static create(ce,te){const h=new b(ce.toString(),te);return T(h,te),h}constructor(ce,te){super(ce),this.code=te}}e.$gl=b;function U(W,ce){return b.create(W,ce)}function Z(W){return W||U((0,P.localize)(0,null),v.Unknown)}function T(W,ce){return W.name=ce?`${ce} (FileSystemError)`:"FileSystemError",W}function I(W){if(!W)return v.Unknown;if(W instanceof b)return W.code;const ce=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ce)return v.Unknown;switch(ce[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function d(W){if(W instanceof V)return W.fileOperationResult;switch(I(W)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}var N;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class A{constructor(ce,te,h){this.resource=ce,this.operation=te,this.target=h}isOperation(ce){return this.operation===ce}}e.$ml=A;var M;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class q{static{this.a=null}constructor(ce,te){this.c=te,this.b=void 0,this.d=new u.$V(()=>{const h=w.$Gi.forUris(()=>this.c);return h.fill(this.rawAdded.map(F=>[F,!0])),h}),this.f=new u.$V(()=>{const h=w.$Gi.forUris(()=>this.c);return h.fill(this.rawUpdated.map(F=>[F,!0])),h}),this.g=new u.$V(()=>{const h=w.$Gi.forUris(()=>this.c);return h.fill(this.rawDeleted.map(F=>[F,!0])),h}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const h of ce){switch(h.type){case 1:this.rawAdded.push(h.resource);break;case 0:this.rawUpdated.push(h.resource);break;case 2:this.rawDeleted.push(h.resource);break}this.b!==q.a&&(typeof h.cId=="number"?this.b===void 0?this.b=h.cId:this.b!==h.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(ce,...te){return this.h(ce,{includeChildren:!1},...te)}affects(ce,...te){return this.h(ce,{includeChildren:!0},...te)}h(ce,te,...h){if(!ce)return!1;const F=h.length>0;return!!((!F||h.includes(1))&&(this.d.value.get(ce)||te.includeChildren&&this.d.value.findSuperstr(ce))||(!F||h.includes(0))&&(this.f.value.get(ce)||te.includeChildren&&this.f.value.findSuperstr(ce))||(!F||h.includes(2))&&(this.g.value.findSubstr(ce)||te.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$nl=q;function _(W,ce,te){return!W||!ce||W===ce||ce.length>W.length?!1:(ce.charAt(ce.length-1)!==L.sep&&(ce+=L.sep),te?(0,C.$Cf)(W,ce):W.indexOf(ce)===0)}class V extends Error{constructor(ce,te,h){super(ce),this.fileOperationResult=te,this.options=h}}e.$pl=V;class x extends V{constructor(ce,te,h,F){super(ce,te,F),this.fileOperationResult=te,this.size=h}}e.$ql=x;class re extends V{constructor(ce,te,h){super(ce,2,h),this.stat=te}}e.$rl=re;var he;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(he||(e.FileOperationResult=he={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var X;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$zl="";function z(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function Q(W,ce){if(!ce.hasProvider(R.URI.from({scheme:W.scheme})))return new Promise(te=>{const h=ce.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===W.scheme&&F.added&&(h.dispose(),te())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ce){return(0,D.$eg)(ce)||(ce=0),ce<ee.KB?(0,P.localize)(1,null,ce.toFixed(0)):ce<ee.MB?(0,P.localize)(2,null,(ce/ee.KB).toFixed(2)):ce<ee.GB?(0,P.localize)(3,null,(ce/ee.MB).toFixed(2)):ce<ee.TB?(0,P.localize)(4,null,(ce/ee.GB).toFixed(2)):(0,P.localize)(5,null,(ce/ee.TB).toFixed(2))}}e.$Cl=ee;function le(W){const ce=typeof W=="string"||W?.scheme===y.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===y.Schemas.file?1024*ee.MB:ce?10*ee.MB:r.$o?50*ee.MB:1024*ee.MB}}),define(fe[8],de([0,1,70,56,4,49,2,25,3,23,10,6,35,21]),function(oe,e,w,L,C,D,R,P,l,r,y,u,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=g,e.log=s,e.$ik=b,e.$jk=U,e.$kk=Z,e.$lk=T,e.$7j=(0,a.$Ai)("logService"),e.$8j=(0,a.$Ai)("loggerService");function c(){return new Date().toISOString()}function g(I){return(0,y.$eg)(I)}var f;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$0j=f.Info;function s(I,d,N){switch(d){case f.Trace:I.trace(N);break;case f.Debug:I.debug(N);break;case f.Info:I.info(N);break;case f.Warning:I.warn(N);break;case f.Error:I.error(N);break;case f.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function n(I,d=!1){let N="";for(let A=0;A<I.length;A++){let M=I[A];if(M instanceof Error&&(M=(0,L.$lj)(M,d)),typeof M=="object")try{M=JSON.stringify(M)}catch{}N+=(A>0?" ":"")+M}return N}class m extends R.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new C.$he),this.onDidChangeLogLevel=this.c.event}setLevel(d){this.b!==d&&(this.b=d,this.c.fire(this.b))}getLevel(){return this.b}f(d){return this.b!==f.Off&&this.b<=d}}e.$_j=m;class p extends m{constructor(d){super(),this.h=d}f(d){return this.h||super.f(d)}trace(d,...N){this.f(f.Trace)&&this.g(f.Trace,n([d,...N],!0))}debug(d,...N){this.f(f.Debug)&&this.g(f.Debug,n([d,...N]))}info(d,...N){this.f(f.Info)&&this.g(f.Info,n([d,...N]))}warn(d,...N){this.f(f.Warning)&&this.g(f.Warning,n([d,...N]))}error(d,...N){if(this.f(f.Error))if(d instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=d.stack,this.g(f.Error,n(A))}else this.g(f.Error,n([d,...N]))}flush(){}}e.$ak=p;class i extends m{constructor(d=e.$0j){super(),this.setLevel(d),this.g=!l.$i}trace(d,...N){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...N):console.log(`[main ${c()}]`,d,...N))}debug(d,...N){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...N):console.log(`[main ${c()}]`,d,...N))}info(d,...N){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,d,...N):console.log(`[main ${c()}]`,d,...N))}warn(d,...N){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,d,...N):console.warn(`[main ${c()}]`,d,...N))}error(d,...N){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,d,...N):console.error(`[main ${c()}]`,d,...N))}flush(){}}e.$bk=i;class t extends m{constructor(d=e.$0j,N=!0){super(),this.g=N,this.setLevel(d)}trace(d,...N){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",d,...N):console.log(d,...N))}debug(d,...N){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",d,...N):console.log(d,...N))}info(d,...N){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",d,...N):console.log(d,...N))}warn(d,...N){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",d,...N):console.log(d,...N))}error(d,...N){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",d,...N):console.error(d,...N))}flush(){}}e.$ck=t;class o extends m{constructor(d,N=e.$0j){super(),this.g=d,this.setLevel(N)}trace(d,...N){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(d),...N])}debug(d,...N){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(d),...N])}info(d,...N){this.f(f.Info)&&this.g.log(f.Info,[this.h(d),...N])}warn(d,...N){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(d),...N])}error(d,...N){this.f(f.Error)&&this.g.log(f.Error,[this.h(d),...N])}h(d){return typeof d=="string"?d:(0,L.$lj)(d,this.f(f.Trace))}flush(){}}e.$dk=o;class k extends m{constructor(d){super(),this.g=d,d.length&&this.setLevel(d[0].getLevel())}setLevel(d){for(const N of this.g)N.setLevel(d);super.setLevel(d)}trace(d,...N){for(const A of this.g)A.trace(d,...N)}debug(d,...N){for(const A of this.g)A.debug(d,...N)}info(d,...N){for(const A of this.g)A.info(d,...N)}warn(d,...N){for(const A of this.g)A.warn(d,...N)}error(d,...N){for(const A of this.g)A.error(d,...N)}flush(){for(const d of this.g)d.flush()}dispose(){for(const d of this.g)d.dispose();super.dispose()}}e.$ek=k;class $ extends R.$Uc{constructor(d,N,A){if(super(),this.h=d,this.j=N,this.b=new P.$Ac,this.c=this.B(new C.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$he),this.onDidChangeVisibility=this.g.event,A)for(const M of A)this.b.set(M.resource,{logger:void 0,info:M})}m(d){return(0,y.$ag)(d)?[...this.b.values()].find(N=>N.info.id===d):this.b.get(d)}getLogger(d){return this.m(d)?.logger}createLogger(d,N){const A=this.n(d),M=(0,y.$ag)(d)?d:N?.id??(0,D.$oj)(A.toString()).toString(16);let q=this.b.get(A)?.logger;const _=N?.logLevel==="always"?f.Trace:N?.logLevel;q||(q=this.s(A,_??this.getLogLevel(A)??this.h,{...N,id:M}));const V={logger:q,info:{resource:A,id:M,logLevel:_,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(V.info),this.b.set(A,V),q}n(d){return(0,y.$ag)(d)?(0,r.$bh)(this.j,`${d}.log`):d}setLogLevel(d,N){if(u.URI.isUri(d)){const A=d,M=N,q=this.b.get(A);q&&M!==q.info.logLevel&&(q.info.logLevel=M===this.h?void 0:M,q.logger?.setLevel(M),this.b.set(q.info.resource,q),this.f.fire([A,M]))}else{this.h=d;for(const[A,M]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(d,N){const A=this.m(d);A&&N!==!A.info.hidden&&(A.info.hidden=!N,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,N]))}getLogLevel(d){let N;return d&&(N=this.b.get(d)?.info.logLevel),N??this.h}registerLogger(d){const N=this.b.get(d.resource);N?N.info.hidden!==d.hidden&&this.setVisibility(d.resource,!d.hidden):(this.b.set(d.resource,{info:d,logger:void 0}),this.c.fire({added:[d],removed:[]}))}deregisterLogger(d){const N=this.b.get(d);N&&(N.logger&&N.logger.dispose(),this.b.delete(d),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const d of this.b.values())yield d.info}getRegisteredLogger(d){return this.b.get(d)?.info}dispose(){this.b.forEach(d=>d.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=$;class S{constructor(){this.onDidChangeLogLevel=new C.$he().event}setLevel(d){}getLevel(){return f.Info}trace(d,...N){}debug(d,...N){}info(d,...N){}warn(d,...N){}error(d,...N){}critical(d,...N){}dispose(){}flush(){}}e.$gk=S;class v extends S{}e.$hk=v;function b(I){if(I.verbose)return f.Trace;if(typeof I.logLevel=="string"){const d=T(I.logLevel.toLowerCase());if(d!==void 0)return d}return e.$0j}function U(I){switch(I){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function Z(I){switch(I){case f.Trace:return{original:"Trace",value:w.localize(0,null)};case f.Debug:return{original:"Debug",value:w.localize(1,null)};case f.Info:return{original:"Info",value:w.localize(2,null)};case f.Warning:return{original:"Warning",value:w.localize(3,null)};case f.Error:return{original:"Error",value:w.localize(4,null)};case f.Off:return{original:"Off",value:w.localize(5,null)}}}function T(I){switch(I){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$mk=new E.$Rj("logLevel",U(f.Info))}),define(fe[80],de([0,1,6,4,8,2]),function(oe,e,w,L,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=void 0;class R extends C.$fk{constructor(u,E,a,c,g){super(E,a,c),this.r=u,this.t=g,this.B(g.listen("onDidChangeLogLevel",u)(f=>{(0,C.$9j)(f)?super.setLogLevel(f):super.setLogLevel(w.URI.revive(f[0]),f[1])})),this.B(g.listen("onDidChangeVisibility",u)(([f,s])=>super.setVisibility(w.URI.revive(f),s))),this.B(g.listen("onDidChangeLoggers",u)(({added:f,removed:s})=>{for(const n of f)super.registerLogger({...n,resource:w.URI.revive(n.resource)});for(const n of s)super.deregisterLogger(n.resource)}))}createConsoleMainLogger(){return new C.$dk({log:(u,E)=>{this.t.call("consoleLog",[u,E])}})}registerLogger(u){super.registerLogger(u),this.t.call("registerLogger",[u,this.r])}deregisterLogger(u){super.deregisterLogger(u),this.t.call("deregisterLogger",[u,this.r])}setLogLevel(u,E){super.setLogLevel(u,E),this.t.call("setLogLevel",[u,E])}setVisibility(u,E){super.setVisibility(u,E),this.t.call("setVisibility",[this.n(u),E])}s(u,E,a){return new P(this.t,u,E,a,this.r)}static setLogLevel(u,E,a){return u.call("setLogLevel",[E,a])}}e.$fs=R;class P extends C.$ak{constructor(u,E,a,c,g){super(c?.logLevel==="always"),this.r=u,this.s=E,this.m=!1,this.n=[],this.setLevel(a),this.r.call("createLogger",[E,c,g]).then(()=>{this.u(this.n),this.m=!0})}g(u,E){const a=[[u,E]];this.m?this.u(a):this.n.push(...a)}u(u){this.r.call("log",[this.s,u])}}class l{constructor(u,E){this.a=u,this.b=E}listen(u,E){const a=this.b(u);switch(E){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(g=>this.c(g,a)),removed:[...c.removed].map(g=>this.c(g,a))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,c=>[a.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,c=>(0,C.$9j)(c)?c:[a.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${E}`)}async call(u,E,a){const c=this.b(u);switch(E){case"setLogLevel":return(0,C.$9j)(a[0])?this.a.setLogLevel(a[0]):this.a.setLogLevel(w.URI.revive(c.transformIncoming(a[0][0])),a[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,c)))}throw new Error(`Call not found: ${E}`)}c(u,E){return{...u,resource:E.transformOutgoingURI(u.resource)}}}e.$gs=l;class r extends D.$Uc{constructor(u,E){super(),E.call("setLogLevel",[u.getLogLevel()]),this.B(u.onDidChangeLogLevel(a=>E.call("setLogLevel",[a]))),E.call("getRegisteredLoggers").then(a=>{for(const c of a)u.registerLogger({...c,resource:w.URI.revive(c.resource)})}),this.B(E.listen("onDidChangeVisibility")(([a,c])=>u.setVisibility(w.URI.revive(a),c))),this.B(E.listen("onDidChangeLoggers")(({added:a,removed:c})=>{for(const g of a)u.registerLogger({...g,resource:w.URI.revive(g.resource)});for(const g of c)u.deregisterLogger(g.resource)}))}}e.$hs=r}),define(fe[81],de([0,1,2,8]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;class C extends w.$Uc{constructor(R,P=[]){super(),this.a=new L.$ek([R,...P]),this.B(R.onDidChangeLogLevel(l=>this.setLevel(l)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...P){this.a.trace(R,...P)}debug(R,...P){this.a.debug(R,...P)}info(R,...P){this.a.info(R,...P)}warn(R,...P){this.a.warn(R,...P)}error(R,...P){this.a.error(R,...P)}flush(){this.a.flush()}}e.$fQ=C}),define(fe[82],de([0,1,79,8]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=void 0;var C;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(C||(C={}));async function D(r,y,u,E,a){try{const c=await new Promise((f,s)=>{oe(["@vscode/spdlog"],f,s)});c.setFlushOn(C.Trace);const g=await c.createAsyncRotatingLogger(r,y,u,E);return a?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(c){console.error(c)}return null}function R(r,y,u){switch(y){case L.LogLevel.Trace:r.trace(u);break;case L.LogLevel.Debug:r.debug(u);break;case L.LogLevel.Info:r.info(u);break;case L.LogLevel.Warning:r.warn(u);break;case L.LogLevel.Error:r.error(u);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function P(r,y){switch(y){case L.LogLevel.Trace:r.setLevel(C.Trace);break;case L.LogLevel.Debug:r.setLevel(C.Debug);break;case L.LogLevel.Info:r.setLevel(C.Info);break;case L.LogLevel.Warning:r.setLevel(C.Warning);break;case L.LogLevel.Error:r.setLevel(C.Error);break;case L.LogLevel.Off:r.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class l extends L.$ak{constructor(y,u,E,a,c){super(),this.m=[],this.setLevel(c),this.n=this.s(y,u,E,a),this.B(this.onDidChangeLogLevel(g=>{this.r&&P(this.r,g)}))}async s(y,u,E,a){const c=E?6:1,g=30/c*w.$Cl.MB,f=await D(y,u,g,c,a);if(f){this.r=f,P(this.r,this.getLevel());for(const{level:s,message:n}of this.m)R(this.r,s,n);this.m=[]}}g(y,u){this.r?R(this.r,y,u):this.getLevel()<=y&&this.m.push({level:y,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$7P=l}),define(fe[83],de([0,1,52,8,82]),function(oe,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=void 0;class D extends L.$fk{s(P,l,r){return new C.$7P((0,w.$Wg)(),P.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,l)}}e.$8P=D}),define(fe[84],de([0,1,15]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const D=C.context.configuration();if(D)L=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,w.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:D.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(fe[85],de([0,1,21]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,w.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(fe[86],de([0,1,42,10]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=void 0;class C{constructor(){this.a=new Map}add(R,P){w.ok(L.$ag(R)),w.ok(L.$cg(P)),w.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,P)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$ho=new C}),define(fe[87],de([0,1,4,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gvb=void 0;class C extends L.$Uc{constructor(R){super(),this.f=R,this.type=4,this.a=new Map,this.b=new Map,this.c=this.B(new w.$he),this.onMarkAdded=this.c.event}*markers(){for(const R of this.a.values())yield R;for(const R of this.b.values())yield R}addMark(R){const P=R?.marker||this.f.registerMarker(),l=R?.id;P&&(l?(this.a.set(l,P),P.onDispose(()=>this.a.delete(l))):(this.b.set(P.id,P),P.onDispose(()=>this.b.delete(P.id))),this.c.fire({marker:P,id:l,hidden:R?.hidden,hoverMessage:R?.hoverMessage}))}getMark(R){return this.a.get(R)}}e.$gvb=C});var Fe=this&&this.__param||function(oe,e){return function(w,L){e(w,L,oe)}};define(fe[88],de([0,1,4,2,8,14]),function(oe,e,w,L,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0;var R;(function(l){l[l.Unknown=0]="Unknown",l[l.Input=1]="Input",l[l.Execute=2]="Execute"})(R||(R={}));let P=class extends L.$Uc{get value(){return this.j}get cursorIndex(){return this.m}get ghostTextIndex(){return this.n}constructor(r,y,u,E){super(),this.w=r,this.z=E,this.a=0,this.c=0,this.h="",this.j="",this.m=0,this.n=-1,this.r=this.B(new w.$he),this.onDidStartInput=this.r.event,this.s=this.B(new w.$he),this.onDidChangeInput=this.s.event,this.t=this.B(new w.$he),this.onDidFinishInput=this.t.event,this.u=this.B(new w.$he),this.onDidInterrupt=this.u.event,this.B(w.Event.any(this.w.onCursorMove,this.w.onData,this.w.onWriteParsed)(()=>this.G())),this.B(this.w.onData(a=>this.I(a))),this.B(y(a=>this.D(a))),this.B(u(()=>this.F())),this.B(this.onDidStartInput(()=>this.C("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.C("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.C("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.C("PromptInputModel#onDidInterrupt")))}C(r){this.z.getLevel()===C.LogLevel.Trace&&this.z.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.g=r,this.G()}setLastPromptLine(r){this.f=r,this.G()}setConfidentCommandLine(r){this.j!==r&&(this.j=r,this.m=-1,this.n=-1,this.s.fire(this.Q()))}getCombinedString(){const r=this.j.replaceAll(`
`,"\u23CE");if(this.m===-1)return r;let y=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(y+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,y+=`${r.substring(this.ghostTextIndex)}]`):y+=r.substring(this.cursorIndex),y}D(r){this.a!==1&&(this.a=1,this.b=r.marker,this.c=this.w.buffer.active.cursorX,this.j="",this.m=0,this.r.fire(this.Q()),this.s.fire(this.Q()),this.f&&this.c!==this.f.length&&this.w.buffer.active.getLine(this.b.line)?.translateToString(!0).startsWith(this.f)&&(this.c=this.f.length,this.G()))}F(){if(this.a===2)return;this.m=-1,this.n!==-1&&(this.j=this.j.substring(0,this.n),this.n=-1);const r=this.Q();this.h===""&&(this.h="",this.u.fire(r)),this.a=2,this.t.fire(r),this.s.fire(r)}G(){try{this.H()}catch(r){this.z.error("Error while syncing prompt input model",r)}}H(){if(this.a!==1)return;const r=this.b?.line;if(r===void 0)return;const y=this.w.buffer.active;let u=y.getLine(r);const E=u?.translateToString(!0,this.c);if(!u||E===void 0){this.z.trace("PromptInputModel#_sync: no line");return}const a=y.baseY+y.cursorY;let c=E,g=a===r?this.O(this.c,y,u):E.trimEnd().length+1,f=-1;a===r&&y.cursorX>1&&(f=this.J(y,u,g));for(let s=r+1;s<=a;s++){u=y.getLine(s);const n=u?.translateToString(!0);if(n&&u)if(this.g===void 0||this.M(n)){const m=this.L(n);if(c+=`
${m}`,a===s){const p=this.N(u,n),i=this.O(p,y,u);g+=i}else g+=m.length+1}else break}for(let s=a+1;s<y.baseY+this.w.rows;s++){u=y.getLine(s);const n=u?.translateToString(!0);if(n&&u)if(this.g===void 0||this.M(n))c+=`
${this.L(n)}`;else break;else break}this.z.getLevel()===C.LogLevel.Trace&&this.z.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let s=this.j.length-this.j.trimEnd().length;this.h==="\x7F"&&(this.h="",g===this.m-1&&(this.j.trimEnd().length>c.trimEnd().length&&c.trimEnd().length<=g?s=Math.max(this.j.length-1-c.trimEnd().length,0):s=Math.max(s-1,0))),this.h==="\x1B[3~"&&(this.h="",g===this.m&&(s=Math.max(s-1,0)));const n=c.split(`
`),m=n.length>1,p=c.trimEnd();if(!m){p.length<c.length&&(this.h===" "&&(this.h="",g>p.length&&g>this.m&&s++),s=Math.max(g-p.length,s,0));const i=g===0?"":c[g-1];s>0&&g===this.m+1&&this.h!==""&&i!==" "&&(s=this.j.length-this.m)}if(m){n[n.length-1]=n.at(-1)?.trimEnd()??"";const i=(n.length-1)*(this.g?.length??0);s=Math.max(0,g-c.length-i)}c=n.map(i=>i.trimEnd()).join(`
`)+" ".repeat(s)}(this.j!==c||this.m!==g||this.n!==f)&&(this.j=c,this.m=g,this.n=f,this.s.fire(this.Q()))}I(r){this.h=r}J(r,y,u){let E=-1,a=!1,c=r.cursorX;for(;c>0;){const g=y.getCell(--c);if(!g)break;if(g.getChars().trim().length>0){a=!this.P(g);break}}if(a){let g=0,f=r.cursorX;for(;f<y.length;){const s=y.getCell(f++);if(!s||s.getCode()===0)break;if(this.P(s)){E=u+g;break}g+=s.getChars().length}}return E}L(r){return this.M(r)&&(r=r.substring(this.g.length)),r}M(r){return!!(this.g&&r.startsWith(this.g))}N(r,y){if(!this.g||!y.startsWith(this.g))return 0;let u="",E=0;for(;u!==this.g;)u+=r.getCell(E++).getChars();return E}O(r,y,u){return u?.translateToString(!0,r,y.cursorX).length??0}P(r){return!!(r.isItalic()||r.isDim())}Q(){return Object.freeze({value:this.j,cursorIndex:this.m,ghostTextIndex:this.n})}};e.$9r=P,$e([(0,D.$7h)(0)],P.prototype,"G",null),e.$9r=P=$e([Fe(3,C.$7j)],P)}),define(fe[89],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=void 0;class w{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(y){this.b.endMarker=y}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(y,u){this.a=y,this.b=u}static deserialize(y,u,E){const a=y.buffer.normal,c=u.startLine!==void 0?y.registerMarker(u.startLine-(a.baseY+a.cursorY)):void 0;if(!c)return;const g=u.promptStartLine!==void 0?y.registerMarker(u.promptStartLine-(a.baseY+a.cursorY)):void 0,f=u.endLine!==void 0?y.registerMarker(u.endLine-(a.baseY+a.cursorY)):void 0,s=u.executedLine!==void 0?y.registerMarker(u.executedLine-(a.baseY+a.cursorY)):void 0;return new w(y,{command:E?"":u.command,commandLineConfidence:u.commandLineConfidence??"low",isTrusted:u.isTrusted,promptStartMarker:g,marker:c,startX:u.startX,endMarker:f,executedMarker:s,executedX:u.executedX,timestamp:u.timestamp,duration:u.duration,cwd:u.cwd,commandStartLineContent:u.commandStartLineContent,exitCode:u.exitCode,markProperties:u.markProperties,aliases:void 0,wasReplayed:!0})}serialize(y){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:y?"":this.command,commandLineConfidence:y?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return C(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const y=this.executedMarker.line,u=this.endMarker.line;if(y===u)return;let E="",a;for(let c=y;c<u;c++)a=this.a.buffer.active.getLine(c),a&&(E+=a.translateToString(!a.isWrapped)+(a.isWrapped?"":`
`));return E===""?void 0:E}getOutputMatch(y){if(!this.executedMarker||!this.endMarker)return;const u=this.endMarker.line;if(u===-1)return;const E=this.a.buffer.active,a=Math.max(this.executedMarker.line,0),c=y.lineMatcher,g=typeof c=="string"?1:y.length||R(c),f=[];let s;if(y.anchor==="bottom")for(let n=u-(y.offset||0);n>=a;n--){let m=n;const p=n;for(;m>=a&&E.getLine(m)?.isWrapped;)m--;if(n=m,f.unshift(D(E,m,p,this.a.cols)),s||(s=f[0].match(c)),f.length>=g)break}else for(let n=a+(y.offset||0);n<u;n++){const m=n;let p=n;for(;p+1<u&&E.getLine(p+1)?.isWrapped;)p++;if(n=p,f.push(D(E,m,p,this.a.cols)),s||(s=f[f.length-1].match(c)),f.length>=g)break}return s?{regexMatch:s,outputLines:f}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return P(this,this.a.buffer.active)}getCommandRowCount(){return l(this)}}e.$0r=w;class L{constructor(y){this.c=y}serialize(y){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:y,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(y,u,E,a){if(u===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||E)return new w(this.c,{command:E?"":this.command||"",commandLineConfidence:E?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:y,exitCode:u,commandStartLineContent:this.commandStartLineContent,markProperties:a})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return C(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return P(this,this.c.buffer.active)}getCommandRowCount(){return l(this)}}e.$$r=L;function C(r,y,u,E,a,c){if(!u||!a||E===void 0||c===void 0)return"";let g="";for(let f=u.line;f<=a.line;f++){const s=r.getLine(f);s&&(g+=s.translateToString(!0,f===u.line?E:0,f===a.line?c:y))}return g}function D(r,y,u,E){const a=Math.max(2048/E*2);u=Math.min(u,y+a);let c="";for(let g=y;g<=u;g++){const f=r.getLine(g);f&&(c+=f.translateToString(!0,0,E))}return c}function R(r){if(!r.multiline)return 1;const y=r.source;let u=1,E=y.indexOf("\\n");for(;E!==-1;)u++,E=y.indexOf("\\n",E+1);return u}function P(r,y){const u="hasOutput"in r?r.marker:r.commandStartMarker;if(!u||!r.promptStartMarker)return 1;let E=1,a=r.promptStartMarker.line;for(;a<u.line&&(y.getLine(a)?.translateToString(!0)??"").length===0;)a++;return E=u.line-a+1,E}function l(r){const y="hasOutput"in r?r.marker:r.commandStartMarker,u="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!y||!u)return 1;let a=Math.max(u.line,y.line)-y.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&a--,a}}),define(fe[90],de([0,1,12,14,4,2,8,89,88]),function(oe,e,w,L,C,D,R,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cvb=void 0,e.$dvb=a;let r=class extends D.$Uc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.n.command}get executingCommandObject(){if(this.n.commandStartMarker)return{marker:this.n.commandStartMarker}}get currentCommand(){return this.n}get cwd(){return this.g}get promptTerminator(){return this.h}get D(){return!!(this.n.commandStartMarker&&!this.n.commandExecutedMarker)}get hasInput(){if(!(!this.D||!this.n?.commandStartMarker)){if(this.M.buffer.active.baseY+this.M.buffer.active.cursorY===this.n.commandStartMarker?.line){const s=this.M.buffer.active.getLine(this.M.buffer.active.cursorY)?.translateToString(!0,this.n.commandStartX);return s===void 0?void 0:s.length>0}return!0}}constructor(s,n){super(),this.M=s,this.N=n,this.type=2,this.f=[],this.n=new P.$$r(this.M),this.r=[],this.t=!1,this.F=this.B(new C.$he),this.onCommandStarted=this.F.event,this.G=this.B(new C.$he),this.onBeforeCommandFinished=this.G.event,this.H=this.B(new C.$he),this.onCommandFinished=this.H.event,this.I=this.B(new C.$he),this.onCommandExecuted=this.I.event,this.J=this.B(new C.$he),this.onCommandInvalidated=this.J.event,this.L=this.B(new C.$he),this.onCurrentCommandInvalidated=this.L.event,this.c=this.B(new l.$9r(this.M,this.onCommandStarted,this.onCommandExecuted,this.N)),this.B(this.onCommandExecuted(p=>{if(p.commandLineConfidence!=="high"){const i=p;p.command=i.extractCommandLine(),p.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&p.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(p.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&p.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(p.commandLineConfidence="medium")}}));const m=this;this.z=new class{get onCurrentCommandInvalidatedEmitter(){return m.L}get onCommandStartedEmitter(){return m.F}get onCommandExecutedEmitter(){return m.I}get dimensions(){return m.s}get isCommandStorageDisabled(){return m.t}get commandMarkers(){return m.r}set commandMarkers(p){m.r=p}get clearCommandsInViewport(){return m.Q.bind(m)}commitCommandFinished(){m.w?.flush(),m.w=void 0}},this.C=this.B(new D.$Wc(new y(this.M,this,this.z,this.N))),this.s={cols:this.M.cols,rows:this.M.rows},this.B(this.M.onResize(p=>this.O(p))),this.B(this.M.onCursorMove(()=>this.P()))}O(s){this.C.value.preHandleResize?.(s),this.s.cols=s.cols,this.s.rows=s.rows}P(){this.M.buffer.active===this.M.buffer.normal&&this.n.commandStartMarker&&this.M.buffer.active.baseY+this.M.buffer.active.cursorY<this.n.commandStartMarker.line&&(this.Q(),this.n.isInvalid=!0,this.L.fire({reason:"windows"}))}Q(){let s=0;for(let n=this.f.length-1;n>=0;n--){const m=this.f[n].marker?.line;if(m&&m<this.M.buffer.active.baseY)break;s++}s>0&&this.J.fire(this.f.splice(this.f.length-s,s))}setContinuationPrompt(s){this.c.setContinuationPrompt(s)}setPromptTerminator(s,n){this.N.debug("CommandDetectionCapability#setPromptTerminator",s),this.h=s,this.c.setLastPromptLine(n)}setCwd(s){this.g=s}setIsWindowsPty(s){if(s&&!(this.C.value instanceof E)){const n=this;this.C.value=new E(this.M,this,new class{get onCurrentCommandInvalidatedEmitter(){return n.L}get onCommandStartedEmitter(){return n.F}get onCommandExecutedEmitter(){return n.I}get dimensions(){return n.s}get isCommandStorageDisabled(){return n.t}get commandMarkers(){return n.r}set commandMarkers(m){n.r=m}get clearCommandsInViewport(){return n.Q.bind(n)}commitCommandFinished(){n.w?.flush(),n.w=void 0}},this.N)}else!s&&!(this.C.value instanceof y)&&(this.C.value=new y(this.M,this,this.z,this.N))}setIsCommandStorageDisabled(){this.t=!0}getCommandForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.n;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>s)){for(let n=this.commands.length-1;n>=0;n--)if((this.commands[n].promptStartMarker??this.commands[n].marker).line<=s)return this.commands[n]}}getCwdForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.g;const n=this.getCommandForLine(s);if(n&&"cwd"in n)return n.cwd}handlePromptStart(s){const n=this.commands.at(-1);n?.endMarker&&n?.executedMarker&&n.endMarker.line===n.executedMarker.line&&(this.N.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${n.endMarker.line} -> ${n.executedMarker.line+1}`),n.endMarker=g(this.M,n.executedMarker,1)),this.n.promptStartMarker=s?.marker||(n?.endMarker?g(this.M,n.endMarker):this.M.registerMarker(0)),this.N.debug("CommandDetectionCapability#handlePromptStart",this.M.buffer.active.cursorX,this.n.promptStartMarker?.line)}handleContinuationStart(){this.n.currentContinuationMarker=this.M.registerMarker(0),this.N.debug("CommandDetectionCapability#handleContinuationStart",this.n.currentContinuationMarker)}handleContinuationEnd(){if(!this.n.currentContinuationMarker){this.N.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.n.continuations||(this.n.continuations=[]),this.n.continuations.push({marker:this.n.currentContinuationMarker,end:this.M.buffer.active.cursorX}),this.n.currentContinuationMarker=void 0,this.N.debug("CommandDetectionCapability#handleContinuationEnd",this.n.continuations[this.n.continuations.length-1])}handleRightPromptStart(){this.n.commandRightPromptStartX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleRightPromptStart",this.n.commandRightPromptStartX)}handleRightPromptEnd(){this.n.commandRightPromptEndX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleRightPromptEnd",this.n.commandRightPromptEndX)}handleCommandStart(s){if(this.u=s,this.n.cwd=this.g,this.n.commandStartMarker=s?.marker||this.n.commandStartMarker,this.n.commandStartMarker?.line===this.M.buffer.active.cursorY){this.n.commandStartX=this.M.buffer.active.cursorX,this.N.debug("CommandDetectionCapability#handleCommandStart",this.n.commandStartX,this.n.commandStartMarker?.line);return}this.C.value.handleCommandStart(s)}handleGenericCommand(s){s?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(s),this.handleCommandStart(s),this.handleCommandExecuted(s),this.handleCommandFinished(void 0,s)}handleCommandExecuted(s){this.C.value.handleCommandExecuted(s),this.n.markExecutedTime()}handleCommandFinished(s,n){if(this.n.markFinishedTime(),this.C.value.preHandleCommandFinished?.(),this.N.debug("CommandDetectionCapability#handleCommandFinished",this.M.buffer.active.cursorX,n?.marker?.line,this.n.command,this.n),s===void 0){const p=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.n.command&&this.n.command.length>0&&p?.command===this.n.command&&(s=p.exitCode)}if(this.n.commandStartMarker===void 0||!this.M.buffer.active)return;this.n.commandFinishedMarker=n?.marker||this.M.registerMarker(0),this.C.value.postHandleCommandFinished?.();const m=this.n.promoteToFullCommand(this.g,s,this.u?.ignoreCommandLine??!1,n?.markProperties);m&&(this.f.push(m),this.w=new w.$Mh(()=>{this.G.fire(m),this.n.isInvalid||(this.N.debug("CommandDetectionCapability#onCommandFinished",m),this.H.fire(m))},50),this.w.schedule()),this.n=new P.$$r(this.M),this.u=void 0}setCommandLine(s,n){this.N.debug("CommandDetectionCapability#setCommandLine",s,n),this.n.command=s,this.n.commandLineConfidence="high",this.n.isTrusted=n,n&&this.c.setConfidentCommandLine(s)}serialize(){const s=this.commands.map(m=>m.serialize(this.t)),n=this.n.serialize(this.g);return n&&s.push(n),{isWindowsPty:this.C.value instanceof E,commands:s}}deserialize(s){s.isWindowsPty&&this.setIsWindowsPty(s.isWindowsPty);const n=this.M.buffer.normal;for(const m of s.commands){if(!m.endLine){const i=m.startLine!==void 0?this.M.registerMarker(m.startLine-(n.baseY+n.cursorY)):void 0;if(!i)continue;this.n.commandStartMarker=m.startLine!==void 0?this.M.registerMarker(m.startLine-(n.baseY+n.cursorY)):void 0,this.n.commandStartX=m.startX,this.n.promptStartMarker=m.promptStartLine!==void 0?this.M.registerMarker(m.promptStartLine-(n.baseY+n.cursorY)):void 0,this.g=m.cwd,this.F.fire({marker:i});continue}const p=P.$0r.deserialize(this.M,m,this.t);p&&(this.f.push(p),this.N.debug("CommandDetectionCapability#onCommandFinished",p),this.H.fire(p))}}};e.$cvb=r,$e([(0,L.$6h)(500)],r.prototype,"P",null),e.$cvb=r=$e([Fe(1,R.$7j)],r);class y extends D.$Uc{constructor(s,n,m,p){super(),this.c=s,this.f=n,this.g=m,this.h=p,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&m.clearCommandsInViewport(),!1)))}handleCommandStart(s){this.g.commitCommandFinished();const n=this.f.currentCommand;n.commandStartX=this.c.buffer.active.cursorX,n.commandStartMarker=s?.marker||this.c.registerMarker(0),n.commandExecutedMarker?.dispose(),n.commandExecutedMarker=void 0,n.commandExecutedX=void 0;for(const m of this.g.commandMarkers)m.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:s?.marker||n.commandStartMarker,markProperties:s?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",n.commandStartX,n.commandStartMarker?.line)}handleCommandExecuted(s){const n=this.f.currentCommand;if(n.commandExecutedMarker=s?.marker||this.c.registerMarker(0),n.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",n.commandExecutedX,n.commandExecutedMarker?.line),!n.commandStartMarker||!n.commandExecutedMarker||n.commandStartX===void 0)return;n.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(n.commandStartMarker.line)?.translateToString(!0,n.commandStartX,n.commandRightPromptStartX).trim();let m=n.commandStartMarker.line+1;const p=n.commandExecutedMarker.line;for(;m<p;m++){const i=this.c.buffer.active.getLine(m);if(i){const t=n.continuations?.find(k=>k.marker.line===m);t&&(n.command+=`
`);const o=t?.end??0;n.command+=i.translateToString(!0,o)}}m===p&&(n.command+=this.c.buffer.active.getLine(p)?.translateToString(!0,void 0,n.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(n)}}var u;(function(f){f[f.MaxCheckLineCount=10]="MaxCheckLineCount",f[f.Interval=20]="Interval",f[f.MaximumPollCount=10]="MaximumPollCount"})(u||(u={}));let E=class extends D.$Uc{constructor(s,n,m,p){super(),this.n=s,this.r=n,this.s=m,this.t=p,this.c=this.B(new D.$Vc),this.g=0,this.h=0,this.B(s.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(s){const n=this.n.buffer.active.baseY,m=s.rows-this.s.dimensions.rows;m>0&&this.D().then(()=>{const p=Math.min(m,n);for(let i=this.r.commands.length-1;i>=0;i--){const t=this.r.commands[i];if(!t.marker||t.marker.line<n||t.commandStartLineContent===void 0)break;const o=this.n.buffer.active.getLine(t.marker.line);if(!o||o.translateToString(!0)===t.commandStartLineContent)continue;const k=t.marker.line-p;this.n.buffer.active.getLine(k)?.translateToString(!0)===t.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:p})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const s=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?g(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new w.$Mh(()=>this.u(s),20),this.f.schedule()}u(s){if(this.q.isDisposed)return;const n=this.n.buffer.active;let m=this.g;for(;m<10&&s.line+m<n.baseY+this.n.rows;){if(this.C()){const p=this.F(s.line+m);if(p){const i=typeof p=="string"?p:p.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof p=="object"&&p.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=g(this.n,this.r.currentCommand.commandStartMarker);const t=this.r.commands.at(-1);t&&this.r.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=g(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=i.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${s.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}m++}m<10?(this.g=m,++this.h<10?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=10,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const s=this.n.registerMarker(0);s&&this.s.commandMarkers.push(s)}})),this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(s){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const s=this.r.currentCommand,n=s.command,m=s.commandStartMarker?.line,p=s.commandExecutedMarker?.line;if(!n||n.length===0||m===void 0||m===-1||p===void 0||p===-1)return;let i=0,t=!1;for(let o=m;o<=p;o++){const k=this.n.buffer.active.getLine(o);if(!k)break;const $=k.translateToString(!0);for(let S=0;S<$.length;S++){for(;n.length<i&&n[i]===" ";)i++;if($[S]===n[i]&&i++,i===n.length){const v=S>=this.n.cols-1;s.commandExecutedMarker=this.n.registerMarker(o-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(v?1:0)),s.commandExecutedX=v?0:S+1,t=!0;break}}if(t)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((s,n)=>s.line-n.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const s=this.r.commands.at(-1);if(!s)return!0;const n=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,m=(s.endMarker?s.endMarker.line:s.marker?.line)??-1;return n>m}D(){const s=this.n.buffer.active.cursorX,n=this.n.buffer.active.cursorY;let m=0;return new Promise((p,i)=>{const t=setInterval(()=>{if(s!==this.n.buffer.active.cursorX||n!==this.n.buffer.active.cursorY){p(),clearInterval(t);return}m+=10,m>1e3&&(clearInterval(t),p())},10)})}F(s=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const n=this.n.buffer.active.getLine(s);if(!n)return;const m=n.translateToString(!0);if(!m)return;const p=m.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(p){const $=this.G(p,m,">");if($)return{prompt:$,likelySingleLine:!0}}const i=m.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const $=this.G(i,m,"\u276F");if($)return $}const t=m.match(/^(?<prompt>\$)/)?.groups?.prompt;if(t){const $=this.G(t,m,"$");if($)return $}const o=m.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(o)return{prompt:o,likelySingleLine:!0};if(this.r.promptTerminator&&m.trim().endsWith(this.r.promptTerminator)){const $=this.G(m,m,this.r.promptTerminator);if($)return $}const k=m.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return k?.groups?.prompt?{prompt:k.groups.prompt,likelySingleLine:!0}:void 0}G(s,n,m){if(s)return n===s&&s.endsWith(m)&&(s+=" "),s}};E=$e([Fe(3,R.$7j)],E);function a(f,s,n,m){if(!m)return;const p=s.executedMarker,i=s.endMarker;if(!p||!i)return;const t=p.line,o=i.line,k=m.length,$=[];if(m.anchor==="bottom")for(let S=o-(m.offset||0);S>=t;S--){let v=S;const b=S;for(;v>=t&&f.getLine(v)?.isWrapped;)v--;S=v,$.unshift(c(f,v,b,n)),$.length>k&&$.pop()}else for(let S=t+(m.offset||0);S<o;S++){const v=S;let b=S;for(;b+1<o&&f.getLine(b+1)?.isWrapped;)b++;S=b,$.push(c(f,v,b,n)),$.length===k&&$.shift()}return $}function c(f,s,n,m){const p=Math.max(2048/m*2);n=Math.min(n,s+p);let i="";for(let t=s;t<=n;t++){const o=f.getLine(t);o&&(i+=o.translateToString(!0,0,m))}return i}function g(f,s,n=0){return f.registerMarker(s.line-(f.buffer.active.baseY+f.buffer.active.cursorY)+n)}}),define(fe[91],de([0,1,4,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$evb=void 0;class C extends L.$Uc{constructor(){super(...arguments),this.type=0,this.a="",this.b=new Map,this.c=this.B(new w.$he),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(R){const P=this.a!==R;this.a=R;const l=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,l+1),P&&this.c.fire(R)}}e.$evb=C}),define(fe[92],de([0,1,4,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fvb=void 0;var C;(function(R){R[R.MinimumPromptLength=2]="MinimumPromptLength"})(C||(C={}));class D extends L.$Tc{get commands(){return this.a}constructor(P){super(),this.c=P,this.type=3,this.a=[],this.b=this.add(new w.$he),this.onCommandFinished=this.b.event,this.add(this.c.onData(l=>this.h(l))),this.add(this.c.parser.registerCsiHandler({final:"J"},l=>(l.length>=1&&(l[0]===2||l[0]===3)&&this.m(),!1)))}h(P){P==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=2){const P=this.c.registerMarker(0);P&&(this.a.push(P),this.b.fire(P))}}m(){let P=0;for(let l=this.a.length-1;l>=0&&!(this.a[l].line<this.c.buffer.active.baseY);l--)P++;this.a.splice(this.a.length-P,P)}}e.$fvb=D}),define(fe[93],de([0,1,4,2]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bvb=e.$avb=void 0;class C extends L.$Uc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new w.$he),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new w.$he),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new w.$he),this.onDidRemoveCapability=this.g.event,this.h=this.B(new w.$he),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(P,l){this.a.set(P,l),this.f.fire(P),this.h.fire({id:P,capability:l})}get(P){return this.a.get(P)}remove(P){const l=this.a.get(P);l&&(this.a.delete(P),this.b.fire(P),this.h.fire({id:P,capability:l}))}has(P){return this.a.has(P)}}e.$avb=C;class D extends L.$Uc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new w.$he),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new w.$he),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new w.$he),this.onDidRemoveCapability=this.f.event,this.g=this.B(new w.$he),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const P of this._stores)for(const l of P.items)yield l}has(P){for(const l of this._stores)for(const r of l.items)if(r===P)return!0;return!1}get(P){for(const l of this._stores){const r=l.get(P);if(r)return r}}add(P){this._stores.push(P);for(const l of P.items)this.b.fire(l),this.g.fire({id:l,capability:P.get(l)});this.B(P.onDidAddCapabilityType(l=>this.b.fire(l))),this.B(P.onDidAddCapability(l=>this.g.fire(l))),this.B(P.onDidRemoveCapabilityType(l=>this.a.fire(l))),this.B(P.onDidRemoveCapability(l=>this.f.fire(l)))}}e.$bvb=D}),define(fe[36],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var w;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(w||(e.EnvironmentVariableMutatorType=w={}))}),define(fe[94],de([0,1,3,36]),function(oe,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;const C=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((u,E)=>{this.d(u,E);const a=u.map.entries();let c=a.next();for(;!c.done;){const g=c.value[1],f=c.value[0];let s=this.a.get(f);if(s||(s=[],this.a.set(f,s)),s.length>0&&s[0].type===L.EnvironmentVariableMutatorType.Replace){c=a.next();continue}const n={extensionIdentifier:E,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};n.scope||delete n.scope,s.unshift(n),c=a.next()}})}async applyToProcessEnvironment(y,u,E){let a;w.$i&&(a={},Object.keys(y).forEach(c=>a[c.toLowerCase()]=c));for(const[c,g]of this.getVariableMap(u)){const f=w.$i&&a[c.toLowerCase()]||c;for(const s of g){const n=E?await E(s.value):s.value;if(s.options?.applyAtProcessCreation??!0)switch(s.type){case L.EnvironmentVariableMutatorType.Append:y[f]=(y[f]||"")+n;break;case L.EnvironmentVariableMutatorType.Prepend:y[f]=n+(y[f]||"");break;case L.EnvironmentVariableMutatorType.Replace:y[f]=n;break}if(s.options?.applyAtShellIntegration??!1){const m=`VSCODE_ENV_${C.get(s.type)}`;y[m]=(y[m]?y[m]+":":"")+c+"="+this.c(n)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,u){const E=new Map,a=new Map,c=new Map;if(y.getVariableMap(u).forEach((g,f)=>{const s=this.getVariableMap(u).get(f),n=P(g,s);n&&E.set(f,n)}),this.getVariableMap(u).forEach((g,f)=>{const s=y.getVariableMap(u).get(f),n=P(g,s);n&&c.set(f,n)}),this.getVariableMap(u).forEach((g,f)=>{const s=y.getVariableMap(u).get(f),n=l(g,s);n&&a.set(f,n)}),!(E.size===0&&a.size===0&&c.size===0))return{added:E,changed:a,removed:c}}getVariableMap(y){const u=new Map;for(const E of this.a.values()){const a=E.filter(c=>R(c,y));a.length>0&&u.set(a[0].variable,a)}return u}getDescriptionMap(y){const u=new Map;for(const E of this.b.values()){const a=E.filter(c=>R(c,y,!0));for(const c of a)u.set(c.extensionIdentifier,c.description)}return u}d(y,u){if(!y.descriptionMap)return;const E=y.descriptionMap.entries();let a=E.next();for(;!a.done;){const c=a.value[1],g=a.value[0];let f=this.b.get(g);f||(f=[],this.b.set(g,f));const s={extensionIdentifier:u,scope:c.scope,description:c.description};s.scope||delete s.scope,f.push(s),a=E.next()}}}e.$xs=D;function R(r,y,u=!1){return r.scope?!!(r.scope.workspaceFolder&&y?.workspaceFolder&&r.scope.workspaceFolder.index===y.workspaceFolder.index):u?y===r.scope:!0}function P(r,y){if(!y)return r;const u=new Set;y.forEach(a=>u.add(a.extensionIdentifier));const E=[];return r.forEach(a=>{u.has(a.extensionIdentifier)||E.push(a)}),E.length===0?void 0:E}function l(r,y){if(!y)return;const u=new Map;y.forEach(a=>u.set(a.extensionIdentifier,a));const E=[];return r.forEach(a=>{const c=u.get(a.extensionIdentifier);c&&(a.type!==c.type||a.value!==c.value||a.scope?.workspaceFolder?.index!==c.scope?.workspaceFolder?.index)&&E.push(c)}),E.length===0?void 0:E}}),define(fe[95],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=w,e.$ss=L,e.$ts=C,e.$us=D,e.$vs=R,e.$ws=P;function w(l){return[...l.entries()]}function L(l){return l?[...l.entries()]:[]}function C(l){return new Map(l)}function D(l){return new Map(l??[])}function R(l){return Array.from(l.entries()).map(r=>[r[0],w(r[1].map),L(r[1].descriptionMap)])}function P(l){return new Map(l.map(r=>[r[0],{map:C(r[1]),descriptionMap:D(r[2])}]))}}),define(fe[96],de([0,1,12,17,4,2,8]),function(oe,e,w,L,C,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;let P=class extends D.$Uc{constructor(r,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new C.$he),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,D.$Sc)(()=>{for(const u of this.f.values())(0,D.$Pc)(u)}))}createRequest(r){return new Promise((y,u)=>{const E=++this.a;this.c.set(E,y),this.g.fire({requestId:E,...r});const a=new L.$se;(0,w.$Bh)(this.b,a.token).then(()=>u(`Request ${E} timed out (${this.b}ms)`)),this.f.set(E,[(0,D.$Sc)(()=>a.cancel())])})}acceptReply(r,y){const u=this.c.get(r);u?(this.c.delete(r),(0,D.$Pc)(this.f.get(r)||[]),this.f.delete(r),u(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$is=P,e.$is=P=$e([Fe(1,R.$7j)],P)}),define(fe[28],de([0,1,21,35,86]),function(oe,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=e.$ds=e.$cs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$bs=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$as=void 0,e.$as=new L.$Rj("terminalTabFocusMode",!1,!0);var D;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var R;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var P;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(P||(e.PosixShellType=P={}));var l;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(l||(e.WindowsShellType=l={}));var r;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(r||(e.TitleEventSource=r={}));var y;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var u;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(u||(e.ProcessPropertyType=u={})),e.$bs=(0,w.$Ai)("ptyService");var E;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var a;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(a||(e.TerminalLocation=a={}));var c;(function(i){i.TerminalView="view",i.Editor="editor"})(c||(e.TerminalLocationString=c={}));var g;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var f;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var s;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(s||(e.ProfileSource=s={}));var n;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(n||(e.ShellIntegrationStatus=n={}));var m;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(m||(e.TerminalExitReason=m={})),e.$cs={Backend:"workbench.contributions.terminal.processBackend"};class p{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}C.$ho.add(e.$cs.Backend,new p),e.$ds=(0,w.$Ai)("localPtyService"),e.$es=(0,w.$Ai)("terminalLogService")}),define(fe[97],de([0,1,12,2,3]),function(oe,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=void 0;class D extends L.$Uc{constructor(P,l,r,y){super(),this.a=0,this.b=!1,this.c=!1,this.B(P.onProcessData(u=>{if(this.b||this.c)return;const E=typeof u=="string"?u:u.data;for(let a=0;a<E.length;a++)E[a]===l[this.a]?this.a++:this.f(),this.a===l.length&&(y.debug(`Auto reply match: "${l}", response: "${r}"`),P.input(r),this.c=!0,(0,w.$Bh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){C.$i&&(this.b=!0)}handleInput(){this.b=!1}}e.$Ejc=D}),define(fe[98],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qwb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,D,R=5){const P=D(l=>{const r=typeof l=="string"?l:l.data;let y=this.a.get(C);if(y){y.data.push(r);return}const u=setTimeout(()=>this.flushBuffer(C),R);y={data:[r],timeoutId:u,dispose:()=>{clearTimeout(u),this.flushBuffer(C),P.dispose()}},this.a.set(C,y)});return P}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const D=this.a.get(C);D&&(this.a.delete(C),this.b(C,D.data.join("")))}}e.$qwb=w}),define(fe[37],de([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=L,e.$IP=C,e.$JP=D,e.$KP=R;function L(P){let l=P;l.includes("\\")&&(l=l.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return l=l.replace(r,""),`'${l}'`}function C(P,l,r){if(!P)return"";if(!l)return P;l.match(/[\/\\]$/)&&(l=l.slice(0,l.length-1));const y=P.replace(/\\/g,"/").toLowerCase(),u=l.replace(/\\/g,"/").toLowerCase();return y.includes(u)?`~${r}${P.slice(l.length+1)}`:P}function D(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),w.OS===1&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function R(P){return!P.strictEnv}}),define(fe[99],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=L;var w;(function(C){C[C.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(w||(w={}));function L(C){const D=[];let R=0;for(let P=0;P<C.length-1;P++)(P-R+1>=50||C[P+1]==="\x1B")&&(D.push(C.substring(R,P+1)),R=P+1,P++);return R!==C.length&&D.push(C.substring(R)),D}}),define(fe[100],de([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rVb=w;function w(L,C={}){let D="";return C.excludeLeadingNewLine||(D+=`\r
`),D+="\x1B[0m\x1B[7m * ",C.loudFormatting?D+="\x1B[0;104m":D+="\x1B[0m",D+=` ${L} \x1B[0m
\r`,D}}),define(fe[101],de([0,1,2,93,90,91,92,4,87,6,37,9]),function(oe,e,w,L,C,D,R,P,l,r,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hvb=e.ShellIntegrationOscPs=void 0,e.$ivb=s,e.$jvb=n,e.$kvb=m;var E;(function(p){p[p.FinalTerm=133]="FinalTerm",p[p.VSCode=633]="VSCode",p[p.ITerm=1337]="ITerm",p[p.SetCwd=7]="SetCwd",p[p.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(E||(e.ShellIntegrationOscPs=E={}));var a;(function(p){p.PromptStart="A",p.CommandStart="B",p.CommandExecuted="C",p.CommandFinished="D"})(a||(a={}));var c;(function(p){p.PromptStart="A",p.CommandStart="B",p.CommandExecuted="C",p.CommandFinished="D",p.CommandLine="E",p.ContinuationStart="F",p.ContinuationEnd="G",p.RightPromptStart="H",p.RightPromptEnd="I",p.Property="P",p.SetMark="SetMark"})(c||(c={}));var g;(function(p){p.SetMark="SetMark",p.CurrentDir="CurrentDir"})(g||(g={}));class f extends w.$Uc{get status(){return this.g}constructor(i,t,o,k){super(),this.j=i,this.m=t,this.n=o,this.r=k,this.capabilities=this.B(new L.$avb),this.b=!1,this.f=[],this.g=0,this.h=new P.$he,this.onDidChangeStatus=this.h.event,this.B((0,w.$Sc)(()=>{this.z(),this.s()}))}s(){(0,w.$Pc)(this.f),this.f.length=0}activate(i){this.a=i,this.capabilities.add(3,this.B(new R.$fvb(this.a))),this.B(i.parser.registerOscHandler(633,t=>this.w(t))),this.B(i.parser.registerOscHandler(1337,t=>this.H(t))),this.f.push(i.parser.registerOscHandler(133,t=>this.t(t))),this.B(i.parser.registerOscHandler(7,t=>this.J(t))),this.B(i.parser.registerOscHandler(9,t=>this.I(t))),this.y()}getMarkerId(i,t){this.N(i).getMark(t)}t(i){const t=this.u(i);return this.g===0&&(this.g=1,this.h.fire(this.g)),t}u(i){if(!this.a)return!1;const[t,...o]=i.split(";");switch(t){case"A":return this.M(this.a).handlePromptStart(),!0;case"B":return this.M(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this.M(this.a).handleCommandExecuted(),!0;case"D":{const k=o.length===1?parseInt(o[0]):void 0;return this.M(this.a).handleCommandFinished(k),!0}}return!1}w(i){const t=this.C(i);return!this.b&&t&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==2&&(this.g=2,this.h.fire(this.g)),t}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(i){if(!this.a)return!1;const t=i.indexOf(";"),o=t===-1?i:i.substring(0,t),k=t===-1?[]:i.substring(t+1).split(";");switch(o){case"A":return this.M(this.a).handlePromptStart(),!0;case"B":return this.M(this.a).handleCommandStart(),!0;case"C":return this.M(this.a).handleCommandExecuted(),!0;case"D":{const $=k[0],S=$!==void 0?parseInt($):void 0;return this.M(this.a).handleCommandFinished(S),!0}case"E":{const $=k[0],S=k[1];let v;return $!==void 0?v=s($):v="",this.M(this.a).setCommandLine(v,S===this.j),!0}case"F":return this.M(this.a).handleContinuationStart(),!0;case"G":return this.M(this.a).handleContinuationEnd(),!0;case"H":return this.M(this.a).handleRightPromptStart(),!0;case"I":return this.M(this.a).handleRightPromptEnd(),!0;case"P":{const $=k[0],S=$!==void 0?s($):"",{key:v,value:b}=n(S);if(b===void 0)return!0;switch(v){case"ContinuationPrompt":return this.D((0,u.$Yf)(b)),!0;case"Cwd":return this.G(b),!0;case"IsWindows":return this.M(this.a).setIsWindowsPty(b==="True"),!0;case"Prompt":{const U=b.replace(/\x1b\[[0-9;]*m/g,"");return this.F(U),!0}case"Task":return this.N(this.a),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this.N(this.a).addMark(m(k)),!0}return!1}D(i){this.a&&this.M(this.a).setContinuationPrompt(i)}F(i){if(!this.a)return;const t=i.substring(i.lastIndexOf(`
`)+1),o=t.substring(t.lastIndexOf(" "));o&&this.M(this.a).setPromptTerminator(o,t)}G(i){i=(0,y.$JP)(i),this.L().updateCwd(i),this.capabilities.get(2)?.setCwd(i)}H(i){if(!this.a)return!1;const[t]=i.split(";");switch(t){case"SetMark":this.N(this.a).addMark();default:{const{key:o,value:k}=n(t);if(k===void 0)return!0;switch(o){case"CurrentDir":return this.G(k),!0}}}return!1}I(i){if(!this.a)return!1;const[t,...o]=i.split(";");switch(t){case"9":return o.length&&this.G(o[0]),!0}return!1}J(i){if(!this.a)return!1;const[t]=i.split(";");if(t.match(/^file:\/\/.*\//)){const o=r.URI.parse(t);if(o.path&&o.path.length>0)return this.G(o.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this.M(this.a).serialize()}deserialize(i){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.M(this.a).deserialize(i)}L(){let i=this.capabilities.get(0);return i||(i=this.B(new D.$evb),this.capabilities.add(0,i)),i}M(i){let t=this.capabilities.get(2);return t||(t=this.B(new C.$cvb(i,this.r)),this.capabilities.add(2,t)),t}N(i){let t=this.capabilities.get(4);return t||(t=this.B(new l.$gvb(i)),this.capabilities.add(4,t)),t}}e.$hvb=f;function s(p){return p.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(i,t,o)=>o?String.fromCharCode(parseInt(o,16)):t)}function n(p){const i=p.indexOf("=");return i===-1?{key:p,value:void 0}:{key:p.substring(0,i),value:p.substring(1+i)}}function m(p){let i,t=!1;for(const o of p)o!==void 0&&(o==="Hidden"&&(t=!0),o.startsWith("Id=")&&(i=o.substring(3)));return{id:i,hidden:t}}}),define(fe[38],de([0,1,5,14,4,2,62,8]),function(oe,e,w,L,C,D,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=e.$Fjc=void 0;var l;(function(y){y[y.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",y[y.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(l||(l={})),e.$Fjc=[];let r=class extends D.$Uc{set hasChildProcesses(u){this.a!==u&&(this.a=u,this.f.debug("ChildProcessMonitor: Has child processes changed",u),this.b.fire(u))}get hasChildProcesses(){return this.a}constructor(u,E){super(),this.c=u,this.f=E,this.a=!1,this.b=this.B(new C.$he),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const u=await(0,R.$Js)(this.c);this.hasChildProcesses=this.j(u)}catch(u){this.f.debug("ChildProcessMonitor: Fetching process tree failed",u)}}h(){this.g()}j(u){if(!u.children)return!1;if(u.children.length===1){const E=u.children[0];let a;if(E.cmd.startsWith('"'))a=E.cmd.substring(1,E.cmd.indexOf('"',1));else{const c=E.cmd.indexOf(" ");c===-1?a=E.cmd:a=E.cmd.substring(0,c)}return e.$Fjc.indexOf((0,w.$qc)(a).name)===-1}return u.children.length>0}};e.$Gjc=r,$e([(0,L.$6h)(1e3)],r.prototype,"g",null),$e([(0,L.$7h)(5e3)],r.prototype,"h",null),e.$Gjc=r=$e([Fe(1,P.$7j)],r)}),define(fe[102],de([0,1,4,2,28]),function(oe,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class D extends L.$Uc{constructor(){super(),this.a=this.B(new w.$he),this.onBeat=this.a.event;const P=setInterval(()=>{this.a.fire()},C.HeartbeatConstants.BeatInterval);this.B((0,L.$Sc)(()=>clearInterval(P)))}}e.$Hjc=D}),define(fe[39],de([0,1,20,19,30,5,3,15,9,10,24,36,95,94]),function(oe,e,w,L,C,D,R,P,l,r,y,u,E,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=c,e.$zs=g,e.$As=f;function c(){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());let b=0;return v&&v.length===4&&(b=parseInt(v[3])),b}async function g(v,b,U,Z=P.env,T=y.Promises.exists){if(D.$ic(v))return await T(v)?v:void 0;if(b===void 0&&(b=P.cwd()),D.$mc(v)!=="."){const A=D.$jc(b,v);return await T(A)?A:void 0}const d=(0,C.$bo)(Z,"PATH");if(U===void 0&&(0,r.$ag)(d)&&(U=d.split(D.$tc)),U===void 0||U.length===0){const A=D.$jc(b,v);return await T(A)?A:void 0}for(const A of U){let M;if(D.$ic(A)?M=D.$jc(A,v):M=D.$jc(b,A,v),await T(M))return M;if(R.$i){let q=M+".com";if(await T(q)||(q=M+".exe",await T(q)))return q}}const N=D.$jc(b,v);return await T(N)?N:void 0}function f(v,b,U,Z,T){const I=R.$i&&(!b.windowsEnableConpty||c()<18309);if(!b.shellIntegration.enabled||!v.executable||v.isFeatureTerminal&&!v.forceShellIntegration||v.ignoreShellIntegration||I)return;const d=v.args,N=P.$dc==="win32"?D.$nc(v.executable).toLowerCase():D.$nc(v.executable),A=D.$mc(L.$Ug.asFileUri("").fsPath);let M;const q={VSCODE_INJECTION:"1"};if(b.shellIntegration.nonce&&(q.VSCODE_NONCE=b.shellIntegration.nonce),R.$i){if(N==="pwsh.exe"||N==="powershell.exe")return!d||$(d)?M=m.get(n.WindowsPwsh):k(d)&&(M=m.get(n.WindowsPwshLogin)),M?(M=[...M],M[M.length-1]=(0,l.$_e)(M[M.length-1],A,""),b.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),{newArgs:M,envMixin:q}):void 0;if(N==="bash.exe")return!d||d.length===0?M=m.get(n.Bash):S(d)&&(q.VSCODE_SHELL_LOGIN="1",s(b,q),M=m.get(n.Bash)),M?(M=[...M],M[M.length-1]=(0,l.$_e)(M[M.length-1],A),{newArgs:M,envMixin:q}):void 0;Z.warn(`Shell integration cannot be enabled for executable "${v.executable}" and args`,v.args);return}switch(N){case"bash":return!d||d.length===0?M=m.get(n.Bash):S(d)&&(q.VSCODE_SHELL_LOGIN="1",s(b,q),M=m.get(n.Bash)),M?(M=[...M],M[M.length-1]=(0,l.$_e)(M[M.length-1],A),{newArgs:M,envMixin:q}):void 0;case"fish":{const _=U?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=D.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${_}:${V}`,s(b,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!d||$(d)?M=m.get(n.Pwsh):k(d)&&(M=m.get(n.PwshLogin)),M?(b.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),M=[...M],M[M.length-1]=(0,l.$_e)(M[M.length-1],A,""),{newArgs:M,envMixin:q}):void 0;case"zsh":{if(!d||d.length===0?M=m.get(n.Zsh):S(d)?(M=m.get(n.ZshLogin),s(b,q)):(d===m.get(n.Zsh)||d===m.get(n.ZshLogin))&&(M=d),!M)return;M=[...M],M[M.length-1]=(0,l.$_e)(M[M.length-1],A);let _;try{_=w.userInfo().username}catch{_="unknown"}const V=D.$jc(w.tmpdir(),`${_}-${T.applicationName}-zsh`);q.ZDOTDIR=V;const x=U?.ZDOTDIR??w.homedir()??"~";q.USER_ZDOTDIR=x;const re=[];return re.push({source:D.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$jc(V,".zshrc")}),re.push({source:D.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$jc(V,".zprofile")}),re.push({source:D.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$jc(V,".zshenv")}),re.push({source:D.$jc(A,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$jc(V,".zlogin")}),{newArgs:M,envMixin:q,filesToCopy:re}}}Z.warn(`Shell integration cannot be enabled for executable "${v.executable}" and args`,v.args)}function s(v,b){if(R.$j&&v.environmentVariableCollections){const U=(0,E.$ws)(v.environmentVariableCollections),T=new a.$xs(U).getVariableMap({workspaceFolder:v.workspaceFolder}).get("PATH"),I=[];if(T)for(const d of T)d.type===u.EnvironmentVariableMutatorType.Prepend&&I.push(d.value);I.length>0&&(b.VSCODE_PATH_PREFIX=I.join(""))}}var n;(function(v){v.WindowsPwsh="windows-pwsh",v.WindowsPwshLogin="windows-pwsh-login",v.Pwsh="pwsh",v.PwshLogin="pwsh-login",v.Zsh="zsh",v.ZshLogin="zsh-login",v.Bash="bash"})(n||(n={}));const m=new Map;m.set(n.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(n.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(n.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),m.set(n.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),m.set(n.Zsh,["-i"]),m.set(n.ZshLogin,["-il"]),m.set(n.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const p=["-login","-l"],i=["--login","-l"],t=["-i","--interactive"],o=["-nol","-nologo"];function k(v){return typeof v=="string"?p.includes(v.toLowerCase()):v.length===1&&p.includes(v[0].toLowerCase())||v.length===2&&(p.includes(v[0].toLowerCase())||p.includes(v[1].toLowerCase()))&&(o.includes(v[0].toLowerCase())||o.includes(v[1].toLowerCase()))}function $(v){return typeof v=="string"?o.includes(v.toLowerCase()):v.length===0||v?.length===1&&o.includes(v[0].toLowerCase())}function S(v){return typeof v!="string"&&(v=v.filter(b=>!t.includes(b.toLowerCase()))),v==="string"&&i.includes(v.toLowerCase())||typeof v!="string"&&v.length===1&&i.includes(v[0].toLowerCase())}}),define(fe[103],de([0,1,12,14,4,2,3]),function(oe,e,w,L,C,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;const P=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let l;class r extends D.$Uc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(u){if(super(),this.h=u,this.c="",this.f=new C.$he,this.g=new C.$he,!R.$i)throw new Error(`WindowsShellHelper cannot be instantiated on ${R.$u}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){R.$i&&(await(0,w.$Bh)(300),this.getShellName().then(u=>{const E=this.getShellType(u);E!==this.b&&(this.g.fire(E),this.f.fire(u),this.b=E,this.c=u)}))}m(u){if(!u)return"";if(P.indexOf(u.name)===-1||!u.children||u.children.length===0)return u.name;let E=0;for(;E<u.children.length;E++){const a=u.children[E];if(!a.children||a.children.length===0||a.children[0].name!=="conhost.exe")break}return E>=u.children.length?u.name:this.m(u.children[E])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(l||(l=await new Promise((u,E)=>{oe(["@vscode/windows-process-tree"],u,E)})),this.a=new Promise(u=>{l.getProcessTree(this.h,E=>{const a=this.m(E);this.a=void 0,u(a)})}),this.a)}getShellType(u){switch(u.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return u.match(/python(\d(\.\d{0,2})?)?\.exe/)?"python":void 0}}}e.$Ijc=r,$e([(0,L.$6h)(500)],r.prototype,"checkShell",null)}),define(fe[104],de([0,1,26,12,4,2,5,3,6,24,72,8,85,38,39,103,109,99]),function(oe,e,w,L,C,D,R,P,l,r,y,u,E,a,c,g,f,s){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;var m;(function(k){k[k.DataFlushTimeout=250]="DataFlushTimeout",k[k.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(m||(m={}));var p;(function(k){k[k.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",k[k.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",k[k.WriteInterval=5]="WriteInterval"})(p||(p={}));const i=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["python","python"],["zsh","zsh"]]);let t=class extends D.$Uc{static{n=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return P.$i?this.t?.shellType:i.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor($,S,v,b,U,Z,T,I,d){super(),this.shellLaunchConfig=$,this.N=Z,this.O=T,this.P=I,this.Q=d,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new C.$he),this.onProcessData=this.I.event,this.J=this.B(new C.$he),this.onProcessReady=this.J.event,this.L=this.B(new C.$he),this.onDidChangeProperty=this.L.event,this.M=this.B(new C.$he),this.onProcessExit=this.M.event;let N;P.$i?N=R.$nc(this.shellLaunchConfig.executable||""):N="xterm-256color",this.D=S,this.a.initialCwd=this.D,this.a.cwd=this.D;const A=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,c.$ys)()>=18309;this.F={name:N,cwd:S,env:U,cols:v,rows:b,useConpty:A,conptyInheritCursor:A&&!!$.initialText},P.$i&&(A&&v===0&&b===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new o,this.B(this.C.onTrigger(M=>{this.C?.dispose(),this.C=void 0,M.cols&&M.rows&&this.resize(M.cols,M.rows)}))),this.onProcessReady(M=>{this.t=this.B(new g.$Ijc(M.pid)),this.B(this.t.onShellTypeChanged(q=>this.L.fire({type:"shellType",value:q}))),this.B(this.t.onShellNameChanged(q=>this.L.fire({type:"title",value:q})))})),this.B((0,D.$Sc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const S=(await Promise.all([this.R(),this.S()])).find(b=>b!==void 0);if(S)return S;let v;if(this.O.shellIntegration.enabled)if(v=(0,c.$As)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),v){if(this.L.fire({type:"usedShellIntegrationInjection",value:!0}),v.envMixin)for(const[b,U]of Object.entries(v.envMixin))this.F.env||={},this.F.env[b]=U;if(v.filesToCopy)for(const b of v.filesToCopy){await r.Promises.mkdir(R.$mc(b.dest),{recursive:!0});try{await r.Promises.copyFile(b.source,b.dest)}catch{}}}else this.L.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.U(this.shellLaunchConfig,this.F,v),v?.newArgs?{injectedArgs:v.newArgs}:void 0}catch(b){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",b),{message:`A native exception occurred during launch (${b.message})`}}}async R(){try{if(!(await r.Promises.stat(this.D)).isDirectory())return{message:(0,y.localize)(0,null,this.D.toString())}}catch($){if($?.code==="ENOENT")return{message:(0,y.localize)(1,null,this.D.toString())}}this.L.fire({type:"initialCwd",value:this.D})}async S(){const $=this.shellLaunchConfig;if(!$.executable)throw new Error("IShellLaunchConfig.executable not set");const S=$.cwd instanceof l.URI?$.cwd.path:$.cwd,v=$.env&&$.env.PATH?$.env.PATH.split(R.$tc):void 0,b=await(0,c.$zs)($.executable,S,v,this.N);if(!b)return{message:(0,y.localize)(2,null,$.executable)};try{const U=await r.Promises.stat(b);if(!U.isFile()&&!U.isSymbolicLink())return{message:(0,y.localize)(3,null,$.executable)};$.executable=b}catch(U){if(U?.code!=="EACCES")throw U}}async U($,S,v){const b=v?.newArgs||$.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",$.executable,b,S);const U=(0,f.spawn)($.executable,b,S);this.m=U,this.u=this.B(new a.$Gjc(U.pid,this.P)),this.u.onDidChangeHasChildProcesses(Z=>this.L.fire({type:"hasChildProcesses",value:Z})),this.s=new Promise(Z=>{this.onProcessReady(()=>Z())}),U.onData(Z=>{this.H+=Z.length,!this.G&&this.H>1e5&&(this.P.trace(`Flow control: Pause (${this.H} > 100000)`),this.G=!0,U.pause()),this.P.trace("node-pty.IPty#onData",Z),this.I.fire(Z),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),U.onExit(Z=>{this.g=Z.exitCode,this.X()}),this.$(U.pid),this.W(U)}W($){setTimeout(()=>this.ab($)),P.$i||(this.w=setInterval(()=>{this.n!==$.process&&this.ab($)},200))}X(){this.P.getLevel()===u.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},250)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!P.$i||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-n.b<250;)this.P.trace("Throttling kill/spawn call"),await(0,L.$Bh)(250-(Date.now()-n.b)+50);n.b=Date.now()}}$($){this.J.fire({pid:$,cwd:this.D,windowsPty:this.getWindowsPty()})}ab($){if(this.q.isDisposed)return;this.n=$.process,this.L.fire({type:"title",value:this.n});const S=this.currentTitle.replace(/ \(figterm\)$/g,"");S.toLowerCase().startsWith("python")?this.L.fire({type:"shellType",value:"python"}):this.L.fire({type:"shellType",value:i.get(S)})}shutdown($){this.P.getLevel()===u.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),$&&!P.$i?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},5e3))}input($,S=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,s.$_r)($).map(v=>({isBinary:S,data:v}))),this.bb())}async processBinary($){this.input($,!0)}async refreshProperty($){switch($){case"cwd":{const S=await this.getCwd();return S!==this.a.cwd&&(this.a.cwd=S,this.L.fire({type:"cwd",value:this.a.cwd})),S}case"initialCwd":{const S=await this.getInitialCwd();return S!==this.a.initialCwd&&(this.a.initialCwd=S,this.L.fire({type:"initialCwd",value:this.a.initialCwd})),S}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty($,S){$==="fixedDimensions"&&(this.a.fixedDimensions=S)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},5)}}cb(){const $=this.y.shift();this.P.trace("node-pty.IPty#write",$.data),$.isBinary?this.m.write(Buffer.from($.data,"binary")):this.m.write($.data),this.u?.handleInput()}resize($,S){if(!this.q.isDisposed&&!(typeof $!="number"||typeof S!="number"||isNaN($)||isNaN(S))&&this.m){if($=Math.max($,1),S=Math.max(S,1),this.C){this.C.cols=$,this.C.rows=S;return}this.P.trace("node-pty.IPty#resize",$,S);try{this.m.resize($,S)}catch(v){if(this.P.trace("node-pty.IPty#resize exception "+v.message),this.g!==void 0&&v.message!=="ioctl(2) failed, EBADF"&&v.message!=="Cannot resize a pty that has already exited")throw v}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent($){this.H=Math.max(this.H-$,0),this.P.trace(`Flow control: Ack ${$} chars (unacknowledged: ${this.H})`),this.G&&this.H<5e3&&(this.P.trace(`Flow control: Resume (${this.H} < 5000)`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(P.$j)return new Promise($=>{if(!this.m){$(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,w.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(S,v,b)=>{!S&&v!==""?$(v.substring(v.indexOf("/"),v.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",S,v,b),$(this.D))})});if(P.$k){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await r.Promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return P.$i?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,c.$ys)()}:void 0}};e.$Jjc=t,e.$Jjc=t=n=$e([Fe(7,u.$7j),Fe(8,E.$nk)],t);class o extends D.$Uc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new C.$he),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,D.$Sc)(()=>clearTimeout(this.a)))}}}),define(fe[105],de([0,1,26,12,4,2,3,63,8,96,28,98,37,110,39,104,71,38,97,7,101,100,77,14,111]),function(oe,e,w,L,C,D,R,P,l,r,y,u,E,a,c,g,f,s,n,m,p,i,t,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=void 0,e.$Kjc=$;function $(N,A,M){if(typeof M.value!="function")throw new Error("not supported");const q="value",_=M.value;M[q]=async function(...V){this.traceRpcArgs.logService.getLevel()===l.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${_.name}(${V.map(re=>JSON.stringify(re)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,L.$Bh)(this.traceRpcArgs.simulatedLatency);let x;try{x=await _.apply(this,V)}catch(re){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${_.name}`,re),re}return this.traceRpcArgs.logService.getLevel()===l.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${_.name}`,x),x}}let S,v;class b extends D.$Uc{H(A,M){return M(q=>{this.I.getLevel()===l.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${A}.fire(${JSON.stringify(q)})`)}),M}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(A,M,q,_){super(),this.I=A,this.J=M,this.L=q,this.M=_,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new C.$he),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new C.$he),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new C.$he),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new C.$he),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new C.$he),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new C.$he),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new C.$he),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new C.$he),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,D.$Sc)(()=>{for(const V of this.a.values())V.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$is(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(A){s.$Fjc.length=0,s.$Fjc.push(...A)}async requestDetachInstance(A,M){return this.f.createRequest({workspaceId:A,instanceId:M})}async acceptDetachInstanceReply(A,M){let q;const _=this.a.get(M);_&&(q=await this.S(M,_)),this.f.acceptReply(A,q)}async freePortKillProcess(A){const q=(await new Promise((_,V)=>{(0,w.exec)(R.$i?`netstat -ano | findstr "${A}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${A}`,{},(x,re)=>{if(x)return V("Problem occurred when listing active processes");_(re)})})).split(/\r?\n/).filter(_=>!!_.trim());if(q.length>=1){const _=/\s+(\d+)(?:\s+|$)/,V=q[0].match(_)?.[1];if(V)try{process.kill(Number.parseInt(V))}catch{}else throw new Error(`Processes for port ${A} were not found`);return{port:A,processId:V}}throw new Error(`Could not kill process with port ${A}`)}async serializeTerminalState(A){const M=[];for(const[_,V]of this.a.entries())V.hasWrittenData&&A.indexOf(_)!==-1&&M.push(L.Promises.withAsyncBody(async x=>{x({id:_,shellLaunchConfig:V.shellLaunchConfig,processDetails:await this.S(_,V),processLaunchConfig:V.processLaunchOptions,unicodeVersion:V.unicodeVersion,replayEvent:await V.serializeNormalBuffer(),timestamp:Date.now()})}));const q={version:1,state:await Promise.all(M)};return JSON.stringify(q)}async reviveTerminalProcesses(A,M,q){const _=[];for(const V of M)_.push(this.N(A,V));await Promise.all(_)}async N(A,M){const q=(0,f.localize)(0,null),_=await this.createProcess({...M.shellLaunchConfig,cwd:M.processDetails.cwd,color:M.processDetails.color,icon:M.processDetails.icon,name:M.processDetails.titleSource===y.TitleEventSource.Api?M.processDetails.title:void 0,initialText:M.replayEvent.events[0].data+(0,i.$rVb)(q,{loudFormatting:!0})},M.processDetails.cwd,M.replayEvent.events[0].cols,M.replayEvent.events[0].rows,M.unicodeVersion,M.processLaunchConfig.env,M.processLaunchConfig.executableEnv,M.processLaunchConfig.options,!0,M.processDetails.workspaceId,M.processDetails.workspaceName,!0,M.replayEvent.events[0].data),V=this.R(A,M.id);this.g.set(V,{newId:_,state:M}),this.I.info(`Revived process, old id ${V} -> new id ${_}`)}async shutdownAll(){this.dispose()}async createProcess(A,M,q,_,V,x,re,he,X,z,Q,ee,le){if(A.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const W=++this.n,ce=new g.$Jjc(A,M,q,_,x,re,he,this.I,this.J),te={env:x,executableEnv:re,options:he},h=new Z(W,ce,z,Q,X,q,_,te,V,this.L,this.I,ee&&typeof A.initialText=="string"?A.initialText:void 0,le,A.icon,A.color,A.name,A.fixedDimensions);return ce.onProcessExit(F=>{h.dispose(),this.a.delete(W),this.C.fire({id:W,event:F})}),h.onProcessData(F=>this.w.fire({id:W,event:F})),h.onProcessReplay(F=>this.y.fire({id:W,event:F})),h.onProcessReady(F=>this.z.fire({id:W,event:F})),h.onProcessOrphanQuestion(()=>this.D.fire({id:W})),h.onDidChangeProperty(F=>this.G.fire({id:W,property:F})),h.onPersistentProcessReady(()=>{for(const F of this.j.entries())h.installAutoReply(F[0],F[1])}),this.a.set(W,h),W}async attachToProcess(A){try{await this.U(A).attach(),this.I.info(`Persistent process reconnection "${A}"`)}catch(M){throw this.I.warn(`Persistent process reconnection "${A}" failed`,M.message),M}}async updateTitle(A,M,q){this.U(A).setTitle(M,q)}async updateIcon(A,M,q,_){this.U(A).setIcon(M,q,_)}async clearBuffer(A){this.U(A).clearBuffer()}async refreshProperty(A,M){return this.U(A).refreshProperty(M)}async updateProperty(A,M,q){return this.U(A).updateProperty(M,q)}async detachFromProcess(A,M){return this.U(A).detach(M)}async reduceConnectionGraceTime(){for(const A of this.a.values())A.reduceGraceTime()}async listProcesses(){const A=Array.from(this.a.entries()).filter(([_,V])=>V.shouldPersistTerminal);this.I.info(`Listing ${A.length} persistent terminals, ${this.a.size} total terminals`);const M=A.map(async([_,V])=>this.S(_,V));return(await Promise.all(M)).filter(_=>_.isOrphan)}async getPerformanceMarks(){return k.getMarks()}async start(A){const M=this.a.get(A);return M?M.start():{message:`Could not find pty with id "${A}"`}}async shutdown(A,M){return this.a.get(A)?.shutdown(M)}async input(A,M){return this.U(A).input(M)}async processBinary(A,M){return this.U(A).writeBinary(M)}async resize(A,M,q){return this.U(A).resize(M,q)}async getInitialCwd(A){return this.U(A).getInitialCwd()}async getCwd(A){return this.U(A).getCwd()}async acknowledgeDataEvent(A,M){return this.U(A).acknowledgeDataEvent(M)}async setUnicodeVersion(A,M){return this.U(A).setUnicodeVersion(M)}async getLatency(){return[]}async orphanQuestionReply(A){return this.U(A).orphanQuestionReply()}async installAutoReply(A,M){this.j.set(A,M);for(const q of this.a.values())q.installAutoReply(A,M)}async uninstallAllAutoReplies(){for(const A of this.j.keys())for(const M of this.a.values())M.uninstallAutoReply(A)}async uninstallAutoReply(A){for(const M of this.a.values())M.uninstallAutoReply(A)}async getDefaultSystemShell(A=R.OS){return(0,P.$um)(A,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(A,M){if(M==="win-to-unix"){if(!R.$i)return A;if((0,c.$ys)()<17063)return A.replace(/\\/g,"/");const q=this.O();return q?new Promise(_=>{(0,w.execFile)(q,["-e","wslpath",A],{},(x,re,he)=>{_(x?A:(0,E.$HP)(re.trim()))}).stdin.end()}):A}if(M==="unix-to-win"&&R.$i){if((0,c.$ys)()<17063)return A;const q=this.O();return q?new Promise(_=>{(0,w.execFile)(q,["-e","wslpath","-w",A],{},(x,re,he)=>{_(x?A:re.trim())}).stdin.end()}):A}return A}O(){const A=(0,c.$ys)()>=16299,M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),q=process.env.SystemRoot;if(q)return(0,t.join)(q,M?"Sysnative":"System32",A?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(A,M){try{return this.g.get(this.R(A,M))?.newId}catch(q){this.I.warn(`Couldn't find terminal ID ${A}-${M}`,q.message)}}async setTerminalLayoutInfo(A){this.b.set(A.workspaceId,A)}async getTerminalLayoutInfo(A){k.mark("code/willGetTerminalLayoutInfo");const M=this.b.get(A.workspaceId);if(M){const q=new Set,V=(await Promise.all(M.tabs.map(async x=>this.P(A.workspaceId,x,q)))).filter(x=>x.terminals.length>0);return k.mark("code/didGetTerminalLayoutInfo"),{tabs:V}}k.mark("code/didGetTerminalLayoutInfo")}async P(A,M,q){const V=(await Promise.all(M.terminals.map(x=>this.Q(A,x,q)))).filter(x=>x.terminal!==null);return{isActive:M.isActive,activePersistentProcessId:M.activePersistentProcessId,terminals:V}}async Q(A,M,q){try{const _=this.R(A,M.terminal),V=this.g.get(_)?.newId;this.I.info(`Expanding terminal instance, old id ${_} -> new id ${V}`),this.g.delete(_);const x=V??M.terminal;if(q.has(x))throw new Error(`Terminal ${x} has already been expanded`);q.add(x);const re=this.U(x);return{terminal:{...re&&await this.S(M.terminal,re,V!==void 0),id:x},relativeSize:M.relativeSize}}catch(_){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",_.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",M),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:M.relativeSize}}}R(A,M){return`${A}-${M}`}async S(A,M,q=!1){k.mark(`code/willBuildProcessDetails/${A}`);const[_,V]=await Promise.all([M.getCwd(),q?!0:M.isOrphaned()]),x={id:A,title:M.title,titleSource:M.titleSource,pid:M.pid,workspaceId:M.workspaceId,workspaceName:M.workspaceName,cwd:_,isOrphan:V,icon:M.icon,color:M.color,fixedDimensions:M.fixedDimensions,environmentVariableCollections:M.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:M.shellLaunchConfig.reconnectionProperties,waitOnExit:M.shellLaunchConfig.waitOnExit,hideFromUser:M.shellLaunchConfig.hideFromUser,isFeatureTerminal:M.shellLaunchConfig.isFeatureTerminal,type:M.shellLaunchConfig.type,hasChildProcesses:M.hasChildProcesses,shellIntegrationNonce:M.processLaunchOptions.options.shellIntegration.nonce};return k.mark(`code/didBuildProcessDetails/${A}`),x}U(A){const M=this.a.get(A);if(!M)throw new m.$bb("Could not find pty on pty host");return M}}e.$Ljc=b,$e([o.$5h],b.prototype,"traceRpcArgs",null),$e([$],b.prototype,"refreshIgnoreProcessNames",null),$e([$],b.prototype,"requestDetachInstance",null),$e([$],b.prototype,"acceptDetachInstanceReply",null),$e([$],b.prototype,"freePortKillProcess",null),$e([$],b.prototype,"serializeTerminalState",null),$e([$],b.prototype,"reviveTerminalProcesses",null),$e([$],b.prototype,"shutdownAll",null),$e([$],b.prototype,"createProcess",null),$e([$],b.prototype,"attachToProcess",null),$e([$],b.prototype,"updateTitle",null),$e([$],b.prototype,"updateIcon",null),$e([$],b.prototype,"clearBuffer",null),$e([$],b.prototype,"refreshProperty",null),$e([$],b.prototype,"updateProperty",null),$e([$],b.prototype,"detachFromProcess",null),$e([$],b.prototype,"reduceConnectionGraceTime",null),$e([$],b.prototype,"listProcesses",null),$e([$],b.prototype,"getPerformanceMarks",null),$e([$],b.prototype,"start",null),$e([$],b.prototype,"shutdown",null),$e([$],b.prototype,"input",null),$e([$],b.prototype,"processBinary",null),$e([$],b.prototype,"resize",null),$e([$],b.prototype,"getInitialCwd",null),$e([$],b.prototype,"getCwd",null),$e([$],b.prototype,"acknowledgeDataEvent",null),$e([$],b.prototype,"setUnicodeVersion",null),$e([$],b.prototype,"getLatency",null),$e([$],b.prototype,"orphanQuestionReply",null),$e([$],b.prototype,"installAutoReply",null),$e([$],b.prototype,"uninstallAllAutoReplies",null),$e([$],b.prototype,"uninstallAutoReply",null),$e([$],b.prototype,"getDefaultSystemShell",null),$e([$],b.prototype,"getEnvironment",null),$e([$],b.prototype,"getWslPath",null),$e([$],b.prototype,"getRevivedPtyNewId",null),$e([$],b.prototype,"setTerminalLayoutInfo",null),$e([$],b.prototype,"getTerminalLayoutInfo",null);var U;(function(N){N.None="None",N.ReplayOnly="ReplayOnly",N.Session="Session"})(U||(U={}));class Z extends D.$Uc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!=="None"}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(A,M){M===y.TitleEventSource.Api&&(this.j.setValue("Session","setTitle"),this.P.freeRawReviveBuffer()),this.N=A,this.O=M}setIcon(A,M,q){(!this.Y||"id"in M&&"id"in this.Y&&M.id!==this.Y.id||!this.color||q!==this.Z)&&(this.P.freeRawReviveBuffer(),A&&this.j.setValue("Session","setIcon")),this.Y=M,this.Z=q}S(A){this.R=A}constructor(A,M,q,_,V,x,re,he,X,z,Q,ee,le,W,ce,te,h){super(),this.U=A,this.W=M,this.workspaceId=q,this.workspaceName=_,this.shouldPersistTerminal=V,this.processLaunchOptions=he,this.unicodeVersion=X,this.X=Q,this.Y=W,this.Z=ce,this.b=new Map,this.f=new Map,this.g=!1,this.w=new L.$Hh,this.C=this.B(new C.$he),this.onProcessReplay=this.C.event,this.D=this.B(new C.$he),this.onProcessReady=this.D.event,this.F=this.B(new C.$he),this.onPersistentProcessReady=this.F.event,this.G=this.B(new C.$he),this.onProcessData=this.G.event,this.H=this.B(new C.$he),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new C.$he),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=y.TitleEventSource.Process,this.j=new T(`Persistent process "${this.U}" interaction state`,"None",this.X),this.Q=ee!==void 0,this.P=new I(x,re,z.scrollback,X,ee,he.options.shellIntegration.nonce,V?le:void 0,this.X),te&&this.setTitle(te,y.TitleEventSource.Api),this.R=h,this.n=null,this.u=0,this.y=this.B(new L.$Nh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${d(z.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},z.graceTime)),this.z=this.B(new L.$Nh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${d(z.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},z.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(F=>{this.L=F.pid,this.M=F.cwd,this.D.fire(F)})),this.B(this.W.onDidChangeProperty(F=>{this.I.fire(F)})),this.a=new u.$qwb((F,ne)=>this.G.fire(ne)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(F=>this.P.handleData(F))),this.B((0,D.$Sc)(()=>{for(const F of this.b.values())F.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(A){this.shouldPersistTerminal&&(this.j.value!=="None"||A)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!=="Session")}async refreshProperty(A){return this.W.refreshProperty(A)}async updateProperty(A,M){if(A==="fixedDimensions")return this.S(M)}async start(){if(!this.g){const A=await this.W.start();return A&&"message"in A||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),A}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:"title",value:this.W.currentTitle}),this.I.fire({type:"shellType",value:this.W.shellType}),this.triggerReplay()}shutdown(A){return this.W.shutdown(A)}input(A){if(this.j.setValue("Session","input"),this.P.freeRawReviveBuffer(),!this.J){for(const M of this.b.values())M.handleInput();return this.W.input(A)}}writeBinary(A){return this.W.processBinary(A)}resize(A,M){if(!this.J){this.P.handleResize(A,M),this.a.flushBuffer(this.U);for(const q of this.b.values())q.handleResize();return this.W.resize(A,M)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(A){this.unicodeVersion=A,this.P.setUnicodeVersion?.(A)}acknowledgeDataEvent(A){if(!this.J)return this.W.acknowledgeDataEvent(A)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value==="None"&&this.j.setValue("ReplayOnly","triggerReplay");const A=await this.P.generateReplayEvent();let M=0;for(const q of A.events)M+=q.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${M} chars and ${A.events.length} size events`),this.C.fire(A),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(A,M){this.b.get(A)?.dispose(),this.b.set(A,new n.$Ejc(this.W,A,M,this.X))}uninstallAutoReply(A){this.b.get(A)?.dispose(),this.b.delete(A)}sendCommandResult(A,M,q){this.f.get(A)&&this.f.delete(A)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const A=this.n;this.n=null,A.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new L.$Ah(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class T{get value(){return this.b}setValue(A,M){this.b!==A&&(this.b=A,this.f(M))}constructor(A,M,q){this.a=A,this.b=M,this.d=q,this.f("initialized")}f(A){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${A}`)}}class I{constructor(A,M,q,_,V,x,re,he){this.f=re,this.a=new a.Terminal({cols:A,rows:M,scrollback:q,allowProposedApi:!0}),V&&this.a.writeln(V),this.setUnicodeVersion(_),this.b=new p.$hvb(x,!0,void 0,he),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(A){this.a.write(A)}handleResize(A,M){this.a.resize(A,M)}clearBuffer(){this.a.clear()}async generateReplayEvent(A,M){const q=new(await this._getSerializeConstructor());this.a.loadAddon(q);const _={scrollback:this.a.options.scrollback};A&&(_.excludeAltBuffer=!0,_.excludeModes=!0);let V;return M&&this.f?V=this.f:V=q.serialize(_),{events:[{cols:this.a.cols,rows:this.a.rows,data:V}],commands:this.b.serialize()}}async setUnicodeVersion(A){this.a.unicode.activeVersion!==A&&(A==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=A)}async _getUnicode11Constructor(){return v||(v=(await new Promise((A,M)=>{oe(["@xterm/addon-unicode11"],A,M)})).Unicode11Addon),v}async _getSerializeConstructor(){return S||(S=(await new Promise((A,M)=>{oe(["@xterm/addon-serialize"],A,M)})).SerializeAddon),S}}function d(N){let A=0,M=0,q=0;N>=1e3&&(q=Math.floor(N/1e3),N-=q*1e3),q>=60&&(M=Math.floor(q/60),q-=M*60),M>=60&&(A=Math.floor(M/60),M-=A*60);const _=A?`${A}h`:"",V=M?`${M}m`:"",x=q?`${q}s`:"",re=N?`${N}ms`:"";return`${_}${V}${x}${re}`}}),define(fe[112],de([0,1,60,27,64,65,11,75,78,8,80,81,83,84,28,102,105,31,12,2]),function(oe,e,w,L,C,D,R,P,l,r,y,u,E,a,c,g,f,s,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p();async function p(){const i=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),t=parseInt(process.env.VSCODE_LATENCY??"0"),o={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,i&&await(0,n.$Bh)(i);const k=(0,s.$yW)(process);let $;k?$=new D.$zW:$=new C.$6q(c.TerminalIpcChannels.PtyHost);const S={_serviceBrand:void 0,...a.default},v=new l.$an((0,P.$xm)(process.argv,P.$wm),S),b=new E.$8P((0,r.$ik)(v),v.logsHome);$.registerChannel(c.TerminalIpcChannels.Logger,new y.$gs(b,()=>w.$Dn));const U=b.createLogger("ptyhost",{name:(0,R.localize)(0,null)}),Z=new u.$fQ(U);i&&Z.warn(`Pty Host startup is delayed ${i}ms`),t&&Z.warn(`Pty host is simulating ${t}ms latency`);const T=new m.$Tc,I=new g.$Hjc;$.registerChannel(c.TerminalIpcChannels.Heartbeat,L.ProxyChannel.fromService(I,T));const d=new f.$Ljc(Z,S,o,t),N=L.ProxyChannel.fromService(d,T);$.registerChannel(c.TerminalIpcChannels.PtyHost,N),k&&$.registerChannel(c.TerminalIpcChannels.PtyHostWindow,N),process.once("exit",()=>{Z.trace("Pty host exiting"),Z.dispose(),I.dispose(),d.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/platform/terminal/node/ptyHostMain.js.map
