/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/themables","vs/editor/common/core/position","vs/base/common/process","vs/base/common/marshalling","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(le){for(var e=[],l=0,L=le.length;l<L;l++)e[l]=ke[le[l]];return e};define(ke[163],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class l{static get(){const M=new Map,A=new Map,R=new Map,w=new Map;function $(E,v){E.has(v.detail)||E.set(v.detail,-v.timestamp)}function k(E,v){const d=E.get(v.detail);d&&(d>=0||E.set(v.detail,d+v.timestamp))}let I=[];typeof le=="function"&&typeof le.getStats=="function"&&(I=le.getStats().slice(0).sort((E,v)=>E.timestamp-v.timestamp));for(const E of I)switch(E.type){case 10:$(M,E);break;case 11:case 12:k(M,E);break;case 21:$(A,E);break;case 22:k(A,E);break;case 33:$(R,E);break;case 34:k(R,E);break;case 31:$(w,E);break;case 32:k(w,E);break}let P=0;R.forEach(E=>P+=E);function p(E){const v=[];return E.forEach((d,h)=>v.push([h,d])),v}return{amdLoad:p(M),amdInvoke:p(A),nodeRequire:p(R),nodeEval:p(w),nodeRequireTotal:P}}static toMarkdownTable(M,A){let R="";const w=[];return M.forEach(($,k)=>{w[k]=$.length}),A.forEach($=>{$.forEach((k,I)=>{typeof k>"u"&&(k=$[I]="-");const P=k.toString().length;w[I]=Math.max(P,w[I])})}),M.forEach(($,k)=>{R+=`| ${$+" ".repeat(w[k]-$.toString().length)} `}),R+=`|
`,M.forEach(($,k)=>{R+=`| ${"-".repeat(w[k])} `}),R+=`|
`,A.forEach($=>{$.forEach((k,I)=>{typeof k<"u"&&(R+=`| ${k+" ".repeat(w[I]-k.toString().length)} `)}),R+=`|
`}),R}}e.$U=l}),define(ke[164],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=l,e.$gb=L,e.$hb=M,e.$ib=A,e.$jb=R,e.$kb=w,e.$lb=$,e.$nb=I,e.$ob=P,e.$pb=p,e.$qb=E,e.$rb=v;function l(d,h){const c=L(d,h);if(c!==-1)return d[c]}function L(d,h,c=d.length-1){for(let i=c;i>=0;i--){const n=d[i];if(h(n))return i}return-1}function M(d,h){const c=A(d,h);return c===-1?void 0:d[c]}function A(d,h,c=0,i=d.length){let n=c,a=i;for(;n<a;){const r=Math.floor((n+a)/2);h(d[r])?n=r+1:a=r}return n-1}function R(d,h){const c=w(d,h);return c===d.length?void 0:d[c]}function w(d,h,c=0,i=d.length){let n=c,a=i;for(;n<a;){const r=Math.floor((n+a)/2);h(d[r])?a=r:n=r+1}return n}function $(d,h,c=0,i=d.length){const n=w(d,h,c,i);return n===d.length?-1:n}class k{static{this.assertInvariants=!1}constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if(k.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!h(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const c=A(this.e,h,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=k;function I(d,h){if(d.length===0)return;let c=d[0];for(let i=1;i<d.length;i++){const n=d[i];h(n,c)>0&&(c=n)}return c}function P(d,h){if(d.length===0)return;let c=d[0];for(let i=1;i<d.length;i++){const n=d[i];h(n,c)>=0&&(c=n)}return c}function p(d,h){return I(d,(c,i)=>-h(c,i))}function E(d,h){if(d.length===0)return-1;let c=0;for(let i=1;i<d.length;i++){const n=d[i];h(n,d[c])>0&&(c=i)}return c}function v(d,h){for(const c of d){const i=h(c);if(i!==void 0)return i}}}),define(ke[74],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=l,e.$L=L,e.$M=M,e.$N=A;function l(R,w){const $=Object.create(null);for(const k of R){const I=w(k);let P=$[I];P||(P=$[I]=[]),P.push(k)}return $}function L(R,w){const $=[],k=[];for(const I of R)w.has(I)||$.push(I);for(const I of w)R.has(I)||k.push(I);return{removed:$,added:k}}function M(R,w){const $=[],k=[];for(const[I,P]of R)w.has(I)||$.push(P);for(const[I,P]of w)R.has(I)||k.push(P);return{removed:$,added:k}}function A(R,w){const $=new Set;for(const k of w)R.has(k)&&$.add(k);return $}}),define(ke[57],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=L,e.$6h=M,e.$7h=A;function l(R){return(w,$,k)=>{let I=null,P=null;if(typeof k.value=="function"?(I="value",P=k.value):typeof k.get=="function"&&(I="get",P=k.get),!P)throw new Error("not supported");k[I]=R(P,$)}}function L(R,w,$){let k=null,I=null;if(typeof $.value=="function"?(k="value",I=$.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(k="get",I=$.get),!I)throw new Error("not supported");const P=`$memoize$${w}`;$[k]=function(...p){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,p)}),this[P]}}function M(R,w,$){return l((k,I)=>{const P=`$debounce$${I}`,p=`$debounce$result$${I}`;return function(...E){this[p]||(this[p]=$?$():void 0),clearTimeout(this[P]),w&&(this[p]=w(this[p],...E),E=[this[p]]),this[P]=setTimeout(()=>{k.apply(this,E),this[p]=$?$():void 0},R)}})}function A(R,w,$){return l((k,I)=>{const P=`$throttle$timer$${I}`,p=`$throttle$result$${I}`,E=`$throttle$lastRun$${I}`,v=`$throttle$pending$${I}`;return function(...d){if(this[p]||(this[p]=$?$():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),w&&(this[p]=w(this[p],...d)),this[v])return;const h=this[E]+R;h<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[p]]),this[p]=$?$():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[E]=Date.now(),k.apply(this,[this[p]]),this[p]=$?$():void 0},h-Date.now()))}})}}),define(ke[13],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=L,e.$Z=M,e.$1=A,e.$2=R,e.$3=w,e.$4=k,e.$6=P,e.$7=p,e.$8=E,e.$0=d;class l{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=l,e.$X=new l;function L(r){e.$X.setUnexpectedErrorHandler(r)}function M(r){if(!r||typeof r!="object")return!1;const t=r;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(r){k(r)||e.$X.onUnexpectedError(r)}function R(r){k(r)||e.$X.onUnexpectedExternalError(r)}function w(r){if(r instanceof Error){const{name:t,message:f}=r,o=r.stacktrace||r.stack;return{$isError:!0,name:t,message:f,stack:o,noTelemetry:n.isErrorNoTelemetry(r)}}return r}const $="Canceled";function k(r){return r instanceof I?!0:r instanceof Error&&r.name===$&&r.message===$}class I extends Error{constructor(){super($),this.name=this.message}}e.$5=I;function P(){const r=new Error($);return r.name=r.message,r}function p(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}function E(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function d(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}class h extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=h;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=c;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const f=new n;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class a extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype)}}e.$cb=a}),define(ke[19],De([1,0,13,164]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=M,e.$tb=A,e.$ub=R,e.$vb=w,e.$wb=$,e.$xb=k,e.$yb=I,e.$zb=P,e.$Ab=p,e.$Bb=E,e.$Cb=v,e.$Db=d,e.$Eb=h,e.top=c,e.$Gb=i,e.$Hb=a,e.$Ib=r,e.$Jb=t,e.$Kb=f,e.$Lb=o,e.$Mb=s,e.$Nb=u,e.$Ob=g,e.$Pb=b,e.$Qb=S,e.$Rb=m,e.$Sb=y,e.$Tb=D,e.$Ub=C,e.$Vb=O,e.$Wb=z,e.$Xb=T,e.$Yb=F,e.$Zb=N,e.$1b=j,e.$2b=B,e.$3b=X,e.$4b=ie,e.$5b=H,e.$6b=_,e.$7b=ge,e.$0b=me;function M(ce,ae=0){return ce[ce.length-(1+ae)]}function A(ce){if(ce.length===0)throw new Error("Invalid tail call");return[ce.slice(0,ce.length-1),ce[ce.length-1]]}function R(ce,ae,se=(ue,Q)=>ue===Q){if(ce===ae)return!0;if(!ce||!ae||ce.length!==ae.length)return!1;for(let ue=0,Q=ce.length;ue<Q;ue++)if(!se(ce[ue],ae[ue]))return!1;return!0}function w(ce,ae){const se=ce.length-1;ae<se&&(ce[ae]=ce[se]),ce.pop()}function $(ce,ae,se){return k(ce.length,ue=>se(ce[ue],ae))}function k(ce,ae){let se=0,ue=ce-1;for(;se<=ue;){const Q=(se+ue)/2|0,re=ae(Q);if(re<0)se=Q+1;else if(re>0)ue=Q-1;else return Q}return-(se+1)}function I(ce,ae,se){if(ce=ce|0,ce>=ae.length)throw new TypeError("invalid index");const ue=ae[Math.floor(ae.length*Math.random())],Q=[],re=[],$e=[];for(const we of ae){const Ne=se(we,ue);Ne<0?Q.push(we):Ne>0?re.push(we):$e.push(we)}return ce<Q.length?I(ce,Q,se):ce<Q.length+$e.length?$e[0]:I(ce-(Q.length+$e.length),re,se)}function P(ce,ae){const se=[];let ue;for(const Q of ce.slice(0).sort(ae))!ue||ae(ue[0],Q)!==0?(ue=[Q],se.push(ue)):ue.push(Q);return se}function*p(ce,ae){let se,ue;for(const Q of ce)ue!==void 0&&ae(ue,Q)?se.push(Q):(se&&(yield se),se=[Q]),ue=Q;se&&(yield se)}function E(ce,ae){for(let se=0;se<=ce.length;se++)ae(se===0?void 0:ce[se-1],se===ce.length?void 0:ce[se])}function v(ce,ae){for(let se=0;se<ce.length;se++)ae(se===0?void 0:ce[se-1],ce[se],se+1===ce.length?void 0:ce[se+1])}function d(ce,ae,se){const ue=[];function Q(we,Ne,Se){if(Ne===0&&Se.length===0)return;const Ie=ue[ue.length-1];Ie&&Ie.start+Ie.deleteCount===we?(Ie.deleteCount+=Ne,Ie.toInsert.push(...Se)):ue.push({start:we,deleteCount:Ne,toInsert:Se})}let re=0,$e=0;for(;;){if(re===ce.length){Q(re,0,ae.slice($e));break}if($e===ae.length){Q(re,ce.length-re,[]);break}const we=ce[re],Ne=ae[$e],Se=se(we,Ne);Se===0?(re+=1,$e+=1):Se<0?(Q(re,1,[]),re+=1):Se>0&&(Q(re,0,[Ne]),$e+=1)}return ue}function h(ce,ae,se){const ue=d(ce,ae,se),Q=[],re=[];for(const $e of ue)Q.push(...ce.slice($e.start,$e.start+$e.deleteCount)),re.push(...$e.toInsert);return{removed:Q,added:re}}function c(ce,ae,se){if(se===0)return[];const ue=ce.slice(0,se).sort(ae);return n(ce,ae,ue,se,ce.length),ue}function i(ce,ae,se,ue,Q){return se===0?Promise.resolve([]):new Promise((re,$e)=>{(async()=>{const we=ce.length,Ne=ce.slice(0,se).sort(ae);for(let Se=se,Ie=Math.min(se+ue,we);Se<we;Se=Ie,Ie=Math.min(Ie+ue,we)){if(Se>se&&await new Promise(Ae=>setTimeout(Ae)),Q&&Q.isCancellationRequested)throw new l.$5;n(ce,ae,Ne,Se,Ie)}return Ne})().then(re,$e)})}function n(ce,ae,se,ue,Q){for(const re=se.length;ue<Q;ue++){const $e=ce[ue];if(ae($e,se[re-1])<0){se.pop();const we=(0,L.$kb)(se,Ne=>ae($e,Ne)<0);se.splice(we,0,$e)}}}function a(ce){return ce.filter(ae=>!!ae)}function r(ce){let ae=0;for(let se=0;se<ce.length;se++)ce[se]&&(ce[ae]=ce[se],ae+=1);ce.length=ae}function t(ce,ae,se){ce.splice(se,0,ce.splice(ae,1)[0])}function f(ce){return!Array.isArray(ce)||ce.length===0}function o(ce){return Array.isArray(ce)&&ce.length>0}function s(ce,ae=se=>se){const se=new Set;return ce.filter(ue=>{const Q=ae(ue);return se.has(Q)?!1:(se.add(Q),!0)})}function u(ce){const ae=new Set;return se=>{const ue=ce(se);return ae.has(ue)?!1:(ae.add(ue),!0)}}function g(ce,ae){return ce.length>0?ce[0]:ae}function b(ce,ae){return ce.length>0?ce[ce.length-1]:ae}function S(ce,ae,se=(ue,Q)=>ue===Q){let ue=0;for(let Q=0,re=Math.min(ce.length,ae.length);Q<re&&se(ce[Q],ae[Q]);Q++)ue++;return ue}function m(ce,ae){let se=typeof ae=="number"?ce:0;typeof ae=="number"?se=ce:(se=0,ae=ce);const ue=[];if(se<=ae)for(let Q=se;Q<ae;Q++)ue.push(Q);else for(let Q=se;Q>ae;Q--)ue.push(Q);return ue}function y(ce,ae,se){return ce.reduce((ue,Q)=>(ue[ae(Q)]=se?se(Q):Q,ue),Object.create(null))}function D(ce,ae){return ce.push(ae),()=>C(ce,ae)}function C(ce,ae){const se=ce.indexOf(ae);if(se>-1)return ce.splice(se,1),ae}function O(ce,ae,se){const ue=ce.slice(0,ae),Q=ce.slice(ae);return ue.concat(se,Q)}function z(ce,ae){let se;if(typeof ae=="number"){let ue=ae;se=()=>{const Q=Math.sin(ue++)*179426549;return Q-Math.floor(Q)}}else se=Math.random;for(let ue=ce.length-1;ue>0;ue-=1){const Q=Math.floor(se()*(ue+1)),re=ce[ue];ce[ue]=ce[Q],ce[Q]=re}}function T(ce,ae){const se=ce.indexOf(ae);se>-1&&(ce.splice(se,1),ce.unshift(ae))}function F(ce,ae){const se=ce.indexOf(ae);se>-1&&(ce.splice(se,1),ce.push(ae))}function N(ce,ae){for(const se of ae)ce.push(se)}function j(ce,ae){return Array.isArray(ce)?ce.map(ae):ae(ce)}function B(ce){return Array.isArray(ce)?ce:[ce]}function X(ce){return ce[Math.floor(Math.random()*ce.length)]}function ie(ce,ae,se){const ue=K(ce,ae),Q=ce.length,re=se.length;ce.length=Q+re;for(let $e=Q-1;$e>=ue;$e--)ce[$e+re]=ce[$e];for(let $e=0;$e<re;$e++)ce[$e+ue]=se[$e]}function H(ce,ae,se,ue){const Q=K(ce,ae);let re=ce.splice(Q,se);return re===void 0&&(re=[]),ie(ce,Q,ue),re}function K(ce,ae){return ae<0?Math.max(ae+ce.length,0):Math.min(ae,ce.length)}var x;(function(ce){function ae(re){return re<0}ce.isLessThan=ae;function se(re){return re<=0}ce.isLessThanOrEqual=se;function ue(re){return re>0}ce.isGreaterThan=ue;function Q(re){return re===0}ce.isNeitherLessOrGreaterThan=Q,ce.greaterThan=1,ce.lessThan=-1,ce.neitherLessOrGreaterThan=0})(x||(e.CompareResult=x={}));function _(ce,ae){return(se,ue)=>ae(ce(se),ce(ue))}function ge(...ce){return(ae,se)=>{for(const ue of ce){const Q=ue(ae,se);if(!x.isNeitherLessOrGreaterThan(Q))return Q}return x.neitherLessOrGreaterThan}}const oe=(ce,ae)=>ce-ae;e.$8b=oe;const Pe=(ce,ae)=>(0,e.$8b)(ce?1:0,ae?1:0);e.$9b=Pe;function me(ce){return(ae,se)=>-ce(ae,se)}class U{constructor(ae){this.g=ae,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let se=this.c;for(;se<this.g.length&&ae(this.g[se]);)se++;const ue=se===this.c?null:this.g.slice(this.c,se);return this.c=se,ue}takeFromEndWhile(ae){let se=this.d;for(;se>=0&&ae(this.g[se]);)se--;const ue=se===this.d?null:this.g.slice(se+1,this.d+1);return this.d=se,ue}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ae=this.g[this.c];return this.c++,ae}removeLast(){const ae=this.g[this.d];return this.d--,ae}takeCount(ae){const se=this.g.slice(this.c,this.c+ae);return this.c+=ae,se}}e.$$b=U;class Y{static{this.empty=new Y(ae=>{})}constructor(ae){this.iterate=ae}forEach(ae){this.iterate(se=>(ae(se),!0))}toArray(){const ae=[];return this.iterate(se=>(ae.push(se),!0)),ae}filter(ae){return new Y(se=>this.iterate(ue=>ae(ue)?se(ue):!0))}map(ae){return new Y(se=>this.iterate(ue=>se(ae(ue))))}some(ae){let se=!1;return this.iterate(ue=>(se=ae(ue),!se)),se}findFirst(ae){let se;return this.iterate(ue=>ae(ue)?(se=ue,!1):!0),se}findLast(ae){let se;return this.iterate(ue=>(ae(ue)&&(se=ue),!0)),se}findLastMaxBy(ae){let se,ue=!0;return this.iterate(Q=>((ue||x.isGreaterThan(ae(Q,se)))&&(ue=!1,se=Q),!0)),se}}e.$_b=Y;class pe{constructor(ae){this.c=ae}static createSortPermutation(ae,se){const ue=Array.from(ae.keys()).sort((Q,re)=>se(ae[Q],ae[re]));return new pe(ue)}apply(ae){return ae.map((se,ue)=>ae[this.c[ue]])}inverse(){const ae=this.c.slice();for(let se=0;se<this.c.length;se++)ae[this.c[se]]=se;return new pe(ae)}}e.$ac=pe}),define(ke[62],De([1,0,13]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.$ed=M,e.$fd=A,e.$gd=R,e.$hd=w,e.$id=$;function L(k,I){if(!k)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function M(k,I="Unreachable"){throw new Error(I)}function A(k,I="unexpected state"){if(!k)throw new l.$cb(`Assertion Failed: ${I}`)}function R(k){k||(0,l.$1)(new l.$cb("Soft Assertion Failed"))}function w(k){if(!k()){debugger;k(),(0,l.$1)(new l.$cb("Assertion Failed"))}}function $(k,I){let P=0;for(;P<k.length-1;){const p=k[P],E=k[P+1];if(!I(p,E))return!1;P++}return!0}}),define(ke[165],De([1,0,19]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=M,e.$8c=A,e.$9c=R,e.$0c=w,e.$$c=$,e.$_c=k;const L=(E,v)=>E===v;e.$6c=L;function M(E=e.$6c){return(v,d)=>l.$ub(v,d,E)}function A(){return(E,v)=>JSON.stringify(E)===JSON.stringify(v)}function R(){return(E,v)=>E.equals(v)}function w(E,v,d){return!E||!v?E===v:d(E,v)}function $(E,v){if(E===v)return!0;if(Array.isArray(E)&&Array.isArray(v)){if(E.length!==v.length)return!1;for(let d=0;d<E.length;d++)if(!$(E[d],v[d]))return!1;return!0}if(E&&typeof E=="object"&&v&&typeof v=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(v)===Object.prototype){const d=E,h=v,c=Object.keys(d),i=Object.keys(h),n=new Set(i);if(c.length!==i.length)return!1;for(const a of c)if(!n.has(a)||!$(d[a],h[a]))return!1;return!0}return!1}function k(E){return JSON.stringify(p(E))}let I=0;const P=new WeakMap;function p(E){if(Array.isArray(E))return E.map(p);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const v=E,d=Object.create(null);for(const h of Object.keys(v).sort())d[h]=p(v[h]);return d}else{let v=P.get(E);return v===void 0&&(v=I++,P.set(E,v)),v+"----2b76a038c20c4bcc"}return E}}),define(ke[75],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=l;function l(L,M){const A=this;let R=!1,w;return function(){if(R)return w;if(R=!0,M)try{w=L.apply(A,arguments)}finally{M()}else w=L.apply(A,arguments);return w}}}),define(ke[125],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=e.$WO=void 0;class l{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$WO=l,e.$XO=new l("id#")}),define(ke[39],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(L){function M(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=M;const A=Object.freeze([]);function R(){return A}L.empty=R;function*w(t){yield t}L.single=w;function $(t){return M(t)?t:w(t)}L.wrap=$;function k(t){return t||A}L.from=k;function*I(t){for(let f=t.length-1;f>=0;f--)yield t[f]}L.reverse=I;function P(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=P;function p(t){return t[Symbol.iterator]().next().value}L.first=p;function E(t,f){for(const o of t)if(f(o))return!0;return!1}L.some=E;function v(t,f){for(const o of t)if(f(o))return o}L.find=v;function*d(t,f){for(const o of t)f(o)&&(yield o)}L.filter=d;function*h(t,f){let o=0;for(const s of t)yield f(s,o++)}L.map=h;function*c(...t){for(const f of t)yield*f}L.concat=c;function i(t,f,o){let s=o;for(const u of t)s=f(s,u);return s}L.reduce=i;function*n(t,f,o=t.length){for(f<0&&(f+=t.length),o<0?o+=t.length:o>t.length&&(o=t.length);f<o;f++)yield t[f]}L.slice=n;function a(t,f=Number.POSITIVE_INFINITY){const o=[];if(f===0)return[o,t];const s=t[Symbol.iterator]();for(let u=0;u<f;u++){const g=s.next();if(g.done)return[o,L.empty()];o.push(g.value)}return[o,{[Symbol.iterator](){return s}}]}L.consume=a;async function r(t){const f=[];for await(const o of t)f.push(o);return Promise.resolve(f)}L.asyncToArray=r})(l||(e.Iterable=l={}))}),define(ke[166],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Ln=R,e.$Mn=P,e.$Nn=p,e.$On=E,e.$Pn=v,e.$Qn=d,e.$Rn=h,e.$Sn=c,e.$Tn=i,e.$Un=n,e.$Vn=a,e.$Wn=r;var l;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(l||(e.ScanError=l={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,f=!1){let o=0;const s=t.length;let u="",g=0,b=16,S=0;function m(F){let N=0,j=0;for(;N<F;){const B=t.charCodeAt(o);if(B>=48&&B<=57)j=j*16+B-48;else if(B>=65&&B<=70)j=j*16+B-65+10;else if(B>=97&&B<=102)j=j*16+B-97+10;else break;o++,N++}return N<F&&(j=-1),j}function y(F){o=F,u="",g=0,b=16,S=0}function D(){const F=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&k(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&k(t.charCodeAt(o)))for(o++;o<t.length&&k(t.charCodeAt(o));)o++;else return S=3,t.substring(F,o);let N=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&k(t.charCodeAt(o))){for(o++;o<t.length&&k(t.charCodeAt(o));)o++;N=o}else S=3;return t.substring(F,N)}function C(){let F="",N=o;for(;;){if(o>=s){F+=t.substring(N,o),S=2;break}const j=t.charCodeAt(o);if(j===34){F+=t.substring(N,o),o++;break}if(j===92){if(F+=t.substring(N,o),o++,o>=s){S=2;break}switch(t.charCodeAt(o++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const X=m(4);X>=0?F+=String.fromCharCode(X):S=4;break}default:S=5}N=o;continue}if(j>=0&&j<=31)if($(j)){F+=t.substring(N,o),S=2;break}else S=6;o++}return F}function O(){if(u="",S=0,g=o,o>=s)return g=s,b=17;let F=t.charCodeAt(o);if(w(F)){do o++,u+=String.fromCharCode(F),F=t.charCodeAt(o);while(w(F));return b=15}if($(F))return o++,u+=String.fromCharCode(F),F===13&&t.charCodeAt(o)===10&&(o++,u+=`
`),b=14;switch(F){case 123:return o++,b=1;case 125:return o++,b=2;case 91:return o++,b=3;case 93:return o++,b=4;case 58:return o++,b=6;case 44:return o++,b=5;case 34:return o++,u=C(),b=10;case 47:{const N=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<s&&!$(t.charCodeAt(o));)o++;return u=t.substring(N,o),b=12}if(t.charCodeAt(o+1)===42){o+=2;const j=s-1;let B=!1;for(;o<j;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,B=!0;break}o++}return B||(o++,S=1),u=t.substring(N,o),b=13}return u+=String.fromCharCode(F),o++,b=16}case 45:if(u+=String.fromCharCode(F),o++,o===s||!k(t.charCodeAt(o)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=D(),b=11;default:for(;o<s&&z(F);)o++,F=t.charCodeAt(o);if(g!==o){switch(u=t.substring(g,o),u){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return u+=String.fromCharCode(F),o++,b=16}}function z(F){if(w(F)||$(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let F;do F=O();while(F>=12&&F<=15);return F}return{setPosition:y,getPosition:()=>o,scan:f?T:O,getToken:()=>b,getTokenValue:()=>u,getTokenOffset:()=>g,getTokenLength:()=>o-g,getTokenError:()=>S}}function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function P(t,f){const o=[],s=new Object;let u;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function S(m,y,D,C){g.value=m,g.offset=y,g.length=D,g.type=C,g.colonOffset=void 0,u=g}try{n(t,{onObjectBegin:(m,y)=>{if(f<=m)throw s;u=void 0,b=f>m,o.push("")},onObjectProperty:(m,y,D)=>{if(f<y||(S(m,y,D,"property"),o[o.length-1]=m,f<=y+D))throw s},onObjectEnd:(m,y)=>{if(f<=m)throw s;u=void 0,o.pop()},onArrayBegin:(m,y)=>{if(f<=m)throw s;u=void 0,o.push(0)},onArrayEnd:(m,y)=>{if(f<=m)throw s;u=void 0,o.pop()},onLiteralValue:(m,y,D)=>{if(f<y||(S(m,y,D,r(m)),f<=y+D))throw s},onSeparator:(m,y,D)=>{if(f<=y)throw s;if(m===":"&&u&&u.type==="property")u.colonOffset=y,b=!1,u=void 0;else if(m===","){const C=o[o.length-1];typeof C=="number"?o[o.length-1]=C+1:(b=!0,o[o.length-1]=""),u=void 0}}})}catch(m){if(m!==s)throw m}return{path:o,previousNode:u,isAtPropertyKey:b,matches:m=>{let y=0;for(let D=0;y<m.length&&D<o.length;D++)if(m[y]===o[D]||m[y]==="*")y++;else if(m[y]!=="**")return!1;return y===m.length}}}function p(t,f=[],o=A.DEFAULT){let s=null,u=[];const g=[];function b(m){Array.isArray(u)?u.push(m):s!==null&&(u[s]=m)}return n(t,{onObjectBegin:()=>{const m={};b(m),g.push(u),u=m,s=null},onObjectProperty:m=>{s=m},onObjectEnd:()=>{u=g.pop()},onArrayBegin:()=>{const m=[];b(m),g.push(u),u=m,s=null},onArrayEnd:()=>{u=g.pop()},onLiteralValue:b,onError:(m,y,D)=>{f.push({error:m,offset:y,length:D})}},o),u[0]}function E(t,f=[],o=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(m){s.type==="property"&&(s.length=m-s.offset,s=s.parent)}function g(m){return s.children.push(m),m}n(t,{onObjectBegin:m=>{s=g({type:"object",offset:m,length:-1,parent:s,children:[]})},onObjectProperty:(m,y,D)=>{s=g({type:"property",offset:y,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:m,offset:y,length:D,parent:s})},onObjectEnd:(m,y)=>{s.length=m+y-s.offset,s=s.parent,u(m+y)},onArrayBegin:(m,y)=>{s=g({type:"array",offset:m,length:-1,parent:s,children:[]})},onArrayEnd:(m,y)=>{s.length=m+y-s.offset,s=s.parent,u(m+y)},onLiteralValue:(m,y,D)=>{g({type:r(m),offset:y,length:D,parent:s,value:m}),u(y+D)},onSeparator:(m,y,D)=>{s.type==="property"&&(m===":"?s.colonOffset=y:m===","&&u(y))},onError:(m,y,D)=>{f.push({error:m,offset:y,length:D})}},o);const S=s.children[0];return S&&delete S.parent,S}function v(t,f){if(!t)return;let o=t;for(const s of f)if(typeof s=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let u=!1;for(const g of o.children)if(Array.isArray(g.children)&&g.children[0].value===s){o=g.children[1],u=!0;break}if(!u)return}else{const u=s;if(o.type!=="array"||u<0||!Array.isArray(o.children)||u>=o.children.length)return;o=o.children[u]}return o}function d(t){if(!t.parent||!t.parent.children)return[];const f=d(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;f.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&f.push(o)}return f}function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const f=Object.create(null);for(const o of t.children){const s=o.children[1];s&&(f[o.children[0].value]=h(s))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,f,o=!1){return f>=t.offset&&f<t.offset+t.length||o&&f===t.offset+t.length}function i(t,f,o=!1){if(c(t,f,o)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=f;u++){const g=i(s[u],f,o);if(g)return g}return t}}function n(t,f,o=A.DEFAULT){const s=R(t,!1);function u(ge){return ge?()=>ge(s.getTokenOffset(),s.getTokenLength()):()=>!0}function g(ge){return ge?oe=>ge(oe,s.getTokenOffset(),s.getTokenLength()):()=>!0}const b=u(f.onObjectBegin),S=g(f.onObjectProperty),m=u(f.onObjectEnd),y=u(f.onArrayBegin),D=u(f.onArrayEnd),C=g(f.onLiteralValue),O=g(f.onSeparator),z=u(f.onComment),T=g(f.onError),F=o&&o.disallowComments,N=o&&o.allowTrailingComma;function j(){for(;;){const ge=s.scan();switch(s.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:F||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(ge){case 12:case 13:F?B(10):z();break;case 16:B(1);break;case 15:case 14:break;default:return ge}}}function B(ge,oe=[],Pe=[]){if(T(ge),oe.length+Pe.length>0){let me=s.getToken();for(;me!==17;){if(oe.indexOf(me)!==-1){j();break}else if(Pe.indexOf(me)!==-1)break;me=j()}}}function X(ge){const oe=s.getTokenValue();return ge?C(oe):S(oe),j(),!0}function ie(){switch(s.getToken()){case 11:{let ge=0;try{ge=JSON.parse(s.getTokenValue()),typeof ge!="number"&&(B(2),ge=0)}catch{B(2)}C(ge);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return j(),!0}function H(){return s.getToken()!==10?(B(3,[],[2,5]),!1):(X(!1),s.getToken()===6?(O(":"),j(),_()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function K(){b(),j();let ge=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ge||B(4,[],[]),O(","),j(),s.getToken()===2&&N)break}else ge&&B(6,[],[]);H()||B(4,[],[2,5]),ge=!0}return m(),s.getToken()!==2?B(7,[2],[]):j(),!0}function x(){y(),j();let ge=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ge||B(4,[],[]),O(","),j(),s.getToken()===4&&N)break}else ge&&B(6,[],[]);_()||B(4,[],[4,5]),ge=!0}return D(),s.getToken()!==4?B(8,[4],[]):j(),!0}function _(){switch(s.getToken()){case 3:return x();case 1:return K();case 10:return X(!0);default:return ie()}}return j(),s.getToken()===17?o.allowEmptyContent?!0:(B(4,[],[]),!1):_()?(s.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function a(t,f){const o=R(t),s=[];let u,g=0,b;do switch(b=o.getPosition(),u=o.scan(),u){case 12:case 13:case 17:g!==b&&s.push(t.substring(g,b)),f!==void 0&&s.push(o.getTokenValue().replace(/[^\r\n]/g,f)),g=o.getPosition();break}while(u!==17);return s.join("")}function r(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[46],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class l{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=l}),define(ke[76],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class l{static{this.Undefined=new l(void 0)}constructor(A){this.element=A,this.next=l.Undefined,this.prev=l.Undefined}}class L{constructor(){this.a=l.Undefined,this.b=l.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===l.Undefined}clear(){let A=this.a;for(;A!==l.Undefined;){const R=A.next;A.prev=l.Undefined,A.next=l.Undefined,A=R}this.a=l.Undefined,this.b=l.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const w=new l(A);if(this.a===l.Undefined)this.a=w,this.b=w;else if(R){const k=this.b;this.b=w,w.prev=k,k.next=w}else{const k=this.a;this.a=w,w.next=k,k.prev=w}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(w))}}shift(){if(this.a!==l.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==l.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==l.Undefined&&A.next!==l.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===l.Undefined&&A.next===l.Undefined?(this.a=l.Undefined,this.b=l.Undefined):A.next===l.Undefined?(this.b=this.b.prev,this.b.next=l.Undefined):A.prev===l.Undefined&&(this.a=this.a.next,this.a.prev=l.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==l.Undefined;)yield A.element,A=A.next}}e.$5c=L}),define(ke[27],De([1,0]),function(le,e){"use strict";var l,L,M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=R,e.$zc=w,e.$Ic=a;function A(r,t,f){let o=r.get(t);return o===void 0&&(o=f,r.set(t,o)),o}function R(r){const t=[];return r.forEach((f,o)=>{t.push(`${o} => ${f}`)}),`Map(${r.size}) {${t.join(", ")}}`}function w(r){const t=[];return r.forEach(f=>{t.push(f)}),`Set(${r.size}) {${t.join(", ")}}`}class ${constructor(t,f){this.uri=t,this.value=f}}function k(r){return Array.isArray(r)}class I{static{this.c=t=>t.toString()}constructor(t,f){if(this[l]="ResourceMap",t instanceof I)this.d=new Map(t.d),this.e=f??I.c;else if(k(t)){this.d=new Map,this.e=f??I.c;for(const[o,s]of t)this.set(o,s)}else this.d=new Map,this.e=t??I.c}set(t,f){return this.d.set(this.e(t),new $(t,f)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,f){typeof f<"u"&&(t=t.bind(f));for(const[o,s]of this.d)t(s.value,s.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(l=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=I;class P{constructor(t,f){this[L]="ResourceSet",!t||typeof t=="function"?this.c=new I(t):(this.c=new I(f),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,f){this.c.forEach((o,s)=>t.call(f,s,s,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=P;var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class E{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,f=0){const o=this.c.get(t);if(o)return f!==0&&this.m(o,f),o.value}set(t,f,o=0){let s=this.c.get(t);if(s)s.value=f,o!==0&&this.m(s,o);else{switch(s={key:t,value:f,next:void 0,previous:void 0},o){case 0:this.k(s);break;case 1:this.j(s);break;case 2:this.k(s);break;default:this.k(s);break}this.c.set(t,s),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const f=this.c.get(t);if(f)return this.c.delete(t),this.l(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,f){const o=this.g;let s=this.d;for(;s;){if(f?t.bind(f)(s.value,s.key,this):t(s.value,s.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,f=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==f)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:o.key,done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return s}values(){const t=this,f=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==f)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:o.value,done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return s}entries(){const t=this,f=this.g;let o=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==f)throw new Error("LinkedMap got modified during iteration.");if(o){const u={value:[o.key,o.value],done:!1};return o=o.next,u}else return{value:void 0,done:!0}}};return s}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let f=this.d,o=this.size;for(;f&&o>t;)this.c.delete(f.key),f=f.next,o--;this.d=f,this.f=o,f&&(f.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let f=this.e,o=this.size;for(;f&&o>t;)this.c.delete(f.key),f=f.previous,o--;this.e=f,this.f=o,f&&(f.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const f=t.next,o=t.previous;if(!f||!o)throw new Error("Invalid list");f.previous=o,o.next=f}t.next=void 0,t.previous=void 0,this.g++}m(t,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(t===this.d)return;const o=t.next,s=t.previous;t===this.e?(s.next=void 0,this.e=s):(o.previous=s,s.next=o),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(f===2){if(t===this.e)return;const o=t.next,s=t.previous;t===this.d?(o.previous=void 0,this.d=o):(o.previous=s,s.next=o),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((f,o)=>{t.push([o,f])}),t}fromJSON(t){this.clear();for(const[f,o]of t)this.set(f,o)}}e.$Cc=E;class v extends E{constructor(t,f=1){super(),this.n=t,this.o=Math.min(Math.max(0,f),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,f=2){return super.get(t,f)}peek(t){return super.get(t,0)}set(t,f){return super.set(t,f,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class d extends v{constructor(t,f=1){super(t,f)}q(t){this.h(t)}set(t,f){return super.set(t,f),this.p(),this}}e.$Dc=d;class h extends v{constructor(t,f=1){super(t,f)}q(t){this.i(t)}set(t,f){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,f),this}}e.$Ec=h;class c{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let f=this.c.get(t)||0;return f===0?!1:(f--,f===0?this.c.delete(t):this.c.set(t,f),!0)}has(t){return this.c.has(t)}}e.$Fc=c;class i{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[f,o]of t)this.set(f,o)}clear(){this.c.clear(),this.d.clear()}set(t,f){this.c.set(t,f),this.d.set(f,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const f=this.c.get(t);return f===void 0?!1:(this.c.delete(t),this.d.delete(f),!0)}forEach(t,f){this.c.forEach((o,s)=>{t.call(f,o,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=i;class n{constructor(){this.c=new Map}add(t,f){let o=this.c.get(t);o||(o=new Set,this.c.set(t,o)),o.add(f)}delete(t,f){const o=this.c.get(t);o&&(o.delete(f),o.size===0&&this.c.delete(t))}forEach(t,f){const o=this.c.get(t);o&&o.forEach(f)}get(t){const f=this.c.get(t);return f||new Set}}e.$Hc=n;function a(r,t){if(r===t)return!0;if(r.size!==t.size)return!1;for(const[f,o]of r)if(!t.has(f)||t.get(f)!==o)return!1;for(const[f]of t)if(!r.has(f))return!1;return!0}}),define(ke[3],De([1,0,19,74,27,75,39]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=I,e.$Lc=P,e.$Mc=p,e.$Nc=d,e.$Oc=h,e.$Pc=c,e.$Qc=i,e.$Rc=n,e.$Sc=a,e.$3c=m;const w=!1;let $=null;class k{constructor(){this.b=new Map}static{this.a=0}c(C){let O=this.b.get(C);return O||(O={parent:null,source:null,isSingleton:!1,value:C,idx:k.a++},this.b.set(C,O)),O}trackDisposable(C){const O=this.c(C);O.source||(O.source=new Error().stack)}setParent(C,O){const z=this.c(C);z.parent=O}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,O){const z=O.get(C);if(z)return z;const T=C.parent?this.f(this.c(C.parent),O):C;return O.set(C,T),T}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,C).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(C=10,O){let z;if(O)z=O;else{const B=new Map,X=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,B).isSingleton);if(X.length===0)return;const ie=new Set(X.map(H=>H.value));if(z=X.filter(H=>!(H.parent&&ie.has(H.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function T(B){function X(H,K){for(;H.length>0&&K.some(x=>typeof x=="string"?x===H[0]:H[0].match(x));)H.shift()}const ie=B.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return X(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const F=new M.$Hc;for(const B of z){const X=T(B);for(let ie=0;ie<=X.length;ie++)F.add(X.slice(0,ie).join(`
`),B)}z.sort((0,l.$6b)(B=>B.idx,l.$8b));let N="",j=0;for(const B of z.slice(0,C)){j++;const X=T(B),ie=[];for(let H=0;H<X.length;H++){let K=X[H];K=`(shared with ${F.get(X.slice(0,H+1).join(`
`)).size}/${z.length} leaks) at ${K}`;const _=F.get(X.slice(0,H).join(`
`)),ge=(0,L.$K)([..._].map(oe=>T(oe)[H]),oe=>oe);delete ge[X[H]];for(const[oe,Pe]of Object.entries(ge))ie.unshift(`    - stacktraces of ${Pe.length} other leaks continue with ${oe}`);ie.unshift(K)}N+=`


==================== Leaking disposable ${j}/${z.length}: ${B.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return z.length>C&&(N+=`


... and ${z.length-C} more leaking disposables

`),{leaks:z,details:N}}}e.$Jc=k;function I(D){$=D}if(w){const D="__is_disposable_tracked__";I(new class{trackDisposable(C){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[D]||console.log(O)},3e3)}setParent(C,O){if(C&&C!==t.None)try{C[D]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[D]=!0}catch{}}markAsSingleton(C){}})}function P(D){return $?.trackDisposable(D),D}function p(D){$?.markAsDisposed(D)}function E(D,C){$?.setParent(D,C)}function v(D,C){if($)for(const O of D)$.setParent(O,C)}function d(D){return $?.markAsSingleton(D),D}function h(D){return typeof D=="object"&&D!==null&&typeof D.dispose=="function"&&D.dispose.length===0}function c(D){if(R.Iterable.is(D)){const C=[];for(const O of D)if(O)try{O.dispose()}catch(z){C.push(z)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}function i(D){for(const C of D)h(C)&&C.dispose();return[]}function n(...D){const C=a(()=>c(D));return v(D,C),C}function a(D){const C=P({dispose:(0,A.$db)(()=>{p(C),D()})});return C}class r{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return E(C,this),this.g?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),E(C,null))}}e.$Tc=r;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new r,P(this),E(this.q,this)}dispose(){p(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class f{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&E(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&E(C,null),C}}e.$Vc=f;class o{constructor(C){this.a=new f,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=o;class s{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(C){let O=C;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,p(this))},this}}e.$Yc=u;class g{constructor(){this.a=new Map}acquire(C,...O){let z=this.a.get(C);z||(z={counter:0,object:this.b(C,...O)},this.a.set(C,z));const{object:T}=z,F=(0,A.$db)(()=>{--z.counter===0&&(this.c(C,z.object),this.a.delete(C))});return z.counter++,{object:T,dispose:F}}}e.$Zc=g;class b{constructor(C){this.a=C}async acquire(C,...O){const z=this.a.acquire(C,...O);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(T){throw z.dispose(),T}}}e.$1c=b;class S{constructor(C){this.object=C}dispose(){}}e.$2c=S;function m(D){const C=new r;try{D(C)}finally{C.dispose()}}class y{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,O,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(C)?.dispose(),this.a.set(C,O)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=y}),function(le,e){typeof define=="function"&&define.amd?define(ke[167],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(ae,se){for(var ue=0;ue<se.length;ue++){var Q=se[ue];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(ae,Q.key,Q)}}function l(ae,se,ue){return se&&e(ae.prototype,se),ue&&e(ae,ue),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function L(ae,se){if(ae){if(typeof ae=="string")return M(ae,se);var ue=Object.prototype.toString.call(ae).slice(8,-1);if(ue==="Object"&&ae.constructor&&(ue=ae.constructor.name),ue==="Map"||ue==="Set")return Array.from(ae);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return M(ae,se)}}function M(ae,se){(se==null||se>ae.length)&&(se=ae.length);for(var ue=0,Q=new Array(se);ue<se;ue++)Q[ue]=ae[ue];return Q}function A(ae,se){var ue=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(ue)return(ue=ue.call(ae)).next.bind(ue);if(Array.isArray(ae)||(ue=L(ae))||se&&ae&&typeof ae.length=="number"){ue&&(ae=ue);var Q=0;return function(){return Q>=ae.length?{done:!0}:{done:!1,value:ae[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=R();function w(ae){le.defaults=ae}var $=/[&<>"']/,k=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(se){return p[se]};function v(ae,se){if(se){if($.test(ae))return ae.replace(k,E)}else if(I.test(ae))return ae.replace(P,E);return ae}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(ae){return ae.replace(d,function(se,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var c=/(^|[^\[])\^/g;function i(ae,se){ae=typeof ae=="string"?ae:ae.source,se=se||"";var ue={replace:function(re,$e){return $e=$e.source||$e,$e=$e.replace(c,"$1"),ae=ae.replace(re,$e),ue},getRegex:function(){return new RegExp(ae,se)}};return ue}var n=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function r(ae,se,ue){if(ae){var Q;try{Q=decodeURIComponent(h(ue)).replace(n,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}se&&!a.test(ue)&&(ue=u(se,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var t={},f=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(ae,se){t[" "+ae]||(f.test(ae)?t[" "+ae]=ae+"/":t[" "+ae]=m(ae,"/",!0)),ae=t[" "+ae];var ue=ae.indexOf(":")===-1;return se.substring(0,2)==="//"?ue?se:ae.replace(o,"$1")+se:se.charAt(0)==="/"?ue?se:ae.replace(s,"$1")+se:ae+se}var g={exec:function(){}};function b(ae){for(var se=1,ue,Q;se<arguments.length;se++){ue=arguments[se];for(Q in ue)Object.prototype.hasOwnProperty.call(ue,Q)&&(ae[Q]=ue[Q])}return ae}function S(ae,se){var ue=ae.replace(/\|/g,function($e,we,Ne){for(var Se=!1,Ie=we;--Ie>=0&&Ne[Ie]==="\\";)Se=!Se;return Se?"|":" |"}),Q=ue.split(/ \|/),re=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>se)Q.splice(se);else for(;Q.length<se;)Q.push("");for(;re<Q.length;re++)Q[re]=Q[re].trim().replace(/\\\|/g,"|");return Q}function m(ae,se,ue){var Q=ae.length;if(Q===0)return"";for(var re=0;re<Q;){var $e=ae.charAt(Q-re-1);if($e===se&&!ue)re++;else if($e!==se&&ue)re++;else break}return ae.slice(0,Q-re)}function y(ae,se){if(ae.indexOf(se[1])===-1)return-1;for(var ue=ae.length,Q=0,re=0;re<ue;re++)if(ae[re]==="\\")re++;else if(ae[re]===se[0])Q++;else if(ae[re]===se[1]&&(Q--,Q<0))return re;return-1}function D(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(ae,se){if(se<1)return"";for(var ue="";se>1;)se&1&&(ue+=ae),se>>=1,ae+=ae;return ue+ae}function O(ae,se,ue,Q){var re=se.href,$e=se.title?v(se.title):null,we=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){Q.state.inLink=!0;var Ne={type:"link",raw:ue,href:re,title:$e,text:we,tokens:Q.inlineTokens(we)};return Q.state.inLink=!1,Ne}return{type:"image",raw:ue,href:re,title:$e,text:v(we)}}function z(ae,se){var ue=ae.match(/^(\s+)(?:```)/);if(ue===null)return se;var Q=ue[1];return se.split(`
`).map(function(re){var $e=re.match(/^\s+/);if($e===null)return re;var we=$e[0];return we.length>=Q.length?re.slice(Q.length):re}).join(`
`)}var T=function(){function ae(ue){this.options=ue||le.defaults}var se=ae.prototype;return se.space=function(Q){var re=this.rules.block.newline.exec(Q);if(re&&re[0].length>0)return{type:"space",raw:re[0]}},se.code=function(Q){var re=this.rules.block.code.exec(Q);if(re){var $e=re[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:re[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:m($e,`
`)}}},se.fences=function(Q){var re=this.rules.block.fences.exec(Q);if(re){var $e=re[0],we=z($e,re[3]||"");return{type:"code",raw:$e,lang:re[2]?re[2].trim():re[2],text:we}}},se.heading=function(Q){var re=this.rules.block.heading.exec(Q);if(re){var $e=re[2].trim();if(/#$/.test($e)){var we=m($e,"#");(this.options.pedantic||!we||/ $/.test(we))&&($e=we.trim())}return{type:"heading",raw:re[0],depth:re[1].length,text:$e,tokens:this.lexer.inline($e)}}},se.hr=function(Q){var re=this.rules.block.hr.exec(Q);if(re)return{type:"hr",raw:re[0]}},se.blockquote=function(Q){var re=this.rules.block.blockquote.exec(Q);if(re){var $e=re[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:re[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},se.list=function(Q){var re=this.rules.block.list.exec(Q);if(re){var $e,we,Ne,Se,Ie,Ae,je,V,W,J,Z,he,be=re[1].trim(),Fe=be.length>1,Ve={type:"list",raw:"",ordered:Fe,start:Fe?+be.slice(0,-1):"",loose:!1,items:[]};be=Fe?"\\d{1,9}\\"+be.slice(-1):"\\"+be,this.options.pedantic&&(be=Fe?be:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+be+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(he=!1,!(!(re=Qe.exec(Q))||this.rules.block.hr.test(Q)));){if($e=re[0],Q=Q.substring($e.length),V=re[2].split(`
`,1)[0],W=Q.split(`
`,1)[0],this.options.pedantic?(Se=2,Z=V.trimLeft()):(Se=re[2].search(/[^ ]/),Se=Se>4?1:Se,Z=V.slice(Se),Se+=re[1].length),Ae=!1,!V&&/^ *$/.test(W)&&($e+=W+`
`,Q=Q.substring(W.length+1),he=!0),!he)for(var tt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Se-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,Se-1)+"}#");Q&&(J=Q.split(`
`,1)[0],V=J,this.options.pedantic&&(V=V.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(V)||it.test(V)||tt.test(V)||_e.test(Q)));){if(V.search(/[^ ]/)>=Se||!V.trim())Z+=`
`+V.slice(Se);else if(!Ae)Z+=`
`+V;else break;!Ae&&!V.trim()&&(Ae=!0),$e+=J+`
`,Q=Q.substring(J.length+1)}Ve.loose||(je?Ve.loose=!0:/\n *\n *$/.test($e)&&(je=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(Z),we&&(Ne=we[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:$e,task:!!we,checked:Ne,loose:!1,text:Z}),Ve.raw+=$e}Ve.items[Ve.items.length-1].raw=$e.trimRight(),Ve.items[Ve.items.length-1].text=Z.trimRight(),Ve.raw=Ve.raw.trimRight();var rt=Ve.items.length;for(Ie=0;Ie<rt;Ie++){this.lexer.state.top=!1,Ve.items[Ie].tokens=this.lexer.blockTokens(Ve.items[Ie].text,[]);var at=Ve.items[Ie].tokens.filter(function(ve){return ve.type==="space"}),Re=at.every(function(ve){for(var qe=ve.raw.split(""),te=0,ne=A(qe),Ce;!(Ce=ne()).done;){var Ge=Ce.value;if(Ge===`
`&&(te+=1),te>1)return!0}return!1});!Ve.loose&&at.length&&Re&&(Ve.loose=!0,Ve.items[Ie].loose=!0)}return Ve}},se.html=function(Q){var re=this.rules.block.html.exec(Q);if(re){var $e={type:"html",raw:re[0],pre:!this.options.sanitizer&&(re[1]==="pre"||re[1]==="script"||re[1]==="style"),text:re[0]};if(this.options.sanitize){var we=this.options.sanitizer?this.options.sanitizer(re[0]):v(re[0]);$e.type="paragraph",$e.text=we,$e.tokens=this.lexer.inline(we)}return $e}},se.def=function(Q){var re=this.rules.block.def.exec(Q);if(re){re[3]&&(re[3]=re[3].substring(1,re[3].length-1));var $e=re[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:re[0],href:re[2],title:re[3]}}},se.table=function(Q){var re=this.rules.block.table.exec(Q);if(re){var $e={type:"table",header:S(re[1]).map(function(je){return{text:je}}),align:re[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:re[3]&&re[3].trim()?re[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=re[0];var we=$e.align.length,Ne,Se,Ie,Ae;for(Ne=0;Ne<we;Ne++)/^ *-+: *$/.test($e.align[Ne])?$e.align[Ne]="right":/^ *:-+: *$/.test($e.align[Ne])?$e.align[Ne]="center":/^ *:-+ *$/.test($e.align[Ne])?$e.align[Ne]="left":$e.align[Ne]=null;for(we=$e.rows.length,Ne=0;Ne<we;Ne++)$e.rows[Ne]=S($e.rows[Ne],$e.header.length).map(function(je){return{text:je}});for(we=$e.header.length,Se=0;Se<we;Se++)$e.header[Se].tokens=this.lexer.inline($e.header[Se].text);for(we=$e.rows.length,Se=0;Se<we;Se++)for(Ae=$e.rows[Se],Ie=0;Ie<Ae.length;Ie++)Ae[Ie].tokens=this.lexer.inline(Ae[Ie].text);return $e}}},se.lheading=function(Q){var re=this.rules.block.lheading.exec(Q);if(re)return{type:"heading",raw:re[0],depth:re[2].charAt(0)==="="?1:2,text:re[1],tokens:this.lexer.inline(re[1])}},se.paragraph=function(Q){var re=this.rules.block.paragraph.exec(Q);if(re){var $e=re[1].charAt(re[1].length-1)===`
`?re[1].slice(0,-1):re[1];return{type:"paragraph",raw:re[0],text:$e,tokens:this.lexer.inline($e)}}},se.text=function(Q){var re=this.rules.block.text.exec(Q);if(re)return{type:"text",raw:re[0],text:re[0],tokens:this.lexer.inline(re[0])}},se.escape=function(Q){var re=this.rules.inline.escape.exec(Q);if(re)return{type:"escape",raw:re[0],text:v(re[1])}},se.tag=function(Q){var re=this.rules.inline.tag.exec(Q);if(re)return!this.lexer.state.inLink&&/^<a /i.test(re[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(re[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(re[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(re[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:re[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):v(re[0]):re[0]}},se.link=function(Q){var re=this.rules.inline.link.exec(Q);if(re){var $e=re[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var we=m($e.slice(0,-1),"\\");if(($e.length-we.length)%2===0)return}else{var Ne=y(re[2],"()");if(Ne>-1){var Se=re[0].indexOf("!")===0?5:4,Ie=Se+re[1].length+Ne;re[2]=re[2].substring(0,Ne),re[0]=re[0].substring(0,Ie).trim(),re[3]=""}}var Ae=re[2],je="";if(this.options.pedantic){var V=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);V&&(Ae=V[1],je=V[3])}else je=re[3]?re[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test($e)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),O(re,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},re[0],this.lexer)}},se.reflink=function(Q,re){var $e;if(($e=this.rules.inline.reflink.exec(Q))||($e=this.rules.inline.nolink.exec(Q))){var we=($e[2]||$e[1]).replace(/\s+/g," ");if(we=re[we.toLowerCase()],!we||!we.href){var Ne=$e[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return O($e,we,$e[0],this.lexer)}},se.emStrong=function(Q,re,$e){$e===void 0&&($e="");var we=this.rules.inline.emStrong.lDelim.exec(Q);if(we&&!(we[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=we[1]||we[2]||"";if(!Ne||Ne&&($e===""||this.rules.inline.punctuation.exec($e))){var Se=we[0].length-1,Ie,Ae,je=Se,V=0,W=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,re=re.slice(-1*Q.length+Se);(we=W.exec(re))!=null;)if(Ie=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!Ie){if(Ae=Ie.length,we[3]||we[4]){je+=Ae;continue}else if((we[5]||we[6])&&Se%3&&!((Se+Ae)%3)){V+=Ae;continue}if(je-=Ae,!(je>0)){if(Ae=Math.min(Ae,Ae+je+V),Math.min(Se,Ae)%2){var J=Q.slice(1,Se+we.index+Ae);return{type:"em",raw:Q.slice(0,Se+we.index+Ae+1),text:J,tokens:this.lexer.inlineTokens(J)}}var Z=Q.slice(2,Se+we.index+Ae-1);return{type:"strong",raw:Q.slice(0,Se+we.index+Ae+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},se.codespan=function(Q){var re=this.rules.inline.code.exec(Q);if(re){var $e=re[2].replace(/\n/g," "),we=/[^ ]/.test($e),Ne=/^ /.test($e)&&/ $/.test($e);return we&&Ne&&($e=$e.substring(1,$e.length-1)),$e=v($e,!0),{type:"codespan",raw:re[0],text:$e}}},se.br=function(Q){var re=this.rules.inline.br.exec(Q);if(re)return{type:"br",raw:re[0]}},se.del=function(Q){var re=this.rules.inline.del.exec(Q);if(re)return{type:"del",raw:re[0],text:re[2],tokens:this.lexer.inlineTokens(re[2])}},se.autolink=function(Q,re){var $e=this.rules.inline.autolink.exec(Q);if($e){var we,Ne;return $e[2]==="@"?(we=v(this.options.mangle?re($e[1]):$e[1]),Ne="mailto:"+we):(we=v($e[1]),Ne=we),{type:"link",raw:$e[0],text:we,href:Ne,tokens:[{type:"text",raw:we,text:we}]}}},se.url=function(Q,re){var $e;if($e=this.rules.inline.url.exec(Q)){var we,Ne;if($e[2]==="@")we=v(this.options.mangle?re($e[0]):$e[0]),Ne="mailto:"+we;else{var Se;do Se=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(Se!==$e[0]);we=v($e[0]),$e[1]==="www."?Ne="http://"+we:Ne=we}return{type:"link",raw:$e[0],text:we,href:Ne,tokens:[{type:"text",raw:we,text:we}]}}},se.inlineText=function(Q,re){var $e=this.rules.inline.text.exec(Q);if($e){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):v($e[0]):$e[0]:we=v(this.options.smartypants?re($e[0]):$e[0]),{type:"text",raw:$e[0],text:we}}},ae}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=i(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=i(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=i(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=i(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=i(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=b({},F),F.gfm=b({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=i(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=b({},F.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:i(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(F._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",F._label).getRegex(),N.nolink=i(N.nolink).replace("ref",F._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=b({},N),N.pedantic=b({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=b({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=b({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(ae){var se="",ue,Q,re=ae.length;for(ue=0;ue<re;ue++)Q=ae.charCodeAt(ue),Math.random()>.5&&(Q="x"+Q.toString(16)),se+="&#"+Q+";";return se}var X=function(){function ae(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||le.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:F.normal,inline:N.normal};this.options.pedantic?(Q.block=F.pedantic,Q.inline=N.pedantic):this.options.gfm&&(Q.block=F.gfm,this.options.breaks?Q.inline=N.breaks:Q.inline=N.gfm),this.tokenizer.rules=Q}ae.lex=function(Q,re){var $e=new ae(re);return $e.lex(Q)},ae.lexInline=function(Q,re){var $e=new ae(re);return $e.inlineTokens(Q)};var se=ae.prototype;return se.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var re;re=this.inlineQueue.shift();)this.inlineTokens(re.src,re.tokens);return this.tokens},se.blockTokens=function(Q,re){var $e=this;re===void 0&&(re=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(je,V,W){return V+"    ".repeat(W.length)});for(var we,Ne,Se,Ie;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(we=je.call({lexer:$e},Q,re))?(Q=Q.substring(we.raw.length),re.push(we),!0):!1}))){if(we=this.tokenizer.space(Q)){Q=Q.substring(we.raw.length),we.raw.length===1&&re.length>0?re[re.length-1].raw+=`
`:re.push(we);continue}if(we=this.tokenizer.code(Q)){Q=Q.substring(we.raw.length),Ne=re[re.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+we.raw,Ne.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):re.push(we);continue}if(we=this.tokenizer.fences(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.heading(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.hr(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.blockquote(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.list(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.html(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.def(Q)){Q=Q.substring(we.raw.length),Ne=re[re.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+we.raw,Ne.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.lheading(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(Se=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,V=Q.slice(1),W=void 0;$e.options.extensions.startBlock.forEach(function(J){W=J.call({lexer:this},V),typeof W=="number"&&W>=0&&(je=Math.min(je,W))}),je<1/0&&je>=0&&(Se=Q.substring(0,je+1))}(),this.state.top&&(we=this.tokenizer.paragraph(Se))){Ne=re[re.length-1],Ie&&Ne.type==="paragraph"?(Ne.raw+=`
`+we.raw,Ne.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):re.push(we),Ie=Se.length!==Q.length,Q=Q.substring(we.raw.length);continue}if(we=this.tokenizer.text(Q)){Q=Q.substring(we.raw.length),Ne=re[re.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+we.raw,Ne.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):re.push(we);continue}if(Q){var Ae="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,re},se.inline=function(Q,re){return re===void 0&&(re=[]),this.inlineQueue.push({src:Q,tokens:re}),re},se.inlineTokens=function(Q,re){var $e=this;re===void 0&&(re=[]);var we,Ne,Se,Ie=Q,Ae,je,V;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)W.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(je||(V=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(we=Z.call({lexer:$e},Q,re))?(Q=Q.substring(we.raw.length),re.push(we),!0):!1}))){if(we=this.tokenizer.escape(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.tag(Q)){Q=Q.substring(we.raw.length),Ne=re[re.length-1],Ne&&we.type==="text"&&Ne.type==="text"?(Ne.raw+=we.raw,Ne.text+=we.text):re.push(we);continue}if(we=this.tokenizer.link(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(we.raw.length),Ne=re[re.length-1],Ne&&we.type==="text"&&Ne.type==="text"?(Ne.raw+=we.raw,Ne.text+=we.text):re.push(we);continue}if(we=this.tokenizer.emStrong(Q,Ie,V)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.codespan(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.br(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.del(Q)){Q=Q.substring(we.raw.length),re.push(we);continue}if(we=this.tokenizer.autolink(Q,B)){Q=Q.substring(we.raw.length),re.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(Q,B))){Q=Q.substring(we.raw.length),re.push(we);continue}if(Se=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,he=Q.slice(1),be=void 0;$e.options.extensions.startInline.forEach(function(Fe){be=Fe.call({lexer:this},he),typeof be=="number"&&be>=0&&(Z=Math.min(Z,be))}),Z<1/0&&Z>=0&&(Se=Q.substring(0,Z+1))}(),we=this.tokenizer.inlineText(Se,j)){Q=Q.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(V=we.raw.slice(-1)),je=!0,Ne=re[re.length-1],Ne&&Ne.type==="text"?(Ne.raw+=we.raw,Ne.text+=we.text):re.push(we);continue}if(Q){var J="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return re},l(ae,null,[{key:"rules",get:function(){return{block:F,inline:N}}}]),ae}(),ie=function(){function ae(ue){this.options=ue||le.defaults}var se=ae.prototype;return se.code=function(Q,re,$e){var we=(re||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(Q,we);Ne!=null&&Ne!==Q&&($e=!0,Q=Ne)}return Q=Q.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+v(we,!0)+'">'+($e?Q:v(Q,!0))+`</code></pre>
`:"<pre><code>"+($e?Q:v(Q,!0))+`</code></pre>
`},se.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},se.html=function(Q){return Q},se.heading=function(Q,re,$e,we){if(this.options.headerIds){var Ne=this.options.headerPrefix+we.slug($e);return"<h"+re+' id="'+Ne+'">'+Q+"</h"+re+`>
`}return"<h"+re+">"+Q+"</h"+re+`>
`},se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},se.list=function(Q,re,$e){var we=re?"ol":"ul",Ne=re&&$e!==1?' start="'+$e+'"':"";return"<"+we+Ne+`>
`+Q+"</"+we+`>
`},se.listitem=function(Q){return"<li>"+Q+`</li>
`},se.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},se.paragraph=function(Q){return"<p>"+Q+`</p>
`},se.table=function(Q,re){return re&&(re="<tbody>"+re+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+re+`</table>
`},se.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},se.tablecell=function(Q,re){var $e=re.header?"th":"td",we=re.align?"<"+$e+' align="'+re.align+'">':"<"+$e+">";return we+Q+("</"+$e+`>
`)},se.strong=function(Q){return"<strong>"+Q+"</strong>"},se.em=function(Q){return"<em>"+Q+"</em>"},se.codespan=function(Q){return"<code>"+Q+"</code>"},se.br=function(){return this.options.xhtml?"<br/>":"<br>"},se.del=function(Q){return"<del>"+Q+"</del>"},se.link=function(Q,re,$e){if(Q=r(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var we='<a href="'+v(Q)+'"';return re&&(we+=' title="'+re+'"'),we+=">"+$e+"</a>",we},se.image=function(Q,re,$e){if(Q=r(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var we='<img src="'+Q+'" alt="'+$e+'"';return re&&(we+=' title="'+re+'"'),we+=this.options.xhtml?"/>":">",we},se.text=function(Q){return Q},ae}(),H=function(){function ae(){}var se=ae.prototype;return se.strong=function(Q){return Q},se.em=function(Q){return Q},se.codespan=function(Q){return Q},se.del=function(Q){return Q},se.html=function(Q){return Q},se.text=function(Q){return Q},se.link=function(Q,re,$e){return""+$e},se.image=function(Q,re,$e){return""+$e},se.br=function(){return""},ae}(),K=function(){function ae(){this.seen={}}var se=ae.prototype;return se.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},se.getNextSafeSlug=function(Q,re){var $e=Q,we=0;if(this.seen.hasOwnProperty($e)){we=this.seen[Q];do we++,$e=Q+"-"+we;while(this.seen.hasOwnProperty($e))}return re||(this.seen[Q]=we,this.seen[$e]=0),$e},se.slug=function(Q,re){re===void 0&&(re={});var $e=this.serialize(Q);return this.getNextSafeSlug($e,re.dryrun)},ae}(),x=function(){function ae(ue){this.options=ue||le.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new K}ae.parse=function(Q,re){var $e=new ae(re);return $e.parse(Q)},ae.parseInline=function(Q,re){var $e=new ae(re);return $e.parseInline(Q)};var se=ae.prototype;return se.parse=function(Q,re){re===void 0&&(re=!0);var $e="",we,Ne,Se,Ie,Ae,je,V,W,J,Z,he,be,Fe,Ve,Qe,tt,_e,nt,it,rt=Q.length;for(we=0;we<rt;we++){if(Z=Q[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(it=this.options.extensions.renderers[Z.type].call({parser:this},Z),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){$e+=it||"";continue}switch(Z.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,h(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(W="",V="",Ie=Z.header.length,Ne=0;Ne<Ie;Ne++)V+=this.renderer.tablecell(this.parseInline(Z.header[Ne].tokens),{header:!0,align:Z.align[Ne]});for(W+=this.renderer.tablerow(V),J="",Ie=Z.rows.length,Ne=0;Ne<Ie;Ne++){for(je=Z.rows[Ne],V="",Ae=je.length,Se=0;Se<Ae;Se++)V+=this.renderer.tablecell(this.parseInline(je[Se].tokens),{header:!1,align:Z.align[Se]});J+=this.renderer.tablerow(V)}$e+=this.renderer.table(W,J);continue}case"blockquote":{J=this.parse(Z.tokens),$e+=this.renderer.blockquote(J);continue}case"list":{for(he=Z.ordered,be=Z.start,Fe=Z.loose,Ie=Z.items.length,J="",Ne=0;Ne<Ie;Ne++)Qe=Z.items[Ne],tt=Qe.checked,_e=Qe.task,Ve="",Qe.task&&(nt=this.renderer.checkbox(tt),Fe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=nt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=nt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:nt}):Ve+=nt),Ve+=this.parse(Qe.tokens,Fe),J+=this.renderer.listitem(Ve,_e,tt);$e+=this.renderer.list(J,he,be);continue}case"html":{$e+=this.renderer.html(Z.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(J=Z.tokens?this.parseInline(Z.tokens):Z.text;we+1<rt&&Q[we+1].type==="text";)Z=Q[++we],J+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);$e+=re?this.renderer.paragraph(J):J;continue}default:{var at='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return $e},se.parseInline=function(Q,re){re=re||this.renderer;var $e="",we,Ne,Se,Ie=Q.length;for(we=0;we<Ie;we++){if(Ne=Q[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(Se=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),Se!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){$e+=Se||"";continue}switch(Ne.type){case"escape":{$e+=re.text(Ne.text);break}case"html":{$e+=re.html(Ne.text);break}case"link":{$e+=re.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,re));break}case"image":{$e+=re.image(Ne.href,Ne.title,Ne.text);break}case"strong":{$e+=re.strong(this.parseInline(Ne.tokens,re));break}case"em":{$e+=re.em(this.parseInline(Ne.tokens,re));break}case"codespan":{$e+=re.codespan(Ne.text);break}case"br":{$e+=re.br();break}case"del":{$e+=re.del(this.parseInline(Ne.tokens,re));break}case"text":{$e+=re.text(Ne.text);break}default:{var Ae='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return $e},ae}();function _(ae,se,ue){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof se=="function"&&(ue=se,se=null),se=b({},_.defaults,se||{}),D(se),ue){var Q=se.highlight,re;try{re=X.lex(ae,se)}catch(Ie){return ue(Ie)}var $e=function(Ae){var je;if(!Ae)try{se.walkTokens&&_.walkTokens(re,se.walkTokens),je=x.parse(re,se)}catch(V){Ae=V}return se.highlight=Q,Ae?ue(Ae):ue(null,je)};if(!Q||Q.length<3||(delete se.highlight,!re.length))return $e();var we=0;_.walkTokens(re,function(Ie){Ie.type==="code"&&(we++,setTimeout(function(){Q(Ie.text,Ie.lang,function(Ae,je){if(Ae)return $e(Ae);je!=null&&je!==Ie.text&&(Ie.text=je,Ie.escaped=!0),we--,we===0&&$e()})},0))}),we===0&&$e();return}function Ne(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+v(Ie.message+"",!0)+"</pre>";throw Ie}try{var Se=X.lex(ae,se);if(se.walkTokens){if(se.async)return Promise.all(_.walkTokens(Se,se.walkTokens)).then(function(){return x.parse(Se,se)}).catch(Ne);_.walkTokens(Se,se.walkTokens)}return x.parse(Se,se)}catch(Ie){Ne(Ie)}}_.options=_.setOptions=function(ae){return b(_.defaults,ae),w(_.defaults),_},_.getDefaults=R,_.defaults=le.defaults,_.use=function(){for(var ae=arguments.length,se=new Array(ae),ue=0;ue<ae;ue++)se[ue]=arguments[ue];var Q=b.apply(void 0,[{}].concat(se)),re=_.defaults.extensions||{renderers:{},childTokens:{}},$e;se.forEach(function(we){if(we.extensions&&($e=!0,we.extensions.forEach(function(Se){if(!Se.name)throw new Error("extension name required");if(Se.renderer){var Ie=re.renderers?re.renderers[Se.name]:null;Ie?re.renderers[Se.name]=function(){for(var Ae=arguments.length,je=new Array(Ae),V=0;V<Ae;V++)je[V]=arguments[V];var W=Se.renderer.apply(this,je);return W===!1&&(W=Ie.apply(this,je)),W}:re.renderers[Se.name]=Se.renderer}if(Se.tokenizer){if(!Se.level||Se.level!=="block"&&Se.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");re[Se.level]?re[Se.level].unshift(Se.tokenizer):re[Se.level]=[Se.tokenizer],Se.start&&(Se.level==="block"?re.startBlock?re.startBlock.push(Se.start):re.startBlock=[Se.start]:Se.level==="inline"&&(re.startInline?re.startInline.push(Se.start):re.startInline=[Se.start]))}Se.childTokens&&(re.childTokens[Se.name]=Se.childTokens)})),we.renderer&&function(){var Se=_.defaults.renderer||new ie,Ie=function(V){var W=Se[V];Se[V]=function(){for(var J=arguments.length,Z=new Array(J),he=0;he<J;he++)Z[he]=arguments[he];var be=we.renderer[V].apply(Se,Z);return be===!1&&(be=W.apply(Se,Z)),be}};for(var Ae in we.renderer)Ie(Ae);Q.renderer=Se}(),we.tokenizer&&function(){var Se=_.defaults.tokenizer||new T,Ie=function(V){var W=Se[V];Se[V]=function(){for(var J=arguments.length,Z=new Array(J),he=0;he<J;he++)Z[he]=arguments[he];var be=we.tokenizer[V].apply(Se,Z);return be===!1&&(be=W.apply(Se,Z)),be}};for(var Ae in we.tokenizer)Ie(Ae);Q.tokenizer=Se}(),we.walkTokens){var Ne=_.defaults.walkTokens;Q.walkTokens=function(Se){var Ie=[];return Ie.push(we.walkTokens.call(this,Se)),Ne&&(Ie=Ie.concat(Ne.call(this,Se))),Ie}}$e&&(Q.extensions=re),_.setOptions(Q)})},_.walkTokens=function(ae,se){for(var ue=[],Q=function(){var Ne=$e.value;switch(ue=ue.concat(se.call(_,Ne)),Ne.type){case"table":{for(var Se=A(Ne.header),Ie;!(Ie=Se()).done;){var Ae=Ie.value;ue=ue.concat(_.walkTokens(Ae.tokens,se))}for(var je=A(Ne.rows),V;!(V=je()).done;)for(var W=V.value,J=A(W),Z;!(Z=J()).done;){var he=Z.value;ue=ue.concat(_.walkTokens(he.tokens,se))}break}case"list":{ue=ue.concat(_.walkTokens(Ne.items,se));break}default:_.defaults.extensions&&_.defaults.extensions.childTokens&&_.defaults.extensions.childTokens[Ne.type]?_.defaults.extensions.childTokens[Ne.type].forEach(function(be){ue=ue.concat(_.walkTokens(Ne[be],se))}):Ne.tokens&&(ue=ue.concat(_.walkTokens(Ne.tokens,se)))}},re=A(ae),$e;!($e=re()).done;)Q();return ue},_.parseInline=function(ae,se){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");se=b({},_.defaults,se||{}),D(se);try{var ue=X.lexInline(ae,se);return se.walkTokens&&_.walkTokens(ue,se.walkTokens),x.parseInline(ue,se)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,se.silent)return"<p>An error occurred:</p><pre>"+v(Q.message+"",!0)+"</pre>";throw Q}},_.Parser=x,_.parser=x.parse,_.Renderer=ie,_.TextRenderer=H,_.Lexer=X,_.lexer=X.lex,_.Tokenizer=T,_.Slugger=K,_.parse=_;var ge=_.options,oe=_.setOptions,Pe=_.use,me=_.walkTokens,U=_.parseInline,Y=_,pe=x.parse,ce=X.lex;le.Lexer=X,le.Parser=x,le.Renderer=ie,le.Slugger=K,le.TextRenderer=H,le.Tokenizer=T,le.getDefaults=R,le.lexer=ce,le.marked=_,le.options=ge,le.parse=Y,le.parseInline=U,le.parser=pe,le.setOptions=oe,le.use=Pe,le.walkTokens=me,Object.defineProperty(le,"__esModule",{value:!0})}),define(ke[168],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=l;function l(d){const h=A(d);if(h&&h.length>0)return new Uint32Array(h)}let L=0;const M=new Uint32Array(10);function A(d){if(L=0,R(d,P,4352),L>0||(R(d,p,4449),L>0)||(R(d,E,4520),L>0)||(R(d,v,12593),L))return M.subarray(0,L);if(d>=44032&&d<=55203){const h=d-44032,c=h%588,i=Math.floor(h/588),n=Math.floor(c/28),a=c%28-1;if(i<P.length?R(i,P,0):4352+i-12593<v.length&&R(4352+i,v,12593),n<p.length?R(n,p,0):4449+n-12593<v.length&&R(4449+n-12593,v,12593),a>=0&&(a<E.length?R(a,E,0):4520+a-12593<v.length&&R(4520+a-12593,v,12593)),L>0)return M.subarray(0,L)}}function R(d,h,c){d>=c&&d<c+h.length&&w(h[d-c])}function w(d){d!==0&&(M[L++]=d&255,d>>8&&(M[L++]=d>>8&255),d>>16&&(M[L++]=d>>16&255))}var $;(function(d){d[d.InitialConsonant=4352]="InitialConsonant",d[d.Vowel=4449]="Vowel",d[d.FinalConsonant=4520]="FinalConsonant",d[d.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var k;(function(d){d[d.NUL=0]="NUL",d[d.A=65]="A",d[d.B=66]="B",d[d.C=67]="C",d[d.D=68]="D",d[d.E=69]="E",d[d.F=70]="F",d[d.G=71]="G",d[d.H=72]="H",d[d.I=73]="I",d[d.J=74]="J",d[d.K=75]="K",d[d.L=76]="L",d[d.M=77]="M",d[d.N=78]="N",d[d.O=79]="O",d[d.P=80]="P",d[d.Q=81]="Q",d[d.R=82]="R",d[d.S=83]="S",d[d.T=84]="T",d[d.U=85]="U",d[d.V=86]="V",d[d.W=87]="W",d[d.X=88]="X",d[d.Y=89]="Y",d[d.Z=90]="Z",d[d.a=97]="a",d[d.b=98]="b",d[d.c=99]="c",d[d.d=100]="d",d[d.e=101]="e",d[d.f=102]="f",d[d.g=103]="g",d[d.h=104]="h",d[d.i=105]="i",d[d.j=106]="j",d[d.k=107]="k",d[d.l=108]="l",d[d.m=109]="m",d[d.n=110]="n",d[d.o=111]="o",d[d.p=112]="p",d[d.q=113]="q",d[d.r=114]="r",d[d.s=115]="s",d[d.t=116]="t",d[d.u=117]="u",d[d.v=118]="v",d[d.w=119]="w",d[d.x=120]="x",d[d.y=121]="y",d[d.z=122]="z"})(k||(k={}));var I;(function(d){d[d.fa=24934]="fa",d[d.fg=26470]="fg",d[d.fq=29030]="fq",d[d.fr=29286]="fr",d[d.ft=29798]="ft",d[d.fv=30310]="fv",d[d.fx=30822]="fx",d[d.hk=27496]="hk",d[d.hl=27752]="hl",d[d.ho=28520]="ho",d[d.ml=27757]="ml",d[d.nj=27246]="nj",d[d.nl=27758]="nl",d[d.np=28782]="np",d[d.qt=29809]="qt",d[d.rt=29810]="rt",d[d.sg=26483]="sg",d[d.sw=30579]="sw"})(I||(I={}));const P=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[77],De([1,0,27]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=void 0,e.$fm=M,e.$gm=R;const L=new l.$Dc(1e4);function M(k){return $(k,"NFC",L)}const A=new l.$Dc(1e4);function R(k){return $(k,"NFD",A)}const w=/[^\u0000-\u0080]/;function $(k,I,P){if(!k)return k;const p=P.get(k);if(p)return p;let E;return w.test(k)?E=k.normalize(I):E=k,P.set(k,E),E}e.$hm=function(){const k=/[\u0300-\u036f]/g;return function(I){return R(I).replace(k,"")}}()}),define(ke[126],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=void 0,e.$Fm=l,e.rot=L;function l(w,$,k){return Math.min(Math.max(w,$),k)}function L(w,$){return($+w%$)%$}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$Hm=M;class A{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Im=A;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const k=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jm=R}),define(ke[169],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=A,e.$cd=p;class l{constructor(v,d,h){this.owner=v,this.debugNameSource=d,this.referenceFn=h}getDebugName(v){return A(v,this)}}e.$ad=l;const L=new Map,M=new WeakMap;function A(E,v){const d=M.get(E);if(d)return d;const h=R(E,v);if(h){let c=L.get(h)??0;c++,L.set(h,c);const i=c===1?h:`${h}#${c}`;return M.set(E,i),i}}function R(E,v){const d=M.get(E);if(d)return d;const h=v.owner?I(v.owner)+".":"";let c;const i=v.debugNameSource;if(i!==void 0)if(typeof i=="function"){if(c=i(),c!==void 0)return h+c}else return h+i;const n=v.referenceFn;if(n!==void 0&&(c=p(n),c!==void 0))return h+c;if(v.owner!==void 0){const a=w(v.owner,E);if(a!==void 0)return h+a}}function w(E,v){for(const d in E)if(E[d]===v)return d}const $=new Map,k=new WeakMap;function I(E){const v=k.get(E);if(v)return v;const d=P(E);let h=$.get(d)??0;h++,$.set(d,h);const c=h===1?d:`${d}#${h}`;return k.set(E,c),c}function P(E){const v=E.constructor;return v?v.name:"Object"}function p(E){const v=E.toString(),h=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(v);return(h?h[1]:void 0)?.trim()}}),define(ke[170],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=L,e.$Id=M;let l;function L(d){l=d}function M(){return l}class A{constructor(){this.a=0,this.d=new WeakMap}b(h){return R([w(E("|  ",this.a)),h])}c(h){return h.hadValue?h.didChange?[w(" "),k(I(h.oldValue,70),{color:"red",strikeThrough:!0}),w(" "),k(I(h.newValue,60),{color:"green"})]:[w(" (unchanged)")]:[w(" "),k(I(h.newValue,60),{color:"green"}),w(" (initial)")]}handleObservableChanged(h,c){console.log(...this.b([$("observable value changed"),k(h.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(h){if(h.size!==0)return k(" (changed deps: "+[...h].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(h){const c=h.handleChange;this.d.set(h,new Set),h.handleChange=(i,n)=>(this.d.get(h).add(i),c.apply(h,[i,n]))}handleDerivedRecomputed(h,c){const i=this.d.get(h);console.log(...this.b([$("derived recomputed"),k(h.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(i),{data:[{fn:h._computeFn}]}])),i.clear()}handleFromEventObservableTriggered(h,c){console.log(...this.b([$("observable from event triggered"),k(h.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:h._getValue}]}]))}handleAutorunCreated(h){const c=h.handleChange;this.d.set(h,new Set),h.handleChange=(i,n)=>(this.d.get(h).add(i),c.apply(h,[i,n]))}handleAutorunTriggered(h){const c=this.d.get(h);console.log(...this.b([$("autorun"),k(h.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:h._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(h){this.a--}handleBeginTransaction(h){let c=h.getDebugName();c===void 0&&(c=""),console.log(...this.b([$("transaction"),k(c,{color:"BlueViolet"}),{data:[{fn:h._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=A;function R(d){const h=new Array,c=[];let i="";function n(r){if("length"in r)for(const t of r)t&&n(t);else"text"in r?(i+=`%c${r.text}`,h.push(r.style),r.data&&c.push(...r.data)):"data"in r&&c.push(...r.data)}n(d);const a=[i,...h];return a.push(...c),a}function w(d){return k(d,{color:"black"})}function $(d){return k(v(`${d}: `,10),{color:"black",bold:!0})}function k(d,h={color:"black"}){function c(n){return Object.entries(n).reduce((a,[r,t])=>`${a}${r}:${t};`,"")}const i={color:h.color};return h.strikeThrough&&(i["text-decoration"]="line-through"),h.bold&&(i["font-weight"]="bold"),{text:d,style:c(i)}}function I(d,h){switch(typeof d){case"number":return""+d;case"string":return d.length+2<=h?`"${d}"`:`"${d.substr(0,h-7)}"+...`;case"boolean":return d?"true":"false";case"undefined":return"undefined";case"object":return d===null?"null":Array.isArray(d)?P(d,h):p(d,h);case"symbol":return d.toString();case"function":return`[[Function${d.name?" "+d.name:""}]]`;default:return""+d}}function P(d,h){let c="[ ",i=!0;for(const n of d){if(i||(c+=", "),c.length-5>h){c+="...";break}i=!1,c+=`${I(n,h-c.length)}`}return c+=" ]",c}function p(d,h){let c="{ ",i=!0;for(const[n,a]of Object.entries(d)){if(i||(c+=", "),c.length-5>h){c+="...";break}i=!1,c+=`${n}: ${I(a,h-c.length)}`}return c+=" }",c}function E(d,h){let c="";for(let i=1;i<=h;i++)c+=d;return c}function v(d,h){for(;d.length<h;)d+=" ";return d}}),define(ke[171],De([1,0,165,169,170]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=R,e.$Td=$,e.$Ud=I,e.$Xd=E,e.$Yd=d,e.$Zd=h,e.$1d=c,e.$3d=n,e.$4d=a,e.$6d=t;let A;function R(o){A=o}let w;function $(o){w=o}let k;function I(o){k=o}class P{get TChange(){return null}reportChanges(){this.get()}read(s){return s?s.readObservable(this):this.get()}map(s,u){const g=u===void 0?void 0:s,b=u===void 0?s:u;return k({owner:g,debugName:()=>{const S=(0,L.$cd)(b);if(S!==void 0)return S;const y=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(b.toString());if(y)return`${this.debugName}.${y[2]}`;if(!g)return`${this.debugName} (mapped)`},debugReferenceFn:b},S=>b(this.read(S),S))}recomputeInitiallyAndOnChange(s,u){return s.add(A(this,u)),this}keepObserved(s){return s.add(w(this)),this}get a(){return this.get()}}e.$Vd=P;class p extends P{constructor(){super(...arguments),this.b=new Set}addObserver(s){const u=this.b.size;this.b.add(s),u===0&&this.c()}removeObserver(s){this.b.delete(s)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=p;function E(o,s){const u=new i(o,s);try{o(u)}finally{u.finish()}}let v;function d(o){if(v)o(v);else{const s=new i(o,void 0);v=s;try{o(s)}finally{s.finish(),v=void 0}}}async function h(o,s){const u=new i(o,s);try{await o(u)}finally{u.finish()}}function c(o,s,u){o?s(o):E(s,u)}class i{constructor(s,u){this._fn=s,this.b=u,this.a=[],(0,M.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,L.$cd)(this._fn)}updateObserver(s,u){this.a.push({observer:s,observable:u}),s.beginUpdate(u)}finish(){const s=this.a;for(let u=0;u<s.length;u++){const{observer:g,observable:b}=s[u];g.endUpdate(b)}this.a=null,(0,M.$Id)()?.handleEndTransaction()}}e.$2d=i;function n(o,s){let u;return typeof o=="string"?u=new L.$ad(void 0,o,void 0):u=new L.$ad(o,void 0,void 0),new r(u,s,l.$6c)}function a(o,s){return new r(new L.$ad(o.owner,o.debugName,void 0),s,o.equalsFn??l.$6c)}class r extends p{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(s,u,g){super(),this.e=s,this.g=g,this.d=u}get(){return this.d}set(s,u,g){if(g===void 0&&this.g(this.d,s))return;let b;u||(u=b=new i(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(s),(0,M.$Id)()?.handleObservableChanged(this,{oldValue:S,newValue:s,change:g,didChange:!0,hadValue:!0});for(const m of this.b)u.updateObserver(m,this),m.handleChange(this,g)}finally{b&&b.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(s){this.d=s}}e.$5d=r;function t(o,s){let u;return typeof o=="string"?u=new L.$ad(void 0,o,void 0):u=new L.$ad(o,void 0,void 0),new f(u,s,l.$6c)}class f extends r{h(s){this.d!==s&&(this.d&&this.d.dispose(),this.d=s)}dispose(){this.d?.dispose()}}e.$7d=f}),function(){function le(M){const A=[];typeof M=="number"&&A.push("code/timeOrigin",M);function R($){A.push($,Date.now())}function w(){const $=[];for(let k=0;k<A.length;k+=2)$.push({name:A[k],startTime:A[k+1]});return $}return{mark:R,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(M+R.startTime)});return A}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function l(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=l(L))}(),define(ke[172],De([1,0,39]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=void 0;const L=Symbol("unset");class M{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||l.Iterable.empty()}insert($,k,I){this.d($,P=>P._value=k,I)}mutate($,k){this.d($,I=>I._value=k(I._value===L?void 0:I._value))}mutatePath($,k){this.d($,()=>{},I=>k(I))}delete($){const k=this.c($);if(!k)return;let I=k.length-1;const P=k[I].node._value;if(P!==L){for(this.b--,k[I].node._value=L;I>0;I--){const{node:p,part:E}=k[I];if(p.children?.size||p._value!==L)break;k[I-1].node.children.delete(E)}return P}}*deleteRecursive($){const k=this.c($);if(!k)return;const I=k[k.length-1].node;for(let P=k.length-1;P>0;P--){const p=k[P-1];if(p.node.children.delete(k[P].part),p.node.children.size>0||p.node._value!==L)break}for(const P of A(I))P._value!==L&&(this.b--,yield P._value)}find($){let k=this.a;for(const I of $){const P=k.children?.get(I);if(!P)return;k=P}return k._value===L?void 0:k._value}hasKeyOrParent($){let k=this.a;for(const I of $){const P=k.children?.get(I);if(!P)return!1;if(P._value!==L)return!0;k=P}return!1}hasKeyOrChildren($){let k=this.a;for(const I of $){const P=k.children?.get(I);if(!P)return!1;k=P}return!0}hasKey($){let k=this.a;for(const I of $){const P=k.children?.get(I);if(!P)return!1;k=P}return k._value!==L}c($){const k=[{part:"",node:this.a}];let I=0;for(const P of $){const p=k[I].node.children?.get(P);if(!p)return;k.push({part:P,node:p}),I++}return k}d($,k,I){let P=this.a;for(const v of $){if(P.children)if(P.children.has(v))P=P.children.get(v);else{const d=new R;P.children.set(v,d),P=d}else{const d=new R;P.children=new Map([[v,d]]),P=d}I?.(P)}const p=P._value===L?0:1;k(P);const E=P._value===L?0:1;this.b+=E-p}*values(){for(const{_value:$}of A(this.a))$!==L&&(yield $)}}e.$GO=M;function*A(w){const $=[w];for(;$.length>0;){const k=$.pop();if(yield k,k.children)for(const I of k.children.values())$.push(I)}}class R{constructor(){this._value=L}get value(){return this._value===L?void 0:this._value}set value($){this._value=$===void 0?L:$}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var L in l)(typeof exports=="object"?exports:le)[L]=l[L]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function l(L){if(e[L])return e[L].exports;var M=e[L]={i:L,l:!1,exports:{}};return le[L].call(M.exports,M,M.exports,l),M.l=!0,M.exports}return l.m=le,l.c=e,l.d=function(L,M,A){l.o(L,M)||Object.defineProperty(L,M,{enumerable:!0,get:A})},l.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},l.t=function(L,M){if(1&M&&(L=l(L)),8&M||4&M&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(l.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&M&&typeof L!="string")for(var R in L)l.d(A,R,function(w){return L[w]}.bind(null,R));return A},l.n=function(L){var M=L&&L.__esModule?function(){return L.default}:function(){return L};return l.d(M,"a",M),M},l.o=function(L,M){return Object.prototype.hasOwnProperty.call(L,M)},l.p="",l(l.s=0)}([function(le,e,l){(function(L){var M;e=le.exports=Pe,M=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],$=e.src=[],k=0,I=k++;$[I]="0|[1-9]\\d*";var P=k++;$[P]="[0-9]+";var p=k++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;$[E]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var v=k++;$[v]="("+$[P]+")\\.("+$[P]+")\\.("+$[P]+")";var d=k++;$[d]="(?:"+$[I]+"|"+$[p]+")";var h=k++;$[h]="(?:"+$[P]+"|"+$[p]+")";var c=k++;$[c]="(?:-("+$[d]+"(?:\\."+$[d]+")*))";var i=k++;$[i]="(?:-?("+$[h]+"(?:\\."+$[h]+")*))";var n=k++;$[n]="[0-9A-Za-z-]+";var a=k++;$[a]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var r=k++,t="v?"+$[E]+$[c]+"?"+$[a]+"?";$[r]="^"+t+"$";var f="[v=\\s]*"+$[v]+$[i]+"?"+$[a]+"?",o=k++;$[o]="^"+f+"$";var s=k++;$[s]="((?:<|>)?=?)";var u=k++;$[u]=$[P]+"|x|X|\\*";var g=k++;$[g]=$[I]+"|x|X|\\*";var b=k++;$[b]="[v=\\s]*("+$[g]+")(?:\\.("+$[g]+")(?:\\.("+$[g]+")(?:"+$[c]+")?"+$[a]+"?)?)?";var S=k++;$[S]="[v=\\s]*("+$[u]+")(?:\\.("+$[u]+")(?:\\.("+$[u]+")(?:"+$[i]+")?"+$[a]+"?)?)?";var m=k++;$[m]="^"+$[s]+"\\s*"+$[b]+"$";var y=k++;$[y]="^"+$[s]+"\\s*"+$[S]+"$";var D=k++;$[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=k++;$[C]="(?:~>?)";var O=k++;$[O]="(\\s*)"+$[C]+"\\s+",w[O]=new RegExp($[O],"g");var z=k++;$[z]="^"+$[C]+$[b]+"$";var T=k++;$[T]="^"+$[C]+$[S]+"$";var F=k++;$[F]="(?:\\^)";var N=k++;$[N]="(\\s*)"+$[F]+"\\s+",w[N]=new RegExp($[N],"g");var j=k++;$[j]="^"+$[F]+$[b]+"$";var B=k++;$[B]="^"+$[F]+$[S]+"$";var X=k++;$[X]="^"+$[s]+"\\s*("+f+")$|^$";var ie=k++;$[ie]="^"+$[s]+"\\s*("+t+")$|^$";var H=k++;$[H]="(\\s*)"+$[s]+"\\s*("+f+"|"+$[b]+")",w[H]=new RegExp($[H],"g");var K=k++;$[K]="^\\s*("+$[b]+")\\s+-\\s+("+$[b]+")\\s*$";var x=k++;$[x]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var _=k++;$[_]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)M(ge,$[ge]),w[ge]||(w[ge]=new RegExp($[ge]));function oe(W,J){if(W instanceof Pe)return W;if(typeof W!="string"||W.length>A||!(J?w[o]:w[r]).test(W))return null;try{return new Pe(W,J)}catch{return null}}function Pe(W,J){if(W instanceof Pe){if(W.loose===J)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Pe))return new Pe(W,J);M("SemVer",W,J),this.loose=J;var Z=W.trim().match(J?w[o]:w[r]);if(!Z)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var be=+he;if(be>=0&&be<R)return be}return he}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=oe,e.valid=function(W,J){var Z=oe(W,J);return Z?Z.version:null},e.clean=function(W,J){var Z=oe(W.trim().replace(/^[=v]+/,""),J);return Z?Z.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(W){return M("SemVer.compare",this.version,this.loose,W),W instanceof Pe||(W=new Pe(W,this.loose)),this.compareMain(W)||this.comparePre(W)},Pe.prototype.compareMain=function(W){return W instanceof Pe||(W=new Pe(W,this.loose)),U(this.major,W.major)||U(this.minor,W.minor)||U(this.patch,W.patch)},Pe.prototype.comparePre=function(W){if(W instanceof Pe||(W=new Pe(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var J=0;do{var Z=this.prerelease[J],he=W.prerelease[J];if(M("prerelease compare",J,Z,he),Z===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(Z===void 0)return-1;if(Z!==he)return U(Z,he)}while(++J)},Pe.prototype.inc=function(W,J){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,J,Z,he){typeof Z=="string"&&(he=Z,Z=void 0);try{return new Pe(W,Z).inc(J,he).version}catch{return null}},e.diff=function(W,J){if(ae(W,J))return null;var Z=oe(W),he=oe(J);if(Z.prerelease.length||he.prerelease.length){for(var be in Z)if((be==="major"||be==="minor"||be==="patch")&&Z[be]!==he[be])return"pre"+be;return"prerelease"}for(var be in Z)if((be==="major"||be==="minor"||be==="patch")&&Z[be]!==he[be])return be},e.compareIdentifiers=U;var me=/^[0-9]+$/;function U(W,J){var Z=me.test(W),he=me.test(J);return Z&&he&&(W=+W,J=+J),Z&&!he?-1:he&&!Z?1:W<J?-1:W>J?1:0}function Y(W,J,Z){return new Pe(W,Z).compare(new Pe(J,Z))}function pe(W,J,Z){return Y(W,J,Z)>0}function ce(W,J,Z){return Y(W,J,Z)<0}function ae(W,J,Z){return Y(W,J,Z)===0}function se(W,J,Z){return Y(W,J,Z)!==0}function ue(W,J,Z){return Y(W,J,Z)>=0}function Q(W,J,Z){return Y(W,J,Z)<=0}function re(W,J,Z,he){var be;switch(J){case"===":typeof W=="object"&&(W=W.version),typeof Z=="object"&&(Z=Z.version),be=W===Z;break;case"!==":typeof W=="object"&&(W=W.version),typeof Z=="object"&&(Z=Z.version),be=W!==Z;break;case"":case"=":case"==":be=ae(W,Z,he);break;case"!=":be=se(W,Z,he);break;case">":be=pe(W,Z,he);break;case">=":be=ue(W,Z,he);break;case"<":be=ce(W,Z,he);break;case"<=":be=Q(W,Z,he);break;default:throw new TypeError("Invalid operator: "+J)}return be}function $e(W,J){if(W instanceof $e){if(W.loose===J)return W;W=W.value}if(!(this instanceof $e))return new $e(W,J);M("comparator",W,J),this.loose=J,this.parse(W),this.semver===we?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(W,J){return U(J,W)},e.major=function(W,J){return new Pe(W,J).major},e.minor=function(W,J){return new Pe(W,J).minor},e.patch=function(W,J){return new Pe(W,J).patch},e.compare=Y,e.compareLoose=function(W,J){return Y(W,J,!0)},e.rcompare=function(W,J,Z){return Y(J,W,Z)},e.sort=function(W,J){return W.sort(function(Z,he){return e.compare(Z,he,J)})},e.rsort=function(W,J){return W.sort(function(Z,he){return e.rcompare(Z,he,J)})},e.gt=pe,e.lt=ce,e.eq=ae,e.neq=se,e.gte=ue,e.lte=Q,e.cmp=re,e.Comparator=$e;var we={};function Ne(W,J){if(W instanceof Ne)return W.loose===J?W:new Ne(W.raw,J);if(W instanceof $e)return new Ne(W.value,J);if(!(this instanceof Ne))return new Ne(W,J);if(this.loose=J,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function Se(W){return!W||W.toLowerCase()==="x"||W==="*"}function Ie(W,J,Z,he,be,Fe,Ve,Qe,tt,_e,nt,it,rt){return((J=Se(Z)?"":Se(he)?">="+Z+".0.0":Se(be)?">="+Z+"."+he+".0":">="+J)+" "+(Qe=Se(tt)?"":Se(_e)?"<"+(+tt+1)+".0.0":Se(nt)?"<"+tt+"."+(+_e+1)+".0":it?"<="+tt+"."+_e+"."+nt+"-"+it:"<="+Qe)).trim()}function Ae(W,J){for(var Z=0;Z<W.length;Z++)if(!W[Z].test(J))return!1;if(J.prerelease.length){for(Z=0;Z<W.length;Z++)if(M(W[Z].semver),W[Z].semver!==we&&W[Z].semver.prerelease.length>0){var he=W[Z].semver;if(he.major===J.major&&he.minor===J.minor&&he.patch===J.patch)return!0}return!1}return!0}function je(W,J,Z){try{J=new Ne(J,Z)}catch{return!1}return J.test(W)}function V(W,J,Z,he){var be,Fe,Ve,Qe,tt;switch(W=new Pe(W,he),J=new Ne(J,he),Z){case">":be=pe,Fe=Q,Ve=ce,Qe=">",tt=">=";break;case"<":be=ce,Fe=ue,Ve=pe,Qe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(W,J,he))return!1;for(var _e=0;_e<J.set.length;++_e){var nt=J.set[_e],it=null,rt=null;if(nt.forEach(function(at){at.semver===we&&(at=new $e(">=0.0.0")),it=it||at,rt=rt||at,be(at.semver,it.semver,he)?it=at:Ve(at.semver,rt.semver,he)&&(rt=at)}),it.operator===Qe||it.operator===tt||(!rt.operator||rt.operator===Qe)&&Fe(W,rt.semver)||rt.operator===tt&&Ve(W,rt.semver))return!1}return!0}$e.prototype.parse=function(W){var J=this.loose?w[X]:w[ie],Z=W.match(J);if(!Z)throw new TypeError("Invalid comparator: "+W);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new Pe(Z[2],this.loose):this.semver=we},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(W){return M("Comparator.test",W,this.loose),this.semver===we||(typeof W=="string"&&(W=new Pe(W,this.loose)),re(W,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(W,J){if(!(W instanceof $e))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Ne(W.value,J),je(this.value,Z,J);if(W.operator==="")return Z=new Ne(this.value,J),je(W.semver,Z,J);var he=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Fe=this.semver.version===W.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Qe=re(this.semver,"<",W.semver,J)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),tt=re(this.semver,">",W.semver,J)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return he||be||Fe&&Ve||Qe||tt},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(W){var J=this.loose;W=W.trim(),M("range",W,J);var Z=J?w[x]:w[K];W=W.replace(Z,Ie),M("hyphen replace",W),W=W.replace(w[H],"$1$2$3"),M("comparator trim",W,w[H]),W=(W=(W=W.replace(w[O],"$1~")).replace(w[N],"$1^")).split(/\s+/).join(" ");var he=J?w[X]:w[ie],be=W.split(" ").map(function(Fe){return function(Ve,Qe){return M("comp",Ve),Ve=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){M("caret",it,rt);var at=rt?w[B]:w[j];return it.replace(at,function(Re,ve,qe,te,ne){var Ce;return M("caret",it,Re,ve,qe,te,ne),Se(ve)?Ce="":Se(qe)?Ce=">="+ve+".0.0 <"+(+ve+1)+".0.0":Se(te)?Ce=ve==="0"?">="+ve+"."+qe+".0 <"+ve+"."+(+qe+1)+".0":">="+ve+"."+qe+".0 <"+(+ve+1)+".0.0":ne?(M("replaceCaret pr",ne),ne.charAt(0)!=="-"&&(ne="-"+ne),Ce=ve==="0"?qe==="0"?">="+ve+"."+qe+"."+te+ne+" <"+ve+"."+qe+"."+(+te+1):">="+ve+"."+qe+"."+te+ne+" <"+ve+"."+(+qe+1)+".0":">="+ve+"."+qe+"."+te+ne+" <"+(+ve+1)+".0.0"):(M("no pr"),Ce=ve==="0"?qe==="0"?">="+ve+"."+qe+"."+te+" <"+ve+"."+qe+"."+(+te+1):">="+ve+"."+qe+"."+te+" <"+ve+"."+(+qe+1)+".0":">="+ve+"."+qe+"."+te+" <"+(+ve+1)+".0.0"),M("caret return",Ce),Ce})}(nt,_e)}).join(" ")}(Ve,Qe),M("caret",Ve),Ve=function(tt,_e){return tt.trim().split(/\s+/).map(function(nt){return function(it,rt){var at=rt?w[T]:w[z];return it.replace(at,function(Re,ve,qe,te,ne){var Ce;return M("tilde",it,Re,ve,qe,te,ne),Se(ve)?Ce="":Se(qe)?Ce=">="+ve+".0.0 <"+(+ve+1)+".0.0":Se(te)?Ce=">="+ve+"."+qe+".0 <"+ve+"."+(+qe+1)+".0":ne?(M("replaceTilde pr",ne),ne.charAt(0)!=="-"&&(ne="-"+ne),Ce=">="+ve+"."+qe+"."+te+ne+" <"+ve+"."+(+qe+1)+".0"):Ce=">="+ve+"."+qe+"."+te+" <"+ve+"."+(+qe+1)+".0",M("tilde return",Ce),Ce})}(nt,_e)}).join(" ")}(Ve,Qe),M("tildes",Ve),Ve=function(tt,_e){return M("replaceXRanges",tt,_e),tt.split(/\s+/).map(function(nt){return function(it,rt){it=it.trim();var at=rt?w[y]:w[m];return it.replace(at,function(Re,ve,qe,te,ne,Ce){M("xRange",it,Re,ve,qe,te,ne,Ce);var Ge=Se(qe),Me=Ge||Se(te),st=Me||Se(ne);return ve==="="&&st&&(ve=""),Ge?Re=ve===">"||ve==="<"?"<0.0.0":"*":ve&&st?(Me&&(te=0),st&&(ne=0),ve===">"?(ve=">=",Me?(qe=+qe+1,te=0,ne=0):st&&(te=+te+1,ne=0)):ve==="<="&&(ve="<",Me?qe=+qe+1:te=+te+1),Re=ve+qe+"."+te+"."+ne):Me?Re=">="+qe+".0.0 <"+(+qe+1)+".0.0":st&&(Re=">="+qe+"."+te+".0 <"+qe+"."+(+te+1)+".0"),M("xRange return",Re),Re})}(nt,_e)}).join(" ")}(Ve,Qe),M("xrange",Ve),Ve=function(tt,_e){return M("replaceStars",tt,_e),tt.trim().replace(w[_],"")}(Ve,Qe),M("stars",Ve),Ve}(Fe,J)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Fe){return!!Fe.match(he)})),be=be.map(function(Fe){return new $e(Fe,J)})},Ne.prototype.intersects=function(W,J){if(!(W instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(he){return W.set.some(function(be){return be.every(function(Fe){return he.intersects(Fe,J)})})})})},e.toComparators=function(W,J){return new Ne(W,J).set.map(function(Z){return Z.map(function(he){return he.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new Pe(W,this.loose));for(var J=0;J<this.set.length;J++)if(Ae(this.set[J],W))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(W,J,Z){var he=null,be=null;try{var Fe=new Ne(J,Z)}catch{return null}return W.forEach(function(Ve){Fe.test(Ve)&&(he&&be.compare(Ve)!==-1||(be=new Pe(he=Ve,Z)))}),he},e.minSatisfying=function(W,J,Z){var he=null,be=null;try{var Fe=new Ne(J,Z)}catch{return null}return W.forEach(function(Ve){Fe.test(Ve)&&(he&&be.compare(Ve)!==1||(be=new Pe(he=Ve,Z)))}),he},e.validRange=function(W,J){try{return new Ne(W,J).range||"*"}catch{return null}},e.ltr=function(W,J,Z){return V(W,J,"<",Z)},e.gtr=function(W,J,Z){return V(W,J,">",Z)},e.outside=V,e.prerelease=function(W,J){var Z=oe(W,J);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(W,J,Z){return W=new Ne(W,Z),J=new Ne(J,Z),W.intersects(J)},e.coerce=function(W){if(W instanceof Pe)return W;if(typeof W!="string")return null;var J=W.match(w[D]);return J==null?null:oe((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,l(1))},function(le,e){var l,L,M=le.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(h){if(l===setTimeout)return setTimeout(h,0);if((l===A||!l)&&setTimeout)return l=setTimeout,setTimeout(h,0);try{return l(h,0)}catch{try{return l.call(null,h,0)}catch{return l.call(this,h,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:A}catch{l=A}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var $,k=[],I=!1,P=-1;function p(){I&&$&&(I=!1,$.length?k=$.concat(k):P=-1,k.length&&E())}function E(){if(!I){var h=w(p);I=!0;for(var c=k.length;c;){for($=k,k=[];++P<c;)$&&$[P].run();P=-1,c=k.length}$=null,I=!1,function(i){if(L===clearTimeout)return clearTimeout(i);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(i);try{L(i)}catch{try{return L.call(null,i)}catch{return L.call(this,i)}}}(h)}}function v(h,c){this.fun=h,this.array=c}function d(){}M.nextTick=function(h){var c=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)c[i-1]=arguments[i];k.push(new v(h,c)),k.length!==1||I||w(E)},v.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=d,M.addListener=d,M.once=d,M.off=d,M.removeListener=d,M.removeAllListeners=d,M.emit=d,M.prependListener=d,M.prependOnceListener=d,M.listeners=function(h){return[]},M.binding=function(h){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(h){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(ke[40],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const l=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this.c=l&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=L}),define(ke[4],De([1,0,13,75,3,76,40]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=E;const w=!1,$=!1,k=!1;var I;(function(T){T.None=()=>M.$Uc.None;function F(Ie){if(k){const{onDidAddListener:Ae}=Ie,je=d.create();let V=0;Ie.onDidAddListener=()=>{++V===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),je.print()),Ae?.()}}}function N(Ie,Ae){return oe(Ie,()=>{},0,void 0,!0,void 0,Ae)}T.defer=N;function j(Ie){return(Ae,je=null,V)=>{let W=!1,J;return J=Ie(Z=>{if(!W)return J?J.dispose():W=!0,Ae.call(je,Z)},null,V),W&&J.dispose(),J}}T.once=j;function B(Ie,Ae,je){return _((V,W=null,J)=>Ie(Z=>V.call(W,Ae(Z)),null,J),je)}T.map=B;function X(Ie,Ae,je){return _((V,W=null,J)=>Ie(Z=>{Ae(Z),V.call(W,Z)},null,J),je)}T.forEach=X;function ie(Ie,Ae,je){return _((V,W=null,J)=>Ie(Z=>Ae(Z)&&V.call(W,Z),null,J),je)}T.filter=ie;function H(Ie){return Ie}T.signal=H;function K(...Ie){return(Ae,je=null,V)=>{const W=(0,M.$Rc)(...Ie.map(J=>J(Z=>Ae.call(je,Z))));return ge(W,V)}}T.any=K;function x(Ie,Ae,je,V){let W=je;return B(Ie,J=>(W=Ae(W,J),W),V)}T.reduce=x;function _(Ie,Ae){let je;const V={onWillAddFirstListener(){je=Ie(W.fire,W)},onDidRemoveLastListener(){je?.dispose()}};Ae||F(V);const W=new f(V);return Ae?.add(W),W.event}function ge(Ie,Ae){return Ae instanceof Array?Ae.push(Ie):Ae&&Ae.add(Ie),Ie}function oe(Ie,Ae,je=100,V=!1,W=!1,J,Z){let he,be,Fe,Ve=0,Qe;const tt={leakWarningThreshold:J,onWillAddFirstListener(){he=Ie(nt=>{Ve++,be=Ae(be,nt),V&&!Fe&&(_e.fire(be),be=void 0),Qe=()=>{const it=be;be=void 0,Fe=void 0,(!V||Ve>1)&&_e.fire(it),Ve=0},typeof je=="number"?(clearTimeout(Fe),Fe=setTimeout(Qe,je)):Fe===void 0&&(Fe=0,queueMicrotask(Qe))})},onWillRemoveListener(){W&&Ve>0&&Qe?.()},onDidRemoveLastListener(){Qe=void 0,he.dispose()}};Z||F(tt);const _e=new f(tt);return Z?.add(_e),_e.event}T.debounce=oe;function Pe(Ie,Ae=0,je){return T.debounce(Ie,(V,W)=>V?(V.push(W),V):[W],Ae,void 0,!0,void 0,je)}T.accumulate=Pe;function me(Ie,Ae=(V,W)=>V===W,je){let V=!0,W;return ie(Ie,J=>{const Z=V||!Ae(J,W);return V=!1,W=J,Z},je)}T.latch=me;function U(Ie,Ae,je){return[T.filter(Ie,Ae,je),T.filter(Ie,V=>!Ae(V),je)]}T.split=U;function Y(Ie,Ae=!1,je=[],V){let W=je.slice(),J=Ie(be=>{W?W.push(be):he.fire(be)});V&&V.add(J);const Z=()=>{W?.forEach(be=>he.fire(be)),W=null},he=new f({onWillAddFirstListener(){J||(J=Ie(be=>he.fire(be)),V&&V.add(J))},onDidAddFirstListener(){W&&(Ae?setTimeout(Z):Z())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return V&&V.add(he),he.event}T.buffer=Y;function pe(Ie,Ae){return(V,W,J)=>{const Z=Ae(new ae);return Ie(function(he){const be=Z.evaluate(he);be!==ce&&V.call(W,be)},void 0,J)}}T.chain=pe;const ce=Symbol("HaltChainable");class ae{constructor(){this.f=[]}map(Ae){return this.f.push(Ae),this}forEach(Ae){return this.f.push(je=>(Ae(je),je)),this}filter(Ae){return this.f.push(je=>Ae(je)?je:ce),this}reduce(Ae,je){let V=je;return this.f.push(W=>(V=Ae(V,W),V)),this}latch(Ae=(je,V)=>je===V){let je=!0,V;return this.f.push(W=>{const J=je||!Ae(W,V);return je=!1,V=W,J?W:ce}),this}evaluate(Ae){for(const je of this.f)if(Ae=je(Ae),Ae===ce)break;return Ae}}function se(Ie,Ae,je=V=>V){const V=(...he)=>Z.fire(je(...he)),W=()=>Ie.on(Ae,V),J=()=>Ie.removeListener(Ae,V),Z=new f({onWillAddFirstListener:W,onDidRemoveLastListener:J});return Z.event}T.fromNodeEventEmitter=se;function ue(Ie,Ae,je=V=>V){const V=(...he)=>Z.fire(je(...he)),W=()=>Ie.addEventListener(Ae,V),J=()=>Ie.removeEventListener(Ae,V),Z=new f({onWillAddFirstListener:W,onDidRemoveLastListener:J});return Z.event}T.fromDOMEventEmitter=ue;function Q(Ie){return new Promise(Ae=>j(Ie)(Ae))}T.toPromise=Q;function re(Ie){const Ae=new f;return Ie.then(je=>{Ae.fire(je)},()=>{Ae.fire(void 0)}).finally(()=>{Ae.dispose()}),Ae.event}T.fromPromise=re;function $e(Ie,Ae,je){return Ae(je),Ie(V=>Ae(V))}T.runAndSubscribe=$e;class we{constructor(Ae,je){this._observable=Ae,this.f=0,this.g=!1;const V={onWillAddFirstListener:()=>{Ae.addObserver(this)},onDidRemoveLastListener:()=>{Ae.removeObserver(this)}};je||F(V),this.emitter=new f(V),je&&je.add(this.emitter)}beginUpdate(Ae){this.f++}handlePossibleChange(Ae){}handleChange(Ae,je){this.g=!0}endUpdate(Ae){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ne(Ie,Ae){return new we(Ie,Ae).emitter.event}T.fromObservable=Ne;function Se(Ie){return(Ae,je,V)=>{let W=0,J=!1;const Z={beginUpdate(){W++},endUpdate(){W--,W===0&&(Ie.reportChanges(),J&&(J=!1,Ae.call(je)))},handlePossibleChange(){},handleChange(){J=!0}};Ie.addObserver(Z),Ie.reportChanges();const he={dispose(){Ie.removeObserver(Z)}};return V instanceof M.$Tc?V.add(he):Array.isArray(V)&&V.push(he),he}}T.fromObservableLight=Se})(I||(e.Event=I={}));class P{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${P.f++}`,P.all.add(this)}start(F){this.g=new R.$be,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$de=P;let p=-1;function E(T){const F=p;return p=T,{dispose(){p=F}}}class v{constructor(F,N,j=Math.random().toString(18).slice(2,5)){this.h=F,this.threshold=N,this.name=j,this.g=0}dispose(){this.f?.clear()}check(F,N){const j=this.threshold;if(j<=0||N<j)return;this.f||(this.f=new Map);const B=this.f.get(F.value)||0;if(this.f.set(F.value,B+1),this.g-=1,this.g<=0){this.g=j*.5;const[X,ie]=this.getMostFrequentStack(),H=`[${this.name}] potential listener LEAK detected, having ${N} listeners already. MOST frequent listener (${ie}):`;console.warn(H),console.warn(X);const K=new h(H,X);this.h(K)}return()=>{const X=this.f.get(F.value)||0;this.f.set(F.value,X-1)}}getMostFrequentStack(){if(!this.f)return;let F,N=0;for(const[j,B]of this.f)(!F||N<B)&&(F=[j,B],N=B);return F}}class d{static create(){const F=new Error;return new d(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h extends Error{constructor(F,N){super(F),this.name="ListenerLeakError",this.stack=N}}e.$fe=h;class c extends Error{constructor(F,N){super(F),this.name="ListenerRefusalError",this.stack=N}}e.$ge=c;let i=0;class n{constructor(F){this.value=F,this.id=i++}}const a=2,r=(T,F)=>{if(T instanceof n)F(T);else for(let N=0;N<T.length;N++){const j=T[N];j&&F(j)}},t=w?new FinalizationRegistry(T=>{typeof T=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(T))}):void 0;class f{constructor(F){this.w=0,this.f=F,this.g=p>0||this.f?.leakWarningThreshold?new v(F?.onListenerError??l.$1,this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const F=this.t;queueMicrotask(()=>{r(F,N=>N.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,N,j)=>{if(this.g&&this.w>this.g.threshold*3){const K=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w}/${this.g.threshold})`;console.warn(K);const x=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],_=new c(`${K}. HINT: Stack shows most frequent listener (${x[1]}-times)`,x[0]);return(this.f?.onListenerError||l.$1)(_),M.$Uc.None}if(this.m)return M.$Uc.None;N&&(F=F.bind(N));const B=new n(F);let X,ie;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(B.stack=d.create(),X=this.g.check(B.stack,this.w+1)),$&&(B.stack=ie??d.create()),this.t?this.t instanceof n?(this.u??=new s,this.t=[this.t,B]):this.t.push(B):(this.f?.onWillAddFirstListener?.(this),this.t=B,this.f?.onDidAddFirstListener?.(this)),this.w++;const H=(0,M.$Sc)(()=>{t?.unregister(H),X?.(),this.x(B)});if(j instanceof M.$Tc?j.add(H):Array.isArray(j)&&j.push(H),t){const K=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(H,K,H)}return H},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const N=this.t,j=N.indexOf(F);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,N[j]=void 0;const B=this.u.current===this;if(this.w*a<=N.length){let X=0;for(let ie=0;ie<N.length;ie++)N[ie]?N[X++]=N[ie]:B&&(this.u.end--,X<this.u.i&&this.u.i--);N.length=X}}y(F,N){if(!F)return;const j=this.f?.onListenerError||l.$1;if(!j){F.value(N);return}try{F.value(N)}catch(B){j(B)}}z(F){const N=F.current.t;for(;F.i<F.end;)this.y(N[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof n)this.y(this.t,F);else{const N=this.u;N.enqueue(this,F,this.t.length),this.z(N)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=f;const o=()=>new s;e.$ie=o;class s{constructor(){this.i=-1,this.end=0}enqueue(F,N,j){this.i=0,this.end=j,this.current=F,this.value=N}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class u extends f{async fireAsync(F,N,j){if(this.t)for(this.h||(this.h=new A.$5c),r(this.t,B=>this.h.push([B.value,F]));this.h.size>0&&!N.isCancellationRequested;){const[B,X]=this.h.shift(),ie=[],H={...X,token:N,waitUntil:K=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");j&&(K=j(K,B)),ie.push(K)}};try{B(H)}catch(K){(0,l.$1)(K);continue}Object.freeze(ie),await Promise.allSettled(ie).then(K=>{for(const x of K)x.status==="rejected"&&(0,l.$1)(x.reason)})}}}e.$je=u;class g extends f{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new A.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ke=g;class b extends g{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$le=b;class S extends f{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(N=>super.fire(N)),this.h=[]}))}}e.$me=S;class m{constructor(){this.g=!1,this.h=[],this.f=new f({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const N={event:F,listener:null};this.h.push(N),this.g&&this.m(N);const j=()=>{this.g&&this.o(N);const B=this.h.indexOf(N);this.h.splice(B,1)};return(0,M.$Sc)((0,L.$db)(j))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(N=>this.f.fire(N))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$ne=m;class y{constructor(F,N,j,B){this.f=new M.$Tc;const X=this.f.add(new m),ie=this.f.add(new M.$4c);function H(K){ie.set(K,X.add(B(K)))}for(const K of F)H(K);this.f.add(N(K=>{H(K)})),this.f.add(j(K=>{ie.deleteAndDispose(K)})),this.event=X.event}dispose(){this.f.dispose()}}e.$oe=y;class D{constructor(){this.f=[]}wrapEvent(F,N,j){return(B,X,ie)=>F(H=>{const K=this.f[this.f.length-1];if(!N){K?K.buffers.push(()=>B.call(X,H)):B.call(X,H);return}const x=K;if(!x){B.call(X,N(j,H));return}x.items??=[],x.items.push(H),x.buffers.length===0&&K.buffers.push(()=>{x.reducedResult??=j?x.items.reduce(N,j):x.items.reduce(N),B.call(X,x.reducedResult)})},void 0,ie)}bufferEvents(F){const N={buffers:new Array};this.f.push(N);const j=F();return this.f.pop(),N.buffers.forEach(B=>B()),j}}e.$pe=D;class C{constructor(){this.f=!1,this.g=I.None,this.h=M.$Uc.None,this.j=new f({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=C;class O{static const(F){return new z(F)}constructor(F){this.g=F,this.f=new f,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$re=O;class z{constructor(F){this.value=F,this.onDidChange=I.None}}}),define(ke[21],De([1,0,4]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=w;const L=Object.freeze(function($,k){const I=setTimeout($.bind(k),0);return{dispose(){clearTimeout(I)}}});var M;(function($){function k(I){return I===$.None||I===$.Cancelled||I instanceof A?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}$.isCancellationToken=k,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(M||(e.CancellationToken=M={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new l.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=M.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=M.None}}e.$se=R;function w($){const k=new R;return $.add({dispose(){k.cancel()}}),k.token}}),define(ke[173],De([1,0,21]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=M;class L{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new l.$se,k=this.b($.token);return this.a={promise:k,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$5e=L;function M(w){return w}class A{constructor($,k){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=M):(this.c=k,this.d=$.getCacheKey)}get($){const k=this.d($);return this.b!==k&&(this.b=k,this.a=this.c($)),this.a}}e.$7e=A;class R{get cachedValues(){return this.a}constructor($,k){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=M):(this.c=k,this.d=$.getCacheKey)}get($){const k=this.d($);if(this.b.has(k))return this.b.get(k);const I=this.c($);return this.a.set($,I),this.b.set(k,I),I}}e.$8e=R}),define(ke[98],De([1,0,13,3]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=M,e.$ve=A,e.$we=R,e.$xe=w,e.$ye=k,e.$ze=I,e.$Ae=P,e.$Be=p,e.$Ce=E,e.$De=v,e.$Ee=d,e.$Fe=h,e.$Ge=c,e.$He=i,e.$Ie=n;function M(a){const r=a;return r?typeof r.read=="function":!1}function A(a){const r=a;return r?[r.on,r.pause,r.resume,r.destroy].every(t=>typeof t=="function"):!1}function R(a){const r=a;return r?A(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}function w(a,r){return new $(a,r)}class ${constructor(r,t){this.e=r,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(r){if(!this.a.destroyed){if(this.a.flowing)this.g(r);else if(this.b.data.push(r),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(r){this.a.destroyed||(this.a.flowing?this.h(r):this.b.error.push(r))}end(r){this.a.destroyed||(typeof r<"u"&&this.write(r),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(r){this.c.data.slice(0).forEach(t=>t(r))}h(r){this.c.error.length===0?(0,l.$1)(r):this.c.error.slice(0).forEach(t=>t(r))}i(){this.c.end.slice(0).forEach(r=>r())}on(r,t){if(!this.a.destroyed)switch(r){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(r,t){if(this.a.destroyed)return;let f;switch(r){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const o=f.indexOf(t);o>=0&&f.splice(o,1)}}j(){if(this.b.data.length>0){const r=this.e(this.b.data);this.g(r),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const r of this.b.error)this.h(r);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(a,r){const t=[];let f;for(;(f=a.read())!==null;)t.push(f);return r(t)}function I(a,r,t){const f=[];let o;for(;(o=a.read())!==null&&f.length<t;)f.push(o);return o===null&&f.length>0?r(f):{read:()=>{if(f.length>0)return f.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return a.read()}}}function P(a,r){return new Promise((t,f)=>{const o=[];p(a,{onData:s=>{r&&o.push(s)},onError:s=>{r?f(s):t(void 0)},onEnd:()=>{t(r?r(o):void 0)}})})}function p(a,r,t){a.on("error",f=>{t?.isCancellationRequested||r.onError(f)}),a.on("end",()=>{t?.isCancellationRequested||r.onEnd()}),a.on("data",f=>{t?.isCancellationRequested||r.onData(f)})}function E(a,r){return new Promise((t,f)=>{const o=new L.$Tc,s=[],u=S=>{if(s.push(S),s.length>r)return o.dispose(),a.pause(),t({stream:a,buffer:s,ended:!1})},g=S=>(o.dispose(),f(S)),b=()=>(o.dispose(),t({stream:a,buffer:s,ended:!0}));o.add((0,L.$Sc)(()=>a.removeListener("error",g))),a.on("error",g),o.add((0,L.$Sc)(()=>a.removeListener("end",b))),a.on("end",b),o.add((0,L.$Sc)(()=>a.removeListener("data",u))),a.on("data",u)})}function v(a,r){const t=w(r);return t.end(a),t}function d(){const a=w(()=>{throw new Error("not supported")});return a.end(),a}function h(a){let r=!1;return{read:()=>r?null:(r=!0,a)}}function c(a,r,t){const f=w(t);return p(a,{onData:o=>f.write(r.data(o)),onError:o=>f.error(r.error?r.error(o):o),onEnd:()=>f.end()}),f}function i(a,r,t){let f=!1;return{read:()=>{const o=r.read();return f?o:(f=!0,o!==null?t([a,o]):a)}}}function n(a,r,t){let f=!1;const o=w(t);return p(r,{onData:s=>f?o.write(s):(f=!0,o.write(t([a,s]))),onError:s=>o.error(s),onEnd:()=>{f||(f=!0,o.write(a)),o.end()}}),o}}),define(ke[22],De([1,0,46,98]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=k,e.$Le=I,e.$Me=P,e.$Ne=p,e.$Oe=E,e.$Pe=v,e.$Qe=d,e.$Re=h,e.$Se=c,e.$Te=i,e.$Ue=n,e.$Ve=a,e.$We=r,e.$Xe=t,e.$Ye=f,e.$Ze=o,e.$1e=s,e.$2e=u,e.$3e=g,e.$4e=m;const M=typeof Buffer<"u",A=new l.$V(()=>new Uint8Array(256));let R,w;class ${static alloc(D){return M?new $(Buffer.allocUnsafe(D)):new $(new Uint8Array(D))}static wrap(D){return M&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new $(D)}static fromString(D,C){return!(C?.dontUseNodeBuffer||!1)&&M?new $(Buffer.from(D)):(R||(R=new TextEncoder),new $(R.encode(D)))}static fromByteArray(D){const C=$.alloc(D.length);for(let O=0,z=D.length;O<z;O++)C.buffer[O]=D[O];return C}static concat(D,C){if(typeof C>"u"){C=0;for(let T=0,F=D.length;T<F;T++)C+=D[T].byteLength}const O=$.alloc(C);let z=0;for(let T=0,F=D.length;T<F;T++){const N=D[T];O.set(N,z),z+=N.byteLength}return O}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=$.alloc(this.byteLength);return D.set(this),D}toString(){return M?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(D,C){return new $(this.buffer.subarray(D,C))}set(D,C){if(D instanceof $)this.buffer.set(D.buffer,C);else if(D instanceof Uint8Array)this.buffer.set(D,C);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),C);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return p(this.buffer,D)}writeUInt32BE(D,C){E(this.buffer,D,C)}readUInt32LE(D){return v(this.buffer,D)}writeUInt32LE(D,C){d(this.buffer,D,C)}readUInt8(D){return h(this.buffer,D)}writeUInt8(D,C){c(this.buffer,D,C)}indexOf(D,C=0){return k(this.buffer,D instanceof $?D.buffer:D,C)}}e.$Je=$;function k(y,D,C=0){const O=D.byteLength,z=y.byteLength;if(O===0)return 0;if(O===1)return y.indexOf(D[0]);if(O>z-C)return-1;const T=A.value;T.fill(D.length);for(let B=0;B<D.length;B++)T[D[B]]=D.length-B-1;let F=C+D.length-1,N=F,j=-1;for(;F<z;)if(y[F]===D[N]){if(N===0){j=F;break}F--,N--}else F+=Math.max(D.length-N,T[y[F]]),N=D.length-1;return j}function I(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0}function P(y,D,C){y[C+0]=D&255,D=D>>>8,y[C+1]=D&255}function p(y,D){return y[D]*2**24+y[D+1]*2**16+y[D+2]*2**8+y[D+3]}function E(y,D,C){y[C+3]=D,D=D>>>8,y[C+2]=D,D=D>>>8,y[C+1]=D,D=D>>>8,y[C]=D}function v(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0|y[D+2]<<16>>>0|y[D+3]<<24>>>0}function d(y,D,C){y[C+0]=D&255,D=D>>>8,y[C+1]=D&255,D=D>>>8,y[C+2]=D&255,D=D>>>8,y[C+3]=D&255}function h(y,D){return y[D]}function c(y,D,C){y[C]=D}function i(y){return L.$ye(y,D=>$.concat(D))}function n(y){return L.$Fe(y)}function a(y){return L.$Ae(y,D=>$.concat(D))}async function r(y){return y.ended?$.concat(y.buffer):$.concat([...y.buffer,await a(y.stream)])}function t(y){return L.$De(y,D=>$.concat(D))}function f(y){return L.$Ge(y,{data:D=>typeof D=="string"?$.fromString(D):$.wrap(D)},D=>$.concat(D))}function o(y){return L.$xe(D=>$.concat(D),y)}function s(y,D){return L.$He(y,D,C=>$.concat(C))}function u(y,D){return L.$Ie(y,D,C=>$.concat(C))}function g(y){let D=0,C=0,O=0;const z=new Uint8Array(Math.floor(y.length/4*3)),T=N=>{switch(C){case 3:z[O++]=D|N,C=0;break;case 2:z[O++]=D|N>>>2,D=N<<6,C=3;break;case 1:z[O++]=D|N>>>4,D=N<<4,C=2;break;default:D=N<<2,C=1}};for(let N=0;N<y.length;N++){const j=y.charCodeAt(N);if(j>=65&&j<=90)T(j-65);else if(j>=97&&j<=122)T(j-97+26);else if(j>=48&&j<=57)T(j-48+52);else if(j===43||j===45)T(62);else if(j===47||j===95)T(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${y[N]}`)}}const F=O;for(;C>0;)T(0);return $.wrap(z).slice(0,F)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:y},D=!0,C=!1){const O=C?S:b;let z="";const T=y.byteLength%3;let F=0;for(;F<y.byteLength-T;F+=3){const N=y[F+0],j=y[F+1],B=y[F+2];z+=O[N>>>2],z+=O[(N<<4|j>>>4)&63],z+=O[(j<<2|B>>>6)&63],z+=O[B&63]}if(T===1){const N=y[F+0];z+=O[N>>>2],z+=O[N<<4&63],D&&(z+="==")}else if(T===2){const N=y[F+0],j=y[F+1];z+=O[N>>>2],z+=O[(N<<4|j>>>4)&63],z+=O[j<<2&63],D&&(z+="=")}return z}}),define(ke[14],De([1,0,173,46]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=M,e.$_e=R,e.$af=$,e.$bf=k,e.$cf=I,e.$df=P,e.$ef=p,e.$ff=E,e.$gf=v,e.$hf=d,e.$if=h,e.$jf=c,e.$kf=i,e.$lf=n,e.$mf=a,e.$nf=r,e.$of=t,e.$pf=f,e.$qf=o,e.$rf=s,e.$sf=u,e.$tf=g,e.$uf=b,e.$vf=S,e.$wf=m,e.$xf=y,e.$yf=D,e.$zf=C,e.$Af=O,e.$Bf=z,e.$Cf=T,e.$Df=F,e.$Ef=N,e.$Ff=j,e.$Gf=B,e.$Hf=X,e.$If=ie,e.$Lf=_,e.$Mf=ge,e.$Nf=oe,e.$Of=Pe,e.$Pf=Y,e.$Qf=ce,e.$Sf=ae,e.$Tf=se,e.$Uf=ue,e.$Vf=Q,e.$Wf=$e,e.$Xf=we,e.$Yf=Se,e.$1f=Ie,e.$2f=Ae,e.$3f=je,e.$4f=V,e.$5f=W,e.$6f=J,e.$7f=Z,e.$8f=he,e.$9f=tt;function M(Re){return!Re||typeof Re!="string"?!0:Re.trim().length===0}const A=/{(\d+)}/g;function R(Re,...ve){return ve.length===0?Re:Re.replace(A,function(qe,te){const ne=parseInt(te,10);return isNaN(ne)||ne<0||ne>=ve.length?qe:ve[ne]})}const w=/{([^}]+)}/g;function $(Re,ve){return Object.keys(ve).length===0?Re:Re.replace(w,(qe,te)=>ve[te]??qe)}function k(Re){return Re.replace(/[<>"'&]/g,ve=>{switch(ve){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ve})}function I(Re){return Re.replace(/[<>&]/g,function(ve){switch(ve){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ve}})}function P(Re){return Re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(Re,ve){let qe=0,te=Re.indexOf(ve);for(;te!==-1;)qe++,te=Re.indexOf(ve,te+ve.length);return qe}function E(Re,ve,qe="\u2026"){return Re.length<=ve?Re:`${Re.substr(0,ve)}${qe}`}function v(Re,ve,qe="\u2026"){if(Re.length<=ve)return Re;const te=Math.ceil(ve/2)-qe.length/2,ne=Math.floor(ve/2)-qe.length/2;return`${Re.substr(0,te)}${qe}${Re.substr(Re.length-ne)}`}function d(Re,ve=" "){const qe=h(Re,ve);return c(qe,ve)}function h(Re,ve){if(!Re||!ve)return Re;const qe=ve.length;if(qe===0||Re.length===0)return Re;let te=0;for(;Re.indexOf(ve,te)===te;)te=te+qe;return Re.substring(te)}function c(Re,ve){if(!Re||!ve)return Re;const qe=ve.length,te=Re.length;if(qe===0||te===0)return Re;let ne=te,Ce=-1;for(;Ce=Re.lastIndexOf(ve,ne-1),!(Ce===-1||Ce+qe!==ne);){if(Ce===0)return"";ne=Ce}return Re.substring(0,ne)}function i(Re){return Re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(Re){return Re.replace(/\*/g,"")}function a(Re,ve,qe={}){if(!Re)throw new Error("Cannot create regex from empty string");ve||(Re=P(Re)),qe.wholeWord&&(/\B/.test(Re.charAt(0))||(Re="\\b"+Re),/\B/.test(Re.charAt(Re.length-1))||(Re=Re+"\\b"));let te="";return qe.global&&(te+="g"),qe.matchCase||(te+="i"),qe.multiline&&(te+="m"),qe.unicode&&(te+="u"),new RegExp(Re,te)}function r(Re){return Re.source==="^"||Re.source==="^$"||Re.source==="$"||Re.source==="^\\s*$"?!1:!!(Re.exec("")&&Re.lastIndex===0)}function t(Re){return Re.split(/\r\n|\r|\n/)}function f(Re){const ve=[],qe=Re.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(qe.length/2);te++)ve.push(qe[2*te]+(qe[2*te+1]??""));return ve}function o(Re){for(let ve=0,qe=Re.length;ve<qe;ve++){const te=Re.charCodeAt(ve);if(te!==32&&te!==9)return ve}return-1}function s(Re,ve=0,qe=Re.length){for(let te=ve;te<qe;te++){const ne=Re.charCodeAt(te);if(ne!==32&&ne!==9)return Re.substring(ve,te)}return Re.substring(ve,qe)}function u(Re,ve=Re.length-1){for(let qe=ve;qe>=0;qe--){const te=Re.charCodeAt(qe);if(te!==32&&te!==9)return qe}return-1}function g(Re,ve,qe){const te=[];let ne=0;for(const Ce of Re.matchAll(ve)){if(te.push(Re.slice(ne,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");ne=Ce.index+Ce[0].length,te.push(qe(Ce[0],...Ce.slice(1),Ce.index,Re,Ce.groups))}return te.push(Re.slice(ne)),Promise.all(te).then(Ce=>Ce.join(""))}function b(Re,ve){return Re<ve?-1:Re>ve?1:0}function S(Re,ve,qe=0,te=Re.length,ne=0,Ce=ve.length){for(;qe<te&&ne<Ce;qe++,ne++){const st=Re.charCodeAt(qe),ut=ve.charCodeAt(ne);if(st<ut)return-1;if(st>ut)return 1}const Ge=te-qe,Me=Ce-ne;return Ge<Me?-1:Ge>Me?1:0}function m(Re,ve){return y(Re,ve,0,Re.length,0,ve.length)}function y(Re,ve,qe=0,te=Re.length,ne=0,Ce=ve.length){for(;qe<te&&ne<Ce;qe++,ne++){let st=Re.charCodeAt(qe),ut=ve.charCodeAt(ne);if(st===ut)continue;if(st>=128||ut>=128)return S(Re.toLowerCase(),ve.toLowerCase(),qe,te,ne,Ce);C(st)&&(st-=32),C(ut)&&(ut-=32);const $t=st-ut;if($t!==0)return $t}const Ge=te-qe,Me=Ce-ne;return Ge<Me?-1:Ge>Me?1:0}function D(Re){return Re>=48&&Re<=57}function C(Re){return Re>=97&&Re<=122}function O(Re){return Re>=65&&Re<=90}function z(Re,ve){return Re.length===ve.length&&y(Re,ve)===0}function T(Re,ve){const qe=ve.length;return ve.length>Re.length?!1:y(Re,ve,0,qe)===0}function F(Re,ve){const qe=Math.min(Re.length,ve.length);let te;for(te=0;te<qe;te++)if(Re.charCodeAt(te)!==ve.charCodeAt(te))return te;return qe}function N(Re,ve){const qe=Math.min(Re.length,ve.length);let te;const ne=Re.length-1,Ce=ve.length-1;for(te=0;te<qe;te++)if(Re.charCodeAt(ne-te)!==ve.charCodeAt(Ce-te))return te;return qe}function j(Re){return 55296<=Re&&Re<=56319}function B(Re){return 56320<=Re&&Re<=57343}function X(Re,ve){return(Re-55296<<10)+(ve-56320)+65536}function ie(Re,ve,qe){const te=Re.charCodeAt(qe);if(j(te)&&qe+1<ve){const ne=Re.charCodeAt(qe+1);if(B(ne))return X(te,ne)}return te}function H(Re,ve){const qe=Re.charCodeAt(ve-1);if(B(qe)&&ve>1){const te=Re.charCodeAt(ve-2);if(j(te))return X(te,qe)}return qe}class K{get offset(){return this.e}constructor(ve,qe=0){this.c=ve,this.d=ve.length,this.e=qe}setOffset(ve){this.e=ve}prevCodePoint(){const ve=H(this.c,this.e);return this.e-=ve>=65536?2:1,ve}nextCodePoint(){const ve=ie(this.c,this.d,this.e);return this.e+=ve>=65536?2:1,ve}eol(){return this.e>=this.d}}e.$Jf=K;class x{get offset(){return this.c.offset}constructor(ve,qe=0){this.c=new K(ve,qe)}nextGraphemeLength(){const ve=Ve.getInstance(),qe=this.c,te=qe.offset;let ne=ve.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const Ce=qe.offset,Ge=ve.getGraphemeBreakType(qe.nextCodePoint());if(be(ne,Ge)){qe.setOffset(Ce);break}ne=Ge}return qe.offset-te}prevGraphemeLength(){const ve=Ve.getInstance(),qe=this.c,te=qe.offset;let ne=ve.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const Ce=qe.offset,Ge=ve.getGraphemeBreakType(qe.prevCodePoint());if(be(Ge,ne)){qe.setOffset(Ce);break}ne=Ge}return te-qe.offset}eol(){return this.c.eol()}}e.$Kf=x;function _(Re,ve){return new x(Re,ve).nextGraphemeLength()}function ge(Re,ve){return new x(Re,ve).prevGraphemeLength()}function oe(Re,ve){ve>0&&B(Re.charCodeAt(ve))&&ve--;const qe=ve+_(Re,ve);return[qe-ge(Re,qe),qe]}function Pe(Re){const ve=new x(Re);let qe=0;for(;!ve.eol();)qe++,ve.nextGraphemeLength();return qe}let me;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Y(Re){return me||(me=U()),me.test(Re)}const pe=/^[\t\n\r\x20-\x7E]*$/;function ce(Re){return pe.test(Re)}e.$Rf=/[\u2028\u2029]/;function ae(Re){return e.$Rf.test(Re)}function se(Re){return Re>=11904&&Re<=55215||Re>=63744&&Re<=64255||Re>=65281&&Re<=65374}function ue(Re){return Re>=127462&&Re<=127487||Re===8986||Re===8987||Re===9200||Re===9203||Re>=9728&&Re<=10175||Re===11088||Re===11093||Re>=127744&&Re<=128591||Re>=128640&&Re<=128764||Re>=128992&&Re<=129008||Re>=129280&&Re<=129535||Re>=129648&&Re<=129782}function Q(Re,ve,qe=""){const te=Re.trimStart();if(te.length<ve)return te;const ne=/\b/g;let Ce=0;for(;ne.test(te)&&!(te.length-ne.lastIndex<ve);)Ce=ne.lastIndex,ne.lastIndex+=1;return Ce===0?te:qe+te.substring(Ce).trimStart()}const re=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*$e(Re){let ve=0;for(const qe of Re.matchAll(re))ve!==qe.index&&(yield{isCode:!1,str:Re.substring(ve,qe.index)}),yield{isCode:!0,str:qe[0]},ve=qe.index+qe[0].length;ve!==Re.length&&(yield{isCode:!1,str:Re.substring(ve)})}function we(Re){return Re&&(Re=Re.replace(re,"")),Re}const Ne=/\\\[.*?\\\]/g;function Se(Re){return we(Re).replace(Ne,"")}e.$Zf="\uFEFF";function Ie(Re){return!!(Re&&Re.length>0&&Re.charCodeAt(0)===65279)}function Ae(Re){return Ie(Re)?Re.substr(1):Re}function je(Re,ve){if(!Re||!ve||Re.length<ve.length)return!1;const qe=ve.length,te=Re.toLowerCase();let ne=0,Ce=-1;for(;ne<qe;){const Ge=te.indexOf(ve[ne],Ce+1);if(Ge<0)return!1;Ce=Ge,ne++}return!0}function V(Re,ve=!1){return Re?(ve&&(Re=Re.replace(/\\./g,"")),Re.toLowerCase()!==Re):!1}function W(Re){return Re.charAt(0).toUpperCase()+Re.slice(1)}function J(Re,ve=1){if(ve===0)return"";let qe=-1;do qe=Re.indexOf(`
`,qe+1),ve--;while(ve>0&&qe>=0);return qe===-1?Re:(Re[qe-1]==="\r"&&qe--,Re.substr(0,qe))}function Z(Re){return Re=Re%(2*26),Re<26?String.fromCharCode(97+Re):String.fromCharCode(65+Re-26)}function he(Re){return Ve.getInstance().getGraphemeBreakType(Re)}function be(Re,ve){return Re===0?ve!==5&&ve!==7:Re===2&&ve===3?!1:Re===4||Re===2||Re===3||ve===4||ve===2||ve===3?!0:!(Re===8&&(ve===8||ve===9||ve===11||ve===12)||(Re===11||Re===9)&&(ve===9||ve===10)||(Re===12||Re===10)&&ve===10||ve===5||ve===13||ve===7||Re===1||Re===13&&ve===14||Re===6&&ve===6)}var Fe;(function(Re){Re[Re.Other=0]="Other",Re[Re.Prepend=1]="Prepend",Re[Re.CR=2]="CR",Re[Re.LF=3]="LF",Re[Re.Control=4]="Control",Re[Re.Extend=5]="Extend",Re[Re.Regional_Indicator=6]="Regional_Indicator",Re[Re.SpacingMark=7]="SpacingMark",Re[Re.L=8]="L",Re[Re.V=9]="V",Re[Re.T=10]="T",Re[Re.LV=11]="LV",Re[Re.LVT=12]="LVT",Re[Re.ZWJ=13]="ZWJ",Re[Re.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(e.GraphemeBreakType=Fe={}));class Ve{static{this.c=null}static getInstance(){return Ve.c||(Ve.c=new Ve),Ve.c}constructor(){this.d=Qe()}getGraphemeBreakType(ve){if(ve<32)return ve===10?3:ve===13?2:4;if(ve<127)return 0;const qe=this.d,te=qe.length/3;let ne=1;for(;ne<=te;)if(ve<qe[3*ne])ne=2*ne;else if(ve>qe[3*ne+1])ne=2*ne+1;else return qe[3*ne+2];return 0}}function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(Re,ve){if(Re===0)return 0;const qe=_e(Re,ve);if(qe!==void 0)return qe;const te=new K(ve,Re);return te.prevCodePoint(),te.offset}function _e(Re,ve){const qe=new K(ve,Re);let te=qe.prevCodePoint();for(;nt(te)||te===65039||te===8419;){if(qe.offset===0)return;te=qe.prevCodePoint()}if(!ue(te))return;let ne=qe.offset;return ne>0&&qe.prevCodePoint()===8205&&(ne=qe.offset),ne}function nt(Re){return 127995<=Re&&Re<=127999}var it;(function(Re){Re[Re.zwj=8205]="zwj",Re[Re.emojiVariantSelector=65039]="emojiVariantSelector",Re[Re.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.$0f="\xA0";class rt{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new l.$7e({getCacheKey:JSON.stringify},ve=>{function qe($t){const Ct=new Map;for(let Pt=0;Pt<$t.length;Pt+=2)Ct.set($t[Pt],$t[Pt+1]);return Ct}function te($t,Ct){const Pt=new Map($t);for(const[Ut,Bt]of Ct)Pt.set(Ut,Bt);return Pt}function ne($t,Ct){if(!$t)return Ct;const Pt=new Map;for(const[Ut,Bt]of $t)Ct.has(Ut)&&Pt.set(Ut,Bt);return Pt}const Ce=this.c.value;let Ge=ve.filter($t=>!$t.startsWith("_")&&$t in Ce);Ge.length===0&&(Ge=["_default"]);let Me;for(const $t of Ge){const Ct=qe(Ce[$t]);Me=ne(Me,Ct)}const st=qe(Ce._common),ut=te(st,Me);return new rt(ut)})}static getInstance(ve){return rt.d.get(Array.from(ve))}static{this.e=new L.$V(()=>Object.keys(rt.c.value).filter(ve=>!ve.startsWith("_")))}static getLocales(){return rt.e.value}constructor(ve){this.f=ve}isAmbiguous(ve){return this.f.has(ve)}containsAmbiguousCharacter(ve){for(let qe=0;qe<ve.length;qe++){const te=ve.codePointAt(qe);if(typeof te=="number"&&this.isAmbiguous(te))return!0}return!1}getPrimaryConfusable(ve){return this.f.get(ve)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=rt;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(ve){return at.e().has(ve)}static containsInvisibleCharacter(ve){for(let qe=0;qe<ve.length;qe++){const te=ve.codePointAt(qe);if(typeof te=="number"&&at.isInvisibleCharacter(te))return!0}return!1}static get codePoints(){return at.e()}}e.$_f=at}),define(ke[127],De([1,0,27,168,14]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=A,e.$Dk=w,e.$Ek=$,e.$Fk=P,e.$Gk=g,e.$Hk=b,e.$Ik=O,e.$Jk=z,e.$Kk=T,e.$Lk=F,e.$Mk=Y,e.$Ok=se,e.$Pk=re,e.$Qk=$e;function A(...Se){return function(Ie,Ae){for(let je=0,V=Se.length;je<V;je++){const W=Se[je](Ie,Ae);if(W)return W}return null}}e.$Bk=R.bind(void 0,!1),e.$Ck=R.bind(void 0,!0);function R(Se,Ie,Ae){if(!Ae||Ae.length<Ie.length)return null;let je;return Se?je=M.$Cf(Ae,Ie):je=Ae.indexOf(Ie)===0,je?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function w(Se,Ie){const Ae=Ie.toLowerCase().indexOf(Se.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+Se.length}]}function $(Se,Ie){return k(Se.toLowerCase(),Ie.toLowerCase(),0,0)}function k(Se,Ie,Ae,je){if(Ae===Se.length)return[];if(je===Ie.length)return null;if(Se[Ae]===Ie[je]){let V=null;return(V=k(Se,Ie,Ae+1,je+1))?a({start:je,end:je+1},V):null}return k(Se,Ie,Ae,je+1)}function I(Se){return 97<=Se&&Se<=122}function P(Se){return 65<=Se&&Se<=90}function p(Se){return 48<=Se&&Se<=57}function E(Se){return Se===32||Se===9||Se===10||Se===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Se=>v.add(Se.charCodeAt(0)));function d(Se){return E(Se)||v.has(Se)}function h(Se,Ie){return Se===Ie||d(Se)&&d(Ie)}const c=new Map;function i(Se){if(c.has(Se))return c.get(Se);let Ie;const Ae=(0,L.$zk)(Se);return Ae&&(Ie=Ae),c.set(Se,Ie),Ie}function n(Se){return I(Se)||P(Se)||p(Se)}function a(Se,Ie){return Ie.length===0?Ie=[Se]:Se.end===Ie[0].start?Ie[0].start=Se.start:Ie.unshift(Se),Ie}function r(Se,Ie){for(let Ae=Ie;Ae<Se.length;Ae++){const je=Se.charCodeAt(Ae);if(P(je)||p(je)||Ae>0&&!n(Se.charCodeAt(Ae-1)))return Ae}return Se.length}function t(Se,Ie,Ae,je){if(Ae===Se.length)return[];if(je===Ie.length)return null;if(Se[Ae]!==Ie[je].toLowerCase())return null;{let V=null,W=je+1;for(V=t(Se,Ie,Ae+1,je+1);!V&&(W=r(Ie,W))<Ie.length;)V=t(Se,Ie,Ae+1,W),W++;return V===null?null:a({start:je,end:je+1},V)}}function f(Se){let Ie=0,Ae=0,je=0,V=0,W=0;for(let Fe=0;Fe<Se.length;Fe++)W=Se.charCodeAt(Fe),P(W)&&Ie++,I(W)&&Ae++,n(W)&&je++,p(W)&&V++;const J=Ie/Se.length,Z=Ae/Se.length,he=je/Se.length,be=V/Se.length;return{upperPercent:J,lowerPercent:Z,alphaPercent:he,numericPercent:be}}function o(Se){const{upperPercent:Ie,lowerPercent:Ae}=Se;return Ae===0&&Ie>.6}function s(Se){const{upperPercent:Ie,lowerPercent:Ae,alphaPercent:je,numericPercent:V}=Se;return Ae>.2&&Ie<.8&&je>.6&&V<.2}function u(Se){let Ie=0,Ae=0,je=0,V=0;for(let W=0;W<Se.length;W++)je=Se.charCodeAt(W),P(je)&&Ie++,I(je)&&Ae++,E(je)&&V++;return(Ie===0||Ae===0)&&V===0?Se.length<=30:Ie<=5}function g(Se,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!u(Se))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Ae=f(Ie);if(!s(Ae)){if(!o(Ae))return null;Ie=Ie.toLowerCase()}let je=null,V=0;for(Se=Se.toLowerCase();V<Ie.length&&(je=t(Se,Ie,0,V))===null;)V=r(Ie,V+1);return je}function b(Se,Ie,Ae=!1){if(!Ie||Ie.length===0)return null;let je=null,V=0;for(Se=Se.toLowerCase(),Ie=Ie.toLowerCase();V<Ie.length&&(je=S(Se,Ie,0,V,Ae),je===null);)V=m(Ie,V+1);return je}function S(Se,Ie,Ae,je,V){let W=0;if(Ae===Se.length)return[];if(je===Ie.length)return null;if(!h(Se.charCodeAt(Ae),Ie.charCodeAt(je))){const he=i(Se.charCodeAt(Ae));if(!he)return null;for(let be=0;be<he.length;be++)if(!h(he[be],Ie.charCodeAt(je+be)))return null;W+=he.length-1}let J=null,Z=je+W+1;if(J=S(Se,Ie,Ae+1,Z,V),!V)for(;!J&&(Z=m(Ie,Z))<Ie.length;)J=S(Se,Ie,Ae+1,Z,V),Z++;if(!J)return null;if(Se.charCodeAt(Ae)!==Ie.charCodeAt(je)){const he=i(Se.charCodeAt(Ae));if(!he)return J;for(let be=0;be<he.length;be++)if(he[be]!==Ie.charCodeAt(je+be))return J}return a({start:je,end:je+W+1},J)}function m(Se,Ie){for(let Ae=Ie;Ae<Se.length;Ae++)if(d(Se.charCodeAt(Ae))||Ae>0&&d(Se.charCodeAt(Ae-1)))return Ae;return Se.length}const y=A(e.$Ck,g,w),D=A(e.$Ck,g,$),C=new l.$Dc(1e4);function O(Se,Ie,Ae=!1){if(typeof Se!="string"||typeof Ie!="string")return null;let je=C.get(Se);je||(je=new RegExp(M.$kf(Se),"i"),C.set(Se,je));const V=je.exec(Ie);return V?[{start:V.index,end:V.index+V[0].length}]:Ae?D(Se,Ie):y(Se,Ie)}function z(Se,Ie){const Ae=se(Se,Se.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?F(Ae):null}function T(Se,Ie,Ae,je,V,W){const J=Math.min(13,Se.length);for(;Ae<J;Ae++){const Z=se(Se,Ie,Ae,je,V,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,W]}function F(Se){if(typeof Se>"u")return[];const Ie=[],Ae=Se[1];for(let je=Se.length-1;je>1;je--){const V=Se[je]+Ae,W=Ie[Ie.length-1];W&&W.end===V?W.end=V+1:Ie.push({start:V,end:V+1})}return Ie}const N=128;function j(){const Se=[],Ie=[];for(let Ae=0;Ae<=N;Ae++)Ie[Ae]=0;for(let Ae=0;Ae<=N;Ae++)Se.push(Ie.slice(0));return Se}function B(Se){const Ie=[];for(let Ae=0;Ae<=Se;Ae++)Ie[Ae]=0;return Ie}const X=B(2*N),ie=B(2*N),H=j(),K=j(),x=j(),_=!1;function ge(Se,Ie,Ae,je,V){function W(Z,he,be=" "){for(;Z.length<he;)Z=be+Z;return Z}let J=` |   |${je.split("").map(Z=>W(Z,3)).join("|")}
`;for(let Z=0;Z<=Ae;Z++)Z===0?J+=" |":J+=`${Ie[Z-1]}|`,J+=Se[Z].slice(0,V+1).map(he=>W(he.toString(),3)).join("|")+`
`;return J}function oe(Se,Ie,Ae,je){Se=Se.substr(Ie),Ae=Ae.substr(je),console.log(ge(K,Se,Se.length,Ae,Ae.length)),console.log(ge(x,Se,Se.length,Ae,Ae.length)),console.log(ge(H,Se,Se.length,Ae,Ae.length))}function Pe(Se,Ie){if(Ie<0||Ie>=Se.length)return!1;const Ae=Se.codePointAt(Ie);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Uf(Ae)}}function me(Se,Ie){if(Ie<0||Ie>=Se.length)return!1;switch(Se.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function U(Se,Ie,Ae){return Ie[Se]!==Ae[Se]}function Y(Se,Ie,Ae,je,V,W,J=!1){for(;Ie<Ae&&V<W;)Se[Ie]===je[V]&&(J&&(X[Ie]=V),Ie+=1),V+=1;return Ie===Ae}var pe;(function(Se){Se[Se.Diag=1]="Diag",Se[Se.Left=2]="Left",Se[Se.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var ce;(function(Se){Se.Default=[-100,0];function Ie(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}Se.isDefault=Ie})(ce||(e.FuzzyScore=ce={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Ae){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Ae}}e.$Nk=ae;function se(Se,Ie,Ae,je,V,W,J=ae.default){const Z=Se.length>N?N:Se.length,he=je.length>N?N:je.length;if(Ae>=Z||W>=he||Z-Ae>he-W||!Y(Ie,Ae,Z,V,W,he,!0))return;ue(Z,he,Ae,W,Ie,V);let be=1,Fe=1,Ve=Ae,Qe=W;const tt=[!1];for(be=1,Ve=Ae;Ve<Z;be++,Ve++){const at=X[Ve],Re=ie[Ve],ve=Ve+1<Z?ie[Ve+1]:he;for(Fe=at-W+1,Qe=at;Qe<ve;Fe++,Qe++){let qe=Number.MIN_SAFE_INTEGER,te=!1;Qe<=Re&&(qe=Q(Se,Ie,Ve,Ae,je,V,Qe,he,W,H[be-1][Fe-1]===0,tt));let ne=0;qe!==Number.MAX_SAFE_INTEGER&&(te=!0,ne=qe+K[be-1][Fe-1]);const Ce=Qe>at,Ge=Ce?K[be][Fe-1]+(H[be][Fe-1]>0?-5:0):0,Me=Qe>at+1&&H[be][Fe-1]>0,st=Me?K[be][Fe-2]+(H[be][Fe-2]>0?-5:0):0;if(Me&&(!Ce||st>=Ge)&&(!te||st>=ne))K[be][Fe]=st,x[be][Fe]=3,H[be][Fe]=0;else if(Ce&&(!te||Ge>=ne))K[be][Fe]=Ge,x[be][Fe]=2,H[be][Fe]=0;else if(te)K[be][Fe]=ne,x[be][Fe]=1,H[be][Fe]=H[be-1][Fe-1]+1;else throw new Error("not possible")}}if(_&&oe(Se,Ae,je,W),!tt[0]&&!J.firstMatchCanBeWeak)return;be--,Fe--;const _e=[K[be][Fe],W];let nt=0,it=0;for(;be>=1;){let at=Fe;do{const Re=x[be][at];if(Re===3)at=at-2;else if(Re===2)at=at-1;else break}while(at>=1);nt>1&&Ie[Ae+be-1]===V[W+Fe-1]&&!U(at+W-1,je,V)&&nt+1>H[be][at]&&(at=Fe),at===Fe?nt++:nt=1,it||(it=at),be--,Fe=at-1,_e.push(Fe)}he-W===Z&&J.boostFullMatch&&(_e[0]+=2);const rt=it-Z;return _e[0]-=rt,_e}function ue(Se,Ie,Ae,je,V,W){let J=Se-1,Z=Ie-1;for(;J>=Ae&&Z>=je;)V[J]===W[Z]&&(ie[J]=Z,J--),Z--}function Q(Se,Ie,Ae,je,V,W,J,Z,he,be,Fe){if(Ie[Ae]!==W[J])return Number.MIN_SAFE_INTEGER;let Ve=1,Qe=!1;return J===Ae-je?Ve=Se[Ae]===V[J]?7:5:U(J,V,W)&&(J===0||!U(J-1,V,W))?(Ve=Se[Ae]===V[J]?7:5,Qe=!0):Pe(W,J)&&(J===0||!Pe(W,J-1))?Ve=5:(Pe(W,J-1)||me(W,J-1))&&(Ve=5,Qe=!0),Ve>1&&Ae===je&&(Fe[0]=!0),Qe||(Qe=U(J,V,W)||Pe(W,J-1)||me(W,J-1)),Ae===je?J>he&&(Ve-=Qe?3:5):be?Ve+=Qe?2:0:Ve+=Qe?0:1,J+1===Z&&(Ve-=Qe?3:5),Ve}function re(Se,Ie,Ae,je,V,W,J){return we(Se,Ie,Ae,je,V,W,!0,J)}function $e(Se,Ie,Ae,je,V,W,J){return we(Se,Ie,Ae,je,V,W,!1,J)}function we(Se,Ie,Ae,je,V,W,J,Z){let he=se(Se,Ie,Ae,je,V,W,Z);if(he&&!J)return he;if(Se.length>=3){const be=Math.min(7,Se.length-1);for(let Fe=Ae+1;Fe<be;Fe++){const Ve=Ne(Se,Fe);if(Ve){const Qe=se(Ve,Ve.toLowerCase(),Ae,je,V,W,Z);Qe&&(Qe[0]-=3,(!he||Qe[0]>he[0])&&(he=Qe))}}}return he}function Ne(Se,Ie){if(Ie+1>=Se.length)return;const Ae=Se[Ie],je=Se[Ie+1];if(Ae!==je)return Se.slice(0,Ie)+je+Ae+Se.slice(Ie+2)}}),define(ke[58],De([1,0,14]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=L,e.$pj=M,e.$qj=A,e.$rj=w,e.$tj=d;function L(c){return M(c,0)}function M(c,i){switch(typeof c){case"object":return c===null?A(349,i):Array.isArray(c)?$(c,i):k(c,i);case"string":return w(c,i);case"boolean":return R(c,i);case"number":return A(c,i);case"undefined":return A(937,i);default:return A(617,i)}}function A(c,i){return(i<<5)-i+c|0}function R(c,i){return A(c?433:863,i)}function w(c,i){i=A(149417,i);for(let n=0,a=c.length;n<a;n++)i=A(c.charCodeAt(n),i);return i}function $(c,i){return i=A(104579,i),c.reduce((n,a)=>M(a,n),i)}function k(c,i){return i=A(181387,i),Object.keys(c).sort().reduce((n,a)=>(n=w(a,n),M(c[a],n)),i)}class I{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=M(i,this.g),this.g}}e.$sj=I;var P;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function p(c,i,n=32){const a=n-i,r=~((1<<a)-1);return(c<<i|(r&c)>>>a)>>>0}function E(c,i=0,n=c.byteLength,a=0){for(let r=0;r<n;r++)c[i+r]=a}function v(c,i,n="0"){for(;c.length<i;)c=n+c;return c}function d(c,i=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(n=>n.toString(16).padStart(2,"0")).join(""):v((c>>>0).toString(16),i/4)}class h{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const a=this.p;let r=this.r,t=this.u,f,o;for(t!==0?(f=t,o=-1,t=0):(f=i.charCodeAt(0),o=0);;){let s=f;if(l.$Ff(f))if(o+1<n){const u=i.charCodeAt(o+1);l.$Gf(u)?(o++,s=l.$Hf(f,u)):s=65533}else{t=f;break}else l.$Gf(f)&&(s=65533);if(r=this.w(a,r,s),o++,o<n)f=i.charCodeAt(o);else break}this.r=r,this.u=t}w(i,n,a){return a<128?i[n++]=a:a<2048?(i[n++]=192|(a&1984)>>>6,i[n++]=128|(a&63)>>>0):a<65536?(i[n++]=224|(a&61440)>>>12,i[n++]=128|(a&4032)>>>6,i[n++]=128|(a&63)>>>0):(i[n++]=240|(a&1835008)>>>18,i[n++]=128|(a&258048)>>>12,i[n++]=128|(a&4032)>>>6,i[n++]=128|(a&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=h.g,n=this.q;for(let b=0;b<64;b+=4)i.setUint32(b,n.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)i.setUint32(b,p(i.getUint32(b-12,!1)^i.getUint32(b-32,!1)^i.getUint32(b-56,!1)^i.getUint32(b-64,!1),1),!1);let a=this.h,r=this.l,t=this.m,f=this.n,o=this.o,s,u,g;for(let b=0;b<80;b++)b<20?(s=r&t|~r&f,u=1518500249):b<40?(s=r^t^f,u=1859775393):b<60?(s=r&t|r&f|t&f,u=2400959708):(s=r^t^f,u=3395469782),g=p(a,5)+s+o+u+i.getUint32(b*4,!1)&4294967295,o=f,f=t,t=p(r,30),r=a,a=g;this.h=this.h+a&4294967295,this.l=this.l+r&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+o&4294967295}}e.$uj=h}),define(ke[41],De([1,0,14]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(L||(L={})),function(M){const A="error",R="warning",w="warn",$="info",k="ignore";function I(p){return p?l.$Bf(A,p)?M.Error:l.$Bf(R,p)||l.$Bf(w,p)?M.Warning:l.$Bf($,p)?M.Info:M.Ignore:M.Ignore}M.fromValue=I;function P(p){switch(p){case M.Error:return A;case M.Warning:return R;case M.Info:return $;default:return k}}M.toString=P}(L||(L={})),e.default=L}),define(ke[174],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ke[78],De([1,0,19,14]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class M{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const v=E.charCodeAt(0),d=this.b.charCodeAt(this.c);return v-d}value(){return this.b[this.c]}}e.$Ci=M;class A{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,L.$vf)(E,this.b,0,E.length,this.c,this.d):(0,L.$xf)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=A;class R{constructor(E=!0,v=!0){this.f=E,this.g=v}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let v=E.length-1;v>=0;v--,this.c--){const d=this.b.charCodeAt(v);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,L.$vf)(E,this.b,0,E.length,this.d,this.e):(0,L.$xf)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=R;var w;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(w||(w={}));class ${constructor(E,v){this.f=E,this.g=v,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,L.$wf)(E,this.c.scheme);if(this.d[this.e]===2)return(0,L.$wf)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,L.$uf)(E,this.c.query);if(this.d[this.e]===5)return(0,L.$uf)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fi=$;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(I||(I={}));class P{static forUris(E=()=>!1,v=()=>!1){return new P(new $(E,v))}static forPaths(E=!1){return new P(new R(void 0,!E))}static forStrings(){return new P(new M)}static forConfigKeys(){return new P(new A)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,v){if(v){const d=v.slice(0);(0,l.$Wb)(d);for(const h of d)this.set(h,E)}else{const d=E.slice(0);(0,l.$Wb)(d);for(const h of d)this.set(h[0],h[1])}}set(E,v){const d=this.b.reset(E);let h;this.c||(this.c=new k,this.c.segment=d.value());const c=[];for(h=this.c;;){const n=d.cmp(h.segment);if(n>0)h.left||(h.left=new k,h.left.segment=d.value()),c.push([-1,h]),h=h.left;else if(n<0)h.right||(h.right=new k,h.right.segment=d.value()),c.push([1,h]),h=h.right;else if(d.hasNext())d.next(),h.mid||(h.mid=new k,h.mid.segment=d.value()),c.push([0,h]),h=h.mid;else break}const i=h.value;h.value=v,h.key=E;for(let n=c.length-1;n>=0;n--){const a=c[n][1];a.updateHeight();const r=a.balanceFactor();if(r<-1||r>1){const t=c[n][0],f=c[n+1][0];if(t===1&&f===1)c[n][1]=a.rotateLeft();else if(t===-1&&f===-1)c[n][1]=a.rotateRight();else if(t===1&&f===-1)a.right=c[n+1][1]=c[n+1][1].rotateRight(),c[n][1]=a.rotateLeft();else if(t===-1&&f===1)a.left=c[n+1][1]=c[n+1][1].rotateLeft(),c[n][1]=a.rotateRight();else throw new Error;if(n>0)switch(c[n-1][0]){case-1:c[n-1][1].left=c[n][1];break;case 1:c[n-1][1].right=c[n][1];break;case 0:c[n-1][1].mid=c[n][1];break}else this.c=c[0][1]}}return i}get(E){return this.d(E)?.value}d(E){const v=this.b.reset(E);let d=this.c;for(;d;){const h=v.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(E){const v=this.d(E);return!(v?.value===void 0&&v?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,v){const d=this.b.reset(E),h=[];let c=this.c;for(;c;){const i=d.cmp(c.segment);if(i>0)h.push([-1,c]),c=c.left;else if(i<0)h.push([1,c]),c=c.right;else if(d.hasNext())d.next(),h.push([0,c]),c=c.mid;else break}if(c){if(v?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const i=this.f(c.right);if(i.key){const{key:n,value:a,segment:r}=i;this.e(i.key,!1),c.key=n,c.value=a,c.segment=r}}else{const i=c.left??c.right;if(h.length>0){const[n,a]=h[h.length-1];switch(n){case-1:a.left=i;break;case 0:a.mid=i;break;case 1:a.right=i;break}}else this.c=i}for(let i=h.length-1;i>=0;i--){const n=h[i][1];n.updateHeight();const a=n.balanceFactor();if(a>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),h[i][1]=n.rotateLeft()):a<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),h[i][1]=n.rotateRight()),i>0)switch(h[i-1][0]){case-1:h[i-1][1].left=h[i][1];break;case 1:h[i-1][1].right=h[i][1];break;case 0:h[i-1][1].mid=h[i][1];break}else this.c=h[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const v=this.b.reset(E);let d=this.c,h;for(;d;){const c=v.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(v.hasNext())v.next(),h=d.value||h,d=d.mid;else break}return d&&d.value||h}findSuperstr(E){return this.g(E,!1)}g(E,v){const d=this.b.reset(E);let h=this.c;for(;h;){const c=d.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(d.hasNext())d.next(),h=h.mid;else return h.mid?this.h(h.mid):v?h.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[v,d]of this)E(d,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const v=[];return this.j(E,v),v[Symbol.iterator]()}j(E,v){E&&(E.left&&this.j(E.left,v),E.value&&v.push([E.key,E.value]),E.mid&&this.j(E.mid,v),E.right&&this.j(E.right,v))}_isBalanced(){const E=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:E(v.left)&&E(v.right)};return E(this.c)}}e.$Gi=P}),define(ke[18],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=l,e.$bg=L,e.$cg=M,e.$dg=A,e.$eg=R,e.$fg=w,e.$gg=$,e.$hg=k,e.$ig=I,e.$jg=P,e.$kg=p,e.$lg=E,e.$mg=v,e.$ng=h,e.$og=c,e.$pg=i,e.$qg=n,e.$rg=a;function l(r){return typeof r=="string"}function L(r){return Array.isArray(r)&&r.every(t=>l(t))}function M(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}function A(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}function R(r){return typeof r=="number"&&!isNaN(r)}function w(r){return!!r&&typeof r[Symbol.iterator]=="function"}function $(r){return r===!0||r===!1}function k(r){return typeof r>"u"}function I(r){return!P(r)}function P(r){return k(r)||r===null}function p(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function E(r){if(P(r))throw new Error("Assertion Failed: argument is undefined or null");return r}function v(...r){const t=[];for(let f=0;f<r.length;f++){const o=r[f];if(P(o))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(o)}return t}const d=Object.prototype.hasOwnProperty;function h(r){if(!M(r))return!1;for(const t in r)if(d.call(r,t))return!1;return!0}function c(r){return typeof r=="function"}function i(...r){return r.length>0&&r.every(c)}function n(r,t){const f=Math.min(r.length,t.length);for(let o=0;o<f;o++)a(r[o],t[o])}function a(r,t){if(l(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(r instanceof t)return}catch{}if(!P(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],De([1,0,18]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=M,e.$Vj=A;const L=Object.create(null);function M(R,w){if((0,l.$ag)(w)){const $=L[w];if($===void 0)throw new Error(`${R} references an unknown codicon: ${w}`);w=$}return L[R]=w,{id:R}}function A(){return L}}),define(ke[175],De([1,0,99]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0,e.$Wj={add:(0,l.$Uj)("add",6e4),plus:(0,l.$Uj)("plus",6e4),gistNew:(0,l.$Uj)("gist-new",6e4),repoCreate:(0,l.$Uj)("repo-create",6e4),lightbulb:(0,l.$Uj)("lightbulb",60001),lightBulb:(0,l.$Uj)("light-bulb",60001),repo:(0,l.$Uj)("repo",60002),repoDelete:(0,l.$Uj)("repo-delete",60002),gistFork:(0,l.$Uj)("gist-fork",60003),repoForked:(0,l.$Uj)("repo-forked",60003),gitPullRequest:(0,l.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,l.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,l.$Uj)("record-keys",60005),keyboard:(0,l.$Uj)("keyboard",60005),tag:(0,l.$Uj)("tag",60006),gitPullRequestLabel:(0,l.$Uj)("git-pull-request-label",60006),tagAdd:(0,l.$Uj)("tag-add",60006),tagRemove:(0,l.$Uj)("tag-remove",60006),person:(0,l.$Uj)("person",60007),personFollow:(0,l.$Uj)("person-follow",60007),personOutline:(0,l.$Uj)("person-outline",60007),personFilled:(0,l.$Uj)("person-filled",60007),gitBranch:(0,l.$Uj)("git-branch",60008),gitBranchCreate:(0,l.$Uj)("git-branch-create",60008),gitBranchDelete:(0,l.$Uj)("git-branch-delete",60008),sourceControl:(0,l.$Uj)("source-control",60008),mirror:(0,l.$Uj)("mirror",60009),mirrorPublic:(0,l.$Uj)("mirror-public",60009),star:(0,l.$Uj)("star",60010),starAdd:(0,l.$Uj)("star-add",60010),starDelete:(0,l.$Uj)("star-delete",60010),starEmpty:(0,l.$Uj)("star-empty",60010),comment:(0,l.$Uj)("comment",60011),commentAdd:(0,l.$Uj)("comment-add",60011),alert:(0,l.$Uj)("alert",60012),warning:(0,l.$Uj)("warning",60012),search:(0,l.$Uj)("search",60013),searchSave:(0,l.$Uj)("search-save",60013),logOut:(0,l.$Uj)("log-out",60014),signOut:(0,l.$Uj)("sign-out",60014),logIn:(0,l.$Uj)("log-in",60015),signIn:(0,l.$Uj)("sign-in",60015),eye:(0,l.$Uj)("eye",60016),eyeUnwatch:(0,l.$Uj)("eye-unwatch",60016),eyeWatch:(0,l.$Uj)("eye-watch",60016),circleFilled:(0,l.$Uj)("circle-filled",60017),primitiveDot:(0,l.$Uj)("primitive-dot",60017),closeDirty:(0,l.$Uj)("close-dirty",60017),debugBreakpoint:(0,l.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,l.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,l.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,l.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,l.$Uj)("primitive-square",60018),edit:(0,l.$Uj)("edit",60019),pencil:(0,l.$Uj)("pencil",60019),info:(0,l.$Uj)("info",60020),issueOpened:(0,l.$Uj)("issue-opened",60020),gistPrivate:(0,l.$Uj)("gist-private",60021),gitForkPrivate:(0,l.$Uj)("git-fork-private",60021),lock:(0,l.$Uj)("lock",60021),mirrorPrivate:(0,l.$Uj)("mirror-private",60021),close:(0,l.$Uj)("close",60022),removeClose:(0,l.$Uj)("remove-close",60022),x:(0,l.$Uj)("x",60022),repoSync:(0,l.$Uj)("repo-sync",60023),sync:(0,l.$Uj)("sync",60023),clone:(0,l.$Uj)("clone",60024),desktopDownload:(0,l.$Uj)("desktop-download",60024),beaker:(0,l.$Uj)("beaker",60025),microscope:(0,l.$Uj)("microscope",60025),vm:(0,l.$Uj)("vm",60026),deviceDesktop:(0,l.$Uj)("device-desktop",60026),file:(0,l.$Uj)("file",60027),fileText:(0,l.$Uj)("file-text",60027),more:(0,l.$Uj)("more",60028),ellipsis:(0,l.$Uj)("ellipsis",60028),kebabHorizontal:(0,l.$Uj)("kebab-horizontal",60028),mailReply:(0,l.$Uj)("mail-reply",60029),reply:(0,l.$Uj)("reply",60029),organization:(0,l.$Uj)("organization",60030),organizationFilled:(0,l.$Uj)("organization-filled",60030),organizationOutline:(0,l.$Uj)("organization-outline",60030),newFile:(0,l.$Uj)("new-file",60031),fileAdd:(0,l.$Uj)("file-add",60031),newFolder:(0,l.$Uj)("new-folder",60032),fileDirectoryCreate:(0,l.$Uj)("file-directory-create",60032),trash:(0,l.$Uj)("trash",60033),trashcan:(0,l.$Uj)("trashcan",60033),history:(0,l.$Uj)("history",60034),clock:(0,l.$Uj)("clock",60034),folder:(0,l.$Uj)("folder",60035),fileDirectory:(0,l.$Uj)("file-directory",60035),symbolFolder:(0,l.$Uj)("symbol-folder",60035),logoGithub:(0,l.$Uj)("logo-github",60036),markGithub:(0,l.$Uj)("mark-github",60036),github:(0,l.$Uj)("github",60036),terminal:(0,l.$Uj)("terminal",60037),console:(0,l.$Uj)("console",60037),repl:(0,l.$Uj)("repl",60037),zap:(0,l.$Uj)("zap",60038),symbolEvent:(0,l.$Uj)("symbol-event",60038),error:(0,l.$Uj)("error",60039),stop:(0,l.$Uj)("stop",60039),variable:(0,l.$Uj)("variable",60040),symbolVariable:(0,l.$Uj)("symbol-variable",60040),array:(0,l.$Uj)("array",60042),symbolArray:(0,l.$Uj)("symbol-array",60042),symbolModule:(0,l.$Uj)("symbol-module",60043),symbolPackage:(0,l.$Uj)("symbol-package",60043),symbolNamespace:(0,l.$Uj)("symbol-namespace",60043),symbolObject:(0,l.$Uj)("symbol-object",60043),symbolMethod:(0,l.$Uj)("symbol-method",60044),symbolFunction:(0,l.$Uj)("symbol-function",60044),symbolConstructor:(0,l.$Uj)("symbol-constructor",60044),symbolBoolean:(0,l.$Uj)("symbol-boolean",60047),symbolNull:(0,l.$Uj)("symbol-null",60047),symbolNumeric:(0,l.$Uj)("symbol-numeric",60048),symbolNumber:(0,l.$Uj)("symbol-number",60048),symbolStructure:(0,l.$Uj)("symbol-structure",60049),symbolStruct:(0,l.$Uj)("symbol-struct",60049),symbolParameter:(0,l.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,l.$Uj)("symbol-type-parameter",60050),symbolKey:(0,l.$Uj)("symbol-key",60051),symbolText:(0,l.$Uj)("symbol-text",60051),symbolReference:(0,l.$Uj)("symbol-reference",60052),goToFile:(0,l.$Uj)("go-to-file",60052),symbolEnum:(0,l.$Uj)("symbol-enum",60053),symbolValue:(0,l.$Uj)("symbol-value",60053),symbolRuler:(0,l.$Uj)("symbol-ruler",60054),symbolUnit:(0,l.$Uj)("symbol-unit",60054),activateBreakpoints:(0,l.$Uj)("activate-breakpoints",60055),archive:(0,l.$Uj)("archive",60056),arrowBoth:(0,l.$Uj)("arrow-both",60057),arrowDown:(0,l.$Uj)("arrow-down",60058),arrowLeft:(0,l.$Uj)("arrow-left",60059),arrowRight:(0,l.$Uj)("arrow-right",60060),arrowSmallDown:(0,l.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,l.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,l.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,l.$Uj)("arrow-small-up",60064),arrowUp:(0,l.$Uj)("arrow-up",60065),bell:(0,l.$Uj)("bell",60066),bold:(0,l.$Uj)("bold",60067),book:(0,l.$Uj)("book",60068),bookmark:(0,l.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,l.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,l.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,l.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,l.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,l.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,l.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,l.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,l.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,l.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,l.$Uj)("briefcase",60076),broadcast:(0,l.$Uj)("broadcast",60077),browser:(0,l.$Uj)("browser",60078),bug:(0,l.$Uj)("bug",60079),calendar:(0,l.$Uj)("calendar",60080),caseSensitive:(0,l.$Uj)("case-sensitive",60081),check:(0,l.$Uj)("check",60082),checklist:(0,l.$Uj)("checklist",60083),chevronDown:(0,l.$Uj)("chevron-down",60084),chevronLeft:(0,l.$Uj)("chevron-left",60085),chevronRight:(0,l.$Uj)("chevron-right",60086),chevronUp:(0,l.$Uj)("chevron-up",60087),chromeClose:(0,l.$Uj)("chrome-close",60088),chromeMaximize:(0,l.$Uj)("chrome-maximize",60089),chromeMinimize:(0,l.$Uj)("chrome-minimize",60090),chromeRestore:(0,l.$Uj)("chrome-restore",60091),circleOutline:(0,l.$Uj)("circle-outline",60092),circle:(0,l.$Uj)("circle",60092),debugBreakpointUnverified:(0,l.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,l.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,l.$Uj)("circle-slash",60093),circuitBoard:(0,l.$Uj)("circuit-board",60094),clearAll:(0,l.$Uj)("clear-all",60095),clippy:(0,l.$Uj)("clippy",60096),closeAll:(0,l.$Uj)("close-all",60097),cloudDownload:(0,l.$Uj)("cloud-download",60098),cloudUpload:(0,l.$Uj)("cloud-upload",60099),code:(0,l.$Uj)("code",60100),collapseAll:(0,l.$Uj)("collapse-all",60101),colorMode:(0,l.$Uj)("color-mode",60102),commentDiscussion:(0,l.$Uj)("comment-discussion",60103),creditCard:(0,l.$Uj)("credit-card",60105),dash:(0,l.$Uj)("dash",60108),dashboard:(0,l.$Uj)("dashboard",60109),database:(0,l.$Uj)("database",60110),debugContinue:(0,l.$Uj)("debug-continue",60111),debugDisconnect:(0,l.$Uj)("debug-disconnect",60112),debugPause:(0,l.$Uj)("debug-pause",60113),debugRestart:(0,l.$Uj)("debug-restart",60114),debugStart:(0,l.$Uj)("debug-start",60115),debugStepInto:(0,l.$Uj)("debug-step-into",60116),debugStepOut:(0,l.$Uj)("debug-step-out",60117),debugStepOver:(0,l.$Uj)("debug-step-over",60118),debugStop:(0,l.$Uj)("debug-stop",60119),debug:(0,l.$Uj)("debug",60120),deviceCameraVideo:(0,l.$Uj)("device-camera-video",60121),deviceCamera:(0,l.$Uj)("device-camera",60122),deviceMobile:(0,l.$Uj)("device-mobile",60123),diffAdded:(0,l.$Uj)("diff-added",60124),diffIgnored:(0,l.$Uj)("diff-ignored",60125),diffModified:(0,l.$Uj)("diff-modified",60126),diffRemoved:(0,l.$Uj)("diff-removed",60127),diffRenamed:(0,l.$Uj)("diff-renamed",60128),diff:(0,l.$Uj)("diff",60129),diffSidebyside:(0,l.$Uj)("diff-sidebyside",60129),discard:(0,l.$Uj)("discard",60130),editorLayout:(0,l.$Uj)("editor-layout",60131),emptyWindow:(0,l.$Uj)("empty-window",60132),exclude:(0,l.$Uj)("exclude",60133),extensions:(0,l.$Uj)("extensions",60134),eyeClosed:(0,l.$Uj)("eye-closed",60135),fileBinary:(0,l.$Uj)("file-binary",60136),fileCode:(0,l.$Uj)("file-code",60137),fileMedia:(0,l.$Uj)("file-media",60138),filePdf:(0,l.$Uj)("file-pdf",60139),fileSubmodule:(0,l.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,l.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,l.$Uj)("file-symlink-file",60142),fileZip:(0,l.$Uj)("file-zip",60143),files:(0,l.$Uj)("files",60144),filter:(0,l.$Uj)("filter",60145),flame:(0,l.$Uj)("flame",60146),foldDown:(0,l.$Uj)("fold-down",60147),foldUp:(0,l.$Uj)("fold-up",60148),fold:(0,l.$Uj)("fold",60149),folderActive:(0,l.$Uj)("folder-active",60150),folderOpened:(0,l.$Uj)("folder-opened",60151),gear:(0,l.$Uj)("gear",60152),gift:(0,l.$Uj)("gift",60153),gistSecret:(0,l.$Uj)("gist-secret",60154),gist:(0,l.$Uj)("gist",60155),gitCommit:(0,l.$Uj)("git-commit",60156),gitCompare:(0,l.$Uj)("git-compare",60157),compareChanges:(0,l.$Uj)("compare-changes",60157),gitMerge:(0,l.$Uj)("git-merge",60158),githubAction:(0,l.$Uj)("github-action",60159),githubAlt:(0,l.$Uj)("github-alt",60160),globe:(0,l.$Uj)("globe",60161),grabber:(0,l.$Uj)("grabber",60162),graph:(0,l.$Uj)("graph",60163),gripper:(0,l.$Uj)("gripper",60164),heart:(0,l.$Uj)("heart",60165),home:(0,l.$Uj)("home",60166),horizontalRule:(0,l.$Uj)("horizontal-rule",60167),hubot:(0,l.$Uj)("hubot",60168),inbox:(0,l.$Uj)("inbox",60169),issueReopened:(0,l.$Uj)("issue-reopened",60171),issues:(0,l.$Uj)("issues",60172),italic:(0,l.$Uj)("italic",60173),jersey:(0,l.$Uj)("jersey",60174),json:(0,l.$Uj)("json",60175),kebabVertical:(0,l.$Uj)("kebab-vertical",60176),key:(0,l.$Uj)("key",60177),law:(0,l.$Uj)("law",60178),lightbulbAutofix:(0,l.$Uj)("lightbulb-autofix",60179),linkExternal:(0,l.$Uj)("link-external",60180),link:(0,l.$Uj)("link",60181),listOrdered:(0,l.$Uj)("list-ordered",60182),listUnordered:(0,l.$Uj)("list-unordered",60183),liveShare:(0,l.$Uj)("live-share",60184),loading:(0,l.$Uj)("loading",60185),location:(0,l.$Uj)("location",60186),mailRead:(0,l.$Uj)("mail-read",60187),mail:(0,l.$Uj)("mail",60188),markdown:(0,l.$Uj)("markdown",60189),megaphone:(0,l.$Uj)("megaphone",60190),mention:(0,l.$Uj)("mention",60191),milestone:(0,l.$Uj)("milestone",60192),gitPullRequestMilestone:(0,l.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,l.$Uj)("mortar-board",60193),move:(0,l.$Uj)("move",60194),multipleWindows:(0,l.$Uj)("multiple-windows",60195),mute:(0,l.$Uj)("mute",60196),noNewline:(0,l.$Uj)("no-newline",60197),note:(0,l.$Uj)("note",60198),octoface:(0,l.$Uj)("octoface",60199),openPreview:(0,l.$Uj)("open-preview",60200),package:(0,l.$Uj)("package",60201),paintcan:(0,l.$Uj)("paintcan",60202),pin:(0,l.$Uj)("pin",60203),play:(0,l.$Uj)("play",60204),run:(0,l.$Uj)("run",60204),plug:(0,l.$Uj)("plug",60205),preserveCase:(0,l.$Uj)("preserve-case",60206),preview:(0,l.$Uj)("preview",60207),project:(0,l.$Uj)("project",60208),pulse:(0,l.$Uj)("pulse",60209),question:(0,l.$Uj)("question",60210),quote:(0,l.$Uj)("quote",60211),radioTower:(0,l.$Uj)("radio-tower",60212),reactions:(0,l.$Uj)("reactions",60213),references:(0,l.$Uj)("references",60214),refresh:(0,l.$Uj)("refresh",60215),regex:(0,l.$Uj)("regex",60216),remoteExplorer:(0,l.$Uj)("remote-explorer",60217),remote:(0,l.$Uj)("remote",60218),remove:(0,l.$Uj)("remove",60219),replaceAll:(0,l.$Uj)("replace-all",60220),replace:(0,l.$Uj)("replace",60221),repoClone:(0,l.$Uj)("repo-clone",60222),repoForcePush:(0,l.$Uj)("repo-force-push",60223),repoPull:(0,l.$Uj)("repo-pull",60224),repoPush:(0,l.$Uj)("repo-push",60225),report:(0,l.$Uj)("report",60226),requestChanges:(0,l.$Uj)("request-changes",60227),rocket:(0,l.$Uj)("rocket",60228),rootFolderOpened:(0,l.$Uj)("root-folder-opened",60229),rootFolder:(0,l.$Uj)("root-folder",60230),rss:(0,l.$Uj)("rss",60231),ruby:(0,l.$Uj)("ruby",60232),saveAll:(0,l.$Uj)("save-all",60233),saveAs:(0,l.$Uj)("save-as",60234),save:(0,l.$Uj)("save",60235),screenFull:(0,l.$Uj)("screen-full",60236),screenNormal:(0,l.$Uj)("screen-normal",60237),searchStop:(0,l.$Uj)("search-stop",60238),server:(0,l.$Uj)("server",60240),settingsGear:(0,l.$Uj)("settings-gear",60241),settings:(0,l.$Uj)("settings",60242),shield:(0,l.$Uj)("shield",60243),smiley:(0,l.$Uj)("smiley",60244),sortPrecedence:(0,l.$Uj)("sort-precedence",60245),splitHorizontal:(0,l.$Uj)("split-horizontal",60246),splitVertical:(0,l.$Uj)("split-vertical",60247),squirrel:(0,l.$Uj)("squirrel",60248),starFull:(0,l.$Uj)("star-full",60249),starHalf:(0,l.$Uj)("star-half",60250),symbolClass:(0,l.$Uj)("symbol-class",60251),symbolColor:(0,l.$Uj)("symbol-color",60252),symbolConstant:(0,l.$Uj)("symbol-constant",60253),symbolEnumMember:(0,l.$Uj)("symbol-enum-member",60254),symbolField:(0,l.$Uj)("symbol-field",60255),symbolFile:(0,l.$Uj)("symbol-file",60256),symbolInterface:(0,l.$Uj)("symbol-interface",60257),symbolKeyword:(0,l.$Uj)("symbol-keyword",60258),symbolMisc:(0,l.$Uj)("symbol-misc",60259),symbolOperator:(0,l.$Uj)("symbol-operator",60260),symbolProperty:(0,l.$Uj)("symbol-property",60261),wrench:(0,l.$Uj)("wrench",60261),wrenchSubaction:(0,l.$Uj)("wrench-subaction",60261),symbolSnippet:(0,l.$Uj)("symbol-snippet",60262),tasklist:(0,l.$Uj)("tasklist",60263),telescope:(0,l.$Uj)("telescope",60264),textSize:(0,l.$Uj)("text-size",60265),threeBars:(0,l.$Uj)("three-bars",60266),thumbsdown:(0,l.$Uj)("thumbsdown",60267),thumbsup:(0,l.$Uj)("thumbsup",60268),tools:(0,l.$Uj)("tools",60269),triangleDown:(0,l.$Uj)("triangle-down",60270),triangleLeft:(0,l.$Uj)("triangle-left",60271),triangleRight:(0,l.$Uj)("triangle-right",60272),triangleUp:(0,l.$Uj)("triangle-up",60273),twitter:(0,l.$Uj)("twitter",60274),unfold:(0,l.$Uj)("unfold",60275),unlock:(0,l.$Uj)("unlock",60276),unmute:(0,l.$Uj)("unmute",60277),unverified:(0,l.$Uj)("unverified",60278),verified:(0,l.$Uj)("verified",60279),versions:(0,l.$Uj)("versions",60280),vmActive:(0,l.$Uj)("vm-active",60281),vmOutline:(0,l.$Uj)("vm-outline",60282),vmRunning:(0,l.$Uj)("vm-running",60283),watch:(0,l.$Uj)("watch",60284),whitespace:(0,l.$Uj)("whitespace",60285),wholeWord:(0,l.$Uj)("whole-word",60286),window:(0,l.$Uj)("window",60287),wordWrap:(0,l.$Uj)("word-wrap",60288),zoomIn:(0,l.$Uj)("zoom-in",60289),zoomOut:(0,l.$Uj)("zoom-out",60290),listFilter:(0,l.$Uj)("list-filter",60291),listFlat:(0,l.$Uj)("list-flat",60292),listSelection:(0,l.$Uj)("list-selection",60293),selection:(0,l.$Uj)("selection",60293),listTree:(0,l.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,l.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,l.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,l.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,l.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,l.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,l.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,l.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,l.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,l.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,l.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,l.$Uj)("symbol-string",60301),debugReverseContinue:(0,l.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,l.$Uj)("debug-step-back",60303),debugRestartFrame:(0,l.$Uj)("debug-restart-frame",60304),debugAlt:(0,l.$Uj)("debug-alt",60305),callIncoming:(0,l.$Uj)("call-incoming",60306),callOutgoing:(0,l.$Uj)("call-outgoing",60307),menu:(0,l.$Uj)("menu",60308),expandAll:(0,l.$Uj)("expand-all",60309),feedback:(0,l.$Uj)("feedback",60310),gitPullRequestReviewer:(0,l.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,l.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,l.$Uj)("ungroup-by-ref-type",60312),account:(0,l.$Uj)("account",60313),gitPullRequestAssignee:(0,l.$Uj)("git-pull-request-assignee",60313),bellDot:(0,l.$Uj)("bell-dot",60314),debugConsole:(0,l.$Uj)("debug-console",60315),library:(0,l.$Uj)("library",60316),output:(0,l.$Uj)("output",60317),runAll:(0,l.$Uj)("run-all",60318),syncIgnored:(0,l.$Uj)("sync-ignored",60319),pinned:(0,l.$Uj)("pinned",60320),githubInverted:(0,l.$Uj)("github-inverted",60321),serverProcess:(0,l.$Uj)("server-process",60322),serverEnvironment:(0,l.$Uj)("server-environment",60323),pass:(0,l.$Uj)("pass",60324),issueClosed:(0,l.$Uj)("issue-closed",60324),stopCircle:(0,l.$Uj)("stop-circle",60325),playCircle:(0,l.$Uj)("play-circle",60326),record:(0,l.$Uj)("record",60327),debugAltSmall:(0,l.$Uj)("debug-alt-small",60328),vmConnect:(0,l.$Uj)("vm-connect",60329),cloud:(0,l.$Uj)("cloud",60330),merge:(0,l.$Uj)("merge",60331),export:(0,l.$Uj)("export",60332),graphLeft:(0,l.$Uj)("graph-left",60333),magnet:(0,l.$Uj)("magnet",60334),notebook:(0,l.$Uj)("notebook",60335),redo:(0,l.$Uj)("redo",60336),checkAll:(0,l.$Uj)("check-all",60337),pinnedDirty:(0,l.$Uj)("pinned-dirty",60338),passFilled:(0,l.$Uj)("pass-filled",60339),circleLargeFilled:(0,l.$Uj)("circle-large-filled",60340),circleLarge:(0,l.$Uj)("circle-large",60341),circleLargeOutline:(0,l.$Uj)("circle-large-outline",60341),combine:(0,l.$Uj)("combine",60342),gather:(0,l.$Uj)("gather",60342),table:(0,l.$Uj)("table",60343),variableGroup:(0,l.$Uj)("variable-group",60344),typeHierarchy:(0,l.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,l.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,l.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,l.$Uj)("git-pull-request-create",60348),runAbove:(0,l.$Uj)("run-above",60349),runBelow:(0,l.$Uj)("run-below",60350),notebookTemplate:(0,l.$Uj)("notebook-template",60351),debugRerun:(0,l.$Uj)("debug-rerun",60352),workspaceTrusted:(0,l.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,l.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,l.$Uj)("workspace-unknown",60355),terminalCmd:(0,l.$Uj)("terminal-cmd",60356),terminalDebian:(0,l.$Uj)("terminal-debian",60357),terminalLinux:(0,l.$Uj)("terminal-linux",60358),terminalPowershell:(0,l.$Uj)("terminal-powershell",60359),terminalTmux:(0,l.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,l.$Uj)("terminal-ubuntu",60361),terminalBash:(0,l.$Uj)("terminal-bash",60362),arrowSwap:(0,l.$Uj)("arrow-swap",60363),copy:(0,l.$Uj)("copy",60364),personAdd:(0,l.$Uj)("person-add",60365),filterFilled:(0,l.$Uj)("filter-filled",60366),wand:(0,l.$Uj)("wand",60367),debugLineByLine:(0,l.$Uj)("debug-line-by-line",60368),inspect:(0,l.$Uj)("inspect",60369),layers:(0,l.$Uj)("layers",60370),layersDot:(0,l.$Uj)("layers-dot",60371),layersActive:(0,l.$Uj)("layers-active",60372),compass:(0,l.$Uj)("compass",60373),compassDot:(0,l.$Uj)("compass-dot",60374),compassActive:(0,l.$Uj)("compass-active",60375),azure:(0,l.$Uj)("azure",60376),issueDraft:(0,l.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,l.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,l.$Uj)("git-pull-request-draft",60379),debugAll:(0,l.$Uj)("debug-all",60380),debugCoverage:(0,l.$Uj)("debug-coverage",60381),runErrors:(0,l.$Uj)("run-errors",60382),folderLibrary:(0,l.$Uj)("folder-library",60383),debugContinueSmall:(0,l.$Uj)("debug-continue-small",60384),beakerStop:(0,l.$Uj)("beaker-stop",60385),graphLine:(0,l.$Uj)("graph-line",60386),graphScatter:(0,l.$Uj)("graph-scatter",60387),pieChart:(0,l.$Uj)("pie-chart",60388),bracket:(0,l.$Uj)("bracket",60175),bracketDot:(0,l.$Uj)("bracket-dot",60389),bracketError:(0,l.$Uj)("bracket-error",60390),lockSmall:(0,l.$Uj)("lock-small",60391),azureDevops:(0,l.$Uj)("azure-devops",60392),verifiedFilled:(0,l.$Uj)("verified-filled",60393),newline:(0,l.$Uj)("newline",60394),layout:(0,l.$Uj)("layout",60395),layoutActivitybarLeft:(0,l.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,l.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,l.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,l.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,l.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,l.$Uj)("layout-panel-right",60401),layoutPanel:(0,l.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,l.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,l.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,l.$Uj)("layout-statusbar",60405),layoutMenubar:(0,l.$Uj)("layout-menubar",60406),layoutCentered:(0,l.$Uj)("layout-centered",60407),target:(0,l.$Uj)("target",60408),indent:(0,l.$Uj)("indent",60409),recordSmall:(0,l.$Uj)("record-small",60410),errorSmall:(0,l.$Uj)("error-small",60411),terminalDecorationError:(0,l.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,l.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,l.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,l.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,l.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,l.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,l.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,l.$Uj)("layout-sidebar-left-off",60418),blank:(0,l.$Uj)("blank",60419),heartFilled:(0,l.$Uj)("heart-filled",60420),map:(0,l.$Uj)("map",60421),mapHorizontal:(0,l.$Uj)("map-horizontal",60421),foldHorizontal:(0,l.$Uj)("fold-horizontal",60421),mapFilled:(0,l.$Uj)("map-filled",60422),mapHorizontalFilled:(0,l.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,l.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,l.$Uj)("circle-small",60423),bellSlash:(0,l.$Uj)("bell-slash",60424),bellSlashDot:(0,l.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,l.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,l.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,l.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,l.$Uj)("search-fuzzy",60429),commentDraft:(0,l.$Uj)("comment-draft",60430),send:(0,l.$Uj)("send",60431),sparkle:(0,l.$Uj)("sparkle",60432),insert:(0,l.$Uj)("insert",60433),mic:(0,l.$Uj)("mic",60434),thumbsdownFilled:(0,l.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,l.$Uj)("thumbsup-filled",60436),coffee:(0,l.$Uj)("coffee",60437),snake:(0,l.$Uj)("snake",60438),game:(0,l.$Uj)("game",60439),vr:(0,l.$Uj)("vr",60440),chip:(0,l.$Uj)("chip",60441),piano:(0,l.$Uj)("piano",60442),music:(0,l.$Uj)("music",60443),micFilled:(0,l.$Uj)("mic-filled",60444),repoFetch:(0,l.$Uj)("repo-fetch",60445),copilot:(0,l.$Uj)("copilot",60446),lightbulbSparkle:(0,l.$Uj)("lightbulb-sparkle",60447),robot:(0,l.$Uj)("robot",60448),sparkleFilled:(0,l.$Uj)("sparkle-filled",60449),diffSingle:(0,l.$Uj)("diff-single",60450),diffMultiple:(0,l.$Uj)("diff-multiple",60451),surroundWith:(0,l.$Uj)("surround-with",60452),share:(0,l.$Uj)("share",60453),gitStash:(0,l.$Uj)("git-stash",60454),gitStashApply:(0,l.$Uj)("git-stash-apply",60455),gitStashPop:(0,l.$Uj)("git-stash-pop",60456),vscode:(0,l.$Uj)("vscode",60457),vscodeInsiders:(0,l.$Uj)("vscode-insiders",60458),codeOss:(0,l.$Uj)("code-oss",60459),runCoverage:(0,l.$Uj)("run-coverage",60460),runAllCoverage:(0,l.$Uj)("run-all-coverage",60461),coverage:(0,l.$Uj)("coverage",60462),githubProject:(0,l.$Uj)("github-project",60463),mapVertical:(0,l.$Uj)("map-vertical",60464),foldVertical:(0,l.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,l.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,l.$Uj)("fold-vertical-filled",60465),goToSearch:(0,l.$Uj)("go-to-search",60466),percentage:(0,l.$Uj)("percentage",60467),sortPercentage:(0,l.$Uj)("sort-percentage",60467),attach:(0,l.$Uj)("attach",60468)}}),define(ke[79],De([1,0,99,175]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=void 0,e.$Xj=M;function M(){return Object.values(e.$Zj)}e.$Yj={dialogError:(0,l.$Uj)("dialog-error","error"),dialogWarning:(0,l.$Uj)("dialog-warning","warning"),dialogInfo:(0,l.$Uj)("dialog-info","info"),dialogClose:(0,l.$Uj)("dialog-close","close"),treeItemExpanded:(0,l.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,l.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,l.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,l.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,l.$Uj)("tree-item-loading","loading"),menuSelection:(0,l.$Uj)("menu-selection","check"),menuSubmenu:(0,l.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,l.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,l.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,l.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,l.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,l.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,l.$Uj)("toolbar-more","more"),quickInputBack:(0,l.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,l.$Uj)("drop-down-button",60084),symbolCustomColor:(0,l.$Uj)("symbol-customcolor",60252),exportIcon:(0,l.$Uj)("export",60332),workspaceUnspecified:(0,l.$Uj)("workspace-unspecified",60355),newLine:(0,l.$Uj)("newline",60394),thumbsDownFilled:(0,l.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,l.$Uj)("thumbsup-filled",60436),gitFetch:(0,l.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,l.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,l.$Uj)("debug-breakpoint-pending",60377)},e.$Zj={...L.$Wj,...e.$Yj}}),define(ke[24],De([1,0,18]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=L,e.$8n=M,e.$9n=R,e.$0n=$,e.$$n=k,e.$_n=I,e.$ao=P,e.$bo=p,e.$co=E,e.$do=v,e.$eo=d,e.$fo=h,e.$go=c;function L(i){if(!i||typeof i!="object"||i instanceof RegExp)return i;const n=Array.isArray(i)?[]:{};return Object.entries(i).forEach(([a,r])=>{n[a]=r&&typeof r=="object"?L(r):r}),n}function M(i){if(!i||typeof i!="object")return i;const n=[i];for(;n.length>0;){const a=n.shift();Object.freeze(a);for(const r in a)if(A.call(a,r)){const t=a[r];typeof t=="object"&&!Object.isFrozen(t)&&!(0,l.$dg)(t)&&n.push(t)}}return i}const A=Object.prototype.hasOwnProperty;function R(i,n){return w(i,n,new Set)}function w(i,n,a){if((0,l.$jg)(i))return i;const r=n(i);if(typeof r<"u")return r;if(Array.isArray(i)){const t=[];for(const f of i)t.push(w(f,n,a));return t}if((0,l.$cg)(i)){if(a.has(i))throw new Error("Cannot clone recursive data-structure");a.add(i);const t={};for(const f in i)A.call(i,f)&&(t[f]=w(i[f],n,a));return a.delete(i),t}return i}function $(i,n,a=!0){return(0,l.$cg)(i)?((0,l.$cg)(n)&&Object.keys(n).forEach(r=>{r in i?a&&((0,l.$cg)(i[r])&&(0,l.$cg)(n[r])?$(i[r],n[r],a):i[r]=n[r]):i[r]=n[r]}),i):n}function k(i,n){if(i===n)return!0;if(i==null||n===null||n===void 0||typeof i!=typeof n||typeof i!="object"||Array.isArray(i)!==Array.isArray(n))return!1;let a,r;if(Array.isArray(i)){if(i.length!==n.length)return!1;for(a=0;a<i.length;a++)if(!k(i[a],n[a]))return!1}else{const t=[];for(r in i)t.push(r);t.sort();const f=[];for(r in n)f.push(r);if(f.sort(),!k(t,f))return!1;for(a=0;a<t.length;a++)if(!k(i[t[a]],n[t[a]]))return!1}return!0}function I(i){const n=new Set;return JSON.stringify(i,(a,r)=>{if((0,l.$cg)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return typeof r=="bigint"?`[BigInt ${r.toString()}]`:r})}function P(i,n){const a=Object.create(null);return!i||!n||Object.keys(n).forEach(t=>{const f=i[t],o=n[t];k(f,o)||(a[t]=o)}),a}function p(i,n){const a=n.toLowerCase(),r=Object.keys(i).find(t=>t.toLowerCase()===a);return r?i[r]:i[n]}function E(i,n){const a=Object.create(null);for(const[r,t]of Object.entries(i))n(r,t)&&(a[r]=t);return a}function v(i){let n=[];for(;Object.prototype!==i;)n=n.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return n}function d(i){const n=[];for(const a of v(i))typeof i[a]=="function"&&n.push(a);return n}function h(i,n){const a=t=>function(){const f=Array.prototype.slice.call(arguments,0);return n(t,f)},r={};for(const t of i)r[t]=a(t);return r}function c(i,n){const a={};for(const[r,t]of Object.entries(i))a[r]=n(t,r);return a}}),define(ke[50],De([1,0,79]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=M;var L;(function(R){function w($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=w})(L||(e.ThemeColor=L={}));function M(R){return{id:R}}var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(i){const n=w.exec(i.id);if(!n)return $(l.$Zj.error);const[,a,r]=n,t=["codicon","codicon-"+a];return r&&t.push("codicon-modifier-"+r.substring(1)),t}R.asClassNameArray=$;function k(i){return $(i).join(" ")}R.asClassName=k;function I(i){return"."+$(i).join(".")}R.asCSSSelector=I;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||L.isThemeColor(i.color))}R.isThemeIcon=P;const p=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(i){const n=p.exec(i);if(!n)return;const[,a]=n;return{id:a}}R.fromString=E;function v(i){return{id:i}}R.fromId=v;function d(i,n){let a=i.id;const r=a.lastIndexOf("~");return r!==-1&&(a=a.substring(0,r)),n&&(a=`${a}~${n}`),{id:a}}R.modify=d;function h(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=h;function c(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=c})(A||(e.ThemeIcon=A={}))}),define(ke[176],De([1,0,127,14,50]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=$,e.$Sk=I,e.$Tk=p,e.$Uk=E,e.$Vk=d,e.$Wk=h;const A="$(",R=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${R.source}`,"g");function $(c){return c.replace(w,(i,n)=>n?i:`\\${i}`)}const k=new RegExp(`\\\\${R.source}`,"g");function I(c){return c.replace(k,i=>`\\${i}`)}const P=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function p(c){return c.indexOf(A)===-1?c:c.replace(P,(i,n,a,r)=>a?i:n||r||"")}function E(c){return c?c.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}const v=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function d(c){v.lastIndex=0;let i="";const n=[];let a=0;for(;;){const r=v.lastIndex,t=v.exec(c),f=c.substring(r,t?.index);if(f.length>0){i+=f;for(let o=0;o<f.length;o++)n.push(a)}if(!t)break;a+=t[0].length}return{text:i,iconOffsets:n}}function h(c,i,n=!1){const{text:a,iconOffsets:r}=i;if(!r||r.length===0)return(0,l.$Ik)(c,a,n);const t=(0,L.$if)(a," "),f=a.length-t.length,o=(0,l.$Ik)(c,t,n);if(o)for(const s of o){const u=r[s.start+f]+f;s.start+=u,s.end+=u}return o}}),define(ke[128],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=L,e.$0e=M;var l;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l||(e.Constants=l={}));function L(A){return A<0?0:A>255?255:A|0}function M(A){return A<0?0:A>4294967295?4294967295:A|0}}),define(ke[30],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=L;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(M){return l.test(M)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(w){for(let $=0;$<w.length;$++)w[$]=Math.floor(Math.random()*256);return w};const A=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));return function(){M(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let $=0,k="";return k+=R[A[$++]],k+=R[A[$++]],k+=R[A[$++]],k+=R[A[$++]],k+="-",k+=R[A[$++]],k+=R[A[$++]],k+="-",k+=R[A[$++]],k+=R[A[$++]],k+="-",k+=R[A[$++]],k+=R[A[$++]],k+="-",k+=R[A[$++]],k+=R[A[$++]],k+=R[A[$++]],k+=R[A[$++]],k+=R[A[$++]],k+=R[A[$++]],k}}()}),define(ke[177],De([1,0,19,39,30]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=e.$cu=void 0,e.$au=A,e.$bu=R,e.$du=k;function A(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}function R(P,p,E){const v={id:(0,M.$Wg)(),name:P,uri:p,data:E};return{asString:async()=>"",asFile:()=>v,value:void 0}}class w{constructor(){this.a=new Map}get size(){let p=0;for(const E of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const E=[...this.a.keys()];return L.Iterable.some(this,([v,d])=>d.asFile())&&E.push("files"),I($(p),E)}get(p){return this.a.get(this.b(p))?.[0]}append(p,E){const v=this.a.get(p);v?v.push(E):this.a.set(this.b(p),[E])}replace(p,E){this.a.set(this.b(p),[E])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,E]of this.a)for(const v of E)yield[p,v]}b(p){return $(p)}}e.$cu=w;function $(P){return P.toLowerCase()}function k(P,p){return I($(P),p.map($))}function I(P,p){if(P==="*/*")return p.length>0;if(p.includes(P))return!0;const E=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[v,d,h]=E;return h==="*"?p.some(c=>c.startsWith(d+"/")):!1}e.$eu=Object.freeze({create:P=>(0,l.$Mb)(P.map(p=>p.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$eu.split(P).filter(p=>!p.startsWith("#"))})}),define(ke[178],De([1,0,63]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=L,e.$1g=A;function L(w,$,k,I=1){let P=!1;return new Promise(p=>{const E=setTimeout(()=>{if(!P)return P=!0,p(0)},k);M(w,$,I,v=>{if(!P)return P=!0,clearTimeout(E),p(v)})})}function M(w,$,k,I){if($===0)return I(0);const P=new l.Socket;P.once("connect",()=>(R(P),M(w+k,$-1,k,I))),P.once("data",()=>{}),P.once("error",p=>(R(P),p.code!=="ECONNREFUSED"?M(w+k,$-1,k,I):I(w))),P.connect(w,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(w,$,k,I="127.0.0.1"){let P=!1,p,E=1;const v=l.createServer({pauseOnConnect:!0});function d(h,c){P||(P=!0,v.removeAllListeners(),v.close(),p&&clearTimeout(p),c(h))}return new Promise(h=>{p=setTimeout(()=>{d(0,h)},k),v.on("listening",()=>{d(w,h)}),v.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&E<$?(w++,E++,v.listen(w,I)):d(0,h)}),v.on("close",()=>{d(0,h)}),v.listen(w,I)})}function R(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch($){console.error($)}}}),define(ke[129],De([1,0,128]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6t=e.$5t=void 0;class L{constructor(w){const $=(0,l.$9e)(w);this.c=$,this.a=L.d($),this.b=new Map}static d(w){const $=new Uint8Array(256);return $.fill(w),$}set(w,$){const k=(0,l.$9e)($);w>=0&&w<256?this.a[w]=k:this.b.set(w,k)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$5t=L;var M;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(M||(M={}));class A{constructor(){this.a=new L(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}e.$6t=A}),define(ke[179],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$ku=L;var l;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(l||(e.StringEOL=l={}));function L(M){let A=0,R=0,w=0,$=0;for(let k=0,I=M.length;k<I;k++){const P=M.charCodeAt(k);P===13?(A===0&&(R=k),A++,k+1<I&&M.charCodeAt(k+1)===10?($|=2,k++):$|=3,w=k+1):P===10&&($|=1,A===0&&(R=k),A++,w=k+1)}return A===0&&(R=M.length),[A,R,M.length-w,$]}}),define(ke[51],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=void 0;class l{constructor(M,A){this.lineNumber=M,this.column=A}with(M=this.lineNumber,A=this.column){return M===this.lineNumber&&A===this.column?this:new l(M,A)}delta(M=0,A=0){return this.with(this.lineNumber+M,this.column+A)}equals(M){return l.equals(this,M)}static equals(M,A){return!M&&!A?!0:!!M&&!!A&&M.lineNumber===A.lineNumber&&M.column===A.column}isBefore(M){return l.isBefore(this,M)}static isBefore(M,A){return M.lineNumber<A.lineNumber?!0:A.lineNumber<M.lineNumber?!1:M.column<A.column}isBeforeOrEqual(M){return l.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,A){return M.lineNumber<A.lineNumber?!0:A.lineNumber<M.lineNumber?!1:M.column<=A.column}static compare(M,A){const R=M.lineNumber|0,w=A.lineNumber|0;if(R===w){const $=M.column|0,k=A.column|0;return $-k}return R-w}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new l(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$zt=l}),define(ke[29],De([1,0,51]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=void 0;class L{constructor(A,R,w,$){A>w||A===w&&R>$?(this.startLineNumber=w,this.startColumn=$,this.endLineNumber=A,this.endColumn=R):(this.startLineNumber=A,this.startColumn=R,this.endLineNumber=w,this.endColumn=$)}isEmpty(){return L.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return L.containsPosition(this,A)}static containsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<A.startColumn||R.lineNumber===A.endLineNumber&&R.column>A.endColumn)}static strictContainsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<=A.startColumn||R.lineNumber===A.endLineNumber&&R.column>=A.endColumn)}containsRange(A){return L.containsRange(this,A)}static containsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>A.endColumn)}strictContainsRange(A){return L.strictContainsRange(this,A)}static strictContainsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<=A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>=A.endColumn)}plusRange(A){return L.plusRange(this,A)}static plusRange(A,R){let w,$,k,I;return R.startLineNumber<A.startLineNumber?(w=R.startLineNumber,$=R.startColumn):R.startLineNumber===A.startLineNumber?(w=R.startLineNumber,$=Math.min(R.startColumn,A.startColumn)):(w=A.startLineNumber,$=A.startColumn),R.endLineNumber>A.endLineNumber?(k=R.endLineNumber,I=R.endColumn):R.endLineNumber===A.endLineNumber?(k=R.endLineNumber,I=Math.max(R.endColumn,A.endColumn)):(k=A.endLineNumber,I=A.endColumn),new L(w,$,k,I)}intersectRanges(A){return L.intersectRanges(this,A)}static intersectRanges(A,R){let w=A.startLineNumber,$=A.startColumn,k=A.endLineNumber,I=A.endColumn;const P=R.startLineNumber,p=R.startColumn,E=R.endLineNumber,v=R.endColumn;return w<P?(w=P,$=p):w===P&&($=Math.max($,p)),k>E?(k=E,I=v):k===E&&(I=Math.min(I,v)),w>k||w===k&&$>I?null:new L(w,$,k,I)}equalsRange(A){return L.equalsRange(this,A)}static equalsRange(A,R){return!A&&!R?!0:!!A&&!!R&&A.startLineNumber===R.startLineNumber&&A.startColumn===R.startColumn&&A.endLineNumber===R.endLineNumber&&A.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(A){return new l.$zt(A.endLineNumber,A.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(A){return new l.$zt(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,R){return new L(this.startLineNumber,this.startColumn,A,R)}setStartPosition(A,R){return new L(A,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(A){return new L(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(A){return new L(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new L(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,R=A){return new L(A.lineNumber,A.column,R.lineNumber,R.column)}static lift(A){return A?new L(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn)}static areIntersecting(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,R){if(A&&R){const k=A.startLineNumber|0,I=R.startLineNumber|0;if(k===I){const P=A.startColumn|0,p=R.startColumn|0;if(P===p){const E=A.endLineNumber|0,v=R.endLineNumber|0;if(E===v){const d=A.endColumn|0,h=R.endColumn|0;return d-h}return E-v}return P-p}return k-I}return(A?1:0)-(R?1:0)}static compareRangesUsingEnds(A,R){return A.endLineNumber===R.endLineNumber?A.endColumn===R.endColumn?A.startLineNumber===R.startLineNumber?A.startColumn-R.startColumn:A.startLineNumber-R.startLineNumber:A.endColumn-R.endColumn:A.endLineNumber-R.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$At=L}),define(ke[180],De([1,0,29]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;class L{static insert(A,R){return{range:new l.$At(A.lineNumber,A.column,A.lineNumber,A.column),text:R,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,R){return{range:A,text:R}}static replaceMove(A,R){return{range:A,text:R,forceMoveMarkers:!0}}}e.$Bt=L}),define(ke[181],De([1,0,51,29]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.SelectionDirection=void 0;var M;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(M||(e.SelectionDirection=M={}));class A extends L.$At{constructor(w,$,k,I){super(w,$,k,I),this.selectionStartLineNumber=w,this.selectionStartColumn=$,this.positionLineNumber=k,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return A.selectionsEqual(this,w)}static selectionsEqual(w,$){return w.selectionStartLineNumber===$.selectionStartLineNumber&&w.selectionStartColumn===$.selectionStartColumn&&w.positionLineNumber===$.positionLineNumber&&w.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,$){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,w,$):new A(w,$,this.startLineNumber,this.startColumn)}getPosition(){return new l.$zt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.$zt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,$){return this.getDirection()===0?new A(w,$,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,w,$)}static fromPositions(w,$=w){return new A(w.lineNumber,w.column,$.lineNumber,$.column)}static fromRange(w,$){return $===0?new A(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new A(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new A(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,$){if(w&&!$||!w&&$)return!1;if(!w&&!$)return!0;if(w.length!==$.length)return!1;for(let k=0,I=w.length;k<I;k++)if(!this.selectionsEqual(w[k],$[k]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,$,k,I,P){return P===0?new A(w,$,k,I):new A(k,I,w,$)}}e.$Ct=A}),define(ke[182],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$0s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[183],De([1,0,27,129]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.WordCharacterClass=void 0,e.$8t=w;var M;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(M||(e.WordCharacterClass=M={}));class A extends L.$5t{constructor(k,I){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=I,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let P=0,p=k.length;P<p;P++)this.set(k.charCodeAt(P),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(k,I){let P=null;for(const p of this.h(k)){if(p.index>I)break;P=p}return P}findNextIntlWordAtOrAfterOffset(k,I){for(const P of this.h(k))if(!(P.index<I))return P;return null}h(k){return this.e?this.f===k?this.g:(this.f=k,this.g=this.j(this.e.segment(k)),this.g):[]}j(k){const I=[];for(const P of k)this.k(P)&&I.push(P);return I}k(k){return!!k.isWordLike}}e.$7t=A;const R=new l.$Dc(10);function w($,k){const I=`${$}/${k.join(",")}`;let P=R.get(I);return P||(P=new A($,k),R.set(I,P)),P}}),define(ke[130],De([1,0,39,3,76]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.$$s=void 0,e.$at=R,e.$bt=$,e.$ct=k,e.$$s="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(P=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$$s)P.indexOf(E)>=0||(p+="\\"+E);return p+="\\s]+)",new RegExp(p,"g")}e.$_s=A();function R(P){let p=e.$_s;if(P&&P instanceof RegExp)if(P.global)p=P;else{let E="g";P.ignoreCase&&(E+="i"),P.multiline&&(E+="m"),P.unicode&&(E+="u"),p=new RegExp(P.source,E)}return p.lastIndex=0,p}const w=new M.$5c;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(P){const p=w.unshift(P);return(0,L.$Sc)(p)}function k(P,p,E,v,d){if(p=R(p),d||(d=l.Iterable.first(w)),E.length>d.maxLen){let a=P-d.maxLen/2;return a<0?a=0:v+=a,E=E.substring(a,P+d.maxLen/2),k(P,p,E,v,d)}const h=Date.now(),c=P-1-v;let i=-1,n=null;for(let a=1;!(Date.now()-h>=d.timeBudget);a++){const r=c-d.windowSize*a;p.lastIndex=Math.max(0,r);const t=I(p,E,c,i);if(!t&&n||(n=t,r<=0))break;i=r}if(n){const a={word:n[0],startColumn:v+1+n.index,endColumn:v+1+n.index+n[0].length};return p.lastIndex=0,a}return null}function I(P,p,E,v){let d;for(;d=P.exec(p);){const h=d.index||0;if(h<=E&&P.lastIndex>=E)return d;if(v>0&&h>v)return null}return null}}),define(ke[184],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hu=e.$Gu=e.IndentAction=void 0;var l;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(l||(e.IndentAction=l={}));class L{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let $=0,k=w.notIn.length;$<k;$++)switch(w.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,$){if(w.getTokenCount()===0)return!0;const k=w.findTokenIndexAtOffset($-2),I=w.getStandardTokenType(k);return this.isOK(I)}g(w,$){for(let k=w;k<=$;k++){const I=String.fromCharCode(k);if(!this.open.includes(I)&&!this.close.includes(I))return I}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Gu=L;class M{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of w)A(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),A(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),A(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),A(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&A(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Hu=M;function A(R,w,$){R.has(w)?R.get(w).push($):R.set(w,[$])}}),define(ke[185],De([1,0,129]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X2=e.$W2=e.State=void 0,e.$Y2=p;var L;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(L||(e.State=L={}));class M{constructor(v,d,h){const c=new Uint8Array(v*d);for(let i=0,n=v*d;i<n;i++)c[i]=h;this.a=c,this.rows=v,this.cols=d}get(v,d){return this.a[v*this.cols+d]}set(v,d,h){this.a[v*this.cols+d]=h}}class A{constructor(v){let d=0,h=0;for(let i=0,n=v.length;i<n;i++){const[a,r,t]=v[i];r>d&&(d=r),a>h&&(h=a),t>h&&(h=t)}d++,h++;const c=new M(h,d,0);for(let i=0,n=v.length;i<n;i++){const[a,r,t]=v[i];c.set(a,r,t)}this.a=c,this.b=d}nextState(v,d){return d<0||d>=this.b?0:this.a.get(v,d)}}e.$W2=A;let R=null;function w(){return R===null&&(R=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})($||($={}));let k=null;function I(){if(k===null){k=new l.$5t(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<E.length;d++)k.set(E.charCodeAt(d),1);const v=".,;:";for(let d=0;d<v.length;d++)k.set(v.charCodeAt(d),2)}return k}class P{static a(v,d,h,c,i){let n=i-1;do{const a=d.charCodeAt(n);if(v.get(a)!==2)break;n--}while(n>c);if(c>0){const a=d.charCodeAt(c-1),r=d.charCodeAt(n);(a===40&&r===41||a===91&&r===93||a===123&&r===125)&&n--}return{range:{startLineNumber:h,startColumn:c+1,endLineNumber:h,endColumn:n+2},url:d.substring(c,n+1)}}static computeLinks(v,d=w()){const h=I(),c=[];for(let i=1,n=v.getLineCount();i<=n;i++){const a=v.getLineContent(i),r=a.length;let t=0,f=0,o=0,s=1,u=!1,g=!1,b=!1,S=!1;for(;t<r;){let m=!1;const y=a.charCodeAt(t);if(s===13){let D;switch(y){case 40:u=!0,D=0;break;case 41:D=u?0:1;break;case 91:b=!0,g=!0,D=0;break;case 93:b=!1,D=g?0:1;break;case 123:S=!0,D=0;break;case 125:D=S?0:1;break;case 39:case 34:case 96:o===y?D=1:o===39||o===34||o===96?D=0:D=1;break;case 42:D=o===42?1:0;break;case 124:D=o===124?1:0;break;case 32:D=b?0:1;break;default:D=h.get(y)}D===1&&(c.push(P.a(h,a,i,f,t)),m=!0)}else if(s===12){let D;y===91?(g=!0,D=0):D=h.get(y),D===1?m=!0:s=13}else s=d.nextState(s,y),s===0&&(m=!0);m&&(s=1,u=!1,g=!1,S=!1,f=t+1,o=y),t++}s===13&&c.push(P.a(h,a,i,f,r))}return c}}e.$X2=P;function p(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:P.computeLinks(E)}}),define(ke[80],De([1,0,24]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$1v=e.$Zv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$2v=v,e.$6v=a;var L;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(L||(e.OverviewRulerLane=L={}));var M;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(M||(e.GlyphMarginLane=M={}));var A;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var R;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var w;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(w||(e.InjectedTextCursorStops=w={}));var $;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var k;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(k||(e.DefaultEndOfLine=k={}));var I;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class P{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,l.$$n)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$Zv=P;class p{constructor(t,f){this._findMatchBrand=void 0,this.range=t,this.matches=f}}e.$1v=p;var E;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(E||(e.TrackedRangeStickiness=E={}));function v(r){return r&&typeof r.read=="function"}var d;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(d||(e.PositionAffinity=d={}));var h;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(h||(e.ModelConstants=h={}));class c{constructor(t,f,o,s,u,g){this.identifier=t,this.range=f,this.text=o,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=u,this._isTracked=g}}e.$3v=c;class i{constructor(t,f,o){this.regex=t,this.wordSeparators=f,this.simpleSearch=o}}e.$4v=i;class n{constructor(t,f,o){this.reverseEdits=t,this.changes=f,this.trimAutoWhitespaceLineNumbers=o}}e.$5v=n;function a(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}}),define(ke[186],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.NodeColor=e.$LC=void 0,e.$NC=M,e.$OC=A,e.$PC=k,e.$QC=I,e.$RC=P,e.$SC=p,e.$TC=E,e.$UC=v;class l{constructor(h,c){this.piece=h,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$MC)return M(this.right);let h=this;for(;h.parent!==e.$MC&&h.parent.left!==h;)h=h.parent;return h.parent===e.$MC?e.$MC:h.parent}prev(){if(this.left!==e.$MC)return A(this.left);let h=this;for(;h.parent!==e.$MC&&h.parent.right!==h;)h=h.parent;return h.parent===e.$MC?e.$MC:h.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$LC=l;var L;(function(d){d[d.Black=0]="Black",d[d.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$MC=new l(null,0),e.$MC.parent=e.$MC,e.$MC.left=e.$MC,e.$MC.right=e.$MC,e.$MC.color=0;function M(d){for(;d.left!==e.$MC;)d=d.left;return d}function A(d){for(;d.right!==e.$MC;)d=d.right;return d}function R(d){return d===e.$MC?0:d.size_left+d.piece.length+R(d.right)}function w(d){return d===e.$MC?0:d.lf_left+d.piece.lineFeedCnt+w(d.right)}function $(){e.$MC.parent=e.$MC}function k(d,h){const c=h.right;c.size_left+=h.size_left+(h.piece?h.piece.length:0),c.lf_left+=h.lf_left+(h.piece?h.piece.lineFeedCnt:0),h.right=c.left,c.left!==e.$MC&&(c.left.parent=h),c.parent=h.parent,h.parent===e.$MC?d.root=c:h.parent.left===h?h.parent.left=c:h.parent.right=c,c.left=h,h.parent=c}function I(d,h){const c=h.left;h.left=c.right,c.right!==e.$MC&&(c.right.parent=h),c.parent=h.parent,h.size_left-=c.size_left+(c.piece?c.piece.length:0),h.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),h.parent===e.$MC?d.root=c:h===h.parent.right?h.parent.right=c:h.parent.left=c,c.right=h,h.parent=c}function P(d,h){let c,i;if(h.left===e.$MC?(i=h,c=i.right):h.right===e.$MC?(i=h,c=i.left):(i=M(h.right),c=i.right),i===d.root){d.root=c,c.color=0,h.detach(),$(),d.root.parent=e.$MC;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=c:i.parent.right=c,i===h?(c.parent=i.parent,v(d,c)):(i.parent===h?c.parent=i:c.parent=i.parent,v(d,c),i.left=h.left,i.right=h.right,i.parent=h.parent,i.color=h.color,h===d.root?d.root=i:h===h.parent.left?h.parent.left=i:h.parent.right=i,i.left!==e.$MC&&(i.left.parent=i),i.right!==e.$MC&&(i.right.parent=i),i.size_left=h.size_left,i.lf_left=h.lf_left,v(d,i)),h.detach(),c.parent.left===c){const r=R(c),t=w(c);if(r!==c.parent.size_left||t!==c.parent.lf_left){const f=r-c.parent.size_left,o=t-c.parent.lf_left;c.parent.size_left=r,c.parent.lf_left=t,E(d,c.parent,f,o)}}if(v(d,c.parent),n){$();return}let a;for(;c!==d.root&&c.color===0;)c===c.parent.left?(a=c.parent.right,a.color===1&&(a.color=0,c.parent.color=1,k(d,c.parent),a=c.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,c=c.parent):(a.right.color===0&&(a.left.color=0,a.color=1,I(d,a),a=c.parent.right),a.color=c.parent.color,c.parent.color=0,a.right.color=0,k(d,c.parent),c=d.root)):(a=c.parent.left,a.color===1&&(a.color=0,c.parent.color=1,I(d,c.parent),a=c.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,c=c.parent):(a.left.color===0&&(a.right.color=0,a.color=1,k(d,a),a=c.parent.left),a.color=c.parent.color,c.parent.color=0,a.left.color=0,I(d,c.parent),c=d.root));c.color=0,$()}function p(d,h){for(v(d,h);h!==d.root&&h.parent.color===1;)if(h.parent===h.parent.parent.left){const c=h.parent.parent.right;c.color===1?(h.parent.color=0,c.color=0,h.parent.parent.color=1,h=h.parent.parent):(h===h.parent.right&&(h=h.parent,k(d,h)),h.parent.color=0,h.parent.parent.color=1,I(d,h.parent.parent))}else{const c=h.parent.parent.left;c.color===1?(h.parent.color=0,c.color=0,h.parent.parent.color=1,h=h.parent.parent):(h===h.parent.left&&(h=h.parent,I(d,h)),h.parent.color=0,h.parent.parent.color=1,k(d,h.parent.parent))}d.root.color=0}function E(d,h,c,i){for(;h!==d.root&&h!==e.$MC;)h.parent.left===h&&(h.parent.size_left+=c,h.parent.lf_left+=i),h=h.parent}function v(d,h){let c=0,i=0;if(h!==d.root){for(;h!==d.root&&h===h.parent.right;)h=h.parent;if(h!==d.root)for(h=h.parent,c=R(h.left)-h.size_left,i=w(h.left)-h.lf_left,h.size_left+=c,h.lf_left+=i;h!==d.root&&(c!==0||i!==0);)h.parent.left===h&&(h.parent.size_left+=c,h.parent.lf_left+=i),h=h.parent}}}),define(ke[187],De([1,0,19,128]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$v=e.$0v=e.$9v=void 0;class M{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,k){$=(0,L.$0e)($);const I=this.a,P=this.b,p=k.length;return p===0?!1:(this.a=new Uint32Array(I.length+p),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($),$+p),this.a.set(k,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue($,k){return $=(0,L.$0e)($),k=(0,L.$0e)(k),this.a[$]===k?!1:(this.a[$]=k,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,k){$=(0,L.$0e)($),k=(0,L.$0e)(k);const I=this.a,P=this.b;if($>=I.length)return!1;const p=I.length-$;return k>=p&&(k=p),k===0?!1:(this.a=new Uint32Array(I.length-k),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($+k),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,L.$0e)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),$>=this.a.length&&($=this.a.length-1);for(let I=k;I<=$;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let k=0,I=this.a.length-1,P=0,p=0,E=0;for(;k<=I;)if(P=k+(I-k)/2|0,p=this.b[P],E=p-this.a[P],$<E)I=P-1;else if($>=p)k=P+1;else break;return new R(P,$-E)}}e.$9v=M;class A{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const k=this.e[$],I=k>0?this.d[k-1]:0;return new R(k,$-I)}removeValues($,k){this.a.splice($,k),this.f($)}insertValues($,k){this.a=(0,l.$Vb)(this.a,$,k),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,k=this.a.length;$<k;$++){const I=this.a[$],P=$>0?this.d[$-1]:0;this.d[$]=P+I;for(let p=0;p<I;p++)this.e[P+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,k){this.a[$]!==k&&(this.a[$]=k,this.f($))}}e.$0v=A;class R{constructor($,k){this.index=$,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=k}}e.$$v=R}),define(ke[188],De([1,0,14,51,187]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_v=void 0;class A{constructor(w,$,k,I){this.d=w,this.f=$,this.g=k,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const $=w.changes;for(const k of $)this.o(k.range),this.p(new L.$zt(k.range.startLineNumber,k.range.startColumn),k.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,$=this.f.length,k=new Uint32Array($);for(let I=0;I<$;I++)k[I]=this.f[I].length+w;this.j=new M.$9v(k)}}n(w,$){this.f[w]=$,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,$){if($.length===0)return;const k=(0,l.$of)($);if(k.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+k[0]+this.f[w.lineNumber-1].substring(w.column-1));return}k[k.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+k[0]);const I=new Uint32Array(k.length-1);for(let P=1;P<k.length;P++)this.f.splice(w.lineNumber+P-1,0,k[P]),I[P-1]=k[P].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,I)}}e.$_v=A}),define(ke[100],De([1,0,14,183,51,29,80]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$YC=e.$VC=void 0,e.$WC=k,e.$XC=I,e.$ZC=d;const w=999;class ${constructor(i,n,a,r){this.searchString=i,this.isRegex=n,this.matchCase=a,this.wordSeparators=r}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=k(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=l.$mf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let a=!this.isRegex&&!i;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new R.$4v(n,this.wordSeparators?(0,L.$8t)(this.wordSeparators,[]):null,a?this.searchString:null)}}e.$VC=$;function k(c){if(!c||c.length===0)return!1;for(let i=0,n=c.length;i<n;i++){const a=c.charCodeAt(i);if(a===10)return!0;if(a===92){if(i++,i>=n)break;const r=c.charCodeAt(i);if(r===110||r===114||r===87)return!0}}return!1}function I(c,i,n){if(!n)return new R.$1v(c,null);const a=[];for(let r=0,t=i.length;r<t;r++)a[r]=i[r];return new R.$1v(c,a)}class P{constructor(i){const n=[];let a=0;for(let r=0,t=i.length;r<t;r++)i.charCodeAt(r)===10&&(n[a++]=r);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let a=0,r=n.length-1;if(r===-1||i<=n[0])return 0;for(;a<r;){const t=a+((r-a)/2>>0);n[t]>=i?r=t-1:n[t+1]>=i?(a=t,r=t):a=t+1}return a+1}}class p{static findMatches(i,n,a,r,t){const f=n.parseSearchRequest();return f?f.regex.multiline?this.b(i,a,new h(f.wordSeparators,f.regex),r,t):this.c(i,a,f,r,t):[]}static a(i,n,a,r,t,f){let o,s=0;r?(s=r.findLineFeedCountBeforeOffset(t),o=n+t+s):o=n+t;let u;if(r){const m=r.findLineFeedCountBeforeOffset(t+f.length)-s;u=o+f.length+m}else u=o+f.length;const g=i.getPositionAt(o),b=i.getPositionAt(u);return new A.$At(g.lineNumber,g.column,b.lineNumber,b.column)}static b(i,n,a,r,t){const f=i.getOffsetAt(n.getStartPosition()),o=i.getValueInRange(n,1),s=i.getEOL()===`\r
`?new P(o):null,u=[];let g=0,b;for(a.reset(0);b=a.next(o);)if(u[g++]=I(this.a(i,f,o,s,b.index,b[0]),b,r),g>=t)return u;return u}static c(i,n,a,r,t){const f=[];let o=0;if(n.startLineNumber===n.endLineNumber){const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return o=this.d(a,u,n.startLineNumber,n.startColumn-1,o,f,r,t),f}const s=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);o=this.d(a,s,n.startLineNumber,n.startColumn-1,o,f,r,t);for(let u=n.startLineNumber+1;u<n.endLineNumber&&o<t;u++)o=this.d(a,i.getLineContent(u),u,0,o,f,r,t);if(o<t){const u=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);o=this.d(a,u,n.endLineNumber,0,o,f,r,t)}return f}static d(i,n,a,r,t,f,o,s){const u=i.wordSeparators;if(!o&&i.simpleSearch){const S=i.simpleSearch,m=S.length,y=n.length;let D=-m;for(;(D=n.indexOf(S,D+m))!==-1;)if((!u||d(u,n,y,D,m))&&(f[t++]=new R.$1v(new A.$At(a,D+1+r,a,D+1+m+r),null),t>=s))return t;return t}const g=new h(i.wordSeparators,i.regex);let b;g.reset(0);do if(b=g.next(n),b&&(f[t++]=I(new A.$At(a,b.index+1+r,a,b.index+1+b[0].length+r),b,o),t>=s))return t;while(b);return t}static findNextMatch(i,n,a,r){const t=n.parseSearchRequest();if(!t)return null;const f=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,a,f,r):this.f(i,a,f,r)}static e(i,n,a,r){const t=new M.$zt(n.lineNumber,1),f=i.getOffsetAt(t),o=i.getLineCount(),s=i.getValueInRange(new A.$At(t.lineNumber,t.column,o,i.getLineMaxColumn(o)),1),u=i.getEOL()===`\r
`?new P(s):null;a.reset(n.column-1);const g=a.next(s);return g?I(this.a(i,f,s,u,g.index,g[0]),g,r):n.lineNumber!==1||n.column!==1?this.e(i,new M.$zt(1,1),a,r):null}static f(i,n,a,r){const t=i.getLineCount(),f=n.lineNumber,o=i.getLineContent(f),s=this.g(a,o,f,n.column,r);if(s)return s;for(let u=1;u<=t;u++){const g=(f+u-1)%t,b=i.getLineContent(g+1),S=this.g(a,b,g+1,1,r);if(S)return S}return null}static g(i,n,a,r,t){i.reset(r-1);const f=i.next(n);return f?I(new A.$At(a,f.index+1,a,f.index+1+f[0].length),f,t):null}static findPreviousMatch(i,n,a,r){const t=n.parseSearchRequest();if(!t)return null;const f=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,a,f,r):this.j(i,a,f,r)}static h(i,n,a,r){const t=this.b(i,new A.$At(1,1,n.lineNumber,n.column),a,r,10*w);if(t.length>0)return t[t.length-1];const f=i.getLineCount();return n.lineNumber!==f||n.column!==i.getLineMaxColumn(f)?this.h(i,new M.$zt(f,i.getLineMaxColumn(f)),a,r):null}static j(i,n,a,r){const t=i.getLineCount(),f=n.lineNumber,o=i.getLineContent(f).substring(0,n.column-1),s=this.k(a,o,f,r);if(s)return s;for(let u=1;u<=t;u++){const g=(t+f-u-1)%t,b=i.getLineContent(g+1),S=this.k(a,b,g+1,r);if(S)return S}return null}static k(i,n,a,r){let t=null,f;for(i.reset(0);f=i.next(n);)t=I(new A.$At(a,f.index+1,a,f.index+1+f[0].length),f,r);return t}}e.$YC=p;function E(c,i,n,a,r){if(a===0)return!0;const t=i.charCodeAt(a-1);if(c.get(t)!==0||t===13||t===10)return!0;if(r>0){const f=i.charCodeAt(a);if(c.get(f)!==0)return!0}return!1}function v(c,i,n,a,r){if(a+r===n)return!0;const t=i.charCodeAt(a+r);if(c.get(t)!==0||t===13||t===10)return!0;if(r>0){const f=i.charCodeAt(a+r-1);if(c.get(f)!==0)return!0}return!1}function d(c,i,n,a,r){return E(c,i,n,a,r)&&v(c,i,n,a,r)}class h{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let a;do{if(this.b+this.c===n||(a=this.a.exec(i),!a))return null;const r=a.index,t=a[0].length;if(r===this.b&&t===this.c){if(t===0){l.$If(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=r,this.c=t,!this._wordSeparators||d(this._wordSeparators,i,n,r,t))return a}while(a);return null}}e.$1C=h}),define(ke[131],De([1,0,51,29,80,186,100]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=e.$5C=e.$4C=void 0,e.$2C=I,e.$3C=P;const w=65535;function $(c){let i;return c[c.length-1]<65536?i=new Uint16Array(c.length):i=new Uint32Array(c.length),i.set(c,0),i}class k{constructor(i,n,a,r,t){this.lineStarts=i,this.cr=n,this.lf=a,this.crlf=r,this.isBasicASCII=t}}function I(c,i=!0){const n=[0];let a=1;for(let r=0,t=c.length;r<t;r++){const f=c.charCodeAt(r);f===13?r+1<t&&c.charCodeAt(r+1)===10?(n[a++]=r+2,r++):n[a++]=r+1:f===10&&(n[a++]=r+1)}return i?$(n):n}function P(c,i){c.length=0,c[0]=0;let n=1,a=0,r=0,t=0,f=!0;for(let s=0,u=i.length;s<u;s++){const g=i.charCodeAt(s);g===13?s+1<u&&i.charCodeAt(s+1)===10?(t++,c[n++]=s+2,s++):(a++,c[n++]=s+1):g===10?(r++,c[n++]=s+1):f&&g!==9&&(g<32||g>126)&&(f=!1)}const o=new k($(c),a,r,t,f);return c.length=0,o}class p{constructor(i,n,a,r,t){this.bufferIndex=i,this.start=n,this.end=a,this.lineFeedCnt=r,this.length=t}}e.$4C=p;class E{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$5C=E;class v{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==A.$MC&&i.iterate(i.root,a=>(a!==A.$MC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class d{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const a=this.b[n];if(a.nodeStartOffset<=i&&a.nodeStartOffset+a.node.piece.length>=i)return a}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const a=this.b[n];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<i&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=i)return a}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const a=this.b;for(let r=0;r<a.length;r++){const t=a[r];if(t.node.parent===null||t.nodeStartOffset>=i){a[r]=null,n=!0;continue}}if(n){const r=[];for(const t of a)t!==null&&r.push(t);this.b=r}}}class h{constructor(i,n,a){this.create(i,n,a)}create(i,n,a){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=A.$MC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=a;let r=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=I(i[t].buffer));const o=new p(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),r=this.S(r,o)}this.h=new d(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=w,a=n-Math.floor(n/3),r=a*2;let t="",f=0;const o=[];if(this.iterate(this.root,s=>{const u=this.R(s),g=u.length;if(f<=a||f+g<r)return t+=u,f+=g,!0;const b=t.replace(/\r\n|\r|\n/g,i);return o.push(new E(b,I(b))),t=u,f=g,!0}),f>0){const s=t.replace(/\r\n|\r|\n/g,i);o.push(new E(s,I(s)))}this.create(o,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new v(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,r=>{if(r===A.$MC)return!0;const t=this.R(r),f=t.length,o=i.G(n),s=i.G(n+f),u=i.getValueInRange2(o,s);return n+=f,t===u})}getOffsetAt(i,n){let a=0,r=this.root;for(;r!==A.$MC;)if(r.left!==A.$MC&&r.lf_left+1>=i)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt+1>=i){a+=r.size_left;const t=this.B(r,i-r.lf_left-2);return a+=t+n-1}else i-=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;return a}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,a=0;const r=i;for(;n!==A.$MC;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(a+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(a+1,1),o=r-f;return new l.$zt(a+1,o+1)}return new l.$zt(a+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,a+=n.lf_left+n.piece.lineFeedCnt,n.right===A.$MC){const t=this.getOffsetAt(a+1,1),f=r-i-t;return new l.$zt(a+1,f+1)}else n=n.right;return new l.$zt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const a=this.H(i.startLineNumber,i.startColumn),r=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(a,r);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const o=i.node,s=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);return s.substring(u+i.remainder,u+n.remainder)}let a=i.node;const r=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let f=r.substring(t+i.remainder,t+a.piece.length);for(a=a.next();a!==A.$MC;){const o=this.a[a.piece.bufferIndex].buffer,s=this.u(a.piece.bufferIndex,a.piece.start);if(a===n.node){f+=o.substring(s,s+n.remainder);break}else f+=o.substr(s,a.piece.length);a=a.next()}return f}getLinesContent(){const i=[];let n=0,a="",r=!1;return this.iterate(this.root,t=>{if(t===A.$MC)return!0;const f=t.piece;let o=f.length;if(o===0)return!0;const s=this.a[f.bufferIndex].buffer,u=this.a[f.bufferIndex].lineStarts,g=f.start.line,b=f.end.line;let S=u[g]+f.start.column;if(r&&(s.charCodeAt(S)===10&&(S++,o--),i[n++]=a,a="",r=!1,o===0))return!0;if(g===b)return!this.f&&s.charCodeAt(S+o-1)===13?(r=!0,a+=s.substr(S,o-1)):a+=s.substr(S,o),!0;a+=this.f?s.substring(S,Math.max(S,u[g+1]-this.e)):s.substring(S,u[g+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=a;for(let m=g+1;m<b;m++)a=this.f?s.substring(u[m],u[m+1]-this.e):s.substring(u[m],u[m+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=a;return!this.f&&s.charCodeAt(u[b]+f.end.column-1)===13?(r=!0,f.end.column===0?n--:a=s.substr(u[b],f.end.column-1)):a=s.substr(u[b],f.end.column),!0}),r&&(i[n++]=a,a=""),i[n++]=a,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const a=this.a[n.piece.bufferIndex],r=this.u(n.piece.bufferIndex,n.piece.start);return a.buffer.charCodeAt(r)}else{const n=this.a[i.node.piece.bufferIndex],r=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(r)}}getLineCharCode(i,n){const a=this.H(i,n+1);return this.l(a)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,a,r,t,f,o,s,u,g,b){const S=this.a[i.piece.bufferIndex],m=this.u(i.piece.bufferIndex,i.piece.start),y=this.u(i.piece.bufferIndex,t),D=this.u(i.piece.bufferIndex,f);let C;const O={line:0,column:0};let z,T;n._wordSeparators?(z=S.buffer.substring(y,D),T=F=>F+y,n.reset(0)):(z=S.buffer,T=F=>F,n.reset(y));do if(C=n.next(z),C){if(T(C.index)>=D)return g;this.s(i,T(C.index)-m,O);const F=this.t(i.piece.bufferIndex,t,O),N=O.line===t.line?O.column-t.column+r:O.column+1,j=N+C[0].length;if(b[g++]=(0,R.$XC)(new L.$At(a+F,N,a+F,j),C,s),T(C.index)+C[0].length>=D||g>=u)return g}while(C);return g}findMatchesLineByLine(i,n,a,r){const t=[];let f=0;const o=new R.$1C(n.wordSeparators,n.regex);let s=this.H(i.startLineNumber,i.startColumn);if(s===null)return[];const u=this.H(i.endLineNumber,i.endColumn);if(u===null)return[];let g=this.s(s.node,s.remainder);const b=this.s(u.node,u.remainder);if(s.node===u.node)return this.findMatchesInNode(s.node,o,i.startLineNumber,i.startColumn,g,b,n,a,r,f,t),t;let S=i.startLineNumber,m=s.node;for(;m!==u.node;){const D=this.t(m.piece.bufferIndex,g,m.piece.end);if(D>=1){const O=this.a[m.piece.bufferIndex].lineStarts,z=this.u(m.piece.bufferIndex,m.piece.start),T=O[g.line+D],F=S===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(m,o,S,F,g,this.s(m,T-z),n,a,r,f,t),f>=r)return t;S+=D}const C=S===i.startLineNumber?i.startColumn-1:0;if(S===i.endLineNumber){const O=this.getLineContent(S).substring(C,i.endColumn-1);return f=this.n(n,o,O,i.endLineNumber,C,f,t,a,r),t}if(f=this.n(n,o,this.getLineContent(S).substr(C),S,C,f,t,a,r),f>=r)return t;S++,s=this.H(S,1),m=s.node,g=this.s(s.node,s.remainder)}if(S===i.endLineNumber){const D=S===i.startLineNumber?i.startColumn-1:0,C=this.getLineContent(S).substring(D,i.endColumn-1);return f=this.n(n,o,C,i.endLineNumber,D,f,t,a,r),t}const y=S===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(u.node,o,S,y,g,b,n,a,r,f,t),t}n(i,n,a,r,t,f,o,s,u){const g=i.wordSeparators;if(!s&&i.simpleSearch){const S=i.simpleSearch,m=S.length,y=a.length;let D=-m;for(;(D=a.indexOf(S,D+m))!==-1;)if((!g||(0,R.$ZC)(g,a,y,D,m))&&(o[f++]=new M.$1v(new L.$At(r,D+1+t,r,D+1+m+t),null),f>=u))return f;return f}let b;n.reset(0);do if(b=n.next(a),b&&(o[f++]=(0,R.$XC)(new L.$At(r,b.index+1+t,r,b.index+1+b[0].length+t),b,s),f>=u))return f;while(b);return f}insert(i,n,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==A.$MC){const{node:r,remainder:t,nodeStartOffset:f}=this.G(i),o=r.piece,s=o.bufferIndex,u=this.s(r,t);if(r.piece.bufferIndex===0&&o.end.line===this.g.line&&o.end.column===this.g.column&&f+o.length===i&&n.length<w){this.F(r,n),this.y();return}if(f===i)this.o(n,r),this.h.validate(i);else if(f+r.piece.length>i){const g=[];let b=new p(o.bufferIndex,u,o.end,this.t(o.bufferIndex,u,o.end),this.u(s,o.end)-this.u(s,u));if(this.K()&&this.M(n)&&this.I(r,t)===10){const D={line:b.start.line+1,column:0};b=new p(b.bufferIndex,D,b.end,this.t(b.bufferIndex,D,b.end),b.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(r,t-1)===13){const D=this.s(r,t-1);this.C(r,D),n="\r"+n,r.piece.length===0&&g.push(r)}else this.C(r,u);else this.C(r,u);const S=this.w(n);b.length>0&&this.S(r,b);let m=r;for(let y=0;y<S.length;y++)m=this.S(m,S[y]);this.v(g)}else this.q(n,r)}else{const r=this.w(n);let t=this.T(null,r[0]);for(let f=1;f<r.length;f++)t=this.S(t,r[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===A.$MC)return;const a=this.G(i),r=this.G(i+n),t=a.node,f=r.node;if(t===f){const S=this.s(t,a.remainder),m=this.s(t,r.remainder);if(a.nodeStartOffset===i){if(n===t.piece.length){const y=t.next();(0,A.$RC)(this,t),this.N(y),this.y();return}this.D(t,m),this.h.validate(i),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===i+n){this.C(t,S),this.O(t),this.y();return}this.E(t,S,m),this.y();return}const o=[],s=this.s(t,a.remainder);this.C(t,s),this.h.validate(i),t.piece.length===0&&o.push(t);const u=this.s(f,r.remainder);this.D(f,u),f.piece.length===0&&o.push(f);const g=t.next();for(let S=g;S!==A.$MC&&S!==f;S=S.next())o.push(S);const b=t.piece.length===0?t.prev():t;this.v(o),this.O(b),this.y()}o(i,n){const a=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,o={line:f.start.line+1,column:0},s=new p(f.bufferIndex,o,f.end,this.t(f.bufferIndex,o,f.end),f.length-1);n.piece=s,i+=`
`,(0,A.$TC)(this,n,-1,-1),n.piece.length===0&&a.push(n)}const r=this.w(i);let t=this.T(n,r[r.length-1]);for(let f=r.length-2;f>=0;f--)t=this.T(t,r[f]);this.N(t),this.v(a)}q(i,n){this.Q(i,n)&&(i+=`
`);const a=this.w(i),r=this.S(n,a[0]);let t=r;for(let f=1;f<a.length;f++)t=this.S(t,a[f]);this.N(r)}s(i,n,a){const r=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,s=f[r.start.line]+r.start.column+n;let u=r.start.line,g=r.end.line,b=0,S=0,m=0;for(;u<=g&&(b=u+(g-u)/2|0,m=f[b],b!==g);)if(S=f[b+1],s<m)g=b-1;else if(s>=S)u=b+1;else break;return a?(a.line=b,a.column=s-m,null):{line:b,column:s-m}}t(i,n,a){if(a.column===0)return a.line-n.line;const r=this.a[i].lineStarts;if(a.line===r.length-1)return a.line-n.line;const t=r[a.line+1],f=r[a.line]+a.column;if(t>f+1)return a.line-n.line;const o=f-1;return this.a[i].buffer.charCodeAt(o)===13?a.line-n.line+1:a.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,A.$RC)(this,i[n])}w(i){if(i.length>w){const g=[];for(;i.length>w;){const S=i.charCodeAt(w-1);let m;S===13||S>=55296&&S<=56319?(m=i.substring(0,w-1),i=i.substring(w-1)):(m=i.substring(0,w),i=i.substring(w));const y=I(m);g.push(new p(this.a.length,{line:0,column:0},{line:y.length-1,column:m.length-y[y.length-1]},y.length-1,m.length)),this.a.push(new E(m,y))}const b=I(i);return g.push(new p(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new E(i,b)),g}let n=this.a[0].buffer.length;const a=I(i,!1);let r=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},r=this.g;for(let g=0;g<a.length;g++)a[g]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let g=0;g<a.length;g++)a[g]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,o=t-this.a[0].lineStarts[f],s={line:f,column:o},u=new p(0,r,s,this.t(0,r,s),t-n);return this.g=s,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let a=this.root,r="";const t=this.h.get2(i);if(t){a=t.node;const f=this.B(a,i-t.nodeStartLineNumber-1),o=this.a[a.piece.bufferIndex].buffer,s=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===i)r=o.substring(s+f,s+a.piece.length);else{const u=this.B(a,i-t.nodeStartLineNumber);return o.substring(s+f,s+u-n)}}else{let f=0;const o=i;for(;a!==A.$MC;)if(a.left!==A.$MC&&a.lf_left>=i-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>i-1){const s=this.B(a,i-a.lf_left-2),u=this.B(a,i-a.lf_left-1),g=this.a[a.piece.bufferIndex].buffer,b=this.u(a.piece.bufferIndex,a.piece.start);return f+=a.size_left,this.h.set({node:a,nodeStartOffset:f,nodeStartLineNumber:o-(i-1-a.lf_left)}),g.substring(b+s,b+u-n)}else if(a.lf_left+a.piece.lineFeedCnt===i-1){const s=this.B(a,i-a.lf_left-2),u=this.a[a.piece.bufferIndex].buffer,g=this.u(a.piece.bufferIndex,a.piece.start);r=u.substring(g+s,g+a.piece.length);break}else i-=a.lf_left+a.piece.lineFeedCnt,f+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==A.$MC;){const f=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const o=this.B(a,0),s=this.u(a.piece.bufferIndex,a.piece.start);return r+=f.substring(s,s+o-n),r}else{const o=this.u(a.piece.bufferIndex,a.piece.start);r+=f.substr(o,a.piece.length)}a=a.next()}return r}y(){let i=this.root,n=1,a=0;for(;i!==A.$MC;)n+=i.lf_left+i.piece.lineFeedCnt,a+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=a,this.h.validate(this.c)}A(i,n){const a=i.piece,r=this.s(i,n),t=r.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===n){const f=this.t(i.piece.bufferIndex,a.start,r);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:r.column}}B(i,n){if(n<0)return 0;const a=i.piece,r=this.a[a.bufferIndex].lineStarts,t=a.start.line+n+1;return t>a.end.line?r[a.end.line]+a.end.column-r[a.start.line]-a.start.column:r[t]-r[a.start.line]-a.start.column}C(i,n){const a=i.piece,r=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),f=n,o=this.u(a.bufferIndex,f),s=this.t(a.bufferIndex,a.start,f),u=s-r,g=o-t,b=a.length+g;i.piece=new p(a.bufferIndex,a.start,f,s,b),(0,A.$TC)(this,i,g,u)}D(i,n){const a=i.piece,r=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),f=n,o=this.t(a.bufferIndex,f,a.end),s=this.u(a.bufferIndex,f),u=o-r,g=t-s,b=a.length+g;i.piece=new p(a.bufferIndex,f,a.end,o,b),(0,A.$TC)(this,i,g,u)}E(i,n,a){const r=i.piece,t=r.start,f=r.end,o=r.length,s=r.lineFeedCnt,u=n,g=this.t(r.bufferIndex,r.start,u),b=this.u(r.bufferIndex,n)-this.u(r.bufferIndex,t);i.piece=new p(r.bufferIndex,r.start,u,g,b),(0,A.$TC)(this,i,b-o,g-s);const S=new p(r.bufferIndex,a,f,this.t(r.bufferIndex,a,f),this.u(r.bufferIndex,f)-this.u(r.bufferIndex,a)),m=this.S(i,S);this.N(m)}F(i,n){this.Q(n,i)&&(n+=`
`);const a=this.K()&&this.L(n)&&this.M(i),r=this.a[0].buffer.length;this.a[0].buffer+=n;const t=I(n,!1);for(let m=0;m<t.length;m++)t[m]+=r;if(a){const m=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:r-m}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,o=this.a[0].buffer.length-this.a[0].lineStarts[f],s={line:f,column:o},u=i.piece.length+n.length,g=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,s),S=b-g;i.piece=new p(i.piece.bufferIndex,i.piece.start,s,b,u),this.g=s,(0,A.$TC)(this,i,n.length,S)}G(i){let n=this.root;const a=this.h.get(i);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:i-a.nodeStartOffset};let r=0;for(;n!==A.$MC;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){r+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:r};return this.h.set(t),t}else i-=n.size_left+n.piece.length,r+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let a=this.root,r=0;for(;a!==A.$MC;)if(a.left!==A.$MC&&a.lf_left>=i-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>i-1){const t=this.B(a,i-a.lf_left-2),f=this.B(a,i-a.lf_left-1);return r+=a.size_left,{node:a,remainder:Math.min(t+n-1,f),nodeStartOffset:r}}else if(a.lf_left+a.piece.lineFeedCnt===i-1){const t=this.B(a,i-a.lf_left-2);if(t+n-1<=a.piece.length)return{node:a,remainder:t+n-1,nodeStartOffset:r};n-=a.piece.length-t;break}else i-=a.lf_left+a.piece.lineFeedCnt,r+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==A.$MC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),f=this.J(a);return{node:a,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(a.piece.length>=n-1){const t=this.J(a);return{node:a,remainder:n-1,nodeStartOffset:t}}else n-=a.piece.length;a=a.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const a=this.a[i.piece.bufferIndex],r=this.u(i.piece.bufferIndex,i.piece.start)+n;return a.buffer.charCodeAt(r)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$MC||i.piece.lineFeedCnt===0)return!1;const n=i.piece,a=this.a[n.bufferIndex].lineStarts,r=n.start.line,t=a[r]+n.start.column;return r===a.length-1||a[r+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$MC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const a=[],r=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:r[i.piece.end.line]-r[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,o=i.piece.lineFeedCnt-1;i.piece=new p(i.piece.bufferIndex,i.piece.start,t,o,f),(0,A.$TC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const s={line:n.piece.start.line+1,column:0},u=n.piece.length-1,g=this.t(n.piece.bufferIndex,s,n.piece.end);n.piece=new p(n.piece.bufferIndex,s,n.piece.end,g,u),(0,A.$TC)(this,n,-1,-1),n.piece.length===0&&a.push(n);const b=this.w(`\r
`);this.S(i,b[0]);for(let S=0;S<a.length;S++)(0,A.$RC)(this,a[S])}Q(i,n){if(this.K()&&this.M(i)){const a=n.next();if(this.L(a)){if(i+=`
`,a.piece.length===1)(0,A.$RC)(this,a);else{const r=a.piece,t={line:r.start.line+1,column:0},f=r.length-1,o=this.t(r.bufferIndex,t,r.end);a.piece=new p(r.bufferIndex,t,r.end,o,f),(0,A.$TC)(this,a,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.$MC)return n(A.$MC);const a=this.iterate(i.left,n);return a&&n(i)&&this.iterate(i.right,n)}R(i){if(i===A.$MC)return"";const n=this.a[i.piece.bufferIndex],a=i.piece,r=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return n.buffer.substring(r,t)}getPieceContent(i){const n=this.a[i.bufferIndex],a=this.u(i.bufferIndex,i.start),r=this.u(i.bufferIndex,i.end);return n.buffer.substring(a,r)}S(i,n){const a=new A.$LC(n,1);if(a.left=A.$MC,a.right=A.$MC,a.parent=A.$MC,a.size_left=0,a.lf_left=0,this.root===A.$MC)this.root=a,a.color=0;else if(i.right===A.$MC)i.right=a,a.parent=i;else{const t=(0,A.$NC)(i.right);t.left=a,a.parent=t}return(0,A.$SC)(this,a),a}T(i,n){const a=new A.$LC(n,1);if(a.left=A.$MC,a.right=A.$MC,a.parent=A.$MC,a.size_left=0,a.lf_left=0,this.root===A.$MC)this.root=a,a.color=0;else if(i.left===A.$MC)i.left=a,a.parent=i;else{const r=(0,A.$OC)(i.left);r.right=a,a.parent=r}return(0,A.$SC)(this,a),a}U(i){let n="";return this.iterate(i,a=>(n+=this.R(a),!0)),n}}e.$6C=h}),define(ke[189],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0=e.$W0=void 0;class l{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const R=this.a.get(A);return this.a.delete(A),R}}addDragOperationTransfer(A,R){this.a.set(A,R)}}e.$W0=l;class L{constructor(A){this.identifier=A}}e.$X0=L}),define(ke[190],De([1,0,4,3]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=void 0;class M{constructor(){this.a=new Map,this.b=new Map,this.c=new l.$he,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,$){return this.a.set(w,$),this.handleChange([w]),(0,L.$Sc)(()=>{this.a.get(w)===$&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,$){this.b.get(w)?.dispose();const k=new A(this,w,$);return this.b.set(w,k),(0,L.$Sc)(()=>{const I=this.b.get(w);!I||I!==k||(this.b.delete(w),I.dispose())})}async getOrCreate(w){const $=this.get(w);if($)return $;const k=this.b.get(w);return!k||k.isResolved?null:(await k.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const k=this.b.get(w);return!!(!k||k.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ju=M;class A extends L.$Uc{get isResolved(){return this.c}constructor(w,$,k){super(),this.f=w,this.g=$,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),define(ke[191],De([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(ke[192],De([1,0,4,3,191]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=I;class A extends L.$Uc{constructor(p,E="",v="",d=!0,h){super(),this.j=this.B(new l.$he),this.onDidChange=this.j.event,this.z=!0,this.m=p,this.n=E,this.w=v,this.z=d,this.D=h}get id(){return this.m}get label(){return this.n}set label(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.j.fire({label:p}))}get tooltip(){return this.u||""}set tooltip(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.j.fire({tooltip:p}))}get class(){return this.w}set class(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.j.fire({class:p}))}get enabled(){return this.z}set enabled(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.j.fire({enabled:p}))}get checked(){return this.C}set checked(p){this.J(p)}J(p){this.C!==p&&(this.C=p,this.j.fire({checked:p}))}async run(p,E){this.D&&await this.D(p)}}e.$fj=A;class R extends L.$Uc{constructor(){super(...arguments),this.f=this.B(new l.$he),this.onWillRun=this.f.event,this.m=this.B(new l.$he),this.onDidRun=this.m.event}async run(p,E){if(!p.enabled)return;this.f.fire({action:p});let v;try{await this.u(p,E)}catch(d){v=d}this.m.fire({action:p,error:v})}async u(p,E){await p.run(E)}}e.$gj=R;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let E=[];for(const v of p)v.length&&(E.length?E=[...E,new w,...v]:E=v);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$hj=w;class ${get actions(){return this.a}constructor(p,E,v,d){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=E,this.class=d,this.a=v}async run(){}}e.$ij=$;class k extends A{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,M.localize(0,null),void 0,!1)}}e.$jj=k;function I(P){return{id:P.id,label:P.label,class:P.class,enabled:P.enabled??!0,checked:P.checked,run:async(...p)=>P.run(...p),tooltip:P.label}}}),define(ke[193],De([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(ke[194],De([1,0,193]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=k,e.$7m=I,e.$8m=P;const L=60,M=L*60,A=M*24,R=A*7,w=A*30,$=A*365;function k(p,E,v,d){typeof p!="number"&&(p=p.getTime());const h=Math.round((new Date().getTime()-p)/1e3);if(h<-30)return(0,l.localize)(0,null,k(new Date().getTime()+h*1e3,!1));if(!d&&h<30)return(0,l.localize)(1,null);let c;return h<L?(c=h,E?c===1?v?(0,l.localize)(2,null,c):(0,l.localize)(3,null,c):v?(0,l.localize)(4,null,c):(0,l.localize)(5,null,c):c===1?v?(0,l.localize)(6,null,c):(0,l.localize)(7,null,c):v?(0,l.localize)(8,null,c):(0,l.localize)(9,null,c)):h<M?(c=Math.floor(h/L),E?c===1?v?(0,l.localize)(10,null,c):(0,l.localize)(11,null,c):v?(0,l.localize)(12,null,c):(0,l.localize)(13,null,c):c===1?v?(0,l.localize)(14,null,c):(0,l.localize)(15,null,c):v?(0,l.localize)(16,null,c):(0,l.localize)(17,null,c)):h<A?(c=Math.floor(h/M),E?c===1?v?(0,l.localize)(18,null,c):(0,l.localize)(19,null,c):v?(0,l.localize)(20,null,c):(0,l.localize)(21,null,c):c===1?v?(0,l.localize)(22,null,c):(0,l.localize)(23,null,c):v?(0,l.localize)(24,null,c):(0,l.localize)(25,null,c)):h<R?(c=Math.floor(h/A),E?c===1?(0,l.localize)(26,null,c):(0,l.localize)(27,null,c):c===1?(0,l.localize)(28,null,c):(0,l.localize)(29,null,c)):h<w?(c=Math.floor(h/R),E?c===1?v?(0,l.localize)(30,null,c):(0,l.localize)(31,null,c):v?(0,l.localize)(32,null,c):(0,l.localize)(33,null,c):c===1?v?(0,l.localize)(34,null,c):(0,l.localize)(35,null,c):v?(0,l.localize)(36,null,c):(0,l.localize)(37,null,c)):h<$?(c=Math.floor(h/w),E?c===1?v?(0,l.localize)(38,null,c):(0,l.localize)(39,null,c):v?(0,l.localize)(40,null,c):(0,l.localize)(41,null,c):c===1?v?(0,l.localize)(42,null,c):(0,l.localize)(43,null,c):v?(0,l.localize)(44,null,c):(0,l.localize)(45,null,c)):(c=Math.floor(h/$),E?c===1?v?(0,l.localize)(46,null,c):(0,l.localize)(47,null,c):v?(0,l.localize)(48,null,c):(0,l.localize)(49,null,c):c===1?v?(0,l.localize)(50,null,c):(0,l.localize)(51,null,c):v?(0,l.localize)(52,null,c):(0,l.localize)(53,null,c))}function I(p,E){const v=Math.abs(p/1e3);return v<1?E?(0,l.localize)(54,null,p):(0,l.localize)(55,null,p):v<L?E?(0,l.localize)(56,null,Math.round(p)/1e3):(0,l.localize)(57,null,Math.round(p)/1e3):v<M?E?(0,l.localize)(58,null,Math.round(p/(1e3*L))):(0,l.localize)(59,null,Math.round(p/(1e3*L))):v<A?E?(0,l.localize)(60,null,Math.round(p/(1e3*M))):(0,l.localize)(61,null,Math.round(p/(1e3*M))):(0,l.localize)(62,null,Math.round(p/(1e3*A)))}function P(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[195],De([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(ke[47],De([1,0,19,18,195]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=$,e.$mj=k,e.$nj=I;function A(P,p){return p&&(P.stack||P.stacktrace)?M.localize(0,null,w(P),R(P.stack)||R(P.stacktrace)):w(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function w(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?M.localize(1,null,P.message):P.message||M.localize(2,null)}function $(P=null,p=!1){if(!P)return M.localize(3,null);if(Array.isArray(P)){const E=l.$Hb(P),v=$(E[0],p);return E.length>1?M.localize(4,null,v,E.length):v}if(L.$ag(P))return P;if(P.detail){const E=P.detail;if(E.error)return A(E.error,p);if(E.exception)return A(E.exception,p)}return P.stack?A(P,p):P.message?P.message:M.localize(5,null)}function k(P){const p=P;return p instanceof Error&&Array.isArray(p.actions)}function I(P,p){let E;return typeof P=="string"?E=new Error(P):E=P,E.actions=p,E}}),define(ke[196],De([9,10]),function(le,e){return le.create("vs/base/common/platform",e)}),define(ke[12],De([1,0,196]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=f,e.$D=S,e.$J=m,e.$g="en";let L=!1,M=!1,A=!1,R=!1,w=!1,$=!1,k=!1,I=!1,P=!1,p=!1,E,v=e.$g,d=e.$g,h,c;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const a=typeof n?.versions?.electron=="string",r=a&&n?.type==="renderer";if(typeof n=="object"){L=n.platform==="win32",M=n.platform==="darwin",A=n.platform==="linux",R=A&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,k=a,P=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,v=e.$g;const y=n.env.VSCODE_NLS_CONFIG;if(y)try{const D=JSON.parse(y),C=D.availableLanguages["*"];E=D.locale,d=D.osLocale,v=C||e.$g,h=D._translationsConfigFile}catch{}w=!0}else typeof navigator=="object"&&!r?(c=navigator.userAgent,L=c.indexOf("Windows")>=0,M=c.indexOf("Macintosh")>=0,I=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,p=c?.indexOf("Mobi")>=0,$=!0,E=l.getConfiguredDefaultLocale(l.localize(0,null))||e.$g,v=E,d=navigator.language):console.error("Unable to resolve platform.");var t;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let o=0;M?o=1:L?o=3:A&&(o=2),e.$i=L,e.$j=M,e.$k=A,e.$l=R,e.$m=w,e.$n=k,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=I,e.$s=p,e.$t=P,e.$u=o,e.$v=c,e.$w=v;var s;(function(y){function D(){return e.$w}y.value=D;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}y.isDefaultVariant=C;function O(){return e.$w==="en"}y.isDefault=O})(s||(e.Language=s={})),e.$x=E,e.$y=d,e.$z=h,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const y=[];i.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let O=0,z=y.length;O<z;O++){const T=y[O];if(T.id===C.data.vscodeScheduleAsyncWork){y.splice(O,1),T.callback();return}}});let D=0;return C=>{const O=++D;y.push({id:O,callback:C}),i.postMessage({vscodeScheduleAsyncWork:O},"*")}}return y=>setTimeout(y)})();var u;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=M||I?2:L?1:3;let g=!0,b=!1;function S(){if(!b){b=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,g=new Uint16Array(y.buffer)[0]===513}return g}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function m(y){return parseFloat(y)>=20}}),define(ke[52],De([1,0,12]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const A=M.process;L={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return l.$i?"win32":l.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(ke[16],De([1,0,52]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,M=97,A=90,R=122,w=46,$=47,k=92,I=58,P=63;class p extends Error{constructor(f,o,s){let u;typeof o=="string"&&o.indexOf("not ")===0?(u="must not be",o=o.replace(/^not /,"")):u="must be";const g=f.indexOf(".")!==-1?"property":"argument";let b=`The "${f}" ${g} ${u} of type ${o}`;b+=`. Received type ${typeof s}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,f){if(t===null||typeof t!="object")throw new p(f,"Object",t)}function v(t,f){if(typeof t!="string")throw new p(f,"string",t)}const d=l.$dc==="win32";function h(t){return t===$||t===k}function c(t){return t===$}function i(t){return t>=L&&t<=A||t>=M&&t<=R}function n(t,f,o,s){let u="",g=0,b=-1,S=0,m=0;for(let y=0;y<=t.length;++y){if(y<t.length)m=t.charCodeAt(y);else{if(s(m))break;m=$}if(s(m)){if(!(b===y-1||S===1))if(S===2){if(u.length<2||g!==2||u.charCodeAt(u.length-1)!==w||u.charCodeAt(u.length-2)!==w){if(u.length>2){const D=u.lastIndexOf(o);D===-1?(u="",g=0):(u=u.slice(0,D),g=u.length-1-u.lastIndexOf(o)),b=y,S=0;continue}else if(u.length!==0){u="",g=0,b=y,S=0;continue}}f&&(u+=u.length>0?`${o}..`:"..",g=2)}else u.length>0?u+=`${o}${t.slice(b+1,y)}`:u=t.slice(b+1,y),g=y-b-1;b=y,S=0}else m===w&&S!==-1?++S:S=-1}return u}function a(t,f){E(f,"pathObject");const o=f.dir||f.root,s=f.base||`${f.name||""}${f.ext||""}`;return o?o===f.root?`${o}${s}`:`${o}${t}${s}`:s}e.$fc={resolve(...t){let f="",o="",s=!1;for(let u=t.length-1;u>=-1;u--){let g;if(u>=0){if(g=t[u],v(g,"path"),g.length===0)continue}else f.length===0?g=l.cwd():(g=l.env[`=${f}`]||l.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==f.toLowerCase()&&g.charCodeAt(2)===k)&&(g=`${f}\\`));const b=g.length;let S=0,m="",y=!1;const D=g.charCodeAt(0);if(b===1)h(D)&&(S=1,y=!0);else if(h(D))if(y=!0,h(g.charCodeAt(1))){let C=2,O=C;for(;C<b&&!h(g.charCodeAt(C));)C++;if(C<b&&C!==O){const z=g.slice(O,C);for(O=C;C<b&&h(g.charCodeAt(C));)C++;if(C<b&&C!==O){for(O=C;C<b&&!h(g.charCodeAt(C));)C++;(C===b||C!==O)&&(m=`\\\\${z}\\${g.slice(O,C)}`,S=C)}}}else S=1;else i(D)&&g.charCodeAt(1)===I&&(m=g.slice(0,2),S=2,b>2&&h(g.charCodeAt(2))&&(y=!0,S=3));if(m.length>0)if(f.length>0){if(m.toLowerCase()!==f.toLowerCase())continue}else f=m;if(s){if(f.length>0)break}else if(o=`${g.slice(S)}\\${o}`,s=y,y&&f.length>0)break}return o=n(o,!s,"\\",h),s?`${f}\\${o}`:`${f}${o}`||"."},normalize(t){v(t,"path");const f=t.length;if(f===0)return".";let o=0,s,u=!1;const g=t.charCodeAt(0);if(f===1)return c(g)?"\\":t;if(h(g))if(u=!0,h(t.charCodeAt(1))){let S=2,m=S;for(;S<f&&!h(t.charCodeAt(S));)S++;if(S<f&&S!==m){const y=t.slice(m,S);for(m=S;S<f&&h(t.charCodeAt(S));)S++;if(S<f&&S!==m){for(m=S;S<f&&!h(t.charCodeAt(S));)S++;if(S===f)return`\\\\${y}\\${t.slice(m)}\\`;S!==m&&(s=`\\\\${y}\\${t.slice(m,S)}`,o=S)}}}else o=1;else i(g)&&t.charCodeAt(1)===I&&(s=t.slice(0,2),o=2,f>2&&h(t.charCodeAt(2))&&(u=!0,o=3));let b=o<f?n(t.slice(o),!u,"\\",h):"";return b.length===0&&!u&&(b="."),b.length>0&&h(t.charCodeAt(f-1))&&(b+="\\"),s===void 0?u?`\\${b}`:b:u?`${s}\\${b}`:`${s}${b}`},isAbsolute(t){v(t,"path");const f=t.length;if(f===0)return!1;const o=t.charCodeAt(0);return h(o)||f>2&&i(o)&&t.charCodeAt(1)===I&&h(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,o;for(let g=0;g<t.length;++g){const b=t[g];v(b,"path"),b.length>0&&(f===void 0?f=o=b:f+=`\\${b}`)}if(f===void 0)return".";let s=!0,u=0;if(typeof o=="string"&&h(o.charCodeAt(0))){++u;const g=o.length;g>1&&h(o.charCodeAt(1))&&(++u,g>2&&(h(o.charCodeAt(2))?++u:s=!1))}if(s){for(;u<f.length&&h(f.charCodeAt(u));)u++;u>=2&&(f=`\\${f.slice(u)}`)}return e.$fc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f)return"";const o=e.$fc.resolve(t),s=e.$fc.resolve(f);if(o===s||(t=o.toLowerCase(),f=s.toLowerCase(),t===f))return"";let u=0;for(;u<t.length&&t.charCodeAt(u)===k;)u++;let g=t.length;for(;g-1>u&&t.charCodeAt(g-1)===k;)g--;const b=g-u;let S=0;for(;S<f.length&&f.charCodeAt(S)===k;)S++;let m=f.length;for(;m-1>S&&f.charCodeAt(m-1)===k;)m--;const y=m-S,D=b<y?b:y;let C=-1,O=0;for(;O<D;O++){const T=t.charCodeAt(u+O);if(T!==f.charCodeAt(S+O))break;T===k&&(C=O)}if(O!==D){if(C===-1)return s}else{if(y>D){if(f.charCodeAt(S+O)===k)return s.slice(S+O+1);if(O===2)return s.slice(S+O)}b>D&&(t.charCodeAt(u+O)===k?C=O:O===2&&(C=3)),C===-1&&(C=0)}let z="";for(O=u+C+1;O<=g;++O)(O===g||t.charCodeAt(O)===k)&&(z+=z.length===0?"..":"\\..");return S+=C,z.length>0?`${z}${s.slice(S,m)}`:(s.charCodeAt(S)===k&&++S,s.slice(S,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$fc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===k){if(f.charCodeAt(1)===k){const o=f.charCodeAt(2);if(o!==P&&o!==w)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(i(f.charCodeAt(0))&&f.charCodeAt(1)===I&&f.charCodeAt(2)===k)return`\\\\?\\${f}`;return t},dirname(t){v(t,"path");const f=t.length;if(f===0)return".";let o=-1,s=0;const u=t.charCodeAt(0);if(f===1)return h(u)?t:".";if(h(u)){if(o=s=1,h(t.charCodeAt(1))){let S=2,m=S;for(;S<f&&!h(t.charCodeAt(S));)S++;if(S<f&&S!==m){for(m=S;S<f&&h(t.charCodeAt(S));)S++;if(S<f&&S!==m){for(m=S;S<f&&!h(t.charCodeAt(S));)S++;if(S===f)return t;S!==m&&(o=s=S+1)}}}}else i(u)&&t.charCodeAt(1)===I&&(o=f>2&&h(t.charCodeAt(2))?3:2,s=o);let g=-1,b=!0;for(let S=f-1;S>=s;--S)if(h(t.charCodeAt(S))){if(!b){g=S;break}}else b=!1;if(g===-1){if(o===-1)return".";g=o}return t.slice(0,g)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let o=0,s=-1,u=!0,g;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===I&&(o=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let b=f.length-1,S=-1;for(g=t.length-1;g>=o;--g){const m=t.charCodeAt(g);if(h(m)){if(!u){o=g+1;break}}else S===-1&&(u=!1,S=g+1),b>=0&&(m===f.charCodeAt(b)?--b===-1&&(s=g):(b=-1,s=S))}return o===s?s=S:s===-1&&(s=t.length),t.slice(o,s)}for(g=t.length-1;g>=o;--g)if(h(t.charCodeAt(g))){if(!u){o=g+1;break}}else s===-1&&(u=!1,s=g+1);return s===-1?"":t.slice(o,s)},extname(t){v(t,"path");let f=0,o=-1,s=0,u=-1,g=!0,b=0;t.length>=2&&t.charCodeAt(1)===I&&i(t.charCodeAt(0))&&(f=s=2);for(let S=t.length-1;S>=f;--S){const m=t.charCodeAt(S);if(h(m)){if(!g){s=S+1;break}continue}u===-1&&(g=!1,u=S+1),m===w?o===-1?o=S:b!==1&&(b=1):o!==-1&&(b=-1)}return o===-1||u===-1||b===0||b===1&&o===u-1&&o===s+1?"":t.slice(o,u)},format:a.bind(null,"\\"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const o=t.length;let s=0,u=t.charCodeAt(0);if(o===1)return h(u)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(h(u)){if(s=1,h(t.charCodeAt(1))){let C=2,O=C;for(;C<o&&!h(t.charCodeAt(C));)C++;if(C<o&&C!==O){for(O=C;C<o&&h(t.charCodeAt(C));)C++;if(C<o&&C!==O){for(O=C;C<o&&!h(t.charCodeAt(C));)C++;C===o?s=C:C!==O&&(s=C+1)}}}}else if(i(u)&&t.charCodeAt(1)===I){if(o<=2)return f.root=f.dir=t,f;if(s=2,h(t.charCodeAt(2))){if(o===3)return f.root=f.dir=t,f;s=3}}s>0&&(f.root=t.slice(0,s));let g=-1,b=s,S=-1,m=!0,y=t.length-1,D=0;for(;y>=s;--y){if(u=t.charCodeAt(y),h(u)){if(!m){b=y+1;break}continue}S===-1&&(m=!1,S=y+1),u===w?g===-1?g=y:D!==1&&(D=1):g!==-1&&(D=-1)}return S!==-1&&(g===-1||D===0||D===1&&g===S-1&&g===b+1?f.base=f.name=t.slice(b,S):(f.name=t.slice(b,g),f.base=t.slice(b,S),f.ext=t.slice(g,S))),b>0&&b!==s?f.dir=t.slice(0,b-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const r=(()=>{if(d){const t=/\\/g;return()=>{const f=l.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>l.cwd()})();e.$gc={resolve(...t){let f="",o=!1;for(let s=t.length-1;s>=-1&&!o;s--){const u=s>=0?t[s]:r();v(u,"path"),u.length!==0&&(f=`${u}/${f}`,o=u.charCodeAt(0)===$)}return f=n(f,!o,"/",c),o?`/${f}`:f.length>0?f:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===$,o=t.charCodeAt(t.length-1)===$;return t=n(t,!f,"/",c),t.length===0?f?"/":o?"./":".":(o&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let f;for(let o=0;o<t.length;++o){const s=t[o];v(s,"path"),s.length>0&&(f===void 0?f=s:f+=`/${s}`)}return f===void 0?".":e.$gc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f||(t=e.$gc.resolve(t),f=e.$gc.resolve(f),t===f))return"";const o=1,s=t.length,u=s-o,g=1,b=f.length-g,S=u<b?u:b;let m=-1,y=0;for(;y<S;y++){const C=t.charCodeAt(o+y);if(C!==f.charCodeAt(g+y))break;C===$&&(m=y)}if(y===S)if(b>S){if(f.charCodeAt(g+y)===$)return f.slice(g+y+1);if(y===0)return f.slice(g+y)}else u>S&&(t.charCodeAt(o+y)===$?m=y:y===0&&(m=0));let D="";for(y=o+m+1;y<=s;++y)(y===s||t.charCodeAt(y)===$)&&(D+=D.length===0?"..":"/..");return`${D}${f.slice(g+m)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===$;let o=-1,s=!0;for(let u=t.length-1;u>=1;--u)if(t.charCodeAt(u)===$){if(!s){o=u;break}}else s=!1;return o===-1?f?"/":".":f&&o===1?"//":t.slice(0,o)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let o=0,s=-1,u=!0,g;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let b=f.length-1,S=-1;for(g=t.length-1;g>=0;--g){const m=t.charCodeAt(g);if(m===$){if(!u){o=g+1;break}}else S===-1&&(u=!1,S=g+1),b>=0&&(m===f.charCodeAt(b)?--b===-1&&(s=g):(b=-1,s=S))}return o===s?s=S:s===-1&&(s=t.length),t.slice(o,s)}for(g=t.length-1;g>=0;--g)if(t.charCodeAt(g)===$){if(!u){o=g+1;break}}else s===-1&&(u=!1,s=g+1);return s===-1?"":t.slice(o,s)},extname(t){v(t,"path");let f=-1,o=0,s=-1,u=!0,g=0;for(let b=t.length-1;b>=0;--b){const S=t.charCodeAt(b);if(S===$){if(!u){o=b+1;break}continue}s===-1&&(u=!1,s=b+1),S===w?f===-1?f=b:g!==1&&(g=1):f!==-1&&(g=-1)}return f===-1||s===-1||g===0||g===1&&f===s-1&&f===o+1?"":t.slice(f,s)},format:a.bind(null,"/"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const o=t.charCodeAt(0)===$;let s;o?(f.root="/",s=1):s=0;let u=-1,g=0,b=-1,S=!0,m=t.length-1,y=0;for(;m>=s;--m){const D=t.charCodeAt(m);if(D===$){if(!S){g=m+1;break}continue}b===-1&&(S=!1,b=m+1),D===w?u===-1?u=m:y!==1&&(y=1):u!==-1&&(y=-1)}if(b!==-1){const D=g===0&&o?1:g;u===-1||y===0||y===1&&u===b-1&&u===g+1?f.base=f.name=t.slice(D,b):(f.name=t.slice(D,u),f.base=t.slice(D,b),f.ext=t.slice(u,b))}return g>0?f.dir=t.slice(0,g-1):o&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=d?e.$fc.normalize:e.$gc.normalize,e.$ic=d?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=d?e.$fc.join:e.$gc.join,e.$kc=d?e.$fc.resolve:e.$gc.resolve,e.$lc=d?e.$fc.relative:e.$gc.relative,e.$mc=d?e.$fc.dirname:e.$gc.dirname,e.$nc=d?e.$fc.basename:e.$gc.basename,e.$oc=d?e.$fc.extname:e.$gc.extname,e.$pc=d?e.$fc.format:e.$gc.format,e.$qc=d?e.$fc.parse:e.$gc.parse,e.$rc=d?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=d?e.$fc.sep:e.$gc.sep,e.$tc=d?e.$fc.delimiter:e.$gc.delimiter}),define(ke[132],De([1,0,46,16]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=w,e.$nr=$,e.$or=k,e.$pr=I,e.$qr=P,e.$rr=p,e.$sr=E,e.$tr=v,e.$ur=d,e.$vr=h,e.$wr=u,e.$xr=g,e.$yr=b;const M=new l.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),A=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(S,m,y=!1){const D=S||"",C=m||"",O=M.value.collator.compare(D,C);return M.value.collatorIsNumeric&&O===0&&D!==C?D<C?-1:1:O}function $(S,m){const y=A.value.collator;return S=S||"",m=m||"",a(y,S,m)}function k(S,m){const y=A.value.collator;return S=S||"",m=m||"",o(S,m)||a(y,S,m)}function I(S,m){const y=A.value.collator;return S=S||"",m=m||"",f(S,m)||a(y,S,m)}function P(S,m){return S=S||"",m=m||"",S===m?0:S<m?-1:1}function p(S,m){const[y,D]=i(S),[C,O]=i(m);let z=M.value.collator.compare(D,O);if(z===0){if(M.value.collatorIsNumeric&&D!==O)return D<O?-1:1;if(z=M.value.collator.compare(y,C),M.value.collatorIsNumeric&&z===0&&y!==C)return y<C?-1:1}return z}function E(S,m){S=S||"",m=m||"";const y=n(S),D=n(m),C=A.value.collator,O=R.value.collator;return a(O,y,D)||a(C,S,m)}function v(S,m){S=S||"",m=m||"";const y=n(S),D=n(m),C=A.value.collator,O=R.value.collator;return a(O,y,D)||o(S,m)||a(C,S,m)}function d(S,m){S=S||"",m=m||"";const y=n(S),D=n(m),C=A.value.collator,O=R.value.collator;return a(O,y,D)||f(S,m)||a(C,S,m)}function h(S,m){S=S||"",m=m||"";const y=n(S).toLowerCase(),D=n(m).toLowerCase();return y!==D?y<D?-1:1:S!==m?S<m?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function i(S,m=!1){const y=S?c.exec(S):[];let D=[y&&y[1]||"",y&&y[3]||""];return m&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function n(S){const m=S?c.exec(S):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function a(S,m,y){const D=S.compare(m,y);return D!==0?D:m.length!==y.length?m.length<y.length?-1:1:0}function r(S){const m=S.charAt(0);return m.toLocaleUpperCase()!==m}function t(S){const m=S.charAt(0);return m.toLocaleLowerCase()!==m}function f(S,m){return r(S)&&t(m)?-1:t(S)&&r(m)?1:0}function o(S,m){return t(S)&&r(m)?-1:r(S)&&t(m)?1:0}function s(S,m,y=!1){return y||(S=S&&S.toLowerCase(),m=m&&m.toLowerCase()),S===m?0:S<m?-1:1}function u(S,m,y=!1){const D=S.split(L.sep),C=m.split(L.sep),O=D.length-1,z=C.length-1;let T,F;for(let N=0;;N++){if(T=O===N,F=z===N,T&&F)return w(D[N],C[N],y);if(T)return-1;if(F)return 1;const j=s(D[N],C[N],y);if(j!==0)return j}}function g(S,m,y){const D=S.toLowerCase(),C=m.toLowerCase(),O=b(S,m,y);if(O)return O;const z=D.endsWith(y),T=C.endsWith(y);if(z!==T)return z?-1:1;const F=w(D,C);return F!==0?F:D.localeCompare(C)}function b(S,m,y){const D=S.toLowerCase(),C=m.toLowerCase(),O=D.startsWith(y),z=C.startsWith(y);if(O!==z)return O?-1:1;if(O&&z){if(D.length<C.length)return-1;if(D.length>C.length)return 1}return 0}}),define(ke[31],De([1,0,16,12,14,18]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=R,e.$tg=w,e.$ug=$,e.$vg=k,e.$wg=I,e.$xg=v,e.$yg=d,e.$zg=h,e.$Ag=c,e.$Bg=i,e.$Cg=n,e.$Dg=a,e.$Eg=r,e.$Fg=t,e.$Gg=f,e.$Hg=o,e.$Ig=g;function R(b){return b===47||b===92}function w(b){return b.replace(/[\\/]/g,l.$gc.sep)}function $(b){return b.indexOf("/")===-1&&(b=w(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function k(b,S=l.$gc.sep){if(!b)return"";const m=b.length,y=b.charCodeAt(0);if(R(y)){if(R(b.charCodeAt(1))&&!R(b.charCodeAt(2))){let C=3;const O=C;for(;C<m&&!R(b.charCodeAt(C));C++);if(O!==C&&!R(b.charCodeAt(C+1))){for(C+=1;C<m;C++)if(R(b.charCodeAt(C)))return b.slice(0,C+1).replace(/[\\/]/g,S)}}return S}else if(c(y)&&b.charCodeAt(1)===58)return R(b.charCodeAt(2))?b.slice(0,2)+S:b.slice(0,2);let D=b.indexOf("://");if(D!==-1){for(D+=3;D<m;D++)if(R(b.charCodeAt(D)))return b.slice(0,D+1)}return""}function I(b){if(!L.$i||!b||b.length<5)return!1;let S=b.charCodeAt(0);if(S!==92||(S=b.charCodeAt(1),S!==92))return!1;let m=2;const y=m;for(;m<b.length&&(S=b.charCodeAt(m),S!==92);m++);return!(y===m||(S=b.charCodeAt(m+1),isNaN(S)||S===92))}const P=/[\\/:\*\?"<>\|]/g,p=/[/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(b,S=L.$i){const m=S?P:p;return!(!b||b.length===0||/^\s+$/.test(b)||(m.lastIndex=0,m.test(b))||S&&E.test(b)||b==="."||b===".."||S&&b[b.length-1]==="."||S&&b.length!==b.trim().length||b.length>255)}function d(b,S,m){const y=b===S;return!m||y?y:!b||!S?!1:(0,M.$Bf)(b,S)}function h(b,S,m,y=l.sep){if(b===S)return!0;if(!b||!S||S.length>b.length)return!1;if(m){if(!(0,M.$Cf)(b,S))return!1;if(S.length===b.length)return!0;let C=S.length;return S.charAt(S.length-1)===y&&C--,b.charAt(C)===y}return S.charAt(S.length-1)!==y&&(S+=y),b.indexOf(S)===0}function c(b){return b>=65&&b<=90||b>=97&&b<=122}function i(b,S){return L.$i&&b.endsWith(":")&&(b+=l.sep),(0,l.$ic)(b)||(b=(0,l.$jc)(S,b)),b=(0,l.$hc)(b),n(b)}function n(b){return L.$i?(b=(0,M.$jf)(b,l.sep),b.endsWith(":")&&(b+=l.sep)):(b=(0,M.$jf)(b,l.sep),b||(b=l.sep)),b}function a(b){const S=(0,l.$hc)(b);return L.$i?b.length>3?!1:r(S)&&(b.length===2||S.charCodeAt(2)===92):S===l.$gc.sep}function r(b,S=L.$i){return S?c(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function t(b,S=L.$i){return r(b,S)?b[0]:void 0}function f(b,S,m){return S.length>b.length?-1:b===S?0:(m&&(b=b.toLowerCase(),S=S.toLowerCase()),b.indexOf(S))}function o(b){const S=b.split(":");let m,y,D;for(const C of S){const O=Number(C);(0,A.$eg)(O)?y===void 0?y=O:D===void 0&&(D=O):m=m?[m,C].join(":"):C}if(!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:y!==void 0?y:void 0,column:D!==void 0?D:y!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(b,S,m=8){let y="";for(let C=0;C<m;C++){let O;C===0&&L.$i&&!S&&(m===3||m===4)?O=u:O=s,y+=O.charAt(Math.floor(Math.random()*O.length))}let D;return S?D=`${S}-${y}`:D=y,b?(0,l.$jc)(b,D):D}}),define(ke[133],De([1,0,132,127,58,16,12,14]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=I,e.$Ar=h,e.$Br=o,e.$Cr=y,e.$Dr=F,e.$Er=j;const $=0,k=[$,[]];function I(B,X,ie,H){if(!B||!X)return k;const K=B.length,x=X.length;if(K<x)return k;const _=B.toLowerCase();return P(X,ie,x,B,_,K,H)}function P(B,X,ie,H,K,x,_){const ge=[],oe=[];for(let Y=0;Y<ie;Y++){const pe=Y*x,ce=pe-x,ae=Y>0,se=B[Y],ue=X[Y];for(let Q=0;Q<x;Q++){const re=Q>0,$e=pe+Q,we=$e-1,Ne=ce+Q-1,Se=re?ge[we]:0,Ie=ae&&re?ge[Ne]:0,Ae=ae&&re?oe[Ne]:0;let je;!Ie&&ae?je=0:je=p(se,ue,H,K,Q,Ae),je&&Ie+je>=Se&&(_||ae||K.startsWith(X,Q))?(oe[$e]=Ae+1,ge[$e]=Ie+je):(oe[$e]=$,ge[$e]=Se)}}const Pe=[];let me=ie-1,U=x-1;for(;me>=0&&U>=0;){const Y=me*x+U;oe[Y]===$||(Pe.push(U),me--),U--}return[ge[ie*x-1],Pe.reverse()]}function p(B,X,ie,H,K,x){let _=0;if(!E(X,H[K]))return _;if(_+=1,x>0&&(_+=x*5),B===ie[K]&&(_+=1),K===0)_+=8;else{const ge=v(ie.charCodeAt(K-1));ge?_+=ge:(0,L.$Fk)(ie.charCodeAt(K))&&x===0&&(_+=2)}return _}function E(B,X){return B===X?!0:B==="/"||B==="\\"?X==="/"||X==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function h(B,X,ie=0,H=0){const K=X;return K.values&&K.values.length>1?c(B,K.values,ie,H):i(B,X,ie,H)}function c(B,X,ie,H){let K=0;const x=[];for(const _ of X){const[ge,oe]=i(B,_,ie,H);if(typeof ge!="number")return d;K+=ge,x.push(...oe)}return[K,S(x)]}function i(B,X,ie,H){const K=(0,L.$Ok)(X.original,X.originalLowercase,ie,B,B.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return K?[K[0],(0,L.$Lk)(K)]:d}const n=Object.freeze({score:0}),a=1<<18,r=1<<17,t=65536;function f(B,X,ie,H){const K=H.values?H.values:[H];return(0,M.$oj)({[H.normalized]:{values:K.map(_=>({value:_.normalized,expectContiguousMatch:_.expectContiguousMatch})),label:B,description:X,allowNonContiguousMatches:ie}})}function o(B,X,ie,H,K){if(!B||!X.normalized)return n;const x=H.getItemLabel(B);if(!x)return n;const _=H.getItemDescription(B),ge=f(x,_,ie,X),oe=K[ge];if(oe)return oe;const Pe=s(x,_,H.getItemPath(B),X,ie);return K[ge]=Pe,Pe}function s(B,X,ie,H,K){const x=!ie||!H.containsPathSeparator;return ie&&(R.$k?H.pathNormalized===ie:(0,w.$Bf)(H.pathNormalized,ie))?{score:a,labelMatch:[{start:0,end:B.length}],descriptionMatch:X?[{start:0,end:X.length}]:void 0}:H.values&&H.values.length>1?u(B,X,ie,H.values,x,K):g(B,X,ie,H,x,K)}function u(B,X,ie,H,K,x){let _=0;const ge=[],oe=[];for(const Pe of H){const{score:me,labelMatch:U,descriptionMatch:Y}=g(B,X,ie,Pe,K,x);if(me===$)return n;_+=me,U&&ge.push(...U),Y&&oe.push(...Y)}return{score:_,labelMatch:S(ge),descriptionMatch:S(oe)}}function g(B,X,ie,H,K,x){if(K||!X){const[_,ge]=I(B,H.normalized,H.normalizedLowercase,x&&!H.expectContiguousMatch);if(_){const oe=(0,L.$Ck)(H.normalized,B);let Pe;if(oe){Pe=r;const me=Math.round(H.normalized.length/B.length*100);Pe+=me}else Pe=t;return{score:Pe+_,labelMatch:oe||b(ge)}}}if(X){let _=X;ie&&(_=`${X}${A.sep}`);const ge=_.length,oe=`${_}${B}`,[Pe,me]=I(oe,H.normalized,H.normalizedLowercase,x&&!H.expectContiguousMatch);if(Pe){const U=b(me),Y=[],pe=[];return U.forEach(ce=>{ce.start<ge&&ce.end>ge?(Y.push({start:0,end:ce.end-ge}),pe.push({start:ce.start,end:ge})):ce.start>=ge?Y.push({start:ce.start-ge,end:ce.end-ge}):pe.push(ce)}),{score:Pe,labelMatch:Y,descriptionMatch:pe}}}return n}function b(B){const X=[];if(!B)return X;let ie;for(const H of B)ie&&ie.end===H?ie.end+=1:(ie={start:H,end:H+1},X.push(ie));return X}function S(B){const X=B.sort((K,x)=>K.start-x.start),ie=[];let H;for(const K of X)!H||!m(H,K)?(H=K,ie.push(K)):(H.start=Math.min(H.start,K.start),H.end=Math.max(H.end,K.end));return ie}function m(B,X){return!(B.end<X.start||X.end<B.start)}function y(B,X,ie,H,K,x){const _=o(B,ie,H,K,x),ge=o(X,ie,H,K,x),oe=_.score,Pe=ge.score;if((oe===a||Pe===a)&&oe!==Pe)return oe===a?-1:1;if(oe>t||Pe>t){if(oe!==Pe)return oe>Pe?-1:1;if(oe<r&&Pe<r){const se=C(_.labelMatch,ge.labelMatch);if(se!==0)return se}const ce=K.getItemLabel(B)||"",ae=K.getItemLabel(X)||"";if(ce.length!==ae.length)return ce.length-ae.length}if(oe!==Pe)return oe>Pe?-1:1;const me=Array.isArray(_.labelMatch)&&_.labelMatch.length>0,U=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(me&&!U)return-1;if(U&&!me)return 1;const Y=D(B,_,K),pe=D(X,ge,K);return Y&&pe&&Y!==pe?pe>Y?-1:1:O(B,X,ie,K)}function D(B,X,ie){let H=-1,K=-1;if(X.descriptionMatch&&X.descriptionMatch.length?H=X.descriptionMatch[0].start:X.labelMatch&&X.labelMatch.length&&(H=X.labelMatch[0].start),X.labelMatch&&X.labelMatch.length){if(K=X.labelMatch[X.labelMatch.length-1].end,X.descriptionMatch&&X.descriptionMatch.length){const x=ie.getItemDescription(B);x&&(K+=x.length)}}else X.descriptionMatch&&X.descriptionMatch.length&&(K=X.descriptionMatch[X.descriptionMatch.length-1].end);return K-H}function C(B,X){if(!B&&!X||(!B||!B.length)&&(!X||!X.length))return 0;if(!X||!X.length)return-1;if(!B||!B.length)return 1;const ie=B[0].start,K=B[B.length-1].end-ie,x=X[0].start,ge=X[X.length-1].end-x;return K===ge?0:ge<K?1:-1}function O(B,X,ie,H){const K=H.getItemLabel(B)||"",x=H.getItemLabel(X)||"",_=H.getItemDescription(B),ge=H.getItemDescription(X),oe=K.length+(_?_.length:0),Pe=x.length+(ge?ge.length:0);if(oe!==Pe)return oe-Pe;const me=H.getItemPath(B),U=H.getItemPath(X);return me&&U&&me.length!==U.length?me.length-U.length:K!==x?(0,l.$xr)(K,x,ie.normalized):_&&ge&&_!==ge?(0,l.$xr)(_,ge,ie.normalized):me&&U&&me!==U?(0,l.$xr)(me,U,ie.normalized):0}function z(B){return B.startsWith('"')&&B.endsWith('"')}const T=" ";function F(B){typeof B!="string"&&(B="");const X=B.toLowerCase(),{pathNormalized:ie,normalized:H,normalizedLowercase:K}=N(B),x=ie.indexOf(A.sep)>=0,_=z(B);let ge;const oe=B.split(T);if(oe.length>1)for(const Pe of oe){const me=z(Pe),{pathNormalized:U,normalized:Y,normalizedLowercase:pe}=N(Pe);Y&&(ge||(ge=[]),ge.push({original:Pe,originalLowercase:Pe.toLowerCase(),pathNormalized:U,normalized:Y,normalizedLowercase:pe,expectContiguousMatch:me}))}return{original:B,originalLowercase:X,pathNormalized:ie,normalized:H,normalizedLowercase:K,values:ge,containsPathSeparator:x,expectContiguousMatch:_}}function N(B){let X;R.$i?X=B.replace(/\//g,A.sep):X=B.replace(/\\/g,A.sep);const ie=(0,w.$lf)(X).replace(/\s|"/g,"");return{pathNormalized:X,normalized:ie,normalizedLowercase:ie.toLowerCase()}}function j(B){return Array.isArray(B)?F(B.map(X=>X.original).join(T)):F(B.original)}}),define(ke[101],De([1,0,16]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0,e.$Xs=A,e.$Ys=R,e.$Zs=w,e.$1s=k,e.$Ws=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(I){const P=(0,l.$oc)(I),p=L[P.toLowerCase()];return p!==void 0?p:R(I)}function R(I){const P=(0,l.$oc)(I);return M[P.toLowerCase()]}function w(I){for(const P in M)if(M[P]===I)return P}const $=/^(.+)\/(.+?)(;.+)?$/;function k(I,P){const p=$.exec(I);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:P?void 0:I}}),define(ke[102],De([1,0,12]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$qm=A,e.$rm=R;var L;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(L||(e.Source=L={}));var M;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(M||(e.TerminateResponseCode=M={}));function A(w,...$){const k=$.reduce((p,E)=>(p[E]=!0,p),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(p=>!k[p]).forEach(p=>{for(let E=0;E<I.length;E++)if(p.search(I[E])!==-1){delete w[p];break}})}function R(w){w&&(delete w.DEBUG,l.$j&&delete w.DYLD_LIBRARY_PATH,l.$k&&delete w.LD_PRELOAD)}}),define(ke[2],De([1,0,16,12]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=v,e.$wc=a;const M=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function w(s,u){if(!s.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!M.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(s,u){return!s&&!u?"file":s}function k(s,u){switch(s){case"https":case"http":case"file":u?u[0]!==P&&(u=P+u):u=P;break}return u}const I="",P="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(u){return u instanceof E?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,g,b,S,m,y=!1){typeof u=="object"?(this.scheme=u.scheme||I,this.authority=u.authority||I,this.path=u.path||I,this.query=u.query||I,this.fragment=u.fragment||I):(this.scheme=$(u,y),this.authority=g||I,this.path=k(this.scheme,b||I),this.query=S||I,this.fragment=m||I,w(this,y))}get fsPath(){return a(this,!1)}with(u){if(!u)return this;let{scheme:g,authority:b,path:S,query:m,fragment:y}=u;return g===void 0?g=this.scheme:g===null&&(g=I),b===void 0?b=this.authority:b===null&&(b=I),S===void 0?S=this.path:S===null&&(S=I),m===void 0?m=this.query:m===null&&(m=I),y===void 0?y=this.fragment:y===null&&(y=I),g===this.scheme&&b===this.authority&&S===this.path&&m===this.query&&y===this.fragment?this:new h(g,b,S,m,y)}static parse(u,g=!1){const b=p.exec(u);return b?new h(b[2]||I,o(b[4]||I),o(b[5]||I),o(b[7]||I),o(b[9]||I),g):new h(I,I,I,I,I)}static file(u){let g=I;if(L.$i&&(u=u.replace(/\\/g,P)),u[0]===P&&u[1]===P){const b=u.indexOf(P,2);b===-1?(g=u.substring(2),u=P):(g=u.substring(2,b),u=u.substring(b)||P)}return new h("file",g,u,I,I)}static from(u,g){return new h(u.scheme,u.authority,u.path,u.query,u.fragment,g)}static joinPath(u,...g){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return L.$i&&u.scheme==="file"?b=E.file(l.$fc.join(a(u,!0),...g)).path:b=l.$gc.join(u.path,...g),u.with({path:b})}toString(u=!1){return r(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof E)return u;{const g=new h(u);return g._formatted=u.external??null,g._fsPath=u._sep===d?u.fsPath??null:null,g}}else return u}}e.URI=E;function v(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const d=L.$i?1:void 0;class h extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(u=!1){return u?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=d),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(s,u,g){let b,S=-1;for(let m=0;m<s.length;m++){const y=s.charCodeAt(m);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||u&&y===47||g&&y===91||g&&y===93||g&&y===58)S!==-1&&(b+=encodeURIComponent(s.substring(S,m)),S=-1),b!==void 0&&(b+=s.charAt(m));else{b===void 0&&(b=s.substr(0,m));const D=c[y];D!==void 0?(S!==-1&&(b+=encodeURIComponent(s.substring(S,m)),S=-1),b+=D):S===-1&&(S=m)}}return S!==-1&&(b+=encodeURIComponent(s.substring(S))),b!==void 0?b:s}function n(s){let u;for(let g=0;g<s.length;g++){const b=s.charCodeAt(g);b===35||b===63?(u===void 0&&(u=s.substr(0,g)),u+=c[b]):u!==void 0&&(u+=s[g])}return u!==void 0?u:s}function a(s,u){let g;return s.authority&&s.path.length>1&&s.scheme==="file"?g=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?u?g=s.path.substr(1):g=s.path[1].toLowerCase()+s.path.substr(2):g=s.path,L.$i&&(g=g.replace(/\//g,"\\")),g}function r(s,u){const g=u?n:i;let b="",{scheme:S,authority:m,path:y,query:D,fragment:C}=s;if(S&&(b+=S,b+=":"),(m||S==="file")&&(b+=P,b+=P),m){let O=m.indexOf("@");if(O!==-1){const z=m.substr(0,O);m=m.substr(O+1),O=z.lastIndexOf(":"),O===-1?b+=g(z,!1,!1):(b+=g(z.substr(0,O),!1,!1),b+=":",b+=g(z.substr(O+1),!1,!0)),b+="@"}m=m.toLowerCase(),O=m.lastIndexOf(":"),O===-1?b+=g(m,!1,!0):(b+=g(m.substr(0,O),!1,!0),b+=m.substr(O))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const O=y.charCodeAt(1);O>=65&&O<=90&&(y=`/${String.fromCharCode(O+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const O=y.charCodeAt(0);O>=65&&O<=90&&(y=`${String.fromCharCode(O+32)}:${y.substr(2)}`)}b+=g(y,!0,!1)}return D&&(b+="?",b+=g(D,!1,!1)),C&&(b+="#",b+=u?C:i(C,!1,!1)),b}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(f)?s.replace(f,u=>t(u)):s}}),define(ke[197],De([1,0,2]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=L,e.$3q=M,e.$4q=A,e.log=w;function L(k){const I=k;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function M(k){const I=[];let P;try{const p=JSON.parse(k.arguments),E=p[p.length-1];E&&E.__$stack&&(p.pop(),P=E.__$stack),I.push(...p)}catch{I.push("Unable to log remote console arguments",k.arguments)}return{args:I,stack:P}}function A(k){if(typeof k!="string")return A(M(k).stack);const I=k;if(I){const P=R(I),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(p&&p.length===4)return{uri:l.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function R(k){if(!k)return k;const I=k.indexOf(`
`);return I===-1?k:k.substring(0,I)}function w(k,I){const{args:P,stack:p}=M(k),E=typeof P[0]=="string"&&P.length===1;let v=R(p);v&&(v=`(${v.trim()})`);let d=[];if(typeof P[0]=="string"?v&&E?d=[`%c[${I}] %c${P[0]} %c${v}`,$("blue"),$(""),$("grey")]:d=[`%c[${I}] %c${P[0]}`,$("blue"),$(""),...P.slice(1)]:d=[`%c[${I}]%`,$("blue"),...P],v&&!E&&d.push(v),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,d)}function $(k){return`color: ${k}`}}),define(ke[53],De([1,0,22,2]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=M,e.$9h=A,e.$0h=w;function M($){return JSON.stringify($,R)}function A($){let k=JSON.parse($);return k=w(k),k}function R($,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function w($,k=0){if(!$||k>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return L.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof l.$Je||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let I=0;I<$.length;++I)$[I]=w($[I],k+1);else for(const I in $)Object.hasOwnProperty.call($,I)&&($[I]=w($[I],k+1))}return $}}),define(ke[15],De([1,0,13,12,14,2,16]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=$,e.$Kg=k,e.$Og=P;var w;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.commentsInput="comment",v.codeSetting="code-setting"})(w||(e.Schemas=w={}));function $(v,d){return A.URI.isUri(v)?(0,M.$Bf)(v.scheme,d):(0,M.$Cf)(v,d+":")}function k(v,...d){return d.some(h=>$(v,h))}e.$Lg="vscode-tkn",e.$Mg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(d){this.d=d}setDelegate(d){this.e=d}setServerRootPath(d,h){this.f=P(d,h)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,w.vscodeRemoteResource)}set(d,h,c){this.a[d]=h,this.b[d]=c}setConnectionToken(d,h){this.c[d]=h}getPreferredWebSchema(){return this.d}rewrite(d){if(this.e)try{return this.e(d)}catch(r){return l.$1(r),d}const h=d.authority;let c=this.a[h];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const i=this.b[h],n=this.c[h];let a=`path=${encodeURIComponent(d.path)}`;return typeof n=="string"&&(a+=`&${e.$Mg}=${encodeURIComponent(n)}`),A.URI.from({scheme:L.$o?this.d:w.vscodeRemoteResource,authority:`${c}:${i}`,path:this.g,query:a})}}e.$Ng=new I;function P(v,d){return R.$gc.join(d??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class p{static{this.a=e.$Tg}asBrowserUri(d){const h=this.b(d,le);return this.uriToBrowserUri(h)}uriToBrowserUri(d){return d.scheme===w.vscodeRemote?e.$Ng.rewrite(d):d.scheme===w.file&&(L.$m||L.$q===`${w.vscodeFileResource}://${p.a}`)?d.with({scheme:w.vscodeFileResource,authority:d.authority||p.a,query:null,fragment:null}):d}asFileUri(d){const h=this.b(d,le);return this.uriToFileUri(h)}uriToFileUri(d){return d.scheme===w.vscodeFileResource?d.with({scheme:w.file,authority:d.authority!==p.a?d.authority:null,query:null,fragment:null}):d}b(d,h){return A.URI.isUri(d)?d:A.URI.parse(h.toUrl(d))}}e.$Ug=new p;var E;(function(v){const d=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(d.get("3"));const h="vscode-coi";function c(n){let a;typeof n=="string"?a=new URL(n).searchParams:n instanceof URL?a=n.searchParams:A.URI.isUri(n)&&(a=new URL(n.toString(!0)).searchParams);const r=a?.get(h);if(r)return d.get(r)}v.getHeadersFromQuery=c;function i(n,a,r){if(!globalThis.crossOriginIsolated)return;const t=a&&r?"3":r?"2":"1";n instanceof URLSearchParams?n.set(h,t):n[h]=t}v.addSearchParam=i})(E||(e.COI=E={}))}),define(ke[198],De([1,0,163,15,12,2]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bE=I;class R{constructor(p,E,v){this.id=p,this.dependencies=E,this.callback=v}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,E,v)=>{typeof p!="string"&&(v=E,E=p,p=null),(typeof E!="object"||!Array.isArray(E))&&(v=E,E=null),this.c.push(new R(p,E,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const E=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!E)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(p){return new Promise((E,v)=>{const d=document.createElement("script");d.setAttribute("async","async"),d.setAttribute("type","text/javascript");const h=()=>{d.removeEventListener("load",c),d.removeEventListener("error",i)},c=n=>{h(),E(this.c.pop())},i=n=>{h(),v(n)};d.addEventListener("load",c),d.addEventListener("error",i),this.f&&(p=this.f.createScriptURL(p)),d.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(d)})}i(p){return new Promise((E,v)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),E(this.c.pop())}catch(d){v(d)}})}async j(p){try{const E=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,d=globalThis._VSCODE_NODE_MODULES.module,h=A.URI.parse(p).fsPath,c=E.readFileSync(h).toString(),i=d.wrap(c.replace(/^#!.*/,""));return new v.Script(i).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const $=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function I(P,p,E){if(l.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[P]&&(P=k[P]);const v=`${P}/${p}`;if($.has(v))return $.get(v);let d;if(/^\w[\w\d+.-]*:\/\//.test(v))d=v;else{const n=`${E&&!M.$o?L.$Rg:L.$Qg}/${v}`;d=L.$Ug.asBrowserUri(n).toString(!0)}const h=w.INSTANCE.load(d);return $.set(v,h),h}else return await new Promise((v,d)=>{le([P],v,d)})}}),define(ke[23],De([1,0,31,15,16,12,14,2]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=$,e.$kh=I,e.$lh=p;function $(E){return(0,w.$wc)(E,!0)}class k{constructor(v){this.a=v}compare(v,d,h=!1){return v===d?0:(0,R.$uf)(this.getComparisonKey(v,h),this.getComparisonKey(d,h))}isEqual(v,d,h=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,h)===this.getComparisonKey(d,h)}getComparisonKey(v,d=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,d,h=!1){if(v.scheme===d.scheme){if(v.scheme===L.Schemas.file)return l.$zg($(v),$(d),this.a(v))&&v.query===d.query&&(h||v.fragment===d.fragment);if((0,e.$gh)(v.authority,d.authority))return l.$zg(v.path,d.path,this.a(v),"/")&&v.query===d.query&&(h||v.fragment===d.fragment)}return!1}joinPath(v,...d){return w.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.$$g)(v)||v.authority}basename(v){return M.$gc.basename(v.path)}extname(v){return M.$gc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===L.Schemas.file?d=w.URI.file(M.$mc($(v))).path:(d=M.$gc.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===L.Schemas.file?d=w.URI.file(M.$hc($(v))).path:d=M.$gc.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.$gh)(v.authority,d.authority))return;if(v.scheme===L.Schemas.file){const i=M.$lc($(v),$(d));return A.$i?l.$tg(i):i}let h=v.path||"/";const c=d.path||"/";if(this.a(v)){let i=0;for(const n=Math.min(h.length,c.length);i<n&&!(h.charCodeAt(i)!==c.charCodeAt(i)&&h.charAt(i).toLowerCase()!==c.charAt(i).toLowerCase());i++);h=c.substr(0,i)+h.substr(i)}return M.$gc.relative(h,c)}resolvePath(v,d){if(v.scheme===L.Schemas.file){const h=w.URI.file(M.$kc($(v),d));return v.with({authority:h.authority,path:h.path})}return d=l.$ug(d),v.with({path:M.$gc.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,R.$Bf)(v,d)}hasTrailingPathSeparator(v,d=M.sep){if(v.scheme===L.Schemas.file){const h=$(v);return h.length>l.$vg(h).length&&h[h.length-1]===d}else{const h=v.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=M.sep){return(0,e.$hh)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=M.sep){let h=!1;if(v.scheme===L.Schemas.file){const c=$(v);h=c!==void 0&&c.length===l.$vg(c).length&&c[c.length-1]===d}else{d="/";const c=v.path;h=c.length===1&&c.charCodeAt(c.length-1)===47}return!h&&!(0,e.$hh)(v,d)?v.with({path:v.path+"/"}):v}}e.$3g=k,e.$4g=new k(()=>!1),e.$5g=new k(E=>E.scheme===L.Schemas.file?!A.$k:!0),e.$6g=new k(E=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function I(E,v){const d=[];for(let h=0;h<E.length;h++){const c=v(E[h]);E.some((i,n)=>n===h?!1:(0,e.$8g)(c,v(i)))||d.push(E[h])}return d}var P;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function v(d){const h=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(n=>{const[a,r]=n.split(":");a&&r&&h.set(a,r)});const i=d.path.substring(0,d.path.indexOf(";"));return i&&h.set(E.META_DATA_MIME,i),h}E.parseMetaData=v})(P||(e.DataUri=P={}));function p(E,v,d){if(v){let h=E.path;return h&&h[0]!==M.$gc.sep&&(h=M.$gc.sep+h),E.with({scheme:d,authority:v,path:h})}return E.with({scheme:d})}}),define(ke[7],De([1,0,21,13,4,3,23,12,174,46]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=I,e.$nh=P,e.$oh=p,e.$ph=E,e.$qh=v,e.$rh=d,e.$sh=h,e.$th=c,e.$Bh=g,e.$Ch=b,e.$Dh=S,e.$Eh=m,e.$Fh=y,e.$Uh=K,e.$3h=ae;function I(ue){return!!ue&&typeof ue.then=="function"}function P(ue){const Q=new l.$se,re=ue(Q.token),$e=new Promise((we,Ne)=>{const Se=Q.token.onCancellationRequested(()=>{Se.dispose(),Ne(new L.$5)});Promise.resolve(re).then(Ie=>{Se.dispose(),Q.dispose(),we(Ie)},Ie=>{Se.dispose(),Q.dispose(),Ne(Ie)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(we,Ne){return $e.then(we,Ne)}catch(we){return this.then(void 0,we)}finally(we){return $e.finally(we)}}}function p(ue,Q,re){return new Promise(($e,we)=>{const Ne=Q.onCancellationRequested(()=>{Ne.dispose(),$e(re)});ue.then($e,we).finally(()=>Ne.dispose())})}function E(ue,Q){return new Promise((re,$e)=>{const we=Q.onCancellationRequested(()=>{we.dispose(),$e(new L.$5)});ue.then(re,$e).finally(()=>we.dispose())})}async function v(ue){let Q=-1;const re=ue.map(($e,we)=>$e.then(Ne=>(Q=we,Ne)));try{return await Promise.race(re)}finally{ue.forEach(($e,we)=>{we!==Q&&$e.cancel()})}}function d(ue,Q,re){let $e;const we=setTimeout(()=>{$e?.(void 0),re?.()},Q);return Promise.race([ue.finally(()=>clearTimeout(we)),new Promise(Ne=>$e=Ne)])}function h(ue){return new Promise((Q,re)=>{const $e=ue();I($e)?$e.then(Q,re):Q($e)})}function c(){let ue,Q;return{promise:new Promise(($e,we)=>{ue=$e,Q=we}),resolve:ue,reject:Q}}class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const re=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(re,re).then($e)})}return new Promise((re,$e)=>{this.b.then(re,$e)})}return this.a=Q(),new Promise((re,$e)=>{this.a.then(we=>{this.a=null,re(we)},we=>{this.a=null,$e(we)})})}dispose(){this.f=!0}}e.$uh=i;class n{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$vh=n;class a{constructor(){this.a=new Map}queue(Q,re){const we=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(Q)===we&&this.a.delete(Q)});return this.a.set(Q,we),we}}e.$wh=a;const r=(ue,Q)=>{let re=!0;const $e=setTimeout(()=>{re=!1,Q()},ue);return{isTriggered:()=>re,dispose:()=>{clearTimeout($e),re=!1}}},t=ue=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,ue())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class f{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,re=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((we,Ne)=>{this.d=we,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=re===$.$ce?t($e):r(re,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=f;class o{constructor(Q){this.a=new f(Q),this.b=new i}trigger(Q,re){return this.a.trigger(()=>this.b.queue(Q),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=o;class s{constructor(){this.a=!1,this.b=new Promise((Q,re)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=s;class u extends s{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$Ah=u;function g(ue,Q){return Q?new Promise((re,$e)=>{const we=setTimeout(()=>{Ne.dispose(),re()},ue),Ne=Q.onCancellationRequested(()=>{clearTimeout(we),Ne.dispose(),$e(new L.$5)})}):P(re=>g(ue,re))}function b(ue,Q=0,re){const $e=setTimeout(()=>{ue(),re&&we.dispose()},Q),we=(0,A.$Sc)(()=>{clearTimeout($e),re?.deleteAndLeak(we)});return re?.add(we),we}function S(ue){const Q=[];let re=0;const $e=ue.length;function we(){return re<$e?ue[re++]():null}function Ne(Se){Se!=null&&Q.push(Se);const Ie=we();return Ie?Ie.then(Ne):Promise.resolve(Q)}return Promise.resolve(null).then(Ne)}function m(ue,Q=$e=>!!$e,re=null){let $e=0;const we=ue.length,Ne=()=>{if($e>=we)return Promise.resolve(re);const Se=ue[$e++];return Promise.resolve(Se()).then(Ae=>Q(Ae)?Promise.resolve(Ae):Ne())};return Ne()}function y(ue,Q=$e=>!!$e,re=null){if(ue.length===0)return Promise.resolve(re);let $e=ue.length;const we=()=>{$e=-1;for(const Ne of ue)Ne.cancel?.()};return new Promise((Ne,Se)=>{for(const Ie of ue)Ie.then(Ae=>{--$e>=0&&Q(Ae)?(we(),Ne(Ae)):$e===0&&Ne(re)}).catch(Ae=>{--$e>=0&&(we(),Se(Ae))})})}class D{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new M.$he}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,$e)=>{this.g.push({factory:Q,c:re,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const re=Q.factory();re.then(Q.c,Q.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=D;class C extends D{constructor(){super(1)}}e.$Hh=C;class O{constructor(){this.a=new x,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Ih=O;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new oe;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,re=R.$4g){const $e=re.getComparisonKey(Q);return this.a.get($e)?.size??0}queueFor(Q,re,$e=R.$4g){const we=$e.getComparisonKey(Q);let Ne=this.a.get(we);if(!Ne){Ne=new C;const Se=this.f++,Ie=M.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(Se),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(Se,Ie),this.a.set(we,Ne)}return Ne.queue(re)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=z;class T{constructor(Q,re){this.a=-1,typeof Q=="function"&&typeof re=="number"&&this.setIfNotSet(Q,re)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,re){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},re)}setIfNotSet(Q,re){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},re))}}e.$Kh=T;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,re,$e=globalThis){this.cancel();const we=$e.setInterval(()=>{Q()},re);this.d=(0,A.$Sc)(()=>{$e.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$Lh=F;class N{constructor(Q,re){this.b=-1,this.a=Q,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=N;class j{constructor(Q,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=Q,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=j;class B extends N{constructor(Q,re){super(Q,re),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Oh=B;class X extends A.$Uc{constructor(Q,re){super(),this.g=Q,this.h=re,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of Q)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(ue,Q)=>{(0,w.$B)(()=>{if(re)return;const $e=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$Rh=(ue,Q,re)=>{const $e=ue.requestIdleCallback(Q,typeof re=="number"?{timeout:re}:void 0);let we=!1;return{dispose(){we||(we=!0,ue.cancelIdleCallback($e))}}},e.$Qh=ue=>(0,e.$Rh)(globalThis,ue)}();class ie{constructor(Q,re){this.g=!1,this.d=()=>{try{this.j=re()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Rh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=ie;class H extends ie{constructor(Q){super(globalThis,Q)}}e.$Th=H;async function K(ue,Q,re){let $e;for(let we=0;we<re;we++)try{return await ue()}catch(Ne){$e=Ne,await g(Q)}throw $e}class x{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,re,$e){return this.a={taskId:Q,cancel:()=>$e?.(),promise:re},re.then(()=>this.d(Q),()=>this.d(Q)),re}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:re,resolve:$e,reject:we}=c();this.b={run:Q,promise:re,promiseResolve:$e,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=x;class _{constructor(Q,re=()=>Date.now()){this.d=Q,this.f=re,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Wh=_;var ge;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(ge||(ge={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,re)=>{this.a=Q,this.b=re})}complete(Q){return new Promise(re=>{this.a(Q),this.d={outcome:0,value:Q},re()})}error(Q){return new Promise(re=>{this.b(Q),this.d={outcome:1,value:Q},re()})}cancel(){return this.error(new L.$5)}}e.$Xh=oe;var Pe;(function(ue){async function Q($e){let we;const Ne=await Promise.all($e.map(Se=>Se.then(Ie=>Ie,Ie=>{we||(we=Ie)})));if(typeof we<"u")throw we;return Ne}ue.settled=Q;function re($e){return new Promise(async(we,Ne)=>{try{await $e(we,Ne)}catch(Se){Ne(Se)}})}ue.withAsyncBody=re})(Pe||(e.Promises=Pe={}));class me{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=me;class U{constructor(Q){this.b=Q,this.a=new k.$V(()=>new me(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=U;var Y;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(Y||(Y={}));class pe{static fromArray(Q){return new pe(re=>{re.emitMany(Q)})}static fromPromise(Q){return new pe(async re=>{re.emitMany(await Q)})}static fromPromises(Q){return new pe(async re=>{await Promise.all(Q.map(async $e=>re.emitOne(await $e)))})}static merge(Q){return new pe(async re=>{await Promise.all(Q.map(async $e=>{for await(const we of $e)re.emitOne(we)}))})}static{this.EMPTY=pe.fromArray([])}constructor(Q,re){this.a=0,this.b=[],this.d=null,this.f=re,this.g=new M.$he,queueMicrotask(async()=>{const $e={emitOne:we=>this.h(we),emitMany:we=>this.j(we),reject:we=>this.l(we)};try{await Promise.resolve(Q($e)),this.k()}catch(we){this.l(we)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,re){return new pe(async $e=>{for await(const we of Q)$e.emitOne(re(we))})}map(Q){return pe.map(this,Q)}static filter(Q,re){return new pe(async $e=>{for await(const we of Q)re(we)&&$e.emitOne(we)})}filter(Q){return pe.filter(this,Q)}static coalesce(Q){return pe.filter(Q,re=>!!re)}coalesce(){return pe.coalesce(this)}static async toPromise(Q){const re=[];for await(const $e of Q)re.push($e);return re}toPromise(){return pe.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$1h=pe;class ce extends pe{constructor(Q,re){super(re),this.m=Q}cancel(){this.m.cancel()}}e.$2h=ce;function ae(ue){const Q=new l.$se,re=ue(Q.token);return new ce(Q,async $e=>{const we=Q.token.onCancellationRequested(()=>{we.dispose(),Q.dispose(),$e.reject(new L.$5)});try{for await(const Ne of re){if(Q.token.isCancellationRequested)return;$e.emitOne(Ne)}we.dispose(),Q.dispose()}catch(Ne){we.dispose(),Q.dispose(),$e.reject(Ne)}})}class se{constructor(Q){this.a=new oe,this.b=new pe(we=>{if(re){we.reject(re);return}return $e&&we.emitMany($e),this.d=Ne=>we.reject(Ne),this.f=Ne=>we.emitOne(Ne),this.a.p},Q);let re,$e;this.f=we=>{$e||($e=[]),$e.push(we)},this.d=we=>{re||(re=we)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$4h=se}),define(ke[35],De([1,0,19,7,31,27,16,12,14]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=k,e.$sk=v,e.$tk=C,e.$uk=O,e.$vk=z,e.$wk=T,e.$xk=F,e.$yk=X;function k(){return Object.create(null)}e.$qk="**",e.$rk="/";const I="[/\\\\]",P="[^/\\\\]",p=/\//g;function E(ie,H){switch(ie){case 0:return"";case 1:return`${P}*?`;default:return`(?:${I}|${P}+${I}${H?`|${I}${P}+`:""})*?`}}function v(ie,H){if(!ie)return[];const K=[];let x=!1,_=!1,ge="";for(const oe of ie){switch(oe){case H:if(!x&&!_){K.push(ge),ge="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":_=!0;break;case"]":_=!1;break}ge+=oe}return ge&&K.push(ge),K}function d(ie){if(!ie)return"";let H="";const K=v(ie,e.$rk);if(K.every(x=>x===e.$qk))H=".*";else{let x=!1;K.forEach((_,ge)=>{if(_===e.$qk){if(x)return;H+=E(2,ge===K.length-1)}else{let oe=!1,Pe="",me=!1,U="";for(const Y of _){if(Y!=="}"&&oe){Pe+=Y;continue}if(me&&(Y!=="]"||!U)){let pe;Y==="-"?pe=Y:(Y==="^"||Y==="!")&&!U?pe="^":Y===e.$rk?pe="":pe=(0,$.$df)(Y),U+=pe;continue}switch(Y){case"{":oe=!0;continue;case"[":me=!0;continue;case"}":{const ce=`(?:${v(Pe,",").map(ae=>d(ae)).join("|")})`;H+=ce,oe=!1,Pe="";break}case"]":{H+="["+U+"]",me=!1,U="";break}case"?":H+=P;continue;case"*":H+=E(1);continue;default:H+=(0,$.$df)(Y)}}ge<K.length-1&&(K[ge+1]!==e.$qk||ge+2<K.length)&&(H+=I)}x=_===e.$qk})}return H}const h=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),f=function(){return!1},o=function(){return null};function s(ie,H){if(!ie)return o;let K;typeof ie!="string"?K=ie.pattern:K=ie,K=K.trim();const x=`${K}_${!!H.trimForExclusions}`;let _=t.get(x);if(_)return u(_,ie);let ge;return h.test(K)?_=b(K.substr(4),K):(ge=c.exec(g(K,H)))?_=S(ge[1],K):(H.trimForExclusions?n:i).test(K)?_=m(K,H):(ge=a.exec(g(K,H)))?_=y(ge[1].substr(1),K,!0):(ge=r.exec(g(K,H)))?_=y(ge[1],K,!1):_=D(K),t.set(x,_),u(_,ie)}function u(ie,H){if(typeof H=="string")return ie;const K=function(x,_){return(0,M.$zg)(x,H.base,!w.$k)?ie((0,$.$if)(x.substr(H.base.length),R.sep),_):null};return K.allBasenames=ie.allBasenames,K.allPaths=ie.allPaths,K.basenames=ie.basenames,K.patterns=ie.patterns,K}function g(ie,H){return H.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function b(ie,H){return function(K,x){return typeof K=="string"&&K.endsWith(ie)?H:null}}function S(ie,H){const K=`/${ie}`,x=`\\${ie}`,_=function(oe,Pe){return typeof oe!="string"?null:Pe?Pe===ie?H:null:oe===ie||oe.endsWith(K)||oe.endsWith(x)?H:null},ge=[ie];return _.basenames=ge,_.patterns=[H],_.allBasenames=ge,_}function m(ie,H){const K=B(ie.slice(1,-1).split(",").map(Pe=>s(Pe,H)).filter(Pe=>Pe!==o),ie),x=K.length;if(!x)return o;if(x===1)return K[0];const _=function(Pe,me){for(let U=0,Y=K.length;U<Y;U++)if(K[U](Pe,me))return ie;return null},ge=K.find(Pe=>!!Pe.allBasenames);ge&&(_.allBasenames=ge.allBasenames);const oe=K.reduce((Pe,me)=>me.allPaths?Pe.concat(me.allPaths):Pe,[]);return oe.length&&(_.allPaths=oe),_}function y(ie,H,K){const x=R.sep===R.$gc.sep,_=x?ie:ie.replace(p,R.sep),ge=R.sep+_,oe=R.$gc.sep+ie;let Pe;return K?Pe=function(me,U){return typeof me=="string"&&(me===_||me.endsWith(ge)||!x&&(me===ie||me.endsWith(oe)))?H:null}:Pe=function(me,U){return typeof me=="string"&&(me===_||!x&&me===ie)?H:null},Pe.allPaths=[(K?"*/":"./")+ie],Pe}function D(ie){try{const H=new RegExp(`^${d(ie)}$`);return function(K){return H.lastIndex=0,typeof K=="string"&&H.test(K)?ie:null}}catch{return o}}function C(ie,H,K){return!ie||typeof H!="string"?!1:O(ie)(H,void 0,K)}function O(ie,H={}){if(!ie)return f;if(typeof ie=="string"||z(ie)){const K=s(ie,H);if(K===o)return f;const x=function(_,ge){return!!K(_,ge)};return K.allBasenames&&(x.allBasenames=K.allBasenames),K.allPaths&&(x.allPaths=K.allPaths),x}return N(ie,H)}function z(ie){const H=ie;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function T(ie){return ie.allBasenames||[]}function F(ie){return ie.allPaths||[]}function N(ie,H){const K=B(Object.getOwnPropertyNames(ie).map(Pe=>j(Pe,ie[Pe],H)).filter(Pe=>Pe!==o)),x=K.length;if(!x)return o;if(!K.some(Pe=>!!Pe.requiresSiblings)){if(x===1)return K[0];const Pe=function(Y,pe){let ce;for(let ae=0,se=K.length;ae<se;ae++){const ue=K[ae](Y,pe);if(typeof ue=="string")return ue;(0,L.$mh)(ue)&&(ce||(ce=[]),ce.push(ue))}return ce?(async()=>{for(const ae of ce){const se=await ae;if(typeof se=="string")return se}return null})():null},me=K.find(Y=>!!Y.allBasenames);me&&(Pe.allBasenames=me.allBasenames);const U=K.reduce((Y,pe)=>pe.allPaths?Y.concat(pe.allPaths):Y,[]);return U.length&&(Pe.allPaths=U),Pe}const _=function(Pe,me,U){let Y,pe;for(let ce=0,ae=K.length;ce<ae;ce++){const se=K[ce];se.requiresSiblings&&U&&(me||(me=(0,R.$nc)(Pe)),Y||(Y=me.substr(0,me.length-(0,R.$oc)(Pe).length)));const ue=se(Pe,me,Y,U);if(typeof ue=="string")return ue;(0,L.$mh)(ue)&&(pe||(pe=[]),pe.push(ue))}return pe?(async()=>{for(const ce of pe){const ae=await ce;if(typeof ae=="string")return ae}return null})():null},ge=K.find(Pe=>!!Pe.allBasenames);ge&&(_.allBasenames=ge.allBasenames);const oe=K.reduce((Pe,me)=>me.allPaths?Pe.concat(me.allPaths):Pe,[]);return oe.length&&(_.allPaths=oe),_}function j(ie,H,K){if(H===!1)return o;const x=s(ie,K);if(x===o)return o;if(typeof H=="boolean")return x;if(H){const _=H.when;if(typeof _=="string"){const ge=(oe,Pe,me,U)=>{if(!U||!x(oe,Pe))return null;const Y=_.replace("$(basename)",()=>me),pe=U(Y);return(0,L.$mh)(pe)?pe.then(ce=>ce?ie:null):pe?ie:null};return ge.requiresSiblings=!0,ge}}return x}function B(ie,H){const K=ie.filter(Pe=>!!Pe.basenames);if(K.length<2)return ie;const x=K.reduce((Pe,me)=>{const U=me.basenames;return U?Pe.concat(U):Pe},[]);let _;if(H){_=[];for(let Pe=0,me=x.length;Pe<me;Pe++)_.push(H)}else _=K.reduce((Pe,me)=>{const U=me.patterns;return U?Pe.concat(U):Pe},[]);const ge=function(Pe,me){if(typeof Pe!="string")return null;if(!me){let Y;for(Y=Pe.length;Y>0;Y--){const pe=Pe.charCodeAt(Y-1);if(pe===47||pe===92)break}me=Pe.substr(Y)}const U=x.indexOf(me);return U!==-1?_[U]:null};ge.basenames=x,ge.patterns=_,ge.allBasenames=x;const oe=ie.filter(Pe=>!Pe.basenames);return oe.push(ge),oe}function X(ie,H){return(0,l.$ub)(ie,H,(K,x)=>typeof K=="string"&&typeof x=="string"?K===x:typeof K!="string"&&typeof x!="string"?K.base===x.base&&K.pattern===x.pattern:!1)}}),define(ke[81],De([1,0,13,176,23,14,2]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=k,e.$Zk=I,e.$1k=P,e.$2k=p,e.$3k=E,e.$4k=v,e.$5k=d,e.$6k=h;var w;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class ${constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,l.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=p(this.supportThemeIcons?(0,L.$Rk)(i):i).replace(/([ \t]+)/g,(a,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${E(n,i)}
`,this}appendLink(i,n,a){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(i,n){const a=new RegExp((0,A.$df)(n),"g");return i.replace(a,(r,t)=>i.charAt(t-1)!=="\\"?`\\${r}`:r)}}e.$Xk=$;function k(c){return I(c)?!c.value:Array.isArray(c)?c.every(k):!0}function I(c){return c instanceof $?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function P(c,i){return c===i?!0:!c||!i?!1:c.value===i.value&&c.isTrusted===i.isTrusted&&c.supportThemeIcons===i.supportThemeIcons&&c.supportHtml===i.supportHtml&&(c.baseUri===i.baseUri||!!c.baseUri&&!!i.baseUri&&(0,M.$7g)(R.URI.from(c.baseUri),R.URI.from(i.baseUri)))}function p(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(c,i){const n=c.match(/^`+/gm)?.reduce((r,t)=>r.length>t.length?r:t).length??0,a=n>=3?n+1:3;return[`${"`".repeat(a)}${i}`,c,`${"`".repeat(a)}`].join(`
`)}function v(c){return c.replace(/"/g,"&quot;")}function d(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function h(c){const i=[],n=c.split("|").map(r=>r.trim());c=n[0];const a=n[1];if(a){const r=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),f=r?r[1]:"",o=t?t[1]:"",s=isFinite(parseInt(o)),u=isFinite(parseInt(f));s&&i.push(`width="${o}"`),u&&i.push(`height="${f}"`)}return{href:c,dimensions:i}}}),define(ke[103],De([1,0,19,31,16,12,23,14]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jw=$,e.$Kw=I,e.$Lw=p,e.$Mw=E,e.$Nw=c,e.$Ow=n,e.$Pw=a,e.$Qw=r,e.$Rw=t,e.$Sw=f;function $(s,u){const{os:g,tildify:b,relative:S}=u;if(S){const D=k(s,S,g);if(typeof D=="string")return D}let m=s.fsPath;if(g===1&&!A.$i?m=m.replace(/\//g,"\\"):g!==1&&A.$i&&(m=m.replace(/\\/g,"/")),g!==1&&b?.userHome){const D=b.userHome.fsPath;let C;s.scheme!==b.userHome.scheme&&s.path[0]===M.$gc.sep&&s.path[1]!==M.$gc.sep?C=b.userHome.with({path:s.path}).fsPath:C=m,m=p(C,D,g)}return(g===1?M.$fc:M.$gc).normalize(I(m,g===1))}function k(s,u,g){const b=g===1?M.$fc:M.$gc,S=g===3?R.$4g:R.$6g,m=u.getWorkspace(),y=(0,l.$Ob)(m.folders);if(!y)return;s.scheme!==y.uri.scheme&&s.path[0]===M.$gc.sep&&s.path[1]!==M.$gc.sep&&(s=y.uri.with({path:s.path}));const D=u.getWorkspaceFolder(s);if(!D)return;let C;if(S.isEqual(D.uri,s)?C="":C=S.relativePath(D.uri,s)??"",C&&(C=b.normalize(C)),m.folders.length>1&&!u.noPrefix){const O=D.name?D.name:S.basenameOrAuthority(D.uri);C=C?`${O} \u2022 ${C}`:O}return C}function I(s,u=A.$i){return(0,L.$Eg)(s,u)?s.charAt(0).toUpperCase()+s.slice(1):s}let P=Object.create(null);function p(s,u,g=A.OS){if(g===1||!s||!u)return s;let b=P.original===u?P.normalized:void 0;b||(b=u,A.$i&&(b=(0,L.$tg)(b)),b=`${(0,w.$jf)(b,M.$gc.sep)}${M.$gc.sep}`,P={original:u,normalized:b});let S=s;return A.$i&&(S=(0,L.$tg)(S)),(g===3?S.startsWith(b):(0,w.$Cf)(S,b))?`~/${S.substr(b.length)}`:s}function E(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}const v="\u2026",d="\\\\",h="~";function c(s,u=M.sep){const g=new Array(s.length);let b=!1;for(let S=0;S<s.length;S++){const m=s[S];if(m===""){g[S]=`.${u}`;continue}if(!m){g[S]=m;continue}b=!0;let y="",D=m;D.indexOf(d)===0?(y=D.substr(0,D.indexOf(d)+d.length),D=D.substr(D.indexOf(d)+d.length)):D.indexOf(u)===0?(y=D.substr(0,D.indexOf(u)+u.length),D=D.substr(D.indexOf(u)+u.length)):D.indexOf(h)===0&&(y=D.substr(0,D.indexOf(h)+h.length),D=D.substr(D.indexOf(h)+h.length));const C=D.split(u);for(let O=1;b&&O<=C.length;O++)for(let z=C.length-O;b&&z>=0;z--){b=!1;let T=C.slice(z,z+O).join(u);for(let F=0;!b&&F<s.length;F++)if(F!==S&&s[F]&&s[F].indexOf(T)>-1){const N=z+O===C.length,j=z>0&&s[F].indexOf(u)>-1?u+T:T,B=s[F].endsWith(j);b=!N||B}if(!b){let F="";(C[0].endsWith(":")||y!=="")&&(z===1&&(z=0,O++,T=C[0]+u+T),z>0&&(F=C[0]+u),F=y+F),z>0&&(F=F+v+u),F=F+T,z+O<C.length&&(F=F+u+v),g[S]=F}}b&&(g[S]=m)}return g}var i;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(s,u=Object.create(null)){const g=[];let b=!1,S="";for(const m of s)if(m==="$"||b&&m==="{")S&&g.push({value:S,type:i.TEXT}),S="",b=!0;else if(m==="}"&&b){const y=u[S];if(typeof y=="string")y.length&&g.push({value:y,type:i.VARIABLE});else if(y){const D=g[g.length-1];(!D||D.type!==i.SEPARATOR)&&g.push({value:y.label,type:i.SEPARATOR})}S="",b=!1}else S+=m;return S&&!b&&g.push({value:S,type:i.TEXT}),g.filter((m,y)=>{if(m.type===i.SEPARATOR){const D=g[y-1],C=g[y+1];return[D,C].every(O=>O&&(O.type===i.VARIABLE||O.type===i.TEXT)&&O.value.length>0)}return!0}).map(m=>m.value).join("")}function a(s,u){return A.$j||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):s.replace(/&&|&/g,g=>g==="&"?"&&":"&")}function r(s,u){return A.$j||u?s.replace(/\(&&\w\)|&&/g,""):A.$i?s.replace(/&&|&/g,g=>g==="&"?"&&":"&"):s.replace(/&&/g,"_")}function t(s){return s.replace(/&/g,"&&")}function f(s){if(s.endsWith("]")){const u=s.lastIndexOf(" [",s.length-2);if(u!==-1){const g=o(s.substring(0,u)),b=s.substring(u);return{name:g.name+b,parentPath:g.parentPath}}}return o(s)}function o(s){const u=s.indexOf("/")!==-1?M.$gc:M.$fc,g=u.basename(s),b=u.dirname(s);return g.length?{name:g,parentPath:b}:{name:b,parentPath:""}}}),define(ke[134],De([1,0,22,2]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=void 0,e.$En=w,e.$Fn=k,e.$Gn=I;function M(P){return P.toJSON()}class A{constructor(p){this.a=p}transformIncoming(p){const E=this.a.transformIncoming(p);return E===p?p:M(L.URI.from(E))}transformOutgoing(p){const E=this.a.transformOutgoing(p);return E===p?p:M(L.URI.from(E))}transformOutgoingURI(p){const E=this.a.transformOutgoing(p);return E===p?p:L.URI.from(E)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Cn=A,e.$Dn=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function R(P,p,E){if(!P||E>200)return null;if(typeof P=="object"){if(P instanceof L.URI)return p.transformOutgoing(P);for(const v in P)if(Object.hasOwnProperty.call(P,v)){const d=R(P[v],p,E+1);d!==null&&(P[v]=d)}}return null}function w(P,p){const E=R(P,p,0);return E===null?P:E}function $(P,p,E,v){if(!P||v>200)return null;if(typeof P=="object"){if(P.$mid===1)return E?L.URI.revive(p.transformIncoming(P)):p.transformIncoming(P);if(P instanceof l.$Je)return null;for(const d in P)if(Object.hasOwnProperty.call(P,d)){const h=$(P[d],p,E,v+1);h!==null&&(P[d]=h)}}return null}function k(P,p){const E=$(P,p,!1,0);return E===null?P:E}function I(P,p){const E=$(P,p,!0,0);return E===null?P:E}}),define(ke[32],De([1,0,54,64,400,7,31,77,16,12,23,2]),function(le,e,l,L,M,A,R,w,$,k,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=h,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=g,e.writeFileSync=S;var p;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function E(j,B=p.UNLINK,X){if((0,R.$Dg)(j))throw new Error("rimraf - will refuse to recursively delete root");return B===p.UNLINK?d(j):v(j,X)}async function v(j,B=(0,R.$Ig)((0,L.tmpdir)())){try{try{await l.promises.rename(j,B)}catch(X){return X.code==="ENOENT"?void 0:d(j)}d(B).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function d(j){return(0,M.promisify)(l.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function h(j){if((0,R.$Dg)(j))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}async function c(j,B){return a(await(B?i(j):(0,M.promisify)(l.readdir)(j)))}async function i(j){try{return await(0,M.promisify)(l.readdir)(j,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const B=[],X=await c(j);for(const ie of X){let H=!1,K=!1,x=!1;try{const _=await e.Promises.lstat((0,$.$jc)(j,ie));H=_.isFile(),K=_.isDirectory(),x=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}B.push({name:ie,isFile:()=>H,isDirectory:()=>K,isSymbolicLink:()=>x})}return B}function n(j){return a(l.readdirSync(j))}function a(j){return j.map(B=>typeof B=="string"?k.$j?(0,w.$fm)(B):B:(B.name=k.$j?(0,w.$fm)(B.name):B.name,B))}async function r(j){const B=await c(j),X=[];for(const ie of B)await f.existsDirectory((0,$.$jc)(j,ie))&&X.push(ie);return X}function t(j,B=1e3){return new Promise(X=>{let ie=!1;const H=setInterval(()=>{ie||(ie=!0,l.access(j,K=>{ie=!1,K&&(clearInterval(H),X(void 0))}))},B)})}var f;(function(j){async function B(H){let K;try{if(K=await e.Promises.lstat(H),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(k.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw _}throw x}}j.stat=B;async function X(H){try{const{stat:K,symbolicLink:x}=await j.stat(H);return K.isFile()&&x?.dangling!==!0}catch{}return!1}j.existsFile=X;async function ie(H){try{const{stat:K,symbolicLink:x}=await j.stat(H);return K.isDirectory()&&x?.dangling!==!0}catch{}return!1}j.existsDirectory=ie})(f||(e.SymlinkSupport=f={}));const o=new A.$Jh;function s(j,B,X){return o.queueFor(P.URI.file(j),()=>{const ie=m(X);return new Promise((H,K)=>b(j,B,ie,x=>x?K(x):H()))},I.$5g)}let u=!0;function g(j){u=j}function b(j,B,X,ie){if(!u)return l.writeFile(j,B,{mode:X.mode,flag:X.flag},ie);l.open(j,X.flag,X.mode,(H,K)=>{if(H)return ie(H);l.writeFile(K,B,x=>{if(x)return l.close(K,()=>ie(x));l.fdatasync(K,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),g(!1)),l.close(K,ge=>ie(ge))))})})}function S(j,B,X){const ie=m(X);if(!u)return l.writeFileSync(j,B,{mode:ie.mode,flag:ie.flag});const H=l.openSync(j,ie.flag,ie.mode);try{l.writeFileSync(H,B);try{l.fdatasyncSync(H)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),g(!1)}}finally{l.closeSync(H)}}function m(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function y(j,B,X=6e4){if(j!==B)try{k.$i&&typeof X=="number"?await D(j,B,Date.now(),X):await(0,M.promisify)(l.rename)(j,B)}catch(ie){if(j.toLowerCase()!==B.toLowerCase()&&ie.code==="EXDEV"||j.endsWith("."))await C(j,B,{preserveSymlinks:!1}),await E(j,p.MOVE);else throw ie}}async function D(j,B,X,ie,H=0){try{return await(0,M.promisify)(l.rename)(j,B)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-X>=ie)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${K}`),K;if(H===0){let x=!1;try{const{stat:_}=await f.stat(B);_.isFile()||(x=!0)}catch{}if(x)throw K}return await(0,A.$Bh)(Math.min(100,H*10)),D(j,B,X,ie,H+1)}}async function C(j,B,X){return z(j,B,{root:{source:j,target:B},options:X,handledSourcePaths:new Set})}const O=511;async function z(j,B,X){if(X.handledSourcePaths.has(j))return;X.handledSourcePaths.add(j);const{stat:ie,symbolicLink:H}=await f.stat(j);if(H){if(X.options.preserveSymlinks)try{return await N(j,B,X)}catch{}if(H.dangling)return}return ie.isDirectory()?T(j,B,ie.mode&O,X):F(j,B,ie.mode&O)}async function T(j,B,X,ie){await e.Promises.mkdir(B,{recursive:!0,mode:X});const H=await c(j);for(const K of H)await z((0,$.$jc)(j,K),(0,$.$jc)(B,K),ie)}async function F(j,B,X){await e.Promises.copyFile(j,B),await e.Promises.chmod(B,X)}async function N(j,B,X){let ie=await e.Promises.readlink(j);(0,R.$zg)(ie,X.root.source,!k.$k)&&(ie=(0,$.$jc)(X.root.target,ie.substr(X.root.source.length+1))),await e.Promises.symlink(ie,B)}e.Promises=new class{get access(){return(0,M.promisify)(l.access)}get stat(){return(0,M.promisify)(l.stat)}get lstat(){return(0,M.promisify)(l.lstat)}get utimes(){return(0,M.promisify)(l.utimes)}get read(){return(j,B,X,ie,H)=>new Promise((K,x)=>{l.read(j,B,X,ie,H,(_,ge,oe)=>_?x(_):K({bytesRead:ge,buffer:oe}))})}get readFile(){return(0,M.promisify)(l.readFile)}get write(){return(j,B,X,ie,H)=>new Promise((K,x)=>{l.write(j,B,X,ie,H,(_,ge,oe)=>_?x(_):K({bytesWritten:ge,buffer:oe}))})}get appendFile(){return(0,M.promisify)(l.appendFile)}get fdatasync(){return(0,M.promisify)(l.fdatasync)}get truncate(){return(0,M.promisify)(l.truncate)}get copyFile(){return(0,M.promisify)(l.copyFile)}get open(){return(0,M.promisify)(l.open)}get close(){return(0,M.promisify)(l.close)}get symlink(){return(0,M.promisify)(l.symlink)}get readlink(){return(0,M.promisify)(l.readlink)}get chmod(){return(0,M.promisify)(l.chmod)}get mkdir(){return(0,M.promisify)(l.mkdir)}get unlink(){return(0,M.promisify)(l.unlink)}get rmdir(){return(0,M.promisify)(l.rmdir)}get realpath(){return(0,M.promisify)(l.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return r}get writeFile(){return s}get rm(){return E}get rename(){return y}get copy(){return C}}}),define(ke[104],De([1,0,54,16,12,14,32]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=w,e.$$q=$,e.$_q=k,e.$ar=I;function w(p){if(M.$k)return p;const E=(0,L.$mc)(p);if(p===E)return p;const v=((0,L.$nc)(p)||p).toLowerCase();try{const h=(0,R.readdirSync)(E).filter(c=>c.toLowerCase()===v);if(h.length===1){const c=w(E);if(c)return(0,L.$jc)(c,h[0])}else if(h.length>1){const c=h.indexOf(v);if(c>=0){const i=w(E);if(i)return(0,L.$jc)(i,h[c])}}}catch{}return null}async function $(p,E){if(M.$k)return p;const v=(0,L.$mc)(p);if(p===v)return p;const d=((0,L.$nc)(p)||p).toLowerCase();try{if(E?.isCancellationRequested)return null;const c=(await R.Promises.readdir(v)).filter(i=>i.toLowerCase()===d);if(c.length===1){const i=await $(v,E);if(i)return(0,L.$jc)(i,c[0])}else if(c.length>1){const i=c.indexOf(d);if(i>=0){const n=await $(v,E);if(n)return(0,L.$jc)(n,c[i])}}}catch{}return null}async function k(p){try{return await R.Promises.realpath(p)}catch{const v=P(p);return await R.Promises.access(v,l.constants.R_OK),v}}function I(p){try{return l.realpathSync(p)}catch{const v=P(p);return l.accessSync(v,l.constants.R_OK),v}}function P(p){return(0,A.$jf)((0,L.$hc)(p),L.sep)}}),define(ke[105],De([1,0,16,12,52,102,18,32]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$sm=$,e.$tm=k,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function $(P=M.env){return P.comspec||"cmd.exe"}function k(P){let p=[],E=!1;const v=function(d){if(E){p.push(d);return}(!P.send(d,c=>{if(c&&console.error(c),E=!1,p.length>0){const i=p.slice(0);p=[],i.forEach(n=>v(n))}})||L.$i)&&(E=!0)};return{send:v}}var I;(function(P){async function p(E,v,d){if(l.$ic(E))return E;if(v===void 0&&(v=M.cwd()),l.$mc(E)!=="."||(d===void 0&&R.$ag(M.env.PATH)&&(d=M.env.PATH.split(l.$tc)),d===void 0||d.length===0))return l.$jc(v,E);async function c(i){if(await w.Promises.exists(i)){let n;try{n=await w.Promises.stat(i)}catch(a){a.message.startsWith("EACCES")&&(n=await w.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of d){let n;if(l.$ic(i)?n=l.$jc(i,E):n=l.$jc(v,i,E),await c(n))return n;let a=n+".com";if(await c(a)||(a=n+".exe",await c(a)))return a}return l.$jc(v,E)}P.findExecutable=p})(I||(e.win32=I={}))});var Je=this&&this.__decorate||function(le,e,l,L){var M=arguments.length,A=M<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,l):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(le,e,l,L);else for(var w=le.length-1;w>=0;w--)(R=le[w])&&(A=(M<3?R(A):M>3?R(e,l,A):R(e,l))||A);return M>3&&A&&Object.defineProperty(e,l,A),A};define(ke[82],De([1,0,19,7,22,21,57,13,4,3,53,14,18]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=g,e.$bi=b,e.$gi=O,e.$hi=z;var E;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(E||(E={}));function v(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(d||(d={}));function h(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(c||(c={}));function i(H){let K=0;for(let x=0;;x+=7){const _=H.read(1);if(K|=(_.buffer[0]&127)<<x,!(_.buffer[0]&128))return K}}const n=o(0);function a(H,K){if(K===0){H.write(n);return}let x=0;for(let ge=K;ge!==0;ge=ge>>>7)x++;const _=M.$Je.alloc(x);for(let ge=0;K!==0;ge++)_.buffer[ge]=K&127,K=K>>>7,K>0&&(_.buffer[ge]|=128);H.write(_)}class r{constructor(K){this.b=K,this.a=0}read(K){const x=this.b.slice(this.a,this.a+K);return this.a+=x.byteLength,x}}e.$$h=r;class t{constructor(){this.a=[]}get buffer(){return M.$Je.concat(this.a)}write(K){this.a.push(K)}}e.$_h=t;var f;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(f||(f={}));function o(H){const K=M.$Je.alloc(1);return K.writeUInt8(H,0),K}const s={Undefined:o(f.Undefined),String:o(f.String),Buffer:o(f.Buffer),VSBuffer:o(f.VSBuffer),Array:o(f.Array),Object:o(f.Object),Uint:o(f.Int)},u=typeof Buffer<"u";function g(H,K){if(typeof K>"u")H.write(s.Undefined);else if(typeof K=="string"){const x=M.$Je.fromString(K);H.write(s.String),a(H,x.byteLength),H.write(x)}else if(u&&Buffer.isBuffer(K)){const x=M.$Je.wrap(K);H.write(s.Buffer),a(H,x.byteLength),H.write(x)}else if(K instanceof M.$Je)H.write(s.VSBuffer),a(H,K.byteLength),H.write(K);else if(Array.isArray(K)){H.write(s.Array),a(H,K.length);for(const x of K)g(H,x)}else if(typeof K=="number"&&(K|0)===K)H.write(s.Uint),a(H,K);else{const x=M.$Je.fromString(JSON.stringify(K));H.write(s.Object),a(H,x.byteLength),H.write(x)}}function b(H){switch(H.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return H.read(i(H)).toString();case f.Buffer:return H.read(i(H)).buffer;case f.VSBuffer:return H.read(i(H));case f.Array:{const x=i(H),_=[];for(let ge=0;ge<x;ge++)_.push(b(H));return _}case f.Object:return JSON.parse(H.read(i(H)).toString());case f.Int:return i(H)}}class S{constructor(K,x,_=null,ge=1e3){this.h=K,this.j=x,this.k=_,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(K,x){this.b.set(K,x),setTimeout(()=>this.w(K),0)}m(K){switch(K.type){case 200:{const x=this.o([K.type]);this.k?.logOutgoing(x,0,1,h(K.type));return}case 201:case 202:case 204:case 203:{const x=this.o([K.type,K.id],K.data);this.k?.logOutgoing(x,K.id,1,h(K.type),K.data);return}}}o(K,x=void 0){const _=new t;return g(_,K),g(_,x),this.p(_.buffer)}p(K){try{return this.h.send(K),K.byteLength}catch{return 0}}q(K){const x=new r(K),_=b(x),ge=b(x),oe=_[0];switch(oe){case 100:return this.k?.logIncoming(K.byteLength,_[1],1,`${v(oe)}: ${_[2]}.${_[3]}`,ge),this.s({type:oe,id:_[1],channelName:_[2],name:_[3],arg:ge});case 102:return this.k?.logIncoming(K.byteLength,_[1],1,`${v(oe)}: ${_[2]}.${_[3]}`,ge),this.t({type:oe,id:_[1],channelName:_[2],name:_[3],arg:ge});case 101:return this.k?.logIncoming(K.byteLength,_[1],1,`${v(oe)}`),this.u({type:oe,id:_[1]});case 103:return this.k?.logIncoming(K.byteLength,_[1],1,`${v(oe)}`),this.u({type:oe,id:_[1]})}}s(K){const x=this.b.get(K.channelName);if(!x){this.v(K);return}const _=new A.$se;let ge;try{ge=x.call(this.j,K.name,K.arg,_.token)}catch(me){ge=Promise.reject(me)}const oe=K.id;ge.then(me=>{this.m({id:oe,data:me,type:201})},me=>{me instanceof Error?this.m({id:oe,data:{message:me.message,name:me.name,stack:me.stack?me.stack.split?me.stack.split(`
`):me.stack:void 0},type:202}):this.m({id:oe,data:me,type:203})}).finally(()=>{Pe.dispose(),this.d.delete(K.id)});const Pe=(0,k.$Sc)(()=>_.cancel());this.d.set(K.id,Pe)}t(K){const x=this.b.get(K.channelName);if(!x){this.v(K);return}const _=K.id,oe=x.listen(this.j,K.name,K.arg)(Pe=>this.m({id:_,data:Pe,type:204}));this.d.set(K.id,oe)}u(K){const x=this.d.get(K.id);x&&(x.dispose(),this.d.delete(K.id))}v(K){let x=this.g.get(K.channelName);x||(x=[],this.g.set(K.channelName,x));const _=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.m({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:K,timeoutTimer:_})}w(K){const x=this.g.get(K);if(x){for(const _ of x)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.s(_.request);break;case 102:this.t(_.request);break}this.g.delete(K)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$ci=S;var m;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class y{constructor(K,x=null){this.l=K,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=x}getChannel(K){const x=this;return{call(_,ge,oe){return x.a?Promise.reject(new w.$5):x.m(K,_,ge,oe)},listen(_,ge){return x.a?$.Event.None:x.o(K,_,ge)}}}m(K,x,_,ge=A.CancellationToken.None){const oe=this.g++,me={id:oe,type:100,channelName:K,name:x,arg:_};if(ge.isCancellationRequested)return Promise.reject(new w.$5);let U;return new Promise((pe,ce)=>{if(ge.isCancellationRequested)return ce(new w.$5);const ae=()=>{const re=$e=>{switch($e.type){case 201:this.f.delete(oe),pe($e.data);break;case 202:{this.f.delete(oe);const we=new Error($e.data.message);we.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,we.name=$e.data.name,ce(we);break}case 203:this.f.delete(oe),ce($e.data);break}};this.f.set(oe,re),this.p(me)};let se=null;this.b===c.Idle?ae():(se=(0,L.$nh)(re=>this.u()),se.then(()=>{se=null,ae()}));const ue=()=>{se?(se.cancel(),se=null):this.p({id:oe,type:101}),ce(new w.$5)},Q=ge.onCancellationRequested(ue);U=(0,k.$Rc)((0,k.$Sc)(ue),Q),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(K,x,_){const ge=this.g++,Pe={id:ge,type:102,channelName:K,name:x,arg:_};let me=null;const U=new $.$he({onWillAddFirstListener:()=>{me=(0,L.$nh)(pe=>this.u()),me.then(()=>{me=null,this.d.add(U),this.p(Pe)})},onDidRemoveLastListener:()=>{me?(me.cancel(),me=null):(this.d.delete(U),this.p({id:ge,type:103}))}}),Y=pe=>U.fire(pe.data);return this.f.set(ge,Y),U.event}p(K){switch(K.type){case 100:case 102:{const x=this.q([K.type,K.id,K.channelName,K.name],K.arg);this.j?.logOutgoing(x,K.id,0,`${v(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const x=this.q([K.type,K.id]);this.j?.logOutgoing(x,K.id,0,v(K.type));return}}}q(K,x=void 0){const _=new t;return g(_,K),g(_,x),this.r(_.buffer)}r(K){try{return this.l.send(K),K.byteLength}catch{return 0}}s(K){const x=new r(K),_=b(x),ge=b(x),oe=_[0];switch(oe){case 200:return this.j?.logIncoming(K.byteLength,0,0,h(oe)),this.t({type:_[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(K.byteLength,_[1],0,h(oe),ge),this.t({type:_[0],id:_[1],data:ge})}}t(K){if(K.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(K.id)?.(K)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Pc)(this.d.values()),this.d.clear()}}e.$di=y,Je([R.$5h],y.prototype,"onDidInitializePromise",null);class D{get connections(){const K=[];return this.f.forEach(x=>K.push(x)),K}constructor(K,x,_){this.a=new Map,this.f=new Set,this.g=new $.$he,this.onDidAddConnection=this.g.event,this.h=new $.$he,this.onDidRemoveConnection=this.h.event,this.j=new k.$Tc,this.j.add(K(({protocol:ge,onDidClientDisconnect:oe})=>{const Pe=$.Event.once(ge.onMessage);this.j.add(Pe(me=>{const U=new r(me),Y=b(U),pe=new S(ge,Y,x,_),ce=new y(ge,x);this.a.forEach((se,ue)=>pe.registerChannel(ue,se));const ae={channelServer:pe,channelClient:ce,ctx:Y};this.f.add(ae),this.g.fire(ae),this.j.add(oe(()=>{pe.dispose(),ce.dispose(),this.f.delete(ae),this.h.fire(ae)}))}))}))}getChannel(K,x){const _=this;return{call(ge,oe,Pe){let me;if((0,p.$og)(x)){const Y=(0,l.$3b)(_.connections.filter(x));me=Y?Promise.resolve(Y):$.Event.toPromise($.Event.filter(_.onDidAddConnection,x))}else me=x.routeCall(_,ge,oe);const U=me.then(Y=>Y.channelClient.getChannel(K));return O(U).call(ge,oe,Pe)},listen(ge,oe){if((0,p.$og)(x))return _.k(K,x,ge,oe);const Pe=x.routeEvent(_,ge,oe).then(me=>me.channelClient.getChannel(K));return O(Pe).listen(ge,oe)}}}k(K,x,_,ge){const oe=this;let Pe;const me=new $.$he({onWillAddFirstListener:()=>{Pe=new k.$Tc;const U=new $.$ne,Y=new Map,pe=ae=>{const ue=ae.channelClient.getChannel(K).listen(_,ge),Q=U.add(ue);Y.set(ae,Q)},ce=ae=>{const se=Y.get(ae);se&&(se.dispose(),Y.delete(ae))};oe.connections.filter(x).forEach(pe),$.Event.filter(oe.onDidAddConnection,x)(pe,void 0,Pe),oe.onDidRemoveConnection(ce,void 0,Pe),U.event(me.fire,me,Pe),Pe.add(U)},onDidRemoveLastListener:()=>{Pe?.dispose(),Pe=void 0}});return me.event}registerChannel(K,x){this.a.set(K,x);for(const _ of this.f)_.channelServer.registerChannel(K,x)}dispose(){this.j.dispose();for(const K of this.f)K.channelClient.dispose(),K.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=D;class C{constructor(K,x,_=null){const ge=new t;g(ge,x),K.send(ge.buffer),this.a=new y(K,_),this.d=new S(K,x,_)}getChannel(K){return this.a.getChannel(K)}registerChannel(K,x){this.d.registerChannel(K,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=C;function O(H){return{call(K,x,_){return H.then(ge=>ge.call(K,x,_))},listen(K,x){const _=new $.$qe;return H.then(ge=>_.input=ge.listen(K,x)),_.event}}}function z(H){let K=!1;return{call(x,_,ge){return K?H.call(x,_,ge):(0,L.$Bh)(0).then(()=>K=!0).then(()=>H.call(x,_,ge))},listen(x,_){if(K)return H.listen(x,_);const ge=new $.$qe;return(0,L.$Bh)(0).then(()=>K=!0).then(()=>ge.input=H.listen(x,_)),ge.event}}}class T{constructor(K){this.a=K}routeCall(K){return this.b(K)}routeEvent(K){return this.b(K)}async b(K){for(const x of K.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(K.onDidAddConnection),await this.b(K)}}e.$ii=T;var F;(function(H){function K(oe,Pe,me){const U=oe,Y=me&&me.disableMarshalling,pe=new Map;for(const ce in U)_(ce)&&pe.set(ce,$.Event.buffer(U[ce],!0,void 0,Pe));return new class{listen(ce,ae,se){const ue=pe.get(ae);if(ue)return ue;const Q=U[ae];if(typeof Q=="function"){if(ge(ae))return Q.call(U,se);if(_(ae))return pe.set(ae,$.Event.buffer(U[ae],!0,void 0,Pe)),pe.get(ae)}throw new w.$bb(`Event not found: ${ae}`)}call(ce,ae,se){const ue=U[ae];if(typeof ue=="function"){if(!Y&&Array.isArray(se))for(let re=0;re<se.length;re++)se[re]=(0,I.$0h)(se[re]);let Q=ue.apply(U,se);return Q instanceof Promise||(Q=Promise.resolve(Q)),Q}throw new w.$bb(`Method not found: ${ae}`)}}}H.fromService=K;function x(oe,Pe){const me=Pe&&Pe.disableMarshalling;return new Proxy({},{get(U,Y){if(typeof Y=="string")return Pe?.properties?.has(Y)?Pe.properties.get(Y):ge(Y)?function(pe){return oe.listen(Y,pe)}:_(Y)?oe.listen(Y):async function(...pe){let ce;Pe&&!(0,p.$jg)(Pe.context)?ce=[Pe.context,...pe]:ce=pe;const ae=await oe.call(Y,ce);return me?ae:(0,I.$0h)(ae)};throw new w.$bb(`Property not found: ${String(Y)}`)}})}H.toService=x;function _(oe){return oe[0]==="o"&&oe[1]==="n"&&P.$Af(oe.charCodeAt(2))}function ge(oe){return/^onDynamic/.test(oe)&&P.$Af(oe.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const K=H.toString();if(K!=="[object Object]")return K}return H}function B(H){return Array.isArray(H)?H.map(j):j(H)}function X(H,K,x,_,ge,oe,Pe){Pe=B(Pe);const me=N[ge],U=me[_%me.length];let Y=[`%c[${H}]%c[${String(K).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(oe)?(Y=Y.concat(Pe),Y.push(")")):Y.push(Pe),console.log.apply(console,Y)}class ie{constructor(K,x){this.d=K,this.f=x,this.a=0,this.b=0}logOutgoing(K,x,_,ge,oe){this.b+=K,X(this.d,this.b,K,x,_,ge,oe)}logIncoming(K,x,_,ge,oe){this.a+=K,X(this.f,this.a,K,x,_,ge,oe)}}e.$ji=ie}),define(ke[83],De([1,0,22,4,3,82]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var w;(function(s){s.enableDiagnostics=!1,s.records=[];const u=new WeakMap;let g=0;function b(m,y){if(!u.has(m)){const D=String(++g);u.set(m,D)}return u.get(m)}function S(m,y,D,C){if(!s.enableDiagnostics)return;const O=b(m,y);if(C instanceof l.$Je||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const z=l.$Je.alloc(C.byteLength);z.set(C),s.records.push({timestamp:Date.now(),id:O,label:y,type:D,buff:z})}else s.records.push({timestamp:Date.now(),id:O,label:y,type:D,data:C})}s.traceSocketEvent=S})(w||(e.SocketDiagnostics=w={}));var $;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let k=null;function I(){return k||(k=l.$Je.alloc(0)),k}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,g){if(u===0)return I();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const y=this.a[0];return g&&(this.a.shift(),this.b-=u),y}if(this.a[0].byteLength>u){const y=this.a[0].slice(0,u);return g&&(this.a[0]=this.a[0].slice(u),this.b-=u),y}const b=l.$Je.alloc(u);let S=0,m=0;for(;u>0;){const y=this.a[m];if(y.byteLength>u){const D=y.slice(0,u);b.set(D,S),S+=u,g&&(this.a[m]=y.slice(u),this.b-=u),u-=u}else b.set(y,S),S+=y.byteLength,g?(this.a.shift(),this.b-=y.byteLength):m++,u-=y.byteLength}return b}}e.$ki=P;var p;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(p||(p={}));function E(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class d{constructor(u,g,b,S){this.type=u,this.id=g,this.ack=b,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends M.$Uc{constructor(u){super(),this.f=this.B(new L.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=u,this.b=!1,this.c=new P,this.B(this.a.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const g=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=g.readUInt32BE(9),this.g.messageType=g.readUInt8(0),this.g.id=g.readUInt32BE(1),this.g.ack=g.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,S=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",g),this.f.fire(new d(b,S,m,g)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=l.$Je.alloc(13);g.writeUInt8(u.type,0),g.writeUInt32BE(u.id,1),g.writeUInt32BE(u.ack,5),g.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",u.data),this.j(g,u.data)}g(u,g){const b=this.f===0;return this.d.push(u,g),this.f+=u.byteLength+g.byteLength,b}h(){const u=l.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,g){this.g(u,g)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:u.byteLength}),this.c.write(u)}}class i extends M.$Uc{constructor(u){super(),this.f=new L.$he,this.onMessage=this.f.event,this.g=new L.$he,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new c(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(g=>{g.type===1&&this.f.fire(g.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new d(1,0,0,u))}}e.$li=i;class n extends A.$fi{static fromSocket(u,g){return new n(new i(u),g)}get onDidDispose(){return this.b.onDidDispose}constructor(u,g,b=null){super(u,g,b),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$mi=n;class a{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$ni=a;class r{constructor(u){this.data=u,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let u=0,g=this.a;for(;g;)g=g.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let g=0,b=this.a;for(;b;)u[g++]=b.data,b=b.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const g=new r(u);if(!this.a){this.a=g,this.b=g;return}this.b.next=g,this.b=g}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const u=Date.now();for(let g=0;g<f.a;g++)this.c[g]=u-1e3*g;setInterval(()=>{for(let g=f.a;g>=1;g--)this.c[g]=this.c[g-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),g=(1+f.a)*1e3;let b=0;for(let S=0;S<f.a;S++)u-this.c[S]<=g&&b++;return 1-b/f.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new a,this.onControlMessage=this.u.event,this.v=new a,this.onMessage=this.v.event,this.w=new a,this.onDidDispose=this.w.event,this.x=new a,this.onSocketClose=this.x.event,this.y=new a,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??f.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new M.$Tc,this.o=u.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new d(5,0,0,I());this.p.write(u),this.p.flush()}sendPause(){const u=new d(7,0,0,I());this.p.write(u)}sendResume(){const u=new d(8,0,0,I());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,g){this.a=!0,this.r.dispose(),this.r=new M.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(g)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new d(3,0,this.h,I());this.p.write(u);const g=this.b.toArray();for(let b=0,S=g.length;b<S;b++)this.p.write(g[b]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const g=this.b.peek();if(g&&g.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case 0:break;case 1:{if(u.id>this.g)if(u.id!==this.g+1){const g=Date.now();g-this.m>1e4&&(this.m=g,this.p.write(new d(6,0,0,I())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case 2:{this.u.fire(u.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const g=this.b.toArray();for(let b=0,S=g.length;b<S;b++)this.p.write(g[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const g=++this.c;this.h=this.g;const b=new d(1,g,this.h,u);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(u){const g=new d(2,0,0,u);this.p.write(g)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),g=Date.now()-u.writtenTime,b=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(g>=2e4&&b>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:g,timeSinceLastReceivedSomeData:b});return}const m=Math.max(2e4-g,2e4-b,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new d(3,0,this.h,I());this.p.write(u)}D(){this.h=this.g;const u=new d(9,0,this.h,I());this.p.write(u)}}e.$oi=o}),define(ke[199],De([1,0,55,7,22,21,197,13,4,3,24,105,102,82]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=void 0;class v extends E.$ci{constructor(c){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>M.$Je.wrap(Buffer.from(i,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$6q=v;class d{constructor(c,i){this.i=c,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$he,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new L.$xh(n),this.d=null,this.f=null}getChannel(c){const i=this;return{call(n,a,r){return i.k(c,n,a,r)},listen(n,a){return i.l(c,n,a)}}}k(c,i,n,a=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(w.$6());this.b.cancel();const r=this.n(c),t=(0,L.$nh)(s=>r.call(i,n,s)),f=a.onCancellationRequested(()=>t.cancel()),o=(0,k.$Sc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{f.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,i,n){if(!this.b)return $.Event.None;this.b.cancel();let a;const r=new $.$he({onWillAddFirstListener:()=>{a=this.n(c).listen(i,n)(r.fire,r),this.c.add(a)},onDidRemoveLastListener:()=>{this.c.delete(a),a.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return r.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,I.$7n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(g=>!/^--inspect(-brk)?=/.test(g)).filter(g=>!g.startsWith("--vscode-"))),(0,p.$rm)(i.env),this.d=(0,l.fork)(this.i,c,i);const n=new $.$he,r=$.Event.fromNodeEventEmitter(this.d,"message",g=>g)(g=>{if((0,R.$2q)(g)){(0,R.log)(g,`IPC Library: ${this.j.serverName}`);return}n.fire(M.$Je.wrap(Buffer.from(g,"base64")))}),t=this.j.useQueue?(0,P.$tm)(this.d):this.d,f=g=>this.d&&this.d.connected&&t.send(g.buffer.toString("base64")),o=n.event,s={send:f,onMessage:o};this.f=new E.$di(s);const u=()=>this.o();process.once("exit",u),this.d.on("error",g=>console.warn('IPC "'+this.j.serverName+'" errored with '+g)),this.d.on("exit",(g,b)=>{process.removeListener("exit",u),r.dispose(),this.c.forEach(S=>(0,k.$Pc)(S)),this.c.clear(),g!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+g+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:g,signal:b})})}return this.f}n(c){let i=this.g.get(c);return i||(i=this.m.getChannel(c),this.g.set(c,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$7q=d}),define(ke[200],De([1,0,7,4,3,53,18]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.StorageState=e.StorageHint=void 0,e.$2p=$;var w;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function $(p){const E=p;return E?.changed instanceof Map||E?.deleted instanceof Set}var k;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(k||(e.StorageState=k={}));class I extends M.$Uc{static{this.a=100}constructor(E,v=Object.create(null)){super(),this.r=E,this.s=v,this.b=this.B(new L.$ke),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new l.$yh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((v,d)=>this.w(d,v)),E.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(E,v){if(this.c===k.Closed)return;let d=!1;(0,R.$jg)(v)?d=this.f.delete(E):this.f.get(E)!==v&&(this.f.set(E,v),d=!0),d&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,v){const d=this.f.get(E);return(0,R.$jg)(d)?v:d}getBoolean(E,v){const d=this.get(E);return(0,R.$jg)(d)?v:d==="true"}getNumber(E,v){const d=this.get(E);return(0,R.$jg)(d)?v:parseInt(d,10)}getObject(E,v){const d=this.get(E);return(0,R.$jg)(d)?v:(0,A.$9h)(d)}async set(E,v,d=!1){if(this.c===k.Closed)return;if((0,R.$jg)(v))return this.delete(E,d);const h=(0,R.$cg)(v)||Array.isArray(v)?(0,A.$8h)(v):String(v);if(this.f.get(E)!==h)return this.f.set(E,h),this.j.set(E,h),this.h.delete(E),this.b.fire({key:E,external:d}),this.D()}async delete(E,v=!1){if(!(this.c===k.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:v}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===k.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$3p=I;class P{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((v,d)=>this.a.set(d,v)),E.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$4p=P}),define(ke[201],De([1,0,14,12,22]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2t=void 0,e.$Zt=I,e.$1t=P;let A;function R(){return A||(A=new TextDecoder("UTF-16LE")),A}let w;function $(){return w||(w=new TextDecoder("UTF-16BE")),w}let k;function I(){return k||(k=L.$D()?R():$()),k}function P(v,d,h){const c=new Uint16Array(v.buffer,d,h);return h>0&&(c[0]===65279||c[0]===65534)?p(v,d,h):R().decode(c)}function p(v,d,h){const c=[];let i=0;for(let n=0;n<h;n++){const a=M.$Le(v,d);d+=2,c[i++]=String.fromCharCode(a)}return c.join("")}class E{constructor(d){this.a=d|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const d=new Uint16Array(this.b.buffer,0,this.d);return I().decode(d)}f(){const d=this.e();this.d=0,this.c===null?this.c=[d]:this.c[this.c.length]=d}appendCharCode(d){const h=this.a-this.d;h<=1&&(h===0||l.$Ff(d))&&this.f(),this.b[this.d++]=d}appendASCIICharCode(d){this.d===this.a&&this.f(),this.b[this.d++]=d}appendString(d){const h=d.length;if(this.d+h>=this.a){this.f(),this.c[this.c.length]=d;return}for(let c=0;c<h;c++)this.b[this.d++]=d.charCodeAt(c)}}e.$2t=E}),define(ke[202],De([1,0,22,201]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3t=void 0,e.$4t=R;function M($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,I,P,p){this.oldPosition=k,this.oldText=I,this.newPosition=P,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,I,P){const p=I.length;l.$Oe(k,p,P),P+=4;for(let E=0;E<p;E++)l.$Me(k,I.charCodeAt(E),P),P+=2;return P}static d(k,I){const P=l.$Ne(k,I);return I+=4,(0,L.$1t)(k,I,P)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(k,I){return l.$Oe(k,this.oldPosition,I),I+=4,l.$Oe(k,this.newPosition,I),I+=4,I=A.c(k,this.oldText,I),I=A.c(k,this.newText,I),I}static read(k,I,P){const p=l.$Ne(k,I);I+=4;const E=l.$Ne(k,I);I+=4;const v=A.d(k,I);I+=A.a(v);const d=A.d(k,I);return I+=A.a(d),P.push(new A(p,v,E,d)),I}}e.$3t=A;function R($,k){return $===null||$.length===0?k:new w($,k).compress()}class w{constructor(k,I){this.a=k,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,I=0,P=this.n(k),p=this.l(I);for(;k<this.f||I<this.h;){if(P===null){this.k(p),p=this.l(++I);continue}if(p===null){this.m(P),P=this.n(++k);continue}if(p.oldEnd<=P.newPosition){this.k(p),p=this.l(++I);continue}if(P.newEnd<=p.oldPosition){this.m(P),P=this.n(++k);continue}if(p.oldPosition<P.newPosition){const[c,i]=w.r(p,P.newPosition-p.oldPosition);this.k(c),p=i;continue}if(P.newPosition<p.oldPosition){const[c,i]=w.q(P,p.oldPosition-P.newPosition);this.m(c),P=i;continue}let d,h;if(p.oldEnd===P.newEnd)d=P,h=p,P=this.n(++k),p=this.l(++I);else if(p.oldEnd<P.newEnd){const[c,i]=w.q(P,p.oldLength);d=c,h=p,P=i,p=this.l(++I)}else{const[c,i]=w.r(p,P.newLength);d=P,h=c,P=this.n(++k),p=i}this.d[this.e++]=new A(d.oldPosition,d.oldText,h.newPosition,h.newText),this.g+=d.newLength-d.oldLength,this.j+=h.newLength-h.oldLength}const E=w.s(this.d);return w.t(E)}k(k){this.d[this.e++]=w.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=w.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,I){return new A(I.oldPosition-k,I.oldText,I.newPosition,I.newText)}static p(k,I){return new A(I.oldPosition,I.oldText,I.newPosition+k,I.newText)}static q(k,I){const P=k.newText.substr(0,I),p=k.newText.substr(I);return[new A(k.oldPosition,k.oldText,k.newPosition,P),new A(k.oldEnd,"",k.newPosition+I,p)]}static r(k,I){const P=k.oldText.substr(0,I),p=k.oldText.substr(I);return[new A(k.oldPosition,P,k.newPosition,k.newText),new A(k.oldPosition+I,p,k.newEnd,"")]}static s(k){if(k.length===0)return k;const I=[];let P=0,p=k[0];for(let E=1;E<k.length;E++){const v=k[E];p.oldEnd===v.oldPosition?p=new A(p.oldPosition,p.oldText+v.oldText,p.newPosition,p.newText+v.newText):(I[P++]=p,p=v)}return I[P++]=p,I}static t(k){if(k.length===0)return k;const I=[];let P=0;for(let p=0;p<k.length;p++){const E=k[p];E.oldText!==E.newText&&(I[P++]=E)}return I}}}),define(ke[203],De([1,0,35,16]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hu=M,e.$iu=A;function M(R,w,$,k,I,P){if(Array.isArray(R)){let p=0;for(const E of R){const v=M(E,w,$,k,I,P);if(v===10)return v;v>p&&(p=v)}return p}else{if(typeof R=="string")return k?R==="*"?5:R===$?10:0:0;if(R){const{language:p,pattern:E,scheme:v,hasAccessToAllModels:d,notebookType:h}=R;if(!k&&!d)return 0;h&&I&&(w=I);let c=0;if(v)if(v===w.scheme)c=10;else if(v==="*")c=5;else return 0;if(p)if(p===$)c=10;else if(p==="*")c=Math.max(c,5);else return 0;if(h)if(h===P)c=10;else if(h==="*"&&P!==void 0)c=Math.max(c,5);else return 0;if(E){let i;if(typeof E=="string"?i=E:i={...E,base:(0,L.$hc)(E.base)},i===w.fsPath||(0,l.$tk)(i,w.fsPath))c=10;else return 0}return c}else return 0}}function A(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(A):!!R.notebookType}}),define(ke[204],De([1,0,4,14,29,80,131,179,202,3]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7C=void 0;class I extends k.$Uc{constructor(p,E,v,d,h,c,i){super(),this.m=this.B(new l.$he),this.onDidChangeContent=this.m.event,this.f=E,this.j=!c,this.g=d,this.h=h,this.c=new R.$6C(p,v,i)}equals(p){return!(p instanceof I)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,E){return this.c.getOffsetAt(p,E)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,E){const v=p+E,d=this.getPositionAt(p),h=this.getPositionAt(v);return new M.$At(d.lineNumber,d.column,h.lineNumber,h.column)}getValueInRange(p,E=0){if(p.isEmpty())return"";const v=this.n(E);return this.c.getValueInRange(p,v)}getValueLengthInRange(p,E=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const v=this.getOffsetAt(p.startLineNumber,p.startColumn),d=this.getOffsetAt(p.endLineNumber,p.endColumn);let h=0;const c=this.n(E),i=this.getEOL();if(c.length!==i.length){const n=c.length-i.length,a=p.endLineNumber-p.startLineNumber;h=n*a}return d-v+h}getCharacterCountInRange(p,E=0){if(this.j){let v=0;const d=p.startLineNumber,h=p.endLineNumber;for(let c=d;c<=h;c++){const i=this.getLineContent(c),n=c===d?p.startColumn-1:0,a=c===h?p.endColumn-1:i.length;for(let r=n;r<a;r++)L.$Ff(i.charCodeAt(r))?(v=v+1,r=r+1):v=v+1}return v+=this.n(E).length*(h-d),v}return this.getValueLengthInRange(p,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,E){return this.c.getLineCharCode(p,E)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const E=L.$qf(this.getLineContent(p));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(p){const E=L.$sf(this.getLineContent(p));return E===-1?0:E+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,E,v){let d=this.g,h=this.h,c=this.j,i=!0,n=[];for(let u=0;u<p.length;u++){const g=p[u];i&&g._isTracked&&(i=!1);const b=g.range;if(g.text){let C=!0;c||(C=!L.$Qf(g.text),c=C),!d&&C&&(d=L.$Pf(g.text)),!h&&C&&(h=L.$Sf(g.text))}let S="",m=0,y=0,D=0;if(g.text){let C;[m,y,D,C]=(0,w.$ku)(g.text);const O=this.getEOL();C===0||C===(O===`\r
`?2:1)?S=g.text:S=g.text.replace(/\r\n|\r|\n/g,O)}n[u]={sortIndex:u,identifier:g.identifier||null,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b),text:S,eolCount:m,firstLineLength:y,lastLineLength:D,forceMoveMarkers:!!g.forceMoveMarkers,isAutoWhitespaceEdit:g.isAutoWhitespaceEdit||!1}}n.sort(I.u);let a=!1;for(let u=0,g=n.length-1;u<g;u++){const b=n[u].range.getEndPosition(),S=n[u+1].range.getStartPosition();if(S.isBeforeOrEqual(b)){if(S.isBefore(b))throw new Error("Overlapping ranges are not allowed!");a=!0}}i&&(n=this.s(n));const r=v||E?I._getInverseEditRanges(n):[],t=[];if(E)for(let u=0;u<n.length;u++){const g=n[u],b=r[u];if(g.isAutoWhitespaceEdit&&g.range.isEmpty())for(let S=b.startLineNumber;S<=b.endLineNumber;S++){let m="";S===b.startLineNumber&&(m=this.getLineContent(g.range.startLineNumber),L.$qf(m)!==-1)||t.push({lineNumber:S,oldContent:m})}}let f=null;if(v){let u=0;f=[];for(let g=0;g<n.length;g++){const b=n[g],S=r[g],m=this.getValueInRange(b.range),y=b.rangeOffset+u;u+=b.text.length-m.length,f[g]={sortIndex:b.sortIndex,identifier:b.identifier,range:S,text:m,textChange:new $.$3t(b.rangeOffset,m,y,b.text)}}a||f.sort((g,b)=>g.sortIndex-b.sortIndex)}this.g=d,this.h=h,this.j=c;const o=this.t(n);let s=null;if(E&&t.length>0){t.sort((u,g)=>g.lineNumber-u.lineNumber),s=[];for(let u=0,g=t.length;u<g;u++){const b=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===b)continue;const S=t[u].oldContent,m=this.getLineContent(b);m.length===0||m===S||L.$qf(m)!==-1||s.push(b)}}return this.m.fire(),new A.$5v(f,o,s)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let E=!1;const v=p[0].range,d=p[p.length-1].range,h=new M.$At(v.startLineNumber,v.startColumn,d.endLineNumber,d.endColumn);let c=v.startLineNumber,i=v.startColumn;const n=[];for(let o=0,s=p.length;o<s;o++){const u=p[o],g=u.range;E=E||u.forceMoveMarkers,n.push(this.getValueInRange(new M.$At(c,i,g.startLineNumber,g.startColumn))),u.text.length>0&&n.push(u.text),c=g.endLineNumber,i=g.endColumn}const a=n.join(""),[r,t,f]=(0,w.$ku)(a);return{sortIndex:0,identifier:p[0].identifier,range:h,rangeOffset:this.getOffsetAt(h.startLineNumber,h.startColumn),rangeLength:this.getValueLengthInRange(h,0),text:a,eolCount:r,firstLineLength:t,lastLineLength:f,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(p){p.sort(I.w);const E=[];for(let v=0;v<p.length;v++){const d=p[v],h=d.range.startLineNumber,c=d.range.startColumn,i=d.range.endLineNumber,n=d.range.endColumn;if(h===i&&c===n&&d.text.length===0)continue;d.text?(this.c.delete(d.rangeOffset,d.rangeLength),this.c.insert(d.rangeOffset,d.text,!0)):this.c.delete(d.rangeOffset,d.rangeLength);const a=new M.$At(h,c,i,n);E.push({range:a,rangeLength:d.rangeLength,text:d.text,rangeOffset:d.rangeOffset,forceMoveMarkers:d.forceMoveMarkers})}return E}findMatchesLineByLine(p,E,v,d){return this.c.findMatchesLineByLine(p,E,v,d)}getPieceTree(){return this.c}static _getInverseEditRange(p,E){const v=p.startLineNumber,d=p.startColumn,[h,c,i]=(0,w.$ku)(E);let n;if(E.length>0){const a=h+1;a===1?n=new M.$At(v,d,v,d+c):n=new M.$At(v,d,v+a-1,i+1)}else n=new M.$At(v,d,v,d);return n}static _getInverseEditRanges(p){const E=[];let v=0,d=0,h=null;for(let c=0,i=p.length;c<i;c++){const n=p[c];let a,r;h?h.range.endLineNumber===n.range.startLineNumber?(a=v,r=d+(n.range.startColumn-h.range.endColumn)):(a=v+(n.range.startLineNumber-h.range.endLineNumber),r=n.range.startColumn):(a=n.range.startLineNumber,r=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new M.$At(a,r,a,r+n.firstLineLength):t=new M.$At(a,r,a+f-1,n.lastLineLength+1)}else t=new M.$At(a,r,a,r);v=t.endLineNumber,d=t.endColumn,E.push(t),h=n}return E}static u(p,E){const v=M.$At.compareRangesUsingEnds(p.range,E.range);return v===0?p.sortIndex-E.sortIndex:v}static w(p,E){const v=M.$At.compareRangesUsingEnds(p.range,E.range);return v===0?E.sortIndex-p.sortIndex:-v}}e.$7C=I}),define(ke[205],De([1,0,14,131,204]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=void 0;class A{constructor($,k,I,P,p,E,v,d,h){this.a=$,this.b=k,this.c=I,this.d=P,this.e=p,this.f=E,this.g=v,this.h=d,this.j=h}k($){const k=this.c+this.d+this.e,I=this.c+this.e;return k===0?$===1?`
`:`\r
`:I>k/2?`\r
`:`
`}create($){const k=this.k($),I=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let p=0,E=I.length;p<E;p++){const v=I[p].buffer.replace(/\r\n|\r|\n/g,k),d=(0,L.$2C)(v);I[p]=new L.$5C(v,d)}const P=new M.$7C(I,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&l.$1f($)&&(this.b=l.$Zf,$=$.substr(1));const k=$.charCodeAt($.length-1);k===13||k>=55296&&k<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=k):(this.m($,!1),this.c=!1,this.d=k)}m($,k){!k&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const k=(0,L.$3C)(this.e,$);this.a.push(new L.$5C($,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=l.$Pf($)),this.k||(this.k=l.$Sf($)))}finish($=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const k=(0,L.$2C)($.buffer);$.lineStarts=k,this.d===13&&this.f++}}}e.$8C=R}),define(ke[135],De([1,0,22,12]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbb=$,e.$Obb=I;var M;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(M||(M={}));function A(P){for(let p=0,E=P.length;p<E;p+=4){const v=P[p+0],d=P[p+1],h=P[p+2],c=P[p+3];P[p+0]=c,P[p+1]=h,P[p+2]=d,P[p+3]=v}}function R(P){const p=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.$D()||A(p),l.$Je.wrap(p)}function w(P){const p=P.buffer;if(L.$D()||A(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const E=new Uint8Array(p.byteLength);return E.set(p),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function $(P){const p=new Uint32Array(k(P));let E=0;if(p[E++]=P.id,P.type==="full")p[E++]=1,p[E++]=P.data.length,p.set(P.data,E),E+=P.data.length;else{p[E++]=2,p[E++]=P.deltas.length;for(const v of P.deltas)p[E++]=v.start,p[E++]=v.deleteCount,v.data?(p[E++]=v.data.length,p.set(v.data,E),E+=v.data.length):p[E++]=0}return R(p)}function k(P){let p=0;if(p+=2,P.type==="full")p+=1+P.data.length;else{p+=1,p+=3*P.deltas.length;for(const E of P.deltas)E.data&&(p+=E.data.length)}return p}function I(P){const p=w(P);let E=0;const v=p[E++];if(p[E++]===1){const i=p[E++],n=p.subarray(E,E+i);return E+=i,{id:v,type:"full",data:n}}const h=p[E++],c=[];for(let i=0;i<h;i++){const n=p[E++],a=p[E++],r=p[E++];let t;r>0&&(t=p.subarray(E,E+r),E+=r),c[i]={start:n,deleteCount:a,data:t}}return{id:v,type:"delta",deltas:c}}}),define(ke[206],De([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(ke[136],De([1,0,19,24,12,182,130,206]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=h,e.clampedInt=i,e.clampedFloat=a,e.stringSet=f,e.cursorStyleToString=D,e.filterValidationDecorations=we;var $;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(ne){this.c=ne}hasChanged(ne){return this.c[ne]}}e.ConfigurationChangedEvent=k;class I{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=I;class P{constructor(ne,Ce,Ge,Me){this.id=ne,this.name=Ce,this.defaultValue=Ge,this.schema=Me}applyUpdate(ne,Ce){return E(ne,Ce)}compute(ne,Ce,Ge){return Ge}}class p{constructor(ne,Ce){this.newValue=ne,this.didChange=Ce}}e.ApplyUpdateResult=p;function E(te,ne){if(typeof te!="object"||typeof ne!="object"||!te||!ne)return new p(ne,te!==ne);if(Array.isArray(te)||Array.isArray(ne)){const Ge=Array.isArray(te)&&Array.isArray(ne)&&l.$ub(te,ne);return new p(ne,!Ge)}let Ce=!1;for(const Ge in ne)if(ne.hasOwnProperty(Ge)){const Me=E(te[Ge],ne[Ge]);Me.didChange&&(te[Ge]=Me.newValue,Ce=!0)}return new p(te,Ce)}class v{constructor(ne){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0}applyUpdate(ne,Ce){return E(ne,Ce)}validate(ne){return this.defaultValue}}class d{constructor(ne,Ce,Ge,Me){this.id=ne,this.name=Ce,this.defaultValue=Ge,this.schema=Me}applyUpdate(ne,Ce){return E(ne,Ce)}validate(ne){return typeof ne>"u"?this.defaultValue:ne}compute(ne,Ce,Ge){return Ge}}function h(te,ne){return typeof te>"u"?ne:te==="false"?!1:!!te}class c extends d{constructor(ne,Ce,Ge,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Ge),super(ne,Ce,Ge,Me)}validate(ne){return h(ne,this.defaultValue)}}function i(te,ne,Ce,Ge){if(typeof te>"u")return ne;let Me=parseInt(te,10);return isNaN(Me)?ne:(Me=Math.max(Ce,Me),Me=Math.min(Ge,Me),Me|0)}class n extends d{static clampedInt(ne,Ce,Ge,Me){return i(ne,Ce,Ge,Me)}constructor(ne,Ce,Ge,Me,st,ut=void 0){typeof ut<"u"&&(ut.type="integer",ut.default=Ge,ut.minimum=Me,ut.maximum=st),super(ne,Ce,Ge,ut),this.minimum=Me,this.maximum=st}validate(ne){return n.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}function a(te,ne,Ce,Ge){if(typeof te>"u")return ne;const Me=r.float(te,ne);return r.clamp(Me,Ce,Ge)}class r extends d{static clamp(ne,Ce,Ge){return ne<Ce?Ce:ne>Ge?Ge:ne}static float(ne,Ce){if(typeof ne=="number")return ne;if(typeof ne>"u")return Ce;const Ge=parseFloat(ne);return isNaN(Ge)?Ce:Ge}constructor(ne,Ce,Ge,Me,st){typeof st<"u"&&(st.type="number",st.default=Ge),super(ne,Ce,Ge,st),this.validationFn=Me}validate(ne){return this.validationFn(r.float(ne,this.defaultValue))}}class t extends d{static string(ne,Ce){return typeof ne!="string"?Ce:ne}constructor(ne,Ce,Ge,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Ge),super(ne,Ce,Ge,Me)}validate(ne){return t.string(ne,this.defaultValue)}}function f(te,ne,Ce,Ge){return typeof te!="string"?ne:Ge&&te in Ge?Ge[te]:Ce.indexOf(te)===-1?ne:te}class o extends d{constructor(ne,Ce,Ge,Me,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Me,st.default=Ge),super(ne,Ce,Ge,st),this.c=Me}validate(ne){return f(ne,this.defaultValue,this.c)}}class s extends P{constructor(ne,Ce,Ge,Me,st,ut,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=st,$t.default=Me),super(ne,Ce,Ge,$t),this.c=st,this.d=ut}validate(ne){return typeof ne!="string"?this.defaultValue:this.c.indexOf(ne)===-1?this.defaultValue:this.d(ne)}}function u(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,Ce,Ge){return Ge===0?ne.accessibilitySupport:Ge}}class b extends P{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:w.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{insertSpace:h(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function m(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function D(te){switch(te){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}function C(te){switch(te){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class O extends v{constructor(){super(142)}compute(ne,Ce,Ge){const Me=["monaco-editor"];return Ce.get(39)&&Me.push(Ce.get(39)),ne.extraEditorClassName&&Me.push(ne.extraEditorClassName),Ce.get(74)==="default"?Me.push("mouse-default"):Ce.get(74)==="copy"&&Me.push("mouse-copy"),Ce.get(111)&&Me.push("showUnused"),Ce.get(140)&&Me.push("showDeprecated"),Me.join(" ")}}class z extends c{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(ne,Ce,Ge){return Ge&&ne.emptySelectionClipboard}}class T extends P{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:w.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:w.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{cursorMoveOnType:h(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":f(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":f(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(Ce.loop,this.defaultValue.loop)}}}class F extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(ne){return typeof ne>"u"?this.defaultValue:typeof ne=="string"?ne==="false"||ne.length===0?F.OFF:ne==="true"?F.ON:ne:ne?F.ON:F.OFF}}e.EditorFontLigatures=F;class N extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(ne){return typeof ne>"u"?this.defaultValue:typeof ne=="string"?ne==="false"?N.OFF:ne==="true"?N.TRANSLATE:ne:ne?N.TRANSLATE:N.OFF}compute(ne,Ce,Ge){return ne.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class j extends v{constructor(){super(50)}compute(ne,Ce,Ge){return ne.fontInfo}}class B extends d{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(ne){const Ce=r.float(ne,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:r.clamp(Ce,6,100)}compute(ne,Ce,Ge){return ne.fontInfo.fontSize}}class X extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(n.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class ie extends P{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:Ge,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:Ge,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:Ge,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:Ge,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:Ge,description:w.localize(41,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{multiple:f(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??f(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??f(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??f(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??f(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??f(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends P{constructor(){const ne={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:ne.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ne.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:w.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{enabled:h(Ce.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:h(Ce.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:h(Ce.above,this.defaultValue.above)}}}var K;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(K||(e.RenderMinimap=K={}));class x extends v{constructor(){super(145)}compute(ne,Ce,Ge){return x.computeLayout(Ce,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio,glyphMarginDecorationLaneCount:ne.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ne){const Ce=ne.height/ne.lineHeight,Ge=Math.floor(ne.paddingTop/ne.lineHeight);let Me=Math.floor(ne.paddingBottom/ne.lineHeight);ne.scrollBeyondLastLine&&(Me=Math.max(Me,Ce-1));const st=(Ge+ne.viewLineCount+Me)/(ne.pixelRatio*ne.height),ut=Math.floor(ne.viewLineCount/st);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:Me,desiredRatio:st,minimapLineCount:ut}}static c(ne,Ce){const Ge=ne.outerWidth,Me=ne.outerHeight,st=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const ut=Ce.stableMinimapLayoutInput,$t=ut&&ne.outerHeight===ut.outerHeight&&ne.lineHeight===ut.lineHeight&&ne.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&ne.pixelRatio===ut.pixelRatio&&ne.scrollBeyondLastLine===ut.scrollBeyondLastLine&&ne.paddingTop===ut.paddingTop&&ne.paddingBottom===ut.paddingBottom&&ne.minimap.enabled===ut.minimap.enabled&&ne.minimap.side===ut.minimap.side&&ne.minimap.size===ut.minimap.size&&ne.minimap.showSlider===ut.minimap.showSlider&&ne.minimap.renderCharacters===ut.minimap.renderCharacters&&ne.minimap.maxColumn===ut.minimap.maxColumn&&ne.minimap.scale===ut.minimap.scale&&ne.verticalScrollbarWidth===ut.verticalScrollbarWidth&&ne.isViewportWrapping===ut.isViewportWrapping,Ct=ne.lineHeight,Pt=ne.typicalHalfwidthCharacterWidth,Ut=ne.scrollBeyondLastLine,Bt=ne.minimap.renderCharacters;let kt=st>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const Yt=ne.minimap.maxColumn,xt=ne.minimap.size,xe=ne.minimap.side,on=ne.verticalScrollbarWidth,Qt=ne.viewLineCount,ft=ne.remainingWidth,gt=ne.isViewportWrapping,_t=Bt?2:3;let Zt=Math.floor(st*Me);const Ft=Zt/st;let mt=!1,Ht=!1,en=_t*kt,Wt=kt/st,Xe=1;if(xt==="fill"||xt==="fit"){const{typicalViewportLineCount:Lt,extraLinesBeforeFirstLine:tn,extraLinesBeyondLastLine:Gt,desiredRatio:an,minimapLineCount:Nt}=x.computeContainedMinimapLineCount({viewLineCount:Qt,scrollBeyondLastLine:Ut,paddingTop:ne.paddingTop,paddingBottom:ne.paddingBottom,height:Me,lineHeight:Ct,pixelRatio:st});if(Qt/Nt>1)mt=!0,Ht=!0,kt=1,en=1,Wt=kt/st;else{let Ot=!1,It=kt+1;if(xt==="fit"){const pt=Math.ceil((tn+Qt+Gt)*en);gt&&$t&&ft<=Ce.stableFitRemainingWidth?(Ot=!0,It=Ce.stableFitMaxMinimapScale):Ot=pt>Zt}if(xt==="fill"||Ot){mt=!0;const pt=kt;en=Math.min(Ct*st,Math.max(1,Math.floor(1/an))),gt&&$t&&ft<=Ce.stableFitRemainingWidth&&(It=Ce.stableFitMaxMinimapScale),kt=Math.min(It,Math.max(1,Math.floor(en/_t))),kt>pt&&(Xe=Math.min(2,kt/pt)),Wt=kt/st/Xe,Zt=Math.ceil(Math.max(Lt,tn+Qt+Gt)*en),gt?(Ce.stableMinimapLayoutInput=ne,Ce.stableFitRemainingWidth=ft,Ce.stableFitMaxMinimapScale=kt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const ln=Math.floor(Yt*Wt),Xt=Math.min(ln,Math.max(0,Math.floor((ft-on-2)*Wt/(Pt+Wt)))+e.MINIMAP_GUTTER_WIDTH);let Vt=Math.floor(st*Xt);const wt=Vt/st;Vt=Math.floor(Vt*Xe);const qt=Bt?1:2,Mt=xe==="left"?0:Ge-Xt-on;return{renderMinimap:qt,minimapLeft:Mt,minimapWidth:Xt,minimapHeightIsEditorHeight:mt,minimapIsSampling:Ht,minimapScale:kt,minimapLineHeight:en,minimapCanvasInnerWidth:Vt,minimapCanvasInnerHeight:Zt,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:Ft}}static computeLayout(ne,Ce){const Ge=Ce.outerWidth|0,Me=Ce.outerHeight|0,st=Ce.lineHeight|0,ut=Ce.lineNumbersDigitCount|0,$t=Ce.typicalHalfwidthCharacterWidth,Ct=Ce.maxDigitWidth,Pt=Ce.pixelRatio,Ut=Ce.viewLineCount,Bt=ne.get(137),kt=Bt==="inherit"?ne.get(136):Bt,Yt=kt==="inherit"?ne.get(132):kt,xt=ne.get(135),xe=Ce.isDominatedByLongLines,on=ne.get(57),Qt=ne.get(68).renderType!==0,ft=ne.get(69),gt=ne.get(105),_t=ne.get(84),Zt=ne.get(73),Ft=ne.get(103),mt=Ft.verticalScrollbarSize,Ht=Ft.verticalHasArrows,en=Ft.arrowSize,Wt=Ft.horizontalScrollbarSize,Xe=ne.get(43),ln=ne.get(110)!=="never";let Xt=ne.get(66);Xe&&ln&&(Xt+=16);let Vt=0;if(Qt){const cn=Math.max(ut,ft);Vt=Math.round(cn*Ct)}let wt=0;on&&(wt=st*Ce.glyphMarginDecorationLaneCount);let qt=0,Mt=qt+wt,Lt=Mt+Vt,tn=Lt+Xt;const Gt=Ge-wt-Vt-Xt;let an=!1,Nt=!1,Kt=-1;kt==="inherit"&&xe?(an=!0,Nt=!0):Yt==="on"||Yt==="bounded"?Nt=!0:Yt==="wordWrapColumn"&&(Kt=xt);const Ot=x.c({outerWidth:Ge,outerHeight:Me,lineHeight:st,typicalHalfwidthCharacterWidth:$t,pixelRatio:Pt,scrollBeyondLastLine:gt,paddingTop:_t.top,paddingBottom:_t.bottom,minimap:Zt,verticalScrollbarWidth:mt,viewLineCount:Ut,remainingWidth:Gt,isViewportWrapping:Nt},Ce.memory||new I);Ot.renderMinimap!==0&&Ot.minimapLeft===0&&(qt+=Ot.minimapWidth,Mt+=Ot.minimapWidth,Lt+=Ot.minimapWidth,tn+=Ot.minimapWidth);const It=Gt-Ot.minimapWidth,pt=Math.max(1,Math.floor((It-mt-2)/$t)),St=Ht?en:0;return Nt&&(Kt=Math.max(1,pt),Yt==="bounded"&&(Kt=Math.min(Kt,xt))),{width:Ge,height:Me,glyphMarginLeft:qt,glyphMarginWidth:wt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Mt,lineNumbersWidth:Vt,decorationsLeft:Lt,decorationsWidth:Xt,contentLeft:tn,contentWidth:It,minimap:Ot,viewportColumn:pt,isWordWrapMinified:an,isViewportWrapping:Nt,wrappingColumn:Kt,verticalScrollbarWidth:mt,horizontalScrollbarHeight:Wt,overviewRuler:{top:St,width:mt,height:Me-2*St,right:0}}}}e.EditorLayoutInfoComputer=x;class _ extends P{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(ne){return f(ne,"simple",["simple","advanced"])}compute(ne,Ce,Ge){return Ce.get(2)===2?"advanced":Ge}}var ge;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(ge||(e.ShowLightbulbIconMode=ge={}));class oe extends P{constructor(){const ne={enabled:ge.On};super(65,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ge.Off,ge.OnCode,ge.On],default:ne.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:f(ne.enabled,this.defaultValue.enabled,[ge.Off,ge.OnCode,ge.On])}}}class Pe extends P{constructor(){const ne={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ne,{"editor.stickyScroll.enabled":{type:"boolean",default:ne.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ne.maxLineCount,minimum:1,maximum:20,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ne.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ne.scrollWithEditor,description:w.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{enabled:h(Ce.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:h(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class me extends P{constructor(){const ne={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"string",default:ne.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ne.padding,description:w.localize(65,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:f(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:h(Ce.padding,this.defaultValue.padding)}}}class U extends P{constructor(){super(66,"lineDecorationsWidth",10)}validate(ne){return typeof ne=="string"&&/^\d+(\.\d+)?ch$/.test(ne)?-parseFloat(ne.substring(0,ne.length-2)):n.clampedInt(ne,this.defaultValue,0,1e3)}compute(ne,Ce,Ge){return Ge<0?n.clampedInt(-Ge*ne.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class Y extends r{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>r.clamp(ne,0,150),{markdownDescription:w.localize(66,null)})}compute(ne,Ce,Ge){return ne.fontInfo.lineHeight}}class pe extends P{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ne.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:ne.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:w.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ne.showRegionSectionHeaders,description:w.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ne.showMarkSectionHeaders,description:w.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ne.sectionHeaderFontSize,description:w.localize(80,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{enabled:h(Ce.enabled,this.defaultValue.enabled),autohide:h(Ce.autohide,this.defaultValue.autohide),size:f(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Ce.side,this.defaultValue.side,["right","left"]),showSlider:f(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ce.scale,1,1,3),maxColumn:n.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:h(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:h(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:r.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function ce(te){return te==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class ae extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(82,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{top:n.clampedInt(Ce.top,0,0,1e3),bottom:n.clampedInt(Ce.bottom,0,0,1e3)}}}class se extends P{constructor(){const ne={enabled:!0,cycle:!0};super(86,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:w.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:w.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{enabled:h(Ce.enabled,this.defaultValue.enabled),cycle:h(Ce.cycle,this.defaultValue.cycle)}}}class ue extends v{constructor(){super(143)}compute(ne,Ce,Ge){return ne.pixelRatio}}class Q extends P{constructor(){const ne={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(85,null),w.localize(86,null),w.localize(87,null)]}];super(89,"quickSuggestions",ne,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:ne.strings,description:w.localize(88,null)},comments:{anyOf:Ce,default:ne.comments,description:w.localize(89,null)},other:{anyOf:Ce,default:ne.other,description:w.localize(90,null)}},default:ne,markdownDescription:w.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ne}validate(ne){if(typeof ne=="boolean"){const Pt=ne?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!ne||typeof ne!="object")return this.defaultValue;const{other:Ce,comments:Ge,strings:Me}=ne,st=["on","inline","off"];let ut,$t,Ct;return typeof Ce=="boolean"?ut=Ce?"on":"off":ut=f(Ce,this.defaultValue.other,st),typeof Ge=="boolean"?$t=Ge?"on":"off":$t=f(Ge,this.defaultValue.comments,st),typeof Me=="boolean"?Ct=Me?"on":"off":Ct=f(Me,this.defaultValue.strings,st),{other:ut,comments:$t,strings:Ct}}}var re;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class $e extends P{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(92,null),w.localize(93,null),w.localize(94,null),w.localize(95,null)],default:"on",description:w.localize(96,null)})}validate(ne){let Ce=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof ne<"u"&&(typeof ne=="function"?(Ce=4,Ge=ne):ne==="interval"?Ce=3:ne==="relative"?Ce=2:ne==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ge}}}function we(te){const ne=te.get(98);return ne==="editable"?te.get(91):ne!=="on"}class Ne extends P{constructor(){const ne=[],Ce={type:"number",description:w.localize(97,null)};super(102,"rulers",ne,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:w.localize(98,null),format:"color-hex"}}}]},default:ne,description:w.localize(99,null)})}validate(ne){if(Array.isArray(ne)){const Ce=[];for(const Ge of ne)if(typeof Ge=="number")Ce.push({column:n.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const Me=Ge;Ce.push({column:n.clampedInt(Me.column,0,0,1e4),color:Me.color})}return Ce.sort((Ge,Me)=>Ge.column-Me.column),Ce}return this.defaultValue}}class Se extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:ne}}function Ie(te,ne){if(typeof te!="string")return ne;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends P{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(100,null),w.localize(101,null),w.localize(102,null)],default:"auto",description:w.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(104,null),w.localize(105,null),w.localize(106,null)],default:"auto",description:w.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:w.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:w.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:w.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ne.ignoreHorizontalScrollbarInContentHeight,description:w.localize(111,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne,Ge=n.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=n.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:h(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:n.clampedInt(Ce.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:n.clampedInt(Ce.verticalSliderSize,Me,0,1e3),scrollByPage:h(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:h(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends P{constructor(){const ne={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ne,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.nonBasicASCII,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ne.invisibleCharacters,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ne.ambiguousCharacters,description:w.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeComments,description:w.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeStrings,description:w.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ne.allowedCharacters,description:w.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ne.allowedLocales,description:w.localize(118,null)}})}applyUpdate(ne,Ce){let Ge=!1;Ce.allowedCharacters&&ne&&(L.$$n(ne.allowedCharacters,Ce.allowedCharacters)||(ne={...ne,allowedCharacters:Ce.allowedCharacters},Ge=!0)),Ce.allowedLocales&&ne&&(L.$$n(ne.allowedLocales,Ce.allowedLocales)||(ne={...ne,allowedLocales:Ce.allowedLocales},Ge=!0));const Me=super.applyUpdate(ne,Ce);return Ge?new p(Me.newValue,!0):Me}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{nonBasicASCII:he(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ne.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ne.allowedLocales,this.defaultValue.allowedLocales)}}c(ne,Ce){if(typeof ne!="object"||!ne)return Ce;const Ge={};for(const[Me,st]of Object.entries(ne))st===!0&&(Ge[Me]=!0);return Ge}}class V extends P{constructor(){const ne={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:w.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ne.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(120,null),w.localize(121,null),w.localize(122,null)],description:w.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ne.suppressSuggestions,description:w.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ne.fontFamily,description:w.localize(125,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{enabled:h(Ce.enabled,this.defaultValue.enabled),mode:f(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:h(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:h(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class W extends P{constructor(){const ne={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ne,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ne.enabled,description:w.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ne.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(127,null),w.localize(128,null),w.localize(129,null)],description:w.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ne.fontFamily,description:w.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ne.backgroundColoring,description:w.localize(132,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{enabled:h(Ce.enabled,this.defaultValue.enabled),showToolbar:f(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:h(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:h(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class J extends P{constructor(){const ne={enabled:A.$0s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$0s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,markdownDescription:w.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ne.independentColorPoolPerBracketType,description:w.localize(134,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{enabled:h(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends P{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(135,null),w.localize(136,null),w.localize(137,null)],default:ne.bracketPairs,description:w.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(139,null),w.localize(140,null),w.localize(141,null)],default:ne.bracketPairsHorizontal,description:w.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:w.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:w.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(145,null),w.localize(146,null),w.localize(147,null)],default:ne.highlightActiveIndentation,description:w.localize(148,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{bracketPairs:he(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(te,ne,Ce){const Ge=Ce.indexOf(te);return Ge===-1?ne:Ce[Ge]}class be extends P{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(149,null),w.localize(150,null)],default:ne.insertMode,description:w.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:w.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:w.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:w.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(155,null),w.localize(156,null),w.localize(157,null),w.localize(158,null)],default:ne.selectionMode,markdownDescription:w.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:w.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:w.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:w.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:w.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:w.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(196,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{insertMode:f(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:h(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:h(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:h(Ce.preview,this.defaultValue.preview),previewMode:f(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(Ce.showMethods,this.defaultValue.showMethods),showFunctions:h(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:h(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(Ce.showFields,this.defaultValue.showFields),showVariables:h(Ce.showVariables,this.defaultValue.showVariables),showClasses:h(Ce.showClasses,this.defaultValue.showClasses),showStructs:h(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:h(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:h(Ce.showModules,this.defaultValue.showModules),showProperties:h(Ce.showProperties,this.defaultValue.showProperties),showEvents:h(Ce.showEvents,this.defaultValue.showEvents),showOperators:h(Ce.showOperators,this.defaultValue.showOperators),showUnits:h(Ce.showUnits,this.defaultValue.showUnits),showValues:h(Ce.showValues,this.defaultValue.showValues),showConstants:h(Ce.showConstants,this.defaultValue.showConstants),showEnums:h(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:h(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(Ce.showKeywords,this.defaultValue.showKeywords),showWords:h(Ce.showWords,this.defaultValue.showWords),showColors:h(Ce.showColors,this.defaultValue.showColors),showFiles:h(Ce.showFiles,this.defaultValue.showFiles),showReferences:h(Ce.showReferences,this.defaultValue.showReferences),showFolders:h(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:h(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:h(Ce.showUsers,this.defaultValue.showUsers),showIssues:h(Ce.showIssues,this.defaultValue.showIssues)}}}class Fe extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(198,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:h(ne.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends P{constructor(){const ne=[];super(130,"wordSegmenterLocales",ne,{anyOf:[{description:w.localize(199,null),type:"string"},{description:w.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ne){if(typeof ne=="string"&&(ne=[ne]),Array.isArray(ne)){const Ce=[];for(const Ge of ne)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&Ce.push(Ge)}catch{}return Ce}return this.defaultValue}}var Qe;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class tt extends P{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(201,null),w.localize(202,null),w.localize(203,null),w.localize(204,null)],description:w.localize(205,null),default:"same"}})}validate(ne){switch(ne){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ne,Ce,Ge){return Ce.get(2)===2?0:Ge}}class _e extends v{constructor(){super(146)}compute(ne,Ce,Ge){const Me=Ce.get(145);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class nt extends P{constructor(){const ne={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ne,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ne.enabled,markdownDescription:w.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(208,null),w.localize(209,null)],default:"afterDrop"}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{enabled:h(Ce.enabled,this.defaultValue.enabled),showDropSelector:f(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends P{constructor(){const ne={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ne,{"editor.pasteAs.enabled":{type:"boolean",default:ne.enabled,markdownDescription:w.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(212,null),w.localize(213,null)],default:"afterPaste"}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ce=ne;return{enabled:h(Ce.enabled,this.defaultValue.enabled),showPasteSelector:f(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",Re="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?at:M.$k?Re:rt,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ve(te){return e.editorOptionsRegistry[te.id]=te,te}var qe;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",te[te.quickSuggestions=89]="quickSuggestions",te[te.quickSuggestionsDelay=90]="quickSuggestionsDelay",te[te.readOnly=91]="readOnly",te[te.readOnlyMessage=92]="readOnlyMessage",te[te.renameOnType=93]="renameOnType",te[te.renderControlCharacters=94]="renderControlCharacters",te[te.renderFinalNewline=95]="renderFinalNewline",te[te.renderLineHighlight=96]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=98]="renderValidationDecorations",te[te.renderWhitespace=99]="renderWhitespace",te[te.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",te[te.roundedSelection=101]="roundedSelection",te[te.rulers=102]="rulers",te[te.scrollbar=103]="scrollbar",te[te.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=105]="scrollBeyondLastLine",te[te.scrollPredominantAxis=106]="scrollPredominantAxis",te[te.selectionClipboard=107]="selectionClipboard",te[te.selectionHighlight=108]="selectionHighlight",te[te.selectOnLineNumbers=109]="selectOnLineNumbers",te[te.showFoldingControls=110]="showFoldingControls",te[te.showUnused=111]="showUnused",te[te.snippetSuggestions=112]="snippetSuggestions",te[te.smartSelect=113]="smartSelect",te[te.smoothScrolling=114]="smoothScrolling",te[te.stickyScroll=115]="stickyScroll",te[te.stickyTabStops=116]="stickyTabStops",te[te.stopRenderingLineAfter=117]="stopRenderingLineAfter",te[te.suggest=118]="suggest",te[te.suggestFontSize=119]="suggestFontSize",te[te.suggestLineHeight=120]="suggestLineHeight",te[te.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",te[te.suggestSelection=122]="suggestSelection",te[te.tabCompletion=123]="tabCompletion",te[te.tabIndex=124]="tabIndex",te[te.unicodeHighlighting=125]="unicodeHighlighting",te[te.unusualLineTerminators=126]="unusualLineTerminators",te[te.useShadowDOM=127]="useShadowDOM",te[te.useTabStops=128]="useTabStops",te[te.wordBreak=129]="wordBreak",te[te.wordSegmenterLocales=130]="wordSegmenterLocales",te[te.wordSeparators=131]="wordSeparators",te[te.wordWrap=132]="wordWrap",te[te.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=135]="wordWrapColumn",te[te.wordWrapOverride1=136]="wordWrapOverride1",te[te.wordWrapOverride2=137]="wordWrapOverride2",te[te.wrappingIndent=138]="wrappingIndent",te[te.wrappingStrategy=139]="wrappingStrategy",te[te.showDeprecated=140]="showDeprecated",te[te.inlayHints=141]="inlayHints",te[te.editorClassName=142]="editorClassName",te[te.pixelRatio=143]="pixelRatio",te[te.tabFocusMode=144]="tabFocusMode",te[te.layoutInfo=145]="layoutInfo",te[te.wrappingInfo=146]="wrappingInfo",te[te.defaultColorDecorators=147]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(qe||(e.EditorOption=qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new c(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(214,null)})),acceptSuggestionOnEnter:ve(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(215,null),""],markdownDescription:w.localize(216,null)})),accessibilitySupport:ve(new g),accessibilityPageSize:ve(new n(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(217,null),tags:["accessibility"]})),ariaLabel:ve(new t(4,"ariaLabel",w.localize(218,null))),ariaRequired:ve(new c(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ve(new c(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:ve(new o(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(220,null),w.localize(221,null),""],description:w.localize(222,null)})),autoClosingComments:ve(new o(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(223,null),w.localize(224,null),""],description:w.localize(225,null)})),autoClosingDelete:ve(new o(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(226,null),""],description:w.localize(227,null)})),autoClosingOvertype:ve(new o(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(228,null),""],description:w.localize(229,null)})),autoClosingQuotes:ve(new o(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(230,null),w.localize(231,null),""],description:w.localize(232,null)})),autoIndent:ve(new s(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[w.localize(233,null),w.localize(234,null),w.localize(235,null),w.localize(236,null),w.localize(237,null)],description:w.localize(238,null)})),automaticLayout:ve(new c(13,"automaticLayout",!1)),autoSurround:ve(new o(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(239,null),w.localize(240,null),w.localize(241,null),""],description:w.localize(242,null)})),bracketPairColorization:ve(new J),bracketPairGuides:ve(new Z),stickyTabStops:ve(new c(116,"stickyTabStops",!1,{description:w.localize(243,null)})),codeLens:ve(new c(17,"codeLens",!0,{description:w.localize(244,null)})),codeLensFontFamily:ve(new t(18,"codeLensFontFamily","",{description:w.localize(245,null)})),codeLensFontSize:ve(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(246,null)})),colorDecorators:ve(new c(20,"colorDecorators",!0,{description:w.localize(247,null)})),colorDecoratorActivatedOn:ve(new o(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(248,null),w.localize(249,null),w.localize(250,null)],description:w.localize(251,null)})),colorDecoratorsLimit:ve(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(252,null)})),columnSelection:ve(new c(22,"columnSelection",!1,{description:w.localize(253,null)})),comments:ve(new b),contextmenu:ve(new c(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new c(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(254,null)})),cursorBlinking:ve(new s(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:w.localize(255,null)})),cursorSmoothCaretAnimation:ve(new o(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(256,null),w.localize(257,null),w.localize(258,null)],description:w.localize(259,null)})),cursorStyle:ve(new s(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:w.localize(260,null)})),cursorSurroundingLines:ve(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(261,null)})),cursorSurroundingLinesStyle:ve(new o(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(262,null),w.localize(263,null)],markdownDescription:w.localize(264,null)})),cursorWidth:ve(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(265,null)})),disableLayerHinting:ve(new c(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new c(33,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new c(34,"domReadOnly",!1)),dragAndDrop:ve(new c(35,"dragAndDrop",!0,{description:w.localize(266,null)})),emptySelectionClipboard:ve(new z),dropIntoEditor:ve(new nt),stickyScroll:ve(new Pe),experimentalWhitespaceRendering:ve(new o(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(267,null),w.localize(268,null),w.localize(269,null)],description:w.localize(270,null)})),extraEditorClassName:ve(new t(39,"extraEditorClassName","")),fastScrollSensitivity:ve(new r(40,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:w.localize(271,null)})),find:ve(new T),fixedOverflowWidgets:ve(new c(42,"fixedOverflowWidgets",!1)),folding:ve(new c(43,"folding",!0,{description:w.localize(272,null)})),foldingStrategy:ve(new o(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(273,null),w.localize(274,null)],description:w.localize(275,null)})),foldingHighlight:ve(new c(45,"foldingHighlight",!0,{description:w.localize(276,null)})),foldingImportsByDefault:ve(new c(46,"foldingImportsByDefault",!1,{description:w.localize(277,null)})),foldingMaximumRegions:ve(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(278,null)})),unfoldOnClickAfterEndOfLine:ve(new c(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(279,null)})),fontFamily:ve(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(280,null)})),fontInfo:ve(new j),fontLigatures2:ve(new F),fontSize:ve(new B),fontWeight:ve(new X),fontVariations:ve(new N),formatOnPaste:ve(new c(55,"formatOnPaste",!1,{description:w.localize(281,null)})),formatOnType:ve(new c(56,"formatOnType",!1,{description:w.localize(282,null)})),glyphMargin:ve(new c(57,"glyphMargin",!0,{description:w.localize(283,null)})),gotoLocation:ve(new ie),hideCursorInOverviewRuler:ve(new c(59,"hideCursorInOverviewRuler",!1,{description:w.localize(284,null)})),hover:ve(new H),inDiffEditor:ve(new c(61,"inDiffEditor",!1)),letterSpacing:ve(new r(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>r.clamp(te,-5,20),{description:w.localize(285,null)})),lightbulb:ve(new oe),lineDecorationsWidth:ve(new U),lineHeight:ve(new Y),lineNumbers:ve(new $e),lineNumbersMinChars:ve(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new c(70,"linkedEditing",!1,{description:w.localize(286,null)})),links:ve(new c(71,"links",!0,{description:w.localize(287,null)})),matchBrackets:ve(new o(72,"matchBrackets","always",["always","near","never"],{description:w.localize(288,null)})),minimap:ve(new pe),mouseStyle:ve(new o(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new r(75,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:w.localize(289,null)})),mouseWheelZoom:ve(new c(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?w.localize(290,null):w.localize(291,null)})),multiCursorMergeOverlapping:ve(new c(77,"multiCursorMergeOverlapping",!0,{description:w.localize(292,null)})),multiCursorModifier:ve(new s(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[w.localize(293,null),w.localize(294,null)],markdownDescription:w.localize(295,null)})),multiCursorPaste:ve(new o(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(296,null),w.localize(297,null)],markdownDescription:w.localize(298,null)})),multiCursorLimit:ve(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(299,null)})),occurrencesHighlight:ve(new o(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(300,null),w.localize(301,null),w.localize(302,null)],markdownDescription:w.localize(303,null)})),overviewRulerBorder:ve(new c(82,"overviewRulerBorder",!0,{description:w.localize(304,null)})),overviewRulerLanes:ve(new n(83,"overviewRulerLanes",3,0,3)),padding:ve(new ae),pasteAs:ve(new it),parameterHints:ve(new se),peekWidgetDefaultFocus:ve(new o(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(305,null),w.localize(306,null)],description:w.localize(307,null)})),definitionLinkOpensInPeek:ve(new c(88,"definitionLinkOpensInPeek",!1,{description:w.localize(308,null)})),quickSuggestions:ve(new Q),quickSuggestionsDelay:ve(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(309,null)})),readOnly:ve(new c(91,"readOnly",!1)),readOnlyMessage:ve(new Se),renameOnType:ve(new c(93,"renameOnType",!1,{description:w.localize(310,null),markdownDeprecationMessage:w.localize(311,null)})),renderControlCharacters:ve(new c(94,"renderControlCharacters",!0,{description:w.localize(312,null),restricted:!0})),renderFinalNewline:ve(new o(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:w.localize(313,null)})),renderLineHighlight:ve(new o(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(314,null)],description:w.localize(315,null)})),renderLineHighlightOnlyWhenFocus:ve(new c(97,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(316,null)})),renderValidationDecorations:ve(new o(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new o(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(317,null),w.localize(318,null),w.localize(319,null),""],description:w.localize(320,null)})),revealHorizontalRightPadding:ve(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ve(new c(101,"roundedSelection",!0,{description:w.localize(321,null)})),rulers:ve(new Ne),scrollbar:ve(new Ae),scrollBeyondLastColumn:ve(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(322,null)})),scrollBeyondLastLine:ve(new c(105,"scrollBeyondLastLine",!0,{description:w.localize(323,null)})),scrollPredominantAxis:ve(new c(106,"scrollPredominantAxis",!0,{description:w.localize(324,null)})),selectionClipboard:ve(new c(107,"selectionClipboard",!0,{description:w.localize(325,null),included:M.$k})),selectionHighlight:ve(new c(108,"selectionHighlight",!0,{description:w.localize(326,null)})),selectOnLineNumbers:ve(new c(109,"selectOnLineNumbers",!0)),showFoldingControls:ve(new o(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(327,null),w.localize(328,null),w.localize(329,null)],description:w.localize(330,null)})),showUnused:ve(new c(111,"showUnused",!0,{description:w.localize(331,null)})),showDeprecated:ve(new c(140,"showDeprecated",!0,{description:w.localize(332,null)})),inlayHints:ve(new me),snippetSuggestions:ve(new o(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(333,null),w.localize(334,null),w.localize(335,null),w.localize(336,null)],description:w.localize(337,null)})),smartSelect:ve(new Fe),smoothScrolling:ve(new c(114,"smoothScrolling",!1,{description:w.localize(338,null)})),stopRenderingLineAfter:ve(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new be),inlineSuggest:ve(new V),inlineEdit:ve(new W),inlineCompletionsAccessibilityVerbose:ve(new c(149,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(339,null)})),suggestFontSize:ve(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ve(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ve(new c(121,"suggestOnTriggerCharacters",!0,{description:w.localize(342,null)})),suggestSelection:ve(new o(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(343,null),w.localize(344,null),w.localize(345,null)],description:w.localize(346,null)})),tabCompletion:ve(new o(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(347,null),w.localize(348,null),w.localize(349,null)],description:w.localize(350,null)})),tabIndex:ve(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:ve(new je),unusualLineTerminators:ve(new o(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(351,null),w.localize(352,null),w.localize(353,null)],description:w.localize(354,null)})),useShadowDOM:ve(new c(127,"useShadowDOM",!0)),useTabStops:ve(new c(128,"useTabStops",!0,{description:w.localize(355,null)})),wordBreak:ve(new o(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(356,null),w.localize(357,null)],description:w.localize(358,null)})),wordSegmenterLocales:ve(new Ve),wordSeparators:ve(new t(131,"wordSeparators",R.$$s,{description:w.localize(359,null)})),wordWrap:ve(new o(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(360,null),w.localize(361,null),w.localize(362,null),w.localize(363,null)],description:w.localize(364,null)})),wordWrapBreakAfterCharacters:ve(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(365,null)})),wordWrapOverride1:ve(new o(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new o(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ve(new O),defaultColorDecorators:ve(new c(147,"defaultColorDecorators",!1,{markdownDescription:w.localize(366,null)})),pixelRatio:ve(new ue),tabFocusMode:ve(new c(144,"tabFocusMode",!1,{markdownDescription:w.localize(367,null)})),layoutInfo:ve(new x),wrappingInfo:ve(new _e),wrappingIndent:ve(new tt),wrappingStrategy:ve(new _)}}),define(ke[207],De([9,10]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(ke[84],De([1,0,79,2,180,29,190,207]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Bu=e.$Au=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$zu=e.$yu=e.SymbolKinds=e.SymbolTag=e.$wu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$uu=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$tu=e.$su=e.$ru=void 0,e.$vu=o,e.$xu=u;class ${constructor(K,x,_){this.offset=K,this.type=x,this.language=_,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ru=$;class k{constructor(K,x){this.tokens=K,this.endState=x,this._tokenizationResultBrand=void 0}}e.$su=k;class I{constructor(K,x){this.tokens=K,this.endState=x,this._encodedTokenizationResultBrand=void 0}}e.$tu=I;var P;(function(H){H[H.Increase=0]="Increase",H[H.Decrease=1]="Decrease"})(P||(e.HoverVerbosityAction=P={}));var p;(function(H){H[H.Method=0]="Method",H[H.Function=1]="Function",H[H.Constructor=2]="Constructor",H[H.Field=3]="Field",H[H.Variable=4]="Variable",H[H.Class=5]="Class",H[H.Struct=6]="Struct",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Event=10]="Event",H[H.Operator=11]="Operator",H[H.Unit=12]="Unit",H[H.Value=13]="Value",H[H.Constant=14]="Constant",H[H.Enum=15]="Enum",H[H.EnumMember=16]="EnumMember",H[H.Keyword=17]="Keyword",H[H.Text=18]="Text",H[H.Color=19]="Color",H[H.File=20]="File",H[H.Reference=21]="Reference",H[H.Customcolor=22]="Customcolor",H[H.Folder=23]="Folder",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue",H[H.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var E;(function(H){const K=new Map;K.set(0,l.$Zj.symbolMethod),K.set(1,l.$Zj.symbolFunction),K.set(2,l.$Zj.symbolConstructor),K.set(3,l.$Zj.symbolField),K.set(4,l.$Zj.symbolVariable),K.set(5,l.$Zj.symbolClass),K.set(6,l.$Zj.symbolStruct),K.set(7,l.$Zj.symbolInterface),K.set(8,l.$Zj.symbolModule),K.set(9,l.$Zj.symbolProperty),K.set(10,l.$Zj.symbolEvent),K.set(11,l.$Zj.symbolOperator),K.set(12,l.$Zj.symbolUnit),K.set(13,l.$Zj.symbolValue),K.set(15,l.$Zj.symbolEnum),K.set(14,l.$Zj.symbolConstant),K.set(15,l.$Zj.symbolEnum),K.set(16,l.$Zj.symbolEnumMember),K.set(17,l.$Zj.symbolKeyword),K.set(27,l.$Zj.symbolSnippet),K.set(18,l.$Zj.symbolText),K.set(19,l.$Zj.symbolColor),K.set(20,l.$Zj.symbolFile),K.set(21,l.$Zj.symbolReference),K.set(22,l.$Zj.symbolCustomColor),K.set(23,l.$Zj.symbolFolder),K.set(24,l.$Zj.symbolTypeParameter),K.set(25,l.$Zj.account),K.set(26,l.$Zj.issues);function x(oe){let Pe=K.get(oe);return Pe||(console.info("No codicon found for CompletionItemKind "+oe),Pe=l.$Zj.symbolProperty),Pe}H.toIcon=x;const _=new Map;_.set("method",0),_.set("function",1),_.set("constructor",2),_.set("field",3),_.set("variable",4),_.set("class",5),_.set("struct",6),_.set("interface",7),_.set("module",8),_.set("property",9),_.set("event",10),_.set("operator",11),_.set("unit",12),_.set("value",13),_.set("constant",14),_.set("enum",15),_.set("enum-member",16),_.set("enumMember",16),_.set("keyword",17),_.set("snippet",27),_.set("text",18),_.set("color",19),_.set("file",20),_.set("reference",21),_.set("customcolor",22),_.set("folder",23),_.set("type-parameter",24),_.set("typeParameter",24),_.set("account",25),_.set("issue",26);function ge(oe,Pe){let me=_.get(oe);return typeof me>"u"&&!Pe&&(me=9),me}H.fromString=ge})(E||(e.CompletionItemKinds=E={}));var v;(function(H){H[H.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var d;(function(H){H[H.None=0]="None",H[H.KeepWhitespace=1]="KeepWhitespace",H[H.InsertAsSnippet=4]="InsertAsSnippet"})(d||(e.CompletionItemInsertTextRule=d={}));var h;(function(H){H[H.Word=0]="Word",H[H.Line=1]="Line",H[H.Suggest=2]="Suggest"})(h||(e.PartialAcceptTriggerKind=h={}));var c;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var i;(function(H){H[H.Automatic=0]="Automatic",H[H.Explicit=1]="Explicit"})(i||(e.InlineCompletionTriggerKind=i={}));class n{constructor(K,x,_,ge){this.range=K,this.text=x,this.completionKind=_,this.isSnippetText=ge}equals(K){return A.$At.lift(this.range).equalsRange(K.range)&&this.text===K.text&&this.completionKind===K.completionKind&&this.isSnippetText===K.isSnippetText}}e.$uu=n;var a;(function(H){H[H.Invoke=1]="Invoke",H[H.Auto=2]="Auto"})(a||(e.CodeActionTriggerType=a={}));var r;(function(H){H[H.Automatic=0]="Automatic",H[H.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var t;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var f;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(f||(e.DocumentHighlightKind=f={}));function o(H){return H&&L.URI.isUri(H.uri)&&A.$At.isIRange(H.range)&&(A.$At.isIRange(H.originSelectionRange)||A.$At.isIRange(H.targetSelectionRange))}var s;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(s||(e.SymbolKind=s={})),e.$wu={17:(0,w.localize)(0,null),16:(0,w.localize)(1,null),4:(0,w.localize)(2,null),13:(0,w.localize)(3,null),8:(0,w.localize)(4,null),9:(0,w.localize)(5,null),21:(0,w.localize)(6,null),23:(0,w.localize)(7,null),7:(0,w.localize)(8,null),0:(0,w.localize)(9,null),11:(0,w.localize)(10,null),10:(0,w.localize)(11,null),19:(0,w.localize)(12,null),5:(0,w.localize)(13,null),1:(0,w.localize)(14,null),2:(0,w.localize)(15,null),20:(0,w.localize)(16,null),15:(0,w.localize)(17,null),18:(0,w.localize)(18,null),24:(0,w.localize)(19,null),3:(0,w.localize)(20,null),6:(0,w.localize)(21,null),14:(0,w.localize)(22,null),22:(0,w.localize)(23,null),25:(0,w.localize)(24,null),12:(0,w.localize)(25,null)};function u(H,K){return(0,w.localize)(26,null,H,e.$wu[K])}var g;(function(H){H[H.Deprecated=1]="Deprecated"})(g||(e.SymbolTag=g={}));var b;(function(H){const K=new Map;K.set(0,l.$Zj.symbolFile),K.set(1,l.$Zj.symbolModule),K.set(2,l.$Zj.symbolNamespace),K.set(3,l.$Zj.symbolPackage),K.set(4,l.$Zj.symbolClass),K.set(5,l.$Zj.symbolMethod),K.set(6,l.$Zj.symbolProperty),K.set(7,l.$Zj.symbolField),K.set(8,l.$Zj.symbolConstructor),K.set(9,l.$Zj.symbolEnum),K.set(10,l.$Zj.symbolInterface),K.set(11,l.$Zj.symbolFunction),K.set(12,l.$Zj.symbolVariable),K.set(13,l.$Zj.symbolConstant),K.set(14,l.$Zj.symbolString),K.set(15,l.$Zj.symbolNumber),K.set(16,l.$Zj.symbolBoolean),K.set(17,l.$Zj.symbolArray),K.set(18,l.$Zj.symbolObject),K.set(19,l.$Zj.symbolKey),K.set(20,l.$Zj.symbolNull),K.set(21,l.$Zj.symbolEnumMember),K.set(22,l.$Zj.symbolStruct),K.set(23,l.$Zj.symbolEvent),K.set(24,l.$Zj.symbolOperator),K.set(25,l.$Zj.symbolTypeParameter);function x(_){let ge=K.get(_);return ge||(console.info("No codicon found for SymbolKind "+_),ge=l.$Zj.symbolProperty),ge}H.toIcon=x})(b||(e.SymbolKinds=b={}));class S{static asEditOperation(K){return M.$Bt.replace(A.$At.lift(K.range),K.text)}}e.$yu=S;class m{static{this.Comment=new m("comment")}static{this.Imports=new m("imports")}static{this.Region=new m("region")}static fromValue(K){switch(K){case"comment":return m.Comment;case"imports":return m.Imports;case"region":return m.Region}return new m(K)}constructor(K){this.value=K}}e.$zu=m;var y;(function(H){H[H.AIGenerated=1]="AIGenerated"})(y||(e.NewSymbolNameTag=y={}));var D;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(D||(e.NewSymbolNameTriggerKind=D={}));var C;(function(H){function K(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}H.is=K})(C||(e.Command=C={}));var O;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(O||(e.CommentThreadCollapsibleState=O={}));var z;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(z||(e.CommentThreadState=z={}));var T;(function(H){H[H.Current=0]="Current",H[H.Outdated=1]="Outdated"})(T||(e.CommentThreadApplicability=T={}));var F;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(F||(e.CommentMode=F={}));var N;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(N||(e.CommentState=N={}));var j;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class B{constructor(K){this.b=K,this.a=null}dispose(){this.a&&this.a.then(K=>{K&&K.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Au=B,e.$Bu=new R.$ju;var X;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(X||(e.ExternalUriOpenerPriority=X={}));var ie;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(ie||(e.InlineEditTriggerKind=ie={}))}),define(ke[208],De([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[209],De([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[210],De([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(ke[211],De([9,10]),function(le,e){return le.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[212],De([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[213],De([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[214],De([9,10]),function(le,e){return le.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[215],De([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(ke[216],De([9,10]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(ke[217],De([9,10]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[218],De([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(ke[219],De([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(ke[220],De([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(ke[221],De([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[222],De([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[223],De([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(ke[224],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[225],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[226],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[227],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[228],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[229],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[230],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[231],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[232],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[233],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[234],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[235],De([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[236],De([9,10]),function(le,e){return le.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[237],De([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(ke[238],De([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(ke[239],De([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(ke[240],De([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[241],De([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[242],De([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[243],De([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[244],De([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[245],De([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[246],De([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[247],De([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[248],De([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[249],De([9,10]),function(le,e){return le.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[250],De([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[251],De([1,0,13,210]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var M;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(M||(e.TokenType=M={}));function A(...k){switch(k.length){case 1:return(0,L.localize)(0,null,k[0]);case 2:return(0,L.localize)(1,null,k[0],k[1]);case 3:return(0,L.localize)(2,null,k[0],k[1],k[2]);default:return}}const R=(0,L.localize)(3,null),w=(0,L.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,l.$8)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(I){return this.c=I,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(I){return this.r()||this.c.charCodeAt(this.e)!==I?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(I){this.f.push({type:I,offset:this.d})}l(I){const P=this.d,p=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:p};this.g.push({offset:P,lexeme:p,additionalInfo:I}),this.f.push(E)}n(){this.m.lastIndex=this.d;const I=this.m.exec(this.c);if(I){this.e=this.d+I[0].length;const P=this.c.substring(this.d,this.e),p=$.b.get(P);p?this.k(p):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let I=this.e,P=!1,p=!1;for(;;){if(I>=this.c.length){this.e=I,this.l(w);return}const v=this.c.charCodeAt(I);if(P)P=!1;else if(v===47&&!p){I++;break}else v===91?p=!0:v===92?P=!0:v===93&&(p=!1);I++}for(;I<this.c.length&&$.a.has(this.c.charCodeAt(I));)I++;this.e=I;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=$}),define(ke[252],De([1,0,23,41,213,401]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=$,e.$Np=k,e.$Op=I,e.$Pp=P,e.$Qp=p,e.$Rp=E,e.$Sp=v;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function $(c){return c=c.trim(),c==="*"||R.test(c)}function k(c){if(!$(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=c.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function I(c){if(!c)return null;const i=c.majorBase,n=c.majorMustEqual,a=c.minorBase;let r=c.minorMustEqual;const t=c.patchBase;let f=c.patchMustEqual;c.hasCaret&&(i===0||(r=!1),f=!1);let o=0;if(c.preRelease){const s=w.exec(c.preRelease);if(s){const[,u,g,b]=s;o=Date.UTC(Number(u),Number(g)-1,Number(b))}}return{majorBase:i,majorMustEqual:n,minorBase:a,minorMustEqual:r,patchBase:t,patchMustEqual:f,isMinimum:c.hasGreaterEquals,notBefore:o}}function P(c,i,n){let a;typeof c=="string"?a=I(k(c)):a=c;let r;i instanceof Date?r=i.getTime():typeof i=="string"&&(r=new Date(i).getTime());let t;if(typeof n=="string"?t=I(k(n)):t=n,!a||!t)return!1;const f=a.majorBase,o=a.minorBase,s=a.patchBase;let u=t.majorBase,g=t.minorBase,b=t.patchBase;const S=t.notBefore;let m=t.majorMustEqual,y=t.minorMustEqual,D=t.patchMustEqual;return t.isMinimum?f>u?!0:f<u?!1:o>g?!0:o<g||r&&r<S?!1:s>=b:(f===1&&u===0&&(!m||!y||!D)&&(u=1,g=0,b=0,m=!0,y=!1,D=!1),f<u?!1:f>u?!m:o<g?!1:o>g?!y:s<b?!1:s>b?!D:!(r&&r<S))}function p(c,i,n,a,r){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([L.default.Error,M.localize(0,null)]),t;if(typeof a.name!="string")return t.push([L.default.Error,M.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([L.default.Error,M.localize(2,null,"version")]),t;if(!a.engines)return t.push([L.default.Error,M.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([L.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!h(a.extensionDependencies))return t.push([L.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!h(a.activationEvents))return t.push([L.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([L.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([L.default.Warning,M.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([L.default.Error,M.localize(9,null,"main")]),t;{const s=(0,l.$bh)(n,a.main);(0,l.$8g)(s,n)||t.push([L.default.Warning,M.localize(10,null,s.path,n.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([L.default.Error,M.localize(11,null,"browser")]),t;{const s=(0,l.$bh)(n,a.browser);(0,l.$8g)(s,n)||t.push([L.default.Warning,M.localize(12,null,s.path,n.path)])}}if(!A.valid(a.version))return t.push([L.default.Error,M.localize(13,null)]),t;const f=[];if(!E(c,i,a,r,f))for(const s of f)t.push([L.default.Error,s]);return t}function E(c,i,n,a,r){return a||typeof n.main>"u"&&typeof n.browser>"u"?!0:d(c,i,n.engines.vscode,r)}function v(c,i,n){return c==="*"||d(i,n,c)}function d(c,i,n,a=[]){const r=I(k(n));if(!r)return a.push(M.localize(14,null,n)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return a.push(M.localize(15,null,n)),!1}else if(!r.majorMustEqual)return a.push(M.localize(16,null,n)),!1;return P(c,i,r)?!0:(a.push(M.localize(17,null,c,n)),!1)}function h(c){if(!Array.isArray(c))return!1;for(let i=0,n=c.length;i<n;i++)if(typeof c[i]!="string")return!1;return!0}}),define(ke[106],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class l{constructor(M,A=[],R=!1){this.ctor=M,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$xi=l}),define(ke[85],De([1,0,106]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ds=A,e.$Es=R;const L=[];var M;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function A(w,$,k){$ instanceof l.$xi||($=new l.$xi($,[],!!k)),L.push([w,$])}function R(){return L}}),define(ke[253],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;class l{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$gr=l;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const w=this.lookupOrInsertNode(A),$=this.lookupOrInsertNode(R);w.outgoing.set($.key,$),$.incoming.set(w.key,w)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const w of this.a.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let w=this.a.get(R);return w||(w=new l(R,A),this.a.set(R,w)),w}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,w]of this.a)A.push(`${R}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const w=new Set([A]),$=this.c(R,w);if($)return $}}c(A,R){for(const[w,$]of A.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const k=this.c($,R);if(k)return k;R.delete(w)}}}e.$hr=L}),define(ke[5],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=M,e.$Bi=A;var l;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function w($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=w})(l||(e._util=l={})),e.$zi=M("instantiationService");function L(R,w,$){w[l.DI_TARGET]===w?w[l.DI_DEPENDENCIES].push({id:R,index:$}):(w[l.DI_DEPENDENCIES]=[{id:R,index:$}],w[l.DI_TARGET]=w)}function M(R){if(l.serviceIds.has(R))return l.serviceIds.get(R);const w=function($,k,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(w,$,I)};return w.toString=()=>R,l.serviceIds.set(R,w),w}function A(R){return R}}),define(ke[56],De([1,0,18,2,5]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=A,e.$9i=R,e.$0i=$,e.$$i=k,e.$_i=I,e.$aj=P,e.$bj=p,e.$cj=v,e.$dj=d,e.$ej=h,e.$7i=(0,M.$Ai)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof L.URI)}function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof L.URI)}var w;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function $(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function I(c,i){const n=Object.create(null);for(const a in c)P(n,a,c[a],i);return n}function P(c,i,n,a){const r=i.split("."),t=r.pop();let f=c;for(let o=0;o<r.length;o++){const s=r[o];let u=f[s];switch(typeof u){case"undefined":u=f[s]=Object.create(null);break;case"object":if(u===null){a(`Ignoring ${i} as ${r.slice(0,o+1).join(".")} is null`);return}break;default:a(`Ignoring ${i} as ${r.slice(0,o+1).join(".")} is ${JSON.stringify(u)}`);return}f=u}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{a(`Ignoring ${i} as ${r.join(".")} is ${JSON.stringify(f)}`)}else a(`Ignoring ${i} as ${r.join(".")} is ${JSON.stringify(f)}`)}function p(c,i){const n=i.split(".");E(c,n)}function E(c,i){const n=i.shift();if(i.length===0){delete c[n];return}if(Object.keys(c).indexOf(n)!==-1){const a=c[n];typeof a=="object"&&!Array.isArray(a)&&(E(a,i),Object.keys(a).length===0&&delete c[n])}}function v(c,i,n){function a(f,o){let s=f;for(const u of o){if(typeof s!="object"||s===null)return;s=s[u]}return s}const r=i.split("."),t=a(c,r);return typeof t>"u"?n:t}function d(c,i,n){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in c?l.$cg(c[a])&&l.$cg(i[a])?d(c[a],i[a],n):n&&(c[a]=i[a]):c[a]=i[a])})}function h(c){return c.replace(/[\[\]]/g,"")}}),define(ke[38],De([1,0,12,14,251,5,209,13]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=k,e.$zj=f,e.$Aj=o,e.$Tj=ge;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",l.$j),$.set("isLinux",l.$k),$.set("isWindows",l.$i),$.set("isWeb",l.$o),$.set("isMacNative",l.$j&&!l.$o),$.set("isEdge",l.$H),$.set("isFirefox",l.$F),$.set("isChrome",l.$E),$.set("isSafari",l.$G);function k(me,U){if($.get(me)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(me,U)}const I=Object.prototype.hasOwnProperty;var P;(function(me){me[me.False=0]="False",me[me.True=1]="True",me[me.Defined=2]="Defined",me[me.Not=3]="Not",me[me.Equals=4]="Equals",me[me.NotEquals=5]="NotEquals",me[me.And=6]="And",me[me.Regex=7]="Regex",me[me.NotRegex=8]="NotRegex",me[me.Or=9]="Or",me[me.In=10]="In",me[me.NotIn=11]="NotIn",me[me.Greater=12]="Greater",me[me.GreaterEquals=13]="GreaterEquals",me[me.Smaller=14]="Smaller",me[me.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const p={regexParsingWithErrorRecovery:!0},E=(0,R.localize)(0,null),v=(0,R.localize)(1,null),d=(0,R.localize)(2,null),h=(0,R.localize)(3,null),c=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),a=(0,R.localize)(7,null);class r{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=p){this.k=U,this.d=new M.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const Y=this.l();if(!this.E()){const pe=this.D(),ce=pe.type===17?i:void 0;throw this.h.push({message:c,offset:pe.offset,lexeme:M.$vj.getLexeme(pe),additionalInfo:ce}),r.c}return Y}catch(Y){if(Y!==r.c)throw Y;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const Y=this.o();U.push(Y)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const Y=this.s();U.push(Y)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const Y=this.l();return this.A(1,h),Y?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const Y=this.l();return this.A(1,h),Y}case 17:{const Y=U.lexeme;if(this.z(),this.y(9)){const ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ce.type!==10)throw this.B("REGEX",ce);const ae=ce.lexeme,se=ae.lastIndexOf("/"),ue=se===ae.length-1?void 0:this.w(ae.substring(se+1));let Q;try{Q=new RegExp(ae.substring(1,se),ue)}catch{throw this.B("REGEX",ce)}return j.create(Y,Q)}switch(ce.type){case 10:case 19:{const ae=[ce.lexeme];this.z();let se=this.D(),ue=0;for(let Ne=0;Ne<ce.lexeme.length;Ne++)ce.lexeme.charCodeAt(Ne)===40?ue++:ce.lexeme.charCodeAt(Ne)===41&&ue--;for(;!this.E()&&se.type!==15&&se.type!==16;){switch(se.type){case 0:ue++;break;case 1:ue--;break;case 10:case 18:for(let Ne=0;Ne<se.lexeme.length;Ne++)se.lexeme.charCodeAt(Ne)===40?ue++:ce.lexeme.charCodeAt(Ne)===41&&ue--}if(ue<0)break;ae.push(M.$vj.getLexeme(se)),this.z(),se=this.D()}const Q=ae.join(""),re=Q.lastIndexOf("/"),$e=re===Q.length-1?void 0:this.w(Q.substring(re+1));let we;try{we=new RegExp(Q.substring(1,re),$e)}catch{throw this.B("REGEX",ce)}return t.regex(Y,we)}case 18:{const ae=ce.lexeme;this.z();let se=null;if(!(0,L.$$e)(ae)){const ue=ae.indexOf("/"),Q=ae.lastIndexOf("/");if(ue!==Q&&ue>=0){const re=ae.slice(ue+1,Q),$e=ae[Q+1]==="i"?"i":"";try{se=new RegExp(re,$e)}catch{throw this.B("REGEX",ce)}}}if(se===null)throw this.B("REGEX",ce);return j.create(Y,se)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,d);const ce=this.u();return t.notIn(Y,ce)}switch(this.D().type){case 3:{this.z();const ce=this.u();if(this.x().type===18)return t.equals(Y,ce);switch(ce){case"true":return t.has(Y);case"false":return t.not(Y);default:return t.equals(Y,ce)}}case 4:{this.z();const ce=this.u();if(this.x().type===18)return t.notEquals(Y,ce);switch(ce){case"true":return t.not(Y);case"false":return t.has(Y);default:return t.notEquals(Y,ce)}}case 5:return this.z(),F.create(Y,this.u());case 6:return this.z(),N.create(Y,this.u());case 7:return this.z(),z.create(Y,this.u());case 8:return this.z(),T.create(Y,this.u());case 13:return this.z(),t.in(Y,this.u());default:return t.has(Y)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:a}),r.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,Y){if(this.C(U))return this.z();throw this.B(Y,this.D())}B(U,Y,pe){const ce=(0,R.localize)(8,null,U,M.$vj.getLexeme(Y)),ae=Y.offset,se=M.$vj.getLexeme(Y);return this.h.push({message:ce,offset:ae,lexeme:se,additionalInfo:pe}),r.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$xj=r;class t{static false(){return u.INSTANCE}static true(){return g.INSTANCE}static has(U){return b.create(U)}static equals(U,Y){return S.create(U,Y)}static notEquals(U,Y){return D.create(U,Y)}static regex(U,Y){return j.create(U,Y)}static in(U,Y){return m.create(U,Y)}static notIn(U,Y){return y.create(U,Y)}static not(U){return C.create(U)}static and(...U){return ie.create(U,null,!0)}static or(...U){return H.create(U,null,!0)}static greater(U,Y){return z.create(U,Y)}static greaterEquals(U,Y){return T.create(U,Y)}static smaller(U,Y){return F.create(U,Y)}static smallerEquals(U,Y){return N.create(U,Y)}static{this.c=new r({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$yj=t;function f(me){const U=new r({regexParsingWithErrorRecovery:!1});return me.map(Y=>(U.parse(Y),U.lexingErrors.length>0?U.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,R.localize)(9,null,pe.additionalInfo):(0,R.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function o(me,U){const Y=me?me.substituteConstants():void 0,pe=U?U.substituteConstants():void 0;return!Y&&!pe?!0:!Y||!pe?!1:Y.equals(pe)}function s(me,U){return me.cmp(U)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return g.INSTANCE}}e.$Bj=u;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return u.INSTANCE}}e.$Cj=g;class b{static create(U,Y=null){const pe=$.get(U);return typeof pe=="boolean"?pe?g.INSTANCE:u.INSTANCE:new b(U,Y)}constructor(U,Y){this.key=U,this.c=Y,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?g.INSTANCE:u.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Dj=b;class S{static create(U,Y,pe=null){if(typeof Y=="boolean")return Y?b.create(U,pe):C.create(U,pe);const ce=$.get(U);return typeof ce=="boolean"?Y===(ce?"true":"false")?g.INSTANCE:u.INSTANCE:new S(U,Y,pe)}constructor(U,Y,pe){this.c=U,this.d=Y,this.f=pe,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const Y=U?"true":"false";return this.d===Y?g.INSTANCE:u.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Ej=S;class m{static create(U,Y){return new m(U,Y)}constructor(U,Y){this.d=U,this.f=Y,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:_(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const Y=U.getValue(this.f),pe=U.getValue(this.d);return Array.isArray(Y)?Y.includes(pe):typeof pe=="string"&&typeof Y=="object"&&Y!==null?I.call(Y,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$Fj=m;class y{static create(U,Y){return new y(U,Y)}constructor(U,Y){this.d=U,this.f=Y,this.type=11,this.c=m.create(U,Y)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=y;class D{static create(U,Y,pe=null){if(typeof Y=="boolean")return Y?C.create(U,pe):b.create(U,pe);const ce=$.get(U);return typeof ce=="boolean"?Y===(ce?"true":"false")?u.INSTANCE:g.INSTANCE:new D(U,Y,pe)}constructor(U,Y,pe){this.c=U,this.d=Y,this.f=pe,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const Y=U?"true":"false";return this.d===Y?u.INSTANCE:g.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Hj=D;class C{static create(U,Y=null){const pe=$.get(U);return typeof pe=="boolean"?pe?u.INSTANCE:g.INSTANCE:new C(U,Y)}constructor(U,Y){this.c=U,this.d=Y,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?u.INSTANCE:g.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Ij=C;function O(me,U){if(typeof me=="string"){const Y=parseFloat(me);isNaN(Y)||(me=Y)}return typeof me=="string"||typeof me=="number"?U(me):u.INSTANCE}class z{static create(U,Y,pe=null){return O(Y,ce=>new z(U,ce,pe))}constructor(U,Y,pe){this.c=U,this.d=Y,this.f=pe,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Jj=z;class T{static create(U,Y,pe=null){return O(Y,ce=>new T(U,ce,pe))}constructor(U,Y,pe){this.c=U,this.d=Y,this.f=pe,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Kj=T;class F{static create(U,Y,pe=null){return O(Y,ce=>new F(U,ce,pe))}constructor(U,Y,pe){this.c=U,this.d=Y,this.f=pe,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Lj=F;class N{static create(U,Y,pe=null){return O(Y,ce=>new N(U,ce,pe))}constructor(U,Y,pe){this.c=U,this.d=Y,this.f=pe,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:_(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Mj=N;class j{static create(U,Y){return new j(U,Y)}constructor(U,Y){this.d=U,this.f=Y,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const Y=this.f?this.f.source:"",pe=U.f?U.f.source:"";return Y<pe?-1:Y>pe?1:0}equals(U){if(U.type===this.type){const Y=this.f?this.f.source:"",pe=U.f?U.f.source:"";return this.d===U.d&&Y===pe}return!1}substituteConstants(){return this}evaluate(U){const Y=U.getValue(this.d);return this.f?this.f.test(Y):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$Nj=j;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$Oj=B;function X(me){let U=null;for(let Y=0,pe=me.length;Y<pe;Y++){const ce=me[Y].substituteConstants();if(me[Y]!==ce&&U===null){U=[];for(let ae=0;ae<Y;ae++)U[ae]=me[ae]}U!==null&&(U[Y]=ce)}return U===null?me:U}class ie{static create(U,Y,pe){return ie.d(U,Y,pe)}constructor(U,Y){this.expr=U,this.c=Y,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Y=0,pe=this.expr.length;Y<pe;Y++){const ce=s(this.expr[Y],U.expr[Y]);if(ce!==0)return ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(!this.expr[Y].equals(U.expr[Y]))return!1;return!0}return!1}substituteConstants(){const U=X(this.expr);return U===this.expr?this:ie.create(U,this.c,!1)}evaluate(U){for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(!this.expr[Y].evaluate(U))return!1;return!0}static d(U,Y,pe){const ce=[];let ae=!1;for(const se of U)if(se){if(se.type===1){ae=!0;continue}if(se.type===0)return u.INSTANCE;if(se.type===6){ce.push(...se.expr);continue}ce.push(se)}if(ce.length===0&&ae)return g.INSTANCE;if(ce.length!==0){if(ce.length===1)return ce[0];ce.sort(s);for(let se=1;se<ce.length;se++)ce[se-1].equals(ce[se])&&(ce.splice(se,1),se--);if(ce.length===1)return ce[0];for(;ce.length>1;){const se=ce[ce.length-1];if(se.type!==9)break;ce.pop();const ue=ce.pop(),Q=ce.length===0,re=H.create(se.expr.map($e=>ie.create([$e,ue],null,pe)),null,Q);re&&(ce.push(re),ce.sort(s))}if(ce.length===1)return ce[0];if(pe){for(let se=0;se<ce.length;se++)for(let ue=se+1;ue<ce.length;ue++)if(ce[se].negate().equals(ce[ue]))return u.INSTANCE;if(ce.length===1)return ce[0]}return new ie(ce,Y)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const Y of this.expr)U.push(...Y.keys());return U}map(U){return new ie(this.expr.map(Y=>Y.map(U)),null)}negate(){if(!this.c){const U=[];for(const Y of this.expr)U.push(Y.negate());this.c=H.create(U,this,!0)}return this.c}}e.$Pj=ie;class H{static create(U,Y,pe){return H.d(U,Y,pe)}constructor(U,Y){this.expr=U,this.c=Y,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let Y=0,pe=this.expr.length;Y<pe;Y++){const ce=s(this.expr[Y],U.expr[Y]);if(ce!==0)return ce}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(!this.expr[Y].equals(U.expr[Y]))return!1;return!0}return!1}substituteConstants(){const U=X(this.expr);return U===this.expr?this:H.create(U,this.c,!1)}evaluate(U){for(let Y=0,pe=this.expr.length;Y<pe;Y++)if(this.expr[Y].evaluate(U))return!0;return!1}static d(U,Y,pe){let ce=[],ae=!1;if(U){for(let se=0,ue=U.length;se<ue;se++){const Q=U[se];if(Q){if(Q.type===0){ae=!0;continue}if(Q.type===1)return g.INSTANCE;if(Q.type===9){ce=ce.concat(Q.expr);continue}ce.push(Q)}}if(ce.length===0&&ae)return u.INSTANCE;ce.sort(s)}if(ce.length!==0){if(ce.length===1)return ce[0];for(let se=1;se<ce.length;se++)ce[se-1].equals(ce[se])&&(ce.splice(se,1),se--);if(ce.length===1)return ce[0];if(pe){for(let se=0;se<ce.length;se++)for(let ue=se+1;ue<ce.length;ue++)if(ce[se].negate().equals(ce[ue]))return g.INSTANCE;if(ce.length===1)return ce[0]}return new H(ce,Y)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const Y of this.expr)U.push(...Y.keys());return U}map(U){return new H(this.expr.map(Y=>Y.map(U)),null)}negate(){if(!this.c){const U=[];for(const Y of this.expr)U.push(Y.negate());for(;U.length>1;){const Y=U.shift(),pe=U.shift(),ce=[];for(const ae of Pe(Y))for(const se of Pe(pe))ce.push(ie.create([ae,se],null,!1));U.unshift(H.create(ce,null,!1))}this.c=H.create(U,this,!0)}return this.c}}e.$Qj=H;class K extends b{static{this.d=[]}static all(){return K.d.values()}constructor(U,Y,pe){super(U,null),this.f=Y,typeof pe=="object"?K.d.push({...pe,key:U}):pe!==!0&&K.d.push({key:U,description:pe,type:Y!=null?typeof Y:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return S.create(this.key,U)}notEqualsTo(U){return D.create(this.key,U)}}e.$Rj=K,e.$Sj=(0,A.$Ai)("contextKeyService");function x(me,U){return me<U?-1:me>U?1:0}function _(me,U,Y,pe){return me<Y?-1:me>Y?1:U<pe?-1:U>pe?1:0}function ge(me,U){if(me.type===0||U.type===1)return!0;if(me.type===9)return U.type===9?oe(me.expr,U.expr):!1;if(U.type===9){for(const Y of U.expr)if(ge(me,Y))return!0;return!1}if(me.type===6){if(U.type===6)return oe(U.expr,me.expr);for(const Y of me.expr)if(ge(Y,U))return!0;return!1}return me.equals(U)}function oe(me,U){let Y=0,pe=0;for(;Y<me.length&&pe<U.length;){const ce=me[Y].cmp(U[pe]);if(ce<0)return!1;ce===0&&Y++,pe++}return Y===me.length}function Pe(me){return me.type===9?me.expr:[me]}}),define(ke[254],De([1,0,23,41,211,5,103,12,24]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Vw=e.$Uw=e.$Tw=void 0,e.$Ww=E,e.$Xw=v,e.$Tw=(0,A.$Ai)("dialogService");var k;(function(d){d[d.Confirmation=1]="Confirmation",d[d.Prompt=2]="Prompt",d[d.Input=3]="Input"})(k||(k={}));class I{a(h){return this.d(h,k.Confirmation)}b(h){return this.d(h,k.Prompt)}c(h){return this.d(h,k.Input)}d(h,c){const i=[];switch(c){case k.Confirmation:{const n=h;n.primaryButton?i.push(n.primaryButton):i.push((0,M.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,M.localize)(1,null));break}case k.Prompt:{const n=h;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(a=>a.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,M.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,M.localize)(3,null))),i.length===0&&i.push((0,M.localize)(4,null));break}case k.Input:{const n=h;n.primaryButton?i.push(n.primaryButton):i.push((0,M.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,M.localize)(6,null));break}}return i}e(h){if(typeof h=="string")return h;if(typeof h=="number")return h===L.default.Info?"info":h===L.default.Error?"error":h===L.default.Warning?"warning":"none"}f(h,c,i){const n=[...h.buttons??[]];h.cancelButton&&typeof h.cancelButton!="string"&&typeof h.cancelButton!="boolean"&&n.push(h.cancelButton);let a=n[c]?.run({checkboxChecked:i});return a instanceof Promise||(a=Promise.resolve(a)),{result:a,checkboxChecked:i}}}e.$Uw=I,e.$Vw=(0,A.$Ai)("fileDialogService");var P;(function(d){d[d.SAVE=0]="SAVE",d[d.DONT_SAVE=1]="DONT_SAVE",d[d.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const p=10;function E(d){const h=[];return h.push(...d.slice(0,p).map(c=>typeof c=="string"?c:(0,l.$$g)(c))),d.length>p&&(d.length-p===1?h.push((0,M.localize)(7,null)):h.push((0,M.localize)(8,null,d.length-p))),h.push(""),h.join(`
`)}function v(d,h){const c=(0,$.$7n)(d);let i=(c.buttons??[]).map(t=>(0,R.$Qw)(t)),n=(d.buttons||[]).map((t,f)=>f),a=0,r=c.cancelId??i.length-1;if(i.length>1){const t=typeof r=="number"?i[r]:void 0;if(w.$k||w.$j){if(typeof t=="string"&&i.length>1&&r!==1){i.splice(r,1),i.splice(1,0,t);const f=n[r];n.splice(r,1),n.splice(1,0,f),r=1}w.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),a=i.length-1,typeof t=="string"&&(r=a-1))}else if(w.$i&&typeof t=="string"&&i.length>1&&r!==i.length-1){i.splice(r,1),i.push(t);const f=n[r];n.splice(r,1),n.push(f),r=i.length-1}}return c.buttons=i,c.defaultId=a,c.cancelId=r,c.noLink=!0,c.title=c.title||h.nameLong,{options:c,buttonIndeces:n}}}),define(ke[137],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,l.$Ai)("environmentService"),e.$Ii=(0,l.$Bi)(e.$Hi)}),define(ke[138],De([1,0,212,5]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.ExtensionManagementErrorCode=e.$ap=e.ExtensionGalleryErrorCode=e.$_o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0,e.$6o=A,e.$7o=R,e.$8o=w,e.$9o=$,e.$0o=k,e.$$o=I,e.$Yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Zo=new RegExp(e.$Yo),e.$1o="__web_extension",e.$2o="skipWalkthrough",e.$3o="extensionInstallSource",e.$4o="dependecyOrPackExtensionInstall",e.$5o="clientTargetPlatform";var M;(function(n){n.COMMAND="command",n.SETTINGS_SYNC="settingsSync"})(M||(e.ExtensionInstallSource=M={}));function A(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function w(n,a){switch(n){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function $(n,a){return a==="web"&&!n.includes("web")}function k(n,a,r){return $(a,r)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===r}function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var P;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var p;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var E;(function(n){n.Install="install",n.Uninstall="uninstall"})(E||(e.StatisticType=E={}));var v;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$_o=(0,L.$Ai)("extensionGalleryService");var d;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed",n.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class h extends Error{constructor(a,r){super(a),this.code=r,this.name=r}}e.$ap=h;var c;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.DownloadFailedWriting="DownloadFailedWriting",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.ScanningExtension="ScanningExtension",n.ReadUninstalled="ReadUninstalled",n.UnsetUninstalled="UnsetUninstalled",n.Delete="Delete",n.Rename="Rename",n.IntializeDefaultProfile="IntializeDefaultProfile",n.AddToProfile="AddToProfile",n.InstalledExtensionNotFound="InstalledExtensionNotFound",n.PostInstall="PostInstall",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(c||(e.ExtensionManagementErrorCode=c={}));class i extends Error{constructor(a,r){super(a),this.code=r,this.name=r}}e.$bp=i,e.$cp=(0,L.$Ai)("extensionManagementService"),e.$dp="extensionsIdentifiers/disabled",e.$ep="extensionsIdentifiers/enabled",e.$fp=(0,L.$Ai)("IGlobalExtensionEnablementService"),e.$gp=(0,L.$Ai)("IExtensionTipsService"),e.$hp=(0,l.localize2)(0,"Extensions"),e.$ip=(0,l.localize2)(1,"Preferences")}),define(ke[255],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$97b=e.$87b=void 0,e.$87b=(0,l.$Ai)("externalTerminal"),e.$97b="Terminal.app"}),define(ke[256],De([1,0,55,57,15,16,12,102,32,105,214,255]),function(le,e,l,L,M,A,R,w,$,k,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=e.$wdc=void 0;const p=I.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends E{static{this.b="cmd.exe"}openTerminal(r,t){return this.spawnTerminal(l,r,k.$sm(),t)}spawnTerminal(r,t,f,o){const s=t.windowsExec||v.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const u=A.$nc(s,".exe").toLowerCase();if(u==="cmder")return r.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const g=["/c","start","/wait"];return s.indexOf(" ")>=0&&g.push('""'),g.push(s),u==="wt"&&g.push("-d ."),new Promise((b,S)=>{const m=c(process),y=r.spawn(f,g,{cwd:o,env:m,detached:!0});y.on("error",S),y.on("exit",()=>b())})}async runInTerminal(r,t,f,o,s){const u="windowsExec"in s&&s.windowsExec?s.windowsExec:v.getDefaultTerminalWindows(),g=await v.f();return new Promise((b,S)=>{const m=`"${t} - ${p}"`,y=`"${f.join('" "')}" & pause`,D=Object.assign({},c(process),o);Object.keys(D).filter(F=>D[F]===null).forEach(F=>delete D[F]);const C={cwd:t,env:D,windowsVerbatimArguments:!0};let O,z;A.$nc(u,".exe")==="wt"?(O=u,z=["-d",".",v.b,"/c",y]):g?(O=g,z=["-d",".",u,"/c",y]):(O=v.b,z=["/c","start",m,"/wait",u,"/c",`"${y}"`]),l.spawn(O,z,C).on("error",F=>{S(i(F))}),b(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const r=await k.win32.findExecutable("wt");return await $.Promises.exists(r)?r:void 0}catch{return}}}e.$wdc=v,Je([L.$5h],v,"f",null);class d extends E{static{this.b="/usr/bin/osascript"}openTerminal(r,t){return this.spawnTerminal(l,r,t)}runInTerminal(r,t,f,o,s){const u=s.osxExec||P.$97b;return new Promise((g,b)=>{if(u===P.$97b||u==="iTerm.app"){const S=u===P.$97b?"TerminalHelper":"iTermHelper",y=[M.$Ug.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",r||p,"-w",t];for(const O of f)y.push("-a"),y.push(O);if(o){const O=Object.assign({},c(process),o);for(const z in O){const T=O[z];T===null?(y.push("-u"),y.push(z)):(y.push("-e"),y.push(`${z}=${T}`))}}let D="";const C=l.spawn(d.b,y);C.on("error",O=>{b(i(O))}),C.stderr.on("data",O=>{D+=O.toString()}),C.on("exit",O=>{if(O===0)g(void 0);else if(D){const z=D.split(`
`,1);b(new Error(z[0]))}else b(new Error(I.localize(1,null,S,O)))})}else b(new Error(I.localize(2,null,u)))})}spawnTerminal(r,t,f){const o=t.osxExec||P.$97b;return new Promise((s,u)=>{const g=["-a",o];f&&g.push(f);const b=c(process),S=r.spawn("/usr/bin/open",g,{cwd:f,env:b});S.on("error",u),S.on("exit",()=>s())})}}e.$xdc=d;class h extends E{static{this.b=I.localize(3,null)}openTerminal(r,t){return this.spawnTerminal(l,r,t)}runInTerminal(r,t,f,o,s){const u=s.linuxExec?Promise.resolve(s.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((g,b)=>{const S=[];u.then(m=>{m.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const y=`${n(f)}; echo; read -p "${h.b}" -n1;`;S.push(`''${y}''`);const D=Object.assign({},c(process),o);Object.keys(D).filter(T=>D[T]===null).forEach(T=>delete D[T]);const C={cwd:t,env:D};let O="";const z=l.spawn(m,S,C);z.on("error",T=>{b(i(T))}),z.stderr.on("data",T=>{O+=T.toString()}),z.on("exit",T=>{if(T===0)g(void 0);else if(O){const F=O.split(`
`,1);b(new Error(F[0]))}else b(new Error(I.localize(4,null,m,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!h.d)if(!R.$k)h.d=Promise.resolve("xterm");else{const r=await $.Promises.exists("/etc/debian_version");h.d=new Promise(t=>{r?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return h.d}spawnTerminal(r,t,f){const o=t.linuxExec?Promise.resolve(t.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,u)=>{o.then(g=>{const b=c(process),S=r.spawn(g,[],{cwd:f,env:b});S.on("error",u),S.on("exit",()=>s())})})}}e.$ydc=h;function c(a){const r={...a.env};return(0,w.$qm)(r),r}function i(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(I.localize(5,null,a.path)):a}function n(a){let r="";for(const t of a)t.indexOf(" ")>=0?r+='"'+t+'"':r+=t,r+=" ";return r}}),define(ke[33],De([1,0,78,16,14,18,2,215,5,12,15,46]),function(le,e,l,L,M,A,R,w,$,k,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=p,e.$9k=h,e.$0k=i,e.$$k=n,e.$_k=a,e.$al=r,e.$bl=t,e.$cl=f,e.$dl=o,e.$el=s,e.$fl=u,e.$hl=S,e.$il=m,e.$jl=y,e.$kl=D,e.$ll=C,e.$ol=N,e.$Al=K,e.$Bl=x,e.$Dl=ge,e.$7k=(0,$.$Ai)("fileService");function p(oe){return oe.create===!0}var E;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var v;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(v||(e.FilePermission=v={}));var d;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(d||(e.FileChangeFilter=d={}));function h(oe){const Pe=oe;return!!Pe&&typeof Pe.onDidChange=="function"}var c;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function i(oe){return!!(oe.capabilities&2)}function n(oe){return!!(oe.capabilities&8)}function a(oe){return!!(oe.capabilities&131072)}function r(oe){return!!(oe.capabilities&4)}function t(oe){return!!(oe.capabilities&16)}function f(oe){return i(oe)?!!(oe.capabilities&16384):!1}function o(oe){return i(oe)?!!(oe.capabilities&32768):!1}function s(oe){return!!(oe.capabilities&65536)}function u(oe){return!!(oe.capabilities&2048)}var g;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(g||(e.FileSystemProviderErrorCode=g={}));class b extends Error{static create(Pe,me){const U=new b(Pe.toString(),me);return y(U,me),U}constructor(Pe,me){super(Pe),this.code=me}}e.$gl=b;function S(oe,Pe){return b.create(oe,Pe)}function m(oe){return oe||S((0,w.localize)(0,null),g.Unknown)}function y(oe,Pe){return oe.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",oe}function D(oe){if(!oe)return g.Unknown;if(oe instanceof b)return oe.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!Pe)return g.Unknown;switch(Pe[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}function C(oe){if(oe instanceof j)return oe.fileOperationResult;switch(D(oe)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}var O;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class z{constructor(Pe,me,U){this.resource=Pe,this.operation=me,this.target=U}isOperation(Pe){return this.operation===Pe}}e.$ml=z;var T;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class F{static{this.a=null}constructor(Pe,me){this.c=me,this.b=void 0,this.d=new P.$V(()=>{const U=l.$Gi.forUris(()=>this.c);return U.fill(this.rawAdded.map(Y=>[Y,!0])),U}),this.f=new P.$V(()=>{const U=l.$Gi.forUris(()=>this.c);return U.fill(this.rawUpdated.map(Y=>[Y,!0])),U}),this.g=new P.$V(()=>{const U=l.$Gi.forUris(()=>this.c);return U.fill(this.rawDeleted.map(Y=>[Y,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of Pe){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==F.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(Pe,...me){return this.h(Pe,{includeChildren:!1},...me)}affects(Pe,...me){return this.h(Pe,{includeChildren:!0},...me)}h(Pe,me,...U){if(!Pe)return!1;const Y=U.length>0;return!!((!Y||U.includes(1))&&(this.d.value.get(Pe)||me.includeChildren&&this.d.value.findSuperstr(Pe))||(!Y||U.includes(0))&&(this.f.value.get(Pe)||me.includeChildren&&this.f.value.findSuperstr(Pe))||(!Y||U.includes(2))&&(this.g.value.findSubstr(Pe)||me.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$nl=F;function N(oe,Pe,me){return!oe||!Pe||oe===Pe||Pe.length>oe.length?!1:(Pe.charAt(Pe.length-1)!==L.sep&&(Pe+=L.sep),me?(0,M.$Cf)(oe,Pe):oe.indexOf(Pe)===0)}class j extends Error{constructor(Pe,me,U){super(Pe),this.fileOperationResult=me,this.options=U}}e.$pl=j;class B extends j{constructor(Pe,me,U,Y){super(Pe,me,Y),this.fileOperationResult=me,this.size=U}}e.$ql=B;class X extends j{constructor(Pe,me,U){super(Pe,2,U),this.stat=me}}e.$rl=X;var ie;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var H;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$zl="";function K(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function x(oe,Pe){if(!Pe.hasProvider(R.URI.from({scheme:oe.scheme})))return new Promise(me=>{const U=Pe.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===oe.scheme&&Y.added&&(U.dispose(),me())})})}class _{static{this.KB=1024}static{this.MB=_.KB*_.KB}static{this.GB=_.MB*_.KB}static{this.TB=_.GB*_.KB}static formatSize(Pe){return(0,A.$eg)(Pe)||(Pe=0),Pe<_.KB?(0,w.localize)(1,null,Pe.toFixed(0)):Pe<_.MB?(0,w.localize)(2,null,(Pe/_.KB).toFixed(2)):Pe<_.GB?(0,w.localize)(3,null,(Pe/_.MB).toFixed(2)):Pe<_.TB?(0,w.localize)(4,null,(Pe/_.GB).toFixed(2)):(0,w.localize)(5,null,(Pe/_.TB).toFixed(2))}}e.$Cl=_;function ge(oe){const Pe=typeof oe=="string"||oe?.scheme===I.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===I.Schemas.file?1024*_.MB:Pe?10*_.MB:k.$o?50*_.MB:1024*_.MB}}),define(ke[257],De([1,0,22,13,216,33]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=R;async function R(I,P,p,E,v,d){let h;try{await w(I,P,p,E,v,d)}catch(c){h=c}finally{h&&v.errorTransformer&&(h=v.errorTransformer(h)),typeof h<"u"&&p.error(h),p.end()}}async function w(I,P,p,E,v,d){$(d);const h=await I.open(P,{create:!1});try{$(d);let c=0,i=0,n=v&&typeof v.length=="number"?v.length:void 0,a=l.$Je.alloc(Math.min(v.bufferSize,typeof n=="number"?n:v.bufferSize)),r=v&&typeof v.position=="number"?v.position:0,t=0;do i=await I.read(h,r,a.buffer,t,a.byteLength-t),r+=i,t+=i,c+=i,typeof n=="number"&&(n-=i),t===a.byteLength&&(await p.write(E(a)),a=l.$Je.alloc(Math.min(v.bufferSize,typeof n=="number"?n:v.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(d)&&k(c,v));if(t>0){let f=t;typeof n=="number"&&(f=Math.min(t,n)),p.write(E(a.slice(0,f)))}}catch(c){throw(0,A.$il)(c)}finally{await I.close(h)}}function $(I){if(I.isCancellationRequested)throw(0,L.$6)();return!0}function k(I,P){if(typeof P?.limits?.size=="number"&&I>P.limits.size)throw(0,A.$hl)((0,M.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[65],De([1,0,35,3,16,12,2,33]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0,e.$Pq=$,e.$Qq=k,e.$Uq=E,e.$Vq=v,e.$Wq=d,e.$Xq=h,e.$Yq=i,e.$Zq=n;function $(a){return typeof a.correlationId=="number"}function k(a){return a.recursive===!0}class I extends L.$Uc{static{this.a=3}static{this.b=10}constructor(r,t,f,o){super(),this.m=r,this.n=t,this.r=f,this.s=o,this.f=this.B(new L.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const r=new L.$Tc;this.f.value=r,this.c=this.t(r),this.c.setVerboseLogging(this.r),r.add(this.c.onDidChangeFile(t=>this.m(t))),r.add(this.c.onDidLogMessage(t=>this.n(t))),r.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(r,t){if(this.s.restartOnError&&this.g?.length)if(t){const f=this.h.get(t.path)??0;f<I.a?(this.z(`restarting watcher from error in watch request (retrying request): ${r} (${JSON.stringify(t)})`),this.h.set(t.path,f+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${r} (${JSON.stringify(t)})`),this.y(this.g.filter(o=>o.path!==t.path)))}else this.j<I.b?(this.z(`restarting watcher after unknown global error: ${r}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${r}`);else this.z(r)}y(r){this.u(),this.watch(r)}async watch(r){this.g=r,await this.c?.watch(r)}async setVerboseLogging(r){this.r=r,await this.c?.setVerboseLogging(r)}z(r){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${r}`})}C(r){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${r}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Rq=I;class P extends I{constructor(r,t,f){super(r,t,f,{type:"node.js",restartOnError:!1})}}e.$Sq=P;class p extends I{constructor(r,t,f){super(r,t,f,{type:"universal",restartOnError:!0})}}e.$Tq=p;function E(a){return a.map(r=>({type:r.type,resource:R.URI.revive(r.resource),cId:r.cId}))}function v(a){const r=new c;for(const t of a)r.processEvent(t);return r.coalesce()}function d(a,r){return typeof r=="string"&&!r.startsWith(l.$qk)&&!(0,M.$ic)(r)?{base:a,pattern:r}:r}function h(a,r){const t=[];for(const f of r)t.push((0,l.$uk)(d(a,f)));return t}class c{constructor(){this.a=new Set,this.b=new Map}c(r){return A.$k?r.resource.fsPath:r.resource.fsPath.toLowerCase()}processEvent(r){const t=this.b.get(this.c(r));let f=!1;if(t){const o=t.type,s=r.type;t.resource.fsPath!==r.resource.fsPath&&(r.type===2||r.type===1)?f=!0:o===1&&s===2?(this.b.delete(this.c(r)),this.a.delete(t)):o===2&&s===1?t.type=0:o===1&&s===0||(t.type=s)}else f=!0;f&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],t=[];return Array.from(this.a).filter(f=>f.type!==2?(r.push(f),!1):!0).sort((f,o)=>f.resource.fsPath.length-o.resource.fsPath.length).filter(f=>t.some(o=>(0,w.$ol)(f.resource.fsPath,o,!A.$k))?!1:(t.push(f.resource.fsPath),!0)).concat(r)}}function i(a,r){if(typeof r=="number")switch(a.type){case 1:return(r&4)===0;case 2:return(r&8)===0;case 0:return(r&2)===0}return!1}function n(a){if(typeof a=="number"){const r=[];return a&4&&r.push("Added"),a&8&&r.push("Deleted"),a&2&&r.push("Updated"),r.length===0?"<all>":`[${r.join(", ")}]`}return"<none>"}}),define(ke[258],De([1,0,54,3,65,4,2,7]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class $ extends L.$Uc{constructor(){super(),this.a=this.B(new A.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new L.$4c),this.m=new Set,this.n=5007,this.r=new w.$Xh,this.P=!1,this.B(this.f(I=>this.s(I)))}s(I){this.t(I)&&this.w(I)}t(I){return(0,M.$Pq)(I)}async watch(I){this.r.isSettled||this.r.complete(),this.r=new w.$Xh;try{this.h.clear(),this.g.clear();for(const P of I)this.t(P)?this.h.set(P.correlationId,P):this.g.add(P);for(const[P]of this.j)this.h.has(P)||(this.j.deleteAndDispose(P),this.m.delete(P));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(I=>!this.j.has(I.correlationId))])}isSuspended(I){return typeof I.correlationId!="number"?!1:this.m.has(I.correlationId)?"polling":this.j.has(I.correlationId)}async w(I){if(this.j.has(I.correlationId))return;const P=new L.$Tc;this.j.set(I.correlationId,P),await this.r.p,!P.isDisposed&&(this.z(I,P),this.u())}y(I){this.j.deleteAndDispose(I.correlationId),this.m.delete(I.correlationId),this.u()}z(I,P){this.C(I,P)?(this.N(`reusing an existing recursive watcher to monitor ${I.path}`),this.m.delete(I.correlationId)):(this.D(I,P),this.m.add(I.correlationId))}C(I,P){const p=this.M?.subscribe(I.path,(E,v)=>{P.isDisposed||(E?this.z(I,P):v?.type===1&&this.F(I))});return p?(P.add(p),!0):!1}D(I,P){let p=!1;const E=(v,d)=>{if(P.isDisposed)return;const h=this.G(v),c=this.G(d),i=p;p=h,!h&&(c||i)&&this.F(I)};this.N(`starting fs.watchFile() on ${I.path} (correlationId: ${I.correlationId})`);try{(0,l.watchFile)(I.path,{persistent:!1,interval:this.n},E)}catch(v){this.O(`fs.watchFile() failed with error ${v} on path ${I.path} (correlationId: ${I.correlationId})`)}P.add((0,L.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${I.path} (correlationId: ${I.correlationId})`);try{(0,l.unwatchFile)(I.path,E)}catch(v){this.O(`fs.unwatchFile() failed with error ${v} on path ${I.path} (correlationId: ${I.correlationId})`)}}))}F(I){this.N(`detected ${I.path} exists again, resuming watcher (correlationId: ${I.correlationId})`);const P={resource:R.URI.file(I.path),type:1,cId:I.correlationId};this.a.fire([P]),this.H(P,I),this.y(I)}G(I){return I.ctimeMs===0&&I.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(I,P){if(this.P){const p=` >> normalized ${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`;this.I(p,P)}}I(I,P){this.P&&this.N(`${I}${typeof P.correlationId=="number"?` <${P.correlationId}> `:""}`)}J(I){return`${I.path} (excludes: ${I.excludes.length>0?I.excludes:"<none>"}, includes: ${I.includes&&I.includes.length>0?JSON.stringify(I.includes):"<all>"}, filter: ${(0,M.$Zq)(I.filter)}, correlationId: ${typeof I.correlationId=="number"?I.correlationId:"<none>"})`}async setVerboseLogging(I){this.P=I}}e.$9q=$}),define(ke[259],De([1,0,54,7,21,31,3,77,16,12,23,2,104,32,65]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0,e.$cr=h;class d extends R.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,n,a,r,t,f){super(),this.s=i,this.t=n,this.u=a,this.w=r,this.y=t,this.z=f,this.c=this.B(new L.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.u(o))),this.f=this.B(new L.$Oh(o=>this.M(o),d.b)),this.g=(0,v.$Xq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,v.$Xq)(this.s.path,this.s.includes):void 0,this.j=(0,v.$Pq)(this.s)?this.s.filter:void 0,this.m=new M.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const n=await E.Promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let n=i.path;try{n=await E.Promises.realpath(i.path),i.path===n&&(n=await(0,p.$$q)(i.path,this.m.token)??i.path),i.path!==n&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async G(i,n){const a=new R.$Tc;return this.H(i,n,a)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,n,a)),a}H(i,n,a){if(n)return!1;const r=P.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(f,o)=>{if(!a.isDisposed)if(f){const s=await this.G(i,n);a.isDisposed?s.dispose():a.add(s)}else o&&(typeof o.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:r,type:o.type,cId:this.s.correlationId},!0)});return t?(a.add(t),!0):!1}async I(i,n,a){if(k.$j&&(0,A.$zg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const r=new M.$se(this.m.token);a.add((0,R.$Sc)(()=>r.dispose(!0)));const t=new R.$Tc;a.add(t);try{const f=P.URI.file(this.s.path),o=(0,$.$nc)(i),s=(0,l.watch)(i);t.add((0,R.$Sc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const b of await E.Promises.readdir(i))u.add(b)}catch(b){this.O(b)}if(r.token.isCancellationRequested)return;const g=new Map;t.add((0,R.$Sc)(()=>{for(const[,b]of g)b.dispose();g.clear()})),s.on("error",(b,S)=>{r.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${b}, ${S})`),this.D())}),s.on("change",(b,S)=>{if(r.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${b}"] ${S}`);let m="";if(S&&(m=S.toString(),k.$j&&(m=(0,w.$fm)(m))),!(!m||b!=="change"&&b!=="rename"))if(n)if(b==="rename"){g.get(m)?.dispose();const y=setTimeout(async()=>{if(g.delete(m),m===o&&!await E.Promises.exists(i)){this.J(f);return}if(r.token.isCancellationRequested)return;const D=await this.N((0,$.$jc)(i,m));if(r.token.isCancellationRequested)return;let C;D?u.has(m)?C=0:(C=1,u.add(m)):(u.delete(m),C=2),this.L({resource:(0,I.$bh)(f,m),type:C,cId:this.s.correlationId})},d.a);g.set(m,(0,R.$Sc)(()=>clearTimeout(y)))}else{let y;u.has(m)?y=0:(y=1,u.add(m)),this.L({resource:(0,I.$bh)(f,m),type:y,cId:this.s.correlationId})}else if(b==="rename"||m!==o){const y=setTimeout(async()=>{const D=await E.Promises.exists(i);r.token.isCancellationRequested||(D?(this.L({resource:f,type:0,cId:this.s.correlationId},!0),t.add(await this.G(i,!1))):this.J(f))},d.a);t.clear(),t.add((0,R.$Sc)(()=>clearTimeout(y)))}else this.L({resource:f,type:0,cId:this.s.correlationId},!0)})}catch(f){r.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${f.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,n=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(a=>a(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(a=>a(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const n=(0,v.$Vq)(i),a=[];for(const t of n){if((0,v.$Yq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}a.push(t)}if(a.length===0)return;if(this.z)for(const t of a)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(a)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(k.$k)return E.Promises.exists(i);try{const n=(0,$.$nc)(i);return(await E.Promises.readdir((0,$.$mc)(i))).some(r=>r===n)}catch(n){return this.Q(n),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$br=d;async function h(c,i,n,a,r=512){const t=await E.Promises.open(c,"r"),f=Buffer.allocUnsafe(r),o=new M.$se(a);let s,u=!1;const g={path:c,excludes:[],recursive:!1},b=new d(g,void 0,S=>{(async()=>{for(const{type:m}of S)if(m===0){if(u)return;u=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:y}=await E.Promises.read(t,f,0,r,null);if(!y||o.token.isCancellationRequested)break;i(f.slice(0,y))}}catch(y){s=new Error(y),o.dispose(!0)}finally{u=!1}}})()});return await b.ready,n(),new Promise((S,m)=>{o.token.onCancellationRequested(async()=>{b.dispose();try{await E.Promises.close(t)}catch(y){s=new Error(y)}s?m(s):S()})})}}),define(ke[260],De([1,0,4,35,258,12,259,31]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class $ extends M.$9q{constructor(I){super(),this.M=I,this.onDidError=l.Event.None,this.watchers=new Set}async L(I){I=this.X(I);const P=[],p=new Set(Array.from(this.watchers));for(const E of I){const v=this.S(E);v&&(0,L.$yk)(v.request.excludes,E.excludes)&&(0,L.$yk)(v.request.includes,E.includes)?p.delete(v):P.push(E)}P.length&&this.N(`Request to start watching: ${P.map(E=>this.J(E)).join(",")}`),p.size&&this.N(`Request to stop watching: ${Array.from(p).map(E=>this.J(E.request)).join(",")}`);for(const E of p)this.W(E);for(const E of P)this.U(E)}S(I){for(const P of this.watchers)if(typeof I.correlationId=="number"||typeof P.request.correlationId=="number"){if(P.request.correlationId===I.correlationId)return P}else if((0,w.$yg)(P.request.path,I.path,!A.$k))return P}U(I){const P=new R.$br(I,this.M,E=>this.a.fire(E),()=>this.c.fire(I),E=>this.b.fire(E),this.P),p={request:I,instance:P};this.watchers.add(p)}async stop(){await super.stop();for(const I of this.watchers)this.W(I)}W(I){this.N("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}X(I){const P=new Map;for(const p of I){const E=A.$k?p.path:p.path.toLowerCase();let v=P.get(p.correlationId);v||(v=new Map,P.set(p.correlationId,v)),v.has(E)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(p)}`),v.set(E,p)}return Array.from(P.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const P of this.watchers)P.instance.setVerboseLogging(I)}N(I,P){this.P&&this.b.fire({type:"trace",message:this.$(I,P)})}O(I){this.b.fire({type:"warn",message:this.$(I)})}$(I,P){return P?`[File Watcher (node.js)] ${I} (${this.J(P.request)})`:`[File Watcher (node.js)] ${I}`}}e.$dr=$}),define(ke[261],De([1,0,65,260]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;class M extends l.$Sq{constructor(R,w,$){super(R,w,$),this.u()}t(R){return R.add(new L.$dr(void 0))}}e.$er=M}),define(ke[262],De([1,0,15,82,199,65]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class R extends A.$Tq{constructor($,k,I){super($,k,I),this.u()}t($){const k=$.add(new M.$7q(l.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(k.onDidProcessExit(({code:I,signal:P})=>this.w(`terminated by itself with code ${I}, signal: ${P} (ETERM)`))),L.ProxyChannel.toService((0,L.$hi)(k.getChannel("watcher")))}}e.$8q=R}),define(ke[107],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class l{constructor(...M){this.a=new Map;for(const[A,R]of M)this.set(A,R)}set(M,A){const R=this.a.get(M);return this.a.set(M,A),R}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$yi=l}),define(ke[263],De([1,0,7,13,3,106,253,5,107,76]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;const I=!1;class P extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class p{constructor(h=new $.$yi,c=!1,i,n=I){this.i=h,this.j=c,this.k=i,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(w.$zi,this),this._globalGraph=n?i?._globalGraph??new R.$hr(a=>a):void 0}dispose(){if(!this.f){this.f=!0,(0,M.$Pc)(this.h),this.h.clear();for(const h of this.g)(0,M.$Oc)(h)&&h.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(h,c){this.m();const i=new class extends p{dispose(){this.h.delete(i),super.dispose()}}(h,this.j,this,this.l);return this.h.add(i),c?.add(i),i}invokeFunction(h,...c){this.m();const i=v.traceInvocation(this.l,h);let n=!1;try{return h({get:r=>{if(n)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(r,i);if(!t)throw new Error(`[invokeFunction] unknown service '${r}'`);return t}},...c)}finally{n=!0,i.stop()}}createInstance(h,...c){this.m();let i,n;return h instanceof A.$xi?(i=v.traceCreation(this.l,h.ctor),n=this.o(h.ctor,h.staticArguments.concat(c),i)):(i=v.traceCreation(this.l,h),n=this.o(h,c,i)),i.stop(),n}o(h,c=[],i){const n=w._util.getServiceDependencies(h).sort((t,f)=>t.index-f.index),a=[];for(const t of n){const f=this.s(t.id,i);f||this.y(`[createInstance] ${h.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(f)}const r=n.length>0?n[0].index:c.length;if(c.length!==r){console.trace(`[createInstance] First service dependency of ${h.name} at position ${r+1} conflicts with ${c.length} static arguments`);const t=r-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,r)}return Reflect.construct(h,c.concat(a))}q(h,c){if(this.i.get(h)instanceof A.$xi)this.i.set(h,c);else if(this.k)this.k.q(h,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(h){const c=this.i.get(h);return!c&&this.k?this.k.r(h):c}s(h,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const i=this.r(h);return i instanceof A.$xi?this.u(h,i,c.branch(h,!0)):(c.branch(h,!1),i)}u(h,c,i){if(this.t.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.t.add(h);try{return this.v(h,c,i)}finally{this.t.delete(h)}}v(h,c,i){const n=new R.$hr(t=>t.id.toString());let a=0;const r=[{id:h,desc:c,_trace:i}];for(;r.length;){const t=r.pop();if(n.lookupOrInsertNode(t),a++>1e3)throw new P(n);for(const f of w._util.getServiceDependencies(t.desc.ctor)){const o=this.r(f.id);if(o||this.y(`[createInstance] ${h} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),o instanceof A.$xi){const s={id:f.id,desc:o,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,s),r.push(s)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new P(n);break}for(const{data:f}of t){if(this.r(f.id)instanceof A.$xi){const s=this.w(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.q(f.id,s)}n.removeNode(f)}}return this.r(h)}w(h,c,i=[],n,a){if(this.i.get(h)instanceof A.$xi)return this.x(h,c,i,n,a,this.g);if(this.k)return this.k.w(h,c,i,n,a);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(h,c,i=[],n,a,r){if(n){const t=new p(void 0,this.j,this,this.l);t.c=String(h);const f=new Map,o=new l.$Th(()=>{const s=t.o(c,i,a);for(const[u,g]of f){const b=s[u];if(typeof b=="function")for(const S of g)S.disposable=b.apply(s,S.listener)}return f.clear(),r.add(s),s});return new Proxy(Object.create(null),{get(s,u){if(!o.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let S=f.get(u);return S||(S=new k.$5c,f.set(u,S)),(y,D,C)=>{if(o.isInitialized)return o.value[u](y,D,C);{const O={listener:[y,D,C],disposable:void 0},z=S.push(O);return(0,M.$Sc)(()=>{z(),O.disposable?.dispose()})}}}if(u in s)return s[u];const g=o.value;let b=g[u];return typeof b!="function"||(b=b.bind(g),s[u]=b),b},set(s,u,g){return o.value[u]=g,!0},getPrototypeOf(s){return c.prototype}})}else{const t=this.o(c,i,a);return r.add(t),t}}y(h,c){if(c&&console.warn(h),this.j)throw new Error(h)}}e.$ir=p;var E;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(E||(E={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(h,c){return h?new v(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(h,c){return h?new v(1,c.name):v.c}static{this.f=0}constructor(h,c){this.type=h,this.name=c,this.g=Date.now(),this.h=[]}branch(h,c){const i=new v(3,h.toString());return this.h.push([h,c,i]),i}stop(){const h=Date.now()-this.g;v.f+=h;let c=!1;function i(a,r){const t=[],f=new Array(a+1).join("	");for(const[o,s,u]of r.h)if(s&&u){c=!0,t.push(`${f}CREATES -> ${o}`);const g=i(a+1,u);g&&t.push(g)}else t.push(`${f}uses -> ${o}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(h>2||c)&&v.all.add(n.join(`
`))}}e.$jr=v}),define(ke[11],De([1,0,218,47,4,58,3,27,12,23,18,2,38,5]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=d,e.log=c,e.$ik=b,e.$jk=S,e.$kk=m,e.$lk=y,e.$7j=(0,E.$Ai)("logService"),e.$8j=(0,E.$Ai)("loggerService");function v(){return new Date().toISOString()}function d(D){return(0,I.$eg)(D)}var h;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(h||(e.LogLevel=h={})),e.$0j=h.Info;function c(D,C,O){switch(C){case h.Trace:D.trace(O);break;case h.Debug:D.debug(O);break;case h.Info:D.info(O);break;case h.Warning:D.warn(O);break;case h.Error:D.error(O);break;case h.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function i(D,C=!1){let O="";for(let z=0;z<D.length;z++){let T=D[z];if(T instanceof Error&&(T=(0,L.$lj)(T,C)),typeof T=="object")try{T=JSON.stringify(T)}catch{}O+=(z>0?" ":"")+T}return O}class n extends R.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new M.$he),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==h.Off&&this.b<=C}}e.$_j=n;class a extends n{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...O){this.f(h.Trace)&&this.g(h.Trace,i([C,...O],!0))}debug(C,...O){this.f(h.Debug)&&this.g(h.Debug,i([C,...O]))}info(C,...O){this.f(h.Info)&&this.g(h.Info,i([C,...O]))}warn(C,...O){this.f(h.Warning)&&this.g(h.Warning,i([C,...O]))}error(C,...O){if(this.f(h.Error))if(C instanceof Error){const z=Array.prototype.slice.call(arguments);z[0]=C.stack,this.g(h.Error,i(z))}else this.g(h.Error,i([C,...O]))}flush(){}}e.$ak=a;class r extends n{constructor(C=e.$0j){super(),this.setLevel(C),this.g=!$.$i}trace(C,...O){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...O):console.log(`[main ${v()}]`,C,...O))}debug(C,...O){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...O):console.log(`[main ${v()}]`,C,...O))}info(C,...O){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,C,...O):console.log(`[main ${v()}]`,C,...O))}warn(C,...O){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,C,...O):console.warn(`[main ${v()}]`,C,...O))}error(C,...O){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,C,...O):console.error(`[main ${v()}]`,C,...O))}flush(){}}e.$bk=r;class t extends n{constructor(C=e.$0j,O=!0){super(),this.g=O,this.setLevel(C)}trace(C,...O){this.f(h.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...O):console.log(C,...O))}debug(C,...O){this.f(h.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...O):console.log(C,...O))}info(C,...O){this.f(h.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...O):console.log(C,...O))}warn(C,...O){this.f(h.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...O):console.log(C,...O))}error(C,...O){this.f(h.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...O):console.error(C,...O))}flush(){}}e.$ck=t;class f extends n{constructor(C,O=e.$0j){super(),this.g=C,this.setLevel(O)}trace(C,...O){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(C),...O])}debug(C,...O){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(C),...O])}info(C,...O){this.f(h.Info)&&this.g.log(h.Info,[this.h(C),...O])}warn(C,...O){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(C),...O])}error(C,...O){this.f(h.Error)&&this.g.log(h.Error,[this.h(C),...O])}h(C){return typeof C=="string"?C:(0,L.$lj)(C,this.f(h.Trace))}flush(){}}e.$dk=f;class o extends n{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const O of this.g)O.setLevel(C);super.setLevel(C)}trace(C,...O){for(const z of this.g)z.trace(C,...O)}debug(C,...O){for(const z of this.g)z.debug(C,...O)}info(C,...O){for(const z of this.g)z.info(C,...O)}warn(C,...O){for(const z of this.g)z.warn(C,...O)}error(C,...O){for(const z of this.g)z.error(C,...O)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ek=o;class s extends R.$Uc{constructor(C,O,z){if(super(),this.h=C,this.j=O,this.b=new w.$Ac,this.c=this.B(new M.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$he),this.onDidChangeVisibility=this.g.event,z)for(const T of z)this.b.set(T.resource,{logger:void 0,info:T})}m(C){return(0,I.$ag)(C)?[...this.b.values()].find(O=>O.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,O){const z=this.n(C),T=(0,I.$ag)(C)?C:O?.id??(0,A.$oj)(z.toString()).toString(16);let F=this.b.get(z)?.logger;const N=O?.logLevel==="always"?h.Trace:O?.logLevel;F||(F=this.s(z,N??this.getLogLevel(z)??this.h,{...O,id:T}));const j={logger:F,info:{resource:z,id:T,logLevel:N,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(j.info),this.b.set(z,j),F}n(C){return(0,I.$ag)(C)?(0,k.$bh)(this.j,`${C}.log`):C}setLogLevel(C,O){if(P.URI.isUri(C)){const z=C,T=O,F=this.b.get(z);F&&T!==F.info.logLevel&&(F.info.logLevel=T===this.h?void 0:T,F.logger?.setLevel(T),this.b.set(F.info.resource,F),this.f.fire([z,T]))}else{this.h=C;for(const[z,T]of this.b.entries())this.b.get(z)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,O){const z=this.m(C);z&&O!==!z.info.hidden&&(z.info.hidden=!O,this.b.set(z.info.resource,z),this.g.fire([z.info.resource,O]))}getLogLevel(C){let O;return C&&(O=this.b.get(C)?.info.logLevel),O??this.h}registerLogger(C){const O=this.b.get(C.resource);O?O.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const O=this.b.get(C);O&&(O.logger&&O.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=s;class u{constructor(){this.onDidChangeLogLevel=new M.$he().event}setLevel(C){}getLevel(){return h.Info}trace(C,...O){}debug(C,...O){}info(C,...O){}warn(C,...O){}error(C,...O){}critical(C,...O){}dispose(){}flush(){}}e.$gk=u;class g extends u{}e.$hk=g;function b(D){if(D.verbose)return h.Trace;if(typeof D.logLevel=="string"){const C=y(D.logLevel.toLowerCase());if(C!==void 0)return C}return e.$0j}function S(D){switch(D){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}function m(D){switch(D){case h.Trace:return{original:"Trace",value:l.localize(0,null)};case h.Debug:return{original:"Debug",value:l.localize(1,null)};case h.Info:return{original:"Info",value:l.localize(2,null)};case h.Warning:return{original:"Warning",value:l.localize(3,null)};case h.Error:return{original:"Error",value:l.localize(4,null)};case h.Off:return{original:"Off",value:l.localize(5,null)}}}function y(D){switch(D){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.$mk=new p.$Rj("logLevel",S(h.Info))}),define(ke[264],De([1,0,19,7,13,4,31,3,16,65,11]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;class P extends w.$Uc{constructor(E,v){super(),this.a=E,this.b=v,this.c=this.B(new A.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$yh(0)),this.w=[],this.y=this.B(new L.$yh(0))}watch(E,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(E,v):this.z(E,v)}n(E,v){const d={path:this.J(E),excludes:v.excludes,includes:v.includes,recursive:v.recursive,filter:v.filter,correlationId:v.correlationId},h=(0,l.$Tb)(this.j,d);return this.r(),(0,w.$Sc)(()=>{h(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(E=>(0,M.$1)(E))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,k.$Uq)(v)),v=>this.G(v),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const E=this.b?.watcher?.recursive?.usePolling;if(E===!0)for(const v of this.j)(0,k.$Qq)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const v of this.j)(0,k.$Qq)(v)&&E.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(E,v){const d={path:this.J(E),excludes:v.excludes,includes:v.includes,recursive:!1,filter:v.filter,correlationId:v.correlationId},h=(0,l.$Tb)(this.w,d);return this.C(),(0,w.$Sc)(()=>{h(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(E=>(0,M.$1)(E))}D(){return this.u||(this.u=this.B(this.F(E=>this.c.fire((0,k.$Uq)(E)),E=>this.G(E),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(E){E.type==="error"&&this.g.fire(E.message),this.H(E)}H(E){this.a[E.type](E.message)}I(E){return(0,$.$hc)(E.fsPath)}J(E){const v=this.I(E);return(0,R.$Cg)(v)}}e.$1q=P}),define(ke[265],De([1,0,54,402,7,27,22,4,31,3,16,12,23,98,32,217,33,257,264,47,262,261]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0,(()=>{try{(0,L.gracefulify)(l)}catch(f){console.error(`Error enabling graceful-fs: ${(0,n.$lj)(f)}`)}})();class t extends i.$1q{static{this.L=!1}constructor(o,s){super(o,s),this.onDidChangeCapabilities=w.Event.None,this.P=new A.$Ac(u=>p.$5g.getComparisonKey(u)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,P.$k&&(this.M|=1024)),this.M}async stat(o){try{const{stat:s,symbolicLink:u}=await v.SymlinkSupport.stat(this.I(o));return{type:this.O(s,u),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:h.FilePermission.Locked}}catch(s){throw this.hb(s)}}async N(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const s=await v.Promises.readdir(this.I(o),{withFileTypes:!0}),u=[];return await Promise.all(s.map(async g=>{try{let b;g.isSymbolicLink()?b=(await this.stat((0,p.$bh)(o,g.name))).type:b=this.O(g),u.push([g.name,b])}catch(b){this.a.trace(b)}})),u}catch(s){throw this.hb(s)}}O(o,s){let u;return s?.dangling?u=h.FileType.Unknown:o.isFile()?u=h.FileType.File:o.isDirectory()?u=h.FileType.Directory:u=h.FileType.Unknown,s&&(u|=h.FileType.SymbolicLink),u}async Q(o){const s=this.I(o);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let u;for(;u=this.P.get(o);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await u.wait();const g=new M.$zh;return this.P.set(o,g),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,k.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.P.get(o)===g&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.P.delete(o)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),g.open()})}async readFile(o,s){let u;try{s?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(o)})`),u=await this.Q(o));const g=this.I(o);return await v.Promises.readFile(g)}catch(g){throw this.hb(g)}finally{u?.dispose()}}R(o){t.L&&this.a.trace(o)}readFileStream(o,s,u){const g=(0,E.$xe)(b=>R.$Je.concat(b.map(S=>R.$Je.wrap(S))).buffer);return(0,c.$Nq)(this,o,g,b=>b.buffer,{...s,bufferSize:256*1024},u),g}async writeFile(o,s,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.S(o)?this.U(o,(0,p.$bh)((0,p.$ah)(o),`${(0,p.$$g)(o)}${u.atomic.postfix}`),s,u):this.W(o,s,u)}async S(o){try{const s=this.I(o),{symbolicLink:u}=await v.SymlinkSupport.stat(s);if(u)return!1}catch{}return!0}async U(o,s,u,g){const b=new k.$Tc;try{b.add(await this.Q(o)),b.add(await this.Q(s)),await this.W(s,u,g,!0);try{await this.rename(s,o,{overwrite:!0})}catch(S){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{b.dispose()}}async W(o,s,u,g){let b;try{const S=this.I(o);if(!u.create||!u.overwrite){if(await v.Promises.exists(S)){if(!u.overwrite)throw(0,h.$hl)((0,d.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,h.$hl)((0,d.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(o,{create:!0,unlock:u.unlock},g),await this.write(b,0,s,0,s.byteLength)}catch(S){throw await this.ib(o,S)}finally{typeof b=="number"&&await this.close(b)}}static{this.$=!0}static configureFlushOnWrite(o){t.$=o}async open(o,s,u){const g=this.I(o);let b;(0,h.$8k)(s)&&!u&&(b=await this.Q(o));let S;try{if((0,h.$8k)(s)&&s.unlock)try{const{stat:y}=await v.SymlinkSupport.stat(g);y.mode&128||await v.Promises.chmod(g,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let m;if((0,h.$8k)(s)){if(P.$i)try{await v.Promises.truncate(g,0),m="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}m||(m="w")}else m="r";S=await v.Promises.open(g,m)}catch(m){throw b?.dispose(),(0,h.$8k)(s)?await this.ib(o,m):this.hb(m)}if(this.X.set(S,0),(0,h.$8k)(s)&&this.Z.set(S,o),b){const m=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${g})`),this.Y.set(S,b),m&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${g})`),m.dispose())}return S}async close(o){const s=this.Y.get(o);try{if(this.X.delete(o),this.Z.delete(o)&&t.$)try{await v.Promises.fdatasync(o)}catch(u){t.configureFlushOnWrite(!1),this.a.error(u)}return await v.Promises.close(o)}catch(u){throw this.hb(u)}finally{s&&(this.Y.get(o)===s&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.Y.delete(o)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),s.dispose())}}async read(o,s,u,g,b){const S=this.ab(o,s);let m=null;try{m=(await v.Promises.read(o,u,g,b,S)).bytesRead}catch(y){throw this.hb(y)}finally{this.bb(o,S,m)}return m}ab(o,s){return s===this.X.get(o)?null:s}bb(o,s,u){const g=this.X.get(o);typeof g=="number"&&(typeof s=="number"||(typeof u=="number"?this.X.set(o,g+u):this.X.delete(o)))}async write(o,s,u,g,b){return(0,M.$Uh)(()=>this.cb(o,s,u,g,b),100,3)}async cb(o,s,u,g,b){const S=this.ab(o,s);let m=null;try{m=(await v.Promises.write(o,u,g,b,S)).bytesWritten}catch(y){throw await this.ib(this.Z.get(o),y)}finally{this.bb(o,S,m)}return m}async mkdir(o){try{await v.Promises.mkdir(this.I(o))}catch(s){throw this.hb(s)}}async delete(o,s){try{const u=this.I(o);if(s.recursive){let g;s?.atomic!==!1&&s.atomic.postfix&&(g=(0,I.$jc)((0,I.$mc)(u),`${(0,I.$nc)(u)}${s.atomic.postfix}`)),await v.Promises.rm(u,v.RimRafMode.MOVE,g)}else try{await v.Promises.unlink(u)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let b=!1;try{const{stat:S,symbolicLink:m}=await v.SymlinkSupport.stat(u);b=S.isDirectory()&&!m}catch{}if(b)await v.Promises.rmdir(u);else throw g}else throw g}}catch(u){throw this.hb(u)}}async rename(o,s,u){const g=this.I(o),b=this.I(s);if(g!==b)try{await this.db(o,s,"move",u.overwrite),await v.Promises.rename(g,b)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,d.localize)(2,null,(0,I.$nc)(g),(0,I.$nc)((0,I.$mc)(b)),S.toString()))),this.hb(S)}}async copy(o,s,u){const g=this.I(o),b=this.I(s);if(g!==b)try{await this.db(o,s,"copy",u.overwrite),await v.Promises.copy(g,b,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,d.localize)(3,null,(0,I.$nc)(g),(0,I.$nc)((0,I.$mc)(b)),S.toString()))),this.hb(S)}}async db(o,s,u,g){const b=this.I(o),S=this.I(s);let m=!1;if(!!(this.capabilities&1024)||(m=(0,$.$yg)(b,S,!0)),m){if(u==="copy")throw(0,h.$hl)((0,d.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const D=await this.N(o);if(!D)throw(0,h.$hl)((0,d.localize)(5,null),h.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(s);if(C){if(!g)throw(0,h.$hl)((0,d.localize)(6,null),h.FileSystemProviderErrorCode.FileExists);D.type&h.FileType.File&&C.type&h.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,s){return this.eb(o,s,!1)}async eb(o,s,u){const g=this.I(o),b=this.I(s),S=!!(this.capabilities&1024);if((0,$.$yg)(g,b,!S))return;const m=new k.$Tc;try{m.add(await this.Q(o)),m.add(await this.Q(s)),u&&await v.Promises.mkdir((0,I.$mc)(b),{recursive:!0}),await v.Promises.copyFile(g,b)}catch(y){if(y.code==="ENOENT"&&!u)return this.eb(o,s,!0);throw this.hb(y)}finally{m.dispose()}}t(o,s,u){return new a.$8q(g=>o(g),g=>s(g),u)}F(o,s,u){return new r.$er(g=>o(g),g=>s(g),u)}hb(o){if(o instanceof h.$gl)return o;let s=o,u;switch(o.code){case"ENOENT":u=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=h.FileSystemProviderErrorCode.Unknown;break;default:u=h.FileSystemProviderErrorCode.Unknown}return(0,h.$hl)(s,u)}async ib(o,s){let u=this.hb(s);if(o&&u.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await v.SymlinkSupport.stat(this.I(o));g.mode&128||(u=(0,h.$hl)(s,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return u}}e.$fr=t}),define(ke[266],De([1,0,3,11]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;class M extends l.$Uc{constructor(R,w=[]){super(),this.a=new L.$ek([R,...w]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...w){this.a.trace(R,...w)}debug(R,...w){this.a.debug(R,...w)}info(R,...w){this.a.info(R,...w)}warn(R,...w){this.a.warn(R,...w)}error(R,...w){this.a.error(R,...w)}flush(){this.a.flush()}}e.$fQ=M}),define(ke[267],De([1,0,33,11]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=void 0;var M;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(M||(M={}));async function A(k,I,P,p,E){try{const v=await new Promise((h,c)=>{le(["@vscode/spdlog"],h,c)});v.setFlushOn(M.Trace);const d=await v.createAsyncRotatingLogger(k,I,P,p);return E?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(v){console.error(v)}return null}function R(k,I,P){switch(I){case L.LogLevel.Trace:k.trace(P);break;case L.LogLevel.Debug:k.debug(P);break;case L.LogLevel.Info:k.info(P);break;case L.LogLevel.Warning:k.warn(P);break;case L.LogLevel.Error:k.error(P);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function w(k,I){switch(I){case L.LogLevel.Trace:k.setLevel(M.Trace);break;case L.LogLevel.Debug:k.setLevel(M.Debug);break;case L.LogLevel.Info:k.setLevel(M.Info);break;case L.LogLevel.Warning:k.setLevel(M.Warning);break;case L.LogLevel.Error:k.setLevel(M.Error);break;case L.LogLevel.Off:k.setLevel(M.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class $ extends L.$ak{constructor(I,P,p,E,v){super(),this.m=[],this.setLevel(v),this.n=this.s(I,P,p,E),this.B(this.onDidChangeLogLevel(d=>{this.r&&w(this.r,d)}))}async s(I,P,p,E){const v=p?6:1,d=30/v*l.$Cl.MB,h=await A(I,P,d,v,E);if(h){this.r=h,w(this.r,this.getLevel());for(const{level:c,message:i}of this.m)R(this.r,c,i);this.m=[]}}g(I,P){this.r?R(this.r,I,P):this.getLevel()<=I&&this.m.push({level:I,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$7P=$}),define(ke[139],De([1,0,41,219,5]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function k(v,d){return d-v}$.compare=k;const I=Object.create(null);I[$.Error]=(0,L.localize)(0,null),I[$.Warning]=(0,L.localize)(1,null),I[$.Info]=(0,L.localize)(2,null);function P(v){return I[v]||""}$.toString=P;function p(v){switch(v){case l.default.Error:return $.Error;case l.default.Warning:return $.Warning;case l.default.Info:return $.Info;case l.default.Ignore:return $.Hint}}$.fromSeverity=p;function E(v){switch(v){case $.Error:return l.default.Error;case $.Warning:return l.default.Warning;case $.Info:return l.default.Info;case $.Hint:return l.default.Ignore}}$.toSeverity=E}(R||(e.MarkerSeverity=R={}));var w;(function($){const k="";function I(p){return P(p,!0)}$.makeKey=I;function P(p,E){const v=[k];return p.source?v.push(p.source.replace("\xA6","\\\xA6")):v.push(k),p.code?typeof p.code=="string"?v.push(p.code.replace("\xA6","\\\xA6")):v.push(p.code.value.replace("\xA6","\\\xA6")):v.push(k),p.severity!==void 0&&p.severity!==null?v.push(R.toString(p.severity)):v.push(k),p.message&&E?v.push(p.message.replace("\xA6","\\\xA6")):v.push(k),p.startLineNumber!==void 0&&p.startLineNumber!==null?v.push(p.startLineNumber.toString()):v.push(k),p.startColumn!==void 0&&p.startColumn!==null?v.push(p.startColumn.toString()):v.push(k),p.endLineNumber!==void 0&&p.endLineNumber!==null?v.push(p.endLineNumber.toString()):v.push(k),p.endColumn!==void 0&&p.endColumn!==null?v.push(p.endColumn.toString()):v.push(k),v.push(k),v.join("\xA6")}$.makeKeyOptionalMessage=P})(w||(e.IMarkerData=w={})),e.$qu=(0,M.$Ai)("markerService")}),define(ke[268],De([1,0,4,41,5]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$dw=e.Severity=void 0,e.$ew=w,e.Severity=L.default,e.$dw=(0,M.$Ai)("notificationService");var A;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var R;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function w(P){if(P){const p=P;return typeof p.id=="string"&&typeof p.label=="string"}return!1}var $;(function(P){P[P.OFF=0]="OFF",P[P.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class k{constructor(){this.progress=new I,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$fw=k;class I{infinite(){}done(){}total(p){}worked(p){}}e.$gw=I}),define(ke[269],De([1,0,52]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.context<"u"){const A=M.context.configuration();if(A)L=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,l.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:A.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ke[108],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,l.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"});var We=this&&this.__param||function(le,e){return function(l,L){e(l,L,le)}};define(ke[109],De([1,0,7,21,3,5]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.ProgressLocation=e.$hw=void 0,e.$hw=(0,A.$Ai)("progressService");var R;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$iw=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$jw=w;class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const E=this.d;this.d=()=>{E?.(),p()}}):Promise.resolve()}}e.$kw=$;let k=class extends M.$Uc{constructor(p,E){super(),this.a=new l.$Xh,E.withProgress(p,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$lw=k,e.$lw=k=Je([We(1,e.$hw)],k);class I extends M.$Uc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new M.$Tc)}start(p){this.stop();const E=++this.a,v=new L.$se;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>v.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:E,token:v.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$mw=I,e.$nw=(0,A.$Ai)("editorProgressService")}),define(ke[36],De([1,0,62,18]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=void 0;class M{constructor(){this.a=new Map}add(R,w){l.ok(L.$ag(R)),l.ok(L.$cg(w)),l.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,w)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$ho=new M}),define(ke[110],De([1,0,4,36]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=void 0,e.$io={JSONContribution:"base.contributions.json"};function M(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class A{constructor(){this.b=new l.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,k){this.a[M($)]=k,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;L.$ho.add(e.$io.JSONContribution,R)}),define(ke[66],De([1,0,19,4,18,208,56,110,36]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ConfigurationScope=e.$mo=e.EditPresentationTypes=void 0,e.$xo=d,e.$yo=h,e.$zo=c,e.$Ao=n,e.$Bo=a;var k;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$mo={Configuration:"base.contributions.configuration"};var I;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to="vscode://schemas/settings/resourceLanguage",e.$uo="vscode://schemas/settings/configurationDefaults";const P=$.$ho.as(w.$io.JSONContribution);class p{constructor(){this.h=new Set,this.i=new L.$he,this.onDidSchemaChange=this.i.event,this.j=new L.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$to,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const o=new Set;this.n(t,f,o),P.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const f=new Set;this.o(t,f),P.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const o=new Set;this.o(f,o),this.n(t,!1,o),P.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const o=[];for(const{overrides:s,source:u}of t)for(const g in s)if(f.add(g),e.$wo.test(g)){const b=this.a.get(g),S=b?.valuesSources??new Map;if(u)for(const C of Object.keys(s[g]))S.set(C,u);const m={...b?.value||{},...s[g]};this.a.set(g,{source:u,value:m,valuesSources:S});const y=(0,R.$ej)(g),D={type:"object",default:m,description:A.localize(1,null,y),$ref:e.$to,defaultDefaultValue:m,source:M.$ag(u)?void 0:u,defaultValueSource:u};o.push(...d(g)),this.d[g]=D,this.b.properties[g]=D}else{this.a.set(g,{value:s[g],source:u});const b=this.d[g];b&&(this.w(g,b),this.r(g,b))}this.m(o)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:o,source:s}of t)for(const u in o){const g=this.a.get(u),b=M.$ag(s)?s:s?.id,S=M.$ag(g?.source)?g?.source:g?.source?.id;if(b===S)if(f.add(u),this.a.delete(u),e.$wo.test(u))delete this.d[u],delete this.b.properties[u];else{const m=this.d[u];m&&(this.w(u,m),this.r(u,m))}}this.u()}deltaConfiguration(t){let f=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,o){t.forEach(s=>{this.p(s,f,s.extensionInfo,s.restrictedProperties,void 0,o),this.c.push(s),this.q(s)})}o(t,f){const o=s=>{if(s.properties)for(const u in s.properties){f.add(u);const g=this.d[u];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[u],this.s(u,s.properties[u])}s.allOf?.forEach(u=>o(u))};for(const s of t){o(s);const u=this.c.indexOf(s);u!==-1&&this.c.splice(u,1)}}p(t,f=!0,o,s,u=3,g){u=M.$jg(t.scope)?u:t.scope;const b=t.properties;if(b)for(const m in b){const y=b[m];if(f&&n(m,y)){delete b[m];continue}if(y.source=o,y.defaultDefaultValue=b[m].default,this.w(m,y),e.$wo.test(m)?y.scope=void 0:(y.scope=M.$jg(y.scope)?u:y.scope,y.restricted=M.$jg(y.restricted)?!!s?.includes(m):y.restricted),b[m].hasOwnProperty("included")&&!b[m].included){this.f[m]=b[m],delete b[m];continue}else this.d[m]=b[m],b[m].policy?.name&&this.e.set(b[m].policy.name,m);!b[m].deprecationMessage&&b[m].markdownDeprecationMessage&&(b[m].deprecationMessage=b[m].markdownDeprecationMessage),g.add(m)}const S=t.allOf;if(S)for(const m of S)this.p(m,f,o,s,u,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=o=>{const s=o.properties;if(s)for(const g in s)this.r(g,s[g]);o.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$no.properties[t]=f,f.scope){case 1:e.$oo.properties[t]=f;break;case 2:e.$po.properties[t]=f;break;case 6:e.$qo.properties[t]=f;break;case 3:e.$ro.properties[t]=f;break;case 4:e.$so.properties[t]=f;break;case 5:e.$so.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$no.properties[t],f.scope){case 1:delete e.$oo.properties[t];break;case 2:delete e.$po.properties[t];break;case 6:delete e.$qo.properties[t];break;case 3:delete e.$ro.properties[t];break;case 4:case 5:delete e.$so.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,o={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$to};this.w(f,o),e.$no.properties[f]=o,e.$oo.properties[f]=o,e.$po.properties[f]=o,e.$qo.properties[f]=o,e.$ro.properties[f]=o,e.$so.properties[f]=o}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$to};e.$no.patternProperties[e.$vo]=t,e.$oo.patternProperties[e.$vo]=t,e.$po.patternProperties[e.$vo]=t,e.$qo.patternProperties[e.$vo]=t,e.$ro.patternProperties[e.$vo]=t,e.$so.patternProperties[e.$vo]=t,this.i.fire()}w(t,f){const o=this.a.get(t);let s=o?.value,u=o?.source;M.$hg(s)&&(s=f.defaultDefaultValue,u=void 0),M.$hg(s)&&(s=c(f.type)),f.default=s,f.defaultValueSource=u}}const E="\\[([^\\]]+)\\]",v=new RegExp(E,"g");e.$vo=`^(${E})+$`,e.$wo=new RegExp(e.$vo);function d(r){const t=[];if(e.$wo.test(r)){let f=v.exec(r);for(;f?.length;){const o=f[1].trim();o&&t.push(o),f=v.exec(r)}}return(0,l.$Mb)(t)}function h(r){return r.reduce((t,f)=>`${t}[${f}]`,"")}function c(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const i=new p;$.$ho.add(e.$mo.Configuration,i);function n(r,t){return r.trim()?e.$wo.test(r)?A.localize(7,null,r):i.getConfigurationProperties()[r]!==void 0?A.localize(8,null,r):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,r,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function a(){const r=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))r.push([f,t[f].scope]);return r.push(["launch",4]),r.push(["task",4]),r}}),define(ke[270],De([1,0,19,4,166,3,27,24,18,2,56,66,36]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Go=n;function E(f){return Object.isFrozen(f)?f:w.$8n(f)}class v{static createEmptyModel(o){return new v({},[],[],void 0,o)}constructor(o,s,u,g,b){this.b=o,this.c=s,this.d=u,this.raw=g,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const o=this.raw.map(s=>{if(s instanceof v)return s;const u=new d("",this.f);return u.parseRaw(s),u.configurationModel});this.g=o.reduce((s,u)=>u===s?u:s.merge(u),o[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,I.$cj)(this.contents,o):this.contents}inspect(o,s){const u=this;return{get value(){return E(u.rawConfiguration.getValue(o))},get override(){return s?E(u.rawConfiguration.getOverrideValue(o,s)):void 0},get merged(){return E(s?u.rawConfiguration.override(s).getValue(o):u.rawConfiguration.getValue(o))},get overrides(){const g=[];for(const{contents:b,identifiers:S,keys:m}of u.rawConfiguration.overrides){const y=new v(b,m,[],void 0,u.f).getValue(o);y!==void 0&&g.push({identifiers:S,value:y})}return g.length?E(g):void 0}}}getOverrideValue(o,s){const u=this.j(s);return u?o?(0,I.$cj)(u,o):u:void 0}getKeysForOverrideIdentifier(o){const s=[];for(const u of this.overrides)u.identifiers.includes(o)&&s.push(...u.keys);return l.$Mb(s)}getAllOverrideIdentifiers(){const o=[];for(const s of this.overrides)o.push(...s.identifiers);return l.$Mb(o)}override(o){let s=this.a.get(o);return s||(s=this.h(o),this.a.set(o,s)),s}merge(...o){const s=w.$7n(this.contents),u=w.$7n(this.overrides),g=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const S of o)if(b.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(s,S.contents);for(const m of S.overrides){const[y]=u.filter(D=>l.$ub(D.identifiers,m.identifiers));y?(this.i(y.contents,m.contents),y.keys.push(...m.keys),y.keys=l.$Mb(y.keys)):u.push(w.$7n(m))}for(const m of S.keys)g.indexOf(m)===-1&&g.push(m)}return new v(s,g,u,b.every(S=>S instanceof v)?void 0:b,this.f)}h(o){const s=this.j(o);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const u={};for(const g of l.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let b=this.contents[g];const S=s[g];S&&(typeof b=="object"&&typeof S=="object"?(b=w.$7n(b),this.i(b,S)):b=S),u[g]=b}return new v(u,this.keys,this.overrides,void 0,this.f)}i(o,s){for(const u of Object.keys(s)){if(u in o&&$.$cg(o[u])&&$.$cg(s[u])){this.i(o[u],s[u]);continue}o[u]=w.$7n(s[u])}}j(o){let s=null,u=null;const g=b=>{b&&(u?this.i(u,b):u=w.$7n(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===o?s=b.contents:b.identifiers.includes(o)&&g(b.contents);return g(s),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,s){this.k(o,s,!0)}setValue(o,s){this.k(o,s,!1)}removeValue(o){const s=this.keys.indexOf(o);s!==-1&&(this.keys.splice(s,1),(0,I.$bj)(this.contents,o),P.$wo.test(o)&&this.overrides.splice(this.overrides.findIndex(u=>l.$ub(u.identifiers,(0,P.$xo)(o))),1))}k(o,s,u){(0,I.$aj)(this.contents,o,s,g=>this.f.error(g)),u=u||this.keys.indexOf(o)===-1,u&&this.keys.push(o),P.$wo.test(o)&&this.overrides.push({identifiers:(0,P.$xo)(o),keys:Object.keys(this.contents[o]),contents:(0,I.$_i)(this.contents[o],g=>this.f.error(g))})}}e.$Co=v;class d{constructor(o,s){this.f=o,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||v.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,s){if(!$.$jg(o)){const u=this.h(o);this.parseRaw(u,s)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,s){this.a=o;const{contents:u,keys:g,overrides:b,restricted:S,hasExcludedProperties:m}=this.i(o,s);this.b=new v(u,g,b,m?[o]:void 0,this.g),this.c=S||[]}h(o){let s={},u=null,g=[];const b=[],S=[];function m(D){Array.isArray(g)?g.push(D):u!==null&&(g[u]=D)}const y={onObjectBegin:()=>{const D={};m(D),b.push(g),g=D,u=null},onObjectProperty:D=>{u=D},onObjectEnd:()=>{g=b.pop()},onArrayBegin:()=>{const D=[];m(D),b.push(g),g=D,u=null},onArrayEnd:()=>{g=b.pop()},onLiteralValue:m,onError:(D,C,O)=>{S.push({error:D,offset:C,length:O})}};if(o)try{M.$Un(o,y),s=g[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return s}i(o,s){const u=p.$ho.as(P.$mo.Configuration).getConfigurationProperties(),g=this.j(o,u,!0,s);o=g.raw;const b=(0,I.$_i)(o,y=>this.g.error(`Conflict in settings file ${this.f}: ${y}`)),S=Object.keys(o),m=this.l(o,y=>this.g.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:b,keys:S,overrides:m,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}j(o,s,u,g){let b=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:b};const S={},m=[];for(const y in o)if(P.$wo.test(y)&&u){const D=this.j(o[y],s,!1,g);S[y]=D.raw,b=b||D.hasExcludedProperties,m.push(...D.restricted)}else{const D=s[y],C=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&m.push(y),!g.exclude?.includes(y)&&(g.include?.includes(y)||(C===void 0||g.scopes===void 0||g.scopes.includes(C))&&!(g.skipRestricted&&D?.restricted))?S[y]=o[y]:b=!0}return{raw:S,restricted:m,hasExcludedProperties:b}}l(o,s){const u=[];for(const g of Object.keys(o))if(P.$wo.test(g)){const b={};for(const S in o[g])b[S]=o[g][S];u.push({identifiers:(0,P.$xo)(g),keys:Object.keys(b),contents:(0,I.$_i)(b,s)})}return u}}e.$Do=d;class h extends A.$Uc{constructor(o,s,u,g,b){super(),this.c=o,this.f=s,this.g=g,this.h=b,this.b=this.B(new L.$he),this.onDidChange=this.b.event,this.a=new d(this.c.toString(),b),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&u.isEqual(S.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return v.createEmptyModel(this.h)}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Eo=h;class c{constructor(o,s,u,g,b,S,m,y,D,C,O,z,T){this.a=o,this.b=s,this.c=u,this.overrideIdentifiers=g,this.d=b,this.f=S,this.g=m,this.h=y,this.i=D,this.j=C,this.k=O,this.l=z,this.m=T}get value(){return E(this.c)}n(o){return o?.value!==void 0||o?.override!==void 0||o?.overrides!==void 0?o:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(o,s,u,g,b,S,m,y,D,C){this.j=o,this.l=s,this.m=u,this.n=g,this.p=b,this.q=S,this.r=m,this.s=y,this.t=D,this.u=C,this.h=null,this.i=new R.$Ac,this.v=null}getValue(o,s,u){return this.w(o,s,u).getValue(o)}updateValue(o,s,u={}){let g;u.resource?(g=this.t.get(u.resource),g||(g=v.createEmptyModel(this.u),this.t.set(u.resource,g))):g=this.s,s===void 0?g.removeValue(o):g.setValue(o,s),u.resource||(this.h=null)}inspect(o,s,u){const g=this.w(o,s,u),b=this.A(s.resource,u),S=s.resource?this.t.get(s.resource)||this.s:this.s,m=new Set;for(const y of g.overrides)for(const D of y.identifiers)g.getOverrideValue(o,D)!==void 0&&m.add(D);return new c(o,s,g.getValue(o),m.size?[...m]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,b||void 0,S)}keys(o){const s=this.A(void 0,o);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(o){this.j=o,this.h=null,this.i.clear()}updatePolicyConfiguration(o){this.l=o}updateApplicationConfiguration(o){this.m=o,this.h=null,this.i.clear()}updateLocalUserConfiguration(o){this.n=o,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(o){this.p=o,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(o){this.q=o,this.h=null,this.i.clear()}updateFolderConfiguration(o,s){this.r.set(o,s),this.i.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.i.delete(o)}compareAndUpdateDefaultConfiguration(o,s){const u=[];if(!s){const{added:g,updated:b,removed:S}=r(this.j,o);s=[...g,...b,...S]}for(const g of s)for(const b of(0,P.$xo)(g)){const S=this.j.getKeysForOverrideIdentifier(b),m=o.getKeysForOverrideIdentifier(b),y=[...m.filter(D=>S.indexOf(D)===-1),...S.filter(D=>m.indexOf(D)===-1),...S.filter(D=>!w.$$n(this.j.override(b).getValue(D),o.override(b).getValue(D)))];u.push([b,y])}return this.updateDefaultConfiguration(o),{keys:s,overrides:u}}compareAndUpdatePolicyConfiguration(o){const{added:s,updated:u,removed:g}=r(this.l,o),b=[...s,...u,...g];return b.length&&this.updatePolicyConfiguration(o),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:s,updated:u,removed:g,overrides:b}=r(this.applicationConfiguration,o),S=[...s,...u,...g];return S.length&&this.updateApplicationConfiguration(o),{keys:S,overrides:b}}compareAndUpdateLocalUserConfiguration(o){const{added:s,updated:u,removed:g,overrides:b}=r(this.localUserConfiguration,o),S=[...s,...u,...g];return S.length&&this.updateLocalUserConfiguration(o),{keys:S,overrides:b}}compareAndUpdateRemoteUserConfiguration(o){const{added:s,updated:u,removed:g,overrides:b}=r(this.remoteUserConfiguration,o),S=[...s,...u,...g];return S.length&&this.updateRemoteUserConfiguration(o),{keys:S,overrides:b}}compareAndUpdateWorkspaceConfiguration(o){const{added:s,updated:u,removed:g,overrides:b}=r(this.workspaceConfiguration,o),S=[...s,...u,...g];return S.length&&this.updateWorkspaceConfiguration(o),{keys:S,overrides:b}}compareAndUpdateFolderConfiguration(o,s){const u=this.folderConfigurations.get(o),{added:g,updated:b,removed:S,overrides:m}=r(u,s),y=[...g,...b,...S];return(y.length||!u)&&this.updateFolderConfiguration(o,s),{keys:y,overrides:m}}compareAndDeleteFolderConfiguration(o){const s=this.folderConfigurations.get(o);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:u,updated:g,removed:b,overrides:S}=r(s,void 0);return{keys:[...u,...g,...b],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(o,s,u){let g=this.x(s,u);return s.overrideIdentifier&&(g=g.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(o)!==void 0&&(g=g.merge(this.l)),g}x({resource:o},s){let u=this.y();if(s&&o){const g=s.getFolder(o);g&&(u=this.z(g.uri)||u);const b=this.t.get(o);b&&(u=u.merge(b))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(o){let s=this.i.get(o);if(!s){const u=this.y(),g=this.r.get(o);g?(s=u.merge(g),this.i.set(o,s)):s=u}return s}A(o,s){if(s&&o){const u=s.getFolder(o);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((o,s)=>{const{contents:u,overrides:g,keys:b}=this.r.get(s);return o.push([s,{contents:u,overrides:g,keys:b}]),o},[])}}allKeys(){const o=new Set;return this.j.keys.forEach(s=>o.add(s)),this.userConfiguration.keys.forEach(s=>o.add(s)),this.q.keys.forEach(s=>o.add(s)),this.r.forEach(s=>s.keys.forEach(u=>o.add(u))),[...o.values()]}B(){const o=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(u=>o.add(u))),[...o.values()]}D(o){const s=new Set;return this.j.getKeysForOverrideIdentifier(o).forEach(u=>s.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(u=>s.add(u)),this.q.getKeysForOverrideIdentifier(o).forEach(u=>s.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(o).forEach(g=>s.add(g))),[...s.values()]}static parse(o,s){const u=this.E(o.defaults,s),g=this.E(o.policy,s),b=this.E(o.application,s),S=this.E(o.user,s),m=this.E(o.workspace,s),y=o.folders.reduce((D,C)=>(D.set(k.URI.revive(C[0]),this.E(C[1],s)),D),new R.$Ac);return new i(u,g,b,S,v.createEmptyModel(s),m,y,v.createEmptyModel(s),new R.$Ac,s)}static E(o,s){return new v(o.contents,o.keys,o.overrides,void 0,s)}}e.$Fo=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const o=new Set,s=new Map;for(const g of f)g.keys.forEach(b=>o.add(b)),g.overrides.forEach(([b,S])=>{const m=(0,R.$xc)(s,b,new Set);S.forEach(y=>m.add(y))});const u=[];return s.forEach((g,b)=>u.push([b,[...g.values()]])),{keys:[...o.values()],overrides:u}}class a{constructor(o,s,u,g,b){this.change=o,this.f=s,this.g=u,this.h=g,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of o.keys)this.affectedKeys.add(S);for(const[,S]of o.overrides)for(const m of S)this.affectedKeys.add(m);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(o,s){const u=this.a+o,g=this.d.indexOf(u);if(g<0)return!1;const b=g+u.length;if(b>=this.d.length)return!1;const S=this.d.charCodeAt(b);if(S!==this.b&&S!==this.c)return!1;if(s){const m=this.previousConfiguration?this.previousConfiguration.getValue(o,s,this.f?.workspace):void 0,y=this.g.getValue(o,s,this.h);return!w.$$n(m,y)}return!0}}e.$Ho=a;function r(f,o){const{added:s,removed:u,updated:g}=t(o?.rawConfiguration,f?.rawConfiguration),b=[],S=f?.getAllOverrideIdentifiers()||[],m=o?.getAllOverrideIdentifiers()||[];if(o){const y=m.filter(D=>!S.includes(D));for(const D of y)b.push([D,o.getKeysForOverrideIdentifier(D)])}if(f){const y=S.filter(D=>!m.includes(D));for(const D of y)b.push([D,f.getKeysForOverrideIdentifier(D)])}if(o&&f){for(const y of S)if(m.includes(y)){const D=t({contents:f.getOverrideValue(void 0,y)||{},keys:f.getKeysForOverrideIdentifier(y)},{contents:o.getOverrideValue(void 0,y)||{},keys:o.getKeysForOverrideIdentifier(y)});b.push([y,[...D.added,...D.removed,...D.updated]])}}return{added:s,removed:u,updated:g,overrides:b}}function t(f,o){const s=f?o?f.keys.filter(b=>o.keys.indexOf(b)===-1):[...f.keys]:[],u=o?f?o.keys.filter(b=>f.keys.indexOf(b)===-1):[...o.keys]:[],g=[];if(f&&o){for(const b of o.keys)if(f.keys.indexOf(b)!==-1){const S=(0,I.$cj)(o.contents,b),m=(0,I.$cj)(f.contents,b);w.$$n(S,m)||g.push(b)}}return{added:s,removed:u,updated:g}}}),define(ke[271],De([1,0,22,4,3,83]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$vb=e.$9vb=e.$8vb=void 0,e.$0vb=w;const R=(k,I,P)=>{const p=new Uint8Array(16);for(let d=0;d<16;d++)p[d]=Math.round(Math.random()*256);const E=(0,l.$4e)(l.$Je.wrap(p));return[`GET ws://localhost${k}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$8vb=R,e.$9vb=l.$Je.fromString(`\r
\r
`);async function w(k,I,P,p,E){k.write(l.$Je.fromString((0,e.$8vb)(I,P,p)));const v=new M.$Tc;try{return await new Promise((d,h)=>{let c;v.add(k.onData(i=>{c?c=l.$Je.concat([c,i],c.byteLength+i.byteLength):c=i;const n=c.indexOf(e.$9vb);if(n===-1)return;d(k),k.pauseData();const a=c.slice(n+e.$9vb.byteLength);a.byteLength&&E.onData.fire(a)})),v.add(k.onClose(i=>h(i??new Error("socket closed")))),v.add(k.onEnd(()=>h(new Error("socket ended"))))})}catch(d){throw k.dispose(),d}finally{v.dispose()}}class $ extends M.$Uc{constructor(I,P){super(),this.g=I,this.a=this.B(new L.$ke),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new L.$he),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(p=>this.a.fire(p))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,P){A.SocketDiagnostics.traceSocketEvent(this,this.g,I,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$$vb=$}),define(ke[67],De([1,0,13,5]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=k,e.$Ll=(0,L.$Ai)("remoteAuthorityResolverService");var M;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class A{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ml=A;class R{constructor(P,p){this.host=P,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=R;var w;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class $ extends l.$bb{static isNotAvailable(P){return P instanceof $&&P._code===w.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof $&&P._code===w.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof $&&P._code===w.NoResolverFound}static isInvalidAuthority(P){return P instanceof $&&P._code===w.InvalidAuthority}static isHandled(P){return P instanceof $&&P.isHandled}constructor(P,p=w.Unknown,E){super(P),this._message=P,this._code=p,this._detail=E,this.isHandled=p===w.NotAvailable&&E===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ol=$;function k(I){const P=I.indexOf("+");return P===-1?I:I.substring(0,P)}}),define(ke[272],De([1,0,7,22,21,13,4,3,15,59,40,30,83,67]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ul=S,e.$Vl=m,e.$Wl=D;const v=30*1e3;var d;(function(me){me[me.Management=1]="Management",me[me.ExtensionHost=2]="ExtensionHost",me[me.Tunnel=3]="Tunnel"})(d||(e.ConnectionType=d={}));function h(me){switch(me){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(me){const U=new M.$se;return setTimeout(()=>U.cancel(),me),U.token}function i(me,U){if(me.isCancellationRequested||U.isCancellationRequested)return M.CancellationToken.Cancelled;const Y=new M.$se;return me.onCancellationRequested(()=>Y.cancel()),U.onCancellationRequested(()=>Y.cancel()),Y.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new w.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,l.$th)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function a(me,U){const Y=new n(U);return Y.registerDisposable(me.onControlMessage(pe=>{const ce=JSON.parse(pe.toString()),ae=K(ce);ae?Y.reject(ae):Y.resolve(ce)})),Y.promise}function r(me,U,Y,pe,ce,ae,se,ue){const Q=new n(ue),re=I.$be.create(!1);return me.info(`Creating a socket (${se})...`),k.mark(`code/willCreateSocket/${ae}`),U.connect(Y,pe,ce,se).then($e=>{Q.didTimeout?(k.mark(`code/didCreateSocketError/${ae}`),me.info(`Creating a socket (${se}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(k.mark(`code/didCreateSocketOK/${ae}`),me.info(`Creating a socket (${se}) was successful after ${re.elapsed()} ms.`),Q.resolve($e))},$e=>{k.mark(`code/didCreateSocketError/${ae}`),me.info(`Creating a socket (${se}) returned an error after ${re.elapsed()} ms.`),me.error($e),Q.reject($e)}),Q.promise}function t(me,U){const Y=new n(U);return me.then(pe=>{Y.didTimeout||Y.resolve(pe)},pe=>{Y.didTimeout||Y.reject(pe)}),Y.promise}async function f(me,U,Y,pe){const ce=oe(me,U);me.logService.trace(`${ce} 1/6. invoking socketFactory.connect().`);let ae;try{ae=await r(me.logService,me.remoteSocketFactoryService,me.connectTo,$.$Ng.getServerRootPath(),`reconnectionToken=${me.reconnectionToken}&reconnection=${me.reconnectionProtocol?"true":"false"}`,h(U),`renderer-${h(U)}-${me.reconnectionToken}`,pe)}catch($e){throw me.logService.error(`${ce} socketFactory.connect() failed or timed out. Error:`),me.logService.error($e),$e}me.logService.trace(`${ce} 2/6. socketFactory.connect() was successful.`);let se,ue;me.reconnectionProtocol?(me.reconnectionProtocol.beginAcceptReconnection(ae,null),se=me.reconnectionProtocol,ue=!1):(se=new p.$oi({socket:ae}),ue=!0),me.logService.trace(`${ce} 3/6. sending AuthRequest control message.`);const Q=await t(me.signService.createNewMessage((0,P.$Wg)()),pe),re={type:"auth",auth:me.connectionToken||"00000000000000000000",data:Q.data};se.sendControl(L.$Je.fromString(JSON.stringify(re)));try{const $e=await a(se,i(pe,c(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(me.logService.trace(`${ce} 4/6. received SignRequest control message.`),!await t(me.signService.validate(Q,$e.signedData),pe)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const Ne=await t(me.signService.sign($e.data),pe),Se={type:"connectionType",commit:me.commit,signedData:Ne,desiredConnectionType:U};return Y&&(Se.args=Y),me.logService.trace(`${ce} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(L.$Je.fromString(JSON.stringify(Se))),{protocol:se,ownsProtocol:ue}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(me.logService.error(`${ce} the handshake timed out. Error:`),me.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(me.logService.error(`${ce} received error control message when negotiating connection. Error:`),me.logService.error($e)),ue&&H(se),$e}}async function o(me,U,Y,pe){const ce=Date.now(),ae=oe(me,U),{protocol:se,ownsProtocol:ue}=await f(me,U,Y,pe),Q=new n(pe);return Q.registerDisposable(se.onControlMessage(re=>{const $e=JSON.parse(re.toString()),we=K($e);we?(me.logService.error(`${ae} received error control message when negotiating connection. Error:`),me.logService.error(we),ue&&H(se),Q.reject(we)):(me.reconnectionProtocol?.endAcceptReconnection(),me.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${Pe(ce)}!`),Q.resolve({protocol:se,firstMessage:$e}))})),Q.promise}async function s(me,U){const{protocol:Y}=await o(me,1,void 0,U);return{protocol:Y}}async function u(me,U,Y){const{protocol:pe,firstMessage:ce}=await o(me,2,U,Y),ae=ce&&ce.debugPort;return{protocol:pe,debugPort:ae}}async function g(me,U,Y){const pe=Date.now(),ce=oe(me,3),{protocol:ae}=await f(me,3,U,Y);return me.logService.trace(`${ce} 6/6. handshake finished, connection is up and running after ${Pe(pe)}!`),ae}async function b(me,U,Y){const{connectTo:pe,connectionToken:ce}=await me.addressProvider.getAddress();return{commit:me.commit,quality:me.quality,connectTo:pe,connectionToken:ce,reconnectionToken:U,reconnectionProtocol:Y,remoteSocketFactoryService:me.remoteSocketFactoryService,signService:me.signService,logService:me.logService}}async function S(me,U,Y){return y(me,async pe=>{const{protocol:ce}=await s(pe,M.CancellationToken.None);return new X(me,U,Y,pe.reconnectionToken,ce)})}async function m(me,U){return y(me,async Y=>{const{protocol:pe,debugPort:ce}=await u(Y,U,M.CancellationToken.None);return new ie(me,U,Y.reconnectionToken,pe,ce)})}async function y(me,U){for(let pe=1;;pe++)try{const ce=(0,P.$Wg)(),ae=await b(me,ce,null);return await U(ae)}catch(ce){if(pe<5)me.logService.error(`[remote-connection][attempt ${pe}] An error occurred in initial connection! Will retry... Error:`),me.logService.error(ce);else throw me.logService.error(`[remote-connection][attempt ${pe}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),me.logService.error(ce),B.triggerPermanentFailure(0,0,E.$Ol.isHandled(ce)),ce}}async function D(me,U,Y){const pe=await b(me,(0,P.$Wg)(),null);return await g(pe,{host:U,port:Y},M.CancellationToken.None)}function C(me){return(0,l.$nh)(U=>new Promise((Y,pe)=>{const ce=setTimeout(Y,me*1e3);U.onCancellationRequested(()=>{clearTimeout(ce),Y()})}))}var O;(function(me){me[me.ConnectionLost=0]="ConnectionLost",me[me.ReconnectionWait=1]="ReconnectionWait",me[me.ReconnectionRunning=2]="ReconnectionRunning",me[me.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",me[me.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class z{constructor(U,Y){this.reconnectionToken=U,this.millisSinceLastIncomingData=Y,this.type=0}}e.$Xl=z;class T{constructor(U,Y,pe,ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=Y,this.durationSeconds=pe,this.c=ce,this.type=1}skipWait(){this.c.cancel()}}e.$Yl=T;class F{constructor(U,Y,pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=Y,this.attempt=pe,this.type=2}}e.$Zl=F;class N{constructor(U,Y,pe){this.reconnectionToken=U,this.millisSinceLastIncomingData=Y,this.attempt=pe,this.type=4}}e.$1l=N;class j{constructor(U,Y,pe,ce){this.reconnectionToken=U,this.millisSinceLastIncomingData=Y,this.attempt=pe,this.handled=ce,this.type=3}}e.$2l=j;class B extends w.$Uc{static triggerPermanentFailure(U,Y,pe){this._permanentFailure=!0,this.f=U,this.g=Y,this.h=pe,this.j.forEach(ce=>ce.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,Y,pe,ce,ae){super(),this.t=U,this.u=Y,this.reconnectionToken=pe,this.protocol=ce,this.w=ae,this.m=this.B(new R.$he),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(ce.onSocketClose(se=>{const ue=ge(this.t,this.reconnectionToken,!0);se?se.type===0?(this.u.logService.info(`${ue} received socket close event (hadError: ${se.hadError}).`),se.error&&this.u.logService.error(se.error)):(this.u.logService.info(`${ue} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.u.logService.error(se.event)):this.u.logService.info(`${ue} received socket close event.`),this.y()})),this.B(ce.onSocketTimeout(se=>{const ue=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ue} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,w.$Sc)(()=>{const se=B.j.indexOf(this);se>=0&&B.j.splice(se,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=ge(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const Y=[0,5,5,10,10,10,10,10,30];let pe=-1;do{pe++;const ce=pe<Y.length?Y[pe]:Y[Y.length-1];try{if(ce>0){const se=C(ce);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ce,se)),this.u.logService.info(`${U} waiting for ${ce} seconds before reconnecting...`);try{await se}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1)),this.u.logService.info(`${U} resolving connection...`);const ae=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ae.connectTo}...`),await this.G(ae,c(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),pe+1));break}catch(ae){if(ae.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(pe>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}if(E.$Ol.isTemporarilyNotAvailable(ae)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((ae.code==="ETIMEDOUT"||ae.code==="ENETUNREACH"||ae.code==="ECONNREFUSED"||ae.code==="ECONNRESET")&&ae.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((0,A.$4)(ae)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if(ae instanceof E.$Ol){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,E.$Ol.isHandled(ae));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),pe+1,!1);break}}while(!this.n&&!this.s)}C(U,Y,pe){this.w?B.triggerPermanentFailure(U,Y,pe):this.D(U,Y,pe)}D(U,Y,pe){this.m.fire(new j(this.reconnectionToken,U,Y,pe)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$3l=B;class X extends B{constructor(U,Y,pe,ce,ae){super(1,U,ce,ae,!0),this.client=this.B(new p.$mi(ae,{remoteAuthority:Y,clientId:pe},U.ipcLogger))}async G(U,Y){await s(U,Y)}}e.$4l=X;class ie extends B{constructor(U,Y,pe,ce,ae){super(2,U,pe,ce,!1),this.H=Y,this.debugPort=ae}async G(U,Y){await u(U,this.H,Y)}}e.$5l=ie;function H(me){try{me.acceptDisconnect();const U=me.getSocket();me.dispose(),U.dispose()}catch(U){(0,A.$1)(U)}}function K(me){if(me&&me.type==="error"){const U=new Error(`Connection error: ${me.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(me,U){for(;me.length<U;)me+=" ";return me}function _(me,U){return`[remote-connection][${x(h(me),13)}][${U.substr(0,5)}\u2026]`}function ge(me,U,Y){return`${_(me,U)}[${Y?"reconnect":"initial"}]`}function oe(me,U){return`${ge(U,me.reconnectionToken,!!me.reconnectionProtocol)}[${me.connectTo}]`}function Pe(me){return`${Date.now()-me} ms`}}),define(ke[86],De([1,0,15]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=L,e.$Mm=M,e.$Nm=A,e.$Om=R;function L($){return $.scheme===l.Schemas.vscodeRemote?$.authority:void 0}function M($){if(!$)return;const k=$.indexOf("+");return k<0?$:$.substr(0,k)}function A($){const{host:k,port:I}=w($);if(typeof I>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:I}}function R($,k){let{host:I,port:P}=w($);return typeof P>"u"&&(P=k),{host:I,port:P}}function w($){const k=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const I=$.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const P=$.match(/(.*):(\d+)$/);return P?{host:P[1],port:parseInt(P[2],10)}:{host:$,port:void 0}}}),define(ke[25],De([1,0,14,5,86]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$Xm=e.$Wm=e.$Vm=e.TargetPlatform=e.ExtensionType=e.$Um=e.$Sm=e.$Rm=e.$Qm=e.$Pm=void 0,e.$Tm=A,e.$Ym=P,e.$Zm=p,e.$1m=E,e.$2m=v,e.$Pm="extensions.user.cache",e.$Qm="extensions.builtin.cache",e.$Rm="undefined_publisher",e.$Sm=["ui","workspace","web"];function A(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.$Um=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R||(e.ExtensionType=R={}));var w;(function(d){d.WIN32_X64="win32-x64",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class ${constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,c){if(typeof h>"u"||h===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof h=="string"||typeof c=="string"){const i=typeof h=="string"?h:h.value,n=typeof c=="string"?c:c.value;return l.$Bf(i,n)}return h._lower===c._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$Vm=$;class k{get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const c of h)this.add(c)}add(h){this.c.add($.toKey(h))}delete(h){return this.c.delete($.toKey(h))}has(h){return this.c.has($.toKey(h))}}e.$Wm=k;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete($.toKey(h))}get(h){return this.c.get($.toKey(h))}has(h){return this.c.has($.toKey(h))}set(h,c){this.c.set($.toKey(h),c)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xm=I;function P(d){return p(d)}function p(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}function E(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}function v(d,h){if(h){const c=`onResolveRemoteAuthority:${(0,M.$Mm)(h)}`;return!!d.activationEvents?.includes(c)}return!1}e.$3m=(0,L.$Ai)("IBuiltinExtensionsScannerService")}),define(ke[140],De([1,0,13,25]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tG=e.$sG=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(R,w){this.a.set(R,w)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const w=Object.create(null);for(const $ of R){const k=this.readActivationEvents($);k.length>0&&(w[L.$Vm.toKey($.identifier)]=k)}return w}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const w=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<w.length;$++)w[$]==="onUri"&&(w[$]=`onUri:${L.$Vm.toKey(R.identifier)}`);if(!R.contributes)return w;for(const $ in R.contributes){const k=this.a.get($);if(!k)continue;const I=R.contributes[$],P=Array.isArray(I)?I:[I];try{k(P,w)}catch(p){(0,l.$1)(p)}}return w}}e.$sG=M,e.$tG=new M}),define(ke[273],De([1,0,3,5]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql=(0,L.$Ai)("remoteSocketFactoryService");class M{constructor(){this.a={}}register(R,w){return this.a[R]??=[],this.a[R].push(w),(0,l.$Sc)(()=>{const $=this.a[R]?.indexOf(w);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,w,$,k){const I=this.b(R);if(!I)throw new Error(`No socket factory found for ${R}`);return I.connect(R,w,$,k)}}e.$Rl=M}),define(ke[274],De([1,0,22,13,3,220,66,5,11,36]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0,e.$Vp=p,e.$Wp=E,e.$Xp=v,e.$Yp=d,e.$Zp=h,e.$1p=c,e.$Tp=(0,w.$Ai)("requestService");class I{constructor(r){this.b=r}toJSON(){if(!this.a){const r=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?r[t]="*****":r[t]=this.b[t];this.a=r}return this.a}}class P extends M.$Uc{constructor(r){super(),this.b=0,this.a=r.createLogger("network",{name:(0,A.localize)(0,null),when:$.$mk.isEqualTo((0,$.$jk)($.LogLevel.Trace)).serialize()})}async c(r,t,f){const o=`${r} #${++this.b}: ${t.url}`;this.a.trace(`${o} - begin`,t.type,new I(t.headers??{}));try{const s=await f();return this.a.trace(`${o} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,t.type,(0,L.$0)(s)),s}}}e.$Up=P;function p(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}function E(a){return a.res.statusCode===204}async function v(a){return E(a)?null:(await(0,l.$Ve)(a.stream)).toString()}async function d(a){if(!p(a))throw new Error("Server returned "+a.res.statusCode);return v(a)}async function h(a){if(!p(a))throw new Error("Server returned "+a.res.statusCode);if(E(a))return null;const t=(await(0,l.$Ve)(a.stream)).toString();try{return JSON.parse(t)}catch(f){throw f.message+=`:
`+t,f}}function c(a){n(a)}let i;function n(a){const r=k.$ho.as(R.$mo.Configuration),t=i;i={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},r.updateConfigurations({add:[i],remove:t?[t]:[]})}n(1)}),define(ke[275],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;class l{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(M){try{const A=await this.c();if(A){const R=String(l.a++);return this.b.set(R,A),{id:R,data:A.createNewMessage(M)}}}catch{}return{id:"",data:M}}async validate(M,A){if(!M.id)return!0;const R=this.b.get(M.id);if(!R)return!1;this.b.delete(M.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(M){try{return await this.d(M)}catch{}return M}}e.$Q_b=l}),define(ke[111],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl="signService",e.$Tl=(0,l.$Ai)(e.$Sl)}),define(ke[141],De([1,0,275]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class L extends l.$Q_b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(R=>new R.signer().sign(A))}h(){return new Promise((A,R)=>le(["vsda"],A,R))}}e.$Lec=L}),define(ke[276],De([1,0,12,52,30]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=R,e.$kp=w;function A($){if(l.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,k,I,P,p,E,v,d,h){const c=Object.create(null);c["common.machineId"]=E,c["common.sqmId"]=v,c.sessionID=(0,M.$Wg)()+Date.now(),c.commitHash=P,c.version=p,c["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,l.$h)(l.$u),c["common.nodePlatform"]=L.$dc,c["common.nodeArch"]=I,c["common.product"]=h||"desktop",d&&(c["common.msftInternal"]=d);let i=0;const n=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),l.$l&&(c["common.snap"]="true");const a=A(k);return a&&(c["common.platformDetail"]=a),c}function w($){const k=L.env.USERDNSDOMAIN;if(!k)return!1;const I=k.toLowerCase();return $.some(P=>I===P)}}),define(ke[277],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,l.$Ai)("telemetryService"),e.$7l=(0,l.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry",e.$bm="telemetry.telemetryLevel",e.$cm="telemetry.enableCrashReporter",e.$dm="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var M;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(ke[87],De([1,0,24,18,86,276,277]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0,e.$sp=I,e.$tp=P,e.$up=p,e.$vp=E,e.$wp=d,e.$xp=c,e.$yp=i,e.$zp=r;class w{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$lp=w;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$mp=$,e.$np=new $;class k{async publicLog(f,o,s){}async publicLogError(f,o,s){}}e.$op=k,e.$pp="telemetry",e.$qp="extensionTelemetryLog",e.$rp={log:()=>null,flush:()=>Promise.resolve(null)};function I(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function P(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const f=t.getValue(R.$bm),o=t.getValue(R.$cm);if(t.getValue(R.$dm)===!1||o===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function E(t){const f={},o={},s={};h(t,s);for(let u in s){u=u.length>150?u.substr(u.length-149):u;const g=s[u];typeof g=="number"?o[u]=g:typeof g=="boolean"?o[u]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${g.length}`),f[u]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(f[u]=g)}return{properties:f,measurements:o}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(t){if(!t)return"none";const f=(0,M.$Mm)(t);return v.has(f)?f:"other"}function h(t,f,o=0,s){if(t)for(const u of Object.getOwnPropertyNames(t)){const g=t[u],b=s?s+u:u;Array.isArray(g)?f[b]=(0,l.$_n)(g):g instanceof Date?f[b]=g.toISOString():(0,L.$cg)(g)?o<2?h(g,f,o+1,b+"."):f[b]=(0,l.$_n)(g):f[b]=g}}function c(t,f){const o=t.msftInternalDomains||[],s=f.getValue("telemetry.internalTesting");return(0,A.$kp)(o)||s}function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let o=t;const s=[];for(const S of f)for(;;){const m=S.exec(t);if(!m)break;s.push([m.index,S.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(o="";;){const S=g.exec(t);if(!S)break;const m=s.some(([y,D])=>S.index<D&&y<g.lastIndex);!u.test(S[0])&&!m&&(o+=t.substring(b,S.index)+"<REDACTED: user-file-path>",b=g.lastIndex)}return b<t.length&&(o+=t.substr(b)),o}function a(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of f)if(o.regex.test(t))return`<REDACTED: ${o.label}>`;return t}function r(t,f){return(0,l.$9n)(t,o=>{if(o instanceof w||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let s=o.replaceAll("%20"," ");s=n(s,f);for(const u of f)s=s.replace(u,"");return s=a(s),s}})}}),define(ke[278],De([1,0,14,138,25,12,2,13,52,87]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Bp=void 0,e.$Ap=I,e.$Cp=v,e.$Dp=d,e.$Ep=h,e.$Fp=c,e.$Gp=i,e.$Hp=n,e.$Ip=a,e.$Kp=r,e.$Lp=f;function I(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,l.$wf)(o.id,s.id)===0}const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(s){const u=s.manifest?s.manifest.version:s.version,g=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new p(s.identifier,u,g)}static parse(s){const u=P.exec(s);return u&&u[1]&&u[2]?new p({id:u[1]},u[2],u[4]||void 0):null}constructor(s,u,g="undefined"){this.identifier=s,this.version=u,this.targetPlatform=g,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof p?I(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Bp=p;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const s=E.exec(o);return s&&s[1]?[h(s[1]),s[2]]:[h(o),void 0]}function d(o,s){return`${o}.${s}`}function h(o){return o.toLowerCase()}function c(o,s){return h(d(o??M.$Rm,s))}function i(o,s){const u=[],g=b=>{for(const S of u)if(S.some(m=>I(s(m),s(b))))return S;return null};for(const b of o){const S=g(b);S?S.push(b):u.push([b])}return u}function n(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}function a(o){return{id:new k.$lp(o.identifier.id),name:new k.$lp(o.name),version:o.version,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Jp=new M.$Vm("pprice.better-merge");function r(o,s){const u=[],g=s.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const b=g.shift();if(b&&u.every(S=>!I(S.identifier,{id:b}))){const S=o.filter(m=>I(m.identifier,{id:b}));S.length===1&&(u.push(S[0]),g.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}async function t(o,s){if(!A.$k)return!1;let u;try{u=(await o.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await o.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){s.debug("Error while getting the os-release file.",(0,w.$0)(b))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(o,s){const u=await t(o,s),g=(0,L.$8o)(u?"alpine":A.$u,$.$ec);return s.debug("ComputeTargetPlatform:",g),g}}),define(ke[279],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=l,e.$ss=L,e.$ts=M,e.$us=A,e.$vs=R,e.$ws=w;function l($){return[...$.entries()]}function L($){return $?[...$.entries()]:[]}function M($){return new Map($)}function A($){return new Map($??[])}function R($){return Array.from($.entries()).map(k=>[k[0],l(k[1].map),L(k[1].descriptionMap)])}function w($){return new Map($.map(k=>[k[0],{map:M(k[1]),descriptionMap:A(k[2])}]))}}),define(ke[280],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qwb=void 0;class l{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,A,R=5){const w=A($=>{const k=typeof $=="string"?$:$.data;let I=this.a.get(M);if(I){I.data.push(k);return}const P=setTimeout(()=>this.flushBuffer(M),R);I={data:[k],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(M),w.dispose()}},this.a.set(M,I)});return w}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const A=this.a.get(M);A&&(this.a.delete(M),this.b(M,A.data.join("")))}}e.$qwb=l}),define(ke[281],De([1,0,7,79,99,50,4,18,2,221,110,36]),function(le,e,l,L,M,A,R,w,$,k,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sx=e.$rx=e.$qx=e.$px=e.$ox=e.$nx=e.IconFontDefinition=e.IconContribution=e.$kx=void 0,e.$lx=h,e.$mx=c,e.$kx={IconContribution:"base.contributions.icons"};var p;(function(r){function t(f,o){let s=f.defaults;for(;A.ThemeIcon.isThemeIcon(s);){const u=d.getIcon(s.id);if(!u)return;s=u.defaults}return s}r.getDefinition=t})(p||(e.IconContribution=p={}));var E;(function(r){function t(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}r.toJSONObject=t;function f(o){const s=u=>(0,w.$ag)(u)?u:void 0;if(o&&Array.isArray(o.src)&&o.src.every(u=>(0,w.$ag)(u.format)&&(0,w.$ag)(u.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(u=>({format:u.format,location:$.URI.parse(u.location)}))}}r.fromJSONObject=f})(E||(e.IconFontDefinition=E={}));class v{constructor(){this.a=new R.$he,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,o,s){const u=this.b[t];if(u){if(o&&!u.description){u.description=o,this.d.properties[t].markdownDescription=`${o} $(${t})`;const S=this.e.enum.indexOf(t);S!==-1&&(this.e.enumDescriptions[S]=o),this.a.fire()}return u}const g={id:t,description:o,defaults:f,deprecationMessage:s};this.b[t]=g;const b={$ref:"#/definitions/icons"};return s&&(b.deprecationMessage=s),o&&(b.markdownDescription=`${o}: $(${t})`),this.d.properties[t]=b,this.e.enum.push(t),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const o=this.f[t];return o||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(u,g)=>u.id.localeCompare(g.id),f=u=>{for(;A.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(u=>this.b[u]);for(const u of s.filter(g=>!!g.description).sort(t))o.push(`|<i class="${f(u)}"></i>|${u.id}|${A.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const u of s.filter(g=>!A.ThemeIcon.isThemeIcon(g.defaults)).sort(t))o.push(`|<i class="${f(u)}"></i>|${u.id}|`);return o.join(`
`)}}const d=new v;P.$ho.add(e.$kx.IconContribution,d);function h(r,t,f,o){return d.registerIcon(r,t,f,o)}function c(){return d}function i(){const r=(0,M.$Vj)();for(const t in r){const f="\\"+r[t].toString(16);d.registerIcon(t,{fontCharacter:f})}}i(),e.$nx="vscode://schemas/icons";const n=P.$ho.as(I.$io.JSONContribution);n.registerSchema(e.$nx,d.getIconSchema());const a=new l.$Mh(()=>n.notifySchemaChanged(e.$nx),200);d.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$ox=h("widget-close",L.$Zj.close,(0,k.localize)(2,null)),e.$px=h("goto-previous-location",L.$Zj.arrowUp,(0,k.localize)(3,null)),e.$qx=h("goto-next-location",L.$Zj.arrowDown,(0,k.localize)(4,null)),e.$rx=A.ThemeIcon.modify(L.$Zj.sync,"spin"),e.$sx=A.ThemeIcon.modify(L.$Zj.loading,"spin")}),define(ke[88],De([1,0,4,2,56,5,11]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zw=e.$yw=e.$vw=e.$tw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$pw=e.$ow=void 0,e.$qw=k,e.$rw=P,e.$sw=p,e.$uw=E,e.$ww=v,e.$xw=d,e.$ow=(0,A.$Ai)("tunnelService"),e.$pw=(0,A.$Ai)("sharedTunnelsService");var w;(function(i){i.Http="http",i.Https="https"})(w||(e.TunnelProtocol=w={}));var $;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})($||(e.TunnelPrivacyId=$={}));function k(i){return!!i.forwardPort}var I;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(I||(e.ProvidedOnAutoForward=I={}));function P(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(n)return{address:n[1],port:+n[2]}}function p(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const n=i.query.split("&");for(const a of n){const r=a.split("=")[1];if(/^https?:/.exec(r)){const t=P(L.URI.parse(r));if(t)return t}}}e.$tw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(i){return e.$tw.indexOf(i)>=0}e.$vw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(i){return e.$vw.indexOf(i)>=0}function d(i,n,a,r){if(a===1)return!1;if(a===2&&v(n)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(t?.length===4&&parseInt(t[1])>=18)return!1}return i<1024}class h{constructor(n,a,r){this.remoteAddress=n,this.localAddress=a,this.b=r,this.a=new l.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$yw=h;let c=class{constructor(n,a){this.k=n,this.l=a,this.a=new l.$he,this.onTunnelOpened=this.a.event,this.b=new l.$he,this.onTunnelClosed=this.b.event,this.c=new l.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],a=Array.from(this.e.values());for(const r of a){const t=Array.from(r.values());for(const f of t){const o=await f.value;o&&typeof o!="string"&&n.push(o)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:a}of n.values())await a.then(r=>typeof r!="string"?r?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,a,r,t,f){this.q(n,a,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:a,localAddress:r,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,a){(v(n)||E(n))&&(n=e.$tw[0]);const r=this.s(n,a);if(r)return++r.refcount,r.value}openTunnel(n,a,r,t,f,o=!1,s,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${r} on local port ${f}.`);const g=this.f??n;if(!g)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(g,a,r,t,f,o,s,u);return b?b.then(S=>{if(S){if(typeof S=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,r),S}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.o(S);return(S.tunnelRemoteHost!==a||S.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&S.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const a=this.e.get(n.tunnelRemoteHost);if(a){const r=a.get(n.tunnelRemotePort);r&&(r.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,r))}}}}async p(n,a,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${a}.`);const t=r.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(a),t}}async closeTunnel(n,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${a} `);const r=this.e.get(n);if(r&&r.has(a)){const t=r.get(a);t.refcount=0,await this.p(n,a,t)}}q(n,a,r){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(a,{refcount:1,value:r})}async r(n,a){const r=this.e.get(n);if(r){const t=r.get(a),f=t?await t.value:void 0;(!f||typeof f=="string")&&r.delete(a),r.size===0&&this.e.delete(n)}}s(n,a){const r=[n];E(n)?(r.push(...e.$tw),r.push(...e.$vw)):v(n)&&r.push(...e.$vw);const t=r.map(f=>this.e.get(f));for(const f of t){const o=f?.get(a);if(o)return o}}canTunnel(n){return!!P(n)}u(n,a,r,t,f,o,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${r} on local port ${t}.`);const u=r;this.j.add(u);const g=t===void 0?r:t,b={elevationRequired:f?this.isPortPrivileged(g):!1},S={remoteAddress:{host:a,port:r},localAddressPort:t,privacy:o,public:o?o!==$.Private:void 0,protocol:s},m=n.forwardPort(S,b);return m?(this.q(a,r,m),m.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),m}};e.$zw=c,e.$zw=c=Je([We(0,R.$7j),We(1,M.$7i)],c)}),define(ke[282],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,l.$Ai)("IUriIdentityService")}),define(ke[283],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Aw=void 0,e.$Aw=(0,l.$Ai)("editSessionIdentityService");var L;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(ke[284],De([1,0,15]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=L,e.$XL=M,e.$YL=A,e.$ZL=R,e.$1L=w;function L($){return $.scheme!==l.Schemas.file&&$.scheme!==l.Schemas.vscodeRemote}function M($){if($.folders.length)return $.folders.every(k=>L(k.uri))?$.folders[0].uri:void 0;if($.configuration&&L($.configuration))return $.configuration}function A($){return M($)?.scheme}function R($){return M($)?.authority}function w($){return M($)!==void 0}}),define(ke[42],De([1,0,223,16,78,23,2,5,15]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=k,e.$Li=I,e.$Oi=P,e.$Pi=p,e.$Qi=E,e.$Ri=d,e.$Si=h,e.$Vi=n,e.$1i=a,e.$2i=r,e.$4i=t,e.$5i=f,e.$6i=o,e.$Ji=(0,w.$Ai)("contextService");function k(s){const u=s;return typeof u?.id=="string"&&R.URI.isUri(u.uri)}function I(s){return typeof s?.id=="string"&&!k(s)&&!p(s)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function P(s,u){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,L.$nc)(s)}:u?e.$Mi:e.$Ni;const g=s;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}function p(s){const u=s;return typeof u?.id=="string"&&R.URI.isUri(u.configPath)}function E(s){const u=s;if(u?.uri)return{id:u.id,uri:R.URI.revive(u.uri)};const g=s;if(g?.configPath)return{id:g.id,configPath:R.URI.revive(g.configPath)};if(s?.id)return{id:s.id}}var v;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function d(s){const u=s;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}function h(s){const u=s;return!!(u&&typeof u=="object"&&R.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}class c{constructor(u,g,b,S,m){this.h=u,this.j=b,this.k=S,this.l=m,this.c=M.$Gi.forUris(this.l,()=>!0),this.folders=g}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=M.$Gi.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=c;class i{constructor(u,g){this.raw=g,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,A.$bh)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=i;function n(s){return new i({uri:s,index:0,name:(0,A.$0g)(s)},{uri:s.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,l.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function a(s,u){return A.$5g.isEqualOrParent(s,u.untitledWorkspacesHome)}function r(s){let u;return R.URI.isUri(s)?u=s:u=s.configuration,u?.scheme===$.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$3i}function f(s,u){return!a(s,u)&&!r(s)}function o(s){return(typeof s=="string"?(0,L.$oc)(s):(0,A.$_g)(s))===e.$Xi}}),define(ke[285],De([1,0,58,4,3,23,2,222,137,33,5,11,42,27,282,7,30,14,18]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=a,e.$Hl=r,e.$Il=t;var n;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function a(s){const u=s;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&R.URI.isUri(u.location)&&R.URI.isUri(u.globalStorageHome)&&R.URI.isUri(u.settingsResource)&&R.URI.isUri(u.keybindingsResource)&&R.URI.isUri(u.tasksResource)&&R.URI.isUri(u.snippetsHome)&&R.URI.isUri(u.extensionsResource))}e.$Gl=(0,I.$Ai)("IUserDataProfilesService");function r(s,u){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:R.URI.revive(s.location).with({scheme:u}),globalStorageHome:R.URI.revive(s.globalStorageHome).with({scheme:u}),settingsResource:R.URI.revive(s.settingsResource).with({scheme:u}),keybindingsResource:R.URI.revive(s.keybindingsResource).with({scheme:u}),tasksResource:R.URI.revive(s.tasksResource).with({scheme:u}),snippetsHome:R.URI.revive(s.snippetsHome).with({scheme:u}),extensionsResource:R.URI.revive(s.extensionsResource).with({scheme:u}),cacheHome:R.URI.revive(s.cacheHome).with({scheme:u}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,u,g,b,S,m){return{id:s,name:u,location:g,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:m&&S?.useDefaultFlags?.globalState?m.globalStorageHome:(0,A.$bh)(g,"globalStorage"),settingsResource:m&&S?.useDefaultFlags?.settings?m.settingsResource:(0,A.$bh)(g,"settings.json"),keybindingsResource:m&&S?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,A.$bh)(g,"keybindings.json"),tasksResource:m&&S?.useDefaultFlags?.tasks?m.tasksResource:(0,A.$bh)(g,"tasks.json"),snippetsHome:m&&S?.useDefaultFlags?.snippets?m.snippetsHome:(0,A.$bh)(g,"snippets"),extensionsResource:m&&S?.useDefaultFlags?.extensions?m.extensionsResource:(0,A.$bh)(g,"extensions.json"),cacheHome:(0,A.$bh)(b,s),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let f=class extends M.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,g,b,S){super(),this.t=u,this.u=g,this.w=b,this.y=S,this.f=!0,this.h=this.B(new L.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),g=[u];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,i.$ag)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}g.push(t((0,A.$$g)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},u))}}catch(m){this.y.error(m)}const b=new E.$Ac,S=new Map;if(g.length)try{const m=this.Q();if(m.workspaces)for(const[y,D]of Object.entries(m.workspaces)){const C=R.URI.parse(y),O=g.find(z=>z.id===D);O&&b.set(C,O)}if(m.emptyWindows)for(const[y,D]of Object.entries(m.emptyWindows)){const C=g.find(O=>O.id===D);C&&S.set(y,C)}}catch(m){this.y.error(m)}this.z={profiles:g,workspaces:b,emptyWindows:S}}return this.z}D(){const u=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const g="Temp",b=new RegExp(`${(0,c.$df)(g)}\\s(\\d+)`);let S=0;for(const y of this.profiles){const D=b.exec(y.name),C=D?parseInt(D[1]):0;S=C>S?C:S}const m=`${g} ${S+1}`;return this.createProfile((0,l.$oj)((0,h.$Wg)()).toString(16),m,{transient:!0},u)}async createNamedProfile(u,g,b){return this.createProfile((0,l.$oj)((0,h.$Wg)()).toString(16),u,g,b)}async createProfile(u,g,b,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(u,g,b);return S&&await this.setProfileForWorkspace(S,m),m}async F(u,g,b){if(!(0,i.$ag)(g)||!g)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(g);return S||(S=(async()=>{try{if(this.profiles.find(C=>C.name===g||C.id===u))throw new Error(`Profile with ${g} name already exists`);const y=t(u,g,(0,A.$bh)(this.profilesHome,u),this.g,b,this.defaultProfile);await this.u.createFolder(y.location);const D=[];return this.j.fire({profile:y,join(C){D.push(C)}}),await d.Promises.settled(D),this.I([y],[],[]),y}finally{this.r.delete(g)}})(),this.r.set(g,S)),S}async updateProfile(u,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(S=>S.id===u.id);if(!b)throw new Error(`Profile '${u.name}' does not exist`);return b=t(b.id,g.name??b.name,b.location,this.g,{shortName:g.shortName??b.shortName,icon:g.icon===null?void 0:g.icon??b.icon,transient:g.transient??b.isTransient,useDefaultFlags:g.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const g=this.profiles.find(S=>S.id===u.id);if(!g)throw new Error(`Profile '${u.name}' does not exist`);const b=[];this.m.fire({profile:g,join(S){b.push(S)}});try{await Promise.allSettled(b)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])g.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])g.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[g],[]);try{await this.u.del(g.cacheHome,{recursive:!0})}catch(S){(0,k.$ll)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(u,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(S=>S.id===g.id);if(!b)throw new Error(`Profile '${g.name}' does not exist`);this.L(u,b)}unsetWorkspace(u,g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,g)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(g=>g.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,g.resource))).map(g=>this.u.del(g.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(g=>!this.H(g));await Promise.allSettled(u.map(g=>this.removeProfile(g)))}getProfileForWorkspace(u){const g=this.G(u);return R.URI.isUri(g)?this.s.workspaces.get(g)??this.C.workspaces.get(g):this.s.emptyWindows.get(g)??this.C.emptyWindows.get(g)}G(u){return(0,p.$Ki)(u)?u.uri:(0,p.$Pi)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,u.location))||[...this.s.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,u.location))||[...this.C.emptyWindows.values()].some(g=>this.w.extUri.isEqual(g.location,u.location))||[...this.C.workspaces.values()].some(g=>this.w.extUri.isEqual(g.location,u.location)))}I(u,g,b){const S=[...this.profiles,...u],m=[];this.s.profiles=[];for(let y of S)y.isDefault||g.some(D=>y.id===D.id)||(y=b.find(D=>y.id===D.id)??y,y.isTransient?this.s.profiles.push(y):m.push({location:y.location,name:y.name,shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags}));this.P(m),this.z=void 0,this.J(u,g,b)}J(u,g,b){this.h.fire({added:u,removed:g,updated:b,all:this.profiles})}L(u,g,b){b=g?.isTransient?!0:b,b||this.L(u,void 0,!0);const S=this.G(u),m=b?this.s:this.C;R.URI.isUri(S)?(m.workspaces.delete(S),g&&m.workspaces.set(S,g)):(m.emptyWindows.delete(S),g&&m.emptyWindows.set(S,g)),b||this.M()}M(){const u={};for(const[b,S]of this.C.workspaces.entries())u[b.toString()]=S.id;const g={};for(const[b,S]of this.C.emptyWindows.entries())g[b.toString()]=S.id;this.R({workspaces:u,emptyWindows:g}),this.z=void 0}N(u){const g={},b=this.D();if(u.workspaces)for(const[m,y]of Object.entries(u.workspaces)){const D=R.URI.parse(y);g[m]=this.w.extUri.isEqual(D,b.location)?b.id:this.w.extUri.basename(D)}const S={};if(u.emptyWindows)for(const[m,y]of Object.entries(u.emptyWindows)){const D=R.URI.parse(y);S[m]=this.w.extUri.isEqual(D,b.location)?b.id:this.w.extUri.basename(D)}return{workspaces:g,emptyWindows:S}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Jl=f,e.$Jl=f=Je([We(0,$.$Hi),We(1,k.$7k),We(2,v.$El),We(3,P.$7j)],f);class o extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Kl=o}),define(ke[142],De([1,0,7,4,3,59,18,200,5,285]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$9p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7p=e.$6p=e.$5p=void 0,e.$8p=E,e.$0p=d,e.$_p=c,e.$5p="__$__isNewStorageMarker",e.$6p="__$__targetStorageMarker",e.$7p=(0,$.$Ai)("storageService");var I;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var P;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var p;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function E(i){const n=i.get(e.$6p);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class v extends M.$Uc{static{this.a=60*1e3}constructor(n={flushInterval:v.a}){super(),this.m=n,this.b=this.B(new L.$ke),this.c=this.B(new L.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$he),this.onWillSaveState=this.f.event,this.h=this.B(new l.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,a,r){return L.Event.filter(this.b.event,t=>t.scope===n&&(a===void 0||t.key===a),r)}n(){this.j.value=(0,l.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,a){const{key:r,external:t}=a;if(r===e.$6p){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:r,target:this.J(n)[r],external:t})}w(n){this.f.fire({reason:n})}get(n,a,r){return this.P(a)?.get(n,r)}getBoolean(n,a,r){return this.P(a)?.getBoolean(n,r)}getNumber(n,a,r){return this.P(a)?.getNumber(n,r)}getObject(n,a,r){return this.P(a)?.getObject(n,r)}storeAll(n,a){this.y(()=>{for(const r of n)this.store(r.key,r.value,r.scope,r.target,a)})}store(n,a,r,t,f=!1){if((0,R.$jg)(a)){this.remove(n,r,f);return}this.y(()=>{this.z(n,r,t),this.P(r)?.set(n,a,f)})}remove(n,a,r=!1){this.y(()=>{this.z(n,a,void 0),this.P(a)?.delete(n,r)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,a){const r=[],t=this.J(n);for(const f of Object.keys(t))t[f]===a&&r.push(f);return r}z(n,a,r,t=!1){const f=this.J(a);typeof r=="number"?f[n]!==r&&(f[n]=r,this.P(a)?.set(e.$6p,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.P(a)?.set(e.$6p,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const a=this.P(n);return a?E(a):Object.create(null)}isNew(n){return this.getBoolean(e.$5p,n)===!0}async flush(n=I.NONE){this.f.fire({reason:n});const a=this.P(-1),r=this.P(0),t=this.P(1);switch(n){case I.NONE:await l.Promises.settled([a?.whenFlushed()??Promise.resolve(),r?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await l.Promises.settled([a?.flush(0)??Promise.resolve(),r?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,a=this.P(0)?.items??new Map,r=this.P(1)?.items??new Map;return c(n,a,r,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,a){return this.w(I.NONE),(0,k.$Fl)(n)?this.R(n,a):this.S(n,a)}M(n,a){return!(n.id===a.id||d(a)&&d(n))}N(n,a,r){this.y(()=>{const t=new Set;for(const[f,o]of n)t.add(f),a.get(f)!==o&&this.u(r,{key:f,external:!0});for(const[f]of a.items)t.has(f)||this.u(r,{key:f,external:!0})})}}e.$9p=v;function d(i){return i.isDefault||!!i.useDefaultFlags?.globalState}class h extends v{constructor(){super(),this.U=this.B(new w.$3p(new w.$4p,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$3p(new w.$4p,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$3p(new w.$4p,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$$p=h;async function c(i,n,a,r,t,f){const o=C=>{try{return JSON.parse(C)}catch{return C}},s=new Map,u=new Map;i.forEach((C,O)=>{s.set(O,C),u.set(O,o(C))});const g=new Map,b=new Map;n.forEach((C,O)=>{g.set(O,C),b.set(O,o(C))});const S=new Map,m=new Map;a.forEach((C,O)=>{S.set(O,C),m.set(O,o(C))}),console.group(r!==t?`Storage: Application (path: ${r})`:`Storage: Application & Profile (path: ${r}, default profile)`);const y=[];if(s.forEach((C,O)=>{y.push({key:O,value:C})}),console.table(y),console.groupEnd(),console.log(u),r!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];g.forEach((O,z)=>{C.push({key:z,value:O})}),console.table(C),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${f})`);const D=[];S.forEach((C,O)=>{D.push({key:O,value:C})}),console.table(D),console.groupEnd(),console.log(m)}}),define(ke[112],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class l{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const A=this.c++;return this.b.set(A,M),this.e(),A}get(M,A){return this.b.has(M)?this.b.get(M)[A]:void 0}delete(M){this.b.delete(M),this.e()}e(){l.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$dmc=l}),define(ke[60],De([1,0,15,23,5]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=void 0;class A{constructor(){this.a=new Set(Object.keys(l.Schemas)),this.b=new Map,this.extUri=new L.$3g(w=>{const $=this.b.get(w.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(w,$){$===null?this.b.delete(w.scheme):this.b.set(w.scheme,$)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$imc=A,e.$jmc=(0,M.$Ai)("IExtHostFileSystemInfo")}),define(ke[28],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=void 0,e.$8O=(0,l.$Ai)("IExtHostInitDataService")}),define(ke[286],De([1,0,228,11,266,28]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;let R=class extends M.$fQ{constructor($,k,I){const P=I.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=I.remote.isRemote?(0,l.localize)(0,null):$?(0,l.localize)(1,null):(0,l.localize)(2,null);super(k.createLogger(P,{name:p}))}};e.$poc=R,e.$poc=R=Je([We(1,L.$8j),We(2,A.$8O)],R)}),define(ke[287],De([1,0,7]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=e.$1mc=void 0;class L{constructor(R,w,$){this.h=new Map,this.a=R,this.b=w,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new l.$Mh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of k.values())I.complete()}catch(I){for(const P of k.values())P.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,w){let $=this.f[R];return typeof $>"u"&&($=w),$}update(R,w){this.f[R]=w;const $=this.h.get(R);if($!==void 0)return $.p;const k=new l.$Xh;return this.h.set(R,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$1mc=L;class M extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,w){super(R.identifier.value,!0,w),this.j=R}}e.$2mc=M}),define(ke[288],De([1,0,4,2]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=void 0;class M{constructor(R){this.c=R,this.a=new l.$he,this.onDidSaveNotebookDocument=this.a.event,this.b=new l.$he,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,w,$,k){const P=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged(w.value,$,k);this.b.fire(P)}$acceptDirtyStateChanged(R,w){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty(w)}$acceptModelSaved(R){const w=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire(w.apiNotebook)}}e.$Pnc=M}),define(ke[20],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=void 0,e.$RO=(0,l.$Ai)("IExtHostRpcService");class L{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$SO=L}),define(ke[289],De([1,0,25,4]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class M{#e;constructor(R,w){this.b=new L.$he,this.onDidChange=this.b.event,this.a=l.$Vm.toKey(R.identifier),this.#e=w,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,w){return this.#e.store(this.a,R,w)}delete(R){return this.#e.delete(this.a,R)}}e.$$mc=M}),define(ke[68],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=e.$ymc=void 0,e.$ymc=(0,l.$Ai)("IURITransformerService");class L{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$zmc=L}),define(ke[290],De([1,0,22]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsb=M,e.$rsb=R;class L{constructor(){this.buffers=[]}add($){let k=this.buffers.indexOf($);return k<0&&(k=this.buffers.length,this.buffers.push($)),k}}function M(w,$){if($.serializeBuffersForPostMessage){const k=new L,P=JSON.stringify(w,(E,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(v)};if(ArrayBuffer.isView(v)){const d=A(v);if(d)return{$$vscode_array_buffer_reference$$:!0,index:k.add(v.buffer),view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),p=k.buffers.map(E=>{const v=new Uint8Array(E);return l.$Je.wrap(v)});return{message:P,buffers:p}}else return{message:JSON.stringify(w),buffers:[]}}function A(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(w,$){const k=$.map(p=>{const E=new ArrayBuffer(p.byteLength);return new Uint8Array(E).set(p.buffer),E}),I=$.length?(p,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const v=E,{index:d}=v,h=k[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(h,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return E}:void 0;return{message:JSON.parse(w,I),arrayBuffers:k}}}),define(ke[291],De([1,0,292,403,404,63,2,11,405]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=I;const k=!1;function I(n,a,r,t,f,o){const s=o.environment.useHostProxy,u=typeof s=="boolean"?s:!o.remote.isRemote,g={resolveProxy:m=>n.resolveProxy(m),lookupProxyAuthorization:h.bind(void 0,t,f,a,{},o.remote.isRemote),getProxyURL:()=>a.getConfiguration("http").get("proxy"),getProxySupport:()=>a.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(a),addCertificatesV2:()=>E(a),log:t,getLogLevel:()=>{const m=t.getLevel();switch(m){case w.LogLevel.Trace:return $.LogLevel.Trace;case w.LogLevel.Debug:return $.LogLevel.Debug;case w.LogLevel.Info:return $.LogLevel.Info;case w.LogLevel.Warning:return $.LogLevel.Warning;case w.LogLevel.Error:return $.LogLevel.Error;case w.LogLevel.Off:return $.LogLevel.Off;default:return y(m)}function y(D){return t.error("Unknown log level",D),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:u,loadAdditionalCertificates:async()=>{const m=[];if(o.remote.isRemote&&m.push((0,$.loadSystemCertificates)({log:t})),u){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const y=n.loadCertificates();y.then(D=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",D.length)),m.push(y)}return(await Promise.all(m)).flat()},env:process.env},b=(0,$.createProxyResolver)(g),S=P(g,b);return d(r,S)}function P(n,a){return{http:Object.assign(l,(0,$.createHttpPatch)(n,l,a)),https:Object.assign(L,(0,$.createHttpPatch)(n,L,a)),net:Object.assign(A,(0,$.createNetPatch)(n,A)),tls:Object.assign(M,(0,$.createTlsPatch)(n,M))}}function p(n){const a=n.getConfiguration("http");return!a.get("experimental.systemCertificatesV2",k)&&!!a.get("systemCertificates")}function E(n){const a=n.getConfiguration("http");return!!a.get("experimental.systemCertificatesV2",k)&&!!a.get("systemCertificates")}const v=new Map;function d(n,a){return n.getExtensionPathIndex().then(r=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(s,u,g){if(s==="net")return a.net;if(s==="tls")return a.tls;if(s!=="http"&&s!=="https")return f.apply(this,arguments);const b=r.findSubstr(R.URI.file(u.filename));let S=v.get(b);if(S||v.set(b,S={}),!S[s]){const m=a[s];S[s]={...m}}return S[s]}})}async function h(n,a,r,t,f,o,s,u){const g=t[o];s&&(t[o]=s),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${o}`,`proxyAuthenticate:${s}`,`proxyAuthenticateCache:${g}`);const b=s||g,S=Array.isArray(b)?b:typeof b=="string"?[b]:[];if(i(a,S,f),S.some(m=>/^(Negotiate|Kerberos)( |$)/i.test(m))&&!u.kerberosRequested)try{u.kerberosRequested=!0;const m=await new Promise((z,T)=>{le(["kerberos"],z,T)}),y=new URL(o),D=r.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${y.hostname}`:`HTTP@${y.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${o}`,`spn:${D}`),"Negotiate "+await(await m.initializeClient(D)).step("")}catch(m){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",m)}}let c=!1;function i(n,a,r){c||!a.length||(c=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:a.map(t=>t.split(" ")[0]).join(","),extensionHostType:r?"remote":"local"}))}}),define(ke[293],De([1,0,134]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=M;function L(A){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:A,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function M(A){return new l.$Cn(L(A))}}),define(ke[143],De([1,0,238,18,2,3,5,36,33,15,47,192,41]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$YF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$OF=e.EditorInputCapabilities=e.$NF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0,e.$EF=d,e.$FF=h,e.$GF=c,e.$HF=i,e.$IF=n,e.$JF=a,e.$KF=r,e.$LF=t,e.$MF=f,e.$PF=S,e.$QF=y,e.$RF=D,e.$SF=C,e.$TF=O,e.$UF=z,e.$VF=T,e.$WF=F,e.$XF=H,e.$ZF=_,e.$1F=oe,e.$2F=Pe,e.$3F=me,e.$zF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$AF={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.$BF="workbench.editor.sidebysideEditor",e.$CF="workbench.editors.textDiffEditor",e.$DF="workbench.editors.binaryResourceDiffEditor";var E;(function(U){U[U.PROGRAMMATIC=1]="PROGRAMMATIC",U[U.USER=2]="USER",U[U.EDIT=3]="EDIT",U[U.NAVIGATION=4]="NAVIGATION",U[U.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var v;(function(U){U[U.IDENTICAL=1]="IDENTICAL",U[U.SIMILAR=2]="SIMILAR",U[U.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function d(U){const Y=U;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}function h(U){const Y=U;return!!Y&&typeof Y.getScrollPosition=="function"&&typeof Y.setScrollPosition=="function"&&!!Y.onDidChangeScroll}function c(U,Y,pe){for(const ce of pe.visibleEditorPanes)if(ce.group.id===Y&&U.matches(ce.input))return ce.getViewState()}function i(U){if(S(U))return!1;const Y=U;return M.URI.isUri(Y?.resource)}function n(U){if(S(U))return!1;const Y=U;return Y?.original!==void 0&&Y.modified!==void 0}function a(U){if(S(U))return!1;const Y=U;return!Y||Y.resources&&!Array.isArray(Y.resources)?!1:!!Y.resources||!!Y.multiDiffSource}function r(U){if(S(U)||n(U))return!1;const Y=U;return Y?.primary!==void 0&&Y.secondary!==void 0}function t(U){if(S(U))return!1;const Y=U;return Y?Y.resource===void 0||Y.resource.scheme===k.Schemas.untitled||Y.forceUntitled===!0:!1}function f(U){if(S(U))return!1;const Y=U;return M.URI.isUri(Y?.base?.resource)&&M.URI.isUri(Y?.input1?.resource)&&M.URI.isUri(Y?.input2?.resource)&&M.URI.isUri(Y?.result?.resource)}var o;(function(U){U[U.SHORT=0]="SHORT",U[U.MEDIUM=1]="MEDIUM",U[U.LONG=2]="LONG"})(o||(e.Verbosity=o={}));var s;(function(U){U[U.EXPLICIT=1]="EXPLICIT",U[U.AUTO=2]="AUTO",U[U.FOCUS_CHANGE=3]="FOCUS_CHANGE",U[U.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class u{constructor(){this.a=new Map}registerSource(Y,pe){let ce=this.a.get(Y);return ce||(ce={source:Y,label:pe},this.a.set(Y,ce)),ce.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$NF=new u;var g;(function(U){U[U.None=0]="None",U[U.Readonly=2]="Readonly",U[U.Untitled=4]="Untitled",U[U.Singleton=8]="Singleton",U[U.RequiresTrust=16]="RequiresTrust",U[U.CanSplitInGroup=32]="CanSplitInGroup",U[U.ForceDescription=64]="ForceDescription",U[U.CanDropIntoEditor=128]="CanDropIntoEditor",U[U.MultipleEditors=256]="MultipleEditors",U[U.Scratchpad=512]="Scratchpad"})(g||(e.EditorInputCapabilities=g={}));class b extends A.$Uc{}e.$OF=b;function S(U){return U instanceof b}function m(U){const Y=U;return M.URI.isUri(Y?.preferredResource)}function y(U){const Y=U;return S(Y?.primary)&&S(Y?.secondary)}function D(U){const Y=U;return S(Y?.modified)&&S(Y?.original)}function C(U,Y,pe,ce,ae){return me(ce,[(0,P.$kj)({id:"workbench.action.openLargeFile",label:(0,l.localize)(2,null),run:()=>{const se={...pe,limits:{size:Number.MAX_VALUE}};U.openEditor(Y,se)}}),(0,P.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,l.localize)(3,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function O(U){return S(U?.editor)}function z(U){const Y=U;return O(U)&&Y?.group!==void 0}function T(U){const Y=U;return typeof Y?.groupId=="number"&&S(Y.editor)}function F(U){return typeof U?.groupId=="number"}var N;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.REPLACE=1]="REPLACE",U[U.MOVE=2]="MOVE",U[U.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var j;(function(U){U[U.GROUP_ACTIVE=0]="GROUP_ACTIVE",U[U.GROUP_INDEX=1]="GROUP_INDEX",U[U.GROUP_LABEL=2]="GROUP_LABEL",U[U.GROUP_LOCKED=3]="GROUP_LOCKED",U[U.EDITOR_OPEN=4]="EDITOR_OPEN",U[U.EDITOR_CLOSE=5]="EDITOR_CLOSE",U[U.EDITOR_MOVE=6]="EDITOR_MOVE",U[U.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",U[U.EDITOR_LABEL=8]="EDITOR_LABEL",U[U.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",U[U.EDITOR_PIN=10]="EDITOR_PIN",U[U.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",U[U.EDITOR_SELECTION=12]="EDITOR_SELECTION",U[U.EDITOR_STICKY=13]="EDITOR_STICKY",U[U.EDITOR_DIRTY=14]="EDITOR_DIRTY",U[U.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var B;(function(U){U[U.PRIMARY=1]="PRIMARY",U[U.SECONDARY=2]="SECONDARY",U[U.BOTH=3]="BOTH",U[U.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class X{getOriginalUri(Y,pe){if(!Y)return;if(f(Y))return e.$YF.getOriginalUri(Y.result,pe);if(pe?.supportSideBySide){const{primary:ae,secondary:se}=this.a(Y);if(ae&&se){if(pe?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:pe.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:pe.filterByScheme})};if(pe?.supportSideBySide===B.ANY)return this.getOriginalUri(ae,{filterByScheme:pe.filterByScheme})??this.getOriginalUri(se,{filterByScheme:pe.filterByScheme});Y=pe.supportSideBySide===B.PRIMARY?ae:se}}if(n(Y)||a(Y)||r(Y)||f(Y))return;const ce=m(Y)?Y.preferredResource:Y.resource;return!ce||!pe||!pe.filterByScheme?ce:this.b(ce,pe.filterByScheme)}a(Y){return y(Y)||r(Y)?{primary:Y.primary,secondary:Y.secondary}:D(Y)||n(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,pe){if(!Y)return;if(f(Y))return e.$YF.getCanonicalUri(Y.result,pe);if(pe?.supportSideBySide){const{primary:ae,secondary:se}=this.a(Y);if(ae&&se){if(pe?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:pe.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:pe.filterByScheme})};if(pe?.supportSideBySide===B.ANY)return this.getCanonicalUri(ae,{filterByScheme:pe.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:pe.filterByScheme});Y=pe.supportSideBySide===B.PRIMARY?ae:se}}if(n(Y)||a(Y)||r(Y)||f(Y))return;const ce=Y.resource;return!ce||!pe||!pe.filterByScheme?ce:this.b(ce,pe.filterByScheme)}b(Y,pe){if(Array.isArray(pe)){if(pe.some(ce=>Y.scheme===ce))return Y}else if(pe===Y.scheme)return Y}}var ie;(function(U){U[U.UNKNOWN=0]="UNKNOWN",U[U.KEYBOARD=1]="KEYBOARD",U[U.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function H(U,Y,pe,ce){if(!U.isSticky(Y))return!1;switch(ce.preventPinnedEditorClose){case"keyboardAndMouse":return pe===ie.MOUSE||pe===ie.KEYBOARD;case"mouse":return pe===ie.MOUSE;case"keyboard":return pe===ie.KEYBOARD}return!1}e.$YF=new X;var K;(function(U){U[U.LEFT=0]="LEFT",U[U.RIGHT=1]="RIGHT"})(K||(e.CloseDirection=K={}));class x{constructor(){this.c=new Map,this.d=new Map}start(Y){const pe=this.a=Y.get(R.$zi);for(const[ce,ae]of this.c)this.e(ce,ae,pe);this.c.clear()}e(Y,pe,ce){const ae=ce.createInstance(pe);this.d.set(Y,ae)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,L.$lg)(this.b)}registerEditorSerializer(Y,pe){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,pe,this.a):this.c.set(Y,pe),(0,A.$Sc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}w.$ho.add(e.$zF.EditorFactory,new x);async function _(U,Y,pe){return!U||!U.length?[]:await Promise.all(U.map(async ce=>{const ae=M.URI.revive(ce.fileUri);if(!ae){pe.info("Cannot resolve the path because it is not valid.",ce);return}if(!await Y.canHandleResource(ae)){pe.info("Cannot resolve the path because it cannot be handled",ce);return}let ue=ce.exists,Q=ce.type;if(typeof ue!="boolean"||typeof Q!="number")try{Q=(await Y.stat(ae)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ue=!0}catch($e){pe.error($e),ue=!1}if(!ue&&ce.openOnlyIfExists){pe.info("Cannot resolve the path because it does not exist",ce);return}if(Q===$.FileType.Directory){pe.info("Cannot resolve the path because it is a directory",ce);return}const re={...ce.options,pinned:!0};return ue?{resource:ae,options:re}:{resource:ae,options:re,forceUntitled:!0}}))}var ge;(function(U){U[U.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",U[U.SEQUENTIAL=1]="SEQUENTIAL"})(ge||(e.EditorsOrder=ge={}));function oe(U){const Y=U;if(!Y)return!1;const pe=Y;if(pe.modified)return oe(pe.modified);const ce=Y;return!!(ce.contributionsState&&ce.viewState&&Array.isArray(ce.cursorState))}function Pe(U){return(0,I.$mj)(U)}function me(U,Y,pe){const ce=(0,I.$nj)(U,Y);return ce.forceMessage=pe?.forceMessage,ce.forceSeverity=pe?.forceSeverity,ce.allowDialog=pe?.allowDialog,ce}}),define(ke[294],De([1,0,4,239,5,3,27,36,24,79,281]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=e.$0F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$9F=e.ViewContentGroups=e.$7F=e.ViewContainerLocation=e.Extensions=e.$6F=e.$5F=e.$4F=void 0,e.$8F=E,e.$4F="views",e.$5F=(0,L.localize)(0,null),e.$6F=(0,I.$lx)("default-view-icon",k.$Zj.window,(0,L.localize)(1,null));var P;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(P||(e.Extensions=P={}));var p;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$7F=[0,1,2];function E(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class v extends A.$Uc{constructor(){super(...arguments),this.c=this.B(new l.$he),this.onDidRegister=this.c.event,this.f=this.B(new l.$he),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(f,o,s){const u=this.get(f.id);if(u)return u;const g=f;return g.openCommandActionDescriptor=s?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,R.$xc)(this.g,o,[]).push(g),s?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:o}),g}deregisterViewContainer(f){for(const o of this.g.keys()){const s=this.g.get(o),u=s?.indexOf(f);if(u!==-1){s?.splice(u,1),s.length===0&&this.g.delete(o),this.f.fire({viewContainer:f,viewContainerLocation:o});return}}}get(f){return this.all.filter(o=>o.id===f)[0]}getViewContainers(f){return[...this.g.get(f)||[]]}getViewContainerLocation(f){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(s=>s?.id===f.id).length>0)[0]}getDefaultViewContainer(f){return this.h.find(o=>this.getViewContainerLocation(o)===f)}}w.$ho.add(P.ViewContainersRegistry,new v);var d;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(d||(e.ViewContentGroups=d={}));function h(t,f){const o=t.group??d.More,s=f.group??d.More;return o!==s?o.localeCompare(s):(t.order??5)-(f.order??5)}class c extends A.$Uc{constructor(){super(...arguments),this.c=this.B(new l.$he),this.onViewsRegistered=this.c.event,this.f=this.B(new l.$he),this.onViewsDeregistered=this.f.event,this.g=this.B(new l.$he),this.onDidChangeContainer=this.g.event,this.h=this.B(new l.$he),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Hc}registerViews(f,o){this.registerViews2([{views:f,viewContainer:o}])}registerViews2(f){f.forEach(({views:o,viewContainer:s})=>this.r(o,s)),this.c.fire(f)}deregisterViews(f,o){const s=this.s(f,o);s.length&&this.f.fire({views:s,viewContainer:o})}moveViews(f,o){for(const s of this.m.keys())if(s!==o){const u=this.s(f,s);u.length&&(this.r(u,o),this.g.fire({views:u,from:s,to:o}))}}getViews(f){return this.m.get(f)||[]}getView(f){for(const o of this.j){const s=(this.m.get(o)||[]).filter(u=>u.id===f)[0];if(s)return s}return null}getViewContainer(f){for(const o of this.j)if((this.m.get(o)||[]).filter(u=>u.id===f)[0])return o;return null}registerViewWelcomeContent(f,o){return this.n.add(f,o),this.h.fire(f),(0,A.$Sc)(()=>{this.n.delete(f,o),this.h.fire(f)})}registerViewWelcomeContent2(f,o){const s=new Map;for(const[u,g]of o)this.n.add(f,g),s.set(u,(0,A.$Sc)(()=>{this.n.delete(f,g),this.h.fire(f)}));return this.h.fire(f),s}getViewWelcomeContent(f){const o=[];return this.n.forEach(f,s=>o.push(s)),o.sort(h)}r(f,o){let s=this.m.get(o);s||(s=[],this.m.set(o,s),this.j.push(o));for(const u of f){if(this.getView(u.id)!==null)throw new Error((0,L.localize)(2,null,u.id));s.push(u)}}s(f,o){const s=this.m.get(o);if(!s)return[];const u=[],g=[];for(const b of s)f.includes(b)?u.push(b):g.push(b);return u.length&&(g.length?this.m.set(o,g):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),u}}w.$ho.add(P.ViewsRegistry,new c),e.$9F=(0,M.$Ai)("viewDescriptorService");var i;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class a{constructor(f,o){this.c=!1,this.d=!1,(0,$.$0n)(this,f),this.d=!!o,this.resolve=async s=>{if(o&&!this.c){const u=await o(s);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}s.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$0F=a;class r extends Error{constructor(f){super((0,L.localize)(3,null,f)),this.name="NoTreeViewError"}static is(f){return f.name==="NoTreeViewError"}}e.$$F=r}),define(ke[295],De([1,0,240,38]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=void 0,e.$cG=new L.$Rj("chatSessionResponseVote","",{type:"string",description:(0,l.localize)(0,null)}),e.$dG=new L.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,l.localize)(1,null)}),e.$eG=new L.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,l.localize)(2,null)}),e.$fG=new L.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,l.localize)(3,null)}),e.$gG=new L.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,l.localize)(4,null)}),e.$hG=new L.$Rj("chatResponse",!1,{type:"boolean",description:(0,l.localize)(5,null)}),e.$iG=new L.$Rj("chatRequest",!1,{type:"boolean",description:(0,l.localize)(6,null)}),e.$jG=new L.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,l.localize)(7,null)}),e.$kG=new L.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,l.localize)(8,null)}),e.$lG=new L.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,l.localize)(9,null)}),e.$mG=new L.$Rj("inChatInput",!1,{type:"boolean",description:(0,l.localize)(10,null)}),e.$nG=new L.$Rj("inChat",!1,{type:"boolean",description:(0,l.localize)(11,null)}),e.$oG=new L.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,l.localize)(12,null)}),e.$pG=new L.$Rj("chatCursorAtTop",!1),e.$qG=new L.$Rj("chatInputHasAgent",!1),e.$rG=new L.$Rj("chatLocation",void 0)}),define(ke[296],De([1,0,7,21,4,39,3,53,171,14,38,5,11,108,274,142,295]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.ChatAgentLocation=void 0,e.$vH=t,e.$wH=f;var i;(function(o){o.Panel="panel",o.Terminal="terminal",o.Notebook="notebook",o.Editor="editor"})(i||(e.ChatAgentLocation=i={})),function(o){function s(u){switch(u){case"panel":return o.Panel;case"terminal":return o.Terminal;case"notebook":return o.Notebook;case"editor":return o.Editor}return o.Panel}o.fromRaw=s}(i||(e.ChatAgentLocation=i={})),e.$qH=(0,P.$Ai)("chatAgentService");let n=class{static{this.AGENT_LEADER="@"}constructor(s){this.f=s,this.b=[],this.d=new M.$he,this.onDidChangeAgents=this.d.event,this.e=h.$oG.bindTo(this.f)}registerAgent(s,u){if(this.getAgent(s))throw new Error(`Agent already registered: ${JSON.stringify(s)}`);const b=this,S=u.slashCommands;u={...u,get slashCommands(){return S.filter(y=>!y.when||b.f.contextMatchesRules(I.$yj.deserialize(y.when)))}};const m={data:u};return this.b.push(m),(0,R.$Sc)(()=>{this.b=this.b.filter(y=>y!==m),this.d.fire(void 0)})}registerAgentImplementation(s,u){const g=this.g(s);if(!g)throw new Error(`Unknown agent: ${JSON.stringify(s)}`);if(g.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(s)}`);return g.data.isDefault&&this.e.set(!0),g.impl=u,this.d.fire(new a(g.data,u)),(0,R.$Sc)(()=>{g.impl=void 0,this.d.fire(void 0),g.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(s,u){s.isDynamic=!0;const g={data:s,impl:u};return this.b.push(g),this.d.fire(new a(s,u)),(0,R.$Sc)(()=>{this.b=this.b.filter(b=>b!==g),this.d.fire(void 0)})}updateAgent(s,u){const g=this.g(s);if(!g?.impl)throw new Error(`No activated agent with id ${JSON.stringify(s)} registered`);g.data.metadata={...g.data.metadata,...u},this.d.fire(new a(g.data,g.impl))}getDefaultAgent(s){return this.getActivatedAgents().find(u=>!!u.isDefault&&u.locations.includes(s))}getContributedDefaultAgent(s){return this.getAgents().find(u=>!!u.isDefault&&u.locations.includes(s))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),s=>!!s.data.metadata.isSecondary)?.data}g(s){return this.b.find(u=>u.data.id===s)}getAgent(s){return this.g(s)?.data}getAgentByFullyQualifiedId(s){return this.b.find(u=>t(u.data)===s)?.data}getAgents(){return this.b.map(s=>s.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(s=>!!s.impl).map(s=>new a(s.data,s.impl))}getAgentsByName(s){return this.getAgents().filter(u=>u.name===s)}async invokeAgent(s,u,g,b,S){const m=this.g(s);if(!m?.impl)throw new Error(`No activated agent with id ${s}`);return await m.impl.invoke(u,g,b,S)}async getFollowups(s,u,g,b,S){const m=this.g(s);if(!m?.impl)throw new Error(`No activated agent with id ${s}`);return m.impl?.provideFollowups?m.impl.provideFollowups(u,g,b,S):[]}};e.$rH=n,e.$rH=n=Je([We(0,I.$Sj)],n);class a{constructor(s,u){this.b=s,this.d=u}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(s,u,g,b){return this.d.invoke(s,u,g,b)}async provideFollowups(s,u,g,b){return this.d.provideFollowups?this.d.provideFollowups(s,u,g,b):[]}provideWelcomeMessage(s,u){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(s,u)}provideSampleQuestions(s,u){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(s,u)}}e.$sH=a,e.$tH=(0,P.$Ai)("chatAgentNameService");let r=class{static{c=this}static{this.b="chat.participantNameRegistry"}constructor(s,u,g,b){if(this.g=u,this.h=g,this.i=b,this.e=(0,$.$3d)(this,Object.create(null)),this.f=!1,!s.chatParticipantRegistry)return;this.d=s.chatParticipantRegistry;const S=b.get(c.b,-1);try{this.e.set(JSON.parse(S??"{}"),void 0)}catch{b.remove(c.b,-1)}this.j()}j(){this.f||this.k().catch(s=>this.h.warn("Failed to fetch chat participant registry",s)).then(()=>(0,l.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const s=await this.g.request({type:"GET",url:this.d},L.CancellationToken.None);if(s.res.statusCode!==200)throw new Error("Could not get extensions report.");const u=await(0,v.$Zp)(s);if(!u||u.version!==1)throw new Error("Unexpected chat participant registry response.");const g=u.restrictedChatParticipants;this.e.set(g,void 0),this.i.store(c.b,JSON.stringify(g),-1,1)}getAgentNameRestriction(s){const u=this.l(s.name,s).get(),g=!s.fullName||this.l(s.fullName.replace(/\s/g,""),s).get();return u&&g}l(s,u){return this.e.map(b=>b[s.toLowerCase()]).map(b=>b?b.some(S=>(0,k.$Bf)(S,S.includes(".")?u.extensionId.value:u.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$uH=r,e.$uH=r=c=Je([We(0,E.$nk),We(1,v.$Tp),We(2,p.$7j),We(3,d.$7p)],r);function t(o){return`${o.extensionId.value}.${o.id}`}function f(o){const s="name"in o?o:{...o,name:o.id};return"extensionPublisherId"in s||(s.extensionPublisherId=s.extensionPublisher??""),"extensionDisplayName"in s||(s.extensionDisplayName=""),(0,w.$0h)(s)}}),define(ke[297],De([1,0,2,29,5]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3G=e.$2G=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$ZG=A,e.$1G=R;function A(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof l.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(L.$At.isIRange)}function R(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(A)}var w;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(w||(e.ChatAgentVoteDirection=w={}));var $;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$2G=(0,M.$Ai)("IChatService"),e.$3G="accessibility.voice.keywordActivation"}),define(ke[144],De([1,0,4,7,241]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsb=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new l.$he,this.o=new l.$he,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(w){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=w}onEvent(w){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=w}onRequest(w){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.u("response",w)}sendRequest(w,$,k,I){const P={command:w};if($&&Object.keys($).length>0&&(P.arguments=$),this.u("request",P),typeof I=="number"){const p=setTimeout(()=>{clearTimeout(p);const E=this.f.get(P.seq);if(E){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:w,message:(0,M.localize)(0,null,I,w)};E(v)}},I)}return k&&this.f.set(P.seq,k),P.seq}acceptMessage(w){this.k?this.k(w):(this.m.push(w),this.m.length===1&&this.s())}q(w,$){return w.type!=="event"||$.type!=="event"}async s(){let w;for(;this.m.length;){if((!w||this.q(this.m[0],w))&&await(0,L.$Bh)(0),w=this.m.shift(),!w)return;switch(w.type){case"event":this.j?.(w);break;case"request":this.g?.(w);break;case"response":{const $=w,k=this.f.get($.request_seq);k&&(this.f.delete($.request_seq),k($));break}}}}u(w,$){$.type=w,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach(($,k)=>w.set(k,$)),await(0,L.$Bh)(500),w.forEach(($,k)=>{$({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Dsb=A}),define(ke[298],De([1,0,2,242,38,5]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$MJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$KJ=e.MemoryRangeType=e.State=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=void 0,e.$JJ=$,e.$LJ=I,e.$xI="workbench.view.debug",e.$yI="workbench.debug.variablesView",e.$zI="workbench.debug.watchExpressionsView",e.$AI="workbench.debug.callStackView",e.$BI="workbench.debug.loadedScriptsView",e.$CI="workbench.debug.breakPointsView",e.$DI="workbench.debug.disassemblyView",e.$EI="workbench.panel.repl",e.$FI="workbench.panel.repl.view",e.$GI=new M.$Rj("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.$HI=new M.$Rj("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.$II=new M.$Rj("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.$JI="debugUx",e.$KI=new M.$Rj(e.$JI,"default",{type:"string",description:L.localize(3,null)}),e.$LI=new M.$Rj("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.$MI=new M.$Rj("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.$NI=new M.$Rj("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.$OI=new M.$Rj("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.$PI=new M.$Rj("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.$QI=new M.$Rj("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.$RI=new M.$Rj("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.$SI=new M.$Rj("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.$TI=new M.$Rj("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.$UI=new M.$Rj("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.$VI=new M.$Rj("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.$WI=new M.$Rj("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.$XI=new M.$Rj("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.$YI=new M.$Rj("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.$ZI=new M.$Rj("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.$1I=new M.$Rj("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.$2I=new M.$Rj("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.$3I=new M.$Rj("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.$4I=new M.$Rj("breakpointItemBytes",void 0,{type:"boolean",description:L.localize(22,null)}),e.$5I=new M.$Rj("breakpointHasModes",!1,{type:"boolean",description:L.localize(23,null)}),e.$6I=new M.$Rj("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(24,null)}),e.$7I=new M.$Rj("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(25,null)}),e.$8I=new M.$Rj("loadedScriptsItemType",void 0,{type:"string",description:L.localize(26,null)}),e.$9I=new M.$Rj("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(27,null)}),e.$0I=new M.$Rj("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(28,null)}),e.$$I=new M.$Rj("stepBackSupported",!1,{type:"boolean",description:L.localize(29,null)}),e.$_I=new M.$Rj("restartFrameSupported",!1,{type:"boolean",description:L.localize(30,null)}),e.$aJ=new M.$Rj("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(31,null)}),e.$bJ=new M.$Rj("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(32,null)}),e.$cJ=new M.$Rj("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(33,null)}),e.$dJ=new M.$Rj("breakpointsExist",!1,{type:"boolean",description:L.localize(34,null)}),e.$eJ=new M.$Rj("debuggersAvailable",!1,{type:"boolean",description:L.localize(35,null)}),e.$fJ=new M.$Rj("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(36,null)}),e.$gJ=new M.$Rj("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(37,null)}),e.$hJ=new M.$Rj("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.$iJ=new M.$Rj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.$jJ=new M.$Rj("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.$kJ=new M.$Rj("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.$lJ=new M.$Rj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.$mJ=new M.$Rj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(43,null)}),e.$nJ=new M.$Rj("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(44,null)}),e.$oJ=new M.$Rj("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(45,null)}),e.$pJ=new M.$Rj("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(46,null)}),e.$qJ=new M.$Rj("variableIsReadonly",!1,{type:"boolean",description:L.localize(47,null)}),e.$rJ=new M.$Rj("variableValue",!1,{type:"string",description:L.localize(48,null)}),e.$sJ=new M.$Rj("variableType",!1,{type:"string",description:L.localize(49,null)}),e.$tJ=new M.$Rj("variableInterfaces",!1,{type:"array",description:L.localize(50,null)}),e.$uJ=new M.$Rj("variableName",!1,{type:"string",description:L.localize(51,null)}),e.$vJ=new M.$Rj("variableLanguage",!1,{type:"string",description:L.localize(52,null)}),e.$wJ=new M.$Rj("variableExtensionId",!1,{type:"string",description:L.localize(53,null)}),e.$xJ=new M.$Rj("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(54,null)}),e.$yJ=new M.$Rj("multiSessionRepl",!1,{type:"boolean",description:L.localize(55,null)}),e.$zJ=new M.$Rj("multiSessionDebug",!1,{type:"boolean",description:L.localize(56,null)}),e.$AJ=new M.$Rj("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(57,null)}),e.$BJ=new M.$Rj("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(58,null)}),e.$CJ=new M.$Rj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(59,null)}),e.$DJ=new M.$Rj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(60,null)});const R=n=>L.localize(61,null,n);e.$EJ=R,e.$FJ="editor.contrib.debug",e.$GJ="editor.contrib.breakpoint",e.$HJ="debug",e.$IJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(62,null)};var w;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(w||(e.State=w={}));function $(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$KJ="vscode-debug-memory";function I(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var P;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(P||(e.DataBreakpointSetType=P={}));var p;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var E;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$MJ=(0,A.$Ai)("debugService");var v;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var d;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(d||(e.DebugVisualizationType=d={}));var h;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(h||(e.DebugTreeItemCollapsibleState=h={}));var c;(function(n){n.deserialize=a=>a,n.serialize=a=>a})(c||(e.IDebugVisualizationTreeItem=c={}));var i;(function(n){n.deserialize=a=>({id:a.id,name:a.name,iconPath:a.iconPath&&{light:l.URI.revive(a.iconPath.light),dark:l.URI.revive(a.iconPath.dark)},iconClass:a.iconClass,visualization:a.visualization}),n.serialize=a=>a})(i||(e.IDebugVisualization=i={}))}),define(ke[299],De([1,0,14,2,16,24,15,29,21,19]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=void 0,e.$zH=P,e.$AH=p,e.$BH=E,e.$CH=v,e.$DH=d,e.$EH=h,e.$FH=c,e.$GH=n,e.$HH=t,e.$IH=f,e.$JH=s,e.$KH=g;const I=/{([^}]+)}/g;function P(S,m,y){return S.replace(I,function(D,C){return m&&C.length>0&&C[0]!=="_"?D:y&&y.hasOwnProperty(C)?y[C]:D})}function p(S){const m={};for(const y of Object.keys(S))y.startsWith("!")||(m[y]=S[y]);return m}function E(S){return S.configuration.request==="attach"&&!v(S)&&(!S.parentSession||E(S.parentSession))}function v(S){let m=S.configuration.type;if(m)return m==="vslsShare"&&(m=S.configuration.adapterProxy.configuration.type),(0,l.$Bf)(m,"extensionhost")||(0,l.$Bf)(m,"pwa-extensionhost")?S:S.parentSession?v(S.parentSession):void 0}function d(S){return S.type&&(S.label||S.program||S.runtime)}function h(S,m,y){let D,C=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=O.exec(S);){const T=z.index+1,F=T+z[0].length;if(T<=m&&F>=y){D=z[0],C=T;break}}if(D){const T=/\w+/g;let F=null;for(;(F=T.exec(D))&&!(F.index+1+C+F[0].length>=y););F&&(D=D.substring(0,T.lastIndex))}return D?{start:C,end:C+D.length-1}:{start:0,end:0}}async function c(S,m,y,D){if(S.evaluatableExpressionProvider.has(m)){const C=S.evaluatableExpressionProvider.ordered(m),O=(0,k.$Hb)(await Promise.all(C.map(async z=>{try{return await z.provideEvaluatableExpression(m,y,D??$.CancellationToken.None)}catch{return}})));if(O.length>0){let z=O[0].expression;const T=O[0].range;return z||(z=m.getLineContent(y.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:z}}}else{const C=m.getLineContent(y.lineNumber),{start:O,end:z}=h(C,y.column,y.column),T=C.substring(O-1,z);return{matchingExpression:T,range:new w.$At(y.lineNumber,O,y.lineNumber,O+T.length)}}return null}const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(S){return!!(S&&S.match(i))}function a(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(n(S.path))return L.URI.parse(S.path);if((0,M.$ic)(S.path))return L.URI.file(S.path)}return S.path}function r(S){if(typeof S.path=="object"){const m=L.URI.revive(S.path);if(m)return m.scheme===R.Schemas.file?m.fsPath:m.toString()}return S.path}function t(S,m){const y=m?a:r,D=(0,A.$7n)(S);return o(D,(C,O)=>{C&&O&&(O.path=y(O))}),D}function f(S,m){const y=m?a:r,D=(0,A.$7n)(S);return o(D,(C,O)=>{!C&&O&&(O.path=y(O))}),D}function o(S,m){switch(S.type){case"event":{const y=S;switch(y.event){case"output":m(!1,y.body.source);break;case"loadedSource":m(!1,y.body.source);break;case"breakpoint":m(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=S;switch(y.command){case"setBreakpoints":m(!0,y.arguments.source);break;case"breakpointLocations":m(!0,y.arguments.source);break;case"source":m(!0,y.arguments.source);break;case"gotoTargets":m(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(D=>m(!1,D));break;default:break}break}case"response":{const y=S;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(D=>m(!1,D.source));break;case"loadedSources":y.body.sources.forEach(D=>m(!1,D));break;case"scopes":y.body.scopes.forEach(D=>m(!1,D.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(D=>m(!1,D.source));break;case"setBreakpoints":y.body.breakpoints.forEach(D=>m(!1,D.source));break;case"disassemble":y.body?.instructions.forEach(C=>m(!1,C.location));break;default:break}break}}}function s(S){return S.filter(m=>!m.presentation?.hidden).sort((m,y)=>m.presentation?y.presentation?m.presentation.group?y.presentation.group?m.presentation.group!==y.presentation.group?m.presentation.group.localeCompare(y.presentation.group):u(m.presentation.order,y.presentation.order):-1:y.presentation.group?1:u(m.presentation.order,y.presentation.order):-1:y.presentation?1:0)}function u(S,m){return typeof S!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:S-m}async function g(S,m){const y=S.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(y!=="none"&&(await m.saveAll(),y==="allEditorsInActiveGroup")){const D=m.activeEditorPane;D&&D.input.resource?.scheme===R.Schemas.untitled&&await m.save({editor:D.input,groupId:D.group.id})}await S.reloadConfiguration()}const b=(S,m)=>!S||!m?S===m:S.name===m.name&&S.path===m.path&&S.sourceReference===m.sourceReference;e.$LH=b}),define(ke[300],De([1,0,55,63,24,16,12,14,32,243,144]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=e.$yoc=e.$xoc=e.$woc=e.$voc=void 0;class P extends I.$Dsb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(c,i){this.l=i,this.p=Buffer.allocUnsafe(0),this.r=-1,c.on("data",n=>this.v(n))}sendMessage(c){if(this.l){const i=JSON.stringify(c);this.l.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${P.a}${i}`,"utf8")}}v(c){for(this.p=Buffer.concat([this.p,c]);;){if(this.r>=0){if(this.p.length>=this.r){const i=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.n.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.p.indexOf(P.a);if(i!==-1){const a=this.p.toString("utf8",0,i).split(P.b);for(const r of a){const t=r.split(P.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(i+P.a.length);continue}}break}}}e.$voc=P;class p extends P{startSession(){return new Promise((c,i)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),c(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",a=>{n?this.n.fire(a):i(a)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$woc=p;class E extends p{constructor(c){super(),this.z=c}y(c){return L.createConnection(this.z.port,this.z.host||"127.0.0.1",c)}}e.$xoc=E;class v extends p{constructor(c){super(),this.z=c}y(c){return L.createConnection(this.z.path,c)}}e.$yoc=v;class d extends P{constructor(c,i){super(),this.y=c,this.z=i}async startSession(){const c=this.y.command,i=this.y.args,n=this.y.options||{};try{if(c)if(A.$ic(c)){if(!await $.Promises.exists(c))throw new Error(k.localize(0,null,c))}else c.indexOf("/")<0&&c.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let a=process.env;if(n.env&&Object.keys(n.env).length>0&&(a=M.$0n(M.$7n(process.env),n.env)),c==="node")if(Array.isArray(i)&&i.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:a,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const f=l.fork(i[0],i.slice(1),t);if(!f.pid)throw new Error(k.localize(2,null,i[0]));this.x=f}else throw new Error(k.localize(3,null));else{const r={env:a};n.cwd&&(r.cwd=n.cwd),this.x=l.spawn(c,i,r)}this.x.on("error",r=>{this.n.fire(r)}),this.x.on("exit",(r,t)=>{this.o.fire(r)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",r=>{this.n.fire(r)}),this.x.stdin.on("error",r=>{this.n.fire(r)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(a){this.n.fire(a)}}async stopSession(){return this.x?(await this.w(),R.$i?new Promise((c,i)=>{const n=l.exec(`taskkill /F /T /PID ${this.x.pid}`,function(a,r,t){if(a)return i(a)});n.on("exit",c),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(c,i){if(!c)return;const n=Object.create(null);c.runtime&&(c.runtime.indexOf("./")===0?n.runtime=A.$jc(i,c.runtime):n.runtime=c.runtime),c.runtimeArgs&&(n.runtimeArgs=c.runtimeArgs),c.program&&(A.$ic(c.program)?n.program=c.program:n.program=A.$jc(i,c.program)),c.args&&(n.args=c.args);const a=c;return a.win&&(n.win=d.A(a.win,i)),a.winx86&&(n.winx86=d.A(a.winx86,i)),a.windows&&(n.windows=d.A(a.windows,i)),a.osx&&(n.osx=d.A(a.osx,i)),a.linux&&(n.linux=d.A(a.linux,i)),n}static platformAdapterExecutable(c,i){let n=Object.create(null);i=i.toLowerCase();for(const s of c)if(s.contributes){const u=s.contributes.debuggers;u&&u.length>0&&u.filter(g=>typeof g.type=="string"&&w.$Bf(g.type,i)).forEach(g=>{const b=d.A(g,s.extensionLocation.fsPath);n=M.$0n(n,b,s.isBuiltin)})}let a;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?a=n.winx86||n.win||n.windows:R.$i?a=n.win||n.windows:R.$j?a=n.osx:R.$k&&(a=n.linux),a=a||n;const r=a.program||n.program,t=a.args||n.args,f=a.runtime||n.runtime,o=a.runtimeArgs||n.runtimeArgs;if(f)return{type:"executable",command:f,args:(o||[]).concat(typeof r=="string"?[r]:[]).concat(t||[])};if(r)return{type:"executable",command:r,args:t||[]}}}e.$zoc=d}),define(ke[301],De([1,0,55,31,12]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=R,e.$Boc=$;function A(k,I){return new Promise((P,p)=>{let E="";const v=l.spawn(k,I);v.pid&&v.stdout.on("data",d=>{E+=d.toString()}),v.on("error",d=>{p(d)}),v.on("close",d=>{P(E)})})}async function R(k){if(k)if(M.$i){const I=await new Promise((P,p)=>{le(["@vscode/windows-process-tree"],P,p)});return new Promise(P=>{I.getProcessTree(k,p=>{P(!!p&&p.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(k)]).then(I=>{const P=I.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var w;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(w||(w={}));function $(k,I,P,p,E){k=k.trim().toLowerCase();let v;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?v=1:k.indexOf("cmd.exe")>=0?v=0:k.indexOf("bash")>=0?v=2:M.$i?v=0:v=2;let d,h=" ";switch(v){case 1:if(d=c=>(c=c.replace(/\'/g,"''"),c.length>0&&c.charAt(c.length-1)==="\\"?`'${c}\\'`:`'${c}'`),p){const c=(0,L.$Fg)(p);c&&(h+=`${c}:; `),h+=`cd ${d(p)}; `}if(E)for(const c in E){const i=E[c];i===null?h+=`Remove-Item env:${c}; `:h+=`\${env:${c}}='${i}'; `}if(I.length>0){const c=I.shift(),i=P?c:d(c);h+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of I)h+=n==="<"||n===">"||P?n:d(n),h+=" "}break;case 0:if(d=c=>(c=c.replace(/\"/g,'""'),c=c.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>c.includes(i))||c.length===0?`"${c}"`:c),p){const c=(0,L.$Fg)(p);c&&(h+=`${c}: && `),h+=`cd ${d(p)} && `}if(E){h+='cmd /C "';for(const c in E){let i=E[c];i===null?h+=`set "${c}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),h+=`set "${c}=${i}" && `)}}for(const c of I)h+=c==="<"||c===">"||P?c:d(c),h+=" ";E&&(h+='"');break;case 2:{d=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const c=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(p&&(h+=`cd ${d(p)} ; `),E){h+="/usr/bin/env";for(const i in E){const n=E[i];n===null?h+=` -u ${c(i)}`:h+=` ${c(`${i}=${n}`)}`}h+=" "}for(const i of I)h+=i==="<"||i===">"||P?i:d(i),h+=" ";break}}return h}}),define(ke[302],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.CellExecutionUpdateType=void 0;var L;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$5J=(0,l.$Ai)("INotebookExecutionService")}),define(ke[303],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjb=e.$ajb=e.ProxyKernelState=e.$_ib=void 0,e.$_ib=100;var L;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.$ajb=(0,l.$Ai)("INotebookKernelService"),e.$bjb=(0,l.$Ai)("INotebookKernelHistoryService")}),define(ke[304],De([1,0,3,29,205,100]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XXb=void 0;class R extends l.$Uc{constructor($,k,I){super(),this._source=$,this.b=k,this.c=I,this.a=void 0}f($){const k=$.getLineCount();return new L.$At(1,1,k,this.g($,k))}g($,k){if(k<1||k>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const $=new M.$8C;$.acceptChunk(this._source);const k=$.finish(!0),{textBuffer:I,disposable:P}=k.create(1);this.b=I,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const k=new M.$8C;k.acceptChunk($);const I=k.finish(!0),{textBuffer:P,disposable:p}=I.create(1);return this.B(p),P})),this.a}findInInputs($){const I=new A.$VC($,!1,!1,null).parseSearchRequest();if(!I)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,I,!0,5e3)}findInOutputs($){const I=new A.$VC($,!1,!1,null).parseSearchRequest();return I?this.outputTextBuffers.map(P=>{const p=P.findMatchesLineByLine(this.f(P),I,!0,5e3);if(p.length!==0)return{textBuffer:P,matches:p}}).filter(P=>!!P):[]}}e.$XXb=R}),define(ke[69],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_K=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(A){A.Delimiter="\0"})(l||(e.TestIdPathParts=l={}));var L;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class M{static fromExtHostTestItem(R,w,$=R.parent){if(R._isRoot)return new M([w]);const k=[R.id];for(let I=$;I&&I.id!==w;I=I.parent)k.push(I.id);return k.push(w),new M(k.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const w=R.indexOf("\0");return w===-1?R:R.slice(0,w)}static fromString(R){return new M(R.split("\0"))}static join(R,w){return new M([...R.path,w])}static joinToString(R,w){return R.toString()+"\0"+w}static parentId(R){const w=R.lastIndexOf("\0");return w===-1?void 0:R.slice(0,w)}static localId(R){const w=R.lastIndexOf("\0");return w===-1?R:R.slice(w+1)}static isChild(R,w){return w.startsWith(R)&&w[R.length]==="\0"}static compare(R,w){return R===w?0:M.isChild(R,w)?2:M.isChild(w,R)?3:1}static getLengthOfCommonPrefix(R,w){if(R===0)return 0;let $=0;for(;$<R-1;){for(let k=1;k<R;k++){const I=w(k-1),P=w(k);if(I.path[$]!==P.path[$])return $}$++}return $}constructor(R,w=R.length){if(this.path=R,this.d=w,R.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new M(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new M(this.path,R)}compare(R){if(typeof R=="string")return M.compare(this.toString(),R);for(let w=0;w<R.d&&w<this.d;w++)if(R.path[w]!==this.path[w])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$_K=M}),define(ke[89],De([1,0,2,51,29,69]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$hL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$gL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$fL=e.$eL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$dL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$cL=e.$bL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$aL=e.TestResultState=void 0;var R;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$aL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var w;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var $;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$bL=[2,4,8,16,32,64];const k=N=>"runId"in N;e.$cL=k;var I;(function(N){N.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),N.deserialize=(j,B)=>({range:M.$At.lift(B.range),uri:j.asCanonicalUri(l.URI.revive(B.uri))})})(I||(e.IRichLocation=I={}));var P;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(P||(e.TestMessageType=P={}));var p;(function(N){N.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&I.serialize(j.location)}),N.deserialize=(j,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&I.deserialize(j,B.location)})})(p||(e.ITestErrorMessage=p={}));const E=(N,j)=>`${j?"s":"e"}${N}`;e.$dL=E;var v;(function(N){N.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&I.serialize(j.location)}),N.deserialize=(j,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&I.deserialize(j,B.location)})})(v||(e.ITestOutputMessage=v={}));var d;(function(N){N.serialize=j=>j.type===0?p.serialize(j):v.serialize(j),N.deserialize=(j,B)=>B.type===0?p.deserialize(j,B):v.deserialize(j,B)})(d||(e.ITestMessage=d={}));var h;(function(N){N.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),N.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(d.serialize)}),N.deserialize=(j,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(X=>d.deserialize(j,X))})})(h||(e.ITestTaskState=h={}));const c="\0",i=(N,j)=>N+c+j;e.$eL=i;const n=N=>{const j=N.indexOf(c);return{ctrlId:N.slice(0,j),tagId:N.slice(j+1)}};e.$fL=n;var a;(function(N){N.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),N.deserialize=(j,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?j.asCanonicalUri(l.URI.revive(B.uri)):void 0,range:B.range?M.$At.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(a||(e.ITestItem=a={}));var r;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var t;(function(N){N.serialize=j=>({expand:j.expand,item:a.serialize(j.item)}),N.deserialize=(j,B)=>({controllerId:A.$_K.root(B.item.extId),expand:B.expand,item:a.deserialize(j,B.item)})})(t||(e.InternalTestItem=t={}));var f;(function(N){N.serialize=j=>{let B;return j.item&&(B={},j.item.label!==void 0&&(B.label=j.item.label),j.item.tags!==void 0&&(B.tags=j.item.tags),j.item.busy!==void 0&&(B.busy=j.item.busy),j.item.uri!==void 0&&(B.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(B.range=j.item.range?.toJSON()),j.item.description!==void 0&&(B.description=j.item.description),j.item.error!==void 0&&(B.error=j.item.error),j.item.sortText!==void 0&&(B.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:B}},N.deserialize=j=>{let B;return j.item&&(B={},j.item.label!==void 0&&(B.label=j.item.label),j.item.tags!==void 0&&(B.tags=j.item.tags),j.item.busy!==void 0&&(B.busy=j.item.busy),j.item.range!==void 0&&(B.range=j.item.range?M.$At.lift(j.item.range):null),j.item.description!==void 0&&(B.description=j.item.description),j.item.error!==void 0&&(B.error=j.item.error),j.item.sortText!==void 0&&(B.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:B}}})(f||(e.ITestItemUpdate=f={}));const o=(N,j)=>{j.expand!==void 0&&(N.expand=j.expand),j.item!==void 0&&(N.item=N.item?Object.assign(N.item,j.item):j.item)};e.$gL=o;var s;(function(N){N.serializeWithoutMessages=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(h.serializeWithoutMessages)}),N.serialize=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(h.serialize)}),N.deserialize=(j,B)=>({...t.deserialize(j,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(X=>h.deserialize(j,X)),retired:!0})})(s||(e.TestResultItem=s={}));var u;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(j,B)=>{j.covered+=B.covered,j.total+=B.total}})(u||(e.ICoverageCount=u={}));var g;(function(N){N.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,testId:j.testId?.toString(),uri:j.uri.toJSON()}),N.deserialize=(j,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testId:B.testId?A.$_K.fromString(B.testId):void 0,uri:j.asCanonicalUri(l.URI.revive(B.uri))}),N.empty=(j,B)=>({id:j,uri:B,testId:void 0,statement:u.empty()})})(g||(e.IFileCoverage=g={}));function b(N){return{...N,location:N.location?.toJSON()}}function S(N){return N.location=N.location?L.$zt.isIPosition(N.location)?L.$zt.lift(N.location):M.$At.lift(N.location):void 0,N}e.$hL=3;var m;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(m||(e.DetailType=m={}));var y;(function(N){N.serialize=j=>j.type===0?C.serialize(j):O.serialize(j),N.deserialize=j=>j.type===0?C.deserialize(j):O.deserialize(j)})(y||(e.CoverageDetails=y={}));var D;(function(N){N.serialize=b,N.deserialize=S})(D||(e.IBranchCoverage=D={}));var C;(function(N){N.serialize=b,N.deserialize=S})(C||(e.IDeclarationCoverage=C={}));var O;(function(N){N.serialize=j=>({...b(j),branches:j.branches?.map(D.serialize)}),N.deserialize=j=>({...S(j),branches:j.branches?.map(D.deserialize)})})(O||(e.IStatementCoverage=O={}));var z;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var T;(function(N){N.deserialize=(j,B)=>B.op===0?{op:B.op,item:t.deserialize(j,B.item)}:B.op===1?{op:B.op,item:f.deserialize(B.item)}:B.op===2?{op:B.op,uri:j.asCanonicalUri(l.URI.revive(B.uri)),docv:B.docv}:B,N.serialize=j=>j.op===0?{op:j.op,item:t.serialize(j.item)}:j.op===1?{op:j.op,item:f.serialize(j.item)}:j})(T||(e.TestsDiffOp=T={}));class F{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const B=this.v();for(const X of j)switch(X.op){case 0:this.l(t.deserialize(this.k,X.item),B);break;case 1:this.o(f.deserialize(X.item),B);break;case 3:this.p(X.itemId,B);break;case 5:this.q(X.itemId);break;case 4:this.updatePendingRoots(X.amount);break;case 6:this.c.set(X.tag.id,X.tag);break;case 7:this.c.delete(X.id);break}B.complete?.()}l(j,B){const X=A.$_K.parentId(j.item.extId)?.toString();let ie;if(!X)ie=this.w(j),this.g.add(ie),this.f.set(j.item.extId,ie);else if(this.f.has(X)){const H=this.f.get(X);H.children.add(j.item.extId),ie=this.w(j,H),this.f.set(j.item.extId,ie)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return B.add?.(ie),j.expand===2&&this.h++,ie}o(j,B){const X=this.f.get(j.extId);if(X)return j.expand!==void 0&&(X.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$gL)(X,j),B.update?.(X),X}p(j,B){const X=this.f.get(j);if(!X)return;const ie=A.$_K.parentId(X.item.extId)?.toString();ie?this.f.get(ie).children.delete(X.item.extId):this.g.delete(X);const H=[[j]];for(;H.length;)for(const K of H.pop()){const x=this.f.get(K);x&&(H.push(x.children),this.f.delete(K),B.remove?.(x,x!==X),x.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$iL=F}),define(ke[113],De([1,0,7,4,3,62,89,69]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const k=(i,n)=>i===n,P=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:k,label:k,description:k,error:k,sortText:k,tags:(i,n)=>!(i.length!==n.length||i.some(a=>!n.includes(a)))}),p=(i,n)=>{let a;for(const[r,t]of P)t(i[r],n[r])||(a?a[r]=n[r]:a={[r]:n[r]});return a};class E extends M.$Uc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new l.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new L.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===n.uri){a.docv=n.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===n.item.extId){(0,R.$gL)(a.item,n.item);return}if(a.op===0&&a.item.item.extId===n.item.extId){(0,R.$gL)(a.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,a){const r=this.tree.get(n);if(r){if((r.expandLevels===void 0||a>r.expandLevels)&&(r.expandLevels=a),r.expand===1){const t=this.M(r);return t.isOpen()?this.L(r,a-1):t.wait().then(()=>this.L(r,a-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.L(r,a-1)):this.L(r,a-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,a){switch(a.op){case 3:this.O(w.$_K.joinToString(n.fullId,a.id));break;case 0:this.z(a.item,n);break;case 5:for(const r of a.ops)this.w(n,r);break;case 1:this.C(a.new,a.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:a.update}});break;case 6:this.y(n.actual.uri);break;default:(0,A.$ed)(a)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,a){const r=w.$_K.fromExtHostTestItem(n,this.root.id,a?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(r.toString());if(!f){f={fullId:r,actual:n,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,a);return}if(f.actual===n){this.H(n,f,a);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(r.toString()),this.z(n,a);const o=this.s.getChildren(f.actual),s=f.actual,u=p(this.s.toITestItem(s),this.s.toITestItem(n));this.s.getApiFor(s).listener=void 0,f.actual=n,f.resolveBarrier=void 0,f.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(n.tags,s.tags,r.toString()),delete u.tags),this.w(f,{op:4,update:u})),this.I(n,f,a);for(const[b,S]of o)this.s.getChildren(n).get(S.id)||this.O(w.$_K.joinToString(r,S.id));const g=f.expandLevels;g!==void 0&&queueMicrotask(()=>{f.expand===1&&(f.expandLevels=void 0,this.expand(r.toString(),g))}),this.y(f.actual.uri)}C(n,a,r){const t=new Set(a.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:r,item:{tags:n.map(f=>(0,R.$eL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const a=this.j.get(n.id);a?a.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$eL)(this.s.controllerId,n.id)}}))}F(n){const a=this.j.get(n);a&&!--a.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$eL)(this.s.controllerId,n)}))}G(n,a){this.s.getApiFor(n).parent=a&&a.actual!==this.root?a.actual:void 0}H(n,a,r){this.G(n,r);const t=this.s.getApiFor(n);t.parent=r?.actual,t.listener=f=>this.w(a,f),this.J(a)}I(n,a,r){this.H(n,a,r);for(const[t,f]of this.s.getChildren(n))this.z(f,a)}J(n){let a;this.h?n.resolveBarrier?a=n.resolveBarrier.isOpen()?3:2:a=n.actual.canResolveChildren?1:0:a=0,a!==n.expand&&(n.expand=a,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:a}}),a===1&&n.expandLevels!==void 0&&this.M(n))}L(n,a){if(a<0)return;const r=[];for(const[t,f]of this.s.getChildren(n.actual)){const o=this.expand(w.$_K.joinToString(n.fullId,f.id),a);(0,l.$mh)(o)&&r.push(o)}if(r.length)return Promise.all(r).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new l.$zh;return f.open(),f}n.expand=2,this.N(n);const a=n.resolveBarrier=new l.$zh,r=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){r(f)}return(0,l.$mh)(t)?t.catch(r).then(()=>{a.open(),this.J(n)}):(a.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const a=this.tree.get(n);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const r=[a];for(;r.length;){const t=r.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,o]of this.s.getChildren(t.actual))r.push(this.tree.get(w.$_K.joinToString(t.fullId,o.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$HO=E;class v extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$IO=v;class d extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$JO=d;class h extends Error{constructor(n,a,r){super(`TestItem with ID "${n}" is from controller "${a}" and cannot be added as a child of an item from controller "${r}".`)}}e.$KO=h;const c=(i,n,a)=>{let r=new Map;return{get size(){return r.size},forEach(t,f){for(const o of r.values())t.call(f,o,this)},[Symbol.iterator](){return r.entries()},replace(t){const f=new Map,o=new Set(r.keys()),s={op:5,ops:[]};for(const u of t){if(!(u instanceof a))throw new d(u.id);const g=n(u).controllerId;if(g!==i.controllerId)throw new h(u.id,g,i.controllerId);if(f.has(u.id))throw new v(u.id);f.set(u.id,u),o.delete(u.id),s.ops.push({op:0,item:u})}for(const u of o.keys())s.ops.push({op:3,id:u});i.listener?.(s),r=f},add(t){if(!(t instanceof a))throw new d(t.id);r.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){r.delete(t)&&i.listener?.({op:3,id:t})},get(t){return r.get(t)},toJSON(){return Array.from(r.values())}}};e.$LO=c}),define(ke[145],De([1,0,113]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0;const L=new WeakMap,M=(R,w)=>{const $={controllerId:w};return L.set(R,$),$};e.$MO=M;const A=R=>{const w=L.get(R);if(!w)throw new l.$JO(R?.id||"<unknown>");return w};e.$NO=A}),define(ke[114],De([1,0,15,2]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rBb=e.$qBb=e.$pBb=void 0,e.$sBb=M,e.$tBb=R,e.$pBb="vscode-cdn.net",e.$qBb=`vscode-resource.${e.$pBb}`,e.$rBb=`'self' https://*.${e.$pBb}`;function M(w,$){return w.scheme===l.Schemas.http||w.scheme===l.Schemas.https?w:($&&$.authority&&$.isRemote&&w.scheme===l.Schemas.file&&(w=L.URI.from({scheme:l.Schemas.vscodeRemote,authority:$.authority,path:w.path})),L.URI.from({scheme:l.Schemas.https,authority:`${w.scheme}+${A(w.authority)}.${e.$qBb}`,path:w.path,fragment:w.fragment,query:w.query}))}function A(w){return w.replace(/./g,$=>{const k=$.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?$:"-"+k.toString(16).padStart(4,"0")})}function R(w){return w.replace(/-([0-9a-f]{4})/g,($,k)=>String.fromCharCode(parseInt(k,16)))}}),define(ke[305],De([1,0,4,3,114]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class A{constructor(w,$,k){this.d=w,this.e=$,this.f=k,this.a=0,this.b=new L.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const I=$.getVisibleTextEditors();for(const P of this.c.values())I.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,$,k,I,P){let p;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===w){p=n;break}if(!p)throw new Error("not a visible editor");const E=this,v=this.a++,d=new l.$he,h=new l.$he,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,M.$sBb)(n,E.f)}get cspSource(){return M.$rBb}set options(n){this.b=n,E.d.$setOptions(v,n)}get options(){return this.b}set html(n){this.a=n,E.d.$setHtml(v,n)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(n){return E.d.$postMessage(v,n)}},i=new class{constructor(){this.editor=w,this.line=$,this.height=k,this.webview=c,this.onDidDispose=h.event}dispose(){E.c.has(v)&&(E.c.delete(v),E.d.$disposeEditorInset(v),h.fire(),h.dispose(),d.dispose())}};return this.d.$createEditorInset(v,p.id,p.value.document.uri,$+1,k,I||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:w,inset:i,onDidReceiveMessage:d}),i}$onDidDispose(w){const $=this.c.get(w);$&&$.inset.dispose()}$onDidReceiveMessage(w,$){this.c.get(w)?.onDidReceiveMessage.fire($)}}e.$wmc=A}),define(ke[146],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rL=e.$qL=e.$pL=void 0,e.$pL="__",e.$qL=(0,l.$Ai)("IAuthenticationService"),e.$rL=(0,l.$Ai)("IAuthenticationExtensionsService")}),define(ke[306],De([1,0,5]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=e.VariableKind=e.$FP=void 0,e.$FP=(0,l.$Ai)("configurationResolverService");var L;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class M extends Error{constructor(R,w){super(w),this.variable=R}}e.$GP=M}),define(ke[307],De([1,0,16,52,18,24,12,103,246,306,14]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,v,d,h){this.h=new Map,this.a=E,this.b=v,this.g=d,h&&(this.c=h.then(c=>this.i(c)))}i(E){if(R.$i){const v=Object.create(null);return Object.keys(E).forEach(d=>{v[d.toLowerCase()]=E[d]}),v}return E}resolveWithEnvironment(E,v,d){return this.l({env:this.i(E),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(E,v){const d={env:await this.c,userHome:await this.g};return this.l(d,E?E.uri:void 0,v)}async j(E,v,d,h){const c=A.$7n(v);R.$i&&c.windows?Object.keys(c.windows).forEach(n=>c[n]=c.windows[n]):R.$j&&c.osx?Object.keys(c.osx).forEach(n=>c[n]=c.osx[n]):R.$k&&c.linux&&Object.keys(c.linux).forEach(n=>c[n]=c.linux[n]),delete c.windows,delete c.osx,delete c.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,E?E.uri:void 0,c,d,h)}async resolveAnyAsync(E,v,d){return this.j(E,v,d)}async resolveAnyMap(E,v,d){const h=new Map;return{newConfig:await this.j(E,v,d,h),resolvedVariables:h}}resolveWithInteractionReplace(E,v,d,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,v,d,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,v){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,v)}async l(E,v,d,h,c){if(M.$ag(d))return this.m(E,v,d,h,c);if(Array.isArray(d))return Promise.all(d.map(i=>this.l(E,v,i,h,c)));if(M.$cg(d)){const i=Object.create(null),n=await Promise.all(Object.keys(d).map(async a=>[await this.m(E,v,a,h,c),await this.l(E,v,d[a],h,c)]));for(const[a,r]of n)i[a]=r;return i}return d}m(E,v,d,h,c){return(0,I.$tf)(d,P.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(P.VARIABLE_LHS))return i;let a=await this.o(E,i,n,v,h);return c?.set(n,a),a!==i&&M.$ag(a)&&a.match(P.VARIABLE_REGEXP)&&(a=await this.m(E,v,a,h,c)),a})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,v,d,h,c){let i;const n=d.split(":");n.length>1&&(d=n[0],i=n[1]);const a=f=>{const o=this.a.getFilePath();if(o)return(0,w.$Kw)(o);throw new k.$GP(f,(0,$.localize)(0,null,v))},r=f=>{const o=a(f);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,w.$Kw)(s)}throw new k.$GP(f,(0,$.localize)(1,null,v,l.$nc(o)))},t=f=>{if(i){const o=this.a.getFolderUri(i);if(o)return o;throw new k.$GP(f,(0,$.localize)(2,null,v,i))}if(h)return h;throw this.a.getWorkspaceFolderCount()>1?new k.$GP(f,(0,$.localize)(3,null,v)):new k.$GP(f,(0,$.localize)(4,null,v))};switch(d){case"env":if(i){if(E.env){const f=E.env[R.$i?i.toLowerCase():i];if(M.$ag(f))return f}return""}throw new k.$GP(k.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(i){const f=this.a.getConfigurationValue(h,i);if(M.$jg(f))throw new k.$GP(k.VariableKind.Config,(0,$.localize)(6,null,v,i));if(M.$cg(f))throw new k.$GP(k.VariableKind.Config,(0,$.localize)(7,null,v,i));return f}throw new k.$GP(k.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(k.VariableKind.Command,v,i,c,"command");case"input":return this.p(k.VariableKind.Input,v,i,c,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new k.$GP(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,i));return this.n(f.extensionLocation)}throw new k.$GP(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,w.$Kw)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return h||i?(0,w.$Kw)(this.n(t(k.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$Kw)(l.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new k.$GP(k.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new k.$GP(k.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new k.$GP(k.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return a(k.VariableKind.File);case"fileWorkspaceFolder":return r(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return l.$nc(r(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return h||i?l.$lc(this.n(t(k.VariableKind.RelativeFile)),a(k.VariableKind.RelativeFile)):a(k.VariableKind.RelativeFile);case"relativeFileDirname":{const f=l.$mc(a(k.VariableKind.RelativeFileDirname));if(h||i){const o=l.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),f);return o.length===0?".":o}return f}case"fileDirname":return l.$mc(a(k.VariableKind.FileDirname));case"fileExtname":return l.$oc(a(k.VariableKind.FileExtname));case"fileBasename":return l.$nc(a(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=l.$nc(a(k.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-l.$oc(f).length)}case"fileDirnameBasename":return l.$nc(l.$mc(a(k.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||v}case"execInstallFolder":{const f=this.a.getAppRoot();return f||v}case"pathSeparator":case"/":return l.sep;default:try{const f=i?`${d}:${i}`:d;return this.p(k.VariableKind.Unknown,v,f,c,void 0)}catch{return v}}}}p(E,v,d,h,c){if(d&&h){const i=c===void 0?h[d]:h[c+":"+d];if(typeof i=="string")return i;throw new k.$GP(E,(0,$.localize)(14,null,v))}return v}}e.$VP=P}),define(ke[147],De([1,0,5,143]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$5D=void 0,e.$6D=k,e.$7D=p,e.$8D=E,e.$5D=(0,l.$Ai)("editorGroupsService");var M;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var w;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function k(v){const d=v;return(0,L.$PF)(d?.editor)&&(0,L.$PF)(d?.replacement)}var I;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function p(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}function E(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[308],De([1,0,5,147]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_D=e.$$D=e.$0D=e.$9D=void 0,e.$aE=M,e.$9D=(0,l.$Ai)("editorService"),e.$0D=-1,e.$$D=-2,e.$_D=-3;function M(A){const R=A;return typeof A=="number"||(0,L.$7D)(R)}}),define(ke[148],De([1,0,5,137]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=void 0,e.$KL=(0,l.$Bi)(L.$Hi)}),define(ke[149],De([1,0,25,4,16,3,7]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=e.$Rac=e.$Qac=e.$Pac=void 0;class w{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$Pac=w;class ${static isHostExtension(i,n,a){if(n.getExtensionDescription(i))return!1;const r=a.getExtensionDescription(i);return r?!!((r.main||r.browser)&&r.api==="none"):!1}constructor(i,n){this.j=i,this.c=new L.$he,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(d),this.f=new l.$Xm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const a of n)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=h(this.e,n),this.e=this.e.concat(i);const a=$.l(this.e);return this.e=h(this.e,a.map(r=>r.identifier)),this.k(),this.d++,this.c.fire(void 0),new w(this.d,a)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(o){this.d.has(o)||(this.d.add(o),this.e.push(o))}addArc(o,s){this.addNode(o),this.addNode(s),this.c.has(o)?this.c.get(o).push(s):this.c.set(o,[s])}getArcs(o){return this.c.has(o)?this.c.get(o):[]}hasOnlyGoodArcs(o,s){const u=n.getArcs(o);for(let g=0;g<u.length;g++)if(!s.has(u[g]))return!1;return!0}getNodes(){return this.e}},a=new l.$Xm;for(const o of i)if(a.set(o.identifier,o),o.extensionDependencies)for(const s of o.extensionDependencies)n.addArc(l.$Vm.toKey(o.identifier),l.$Vm.toKey(s));const r=new Set;n.getNodes().filter(o=>n.getArcs(o).length===0).forEach(o=>r.add(o));const t=n.getNodes().filter(o=>!r.has(o));let f;do{f=!1;for(let o=0;o<t.length;o++){const s=t[o];n.hasOnlyGoodArcs(s,r)&&(t.splice(o,1),o--,r.add(s),f=!0)}}while(f);return t.map(o=>a.get(o))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$Qac=$;class k{constructor(i,n){this.versionId=i,this.extensions=n}}e.$Rac=k;class I{constructor(i){this.d=new E,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new P(this,n)}deltaExtensions(i,n,a){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,a)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$Sac=I;class P extends A.$Uc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$Tac=P;class p{constructor(i){this.name=i;const n=(0,R.$th)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class E{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new p(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const a=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),r=()=>{n&&(clearTimeout(a),n=!1,this.d=!1,this.e())};i.resolve((0,A.$Sc)(r))}}var v;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(v||(v={}));function d(c,i){const n=c.isBuiltin?0:c.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==a)return n-a;const r=M.$gc.basename(c.extensionLocation.path),t=M.$gc.basename(i.extensionLocation.path);return r<t?-1:r>t?1:0}function h(c,i){const n=new l.$Wm(i);return c.filter(a=>!n.has(a.identifier))}}),define(ke[309],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=e.ExtHostConnectionType=void 0,e.$rn=w,e.$sn=$;var l;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(l||(e.ExtHostConnectionType=l={}));class L{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[L.ENV_KEY]=this.pipeName}}e.$on=L;class M{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[M.ENV_KEY]="1"}}e.$pn=M;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[A.ENV_KEY]="1"}}e.$qn=A;function R(I){delete I[L.ENV_KEY],delete I[M.ENV_KEY],delete I[A.ENV_KEY]}function w(I,P){R(P),I.serialize(P)}function $(I){if(I[L.ENV_KEY])return k(I,new L(I[L.ENV_KEY]));if(I[M.ENV_KEY])return k(I,new M);if(I[A.ENV_KEY])return k(I,new A);throw new Error("No connection information defined in environment!")}function k(I,P){return R(I),P}}),define(ke[115],De([1,0,22]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$4m=R,e.$5m=w;var L;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(L||(e.UIKind=L={}));var M;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var A;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function R(k){const I=l.$Je.alloc(1);switch(k){case 0:I.writeUInt8(1,0);break;case 1:I.writeUInt8(2,0);break;case 2:I.writeUInt8(3,0);break}return I}function w(k,I){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return I===0;case 2:return I===1;case 3:return I===2;default:return!1}}var $;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],De([1,0,5,4,11,28,115,86,87,24,2,3,231]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$0O=e.$9O=void 0,e.$$O=d;let E=class extends P.$Uc{constructor(c,i){super(),this.s=c,this.t=i,this.a=this.B(new L.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=I.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$qp,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,M.$9j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,i,n){const a=this.getTelemetryDetails(),r=new v(i,n,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,r]),r.apiTelemetryLogger}$initializeTelemetryLevel(c,i,n){this.f=c,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const i=Object.create(null);switch(i["common.extname"]=`${c.publisher}.${c.name}`,i["common.extversion"]=c.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.$Mm)((0,$.$wp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const i=this.getTelemetryDetails();this.r.forEach((n,a)=>{const r=n.filter(t=>!t.isDisposed);r.length===0?this.r.delete(a):this.r.set(a,r)}),this.r.forEach(n=>{for(const a of n)a.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,i){const a=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(c.value),!1;let r=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(i),r=!0);return r}};e.$9O=E,e.$9O=E=Je([We(0,A.$8O),We(1,M.$8j)],E);class v{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,i,n,a,r,t,f){this.g=n,this.h=a,this.i=r,this.j=t,this.a=new L.$he,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(c,i){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let i="properties"in c?c.properties??{}:c;return i=(0,$.$zp)(i,[]),this.c&&(i=(0,k.$0n)(i,this.c)),this.b||(i=(0,k.$0n)(i,this.j)),"properties"in c?c.properties=i:c=i,c}k(c,i){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(c,i),this.h.trace(c,i))}logUsage(c,i){this.d.isUsageEnabled&&this.k(c,i)}logError(c,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,i);else{const n={name:c.name,message:c.message,stack:c.stack,cause:c.cause},a=(0,$.$zp)(n,[]),r=new Error(a.message,{cause:a.cause});r.stack=a.stack,r.name=a.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(r,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const c=this,i={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$0O=v;function d(h){const c=Date.now()-new Date(h).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$_O=(0,l.$Ai)("IExtHostTelemetry")}),define(ke[26],De([1,0,4,2,278,140,25,5]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TG=e.ActivationKind=e.$QG=e.$PG=e.$MG=e.ExtensionHostStartup=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$NG=p,e.$OG=E,e.$RG=c,e.$SG=i,e.$IG=Object.freeze({identifier:new R.$Vm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$JG="extensions.webWorker",e.$KG=(0,w.$Ai)("extensionService");class ${constructor(r){this.dependency=r}}e.$LG=$;var k;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(r,t,f){this.c=r,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$tG.createActivationEventsMap(this.d)}}set(r,t,f){if(this.c>r)throw new Error(`ExtensionHostExtensions: invalid versionId ${r} (current: ${this.c})`);const o=[],s=[],u=[],g=[],b=P(this.d),S=P(t),m=(z,T)=>z.extensionLocation.toString()===T.extensionLocation.toString()||z.isBuiltin===T.isBuiltin||z.isUserBuiltin===T.isUserBuiltin||z.isUnderDevelopment===T.isUnderDevelopment;for(const z of this.d){const T=S.get(z.identifier);if(!T){o.push(z.identifier),b.delete(z.identifier);continue}if(!m(z,T)){o.push(z.identifier),b.delete(z.identifier);continue}}for(const z of t){const T=b.get(z.identifier);if(!T){s.push(z);continue}if(!m(T,z)){o.push(T.identifier),b.delete(T.identifier);continue}}const y=new R.$Wm(this.e),D=new R.$Wm(f);for(const z of this.e)D.has(z)||u.push(z);for(const z of f)y.has(z)||g.push(z);const C=A.$tG.createActivationEventsMap(s),O={versionId:r,toRemove:o,toAdd:s,addActivationEvents:C,myToRemove:u,myToAdd:g};return this.delta(O),O}delta(r){if(this.c>=r.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:o,myToAdd:s}=r,u=new R.$Wm(t),g=new R.$Wm(o);for(let b=0;b<this.d.length;b++)u.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)g.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of f)this.d.push(b);for(const b of s)this.e.push(b);return this.f=null,r}containsExtension(r){for(const t of this.e)if(R.$Vm.equals(t,r))return!0;return!1}containsActivationEvent(r){return this.f||(this.f=this.g()),this.f.has(r)}g(){const r=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=A.$tG.readActivationEvents(t);for(const o of f)r.add(o)}return r}}e.$MG=I;function P(a){const r=new R.$Xm;for(const t of a)r.set(t.identifier,t);return r}function p(a,r){return a.enabledApiProposals?a.enabledApiProposals.includes(r):!1}function E(a,r){if(!p(a,r))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${r}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${r}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class v{constructor(r,t,f,o){this.codeLoadingTime=r,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=o}}e.$PG=v;class d{constructor(r,t){this.description=r,this.value=t}}e.$QG=d;var h;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(h||(e.ActivationKind=h={}));function c(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,M.$Fp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function i(a,r){return{identifier:new R.$Vm((0,M.$Dp)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!r,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,publisherDisplayName:a.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.onWillStop=l.Event.None,this.extensions=[]}activateByEvent(r){return Promise.resolve(void 0)}activateById(r,t){return Promise.resolve(void 0)}activationEventIsDone(r){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(r){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(r,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(r){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$TG=n}),define(ke[310],De([1,0,13,149,25,26,11,7]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=e.$Vmc=e.$Umc=e.$Tmc=e.$Smc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(c,i,n,a){this.startup=c,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=a}}e.$Smc=$;class k{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,i){return c===-1||i===-1?-1:i-c}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Tmc=k;class I{constructor(c,i,n,a,r,t){this.activationFailed=c,this.activationFailedError=i,this.activationTimes=n,this.module=a,this.exports=r,this.subscriptions=t}}e.$Umc=I;class P extends I{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Vmc=P;class p extends I{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wmc=p;class E extends I{constructor(c){super(!0,c,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(c,i,n,a){this.g=a,this.a=c,this.b=i,this.c=n,this.d=new M.$Xm,this.f=Object.create(null)}dispose(){for(const[c,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const c=[];for(const[i,n]of this.d)c.push(n.wait());await Promise.all(c)}isActivated(c){const i=this.d.get(c);return!!(i&&i.value)}getActivatedExtension(c){const i=this.d.get(c);if(!i||!i.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return i.value}async activateByEvent(c,i){if(this.f[c])return;const n=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(n.map(a=>({id:a.identifier,reason:{startup:i,extensionId:a.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,i){const n=this.a.getExtensionDescription(c);if(!n)throw new Error(`Extension '${c.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(c){const i=c.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const i=this.a.getExtensionDescription(c.id);if(!i){const r=new Error(`Cannot activate unknown extension '${c.id.value}'`),t=this.k(c,null,[],new E(r));return this.c.onExtensionActivationError(c.id,r,new A.$LG(c.id.value)),t}const n=[],a=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const r of a){if(this.m(r))continue;const t=this.d.get(r);if(t){n.push(t);continue}if(this.l(r)){n.push(this.j({id:this.b.getExtensionDescription(r).identifier,reason:c.reason}));continue}const f=this.a.getExtensionDescription(r);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:c.reason}));continue}const o=i.displayName||i.identifier.value,s=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${r}'`),u=this.k(c,i.displayName,[],new E(s));return this.c.onExtensionActivationError(i.identifier,s,new A.$LG(r)),u}return this.k(c,i.displayName,n,null)}k(c,i,n,a){const r=new d(c.id,i,c.reason,n,a,this.c,this.g);return this.d.set(c.id,r),r}l(c){return L.$Qac.isHostExtension(c,this.a,this.b)}m(c){const i=this.b.getExtensionDescription(c);return i?!i.main&&!i.browser:!1}};e.$Xmc=v,e.$Xmc=v=Je([We(3,R.$7j)],v);let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,i,n,a,r,t,f){this.c=c,this.d=i,this.f=n,this.g=a,this.h=r,this.j=t,this.k=f,this.a=new w.$zh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const i=this.g[c];if(i.value&&!i.value.activationFailed){this.g.splice(c,1),c--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new E(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const i=new Error;if(c&&c.name&&(i.name=c.name),c&&c.message?i.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(i.stack=c.stack),this.h=new E(i),this.b&&l.$4(c))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};d=Je([We(6,R.$7j)],d)}),define(ke[311],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[312],De([1,0,248,13,41,138,110,36,25,311,108,140]),function(le,e,l,L,M,A,R,w,$,k,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=void 0;const p=w.$ho.as(R.$io.JSONContribution);class E{constructor(r,t,f){this.a=r,this.b=t,this.c=f}d(r,t){this.a({type:r,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(r){this.d(M.default.Error,r)}warn(r){this.d(M.default.Warning,r)}info(r){this.d(M.default.Info,r)}}e.$CG=E;class v{static a(r){const t=new $.$Wm;for(let f=0,o=r.length;f<o;f++)t.add(r[f].description.identifier);return t}static compute(r,t){if(!r||!r.length)return new v(t,[]);if(!t||!t.length)return new v([],r);const f=this.a(r),o=this.a(t),s=t.filter(g=>!f.has(g.description.identifier)),u=r.filter(g=>!o.has(g.description.identifier));return new v(s,u)}constructor(r,t){this.added=r,this.removed=t}}e.$DG=v;class d{constructor(r,t){this.name=r,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(r){if(this.a!==null)throw new Error("Handler already set!");this.a=r,this.d()}acceptUsers(r){this.c=v.compute(this.b,r),this.b=r,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(r){(0,L.$1)(r)}}}e.$EG=d;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$FG={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Um},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:l.localize(15,null),type:"string",enum:["none"],enumDescriptions:[l.localize(16,null)]},activationEvents:{description:l.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(32,null)},{label:"onUri",body:"onUri",description:l.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(37,null)},{label:"onRenderer",description:l.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:l.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:l.localize(42,null)},{label:"*",description:l.localize(43,null),body:"*"}]}},badges:{type:"array",description:l.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(45,null)},href:{type:"string",description:l.localize(46,null)},description:{type:"string",description:l.localize(47,null)}}}},markdown:{type:"string",description:l.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Yo}},extensionPack:{description:l.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Yo}},extensionKind:{description:l.localize(52,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(53,null)},{body:["workspace"],description:l.localize(54,null)},{body:["ui","workspace"],description:l.localize(55,null)},{body:["workspace","ui"],description:l.localize(56,null)},{body:[],description:l.localize(57,null)}]},capabilities:{description:l.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(61,null),l.localize(62,null),l.localize(63,null)]},description:{type:"string",markdownDescription:l.localize(64,null)}}},untrustedWorkspaces:{description:l.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(67,null),l.localize(68,null),l.localize(69,null)]},restrictedConfigurations:{description:l.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(71,null)}}}}},sponsor:{description:l.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(74,null),type:"string"},"vscode:uninstall":{description:l.localize(75,null),type:"string"}}},icon:{type:"string",description:l.localize(76,null)},l10n:{type:"string",description:l.localize(77,null)},pricing:{type:"string",markdownDescription:l.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(r){if(this.a.has(r.extensionPoint))throw new Error("Duplicate extension point: "+r.extensionPoint);const t=new d(r.extensionPoint,r.defaultExtensionKind);return this.a.set(r.extensionPoint,t),r.activationEventsGenerator&&P.$tG.register(r.extensionPoint,r.activationEventsGenerator),e.$FG.properties.contributes.properties[r.extensionPoint]=r.jsonSchema,p.registerSchema(c,e.$FG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$GG=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};w.$ho.add(n.ExtensionsRegistry,new i),e.$HG=w.$ho.as(n.ExtensionsRegistry),p.registerSchema(c,e.$FG),p.registerSchema(I.$ok,{properties:{extensionEnabledApiProposals:{description:l.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(ke[313],De([1,0,244,18,24,312,38,4]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var k;(function(p){function E(v,d,h){if(!v)return;const c=L.$ag(v.type)?v.type:void 0;if(!c||c.length===0){h.error(l.localize(3,null));return}const i=[];if(Array.isArray(v.required))for(const n of v.required)L.$ag(n)&&i.push(n);return{extensionId:d.value,taskType:c,required:i,properties:v.properties?M.$7n(v.properties):{},when:v.when?R.$yj.deserialize(v.when):void 0}}p.from=E})(k||(k={}));const I=A.$HG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,E)=>{for(const v of p)v.type&&E.push(`onTaskType:${v.type}`)},jsonSchema:{description:l.localize(4,null),type:"array",items:$}});class P{constructor(){this.d=new w.$he,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,v)=>{I.setHandler((d,h)=>{this.c=void 0;try{for(const c of h.removed){const i=c.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const c of h.added){const i=c.value;for(const n of i){const a=k.from(n,c.description.identifier,c.collector);a&&(this.a[a.taskType]=a)}}(h.removed.length>0||h.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=M.$7n(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},E.push(d)}this.c={oneOf:E}}return this.c}}e.$mI=new P}),define(ke[314],De([1,0,245,18,23,24,38,313]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$wI=e.JsonSchemaVersion=e.ExecutionEngine=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$qI=e.ShellQuoting=e.$pI=e.$oI=e.$nI=void 0,e.$nI="settings",e.$oI=new R.$Rj("taskRunning",!1,l.localize(0,null)),e.$pI=l.localize2(2,"Tasks");var $;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$qI="$customized",function(N){function j(B){if(!B)return N.Strong;switch(B.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=j}($||(e.ShellQuoting=$={}));var k;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var I;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(I||(e.RevealKind=I={})),function(N){function j(B){switch(B.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=j}(I||(e.RevealKind=I={}));var P;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(N){function j(B){switch(B.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=j}(P||(e.RevealProblemKind=P={}));var p;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(p||(e.PanelKind=p={})),function(N){function j(B){switch(B.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=j}(p||(e.PanelKind=p={}));var E;(function(N){N.defaults={echo:!0,reveal:I.Always,revealProblems:P.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var v;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(N){function j(X){switch(X.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=j;function B(X){switch(X){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=B}(v||(e.RuntimeType=v={}));var d;(function(N){function j(B){return L.$ag(B)?B:B.value}N.value=j})(d||(e.CommandString=d={}));var h;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function j(X){return X===N.Clean._id||X===N.Build._id||X===N.Rebuild._id||X===N.Test._id}N.is=j;function B(X){if(X!==void 0)return L.$ag(X)?j(X)?{_id:X,isDefault:!1}:void 0:X}N.from=B})(h||(e.TaskGroup=h={}));var c;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(c||(e.TaskScope=c={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function j(B){switch(B){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=j})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var a;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var r;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(r||(e.RunOptions=r={}));class t{constructor(j,B,X,ie,H,K){this._label="",this._id=j,B&&(this._label=B),X&&(this.type=X),this.runOptions=ie,this.configurationProperties=H,this._source=K}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,B=!1){if(j===void 0)return!1;if(L.$ag(j))return j===this._label||j===this.configurationProperties.identifier||B&&j===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$rI=t;class f extends t{constructor(j,B,X,ie,H,K,x,_){super(j,X,void 0,x,_,B),this.command={},this._source=B,this.hasDefinedMatchers=K,H&&(this.command=H)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(j){return j instanceof f}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$nI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const X={type:e.$qI,folder:j,id:B};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$$g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new f(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$sI=f;class o extends t{constructor(j,B,X,ie,H,K,x){super(j,X,ie,K,x,B),this._source=B,this.configures=H}static is(j){return j instanceof o}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$$g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$nI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let B=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(B+=this._source.kind);const X={type:e.$qI,folder:j,id:B};return JSON.stringify(X)}}e.$tI=o;class s extends t{constructor(j,B,X,ie,H,K,x,_,ge){super(j,X,ie,_,ge,B),this.defines=H,this.hasDefinedMatchers=x,this.command=K,this.icon=ge.icon,this.hide=ge.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof s}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new s(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$uI=s;class u extends t{constructor(j,B,X,ie,H,K){super(j,X,ie,H,K,B),this._source=B}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new u(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$vI=u;var g;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(N){N._default=N.Terminal}(g||(e.ExecutionEngine=g={}));var b;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class S{constructor(j){this.c=new Map;for(let B=0;B<j.length;B++)this.c.set(j[B].uri.toString(),B)}compare(j,B){const X=j.getWorkspaceFolder(),ie=B.getWorkspaceFolder();if(X&&ie){let H=this.c.get(X.uri.toString());H=H===void 0?0:H+1;let K=this.c.get(ie.uri.toString());return K=K===void 0?0:K+1,H===K?j._label.localeCompare(B._label):H-K}else return!X&&ie?-1:X&&!ie?1:0}}e.$wI=S;var m;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(m||(e.TaskEventKind=m={}));var y;(function(N){N.SingleRun="singleRun",N.Background="background"})(y||(e.TaskRunType=y={}));var D;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var C;(function(N){function j(_){return{taskId:_._id,taskName:_.configurationProperties.name,runType:_.configurationProperties.isBackground?"background":"singleRun",group:_.configurationProperties.group,__task:_}}function B(_,ge,oe){return{...j(_),kind:"start",terminalId:ge,resolvedVariables:oe}}N.start=B;function X(_,ge,oe){return{...j(_),kind:"processStarted",terminalId:ge,processId:oe}}N.processStarted=X;function ie(_,ge,oe){return{...j(_),kind:"processEnded",terminalId:ge,exitCode:oe}}N.processEnded=ie;function H(_,ge,oe){return{...j(_),kind:"terminated",exitReason:oe,terminalId:ge}}N.terminated=H;function K(_,ge,oe){return{...j(ge),kind:_,terminalId:oe}}N.general=K;function x(){return{kind:"changed"}}N.changed=x})(C||(e.TaskEvent=C={}));var O;(function(N){function j(X){const ie=Object.keys(X).sort();let H="";for(const K of ie){let x=X[K];x instanceof Object?x=j(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),H+=K+","+x+","}return H}function B(X){const H={_key:j(X),type:X.taskType};return Object.assign(H,X),H}N.create=B})(O||(e.KeyedTaskIdentifier=O={}));var z;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var T;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var F;(function(N){function j(B,X){const ie=w.$mI.get(B.type);if(ie===void 0){const _=A.$7n(B);return delete _._key,O.create(_)}const H=Object.create(null);H.type=ie.taskType;const K=new Set;ie.required.forEach(_=>K.add(_));const x=ie.properties;for(const _ of Object.keys(x)){const ge=B[_];if(ge!=null)H[_]=ge;else if(K.has(_)){const oe=x[_];if(oe.default!==void 0)H[_]=A.$7n(oe.default);else switch(oe.type){case"boolean":H[_]=!1;break;case"number":case"integer":H[_]=0;break;case"string":H[_]="";break;default:X.error(l.localize(1,null,JSON.stringify(B,void 0,0),_));return}}}return O.create(H)}N.createTaskIdentifier=j})(F||(e.TaskDefinition=F={}))}),define(ke[315],De([1,0,13]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=e.$Uac=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,w)=>{this.b=R,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,l.$1)(R))}then(R,w){return this.j().then(R,w)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$Uac=L;class M extends L{constructor(){super(),this.h=!0,this.i=new l.$5}}e.$Vac=M}),define(ke[48],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Ew=void 0,e.$Fw=M,e.$Gw=A;class l{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++l.count}}e.$Ew=l;const L=[];function M(w){const $=new l(w);return L[$.nid]=$,$}function A(w){return L[w].sid}class R{constructor($){this.value=$}}e.$Hw=R}),define(ke[6],De([1,0,48]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$mM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var M;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput",d[d.ChatEditorInput=10]="ChatEditorInput",d[d.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(M||(e.TabInputKind=M={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var R;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var w;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var $;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var k;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var I;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output",d[d.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class P{static{this.a=0}static mixin(h){return h._id=P.a++,h}}e.$mM=P;var p;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var E;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$nM={MainThreadAuthentication:(0,l.$Fw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.$Fw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,l.$Fw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,l.$Fw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,l.$Fw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,l.$Fw)("MainThreadChatVariables"),MainThreadClipboard:(0,l.$Fw)("MainThreadClipboard"),MainThreadCommands:(0,l.$Fw)("MainThreadCommands"),MainThreadComments:(0,l.$Fw)("MainThreadComments"),MainThreadConfiguration:(0,l.$Fw)("MainThreadConfiguration"),MainThreadConsole:(0,l.$Fw)("MainThreadConsole"),MainThreadDebugService:(0,l.$Fw)("MainThreadDebugService"),MainThreadDecorations:(0,l.$Fw)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.$Fw)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.$Fw)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.$Fw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.$Fw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.$Fw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.$Fw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.$Fw)("MainThreadEditorTabs"),MainThreadErrors:(0,l.$Fw)("MainThreadErrors"),MainThreadTreeViews:(0,l.$Fw)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.$Fw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,l.$Fw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.$Fw)("MainThreadLanguages"),MainThreadLogger:(0,l.$Fw)("MainThreadLogger"),MainThreadMessageService:(0,l.$Fw)("MainThreadMessageService"),MainThreadOutputService:(0,l.$Fw)("MainThreadOutputService"),MainThreadProgress:(0,l.$Fw)("MainThreadProgress"),MainThreadQuickDiff:(0,l.$Fw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,l.$Fw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.$Fw)("MainThreadStatusBar"),MainThreadSecretState:(0,l.$Fw)("MainThreadSecretState"),MainThreadStorage:(0,l.$Fw)("MainThreadStorage"),MainThreadSpeech:(0,l.$Fw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,l.$Fw)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.$Fw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,l.$Fw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,l.$Fw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.$Fw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.$Fw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.$Fw)("MainThreadCustomEditors"),MainThreadUrls:(0,l.$Fw)("MainThreadUrls"),MainThreadUriOpeners:(0,l.$Fw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,l.$Fw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,l.$Fw)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.$Fw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,l.$Fw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,l.$Fw)("MainThreadExtensionService"),MainThreadSCM:(0,l.$Fw)("MainThreadSCM"),MainThreadSearch:(0,l.$Fw)("MainThreadSearch"),MainThreadShare:(0,l.$Fw)("MainThreadShare"),MainThreadTask:(0,l.$Fw)("MainThreadTask"),MainThreadWindow:(0,l.$Fw)("MainThreadWindow"),MainThreadLabelService:(0,l.$Fw)("MainThreadLabelService"),MainThreadNotebook:(0,l.$Fw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.$Fw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.$Fw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.$Fw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.$Fw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.$Fw)("MainThreadInteractive"),MainThreadTheming:(0,l.$Fw)("MainThreadTheming"),MainThreadTunnelService:(0,l.$Fw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,l.$Fw)("MainThreadManagedSockets"),MainThreadTimeline:(0,l.$Fw)("MainThreadTimeline"),MainThreadTesting:(0,l.$Fw)("MainThreadTesting"),MainThreadLocalization:(0,l.$Fw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,l.$Fw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,l.$Fw)("MainThreadAiEmbeddingVector")},e.$oM={ExtHostCommands:(0,l.$Fw)("ExtHostCommands"),ExtHostConfiguration:(0,l.$Fw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.$Fw)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.$Fw)("ExtHostDebugService"),ExtHostDecorations:(0,l.$Fw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.$Fw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.$Fw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.$Fw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.$Fw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.$Fw)("ExtHostEditors"),ExtHostTreeViews:(0,l.$Fw)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.$Fw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.$Fw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.$Fw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.$Fw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.$Fw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.$Fw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,l.$Fw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,l.$Fw)("ExtHostStatusBar"),ExtHostShare:(0,l.$Fw)("ExtHostShare"),ExtHostExtensionService:(0,l.$Fw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.$Fw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.$Fw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,l.$Fw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,l.$Fw)("ExtHostSCM"),ExtHostSearch:(0,l.$Fw)("ExtHostSearch"),ExtHostTask:(0,l.$Fw)("ExtHostTask"),ExtHostWorkspace:(0,l.$Fw)("ExtHostWorkspace"),ExtHostWindow:(0,l.$Fw)("ExtHostWindow"),ExtHostWebviews:(0,l.$Fw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.$Fw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.$Fw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.$Fw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.$Fw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.$Fw)("ExtHostEditorTabs"),ExtHostProgress:(0,l.$Fw)("ExtHostProgress"),ExtHostComments:(0,l.$Fw)("ExtHostComments"),ExtHostSecretState:(0,l.$Fw)("ExtHostSecretState"),ExtHostStorage:(0,l.$Fw)("ExtHostStorage"),ExtHostUrls:(0,l.$Fw)("ExtHostUrls"),ExtHostUriOpeners:(0,l.$Fw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,l.$Fw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,l.$Fw)("ExtHostOutputService"),ExtHostLabelService:(0,l.$Fw)("ExtHostLabelService"),ExtHostNotebook:(0,l.$Fw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.$Fw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.$Fw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.$Fw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.$Fw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,l.$Fw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,l.$Fw)("ExtHostInteractive"),ExtHostChatAgents2:(0,l.$Fw)("ExtHostChatAgents"),ExtHostChatVariables:(0,l.$Fw)("ExtHostChatVariables"),ExtHostChatProvider:(0,l.$Fw)("ExtHostChatProvider"),ExtHostSpeech:(0,l.$Fw)("ExtHostSpeech"),ExtHostEmbeddings:(0,l.$Fw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,l.$Fw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,l.$Fw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,l.$Fw)("ExtHostTheming"),ExtHostTunnelService:(0,l.$Fw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,l.$Fw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,l.$Fw)("ExtHostAuthentication"),ExtHostTimeline:(0,l.$Fw)("ExtHostTimeline"),ExtHostTesting:(0,l.$Fw)("ExtHostTesting"),ExtHostTelemetry:(0,l.$Fw)("ExtHostTelemetry"),ExtHostLocalization:(0,l.$Fw)("ExtHostLocalization")}}),define(ke[91],De([1,0,5,11,6,20]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=e.$gmc=e.$fmc=void 0,e.$fmc=(0,l.$Ai)("IExtHostApiDeprecationService");let R=class{constructor($,k){this.c=k,this.a=new Set,this.b=$.getProxy(M.$nM.MainThreadTelemetry)}report($,k,I){const P=this.d($,k);this.a.has(P)||(this.a.add(P),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:$}))}d($,k){return`${$}-${k.identifier.value}`}};e.$gmc=R,e.$gmc=R=Je([We(0,A.$RO),We(1,L.$7j)],R),e.$hmc=Object.freeze(new class{report(w,$,k){}})}),define(ke[316],De([1,0,6]),function(le,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class L{constructor(A){const R=A.getProxy(l.$nM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(w){return R.$writeText(w)}})}}e.$umc=L}),define(ke[317],De([1,0,24,6,28,20]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=void 0;let R=class{constructor(I,P){this.a=I.getProxy(L.$nM.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,P){const p=this,E=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){p.e(I,P,E,arguments)}})}e(I,P,p,E){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:$(E,this.b)}),this.c&&this.f(I,p,E)}};e.$ooc=R,e.$ooc=R=Je([We(0,A.$RO),We(1,M.$8O)],R);const w=1e5;function $(k,I){const P=[];if(k.length)for(let p=0;p<k.length;p++){let E=k[p];if(typeof E>"u")E="undefined";else if(E instanceof Error){const v=E;v.stack?E=v.stack:E=v.toString()}P.push(E)}if(I){const p=new Error().stack;p&&P.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,l.$_n)(P);return p.length>w?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(ke[318],De([1,0,2,6,26]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;class A{constructor(w){this.a=w.getProxy(L.$nM.MainThreadDialogs)}showOpenDialog(w,$){return $?.allowUIResources&&(0,M.$OG)(w,"showLocal"),this.a.$showOpenDialog($).then(k=>k?k.map(I=>l.URI.revive(I)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then($=>$?l.URI.revive($):void 0)}}e.$rnc=A}),define(ke[319],De([1,0,21,4,3,6]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class R{constructor($){this.b=new Map,this.c=new L.$he,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(A.$nM.MainThreadEmbeddings)}registerEmbeddingsProvider($,k,I){if(this.d.has(k))throw new Error("An embeddings provider for this model is already registered");const P=this.e++;return this.a.$registerEmbeddingProvider(P,k),this.b.set(P,{id:k,provider:I}),(0,M.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(P),this.b.delete(P)})}async computeEmbeddings($,k,I){I??=l.CancellationToken.None;let P=!1;typeof k=="string"&&(k=[k],P=!0);const p=await this.a.$computeEmbeddings($,k,I);if(p.length!==k.length)throw new Error;if(P){if(p.length!==1)throw new Error;return p[0]}return p}async $provideEmbeddings($,k,I){const P=this.b.get($);if(!P)return[];const p=await P.provider.provideEmbeddings(k,I);return p||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$unc=R}),define(ke[320],De([1,0,3,6]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=void 0;class M{constructor(R){this.b=0,this.a=R.getProxy(L.$nM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,R),(0,l.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$Lnc=M}),define(ke[116],De([1,0,12,14,2,5,11,6,28,20]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=void 0;let I=class{constructor(p,E,v){this.f=v,this.d=new Map,this.a=E.getProxy(w.$nM.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===l.$g}getMessage(p,E){const{message:v,args:d,comment:h}=E;if(this.c)return(0,L.$af)(v,d??{});let c=v;h&&h.length>0&&(c+=`/${Array.isArray(h)?h.join(""):h}`);const i=this.d.get(p)?.contents[c];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,L.$af)(i??v,d??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let E;const v=await this.g(p);if(!v){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(v),h=JSON.parse(d);E=p.isBuiltin?h.contents?.bundle:h}catch(d){this.f.error(`Failed to load translations for ${p.identifier.value} from ${v}: ${d.message}`);return}E&&this.d.set(p.identifier.value,{contents:E,uri:v})}async g(p){if(p.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return M.URI.revive(E)}return p.l10n?M.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$_mc=I,e.$_mc=I=Je([We(0,$.$8O),We(1,k.$RO),We(2,R.$7j)],I),e.$anc=(0,A.$Ai)("IExtHostLocalizationService")}),define(ke[150],De([1,0,11,6,28,20,2,53]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0;let $=class extends l.$fk{constructor(P,p){super(p.logLevel,p.logsLocation,p.loggers.map(E=>(0,w.$0h)(E))),this.r=P.getProxy(L.$nM.MainThreadLogger)}$setLogLevel(P,p){p?this.setLogLevel(R.URI.revive(p),P):this.setLogLevel(P)}setVisibility(P,p){super.setVisibility(P,p),this.r.$setVisibility(P,p)}s(P,p,E){return new k(this.r,P,p,E)}};e.$noc=$,e.$noc=$=Je([We(0,A.$RO),We(1,M.$8O)],$);class k extends l.$ak{constructor(P,p,E,v){super(v?.logLevel==="always"),this.r=P,this.s=p,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(p,v).then(()=>{this.u(this.n),this.m=!0})}g(P,p){const E=[[P,p]];this.m?this.u(E):this.n.push(...E)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[117],De([1,0,6,5,3,20,22]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=void 0,e.$bnc=(0,L.$Ai)("IExtHostManagedSockets");let w=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(l.$nM.MainThreadManagedSockets)}setFactory(P,p){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(P,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const p=++this.b,E=await this.c.makeConnection(),v=new M.$Tc;return this.d.set(p,new k(p,E,v)),v.add((0,M.$Sc)(()=>this.d.delete(p))),v.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),v.dispose()})),v.add(E.onDidClose(d=>{this.a.$onDidManagedSocketClose(p,d?.stack??d?.message),v.dispose()})),v.add(E.onDidReceiveMessage(d=>this.a.$onDidManagedSocketHaveData(p,R.$Je.wrap(d)))),p}$remoteSocketWrite(P,p){this.d.get(P)?.actual.send(p.buffer)}$remoteSocketEnd(P){const p=this.d.get(P);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$cnc=w,e.$cnc=w=Je([We(0,A.$RO)],w);class ${constructor(P,p){this.socketFactoryId=P,this.makeConnection=p}}class k extends M.$Uc{constructor(P,p,E){super(),this.socketId=P,this.actual=p,this.B(E)}}}),define(ke[321],De([1,0,6,11,26]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0;function A(w){return w&&w.title}let R=class{constructor($,k){this.b=k,this.a=$.getProxy(l.$nM.MainThreadMessageService)}showMessage($,k,I,P,p){const E={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof P=="string"||A(P)?v=[P,...p]:(E.modal=P?.modal,E.useCustom=P?.useCustom,E.detail=P?.detail,v=p),E.useCustom&&(0,M.$OG)($,"resolvers");const d=[];let h=!1;for(let c=0;c<v.length;c++){const i=v[c];if(typeof i=="string")d.push({title:i,handle:c,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:a}=i;d.push({title:n,isCloseAffordance:!!a,handle:c}),a&&(h?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):h=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(k,I,E,d).then(c=>{if(typeof c=="number")return v[c]})}};e.$Nnc=R,e.$Nnc=R=Je([We(1,L.$7j)],R)}),define(ke[322],De([1,0,3,18,2,26,6]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class w{constructor(k){this.b=new Map,this.a=k.getProxy(R.$nM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,I,P){if((0,A.$OG)(k,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,P),this.a.$registerProfileContentHandler(I,P.name,P.description,k.identifier.value),(0,l.$Sc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(k,I,P,p){const E=this.b.get(k);if(!E)throw new Error(`Unknown handler with id: ${k}`);return E.saveProfile(I,P,p)}async $readProfile(k,I,P){const p=this.b.get(k);if(!p)throw new Error(`Unknown handler with id: ${k}`);return p.readProfile((0,L.$ag)(I)?I:M.URI.revive(I),P)}}e.$Wnc=w}),define(ke[118],De([1,0,6,4,5]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=void 0;class A{constructor(w){this.b=new L.$he,this.onDidChangePassword=this.b.event,this.a=w.getProxy(l.$nM.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,$){return this.a.$getPassword(w,$)}store(w,$,k){return this.a.$setPassword(w,$,k)}delete(w,$){return this.a.$deletePassword(w,$)}}e.$9mc=A,e.$0mc=(0,M.$Ai)("IExtHostSecretState")}),define(ke[323],De([1,0,21,3,6]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;class A{static{this.a=1}constructor(w){this.c=new Map,this.d=new Map,this.f=new Map,this.b=w.getProxy(M.$nM.MainThreadSpeech)}async $createSpeechToTextSession(w,$,k){const I=this.c.get(w);if(!I)return;const P=new L.$Tc,p=new l.$se;this.d.set($,p);const E=await I.provideSpeechToTextSession(p.token,k?{language:k}:void 0);E&&(P.add(E.onDidChange(v=>{p.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),P.add(p.token.onCancellationRequested(()=>P.dispose())))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}async $createTextToSpeechSession(w,$,k){const I=this.c.get(w);if(!I)return;const P=new L.$Tc,p=new l.$se;this.d.set($,p);const E=await I.provideTextToSpeechSession(p.token,k?{language:k}:void 0);E&&(this.f.set($,E),P.add(E.onDidChange(v=>{p.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,v)})),P.add(p.token.onCancellationRequested(()=>P.dispose())))}async $synthesizeSpeech(w,$){this.f.get(w)?.synthesize($)}async $cancelTextToSpeechSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w),this.f.delete(w)}async $createKeywordRecognitionSession(w,$){const k=this.c.get(w);if(!k)return;const I=new L.$Tc,P=new l.$se;this.d.set($,P);const p=await k.provideKeywordRecognitionSession(P.token);p&&(I.add(p.onDidChange(E=>{P.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,E)})),I.add(P.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,$,k){const I=A.a++;return this.c.set(I,k),this.b.$registerProvider(I,$,{extension:w,displayName:w.value}),(0,L.$Sc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$4nc=A}),define(ke[119],De([1,0,6,4,5]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0;class A{constructor(w,$){this.c=$,this.b=new L.$he,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(l.$nM.MainThreadStorage)}registerExtensionStorageKeysToSync(w,$){this.a.$registerExtensionStorageKeysToSync(w,$)}async initializeExtensionStorage(w,$,k){const I=await this.a.$initializeExtensionStorage(w,$);let P;return I&&(P=this.d(w,$,I)),P||k}setValue(w,$,k){return this.a.$setValue(w,$,k)}$acceptValue(w,$,k){const I=this.d(w,$,k);I&&this.b.fire({shared:w,key:$,value:I})}d(w,$,k){try{return JSON.parse(k)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${w}): ${I}`)}}}e.$Ymc=A,e.$Zmc=(0,M.$Ai)("IExtHostStorage")}),define(ke[324],De([1,0,3,15,2,6]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(A.$nM.MainThreadUriOpeners)}registerExternalUriOpener($,k,I,P){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const p=P.schemes.find(E=>!R.a.has(E));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(k,I),this.b.$registerUriOpener(k,P.schemes,$,P.label),(0,l.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri($,k,I){const P=this.c.get($);if(!P)throw new Error(`Unknown opener with id: ${$}`);const p=M.URI.revive(k);return P.canOpenExternalUri(p,I)}async $openUri($,k,I){const P=this.c.get($);if(!P)throw new Error(`Unknown opener id: '${$}'`);return P.openExternalUri(M.URI.revive(k.resolvedUri),{sourceUri:M.URI.revive(k.sourceUri)},I)}}e.$hoc=R}),define(ke[325],De([1,0,6,2,3,13,25]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class w{static{this.a=0}constructor(k){this.c=new R.$Wm,this.d=new Map,this.b=k.getProxy(l.$nM.MainThreadUrls)}registerUriHandler(k,I){const P=k.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const p=w.a++;return this.c.add(P),this.d.set(p,I),this.b.$registerUriHandler(p,P,k.displayName||k.name),(0,M.$Sc)(()=>{this.c.delete(P),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(k,I){const P=this.d.get(k);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(I))}catch(p){(0,A.$1)(p)}return Promise.resolve(void 0)}async createAppUri(k){return L.URI.revive(await this.b.$createAppUri(k))}}e.$ioc=w}),define(ke[92],De([1,0,4,3,15,24,2,252,290,114,6]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Jmc=void 0,e.$Kmc=p,e.$Mmc=d,e.$Nmc=h;class P{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,r,t,f,o,s,u){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new l.$he,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new l.$he,this._onDidDispose=this.#h.event,this.#e=a,this.#t=r,this.#o=t,this.#i=f,this.#s=o,this.#r=s,this.#l=p(s),this.#d=E(s),this.#n=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,k.$sBb)(a,this.#i)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===M.Schemas.https||a.scheme===M.Schemas.http){let r=a.toString();return r.endsWith("/")||(r+="/"),r+" "+k.$rBb}return k.$rBb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#n.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),A.$$n(this.#o,a)||this.#t.$setOptions(this.#e,h(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const r=(0,$.$qsb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,r.message,...r.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const r=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,o,s,u,g,b)=>{const S=R.URI.from({scheme:u||"file",path:decodeURIComponent(g)}),m=(0,k.$sBb)(S,{isRemote:r,authority:t}).toString();return`${o}${m}${b}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,o,s,u,g,b)=>{const S=R.URI.from({scheme:u||"file",path:decodeURIComponent(g)}),m=(0,k.$sBb)(S,{isRemote:r,authority:t}).toString();return`${o}${m}${b}`})}}e.$Jmc=P;function p(n){try{const a=(0,w.$Op)((0,w.$Np)(n.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function E(n){try{const a=(0,w.$Op)((0,w.$Np)(n.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class v extends L.$Uc{constructor(a,r,t,f,o){super(),this.c=r,this.f=t,this.g=f,this.h=o,this.b=new Map,this.a=a.getProxy(I.$nM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,r,t){const f=this.j(a);if(f){const{message:o}=(0,$.$rsb)(r,t.value);f._onMessageEmitter.fire(o)}}$onMissingCsp(a,r){this.g.warn(`${r} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,r,t){const f=new P(a,this.a,c(r),this.c,this.f,t,this.h);this.b.set(a,f);const o=f._onDidDispose(()=>{o.dispose(),this.deleteWebview(a)});return f}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$Lmc=v;function d(n){return{id:n.identifier,location:n.extensionLocation}}function h(n,a,r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots||i(n,a)}}function c(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(a=>R.URI.from(a))}}function i(n,a){return[...(a?.getWorkspaceFolders()||[]).map(r=>r.uri),n.extensionLocation]}}),define(ke[151],De([1,0,4,15,14,2,5,20,6]),function(le,e,l,L,M,A,R,w,$){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=e.$koc=void 0;let I=class{static{k=this}static{this.a={focused:!0,active:!0}}getState(){const p=this.d;return{get focused(){return p.focused},get active(){return p.active}}}constructor(p){this.c=new l.$he,this.onDidChangeWindowState=this.c.event,this.d=k.a,this.b=p.getProxy($.$nM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:v})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",v)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,E){E!==this.d[p]&&(this.d={...this.d,[p]:E},this.c.fire(this.d))}openUri(p,E){let v;if(typeof p=="string"){v=p;try{p=A.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,M.$$e)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,v,E)}async asExternalUri(p,E){if((0,M.$$e)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this.b.$asExternalUri(p,E);return A.URI.from(v)}};e.$koc=I,e.$koc=I=k=Je([We(0,w.$RO)],I),e.$loc=(0,R.$Ai)("IExtHostWindow")}),define(ke[326],De([1,0,317,28,20]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=void 0;const A=1024*1024;let R=class extends l.$ooc{constructor($,k){super($,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,k,I){const P=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),k.apply(console,I),P.write(`
END_NATIVE_LOG
`),this.g=!1}j($,k){const I=process[$],P=I.write;let p="";Object.defineProperty(I,"write",{set:()=>{},get:()=>(E,v,d)=>{if(!this.g){p+=E.toString(v);const h=p.length>A?p.length:p.lastIndexOf(`
`);h!==-1&&(console[k](p.slice(0,h)),p=p.slice(h+1))}P.call(I,E,v,d)}})}};e.$Zoc=R,e.$Zoc=R=Je([We(0,M.$RO),We(1,L.$8O)],R)}),define(ke[327],De([1,0,150,15,267,30]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0;class R extends l.$noc{s($,k,I){return $.scheme===L.Schemas.file?new M.$7P(I?.name||(0,A.$Wg)(),$.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,k):super.s($,k,I)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$_oc=R}),define(ke[328],De([1,0,7,22,21,13,4,3,134,315,48]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=e.ResponsiveState=e.RequestInitiator=void 0,e.$Wac=h,e.$Xac=c;function p(D,C){try{return JSON.stringify(D,C)}catch{return"null"}}const E="$$ref$$",v={[E]:-1};class d{constructor(C,O){this.jsonString=C,this.referencedBuffers=O}}function h(D,C=null,O=!1){const z=[];return{jsonString:(O?p:JSON.stringify)(D,(F,N)=>{if(typeof N>"u")return v;if(typeof N=="object"){if(N instanceof L.$Je){const j=z.push(N)-1;return{[E]:j}}if(C)return C(F,N)}return N}),referencedBuffers:z}}function c(D,C,O){return JSON.parse(D,(z,T)=>{if(T){const F=T[E];if(typeof F=="number")return C[F];if(O&&T.$mid===1)return O.transformIncoming(T)}return T})}function i(D,C){return JSON.stringify(D,C)}function n(D){return D?(C,O)=>O&&O.$mid===1?D.transformOutgoing(O):O:null}var a;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var r;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(r||(e.ResponsiveState=r={}));const t=()=>{},f=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class s extends w.$Uc{static{P=f}static{this.a=3*1e3}constructor(C,O=null,z=null){super(),this[P]=!0,this.b=this.B(new R.$he),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=O,this.g=z,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,F=I.$Ew.count;T<F;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new l.$Mh(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const O=this.w[C];delete this.w[C],O.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+s.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+s.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,$.$Fn)(C,this.g):C}getProxy(C){const{nid:O,sid:z}=C;return this.s[O]||(this.s[O]=this.J(O,z)),this.s[O]}J(C,O){const z={get:(T,F)=>(typeof F=="string"&&!T[F]&&F.charCodeAt(0)===36&&(T[F]=(...N)=>this.U(C,F,N)),F===o?O:T[F])};return new Proxy(Object.create(null),z)}set(C,O){return this.m[C.nid]=O,O}assertRegistered(C){for(let O=0,z=C.length;O<z;O++){const T=C[O];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(C){if(this.j)return;const O=C.byteLength,z=g.read(C,0),T=z.readUInt8(),F=z.readUInt32();switch(T){case 1:case 2:{let{rpcId:N,method:j,args:B}=S.deserializeRequestJSONArgs(z);this.g&&(B=(0,$.$Fn)(B,this.g)),this.M(O,F,N,j,B,T===2);break}case 3:case 4:{let{rpcId:N,method:j,args:B}=S.deserializeRequestMixedArgs(z);this.g&&(B=(0,$.$Fn)(B,this.g)),this.M(O,F,N,j,B,T===4);break}case 5:{this.f?.logIncoming(O,F,0,"ack"),this.G(F);break}case 6:{this.N(O,F);break}case 7:{this.O(O,F,void 0);break}case 9:{let N=S.deserializeReplyOKJSON(z);this.g&&(N=(0,$.$Fn)(N,this.g)),this.O(O,F,N);break}case 10:{const N=S.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(O,F,N);break}case 8:{const N=S.deserializeReplyOKVSBuffer(z);this.O(O,F,N);break}case 11:{let N=S.deserializeReplyErrError(z);this.g&&(N=(0,$.$Fn)(N,this.g)),this.P(O,F,N);break}case 12:{this.P(O,F,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,O,z,T,F,N){this.f?.logIncoming(C,O,1,`receiveRequest ${(0,I.$Gw)(z)}.${T}(`,F);const j=String(O);let B,X;if(N){const H=new M.$se;F.push(H.token),B=this.Q(z,T,F),X=()=>H.cancel()}else B=this.Q(z,T,F),X=t;this.u[j]=X;const ie=S.serializeAcknowledged(O);this.f?.logOutgoing(ie.byteLength,O,1,"ack"),this.c.send(ie),B.then(H=>{delete this.u[j];const K=S.serializeReplyOK(O,H,this.h);this.f?.logOutgoing(K.byteLength,O,1,"reply:",H),this.c.send(K)},H=>{delete this.u[j];const K=S.serializeReplyErr(O,H);this.f?.logOutgoing(K.byteLength,O,1,"replyErr:",H),this.c.send(K)})}N(C,O){this.f?.logIncoming(C,O,1,"receiveCancel");const z=String(O);this.u[z]?.()}O(C,O,z){this.f?.logIncoming(C,O,0,"receiveReply:",z);const T=String(O);if(!this.w.hasOwnProperty(T))return;const F=this.w[T];delete this.w[T],F.resolveOk(z)}P(C,O,z){this.f?.logIncoming(C,O,0,"receiveReplyErr:",z);const T=String(O);if(!this.w.hasOwnProperty(T))return;const F=this.w[T];delete this.w[T];let N;z&&(z.$isError?(N=new Error,N.name=z.name,N.message=z.message,N.stack=z.stack):N=z),F.resolveErr(N)}Q(C,O,z){try{return Promise.resolve(this.S(C,O,z))}catch(T){return Promise.reject(T)}}S(C,O,z){const T=this.m[C];if(!T)throw new Error("Unknown actor "+(0,I.$Gw)(C));const F=T[O];if(typeof F!="function")throw new Error("Unknown method "+O+" on actor "+(0,I.$Gw)(C));return F.apply(T,z)}U(C,O,z){if(this.j)return new k.$Vac;let T=null;if(z.length>0&&M.CancellationToken.isCancellationToken(z[z.length-1])&&(T=z.pop()),T&&T.isCancellationRequested)return Promise.reject(A.$6());const F=S.serializeRequestArguments(z,this.h),N=++this.t,j=String(N),B=new k.$Uac,X=new w.$Tc;T&&X.add(T.onCancellationRequested(()=>{const H=S.serializeCancel(N);this.f?.logOutgoing(H.byteLength,N,0,"cancel"),this.c.send(S.serializeCancel(N))})),this.w[j]=new u(B,X),this.F(N);const ie=S.serializeRequest(N,C,O,F,!!T);return this.f?.logOutgoing(ie.byteLength,N,0,`request: ${(0,I.$Gw)(C)}.${O}(`,z),this.c.send(ie),B}}e.$Yac=s;class u{constructor(C,O){this.a=C,this.b=O}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class g{static alloc(C,O,z){const T=new g(L.$Je.alloc(z+1+4),0);return T.writeUInt8(C),T.writeUInt32(O),T}static read(C,O){return new g(C,O)}get buffer(){return this.a}constructor(C,O){this.a=C,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+C).toString();return this.b+=C,z}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+C);return this.b+=C,O}static sizeMixedArray(C){let O=0;O+=1;for(let z=0,T=C.length;z<T;z++){const F=C[z];switch(O+=1,F.type){case 1:O+=this.sizeLongString(F.value);break;case 2:O+=this.sizeVSBuffer(F.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(F.value);for(let N=0;N<F.buffers.length;++N)O+=this.sizeVSBuffer(F.buffers[N]);break;case 4:break}}return O}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let O=0,z=C.length;O<z;O++){const T=C[O];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let F=0;F<T.buffers.length;++F)this.writeBuffer(T.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const O=new Array(C);for(let z=0;z<C;z++)switch(this.readUInt8()){case 1:O[z]=this.readLongString();break;case 2:O[z]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),N=this.readLongString(),j=[];for(let B=0;B<F;++B)j.push(this.readVSBuffer());O[z]=new I.$Hw(c(N,j,null));break}case 4:O[z]=void 0;break}return O}}var b;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(b||(b={}));class S{static a(C){for(let O=0,z=C.length;O<z;O++)if(C[O]instanceof L.$Je||C[O]instanceof I.$Hw||typeof C[O]>"u")return!0;return!1}static serializeRequestArguments(C,O){if(this.a(C)){const z=[];for(let T=0,F=C.length;T<F;T++){const N=C[T];if(N instanceof L.$Je)z[T]={type:2,value:N};else if(typeof N>"u")z[T]={type:4};else if(N instanceof I.$Hw){const{jsonString:j,referencedBuffers:B}=h(N.value,O);z[T]={type:3,value:L.$Je.fromString(j),buffers:B}}else z[T]={type:1,value:L.$Je.fromString(i(N,O))}}return{type:1,args:z}}return{type:0,args:i(C,O)}}static serializeRequest(C,O,z,T,F){switch(T.type){case 0:return this.b(C,O,z,T.args,F);case 1:return this.c(C,O,z,T.args,F)}}static b(C,O,z,T,F){const N=L.$Je.fromString(z),j=L.$Je.fromString(T);let B=0;B+=g.sizeUInt8(),B+=g.sizeShortString(N),B+=g.sizeLongString(j);const X=g.alloc(F?2:1,C,B);return X.writeUInt8(O),X.writeShortString(N),X.writeLongString(j),X.buffer}static deserializeRequestJSONArgs(C){const O=C.readUInt8(),z=C.readShortString(),T=C.readLongString();return{rpcId:O,method:z,args:JSON.parse(T)}}static c(C,O,z,T,F){const N=L.$Je.fromString(z);let j=0;j+=g.sizeUInt8(),j+=g.sizeShortString(N),j+=g.sizeMixedArray(T);const B=g.alloc(F?4:3,C,j);return B.writeUInt8(O),B.writeShortString(N),B.writeMixedArray(T),B.buffer}static deserializeRequestMixedArgs(C){const O=C.readUInt8(),z=C.readShortString(),T=C.readMixedArray(),F=new Array(T.length);for(let N=0,j=T.length;N<j;N++){const B=T[N];typeof B=="string"?F[N]=JSON.parse(B):F[N]=B}return{rpcId:O,method:z,args:F}}static serializeAcknowledged(C){return g.alloc(5,C,0).buffer}static serializeCancel(C){return g.alloc(6,C,0).buffer}static serializeReplyOK(C,O,z){if(typeof O>"u")return this.d(C);if(O instanceof L.$Je)return this.e(C,O);if(O instanceof I.$Hw){const{jsonString:T,referencedBuffers:F}=h(O.value,z,!0);return this.g(C,T,F)}else return this.f(C,p(O,z))}static d(C){return g.alloc(7,C,0).buffer}static e(C,O){let z=0;z+=g.sizeVSBuffer(O);const T=g.alloc(8,C,z);return T.writeVSBuffer(O),T.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,O){const z=L.$Je.fromString(O);let T=0;T+=g.sizeLongString(z);const F=g.alloc(9,C,T);return F.writeLongString(z),F.buffer}static g(C,O,z){const T=L.$Je.fromString(O);let F=0;F+=g.sizeUInt32,F+=g.sizeLongString(T);for(const j of z)F+=g.sizeVSBuffer(j);const N=g.alloc(10,C,F);N.writeUInt32(z.length),N.writeLongString(T);for(const j of z)N.writeBuffer(j);return N.buffer}static deserializeReplyOKJSON(C){const O=C.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(C,O){const z=C.readUInt32(),T=C.readLongString(),F=[];for(let N=0;N<z;++N)F.push(C.readVSBuffer());return new I.$Hw(c(T,F,O))}static serializeReplyErr(C,O){const z=O?p(A.$3(O),null):void 0;if(typeof z!="string")return this.h(C);const T=L.$Je.fromString(z);let F=0;F+=g.sizeLongString(T);const N=g.alloc(11,C,F);return N.writeLongString(T),N.buffer}static deserializeReplyErrError(C){const O=C.readLongString();return JSON.parse(O)}static h(C){return g.alloc(12,C,0).buffer}}var m;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var y;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(y||(y={}))}),define(ke[329],De([1,0,22,27,15,85,5]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.$1J=void 0,e.$2J=I,e.$3J=P,e.$1J=(0,R.$Ai)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${w.join("")}]+`),k=7;function I(E){if(E.scheme!==M.Schemas.vscodeNotebookCell)return;const v=E.fragment.indexOf("s");if(v<0)return;const d=parseInt(E.fragment.substring(0,v).replace($,""),k),h=(0,l.$3e)(E.fragment.substring(v+1)).toString();if(!isNaN(d))return{handle:d,notebook:E.with({scheme:h,fragment:null})}}function P(E,v){const d=v.toString(k),c=`${d.length<w.length?w[d.length-1]:"z"}${d}s${(0,l.$4e)(l.$Je.fromString(E.scheme),!0,!0)}`;return E.with({scheme:M.Schemas.vscodeNotebookCell,fragment:c})}class p{constructor(){this.a=new L.$Ac}getNotebook(v){if(v.scheme===M.Schemas.vscodeNotebookCell){const d=I(v);if(d){const h=this.a.get(d.notebook);if(h)return h}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$4J=p,(0,A.$Ds)(e.$1J,p,1)}),define(ke[120],De([1,0,22,35,39,101,15,16,12,38,329]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lK=e.$iK=e.CellStatusbarAlignment=e.$hK=e.NotebookEditorPriority=e.$eK=e.$dK=e.$bK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$aK=e.$_J=e.$$J=e.$0J=e.CellKind=e.$9J=e.$8J=e.$7J=void 0,e.$cK=f,e.$fK=s,e.$gK=u,e.$jK=S,e.$kK=y,e.$7J="workbench.editor.notebook",e.$8J="workbench.editor.notebookTextDiffEditor",e.$9J="workbench.editor.interactive";var P;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(P||(e.CellKind=P={})),e.$0J=["application/json","application/javascript","text/html","image/svg+xml",A.$Ws.latex,A.$Ws.markdown,"image/png","image/jpeg",A.$Ws.text],e.$$J=[A.$Ws.latex,A.$Ws.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$Ws.text],e.$_J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$aK="_notAvailable";var p;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var d;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(d||(e.NotebookRendererMatch=d={}));var h;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(h||(e.RendererMessagingSpec=h={}));var c;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var i;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var a;(function(B){B.scheme=R.Schemas.vscodeNotebookCell;function X(ge,oe){return(0,I.$3J)(ge,oe)}B.generate=X;function ie(ge){return(0,I.$2J)(ge)}B.parse=ie;function H(ge,oe){return ge.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${oe??""},${ge.scheme!==R.Schemas.file?ge.scheme:""}`})}B.generateCellOutputUri=H;function K(ge){if(ge.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const oe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ge.fragment);if(!oe)return;const Pe=oe[1]&&oe[1]!==""?oe[1]:void 0,me=oe[2];return{outputId:Pe,notebook:ge.with({scheme:me||R.Schemas.file,fragment:null})}}B.parseCellOutputUri=K;function x(ge,oe,Pe){return B.generate(ge,oe).with({scheme:Pe})}B.generateCellPropertyUri=x;function _(ge,oe){if(ge.scheme===oe)return B.parse(ge.with({scheme:B.scheme}))}B.parseCellPropertyUri=_})(a||(e.CellUri=a={}));const r=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(X=[],ie=e.$0J){this.e=ie,this.d=[...new Set(X)].map(H=>({pattern:H,matches:L.$uk(r(H))}))}sort(X){const ie=new Map(M.Iterable.map(X,K=>[K,r(K)]));let H=[];for(const{matches:K}of this.d)for(const[x,_]of ie)if(K(_)){H.push(x),ie.delete(x);break}return ie.size&&(H=H.concat([...ie.keys()].sort((K,x)=>this.e.indexOf(K)-this.e.indexOf(x)))),H}prioritize(X,ie){const H=this.f(X);if(H===-1){this.d.unshift({pattern:X,matches:L.$uk(r(X))});return}const K=new Set(ie.map(_=>this.f(_,H)));K.delete(-1);const x=Array.from(K).sort();this.d.splice(H+1,0,...x.map(_=>this.d[_]));for(let _=x.length-1;_>=0;_--)this.d.splice(x[_],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,ie=this.d.length){const H=r(X);for(let K=0;K<ie;K++)if(this.d[K].matches(H))return K;return-1}}e.$bK=t;function f(B,X,ie,H=(K,x)=>K===x){const K=[];function x(oe,Pe,me){if(Pe===0&&me.length===0)return;const U=K[K.length-1];U&&U.start+U.deleteCount===oe?(U.deleteCount+=Pe,U.toInsert.push(...me)):K.push({start:oe,deleteCount:Pe,toInsert:me})}let _=0,ge=0;for(;;){if(_===B.length){x(_,0,X.slice(ge));break}if(ge===X.length){x(_,B.length-_,[]);break}const oe=B[_],Pe=X[ge];if(H(oe,Pe)){_+=1,ge+=1;continue}ie(Pe)?(x(_,1,[]),_+=1):(x(_,0,[Pe]),ge+=1)}return K}e.$dK=new k.$Rj("notebookEditorCursorAtBoundary","none"),e.$eK=new k.$Rj("notebookEditorCursorAtLineBoundary","none");var o;(function(B){B.default="default",B.option="option"})(o||(e.NotebookEditorPriority=o={}));function s(B){const X=B;return!!((typeof X.include=="string"||L.$vk(X.include))&&(typeof X.exclude=="string"||L.$vk(X.exclude)))}function u(B,X,ie){if(Array.isArray(B.viewType)&&B.viewType.indexOf(X)>=0||B.viewType===X)return!0;if(B.filenamePattern){const H=s(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,K=s(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(L.$tk(H,(0,w.$nc)(ie.fsPath).toLowerCase()))return!(K&&L.$tk(K,(0,w.$nc)(ie.fsPath).toLowerCase()))}return!1}e.$hK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var g;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(g||(e.CellStatusbarAlignment=g={}));class b{static{this.d="notebook/"}static create(X){return`${b.d}${X}`}static parse(X){if(X.startsWith(b.d))return X.substring(b.d.length)}}e.$iK=b;function S(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const m=new TextDecoder;function y(B){const X=[];let ie=!1;for(const _ of B)(X.length===0||ie)&&(X.push(_),ie=!0);let H=O(X);const K=l.$Je.concat(X.map(_=>l.$Je.wrap(_))),x=j(K);return H=H||x.byteLength!==K.byteLength,{data:x,didCompression:H}}e.$lK="\x1B[A";const D=e.$lK.split("").map(B=>B.charCodeAt(0)),C=10;function O(B){let X=!1;return B.forEach((ie,H)=>{if(H===0||ie.length<e.$lK.length)return;const K=B[H-1],x=ie.subarray(0,e.$lK.length);if(x[0]===D[0]&&x[1]===D[1]&&x[2]===D[2]){const _=K.lastIndexOf(C);if(_===-1)return;X=!0,B[H-1]=K.subarray(0,_),B[H]=ie.subarray(e.$lK.length)}}),X}function z(B){let X=B;do B=X,X=B.replace(/[^\n]\x08/gm,"");while(X.length<B.length);return B}function T(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const X=B.match(/^(.*)\r+/m)[1];let ie=B.match(/\r+(.*)$/m)[1];ie=ie+X.slice(ie.length,X.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ie)}return B}const F=8,N=13;function j(B){return!B.buffer.includes(F)&&!B.buffer.includes(N)?B:l.$Je.fromString(T(z(m.decode(B.buffer))))}}),define(ke[8],De([1,0,19,13,81,27,101,14,18,2,30,25,33,67,120]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v){"use strict";var d,h,c,i,n,a,r,t,f,o,s,u,g,b,S,m,y;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$FO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$lO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$$N=e.$0N=e.$9N=e.$8N=e.$6N=e.$5N=e.$4N=e.$3N=e.TestRunProfileKind=e.TestResultState=e.$2N=e.$1N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$ZN=e.NotebookVariablesRequestKind=e.$YN=e.$XN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$WN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.ColorThemeKind=e.$QN=e.$PN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$ON=e.$NN=e.DebugConsoleMode=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$HN=e.$GN=e.FileChangeType=e.$FN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$EN=e.$DN=e.$CN=e.$BN=e.InlineCompletionTriggerKind=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$oN=e.ConfigurationTarget=e.$nN=e.$mN=e.$lN=e.$kN=e.DocumentPasteTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$dN=e.ViewBadge=e.ProgressLocation=e.$cN=e.$bN=e.TaskScope=e.ShellQuoting=e.$aN=e.$_M=e.$$M=e.TaskPanelKind=e.TaskRevealKind=e.$0M=e.TerminalLocation=e.$9M=e.$8M=e.$7M=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$6M=e.$5M=e.$4M=e.$3M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$1M=e.$ZM=e.$YM=e.$XM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$WM=e.$VM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.LanguageStatusSeverity=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.CodeActionTriggerKind=e.$JM=e.$IM=e.SymbolTag=e.SymbolKind=e.$HM=e.$GM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.DiagnosticSeverity=e.DiagnosticTag=e.$AM=e.$zM=e.FileEditType=e.$yM=e.$xM=e.$wM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$2M=Ct,e.$pN=Te,e.$7N=Ei;function D(G){return Object.assign(G,{apply:function(...fe){if(fe.length===0)return Reflect.construct(G,[]);{const Le=fe.length===1?[]:fe[1];return Reflect.construct(G,Le,fe[0].constructor)}},call:function(...fe){if(fe.length===0)return Reflect.construct(G,[]);{const[Le,...Ze]=fe;return Reflect.construct(G,Ze,Le.constructor)}}})}var C;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var O;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let z=d=class{static from(...q){let fe=q;return new d(function(){if(fe){for(const Le of fe)Le&&typeof Le.dispose=="function"&&Le.dispose();fe=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$pM=z,e.$pM=z=d=Je([D],z);let T=h=class{static Min(...q){if(q.length===0)throw new TypeError;let fe=q[0];for(let Le=1;Le<q.length;Le++){const Ze=q[Le];Ze.isBefore(fe)&&(fe=Ze)}return fe}static Max(...q){if(q.length===0)throw new TypeError;let fe=q[0];for(let Le=1;Le<q.length;Le++){const Ze=q[Le];Ze.isAfter(fe)&&(fe=Ze)}return fe}static isPosition(q){if(!q)return!1;if(q instanceof h)return!0;const{line:fe,character:Le}=q;return typeof fe=="number"&&typeof Le=="number"}static of(q){if(q instanceof h)return q;if(this.isPosition(q))return new h(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,fe){if(q<0)throw(0,L.$7)("line must be non-negative");if(fe<0)throw(0,L.$7)("character must be non-negative");this.c=q,this.e=fe}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,fe=0){if(q===null||fe===null)throw(0,L.$7)();let Le;return typeof q>"u"?Le=0:typeof q=="number"?Le=q:(Le=typeof q.lineDelta=="number"?q.lineDelta:0,fe=typeof q.characterDelta=="number"?q.characterDelta:0),Le===0&&fe===0?this:new h(this.line+Le,this.character+fe)}with(q,fe=this.character){if(q===null||fe===null)throw(0,L.$7)();let Le;return typeof q>"u"?Le=this.line:typeof q=="number"?Le=q:(Le=typeof q.line=="number"?q.line:this.line,fe=typeof q.character=="number"?q.character:this.character),Le===this.line&&fe===this.character?this:new h(Le,fe)}toJSON(){return{line:this.line,character:this.character}}};e.$qM=T,e.$qM=T=h=Je([D],T);let F=c=class{static isRange(q){return q instanceof c?!0:q?T.isPosition(q.start)&&T.isPosition(q.end):!1}static of(q){if(q instanceof c)return q;if(this.isRange(q))return new c(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,fe,Le,Ze){let et,dt;if(typeof q=="number"&&typeof fe=="number"&&typeof Le=="number"&&typeof Ze=="number"?(et=new T(q,fe),dt=new T(Le,Ze)):T.isPosition(q)&&T.isPosition(fe)&&(et=T.of(q),dt=T.of(fe)),!et||!dt)throw new Error("Invalid arguments");et.isBefore(dt)?(this.c=et,this.e=dt):(this.c=dt,this.e=et)}contains(q){return c.isRange(q)?this.contains(q.start)&&this.contains(q.end):T.isPosition(q)?!(T.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const fe=T.Max(q.start,this.c),Le=T.Min(q.end,this.e);if(!fe.isAfter(Le))return new c(fe,Le)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const fe=T.Min(q.start,this.c),Le=T.Max(q.end,this.end);return new c(fe,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,fe=this.end){if(q===null||fe===null)throw(0,L.$7)();let Le;return q?T.isPosition(q)?Le=q:(Le=q.start||this.start,fe=q.end||this.end):Le=this.start,Le.isEqual(this.c)&&fe.isEqual(this.end)?this:new c(Le,fe)}toJSON(){return[this.start,this.end]}};e.$rM=F,e.$rM=F=c=Je([D],F);let N=i=class extends F{static isSelection(q){return q instanceof i?!0:q?F.isRange(q)&&T.isPosition(q.anchor)&&T.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,fe,Le,Ze){let et,dt;if(typeof q=="number"&&typeof fe=="number"&&typeof Le=="number"&&typeof Ze=="number"?(et=new T(q,fe),dt=new T(Le,Ze)):T.isPosition(q)&&T.isPosition(fe)&&(et=T.of(q),dt=T.of(fe)),!et||!dt)throw new Error("Invalid arguments");super(et,dt),this.f=et,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$sM=N,e.$sM=N=i=Je([D],N);const j=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,L.$7)("connectionToken")};class B{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,fe,Le){if(typeof q!="string"||q.length===0)throw(0,L.$7)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,L.$7)("port");typeof Le<"u"&&j(Le),this.host=q,this.port=Math.round(fe),this.connectionToken=Le}}e.$tM=B;class X{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,fe){this.makeConnection=q,this.connectionToken=fe,typeof fe<"u"&&j(fe)}}e.$uM=X;class ie extends Error{static NotAvailable(q,fe){return new ie(q,E.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(q){return new ie(q,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,fe=E.RemoteAuthorityResolverErrorCode.Unknown,Le){super(q),this._message=q,this._code=fe,this._detail=Le,Object.setPrototypeOf(this,ie.prototype)}}e.$vM=ie;var H;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(H||(e.EndOfLine=H={}));var K;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(K||(e.EnvironmentVariableMutatorType=K={}));let x=n=class{static isTextEdit(q){return q instanceof n?!0:q?F.isRange(q)&&typeof q.newText=="string":!1}static replace(q,fe){return new n(q,fe)}static insert(q,fe){return n.replace(new F(q,q),fe)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const fe=new n(new F(new T(0,0),new T(0,0)),"");return fe.newEol=q,fe}get range(){return this.c}set range(q){if(q&&!F.isRange(q))throw(0,L.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,L.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,L.$7)("newEol");this.f=q}constructor(q,fe){this.c=q,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$wM=x,e.$wM=x=n=Je([D],x);let _=a=class{static isNotebookCellEdit(q){return q instanceof a?!0:q?mn.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,fe){return new a(q,fe)}static insertCells(q,fe){return new a(new mn(q,q),fe)}static deleteCells(q){return new a(q,[])}static updateCellMetadata(q,fe){const Le=new a(new mn(q,q),[]);return Le.newCellMetadata=fe,Le}static updateNotebookMetadata(q){const fe=new a(new mn(0,0),[]);return fe.newNotebookMetadata=q,fe}constructor(q,fe){this.range=q,this.newCells=fe}};e.$xM=_,e.$xM=_=a=Je([D],_);class ge{static isSnippetTextEdit(q){return q instanceof ge?!0:q?F.isRange(q.range)&&me.isSnippetString(q.snippet):!1}static replace(q,fe){return new ge(q,fe)}static insert(q,fe){return ge.replace(new F(q,q),fe)}constructor(q,fe){this.range=q,this.snippet=fe}}e.$yM=ge;var oe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(oe||(e.FileEditType=oe={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,fe,Le,Ze){this.c.push({_type:1,from:q,to:fe,options:Le,metadata:Ze})}createFile(q,fe,Le){this.c.push({_type:1,from:void 0,to:q,options:fe,metadata:Le})}deleteFile(q,fe,Le){this.c.push({_type:1,from:q,to:void 0,options:fe,metadata:Le})}e(q,fe,Le){this.c.push({_type:3,metadata:Le,uri:q,edit:{editType:5,metadata:fe},notebookMetadata:fe})}f(q,fe,Le,Ze){const et=fe.start,dt=fe.end;(et!==dt||Le.length>0)&&this.c.push({_type:5,uri:q,index:et,count:dt-et,cells:Le,metadata:Ze})}g(q,fe,Le,Ze){this.c.push({_type:3,metadata:Ze,uri:q,edit:{editType:3,index:fe,metadata:Le}})}replace(q,fe,Le,Ze){this.c.push({_type:2,uri:q,edit:new x(fe,Le),metadata:Ze})}insert(q,fe,Le,Ze){this.replace(q,new F(fe,fe),Le,Ze)}delete(q,fe,Le){this.replace(q,fe,"",Le)}has(q){return this.c.some(fe=>fe._type===2&&fe.uri.toString()===q.toString())}set(q,fe){if(fe)for(const Le of fe){if(!Le)continue;let Ze,et;Array.isArray(Le)?(Ze=Le[0],et=Le[1]):Ze=Le,_.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(q,Ze.range.start,Ze.newCellMetadata,et):Ze.newNotebookMetadata?this.e(q,Ze.newNotebookMetadata,et):this.f(q,Ze.range,Ze.newCells,et):ge.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:q,range:Ze.range,edit:Ze.snippet,metadata:et}):this.c.push({_type:2,uri:q,edit:Ze,metadata:et})}else{for(let Le=0;Le<this.c.length;Le++){const Ze=this.c[Le];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===q.toString()&&(this.c[Le]=void 0);break}}(0,l.$Ib)(this.c)}}get(q){const fe=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===q.toString()&&fe.push(Le.edit);return fe}entries(){const q=new A.$Ac;for(const fe of this.c)if(fe._type===2){let Le=q.get(fe.uri);Le||(Le=[fe.uri,[]],q.set(fe.uri,Le)),Le[1].push(fe.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$zM=Pe,e.$zM=Pe=Je([D],Pe);let me=r=class{static isSnippetString(q){return q instanceof r?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=r.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,fe=this.e++){if(typeof q=="function"){const Le=new r;Le.e=this.e,q(Le),this.e=Le.e,q=Le.value}else q=r.c(q);return this.value+="${",this.value+=fe,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,fe=this.e++){const Le=q.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(q,fe){if(typeof fe=="function"){const Le=new r;Le.e=this.e,fe(Le),this.e=Le.e,fe=Le.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};e.$AM=me,e.$AM=me=r=Je([D],me);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var Y;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(Y||(e.DiagnosticSeverity=Y={}));let pe=t=class{static isLocation(q){return q instanceof t?!0:q?F.isRange(q.range)&&k.URI.isUri(q.uri):!1}constructor(q,fe){if(this.uri=q,fe)if(F.isRange(fe))this.range=F.of(fe);else if(T.isPosition(fe))this.range=new F(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$BM=pe,e.$BM=pe=t=Je([D],pe);let ce=class{static is(q){return q?typeof q.message=="string"&&q.location&&F.isRange(q.location.range)&&k.URI.isUri(q.location.uri):!1}constructor(q,fe){this.location=q,this.message=fe}static isEqual(q,fe){return q===fe?!0:!q||!fe?!1:q.message===fe.message&&q.location.range.isEqual(fe.location.range)&&q.location.uri.toString()===fe.location.uri.toString()}};e.$CM=ce,e.$CM=ce=Je([D],ce);let ae=class{constructor(q,fe,Le=Y.Error){if(!F.isRange(q))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=q,this.message=fe,this.severity=Le}toJSON(){return{severity:Y[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,fe){return q===fe?!0:!q||!fe?!1:q.message===fe.message&&q.severity===fe.severity&&q.code===fe.code&&q.severity===fe.severity&&q.source===fe.source&&q.range.isEqual(fe.range)&&(0,l.$ub)(q.tags,fe.tags)&&(0,l.$ub)(q.relatedInformation,fe.relatedInformation,ce.isEqual)}};e.$DM=ae,e.$DM=ae=Je([D],ae);let se=class{constructor(q,fe){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=fe}};e.$EM=se,e.$EM=se=Je([D],se);let ue=class extends se{constructor(q,fe,Le,Ze){super(q,fe),this.canIncreaseHover=Le,this.canDecreaseHover=Ze}};e.$FM=ue,e.$FM=ue=Je([D],ue);var Q;(function(G){G[G.Increase=0]="Increase",G[G.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var re;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let $e=class{constructor(q,fe=re.Text){this.range=q,this.kind=fe}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$GM=$e,e.$GM=$e=Je([D],$e);let we=class{constructor(q,fe){this.uri=q,this.highlights=fe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$HM=we,e.$HM=we=Je([D],we);var Ne;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var Se;(function(G){G[G.Deprecated=1]="Deprecated"})(Se||(e.SymbolTag=Se={}));let Ie=f=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,fe,Le,Ze,et){this.name=q,this.kind=fe,this.containerName=et,typeof Le=="string"&&(this.containerName=Le),Ze instanceof pe?this.location=Ze:Le instanceof F&&(this.location=new pe(Ze,Le)),f.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$IM=Ie,e.$IM=Ie=f=Je([D],Ie);let Ae=o=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(o.validate)}constructor(q,fe,Le,Ze,et){this.name=q,this.detail=fe,this.kind=Le,this.range=Ze,this.selectionRange=et,this.children=[],o.validate(this)}};e.$JM=Ae,e.$JM=Ae=o=Je([D],Ae);var je;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let V=class{constructor(q,fe){this.title=q,this.kind=fe}};e.$KM=V,e.$KM=V=Je([D],V);let W=class{static{s=this}static{this.c="."}constructor(q){this.value=q}append(q){return new s(this.value?this.value+s.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+s.c)}};e.$LM=W,e.$LM=W=s=Je([D],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let J=class{constructor(q,fe){if(this.range=q,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$MM=J,e.$MM=J=Je([D],J);class Z{constructor(q,fe,Le,Ze,et,dt){this.kind=q,this.name=fe,this.detail=Le,this.uri=Ze,this.range=et,this.selectionRange=dt}}e.$NM=Z;class he{constructor(q,fe){this.fromRanges=fe,this.from=q}}e.$OM=he;class be{constructor(q,fe){this.fromRanges=fe,this.to=q}}e.$PM=be;var Fe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Fe||(e.LanguageStatusSeverity=Fe={}));let Ve=class{constructor(q,fe){this.range=q,this.command=fe}get isResolved(){return!!this.command}};e.$QM=Ve,e.$QM=Ve=Je([D],Ve);let Qe=u=class{#e;static isMarkdownString(q){return q instanceof u?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,fe=!1){this.#e=new M.$Xk(q,{supportThemeIcons:fe})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,fe){return this.#e.appendCodeblock(fe??"",q),this}};e.$RM=Qe,e.$RM=Qe=u=Je([D],Qe);let tt=class{constructor(q,fe){this.label=q,this.documentation=fe}};e.$SM=tt,e.$SM=tt=Je([D],tt);let _e=class{constructor(q,fe){this.label=q,this.documentation=fe,this.parameters=[]}};e.$TM=_e,e.$TM=_e=Je([D],_e);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$UM=nt,e.$UM=nt=Je([D],nt);var it;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var rt;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let at=class{constructor(q){this.value=q}};e.$VM=at,e.$VM=at=Je([D],at);let Re=class{constructor(q,fe,Le){this.position=q,this.label=fe,this.kind=Le}};e.$WM=Re,e.$WM=Re=Je([D],Re);var ve;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ve||(e.CompletionTriggerKind=ve={}));var qe;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(qe||(e.CompletionItemKind=qe={}));var te;(function(G){G[G.Deprecated=1]="Deprecated"})(te||(e.CompletionItemTag=te={}));let ne=class{constructor(q,fe){this.label=q,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$XM=ne,e.$XM=ne=Je([D],ne);let Ce=class{constructor(q=[],fe=!1){this.items=q,this.isIncomplete=fe}};e.$YM=Ce,e.$YM=Ce=Je([D],Ce);let Ge=class{constructor(q,fe,Le){this.insertText=q,this.range=fe,this.command=Le}};e.$ZM=Ge,e.$ZM=Ge=Je([D],Ge);let Me=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$1M=Me,e.$1M=Me=Je([D],Me);var st;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var ut;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ut||(e.ViewColumn=ut={}));var $t;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function Ct(G,q){return`${P.$Vm.toKey(G)}.${q}`}var Pt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Ut;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Ut||(e.TextDocumentSaveReason=Ut={}));var Bt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Bt||(e.TextEditorRevealType=Bt={}));var kt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(kt||(e.TextEditorSelectionChangeKind=kt={}));var Yt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Yt||(e.TextDocumentChangeReason=Yt={}));var xt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(xt||(e.DecorationRangeBehavior=xt={})),function(G){function q(fe){switch(fe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=q}(kt||(e.TextEditorSelectionChangeKind=kt={}));var xe;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(xe||(e.SyntaxTokenType=xe={})),function(G){function q(fe){switch(fe){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=q}(xe||(e.SyntaxTokenType=xe={}));let on=class{constructor(q,fe){if(fe&&!k.URI.isUri(fe))throw(0,L.$7)("target");if(!F.isRange(q)||q.isEmpty)throw(0,L.$7)("range");this.range=q,this.target=fe}};e.$3M=on,e.$3M=on=Je([D],on);let Qt=class{constructor(q,fe,Le,Ze){this.red=q,this.green=fe,this.blue=Le,this.alpha=Ze}};e.$4M=Qt,e.$4M=Qt=Je([D],Qt);let ft=class{constructor(q,fe){if(fe&&!(fe instanceof Qt))throw(0,L.$7)("color");if(!F.isRange(q)||q.isEmpty)throw(0,L.$7)("range");this.range=q,this.color=fe}};e.$5M=ft,e.$5M=ft=Je([D],ft);let gt=class{constructor(q){if(!q||typeof q!="string")throw(0,L.$7)("label");this.label=q}};e.$6M=gt,e.$6M=gt=Je([D],gt);var _t;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var Zt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Zt||(e.SourceControlInputBoxValidationType=Zt={}));var Ft;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));var mt;(function(G){G[G.Low=0]="Low",G[G.Medium=1]="Medium",G[G.High=2]="High"})(mt||(e.TerminalShellExecutionCommandLineConfidence=mt={}));class Ht{constructor(q,fe,Le){if(this.startIndex=q,this.length=fe,this.tooltip=Le,typeof q!="number"||q<0)throw(0,L.$7)("startIndex");if(typeof fe!="number"||fe<1)throw(0,L.$7)("length");if(Le!==void 0&&typeof Le!="string")throw(0,L.$7)("tooltip")}}e.$7M=Ht;class en{constructor(q){this.uri=q}}e.$8M=en;class Wt{constructor(q){this.terminalCommand=q}}e.$9M=Wt;var Xe;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Xe||(e.TerminalLocation=Xe={}));class ln{constructor(q){if(this.options=q,typeof q!="object")throw(0,L.$7)("options")}}e.$0M=ln;var Xt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Xt||(e.TaskRevealKind=Xt={}));var Vt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Vt||(e.TaskPanelKind=Vt={}));let wt=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(q){switch(q){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(q,fe){if(this.label=fe,typeof q!="string"||typeof fe!="string")throw(0,L.$7)("name");this.c=q}get id(){return this.c}};e.$$M=wt,e.$$M=wt=g=Je([D],wt);function qt(G){let q="";for(let fe=0;fe<G.length;fe++)q+=G[fe].replace(/,/g,",,")+",";return q}let Mt=class{constructor(q,fe,Le){if(typeof q!="string")throw(0,L.$7)("process");this.e=[],this.c=q,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Le):this.f=fe)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,L.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)q.push(fe);return qt(q)}};e.$_M=Mt,e.$_M=Mt=Je([D],Mt);let Lt=class{constructor(q,fe,Le){if(this.f=[],Array.isArray(fe)){if(!q)throw(0,L.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,L.$7)("command");this.e=q,this.f=fe,this.g=Le}else{if(typeof q!="string")throw(0,L.$7)("commandLine");this.c=q,this.g=fe}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,L.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,L.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)q.push(typeof fe=="string"?fe:fe.value);return qt(q)}};e.$aN=Lt,e.$aN=Lt=Je([D],Lt);var tn;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(tn||(e.ShellQuoting=tn={}));var Gt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Gt||(e.TaskScope=Gt={}));class an{constructor(q){this.c=q}computeId(){return"customExecution"+(0,I.$Wg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$bN=an;let Nt=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,fe,Le,Ze,et,dt){this.k=!1,this.l=this.definition=q;let bt;typeof fe=="string"?(this.o=this.name=fe,this.w=this.source=Le,this.execution=Ze,bt=et,this.k=!0):fe===Gt.Global||fe===Gt.Workspace?(this.target=fe,this.o=this.name=Le,this.w=this.source=Ze,this.execution=et,bt=dt):(this.target=fe,this.o=this.name=Le,this.w=this.source=Ze,this.execution=et,bt=dt),typeof bt=="string"?(this.r=[bt],this.t=!0):Array.isArray(bt)?(this.r=bt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof Lt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof an?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,I.$Wg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,L.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,L.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const fe=this.l.type;(b.g===fe||b.e===fe||b.f===fe||b.c===fe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,L.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$cN=Nt,e.$cN=Nt=b=Je([D],Nt);var Kt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Kt||(e.ProgressLocation=Kt={}));var Ot;(function(G){function q(fe){const Le=fe;return(0,$.$eg)(Le.value)?Le.tooltip&&!(0,$.$ag)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}G.isViewBadge=q})(Ot||(e.ViewBadge=Ot={}));let It=S=class{static isTreeItem(q,fe){const Le=q;if(Le.checkboxState!==void 0){const Ze=(0,$.$eg)(Le.checkboxState)?Le.checkboxState:(0,$.$cg)(Le.checkboxState)&&(0,$.$eg)(Le.checkboxState.state)?Le.checkboxState.state:void 0,et=!(0,$.$eg)(Le.checkboxState)&&(0,$.$cg)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==St.Checked&&Ze!==St.Unchecked||et!==void 0&&!(0,$.$ag)(et))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(q instanceof S)return!0;if(Le.label!==void 0&&!(0,$.$ag)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,$.$ag)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,$.$ag)(Le.iconPath)&&!k.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,$.$ag)(Le.iconPath.id))){const Ze=Le.iconPath;if(!Ze||!(0,$.$ag)(Ze.light)&&!k.URI.isUri(Ze.light)&&!(0,$.$ag)(Ze.dark)&&!k.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,$.$ag)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!k.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,$.$ag)(Le.tooltip)&&!(Le.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<pt.None&&Le.collapsibleState>pt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,$.$ag)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(q,fe=pt.None){this.collapsibleState=fe,k.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$dN=It,e.$dN=It=S=Je([D],It);var pt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(pt||(e.TreeItemCollapsibleState=pt={}));var St;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let cn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$eN=cn,e.$eN=cn=Je([D],cn);class Dt extends cn{}e.$fN=Dt;class gn extends Dt{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$gN=gn;class rn{constructor(q,fe,Le,Ze){this.name=q,this.uri=fe,this._itemId=Le,this.c=Ze}data(){return this.c()}}e.$hN=rn;let pn=class{#e=new Map;constructor(q){for(const[fe,Le]of q??[]){const Ze=this.#e.get(this.#t(fe));Ze?Ze.push(Le):this.#e.set(this.#t(fe),[Le])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,fe){this.#e.set(this.#t(q),[fe])}forEach(q,fe){for(const[Le,Ze]of this.#e)for(const et of Ze)q.call(fe,et,Le,this)}*[Symbol.iterator](){for(const[q,fe]of this.#e)for(const Le of fe)yield[q,Le]}#t(q){return q.toLowerCase()}};e.$iN=pn,e.$iN=pn=Je([D],pn);let hn=class{constructor(q,fe,Le){this.insertText=q,this.title=fe,this.kind=Le}};e.$jN=hn,e.$jN=hn=Je([D],hn);var vn;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(vn||(e.DocumentPasteTriggerKind=vn={}));class At{static{this.c="."}constructor(q){this.value=q}append(...q){return new At((this.value?[this.value,...q]:q).join(At.c))}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+At.c)}}e.$kN=At,At.Empty=new At("");class kn{constructor(q,fe,Le){this.title=fe,this.insertText=q,this.kind=Le}}e.$lN=kn;let sn=class{constructor(q,fe){this.id=q,this.color=fe}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$mN=sn,e.$mN=sn=Je([D],sn),sn.File=new sn("file"),sn.Folder=new sn("folder");let Oe=class{constructor(q){this.id=q}};e.$nN=Oe,e.$nN=Oe=Je([D],Oe);var ze;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(ze||(e.ConfigurationTarget=ze={}));let Ee=class{get base(){return this.c}set base(q){this.c=q,this.e=k.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,fe){if(typeof q!="string"&&(!q||!k.URI.isUri(q)&&!k.URI.isUri(q.uri)))throw(0,L.$7)("base");if(typeof fe!="string")throw(0,L.$7)("pattern");typeof q=="string"?this.baseUri=k.URI.file(q):k.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$oN=Ee,e.$oN=Ee=Je([D],Ee);const ee=new WeakMap;function Te(G,q){ee.set(G,q)}let He=class{constructor(q,fe,Le,Ze,et){this.enabled=typeof q=="boolean"?q:!0,typeof fe=="string"&&(this.condition=fe),typeof Le=="string"&&(this.hitCondition=Le),typeof Ze=="string"&&(this.logMessage=Ze),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=ee.get(this)??(0,I.$Wg)()),this.c}};e.$qN=He,e.$qN=He=Je([D],He);let Ye=class extends He{constructor(q,fe,Le,Ze,et,dt){if(super(fe,Le,Ze,et,dt),q===null)throw(0,L.$7)("location");this.location=q}};e.$rN=Ye,e.$rN=Ye=Je([D],Ye);let Ke=class extends He{constructor(q,fe,Le,Ze,et,dt){super(fe,Le,Ze,et,dt),this.functionName=q}};e.$sN=Ke,e.$sN=Ke=Je([D],Ke);let ht=class extends He{constructor(q,fe,Le,Ze,et,dt,bt,Jt){if(super(Ze,et,dt,bt,Jt),!fe)throw(0,L.$7)("dataId");this.label=q,this.dataId=fe,this.canPersist=Le}};e.$tN=ht,e.$tN=ht=Je([D],ht);let Et=class{constructor(q,fe,Le){this.command=q,this.args=fe||[],this.options=Le}};e.$uN=Et,e.$uN=Et=Je([D],Et);let jt=class{constructor(q,fe){this.port=q,this.host=fe}};e.$vN=jt,e.$vN=jt=Je([D],jt);let lt=class{constructor(q){this.path=q}};e.$wN=lt,e.$wN=lt=Je([D],lt);let Tt=class{constructor(q){this.implementation=q}};e.$xN=Tt,e.$xN=Tt=Je([D],Tt);class zt{constructor(q,fe,Le){this.session=q,this.threadId=fe,this.frameId=Le}}e.$yN=zt;class Sn{constructor(q,fe){this.session=q,this.threadId=fe}}e.$zN=Sn;let Pn=class{constructor(q,fe){this.range=q,this.expression=fe}};e.$AN=Pn,e.$AN=Pn=Je([D],Pn);var Qn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Qn||(e.InlineCompletionTriggerKind=Qn={}));let Ln=class{constructor(q,fe){this.range=q,this.text=fe}};e.$BN=Ln,e.$BN=Ln=Je([D],Ln);let Nn=class{constructor(q,fe,Le=!0){this.range=q,this.variableName=fe,this.caseSensitiveLookup=Le}};e.$CN=Nn,e.$CN=Nn=Je([D],Nn);let In=class{constructor(q,fe){this.range=q,this.expression=fe}};e.$DN=In,e.$DN=In=Je([D],In);let Tn=class{constructor(q,fe){this.frameId=q,this.stoppedLocation=fe}};e.$EN=Tn,e.$EN=Tn=Je([D],Tn);var Fn;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Fn||(e.NewSymbolNameTag=Fn={}));var Zn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Zn||(e.NewSymbolNameTriggerKind=Zn={}));class jn{constructor(q,fe){this.newSymbolName=q,this.tags=fe}}e.$FN=jn;var An;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(An||(e.FileChangeType=An={}));let zn=m=class extends Error{static FileExists(q){return new m(q,p.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(q){return new m(q,p.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(q){return new m(q,p.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(q){return new m(q,p.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(q){return new m(q,p.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(q){return new m(q,p.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(q,fe=p.FileSystemProviderErrorCode.Unknown,Le){super(k.URI.isUri(q)?q.toString(!0):q),this.code=Le?.name??"Unknown",(0,p.$jl)(this,fe),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$GN=zn,e.$GN=zn=m=Je([D],zn);let Un=class{constructor(q,fe,Le){this.start=q,this.end=fe,this.kind=Le}};e.$HN=Un,e.$HN=Un=Je([D],Un);var yn;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(yn||(e.FoldingRangeKind=yn={}));var Xn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Xn||(e.CommentThreadCollapsibleState=Xn={}));var Yn;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Yn||(e.CommentMode=Yn={}));var Rn;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Rn||(e.CommentState=Rn={}));var xn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(xn||(e.CommentThreadState=xn={}));var Bn;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Bn||(e.CommentThreadApplicability=Bn={}));class gi{constructor(q,fe=[]){this.tokenTypes=q,this.tokenModifiers=fe}}e.$IN=gi;function _n(G){return typeof G>"u"||(0,$.$bg)(G)}class Wn{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let fe=0,Le=q.tokenTypes.length;fe<Le;fe++)this.k.set(q.tokenTypes[fe],fe);for(let fe=0,Le=q.tokenModifiers.length;fe<Le;fe++)this.l.set(q.tokenModifiers[fe],fe)}}push(q,fe,Le,Ze,et){if(typeof q=="number"&&typeof fe=="number"&&typeof Le=="number"&&typeof Ze=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(q,fe,Le,Ze,et);if(F.isRange(q)&&typeof fe=="string"&&_n(Le))return this.o(q,fe,Le);throw(0,L.$7)()}o(q,fe,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ze=q.start.line,et=q.start.character,dt=q.end.character-q.start.character,bt=this.k.get(fe);let Jt=0;if(Le)for(const un of Le){if(!this.l.has(un))throw new Error("`tokenModifier` is not in the provided legend");const fn=this.l.get(un);Jt|=1<<fn>>>0}this.q(Ze,et,dt,bt,Jt)}q(q,fe,Le,Ze,et){if(this.f&&(q<this.c||q===this.c&&fe<this.e)){this.f=!1;const Jt=this.g.length/5|0;let un=0,fn=0;for(let $n=0;$n<Jt;$n++){let wn=this.g[5*$n],Kn=this.g[5*$n+1];wn===0?(wn=un,Kn+=fn):wn+=un,this.g[5*$n]=wn,this.g[5*$n+1]=Kn,un=wn,fn=Kn}}let dt=q,bt=fe;this.f&&this.j>0&&(dt-=this.c,dt===0&&(bt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=bt,this.g[this.j++]=Le,this.g[this.j++]=Ze,this.g[this.j++]=et,this.c=q,this.e=fe}static r(q){const fe=[],Le=q.length/5|0;for(let bt=0;bt<Le;bt++)fe[bt]=bt;fe.sort((bt,Jt)=>{const un=q[5*bt],fn=q[5*Jt];if(un===fn){const $n=q[5*bt+1],wn=q[5*Jt+1];return $n-wn}return un-fn});const Ze=new Uint32Array(q.length);let et=0,dt=0;for(let bt=0;bt<Le;bt++){const Jt=5*fe[bt],un=q[Jt+0],fn=q[Jt+1],$n=q[Jt+2],wn=q[Jt+3],Kn=q[Jt+4],ji=un-et,br=ji===0?fn-dt:fn,Jn=5*bt;Ze[Jn+0]=ji,Ze[Jn+1]=br,Ze[Jn+2]=$n,Ze[Jn+3]=wn,Ze[Jn+4]=Kn,et=un,dt=fn}return Ze}build(q){return this.f?new bn(new Uint32Array(this.g),q):new bn(Wn.r(this.g),q)}}e.$JN=Wn;class bn{constructor(q,fe){this.resultId=fe,this.data=q}}e.$KN=bn;class mi{constructor(q,fe,Le){this.start=q,this.deleteCount=fe,this.data=Le}}e.$LN=mi;class $i{constructor(q,fe){this.resultId=fe,this.edits=q}}e.$MN=$i;var ei;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(ei||(e.DebugConsoleMode=ei={}));class Vn{constructor(q){this.name=q}}e.$NN=Vn;let Mn=class{static{this.Back={iconPath:new sn("arrow-left")}}constructor(){}};e.$ON=Mn,e.$ON=Mn=Je([D],Mn);var Be;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Be||(e.QuickPickItemKind=Be={}));var dn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(dn||(e.InputBoxValidationSeverity=dn={}));var qn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(qn||(e.ExtensionKind=qn={}));class ot{static validate(q){if(typeof q.badge=="string"){let fe=(0,w.$Lf)(q.badge,0);if(fe<q.badge.length&&(fe+=(0,w.$Lf)(q.badge,fe)),q.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!sn.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,fe,Le){this.badge=q,this.tooltip=fe,this.color=Le}}e.$PN=ot;let vt=class{constructor(q){this.kind=q}};e.$QN=vt,e.$QN=vt=Je([D],vt);var ti;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(ti||(e.ColorThemeKind=ti={}));class mn{static isNotebookRange(q){return q instanceof mn?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,fe){if(q<0)throw(0,L.$7)("start must be positive");if(fe<0)throw(0,L.$7)("end must be positive");q<=fe?(this.c=q,this.e=fe):(this.c=fe,this.e=q)}with(q){let fe=this.c,Le=this.e;return q.start!==void 0&&(fe=q.start),q.end!==void 0&&(Le=q.end),fe===this.c&&Le===this.e?this:new mn(fe,Le)}}e.$RN=mn;class Dn{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(fe=>Dn.isNotebookCellData(fe))}static isNotebookCellData(q){return!0}constructor(q,fe,Le,Ze,et,dt,bt){this.kind=q,this.value=fe,this.languageId=Le,this.mime=Ze,this.outputs=et??[],this.metadata=dt,this.executionSummary=bt,Dn.validate(this)}}e.$SN=Dn;class pi{constructor(q){this.cells=q}}e.$TN=pi;class nn{static isNotebookCellOutputItem(q){return q instanceof nn?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const fe={name:q.name,message:q.message,stack:q.stack};return nn.json(fe,"application/vnd.code.notebook.error")}static stdout(q){return nn.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return nn.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,fe="application/octet-stream"){return new nn(q,fe)}static#e=new TextEncoder;static text(q,fe=R.$Ws.text){const Le=nn.#e.encode(String(q));return new nn(Le,fe)}static json(q,fe="text/x-json"){const Le=JSON.stringify(q,void 0,"	");return nn.text(Le,fe)}constructor(q,fe){this.data=q,this.mime=fe;const Le=(0,R.$1s)(fe,!0);if(!Le)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$UN=nn;class On{static isNotebookCellOutput(q){return q instanceof On?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,fe=!1){const Le=new Set,Ze=new Set;for(let et=0;et<q.length;et++){const dt=q[et],bt=(0,R.$1s)(dt.mime);if(!Le.has(bt)||(0,v.$jK)(bt)){Le.add(bt);continue}Ze.add(et),fe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ze.size===0?q:q.filter((et,dt)=>!Ze.has(dt))}constructor(q,fe,Le){this.items=On.ensureUniqueMimeTypes(q,!0),typeof fe=="string"?(this.id=fe,this.metadata=Le):(this.id=(0,I.$Wg)(),this.metadata=fe??Le)}}e.$VN=On;var ni;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(ni||(e.NotebookCellKind=ni={}));var ii;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(ii||(e.NotebookCellExecutionState=ii={}));var Hn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Hn||(e.NotebookCellStatusBarAlignment=Hn={}));var ri;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(ri||(e.NotebookEditorRevealType=ri={}));class bi{constructor(q,fe){this.text=q,this.alignment=fe}}e.$WN=bi;var si;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(si||(e.NotebookControllerAffinity=si={}));var oi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(oi||(e.NotebookControllerAffinity2=oi={}));class wi{constructor(q,fe=[]){this.uri=q,this.provides=(0,l.$2b)(fe)}}e.$XN=wi;class vi{constructor(q){this.label=q}}e.$YN=vi;var ai;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(ai||(e.NotebookVariablesRequestKind=ai={}));let Gn=class{constructor(q,fe){this.label=q,this.timestamp=fe}};e.$ZN=Gn,e.$ZN=Gn=Je([D],Gn);var ci;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(ci||(e.ExtensionMode=ci={}));var ui;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ui||(e.ExtensionRuntime=ui={}));var li;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(li||(e.StandardTokenType=li={}));class de{constructor(q,fe){this.ranges=q,this.wordPattern=fe}}e.$1N=de;class ye{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$2N=ye;var Ue;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(Ue||(e.TestResultState=Ue={}));var ct;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(ct||(e.TestRunProfileKind=ct={}));let yt=class{constructor(q=void 0,fe=void 0,Le=void 0,Ze=!1,et=!0){this.include=q,this.exclude=fe,this.profile=Le,this.continuous=Ze,this.preserveFocus=et}};e.$3N=yt,e.$3N=yt=Je([D],yt);let Rt=y=class{static diff(q,fe,Le){const Ze=new y(q);return Ze.expectedOutput=fe,Ze.actualOutput=Le,Ze}constructor(q){this.message=q}};e.$4N=Rt,e.$4N=Rt=y=Je([D],Rt);let Cn=class{constructor(q){this.id=q}};e.$5N=Cn,e.$5N=Cn=Je([D],Cn);class hi{constructor(q,fe){this.covered=q,this.total=fe,Ei(this)}}e.$6N=hi;function Ei(G){if(G){if(G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`);if(G.total<0)throw new Error(`The number of covered items (${G.total}) cannot be negative`)}}class yi{static fromDetails(q,fe){const Le=new hi(0,0),Ze=new hi(0,0),et=new hi(0,0);for(const bt of fe)if("branches"in bt){Le.total+=1,Le.covered+=bt.executed?1:0;for(const Jt of bt.branches)Ze.total+=1,Ze.covered+=Jt.executed?1:0}else et.total+=1,et.covered+=bt.executed?1:0;const dt=new yi(q,Le,Ze.total>0?Ze:void 0,et.total>0?et:void 0);return dt.detailedCoverage=fe,dt}constructor(q,fe,Le,Ze,et){this.uri=q,this.statementCoverage=fe,this.branchCoverage=Le,this.declarationCoverage=Ze,this.testItem=et}}e.$8N=yi;class zi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,fe,Le=[]){this.executed=q,this.location=fe,this.branches=Le}}e.$9N=zi;class Ui{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,fe,Le){this.executed=q,this.location=fe,this.label=Le}}e.$0N=Ui;class Bi{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,fe,Le){this.name=q,this.executed=fe,this.location=Le}}e.$$N=Bi;var ki;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(ki||(e.ExternalUriOpenerPriority=ki={}));var Si;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Si||(e.WorkspaceTrustState=Si={}));var Di;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Di||(e.PortAutoForwardAction=Di={}));class Wi{constructor(q,fe,Le,Ze,et,dt){this.kind=q,this.name=fe,this.detail=Le,this.uri=Ze,this.range=et,this.selectionRange=dt}}e.$_N=Wi;class Vi{constructor(q){this.uri=q}}e.$aO=Vi;class qi{constructor(q,fe){this.original=q,this.modified=fe}}e.$bO=qi;class Hi{constructor(q,fe,Le,Ze){this.base=q,this.input1=fe,this.input2=Le,this.result=Ze}}e.$cO=Hi;class Gi{constructor(q,fe){this.uri=q,this.viewType=fe}}e.$dO=Gi;class Ki{constructor(q){this.viewType=q}}e.$eO=Ki;class Ji{constructor(q,fe){this.uri=q,this.notebookType=fe}}e.$fO=Ji;class Qi{constructor(q,fe,Le){this.original=q,this.modified=fe,this.notebookType=Le}}e.$gO=Qi;class Zi{constructor(){}}e.$hO=Zi;class Xi{constructor(q,fe){this.uri=q,this.inputBoxUri=fe}}e.$iO=Xi;class Yi{constructor(){}}e.$jO=Yi;class xi{constructor(q){this.textDiffs=q}}e.$kO=xi;var Ci;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(Ci||(e.InteractiveSessionVoteDirection=Ci={}));var Pi;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Pi||(e.ChatCopyKind=Pi={}));var Ii;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Ii||(e.ChatVariableLevel=Ii={}));class _i{constructor(q,fe,Le){this.id=q,this.label=fe,this.values=Le}}e.$lO=_i;var Ai;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Ai||(e.InteractiveEditorResponseFeedbackKind=Ai={}));var Ri;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(Ri||(e.ChatResultFeedbackKind=Ri={}));class er{constructor(q){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new Qe(q):q}}e.$mO=er;class tr{constructor(q,fe){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new Qe(q):q,this.vulnerabilities=fe}}e.$nO=tr;class nr{constructor(q,fe){this.participant=q,this.command=fe}}e.$oO=nr;class ir{constructor(q,fe,Le){this.title=q,this.message=fe,this.data=Le}}e.$pO=ir;class rr{constructor(q,fe){this.value=q,this.baseUri=fe}}e.$qO=rr;class sr{constructor(q,fe){this.value=q,this.title=fe}}e.$rO=sr;class or{constructor(q){this.value=q}}e.$sO=or;class ar{constructor(q,fe){this.value=q,this.task=fe}}e.$tO=ar;class cr{constructor(q){if(typeof q!="string"&&q.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof q=="string"?new Qe(q):q}}e.$uO=cr;class ur{constructor(q){this.value=q}}e.$vO=ur;class lr{constructor(q,fe){this.value=q,this.iconPath=fe}}e.$wO=lr;class hr{constructor(q,fe){this.uri=q,this.edits=Array.isArray(fe)?fe:[fe]}}e.$xO=hr;class dr{constructor(q,fe,Le,Ze){this.prompt=q,this.command=fe,this.references=Le,this.participant=Ze}}e.$yO=dr;class fr{constructor(q,fe,Le,Ze){this.response=q,this.result=fe,this.participant=Le,this.command=Ze}}e.$zO=fr;var Mi;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook",G[G.Editor=4]="Editor"})(Mi||(e.ChatLocation=Mi={}));var di;(function(G){G[G.User=1]="User",G[G.Assistant=2]="Assistant",G[G.System=3]="System"})(di||(e.LanguageModelChatMessageRole=di={}));class fi{static User(q,fe){return new fi(di.User,q,fe)}static Assistant(q,fe){return new fi(di.Assistant,q,fe)}constructor(q,fe,Le){this.role=q,this.content=fe,this.name=Le}}e.$AO=fi;class gr{constructor(q){this.content=q}}e.$BO=gr;class mr{constructor(q,fe){this.content=q,this.name=fe}}e.$CO=mr;class $r{constructor(q,fe){this.content=q,this.name=fe}}e.$DO=$r;class En extends Error{static NotFound(q){return new En(q,En.NotFound.name)}static NoPermissions(q){return new En(q,En.NoPermissions.name)}static Blocked(q){return new En(q,En.Blocked.name)}constructor(q,fe,Le){super(q,{cause:Le}),this.name="LanguageModelError",this.code=fe??""}}e.$EO=En;var Oi;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Oi||(e.RelatedInformationType=Oi={}));var Li;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped",G[G.Error=5]="Error"})(Li||(e.SpeechToTextStatus=Li={}));var Ni;(function(G){G[G.Started=1]="Started",G[G.Stopped=2]="Stopped",G[G.Error=3]="Error"})(Ni||(e.TextToSpeechStatus=Ni={}));var Ti;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Ti||(e.KeywordRecognitionStatus=Ti={}));class pr{constructor(q,fe){this.text=q,this.range=fe}}e.$FO=pr;var Fi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Fi||(e.InlineEditTriggerKind=Fi={}))}),define(ke[330],De([1,0,6,8]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$nM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,w,$){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(R);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(w,$)??[]}getRelatedInformation(R,w,$){return this.c.$getAiRelatedInformation(w,$)}registerRelatedInformationProvider(R,w,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiRelatedInformationProvider(k,w),new L.$pM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$emc=M}),define(ke[121],De([1,0,4,6,8,25,146,5,20]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=e.$pmc=void 0,e.$pmc=(0,w.$Ai)("IExtHostAuthentication");let k=class{constructor(p){this.b=new Map,this.c=new l.$he,this.onDidChangeSessions=this.c.event,this.d=new I,this.f=new I,this.a=p.getProxy(L.$nM.MainThreadAuthentication)}async getSession(p,E,v,d={}){const h=A.$Vm.toKey(p.identifier),c=[...v].sort().join(" ");return await this.d.getOrCreate(`${h} ${E} ${c}`,async()=>{await this.a.$ensureProvider(E);const i=p.displayName||p.name;return this.a.$getSession(E,v,h,i,d)})}async getSessions(p,E,v){const d=A.$Vm.toKey(p.identifier),h=[...v].sort().join(" ");return await this.f.getOrCreate(`${d} ${h}`,async()=>{await this.a.$ensureProvider(E);const c=p.displayName||p.name;return this.a.$getSessions(E,v,d,c)})}async removeSession(p,E){const v=this.b.get(p);return v?v.provider.removeSession(E):this.a.$removeSession(p,E)}registerAuthenticationProvider(p,E,v,d){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:E,provider:v,options:d??{supportsMultipleAccounts:!1}});const h=v.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(p,c));return this.a.$registerAuthenticationProvider(p,E,d?.supportsMultipleAccounts??!1),new M.$pM(()=>{h.dispose(),this.b.delete(p),this.a.$unregisterAuthenticationProvider(p)})}async $createSession(p,E,v){const d=this.b.get(p);if(d)return await d.provider.createSession(E,v);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $removeSession(p,E){const v=this.b.get(p);if(v)return await v.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${p}`)}async $getSessions(p,E){const v=this.b.get(p);if(v)return await v.provider.getSessions(E);throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,E){return p.startsWith(R.$pL)||this.c.fire({provider:{id:p,label:E}}),Promise.resolve()}};e.$qmc=k,e.$qmc=k=Je([We(0,$.$RO)],k);class I{constructor(){this.a=new Map}getOrCreate(p,E){const v=this.a.get(p);if(v)return v;const d=E().finally(()=>this.a.delete(p));return this.a.set(p,d),d}}}),define(ke[152],De([1,0,2,6,8,5,20,11,19,14,16,26]),function(le,e,l,L,M,A,R,w,$,k,I,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=e.$pnc=void 0;let E=class{static{p=this}static{this.c=0}static{this.d=250}constructor(d,h){this.h=h,this.f=new Map,this.g=d.getProxy(L.$nM.MainThreadDecorations)}registerFileDecorationProvider(d,h){const c=p.c++;this.f.set(c,{provider:d,extensionDescription:h}),this.g.$registerDecorationProvider(c,h.identifier.value);const i=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(c,null);return}const a=(0,$.$2b)(n);if(a.length<=p.d){this.g.$onDidChange(c,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",h.identifier.value,a.length);const r=a.map(o=>({uri:o,rank:(0,k.$ef)(o.path,"/")})),t=(0,$.$zb)(r,(o,s)=>o.rank-s.rank||(0,k.$uf)(o.uri.path,s.uri.path)),f=[];e:for(const o of t){let s;for(const u of o){const g=(0,I.$mc)(u.uri.path);if(s!==g&&(s=g,f.push(u.uri)>=p.d))break e}}this.g.$onDidChange(c,f)});return new M.$pM(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(d,h,c){if(!this.f.has(d))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:a}=this.f.get(d);return await Promise.all(h.map(async r=>{try{const{uri:t,id:f}=r,o=await Promise.resolve(n.provideFileDecoration(l.URI.revive(t),c));if(!o)return;try{M.$PN.validate(o),o.badge&&typeof o.badge!="string"&&(0,P.$OG)(a,"codiconDecoration"),i[f]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${s}`)}}catch(t){this.h.error(t)}})),i}};e.$pnc=E,e.$pnc=E=p=Je([We(0,R.$RO),We(1,w.$7j)],E),e.$qnc=(0,A.$Ai)("IExtHostDecorations")}),define(ke[331],De([1,0,13,2,8,6,15,21,14]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;class k{static{this.a=0}constructor(P,p,E){this.d=p,this.e=E,this.b=new Map,this.c=P.getProxy(A.$nM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,p){if(Object.keys(R.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const E=k.a++;this.b.set(E,p),this.c.$registerTextContentProvider(E,P);let v;if(typeof p.onDidChange=="function"){let d;v=p.onDidChange(async h=>{if(h.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(h))return;d&&await d;const c=this.$provideTextDocumentContent(E,h).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(h);if(!n)return;const a=(0,$.$of)(i);if(!n.equalLines(a))return this.c.$onVirtualDocumentChange(h,i)}).catch(l.$1).finally(()=>{d===c&&(d=void 0)});d=c})}return new M.$pM(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,p){const E=this.b.get(P);return E?Promise.resolve(E.provideTextDocumentContent(L.URI.revive(p),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$snc=k}),define(ke[153],De([1,0,62,15,14,188,130,8,19]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=void 0,e.$TO=I;const k=new Map;function I(v,d){d?k.set(v,d):k.delete(v)}function P(v){return k.get(v)}class p extends A.$_v{constructor(d,h,c,i,n,a,r){super(h,c,i,n),this.c=d,this.m=a,this.q=r,this.b=!1}dispose(){(0,l.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,$.$ub)(this.f,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.d},get fileName(){return d.d.fsPath},get isUntitled(){return d.d.scheme===L.Schemas.untitled},get languageId(){return d.m},get version(){return d.h},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(h){return h?d.s(h):d.getText()},get eol(){return d.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return d.f.length},lineAt(h){return d.t(h)},offsetAt(h){return d.u(h)},positionAt(h){return d.v(h)},validateRange(h){return d.w(h)},validatePosition(h){return d.x(h)},getWordRangeAtPosition(h,c){return d.y(h,c)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,l.ok)(!this.b),this.m=d}_acceptIsDirty(d){(0,l.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(d){const h=this.w(d);if(h.isEmpty)return"";if(h.isSingleLine)return this.f[h.start.line].substring(h.start.character,h.end.character);const c=this.g,i=h.start.line,n=h.end.line,a=[];a.push(this.f[i].substring(h.start.character));for(let r=i+1;r<n;r++)a.push(this.f[r]);return a.push(this.f[n].substring(0,h.end.character)),a.join(c)}t(d){let h;if(d instanceof w.$qM?h=d.line:typeof d=="number"&&(h=d),typeof h!="number"||h<0||h>=this.f.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new E(h,this.f[h],h===this.f.length-1)}u(d){return d=this.x(d),this.l(),this.j.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.l();const h=this.j.getIndexOf(d),c=this.f[h.index].length;return new w.$qM(h.index,Math.min(h.remainder,c))}w(d){if(!(d instanceof w.$rM))throw new Error("Invalid argument");const h=this.x(d.start),c=this.x(d.end);return h===d.start&&c===d.end?d:new w.$rM(h.line,h.character,c.line,c.character)}x(d){if(!(d instanceof w.$qM))throw new Error("Invalid argument");if(this.f.length===0)return d.with(0,0);let{line:h,character:c}=d,i=!1;if(h<0)h=0,c=0,i=!0;else if(h>=this.f.length)h=this.f.length-1,c=this.f[h].length,i=!0;else{const n=this.f[h].length;c<0?(c=0,i=!0):c>n&&(c=n,i=!0)}return i?new w.$qM(h,c):d}y(d,h){const c=this.x(d);if(!h)h=P(this.m);else if((0,M.$nf)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const i=(0,R.$ct)(c.character+1,(0,R.$at)(h),this.f[c.line],0);if(i)return new w.$rM(c.line,i.startColumn-1,c.line,i.endColumn-1)}}e.$UO=p;class E{constructor(d,h,c){this.a=d,this.b=h,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$rM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$rM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$VO=E}),define(ke[332],De([1,0,6,8]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$nM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,w,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(R);if(!k)throw new Error("Embedding vector provider not found");const I=await k.provideEmbeddingVector(w,$);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(R,w,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiEmbeddingVectorProvider(w,k),new L.$pM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$vnc=M}),define(ke[70],De([1,0,6,33,8,22,5,20,60,3,7,23,15]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=e.$Fmc=void 0;let v=E=class{constructor(h,c){this.b=new Map,this.c=new I.$Jh,this.a=h.getProxy(l.$nM.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let a;const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),a=await r.impl.stat(n)):a=await i.a.$stat(n),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===L.FilePermission.Readonly?1:void 0}}catch(a){E.e(a)}},async readDirectory(n){try{const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),(await a.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(a){return E.e(a)}},async createDirectory(n){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,n)):await i.a.$mkdir(n)}catch(a){return E.e(a)}},async readFile(n){try{const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),(await a.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(a){return E.e(a)}},async writeFile(n,a){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,r.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(r.impl.writeFile(n,a,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,A.$Je.wrap(a))}catch(r){return E.e(r)}},async delete(n,a){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly&&!a?.useTrash?(await i.a.$ensureActivation(n.scheme),await r.impl.delete(n,{recursive:!1,...a})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(r){return E.e(r)}},async rename(n,a,r){try{return await i.a.$rename(n,a,{overwrite:!1,...r})}catch(t){return E.e(t)}},async copy(n,a,r){try{return await i.a.$copy(n,a,{overwrite:!1,...r})}catch(t){return E.e(t)}},isWritableFileSystem(n){const a=c.getCapabilities(n);if(typeof a=="number")return!(a&2048)}})}async d(h,c,i){const n=[];for(;!c.isEqual(i,c.dirname(i));)try{if(!((await h.stat(i)).type&L.FileType.Directory))throw M.$GN.FileExists(`Unable to create folder '${i.scheme===p.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(L.$kl(a)!==L.FileSystemProviderErrorCode.FileNotFound)throw a;n.push(c.basename(i)),i=c.dirname(i)}for(let a=n.length-1;a>=0;a--){i=c.joinPath(i,n[a]);try{await h.createDirectory(i)}catch(r){if(L.$kl(r)!==L.FileSystemProviderErrorCode.FileExists)throw r}}}static e(h){if(h instanceof M.$GN)throw h;if(h instanceof L.$gl)switch(h.code){case L.FileSystemProviderErrorCode.FileExists:throw M.$GN.FileExists(h.message);case L.FileSystemProviderErrorCode.FileNotFound:throw M.$GN.FileNotFound(h.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw M.$GN.FileNotADirectory(h.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw M.$GN.FileIsADirectory(h.message);case L.FileSystemProviderErrorCode.NoPermissions:throw M.$GN.NoPermissions(h.message);case L.FileSystemProviderErrorCode.Unavailable:throw M.$GN.Unavailable(h.message);default:throw new M.$GN(h.message,h.name)}if(!(h instanceof Error))throw new M.$GN(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw M.$GN.Unavailable(h.message);switch(h.name){case L.FileSystemProviderErrorCode.FileExists:throw M.$GN.FileExists(h.message);case L.FileSystemProviderErrorCode.FileNotFound:throw M.$GN.FileNotFound(h.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw M.$GN.FileNotADirectory(h.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw M.$GN.FileIsADirectory(h.message);case L.FileSystemProviderErrorCode.NoPermissions:throw M.$GN.NoPermissions(h.message);case L.FileSystemProviderErrorCode.Unavailable:throw M.$GN.Unavailable(h.message);default:throw new M.$GN(h.message,h.name)}}addFileSystemProvider(h,c,i){return this.b.set(h,{impl:c,extUri:i?.isCaseSensitive?P.$4g:P.$6g,isReadonly:!!i?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(h))}getFileSystemProviderExtUri(h){return this.b.get(h)?.extUri??P.$4g}};e.$Fmc=v,e.$Fmc=v=E=Je([We(0,w.$RO),We(1,$.$jmc)],v),e.$Gmc=(0,R.$Ai)("IExtHostConsumerFileSystem")}),define(ke[93],De([1,0,5,28,11,70,2]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=e.$Hmc=void 0,e.$Hmc=(0,l.$Ai)("IExtensionStoragePaths");let w=class{constructor(k,I,P){this.d=I,this.f=P,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(k){return R.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,I=await this.g(k);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(R.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(k){if(this.c)return R.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return R.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Imc=w,e.$Imc=w=Je([We(0,L.$8O),We(1,M.$7j),We(2,A.$Gmc)],w)}),define(ke[333],De([1,0,8,20,4]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=void 0;let A=class{constructor(w){this.a=new l.$QN(l.ColorThemeKind.Dark),this.b=new M.$he}get activeColorTheme(){return this.a}$onColorThemeChange(w){let $;switch(w){case"light":$=l.ColorThemeKind.Light;break;case"hcDark":$=l.ColorThemeKind.HighContrast;break;case"hcLight":$=l.ColorThemeKind.HighContrastLight;break;default:$=l.ColorThemeKind.Dark}this.a=new l.$QN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$doc=A,e.$doc=A=Je([We(0,L.$RO)],A)}),define(ke[71],De([1,0,21,4,3,234,5,11,88,6,28,20,8]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aEb=e.$_Db=e.TunnelDtoConverter=void 0;class E extends $.$yw{}var v;(function(h){function c(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}h.fromApiTunnel=c;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}h.fromServiceTunnel=i})(v||(e.TunnelDtoConverter=v={})),e.$_Db=(0,R.$Ai)("IExtHostTunnelService");let d=class extends M.$Uc{constructor(c,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$he,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(k.$nM.MainThreadTunnelService)}async openTunnel(c,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,c.displayName);if(n){const a=new E(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,i){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:c,provider:i}),this.a.$registerPortsAttributesProvider(c,n),new p.$pM(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(c,i,n,a,r){const t=[];for(const o of c){const s=this.r.get(o);if(!s)return[];t.push(...await Promise.all(i.map(async u=>{let g;try{g=await s.provider.providePortAttributes({port:u,pid:n,commandLine:a},r)}catch{g=await s.provider.providePortAttributes(u,n,a,r)}return{providedAttributes:g,port:u}})))}const f=t.filter(o=>!!o.providedAttributes);return f.length>0?f.map(o=>({autoForwardAction:o.providedAttributes.autoForwardAction,port:o.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,r)=>await c.provideTunnel(a,r,l.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,i){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const n=c.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let a=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const r=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(r)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,i){if(this.g.has(c.host)){const n=this.g.get(c.host);n.has(c.port)&&(i&&n.get(c.port).disposeListener.dispose(),await n.get(c.port).tunnel.dispose(),n.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(c,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const a=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const r=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:a,disposeListener:r}),v.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(c){const i=await Promise.all(c.map(a=>this.f(a.host,a.port,a.detail??""))),n=c.filter((a,r)=>i[r]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(a=>a.port).join(", ")} to ${n.map(a=>a.port).join(", ")}`),n}};e.$aEb=d,e.$aEb=d=Je([We(0,P.$RO),We(1,I.$8O),We(2,w.$7j)],d)}),define(ke[17],De([1,0,19,22,177,75,81,27,167,53,101,24,172,23,50,18,2,29,84,139,145,143,296,120,69,89,308,8]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r,t,f,o,s,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$OO=B,e.$PO=ie,e.$QO=H;var b;(function(Oe){function ze(ee){const{selectionStartLineNumber:Te,selectionStartColumn:He,positionLineNumber:Ye,positionColumn:Ke}=ee,ht=new g.$qM(Te-1,He-1),Et=new g.$qM(Ye-1,Ke-1);return new g.$sM(ht,Et)}Oe.to=ze;function Ee(ee){const{anchor:Te,active:He}=ee;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Oe.from=Ee})(b||(e.Selection=b={}));var S;(function(Oe){function ze(ee){if(!ee)return;const{start:Te,end:He}=ee;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Oe.from=ze;function Ee(ee){if(!ee)return;const{startLineNumber:Te,startColumn:He,endLineNumber:Ye,endColumn:Ke}=ee;return new g.$rM(Te-1,He-1,Ye-1,Ke-1)}Oe.to=Ee})(S||(e.Range=S={}));var m;(function(Oe){function ze(ee){return{uri:ee.uri,range:S.from(ee.range)}}Oe.from=ze;function Ee(ee){return new g.$BM(h.URI.revive(ee.uri),S.to(ee.range))}Oe.to=Ee})(m||(e.Location=m={}));var y;(function(Oe){function ze(Ee){switch(Ee){case 1:return g.StandardTokenType.Comment;case 0:return g.StandardTokenType.Other;case 3:return g.StandardTokenType.RegEx;case 2:return g.StandardTokenType.String}}Oe.to=ze})(y||(e.TokenType=y={}));var D;(function(Oe){function ze(ee){return new g.$qM(ee.lineNumber-1,ee.column-1)}Oe.to=ze;function Ee(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Oe.from=Ee})(D||(e.Position=D={}));var C;(function(Oe){function ze(Te,He,Ye){return(0,l.$Hb)((0,l.$2b)(Te).map(Ke=>Ee(Ke,He,Ye)))}Oe.from=ze;function Ee(Te,He,Ye){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Ye?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:ee(Te.scheme,He),pattern:Ce.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Ye?.isBuiltin}}function ee(Te,He){return He&&typeof Te=="string"?He.transformOutgoingScheme(Te):Te}})(C||(e.DocumentSelector=C={}));var O;(function(Oe){function ze(ee){switch(ee){case g.DiagnosticTag.Unnecessary:return 1;case g.DiagnosticTag.Deprecated:return 2}}Oe.from=ze;function Ee(ee){switch(ee){case 1:return g.DiagnosticTag.Unnecessary;case 2:return g.DiagnosticTag.Deprecated;default:return}}Oe.to=Ee})(O||(e.DiagnosticTag=O={}));var z;(function(Oe){function ze(ee){let Te;return ee.code&&((0,d.$ag)(ee.code)||(0,d.$eg)(ee.code)?Te=String(ee.code):Te={value:String(ee.code.value),target:ee.code.target}),{...S.from(ee.range),message:ee.message,source:ee.source,code:Te,severity:F.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(T.from),tags:Array.isArray(ee.tags)?(0,l.$Hb)(ee.tags.map(O.from)):void 0}}Oe.from=ze;function Ee(ee){const Te=new g.$DM(S.to(ee),ee.message,F.to(ee.severity));return Te.source=ee.source,Te.code=(0,d.$ag)(ee.code)?ee.code:ee.code?.value,Te.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(T.to),Te.tags=ee.tags&&(0,l.$Hb)(ee.tags.map(O.to)),Te}Oe.to=Ee})(z||(e.Diagnostic=z={}));var T;(function(Oe){function ze(ee){return{...S.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Oe.from=ze;function Ee(ee){return new g.$CM(new g.$BM(ee.resource,S.to(ee)),ee.message)}Oe.to=Ee})(T||(e.DiagnosticRelatedInformation=T={}));var F;(function(Oe){function ze(ee){switch(ee){case g.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case g.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case g.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case g.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Oe.from=ze;function Ee(ee){switch(ee){case n.MarkerSeverity.Info:return g.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return g.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return g.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return g.DiagnosticSeverity.Hint;default:return g.DiagnosticSeverity.Error}}Oe.to=Ee})(F||(e.DiagnosticSeverity=F={}));var N;(function(Oe){function ze(ee){return typeof ee=="number"&&ee>=g.ViewColumn.One?ee-1:ee===g.ViewColumn.Beside?u.$$D:u.$0D}Oe.from=ze;function Ee(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Oe.to=Ee})(N||(e.ViewColumn=N={}));function j(Oe){return typeof Oe.range<"u"}function B(Oe){return Oe.length===0?!0:!!j(Oe[0])}var X;(function(Oe){function ze(Ke){return Ke.map(Oe.from)}Oe.fromMany=ze;function Ee(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function ee(Ke){let ht;if(Ee(Ke)){const{language:Tt,value:zt}=Ke;ht={value:"```"+Tt+`
`+zt+"\n```\n"}}else g.$RM.isMarkdownString(Ke)?ht={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ht={value:Ke}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const jt=Tt=>{try{let zt=h.URI.parse(Tt,!0);zt=zt.with({query:Te(zt.query,Et)}),Et[Tt]=zt}catch{}return""},lt=new $.marked.Renderer;return lt.link=jt,lt.image=Tt=>typeof Tt=="string"?jt(R.$6k(Tt).href):"",(0,$.marked)(ht.value,{renderer:lt}),ht}Oe.from=ee;function Te(Ke,ht){if(!Ke)return Ke;let Et;try{Et=(0,k.$9h)(Ke)}catch{}if(!Et)return Ke;let jt=!1;return Et=(0,P.$9n)(Et,lt=>{if(h.URI.isUri(lt)){const Tt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[Tt]=lt,jt=!0,Tt}else return}),jt?JSON.stringify(Et):Ke}function He(Ke){const ht=new g.$RM(Ke.value,Ke.supportThemeIcons);return ht.isTrusted=Ke.isTrusted,ht.supportHtml=Ke.supportHtml,ht.baseUri=Ke.baseUri?h.URI.from(Ke.baseUri):void 0,ht}Oe.to=He;function Ye(Ke){if(Ke)return typeof Ke=="string"?Ke:Oe.from(Ke)}Oe.fromStrict=Ye})(X||(e.MarkdownString=X={}));function ie(Oe){return B(Oe)?Oe.map(ze=>({range:S.from(ze.range),hoverMessage:Array.isArray(ze.hoverMessage)?X.fromMany(ze.hoverMessage):ze.hoverMessage?X.from(ze.hoverMessage):void 0,renderOptions:ze.renderOptions})):Oe.map(ze=>({range:S.from(ze)}))}function H(Oe){return typeof Oe>"u"?Oe:typeof Oe=="string"?h.URI.file(Oe):Oe}var K;(function(Oe){function ze(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?H(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Oe.from=ze})(K||(e.ThemableDecorationAttachmentRenderOptions=K={}));var x;(function(Oe){function ze(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?H(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?K.from(Ee.before):void 0,after:Ee.after?K.from(Ee.after):void 0}}Oe.from=ze})(x||(e.ThemableDecorationRenderOptions=x={}));var _;(function(Oe){function ze(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case g.DecorationRangeBehavior.OpenOpen:return 0;case g.DecorationRangeBehavior.ClosedClosed:return 1;case g.DecorationRangeBehavior.OpenClosed:return 2;case g.DecorationRangeBehavior.ClosedOpen:return 3}}Oe.from=ze})(_||(e.DecorationRangeBehavior=_={}));var ge;(function(Oe){function ze(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?_.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?x.from(Ee.light):void 0,dark:Ee.dark?x.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?H(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?K.from(Ee.before):void 0,after:Ee.after?K.from(Ee.after):void 0}}Oe.from=ze})(ge||(e.DecorationRenderOptions=ge={}));var oe;(function(Oe){function ze(ee){return{text:ee.newText,eol:ee.newEol&&Re.from(ee.newEol),range:S.from(ee.range)}}Oe.from=ze;function Ee(ee){const Te=new g.$wM(S.to(ee.range),ee.text);return Te.newEol=typeof ee.eol>"u"?void 0:Re.to(ee.eol),Te}Oe.to=Ee})(oe||(e.TextEdit=oe={}));var Pe;(function(Oe){function ze(ee,Te){const He={edits:[]};if(ee instanceof g.$zM){const Ye=new w.$Bc;for(const Ke of ee._allEntries())Ke._type===1&&h.URI.isUri(Ke.to)&&Ke.from===void 0&&Ye.add(Ke.to);for(const Ke of ee._allEntries())if(Ke._type===1){let ht;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?ht={type:"base64",value:(0,L.$4e)(L.$Je.wrap(Ke.options.contents))}:ht={type:"dataTransferItem",id:Ke.options.contents._itemId}),He.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:ht},metadata:Ke.metadata})}else Ke._type===2?He.edits.push({resource:Ke.uri,textEdit:oe.from(Ke.edit),versionId:Ye.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?He.edits.push({resource:Ke.uri,textEdit:{range:S.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ke.uri)?void 0:Te?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?He.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&He.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(Ut.from)}})}return He}Oe.from=ze;function Ee(ee){const Te=new g.$zM,He=new w.$Ac;for(const Ye of ee.edits)if(Ye.textEdit){const Ke=Ye,ht=h.URI.revive(Ke.resource),Et=S.to(Ke.textEdit.range),jt=Ke.textEdit.text,lt=Ke.textEdit.insertAsSnippet;let Tt;lt?Tt=g.$yM.replace(Et,new g.$AM(jt)):Tt=g.$wM.replace(Et,jt);const zt=He.get(ht);zt?zt.push(Tt):He.set(ht,[Tt])}else Te.renameFile(h.URI.revive(Ye.oldResource),h.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ke]of He)Te.set(Ye,Ke);return Te}Oe.to=Ee})(Pe||(e.WorkspaceEdit=Pe={}));var me;(function(Oe){const ze=Object.create(null);ze[g.SymbolKind.File]=0,ze[g.SymbolKind.Module]=1,ze[g.SymbolKind.Namespace]=2,ze[g.SymbolKind.Package]=3,ze[g.SymbolKind.Class]=4,ze[g.SymbolKind.Method]=5,ze[g.SymbolKind.Property]=6,ze[g.SymbolKind.Field]=7,ze[g.SymbolKind.Constructor]=8,ze[g.SymbolKind.Enum]=9,ze[g.SymbolKind.Interface]=10,ze[g.SymbolKind.Function]=11,ze[g.SymbolKind.Variable]=12,ze[g.SymbolKind.Constant]=13,ze[g.SymbolKind.String]=14,ze[g.SymbolKind.Number]=15,ze[g.SymbolKind.Boolean]=16,ze[g.SymbolKind.Array]=17,ze[g.SymbolKind.Object]=18,ze[g.SymbolKind.Key]=19,ze[g.SymbolKind.Null]=20,ze[g.SymbolKind.EnumMember]=21,ze[g.SymbolKind.Struct]=22,ze[g.SymbolKind.Event]=23,ze[g.SymbolKind.Operator]=24,ze[g.SymbolKind.TypeParameter]=25;function Ee(Te){return typeof ze[Te]=="number"?ze[Te]:6}Oe.from=Ee;function ee(Te){for(const He in ze)if(ze[He]===Te)return Number(He);return g.SymbolKind.Property}Oe.to=ee})(me||(e.SymbolKind=me={}));var U;(function(Oe){function ze(ee){switch(ee){case g.SymbolTag.Deprecated:return 1}}Oe.from=ze;function Ee(ee){switch(ee){case 1:return g.SymbolTag.Deprecated}}Oe.to=Ee})(U||(e.SymbolTag=U={}));var Y;(function(Oe){function ze(ee){return{name:ee.name,kind:me.from(ee.kind),tags:ee.tags&&ee.tags.map(U.from),containerName:ee.containerName,location:ue.from(ee.location)}}Oe.from=ze;function Ee(ee){const Te=new g.$IM(ee.name,me.to(ee.kind),ee.containerName,ue.to(ee.location));return Te.tags=ee.tags&&ee.tags.map(U.to),Te}Oe.to=Ee})(Y||(e.WorkspaceSymbol=Y={}));var pe;(function(Oe){function ze(ee){const Te={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:S.from(ee.range),selectionRange:S.from(ee.selectionRange),kind:me.from(ee.kind),tags:ee.tags?.map(U.from)??[]};return ee.children&&(Te.children=ee.children.map(ze)),Te}Oe.from=ze;function Ee(ee){const Te=new g.$JM(ee.name,ee.detail,me.to(ee.kind),S.to(ee.range),S.to(ee.selectionRange));return(0,l.$Lb)(ee.tags)&&(Te.tags=ee.tags.map(U.to)),ee.children&&(Te.children=ee.children.map(Ee)),Te}Oe.to=Ee})(pe||(e.DocumentSymbol=pe={}));var ce;(function(Oe){function ze(ee){const Te=new g.$NM(me.to(ee.kind),ee.name,ee.detail||"",h.URI.revive(ee.uri),S.to(ee.range),S.to(ee.selectionRange));return Te._sessionId=ee._sessionId,Te._itemId=ee._itemId,Te}Oe.to=ze;function Ee(ee,Te,He){if(Te=Te??ee._sessionId,He=He??ee._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,name:ee.name,detail:ee.detail,kind:me.from(ee.kind),uri:ee.uri,range:S.from(ee.range),selectionRange:S.from(ee.selectionRange),tags:ee.tags?.map(U.from)}}Oe.from=Ee})(ce||(e.CallHierarchyItem=ce={}));var ae;(function(Oe){function ze(Ee){return new g.$OM(ce.to(Ee.from),Ee.fromRanges.map(ee=>S.to(ee)))}Oe.to=ze})(ae||(e.CallHierarchyIncomingCall=ae={}));var se;(function(Oe){function ze(Ee){return new g.$PM(ce.to(Ee.to),Ee.fromRanges.map(ee=>S.to(ee)))}Oe.to=ze})(se||(e.CallHierarchyOutgoingCall=se={}));var ue;(function(Oe){function ze(ee){return{range:ee.range&&S.from(ee.range),uri:ee.uri}}Oe.from=ze;function Ee(ee){return new g.$BM(h.URI.revive(ee.uri),S.to(ee.range))}Oe.to=Ee})(ue||(e.location=ue={}));var Q;(function(Oe){function ze(ee){const Te=ee,He=ee;return{originSelectionRange:Te.originSelectionRange?S.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:He.uri,range:S.from(Te.targetRange?Te.targetRange:He.range),targetSelectionRange:Te.targetSelectionRange?S.from(Te.targetSelectionRange):void 0}}Oe.from=ze;function Ee(ee){return{targetUri:h.URI.revive(ee.uri),targetRange:S.to(ee.range),targetSelectionRange:ee.targetSelectionRange?S.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?S.to(ee.originSelectionRange):void 0}}Oe.to=Ee})(Q||(e.DefinitionLink=Q={}));var re;(function(Oe){function ze(ee){return{range:S.from(ee.range),contents:X.fromMany(ee.contents),canIncreaseVerbosity:ee.canIncreaseVerbosity,canDecreaseVerbosity:ee.canDecreaseVerbosity}}Oe.from=ze;function Ee(ee){const Te=ee.contents.map(X.to),He=S.to(ee.range),Ye=ee.canIncreaseVerbosity,Ke=ee.canDecreaseVerbosity;return new g.$FM(Te,He,Ye,Ke)}Oe.to=Ee})(re||(e.Hover=re={}));var $e;(function(Oe){function ze(ee){return{range:S.from(ee.range),expression:ee.expression}}Oe.from=ze;function Ee(ee){return new g.$AN(S.to(ee.range),ee.expression)}Oe.to=Ee})($e||(e.EvaluatableExpression=$e={}));var we;(function(Oe){function ze(ee){if(ee instanceof g.$BN)return{type:"text",range:S.from(ee.range),text:ee.text};if(ee instanceof g.$CN)return{type:"variable",range:S.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof g.$DN)return{type:"expression",range:S.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Oe.from=ze;function Ee(ee){switch(ee.type){case"text":return{range:S.to(ee.range),text:ee.text};case"variable":return{range:S.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:S.to(ee.range),expression:ee.expression}}}Oe.to=Ee})(we||(e.InlineValue=we={}));var Ne;(function(Oe){function ze(ee){return{frameId:ee.frameId,stoppedLocation:S.from(ee.stoppedLocation)}}Oe.from=ze;function Ee(ee){return new g.$EN(ee.frameId,S.to(ee.stoppedLocation))}Oe.to=Ee})(Ne||(e.InlineValueContext=Ne={}));var Se;(function(Oe){function ze(ee){return{range:S.from(ee.range),kind:ee.kind}}Oe.from=ze;function Ee(ee){return new g.$GM(S.to(ee.range),ee.kind)}Oe.to=Ee})(Se||(e.DocumentHighlight=Se={}));var Ie;(function(Oe){function ze(ee){return{uri:ee.uri,highlights:ee.highlights.map(Se.from)}}Oe.from=ze;function Ee(ee){return new g.$HM(h.URI.revive(ee.uri),ee.highlights.map(Se.to))}Oe.to=Ee})(Ie||(e.MultiDocumentHighlight=Ie={}));var Ae;(function(Oe){function ze(Ee){switch(Ee){case 1:return g.CompletionTriggerKind.TriggerCharacter;case 2:return g.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return g.CompletionTriggerKind.Invoke}}Oe.to=ze})(Ae||(e.CompletionTriggerKind=Ae={}));var je;(function(Oe){function ze(Ee){return{triggerKind:Ae.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Oe.to=ze})(je||(e.CompletionContext=je={}));var V;(function(Oe){function ze(ee){switch(ee){case g.CompletionItemTag.Deprecated:return 1}}Oe.from=ze;function Ee(ee){switch(ee){case 1:return g.CompletionItemTag.Deprecated}}Oe.to=Ee})(V||(e.CompletionItemTag=V={}));var W;(function(Oe){const ze=new Map([[g.CompletionItemKind.Method,0],[g.CompletionItemKind.Function,1],[g.CompletionItemKind.Constructor,2],[g.CompletionItemKind.Field,3],[g.CompletionItemKind.Variable,4],[g.CompletionItemKind.Class,5],[g.CompletionItemKind.Interface,7],[g.CompletionItemKind.Struct,6],[g.CompletionItemKind.Module,8],[g.CompletionItemKind.Property,9],[g.CompletionItemKind.Unit,12],[g.CompletionItemKind.Value,13],[g.CompletionItemKind.Constant,14],[g.CompletionItemKind.Enum,15],[g.CompletionItemKind.EnumMember,16],[g.CompletionItemKind.Keyword,17],[g.CompletionItemKind.Snippet,27],[g.CompletionItemKind.Text,18],[g.CompletionItemKind.Color,19],[g.CompletionItemKind.File,20],[g.CompletionItemKind.Reference,21],[g.CompletionItemKind.Folder,23],[g.CompletionItemKind.Event,10],[g.CompletionItemKind.Operator,11],[g.CompletionItemKind.TypeParameter,24],[g.CompletionItemKind.Issue,26],[g.CompletionItemKind.User,25]]);function Ee(He){return ze.get(He)??9}Oe.from=Ee;const ee=new Map([[0,g.CompletionItemKind.Method],[1,g.CompletionItemKind.Function],[2,g.CompletionItemKind.Constructor],[3,g.CompletionItemKind.Field],[4,g.CompletionItemKind.Variable],[5,g.CompletionItemKind.Class],[7,g.CompletionItemKind.Interface],[6,g.CompletionItemKind.Struct],[8,g.CompletionItemKind.Module],[9,g.CompletionItemKind.Property],[12,g.CompletionItemKind.Unit],[13,g.CompletionItemKind.Value],[14,g.CompletionItemKind.Constant],[15,g.CompletionItemKind.Enum],[16,g.CompletionItemKind.EnumMember],[17,g.CompletionItemKind.Keyword],[27,g.CompletionItemKind.Snippet],[18,g.CompletionItemKind.Text],[19,g.CompletionItemKind.Color],[20,g.CompletionItemKind.File],[21,g.CompletionItemKind.Reference],[23,g.CompletionItemKind.Folder],[10,g.CompletionItemKind.Event],[11,g.CompletionItemKind.Operator],[24,g.CompletionItemKind.TypeParameter],[25,g.CompletionItemKind.User],[26,g.CompletionItemKind.Issue]]);function Te(He){return ee.get(He)??g.CompletionItemKind.Property}Oe.to=Te})(W||(e.CompletionItemKind=W={}));var J;(function(Oe){function ze(Ee,ee){const Te=new g.$XM(Ee.label);return Te.insertText=Ee.insertText,Te.kind=W.to(Ee.kind),Te.tags=Ee.tags?.map(V.to),Te.detail=Ee.detail,Te.documentation=R.$Zk(Ee.documentation)?X.to(Ee.documentation):Ee.documentation,Te.sortText=Ee.sortText,Te.filterText=Ee.filterText,Te.preselect=Ee.preselect,Te.commitCharacters=Ee.commitCharacters,c.$At.isIRange(Ee.range)?Te.range=S.to(Ee.range):typeof Ee.range=="object"&&(Te.range={inserting:S.to(Ee.range.insert),replacing:S.to(Ee.range.replace)}),Te.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Te.insertText=new g.$AM(Ee.insertText):(Te.insertText=Ee.insertText,Te.textEdit=Te.range instanceof g.$rM?new g.$wM(Te.range,Te.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ee.additionalTextEdits.map(He=>oe.to(He))),Te.command=ee&&Ee.command?ee.fromInternal(Ee.command):void 0,Te}Oe.to=ze})(J||(e.CompletionItem=J={}));var Z;(function(Oe){function ze(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:X.fromStrict(ee.documentation)}}Oe.from=ze;function Ee(ee){return{label:ee.label,documentation:R.$Zk(ee.documentation)?X.to(ee.documentation):ee.documentation}}Oe.to=Ee})(Z||(e.ParameterInformation=Z={}));var he;(function(Oe){function ze(ee){return{label:ee.label,documentation:X.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(Z.from):[],activeParameter:ee.activeParameter}}Oe.from=ze;function Ee(ee){return{label:ee.label,documentation:R.$Zk(ee.documentation)?X.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(Z.to):[],activeParameter:ee.activeParameter}}Oe.to=Ee})(he||(e.SignatureInformation=he={}));var be;(function(Oe){function ze(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(he.from):[]}}Oe.from=ze;function Ee(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(he.to):[]}}Oe.to=Ee})(be||(e.SignatureHelp=be={}));var Fe;(function(Oe){function ze(Ee,ee){const Te=new g.$WM(D.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(Ve.to.bind(void 0,Ee)),ee.kind&&Qe.to(ee.kind));return Te.textEdits=ee.textEdits&&ee.textEdits.map(oe.to),Te.tooltip=R.$Zk(ee.tooltip)?X.to(ee.tooltip):ee.tooltip,Te.paddingLeft=ee.paddingLeft,Te.paddingRight=ee.paddingRight,Te}Oe.to=ze})(Fe||(e.InlayHint=Fe={}));var Ve;(function(Oe){function ze(Ee,ee){const Te=new g.$VM(ee.label);return Te.tooltip=R.$Zk(ee.tooltip)?X.to(ee.tooltip):ee.tooltip,i.Command.is(ee.command)&&(Te.command=Ee.fromInternal(ee.command)),ee.location&&(Te.location=ue.to(ee.location)),Te}Oe.to=ze})(Ve||(e.InlayHintLabelPart=Ve={}));var Qe;(function(Oe){function ze(ee){return ee}Oe.from=ze;function Ee(ee){return ee}Oe.to=Ee})(Qe||(e.InlayHintKind=Qe={}));var tt;(function(Oe){function ze(ee){return{range:S.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Oe.from=ze;function Ee(ee){let Te;if(ee.url)try{Te=typeof ee.url=="string"?h.URI.parse(ee.url,!0):h.URI.revive(ee.url)}catch{}return new g.$3M(S.to(ee.range),Te)}Oe.to=Ee})(tt||(e.DocumentLink=tt={}));var _e;(function(Oe){function ze(ee){const Te=new g.$6M(ee.label);return ee.textEdit&&(Te.textEdit=oe.to(ee.textEdit)),ee.additionalTextEdits&&(Te.additionalTextEdits=ee.additionalTextEdits.map(He=>oe.to(He))),Te}Oe.to=ze;function Ee(ee){return{label:ee.label,textEdit:ee.textEdit?oe.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Te=>oe.from(Te)):void 0}}Oe.from=Ee})(_e||(e.ColorPresentation=_e={}));var nt;(function(Oe){function ze(ee){return new g.$4M(ee[0],ee[1],ee[2],ee[3])}Oe.to=ze;function Ee(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Oe.from=Ee})(nt||(e.Color=nt={}));var it;(function(Oe){function ze(ee){return{range:S.from(ee.range)}}Oe.from=ze;function Ee(ee){return new g.$MM(S.to(ee.range))}Oe.to=Ee})(it||(e.SelectionRange=it={}));var rt;(function(Oe){function ze(Ee){switch(Ee){case 2:return g.TextDocumentSaveReason.AfterDelay;case 1:return g.TextDocumentSaveReason.Manual;case 3:case 4:return g.TextDocumentSaveReason.FocusOut}}Oe.to=ze})(rt||(e.TextDocumentSaveReason=rt={}));var at;(function(Oe){function ze(ee){switch(ee){case g.TextEditorLineNumbersStyle.Off:return 0;case g.TextEditorLineNumbersStyle.Relative:return 2;case g.TextEditorLineNumbersStyle.Interval:return 3;case g.TextEditorLineNumbersStyle.On:default:return 1}}Oe.from=ze;function Ee(ee){switch(ee){case 0:return g.TextEditorLineNumbersStyle.Off;case 2:return g.TextEditorLineNumbersStyle.Relative;case 3:return g.TextEditorLineNumbersStyle.Interval;case 1:default:return g.TextEditorLineNumbersStyle.On}}Oe.to=Ee})(at||(e.TextEditorLineNumbersStyle=at={}));var Re;(function(Oe){function ze(ee){if(ee===g.EndOfLine.CRLF)return 1;if(ee===g.EndOfLine.LF)return 0}Oe.from=ze;function Ee(ee){if(ee===1)return g.EndOfLine.CRLF;if(ee===0)return g.EndOfLine.LF}Oe.to=Ee})(Re||(e.EndOfLine=Re={}));var ve;(function(Oe){function ze(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case g.ProgressLocation.SourceControl:return 3;case g.ProgressLocation.Window:return 10;case g.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Oe.from=ze})(ve||(e.ProgressLocation=ve={}));var qe;(function(Oe){function ze(ee){const Te={start:ee.start+1,end:ee.end+1};return ee.kind&&(Te.kind=te.from(ee.kind)),Te}Oe.from=ze;function Ee(ee){const Te={start:ee.start-1,end:ee.end-1};return ee.kind&&(Te.kind=te.to(ee.kind)),Te}Oe.to=Ee})(qe||(e.FoldingRange=qe={}));var te;(function(Oe){function ze(ee){if(ee)switch(ee){case g.FoldingRangeKind.Comment:return i.$zu.Comment;case g.FoldingRangeKind.Imports:return i.$zu.Imports;case g.FoldingRangeKind.Region:return i.$zu.Region}}Oe.from=ze;function Ee(ee){if(ee)switch(ee.value){case i.$zu.Comment.value:return g.FoldingRangeKind.Comment;case i.$zu.Imports.value:return g.FoldingRangeKind.Imports;case i.$zu.Region.value:return g.FoldingRangeKind.Region}}Oe.to=Ee})(te||(e.FoldingRangeKind=te={}));var ne;(function(Oe){function ze(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?S.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?r.$AF.id:void 0}}Oe.from=ze})(ne||(e.TextEditorOpenOptions=ne={}));var Ce;(function(Oe){function ze(He){return He instanceof g.$oN?He.toJSON():typeof He=="string"?He:Ee(He)||ee(He)?new g.$oN(He.baseUri??He.base,He.pattern).toJSON():He}Oe.from=ze;function Ee(He){const Ye=He;return Ye?h.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function ee(He){const Ye=He;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Te(He){return typeof He=="string"?He:new g.$oN(h.URI.revive(He.baseUri),He.pattern)}Oe.to=Te})(Ce||(e.GlobPattern=Ce={}));var Ge;(function(Oe){function ze(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(ze);if(typeof Ee=="string")return Ee;{const ee=Ee;return{language:ee.language,scheme:ee.scheme,pattern:Ce.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Oe.from=ze})(Ge||(e.LanguageSelector=Ge={}));var Me;(function(Oe){function ze(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Te=>Array.isArray(Te)&&Te.every(He=>He&&typeof He=="object"&&"uri"in He&&h.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(Ye=>Ye instanceof g.$rM)))}Oe.is=ze;function Ee(ee){return{documents:ee.documents.map(Te=>Te.map(He=>({uri:h.URI.from(He.uri),version:He.version,ranges:He.ranges.map(Ye=>S.from(Ye))})))}}Oe.from=Ee})(Me||(e.MappedEditsContext=Me={}));var st;(function(Oe){function ze(ee){return{start:ee.start,end:ee.end}}Oe.from=ze;function Ee(ee){return new g.$RN(ee.start,ee.end)}Oe.to=Ee})(st||(e.NotebookRange=st={}));var ut;(function(Oe){function ze(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Oe.to=ze;function Ee(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Oe.from=Ee})(ut||(e.NotebookCellExecutionSummary=ut={}));var $t;(function(Oe){function ze(Ee){if(Ee===f.NotebookCellExecutionState.Unconfirmed)return g.NotebookCellExecutionState.Pending;if(Ee===f.NotebookCellExecutionState.Pending)return;if(Ee===f.NotebookCellExecutionState.Executing)return g.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Oe.to=ze})($t||(e.NotebookCellExecutionState=$t={}));var Ct;(function(Oe){function ze(ee){switch(ee){case g.NotebookCellKind.Markup:return f.CellKind.Markup;case g.NotebookCellKind.Code:default:return f.CellKind.Code}}Oe.from=ze;function Ee(ee){switch(ee){case f.CellKind.Markup:return g.NotebookCellKind.Markup;case f.CellKind.Code:default:return g.NotebookCellKind.Code}}Oe.to=Ee})(Ct||(e.NotebookCellKind=Ct={}));var Pt;(function(Oe){function ze(ee){const Te={metadata:ee.metadata??Object.create(null),cells:[]};for(const He of ee.cells)g.$SN.validate(He),Te.cells.push(Ut.from(He));return Te}Oe.from=ze;function Ee(ee){const Te=new g.$TN(ee.cells.map(Ut.to));return(0,d.$ng)(ee.metadata)||(Te.metadata=ee.metadata),Te}Oe.to=Ee})(Pt||(e.NotebookData=Pt={}));var Ut;(function(Oe){function ze(ee){return{cellKind:Ct.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:ut.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(kt.from):[]}}Oe.from=ze;function Ee(ee){return new g.$SN(Ct.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(kt.to):void 0,ee.metadata,ee.internalMetadata?ut.to(ee.internalMetadata):void 0)}Oe.to=Ee})(Ut||(e.NotebookCellData=Ut={}));var Bt;(function(Oe){function ze(ee){return{mime:ee.mime,valueBytes:L.$Je.wrap(ee.data)}}Oe.from=ze;function Ee(ee){return new g.$UN(ee.valueBytes.buffer,ee.mime)}Oe.to=Ee})(Bt||(e.NotebookCellOutputItem=Bt={}));var kt;(function(Oe){function ze(ee){return{outputId:ee.id,items:ee.items.map(Bt.from),metadata:ee.metadata}}Oe.from=ze;function Ee(ee){const Te=ee.items.map(Bt.to);return new g.$VN(Te,ee.outputId,ee.metadata)}Oe.to=Ee})(kt||(e.NotebookCellOutput=kt={}));var Yt;(function(Oe){function ze(Te){return ee(Te)?{include:Ce.from(Te.include)??void 0,exclude:Ce.from(Te.exclude)??void 0}:Ce.from(Te)??void 0}Oe.from=ze;function Ee(Te){return ee(Te)?{include:Ce.to(Te.include),exclude:Ce.to(Te.exclude)}:Ce.to(Te)}Oe.to=Ee;function ee(Te){const He=Te;return He?!(0,d.$jg)(He.include)&&!(0,d.$jg)(He.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var xt;(function(Oe){function ze(Ee,ee,Te){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===g.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(He,Te),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Oe.from=ze})(xt||(e.NotebookStatusBarItem=xt={}));var xe;(function(Oe){function ze(Ee,ee,Te){const He=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:ee.toInternal(He,Te),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Oe.from=ze})(xe||(e.NotebookKernelSourceAction=xe={}));var on;(function(Oe){function ze(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Oe.from=ze})(on||(e.NotebookDocumentContentOptions=on={}));var Qt;(function(Oe){function ze(ee){return{uri:ee.uri,provides:ee.provides}}Oe.from=ze;function Ee(ee){return new g.$XN(h.URI.revive(ee.uri),ee.provides)}Oe.to=Ee})(Qt||(e.NotebookRendererScript=Qt={}));var ft;(function(Oe){function ze(ee){return{message:X.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:S.from(ee.location.range),uri:ee.location.uri}}}Oe.from=ze;function Ee(ee){const Te=new g.$4N(typeof ee.message=="string"?ee.message:X.to(ee.message));return Te.actualOutput=ee.actual,Te.expectedOutput=ee.expected,Te.contextValue=ee.contextValue,Te.location=ee.location?ue.to(ee.location):void 0,Te}Oe.to=Ee})(ft||(e.TestMessage=ft={}));var gt;(function(Oe){Oe.namespace=s.$eL,Oe.denamespace=s.$fL})(gt||(e.TestTag=gt={}));var _t;(function(Oe){function ze(ee){const Te=(0,a.$NO)(ee).controllerId;return{extId:o.$_K.fromExtHostTestItem(ee,Te).toString(),label:ee.label,uri:h.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(He=>gt.namespace(Te,He.id)),range:c.$At.lift(S.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&X.fromStrict(ee.error)||null}}Oe.from=ze;function Ee(ee){return{parent:void 0,error:void 0,id:o.$_K.fromString(ee.extId).localId,label:ee.label,uri:h.URI.revive(ee.uri),tags:(ee.tags||[]).map(Te=>{const{tagId:He}=gt.denamespace(Te);return new g.$5N(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:S.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Oe.toPlain=Ee})(_t||(e.TestItem=_t={})),function(Oe){function ze(ee){return{id:ee.id}}Oe.from=ze;function Ee(ee){return new g.$5N(ee.id)}Oe.to=Ee}(gt||(e.TestTag=gt={}));var Zt;(function(Oe){const ze=(ee,Te)=>{const He=ee.value;if(!He)return;const Ye={..._t.toPlain(He.item),parent:Te,taskStates:He.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(ht=>ht.type===0).map(ft.to)})),children:[]};if(ee.children)for(const Ke of ee.children.values()){const ht=ze(Ke,Ye);ht&&Ye.children.push(ht)}return Ye};function Ee(ee){const Te=new p.$GO;for(const Ke of ee.items)Te.insert(o.$_K.fromString(Ke.item.extId).path,Ke);const He=[Te.nodes],Ye=[];for(;He.length;)for(const Ke of He.pop())Ke.value?Ye.push(Ke):Ke.children&&He.push(Ke.children.values());return{completedAt:ee.completedAt,results:Ye.map(Ke=>ze(Ke)).filter(d.$ig)}}Oe.to=Ee})(Zt||(e.TestResults=Zt={}));var Ft;(function(Oe){function ze(He){return{covered:He.covered,total:He.total}}function Ee(He){return"line"in He?D.from(He):S.from(He)}function ee(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:Ee(He.location),type:1,branches:He.branches.length?He.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&Ee(Ye.location),label:Ye.label})):void 0}:{type:0,name:He.name,count:He.executed,location:Ee(He.location)}}Oe.fromDetails=ee;function Te(He,Ye,Ke){return g.$7N(Ke.statementCoverage),g.$7N(Ke.branchCoverage),g.$7N(Ke.declarationCoverage),{id:Ye,uri:Ke.uri,statement:ze(Ke.statementCoverage),branch:Ke.branchCoverage&&ze(Ke.branchCoverage),declaration:Ke.declarationCoverage&&ze(Ke.declarationCoverage),testId:Ke instanceof g.$8N&&Ke.testItem?o.$_K.fromExtHostTestItem(Ke.testItem,He).toString():void 0}}Oe.fromFile=Te})(Ft||(e.TestCoverage=Ft={}));var mt;(function(Oe){function ze(Ee){switch(Ee){case 1:return g.CodeActionTriggerKind.Invoke;case 2:return g.CodeActionTriggerKind.Automatic}}Oe.to=ze})(mt||(e.CodeActionTriggerKind=mt={}));var Ht;(function(Oe){function ze(ee){const Te=new g.$_N(me.to(ee.kind),ee.name,ee.detail||"",h.URI.revive(ee.uri),S.to(ee.range),S.to(ee.selectionRange));return Te._sessionId=ee._sessionId,Te._itemId=ee._itemId,Te}Oe.to=ze;function Ee(ee,Te,He){if(Te=Te??ee._sessionId,He=He??ee._itemId,Te===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:He,kind:me.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:S.from(ee.range),selectionRange:S.from(ee.selectionRange),tags:ee.tags?.map(U.from)}}Oe.from=Ee})(Ht||(e.TypeHierarchyItem=Ht={}));var en;(function(Oe){function ze(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Oe.from=ze})(en||(e.ViewBadge=en={}));var Wt;(function(Oe){function ze(He,Ye,Ke){const ht=Ye.fileData;return ht?new g.$gN(new g.$hN(ht.name,h.URI.revive(ht.uri),ht.id,(0,A.$db)(()=>Ke(ht.id)))):He===I.$Ws.uriList&&Ye.uriListData?new g.$fN(Te(Ye.uriListData)):new g.$fN(Ye.asString)}Oe.to=ze;async function Ee(He,Ye){const Ke=await Ye.asString();if(He===I.$Ws.uriList)return{asString:Ke,fileData:void 0,uriListData:ee(Ke)};const ht=Ye.asFile();return{asString:Ke,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}Oe.from=Ee;function ee(He){return M.$eu.split(He).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return h.URI.parse(Ye)}catch{}return Ye})}function Te(He){return M.$eu.create(He.map(Ye=>typeof Ye=="string"?Ye:h.URI.revive(Ye)))}})(Wt||(e.DataTransferItem=Wt={}));var Xe;(function(Oe){function ze(ee,Te){const He=ee.items.map(([Ye,Ke])=>[Ye,Wt.to(Ye,Ke,Te)]);return new g.$iN(He)}Oe.toDataTransfer=ze;async function Ee(ee){const Te={items:[]},He=[];for(const[Ye,Ke]of ee)He.push((async()=>{Te.items.push([Ye,await Wt.from(Ye,Ke)])})());return await Promise.all(He),Te}Oe.from=Ee})(Xe||(e.DataTransfer=Xe={}));var ln;(function(Oe){function ze(ee,Te){return{kind:"reply",agentId:ee.participant??Te?.agentId??"",subCommand:ee.command??Te?.command,message:ee.prompt,title:ee.label}}Oe.from=ze;function Ee(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Oe.to=Ee})(ln||(e.ChatFollowup=ln={}));var Xt;(function(Oe){function ze(ee){switch(ee.role){case 0:return new g.$AO(g.LanguageModelChatMessageRole.System,ee.content);case 1:return new g.$AO(g.LanguageModelChatMessageRole.User,ee.content);case 2:return new g.$AO(g.LanguageModelChatMessageRole.Assistant,ee.content)}}Oe.to=ze;function Ee(ee){switch(ee.role){case g.LanguageModelChatMessageRole.System:return{role:0,content:ee.content};case g.LanguageModelChatMessageRole.User:return{role:1,content:ee.content};case g.LanguageModelChatMessageRole.Assistant:return{role:2,content:ee.content}}}Oe.from=Ee})(Xt||(e.LanguageModelChatMessage=Xt={}));var Vt;(function(Oe){function ze(ee){return{kind:"markdownContent",content:X.from(ee.value)}}Oe.from=ze;function Ee(ee){return new g.$mO(X.to(ee.content))}Oe.to=Ee})(Vt||(e.ChatResponseMarkdownPart=Vt={}));var wt;(function(Oe){function ze(ee){return{kind:"markdownVuln",content:X.from(ee.value),vulnerabilities:ee.vulnerabilities}}Oe.from=ze;function Ee(ee){return new g.$nO(X.to(ee.content),ee.vulnerabilities)}Oe.to=Ee})(wt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=wt={}));var qt;(function(Oe){function ze(ee){return{kind:"agentDetection",agentId:ee.participant,command:ee.command}}Oe.from=ze;function Ee(ee){return new g.$oO(ee.agentId,ee.command)}Oe.to=Ee})(qt||(e.ChatResponseDetectedParticipantPart=qt={}));var Mt;(function(Oe){function ze(Ee){return{kind:"confirmation",title:Ee.title,message:Ee.message,data:Ee.data}}Oe.from=ze})(Mt||(e.ChatResponseConfirmationPart=Mt={}));var Lt;(function(Oe){function ze(ee){const{value:Te,baseUri:He}=ee;function Ye(Ke,ht){return Ke.map(Et=>{const jt=h.URI.joinPath(ht,Et.name);return{label:Et.name,uri:jt,children:Et.children&&Ye(Et.children,jt)}})}return{kind:"treeData",treeData:{label:(0,E.$$g)(He),uri:He,children:Ye(Te,He)}}}Oe.from=ze;function Ee(ee){const Te=(0,k.$0h)(ee.treeData);function He(ht){return ht.map(Et=>({name:Et.label,children:Et.children&&He(Et.children)}))}const Ye=Te.uri,Ke=Te.children?He(Te.children):[];return new g.$qO(Ke,Ye)}Oe.to=Ee})(Lt||(e.ChatResponseFilesPart=Lt={}));var tn;(function(Oe){function ze(ee){const Te=He=>h.URI.isUri(He);return{kind:"inlineReference",name:ee.title,inlineReference:Te(ee.value)?ee.value:m.from(ee.value)}}Oe.from=ze;function Ee(ee){const Te=(0,k.$0h)(ee);return new g.$rO(h.URI.isUri(Te.inlineReference)?Te.inlineReference:m.to(Te.inlineReference),ee.name)}Oe.to=Ee})(tn||(e.ChatResponseAnchorPart=tn={}));var Gt;(function(Oe){function ze(ee){return{kind:"progressMessage",content:X.from(ee.value)}}Oe.from=ze;function Ee(ee){return new g.$sO(ee.content.value)}Oe.to=Ee})(Gt||(e.ChatResponseProgressPart=Gt={}));var an;(function(Oe){function ze(ee){return{kind:"warning",content:X.from(ee.value)}}Oe.from=ze;function Ee(ee){return new g.$uO(ee.content.value)}Oe.to=Ee})(an||(e.ChatResponseWarningPart=an={}));var Nt;(function(Oe){function ze(Ee){return{kind:"progressTask",content:X.from(Ee.value)}}Oe.from=ze})(Nt||(e.ChatTask=Nt={}));var Kt;(function(Oe){function ze(Ee){return{kind:"progressTaskResult",content:typeof Ee=="string"?X.from(Ee):void 0}}Oe.from=ze})(Kt||(e.ChatTaskResult=Kt={}));var Ot;(function(Oe){function ze(ee,Te,He){return{kind:"command",command:Te.toInternal(ee.value,He)??{command:ee.value.command,title:ee.value.title}}}Oe.from=ze;function Ee(ee,Te){return new g.$vO(Te.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Oe.to=Ee})(Ot||(e.ChatResponseCommandButtonPart=Ot={}));var It;(function(Oe){function ze(ee){return{kind:"textEdit",uri:ee.uri,edits:ee.edits.map(Te=>oe.from(Te))}}Oe.from=ze;function Ee(ee){return new g.$xO(h.URI.revive(ee.uri),ee.edits.map(Te=>oe.to(Te)))}Oe.to=Ee})(It||(e.ChatResponseTextEditPart=It={}));var pt;(function(Oe){function ze(ee){const Te=v.ThemeIcon.isThemeIcon(ee.iconPath)?ee.iconPath:h.URI.isUri(ee.iconPath)?{light:h.URI.revive(ee.iconPath)}:ee.iconPath&&"light"in ee.iconPath&&"dark"in ee.iconPath&&h.URI.isUri(ee.iconPath.light)&&h.URI.isUri(ee.iconPath.dark)?{light:h.URI.revive(ee.iconPath.light),dark:h.URI.revive(ee.iconPath.dark)}:void 0;return"variableName"in ee.value?{kind:"reference",reference:{variableName:ee.value.variableName,value:h.URI.isUri(ee.value.value)||!ee.value.value?ee.value.value:m.from(ee.value.value)},iconPath:Te}:{kind:"reference",reference:h.URI.isUri(ee.value)?ee.value:m.from(ee.value),iconPath:Te}}Oe.from=ze;function Ee(ee){const Te=(0,k.$0h)(ee),He=Ye=>h.URI.isUri(Ye)?Ye:m.to(Ye);return new g.$wO("variableName"in Te.reference?{variableName:Te.reference.variableName,value:Te.reference.value&&He(Te.reference.value)}:He(Te.reference))}Oe.to=Ee})(pt||(e.ChatResponseReferencePart=pt={}));var St;(function(Oe){function ze(Te,He,Ye){return Te instanceof g.$mO?Vt.from(Te):Te instanceof g.$rO?tn.from(Te):Te instanceof g.$wO?pt.from(Te):Te instanceof g.$sO?Gt.from(Te):Te instanceof g.$qO?Lt.from(Te):Te instanceof g.$vO?Ot.from(Te,He,Ye):Te instanceof g.$xO?It.from(Te):Te instanceof g.$nO?wt.from(Te):Te instanceof g.$oO?qt.from(Te):Te instanceof g.$uO?an.from(Te):{kind:"markdownContent",content:X.from("")}}Oe.from=ze;function Ee(Te,He){switch(Te.kind){case"reference":return pt.to(Te);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Te,He)}}Oe.to=Ee;function ee(Te,He){switch(Te.kind){case"markdownContent":return Vt.to(Te);case"inlineReference":return tn.to(Te);case"progressMessage":return;case"treeData":return Lt.to(Te);case"command":return Ot.to(Te,He)}}Oe.toContent=ee})(St||(e.ChatResponsePart=St={}));var cn;(function(Oe){function ze(Ee){return{prompt:Ee.message,command:Ee.command,attempt:Ee.attempt??0,enableCommandDetection:Ee.enableCommandDetection??!0,references:Ee.variables.variables.map(gn.to),location:Dt.to(Ee.location),acceptedConfirmationData:Ee.acceptedConfirmationData,rejectedConfirmationData:Ee.rejectedConfirmationData}}Oe.to=ze})(cn||(e.ChatAgentRequest=cn={}));var Dt;(function(Oe){function ze(Ee){switch(Ee){case t.ChatAgentLocation.Notebook:return g.ChatLocation.Notebook;case t.ChatAgentLocation.Terminal:return g.ChatLocation.Terminal;case t.ChatAgentLocation.Panel:return g.ChatLocation.Panel;case t.ChatAgentLocation.Editor:return g.ChatLocation.Editor}}Oe.to=ze})(Dt||(e.ChatLocation=Dt={}));var gn;(function(Oe){function ze(Ee){const ee=Ee.value;if(!ee)throw new Error("Invalid value reference");return{id:Ee.id,name:Ee.name,range:Ee.range&&[Ee.range.start,Ee.range.endExclusive],value:(0,h.$vc)(ee)?h.URI.revive(ee):ee,modelDescription:Ee.modelDescription}}Oe.to=ze})(gn||(e.ChatAgentValueReference=gn={}));var rn;(function(Oe){function ze(Ee,ee,Te){return{id:Ee.id,label:Ee.label,value:Ee.values[0].value,insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation,command:ee.toInternal(Ee.command,Te)}}Oe.from=ze})(rn||(e.ChatAgentCompletionItem=rn={}));var pn;(function(Oe){function ze(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Oe.to=ze})(pn||(e.ChatAgentResult=pn={}));var hn;(function(Oe){function ze(Ee,ee,Te){if(ee.action.kind==="vote")return;const He=pn.to(Ee);if(ee.action.kind==="command"){const Ye=ee.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Te.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:He}}else return ee.action.kind==="followUp"?{action:{kind:"followUp",followup:ln.to(ee.action.followup)},result:He}:ee.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ee.action.action==="accepted"},result:He}:{action:ee.action,result:He}}Oe.to=ze})(hn||(e.ChatAgentUserActionEvent=hn={}));var vn;(function(Oe){function ze(Ee,ee,Te){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:ee.toInternal(Ee,Te)}Oe.from=ze})(vn||(e.TerminalQuickFix=vn={}));var At;(function(Oe){function ze(Ee){return{kind:kn.to(Ee.kind)}}Oe.to=ze})(At||(e.PartialAcceptInfo=At={}));var kn;(function(Oe){function ze(Ee){switch(Ee){case 0:return g.PartialAcceptTriggerKind.Word;case 1:return g.PartialAcceptTriggerKind.Line;case 2:return g.PartialAcceptTriggerKind.Suggest;default:return g.PartialAcceptTriggerKind.Unknown}}Oe.to=ze})(kn||(e.PartialAcceptTriggerKind=kn={}));var sn;(function(Oe){function ze(Ee,ee){return{id:ee,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||0,contextValue:Ee.contextValue}}Oe.from=ze})(sn||(e.DebugTreeItem=sn={}))}),define(ke[334],De([1,0,6,20,17,48]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=void 0;let R=class{constructor($,k){this.a=$.getProxy(l.$nM.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>k.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,k,I){const P=new A.$Hw(M.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(P,void 0,I?.isRefactoring??!1)}};e.$rmc=R,e.$rmc=R=Je([We(0,L.$RO)],R)}),define(ke[335],De([1,0,19,7,47,4,39,3,40,18,2,25,6,17,8,297,26]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=void 0;class c{constructor(r,t,f,o,s){this.j=r,this.k=t,this.l=f,this.m=o,this.n=s,this.b=$.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(o){if(r.c){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,o),s}};const r=this;this.b.reset();const f=(o,s)=>{if(typeof this.d>"u"&&"content"in o&&(this.d=this.b.elapsed()),s){const u=this.l.$handleProgressChunk(this.k.requestId,o),g={report:b=>{u?.then(S=>{S&&(v.$RM.isMarkdownString(b.value)?this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseWarningPart.from(b),S):this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseReferencePart.from(b),S))})}};Promise.all([u,s?.(g)]).then(([b,S])=>{b!==void 0&&S!==void 0&&this.l.$handleProgressChunk(this.k.requestId,E.ChatTaskResult.from(S),b)})}else this.l.$handleProgressChunk(this.k.requestId,o)};this.g={markdown(o){t(this.markdown);const s=new v.$mO(o),u=E.ChatResponseMarkdownPart.from(s);return f(u),this},markdownWithVulnerabilities(o,s){t(this.markdown),s&&(0,h.$OG)(r.j,"chatParticipantAdditions");const u=new v.$nO(o,s),g=E.ChatResponseMarkdownWithVulnerabilitiesPart.from(u);return f(g),this},filetree(o,s){t(this.filetree);const u=new v.$qO(o,s),g=E.ChatResponseFilesPart.from(u);return f(g),this},anchor(o,s){t(this.anchor);const u=new v.$rO(o,s),g=E.ChatResponseAnchorPart.from(u);return f(g),this},button(o){t(this.anchor);const s=new v.$vO(o),u=E.ChatResponseCommandButtonPart.from(s,r.m,r.n);return f(u),this},progress(o,s){t(this.progress);const u=new v.$tO(o,s),g=s?E.ChatTask.from(u):E.ChatResponseProgressPart.from(u);return f(g,s),this},warning(o){t(this.progress),(0,h.$OG)(r.j,"chatParticipantAdditions");const s=new v.$uO(o),u=E.ChatResponseWarningPart.from(s);return f(u),this},reference(o,s){if(t(this.reference),"variableName"in o&&(0,h.$OG)(r.j,"chatParticipantAdditions"),"variableName"in o&&!o.value){const u=r.k.variables.variables.find(g=>g.name===o.variableName);if(u){let g;if(u.references?.length)g=u.references.map(b=>({kind:"reference",reference:{variableName:o.variableName,value:b.reference}}));else{const b=new v.$wO(o,s);g=[E.ChatResponseReferencePart.from(b)]}return g.forEach(b=>f(b)),this}}else{const u=new v.$wO(o,s),g=E.ChatResponseReferencePart.from(u);f(g)}return this},textEdit(o,s){t(this.textEdit),(0,h.$OG)(r.j,"chatParticipantAdditions");const u=new v.$xO(o,s),g=E.ChatResponseTextEditPart.from(u);return f(g),this},detectedParticipant(o,s){t(this.detectedParticipant),(0,h.$OG)(r.j,"chatParticipantAdditions");const u=new v.$oO(o,s),g=E.ChatResponseDetectedParticipantPart.from(u);return f(g),this},confirmation(o,s,u){t(this.confirmation),(0,h.$OG)(r.j,"chatParticipantAdditions");const g=new v.$pO(o,s,u),b=E.ChatResponseConfirmationPart.from(g);return f(b),this},push(o){if(t(this.push),(o instanceof v.$xO||o instanceof v.$nO||o instanceof v.$oO||o instanceof v.$uO||o instanceof v.$pO)&&(0,h.$OG)(r.j,"chatParticipantAdditions"),o instanceof v.$wO)this.reference(o.value,o.iconPath);else{const s=E.ChatResponsePart.from(o,r.m,r.n);f(s)}return this}}}return this.g}}class i extends w.$Uc{static{this.b=0}constructor(r,t,f){super(),this.n=t,this.s=f,this.c=new Map,this.j=this.B(new w.$4c),this.m=this.B(new w.$4c),this.g=r.getProxy(p.$nM.MainThreadChatAgents2)}transferActiveChat(r){this.g.$transferActiveChatSession(r)}createChatAgent(r,t,f){const o=i.b++,s=new n(r,t,this.g,o,f);return this.c.set(o,s),this.g.$registerAgent(o,r.identifier,t,{},void 0),s.apiAgent}createDynamicChatAgent(r,t,f,o){const s=i.b++,u=new n(r,t,this.g,s,o);return this.c.set(s,u),this.g.$registerAgent(s,r.identifier,t,{isSticky:!0},f),u.apiAgent}async $invokeAgent(r,t,f,o){const s=this.c.get(r);if(!s)throw new Error(`[CHAT](${r}) CANNOT invoke agent because the agent is not registered`);let u=this.j.get(t.sessionId);u||(u=new w.$Tc,this.j.set(t.sessionId,u));const g=new c(s.extension,t,this.g,this.s.converter,u);try{const b=await this.t(t.agentId,f),S=s.invoke(E.ChatAgentRequest.to(t),{history:b},g.apiObject,o);return await(0,L.$oh)(Promise.resolve(S).then(m=>{if(m?.metadata)try{JSON.stringify(m.metadata)}catch(D){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${D.message}`;return this.n.error(`[${s.extension.identifier.value}] [@${s.id}] ${C}`,s.extension),{errorDetails:{message:C},timings:g.timings}}let y;return m?.errorDetails&&(y={...m.errorDetails,responseIsIncomplete:!0}),{errorDetails:y,timings:g.timings,metadata:m?.metadata}}),o)}catch(b){return this.n.error(b,s.extension),{errorDetails:{message:(0,M.$lj)(b),responseIsIncomplete:!0}}}finally{g.close()}}async t(r,t){const f=[];for(const o of t.history){const s=E.ChatAgentResult.to(o.result),u=r===o.request.agentId?s:{...s,metadata:void 0};f.push(new v.$yO(o.request.message,o.request.command,o.request.variables.variables.map(E.ChatAgentValueReference.to),o.request.agentId));const g=(0,l.$Hb)(o.response.map(b=>E.ChatResponsePart.toContent(b,this.s.converter)));f.push(new v.$zO(g,u,o.request.agentId,o.request.command))}return f}$releaseSession(r){this.j.deleteAndDispose(r)}async $provideFollowups(r,t,f,o,s){const u=this.c.get(t);if(!u)return Promise.resolve([]);const g=await this.t(u.id,o),b=E.ChatAgentResult.to(f);return(await u.provideFollowups(b,{history:g},s)).filter(S=>{const m=!S.participant||R.Iterable.some(this.c.values(),y=>y.id===S.participant&&P.$Vm.equals(y.extension.identifier,u.extension.identifier));return m||this.n.warn(`[@${u.id}] ChatFollowup refers to an unknown participant: ${S.participant}`),m}).map(S=>E.ChatFollowup.from(S,r))}$acceptFeedback(r,t,f,o){const s=this.c.get(r);if(!s)return;const u=E.ChatAgentResult.to(t);let g;switch(f){case d.ChatAgentVoteDirection.Down:g=v.ChatResultFeedbackKind.Unhelpful;break;case d.ChatAgentVoteDirection.Up:g=v.ChatResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze(o?{result:u,kind:g,reportIssue:o}:{result:u,kind:g}))}$acceptAction(r,t,f){const o=this.c.get(r);if(!o||f.action.kind==="vote")return;const s=E.ChatAgentUserActionEvent.to(t,f,this.s.converter);s&&o.acceptAction(Object.freeze(s))}async $invokeCompletionProvider(r,t,f){const o=this.c.get(r);if(!o)return[];let s=this.m.get(r);return s?s.clear():(s=new w.$Tc,this.m.set(r,s)),(await o.invokeCompletionProvider(t,f)).map(g=>E.ChatAgentCompletionItem.from(g,this.s.converter,s))}async $provideWelcomeMessage(r,t,f){const o=this.c.get(r);if(o)return await o.provideWelcomeMessage(E.ChatLocation.to(t),f)}async $provideSampleQuestions(r,t,f){const o=this.c.get(r);if(o)return(await o.provideSampleQuestions(E.ChatLocation.to(t),f)).map(s=>E.ChatFollowup.from(s,void 0))}}e.$smc=i;class n{constructor(r,t,f,o,s){this.extension=r,this.id=t,this.w=f,this.x=o,this.y=s,this.m=new A.$he,this.n=new A.$he}acceptFeedback(r){this.m.fire(r)}acceptAction(r){this.n.fire(r)}async invokeCompletionProvider(r,t){return this.q?await this.q.provider.provideCompletionItems(r,t)??[]:[]}async provideFollowups(r,t,f){if(!this.b)return[];const o=await this.b.provideFollowups(r,t,f);return o?o.filter(s=>!(s&&"commandId"in s)).filter(s=>!(s&&"message"in s)):[]}async provideWelcomeMessage(r,t){if(!this.s)return[];const f=await this.s.provideWelcomeMessage(r,t);return f?f.map(o=>typeof o=="string"?o:E.MarkdownString.from(o)):[]}async provideSampleQuestions(r,t){if(!this.s||!this.s.provideSampleQuestions)return[];const f=await this.s.provideSampleQuestions(r,t);return f||[]}get apiAgent(){let r=!1,t=!1;const f=()=>{r||t||(t=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof I.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof v.$mN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:E.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:E.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:E.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1}))},o=this;return{get id(){return o.id},get iconPath(){return o.c},set iconPath(s){o.c=s,f()},get requestHandler(){return o.y},set requestHandler(s){(0,k.$kg)(typeof s=="function","Invalid request handler"),o.y=s},get followupProvider(){return o.b},set followupProvider(s){o.b=s,f()},get isDefault(){return(0,h.$OG)(o.extension,"defaultChatParticipant"),o.d},set isDefault(s){(0,h.$OG)(o.extension,"defaultChatParticipant"),o.d=s,f()},get helpTextPrefix(){return(0,h.$OG)(o.extension,"defaultChatParticipant"),o.g},set helpTextPrefix(s){(0,h.$OG)(o.extension,"defaultChatParticipant"),o.g=s,f()},get helpTextVariablesPrefix(){return(0,h.$OG)(o.extension,"defaultChatParticipant"),o.j},set helpTextVariablesPrefix(s){(0,h.$OG)(o.extension,"defaultChatParticipant"),o.j=s,f()},get helpTextPostfix(){return(0,h.$OG)(o.extension,"defaultChatParticipant"),o.k},set helpTextPostfix(s){(0,h.$OG)(o.extension,"defaultChatParticipant"),o.k=s,f()},get isSecondary(){return(0,h.$OG)(o.extension,"defaultChatParticipant"),o.l},set isSecondary(s){(0,h.$OG)(o.extension,"defaultChatParticipant"),o.l=s,f()},get supportIssueReporting(){return(0,h.$OG)(o.extension,"chatParticipantAdditions"),o.o},set supportIssueReporting(s){(0,h.$OG)(o.extension,"chatParticipantAdditions"),o.o=s,f()},get onDidReceiveFeedback(){return o.m.event},set participantVariableProvider(s){if((0,h.$OG)(o.extension,"chatParticipantAdditions"),o.q=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");o.w.$registerAgentCompletionsProvider(o.x,s.triggerCharacters)}else o.w.$unregisterAgentCompletionsProvider(o.x)},get participantVariableProvider(){return(0,h.$OG)(o.extension,"chatParticipantAdditions"),o.q},set welcomeMessageProvider(s){(0,h.$OG)(o.extension,"defaultChatParticipant"),o.s=s,f()},get welcomeMessageProvider(){return(0,h.$OG)(o.extension,"defaultChatParticipant"),o.s},onDidPerformAction:(0,h.$NG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(s){o.t=s,f()},get requester(){return o.t},set supportsSlowReferences(s){o.u=s,f()},get supportsSlowReferences(){return o.u},dispose(){r=!0,o.b=void 0,o.m.dispose(),o.w.$unregisterAgent(o.x)}}}invoke(r,t,f,o){return this.y(r,t,f,o)}}}),define(ke[336],De([1,0,13,3,6,17,8,26]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0;class ${static{this.a=0}constructor(P){this.b=new Map,this.c=P.getProxy(M.$nM.MainThreadChatVariables)}async $resolveVariable(P,p,E,v){const d=this.b.get(P);if(d)try{if(d.resolver.resolve2){(0,w.$OG)(d.extension,"chatParticipantAdditions");const h=new k(p,this.c),c=await d.resolver.resolve2(d.data.name,{prompt:E},h.apiObject,v);if(c&&c[0])return c[0].value}else{const h=await d.resolver.resolve(d.data.name,{prompt:E},v);if(h&&h[0])return h[0].value}}catch(h){(0,l.$2)(h)}}registerVariableResolver(P,p,E,v,d,h,c){const i=$.a++;return this.b.set(i,{extension:P,data:{id:p,name:E,description:v,modelDescription:d},resolver:c}),this.c.$registerVariable(i,{id:p,name:E,description:v,modelDescription:d,isSlow:h}),(0,L.$Sc)(()=>{this.b.delete(i),this.c.$unregisterVariable(i)})}}e.$tmc=$;class k{constructor(P,p){this.c=P,this.d=p,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let p=function(v){if(P.a){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,v),d}};const P=this,E=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){p(this.progress);const d=new R.$sO(v),h=A.ChatResponseProgressPart.from(d);return E(h),this},reference(v){p(this.reference);const d=new R.$wO(v),h=A.ChatResponseReferencePart.from(d);return E(h),this},push(v){return p(this.push),v instanceof R.$wO?E(A.ChatResponseReferencePart.from(v)):v instanceof R.$sO&&E(A.ChatResponseProgressPart.from(v)),this}}}return this.b}}}),define(ke[337],De([1,0,7,57,4,3,2,84,25,17,8,6,26]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=E;function E(v,d,h){const c=v.getProxy(P.$nM.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Xm,d.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const S=this.b.get(b.handle);return S?S.value:b}else if(b&&b.$mid===7){const S=b,m=this.b.get(S.commentControlHandle);if(!m)return S;const y=m.getCommentThread(S.commentThreadHandle);return y?y.value:S}else if(b&&(b.$mid===9||b.$mid===8)){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const m=S.getCommentThread(b.thread.commentThreadHandle);return m?b.$mid===8?m.value:{thread:m.value,text:b.text}:b}else if(b&&b.$mid===10){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const m=S.getCommentThread(b.thread.commentThreadHandle);if(!m)return b;const y=b.commentUniqueId,D=m.getCommentByUniqueId(y);return D||b}else if(b&&b.$mid===11){const S=this.b.get(b.thread.commentControlHandle);if(!S)return b;const m=S.getCommentThread(b.thread.commentThreadHandle);if(!m)return b;const y=b.text,D=b.commentUniqueId,C=m.getCommentByUniqueId(D);return C?(typeof C.body=="string"?C.body=y:C.body=new I.$RM(y),C):b}return b}})}createCommentController(b,S,m){const y=i.a++,D=new a(b,y,S,m);this.b.set(D.handle,D);const C=this.c.get(b.identifier)||[];return C.push(D),this.c.set(b.identifier,C),D.value}async $createCommentThreadTemplate(b,S,m,y){const D=this.b.get(b);D&&D.$createCommentThreadTemplate(S,m,y)}async $setActiveComment(b,S){const m=this.b.get(b);m&&m.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(b,S,m){const y=this.b.get(b);y&&y.$updateCommentThreadTemplate(S,m)}$deleteCommentThread(b,S){this.b.get(b)?.$deleteCommentThread(S)}async $provideCommentingRanges(b,S,m){const y=this.b.get(b);if(!y||!y.commentingRangeProvider)return Promise.resolve(void 0);const D=await h.ensureDocumentData(R.URI.revive(S));return(0,l.$sh)(async()=>{const C=await y.commentingRangeProvider.provideCommentingRanges(D.document,m);let O;return Array.isArray(C)?O={ranges:C,fileComments:!1}:C?O={ranges:C.ranges||[],fileComments:C.fileComments||!1}:O=C??void 0,O}).then(C=>{let O;return C&&(O={ranges:C.ranges.map(z=>k.Range.from(z)),fileComments:C.fileComments}),O})}$toggleReaction(b,S,m,y,D){const C=this.b.get(b);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,l.$sh)(()=>{const O=C.getCommentThread(S);if(O){const z=O.getCommentByUniqueId(y.uniqueIdInThread);if(C!==void 0&&z&&C.reactionHandler)return C.reactionHandler(z,f(D))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,p.$OG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,S,m,y,D,C,O,z,T){this.m=S,this.n=m,this.o=y,this.p=D,this.q=C,this.extensionDescription=O,this.r=z,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$he,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Vc,this.l.value=new A.$Tc,this.n===void 0&&(this.n=`${b}.${this.handle}`),c.$createCommentThread(S,this.handle,this.n,this.o,k.Range.from(this.p),O.identifier,this.r,T),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{c.$deleteCommentThread(S,this.handle)}});const F=this;this.value={get uri(){return F.uri},get range(){return F.range},set range(N){F.range=N},get comments(){return F.comments},set comments(N){F.comments=N},get collapsibleState(){return F.collapsibleState},set collapsibleState(N){F.collapsibleState=N},get canReply(){return F.canReply},set canReply(N){F.canReply=N},get contextValue(){return F.contextValue},set contextValue(N){F.contextValue=N},get label(){return F.label},set label(N){F.label=N},get state(){return F.state},set state(N){F.state=N},dispose:()=>{F.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Tc);const b=m=>Object.prototype.hasOwnProperty.call(this.b,m),S={};b("range")&&(S.range=k.Range.from(this.p)),b("label")&&(S.label=this.label),b("contextValue")&&(S.contextValue=this.contextValue??null),b("comments")&&(S.comments=this.q.map(m=>r(this,m,this.k,this.extensionDescription))),b("collapsibleState")&&(S.collapseState=o(this.g)),b("canReply")&&(S.canReply=this.canReply),b("state")&&(S.state=s(this.h)),b("applicability")&&(S.applicability=u(this.h)),b("isTemplate")&&(S.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(b){for(const S of this.k){const m=S[0],y=S[1];if(b===y)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Je([(0,L.$6h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,p.$OG)(this.h,"commentingRangeHint"),c.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,p.$OG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,p.$OG)(this.h,"activeComment"),this.f}constructor(b,S,m,y){this.h=b,this.i=S,this.j=m,this.k=y,this.a=new Map,c.$registerCommentController(this.handle,m,y,this.h.identifier.value);const D=this;this.value=Object.freeze({id:D.id,label:D.label,get options(){return D.options},set options(C){D.options=C},get commentingRangeProvider(){return D.commentingRangeProvider},set commentingRangeProvider(C){D.commentingRangeProvider=C},get reactionHandler(){return D.reactionHandler},set reactionHandler(C){D.reactionHandler=C},get activeCommentThread(){return D.activeCommentThread},createCommentThread(C,O,z){return D.createCommentThread(C,O,z).value},dispose:()=>{D.dispose()}}),this.g=[],this.g.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(b,S,m){S===void 0&&(0,p.$OG)(this.h,"fileComments");const y=new n(this.id,this.handle,void 0,b,S,m,this.h,!1);return this.a.set(y.handle,y),y}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const S=this.a.get(b.commentThreadHandle);S&&(this.e=b.uniqueIdInThread?S.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(b,S,m){const y=new n(this.id,this.handle,void 0,R.URI.revive(b),k.Range.to(S),[],this.h,!0,m);return y.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(y.handle,y),y}$updateCommentThreadTemplate(b,S){const m=this.a.get(b);m&&(m.range=k.Range.to(S))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function r(g,b,S,m){let y=S.get(b);return y||(y=++g.commentHandle,S.set(b,y)),b.state!==void 0&&(0,p.$OG)(m,"commentsDraftState"),b.reactions?.some(D=>D.reactors!==void 0)&&(0,p.$OG)(m,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:y,body:typeof b.body=="string"?b.body:k.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(D=>t(D)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function t(g){return{label:g.label,iconPath:g.iconPath?k.$QO(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted,reactors:g.reactors&&g.reactors.length>0&&typeof g.reactors[0]!="string"?g.reactors.map(b=>b.name):g.reactors}}function f(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?R.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1,reactors:g.reactors?.map(b=>({name:b}))}}function o(g){if(g!==void 0)switch(g){case I.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case I.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function s(g){let b;if(typeof g=="object"?b=g.resolved:b=g,b!==void 0)switch(b){case I.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case I.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}function u(g){let b;if(typeof g=="object"&&(b=g.applicability),b!==void 0)switch(b){case I.CommentThreadApplicability.Current:return w.CommentThreadApplicability.Current;case I.CommentThreadApplicability.Outdated:return w.CommentThreadApplicability.Outdated}return w.CommentThreadApplicability.Current}return new i}}),define(ke[338],De([1,0,21,58,3,15,23,2,17,92,112,6,8]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;class E{constructor(f,o){this.document=f,this.b=o,this.a=1,this.c=new I.$dmc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,o){await this.f(f).undo(),o||this.disposeBackup()}async redo(f,o){await this.f(f).redo(),o||this.disposeBackup()}disposeEdits(f){for(const o of f)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=r(this.document.uri)+this.a++;return(0,R.$bh)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const o=this.c.get(f,0);if(!o)throw new Error("No edit found");return o}}class v{constructor(){this.a=new Map}get(f,o){return this.a.get(this.b(f,o))}add(f,o,s){const u=this.b(f,o.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${f} resource:${o.uri}`);const g=new E(o,s);return this.a.set(u,g),g}delete(f,o){const s=this.b(f,o.uri);this.a.delete(s)}b(f,o){return`${f}@@@${o}`}}var d;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(d||(d={}));class h{constructor(){this.a=new Map}addTextProvider(f,o,s){return this.b(f,{type:0,extension:o,provider:s})}addCustomProvider(f,o,s){return this.b(f,{type:1,extension:o,provider:s})}get(f){return this.a.get(f)}b(f,o){if(this.a.has(f))throw new Error(`Provider for viewType:${f} already registered`);return this.a.set(f,o),new p.$pM(()=>this.a.delete(f))}}class c{constructor(f,o,s,u,g){this.d=o,this.f=s,this.g=u,this.h=g,this.b=new h,this.c=new v,this.a=f.getProxy(P.$nM.MainThreadCustomEditors)}registerCustomEditorProvider(f,o,s,u){const g=new M.$Tc;return n(s)?(g.add(this.b.addTextProvider(o,f,s)),this.a.$registerTextEditorProvider((0,k.$Mmc)(f),o,u.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,k.$Kmc)(f))):(g.add(this.b.addCustomProvider(o,f,s)),i(s)&&g.add(s.onDidChangeCustomDocument(b=>{const S=this.i(o,b.document.uri);if(a(b)){const m=S.addEdit(b);this.a.$onDidEdit(b.document.uri,o,m,b.label)}else this.a.$onContentChange(b.document.uri,o)})),this.a.$registerCustomEditorProvider((0,k.$Mmc)(f),o,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,k.$Kmc)(f))),p.$pM.from(g,new p.$pM(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(f,o,s,u,g){const b=this.b.get(o);if(!b)throw new Error(`No provider found for '${o}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${o}'`);const S=w.URI.revive(f),m=await b.provider.openCustomDocument(S,{backupId:s,untitledDocumentData:u?.buffer},g);let y;return i(b.provider)&&this.f&&(y=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(o,m,y),{editable:i(b.provider)}}async $disposeCustomDocument(f,o){const s=this.b.get(o);if(!s)throw new Error(`No provider found for '${o}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${o}'`);const u=w.URI.revive(f),{document:g}=this.i(o,u);this.c.delete(o,g),g.dispose()}async $resolveCustomEditor(f,o,s,u,g,b){const S=this.b.get(s);if(!S)throw new Error(`No provider found for '${s}'`);const m=$.ViewColumn.to(g),y=this.g.createNewWebview(o,u.contentOptions,S.extension),D=this.h.createNewWebviewPanel(o,s,u.title,m,u.options,y,u.active),C=w.URI.revive(f);switch(S.type){case 1:{const{document:O}=this.i(s,C);return S.provider.resolveCustomEditor(O,D,b)}case 0:{const O=this.d.getDocument(C);return S.provider.resolveCustomTextEditor(O,D,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,o,s){this.i(o,f).disposeEdits(s)}async $onMoveCustomEditor(f,o,s){const u=this.b.get(s);if(!u)throw new Error(`No provider found for '${s}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const g=this.h.getWebviewPanel(f);if(!g)throw new Error("No webview found");const b=w.URI.revive(o),S=this.d.getDocument(b);await u.provider.moveCustomTextEditor(S,g,l.CancellationToken.None)}async $undo(f,o,s,u){return this.i(o,f).undo(s,u)}async $redo(f,o,s,u){return this.i(o,f).redo(s,u)}async $revert(f,o,s){const u=this.i(o,f);await this.j(o).revertCustomDocument(u.document,s),u.disposeBackup()}async $onSave(f,o,s){const u=this.i(o,f);await this.j(o).saveCustomDocument(u.document,s),u.disposeBackup()}async $onSaveAs(f,o,s,u){const g=this.i(o,f);return this.j(o).saveCustomDocumentAs(g.document,w.URI.revive(s),u)}async $backup(f,o,s){const u=this.i(o,f),b=await this.j(o).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},s);return u.updateBackup(b),b.id}i(f,o){const s=this.c.get(f,w.URI.revive(o));if(!s)throw new Error("No custom document found");return s}j(f){const s=this.b.get(f)?.provider;if(!s||!i(s))throw new Error("Custom document is not editable");return s}}e.$Pmc=c;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function r(t){const f=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,L.$oj)(f)+""}}),define(ke[339],De([1,0,224,139,2,6,8,17,4,11,27,60]),function(le,e,l,L,M,A,R,w,$,k,I,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0;class E{#e;#t;#n;constructor(h,c,i,n,a,r,t,f){this.d=h,this.e=c,this.f=i,this.g=n,this.h=a,this.c=!1,this.f=Math.max(n,i),this.#n=new I.$Ac(o=>r.getComparisonKey(o)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#n.keys()]),this.#e?.$clear(this.e),this.#n.clear(),this.c=!0)}get name(){return this.j(),this.d}set(h,c){if(!h){this.clear();return}this.j();let i=[];if(M.URI.isUri(h)){if(!c){this.delete(h);return}this.#n.set(h,c.slice()),i=[h]}else if(Array.isArray(h)){i=[];let r;h=[...h].sort(E.k);for(const t of h){const[f,o]=t;if((!r||f.toString()!==r.toString())&&(r&&this.#n.get(r).length===0&&this.#n.delete(r),r=f,i.push(f),this.#n.set(f,[])),o)this.#n.get(f)?.push(...o);else{const s=this.#n.get(f);s&&(s.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let a=0;for(const r of i){let t=[];const f=this.#n.get(r);if(f)if(f.length>this.g){t=[];const o=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const u of f)if(u.severity===o[s]&&t.push({...w.Diagnostic.from(u),modelVersionId:this.h(r)})===this.g)break e;t.push({severity:L.MarkerSeverity.Info,message:(0,l.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(o=>({...w.Diagnostic.from(o),modelVersionId:this.h(r)}));if(n.push([r,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,n)}delete(h){this.j(),this.#t.fire([h]),this.#n.delete(h),this.#e?.$changeMany(this.e,[[h,void 0]])}clear(){this.j(),this.#t.fire([...this.#n.keys()]),this.#n.clear(),this.#e?.$clear(this.e)}forEach(h,c){this.j();for(const[i,n]of this)h.call(c,i,n,this)}*[Symbol.iterator](){this.j();for(const h of this.#n.keys())yield[h,this.get(h)]}get(h){this.j();const c=this.#n.get(h);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(h){return this.j(),Array.isArray(this.#n.get(h))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(h,c){return h[0].toString()<c[0].toString()?-1:h[0].toString()>c[0].toString()?1:0}}e.$kmc=E;let v=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(h){const c=new I.$Ac;for(const i of h)c.set(i,i);return{uris:Object.freeze(Array.from(c.values()))}}constructor(h,c,i,n){this.j=c,this.k=i,this.l=n,this.g=new Map,this.h=new $.$le({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,p._mapper),this.f=h.getProxy(A.$nM.MainThreadDiagnostics)}createDiagnosticCollection(h,c){const{g:i,f:n,h:a,j:r,k:t,l:f}=this,o=new class{$changeMany(g,b){n.$changeMany(g,b),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,g,b.length===0?"CLEARING":b)}$clear(g){n.$clear(g),r.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,g)}dispose(){n.dispose()}};let s;if(!c)c="_generated_diagnostic_collection_name_#"+p.c++,s=c;else if(!i.has(c))s=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do s=c+p.c++;while(i.has(s))}return new class extends E{constructor(){super(c,s,p.e,p.d,g=>f.getDocument(g)?.version,t.extUri,o,a),i.set(s,this)}dispose(){super.dispose(),i.delete(s)}}}getDiagnostics(h){if(h)return this.m(h);{const c=new Map,i=[];for(const n of this.g.values())n.forEach((a,r)=>{let t=c.get(a.toString());typeof t>"u"&&(t=i.length,c.set(a.toString(),t),i.push([a,[]])),i[t][1]=i[t][1].concat(...r)});return i}}m(h){let c=[];for(const i of this.g.values())i.has(h)&&(c=c.concat(i.get(h)));return c}$acceptMarkersChange(h){if(!this.n){const c="_generated_mirror",i=new E(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(c,i),this.n=i}for(const[c,i]of h)this.n.set(M.URI.revive(c),i.map(w.Diagnostic.to))}};e.$lmc=v,e.$lmc=v=p=Je([We(1,k.$7j),We(2,P.$jmc)],v)}),define(ke[340],De([1,0,2,13,8,17,76,48]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;class ${constructor(I,P,p,E={timeout:1500,errors:3}){this.c=I,this.d=P,this.f=p,this.g=E,this.a=new R.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(P,p,E)=>{const d={dispose:this.a.push([P,p,I])};return Array.isArray(E)&&E.push(d),d}}async $participateInSave(I,P){const p=l.URI.revive(I);let E=!1;const v=setTimeout(()=>E=!0,this.g.timeout),d=[];try{for(const h of[...this.a]){if(E)break;const c=this.d.getDocument(p),i=await this.h(h,{document:c,reason:A.TextDocumentSaveReason.to(P)});d.push(i)}}finally{clearTimeout(v)}return d}h([I,P,p],E){const v=this.b.get(I);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(p,I,P,E).then(()=>!0,d=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' threw ERROR`),this.c.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const h=this.b.get(I);this.b.set(I,h?h+1:1),typeof h=="number"&&h>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,P,p,E){const v=[],d=Date.now(),{document:h,reason:c}=E,{version:i}=h,n=Object.freeze({document:h,reason:c,waitUntil(a){if(Object.isFrozen(v))throw(0,L.$8)("waitUntil can not be called async");v.push(Promise.resolve(a))}});try{P.apply(p,[n])}catch(a){return Promise.reject(a)}return Object.freeze(v),new Promise((a,r)=>{const t=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(v).then(f=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(t),a(f)}).catch(f=>{clearTimeout(t),r(f)})}).then(a=>{const r={edits:[]};for(const t of a)if(Array.isArray(t)&&t.every(f=>f instanceof M.$wM))for(const{newText:f,newEol:o,range:s}of t)r.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:s&&A.Range.from(s),text:f,eol:o&&A.EndOfLine.from(o)}});if(r.edits.length!==0)return i===h.version?this.f.$tryApplyWorkspaceEdit(new w.$Hw(r)):Promise.reject(new Error("concurrent_edits"))})}}e.$tnc=$}),define(ke[341],De([1,0,4,3,2,6,153,17,18,24,8]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class P{constructor(E,v){this.a=new l.$he,this.b=new l.$he,this.c=new l.$he,this.d=new l.$he,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Tc,this.h=new Map,this.f=E.getProxy(A.$nM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(d=>{for(const h of d)this.b.fire(h.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const h of d)this.a.fire(h.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const v=this.g.getDocument(E);if(v)return v}getDocument(E){const v=this.getDocumentData(E);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return v.document}ensureDocumentData(E){const v=this.g.getDocument(E);if(v)return Promise.resolve(v);let d=this.h.get(E.toString());return d||(d=this.f.$tryOpenDocument(E).then(h=>{this.h.delete(E.toString());const c=M.URI.revive(h);return(0,$.$lg)(this.g.getDocument(c))},h=>(this.h.delete(E.toString()),Promise.reject(h))),this.h.set(E.toString(),d)),d}createDocumentData(E){return this.f.$tryCreateDocument(E).then(v=>M.URI.revive(v))}$acceptModelLanguageChanged(E,v){const d=M.URI.revive(E),h=this.g.getDocument(d);if(!h)throw new Error("unknown document");this.b.fire(h.document),h._acceptLanguageId(v),this.a.fire(h.document)}$acceptModelSaved(E){const v=M.URI.revive(E),d=this.g.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(E,v){const d=M.URI.revive(E),h=this.g.getDocument(d);if(!h)throw new Error("unknown document");h._acceptIsDirty(v),this.c.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,v,d){const h=M.URI.revive(E),c=this.g.getDocument(h);if(!c)throw new Error("unknown document");c._acceptIsDirty(d),c.onEvents(v);let i;v.isUndoing?i=I.TextDocumentChangeReason.Undo:v.isRedoing&&(i=I.TextDocumentChangeReason.Redo),this.c.fire((0,k.$8n)({document:c.document,contentChanges:v.changes.map(n=>({range:w.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(E,v){(0,R.$TO)(E,v)}}e.$mmc=P}),define(ke[72],De([1,0,74,4,18,2,5,6,20,17,8]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=e.$Qmc=void 0,e.$Qmc=(0,R.$Ai)("IExtHostEditorTabs");class P{constructor(h,c,i){this.e=i,this.d=c,this.acceptDtoUpdate(h)}get apiObject(){if(!this.a){const h=this,c={get isActive(){return h.b.id===h.e()},get label(){return h.b.label},get input(){return h.c},get isDirty(){return h.b.isDirty},get isPinned(){return h.b.isPinned},get isPreview(){return h.b.isPreview},get group(){return h.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(h){this.b=h,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new I.$aO(A.URI.revive(this.b.input.uri));case 2:return new I.$bO(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new I.$cO(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new I.$dO(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new I.$eO(this.b.input.viewType);case 4:return new I.$fO(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new I.$gO(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new I.$hO;case 9:return new I.$iO(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new I.$jO;case 11:return new I.$kO(this.b.input.diffEditors.map(h=>new I.$bO(A.URI.revive(h.original),A.URI.revive(h.modified))));default:return}}}class p{constructor(h,c){this.c=[],this.d="",this.b=h,this.e=c;for(const i of h.tabs)i.isActive&&(this.d=i.id),this.c.push(new P(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const h=this,c={get isActive(){return h.b.groupId===h.e()},get viewColumn(){return k.ViewColumn.to(h.b.viewColumn)},get activeTab(){return h.c.find(i=>i.tabId===h.d)?.apiObject},get tabs(){return Object.freeze(h.c.map(i=>i.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(h){this.b=h}acceptTabOperation(h){if(h.kind===0){const i=new P(h.tabDto,this,()=>this.activeTabId());return this.c.splice(h.index,0,i),h.tabDto.isActive&&(this.d=i.tabId),i}else if(h.kind===1){const i=this.c.splice(h.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(h.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this.c.splice(h.index,0,i),i}const c=this.c.find(i=>i.tabId===h.tabDto.id);if(!c)throw new Error("INVALID tab");return h.tabDto.isActive?this.d=h.tabDto.id:this.d===h.tabDto.id&&!h.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(h.tabDto),c}activeTabId(){return this.d}}let E=class{constructor(h){this.b=new L.$he,this.c=new L.$he,this.e=[],this.a=h.getProxy(w.$nM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const h=this,c={onDidChangeTabGroups:h.c.event,onDidChangeTabs:h.b.event,get all(){return Object.freeze(h.e.map(i=>i.apiObject))},get activeTabGroup(){const i=h.d;return(0,M.$lg)(h.e.find(a=>a.groupId===i)?.apiObject)},close:async(i,n)=>{const a=Array.isArray(i)?i:[i];return a.length?v(a[0])?this.j(a,n):this.i(a,n):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(h){const c=new Set(this.e.map(o=>o.groupId)),i=new Set(h.map(o=>o.groupId)),n=(0,l.$L)(c,i),a=this.e.filter(o=>n.removed.includes(o.groupId)).map(o=>o.apiObject),r=[],t=[];this.e=h.map(o=>{const s=new p(o,()=>this.d);return n.added.includes(s.groupId)?r.push(s.apiObject):t.push(s.apiObject),s});const f=(0,M.$lg)(h.find(o=>o.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:r,closed:a,changed:t}))}$acceptTabGroupUpdate(h){const c=this.e.find(i=>i.groupId===h.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(h),h.isActive&&(this.d=h.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const c=this.e.find(n=>n.groupId===h.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const i=c.acceptTabOperation(h);switch(h.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(h){for(const c of this.e)for(const i of c.tabs)if(i.apiObject===h)return i}h(h){return this.e.find(c=>c.apiObject===h)}async i(h,c){const i=[];for(const n of h){const a=this.g(n);if(!a)throw new Error("Tab close: Invalid tab not found!");i.push(a.tabId)}return this.a.$closeTab(i,c)}async j(h,c){const i=[];for(const n of h){const a=this.h(n);if(!a)throw new Error("Group close: Invalid group not found!");i.push(a.groupId)}return this.a.$closeGroup(i,c)}};e.$Rmc=E,e.$Rmc=E=Je([We(0,$.$RO)],E);function v(d){return d.tabs!==void 0}}),define(ke[342],De([1,0,2,6,3,8,17,185,14,22,26,81]),function(le,e,l,L,M,A,R,w,$,k,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0;class p{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const h=this.a.indexOf(d);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),h=[];let c,i,n=14,a=14;for(const r of d){let t=c?(0,$.$Df)(c,r):0;for(t===0?i=1:i=a;t<r.length;t++)t+1===r.length?(n=a,a=9):a+=1,h.push([i,r.toUpperCase().charCodeAt(t),a]),h.push([i,r.toLowerCase().charCodeAt(t),a]),i=a;c=r,a=n}h.push([9,58,10]),h.push([10,47,12]),this.b=new w.$W2(h)}}provideDocumentLinks(d){this.c();const h=[],c=w.$X2.computeLinks({getLineContent(i){return d.lineAt(i-1).text},getLineCount(){return d.lineCount}},this.b);for(const i of c){const n=R.DocumentLink.to(i);n.target&&h.push(n)}return h}}class E{constructor(d,h){this.i=h,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(L.$nM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,h,c,i={}){if(E.j(c),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const n=this.h++;this.b.add(h),this.d.add(h),this.c.set(n,c);let a=2;i.isCaseSensitive&&(a+=1024),i.isReadonly&&(a+=2048),typeof c.copy=="function"&&(a+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,I.$OG)(d,"fsChunks"),a+=4);let r;i.isReadonly&&(0,P.$Zk)(i.isReadonly)&&i.isReadonly.value!==""&&(r={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,h,a,r).catch(f=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${h}`),console.error(f)});const t=c.onDidChangeFile(f=>{const o=[];for(const s of f){const{uri:u,type:g}=s;if(u.scheme!==h)continue;let b;switch(g){case A.FileChangeType.Changed:b=0;break;case A.FileChangeType.Created:b=1;break;case A.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:u,type:b})}this.a.$onFileSystemChange(n,o)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:h,ctime:c,mtime:i,size:n,permissions:a}=d;return{type:h,ctime:c,mtime:i,size:n,permissions:a}}$stat(d,h){return Promise.resolve(this.l(d).stat(l.URI.revive(h))).then(c=>E.k(c))}$readdir(d,h){return Promise.resolve(this.l(d).readDirectory(l.URI.revive(h)))}$readFile(d,h){return Promise.resolve(this.l(d).readFile(l.URI.revive(h))).then(c=>k.$Je.wrap(c))}$writeFile(d,h,c,i){return Promise.resolve(this.l(d).writeFile(l.URI.revive(h),c.buffer,i))}$delete(d,h,c){return Promise.resolve(this.l(d).delete(l.URI.revive(h),c))}$rename(d,h,c,i){return Promise.resolve(this.l(d).rename(l.URI.revive(h),l.URI.revive(c),i))}$copy(d,h,c,i){const n=this.l(d);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(l.URI.revive(h),l.URI.revive(c),i))}$mkdir(d,h){return Promise.resolve(this.l(d).createDirectory(l.URI.revive(h)))}$watch(d,h,c,i){const n=this.l(d).watch(l.URI.revive(c),i);this.f.set(h,n)}$unwatch(d,h){const c=this.f.get(h);c&&(c.dispose(),this.f.delete(h))}$open(d,h,c){const i=this.l(d);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(l.URI.revive(h),c))}$close(d,h){const c=this.l(d);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(h))}$read(d,h,c,i){const n=this.l(d);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const a=k.$Je.alloc(i);return Promise.resolve(n.read(h,c,a.buffer,0,i)).then(r=>a.slice(0,r))}$write(d,h,c,i){const n=this.l(d);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(h,c,i.buffer,0,i.byteLength))}l(d){const h=this.c.get(d);if(!h){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return h}}e.$wnc=E}),define(ke[343],De([1,0,4,35,2,6,17,8,46]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,v,d,h,c,i){this.a=Math.random(),this.b=new l.$he,this.c=new l.$he,this.d=new l.$he,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,L.$uk)(c),a=typeof c=="string",r=i?.correlate,t=h(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(r&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const o of f.created){const s=M.URI.revive(o);n(s.fsPath)&&(!a||v.getWorkspaceFolder(s))&&this.b.fire(s)}if(!i?.ignoreChangeEvents)for(const o of f.changed){const s=M.URI.revive(o);n(s.fsPath)&&(!a||v.getWorkspaceFolder(s))&&this.c.fire(s)}if(!i?.ignoreDeleteEvents)for(const o of f.deleted){const s=M.URI.revive(o);n(s.fsPath)&&(!a||v.getWorkspaceFolder(s))&&this.d.fire(s)}}});this.g=w.$pM.from(this.i(E,d,c,i,i?.correlate),this.b,this.c,this.d,t)}i(E,v,d,h,c){const i=w.$pM.from();if(typeof d=="string"||h?.ignoreChangeEvents&&h?.ignoreCreateEvents&&h?.ignoreDeleteEvents)return i;const n=E.getProxy(A.$nM.MainThreadFileSystemEventService);let a=!1;(d.pattern.includes(L.$qk)||d.pattern.includes(L.$rk))&&(a=!0);let r;return c&&(h?.ignoreChangeEvents||h?.ignoreCreateEvents||h?.ignoreDeleteEvents)&&(r=14,h?.ignoreChangeEvents&&(r&=-3),h?.ignoreCreateEvents&&(r&=-5),h?.ignoreDeleteEvents&&(r&=-9)),n.$watch(v.identifier.value,this.a,d.baseUri,{recursive:a,excludes:h?.excludes??[],filter:r},!!c),w.$pM.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class I{constructor(E){this.a=E,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(M.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(E,v,d){this.j=E,this.k=v,this.l=d,this.a=new l.$he,this.b=new l.$he,this.c=new l.$he,this.d=new l.$he,this.g=new l.$je,this.h=new l.$je,this.i=new l.$je,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,v,d,h){return new k(this.j,E,v,this.a.event,R.GlobPattern.from(d),h)}$onFileEvent(E){this.a.fire(new I(E))}$onDidRunFileOperation(E,v){switch(E){case 2:this.b.fire(Object.freeze({files:v.map(d=>({oldUri:M.URI.revive(d.source),newUri:M.URI.revive(d.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(d=>M.URI.revive(d.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(d=>M.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,v){return(d,h,c)=>{const i=function(a){d.call(h,a)};return i.extension=E,v.event(i,void 0,c)}}async $onWillRunFileOperation(E,v,d,h){switch(E){case 2:return await this.n(this.g,{files:v.map(c=>({oldUri:M.URI.revive(c.source),newUri:M.URI.revive(c.target)}))},d,h);case 1:return await this.n(this.i,{files:v.map(c=>M.URI.revive(c.target))},d,h);case 0:case 3:return await this.n(this.h,{files:v.map(c=>M.URI.revive(c.target))},d,h)}}async n(E,v,d,h){const c=new Set,i=[];if(await E.fireAsync(v,h,async(a,r)=>{const t=Date.now(),f=await Promise.resolve(a);f instanceof w.$zM&&(i.push([r.extension,f]),c.add(r.extension.displayName??r.extension.identifier.value)),Date.now()-t>d&&this.k.warn("SLOW file-participant",r.extension.identifier)}),h.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,a]of i){const{edits:r}=R.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(r)}return{edit:n,extensionNames:Array.from(c)}}}e.$xnc=P}),define(ke[344],De([1,0,19,7,21,13,125,3,24,40,14,18,2,29,181,84,135,226,25,17,8,26,112,6]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;class o{constructor(V,W){this.d=V,this.e=W}async provideDocumentSymbols(V,W){const J=this.d.getDocument(V),Z=await this.e.provideDocumentSymbols(J,W);if(!(0,l.$Kb)(Z))return Z[0]instanceof a.$JM?Z.map(n.DocumentSymbol.from):o.f(Z)}static f(V){V=V.slice(0).sort((Z,he)=>{let be=Z.location.range.start.compareTo(he.location.range.start);return be===0&&(be=he.location.range.end.compareTo(Z.location.range.end)),be});const W=[],J=[];for(const Z of V){const he={name:Z.name||"!!MISSING: name!!",kind:n.SymbolKind.from(Z.kind),tags:Z.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:n.Range.from(Z.location.range),selectionRange:n.Range.from(Z.location.range),children:[]};for(;;){if(J.length===0){J.push(he),W.push(he);break}const be=J[J.length-1];if(E.$At.containsRange(be.range,he.range)&&!E.$At.equalsRange(be.range,he.range)){be.children?.push(he),J.push(he);break}J.pop()}}return W}}class s{constructor(V,W,J,Z,he,be){this.f=V,this.g=W,this.h=J,this.j=Z,this.k=he,this.l=be,this.d=new t.$dmc("CodeLens"),this.e=new Map}async provideCodeLenses(V,W){const J=this.f.getDocument(V),Z=await this.h.provideCodeLenses(J,W);if(!Z||W.isCancellationRequested)return;const he=this.d.add(Z),be=new w.$Tc;this.e.set(he,be);const Fe={cacheId:he,lenses:[]};for(let Ve=0;Ve<Z.length;Ve++)Fe.lenses.push({cacheId:[he,Ve],range:n.Range.from(Z[Ve].range),command:this.g.toInternal(Z[Ve].command,be)});return Fe}async resolveCodeLens(V,W){const J=V.cacheId&&this.d.get(...V.cacheId);if(!J)return;let Z;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?Z=J:Z=await this.h.resolveCodeLens(J,W),Z||(Z=J),W.isCancellationRequested)return;const he=V.cacheId&&this.e.get(V.cacheId[0]);if(he){if(!Z.command){const be=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,be),this.l.error(be);return}return V.command=this.g.toInternal(Z.command,he),V}}releaseCodeLenses(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}}function u(je){return Array.isArray(je)?je.map(n.DefinitionLink.from):je?[n.DefinitionLink.from(je)]:[]}class g{constructor(V,W){this.d=V,this.e=W}async provideDefinition(V,W,J){const Z=this.d.getDocument(V),he=n.Position.to(W),be=await this.e.provideDefinition(Z,he,J);return u(be)}}class b{constructor(V,W){this.d=V,this.e=W}async provideDeclaration(V,W,J){const Z=this.d.getDocument(V),he=n.Position.to(W),be=await this.e.provideDeclaration(Z,he,J);return u(be)}}class S{constructor(V,W){this.d=V,this.e=W}async provideImplementation(V,W,J){const Z=this.d.getDocument(V),he=n.Position.to(W),be=await this.e.provideImplementation(Z,he,J);return u(be)}}class m{constructor(V,W){this.d=V,this.e=W}async provideTypeDefinition(V,W,J){const Z=this.d.getDocument(V),he=n.Position.to(W),be=await this.e.provideTypeDefinition(Z,he,J);return u(be)}}class y{static{this.f=10}constructor(V,W){this.g=V,this.h=W,this.d=0,this.e=new Map}async provideHover(V,W,J,Z){const he=this.g.getDocument(V),be=n.Position.to(W);let Fe;if(J&&J.verbosityRequest){const _e=J.verbosityRequest.previousHover.id,nt=this.e.get(_e);if(!nt)throw new Error(`Hover with id ${_e} not found`);const it={action:J.verbosityRequest.action,previousHover:nt};Fe=await this.h.provideHover(he,be,Z,it)}else Fe=await this.h.provideHover(he,be,Z);if(!Fe||(0,l.$Kb)(Fe.contents))return;Fe.range||(Fe.range=he.getWordRangeAtPosition(be)),Fe.range||(Fe.range=new a.$rM(be,be));const Ve=n.Hover.from(Fe),Qe=this.d;if(this.e.size===y.f){const _e=Math.min(...this.e.keys());this.e.delete(_e)}return this.e.set(Qe,Fe),this.d+=1,{...Ve,id:Qe}}releaseHover(V){this.e.delete(V)}}class D{constructor(V,W){this.d=V,this.e=W}async provideEvaluatableExpression(V,W,J){const Z=this.d.getDocument(V),he=n.Position.to(W),be=await this.e.provideEvaluatableExpression(Z,he,J);if(be)return n.EvaluatableExpression.from(be)}}class C{constructor(V,W){this.d=V,this.e=W}async provideInlineValues(V,W,J,Z){const he=this.d.getDocument(V),be=await this.e.provideInlineValues(he,n.Range.to(W),n.InlineValueContext.to(J),Z);if(Array.isArray(be))return be.map(Fe=>n.InlineValue.from(Fe))}}class O{constructor(V,W){this.d=V,this.e=W}async provideDocumentHighlights(V,W,J){const Z=this.d.getDocument(V),he=n.Position.to(W),be=await this.e.provideDocumentHighlights(Z,he,J);if(Array.isArray(be))return be.map(n.DocumentHighlight.from)}}class z{constructor(V,W){this.d=V,this.e=W}async provideMultiDocumentHighlights(V,W,J,Z){const he=this.d.getDocument(V),be=J.map(Qe=>this.d.getDocument(Qe)),Fe=n.Position.to(W),Ve=await this.e.provideMultiDocumentHighlights(he,Fe,be,Z);if(Array.isArray(Ve))return Ve.map(n.MultiDocumentHighlight.from)}}class T{constructor(V,W){this.d=V,this.e=W}async provideLinkedEditingRanges(V,W,J){const Z=this.d.getDocument(V),he=n.Position.to(W),be=await this.e.provideLinkedEditingRanges(Z,he,J);if(be&&Array.isArray(be.ranges))return{ranges:(0,l.$Hb)(be.ranges.map(n.Range.from)),wordPattern:be.wordPattern}}}class F{constructor(V,W){this.d=V,this.e=W}async provideReferences(V,W,J,Z){const he=this.d.getDocument(V),be=n.Position.to(W),Fe=await this.e.provideReferences(he,be,J,Z);if(Array.isArray(Fe))return Fe.map(n.location.from)}}class N{static{this.d=1e3}constructor(V,W,J,Z,he,be,Fe){this.g=V,this.h=W,this.j=J,this.k=Z,this.l=he,this.m=be,this.n=Fe,this.e=new t.$dmc("CodeAction"),this.f=new Map}async provideCodeActions(V,W,J,Z){const he=this.g.getDocument(V),be=v.$Ct.isISelection(W)?n.Selection.to(W):n.Range.to(W),Fe=[];for(const it of this.j.getDiagnostics(V))if(be.intersection(it.range)&&Fe.push(it)>N.d)break;const Ve={diagnostics:Fe,only:J.only?new a.$LM(J.only):void 0,triggerKind:n.CodeActionTriggerKind.to(J.trigger)},Qe=await this.k.provideCodeActions(he,be,Ve,Z);if(!(0,l.$Lb)(Qe)||Z.isCancellationRequested)return;const tt=this.e.add(Qe),_e=new w.$Tc;this.f.set(tt,_e);const nt=[];for(let it=0;it<Qe.length;it++){const rt=Qe[it];if(rt)if(N.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)});else{Ve.only&&(rt.kind?Ve.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=rt.ranges??[];nt.push({cacheId:[tt,it],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(n.Diagnostic.from),edit:rt.edit&&n.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,r.$NG)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,r.$NG)(this.m,"codeActionRanges")?(0,l.$Hb)(at.map(n.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:tt,actions:nt}}async resolveCodeAction(V,W){const[J,Z]=V,he=this.e.get(J,Z);if(!he||N.o(he))return{};if(!this.k.resolveCodeAction)return{};const be=await this.k.resolveCodeAction(he,W)??he;let Fe;be.edit&&(Fe=n.WorkspaceEdit.from(be.edit,void 0));let Ve;if(be.command){const Qe=this.f.get(J);Qe&&(Ve=this.h.toInternal(be.command,Qe))}return{edit:Fe,command:Ve}}releaseCodeActions(V){this.f.get(V)?.dispose(),this.f.delete(V),this.e.delete(V)}static o(V){return typeof V.command=="string"&&typeof V.title=="string"}}class j{constructor(V,W,J,Z,he){this.e=V,this.f=W,this.g=J,this.h=Z,this.j=he,this.d=new t.$dmc("DocumentPasteEdit")}async prepareDocumentPaste(V,W,J,Z){if(!this.g.prepareDocumentPaste)return;const he=this.f.getDocument(V),be=W.map(Qe=>n.Range.to(Qe)),Fe=n.DataTransfer.toDataTransfer(J,()=>{throw new A.$$});if(await this.g.prepareDocumentPaste(he,be,Fe,Z),Z.isCancellationRequested)return;const Ve=Array.from(Fe).filter(([,Qe])=>!(Qe instanceof a.$fN));return n.DataTransfer.from(Ve)}async providePasteEdits(V,W,J,Z,he,be){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(W),Ve=J.map(nt=>n.Range.to(nt)),Qe=n.DataTransfer.toDataTransfer(Z,async nt=>(await this.e.$resolvePasteFileData(this.h,V,nt)).buffer),tt=await this.g.provideDocumentPasteEdits(Fe,Ve,Qe,{only:he.only?new a.$kN(he.only):void 0,triggerKind:he.triggerKind},be);if(!tt||be.isCancellationRequested)return[];const _e=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[_e,it],title:nt.title??(0,c.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(V,W){const[J,Z]=V,he=this.d.get(J,Z);if(!he||!this.g.resolveDocumentPasteEdit)return{};const be=await this.g.resolveDocumentPasteEdit(he,W)??he;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releasePasteEdits(V){this.d.delete(V)}}class B{constructor(V,W){this.d=V,this.e=W}async provideDocumentFormattingEdits(V,W,J){const Z=this.d.getDocument(V),he=await this.e.provideDocumentFormattingEdits(Z,W,J);if(Array.isArray(he))return he.map(n.TextEdit.from)}}class X{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeFormattingEdits(V,W,J,Z){const he=this.d.getDocument(V),be=n.Range.to(W),Fe=await this.e.provideDocumentRangeFormattingEdits(he,be,J,Z);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(V,W,J,Z){(0,P.$kg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const he=this.d.getDocument(V),be=W.map(n.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(he,be,J,Z);if(Array.isArray(Fe))return Fe.map(n.TextEdit.from)}}class ie{constructor(V,W){this.d=V,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(V,W,J,Z,he){const be=this.d.getDocument(V),Fe=n.Position.to(W),Ve=await this.e.provideOnTypeFormattingEdits(be,Fe,J,Z,he);if(Array.isArray(Ve))return Ve.map(n.TextEdit.from)}}class H{constructor(V,W){this.e=V,this.f=W,this.d=new t.$dmc("WorkspaceSymbols")}async provideWorkspaceSymbols(V,W){const J=await this.e.provideWorkspaceSymbols(V,W);if(!(0,l.$Lb)(J))return{symbols:[]};const Z=this.d.add(J),he={cacheId:Z,symbols:[]};for(let be=0;be<J.length;be++){const Fe=J[be];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}he.symbols.push({...n.WorkspaceSymbol.from(Fe),cacheId:[Z,be]})}return he}async resolveWorkspaceSymbol(V,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!V.cacheId)return V;const J=this.d.get(...V.cacheId);if(J){const Z=await this.e.resolveWorkspaceSymbol(J,W);return Z&&(0,$.$0n)(V,n.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(V){this.d.delete(V)}}class K{static supportsResolving(V){return typeof V.prepareRename=="function"}constructor(V,W,J){this.d=V,this.e=W,this.f=J}async provideRenameEdits(V,W,J,Z){const he=this.d.getDocument(V),be=n.Position.to(W);try{const Fe=await this.e.provideRenameEdits(he,be,J,Z);return Fe?n.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Ve=K.g(Fe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(V,W,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(V),he=n.Position.to(W);try{const be=await this.e.prepareRename(Z,he,J);let Fe,Ve;if(a.$rM.isRange(be)?(Fe=be,Ve=Z.getText(be)):(0,P.$cg)(be)&&(Fe=be.range,Ve=be.placeholder),!Fe||!Ve)return;if(Fe.start.line>he.line||Fe.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Fe),text:Ve}}catch(be){const Fe=K.g(be);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(be)}}static g(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class x{static{this.d={[d.NewSymbolNameTriggerKind.Invoke]:a.NewSymbolNameTriggerKind.Invoke,[d.NewSymbolNameTriggerKind.Automatic]:a.NewSymbolNameTriggerKind.Automatic}}constructor(V,W,J){this.e=V,this.f=W,this.g=J}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(V,W,J,Z){const he=this.e.getDocument(V),be=n.Range.to(W);try{const Fe=x.d[J],Ve=await this.f.provideNewSymbolNames(he,be,Fe,Z);return Ve?Ve.map(Qe=>typeof Qe=="string"?{newSymbolName:Qe}:{newSymbolName:Qe.newSymbolName,tags:Qe.tags}):void 0}catch(Fe){this.g.error(x.h(Fe)??JSON.stringify(Fe,null,"	"));return}}static h(V){return typeof V=="string"?V:V instanceof Error&&typeof V.message=="string"?V.message:void 0}}class _{constructor(V,W){this.resultId=V,this.tokens=W}}class ge{constructor(V,W){this.f=V,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(V,W,J){const Z=this.f.getDocument(V),he=W!==0?this.d.get(W):null;let be=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,he.resultId,J):await this.g.provideDocumentSemanticTokens(Z,J);return he&&this.d.delete(W),be?(be=ge.h(be),this.o(ge.n(he,be),be)):null}async releaseDocumentSemanticColoring(V){this.d.delete(V)}static h(V){return ge.j(V)?ge.k(V)?V:new a.$KN(new Uint32Array(V.data),V.resultId):ge.l(V)?ge.m(V)?V:new a.$MN(V.edits.map(W=>new a.$LN(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),V.resultId):V}static j(V){return V&&!!V.data}static k(V){return V.data instanceof Uint32Array}static l(V){return V&&Array.isArray(V.edits)}static m(V){for(const W of V.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(V,W){if(!ge.j(W)||!V||!V.tokens)return W;const J=V.tokens,Z=J.length,he=W.data,be=he.length;let Fe=0;const Ve=Math.min(Z,be);for(;Fe<Ve&&J[Fe]===he[Fe];)Fe++;if(Fe===Z&&Fe===be)return new a.$MN([],W.resultId);let Qe=0;const tt=Ve-Fe;for(;Qe<tt&&J[Z-Qe-1]===he[be-Qe-1];)Qe++;return new a.$MN([{start:Fe,deleteCount:Z-Fe-Qe,data:he.subarray(Fe,be-Qe)}],W.resultId)}o(V,W){if(ge.j(V)){const J=this.e++;return this.d.set(J,new _(V.resultId,V.data)),(0,h.$Nbb)({id:J,type:"full",data:V.data})}if(ge.l(V)){const J=this.e++;return ge.j(W)?this.d.set(J,new _(W.resultId,W.data)):this.d.set(J,new _(V.resultId)),(0,h.$Nbb)({id:J,type:"delta",deltas:(V.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class oe{constructor(V,W){this.d=V,this.e=W}async provideDocumentRangeSemanticTokens(V,W,J){const Z=this.d.getDocument(V),he=await this.e.provideDocumentRangeSemanticTokens(Z,n.Range.to(W),J);return he?this.f(he):null}f(V){return(0,h.$Nbb)({id:0,type:"full",data:V.data})}}class Pe{static supportsResolving(V){return typeof V.resolveCompletionItem=="function"}constructor(V,W,J,Z,he){this.f=V,this.g=W,this.h=J,this.j=Z,this.k=he,this.d=new t.$dmc("CompletionItem"),this.e=new Map}async provideCompletionItems(V,W,J,Z){const he=this.f.getDocument(V),be=n.Position.to(W),Fe=he.getWordRangeAtPosition(be)||new a.$rM(be,be),Ve=Fe.with({end:be}),Qe=new k.$be,tt=await this.h.provideCompletionItems(he,be,Z,n.CompletionContext.to(J));if(!tt||Z.isCancellationRequested)return;const _e=Array.isArray(tt)?new a.$YM(tt):tt,nt=Pe.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),it=new w.$Tc;this.e.set(nt,it);const rt=[],at={x:nt,b:rt,a:{replace:n.Range.from(Fe),insert:n.Range.from(Ve)},c:_e.isIncomplete||void 0,d:Qe.elapsed()};for(let Re=0;Re<_e.items.length;Re++){const ve=_e.items[Re],qe=this.l(ve,[nt,Re],Ve,Fe);rt.push(qe)}return at}async resolveCompletionItem(V,W){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...V);if(!J)return;const Z=this.l(J,V),he=await this.h.resolveCompletionItem(J,W);if(!he)return;const be=this.l(he,V);return(Z.h!==be.h||Z.i!==be.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Z.n!==be.n||Z.o!==be.o||!(0,$.$$n)(Z.p,be.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Z,d:be.d,c:be.c,l:be.l,h:be.h,i:be.i,n:be.n,o:be.o,p:be.p}}releaseCompletionItems(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W,J,Z){const he=this.e.get(W[0]);if(!he)throw Error("DisposableStore is missing...");const be=this.g.toInternal(V.command,he),Fe={x:W,a:V.label,b:V.kind!==void 0?n.CompletionItemKind.from(V.kind):void 0,m:V.tags&&V.tags.map(n.CompletionItemTag.from),c:V.detail,d:typeof V.documentation>"u"?void 0:n.MarkdownString.fromStrict(V.documentation),e:V.sortText!==V.label?V.sortText:void 0,f:V.filterText!==V.label?V.filterText:void 0,g:V.preselect||void 0,i:V.keepWhitespace?1:0,k:V.commitCharacters?.join(""),l:V.additionalTextEdits&&V.additionalTextEdits.map(n.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};V.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=V.textEdit.newText):typeof V.insertText=="string"?Fe.h=V.insertText:V.insertText instanceof a.$AM&&(Fe.h=V.insertText.value,Fe.i|=4);let Ve;return V.textEdit?Ve=V.textEdit.range:V.range&&(Ve=V.range),a.$rM.isRange(Ve)?Fe.j=n.Range.from(Ve):Ve&&(!J?.isEqual(Ve.inserting)||!Z?.isEqual(Ve.replacing))&&(Fe.j={insert:n.Range.from(Ve.inserting),replace:n.Range.from(Ve.replacing)}),Fe}}class me{async provideInlineCompletions(V,W,J,Z){}disposeCompletions(V){}handleDidShowCompletionItem(V,W,J){}handlePartialAccept(V,W,J,Z){}}class U extends me{constructor(V,W,J,Z){super(),this.f=V,this.g=W,this.h=J,this.j=Z,this.d=new pe,this.e=(0,r.$NG)(this.f,"inlineCompletionsAdditions"),this.k={[d.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[d.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$NG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(V,W,J,Z){const he=this.g.getDocument(V),be=n.Position.to(W),Fe=await this.h.provideInlineCompletionItems(he,be,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:n.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},Z);if(!Fe||Z.isCancellationRequested)return;const Ve=Array.isArray(Fe)?Fe:Fe.items,Qe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],tt=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:Ve}),items:Ve.map((it,rt)=>{let at;it.command&&(_e||(_e=new w.$Tc),at=this.j.toInternal(it.command,_e));const Re=it.insertText;return{insertText:typeof Re=="string"?Re:{snippet:Re.value},filterText:it.filterText,range:it.range?n.Range.from(it.range):void 0,command:at,idx:rt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(_e||(_e=new w.$Tc),this.j.toInternal(it,_e))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(V){this.d.disposeReferenceId(V)?.dispose()}handleDidShowCompletionItem(V,W,J){const Z=this.d.get(V)?.items[W];Z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Z,J)}handlePartialAccept(V,W,J,Z){const he=this.d.get(V)?.items[W];he&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(he,J),this.h.handleDidPartiallyAcceptCompletionItem(he,n.PartialAcceptInfo.to(Z)))}}class Y{async provideInlineEdits(V,W,J){const Z=this.f.getDocument(V),he=await this.g.provideInlineEdit(Z,{triggerKind:this.e[W.triggerKind]},J);if(!he||J.isCancellationRequested)return;let be;const Fe=this.d.createReferenceId({dispose(){be?.dispose()},item:he});let Ve;he.accepted&&(be||(be=new w.$Tc),Ve=this.h.toInternal(he.accepted,be));let Qe;return he.rejected&&(be||(be=new w.$Tc),Qe=this.h.toInternal(he.rejected,be)),{pid:Fe,text:he.text,range:n.Range.from(he.range),accepted:Ve,rejected:Qe}}disposeEdit(V){this.d.disposeReferenceId(V)?.dispose()}constructor(V,W,J,Z){this.f=W,this.g=J,this.h=Z,this.d=new pe,this.e={[d.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[d.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(V){const W=this.e++;return this.d.set(W,V),W}disposeReferenceId(V){const W=this.d.get(V);return this.d.delete(V),W}get(V){return this.d.get(V)}}class ce{constructor(V,W){this.e=V,this.f=W,this.d=new t.$dmc("SignatureHelp")}async provideSignatureHelp(V,W,J,Z){const he=this.e.getDocument(V),be=n.Position.to(W),Fe=this.g(J),Ve=await this.f.provideSignatureHelp(he,be,Z,Fe);if(Ve){const Qe=this.d.add([Ve]);return{...n.SignatureHelp.from(Ve),id:Qe}}}g(V){let W;if(V.activeSignatureHelp){const J=n.SignatureHelp.to(V.activeSignatureHelp),Z=this.d.get(V.activeSignatureHelp.id,0);Z?(W=Z,W.activeSignature=J.activeSignature,W.activeParameter=J.activeParameter):W=J}return{...V,activeSignatureHelp:W}}releaseSignatureHelp(V){this.d.delete(V)}}class ae{constructor(V,W,J,Z,he){this.f=V,this.g=W,this.h=J,this.j=Z,this.k=he,this.d=new t.$dmc("InlayHints"),this.e=new Map}async provideInlayHints(V,W,J){const Z=this.f.getDocument(V),he=n.Range.to(W),be=await this.h.provideInlayHints(Z,he,J);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(J.isCancellationRequested)return;const Fe=this.d.add(be);this.e.set(Fe,new w.$Tc);const Ve={hints:[],cacheId:Fe};for(let Qe=0;Qe<be.length;Qe++)this.l(be[Qe],he)&&Ve.hints.push(this.m(be[Qe],[Fe,Qe]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),Ve}async resolveInlayHint(V,W){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...V);if(!J)return;const Z=await this.h.resolveInlayHint(J,W);if(Z&&this.l(Z))return this.m(Z,V)}releaseHints(V){this.e.get(V)?.dispose(),this.e.delete(V),this.d.delete(V)}l(V,W){return V.label.length===0||Array.isArray(V.label)&&V.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",V),!1):!(W&&!W.contains(V.position))}m(V,W){const J=this.e.get(W[0]);if(!J)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:W,tooltip:n.MarkdownString.fromStrict(V.tooltip),position:n.Position.from(V.position),textEdits:V.textEdits&&V.textEdits.map(n.TextEdit.from),kind:V.kind&&n.InlayHintKind.from(V.kind),paddingLeft:V.paddingLeft,paddingRight:V.paddingRight};if(typeof V.label=="string")Z.label=V.label;else{const he=[];Z.label=he;for(const be of V.label){if(!be.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:be.value,tooltip:n.MarkdownString.fromStrict(be.tooltip)};a.$BM.isLocation(be.location)&&(Fe.location=n.location.from(be.location)),be.command&&(Fe.command=this.g.toInternal(be.command,J)),he.push(Fe)}}return Z}}class se{constructor(V,W){this.e=V,this.f=W,this.d=new t.$dmc("DocumentLink")}async provideLinks(V,W){const J=this.e.getDocument(V),Z=await this.f.provideDocumentLinks(J,W);if(!(!Array.isArray(Z)||Z.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(se.g).map(n.DocumentLink.from)};{const he=this.d.add(Z),be={links:[],cacheId:he};for(let Fe=0;Fe<Z.length;Fe++){if(!se.g(Z[Fe]))continue;const Ve=n.DocumentLink.from(Z[Fe]);Ve.cacheId=[he,Fe],be.links.push(Ve)}return be}}}static g(V){return V.target&&V.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(V,W){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...V);if(!J)return;const Z=await this.f.resolveDocumentLink(J,W);if(!(!Z||!se.g(Z)))return n.DocumentLink.from(Z)}releaseLinks(V){this.d.delete(V)}}class ue{constructor(V,W){this.d=V,this.e=W}async provideColors(V,W){const J=this.d.getDocument(V),Z=await this.e.provideDocumentColors(J,W);return Array.isArray(Z)?Z.map(be=>({color:n.Color.from(be.color),range:n.Range.from(be.range)})):[]}async provideColorPresentations(V,W,J){const Z=this.d.getDocument(V),he=n.Range.to(W.range),be=n.Color.to(W.color),Fe=await this.e.provideColorPresentations(be,{document:Z,range:he},J);if(Array.isArray(Fe))return Fe.map(n.ColorPresentation.from)}}class Q{constructor(V,W){this.d=V,this.e=W}async provideFoldingRanges(V,W,J){const Z=this.d.getDocument(V),he=await this.e.provideFoldingRanges(Z,W,J);if(Array.isArray(he))return he.map(n.FoldingRange.from)}}class re{constructor(V,W,J){this.d=V,this.e=W,this.f=J}async provideSelectionRanges(V,W,J){const Z=this.d.getDocument(V),he=W.map(n.Position.to),be=await this.e.provideSelectionRanges(Z,he,J);if(!(0,l.$Lb)(be))return[];if(be.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Ve=0;Ve<he.length;Ve++){const Qe=[];Fe.push(Qe);let tt=he[Ve],_e=be[Ve];for(;;){if(!_e.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(n.SelectionRange.from(_e)),!_e.parent)break;tt=_e.range,_e=_e.parent}}return Fe}}class $e{constructor(V,W){this.f=V,this.g=W,this.d=new R.$WO(""),this.e=new Map}async prepareSession(V,W,J){const Z=this.f.getDocument(V),he=n.Position.to(W),be=await this.g.prepareCallHierarchy(Z,he,J);if(!be)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(be)?be.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,be)]}async provideCallsTo(V,W,J){const Z=this.j(V,W);if(!Z)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Z,J);if(he)return he.map(be=>({from:this.h(V,be.from),fromRanges:be.fromRanges.map(Fe=>n.Range.from(Fe))}))}async provideCallsFrom(V,W,J){const Z=this.j(V,W);if(!Z)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Z,J);if(he)return he.map(be=>({to:this.h(V,be.to),fromRanges:be.fromRanges.map(Fe=>n.Range.from(Fe))}))}releaseSession(V){this.e.delete(V)}h(V,W){const J=this.e.get(V),Z=n.CallHierarchyItem.from(W,V,J.size.toString(36));return J.set(Z._itemId,W),Z}j(V,W){return this.e.get(V)?.get(W)}}class we{constructor(V,W){this.f=V,this.g=W,this.d=new R.$WO(""),this.e=new Map}async prepareSession(V,W,J){const Z=this.f.getDocument(V),he=n.Position.to(W),be=await this.g.prepareTypeHierarchy(Z,he,J);if(!be)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(be)?be.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,be)]}async provideSupertypes(V,W,J){const Z=this.j(V,W);if(!Z)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Z,J);if(he)return he.map(be=>this.h(V,be))}async provideSubtypes(V,W,J){const Z=this.j(V,W);if(!Z)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Z,J);if(he)return he.map(be=>this.h(V,be))}releaseSession(V){this.e.delete(V)}h(V,W){const J=this.e.get(V),Z=n.TypeHierarchyItem.from(W,V,J.size.toString(36));return J.set(Z._itemId,W),Z}j(V,W){return this.e.get(V)?.get(W)}}class Ne{constructor(V,W,J,Z,he){this.e=V,this.f=W,this.g=J,this.h=Z,this.j=he,this.d=new t.$dmc("DocumentDropEdit")}async provideDocumentOnDropEdits(V,W,J,Z,he){const be=this.f.getDocument(W),Fe=n.Position.to(J),Ve=n.DataTransfer.toDataTransfer(Z,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,V,nt)).buffer),Qe=await this.g.provideDocumentDropEdits(be,Fe,Ve,he);if(!Qe)return;const tt=(0,l.$2b)(Qe),_e=this.d.add(tt);return tt.map((nt,it)=>({_cacheId:[_e,it],title:nt.title??(0,c.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(V,W){const[J,Z]=V,he=this.d.get(J,Z);if(!he||!this.g.resolveDocumentDropEdit)return{};const be=await this.g.resolveDocumentDropEdit(he,W)??he;return{additionalEdit:be.additionalEdit?n.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}releaseDropEdits(V){this.d.delete(V)}}class Se{constructor(V,W){this.d=V,this.e=W}async provideMappedEdits(V,W,J,Z){const he=p.URI.revive(V),be=this.d.getDocument(he),Fe=J.documents.map(tt=>tt.map(_e=>({uri:p.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(nt=>n.Range.to(nt))}))),Ve={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(be,W,Ve,Z);return Qe?n.WorkspaceEdit.from(Qe):null}}class Ie{constructor(V,W){this.adapter=V,this.extension=W}}class Ae{static{this.d=0}constructor(V,W,J,Z,he,be,Fe,Ve){this.g=W,this.h=J,this.j=Z,this.k=he,this.l=be,this.m=Fe,this.n=Ve,this.f=new Map,this.e=V.getProxy(f.$nM.MainThreadLanguageFeatures)}o(V,W){return n.DocumentSelector.from(V,this.g,W)}p(V){return new a.$pM(()=>{this.f.delete(V),this.e.$unregister(V)})}q(){return Ae.d++}async s(V,W,J,Z,he,be=!1){const Fe=this.f.get(V);if(!Fe||!(Fe.adapter instanceof W))return Z;const Ve=Date.now();be||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Qe=J(Fe.adapter,Fe.extension);return Promise.resolve(Qe).catch(tt=>{(0,A.$4)(tt)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Fe.extension.identifier,tt))}).finally(()=>{be||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),M.CancellationToken.isCancellationToken(he)?(0,L.$ph)(Qe,he):Qe}t(V,W){const J=this.q();return this.f.set(J,new Ie(V,W)),J}static u(V){return V.displayName||V.name}static w(V){return V.identifier.value}registerDocumentSymbolProvider(V,W,J,Z){const he=this.t(new o(this.h,J),V),be=Z&&Z.label||Ae.u(V);return this.e.$registerDocumentSymbolProvider(he,this.o(W,V),be),this.p(he)}$provideDocumentSymbols(V,W,J){return this.s(V,o,Z=>Z.provideDocumentSymbols(p.URI.revive(W),J),void 0,J)}registerCodeLensProvider(V,W,J){const Z=this.q(),he=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new Ie(new s(this.h,this.j.converter,J,V,this.n,this.l),V)),this.e.$registerCodeLensSupport(Z,this.o(W,V),he);let be=this.p(Z);if(he!==void 0){const Fe=J.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(he));be=a.$pM.from(be,Fe)}return be}$provideCodeLenses(V,W,J){return this.s(V,s,Z=>Z.provideCodeLenses(p.URI.revive(W),J),void 0,J)}$resolveCodeLens(V,W,J){return this.s(V,s,Z=>Z.resolveCodeLens(W,J),void 0,void 0)}$releaseCodeLenses(V,W){this.s(V,s,J=>Promise.resolve(J.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(V,W,J){const Z=this.t(new g(this.h,J),V);return this.e.$registerDefinitionSupport(Z,this.o(W,V)),this.p(Z)}$provideDefinition(V,W,J,Z){return this.s(V,g,he=>he.provideDefinition(p.URI.revive(W),J,Z),[],Z)}registerDeclarationProvider(V,W,J){const Z=this.t(new b(this.h,J),V);return this.e.$registerDeclarationSupport(Z,this.o(W,V)),this.p(Z)}$provideDeclaration(V,W,J,Z){return this.s(V,b,he=>he.provideDeclaration(p.URI.revive(W),J,Z),[],Z)}registerImplementationProvider(V,W,J){const Z=this.t(new S(this.h,J),V);return this.e.$registerImplementationSupport(Z,this.o(W,V)),this.p(Z)}$provideImplementation(V,W,J,Z){return this.s(V,S,he=>he.provideImplementation(p.URI.revive(W),J,Z),[],Z)}registerTypeDefinitionProvider(V,W,J){const Z=this.t(new m(this.h,J),V);return this.e.$registerTypeDefinitionSupport(Z,this.o(W,V)),this.p(Z)}$provideTypeDefinition(V,W,J,Z){return this.s(V,m,he=>he.provideTypeDefinition(p.URI.revive(W),J,Z),[],Z)}registerHoverProvider(V,W,J,Z){const he=this.t(new y(this.h,J),V);return this.e.$registerHoverProvider(he,this.o(W,V)),this.p(he)}$provideHover(V,W,J,Z,he){return this.s(V,y,be=>be.provideHover(p.URI.revive(W),J,Z,he),void 0,he)}$releaseHover(V,W){this.s(V,y,J=>Promise.resolve(J.releaseHover(W)),void 0,void 0)}registerEvaluatableExpressionProvider(V,W,J,Z){const he=this.t(new D(this.h,J),V);return this.e.$registerEvaluatableExpressionProvider(he,this.o(W,V)),this.p(he)}$provideEvaluatableExpression(V,W,J,Z){return this.s(V,D,he=>he.provideEvaluatableExpression(p.URI.revive(W),J,Z),void 0,Z)}registerInlineValuesProvider(V,W,J,Z){const he=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new C(this.h,J),V);this.e.$registerInlineValuesProvider(be,this.o(W,V),he);let Fe=this.p(be);if(he!==void 0){const Ve=J.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(he));Fe=a.$pM.from(Fe,Ve)}return Fe}$provideInlineValues(V,W,J,Z,he){return this.s(V,C,be=>be.provideInlineValues(p.URI.revive(W),J,Z,he),void 0,he)}registerDocumentHighlightProvider(V,W,J){const Z=this.t(new O(this.h,J),V);return this.e.$registerDocumentHighlightProvider(Z,this.o(W,V)),this.p(Z)}registerMultiDocumentHighlightProvider(V,W,J){const Z=this.t(new z(this.h,J),V);return this.e.$registerMultiDocumentHighlightProvider(Z,this.o(W,V)),this.p(Z)}$provideDocumentHighlights(V,W,J,Z){return this.s(V,O,he=>he.provideDocumentHighlights(p.URI.revive(W),J,Z),void 0,Z)}$provideMultiDocumentHighlights(V,W,J,Z,he){return this.s(V,z,be=>be.provideMultiDocumentHighlights(p.URI.revive(W),J,Z.map(Fe=>p.URI.revive(Fe)),he),void 0,he)}registerLinkedEditingRangeProvider(V,W,J){const Z=this.t(new T(this.h,J),V);return this.e.$registerLinkedEditingRangeProvider(Z,this.o(W,V)),this.p(Z)}$provideLinkedEditingRanges(V,W,J,Z){return this.s(V,T,async he=>{const be=await he.provideLinkedEditingRanges(p.URI.revive(W),J,Z);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?Ae.y(be.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(V,W,J){const Z=this.t(new F(this.h,J),V);return this.e.$registerReferenceSupport(Z,this.o(W,V)),this.p(Z)}$provideReferences(V,W,J,Z,he){return this.s(V,F,be=>be.provideReferences(p.URI.revive(W),J,Z,he),void 0,he)}registerCodeActionProvider(V,W,J,Z){const he=new w.$Tc,be=this.t(new N(this.h,this.j.converter,this.k,J,this.l,V,this.m),V);return this.e.$registerCodeActionSupport(be,this.o(W,V),{providedKinds:Z?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:Z?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,he)}))},Ae.u(V),Ae.w(V),!!J.resolveCodeAction),he.add(this.p(be)),he}$provideCodeActions(V,W,J,Z,he){return this.s(V,N,be=>be.provideCodeActions(p.URI.revive(W),J,Z,he),void 0,he)}$resolveCodeAction(V,W,J){return this.s(V,N,Z=>Z.resolveCodeAction(W,J),{},void 0)}$releaseCodeActions(V,W){this.s(V,N,J=>Promise.resolve(J.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(V,W,J){const Z=this.t(new B(this.h,J),V);return this.e.$registerDocumentFormattingSupport(Z,this.o(W,V),V.identifier,V.displayName||V.name),this.p(Z)}$provideDocumentFormattingEdits(V,W,J,Z){return this.s(V,B,he=>he.provideDocumentFormattingEdits(p.URI.revive(W),J,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(V,W,J){const Z=typeof J.provideDocumentRangesFormattingEdits=="function",he=this.t(new X(this.h,J),V);return this.e.$registerRangeFormattingSupport(he,this.o(W,V),V.identifier,V.displayName||V.name,Z),this.p(he)}$provideDocumentRangeFormattingEdits(V,W,J,Z,he){return this.s(V,X,be=>be.provideDocumentRangeFormattingEdits(p.URI.revive(W),J,Z,he),void 0,he)}$provideDocumentRangesFormattingEdits(V,W,J,Z,he){return this.s(V,X,be=>be.provideDocumentRangesFormattingEdits(p.URI.revive(W),J,Z,he),void 0,he)}registerOnTypeFormattingEditProvider(V,W,J,Z){const he=this.t(new ie(this.h,J),V);return this.e.$registerOnTypeFormattingSupport(he,this.o(W,V),Z,V.identifier),this.p(he)}$provideOnTypeFormattingEdits(V,W,J,Z,he,be){return this.s(V,ie,Fe=>Fe.provideOnTypeFormattingEdits(p.URI.revive(W),J,Z,he,be),void 0,be)}registerWorkspaceSymbolProvider(V,W){const J=this.t(new H(W,this.l),V);return this.e.$registerNavigateTypeSupport(J,typeof W.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(V,W,J){return this.s(V,H,Z=>Z.provideWorkspaceSymbols(W,J),{symbols:[]},J)}$resolveWorkspaceSymbol(V,W,J){return this.s(V,H,Z=>Z.resolveWorkspaceSymbol(W,J),void 0,void 0)}$releaseWorkspaceSymbols(V,W){this.s(V,H,J=>J.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(V,W,J){const Z=this.t(new K(this.h,J,this.l),V);return this.e.$registerRenameSupport(Z,this.o(W,V),K.supportsResolving(J)),this.p(Z)}$provideRenameEdits(V,W,J,Z,he){return this.s(V,K,be=>be.provideRenameEdits(p.URI.revive(W),J,Z,he),void 0,he)}$resolveRenameLocation(V,W,J,Z){return this.s(V,K,he=>he.resolveRenameLocation(p.URI.revive(W),J,Z),void 0,Z)}registerNewSymbolNamesProvider(V,W,J){const Z=this.t(new x(this.h,J,this.l),V);return this.e.$registerNewSymbolNamesProvider(Z,this.o(W,V)),this.p(Z)}$supportsAutomaticNewSymbolNamesTriggerKind(V){return this.s(V,x,W=>W.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(V,W,J,Z,he){return this.s(V,x,be=>be.provideNewSymbolNames(p.URI.revive(W),J,Z,he),void 0,he)}registerDocumentSemanticTokensProvider(V,W,J,Z){const he=this.t(new ge(this.h,J),V),be=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(W,V),Z,be);let Fe=this.p(he);if(be){const Ve=J.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(be));Fe=a.$pM.from(Fe,Ve)}return Fe}$provideDocumentSemanticTokens(V,W,J,Z){return this.s(V,ge,he=>he.provideDocumentSemanticTokens(p.URI.revive(W),J,Z),null,Z)}$releaseDocumentSemanticTokens(V,W){this.s(V,ge,J=>J.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(V,W,J,Z){const he=this.t(new oe(this.h,J),V);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(W,V),Z),this.p(he)}$provideDocumentRangeSemanticTokens(V,W,J,Z){return this.s(V,oe,he=>he.provideDocumentRangeSemanticTokens(p.URI.revive(W),J,Z),null,Z)}registerCompletionItemProvider(V,W,J,Z){const he=this.t(new Pe(this.h,this.j.converter,J,this.m,V),V);return this.e.$registerCompletionsProvider(he,this.o(W,V),Z,Pe.supportsResolving(J),V.identifier),this.p(he)}$provideCompletionItems(V,W,J,Z,he){return this.s(V,Pe,be=>be.provideCompletionItems(p.URI.revive(W),J,Z,he),void 0,he)}$resolveCompletionItem(V,W,J){return this.s(V,Pe,Z=>Z.resolveCompletionItem(W,J),void 0,J)}$releaseCompletionItems(V,W){this.s(V,Pe,J=>J.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(V,W,J,Z){const he=new U(V,this.h,J,this.j.converter),be=this.t(he,V);return this.e.$registerInlineCompletionsSupport(be,this.o(W,V),he.supportsHandleEvents,i.$Vm.toKey(V.identifier.value),Z?.yieldTo?.map(Fe=>i.$Vm.toKey(Fe))||[]),this.p(be)}$provideInlineCompletions(V,W,J,Z,he){return this.s(V,me,be=>be.provideInlineCompletions(p.URI.revive(W),J,Z,he),void 0,he)}$handleInlineCompletionDidShow(V,W,J,Z){this.s(V,me,async he=>{he.handleDidShowCompletionItem(W,J,Z)},void 0,void 0)}$handleInlineCompletionPartialAccept(V,W,J,Z,he){this.s(V,me,async be=>{be.handlePartialAccept(W,J,Z,he)},void 0,void 0)}$freeInlineCompletionsList(V,W){this.s(V,me,async J=>{J.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(V,W,J){const Z=new Y(V,this.h,J,this.j.converter),he=this.t(Z,V);return this.e.$registerInlineEditProvider(he,this.o(W,V),V.identifier),this.p(he)}$provideInlineEdit(V,W,J,Z){return this.s(V,Y,he=>he.provideInlineEdits(p.URI.revive(W),J,Z),void 0,Z)}$freeInlineEdit(V,W){this.s(V,Y,async J=>{J.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(V,W,J,Z){const he=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,be=this.t(new ce(this.h,J),V);return this.e.$registerSignatureHelpProvider(be,this.o(W,V),he),this.p(be)}$provideSignatureHelp(V,W,J,Z,he){return this.s(V,ce,be=>be.provideSignatureHelp(p.URI.revive(W),J,Z,he),void 0,he)}$releaseSignatureHelp(V,W){this.s(V,ce,J=>J.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(V,W,J){const Z=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new ae(this.h,this.j.converter,J,this.l,V),V);this.e.$registerInlayHintsProvider(he,this.o(W,V),typeof J.resolveInlayHint=="function",Z,Ae.u(V));let be=this.p(he);if(Z!==void 0){const Fe=J.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(Z));be=a.$pM.from(be,Fe)}return be}$provideInlayHints(V,W,J,Z){return this.s(V,ae,he=>he.provideInlayHints(p.URI.revive(W),J,Z),void 0,Z)}$resolveInlayHint(V,W,J){return this.s(V,ae,Z=>Z.resolveInlayHint(W,J),void 0,J)}$releaseInlayHints(V,W){this.s(V,ae,J=>J.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(V,W,J){const Z=this.t(new se(this.h,J),V);return this.e.$registerDocumentLinkProvider(Z,this.o(W,V),typeof J.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(V,W,J){return this.s(V,se,Z=>Z.provideLinks(p.URI.revive(W),J),void 0,J,W.scheme==="output")}$resolveDocumentLink(V,W,J){return this.s(V,se,Z=>Z.resolveLink(W,J),void 0,void 0,!0)}$releaseDocumentLinks(V,W){this.s(V,se,J=>J.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(V,W,J){const Z=this.t(new ue(this.h,J),V);return this.e.$registerDocumentColorProvider(Z,this.o(W,V)),this.p(Z)}$provideDocumentColors(V,W,J){return this.s(V,ue,Z=>Z.provideColors(p.URI.revive(W),J),[],J)}$provideColorPresentations(V,W,J,Z){return this.s(V,ue,he=>he.provideColorPresentations(p.URI.revive(W),J,Z),void 0,Z)}registerFoldingRangeProvider(V,W,J){const Z=this.q(),he=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new Ie(new Q(this.h,J),V)),this.e.$registerFoldingRangeProvider(Z,this.o(W,V),V.identifier,he);let be=this.p(Z);if(he!==void 0){const Fe=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));be=a.$pM.from(be,Fe)}return be}$provideFoldingRanges(V,W,J,Z){return this.s(V,Q,he=>he.provideFoldingRanges(p.URI.revive(W),J,Z),void 0,Z)}registerSelectionRangeProvider(V,W,J){const Z=this.t(new re(this.h,J,this.l),V);return this.e.$registerSelectionRangeProvider(Z,this.o(W,V)),this.p(Z)}$provideSelectionRanges(V,W,J,Z){return this.s(V,re,he=>he.provideSelectionRanges(p.URI.revive(W),J,Z),[],Z)}registerCallHierarchyProvider(V,W,J){const Z=this.t(new $e(this.h,J),V);return this.e.$registerCallHierarchyProvider(Z,this.o(W,V)),this.p(Z)}$prepareCallHierarchy(V,W,J,Z){return this.s(V,$e,he=>Promise.resolve(he.prepareSession(p.URI.revive(W),J,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(V,W,J,Z){return this.s(V,$e,he=>he.provideCallsTo(W,J,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(V,W,J,Z){return this.s(V,$e,he=>he.provideCallsFrom(W,J,Z),void 0,Z)}$releaseCallHierarchy(V,W){this.s(V,$e,J=>Promise.resolve(J.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(V,W,J){const Z=this.t(new we(this.h,J),V);return this.e.$registerTypeHierarchyProvider(Z,this.o(W,V)),this.p(Z)}$prepareTypeHierarchy(V,W,J,Z){return this.s(V,we,he=>Promise.resolve(he.prepareSession(p.URI.revive(W),J,Z)),void 0,Z)}$provideTypeHierarchySupertypes(V,W,J,Z){return this.s(V,we,he=>he.provideSupertypes(W,J,Z),void 0,Z)}$provideTypeHierarchySubtypes(V,W,J,Z){return this.s(V,we,he=>he.provideSubtypes(W,J,Z),void 0,Z)}$releaseTypeHierarchy(V,W){this.s(V,we,J=>Promise.resolve(J.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(V,W,J,Z){const he=this.q();return this.f.set(he,new Ie(new Ne(this.e,this.h,J,he,V),V)),this.e.$registerDocumentOnDropEditProvider(he,this.o(W,V),(0,r.$NG)(V,"documentPaste")&&Z?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:Z.dropMimeTypes}:void 0),this.p(he)}$provideDocumentOnDropEdits(V,W,J,Z,he,be){return this.s(V,Ne,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(W,p.URI.revive(J),Z,he,be)),void 0,void 0)}$resolveDropEdit(V,W,J){return this.s(V,Ne,Z=>Z.resolveDropEdit(W,J),{},void 0)}$releaseDropEdits(V,W){this.s(V,Ne,J=>Promise.resolve(J.releaseDropEdits(W)),void 0,void 0)}registerMappedEditsProvider(V,W,J){const Z=this.t(new Se(this.h,J),V);return this.e.$registerMappedEditsProvider(Z,this.o(W,V)),this.p(Z)}$provideMappedEdits(V,W,J,Z,he){return this.s(V,Se,be=>Promise.resolve(be.provideMappedEdits(W,J,Z,he)),null,he)}registerDocumentPasteEditProvider(V,W,J,Z){const he=this.q();return this.f.set(he,new Ie(new j(this.e,this.h,J,he,V),V)),this.e.$registerPasteEditProvider(he,this.o(W,V),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:Z.providedPasteEditKinds?.map(be=>be.value),copyMimeTypes:Z.copyMimeTypes,pasteMimeTypes:Z.pasteMimeTypes}),this.p(he)}$prepareDocumentPaste(V,W,J,Z,he){return this.s(V,j,be=>be.prepareDocumentPaste(p.URI.revive(W),J,Z,he),void 0,he)}$providePasteEdits(V,W,J,Z,he,be,Fe){return this.s(V,j,Ve=>Ve.providePasteEdits(W,p.URI.revive(J),Z,he,be,Fe),void 0,Fe)}$resolvePasteEdit(V,W,J){return this.s(V,j,Z=>Z.resolvePasteEdit(W,J),{},void 0)}$releasePasteEdits(V,W){this.s(V,j,J=>Promise.resolve(J.releasePasteEdits(W)),void 0,void 0)}static y(V){return{pattern:V.source,flags:V.flags}}static z(V){return{decreaseIndentPattern:Ae.y(V.decreaseIndentPattern),increaseIndentPattern:Ae.y(V.increaseIndentPattern),indentNextLinePattern:V.indentNextLinePattern?Ae.y(V.indentNextLinePattern):void 0,unIndentedLinePattern:V.unIndentedLinePattern?Ae.y(V.unIndentedLinePattern):void 0}}static B(V){return{beforeText:Ae.y(V.beforeText),afterText:V.afterText?Ae.y(V.afterText):void 0,previousLineText:V.previousLineText?Ae.y(V.previousLineText):void 0,action:V.action}}static C(V){return V.map(Ae.B)}static D(V){return{open:V.open,close:V.close,notIn:V.notIn?V.notIn.map(W=>a.SyntaxTokenType.toString(W)):void 0}}static E(V){return V.map(Ae.D)}setLanguageConfiguration(V,W,J){const{wordPattern:Z}=J;if(Z&&(0,I.$nf)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor(W,Z):this.h.setWordDefinitionFor(W,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",V,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",V,"Do not use.");const he=this.q(),be={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ae.y(J.wordPattern):void 0,indentationRules:J.indentationRules?Ae.z(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ae.C(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ae.E(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(he,W,be),this.p(he)}$setWordDefinitions(V){for(const W of V)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$nmc=Ae}),define(ke[122],De([1,0,7,21,13,4,39,3,227,25,5,11,109,6,121,20,17,8,146,26]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=e.$7mc=void 0,e.$7mc=(0,I.$Ai)("IExtHostLanguageModels");class r{constructor(s,u){this.option=s,this.stream=new l.$4h,this.stream=u??new l.$4h}}class t{constructor(){this.a=new Map,this.b=new l.$4h,this.c=!1,this.d=!1;const s=this;this.apiObject={text:s.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,s]of this.a)yield s.stream;else yield this.b}handleFragment(s){if(this.c)return;this.d=!0;let u=this.a.get(s.index);u||(this.a.size===0?u=new r(s.index,this.b):u=new r(s.index),this.a.set(s.index,u)),u.stream.emitOne(s.part)}get isStreaming(){return this.d}reject(s){this.c=!0;for(const u of this.f())u.reject(s)}resolve(){this.c=!0;for(const s of this.f())s.resolve()}}let f=class{static{a=this}static{this.a=1}constructor(s,u,g){this.j=u,this.k=g,this.c=new A.$he,this.d=new A.$he,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new k.$Xm,this.i=new Map,this.r=new Set,this.b=s.getProxy(E.$nM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(s,u,g,b){const S=a.a++;this.f.set(S,{extension:s.identifier,provider:g,languageModelId:u});let m;b.auth&&(m={providerLabel:s.displayName||s.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this.b.$registerLanguageModelProvider(S,`${k.$Vm.toKey(s.identifier)}/${S}/${u}`,{extension:s.identifier,id:u,vendor:b.vendor??k.$Vm.toKey(s.identifier),name:b.name??"",family:b.family??"",version:b.version,maxInputTokens:b.maxInputTokens??b.tokens,maxOutputTokens:b.maxOutputTokens??b.tokens,auth:m,targetExtensions:b.extensions});const y=g.onDidReceiveLanguageModelResponse2?.(({extensionId:D,participant:C,tokenCount:O})=>{this.b.$whenLanguageModelChatRequestMade(u,new k.$Vm(D),C,O)});return(0,w.$Sc)(()=>{this.f.delete(S),this.b.$unregisterProvider(S),y?.dispose()})}async $provideLanguageModelResponse(s,u,g,b,S,m){const y=this.f.get(s);if(!y)return;const D=new p.$jw(async C=>{if(m.isCancellationRequested){this.j.warn(`[CHAT](${y.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(u,{index:C.index,part:C.part})});return y.provider.provideLanguageModelResponse(b.map(h.LanguageModelChatMessage.to),S,k.$Vm.toKey(g),D,m)}$provideTokenLength(s,u,g){const b=this.f.get(s);return b?Promise.resolve(b.provider.provideTokenCount(u,g)):Promise.resolve(0)}$acceptChatModelMetadata(s){if(s.added)for(const{identifier:u,metadata:g}of s.added)this.g.set(u,{metadata:g,apiObjects:new k.$Xm});if(s.removed)for(const u of s.removed){this.g.delete(u);for(const[g,b]of this.i)b.languageModelId===u&&(b.res.reject(new M.$5),this.i.delete(g))}s.added?.forEach(u=>this.p(u.metadata)),this.d.fire(void 0)}async selectLanguageModels(s,u){const g=await this.b.$selectChatModels({...u,extension:s.identifier}),b=[],S=this;for(const m of g){const y=this.g.get(m);if(!y)continue;let D=y.apiObjects.get(s.identifier);D||(D={id:m,vendor:y.metadata.vendor,family:y.metadata.family,version:y.metadata.version,name:y.metadata.name,maxInputTokens:y.metadata.maxInputTokens,countTokens(C,O){if(!S.g.has(m))throw c.$EO.NotFound(m);return S.q(m,C,O??L.CancellationToken.None)},sendRequest(C,O,z){if(!S.g.has(m))throw c.$EO.NotFound(m);return S.l(s,m,C,O??{},z??L.CancellationToken.None)}},Object.freeze(D),y.apiObjects.set(s.identifier,D)),b.push(D)}return b}async l(s,u,g,b,S){const m=this.m(s,g),y=s.identifier,D=this.g.get(u)?.metadata;if(!D||!this.g.has(u))throw c.$EO.NotFound(`Language model '${u}' is unknown.`);if(this.o(y,D)&&(!await this.n(s,{identifier:D.extension,displayName:D.auth.providerLabel},b.justification,!1)||!this.h.get(y)?.has(D.extension)))throw c.$EO.NoPermissions(`Language model '${u}' cannot be used by '${y.value}'.`);const C=Math.random()*1e6|0,O=this.b.$fetchResponse(y,u,C,m,b.modelOptions??{},S),z=new l.$zh,T=new t;this.i.set(C,{languageModelId:u,res:T});let F;if(O.catch(N=>{z.isOpen()?T.reject(N):F=N}).finally(()=>{this.i.delete(C),T.resolve(),z.open()}),await z.wait(),F)throw F.name===c.$EO.name?F:new c.$EO(`Language model '${u}' errored, check cause for more details`,"Unknown",F);return T.apiObject}m(s,u){const g=[];for(const b of u)b.role===c.LanguageModelChatMessageRole.System&&(0,n.$OG)(s,"languageModelSystem"),g.push(h.LanguageModelChatMessage.from(b));return g}async $handleResponseFragment(s,u){const g=this.i.get(s);g&&g.res.handleFragment(u)}async n(s,u,g,b){const S=i.$pL+u.identifier.value;if(await this.k.getSession(s,S,[],{silent:!0}))return this.$updateModelAccesslist([{from:s.identifier,to:u.identifier,enabled:!0}]),!0;if(b)return!1;try{const y=g?(0,$.localize)(0,null,u.displayName,g):void 0;return await this.k.getSession(s,S,[],{forceNewSession:{detail:y}}),this.$updateModelAccesslist([{from:s.identifier,to:u.identifier,enabled:!0}]),!0}catch{return!1}}o(s,u){return!!u.auth&&!k.$Vm.equals(u.extension,s)}async p(s){for(const u of this.r)try{await this.n(u,{identifier:s.extension,displayName:""},void 0,!0)}catch(g){this.j.error("Fake Auth request failed"),this.j.error(g)}}async q(s,u,g){if(!this.g.get(s))throw c.$EO.NotFound(`Language model '${s}' is unknown.`);const S=R.Iterable.find(this.f.values(),m=>m.languageModelId===s);return S?S.provider.provideTokenCount(u,g):this.b.$countTokens(s,typeof u=="string"?u:h.LanguageModelChatMessage.from(u),g)}$updateModelAccesslist(s){const u=new Array;for(const{from:g,to:b,enabled:S}of s){const m=this.h.get(g)??new k.$Wm;if(m.has(b)!==S){S?m.add(b):m.delete(b),this.h.set(g,m);const D={from:g,to:b};u.push(D),this.c.fire(D)}}}createLanguageModelAccessInformation(s){this.r.add(s);const u=this,g=A.Event.signal(A.Event.filter(this.c.event,S=>k.$Vm.equals(S.from,s.identifier))),b=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(g,b)},canSendRequest(S){let m;e:for(const[D,C]of u.g)for(const O of C.apiObjects.values())if(O===S){m=C.metadata;break e}if(!m)return;if(!u.o(s.identifier,m))return!0;const y=u.h.get(s.identifier);if(y)return y.has(m.extension)}}}};e.$8mc=f,e.$8mc=f=a=Je([We(0,d.$RO),We(1,P.$7j),We(2,v.$pmc)],f)}),define(ke[345],De([1,0,6,17,8,41,7,3,26]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;class k{constructor(P,p,E,v){this.c=p,this.d=E,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(l.$nM.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,p){await this.a.$changeLanguage(P,p);const E=this.c.getDocumentData(P);if(!E)throw new Error(`document '${P.toString()}' NOT found`);return E.document}async tokenAtPosition(P,p){const E=P.version,v=L.Position.from(p),d=await this.a.$tokensAtPosition(P.uri,v),h={type:M.StandardTokenType.Other,range:P.getWordRangeAtPosition(p)??new M.$rM(p.line,p.character,p.line,p.character)};if(!d)return h;const c={range:L.Range.to(d.range),type:L.TokenType.to(d.type)};return!c.range.contains(p)||E!==P.version?h:c}createLanguageStatusItem(P,p,E){const v=this.f++,d=this.a,h=this.g,c=`${P.identifier.value}/${p}`;if(h.has(c))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);h.add(c);const i={selector:E,id:p,name:P.displayName??P.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const a=new w.$Tc,r=()=>{if(n?.dispose(),!h.has(c)){console.warn(`LanguageStatusItem (${p}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$Ch)(()=>{a.clear(),this.a.$setLanguageStatus(v,{id:c,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:L.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===M.LanguageStatusSeverity.Error?A.default.Error:i.severity===M.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:i.command&&this.d.toInternal(i.command,a),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){a.dispose(),n?.dispose(),d.$removeLanguageStatus(v),h.delete(c)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,r()},get selector(){return i.selector},set selector(f){i.selector=f,r()},get text(){return i.text},set text(f){i.text=f,r()},set text2(f){(0,$.$OG)(P,"languageStatusText"),i.text=f,r()},get text2(){return(0,$.$OG)(P,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,r()},get severity(){return i.severity},set severity(f){i.severity=f,r()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,r()},get command(){return i.command},set command(f){i.command=f,r()},get busy(){return i.busy},set busy(f){i.busy=f,r()}};return r(),t}}e.$Mnc=k}),define(ke[346],De([1,0,15,2,17,8,120]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=e.$ync=void 0;class w{constructor(P,p,E,v){this.start=P,this.deletedCount=p,this.deletedItems=E,this.items=v}asApiEvent(){return{range:new A.$RN(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(P){return{EOL:P.eol,lines:P.source,languageId:P.language,uri:P.uri,isDirty:!1,versionId:1}}constructor(P,p,E){this.notebook=P,this.h=p,this.j=E,this.handle=E.handle,this.uri=L.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(M.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(E)}return this.f}setOutputs(P){this.a=P.map(M.NotebookCellOutput.to)}setOutputItems(P,p,E){const v=E.map(M.NotebookCellOutputItem.to),d=this.a.find(h=>h.id===P);if(d&&(p||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(h=>R.$jK(h.mime)))){const h=new Map,c=[];d.items.forEach(i=>{let n;h.has(i.mime)?n=h.get(i.mime):(n=[],h.set(i.mime,n),c.push(i.mime)),n.push(i.data)}),d.items.length=0,c.forEach(i=>{const n=R.$kK(h.get(i));d.items.push({mime:i,data:n.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$ync=$;class k{static{this.a=0}constructor(P,p,E,v,d){this.k=P,this.l=p,this.m=E,this.uri=v,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,p={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===l.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(E){return E=P.n(E),P.b[E].apiCell},getCells(E){return(E?P.p(E):P.b).map(d=>d.apiCell)},save(){return P.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,p,E){this.g=P.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:E});const v={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},d=[];for(const c of P.rawEvents)c.kind===R.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,v.contentChanges):c.kind===R.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,v.contentChanges):c.kind===R.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),d.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),d.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),d.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===R.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),d.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),d.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const h=new Map;for(let c=0;c<d.length;c++){const i=d[c],n=h.get(i.cell);if(n===void 0){const a=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});h.set(i.cell,a-1)}else v.cellChanges[n]={...v.cellChanges[n],...i}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let p=P.start|0,E=P.end|0;return p<0&&(p=0),E>this.b.length&&(E=this.b.length),P.with({start:p,end:E})}p(P){P=this.o(P);const p=[];for(let E=P.start;E<P.end;E++)p.push(this.b[E]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,p,E){if(this.j)return;const v=[],d=[],h=[];if(P.reverse().forEach(c=>{const n=c[2].map(t=>{const f=new $(this,this.l,t);return p||d.push($.asModelAddData(t)),f}),a=new w(c[0],c[1],[],n),r=this.b.splice(c[0],c[1],...n);for(const t of r)h.push(t.uri),a.deletedItems.push(t.apiCell);v.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:h}),E)for(const c of v)E.push(c.asApiEvent())}s(P,p,E,v){const d=this.b.splice(P,p);this.b.splice(E,0,...d);const h=[new w(P,p,d.map(c=>c.apiCell),[]),new w(E,0,[],d)];for(const c of h)v.push(c.asApiEvent())}t(P,p){this.b[P].setOutputs(p)}u(P,p,E,v){this.b[P].setOutputItems(p,E,v)}v(P,p){const E=this.b[P];E.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(E.uri,p)}w(P,p){const E=this.b[P];E.apiCell.mime=p}x(P,p){this.b[P].setMetadata(p)}y(P,p){this.b[P].setInternalMetadata(p)}getCellFromApiCell(P){return this.b.find(p=>p.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(p=>p.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$znc=k}),define(ke[347],De([1,0,4,2,17,8,48]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0;class w{constructor(k,I,P,p={timeout:1500,errors:3}){this.b=k,this.c=I,this.d=P,this.f=p,this.a=new l.$je}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(I,P,p)=>{const E=function(d){I.call(P,d)};return E.extension=k,this.a.event(E,void 0,p)}}async $participateInSave(k,I,P){const p=L.URI.revive(k),E=this.c.getNotebookDocument(p);if(!E)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:M.TextDocumentSaveReason.to(I)},P,async(h,c)=>{const i=Date.now(),n=await await Promise.resolve(h);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!P.isCancellationRequested&&n&&(n instanceof A.$zM?v.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(v.length===0)return!0;const d={edits:[]};for(const h of v){const{edits:c}=M.WorkspaceEdit.from(h);d.edits=d.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new R.$Hw(d))}}e.$Onc=w}),define(ke[154],De([1,0,13,17,8]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,$,k,I,P,p){this.id=w,this.f=$,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=I,this.c=p}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection($){this.selections=[$]},get selections(){return w.a},set selections($){if(!Array.isArray($)||!$.every(M.$RN.isNotebookRange))throw(0,l.$7)("selections");w.a=$,w.g($)},get visibleRanges(){return w.b},revealRange($,k){w.f.$tryRevealRange(w.id,L.NotebookRange.from($),k??M.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(L.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$Anc=A}),define(ke[348],De([1,0,4,11,17]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=void 0;let A=class{constructor(w,$){this.c=w,this.d=$,this.a=new l.$he,this.b=new l.$he,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,$);const k=this.d.getEditorById(w);$.visibleRanges&&k._acceptVisibleRanges($.visibleRanges.ranges.map(M.NotebookRange.to)),$.selections&&k._acceptSelections($.selections.selections.map(M.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const $ in w)this.d.getEditorById($)._acceptViewColumn(M.ViewColumn.to(w[$]))}};e.$Qnc=A,e.$Qnc=A=Je([We(0,L.$7j)],A)}),define(ke[349],De([1,0,4,6,154]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=void 0;class A{constructor(w,$){this.c=$,this.a=new Map,this.b=w.getProxy(L.$nM.MainThreadNotebookRenderers)}$postRendererMessage(w,$,k){const I=this.c.getEditorById(w);this.a.get($)?.fire({editor:I.apiEditor,message:k})}createRendererMessaging(w,$){if(!w.contributes?.notebookRenderer?.some(I=>I.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(I,P,p)=>this.d($).event(I,P,p),postMessage:(I,P)=>{M.$Anc.apiEditorsToExtHost.has(I)&&([I,P]=[P,I]);const p=P&&M.$Anc.apiEditorsToExtHost.get(P);return this.b.$postMessage(p?.id,$,I)}}}d(w){let $=this.a.get(w);return $||($=new l.$he({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(w)}}),this.a.set(w,$),$)}}e.$Tnc=A}),define(ke[350],De([1,0,17,109,21,57,13]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;class w{constructor(P){this.b=0,this.c=new Map,this.a=P}async withProgress(P,p,E){const v=this.b++,{title:d,location:h,cancellable:c}=p,i={label:P.displayName||P.name,id:P.identifier.value};return this.a.$startProgress(v,{location:l.ProgressLocation.from(h),title:d,source:i,cancellable:c},P.isUnderDevelopment?void 0:P.identifier.value).catch(R.$2),this.d(v,E,!!c)}d(P,p,E){let v;E&&(v=new M.$se,this.c.set(P,v));const d=c=>{this.a.$progressEnd(c),this.c.delete(c),v?.dispose()};let h;try{h=p(new k(this.a,P),E&&v?v.token:M.CancellationToken.None)}catch(c){throw d(P),c}return h.then(c=>d(P),c=>d(P)),h}$acceptProgressCanceled(P){const p=this.c.get(P);p&&(p.cancel(),this.c.delete(P))}}e.$Xnc=w;function $(I,P){return I.message=P.message,typeof P.increment=="number"&&(typeof I.increment=="number"?I.increment+=P.increment:I.increment=P.increment),I}class k extends L.$jw{constructor(P,p){super(E=>this.throttledReport(E)),this.c=P,this.d=p}throttledReport(P){this.c.$progressReport(this.d,P)}}Je([(0,A.$7h)(100,(I,P)=>$(I,P),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ke[351],De([1,0,2,6,7,17]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=void 0;class R{static{this.a=0}constructor($,k){this.d=k,this.c=new Map,this.b=$.getProxy(L.$nM.MainThreadQuickDiff)}$provideOriginalResource($,k,I){const P=l.URI.revive(k),p=this.c.get($);return p?(0,M.$sh)(()=>p.provideOriginalResource(P,I)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider($,k,I,P){const p=R.a++;return this.c.set(p,k),this.b.$registerQuickDiffProvider(p,A.DocumentSelector.from($,this.d),I,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Ync=R}),define(ke[352],De([1,0,21,4,3,6,2,8,13,19,41,50,26,17]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=v;function v(d,h,c){const i=d.getProxy(A.$nM.MainThreadQuickOpen);class n{constructor(b,S){this.e=new Map,this.f=0,this.a=b,this.b=S}showQuickPick(b,S,m,y=l.CancellationToken.None){this.c=void 0;const D=Promise.resolve(S),C=++this.f,O=i.$show(C,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},y),z={},T=O.then(()=>z);return Promise.race([T,D]).then(F=>{if(F===z)return;const N=(0,p.$NG)(b,"quickPickItemTooltip");return D.then(j=>{const B=[];for(let X=0;X<j.length;X++){const ie=j[X];if(typeof ie=="string")B.push({label:ie,handle:X});else if(ie.kind===w.QuickPickItemKind.Separator)B.push({type:"separator",label:ie.label});else{ie.tooltip&&!N&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const H=ie.iconPath?o(ie.iconPath):void 0;B.push({label:ie.label,iconPath:H?.iconPath,iconClass:H?.iconClass,description:ie.description,detail:ie.detail,picked:ie.picked,alwaysShow:ie.alwaysShow,tooltip:N?E.MarkdownString.fromStrict(ie.tooltip):void 0,handle:X})}}return m&&typeof m.onDidSelectItem=="function"&&(this.c=X=>{m.onDidSelectItem(j[X])}),i.$setItems(C,B),O.then(X=>{if(typeof X=="number")return j[X];if(Array.isArray(X))return X.map(ie=>j[ie])})})}).then(void 0,F=>{if(!(0,$.$4)(F))return i.$setError(C,F),Promise.reject(F)})}$onItemSelected(b){this.c?.(b)}showInput(b,S=l.CancellationToken.None){return this.d=b?.validateInput,i.$input(b,typeof this.d=="function",S).then(void 0,m=>{if(!(0,$.$4)(m))return Promise.reject(m)})}async $validateInput(b){if(!this.d)return;const S=await this.d(b);if(!S||typeof S=="string")return S;let m;switch(S.severity){case w.InputBoxValidationSeverity.Info:m=I.default.Info;break;case w.InputBoxValidationSeverity.Warning:m=I.default.Warning;break;case w.InputBoxValidationSeverity.Error:m=I.default.Error;break;default:m=S.message?I.default.Error:I.default.Ignore;break}return{content:S.message,severity:m}}async showWorkspaceFolderPick(b,S=l.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!m)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(D=>D.uri.toString()===m.uri.toString())}createQuickPick(b){const S=new s(b,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(b){const S=new u(b,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(b,S){this.e.get(b)?._fireDidChangeValue(S)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,S){const m=this.e.get(b);m instanceof s&&m._fireDidChangeActive(S)}$onDidChangeSelection(b,S){const m=this.e.get(b);m instanceof s&&m._fireDidChangeSelection(S)}$onDidTriggerButton(b,S){this.e.get(b)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(b,S,m){const y=this.e.get(b);y instanceof s&&y._fireDidTriggerItemButton(S,m)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class a{static{this.a=1}constructor(b,S){this.x=b,this.y=S,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$he,this.q=new L.$he,this.r=new L.$he,this.s=new L.$he,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((S,m)=>{const y=S===w.$ON.Back?-1:m;this.o.set(y,S)}),this.z({buttons:b.map((S,m)=>({...o(S.iconPath),tooltip:S.tooltip,handle:S===w.$ON.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const S=this.o.get(b);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(b){if(!this.v){for(const S of Object.keys(b)){const m=b[S];this.u[S]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function r(g){if(g instanceof w.$mN)return{id:g.id};const b=f(g),S=t(g);return{dark:typeof b=="string"?R.URI.file(b):b,light:typeof S=="string"?R.URI.file(S):S}}function t(g){return typeof g=="object"&&"light"in g?g.light:g}function f(g){return typeof g=="object"&&"dark"in g?g.dark:g}function o(g){const b=r(g);let S,m;return"id"in b?m=P.ThemeIcon.asClassName(b):S=b,{iconPath:S,iconClass:m}}class s extends a{constructor(b,S){super(b.identifier,S),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$he,this.L=[],this.M=new L.$he,this.N=new L.$he,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((y,D)=>{this.C.set(D,y),this.D.set(y,D)});const S=(0,p.$NG)(this.O,"quickPickItemTooltip"),m=[];for(let y=0;y<b.length;y++){const D=b[y];if(D.kind===w.QuickPickItemKind.Separator)m.push({type:"separator",label:D.label});else{D.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=D.iconPath?o(D.iconPath):void 0;m.push({handle:y,label:D.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:S?E.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((O,z)=>({...o(O.iconPath),tooltip:O.tooltip,handle:z}))})}}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(b){const S=(0,k.$Hb)(b.map(m=>this.C.get(m)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(b){const S=(0,k.$Hb)(b.map(m=>this.C.get(m)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(b,S){const m=this.C.get(b);if(!m||!m.buttons||!m.buttons.length)return;const y=m.buttons[S];y&&this.N.fire({button:y,item:m})}}class u extends a{constructor(b,S){super(b.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:I.default.Error}):this.z({validationMessage:b.message,severity:b.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new n(h,c)}}),define(ke[353],De([1,0,2,4,57,3,7,6,19,132,11,25,50,17,26,15,12]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=e.$1nc=void 0;function i(C){return C instanceof l.URI}function n(C,O){return C.scheme===d.Schemas.file&&O.scheme===d.Schemas.file&&h.$k?C.toString()===O.toString():C.toString().toLowerCase()===O.toString().toLowerCase()}function a(C){if(C)return typeof C.iconPath=="string"?l.URI.file(C.iconPath):l.URI.isUri(C.iconPath)||p.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function r(C){if(C.icon){if(l.URI.isUri(C.icon))return C.icon;if(p.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const O=C.icon;return{light:O.light,dark:O.dark}}}else return}function t(C,O){if(!C.iconPath&&!O.iconPath)return 0;if(C.iconPath){if(!O.iconPath)return 1}else return-1;const z=typeof C.iconPath=="string"?C.iconPath:l.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,T=typeof O.iconPath=="string"?O.iconPath:l.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,k.$wr)(z,T)}function f(C,O){let z=0;if(C.strikeThrough!==O.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==O.faded)return C.faded?1:-1;if(C.tooltip!==O.tooltip)return(C.tooltip||"").localeCompare(O.tooltip||"");if(z=t(C,O),z!==0)return z;if(C.light&&O.light)z=t(C.light,O.light);else{if(C.light)return 1;if(O.light)return-1}if(z!==0)return z;if(C.dark&&O.dark)z=t(C.dark,O.dark);else{if(C.dark)return 1;if(O.dark)return-1}return z}function o(C,O){if(C.command!==O.command)return C.command<O.command?-1:1;if(C.title!==O.title)return C.title<O.title?-1:1;if(C.tooltip!==O.tooltip){if(C.tooltip!==void 0&&O.tooltip!==void 0)return C.tooltip<O.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(C.arguments===O.arguments)return 0;if(C.arguments)if(O.arguments){if(C.arguments.length!==O.arguments.length)return C.arguments.length-O.arguments.length}else return 1;else return-1;for(let z=0;z<C.arguments.length;z++){const T=C.arguments[z],F=O.arguments[z];if(T!==F&&!(i(T)&&i(F)&&n(T,F)))return T<F?-1:1}return 0}function s(C,O){let z=(0,k.$wr)(C.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(z!==0)return z;if(C.command&&O.command)z=o(C.command,O.command);else{if(C.command)return 1;if(O.command)return-1}if(z!==0)return z;if(C.decorations&&O.decorations)z=f(C.decorations,O.decorations);else{if(C.decorations)return 1;if(O.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)z=(0,k.$wr)(C.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)z=(0,k.$wr)(C.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return z}function u(C,O){for(let z=0;z<C.length;z++)if(C[z]!==O[z])return!1;return!0}function g(C,O){return C.command===O.command&&C.title===O.title&&C.tooltip===O.tooltip&&(C.arguments&&O.arguments?u(C.arguments,O.arguments):C.arguments===O.arguments)}function b(C,O){return(0,$.$ub)(C,O,g)}class S{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,v.$OG)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,v.$OG)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,v.$OG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,z,T,F,N){this.k=O,this.l=F,this.m=N,this.d="",this.e=new L.$he,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=T}showValidationMessage(O,z){(0,v.$OG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,z)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$1nc=S;class m{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,z,T,F,N,j,B){this.q=O,this.s=z,this.t=T,this.u=F,this.v=N,this.multiDiffEditorEnableViewChanges=j,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$he,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$he,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=m.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,z){const T=this.h.get(O);return T?(0,R.$sh)(()=>this.s.executeCommand(T.command,...T.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(s),T=(0,$.$Db)(this.o,O,s).map(j=>{const B=j.toInsert.map(X=>{const ie=this.e++;this.g.set(ie,X);const H=X.resourceUri;let K;if(X.command)if(X.command.command==="vscode.open"||X.command.command==="vscode.diff"||X.command.command==="vscode.changes"){const ue=new A.$Tc;K=this.s.converter.toInternal(X.command,ue),this.j.set(ie,ue)}else this.h.set(ie,X.command);const x=(0,v.$NG)(this.w,"scmMultiDiffEditor"),_=x?X.multiDiffEditorOriginalUri:void 0,ge=x?X.multiFileDiffEditorModifiedUri:void 0,oe=a(X.decorations),Pe=X.decorations&&a(X.decorations.light)||oe,me=X.decorations&&a(X.decorations.dark)||oe,U=[Pe,me],Y=X.decorations&&X.decorations.tooltip||"",pe=X.decorations&&!!X.decorations.strikeThrough,ce=X.decorations&&!!X.decorations.faded,ae=X.contextValue||"";return{rawResource:[ie,H,U,Y,pe,ce,ae,K,_,ge],handle:ie}});return{start:j.start,deleteCount:j.deleteCount,toInsert:B}}),F=T.map(({start:j,deleteCount:B,toInsert:X})=>[j,B,X.map(ie=>ie.rawResource)]),N=T.reverse();for(const{start:j,deleteCount:B,toInsert:X}of N){const ie=X.map(K=>K.handle),H=this.n.splice(j,B,...ie);for(const K of H)this.g.delete(K),this.h.delete(K),this.j.get(K)?.dispose(),this.j.delete(K)}return this.o=O,F}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let z;(0,v.$NG)(this.x,"quickDiffProvider")&&(z=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:z})}get historyProvider(){return(0,v.$OG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,v.$OG)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new A.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new A.$Tc,this.o=O;const z=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,v.$OG)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,v.$OG)(this.x,"scmActionButton"),this.p.value=new A.$Tc,this.q=O;const z=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(T=>T.map(F=>this.y.converter.toInternal(F,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&b(this.t,O))return;this.s.value=new A.$Tc,this.t=O;const z=(O||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(O,z,T,F,N,j,B){this.x=O,this.y=F,this.z=N,this.A=j,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Vc,this.m=void 0,this.n=new A.$Vc,this.o=void 0,this.p=new A.$Vc,this.s=new A.$Vc,this.t=void 0,this.u=!1,this.v=new L.$he,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=T;const X=l.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new S(O,z,this.#e,this.w,X),this.#e.$registerSourceControl(this.w,N,j,B,X)}createResourceGroup(O,z,T){const F=(0,v.$NG)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,N=new m(this.#e,this.y,this.w,O,z,F,this.x),j=L.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,j),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const O=[],z=[];for(const[T,F]of this.C){F.dispose();const N=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});L.Event.once(T.onDidDispose)(()=>{this.D.delete(T),N.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),O.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const j=T._takeResourceStateSnapshot();j.length>0&&z.push([T.handle,j]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,O,z),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(z=>{const T=z._takeResourceStateSnapshot();T.length!==0&&O.push([z.handle,T])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$6h)(100)],y.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$6h)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{c=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,z,T,F){this.l=z,this.m=T,this.n=F,this.g=new Map,this.h=new P.$Xm,this.j=new L.$he,this.e=O.getProxy(w.$nM.MainThreadSCM),this.f=O.getProxy(w.$nM.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const j=this.g.get(N.sourceControlHandle);if(!j)return N;const B=j.getResourceGroup(N.groupHandle);return B?B.getResourceState(N.handle):N}else if(N&&N.$mid===4){const j=this.g.get(N.sourceControlHandle);return j?j.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const j=this.g.get(N.handle);return j||N}return N}})}createSourceControl(O,z,T,F){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,z,T,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const N=c.d++,j=new y(O,this.m,this.e,this.l,z,T,F);this.g.set(N,j);const B=this.h.get(O.identifier)||[];return B.push(j),this.h.set(O.identifier,B),j}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const z=this.h.get(O.identifier),T=z&&z[z.length-1];return T&&T.inputBox}$provideOriginalResource(O,z,T){const F=l.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",O,F.toString());const N=this.g.get(O);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$sh)(()=>N.quickDiffProvider.provideOriginalResource(F,T)).then(j=>j||null)}$onInputBoxValueChange(O,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const T=this.g.get(O);return T&&T.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(O,z,T,F){this.n.trace("ExtHostSCM#$executeResourceCommand",O,z,T);const N=this.g.get(O);if(!N)return Promise.resolve(void 0);const j=N.getResourceGroup(z);return j?j.$executeResourceCommand(T,F):Promise.resolve(void 0)}$validateInput(O,z,T){this.n.trace("ExtHostSCM#$validateInput",O);const F=this.g.get(O);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,R.$sh)(()=>F.inputBox.validateInput(z,T)).then(N=>{if(!N)return Promise.resolve(void 0);const j=E.MarkdownString.fromStrict(N.message);return j?Promise.resolve([j,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,z,T,F){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,T,F)??void 0}async $provideHistoryItems(O,z,T,F){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(z,T,F))?.map(B=>({...B,icon:r(B)}))??void 0}async $provideHistoryItemSummary(O,z,T,F){const N=this.g.get(O)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const j=await N.provideHistoryItemSummary(z,T,F);return j?{...j,icon:r(j)}:void 0}async $provideHistoryItemChanges(O,z,T,F){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(z,T,F)??void 0}};e.$2nc=D,e.$2nc=D=c=Je([We(3,I.$7j)],D)}),define(ke[354],De([1,0,6,17,2]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0;class A{static{this.a=0}constructor(w,$){this.d=$,this.c=new Map,this.b=w.getProxy(l.$nM.MainThreadShare)}async $provideShare(w,$,k){return await this.c.get(w)?.provideShare({selection:L.Range.to($.selection),resourceUri:M.URI.revive($.resourceUri)},k)??void 0}registerShareProvider(w,$){const k=A.a++;return this.c.set(k,$),this.b.$registerShareProvider(k,L.DocumentSelector.from(w,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$3nc=A}),define(ke[355],De([1,0,8,6,230,3,17,18]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=e.$5nc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new l.$nN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.$nN("statusBarItem.warningForeground")]])}#e;#t;constructor(p,E,v,d,h,c=l.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new A.$Tc,this.#e=p,this.#t=E,h&&d){this.c=(0,l.$2M)(d.identifier,h);const n=v.get(this.c);n&&(c=n.alignLeft?l.StatusBarAlignment.Left:l.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=d,this.f=h,this.g=c,this.h=this.u(i)}u(p){if((0,w.$eg)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!$.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new A.$Tc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let E;this.m?E=this.m:E=(0,M.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const d=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,E,this.k,d,this.r?.internal,v,this.o,this.g===l.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5nc=$;class k{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const E={message:p};return this.b.unshift(E),this.c(),new l.$pM(()=>{const v=this.b.indexOf(E);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(p,E){this.e=new Map,this.a=p.getProxy(L.$nM.MainThreadStatusBar),this.b=E,this.c=new k(this)}$acceptStaticEntries(p){for(const E of p)this.e.set(E.entryId,E)}createStatusBarEntry(p,E,v,d){return new $(this.a,this.b,this.e,p,E,v,d)}setStatusBarMessage(p,E){const v=this.c.setMessage(p);let d;return typeof E=="number"?d=setTimeout(()=>v.dispose(),E):typeof E<"u"&&E.then(()=>v.dispose(),()=>v.dispose()),new l.$pM(()=>{v.dispose(),clearTimeout(d)})}}e.$6nc=I}),define(ke[155],De([1,0,29,145,69,113,89,17,2]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=e.$5O=e.$4O=void 0;const k=(n,a,r,t)=>{let f=a;return{enumerable:!0,configurable:!1,get(){return f},set(o){if(!r(f,o)){const s=f;f=o,n.listener?.(t(o,s))}}}},I=(n,a)=>n===a,P={range:(n,a)=>n===a?!0:!n||!a?!1:n.isEqual(a),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(n,a)=>!(n.length!==a.length||n.some(r=>!a.find(t=>r.id===t.id)))},p=n=>a=>({op:4,update:n(a)}),E=(n,a)=>({range:(()=>{let r;const t=p(f=>({range:l.$At.lift(w.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return r},set(f){n.listener?.({op:6}),P.range(r,f)||(r=f,n.listener?.(t(f)))}}})(),label:k(n,a,P.label,p(r=>({label:r}))),description:k(n,void 0,P.description,p(r=>({description:r}))),sortText:k(n,void 0,P.sortText,p(r=>({sortText:r}))),canResolveChildren:k(n,!1,P.canResolveChildren,r=>({op:2,state:r})),busy:k(n,!1,P.busy,p(r=>({busy:r}))),error:k(n,void 0,P.error,p(r=>({error:w.MarkdownString.fromStrict(r)||null}))),tags:k(n,[],P.tags,(r,t)=>({op:1,new:r.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),v=n=>{const a=M.$_K.fromString(n.extId),r=new h(a.controllerId,a.localId,n.label,$.URI.revive(n.uri)||void 0);return r.range=w.Range.to(n.range||void 0),r.description=n.description||void 0,r.sortText=n.sortText||void 0,r.tags=n.tags.map(t=>w.TestTag.to({id:(0,R.$fL)(t).tagId})),r},d=n=>{let a;for(const r of n.tests){const t=v(r.item);(0,L.$NO)(t).parent=a,a=t}return a};e.$4O=d;class h{constructor(a,r,t,f){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const o=(0,L.$MO)(this,a);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof c?void 0:o.parent}},children:{value:(0,A.$LO)(o,L.$NO,h),enumerable:!0,writable:!1},...E(o,t)})}}e.$5O=h;class c extends h{constructor(a,r){super(a,a,r,void 0),this._isRoot=!0}}e.$6O=c;class i extends A.$HO{constructor(a,r,t){super({controllerId:a,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:L.$NO,getChildren:f=>f.children,root:new c(a,r),toITestItem:w.TestItem.from})}}e.$7O=i}),define(ke[34],De([1,0,18,8,17,24,6,19,11,53,29,51,2,3,5,20,155,22,48,47,40,87,90,30]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=void 0;let o=class{#e;#t;#n;constructor(m,y,D){this.b=new Map,this.c=new Map,this.#e=m.getProxy(R.$nM.MainThreadCommands),this.d=y,this.#n=D,this.#t=m.getProxy(R.$nM.MainThreadTelemetry),this.converter=new s(this,C=>{const O=this.c.get(C);return O?.result===g.Void?O:void 0},y),this.f=[{processArgument(C){return(0,k.$0h)(C)}},{processArgument(C){return(0,A.$9n)(C,function(O){if(I.$At.isIRange(O))return M.Range.to(O);if(P.$zt.isIPosition(O))return M.Position.to(O);if(I.$At.isIRange(O.range)&&p.URI.isUri(O.uri))return M.location.to(O);if(O instanceof c.$Je)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const y=this.registerCommand(!1,m.id,async(...D)=>{const C=m.args.map((z,T)=>{if(!z.validate(D[T]))throw new Error(`Invalid argument '${z.name}' when running '${m.id}', received: ${typeof D[T]=="object"?JSON.stringify(D[T],null,"	"):D[T]} `);return z.convert(D[T])}),O=await this.executeCommand(m.internalId,...C);return m.result.convert(O,D,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new L.$pM(()=>{y.dispose(),this.c.delete(m.id)})}registerCommand(m,y,D,C,O,z){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:D,thisArg:C,metadata:O,extension:z}),m&&this.#e.$registerCommand(y),new L.$pM(()=>{this.b.delete(y)&&m&&this.#e.$unregisterCommand(y)})}executeCommand(m,...y){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,y,!0)}async g(m,y,D){if(this.b.has(m))return this.#e.$fireCommandActivationEvent(m),this.h(m,y,!1);{let C=!1;const O=(0,A.$9n)(y,function(z){if(z instanceof L.$qM)return M.Position.from(z);if(z instanceof L.$rM)return M.Range.from(z);if(z instanceof L.$BM)return M.location.from(z);if(L.$RN.isNotebookRange(z))return M.NotebookRange.from(z);if(z instanceof ArrayBuffer)return C=!0,c.$Je.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return C=!0,c.$Je.wrap(z);if(z instanceof c.$Je)return C=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(m,C?new i.$Hw(O):O,D);return(0,k.$0h)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(m,y,!1);throw z}}}async h(m,y,D){const C=this.b.get(m);if(!C)throw new Error("Unknown command");const{callback:O,thisArg:z,metadata:T}=C;if(T?.args)for(let N=0;N<T.args.length;N++)try{(0,l.$rg)(y[N],T.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${T.args[N].name}' - ${T.args[N].description}`)}const F=a.$be.create();try{return await O.apply(z,y)}catch(N){if(m===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...y);j&&(m=j.command)}if(this.d.error(N,m,C.extension?.identifier),!D)throw N;if(C.extension?.identifier){const j=this.#n.onExtensionError(C.extension.identifier,N);this.d.trace("forwarded error to extension?",j,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$lj)(N)),this.id=m,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,m,F.elapsed())}}j(m,y,D){m.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new r.$lp(y),duration:D})}$executeContributedCommand(m,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const D=this.b.get(m);return D?(y=y.map(C=>this.f.reduce((O,z)=>z.processArgument(O,D.extension?.identifier),C)),this.h(m,y,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),this.#e.$getCommands().then(y=>(m&&(y=y.filter(D=>D[0]!=="_")),y))}$getContributedCommandMetadata(){const m=Object.create(null);for(const[y,D]of this.b){const{metadata:C}=D;C&&(m[y]=C)}return Promise.resolve(m)}};e.$aP=o,e.$aP=o=Je([We(0,d.$RO),We(1,$.$7j),We(2,t.$_O)],o),e.$bP=(0,v.$Ai)("IExtHostCommands");class s{constructor(m,y,D){this.d=m,this.f=y,this.g=D,this.delegatingCommandId=`__vsc${(0,f.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,y){if(!m)return;const D={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return D;const C=this.f(m.command);if(C)D.id=C.internalId,D.arguments=C.args.map((O,z)=>O.convert(m.arguments&&m.arguments[z]));else if((0,w.$Lb)(m.arguments)){const O=`${m.command} /${++this.c}`;this.b.set(O,m),y.add((0,E.$Sc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),D.$ident=O,D.id=this.delegatingCommandId,D.arguments=[O],this.g.trace("CommandsConverter#CREATE",m.command,O)}return D}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const y=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.$cP=s;class u{static{this.Uri=new u("uri","Uri of a text document",m=>p.URI.isUri(m),m=>m)}static{this.Position=new u("position","A position in a text document",m=>L.$qM.isPosition(m),M.Position.from)}static{this.Range=new u("range","A range in a text document",m=>L.$rM.isRange(m),M.Range.from)}static{this.Selection=new u("selection","A selection in a text document",m=>L.$sM.isSelection(m),M.Selection.from)}static{this.Number=new u("number","",m=>typeof m=="number",m=>m)}static{this.String=new u("string","",m=>typeof m=="string",m=>m)}static{this.StringArray=u.Arr(u.String)}static Arr(m){return new u(`${m.name}_array`,`Array of ${m.name}, ${m.description}`,y=>Array.isArray(y)&&y.every(D=>m.validate(D)),y=>y.map(D=>m.convert(D)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",m=>m instanceof L.$NM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",m=>m instanceof L.$_N,M.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",m=>m instanceof h.$5O,M.TestItem.from)}constructor(m,y,D,C){this.name=m,this.description=y,this.validate=D,this.convert=C}optional(){return new u(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,y){return new u(m??this.name,y??this.description,this.validate,this.convert)}}e.$dP=u;class g{static{this.Void=new g("no result",m=>m)}constructor(m,y){this.description=m,this.convert=y}}e.$eP=g;class b{constructor(m,y,D,C,O){this.id=m,this.internalId=y,this.description=D,this.args=C,this.result=O}}e.$fP=b}),define(ke[356],De([1,0,19,15,2,84,135,38,34,17,8]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0;const P=[new $.$fP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to an array of DocumentHighlight-instances.",E(k.DocumentHighlight.to))),new $.$fP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$dP.Uri],new $.$eP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,h)=>{if((0,l.$Kb)(d))return;class c extends I.$IM{static to(n){const a=new c(n.name,k.SymbolKind.to(n.kind),n.containerName||"",new I.$BM(h[0],k.Range.to(n.range)));return a.detail=n.detail,a.range=a.location.range,a.selectionRange=k.Range.to(n.selectionRange),a.children=n.children?n.children.map(c.to):[],a}}return d.map(c.to)})),new $.$fP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$dP.Uri,new $.$dP("options","Formatting options",d=>!0,d=>d)],new $.$eP("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$fP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$dP.Uri,$.$dP.Range,new $.$dP("options","Formatting options",d=>!0,d=>d)],new $.$eP("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$fP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$dP.Uri,$.$dP.Position,new $.$dP("ch","Trigger character",d=>typeof d=="string",d=>d),new $.$dP("options","Formatting options",d=>!0,d=>d)],new $.$eP("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$fP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$fP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$fP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$fP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$fP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to an array of Location-instances.",E(k.location.to))),new $.$fP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to an array of Hover-instances.",E(k.Hover.to))),new $.$fP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$dP.Uri,new $.$dP("position","A position in a text document",d=>Array.isArray(d)&&d.every(h=>I.$qM.isPosition(h)),d=>d.map(k.Position.from))],new $.$eP("A promise that resolves to an array of ranges.",d=>d.map(h=>{let c;for(const i of h.reverse())c=new I.$MM(k.Range.to(i),c);return c}))),new $.$fP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$dP.String.with("query","Search string")],new $.$eP("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(k.WorkspaceSymbol.to))),new $.$fP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(k.CallHierarchyItem.to))),new $.$fP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$dP.CallHierarchyItem],new $.$eP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(k.CallHierarchyIncomingCall.to))),new $.$fP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$dP.CallHierarchyItem],new $.$eP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(k.CallHierarchyOutgoingCall.to))),new $.$fP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to a range and placeholder text.",d=>{if(d)return{range:k.Range.to(d.range),placeholder:d.text}})),new $.$fP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$dP.Uri,$.$dP.Position,$.$dP.String.with("newName","The new symbol name")],new $.$eP("A promise that resolves to a WorkspaceEdit.",d=>{if(d){if(d.rejectReason)throw new Error(d.rejectReason);return k.WorkspaceEdit.to(d)}})),new $.$fP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$dP.Uri,$.$dP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$eP("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(k.DocumentLink.to))),new $.$fP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$dP.Uri],new $.$eP("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new I.$IN(d.tokenTypes,d.tokenModifiers)})),new $.$fP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$dP.Uri],new $.$eP("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const h=(0,R.$Obb)(d);if(h.type==="full")return new I.$KN(h.data,void 0)})),new $.$fP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$dP.Uri,$.$dP.Range.optional()],new $.$eP("A promise that resolves to SemanticTokensLegend.",d=>{if(d)return new I.$IN(d.tokenTypes,d.tokenModifiers)})),new $.$fP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$dP.Uri,$.$dP.Range],new $.$eP("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const h=(0,R.$Obb)(d);if(h.type==="full")return new I.$KN(h.data,void 0)})),new $.$fP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$dP.Uri,$.$dP.Position,$.$dP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$dP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$eP("A promise that resolves to a CompletionList-instance.",(d,h,c)=>{if(!d)return new I.$YM([]);const i=d.suggestions.map(n=>k.CompletionItem.to(n,c));return new I.$YM(i,d.incomplete)})),new $.$fP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$dP.Uri,$.$dP.Position,$.$dP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$eP("A promise that resolves to SignatureHelp.",d=>{if(d)return k.SignatureHelp.to(d)})),new $.$fP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$dP.Uri,$.$dP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$eP("A promise that resolves to an array of CodeLens-instances.",(d,h,c)=>E(i=>new I.$QM(k.Range.to(i.range),i.command&&c.fromInternal(i.command)))(d))),new $.$fP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$dP.Uri,new $.$dP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>I.$rM.isRange(d),d=>I.$sM.isSelection(d)?k.Selection.from(d):k.Range.from(d)),$.$dP.String.with("kind","Code action kind to return code actions for").optional(),$.$dP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$eP("A promise that resolves to an array of Command-instances.",(d,h,c)=>E(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(i.command)}else{const n=new I.$KM(i.title,i.kind?new I.$LM(i.kind):void 0);return i.edit&&(n.edit=k.WorkspaceEdit.to(i.edit)),i.command&&(n.command=c.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(d))),new $.$fP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$dP.Uri],new $.$eP("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(h=>new I.$5M(k.Range.to(h.range),k.Color.to(h.color))):[])),new $.$fP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$dP("color","The color to show and insert",d=>d instanceof I.$4M,k.Color.from),new $.$dP("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:k.Range.from(d.range)}))],new $.$eP("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(k.ColorPresentation.to):[])),new $.$fP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$dP.Uri,$.$dP.Range],new $.$eP("A promise that resolves to an array of Inlay objects",(d,h,c)=>d.map(k.InlayHint.to.bind(void 0,c)))),new $.$fP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$dP.Uri],new $.$eP("A promise that resolves to an array of FoldingRange objects",(d,h)=>{if(d)return d.map(k.FoldingRange.to)})),new $.$fP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$eP("A promise that resolves to an array of NotebookContentProvider static info objects.",E(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(h=>k.NotebookExclusiveDocumentPattern.to(h))})))),new $.$fP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$dP.Uri,$.$dP.Range,new $.$dP("context","An InlineValueContext",d=>d&&typeof d.frameId=="number"&&d.stoppedLocation instanceof I.$rM,d=>k.InlineValueContext.from(d))],new $.$eP("A promise that resolves to an array of InlineValue objects",d=>d.map(k.InlineValue.to))),new $.$fP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$dP("uriOrString","Uri-instance or string (only http/https)",d=>M.URI.isUri(d)||typeof d=="string"&&(0,L.$Kg)(d,L.Schemas.http,L.Schemas.https),d=>d),new $.$dP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[k.ViewColumn.from(d),void 0]:[k.ViewColumn.from(d.viewColumn),k.TextEditorOpenOptions.from(d)])).optional(),$.$dP.String.with("label","").optional()],$.$eP.Void),new $.$fP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$dP.Uri.with("resource","Resource to open"),$.$dP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$dP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[k.ViewColumn.from(d),void 0]:[k.ViewColumn.from(d.viewColumn),k.TextEditorOpenOptions.from(d)])).optional()],$.$eP.Void),new $.$fP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$dP.Uri.with("left","Left-hand side resource of the diff editor"),$.$dP.Uri.with("right","Right-hand side resource of the diff editor"),$.$dP.String.with("title","Human readable title for the diff editor").optional(),new $.$dP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[k.ViewColumn.from(d.viewColumn),k.TextEditorOpenOptions.from(d)]).optional()],$.$eP.Void),new $.$fP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$dP.String.with("title","Human readable title for the changes editor"),new $.$dP("resourceList","List of resources to compare",d=>{for(const h of d){if(h.length!==3)return!1;const[c,i,n]=h;if(!M.URI.isUri(c)||!M.URI.isUri(i)&&i!==void 0&&i!==null||!M.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},d=>d)],$.$eP.Void),new $.$fP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$dP.Uri,$.$dP.Position],new $.$eP("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(k.TypeHierarchyItem.to))),new $.$fP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$dP.TypeHierarchyItem],new $.$eP("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(k.TypeHierarchyItem.to))),new $.$fP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$dP.TypeHierarchyItem],new $.$eP("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(k.TypeHierarchyItem.to))),new $.$fP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$dP.TestItem],$.$eP.Void),new $.$fP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$dP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$eP.Void),new $.$fP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$dP.String.with("name","The context key name"),new $.$dP("value","The context key value",()=>!0,d=>d)],$.$eP.Void),new $.$fP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$dP.Uri,$.$dP.StringArray,new $.$dP("MappedEditsContext","Mapped Edits Context",d=>k.MappedEditsContext.is(d),d=>k.MappedEditsContext.from(d))],new $.$eP("A promise that resolves to a workspace edit or null",d=>d?k.WorkspaceEdit.to(d):null)),new $.$fP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$dP("Run arguments","",d=>!0,d=>{if(d)return{initialRange:d.initialRange?k.Range.from(d.initialRange):void 0,initialSelection:I.$sM.isSelection(d.initialSelection)?k.Selection.from(d.initialSelection):void 0,message:d.message,autoSend:d.autoSend,position:d.position?k.Position.from(d.position):void 0}})],$.$eP.Void)];class p{static register(h){P.forEach(h.registerApiCommand,h),this.a(h)}static a(h){h.registerCommand(!1,"_validateWhenClauses",w.$zj)}}e.$omc=p;function E(d){return h=>{if(Array.isArray(h))return h.map(d)}}function v(d){if(!Array.isArray(d))return;const h=[];for(const c of d)A.$vu(c)?h.push(k.DefinitionLink.to(c)):h.push(k.location.to(c));return h}}),define(ke[357],De([1,0,2,34]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=void 0;class M{constructor(R,w,$,k,I){this.a=w,this.b=$,this.c=k;const P=new L.$fP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$dP("showOptions","Show Options",p=>!0,p=>p),new L.$dP("resource","Interactive resource Uri",p=>!0,p=>p),new L.$dP("controllerId","Notebook controller Id",p=>!0,p=>p),new L.$dP("title","Interactive editor title",p=>!0,p=>p)],new L.$eP("Notebook and input URI",p=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const E=this.a.getEditorById(p.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:l.URI.revive(p.notebookUri),inputUri:l.URI.revive(p.inputUri),notebookEditor:E.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:l.URI.revive(p.notebookUri),inputUri:l.URI.revive(p.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(R,w,$,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Knc=M}),define(ke[358],De([1,0,19,7,21,4,3,27,2,25,11,6,34,17,8,114,302,26,48,303]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0,e.$Snc=u;let a=class{constructor(b,S,m,y,D){this.m=S,this.n=m,this.o=y,this.q=D,this.b=new w.$Ac,this.c=new w.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$he,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=b.getProxy(P.$nM.MainThreadNotebookKernels);const C=new p.$fP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$dP("options","Select kernel options",z=>!0,z=>{if(z&&"notebookEditor"in z&&"id"in z){const T=this.n.getIdByEditor(z.notebookEditor);return{id:z.id,extension:z.extension,notebookEditorId:T}}else if(z&&"notebookEditor"in z){const T=this.n.getIdByEditor(z.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${z.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return z})],p.$eP.Void),O=new p.$fP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.$dP.Uri],new p.$eP("A promise that resolves to an array of variables",(z,T)=>z.map(F=>({variable:{name:F.name,value:F.value,expression:F.expression,type:F.type,language:F.language},hasNamedChildren:F.hasNamedChildren,indexedChildrenCount:F.indexedChildrenCount}))));this.o.registerApiCommand(C),this.o.registerApiCommand(O)}createNotebookController(b,S,m,y,D,C){for(const oe of this.j.values())if(oe.controller.id===S&&k.$Vm.equals(b.identifier,oe.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const O=this.k++,z=this;this.q.trace(`NotebookController[${O}], CREATED by ${b.identifier.value}, ${S}`);const T=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${b.identifier}'`);let F=!1;const N=new A.$he,j=new A.$he,B={id:u(b.identifier,S),notebookType:m,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:y||b.identifier.value,preloads:C?C.map(E.NotebookRendererScript.from):[]};let X=D??T,ie,H;this.a.$addKernel(O,B).catch(oe=>{console.log(oe),F=!0});let K=0;const x=()=>{if(F)return;const oe=++K;Promise.resolve().then(()=>{oe===K&&this.a.$updateKernel(O,B)})},_=new w.$Ac,ge={get id(){return S},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return B.label},set label(oe){B.label=oe??b.displayName??b.name,x()},get detail(){return B.detail??""},set detail(oe){B.detail=oe,x()},get description(){return B.description??""},set description(oe){B.description=oe,x()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(oe){B.supportedLanguages=oe,x()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){B.supportsExecutionOrder=oe,x()},get rendererScripts(){return B.preloads?B.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(oe){X=oe??T},get interruptHandler(){return ie},set interruptHandler(oe){ie=oe,B.supportsInterrupt=!!oe,x()},set variableProvider(oe){(0,c.$OG)(b,"notebookVariableProvider"),H=oe,B.hasVariableProvider=!!oe,oe?.onDidChangeVariables(Pe=>z.a.$variablesUpdated(Pe.uri)),x()},get variableProvider(){return H},createNotebookCellExecution(oe){if(F)throw new Error("notebook controller is DISPOSED");if(!_.has(oe.notebook.uri))throw z.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return z._createNotebookCellExecution(oe,u(b.identifier,this.id))},createNotebookExecution(oe){if((0,c.$OG)(b,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!_.has(oe.uri))throw z.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return z._createNotebookExecution(oe,u(b.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${O}], DISPOSED`),F=!0,this.j.delete(O),N.dispose(),j.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(oe,Pe){Pe===v.NotebookControllerAffinity2.Hidden&&(0,c.$OG)(b,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(O,oe.uri,Pe)},onDidReceiveMessage:j.event,postMessage(oe,Pe){return(0,c.$OG)(b,"notebookMessaging"),z.a.$postMessage(O,Pe&&z.n.getIdByEditor(Pe),oe)},asWebviewUri(oe){return(0,c.$OG)(b,"notebookMessaging"),(0,d.$sBb)(oe,z.m.remote)}};return this.j.set(O,{extensionId:b.identifier,controller:ge,onDidReceiveMessage:j,onDidChangeSelection:N,associatedNotebooks:_}),ge}getIdByController(b){for(const[S,m]of this.j)if(m.controller===b)return u(m.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,S){const m=this.g++,y=this;this.q.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(m,S);const D={dispose:()=>{this.f.delete(m),y.a.$removeKernelDetectionTask(m)}};return this.f.set(m,D),D}registerKernelSourceActionProvider(b,S,m){const y=this.i++,D=typeof m.onDidChangeNotebookKernelSourceActions=="function"?y:void 0,C=this;this.h.set(y,m),this.q.trace(`NotebookKernelSourceActionProvider[${y}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(y,y,S);let O;return D!==void 0&&(O=m.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(D))),{dispose:()=>{this.h.delete(y),C.a.$removeKernelSourceActionProvider(y,y),O?.dispose()}}}async $provideKernelSourceActions(b,S){const m=this.h.get(b);if(m){const y=new R.$Tc;return(await m.provideNotebookKernelSourceActions(S)??[]).map(C=>E.NotebookKernelSourceAction.from(C,this.o.converter,y))}return[]}$acceptNotebookAssociation(b,S,m){const y=this.j.get(b);if(y){const D=this.n.getNotebookDocument($.URI.revive(S));m?y.associatedNotebooks.set(D.uri,!0):y.associatedNotebooks.delete(D.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,D.uri.toString(),m),y.onDidChangeSelection.fire({selected:m,notebook:D.apiNotebook})}}async $executeCells(b,S,m){const y=this.j.get(b);if(!y)return;const D=this.n.getNotebookDocument($.URI.revive(S)),C=[];for(const O of m){const z=D.getCell(O);z&&C.push(z.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,D.uri.toString(),C.length),await y.controller.executeHandler.call(y.controller,C,D.apiNotebook,y.controller)}catch(O){this.q.error(`NotebookController[${b}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(b,S,m){const y=this.j.get(b);if(!y)return;const D=this.n.getNotebookDocument($.URI.revive(S));if(y.controller.interruptHandler)await y.controller.interruptHandler.call(y.controller,D.apiNotebook);else for(const C of m){const O=D.getCell(C);O&&this.b.get(O.uri)?.cancel()}if(y.controller.interruptHandler){const C=this.c.get(D.uri);this.c.delete(D.uri),m.length&&Array.isArray(C)&&C.length&&C.forEach(O=>O.dispose())}}async $provideVariables(b,S,m,y,D,C,O){const z=this.j.get(b);if(!z)return;const T=this.n.getNotebookDocument($.URI.revive(m)),F=z.controller.variableProvider;if(!F)return;let N;if(y!==void 0){if(N=this.s[y],!N)return}else this.s={};const j=D==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=F.provideVariables(T.apiNotebook,N,j,C,O);let X=0;for await(const ie of B){if(O.isCancellationRequested)return;const H={id:this.r++,name:ie.variable.name,value:ie.variable.value,type:ie.variable.type,interfaces:ie.variable.interfaces,language:ie.variable.language,expression:ie.variable.expression,hasNamedChildren:ie.hasNamedChildren,indexedChildrenCount:ie.indexedChildrenCount,extensionId:z.extensionId.value};if(this.s[H.id]=ie.variable,this.a.$receiveVariable(S,H),X++>=n.$_ib)return}}$acceptKernelMessageFromRenderer(b,S,m){const y=this.j.get(b);if(!y)return;const D=this.n.getEditorById(S);y.onDidReceiveMessage.fire(Object.freeze({editor:D.apiEditor,message:m}))}$cellExecutionChanged(b,S,m){const D=this.n.getNotebookDocument($.URI.revive(b)).getCell(S);if(D){const C=m?E.NotebookCellExecutionState.to(m):v.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:D.apiCell,state:C})}}_createNotebookCellExecution(b,S){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const y=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!y)throw new Error("invalid cell");if(this.b.has(y.uri))throw new Error(`duplicate execution for ${y.uri}`);const D=new t(S,y,this.a);this.b.set(y.uri,D);const C=D.onDidChangeState(()=>{D.state===r.Resolved&&(D.dispose(),C.dispose(),this.b.delete(y.uri))});return D.asApiObject()}_createNotebookExecution(b,S){const m=this.n.getNotebookDocument(b.uri),y=b.getCells().find(O=>{const z=m.getCellFromApiCell(O);return z&&this.b.has(z.uri)});if(y)throw new Error(`duplicate cell execution for ${y.document.uri}`);if(this.c.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const D=new o(S,m,this.a),C=D.onDidChangeState(()=>{D.state===f.Resolved&&(D.dispose(),C.dispose(),this.c.delete(m.uri))});return this.c.set(m.uri,[D,C]),D.asApiObject()}};e.$Rnc=a,e.$Rnc=a=Je([We(4,I.$7j)],a);var r;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(r||(r={}));class t extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(b,S,m){super(),this.m=S,this.n=m,this.b=t.a++,this.c=new A.$he,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new M.$se),this.h=new s(10,y=>this.s(y)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,b,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(b){await this.h.addItem(b)}async s(b){const S=Array.isArray(b)?b:[b];return this.n.$updateExecution(this.b,new i.$Hw(S))}t(){if(this.f===r.Init)throw new Error("Must call start before modifying cell output");if(this.f===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(b){let S=this.m;if(b&&(S=this.m.notebook.getCellFromApiCell(b)),!S)throw new Error("INVALID cell");return S.handle}y(b){return b.map(S=>{const m=v.$VN.ensureUniqueMimeTypes(S.items,!0);return m===S.items?E.NotebookCellOutput.from(S):E.NotebookCellOutput.from({items:m,id:S.id,metadata:S.metadata})})}async z(b,S,m){const y=this.w(S),D=this.y((0,l.$2b)(b));return this.r({editType:h.CellExecutionUpdateType.Output,cellHandle:y,append:m,outputs:D})}async C(b,S,m){return b=v.$VN.ensureUniqueMimeTypes((0,l.$2b)(b),!0),this.r({editType:h.CellExecutionUpdateType.OutputItems,items:b.map(E.NotebookCellOutputItem.from),outputId:S.id,append:m})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.m.apiCell},get executionOrder(){return b.j},set executionOrder(m){b.j=m,b.s([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:b.j}])},start(m){if(b.f===r.Resolved||b.f===r.Started)throw new Error("Cannot call start again");b.f=r.Started,b.c.fire(),b.s({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,y,D){if(b.f===r.Resolved)throw new Error("Cannot call resolve twice");b.f=r.Resolved,b.c.fire(),b.h.flush();const C=D?{message:D.message,stack:D.stack,location:D?.location?{startLineNumber:D.location.start.line,startColumn:D.location.start.character,endLineNumber:D.location.end.line,endColumn:D.location.end.character}:void 0,uri:D.uri}:void 0;b.n.$completeExecution(b.b,new i.$Hw({runEndTime:y,lastRunSuccess:m,error:C}))},clearOutput(m){return b.t(),b.z([],m,!1)},appendOutput(m,y){return b.t(),b.z(m,y,!0)},replaceOutput(m,y){return b.t(),b.z(m,y,!1)},appendOutputItems(m,y){return b.t(),b.C(m,y,!0)},replaceOutputItems(m,y){return b.t(),b.C(m,y,!1)}})}}var f;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(f||(f={}));class o extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(b,S,m){super(),this.h=S,this.j=m,this.b=o.a++,this.c=new A.$he,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new M.$se),this.j.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(b,S){this.f=b,this.g=S,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new L.$Xh,this.b=Date.now(),(0,L.$Bh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>b.complete())}}function u(g,b){return`${g.value}/${b}`}}),define(ke[43],De([1,0,4,6,5,2,20,3,8,232,13,279,21,30,280,50,7,17,34]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=e.$5mc=e.$4mc=e.$3mc=void 0,e.$3mc=(0,M.$Ai)("IExtHostTerminalService");class n extends w.$Uc{constructor(m,y,D,C){super(),this.u=m,this._id=y,this.w=D,this.y=C,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new l.$he),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(z=>this.g=z);const O=this;this.value={get name(){return O.y||""},get processId(){return O.b},get creationOptions(){return O.w},get exitStatus(){return O.j},get state(){return O.m},get selection(){return O.n},get shellIntegration(){return O.shellIntegration},sendText(z,T=!0){O.C(),O.u.$sendText(O._id,z,T)},show(z){O.C(),O.u.$show(O._id,z)},hide(){O.C(),O.u.$hide(O._id)},dispose(){O.a||(O.a=!0,O.u.$dispose(O._id))},get dimensions(){if(!(O.f===void 0||O.h===void 0))return{columns:O.f,rows:O.h}}}}dispose(){this.s.fire(),super.dispose()}async create(m,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??y?.cwd??void 0,env:m.env??void 0,icon:u(m.iconPath)??void 0,color:d.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,forceShellIntegration:y?.forceShellIntegration??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.z(m.location,y?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,y,D,C,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:C,color:d.ThemeColor.isThemeColor(O)?O.id:void 0,location:y?.location||this.z(m,D),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(m,y){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in m?{viewColumn:c.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.y=m}setExitStatus(m,y){this.j=Object.freeze({code:m,reason:y})}setDimensions(m,y){return m===this.f&&y===this.h||m===0||y===0?!1:(this.f=m,this.h=y,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(m){this.n=m}_setProcessId(m){this.g?(this.g(m),this.g=void 0):this.b.then(y=>{y!==m&&(this.b=Promise.resolve(m))})}}e.$4mc=n;class a{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new l.$he,this.onProcessData=this.a.event,this.b=new l.$he,this.d=new l.$he,this.onDidChangeProperty=this.d.event,this.f=new l.$he,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,y){this.g.setDimensions?.({columns:m,rows:y})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,t=class extends w.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,y,D){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new l.$he,this.onDidCloseTerminal=this.H.event,this.I=new l.$he,this.onDidOpenTerminal=this.I.event,this.J=new l.$he,this.onDidChangeActiveTerminal=this.J.event,this.L=new l.$he,this.onDidChangeTerminalDimensions=this.L.event,this.M=new l.$he,this.onDidChangeTerminalState=this.M.event,this.N=new l.$he,this.onDidChangeShell=this.N.event,this.O=new l.$he({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new l.$he({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(L.$nM.MainThreadTerminalService),this.y=new v.$qwb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:C=>{const O=z=>{const T=z;return this.getTerminalById(T.instanceId)?.value};switch(C?.$mid){case 15:return O(C);default:{if(Array.isArray(C))for(let z=0;z<C.length&&C[z].$mid===15;z++)C[z]=O(C[z]);return C}}}}),this.B({dispose:()=>{for(const[C,O]of this.g)O.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,y){const D=new n(this.a,(0,E.$Wg)(),m,m.name),C=new a(m.pty);return D.createExtensionTerminal(m.location,y,this.R(m,y).resolvedExtHostIdentifier,u(m.iconPath),g(m.color)).then(O=>{const z=this.S(O,C);this.h[O]=z}),this.f.push(D),D.value}R(m,y){if(y=y||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const D=m.location.parentTerminal;if(D){const C=this.f.find(O=>O.value===D);C&&(y.resolvedExtHostIdentifier=C._id)}}else m.location&&typeof m.location!="object"?y.location=m.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(m,y){if(!this.getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const C=new a(y),O=this.S(m,C);this.h[m]=O}async $acceptActiveTerminalChanged(m){const y=this.b;if(m===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const D=this.getTerminalById(m);D&&(this.b=D,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,y){const D=this.getTerminalById(m);D&&this.O.fire({terminal:D.value,data:y})}async $acceptTerminalDimensions(m,y,D){const C=this.getTerminalById(m);C&&C.setDimensions(y,D)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(m,y){const D=this.getTerminalById(m);D&&this.P.fire({terminal:D.value,...y})}async $acceptTerminalMaximumDimensions(m,y,D){this.g.get(m)?.resize(y,D)}async $acceptTerminalTitleChange(m,y){const D=this.getTerminalById(m);D&&(D.name=y)}async $acceptTerminalClosed(m,y,D){const C=this.X(this.f,m);if(C!==null){const O=this.f.splice(C,1)[0];O.setExitStatus(y,D),this.H.fire(O.value)}}$acceptTerminalOpened(m,y,D,C){if(y){const T=this.X(this.f,y);if(T!==null){this.f[T]._id=m,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const O={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:A.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},z=new n(this.a,m,O,D);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(m,y){this.getTerminalById(m)?._setProcessId(y)}async $startExtensionTerminal(m,y){const D=this.getTerminalById(m);if(!D)return{message:(0,k.localize)(0,null,m)};D.isOpen||await new Promise(O=>{const z=this.onDidOpenTerminal(async T=>{T===D.value&&(z.dispose(),O())})});const C=this.g.get(m);C?C.startSendingEvents(y):this.j[m]={initialDimensions:y}}S(m,y){const D=new w.$Tc;D.add(y.onProcessReady(O=>this.a.$sendProcessReady(m,O.pid,O.cwd,O.windowsPty))),D.add(y.onDidChangeProperty(O=>this.a.$sendProcessProperty(m,O))),this.y.startBuffering(m,y.onProcessData),D.add(y.onProcessExit(O=>this.U(m,O))),this.g.set(m,y);const C=this.j[m];return C&&y instanceof a&&(y.startSendingEvents(C.initialDimensions),delete this.j[m]),D}$acceptProcessAckDataEvent(m,y){this.g.get(m)?.acknowledgeDataEvent(y)}$acceptProcessInput(m,y){this.g.get(m)?.input(y)}$acceptTerminalInteraction(m){const y=this.getTerminalById(m);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(m,y){this.getTerminalById(m)?.setSelection(y)}$acceptProcessResize(m,y,D){try{this.g.get(m)?.resize(y,D)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(m,y){this.g.get(m)?.shutdown(y)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(m,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(y=>this.a.$sendProcessProperty(m,{type:"cwd",value:y}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new $.$pM(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,y,D){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,D),this.a.$registerProfileProvider(y,m.identifier.value),new $.$pM(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(m,y,D){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,D),this.a.$registerQuickFixProvider(m,y),new $.$pM(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,y){const D=new p.$se().token;if(D.isCancellationRequested)return;const C=this.D.get(m);if(!C)return;const O=await C.provideTerminalQuickFixes(y,D);if(O===null||Array.isArray(O)&&O.length===0)return;const z=new w.$Tc;if(this.w.value=z,!Array.isArray(O))return O?c.TerminalQuickFix.from(O,this.Q.converter,z):void 0;const T=[];for(const F of O){const N=c.TerminalQuickFix.from(F,this.Q.converter,z);N&&T.push(N)}return T}async $createContributedProfileTerminal(m,y){const D=new p.$se().token;let C=await this.C.get(m)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,y);return}this.createTerminalFromOptions(C.options,y)}}async $provideLinks(m,y){const D=this.getTerminalById(m);if(!D)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const O=new p.$se;this.G.set(m,O);const z=[],T={terminal:D.value,line:y},F=[];for(const B of this.z)F.push(h.Promises.withAsyncBody(async X=>{O.token.onCancellationRequested(()=>X({provider:B,links:[]}));const ie=await B.provideTerminalLinks(T,O.token)||[];O.token.isCancellationRequested||X({provider:B,links:ie})}));const N=await Promise.all(F);if(O.token.isCancellationRequested)return[];const j=new Map;for(const B of N)B&&B.links.length>0&&z.push(...B.links.map(X=>{const ie={id:r++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return j.set(ie.id,{provider:B.provider,link:X}),ie}));return this.F.set(m,j),z}$activateLink(m,y){const D=this.F.get(m)?.get(y);D&&D.provider.handleTerminalLink(D.link)}U(m,y){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const D=this.h[m];D&&(D.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,y)}getTerminalById(m){return this.W(this.f,m)}getTerminalIdByApiObject(m){const y=this.f.findIndex(D=>D.value===m);return y>=0?y:null}W(m,y){const D=this.X(m,y);return D!==null?m[D]:null}X(m,y){const D=m.findIndex(C=>C._id===y);return D>=0?D:null}getEnvironmentVariableCollection(m){let y=this.n.get(m.identifier.value);return y||(y=new f,this.Z(m.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Y(m,y){const D=(0,P.$rs)(y.map),C=(0,P.$ss)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(m,y.persistent,D.length===0?void 0:D,C)}$initEnvironmentVariableCollections(m){m.forEach(y=>{const D=y[0],C=new f(y[1]);this.Z(D,C)})}$acceptDefaultProfile(m,y){const D=this.s;this.s=m,this.u=y,D?.path!==m.path&&this.N.fire(m.path)}Z(m,y){this.n.set(m,y),y.onDidChangeCollection(()=>{this.Y(m,y)})}};e.$5mc=t,e.$5mc=t=Je([We(1,i.$bP),We(2,R.$RO)],t);class f{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new l.$he,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const y=this.h(m);let D=this.a.get(y);return D||(D=new o(this,m),this.a.set(y,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(m,y,D,C){this.f(m,{value:y,type:$.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:C})}append(m,y,D,C){this.f(m,{value:y,type:$.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:C})}prepend(m,y,D,C){this.f(m,{value:y,type:$.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:C})}f(m,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(m,y.scope),C=this.map.get(D),O=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==y.value||C.type!==y.type||C.options?.applyAtProcessCreation!==O.applyAtProcessCreation||C.options?.applyAtShellIntegration!==O.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const z=this.g(m,y.scope),T={variable:m,...y,options:O};this.map.set(z,T),this.d.fire()}}get(m,y){const D=this.g(m,y),C=this.map.get(D);return C?b(C):void 0}g(m,y){const D=this.h(y);return D.length?`${m}:::${D}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const y=new Map;for(const[D,C]of this.map)this.h(C.scope)===this.h(m)&&y.set(C.variable,b(C));return y}delete(m,y){const D=this.g(m,y);this.map.delete(D),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[y,D]of this.map)D.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(y);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,y){const D=this.h(y),C=this.descriptionMap.get(D);if(!C||C.description!==m){let O;typeof m=="string"?O=m:O=m?.value.split(`

`)[0];const z={description:O,scope:y};this.descriptionMap.set(D,z),this.d.fire()}}getDescription(m){const y=this.h(m);return this.descriptionMap.get(y)?.description}k(m){const y=this.h(m);this.descriptionMap.delete(y)}}class o{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,y){this.b=m,this.d=y,this.a=new l.$he}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,y,D){this.b.replace(m,y,D,this.d)}append(m,y,D){this.b.append(m,y,D,this.d)}prepend(m,y,D){this.b.prepend(m,y,D,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,y){this.b.getVariableMap(this.d).forEach((D,C)=>m.call(y,C,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let s=class extends t{constructor(m,y){super(!1,m,y)}createTerminal(m,y,D){throw new I.$_}createTerminalFromOptions(m,y){throw new I.$_}};e.$6mc=s,e.$6mc=s=Je([We(0,i.$bP),We(1,R.$RO)],s);function u(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function g(S){return d.ThemeColor.isThemeColor(S)?S:void 0}function b(S){const m={...S};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(ke[156],De([1,0,8,3,5,6,20,43,4,2,7]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=e.$0nc=void 0,e.$0nc=(0,M.$Ai)("IExtHostTerminalShellIntegration");let P=class extends L.$Uc{constructor(h,c){super(),this.h=c,this.b=new Map,this.c=new $.$he,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$he,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$he,this.onDidEndTerminalShellExecution=this.g.event,this.a=h.getProxy(A.$nM.MainThreadTerminalShellIntegration),this.B((0,L.$Sc)(()=>{for(const[i,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(h){const c=this.h.getTerminalById(h);if(!c)return;const i=c.value;let n=this.b.get(h);n||(n=new p(c.value,this.f),this.b.set(h,n),n.store.add(c.onWillDispose(()=>this.b.get(h)?.dispose())),n.store.add(n.onDidRequestShellExecution(a=>this.a.$executeCommand(h,a))),n.store.add(n.onDidRequestEndExecution(a=>this.g.fire(a))),n.store.add(n.onDidRequestChangeShellIntegration(a=>this.c.fire(a))),c.shellIntegration=n.value),this.c.fire({terminal:i,shellIntegration:n.value})}$shellExecutionStart(h,c,i,n,a){this.b.has(h)||this.$shellIntegrationChange(h);const r={value:c,confidence:i,isTrusted:n};this.b.get(h)?.startShellExecution(r,a)}$shellExecutionEnd(h,c,i,n,a){const r={value:c,confidence:i,isTrusted:n};this.b.get(h)?.endShellExecution(r,a)}$shellExecutionData(h,c){this.b.get(h)?.emitData(c)}$cwdChange(h,c){this.b.get(h)?.setCwd((0,k.$vc)(c)?k.URI.revive(c):c)}$closeTerminal(h){this.b.get(h)?.dispose(),this.b.delete(h)}};e.$$nc=P,e.$$nc=P=Je([We(0,R.$RO),We(1,w.$3mc)],P);class p extends L.$Uc{get currentExecution(){return this.a}constructor(h,c){super(),this.j=h,this.m=c,this.b=!1,this.store=this.B(new L.$Tc),this.f=this.B(new $.$he),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$he),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$he),this.onDidRequestEndExecution=this.h.event;const i=this;this.value={get cwd(){return i.c},executeCommand(n,a){let r=n;a&&(r+=` "${a.map(o=>`${o.replaceAll('"','\\"')}`).join('" "')}"`),i.g.fire(r);const t={value:r,confidence:l.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},f=i.startShellExecution(t,i.c,!0).value;return i.b=!0,f}}}startShellExecution(h,c,i){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new E(h,c);i?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(h){this.currentExecution?.emitData(h)}endShellExecution(h,c){this.a&&(this.a.endExecution(h),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(h){let c=!1;k.URI.isUri(this.c)?c=!k.URI.isUri(h)||this.c.toString()!==h.toString():this.c!==h&&(c=!0),c&&(this.c=h,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(h,c){this.c=h,this.cwd=c,this.b=!1;const i=this;this.value={get commandLine(){return i.c},get cwd(){return i.cwd},read(){return i.d()}}}d(){if(!this.a){if(this.b)return I.$1h.EMPTY;this.a=new v}return this.a.createIterable()}emitData(h){this.a?.emitData(h)}endExecution(h){h&&(this.c=h),this.a?.endExecution(),this.a=void 0,this.b=!0}}class v extends L.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$zh);const h=this.a;return new I.$1h(async i=>{this.b.push(i),await h.wait()})}emitData(h){for(const c of this.b)c.emitOne(h)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[359],De([1,0,7,22,21,4,75,58,3,18,30,11,6,20,155,17,8,69,113,89,26]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=e.$boc=e.$aoc=e.$_nc=void 0;let r=class extends $.$Uc{constructor(z,T,F,N){super(),this.w=N,this.f=this.B(new A.$he),this.g=new Map,this.s=this.B(new A.$he),this.onResultsChanged=this.f.event,this.results=[],this.h=z.getProxy(p.$nM.MainThreadTesting),this.m=new m(this.h),this.j=new s(this.h,T),F.registerArgumentProcessor({processArgument:j=>{switch(j?.$mid){case 16:{const B=j,X=B.tests[B.tests.length-1].item.extId;return this.g.get(c.$_K.root(X))?.collection.tree.get(X)?.actual??(0,v.$4O)(j)}case 18:{const{test:B,message:X}=j,ie=B.item.extId;return{test:this.g.get(c.$_K.root(ie))?.collection.tree.get(ie)?.actual??(0,v.$4O)({$mid:16,tests:[B]}),message:d.TestMessage.to(X)}}default:return j}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const j=await F.executeCommand("_testing.getExplorerSelection"),B=X=>{const ie=this.g.get(c.$_K.root(X));if(ie)return c.$_K.isRoot(X)?ie.controller:ie.collection.tree.get(X)?.actual};return{include:j?.include.map(B).filter(k.$ig)||[],exclude:j?.exclude.map(B).filter(k.$ig)||[]}})}createTestController(z,T,F,N){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const j=new $.$Tc,B=j.add(new v.$7O(T,F,this.w));B.root.label=F;const X=new Map,ie=new Set,H=this.h,K={items:B.root.children,get label(){return F},set label(_){F=_,B.root.label=_,H.$updateController(T,{label:F})},get refreshHandler(){return N},set refreshHandler(_){N=_,H.$updateController(T,{canRefresh:!!_})},get id(){return T},createRunProfile:(_,ge,oe,Pe,me,U)=>{let Y=(0,w.$oj)(_);for(;X.has(Y);)Y++;return new D(this.h,X,ie,this.s.event,T,Y,_,ge,oe,Pe,me,U)},createTestItem(_,ge,oe){return new v.$5O(T,_,ge,oe)},createTestRun:(_,ge,oe=!0)=>this.j.createTestRun(z,T,B,_,ge,oe),invalidateTestResults:_=>{if(_===void 0)this.h.$markTestRetired(void 0);else{const ge=_ instanceof Array?_:[_];this.h.$markTestRetired(ge.map(oe=>c.$_K.fromExtHostTestItem(oe,T).toString()))}},set resolveHandler(_){B.resolveHandler=_},get resolveHandler(){return B.resolveHandler},dispose:()=>{j.dispose()}};H.$registerTestController(T,F,!!N),j.add((0,$.$Sc)(()=>H.$unregisterTestController(T)));const x={controller:K,collection:B,profiles:X,extension:z,activeProfiles:ie};return this.g.set(T,x),j.add((0,$.$Sc)(()=>this.g.delete(T))),j.add(B.onDidGenerateDiff(_=>H.$publishDiff(T,_.map(n.TestsDiffOp.serialize)))),K}createTestObserver(){return this.m.checkout()}async runTests(z,T=M.CancellationToken.None){const F=u(z);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.g.get(F.controllerId);if(!N)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:z.preserveFocus??!0,targets:[{testIds:z.include?.map(j=>c.$_K.fromExtHostTestItem(j,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:C[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:z.exclude?.map(j=>j.id)},T)}$syncTests(){for(const{collection:z}of this.g.values())z.flushDiff();return Promise.resolve()}async $getCoverageDetails(z,T){return(await this.j.getCoverageDetails(z,T))?.map(d.TestCoverage.fromDetails)}async $disposeRun(z){this.j.disposeTestRun(z)}$configureRunProfile(z,T){this.g.get(z)?.profiles.get(T)?.configureHandler?.()}$setDefaultRunProfiles(z){const T=new Map;for(const[F,N]of Object.entries(z)){const j=this.g.get(F);if(!j)continue;const B=new Map,X=N.filter(H=>!j.activeProfiles.has(H)),ie=[...j.activeProfiles].filter(H=>!N.includes(H));for(const H of X)B.set(H,!0),j.activeProfiles.add(H);for(const H of ie)B.set(H,!1),j.activeProfiles.delete(H);B.size&&T.set(F,B)}this.s.fire(T)}async $refreshTests(z,T){await this.g.get(z)?.controller.refreshHandler?.(T)}$publishTestResults(z){this.results=Object.freeze(z.map(d.TestResults.to).concat(this.results).sort((T,F)=>F.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(z,T){const F=this.g.get(c.$_K.fromString(z).controllerId)?.collection;F&&(await F.expand(z,T<0?1/0:T),F.flushDiff())}$acceptDiff(z){this.m.applyDiff(z.map(T=>n.TestsDiffOp.deserialize({asCanonicalUri:F=>F},T)))}async $runControllerTests(z,T){return Promise.all(z.map(F=>this.y(F,!1,T)))}async $startContinuousRun(z,T){const F=new M.$se(T),N=await Promise.all(z.map(j=>this.y(j,!0,F.token)));return!T.isCancellationRequested&&!N.some(j=>j.error)&&await new Promise(j=>T.onCancellationRequested(j)),F.dispose(!0),N}async y(z,T,F){const N=this.g.get(z.controllerId);if(!N)return{};const{collection:j,profiles:B,extension:X}=N,ie=B.get(z.profileId);if(!ie)return{};const H=z.testIds.map(ge=>j.tree.get(ge)).filter(k.$ig),K=z.excludeExtIds.map(ge=>N.collection.tree.get(ge)).filter(k.$ig).filter(ge=>H.some(oe=>oe.fullId.compare(ge.fullId)===2));if(!H.length)return{};const x=new h.$3N(H.some(ge=>ge.actual instanceof v.$6O)?void 0:H.map(ge=>ge.actual),K.map(ge=>ge.actual),ie,T),_=(0,n.$cL)(z)&&this.j.prepareForMainThreadTestRun(X,x,g.fromInternal(z,N.collection),ie,F);try{return await ie.runHandler(x,F),{}}catch(ge){return{error:String(ge)}}finally{_&&_.hasRunningTasks&&!F.isCancellationRequested&&await A.Event.toPromise(_.onEnd)}}$cancelExtensionTestRun(z){z===void 0?this.j.cancelAllRuns():this.j.cancelRunById(z)}};e.$_nc=r,e.$_nc=r=Je([We(0,E.$RO),We(1,P.$7j)],r);const t=1e4;var f;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(f||(f={}));class o extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(z,T,F,N,j,B){super(),this.y=z,this.z=T,this.C=F,this.D=N,this.F=j,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$he),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new M.$se(B));const X=this.B(new l.$Mh(()=>this.G(),t));this.B(this.j.token.onCancellationRequested(()=>X.schedule()));const ie=new A.$he;this.s=ie.event,this.B((0,$.$Sc)(()=>{ie.fire(),ie.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.G()}getCoverageDetails(z,T){const[,F]=c.$_K.fromString(z).path,N=this.w.get(z);if(!N)return[];const j=this.g.get(F);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,N,T)??[]}createRun(z){const T=this.y.id,F=this.y.controllerId,N=(0,I.$Wg)(),j=K=>(x,..._)=>{if(X){this.C.warn(`Setting the state of test "${x.id}" is a no-op after the run ends.`);return}this.y.isIncluded(x)&&(this.I(x),K(x,..._))},B=(K,x)=>{const _=x instanceof Array?x.map(d.TestMessage.from):[d.TestMessage.from(x)];if(K.uri&&K.range){const ge={range:d.Range.from(K.range),uri:K.uri};for(const oe of _)oe.location=oe.location||ge}this.z.$appendTestMessagesInRun(T,N,c.$_K.fromExtHostTestItem(K,F).toString(),_)};let X=!1;const ie=new Map,H={isPersisted:this.y.isPersisted,token:this.j.token,name:z,onDidDispose:this.s,addCoverage:K=>{if(X)return;const x=K instanceof h.$8N?K.testItem:void 0;let _;if(x){if((0,a.$OG)(this.F,"attributableCoverage"),!this.y.isIncluded(x))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.I(x),_=ie.get(x),_===void 0&&(_=ie.size,ie.set(x,_))}const ge=K.uri.toString(),oe=new c.$_K(_!==void 0?[T,N,ge,String(_)]:[T,N,ge]).toString();this.w.set(oe,K),this.z.$appendCoverage(T,N,d.TestCoverage.fromFile(F,oe,K))},enqueued:j(K=>{this.z.$updateTestStateInRun(T,N,c.$_K.fromExtHostTestItem(K,F).toString(),1)}),skipped:j(K=>{this.z.$updateTestStateInRun(T,N,c.$_K.fromExtHostTestItem(K,F).toString(),5)}),started:j(K=>{this.z.$updateTestStateInRun(T,N,c.$_K.fromExtHostTestItem(K,F).toString(),2)}),errored:j((K,x,_)=>{B(K,x),this.z.$updateTestStateInRun(T,N,c.$_K.fromExtHostTestItem(K,F).toString(),6,_)}),failed:j((K,x,_)=>{B(K,x),this.z.$updateTestStateInRun(T,N,c.$_K.fromExtHostTestItem(K,F).toString(),4,_)}),passed:j((K,x)=>{this.z.$updateTestStateInRun(T,N,c.$_K.fromExtHostTestItem(K,this.y.controllerId).toString(),3,x)}),appendOutput:(K,x,_)=>{X||(_&&(this.y.isIncluded(_)?this.I(_):_=void 0),this.z.$appendOutputToRun(T,N,L.$Je.fromString(K),x&&d.location.from(x),_&&c.$_K.fromExtHostTestItem(_,F).toString()))},end:()=>{X||(X=!0,ie.clear(),this.z.$finishedTestRunTask(T,N),--this.f||this.H())}};return this.f++,this.g.set(N,{run:H}),this.z.$startedTestRunTask(T,{id:N,name:z,running:!0}),H}G(){for(const{run:z}of this.g.values())z.end()}H(){this.c!==2&&(this.c=2,this.m.fire())}I(z){if(!(z instanceof v.$5O))throw new i.$JO(z.id);if(this.h.has(c.$_K.fromExtHostTestItem(z,this.y.controllerId).toString()))return;const T=[],F=this.y.colllection.root;for(;;){const N=d.TestItem.from(z);if(T.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),z===F))break;z=z.parent||F}this.z.$addTestsToRun(this.y.controllerId,this.y.id,T)}dispose(){this.H(),super.dispose()}}class s{get trackers(){return this.c.values()}constructor(z,T){this.g=z,this.h=T,this.c=new Map,this.f=new Map}getCoverageDetails(z,T){const F=c.$_K.root(z);return this.f.get(F)?.getCoverageDetails(z,T)||[]}disposeTestRun(z){this.f.get(z)?.dispose(),this.f.delete(z);for(const[T,{id:F}]of this.c)F===z&&this.c.delete(T)}prepareForMainThreadTestRun(z,T,F,N,j){return this.j(T,F,N,z,j)}cancelRunById(z){this.f.get(z)?.cancel()}cancelAllRuns(){for(const z of this.c.values())z.cancel()}createTestRun(z,T,F,N,j,B){const X=this.c.get(N);if(X)return X.createRun(j);const ie=g.fromPublic(T,F,N,B),H=u(N);this.g.$startedExtensionTestRun({controllerId:T,continuous:!!N.continuous,profile:H&&{group:C[H.kind],id:H.profileId},exclude:N.exclude?.map(x=>c.$_K.fromExtHostTestItem(x,F.root.id).toString())??[],id:ie.id,include:N.include?.map(x=>c.$_K.fromExtHostTestItem(x,F.root.id).toString())??[F.root.id],preserveFocus:N.preserveFocus??!0,persist:B});const K=this.j(N,ie,N.profile,z);return A.Event.once(K.onEnd)(()=>{this.g.$finishedExtensionTestRun(ie.id)}),K.createRun(j)}j(z,T,F,N,j){const B=new o(T,this.g,this.h,F,N,j);return this.c.set(z,B),this.f.set(B.id,B),B}}e.$aoc=s;const u=O=>{if(O.profile){if(!(O.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class g{static fromPublic(z,T,F,N){return new g(z,(0,I.$Wg)(),F.include?.map(j=>c.$_K.fromExtHostTestItem(j,z).toString())??[z],F.exclude?.map(j=>c.$_K.fromExtHostTestItem(j,z).toString())??[],N,T)}static fromInternal(z,T){return new g(z.controllerId,z.runId,z.testIds,z.excludeExtIds,!0,T)}constructor(z,T,F,N,j,B){this.controllerId=z,this.id=T,this.isPersisted=j,this.colllection=B,this.c=F.map(X=>X+"\0"),this.f=N.map(X=>X+"\0")}isIncluded(z){const T=c.$_K.fromExtHostTestItem(z,this.controllerId).toString()+"\0";for(const F of this.f)if(T===F||T.startsWith(F))return!1;for(const F of this.c)if(T===F||T.startsWith(F))return!0;return!1}}e.$boc=g;class b{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(z){this.j=z,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(z){this.c.add(z)}update(z){Object.assign(z.revived,d.TestItem.toPlain(z.item)),this.c.has(z)||this.f.add(z)}remove(z){if(this.c.has(z)){this.c.delete(z);return}this.f.delete(z);const T=c.$_K.parentId(z.item.extId);if(T&&this.h.has(T.toString())){this.h.add(z.item.extId);return}this.g.add(z)}getChangeEvent(){const{c:z,f:T,g:F}=this;return{get added(){return[...z].map(N=>N.revived)},get updated(){return[...T].map(N=>N.revived)},get removed(){return[...F].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class S extends n.$iL{constructor(){super(...arguments),this.s=new A.$he,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(z){return this.f.get(z)}getMirroredTestDataByReference(z){return this.f.get(z.id)}w(z,T){return{...z,revived:d.TestItem.toPlain(z.item),depth:T?T.depth+1:0,children:new Set}}v(){return new b(this.s)}}class m{constructor(z){this.f=z}checkout(){this.c||(this.c=this.g());const z=this.c;return z.observers++,{onDidChangeTest:z.tests.onDidChangeTests,get tests(){return[...z.tests.rootTests].map(T=>T.revived)},dispose:(0,R.$db)(()=>{--z.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(z){return this.c?.tests.getMirroredTestDataByReference(z)}applyDiff(z){this.c?.tests.apply(z)}g(){const z=new S({asCanonicalUri:T=>T});return this.f.$subscribeToDiffs(),{observers:0,tests:z}}}const y=(O,z,T,F)=>{T?Object.assign(T,F):z.$updateTestRunConfig(O.controllerId,O.profileId,F)};class D{#e;#t;#n;#i;#s;get label(){return this.f}set label(z){z!==this.f&&(this.f=z,y(this,this.#e,this.#i,{label:z}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(z){z!==this.g&&(this.g=z,y(this,this.#e,this.#i,{supportsContinuousRun:z}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(z){z!==this.isDefault&&(z?this.#t.add(this.profileId):this.#t.delete(this.profileId),y(this,this.#e,this.#i,{isDefault:z}))}get tag(){return this._tag}set tag(z){z?.id!==this._tag?.id&&(this._tag=z,y(this,this.#e,this.#i,{tag:z?d.TestTag.namespace(this.controllerId,z.id):null}))}get configureHandler(){return this.c}set configureHandler(z){z!==this.c&&(this.c=z,y(this,this.#e,this.#i,{hasConfigurationHandler:!!z}))}get onDidChangeDefault(){return A.Event.chain(this.#n,z=>z.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(k.$ig))}constructor(z,T,F,N,j,B,X,ie,H,K=!1,x=void 0,_=!1){this.controllerId=j,this.profileId=B,this.f=X,this.kind=ie,this.runHandler=H,this._tag=x,this.g=_,this.#e=z,this.#s=T,this.#t=F,this.#n=N,T.set(B,this);const ge=C[ie];if(typeof ge!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);K&&F.add(B),this.#i={profileId:B,controllerId:j,tag:x?d.TestTag.namespace(this.controllerId,x.id):null,label:X,group:ge,isDefault:K,hasConfigurationHandler:!1,supportsContinuousRun:_},queueMicrotask(()=>{this.#i&&(this.#e.$publishTestRunProfile(this.#i),this.#i=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#i=void 0}}e.$coc=D;const C={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(ke[157],De([1,0,62,13,125,17,8]),function(le,e,l,L,M,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=e.$YO=void 0;class w{static{this.c=new M.$WO("TextEditorDecorationType")}constructor(p,E,v){const d=w.c.nextId();p.$registerTextEditorDecorationType(E.identifier,d,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){p.$removeTextEditorDecorationType(d)}})}}e.$YO=w;class ${constructor(p,E){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,E){this.k();let v=null;if(p instanceof R.$qM)v=new R.$rM(p,p);else if(p instanceof R.$rM)v=p;else throw new Error("Unrecognized location");this.l(v,E,!1)}insert(p,E){this.k(),this.l(new R.$rM(p,p),E,!0)}delete(p){this.k();let E=null;if(p instanceof R.$rM)E=p;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(p,E,v){const d=this.c.validateRange(p);this.g.push({range:d,text:E,forceMoveMarkers:v})}setEndOfLine(p){if(this.k(),p!==R.EndOfLine.LF&&p!==R.EndOfLine.CRLF)throw(0,L.$7)("endOfLine");this.h=p}}class k{constructor(p,E,v,d){this.c=p,this.d=E,this._accept(v),this.e=d;const h=this;this.value={get tabSize(){return h.f},set tabSize(c){h.n(c)},get indentSize(){return h.g},set indentSize(c){h.p(c)},get insertSpaces(){return h.j},set insertSpaces(c){h.s(c)},get cursorStyle(){return h.k},set cursorStyle(c){h.t(c)},get lineNumbers(){return h.l},set lineNumbers(c){h.u(c)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const E=Math.floor(p);return E>0?E:null}if(typeof p=="string"){const E=parseInt(p,10);return isNaN(E)?null:E>0?E:null}return null}n(p){const E=this.m(p);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const E=Math.floor(p);return E>0?E:null}if(typeof p=="string"){const E=parseInt(p,10);return isNaN(E)?null:E>0?E:null}return null}p(p){const E=this.o(p);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const E=this.q(p);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(p)})))}assign(p){const E={};let v=!1;if(typeof p.tabSize<"u"){const d=this.m(p.tabSize);d==="auto"?(v=!0,E.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,v=!0,E.tabSize=d)}if(typeof p.indentSize<"u"){const d=this.o(p.indentSize);d==="tabSize"?(v=!0,E.indentSize=d):typeof d=="number"&&this.h!==d&&(this.g=d,this.h=d,v=!0,E.indentSize=d)}if(typeof p.insertSpaces<"u"){const d=this.q(p.insertSpaces);d==="auto"?(v=!0,E.insertSpaces=d):this.j!==d&&(this.j=d,v=!0,E.insertSpaces=d)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,v=!0,E.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,v=!0,E.lineNumbers=A.TextEditorLineNumbersStyle.from(p.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(p,E){E.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(v)})}}e.$ZO=k;class I{constructor(p,E,v,d,h,c,i,n){this.id=p,this.j=E,this.k=v,this.g=!1,this.h=new Set,this.c=h,this.d=new k(this.j,this.id,c,v),this.e=i,this.f=n;const a=this;this.value=Object.freeze({get document(){return d.value},set document(r){throw new L.$9("document")},get selection(){return a.c&&a.c[0]},set selection(r){if(!(r instanceof R.$sM))throw(0,L.$7)("selection");a.c=[r],a.l()},get selections(){return a.c},set selections(r){if(!Array.isArray(r)||r.some(t=>!(t instanceof R.$sM)))throw(0,L.$7)("selections");a.c=r,a.l()},get visibleRanges(){return a.e},set visibleRanges(r){throw new L.$9("visibleRanges")},get options(){return a.d.value},set options(r){a.g||a.d.assign(r)},get viewColumn(){return a.f},set viewColumn(r){throw new L.$9("viewColumn")},edit(r,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new $(d.value,t);return r(f),a.m(f)},insertSnippet(r,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!t||Array.isArray(t)&&t.length===0)o=a.c.map(s=>A.Range.from(s));else if(t instanceof R.$qM){const{lineNumber:s,column:u}=A.Position.from(t);o=[{startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u}]}else if(t instanceof R.$rM)o=[A.Range.from(t)];else{o=[];for(const s of t)if(s instanceof R.$rM)o.push(A.Range.from(s));else{const{lineNumber:u,column:g}=A.Position.from(s);o.push({startLineNumber:u,startColumn:g,endLineNumber:u,endColumn:g})}}return E.$tryInsertSnippet(p,d.value.version,r.value,o,f)},setDecorations(r,t){const f=t.length===0;f&&!a.h.has(r.key)||(f?a.h.delete(r.key):a.h.add(r.key),a.n(()=>{if(A.$OO(t))return E.$trySetDecorations(p,r.key,A.$PO(t));{const o=new Array(4*t.length);for(let s=0,u=t.length;s<u;s++){const g=t[s];o[4*s]=g.start.line+1,o[4*s+1]=g.start.character+1,o[4*s+2]=g.end.line+1,o[4*s+3]=g.end.character+1}return E.$trySetDecorationsFast(p,r.key,o)}}))},revealRange(r,t){a.n(()=>E.$tryRevealRange(p,A.Range.from(r),t||R.TextEditorRevealType.Default))},show(r){E.$tryShowEditor(p,A.ViewColumn.from(r))},hide(){E.$tryHideEditor(p)}})}dispose(){(0,l.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,l.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,l.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,l.ok)(!this.g),this.f=p}_acceptSelections(p){(0,l.ok)(!this.g),this.c=p}async l(){const p=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const E=p.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const v=E.edits.map(h=>h.range);v.sort((h,c)=>h.end.line===c.end.line?h.end.character===c.end.character?h.start.line===c.start.line?h.start.character-c.start.character:h.start.line-c.start.line:h.end.character-c.end.character:h.end.line-c.end.line);for(let h=0,c=v.length-1;h<c;h++){const i=v[h].end;if(v[h+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=E.edits.map(h=>({range:A.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,d,{setEndOfLine:typeof E.setEndOfLine=="number"?A.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$1O=I}),define(ke[73],De([1,0,62,4,3,2,5,6,153,20,157,17,11,27,15,39,46]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=void 0;class c{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(a,r){this.h=a,this.i=r,this.a=null,this.b=new Map,this.c=new E.$Ac,this.d=new L.$he,this.e=new L.$he,this.f=new L.$he,this.g=new L.$he,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const r=[],t=[],f=[];if(a.removedDocuments)for(const o of a.removedDocuments){const s=A.URI.revive(o),u=this.c.get(s);u?.unref()&&(this.c.delete(s),r.push(u.value))}if(a.addedDocuments)for(const o of a.addedDocuments){const s=A.URI.revive(o.uri);let u=this.c.get(s);if(u&&s.scheme!==v.Schemas.vscodeNotebookCell&&s.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);u||(u=new c(new $.$UO(this.h.getProxy(w.$nM.MainThreadDocuments),s,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty)),this.c.set(s,u),t.push(u.value)),u.ref()}if(a.removedEditors)for(const o of a.removedEditors){const s=this.b.get(o);this.b.delete(o),s&&f.push(s)}if(a.addedEditors)for(const o of a.addedEditors){const s=A.URI.revive(o.documentUri);l.ok(this.c.has(s),`document '${s}' does not exist`),l.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const u=this.c.get(s).value,g=new I.$1O(o.id,this.h.getProxy(w.$nM.MainThreadTextEditors),this.i,new h.$V(()=>u.document),o.selections.map(P.Selection.to),o.options,o.visibleRanges.map(b=>P.Range.to(b)),typeof o.editorPosition=="number"?P.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,g)}a.newActiveEditor!==void 0&&(l.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,M.$Pc)(r),(0,M.$Pc)(f),a.removedDocuments&&this.e.fire(r),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return d.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const r=this.b.get(this.a);return a?r:r?.value}allEditors(){return[...this.b.values()]}};e.$2O=i,e.$2O=i=Je([We(0,k.$RO),We(1,p.$7j)],i),e.$3O=(0,R.$Ai)("IExtHostDocumentsAndEditors")}),define(ke[360],De([1,0,19,4,6,157,17,8]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class ${constructor(I,P){this.i=P,this.a=new L.$he,this.b=new L.$he,this.c=new L.$he,this.d=new L.$he,this.f=new L.$he,this.g=new L.$he,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(M.$nM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const P=this.i.allEditors();return I?P:P.map(p=>p.value)}async showTextDocument(I,P,p){let E;typeof P=="number"?E={position:R.ViewColumn.from(P),preserveFocus:p}:typeof P=="object"?E={position:R.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?R.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:E={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(I.uri,E),d=v&&this.i.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,P){return new A.$YO(this.h,I,P).value}$acceptEditorPropertiesChanged(I,P){const p=this.i.getEditor(I);if(!p)throw new Error("unknown text editor");if(P.options&&p._acceptOptions(P.options),P.selections){const E=P.selections.selections.map(R.Selection.to);p._acceptSelections(E)}if(P.visibleRanges){const E=l.$Hb(P.visibleRanges.map(R.Range.to));p._acceptVisibleRanges(E)}if(P.options&&this.b.fire({textEditor:p.value,options:{...P.options,lineNumbers:R.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const E=w.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(R.Selection.to);this.a.fire({textEditor:p.value,selections:v,kind:E})}if(P.visibleRanges){const E=l.$Hb(P.visibleRanges.map(R.Range.to));this.c.fire({textEditor:p.value,visibleRanges:E})}}$acceptEditorPositionData(I){for(const P in I){const p=this.i.getEditor(P);if(!p)throw new Error("Unknown text editor");const E=R.ViewColumn.to(I[P]);p.value.viewColumn!==E&&(p._acceptViewColumn(E),this.d.fire({textEditor:p.value,viewColumn:E}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$vmc=$}),define(ke[361],De([1,0,2,5,6,3,8,17,25,18]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=e.$eoc=void 0,e.$eoc=(0,L.$Ai)("IExtHostTimeline");class I{constructor(E,v){this.b=new Map,this.c=new Map,this.a=E.getProxy(M.$nM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(d,h)=>{if(d&&d.$mid===12)if(this.b.get(d.source)&&$.$Vm.equals(h,this.b.get(d.source)?.extension)){const c=d.uri===void 0?void 0:l.URI.revive(d.uri);return this.c.get(d.source)?.get(P(c))?.get(d.handle)}else return;return d}})}async $getTimeline(E,v,d,h){return this.b.get(E)?.provider.provideTimeline(l.URI.revive(v),d,h)}registerTimelineProvider(E,v,d,h){const c=new A.$Tc,i=this.d(v.id,h,c).bind(this);let n;v.onDidChange&&(n=v.onDidChange(r=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...r,id:v.id}),this));const a=this.c;return this.f({...v,scheme:E,onDidChange:void 0,async provideTimeline(r,t,f){t?.resetCache&&(c.clear(),a.get(v.id)?.clear());const o=await v.provideTimeline(r,t,f);if(o==null)return;const s=i(r,t);return{...o,source:v.id,items:o.items.map(s)}},dispose(){for(const r of a.values())r.get(v.id)?.clear();n?.dispose(),c.dispose()}},d)}d(E,v,d){return(h,c)=>{let i;if(c?.cacheResults){let n=this.c.get(E);n===void 0&&(n=new Map,this.c.set(E,n));const a=P(h);i=n.get(a),i===void 0&&(i=new Map,n.set(a,i))}return n=>{const{iconPath:a,...r}=n,t=`${E}|${n.id??n.timestamp}`;i?.set(t,n);let f,o,s;n.iconPath&&(a instanceof R.$mN?s={id:a.id,color:a.color}:l.URI.isUri(a)?(f=a,o=a):{light:f,dark:o}=a);let u;return R.$RM.isMarkdownString(r.tooltip)?u=w.MarkdownString.from(r.tooltip):(0,k.$ag)(r.tooltip)?u=r.tooltip:R.$RM.isMarkdownString(r.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=w.MarkdownString.from(r.detail)):(0,k.$ag)(r.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=r.detail),{...r,id:r.id??void 0,handle:t,source:E,command:n.command?v.toInternal(n.command,d):void 0,icon:f,iconDark:o,themeIcon:s,tooltip:u,accessibilityInformation:n.accessibilityInformation}}}}f(E,v){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:v}),(0,A.$Sc)(()=>{for(const h of this.c.values())h.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$foc=I;function P(p){return p?.toString()}}),define(ke[362],De([1,0,233,23,2,4,3,294,7,8,18,19,17,81,21,189,26]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=void 0;function c(a,r){if((0,I.$ag)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class i extends R.$Uc{constructor(r,t,f){super(),this.f=r,this.g=t,this.h=f,this.a=new Map,this.b=new d.$W0;function o(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:s=>o(s)?this.r(s):Array.isArray(s)&&s.length>0?s.map(u=>o(u)?this.r(u):u):s})}registerTreeDataProvider(r,t,f){const o=this.createTreeView(r,{treeDataProvider:t},f);return{dispose:()=>o.dispose()}}createTreeView(r,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=t.dragAndDropController?.dropMimeTypes??[],s=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,g=!!t.dragAndDropController?.handleDrop,b=this.m(r,t,f),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:o,dragMimeTypes:s,hasHandleDrag:u,hasHandleDrop:g,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this.f.$registerTreeViewDataProvider(r,S),y={get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get activeItem(){return(0,h.$OG)(f,"treeViewActiveItem"),b.focusedElement},get onDidChangeActiveItem(){return(0,h.$OG)(f,"treeViewActiveItem"),b.onDidChangeActiveItem},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get onDidChangeCheckboxState(){return b.onDidChangeCheckboxState},get message(){return b.message},set message(D){(0,E.$Zk)(D)&&(0,h.$OG)(f,"treeViewMarkdownMessage"),b.message=D},get title(){return b.title},set title(D){b.title=D},get description(){return b.description},set description(D){b.description=D},get badge(){return b.badge},set badge(D){D!==void 0&&k.ViewBadge.isViewBadge(D)?b.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(b.badge=void 0)},reveal:(D,C)=>b.reveal(D,C),dispose:async()=>{await m,this.a.delete(r),b.dispose()}};return this.B(y),y}$getChildren(r,t){const f=this.a.get(r);return f?f.getChildren(t):Promise.reject(new w.$$F(r))}async $handleDrop(r,t,f,o,s,u,g,b){const S=this.a.get(r);if(!S)return Promise.reject(new w.$$F(r));const m=p.DataTransfer.toDataTransfer(f,async y=>(await this.f.$resolveDropFileData(r,t,y)).buffer);return g===r&&b&&await this.j(m,S,b,s,u),S.onDrop(m,o,s)}async j(r,t,f,o,s){const u=this.b.removeDragOperationTransfer(s);if(u)(await u)?.forEach((g,b)=>{g&&r.set(b,g)});else if(s&&t.handleDrag){const g=t.handleDrag(f,r,o);this.b.addDragOperationTransfer(s,g),await g}return r}async $handleDrag(r,t,f,o){const s=this.a.get(r);if(!s)return Promise.reject(new w.$$F(r));const u=await this.j(new k.$iN,s,t,o,f);if(!(!u||o.isCancellationRequested))return p.DataTransfer.from(u)}async $hasResolve(r){const t=this.a.get(r);if(!t)throw new w.$$F(r);return t.hasResolve}$resolve(r,t,f){const o=this.a.get(r);if(!o)throw new w.$$F(r);return o.resolveTreeItem(t,f)}$setExpanded(r,t,f){const o=this.a.get(r);if(!o)throw new w.$$F(r);o.setExpanded(t,f)}$setSelectionAndFocus(r,t,f){const o=this.a.get(r);if(!o)throw new w.$$F(r);o.setSelectionAndFocus(t,f)}$setVisible(r,t){const f=this.a.get(r);if(!f){if(!t)return;throw new w.$$F(r)}f.setVisible(t)}$changeCheckboxState(r,t){const f=this.a.get(r);if(!f)throw new w.$$F(r);f.setCheckboxState(t)}m(r,t,f){const o=this.B(new n(r,t,this.f,this.g.converter,this.h,f));return this.a.set(r,o),o}r(r){const t=this.a.get(r.$treeViewId);return t&&"$treeItemHandle"in r?t.getExtensionElement(r.$treeItemHandle):t&&"$focusedTreeItem"in r&&r.$focusedTreeItem?t.focusedElement:null}}e.$goc=i;class n extends R.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(r=>this.getExtensionElement(r)).filter(r=>!(0,I.$jg)(r))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(r,t,f,o,s,u){if(super(),this.I=r,this.J=f,this.L=o,this.M=s,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$he),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$he),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$he),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$he),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$he),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$he),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$he),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$se,u.contributes&&u.contributes.views)for(const m in u.contributes.views)for(const y of u.contributes.views[m])y.id===r&&(this.P=y.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(m=>{Array.isArray(m)&&m.length===0||this.F.fire({message:!1,element:m})}));let g,b;const S=A.Event.debounce(this.F.event,(m,y)=>(m||(m={message:!1,elements:[]}),y.element!==!1&&(g||(g=new Promise(D=>b=D),this.G=this.G.then(()=>g)),Array.isArray(y.element)?m.elements.push(...y.element):m.elements.push(y.element)),y.message&&(m.message=!0),m),200,!0);this.B(S(({message:m,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const D=b;return g=null,this.$(y).then(()=>D())})),m&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(r){const t=r?this.getExtensionElement(r):void 0;if(r&&!t)return this.M.error(`No tree item with id '${r}' found.`),Promise.resolve([]);let f=this.X(r);return f||(f=await this.Y(t)),f?f.map(o=>o.item):void 0}getExtensionElement(r){return this.j.get(r)}reveal(r,t){t=t||{select:!0,focus:!1};const f=(0,I.$jg)(t.select)?!0:t.select,o=(0,I.$jg)(t.focus)?!1:t.focus,s=(0,I.$jg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):r?this.G.then(()=>this.S(r)).then(u=>this.W(r,u[u.length-1]).then(g=>this.J.$reveal(this.I,{item:g.item,parentChain:u.map(b=>b.item)},{select:f,focus:o,expand:s})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:f,focus:o,expand:s})}get message(){return this.O}set message(r){this.O=r,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(r){this.P=r,this.J.$setTitle(this.I,r,this.Q)}get description(){return this.Q}set description(r){this.Q=r,this.J.$setTitle(this.I,this.P,r)}get badge(){return this.R}set badge(r){this.R?.value===r?.value&&this.R?.tooltip===r?.tooltip||(this.R=p.ViewBadge.from(r),this.J.$setBadge(this.I,r))}setExpanded(r,t){const f=this.getExtensionElement(r);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(r,t){const f=!(0,P.$ub)(this.s,r);this.s=r;const o=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),o&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(r){r!==this.r&&(this.r=r,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(r){const t=(await Promise.all(r.map(async f=>{const o=this.getExtensionElement(f.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:f.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(r,t,f){const o=[];for(const s of r){const u=this.getExtensionElement(s);u&&o.push(u)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(r,t,f){const o=t?this.getExtensionElement(t):void 0;if(!(!o&&t||!this.g?.handleDrop))return(0,$.$sh)(()=>this.g?.handleDrop?this.g.handleDrop(o,r,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(r,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(r);if(f){const o=this.m.get(f);if(o){const s=await this.f.resolveTreeItem(o.extensionItem,f,t)??o.extensionItem;return this.hb(s),o.item.tooltip=this.eb(s.tooltip),o.item.command=this.fb(o.disposableStore,s.command),o.item}}}S(r){return this.U(r).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(o=>(f.push(o),f))):Promise.resolve([]))}U(r){const t=this.m.get(r);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$sh)(()=>this.f.getParent(r))}W(r,t){const f=this.m.get(r);return f?Promise.resolve(f):(0,$.$sh)(()=>this.f.getTreeItem(r)).then(o=>this.kb(r,o,t,!0)).then(o=>this.getChildren(t?t.item.handle:void 0).then(()=>{const s=this.getExtensionElement(o);if(s){const u=this.m.get(s);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${o} from extension ${this.N.identifier.value}`)}))}X(r){if(r){let t;if(typeof r=="string"){const f=this.getExtensionElement(r);t=f?this.m.get(f):void 0}else t=r;return t&&t.children||void 0}return this.h}async Y(r){this.rb(r);const t=new v.$se(this.Z.token);try{const f=r?this.m.get(r):void 0,o=await this.f.getChildren(r);if(t.token.isCancellationRequested)return;const s=(0,P.$Hb)(o||[]),u=await Promise.all((0,P.$Hb)(s).map(b=>this.f.getTreeItem(b)));if(t.token.isCancellationRequested)return;const g=u.map((b,S)=>b?this.db(s[S],b,f):null);return(0,P.$Hb)(g)}finally{t.dispose()}}$(r){if(r.some(f=>!f))return this.Z.dispose(!0),this.Z=new v.$se,this.tb(),this.J.$refresh(this.I);{const f=this.ab(r);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(r){const t=new Set,f=r.map(s=>this.m.get(s));for(const s of f)if(s&&!t.has(s.item.handle)){let u=s;for(;u&&u.parent&&f.findIndex(g=>u&&u.parent&&g&&g.item.handle===u.parent.item.handle)===-1;){const g=this.j.get(u.parent.item.handle);u=g?this.m.get(g):void 0}u&&!u.parent&&t.add(s.item.handle)}const o=[];return t.forEach(s=>{const u=this.j.get(s);if(u){const g=this.m.get(u);g&&(!g.parent||!t.has(g.parent.item.handle))&&o.push(s)}}),o}bb(r){const t={};return Promise.all(r.map(f=>this.cb(f).then(o=>{o&&(t[f]=o.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(r){const t=this.getExtensionElement(r);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,$.$sh)(()=>this.f.getTreeItem(t)).then(o=>{if(o){const s=this.ib(t,o,f.parent);return this.pb(t,s,f,f.parent),f.dispose(),s}return null})}return Promise.resolve(null)}db(r,t,f){const o=this.ib(r,t,f);if(t.id&&this.j.has(o.item.handle))throw new Error((0,l.localize)(0,null,t.id));return this.ob(r,o),this.qb(o,f),o}eb(r){return k.$RM.isMarkdownString(r)?p.MarkdownString.from(r):r}fb(r,t){return t?{...this.L.toInternal(t,r),originalId:t.command}:void 0}gb(r){if(r.checkboxState===void 0)return;let t,f,o;return typeof r.checkboxState=="number"?t=r.checkboxState:(t=r.checkboxState.state,f=r.checkboxState.tooltip,o=r.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:o}}hb(r){if(!k.$dN.isTreeItem(r,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(r,t,f){this.hb(t);const o=this.B(new R.$Tc),s=this.kb(r,t,f),u=this.lb(t);return{item:{handle:s,parentHandle:f?f.item.handle:void 0,label:c(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(o,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,I.$jg)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:o,dispose(){o.dispose()}}}jb(r){return r.iconPath instanceof k.$mN?r.iconPath:void 0}kb(r,{id:t,label:f,resourceUri:o},s,u){if(t)return`${n.b}/${t}`;const g=c(f,this.N),b=s?s.item.handle:n.a;let S=g?g.label:o?(0,L.$$g)(o):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const m=this.m.has(r)?this.m.get(r).item.handle:void 0,y=this.X(s)||[];let D,C=0;do{if(D=`${b}/${C}:${S}`,u||!this.j.has(D)||m===D)break;C++}while(C<=y.length);return D}lb(r){if(r.iconPath&&!(r.iconPath instanceof k.$mN))return typeof r.iconPath=="string"||M.URI.isUri(r.iconPath)?this.nb(r.iconPath):this.nb(r.iconPath.light)}mb(r){if(r.iconPath&&!(r.iconPath instanceof k.$mN)&&r.iconPath.dark)return this.nb(r.iconPath.dark)}nb(r){return M.URI.isUri(r)?r:M.URI.file(r)}ob(r,t){this.j.set(t.item.handle,r),this.m.set(r,t)}pb(r,t,f,o){this.j.delete(t.item.handle),this.m.delete(r),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(r,t);const s=this.X(o)||[],u=s.filter(g=>g.item.handle===f.item.handle)[0];u&&s.splice(s.indexOf(u),1,t)}qb(r,t){t?(t.children||(t.children=[]),t.children.push(r)):(this.h||(this.h=[]),this.h.push(r))}rb(r){if(r){const t=this.m.get(r);if(t){if(t.children)for(const f of t.children){const o=this.j.get(f.item.handle);o&&this.sb(o)}t.children=void 0}}else this.tb()}sb(r){const t=this.m.get(r);if(t){if(t.children)for(const f of t.children){const o=this.j.get(f.item.handle);o&&this.sb(o)}this.m.delete(r),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(r=>r.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[363],De([1,0,4,3,2,30,17,92,6,8]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class I extends L.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,d,h,c){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new l.$he),this.onDidDispose=this.#d.event,this.#h=this.B(new l.$he),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=d,this.#i=h,this.#n=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#u=c.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#i.dispose(),super.dispose())}get webview(){return this.c(),this.#i}get viewType(){return this.c(),this.#n}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,M.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,d){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:R.ViewColumn.from(v),preserveFocus:!!d})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends L.$Uc{static c(){return(0,A.$Wg)()}constructor(v,d,h){super(),this.j=d,this.m=h,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$nM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,d,h,c,i={}){const n=typeof c=="object"?c.viewColumn:c,a={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof c=="object"&&!!c.preserveFocus},r=(0,w.$Kmc)(v),t=P.c();this.f.$createWebviewPanel((0,w.$Mmc)(v),t,d,{title:h,panelOptions:p(i),webviewOptions:(0,w.$Nmc)(v,this.m,i),serializeBuffersForPostMessage:r},a);const f=this.j.createNewWebview(t,i,v);return this.createNewWebviewPanel(t,d,h,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(v){const d=Object.keys(v);d.sort((h,c)=>{const i=v[h],n=v[c];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const h of d){const c=this.getWebviewPanel(h);if(!c)continue;const i=v[h];c._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,d,h){if(this.h.has(d))throw new Error(`Serializer for '${d}' already registered`);return this.h.set(d,{serializer:h,extension:v}),this.f.$registerSerializer(d,{serializeBuffersForPostMessage:(0,w.$Kmc)(v)}),new k.$pM(()=>{this.h.delete(d),this.f.$unregisterSerializer(d)})}async $deserializeWebviewPanel(v,d,h,c){const i=this.h.get(d);if(!i)throw new Error(`No serializer found for '${d}'`);const{serializer:n,extension:a}=i,r=this.j.createNewWebview(v,h.webviewOptions,a),t=this.createNewWebviewPanel(v,d,h.title,c,h.panelOptions,r,h.active);await n.deserializeWebviewPanel(t,h.state)}createNewWebviewPanel(v,d,h,c,i,n,a){const r=new I(v,this.f,n,{viewType:d,title:h,viewColumn:c,panelOptions:i,active:a});return this.g.set(v,r),r}getWebviewPanel(v){return this.g.get(v)}}e.$Omc=P;function p(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(ke[364],De([1,0,4,3,92,17,6,8]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=void 0;class $ extends L.$Uc{#e;#t;#n;#i;#s;#r;#a;#o;#c;constructor(P,p,E,v,d,h){super(),this.#s=!1,this.#u=this.B(new l.$he),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new l.$he),this.onDidDispose=this.#l.event,this.#n=E,this.#a=v,this.#e=P,this.#t=p,this.#i=d,this.#r=h}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#i.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#o}set description(P){this.a(),this.#o!==P&&(this.#o=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#r}get webview(){return this.#i}get viewType(){return this.#n}_setVisible(P){P===this.#r||this.#s||(this.#r=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(P,p){this.d=p,this.b=new Map,this.c=new Map,this.a=P.getProxy(R.$nM.MainThreadWebviewViews)}registerWebviewViewProvider(P,p,E,v){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:E,extension:P}),this.a.$registerWebviewViewProvider((0,M.$Mmc)(P),p,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$Kmc)(P)}),new w.$pM(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(P,p,E,v,d){const h=this.b.get(p);if(!h)throw new Error(`No view provider found for '${p}'`);const{provider:c,extension:i}=h,n=this.d.createNewWebview(P,{},i),a=new $(P,this.a,p,E,n,!0);this.c.set(P,a),await c.resolveWebviewView(a,{state:v},d)}async $onDidChangeWebviewViewVisibility(P,p){this.e(P)._setVisible(p)}async $disposeWebviewView(P){const p=this.e(P);this.c.delete(P),p.dispose(),this.d.deleteWebview(P)}e(P){const p=this.c.get(P);if(!p)throw new Error("No webview found");return p}}e.$joc=k}),define(ke[365],De([1,0,70,15,11,265,33,12]),function(le,e,l,L,M,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=void 0;let $=class{constructor(P,p){P.addFileSystemProvider(L.Schemas.file,new k(p),{isCaseSensitive:w.$k})}};e.$1oc=$,e.$1oc=$=Je([We(0,l.$Gmc),We(1,M.$7j)],$);class k{constructor(P){this.b=P,this.a=new A.$fr(this.b)}async stat(P){const p=await this.a.stat(P);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,p,E){return this.a.writeFile(P,p,{...E,unlock:!1,atomic:!1})}delete(P,p){return this.a.delete(P,{...p,useTrash:!1,atomic:!1})}rename(P,p,E){return this.a.rename(P,p,E)}copy(P,p,E){return this.a.copy(P,p,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,p){throw new Error("Method not implemented.")}}}),define(ke[366],De([1,0,16,64,30,34,3,6,2,20]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=void 0;let I=class extends R.$Uc{constructor(p,E){super();const v=p.getProxy(w.$nM.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async d=>{const h=$.URI.file((0,l.$jc)((0,L.tmpdir)(),(0,M.$Wg)()));return await v.$download(d,h),h})}};e.$Yoc=I,e.$Yoc=I=Je([We(0,k.$RO),We(1,A.$bP)],I)}),define(ke[367],De([1,0,54,16,2,93,3,15,7,32]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0;class I extends A.$Imc{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==w.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const o=f.fsPath;let s=0;do{let u;s===0?u=o:u=/[/\\]$/.test(o)?`${o.substr(0,o.length-1)}-${s}`:`${o}-${s}`,await P(u);const g=L.$jc(u,"vscode.lock"),b=await d(this.d,g,!1);if(b)return this.i=b,process.on("exit",()=>{b.dispose()}),M.URI.file(u);s++}while(s<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$$oc=I;async function P(r){try{await k.Promises.stat(r);return}catch{}try{await k.Promises.mkdir(r,{recursive:!0})}catch{}}const p=1e3,E=10*60*1e3;class v extends R.$Uc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new $.$Lh),this.a.cancelAndSet(async()=>{const o=await h(t,f);(!o||o.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(f,new Date,new Date)}catch(s){t.error(s),t.info(`Lock '${f}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{l.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function d(r,t,f){try{const s={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(s),{flag:"wx"})}catch(s){r.error(s)}const o=await h(r,t);return!o||o.pid!==process.pid?f?(r.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(r.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(r,t)):(r.info(`Lock '${t}': Lock acquired.`),new v(r,t))}async function h(r,t){let f;try{f=await k.Promises.readFile(t)}catch(o){return r.error(o),null}try{return JSON.parse(String(f))}catch(o){return r.error(o),null}}async function c(r,t){let f;try{f=await k.Promises.stat(t)}catch(o){return r.error(o),0}return f.mtime.getTime()}function i(r){try{return process.kill(r,0),!0}catch{return!1}}async function n(r,t){const f=await h(r,t);if(!f)return r.info(`Lock '${t}': Could not read pid of lock holder.`),a(r,t);if(f.willReleaseAt){let b=f.willReleaseAt-Date.now();if(b<5e3){for(b>0?r.info(`Lock '${t}': The lockfile is scheduled to be released in ${b} ms.`):r.info(`Lock '${t}': The lockfile is scheduled to have been released.`);b>0;){if(await(0,$.$Bh)(Math.min(100,b)),await c(r,t)===0)return a(r,t);b=f.willReleaseAt-Date.now()}return a(r,t)}}if(!i(f.pid))return r.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),a(r,t);const o=await c(r,t),s=Date.now()-o;if(s<=E)return r.info(`Lock '${t}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;r.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$Bh)(2e3);const u=await c(r,t),g=Date.now()-u;return g<=E?(r.info(`Lock '${t}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(r.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),a(r,t))}async function a(r,t){r.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return d(r,t,!0)}}),define(ke[368],De([1,0,30,20,43,34]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=void 0;let R=class extends M.$5mc{constructor($,k){super(!0,$,k)}createTerminal($,k,I){return this.createTerminalFromOptions({name:$,shellPath:k,shellArgs:I})}createTerminalFromOptions($,k){const I=new M.$4mc(this.a,(0,l.$Wg)(),$,$.name);return this.f.push(I),I.create($,this.R($,k)),I.value}};e.$toc=R,e.$toc=R=Je([We(0,A.$bP),We(1,L.$RO)],R)}),define(ke[369],De([1,0,4,36,38,5]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JL=e.$IL=e.OutputChannelUpdateMode=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=void 0,e.$vL="text/x-code-output",e.$wL="output",e.$xL="Log",e.$yL="text/x-code-log-output",e.$zL="log",e.$AL="workbench.panel.output",e.$BL=new M.$Rj("inOutput",!1),e.$CL=new M.$Rj("activeLogOutput",!1),e.$DL=new M.$Rj("activeLogOutput.levelSettable",!1),e.$EL=new M.$Rj("activeLogOutput.level",""),e.$FL=new M.$Rj("activeLogOutput.levelIsDefault",!1),e.$GL=new M.$Rj("outputView.scrollLock",!1),e.$HL=(0,A.$Ai)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$IL={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new l.$he,this.onDidRegisterChannel=this.b.event,this.c=new l.$he,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(I=>k.push(I)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}L.$ho.add(e.$IL.OutputChannels,new w),e.$JL=new M.$Rj("activeOutputChannel","")}),define(ke[158],De([1,0,6,5,20,25,11,369,70,28,60,194,22,18,33,4,3]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=void 0;class c extends R.$ak{get disposed(){return this.n}constructor(r,t,f,o,s){super(),this.id=r,this.name=t,this.r=f,this.s=o,this.extension=s,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(r){this.append(r+`
`)}append(r){this.info(r)}clear(){const r=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,r)}replace(r){const t=this.m;this.info(r),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(r,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof r=="boolean"?r:t))}hide(){this.s.$close(this.id)}g(r,t){this.m+=p.$Je.fromString(t).byteLength,(0,R.log)(this.r,r,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends c{appendLine(r){this.append(r)}}let n=class{constructor(r,t,f,o,s,u){this.i=t,this.j=f,this.k=o,this.l=s,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=r.getProxy(l.$nM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(r){this.h=r;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(r,t,f){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");const o=typeof t=="object"&&t.log,s=(0,E.$ag)(t)?t:void 0;if((0,E.$ag)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const g=this.i.environment.extensionLogLevel?.find(([S])=>A.$Vm.equals(f.identifier,S))?.[1];g&&(u=(0,R.$lk)(g));const b=o?this.o(r,u,f):this.n(r,s,f);return b.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),o?this.r(r,u??this.m.getLevel(),b):this.q(r,b)}async n(r,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,s=this.k.extUri.joinPath(o,`${this.f++}-${r.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(r,s,t,f.identifier.value);return new c(g,r,u,this.a,f)}async o(r,t,f){const o=await this.p(f),s=r.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(o,`${s}.log`),g=`${f.identifier.value}.${s}`,b=this.l.createLogger(u,{id:g,name:r,logLevel:t,extensionId:f.identifier.value});return new i(g,r,b,this.a,f)}p(r){let t=this.d.get(r.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,r.identifier.value);this.d.set(r.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(o){if((0,v.$kl)(o)!==v.FileSystemProviderErrorCode.FileExists)throw o}return f})())}return t}q(r,t){let f=!1;const o=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return r},append(s){o(),t.then(u=>u.append(s))},appendLine(s){o(),t.then(u=>u.appendLine(s))},clear(){o(),t.then(s=>s.clear())},replace(s){o(),t.then(u=>u.replace(s))},show(s,u){o(),t.then(g=>g.show(s,u))},hide(){o(),t.then(s=>s.hide())},dispose(){f=!0,t.then(s=>s.dispose())}}}r(r,t,f){const o=new h.$Tc,s=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},u=o.add(new d.$he);function g(b){t=b,u.fire(b)}return f.then(b=>{o.add(b),b.logLevel!==t&&g(b.logLevel),o.add(b.onDidChangeLogLevel(S=>g(S)))}),{...this.q(r,f),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(b,...S){s(),f.then(m=>m.trace(b,...S))},debug(b,...S){s(),f.then(m=>m.debug(b,...S))},info(b,...S){s(),f.then(m=>m.info(b,...S))},warn(b,...S){s(),f.then(m=>m.warn(b,...S))},error(b,...S){s(),f.then(m=>m.error(b,...S))},dispose(){o.dispose()}}}};e.$Unc=n,e.$Unc=n=Je([We(0,M.$RO),We(1,k.$8O),We(2,$.$Gmc),We(3,I.$jmc),We(4,R.$8j),We(5,R.$7j)],n),e.$Vnc=(0,L.$Ai)("IExtHostOutputService")}),define(ke[159],De([1,0,5,7]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$kn=(0,l.$Ai)("remoteAgentService"),e.$ln=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let A=1/0;for(let w=0;w<this.maxSampleCount;w++){const $=await M.getRoundTripTime();if($===void 0)return;A=Math.min(A,$/2),await(0,L.$Bh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(A):R=this.initial.reduce((w,$)=>w+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:A,average:this.average.reduce((w,$)=>w+$,0)/this.average.length,high:typeof R>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[370],De([1,0,237,66,36,42,56,3,4,159,12,24,7]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gb=e.$7gb=e.$6gb=e.$5gb=e.$4gb=e.$3gb=e.$2gb=void 0,e.$2gb=Object.freeze({id:"application",order:100,title:(0,l.localize)(0,null),type:"object"}),e.$3gb=Object.freeze({id:"workbench",order:7,title:(0,l.localize)(1,null),type:"object"}),e.$4gb=Object.freeze({id:"security",scope:1,title:(0,l.localize)(2,null),type:"object",order:7}),e.$5gb=Object.freeze({id:"problems",title:(0,l.localize)(3,null),type:"object",order:101}),e.$6gb={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new $.$he,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const v=new E;M.$ho.add(e.$6gb.ConfigurationMigration,v);let d=class extends w.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const r of a.added)await this.f(r,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(a=>this.g(a,i?.uri))])}async g(i,n){const a=this.a.inspect(i.key,{resource:n}),r=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of r){const o=a[t];if(!o)continue;const s=[];if(o.value!==void 0){const u=await this.h(i,t,o.value,n,void 0);for(const g of u??[])s.push([g,[]])}for(const{identifiers:u,value:g}of o.overrides??[])if(g!==void 0){const b=await this.h(i,t,g,n,u);for(const S of b??[])s.push([S,u])}s.length&&await Promise.allSettled(s.map(async([[u,g],b])=>this.a.updateValue(u,g.value,{resource:n,overrideIdentifiers:b},f)))}}async h(i,n,a,r,t){const f=s=>{const g=this.a.inspect(s,{resource:r})[n];if(g)return t?g.overrides?.find(({identifiers:b})=>(0,P.$$n)(b,t))?.value:g.value},o=await i.migrateFn(a,f);return Array.isArray(o)?o:[[i.key,o]]}};e.$7gb=d,e.$7gb=d=Je([We(0,R.$7i),We(1,A.$Ji)],d);let h=class extends w.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new p.$Xh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$ho.as(L.$mo.Configuration).registerConfiguration({...e.$4gb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,l.localize)(4,null)},default:[],markdownDescription:(0,l.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,l.localize)(6,null),scope:2}}})}};e.$8gb=h,e.$8gb=h=Je([We(0,k.$kn)],h)}),define(ke[371],De([1,0,35,15,16,23,247,370,66,5,36]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$0gb=e.$9gb=void 0,e.$$gb=d,e.$_gb=h,e.$9gb=(0,k.$Ai)("editorResolverService"),e.$0gb="workbench.editorAssociations";const P=I.$ho.as($.$mo.Configuration),p={...w.$3gb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration(p);var E;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(E||(e.RegisteredEditorPriority=E={}));var v;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function d(c){switch(c){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function h(c,i){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(i.scheme))return!1;const r=typeof c=="string"&&c.indexOf(M.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,A.$$g)(i);return l.$tk(typeof c=="string"?c.toLowerCase():c,r.toLowerCase())}}),define(ke[372],De([1,0,31,15,16,12,23,2,5,284,42,148,159]),function(le,e,l,L,M,A,R,w,$,k,I,P,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=void 0,e.$2L=(0,$.$Ai)("pathService");let v=E=class{constructor(h,c,i,n){this.d=h,this.e=c,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??h})()}hasValidBasename(h,c,i){return typeof c=="string"||typeof c>"u"?this.a.then(n=>this.h(h,n,c)):this.h(h,c,i)}h(h,c,i){return h.scheme===L.Schemas.file||h.scheme===L.Schemas.vscodeRemote?(0,l.$xg)(i??(0,R.$$g)(h),c===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(h,c){if(h.remoteAuthority)return L.Schemas.vscodeRemote;const i=(0,k.$YL)(c.getWorkspace());if(i)return i;const n=c.getWorkspace().folders[0];if(n)return n.uri.scheme;const a=c.getWorkspace().configuration;return a?a.scheme:L.Schemas.file}userHome(h){return h?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(h=>h===1?M.$fc:M.$gc)}async fileURI(h){let c="";if(await this.a===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const n=h.indexOf("/",2);n===-1?(c=h.substring(2),h="/"):(c=h.substring(2,n),h=h.substring(n)||"/")}return w.URI.from({scheme:L.Schemas.file,authority:c,path:h,query:"",fragment:""})}};e.$3L=v,e.$3L=v=E=Je([We(1,p.$kn),We(2,P.$KL),We(3,I.$Ji)],v)}),define(ke[373],De([1,0,249,57,4,58,3,2,56,254,11,67,142,88,42,148,26,21,18,24,38]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=e.OnPortForward=e.$PL=e.$OL=e.TunnelSource=e.TunnelCloseReason=e.$ML=e.$LL=void 0,e.$NL=s,e.$QL=b,e.$RL=S,e.$SL=m,e.$TL=D;const r=10*1e3,t="remote.tunnels.toRestore",f="remote.tunnels.toRestoreExpiration",o=1e3*60*60*24*14;e.$LL="onTunnel",e.$ML=new a.$Rj("forwardedPortsViewEnabled",!1,l.localize(0,null));function s(z){const T=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}var u;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var g;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$OL={source:g.User,description:l.localize(1,null)},e.$PL={source:g.Auto,description:l.localize(2,null)};function b(z,T,F){const N=z.get(m(T,F));if(N)return N;if((0,E.$uw)(T))for(const j of E.$tw){const B=m(j,F);if(z.has(B))return z.get(B)}else if((0,E.$ww)(T))for(const j of E.$vw){const B=m(j,F);if(z.has(B))return z.get(B)}}function S(z,T,F){const N=b(z,T,F);if(N)return N;const j=(0,E.$ww)(T)?"localhost":(0,E.$uw)(T)?"0.0.0.0":void 0;if(j)return b(z,j,F)}function m(z,T){return z+":"+T}var y;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(y||(e.OnPortForward=y={}));function D(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}class C extends R.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new M.$he,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(F=>{(F.affectsConfiguration(C.c)||F.affectsConfiguration(C.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,F,N){let j=this.w(T,F,N,this.j,0);const B={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const X=this.j[j];X.key===T?(B.onAutoForward=X.onAutoForward??B.onAutoForward,B.elevateIfNeeded=X.elevateIfNeeded!==void 0?X.elevateIfNeeded:B.elevateIfNeeded,B.label=X.label??B.label,B.requireLocalPort=X.requireLocalPort,B.protocol=X.protocol):(B.onAutoForward=B.onAutoForward??X.onAutoForward,B.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:X.elevateIfNeeded,B.label=B.label??X.label,B.requireLocalPort=B.requireLocalPort!==void 0?B.requireLocalPort:void 0,B.protocol=B.protocol??X.protocol),j=this.w(T,F,N,this.j,j+1)}return B.onAutoForward!==void 0||B.elevateIfNeeded!==void 0||B.label!==void 0||B.requireLocalPort!==void 0||B.protocol!==void 0?B:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,i.$ag)(T.host)&&(0,i.$eg)(T.port)}w(T,F,N,j,B){if(B>=j.length)return-1;const X=!(0,E.$uw)(F)&&!(0,E.$ww)(F),H=j.slice(B).findIndex(K=>(0,i.$eg)(K.key)?X?!1:K.key===T:this.t(K.key)?X?!1:T>=K.key.start&&T<=K.key.end:this.u(K.key)?T===K.key.port&&F===K.key.host:N?K.key.test(N):!1);return H>=0?H+B:-1}y(){const T=this.r.getValue(C.c);if(!T||!(0,i.$cg)(T))return[];const F=[];for(const j in T){if(j===void 0)continue;const B=T[j];let X;if(Number(j))X=Number(j);else if((0,i.$ag)(j))if(C.g.test(j)){const ie=j.match(C.g);X={start:Number(ie[1]),end:Number(ie[2])}}else if(C.h.test(j)){const ie=j.match(C.h);X={host:ie[1],port:Number(ie[2])}}else{let ie;try{ie=RegExp(j)}catch{}ie&&(X=ie)}X&&F.push({key:X,elevateIfNeeded:B.elevateIfNeeded,onAutoForward:B.onAutoForward,label:B.label,requireLocalPort:B.requireLocalPort,protocol:B.protocol})}const N=this.r.getValue(C.f);return N&&(this.m={elevateIfNeeded:N.elevateIfNeeded,label:N.label,onAutoForward:N.onAutoForward,requireLocalPort:N.requireLocalPort,protocol:N.protocol}),this.z(F)}z(T){function F(N,j){return(0,i.$eg)(N.key)?N.key:j.t(N.key)?N.key.start:j.u(N.key)?N.key.port:Number.MAX_VALUE}return T.sort((N,j)=>F(N,this)-F(j,this))}C(){return this.m}static providedActionToAction(T){switch(T){case E.ProvidedOnAutoForward.Notify:return y.Notify;case E.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case E.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case E.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case E.ProvidedOnAutoForward.Silent:return y.Silent;case E.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(T,F,N){const B=this.r.inspect(C.c).userRemoteValue;let X;!B||!(0,i.$cg)(B)?X={}:X=(0,n.$7n)(B),X[`${T}`]||(X[`${T}`]={});for(const ie in F)X[`${T}`][ie]=F[ie];return this.r.updateValue(C.c,X,N)}}e.$UL=C;let O=class extends R.$Uc{constructor(T,F,N,j,B,X,ie,H,K,x){super(),this.H=T,this.I=F,this.J=N,this.L=j,this.M=B,this.N=X,this.O=ie,this.P=H,this.Q=K,this.R=x,this.c=new Map,this.g=new M.$he,this.onForwardPort=this.g.event,this.h=new M.$he,this.onClosePort=this.h.event,this.j=new M.$he,this.onPortName=this.j.event,this.n=new M.$he,this.onCandidatesChanged=this.n.event,this.t=new M.$he,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new M.$he,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new C(N),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const ge=await this.getAttributes(_.map(oe=>({port:oe.tunnelRemotePort,host:oe.tunnelRemoteHost})));for(const oe of _)if(oe.localAddress){const Pe=m(oe.tunnelRemoteHost,oe.tunnelRemotePort),me=S(this.m??new Map,oe.tunnelRemoteHost,oe.tunnelRemotePort);this.forwarded.set(Pe,{remotePort:oe.tunnelRemotePort,remoteHost:oe.tunnelRemoteHost,localAddress:oe.localAddress,protocol:ge?.get(oe.tunnelRemotePort)?.protocol??E.TunnelProtocol.Http,localUri:await this.X(oe.localAddress,ge?.get(oe.tunnelRemotePort)),localPort:oe.tunnelLocalPort,runningProcess:me?.detail,hasRunningProcess:!!me,pid:me?.pid,privacy:oe.privacy,source:e.$OL}),this.f.set(Pe,oe)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const ge=m(_.tunnelRemoteHost,_.tunnelRemotePort);if(!S(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!S(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!S(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const oe=S(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),Pe=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(ge,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:Pe?.protocol??E.TunnelProtocol.Http,localUri:await this.X(_.localAddress,Pe),localPort:_.tunnelLocalPort,closeable:!0,runningProcess:oe?.detail,hasRunningProcess:!!oe,pid:oe?.pid,privacy:_.privacy,source:e.$OL})}await this.cb(),this.f.set(ge,_),this.g.fire(this.forwarded.get(ge))})),this.B(this.H.onTunnelClosed(_=>this.W(_,u.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$LL))?(this.R.createKey(e.$ML.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,F){const N=m(T.host,T.port);this.forwarded.has(N)&&(this.forwarded.delete(N),await this.cb(),this.h.fire(T))}X(T,F){if(T.startsWith("http"))return w.URI.parse(T);const N=F?.protocol??"http";return w.URI.parse(`${N}://${T}`)}async Y(T){const F=this.N.getWorkspace(),N=F.configuration?(0,A.$oj)(F.configuration.path):F.folders.length>0?(0,A.$oj)(F.folders[0].uri.path):void 0;if(N===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${N}`}async Z(){return this.Y(t)}async $(){return this.Y(f)}async ab(){const T=this.I.get(t,1);if(T)return this.I.remove(t,1),await this.cb(),T;const F=await this.Z();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const F=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(N=>N.remotePort).join(", ")}`);for(const N of F){const j=S(this.detected,N.remoteHost,N.remotePort);N.source.source!==g.Extension&&!j||N.source.source===g.Extension&&j?await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,elevateIfNeeded:!0,source:N.source}):N.source.source===g.Extension&&!j&&this.D.set(m(N.remoteHost,N.remotePort),N)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new R.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(F=>F.startsWith(f));for(const F of T){const N=this.I.getNumber(F,0);if(N&&N<Date.now()){this.s=Promise.resolve(void 0);const j=F.replace(f,t);this.I.remove(F,0),this.I.remove(j,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),F=T.map(X=>({remoteHost:X.remoteHost,remotePort:X.remotePort,localPort:X.localPort,name:X.name,localAddress:X.localAddress,localUri:X.localUri,protocol:X.protocol,source:X.source}));let N;T.length>0&&(N=JSON.stringify(F));const j=await this.Z(),B=await this.$();!N&&j&&B?(this.I.remove(j,0),this.I.remove(B,0)):N!==this.y&&j&&B&&(this.I.store(j,N,0,0),this.I.store(B,Date.now()+o,0,0)),this.y=N}}async eb(T,F,N){if(!T.tunnelLocalPort||!N?.requireLocalPort||T.tunnelLocalPort===F)return;const j=new Date;if(this.db.getTime()+r>j.getTime())return;this.db=j;const B=l.localize(3,null,F,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(B)}async forward(T,F){return!this.z&&this.L.remoteAuthority&&await M.Event.toPromise(this.C.event),this.fb(T,F)}async fb(T,F){await this.Q.activateByEvent(e.$LL);const N=S(this.forwarded,T.remote.host,T.remote.port);F=F??(F!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const j=T.local!==void 0?T.local:T.remote.port;let B;if(N)return this.hb(N,T,F);{const X=this.L.remoteAuthority,ie=X?{getAddress:async()=>(await this.M.resolveAuthority(X)).authority}:void 0,H=m(T.remote.host,T.remote.port);this.c.set(H,!0),T=this.gb(H,T);const K=await this.H.openTunnel(ie,T.remote.host,T.remote.port,void 0,j,T.elevateIfNeeded?T.elevateIfNeeded:F?.elevateIfNeeded,T.privacy,F?.protocol);if(typeof K=="string")B=K;else if(K&&K.localAddress){const x=S(this.m??new Map,T.remote.host,T.remote.port),_=K.protocol?K.protocol===E.TunnelProtocol.Https?E.TunnelProtocol.Https:E.TunnelProtocol.Http:F?.protocol??E.TunnelProtocol.Http,ge={remoteHost:K.tunnelRemoteHost,remotePort:K.tunnelRemotePort,localPort:K.tunnelLocalPort,name:F?.label??T.name,closeable:!0,localAddress:K.localAddress,protocol:_,localUri:await this.X(K.localAddress,F),runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,source:T.source??e.$OL,privacy:K.privacy};return this.forwarded.set(H,ge),this.f.set(H,K),this.c.delete(H),await this.cb(),await this.eb(K,j,F),this.g.fire(ge),K}this.c.delete(H)}return B}gb(T,F){const N=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(N){const j=N.get(T);N.delete(T),j&&(F.name=j.name??F.name,F.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??F.local,F.privacy=F.privacy)}return F}async hb(T,F,N){const j=N?.label??F.name;let B;(function(ie){ie[ie.None=0]="None",ie[ie.Fire=1]="Fire",ie[ie.Reopen=2]="Reopen"})(B||(B={}));let X=B.None;switch(j!==T.name&&(T.name=j,X=B.Fire),(N?.protocol||T.protocol!==E.TunnelProtocol.Http)&&N?.protocol!==T.protocol&&(F.source=T.source,X=B.Reopen),F.privacy&&T.privacy!==F.privacy&&(X=B.Reopen),X){case B.Fire:{this.g.fire();break}case B.Reopen:await this.close(T.remoteHost,T.remotePort,u.User),await this.fb(F,N)}return S(this.f,F.remote.host,F.remote.port)}async name(T,F,N){const j=S(this.forwarded,T,F),B=m(T,F);if(j){j.name=N,await this.cb(),this.j.fire({host:T,port:F});return}else this.detected.has(B)&&(this.detected.get(B).name=N,this.j.fire({host:T,port:F}))}async close(T,F,N){const j=m(T,F),B=this.forwarded.get(j);return N===u.AutoForwardEnd&&B&&B.source.source===g.Auto&&this.F.set(j,{local:B.localPort,name:B.name,privacy:B.privacy}),await this.H.closeTunnel(T,F),this.W({host:T,port:F},N)}address(T,F){const N=m(T,F);return(this.forwarded.get(N)||this.detected.get(N))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const F of T){const N=S(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),j=typeof F.localAddress=="string"?F.localAddress:m(F.localAddress.host,F.localAddress.port);this.detected.set(m(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:j,protocol:E.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:N?.detail,hasRunningProcess:!!N,pid:N?.pid,privacy:E.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:l.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,j,E.TunnelPrivacyId.ConstantPrivate,E.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let F=T;this.r&&(F=await this.r(T));const N=this.ib(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(N.values()).map(j=>j.port).join(", ")}`),this.n.fire(N)}ib(T){const F=this.m??new Map,N=new Map;return this.m=N,T.forEach(j=>{const B=m(j.host,j.port);N.set(B,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),F.has(B)&&F.delete(B);const X=S(this.forwarded,j.host,j.port);X&&(X.runningProcess=j.detail,X.hasRunningProcess=!0,X.pid=j.pid)}),F.forEach((j,B)=>{const X=s(B);if(!X)return;const ie=S(this.forwarded,X.host,X.port);ie&&(ie.runningProcess=void 0,ie.hasRunningProcess=!1,ie.pid=void 0);const H=S(this.detected,X.host,X.port);H&&(H.runningProcess=void 0,H.hasRunningProcess=!1,H.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),F=await this.getAttributes(T.map(N=>({port:N.remotePort,host:N.remoteHost})),!1);if(F)for(const N of T){const j=F.get(N.remotePort);(j?.protocol||N.protocol!==E.TunnelProtocol.Http)&&j?.protocol!==N.protocol&&await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,source:N.source},j),j&&j.label&&j.label!==N.name&&await this.name(N.remoteHost,N.remotePort,j.label)}}async getAttributes(T,F=!0){const N=new Map,j=new Map;T.forEach(K=>{const x=S(this.m??new Map,E.$tw[0],K.port)??K;if(x){N.set(K.port,x);const _=D(x)?x.pid:void 0;j.has(_)||j.set(_,[]),j.get(_)?.push(K.port)}});const B=new Map;if(T.forEach(K=>{const x=this.configPortsAttributes.getAttributes(K.port,K.host,N.get(K.port)?.detail);x&&B.set(K.port,x)}),this.G.length===0||!F)return B.size>0?B:void 0;const X=await Promise.all(this.G.flatMap(K=>Array.from(j.entries()).map(x=>{const _=x[1],ge=N.get(_[0]);return K.providePortAttributes(_,ge?.pid,ge?.detail,c.CancellationToken.None)}))),ie=new Map;if(X.forEach(K=>K.forEach(x=>{x&&ie.set(x.port,x)})),!B&&!ie)return;const H=new Map;return T.forEach(K=>{const x=B.get(K.port),_=ie.get(K.port);H.set(K.port,{elevateIfNeeded:x?.elevateIfNeeded,label:x?.label,onAutoForward:x?.onAutoForward??C.providedActionToAction(_?.autoForwardAction),requireLocalPort:x?.requireLocalPort,protocol:x?.protocol})}),H}addAttributesProvider(T){this.G.push(T)}};e.$VL=O,Je([(0,L.$6h)(1e3)],O.prototype,"cb",null),e.$VL=O=Je([We(0,E.$ow),We(1,p.$7p),We(2,$.$7i),We(3,d.$KL),We(4,P.$Ll),We(5,v.$Ji),We(6,I.$7j),We(7,k.$Tw),We(8,h.$KG),We(9,a.$Sj)],O)}),define(ke[94],De([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$uK=e.$tK=void 0;class l{constructor(R,w){this.line=R,this.character=w}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,w){return new l(0,0)}with(R){return new l(0,0)}}e.$tK=l;class L{constructor(R,w,$,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(R,w),this.end=new l($,k)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$uK=L;var M;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(ke[37],De([1,0,19,35,24,31,14,5,16,13,94,7]),function(le,e,l,L,M,A,R,w,$,k,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$RK=e.$KK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$HK=e.$GK=e.$FK=e.$EK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.TextSearchCompleteMessageType=void 0,e.$BK=c,e.$CK=i,e.$DK=n,e.$IK=b,e.$JK=S,e.$LK=D,e.$MK=C,e.$NK=O,e.$OK=z,e.$PK=T,e.$QK=F,e.$SK=j,e.$UK=ie,e.$VK=H,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$vK="workbench.view.search",e.$wK="workbench.panel.search",e.$xK="workbench.view.search",e.$yK="search-result",e.$zK="search.exclude";const p="\u27EA ",E=" characters skipped \u27EB",v=(p.length+E.length+5)*2;e.$AK=(0,w.$Ai)("searchService");var d;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(d||(e.SearchProviderType=d={}));var h;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(h||(e.QueryType=h={}));function c(x){return!!x.preview}function i(x){return!!x.resource}function n(x){return!!x.message}var a;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class r{constructor(_){this.resource=_,this.results=[]}}e.$EK=r;class t{constructor(_,ge,oe,Pe){this.ranges=ge,this.webviewIndex=Pe;const me=Array.isArray(ge)?ge:[ge];if(oe&&oe.matchLines===1&&f(me)){_=(0,R.$6f)(_,oe.matchLines);let U="",Y=0,pe=0;const ce=Math.floor(oe.charsPerLine/5),ae=[];for(const se of me){const ue=Math.max(se.startColumn-ce,0),Q=se.startColumn+oe.charsPerLine;if(ue>pe+ce+v){const re=p+(ue-pe)+E;U+=re+_.slice(ue,Q),Y+=ue-(pe+re.length)}else U+=_.slice(pe,Q);ae.push(new s(0,se.startColumn-Y,se.endColumn-Y)),pe=Q}this.preview={text:U,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const U=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:_,matches:(0,l.$1b)(ge,Y=>new o(Y.startLineNumber-U,Y.startColumn,Y.endLineNumber-U,Y.endColumn))}}}}e.$FK=t;function f(x){const _=x[0].startLineNumber;for(const ge of x)if(ge.startLineNumber!==_||ge.endLineNumber!==_)return!1;return!0}class o{constructor(_,ge,oe,Pe){this.startLineNumber=_,this.startColumn=ge,this.endLineNumber=oe,this.endColumn=Pe}}e.$GK=o;class s extends o{constructor(_,ge,oe){super(_,ge,_,oe)}}e.$HK=s;var u;(function(x){x.List="list",x.Tree="tree"})(u||(e.ViewMode=u={}));var g;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function b(x,_=!0){const ge=x&&x.files&&x.files.exclude,oe=_&&x&&x.search&&x.search.exclude;if(!ge&&!oe)return;if(!ge||!oe)return ge||oe;let Pe=Object.create(null);return Pe=M.$0n(Pe,M.$7n(ge)),Pe=M.$0n(Pe,M.$7n(oe),!0),Pe}function S(x,_){return x.excludePattern&&L.$tk(x.excludePattern,_)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.$tk(x.includePattern,_)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(ge=>{const oe=ge.folder.fsPath;if(A.$zg(_,oe)){const Pe=$.$lc(oe,_);return!ge.includePattern||!!L.$tk(ge.includePattern,Pe)}else return!1}):!1:!0}var m;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class y extends Error{constructor(_,ge){super(_),this.code=ge}}e.$KK=y;function D(x){const _=x.message;if((0,k.$4)(x))return new y(_,m.canceled);try{const ge=JSON.parse(_);return new y(ge.message,ge.code)}catch{return new y(_,m.other)}}function C(x){const _={message:x.message,code:x.code};return new Error(JSON.stringify(_))}function O(x){return x.type==="error"?!0:x.type==="success"}function z(x){return x.type==="success"}function T(x){return!!x.path}function F(x,_,ge=!0){const oe=x.searchPath?x.searchPath:x.relativePath;return ge?(0,R.$3f)(oe,_):L.$tk(_,oe)}class N{constructor(_){this.path=_,this.results=[]}addMatch(_){this.results.push(_)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$RK=N;function j(x,_){const ge={...x||{},..._||{}};return Object.keys(ge).filter(oe=>{const Pe=ge[oe];return typeof Pe=="boolean"&&Pe})}class B{constructor(_,ge){this.c=null,this.a={..._.excludePattern||{},...ge.excludePattern||{}},this.b=L.$uk(this.a);let oe=_.includePattern;ge.includePattern&&(oe?oe={...oe,...ge.includePattern}:oe=ge.includePattern),oe&&(this.c=L.$uk(oe))}matchesExcludesSync(_,ge,oe){return!!(this.b&&this.b(_,ge,oe))}includedInQuerySync(_,ge,oe){return!(this.b&&this.b(_,ge,oe)||this.c&&!this.c(_,ge,oe))}includedInQuery(_,ge,oe){const Pe=this.b(_,ge,oe),me=()=>this.c?!!this.c(_,ge,oe):!0;return(0,P.$mh)(Pe)?Pe.then(U=>U?!1:me()):me()}hasSiblingExcludeClauses(){return X(this.a)}}e.$TK=B;function X(x){for(const _ in x)if(typeof x[_]!="boolean")return!0;return!1}function ie(x){if(!x)return;let _;return ge=>(_||(_=(x()||Promise.resolve([])).then(oe=>oe?K(oe):{})),_.then(oe=>!!oe[ge]))}function H(x){if(!x)return;let _;return ge=>{if(!_){const oe=x();_=oe?K(oe):{}}return!!_[ge]}}function K(x){const _={};for(const ge of x)_[ge]=!0;return _}}),define(ke[44],De([1,0,19,7,21,4,3,78,15,126,23,14,2,235,5,11,268,42,60,28,20,17,8,68,37,6,53]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r,t,f,o,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$Amc=void 0;function g(z,T,F){return new I.$3g(N=>y(N,F)).isEqual(z,T)}function b(z,T,F){return g(z.uri,T.uri,F)?0:(0,P.$uf)(z.uri.toString(),T.uri.toString())}function S(z,T,F){return z.index!==T.index?z.index<T.index?-1:1:g(z.uri,T.uri,F)?(0,P.$uf)(z.name,T.name):(0,P.$uf)(z.uri.toString(),T.uri.toString())}function m(z,T,F,N){const j=z.slice(0).sort((X,ie)=>F(X,ie,N)),B=T.slice(0).sort((X,ie)=>F(X,ie,N));return(0,l.$Eb)(j,B,(X,ie)=>F(X,ie,N))}function y(z,T){const F=T.getCapabilities(z.scheme);return!(F&&F&1024)}class D extends c.$Ti{static toExtHostWorkspace(T,F,N,j){if(!T)return{workspace:null,added:[],removed:[]};const{id:B,name:X,folders:ie,configuration:H,transient:K,isUntitled:x}=T,_=[],ge=F;F?ie.forEach((U,Y)=>{const pe=p.URI.revive(U.uri),ce=D.o(N||F,pe,j);ce?(ce.name=U.name,ce.index=U.index,_.push(ce)):_.push({uri:pe,name:U.name,index:Y})}):_.push(...ie.map(({uri:U,name:Y,index:pe})=>({uri:p.URI.revive(U),name:Y,index:pe}))),_.sort((U,Y)=>U.index<Y.index?-1:1);const oe=new D(B,X,_,!!K,H?p.URI.revive(H):null,!!x,U=>y(U,j)),{added:Pe,removed:me}=m(ge?ge.workspaceFolders:[],oe.workspaceFolders,b,j);return{workspace:oe,added:Pe,removed:me}}static o(T,F,N){for(let j=0;j<T.folders.length;j++){const B=T.workspaceFolders[j];if(g(B.uri,F,N))return B}}constructor(T,F,N,j,B,X,ie){super(T,N.map(H=>new c.$Ui(H)),j,B,ie),this.t=F,this.u=X,this.q=[],this.s=w.$Gi.forUris(ie),N.forEach(H=>{this.q.push(H),this.s.set(H.uri,H)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,F){return F&&this.s.get(T)&&(T=(0,I.$ah)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let C=class{constructor(T,F,N,j,B){this.c=new A.$he,this.onDidChangeWorkspace=this.c.event,this.g=new A.$he,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$je,this.C=new Map,this.h=j,this.s=N,this.t=B,this.j=new k.$Hm,this.k=new L.$zh,this.o=T.getProxy(s.$nM.MainThreadWorkspace),this.q=T.getProxy(s.$nM.MainThreadMessageService);const X=F.workspace;this.l=X?new D(X.id,X.name,[],!!X.transient,X.configuration?p.URI.revive(X.configuration):null,!!X.isUntitled,ie=>y(ie,N)):void 0}$initializeWorkspace(T,F){this.v=F,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,I.$$g)((0,I.$ah)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,F,N,...j){const B=[];if(Array.isArray(j)&&j.forEach(x=>{p.URI.isUri(x.uri)&&!B.some(_=>g(_.uri,x.uri,this.s))&&B.push({uri:x.uri,name:x.name||(0,I.$0g)(x.uri)})}),this.n||[F,N].some(x=>typeof x!="number"||x<0)||N===0&&B.length===0)return!1;const X=this.x?this.x.workspaceFolders:[];if(F+N>X.length)return!1;const ie=X.slice(0);ie.splice(F,N,...B.map(x=>({uri:x.uri,name:x.name||(0,I.$0g)(x.uri),index:void 0})));for(let x=0;x<ie.length;x++){const _=ie[x];if(ie.some((ge,oe)=>oe!==x&&g(_.uri,ge.uri,this.s)))return!1}ie.forEach((x,_)=>x.index=_);const{added:H,removed:K}=m(X,ie,S,this.s);if(H.length===0&&K.length===0)return!1;if(this.o){const x=T.displayName||T.name;this.o.$updateWorkspaceFolders(x,F,N,B).then(void 0,_=>{this.n=void 0;const ge={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(h.Severity.Error,(0,E.localize)(0,null,x,_.toString()),ge,[])})}return this.y(ie),!0}getWorkspaceFolder(T,F){if(this.x)return this.x.getWorkspaceFolder(T,F)}async getWorkspaceFolder2(T,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,F)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,F){let N,j="";if(typeof T=="string"?(N=p.URI.file(T),j=T):typeof T<"u"&&(N=T,j=T.fsPath),!N)return j;const B=this.getWorkspaceFolder(N,!0);if(!B)return j;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let X=(0,I.$dh)(B.uri,N);return F&&B.name&&(X=`${B.name}/${X}`),X}y(T){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:F,added:N,removed:j}=D.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:j}))}findFiles(T,F,N,j,B=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let X="",ie=!0;return F===null?ie=!1:F!==void 0&&(typeof F=="string"?X=F:X=F.pattern),this.z(T,void 0,{exclude:X,maxResults:N,useDefaultExcludes:ie,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(T,F={},N,j=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,T,F,j)}async z(T,F,N,j=M.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const B=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,X={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:B,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let ie;if(T){const{includePattern:H,folder:K}=O(r.GlobPattern.from(T));ie=K,X.includePattern=H}else{const{includePattern:H,folder:K}=O(r.GlobPattern.from(F));ie=K,X.filePattern=H}return this.o.$startFileSearch(ie??null,X,j).then(H=>Array.isArray(H)?H.map(K=>p.URI.revive(K)):[])}async findTextInFiles(T,F,N,j,B=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const X=this.j.getNext(),ie=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:H,folder:K}=O(r.GlobPattern.from(F.include)),x=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,_={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:ie,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:H,excludePattern:x},ge=!1;if(this.u[X]=oe=>{if(ge)return;const Pe=p.URI.revive(oe.resource);oe.results.forEach(me=>{const U=(0,u.$0h)(me);(0,o.$BK)(U)?N({uri:Pe,preview:{text:U.preview.text,matches:(0,l.$1b)(U.preview.matches,Y=>new t.$rM(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))},ranges:(0,l.$1b)(U.ranges,Y=>new t.$rM(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))}):N({uri:Pe,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const oe=await this.o.$startTextSearch(T,K??null,_,X,B);return delete this.u[X],oe||{}}catch(oe){throw delete this.u[X],oe}}$handleTextSearchResult(T,F){this.u[F]?.(T)}async save(T){const F=await this.o.$save(T,{saveAs:!1});return p.URI.revive(F)}async saveAs(T){const F=await this.o.$save(T,{saveAs:!0});return p.URI.revive(F)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,F){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,F);const N=this.t.transformOutgoingScheme(T),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,N),(0,R.$Sc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(T,F){this.h.info("Getting edit session identifier for workspaceFolder",T);const N=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const j=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!j),!j)return;const B=await j.provideEditSessionIdentity(N,F);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(T,F,N,j){this.h.info("Getting edit session identifier for workspaceFolder",T);const B=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const X=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!X),!X)return;const ie=await X.provideEditSessionIdentityMatch?.(F,N,j);if(this.h.info("Provider returned edit session identifier match result: ",ie),!!ie)return ie}getOnWillCreateEditSessionIdentityEvent(T){return(F,N,j)=>{const B=function(ie){F.call(N,ie)};return B.extension=T,this.B.event(B,void 0,j)}}async $onWillCreateEditSessionIdentity(T,F,N){const j=await this.resolveWorkspaceFolder(p.URI.revive(T));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},F,async(B,X)=>{const ie=Date.now();await Promise.resolve(B),Date.now()-ie>N&&this.h.warn("SLOW edit session create-participant",X.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(T,F){if(this.C.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.C.set(T,F);const N=this.t.transformOutgoingScheme(T),j=this.A++;return this.o.$registerCanonicalUriProvider(j,N),(0,R.$Sc)(()=>{this.C.delete(T),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(T,F,N){const j=this.C.get(T.scheme);if(!j)return;const B=await j.provideCanonicalUri?.(p.URI.revive(T),F,N);if(B)return B}async $provideCanonicalUri(T,F,N){return this.provideCanonicalUri(p.URI.revive(T),{targetScheme:F},N)}};e.$Amc=C,e.$Amc=C=Je([We(0,a.$RO),We(1,n.$8O),We(2,i.$jmc),We(3,d.$7j),We(4,f.$ymc)],C),e.$Bmc=(0,v.$Ai)("IExtHostWorkspace");function O(z){let T,F;return z&&(typeof z=="string"?T=z:(T=z.pattern,F=p.URI.revive(z.baseUri))),{includePattern:T,folder:F}}}),define(ke[45],De([1,0,24,4,44,6,8,270,66,18,7,5,20,11,2]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=e.$Dmc=e.$Cmc=void 0;function d(f,o){if(o){const s=o.split(".");let u=f;for(let g=0;u&&g<s.length;g++)u=u[s[g]];return u}}function h(f){return f instanceof v.URI}function c(f){return f&&f.uri instanceof v.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof v.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function a(f){if(h(f))return{resource:f};if(c(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let r=class{constructor(o,s,u){this.a=o.getProxy(A.$nM.MainThreadConfiguration),this.c=s,this.b=u,this.d=new I.$zh,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new t(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,s){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(o,s))}};e.$Cmc=r,e.$Cmc=r=Je([We(0,p.$RO),We(1,M.$Bmc),We(2,E.$7j)],r);class t{constructor(o,s,u,g){this.a=new L.$he,this.b=o,this.f=g,this.c=s,this.e=w.$Fo.parse(u,g),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,s){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$Fo.parse(o,this.f),this.d=this.k(o.configurationScopes),this.a.fire(this.j(s,u))}getConfiguration(o,s,u){const g=a(s)||{},b=this.g(o?d(this.e.getValue(void 0,g,this.c.workspace),o):this.e.getValue(void 0,g,this.c.workspace));o&&this.h(o,g,u?.identifier);function S(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(y){return typeof d(b,y)<"u"},get:(y,D)=>{this.h(o?`${o}.${y}`:y,g,u?.identifier);let C=d(b,y);if(typeof C>"u")C=D;else{let O;const z=(T,F)=>{if((0,k.$cg)(T)){let N;const j=()=>{O=O||(0,l.$7n)(b),N=N||d(O,F)};return new Proxy(T,{get:(B,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return j(),()=>N;if(O)return N=N||d(O,F),N[X];const ie=B[X];return typeof X=="string"?z(ie,`${F}.${X}`):ie},set:(B,X,ie)=>(j(),N&&(N[X]=ie),!0),deleteProperty:(B,X)=>(j(),N&&delete N[X],!0),defineProperty:(B,X,ie)=>(j(),N&&Object.defineProperty(N,X,ie),!0)})}return Array.isArray(T)?(0,l.$7n)(T):T};C=z(C,y)}return C},update:(y,D,C,O)=>{y=o?`${o}.${y}`:y;const z=S(C);return D!==void 0?this.b.$updateConfigurationOption(z,y,D,g,O):this.b.$removeConfigurationOption(z,y,g,O)},inspect:y=>{y=o?`${o}.${y}`:y;const D=this.e.inspect(y,g,this.c.workspace);if(D)return{key:y,defaultValue:(0,l.$7n)(D.policy?.value??D.default?.value),globalValue:(0,l.$7n)(D.user?.value??D.application?.value),workspaceValue:(0,l.$7n)(D.workspace?.value),workspaceFolderValue:(0,l.$7n)(D.workspaceFolder?.value),defaultLanguageValue:(0,l.$7n)(D.default?.override),globalLanguageValue:(0,l.$7n)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,l.$7n)(D.workspace?.override),workspaceFolderLanguageValue:(0,l.$7n)(D.workspaceFolder?.override),languageIds:(0,l.$7n)(D.overrideIdentifiers)}}};return typeof b=="object"&&(0,l.$0n)(m,b,!1),Object.freeze(m)}g(o){const s=u=>(0,k.$cg)(u)?new Proxy(u,{get:(g,b)=>s(g[b]),set:(g,b,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(g,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(g,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return s(o)}h(o,s,u){const g=$.$wo.test(o)?4:this.d.get(o),b=u?`[${u.value}] `:"";if(g===4){typeof s?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){s?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,s){const u=new w.$Ho(o,s,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(g,b)=>u.affectsConfiguration(g,a(b))})}k(o){return o.reduce((s,u)=>(s.set(u[0],u[1]),s),new Map)}}e.$Dmc=t,e.$Emc=(0,P.$Ai)("IExtHostConfiguration")}),define(ke[95],De([1,0,2,7,4,6,8,44,73,45,21,43,20,28,5,15,12,11,91,314,13]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=e.$8nc=e.$7nc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(z){function T(N){if(N!=null)return N}z.from=T;function F(N){if(N!=null)return N}z.to=F})(r||(r={}));var t;(function(z){function T(N){if(N!=null)return N}z.from=T;function F(N){if(N!=null)return N}z.to=F})(t||(t={}));var f;(function(z){function T(N){if(N!=null)return N}z.from=T;function F(N){if(N!=null)return N}z.to=F})(f||(f={}));var o;(function(z){function T(j){if(j){const B=j;return B&&!!B.process}else return!1}z.is=T;function F(j){if(j==null)return;const B={process:j.process,args:j.args};return j.options&&(B.options=f.from(j.options)),B}z.from=F;function N(j){if(j!=null)return new R.$_M(j.process,j.args,j.options)}z.to=N})(o||(o={}));var s;(function(z){function T(N){if(N!=null)return N}z.from=T;function F(N){if(N!=null)return N}z.to=F})(s||(s={}));var u;(function(z){function T(j){if(j){const B=j;return B&&(!!B.commandLine||!!B.command)}else return!1}z.is=T;function F(j){if(j==null)return;const B={};return j.commandLine!==void 0?B.commandLine=j.commandLine:(B.command=j.command,B.args=j.args),j.options&&(B.options=s.from(j.options)),B}z.from=F;function N(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new R.$aN(j.commandLine,j.options):new R.$aN(j.command,j.args?j.args:[],j.options)}z.to=N})(u||(u={}));var g;(function(z){function T(j){if(j){const B=j;return B&&B.customExecution==="customExecution"}else return!1}z.is=T;function F(j){return{customExecution:"customExecution"}}z.from=F;function N(j,B){return B.get(j)}z.to=N})(g||(e.CustomExecutionDTO=g={}));var b;(function(z){function T(F,N){let j;return F.scope!==void 0&&typeof F.scope!="number"?j=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?j=N.workspaceFile:j=n.$nI),{id:F._id,workspaceFolder:j}}z.from=T})(b||(e.TaskHandleDTO=b={}));var S;(function(z){function T(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}z.from=T})(S||(S={}));var m;(function(z){function T(j,B){if(j==null)return[];const X=[];for(const ie of j){const H=F(ie,B);H&&X.push(H)}return X}z.fromMany=T;function F(j,B){if(j==null)return;let X;j.execution instanceof R.$_M?X=o.from(j.execution):j.execution instanceof R.$aN?X=u.from(j.execution):j.execution&&j.execution instanceof R.$bN&&(X=g.from(j.execution));const ie=r.from(j.definition);let H;return j.scope?typeof j.scope=="number"?H=j.scope:H=j.scope.uri:H=R.TaskScope.Workspace,!ie||!H?void 0:{_id:j._id,definition:ie,name:j.name,source:{extensionId:B.identifier.value,label:j.source,scope:H},execution:X,isBackground:j.isBackground,group:S.from(j.group),presentationOptions:t.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}z.from=F;async function N(j,B,X){if(j==null)return;let ie;o.is(j.execution)?ie=o.to(j.execution):u.is(j.execution)?ie=u.to(j.execution):g.is(j.execution)&&(ie=g.to(j._id,X));const H=r.to(j.definition);let K;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?K=j.source.scope:K=await B.resolveWorkspaceFolder(l.URI.revive(j.source.scope)):K=R.TaskScope.Workspace),!H||!K)return;const x=new R.$cN(H,K,j.name,j.source.label,ie,j.problemMatchers);return j.isBackground!==void 0&&(x.isBackground=j.isBackground),j.group!==void 0&&(x.group=R.$$M.from(j.group._id),x.group&&j.group.isDefault&&(x.group=new R.$$M(x.group.id,x.group.label),j.group.isDefault===!0&&(x.group.isDefault=j.group.isDefault))),j.presentationOptions&&(x.presentationOptions=t.to(j.presentationOptions)),j._id&&(x._id=j._id),j.detail&&(x.detail=j.detail),x}z.to=N})(m||(e.TaskDTO=m={}));var y;(function(z){function T(N){return N}z.from=T;function F(N){if(N)return Object.assign(Object.create(null),N)}z.to=F})(y||(y={}));class D{#e;constructor(T,F,N){this._id=F,this.a=N,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let C=class{constructor(T,F,N,j,B,X,ie,H){this.q=new M.$he,this.r=new M.$he,this.s=new M.$he,this.u=new M.$he,this.a=T.getProxy(A.$nM.MainThreadTask),this.b=N,this.c=j,this.d=B,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=H,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,F,N){if(!N)return new R.$pM(()=>{});const j=this.x();return this.j.set(j,{type:F,provider:N,extension:T}),this.a.$registerTaskProvider(j,F),new R.$pM(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(T,F){this.a.$registerTaskSystem(T,F)}fetchTasks(T){return this.a.$fetchTasks(y.from(T)).then(async F=>{const N=[];for(const j of F){const B=await m.to(j,this.b,this.m);B&&N.push(B)}return N})}get taskExecutions(){const T=[];return this.k.forEach(F=>T.push(F)),T}terminateTask(T){if(!(T instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,F,N){const j=this.m.get(T.id);j&&(this.o.set(T.id,j),this.e.attachPtyToTerminal(F,await j.callback(N))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const F=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const F=await this.z(T.id);this.s.fire({execution:F,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const F=await this.z(T.id);this.u.fire({execution:F,exitCode:T.exitCode})}$provideTasks(T,F){const N=this.j.get(T);if(!N)return Promise.reject(new Error("no handler found"));const j=[],B=(0,L.$sh)(()=>N.provider.provideTasks(I.CancellationToken.None)).then(X=>this.v(F,j,N,X));return new Promise(X=>{B.then(ie=>{Promise.all(j).then(()=>{X(ie)})})})}async $resolveTask(T,F){const N=this.j.get(T);if(!N)return Promise.reject(new Error("no handler found"));if(F.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${N.type}].`);const j=await m.to(F,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const B=await N.provider.resolveTask(j,I.CancellationToken.None);if(!B)return;this.A(B,N);const X=m.from(B,N.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(X.execution)&&await this.y(X,B,!0),await this.w(X)}x(){return this.h++}async y(T,F,N){const j=await this.a.$createTaskId(T);!N&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,F.execution)),this.m.set(j,F.execution)}async z(T,F){if(typeof T=="string"){const B=this.l.get(T);if(!B)throw new a.$bb("Unexpected: The specified task is missing an execution");return B}const N=this.l.get(T.id);if(N)return N;let j;return F?j=Promise.resolve(new D(this,T.id,F)):j=m.to(T.task,this.b,this.m).then(B=>{if(!B)throw new a.$bb("Unexpected: Task does not exist.");return new D(this,T.id,B)}),this.l.set(T.id,j),j.then(B=>(this.k.set(T.id,B),B))}A(T,F){T._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const N=this.n.values();let j=N.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=N.next()}};e.$7nc=C,e.$7nc=C=Je([We(0,p.$RO),We(1,E.$8O),We(2,w.$Bmc),We(3,$.$3O),We(4,k.$Emc),We(5,P.$3mc),We(6,c.$7j),We(7,i.$fmc)],C);let O=class extends C{constructor(T,F,N,j,B,X,ie,H){super(T,F,N,j,B,X,ie,H),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:h.$h(0)})}async executeTask(T,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const N=m.from(F,T);if(N===void 0)throw new Error("Task is not valid");if(g.is(N.execution))await this.y(N,F,!1);else throw new a.$_;const j=await this.z(await this.a.$getTaskExecution(N),F);return this.a.$executeTask(N).catch(B=>{throw new Error(B)}),j}v(T,F,N,j){const B=[];if(j)for(const X of j){if(this.A(X,N),!X.definition||!T[X.definition.type]){const H=X.source?X.source:"No task source";this.f.warn(`The task [${H}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`)}const ie=m.from(X,N.extension);ie&&g.is(ie.execution)?(B.push(ie),F.push(this.y(ie,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:N.extension}}async w(T){if(g.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,F,N){}};e.$8nc=O,e.$8nc=O=Je([We(0,p.$RO),We(1,E.$8O),We(2,w.$Bmc),We(3,$.$3O),We(4,k.$Emc),We(5,P.$3mc),We(6,c.$7j),We(7,i.$fmc)],O),e.$9nc=(0,v.$Ai)("IExtHostTask")}),define(ke[374],De([1,0,37,29]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3K=void 0,e.$2K=M,e.$4K=A;function M(R){return"cellResults"in R}e.$3K="rawCell#";function A(R,w){let $=-1;const k=[];let I=[];return R.forEach(p=>{p.range.startLineNumber!==$&&I.length>0&&(k.push([...I]),I=[]),I.push(p),$=p.range.endLineNumber}),I.length>0&&k.push([...I]),k.map(p=>{const E=[],v=p[0].range.startLineNumber,d=p[p.length-1].range.endLineNumber;for(let h=v;h<=d;h++)E.push(w.getLineContent(h));return new l.$FK(E.join(`
`)+`
`,p.map(h=>new L.$At(h.range.startLineNumber-1,h.range.startColumn-1,h.range.endLineNumber-1,h.range.endColumn-1)))})}}),define(ke[375],De([1,0,229,22,4,3,27,14,18,2,33,112,6,34,17,8,48,346,154,24,15,304,374,371]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0;class o{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,g,b,S,m,y){this.q=b,this.r=S,this.s=m,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new M.$he,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$he,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$he,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$he,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$dmc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(p.$nM.MainThreadNotebook),this.c=u.getProxy(p.$nM.MainThreadNotebookDocuments),this.d=u.getProxy(p.$nM.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===13){const C=D.notebookEditor?.notebookUri,O=D.cell.handle,T=this.g.get(C)?.getCell(O);if(T)return T.apiCell}if(D&&D.$mid===14){const C=D.uri,O=this.g.get(C);if(O)return O.apiNotebook}return D}}),o.B(g)}getEditorById(u){const g=this.h.get(u);if(!g)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(u){for(const[g,b]of this.h)if(b.apiEditor===u)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,g){const b=this.g.get(u);if(!b&&!g)throw new Error(`NO notebook document for '${u}'`);return b}static u(u,g){if(!g)return;const b=g.filenamePattern.map(S=>v.NotebookExclusiveDocumentPattern.from(S)).filter(S=>S!==void 0);if(g.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:g.displayName,filenamePattern:b,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,g,b){const S=o.a++,m=typeof b.onDidChangeCellStatusBarItems=="function"?o.a++:void 0;this.f.set(S,b),this.b.$registerNotebookCellStatusBarItemProvider(S,m,g);let y;return m!==void 0&&(y=b.onDidChangeCellStatusBarItems(D=>this.b.$emitCellStatusBarEvent(m))),new d.$pM(()=>{this.f.delete(S),this.b.$unregisterNotebookCellStatusBarItemProvider(S,m),y?.dispose()})}async createNotebookDocument(u){const g=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&v.NotebookData.from(u.content)});return k.URI.revive(g)}async openNotebookDocument(u){const g=this.g.get(u);if(g)return g.apiNotebook;const b=await this.c.$tryOpenNotebook(u),S=this.g.get(k.URI.revive(b));return(0,$.$lg)(S?.apiNotebook)}async showNotebookDocument(u,g){k.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let b;typeof g=="object"?b={position:v.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(v.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:b={preserveFocus:!1};const S=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,b),m=S&&this.h.get(S)?.apiEditor;if(m)return m;throw S?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,g,b,S){const m=this.f.get(u),y=k.URI.revive(g),D=this.g.get(y);if(!D||!m)return;const C=D.getCellFromIndex(b);if(!C)return;const O=await m.provideCellStatusBarItems(C.apiCell,S);if(!O)return;const z=new A.$Tc,T=this.p.add([z]),N=(Array.isArray(O)?O:[O]).map(j=>v.NotebookStatusBarItem.from(j,this.i,z));return{cacheId:T,items:N}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,g,b,S,m){if((0,w.$$e)(g))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:g,serializer:b,options:S}),this.b.$registerNotebookSerializer(y,{id:u.identifier,location:u.extensionLocation},g,v.NotebookDocumentContentOptions.from(S),o.u(u,m)),(0,A.$Sc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(u,g,b){const S=this.x.get(u);if(!S)throw new Error("NO serializer found");const m=await S.serializer.deserializeNotebook(g.buffer,b);return new h.$Hw(v.NotebookData.from(m))}async $notebookToData(u,g,b){const S=this.x.get(u);if(!S)throw new Error("NO serializer found");const m=await S.serializer.serializeNotebook(v.NotebookData.to(g.value),b);return L.$Je.wrap(m)}async $saveNotebook(u,g,b,S,m){const y=k.URI.revive(g),D=this.x.get(u);if(!D)throw new Error("NO serializer found");const C=this.g.get(y);if(!C)throw new Error("Document NOT found");if(C.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new I.$pl((0,l.localize)(0,null,this.z(y)),6);const O={metadata:(0,n.$co)(C.apiNotebook.metadata,j=>!(D.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of C.apiNotebook.getCells()){const B=new d.$SN(j.kind,j.document.getText(),j.document.languageId,j.mime,D.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);B.metadata=(0,n.$co)(j.metadata,X=>!(D.options?.transientCellMetadata??{})[X]),O.cells.push(B)}await this.y(y,S);const z=await D.serializer.serializeNotebook(O,m);await this.s.value.writeFile(y,z);const T=this.s.getFileSystemProviderExtUri(y.scheme),F=await this.s.value.stat(y);return{name:T.basename(y),isFile:(F.type&I.FileType.File)!==0,isDirectory:(F.type&I.FileType.Directory)!==0,isSymbolicLink:(F.type&I.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&I.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((F.permissions??0)&I.FilePermission.Locked),etag:I.$Al({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(u,g,b,S,m){const y=this.x.get(u)?.serializer;if(!y)return{limitHit:!1,results:[]};const D=new R.$Bc;await(async(F,N,j)=>{await Promise.all(F.map(async B=>await Promise.all(B.filenamePatterns.map(X=>{const ie={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:X};return this.t.doInternalFileSearchWithCustomCallback(ie,N,H=>{H.forEach(K=>{D.has(K)||S.some(_=>B.isFromSettings&&!_.isFromSettings?!1:_.filenamePatterns.some(ge=>(0,f.$_gb)(ge,K)))||D.add(K)})}).catch(H=>{if(H.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw H})}))))})(b,m,g);const O=new R.$Ac;let z=!1;const T=Array.from(D).map(async F=>{const N=[];try{if(m.isCancellationRequested)return;if(g.maxResults&&[...O.values()].reduce((ie,H)=>ie+H.cellResults.length,0)>g.maxResults){z=!0;return}const j=[],B=this.g.get(F);if(B)B.apiNotebook.getCells().forEach(H=>j.push({input:H.document.getText(),outputs:H.outputs.flatMap(K=>K.items.map(x=>x.data.toString()))}));else{const ie=await this.s.value.readFile(F),H=L.$Je.fromString(ie.toString()),K=await y.deserializeNotebook(H.buffer,m);if(m.isCancellationRequested)return;v.NotebookData.from(K).cells.forEach(_=>j.push({input:_.source,outputs:_.outputs.flatMap(ge=>ge.items.map(oe=>oe.valueBytes.toString()))}))}if(m.isCancellationRequested)return;j.forEach((ie,H)=>{const K=g.contentPattern.pattern,x=new r.$XXb(ie.input,void 0,ie.outputs),_=x.findInInputs(K),ge=x.findInOutputs(K),oe=ge.flatMap(Pe=>(0,t.$4K)(Pe.matches,Pe.textBuffer)).map((Pe,me)=>(Pe.webviewIndex=me,Pe));if(_.length>0||ge.length>0){const Pe={index:H,contentResults:(0,t.$4K)(_,x.inputTextBuffer),webviewResults:oe};N.push(Pe)}});const X={resource:F,cellResults:N};O.set(F,X);return}catch{return}});return await Promise.all(T),{limitHit:z,results:[...O.values()]}}async y(u,g){const b=await this.s.value.stat(u);if(typeof g?.mtime=="number"&&typeof g.etag=="string"&&g.etag!==I.$zl&&typeof b.mtime=="number"&&typeof b.size=="number"&&g.mtime<b.mtime&&g.etag!==I.$Al({mtime:g.mtime,size:b.size}))throw new I.$pl((0,l.localize)(1,null),3,g)}z(u){return u.scheme===a.Schemas.file?u.fsPath:u.toString()}A(u,g,b){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const S=new i.$Anc(g,this.d,u,b.visibleRanges.map(v.NotebookRange.to),b.selections.map(v.NotebookRange.to),typeof b.viewColumn=="number"?v.ViewColumn.to(b.viewColumn):void 0);this.h.set(g,S)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const b of u.value.removedDocuments){const S=k.URI.revive(b),m=this.g.get(S);m&&(m.dispose(),this.g.delete(S),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(m.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===S.toString()&&this.h.delete(y.id)}if(u.value.addedDocuments){const b=[];for(const S of u.value.addedDocuments){const m=k.URI.revive(S.uri);if(this.g.has(m))throw new Error(`adding EXISTING notebook ${m} `);const y=new c.$znc(this.c,this.q,this.r,m,S);b.push(...S.cells.map(D=>c.$ync.asModelAddData(D))),this.g.get(m)?.dispose(),this.g.set(m,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(y.apiNotebook)}}if(u.value.addedEditors)for(const b of u.value.addedEditors){if(this.h.has(b.id))return;const S=k.URI.revive(b.documentUri),m=this.g.get(S);m&&this.A(m,b.id,b)}const g=[];if(u.value.removedEditors)for(const b of u.value.removedEditors){const S=this.h.get(b);S&&(this.h.delete(b),this.k?.id===S.id&&(this.k=void 0),g.push(S))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(S=>this.h.get(S)).filter(S=>!!S);const b=new Set;this.l.forEach(S=>b.add(S.id));for(const S of this.h.values()){const m=b.has(S.id);S._acceptVisibility(m)}this.l=[...this.h.values()].map(S=>S).filter(S=>S.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const g=E.$dP.String.with("notebookType","A notebook type"),b=new E.$fP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new E.$dP("data","Bytes to convert to data",m=>m instanceof Uint8Array,m=>L.$Je.wrap(m))],new E.$eP("Notebook Data",m=>v.NotebookData.to(m.value))),S=new E.$fP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new E.$dP("NotebookData","Notebook data to convert to bytes",m=>!0,m=>new h.$Hw(v.NotebookData.from(m)))],new E.$eP("Bytes",m=>m.buffer));u.registerApiCommand(b),u.registerApiCommand(S)}}e.$Jnc=o}),define(ke[376],De([1,0,16,21,47,35,23,40,37]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=void 0;class k{constructor(p,E,v){this.k=p,this.l=E,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&A.$uk(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&A.$uk(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const E=this.k.folderQueries||[];return new Promise((v,d)=>{const h=c=>{this.f++,p(c)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const i=c.toString(),n=l.$nc(i);this.j&&this.j(i,n)||this.v(h,{base:c,basename:n})}),Promise.all(E.map(c=>this.p(c,h))).then(c=>{v({limitHit:this.e,stats:c[0]||void 0})},c=>{d(new Error((0,M.$lj)(c)))})})}async p(p,E){const v=new L.$se,d=this.q(p),h=this.r(),c=new $.$TK(this.k,p),i=!c.hasSiblingExcludeClauses();let n;try{this.h.add(v),n=w.$be.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,v.token),r=n.elapsed(),t=w.$be.create();return this.g&&!this.e||(a&&a.forEach(f=>{const o=l.$gc.relative(p.folder.path,f.path);if(i){const s=l.$nc(f.path);this.v(E,{base:p.folder,relativePath:o,basename:s});return}this.s(h,p.folder,o,E)}),this.g&&!this.e)?null:(this.u(h,c,E),{providerTime:r,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(p){const E=(0,$.$SK)(this.k.includePattern,p.includePattern),v=(0,$.$SK)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:v,includes:E,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},E,v,d){if(v===this.a){const c=l.$nc(this.a);this.v(d,{base:E,relativePath:this.a,basename:c})}function h(c){const i=l.$nc(c),n=l.$mc(c);let a=p[n];a||(a=p[n]=[],h(n)),a.push({base:E,relativePath:c,basename:i})}h(v)}u({rootEntries:p,pathToEntries:E},v,d){const h=this,c=this.a;function i(n){const a=(0,$.$VK)(()=>n.map(r=>r.basename));for(let r=0,t=n.length;r<t;r++){const f=n[r],{relativePath:o,basename:s}=f;if(v.matchesExcludesSync(o,s,c!==s?a:void 0))continue;const u=E[o];if(u)i(u);else{if(o===c)continue;h.v(d,f)}if(h.e)break}}i(p)}v(p,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(E))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,E,v,d){const h=this.c(p.cacheKey),c=new k(p,E,h&&h.token);let i=0;const n=a=>{i+=a.length,v(a.map(r=>this.d(r)))};return this.e(c,I.a,n,d).then(a=>({limitHit:a.limitHit,stats:a.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:a.stats}:void 0,messages:[]}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new L.$se),this.b.get(p)}d(p){return p.relativePath?{resource:R.$bh(p.base,p.relativePath)}:{resource:p.base}}e(p,E,v,d){const h=d.onCancellationRequested(()=>{p.cancel()}),c=n=>{n&&(i.push(n),E>0&&i.length>=E&&(v(i),i=[]))};let i=[];return p.search(c).then(n=>(i.length&&v(i),h.dispose(),n),n=>(i.length&&v(i),h.dispose(),Promise.reject(n)))}}e.$Bnc=I}),define(ke[377],De([1,0,19,74,35,103,27,15,16,23,14,18,2,100,250,56,11,42,147,372,37]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=void 0,e.$5L=S;let r=class{constructor(y,D,C,O,z){this.a=y,this.b=D,this.c=C,this.d=O,this.e=z}text(y,D,C={}){y=this.f(y,C);const O=this.a.getValue(),z=D&&D.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(D?.map(c.$Vi),C),type:2,contentPattern:y,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:O.search.usePCRE2||z||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(y,D){const C=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const O={...y,wordSeparators:C.editor.wordSeparators};return this.j(y,D)&&(O.isCaseSensitive=!0),this.k(y)&&(O.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),O}file(y,D={}){return{...this.h(y,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey,shouldGlobMatchFilePattern:D.shouldGlobSearch}}g(y,D){return y?(y=Array.isArray(y)?y.map(u):u(y),D?this.parseSearchPaths(y):{pattern:f(...Array.isArray(y)?y:[y])}):{}}h(y=[],D={}){const C=this.g(D.includePattern,D.expandPatterns),O=this.g(D.excludePattern,D.expandPatterns),z=y.length>1,T=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(j=>this.q(j,D,O)):y.map(j=>this.r(j,D,O,z))).filter(j=>!!j),F={_reason:D._reason,folderQueries:T,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:O.pattern,includePattern:C.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const j=l.$Hb(this.c.groups.flatMap(ie=>ie.editors.map(H=>H.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const B=j.filter(ie=>(0,a.$JK)(F,ie.fsPath)),X=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...F,...X}}const N=D.extraFileResources&&D.extraFileResources.filter(j=>(0,a.$JK)(F,j.fsPath));return F.extraFileResources=N&&N.length?N:void 0,F}i(y){const D=[],C=new R.$Ac,O={};let z=!1;return y.forEach(T=>{if(T.scheme===w.Schemas.walkThrough)return;if((0,k.$fh)(T)){const N=this.b.getWorkspaceFolder(T)?.uri??T.with({path:$.$mc(T.fsPath)});let j=C.get(N);j||(z=!0,j={folder:N,includePattern:{}},D.push(j),C.set(N,j));const B=$.$lc(N.fsPath,T.fsPath);(0,P.$lg)(j.includePattern)[B.replace(/\\/g,"/")]=!0}else T.fsPath&&(z=!0,O[T.fsPath]=!0)}),{folderQueries:D,includePattern:O,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(y,D){if(D.isSmartCase){if(y.isRegExp){if(I.$4f(y.pattern,!0))return!0}else if(I.$4f(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,E.$WC)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const D=X=>$.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),O=(Array.isArray(y)?y:o(y)).map(X=>{const ie=this.e.resolvedUserHome;return ie?(0,A.$Mw)(X,ie.scheme===w.Schemas.file?ie.fsPath:ie.path):X}),z=L.$K(O,X=>D(X)?"searchPaths":"exprSegments"),T=(z.exprSegments||[]).map(X=>I.$jf(X,"/")).map(X=>I.$jf(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),s(X))),F={},N=this.m(z.searchPaths||[]);N&&N.length&&(F.searchPaths=N);const j=T.flat(),B=f(...j);return B&&(F.pattern=B),F}l(y,D){return D.disregardExcludeSettings?void 0:(0,a.$IK)(y,!D.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const D=y.flatMap(O=>{let{pathPortion:z,globPortion:T}=t(O);return T&&(T=g(T)),this.n(z).flatMap(N=>this.o(N,T))}),C=new Map;return D.forEach(O=>{const z=O.searchPath.toString(),T=C.get(z);T?O.pattern&&(T.pattern=T.pattern||{},T.pattern[O.pattern]=!0):C.set(z,{searchPath:O.searchPath,pattern:O.pattern?f(O.pattern):void 0})}),Array.from(C.values())}n(y){if($.$ic(y)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==w.Schemas.file?[{searchPath:D[0].uri.with({path:y})}]:[{searchPath:p.URI.file($.$hc(y))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(y=u(y),y.startsWith("../")||y===".."){const O=$.$gc.resolve(D.path,y);return[{searchPath:D.with({path:O})}]}const C=g(y);return[{searchPath:D,pattern:C}]}else{if(y==="./"||y===".\\")return[];{const D=y.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(z=>{const T=D.match(new RegExp(`^${I.$df(z.name)}(?:/(.*)|$)`));return T?{match:T,folder:z}:null}).filter(P.$ig);if(O.length)return O.map(z=>{const T=z.match[1];return{searchPath:z.folder.uri,pattern:T&&g(T)}});{const z=y.match(/\.[\/\\](.+)[\/\\]?/),T=z?z[1]:y,F=v.localize(0,null,T);throw new Error(F)}}}}o(y,D){const C=y.pattern&&D?`${y.pattern}/${D}`:y.pattern||D,O=[{searchPath:y.searchPath,pattern:C}];return C&&!C.endsWith("**")&&O.push({searchPath:y.searchPath,pattern:C+"/**"}),O}q(y,D,C){const O=this.r((0,c.$Vi)(y.searchPath),D,C,!1);return O?{...O,includePattern:y.pattern}:null}r(y,D,C,O){let z;const T=p.URI.isUri(y)?y:y.uri;if(C.searchPaths){const X=C.searchPaths.filter(ie=>(0,k.$7g)(ie.searchPath,T))[0];if(X&&!X.pattern)return null;X&&(z=X.pattern)}const F=this.a.getValue({resource:T}),j={...this.l(F,D)||{},...z||{}},B=p.URI.isUri(y)?(0,k.$$g)(y):y.name;return{folder:T,folderName:O?B:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!F.search.followSymlinks}}};e.$4L=r,e.$4L=r=Je([We(0,d.$7i),We(1,c.$Ji),We(2,i.$5D),We(3,h.$7j),We(4,n.$2L)],r);function t(m){const y=m.match(/[\*\{\}\(\)\[\]\?]/);if(y){const D=y.index,C=m.substr(0,D).match(/[/|\\][^/\\]*$/);if(C){let O=m.substr(0,C.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:m.substr((C.index||0)+1)}}}return{pathPortion:m}}function f(...m){return m.length?m.reduce((y,D)=>(y[D]=!0,y),Object.create(null)):void 0}function o(m){return M.$sk(m,",").map(y=>y.trim()).filter(y=>!!y.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function u(m){return m.replace(/\\/g,"/")}function g(m){return u(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(m){return m.replace(/([?*[\]])/g,"[$1]")}function S(m,y){m=l.$Mb(m,O=>O.toString());const D=[],C=y.getWorkspace();return m&&m.forEach(O=>{let z;if(y.getWorkbenchState()===2)z=(0,k.$dh)(C.folders[0].uri,O),z&&z!=="."&&(z="./"+z);else{const T=y.getWorkspaceFolder(O);if(T){const F=T.name;if(C.folders.filter(j=>j.name===F).length===1){const j=(0,k.$dh)(T.uri,O);j===""?z=`./${T.name}`:z=`./${T.name}/${j}`}else z=O.fsPath}}z&&D.push(b(z))}),D}}),define(ke[378],De([1,0,23,2,21,13,5,377,37,42,7]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9wb=p,e.$0wb=d;const P=7e3;function p(h,c){const i=c.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],a=[];for(const u of i)if(/^workspaceContains:/.test(u)){const g=u.substr(18);g.indexOf("*")>=0||g.indexOf("?")>=0||h.forceUsingSearch?a.push(g):n.push(g)}if(n.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:r,resolve:t}=(0,I.$th)(),f=u=>t({activationEvent:u}),o=Promise.all(n.map(u=>E(h,u,f))).then(()=>{}),s=v(h,c.identifier,a,f);return Promise.all([o,s]).then(()=>{t(void 0)}),r}async function E(h,c,i){for(const n of h.folders)if(await h.exists(l.$bh(L.URI.revive(n),c))){i(`workspaceContains:${c}`);return}}async function v(h,c,i,n){if(i.length===0)return Promise.resolve(void 0);const a=new M.$se,r=h.checkExists(h.folders,i,a.token),t=setTimeout(async()=>{a.cancel(),h.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let f=!1;try{f=await r}catch(o){A.$4(o)||A.$1(o)}a.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function d(h,c,i,n){const a=h.get(R.$zi),r=h.get($.$AK),f=a.createInstance(w.$4L).file(c.map(o=>(0,k.$Vi)(L.URI.revive(o))),{_reason:"checkExists",includePattern:i,exists:!0});return r.fileSearch(f,n).then(o=>!!o.limitHit,o=>A.$4(o)?!1:Promise.reject(o))}}),define(ke[49],De([1,0,225,16,59,23,7,3,78,2,11,6,45,310,119,44,26,149,13,25,22,287,8,67,5,28,93,20,107,71,43,122,4,378,118,289,15,116,40,12,117]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r,t,f,o,s,u,g,b,S,m,y,D,C,O,z,T,F,N,j,B){"use strict";var X;Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=e.$gnc=e.$fnc=e.$enc=e.$dnc=void 0,e.$dnc=(0,o.$Ai)("IHostUtils");let ie=X=class extends w.$Uc{constructor(U,Y,pe,ce,ae,se,ue,Q,re,$e,we,Ne,Se){super(),this.Y=Ne,this.Z=Se,this.a=this.B(new D.$he),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=Y,this.g=pe,this.f=ue,this.j=ce,this.m=ae,this.s=se,this.t=re,this.u=$e,this.w=we,this.y=this.g.getProxy(P.$nM.MainThreadWorkspace),this.z=this.g.getProxy(P.$nM.MainThreadTelemetry),this.C=this.g.getProxy(P.$nM.MainThreadExtensionService),this.D=new R.$zh,this.F=new R.$zh,this.G=new R.$zh,this.H=new R.$zh,this.I=new Pe(this.f.extensions.activationEvents),this.L=new c.$Qac(this.I,this.f.extensions.allExtensions);const Ie=new n.$Wm(this.f.extensions.myExtensions);this.J=new c.$Qac(this.I,ge(this.L,Ie)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${x(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${x(this.J)}`)),this.M=new v.$Ymc(this.g,this.s),this.N=new O.$9mc(this.g),this.O=Q,this.h=U.createChild(new b.$yi([v.$Zmc,this.M],[O.$0mc,this.N])),this.P=this.B(new E.$Xmc(this.J,this.L,{onExtensionActivationError:(Ae,je,V)=>{this.C.$onExtensionActivationError(Ae,i.$3(je),V)},actualActivateExtension:async(Ae,je)=>{if(c.$Qac.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,je),new E.$Wmc;const V=this.J.getExtensionDescription(Ae);return this.fb(V,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){i.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(U)}terminate(U,Y=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ce=>{this.s.error(ce)}),this.g.dispose();const pe=this.$();Promise.race([(0,R.$Bh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${Y}`):this.s.info(`Extension host exiting with code ${Y}`),this.s.flush(),this.s.dispose(),this.c.exit(Y)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const Y=await this.C.$getExtension(U);return Y&&{...Y,identifier:new n.$Vm(Y.identifier.value),extensionLocation:k.URI.revive(Y.extensionLocation)}}ab(U,Y){return this.P.activateByEvent(U,Y)}bb(U,Y){return this.P.activateById(U,Y)}activateByIdWithErrors(U,Y){return this.bb(U,Y).then(()=>{const pe=this.P.getActivatedExtension(U);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===T.Schemas.file&&this.c.fsRealpath){const Y=U.fsPath;this.R.has(Y)||this.R.set(Y,this.c.fsRealpath(Y));const pe=await this.R.get(Y);return k.URI.file(pe)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new oe(U))),this.Q}async db(U){const Y=$.$Gi.forUris(pe=>A.$5g.ignorePathCasing(pe));return await Promise.all(U.map(async pe=>{if(this.wb(pe)){const ce=await this.cb(pe.extensionLocation);Y.set(ce,pe)}})),Y}eb(U){let Y=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return Y;const pe=this.P.getActivatedExtension(U);if(!pe)return Y;try{typeof pe.module.deactivate=="function"&&(Y=Promise.resolve(pe.module.deactivate()).then(void 0,ce=>(this.s.error(ce),Promise.resolve(void 0))))}catch(ce){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(ce)}try{(0,w.$Pc)(pe.subscriptions)}catch(ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(ce)}return Y}async fb(U,Y){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,Y).then(pe=>{const ce=pe.activationTimes;return this.C.$onDidActivateExtension(U.identifier,ce.codeLoadingTime,ce.activateCallTime,ce.activateResolvedTime,Y),this.gb(U,Y,"success",ce),pe},pe=>{throw this.gb(U,Y,"failure"),pe})}gb(U,Y,pe,ce){const ae=K(U,Y);this.z.$publicLog2("extensionActivationTimes",{...ae,...ce||{},outcome:pe})}hb(U,Y){const pe=K(U,Y);this.z.$publicLog2("activatePlugin",pe);const ce=this.wb(U);if(!ce)return Promise.resolve(new E.$Vmc(E.$Smc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${U.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this.s.flush();const ae=new E.$Tmc(Y.startup);return Promise.all([this.xb(U,(0,A.$bh)(U.extensionLocation,ce),ae),this.ib(U)]).then(se=>(M.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),X.jb(this.s,U.identifier,se[0],se[1],ae))).then(se=>(M.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),se))}ib(U){const Y=this.Z.createLanguageModelAccessInformation(U),pe=new r.$2mc(U,this.M),ce=new r.$1mc(U.identifier.value,!1,this.M),ae=new z.$$mc(U,this.N),se=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ue=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([pe.whenReady,ce.whenReady,this.O.whenReady]).then(()=>{const Q=this;let re,$e;const we=(0,h.$NG)(U,"ipc")?this.f.messagePorts?.get(n.$Vm.toKey(U.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:ce,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return Y},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ne){return L.$jc(U.extensionLocation.fsPath,Ne)},get storagePath(){return Q.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return Q.O.globalValue(U).fsPath},get logPath(){return L.$jc(Q.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return k.URI.joinPath(Q.f.logsLocation,U.identifier.value)},get storageUri(){return Q.O.workspaceValue(U)},get globalStorageUri(){return Q.O.globalValue(U)},get extensionMode(){return se},get extension(){return re===void 0&&(re=new _(Q,U.identifier,U,ue,!1)),re},get extensionRuntime(){return(0,h.$OG)(U,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!$e){if(!we)return;const Ne=D.Event.buffer(D.Event.fromDOMEventEmitter(we,"message",Se=>Se.data));we.start(),$e={onDidReceiveMessage:Ne,postMessage:we.postMessage.bind(we)}}return $e}})})}static jb(U,Y,pe,ce,ae){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(U,Y,pe,ce,ae).then(se=>new E.$Umc(!1,null,ae.build(),pe,se,ce.subscriptions))}static kb(U,Y,pe,ce,ae){if(typeof pe.activate=="function")try{ae.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const se=typeof global=="object"?global:self,ue=pe.activate.apply(se,[ce]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(ue).then(Q=>(ae.activateResolveStop(),Q))}catch(se){return Promise.reject(se)}else return Promise.resolve(pe)}lb(U,Y){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:Y}).then(void 0,pe=>{this.s.error(pe)})}mb(U,Y=0){const ce=Date.now();(0,j.$B)(()=>{for(let ae=Y;ae<U.length;ae+=1){const se=U[ae];for(const ue of se.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ce>50){this.mb(U,ae);break}else this.lb(se,ue)}})}nb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(U=>{const Y=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(Y)this.mb(pe);else for(const ce of pe)if(ce.activationEvents)for(const ae of ce.activationEvents)ae==="onStartupFinished"&&this.lb(ce,ae)})}ob(){const U=this.ab("*",!0).then(void 0,se=>{this.s.error(se)});this.B(this.j.onDidChangeWorkspace(se=>this.pb(se.added)));const Y=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(Y),ce=this.rb(),ae=Promise.all([ce,U,pe]).then(()=>{});return Promise.race([ae,(0,R.$Bh)(1e4)]).then(()=>{this.nb()}),ae}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(Y=>this.qb(U,Y))).then(()=>{})}async qb(U,Y){if(this.isActivated(Y.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,ce={logService:this.s,folders:U.map(se=>se.uri),forceUsingSearch:pe||!this.c.fsExists,exists:se=>this.c.fsExists(se.fsPath),checkExists:(se,ue,Q)=>this.y.$checkExists(se,ue,Q)},ae=await(0,C.$9wb)(ce,Y);if(ae)return this.bb(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:ae.activationEvent}).then(void 0,se=>this.s.error(se))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:Y}=this.f.environment;if(!U||!Y)throw new Error(l.localize(0,null));const pe=await this.xb(null,Y,new E.$Tmc(!1));if(!pe||typeof pe.run!="function")throw new Error(l.localize(1,null,Y.toString()));return new Promise((ce,ae)=>{const se=(re,$e)=>{re?(j.$t&&this.s.error("Test runner called back with error",re),ae(re)):(j.$t&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),ce(typeof $e=="number"&&$e>0?1:0))},ue=(0,A.$2g)(Y),Q=pe.run(ue,se);Q&&Q.then&&Q.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),ce(0)}).catch(re=>{j.$t&&this.s.error("Test runner finished with error",re),ae(re instanceof Error&&re.stack?re.stack:String(re))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Bh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,Y){return this.S[U]=Y,(0,w.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:Y}=await this.ub(U);return Y?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const Y=U.indexOf("+");if(Y===-1)throw new t.$vM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=U.substr(0,Y);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(U,Y){const pe=N.$be.create(!1),ce=()=>`[resolveAuthority(${(0,f.$Pl)(U)},${Y})][${pe.elapsed()}ms] `,ae=W=>this.s.info(`${ce()}${W}`),se=W=>this.s.warn(`${ce()}${W}`),ue=(W,J=void 0)=>this.s.error(`${ce()}${W}`,J),Q=W=>{if(W instanceof t.$vM)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},re=async W=>{ae(`activating resolver for ${W}...`);const{resolver:J,authorityPrefix:Z}=await this.ub(W);if(!J)throw ue(`no resolver for ${Z}`),new t.$vM(`No remote extension installed to resolve ${Z}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:Z,remoteAuthority:W}},$e=U.split(/@|%40/g).reverse();ae(`activating remote resolvers ${$e.join(" -> ")}`);let we;try{we=await Promise.all($e.map(re)).catch(async W=>{if(!(W instanceof t.$vM)||W._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return se(`resolving nested authorities failed: ${W.message}`),[await re(U)]})}catch(W){return Q(W)}const Ne=new R.$Lh;Ne.cancelAndSet(()=>ae("waiting..."),1e3);let Se,Ie;for(const[W,{authorityPrefix:J,resolver:Z,remoteAuthority:he}]of we.entries())try{if(W===we.length-1)ae("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${J}`),Se=await Z.resolve(he,{resolveAttempt:Y,execServer:Ie}),M.mark(`code/extHost/didResolveAuthorityOK/${J}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Z,t.$uM.isManagedResolvedAuthority(Se)?Se:void 0));else{if(ae(`invoking resolveExecServer() for ${he}`),M.mark(`code/extHost/willResolveExecServer/${J}`),Ie=await Z.resolveExecServer?.(he,{resolveAttempt:Y,execServer:Ie}),!Ie)throw new t.$vM(`Exec server was not available for ${he}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(be){return M.mark(`code/extHost/didResolveAuthorityError/${J}`),ue("returned an error",be),Ne.dispose(),Q(be)}Ne.dispose();const Ae={environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures?{elevation:Se.tunnelFeatures.elevation,privacyOptions:Se.tunnelFeatures.privacyOptions,protocol:Se.tunnelFeatures.protocol===void 0?!0:Se.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${t.$uM.isManagedResolvedAuthority(Se)?"managed authority":`${Se.host}:${Se.port}`}`);let V;if(t.$uM.isManagedResolvedAuthority(Se)){const W=Y;this.Y.setFactory(W,Se.makeConnection),V={authority:U,connectTo:new f.$Ml(W),connectionToken:Se.connectionToken}}else V={authority:U,connectTo:new f.$Nl(Se.host,Se.port),connectionToken:Se.connectionToken};return{type:"ok",value:{authority:V,options:je,tunnelInformation:Ae}}}async $getCanonicalURI(U,Y){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$Pl)(U)})`);const{resolver:pe}=await this.ub(U);if(!pe)return null;const ce=k.URI.revive(Y);if(typeof pe.getCanonicalURI>"u")return ce;const ae=await(0,R.$sh)(()=>pe.getCanonicalURI(ce));return ae||ce}async $startExtensionHost(U){U.toAdd.forEach(se=>se.extensionLocation=k.URI.revive(se.extensionLocation));const{globalRegistry:Y,myExtensions:pe}=H(this.I,this.L,this.J,U),ce=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ce),this.L.set(Y.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${x(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${x(this.J)}`)),this.tb()}$activateByEvent(U,Y){return Y===1?this.D.wait().then(pe=>this.ab(U,!1)):this.G.wait().then(pe=>this.ab(U,!1))}async $activate(U,Y){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,Y),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(se=>se.extensionLocation=k.URI.revive(se.extensionLocation));const{globalRegistry:Y,myExtensions:pe}=H(this.I,this.L,this.J,U),ce=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(ce),this.L.set(Y.getAllExtensionDescriptions()),this.J.set(pe),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${x(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${x(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const Y=a.$Je.alloc(U),pe=Math.random()%256;for(let ce=0;ce<U;ce++)Y.writeUInt8(pe,ce);return Y}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$enc=ie,e.$enc=ie=X=Je([We(0,o.$zi),We(1,e.$dnc),We(2,g.$RO),We(3,d.$Bmc),We(4,p.$Emc),We(5,I.$7j),We(6,s.$8O),We(7,u.$Hmc),We(8,S.$_Db),We(9,m.$3mc),We(10,F.$anc),We(11,B.$bnc),We(12,y.$7mc)],ie);function H(me,U,Y,pe){me.addActivationEvents(pe.addActivationEvents);const ce=new c.$Qac(me,U.getAllExtensionDescriptions());ce.deltaExtensions(pe.toAdd,pe.toRemove);const ae=new n.$Wm(Y.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of pe.myToRemove)ae.delete(ue);for(const ue of pe.myToAdd)ae.add(ue);const se=ge(ce,ae);return{globalRegistry:ce,myExtensions:se}}function K(me,U){return{id:me.identifier.value,name:me.name,extensionVersion:me.version,publisherDisplayName:me.publisher,activationEvents:me.activationEvents?me.activationEvents.join(","):null,isBuiltin:me.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function x(me){return me.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$fnc=(0,o.$Ai)("IExtHostExtensionService");class _{#e;#t;#n;constructor(U,Y,pe,ce,ae){this.#e=U,this.#t=Y,this.#n=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=L.$hc((0,A.$2g)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=ce,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#n)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#n)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#n,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$gnc=_;function ge(me,U){return me.getAllExtensionDescriptions().filter(Y=>U.has(Y.identifier))}class oe{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$hnc=oe;class Pe{constructor(U){this.a=new n.$Xm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const Y of Object.keys(U))this.a.set(Y,U[Y])}}}),define(ke[379],De([1,0,59,2,6,45,26,25,20,28,5,49,11,14]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;let d=class{constructor(a,r,t,f,o,s,u){this.c=a,this.d=r,this.e=t,this.f=f,this.g=o,this.h=s,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),l.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new c(this.c,r,this.d,a,this.i)),this.register(this.e.createInstance(h)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,r,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const r of a.nodeModuleName)this.a.set(r,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(r=>a.alternativeModuleName(r))}};e.$qoc=d,e.$qoc=d=Je([We(2,I.$zi),We(3,A.$Emc),We(4,P.$fnc),We(5,k.$8O),We(6,p.$7j)],d);let h=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&v.a.size){const r=(0,E.$df)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${o}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const r=this.b.exec(this.c(a));if(!r)return;const[,t,f,o]=r,s=v.a.get(f);if(s!==void 0)return console.warn(`${f} as been renamed to ${s}, please update your imports`),t+s+o}c(a){return a.replace(/\\/g,"/")}};h=v=Je([We(0,k.$8O)],h);class c{constructor(a,r,t,f,o){this.c=a,this.d=r,this.e=t,this.f=f,this.g=o,this.nodeModuleName="vscode",this.a=new w.$Xm}load(a,r){const t=this.d.findSubstr(r);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((o,s)=>f+=`	${s} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${f}`),this.b=this.c(R.$IG,this.e,this.f)}return this.b}}let i=class{constructor(a,r,t){this.e=a,this.f=r,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$nM.MainThreadTelemetry);const f=t.getProxy(M.$nM.MainThreadWindow);this.c=(o,s)=>{const u=L.URI.parse(o);return s?this.g(o,s):u.scheme==="http"||u.scheme==="https"?f.$openUri(u,o,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?f.$openUri(u,o,{}):this.g(o,s)}}load(a,r,t){const f=this.e.findSubstr(r);return f&&(this.a=f.identifier.value,this.h()),this.b=t(a),this.c}g(a,r){return this.i(),this.b(a,r)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,$.$RO)],i)}),define(ke[61],De([1,0,46,3,16,52,5,73,72,49,8,44,307,45]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=e.$inc=void 0,e.$inc=(0,R.$Ai)("IExtHostVariableResolverProvider");class v extends p.$VP{constructor(c,i,n,a,r,t,f){function o(){if(n){const s=n.activeEditor();if(s)return s.document.uri;const u=a.tabGroups.all.find(g=>g.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof I.$bO||u.input instanceof I.$gO)return u.input.modified;if(u.input instanceof I.$aO||u.input instanceof I.$fO||u.input instanceof I.$dO)return u.input.uri}}}super({getFolderUri:s=>{const u=t.folders.filter(g=>g.name===s);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(s,u)=>r.getConfiguration(void 0,s).get(u),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=o();if(s)return M.$hc(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const s=o();if(s){const u=i.getWorkspaceFolder(s);if(u)return M.$hc(u.uri.fsPath)}}},getSelectedText:()=>{if(n){const s=n.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(n){const s=n.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>c.getExtension(s)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(A.env))}}let d=class extends L.$Uc{constructor(c,i,n,a,r){super(),this.b=c,this.c=i,this.g=n,this.h=a,this.j=r,this.a=new l.$V(async()=>{const t=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,o,this.m())})}getResolver(){return this.a.value}m(){}};e.$jnc=d,e.$jnc=d=Je([We(0,k.$fnc),We(1,P.$Bmc),We(2,w.$3O),We(3,E.$Emc),We(4,$.$Qmc)],d)}),define(ke[96],De([1,0,7,4,2,25,5,6,72,49,20,8,44,144,299,45,61,3,50,34,17,19]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=e.$nnc=e.$mnc=e.$lnc=e.$knc=void 0,e.$knc=(0,R.$Ai)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(S,m,y,D,C,O,z){this.N=m,this.O=y,this.P=D,this.Q=C,this.R=O,this.S=z,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new L.$he,this.o=new L.$he,this.q=new L.$he,this.w=new L.$he,this.l=S.getProxy(w.$nM.MainThreadDebugService),this.A=new L.$he,this.C=new L.$he,this.y=new o(this.l),this.z=new Map,this.O.getExtensionRegistry().then(T=>{T.onDidChange(F=>{this.V(T)}),this.V(T)})}async $getVisualizerTreeItem(S,m){const y=this.W(m);if(!y)return;const D=await this.H.get(S)?.getTreeItem?.(y);return D?this.U(S,D):void 0}registerDebugVisualizationTree(S,m,y){const D=A.$Vm.toKey(S.identifier),C=this.jb(D,m);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.H.set(C,y),this.l.$registerDebugVisualizerTree(C,!!y.editItem),(0,c.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(C),this.H.delete(m)})}async $getVisualizerTreeItemChildren(S,m){const y=this.J.get(m)?.item;return y?(await this.H.get(S)?.getChildren?.(y))?.map(C=>this.U(S,C))||[]:[]}async $editVisualizerTreeItem(S,m){const y=this.J.get(S);if(!y)return;const D=await this.H.get(y.provider)?.editItem?.(y.item,m);return this.U(y.provider,D||y.item)}$disposeVisualizedTree(S){const m=this.J.get(S);if(!m)return;const y=[m.children];for(const D of y)if(D)for(const C of D)y.push(this.J.get(C)?.children),this.J.delete(C)}U(S,m){let y=this.I.get(m);return y||(y=this.F++,this.I.set(m,y),this.J.set(y,{provider:S,item:m})),a.DebugTreeItem.from(m,y)}asDebugSourceUri(S,m){const y=S;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let D=`debug:${encodeURIComponent(y.path||"")}`,C="?";return m&&(D+=`${C}session=${encodeURIComponent(m.id)}`,C="&"),D+=`${C}ref=${y.sourceReference}`,M.URI.parse(D)}else{if(y.path)return M.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(S){const m=[];for(const y of S.getAllExtensionDescriptions())if(y.contributes){const D=y.contributes.debuggers;if(D&&D.length>0)for(const C of D)(0,v.$DH)(C)&&m.push(C.type)}this.l.$registerDebugTypes(m)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const S=[];return this.z.forEach(m=>S.push(m)),S}async $resolveDebugVisualizer(S,m){const y=this.L.get(S);if(!y)throw new Error(`No debug visualizer found with id '${S}'`);let{v:D,provider:C,extensionId:O}=y;if(D.visualization||(D=await C.resolveDebugVisualization?.(D,m)||D,y.v=D),!D.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${C}'`);return this.kb(O,D.visualization)}async $executeDebugVisualizerCommand(S){const m=this.L.get(S);if(!m)throw new Error(`No debug visualizer found with id '${S}'`);const y=m.v.visualization;y&&"command"in y&&this.S.executeCommand(y.command,...y.arguments||[])}W(S){const m=this.m.get(S.sessionId);return m&&{session:m.api,variable:S.variable,containerId:S.containerId,frameId:S.frameId,threadId:S.threadId}}async $provideDebugVisualizers(S,m,y,D){const C=this.W(y),O=this.jb(S,m),z=this.G.get(O);if(!C||!z)return[];const T=await z.provideDebugVisualization(C,D);return T?T.map(F=>{const N=++this.M;this.L.set(N,{v:F,provider:z,extensionId:S});const j=F.iconPath?this.lb(F.iconPath):void 0;return{id:N,name:F.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.kb(S,F.visualization)}}):[]}$disposeDebugVisualizers(S){for(const m of S)this.L.delete(m)}registerDebugVisualizationProvider(S,m,y){if(!S.contributes?.debugVisualizers?.some(O=>O.id===m))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${m})`);const D=A.$Vm.toKey(S.identifier),C=this.jb(D,m);if(this.G.has(C))throw new Error(`A debug visualization provider with id '${m}' is already registered`);return this.G.set(C,y),this.l.$registerDebugVisualizer(D,m),(0,c.$Sc)(()=>{this.l.$unregisterDebugVisualizer(D,m),this.G.delete(m)})}addBreakpoints(S){const m=S.filter(C=>{const O=C.id;return this.z.has(O)?!1:(this.z.set(O,C),!0)});this.gb(m,[],[]);const y=[],D=new Map;for(const C of m)if(C instanceof P.$rN){let O=D.get(C.location.uri.toString());O||(O={type:"sourceMulti",uri:C.location.uri,lines:[]},D.set(C.location.uri.toString(),O),y.push(O)),O.lines.push({id:C.id,enabled:C.enabled,condition:C.condition,hitCondition:C.hitCondition,logMessage:C.logMessage,line:C.location.range.start.line,character:C.location.range.start.character,mode:C.mode})}else C instanceof P.$sN&&y.push({type:"function",id:C.id,enabled:C.enabled,hitCondition:C.hitCondition,logMessage:C.logMessage,condition:C.condition,functionName:C.functionName,mode:C.mode});return this.l.$registerBreakpoints(y)}removeBreakpoints(S){const m=S.filter(O=>this.z.delete(O.id));this.gb([],m,[]);const y=m.filter(O=>O instanceof P.$rN).map(O=>O.id),D=m.filter(O=>O instanceof P.$sN).map(O=>O.id),C=m.filter(O=>O instanceof P.$tN).map(O=>O.id);return this.l.$unregisterBreakpoints(y,D,C)}startDebugging(S,m,y){return this.l.$startDebugging(S?S.uri:void 0,m,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,suppressSaveBeforeStart:y.suppressSaveBeforeStart,suppressDebugStatusbar:y.suppressDebugStatusbar??y.debugUI?.simple,suppressDebugToolbar:y.suppressDebugToolbar??y.debugUI?.simple,suppressDebugView:y.suppressDebugView??y.debugUI?.simple})}stopDebugging(S){return this.l.$stopDebugging(S?S.id:void 0)}registerDebugConfigurationProvider(S,m,y){if(!m)return new P.$pM(()=>{});const D=this.d++;return this.f.push({type:S,handle:D,provider:m}),this.l.$registerDebugConfigurationProvider(S,y,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,D),new P.$pM(()=>{this.f=this.f.filter(C=>C.provider!==m),this.l.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(S,m,y){if(!y)return new P.$pM(()=>{});if(!this.cb(S,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.$(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:m,handle:D,factory:y}),this.l.$registerDebugAdapterDescriptorFactory(m,D),new P.$pM(()=>{this.h=this.h.filter(C=>C.factory!==y),this.l.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(S,m){if(!m)return new P.$pM(()=>{});const y=this.j++;return this.k.push({type:S,handle:y,factory:m}),new P.$pM(()=>{this.k=this.k.filter(D=>D.factory!==m)})}async $runInTerminal(S,m){return Promise.resolve(void 0)}async $substituteVariables(S,m){let y;const D=await this.ib(S);return D&&(y={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(y,m)}X(S,m){if(S.type==="implementation")return new u(S.implementation)}Y(){}async $startDASession(S,m){const y=this,D=await this.hb(m);return this.eb(this.$(D.type),D).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const O=this.Z(C),z=this.X(O,D);if(!z)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const T=z;return this.D.set(S,T),this.db(D).then(F=>(F&&this.E.set(S,F),T.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const j=N,B={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const X=await this.K.sign(j.arguments.value);B.body={signature:X},T.sendResponse(B)}else throw new Error("no signer")}catch(X){B.success=!1,B.message=X.message,T.sendResponse(B)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(N),N=(0,v.$IH)(N,!0),y.l.$acceptDAMessage(S,N)}),T.onError(N=>{F&&F.onError&&F.onError(N),this.l.$acceptDAError(S,N.name,N.message,N.stack)}),T.onExit(N=>{F&&F.onExit&&F.onExit(N??void 0,void 0),this.l.$acceptDAExit(S,N??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),T.startSession()))})}$sendDAMessage(S,m){m=(0,v.$HH)(m,!1);const y=this.E.get(S);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(m),this.D.get(S)?.sendMessage(m)}$stopDASession(S){const m=this.E.get(S);this.E.delete(S),m&&m.onWillStopSession&&m.onWillStopSession();const y=this.D.get(S);return this.D.delete(S),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(S){const m=[],y=[],D=[];if(S.added)for(const C of S.added){const O=C.id;if(O&&!this.z.has(O)){let z;if(C.type==="function")z=new P.$sN(C.functionName,C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode);else if(C.type==="data")z=new P.$tN(C.label,C.dataId,C.canPersist,C.enabled,C.hitCondition,C.condition,C.logMessage,C.mode);else{const T=M.URI.revive(C.uri);z=new P.$rN(new P.$BM(T,new P.$qM(C.line,C.character)),C.enabled,C.condition,C.hitCondition,C.logMessage,C.mode)}(0,P.$pN)(z,O),this.z.set(O,z),m.push(z)}}if(S.removed)for(const C of S.removed){const O=this.z.get(C);O&&(this.z.delete(C),y.push(O))}if(S.changed){for(const C of S.changed)if(C.id){const O=this.z.get(C.id);if(O){if(O instanceof P.$sN&&C.type==="function"){const z=O;z.enabled=C.enabled,z.condition=C.condition,z.hitCondition=C.hitCondition,z.logMessage=C.logMessage,z.functionName=C.functionName}else if(O instanceof P.$rN&&C.type==="source"){const z=O;z.enabled=C.enabled,z.condition=C.condition,z.hitCondition=C.hitCondition,z.logMessage=C.logMessage,z.location=new P.$BM(M.URI.revive(C.uri),new P.$qM(C.line,C.character))}D.push(O)}}}this.gb(m,y,D)}async $acceptStackFrameFocus(S){let m;if(S){const y=await this.hb(S.sessionId);S.kind==="thread"?m=new P.$zN(y.api,S.threadId):m=new P.$yN(y.api,S.threadId,S.frameId)}this.B=m,this.C.fire(this.B)}$provideDebugConfigurations(S,m,y){return(0,l.$sh)(async()=>{const D=this.bb(S);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const C=await this.ib(m);return D.provideDebugConfigurations(C,y)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(S,m,y,D){return(0,l.$sh)(async()=>{const C=this.bb(S);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.ib(m);return C.resolveDebugConfiguration(O,y,D)})}$resolveDebugConfigurationWithSubstitutedVariables(S,m,y,D){return(0,l.$sh)(async()=>{const C=this.bb(S);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.ib(m);return C.resolveDebugConfigurationWithSubstitutedVariables(O,y,D)})}async $provideDebugAdapter(S,m){const y=this.ab(S);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.hb(m);return this.eb(y,D).then(C=>{if(!C)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.Z(C)})}async $acceptDebugSessionStarted(S){const m=await this.hb(S);this.n.fire(m.api)}async $acceptDebugSessionTerminated(S){const m=await this.hb(S);m&&(this.o.fire(m.api),this.m.delete(m.id))}async $acceptDebugSessionActiveChanged(S){this.u=S?await this.hb(S):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(S,m){(await this.hb(S))?._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(S,m){const D={session:(await this.hb(S)).api,event:m.event,body:m.body};this.w.fire(D)}Z(S){if(S instanceof P.$uN)return{type:"executable",command:S.command,args:S.args,options:S.options};if(S instanceof P.$vN)return{type:"server",port:S.port,host:S.host};if(S instanceof P.$wN)return{type:"pipeServer",path:S.path};if(S instanceof P.$xN)return{type:"implementation",implementation:S.implementation};throw new Error("convertToDto unexpected type")}$(S){const m=this.h.filter(y=>y.type===S);if(m.length>0)return m[0].factory}ab(S){const m=this.h.filter(y=>y.handle===S);if(m.length>0)return m[0].factory}bb(S){const m=this.f.filter(y=>y.handle===S);if(m.length>0)return m[0].provider}cb(S,m){if(S.contributes){const y=S.contributes.debuggers;if(y&&y.length>0){for(const D of y)if(D.label&&D.type&&D.type===m)return!0}}return!1}db(S){const y=S.configuration.type,D=this.k.filter(C=>C.type===y||C.type==="*").map(C=>(0,l.$sh)(()=>C.factory.createDebugAdapterTracker(S.api)).then(O=>O,O=>null));return Promise.race([Promise.all(D).then(C=>{const O=(0,r.$Hb)(C);if(O.length>0)return new s(O)}),new Promise(C=>setTimeout(()=>C(void 0),1e3))]).catch(C=>{})}async eb(S,m){const y=m.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new P.$vN(y));if(S){const C=await this.O.getExtensionRegistry();return(0,l.$sh)(()=>S.createDebugAdapterDescriptor(m.api,this.fb(m,C))).then(O=>{if(O)return O})}const D=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(m,D))}fb(S,m){}gb(S,m,y){(S.length>0||m.length>0||y.length>0)&&this.A.fire(Object.freeze({added:S,removed:m,changed:y}))}async hb(S){if(S)if(typeof S=="string"){const m=this.m.get(S);if(m)return m}else{let m=this.m.get(S.id);if(!m){const y=await this.ib(S.folderUri),D=S.parent?this.m.get(S.parent):void 0;m=new f(this.l,S.id,S.type,S.name,y,S.configuration,D?.api),this.m.set(m.id,m),this.l.$sessionCached(m.id)}return m}throw new Error("cannot find session")}ib(S){if(S){const m=M.URI.revive(S);return this.N.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}jb(S,m){return`${S}\0${m}`}kb(S,m){if(m){if("title"in m&&"command"in m)return{type:0};if("treeId"in m)return{type:1,id:`${S}\0${m.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(S){const m=this.mb(S);let y,D;return"id"in m?D=i.ThemeIcon.asClassName(m):y=m,{iconPath:y,iconClass:D}}mb(S){if(S instanceof P.$mN)return{id:S.id};const m=typeof S=="object"&&"dark"in S?S.dark:S,y=typeof S=="object"&&"light"in S?S.light:S;return{dark:typeof m=="string"?M.URI.file(m):m,light:typeof y=="string"?M.URI.file(y):y}}};e.$lnc=t,e.$lnc=t=Je([We(0,I.$RO),We(1,p.$Bmc),We(2,k.$fnc),We(3,d.$Emc),We(4,$.$Qmc),We(5,h.$inc),We(6,n.$bP)],t);class f{constructor(S,m,y,D,C,O,z){this.f=S,this.g=m,this.h=y,this.j=D,this.k=C,this.l=O,this.m=z}get api(){const S=this;return this.d??=Object.freeze({id:S.g,type:S.h,get name(){return S.j},set name(m){S.j=m,S.f.$setDebugSessionName(S.g,m)},parentSession:S.m,workspaceFolder:S.k,configuration:S.l,customRequest(m,y){return S.f.$customDebugAdapterRequest(S.g,m,y)},getDebugProtocolBreakpoint(m){return S.f.$getDebugProtocolBreakpoint(S.g,m.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(S){this.j=S}get configuration(){return this.l}}e.$mnc=f;class o{constructor(S){this.value=Object.freeze({append(m){S.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.$nnc=o;class s{constructor(S){this.d=S}onWillStartSession(){this.d.forEach(S=>S.onWillStartSession?S.onWillStartSession():void 0)}onWillReceiveMessage(S){this.d.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(S):void 0)}onDidSendMessage(S){this.d.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(S):void 0)}onWillStopSession(){this.d.forEach(S=>S.onWillStopSession?S.onWillStopSession():void 0)}onError(S){this.d.forEach(m=>m.onError?m.onError(S):void 0)}onExit(S,m){this.d.forEach(y=>y.onExit?y.onExit(S,m):void 0)}}class u extends E.$Dsb{constructor(S){super(),this.h=S,S.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(S){this.h.handleMessage(S)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let g=class extends t{constructor(S,m,y,D,C,O,z){super(S,m,y,D,C,O,z)}};e.$onc=g,e.$onc=g=Je([We(0,I.$RO),We(1,p.$Bmc),We(2,k.$fnc),We(3,d.$Emc),We(4,$.$Qmc),We(5,h.$inc),We(6,n.$bP)],g)}),define(ke[380],De([1,0,13,59,2,6,328,11,85,107,28,263,20,68,49,90]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=e.$roc=void 0;class h{static async installEarlyHandler(n){Error.stackTraceLimit=100;const a=n.get(w.$7j),t=n.get(p.$RO).getProxy(A.$nM.MainThreadErrors);l.setUnexpectedErrorHandler(f=>{a.error(f);const o=l.$3(f);t.$onUnexpectedError(o)})}static async installFullHandler(n){const a=n.get(w.$7j),r=n.get(p.$RO),t=n.get(v.$fnc),f=n.get(d.$_O),o=r.getProxy(A.$nM.MainThreadExtensionService),s=r.getProxy(A.$nM.MainThreadErrors),u=await t.getExtensionPathIndex(),g=new WeakMap;function b(y,D){if(g.has(y))return g.get(y).stack;let C="",O,z;for(const F of D)C+=`
	at ${F.toString()}`,z=F.getFileName(),!O&&z&&(O=u.findSubstr(M.URI.file(z)));const T=`${y.name||"Error"}: ${y.message||""}${C}`;return g.set(y,{extensionIdentifier:O?.identifier,stack:T}),T}const S=Symbol("prepareStackTrace wrapped");let m=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(y){if(y===b||!y||y[S]){m=y||b;return}m=function(D,C){return b(D,C),y.call(Error,D,C)},Object.assign(m,{[S]:!0})}}),l.setUnexpectedErrorHandler(y=>{a.error(y);const D=l.$3(y),C=g.get(y);if(!C?.extensionIdentifier){s.$onUnexpectedError(D);return}o.$onExtensionRuntimeError(C.extensionIdentifier,D);const O=f.onExtensionError(C.extensionIdentifier,y);a.trace("forwarded error to extension?",O,C)})}}e.$roc=h;class c{constructor(n,a,r,t,f){this.a=r,this.b=new R.$Yac(n,null,t),a=c.e(a,this.b);const o=new k.$yi(...(0,$.$Es)());o.set(I.$8O,{_serviceBrand:void 0,...a,messagePorts:f}),o.set(p.$RO,new p.$SO(this.b)),o.set(E.$ymc,new E.$zmc(t)),o.set(v.$dnc,r);const s=new P.$ir(o,!0);s.invokeFunction(h.installEarlyHandler),this.d=s.invokeFunction(u=>u.get(w.$7j)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=s.invokeFunction(u=>u.get(v.$fnc)),this.c.initialize(),s.invokeFunction(h.installFullHandler)}async asBrowserUri(n){const a=this.b.getProxy(A.$nM.MainThreadExtensionService);return M.URI.revive(await a.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,a){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=M.URI.revive(a.transformIncomingURIs(n.environment.appRoot));const r=n.environment.extensionDevelopmentLocationURI;return r&&(n.environment.extensionDevelopmentLocationURI=r.map(t=>M.URI.revive(a.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=M.URI.revive(a.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=M.URI.revive(a.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=M.URI.revive(a.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=M.URI.revive(a.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=M.URI.revive(a.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=M.URI.revive(a.transformIncomingURIs(n.logsLocation)),n.workspace=a.transformIncomingURIs(n.workspace),n}}e.$soc=c}),define(ke[381],De([1,0,7,12,236,256,141,96,72,49,20,43,8,61,44,300,301,45,34]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=void 0;let n=class extends w.$lnc{constructor(o,s,u,g,b,S,m,y){super(o,s,u,g,S,m,y),this.pb=b,this.nb=new t}X(o,s){switch(o.type){case"server":return new d.$xoc(o);case"pipeServer":return new d.$yoc(o);case"executable":return new d.$zoc(o,s.type)}return super.X(o,s)}fb(o,s){const u=d.$zoc.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(u)return new p.$uN(u.command,u.args,u.options)}Y(){return new R.$Lec}async $runInTerminal(o,s){if(o.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(F=>{this.nb.onTerminalClosed(F)}));const u=await this.P.getConfigProvider(),g=this.pb.getDefaultShell(!0),b=this.pb.getDefaultShellArgs(!0),S=o.title||M.localize(0,null),m=JSON.stringify({shell:g,shellArgs:b});let y=await this.nb.checkout(m,S),D,C=!1;if(y)D=o.cwd;else{const F={shellPath:g,shellArgs:b,cwd:o.cwd,name:S,iconPath:new p.$mN("debug")};C=!0,y=this.pb.createTerminalFromOptions(F,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(y,m)}y.show(!0);const O=await y.processId;C?await new Promise(F=>setTimeout(F,1e3)):(y.state.isInteractedWith&&(y.sendText(""),await(0,l.$Bh)(200)),u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0||g.indexOf("cmd.exe")>=0?y.sendText("cls"):g.indexOf("bash")>=0?y.sendText("clear"):L.$i?y.sendText("cls"):y.sendText("clear")));const z=(0,h.$Boc)(g,o.args,!!o.argsCanBeInterpretedByShell,D,o.env);y.sendText(z);const T=this.onDidTerminateDebugSession(F=>{F.id===s&&(this.nb.free(y),T.dispose())});return O}else if(o.kind==="external")return r(o,await this.P.getConfigProvider());return super.$runInTerminal(o,s)}};e.$Coc=n,e.$Coc=n=Je([We(0,I.$RO),We(1,v.$Bmc),We(2,k.$fnc),We(3,c.$Emc),We(4,P.$3mc),We(5,$.$Qmc),We(6,E.$inc),We(7,i.$bP)],n);let a;function r(f,o){if(!a)if(L.$i)a=new A.$wdc;else if(L.$j)a=new A.$xdc;else if(L.$k)a=new A.$ydc;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return a.runInTerminal(f.title,f.cwd,f.args,f.env||{},s.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(o,s,u=!1){const b=[...this.b.entries()].map(([S,m])=>(0,l.$nh)(async y=>{if(S.name!==s||m.lastUsedAt!==-1&&await(0,h.$Aoc)(await S.processId))return null;const D=Date.now();return m.lastUsedAt+t.a>D||y.isCancellationRequested?null:m.config!==o?(u&&S.dispose(),null):(m.lastUsedAt=D,S)}));return await(0,l.$Fh)(b,S=>!!S)}insert(o,s){this.b.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this.b.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}}),define(ke[382],De([1,0,16,2,105,44,73,45,42,43,20,28,95,15,11,91,23,64,61]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=void 0;let n=class extends p.$7nc{constructor(r,t,f,o,s,u,g,b,S){super(r,t,f,o,s,u,g,b),this.C=f,this.D=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(r,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const o=p.TaskHandleDTO.from(f,this.C),s=await this.a.$getTaskExecution(o);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.z(s,t);return this.a.$executeTask(o).catch(()=>{}),u}else{const o=p.TaskDTO.from(t,r);if(o===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(o.execution)&&await this.y(o,t,!1);const s=await this.z(await this.a.$getTaskExecution(o),t);return this.a.$executeTask(o).catch(()=>{}),s}}v(r,t,f,o){const s=[];if(o)for(const u of o){this.A(u,f),(!u.definition||!r[u.definition.type])&&this.f.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const g=p.TaskDTO.from(u,f.extension);g&&(s.push(g),p.CustomExecutionDTO.is(g.execution)&&t.push(this.y(g,u,!0)))}return{tasks:s,extension:f.extension}}async w(r){return r}async G(r){let t=r&&r.length>0?r[0]:void 0;if(!t){const f=L.URI.file((0,c.homedir)());t=new $.$Ui({uri:f,name:h.$$g(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(r,t){const f=L.URI.revive(r),o={process:void 0,variables:Object.create(null)},s=await this.b.resolveWorkspaceFolder(f),u=await this.b.getWorkspaceFolders2()??[],g=await this.D.getResolver(),b=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(u);for(const S of t.variables)o.variables[S]=await g.resolveAsync(b,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(l.$tc);for(let m=0;m<S.length;m++)S[m]=await g.resolveAsync(b,S[m])}o.process=await M.win32.findExecutable(await g.resolveAsync(b,t.process.name),t.process.cwd!==void 0?await g.resolveAsync(b,t.process.cwd):void 0,S)}return o}async $jsonTasksSupported(){return!0}async $findExecutable(r,t,f){return M.win32.findExecutable(r,t,f)}};e.$uoc=n,e.$uoc=n=Je([We(0,I.$RO),We(1,P.$8O),We(2,A.$Bmc),We(3,R.$3O),We(4,w.$Emc),We(5,k.$3mc),We(6,v.$7j),We(7,d.$fmc),We(8,i.$inc)],n)}),define(ke[383],De([1,0,64,61]),function(le,e,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0;class M extends L.$jnc{m(){return(0,l.homedir)()}}e.$apc=M}),define(ke[160],De([1,0,19,7,21,47,15,16,23,2,37]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=e.$Dnc=e.$Cnc=void 0,e.$Enc=d;class P{constructor(i,n,a){this.d=i,this.e=n,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const a=this.g.folderQueries||[],r=new M.$se(n);return new Promise((t,f)=>{this.a=new E(i);let o=!1;const s=(u,g)=>{if(!o&&!this.b){const b=this.h(u);d(u)&&typeof this.g.maxResults=="number"&&this.c+b>this.g.maxResults&&(this.b=!0,o=!0,r.cancel(),u=this.j(u,this.g.maxResults-this.c));const S=this.h(u);this.c+=S,(S>0||!d(u))&&this.a.add(u,g)}};Promise.all(a.map((u,g)=>this.k(u,b=>s(b,g),r.token))).then(u=>{r.dispose(),this.a.flush();const g=u.some(b=>!!b&&!!b.limitHit);t({limitHit:this.b||g,messages:u.flatMap(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[]),stats:{type:this.f}})},u=>{r.dispose();const g=(0,A.$lj)(u);f(new Error(g))})})}h(i){return d(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const a=Array.isArray(i.ranges)?i.ranges:[i.ranges],r=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:a.slice(0,n),preview:{matches:r.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,a){const r=new I.$TK(this.g,i),t=[],f={report:u=>{if(!this.l(u))return;const g=i.folder.scheme===R.Schemas.file?(0,I.$UK)(()=>this.e.readdir($.$ah(u.uri))):void 0,b=$.$dh(i.folder,u.uri);if(b){const S=r.includedInQuery(b,w.$nc(b),g);(0,L.$mh)(S)?t.push(S.then(m=>{m&&n(u)})):S&&n(u)}}},o=this.n(i);let s;return this.d.query.type===3?s=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,o,f,a):s=await this.d.provider.provideTextSearchResults(p(this.d.query.contentPattern),o,f,a),t.length&&await Promise.all(t),s}l(i){if(d(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,I.$SK)(this.g.includePattern,i.includePattern),a=(0,I.$SK)(this.g.excludePattern,i.excludePattern),r={folder:k.URI.from(i.folder),excludes:a,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(r.usePCRE2=this.g.usePCRE2),r}}e.$Cnc=P;function p(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class E{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new h(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$7g(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(v(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Dnc=E;function v(c){return d(c)?{preview:{matches:(0,l.$1b)(c.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:c.preview.text},ranges:(0,l.$1b)(c.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function d(c){return!!c.preview}class h{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<h.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},h.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Fnc=h}),define(ke[97],De([1,0,3,6,5,376,20,68,11,2,160]),function(le,e,l,L,M,A,R,w,$,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0,e.$Inc=p,e.$Gnc=(0,M.$Ai)("IExtHostSearch");let P=class{constructor(d,h,c){this.n=d,this.o=h,this.q=c,this.c=this.n.getProxy(L.$nM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$Bnc}s(d){return this.o.transformOutgoingScheme(d)}registerTextSearchProvider(d,h){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const c=this.d++;return this.e.set(c,h),this.c.$registerTextSearchProvider(c,this.s(d)),(0,l.$Sc)(()=>{this.g.delete(d),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(d,h){if(this.i.has(d))throw new Error(`an AI text search provider for the scheme '${d}'is already registered`);this.i.add(d);const c=this.d++;return this.h.set(c,h),this.c.$registerAITextSearchProvider(c,this.s(d)),(0,l.$Sc)(()=>{this.i.delete(d),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(d,h){if(this.k.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.k.add(d);const c=this.d++;return this.j.set(c,h),this.c.$registerFileSearchProvider(c,this.s(d)),(0,l.$Sc)(()=>{this.k.delete(d),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(d,h,c,i){const n=p(c),a=this.j.get(d);if(a)return this.l.fileSearch(n,a,r=>{this.c.$handleFileMatch(d,h,r.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+d)}async doInternalFileSearchWithCustomCallback(d,h,c){return{messages:[]}}$clearCache(d){return this.l.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,h,c,i){const n=this.e.get(d);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${d}`);const a=p(c);return this.t(a,n).search(t=>this.c.$handleTextMatch(d,h,t),i)}$provideAITextSearchResults(d,h,c,i){const n=this.h.get(d);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${d}`);const a=p(c);return this.v(a,n).search(t=>this.c.$handleTextMatch(d,h,t),i)}$enableExtensionHostSearch(){}t(d,h){return new I.$Cnc({query:d,provider:h},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(d,h){return new I.$Cnc({query:d,provider:h},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$Hnc=P,e.$Hnc=P=Je([We(0,R.$RO),We(1,w.$ymc),We(2,$.$7j)],P);function p(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(E),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>k.URI.revive(d))}}function E(v){return{...v,folder:k.URI.revive(v.folder)}}}),define(ke[384],De([1,0,21,13,4,3,15,41,2,136,203,184,80,25,33,11,86,87,283,6,330,356,91,121,334,335,336,316,305,34,337,45,338,96,152,339,318,331,340,341,73,72,319,332,49,342,70,343,60,28,357,320,344,122,345,116,117,321,375,347,288,348,358,349,158,322,350,351,352,20,353,97,118,354,323,355,119,93,95,90,43,156,359,360,333,361,362,71,17,8,324,68,325,92,363,364,151,44,298,115,26,94]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r,t,f,o,s,u,g,b,S,m,y,D,C,O,z,T,F,N,j,B,X,ie,H,K,x,_,ge,oe,Pe,me,U,Y,pe,ce,ae,se,ue,Q,re,$e,we,Ne,Se,Ie,Ae,je,V,W,J,Z,he,be,Fe,Ve,Qe,tt,_e,nt,it,rt,at,Re,ve,qe,te,ne,Ce,Ge,Me,st,ut,$t,Ct,Pt,Ut,Bt,kt,Yt,xt,xe,on){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=Qt;function Qt(ft){const gt=ft.get(Pe.$8O),_t=ft.get(oe.$jmc),Zt=ft.get(_.$Gmc),Ft=ft.get(K.$fnc),mt=ft.get(kt.$Bmc),Ht=ft.get(it.$_O),en=ft.get(y.$Emc),Wt=ft.get(ut.$ymc),Xe=ft.get(J.$RO),ln=ft.get(tt.$Zmc),Xt=ft.get(_e.$Hmc),Vt=ft.get(d.$8j),wt=ft.get(d.$7j),qt=ft.get(Ce.$_Db),Mt=ft.get(t.$fmc),Lt=ft.get(Bt.$loc),tn=ft.get(be.$0mc),Gt=ft.get(X.$Qmc),an=ft.get(se.$bnc),Nt=ft.get(f.$pmc),Kt=ft.get(pe.$7mc);Xe.set(n.$oM.ExtHostFileSystemInfo,_t),Xe.set(n.$oM.ExtHostLogLevelServiceShape,Vt),Xe.set(n.$oM.ExtHostWorkspace,mt),Xe.set(n.$oM.ExtHostConfiguration,en),Xe.set(n.$oM.ExtHostExtensionService,Ft),Xe.set(n.$oM.ExtHostStorage,ln),Xe.set(n.$oM.ExtHostTunnelService,qt),Xe.set(n.$oM.ExtHostWindow,Lt),Xe.set(n.$oM.ExtHostSecretState,tn),Xe.set(n.$oM.ExtHostTelemetry,Ht),Xe.set(n.$oM.ExtHostEditorTabs,Gt),Xe.set(n.$oM.ExtHostManagedSockets,an),Xe.set(n.$oM.ExtHostAuthentication,Nt),Xe.set(n.$oM.ExtHostChatProvider,Kt);const Ot=Xe.set(n.$oM.ExtHostDecorations,ft.get(O.$qnc)),It=Xe.set(n.$oM.ExtHostDocumentsAndEditors,ft.get(B.$3O)),pt=Xe.set(n.$oM.ExtHostCommands,ft.get(S.$bP)),St=Xe.set(n.$oM.ExtHostTerminalService,ft.get(rt.$3mc)),cn=Xe.set(n.$oM.ExtHostTerminalShellIntegration,ft.get(at.$0nc)),Dt=Xe.set(n.$oM.ExtHostDebugService,ft.get(C.$knc)),gn=Xe.set(n.$oM.ExtHostSearch,ft.get(he.$Gnc)),rn=Xe.set(n.$oM.ExtHostTask,ft.get(nt.$9nc)),pn=Xe.set(n.$oM.ExtHostOutputService,ft.get(Ie.$Vnc)),hn=Xe.set(n.$oM.ExtHostLocalization,ft.get(ae.$anc)),vn=Xe.set(n.$oM.ExtHostUrls,new $t.$ioc(Xe)),At=Xe.set(n.$oM.ExtHostDocuments,new j.$mmc(Xe,It)),kn=Xe.set(n.$oM.ExtHostDocumentContentProviders,new F.$snc(Xe,It,wt)),sn=Xe.set(n.$oM.ExtHostDocumentSaveParticipant,new N.$tnc(wt,At,Xe.getProxy(n.$nM.MainThreadBulkEdits))),Oe=Xe.set(n.$oM.ExtHostNotebook,new Q.$Jnc(Xe,pt,It,At,Zt,gn)),ze=Xe.set(n.$oM.ExtHostNotebookDocuments,new $e.$Pnc(Oe)),Ee=Xe.set(n.$oM.ExtHostNotebookEditors,new we.$Qnc(wt,Oe)),ee=Xe.set(n.$oM.ExtHostNotebookKernels,new Ne.$Rnc(Xe,gt,Oe,pt,wt)),Te=Xe.set(n.$oM.ExtHostNotebookRenderers,new Se.$Tnc(Xe,Oe)),He=Xe.set(n.$oM.ExtHostNotebookDocumentSaveParticipant,new re.$Onc(wt,Oe,Xe.getProxy(n.$nM.MainThreadBulkEdits))),Ye=Xe.set(n.$oM.ExtHostEditors,new ve.$vmc(Xe,It)),Ke=Xe.set(n.$oM.ExtHostTreeViews,new ne.$goc(Xe.getProxy(n.$nM.MainThreadTreeViews),pt,wt)),ht=Xe.set(n.$oM.ExtHostEditorInsets,new b.$wmc(Xe.getProxy(n.$nM.MainThreadEditorInsets),Ye,gt.remote)),Et=Xe.set(n.$oM.ExtHostDiagnostics,new z.$lmc(Xe,wt,_t,It)),jt=Xe.set(n.$oM.ExtHostLanguages,new ce.$Mnc(Xe,At,pt.converter,Wt)),lt=Xe.set(n.$oM.ExtHostLanguageFeatures,new Y.$nmc(Xe,Wt,At,pt,Et,wt,Mt,Ht)),Tt=Xe.set(n.$oM.ExtHostFileSystem,new x.$wnc(Xe,lt)),zt=Xe.set(n.$oM.ExtHostFileSystemEventService,new ge.$xnc(Xe,wt,It)),Sn=Xe.set(n.$oM.ExtHostQuickOpen,(0,W.$Znc)(Xe,mt,pt)),Pn=Xe.set(n.$oM.ExtHostSCM,new Z.$2nc(Xe,pt,At,wt)),Qn=Xe.set(n.$oM.ExtHostQuickDiff,new V.$Ync(Xe,Wt)),Ln=Xe.set(n.$oM.ExtHostShare,new Fe.$3nc(Xe,Wt)),Nn=Xe.set(n.$oM.ExtHostComments,(0,m.$xmc)(Xe,pt,At)),In=Xe.set(n.$oM.ExtHostProgress,new je.$Xnc(Xe.getProxy(n.$nM.MainThreadProgress))),Tn=Xe.set(n.$oM.ExtHostLabelService,new U.$Lnc(Xe)),Fn=Xe.set(n.$oM.ExtHostTheming,new qe.$doc(Xe)),Zn=Xe.set(n.$oM.ExtHostTimeline,new te.$foc(Xe,pt)),jn=Xe.set(n.$oM.ExtHostWebviews,new Ct.$Lmc(Xe,gt.remote,mt,wt,Mt)),An=Xe.set(n.$oM.ExtHostWebviewPanels,new Pt.$Omc(Xe,jn,mt)),zn=Xe.set(n.$oM.ExtHostCustomEditors,new D.$Pmc(Xe,At,Xt,jn,An)),Un=Xe.set(n.$oM.ExtHostWebviewViews,new Ut.$joc(Xe,jn)),yn=Xe.set(n.$oM.ExtHostTesting,new Re.$_nc(Xe,wt,pt,It)),Xn=Xe.set(n.$oM.ExtHostUriOpeners,new st.$hoc(Xe)),Yn=Xe.set(n.$oM.ExtHostProfileContentHandlers,new Ae.$Wnc(Xe));Xe.set(n.$oM.ExtHostInteractive,new me.$Knc(Xe,Oe,It,pt,wt));const Rn=Xe.set(n.$oM.ExtHostChatAgents2,new s.$smc(Xe,wt,pt)),xn=Xe.set(n.$oM.ExtHostChatVariables,new u.$tmc(Xe)),Bn=Xe.set(n.$oM.ExtHostAiRelatedInformation,new a.$emc(Xe)),gi=Xe.set(n.$oM.ExtHostAiEmbeddingVector,new H.$vnc(Xe)),_n=Xe.set(n.$oM.ExtHostStatusBar,new Qe.$6nc(Xe,pt.converter)),Wn=Xe.set(n.$oM.ExtHostSpeech,new Ve.$4nc(Xe)),bn=Xe.set(n.$oM.ExtHostEmbeddings,new ie.$unc(Xe)),mi=Object.values(n.$oM);Xe.assertRegistered(mi);const $i=new o.$rmc(Xe,It),ei=new g.$umc(Xe),Vn=new ue.$Nnc(Xe,wt),Mn=new T.$rnc(Xe);return r.$omc.register(pt),function(Be,dn,qn){function ot(de){return(ye,Ue,ct)=>{const yt=de(Rt=>{try{ye.call(Ue,Rt)}catch(Cn){L.$2(new Error(`[ExtensionListenerError] Extension '${Be.identifier.value}' FAILED to handle event: ${Cn.toString()}`,{cause:Cn})),Ht.onExtensionError(Be.identifier,Cn)}});return ct?.push(yt),yt}}const vt=function(){let de=!Be.isUnderDevelopment;function ye(){de||(wt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),de=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")ye();else{const yt=ct;typeof yt.scheme>"u"&&ye(),typeof yt.exclusive=="boolean"&&(0,xe.$OG)(Be,"documentFiltersExclusive")}return ct}}(),ti={getSession(de,ye,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,xe.$OG)(Be,"authLearnMore"),Nt.getSession(Be,de,ye,Ue)},getSessions(de,ye){return(0,xe.$OG)(Be,"authGetSessions"),Nt.getSessions(Be,de,ye)},async hasSession(de,ye){return(0,xe.$OG)(Be,"authSession"),!!await Nt.getSession(Be,de,ye,{silent:!0})},get onDidChangeSessions(){return ot(Nt.onDidChangeSessions)},registerAuthenticationProvider(de,ye,Ue,ct){return Nt.registerAuthenticationProvider(de,ye,Ue,ct)}},mn={registerCommand(de,ye,Ue){return pt.registerCommand(!0,de,ye,Ue,void 0,Be)},registerTextEditorCommand(de,ye,Ue){return pt.registerCommand(!0,de,(...ct)=>{const yt=Ye.getActiveTextEditor();if(!yt){wt.warn("Cannot execute "+de+" because there is no active text editor.");return}return yt.edit(Rt=>{ye.apply(Ue,[yt,Rt,...ct])}).then(Rt=>{Rt||wt.warn("Edits from command "+de+" were not applied.")},Rt=>{wt.warn("An error occurred while running command "+de,Rt)})},void 0,void 0,Be)},registerDiffInformationCommand:(de,ye,Ue)=>((0,xe.$OG)(Be,"diffCommand"),pt.registerCommand(!0,de,async(...ct)=>{const yt=It.activeEditor(!0);if(!yt){wt.warn("Cannot execute "+de+" because there is no active text editor.");return}const Rt=await Ye.getDiffInformation(yt.id);ye.apply(Ue,[Rt,...ct])},void 0,void 0,Be)),executeCommand(de,...ye){return pt.executeCommand(de,...ye)},getCommands(de=!1){return pt.getCommands(de)}},Dn={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return ei.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return ot(St.onDidChangeShell)},get isTelemetryEnabled(){return Ht.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Ht.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$OG)(Be,"telemetry"),Ht.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$OG)(Be,"telemetry"),ot(Ht.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$$O)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(de,ye){return it.$0O.validateSender(de),Ht.instantiateLogger(Be,de,ye)},openExternal(de,ye){return Lt.openUri(de,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(de){if(de.scheme===gt.environment.appUriScheme)return vn.createAppUri(de);try{return await Lt.asExternalUri(de,{allowTunneling:!!gt.remote.authority})}catch(ye){if((0,R.$Jg)(de,R.Schemas.http)||(0,R.$Jg)(de,R.Schemas.https))return de;throw ye}},get remoteName(){return(0,h.$Mm)(gt.remote.authority)},get remoteAuthority(){return(0,xe.$OG)(Be,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return ot(wt.onDidChangeLogLevel)},get appQuality(){return(0,xe.$OG)(Be,"resolvers"),gt.quality},get appCommit(){return(0,xe.$OG)(Be,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Dn);const pi={createTestController(de,ye,Ue){return yn.createTestController(Be,de,ye,Ue)},createTestObserver(){return(0,xe.$OG)(Be,"testObserver"),yn.createTestObserver()},runTests(de){return(0,xe.$OG)(Be,"testObserver"),yn.runTests(de)},get onDidChangeTestResults(){return(0,xe.$OG)(Be,"testObserver"),ot(yn.onResultsChanged)},get testResults(){return(0,xe.$OG)(Be,"testObserver"),yn.results}},nn=gt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,On={getExtension(de,ye){(0,xe.$NG)(Be,"extensionsAny")||(ye=!1);const Ue=dn.mine.getExtensionDescription(de);if(Ue)return new K.$gnc(Ft,Be.identifier,Ue,nn,!1);if(ye){const ct=dn.all.getExtensionDescription(de);if(ct)return new K.$gnc(Ft,Be.identifier,ct,nn,!0)}},get all(){const de=[];for(const ye of dn.mine.getAllExtensionDescriptions())de.push(new K.$gnc(Ft,Be.identifier,ye,nn,!1));return de},get allAcrossExtensionHosts(){(0,xe.$OG)(Be,"extensionsAny");const de=new E.$Wm(dn.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of dn.all.getAllExtensionDescriptions()){const ct=!de.has(Ue.identifier);ye.push(new K.$gnc(Ft,Be.identifier,Ue,nn,ct))}return ye},get onDidChange(){return(0,xe.$NG)(Be,"extensionsAny")?ot(M.Event.any(dn.mine.onDidChange,dn.all.onDidChange)):ot(dn.mine.onDidChange)}},ni={createDiagnosticCollection(de){return Et.createDiagnosticCollection(Be.identifier,de)},get onDidChangeDiagnostics(){return ot(Et.onDidChangeDiagnostics)},getDiagnostics:de=>Et.getDiagnostics(de),getLanguages(){return jt.getLanguages()},setTextDocumentLanguage(de,ye){return jt.changeLanguage(de.uri,ye)},match(de,ye){const Ue=Ge.LanguageSelector.from(de);let ct;return(0,I.$iu)(Ue)&&(ct=Oe.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Rt=>Rt.document===ye))?.apiNotebook),(0,I.$hu)(Ue,ye.uri,ye.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(de,ye,Ue){return lt.registerCodeActionProvider(Be,vt(de),ye,Ue)},registerDocumentPasteEditProvider(de,ye,Ue){return(0,xe.$OG)(Be,"documentPaste"),lt.registerDocumentPasteEditProvider(Be,vt(de),ye,Ue)},registerCodeLensProvider(de,ye){return lt.registerCodeLensProvider(Be,vt(de),ye)},registerDefinitionProvider(de,ye){return lt.registerDefinitionProvider(Be,vt(de),ye)},registerDeclarationProvider(de,ye){return lt.registerDeclarationProvider(Be,vt(de),ye)},registerImplementationProvider(de,ye){return lt.registerImplementationProvider(Be,vt(de),ye)},registerTypeDefinitionProvider(de,ye){return lt.registerTypeDefinitionProvider(Be,vt(de),ye)},registerHoverProvider(de,ye){return lt.registerHoverProvider(Be,vt(de),ye,Be.identifier)},registerEvaluatableExpressionProvider(de,ye){return lt.registerEvaluatableExpressionProvider(Be,vt(de),ye,Be.identifier)},registerInlineValuesProvider(de,ye){return lt.registerInlineValuesProvider(Be,vt(de),ye,Be.identifier)},registerDocumentHighlightProvider(de,ye){return lt.registerDocumentHighlightProvider(Be,vt(de),ye)},registerMultiDocumentHighlightProvider(de,ye){return lt.registerMultiDocumentHighlightProvider(Be,vt(de),ye)},registerLinkedEditingRangeProvider(de,ye){return lt.registerLinkedEditingRangeProvider(Be,vt(de),ye)},registerReferenceProvider(de,ye){return lt.registerReferenceProvider(Be,vt(de),ye)},registerRenameProvider(de,ye){return lt.registerRenameProvider(Be,vt(de),ye)},registerNewSymbolNamesProvider(de,ye){return(0,xe.$OG)(Be,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(Be,vt(de),ye)},registerDocumentSymbolProvider(de,ye,Ue){return lt.registerDocumentSymbolProvider(Be,vt(de),ye,Ue)},registerWorkspaceSymbolProvider(de){return lt.registerWorkspaceSymbolProvider(Be,de)},registerDocumentFormattingEditProvider(de,ye){return lt.registerDocumentFormattingEditProvider(Be,vt(de),ye)},registerDocumentRangeFormattingEditProvider(de,ye){return lt.registerDocumentRangeFormattingEditProvider(Be,vt(de),ye)},registerOnTypeFormattingEditProvider(de,ye,Ue,...ct){return lt.registerOnTypeFormattingEditProvider(Be,vt(de),ye,[Ue].concat(ct))},registerDocumentSemanticTokensProvider(de,ye,Ue){return lt.registerDocumentSemanticTokensProvider(Be,vt(de),ye,Ue)},registerDocumentRangeSemanticTokensProvider(de,ye,Ue){return lt.registerDocumentRangeSemanticTokensProvider(Be,vt(de),ye,Ue)},registerSignatureHelpProvider(de,ye,Ue,...ct){return typeof Ue=="object"?lt.registerSignatureHelpProvider(Be,vt(de),ye,Ue):lt.registerSignatureHelpProvider(Be,vt(de),ye,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider(de,ye,...Ue){return lt.registerCompletionItemProvider(Be,vt(de),ye,Ue)},registerInlineCompletionItemProvider(de,ye,Ue){return ye.handleDidShowCompletionItem&&(0,xe.$OG)(Be,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,xe.$OG)(Be,"inlineCompletionsAdditions"),Ue&&(0,xe.$OG)(Be,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Be,vt(de),ye,Ue)},registerInlineEditProvider(de,ye){return(0,xe.$OG)(Be,"inlineEdit"),lt.registerInlineEditProvider(Be,vt(de),ye)},registerDocumentLinkProvider(de,ye){return lt.registerDocumentLinkProvider(Be,vt(de),ye)},registerColorProvider(de,ye){return lt.registerColorProvider(Be,vt(de),ye)},registerFoldingRangeProvider(de,ye){return lt.registerFoldingRangeProvider(Be,vt(de),ye)},registerSelectionRangeProvider(de,ye){return lt.registerSelectionRangeProvider(Be,de,ye)},registerCallHierarchyProvider(de,ye){return lt.registerCallHierarchyProvider(Be,de,ye)},registerTypeHierarchyProvider(de,ye){return lt.registerTypeHierarchyProvider(Be,de,ye)},setLanguageConfiguration:(de,ye)=>lt.setLanguageConfiguration(Be,de,ye),getTokenInformationAtPosition(de,ye){return(0,xe.$OG)(Be,"tokenInformation"),jt.tokenAtPosition(de,ye)},registerInlayHintsProvider(de,ye){return lt.registerInlayHintsProvider(Be,de,ye)},createLanguageStatusItem(de,ye){return jt.createLanguageStatusItem(Be,de,ye)},registerDocumentDropEditProvider(de,ye,Ue){return lt.registerDocumentOnDropEditProvider(Be,de,ye,(0,xe.$NG)(Be,"documentPaste")?Ue:void 0)}},ii={get activeTextEditor(){return Ye.getActiveTextEditor()},get visibleTextEditors(){return Ye.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(de,ye,Ue){$.URI.isUri(de)&&de.scheme===R.Schemas.vscodeRemote&&!de.authority&&Mt.report("workspace.showTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(de)?Promise.resolve(Hn.openTextDocument(de)):Promise.resolve(de));return Ye.showTextDocument(ct,ye,Ue)},createTextEditorDecorationType(de){return Ye.createTextEditorDecorationType(Be,de)},onDidChangeActiveTextEditor(de,ye,Ue){return ot(Ye.onDidChangeActiveTextEditor)(de,ye,Ue)},onDidChangeVisibleTextEditors(de,ye,Ue){return ot(Ye.onDidChangeVisibleTextEditors)(de,ye,Ue)},onDidChangeTextEditorSelection(de,ye,Ue){return ot(Ye.onDidChangeTextEditorSelection)(de,ye,Ue)},onDidChangeTextEditorOptions(de,ye,Ue){return ot(Ye.onDidChangeTextEditorOptions)(de,ye,Ue)},onDidChangeTextEditorVisibleRanges(de,ye,Ue){return ot(Ye.onDidChangeTextEditorVisibleRanges)(de,ye,Ue)},onDidChangeTextEditorViewColumn(de,ye,Ue){return ot(Ye.onDidChangeTextEditorViewColumn)(de,ye,Ue)},onDidCloseTerminal(de,ye,Ue){return ot(St.onDidCloseTerminal)(de,ye,Ue)},onDidOpenTerminal(de,ye,Ue){return ot(St.onDidOpenTerminal)(de,ye,Ue)},onDidChangeActiveTerminal(de,ye,Ue){return ot(St.onDidChangeActiveTerminal)(de,ye,Ue)},onDidChangeTerminalDimensions(de,ye,Ue){return(0,xe.$OG)(Be,"terminalDimensions"),ot(St.onDidChangeTerminalDimensions)(de,ye,Ue)},onDidChangeTerminalState(de,ye,Ue){return ot(St.onDidChangeTerminalState)(de,ye,Ue)},onDidWriteTerminalData(de,ye,Ue){return(0,xe.$OG)(Be,"terminalDataWriteEvent"),ot(St.onDidWriteTerminalData)(de,ye,Ue)},onDidExecuteTerminalCommand(de,ye,Ue){return(0,xe.$OG)(Be,"terminalExecuteCommandEvent"),ot(St.onDidExecuteTerminalCommand)(de,ye,Ue)},onDidChangeTerminalShellIntegration(de,ye,Ue){return(0,xe.$OG)(Be,"terminalShellIntegration"),ot(cn.onDidChangeTerminalShellIntegration)(de,ye,Ue)},onDidStartTerminalShellExecution(de,ye,Ue){return(0,xe.$OG)(Be,"terminalShellIntegration"),ot(cn.onDidStartTerminalShellExecution)(de,ye,Ue)},onDidEndTerminalShellExecution(de,ye,Ue){return(0,xe.$OG)(Be,"terminalShellIntegration"),ot(cn.onDidEndTerminalShellExecution)(de,ye,Ue)},get state(){return Lt.getState()},onDidChangeWindowState(de,ye,Ue){return ot(Lt.onDidChangeWindowState)(de,ye,Ue)},showInformationMessage(de,...ye){return Vn.showMessage(Be,w.default.Info,de,ye[0],ye.slice(1))},showWarningMessage(de,...ye){return Vn.showMessage(Be,w.default.Warning,de,ye[0],ye.slice(1))},showErrorMessage(de,...ye){return Vn.showMessage(Be,w.default.Error,de,ye[0],ye.slice(1))},showQuickPick(de,ye,Ue){return Sn.showQuickPick(Be,de,ye,Ue)},showWorkspaceFolderPick(de){return Sn.showWorkspaceFolderPick(de)},showInputBox(de,ye){return Sn.showInput(de,ye)},showOpenDialog(de){return Mn.showOpenDialog(Be,de)},showSaveDialog(de){return Mn.showSaveDialog(de)},createStatusBarItem(de,ye,Ue){let ct,yt,Rt;return typeof de=="string"?(ct=de,yt=ye,Rt=Ue):(yt=de,Rt=ye),_n.createStatusBarEntry(Be,ct,yt,Rt)},setStatusBarMessage(de,ye){return _n.setStatusBarMessage(de,ye)},withScmProgress(de){return Mt.report("window.withScmProgress",Be,"Use 'withProgress' instead."),In.withProgress(Be,{location:Me.ProgressLocation.SourceControl},(ye,Ue)=>de({report(ct){}}))},withProgress(de,ye){return In.withProgress(Be,de,ye)},createOutputChannel(de,ye){return pn.createOutputChannel(de,ye,Be)},createWebviewPanel(de,ye,Ue,ct){return An.createWebviewPanel(Be,de,ye,Ue,ct)},createWebviewTextEditorInset(de,ye,Ue,ct){return(0,xe.$OG)(Be,"editorInsets"),ht.createWebviewEditorInset(de,ye,Ue,ct,Be)},createTerminal(de,ye,Ue){return typeof de=="object"?"pty"in de?St.createExtensionTerminal(de):St.createTerminalFromOptions(de):St.createTerminal(de,ye,Ue)},registerTerminalLinkProvider(de){return St.registerLinkProvider(de)},registerTerminalProfileProvider(de,ye){return St.registerProfileProvider(Be,de,ye)},registerTerminalQuickFixProvider(de,ye){return(0,xe.$OG)(Be,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(de,Be.identifier.value,ye)},registerTreeDataProvider(de,ye){return Ke.registerTreeDataProvider(de,ye,Be)},createTreeView(de,ye){return Ke.createTreeView(de,ye,Be)},registerWebviewPanelSerializer:(de,ye)=>An.registerWebviewPanelSerializer(Be,de,ye),registerCustomEditorProvider:(de,ye,Ue={})=>zn.registerCustomEditorProvider(Be,de,ye,Ue),registerFileDecorationProvider(de){return Ot.registerFileDecorationProvider(de,Be)},registerUriHandler(de){return vn.registerUriHandler(Be,de)},createQuickPick(){return Sn.createQuickPick(Be)},createInputBox(){return Sn.createInputBox(Be)},get activeColorTheme(){return Fn.activeColorTheme},onDidChangeActiveColorTheme(de,ye,Ue){return ot(Fn.onDidChangeActiveColorTheme)(de,ye,Ue)},registerWebviewViewProvider(de,ye,Ue){return Un.registerWebviewViewProvider(Be,de,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return Oe.activeNotebookEditor},onDidChangeActiveNotebookEditor(de,ye,Ue){return ot(Oe.onDidChangeActiveNotebookEditor)(de,ye,Ue)},get visibleNotebookEditors(){return Oe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Oe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(de,ye,Ue){return ot(Ee.onDidChangeNotebookEditorSelection)(de,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(de,ye,Ue){return ot(Ee.onDidChangeNotebookEditorVisibleRanges)(de,ye,Ue)},showNotebookDocument(de,ye){return Oe.showNotebookDocument(de,ye)},registerExternalUriOpener(de,ye,Ue){return(0,xe.$OG)(Be,"externalUriOpener"),Xn.registerExternalUriOpener(Be.identifier,de,ye,Ue)},registerProfileContentHandler(de,ye){return(0,xe.$OG)(Be,"profileContentHandlers"),Yn.registerProfileContentHandler(Be,de,ye)},registerQuickDiffProvider(de,ye,Ue,ct){return(0,xe.$OG)(Be,"quickDiffProvider"),Qn.registerQuickDiffProvider(vt(de),ye,Ue,ct)},get tabGroups(){return Gt.tabGroups},registerShareProvider(de,ye){return(0,xe.$OG)(Be,"shareProvider"),Ln.registerShareProvider(vt(de),ye)}},Hn={get rootPath(){return Mt.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(de){throw new L.$9("rootPath")},getWorkspaceFolder(de){return mt.getWorkspaceFolder(de)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(de){throw new L.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(de){throw new L.$9("workspaceFile")},updateWorkspaceFolders:(de,ye,...Ue)=>mt.updateWorkspaceFolders(Be,de,ye||0,...Ue),onDidChangeWorkspaceFolders:function(de,ye,Ue){return ot(mt.onDidChangeWorkspace)(de,ye,Ue)},asRelativePath:(de,ye)=>mt.getRelativePath(de,ye),findFiles:(de,ye,Ue,ct)=>mt.findFiles(de,ye,Ue,Be.identifier,ct),findFiles2:(de,ye,Ue)=>((0,xe.$OG)(Be,"findFiles2"),mt.findFiles2(de,ye,Be.identifier,Ue)),findTextInFiles:(de,ye,Ue,ct)=>{(0,xe.$OG)(Be,"findTextInFiles");let yt,Rt;return typeof ye=="object"?(yt=ye,Rt=Ue):(yt={},Rt=ye,ct=Ue),mt.findTextInFiles(de,yt||{},Rt,Be.identifier,ct)},save:de=>mt.save(de),saveAs:de=>mt.saveAs(de),saveAll:de=>mt.saveAll(de),applyEdit(de,ye){return $i.applyWorkspaceEdit(de,Be,ye)},createFileSystemWatcher:(de,ye,Ue,ct)=>{let yt;return typeof ye=="boolean"?yt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:ye&&((0,xe.$OG)(Be,"createFileSystemWatcher"),yt={...ye,correlate:!0}),zt.createFileSystemWatcher(mt,Be,de,yt)},get textDocuments(){return At.getAllDocumentData().map(de=>de.document)},set textDocuments(de){throw new L.$9("textDocuments")},openTextDocument(de){let ye;const Ue=de;if(typeof de=="string")ye=Promise.resolve($.URI.file(de));else if($.URI.isUri(de))ye=Promise.resolve(de);else if(!Ue||typeof Ue=="object")ye=At.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ct=>(ct.scheme===R.Schemas.vscodeRemote&&!ct.authority&&Mt.report("workspace.openTextDocument",Be,"A URI of 'vscode-remote' scheme requires an authority."),At.ensureDocumentData(ct).then(yt=>yt.document)))},onDidOpenTextDocument:(de,ye,Ue)=>ot(At.onDidAddDocument)(de,ye,Ue),onDidCloseTextDocument:(de,ye,Ue)=>ot(At.onDidRemoveDocument)(de,ye,Ue),onDidChangeTextDocument:(de,ye,Ue)=>ot(At.onDidChangeDocument)(de,ye,Ue),onDidSaveTextDocument:(de,ye,Ue)=>ot(At.onDidSaveDocument)(de,ye,Ue),onWillSaveTextDocument:(de,ye,Ue)=>ot(sn.getOnWillSaveTextDocumentEvent(Be))(de,ye,Ue),get notebookDocuments(){return Oe.notebookDocuments.map(de=>de.apiNotebook)},async openNotebookDocument(de,ye){let Ue;if($.URI.isUri(de))Ue=de,await Oe.openNotebookDocument(de);else if(typeof de=="string")Ue=$.URI.revive(await Oe.createNotebookDocument({viewType:de,content:ye}));else throw new Error("Invalid arguments");return Oe.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(de,ye,Ue){return ot(ze.onDidSaveNotebookDocument)(de,ye,Ue)},onDidChangeNotebookDocument(de,ye,Ue){return ot(ze.onDidChangeNotebookDocument)(de,ye,Ue)},onWillSaveNotebookDocument(de,ye,Ue){return ot(He.getOnWillSaveNotebookDocumentEvent(Be))(de,ye,Ue)},get onDidOpenNotebookDocument(){return ot(Oe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Oe.onDidCloseNotebookDocument)},registerNotebookSerializer(de,ye,Ue,ct){return Oe.registerNotebookSerializer(Be,de,ye,Ue,(0,xe.$NG)(Be,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(de,ye,Ue)=>ot(qn.onDidChangeConfiguration)(de,ye,Ue),getConfiguration(de,ye){return ye=arguments.length===1?void 0:ye,qn.getConfiguration(de,ye,Be)},registerTextDocumentContentProvider(de,ye){return kn.registerTextDocumentContentProvider(de,ye)},registerTaskProvider:(de,ye)=>(Mt.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),rn.registerTaskProvider(Be,de,ye)),registerFileSystemProvider(de,ye,Ue){return(0,A.$Rc)(Tt.registerFileSystemProvider(Be,de,ye,Ue),Zt.addFileSystemProvider(de,ye,Ue))},get fs(){return Zt.value},registerFileSearchProvider:(de,ye)=>((0,xe.$OG)(Be,"fileSearchProvider"),gn.registerFileSearchProvider(de,ye)),registerTextSearchProvider:(de,ye)=>((0,xe.$OG)(Be,"textSearchProvider"),gn.registerTextSearchProvider(de,ye)),registerAITextSearchProvider:(de,ye)=>((0,xe.$OG)(Be,"aiTextSearchProvider"),(0,xe.$OG)(Be,"textSearchProvider"),gn.registerAITextSearchProvider(de,ye)),registerRemoteAuthorityResolver:(de,ye)=>((0,xe.$OG)(Be,"resolvers"),Ft.registerRemoteAuthorityResolver(de,ye)),registerResourceLabelFormatter:de=>((0,xe.$OG)(Be,"resolvers"),Tn.$registerResourceLabelFormatter(de)),getRemoteExecServer:de=>((0,xe.$OG)(Be,"resolvers"),Ft.getRemoteExecServer(de)),onDidCreateFiles:(de,ye,Ue)=>ot(zt.onDidCreateFile)(de,ye,Ue),onDidDeleteFiles:(de,ye,Ue)=>ot(zt.onDidDeleteFile)(de,ye,Ue),onDidRenameFiles:(de,ye,Ue)=>ot(zt.onDidRenameFile)(de,ye,Ue),onWillCreateFiles:(de,ye,Ue)=>ot(zt.getOnWillCreateFileEvent(Be))(de,ye,Ue),onWillDeleteFiles:(de,ye,Ue)=>ot(zt.getOnWillDeleteFileEvent(Be))(de,ye,Ue),onWillRenameFiles:(de,ye,Ue)=>ot(zt.getOnWillRenameFileEvent(Be))(de,ye,Ue),openTunnel:de=>((0,xe.$OG)(Be,"tunnels"),qt.openTunnel(Be,de).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,xe.$OG)(Be,"tunnels"),qt.getTunnels()},onDidChangeTunnels:(de,ye,Ue)=>((0,xe.$OG)(Be,"tunnels"),ot(qt.onDidChangeTunnels)(de,ye,Ue)),registerPortAttributesProvider:(de,ye)=>((0,xe.$OG)(Be,"portsAttributes"),qt.registerPortsAttributesProvider(de,ye)),registerTunnelProvider:(de,ye)=>((0,xe.$OG)(Be,"tunnelFactory"),qt.registerTunnelProvider(de,ye)),registerTimelineProvider:(de,ye)=>((0,xe.$OG)(Be,"timeline"),Zn.registerTimelineProvider(de,ye,Be.identifier,pt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:de=>((0,xe.$OG)(Be,"workspaceTrust"),mt.requestWorkspaceTrust(de)),onDidGrantWorkspaceTrust:(de,ye,Ue)=>ot(mt.onDidGrantWorkspaceTrust)(de,ye,Ue),registerEditSessionIdentityProvider:(de,ye)=>((0,xe.$OG)(Be,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(de,ye)),onWillCreateEditSessionIdentity:(de,ye,Ue)=>((0,xe.$OG)(Be,"editSessionIdentityProvider"),ot(mt.getOnWillCreateEditSessionIdentityEvent(Be))(de,ye,Ue)),registerCanonicalUriProvider:(de,ye)=>((0,xe.$OG)(Be,"canonicalUriProvider"),mt.registerCanonicalUriProvider(de,ye)),getCanonicalUri:(de,ye,Ue)=>((0,xe.$OG)(Be,"canonicalUriProvider"),mt.provideCanonicalUri(de,ye,Ue))},ri={get inputBox(){return Mt.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),Pn.getLastInputBox(Be)},createSourceControl(de,ye,Ue){return Pn.createSourceControl(Be,de,ye,Ue)}},bi={createCommentController(de,ye){return Nn.createCommentController(Be,de,ye)}},si={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){return Dt.activeStackItem},registerDebugVisualizationProvider(de,ye){return(0,xe.$OG)(Be,"debugVisualization"),Dt.registerDebugVisualizationProvider(Be,de,ye)},registerDebugVisualizationTreeProvider(de,ye){return(0,xe.$OG)(Be,"debugVisualization"),Dt.registerDebugVisualizationTree(Be,de,ye)},onDidStartDebugSession(de,ye,Ue){return ot(Dt.onDidStartDebugSession)(de,ye,Ue)},onDidTerminateDebugSession(de,ye,Ue){return ot(Dt.onDidTerminateDebugSession)(de,ye,Ue)},onDidChangeActiveDebugSession(de,ye,Ue){return ot(Dt.onDidChangeActiveDebugSession)(de,ye,Ue)},onDidReceiveDebugSessionCustomEvent(de,ye,Ue){return ot(Dt.onDidReceiveDebugSessionCustomEvent)(de,ye,Ue)},onDidChangeBreakpoints(de,ye,Ue){return ot(Dt.onDidChangeBreakpoints)(de,ye,Ue)},onDidChangeActiveStackItem(de,ye,Ue){return ot(Dt.onDidChangeActiveStackItem)(de,ye,Ue)},registerDebugConfigurationProvider(de,ye,Ue){return Dt.registerDebugConfigurationProvider(de,ye,Ue||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(de,ye){return Dt.registerDebugAdapterDescriptorFactory(Be,de,ye)},registerDebugAdapterTrackerFactory(de,ye){return Dt.registerDebugAdapterTrackerFactory(de,ye)},startDebugging(de,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Dt.startDebugging(de,ye,{parentSession:Ue}):Dt.startDebugging(de,ye,Ue||{})},stopDebugging(de){return Dt.stopDebugging(de)},addBreakpoints(de){return Dt.addBreakpoints(de)},removeBreakpoints(de){return Dt.removeBreakpoints(de)},asDebugSourceUri(de,ye){return Dt.asDebugSourceUri(de,ye)}},oi={registerTaskProvider:(de,ye)=>rn.registerTaskProvider(Be,de,ye),fetchTasks:de=>rn.fetchTasks(de),executeTask:de=>rn.executeTask(Be,de),get taskExecutions(){return rn.taskExecutions},onDidStartTask:(de,ye,Ue)=>ot(rn.onDidStartTask)(de,ye,Ue),onDidEndTask:(de,ye,Ue)=>ot(rn.onDidEndTask)(de,ye,Ue),onDidStartTaskProcess:(de,ye,Ue)=>ot(rn.onDidStartTaskProcess)(de,ye,Ue),onDidEndTaskProcess:(de,ye,Ue)=>ot(rn.onDidEndTaskProcess)(de,ye,Ue)},wi={createNotebookController(de,ye,Ue,ct,yt){return ee.createNotebookController(Be,de,ye,Ue,ct,(0,xe.$NG)(Be,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(de,ye)=>Oe.registerNotebookCellStatusBarItemProvider(Be,de,ye),createRendererMessaging(de){return Te.createRendererMessaging(Be,de)},createNotebookControllerDetectionTask(de){return(0,xe.$OG)(Be,"notebookKernelSource"),ee.createNotebookControllerDetectionTask(Be,de)},registerKernelSourceActionProvider(de,ye){return(0,xe.$OG)(Be,"notebookKernelSource"),ee.registerKernelSourceActionProvider(Be,de,ye)},onDidChangeNotebookCellExecutionState(de,ye,Ue){return(0,xe.$OG)(Be,"notebookCellExecutionState"),ot(ee.onDidChangeNotebookCellExecutionState)(de,ye,Ue)}},vi={t(...de){if(typeof de[0]=="string"){const ye=de.shift(),Ue=!de||typeof de[0]!="object"?de:de[0];return hn.getMessage(Be.identifier.value,{message:ye,args:Ue})}return hn.getMessage(Be.identifier.value,de[0])},get bundle(){return hn.getBundle(Be.identifier.value)},get uri(){return hn.getBundleUri(Be.identifier.value)}},ai={_version:1,transferActiveChat(de){return(0,xe.$OG)(Be,"interactive"),Rn.transferActiveChat(de)}},Gn={getRelatedInformation(de,ye){return(0,xe.$OG)(Be,"aiRelatedInformation"),Bn.getRelatedInformation(Be,de,ye)},registerRelatedInformationProvider(de,ye){return(0,xe.$OG)(Be,"aiRelatedInformation"),Bn.registerRelatedInformationProvider(Be,de,ye)},registerEmbeddingVectorProvider(de,ye){return(0,xe.$OG)(Be,"aiRelatedInformation"),gi.registerEmbeddingVectorProvider(Be,de,ye)}},ci={_version:1,registerChatResponseProvider(de,ye,Ue){return(0,xe.$OG)(Be,"chatProvider"),Kt.registerLanguageModel(Be,de,ye,Ue)},registerChatVariableResolver(de,ye,Ue,ct,yt,Rt){return(0,xe.$OG)(Be,"chatVariableResolver"),xn.registerVariableResolver(Be,de,ye,Ue,ct,yt,Rt)},registerMappedEditsProvider(de,ye){return(0,xe.$OG)(Be,"mappedEditsProvider"),lt.registerMappedEditsProvider(Be,de,ye)},createChatParticipant(de,ye){return Rn.createChatAgent(Be,de,ye)},createDynamicChatParticipant(de,ye,Ue){return(0,xe.$OG)(Be,"chatParticipantAdditions"),Rn.createDynamicChatAgent(Be,de,ye,Ue)}},ui={selectChatModels:de=>gt.quality==="stable"?(console.warn(`[${E.$Vm.toKey(Be.identifier)}] This API is disabled in '${gt.environment.appName}'-stable.`),Promise.resolve([])):Kt.selectLanguageModels(Be,de??{}),onDidChangeChatModels:(de,ye,Ue)=>gt.quality==="stable"?(console.warn(`[${E.$Vm.toKey(Be.identifier)}] This API is disabled in '${gt.environment.appName}'-stable.`),M.Event.None(de,ye,Ue)):Kt.onDidChangeProviders(de,ye,Ue),get embeddingModels(){return(0,xe.$OG)(Be,"embeddings"),bn.embeddingsModels},onDidChangeEmbeddingModels:(de,ye,Ue)=>((0,xe.$OG)(Be,"embeddings"),bn.onDidChange(de,ye,Ue)),registerEmbeddingsProvider(de,ye){return(0,xe.$OG)(Be,"embeddings"),bn.registerEmbeddingsProvider(Be,de,ye)},async computeEmbeddings(de,ye,Ue){return(0,xe.$OG)(Be,"embeddings"),bn.computeEmbeddings(de,ye,Ue)}},li={registerSpeechProvider(de,ye){return(0,xe.$OG)(Be,"speech"),Wn.registerProvider(Be.identifier,de,ye)}};return{version:gt.version,ai:Gn,authentication:ti,commands:mn,comments:bi,chat:ci,debug:si,env:Dn,extensions:On,interactive:ai,l10n:vi,languages:ni,lm:ui,notebooks:wi,scm:ri,speech:li,tasks:oi,tests:pi,window:ii,workspace:Hn,Breakpoint:Me.$qN,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$lO,CallHierarchyIncomingCall:Me.$OM,CallHierarchyItem:Me.$NM,CallHierarchyOutgoingCall:Me.$PM,CancellationError:L.$5,CancellationTokenSource:l.$se,CandidatePortSource:n.CandidatePortSource,CodeAction:Me.$KM,CodeActionKind:Me.$LM,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$QM,Color:Me.$4M,ColorInformation:Me.$5M,ColorPresentation:Me.$6M,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$XM,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$YM,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$bN,DebugAdapterExecutable:Me.$uN,DebugAdapterInlineImplementation:Me.$xN,DebugAdapterNamedPipeServer:Me.$wN,DebugAdapterServer:Me.$vN,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$NN,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$DM,DiagnosticRelatedInformation:Me.$CM,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$pM,DocumentHighlight:Me.$GM,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$HM,DocumentLink:Me.$3M,DocumentSymbol:Me.$JM,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$AN,InlineValueText:Me.$BN,InlineValueVariableLookup:Me.$CN,InlineValueEvaluatableExpression:Me.$DN,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:M.$he,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$PN,FileDecoration2:Me.$PN,FileSystemError:Me.$GN,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Me.$HN,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$sN,InlineCompletionItem:Me.$ZM,InlineCompletionList:Me.$1M,Hover:Me.$EM,VerboseHover:Me.$FM,HoverVerbosityAction:Me.HoverVerbosityAction,IndentAction:P.IndentAction,Location:Me.$BM,MarkdownString:Me.$RM,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Me.$SM,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$qM,ProcessExecution:Me.$_M,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$ON,Range:Me.$rM,RelativePattern:Me.$oN,Selection:Me.$sM,SelectionRange:Me.$MM,SemanticTokens:Me.$KN,SemanticTokensBuilder:Me.$JN,SemanticTokensEdit:Me.$LN,SemanticTokensEdits:Me.$MN,SemanticTokensLegend:Me.$IN,ShellExecution:Me.$aN,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$UM,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$TM,SnippetString:Me.$AM,SourceBreakpoint:Me.$rN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$IM,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$cN,TaskGroup:Me.$$M,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$7M,TerminalQuickFixTerminalCommand:Me.$9M,TerminalQuickFixOpener:Me.$8M,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$0M,TerminalExitReason:Me.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Me.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$wM,SnippetTextEdit:Me.$yM,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$nN,ThemeIcon:Me.$mN,TreeItem:Me.$dN,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$_N,UIKind:xt.UIKind,Uri:$.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$zM,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$jN,DocumentDropOrPasteEditKind:Me.$kN,DocumentPasteEdit:Me.$lN,InlayHint:Me.$WM,InlayHintLabelPart:Me.$VM,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$vM,ResolvedAuthority:Me.$tM,ManagedResolvedAuthority:Me.$uM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$ZN,NotebookRange:Me.$RN,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$SN,NotebookData:Me.$TN,NotebookRendererScript:Me.$XN,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$VN,NotebookCellOutputItem:Me.$UN,NotebookCellStatusBarItem:Me.$WN,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$xM,NotebookKernelSourceAction:Me.$YN,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$2N,LinkedEditingRanges:Me.$1N,TestResultState:Me.TestResultState,TestRunRequest:Me.$3N,TestMessage:Me.$4N,TestTag:Me.$5N,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:on.TextSearchCompleteMessageType,DataTransfer:Me.$iN,DataTransferItem:Me.$eN,TestCoverageCount:Me.$6N,FileCoverage:Me.$8N,FileCoverage2:Me.$8N,StatementCoverage:Me.$9N,BranchCoverage:Me.$0N,DeclarationCoverage:Me.$$N,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$aO,TabInputTextDiff:Me.$bO,TabInputTextMerge:Me.$cO,TabInputCustom:Me.$dO,TabInputNotebook:Me.$fO,TabInputNotebookDiff:Me.$gO,TabInputWebview:Me.$eO,TabInputTerminal:Me.$hO,TabInputInteractiveWindow:Me.$iO,TabInputChat:Me.$jO,TabInputTextMultiDiff:Me.$kO,TelemetryTrustedValue:c.$lp,LogLevel:d.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Me.$yN,DebugThread:Me.$zN,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,TextToSpeechStatus:Me.TextToSpeechStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$mO,ChatResponseFileTreePart:Me.$qO,ChatResponseAnchorPart:Me.$rO,ChatResponseProgressPart:Me.$sO,ChatResponseProgressPart2:Me.$tO,ChatResponseReferencePart:Me.$wO,ChatResponseWarningPart:Me.$uO,ChatResponseTextEditPart:Me.$xO,ChatResponseMarkdownWithVulnerabilitiesPart:Me.$nO,ChatResponseCommandButtonPart:Me.$vO,ChatResponseDetectedParticipantPart:Me.$oO,ChatResponseConfirmationPart:Me.$pO,ChatRequestTurn:Me.$yO,ChatResponseTurn:Me.$zO,ChatLocation:Me.ChatLocation,LanguageModelChatMessageRole:Me.LanguageModelChatMessageRole,LanguageModelChatMessage:Me.$AO,LanguageModelChatMessage2:Me.$AO,LanguageModelChatSystemMessage:Me.$BO,LanguageModelChatUserMessage:Me.$CO,LanguageModelChatAssistantMessage:Me.$DO,LanguageModelError:Me.$EO,NewSymbolName:Me.$FN,NewSymbolNameTag:Me.NewSymbolNameTag,NewSymbolNameTriggerKind:Me.NewSymbolNameTriggerKind,InlineEdit:Me.$FO,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(ke[385],De([1,0,85,158,44,152,45,34,73,43,95,96,97,119,71,91,151,70,60,118,90,72,150,11,61,116,117,121,122,156]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r,t,f,o,s,u,g,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$Ds)(s.$anc,s.$_mc,1),(0,l.$Ds)(f.$8j,t.$noc,1),(0,l.$Ds)(d.$fmc,d.$gmc,1),(0,l.$Ds)(w.$bP,w.$aP,0),(0,l.$Ds)(g.$pmc,g.$qmc,0),(0,l.$Ds)(b.$7mc,b.$8mc,0),(0,l.$Ds)(R.$Emc,R.$Cmc,0),(0,l.$Ds)(c.$Gmc,c.$Fmc,0),(0,l.$Ds)(P.$knc,P.$onc,0),(0,l.$Ds)(A.$qnc,A.$pnc,0),(0,l.$Ds)($.$3O,$.$2O,0),(0,l.$Ds)(u.$bnc,u.$cnc,0),(0,l.$Ds)(i.$jmc,i.$imc,0),(0,l.$Ds)(L.$Vnc,L.$Unc,1),(0,l.$Ds)(p.$Gnc,p.$Hnc,0),(0,l.$Ds)(E.$Zmc,E.$Ymc,0),(0,l.$Ds)(I.$9nc,I.$8nc,0),(0,l.$Ds)(k.$3mc,k.$6mc,0),(0,l.$Ds)(S.$0nc,S.$$nc,0),(0,l.$Ds)(v.$_Db,v.$aEb,0),(0,l.$Ds)(h.$loc,h.$koc,0),(0,l.$Ds)(M.$Bmc,M.$Amc,0),(0,l.$Ds)(n.$0mc,n.$9mc,0),(0,l.$Ds)(a.$_O,a.$9O,0),(0,l.$Ds)(r.$Qmc,r.$Rmc,0),(0,l.$Ds)(o.$inc,o.$jnc,0)}),define(ke[123],De([1,0,19,11,37,94]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Foc=void 0,e.$Doc=R,e.$Eoc=w;function R(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}function w(P,p,E,v){const d=(0,l.$1b)(E,$),h=new M.$FK(p,d,v),c=h.preview.matches;return{ranges:(0,l.$1b)(d,k),uri:P,preview:{text:h.preview.text,matches:(0,l.$1b)(c,k)}}}function $(P){return new M.$GK(P.start.line,P.start.character,P.end.line,P.end.character)}function k(P){return new A.$uK(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let I=class{constructor(p,E){this.a=p,this.b=E}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$Foc=I,e.$Foc=I=Je([We(1,L.$7j)],I)}),define(ke[386],De([1,0,55,16,77,31,12,14,123,387]),function(le,e,l,L,M,A,R,w,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=P,e.$Hoc=h,e.$Ioc=i;const I=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(n,a,r,t){const f=p(n,a,r,t),o=a.folder.fsPath;return{cmd:l.spawn(I,f.args,{cwd:o}),rgDiskPath:I,siblingClauses:f.siblingClauses,rgArgs:f,cwd:o}}function p(n,a,r,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];v([a],r,!1).forEach(s=>{const u=(0,$.$Doc)(s);if(f.push("-g",u),R.$j){const g=(0,M.$gm)(u);g!==u&&f.push("-g",g)}});const o=E([a],t,void 0,!1);return o.globArgs.forEach(s=>{const u=`!${(0,$.$Doc)(s)}`;if(f.push("-g",u),R.$j){const g=(0,M.$gm)(u);g!==u&&f.push("-g",g)}}),a.disregardIgnoreFiles!==!1?f.push("--no-ignore"):a.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),a.ignoreSymlinks||f.push("--follow"),n.exists&&f.push("--quiet"),f.push("--no-config"),a.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:o.siblingClauses}}function E(n,a,r,t=!0){const f=[];let o={};return n.forEach(s=>{const u=Object.assign({},s.excludePattern||{},a||{}),g=d(u,t?s.folder.fsPath:void 0,r);f.push(...g.globArgs),g.siblingClauses&&(o=Object.assign(o,g.siblingClauses))}),{globArgs:f,siblingClauses:o}}function v(n,a,r=!0){const t=[];return n.forEach(f=>{const o=Object.assign({},a||{},f.includePattern||{}),s=d(o,r?f.folder.fsPath:void 0);t.push(...s.globArgs)}),t}function d(n,a,r){const t=[],f={};return Object.keys(n).forEach(o=>{if(r&&r.has(o)||!o)return;const s=n[o];o=c(a?h(a,o):o),o.startsWith("\\\\")?o="\\\\"+o.substr(2).replace(/\\/g,"/"):o=o.replace(/\\/g,"/"),typeof s=="boolean"&&s?(o.startsWith("\\\\")&&(o+="**"),t.push(i(o))):s&&s.when&&(f[o]=s)}),{globArgs:t,siblingClauses:f}}function h(n,a){return L.$ic(a)?a:L.$jc(n,a)}function c(n){return n=w.$jf(n,"\\"),w.$jf(n,"/")}function i(n){return A.$vg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(ke[388],De([1,0,55,54,16,389,19,47,35,77,31,12,40,14,18,32,37,386,133]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Koc=e.$Joc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(o=>o())});class a{constructor(s){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=s,this.b=s.filePattern||"",this.d=s.includePattern&&$.$uk(s.includePattern),this.f=s.maxResults||null,this.g=!!s.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=s.shouldGlobMatchFilePattern?null:(0,i.$Dr)(this.b).normalizedLowercase),this.u=s.excludePattern&&$.$uk(s.excludePattern),this.t=new Map,s.folderQueries.forEach(u=>{const g=Object.assign({},u.excludePattern||{},this.a.excludePattern||{}),b=u.folder.fsPath;s.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==b).forEach(S=>{(0,I.$zg)(S,b)&&(g[M.$lc(b,S)]=!0)}),this.t.set(b,new t(g,b))})}cancel(){this.l=!0,n.forEach(s=>s())}walk(s,u,g,b,S){if(this.m=p.$be.create(!1),this.l)return S(null,this.j);u.forEach(m=>{const y=M.$nc(m.fsPath);this.u&&this.u(m.fsPath,y)||this.J(g,{relativePath:m.fsPath,searchPath:void 0})}),this.r=p.$be.create(!1),this.w(s,(m,y)=>{this.x(this.y,this,m,g,b,D=>{if(D){const C=(0,w.$lj)(D);console.error(C),this.q.push(C),y(D,void 0)}else y(null,void 0)})},(m,y)=>{this.m.stop();const D=m?R.$Hb(m)[0]:null;S(D,this.j)})}w(s,u,g){const b=new Array(s.length),S=new Array(s.length);let m=!1,y=0;if(s.length===0)return g(null,[]);s.forEach((D,C)=>{u(D,(O,z)=>{if(O?(m=!0,b[C]=null,S[C]=O):(b[C]=z,S[C]=null),++y===s.length)return g(m?S:null,b)})})}x(s,u,...g){try{s.apply(u,g)}catch(b){g[g.length-1](b)}}y(s,u,g,b){const S=s.folder.fsPath,m=P.$j,y=()=>T&&T.kill();n.add(y);let D=B=>{n.delete(y),D=()=>{},b(B)},C="";const O=this.D(),z=(0,c.$Goc)(this.a,s,this.a.includePattern,this.t.get(s.folder.fsPath).expression),T=z.cmd,F=!Object.keys(z.siblingClauses).length,N=z.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let j=`${z.rgDiskPath} ${N}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),g({message:j}),this.s=0,this.z(T,"utf8",g,(B,X,ie)=>{if(B){D(B);return}if(this.j){D();return}const K=(C+(m?k.$fm(X||""):X)).split(`
`);if(ie){const x=K.length;K[x-1]=K[x-1].trim(),K[x-1]||K.pop()}else C=K.pop()||"";if(K.length&&K[0].indexOf(`
`)!==-1){D(new Error("Splitting up files failed"));return}if(this.s+=K.length,F){for(const x of K)if(this.J(u,{base:S,relativePath:x,searchPath:this.N(s,x)}),this.j){y();break}(ie||this.j)&&D();return}this.G(s,O,S,K,u),ie&&(this.H(O,S,u),D())})}spawnFindCmd(s){const u=this.t.get(s.folder.fsPath),g=u.getBasenameTerms(),b=u.getPathTerms(),S=["-L","."];if(g.length||b.length){S.push("-not","(","(");for(const m of g)S.push("-name",m),S.push("-o");for(const m of b)S.push("-path",m),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),l.spawn("find",S,{cwd:s.folder.fsPath})}readStdout(s,u,g){let b="";this.z(s,u,()=>{},(S,m,y)=>{if(S){g(S);return}b+=m,y&&g(null,b)})}z(s,u,g,b){let S=(D,C,O)=>{(D||O)&&(S=()=>{},this.r?.stop()),b(D,C,O)},m=!1;s.stdout?(this.A(s.stdout,u,S),s.stdout.once("data",()=>m=!0)):g({message:"stdout is null"});let y;s.stderr?y=this.B(s.stderr):g({message:"stderr is null"}),s.on("error",D=>{S(D)}),s.on("close",D=>{let C;!m&&(C=this.C(y,u))&&f(C)?S(new Error(`command failed with error code ${D}: ${this.C(y,u)}`)):(this.g&&D===0&&(this.j=!0),S(null,"",!0))})}A(s,u,g){const b=new A.StringDecoder(u);return s.on("data",S=>{g(null,b.write(S))}),b}B(s){const u=[];return s.on("data",g=>{u.push(g)}),u}C(s,u){const g=new A.StringDecoder(u);return s.map(b=>g.write(b)).join("")}D(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}G(s,{pathToEntries:u},g,b,S){b.indexOf(this.b)!==-1&&this.J(S,{base:g,relativePath:this.b,searchPath:this.N(s,this.b)});const m=y=>{const D=M.$nc(y),C=M.$mc(y);let O=u[C];O||(O=u[C]=[],m(C)),O.push({base:g,relativePath:y,basename:D,searchPath:this.N(s,y)})};b.forEach(m)}H({rootEntries:s,pathToEntries:u},g,b){const S=this,m=this.t.get(g),y=this.b;function D(C){S.o++;const O=(0,h.$VK)(()=>C.map(z=>z.basename));for(let z=0,T=C.length;z<T;z++){const F=C[z],{relativePath:N,basename:j}=F;if(m.test(N,j,y!==j?O:void 0))continue;const B=u[N];if(B)D(B);else{if(S.p++,N===y)continue;S.J(b,F)}if(S.j)break}}D(s)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(s,u,g,b,S){const m=s.folder,y=(0,h.$VK)(()=>g);this.w(g,(D,C)=>{if(this.l||this.j)return C(null);const O=u?[u,D].join(M.sep):D;if(this.t.get(s.folder.fsPath).test(O,D,this.a.filePattern!==D?y:void 0))return C(null);const z=[m.fsPath,O].join(M.sep);L.lstat(z,(T,F)=>{if(T||this.l||this.j)return C(null);this.L(z,F,(N,j)=>N||this.l||this.j?C(null):j.isDirectory()?(this.o++,this.M(z,F,(B,X)=>B||this.l||this.j||(X=X||"",this.v[X])?C(null):(this.v[X]=!0,d.Promises.readdir(z).then(ie=>{if(this.l||this.j)return C(null);this.I(s,O,ie,b,H=>C(H||null))},ie=>{C(null)})))):(this.p++,O===this.b||this.h&&v.$eg(j.size)&&j.size>this.h||this.J(b,{base:m.fsPath,relativePath:O,searchPath:this.N(s,O)}),C(null,void 0)))})},D=>{const C=D&&R.$Hb(D);return S(C&&C.length>0?C[0]:void 0)})}J(s,u){this.K(u)&&(!this.d||this.d(u.relativePath,M.$nc(u.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||s(u))}K(s){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,h.$QK)(s,this.c);if(this.b)return(0,h.$QK)(s,this.b,!1)}return!0}L(s,u,g){return u.isSymbolicLink()?L.stat(s,g):g(null,u)}M(s,u,g){return u.isSymbolicLink()?L.realpath(s,(b,S)=>b?g(b):g(null,S)):g(null,s)}N(s,u){return s.folderName?M.$jc(s.folderName,u):u}}e.$Joc=a;class r{constructor(s){this.a=s.folderQueries,this.b=s.extraFileResources||[],this.c=new a(s)}search(s,u,g){this.c.walk(this.a,this.b,s,u,(b,S)=>{g(b,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$Koc=r;class t{constructor(s,u){this.expression=s,this.c=u,this.d(s)}d(s){let u,g;Object.keys(s).filter(b=>s[b]).forEach(b=>{M.$ic(b)?(u=u||$.$pk(),u[b]=s[b]):(g=g||$.$pk(),g[b]=s[b])}),this.a=u&&$.$uk(u,{trimForExclusions:!0}),this.b=g&&$.$uk(g,{trimForExclusions:!0})}test(s,u,g){return this.b&&this.b(s,u,g)||this.a&&this.a(M.$jc(this.c,s),u,g)}getBasenameTerms(){const s=[];return this.a&&s.push(...$.$wk(this.a)),this.b&&s.push(...$.$wk(this.b)),s}getPathTerms(){const s=[];return this.a&&s.push(...$.$xk(this.a)),this.b&&s.push(...$.$xk(this.b)),s}}function f(o){const s=o.trim().split(`
`),u=s[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return E.$5f(s[s.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(ke[390],De([1,0,98,22,198,21]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sE=e.$kE=e.DecodeStreamErrorKind=e.$jE=e.$iE=e.$hE=e.$fE=e.$eE=e.$dE=e.$cE=void 0,e.$gE=R,e.$lE=v,e.$mE=d,e.$nE=h,e.$oE=c,e.$pE=i,e.$qE=o,e.$rE=s,e.$cE="utf8",e.$dE="utf8bom",e.$eE="utf16be",e.$fE="utf16le";function R(u){return[e.$cE,e.$dE,e.$eE,e.$fE].some(g=>g===u)}e.$hE=[254,255],e.$iE=[255,254],e.$jE=[239,187,191];const w=512,$=512,k=512*8,I=512*128;var P;(function(u){u[u.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class p extends Error{constructor(g,b){super(g),this.decodeStreamErrorKind=b}}e.$kE=p;class E{static async create(g){let b;if(g!==e.$cE)b=(await(0,M.$bE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(c(g));else{const S=new TextDecoder;b={write(m){return S.decode(m,{stream:!0})},end(){return S.decode()}}}return new E(b)}constructor(g){this.a=g}write(g){return this.a.write(g)}end(){return this.a.end()}}function v(u,g){const b=g.minBytesRequiredForDetection??g.guessEncoding?k:$;return new Promise((S,m)=>{const y=(0,l.$xe)(F=>F.join("")),D=[];let C=0,O;const z=new A.$se,T=async()=>{try{const F=await s({buffer:L.$Je.concat(D),bytesRead:C},g.guessEncoding);if(F.seemsBinary&&g.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);F.encoding=await g.overwriteEncoding(F.encoding),O=await E.create(F.encoding);const N=O.write(L.$Je.concat(D).buffer);y.write(N),D.length=0,C=0,S({stream:y,detected:F})}catch(F){z.cancel(),y.destroy(),m(F)}};(0,l.$Be)(u,{onData:async F=>{O?y.write(O.write(F.buffer)):(D.push(F),C+=F.byteLength,C>=b&&(u.pause(),await T(),setTimeout(()=>u.resume())))},onError:F=>y.error(F),onEnd:async()=>{O||await T(),y.end(O?.end())}},z.token)})}async function d(u,g,b){const m=(await(0,M.$bE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(c(g),b);let y=!1,D=!1;return{read(){if(D)return null;const C=u.read();if(typeof C!="string"){if(D=!0,!y&&b?.addBOM)switch(g){case e.$cE:case e.$dE:return L.$Je.wrap(Uint8Array.from(e.$jE));case e.$eE:return L.$Je.wrap(Uint8Array.from(e.$hE));case e.$fE:return L.$Je.wrap(Uint8Array.from(e.$iE))}const O=m.end();return O&&O.length>0?(y=!0,L.$Je.wrap(O)):null}return y=!0,L.$Je.wrap(m.write(C))}}}async function h(u){return(await(0,M.$bE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(c(u))}function c(u){return u===e.$dE||u===null?e.$cE:u}function i(u,g){if(!u||g<e.$hE.length)return null;const b=u.readUInt8(0),S=u.readUInt8(1);if(b===e.$hE[0]&&S===e.$hE[1])return e.$eE;if(b===e.$iE[0]&&S===e.$iE[1])return e.$fE;if(g<e.$jE.length)return null;const m=u.readUInt8(2);return b===e.$jE[0]&&S===e.$jE[1]&&m===e.$jE[2]?e.$dE:null}const n=["ascii","utf-16","utf-32"];async function a(u){const g=await(0,M.$bE)("jschardet","dist/jschardet.min.js"),b=u.slice(0,I),S=f(b.buffer),m=g.detect(S);if(!m||!m.encoding)return null;const y=m.encoding.toLowerCase();return 0<=n.indexOf(y)?null:t(m.encoding)}const r={ibm866:"cp866",big5:"cp950"};function t(u){const g=u.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return r[g]||g}function f(u){let g="";for(let b=0;b<u.length;b++)g+=String.fromCharCode(u[b]);return g}function o(u){switch(u){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const g=u.match(/windows(\d+)/);return g?"windows-"+g[1]:u}}}function s({buffer:u,bytesRead:g},b){let S=i(u,g),m=!1;if(S!==e.$eE&&S!==e.$fE&&u){let y=!0,D=!0,C=!1;for(let O=0;O<g&&O<w;O++){const z=O%2===1,T=u.readUInt8(O)===0;if(T&&(C=!0),y&&(z&&!T||!z&&T)&&(y=!1),D&&(z&&T||!z&&!T)&&(D=!1),T&&!y&&!D)break}C&&(y?S=e.$fE:D?S=e.$eE:m=!0)}return b&&!m&&!S&&u?a(u.slice(0,g)).then(y=>({seemsBinary:!1,encoding:y})):{seemsBinary:m,encoding:S}}e.$sE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[161],De([1,0,390,32,160]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0;class A extends M.$Cnc{constructor(w,$,k=L,I="searchProcess"){super({query:w,provider:$},{readdir:P=>k.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,l.$qE)(P)},I)}}e.$Soc=A}),define(ke[162],De([1,0,55,406,389,19,74,35,14,2,37,94,407,387,123]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Moc=e.$Loc=void 0,e.$Noc=t,e.$Ooc=o,e.$Poc=u,e.$Qoc=g,e.$Roc=S;const d=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(y){this.a=y}provideTextSearchResults(y,D,C,O){return this.a.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify({...D,folder:D.folder.toString()})}`),new Promise((z,T)=>{O.onCancellationRequested(()=>K());const F=t(y,D),N=D.folder.fsPath,j=F.map(Pe=>Pe.match(/^-/)?Pe:`'${Pe}'`).join(" ");this.a.appendLine(`${d} ${j}
 - cwd: ${N}`);let B=l.spawn(d,F,{cwd:N});B.on("error",Pe=>{console.error(Pe),this.a.appendLine("Error: "+(Pe&&Pe.message)),T((0,I.$MK)(new I.$KK(Pe&&Pe.message,I.SearchErrorCode.rgProcessError)))});let X=!1;const ie=new n(D.maxResults,D.folder,D.previewOptions);ie.on("result",Pe=>{X=!0,_="",C.report(Pe)});let H=!1;const K=()=>{H=!0,B?.kill(),ie?.cancel()};let x=!1;ie.on("hitLimit",()=>{x=!0,K()});let _="";B.stdout.on("data",Pe=>{ie.handleData(Pe),X||(_+=Pe)});let ge=!1;B.stdout.once("data",()=>ge=!0);let oe="";B.stderr.on("data",Pe=>{const me=Pe.toString();this.a.appendLine(me),oe.length+me.length<1e6&&(oe+=me)}),B.on("close",()=>{if(this.a.appendLine(ge?"Got data from stdout":"No data from stdout"),this.a.appendLine(X?"Got result from parser":"No result from parser"),_&&this.a.appendLine(`Got data without result: ${_}`),this.a.appendLine(""),H)z({limitHit:x});else{ie.flush(),B=null;let Pe;oe&&!ge&&(Pe=c(oe))?T((0,I.$MK)(new I.$KK(Pe.message,Pe.code))):z({limitHit:x})}})})}}e.$Loc=h;function c(m){const y=m.split(`
`),D=y[0].trim();if(y.some(O=>O.startsWith("regex parse error")))return new I.$KK(i(y),I.SearchErrorCode.regexParseError);const C=D.match(/grep config error: unknown encoding: (.*)/);if(C)return new I.$KK(`Unknown encoding: ${C[1]}`,I.SearchErrorCode.unknownEncoding);if(D.startsWith("error parsing glob"))return new I.$KK(D.charAt(0).toUpperCase()+D.substr(1),I.SearchErrorCode.globParseError);if(D.startsWith("the literal"))return new I.$KK(D.charAt(0).toUpperCase()+D.substr(1),I.SearchErrorCode.invalidLiteral);if(D.startsWith("PCRE2: error compiling pattern"))return new I.$KK(D,I.SearchErrorCode.regexParseError)}function i(m){const y=["Regex parse error"],D=m.filter(C=>C.startsWith("PCRE2:"));if(D.length>=1){const C=D[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const O=C.split(":")[1];y.push(":"+O)}}return y.join("")}class n extends L.EventEmitter{constructor(y,D,C){super(),this.g=y,this.h=D,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new M.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(y,D){return super.on(y,D),this}handleData(y){if(this.b)return;const D=typeof y=="string"?y:this.d.write(y);this.k(D)}k(y){let D=y.indexOf(`
`);const C=this.a+y;if(D>=0)D+=this.a.length;else{this.a=C;return}let O=0;for(;D>=0;)this.m(C.substring(O,D).trim()),O=D+1,D=C.indexOf(`
`,O);this.a=C.substring(O)}m(y){if(this.b||!y)return;let D;try{D=JSON.parse(y)}catch{throw new Error(`malformed line from rg: ${y}`)}if(D.type==="match"){const C=a(D.data.path),O=k.URI.joinPath(this.h,C),z=this.n(D.data,O);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(D.type==="context"){const C=a(D.data.path),O=k.URI.joinPath(this.h,C);this.o(D.data,O).forEach(T=>this.p(T))}}n(y,D){const C=y.line_number-1,O=a(y.lines),z=Buffer.from(O);let T=0,F=0,N=C;y.submatches.length===0&&y.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const j=(0,A.$Hb)(y.submatches.map((B,X)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=a(B.match),H=z.slice(T,B.start).toString(),K=r(H),x=K.numLines>0?K.lastLineLength:K.lastLineLength+F,_=r(ie),ge=K.numLines+N,oe=_.numLines+ge,Pe=_.numLines>0?_.lastLineLength:_.lastLineLength+x;return T=B.end,F=Pe,N=oe,new P.$uK(ge,x,oe,Pe)}));return(0,v.$Eoc)(D,O,j,this.j)}o(y,D){const C=a(y.lines),O=y.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((z,T)=>({text:z,uri:D,lineNumber:O+T}))}p(y){this.emit("result",y)}}e.$Moc=n;function a(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function r(m){const y=/\n/g;let D=0,C=-1,O;for(;O=y.exec(m);)D++,C=O.index;const z=C>=0?m.length-C-1:m.length;return{numLines:D,lastLineLength:z}}function t(m,y){const D=["--hidden","--no-require-git"];D.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:O}=(0,R.$K)(y.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const T=new Set;O.forEach(F=>{T.add(F)}),D.push("-g","!*"),T.forEach(F=>{f(F).map(v.$Doc).forEach(N=>{D.push("-g",N)})})}C&&C.length&&C.forEach(T=>{D.push("-g",T)}),y.excludes.map(v.$Doc).forEach(T=>D.push("-g",`!${T}`)),y.maxFileSize&&D.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?y.useParentIgnoreFiles||D.push("--no-ignore-parent"):D.push("--no-ignore"),y.followSymlinks&&D.push("--follow"),y.encoding&&y.encoding!=="utf8"&&D.push("--encoding",y.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,$.$df)(m.pattern),m.isRegExp=!0),y.usePCRE2&&D.push("--pcre2"),D.push("--crlf"),m.isRegExp&&(m.pattern=o(m.pattern),D.push("--engine","auto"));let z;if(m.isWordMatch){const F=(0,$.$mf)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");D.push("--regexp",F)}else if(m.isRegExp){let T=u(m.pattern);T=g(T),D.push("--regexp",T)}else z=m.pattern,D.push("--fixed-strings");return D.push("--no-config"),y.useGlobalIgnoreFiles||D.push("--no-ignore-global"),D.push("--json"),m.isMultiline&&D.push("--multiline"),y.beforeContext&&D.push("--before-context",y.beforeContext+""),y.afterContext&&D.push("--after-context",y.afterContext+""),D.push("--"),z&&D.push(z),D.push("."),D}function f(m){return S(m).flatMap(D=>{const C=(0,w.$sk)(D,"/");return C.map((O,z)=>C.slice(0,z+1).join("/"))})}function o(m){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(y);)m=m.replace(y,"$1\\x{$2}");const D=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(D);)m=m.replace(D,"$1\\x{$2}");return m}const s=m=>m.type==="Assertion"&&m.kind==="lookbehind";function u(m){let y;try{y=new p.RegExpParser().parsePattern(m)}catch{return m}let D="",C=0;const O=(F,N,j)=>{D+=m.slice(C,F)+j,C=N},z=[];return new p.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const N=z[0];if(!N)O(F.start,F.end,"\\r?\\n");else if(!z.some(s))if(N.type==="CharacterClass")if(N.negate){const j=m.slice(N.start+2,F.start)+m.slice(F.end,N.end-1);N.parent?.type==="Quantifier"?O(N.start,N.end,j?`[^${j}]`:"."):O(N.start,N.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=m.slice(N.start+1,F.start)+m.slice(F.end,N.end-1);O(N.start,N.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else N.type==="Quantifier"&&O(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){z.unshift(F)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(F){z.unshift(F)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(F){z.unshift(F)},onCharacterClassLeave(){z.shift()},onAssertionEnter(F){s(F)&&z.push(F)},onAssertionLeave(F){z[0]===F&&z.shift()}}).visit(y),D+=m.slice(C),D}function g(m){return m.replace(/\n/g,"\\r?\\n")}function b(m){let y=!1,D=!1,C="",O="";for(let z=0;z<m.length;z++){const T=m[z];switch(T){case"\\":D?(y?O+="\\"+T:C+="\\"+T,D=!1):D=!0;break;case"{":if(D)y?O+=T:C+=T,D=!1;else{if(y)return{strInBraces:C+"{"+O+"{"+m.substring(z+1)};y=!0}break;case"}":if(D)y?O+=T:C+=T,D=!1;else{if(y)return{fixedStart:C,strInBraces:O,fixedEnd:m.substring(z+1)};C+=T}break;default:y?O+=(D?"\\":"")+T:C+=(D?"\\":"")+T,D=!1;break}}return{strInBraces:C+(y?"{"+O:"")}}function S(m){const{fixedStart:y,strInBraces:D,fixedEnd:C}=b(m);if(y===void 0||C===void 0)return[D];let O=(0,w.$sk)(D,",");O.length||(O=[""]);const z=S(C);return O.flatMap(T=>{const F=y+T;return z.map(N=>F+N)})}}),define(ke[391],De([1,0,21,162,109,15]),function(le,e,l,L,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class R{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,I,P,p){const E=new L.$Loc(this.b);if(I.folder.scheme===A.Schemas.vscodeUserData){const v={...I,folder:I.folder.with({scheme:A.Schemas.file})},d=new M.$jw(h=>P.report({...h,uri:h.uri.with({scheme:I.folder.scheme})}));return this.c(p,h=>E.provideTextSearchResults(k,v,d,h))}else return this.c(p,v=>E.provideTextSearchResults(k,I,P,v))}async c(k,I){const P=w(k);this.a.add(P);const p=await I(P.token);return this.a.delete(P),p}d(){this.a.forEach(k=>k.cancel())}}e.$Voc=R;function w($){const k=new l.$se;return $.onCancellationRequested(()=>k.cancel()),k}}),define(ke[392],De([1,0,32,162,161]),function(le,e,l,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;class A{constructor($){this.a=$}search($,k,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const P={appendLine(E){I({message:E})}},p=new M.$Soc(this.a,new L.$Loc(P),l);return new Promise((E,v)=>p.search(d=>{k(d.map(R))},$).then(d=>E({limitHit:d.limitHit??!1,type:"success",stats:d.stats,messages:[]}),v))}}e.$Toc=A;function R(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce(($,k)=>{if(k.ranges){const I=k;return $+(Array.isArray(I.ranges)?I.ranges.length:1)}else return $+1},0)}}}),define(ke[393],De([1,0,19,7,13,4,133,16,40,2,33,37,388,392]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;class v{static{this.a=512}constructor(a="searchProcess"){this.d=a,this.b=Object.create(null)}fileSearch(a){let r;const t=c(a),f=new A.$he({onDidAddFirstListener:()=>{r=(0,L.$nh)(o=>this.doFileSearchWithEngine(p.$Koc,t,s=>f.fire(s),o)),r.then(o=>f.fire(o),o=>f.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{r.cancel()}});return f.event}textSearch(a){let r;const t=c(a),f=new A.$he({onDidAddFirstListener:()=>{r=(0,L.$nh)(o=>this.f(t,s=>f.fire(s),o)),r.then(o=>f.fire(o),o=>f.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onDidRemoveLastListener:()=>{r.cancel()}});return f.event}f(a,r,t){return a.maxFileSize=this.g().maxFileSize,new E.$Toc(a).search(t,r,r)}g(){return{maxFileSize:16*I.$Cl.GB}}doFileSearch(a,r,t){return this.doFileSearchWithEngine(p.$Koc,a,r,t)}doFileSearchWithEngine(a,r,t,f,o=v.a){let s=0;const u=b=>{Array.isArray(b)?(s+=b.length,t(b.map(S=>this.h(S)))):b.relativePath?(s++,t(this.h(b))):t(b)};if(r.sortByScore){let b=this.l(r,u,f);if(!b){const S=r.maxResults?Object.assign({},r,{maxResults:null}):r,m=new a(S);b=this.j(m,r,t,u,f)}return new Promise((S,m)=>{b.then(([y,D])=>{const C=D.map(O=>this.h(O));this.o(C,t,o),S(y)},m)})}const g=new a(r);return this.r(g,u,o,f).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:this.d,fromCache:!1,resultCount:s,sortingTime:void 0},messages:[]}))}h(a){return{path:a.base?(0,w.$jc)(a.base,a.relativePath):a.relativePath}}j(a,r,t,f,o){const s=new A.$he;let u=(0,L.$nh)(b=>{let S=[];const m=y=>{Array.isArray(y)?S=y:(f(y),s.fire(y))};return this.r(a,m,-1,b).then(y=>[y,S])}),g;if(r.cacheKey){g=this.k(r.cacheKey);const b={promise:u,event:s.event,resolved:!1};g.resultsToSearchCache[r.filePattern||""]=b,u.then(()=>{b.resolved=!0},S=>{delete g.resultsToSearchCache[r.filePattern||""]}),u=this.s(u)}return u.then(([b,S])=>{const m=g?g.scorerCache:Object.create(null),y=(typeof r.maxResults!="number"||r.maxResults>0)&&$.$be.create(!1);return this.n(r,S,m,o).then(D=>{const C=y?y.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:C,fromCache:!1,type:this.d,resultCount:D.length},messages:b.messages,limitHit:b.limitHit||typeof r.maxResults=="number"&&S.length>r.maxResults},D]})})}k(a){const r=this.b[a];return r||(this.b[a]=new d)}l(a,r,t){const f=a.cacheKey&&this.b[a.cacheKey];if(!f)return;const o=this.q(f,a.filePattern||"",r,t);if(o)return o.then(([s,u,g])=>{const b=$.$be.create(!1);return this.n(a,u,f.scorerCache,t).then(S=>{const m=b.elapsed(),y={fromCache:!0,detailStats:g,type:this.d,resultCount:u.length,sortingTime:m};return[{type:"success",limitHit:s.limitHit||typeof a.maxResults=="number"&&u.length>a.maxResults,stats:y,messages:[]},S]})})}n(a,r,t,f){const o=(0,R.$Dr)(a.filePattern||""),s=(g,b)=>(0,R.$Cr)(g,b,o,!0,h,t),u=typeof a.maxResults=="number"?a.maxResults:Number.MAX_VALUE;return l.$Gb(r,s,u,1e4,f)}o(a,r,t){if(t&&t>0)for(let f=0;f<a.length;f+=t)r(a.slice(f,f+t));else r(a)}q(a,r,t,f){const o=$.$be.create(!1),s=r.indexOf(w.sep)>=0;let u;for(const m in a.resultsToSearchCache)if(r.startsWith(m)){if(s&&m.indexOf(w.sep)<0&&m!=="")continue;const y=a.resultsToSearchCache[m];u={promise:this.s(y.promise),event:y.event,resolved:y.resolved};break}if(!u)return null;const g=o.elapsed(),b=$.$be.create(!1),S=u.event(t);return f&&f.onCancellationRequested(()=>{S.dispose()}),u.promise.then(([m,y])=>{if(f&&f.isCancellationRequested)throw(0,M.$6)();const D=[],C=(0,R.$Dr)(r).normalizedLowercase;for(const O of y)(0,P.$QK)(O,C)&&D.push(O);return[m,D,{cacheWasResolved:u.resolved,cacheLookupTime:g,cacheFilterTime:b.elapsed(),cacheEntryCount:y.length}]})}r(a,r,t,f){return new Promise((o,s)=>{let u=[];f?.onCancellationRequested(()=>a.cancel()),a.search(g=>{g&&(t?(u.push(g),t>0&&u.length>=t&&(r(u),u=[])):r(g))},g=>{r(g)},(g,b)=>{u.length&&r(u),g?(r({message:"Search finished. Error: "+g.message}),s(g)):(r({message:"Search finished. Stats: "+JSON.stringify(b.stats)}),o(b))})})}clearCache(a){return delete this.b[a],Promise.resolve(void 0)}s(a){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,t){return a.then(r,t)}catch(r){return this.then(void 0,r)}finally(r){return a.finally(r)}}}}e.$Uoc=v;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const h=new class{getItemLabel(n){return(0,w.$nc)(n.relativePath)}getItemDescription(n){return(0,w.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function c(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(a=>k.URI.revive(a))}}function i(n){return{...n,folder:k.URI.revive(n.folder)}}}),define(ke[394],De([1,0,3,15,2,32,11,28,20,97,68,37,393,391,123,161]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;let h=class extends k.$Hnc{constructor(i,n,a,r){super(i,a,r),this.w=A,this.x=-1,this.y=null,this.z=!1,this.A=new l.$Tc;const t=new v.$Foc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.vscodeUserData,new E.$Voc(t))),n.remote.isRemote&&n.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const i=new v.$Foc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.file,new E.$Voc(i))),this.A.add(this.C(L.Schemas.file,new p.$Uoc("fileSearchProvider")))}C(i,n){const a=this.d++;return this.y=n,this.x=a,this.c.$registerFileSearchProvider(a,this.s(i)),(0,l.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(a)})}$provideFileSearchResults(i,n,a,r){const t=(0,k.$Inc)(a);if(i===this.x){const f=Date.now();return this.D(i,n,t,r).then(o=>{const s=Date.now()-f;return this.q.debug(`Ext host file search time: ${s}ms`),o})}return super.$provideFileSearchResults(i,n,a,r)}doInternalFileSearchWithCustomCallback(i,n,a){const r=t=>{if((0,P.$PK)(t)&&(t=[t]),Array.isArray(t)){a(t.map(f=>M.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(i,r,n)}async D(i,n,a,r){return this.doInternalFileSearchWithCustomCallback(a,r,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,n){return new d.$Soc(i,n,void 0,"textSearchProvider")}};e.$Woc=h,e.$Woc=h=Je([We(0,$.$RO),We(1,w.$8O),We(2,I.$ymc),We(3,R.$7j)],h)}),define(ke[124],De([1,0,408,63,64,409,22,13,4,3,16,12,30,82,83]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=o,e.$ti=s,e.$vi=b,e.$wi=S;class d{traceSocketEvent(y,D){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,y,D)}constructor(y,D=""){this.f=!0,this.debugLabel=D,this.socket=y,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,w.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(y){const D=C=>{this.traceSocketEvent("read",C),y(R.$Je.wrap(C))};return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(y){const D=C=>{y({type:0,hadError:C,error:void 0})};return this.socket.on("close",D),{dispose:()=>this.socket.off("close",D)}}onEnd(y){const D=()=>{y()};return this.socket.on("end",D),{dispose:()=>this.socket.off("end",D)}}write(y){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",y),this.socket.write(y.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,w.$1)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,w.$1)(D)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((y,D)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),y();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),y()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$pi=d;var h;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(h||(h={}));var c;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(c||(c={}));class i extends k.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(y,D){this.socket.traceSocketEvent(y,D)}constructor(y,D,C,O){super(),this.f=this.B(new $.$he),this.g=this.B(new $.$he),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=y,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:D,inflateBytesLength:C?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new n(this,D,C,O,this.f,(z,T)=>this.m(z,T))),this.B(this.a.onError(z=>{console.error(z),(0,w.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$ki,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this.f.event(y)}onClose(y){return this.g.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){let D=0;for(;D<y.byteLength;)this.a.writeMessage(y.slice(D,Math.min(D+262144,y.byteLength)),{compressed:!0,opcode:2}),D+=262144}m(y,{compressed:D,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",y);let O=2;y.byteLength<126?O+=0:y.byteLength<2**16?O+=2:O+=8;const z=R.$Je.alloc(O),T=D?64:0,F=C&15;if(z.writeUInt8(128|T|F,0),y.byteLength<126)z.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){z.writeUInt8(126,1);let N=1;z.writeUInt8(y.byteLength>>>8&255,++N),z.writeUInt8(y.byteLength>>>0&255,++N)}else{z.writeUInt8(127,1);let N=1;z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(0,++N),z.writeUInt8(y.byteLength>>>24&255,++N),z.writeUInt8(y.byteLength>>>16&255,++N),z.writeUInt8(y.byteLength>>>8&255,++N),z.writeUInt8(y.byteLength>>>0&255,++N)}this.socket.write(R.$Je.concat([z,y]))}end(){this.h=!0,this.socket.end()}n(y){if(y.byteLength!==0){for(this.b.acceptChunk(y);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const D=this.b.peek(this.j.readLen),C=D.readUInt8(0),O=(C&128)>>>7,z=(C&64)>>>6,T=C&15,F=D.readUInt8(1),N=(F&128)>>>7,j=F&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const D=this.b.read(this.j.readLen),C=D.readUInt8(1),O=(C&128)>>>7;let z=C&127,T=1;z===126?z=D.readUInt8(++T)*2**8+D.readUInt8(++T):z===127&&(z=D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*0+D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T));let F=0;O&&(F=D.readUInt8(++T)*2**24+D.readUInt8(++T)*2**16+D.readUInt8(++T)*2**8+D.readUInt8(++T)),this.j.state=3,this.j.readLen=z,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const D=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",D),t(D,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",D),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(D,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(D,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$qi=i;class n extends k.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Je.alloc(0)}constructor(y,D,C,O,z,T){super(),this.n=y,this.r=z,this.s=T,this.a=this.B(new $.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,D?(this.b=this.B(new a(this.n,O,C,{windowBits:15})),this.f=this.B(new r(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(y,D){this.g.push({data:y,options:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:y,options:D}=this.g.shift();if(this.f&&D.compressed){const C=await this.w(this.f,y);this.s(C,D)}else this.s(y,{...D,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(y,D){return new Promise((C,O)=>{y.write(D),y.flush(z=>C(z))})}acceptFrame(y,D,C){this.h.push({data:y,isCompressed:D,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const y=this.h.shift();if(this.b&&y.isCompressed){const D=await this.C(this.b,y.data,y.isLastFrameOfMessage);this.r.fire(D)}else this.r.fire(y.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(y,D,C){return new Promise((O,z)=>{y.write(D),C&&y.write(R.$Je.fromByteArray([0,0,255,255])),y.flush(T=>O(T))})}}class a extends k.$Uc{get recordedInflateBytes(){return this.j?R.$Je.concat(this.f):R.$Je.alloc(0)}constructor(y,D,C,O){super(),this.h=y,this.j=D,this.a=this.B(new $.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(O),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(R.$Je.wrap(z))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(y){this.j&&this.f.push(y.clone()),this.h.traceSocketEvent("zlibInflateWrite",y),this.b.write(y.buffer)}flush(y){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const D=R.$Je.concat(this.g);this.g.length=0,y(D)})}}class r extends k.$Uc{constructor(y,D){super(),this.g=y,this.a=this.B(new $.$he),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(R.$Je.wrap(C))})}write(y){this.g.traceSocketEvent("zlibDeflateWrite",y.buffer),this.b.write(y.buffer)}flush(y){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let D=R.$Je.concat(this.f);this.f.length=0,D=D.slice(0,D.byteLength-4),y(D)})}}function t(m,y){if(y===0)return;const D=m.byteLength>>>2;for(let N=0;N<D;N++){const j=m.readUInt32BE(N*4);m.writeUInt32BE(j^y,N*4)}const C=D*4,O=m.byteLength-C,z=y>>>24&255,T=y>>>16&255,F=y>>>8&255;O>=1&&m.writeUInt8(m.readUInt8(C)^z,C),O>=2&&m.writeUInt8(m.readUInt8(C+1)^T,C+1),O>=3&&m.writeUInt8(m.readUInt8(C+2)^F,C+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function o(){const m=(0,p.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const y=process.platform!=="darwin"&&e.$ri?e.$ri:(0,M.tmpdir)(),D=(0,I.$jc)(y,`vscode-ipc-${m}.sock`);return u(D),D}function s(m,y,D){const O=(0,l.createHash)("sha256").update(m).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${D}-${y}-sock`;const z=D.substr(0,4),T=y.substr(0,6);let F;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?F=(0,I.$jc)(e.$ri,`vscode-${O}-${z}-${T}.sock`):F=(0,I.$jc)(m,`${z}-${T}.sock`),u(F),F}function u(m){const y=f[P.$u];typeof y=="number"&&m.length>=y&&console.warn(`WARNING: IPC handle "${m}" is longer than ${y} chars, try a shorter --user-data-dir`)}class g extends E.$ei{static b(y){const D=$.Event.fromNodeEventEmitter(y,"connection");return $.Event.map(D,C=>({protocol:new v.$li(new d(C,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(C,"close"))}))}constructor(y){super(g.b(y)),this.d=y}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=g;function b(m){return new Promise((y,D)=>{const C=(0,L.createServer)();C.on("error",D),C.listen(m,()=>{C.removeListener("error",D),y(new g(C))})})}function S(m,y){return new Promise((D,C)=>{const O=(0,L.createConnection)(m,()=>{O.removeListener("error",C),D(v.$mi.fromSocket(new d(O,`ipc-client${y}`),y))});O.once("error",C)})}}),define(ke[395],De([1,0,63,64,178,124,7,3,12,56,11,108,272,273,111,88,22]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=e.$Iec=e.$Hec=e.$Gec=void 0;async function c(t,f,o,s,u){let g;for(let b=3;b&&(g?.dispose(),g=await new i(t,f,o,s,u).waitForReady(),!(u&&M.$Zg[u]||!M.$Zg[g.tunnelLocalPort]));b--);return g}class i extends w.$Uc{constructor(f,o,s,u,g){super(),this.m=o,this.n=g,this.privacy=d.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=l.createServer(),this.c=new R.$zh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,o=(0,d.$ww)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,M.$1g)(f,2,1e3,o),u=null;return this.b.listen(s,this.m),await this.c.wait(),u=this.b.address(),u||(s=0,this.b.listen(s,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(f){f.pause();const o=(0,d.$uw)(this.tunnelRemoteHost)||(0,d.$ww)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,p.$Wl)(this.a,o,this.tunnelRemotePort),u=s.getSocket(),g=s.readEntireBuffer();s.dispose(),g.byteLength>0&&f.write(g.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),u.end()}),f.on("close",()=>u.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),u instanceof A.$pi?u.socket.destroy():u.end()}),u instanceof A.$pi?this.t(f,u):this.s(f,u),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),u.end()})}s(f,o){o.onClose(()=>f.destroy()),o.onEnd(()=>f.end()),o.onData(s=>f.write(s.buffer)),f.on("data",s=>o.write(h.$Je.wrap(s))),f.resume()}t(f,o){const s=o.socket;s.on("end",()=>f.end()),s.on("close",()=>f.end()),s.on("error",()=>{f.destroy()}),s.pipe(f),f.pipe(s)}}e.$Gec=i;let n=class extends d.$zw{constructor(f,o,s,u,g){super(o,g),this.v=f,this.w=s,this.y=u}isPortPrivileged(f){return(0,d.$xw)(f,this.m,$.OS,L.release())}t(f,o,s,u,g,b,S,m){const y=this.s(o,s);if(y)return++y.refcount,y.value;if((0,d.$qw)(f))return this.u(f,o,s,g,b,S,m);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${s} on local port ${g}.`);const D={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=c(D,u,o,s,g);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(o,s,C),C}}};e.$Hec=n,e.$Hec=n=Je([We(0,E.$Ql),We(1,I.$7j),We(2,v.$Tl),We(3,P.$nk),We(4,k.$7i)],n);let a=class extends n{constructor(f,o,s,u,g){super(f,o,s,u,g)}};e.$Iec=a,e.$Iec=a=Je([We(0,E.$Ql),We(1,I.$7j),We(2,v.$Tl),We(3,P.$nk),We(4,k.$7i)],a);let r=class extends w.$Uc{constructor(f,o,s,u,g){super(),this.b=f,this.c=o,this.f=s,this.g=u,this.h=g,this.a=new Map}async openTunnel(f,o,s,u,g,b,S,m,y){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${u} on local port ${b}.`),!this.a.has(f)){const D=new a(this.b,this.c,this.g,this.f,this.h);this.B(D),this.a.set(f,D),D.onTunnelClosed(async()=>{(await D.tunnels).length===0&&(D.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(o,s,u,g,b,S,m,y)}};e.$Jec=r,e.$Jec=r=Je([We(0,E.$Ql),We(1,I.$7j),We(2,P.$nk),We(3,v.$Tl),We(4,k.$7i)],r)}),define(ke[396],De([1,0,124,292,54,34,2,11,42]),function(le,e,l,L,M,A,R,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hP=e.$gP=void 0;class k{constructor(p,E,v){this.b=p,this.c=E,this.f=v,this.a=L.createServer((d,h)=>this.h(d,h)),this.g().catch(d=>(E.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,E){const v=(h,c)=>{E.writeHead(h,{"content-type":"application/json"}),E.end(JSON.stringify(c||null),i=>i&&this.c.error(i))},d=[];p.setEncoding("utf8"),p.on("data",h=>d.push(h)),p.on("end",async()=>{try{const h=JSON.parse(d.join(""));let c;switch(h.type){case"open":c=await this.i(h);break;case"openExternal":c=await this.j(h);break;case"status":c=await this.l(h);break;case"extensionManagement":c=await this.k(h);break;default:v(404,`Unknown message type: ${h.type}`);break}v(200,c)}catch(h){const c=h instanceof Error?h.message:JSON.stringify(h);v(500,c),this.c.error("Error while processing pipe request",h)}})}async i(p){const{fileURIs:E,folderURIs:v,forceNewWindow:d,diffMode:h,mergeMode:c,addMode:i,forceReuseWindow:n,gotoLineMode:a,waitMarkerFilePath:r,remoteAuthority:t}=p,f=[];if(Array.isArray(v))for(const g of v)try{f.push({folderUri:R.URI.parse(g)})}catch{}if(Array.isArray(E))for(const g of E)try{(0,$.$6i)(g)?f.push({workspaceUri:R.URI.parse(g)}):f.push({fileUri:R.URI.parse(g)})}catch{}const o=r?R.URI.file(r):void 0,u={forceNewWindow:d,diffMode:h,mergeMode:c,addMode:i,gotoLineMode:a,forceReuseWindow:n,preferNewWindow:!n&&!o&&!i,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,u)}async j(p){for(const E of p.uris){const v=R.URI.parse(E),d=v.scheme==="file"?v:E;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(p){const E=d=>d?.map(h=>/\.vsix$/i.test(h)?R.URI.parse(h):h),v={list:p.list,install:E(p.install),uninstall:E(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&M.existsSync(this.f)&&M.unlinkSync(this.f)}}e.$gP=k;let I=class extends k{constructor(p,E){super(p,E,(0,l.$si)())}};e.$hP=I,e.$hP=I=Je([We(0,A.$bP),We(1,w.$7j)],I)}),define(ke[397],De([1,0,59,384,379,291,49,366,2,15,8,396,104,326,365]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=void 0;class d extends M.$qoc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,a=n._load;n._load=function(o,s,u){return o=t(o),i.a.has(o)?i.a.get(o).load(o,$.URI.file((0,p.$ar)(s.filename)),g=>a.apply(this,[g,s,u])):a.apply(this,arguments)};const r=n._resolveLookupPaths;n._resolveLookupPaths=(f,o)=>r.call(this,t(f),o);const t=f=>{for(const o of i.b){const s=o(f);if(s){f=s;break}}return f}}}class h extends R.$enc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(E.$Zoc);const i=this.h.invokeFunction(L.$moc);if(this.h.createInstance(w.$Yoc),this.f.remote.isRemote&&this.f.remote.authority){const r=this.h.createInstance(P.$hP);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}this.h.createInstance(v.$1oc),await this.h.createInstance(d,i,{mine:this.J,all:this.L}).install(),l.mark("code/extHost/didInitAPI");const a=await this.m.getConfigProvider();await(0,A.$Xoc)(this.j,a,this,this.s,this.z,this.f),l.mark("code/extHost/didInitProxyResolver")}wb(i){return i.main}async xb(i,n,a){if(n.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let r=null;a.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&l.mark(`code/extHost/willLoadExtensionCode/${t}`),r=le.__$__nodeRequire(n.fsPath)}finally{t&&l.mark(`code/extHost/didLoadExtensionCode/${t}`),a.codeLoadingStop()}return r}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const a=i[n];a===null?delete process.env[n]:process.env[n]=a}}}e.$2oc=h}),define(ke[398],De([1,0,55,22,4,3,126,12,23,2,32,11,271,67,111,88,395,28,20,71,373]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=void 0,e.$3oc=r,e.$4oc=t,e.$5oc=f,e.$6oc=o,e.$7oc=u,e.$8oc=g,e.$9oc=b;function r(y){const D=y.trim().split(`
`),C=[];return D.forEach(z=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);T&&T.length>=3&&C.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),C.reduce((z,T)=>(z[T.socket]=T,z),{})}function t(...y){const D=[].concat(...y.map(o));return[...new Map(D.filter(C=>C.st==="0A").map(C=>{const O=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:f(O[0]),port:parseInt(O[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}function f(y){let D="";if(y.length===8)for(let C=y.length-2;C>=0;C-=2)D+=parseInt(y.substr(C,2),16),C!==0&&(D+=".");else for(let C=0;C<y.length;C+=8){const O=y.substring(C,C+8);let z="";for(let T=8;T>=2;T-=2)z+=O.substring(T-2,T),(T===6||T===2)&&(z=parseInt(z,16).toString(16),D+=`${z}`,z="",C+T!==y.length-6&&(D+=":"))}return D}function o(y){const D=y.trim().split(`
`),C=D.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return D.map(z=>z.trim().split(/\s+/).reduce((T,F,N)=>(T[C[N]||N]=F,T),{}))}function s(y){return!!y.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||y.indexOf("out/server-main.js")!==-1||y.indexOf("_productName=VSCode")!==-1}function u(y){const D=y.trim().split(`
`),C=[];return D.forEach(O=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);z&&z.length>=4&&C.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),C}async function g(y,D,C){const O=C.reduce((T,F)=>(T[F.pid]=F,T),{}),z=[];return y.forEach(({socket:T,ip:F,port:N})=>{const j=D[T]?D[T].pid:void 0,B=j?O[j]?.cmd:void 0;j&&B&&!s(B)&&z.push({host:F,port:N,detail:B,pid:j})}),z}function b(y,D,C){const O=new Map,z=u(D);for(const T of y){const F=C.get(T.port);if(F){O.set(T.port,F);continue}const N=z.find(j=>j.cmd.includes(`${T.port}`));if(N){let j=N,B;do B=z.find(X=>X.ppid===j.pid),B&&(j=B);while(B);O.set(T.port,{host:T.ip,port:T.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else O.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return O}let S=class extends n.$aEb{constructor(D,C,O,z){super(D,C,O),this.D=C,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,w.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(D){if(D&&this.C)return;this.C=D;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new R.$Im;let z=0;for(;this.C;){const T=new Date().getTime(),F=(await this.I()).filter(B=>(0,d.$uw)(B.host)||(0,d.$ww)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(B=>B.port).join(", ")}`);const N=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),z++>3&&O.update(N),(!C||JSON.stringify(C)!==JSON.stringify(F))&&(C=F,await this.a.$onFoundNewCandidates(C));const j=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(B=>setTimeout(()=>B(),j))}}G(D){return Math.max(D*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(D=>D.port).join(", ")}`)}async I(){let D="",C="";try{D=await I.Promises.readFile("/proc/net/tcp","utf8"),C=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(D,C),z=await new Promise(H=>{(0,l.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(K,x,_)=>{H(x)})}),T=r(z),F=await I.Promises.readdir("/proc"),N=[];for(const H of F)try{const K=Number(H),x=$.$bh(k.URI.file("/proc"),H);if((await I.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(K)){const ge=await I.Promises.readlink($.$bh(x,"cwd").fsPath),oe=await I.Promises.readFile($.$bh(x,"cmdline").fsPath,"utf8");N.push({pid:K,cwd:ge,cmd:oe})}}catch{}const j=[],B=O.filter(H=>{const K=T[H.socket];return K||j.push(H),K}),X=g(B,T,N);let ie;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const H=await new Promise(K=>{(0,l.exec)("ps -F -A -l | grep root",(x,_,ge)=>{K(_)})});this.z=b(j,H,this.z),ie=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ie.map(K=>K.port).join(", ")}`)}return X.then(H=>ie?H.concat(ie):H)}w(D){return async C=>{const O=new h.$Gec({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,F,N,j){const B=await D.makeConnection();return m.connect(B,F,N,j)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$Ml(0),connectionToken:D.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await O.waitForReady();const z=new M.$he;return{localAddress:(0,a.$NL)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{O.dispose(),z.fire(),z.dispose()}}}}};e.$0oc=S,e.$0oc=S=Je([We(0,i.$RO),We(1,c.$8O),We(2,P.$7j),We(3,v.$Tl)],S);class m extends p.$$vb{static connect(D,C,O,z){const T=new A.$Tc,F={onClose:T.add(new M.$he),onData:T.add(new M.$he),onEnd:T.add(new M.$he)};T.add(D.onDidReceiveMessage(j=>F.onData.fire(L.$Je.wrap(j)))),T.add(D.onDidEnd(()=>F.onEnd.fire())),T.add(D.onDidClose(j=>F.onClose.fire({type:0,error:j,hadError:!!j})));const N=new m(D,z,F);return N.B(T),(0,p.$0vb)(N,C,O,z,F)}constructor(D,C,O){super(C,O),this.n=D}write(D){this.n.send(D.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[399],De([1,0,85,368,382,381,394,397,398,96,49,97,95,43,71,93,367,327,11,383,61,286,106,111,141]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c,i,n,a,r,t,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$Ds)(I.$fnc,w.$2oc,0),(0,l.$Ds)(i.$8j,c.$_oc,1),(0,l.$Ds)(i.$7j,new t.$xi(r.$poc,[!1],!0)),(0,l.$Ds)(f.$Tl,o.$Lec,1),(0,l.$Ds)(d.$Hmc,h.$$oc,0),(0,l.$Ds)(k.$knc,A.$Coc,0),(0,l.$Ds)(P.$Gnc,R.$Woc,0),(0,l.$Ds)(p.$9nc,M.$uoc,0),(0,l.$Ds)(E.$3mc,L.$toc,0),(0,l.$Ds)(v.$_Db,$.$0oc,0),(0,l.$Ds)(a.$inc,n.$apc,0)}),define(ke[410],De([1,0,63,411,59,13,83,124,269,115,380,22,32,104,7,136,293,309,385,399]),function(le,e,l,L,M,A,R,w,$,k,I,P,p,E,v,d,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let b=0;b<process.execArgv.length;b++)process.execArgv[b]==="--inspect-port=0"&&(process.execArgv.splice(b,1),b--)}();const i=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const g=globalThis._VSCODE_NODE_MODULES.module,b=g._load;g._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return b.apply(this,arguments)}})();const n=process.exit.bind(process),a=process.on.bind(process);function r(g){process.exit=function(b){if(g)n(b);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const b=new Error("An extension called process.crash() and this was prevented.");console.warn(b.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(b,S){b==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),a(b,S)}}let t=function(g){n()};function f(){const g=(0,c.$sn)(process.env);if(g.type===3)return new Promise((b,S)=>{const m=y=>{const D=y[0],C=new R.$ni;D.on("message",O=>C.fire(P.$Je.wrap(O.data))),D.on("close",()=>{t("renderer closed the MessagePort")}),D.start(),b({onMessage:C.event,send:O=>D.postMessage(O.buffer)})};process.parentPort.on("message",y=>m(y.ports))});if(g.type===2)return new Promise((b,S)=>{let m=null;const y=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),D=108e5,C=3e5,O=new v.$Nh(()=>t("renderer disconnected for too long (1)"),D),z=new v.$Nh(()=>t("renderer disconnected for too long (2)"),C);process.on("message",(F,N)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const j=P.$Je.wrap(Buffer.from(F.initialDataChunk,"base64"));let B;if(F.skipWebSocketFrames)B=new w.$pi(N,"extHost-socket");else{const X=P.$Je.wrap(Buffer.from(F.inflateBytes,"base64"));B=new w.$qi(new w.$pi(N,"extHost-socket"),F.permessageDeflate,X,!1)}m?(O.cancel(),z.cancel(),m.beginAcceptReconnection(B,j),m.endAcceptReconnection(),m.sendResume()):(clearTimeout(y),m=new R.$oi({socket:B,initialChunk:j}),m.sendResume(),m.onDidDispose(()=>t("renderer disconnected")),b(m),m.onSocketClose(()=>{O.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;O.isScheduled()&&z.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const b=g.pipeName;return new Promise((S,m)=>{const y=l.createConnection(b,()=>{y.removeListener("error",m);const D=new R.$oi({socket:new w.$pi(y,"extHost-renderer")});D.sendResume(),S(D)});y.once("error",m),y.on("close",()=>{t("renderer closed the socket")})})}}async function o(){const g=await f();return new class{constructor(){this.a=new R.$ni,this.onMessage=this.a.event,this.b=!1,g.onMessage(b=>{(0,k.$5m)(b,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(b)})}send(b){this.b||g.send(b)}async drain(){if(g.drain)return g.drain()}}}function s(g){return new Promise(b=>{const S=g.onMessage(m=>{S.dispose();const y=JSON.parse(m.toString()),D=y.commit,C=$.default.commit;if(D&&C&&D!==C&&n(55),y.parentPid){let O=0;setInterval(function(){try{process.kill(y.parentPid,0),O=0}catch(T){T&&T.code==="EPERM"?(O++,O>=3&&t(`parent process ${y.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):t(`parent process ${y.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(y.parentPid)}catch(T){(0,A.$1)(T)}}g.send((0,k.$4m)(0)),b({protocol:g,initData:y})});g.send((0,k.$4m)(1))})}async function u(){const g=[];process.on("unhandledRejection",(O,z)=>{g.push(z),setTimeout(()=>{const T=g.indexOf(z);T>=0&&z.catch(F=>{g.splice(T,1),(0,A.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),O&&(0,A.$1)(O))})},1e3)}),process.on("rejectionHandled",O=>{const z=g.indexOf(O);z>=0&&g.splice(z,1)}),process.on("uncaughtException",function(O){(0,A.$Z)(O)||(0,A.$1)(O)}),M.mark("code/extHost/willConnectToRenderer");const b=await o();M.mark("code/extHost/didConnectToRenderer");const S=await s(b);M.mark("code/extHost/didWaitForInitData");const{initData:m}=S;r(!!m.environment.extensionTestsLocationURI),m.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,m.environment.skipWorkspaceStorageLock=(0,d.boolean)(i.skipWorkspaceStorageLock,!1);const y=new class{constructor(){this.pid=process.pid}exit(z){n(z)}fsExists(z){return p.Promises.exists(z)}fsRealpath(z){return(0,E.$_q)(z)}};let D=null;m.remote.authority&&i.transformURIs&&(D=(0,h.$Hs)(m.remote.authority));const C=new I.$soc(S.protocol,m,y,D);t=O=>C.terminate(O)}u().catch(g=>console.log(g))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/workbench/api/node/extensionHostProcess.js.map
