/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Se=function(he){for(var e=[],C=0,O=he.length;C<O;C++)e[C]=ke[he[C]];return e};define(ke[69],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=O,e.$6h=R,e.$7h=F;function C(M){return(p,m,D)=>{let N=null,S=null;if(typeof D.value=="function"?(N="value",S=D.value):typeof D.get=="function"&&(N="get",S=D.get),!S)throw new Error("not supported");D[N]=M(S,m)}}function O(M,p,m){let D=null,N=null;if(typeof m.value=="function"?(D="value",N=m.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(D="get",N=m.get),!N)throw new Error("not supported");const S=`$memoize$${p}`;m[D]=function(...d){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,d)}),this[S]}}function R(M,p,m){return C((D,N)=>{const S=`$debounce$${N}`,d=`$debounce$result$${N}`;return function(...v){this[d]||(this[d]=m?m():void 0),clearTimeout(this[S]),p&&(this[d]=p(this[d],...v),v=[this[d]]),this[S]=setTimeout(()=>{D.apply(this,v),this[d]=m?m():void 0},M)}})}function F(M,p,m){return C((D,N)=>{const S=`$throttle$timer$${N}`,d=`$throttle$result$${N}`,v=`$throttle$lastRun$${N}`,f=`$throttle$pending$${N}`;return function(...s){if(this[d]||(this[d]=m?m():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[d]=p(this[d],...s)),this[f])return;const r=this[v]+M;r<=Date.now()?(this[v]=Date.now(),D.apply(this,[this[d]]),this[d]=m?m():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),D.apply(this,[this[d]]),this[d]=m?m():void 0},r-Date.now()))}})}}),define(ke[125],Se([1,0,18]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=R,e.$8c=F,e.$9c=M,e.$0c=p,e.$$c=m,e.$_c=D;const O=(v,f)=>v===f;e.$6c=O;function R(v=e.$6c){return(f,s)=>C.$ub(f,s,v)}function F(){return(v,f)=>JSON.stringify(v)===JSON.stringify(f)}function M(){return(v,f)=>v.equals(f)}function p(v,f,s){return!v||!f?v===f:s(v,f)}function m(v,f){if(v===f)return!0;if(Array.isArray(v)&&Array.isArray(f)){if(v.length!==f.length)return!1;for(let s=0;s<v.length;s++)if(!m(v[s],f[s]))return!1;return!0}if(v&&typeof v=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(v)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const s=v,r=f,o=Object.keys(s),n=Object.keys(r),t=new Set(n);if(o.length!==n.length)return!1;for(const c of o)if(!t.has(c)||!m(s[c],r[c]))return!1;return!0}return!1}function D(v){return JSON.stringify(d(v))}let N=0;const S=new WeakMap;function d(v){if(Array.isArray(v))return v.map(d);if(v&&typeof v=="object")if(Object.getPrototypeOf(v)===Object.prototype){const f=v,s=Object.create(null);for(const r of Object.keys(f).sort())s[r]=d(f[r]);return s}else{let f=S.get(v);return f===void 0&&(f=N++,S.set(v,f)),f+"----2b76a038c20c4bcc"}return v}}),define(ke[91],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XO=e.$WO=void 0;class C{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$WO=C,e.$XO=new C("id#")}),define(ke[126],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Ln=M,e.$Mn=S,e.$Nn=d,e.$On=v,e.$Pn=f,e.$Qn=s,e.$Rn=r,e.$Sn=o,e.$Tn=n,e.$Un=t,e.$Vn=c,e.$Wn=u;var C;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var F;(function(i){i.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function M(i,w=!1){let a=0;const l=i.length;let g="",$=0,b=16,y=0;function h(q){let A=0,U=0;for(;A<q;){const K=i.charCodeAt(a);if(K>=48&&K<=57)U=U*16+K-48;else if(K>=65&&K<=70)U=U*16+K-65+10;else if(K>=97&&K<=102)U=U*16+K-97+10;else break;a++,A++}return A<q&&(U=-1),U}function E(q){a=q,g="",$=0,b=16,y=0}function k(){const q=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&D(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&D(i.charCodeAt(a)))for(a++;a<i.length&&D(i.charCodeAt(a));)a++;else return y=3,i.substring(q,a);let A=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&D(i.charCodeAt(a))){for(a++;a<i.length&&D(i.charCodeAt(a));)a++;A=a}else y=3;return i.substring(q,A)}function I(){let q="",A=a;for(;;){if(a>=l){q+=i.substring(A,a),y=2;break}const U=i.charCodeAt(a);if(U===34){q+=i.substring(A,a),a++;break}if(U===92){if(q+=i.substring(A,a),a++,a>=l){y=2;break}switch(i.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=h(4);ie>=0?q+=String.fromCharCode(ie):y=4;break}default:y=5}A=a;continue}if(U>=0&&U<=31)if(m(U)){q+=i.substring(A,a),y=2;break}else y=6;a++}return q}function P(){if(g="",y=0,$=a,a>=l)return $=l,b=17;let q=i.charCodeAt(a);if(p(q)){do a++,g+=String.fromCharCode(q),q=i.charCodeAt(a);while(p(q));return b=15}if(m(q))return a++,g+=String.fromCharCode(q),q===13&&i.charCodeAt(a)===10&&(a++,g+=`
`),b=14;switch(q){case 123:return a++,b=1;case 125:return a++,b=2;case 91:return a++,b=3;case 93:return a++,b=4;case 58:return a++,b=6;case 44:return a++,b=5;case 34:return a++,g=I(),b=10;case 47:{const A=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<l&&!m(i.charCodeAt(a));)a++;return g=i.substring(A,a),b=12}if(i.charCodeAt(a+1)===42){a+=2;const U=l-1;let K=!1;for(;a<U;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,y=1),g=i.substring(A,a),b=13}return g+=String.fromCharCode(q),a++,b=16}case 45:if(g+=String.fromCharCode(q),a++,a===l||!D(i.charCodeAt(a)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=k(),b=11;default:for(;a<l&&V(q);)a++,q=i.charCodeAt(a);if($!==a){switch(g=i.substring($,a),g){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return g+=String.fromCharCode(q),a++,b=16}}function V(q){if(p(q)||m(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:E,getPosition:()=>a,scan:w?W:P,getToken:()=>b,getTokenValue:()=>g,getTokenOffset:()=>$,getTokenLength:()=>a-$,getTokenError:()=>y}}function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function m(i){return i===10||i===13||i===8232||i===8233}function D(i){return i>=48&&i<=57}var N;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(N||(N={}));function S(i,w){const a=[],l=new Object;let g;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function y(h,E,k,I){$.value=h,$.offset=E,$.length=k,$.type=I,$.colonOffset=void 0,g=$}try{t(i,{onObjectBegin:(h,E)=>{if(w<=h)throw l;g=void 0,b=w>h,a.push("")},onObjectProperty:(h,E,k)=>{if(w<E||(y(h,E,k,"property"),a[a.length-1]=h,w<=E+k))throw l},onObjectEnd:(h,E)=>{if(w<=h)throw l;g=void 0,a.pop()},onArrayBegin:(h,E)=>{if(w<=h)throw l;g=void 0,a.push(0)},onArrayEnd:(h,E)=>{if(w<=h)throw l;g=void 0,a.pop()},onLiteralValue:(h,E,k)=>{if(w<E||(y(h,E,k,u(h)),w<=E+k))throw l},onSeparator:(h,E,k)=>{if(w<=E)throw l;if(h===":"&&g&&g.type==="property")g.colonOffset=E,b=!1,g=void 0;else if(h===","){const I=a[a.length-1];typeof I=="number"?a[a.length-1]=I+1:(b=!0,a[a.length-1]=""),g=void 0}}})}catch(h){if(h!==l)throw h}return{path:a,previousNode:g,isAtPropertyKey:b,matches:h=>{let E=0;for(let k=0;E<h.length&&k<a.length;k++)if(h[E]===a[k]||h[E]==="*")E++;else if(h[E]!=="**")return!1;return E===h.length}}}function d(i,w=[],a=F.DEFAULT){let l=null,g=[];const $=[];function b(h){Array.isArray(g)?g.push(h):l!==null&&(g[l]=h)}return t(i,{onObjectBegin:()=>{const h={};b(h),$.push(g),g=h,l=null},onObjectProperty:h=>{l=h},onObjectEnd:()=>{g=$.pop()},onArrayBegin:()=>{const h=[];b(h),$.push(g),g=h,l=null},onArrayEnd:()=>{g=$.pop()},onLiteralValue:b,onError:(h,E,k)=>{w.push({error:h,offset:E,length:k})}},a),g[0]}function v(i,w=[],a=F.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(h){l.type==="property"&&(l.length=h-l.offset,l=l.parent)}function $(h){return l.children.push(h),h}t(i,{onObjectBegin:h=>{l=$({type:"object",offset:h,length:-1,parent:l,children:[]})},onObjectProperty:(h,E,k)=>{l=$({type:"property",offset:E,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:h,offset:E,length:k,parent:l})},onObjectEnd:(h,E)=>{l.length=h+E-l.offset,l=l.parent,g(h+E)},onArrayBegin:(h,E)=>{l=$({type:"array",offset:h,length:-1,parent:l,children:[]})},onArrayEnd:(h,E)=>{l.length=h+E-l.offset,l=l.parent,g(h+E)},onLiteralValue:(h,E,k)=>{$({type:u(h),offset:E,length:k,parent:l,value:h}),g(E+k)},onSeparator:(h,E,k)=>{l.type==="property"&&(h===":"?l.colonOffset=E:h===","&&g(E))},onError:(h,E,k)=>{w.push({error:h,offset:E,length:k})}},a);const y=l.children[0];return y&&delete y.parent,y}function f(i,w){if(!i)return;let a=i;for(const l of w)if(typeof l=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let g=!1;for(const $ of a.children)if(Array.isArray($.children)&&$.children[0].value===l){a=$.children[1],g=!0;break}if(!g)return}else{const g=l;if(a.type!=="array"||g<0||!Array.isArray(a.children)||g>=a.children.length)return;a=a.children[g]}return a}function s(i){if(!i.parent||!i.parent.children)return[];const w=s(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;w.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&w.push(a)}return w}function r(i){switch(i.type){case"array":return i.children.map(r);case"object":{const w=Object.create(null);for(const a of i.children){const l=a.children[1];l&&(w[a.children[0].value]=r(l))}return w}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function o(i,w,a=!1){return w>=i.offset&&w<i.offset+i.length||a&&w===i.offset+i.length}function n(i,w,a=!1){if(o(i,w,a)){const l=i.children;if(Array.isArray(l))for(let g=0;g<l.length&&l[g].offset<=w;g++){const $=n(l[g],w,a);if($)return $}return i}}function t(i,w,a=F.DEFAULT){const l=M(i,!1);function g(Ce){return Ce?()=>Ce(l.getTokenOffset(),l.getTokenLength()):()=>!0}function $(Ce){return Ce?re=>Ce(re,l.getTokenOffset(),l.getTokenLength()):()=>!0}const b=g(w.onObjectBegin),y=$(w.onObjectProperty),h=g(w.onObjectEnd),E=g(w.onArrayBegin),k=g(w.onArrayEnd),I=$(w.onLiteralValue),P=$(w.onSeparator),V=g(w.onComment),W=$(w.onError),q=a&&a.disallowComments,A=a&&a.allowTrailingComma;function U(){for(;;){const Ce=l.scan();switch(l.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Ce){case 12:case 13:q?K(10):V();break;case 16:K(1);break;case 15:case 14:break;default:return Ce}}}function K(Ce,re=[],Ne=[]){if(W(Ce),re.length+Ne.length>0){let Te=l.getToken();for(;Te!==17;){if(re.indexOf(Te)!==-1){U();break}else if(Ne.indexOf(Te)!==-1)break;Te=U()}}}function ie(Ce){const re=l.getTokenValue();return Ce?I(re):y(re),U(),!0}function ce(){switch(l.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(l.getTokenValue()),typeof Ce!="number"&&(K(2),Ce=0)}catch{K(2)}I(Ce);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return U(),!0}function ve(){return l.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),l.getToken()===6?(P(":"),U(),ue()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ee(){b(),U();let Ce=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(Ce||K(4,[],[]),P(","),U(),l.getToken()===2&&A)break}else Ce&&K(6,[],[]);ve()||K(4,[],[2,5]),Ce=!0}return h(),l.getToken()!==2?K(7,[2],[]):U(),!0}function ge(){E(),U();let Ce=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(Ce||K(4,[],[]),P(","),U(),l.getToken()===4&&A)break}else Ce&&K(6,[],[]);ue()||K(4,[],[4,5]),Ce=!0}return k(),l.getToken()!==4?K(8,[4],[]):U(),!0}function ue(){switch(l.getToken()){case 3:return ge();case 1:return Ee();case 10:return ie(!0);default:return ce()}}return U(),l.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):ue()?(l.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(i,w){const a=M(i),l=[];let g,$=0,b;do switch(b=a.getPosition(),g=a.scan(),g){case 12:case 13:case 17:$!==b&&l.push(i.substring($,b)),w!==void 0&&l.push(a.getTokenValue().replace(/[^\r\n]/g,w)),$=a.getPosition();break}while(g!==17);return l.join("")}function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(he,e){typeof define=="function"&&define.amd?define(ke[127],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ye,$e){for(var fe=0;fe<$e.length;fe++){var Q=$e[fe];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(ye,Q.key,Q)}}function C(ye,$e,fe){return $e&&e(ye.prototype,$e),fe&&e(ye,fe),Object.defineProperty(ye,"prototype",{writable:!1}),ye}function O(ye,$e){if(ye){if(typeof ye=="string")return R(ye,$e);var fe=Object.prototype.toString.call(ye).slice(8,-1);if(fe==="Object"&&ye.constructor&&(fe=ye.constructor.name),fe==="Map"||fe==="Set")return Array.from(ye);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return R(ye,$e)}}function R(ye,$e){($e==null||$e>ye.length)&&($e=ye.length);for(var fe=0,Q=new Array($e);fe<$e;fe++)Q[fe]=ye[fe];return Q}function F(ye,$e){var fe=typeof Symbol<"u"&&ye[Symbol.iterator]||ye["@@iterator"];if(fe)return(fe=fe.call(ye)).next.bind(fe);if(Array.isArray(ye)||(fe=O(ye))||$e&&ye&&typeof ye.length=="number"){fe&&(ye=fe);var Q=0;return function(){return Q>=ye.length?{done:!0}:{done:!1,value:ye[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=M();function p(ye){he.defaults=ye}var m=/[&<>"']/,D=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function($e){return d[$e]};function f(ye,$e){if($e){if(m.test(ye))return ye.replace(D,v)}else if(N.test(ye))return ye.replace(S,v);return ye}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(ye){return ye.replace(s,function($e,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(ye,$e){ye=typeof ye=="string"?ye:ye.source,$e=$e||"";var fe={replace:function(x,le){return le=le.source||le,le=le.replace(o,"$1"),ye=ye.replace(x,le),fe},getRegex:function(){return new RegExp(ye,$e)}};return fe}var t=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ye,$e,fe){if(ye){var Q;try{Q=decodeURIComponent(r(fe)).replace(t,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}$e&&!c.test(fe)&&(fe=g($e,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},w=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(ye,$e){i[" "+ye]||(w.test(ye)?i[" "+ye]=ye+"/":i[" "+ye]=h(ye,"/",!0)),ye=i[" "+ye];var fe=ye.indexOf(":")===-1;return $e.substring(0,2)==="//"?fe?$e:ye.replace(a,"$1")+$e:$e.charAt(0)==="/"?fe?$e:ye.replace(l,"$1")+$e:ye+$e}var $={exec:function(){}};function b(ye){for(var $e=1,fe,Q;$e<arguments.length;$e++){fe=arguments[$e];for(Q in fe)Object.prototype.hasOwnProperty.call(fe,Q)&&(ye[Q]=fe[Q])}return ye}function y(ye,$e){var fe=ye.replace(/\|/g,function(le,ae,Fe){for(var de=!1,Pe=ae;--Pe>=0&&Fe[Pe]==="\\";)de=!de;return de?"|":" |"}),Q=fe.split(/ \|/),x=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>$e)Q.splice($e);else for(;Q.length<$e;)Q.push("");for(;x<Q.length;x++)Q[x]=Q[x].trim().replace(/\\\|/g,"|");return Q}function h(ye,$e,fe){var Q=ye.length;if(Q===0)return"";for(var x=0;x<Q;){var le=ye.charAt(Q-x-1);if(le===$e&&!fe)x++;else if(le!==$e&&fe)x++;else break}return ye.slice(0,Q-x)}function E(ye,$e){if(ye.indexOf($e[1])===-1)return-1;for(var fe=ye.length,Q=0,x=0;x<fe;x++)if(ye[x]==="\\")x++;else if(ye[x]===$e[0])Q++;else if(ye[x]===$e[1]&&(Q--,Q<0))return x;return-1}function k(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(ye,$e){if($e<1)return"";for(var fe="";$e>1;)$e&1&&(fe+=ye),$e>>=1,ye+=ye;return fe+ye}function P(ye,$e,fe,Q){var x=$e.href,le=$e.title?f($e.title):null,ae=ye[1].replace(/\\([\[\]])/g,"$1");if(ye[0].charAt(0)!=="!"){Q.state.inLink=!0;var Fe={type:"link",raw:fe,href:x,title:le,text:ae,tokens:Q.inlineTokens(ae)};return Q.state.inLink=!1,Fe}return{type:"image",raw:fe,href:x,title:le,text:f(ae)}}function V(ye,$e){var fe=ye.match(/^(\s+)(?:```)/);if(fe===null)return $e;var Q=fe[1];return $e.split(`
`).map(function(x){var le=x.match(/^\s+/);if(le===null)return x;var ae=le[0];return ae.length>=Q.length?x.slice(Q.length):x}).join(`
`)}var W=function(){function ye(fe){this.options=fe||he.defaults}var $e=ye.prototype;return $e.space=function(Q){var x=this.rules.block.newline.exec(Q);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},$e.code=function(Q){var x=this.rules.block.code.exec(Q);if(x){var le=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?le:h(le,`
`)}}},$e.fences=function(Q){var x=this.rules.block.fences.exec(Q);if(x){var le=x[0],ae=V(le,x[3]||"");return{type:"code",raw:le,lang:x[2]?x[2].trim():x[2],text:ae}}},$e.heading=function(Q){var x=this.rules.block.heading.exec(Q);if(x){var le=x[2].trim();if(/#$/.test(le)){var ae=h(le,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(le=ae.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:le,tokens:this.lexer.inline(le)}}},$e.hr=function(Q){var x=this.rules.block.hr.exec(Q);if(x)return{type:"hr",raw:x[0]}},$e.blockquote=function(Q){var x=this.rules.block.blockquote.exec(Q);if(x){var le=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},$e.list=function(Q){var x=this.rules.block.list.exec(Q);if(x){var le,ae,Fe,de,Pe,Ae,je,j,z,G,H,te,ne=x[1].trim(),Oe=ne.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+ne.slice(0,-1):"",loose:!1,items:[]};ne=Oe?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=Oe?ne:"[*+-]");for(var He=new RegExp("^( {0,3}"+ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(te=!1,!(!(x=He.exec(Q))||this.rules.block.hr.test(Q)));){if(le=x[0],Q=Q.substring(le.length),j=x[2].split(`
`,1)[0],z=Q.split(`
`,1)[0],this.options.pedantic?(de=2,H=j.trimLeft()):(de=x[2].search(/[^ ]/),de=de>4?1:de,H=j.slice(de),de+=x[1].length),Ae=!1,!j&&/^ *$/.test(z)&&(le+=z+`
`,Q=Q.substring(z.length+1),te=!0),!te)for(var _e=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");Q&&(G=Q.split(`
`,1)[0],j=G,this.options.pedantic&&(j=j.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(j)||tt.test(j)||_e.test(j)||xe.test(Q)));){if(j.search(/[^ ]/)>=de||!j.trim())H+=`
`+j.slice(de);else if(!Ae)H+=`
`+j;else break;!Ae&&!j.trim()&&(Ae=!0),le+=G+`
`,Q=Q.substring(G.length+1)}Be.loose||(je?Be.loose=!0:/\n *\n *$/.test(le)&&(je=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(H),ae&&(Fe=ae[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:le,task:!!ae,checked:Fe,loose:!1,text:H}),Be.raw+=le}Be.items[Be.items.length-1].raw=le.trimRight(),Be.items[Be.items.length-1].text=H.trimRight(),Be.raw=Be.raw.trimRight();var it=Be.items.length;for(Pe=0;Pe<it;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var at=Be.items[Pe].tokens.filter(function(Ue){return Ue.type==="space"}),mt=at.every(function(Ue){for(var rt=Ue.raw.split(""),Y=0,Z=F(rt),me;!(me=Z()).done;){var Ge=me.value;if(Ge===`
`&&(Y+=1),Y>1)return!0}return!1});!Be.loose&&at.length&&mt&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},$e.html=function(Q){var x=this.rules.block.html.exec(Q);if(x){var le={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(x[0]):f(x[0]);le.type="paragraph",le.text=ae,le.tokens=this.lexer.inline(ae)}return le}},$e.def=function(Q){var x=this.rules.block.def.exec(Q);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var le=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:x[0],href:x[2],title:x[3]}}},$e.table=function(Q){var x=this.rules.block.table.exec(Q);if(x){var le={type:"table",header:y(x[1]).map(function(je){return{text:je}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=x[0];var ae=le.align.length,Fe,de,Pe,Ae;for(Fe=0;Fe<ae;Fe++)/^ *-+: *$/.test(le.align[Fe])?le.align[Fe]="right":/^ *:-+: *$/.test(le.align[Fe])?le.align[Fe]="center":/^ *:-+ *$/.test(le.align[Fe])?le.align[Fe]="left":le.align[Fe]=null;for(ae=le.rows.length,Fe=0;Fe<ae;Fe++)le.rows[Fe]=y(le.rows[Fe],le.header.length).map(function(je){return{text:je}});for(ae=le.header.length,de=0;de<ae;de++)le.header[de].tokens=this.lexer.inline(le.header[de].text);for(ae=le.rows.length,de=0;de<ae;de++)for(Ae=le.rows[de],Pe=0;Pe<Ae.length;Pe++)Ae[Pe].tokens=this.lexer.inline(Ae[Pe].text);return le}}},$e.lheading=function(Q){var x=this.rules.block.lheading.exec(Q);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},$e.paragraph=function(Q){var x=this.rules.block.paragraph.exec(Q);if(x){var le=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:le,tokens:this.lexer.inline(le)}}},$e.text=function(Q){var x=this.rules.block.text.exec(Q);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},$e.escape=function(Q){var x=this.rules.inline.escape.exec(Q);if(x)return{type:"escape",raw:x[0],text:f(x[1])}},$e.tag=function(Q){var x=this.rules.inline.tag.exec(Q);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):f(x[0]):x[0]}},$e.link=function(Q){var x=this.rules.inline.link.exec(Q);if(x){var le=x[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ae=h(le.slice(0,-1),"\\");if((le.length-ae.length)%2===0)return}else{var Fe=E(x[2],"()");if(Fe>-1){var de=x[0].indexOf("!")===0?5:4,Pe=de+x[1].length+Fe;x[2]=x[2].substring(0,Fe),x[0]=x[0].substring(0,Pe).trim(),x[3]=""}}var Ae=x[2],je="";if(this.options.pedantic){var j=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);j&&(Ae=j[1],je=j[3])}else je=x[3]?x[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(le)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),P(x,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},$e.reflink=function(Q,x){var le;if((le=this.rules.inline.reflink.exec(Q))||(le=this.rules.inline.nolink.exec(Q))){var ae=(le[2]||le[1]).replace(/\s+/g," ");if(ae=x[ae.toLowerCase()],!ae||!ae.href){var Fe=le[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return P(le,ae,le[0],this.lexer)}},$e.emStrong=function(Q,x,le){le===void 0&&(le="");var ae=this.rules.inline.emStrong.lDelim.exec(Q);if(ae&&!(ae[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=ae[1]||ae[2]||"";if(!Fe||Fe&&(le===""||this.rules.inline.punctuation.exec(le))){var de=ae[0].length-1,Pe,Ae,je=de,j=0,z=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,x=x.slice(-1*Q.length+de);(ae=z.exec(x))!=null;)if(Pe=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!Pe){if(Ae=Pe.length,ae[3]||ae[4]){je+=Ae;continue}else if((ae[5]||ae[6])&&de%3&&!((de+Ae)%3)){j+=Ae;continue}if(je-=Ae,!(je>0)){if(Ae=Math.min(Ae,Ae+je+j),Math.min(de,Ae)%2){var G=Q.slice(1,de+ae.index+Ae);return{type:"em",raw:Q.slice(0,de+ae.index+Ae+1),text:G,tokens:this.lexer.inlineTokens(G)}}var H=Q.slice(2,de+ae.index+Ae-1);return{type:"strong",raw:Q.slice(0,de+ae.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},$e.codespan=function(Q){var x=this.rules.inline.code.exec(Q);if(x){var le=x[2].replace(/\n/g," "),ae=/[^ ]/.test(le),Fe=/^ /.test(le)&&/ $/.test(le);return ae&&Fe&&(le=le.substring(1,le.length-1)),le=f(le,!0),{type:"codespan",raw:x[0],text:le}}},$e.br=function(Q){var x=this.rules.inline.br.exec(Q);if(x)return{type:"br",raw:x[0]}},$e.del=function(Q){var x=this.rules.inline.del.exec(Q);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},$e.autolink=function(Q,x){var le=this.rules.inline.autolink.exec(Q);if(le){var ae,Fe;return le[2]==="@"?(ae=f(this.options.mangle?x(le[1]):le[1]),Fe="mailto:"+ae):(ae=f(le[1]),Fe=ae),{type:"link",raw:le[0],text:ae,href:Fe,tokens:[{type:"text",raw:ae,text:ae}]}}},$e.url=function(Q,x){var le;if(le=this.rules.inline.url.exec(Q)){var ae,Fe;if(le[2]==="@")ae=f(this.options.mangle?x(le[0]):le[0]),Fe="mailto:"+ae;else{var de;do de=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(de!==le[0]);ae=f(le[0]),le[1]==="www."?Fe="http://"+ae:Fe=ae}return{type:"link",raw:le[0],text:ae,href:Fe,tokens:[{type:"text",raw:ae,text:ae}]}}},$e.inlineText=function(Q,x){var le=this.rules.inline.text.exec(Q);if(le){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]):le[0]:ae=f(this.options.smartypants?x(le[0]):le[0]),{type:"text",raw:le[0],text:ae}}},ye}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=b({},q),q.gfm=b({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=b({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=n(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=n(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=n(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=n(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=n(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=n(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=n(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=n(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=n(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=n(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=b({},A),A.pedantic=b({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=b({},A.normal,{escape:n(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=n(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=b({},A.gfm,{br:n(A.br).replace("{2,}","*").getRegex(),text:n(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ye){var $e="",fe,Q,x=ye.length;for(fe=0;fe<x;fe++)Q=ye.charCodeAt(fe),Math.random()>.5&&(Q="x"+Q.toString(16)),$e+="&#"+Q+";";return $e}var ie=function(){function ye(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||he.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:A.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=A.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=A.breaks:Q.inline=A.gfm),this.tokenizer.rules=Q}ye.lex=function(Q,x){var le=new ye(x);return le.lex(Q)},ye.lexInline=function(Q,x){var le=new ye(x);return le.inlineTokens(Q)};var $e=ye.prototype;return $e.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},$e.blockTokens=function(Q,x){var le=this;x===void 0&&(x=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(je,j,z){return j+"    ".repeat(z.length)});for(var ae,Fe,de,Pe;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(ae=je.call({lexer:le},Q,x))?(Q=Q.substring(ae.raw.length),x.push(ae),!0):!1}))){if(ae=this.tokenizer.space(Q)){Q=Q.substring(ae.raw.length),ae.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(ae);continue}if(ae=this.tokenizer.code(Q)){Q=Q.substring(ae.raw.length),Fe=x[x.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ae.raw,Fe.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):x.push(ae);continue}if(ae=this.tokenizer.fences(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.heading(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.hr(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.blockquote(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.list(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.html(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.def(Q)){Q=Q.substring(ae.raw.length),Fe=x[x.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ae.raw,Fe.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.lheading(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(de=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,j=Q.slice(1),z=void 0;le.options.extensions.startBlock.forEach(function(G){z=G.call({lexer:this},j),typeof z=="number"&&z>=0&&(je=Math.min(je,z))}),je<1/0&&je>=0&&(de=Q.substring(0,je+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(de))){Fe=x[x.length-1],Pe&&Fe.type==="paragraph"?(Fe.raw+=`
`+ae.raw,Fe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):x.push(ae),Pe=de.length!==Q.length,Q=Q.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(Q)){Q=Q.substring(ae.raw.length),Fe=x[x.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+ae.raw,Fe.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):x.push(ae);continue}if(Q){var Ae="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,x},$e.inline=function(Q,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:Q,tokens:x}),x},$e.inlineTokens=function(Q,x){var le=this;x===void 0&&(x=[]);var ae,Fe,de,Pe=Q,Ae,je,j;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)z.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ae.index)+"["+I("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"["+I("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(je||(j=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(ae=H.call({lexer:le},Q,x))?(Q=Q.substring(ae.raw.length),x.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.tag(Q)){Q=Q.substring(ae.raw.length),Fe=x[x.length-1],Fe&&ae.type==="text"&&Fe.type==="text"?(Fe.raw+=ae.raw,Fe.text+=ae.text):x.push(ae);continue}if(ae=this.tokenizer.link(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ae.raw.length),Fe=x[x.length-1],Fe&&ae.type==="text"&&Fe.type==="text"?(Fe.raw+=ae.raw,Fe.text+=ae.text):x.push(ae);continue}if(ae=this.tokenizer.emStrong(Q,Pe,j)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.codespan(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.br(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.del(Q)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(ae=this.tokenizer.autolink(Q,K)){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(Q,K))){Q=Q.substring(ae.raw.length),x.push(ae);continue}if(de=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,te=Q.slice(1),ne=void 0;le.options.extensions.startInline.forEach(function(Oe){ne=Oe.call({lexer:this},te),typeof ne=="number"&&ne>=0&&(H=Math.min(H,ne))}),H<1/0&&H>=0&&(de=Q.substring(0,H+1))}(),ae=this.tokenizer.inlineText(de,U)){Q=Q.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(j=ae.raw.slice(-1)),je=!0,Fe=x[x.length-1],Fe&&Fe.type==="text"?(Fe.raw+=ae.raw,Fe.text+=ae.text):x.push(ae);continue}if(Q){var G="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return x},C(ye,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),ye}(),ce=function(){function ye(fe){this.options=fe||he.defaults}var $e=ye.prototype;return $e.code=function(Q,x,le){var ae=(x||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(Q,ae);Fe!=null&&Fe!==Q&&(le=!0,Q=Fe)}return Q=Q.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+f(ae,!0)+'">'+(le?Q:f(Q,!0))+`</code></pre>
`:"<pre><code>"+(le?Q:f(Q,!0))+`</code></pre>
`},$e.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},$e.html=function(Q){return Q},$e.heading=function(Q,x,le,ae){if(this.options.headerIds){var Fe=this.options.headerPrefix+ae.slug(le);return"<h"+x+' id="'+Fe+'">'+Q+"</h"+x+`>
`}return"<h"+x+">"+Q+"</h"+x+`>
`},$e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},$e.list=function(Q,x,le){var ae=x?"ol":"ul",Fe=x&&le!==1?' start="'+le+'"':"";return"<"+ae+Fe+`>
`+Q+"</"+ae+`>
`},$e.listitem=function(Q){return"<li>"+Q+`</li>
`},$e.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},$e.paragraph=function(Q){return"<p>"+Q+`</p>
`},$e.table=function(Q,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+x+`</table>
`},$e.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},$e.tablecell=function(Q,x){var le=x.header?"th":"td",ae=x.align?"<"+le+' align="'+x.align+'">':"<"+le+">";return ae+Q+("</"+le+`>
`)},$e.strong=function(Q){return"<strong>"+Q+"</strong>"},$e.em=function(Q){return"<em>"+Q+"</em>"},$e.codespan=function(Q){return"<code>"+Q+"</code>"},$e.br=function(){return this.options.xhtml?"<br/>":"<br>"},$e.del=function(Q){return"<del>"+Q+"</del>"},$e.link=function(Q,x,le){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var ae='<a href="'+f(Q)+'"';return x&&(ae+=' title="'+x+'"'),ae+=">"+le+"</a>",ae},$e.image=function(Q,x,le){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var ae='<img src="'+Q+'" alt="'+le+'"';return x&&(ae+=' title="'+x+'"'),ae+=this.options.xhtml?"/>":">",ae},$e.text=function(Q){return Q},ye}(),ve=function(){function ye(){}var $e=ye.prototype;return $e.strong=function(Q){return Q},$e.em=function(Q){return Q},$e.codespan=function(Q){return Q},$e.del=function(Q){return Q},$e.html=function(Q){return Q},$e.text=function(Q){return Q},$e.link=function(Q,x,le){return""+le},$e.image=function(Q,x,le){return""+le},$e.br=function(){return""},ye}(),Ee=function(){function ye(){this.seen={}}var $e=ye.prototype;return $e.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},$e.getNextSafeSlug=function(Q,x){var le=Q,ae=0;if(this.seen.hasOwnProperty(le)){ae=this.seen[Q];do ae++,le=Q+"-"+ae;while(this.seen.hasOwnProperty(le))}return x||(this.seen[Q]=ae,this.seen[le]=0),le},$e.slug=function(Q,x){x===void 0&&(x={});var le=this.serialize(Q);return this.getNextSafeSlug(le,x.dryrun)},ye}(),ge=function(){function ye(fe){this.options=fe||he.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ve,this.slugger=new Ee}ye.parse=function(Q,x){var le=new ye(x);return le.parse(Q)},ye.parseInline=function(Q,x){var le=new ye(x);return le.parseInline(Q)};var $e=ye.prototype;return $e.parse=function(Q,x){x===void 0&&(x=!0);var le="",ae,Fe,de,Pe,Ae,je,j,z,G,H,te,ne,Oe,Be,He,_e,xe,et,tt,it=Q.length;for(ae=0;ae<it;ae++){if(H=Q[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){le+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(H.tokens),H.depth,r(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(z="",j="",Pe=H.header.length,Fe=0;Fe<Pe;Fe++)j+=this.renderer.tablecell(this.parseInline(H.header[Fe].tokens),{header:!0,align:H.align[Fe]});for(z+=this.renderer.tablerow(j),G="",Pe=H.rows.length,Fe=0;Fe<Pe;Fe++){for(je=H.rows[Fe],j="",Ae=je.length,de=0;de<Ae;de++)j+=this.renderer.tablecell(this.parseInline(je[de].tokens),{header:!1,align:H.align[de]});G+=this.renderer.tablerow(j)}le+=this.renderer.table(z,G);continue}case"blockquote":{G=this.parse(H.tokens),le+=this.renderer.blockquote(G);continue}case"list":{for(te=H.ordered,ne=H.start,Oe=H.loose,Pe=H.items.length,G="",Fe=0;Fe<Pe;Fe++)He=H.items[Fe],_e=He.checked,xe=He.task,Be="",He.task&&(et=this.renderer.checkbox(_e),Oe?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=et+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=et+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(He.tokens,Oe),G+=this.renderer.listitem(Be,xe,_e);le+=this.renderer.list(G,te,ne);continue}case"html":{le+=this.renderer.html(H.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(G=H.tokens?this.parseInline(H.tokens):H.text;ae+1<it&&Q[ae+1].type==="text";)H=Q[++ae],G+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);le+=x?this.renderer.paragraph(G):G;continue}default:{var at='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return le},$e.parseInline=function(Q,x){x=x||this.renderer;var le="",ae,Fe,de,Pe=Q.length;for(ae=0;ae<Pe;ae++){if(Fe=Q[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(de=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){le+=de||"";continue}switch(Fe.type){case"escape":{le+=x.text(Fe.text);break}case"html":{le+=x.html(Fe.text);break}case"link":{le+=x.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,x));break}case"image":{le+=x.image(Fe.href,Fe.title,Fe.text);break}case"strong":{le+=x.strong(this.parseInline(Fe.tokens,x));break}case"em":{le+=x.em(this.parseInline(Fe.tokens,x));break}case"codespan":{le+=x.codespan(Fe.text);break}case"br":{le+=x.br();break}case"del":{le+=x.del(this.parseInline(Fe.tokens,x));break}case"text":{le+=x.text(Fe.text);break}default:{var Ae='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return le},ye}();function ue(ye,$e,fe){if(typeof ye>"u"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof $e=="function"&&(fe=$e,$e=null),$e=b({},ue.defaults,$e||{}),k($e),fe){var Q=$e.highlight,x;try{x=ie.lex(ye,$e)}catch(Pe){return fe(Pe)}var le=function(Ae){var je;if(!Ae)try{$e.walkTokens&&ue.walkTokens(x,$e.walkTokens),je=ge.parse(x,$e)}catch(j){Ae=j}return $e.highlight=Q,Ae?fe(Ae):fe(null,je)};if(!Q||Q.length<3||(delete $e.highlight,!x.length))return le();var ae=0;ue.walkTokens(x,function(Pe){Pe.type==="code"&&(ae++,setTimeout(function(){Q(Pe.text,Pe.lang,function(Ae,je){if(Ae)return le(Ae);je!=null&&je!==Pe.text&&(Pe.text=je,Pe.escaped=!0),ae--,ae===0&&le()})},0))}),ae===0&&le();return}function Fe(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+f(Pe.message+"",!0)+"</pre>";throw Pe}try{var de=ie.lex(ye,$e);if($e.walkTokens){if($e.async)return Promise.all(ue.walkTokens(de,$e.walkTokens)).then(function(){return ge.parse(de,$e)}).catch(Fe);ue.walkTokens(de,$e.walkTokens)}return ge.parse(de,$e)}catch(Pe){Fe(Pe)}}ue.options=ue.setOptions=function(ye){return b(ue.defaults,ye),p(ue.defaults),ue},ue.getDefaults=M,ue.defaults=he.defaults,ue.use=function(){for(var ye=arguments.length,$e=new Array(ye),fe=0;fe<ye;fe++)$e[fe]=arguments[fe];var Q=b.apply(void 0,[{}].concat($e)),x=ue.defaults.extensions||{renderers:{},childTokens:{}},le;$e.forEach(function(ae){if(ae.extensions&&(le=!0,ae.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Pe=x.renderers?x.renderers[de.name]:null;Pe?x.renderers[de.name]=function(){for(var Ae=arguments.length,je=new Array(Ae),j=0;j<Ae;j++)je[j]=arguments[j];var z=de.renderer.apply(this,je);return z===!1&&(z=Pe.apply(this,je)),z}:x.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[de.level]?x[de.level].unshift(de.tokenizer):x[de.level]=[de.tokenizer],de.start&&(de.level==="block"?x.startBlock?x.startBlock.push(de.start):x.startBlock=[de.start]:de.level==="inline"&&(x.startInline?x.startInline.push(de.start):x.startInline=[de.start]))}de.childTokens&&(x.childTokens[de.name]=de.childTokens)})),ae.renderer&&function(){var de=ue.defaults.renderer||new ce,Pe=function(j){var z=de[j];de[j]=function(){for(var G=arguments.length,H=new Array(G),te=0;te<G;te++)H[te]=arguments[te];var ne=ae.renderer[j].apply(de,H);return ne===!1&&(ne=z.apply(de,H)),ne}};for(var Ae in ae.renderer)Pe(Ae);Q.renderer=de}(),ae.tokenizer&&function(){var de=ue.defaults.tokenizer||new W,Pe=function(j){var z=de[j];de[j]=function(){for(var G=arguments.length,H=new Array(G),te=0;te<G;te++)H[te]=arguments[te];var ne=ae.tokenizer[j].apply(de,H);return ne===!1&&(ne=z.apply(de,H)),ne}};for(var Ae in ae.tokenizer)Pe(Ae);Q.tokenizer=de}(),ae.walkTokens){var Fe=ue.defaults.walkTokens;Q.walkTokens=function(de){var Pe=[];return Pe.push(ae.walkTokens.call(this,de)),Fe&&(Pe=Pe.concat(Fe.call(this,de))),Pe}}le&&(Q.extensions=x),ue.setOptions(Q)})},ue.walkTokens=function(ye,$e){for(var fe=[],Q=function(){var Fe=le.value;switch(fe=fe.concat($e.call(ue,Fe)),Fe.type){case"table":{for(var de=F(Fe.header),Pe;!(Pe=de()).done;){var Ae=Pe.value;fe=fe.concat(ue.walkTokens(Ae.tokens,$e))}for(var je=F(Fe.rows),j;!(j=je()).done;)for(var z=j.value,G=F(z),H;!(H=G()).done;){var te=H.value;fe=fe.concat(ue.walkTokens(te.tokens,$e))}break}case"list":{fe=fe.concat(ue.walkTokens(Fe.items,$e));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Fe.type]?ue.defaults.extensions.childTokens[Fe.type].forEach(function(ne){fe=fe.concat(ue.walkTokens(Fe[ne],$e))}):Fe.tokens&&(fe=fe.concat(ue.walkTokens(Fe.tokens,$e)))}},x=F(ye),le;!(le=x()).done;)Q();return fe},ue.parseInline=function(ye,$e){if(typeof ye>"u"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");$e=b({},ue.defaults,$e||{}),k($e);try{var fe=ie.lexInline(ye,$e);return $e.walkTokens&&ue.walkTokens(fe,$e.walkTokens),ge.parseInline(fe,$e)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,$e.silent)return"<p>An error occurred:</p><pre>"+f(Q.message+"",!0)+"</pre>";throw Q}},ue.Parser=ge,ue.parser=ge.parse,ue.Renderer=ce,ue.TextRenderer=ve,ue.Lexer=ie,ue.lexer=ie.lex,ue.Tokenizer=W,ue.Slugger=Ee,ue.parse=ue;var Ce=ue.options,re=ue.setOptions,Ne=ue.use,Te=ue.walkTokens,T=ue.parseInline,X=ue,pe=ge.parse,Ie=ie.lex;he.Lexer=ie,he.Parser=ge,he.Renderer=ce,he.Slugger=Ee,he.TextRenderer=ve,he.Tokenizer=W,he.getDefaults=M,he.lexer=Ie,he.marked=ue,he.options=Ce,he.parse=X,he.parseInline=T,he.parser=pe,he.setOptions=re,he.use=Ne,he.walkTokens=Te,Object.defineProperty(he,"__esModule",{value:!0})}),define(ke[128],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=C;function C(s){const r=F(s);if(r&&r.length>0)return new Uint32Array(r)}let O=0;const R=new Uint32Array(10);function F(s){if(O=0,M(s,S,4352),O>0||(M(s,d,4449),O>0)||(M(s,v,4520),O>0)||(M(s,f,12593),O))return R.subarray(0,O);if(s>=44032&&s<=55203){const r=s-44032,o=r%588,n=Math.floor(r/588),t=Math.floor(o/28),c=o%28-1;if(n<S.length?M(n,S,0):4352+n-12593<f.length&&M(4352+n,f,12593),t<d.length?M(t,d,0):4449+t-12593<f.length&&M(4449+t-12593,f,12593),c>=0&&(c<v.length?M(c,v,0):4520+c-12593<f.length&&M(4520+c-12593,f,12593)),O>0)return R.subarray(0,O)}}function M(s,r,o){s>=o&&s<o+r.length&&p(r[s-o])}function p(s){s!==0&&(R[O++]=s&255,s>>8&&(R[O++]=s>>8&255),s>>16&&(R[O++]=s>>16&255))}var m;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var D;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(D||(D={}));var N;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(N||(N={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),d=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),f=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[129],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=e.$Hm=void 0,e.$Fm=C,e.rot=O;function C(p,m,D){return Math.min(Math.max(p,m),D)}function O(p,m){return(m+p%m)%m}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Hm=R;class F{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Im=F;class M{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const D=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Jm=M}),define(ke[130],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=F,e.$cd=d;class C{constructor(f,s,r){this.owner=f,this.debugNameSource=s,this.referenceFn=r}getDebugName(f){return F(f,this)}}e.$ad=C;const O=new Map,R=new WeakMap;function F(v,f){const s=R.get(v);if(s)return s;const r=M(v,f);if(r){let o=O.get(r)??0;o++,O.set(r,o);const n=o===1?r:`${r}#${o}`;return R.set(v,n),n}}function M(v,f){const s=R.get(v);if(s)return s;const r=f.owner?N(f.owner)+".":"";let o;const n=f.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(o=n(),o!==void 0)return r+o}else return r+n;const t=f.referenceFn;if(t!==void 0&&(o=d(t),o!==void 0))return r+o;if(f.owner!==void 0){const c=p(f.owner,v);if(c!==void 0)return r+c}}function p(v,f){for(const s in v)if(v[s]===f)return s}const m=new Map,D=new WeakMap;function N(v){const f=D.get(v);if(f)return f;const s=S(v);let r=m.get(s)??0;r++,m.set(s,r);const o=r===1?s:`${s}#${r}`;return D.set(v,o),o}function S(v){const f=v.constructor;return f?f.name:"Object"}function d(v){const f=v.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(r?r[1]:void 0)?.trim()}}),define(ke[131],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=O,e.$Id=R;let C;function O(s){C=s}function R(){return C}class F{constructor(){this.a=0,this.d=new WeakMap}b(r){return M([p(v("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[p(" "),D(N(r.oldValue,70),{color:"red",strikeThrough:!0}),p(" "),D(N(r.newValue,60),{color:"green"})]:[p(" (unchanged)")]:[p(" "),D(N(r.newValue,60),{color:"green"}),p(" (initial)")]}handleObservableChanged(r,o){console.log(...this.b([m("observable value changed"),D(r.debugName,{color:"BlueViolet"}),...this.c(o)]))}formatChanges(r){if(r.size!==0)return D(" (changed deps: "+[...r].map(o=>o.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const o=r.handleChange;this.d.set(r,new Set),r.handleChange=(n,t)=>(this.d.get(r).add(n),o.apply(r,[n,t]))}handleDerivedRecomputed(r,o){const n=this.d.get(r);console.log(...this.b([m("derived recomputed"),D(r.debugName,{color:"BlueViolet"}),...this.c(o),this.formatChanges(n),{data:[{fn:r._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(r,o){console.log(...this.b([m("observable from event triggered"),D(r.debugName,{color:"BlueViolet"}),...this.c(o),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const o=r.handleChange;this.d.set(r,new Set),r.handleChange=(n,t)=>(this.d.get(r).add(n),o.apply(r,[n,t]))}handleAutorunTriggered(r){const o=this.d.get(r);console.log(...this.b([m("autorun"),D(r.debugName,{color:"BlueViolet"}),this.formatChanges(o),{data:[{fn:r._runFn}]}])),o.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let o=r.getDebugName();o===void 0&&(o=""),console.log(...this.b([m("transaction"),D(o,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=F;function M(s){const r=new Array,o=[];let n="";function t(u){if("length"in u)for(const i of u)i&&t(i);else"text"in u?(n+=`%c${u.text}`,r.push(u.style),u.data&&o.push(...u.data)):"data"in u&&o.push(...u.data)}t(s);const c=[n,...r];return c.push(...o),c}function p(s){return D(s,{color:"black"})}function m(s){return D(f(`${s}: `,10),{color:"black",bold:!0})}function D(s,r={color:"black"}){function o(t){return Object.entries(t).reduce((c,[u,i])=>`${c}${u}:${i};`,"")}const n={color:r.color};return r.strikeThrough&&(n["text-decoration"]="line-through"),r.bold&&(n["font-weight"]="bold"),{text:s,style:o(n)}}function N(s,r){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=r?`"${s}"`:`"${s.substr(0,r-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?S(s,r):d(s,r);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function S(s,r){let o="[ ",n=!0;for(const t of s){if(n||(o+=", "),o.length-5>r){o+="...";break}n=!1,o+=`${N(t,r-o.length)}`}return o+=" ]",o}function d(s,r){let o="{ ",n=!0;for(const[t,c]of Object.entries(s)){if(n||(o+=", "),o.length-5>r){o+="...";break}n=!1,o+=`${t}: ${N(c,r-o.length)}`}return o+=" }",o}function v(s,r){let o="";for(let n=1;n<=r;n++)o+=s;return o}function f(s,r){for(;s.length<r;)s+=" ";return s}}),define(ke[132],Se([1,0,125,130,131]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=M,e.$Td=m,e.$Ud=N,e.$Xd=v,e.$Yd=s,e.$Zd=r,e.$1d=o,e.$3d=t,e.$4d=c,e.$6d=i;let F;function M(a){F=a}let p;function m(a){p=a}let D;function N(a){D=a}class S{get TChange(){return null}reportChanges(){this.get()}read(l){return l?l.readObservable(this):this.get()}map(l,g){const $=g===void 0?void 0:l,b=g===void 0?l:g;return D({owner:$,debugName:()=>{const y=(0,O.$cd)(b);if(y!==void 0)return y;const E=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(b.toString());if(E)return`${this.debugName}.${E[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:b},y=>b(this.read(y),y))}recomputeInitiallyAndOnChange(l,g){return l.add(F(this,g)),this}keepObserved(l){return l.add(p(this)),this}get a(){return this.get()}}e.$Vd=S;class d extends S{constructor(){super(...arguments),this.b=new Set}addObserver(l){const g=this.b.size;this.b.add(l),g===0&&this.c()}removeObserver(l){this.b.delete(l)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=d;function v(a,l){const g=new n(a,l);try{a(g)}finally{g.finish()}}let f;function s(a){if(f)a(f);else{const l=new n(a,void 0);f=l;try{a(l)}finally{l.finish(),f=void 0}}}async function r(a,l){const g=new n(a,l);try{await a(g)}finally{g.finish()}}function o(a,l,g){a?l(a):v(l,g)}class n{constructor(l,g){this._fn=l,this.b=g,this.a=[],(0,R.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,O.$cd)(this._fn)}updateObserver(l,g){this.a.push({observer:l,observable:g}),l.beginUpdate(g)}finish(){const l=this.a;for(let g=0;g<l.length;g++){const{observer:$,observable:b}=l[g];$.endUpdate(b)}this.a=null,(0,R.$Id)()?.handleEndTransaction()}}e.$2d=n;function t(a,l){let g;return typeof a=="string"?g=new O.$ad(void 0,a,void 0):g=new O.$ad(a,void 0,void 0),new u(g,l,C.$6c)}function c(a,l){return new u(new O.$ad(a.owner,a.debugName,void 0),l,a.equalsFn??C.$6c)}class u extends d{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(l,g,$){super(),this.e=l,this.g=$,this.d=g}get(){return this.d}set(l,g,$){if($===void 0&&this.g(this.d,l))return;let b;g||(g=b=new n(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(l),(0,R.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:l,change:$,didChange:!0,hadValue:!0});for(const h of this.b)g.updateObserver(h,this),h.handleChange(this,$)}finally{b&&b.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(l){this.d=l}}e.$5d=u;function i(a,l){let g;return typeof a=="string"?g=new O.$ad(void 0,a,void 0):g=new O.$ad(a,void 0,void 0),new w(g,l,C.$6c)}class w extends u{h(l){this.d!==l&&(this.d&&this.d.dispose(),this.d=l)}dispose(){this.d?.dispose()}}e.$7d=w}),function(){function he(R){const F=[];typeof R=="number"&&F.push("code/timeOrigin",R);function M(m){F.push(m,Date.now())}function p(){const m=[];for(let D=0;D<F.length;D+=2)m.push({name:F[D],startTime:F[D+1]});return m}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))F.push({name:M.name,startTime:Math.round(R+M.startTime)});return F}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function C(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=C(O))}(),define(ke[133],Se([1,0,42]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=void 0;const O=Symbol("unset");class R{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||C.Iterable.empty()}insert(m,D,N){this.d(m,S=>S._value=D,N)}mutate(m,D){this.d(m,N=>N._value=D(N._value===O?void 0:N._value))}mutatePath(m,D){this.d(m,()=>{},N=>D(N))}delete(m){const D=this.c(m);if(!D)return;let N=D.length-1;const S=D[N].node._value;if(S!==O){for(this.b--,D[N].node._value=O;N>0;N--){const{node:d,part:v}=D[N];if(d.children?.size||d._value!==O)break;D[N-1].node.children.delete(v)}return S}}*deleteRecursive(m){const D=this.c(m);if(!D)return;const N=D[D.length-1].node;for(let S=D.length-1;S>0;S--){const d=D[S-1];if(d.node.children.delete(D[S].part),d.node.children.size>0||d.node._value!==O)break}for(const S of F(N))S._value!==O&&(this.b--,yield S._value)}find(m){let D=this.a;for(const N of m){const S=D.children?.get(N);if(!S)return;D=S}return D._value===O?void 0:D._value}hasKeyOrParent(m){let D=this.a;for(const N of m){const S=D.children?.get(N);if(!S)return!1;if(S._value!==O)return!0;D=S}return!1}hasKeyOrChildren(m){let D=this.a;for(const N of m){const S=D.children?.get(N);if(!S)return!1;D=S}return!0}hasKey(m){let D=this.a;for(const N of m){const S=D.children?.get(N);if(!S)return!1;D=S}return D._value!==O}c(m){const D=[{part:"",node:this.a}];let N=0;for(const S of m){const d=D[N].node.children?.get(S);if(!d)return;D.push({part:S,node:d}),N++}return D}d(m,D,N){let S=this.a;for(const f of m){if(S.children)if(S.children.has(f))S=S.children.get(f);else{const s=new M;S.children.set(f,s),S=s}else{const s=new M;S.children=new Map([[f,s]]),S=s}N?.(S)}const d=S._value===O?0:1;D(S);const v=S._value===O?0:1;this.b+=v-d}*values(){for(const{_value:m}of F(this.a))m!==O&&(yield m)}}e.$GO=R;function*F(p){const m=[p];for(;m.length>0;){const D=m.pop();if(yield D,D.children)for(const N of D.children.values())m.push(N)}}class M{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(m){this._value=m===void 0?O:m}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var O in C)(typeof exports=="object"?exports:he)[O]=C[O]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function C(O){if(e[O])return e[O].exports;var R=e[O]={i:O,l:!1,exports:{}};return he[O].call(R.exports,R,R.exports,C),R.l=!0,R.exports}return C.m=he,C.c=e,C.d=function(O,R,F){C.o(O,R)||Object.defineProperty(O,R,{enumerable:!0,get:F})},C.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},C.t=function(O,R){if(1&R&&(O=C(O)),8&R||4&R&&typeof O=="object"&&O&&O.__esModule)return O;var F=Object.create(null);if(C.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:O}),2&R&&typeof O!="string")for(var M in O)C.d(F,M,function(p){return O[p]}.bind(null,M));return F},C.n=function(O){var R=O&&O.__esModule?function(){return O.default}:function(){return O};return C.d(R,"a",R),R},C.o=function(O,R){return Object.prototype.hasOwnProperty.call(O,R)},C.p="",C(C.s=0)}([function(he,e,C){(function(O){var R;e=he.exports=Ne,R=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],m=e.src=[],D=0,N=D++;m[N]="0|[1-9]\\d*";var S=D++;m[S]="[0-9]+";var d=D++;m[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=D++;m[v]="("+m[N]+")\\.("+m[N]+")\\.("+m[N]+")";var f=D++;m[f]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var s=D++;m[s]="(?:"+m[N]+"|"+m[d]+")";var r=D++;m[r]="(?:"+m[S]+"|"+m[d]+")";var o=D++;m[o]="(?:-("+m[s]+"(?:\\."+m[s]+")*))";var n=D++;m[n]="(?:-?("+m[r]+"(?:\\."+m[r]+")*))";var t=D++;m[t]="[0-9A-Za-z-]+";var c=D++;m[c]="(?:\\+("+m[t]+"(?:\\."+m[t]+")*))";var u=D++,i="v?"+m[v]+m[o]+"?"+m[c]+"?";m[u]="^"+i+"$";var w="[v=\\s]*"+m[f]+m[n]+"?"+m[c]+"?",a=D++;m[a]="^"+w+"$";var l=D++;m[l]="((?:<|>)?=?)";var g=D++;m[g]=m[S]+"|x|X|\\*";var $=D++;m[$]=m[N]+"|x|X|\\*";var b=D++;m[b]="[v=\\s]*("+m[$]+")(?:\\.("+m[$]+")(?:\\.("+m[$]+")(?:"+m[o]+")?"+m[c]+"?)?)?";var y=D++;m[y]="[v=\\s]*("+m[g]+")(?:\\.("+m[g]+")(?:\\.("+m[g]+")(?:"+m[n]+")?"+m[c]+"?)?)?";var h=D++;m[h]="^"+m[l]+"\\s*"+m[b]+"$";var E=D++;m[E]="^"+m[l]+"\\s*"+m[y]+"$";var k=D++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=D++;m[I]="(?:~>?)";var P=D++;m[P]="(\\s*)"+m[I]+"\\s+",p[P]=new RegExp(m[P],"g");var V=D++;m[V]="^"+m[I]+m[b]+"$";var W=D++;m[W]="^"+m[I]+m[y]+"$";var q=D++;m[q]="(?:\\^)";var A=D++;m[A]="(\\s*)"+m[q]+"\\s+",p[A]=new RegExp(m[A],"g");var U=D++;m[U]="^"+m[q]+m[b]+"$";var K=D++;m[K]="^"+m[q]+m[y]+"$";var ie=D++;m[ie]="^"+m[l]+"\\s*("+w+")$|^$";var ce=D++;m[ce]="^"+m[l]+"\\s*("+i+")$|^$";var ve=D++;m[ve]="(\\s*)"+m[l]+"\\s*("+w+"|"+m[b]+")",p[ve]=new RegExp(m[ve],"g");var Ee=D++;m[Ee]="^\\s*("+m[b]+")\\s+-\\s+("+m[b]+")\\s*$";var ge=D++;m[ge]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var ue=D++;m[ue]="(<|>)?=?\\s*\\*";for(var Ce=0;Ce<35;Ce++)R(Ce,m[Ce]),p[Ce]||(p[Ce]=new RegExp(m[Ce]));function re(z,G){if(z instanceof Ne)return z;if(typeof z!="string"||z.length>F||!(G?p[a]:p[u]).test(z))return null;try{return new Ne(z,G)}catch{return null}}function Ne(z,G){if(z instanceof Ne){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof Ne))return new Ne(z,G);R("SemVer",z,G),this.loose=G;var H=z.trim().match(G?p[a]:p[u]);if(!H)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(te){if(/^[0-9]+$/.test(te)){var ne=+te;if(ne>=0&&ne<M)return ne}return te}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=re,e.valid=function(z,G){var H=re(z,G);return H?H.version:null},e.clean=function(z,G){var H=re(z.trim().replace(/^[=v]+/,""),G);return H?H.version:null},e.SemVer=Ne,Ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ne.prototype.toString=function(){return this.version},Ne.prototype.compare=function(z){return R("SemVer.compare",this.version,this.loose,z),z instanceof Ne||(z=new Ne(z,this.loose)),this.compareMain(z)||this.comparePre(z)},Ne.prototype.compareMain=function(z){return z instanceof Ne||(z=new Ne(z,this.loose)),T(this.major,z.major)||T(this.minor,z.minor)||T(this.patch,z.patch)},Ne.prototype.comparePre=function(z){if(z instanceof Ne||(z=new Ne(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],te=z.prerelease[G];if(R("prerelease compare",G,H,te),H===void 0&&te===void 0)return 0;if(te===void 0)return 1;if(H===void 0)return-1;if(H!==te)return T(H,te)}while(++G)},Ne.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,G,H,te){typeof H=="string"&&(te=H,H=void 0);try{return new Ne(z,H).inc(G,te).version}catch{return null}},e.diff=function(z,G){if(ye(z,G))return null;var H=re(z),te=re(G);if(H.prerelease.length||te.prerelease.length){for(var ne in H)if((ne==="major"||ne==="minor"||ne==="patch")&&H[ne]!==te[ne])return"pre"+ne;return"prerelease"}for(var ne in H)if((ne==="major"||ne==="minor"||ne==="patch")&&H[ne]!==te[ne])return ne},e.compareIdentifiers=T;var Te=/^[0-9]+$/;function T(z,G){var H=Te.test(z),te=Te.test(G);return H&&te&&(z=+z,G=+G),H&&!te?-1:te&&!H?1:z<G?-1:z>G?1:0}function X(z,G,H){return new Ne(z,H).compare(new Ne(G,H))}function pe(z,G,H){return X(z,G,H)>0}function Ie(z,G,H){return X(z,G,H)<0}function ye(z,G,H){return X(z,G,H)===0}function $e(z,G,H){return X(z,G,H)!==0}function fe(z,G,H){return X(z,G,H)>=0}function Q(z,G,H){return X(z,G,H)<=0}function x(z,G,H,te){var ne;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),ne=z===H;break;case"!==":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),ne=z!==H;break;case"":case"=":case"==":ne=ye(z,H,te);break;case"!=":ne=$e(z,H,te);break;case">":ne=pe(z,H,te);break;case">=":ne=fe(z,H,te);break;case"<":ne=Ie(z,H,te);break;case"<=":ne=Q(z,H,te);break;default:throw new TypeError("Invalid operator: "+G)}return ne}function le(z,G){if(z instanceof le){if(z.loose===G)return z;z=z.value}if(!(this instanceof le))return new le(z,G);R("comparator",z,G),this.loose=G,this.parse(z),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(z,G){return T(G,z)},e.major=function(z,G){return new Ne(z,G).major},e.minor=function(z,G){return new Ne(z,G).minor},e.patch=function(z,G){return new Ne(z,G).patch},e.compare=X,e.compareLoose=function(z,G){return X(z,G,!0)},e.rcompare=function(z,G,H){return X(G,z,H)},e.sort=function(z,G){return z.sort(function(H,te){return e.compare(H,te,G)})},e.rsort=function(z,G){return z.sort(function(H,te){return e.rcompare(H,te,G)})},e.gt=pe,e.lt=Ie,e.eq=ye,e.neq=$e,e.gte=fe,e.lte=Q,e.cmp=x,e.Comparator=le;var ae={};function Fe(z,G){if(z instanceof Fe)return z.loose===G?z:new Fe(z.raw,G);if(z instanceof le)return new Fe(z.value,G);if(!(this instanceof Fe))return new Fe(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function de(z){return!z||z.toLowerCase()==="x"||z==="*"}function Pe(z,G,H,te,ne,Oe,Be,He,_e,xe,et,tt,it){return((G=de(H)?"":de(te)?">="+H+".0.0":de(ne)?">="+H+"."+te+".0":">="+G)+" "+(He=de(_e)?"":de(xe)?"<"+(+_e+1)+".0.0":de(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+He)).trim()}function Ae(z,G){for(var H=0;H<z.length;H++)if(!z[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<z.length;H++)if(R(z[H].semver),z[H].semver!==ae&&z[H].semver.prerelease.length>0){var te=z[H].semver;if(te.major===G.major&&te.minor===G.minor&&te.patch===G.patch)return!0}return!1}return!0}function je(z,G,H){try{G=new Fe(G,H)}catch{return!1}return G.test(z)}function j(z,G,H,te){var ne,Oe,Be,He,_e;switch(z=new Ne(z,te),G=new Fe(G,te),H){case">":ne=pe,Oe=Q,Be=Ie,He=">",_e=">=";break;case"<":ne=Ie,Oe=fe,Be=pe,He="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(z,G,te))return!1;for(var xe=0;xe<G.set.length;++xe){var et=G.set[xe],tt=null,it=null;if(et.forEach(function(at){at.semver===ae&&(at=new le(">=0.0.0")),tt=tt||at,it=it||at,ne(at.semver,tt.semver,te)?tt=at:Be(at.semver,it.semver,te)&&(it=at)}),tt.operator===He||tt.operator===_e||(!it.operator||it.operator===He)&&Oe(z,it.semver)||it.operator===_e&&Be(z,it.semver))return!1}return!0}le.prototype.parse=function(z){var G=this.loose?p[ie]:p[ce],H=z.match(G);if(!H)throw new TypeError("Invalid comparator: "+z);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Ne(H[2],this.loose):this.semver=ae},le.prototype.toString=function(){return this.value},le.prototype.test=function(z){return R("Comparator.test",z,this.loose),this.semver===ae||(typeof z=="string"&&(z=new Ne(z,this.loose)),x(z,this.operator,this.semver,this.loose))},le.prototype.intersects=function(z,G){if(!(z instanceof le))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Fe(z.value,G),je(this.value,H,G);if(z.operator==="")return H=new Fe(this.value,G),je(z.semver,H,G);var te=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ne=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),He=x(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),_e=x(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return te||ne||Oe&&Be||He||_e},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),R("range",z,G);var H=G?p[ge]:p[Ee];z=z.replace(H,Pe),R("hyphen replace",z),z=z.replace(p[ve],"$1$2$3"),R("comparator trim",z,p[ve]),z=(z=(z=z.replace(p[P],"$1~")).replace(p[A],"$1^")).split(/\s+/).join(" ");var te=G?p[ie]:p[ce],ne=z.split(" ").map(function(Oe){return function(Be,He){return R("comp",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){R("caret",tt,it);var at=it?p[K]:p[U];return tt.replace(at,function(mt,Ue,rt,Y,Z){var me;return R("caret",tt,mt,Ue,rt,Y,Z),de(Ue)?me="":de(rt)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(Y)?me=Ue==="0"?">="+Ue+"."+rt+".0 <"+Ue+"."+(+rt+1)+".0":">="+Ue+"."+rt+".0 <"+(+Ue+1)+".0.0":Z?(R("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=Ue==="0"?rt==="0"?">="+Ue+"."+rt+"."+Y+Z+" <"+Ue+"."+rt+"."+(+Y+1):">="+Ue+"."+rt+"."+Y+Z+" <"+Ue+"."+(+rt+1)+".0":">="+Ue+"."+rt+"."+Y+Z+" <"+(+Ue+1)+".0.0"):(R("no pr"),me=Ue==="0"?rt==="0"?">="+Ue+"."+rt+"."+Y+" <"+Ue+"."+rt+"."+(+Y+1):">="+Ue+"."+rt+"."+Y+" <"+Ue+"."+(+rt+1)+".0":">="+Ue+"."+rt+"."+Y+" <"+(+Ue+1)+".0.0"),R("caret return",me),me})}(et,xe)}).join(" ")}(Be,He),R("caret",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){var at=it?p[W]:p[V];return tt.replace(at,function(mt,Ue,rt,Y,Z){var me;return R("tilde",tt,mt,Ue,rt,Y,Z),de(Ue)?me="":de(rt)?me=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":de(Y)?me=">="+Ue+"."+rt+".0 <"+Ue+"."+(+rt+1)+".0":Z?(R("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),me=">="+Ue+"."+rt+"."+Y+Z+" <"+Ue+"."+(+rt+1)+".0"):me=">="+Ue+"."+rt+"."+Y+" <"+Ue+"."+(+rt+1)+".0",R("tilde return",me),me})}(et,xe)}).join(" ")}(Be,He),R("tildes",Be),Be=function(_e,xe){return R("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var at=it?p[E]:p[h];return tt.replace(at,function(mt,Ue,rt,Y,Z,me){R("xRange",tt,mt,Ue,rt,Y,Z,me);var Ge=de(rt),be=Ge||de(Y),st=be||de(Z);return Ue==="="&&st&&(Ue=""),Ge?mt=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&st?(be&&(Y=0),st&&(Z=0),Ue===">"?(Ue=">=",be?(rt=+rt+1,Y=0,Z=0):st&&(Y=+Y+1,Z=0)):Ue==="<="&&(Ue="<",be?rt=+rt+1:Y=+Y+1),mt=Ue+rt+"."+Y+"."+Z):be?mt=">="+rt+".0.0 <"+(+rt+1)+".0.0":st&&(mt=">="+rt+"."+Y+".0 <"+rt+"."+(+Y+1)+".0"),R("xRange return",mt),mt})}(et,xe)}).join(" ")}(Be,He),R("xrange",Be),Be=function(_e,xe){return R("replaceStars",_e,xe),_e.trim().replace(p[ue],"")}(Be,He),R("stars",Be),Be}(Oe,G)}).join(" ").split(/\s+/);return this.loose&&(ne=ne.filter(function(Oe){return!!Oe.match(te)})),ne=ne.map(function(Oe){return new le(Oe,G)})},Fe.prototype.intersects=function(z,G){if(!(z instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(te){return z.set.some(function(ne){return ne.every(function(Oe){return te.intersects(Oe,G)})})})})},e.toComparators=function(z,G){return new Fe(z,G).set.map(function(H){return H.map(function(te){return te.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new Ne(z,this.loose));for(var G=0;G<this.set.length;G++)if(Ae(this.set[G],z))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(z,G,H){var te=null,ne=null;try{var Oe=new Fe(G,H)}catch{return null}return z.forEach(function(Be){Oe.test(Be)&&(te&&ne.compare(Be)!==-1||(ne=new Ne(te=Be,H)))}),te},e.minSatisfying=function(z,G,H){var te=null,ne=null;try{var Oe=new Fe(G,H)}catch{return null}return z.forEach(function(Be){Oe.test(Be)&&(te&&ne.compare(Be)!==1||(ne=new Ne(te=Be,H)))}),te},e.validRange=function(z,G){try{return new Fe(z,G).range||"*"}catch{return null}},e.ltr=function(z,G,H){return j(z,G,"<",H)},e.gtr=function(z,G,H){return j(z,G,">",H)},e.outside=j,e.prerelease=function(z,G){var H=re(z,G);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(z,G,H){return z=new Fe(z,H),G=new Fe(G,H),z.intersects(G)},e.coerce=function(z){if(z instanceof Ne)return z;if(typeof z!="string")return null;var G=z.match(p[k]);return G==null?null:re((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,C(1))},function(he,e){var C,O,R=he.exports={};function F(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(r){if(C===setTimeout)return setTimeout(r,0);if((C===F||!C)&&setTimeout)return C=setTimeout,setTimeout(r,0);try{return C(r,0)}catch{try{return C.call(null,r,0)}catch{return C.call(this,r,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:F}catch{C=F}try{O=typeof clearTimeout=="function"?clearTimeout:M}catch{O=M}})();var m,D=[],N=!1,S=-1;function d(){N&&m&&(N=!1,m.length?D=m.concat(D):S=-1,D.length&&v())}function v(){if(!N){var r=p(d);N=!0;for(var o=D.length;o;){for(m=D,D=[];++S<o;)m&&m[S].run();S=-1,o=D.length}m=null,N=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===M||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(r)}}function f(r,o){this.fun=r,this.array=o}function s(){}R.nextTick=function(r){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];D.push(new f(r,o)),D.length!==1||N||p(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=s,R.addListener=s,R.once=s,R.off=s,R.removeListener=s,R.removeAllListeners=s,R.emit=s,R.prependListener=s,R.prependOnceListener=s,R.listeners=function(r){return[]},R.binding=function(r){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(r){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ke[134],Se([1,0,14,6]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=R,e.$ve=F,e.$we=M,e.$xe=p,e.$ye=D,e.$ze=N,e.$Ae=S,e.$Be=d,e.$Ce=v,e.$De=f,e.$Ee=s,e.$Fe=r,e.$Ge=o,e.$He=n,e.$Ie=t;function R(c){const u=c;return u?typeof u.read=="function":!1}function F(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}function M(c){const u=c;return u?F(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function p(c,u){return new m(c,u)}class m{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,C.$1)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let w;switch(u){case"data":w=this.c.data;break;case"end":w=this.c.end;break;case"error":w=this.c.error;break}if(w){const a=w.indexOf(i);a>=0&&w.splice(a,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(w=>w())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(c,u){const i=[];let w;for(;(w=c.read())!==null;)i.push(w);return u(i)}function N(c,u,i){const w=[];let a;for(;(a=c.read())!==null&&w.length<i;)w.push(a);return a===null&&w.length>0?u(w):{read:()=>{if(w.length>0)return w.shift();if(typeof a<"u"){const l=a;return a=void 0,l}return c.read()}}}function S(c,u){return new Promise((i,w)=>{const a=[];d(c,{onData:l=>{u&&a.push(l)},onError:l=>{u?w(l):i(void 0)},onEnd:()=>{i(u?u(a):void 0)}})})}function d(c,u,i){c.on("error",w=>{i?.isCancellationRequested||u.onError(w)}),c.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),c.on("data",w=>{i?.isCancellationRequested||u.onData(w)})}function v(c,u){return new Promise((i,w)=>{const a=new O.$Tc,l=[],g=y=>{if(l.push(y),l.length>u)return a.dispose(),c.pause(),i({stream:c,buffer:l,ended:!1})},$=y=>(a.dispose(),w(y)),b=()=>(a.dispose(),i({stream:c,buffer:l,ended:!0}));a.add((0,O.$Sc)(()=>c.removeListener("error",$))),c.on("error",$),a.add((0,O.$Sc)(()=>c.removeListener("end",b))),c.on("end",b),a.add((0,O.$Sc)(()=>c.removeListener("data",g))),c.on("data",g)})}function f(c,u){const i=p(u);return i.end(c),i}function s(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function r(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}function o(c,u,i){const w=p(i);return d(c,{onData:a=>w.write(u.data(a)),onError:a=>w.error(u.error?u.error(a):a),onEnd:()=>w.end()}),w}function n(c,u,i){let w=!1;return{read:()=>{const a=u.read();return w?a:(w=!0,a!==null?i([c,a]):c)}}}function t(c,u,i){let w=!1;const a=p(i);return d(u,{onData:l=>w?a.write(l):(w=!0,a.write(i([c,l]))),onError:l=>a.error(l),onEnd:()=>{w||(w=!0,a.write(c)),a.end()}}),a}}),define(ke[22],Se([1,0,43,134]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=D,e.$Le=N,e.$Me=S,e.$Ne=d,e.$Oe=v,e.$Pe=f,e.$Qe=s,e.$Re=r,e.$Se=o,e.$Te=n,e.$Ue=t,e.$Ve=c,e.$We=u,e.$Xe=i,e.$Ye=w,e.$Ze=a,e.$1e=l,e.$2e=g,e.$3e=$,e.$4e=h;const R=typeof Buffer<"u",F=new C.$V(()=>new Uint8Array(256));let M,p;class m{static alloc(k){return R?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return R&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,I){return!(I?.dontUseNodeBuffer||!1)&&R?new m(Buffer.from(k)):(M||(M=new TextEncoder),new m(M.encode(k)))}static fromByteArray(k){const I=m.alloc(k.length);for(let P=0,V=k.length;P<V;P++)I.buffer[P]=k[P];return I}static concat(k,I){if(typeof I>"u"){I=0;for(let W=0,q=k.length;W<q;W++)I+=k[W].byteLength}const P=m.alloc(I);let V=0;for(let W=0,q=k.length;W<q;W++){const A=k[W];P.set(A,V),V+=A.byteLength}return P}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return R?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(k,I){return new m(this.buffer.subarray(k,I))}set(k,I){if(k instanceof m)this.buffer.set(k.buffer,I);else if(k instanceof Uint8Array)this.buffer.set(k,I);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),I);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return d(this.buffer,k)}writeUInt32BE(k,I){v(this.buffer,k,I)}readUInt32LE(k){return f(this.buffer,k)}writeUInt32LE(k,I){s(this.buffer,k,I)}readUInt8(k){return r(this.buffer,k)}writeUInt8(k,I){o(this.buffer,k,I)}indexOf(k,I=0){return D(this.buffer,k instanceof m?k.buffer:k,I)}}e.$Je=m;function D(E,k,I=0){const P=k.byteLength,V=E.byteLength;if(P===0)return 0;if(P===1)return E.indexOf(k[0]);if(P>V-I)return-1;const W=F.value;W.fill(k.length);for(let K=0;K<k.length;K++)W[k[K]]=k.length-K-1;let q=I+k.length-1,A=q,U=-1;for(;q<V;)if(E[q]===k[A]){if(A===0){U=q;break}q--,A--}else q+=Math.max(k.length-A,W[E[q]]),A=k.length-1;return U}function N(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0}function S(E,k,I){E[I+0]=k&255,k=k>>>8,E[I+1]=k&255}function d(E,k){return E[k]*2**24+E[k+1]*2**16+E[k+2]*2**8+E[k+3]}function v(E,k,I){E[I+3]=k,k=k>>>8,E[I+2]=k,k=k>>>8,E[I+1]=k,k=k>>>8,E[I]=k}function f(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0|E[k+2]<<16>>>0|E[k+3]<<24>>>0}function s(E,k,I){E[I+0]=k&255,k=k>>>8,E[I+1]=k&255,k=k>>>8,E[I+2]=k&255,k=k>>>8,E[I+3]=k&255}function r(E,k){return E[k]}function o(E,k,I){E[I]=k}function n(E){return O.$ye(E,k=>m.concat(k))}function t(E){return O.$Fe(E)}function c(E){return O.$Ae(E,k=>m.concat(k))}async function u(E){return E.ended?m.concat(E.buffer):m.concat([...E.buffer,await c(E.stream)])}function i(E){return O.$De(E,k=>m.concat(k))}function w(E){return O.$Ge(E,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}function a(E){return O.$xe(k=>m.concat(k),E)}function l(E,k){return O.$He(E,k,I=>m.concat(I))}function g(E,k){return O.$Ie(E,k,I=>m.concat(I))}function $(E){let k=0,I=0,P=0;const V=new Uint8Array(Math.floor(E.length/4*3)),W=A=>{switch(I){case 3:V[P++]=k|A,I=0;break;case 2:V[P++]=k|A>>>2,k=A<<6,I=3;break;case 1:V[P++]=k|A>>>4,k=A<<4,I=2;break;default:k=A<<2,I=1}};for(let A=0;A<E.length;A++){const U=E.charCodeAt(A);if(U>=65&&U<=90)W(U-65);else if(U>=97&&U<=122)W(U-97+26);else if(U>=48&&U<=57)W(U-48+52);else if(U===43||U===45)W(62);else if(U===47||U===95)W(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${E[A]}`)}}const q=P;for(;I>0;)W(0);return m.wrap(V).slice(0,q)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:E},k=!0,I=!1){const P=I?y:b;let V="";const W=E.byteLength%3;let q=0;for(;q<E.byteLength-W;q+=3){const A=E[q+0],U=E[q+1],K=E[q+2];V+=P[A>>>2],V+=P[(A<<4|U>>>4)&63],V+=P[(U<<2|K>>>6)&63],V+=P[K&63]}if(W===1){const A=E[q+0];V+=P[A>>>2],V+=P[A<<4&63],k&&(V+="==")}else if(W===2){const A=E[q+0],U=E[q+1];V+=P[A>>>2],V+=P[(A<<4|U>>>4)&63],V+=P[U<<2&63],k&&(V+="=")}return V}}),define(ke[135],Se([1,0,28,128,13]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=F,e.$Dk=p,e.$Ek=m,e.$Fk=S,e.$Gk=$,e.$Hk=b,e.$Ik=P,e.$Jk=V,e.$Kk=W,e.$Lk=q,e.$Mk=X,e.$Ok=$e,e.$Pk=x,e.$Qk=le;function F(...de){return function(Pe,Ae){for(let je=0,j=de.length;je<j;je++){const z=de[je](Pe,Ae);if(z)return z}return null}}e.$Bk=M.bind(void 0,!1),e.$Ck=M.bind(void 0,!0);function M(de,Pe,Ae){if(!Ae||Ae.length<Pe.length)return null;let je;return de?je=R.$Cf(Ae,Pe):je=Ae.indexOf(Pe)===0,je?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(de,Pe){const Ae=Pe.toLowerCase().indexOf(de.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+de.length}]}function m(de,Pe){return D(de.toLowerCase(),Pe.toLowerCase(),0,0)}function D(de,Pe,Ae,je){if(Ae===de.length)return[];if(je===Pe.length)return null;if(de[Ae]===Pe[je]){let j=null;return(j=D(de,Pe,Ae+1,je+1))?c({start:je,end:je+1},j):null}return D(de,Pe,Ae,je+1)}function N(de){return 97<=de&&de<=122}function S(de){return 65<=de&&de<=90}function d(de){return 48<=de&&de<=57}function v(de){return de===32||de===9||de===10||de===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>f.add(de.charCodeAt(0)));function s(de){return v(de)||f.has(de)}function r(de,Pe){return de===Pe||s(de)&&s(Pe)}const o=new Map;function n(de){if(o.has(de))return o.get(de);let Pe;const Ae=(0,O.$zk)(de);return Ae&&(Pe=Ae),o.set(de,Pe),Pe}function t(de){return N(de)||S(de)||d(de)}function c(de,Pe){return Pe.length===0?Pe=[de]:de.end===Pe[0].start?Pe[0].start=de.start:Pe.unshift(de),Pe}function u(de,Pe){for(let Ae=Pe;Ae<de.length;Ae++){const je=de.charCodeAt(Ae);if(S(je)||d(je)||Ae>0&&!t(de.charCodeAt(Ae-1)))return Ae}return de.length}function i(de,Pe,Ae,je){if(Ae===de.length)return[];if(je===Pe.length)return null;if(de[Ae]!==Pe[je].toLowerCase())return null;{let j=null,z=je+1;for(j=i(de,Pe,Ae+1,je+1);!j&&(z=u(Pe,z))<Pe.length;)j=i(de,Pe,Ae+1,z),z++;return j===null?null:c({start:je,end:je+1},j)}}function w(de){let Pe=0,Ae=0,je=0,j=0,z=0;for(let Oe=0;Oe<de.length;Oe++)z=de.charCodeAt(Oe),S(z)&&Pe++,N(z)&&Ae++,t(z)&&je++,d(z)&&j++;const G=Pe/de.length,H=Ae/de.length,te=je/de.length,ne=j/de.length;return{upperPercent:G,lowerPercent:H,alphaPercent:te,numericPercent:ne}}function a(de){const{upperPercent:Pe,lowerPercent:Ae}=de;return Ae===0&&Pe>.6}function l(de){const{upperPercent:Pe,lowerPercent:Ae,alphaPercent:je,numericPercent:j}=de;return Ae>.2&&Pe<.8&&je>.6&&j<.2}function g(de){let Pe=0,Ae=0,je=0,j=0;for(let z=0;z<de.length;z++)je=de.charCodeAt(z),S(je)&&Pe++,N(je)&&Ae++,v(je)&&j++;return(Pe===0||Ae===0)&&j===0?de.length<=30:Pe<=5}function $(de,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!g(de))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Ae=w(Pe);if(!l(Ae)){if(!a(Ae))return null;Pe=Pe.toLowerCase()}let je=null,j=0;for(de=de.toLowerCase();j<Pe.length&&(je=i(de,Pe,0,j))===null;)j=u(Pe,j+1);return je}function b(de,Pe,Ae=!1){if(!Pe||Pe.length===0)return null;let je=null,j=0;for(de=de.toLowerCase(),Pe=Pe.toLowerCase();j<Pe.length&&(je=y(de,Pe,0,j,Ae),je===null);)j=h(Pe,j+1);return je}function y(de,Pe,Ae,je,j){let z=0;if(Ae===de.length)return[];if(je===Pe.length)return null;if(!r(de.charCodeAt(Ae),Pe.charCodeAt(je))){const te=n(de.charCodeAt(Ae));if(!te)return null;for(let ne=0;ne<te.length;ne++)if(!r(te[ne],Pe.charCodeAt(je+ne)))return null;z+=te.length-1}let G=null,H=je+z+1;if(G=y(de,Pe,Ae+1,H,j),!j)for(;!G&&(H=h(Pe,H))<Pe.length;)G=y(de,Pe,Ae+1,H,j),H++;if(!G)return null;if(de.charCodeAt(Ae)!==Pe.charCodeAt(je)){const te=n(de.charCodeAt(Ae));if(!te)return G;for(let ne=0;ne<te.length;ne++)if(te[ne]!==Pe.charCodeAt(je+ne))return G}return c({start:je,end:je+z+1},G)}function h(de,Pe){for(let Ae=Pe;Ae<de.length;Ae++)if(s(de.charCodeAt(Ae))||Ae>0&&s(de.charCodeAt(Ae-1)))return Ae;return de.length}const E=F(e.$Ck,$,p),k=F(e.$Ck,$,m),I=new C.$Dc(1e4);function P(de,Pe,Ae=!1){if(typeof de!="string"||typeof Pe!="string")return null;let je=I.get(de);je||(je=new RegExp(R.$kf(de),"i"),I.set(de,je));const j=je.exec(Pe);return j?[{start:j.index,end:j.index+j[0].length}]:Ae?k(de,Pe):E(de,Pe)}function V(de,Pe){const Ae=$e(de,de.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?q(Ae):null}function W(de,Pe,Ae,je,j,z){const G=Math.min(13,de.length);for(;Ae<G;Ae++){const H=$e(de,Pe,Ae,je,j,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,z]}function q(de){if(typeof de>"u")return[];const Pe=[],Ae=de[1];for(let je=de.length-1;je>1;je--){const j=de[je]+Ae,z=Pe[Pe.length-1];z&&z.end===j?z.end=j+1:Pe.push({start:j,end:j+1})}return Pe}const A=128;function U(){const de=[],Pe=[];for(let Ae=0;Ae<=A;Ae++)Pe[Ae]=0;for(let Ae=0;Ae<=A;Ae++)de.push(Pe.slice(0));return de}function K(de){const Pe=[];for(let Ae=0;Ae<=de;Ae++)Pe[Ae]=0;return Pe}const ie=K(2*A),ce=K(2*A),ve=U(),Ee=U(),ge=U(),ue=!1;function Ce(de,Pe,Ae,je,j){function z(H,te,ne=" "){for(;H.length<te;)H=ne+H;return H}let G=` |   |${je.split("").map(H=>z(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?G+=" |":G+=`${Pe[H-1]}|`,G+=de[H].slice(0,j+1).map(te=>z(te.toString(),3)).join("|")+`
`;return G}function re(de,Pe,Ae,je){de=de.substr(Pe),Ae=Ae.substr(je),console.log(Ce(Ee,de,de.length,Ae,Ae.length)),console.log(Ce(ge,de,de.length,Ae,Ae.length)),console.log(Ce(ve,de,de.length,Ae,Ae.length))}function Ne(de,Pe){if(Pe<0||Pe>=de.length)return!1;const Ae=de.codePointAt(Pe);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Uf(Ae)}}function Te(de,Pe){if(Pe<0||Pe>=de.length)return!1;switch(de.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function T(de,Pe,Ae){return Pe[de]!==Ae[de]}function X(de,Pe,Ae,je,j,z,G=!1){for(;Pe<Ae&&j<z;)de[Pe]===je[j]&&(G&&(ie[Pe]=j),Pe+=1),j+=1;return Pe===Ae}var pe;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(pe||(pe={}));var Ie;(function(de){de.Default=[-100,0];function Pe(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}de.isDefault=Pe})(Ie||(e.FuzzyScore=Ie={}));class ye{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Ae){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Ae}}e.$Nk=ye;function $e(de,Pe,Ae,je,j,z,G=ye.default){const H=de.length>A?A:de.length,te=je.length>A?A:je.length;if(Ae>=H||z>=te||H-Ae>te-z||!X(Pe,Ae,H,j,z,te,!0))return;fe(H,te,Ae,z,Pe,j);let ne=1,Oe=1,Be=Ae,He=z;const _e=[!1];for(ne=1,Be=Ae;Be<H;ne++,Be++){const at=ie[Be],mt=ce[Be],Ue=Be+1<H?ce[Be+1]:te;for(Oe=at-z+1,He=at;He<Ue;Oe++,He++){let rt=Number.MIN_SAFE_INTEGER,Y=!1;He<=mt&&(rt=Q(de,Pe,Be,Ae,je,j,He,te,z,ve[ne-1][Oe-1]===0,_e));let Z=0;rt!==Number.MAX_SAFE_INTEGER&&(Y=!0,Z=rt+Ee[ne-1][Oe-1]);const me=He>at,Ge=me?Ee[ne][Oe-1]+(ve[ne][Oe-1]>0?-5:0):0,be=He>at+1&&ve[ne][Oe-1]>0,st=be?Ee[ne][Oe-2]+(ve[ne][Oe-2]>0?-5:0):0;if(be&&(!me||st>=Ge)&&(!Y||st>=Z))Ee[ne][Oe]=st,ge[ne][Oe]=3,ve[ne][Oe]=0;else if(me&&(!Y||Ge>=Z))Ee[ne][Oe]=Ge,ge[ne][Oe]=2,ve[ne][Oe]=0;else if(Y)Ee[ne][Oe]=Z,ge[ne][Oe]=1,ve[ne][Oe]=ve[ne-1][Oe-1]+1;else throw new Error("not possible")}}if(ue&&re(de,Ae,je,z),!_e[0]&&!G.firstMatchCanBeWeak)return;ne--,Oe--;const xe=[Ee[ne][Oe],z];let et=0,tt=0;for(;ne>=1;){let at=Oe;do{const mt=ge[ne][at];if(mt===3)at=at-2;else if(mt===2)at=at-1;else break}while(at>=1);et>1&&Pe[Ae+ne-1]===j[z+Oe-1]&&!T(at+z-1,je,j)&&et+1>ve[ne][at]&&(at=Oe),at===Oe?et++:et=1,tt||(tt=at),ne--,Oe=at-1,xe.push(Oe)}te-z===H&&G.boostFullMatch&&(xe[0]+=2);const it=tt-H;return xe[0]-=it,xe}function fe(de,Pe,Ae,je,j,z){let G=de-1,H=Pe-1;for(;G>=Ae&&H>=je;)j[G]===z[H]&&(ce[G]=H,G--),H--}function Q(de,Pe,Ae,je,j,z,G,H,te,ne,Oe){if(Pe[Ae]!==z[G])return Number.MIN_SAFE_INTEGER;let Be=1,He=!1;return G===Ae-je?Be=de[Ae]===j[G]?7:5:T(G,j,z)&&(G===0||!T(G-1,j,z))?(Be=de[Ae]===j[G]?7:5,He=!0):Ne(z,G)&&(G===0||!Ne(z,G-1))?Be=5:(Ne(z,G-1)||Te(z,G-1))&&(Be=5,He=!0),Be>1&&Ae===je&&(Oe[0]=!0),He||(He=T(G,j,z)||Ne(z,G-1)||Te(z,G-1)),Ae===je?G>te&&(Be-=He?3:5):ne?Be+=He?2:0:Be+=He?0:1,G+1===H&&(Be-=He?3:5),Be}function x(de,Pe,Ae,je,j,z,G){return ae(de,Pe,Ae,je,j,z,!0,G)}function le(de,Pe,Ae,je,j,z,G){return ae(de,Pe,Ae,je,j,z,!1,G)}function ae(de,Pe,Ae,je,j,z,G,H){let te=$e(de,Pe,Ae,je,j,z,H);if(te&&!G)return te;if(de.length>=3){const ne=Math.min(7,de.length-1);for(let Oe=Ae+1;Oe<ne;Oe++){const Be=Fe(de,Oe);if(Be){const He=$e(Be,Be.toLowerCase(),Ae,je,j,z,H);He&&(He[0]-=3,(!te||He[0]>te[0])&&(te=He))}}}return te}function Fe(de,Pe){if(Pe+1>=de.length)return;const Ae=de[Pe],je=de[Pe+1];if(Ae!==je)return de.slice(0,Pe)+je+Ae+de.slice(Pe+2)}}),define(ke[32],Se([1,0,13]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(O||(O={})),function(R){const F="error",M="warning",p="warn",m="info",D="ignore";function N(d){return d?C.$Bf(F,d)?R.Error:C.$Bf(M,d)||C.$Bf(p,d)?R.Warning:C.$Bf(m,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=N;function S(d){switch(d){case R.Error:return F;case R.Warning:return M;case R.Info:return m;default:return D}}R.toString=S}(O||(O={})),e.default=O}),define(ke[136],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ke[54],Se([1,0,18,13]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class R{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const f=v.charCodeAt(0),s=this.b.charCodeAt(this.c);return f-s}value(){return this.b[this.c]}}e.$Ci=R;class F{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,O.$vf)(v,this.b,0,v.length,this.c,this.d):(0,O.$xf)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=F;class M{constructor(v=!0,f=!0){this.f=v,this.g=f}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let f=v.length-1;f>=0;f--,this.c--){const s=this.b.charCodeAt(f);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,O.$vf)(v,this.b,0,v.length,this.d,this.e):(0,O.$xf)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=M;var p;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(p||(p={}));class m{constructor(v,f){this.f=v,this.g=f,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,O.$wf)(v,this.c.scheme);if(this.d[this.e]===2)return(0,O.$wf)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,O.$uf)(v,this.c.query);if(this.d[this.e]===5)return(0,O.$uf)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fi=m;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(N||(N={}));class S{static forUris(v=()=>!1,f=()=>!1){return new S(new m(v,f))}static forPaths(v=!1){return new S(new M(void 0,!v))}static forStrings(){return new S(new R)}static forConfigKeys(){return new S(new F)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,f){if(f){const s=f.slice(0);(0,C.$Wb)(s);for(const r of s)this.set(r,v)}else{const s=v.slice(0);(0,C.$Wb)(s);for(const r of s)this.set(r[0],r[1])}}set(v,f){const s=this.b.reset(v);let r;this.c||(this.c=new D,this.c.segment=s.value());const o=[];for(r=this.c;;){const t=s.cmp(r.segment);if(t>0)r.left||(r.left=new D,r.left.segment=s.value()),o.push([-1,r]),r=r.left;else if(t<0)r.right||(r.right=new D,r.right.segment=s.value()),o.push([1,r]),r=r.right;else if(s.hasNext())s.next(),r.mid||(r.mid=new D,r.mid.segment=s.value()),o.push([0,r]),r=r.mid;else break}const n=r.value;r.value=f,r.key=v;for(let t=o.length-1;t>=0;t--){const c=o[t][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const i=o[t][0],w=o[t+1][0];if(i===1&&w===1)o[t][1]=c.rotateLeft();else if(i===-1&&w===-1)o[t][1]=c.rotateRight();else if(i===1&&w===-1)c.right=o[t+1][1]=o[t+1][1].rotateRight(),o[t][1]=c.rotateLeft();else if(i===-1&&w===1)c.left=o[t+1][1]=o[t+1][1].rotateLeft(),o[t][1]=c.rotateRight();else throw new Error;if(t>0)switch(o[t-1][0]){case-1:o[t-1][1].left=o[t][1];break;case 1:o[t-1][1].right=o[t][1];break;case 0:o[t-1][1].mid=o[t][1];break}else this.c=o[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const f=this.b.reset(v);let s=this.c;for(;s;){const r=f.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(f.hasNext())f.next(),s=s.mid;else break}return s}has(v){const f=this.d(v);return!(f?.value===void 0&&f?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,f){const s=this.b.reset(v),r=[];let o=this.c;for(;o;){const n=s.cmp(o.segment);if(n>0)r.push([-1,o]),o=o.left;else if(n<0)r.push([1,o]),o=o.right;else if(s.hasNext())s.next(),r.push([0,o]),o=o.mid;else break}if(o){if(f?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:t,value:c,segment:u}=n;this.e(n.key,!1),o.key=t,o.value=c,o.segment=u}}else{const n=o.left??o.right;if(r.length>0){const[t,c]=r[r.length-1];switch(t){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=r.length-1;n>=0;n--){const t=r[n][1];t.updateHeight();const c=t.balanceFactor();if(c>1?(t.right.balanceFactor()>=0||(t.right=t.right.rotateRight()),r[n][1]=t.rotateLeft()):c<-1&&(t.left.balanceFactor()<=0||(t.left=t.left.rotateLeft()),r[n][1]=t.rotateRight()),n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this.c=r[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const f=this.b.reset(v);let s=this.c,r;for(;s;){const o=f.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(f.hasNext())f.next(),r=s.value||r,s=s.mid;else break}return s&&s.value||r}findSuperstr(v){return this.g(v,!1)}g(v,f){const s=this.b.reset(v);let r=this.c;for(;r;){const o=s.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(s.hasNext())s.next(),r=r.mid;else return r.mid?this.h(r.mid):f?r.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[f,s]of this)v(s,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const f=[];return this.j(v,f),f[Symbol.iterator]()}j(v,f){v&&(v.left&&this.j(v.left,f),v.value&&f.push([v.key,v.value]),v.mid&&this.j(v.mid,f),v.right&&this.j(v.right,f))}_isBalanced(){const v=f=>{if(!f)return!0;const s=f.balanceFactor();return s<-1||s>1?!1:v(f.left)&&v(f.right)};return v(this.c)}}e.$Gi=S}),define(ke[36],Se([1,0,92]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=R;var O;(function(M){function p(m){return m&&typeof m=="object"&&typeof m.id=="string"}M.isThemeColor=p})(O||(e.ThemeColor=O={}));function R(M){return{id:M}}var F;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function m(n){const t=p.exec(n.id);if(!t)return m(C.$Zj.error);const[,c,u]=t,i=["codicon","codicon-"+c];return u&&i.push("codicon-modifier-"+u.substring(1)),i}M.asClassNameArray=m;function D(n){return m(n).join(" ")}M.asClassName=D;function N(n){return"."+m(n).join(".")}M.asCSSSelector=N;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}M.isThemeIcon=S;const d=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function v(n){const t=d.exec(n);if(!t)return;const[,c]=t;return{id:c}}M.fromString=v;function f(n){return{id:n}}M.fromId=f;function s(n,t){let c=n.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),t&&(c=`${c}~${t}`),{id:c}}M.modify=s;function r(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}M.getModifier=r;function o(n,t){return n.id===t.id&&n.color?.id===t.color?.id}M.isEqual=o})(F||(e.ThemeIcon=F={}))}),define(ke[137],Se([1,0,135,13,36]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=m,e.$Sk=N,e.$Tk=d,e.$Uk=v,e.$Vk=s,e.$Wk=r;const F="$(",M=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function m(o){return o.replace(p,(n,t)=>t?n:`\\${n}`)}const D=new RegExp(`\\\\${M.source}`,"g");function N(o){return o.replace(D,n=>`\\${n}`)}const S=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function d(o){return o.indexOf(F)===-1?o:o.replace(S,(n,t,c,u)=>c?n:t||u||"")}function v(o){return o?o.replace(/\$\((.*?)\)/g,(n,t)=>` ${t} `).trim():""}const f=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(o){f.lastIndex=0;let n="";const t=[];let c=0;for(;;){const u=f.lastIndex,i=f.exec(o),w=o.substring(u,i?.index);if(w.length>0){n+=w;for(let a=0;a<w.length;a++)t.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:t}}function r(o,n,t=!1){const{text:c,iconOffsets:u}=n;if(!u||u.length===0)return(0,C.$Ik)(o,c,t);const i=(0,O.$if)(c," "),w=c.length-i.length,a=(0,C.$Ik)(o,i,t);if(a)for(const l of a){const g=u[l.start+w]+w;l.start+=g,l.end+=g}return a}}),define(ke[33],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=O;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(R){return C.test(R)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(p){for(let m=0;m<p.length;m++)p[m]=Math.floor(Math.random()*256);return p};const F=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){R(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let m=0,D="";return D+=M[F[m++]],D+=M[F[m++]],D+=M[F[m++]],D+=M[F[m++]],D+="-",D+=M[F[m++]],D+=M[F[m++]],D+="-",D+=M[F[m++]],D+=M[F[m++]],D+="-",D+=M[F[m++]],D+=M[F[m++]],D+="-",D+=M[F[m++]],D+=M[F[m++]],D+=M[F[m++]],D+=M[F[m++]],D+=M[F[m++]],D+=M[F[m++]],D}}()}),define(ke[138],Se([1,0,18,42,33]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=e.$cu=void 0,e.$au=F,e.$bu=M,e.$du=D;function F(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function M(S,d,v){const f={id:(0,R.$Wg)(),name:S,uri:d,data:v};return{asString:async()=>"",asFile:()=>f,value:void 0}}class p{constructor(){this.a=new Map}get size(){let d=0;for(const v of this.a)d++;return d}has(d){return this.a.has(this.b(d))}matches(d){const v=[...this.a.keys()];return O.Iterable.some(this,([f,s])=>s.asFile())&&v.push("files"),N(m(d),v)}get(d){return this.a.get(this.b(d))?.[0]}append(d,v){const f=this.a.get(d);f?f.push(v):this.a.set(this.b(d),[v])}replace(d,v){this.a.set(this.b(d),[v])}delete(d){this.a.delete(this.b(d))}*[Symbol.iterator](){for(const[d,v]of this.a)for(const f of v)yield[d,f]}b(d){return m(d)}}e.$cu=p;function m(S){return S.toLowerCase()}function D(S,d){return N(m(S),d.map(m))}function N(S,d){if(S==="*/*")return d.length>0;if(d.includes(S))return!0;const v=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[f,s,r]=v;return r==="*"?d.some(o=>o.startsWith(s+"/")):!1}e.$eu=Object.freeze({create:S=>(0,C.$Mb)(S.map(d=>d.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$eu.split(S).filter(d=>!d.startsWith("#"))})}),define(ke[139],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$ku=O;var C;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function O(R){let F=0,M=0,p=0,m=0;for(let D=0,N=R.length;D<N;D++){const S=R.charCodeAt(D);S===13?(F===0&&(M=D),F++,D+1<N&&R.charCodeAt(D+1)===10?(m|=2,D++):m|=3,p=D+1):S===10&&(m|=1,F===0&&(M=D),F++,p=D+1)}return F===0&&(M=R.length),[F,M,R.length-p,m]}}),define(ke[140],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$0s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[141],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hu=e.$Gu=e.IndentAction=void 0;var C;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class O{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let m=0,D=p.notIn.length;m<D;m++)switch(p.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,m){if(p.getTokenCount()===0)return!0;const D=p.findTokenIndexAtOffset(m-2),N=p.getStandardTokenType(D);return this.isOK(N)}g(p,m){for(let D=p;D<=m;D++){const N=String.fromCharCode(D);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Gu=O;class R{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of p)F(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),F(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),F(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),F(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&F(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$Hu=R;function F(M,p,m){M.has(p)?M.get(p).push(m):M.set(p,[m])}}),define(ke[142],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.NodeColor=e.$LC=void 0,e.$NC=R,e.$OC=F,e.$PC=D,e.$QC=N,e.$RC=S,e.$SC=d,e.$TC=v,e.$UC=f;class C{constructor(r,o){this.piece=r,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$MC)return R(this.right);let r=this;for(;r.parent!==e.$MC&&r.parent.left!==r;)r=r.parent;return r.parent===e.$MC?e.$MC:r.parent}prev(){if(this.left!==e.$MC)return F(this.left);let r=this;for(;r.parent!==e.$MC&&r.parent.right!==r;)r=r.parent;return r.parent===e.$MC?e.$MC:r.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$LC=C;var O;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$MC=new C(null,0),e.$MC.parent=e.$MC,e.$MC.left=e.$MC,e.$MC.right=e.$MC,e.$MC.color=0;function R(s){for(;s.left!==e.$MC;)s=s.left;return s}function F(s){for(;s.right!==e.$MC;)s=s.right;return s}function M(s){return s===e.$MC?0:s.size_left+s.piece.length+M(s.right)}function p(s){return s===e.$MC?0:s.lf_left+s.piece.lineFeedCnt+p(s.right)}function m(){e.$MC.parent=e.$MC}function D(s,r){const o=r.right;o.size_left+=r.size_left+(r.piece?r.piece.length:0),o.lf_left+=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),r.right=o.left,o.left!==e.$MC&&(o.left.parent=r),o.parent=r.parent,r.parent===e.$MC?s.root=o:r.parent.left===r?r.parent.left=o:r.parent.right=o,o.left=r,r.parent=o}function N(s,r){const o=r.left;r.left=o.right,o.right!==e.$MC&&(o.right.parent=r),o.parent=r.parent,r.size_left-=o.size_left+(o.piece?o.piece.length:0),r.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),r.parent===e.$MC?s.root=o:r===r.parent.right?r.parent.right=o:r.parent.left=o,o.right=r,r.parent=o}function S(s,r){let o,n;if(r.left===e.$MC?(n=r,o=n.right):r.right===e.$MC?(n=r,o=n.left):(n=R(r.right),o=n.right),n===s.root){s.root=o,o.color=0,r.detach(),m(),s.root.parent=e.$MC;return}const t=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===r?(o.parent=n.parent,f(s,o)):(n.parent===r?o.parent=n:o.parent=n.parent,f(s,o),n.left=r.left,n.right=r.right,n.parent=r.parent,n.color=r.color,r===s.root?s.root=n:r===r.parent.left?r.parent.left=n:r.parent.right=n,n.left!==e.$MC&&(n.left.parent=n),n.right!==e.$MC&&(n.right.parent=n),n.size_left=r.size_left,n.lf_left=r.lf_left,f(s,n)),r.detach(),o.parent.left===o){const u=M(o),i=p(o);if(u!==o.parent.size_left||i!==o.parent.lf_left){const w=u-o.parent.size_left,a=i-o.parent.lf_left;o.parent.size_left=u,o.parent.lf_left=i,v(s,o.parent,w,a)}}if(f(s,o.parent),t){m();return}let c;for(;o!==s.root&&o.color===0;)o===o.parent.left?(c=o.parent.right,c.color===1&&(c.color=0,o.parent.color=1,D(s,o.parent),c=o.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.right.color===0&&(c.left.color=0,c.color=1,N(s,c),c=o.parent.right),c.color=o.parent.color,o.parent.color=0,c.right.color=0,D(s,o.parent),o=s.root)):(c=o.parent.left,c.color===1&&(c.color=0,o.parent.color=1,N(s,o.parent),c=o.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,o=o.parent):(c.left.color===0&&(c.right.color=0,c.color=1,D(s,c),c=o.parent.left),c.color=o.parent.color,o.parent.color=0,c.left.color=0,N(s,o.parent),o=s.root));o.color=0,m()}function d(s,r){for(f(s,r);r!==s.root&&r.parent.color===1;)if(r.parent===r.parent.parent.left){const o=r.parent.parent.right;o.color===1?(r.parent.color=0,o.color=0,r.parent.parent.color=1,r=r.parent.parent):(r===r.parent.right&&(r=r.parent,D(s,r)),r.parent.color=0,r.parent.parent.color=1,N(s,r.parent.parent))}else{const o=r.parent.parent.left;o.color===1?(r.parent.color=0,o.color=0,r.parent.parent.color=1,r=r.parent.parent):(r===r.parent.left&&(r=r.parent,N(s,r)),r.parent.color=0,r.parent.parent.color=1,D(s,r.parent.parent))}s.root.color=0}function v(s,r,o,n){for(;r!==s.root&&r!==e.$MC;)r.parent.left===r&&(r.parent.size_left+=o,r.parent.lf_left+=n),r=r.parent}function f(s,r){let o=0,n=0;if(r!==s.root){for(;r!==s.root&&r===r.parent.right;)r=r.parent;if(r!==s.root)for(r=r.parent,o=M(r.left)-r.size_left,n=p(r.left)-r.lf_left,r.size_left+=o,r.lf_left+=n;r!==s.root&&(o!==0||n!==0);)r.parent.left===r&&(r.parent.size_left+=o,r.parent.lf_left+=n),r=r.parent}}}),define(ke[93],Se([1,0,94,30,95,142,96]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=e.$5C=e.$4C=void 0,e.$2C=N,e.$3C=S;const p=65535;function m(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class D{constructor(n,t,c,u,i){this.lineStarts=n,this.cr=t,this.lf=c,this.crlf=u,this.isBasicASCII=i}}function N(o,n=!0){const t=[0];let c=1;for(let u=0,i=o.length;u<i;u++){const w=o.charCodeAt(u);w===13?u+1<i&&o.charCodeAt(u+1)===10?(t[c++]=u+2,u++):t[c++]=u+1:w===10&&(t[c++]=u+1)}return n?m(t):t}function S(o,n){o.length=0,o[0]=0;let t=1,c=0,u=0,i=0,w=!0;for(let l=0,g=n.length;l<g;l++){const $=n.charCodeAt(l);$===13?l+1<g&&n.charCodeAt(l+1)===10?(i++,o[t++]=l+2,l++):(c++,o[t++]=l+1):$===10?(u++,o[t++]=l+1):w&&$!==9&&($<32||$>126)&&(w=!1)}const a=new D(m(o),c,u,i,w);return o.length=0,a}class d{constructor(n,t,c,u,i){this.bufferIndex=n,this.start=t,this.end=c,this.lineFeedCnt=u,this.length=i}}e.$4C=d;class v{constructor(n,t){this.buffer=n,this.lineStarts=t}}e.$5C=v;class f{constructor(n,t){this.a=[],this.c=n,this.d=t,this.b=0,n.root!==F.$MC&&n.iterate(n.root,c=>(c!==F.$MC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(n){this.a=n,this.b=[]}get(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let t=!1;const c=this.b;for(let u=0;u<c.length;u++){const i=c[u];if(i.node.parent===null||i.nodeStartOffset>=n){c[u]=null,t=!0;continue}}if(t){const u=[];for(const i of c)i!==null&&u.push(i);this.b=u}}}class r{constructor(n,t,c){this.create(n,t,c)}create(n,t,c){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=F.$MC,this.b=1,this.c=0,this.d=t,this.e=t.length,this.f=c;let u=null;for(let i=0,w=n.length;i<w;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=N(n[i].buffer));const a=new d(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),u=this.S(u,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const t=p,c=t-Math.floor(t/3),u=c*2;let i="",w=0;const a=[];if(this.iterate(this.root,l=>{const g=this.R(l),$=g.length;if(w<=c||w+$<u)return i+=g,w+=$,!0;const b=i.replace(/\r\n|\r|\n/g,n);return a.push(new v(b,N(b))),i=g,w=$,!0}),w>0){const l=i.replace(/\r\n|\r|\n/g,n);a.push(new v(l,N(l)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new f(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let t=0;return this.iterate(this.root,u=>{if(u===F.$MC)return!0;const i=this.R(u),w=i.length,a=n.G(t),l=n.G(t+w),g=n.getValueInRange2(a,l);return t+=w,i===g})}getOffsetAt(n,t){let c=0,u=this.root;for(;u!==F.$MC;)if(u.left!==F.$MC&&u.lf_left+1>=n)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=n){c+=u.size_left;const i=this.B(u,n-u.lf_left-2);return c+=i+t-1}else n-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let t=this.root,c=0;const u=n;for(;t!==F.$MC;)if(t.size_left!==0&&t.size_left>=n)t=t.left;else if(t.size_left+t.piece.length>=n){const i=this.A(t,n-t.size_left);if(c+=t.lf_left+i.index,i.index===0){const w=this.getOffsetAt(c+1,1),a=u-w;return new C.$zt(c+1,a+1)}return new C.$zt(c+1,i.remainder+1)}else if(n-=t.size_left+t.piece.length,c+=t.lf_left+t.piece.lineFeedCnt,t.right===F.$MC){const i=this.getOffsetAt(c+1,1),w=u-n-i;return new C.$zt(c+1,w+1)}else t=t.right;return new C.$zt(1,1)}getValueInRange(n,t){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),u=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,u);return t?t!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,t):t===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,t):i}getValueInRange2(n,t){if(n.node===t.node){const a=n.node,l=this.a[a.piece.bufferIndex].buffer,g=this.u(a.piece.bufferIndex,a.piece.start);return l.substring(g+n.remainder,g+t.remainder)}let c=n.node;const u=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let w=u.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==F.$MC;){const a=this.a[c.piece.bufferIndex].buffer,l=this.u(c.piece.bufferIndex,c.piece.start);if(c===t.node){w+=a.substring(l,l+t.remainder);break}else w+=a.substr(l,c.piece.length);c=c.next()}return w}getLinesContent(){const n=[];let t=0,c="",u=!1;return this.iterate(this.root,i=>{if(i===F.$MC)return!0;const w=i.piece;let a=w.length;if(a===0)return!0;const l=this.a[w.bufferIndex].buffer,g=this.a[w.bufferIndex].lineStarts,$=w.start.line,b=w.end.line;let y=g[$]+w.start.column;if(u&&(l.charCodeAt(y)===10&&(y++,a--),n[t++]=c,c="",u=!1,a===0))return!0;if($===b)return!this.f&&l.charCodeAt(y+a-1)===13?(u=!0,c+=l.substr(y,a-1)):c+=l.substr(y,a),!0;c+=this.f?l.substring(y,Math.max(y,g[$+1]-this.e)):l.substring(y,g[$+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;for(let h=$+1;h<b;h++)c=this.f?l.substring(g[h],g[h+1]-this.e):l.substring(g[h],g[h+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;return!this.f&&l.charCodeAt(g[b]+w.end.column-1)===13?(u=!0,w.end.column===0?t--:c=l.substr(g[b],w.end.column-1)):c=l.substr(g[b],w.end.column),!0}),u&&(n[t++]=c,c=""),n[t++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t)return 0;const c=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start);return c.buffer.charCodeAt(u)}else{const t=this.a[n.node.piece.bufferIndex],u=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return t.buffer.charCodeAt(u)}}getLineCharCode(n,t){const c=this.H(n,t+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const t=this.getOffsetAt(n,1);return this.getLength()-t}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const t=this.G(n);return this.l(t)}findMatchesInNode(n,t,c,u,i,w,a,l,g,$,b){const y=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,i),k=this.u(n.piece.bufferIndex,w);let I;const P={line:0,column:0};let V,W;t._wordSeparators?(V=y.buffer.substring(E,k),W=q=>q+E,t.reset(0)):(V=y.buffer,W=q=>q,t.reset(E));do if(I=t.next(V),I){if(W(I.index)>=k)return $;this.s(n,W(I.index)-h,P);const q=this.t(n.piece.bufferIndex,i,P),A=P.line===i.line?P.column-i.column+u:P.column+1,U=A+I[0].length;if(b[$++]=(0,M.$XC)(new O.$At(c+q,A,c+q,U),I,l),W(I.index)+I[0].length>=k||$>=g)return $}while(I);return $}findMatchesLineByLine(n,t,c,u){const i=[];let w=0;const a=new M.$1C(t.wordSeparators,t.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const g=this.H(n.endLineNumber,n.endColumn);if(g===null)return[];let $=this.s(l.node,l.remainder);const b=this.s(g.node,g.remainder);if(l.node===g.node)return this.findMatchesInNode(l.node,a,n.startLineNumber,n.startColumn,$,b,t,c,u,w,i),i;let y=n.startLineNumber,h=l.node;for(;h!==g.node;){const k=this.t(h.piece.bufferIndex,$,h.piece.end);if(k>=1){const P=this.a[h.piece.bufferIndex].lineStarts,V=this.u(h.piece.bufferIndex,h.piece.start),W=P[$.line+k],q=y===n.startLineNumber?n.startColumn:1;if(w=this.findMatchesInNode(h,a,y,q,$,this.s(h,W-V),t,c,u,w,i),w>=u)return i;y+=k}const I=y===n.startLineNumber?n.startColumn-1:0;if(y===n.endLineNumber){const P=this.getLineContent(y).substring(I,n.endColumn-1);return w=this.n(t,a,P,n.endLineNumber,I,w,i,c,u),i}if(w=this.n(t,a,this.getLineContent(y).substr(I),y,I,w,i,c,u),w>=u)return i;y++,l=this.H(y,1),h=l.node,$=this.s(l.node,l.remainder)}if(y===n.endLineNumber){const k=y===n.startLineNumber?n.startColumn-1:0,I=this.getLineContent(y).substring(k,n.endColumn-1);return w=this.n(t,a,I,n.endLineNumber,k,w,i,c,u),i}const E=y===n.startLineNumber?n.startColumn:1;return w=this.findMatchesInNode(g.node,a,y,E,$,b,t,c,u,w,i),i}n(n,t,c,u,i,w,a,l,g){const $=n.wordSeparators;if(!l&&n.simpleSearch){const y=n.simpleSearch,h=y.length,E=c.length;let k=-h;for(;(k=c.indexOf(y,k+h))!==-1;)if((!$||(0,M.$ZC)($,c,E,k,h))&&(a[w++]=new R.$1v(new O.$At(u,k+1+i,u,k+1+h+i),null),w>=g))return w;return w}let b;t.reset(0);do if(b=t.next(c),b&&(a[w++]=(0,M.$XC)(new O.$At(u,b.index+1+i,u,b.index+1+b[0].length+i),b,l),w>=g))return w;while(b);return w}insert(n,t,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==F.$MC){const{node:u,remainder:i,nodeStartOffset:w}=this.G(n),a=u.piece,l=a.bufferIndex,g=this.s(u,i);if(u.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&w+a.length===n&&t.length<p){this.F(u,t),this.y();return}if(w===n)this.o(t,u),this.h.validate(n);else if(w+u.piece.length>n){const $=[];let b=new d(a.bufferIndex,g,a.end,this.t(a.bufferIndex,g,a.end),this.u(l,a.end)-this.u(l,g));if(this.K()&&this.M(t)&&this.I(u,i)===10){const k={line:b.start.line+1,column:0};b=new d(b.bufferIndex,k,b.end,this.t(b.bufferIndex,k,b.end),b.length-1),t+=`
`}if(this.K()&&this.L(t))if(this.I(u,i-1)===13){const k=this.s(u,i-1);this.C(u,k),t="\r"+t,u.piece.length===0&&$.push(u)}else this.C(u,g);else this.C(u,g);const y=this.w(t);b.length>0&&this.S(u,b);let h=u;for(let E=0;E<y.length;E++)h=this.S(h,y[E]);this.v($)}else this.q(t,u)}else{const u=this.w(t);let i=this.T(null,u[0]);for(let w=1;w<u.length;w++)i=this.S(i,u[w])}this.y()}delete(n,t){if(this.j.lineNumber=0,this.j.value="",t<=0||this.root===F.$MC)return;const c=this.G(n),u=this.G(n+t),i=c.node,w=u.node;if(i===w){const y=this.s(i,c.remainder),h=this.s(i,u.remainder);if(c.nodeStartOffset===n){if(t===i.piece.length){const E=i.next();(0,F.$RC)(this,i),this.N(E),this.y();return}this.D(i,h),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+t){this.C(i,y),this.O(i),this.y();return}this.E(i,y,h),this.y();return}const a=[],l=this.s(i,c.remainder);this.C(i,l),this.h.validate(n),i.piece.length===0&&a.push(i);const g=this.s(w,u.remainder);this.D(w,g),w.piece.length===0&&a.push(w);const $=i.next();for(let y=$;y!==F.$MC&&y!==w;y=y.next())a.push(y);const b=i.piece.length===0?i.prev():i;this.v(a),this.O(b),this.y()}o(n,t){const c=[];if(this.K()&&this.M(n)&&this.L(t)){const w=t.piece,a={line:w.start.line+1,column:0},l=new d(w.bufferIndex,a,w.end,this.t(w.bufferIndex,a,w.end),w.length-1);t.piece=l,n+=`
`,(0,F.$TC)(this,t,-1,-1),t.piece.length===0&&c.push(t)}const u=this.w(n);let i=this.T(t,u[u.length-1]);for(let w=u.length-2;w>=0;w--)i=this.T(i,u[w]);this.N(i),this.v(c)}q(n,t){this.Q(n,t)&&(n+=`
`);const c=this.w(n),u=this.S(t,c[0]);let i=u;for(let w=1;w<c.length;w++)i=this.S(i,c[w]);this.N(u)}s(n,t,c){const u=n.piece,i=n.piece.bufferIndex,w=this.a[i].lineStarts,l=w[u.start.line]+u.start.column+t;let g=u.start.line,$=u.end.line,b=0,y=0,h=0;for(;g<=$&&(b=g+($-g)/2|0,h=w[b],b!==$);)if(y=w[b+1],l<h)$=b-1;else if(l>=y)g=b+1;else break;return c?(c.line=b,c.column=l-h,null):{line:b,column:l-h}}t(n,t,c){if(c.column===0)return c.line-t.line;const u=this.a[n].lineStarts;if(c.line===u.length-1)return c.line-t.line;const i=u[c.line+1],w=u[c.line]+c.column;if(i>w+1)return c.line-t.line;const a=w-1;return this.a[n].buffer.charCodeAt(a)===13?c.line-t.line+1:c.line-t.line}u(n,t){return this.a[n].lineStarts[t.line]+t.column}v(n){for(let t=0;t<n.length;t++)(0,F.$RC)(this,n[t])}w(n){if(n.length>p){const $=[];for(;n.length>p;){const y=n.charCodeAt(p-1);let h;y===13||y>=55296&&y<=56319?(h=n.substring(0,p-1),n=n.substring(p-1)):(h=n.substring(0,p),n=n.substring(p));const E=N(h);$.push(new d(this.a.length,{line:0,column:0},{line:E.length-1,column:h.length-E[E.length-1]},E.length-1,h.length)),this.a.push(new v(h,E))}const b=N(n);return $.push(new d(this.a.length,{line:0,column:0},{line:b.length-1,column:n.length-b[b.length-1]},b.length-1,n.length)),this.a.push(new v(n,b)),$}let t=this.a[0].buffer.length;const c=N(n,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===t&&t!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let $=0;$<c.length;$++)c[$]+=t+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,t+=1}else{if(t!==0)for(let $=0;$<c.length;$++)c[$]+=t;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,w=this.a[0].lineStarts.length-1,a=i-this.a[0].lineStarts[w],l={line:w,column:a},g=new d(0,u,l,this.t(0,u,l),i-t);return this.g=l,[g]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,t=0){let c=this.root,u="";const i=this.h.get2(n);if(i){c=i.node;const w=this.B(c,n-i.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,l=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)u=a.substring(l+w,l+c.piece.length);else{const g=this.B(c,n-i.nodeStartLineNumber);return a.substring(l+w,l+g-t)}}else{let w=0;const a=n;for(;c!==F.$MC;)if(c.left!==F.$MC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const l=this.B(c,n-c.lf_left-2),g=this.B(c,n-c.lf_left-1),$=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);return w+=c.size_left,this.h.set({node:c,nodeStartOffset:w,nodeStartLineNumber:a-(n-1-c.lf_left)}),$.substring(b+l,b+g-t)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const l=this.B(c,n-c.lf_left-2),g=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);u=g.substring($+l,$+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,w+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==F.$MC;){const w=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),l=this.u(c.piece.bufferIndex,c.piece.start);return u+=w.substring(l,l+a-t),u}else{const a=this.u(c.piece.bufferIndex,c.piece.start);u+=w.substr(a,c.piece.length)}c=c.next()}return u}y(){let n=this.root,t=1,c=0;for(;n!==F.$MC;)t+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=t,this.c=c,this.h.validate(this.c)}A(n,t){const c=n.piece,u=this.s(n,t),i=u.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===t){const w=this.t(n.piece.bufferIndex,c.start,u);if(w!==i)return{index:w,remainder:0}}return{index:i,remainder:u.column}}B(n,t){if(t<0)return 0;const c=n.piece,u=this.a[c.bufferIndex].lineStarts,i=c.start.line+t+1;return i>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[i]-u[c.start.line]-c.start.column}C(n,t){const c=n.piece,u=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),w=t,a=this.u(c.bufferIndex,w),l=this.t(c.bufferIndex,c.start,w),g=l-u,$=a-i,b=c.length+$;n.piece=new d(c.bufferIndex,c.start,w,l,b),(0,F.$TC)(this,n,$,g)}D(n,t){const c=n.piece,u=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),w=t,a=this.t(c.bufferIndex,w,c.end),l=this.u(c.bufferIndex,w),g=a-u,$=i-l,b=c.length+$;n.piece=new d(c.bufferIndex,w,c.end,a,b),(0,F.$TC)(this,n,$,g)}E(n,t,c){const u=n.piece,i=u.start,w=u.end,a=u.length,l=u.lineFeedCnt,g=t,$=this.t(u.bufferIndex,u.start,g),b=this.u(u.bufferIndex,t)-this.u(u.bufferIndex,i);n.piece=new d(u.bufferIndex,u.start,g,$,b),(0,F.$TC)(this,n,b-a,$-l);const y=new d(u.bufferIndex,c,w,this.t(u.bufferIndex,c,w),this.u(u.bufferIndex,w)-this.u(u.bufferIndex,c)),h=this.S(n,y);this.N(h)}F(n,t){this.Q(t,n)&&(t+=`
`);const c=this.K()&&this.L(t)&&this.M(n),u=this.a[0].buffer.length;this.a[0].buffer+=t;const i=N(t,!1);for(let h=0;h<i.length;h++)i[h]+=u;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const w=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[w],l={line:w,column:a},g=n.piece.length+t.length,$=n.piece.lineFeedCnt,b=this.t(0,n.piece.start,l),y=b-$;n.piece=new d(n.piece.bufferIndex,n.piece.start,l,b,g),this.g=l,(0,F.$TC)(this,n,t.length,y)}G(n){let t=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let u=0;for(;t!==F.$MC;)if(t.size_left>n)t=t.left;else if(t.size_left+t.piece.length>=n){u+=t.size_left;const i={node:t,remainder:n-t.size_left,nodeStartOffset:u};return this.h.set(i),i}else n-=t.size_left+t.piece.length,u+=t.size_left+t.piece.length,t=t.right;return null}H(n,t){let c=this.root,u=0;for(;c!==F.$MC;)if(c.left!==F.$MC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),w=this.B(c,n-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(i+t-1,w),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+t-1<=c.piece.length)return{node:c,remainder:i+t-1,nodeStartOffset:u};t-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==F.$MC;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),w=this.J(c);return{node:c,remainder:Math.min(t-1,i),nodeStartOffset:w}}else if(c.piece.length>=t-1){const i=this.J(c);return{node:c,remainder:t-1,nodeStartOffset:i}}else t-=c.piece.length;c=c.next()}return null}I(n,t){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],u=this.u(n.piece.bufferIndex,n.piece.start)+t;return c.buffer.charCodeAt(u)}J(n){if(!n)return 0;let t=n.size_left;for(;n!==this.root;)n.parent.right===n&&(t+=n.parent.size_left+n.parent.piece.length),n=n.parent;return t}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===F.$MC||n.piece.lineFeedCnt===0)return!1;const t=n.piece,c=this.a[t.bufferIndex].lineStarts,u=t.start.line,i=c[u]+t.start.column;return u===c.length-1||c[u+1]>i+1?!1:this.a[t.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===F.$MC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const t=n.prev();this.M(t)&&this.P(t,n)}}O(n){if(this.K()&&this.M(n)){const t=n.next();this.L(t)&&this.P(n,t)}}P(n,t){const c=[],u=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:u[n.piece.end.line]-u[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const w=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new d(n.piece.bufferIndex,n.piece.start,i,a,w),(0,F.$TC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const l={line:t.piece.start.line+1,column:0},g=t.piece.length-1,$=this.t(t.piece.bufferIndex,l,t.piece.end);t.piece=new d(t.piece.bufferIndex,l,t.piece.end,$,g),(0,F.$TC)(this,t,-1,-1),t.piece.length===0&&c.push(t);const b=this.w(`\r
`);this.S(n,b[0]);for(let y=0;y<c.length;y++)(0,F.$RC)(this,c[y])}Q(n,t){if(this.K()&&this.M(n)){const c=t.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,F.$RC)(this,c);else{const u=c.piece,i={line:u.start.line+1,column:0},w=u.length-1,a=this.t(u.bufferIndex,i,u.end);c.piece=new d(u.bufferIndex,i,u.end,a,w),(0,F.$TC)(this,c,-1,-1)}return!0}}return!1}iterate(n,t){if(n===F.$MC)return t(F.$MC);const c=this.iterate(n.left,t);return c&&t(n)&&this.iterate(n.right,t)}R(n){if(n===F.$MC)return"";const t=this.a[n.piece.bufferIndex],c=n.piece,u=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return t.buffer.substring(u,i)}getPieceContent(n){const t=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),u=this.u(n.bufferIndex,n.end);return t.buffer.substring(c,u)}S(n,t){const c=new F.$LC(t,1);if(c.left=F.$MC,c.right=F.$MC,c.parent=F.$MC,c.size_left=0,c.lf_left=0,this.root===F.$MC)this.root=c,c.color=0;else if(n.right===F.$MC)n.right=c,c.parent=n;else{const i=(0,F.$NC)(n.right);i.left=c,c.parent=i}return(0,F.$SC)(this,c),c}T(n,t){const c=new F.$LC(t,1);if(c.left=F.$MC,c.right=F.$MC,c.parent=F.$MC,c.size_left=0,c.lf_left=0,this.root===F.$MC)this.root=c,c.color=0;else if(n.left===F.$MC)n.left=c,c.parent=n;else{const u=(0,F.$OC)(n.left);u.right=c,c.parent=u}return(0,F.$SC)(this,c),c}U(n){let t="";return this.iterate(n,c=>(t+=this.R(c),!0)),t}}e.$6C=r}),define(ke[143],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0=e.$W0=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const M=this.a.get(F);return this.a.delete(F),M}}addDragOperationTransfer(F,M){this.a.set(F,M)}}e.$W0=C;class O{constructor(F){this.identifier=F}}e.$X0=O}),define(ke[144],Se([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(ke[145],Se([1,0,5,6,144]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=N;class F extends O.$Uc{constructor(d,v="",f="",s=!0,r){super(),this.j=this.B(new C.$he),this.onDidChange=this.j.event,this.z=!0,this.m=d,this.n=v,this.w=f,this.z=s,this.D=r}get id(){return this.m}get label(){return this.n}set label(d){this.F(d)}F(d){this.n!==d&&(this.n=d,this.j.fire({label:d}))}get tooltip(){return this.u||""}set tooltip(d){this.G(d)}G(d){this.u!==d&&(this.u=d,this.j.fire({tooltip:d}))}get class(){return this.w}set class(d){this.H(d)}H(d){this.w!==d&&(this.w=d,this.j.fire({class:d}))}get enabled(){return this.z}set enabled(d){this.I(d)}I(d){this.z!==d&&(this.z=d,this.j.fire({enabled:d}))}get checked(){return this.C}set checked(d){this.J(d)}J(d){this.C!==d&&(this.C=d,this.j.fire({checked:d}))}async run(d,v){this.D&&await this.D(d)}}e.$fj=F;class M extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new C.$he),this.onWillRun=this.f.event,this.m=this.B(new C.$he),this.onDidRun=this.m.event}async run(d,v){if(!d.enabled)return;this.f.fire({action:d});let f;try{await this.u(d,v)}catch(s){f=s}this.m.fire({action:d,error:f})}async u(d,v){await d.run(v)}}e.$gj=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...d){let v=[];for(const f of d)f.length&&(v.length?v=[...v,new p,...f]:v=f);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$hj=p;class m{get actions(){return this.a}constructor(d,v,f,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=d,this.label=v,this.class=s,this.a=f}async run(){}}e.$ij=m;class D extends F{static{this.ID="vs.actions.empty"}constructor(){super(D.ID,R.localize(0,null),void 0,!1)}}e.$jj=D;function N(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...d)=>S.run(...d),tooltip:S.label}}}),define(ke[146],Se([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(ke[147],Se([1,0,146]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=D,e.$7m=N,e.$8m=S;const O=60,R=O*60,F=R*24,M=F*7,p=F*30,m=F*365;function D(d,v,f,s){typeof d!="number"&&(d=d.getTime());const r=Math.round((new Date().getTime()-d)/1e3);if(r<-30)return(0,C.localize)(0,null,D(new Date().getTime()+r*1e3,!1));if(!s&&r<30)return(0,C.localize)(1,null);let o;return r<O?(o=r,v?o===1?f?(0,C.localize)(2,null,o):(0,C.localize)(3,null,o):f?(0,C.localize)(4,null,o):(0,C.localize)(5,null,o):o===1?f?(0,C.localize)(6,null,o):(0,C.localize)(7,null,o):f?(0,C.localize)(8,null,o):(0,C.localize)(9,null,o)):r<R?(o=Math.floor(r/O),v?o===1?f?(0,C.localize)(10,null,o):(0,C.localize)(11,null,o):f?(0,C.localize)(12,null,o):(0,C.localize)(13,null,o):o===1?f?(0,C.localize)(14,null,o):(0,C.localize)(15,null,o):f?(0,C.localize)(16,null,o):(0,C.localize)(17,null,o)):r<F?(o=Math.floor(r/R),v?o===1?f?(0,C.localize)(18,null,o):(0,C.localize)(19,null,o):f?(0,C.localize)(20,null,o):(0,C.localize)(21,null,o):o===1?f?(0,C.localize)(22,null,o):(0,C.localize)(23,null,o):f?(0,C.localize)(24,null,o):(0,C.localize)(25,null,o)):r<M?(o=Math.floor(r/F),v?o===1?(0,C.localize)(26,null,o):(0,C.localize)(27,null,o):o===1?(0,C.localize)(28,null,o):(0,C.localize)(29,null,o)):r<p?(o=Math.floor(r/M),v?o===1?f?(0,C.localize)(30,null,o):(0,C.localize)(31,null,o):f?(0,C.localize)(32,null,o):(0,C.localize)(33,null,o):o===1?f?(0,C.localize)(34,null,o):(0,C.localize)(35,null,o):f?(0,C.localize)(36,null,o):(0,C.localize)(37,null,o)):r<m?(o=Math.floor(r/p),v?o===1?f?(0,C.localize)(38,null,o):(0,C.localize)(39,null,o):f?(0,C.localize)(40,null,o):(0,C.localize)(41,null,o):o===1?f?(0,C.localize)(42,null,o):(0,C.localize)(43,null,o):f?(0,C.localize)(44,null,o):(0,C.localize)(45,null,o)):(o=Math.floor(r/m),v?o===1?f?(0,C.localize)(46,null,o):(0,C.localize)(47,null,o):f?(0,C.localize)(48,null,o):(0,C.localize)(49,null,o):o===1?f?(0,C.localize)(50,null,o):(0,C.localize)(51,null,o):f?(0,C.localize)(52,null,o):(0,C.localize)(53,null,o))}function N(d,v){const f=Math.abs(d/1e3);return f<1?v?(0,C.localize)(54,null,d):(0,C.localize)(55,null,d):f<O?v?(0,C.localize)(56,null,Math.round(d)/1e3):(0,C.localize)(57,null,Math.round(d)/1e3):f<R?v?(0,C.localize)(58,null,Math.round(d/(1e3*O))):(0,C.localize)(59,null,Math.round(d/(1e3*O))):f<F?v?(0,C.localize)(60,null,Math.round(d/(1e3*R))):(0,C.localize)(61,null,Math.round(d/(1e3*R))):(0,C.localize)(62,null,Math.round(d/(1e3*F)))}function S(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[148],Se([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,18,15,148]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=m,e.$mj=D,e.$nj=N;function F(S,d){return d&&(S.stack||S.stacktrace)?R.localize(0,null,p(S),M(S.stack)||M(S.stacktrace)):p(S)}function M(S){return Array.isArray(S)?S.join(`
`):S}function p(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?R.localize(1,null,S.message):S.message||R.localize(2,null)}function m(S=null,d=!1){if(!S)return R.localize(3,null);if(Array.isArray(S)){const v=C.$Hb(S),f=m(v[0],d);return v.length>1?R.localize(4,null,f,v.length):f}if(O.$ag(S))return S;if(S.detail){const v=S.detail;if(v.error)return F(v.error,d);if(v.exception)return F(v.exception,d)}return S.stack?F(S,d):S.message?S.message:R.localize(5,null)}function D(S){const d=S;return d instanceof Error&&Array.isArray(d.actions)}function N(S,d){let v;return typeof S=="string"?v=new Error(S):v=S,v.actions=d,v}}),define(ke[149],Se([1,0,43,19]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=p,e.$nr=m,e.$or=D,e.$pr=N,e.$qr=S,e.$rr=d,e.$sr=v,e.$tr=f,e.$ur=s,e.$vr=r,e.$wr=g,e.$xr=$,e.$yr=b;const R=new C.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),F=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(y,h,E=!1){const k=y||"",I=h||"",P=R.value.collator.compare(k,I);return R.value.collatorIsNumeric&&P===0&&k!==I?k<I?-1:1:P}function m(y,h){const E=F.value.collator;return y=y||"",h=h||"",c(E,y,h)}function D(y,h){const E=F.value.collator;return y=y||"",h=h||"",a(y,h)||c(E,y,h)}function N(y,h){const E=F.value.collator;return y=y||"",h=h||"",w(y,h)||c(E,y,h)}function S(y,h){return y=y||"",h=h||"",y===h?0:y<h?-1:1}function d(y,h){const[E,k]=n(y),[I,P]=n(h);let V=R.value.collator.compare(k,P);if(V===0){if(R.value.collatorIsNumeric&&k!==P)return k<P?-1:1;if(V=R.value.collator.compare(E,I),R.value.collatorIsNumeric&&V===0&&E!==I)return E<I?-1:1}return V}function v(y,h){y=y||"",h=h||"";const E=t(y),k=t(h),I=F.value.collator,P=M.value.collator;return c(P,E,k)||c(I,y,h)}function f(y,h){y=y||"",h=h||"";const E=t(y),k=t(h),I=F.value.collator,P=M.value.collator;return c(P,E,k)||a(y,h)||c(I,y,h)}function s(y,h){y=y||"",h=h||"";const E=t(y),k=t(h),I=F.value.collator,P=M.value.collator;return c(P,E,k)||w(y,h)||c(I,y,h)}function r(y,h){y=y||"",h=h||"";const E=t(y).toLowerCase(),k=t(h).toLowerCase();return E!==k?E<k?-1:1:y!==h?y<h?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(y,h=!1){const E=y?o.exec(y):[];let k=[E&&E[1]||"",E&&E[3]||""];return h&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function t(y){const h=y?o.exec(y):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(y,h,E){const k=y.compare(h,E);return k!==0?k:h.length!==E.length?h.length<E.length?-1:1:0}function u(y){const h=y.charAt(0);return h.toLocaleUpperCase()!==h}function i(y){const h=y.charAt(0);return h.toLocaleLowerCase()!==h}function w(y,h){return u(y)&&i(h)?-1:i(y)&&u(h)?1:0}function a(y,h){return i(y)&&u(h)?-1:u(y)&&i(h)?1:0}function l(y,h,E=!1){return E||(y=y&&y.toLowerCase(),h=h&&h.toLowerCase()),y===h?0:y<h?-1:1}function g(y,h,E=!1){const k=y.split(O.sep),I=h.split(O.sep),P=k.length-1,V=I.length-1;let W,q;for(let A=0;;A++){if(W=P===A,q=V===A,W&&q)return p(k[A],I[A],E);if(W)return-1;if(q)return 1;const U=l(k[A],I[A],E);if(U!==0)return U}}function $(y,h,E){const k=y.toLowerCase(),I=h.toLowerCase(),P=b(y,h,E);if(P)return P;const V=k.endsWith(E),W=I.endsWith(E);if(V!==W)return V?-1:1;const q=p(k,I);return q!==0?q:k.localeCompare(I)}function b(y,h,E){const k=y.toLowerCase(),I=h.toLowerCase(),P=k.startsWith(E),V=I.startsWith(E);if(P!==V)return P?-1:1;if(P&&V){if(k.length<I.length)return-1;if(k.length>I.length)return 1}return 0}}),define(ke[49],Se([1,0,19,23,13,15]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=M,e.$tg=p,e.$ug=m,e.$vg=D,e.$wg=N,e.$xg=f,e.$yg=s,e.$zg=r,e.$Ag=o,e.$Bg=n,e.$Cg=t,e.$Dg=c,e.$Eg=u,e.$Fg=i,e.$Gg=w,e.$Hg=a,e.$Ig=$;function M(b){return b===47||b===92}function p(b){return b.replace(/[\\/]/g,C.$gc.sep)}function m(b){return b.indexOf("/")===-1&&(b=p(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function D(b,y=C.$gc.sep){if(!b)return"";const h=b.length,E=b.charCodeAt(0);if(M(E)){if(M(b.charCodeAt(1))&&!M(b.charCodeAt(2))){let I=3;const P=I;for(;I<h&&!M(b.charCodeAt(I));I++);if(P!==I&&!M(b.charCodeAt(I+1))){for(I+=1;I<h;I++)if(M(b.charCodeAt(I)))return b.slice(0,I+1).replace(/[\\/]/g,y)}}return y}else if(o(E)&&b.charCodeAt(1)===58)return M(b.charCodeAt(2))?b.slice(0,2)+y:b.slice(0,2);let k=b.indexOf("://");if(k!==-1){for(k+=3;k<h;k++)if(M(b.charCodeAt(k)))return b.slice(0,k+1)}return""}function N(b){if(!O.$i||!b||b.length<5)return!1;let y=b.charCodeAt(0);if(y!==92||(y=b.charCodeAt(1),y!==92))return!1;let h=2;const E=h;for(;h<b.length&&(y=b.charCodeAt(h),y!==92);h++);return!(E===h||(y=b.charCodeAt(h+1),isNaN(y)||y===92))}const S=/[\\/:\*\?"<>\|]/g,d=/[/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(b,y=O.$i){const h=y?S:d;return!(!b||b.length===0||/^\s+$/.test(b)||(h.lastIndex=0,h.test(b))||y&&v.test(b)||b==="."||b===".."||y&&b[b.length-1]==="."||y&&b.length!==b.trim().length||b.length>255)}function s(b,y,h){const E=b===y;return!h||E?E:!b||!y?!1:(0,R.$Bf)(b,y)}function r(b,y,h,E=C.sep){if(b===y)return!0;if(!b||!y||y.length>b.length)return!1;if(h){if(!(0,R.$Cf)(b,y))return!1;if(y.length===b.length)return!0;let I=y.length;return y.charAt(y.length-1)===E&&I--,b.charAt(I)===E}return y.charAt(y.length-1)!==E&&(y+=E),b.indexOf(y)===0}function o(b){return b>=65&&b<=90||b>=97&&b<=122}function n(b,y){return O.$i&&b.endsWith(":")&&(b+=C.sep),(0,C.$ic)(b)||(b=(0,C.$jc)(y,b)),b=(0,C.$hc)(b),t(b)}function t(b){return O.$i?(b=(0,R.$jf)(b,C.sep),b.endsWith(":")&&(b+=C.sep)):(b=(0,R.$jf)(b,C.sep),b||(b=C.sep)),b}function c(b){const y=(0,C.$hc)(b);return O.$i?b.length>3?!1:u(y)&&(b.length===2||y.charCodeAt(2)===92):y===C.$gc.sep}function u(b,y=O.$i){return y?o(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function i(b,y=O.$i){return u(b,y)?b[0]:void 0}function w(b,y,h){return y.length>b.length?-1:b===y?0:(h&&(b=b.toLowerCase(),y=y.toLowerCase()),b.indexOf(y))}function a(b){const y=b.split(":");let h,E,k;for(const I of y){const P=Number(I);(0,F.$eg)(P)?E===void 0?E=P:k===void 0&&(k=P):h=h?[h,I].join(":"):I}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:E!==void 0?E:void 0,column:k!==void 0?k:E!==void 0?1:void 0}}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function $(b,y,h=8){let E="";for(let I=0;I<h;I++){let P;I===0&&O.$i&&!y&&(h===3||h===4)?P=g:P=l,E+=P.charAt(Math.floor(Math.random()*P.length))}let k;return y?k=`${y}-${E}`:k=E,b?(0,C.$jc)(b,k):k}}),define(ke[70],Se([1,0,19]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0,e.$Xs=F,e.$Ys=M,e.$Zs=p,e.$1s=D,e.$Ws=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(N){const S=(0,C.$oc)(N),d=O[S.toLowerCase()];return d!==void 0?d:M(N)}function M(N){const S=(0,C.$oc)(N);return R[S.toLowerCase()]}function p(N){for(const S in R)if(R[S]===N)return S}const m=/^(.+)\/(.+?)(;.+)?$/;function D(N,S){const d=m.exec(N);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:S?void 0:N}}),define(ke[45],Se([1,0,22,2]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=R,e.$9h=F,e.$0h=p;function R(m){return JSON.stringify(m,M)}function F(m){let D=JSON.parse(m);return D=p(D),D}function M(m,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:D.flags}:D}function p(m,D=0){if(!m||D>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return O.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof C.$Je||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let N=0;N<m.length;++N)m[N]=p(m[N],D+1);else for(const N in m)Object.hasOwnProperty.call(m,N)&&(m[N]=p(m[N],D+1))}return m}}),define(ke[16],Se([1,0,14,23,13,2,19]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=m,e.$Kg=D,e.$Og=S;var p;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(p||(e.Schemas=p={}));function m(f,s){return F.URI.isUri(f)?(0,R.$Bf)(f.scheme,s):(0,R.$Cf)(f,s+":")}function D(f,...s){return s.some(r=>m(f,r))}e.$Lg="vscode-tkn",e.$Mg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,r){this.f=S(s,r)}getServerRootPath(){return this.f}get g(){return M.$gc.join(this.f,p.vscodeRemoteResource)}set(s,r,o){this.a[s]=r,this.b[s]=o}setConnectionToken(s,r){this.c[s]=r}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(u){return C.$1(u),s}const r=s.authority;let o=this.a[r];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[r],t=this.c[r];let c=`path=${encodeURIComponent(s.path)}`;return typeof t=="string"&&(c+=`&${e.$Mg}=${encodeURIComponent(t)}`),F.URI.from({scheme:O.$o?this.d:p.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:c})}}e.$Ng=new N;function S(f,s){return M.$gc.join(s??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class d{static{this.a=e.$Tg}asBrowserUri(s){const r=this.b(s,he);return this.uriToBrowserUri(r)}uriToBrowserUri(s){return s.scheme===p.vscodeRemote?e.$Ng.rewrite(s):s.scheme===p.file&&(O.$m||O.$q===`${p.vscodeFileResource}://${d.a}`)?s.with({scheme:p.vscodeFileResource,authority:s.authority||d.a,query:null,fragment:null}):s}asFileUri(s){const r=this.b(s,he);return this.uriToFileUri(r)}uriToFileUri(s){return s.scheme===p.vscodeFileResource?s.with({scheme:p.file,authority:s.authority!==d.a?s.authority:null,query:null,fragment:null}):s}b(s,r){return F.URI.isUri(s)?s:F.URI.parse(r.toUrl(s))}}e.$Ug=new d;var v;(function(f){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(s.get("3"));const r="vscode-coi";function o(t){let c;typeof t=="string"?c=new URL(t).searchParams:t instanceof URL?c=t.searchParams:F.URI.isUri(t)&&(c=new URL(t.toString(!0)).searchParams);const u=c?.get(r);if(u)return s.get(u)}f.getHeadersFromQuery=o;function n(t,c,u){if(!globalThis.crossOriginIsolated)return;const i=c&&u?"3":u?"2":"1";t instanceof URLSearchParams?t.set(r,i):t[r]=i}f.addSearchParam=n})(v||(e.COI=v={}))}),define(ke[24],Se([1,0,49,16,19,23,13,2]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=m,e.$kh=N,e.$lh=d;function m(v){return(0,p.$wc)(v,!0)}class D{constructor(f){this.a=f}compare(f,s,r=!1){return f===s?0:(0,M.$uf)(this.getComparisonKey(f,r),this.getComparisonKey(s,r))}isEqual(f,s,r=!1){return f===s?!0:!f||!s?!1:this.getComparisonKey(f,r)===this.getComparisonKey(s,r)}getComparisonKey(f,s=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,s,r=!1){if(f.scheme===s.scheme){if(f.scheme===O.Schemas.file)return C.$zg(m(f),m(s),this.a(f))&&f.query===s.query&&(r||f.fragment===s.fragment);if((0,e.$gh)(f.authority,s.authority))return C.$zg(f.path,s.path,this.a(f),"/")&&f.query===s.query&&(r||f.fragment===s.fragment)}return!1}joinPath(f,...s){return p.URI.joinPath(f,...s)}basenameOrAuthority(f){return(0,e.$$g)(f)||f.authority}basename(f){return R.$gc.basename(f.path)}extname(f){return R.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let s;return f.scheme===O.Schemas.file?s=p.URI.file(R.$mc(m(f))).path:(s=R.$gc.dirname(f.path),f.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),s="/")),f.with({path:s})}normalizePath(f){if(!f.path.length)return f;let s;return f.scheme===O.Schemas.file?s=p.URI.file(R.$hc(m(f))).path:s=R.$gc.normalize(f.path),f.with({path:s})}relativePath(f,s){if(f.scheme!==s.scheme||!(0,e.$gh)(f.authority,s.authority))return;if(f.scheme===O.Schemas.file){const n=R.$lc(m(f),m(s));return F.$i?C.$tg(n):n}let r=f.path||"/";const o=s.path||"/";if(this.a(f)){let n=0;for(const t=Math.min(r.length,o.length);n<t&&!(r.charCodeAt(n)!==o.charCodeAt(n)&&r.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);r=o.substr(0,n)+r.substr(n)}return R.$gc.relative(r,o)}resolvePath(f,s){if(f.scheme===O.Schemas.file){const r=p.URI.file(R.$kc(m(f),s));return f.with({authority:r.authority,path:r.path})}return s=C.$ug(s),f.with({path:R.$gc.resolve(f.path,s)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,s){return f===s||f!==void 0&&s!==void 0&&(0,M.$Bf)(f,s)}hasTrailingPathSeparator(f,s=R.sep){if(f.scheme===O.Schemas.file){const r=m(f);return r.length>C.$vg(r).length&&r[r.length-1]===s}else{const r=f.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,s=R.sep){return(0,e.$hh)(f,s)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,s=R.sep){let r=!1;if(f.scheme===O.Schemas.file){const o=m(f);r=o!==void 0&&o.length===C.$vg(o).length&&o[o.length-1]===s}else{s="/";const o=f.path;r=o.length===1&&o.charCodeAt(o.length-1)===47}return!r&&!(0,e.$hh)(f,s)?f.with({path:f.path+"/"}):f}}e.$3g=D,e.$4g=new D(()=>!1),e.$5g=new D(v=>v.scheme===O.Schemas.file?!F.$k:!0),e.$6g=new D(v=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function N(v,f){const s=[];for(let r=0;r<v.length;r++){const o=f(v[r]);v.some((n,t)=>t===r?!1:(0,e.$8g)(o,f(n)))||s.push(v[r])}return s}var S;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function f(s){const r=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(t=>{const[c,u]=t.split(":");c&&u&&r.set(c,u)});const n=s.path.substring(0,s.path.indexOf(";"));return n&&r.set(v.META_DATA_MIME,n),r}v.parseMetaData=f})(S||(e.DataUri=S={}));function d(v,f,s){if(f){let r=v.path;return r&&r[0]!==R.$gc.sep&&(r=R.$gc.sep+r),v.with({scheme:s,authority:f,path:r})}return v.with({scheme:s})}}),define(ke[11],Se([1,0,20,14,5,6,24,23,136,43]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=N,e.$nh=S,e.$oh=d,e.$ph=v,e.$qh=f,e.$rh=s,e.$sh=r,e.$th=o,e.$Bh=$,e.$Ch=b,e.$Dh=y,e.$Eh=h,e.$Fh=E,e.$Uh=Ee,e.$3h=ye;function N(fe){return!!fe&&typeof fe.then=="function"}function S(fe){const Q=new C.$se,x=fe(Q.token),le=new Promise((ae,Fe)=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Fe(new O.$5)});Promise.resolve(x).then(Pe=>{de.dispose(),Q.dispose(),ae(Pe)},Pe=>{de.dispose(),Q.dispose(),Fe(Pe)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ae,Fe){return le.then(ae,Fe)}catch(ae){return this.then(void 0,ae)}finally(ae){return le.finally(ae)}}}function d(fe,Q,x){return new Promise((le,ae)=>{const Fe=Q.onCancellationRequested(()=>{Fe.dispose(),le(x)});fe.then(le,ae).finally(()=>Fe.dispose())})}function v(fe,Q){return new Promise((x,le)=>{const ae=Q.onCancellationRequested(()=>{ae.dispose(),le(new O.$5)});fe.then(x,le).finally(()=>ae.dispose())})}async function f(fe){let Q=-1;const x=fe.map((le,ae)=>le.then(Fe=>(Q=ae,Fe)));try{return await Promise.race(x)}finally{fe.forEach((le,ae)=>{ae!==Q&&le.cancel()})}}function s(fe,Q,x){let le;const ae=setTimeout(()=>{le?.(void 0),x?.()},Q);return Promise.race([fe.finally(()=>clearTimeout(ae)),new Promise(Fe=>le=Fe)])}function r(fe){return new Promise((Q,x)=>{const le=fe();N(le)?le.then(Q,x):Q(le)})}function o(){let fe,Q;return{promise:new Promise((le,ae)=>{fe=le,Q=ae}),resolve:fe,reject:Q}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const x=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(x,x).then(le)})}return new Promise((x,le)=>{this.b.then(x,le)})}return this.a=Q(),new Promise((x,le)=>{this.a.then(ae=>{this.a=null,x(ae)},ae=>{this.a=null,le(ae)})})}dispose(){this.f=!0}}e.$uh=n;class t{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$vh=t;class c{constructor(){this.a=new Map}queue(Q,x){const ae=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(Q)===ae&&this.a.delete(Q)});return this.a.set(Q,ae),ae}}e.$wh=c;const u=(fe,Q)=>{let x=!0;const le=setTimeout(()=>{x=!1,Q()},fe);return{isTriggered:()=>x,dispose:()=>{clearTimeout(le),x=!1}}},i=fe=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,fe())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class w{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,x=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ae,Fe)=>{this.d=ae,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const ae=this.g;return this.g=null,ae()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=x===m.$ce?i(le):u(x,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=w;class a{constructor(Q){this.a=new w(Q),this.b=new n}trigger(Q,x){return this.a.trigger(()=>this.b.queue(Q),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=a;class l{constructor(){this.a=!1,this.b=new Promise((Q,x)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=l;class g extends l{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$Ah=g;function $(fe,Q){return Q?new Promise((x,le)=>{const ae=setTimeout(()=>{Fe.dispose(),x()},fe),Fe=Q.onCancellationRequested(()=>{clearTimeout(ae),Fe.dispose(),le(new O.$5)})}):S(x=>$(fe,x))}function b(fe,Q=0,x){const le=setTimeout(()=>{fe(),x&&ae.dispose()},Q),ae=(0,F.$Sc)(()=>{clearTimeout(le),x?.deleteAndLeak(ae)});return x?.add(ae),ae}function y(fe){const Q=[];let x=0;const le=fe.length;function ae(){return x<le?fe[x++]():null}function Fe(de){de!=null&&Q.push(de);const Pe=ae();return Pe?Pe.then(Fe):Promise.resolve(Q)}return Promise.resolve(null).then(Fe)}function h(fe,Q=le=>!!le,x=null){let le=0;const ae=fe.length,Fe=()=>{if(le>=ae)return Promise.resolve(x);const de=fe[le++];return Promise.resolve(de()).then(Ae=>Q(Ae)?Promise.resolve(Ae):Fe())};return Fe()}function E(fe,Q=le=>!!le,x=null){if(fe.length===0)return Promise.resolve(x);let le=fe.length;const ae=()=>{le=-1;for(const Fe of fe)Fe.cancel?.()};return new Promise((Fe,de)=>{for(const Pe of fe)Pe.then(Ae=>{--le>=0&&Q(Ae)?(ae(),Fe(Ae)):le===0&&Fe(x)}).catch(Ae=>{--le>=0&&(ae(),de(Ae))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new R.$he}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,le)=>{this.g.push({factory:Q,c:x,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const x=Q.factory();x.then(Q.c,Q.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=k;class I extends k{constructor(){super(1)}}e.$Hh=I;class P{constructor(){this.a=new ge,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Ih=P;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new re;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,x=M.$4g){const le=x.getComparisonKey(Q);return this.a.get(le)?.size??0}queueFor(Q,x,le=M.$4g){const ae=le.getComparisonKey(Q);let Fe=this.a.get(ae);if(!Fe){Fe=new I;const de=this.f++,Pe=R.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(ae),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$4c),this.d.set(de,Pe),this.a.set(ae,Fe)}return Fe.queue(x)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=V;class W{constructor(Q,x){this.a=-1,typeof Q=="function"&&typeof x=="number"&&this.setIfNotSet(Q,x)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,x){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},x)}setIfNotSet(Q,x){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},x))}}e.$Kh=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,x,le=globalThis){this.cancel();const ae=le.setInterval(()=>{Q()},x);this.d=(0,F.$Sc)(()=>{le.clearInterval(ae),this.d=void 0})}dispose(){this.cancel()}}e.$Lh=q;class A{constructor(Q,x){this.b=-1,this.a=Q,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=A;class U{constructor(Q,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=Q,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=U;class K extends A{constructor(Q,x){super(Q,x),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Oh=K;class ie extends F.$Uc{constructor(Q,x){super(),this.g=Q,this.h=x,this.a=[],this.b=this.B(new F.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of Q)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(fe,Q)=>{(0,p.$B)(()=>{if(x)return;const le=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Rh=(fe,Q,x)=>{const le=fe.requestIdleCallback(Q,typeof x=="number"?{timeout:x}:void 0);let ae=!1;return{dispose(){ae||(ae=!0,fe.cancelIdleCallback(le))}}},e.$Qh=fe=>(0,e.$Rh)(globalThis,fe)}();class ce{constructor(Q,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Rh)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=ce;class ve extends ce{constructor(Q){super(globalThis,Q)}}e.$Th=ve;async function Ee(fe,Q,x){let le;for(let ae=0;ae<x;ae++)try{return await fe()}catch(Fe){le=Fe,await $(Q)}throw le}class ge{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,x,le){return this.a={taskId:Q,cancel:()=>le?.(),promise:x},x.then(()=>this.d(Q),()=>this.d(Q)),x}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:x,resolve:le,reject:ae}=o();this.b={run:Q,promise:x,promiseResolve:le,promiseReject:ae}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=ge;class ue{constructor(Q,x=()=>Date.now()){this.d=Q,this.f=x,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Wh=ue;var Ce;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(Ce||(Ce={}));class re{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,x)=>{this.a=Q,this.b=x})}complete(Q){return new Promise(x=>{this.a(Q),this.d={outcome:0,value:Q},x()})}error(Q){return new Promise(x=>{this.b(Q),this.d={outcome:1,value:Q},x()})}cancel(){return this.error(new O.$5)}}e.$Xh=re;var Ne;(function(fe){async function Q(le){let ae;const Fe=await Promise.all(le.map(de=>de.then(Pe=>Pe,Pe=>{ae||(ae=Pe)})));if(typeof ae<"u")throw ae;return Fe}fe.settled=Q;function x(le){return new Promise(async(ae,Fe)=>{try{await le(ae,Fe)}catch(de){Fe(de)}})}fe.withAsyncBody=x})(Ne||(e.Promises=Ne={}));class Te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=Te;class T{constructor(Q){this.b=Q,this.a=new D.$V(()=>new Te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=T;var X;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(X||(X={}));class pe{static fromArray(Q){return new pe(x=>{x.emitMany(Q)})}static fromPromise(Q){return new pe(async x=>{x.emitMany(await Q)})}static fromPromises(Q){return new pe(async x=>{await Promise.all(Q.map(async le=>x.emitOne(await le)))})}static merge(Q){return new pe(async x=>{await Promise.all(Q.map(async le=>{for await(const ae of le)x.emitOne(ae)}))})}static{this.EMPTY=pe.fromArray([])}constructor(Q,x){this.a=0,this.b=[],this.d=null,this.f=x,this.g=new R.$he,queueMicrotask(async()=>{const le={emitOne:ae=>this.h(ae),emitMany:ae=>this.j(ae),reject:ae=>this.l(ae)};try{await Promise.resolve(Q(le)),this.k()}catch(ae){this.l(ae)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,x){return new pe(async le=>{for await(const ae of Q)le.emitOne(x(ae))})}map(Q){return pe.map(this,Q)}static filter(Q,x){return new pe(async le=>{for await(const ae of Q)x(ae)&&le.emitOne(ae)})}filter(Q){return pe.filter(this,Q)}static coalesce(Q){return pe.filter(Q,x=>!!x)}coalesce(){return pe.coalesce(this)}static async toPromise(Q){const x=[];for await(const le of Q)x.push(le);return x}toPromise(){return pe.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$1h=pe;class Ie extends pe{constructor(Q,x){super(x),this.m=Q}cancel(){this.m.cancel()}}e.$2h=Ie;function ye(fe){const Q=new C.$se,x=fe(Q.token);return new Ie(Q,async le=>{const ae=Q.token.onCancellationRequested(()=>{ae.dispose(),Q.dispose(),le.reject(new O.$5)});try{for await(const Fe of x){if(Q.token.isCancellationRequested)return;le.emitOne(Fe)}ae.dispose(),Q.dispose()}catch(Fe){ae.dispose(),Q.dispose(),le.reject(Fe)}})}class $e{constructor(Q){this.a=new re,this.b=new pe(ae=>{if(x){ae.reject(x);return}return le&&ae.emitMany(le),this.d=Fe=>ae.reject(Fe),this.f=Fe=>ae.emitOne(Fe),this.a.p},Q);let x,le;this.f=ae=>{le||(le=[]),le.push(ae)},this.d=ae=>{x||(x=ae)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$4h=$e}),define(ke[37],Se([1,0,18,11,49,28,19,23,13]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=D,e.$sk=f,e.$tk=I,e.$uk=P,e.$vk=V,e.$wk=W,e.$xk=q,e.$yk=ie;function D(){return Object.create(null)}e.$qk="**",e.$rk="/";const N="[/\\\\]",S="[^/\\\\]",d=/\//g;function v(ce,ve){switch(ce){case 0:return"";case 1:return`${S}*?`;default:return`(?:${N}|${S}+${N}${ve?`|${N}${S}+`:""})*?`}}function f(ce,ve){if(!ce)return[];const Ee=[];let ge=!1,ue=!1,Ce="";for(const re of ce){switch(re){case ve:if(!ge&&!ue){Ee.push(Ce),Ce="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Ce+=re}return Ce&&Ee.push(Ce),Ee}function s(ce){if(!ce)return"";let ve="";const Ee=f(ce,e.$rk);if(Ee.every(ge=>ge===e.$qk))ve=".*";else{let ge=!1;Ee.forEach((ue,Ce)=>{if(ue===e.$qk){if(ge)return;ve+=v(2,Ce===Ee.length-1)}else{let re=!1,Ne="",Te=!1,T="";for(const X of ue){if(X!=="}"&&re){Ne+=X;continue}if(Te&&(X!=="]"||!T)){let pe;X==="-"?pe=X:(X==="^"||X==="!")&&!T?pe="^":X===e.$rk?pe="":pe=(0,m.$df)(X),T+=pe;continue}switch(X){case"{":re=!0;continue;case"[":Te=!0;continue;case"}":{const Ie=`(?:${f(Ne,",").map(ye=>s(ye)).join("|")})`;ve+=Ie,re=!1,Ne="";break}case"]":{ve+="["+T+"]",Te=!1,T="";break}case"?":ve+=S;continue;case"*":ve+=v(1);continue;default:ve+=(0,m.$df)(X)}}Ce<Ee.length-1&&(Ee[Ce+1]!==e.$qk||Ce+2<Ee.length)&&(ve+=N)}ge=ue===e.$qk})}return ve}const r=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,t=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new F.$Dc(1e4),w=function(){return!1},a=function(){return null};function l(ce,ve){if(!ce)return a;let Ee;typeof ce!="string"?Ee=ce.pattern:Ee=ce,Ee=Ee.trim();const ge=`${Ee}_${!!ve.trimForExclusions}`;let ue=i.get(ge);if(ue)return g(ue,ce);let Ce;return r.test(Ee)?ue=b(Ee.substr(4),Ee):(Ce=o.exec($(Ee,ve)))?ue=y(Ce[1],Ee):(ve.trimForExclusions?t:n).test(Ee)?ue=h(Ee,ve):(Ce=c.exec($(Ee,ve)))?ue=E(Ce[1].substr(1),Ee,!0):(Ce=u.exec($(Ee,ve)))?ue=E(Ce[1],Ee,!1):ue=k(Ee),i.set(ge,ue),g(ue,ce)}function g(ce,ve){if(typeof ve=="string")return ce;const Ee=function(ge,ue){return(0,R.$zg)(ge,ve.base,!p.$k)?ce((0,m.$if)(ge.substr(ve.base.length),M.sep),ue):null};return Ee.allBasenames=ce.allBasenames,Ee.allPaths=ce.allPaths,Ee.basenames=ce.basenames,Ee.patterns=ce.patterns,Ee}function $(ce,ve){return ve.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function b(ce,ve){return function(Ee,ge){return typeof Ee=="string"&&Ee.endsWith(ce)?ve:null}}function y(ce,ve){const Ee=`/${ce}`,ge=`\\${ce}`,ue=function(re,Ne){return typeof re!="string"?null:Ne?Ne===ce?ve:null:re===ce||re.endsWith(Ee)||re.endsWith(ge)?ve:null},Ce=[ce];return ue.basenames=Ce,ue.patterns=[ve],ue.allBasenames=Ce,ue}function h(ce,ve){const Ee=K(ce.slice(1,-1).split(",").map(Ne=>l(Ne,ve)).filter(Ne=>Ne!==a),ce),ge=Ee.length;if(!ge)return a;if(ge===1)return Ee[0];const ue=function(Ne,Te){for(let T=0,X=Ee.length;T<X;T++)if(Ee[T](Ne,Te))return ce;return null},Ce=Ee.find(Ne=>!!Ne.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const re=Ee.reduce((Ne,Te)=>Te.allPaths?Ne.concat(Te.allPaths):Ne,[]);return re.length&&(ue.allPaths=re),ue}function E(ce,ve,Ee){const ge=M.sep===M.$gc.sep,ue=ge?ce:ce.replace(d,M.sep),Ce=M.sep+ue,re=M.$gc.sep+ce;let Ne;return Ee?Ne=function(Te,T){return typeof Te=="string"&&(Te===ue||Te.endsWith(Ce)||!ge&&(Te===ce||Te.endsWith(re)))?ve:null}:Ne=function(Te,T){return typeof Te=="string"&&(Te===ue||!ge&&Te===ce)?ve:null},Ne.allPaths=[(Ee?"*/":"./")+ce],Ne}function k(ce){try{const ve=new RegExp(`^${s(ce)}$`);return function(Ee){return ve.lastIndex=0,typeof Ee=="string"&&ve.test(Ee)?ce:null}}catch{return a}}function I(ce,ve,Ee){return!ce||typeof ve!="string"?!1:P(ce)(ve,void 0,Ee)}function P(ce,ve={}){if(!ce)return w;if(typeof ce=="string"||V(ce)){const Ee=l(ce,ve);if(Ee===a)return w;const ge=function(ue,Ce){return!!Ee(ue,Ce)};return Ee.allBasenames&&(ge.allBasenames=Ee.allBasenames),Ee.allPaths&&(ge.allPaths=Ee.allPaths),ge}return A(ce,ve)}function V(ce){const ve=ce;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function W(ce){return ce.allBasenames||[]}function q(ce){return ce.allPaths||[]}function A(ce,ve){const Ee=K(Object.getOwnPropertyNames(ce).map(Ne=>U(Ne,ce[Ne],ve)).filter(Ne=>Ne!==a)),ge=Ee.length;if(!ge)return a;if(!Ee.some(Ne=>!!Ne.requiresSiblings)){if(ge===1)return Ee[0];const Ne=function(X,pe){let Ie;for(let ye=0,$e=Ee.length;ye<$e;ye++){const fe=Ee[ye](X,pe);if(typeof fe=="string")return fe;(0,O.$mh)(fe)&&(Ie||(Ie=[]),Ie.push(fe))}return Ie?(async()=>{for(const ye of Ie){const $e=await ye;if(typeof $e=="string")return $e}return null})():null},Te=Ee.find(X=>!!X.allBasenames);Te&&(Ne.allBasenames=Te.allBasenames);const T=Ee.reduce((X,pe)=>pe.allPaths?X.concat(pe.allPaths):X,[]);return T.length&&(Ne.allPaths=T),Ne}const ue=function(Ne,Te,T){let X,pe;for(let Ie=0,ye=Ee.length;Ie<ye;Ie++){const $e=Ee[Ie];$e.requiresSiblings&&T&&(Te||(Te=(0,M.$nc)(Ne)),X||(X=Te.substr(0,Te.length-(0,M.$oc)(Ne).length)));const fe=$e(Ne,Te,X,T);if(typeof fe=="string")return fe;(0,O.$mh)(fe)&&(pe||(pe=[]),pe.push(fe))}return pe?(async()=>{for(const Ie of pe){const ye=await Ie;if(typeof ye=="string")return ye}return null})():null},Ce=Ee.find(Ne=>!!Ne.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const re=Ee.reduce((Ne,Te)=>Te.allPaths?Ne.concat(Te.allPaths):Ne,[]);return re.length&&(ue.allPaths=re),ue}function U(ce,ve,Ee){if(ve===!1)return a;const ge=l(ce,Ee);if(ge===a)return a;if(typeof ve=="boolean")return ge;if(ve){const ue=ve.when;if(typeof ue=="string"){const Ce=(re,Ne,Te,T)=>{if(!T||!ge(re,Ne))return null;const X=ue.replace("$(basename)",()=>Te),pe=T(X);return(0,O.$mh)(pe)?pe.then(Ie=>Ie?ce:null):pe?ce:null};return Ce.requiresSiblings=!0,Ce}}return ge}function K(ce,ve){const Ee=ce.filter(Ne=>!!Ne.basenames);if(Ee.length<2)return ce;const ge=Ee.reduce((Ne,Te)=>{const T=Te.basenames;return T?Ne.concat(T):Ne},[]);let ue;if(ve){ue=[];for(let Ne=0,Te=ge.length;Ne<Te;Ne++)ue.push(ve)}else ue=Ee.reduce((Ne,Te)=>{const T=Te.patterns;return T?Ne.concat(T):Ne},[]);const Ce=function(Ne,Te){if(typeof Ne!="string")return null;if(!Te){let X;for(X=Ne.length;X>0;X--){const pe=Ne.charCodeAt(X-1);if(pe===47||pe===92)break}Te=Ne.substr(X)}const T=ge.indexOf(Te);return T!==-1?ue[T]:null};Ce.basenames=ge,Ce.patterns=ue,Ce.allBasenames=ge;const re=ce.filter(Ne=>!Ne.basenames);return re.push(Ce),re}function ie(ce,ve){return(0,C.$ub)(ce,ve,(Ee,ge)=>typeof Ee=="string"&&typeof ge=="string"?Ee===ge:typeof Ee!="string"&&typeof ge!="string"?Ee.base===ge.base&&Ee.pattern===ge.pattern:!1)}}),define(ke[55],Se([1,0,14,137,24,13,2]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=D,e.$Zk=N,e.$1k=S,e.$2k=d,e.$3k=v,e.$4k=f,e.$5k=s,e.$6k=r;var p;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class m{constructor(n="",t=!1){if(this.value=n,typeof this.value!="string")throw(0,C.$7)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(n,t=0){return this.value+=d(this.supportThemeIcons?(0,O.$Rk)(n):n).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,t){return this.value+=`
${v(t,n)}
`,this}appendLink(n,t,c){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,t){const c=new RegExp((0,F.$df)(t),"g");return n.replace(c,(u,i)=>n.charAt(i-1)!=="\\"?`\\${u}`:u)}}e.$Xk=m;function D(o){return N(o)?!o.value:Array.isArray(o)?o.every(D):!0}function N(o){return o instanceof m?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function S(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,R.$7g)(M.URI.from(o.baseUri),M.URI.from(n.baseUri)))}function d(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function v(o,n){const t=o.match(/^`+/gm)?.reduce((u,i)=>u.length>i.length?u:i).length??0,c=t>=3?t+1:3;return[`${"`".repeat(c)}${n}`,o,`${"`".repeat(c)}`].join(`
`)}function f(o){return o.replace(/"/g,"&quot;")}function s(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(o){const n=[],t=o.split("|").map(u=>u.trim());o=t[0];const c=t[1];if(c){const u=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),w=u?u[1]:"",a=i?i[1]:"",l=isFinite(parseInt(a)),g=isFinite(parseInt(w));l&&n.push(`width="${a}"`),g&&n.push(`height="${w}"`)}return{href:o,dimensions:n}}}),define(ke[97],Se([1,0,18,49,19,23,24,13]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jw=m,e.$Kw=N,e.$Lw=d,e.$Mw=v,e.$Nw=o,e.$Ow=t,e.$Pw=c,e.$Qw=u,e.$Rw=i,e.$Sw=w;function m(l,g){const{os:$,tildify:b,relative:y}=g;if(y){const k=D(l,y,$);if(typeof k=="string")return k}let h=l.fsPath;if($===1&&!F.$i?h=h.replace(/\//g,"\\"):$!==1&&F.$i&&(h=h.replace(/\\/g,"/")),$!==1&&b?.userHome){const k=b.userHome.fsPath;let I;l.scheme!==b.userHome.scheme&&l.path[0]===R.$gc.sep&&l.path[1]!==R.$gc.sep?I=b.userHome.with({path:l.path}).fsPath:I=h,h=d(I,k,$)}return($===1?R.$fc:R.$gc).normalize(N(h,$===1))}function D(l,g,$){const b=$===1?R.$fc:R.$gc,y=$===3?M.$4g:M.$6g,h=g.getWorkspace(),E=(0,C.$Ob)(h.folders);if(!E)return;l.scheme!==E.uri.scheme&&l.path[0]===R.$gc.sep&&l.path[1]!==R.$gc.sep&&(l=E.uri.with({path:l.path}));const k=g.getWorkspaceFolder(l);if(!k)return;let I;if(y.isEqual(k.uri,l)?I="":I=y.relativePath(k.uri,l)??"",I&&(I=b.normalize(I)),h.folders.length>1&&!g.noPrefix){const P=k.name?k.name:y.basenameOrAuthority(k.uri);I=I?`${P} \u2022 ${I}`:P}return I}function N(l,g=F.$i){return(0,O.$Eg)(l,g)?l.charAt(0).toUpperCase()+l.slice(1):l}let S=Object.create(null);function d(l,g,$=F.OS){if($===1||!l||!g)return l;let b=S.original===g?S.normalized:void 0;b||(b=g,F.$i&&(b=(0,O.$tg)(b)),b=`${(0,p.$jf)(b,R.$gc.sep)}${R.$gc.sep}`,S={original:g,normalized:b});let y=l;return F.$i&&(y=(0,O.$tg)(y)),($===3?y.startsWith(b):(0,p.$Cf)(y,b))?`~/${y.substr(b.length)}`:l}function v(l,g){return l.replace(/^~($|\/|\\)/,`${g}$1`)}const f="\u2026",s="\\\\",r="~";function o(l,g=R.sep){const $=new Array(l.length);let b=!1;for(let y=0;y<l.length;y++){const h=l[y];if(h===""){$[y]=`.${g}`;continue}if(!h){$[y]=h;continue}b=!0;let E="",k=h;k.indexOf(s)===0?(E=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length)):k.indexOf(g)===0?(E=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length)):k.indexOf(r)===0&&(E=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length));const I=k.split(g);for(let P=1;b&&P<=I.length;P++)for(let V=I.length-P;b&&V>=0;V--){b=!1;let W=I.slice(V,V+P).join(g);for(let q=0;!b&&q<l.length;q++)if(q!==y&&l[q]&&l[q].indexOf(W)>-1){const A=V+P===I.length,U=V>0&&l[q].indexOf(g)>-1?g+W:W,K=l[q].endsWith(U);b=!A||K}if(!b){let q="";(I[0].endsWith(":")||E!=="")&&(V===1&&(V=0,P++,W=I[0]+g+W),V>0&&(q=I[0]+g),q=E+q),V>0&&(q=q+f+g),q=q+W,V+P<I.length&&(q=q+g+f),$[y]=q}}b&&($[y]=h)}return $}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function t(l,g=Object.create(null)){const $=[];let b=!1,y="";for(const h of l)if(h==="$"||b&&h==="{")y&&$.push({value:y,type:n.TEXT}),y="",b=!0;else if(h==="}"&&b){const E=g[y];if(typeof E=="string")E.length&&$.push({value:E,type:n.VARIABLE});else if(E){const k=$[$.length-1];(!k||k.type!==n.SEPARATOR)&&$.push({value:E.label,type:n.SEPARATOR})}y="",b=!1}else y+=h;return y&&!b&&$.push({value:y,type:n.TEXT}),$.filter((h,E)=>{if(h.type===n.SEPARATOR){const k=$[E-1],I=$[E+1];return[k,I].every(P=>P&&(P.type===n.VARIABLE||P.type===n.TEXT)&&P.value.length>0)}return!0}).map(h=>h.value).join("")}function c(l,g){return F.$j||g?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):l.replace(/&&|&/g,$=>$==="&"?"&&":"&")}function u(l,g){return F.$j||g?l.replace(/\(&&\w\)|&&/g,""):F.$i?l.replace(/&&|&/g,$=>$==="&"?"&&":"&"):l.replace(/&&/g,"_")}function i(l){return l.replace(/&/g,"&&")}function w(l){if(l.endsWith("]")){const g=l.lastIndexOf(" [",l.length-2);if(g!==-1){const $=a(l.substring(0,g)),b=l.substring(g);return{name:$.name+b,parentPath:$.parentPath}}}return a(l)}function a(l){const g=l.indexOf("/")!==-1?R.$gc:R.$fc,$=g.basename(l),b=g.dirname(l);return $.length?{name:$,parentPath:b}:{name:b,parentPath:""}}}),define(ke[150],Se([1,0,22,2]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=void 0,e.$En=p,e.$Fn=D,e.$Gn=N;function R(S){return S.toJSON()}class F{constructor(d){this.a=d}transformIncoming(d){const v=this.a.transformIncoming(d);return v===d?d:R(O.URI.from(v))}transformOutgoing(d){const v=this.a.transformOutgoing(d);return v===d?d:R(O.URI.from(v))}transformOutgoingURI(d){const v=this.a.transformOutgoing(d);return v===d?d:O.URI.from(v)}transformOutgoingScheme(d){return this.a.transformOutgoingScheme(d)}}e.$Cn=F,e.$Dn=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function M(S,d,v){if(!S||v>200)return null;if(typeof S=="object"){if(S instanceof O.URI)return d.transformOutgoing(S);for(const f in S)if(Object.hasOwnProperty.call(S,f)){const s=M(S[f],d,v+1);s!==null&&(S[f]=s)}}return null}function p(S,d){const v=M(S,d,0);return v===null?S:v}function m(S,d,v,f){if(!S||f>200)return null;if(typeof S=="object"){if(S.$mid===1)return v?O.URI.revive(d.transformIncoming(S)):d.transformIncoming(S);if(S instanceof C.$Je)return null;for(const s in S)if(Object.hasOwnProperty.call(S,s)){const r=m(S[s],d,v,f+1);r!==null&&(S[s]=r)}}return null}function D(S,d){const v=m(S,d,!1,0);return v===null?S:v}function N(S,d){const v=m(S,d,!0,0);return v===null?S:v}}),define(ke[151],Se([1,0,11,5,6,45,15]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.StorageState=e.StorageHint=void 0,e.$2p=m;var p;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function m(d){const v=d;return v?.changed instanceof Map||v?.deleted instanceof Set}var D;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(D||(e.StorageState=D={}));class N extends R.$Uc{static{this.a=100}constructor(v,f=Object.create(null)){super(),this.r=v,this.s=f,this.b=this.B(new O.$ke),this.onDidChangeStorage=this.b.event,this.c=D.None,this.f=new Map,this.g=this.B(new C.$yh(N.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((f,s)=>this.w(s,f)),v.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(v,f){if(this.c===D.Closed)return;let s=!1;(0,M.$jg)(f)?s=this.f.delete(v):this.f.get(v)!==f&&(this.f.set(v,f),s=!0),s&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===D.None&&(this.c=D.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,f){const s=this.f.get(v);return(0,M.$jg)(s)?f:s}getBoolean(v,f){const s=this.get(v);return(0,M.$jg)(s)?f:s==="true"}getNumber(v,f){const s=this.get(v);return(0,M.$jg)(s)?f:parseInt(s,10)}getObject(v,f){const s=this.get(v);return(0,M.$jg)(s)?f:(0,F.$9h)(s)}async set(v,f,s=!1){if(this.c===D.Closed)return;if((0,M.$jg)(f))return this.delete(v,s);const r=(0,M.$cg)(f)||Array.isArray(f)?(0,F.$8h)(f):String(f);if(this.f.get(v)!==r)return this.f.set(v,r),this.j.set(v,r),this.h.delete(v),this.b.fire({key:v,external:s}),this.D()}async delete(v,f=!1){if(!(this.c===D.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:f}),this.D()}async optimize(){if(this.c!==D.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=D.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(!(this.c===D.Closed||this.m))return this.D(v)}async D(v){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$3p=N;class S{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((f,s)=>this.a.set(s,f)),v.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$4p=S}),define(ke[152],Se([1,0,13,23,22]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2t=void 0,e.$Zt=N,e.$1t=S;let F;function M(){return F||(F=new TextDecoder("UTF-16LE")),F}let p;function m(){return p||(p=new TextDecoder("UTF-16BE")),p}let D;function N(){return D||(D=O.$D()?M():m()),D}function S(f,s,r){const o=new Uint16Array(f.buffer,s,r);return r>0&&(o[0]===65279||o[0]===65534)?d(f,s,r):M().decode(o)}function d(f,s,r){const o=[];let n=0;for(let t=0;t<r;t++){const c=R.$Le(f,s);s+=2,o[n++]=String.fromCharCode(c)}return o.join("")}class v{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return N().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const r=this.a-this.d;r<=1&&(r===0||C.$Ff(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const r=s.length;if(this.d+r>=this.a){this.f(),this.c[this.c.length]=s;return}for(let o=0;o<r;o++)this.b[this.d++]=s.charCodeAt(o)}}e.$2t=v}),define(ke[153],Se([1,0,22,152]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3t=void 0,e.$4t=M;function R(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(D,N,S,d){this.oldPosition=D,this.oldText=N,this.newPosition=S,this.newText=d}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(D){return 4+2*D.length}static c(D,N,S){const d=N.length;C.$Oe(D,d,S),S+=4;for(let v=0;v<d;v++)C.$Me(D,N.charCodeAt(v),S),S+=2;return S}static d(D,N){const S=C.$Ne(D,N);return N+=4,(0,O.$1t)(D,N,S)}writeSize(){return 8+F.a(this.oldText)+F.a(this.newText)}write(D,N){return C.$Oe(D,this.oldPosition,N),N+=4,C.$Oe(D,this.newPosition,N),N+=4,N=F.c(D,this.oldText,N),N=F.c(D,this.newText,N),N}static read(D,N,S){const d=C.$Ne(D,N);N+=4;const v=C.$Ne(D,N);N+=4;const f=F.d(D,N);N+=F.a(f);const s=F.d(D,N);return N+=F.a(s),S.push(new F(d,f,v,s)),N}}e.$3t=F;function M(m,D){return m===null||m.length===0?D:new p(m,D).compress()}class p{constructor(D,N){this.a=D,this.c=N,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let D=0,N=0,S=this.n(D),d=this.l(N);for(;D<this.f||N<this.h;){if(S===null){this.k(d),d=this.l(++N);continue}if(d===null){this.m(S),S=this.n(++D);continue}if(d.oldEnd<=S.newPosition){this.k(d),d=this.l(++N);continue}if(S.newEnd<=d.oldPosition){this.m(S),S=this.n(++D);continue}if(d.oldPosition<S.newPosition){const[o,n]=p.r(d,S.newPosition-d.oldPosition);this.k(o),d=n;continue}if(S.newPosition<d.oldPosition){const[o,n]=p.q(S,d.oldPosition-S.newPosition);this.m(o),S=n;continue}let s,r;if(d.oldEnd===S.newEnd)s=S,r=d,S=this.n(++D),d=this.l(++N);else if(d.oldEnd<S.newEnd){const[o,n]=p.q(S,d.oldLength);s=o,r=d,S=n,d=this.l(++N)}else{const[o,n]=p.r(d,S.newLength);s=S,r=o,S=this.n(++D),d=n}this.d[this.e++]=new F(s.oldPosition,s.oldText,r.newPosition,r.newText),this.g+=s.newLength-s.oldLength,this.j+=r.newLength-r.oldLength}const v=p.s(this.d);return p.t(v)}k(D){this.d[this.e++]=p.o(this.g,D),this.j+=D.newLength-D.oldLength}l(D){return D<this.h?this.c[D]:null}m(D){this.d[this.e++]=p.p(this.j,D),this.g+=D.newLength-D.oldLength}n(D){return D<this.f?this.a[D]:null}static o(D,N){return new F(N.oldPosition-D,N.oldText,N.newPosition,N.newText)}static p(D,N){return new F(N.oldPosition,N.oldText,N.newPosition+D,N.newText)}static q(D,N){const S=D.newText.substr(0,N),d=D.newText.substr(N);return[new F(D.oldPosition,D.oldText,D.newPosition,S),new F(D.oldEnd,"",D.newPosition+N,d)]}static r(D,N){const S=D.oldText.substr(0,N),d=D.oldText.substr(N);return[new F(D.oldPosition,S,D.newPosition,D.newText),new F(D.oldPosition+N,d,D.newEnd,"")]}static s(D){if(D.length===0)return D;const N=[];let S=0,d=D[0];for(let v=1;v<D.length;v++){const f=D[v];d.oldEnd===f.oldPosition?d=new F(d.oldPosition,d.oldText+f.oldText,d.newPosition,d.newText+f.newText):(N[S++]=d,d=f)}return N[S++]=d,N}static t(D){if(D.length===0)return D;const N=[];let S=0;for(let d=0;d<D.length;d++){const v=D[d];v.oldText!==v.newText&&(N[S++]=v)}return N}}}),define(ke[154],Se([1,0,37,19]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hu=R,e.$iu=F;function R(M,p,m,D,N,S){if(Array.isArray(M)){let d=0;for(const v of M){const f=R(v,p,m,D,N,S);if(f===10)return f;f>d&&(d=f)}return d}else{if(typeof M=="string")return D?M==="*"?5:M===m?10:0:0;if(M){const{language:d,pattern:v,scheme:f,hasAccessToAllModels:s,notebookType:r}=M;if(!D&&!s)return 0;r&&N&&(p=N);let o=0;if(f)if(f===p.scheme)o=10;else if(f==="*")o=5;else return 0;if(d)if(d===m)o=10;else if(d==="*")o=Math.max(o,5);else return 0;if(r)if(r===S)o=10;else if(r==="*"&&S!==void 0)o=Math.max(o,5);else return 0;if(v){let n;if(typeof v=="string"?n=v:n={...v,base:(0,O.$hc)(v.base)},n===p.fsPath||(0,C.$tk)(n,p.fsPath))o=10;else return 0}return o}else return 0}}function F(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(F):!!M.notebookType}}),define(ke[155],Se([1,0,5,13,30,95,93,139,153,6]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7C=void 0;class N extends D.$Uc{constructor(d,v,f,s,r,o,n){super(),this.m=this.B(new C.$he),this.onDidChangeContent=this.m.event,this.f=v,this.j=!o,this.g=s,this.h=r,this.c=new M.$6C(d,f,n)}equals(d){return!(d instanceof N)||this.f!==d.f||this.getEOL()!==d.getEOL()?!1:this.c.equal(d.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(d){return this.c.createSnapshot(d?this.f:"")}getOffsetAt(d,v){return this.c.getOffsetAt(d,v)}getPositionAt(d){return this.c.getPositionAt(d)}getRangeAt(d,v){const f=d+v,s=this.getPositionAt(d),r=this.getPositionAt(f);return new R.$At(s.lineNumber,s.column,r.lineNumber,r.column)}getValueInRange(d,v=0){if(d.isEmpty())return"";const f=this.n(v);return this.c.getValueInRange(d,f)}getValueLengthInRange(d,v=0){if(d.isEmpty())return 0;if(d.startLineNumber===d.endLineNumber)return d.endColumn-d.startColumn;const f=this.getOffsetAt(d.startLineNumber,d.startColumn),s=this.getOffsetAt(d.endLineNumber,d.endColumn);let r=0;const o=this.n(v),n=this.getEOL();if(o.length!==n.length){const t=o.length-n.length,c=d.endLineNumber-d.startLineNumber;r=t*c}return s-f+r}getCharacterCountInRange(d,v=0){if(this.j){let f=0;const s=d.startLineNumber,r=d.endLineNumber;for(let o=s;o<=r;o++){const n=this.getLineContent(o),t=o===s?d.startColumn-1:0,c=o===r?d.endColumn-1:n.length;for(let u=t;u<c;u++)O.$Ff(n.charCodeAt(u))?(f=f+1,u=u+1):f=f+1}return f+=this.n(v).length*(r-s),f}return this.getValueLengthInRange(d,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(d){return this.c.getLineContent(d)}getLineCharCode(d,v){return this.c.getLineCharCode(d,v)}getCharCode(d){return this.c.getCharCode(d)}getLineLength(d){return this.c.getLineLength(d)}getLineMinColumn(d){return 1}getLineMaxColumn(d){return this.getLineLength(d)+1}getLineFirstNonWhitespaceColumn(d){const v=O.$qf(this.getLineContent(d));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(d){const v=O.$sf(this.getLineContent(d));return v===-1?0:v+2}n(d){switch(d){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(d){this.c.setEOL(d)}applyEdits(d,v,f){let s=this.g,r=this.h,o=this.j,n=!0,t=[];for(let g=0;g<d.length;g++){const $=d[g];n&&$._isTracked&&(n=!1);const b=$.range;if($.text){let I=!0;o||(I=!O.$Qf($.text),o=I),!s&&I&&(s=O.$Pf($.text)),!r&&I&&(r=O.$Sf($.text))}let y="",h=0,E=0,k=0;if($.text){let I;[h,E,k,I]=(0,p.$ku)($.text);const P=this.getEOL();I===0||I===(P===`\r
`?2:1)?y=$.text:y=$.text.replace(/\r\n|\r|\n/g,P)}t[g]={sortIndex:g,identifier:$.identifier||null,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b),text:y,eolCount:h,firstLineLength:E,lastLineLength:k,forceMoveMarkers:!!$.forceMoveMarkers,isAutoWhitespaceEdit:$.isAutoWhitespaceEdit||!1}}t.sort(N.u);let c=!1;for(let g=0,$=t.length-1;g<$;g++){const b=t[g].range.getEndPosition(),y=t[g+1].range.getStartPosition();if(y.isBeforeOrEqual(b)){if(y.isBefore(b))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(t=this.s(t));const u=f||v?N._getInverseEditRanges(t):[],i=[];if(v)for(let g=0;g<t.length;g++){const $=t[g],b=u[g];if($.isAutoWhitespaceEdit&&$.range.isEmpty())for(let y=b.startLineNumber;y<=b.endLineNumber;y++){let h="";y===b.startLineNumber&&(h=this.getLineContent($.range.startLineNumber),O.$qf(h)!==-1)||i.push({lineNumber:y,oldContent:h})}}let w=null;if(f){let g=0;w=[];for(let $=0;$<t.length;$++){const b=t[$],y=u[$],h=this.getValueInRange(b.range),E=b.rangeOffset+g;g+=b.text.length-h.length,w[$]={sortIndex:b.sortIndex,identifier:b.identifier,range:y,text:h,textChange:new m.$3t(b.rangeOffset,h,E,b.text)}}c||w.sort(($,b)=>$.sortIndex-b.sortIndex)}this.g=s,this.h=r,this.j=o;const a=this.t(t);let l=null;if(v&&i.length>0){i.sort((g,$)=>$.lineNumber-g.lineNumber),l=[];for(let g=0,$=i.length;g<$;g++){const b=i[g].lineNumber;if(g>0&&i[g-1].lineNumber===b)continue;const y=i[g].oldContent,h=this.getLineContent(b);h.length===0||h===y||O.$qf(h)!==-1||l.push(b)}}return this.m.fire(),new F.$5v(w,a,l)}s(d){return d.length<1e3?d:[this._toSingleEditOperation(d)]}_toSingleEditOperation(d){let v=!1;const f=d[0].range,s=d[d.length-1].range,r=new R.$At(f.startLineNumber,f.startColumn,s.endLineNumber,s.endColumn);let o=f.startLineNumber,n=f.startColumn;const t=[];for(let a=0,l=d.length;a<l;a++){const g=d[a],$=g.range;v=v||g.forceMoveMarkers,t.push(this.getValueInRange(new R.$At(o,n,$.startLineNumber,$.startColumn))),g.text.length>0&&t.push(g.text),o=$.endLineNumber,n=$.endColumn}const c=t.join(""),[u,i,w]=(0,p.$ku)(c);return{sortIndex:0,identifier:d[0].identifier,range:r,rangeOffset:this.getOffsetAt(r.startLineNumber,r.startColumn),rangeLength:this.getValueLengthInRange(r,0),text:c,eolCount:u,firstLineLength:i,lastLineLength:w,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(d){d.sort(N.w);const v=[];for(let f=0;f<d.length;f++){const s=d[f],r=s.range.startLineNumber,o=s.range.startColumn,n=s.range.endLineNumber,t=s.range.endColumn;if(r===n&&o===t&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new R.$At(r,o,n,t);v.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return v}findMatchesLineByLine(d,v,f,s){return this.c.findMatchesLineByLine(d,v,f,s)}getPieceTree(){return this.c}static _getInverseEditRange(d,v){const f=d.startLineNumber,s=d.startColumn,[r,o,n]=(0,p.$ku)(v);let t;if(v.length>0){const c=r+1;c===1?t=new R.$At(f,s,f,s+o):t=new R.$At(f,s,f+c-1,n+1)}else t=new R.$At(f,s,f,s);return t}static _getInverseEditRanges(d){const v=[];let f=0,s=0,r=null;for(let o=0,n=d.length;o<n;o++){const t=d[o];let c,u;r?r.range.endLineNumber===t.range.startLineNumber?(c=f,u=s+(t.range.startColumn-r.range.endColumn)):(c=f+(t.range.startLineNumber-r.range.endLineNumber),u=t.range.startColumn):(c=t.range.startLineNumber,u=t.range.startColumn);let i;if(t.text.length>0){const w=t.eolCount+1;w===1?i=new R.$At(c,u,c,u+t.firstLineLength):i=new R.$At(c,u,c+w-1,t.lastLineLength+1)}else i=new R.$At(c,u,c,u);f=i.endLineNumber,s=i.endColumn,v.push(i),r=t}return v}static u(d,v){const f=R.$At.compareRangesUsingEnds(d.range,v.range);return f===0?d.sortIndex-v.sortIndex:f}static w(d,v){const f=R.$At.compareRangesUsingEnds(d.range,v.range);return f===0?v.sortIndex-d.sortIndex:-f}}e.$7C=N}),define(ke[156],Se([1,0,13,93,155]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=void 0;class F{constructor(m,D,N,S,d,v,f,s,r){this.a=m,this.b=D,this.c=N,this.d=S,this.e=d,this.f=v,this.g=f,this.h=s,this.j=r}k(m){const D=this.c+this.d+this.e,N=this.c+this.e;return D===0?m===1?`
`:`\r
`:N>D/2?`\r
`:`
`}create(m){const D=this.k(m),N=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let d=0,v=N.length;d<v;d++){const f=N[d].buffer.replace(/\r\n|\r|\n/g,D),s=(0,O.$2C)(f);N[d]=new O.$5C(f,s)}const S=new R.$7C(N,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&C.$1f(m)&&(this.b=C.$Zf,m=m.substr(1));const D=m.charCodeAt(m.length-1);D===13||D>=55296&&D<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=D):(this.m(m,!1),this.c=!1,this.d=D)}m(m,D){!D&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const D=(0,O.$3C)(this.e,m);this.a.push(new O.$5C(m,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=C.$Pf(m)),this.k||(this.k=C.$Sf(m)))}finish(m=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const D=(0,O.$2C)(m.buffer);m.lineStarts=D,this.d===13&&this.f++}}}e.$8C=M}),define(ke[98],Se([1,0,22,23]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbb=m,e.$Obb=N;var R;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(R||(R={}));function F(S){for(let d=0,v=S.length;d<v;d+=4){const f=S[d+0],s=S[d+1],r=S[d+2],o=S[d+3];S[d+0]=o,S[d+1]=r,S[d+2]=s,S[d+3]=f}}function M(S){const d=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return O.$D()||F(d),C.$Je.wrap(d)}function p(S){const d=S.buffer;if(O.$D()||F(d),d.byteOffset%4===0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const v=new Uint8Array(d.byteLength);return v.set(d),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function m(S){const d=new Uint32Array(D(S));let v=0;if(d[v++]=S.id,S.type==="full")d[v++]=1,d[v++]=S.data.length,d.set(S.data,v),v+=S.data.length;else{d[v++]=2,d[v++]=S.deltas.length;for(const f of S.deltas)d[v++]=f.start,d[v++]=f.deleteCount,f.data?(d[v++]=f.data.length,d.set(f.data,v),v+=f.data.length):d[v++]=0}return M(d)}function D(S){let d=0;if(d+=2,S.type==="full")d+=1+S.data.length;else{d+=1,d+=3*S.deltas.length;for(const v of S.deltas)v.data&&(d+=v.data.length)}return d}function N(S){const d=p(S);let v=0;const f=d[v++];if(d[v++]===1){const n=d[v++],t=d.subarray(v,v+n);return v+=n,{id:f,type:"full",data:t}}const r=d[v++],o=[];for(let n=0;n<r;n++){const t=d[v++],c=d[v++],u=d[v++];let i;u>0&&(i=d.subarray(v,v+u),v+=u),o[n]={start:t,deleteCount:c,data:i}}return{id:f,type:"delta",deltas:o}}}),define(ke[157],Se([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(ke[158],Se([1,0,18,26,23,140,159,157]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=r,e.clampedInt=n,e.clampedFloat=c,e.stringSet=w,e.cursorStyleToString=k,e.filterValidationDecorations=ae;var m;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=D;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class S{constructor(Z,me,Ge,be){this.id=Z,this.name=me,this.defaultValue=Ge,this.schema=be}applyUpdate(Z,me){return v(Z,me)}compute(Z,me,Ge){return Ge}}class d{constructor(Z,me){this.newValue=Z,this.didChange=me}}e.ApplyUpdateResult=d;function v(Y,Z){if(typeof Y!="object"||typeof Z!="object"||!Y||!Z)return new d(Z,Y!==Z);if(Array.isArray(Y)||Array.isArray(Z)){const Ge=Array.isArray(Y)&&Array.isArray(Z)&&C.$ub(Y,Z);return new d(Z,!Ge)}let me=!1;for(const Ge in Z)if(Z.hasOwnProperty(Ge)){const be=v(Y[Ge],Z[Ge]);be.didChange&&(Y[Ge]=be.newValue,me=!0)}return new d(Y,me)}class f{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,me){return v(Z,me)}validate(Z){return this.defaultValue}}class s{constructor(Z,me,Ge,be){this.id=Z,this.name=me,this.defaultValue=Ge,this.schema=be}applyUpdate(Z,me){return v(Z,me)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,me,Ge){return Ge}}function r(Y,Z){return typeof Y>"u"?Z:Y==="false"?!1:!!Y}class o extends s{constructor(Z,me,Ge,be=void 0){typeof be<"u"&&(be.type="boolean",be.default=Ge),super(Z,me,Ge,be)}validate(Z){return r(Z,this.defaultValue)}}function n(Y,Z,me,Ge){if(typeof Y>"u")return Z;let be=parseInt(Y,10);return isNaN(be)?Z:(be=Math.max(me,be),be=Math.min(Ge,be),be|0)}class t extends s{static clampedInt(Z,me,Ge,be){return n(Z,me,Ge,be)}constructor(Z,me,Ge,be,st,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=Ge,dt.minimum=be,dt.maximum=st),super(Z,me,Ge,dt),this.minimum=be,this.maximum=st}validate(Z){return t.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(Y,Z,me,Ge){if(typeof Y>"u")return Z;const be=u.float(Y,Z);return u.clamp(be,me,Ge)}class u extends s{static clamp(Z,me,Ge){return Z<me?me:Z>Ge?Ge:Z}static float(Z,me){if(typeof Z=="number")return Z;if(typeof Z>"u")return me;const Ge=parseFloat(Z);return isNaN(Ge)?me:Ge}constructor(Z,me,Ge,be,st){typeof st<"u"&&(st.type="number",st.default=Ge),super(Z,me,Ge,st),this.validationFn=be}validate(Z){return this.validationFn(u.float(Z,this.defaultValue))}}class i extends s{static string(Z,me){return typeof Z!="string"?me:Z}constructor(Z,me,Ge,be=void 0){typeof be<"u"&&(be.type="string",be.default=Ge),super(Z,me,Ge,be)}validate(Z){return i.string(Z,this.defaultValue)}}function w(Y,Z,me,Ge){return typeof Y!="string"?Z:Ge&&Y in Ge?Ge[Y]:me.indexOf(Y)===-1?Z:Y}class a extends s{constructor(Z,me,Ge,be,st=void 0){typeof st<"u"&&(st.type="string",st.enum=be,st.default=Ge),super(Z,me,Ge,st),this.c=be}validate(Z){return w(Z,this.defaultValue,this.c)}}class l extends S{constructor(Z,me,Ge,be,st,dt,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=st,Pt.default=be),super(Z,me,Ge,Pt),this.c=st,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function g(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,me,Ge){return Ge===0?Z.accessibilitySupport:Ge}}class b extends S{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:p.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertSpace:r(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function h(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function k(Y){switch(Y){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function I(Y){switch(Y){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class P extends f{constructor(){super(142)}compute(Z,me,Ge){const be=["monaco-editor"];return me.get(39)&&be.push(me.get(39)),Z.extraEditorClassName&&be.push(Z.extraEditorClassName),me.get(74)==="default"?be.push("mouse-default"):me.get(74)==="copy"&&be.push("mouse-copy"),me.get(111)&&be.push("showUnused"),me.get(140)&&be.push("showDeprecated"),be.join(" ")}}class V extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(Z,me,Ge){return Ge&&Z.emptySelectionClipboard}}class W extends S{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:p.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:p.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{cursorMoveOnType:r(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":w(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":w(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(me.loop,this.defaultValue.loop)}}}class q extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?A.OFF:Z==="true"?A.TRANSLATE:Z:Z?A.TRANSLATE:A.OFF}compute(Z,me,Ge){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class U extends f{constructor(){super(50)}compute(Z,me,Ge){return Z.fontInfo}}class K extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(Z){const me=u.float(Z,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(me,6,100)}compute(Z,me,Ge){return Z.fontInfo.fontSize}}class ie extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(t.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class ce extends S{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ge,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ge,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ge,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ge,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ge,description:p.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{multiple:w(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??w(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??w(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??w(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??w(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??w(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ve extends S{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:p.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),delay:t.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:r(me.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(me.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:r(me.above,this.defaultValue.above)}}}var Ee;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Ee||(e.RenderMinimap=Ee={}));class ge extends f{constructor(){super(145)}compute(Z,me,Ge){return ge.computeLayout(me,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const me=Z.height/Z.lineHeight,Ge=Math.floor(Z.paddingTop/Z.lineHeight);let be=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(be=Math.max(be,me-1));const st=(Ge+Z.viewLineCount+be)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/st);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:be,desiredRatio:st,minimapLineCount:dt}}static c(Z,me){const Ge=Z.outerWidth,be=Z.outerHeight,st=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:be};const dt=me.stableMinimapLayoutInput,Pt=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,Vt=Z.lineHeight,Qt=Z.typicalHalfwidthCharacterWidth,ii=Z.scrollBeyondLastLine,Xt=Z.minimap.renderCharacters;let Et=st>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Zt=Z.minimap.maxColumn,Yt=Z.minimap.size,Ze=Z.minimap.side,si=Z.verticalScrollbarWidth,Ht=Z.viewLineCount,ht=Z.remainingWidth,ft=Z.isViewportWrapping,xt=Xt?2:3;let Kt=Math.floor(st*be);const Ft=Kt/st;let gt=!1,Bt=!1,_t=xt*Et,zt=Et/st,Qe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:Mt,extraLinesBeforeFirstLine:ei,extraLinesBeyondLastLine:Wt,desiredRatio:oi,minimapLineCount:Ot}=ge.computeContainedMinimapLineCount({viewLineCount:Ht,scrollBeyondLastLine:ii,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:be,lineHeight:Vt,pixelRatio:st});if(Ht/Ot>1)gt=!0,Bt=!0,Et=1,_t=1,zt=Et/st;else{let At=!1,St=Et+1;if(Yt==="fit"){const $t=Math.ceil((ei+Ht+Wt)*_t);ft&&Pt&&ht<=me.stableFitRemainingWidth?(At=!0,St=me.stableFitMaxMinimapScale):At=$t>Kt}if(Yt==="fill"||At){gt=!0;const $t=Et;_t=Math.min(Vt*st,Math.max(1,Math.floor(1/oi))),ft&&Pt&&ht<=me.stableFitRemainingWidth&&(St=me.stableFitMaxMinimapScale),Et=Math.min(St,Math.max(1,Math.floor(_t/xt))),Et>$t&&(Qe=Math.min(2,Et/$t)),zt=Et/st/Qe,Kt=Math.ceil(Math.max(Mt,ei+Ht+Wt)*_t),ft?(me.stableMinimapLayoutInput=Z,me.stableFitRemainingWidth=ht,me.stableFitMaxMinimapScale=Et):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ui=Math.floor(Zt*zt),Jt=Math.min(ui,Math.max(0,Math.floor((ht-si-2)*zt/(Qt+zt)))+e.MINIMAP_GUTTER_WIDTH);let Ut=Math.floor(st*Jt);const wt=Ut/st;Ut=Math.floor(Ut*Qe);const jt=Xt?1:2,Rt=Ze==="left"?0:Ge-Jt-si;return{renderMinimap:jt,minimapLeft:Rt,minimapWidth:Jt,minimapHeightIsEditorHeight:gt,minimapIsSampling:Bt,minimapScale:Et,minimapLineHeight:_t,minimapCanvasInnerWidth:Ut,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:wt,minimapCanvasOuterHeight:Ft}}static computeLayout(Z,me){const Ge=me.outerWidth|0,be=me.outerHeight|0,st=me.lineHeight|0,dt=me.lineNumbersDigitCount|0,Pt=me.typicalHalfwidthCharacterWidth,Vt=me.maxDigitWidth,Qt=me.pixelRatio,ii=me.viewLineCount,Xt=Z.get(137),Et=Xt==="inherit"?Z.get(136):Xt,Zt=Et==="inherit"?Z.get(132):Et,Yt=Z.get(135),Ze=me.isDominatedByLongLines,si=Z.get(57),Ht=Z.get(68).renderType!==0,ht=Z.get(69),ft=Z.get(105),xt=Z.get(84),Kt=Z.get(73),Ft=Z.get(103),gt=Ft.verticalScrollbarSize,Bt=Ft.verticalHasArrows,_t=Ft.arrowSize,zt=Ft.horizontalScrollbarSize,Qe=Z.get(43),ui=Z.get(110)!=="never";let Jt=Z.get(66);Qe&&ui&&(Jt+=16);let Ut=0;if(Ht){const ai=Math.max(dt,ht);Ut=Math.round(ai*Vt)}let wt=0;si&&(wt=st*me.glyphMarginDecorationLaneCount);let jt=0,Rt=jt+wt,Mt=Rt+Ut,ei=Mt+Jt;const Wt=Ge-wt-Ut-Jt;let oi=!1,Ot=!1,qt=-1;Et==="inherit"&&Ze?(oi=!0,Ot=!0):Zt==="on"||Zt==="bounded"?Ot=!0:Zt==="wordWrapColumn"&&(qt=Yt);const At=ge.c({outerWidth:Ge,outerHeight:be,lineHeight:st,typicalHalfwidthCharacterWidth:Pt,pixelRatio:Qt,scrollBeyondLastLine:ft,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Kt,verticalScrollbarWidth:gt,viewLineCount:ii,remainingWidth:Wt,isViewportWrapping:Ot},me.memory||new N);At.renderMinimap!==0&&At.minimapLeft===0&&(jt+=At.minimapWidth,Rt+=At.minimapWidth,Mt+=At.minimapWidth,ei+=At.minimapWidth);const St=Wt-At.minimapWidth,$t=Math.max(1,Math.floor((St-gt-2)/Pt)),Dt=Bt?_t:0;return Ot&&(qt=Math.max(1,$t),Zt==="bounded"&&(qt=Math.min(qt,Yt))),{width:Ge,height:be,glyphMarginLeft:jt,glyphMarginWidth:wt,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:Rt,lineNumbersWidth:Ut,decorationsLeft:Mt,decorationsWidth:Jt,contentLeft:ei,contentWidth:St,minimap:At,viewportColumn:$t,isWordWrapMinified:oi,isViewportWrapping:Ot,wrappingColumn:qt,verticalScrollbarWidth:gt,horizontalScrollbarHeight:zt,overviewRuler:{top:Dt,width:gt,height:be-2*Dt,right:0}}}}e.EditorLayoutInfoComputer=ge;class ue extends S{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(Z){return w(Z,"simple",["simple","advanced"])}compute(Z,me,Ge){return me.get(2)===2?"advanced":Ge}}var Ce;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(Ce||(e.ShowLightbulbIconMode=Ce={}));class re extends S{constructor(){const Z={enabled:Ce.On};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ce.Off,Ce.OnCode,Ce.On],default:Z.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:w(Z.enabled,this.defaultValue.enabled,[Ce.Off,Ce.OnCode,Ce.On])}}}class Ne extends S{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:p.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:w(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:r(me.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Te extends S{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:p.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:w(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily),padding:r(me.padding,this.defaultValue.padding)}}}class T extends S{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):t.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,me,Ge){return Ge<0?t.clampedInt(-Ge*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class X extends u{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>u.clamp(Z,0,150),{markdownDescription:p.localize(66,null)})}compute(Z,me,Ge){return Z.fontInfo.lineHeight}}class pe extends S{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:Z.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Z.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Z.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Z.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),autohide:r(me.autohide,this.defaultValue.autohide),size:w(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(me.side,this.defaultValue.side,["right","left"]),showSlider:w(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(me.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(me.scale,1,1,3),maxColumn:t.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:r(me.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:r(me.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp(me.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Ie(Y){return Y==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class ye extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{top:t.clampedInt(me.top,0,0,1e3),bottom:t.clampedInt(me.bottom,0,0,1e3)}}}class $e extends S{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:p.localize(84,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),cycle:r(me.cycle,this.defaultValue.cycle)}}}class fe extends f{constructor(){super(143)}compute(Z,me,Ge){return Z.pixelRatio}}class Q extends S{constructor(){const Z={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Z.strings,description:p.localize(88,null)},comments:{anyOf:me,default:Z.comments,description:p.localize(89,null)},other:{anyOf:me,default:Z.other,description:p.localize(90,null)}},default:Z,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Qt=Z?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:me,comments:Ge,strings:be}=Z,st=["on","inline","off"];let dt,Pt,Vt;return typeof me=="boolean"?dt=me?"on":"off":dt=w(me,this.defaultValue.other,st),typeof Ge=="boolean"?Pt=Ge?"on":"off":Pt=w(Ge,this.defaultValue.comments,st),typeof be=="boolean"?Vt=be?"on":"off":Vt=w(be,this.defaultValue.strings,st),{other:dt,comments:Pt,strings:Vt}}}var x;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(x||(e.RenderLineNumbersType=x={}));class le extends S{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(Z){let me=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(me=4,Ge=Z):Z==="interval"?me=3:Z==="relative"?me=2:Z==="on"?me=1:me=0),{renderType:me,renderFn:Ge}}}function ae(Y){const Z=Y.get(98);return Z==="editable"?Y.get(91):Z!=="on"}class Fe extends S{constructor(){const Z=[],me={type:"number",description:p.localize(97,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:Z,description:p.localize(99,null)})}validate(Z){if(Array.isArray(Z)){const me=[];for(const Ge of Z)if(typeof Ge=="number")me.push({column:t.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const be=Ge;me.push({column:t.clampedInt(be.column,0,0,1e4),color:be.color})}return me.sort((Ge,be)=>Ge.column-be.column),me}return this.defaultValue}}class de extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Pe(Y,Z){if(typeof Y!="string")return Z;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends S{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z,Ge=t.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),be=t.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(me.vertical,this.defaultValue.vertical),horizontal:Pe(me.horizontal,this.defaultValue.horizontal),useShadows:r(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:t.clampedInt(me.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:be,verticalSliderSize:t.clampedInt(me.verticalSliderSize,be,0,1e3),scrollByPage:r(me.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:r(me.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends S{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:p.localize(118,null)}})}applyUpdate(Z,me){let Ge=!1;me.allowedCharacters&&Z&&(O.$$n(Z.allowedCharacters,me.allowedCharacters)||(Z={...Z,allowedCharacters:me.allowedCharacters},Ge=!0)),me.allowedLocales&&Z&&(O.$$n(Z.allowedLocales,me.allowedLocales)||(Z={...Z,allowedLocales:me.allowedLocales},Ge=!0));const be=super.applyUpdate(Z,me);return Ge?new d(be.newValue,!0):be}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{nonBasicASCII:te(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:te(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:te(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,me){if(typeof Z!="object"||!Z)return me;const Ge={};for(const[be,st]of Object.entries(Z))st===!0&&(Ge[be]=!0);return Ge}}class j extends S{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(125,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),mode:w(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:w(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:r(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r(me.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily)}}}class z extends S{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:p.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),showToolbar:w(me.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string(me.fontFamily,this.defaultValue.fontFamily),keepOnBlur:r(me.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:r(me.backgroundColoring,this.defaultValue.backgroundColoring)}}}class G extends S{constructor(){const Z={enabled:F.$0s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$0s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends S{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:Z.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:Z.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:Z.highlightActiveIndentation,description:p.localize(148,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{bracketPairs:te(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:te(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:te(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function te(Y,Z,me){const Ge=me.indexOf(Y);return Ge===-1?Z:me[Ge]}class ne extends S{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:Z.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:Z.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{insertMode:w(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:w(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(me.showIcons,this.defaultValue.showIcons),showStatusBar:r(me.showStatusBar,this.defaultValue.showStatusBar),preview:r(me.preview,this.defaultValue.preview),previewMode:w(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(me.showMethods,this.defaultValue.showMethods),showFunctions:r(me.showFunctions,this.defaultValue.showFunctions),showConstructors:r(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(me.showFields,this.defaultValue.showFields),showVariables:r(me.showVariables,this.defaultValue.showVariables),showClasses:r(me.showClasses,this.defaultValue.showClasses),showStructs:r(me.showStructs,this.defaultValue.showStructs),showInterfaces:r(me.showInterfaces,this.defaultValue.showInterfaces),showModules:r(me.showModules,this.defaultValue.showModules),showProperties:r(me.showProperties,this.defaultValue.showProperties),showEvents:r(me.showEvents,this.defaultValue.showEvents),showOperators:r(me.showOperators,this.defaultValue.showOperators),showUnits:r(me.showUnits,this.defaultValue.showUnits),showValues:r(me.showValues,this.defaultValue.showValues),showConstants:r(me.showConstants,this.defaultValue.showConstants),showEnums:r(me.showEnums,this.defaultValue.showEnums),showEnumMembers:r(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(me.showKeywords,this.defaultValue.showKeywords),showWords:r(me.showWords,this.defaultValue.showWords),showColors:r(me.showColors,this.defaultValue.showColors),showFiles:r(me.showFiles,this.defaultValue.showFiles),showReferences:r(me.showReferences,this.defaultValue.showReferences),showFolders:r(me.showFolders,this.defaultValue.showFolders),showTypeParameters:r(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(me.showSnippets,this.defaultValue.showSnippets),showUsers:r(me.showUsers,this.defaultValue.showUsers),showIssues:r(me.showIssues,this.defaultValue.showIssues)}}}class Oe extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends S{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const me=[];for(const Ge of Z)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&me.push(Ge)}catch{}return me}return this.defaultValue}}var He;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class _e extends S{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,me,Ge){return me.get(2)===2?0:Ge}}class xe extends f{constructor(){super(146)}compute(Z,me,Ge){const be=me.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:be.isWordWrapMinified,isViewportWrapping:be.isViewportWrapping,wrappingColumn:be.wrappingColumn}}}class et extends S{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),showDropSelector:w(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends S{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const me=Z;return{enabled:r(me.enabled,this.defaultValue.enabled),showPasteSelector:w(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?at:R.$k?mt:it,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var rt;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=89]="quickSuggestions",Y[Y.quickSuggestionsDelay=90]="quickSuggestionsDelay",Y[Y.readOnly=91]="readOnly",Y[Y.readOnlyMessage=92]="readOnlyMessage",Y[Y.renameOnType=93]="renameOnType",Y[Y.renderControlCharacters=94]="renderControlCharacters",Y[Y.renderFinalNewline=95]="renderFinalNewline",Y[Y.renderLineHighlight=96]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=98]="renderValidationDecorations",Y[Y.renderWhitespace=99]="renderWhitespace",Y[Y.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Y[Y.roundedSelection=101]="roundedSelection",Y[Y.rulers=102]="rulers",Y[Y.scrollbar=103]="scrollbar",Y[Y.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=105]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=106]="scrollPredominantAxis",Y[Y.selectionClipboard=107]="selectionClipboard",Y[Y.selectionHighlight=108]="selectionHighlight",Y[Y.selectOnLineNumbers=109]="selectOnLineNumbers",Y[Y.showFoldingControls=110]="showFoldingControls",Y[Y.showUnused=111]="showUnused",Y[Y.snippetSuggestions=112]="snippetSuggestions",Y[Y.smartSelect=113]="smartSelect",Y[Y.smoothScrolling=114]="smoothScrolling",Y[Y.stickyScroll=115]="stickyScroll",Y[Y.stickyTabStops=116]="stickyTabStops",Y[Y.stopRenderingLineAfter=117]="stopRenderingLineAfter",Y[Y.suggest=118]="suggest",Y[Y.suggestFontSize=119]="suggestFontSize",Y[Y.suggestLineHeight=120]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Y[Y.suggestSelection=122]="suggestSelection",Y[Y.tabCompletion=123]="tabCompletion",Y[Y.tabIndex=124]="tabIndex",Y[Y.unicodeHighlighting=125]="unicodeHighlighting",Y[Y.unusualLineTerminators=126]="unusualLineTerminators",Y[Y.useShadowDOM=127]="useShadowDOM",Y[Y.useTabStops=128]="useTabStops",Y[Y.wordBreak=129]="wordBreak",Y[Y.wordSegmenterLocales=130]="wordSegmenterLocales",Y[Y.wordSeparators=131]="wordSeparators",Y[Y.wordWrap=132]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=135]="wordWrapColumn",Y[Y.wordWrapOverride1=136]="wordWrapOverride1",Y[Y.wordWrapOverride2=137]="wordWrapOverride2",Y[Y.wrappingIndent=138]="wrappingIndent",Y[Y.wrappingStrategy=139]="wrappingStrategy",Y[Y.showDeprecated=140]="showDeprecated",Y[Y.inlayHints=141]="inlayHints",Y[Y.editorClassName=142]="editorClassName",Y[Y.pixelRatio=143]="pixelRatio",Y[Y.tabFocusMode=144]="tabFocusMode",Y[Y.layoutInfo=145]="layoutInfo",Y[Y.wrappingInfo=146]="wrappingInfo",Y[Y.defaultColorDecorators=147]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(rt||(e.EditorOption=rt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Ue(new $),accessibilityPageSize:Ue(new t(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new i(4,"ariaLabel",p.localize(218,null))),ariaRequired:Ue(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Ue(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Ue(new o(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Ue(new G),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new o(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Ue(new o(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Ue(new i(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Ue(new t(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Ue(new o(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Ue(new t(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Ue(new o(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Ue(new b),contextmenu:Ue(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new o(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Ue(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Ue(new l(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:p.localize(260,null)})),cursorSurroundingLines:Ue(new t(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Ue(new t(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Ue(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new o(34,"domReadOnly",!1)),dragAndDrop:Ue(new o(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Ue(new V),dropIntoEditor:Ue(new et),stickyScroll:Ue(new Ne),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Ue(new i(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:p.localize(271,null)})),find:Ue(new W),fixedOverflowWidgets:Ue(new o(42,"fixedOverflowWidgets",!1)),folding:Ue(new o(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Ue(new o(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Ue(new o(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Ue(new t(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Ue(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Ue(new U),fontLigatures2:Ue(new q),fontSize:Ue(new K),fontWeight:Ue(new ie),fontVariations:Ue(new A),formatOnPaste:Ue(new o(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Ue(new o(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Ue(new o(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Ue(new ce),hideCursorInOverviewRuler:Ue(new o(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Ue(new ve),inDiffEditor:Ue(new o(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>u.clamp(Y,-5,20),{description:p.localize(285,null)})),lightbulb:Ue(new re),lineDecorationsWidth:Ue(new T),lineHeight:Ue(new X),lineNumbers:Ue(new le),lineNumbersMinChars:Ue(new t(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new o(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Ue(new o(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Ue(new pe),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(75,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Ue(new o(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Ue(new o(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Ue(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ie,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Ue(new t(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Ue(new o(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Ue(new t(83,"overviewRulerLanes",3,0,3)),padding:Ue(new ye),pasteAs:Ue(new tt),parameterHints:Ue(new $e),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Ue(new o(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Ue(new Q),quickSuggestionsDelay:Ue(new t(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Ue(new o(91,"readOnly",!1)),readOnlyMessage:Ue(new de),renameOnType:Ue(new o(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Ue(new o(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Ue(new t(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new o(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Ue(new Fe),scrollbar:Ue(new Ae),scrollBeyondLastColumn:Ue(new t(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Ue(new o(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Ue(new o(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Ue(new o(107,"selectionClipboard",!0,{description:p.localize(325,null),included:R.$k})),selectionHighlight:Ue(new o(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Ue(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Ue(new o(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Ue(new o(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Ue(new Te),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Ue(new Oe),smoothScrolling:Ue(new o(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Ue(new t(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ne),inlineSuggest:Ue(new j),inlineEdit:Ue(new z),inlineCompletionsAccessibilityVerbose:Ue(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Ue(new t(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new t(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new o(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Ue(new t(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Ue(new o(127,"useShadowDOM",!0)),useTabStops:Ue(new o(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new i(131,"wordSeparators",M.$$s,{description:p.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new i(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new i(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new t(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new P),defaultColorDecorators:Ue(new o(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Ue(new fe),tabFocusMode:Ue(new o(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Ue(new ge),wrappingInfo:Ue(new xe),wrappingIndent:Ue(new _e),wrappingStrategy:Ue(new ue)}}),define(ke[160],Se([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[161],Se([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[162],Se([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(ke[163],Se([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[164],Se([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[165],Se([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(ke[166],Se([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(ke[167],Se([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(ke[168],Se([9,10]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(ke[169],Se([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[170],Se([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[171],Se([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(ke[172],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[173],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[174],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[175],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[176],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[177],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[178],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[179],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[180],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[181],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[182],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[183],Se([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[184],Se([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(ke[185],Se([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(ke[186],Se([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(ke[187],Se([9,10]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ke[188],Se([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[189],Se([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[190],Se([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[191],Se([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[192],Se([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[193],Se([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[194],Se([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[195],Se([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[196],Se([1,0,14,162]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var R;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(R||(e.TokenType=R={}));function F(...D){switch(D.length){case 1:return(0,O.localize)(0,null,D[0]);case 2:return(0,O.localize)(1,null,D[0],D[1]);case 3:return(0,O.localize)(2,null,D[0],D[1],D[2]);default:return}}const M=(0,O.localize)(3,null),p=(0,O.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(N){switch(N.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return N.isTripleEq?"===":"==";case 4:return N.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return N.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return N.lexeme;case 18:return N.lexeme;case 19:return N.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(N)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(N){return this.c=N,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(N){return this.r()||this.c.charCodeAt(this.e)!==N?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(N){this.f.push({type:N,offset:this.d})}l(N){const S=this.d,d=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:d};this.g.push({offset:S,lexeme:d,additionalInfo:N}),this.f.push(v)}n(){this.m.lastIndex=this.d;const N=this.m.exec(this.c);if(N){this.e=this.d+N[0].length;const S=this.c.substring(this.d,this.e),d=m.b.get(S);d?this.k(d):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let N=this.e,S=!1,d=!1;for(;;){if(N>=this.c.length){this.e=N,this.l(p);return}const f=this.c.charCodeAt(N);if(S)S=!1;else if(f===47&&!d){N++;break}else f===91?d=!0:f===92?S=!0:f===93&&(d=!1);N++}for(;N<this.c.length&&m.a.has(this.c.charCodeAt(N));)N++;this.e=N;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=m}),define(ke[197],Se([1,0,24,32,164,311]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=m,e.$Np=D,e.$Op=N,e.$Pp=S,e.$Qp=d,e.$Rp=v,e.$Sp=f;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function m(o){return o=o.trim(),o==="*"||M.test(o)}function D(o){if(!m(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(M);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function N(o){if(!o)return null;const n=o.majorBase,t=o.majorMustEqual,c=o.minorBase;let u=o.minorMustEqual;const i=o.patchBase;let w=o.patchMustEqual;o.hasCaret&&(n===0||(u=!1),w=!1);let a=0;if(o.preRelease){const l=p.exec(o.preRelease);if(l){const[,g,$,b]=l;a=Date.UTC(Number(g),Number($)-1,Number(b))}}return{majorBase:n,majorMustEqual:t,minorBase:c,minorMustEqual:u,patchBase:i,patchMustEqual:w,isMinimum:o.hasGreaterEquals,notBefore:a}}function S(o,n,t){let c;typeof o=="string"?c=N(D(o)):c=o;let u;n instanceof Date?u=n.getTime():typeof n=="string"&&(u=new Date(n).getTime());let i;if(typeof t=="string"?i=N(D(t)):i=t,!c||!i)return!1;const w=c.majorBase,a=c.minorBase,l=c.patchBase;let g=i.majorBase,$=i.minorBase,b=i.patchBase;const y=i.notBefore;let h=i.majorMustEqual,E=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?w>g?!0:w<g?!1:a>$?!0:a<$||u&&u<y?!1:l>=b:(w===1&&g===0&&(!h||!E||!k)&&(g=1,$=0,b=0,h=!0,E=!1,k=!1),w<g?!1:w>g?!h:a<$?!1:a>$?!E:l<b?!1:l>b?!k:!(u&&u<y))}function d(o,n,t,c,u){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([O.default.Error,R.localize(0,null)]),i;if(typeof c.name!="string")return i.push([O.default.Error,R.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([O.default.Error,R.localize(2,null,"version")]),i;if(!c.engines)return i.push([O.default.Error,R.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([O.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!r(c.extensionDependencies))return i.push([O.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!r(c.activationEvents))return i.push([O.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([O.default.Error,R.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([O.default.Warning,R.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([O.default.Error,R.localize(9,null,"main")]),i;{const l=(0,C.$bh)(t,c.main);(0,C.$8g)(l,t)||i.push([O.default.Warning,R.localize(10,null,l.path,t.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([O.default.Error,R.localize(11,null,"browser")]),i;{const l=(0,C.$bh)(t,c.browser);(0,C.$8g)(l,t)||i.push([O.default.Warning,R.localize(12,null,l.path,t.path)])}}if(!F.valid(c.version))return i.push([O.default.Error,R.localize(13,null)]),i;const w=[];if(!v(o,n,c,u,w))for(const l of w)i.push([O.default.Error,l]);return i}function v(o,n,t,c,u){return c||typeof t.main>"u"&&typeof t.browser>"u"?!0:s(o,n,t.engines.vscode,u)}function f(o,n,t){return o==="*"||s(n,t,o)}function s(o,n,t,c=[]){const u=N(D(t));if(!u)return c.push(R.localize(14,null,t)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(R.localize(15,null,t)),!1}else if(!u.majorMustEqual)return c.push(R.localize(16,null,t)),!1;return S(o,n,u)?!0:(c.push(R.localize(17,null,o,t)),!1)}function r(o){if(!Array.isArray(o))return!1;for(let n=0,t=o.length;n<t;n++)if(typeof o[n]!="string")return!1;return!0}}),define(ke[71],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class C{constructor(R,F=[],M=!1){this.ctor=R,this.staticArguments=F,this.supportsDelayedInstantiation=M}}e.$xi=C}),define(ke[56],Se([1,0,71]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ds=F,e.$Es=M;const O=[];var R;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function F(p,m,D){m instanceof C.$xi||(m=new C.$xi(m,[],!!D)),O.push([p,m])}function M(){return O}}),define(ke[198],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;class C{constructor(F,M){this.key=F,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$gr=C;class O{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const M of this.a.values())M.outgoing.size===0&&F.push(M);return F}insertEdge(F,M){const p=this.lookupOrInsertNode(F),m=this.lookupOrInsertNode(M);p.outgoing.set(m.key,m),m.incoming.set(p.key,p)}removeNode(F){const M=this.b(F);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(F){const M=this.b(F);let p=this.a.get(M);return p||(p=new C(M,F),this.a.set(M,p)),p}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[M,p]of this.a)F.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,M]of this.a){const p=new Set([F]),m=this.c(M,p);if(m)return m}}c(F,M){for(const[p,m]of F.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const D=this.c(m,M);if(D)return D;M.delete(p)}}}e.$hr=O}),define(ke[3],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=R,e.$Bi=F;var C;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p(m){return m[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(C||(e._util=C={})),e.$zi=R("instantiationService");function O(M,p,m){p[C.DI_TARGET]===p?p[C.DI_DEPENDENCIES].push({id:M,index:m}):(p[C.DI_DEPENDENCIES]=[{id:M,index:m}],p[C.DI_TARGET]=p)}function R(M){if(C.serviceIds.has(M))return C.serviceIds.get(M);const p=function(m,D,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(p,m,N)};return p.toString=()=>M,C.serviceIds.set(M,p),p}function F(M){return M}}),define(ke[50],Se([1,0,15,2,3]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=F,e.$9i=M,e.$0i=m,e.$$i=D,e.$_i=N,e.$aj=S,e.$bj=d,e.$cj=f,e.$dj=s,e.$ej=r,e.$7i=(0,R.$Ai)("configurationService");function F(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}var p;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function m(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function D(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function N(o,n){const t=Object.create(null);for(const c in o)S(t,c,o[c],n);return t}function S(o,n,t,c){const u=n.split("."),i=u.pop();let w=o;for(let a=0;a<u.length;a++){const l=u[a];let g=w[l];switch(typeof g){case"undefined":g=w[l]=Object.create(null);break;case"object":if(g===null){c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is ${JSON.stringify(g)}`);return}w=g}if(typeof w=="object"&&w!==null)try{w[i]=t}catch{c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(w)}`)}else c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(w)}`)}function d(o,n){const t=n.split(".");v(o,t)}function v(o,n){const t=n.shift();if(n.length===0){delete o[t];return}if(Object.keys(o).indexOf(t)!==-1){const c=o[t];typeof c=="object"&&!Array.isArray(c)&&(v(c,n),Object.keys(c).length===0&&delete o[t])}}function f(o,n,t){function c(w,a){let l=w;for(const g of a){if(typeof l!="object"||l===null)return;l=l[g]}return l}const u=n.split("."),i=c(o,u);return typeof i>"u"?t:i}function s(o,n,t){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in o?C.$cg(o[c])&&C.$cg(n[c])?s(o[c],n[c],t):t&&(o[c]=n[c]):o[c]=n[c])})}function r(o){return o.replace(/[\[\]]/g,"")}}),define(ke[31],Se([1,0,23,13,196,3,161,14]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=D,e.$zj=w,e.$Aj=a,e.$Tj=Ce;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",C.$j),m.set("isLinux",C.$k),m.set("isWindows",C.$i),m.set("isWeb",C.$o),m.set("isMacNative",C.$j&&!C.$o),m.set("isEdge",C.$H),m.set("isFirefox",C.$F),m.set("isChrome",C.$E),m.set("isSafari",C.$G);function D(Te,T){if(m.get(Te)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(Te,T)}const N=Object.prototype.hasOwnProperty;var S;(function(Te){Te[Te.False=0]="False",Te[Te.True=1]="True",Te[Te.Defined=2]="Defined",Te[Te.Not=3]="Not",Te[Te.Equals=4]="Equals",Te[Te.NotEquals=5]="NotEquals",Te[Te.And=6]="And",Te[Te.Regex=7]="Regex",Te[Te.NotRegex=8]="NotRegex",Te[Te.Or=9]="Or",Te[Te.In=10]="In",Te[Te.NotIn=11]="NotIn",Te[Te.Greater=12]="Greater",Te[Te.GreaterEquals=13]="GreaterEquals",Te[Te.Smaller=14]="Smaller",Te[Te.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const d={regexParsingWithErrorRecovery:!0},v=(0,M.localize)(0,null),f=(0,M.localize)(1,null),s=(0,M.localize)(2,null),r=(0,M.localize)(3,null),o=(0,M.localize)(4,null),n=(0,M.localize)(5,null),t=(0,M.localize)(6,null),c=(0,M.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(T=d){this.k=T,this.d=new R.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(T){if(T===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(T).scan(),this.g=0,this.h=[];try{const X=this.l();if(!this.E()){const pe=this.D(),Ie=pe.type===17?n:void 0;throw this.h.push({message:o,offset:pe.offset,lexeme:R.$vj.getLexeme(pe),additionalInfo:Ie}),u.c}return X}catch(X){if(X!==u.c)throw X;return}}l(){return this.m()}m(){const T=[this.o()];for(;this.y(16);){const X=this.o();T.push(X)}return T.length===1?T[0]:i.or(...T)}o(){const T=[this.s()];for(;this.y(15);){const X=this.s();T.push(X)}return T.length===1?T[0]:i.and(...T)}s(){if(this.y(2)){const T=this.D();switch(T.type){case 11:return this.z(),g.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const X=this.l();return this.A(1,r),X?.negate()}case 17:return this.z(),I.create(T.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",T)}}return this.t()}t(){const T=this.D();switch(T.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const X=this.l();return this.A(1,r),X}case 17:{const X=T.lexeme;if(this.z(),this.y(9)){const Ie=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ie.type!==10)throw this.B("REGEX",Ie);const ye=Ie.lexeme,$e=ye.lastIndexOf("/"),fe=$e===ye.length-1?void 0:this.w(ye.substring($e+1));let Q;try{Q=new RegExp(ye.substring(1,$e),fe)}catch{throw this.B("REGEX",Ie)}return U.create(X,Q)}switch(Ie.type){case 10:case 19:{const ye=[Ie.lexeme];this.z();let $e=this.D(),fe=0;for(let Fe=0;Fe<Ie.lexeme.length;Fe++)Ie.lexeme.charCodeAt(Fe)===40?fe++:Ie.lexeme.charCodeAt(Fe)===41&&fe--;for(;!this.E()&&$e.type!==15&&$e.type!==16;){switch($e.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let Fe=0;Fe<$e.lexeme.length;Fe++)$e.lexeme.charCodeAt(Fe)===40?fe++:Ie.lexeme.charCodeAt(Fe)===41&&fe--}if(fe<0)break;ye.push(R.$vj.getLexeme($e)),this.z(),$e=this.D()}const Q=ye.join(""),x=Q.lastIndexOf("/"),le=x===Q.length-1?void 0:this.w(Q.substring(x+1));let ae;try{ae=new RegExp(Q.substring(1,x),le)}catch{throw this.B("REGEX",Ie)}return i.regex(X,ae)}case 18:{const ye=Ie.lexeme;this.z();let $e=null;if(!(0,O.$$e)(ye)){const fe=ye.indexOf("/"),Q=ye.lastIndexOf("/");if(fe!==Q&&fe>=0){const x=ye.slice(fe+1,Q),le=ye[Q+1]==="i"?"i":"";try{$e=new RegExp(x,le)}catch{throw this.B("REGEX",Ie)}}}if($e===null)throw this.B("REGEX",Ie);return U.create(X,$e)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Ie=this.u();return i.notIn(X,Ie)}switch(this.D().type){case 3:{this.z();const Ie=this.u();if(this.x().type===18)return i.equals(X,Ie);switch(Ie){case"true":return i.has(X);case"false":return i.not(X);default:return i.equals(X,Ie)}}case 4:{this.z();const Ie=this.u();if(this.x().type===18)return i.notEquals(X,Ie);switch(Ie){case"true":return i.not(X);case"false":return i.has(X);default:return i.notEquals(X,Ie)}}case 5:return this.z(),q.create(X,this.u());case 6:return this.z(),A.create(X,this.u());case 7:return this.z(),V.create(X,this.u());case 8:return this.z(),W.create(X,this.u());case 13:return this.z(),i.in(X,this.u());default:return i.has(X)}}case 20:throw this.h.push({message:t,offset:T.offset,lexeme:"",additionalInfo:c}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const T=this.D();switch(T.type){case 17:case 18:return this.z(),T.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(T){return T.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(T){return this.C(T)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(T,X){if(this.C(T))return this.z();throw this.B(X,this.D())}B(T,X,pe){const Ie=(0,M.localize)(8,null,T,R.$vj.getLexeme(X)),ye=X.offset,$e=R.$vj.getLexeme(X);return this.h.push({message:Ie,offset:ye,lexeme:$e,additionalInfo:pe}),u.c}C(T){return this.D().type===T}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$xj=u;class i{static false(){return g.INSTANCE}static true(){return $.INSTANCE}static has(T){return b.create(T)}static equals(T,X){return y.create(T,X)}static notEquals(T,X){return k.create(T,X)}static regex(T,X){return U.create(T,X)}static in(T,X){return h.create(T,X)}static notIn(T,X){return E.create(T,X)}static not(T){return I.create(T)}static and(...T){return ce.create(T,null,!0)}static or(...T){return ve.create(T,null,!0)}static greater(T,X){return V.create(T,X)}static greaterEquals(T,X){return W.create(T,X)}static smaller(T,X){return q.create(T,X)}static smallerEquals(T,X){return A.create(T,X)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(T){return T==null?void 0:this.c.parse(T)}}e.$yj=i;function w(Te){const T=new u({regexParsingWithErrorRecovery:!1});return Te.map(X=>(T.parse(X),T.lexingErrors.length>0?T.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,M.localize)(9,null,pe.additionalInfo):(0,M.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):T.parsingErrors.length>0?T.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}function a(Te,T){const X=Te?Te.substituteConstants():void 0,pe=T?T.substituteConstants():void 0;return!X&&!pe?!0:!X||!pe?!1:X.equals(pe)}function l(Te,T){return Te.cmp(T)}class g{static{this.INSTANCE=new g}constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return $.INSTANCE}}e.$Bj=g;class ${static{this.INSTANCE=new $}constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return g.INSTANCE}}e.$Cj=$;class b{static create(T,X=null){const pe=m.get(T);return typeof pe=="boolean"?pe?$.INSTANCE:g.INSTANCE:new b(T,X)}constructor(T,X){this.key=T,this.c=X,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:ge(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=m.get(this.key);return typeof T=="boolean"?T?$.INSTANCE:g.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$Dj=b;class y{static create(T,X,pe=null){if(typeof X=="boolean")return X?b.create(T,pe):I.create(T,pe);const Ie=m.get(T);return typeof Ie=="boolean"?X===(Ie?"true":"false")?$.INSTANCE:g.INSTANCE:new y(T,X,pe)}constructor(T,X,pe){this.c=T,this.d=X,this.f=pe,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:ue(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=m.get(this.c);if(typeof T=="boolean"){const X=T?"true":"false";return this.d===X?$.INSTANCE:g.INSTANCE}return this}evaluate(T){return T.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(T){return T.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Ej=y;class h{static create(T,X){return new h(T,X)}constructor(T,X){this.d=T,this.f=X,this.type=10,this.c=null}cmp(T){return T.type!==this.type?this.type-T.type:ue(this.d,this.f,T.d,T.f)}equals(T){return T.type===this.type?this.d===T.d&&this.f===T.f:!1}substituteConstants(){return this}evaluate(T){const X=T.getValue(this.f),pe=T.getValue(this.d);return Array.isArray(X)?X.includes(pe):typeof pe=="string"&&typeof X=="object"&&X!==null?N.call(X,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(T){return T.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Fj=h;class E{static create(T,X){return new E(T,X)}constructor(T,X){this.d=T,this.f=X,this.type=11,this.c=h.create(T,X)}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(T){return T.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=E;class k{static create(T,X,pe=null){if(typeof X=="boolean")return X?I.create(T,pe):b.create(T,pe);const Ie=m.get(T);return typeof Ie=="boolean"?X===(Ie?"true":"false")?g.INSTANCE:$.INSTANCE:new k(T,X,pe)}constructor(T,X,pe){this.c=T,this.d=X,this.f=pe,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:ue(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=m.get(this.c);if(typeof T=="boolean"){const X=T?"true":"false";return this.d===X?g.INSTANCE:$.INSTANCE}return this}evaluate(T){return T.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(T){return T.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Hj=k;class I{static create(T,X=null){const pe=m.get(T);return typeof pe=="boolean"?pe?g.INSTANCE:$.INSTANCE:new I(T,X)}constructor(T,X){this.c=T,this.d=X,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:ge(this.c,T.c)}equals(T){return T.type===this.type?this.c===T.c:!1}substituteConstants(){const T=m.get(this.c);return typeof T=="boolean"?T?g.INSTANCE:$.INSTANCE:this}evaluate(T){return!T.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(T){return T.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Ij=I;function P(Te,T){if(typeof Te=="string"){const X=parseFloat(Te);isNaN(X)||(Te=X)}return typeof Te=="string"||typeof Te=="number"?T(Te):g.INSTANCE}class V{static create(T,X,pe=null){return P(X,Ie=>new V(T,Ie,pe))}constructor(T,X,pe){this.c=T,this.d=X,this.f=pe,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:ue(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Jj=V;class W{static create(T,X,pe=null){return P(X,Ie=>new W(T,Ie,pe))}constructor(T,X,pe){this.c=T,this.d=X,this.f=pe,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:ue(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Kj=W;class q{static create(T,X,pe=null){return P(X,Ie=>new q(T,Ie,pe))}constructor(T,X,pe){this.c=T,this.d=X,this.f=pe,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:ue(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Lj=q;class A{static create(T,X,pe=null){return P(X,Ie=>new A(T,Ie,pe))}constructor(T,X,pe){this.c=T,this.d=X,this.f=pe,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:ue(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Mj=A;class U{static create(T,X){return new U(T,X)}constructor(T,X){this.d=T,this.f=X,this.type=7,this.c=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.d<T.d)return-1;if(this.d>T.d)return 1;const X=this.f?this.f.source:"",pe=T.f?T.f.source:"";return X<pe?-1:X>pe?1:0}equals(T){if(T.type===this.type){const X=this.f?this.f.source:"",pe=T.f?T.f.source:"";return this.d===T.d&&X===pe}return!1}substituteConstants(){return this}evaluate(T){const X=T.getValue(this.d);return this.f?this.f.test(X):!1}serialize(){const T=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${T}`}keys(){return[this.d]}map(T){return T.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Nj=U;class K{static create(T){return new K(T)}constructor(T){this.c=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(T){return new K(this.c.map(T))}negate(){return this.c}}e.$Oj=K;function ie(Te){let T=null;for(let X=0,pe=Te.length;X<pe;X++){const Ie=Te[X].substituteConstants();if(Te[X]!==Ie&&T===null){T=[];for(let ye=0;ye<X;ye++)T[ye]=Te[ye]}T!==null&&(T[X]=Ie)}return T===null?Te:T}class ce{static create(T,X,pe){return ce.d(T,X,pe)}constructor(T,X){this.expr=T,this.c=X,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let X=0,pe=this.expr.length;X<pe;X++){const Ie=l(this.expr[X],T.expr[X]);if(Ie!==0)return Ie}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let X=0,pe=this.expr.length;X<pe;X++)if(!this.expr[X].equals(T.expr[X]))return!1;return!0}return!1}substituteConstants(){const T=ie(this.expr);return T===this.expr?this:ce.create(T,this.c,!1)}evaluate(T){for(let X=0,pe=this.expr.length;X<pe;X++)if(!this.expr[X].evaluate(T))return!1;return!0}static d(T,X,pe){const Ie=[];let ye=!1;for(const $e of T)if($e){if($e.type===1){ye=!0;continue}if($e.type===0)return g.INSTANCE;if($e.type===6){Ie.push(...$e.expr);continue}Ie.push($e)}if(Ie.length===0&&ye)return $.INSTANCE;if(Ie.length!==0){if(Ie.length===1)return Ie[0];Ie.sort(l);for(let $e=1;$e<Ie.length;$e++)Ie[$e-1].equals(Ie[$e])&&(Ie.splice($e,1),$e--);if(Ie.length===1)return Ie[0];for(;Ie.length>1;){const $e=Ie[Ie.length-1];if($e.type!==9)break;Ie.pop();const fe=Ie.pop(),Q=Ie.length===0,x=ve.create($e.expr.map(le=>ce.create([le,fe],null,pe)),null,Q);x&&(Ie.push(x),Ie.sort(l))}if(Ie.length===1)return Ie[0];if(pe){for(let $e=0;$e<Ie.length;$e++)for(let fe=$e+1;fe<Ie.length;fe++)if(Ie[$e].negate().equals(Ie[fe]))return g.INSTANCE;if(Ie.length===1)return Ie[0]}return new ce(Ie,X)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const X of this.expr)T.push(...X.keys());return T}map(T){return new ce(this.expr.map(X=>X.map(T)),null)}negate(){if(!this.c){const T=[];for(const X of this.expr)T.push(X.negate());this.c=ve.create(T,this,!0)}return this.c}}e.$Pj=ce;class ve{static create(T,X,pe){return ve.d(T,X,pe)}constructor(T,X){this.expr=T,this.c=X,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let X=0,pe=this.expr.length;X<pe;X++){const Ie=l(this.expr[X],T.expr[X]);if(Ie!==0)return Ie}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let X=0,pe=this.expr.length;X<pe;X++)if(!this.expr[X].equals(T.expr[X]))return!1;return!0}return!1}substituteConstants(){const T=ie(this.expr);return T===this.expr?this:ve.create(T,this.c,!1)}evaluate(T){for(let X=0,pe=this.expr.length;X<pe;X++)if(this.expr[X].evaluate(T))return!0;return!1}static d(T,X,pe){let Ie=[],ye=!1;if(T){for(let $e=0,fe=T.length;$e<fe;$e++){const Q=T[$e];if(Q){if(Q.type===0){ye=!0;continue}if(Q.type===1)return $.INSTANCE;if(Q.type===9){Ie=Ie.concat(Q.expr);continue}Ie.push(Q)}}if(Ie.length===0&&ye)return g.INSTANCE;Ie.sort(l)}if(Ie.length!==0){if(Ie.length===1)return Ie[0];for(let $e=1;$e<Ie.length;$e++)Ie[$e-1].equals(Ie[$e])&&(Ie.splice($e,1),$e--);if(Ie.length===1)return Ie[0];if(pe){for(let $e=0;$e<Ie.length;$e++)for(let fe=$e+1;fe<Ie.length;fe++)if(Ie[$e].negate().equals(Ie[fe]))return $.INSTANCE;if(Ie.length===1)return Ie[0]}return new ve(Ie,X)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const X of this.expr)T.push(...X.keys());return T}map(T){return new ve(this.expr.map(X=>X.map(T)),null)}negate(){if(!this.c){const T=[];for(const X of this.expr)T.push(X.negate());for(;T.length>1;){const X=T.shift(),pe=T.shift(),Ie=[];for(const ye of Ne(X))for(const $e of Ne(pe))Ie.push(ce.create([ye,$e],null,!1));T.unshift(ve.create(Ie,null,!1))}this.c=ve.create(T,this,!0)}return this.c}}e.$Qj=ve;class Ee extends b{static{this.d=[]}static all(){return Ee.d.values()}constructor(T,X,pe){super(T,null),this.f=X,typeof pe=="object"?Ee.d.push({...pe,key:T}):pe!==!0&&Ee.d.push({key:T,description:pe,type:X!=null?typeof X:void 0})}bindTo(T){return T.createKey(this.key,this.f)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return y.create(this.key,T)}notEqualsTo(T){return k.create(this.key,T)}}e.$Rj=Ee,e.$Sj=(0,F.$Ai)("contextKeyService");function ge(Te,T){return Te<T?-1:Te>T?1:0}function ue(Te,T,X,pe){return Te<X?-1:Te>X?1:T<pe?-1:T>pe?1:0}function Ce(Te,T){if(Te.type===0||T.type===1)return!0;if(Te.type===9)return T.type===9?re(Te.expr,T.expr):!1;if(T.type===9){for(const X of T.expr)if(Ce(Te,X))return!0;return!1}if(Te.type===6){if(T.type===6)return re(T.expr,Te.expr);for(const X of Te.expr)if(Ce(X,T))return!0;return!1}return Te.equals(T)}function re(Te,T){let X=0,pe=0;for(;X<Te.length&&pe<T.length;){const Ie=Te[X].cmp(T[pe]);if(Ie<0)return!1;Ie===0&&X++,pe++}return X===Te.length}function Ne(Te){return Te.type===9?Te.expr:[Te]}}),define(ke[99],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,C.$Ai)("environmentService"),e.$Ii=(0,C.$Bi)(e.$Hi)}),define(ke[100],Se([1,0,163,3]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.ExtensionManagementErrorCode=e.$ap=e.ExtensionGalleryErrorCode=e.$_o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0,e.$6o=F,e.$7o=M,e.$8o=p,e.$9o=m,e.$0o=D,e.$$o=N,e.$Yo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Zo=new RegExp(e.$Yo),e.$1o="__web_extension",e.$2o="skipWalkthrough",e.$3o="extensionInstallSource",e.$4o="dependecyOrPackExtensionInstall",e.$5o="clientTargetPlatform";var R;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function F(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function M(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function p(t,c){switch(t){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(t,c){return c==="web"&&!t.includes("web")}function D(t,c,u){return m(c,u)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===u}function N(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var S;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var v;(function(t){t.Install="install",t.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var f;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$_o=(0,O.$Ai)("extensionGalleryService");var s;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(s||(e.ExtensionGalleryErrorCode=s={}));class r extends Error{constructor(c,u){super(c),this.code=u,this.name=u}}e.$ap=r;var o;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(o||(e.ExtensionManagementErrorCode=o={}));class n extends Error{constructor(c,u){super(c),this.code=u,this.name=u}}e.$bp=n,e.$cp=(0,O.$Ai)("extensionManagementService"),e.$dp="extensionsIdentifiers/disabled",e.$ep="extensionsIdentifiers/enabled",e.$fp=(0,O.$Ai)("IGlobalExtensionEnablementService"),e.$gp=(0,O.$Ai)("IExtensionTipsService"),e.$hp=(0,C.localize2)(0,"Extensions"),e.$ip=(0,C.localize2)(1,"Preferences")}),define(ke[38],Se([1,0,54,19,13,15,2,165,3,23,16,43]),function(he,e,C,O,R,F,M,p,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=d,e.$9k=r,e.$0k=n,e.$$k=t,e.$_k=c,e.$al=u,e.$bl=i,e.$cl=w,e.$dl=a,e.$el=l,e.$fl=g,e.$hl=y,e.$il=h,e.$jl=E,e.$kl=k,e.$ll=I,e.$ol=A,e.$Al=Ee,e.$Bl=ge,e.$Dl=Ce,e.$7k=(0,m.$Ai)("fileService");function d(re){return re.create===!0}var v;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var f;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var s;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(s||(e.FileChangeFilter=s={}));function r(re){const Ne=re;return!!Ne&&typeof Ne.onDidChange=="function"}var o;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function n(re){return!!(re.capabilities&2)}function t(re){return!!(re.capabilities&8)}function c(re){return!!(re.capabilities&131072)}function u(re){return!!(re.capabilities&4)}function i(re){return!!(re.capabilities&16)}function w(re){return n(re)?!!(re.capabilities&16384):!1}function a(re){return n(re)?!!(re.capabilities&32768):!1}function l(re){return!!(re.capabilities&65536)}function g(re){return!!(re.capabilities&2048)}var $;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})($||(e.FileSystemProviderErrorCode=$={}));class b extends Error{static create(Ne,Te){const T=new b(Ne.toString(),Te);return E(T,Te),T}constructor(Ne,Te){super(Ne),this.code=Te}}e.$gl=b;function y(re,Ne){return b.create(re,Ne)}function h(re){return re||y((0,p.localize)(0,null),$.Unknown)}function E(re,Ne){return re.name=Ne?`${Ne} (FileSystemError)`:"FileSystemError",re}function k(re){if(!re)return $.Unknown;if(re instanceof b)return re.code;const Ne=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Ne)return $.Unknown;switch(Ne[1]){case $.FileExists:return $.FileExists;case $.FileIsADirectory:return $.FileIsADirectory;case $.FileNotADirectory:return $.FileNotADirectory;case $.FileNotFound:return $.FileNotFound;case $.FileTooLarge:return $.FileTooLarge;case $.FileWriteLocked:return $.FileWriteLocked;case $.NoPermissions:return $.NoPermissions;case $.Unavailable:return $.Unavailable}return $.Unknown}function I(re){if(re instanceof U)return re.fileOperationResult;switch(k(re)){case $.FileNotFound:return 1;case $.FileIsADirectory:return 0;case $.FileNotADirectory:return 9;case $.FileWriteLocked:return 5;case $.NoPermissions:return 6;case $.FileExists:return 4;case $.FileTooLarge:return 7;default:return 10}}var P;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class V{constructor(Ne,Te,T){this.resource=Ne,this.operation=Te,this.target=T}isOperation(Ne){return this.operation===Ne}}e.$ml=V;var W;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class q{static{this.a=null}constructor(Ne,Te){this.c=Te,this.b=void 0,this.d=new S.$V(()=>{const T=C.$Gi.forUris(()=>this.c);return T.fill(this.rawAdded.map(X=>[X,!0])),T}),this.f=new S.$V(()=>{const T=C.$Gi.forUris(()=>this.c);return T.fill(this.rawUpdated.map(X=>[X,!0])),T}),this.g=new S.$V(()=>{const T=C.$Gi.forUris(()=>this.c);return T.fill(this.rawDeleted.map(X=>[X,!0])),T}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const T of Ne){switch(T.type){case 1:this.rawAdded.push(T.resource);break;case 0:this.rawUpdated.push(T.resource);break;case 2:this.rawDeleted.push(T.resource);break}this.b!==q.a&&(typeof T.cId=="number"?this.b===void 0?this.b=T.cId:this.b!==T.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ne,...Te){return this.h(Ne,{includeChildren:!1},...Te)}affects(Ne,...Te){return this.h(Ne,{includeChildren:!0},...Te)}h(Ne,Te,...T){if(!Ne)return!1;const X=T.length>0;return!!((!X||T.includes(1))&&(this.d.value.get(Ne)||Te.includeChildren&&this.d.value.findSuperstr(Ne))||(!X||T.includes(0))&&(this.f.value.get(Ne)||Te.includeChildren&&this.f.value.findSuperstr(Ne))||(!X||T.includes(2))&&(this.g.value.findSubstr(Ne)||Te.includeChildren&&this.g.value.findSuperstr(Ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ne){return this.b===Ne}hasCorrelation(){return typeof this.b=="number"}}e.$nl=q;function A(re,Ne,Te){return!re||!Ne||re===Ne||Ne.length>re.length?!1:(Ne.charAt(Ne.length-1)!==O.sep&&(Ne+=O.sep),Te?(0,R.$Cf)(re,Ne):re.indexOf(Ne)===0)}class U extends Error{constructor(Ne,Te,T){super(Ne),this.fileOperationResult=Te,this.options=T}}e.$pl=U;class K extends U{constructor(Ne,Te,T,X){super(Ne,Te,X),this.fileOperationResult=Te,this.size=T}}e.$ql=K;class ie extends U{constructor(Ne,Te,T){super(Ne,2,T),this.stat=Te}}e.$rl=ie;var ce;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var ve;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ve||(e.FileKind=ve={})),e.$zl="";function Ee(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function ge(re,Ne){if(!Ne.hasProvider(M.URI.from({scheme:re.scheme})))return new Promise(Te=>{const T=Ne.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===re.scheme&&X.added&&(T.dispose(),Te())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Ne){return(0,F.$eg)(Ne)||(Ne=0),Ne<ue.KB?(0,p.localize)(1,null,Ne.toFixed(0)):Ne<ue.MB?(0,p.localize)(2,null,(Ne/ue.KB).toFixed(2)):Ne<ue.GB?(0,p.localize)(3,null,(Ne/ue.MB).toFixed(2)):Ne<ue.TB?(0,p.localize)(4,null,(Ne/ue.GB).toFixed(2)):(0,p.localize)(5,null,(Ne/ue.TB).toFixed(2))}}e.$Cl=ue;function Ce(re){const Ne=typeof re=="string"||re?.scheme===N.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===N.Schemas.file?1024*ue.MB:Ne?10*ue.MB:D.$o?50*ue.MB:1024*ue.MB}}),define(ke[72],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class C{constructor(...R){this.a=new Map;for(const[F,M]of R)this.set(F,M)}set(R,F){const M=this.a.get(R);return this.a.set(R,F),M}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$yi=C}),define(ke[199],Se([1,0,11,14,6,71,198,3,72,200]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=void 0;const N=!1;class S extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class d{constructor(r=new m.$yi,o=!1,n,t=N){this.i=r,this.j=o,this.k=n,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$zi,this),this._globalGraph=t?n?._globalGraph??new M.$hr(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Pc)(this.h),this.h.clear();for(const r of this.g)(0,R.$Oc)(r)&&r.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(r,o){this.m();const n=new class extends d{dispose(){this.h.delete(n),super.dispose()}}(r,this.j,this,this.l);return this.h.add(n),o?.add(n),n}invokeFunction(r,...o){this.m();const n=f.traceInvocation(this.l,r);let t=!1;try{return r({get:u=>{if(t)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(u,n);if(!i)throw new Error(`[invokeFunction] unknown service '${u}'`);return i}},...o)}finally{t=!0,n.stop()}}createInstance(r,...o){this.m();let n,t;return r instanceof F.$xi?(n=f.traceCreation(this.l,r.ctor),t=this.o(r.ctor,r.staticArguments.concat(o),n)):(n=f.traceCreation(this.l,r),t=this.o(r,o,n)),n.stop(),t}o(r,o=[],n){const t=p._util.getServiceDependencies(r).sort((i,w)=>i.index-w.index),c=[];for(const i of t){const w=this.s(i.id,n);w||this.y(`[createInstance] ${r.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(w)}const u=t.length>0?t[0].index:o.length;if(o.length!==u){console.trace(`[createInstance] First service dependency of ${r.name} at position ${u+1} conflicts with ${o.length} static arguments`);const i=u-o.length;i>0?o=o.concat(new Array(i)):o=o.slice(0,u)}return Reflect.construct(r,o.concat(c))}q(r,o){if(this.i.get(r)instanceof F.$xi)this.i.set(r,o);else if(this.k)this.k.q(r,o);else throw new Error("illegalState - setting UNKNOWN service instance")}r(r){const o=this.i.get(r);return!o&&this.k?this.k.r(r):o}s(r,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const n=this.r(r);return n instanceof F.$xi?this.u(r,n,o.branch(r,!0)):(o.branch(r,!1),n)}u(r,o,n){if(this.t.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.t.add(r);try{return this.v(r,o,n)}finally{this.t.delete(r)}}v(r,o,n){const t=new M.$hr(i=>i.id.toString());let c=0;const u=[{id:r,desc:o,_trace:n}];for(;u.length;){const i=u.pop();if(t.lookupOrInsertNode(i),c++>1e3)throw new S(t);for(const w of p._util.getServiceDependencies(i.desc.ctor)){const a=this.r(w.id);if(a||this.y(`[createInstance] ${r} depends on ${w.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(w.id)),a instanceof F.$xi){const l={id:w.id,desc:a,_trace:i._trace.branch(w.id,!0)};t.insertEdge(i,l),u.push(l)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new S(t);break}for(const{data:w}of i){if(this.r(w.id)instanceof F.$xi){const l=this.w(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this.q(w.id,l)}t.removeNode(w)}}return this.r(r)}w(r,o,n=[],t,c){if(this.i.get(r)instanceof F.$xi)return this.x(r,o,n,t,c,this.g);if(this.k)return this.k.w(r,o,n,t,c);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}x(r,o,n=[],t,c,u){if(t){const i=new d(void 0,this.j,this,this.l);i.c=String(r);const w=new Map,a=new C.$Th(()=>{const l=i.o(o,n,c);for(const[g,$]of w){const b=l[g];if(typeof b=="function")for(const y of $)y.disposable=b.apply(l,y.listener)}return w.clear(),u.add(l),l});return new Proxy(Object.create(null),{get(l,g){if(!a.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let y=w.get(g);return y||(y=new D.$5c,w.set(g,y)),(E,k,I)=>{if(a.isInitialized)return a.value[g](E,k,I);{const P={listener:[E,k,I],disposable:void 0},V=y.push(P);return(0,R.$Sc)(()=>{V(),P.disposable?.dispose()})}}}if(g in l)return l[g];const $=a.value;let b=$[g];return typeof b!="function"||(b=b.bind($),l[g]=b),b},set(l,g,$){return a.value[g]=$,!0},getPrototypeOf(l){return o.prototype}})}else{const i=this.o(o,n,c);return u.add(i),i}}y(r,o){if(o&&console.warn(r),this.j)throw new Error(r)}}e.$ir=d;var v;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(v||(v={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,o){return r?new f(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(r,o){return r?new f(1,o.name):f.c}static{this.f=0}constructor(r,o){this.type=r,this.name=o,this.g=Date.now(),this.h=[]}branch(r,o){const n=new f(3,r.toString());return this.h.push([r,o,n]),n}stop(){const r=Date.now()-this.g;f.f+=r;let o=!1;function n(c,u){const i=[],w=new Array(c+1).join("	");for(const[a,l,g]of u.h)if(l&&g){o=!0,i.push(`${w}CREATES -> ${a}`);const $=n(c+1,g);$&&i.push($)}else i.push(`${w}uses -> ${a}`);return i.join(`
`)}const t=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(r>2||o)&&f.all.add(t.join(`
`))}}e.$jr=f}),define(ke[12],Se([1,0,166,44,5,73,6,28,23,24,15,2,31,3]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=s,e.log=o,e.$ik=b,e.$jk=y,e.$kk=h,e.$lk=E,e.$7j=(0,v.$Ai)("logService"),e.$8j=(0,v.$Ai)("loggerService");function f(){return new Date().toISOString()}function s(k){return(0,N.$eg)(k)}var r;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$0j=r.Info;function o(k,I,P){switch(I){case r.Trace:k.trace(P);break;case r.Debug:k.debug(P);break;case r.Info:k.info(P);break;case r.Warning:k.warn(P);break;case r.Error:k.error(P);break;case r.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function n(k,I=!1){let P="";for(let V=0;V<k.length;V++){let W=k[V];if(W instanceof Error&&(W=(0,O.$lj)(W,I)),typeof W=="object")try{W=JSON.stringify(W)}catch{}P+=(V>0?" ":"")+W}return P}class t extends M.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new R.$he),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==r.Off&&this.b<=I}}e.$_j=t;class c extends t{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...P){this.f(r.Trace)&&this.g(r.Trace,n([I,...P],!0))}debug(I,...P){this.f(r.Debug)&&this.g(r.Debug,n([I,...P]))}info(I,...P){this.f(r.Info)&&this.g(r.Info,n([I,...P]))}warn(I,...P){this.f(r.Warning)&&this.g(r.Warning,n([I,...P]))}error(I,...P){if(this.f(r.Error))if(I instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=I.stack,this.g(r.Error,n(V))}else this.g(r.Error,n([I,...P]))}flush(){}}e.$ak=c;class u extends t{constructor(I=e.$0j){super(),this.setLevel(I),this.g=!m.$i}trace(I,...P){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}debug(I,...P){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}info(I,...P){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}warn(I,...P){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,I,...P):console.warn(`[main ${f()}]`,I,...P))}error(I,...P){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,I,...P):console.error(`[main ${f()}]`,I,...P))}flush(){}}e.$bk=u;class i extends t{constructor(I=e.$0j,P=!0){super(),this.g=P,this.setLevel(I)}trace(I,...P){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...P):console.log(I,...P))}debug(I,...P){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...P):console.log(I,...P))}info(I,...P){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...P):console.log(I,...P))}warn(I,...P){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...P):console.log(I,...P))}error(I,...P){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...P):console.error(I,...P))}flush(){}}e.$ck=i;class w extends t{constructor(I,P=e.$0j){super(),this.g=I,this.setLevel(P)}trace(I,...P){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(I),...P])}debug(I,...P){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(I),...P])}info(I,...P){this.f(r.Info)&&this.g.log(r.Info,[this.h(I),...P])}warn(I,...P){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(I),...P])}error(I,...P){this.f(r.Error)&&this.g.log(r.Error,[this.h(I),...P])}h(I){return typeof I=="string"?I:(0,O.$lj)(I,this.f(r.Trace))}flush(){}}e.$dk=w;class a extends t{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const P of this.g)P.setLevel(I);super.setLevel(I)}trace(I,...P){for(const V of this.g)V.trace(I,...P)}debug(I,...P){for(const V of this.g)V.debug(I,...P)}info(I,...P){for(const V of this.g)V.info(I,...P)}warn(I,...P){for(const V of this.g)V.warn(I,...P)}error(I,...P){for(const V of this.g)V.error(I,...P)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$ek=a;class l extends M.$Uc{constructor(I,P,V){if(super(),this.h=I,this.j=P,this.b=new p.$Ac,this.c=this.B(new R.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$he),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(I){return(0,N.$ag)(I)?[...this.b.values()].find(P=>P.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,P){const V=this.n(I),W=(0,N.$ag)(I)?I:P?.id??(0,F.$oj)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const A=P?.logLevel==="always"?r.Trace:P?.logLevel;q||(q=this.s(V,A??this.getLogLevel(V)??this.h,{...P,id:W}));const U={logger:q,info:{resource:V,id:W,logLevel:A,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(U.info),this.b.set(V,U),q}n(I){return(0,N.$ag)(I)?(0,D.$bh)(this.j,`${I}.log`):I}setLogLevel(I,P){if(S.URI.isUri(I)){const V=I,W=P,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=I;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,P){const V=this.m(I);V&&P!==!V.info.hidden&&(V.info.hidden=!P,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,P]))}getLogLevel(I){let P;return I&&(P=this.b.get(I)?.info.logLevel),P??this.h}registerLogger(I){const P=this.b.get(I.resource);P?P.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const P=this.b.get(I);P&&(P.logger&&P.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=l;class g{constructor(){this.onDidChangeLogLevel=new R.$he().event}setLevel(I){}getLevel(){return r.Info}trace(I,...P){}debug(I,...P){}info(I,...P){}warn(I,...P){}error(I,...P){}critical(I,...P){}dispose(){}flush(){}}e.$gk=g;class $ extends g{}e.$hk=$;function b(k){if(k.verbose)return r.Trace;if(typeof k.logLevel=="string"){const I=E(k.logLevel.toLowerCase());if(I!==void 0)return I}return e.$0j}function y(k){switch(k){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}function h(k){switch(k){case r.Trace:return{original:"Trace",value:C.localize(0,null)};case r.Debug:return{original:"Debug",value:C.localize(1,null)};case r.Info:return{original:"Info",value:C.localize(2,null)};case r.Warning:return{original:"Warning",value:C.localize(3,null)};case r.Error:return{original:"Error",value:C.localize(4,null)};case r.Off:return{original:"Off",value:C.localize(5,null)}}}function E(k){switch(k){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$mk=new d.$Rj("logLevel",y(r.Info))}),define(ke[201],Se([1,0,6,12]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=void 0;class R extends C.$Uc{constructor(M,p=[]){super(),this.a=new O.$ek([M,...p]),this.B(M.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$fQ=R}),define(ke[101],Se([1,0,32,167,3]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var M;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(m){function D(f,s){return s-f}m.compare=D;const N=Object.create(null);N[m.Error]=(0,O.localize)(0,null),N[m.Warning]=(0,O.localize)(1,null),N[m.Info]=(0,O.localize)(2,null);function S(f){return N[f]||""}m.toString=S;function d(f){switch(f){case C.default.Error:return m.Error;case C.default.Warning:return m.Warning;case C.default.Info:return m.Info;case C.default.Ignore:return m.Hint}}m.fromSeverity=d;function v(f){switch(f){case m.Error:return C.default.Error;case m.Warning:return C.default.Warning;case m.Info:return C.default.Info;case m.Hint:return C.default.Ignore}}m.toSeverity=v}(M||(e.MarkerSeverity=M={}));var p;(function(m){const D="";function N(d){return S(d,!0)}m.makeKey=N;function S(d,v){const f=[D];return d.source?f.push(d.source.replace("\xA6","\\\xA6")):f.push(D),d.code?typeof d.code=="string"?f.push(d.code.replace("\xA6","\\\xA6")):f.push(d.code.value.replace("\xA6","\\\xA6")):f.push(D),d.severity!==void 0&&d.severity!==null?f.push(M.toString(d.severity)):f.push(D),d.message&&v?f.push(d.message.replace("\xA6","\\\xA6")):f.push(D),d.startLineNumber!==void 0&&d.startLineNumber!==null?f.push(d.startLineNumber.toString()):f.push(D),d.startColumn!==void 0&&d.startColumn!==null?f.push(d.startColumn.toString()):f.push(D),d.endLineNumber!==void 0&&d.endLineNumber!==null?f.push(d.endLineNumber.toString()):f.push(D),d.endColumn!==void 0&&d.endColumn!==null?f.push(d.endColumn.toString()):f.push(D),f.push(D),f.join("\xA6")}m.makeKeyOptionalMessage=S})(p||(e.IMarkerData=p={})),e.$qu=(0,R.$Ai)("markerService")}),define(ke[202],Se([1,0,5,32,3]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$dw=e.Severity=void 0,e.$ew=p,e.Severity=O.default,e.$dw=(0,R.$Ai)("notificationService");var F;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var M;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(S){if(S){const d=S;return typeof d.id=="string"&&typeof d.label=="string"}return!1}var m;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class D{constructor(){this.progress=new N,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(d){}updateMessage(d){}updateActions(d){}close(){}}e.$fw=D;class N{infinite(){}done(){}total(d){}worked(d){}}e.$gw=N}),define(ke[102],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,C.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(he,e,C,O){var R=arguments.length,F=R<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,C):O,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(he,e,C,O);else for(var p=he.length-1;p>=0;p--)(M=he[p])&&(F=(R<3?M(F):R>3?M(e,C,F):M(e,C))||F);return R>3&&F&&Object.defineProperty(e,C,F),F},We=this&&this.__param||function(he,e){return function(C,O){e(C,O,he)}};define(ke[103],Se([1,0,11,20,6,3]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.ProgressLocation=e.$hw=void 0,e.$hw=(0,F.$Ai)("progressService");var M;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$iw=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(d){this.b=d}report(d){this.a=d,this.b(this.a)}}e.$jw=p;class m{get value(){return this.a}constructor(d){this.e=d}report(d){this.b?this.b.push(d):this.b=[d],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const d=this.b.shift();this.a=d,await this.e(this.a)}}finally{this.c=!1;const d=this.d;this.d=void 0,d?.()}}drain(){return this.c?new Promise(d=>{const v=this.d;this.d=()=>{v?.(),d()}}):Promise.resolve()}}e.$kw=m;let D=class extends R.$Uc{constructor(d,v){super(),this.a=new C.$Xh,v.withProgress(d,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,R.$Sc)(()=>this.a.complete()))}report(d){this.b?this.b.report(d):this.c=d}};e.$lw=D,e.$lw=D=Je([We(1,e.$hw)],D);class N extends R.$Uc{constructor(d){super(),this.g=d,this.a=0,this.b=this.B(new R.$Tc)}start(d){this.stop();const v=++this.a,f=new O.$se;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},d),this.b.add((0,R.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Sc)(()=>f.cancel())),this.b.add((0,R.$Sc)(()=>this.c?this.c.done():void 0)),{id:v,token:f.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(d){this.a===d&&this.b.clear()}}e.$mw=N,e.$nw=(0,F.$Ai)("editorProgressService")}),define(ke[29],Se([1,0,57,15]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=void 0;class R{constructor(){this.a=new Map}add(M,p){C.ok(O.$ag(M)),C.ok(O.$cg(p)),C.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$ho=new R}),define(ke[74],Se([1,0,5,29]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=void 0,e.$io={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class F{constructor(){this.b=new C.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,D){this.a[R(m)]=D,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const M=new F;O.$ho.add(e.$io.JSONContribution,M)}),define(ke[51],Se([1,0,18,5,15,160,50,74,29]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.ConfigurationScope=e.$mo=e.EditPresentationTypes=void 0,e.$xo=s,e.$yo=r,e.$zo=o,e.$Ao=t,e.$Bo=c;var D;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(D||(e.EditPresentationTypes=D={})),e.$mo={Configuration:"base.contributions.configuration"};var N;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N||(e.ConfigurationScope=N={})),e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to="vscode://schemas/settings/resourceLanguage",e.$uo="vscode://schemas/settings/configurationDefaults";const S=m.$ho.as(p.$io.JSONContribution);class d{constructor(){this.h=new Set,this.i=new O.$he,this.onDidSchemaChange=this.i.event,this.j=new O.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$to,this.g),this.v()}registerConfiguration(i,w=!0){this.registerConfigurations([i],w)}registerConfigurations(i,w=!0){const a=new Set;this.n(i,w,a),S.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const w=new Set;this.o(i,w),S.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:w})}updateConfigurations({add:i,remove:w}){const a=new Set;this.o(w,a),this.n(i,!1,a),S.registerSchema(e.$to,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const w=new Set;this.k(i,w),this.i.fire(),this.j.fire({properties:w,defaultsOverrides:!0})}k(i,w){const a=[];for(const{overrides:l,source:g}of i)for(const $ in l)if(w.add($),e.$wo.test($)){const b=this.a.get($),y=b?.valuesSources??new Map;if(g)for(const I of Object.keys(l[$]))y.set(I,g);const h={...b?.value||{},...l[$]};this.a.set($,{source:g,value:h,valuesSources:y});const E=(0,M.$ej)($),k={type:"object",default:h,description:F.localize(1,null,E),$ref:e.$to,defaultDefaultValue:h,source:R.$ag(g)?void 0:g,defaultValueSource:g};a.push(...s($)),this.d[$]=k,this.b.properties[$]=k}else{this.a.set($,{value:l[$],source:g});const b=this.d[$];b&&(this.w($,b),this.r($,b))}this.m(a)}deregisterDefaultConfigurations(i){const w=new Set;this.l(i,w),this.i.fire(),this.j.fire({properties:w,defaultsOverrides:!0})}l(i,w){for(const{overrides:a,source:l}of i)for(const g in a){const $=this.a.get(g),b=R.$ag(l)?l:l?.id,y=R.$ag($?.source)?$?.source:$?.source?.id;if(b===y)if(w.add(g),this.a.delete(g),e.$wo.test(g))delete this.d[g],delete this.b.properties[g];else{const h=this.d[g];h&&(this.w(g,h),this.r(g,h))}}this.u()}deltaConfiguration(i){let w=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),w=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),w=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:w})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const w of i)this.h.add(w);this.u()}n(i,w,a){i.forEach(l=>{this.p(l,w,l.extensionInfo,l.restrictedProperties,void 0,a),this.c.push(l),this.q(l)})}o(i,w){const a=l=>{if(l.properties)for(const g in l.properties){w.add(g);const $=this.d[g];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[g],this.s(g,l.properties[g])}l.allOf?.forEach(g=>a(g))};for(const l of i){a(l);const g=this.c.indexOf(l);g!==-1&&this.c.splice(g,1)}}p(i,w=!0,a,l,g=3,$){g=R.$jg(i.scope)?g:i.scope;const b=i.properties;if(b)for(const h in b){const E=b[h];if(w&&t(h,E)){delete b[h];continue}if(E.source=a,E.defaultDefaultValue=b[h].default,this.w(h,E),e.$wo.test(h)?E.scope=void 0:(E.scope=R.$jg(E.scope)?g:E.scope,E.restricted=R.$jg(E.restricted)?!!l?.includes(h):E.restricted),b[h].hasOwnProperty("included")&&!b[h].included){this.f[h]=b[h],delete b[h];continue}else this.d[h]=b[h],b[h].policy?.name&&this.e.set(b[h].policy.name,h);!b[h].deprecationMessage&&b[h].markdownDeprecationMessage&&(b[h].deprecationMessage=b[h].markdownDeprecationMessage),$.add(h)}const y=i.allOf;if(y)for(const h of y)this.p(h,w,a,l,g,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const w=a=>{const l=a.properties;if(l)for(const $ in l)this.r($,l[$]);a.allOf?.forEach(w)};w(i)}r(i,w){switch(e.$no.properties[i]=w,w.scope){case 1:e.$oo.properties[i]=w;break;case 2:e.$po.properties[i]=w;break;case 6:e.$qo.properties[i]=w;break;case 3:e.$ro.properties[i]=w;break;case 4:e.$so.properties[i]=w;break;case 5:e.$so.properties[i]=w,this.g.properties[i]=w;break}}s(i,w){switch(delete e.$no.properties[i],w.scope){case 1:delete e.$oo.properties[i];break;case 2:delete e.$po.properties[i];break;case 6:delete e.$qo.properties[i];break;case 3:delete e.$ro.properties[i];break;case 4:case 5:delete e.$so.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const w=`[${i}]`,a={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$to};this.w(w,a),e.$no.properties[w]=a,e.$oo.properties[w]=a,e.$po.properties[w]=a,e.$qo.properties[w]=a,e.$ro.properties[w]=a,e.$so.properties[w]=a}}v(){const i={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$to};e.$no.patternProperties[e.$vo]=i,e.$oo.patternProperties[e.$vo]=i,e.$po.patternProperties[e.$vo]=i,e.$qo.patternProperties[e.$vo]=i,e.$ro.patternProperties[e.$vo]=i,e.$so.patternProperties[e.$vo]=i,this.i.fire()}w(i,w){const a=this.a.get(i);let l=a?.value,g=a?.source;R.$hg(l)&&(l=w.defaultDefaultValue,g=void 0),R.$hg(l)&&(l=o(w.type)),w.default=l,w.defaultValueSource=g}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");e.$vo=`^(${v})+$`,e.$wo=new RegExp(e.$vo);function s(u){const i=[];if(e.$wo.test(u)){let w=f.exec(u);for(;w?.length;){const a=w[1].trim();a&&i.push(a),w=f.exec(u)}}return(0,C.$Mb)(i)}function r(u){return u.reduce((i,w)=>`${i}[${w}]`,"")}function o(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new d;m.$ho.add(e.$mo.Configuration,n);function t(u,i){return u.trim()?e.$wo.test(u)?F.localize(7,null,u):n.getConfigurationProperties()[u]!==void 0?F.localize(8,null,u):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?F.localize(9,null,u,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:F.localize(6,null)}function c(){const u=[],i=n.getConfigurationProperties();for(const w of Object.keys(i))u.push([w,i[w].scope]);return u.push(["launch",4]),u.push(["task",4]),u}}),define(ke[203],Se([1,0,18,5,126,6,28,26,15,2,50,51,29]),function(he,e,C,O,R,F,M,p,m,D,N,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Go=t;function v(w){return Object.isFrozen(w)?w:p.$8n(w)}class f{static createEmptyModel(a){return new f({},[],[],void 0,a)}constructor(a,l,g,$,b){this.b=a,this.c=l,this.d=g,this.raw=$,this.f=b,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(l=>{if(l instanceof f)return l;const g=new s("",this.f);return g.parseRaw(l),g.configurationModel});this.g=a.reduce((l,g)=>g===l?g:l.merge(g),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,N.$cj)(this.contents,a):this.contents}inspect(a,l){const g=this;return{get value(){return v(g.rawConfiguration.getValue(a))},get override(){return l?v(g.rawConfiguration.getOverrideValue(a,l)):void 0},get merged(){return v(l?g.rawConfiguration.override(l).getValue(a):g.rawConfiguration.getValue(a))},get overrides(){const $=[];for(const{contents:b,identifiers:y,keys:h}of g.rawConfiguration.overrides){const E=new f(b,h,[],void 0,g.f).getValue(a);E!==void 0&&$.push({identifiers:y,value:E})}return $.length?v($):void 0}}}getOverrideValue(a,l){const g=this.j(l);return g?a?(0,N.$cj)(g,a):g:void 0}getKeysForOverrideIdentifier(a){const l=[];for(const g of this.overrides)g.identifiers.includes(a)&&l.push(...g.keys);return C.$Mb(l)}getAllOverrideIdentifiers(){const a=[];for(const l of this.overrides)a.push(...l.identifiers);return C.$Mb(a)}override(a){let l=this.a.get(a);return l||(l=this.h(a),this.a.set(a,l)),l}merge(...a){const l=p.$7n(this.contents),g=p.$7n(this.overrides),$=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const y of a)if(b.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(l,y.contents);for(const h of y.overrides){const[E]=g.filter(k=>C.$ub(k.identifiers,h.identifiers));E?(this.i(E.contents,h.contents),E.keys.push(...h.keys),E.keys=C.$Mb(E.keys)):g.push(p.$7n(h))}for(const h of y.keys)$.indexOf(h)===-1&&$.push(h)}return new f(l,$,g,b.every(y=>y instanceof f)?void 0:b,this.f)}h(a){const l=this.j(a);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const g={};for(const $ of C.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let b=this.contents[$];const y=l[$];y&&(typeof b=="object"&&typeof y=="object"?(b=p.$7n(b),this.i(b,y)):b=y),g[$]=b}return new f(g,this.keys,this.overrides,void 0,this.f)}i(a,l){for(const g of Object.keys(l)){if(g in a&&m.$cg(a[g])&&m.$cg(l[g])){this.i(a[g],l[g]);continue}a[g]=p.$7n(l[g])}}j(a){let l=null,g=null;const $=b=>{b&&(g?this.i(g,b):g=p.$7n(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===a?l=b.contents:b.identifiers.includes(a)&&$(b.contents);return $(l),g}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,l){this.k(a,l,!0)}setValue(a,l){this.k(a,l,!1)}removeValue(a){const l=this.keys.indexOf(a);l!==-1&&(this.keys.splice(l,1),(0,N.$bj)(this.contents,a),S.$wo.test(a)&&this.overrides.splice(this.overrides.findIndex(g=>C.$ub(g.identifiers,(0,S.$xo)(a))),1))}k(a,l,g){(0,N.$aj)(this.contents,a,l,$=>this.f.error($)),g=g||this.keys.indexOf(a)===-1,g&&this.keys.push(a),S.$wo.test(a)&&this.overrides.push({identifiers:(0,S.$xo)(a),keys:Object.keys(this.contents[a]),contents:(0,N.$_i)(this.contents[a],$=>this.f.error($))})}}e.$Co=f;class s{constructor(a,l){this.f=a,this.g=l,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,l){if(!m.$jg(a)){const g=this.h(a);this.parseRaw(g,l)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,l){this.a=a;const{contents:g,keys:$,overrides:b,restricted:y,hasExcludedProperties:h}=this.i(a,l);this.b=new f(g,$,b,h?[a]:void 0,this.g),this.c=y||[]}h(a){let l={},g=null,$=[];const b=[],y=[];function h(k){Array.isArray($)?$.push(k):g!==null&&($[g]=k)}const E={onObjectBegin:()=>{const k={};h(k),b.push($),$=k,g=null},onObjectProperty:k=>{g=k},onObjectEnd:()=>{$=b.pop()},onArrayBegin:()=>{const k=[];h(k),b.push($),$=k,g=null},onArrayEnd:()=>{$=b.pop()},onLiteralValue:h,onError:(k,I,P)=>{y.push({error:k,offset:I,length:P})}};if(a)try{R.$Un(a,E),l=$[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return l}i(a,l){const g=d.$ho.as(S.$mo.Configuration).getConfigurationProperties(),$=this.j(a,g,!0,l);a=$.raw;const b=(0,N.$_i)(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),y=Object.keys(a),h=this.l(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:b,keys:y,overrides:h,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}j(a,l,g,$){let b=!1;if(!$?.scopes&&!$?.skipRestricted&&!$?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:b};const y={},h=[];for(const E in a)if(S.$wo.test(E)&&g){const k=this.j(a[E],l,!1,$);y[E]=k.raw,b=b||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=l[E],I=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(E),!$.exclude?.includes(E)&&($.include?.includes(E)||(I===void 0||$.scopes===void 0||$.scopes.includes(I))&&!($.skipRestricted&&k?.restricted))?y[E]=a[E]:b=!0}return{raw:y,restricted:h,hasExcludedProperties:b}}l(a,l){const g=[];for(const $ of Object.keys(a))if(S.$wo.test($)){const b={};for(const y in a[$])b[y]=a[$][y];g.push({identifiers:(0,S.$xo)($),keys:Object.keys(b),contents:(0,N.$_i)(b,l)})}return g}}e.$Do=s;class r extends F.$Uc{constructor(a,l,g,$,b){super(),this.c=a,this.f=l,this.g=$,this.h=b,this.b=this.B(new O.$he),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),b),this.B(this.g.watch(g.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&g.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Eo=r;class o{constructor(a,l,g,$,b,y,h,E,k,I,P,V,W){this.a=a,this.b=l,this.c=g,this.overrideIdentifiers=$,this.d=b,this.f=y,this.g=h,this.h=E,this.i=k,this.j=I,this.k=P,this.l=V,this.m=W}get value(){return v(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,l,g,$,b,y,h,E,k,I){this.j=a,this.l=l,this.m=g,this.n=$,this.p=b,this.q=y,this.r=h,this.s=E,this.t=k,this.u=I,this.h=null,this.i=new M.$Ac,this.v=null}getValue(a,l,g){return this.w(a,l,g).getValue(a)}updateValue(a,l,g={}){let $;g.resource?($=this.t.get(g.resource),$||($=f.createEmptyModel(this.u),this.t.set(g.resource,$))):$=this.s,l===void 0?$.removeValue(a):$.setValue(a,l),g.resource||(this.h=null)}inspect(a,l,g){const $=this.w(a,l,g),b=this.A(l.resource,g),y=l.resource?this.t.get(l.resource)||this.s:this.s,h=new Set;for(const E of $.overrides)for(const k of E.identifiers)$.getOverrideValue(a,k)!==void 0&&h.add(k);return new o(a,l,$.getValue(a),h.size?[...h]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,g?this.q:void 0,b||void 0,y)}keys(a){const l=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,l){this.r.set(a,l),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,l){const g=[];if(!l){const{added:$,updated:b,removed:y}=u(this.j,a);l=[...$,...b,...y]}for(const $ of l)for(const b of(0,S.$xo)($)){const y=this.j.getKeysForOverrideIdentifier(b),h=a.getKeysForOverrideIdentifier(b),E=[...h.filter(k=>y.indexOf(k)===-1),...y.filter(k=>h.indexOf(k)===-1),...y.filter(k=>!p.$$n(this.j.override(b).getValue(k),a.override(b).getValue(k)))];g.push([b,E])}return this.updateDefaultConfiguration(a),{keys:l,overrides:g}}compareAndUpdatePolicyConfiguration(a){const{added:l,updated:g,removed:$}=u(this.l,a),b=[...l,...g,...$];return b.length&&this.updatePolicyConfiguration(a),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:l,updated:g,removed:$,overrides:b}=u(this.applicationConfiguration,a),y=[...l,...g,...$];return y.length&&this.updateApplicationConfiguration(a),{keys:y,overrides:b}}compareAndUpdateLocalUserConfiguration(a){const{added:l,updated:g,removed:$,overrides:b}=u(this.localUserConfiguration,a),y=[...l,...g,...$];return y.length&&this.updateLocalUserConfiguration(a),{keys:y,overrides:b}}compareAndUpdateRemoteUserConfiguration(a){const{added:l,updated:g,removed:$,overrides:b}=u(this.remoteUserConfiguration,a),y=[...l,...g,...$];return y.length&&this.updateRemoteUserConfiguration(a),{keys:y,overrides:b}}compareAndUpdateWorkspaceConfiguration(a){const{added:l,updated:g,removed:$,overrides:b}=u(this.workspaceConfiguration,a),y=[...l,...g,...$];return y.length&&this.updateWorkspaceConfiguration(a),{keys:y,overrides:b}}compareAndUpdateFolderConfiguration(a,l){const g=this.folderConfigurations.get(a),{added:$,updated:b,removed:y,overrides:h}=u(g,l),E=[...$,...b,...y];return(E.length||!g)&&this.updateFolderConfiguration(a,l),{keys:E,overrides:h}}compareAndDeleteFolderConfiguration(a){const l=this.folderConfigurations.get(a);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:g,updated:$,removed:b,overrides:y}=u(l,void 0);return{keys:[...g,...$,...b],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,l,g){let $=this.x(l,g);return l.overrideIdentifier&&($=$.override(l.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&($=$.merge(this.l)),$}x({resource:a},l){let g=this.y();if(l&&a){const $=l.getFolder(a);$&&(g=this.z($.uri)||g);const b=this.t.get(a);b&&(g=g.merge(b))}return g}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let l=this.i.get(a);if(!l){const g=this.y(),$=this.r.get(a);$?(l=g.merge($),this.i.set(a,l)):l=g}return l}A(a,l){if(l&&a){const g=l.getFolder(a);if(g)return this.r.get(g.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,l)=>{const{contents:g,overrides:$,keys:b}=this.r.get(l);return a.push([l,{contents:g,overrides:$,keys:b}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(l=>a.add(l)),this.userConfiguration.keys.forEach(l=>a.add(l)),this.q.keys.forEach(l=>a.add(l)),this.r.forEach(l=>l.keys.forEach(g=>a.add(g))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(l=>a.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>a.add(l)),this.q.getAllOverrideIdentifiers().forEach(l=>a.add(l)),this.r.forEach(l=>l.getAllOverrideIdentifiers().forEach(g=>a.add(g))),[...a.values()]}D(a){const l=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(g=>l.add(g)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(g=>l.add(g)),this.q.getKeysForOverrideIdentifier(a).forEach(g=>l.add(g)),this.r.forEach(g=>g.getKeysForOverrideIdentifier(a).forEach($=>l.add($))),[...l.values()]}static parse(a,l){const g=this.E(a.defaults,l),$=this.E(a.policy,l),b=this.E(a.application,l),y=this.E(a.user,l),h=this.E(a.workspace,l),E=a.folders.reduce((k,I)=>(k.set(D.URI.revive(I[0]),this.E(I[1],l)),k),new M.$Ac);return new n(g,$,b,y,f.createEmptyModel(l),h,E,f.createEmptyModel(l),new M.$Ac,l)}static E(a,l){return new f(a.contents,a.keys,a.overrides,void 0,l)}}e.$Fo=n;function t(...w){if(w.length===0)return{keys:[],overrides:[]};if(w.length===1)return w[0];const a=new Set,l=new Map;for(const $ of w)$.keys.forEach(b=>a.add(b)),$.overrides.forEach(([b,y])=>{const h=(0,M.$xc)(l,b,new Set);y.forEach(E=>h.add(E))});const g=[];return l.forEach(($,b)=>g.push([b,[...$.values()]])),{keys:[...a.values()],overrides:g}}class c{constructor(a,l,g,$,b){this.change=a,this.f=l,this.g=g,this.h=$,this.i=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const h of y)this.affectedKeys.add(h);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,l){const g=this.a+a,$=this.d.indexOf(g);if($<0)return!1;const b=$+g.length;if(b>=this.d.length)return!1;const y=this.d.charCodeAt(b);if(y!==this.b&&y!==this.c)return!1;if(l){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,l,this.f?.workspace):void 0,E=this.g.getValue(a,l,this.h);return!p.$$n(h,E)}return!0}}e.$Ho=c;function u(w,a){const{added:l,removed:g,updated:$}=i(a?.rawConfiguration,w?.rawConfiguration),b=[],y=w?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const E=h.filter(k=>!y.includes(k));for(const k of E)b.push([k,a.getKeysForOverrideIdentifier(k)])}if(w){const E=y.filter(k=>!h.includes(k));for(const k of E)b.push([k,w.getKeysForOverrideIdentifier(k)])}if(a&&w){for(const E of y)if(h.includes(E)){const k=i({contents:w.getOverrideValue(void 0,E)||{},keys:w.getKeysForOverrideIdentifier(E)},{contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)});b.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:l,removed:g,updated:$,overrides:b}}function i(w,a){const l=w?a?w.keys.filter(b=>a.keys.indexOf(b)===-1):[...w.keys]:[],g=a?w?a.keys.filter(b=>w.keys.indexOf(b)===-1):[...a.keys]:[],$=[];if(w&&a){for(const b of a.keys)if(w.keys.indexOf(b)!==-1){const y=(0,N.$cj)(a.contents,b),h=(0,N.$cj)(w.contents,b);p.$$n(y,h)||$.push(b)}}return{added:l,removed:g,updated:$}}}),define(ke[104],Se([1,0,14,3]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=D,e.$Ll=(0,O.$Ai)("remoteAuthorityResolverService");var R;(function(N){N[N.WebSocket=0]="WebSocket",N[N.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class F{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ml=F;class M{constructor(S,d){this.host=S,this.port=d,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=M;var p;(function(N){N.Unknown="Unknown",N.NotAvailable="NotAvailable",N.TemporarilyNotAvailable="TemporarilyNotAvailable",N.NoResolverFound="NoResolverFound",N.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class m extends C.$bb{static isNotAvailable(S){return S instanceof m&&S._code===p.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof m&&S._code===p.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof m&&S._code===p.NoResolverFound}static isInvalidAuthority(S){return S instanceof m&&S._code===p.InvalidAuthority}static isHandled(S){return S instanceof m&&S.isHandled}constructor(S,d=p.Unknown,v){super(S),this._message=S,this._code=d,this._detail=v,this.isHandled=d===p.NotAvailable&&v===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Ol=m;function D(N){const S=N.indexOf("+");return S===-1?N:N.substring(0,S)}}),define(ke[58],Se([1,0,16]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=O,e.$Mm=R,e.$Nm=F,e.$Om=M;function O(m){return m.scheme===C.Schemas.vscodeRemote?m.authority:void 0}function R(m){if(!m)return;const D=m.indexOf("+");return D<0?m:m.substr(0,D)}function F(m){const{host:D,port:N}=p(m);if(typeof N>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:D,port:N}}function M(m,D){let{host:N,port:S}=p(m);return typeof S>"u"&&(S=D),{host:N,port:S}}function p(m){const D=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const N=m.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(ke[21],Se([1,0,13,3,58]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$Xm=e.$Wm=e.$Vm=e.TargetPlatform=e.ExtensionType=e.$Um=e.$Sm=e.$Rm=e.$Qm=e.$Pm=void 0,e.$Tm=F,e.$Ym=S,e.$Zm=d,e.$1m=v,e.$2m=f,e.$Pm="extensions.user.cache",e.$Qm="extensions.builtin.cache",e.$Rm="undefined_publisher",e.$Sm=["ui","workspace","web"];function F(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Um=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class m{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,o){if(typeof r>"u"||r===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof r=="string"||typeof o=="string"){const n=typeof r=="string"?r:r.value,t=typeof o=="string"?o:o.value;return C.$Bf(n,t)}return r._lower===o._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.$Vm=m;class D{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const o of r)this.add(o)}add(r){this.c.add(m.toKey(r))}delete(r){return this.c.delete(m.toKey(r))}has(r){return this.c.has(m.toKey(r))}}e.$Wm=D;class N{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(m.toKey(r))}get(r){return this.c.get(m.toKey(r))}has(r){return this.c.has(m.toKey(r))}set(r,o){this.c.set(m.toKey(r),o)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xm=N;function S(s){return d(s)}function d(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function v(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function f(s,r){if(r){const o=`onResolveRemoteAuthority:${(0,R.$Mm)(r)}`;return!!s.activationEvents?.includes(o)}return!1}e.$3m=(0,O.$Ai)("IBuiltinExtensionsScannerService")}),define(ke[105],Se([1,0,14,21]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tG=e.$sG=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const m of M){const D=this.readActivationEvents(m);D.length>0&&(p[O.$Vm.toKey(m.identifier)]=D)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let m=0;m<p.length;m++)p[m]==="onUri"&&(p[m]=`onUri:${O.$Vm.toKey(M.identifier)}`);if(!M.contributes)return p;for(const m in M.contributes){const D=this.a.get(m);if(!D)continue;const N=M.contributes[m],S=Array.isArray(N)?N:[N];try{D(S,p)}catch(d){(0,C.$1)(d)}}return p}}e.$sG=R,e.$tG=new R}),define(ke[204],Se([1,0,22,14,6,168,51,3,12,29]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Tp=void 0,e.$Vp=d,e.$Wp=v,e.$Xp=f,e.$Yp=s,e.$Zp=r,e.$1p=o,e.$Tp=(0,p.$Ai)("requestService");class N{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?u[i]="*****":u[i]=this.b[i];this.a=u}return this.a}}class S extends R.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,F.localize)(0,null),when:m.$mk.isEqualTo((0,m.$jk)(m.LogLevel.Trace)).serialize()})}async c(u,i,w){const a=`${u} #${++this.b}: ${i.url}`;this.a.trace(`${a} - begin`,i.type,new N(i.headers??{}));try{const l=await w();return this.a.trace(`${a} - end`,i.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${a} - error`,i.type,(0,O.$0)(l)),l}}}e.$Up=S;function d(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function v(c){return c.res.statusCode===204}async function f(c){return v(c)?null:(await(0,C.$Ve)(c.stream)).toString()}async function s(c){if(!d(c))throw new Error("Server returned "+c.res.statusCode);return f(c)}async function r(c){if(!d(c))throw new Error("Server returned "+c.res.statusCode);if(v(c))return null;const i=(await(0,C.$Ve)(c.stream)).toString();try{return JSON.parse(i)}catch(w){throw w.message+=`:
`+i,w}}function o(c){t(c)}let n;function t(c){const u=D.$ho.as(M.$mo.Configuration),i=n;n={id:"http",order:15,title:(0,F.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,F.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,F.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,F.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,F.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,F.localize)(6,null),(0,F.localize)(7,null),(0,F.localize)(8,null),(0,F.localize)(9,null)],default:"override",description:(0,F.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,F.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,F.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[n],remove:i?[i]:[]})}t(1)}),define(ke[205],Se([1,0,23,75,33]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=M,e.$kp=p;function F(m){if(C.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function M(m,D,N,S,d,v,f,s,r){const o=Object.create(null);o["common.machineId"]=v,o["common.sqmId"]=f,o.sessionID=(0,R.$Wg)()+Date.now(),o.commitHash=S,o.version=d,o["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=N,o["common.product"]=r||"desktop",s&&(o["common.msftInternal"]=s);let n=0;const t=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const c=F(D);return c&&(o["common.platformDetail"]=c),o}function p(m){const D=O.env.USERDNSDOMAIN;if(!D)return!1;const N=D.toLowerCase();return m.some(S=>N===S)}}),define(ke[206],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,C.$Ai)("telemetryService"),e.$7l=(0,C.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry",e.$bm="telemetry.telemetryLevel",e.$cm="telemetry.enableCrashReporter",e.$dm="telemetry.enableTelemetry";var O;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var R;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ke[59],Se([1,0,26,15,58,205,206]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=void 0,e.$sp=N,e.$tp=S,e.$up=d,e.$vp=v,e.$wp=s,e.$xp=o,e.$yp=n,e.$zp=u;class p{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$lp=p;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$mp=m,e.$np=new m;class D{async publicLog(w,a,l){}async publicLogError(w,a,l){}}e.$op=D,e.$pp="telemetry",e.$qp="extensionTelemetryLog",e.$rp={log:()=>null,flush:()=>Promise.resolve(null)};function N(i,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!i.enableTelemetry)}function S(i,w){return w.extensionTestsLocationURI?!0:!(w.isBuilt||w.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function d(i){const w=i.getValue(M.$bm),a=i.getValue(M.$cm);if(i.getValue(M.$dm)===!1||a===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function v(i){const w={},a={},l={};r(i,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const $=l[g];typeof $=="number"?a[g]=$:typeof $=="boolean"?a[g]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${$.length}`),w[g]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(w[g]=$)}return{properties:w,measurements:a}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const w=(0,R.$Mm)(i);return f.has(w)?w:"other"}function r(i,w,a=0,l){if(i)for(const g of Object.getOwnPropertyNames(i)){const $=i[g],b=l?l+g:g;Array.isArray($)?w[b]=(0,C.$_n)($):$ instanceof Date?w[b]=$.toISOString():(0,O.$cg)($)?a<2?r($,w,a+1,b+"."):w[b]=(0,C.$_n)($):w[b]=$}}function o(i,w){const a=i.msftInternalDomains||[],l=w.getValue("telemetry.internalTesting");return(0,F.$kp)(a)||l}function n(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,w){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const l=[];for(const y of w)for(;;){const h=y.exec(i);if(!h)break;l.push([h.index,y.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(a="";;){const y=$.exec(i);if(!y)break;const h=l.some(([E,k])=>y.index<k&&E<$.lastIndex);!g.test(y[0])&&!h&&(a+=i.substring(b,y.index)+"<REDACTED: user-file-path>",b=$.lastIndex)}return b<i.length&&(a+=i.substr(b)),a}function c(i){if(!i)return i;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of w)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function u(i,w){return(0,C.$9n)(i,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let l=a.replaceAll("%20"," ");l=t(l,w);for(const g of w)l=l.replace(g,"");return l=c(l),l}})}}),define(ke[207],Se([1,0,13,100,21,23,2,14,75,59]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Bp=void 0,e.$Ap=N,e.$Cp=f,e.$Dp=s,e.$Ep=r,e.$Fp=o,e.$Gp=n,e.$Hp=t,e.$Ip=c,e.$Kp=u,e.$Lp=w;function N(a,l){return a.uuid&&l.uuid?a.uuid===l.uuid:a.id===l.id?!0:(0,C.$wf)(a.id,l.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(l){const g=l.manifest?l.manifest.version:l.version,$=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new d(l.identifier,g,$)}static parse(l){const g=S.exec(l);return g&&g[1]&&g[2]?new d({id:g[1]},g[2],g[4]||void 0):null}constructor(l,g,$="undefined"){this.identifier=l,this.version=g,this.targetPlatform=$,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof d?N(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Bp=d;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(a){const l=v.exec(a);return l&&l[1]?[r(l[1]),l[2]]:[r(a),void 0]}function s(a,l){return`${a}.${l}`}function r(a){return a.toLowerCase()}function o(a,l){return r(s(a??R.$Rm,l))}function n(a,l){const g=[],$=b=>{for(const y of g)if(y.some(h=>N(l(h),l(b))))return y;return null};for(const b of a){const y=$(b);y?y.push(b):g.push([b])}return g}function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new D.$lp(a.identifier.id),name:new D.$lp(a.name),version:a.version,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Jp=new R.$Vm("pprice.better-merge");function u(a,l){const g=[],$=l.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const b=$.shift();if(b&&g.every(y=>!N(y.identifier,{id:b}))){const y=a.filter(h=>N(h.identifier,{id:b}));y.length===1&&(g.push(y[0]),$.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function i(a,l){if(!F.$k)return!1;let g;try{g=(await a.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await a.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){l.debug("Error while getting the os-release file.",(0,p.$0)(b))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function w(a,l){const g=await i(a,l),$=(0,O.$8o)(g?"alpine":F.$u,m.$ec);return l.debug("ComputeTargetPlatform:",$),$}}),define(ke[208],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=C,e.$ss=O,e.$ts=R,e.$us=F,e.$vs=M,e.$ws=p;function C(m){return[...m.entries()]}function O(m){return m?[...m.entries()]:[]}function R(m){return new Map(m)}function F(m){return new Map(m??[])}function M(m){return Array.from(m.entries()).map(D=>[D[0],C(D[1].map),O(D[1].descriptionMap)])}function p(m){return new Map(m.map(D=>[D[0],{map:R(D[1]),descriptionMap:F(D[2])}]))}}),define(ke[209],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qwb=void 0;class C{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,F,M=5){const p=F(m=>{const D=typeof m=="string"?m:m.data;let N=this.a.get(R);if(N){N.data.push(D);return}const S=setTimeout(()=>this.flushBuffer(R),M);N={data:[D],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(R),p.dispose()}},this.a.set(R,N)});return p}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const F=this.a.get(R);F&&(this.a.delete(R),this.b(R,F.data.join("")))}}e.$qwb=C}),define(ke[210],Se([1,0,11,92,312,36,5,15,2,169,74,29]),function(he,e,C,O,R,F,M,p,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sx=e.$rx=e.$qx=e.$px=e.$ox=e.$nx=e.IconFontDefinition=e.IconContribution=e.$kx=void 0,e.$lx=r,e.$mx=o,e.$kx={IconContribution:"base.contributions.icons"};var d;(function(u){function i(w,a){let l=w.defaults;for(;F.ThemeIcon.isThemeIcon(l);){const g=s.getIcon(l.id);if(!g)return;l=g.defaults}return l}u.getDefinition=i})(d||(e.IconContribution=d={}));var v;(function(u){function i(a){return{weight:a.weight,style:a.style,src:a.src.map(l=>({format:l.format,location:l.location.toString()}))}}u.toJSONObject=i;function w(a){const l=g=>(0,p.$ag)(g)?g:void 0;if(a&&Array.isArray(a.src)&&a.src.every(g=>(0,p.$ag)(g.format)&&(0,p.$ag)(g.location)))return{weight:l(a.weight),style:l(a.style),src:a.src.map(g=>({format:g.format,location:m.URI.parse(g.location)}))}}u.fromJSONObject=w})(v||(e.IconFontDefinition=v={}));class f{constructor(){this.a=new M.$he,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${F.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,w,a,l){const g=this.b[i];if(g){if(a&&!g.description){g.description=a,this.d.properties[i].markdownDescription=`${a} $(${i})`;const y=this.e.enum.indexOf(i);y!==-1&&(this.e.enumDescriptions[y]=a),this.a.fire()}return g}const $={id:i,description:a,defaults:w,deprecationMessage:l};this.b[i]=$;const b={$ref:"#/definitions/icons"};return l&&(b.deprecationMessage=l),a&&(b.markdownDescription=`${a}: $(${i})`),this.d.properties[i]=b,this.e.enum.push(i),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const w=this.e.enum.indexOf(i);w!==-1&&(this.e.enum.splice(w,1),this.e.enumDescriptions.splice(w,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,w){const a=this.f[i];return a||(this.f[i]=w,this.a.fire(),w)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(g,$)=>g.id.localeCompare($.id),w=g=>{for(;F.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(g=>this.b[g]);for(const g of l.filter($=>!!$.description).sort(i))a.push(`|<i class="${w(g)}"></i>|${g.id}|${F.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const g of l.filter($=>!F.ThemeIcon.isThemeIcon($.defaults)).sort(i))a.push(`|<i class="${w(g)}"></i>|${g.id}|`);return a.join(`
`)}}const s=new f;S.$ho.add(e.$kx.IconContribution,s);function r(u,i,w,a){return s.registerIcon(u,i,w,a)}function o(){return s}function n(){const u=(0,R.$Vj)();for(const i in u){const w="\\"+u[i].toString(16);s.registerIcon(i,{fontCharacter:w})}}n(),e.$nx="vscode://schemas/icons";const t=S.$ho.as(N.$io.JSONContribution);t.registerSchema(e.$nx,s.getIconSchema());const c=new C.$Mh(()=>t.notifySchemaChanged(e.$nx),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$ox=r("widget-close",O.$Zj.close,(0,D.localize)(2,null)),e.$px=r("goto-previous-location",O.$Zj.arrowUp,(0,D.localize)(3,null)),e.$qx=r("goto-next-location",O.$Zj.arrowDown,(0,D.localize)(4,null)),e.$rx=F.ThemeIcon.modify(O.$Zj.sync,"spin"),e.$sx=F.ThemeIcon.modify(O.$Zj.loading,"spin")}),define(ke[211],Se([1,0,5,2,50,3,12]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zw=e.$yw=e.$vw=e.$tw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$pw=e.$ow=void 0,e.$qw=D,e.$rw=S,e.$sw=d,e.$uw=v,e.$ww=f,e.$xw=s,e.$ow=(0,F.$Ai)("tunnelService"),e.$pw=(0,F.$Ai)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var m;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(m||(e.TunnelPrivacyId=m={}));function D(n){return!!n.forwardPort}var N;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(N||(e.ProvidedOnAutoForward=N={}));function S(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function d(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const c of t){const u=c.split("=")[1];if(/^https?:/.exec(u)){const i=S(O.URI.parse(u));if(i)return i}}}e.$tw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function v(n){return e.$tw.indexOf(n)>=0}e.$vw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(n){return e.$vw.indexOf(n)>=0}function s(n,t,c,u){if(c===1)return!1;if(c===2&&f(t)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(i?.length===4&&parseInt(i[1])>=18)return!1}return n<1024}class r{constructor(t,c,u){this.remoteAddress=t,this.localAddress=c,this.b=u,this.a=new C.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$yw=r;let o=class{constructor(t,c){this.k=t,this.l=c,this.a=new C.$he,this.onTunnelOpened=this.a.event,this.b=new C.$he,this.onTunnelClosed=this.b.event,this.c=new C.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],c=Array.from(this.e.values());for(const u of c){const i=Array.from(u.values());for(const w of i){const a=await w.value;a&&typeof a!="string"&&t.push(a)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:c}of t.values())await c.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,c,u,i,w){this.q(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:u,privacy:i,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(f(t)||v(t))&&(t=e.$tw[0]);const u=this.s(t,c);if(u)return++u.refcount,u.value}openTunnel(t,c,u,i,w,a=!1,l,g){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${w}.`);const $=this.f??t;if(!$)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(u)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t($,c,u,i,w,a,l,g);return b?b.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,u),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,u);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==u)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&y.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(h),h}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.e.get(t.tunnelRemoteHost);if(c){const u=c.get(t.tunnelRemotePort);u&&(u.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async p(t,c,u){if(u.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const i=u.value.then(async w=>{w&&typeof w!="string"&&(await w.dispose(!0),this.b.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(c),i}}async closeTunnel(t,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const u=this.e.get(t);if(u&&u.has(c)){const i=u.get(c);i.refcount=0,await this.p(t,c,i)}}q(t,c,u){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(c,{refcount:1,value:u})}async r(t,c){const u=this.e.get(t);if(u){const i=u.get(c),w=i?await i.value:void 0;(!w||typeof w=="string")&&u.delete(c),u.size===0&&this.e.delete(t)}}s(t,c){const u=[t];v(t)?(u.push(...e.$tw),u.push(...e.$vw)):f(t)&&u.push(...e.$vw);const i=u.map(w=>this.e.get(w));for(const w of i){const a=w?.get(c);if(a)return a}}canTunnel(t){return!!S(t)}u(t,c,u,i,w,a,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${i}.`);const g=u;this.j.add(g);const $=i===void 0?u:i,b={elevationRequired:w?this.isPortPrivileged($):!1},y={remoteAddress:{host:c,port:u},localAddressPort:i,privacy:a,public:a?a!==m.Private:void 0,protocol:l},h=t.forwardPort(y,b);return h?(this.q(c,u,h),h.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(g)})):this.j.delete(g),h}};e.$zw=o,e.$zw=o=Je([We(0,M.$7j),We(1,R.$7i)],o)}),define(ke[212],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,C.$Ai)("IUriIdentityService")}),define(ke[213],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Aw=void 0,e.$Aw=(0,C.$Ai)("editSessionIdentityService");var O;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(ke[214],Se([1,0,16]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=O,e.$XL=R,e.$YL=F,e.$ZL=M,e.$1L=p;function O(m){return m.scheme!==C.Schemas.file&&m.scheme!==C.Schemas.vscodeRemote}function R(m){if(m.folders.length)return m.folders.every(D=>O(D.uri))?m.folders[0].uri:void 0;if(m.configuration&&O(m.configuration))return m.configuration}function F(m){return R(m)?.scheme}function M(m){return R(m)?.authority}function p(m){return R(m)!==void 0}}),define(ke[46],Se([1,0,171,19,54,24,2,3,16]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=D,e.$Li=N,e.$Oi=S,e.$Pi=d,e.$Qi=v,e.$Ri=s,e.$Si=r,e.$Vi=t,e.$1i=c,e.$2i=u,e.$4i=i,e.$5i=w,e.$6i=a,e.$Ji=(0,p.$Ai)("contextService");function D(l){const g=l;return typeof g?.id=="string"&&M.URI.isUri(g.uri)}function N(l){return typeof l?.id=="string"&&!D(l)&&!d(l)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function S(l,g){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,O.$nc)(l)}:g?e.$Mi:e.$Ni;const $=l;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}function d(l){const g=l;return typeof g?.id=="string"&&M.URI.isUri(g.configPath)}function v(l){const g=l;if(g?.uri)return{id:g.id,uri:M.URI.revive(g.uri)};const $=l;if($?.configPath)return{id:$.id,configPath:M.URI.revive($.configPath)};if(l?.id)return{id:l.id}}var f;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function s(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function r(l){const g=l;return!!(g&&typeof g=="object"&&M.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class o{constructor(g,$,b,y,h){this.h=g,this.j=b,this.k=y,this.l=h,this.c=R.$Gi.forUris(this.l,()=>!0),this.folders=$}update(g){this.h=g.id,this.k=g.configuration,this.j=g.transient,this.l=g.l,this.folders=g.folders}get folders(){return this.g}set folders(g){this.g=g,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(g){this.k=g}getFolder(g){return g&&this.c.findSubstr(g)||null}n(){this.c=R.$Gi.forUris(this.l,()=>!0);for(const g of this.folders)this.c.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=o;class n{constructor(g,$){this.raw=$,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,F.$bh)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=n;function t(l){return new n({uri:l,index:0,name:(0,F.$0g)(l)},{uri:l.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,C.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function c(l,g){return F.$5g.isEqualOrParent(l,g.untitledWorkspacesHome)}function u(l){let g;return M.URI.isUri(l)?g=l:g=l.configuration,g?.scheme===m.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(l){return l.id===e.$3i}function w(l,g){return!c(l,g)&&!u(l)}function a(l){return(typeof l=="string"?(0,O.$oc)(l):(0,F.$_g)(l))===e.$Xi}}),define(ke[215],Se([1,0,73,5,6,24,2,170,99,38,3,12,46,28,212,11,33,13,15]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=c,e.$Hl=u,e.$Il=i;var t;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(t||(e.ProfileResourceType=t={}));function c(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&M.URI.isUri(g.location)&&M.URI.isUri(g.globalStorageHome)&&M.URI.isUri(g.settingsResource)&&M.URI.isUri(g.keybindingsResource)&&M.URI.isUri(g.tasksResource)&&M.URI.isUri(g.snippetsHome)&&M.URI.isUri(g.extensionsResource))}e.$Gl=(0,N.$Ai)("IUserDataProfilesService");function u(l,g){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:M.URI.revive(l.location).with({scheme:g}),globalStorageHome:M.URI.revive(l.globalStorageHome).with({scheme:g}),settingsResource:M.URI.revive(l.settingsResource).with({scheme:g}),keybindingsResource:M.URI.revive(l.keybindingsResource).with({scheme:g}),tasksResource:M.URI.revive(l.tasksResource).with({scheme:g}),snippetsHome:M.URI.revive(l.snippetsHome).with({scheme:g}),extensionsResource:M.URI.revive(l.extensionsResource).with({scheme:g}),cacheHome:M.URI.revive(l.cacheHome).with({scheme:g}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function i(l,g,$,b,y,h){return{id:l,name:g,location:$,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:h&&y?.useDefaultFlags?.globalState?h.globalStorageHome:(0,F.$bh)($,"globalStorage"),settingsResource:h&&y?.useDefaultFlags?.settings?h.settingsResource:(0,F.$bh)($,"settings.json"),keybindingsResource:h&&y?.useDefaultFlags?.keybindings?h.keybindingsResource:(0,F.$bh)($,"keybindings.json"),tasksResource:h&&y?.useDefaultFlags?.tasks?h.tasksResource:(0,F.$bh)($,"tasks.json"),snippetsHome:h&&y?.useDefaultFlags?.snippets?h.snippetsHome:(0,F.$bh)($,"snippets"),extensionsResource:h&&y?.useDefaultFlags?.extensions?h.extensionsResource:(0,F.$bh)($,"extensions.json"),cacheHome:(0,F.$bh)(b,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let w=class extends R.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(g,$,b,y){super(),this.t=g,this.u=$,this.w=b,this.y=y,this.f=!0,this.h=this.B(new O.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$Ac,emptyWindows:new Map},this.profilesHome=(0,F.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,F.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(g){this.f!==g&&(this.z=void 0,this.f=g)}isEnabled(){return this.f}get C(){if(!this.z){const g=this.D(),$=[g];if(this.f)try{for(const h of this.O()){if(!h.name||!(0,n.$ag)(h.name)||!h.location){this.y.warn("Skipping the invalid stored profile",h.location||h.name);continue}$.push(i((0,F.$$g)(h.location),h.name,h.location,this.g,{shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags},g))}}catch(h){this.y.error(h)}const b=new v.$Ac,y=new Map;if($.length)try{const h=this.Q();if(h.workspaces)for(const[E,k]of Object.entries(h.workspaces)){const I=M.URI.parse(E),P=$.find(V=>V.id===k);P&&b.set(I,P)}if(h.emptyWindows)for(const[E,k]of Object.entries(h.emptyWindows)){const I=$.find(P=>P.id===k);I&&y.set(E,I)}}catch(h){this.y.error(h)}this.z={profiles:$,workspaces:b,emptyWindows:y}}return this.z}D(){const g=i("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...g,extensionsResource:this.S()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const $="Temp",b=new RegExp(`${(0,o.$df)($)}\\s(\\d+)`);let y=0;for(const E of this.profiles){const k=b.exec(E.name),I=k?parseInt(k[1]):0;y=I>y?I:y}const h=`${$} ${y+1}`;return this.createProfile((0,C.$oj)((0,r.$Wg)()).toString(16),h,{transient:!0},g)}async createNamedProfile(g,$,b){return this.createProfile((0,C.$oj)((0,r.$Wg)()).toString(16),g,$,b)}async createProfile(g,$,b,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.F(g,$,b);return y&&await this.setProfileForWorkspace(y,h),h}async F(g,$,b){if(!(0,n.$ag)($)||!$)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get($);return y||(y=(async()=>{try{if(this.profiles.find(I=>I.name===$||I.id===g))throw new Error(`Profile with ${$} name already exists`);const E=i(g,$,(0,F.$bh)(this.profilesHome,g),this.g,b,this.defaultProfile);await this.u.createFolder(E.location);const k=[];return this.j.fire({profile:E,join(I){k.push(I)}}),await s.Promises.settled(k),this.I([E],[],[]),E}finally{this.r.delete($)}})(),this.r.set($,y)),y}async updateProfile(g,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(y=>y.id===g.id);if(!b)throw new Error(`Profile '${g.name}' does not exist`);return b=i(b.id,$.name??b.name,b.location,this.g,{shortName:$.shortName??b.shortName,icon:$.icon===null?void 0:$.icon??b.icon,transient:$.transient??b.isTransient,useDefaultFlags:$.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const $=this.profiles.find(y=>y.id===g.id);if(!$)throw new Error(`Profile '${g.name}' does not exist`);const b=[];this.m.fire({profile:$,join(y){b.push(y)}});try{await Promise.allSettled(b)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])$.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])$.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[$],[]);try{await this.u.del($.cacheHome,{recursive:!0})}catch(y){(0,D.$ll)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(g,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(y=>y.id===$.id);if(!b)throw new Error(`Profile '${$.name}' does not exist`);this.L(g,b)}unsetWorkspace(g,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(g,void 0,$)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const g=await this.u.resolve(this.profilesHome);await Promise.all((g.children||[]).filter($=>$.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,$.resource))).map($=>this.u.del($.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const g=this.s.profiles.filter($=>!this.H($));await Promise.allSettled(g.map($=>this.removeProfile($)))}getProfileForWorkspace(g){const $=this.G(g);return M.URI.isUri($)?this.s.workspaces.get($)??this.C.workspaces.get($):this.s.emptyWindows.get($)??this.C.emptyWindows.get($)}G(g){return(0,d.$Ki)(g)?g.uri:(0,d.$Pi)(g)?g.configPath:g.id}H(g){return!!([...this.s.emptyWindows.values()].some($=>this.w.extUri.isEqual($.location,g.location))||[...this.s.workspaces.values()].some($=>this.w.extUri.isEqual($.location,g.location))||[...this.C.emptyWindows.values()].some($=>this.w.extUri.isEqual($.location,g.location))||[...this.C.workspaces.values()].some($=>this.w.extUri.isEqual($.location,g.location)))}I(g,$,b){const y=[...this.profiles,...g],h=[];this.s.profiles=[];for(let E of y)E.isDefault||$.some(k=>E.id===k.id)||(E=b.find(k=>E.id===k.id)??E,E.isTransient?this.s.profiles.push(E):h.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(h),this.z=void 0,this.J(g,$,b)}J(g,$,b){this.h.fire({added:g,removed:$,updated:b,all:this.profiles})}L(g,$,b){b=$?.isTransient?!0:b,b||this.L(g,void 0,!0);const y=this.G(g),h=b?this.s:this.C;M.URI.isUri(y)?(h.workspaces.delete(y),$&&h.workspaces.set(y,$)):(h.emptyWindows.delete(y),$&&h.emptyWindows.set(y,$)),b||this.M()}M(){const g={};for(const[b,y]of this.C.workspaces.entries())g[b.toString()]=y.id;const $={};for(const[b,y]of this.C.emptyWindows.entries())$[b.toString()]=y.id;this.R({workspaces:g,emptyWindows:$}),this.z=void 0}N(g){const $={},b=this.D();if(g.workspaces)for(const[h,E]of Object.entries(g.workspaces)){const k=M.URI.parse(E);$[h]=this.w.extUri.isEqual(k,b.location)?b.id:this.w.extUri.basename(k)}const y={};if(g.emptyWindows)for(const[h,E]of Object.entries(g.emptyWindows)){const k=M.URI.parse(E);y[h]=this.w.extUri.isEqual(k,b.location)?b.id:this.w.extUri.basename(k)}return{workspaces:$,emptyWindows:y}}O(){return[]}P(g){throw new Error("not implemented")}Q(){return{}}R(g){throw new Error("not implemented")}S(){}};e.$Jl=w,e.$Jl=w=Je([We(0,m.$Hi),We(1,D.$7k),We(2,f.$El),We(3,S.$7j)],w);class a extends w{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(g){this.a=g}Q(){return this.X}R(g){this.X=g}}e.$Kl=a}),define(ke[216],Se([1,0,11,5,6,60,15,151,3,215]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$9p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$7p=e.$6p=e.$5p=void 0,e.$8p=v,e.$0p=s,e.$_p=o,e.$5p="__$__isNewStorageMarker",e.$6p="__$__targetStorageMarker",e.$7p=(0,m.$Ai)("storageService");var N;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(N||(e.WillSaveStateReason=N={}));var S;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var d;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function v(n){const t=n.get(e.$6p);if(t)try{return JSON.parse(t)}catch{}return Object.create(null)}class f extends R.$Uc{static{this.a=60*1e3}constructor(t={flushInterval:f.a}){super(),this.m=t,this.b=this.B(new O.$ke),this.c=this.B(new O.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$he),this.onWillSaveState=this.f.event,this.h=this.B(new C.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(t,c,u){return O.Event.filter(this.b.event,i=>i.scope===t&&(c===void 0||i.key===c),u)}n(){this.j.value=(0,C.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,F.mark)("code/willInitStorage");try{await this.O()}finally{(0,F.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(t,c){const{key:u,external:i}=c;if(u===e.$6p){switch(t){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:t})}else this.b.fire({scope:t,key:u,target:this.J(t)[u],external:i})}w(t){this.f.fire({reason:t})}get(t,c,u){return this.P(c)?.get(t,u)}getBoolean(t,c,u){return this.P(c)?.getBoolean(t,u)}getNumber(t,c,u){return this.P(c)?.getNumber(t,u)}getObject(t,c,u){return this.P(c)?.getObject(t,u)}storeAll(t,c){this.y(()=>{for(const u of t)this.store(u.key,u.value,u.scope,u.target,c)})}store(t,c,u,i,w=!1){if((0,M.$jg)(c)){this.remove(t,u,w);return}this.y(()=>{this.z(t,u,i),this.P(u)?.set(t,c,w)})}remove(t,c,u=!1){this.y(()=>{this.z(t,c,void 0),this.P(c)?.delete(t,u)})}y(t){this.b.pause(),this.c.pause();try{t()}finally{this.b.resume(),this.c.resume()}}keys(t,c){const u=[],i=this.J(t);for(const w of Object.keys(i))i[w]===c&&u.push(w);return u}z(t,c,u,i=!1){const w=this.J(c);typeof u=="number"?w[t]!==u&&(w[t]=u,this.P(c)?.set(e.$6p,JSON.stringify(w),i)):typeof w[t]=="number"&&(delete w[t],this.P(c)?.set(e.$6p,JSON.stringify(w),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(t){switch(t){case-1:return this.I;case 0:return this.G;default:return this.D}}L(t){const c=this.P(t);return c?v(c):Object.create(null)}isNew(t){return this.getBoolean(e.$5p,t)===!0}async flush(t=N.NONE){this.f.fire({reason:t});const c=this.P(-1),u=this.P(0),i=this.P(1);switch(t){case N.NONE:await C.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case N.SHUTDOWN:await C.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const t=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return o(t,c,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(t){return await this.flush(),this.P(t)?.optimize()}async switch(t,c){return this.w(N.NONE),(0,D.$Fl)(t)?this.R(t,c):this.S(t,c)}M(t,c){return!(t.id===c.id||s(c)&&s(t))}N(t,c,u){this.y(()=>{const i=new Set;for(const[w,a]of t)i.add(w),c.get(w)!==a&&this.u(u,{key:w,external:!0});for(const[w]of c.items)i.has(w)||this.u(u,{key:w,external:!0})})}}e.$9p=f;function s(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class r extends f{constructor(){super(),this.U=this.B(new p.$3p(new p.$4p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$3p(new p.$4p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$3p(new p.$4p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(t=>this.u(1,t))),this.B(this.W.onDidChangeStorage(t=>this.u(0,t))),this.B(this.U.onDidChangeStorage(t=>this.u(-1,t)))}P(t){switch(t){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(t){switch(t){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(t){return!1}}e.$$p=r;async function o(n,t,c,u,i,w){const a=I=>{try{return JSON.parse(I)}catch{return I}},l=new Map,g=new Map;n.forEach((I,P)=>{l.set(P,I),g.set(P,a(I))});const $=new Map,b=new Map;t.forEach((I,P)=>{$.set(P,I),b.set(P,a(I))});const y=new Map,h=new Map;c.forEach((I,P)=>{y.set(P,I),h.set(P,a(I))}),console.group(u!==i?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const E=[];if(l.forEach((I,P)=>{E.push({key:P,value:I})}),console.table(E),console.groupEnd(),console.log(g),u!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const I=[];$.forEach((P,V)=>{I.push({key:V,value:P})}),console.table(I),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${w})`);const k=[];y.forEach((I,P)=>{k.push({key:P,value:I})}),console.table(k),console.groupEnd(),console.log(h)}}),define(ke[76],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class C{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const F=this.c++;return this.b.set(F,R),this.e(),F}get(R,F){return this.b.has(R)?this.b.get(R)[F]:void 0}delete(R){this.b.delete(R),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$dmc=C}),define(ke[47],Se([1,0,16,24,3]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=void 0;class F{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new O.$3g(p=>{const m=this.b.get(p.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(p,m){m===null?this.b.delete(p.scheme):this.b.set(p.scheme,m)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$imc=F,e.$jmc=(0,R.$Ai)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8O=void 0,e.$8O=(0,C.$Ai)("IExtHostInitDataService")}),define(ke[217],Se([1,0,176,12,201,27]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;let M=class extends R.$fQ{constructor(m,D,N){const S=N.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",d=N.remote.isRemote?(0,C.localize)(0,null):m?(0,C.localize)(1,null):(0,C.localize)(2,null);super(D.createLogger(S,{name:d}))}};e.$poc=M,e.$poc=M=Je([We(1,O.$8j),We(2,F.$8O)],M)}),define(ke[218],Se([1,0,11]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=e.$1mc=void 0;class O{constructor(M,p,m){this.h=new Map,this.a=M,this.b=p,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new C.$Mh(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of D.values())N.complete()}catch(N){for(const S of D.values())S.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let m=this.f[M];return typeof m>"u"&&(m=p),m}update(M,p){this.f[M]=p;const m=this.h.get(M);if(m!==void 0)return m.p;const D=new C.$Xh;return this.h.set(M,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.$1mc=O;class R extends O{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$2mc=R}),define(ke[219],Se([1,0,5,2]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=void 0;class R{constructor(M){this.c=M,this.a=new C.$he,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$he,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,m,D){const S=this.c.getNotebookDocument(O.URI.revive(M)).acceptModelChanged(p.value,m,D);this.b.fire(S)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(O.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(O.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$Pnc=R}),define(ke[17],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SO=e.$RO=void 0,e.$RO=(0,C.$Ai)("IExtHostRpcService");class O{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$SO=O}),define(ke[220],Se([1,0,21,5]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=void 0;class R{#e;constructor(M,p){this.b=new O.$he,this.onDidChange=this.b.event,this.a=C.$Vm.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$$mc=R}),define(ke[61],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=e.$ymc=void 0,e.$ymc=(0,C.$Ai)("IURITransformerService");class O{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$zmc=O}),define(ke[221],Se([1,0,22]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qsb=R,e.$rsb=M;class O{constructor(){this.buffers=[]}add(m){let D=this.buffers.indexOf(m);return D<0&&(D=this.buffers.length,this.buffers.push(m)),D}}function R(p,m){if(m.serializeBuffersForPostMessage){const D=new O,S=JSON.stringify(p,(v,f)=>{if(f instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:D.add(f)};if(ArrayBuffer.isView(f)){const s=F(f);if(s)return{$$vscode_array_buffer_reference$$:!0,index:D.add(f.buffer),view:{type:s,byteLength:f.byteLength,byteOffset:f.byteOffset}}}return f}),d=D.buffers.map(v=>{const f=new Uint8Array(v);return C.$Je.wrap(f)});return{message:S,buffers:d}}else return{message:JSON.stringify(p),buffers:[]}}function F(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,m){const D=m.map(d=>{const v=new ArrayBuffer(d.byteLength);return new Uint8Array(v).set(d.buffer),v}),N=m.length?(d,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const f=v,{index:s}=f,r=D[s];if(f.view)switch(f.view.type){case 1:return new Int8Array(r,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return v}:void 0;return{message:JSON.parse(p,N),arrayBuffers:D}}}),define(ke[106],Se([1,0,185,15,2,6,3,29,38,16,44,145,32]),function(he,e,C,O,R,F,M,p,m,D,N,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$YF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$OF=e.EditorInputCapabilities=e.$NF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0,e.$EF=s,e.$FF=r,e.$GF=o,e.$HF=n,e.$IF=t,e.$JF=c,e.$KF=u,e.$LF=i,e.$MF=w,e.$PF=y,e.$QF=E,e.$RF=k,e.$SF=I,e.$TF=P,e.$UF=V,e.$VF=W,e.$WF=q,e.$XF=ve,e.$ZF=ue,e.$1F=re,e.$2F=Ne,e.$3F=Te,e.$zF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$AF={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$BF="workbench.editor.sidebysideEditor",e.$CF="workbench.editors.textDiffEditor",e.$DF="workbench.editors.binaryResourceDiffEditor";var v;(function(T){T[T.PROGRAMMATIC=1]="PROGRAMMATIC",T[T.USER=2]="USER",T[T.EDIT=3]="EDIT",T[T.NAVIGATION=4]="NAVIGATION",T[T.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var f;(function(T){T[T.IDENTICAL=1]="IDENTICAL",T[T.SIMILAR=2]="SIMILAR",T[T.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function s(T){const X=T;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}function r(T){const X=T;return!!X&&typeof X.getScrollPosition=="function"&&typeof X.setScrollPosition=="function"&&!!X.onDidChangeScroll}function o(T,X,pe){for(const Ie of pe.visibleEditorPanes)if(Ie.group.id===X&&T.matches(Ie.input))return Ie.getViewState()}function n(T){if(y(T))return!1;const X=T;return R.URI.isUri(X?.resource)}function t(T){if(y(T))return!1;const X=T;return X?.original!==void 0&&X.modified!==void 0}function c(T){if(y(T))return!1;const X=T;return!X||X.resources&&!Array.isArray(X.resources)?!1:!!X.resources||!!X.multiDiffSource}function u(T){if(y(T)||t(T))return!1;const X=T;return X?.primary!==void 0&&X.secondary!==void 0}function i(T){if(y(T))return!1;const X=T;return X?X.resource===void 0||X.resource.scheme===D.Schemas.untitled||X.forceUntitled===!0:!1}function w(T){if(y(T))return!1;const X=T;return R.URI.isUri(X?.base?.resource)&&R.URI.isUri(X?.input1?.resource)&&R.URI.isUri(X?.input2?.resource)&&R.URI.isUri(X?.result?.resource)}var a;(function(T){T[T.SHORT=0]="SHORT",T[T.MEDIUM=1]="MEDIUM",T[T.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var l;(function(T){T[T.EXPLICIT=1]="EXPLICIT",T[T.AUTO=2]="AUTO",T[T.FOCUS_CHANGE=3]="FOCUS_CHANGE",T[T.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class g{constructor(){this.a=new Map}registerSource(X,pe){let Ie=this.a.get(X);return Ie||(Ie={source:X,label:pe},this.a.set(X,Ie)),Ie.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.$NF=new g;var $;(function(T){T[T.None=0]="None",T[T.Readonly=2]="Readonly",T[T.Untitled=4]="Untitled",T[T.Singleton=8]="Singleton",T[T.RequiresTrust=16]="RequiresTrust",T[T.CanSplitInGroup=32]="CanSplitInGroup",T[T.ForceDescription=64]="ForceDescription",T[T.CanDropIntoEditor=128]="CanDropIntoEditor",T[T.MultipleEditors=256]="MultipleEditors",T[T.Scratchpad=512]="Scratchpad"})($||(e.EditorInputCapabilities=$={}));class b extends F.$Uc{}e.$OF=b;function y(T){return T instanceof b}function h(T){const X=T;return R.URI.isUri(X?.preferredResource)}function E(T){const X=T;return y(X?.primary)&&y(X?.secondary)}function k(T){const X=T;return y(X?.modified)&&y(X?.original)}function I(T,X,pe,Ie,ye){return Te(Ie,[(0,S.$kj)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const $e={...pe,limits:{size:Number.MAX_VALUE}};T.openEditor(X,$e)}}),(0,S.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:d.default.Warning})}function P(T){return y(T?.editor)}function V(T){const X=T;return P(T)&&X?.group!==void 0}function W(T){const X=T;return typeof X?.groupId=="number"&&y(X.editor)}function q(T){return typeof T?.groupId=="number"}var A;(function(T){T[T.UNKNOWN=0]="UNKNOWN",T[T.REPLACE=1]="REPLACE",T[T.MOVE=2]="MOVE",T[T.UNPIN=3]="UNPIN"})(A||(e.EditorCloseContext=A={}));var U;(function(T){T[T.GROUP_ACTIVE=0]="GROUP_ACTIVE",T[T.GROUP_INDEX=1]="GROUP_INDEX",T[T.GROUP_LABEL=2]="GROUP_LABEL",T[T.GROUP_LOCKED=3]="GROUP_LOCKED",T[T.EDITOR_OPEN=4]="EDITOR_OPEN",T[T.EDITOR_CLOSE=5]="EDITOR_CLOSE",T[T.EDITOR_MOVE=6]="EDITOR_MOVE",T[T.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",T[T.EDITOR_LABEL=8]="EDITOR_LABEL",T[T.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",T[T.EDITOR_PIN=10]="EDITOR_PIN",T[T.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",T[T.EDITOR_SELECTION=12]="EDITOR_SELECTION",T[T.EDITOR_STICKY=13]="EDITOR_STICKY",T[T.EDITOR_DIRTY=14]="EDITOR_DIRTY",T[T.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var K;(function(T){T[T.PRIMARY=1]="PRIMARY",T[T.SECONDARY=2]="SECONDARY",T[T.BOTH=3]="BOTH",T[T.ANY=4]="ANY"})(K||(e.SideBySideEditor=K={}));class ie{getOriginalUri(X,pe){if(!X)return;if(w(X))return e.$YF.getOriginalUri(X.result,pe);if(pe?.supportSideBySide){const{primary:ye,secondary:$e}=this.a(X);if(ye&&$e){if(pe?.supportSideBySide===K.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:pe.filterByScheme}),secondary:this.getOriginalUri($e,{filterByScheme:pe.filterByScheme})};if(pe?.supportSideBySide===K.ANY)return this.getOriginalUri(ye,{filterByScheme:pe.filterByScheme})??this.getOriginalUri($e,{filterByScheme:pe.filterByScheme});X=pe.supportSideBySide===K.PRIMARY?ye:$e}}if(t(X)||c(X)||u(X)||w(X))return;const Ie=h(X)?X.preferredResource:X.resource;return!Ie||!pe||!pe.filterByScheme?Ie:this.b(Ie,pe.filterByScheme)}a(X){return E(X)||u(X)?{primary:X.primary,secondary:X.secondary}:k(X)||t(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,pe){if(!X)return;if(w(X))return e.$YF.getCanonicalUri(X.result,pe);if(pe?.supportSideBySide){const{primary:ye,secondary:$e}=this.a(X);if(ye&&$e){if(pe?.supportSideBySide===K.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:pe.filterByScheme}),secondary:this.getCanonicalUri($e,{filterByScheme:pe.filterByScheme})};if(pe?.supportSideBySide===K.ANY)return this.getCanonicalUri(ye,{filterByScheme:pe.filterByScheme})??this.getCanonicalUri($e,{filterByScheme:pe.filterByScheme});X=pe.supportSideBySide===K.PRIMARY?ye:$e}}if(t(X)||c(X)||u(X)||w(X))return;const Ie=X.resource;return!Ie||!pe||!pe.filterByScheme?Ie:this.b(Ie,pe.filterByScheme)}b(X,pe){if(Array.isArray(pe)){if(pe.some(Ie=>X.scheme===Ie))return X}else if(pe===X.scheme)return X}}var ce;(function(T){T[T.UNKNOWN=0]="UNKNOWN",T[T.KEYBOARD=1]="KEYBOARD",T[T.MOUSE=2]="MOUSE"})(ce||(e.EditorCloseMethod=ce={}));function ve(T,X,pe,Ie){if(!T.isSticky(X))return!1;switch(Ie.preventPinnedEditorClose){case"keyboardAndMouse":return pe===ce.MOUSE||pe===ce.KEYBOARD;case"mouse":return pe===ce.MOUSE;case"keyboard":return pe===ce.KEYBOARD}return!1}e.$YF=new ie;var Ee;(function(T){T[T.LEFT=0]="LEFT",T[T.RIGHT=1]="RIGHT"})(Ee||(e.CloseDirection=Ee={}));class ge{constructor(){this.c=new Map,this.d=new Map}start(X){const pe=this.a=X.get(M.$zi);for(const[Ie,ye]of this.c)this.e(Ie,ye,pe);this.c.clear()}e(X,pe,Ie){const ye=Ie.createInstance(pe);this.d.set(X,ye)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,O.$lg)(this.b)}registerEditorSerializer(X,pe){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,pe,this.a):this.c.set(X,pe),(0,F.$Sc)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}p.$ho.add(e.$zF.EditorFactory,new ge);async function ue(T,X,pe){return!T||!T.length?[]:await Promise.all(T.map(async Ie=>{const ye=R.URI.revive(Ie.fileUri);if(!ye){pe.info("Cannot resolve the path because it is not valid.",Ie);return}if(!await X.canHandleResource(ye)){pe.info("Cannot resolve the path because it cannot be handled",Ie);return}let fe=Ie.exists,Q=Ie.type;if(typeof fe!="boolean"||typeof Q!="number")try{Q=(await X.stat(ye)).isDirectory?m.FileType.Directory:m.FileType.Unknown,fe=!0}catch(le){pe.error(le),fe=!1}if(!fe&&Ie.openOnlyIfExists){pe.info("Cannot resolve the path because it does not exist",Ie);return}if(Q===m.FileType.Directory){pe.info("Cannot resolve the path because it is a directory",Ie);return}const x={...Ie.options,pinned:!0};return fe?{resource:ye,options:x}:{resource:ye,options:x,forceUntitled:!0}}))}var Ce;(function(T){T[T.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",T[T.SEQUENTIAL=1]="SEQUENTIAL"})(Ce||(e.EditorsOrder=Ce={}));function re(T){const X=T;if(!X)return!1;const pe=X;if(pe.modified)return re(pe.modified);const Ie=X;return!!(Ie.contributionsState&&Ie.viewState&&Array.isArray(Ie.cursorState))}function Ne(T){return(0,N.$mj)(T)}function Te(T,X,pe){const Ie=(0,N.$nj)(T,X);return Ie.forceMessage=pe?.forceMessage,Ie.forceSeverity=pe?.forceSeverity,Ie.allowDialog=pe?.allowDialog,Ie}}),define(ke[222],Se([1,0,5,186,3,6,28,29,26,92,210]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$F=e.$0F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$9F=e.ViewContentGroups=e.$7F=e.ViewContainerLocation=e.Extensions=e.$6F=e.$5F=e.$4F=void 0,e.$8F=v,e.$4F="views",e.$5F=(0,O.localize)(0,null),e.$6F=(0,N.$lx)("default-view-icon",D.$Zj.window,(0,O.localize)(1,null));var S;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var d;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(d||(e.ViewContainerLocation=d={})),e.$7F=[0,1,2];function v(i){switch(i){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class f extends F.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$he),this.onDidRegister=this.c.event,this.f=this.B(new C.$he),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(w,a,l){const g=this.get(w.id);if(g)return g;const $=w;return $.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,M.$xc)(this.g,a,[]).push($),l?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:a}),$}deregisterViewContainer(w){for(const a of this.g.keys()){const l=this.g.get(a),g=l?.indexOf(w);if(g!==-1){l?.splice(g,1),l.length===0&&this.g.delete(a),this.f.fire({viewContainer:w,viewContainerLocation:a});return}}}get(w){return this.all.filter(a=>a.id===w)[0]}getViewContainers(w){return[...this.g.get(w)||[]]}getViewContainerLocation(w){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(l=>l?.id===w.id).length>0)[0]}getDefaultViewContainer(w){return this.h.find(a=>this.getViewContainerLocation(a)===w)}}p.$ho.add(S.ViewContainersRegistry,new f);var s;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(s||(e.ViewContentGroups=s={}));function r(i,w){const a=i.group??s.More,l=w.group??s.More;return a!==l?a.localeCompare(l):(i.order??5)-(w.order??5)}class o extends F.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$he),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$he),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$he),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$he),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Hc}registerViews(w,a){this.registerViews2([{views:w,viewContainer:a}])}registerViews2(w){w.forEach(({views:a,viewContainer:l})=>this.r(a,l)),this.c.fire(w)}deregisterViews(w,a){const l=this.s(w,a);l.length&&this.f.fire({views:l,viewContainer:a})}moveViews(w,a){for(const l of this.m.keys())if(l!==a){const g=this.s(w,l);g.length&&(this.r(g,a),this.g.fire({views:g,from:l,to:a}))}}getViews(w){return this.m.get(w)||[]}getView(w){for(const a of this.j){const l=(this.m.get(a)||[]).filter(g=>g.id===w)[0];if(l)return l}return null}getViewContainer(w){for(const a of this.j)if((this.m.get(a)||[]).filter(g=>g.id===w)[0])return a;return null}registerViewWelcomeContent(w,a){return this.n.add(w,a),this.h.fire(w),(0,F.$Sc)(()=>{this.n.delete(w,a),this.h.fire(w)})}registerViewWelcomeContent2(w,a){const l=new Map;for(const[g,$]of a)this.n.add(w,$),l.set(g,(0,F.$Sc)(()=>{this.n.delete(w,$),this.h.fire(w)}));return this.h.fire(w),l}getViewWelcomeContent(w){const a=[];return this.n.forEach(w,l=>a.push(l)),a.sort(r)}r(w,a){let l=this.m.get(a);l||(l=[],this.m.set(a,l),this.j.push(a));for(const g of w){if(this.getView(g.id)!==null)throw new Error((0,O.localize)(2,null,g.id));l.push(g)}}s(w,a){const l=this.m.get(a);if(!l)return[];const g=[],$=[];for(const b of l)w.includes(b)?g.push(b):$.push(b);return g.length&&($.length?this.m.set(a,$):(this.m.delete(a),this.j.splice(this.j.indexOf(a),1))),g}}p.$ho.add(S.ViewsRegistry,new o),e.$9F=(0,R.$Ai)("viewDescriptorService");var n;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var t;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(t||(e.TreeItemCollapsibleState=t={}));class c{constructor(w,a){this.c=!1,this.d=!1,(0,m.$0n)(this,w),this.d=!!a,this.resolve=async l=>{if(a&&!this.c){const g=await a(l);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$0F=c;class u extends Error{constructor(w){super((0,O.localize)(3,null,w)),this.name="NoTreeViewError"}static is(w){return w.name==="NoTreeViewError"}}e.$$F=u}),define(ke[223],Se([1,0,187,31]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=void 0,e.$cG=new O.$Rj("chatSessionResponseVote","",{type:"string",description:(0,C.localize)(0,null)}),e.$dG=new O.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,C.localize)(1,null)}),e.$eG=new O.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,C.localize)(2,null)}),e.$fG=new O.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,C.localize)(3,null)}),e.$gG=new O.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,C.localize)(4,null)}),e.$hG=new O.$Rj("chatResponse",!1,{type:"boolean",description:(0,C.localize)(5,null)}),e.$iG=new O.$Rj("chatRequest",!1,{type:"boolean",description:(0,C.localize)(6,null)}),e.$jG=new O.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,C.localize)(7,null)}),e.$kG=new O.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,C.localize)(8,null)}),e.$lG=new O.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,C.localize)(9,null)}),e.$mG=new O.$Rj("inChatInput",!1,{type:"boolean",description:(0,C.localize)(10,null)}),e.$nG=new O.$Rj("inChat",!1,{type:"boolean",description:(0,C.localize)(11,null)}),e.$oG=new O.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,C.localize)(12,null)}),e.$pG=new O.$Rj("chatCursorAtTop",!1),e.$qG=new O.$Rj("chatInputHasAgent",!1),e.$rG=new O.$Rj("chatLocation",void 0)}),define(ke[224],Se([1,0,11,20,5,42,6,45,132,13,31,3,12,102,204,216,223]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.ChatAgentLocation=void 0,e.$vH=i,e.$wH=w;var n;(function(a){a.Panel="panel",a.Terminal="terminal",a.Notebook="notebook",a.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(a){function l(g){switch(g){case"panel":return a.Panel;case"terminal":return a.Terminal;case"notebook":return a.Notebook;case"editor":return a.Editor}return a.Panel}a.fromRaw=l}(n||(e.ChatAgentLocation=n={})),e.$qH=(0,S.$Ai)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(l){this.f=l,this.b=[],this.d=new R.$he,this.onDidChangeAgents=this.d.event,this.e=r.$oG.bindTo(this.f)}registerAgent(l,g){if(this.getAgent(l))throw new Error(`Agent already registered: ${JSON.stringify(l)}`);const b=this,y=g.slashCommands;g={...g,get slashCommands(){return y.filter(E=>!E.when||b.f.contextMatchesRules(N.$yj.deserialize(E.when)))}};const h={data:g};return this.b.push(h),(0,M.$Sc)(()=>{this.b=this.b.filter(E=>E!==h),this.d.fire(void 0)})}registerAgentImplementation(l,g){const $=this.g(l);if(!$)throw new Error(`Unknown agent: ${JSON.stringify(l)}`);if($.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(l)}`);return $.data.isDefault&&this.e.set(!0),$.impl=g,this.d.fire(new c($.data,g)),(0,M.$Sc)(()=>{$.impl=void 0,this.d.fire(void 0),$.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(l,g){l.isDynamic=!0;const $={data:l,impl:g};return this.b.push($),this.d.fire(new c(l,g)),(0,M.$Sc)(()=>{this.b=this.b.filter(b=>b!==$),this.d.fire(void 0)})}updateAgent(l,g){const $=this.g(l);if(!$?.impl)throw new Error(`No activated agent with id ${JSON.stringify(l)} registered`);$.data.metadata={...$.data.metadata,...g},this.d.fire(new c($.data,$.impl))}getDefaultAgent(l){return this.getActivatedAgents().find(g=>!!g.isDefault&&g.locations.includes(l))}getContributedDefaultAgent(l){return this.getAgents().find(g=>!!g.isDefault&&g.locations.includes(l))}getSecondaryAgent(){return F.Iterable.find(this.b.values(),l=>!!l.data.metadata.isSecondary)?.data}g(l){return this.b.find(g=>g.data.id===l)}getAgent(l){return this.g(l)?.data}getAgentByFullyQualifiedId(l){return this.b.find(g=>i(g.data)===l)?.data}getAgents(){return this.b.map(l=>l.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(l=>!!l.impl).map(l=>new c(l.data,l.impl))}getAgentsByName(l){return this.getAgents().filter(g=>g.name===l)}async invokeAgent(l,g,$,b,y){const h=this.g(l);if(!h?.impl)throw new Error(`No activated agent with id ${l}`);return await h.impl.invoke(g,$,b,y)}async getFollowups(l,g,$,b,y){const h=this.g(l);if(!h?.impl)throw new Error(`No activated agent with id ${l}`);return h.impl?.provideFollowups?h.impl.provideFollowups(g,$,b,y):[]}};e.$rH=t,e.$rH=t=Je([We(0,N.$Sj)],t);class c{constructor(l,g){this.b=l,this.d=g}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(l,g,$,b){return this.d.invoke(l,g,$,b)}async provideFollowups(l,g,$,b){return this.d.provideFollowups?this.d.provideFollowups(l,g,$,b):[]}provideWelcomeMessage(l,g){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(l,g)}provideSampleQuestions(l,g){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(l,g)}}e.$sH=c,e.$tH=(0,S.$Ai)("chatAgentNameService");let u=class{static{o=this}static{this.b="chat.participantNameRegistry"}constructor(l,g,$,b){if(this.g=g,this.h=$,this.i=b,this.e=(0,m.$3d)(this,Object.create(null)),this.f=!1,!l.chatParticipantRegistry)return;this.d=l.chatParticipantRegistry;const y=b.get(o.b,-1);try{this.e.set(JSON.parse(y??"{}"),void 0)}catch{b.remove(o.b,-1)}this.j()}j(){this.f||this.k().catch(l=>this.h.warn("Failed to fetch chat participant registry",l)).then(()=>(0,C.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const l=await this.g.request({type:"GET",url:this.d},O.CancellationToken.None);if(l.res.statusCode!==200)throw new Error("Could not get extensions report.");const g=await(0,f.$Zp)(l);if(!g||g.version!==1)throw new Error("Unexpected chat participant registry response.");const $=g.restrictedChatParticipants;this.e.set($,void 0),this.i.store(o.b,JSON.stringify($),-1,1)}getAgentNameRestriction(l){const g=this.l(l.name,l).get(),$=!l.fullName||this.l(l.fullName.replace(/\s/g,""),l).get();return g&&$}l(l,g){return this.e.map(b=>b[l.toLowerCase()]).map(b=>b?b.some(y=>(0,D.$Bf)(y,y.includes(".")?g.extensionId.value:g.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$uH=u,e.$uH=u=o=Je([We(0,v.$nk),We(1,f.$Tp),We(2,d.$7j),We(3,s.$7p)],u);function i(a){return`${a.extensionId.value}.${a.id}`}function w(a){const l="name"in a?a:{...a,name:a.id};return"extensionPublisherId"in l||(l.extensionPublisherId=l.extensionPublisher??""),"extensionDisplayName"in l||(l.extensionDisplayName=""),(0,p.$0h)(l)}}),define(ke[225],Se([1,0,2,30,3]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3G=e.$2G=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$ZG=F,e.$1G=M;function F(D){return!!D&&typeof D=="object"&&"uri"in D&&D.uri instanceof C.URI&&"version"in D&&typeof D.version=="number"&&"ranges"in D&&Array.isArray(D.ranges)&&D.ranges.every(O.$At.isIRange)}function M(D){return!!D&&typeof D=="object"&&"documents"in D&&Array.isArray(D.documents)&&D.documents.every(F)}var p;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var m;(function(D){D[D.Action=1]="Action",D[D.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$2G=(0,R.$Ai)("IChatService"),e.$3G="accessibility.voice.keywordActivation"}),define(ke[226],Se([1,0,5,11,188]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dsb=void 0;class F{constructor(){this.f=new Map,this.m=[],this.n=new C.$he,this.o=new C.$he,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,m,D,N){const S={command:p};if(m&&Object.keys(m).length>0&&(S.arguments=m),this.u("request",S),typeof N=="number"){const d=setTimeout(()=>{clearTimeout(d);const v=this.f.get(S.seq);if(v){this.f.delete(S.seq);const f={type:"response",seq:0,request_seq:S.seq,success:!1,command:p,message:(0,R.localize)(0,null,N,p)};v(f)}},N)}return D&&this.f.set(S.seq,D),S.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,m){return p.type!=="event"||m.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,O.$Bh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const m=p,D=this.f.get(m.request_seq);D&&(this.f.delete(m.request_seq),D(m));break}}}}u(p,m){m.type=p,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((m,D)=>p.set(D,m)),await(0,O.$Bh)(500),p.forEach((m,D)=>{m({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Dsb=F}),define(ke[227],Se([1,0,2,189,31,3]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$MJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$KJ=e.MemoryRangeType=e.State=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=void 0,e.$JJ=m,e.$LJ=N,e.$xI="workbench.view.debug",e.$yI="workbench.debug.variablesView",e.$zI="workbench.debug.watchExpressionsView",e.$AI="workbench.debug.callStackView",e.$BI="workbench.debug.loadedScriptsView",e.$CI="workbench.debug.breakPointsView",e.$DI="workbench.debug.disassemblyView",e.$EI="workbench.panel.repl",e.$FI="workbench.panel.repl.view",e.$GI=new R.$Rj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$HI=new R.$Rj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$II=new R.$Rj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$JI="debugUx",e.$KI=new R.$Rj(e.$JI,"default",{type:"string",description:O.localize(3,null)}),e.$LI=new R.$Rj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$MI=new R.$Rj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$NI=new R.$Rj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$OI=new R.$Rj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$PI=new R.$Rj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$QI=new R.$Rj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$RI=new R.$Rj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$SI=new R.$Rj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$TI=new R.$Rj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$UI=new R.$Rj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$VI=new R.$Rj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$WI=new R.$Rj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$XI=new R.$Rj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$YI=new R.$Rj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$ZI=new R.$Rj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$1I=new R.$Rj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$2I=new R.$Rj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$3I=new R.$Rj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$4I=new R.$Rj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$5I=new R.$Rj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$6I=new R.$Rj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$7I=new R.$Rj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$8I=new R.$Rj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$9I=new R.$Rj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$0I=new R.$Rj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$$I=new R.$Rj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$_I=new R.$Rj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$aJ=new R.$Rj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$bJ=new R.$Rj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$cJ=new R.$Rj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$dJ=new R.$Rj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$eJ=new R.$Rj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$fJ=new R.$Rj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$gJ=new R.$Rj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$hJ=new R.$Rj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$iJ=new R.$Rj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$jJ=new R.$Rj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$kJ=new R.$Rj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$lJ=new R.$Rj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$mJ=new R.$Rj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$nJ=new R.$Rj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$oJ=new R.$Rj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$pJ=new R.$Rj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$qJ=new R.$Rj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$rJ=new R.$Rj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$sJ=new R.$Rj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$tJ=new R.$Rj("variableInterfaces",!1,{type:"array",description:O.localize(50,null)}),e.$uJ=new R.$Rj("variableName",!1,{type:"string",description:O.localize(51,null)}),e.$vJ=new R.$Rj("variableLanguage",!1,{type:"string",description:O.localize(52,null)}),e.$wJ=new R.$Rj("variableExtensionId",!1,{type:"string",description:O.localize(53,null)}),e.$xJ=new R.$Rj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(54,null)}),e.$yJ=new R.$Rj("multiSessionRepl",!1,{type:"boolean",description:O.localize(55,null)}),e.$zJ=new R.$Rj("multiSessionDebug",!1,{type:"boolean",description:O.localize(56,null)}),e.$AJ=new R.$Rj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(57,null)}),e.$BJ=new R.$Rj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(58,null)}),e.$CJ=new R.$Rj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(59,null)}),e.$DJ=new R.$Rj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(60,null)});const M=t=>O.localize(61,null,t);e.$EJ=M,e.$FJ="editor.contrib.debug",e.$GJ="editor.contrib.breakpoint",e.$HJ="debug",e.$IJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(62,null)};var p;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(p||(e.State=p={}));function m(t){switch(t){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var D;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$KJ="vscode-debug-memory";function N(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var S;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var d;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var v;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(v||(e.DebuggerString=v={})),e.$MJ=(0,F.$Ai)("debugService");var f;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var s;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var r;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var o;(function(t){t.deserialize=c=>c,t.serialize=c=>c})(o||(e.IDebugVisualizationTreeItem=o={}));var n;(function(t){t.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:C.URI.revive(c.iconPath.light),dark:C.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),t.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(ke[228],Se([1,0,13,2,19,26,16,30,20,18]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=void 0,e.$zH=S,e.$AH=d,e.$BH=v,e.$CH=f,e.$DH=s,e.$EH=r,e.$FH=o,e.$GH=t,e.$HH=i,e.$IH=w,e.$JH=l,e.$KH=$;const N=/{([^}]+)}/g;function S(y,h,E){return y.replace(N,function(k,I){return h&&I.length>0&&I[0]!=="_"?k:E&&E.hasOwnProperty(I)?E[I]:k})}function d(y){const h={};for(const E of Object.keys(y))E.startsWith("!")||(h[E]=y[E]);return h}function v(y){return y.configuration.request==="attach"&&!f(y)&&(!y.parentSession||v(y.parentSession))}function f(y){let h=y.configuration.type;if(h)return h==="vslsShare"&&(h=y.configuration.adapterProxy.configuration.type),(0,C.$Bf)(h,"extensionhost")||(0,C.$Bf)(h,"pwa-extensionhost")?y:y.parentSession?f(y.parentSession):void 0}function s(y){return y.type&&(y.label||y.program||y.runtime)}function r(y,h,E){let k,I=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=P.exec(y);){const W=V.index+1,q=W+V[0].length;if(W<=h&&q>=E){k=V[0],I=W;break}}if(k){const W=/\w+/g;let q=null;for(;(q=W.exec(k))&&!(q.index+1+I+q[0].length>=E););q&&(k=k.substring(0,W.lastIndex))}return k?{start:I,end:I+k.length-1}:{start:0,end:0}}async function o(y,h,E,k){if(y.evaluatableExpressionProvider.has(h)){const I=y.evaluatableExpressionProvider.ordered(h),P=(0,D.$Hb)(await Promise.all(I.map(async V=>{try{return await V.provideEvaluatableExpression(h,E,k??m.CancellationToken.None)}catch{return}})));if(P.length>0){let V=P[0].expression;const W=P[0].range;return V||(V=h.getLineContent(E.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const I=h.getLineContent(E.lineNumber),{start:P,end:V}=r(I,E.column,E.column),W=I.substring(P-1,V);return{matchingExpression:W,range:new p.$At(E.lineNumber,P,E.lineNumber,P+W.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(y){return!!(y&&y.match(n))}function c(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(t(y.path))return O.URI.parse(y.path);if((0,R.$ic)(y.path))return O.URI.file(y.path)}return y.path}function u(y){if(typeof y.path=="object"){const h=O.URI.revive(y.path);if(h)return h.scheme===M.Schemas.file?h.fsPath:h.toString()}return y.path}function i(y,h){const E=h?c:u,k=(0,F.$7n)(y);return a(k,(I,P)=>{I&&P&&(P.path=E(P))}),k}function w(y,h){const E=h?c:u,k=(0,F.$7n)(y);return a(k,(I,P)=>{!I&&P&&(P.path=E(P))}),k}function a(y,h){switch(y.type){case"event":{const E=y;switch(E.event){case"output":h(!1,E.body.source);break;case"loadedSource":h(!1,E.body.source);break;case"breakpoint":h(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=y;switch(E.command){case"setBreakpoints":h(!0,E.arguments.source);break;case"breakpointLocations":h(!0,E.arguments.source);break;case"source":h(!0,E.arguments.source);break;case"gotoTargets":h(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(k=>h(!1,k));break;default:break}break}case"response":{const E=y;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(k=>h(!1,k.source));break;case"loadedSources":E.body.sources.forEach(k=>h(!1,k));break;case"scopes":E.body.scopes.forEach(k=>h(!1,k.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(k=>h(!1,k.source));break;case"setBreakpoints":E.body.breakpoints.forEach(k=>h(!1,k.source));break;case"disassemble":E.body?.instructions.forEach(I=>h(!1,I.location));break;default:break}break}}}function l(y){return y.filter(h=>!h.presentation?.hidden).sort((h,E)=>h.presentation?E.presentation?h.presentation.group?E.presentation.group?h.presentation.group!==E.presentation.group?h.presentation.group.localeCompare(E.presentation.group):g(h.presentation.order,E.presentation.order):-1:E.presentation.group?1:g(h.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function g(y,h){return typeof y!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:y-h}async function $(y,h){const E=y.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(E!=="none"&&(await h.saveAll(),E==="allEditorsInActiveGroup")){const k=h.activeEditorPane;k&&k.input.resource?.scheme===M.Schemas.untitled&&await h.save({editor:k.input,groupId:k.group.id})}await y.reloadConfiguration()}const b=(y,h)=>!y||!h?y===h:y.name===h.name&&y.path===h.path&&y.sourceReference===h.sourceReference;e.$LH=b}),define(ke[229],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.CellExecutionUpdateType=void 0;var O;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$5J=(0,C.$Ai)("INotebookExecutionService")}),define(ke[230],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjb=e.$ajb=e.ProxyKernelState=e.$_ib=void 0,e.$_ib=100;var O;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$ajb=(0,C.$Ai)("INotebookKernelService"),e.$bjb=(0,C.$Ai)("INotebookKernelHistoryService")}),define(ke[231],Se([1,0,6,30,156,96]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XXb=void 0;class M extends C.$Uc{constructor(m,D,N){super(),this._source=m,this.b=D,this.c=N,this.a=void 0}f(m){const D=m.getLineCount();return new O.$At(1,1,D,this.g(m,D))}g(m,D){if(D<1||D>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(D)+1}get inputTextBuffer(){if(!this.b){const m=new R.$8C;m.acceptChunk(this._source);const D=m.finish(!0),{textBuffer:N,disposable:S}=D.create(1);this.b=N,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const D=new R.$8C;D.acceptChunk(m);const N=D.finish(!0),{textBuffer:S,disposable:d}=N.create(1);return this.B(d),S})),this.a}findInInputs(m){const N=new F.$VC(m,!1,!1,null).parseSearchRequest();if(!N)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,N,!0,5e3)}findInOutputs(m){const N=new F.$VC(m,!1,!1,null).parseSearchRequest();return N?this.outputTextBuffers.map(S=>{const d=S.findMatchesLineByLine(this.f(S),N,!0,5e3);if(d.length!==0)return{textBuffer:S,matches:d}}).filter(S=>!!S):[]}}e.$XXb=M}),define(ke[52],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_K=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(F){F.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var O;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class R{static fromExtHostTestItem(M,p,m=M.parent){if(M._isRoot)return new R([p]);const D=[M.id];for(let N=m;N&&N.id!==p;N=N.parent)D.push(N.id);return D.push(p),new R(D.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new R(M.split("\0"))}static join(M,p){return new R([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:R.isChild(M,p)?2:R.isChild(p,M)?3:1}static getLengthOfCommonPrefix(M,p){if(M===0)return 0;let m=0;for(;m<M-1;){for(let D=1;D<M;D++){const N=p(D-1),S=p(D);if(N.path[m]!==S.path[m])return m}m++}return m}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new R(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new R(this.path,M)}compare(M){if(typeof M=="string")return R.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$_K=R}),define(ke[62],Se([1,0,2,94,30,52]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$hL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$gL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$fL=e.$eL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$dL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$cL=e.$bL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$aL=e.TestResultState=void 0;var M;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$aL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var m;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$bL=[2,4,8,16,32,64];const D=A=>"runId"in A;e.$cL=D;var N;(function(A){A.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({range:R.$At.lift(K.range),uri:U.asCanonicalUri(C.URI.revive(K.uri))})})(N||(e.IRichLocation=N={}));var S;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(S||(e.TestMessageType=S={}));var d;(function(A){A.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&N.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&N.deserialize(U,K.location)})})(d||(e.ITestErrorMessage=d={}));const v=(A,U)=>`${U?"s":"e"}${A}`;e.$dL=v;var f;(function(A){A.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&N.serialize(U.location)}),A.deserialize=(U,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&N.deserialize(U,K.location)})})(f||(e.ITestOutputMessage=f={}));var s;(function(A){A.serialize=U=>U.type===0?d.serialize(U):f.serialize(U),A.deserialize=(U,K)=>K.type===0?d.deserialize(U,K):f.deserialize(U,K)})(s||(e.ITestMessage=s={}));var r;(function(A){A.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),A.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(s.serialize)}),A.deserialize=(U,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>s.deserialize(U,ie))})})(r||(e.ITestTaskState=r={}));const o="\0",n=(A,U)=>A+o+U;e.$eL=n;const t=A=>{const U=A.indexOf(o);return{ctrlId:A.slice(0,U),tagId:A.slice(U+1)}};e.$fL=t;var c;(function(A){A.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),A.deserialize=(U,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?U.asCanonicalUri(C.URI.revive(K.uri)):void 0,range:K.range?R.$At.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var u;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var i;(function(A){A.serialize=U=>({expand:U.expand,item:c.serialize(U.item)}),A.deserialize=(U,K)=>({controllerId:F.$_K.root(K.item.extId),expand:K.expand,item:c.deserialize(U,K.item)})})(i||(e.InternalTestItem=i={}));var w;(function(A){A.serialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.uri!==void 0&&(K.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(K.range=U.item.range?.toJSON()),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}},A.deserialize=U=>{let K;return U.item&&(K={},U.item.label!==void 0&&(K.label=U.item.label),U.item.tags!==void 0&&(K.tags=U.item.tags),U.item.busy!==void 0&&(K.busy=U.item.busy),U.item.range!==void 0&&(K.range=U.item.range?R.$At.lift(U.item.range):null),U.item.description!==void 0&&(K.description=U.item.description),U.item.error!==void 0&&(K.error=U.item.error),U.item.sortText!==void 0&&(K.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:K}}})(w||(e.ITestItemUpdate=w={}));const a=(A,U)=>{U.expand!==void 0&&(A.expand=U.expand),U.item!==void 0&&(A.item=A.item?Object.assign(A.item,U.item):U.item)};e.$gL=a;var l;(function(A){A.serializeWithoutMessages=U=>({...i.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(r.serializeWithoutMessages)}),A.serialize=U=>({...i.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(r.serialize)}),A.deserialize=(U,K)=>({...i.deserialize(U,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>r.deserialize(U,ie)),retired:!0})})(l||(e.TestResultItem=l={}));var g;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(U,K)=>{U.covered+=K.covered,U.total+=K.total}})(g||(e.ICoverageCount=g={}));var $;(function(A){A.serialize=U=>({id:U.id,statement:U.statement,branch:U.branch,declaration:U.declaration,testId:U.testId?.toString(),uri:U.uri.toJSON()}),A.deserialize=(U,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,testId:K.testId?F.$_K.fromString(K.testId):void 0,uri:U.asCanonicalUri(C.URI.revive(K.uri))}),A.empty=(U,K)=>({id:U,uri:K,testId:void 0,statement:g.empty()})})($||(e.IFileCoverage=$={}));function b(A){return{...A,location:A.location?.toJSON()}}function y(A){return A.location=A.location?O.$zt.isIPosition(A.location)?O.$zt.lift(A.location):R.$At.lift(A.location):void 0,A}e.$hL=3;var h;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(h||(e.DetailType=h={}));var E;(function(A){A.serialize=U=>U.type===0?I.serialize(U):P.serialize(U),A.deserialize=U=>U.type===0?I.deserialize(U):P.deserialize(U)})(E||(e.CoverageDetails=E={}));var k;(function(A){A.serialize=b,A.deserialize=y})(k||(e.IBranchCoverage=k={}));var I;(function(A){A.serialize=b,A.deserialize=y})(I||(e.IDeclarationCoverage=I={}));var P;(function(A){A.serialize=U=>({...b(U),branches:U.branches?.map(k.serialize)}),A.deserialize=U=>({...y(U),branches:U.branches?.map(k.deserialize)})})(P||(e.IStatementCoverage=P={}));var V;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(A){A.deserialize=(U,K)=>K.op===0?{op:K.op,item:i.deserialize(U,K.item)}:K.op===1?{op:K.op,item:w.deserialize(K.item)}:K.op===2?{op:K.op,uri:U.asCanonicalUri(C.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=U=>U.op===0?{op:U.op,item:i.serialize(U.item)}:U.op===1?{op:U.op,item:w.serialize(U.item)}:U})(W||(e.TestsDiffOp=W={}));class q{constructor(U){this.k=U,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(U){const K=this.v();for(const ie of U)switch(ie.op){case 0:this.l(i.deserialize(this.k,ie.item),K);break;case 1:this.o(w.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(U,K){const ie=F.$_K.parentId(U.item.extId)?.toString();let ce;if(!ie)ce=this.w(U),this.g.add(ce),this.f.set(U.item.extId,ce);else if(this.f.has(ie)){const ve=this.f.get(ie);ve.children.add(U.item.extId),ce=this.w(U,ve),this.f.set(U.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return K.add?.(ce),U.expand===2&&this.h++,ce}o(U,K){const ie=this.f.get(U.extId);if(ie)return U.expand!==void 0&&(ie.expand===2&&this.h--,U.expand===2&&this.h++),(0,e.$gL)(ie,U),K.update?.(ie),ie}p(U,K){const ie=this.f.get(U);if(!ie)return;const ce=F.$_K.parentId(ie.item.extId)?.toString();ce?this.f.get(ce).children.delete(ie.item.extId):this.g.delete(ie);const ve=[[U]];for(;ve.length;)for(const Ee of ve.pop()){const ge=this.f.get(Ee);ge&&(ve.push(ge.children),this.f.delete(Ee),K.remove?.(ge,ge!==ie),ge.expand===2&&this.h--)}}q(U){}updatePendingRoots(U){this.j+=U}v(){return{}}}e.$iL=q}),define(ke[77],Se([1,0,11,5,6,57,62,52]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=e.$JO=e.$IO=e.$HO=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const D=(n,t)=>n===t,S=Object.entries({range:(n,t)=>n===t?!0:!n||!t?!1:n.equalsRange(t),busy:D,label:D,description:D,error:D,sortText:D,tags:(n,t)=>!(n.length!==t.length||n.some(c=>!t.includes(c)))}),d=(n,t)=>{let c;for(const[u,i]of S)i(n[u],t[u])||(c?c[u]=t[u]:c={[u]:t[u]});return c};class v extends R.$Uc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new C.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new O.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===t.uri){c.docv=t.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===t.item.extId){(0,M.$gL)(c.item,t.item);return}if(c.op===0&&c.item.item.extId===t.item.extId){(0,M.$gL)(c.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,c){const u=this.tree.get(t);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const i=this.M(u);return i.isOpen()?this.L(u,c-1):i.wait().then(()=>this.L(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,c-1)):this.L(u,c-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,c){switch(c.op){case 3:this.O(p.$_K.joinToString(t.fullId,c.id));break;case 0:this.z(c.item,t);break;case 5:for(const u of c.ops)this.w(t,u);break;case 1:this.C(c.new,c.old,t.fullId.toString());break;case 2:this.J(t);break;case 4:this.pushDiff({op:1,item:{extId:t.fullId.toString(),item:c.update}});break;case 6:this.y(t.actual.uri);break;default:(0,F.$ed)(c)}}y(t){t&&this.pushDiff({op:2,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,c){const u=p.$_K.fromExtHostTestItem(t,this.root.id,c?.actual),i=this.s.getApiFor(t);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(t.id);let w=this.tree.get(u.toString());if(!w){w={fullId:u,actual:t,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},t.tags.forEach(this.D,this),this.tree.set(w.fullId.toString(),w),this.G(t,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:w.expand,item:this.s.toITestItem(t)}}),this.I(t,w,c);return}if(w.actual===t){this.H(t,w,c);return}if(w.actual.uri?.toString()!==t.uri?.toString())return this.O(u.toString()),this.z(t,c);const a=this.s.getChildren(w.actual),l=w.actual,g=d(this.s.toITestItem(l),this.s.toITestItem(t));this.s.getApiFor(l).listener=void 0,w.actual=t,w.resolveBarrier=void 0,w.expand=0,g&&(g.hasOwnProperty("tags")&&(this.C(t.tags,l.tags,u.toString()),delete g.tags),this.w(w,{op:4,update:g})),this.I(t,w,c);for(const[b,y]of a)this.s.getChildren(t).get(y.id)||this.O(p.$_K.joinToString(u,y.id));const $=w.expandLevels;$!==void 0&&queueMicrotask(()=>{w.expand===1&&(w.expandLevels=void 0,this.expand(u.toString(),$))}),this.y(w.actual.uri)}C(t,c,u){const i=new Set(c.map(w=>w.id));for(const w of t)i.delete(w.id)||this.D(w);this.pushDiff({op:1,item:{extId:u,item:{tags:t.map(w=>(0,M.$eL)(this.s.controllerId,w.id))}}}),i.forEach(this.F,this)}D(t){const c=this.j.get(t.id);c?c.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$eL)(this.s.controllerId,t.id)}}))}F(t){const c=this.j.get(t);c&&!--c.refCount&&(this.j.delete(t),this.pushDiff({op:7,id:(0,M.$eL)(this.s.controllerId,t)}))}G(t,c){this.s.getApiFor(t).parent=c&&c.actual!==this.root?c.actual:void 0}H(t,c,u){this.G(t,u);const i=this.s.getApiFor(t);i.parent=u?.actual,i.listener=w=>this.w(c,w),this.J(c)}I(t,c,u){this.H(t,c,u);for(const[i,w]of this.s.getChildren(t))this.z(w,c)}J(t){let c;this.h?t.resolveBarrier?c=t.resolveBarrier.isOpen()?3:2:c=t.actual.canResolveChildren?1:0:c=0,c!==t.expand&&(t.expand=c,this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:c}}),c===1&&t.expandLevels!==void 0&&this.M(t))}L(t,c){if(c<0)return;const u=[];for(const[i,w]of this.s.getChildren(t.actual)){const a=this.expand(p.$_K.joinToString(t.fullId,w.id),c);(0,C.$mh)(a)&&u.push(a)}if(u.length)return Promise.all(u).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const w=new C.$zh;return w.open(),w}t.expand=2,this.N(t);const c=t.resolveBarrier=new C.$zh,u=w=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,w)};let i;try{i=this.h(t.actual===this.root?void 0:t.actual)}catch(w){u(w)}return(0,C.$mh)(i)?i.catch(u).then(()=>{c.open(),this.J(t)}):(c.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const c=this.tree.get(t);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:t});const u=[c];for(;u.length;){const i=u.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const w of i.actual.tags)this.F(w.id);this.tree.delete(i.fullId.toString());for(const[w,a]of this.s.getChildren(i.actual))u.push(this.tree.get(p.$_K.joinToString(i.fullId,a.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$HO=v;class f extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$IO=f;class s extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$JO=s;class r extends Error{constructor(t,c,u){super(`TestItem with ID "${t}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.$KO=r;const o=(n,t,c)=>{let u=new Map;return{get size(){return u.size},forEach(i,w){for(const a of u.values())i.call(w,a,this)},[Symbol.iterator](){return u.entries()},replace(i){const w=new Map,a=new Set(u.keys()),l={op:5,ops:[]};for(const g of i){if(!(g instanceof c))throw new s(g.id);const $=t(g).controllerId;if($!==n.controllerId)throw new r(g.id,$,n.controllerId);if(w.has(g.id))throw new f(g.id);w.set(g.id,g),a.delete(g.id),l.ops.push({op:0,item:g})}for(const g of a.keys())l.ops.push({op:3,id:g});n.listener?.(l),u=w},add(i){if(!(i instanceof c))throw new s(i.id);u.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){u.delete(i)&&n.listener?.({op:3,id:i})},get(i){return u.get(i)},toJSON(){return Array.from(u.values())}}};e.$LO=o}),define(ke[107],Se([1,0,77]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NO=e.$MO=void 0;const O=new WeakMap,R=(M,p)=>{const m={controllerId:p};return O.set(M,m),m};e.$MO=R;const F=M=>{const p=O.get(M);if(!p)throw new C.$JO(M?.id||"<unknown>");return p};e.$NO=F}),define(ke[78],Se([1,0,16,2]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rBb=e.$qBb=e.$pBb=void 0,e.$sBb=R,e.$tBb=M,e.$pBb="vscode-cdn.net",e.$qBb=`vscode-resource.${e.$pBb}`,e.$rBb=`'self' https://*.${e.$pBb}`;function R(p,m){return p.scheme===C.Schemas.http||p.scheme===C.Schemas.https?p:(m&&m.authority&&m.isRemote&&p.scheme===C.Schemas.file&&(p=O.URI.from({scheme:C.Schemas.vscodeRemote,authority:m.authority,path:p.path})),O.URI.from({scheme:C.Schemas.https,authority:`${p.scheme}+${F(p.authority)}.${e.$qBb}`,path:p.path,fragment:p.fragment,query:p.query}))}function F(p){return p.replace(/./g,m=>{const D=m.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?m:"-"+D.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(m,D)=>String.fromCharCode(parseInt(D,16)))}}),define(ke[232],Se([1,0,5,6,78]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=void 0;class F{constructor(p,m,D){this.d=p,this.e=m,this.f=D,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const N=m.getVisibleTextEditors();for(const S of this.c.values())N.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,m,D,N,S){let d;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===p){d=t;break}if(!d)throw new Error("not a visible editor");const v=this,f=this.a++,s=new C.$he,r=new C.$he,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,R.$sBb)(t,v.f)}get cspSource(){return R.$rBb}set options(t){this.b=t,v.d.$setOptions(f,t)}get options(){return this.b}set html(t){this.a=t,v.d.$setHtml(f,t)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(t){return v.d.$postMessage(f,t)}},n=new class{constructor(){this.editor=p,this.line=m,this.height=D,this.webview=o,this.onDidDispose=r.event}dispose(){v.c.has(f)&&(v.c.delete(f),v.d.$disposeEditorInset(f),r.fire(),r.dispose(),s.dispose())}};return this.d.$createEditorInset(f,d.id,d.value.document.uri,m+1,D,N||{},S.identifier,S.extensionLocation),this.c.set(f,{editor:p,inset:n,onDidReceiveMessage:s}),n}$onDidDispose(p){const m=this.c.get(p);m&&m.inset.dispose()}$onDidReceiveMessage(p,m){this.c.get(p)?.onDidReceiveMessage.fire(m)}}e.$wmc=F}),define(ke[108],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rL=e.$qL=e.$pL=void 0,e.$pL="__",e.$qL=(0,C.$Ai)("IAuthenticationService"),e.$rL=(0,C.$Ai)("IAuthenticationExtensionsService")}),define(ke[233],Se([1,0,3]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GP=e.VariableKind=e.$FP=void 0,e.$FP=(0,C.$Ai)("configurationResolverService");var O;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator",F.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class R extends Error{constructor(M,p){super(p),this.variable=M}}e.$GP=R}),define(ke[234],Se([1,0,19,75,15,26,23,97,192,233,13]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,f,s,r){this.h=new Map,this.a=v,this.b=f,this.g=s,r&&(this.c=r.then(o=>this.i(o)))}i(v){if(M.$i){const f=Object.create(null);return Object.keys(v).forEach(s=>{f[s.toLowerCase()]=v[s]}),f}return v}resolveWithEnvironment(v,f,s){return this.l({env:this.i(v),userHome:void 0},f?f.uri:void 0,s)}async resolveAsync(v,f){const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,f)}async j(v,f,s,r){const o=F.$7n(f);M.$i&&o.windows?Object.keys(o.windows).forEach(t=>o[t]=o.windows[t]):M.$j&&o.osx?Object.keys(o.osx).forEach(t=>o[t]=o.osx[t]):M.$k&&o.linux&&Object.keys(o.linux).forEach(t=>o[t]=o.linux[t]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,o,s,r)}async resolveAnyAsync(v,f,s){return this.j(v,f,s)}async resolveAnyMap(v,f,s){const r=new Map;return{newConfig:await this.j(v,f,s,r),resolvedVariables:r}}resolveWithInteractionReplace(v,f,s,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,f,s,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,f){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,f)}async l(v,f,s,r,o){if(R.$ag(s))return this.m(v,f,s,r,o);if(Array.isArray(s))return Promise.all(s.map(n=>this.l(v,f,n,r,o)));if(R.$cg(s)){const n=Object.create(null),t=await Promise.all(Object.keys(s).map(async c=>[await this.m(v,f,c,r,o),await this.l(v,f,s[c],r,o)]));for(const[c,u]of t)n[c]=u;return n}return s}m(v,f,s,r,o){return(0,N.$tf)(s,S.VARIABLE_REGEXP,async(n,t)=>{if(t.includes(S.VARIABLE_LHS))return n;let c=await this.o(v,n,t,f,r);return o?.set(t,c),c!==n&&R.$ag(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(v,f,c,r,o)),c})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,f,s,r,o){let n;const t=s.split(":");t.length>1&&(s=t[0],n=t[1]);const c=w=>{const a=this.a.getFilePath();if(a)return(0,p.$Kw)(a);throw new D.$GP(w,(0,m.localize)(0,null,f))},u=w=>{const a=c(w);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,p.$Kw)(l)}throw new D.$GP(w,(0,m.localize)(1,null,f,C.$nc(a)))},i=w=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new D.$GP(w,(0,m.localize)(2,null,f,n))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new D.$GP(w,(0,m.localize)(3,null,f)):new D.$GP(w,(0,m.localize)(4,null,f))};switch(s){case"env":if(n){if(v.env){const w=v.env[M.$i?n.toLowerCase():n];if(R.$ag(w))return w}return""}throw new D.$GP(D.VariableKind.Env,(0,m.localize)(5,null,f));case"config":if(n){const w=this.a.getConfigurationValue(r,n);if(R.$jg(w))throw new D.$GP(D.VariableKind.Config,(0,m.localize)(6,null,f,n));if(R.$cg(w))throw new D.$GP(D.VariableKind.Config,(0,m.localize)(7,null,f,n));return w}throw new D.$GP(D.VariableKind.Config,(0,m.localize)(8,null,f));case"command":return this.p(D.VariableKind.Command,f,n,o,"command");case"input":return this.p(D.VariableKind.Input,f,n,o,"input");case"extensionInstallFolder":if(n){const w=await this.a.getExtension(n);if(!w)throw new D.$GP(D.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,f,n));return this.n(w.extensionLocation)}throw new D.$GP(D.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,f));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,p.$Kw)(this.n(i(D.VariableKind.WorkspaceFolder)));case"cwd":return r||n?(0,p.$Kw)(this.n(i(D.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$Kw)(C.$nc(this.n(i(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new D.$GP(D.VariableKind.UserHome,(0,m.localize)(11,null,f))}case"lineNumber":{const w=this.a.getLineNumber();if(w)return w;throw new D.$GP(D.VariableKind.LineNumber,(0,m.localize)(12,null,f))}case"selectedText":{const w=this.a.getSelectedText();if(w)return w;throw new D.$GP(D.VariableKind.SelectedText,(0,m.localize)(13,null,f))}case"file":return c(D.VariableKind.File);case"fileWorkspaceFolder":return u(D.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$nc(u(D.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return r||n?C.$lc(this.n(i(D.VariableKind.RelativeFile)),c(D.VariableKind.RelativeFile)):c(D.VariableKind.RelativeFile);case"relativeFileDirname":{const w=C.$mc(c(D.VariableKind.RelativeFileDirname));if(r||n){const a=C.$lc(this.n(i(D.VariableKind.RelativeFileDirname)),w);return a.length===0?".":a}return w}case"fileDirname":return C.$mc(c(D.VariableKind.FileDirname));case"fileExtname":return C.$oc(c(D.VariableKind.FileExtname));case"fileBasename":return C.$nc(c(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const w=C.$nc(c(D.VariableKind.FileBasenameNoExtension));return w.slice(0,w.length-C.$oc(w).length)}case"fileDirnameBasename":return C.$nc(C.$mc(c(D.VariableKind.FileDirnameBasename)));case"execPath":{const w=this.a.getExecPath();return w||f}case"execInstallFolder":{const w=this.a.getAppRoot();return w||f}case"pathSeparator":case"/":return C.sep;default:try{const w=n?`${s}:${n}`:s;return this.p(D.VariableKind.Unknown,f,w,o,void 0)}catch{return f}}}}p(v,f,s,r,o){if(s&&r){const n=o===void 0?r[s]:r[o+":"+s];if(typeof n=="string")return n;throw new D.$GP(v,(0,m.localize)(14,null,f))}return f}}e.$VP=S}),define(ke[109],Se([1,0,3,106]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$5D=void 0,e.$6D=D,e.$7D=d,e.$8D=v,e.$5D=(0,C.$Ai)("editorGroupsService");var R;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var F;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var M;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var m;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function D(f){const s=f;return(0,O.$PF)(s?.editor)&&(0,O.$PF)(s?.replacement)}var N;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N||(e.GroupsOrder=N={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function d(f){const s=f;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function v(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[235],Se([1,0,3,109]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_D=e.$$D=e.$0D=e.$9D=void 0,e.$aE=R,e.$9D=(0,C.$Ai)("editorService"),e.$0D=-1,e.$$D=-2,e.$_D=-3;function R(F){const M=F;return typeof F=="number"||(0,O.$7D)(M)}}),define(ke[236],Se([1,0,3,99]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=void 0,e.$KL=(0,C.$Bi)(O.$Hi)}),define(ke[110],Se([1,0,21,5,19,6,11]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=e.$Rac=e.$Qac=e.$Pac=void 0;class p{constructor(n,t){this.versionId=n,this.removedDueToLooping=t}}e.$Pac=p;class m{static isHostExtension(n,t,c){if(t.getExtensionDescription(n))return!1;const u=c.getExtensionDescription(n);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(n,t){this.j=n,this.c=new O.$he,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(s),this.f=new C.$Xm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const t=this.j.readActivationEvents(n);for(const c of t)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,t){this.e=r(this.e,t),this.e=this.e.concat(n);const c=m.l(this.e);return this.e=r(this.e,c.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(n){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,l){this.addNode(a),this.addNode(l),this.c.has(a)?this.c.get(a).push(l):this.c.set(a,[l])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,l){const g=t.getArcs(a);for(let $=0;$<g.length;$++)if(!l.has(g[$]))return!1;return!0}getNodes(){return this.e}},c=new C.$Xm;for(const a of n)if(c.set(a.identifier,a),a.extensionDependencies)for(const l of a.extensionDependencies)t.addArc(C.$Vm.toKey(a.identifier),C.$Vm.toKey(l));const u=new Set;t.getNodes().filter(a=>t.getArcs(a).length===0).forEach(a=>u.add(a));const i=t.getNodes().filter(a=>!u.has(a));let w;do{w=!1;for(let a=0;a<i.length;a++){const l=i[a];t.hasOnlyGoodArcs(l,u)&&(i.splice(a,1),a--,u.add(l),w=!0)}}while(w);return i.map(a=>c.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const t=this.h.get(n);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const t=this.f.get(n);return t||void 0}getExtensionDescriptionByUUID(n){for(const t of this.g)if(t.uuid===n)return t}getExtensionDescriptionByIdOrUUID(n,t){return this.getExtensionDescription(n)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$Qac=m;class D{constructor(n,t){this.versionId=n,this.extensions=t}}e.$Rac=D;class N{constructor(n){this.d=new v,this.c=new m(n,[])}async acquireLock(n){const t=await this.d.acquire(n);return new S(this,t)}deltaExtensions(n,t,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,t){return this.c.getExtensionDescriptionByIdOrUUID(n,t)}}e.$Sac=N;class S extends F.$Uc{constructor(n,t){super(),this.f=n,this.c=!1,this.B(t)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$Tac=S;class d{constructor(n){this.name=n;const t=(0,M.$th)();this.promise=t.promise,this.c=t.resolve}resolve(n){this.c(n)}}class v{constructor(){this.c=[],this.d=!1}async acquire(n){const t=new d(n);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let t=!0;const c=setTimeout(()=>{t&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{t&&(clearTimeout(c),t=!1,this.d=!1,this.e())};n.resolve((0,F.$Sc)(u))}}var f;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(f||(f={}));function s(o,n){const t=o.isBuiltin?0:o.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(t!==c)return t-c;const u=R.$gc.basename(o.extensionLocation.path),i=R.$gc.basename(n.extensionLocation.path);return u<i?-1:u>i?1:0}function r(o,n){const t=new C.$Wm(n);return o.filter(c=>!t.has(c.identifier))}}),define(ke[79],Se([1,0,22]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$4m=M,e.$5m=p;var O;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(O||(e.UIKind=O={}));var R;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var F;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function M(D){const N=C.$Je.alloc(1);switch(D){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}function p(D,N){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}var m;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(ke[63],Se([1,0,3,5,12,27,79,58,59,26,2,6,179]),function(he,e,C,O,R,F,M,p,m,D,N,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_O=e.$0O=e.$9O=void 0,e.$$O=s;let v=class extends S.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new O.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=N.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$qp,name:(0,d.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(t=>{(0,R.$9j)(t)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,t){const c=this.getTelemetryDetails(),u=new f(n,t,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...i,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(o,n,t){this.f=o,this.g=n,this.c=t??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:n["common.uikind"]="web";break;case M.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Mm)((0,m.$wp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((t,c)=>{const u=t.filter(i=>!i.isDisposed);u.length===0?this.r.delete(c):this.r.set(c,u)}),this.r.forEach(t=>{for(const c of t)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const c=this.r.get(o.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(o.value),!1;let u=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),u=!0);return u}};e.$9O=v,e.$9O=v=Je([We(0,F.$8O),We(1,R.$8j)],v);class f{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,t,c,u,i,w){this.g=t,this.h=c,this.i=u,this.j=i,this.a=new O.$he,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,m.$zp)(n,[]),this.c&&(n=(0,D.$0n)(n,this.c)),this.b||(n=(0,D.$0n)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const t={name:o.name,message:o.message,stack:o.stack,cause:o.cause},c=(0,m.$zp)(t,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(u,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$0O=f;function s(r){const o=Date.now()-new Date(r).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$_O=(0,C.$Ai)("IExtHostTelemetry")}),define(ke[25],Se([1,0,5,2,207,105,21,3]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TG=e.ActivationKind=e.$QG=e.$PG=e.$MG=e.ExtensionHostStartup=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$NG=d,e.$OG=v,e.$RG=o,e.$SG=n,e.$IG=Object.freeze({identifier:new M.$Vm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$JG="extensions.webWorker",e.$KG=(0,p.$Ai)("extensionService");class m{constructor(u){this.dependency=u}}e.$LG=m;var D;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(D||(e.ExtensionHostStartup=D={}));class N{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,i,w){this.c=u,this.d=i.slice(0),this.e=w.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$tG.createActivationEventsMap(this.d)}}set(u,i,w){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const a=[],l=[],g=[],$=[],b=S(this.d),y=S(i),h=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=y.get(V.identifier);if(!W){a.push(V.identifier),b.delete(V.identifier);continue}if(!h(V,W)){a.push(V.identifier),b.delete(V.identifier);continue}}for(const V of i){const W=b.get(V.identifier);if(!W){l.push(V);continue}if(!h(W,V)){a.push(W.identifier),b.delete(W.identifier);continue}}const E=new M.$Wm(this.e),k=new M.$Wm(w);for(const V of this.e)k.has(V)||g.push(V);for(const V of w)E.has(V)||$.push(V);const I=F.$tG.createActivationEventsMap(l),P={versionId:u,toRemove:a,toAdd:l,addActivationEvents:I,myToRemove:g,myToAdd:$};return this.delta(P),P}delta(u){if(this.c>=u.versionId)return null;const{toRemove:i,toAdd:w,myToRemove:a,myToAdd:l}=u,g=new M.$Wm(i),$=new M.$Wm(a);for(let b=0;b<this.d.length;b++)g.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)$.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of w)this.d.push(b);for(const b of l)this.e.push(b);return this.f=null,u}containsExtension(u){for(const i of this.e)if(M.$Vm.equals(i,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const w=F.$tG.readActivationEvents(i);for(const a of w)u.add(a)}return u}}e.$MG=N;function S(c){const u=new M.$Xm;for(const i of c)u.set(i.identifier,i);return u}function d(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}function v(c,u){if(!d(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class f{constructor(u,i,w,a){this.codeLoadingTime=u,this.activateCallTime=i,this.activateResolvedTime=w,this.activationReason=a}}e.$PG=f;class s{constructor(u,i){this.description=u,this.value=i}}e.$QG=s;var r;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function o(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,R.$Fp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,u){return{identifier:new M.$Vm((0,R.$Dp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,i){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$TG=t}),define(ke[237],Se([1,0,14,110,21,25,12,11]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=e.$Vmc=e.$Umc=e.$Tmc=e.$Smc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(o,n,t,c){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=t,this.activateResolvedTime=c}}e.$Smc=m;class D{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Tmc=D;class N{constructor(o,n,t,c,u,i){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=t,this.module=c,this.exports=u,this.subscriptions=i}}e.$Umc=N;class S extends N{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Vmc=S;class d extends N{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wmc=d;class v extends N{constructor(o){super(!0,o,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(o,n,t,c){this.g=c,this.a=o,this.b=n,this.c=t,this.d=new R.$Xm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,t]of this.d)o.push(t.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const t=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(t.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const t=this.a.getExtensionDescription(o);if(!t)throw new Error(`Extension '${o.value}' is not known`);return this.h([{id:t.identifier,reason:n}])}async h(o){const n=o.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(n.map(t=>t.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const u=new Error(`Cannot activate unknown extension '${o.id.value}'`),i=this.k(o,null,[],new v(u));return this.c.onExtensionActivationError(o.id,u,new F.$LG(o.id.value)),i}const t=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const u of c){if(this.m(u))continue;const i=this.d.get(u);if(i){t.push(i);continue}if(this.l(u)){t.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:o.reason}));continue}const w=this.a.getExtensionDescription(u);if(w){if(!w.main&&!w.browser)continue;t.push(this.j({id:w.identifier,reason:o.reason}));continue}const a=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${u}'`),g=this.k(o,n.displayName,[],new v(l));return this.c.onExtensionActivationError(n.identifier,l,new F.$LG(u)),g}return this.k(o,n.displayName,t,null)}k(o,n,t,c){const u=new s(o.id,n,o.reason,t,c,this.c,this.g);return this.d.set(o.id,u),u}l(o){return O.$Qac.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$Xmc=f,e.$Xmc=f=Je([We(3,M.$7j)],f);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,t,c,u,i,w){this.c=o,this.d=n,this.f=t,this.g=c,this.h=u,this.j=i,this.k=w,this.a=new p.$zh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);t.detail=n.value.activationFailedError,this.h=new v(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new v(n),this.b&&C.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};s=Je([We(6,M.$7j)],s)}),define(ke[238],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[239],Se([1,0,194,14,32,100,74,29,21,238,102,105]),function(he,e,C,O,R,F,M,p,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=void 0;const d=p.$ho.as(M.$io.JSONContribution);class v{constructor(u,i,w){this.a=u,this.b=i,this.c=w}d(u,i){this.a({type:u,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(R.default.Error,u)}warn(u){this.d(R.default.Warning,u)}info(u){this.d(R.default.Info,u)}}e.$CG=v;class f{static a(u){const i=new m.$Wm;for(let w=0,a=u.length;w<a;w++)i.add(u[w].description.identifier);return i}static compute(u,i){if(!u||!u.length)return new f(i,[]);if(!i||!i.length)return new f([],u);const w=this.a(u),a=this.a(i),l=i.filter($=>!w.has($.description.identifier)),g=u.filter($=>!a.has($.description.identifier));return new f(l,g)}constructor(u,i){this.added=u,this.removed=i}}e.$DG=f;class s{constructor(u,i){this.name=u,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=f.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,O.$1)(u)}}}e.$EG=s;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$FG={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Um},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Yo}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Yo}},extensionKind:{description:C.localize(52,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const i=new s(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,i),u.activationEventsGenerator&&S.$tG.register(u.extensionPoint,u.activationEventsGenerator),e.$FG.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,d.registerSchema(o,e.$FG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$GG=n;const t={ExtensionsRegistry:"ExtensionsRegistry"};p.$ho.add(t.ExtensionsRegistry,new n),e.$HG=p.$ho.as(t.ExtensionsRegistry),d.registerSchema(o,e.$FG),d.registerSchema(N.$ok,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(ke[240],Se([1,0,190,15,26,239,31,5]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var D;(function(d){function v(f,s,r){if(!f)return;const o=O.$ag(f.type)?f.type:void 0;if(!o||o.length===0){r.error(C.localize(3,null));return}const n=[];if(Array.isArray(f.required))for(const t of f.required)O.$ag(t)&&n.push(t);return{extensionId:s.value,taskType:o,required:n,properties:f.properties?R.$7n(f.properties):{},when:f.when?M.$yj.deserialize(f.when):void 0}}d.from=v})(D||(D={}));const N=F.$HG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(d,v)=>{for(const f of d)f.type&&v.push(`onTaskType:${f.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:m}});class S{constructor(){this.d=new p.$he,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,f)=>{N.setHandler((s,r)=>{this.c=void 0;try{for(const o of r.removed){const n=o.value;for(const t of n)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const o of r.added){const n=o.value;for(const t of n){const c=D.from(t,o.description.identifier,o.collector);c&&(this.a[c.taskType]=c)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const f of this.all()){const s={type:"object",additionalProperties:!1};f.required.length>0&&(s.required=f.required.slice(0)),f.properties!==void 0?s.properties=R.$7n(f.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[f.taskType]},v.push(s)}this.c={oneOf:v}}return this.c}}e.$mI=new S}),define(ke[241],Se([1,0,191,15,24,26,31,240]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$wI=e.JsonSchemaVersion=e.ExecutionEngine=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$qI=e.ShellQuoting=e.$pI=e.$oI=e.$nI=void 0,e.$nI="settings",e.$oI=new M.$Rj("taskRunning",!1,C.localize(0,null)),e.$pI=C.localize2(2,"Tasks");var m;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$qI="$customized",function(A){function U(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=U}(m||(e.ShellQuoting=m={}));var D;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(D||(e.CommandOptions=D={}));var N;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(N||(e.RevealKind=N={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=U}(N||(e.RevealKind=N={}));var S;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(A){function U(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=U}(S||(e.RevealProblemKind=S={}));var d;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(d||(e.PanelKind=d={})),function(A){function U(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=U}(d||(e.PanelKind=d={}));var v;(function(A){A.defaults={echo:!0,reveal:N.Always,revealProblems:S.Never,focus:!1,panel:d.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var f;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(f||(e.RuntimeType=f={})),function(A){function U(ie){switch(ie.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=U;function K(ie){switch(ie){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(f||(e.RuntimeType=f={}));var s;(function(A){function U(K){return O.$ag(K)?K:K.value}A.value=U})(s||(e.CommandString=s={}));var r;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function U(ie){return ie===A.Clean._id||ie===A.Build._id||ie===A.Rebuild._id||ie===A.Test._id}A.is=U;function K(ie){if(ie!==void 0)return O.$ag(ie)?U(ie)?{_id:ie,isDefault:!1}:void 0:ie}A.from=K})(r||(e.TaskGroup=r={}));var o;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function U(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=U})(n||(e.TaskSourceKind=n={}));var t;(function(A){A.parallel="parallel",A.sequence="sequence"})(t||(e.DependsOrder=t={}));var c;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class i{constructor(U,K,ie,ce,ve,Ee){this._label="",this._id=U,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=ce,this.configurationProperties=ve,this._source=Ee}getDefinition(U){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,K=!1){if(U===void 0)return!1;if(O.$ag(U))return U===this._label||U===this.configurationProperties.identifier||K&&U===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$rI=i;class w extends i{constructor(U,K,ie,ce,ve,Ee,ge,ue){super(U,ie,void 0,ge,ue,K),this.command={},this._source=K,this.hasDefinedMatchers=Ee,ve&&(this.command=ve)}clone(){return new w(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case f.Shell:K="shell";break;case f.Process:K="process";break;case f.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(U){return U instanceof w}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$nI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$qI,folder:U,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$$g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new w(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$sI=w;class a extends i{constructor(U,K,ie,ce,ve,Ee,ge){super(U,ie,ce,Ee,ge,K),this._source=K,this.configures=ve}static is(U){return U instanceof a}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$$g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$nI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const U=this.d();if(!U)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$qI,folder:U,id:K};return JSON.stringify(ie)}}e.$tI=a;class l extends i{constructor(U,K,ie,ce,ve,Ee,ge,ue,Ce){super(U,ie,ce,ue,Ce,K),this.defines=ve,this.hasDefinedMatchers=ge,this.command=Ee,this.icon=Ce.icon,this.hide=Ce.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof l}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new l(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$uI=l;class g extends i{constructor(U,K,ie,ce,ve,Ee){super(U,ie,ce,ve,Ee,K),this._source=K}clone(){return new g(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof g}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new g(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$vI=g;var $;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(A){A._default=A.Terminal}($||(e.ExecutionEngine=$={}));var b;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class y{constructor(U){this.c=new Map;for(let K=0;K<U.length;K++)this.c.set(U[K].uri.toString(),K)}compare(U,K){const ie=U.getWorkspaceFolder(),ce=K.getWorkspaceFolder();if(ie&&ce){let ve=this.c.get(ie.uri.toString());ve=ve===void 0?0:ve+1;let Ee=this.c.get(ce.uri.toString());return Ee=Ee===void 0?0:Ee+1,ve===Ee?U._label.localeCompare(K._label):ve-Ee}else return!ie&&ce?-1:ie&&!ce?1:0}}e.$wI=y;var h;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(h||(e.TaskEventKind=h={}));var E;(function(A){A.SingleRun="singleRun",A.Background="background"})(E||(e.TaskRunType=E={}));var k;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var I;(function(A){function U(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function K(ue,Ce,re){return{...U(ue),kind:"start",terminalId:Ce,resolvedVariables:re}}A.start=K;function ie(ue,Ce,re){return{...U(ue),kind:"processStarted",terminalId:Ce,processId:re}}A.processStarted=ie;function ce(ue,Ce,re){return{...U(ue),kind:"processEnded",terminalId:Ce,exitCode:re}}A.processEnded=ce;function ve(ue,Ce,re){return{...U(ue),kind:"terminated",exitReason:re,terminalId:Ce}}A.terminated=ve;function Ee(ue,Ce,re){return{...U(Ce),kind:ue,terminalId:re}}A.general=Ee;function ge(){return{kind:"changed"}}A.changed=ge})(I||(e.TaskEvent=I={}));var P;(function(A){function U(ie){const ce=Object.keys(ie).sort();let ve="";for(const Ee of ce){let ge=ie[Ee];ge instanceof Object?ge=U(ge):typeof ge=="string"&&(ge=ge.replace(/,/g,",,")),ve+=Ee+","+ge+","}return ve}function K(ie){const ve={_key:U(ie),type:ie.taskType};return Object.assign(ve,ie),ve}A.create=K})(P||(e.KeyedTaskIdentifier=P={}));var V;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(A){function U(K,ie){const ce=p.$mI.get(K.type);if(ce===void 0){const ue=F.$7n(K);return delete ue._key,P.create(ue)}const ve=Object.create(null);ve.type=ce.taskType;const Ee=new Set;ce.required.forEach(ue=>Ee.add(ue));const ge=ce.properties;for(const ue of Object.keys(ge)){const Ce=K[ue];if(Ce!=null)ve[ue]=Ce;else if(Ee.has(ue)){const re=ge[ue];if(re.default!==void 0)ve[ue]=F.$7n(re.default);else switch(re.type){case"boolean":ve[ue]=!1;break;case"number":case"integer":ve[ue]=0;break;case"string":ve[ue]="";break;default:ie.error(C.localize(1,null,JSON.stringify(K,void 0,0),ue));return}}}return P.create(ve)}A.createTaskIdentifier=U})(q||(e.TaskDefinition=q={}))}),define(ke[242],Se([1,0,14]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=e.$Uac=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,C.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$Uac=O;class R extends O{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$Vac=R}),define(ke[34],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=e.$Ew=void 0,e.$Fw=R,e.$Gw=F;class C{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++C.count}}e.$Ew=C;const O=[];function R(p){const m=new C(p);return O[m.nid]=m,m}function F(p){return O[p].sid}class M{constructor(m){this.value=m}}e.$Hw=M}),define(ke[4],Se([1,0,34]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oM=e.$nM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$mM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var R;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var F;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var M;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var m;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var D;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(D||(e.NotebookEditorRevealType=D={}));var N;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output",s[s.Hybrid=3]="Hybrid"})(N||(e.CandidatePortSource=N={}));class S{static{this.a=0}static mixin(r){return r._id=S.a++,r}}e.$mM=S;var d;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(d||(e.ISuggestDataDtoField=d={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var f;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$nM={MainThreadAuthentication:(0,C.$Fw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$Fw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,C.$Fw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,C.$Fw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,C.$Fw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$Fw)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$Fw)("MainThreadClipboard"),MainThreadCommands:(0,C.$Fw)("MainThreadCommands"),MainThreadComments:(0,C.$Fw)("MainThreadComments"),MainThreadConfiguration:(0,C.$Fw)("MainThreadConfiguration"),MainThreadConsole:(0,C.$Fw)("MainThreadConsole"),MainThreadDebugService:(0,C.$Fw)("MainThreadDebugService"),MainThreadDecorations:(0,C.$Fw)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$Fw)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$Fw)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$Fw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$Fw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$Fw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$Fw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$Fw)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$Fw)("MainThreadErrors"),MainThreadTreeViews:(0,C.$Fw)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$Fw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$Fw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$Fw)("MainThreadLanguages"),MainThreadLogger:(0,C.$Fw)("MainThreadLogger"),MainThreadMessageService:(0,C.$Fw)("MainThreadMessageService"),MainThreadOutputService:(0,C.$Fw)("MainThreadOutputService"),MainThreadProgress:(0,C.$Fw)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$Fw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$Fw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$Fw)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$Fw)("MainThreadSecretState"),MainThreadStorage:(0,C.$Fw)("MainThreadStorage"),MainThreadSpeech:(0,C.$Fw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$Fw)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$Fw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,C.$Fw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,C.$Fw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$Fw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$Fw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$Fw)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$Fw)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$Fw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$Fw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$Fw)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$Fw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$Fw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$Fw)("MainThreadExtensionService"),MainThreadSCM:(0,C.$Fw)("MainThreadSCM"),MainThreadSearch:(0,C.$Fw)("MainThreadSearch"),MainThreadShare:(0,C.$Fw)("MainThreadShare"),MainThreadTask:(0,C.$Fw)("MainThreadTask"),MainThreadWindow:(0,C.$Fw)("MainThreadWindow"),MainThreadLabelService:(0,C.$Fw)("MainThreadLabelService"),MainThreadNotebook:(0,C.$Fw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$Fw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$Fw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$Fw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$Fw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$Fw)("MainThreadInteractive"),MainThreadTheming:(0,C.$Fw)("MainThreadTheming"),MainThreadTunnelService:(0,C.$Fw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$Fw)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$Fw)("MainThreadTimeline"),MainThreadTesting:(0,C.$Fw)("MainThreadTesting"),MainThreadLocalization:(0,C.$Fw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$Fw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$Fw)("MainThreadAiEmbeddingVector")},e.$oM={ExtHostCommands:(0,C.$Fw)("ExtHostCommands"),ExtHostConfiguration:(0,C.$Fw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$Fw)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$Fw)("ExtHostDebugService"),ExtHostDecorations:(0,C.$Fw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$Fw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$Fw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$Fw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$Fw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$Fw)("ExtHostEditors"),ExtHostTreeViews:(0,C.$Fw)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$Fw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$Fw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$Fw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$Fw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$Fw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$Fw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$Fw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$Fw)("ExtHostStatusBar"),ExtHostShare:(0,C.$Fw)("ExtHostShare"),ExtHostExtensionService:(0,C.$Fw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$Fw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$Fw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,C.$Fw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,C.$Fw)("ExtHostSCM"),ExtHostSearch:(0,C.$Fw)("ExtHostSearch"),ExtHostTask:(0,C.$Fw)("ExtHostTask"),ExtHostWorkspace:(0,C.$Fw)("ExtHostWorkspace"),ExtHostWindow:(0,C.$Fw)("ExtHostWindow"),ExtHostWebviews:(0,C.$Fw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$Fw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$Fw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$Fw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$Fw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$Fw)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$Fw)("ExtHostProgress"),ExtHostComments:(0,C.$Fw)("ExtHostComments"),ExtHostSecretState:(0,C.$Fw)("ExtHostSecretState"),ExtHostStorage:(0,C.$Fw)("ExtHostStorage"),ExtHostUrls:(0,C.$Fw)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$Fw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$Fw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$Fw)("ExtHostOutputService"),ExtHostLabelService:(0,C.$Fw)("ExtHostLabelService"),ExtHostNotebook:(0,C.$Fw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$Fw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$Fw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$Fw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$Fw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$Fw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$Fw)("ExtHostInteractive"),ExtHostChatAgents2:(0,C.$Fw)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$Fw)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$Fw)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$Fw)("ExtHostSpeech"),ExtHostEmbeddings:(0,C.$Fw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,C.$Fw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$Fw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$Fw)("ExtHostTheming"),ExtHostTunnelService:(0,C.$Fw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$Fw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$Fw)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$Fw)("ExtHostTimeline"),ExtHostTesting:(0,C.$Fw)("ExtHostTesting"),ExtHostTelemetry:(0,C.$Fw)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$Fw)("ExtHostLocalization")}}),define(ke[80],Se([1,0,3,12,4,17]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=e.$gmc=e.$fmc=void 0,e.$fmc=(0,C.$Ai)("IExtHostApiDeprecationService");let M=class{constructor(m,D){this.c=D,this.a=new Set,this.b=m.getProxy(R.$nM.MainThreadTelemetry)}report(m,D,N){const S=this.d(m,D);this.a.has(S)||(this.a.add(S),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:m}))}d(m,D){return`${m}-${D.identifier.value}`}};e.$gmc=M,e.$gmc=M=Je([We(0,F.$RO),We(1,O.$7j)],M),e.$hmc=Object.freeze(new class{report(p,m,D){}})}),define(ke[243],Se([1,0,4]),function(he,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class O{constructor(F){const M=F.getProxy(C.$nM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$umc=O}),define(ke[244],Se([1,0,26,4,27,17]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=void 0;let M=class{constructor(N,S){this.a=N.getProxy(O.$nM.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(N,S){const d=this,v=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){d.e(N,S,v,arguments)}})}e(N,S,d,v){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:m(v,this.b)}),this.c&&this.f(N,d,v)}};e.$ooc=M,e.$ooc=M=Je([We(0,F.$RO),We(1,R.$8O)],M);const p=1e5;function m(D,N){const S=[];if(D.length)for(let d=0;d<D.length;d++){let v=D[d];if(typeof v>"u")v="undefined";else if(v instanceof Error){const f=v;f.stack?v=f.stack:v=f.toString()}S.push(v)}if(N){const d=new Error().stack;d&&S.push({__$stack:d.split(`
`).slice(3).join(`
`)})}try{const d=(0,C.$_n)(S);return d.length>p?"Output omitted for a large object that exceeds the limits":d}catch(d){return`Output omitted for an object that cannot be inspected ('${d.toString()}')`}}}),define(ke[245],Se([1,0,2,4,25]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;class F{constructor(p){this.a=p.getProxy(O.$nM.MainThreadDialogs)}showOpenDialog(p,m){return m?.allowUIResources&&(0,R.$OG)(p,"showLocal"),this.a.$showOpenDialog(m).then(D=>D?D.map(N=>C.URI.revive(N)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(m=>m?C.URI.revive(m):void 0)}}e.$rnc=F}),define(ke[246],Se([1,0,20,5,6,4]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$unc=void 0;class M{constructor(m){this.b=new Map,this.c=new O.$he,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(F.$nM.MainThreadEmbeddings)}registerEmbeddingsProvider(m,D,N){if(this.d.has(D))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,D),this.b.set(S,{id:D,provider:N}),(0,R.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(m,D,N){N??=C.CancellationToken.None;let S=!1;typeof D=="string"&&(D=[D],S=!0);const d=await this.a.$computeEmbeddings(m,D,N);if(d.length!==D.length)throw new Error;if(S){if(d.length!==1)throw new Error;return d[0]}return d}async $provideEmbeddings(m,D,N){const S=this.b.get(m);if(!S)return[];const d=await S.provider.provideEmbeddings(D,N);return d||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$unc=M}),define(ke[247],Se([1,0,6,4]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=void 0;class R{constructor(M){this.b=0,this.a=M.getProxy(O.$nM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,C.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Lnc=R}),define(ke[81],Se([1,0,23,13,2,3,12,4,27,17]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=void 0;let N=class{constructor(d,v,f){this.f=f,this.d=new Map,this.a=v.getProxy(p.$nM.MainThreadLocalization),this.b=d.environment.appLanguage,this.c=this.b===C.$g}getMessage(d,v){const{message:f,args:s,comment:r}=v;if(this.c)return(0,O.$af)(f,s??{});let o=f;r&&r.length>0&&(o+=`/${Array.isArray(r)?r.join(""):r}`);const n=this.d.get(d)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$af)(n??f,s??{})}getBundle(d){return this.d.get(d)?.contents}getBundleUri(d){return this.d.get(d)?.uri}async initializeLocalizedMessages(d){if(this.c||!d.l10n&&!d.isBuiltin||this.d.has(d.identifier.value))return;let v;const f=await this.g(d);if(!f){this.f.error(`No bundle location found for extension ${d.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(f),r=JSON.parse(s);v=d.isBuiltin?r.contents?.bundle:r}catch(s){this.f.error(`Failed to load translations for ${d.identifier.value} from ${f}: ${s.message}`);return}v&&this.d.set(d.identifier.value,{contents:v,uri:f})}async g(d){if(d.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(d.identifier.value,this.b);return R.URI.revive(v)}return d.l10n?R.URI.joinPath(d.extensionLocation,d.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$_mc=N,e.$_mc=N=Je([We(0,m.$8O),We(1,D.$RO),We(2,M.$7j)],N),e.$anc=(0,F.$Ai)("IExtHostLocalizationService")}),define(ke[248],Se([1,0,12,4,27,17,2,45]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0;let m=class extends C.$fk{constructor(S,d){super(d.logLevel,d.logsLocation,d.loggers.map(v=>(0,p.$0h)(v))),this.r=S.getProxy(O.$nM.MainThreadLogger)}$setLogLevel(S,d){d?this.setLogLevel(M.URI.revive(d),S):this.setLogLevel(S)}setVisibility(S,d){super.setVisibility(S,d),this.r.$setVisibility(S,d)}s(S,d,v){return new D(this.r,S,d,v)}};e.$noc=m,e.$noc=m=Je([We(0,F.$RO),We(1,R.$8O)],m);class D extends C.$ak{constructor(S,d,v,f){super(f?.logLevel==="always"),this.r=S,this.s=d,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(d,f).then(()=>{this.u(this.n),this.m=!0})}g(S,d){const v=[[S,d]];this.m?this.u(v):this.n.push(...v)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(ke[82],Se([1,0,4,3,6,17,22]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=void 0,e.$bnc=(0,O.$Ai)("IExtHostManagedSockets");let p=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(C.$nM.MainThreadManagedSockets)}setFactory(S,d){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(S,d),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const d=++this.b,v=await this.c.makeConnection(),f=new R.$Tc;return this.d.set(d,new D(d,v,f)),f.add((0,R.$Sc)(()=>this.d.delete(d))),f.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(d),f.dispose()})),f.add(v.onDidClose(s=>{this.a.$onDidManagedSocketClose(d,s?.stack??s?.message),f.dispose()})),f.add(v.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(d,M.$Je.wrap(s)))),d}$remoteSocketWrite(S,d){this.d.get(S)?.actual.send(d.buffer)}$remoteSocketEnd(S){const d=this.d.get(S);d&&(d.actual.end(),d.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$cnc=p,e.$cnc=p=Je([We(0,F.$RO)],p);class m{constructor(S,d){this.socketFactoryId=S,this.makeConnection=d}}class D extends R.$Uc{constructor(S,d,v){super(),this.socketId=S,this.actual=d,this.B(v)}}}),define(ke[249],Se([1,0,4,12,25]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0;function F(p){return p&&p.title}let M=class{constructor(m,D){this.b=D,this.a=m.getProxy(C.$nM.MainThreadMessageService)}showMessage(m,D,N,S,d){const v={source:{identifier:m.identifier,label:m.displayName||m.name}};let f;typeof S=="string"||F(S)?f=[S,...d]:(v.modal=S?.modal,v.useCustom=S?.useCustom,v.detail=S?.detail,f=d),v.useCustom&&(0,R.$OG)(m,"resolvers");const s=[];let r=!1;for(let o=0;o<f.length;o++){const n=f[o];if(typeof n=="string")s.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:t,isCloseAffordance:c}=n;s.push({title:t,isCloseAffordance:!!c,handle:o}),c&&(r?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,n):r=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,n)}return this.a.$showMessage(D,N,v,s).then(o=>{if(typeof o=="number")return f[o]})}};e.$Nnc=M,e.$Nnc=M=Je([We(1,O.$7j)],M)}),define(ke[250],Se([1,0,6,15,2,25,4]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=void 0;class p{constructor(D){this.b=new Map,this.a=D.getProxy(M.$nM.MainThreadProfileContentHandlers)}registerProfileContentHandler(D,N,S){if((0,F.$OG)(D,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,S),this.a.$registerProfileContentHandler(N,S.name,S.description,D.identifier.value),(0,C.$Sc)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(D,N,S,d){const v=this.b.get(D);if(!v)throw new Error(`Unknown handler with id: ${D}`);return v.saveProfile(N,S,d)}async $readProfile(D,N,S){const d=this.b.get(D);if(!d)throw new Error(`Unknown handler with id: ${D}`);return d.readProfile((0,O.$ag)(N)?N:R.URI.revive(N),S)}}e.$Wnc=p}),define(ke[83],Se([1,0,4,5,3]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=void 0;class F{constructor(p){this.b=new O.$he,this.onDidChangePassword=this.b.event,this.a=p.getProxy(C.$nM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,m){return this.a.$getPassword(p,m)}store(p,m,D){return this.a.$setPassword(p,m,D)}delete(p,m){return this.a.$deletePassword(p,m)}}e.$9mc=F,e.$0mc=(0,R.$Ai)("IExtHostSecretState")}),define(ke[251],Se([1,0,20,6,4]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=void 0;class F{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.f=new Map,this.b=p.getProxy(R.$nM.MainThreadSpeech)}async $createSpeechToTextSession(p,m,D){const N=this.c.get(p);if(!N)return;const S=new O.$Tc,d=new C.$se;this.d.set(m,d);const v=await N.provideSpeechToTextSession(d.token,D?{language:D}:void 0);v&&(S.add(v.onDidChange(f=>{d.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,f)})),S.add(d.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createTextToSpeechSession(p,m,D){const N=this.c.get(p);if(!N)return;const S=new O.$Tc,d=new C.$se;this.d.set(m,d);const v=await N.provideTextToSpeechSession(d.token,D?{language:D}:void 0);v&&(this.f.set(m,v),S.add(v.onDidChange(f=>{d.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,f)})),S.add(d.token.onCancellationRequested(()=>S.dispose())))}async $synthesizeSpeech(p,m){this.f.get(p)?.synthesize(m)}async $cancelTextToSpeechSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p),this.f.delete(p)}async $createKeywordRecognitionSession(p,m){const D=this.c.get(p);if(!D)return;const N=new O.$Tc,S=new C.$se;this.d.set(m,S);const d=await D.provideKeywordRecognitionSession(S.token);d&&(N.add(d.onDidChange(v=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,v)})),N.add(S.token.onCancellationRequested(()=>N.dispose())))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,m,D){const N=F.a++;return this.c.set(N,D),this.b.$registerProvider(N,m,{extension:p,displayName:p.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(N),this.c.delete(N)})}}e.$4nc=F}),define(ke[84],Se([1,0,4,5,3]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0;class F{constructor(p,m){this.c=m,this.b=new O.$he,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(C.$nM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,m){this.a.$registerExtensionStorageKeysToSync(p,m)}async initializeExtensionStorage(p,m,D){const N=await this.a.$initializeExtensionStorage(p,m);let S;return N&&(S=this.d(p,m,N)),S||D}setValue(p,m,D){return this.a.$setValue(p,m,D)}$acceptValue(p,m,D){const N=this.d(p,m,D);N&&this.b.fire({shared:p,key:m,value:N})}d(p,m,D){try{return JSON.parse(D)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${p}): ${N}`)}}}e.$Ymc=F,e.$Zmc=(0,R.$Ai)("IExtHostStorage")}),define(ke[252],Se([1,0,6,16,2,4]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hoc=void 0;class M{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(F.$nM.MainThreadUriOpeners)}registerExternalUriOpener(m,D,N,S){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const d=S.schemes.find(v=>!M.a.has(v));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this.c.set(D,N),this.b.$registerUriOpener(D,S.schemes,m,S.label),(0,C.$Sc)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(m,D,N){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener with id: ${m}`);const d=R.URI.revive(D);return S.canOpenExternalUri(d,N)}async $openUri(m,D,N){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener id: '${m}'`);return S.openExternalUri(R.URI.revive(D.resolvedUri),{sourceUri:R.URI.revive(D.sourceUri)},N)}}e.$hoc=M}),define(ke[253],Se([1,0,4,2,6,14,21]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=void 0;class p{static{this.a=0}constructor(D){this.c=new M.$Wm,this.d=new Map,this.b=D.getProxy(C.$nM.MainThreadUrls)}registerUriHandler(D,N){const S=D.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const d=p.a++;return this.c.add(S),this.d.set(d,N),this.b.$registerUriHandler(d,S,D.displayName||D.name),(0,R.$Sc)(()=>{this.c.delete(S),this.d.delete(d),this.b.$unregisterUriHandler(d)})}$handleExternalUri(D,N){const S=this.d.get(D);if(!S)return Promise.resolve(void 0);try{S.handleUri(O.URI.revive(N))}catch(d){(0,F.$1)(d)}return Promise.resolve(void 0)}async createAppUri(D){return O.URI.revive(await this.b.$createAppUri(D))}}e.$ioc=p}),define(ke[64],Se([1,0,5,6,16,26,2,197,221,78,4]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=e.$Jmc=void 0,e.$Kmc=d,e.$Mmc=s,e.$Nmc=r;class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,u,i,w,a,l,g){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new C.$he,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$he,this._onDidDispose=this.#h.event,this.#e=c,this.#t=u,this.#o=i,this.#n=w,this.#s=a,this.#r=l,this.#l=d(l),this.#d=v(l),this.#i=g}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,D.$sBb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===R.Schemas.https||c.scheme===R.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+D.$rBb}return D.$rBb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),F.$$n(this.#o,c)||this.#t.$setOptions(this.#e,r(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const u=(0,m.$qsb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const u=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(w,a,l,g,$,b)=>{const y=M.URI.from({scheme:g||"file",path:decodeURIComponent($)}),h=(0,D.$sBb)(y,{isRemote:u,authority:i}).toString();return`${a}${h}${b}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(w,a,l,g,$,b)=>{const y=M.URI.from({scheme:g||"file",path:decodeURIComponent($)}),h=(0,D.$sBb)(y,{isRemote:u,authority:i}).toString();return`${a}${h}${b}`})}}e.$Jmc=S;function d(t){try{const c=(0,p.$Op)((0,p.$Np)(t.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function v(t){try{const c=(0,p.$Op)((0,p.$Np)(t.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class f extends O.$Uc{constructor(c,u,i,w,a){super(),this.c=u,this.f=i,this.g=w,this.h=a,this.b=new Map,this.a=c.getProxy(N.$nM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,u,i){const w=this.j(c);if(w){const{message:a}=(0,m.$rsb)(u,i.value);w._onMessageEmitter.fire(a)}}$onMissingCsp(c,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,i){const w=new S(c,this.a,o(u),this.c,this.f,i,this.h);this.b.set(c,w);const a=w._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return w}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Lmc=f;function s(t){return{id:t.identifier,location:t.extensionLocation}}function r(t,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||n(t,c)}}function o(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(c=>M.URI.from(c))}}function n(t,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),t.extensionLocation]}}),define(ke[111],Se([1,0,5,16,13,2,3,17,4]),function(he,e,C,O,R,F,M,p,m){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=e.$koc=void 0;let N=class{static{D=this}static{this.a={focused:!0,active:!0}}getState(){const d=this.d;return{get focused(){return d.focused},get active(){return d.active}}}constructor(d){this.c=new C.$he,this.onDidChangeWindowState=this.c.event,this.d=D.a,this.b=d.getProxy(m.$nM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:f})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(d){this.onDidChangeWindowProperty("focused",d)}$onDidChangeWindowActive(d){this.onDidChangeWindowProperty("active",d)}onDidChangeWindowProperty(d,v){v!==this.d[d]&&(this.d={...this.d,[d]:v},this.c.fire(this.d))}openUri(d,v){let f;if(typeof d=="string"){f=d;try{d=F.URI.parse(d)}catch{return Promise.reject(`Invalid uri - '${d}'`)}}return(0,R.$$e)(d.scheme)?Promise.reject("Invalid scheme - cannot be empty"):d.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${d.scheme}'`):this.b.$openUri(d,f,v)}async asExternalUri(d,v){if((0,R.$$e)(d.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(d,v);return F.URI.from(f)}};e.$koc=N,e.$koc=N=D=Je([We(0,p.$RO)],N),e.$loc=(0,M.$Ai)("IExtHostWindow")}),define(ke[254],Se([1,0,244,27,17]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0;let F=class extends C.$ooc{constructor(p,m){super(p,m)}f(p,m,D){m.apply(console,D)}};e.$wqc=F,e.$wqc=F=Je([We(0,R.$RO),We(1,O.$8O)],F)}),define(ke[255],Se([1,0,11,22,20,14,5,6,150,242,34]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=e.ResponsiveState=e.RequestInitiator=void 0,e.$Wac=r,e.$Xac=o;function d(k,I){try{return JSON.stringify(k,I)}catch{return"null"}}const v="$$ref$$",f={[v]:-1};class s{constructor(I,P){this.jsonString=I,this.referencedBuffers=P}}function r(k,I=null,P=!1){const V=[];return{jsonString:(P?d:JSON.stringify)(k,(q,A)=>{if(typeof A>"u")return f;if(typeof A=="object"){if(A instanceof O.$Je){const U=V.push(A)-1;return{[v]:U}}if(I)return I(q,A)}return A}),referencedBuffers:V}}function o(k,I,P){return JSON.parse(k,(V,W)=>{if(W){const q=W[v];if(typeof q=="number")return I[q];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}function n(k,I){return JSON.stringify(k,I)}function t(k){return k?(I,P)=>P&&P.$mid===1?k.transformOutgoing(P):P:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const i=()=>{},w=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class l extends p.$Uc{static{S=w}static{this.a=3*1e3}constructor(I,P=null,V=null){super(),this[S]=!0,this.b=this.B(new M.$he),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=P,this.g=V,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=N.$Ew.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$Mh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const P=this.w[I];delete this.w[I],P.resolveErr(F.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,m.$Fn)(I,this.g):I}getProxy(I){const{nid:P,sid:V}=I;return this.s[P]||(this.s[P]=this.J(P,V)),this.s[P]}J(I,P){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...A)=>this.U(I,q,A)),q===a?P:W[q])};return new Proxy(Object.create(null),V)}set(I,P){return this.m[I.nid]=P,P}assertRegistered(I){for(let P=0,V=I.length;P<V;P++){const W=I[P];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(I){if(this.j)return;const P=I.byteLength,V=$.read(I,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:A,method:U,args:K}=y.deserializeRequestJSONArgs(V);this.g&&(K=(0,m.$Fn)(K,this.g)),this.M(P,q,A,U,K,W===2);break}case 3:case 4:{let{rpcId:A,method:U,args:K}=y.deserializeRequestMixedArgs(V);this.g&&(K=(0,m.$Fn)(K,this.g)),this.M(P,q,A,U,K,W===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let A=y.deserializeReplyOKJSON(V);this.g&&(A=(0,m.$Fn)(A,this.g)),this.O(P,q,A);break}case 10:{const A=y.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(P,q,A);break}case 8:{const A=y.deserializeReplyOKVSBuffer(V);this.O(P,q,A);break}case 11:{let A=y.deserializeReplyErrError(V);this.g&&(A=(0,m.$Fn)(A,this.g)),this.P(P,q,A);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,P,V,W,q,A){this.f?.logIncoming(I,P,1,`receiveRequest ${(0,N.$Gw)(V)}.${W}(`,q);const U=String(P);let K,ie;if(A){const ve=new R.$se;q.push(ve.token),K=this.Q(V,W,q),ie=()=>ve.cancel()}else K=this.Q(V,W,q),ie=i;this.u[U]=ie;const ce=y.serializeAcknowledged(P);this.f?.logOutgoing(ce.byteLength,P,1,"ack"),this.c.send(ce),K.then(ve=>{delete this.u[U];const Ee=y.serializeReplyOK(P,ve,this.h);this.f?.logOutgoing(Ee.byteLength,P,1,"reply:",ve),this.c.send(Ee)},ve=>{delete this.u[U];const Ee=y.serializeReplyErr(P,ve);this.f?.logOutgoing(Ee.byteLength,P,1,"replyErr:",ve),this.c.send(Ee)})}N(I,P){this.f?.logIncoming(I,P,1,"receiveCancel");const V=String(P);this.u[V]?.()}O(I,P,V){this.f?.logIncoming(I,P,0,"receiveReply:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(I,P,V){this.f?.logIncoming(I,P,0,"receiveReplyErr:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let A;V&&(V.$isError?(A=new Error,A.name=V.name,A.message=V.message,A.stack=V.stack):A=V),q.resolveErr(A)}Q(I,P,V){try{return Promise.resolve(this.S(I,P,V))}catch(W){return Promise.reject(W)}}S(I,P,V){const W=this.m[I];if(!W)throw new Error("Unknown actor "+(0,N.$Gw)(I));const q=W[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,N.$Gw)(I));return q.apply(W,V)}U(I,P,V){if(this.j)return new D.$Vac;let W=null;if(V.length>0&&R.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(F.$6());const q=y.serializeRequestArguments(V,this.h),A=++this.t,U=String(A),K=new D.$Uac,ie=new p.$Tc;W&&ie.add(W.onCancellationRequested(()=>{const ve=y.serializeCancel(A);this.f?.logOutgoing(ve.byteLength,A,0,"cancel"),this.c.send(y.serializeCancel(A))})),this.w[U]=new g(K,ie),this.F(A);const ce=y.serializeRequest(A,I,P,q,!!W);return this.f?.logOutgoing(ce.byteLength,A,0,`request: ${(0,N.$Gw)(I)}.${P}(`,V),this.c.send(ce),K}}e.$Yac=l;class g{constructor(I,P){this.a=I,this.b=P}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class ${static alloc(I,P,V){const W=new $(O.$Je.alloc(V+1+4),0);return W.writeUInt8(I),W.writeUInt32(P),W}static read(I,P){return new $(I,P)}get buffer(){return this.a}constructor(I,P){this.a=I,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+I);return this.b+=I,P}static sizeMixedArray(I){let P=0;P+=1;for(let V=0,W=I.length;V<W;V++){const q=I[V];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)P+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return P}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let P=0,V=I.length;P<V;P++){const W=I[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const P=new Array(I);for(let V=0;V<I;V++)switch(this.readUInt8()){case 1:P[V]=this.readLongString();break;case 2:P[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),U=[];for(let K=0;K<q;++K)U.push(this.readVSBuffer());P[V]=new N.$Hw(o(A,U,null));break}case 4:P[V]=void 0;break}return P}}var b;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(b||(b={}));class y{static a(I){for(let P=0,V=I.length;P<V;P++)if(I[P]instanceof O.$Je||I[P]instanceof N.$Hw||typeof I[P]>"u")return!0;return!1}static serializeRequestArguments(I,P){if(this.a(I)){const V=[];for(let W=0,q=I.length;W<q;W++){const A=I[W];if(A instanceof O.$Je)V[W]={type:2,value:A};else if(typeof A>"u")V[W]={type:4};else if(A instanceof N.$Hw){const{jsonString:U,referencedBuffers:K}=r(A.value,P);V[W]={type:3,value:O.$Je.fromString(U),buffers:K}}else V[W]={type:1,value:O.$Je.fromString(n(A,P))}}return{type:1,args:V}}return{type:0,args:n(I,P)}}static serializeRequest(I,P,V,W,q){switch(W.type){case 0:return this.b(I,P,V,W.args,q);case 1:return this.c(I,P,V,W.args,q)}}static b(I,P,V,W,q){const A=O.$Je.fromString(V),U=O.$Je.fromString(W);let K=0;K+=$.sizeUInt8(),K+=$.sizeShortString(A),K+=$.sizeLongString(U);const ie=$.alloc(q?2:1,I,K);return ie.writeUInt8(P),ie.writeShortString(A),ie.writeLongString(U),ie.buffer}static deserializeRequestJSONArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readLongString();return{rpcId:P,method:V,args:JSON.parse(W)}}static c(I,P,V,W,q){const A=O.$Je.fromString(V);let U=0;U+=$.sizeUInt8(),U+=$.sizeShortString(A),U+=$.sizeMixedArray(W);const K=$.alloc(q?4:3,I,U);return K.writeUInt8(P),K.writeShortString(A),K.writeMixedArray(W),K.buffer}static deserializeRequestMixedArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readMixedArray(),q=new Array(W.length);for(let A=0,U=W.length;A<U;A++){const K=W[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:P,method:V,args:q}}static serializeAcknowledged(I){return $.alloc(5,I,0).buffer}static serializeCancel(I){return $.alloc(6,I,0).buffer}static serializeReplyOK(I,P,V){if(typeof P>"u")return this.d(I);if(P instanceof O.$Je)return this.e(I,P);if(P instanceof N.$Hw){const{jsonString:W,referencedBuffers:q}=r(P.value,V,!0);return this.g(I,W,q)}else return this.f(I,d(P,V))}static d(I){return $.alloc(7,I,0).buffer}static e(I,P){let V=0;V+=$.sizeVSBuffer(P);const W=$.alloc(8,I,V);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,P){const V=O.$Je.fromString(P);let W=0;W+=$.sizeLongString(V);const q=$.alloc(9,I,W);return q.writeLongString(V),q.buffer}static g(I,P,V){const W=O.$Je.fromString(P);let q=0;q+=$.sizeUInt32,q+=$.sizeLongString(W);for(const U of V)q+=$.sizeVSBuffer(U);const A=$.alloc(10,I,q);A.writeUInt32(V.length),A.writeLongString(W);for(const U of V)A.writeBuffer(U);return A.buffer}static deserializeReplyOKJSON(I){const P=I.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(I,P){const V=I.readUInt32(),W=I.readLongString(),q=[];for(let A=0;A<V;++A)q.push(I.readVSBuffer());return new N.$Hw(o(W,q,P))}static serializeReplyErr(I,P){const V=P?d(F.$3(P),null):void 0;if(typeof V!="string")return this.h(I);const W=O.$Je.fromString(V);let q=0;q+=$.sizeLongString(W);const A=$.alloc(11,I,q);return A.writeLongString(W),A.buffer}static deserializeReplyErrError(I){const P=I.readLongString();return JSON.parse(P)}static h(I){return $.alloc(12,I,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var E;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(E||(E={}))}),define(ke[256],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqc=void 0;const C=function(F){const M=p=>{globalThis.removeEventListener("message",M);const m=p.data;Object.defineProperties(globalThis,{postMessage:{value(D,N){m.postMessage(D,N)}},onmessage:{get(){return m.onmessage},set(D){m.onmessage=D}}}),m.addEventListener("message",D=>{globalThis.dispatchEvent(new MessageEvent("message",{data:D.data,ports:D.ports?[...D.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",M)}.toString();class O extends EventTarget{constructor(F,M,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${C})('${M}'))`,D=new Blob([m],{type:"application/javascript"}),N=URL.createObjectURL(D),S=new MessageChannel,d=N,v={type:"_newWorker",id:d,port:S.port2,url:N,options:p};F(v,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{F({type:"_terminateWorker",id:d}),URL.revokeObjectURL(N),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(f){S.port1.onmessage=f}},onmessageerror:{get(){return S.port1.onmessageerror},set(f){S.port1.onmessageerror=f}}}),S.port1.addEventListener("messageerror",f=>{const s=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(s)}),S.port1.addEventListener("message",f=>{const s=new MessageEvent("message",{data:f.data});this.dispatchEvent(s)}),S.port1.start()}}e.$yqc=O}),define(ke[257],Se([1,0,22,28,16,56,3]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.$1J=void 0,e.$2J=N,e.$3J=S,e.$1J=(0,M.$Ai)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${p.join("")}]+`),D=7;function N(v){if(v.scheme!==R.Schemas.vscodeNotebookCell)return;const f=v.fragment.indexOf("s");if(f<0)return;const s=parseInt(v.fragment.substring(0,f).replace(m,""),D),r=(0,C.$3e)(v.fragment.substring(f+1)).toString();if(!isNaN(s))return{handle:s,notebook:v.with({scheme:r,fragment:null})}}function S(v,f){const s=f.toString(D),o=`${s.length<p.length?p[s.length-1]:"z"}${s}s${(0,C.$4e)(C.$Je.fromString(v.scheme),!0,!0)}`;return v.with({scheme:R.Schemas.vscodeNotebookCell,fragment:o})}class d{constructor(){this.a=new O.$Ac}getNotebook(f){if(f.scheme===R.Schemas.vscodeNotebookCell){const s=N(f);if(s){const r=this.a.get(s.notebook);if(r)return r}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$4J=d,(0,F.$Ds)(e.$1J,d,1)}),define(ke[85],Se([1,0,22,37,42,70,16,19,23,31,257]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lK=e.$iK=e.CellStatusbarAlignment=e.$hK=e.NotebookEditorPriority=e.$eK=e.$dK=e.$bK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$aK=e.$_J=e.$$J=e.$0J=e.CellKind=e.$9J=e.$8J=e.$7J=void 0,e.$cK=w,e.$fK=l,e.$gK=g,e.$jK=y,e.$kK=E,e.$7J="workbench.editor.notebook",e.$8J="workbench.editor.notebookTextDiffEditor",e.$9J="workbench.editor.interactive";var S;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(S||(e.CellKind=S={})),e.$0J=["application/json","application/javascript","text/html","image/svg+xml",F.$Ws.latex,F.$Ws.markdown,"image/png","image/jpeg",F.$Ws.text],e.$$J=[F.$Ws.latex,F.$Ws.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$Ws.text],e.$_J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$aK="_notAvailable";var d;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(d||(e.NotebookRunState=d={}));var v;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var f;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var s;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var r;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(r||(e.RendererMessagingSpec=r={}));var o;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var t;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var c;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function ie(Ce,re){return(0,N.$3J)(Ce,re)}K.generate=ie;function ce(Ce){return(0,N.$2J)(Ce)}K.parse=ce;function ve(Ce,re){return Ce.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${Ce.scheme!==M.Schemas.file?Ce.scheme:""}`})}K.generateCellOutputUri=ve;function Ee(Ce){if(Ce.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Ce.fragment);if(!re)return;const Ne=re[1]&&re[1]!==""?re[1]:void 0,Te=re[2];return{outputId:Ne,notebook:Ce.with({scheme:Te||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ee;function ge(Ce,re,Ne){return K.generate(Ce,re).with({scheme:Ne})}K.generateCellPropertyUri=ge;function ue(Ce,re){if(Ce.scheme===re)return K.parse(Ce.with({scheme:K.scheme}))}K.parseCellPropertyUri=ue})(c||(e.CellUri=c={}));const u=K=>m.$i?K.replace(/\//g,"\\"):K;class i{constructor(ie=[],ce=e.$0J){this.e=ce,this.d=[...new Set(ie)].map(ve=>({pattern:ve,matches:O.$uk(u(ve))}))}sort(ie){const ce=new Map(R.Iterable.map(ie,Ee=>[Ee,u(Ee)]));let ve=[];for(const{matches:Ee}of this.d)for(const[ge,ue]of ce)if(Ee(ue)){ve.push(ge),ce.delete(ge);break}return ce.size&&(ve=ve.concat([...ce.keys()].sort((Ee,ge)=>this.e.indexOf(Ee)-this.e.indexOf(ge)))),ve}prioritize(ie,ce){const ve=this.f(ie);if(ve===-1){this.d.unshift({pattern:ie,matches:O.$uk(u(ie))});return}const Ee=new Set(ce.map(ue=>this.f(ue,ve)));Ee.delete(-1);const ge=Array.from(Ee).sort();this.d.splice(ve+1,0,...ge.map(ue=>this.d[ue]));for(let ue=ge.length-1;ue>=0;ue--)this.d.splice(ge[ue],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,ce=this.d.length){const ve=u(ie);for(let Ee=0;Ee<ce;Ee++)if(this.d[Ee].matches(ve))return Ee;return-1}}e.$bK=i;function w(K,ie,ce,ve=(Ee,ge)=>Ee===ge){const Ee=[];function ge(re,Ne,Te){if(Ne===0&&Te.length===0)return;const T=Ee[Ee.length-1];T&&T.start+T.deleteCount===re?(T.deleteCount+=Ne,T.toInsert.push(...Te)):Ee.push({start:re,deleteCount:Ne,toInsert:Te})}let ue=0,Ce=0;for(;;){if(ue===K.length){ge(ue,0,ie.slice(Ce));break}if(Ce===ie.length){ge(ue,K.length-ue,[]);break}const re=K[ue],Ne=ie[Ce];if(ve(re,Ne)){ue+=1,Ce+=1;continue}ce(Ne)?(ge(ue,1,[]),ue+=1):(ge(ue,0,[Ne]),Ce+=1)}return Ee}e.$dK=new D.$Rj("notebookEditorCursorAtBoundary","none"),e.$eK=new D.$Rj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function l(K){const ie=K;return!!((typeof ie.include=="string"||O.$vk(ie.include))&&(typeof ie.exclude=="string"||O.$vk(ie.exclude)))}function g(K,ie,ce){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const ve=l(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ee=l(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(O.$tk(ve,(0,p.$nc)(ce.fsPath).toLowerCase()))return!(Ee&&O.$tk(Ee,(0,p.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$hK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var $;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})($||(e.CellStatusbarAlignment=$={}));class b{static{this.d="notebook/"}static create(ie){return`${b.d}${ie}`}static parse(ie){if(ie.startsWith(b.d))return ie.substring(b.d.length)}}e.$iK=b;function y(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const h=new TextDecoder;function E(K){const ie=[];let ce=!1;for(const ue of K)(ie.length===0||ce)&&(ie.push(ue),ce=!0);let ve=P(ie);const Ee=C.$Je.concat(ie.map(ue=>C.$Je.wrap(ue))),ge=U(Ee);return ve=ve||ge.byteLength!==Ee.byteLength,{data:ge,didCompression:ve}}e.$lK="\x1B[A";const k=e.$lK.split("").map(K=>K.charCodeAt(0)),I=10;function P(K){let ie=!1;return K.forEach((ce,ve)=>{if(ve===0||ce.length<e.$lK.length)return;const Ee=K[ve-1],ge=ce.subarray(0,e.$lK.length);if(ge[0]===k[0]&&ge[1]===k[1]&&ge[2]===k[2]){const ue=Ee.lastIndexOf(I);if(ue===-1)return;ie=!0,K[ve-1]=Ee.subarray(0,ue),K[ve]=ce.subarray(e.$lK.length)}}),ie}function V(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function W(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let ce=K.match(/\r+(.*)$/m)[1];ce=ce+ie.slice(ce.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return K}const q=8,A=13;function U(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:C.$Je.fromString(W(V(h.decode(K.buffer))))}}),define(ke[7],Se([1,0,18,14,55,28,70,13,15,2,33,21,38,104,85]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f){"use strict";var s,r,o,n,t,c,u,i,w,a,l,g,$,b,y,h,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$FO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$lO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$$N=e.$0N=e.$9N=e.$8N=e.$6N=e.$5N=e.$4N=e.$3N=e.TestRunProfileKind=e.TestResultState=e.$2N=e.$1N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$ZN=e.NotebookVariablesRequestKind=e.$YN=e.$XN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$WN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.ColorThemeKind=e.$QN=e.$PN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$ON=e.$NN=e.DebugConsoleMode=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$HN=e.$GN=e.FileChangeType=e.$FN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$EN=e.$DN=e.$CN=e.$BN=e.InlineCompletionTriggerKind=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$oN=e.ConfigurationTarget=e.$nN=e.$mN=e.$lN=e.$kN=e.DocumentPasteTriggerKind=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$dN=e.ViewBadge=e.ProgressLocation=e.$cN=e.$bN=e.TaskScope=e.ShellQuoting=e.$aN=e.$_M=e.$$M=e.TaskPanelKind=e.TaskRevealKind=e.$0M=e.TerminalLocation=e.$9M=e.$8M=e.$7M=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$6M=e.$5M=e.$4M=e.$3M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$1M=e.$ZM=e.$YM=e.$XM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$WM=e.$VM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$UM=e.$TM=e.$SM=e.$RM=e.$QM=e.LanguageStatusSeverity=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.CodeActionTriggerKind=e.$JM=e.$IM=e.SymbolTag=e.SymbolKind=e.$HM=e.$GM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.DiagnosticSeverity=e.DiagnosticTag=e.$AM=e.$zM=e.FileEditType=e.$yM=e.$xM=e.$wM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$2M=Vt,e.$pN=Re,e.$7N=En;function k(B){return Object.assign(B,{apply:function(...ee){if(ee.length===0)return Reflect.construct(B,[]);{const De=ee.length===1?[]:ee[1];return Reflect.construct(B,De,ee[0].constructor)}},call:function(...ee){if(ee.length===0)return Reflect.construct(B,[]);{const[De,...Ke]=ee;return Reflect.construct(B,Ke,De.constructor)}}})}var I;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(I||(e.TerminalOutputAnchor=I={}));var P;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let V=s=class{static from(...L){let ee=L;return new s(function(){if(ee){for(const De of ee)De&&typeof De.dispose=="function"&&De.dispose();ee=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$pM=V,e.$pM=V=s=Je([k],V);let W=r=class{static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let De=1;De<L.length;De++){const Ke=L[De];Ke.isBefore(ee)&&(ee=Ke)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let De=1;De<L.length;De++){const Ke=L[De];Ke.isAfter(ee)&&(ee=Ke)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof r)return!0;const{line:ee,character:De}=L;return typeof ee=="number"&&typeof De=="number"}static of(L){if(L instanceof r)return L;if(this.isPosition(L))return new r(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,ee){if(L<0)throw(0,O.$7)("line must be non-negative");if(ee<0)throw(0,O.$7)("character must be non-negative");this.c=L,this.e=ee}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,O.$7)();let De;return typeof L>"u"?De=0:typeof L=="number"?De=L:(De=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),De===0&&ee===0?this:new r(this.line+De,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,O.$7)();let De;return typeof L>"u"?De=this.line:typeof L=="number"?De=L:(De=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),De===this.line&&ee===this.character?this:new r(De,ee)}toJSON(){return{line:this.line,character:this.character}}};e.$qM=W,e.$qM=W=r=Je([k],W);let q=o=class{static isRange(L){return L instanceof o?!0:L?W.isPosition(L.start)&&W.isPosition(L.end):!1}static of(L){if(L instanceof o)return L;if(this.isRange(L))return new o(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,ee,De,Ke){let Ye,lt;if(typeof L=="number"&&typeof ee=="number"&&typeof De=="number"&&typeof Ke=="number"?(Ye=new W(L,ee),lt=new W(De,Ke)):W.isPosition(L)&&W.isPosition(ee)&&(Ye=W.of(L),lt=W.of(ee)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(L){return o.isRange(L)?this.contains(L.start)&&this.contains(L.end):W.isPosition(L)?!(W.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const ee=W.Max(L.start,this.c),De=W.Min(L.end,this.e);if(!ee.isAfter(De))return new o(ee,De)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=W.Min(L.start,this.c),De=W.Max(L.end,this.end);return new o(ee,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,O.$7)();let De;return L?W.isPosition(L)?De=L:(De=L.start||this.start,ee=L.end||this.end):De=this.start,De.isEqual(this.c)&&ee.isEqual(this.end)?this:new o(De,ee)}toJSON(){return[this.start,this.end]}};e.$rM=q,e.$rM=q=o=Je([k],q);let A=n=class extends q{static isSelection(L){return L instanceof n?!0:L?q.isRange(L)&&W.isPosition(L.anchor)&&W.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,ee,De,Ke){let Ye,lt;if(typeof L=="number"&&typeof ee=="number"&&typeof De=="number"&&typeof Ke=="number"?(Ye=new W(L,ee),lt=new W(De,Ke)):W.isPosition(L)&&W.isPosition(ee)&&(Ye=W.of(L),lt=W.of(ee)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$sM=A,e.$sM=A=n=Je([k],A);const U=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,O.$7)("connectionToken")};class K{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ee,De){if(typeof L!="string"||L.length===0)throw(0,O.$7)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,O.$7)("port");typeof De<"u"&&U(De),this.host=L,this.port=Math.round(ee),this.connectionToken=De}}e.$tM=K;class ie{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ee){this.makeConnection=L,this.connectionToken=ee,typeof ee<"u"&&U(ee)}}e.$uM=ie;class ce extends Error{static NotAvailable(L,ee){return new ce(L,v.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new ce(L,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ee=v.RemoteAuthorityResolverErrorCode.Unknown,De){super(L),this._message=L,this._code=ee,this._detail=De,Object.setPrototypeOf(this,ce.prototype)}}e.$vM=ce;var ve;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ve||(e.EndOfLine=ve={}));var Ee;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ee||(e.EnvironmentVariableMutatorType=Ee={}));let ge=t=class{static isTextEdit(L){return L instanceof t?!0:L?q.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new t(L,ee)}static insert(L,ee){return t.replace(new q(L,L),ee)}static delete(L){return t.replace(L,"")}static setEndOfLine(L){const ee=new t(new q(new W(0,0),new W(0,0)),"");return ee.newEol=L,ee}get range(){return this.c}set range(L){if(L&&!q.isRange(L))throw(0,O.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,O.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,O.$7)("newEol");this.f=L}constructor(L,ee){this.c=L,this.e=ee}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$wM=ge,e.$wM=ge=t=Je([k],ge);let ue=c=class{static isNotebookCellEdit(L){return L instanceof c?!0:L?gi.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ee){return new c(L,ee)}static insertCells(L,ee){return new c(new gi(L,L),ee)}static deleteCells(L){return new c(L,[])}static updateCellMetadata(L,ee){const De=new c(new gi(L,L),[]);return De.newCellMetadata=ee,De}static updateNotebookMetadata(L){const ee=new c(new gi(0,0),[]);return ee.newNotebookMetadata=L,ee}constructor(L,ee){this.range=L,this.newCells=ee}};e.$xM=ue,e.$xM=ue=c=Je([k],ue);class Ce{static isSnippetTextEdit(L){return L instanceof Ce?!0:L?q.isRange(L.range)&&Te.isSnippetString(L.snippet):!1}static replace(L,ee){return new Ce(L,ee)}static insert(L,ee){return Ce.replace(new q(L,L),ee)}constructor(L,ee){this.range=L,this.snippet=ee}}e.$yM=Ce;var re;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,ee,De,Ke){this.c.push({_type:1,from:L,to:ee,options:De,metadata:Ke})}createFile(L,ee,De){this.c.push({_type:1,from:void 0,to:L,options:ee,metadata:De})}deleteFile(L,ee,De){this.c.push({_type:1,from:L,to:void 0,options:ee,metadata:De})}e(L,ee,De){this.c.push({_type:3,metadata:De,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}f(L,ee,De,Ke){const Ye=ee.start,lt=ee.end;(Ye!==lt||De.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:lt-Ye,cells:De,metadata:Ke})}g(L,ee,De,Ke){this.c.push({_type:3,metadata:Ke,uri:L,edit:{editType:3,index:ee,metadata:De}})}replace(L,ee,De,Ke){this.c.push({_type:2,uri:L,edit:new ge(ee,De),metadata:Ke})}insert(L,ee,De,Ke){this.replace(L,new q(ee,ee),De,Ke)}delete(L,ee,De){this.replace(L,ee,"",De)}has(L){return this.c.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const De of ee){if(!De)continue;let Ke,Ye;Array.isArray(De)?(Ke=De[0],Ye=De[1]):Ke=De,ue.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(L,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(L,Ke.newNotebookMetadata,Ye):this.f(L,Ke.range,Ke.newCells,Ye):Ce.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:L,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:Ke,metadata:Ye})}else{for(let De=0;De<this.c.length;De++){const Ke=this.c[De];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===L.toString()&&(this.c[De]=void 0);break}}(0,C.$Ib)(this.c)}}get(L){const ee=[];for(const De of this.c)De._type===2&&De.uri.toString()===L.toString()&&ee.push(De.edit);return ee}entries(){const L=new F.$Ac;for(const ee of this.c)if(ee._type===2){let De=L.get(ee.uri);De||(De=[ee.uri,[]],L.set(ee.uri,De)),De[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$zM=Ne,e.$zM=Ne=Je([k],Ne);let Te=u=class{static isSnippetString(L){return L instanceof u?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=u.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this.e++){if(typeof L=="function"){const De=new u;De.e=this.e,L(De),this.e=De.e,L=De.value}else L=u.c(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this.e++){const De=L.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const De=new u;De.e=this.e,ee(De),this.e=De.e,ee=De.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};e.$AM=Te,e.$AM=Te=u=Je([k],Te);var T;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(T||(e.DiagnosticTag=T={}));var X;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(X||(e.DiagnosticSeverity=X={}));let pe=i=class{static isLocation(L){return L instanceof i?!0:L?q.isRange(L.range)&&D.URI.isUri(L.uri):!1}constructor(L,ee){if(this.uri=L,ee)if(q.isRange(ee))this.range=q.of(ee);else if(W.isPosition(ee))this.range=new q(ee,ee);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$BM=pe,e.$BM=pe=i=Je([k],pe);let Ie=class{static is(L){return L?typeof L.message=="string"&&L.location&&q.isRange(L.location.range)&&D.URI.isUri(L.location.uri):!1}constructor(L,ee){this.location=L,this.message=ee}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};e.$CM=Ie,e.$CM=Ie=Je([k],Ie);let ye=class{constructor(L,ee,De=X.Error){if(!q.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=De}toJSON(){return{severity:X[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,C.$ub)(L.tags,ee.tags)&&(0,C.$ub)(L.relatedInformation,ee.relatedInformation,Ie.isEqual)}};e.$DM=ye,e.$DM=ye=Je([k],ye);let $e=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ee}};e.$EM=$e,e.$EM=$e=Je([k],$e);let fe=class extends $e{constructor(L,ee,De,Ke){super(L,ee),this.canIncreaseHover=De,this.canDecreaseHover=Ke}};e.$FM=fe,e.$FM=fe=Je([k],fe);var Q;(function(B){B[B.Increase=0]="Increase",B[B.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var x;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(x||(e.DocumentHighlightKind=x={}));let le=class{constructor(L,ee=x.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:x[this.kind]}}};e.$GM=le,e.$GM=le=Je([k],le);let ae=class{constructor(L,ee){this.uri=L,this.highlights=ee}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$HM=ae,e.$HM=ae=Je([k],ae);var Fe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Fe||(e.SymbolKind=Fe={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Pe=w=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ee,De,Ke,Ye){this.name=L,this.kind=ee,this.containerName=Ye,typeof De=="string"&&(this.containerName=De),Ke instanceof pe?this.location=Ke:De instanceof q&&(this.location=new pe(Ke,De)),w.validate(this)}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};e.$IM=Pe,e.$IM=Pe=w=Je([k],Pe);let Ae=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(a.validate)}constructor(L,ee,De,Ke,Ye){this.name=L,this.detail=ee,this.kind=De,this.range=Ke,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$JM=Ae,e.$JM=Ae=a=Je([k],Ae);var je;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let j=class{constructor(L,ee){this.title=L,this.kind=ee}};e.$KM=j,e.$KM=j=Je([k],j);let z=class{static{l=this}static{this.c="."}constructor(L){this.value=L}append(L){return new l(this.value?this.value+l.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+l.c)}};e.$LM=z,e.$LM=z=l=Je([k],z),z.Empty=new z(""),z.QuickFix=z.Empty.append("quickfix"),z.Refactor=z.Empty.append("refactor"),z.RefactorExtract=z.Refactor.append("extract"),z.RefactorInline=z.Refactor.append("inline"),z.RefactorMove=z.Refactor.append("move"),z.RefactorRewrite=z.Refactor.append("rewrite"),z.Source=z.Empty.append("source"),z.SourceOrganizeImports=z.Source.append("organizeImports"),z.SourceFixAll=z.Source.append("fixAll"),z.Notebook=z.Empty.append("notebook");let G=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$MM=G,e.$MM=G=Je([k],G);class H{constructor(L,ee,De,Ke,Ye,lt){this.kind=L,this.name=ee,this.detail=De,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$NM=H;class te{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.$OM=te;class ne{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.$PM=ne;var Oe;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Be=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};e.$QM=Be,e.$QM=Be=Je([k],Be);let He=g=class{#e;static isMarkdownString(L){return L instanceof g?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ee=!1){this.#e=new R.$Xk(L,{supportThemeIcons:ee})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,ee){return this.#e.appendCodeblock(ee??"",L),this}};e.$RM=He,e.$RM=He=g=Je([k],He);let _e=class{constructor(L,ee){this.label=L,this.documentation=ee}};e.$SM=_e,e.$SM=_e=Je([k],_e);let xe=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};e.$TM=xe,e.$TM=xe=Je([k],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$UM=et,e.$UM=et=Je([k],et);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let at=class{constructor(L){this.value=L}};e.$VM=at,e.$VM=at=Je([k],at);let mt=class{constructor(L,ee,De){this.position=L,this.label=ee,this.kind=De}};e.$WM=mt,e.$WM=mt=Je([k],mt);var Ue;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var rt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(rt||(e.CompletionItemKind=rt={}));var Y;(function(B){B[B.Deprecated=1]="Deprecated"})(Y||(e.CompletionItemTag=Y={}));let Z=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$XM=Z,e.$XM=Z=Je([k],Z);let me=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};e.$YM=me,e.$YM=me=Je([k],me);let Ge=class{constructor(L,ee,De){this.insertText=L,this.range=ee,this.command=De}};e.$ZM=Ge,e.$ZM=Ge=Je([k],Ge);let be=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$1M=be,e.$1M=be=Je([k],be);var st;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var dt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Pt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Pt||(e.StatusBarAlignment=Pt={}));function Vt(B,L){return`${S.$Vm.toKey(B)}.${L}`}var Qt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var ii;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ii||(e.TextDocumentSaveReason=ii={}));var Xt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var Et;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Zt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Yt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(B){function L(ee){switch(ee){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=L}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Ze;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(B){function L(ee){switch(ee){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=L}(Ze||(e.SyntaxTokenType=Ze={}));let si=class{constructor(L,ee){if(ee&&!D.URI.isUri(ee))throw(0,O.$7)("target");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.target=ee}};e.$3M=si,e.$3M=si=Je([k],si);let Ht=class{constructor(L,ee,De,Ke){this.red=L,this.green=ee,this.blue=De,this.alpha=Ke}};e.$4M=Ht,e.$4M=Ht=Je([k],Ht);let ht=class{constructor(L,ee){if(ee&&!(ee instanceof Ht))throw(0,O.$7)("color");if(!q.isRange(L)||L.isEmpty)throw(0,O.$7)("range");this.range=L,this.color=ee}};e.$5M=ht,e.$5M=ht=Je([k],ht);let ft=class{constructor(L){if(!L||typeof L!="string")throw(0,O.$7)("label");this.label=L}};e.$6M=ft,e.$6M=ft=Je([k],ft);var xt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Kt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Ft;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Ft||(e.TerminalExitReason=Ft={}));var gt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class Bt{constructor(L,ee,De){if(this.startIndex=L,this.length=ee,this.tooltip=De,typeof L!="number"||L<0)throw(0,O.$7)("startIndex");if(typeof ee!="number"||ee<1)throw(0,O.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,O.$7)("tooltip")}}e.$7M=Bt;class _t{constructor(L){this.uri=L}}e.$8M=_t;class zt{constructor(L){this.terminalCommand=L}}e.$9M=zt;var Qe;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ui{constructor(L){if(this.options=L,typeof L!="object")throw(0,O.$7)("options")}}e.$0M=ui;var Jt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var Ut;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Ut||(e.TaskPanelKind=Ut={}));let wt=class{static{$=this}static{this.Clean=new $("clean","Clean")}static{this.Build=new $("build","Build")}static{this.Rebuild=new $("rebuild","Rebuild")}static{this.Test=new $("test","Test")}static from(L){switch(L){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(L,ee){if(this.label=ee,typeof L!="string"||typeof ee!="string")throw(0,O.$7)("name");this.c=L}get id(){return this.c}};e.$$M=wt,e.$$M=wt=$=Je([k],wt);function jt(B){let L="";for(let ee=0;ee<B.length;ee++)L+=B[ee].replace(/,/g,",,")+",";return L}let Rt=class{constructor(L,ee,De){if(typeof L!="string")throw(0,O.$7)("process");this.e=[],this.c=L,ee!==void 0&&(Array.isArray(ee)?(this.e=ee,this.f=De):this.f=ee)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,O.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const ee of this.e)L.push(ee);return jt(L)}};e.$_M=Rt,e.$_M=Rt=Je([k],Rt);let Mt=class{constructor(L,ee,De){if(this.f=[],Array.isArray(ee)){if(!L)throw(0,O.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L,this.f=ee,this.g=De}else{if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L,this.g=ee}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,O.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,O.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ee of this.f)L.push(typeof ee=="string"?ee:ee.value);return jt(L)}};e.$aN=Mt,e.$aN=Mt=Je([k],Mt);var ei;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ei||(e.ShellQuoting=ei={}));var Wt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Wt||(e.TaskScope=Wt={}));class oi{constructor(L){this.c=L}computeId(){return"customExecution"+(0,N.$Wg)()}set callback(L){this.c=L}get callback(){return this.c}}e.$bN=oi;let Ot=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,ee,De,Ke,Ye,lt){this.k=!1,this.l=this.definition=L;let pt;typeof ee=="string"?(this.o=this.name=ee,this.w=this.source=De,this.execution=Ke,pt=Ye,this.k=!0):ee===Wt.Global||ee===Wt.Workspace?(this.target=ee,this.o=this.name=De,this.w=this.source=Ke,this.execution=Ye,pt=lt):(this.target=ee,this.o=this.name=De,this.w=this.source=Ke,this.execution=Ye,pt=lt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Rt?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,N.$Wg)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,O.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const ee=this.l.type;(b.g===ee||b.e===ee||b.f===ee||b.c===ee)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$cN=Ot,e.$cN=Ot=b=Je([k],Ot);var qt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(qt||(e.ProgressLocation=qt={}));var At;(function(B){function L(ee){const De=ee;return(0,m.$eg)(De.value)?De.tooltip&&!(0,m.$ag)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=L})(At||(e.ViewBadge=At={}));let St=y=class{static isTreeItem(L,ee){const De=L;if(De.checkboxState!==void 0){const Ke=(0,m.$eg)(De.checkboxState)?De.checkboxState:(0,m.$cg)(De.checkboxState)&&(0,m.$eg)(De.checkboxState.state)?De.checkboxState.state:void 0,Ye=!(0,m.$eg)(De.checkboxState)&&(0,m.$cg)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Dt.Checked&&Ke!==Dt.Unchecked||Ye!==void 0&&!(0,m.$ag)(Ye))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(L instanceof y)return!0;if(De.label!==void 0&&!(0,m.$ag)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,m.$ag)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,m.$ag)(De.iconPath)&&!D.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,m.$ag)(De.iconPath.id))){const Ke=De.iconPath;if(!Ke||!(0,m.$ag)(Ke.light)&&!D.URI.isUri(Ke.light)&&!(0,m.$ag)(Ke.dark)&&!D.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,m.$ag)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!D.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,m.$ag)(De.tooltip)&&!(De.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<$t.None&&De.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,m.$ag)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(L,ee=$t.None){this.collapsibleState=ee,D.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$dN=St,e.$dN=St=y=Je([k],St);var $t;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Dt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$eN=ai,e.$eN=ai=Je([k],ai);class kt extends ai{}e.$fN=kt;class fi extends kt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$gN=fi;class ni{constructor(L,ee,De,Ke){this.name=L,this.uri=ee,this._itemId=De,this.c=Ke}data(){return this.c()}}e.$hN=ni;let $i=class{#e=new Map;constructor(L){for(const[ee,De]of L??[]){const Ke=this.#e.get(this.#t(ee));Ke?Ke.push(De):this.#e.set(this.#t(ee),[De])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,ee){this.#e.set(this.#t(L),[ee])}forEach(L,ee){for(const[De,Ke]of this.#e)for(const Ye of Ke)L.call(ee,Ye,De,this)}*[Symbol.iterator](){for(const[L,ee]of this.#e)for(const De of ee)yield[L,De]}#t(L){return L.toLowerCase()}};e.$iN=$i,e.$iN=$i=Je([k],$i);let li=class{constructor(L,ee,De){this.insertText=L,this.title=ee,this.kind=De}};e.$jN=li,e.$jN=li=Je([k],li);var bi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(bi||(e.DocumentPasteTriggerKind=bi={}));class It{static{this.c="."}constructor(L){this.value=L}append(...L){return new It((this.value?[this.value,...L]:L).join(It.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+It.c)}}e.$kN=It,It.Empty=new It("");class Ei{constructor(L,ee,De){this.title=ee,this.insertText=L,this.kind=De}}e.$lN=Ei;let ri=class{constructor(L,ee){this.id=L,this.color=ee}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$mN=ri,e.$mN=ri=Je([k],ri),ri.File=new ri("file"),ri.Folder=new ri("folder");let we=class{constructor(L){this.id=L}};e.$nN=we,e.$nN=we=Je([k],we);var Me;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Me||(e.ConfigurationTarget=Me={}));let oe=class{get base(){return this.c}set base(L){this.c=L,this.e=D.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,ee){if(typeof L!="string"&&(!L||!D.URI.isUri(L)&&!D.URI.isUri(L.uri)))throw(0,O.$7)("base");if(typeof ee!="string")throw(0,O.$7)("pattern");typeof L=="string"?this.baseUri=D.URI.file(L):D.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ee}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$oN=oe,e.$oN=oe=Je([k],oe);const J=new WeakMap;function Re(B,L){J.set(B,L)}let Ve=class{constructor(L,ee,De,Ke,Ye){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=J.get(this)??(0,N.$Wg)()),this.c}};e.$qN=Ve,e.$qN=Ve=Je([k],Ve);let Xe=class extends Ve{constructor(L,ee,De,Ke,Ye,lt){if(super(ee,De,Ke,Ye,lt),L===null)throw(0,O.$7)("location");this.location=L}};e.$rN=Xe,e.$rN=Xe=Je([k],Xe);let qe=class extends Ve{constructor(L,ee,De,Ke,Ye,lt){super(ee,De,Ke,Ye,lt),this.functionName=L}};e.$sN=qe,e.$sN=qe=Je([k],qe);let ut=class extends Ve{constructor(L,ee,De,Ke,Ye,lt,pt,Gt){if(super(Ke,Ye,lt,pt,Gt),!ee)throw(0,O.$7)("dataId");this.label=L,this.dataId=ee,this.canPersist=De}};e.$tN=ut,e.$tN=ut=Je([k],ut);let yt=class{constructor(L,ee,De){this.command=L,this.args=ee||[],this.options=De}};e.$uN=yt,e.$uN=yt=Je([k],yt);let Tt=class{constructor(L,ee){this.port=L,this.host=ee}};e.$vN=Tt,e.$vN=Tt=Je([k],Tt);let ct=class{constructor(L){this.path=L}};e.$wN=ct,e.$wN=ct=Je([k],ct);let Nt=class{constructor(L){this.implementation=L}};e.$xN=Nt,e.$xN=Nt=Je([k],Nt);class Lt{constructor(L,ee,De){this.session=L,this.threadId=ee,this.frameId=De}}e.$yN=Lt;class Di{constructor(L,ee){this.session=L,this.threadId=ee}}e.$zN=Di;let Ii=class{constructor(L,ee){this.range=L,this.expression=ee}};e.$AN=Ii,e.$AN=Ii=Je([k],Ii);var Ji;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let Oi=class{constructor(L,ee){this.range=L,this.text=ee}};e.$BN=Oi,e.$BN=Oi=Je([k],Oi);let Ni=class{constructor(L,ee,De=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=De}};e.$CN=Ni,e.$CN=Ni=Je([k],Ni);let Ci=class{constructor(L,ee){this.range=L,this.expression=ee}};e.$DN=Ci,e.$DN=Ci=Je([k],Ci);let Fi=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};e.$EN=Fi,e.$EN=Fi=Je([k],Fi);var Ti;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ti||(e.NewSymbolNameTag=Ti={}));var Qi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Qi||(e.NewSymbolNameTriggerKind=Qi={}));class Li{constructor(L,ee){this.newSymbolName=L,this.tags=ee}}e.$FN=Li;var Pi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let zi=h=class extends Error{static FileExists(L){return new h(L,d.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(L){return new h(L,d.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(L){return new h(L,d.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(L){return new h(L,d.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(L){return new h(L,d.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(L){return new h(L,d.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(L,ee=d.FileSystemProviderErrorCode.Unknown,De){super(D.URI.isUri(L)?L.toString(!0):L),this.code=De?.name??"Unknown",(0,d.$jl)(this,ee),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$GN=zi,e.$GN=zi=h=Je([k],zi);let Ui=class{constructor(L,ee,De){this.start=L,this.end=ee,this.kind=De}};e.$HN=Ui,e.$HN=Ui=Je([k],Ui);var vi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var Xi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Xi||(e.CommentThreadCollapsibleState=Xi={}));var Zi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Ri;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ri||(e.CommentState=Ri={}));var Yi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));var ji;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(ji||(e.CommentThreadApplicability=ji={}));class gn{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.$IN=gn;function xi(B){return typeof B>"u"||(0,m.$bg)(B)}class Bi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let ee=0,De=L.tokenTypes.length;ee<De;ee++)this.k.set(L.tokenTypes[ee],ee);for(let ee=0,De=L.tokenModifiers.length;ee<De;ee++)this.l.set(L.tokenModifiers[ee],ee)}}push(L,ee,De,Ke,Ye){if(typeof L=="number"&&typeof ee=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(L,ee,De,Ke,Ye);if(q.isRange(L)&&typeof ee=="string"&&xi(De))return this.o(L,ee,De);throw(0,O.$7)()}o(L,ee,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,Ye=L.start.character,lt=L.end.character-L.start.character,pt=this.k.get(ee);let Gt=0;if(De)for(const ci of De){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(ci);Gt|=1<<di>>>0}this.q(Ke,Ye,lt,pt,Gt)}q(L,ee,De,Ke,Ye){if(this.f&&(L<this.c||L===this.c&&ee<this.e)){this.f=!1;const Gt=this.g.length/5|0;let ci=0,di=0;for(let mi=0;mi<Gt;mi++){let wi=this.g[5*mi],Hi=this.g[5*mi+1];wi===0?(wi=ci,Hi+=di):wi+=ci,this.g[5*mi]=wi,this.g[5*mi+1]=Hi,ci=wi,di=Hi}}let lt=L,pt=ee;this.f&&this.j>0&&(lt-=this.c,lt===0&&(pt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=pt,this.g[this.j++]=De,this.g[this.j++]=Ke,this.g[this.j++]=Ye,this.c=L,this.e=ee}static r(L){const ee=[],De=L.length/5|0;for(let pt=0;pt<De;pt++)ee[pt]=pt;ee.sort((pt,Gt)=>{const ci=L[5*pt],di=L[5*Gt];if(ci===di){const mi=L[5*pt+1],wi=L[5*Gt+1];return mi-wi}return ci-di});const Ke=new Uint32Array(L.length);let Ye=0,lt=0;for(let pt=0;pt<De;pt++){const Gt=5*ee[pt],ci=L[Gt+0],di=L[Gt+1],mi=L[Gt+2],wi=L[Gt+3],Hi=L[Gt+4],zn=ci-Ye,wr=zn===0?di-lt:di,Ki=5*pt;Ke[Ki+0]=zn,Ke[Ki+1]=wr,Ke[Ki+2]=mi,Ke[Ki+3]=wi,Ke[Ki+4]=Hi,Ye=ci,lt=di}return Ke}build(L){return this.f?new pi(new Uint32Array(this.g),L):new pi(Bi.r(this.g),L)}}e.$JN=Bi;class pi{constructor(L,ee){this.resultId=ee,this.data=L}}e.$KN=pi;class mn{constructor(L,ee,De){this.start=L,this.deleteCount=ee,this.data=De}}e.$LN=mn;class $n{constructor(L,ee){this.resultId=ee,this.edits=L}}e.$MN=$n;var _i;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class Vi{constructor(L){this.name=L}}e.$NN=Vi;let Ai=class{static{this.Back={iconPath:new ri("arrow-left")}}constructor(){}};e.$ON=Ai,e.$ON=Ai=Je([k],Ai);var ze;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var hi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(hi||(e.InputBoxValidationSeverity=hi={}));var Wi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Wi||(e.ExtensionKind=Wi={}));class nt{static validate(L){if(typeof L.badge=="string"){let ee=(0,p.$Lf)(L.badge,0);if(ee<L.badge.length&&(ee+=(0,p.$Lf)(L.badge,ee)),L.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!ri.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ee,De){this.badge=L,this.tooltip=ee,this.color=De}}e.$PN=nt;let bt=class{constructor(L){this.kind=L}};e.$QN=bt,e.$QN=bt=Je([k],bt);var en;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class gi{static isNotebookRange(L){return L instanceof gi?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,ee){if(L<0)throw(0,O.$7)("start must be positive");if(ee<0)throw(0,O.$7)("end must be positive");L<=ee?(this.c=L,this.e=ee):(this.c=ee,this.e=L)}with(L){let ee=this.c,De=this.e;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(De=L.end),ee===this.c&&De===this.e?this:new gi(ee,De)}}e.$RN=gi;class ki{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>ki.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}constructor(L,ee,De,Ke,Ye,lt,pt){this.kind=L,this.value=ee,this.languageId=De,this.mime=Ke,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=pt,ki.validate(this)}}e.$SN=ki;class pn{constructor(L){this.cells=L}}e.$TN=pn;class ti{static isNotebookCellOutputItem(L){return L instanceof ti?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ee={name:L.name,message:L.message,stack:L.stack};return ti.json(ee,"application/vnd.code.notebook.error")}static stdout(L){return ti.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return ti.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ee="application/octet-stream"){return new ti(L,ee)}static#e=new TextEncoder;static text(L,ee=M.$Ws.text){const De=ti.#e.encode(String(L));return new ti(De,ee)}static json(L,ee="text/x-json"){const De=JSON.stringify(L,void 0,"	");return ti.text(De,ee)}constructor(L,ee){this.data=L,this.mime=ee;const De=(0,M.$1s)(ee,!0);if(!De)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$UN=ti;class Mi{static isNotebookCellOutput(L){return L instanceof Mi?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ee=!1){const De=new Set,Ke=new Set;for(let Ye=0;Ye<L.length;Ye++){const lt=L[Ye],pt=(0,M.$1s)(lt.mime);if(!De.has(pt)||(0,f.$jK)(pt)){De.add(pt);continue}Ke.add(Ye),ee&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?L:L.filter((Ye,lt)=>!Ke.has(lt))}constructor(L,ee,De){this.items=Mi.ensureUniqueMimeTypes(L,!0),typeof ee=="string"?(this.id=ee,this.metadata=De):(this.id=(0,N.$Wg)(),this.metadata=ee??De)}}e.$VN=Mi;var tn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var qi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(qi||(e.NotebookCellStatusBarAlignment=qi={}));var rn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class wn{constructor(L,ee){this.text=L,this.alignment=ee}}e.$WN=wn;var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class bn{constructor(L,ee=[]){this.uri=L,this.provides=(0,C.$2b)(ee)}}e.$XN=bn;class vn{constructor(L){this.label=L}}e.$YN=vn;var an;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let Gi=class{constructor(L,ee){this.label=L,this.timestamp=ee}};e.$ZN=Gi,e.$ZN=Gi=Je([k],Gi);var cn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class _{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.$1N=_;class se{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$2N=se;var Le;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Le||(e.TestResultState=Le={}));var ot;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ot||(e.TestRunProfileKind=ot={}));let vt=class{constructor(L=void 0,ee=void 0,De=void 0,Ke=!1,Ye=!0){this.include=L,this.exclude=ee,this.profile=De,this.continuous=Ke,this.preserveFocus=Ye}};e.$3N=vt,e.$3N=vt=Je([k],vt);let Ct=E=class{static diff(L,ee,De){const Ke=new E(L);return Ke.expectedOutput=ee,Ke.actualOutput=De,Ke}constructor(L){this.message=L}};e.$4N=Ct,e.$4N=Ct=E=Je([k],Ct);let Si=class{constructor(L){this.id=L}};e.$5N=Si,e.$5N=Si=Je([k],Si);class hn{constructor(L,ee){this.covered=L,this.total=ee,En(this)}}e.$6N=hn;function En(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class yn{static fromDetails(L,ee){const De=new hn(0,0),Ke=new hn(0,0),Ye=new hn(0,0);for(const pt of ee)if("branches"in pt){De.total+=1,De.covered+=pt.executed?1:0;for(const Gt of pt.branches)Ke.total+=1,Ke.covered+=Gt.executed?1:0}else Ye.total+=1,Ye.covered+=pt.executed?1:0;const lt=new yn(L,De,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=ee,lt}constructor(L,ee,De,Ke,Ye){this.uri=L,this.statementCoverage=ee,this.branchCoverage=De,this.declarationCoverage=Ke,this.testItem=Ye}}e.$8N=yn;class Un{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ee,De=[]){this.executed=L,this.location=ee,this.branches=De}}e.$9N=Un;class jn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ee,De){this.executed=L,this.location=ee,this.label=De}}e.$0N=jn;class Bn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ee,De){this.name=L,this.executed=ee,this.location=De}}e.$$N=Bn;var Dn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Dn||(e.ExternalUriOpenerPriority=Dn={}));var kn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(kn||(e.WorkspaceTrustState=kn={}));var Sn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn||(e.PortAutoForwardAction=Sn={}));class Vn{constructor(L,ee,De,Ke,Ye,lt){this.kind=L,this.name=ee,this.detail=De,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$_N=Vn;class Wn{constructor(L){this.uri=L}}e.$aO=Wn;class qn{constructor(L,ee){this.original=L,this.modified=ee}}e.$bO=qn;class Gn{constructor(L,ee,De,Ke){this.base=L,this.input1=ee,this.input2=De,this.result=Ke}}e.$cO=Gn;class Hn{constructor(L,ee){this.uri=L,this.viewType=ee}}e.$dO=Hn;class Kn{constructor(L){this.viewType=L}}e.$eO=Kn;class Jn{constructor(L,ee){this.uri=L,this.notebookType=ee}}e.$fO=Jn;class Qn{constructor(L,ee,De){this.original=L,this.modified=ee,this.notebookType=De}}e.$gO=Qn;class Xn{constructor(){}}e.$hO=Xn;class Zn{constructor(L,ee){this.uri=L,this.inputBoxUri=ee}}e.$iO=Zn;class Yn{constructor(){}}e.$jO=Yn;class xn{constructor(L){this.textDiffs=L}}e.$kO=xn;var In;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(In||(e.InteractiveSessionVoteDirection=In={}));var Cn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var Pn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class _n{constructor(L,ee,De){this.id=L,this.label=ee,this.values=De}}e.$lO=_n;var Rn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(Rn||(e.InteractiveEditorResponseFeedbackKind=Rn={}));var An;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(An||(e.ChatResultFeedbackKind=An={}));class er{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new He(L):L}}e.$mO=er;class tr{constructor(L,ee){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new He(L):L,this.vulnerabilities=ee}}e.$nO=tr;class ir{constructor(L,ee){this.participant=L,this.command=ee}}e.$oO=ir;class nr{constructor(L,ee,De){this.title=L,this.message=ee,this.data=De}}e.$pO=nr;class rr{constructor(L,ee){this.value=L,this.baseUri=ee}}e.$qO=rr;class sr{constructor(L,ee){this.value=L,this.title=ee}}e.$rO=sr;class or{constructor(L){this.value=L}}e.$sO=or;class ar{constructor(L,ee){this.value=L,this.task=ee}}e.$tO=ar;class cr{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new He(L):L}}e.$uO=cr;class ur{constructor(L){this.value=L}}e.$vO=ur;class lr{constructor(L,ee){this.value=L,this.iconPath=ee}}e.$wO=lr;class hr{constructor(L,ee){this.uri=L,this.edits=Array.isArray(ee)?ee:[ee]}}e.$xO=hr;class dr{constructor(L,ee,De,Ke){this.prompt=L,this.command=ee,this.references=De,this.participant=Ke}}e.$yO=dr;class fr{constructor(L,ee,De,Ke){this.response=L,this.result=ee,this.participant=De,this.command=Ke}}e.$zO=fr;var Mn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(Mn||(e.ChatLocation=Mn={}));var dn;(function(B){B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.System=3]="System"})(dn||(e.LanguageModelChatMessageRole=dn={}));class fn{static User(L,ee){return new fn(dn.User,L,ee)}static Assistant(L,ee){return new fn(dn.Assistant,L,ee)}constructor(L,ee,De){this.role=L,this.content=ee,this.name=De}}e.$AO=fn;class gr{constructor(L){this.content=L}}e.$BO=gr;class mr{constructor(L,ee){this.content=L,this.name=ee}}e.$CO=mr;class $r{constructor(L,ee){this.content=L,this.name=ee}}e.$DO=$r;class yi extends Error{static NotFound(L){return new yi(L,yi.NotFound.name)}static NoPermissions(L){return new yi(L,yi.NoPermissions.name)}static Blocked(L){return new yi(L,yi.Blocked.name)}constructor(L,ee,De){super(L,{cause:De}),this.name="LanguageModelError",this.code=ee??""}}e.$EO=yi;var On;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(On||(e.RelatedInformationType=On={}));var Nn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Nn||(e.SpeechToTextStatus=Nn={}));var Fn;(function(B){B[B.Started=1]="Started",B[B.Stopped=2]="Stopped",B[B.Error=3]="Error"})(Fn||(e.TextToSpeechStatus=Fn={}));var Tn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Tn||(e.KeywordRecognitionStatus=Tn={}));class pr{constructor(L,ee){this.text=L,this.range=ee}}e.$FO=pr;var Ln;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Ln||(e.InlineEditTriggerKind=Ln={}))}),define(ke[258],Se([1,0,4,7]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(C.$nM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,m){if(this.a.size===0)throw new Error("No related information providers registered");const D=this.a.get(M);if(!D)throw new Error("related information provider not found");return await D.provideRelatedInformation(p,m)??[]}getRelatedInformation(M,p,m){return this.c.$getAiRelatedInformation(p,m)}registerRelatedInformationProvider(M,p,m){const D=this.b;return this.b++,this.a.set(D,m),this.c.$registerAiRelatedInformationProvider(D,p),new O.$pM(()=>{this.c.$unregisterAiRelatedInformationProvider(D),this.a.delete(D)})}}e.$emc=R}),define(ke[86],Se([1,0,5,4,7,21,108,3,17]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=e.$pmc=void 0,e.$pmc=(0,p.$Ai)("IExtHostAuthentication");let D=class{constructor(d){this.b=new Map,this.c=new C.$he,this.onDidChangeSessions=this.c.event,this.d=new N,this.f=new N,this.a=d.getProxy(O.$nM.MainThreadAuthentication)}async getSession(d,v,f,s={}){const r=F.$Vm.toKey(d.identifier),o=[...f].sort().join(" ");return await this.d.getOrCreate(`${r} ${v} ${o}`,async()=>{await this.a.$ensureProvider(v);const n=d.displayName||d.name;return this.a.$getSession(v,f,r,n,s)})}async getSessions(d,v,f){const s=F.$Vm.toKey(d.identifier),r=[...f].sort().join(" ");return await this.f.getOrCreate(`${s} ${r}`,async()=>{await this.a.$ensureProvider(v);const o=d.displayName||d.name;return this.a.$getSessions(v,f,s,o)})}async removeSession(d,v){const f=this.b.get(d);return f?f.provider.removeSession(v):this.a.$removeSession(d,v)}registerAuthenticationProvider(d,v,f,s){if(this.b.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this.b.set(d,{label:v,provider:f,options:s??{supportsMultipleAccounts:!1}});const r=f.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(d,o));return this.a.$registerAuthenticationProvider(d,v,s?.supportsMultipleAccounts??!1),new R.$pM(()=>{r.dispose(),this.b.delete(d),this.a.$unregisterAuthenticationProvider(d)})}async $createSession(d,v,f){const s=this.b.get(d);if(s)return await s.provider.createSession(v,f);throw new Error(`Unable to find authentication provider with handle: ${d}`)}async $removeSession(d,v){const f=this.b.get(d);if(f)return await f.provider.removeSession(v);throw new Error(`Unable to find authentication provider with handle: ${d}`)}async $getSessions(d,v){const f=this.b.get(d);if(f)return await f.provider.getSessions(v);throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,v){return d.startsWith(M.$pL)||this.c.fire({provider:{id:d,label:v}}),Promise.resolve()}};e.$qmc=D,e.$qmc=D=Je([We(0,m.$RO)],D);class N{constructor(){this.a=new Map}getOrCreate(d,v){const f=this.a.get(d);if(f)return f;const s=v().finally(()=>this.a.delete(d));return this.a.set(d,s),s}}}),define(ke[112],Se([1,0,2,4,7,3,17,12,18,13,19,25]),function(he,e,C,O,R,F,M,p,m,D,N,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=e.$pnc=void 0;let v=class{static{d=this}static{this.c=0}static{this.d=250}constructor(s,r){this.h=r,this.f=new Map,this.g=s.getProxy(O.$nM.MainThreadDecorations)}registerFileDecorationProvider(s,r){const o=d.c++;this.f.set(o,{provider:s,extensionDescription:r}),this.g.$registerDecorationProvider(o,r.identifier.value);const n=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(o,null);return}const c=(0,m.$2b)(t);if(c.length<=d.d){this.g.$onDidChange(o,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",r.identifier.value,c.length);const u=c.map(a=>({uri:a,rank:(0,D.$ef)(a.path,"/")})),i=(0,m.$zb)(u,(a,l)=>a.rank-l.rank||(0,D.$uf)(a.uri.path,l.uri.path)),w=[];e:for(const a of i){let l;for(const g of a){const $=(0,N.$mc)(g.uri.path);if(l!==$&&(l=$,w.push(g.uri)>=d.d))break e}}this.g.$onDidChange(o,w)});return new R.$pM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(s,r,o){if(!this.f.has(s))return Object.create(null);const n=Object.create(null),{provider:t,extensionDescription:c}=this.f.get(s);return await Promise.all(r.map(async u=>{try{const{uri:i,id:w}=u,a=await Promise.resolve(t.provideFileDecoration(C.URI.revive(i),o));if(!a)return;try{R.$PN.validate(a),a.badge&&typeof a.badge!="string"&&(0,S.$OG)(c,"codiconDecoration"),n[w]=[a.propagate,a.tooltip,a.badge,a.color]}catch(l){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${l}`)}}catch(i){this.h.error(i)}})),n}};e.$pnc=v,e.$pnc=v=d=Je([We(0,M.$RO),We(1,p.$7j)],v),e.$qnc=(0,F.$Ai)("IExtHostDecorations")}),define(ke[259],Se([1,0,14,2,7,4,16,20,13]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=void 0;class D{static{this.a=0}constructor(S,d,v){this.d=d,this.e=v,this.b=new Map,this.c=S.getProxy(F.$nM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,d){if(Object.keys(M.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const v=D.a++;this.b.set(v,d),this.c.$registerTextContentProvider(v,S);let f;if(typeof d.onDidChange=="function"){let s;f=d.onDidChange(async r=>{if(r.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${r.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(r))return;s&&await s;const o=this.$provideTextDocumentContent(v,r).then(async n=>{if(!n&&typeof n!="string")return;const t=this.d.getDocument(r);if(!t)return;const c=(0,m.$of)(n);if(!t.equalLines(c))return this.c.$onVirtualDocumentChange(r,n)}).catch(C.$1).finally(()=>{s===o&&(s=void 0)});s=o})}return new R.$pM(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(S,d){const v=this.b.get(S);return v?Promise.resolve(v.provideTextDocumentContent(O.URI.revive(d),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.$snc=D}),define(ke[113],Se([1,0,57,16,13,313,159,7,18]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=void 0,e.$TO=N;const D=new Map;function N(f,s){s?D.set(f,s):D.delete(f)}function S(f){return D.get(f)}class d extends F.$_v{constructor(s,r,o,n,t,c,u){super(r,o,n,t),this.c=s,this.m=c,this.q=u,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,m.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===O.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(r){return r?s.s(r):s.getText()},get eol(){return s.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(r){return s.t(r)},offsetAt(r){return s.u(r)},positionAt(r){return s.v(r)},validateRange(r){return s.w(r)},validatePosition(r){return s.x(r)},getWordRangeAtPosition(r,o){return s.y(r,o)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,C.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,C.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const r=this.w(s);if(r.isEmpty)return"";if(r.isSingleLine)return this.f[r.start.line].substring(r.start.character,r.end.character);const o=this.g,n=r.start.line,t=r.end.line,c=[];c.push(this.f[n].substring(r.start.character));for(let u=n+1;u<t;u++)c.push(this.f[u]);return c.push(this.f[t].substring(0,r.end.character)),c.join(o)}t(s){let r;if(s instanceof p.$qM?r=s.line:typeof s=="number"&&(r=s),typeof r!="number"||r<0||r>=this.f.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new v(r,this.f[r],r===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const r=this.j.getIndexOf(s),o=this.f[r.index].length;return new p.$qM(r.index,Math.min(r.remainder,o))}w(s){if(!(s instanceof p.$rM))throw new Error("Invalid argument");const r=this.x(s.start),o=this.x(s.end);return r===s.start&&o===s.end?s:new p.$rM(r.line,r.character,o.line,o.character)}x(s){if(!(s instanceof p.$qM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:r,character:o}=s,n=!1;if(r<0)r=0,o=0,n=!0;else if(r>=this.f.length)r=this.f.length-1,o=this.f[r].length,n=!0;else{const t=this.f[r].length;o<0?(o=0,n=!0):o>t&&(o=t,n=!0)}return n?new p.$qM(r,o):s}y(s,r){const o=this.x(s);if(!r)r=S(this.m);else if((0,R.$nf)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const n=(0,M.$ct)(o.character+1,(0,M.$at)(r),this.f[o.line],0);if(n)return new p.$rM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$UO=d;class v{constructor(s,r,o){this.a=s,this.b=r,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$rM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$rM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$VO=v}),define(ke[260],Se([1,0,4,7]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(C.$nM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const D=this.a.get(M);if(!D)throw new Error("Embedding vector provider not found");const N=await D.provideEmbeddingVector(p,m);if(!N)throw new Error("Embedding vector provider returned undefined");return N}registerEmbeddingVectorProvider(M,p,m){const D=this.b;return this.b++,this.a.set(D,m),this.c.$registerAiEmbeddingVectorProvider(p,D),new O.$pM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(D),this.a.delete(D)})}}e.$vnc=R}),define(ke[65],Se([1,0,4,38,7,22,3,17,47,6,11,24,16]),function(he,e,C,O,R,F,M,p,m,D,N,S,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gmc=e.$Fmc=void 0;let f=v=class{constructor(r,o){this.b=new Map,this.c=new N.$Jh,this.a=r.getProxy(C.$nM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(t){try{let c;const u=n.b.get(t.scheme);return u?(await n.a.$ensureActivation(t.scheme),c=await u.impl.stat(t)):c=await n.a.$stat(t),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===O.FilePermission.Readonly?1:void 0}}catch(c){v.e(c)}},async readDirectory(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readDirectory(t)).slice()):await n.a.$readdir(t)}catch(c){return v.e(c)}},async createDirectory(t){try{const c=n.b.get(t.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(c.impl,c.extUri,t)):await n.a.$mkdir(t)}catch(c){return v.e(c)}},async readFile(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readFile(t)).slice()):(await n.a.$readFile(t)).buffer}catch(c){return v.e(c)}},async writeFile(t,c){try{const u=n.b.get(t.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(u.impl,u.extUri,u.extUri.dirname(t)),await n.c.queueFor(t,()=>Promise.resolve(u.impl.writeFile(t,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(t,F.$Je.wrap(c))}catch(u){return v.e(u)}},async delete(t,c){try{const u=n.b.get(t.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(t.scheme),await u.impl.delete(t,{recursive:!1,...c})):await n.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return v.e(u)}},async rename(t,c,u){try{return await n.a.$rename(t,c,{overwrite:!1,...u})}catch(i){return v.e(i)}},async copy(t,c,u){try{return await n.a.$copy(t,c,{overwrite:!1,...u})}catch(i){return v.e(i)}},isWritableFileSystem(t){const c=o.getCapabilities(t);if(typeof c=="number")return!(c&2048)}})}async d(r,o,n){const t=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await r.stat(n)).type&O.FileType.Directory))throw R.$GN.FileExists(`Unable to create folder '${n.scheme===d.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(O.$kl(c)!==O.FileSystemProviderErrorCode.FileNotFound)throw c;t.push(o.basename(n)),n=o.dirname(n)}for(let c=t.length-1;c>=0;c--){n=o.joinPath(n,t[c]);try{await r.createDirectory(n)}catch(u){if(O.$kl(u)!==O.FileSystemProviderErrorCode.FileExists)throw u}}}static e(r){if(r instanceof R.$GN)throw r;if(r instanceof O.$gl)switch(r.code){case O.FileSystemProviderErrorCode.FileExists:throw R.$GN.FileExists(r.message);case O.FileSystemProviderErrorCode.FileNotFound:throw R.$GN.FileNotFound(r.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw R.$GN.FileNotADirectory(r.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw R.$GN.FileIsADirectory(r.message);case O.FileSystemProviderErrorCode.NoPermissions:throw R.$GN.NoPermissions(r.message);case O.FileSystemProviderErrorCode.Unavailable:throw R.$GN.Unavailable(r.message);default:throw new R.$GN(r.message,r.name)}if(!(r instanceof Error))throw new R.$GN(String(r));if(r.name==="ENOPRO"||r.message.includes("ENOPRO"))throw R.$GN.Unavailable(r.message);switch(r.name){case O.FileSystemProviderErrorCode.FileExists:throw R.$GN.FileExists(r.message);case O.FileSystemProviderErrorCode.FileNotFound:throw R.$GN.FileNotFound(r.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw R.$GN.FileNotADirectory(r.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw R.$GN.FileIsADirectory(r.message);case O.FileSystemProviderErrorCode.NoPermissions:throw R.$GN.NoPermissions(r.message);case O.FileSystemProviderErrorCode.Unavailable:throw R.$GN.Unavailable(r.message);default:throw new R.$GN(r.message,r.name)}}addFileSystemProvider(r,o,n){return this.b.set(r,{impl:o,extUri:n?.isCaseSensitive?S.$4g:S.$6g,isReadonly:!!n?.isReadonly}),(0,D.$Sc)(()=>this.b.delete(r))}getFileSystemProviderExtUri(r){return this.b.get(r)?.extUri??S.$4g}};e.$Fmc=f,e.$Fmc=f=v=Je([We(0,p.$RO),We(1,m.$jmc)],f),e.$Gmc=(0,M.$Ai)("IExtHostConsumerFileSystem")}),define(ke[87],Se([1,0,3,27,12,65,2]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=e.$Hmc=void 0,e.$Hmc=(0,C.$Ai)("IExtensionStoragePaths");let p=class{constructor(D,N,S){this.d=N,this.f=S,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(d=>this.c=d)}async g(D){return M.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,N=await this.g(D);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(M.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(D){if(this.c)return M.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return M.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Imc=p,e.$Imc=p=Je([We(0,O.$8O),We(1,R.$7j),We(2,F.$Gmc)],p)}),define(ke[261],Se([1,0,7,17,5]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=void 0;let F=class{constructor(p){this.a=new C.$QN(C.ColorThemeKind.Dark),this.b=new R.$he}get activeColorTheme(){return this.a}$onColorThemeChange(p){let m;switch(p){case"light":m=C.ColorThemeKind.Light;break;case"hcDark":m=C.ColorThemeKind.HighContrast;break;case"hcLight":m=C.ColorThemeKind.HighContrastLight;break;default:m=C.ColorThemeKind.Dark}this.a=new C.$QN(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$doc=F,e.$doc=F=Je([We(0,O.$RO)],F)}),define(ke[88],Se([1,0,20,5,6,182,3,12,211,4,27,17,7]),function(he,e,C,O,R,F,M,p,m,D,N,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aEb=e.$_Db=e.TunnelDtoConverter=void 0;class v extends m.$yw{}var f;(function(r){function o(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:t.protocol}}r.fromApiTunnel=o;function n(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==m.TunnelPrivacyId.ConstantPrivate&&t.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}r.fromServiceTunnel=n})(f||(e.TunnelDtoConverter=f={})),e.$_Db=(0,M.$Ai)("IExtHostTunnelService");let s=class extends R.$Uc{constructor(o,n,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$he,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(D.$nM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const t=await this.a.$openTunnel(n,o.displayName);if(t){const c=new v(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,t),new d.$pM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(o,n,t,c,u){const i=[];for(const a of o){const l=this.r.get(a);if(!l)return[];i.push(...await Promise.all(n.map(async g=>{let $;try{$=await l.provider.providePortAttributes({port:g,pid:t,commandLine:c},u)}catch{$=await l.provider.providePortAttributes(g,t,c,u)}return{providedAttributes:$,port:g}})))}const w=i.filter(a=>!!a.providedAttributes);return w.length>0?w.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,u)=>await o.provideTunnel(c,u,C.CancellationToken.None)??void 0;const t=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,R.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const t=o.tunnelFactory??(n?this.w(n):void 0);if(t){this.b=t;let c=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const u=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,R.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const t=this.g.get(o.host);t.has(o.port)&&(n&&t.get(o.port).disposeListener.dispose(),await t.get(o.port).tunnel.dispose(),t.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const c=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const u=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:c,disposeListener:u}),f.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(c=>this.f(c.host,c.port,c.detail??""))),t=o.filter((c,u)=>n[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(c=>c.port).join(", ")} to ${t.map(c=>c.port).join(", ")}`),t}};e.$aEb=s,e.$aEb=s=Je([We(0,S.$RO),We(1,N.$8O),We(2,p.$7j)],s)}),define(ke[8],Se([1,0,18,22,138,262,55,28,127,45,70,26,133,24,36,15,2,30,89,101,107,106,224,85,52,62,235,7]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c,u,i,w,a,l,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$OO=K,e.$PO=ce,e.$QO=ve;var b;(function(we){function Me(J){const{selectionStartLineNumber:Re,selectionStartColumn:Ve,positionLineNumber:Xe,positionColumn:qe}=J,ut=new $.$qM(Re-1,Ve-1),yt=new $.$qM(Xe-1,qe-1);return new $.$sM(ut,yt)}we.to=Me;function oe(J){const{anchor:Re,active:Ve}=J;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}we.from=oe})(b||(e.Selection=b={}));var y;(function(we){function Me(J){if(!J)return;const{start:Re,end:Ve}=J;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}we.from=Me;function oe(J){if(!J)return;const{startLineNumber:Re,startColumn:Ve,endLineNumber:Xe,endColumn:qe}=J;return new $.$rM(Re-1,Ve-1,Xe-1,qe-1)}we.to=oe})(y||(e.Range=y={}));var h;(function(we){function Me(J){return{uri:J.uri,range:y.from(J.range)}}we.from=Me;function oe(J){return new $.$BM(r.URI.revive(J.uri),y.to(J.range))}we.to=oe})(h||(e.Location=h={}));var E;(function(we){function Me(oe){switch(oe){case 1:return $.StandardTokenType.Comment;case 0:return $.StandardTokenType.Other;case 3:return $.StandardTokenType.RegEx;case 2:return $.StandardTokenType.String}}we.to=Me})(E||(e.TokenType=E={}));var k;(function(we){function Me(J){return new $.$qM(J.lineNumber-1,J.column-1)}we.to=Me;function oe(J){return{lineNumber:J.line+1,column:J.character+1}}we.from=oe})(k||(e.Position=k={}));var I;(function(we){function Me(Re,Ve,Xe){return(0,C.$Hb)((0,C.$2b)(Re).map(qe=>oe(qe,Ve,Xe)))}we.from=Me;function oe(Re,Ve,Xe){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:Xe?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:J(Re.scheme,Ve),pattern:me.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:Xe?.isBuiltin}}function J(Re,Ve){return Ve&&typeof Re=="string"?Ve.transformOutgoingScheme(Re):Re}})(I||(e.DocumentSelector=I={}));var P;(function(we){function Me(J){switch(J){case $.DiagnosticTag.Unnecessary:return 1;case $.DiagnosticTag.Deprecated:return 2}}we.from=Me;function oe(J){switch(J){case 1:return $.DiagnosticTag.Unnecessary;case 2:return $.DiagnosticTag.Deprecated;default:return}}we.to=oe})(P||(e.DiagnosticTag=P={}));var V;(function(we){function Me(J){let Re;return J.code&&((0,s.$ag)(J.code)||(0,s.$eg)(J.code)?Re=String(J.code):Re={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:Re,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,C.$Hb)(J.tags.map(P.from)):void 0}}we.from=Me;function oe(J){const Re=new $.$DM(y.to(J),J.message,q.to(J.severity));return Re.source=J.source,Re.code=(0,s.$ag)(J.code)?J.code:J.code?.value,Re.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),Re.tags=J.tags&&(0,C.$Hb)(J.tags.map(P.to)),Re}we.to=oe})(V||(e.Diagnostic=V={}));var W;(function(we){function Me(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}we.from=Me;function oe(J){return new $.$CM(new $.$BM(J.resource,y.to(J)),J.message)}we.to=oe})(W||(e.DiagnosticRelatedInformation=W={}));var q;(function(we){function Me(J){switch(J){case $.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case $.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case $.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case $.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}we.from=Me;function oe(J){switch(J){case t.MarkerSeverity.Info:return $.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return $.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return $.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return $.DiagnosticSeverity.Hint;default:return $.DiagnosticSeverity.Error}}we.to=oe})(q||(e.DiagnosticSeverity=q={}));var A;(function(we){function Me(J){return typeof J=="number"&&J>=$.ViewColumn.One?J-1:J===$.ViewColumn.Beside?g.$$D:g.$0D}we.from=Me;function oe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=oe})(A||(e.ViewColumn=A={}));function U(we){return typeof we.range<"u"}function K(we){return we.length===0?!0:!!U(we[0])}var ie;(function(we){function Me(qe){return qe.map(we.from)}we.fromMany=Me;function oe(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(oe(qe)){const{language:Nt,value:Lt}=qe;ut={value:"```"+Nt+`
`+Lt+"\n```\n"}}else $.$RM.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const Tt=Nt=>{try{let Lt=r.URI.parse(Nt,!0);Lt=Lt.with({query:Re(Lt.query,yt)}),yt[Nt]=Lt}catch{}return""},ct=new m.marked.Renderer;return ct.link=Tt,ct.image=Nt=>typeof Nt=="string"?Tt(M.$6k(Nt).href):"",(0,m.marked)(ut.value,{renderer:ct}),ut}we.from=J;function Re(qe,ut){if(!qe)return qe;let yt;try{yt=(0,D.$9h)(qe)}catch{}if(!yt)return qe;let Tt=!1;return yt=(0,S.$9n)(yt,ct=>{if(r.URI.isUri(ct)){const Nt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Nt]=ct,Tt=!0,Nt}else return}),Tt?JSON.stringify(yt):qe}function Ve(qe){const ut=new $.$RM(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?r.URI.from(qe.baseUri):void 0,ut}we.to=Ve;function Xe(qe){if(qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function ce(we){return K(we)?we.map(Me=>({range:y.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?ie.fromMany(Me.hoverMessage):Me.hoverMessage?ie.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):we.map(Me=>({range:y.from(Me)}))}function ve(we){return typeof we>"u"?we:typeof we=="string"?r.URI.file(we):we}var Ee;(function(we){function Me(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?ve(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}we.from=Me})(Ee||(e.ThemableDecorationAttachmentRenderOptions=Ee={}));var ge;(function(we){function Me(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ve(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?Ee.from(oe.before):void 0,after:oe.after?Ee.from(oe.after):void 0}}we.from=Me})(ge||(e.ThemableDecorationRenderOptions=ge={}));var ue;(function(we){function Me(oe){if(typeof oe>"u")return oe;switch(oe){case $.DecorationRangeBehavior.OpenOpen:return 0;case $.DecorationRangeBehavior.ClosedClosed:return 1;case $.DecorationRangeBehavior.OpenClosed:return 2;case $.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Me})(ue||(e.DecorationRangeBehavior=ue={}));var Ce;(function(we){function Me(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?ue.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?ge.from(oe.light):void 0,dark:oe.dark?ge.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ve(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?Ee.from(oe.before):void 0,after:oe.after?Ee.from(oe.after):void 0}}we.from=Me})(Ce||(e.DecorationRenderOptions=Ce={}));var re;(function(we){function Me(J){return{text:J.newText,eol:J.newEol&&mt.from(J.newEol),range:y.from(J.range)}}we.from=Me;function oe(J){const Re=new $.$wM(y.to(J.range),J.text);return Re.newEol=typeof J.eol>"u"?void 0:mt.to(J.eol),Re}we.to=oe})(re||(e.TextEdit=re={}));var Ne;(function(we){function Me(J,Re){const Ve={edits:[]};if(J instanceof $.$zM){const Xe=new p.$Bc;for(const qe of J._allEntries())qe._type===1&&r.URI.isUri(qe.to)&&qe.from===void 0&&Xe.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,O.$4e)(O.$Je.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:re.from(qe.edit),versionId:Xe.has(qe.uri)?void 0:Re?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:y.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Xe.has(qe.uri)?void 0:Re?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Re?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ii.from)}})}return Ve}we.from=Me;function oe(J){const Re=new $.$zM,Ve=new p.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const qe=Xe,ut=r.URI.revive(qe.resource),yt=y.to(qe.textEdit.range),Tt=qe.textEdit.text,ct=qe.textEdit.insertAsSnippet;let Nt;ct?Nt=$.$yM.replace(yt,new $.$AM(Tt)):Nt=$.$wM.replace(yt,Tt);const Lt=Ve.get(ut);Lt?Lt.push(Nt):Ve.set(ut,[Nt])}else Re.renameFile(r.URI.revive(Xe.oldResource),r.URI.revive(Xe.newResource),Xe.options);for(const[Xe,qe]of Ve)Re.set(Xe,qe);return Re}we.to=oe})(Ne||(e.WorkspaceEdit=Ne={}));var Te;(function(we){const Me=Object.create(null);Me[$.SymbolKind.File]=0,Me[$.SymbolKind.Module]=1,Me[$.SymbolKind.Namespace]=2,Me[$.SymbolKind.Package]=3,Me[$.SymbolKind.Class]=4,Me[$.SymbolKind.Method]=5,Me[$.SymbolKind.Property]=6,Me[$.SymbolKind.Field]=7,Me[$.SymbolKind.Constructor]=8,Me[$.SymbolKind.Enum]=9,Me[$.SymbolKind.Interface]=10,Me[$.SymbolKind.Function]=11,Me[$.SymbolKind.Variable]=12,Me[$.SymbolKind.Constant]=13,Me[$.SymbolKind.String]=14,Me[$.SymbolKind.Number]=15,Me[$.SymbolKind.Boolean]=16,Me[$.SymbolKind.Array]=17,Me[$.SymbolKind.Object]=18,Me[$.SymbolKind.Key]=19,Me[$.SymbolKind.Null]=20,Me[$.SymbolKind.EnumMember]=21,Me[$.SymbolKind.Struct]=22,Me[$.SymbolKind.Event]=23,Me[$.SymbolKind.Operator]=24,Me[$.SymbolKind.TypeParameter]=25;function oe(Re){return typeof Me[Re]=="number"?Me[Re]:6}we.from=oe;function J(Re){for(const Ve in Me)if(Me[Ve]===Re)return Number(Ve);return $.SymbolKind.Property}we.to=J})(Te||(e.SymbolKind=Te={}));var T;(function(we){function Me(J){switch(J){case $.SymbolTag.Deprecated:return 1}}we.from=Me;function oe(J){switch(J){case 1:return $.SymbolTag.Deprecated}}we.to=oe})(T||(e.SymbolTag=T={}));var X;(function(we){function Me(J){return{name:J.name,kind:Te.from(J.kind),tags:J.tags&&J.tags.map(T.from),containerName:J.containerName,location:fe.from(J.location)}}we.from=Me;function oe(J){const Re=new $.$IM(J.name,Te.to(J.kind),J.containerName,fe.to(J.location));return Re.tags=J.tags&&J.tags.map(T.to),Re}we.to=oe})(X||(e.WorkspaceSymbol=X={}));var pe;(function(we){function Me(J){const Re={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:Te.from(J.kind),tags:J.tags?.map(T.from)??[]};return J.children&&(Re.children=J.children.map(Me)),Re}we.from=Me;function oe(J){const Re=new $.$JM(J.name,J.detail,Te.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,C.$Lb)(J.tags)&&(Re.tags=J.tags.map(T.to)),J.children&&(Re.children=J.children.map(oe)),Re}we.to=oe})(pe||(e.DocumentSymbol=pe={}));var Ie;(function(we){function Me(J){const Re=new $.$NM(Te.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Re._sessionId=J._sessionId,Re._itemId=J._itemId,Re}we.to=Me;function oe(J,Re,Ve){if(Re=Re??J._sessionId,Ve=Ve??J._itemId,Re===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ve,name:J.name,detail:J.detail,kind:Te.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(T.from)}}we.from=oe})(Ie||(e.CallHierarchyItem=Ie={}));var ye;(function(we){function Me(oe){return new $.$OM(Ie.to(oe.from),oe.fromRanges.map(J=>y.to(J)))}we.to=Me})(ye||(e.CallHierarchyIncomingCall=ye={}));var $e;(function(we){function Me(oe){return new $.$PM(Ie.to(oe.to),oe.fromRanges.map(J=>y.to(J)))}we.to=Me})($e||(e.CallHierarchyOutgoingCall=$e={}));var fe;(function(we){function Me(J){return{range:J.range&&y.from(J.range),uri:J.uri}}we.from=Me;function oe(J){return new $.$BM(r.URI.revive(J.uri),y.to(J.range))}we.to=oe})(fe||(e.location=fe={}));var Q;(function(we){function Me(J){const Re=J,Ve=J;return{originSelectionRange:Re.originSelectionRange?y.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ve.uri,range:y.from(Re.targetRange?Re.targetRange:Ve.range),targetSelectionRange:Re.targetSelectionRange?y.from(Re.targetSelectionRange):void 0}}we.from=Me;function oe(J){return{targetUri:r.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}we.to=oe})(Q||(e.DefinitionLink=Q={}));var x;(function(we){function Me(J){return{range:y.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}we.from=Me;function oe(J){const Re=J.contents.map(ie.to),Ve=y.to(J.range),Xe=J.canIncreaseVerbosity,qe=J.canDecreaseVerbosity;return new $.$FM(Re,Ve,Xe,qe)}we.to=oe})(x||(e.Hover=x={}));var le;(function(we){function Me(J){return{range:y.from(J.range),expression:J.expression}}we.from=Me;function oe(J){return new $.$AN(y.to(J.range),J.expression)}we.to=oe})(le||(e.EvaluatableExpression=le={}));var ae;(function(we){function Me(J){if(J instanceof $.$BN)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof $.$CN)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof $.$DN)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Me;function oe(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}we.to=oe})(ae||(e.InlineValue=ae={}));var Fe;(function(we){function Me(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}we.from=Me;function oe(J){return new $.$EN(J.frameId,y.to(J.stoppedLocation))}we.to=oe})(Fe||(e.InlineValueContext=Fe={}));var de;(function(we){function Me(J){return{range:y.from(J.range),kind:J.kind}}we.from=Me;function oe(J){return new $.$GM(y.to(J.range),J.kind)}we.to=oe})(de||(e.DocumentHighlight=de={}));var Pe;(function(we){function Me(J){return{uri:J.uri,highlights:J.highlights.map(de.from)}}we.from=Me;function oe(J){return new $.$HM(r.URI.revive(J.uri),J.highlights.map(de.to))}we.to=oe})(Pe||(e.MultiDocumentHighlight=Pe={}));var Ae;(function(we){function Me(oe){switch(oe){case 1:return $.CompletionTriggerKind.TriggerCharacter;case 2:return $.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return $.CompletionTriggerKind.Invoke}}we.to=Me})(Ae||(e.CompletionTriggerKind=Ae={}));var je;(function(we){function Me(oe){return{triggerKind:Ae.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}we.to=Me})(je||(e.CompletionContext=je={}));var j;(function(we){function Me(J){switch(J){case $.CompletionItemTag.Deprecated:return 1}}we.from=Me;function oe(J){switch(J){case 1:return $.CompletionItemTag.Deprecated}}we.to=oe})(j||(e.CompletionItemTag=j={}));var z;(function(we){const Me=new Map([[$.CompletionItemKind.Method,0],[$.CompletionItemKind.Function,1],[$.CompletionItemKind.Constructor,2],[$.CompletionItemKind.Field,3],[$.CompletionItemKind.Variable,4],[$.CompletionItemKind.Class,5],[$.CompletionItemKind.Interface,7],[$.CompletionItemKind.Struct,6],[$.CompletionItemKind.Module,8],[$.CompletionItemKind.Property,9],[$.CompletionItemKind.Unit,12],[$.CompletionItemKind.Value,13],[$.CompletionItemKind.Constant,14],[$.CompletionItemKind.Enum,15],[$.CompletionItemKind.EnumMember,16],[$.CompletionItemKind.Keyword,17],[$.CompletionItemKind.Snippet,27],[$.CompletionItemKind.Text,18],[$.CompletionItemKind.Color,19],[$.CompletionItemKind.File,20],[$.CompletionItemKind.Reference,21],[$.CompletionItemKind.Folder,23],[$.CompletionItemKind.Event,10],[$.CompletionItemKind.Operator,11],[$.CompletionItemKind.TypeParameter,24],[$.CompletionItemKind.Issue,26],[$.CompletionItemKind.User,25]]);function oe(Ve){return Me.get(Ve)??9}we.from=oe;const J=new Map([[0,$.CompletionItemKind.Method],[1,$.CompletionItemKind.Function],[2,$.CompletionItemKind.Constructor],[3,$.CompletionItemKind.Field],[4,$.CompletionItemKind.Variable],[5,$.CompletionItemKind.Class],[7,$.CompletionItemKind.Interface],[6,$.CompletionItemKind.Struct],[8,$.CompletionItemKind.Module],[9,$.CompletionItemKind.Property],[12,$.CompletionItemKind.Unit],[13,$.CompletionItemKind.Value],[14,$.CompletionItemKind.Constant],[15,$.CompletionItemKind.Enum],[16,$.CompletionItemKind.EnumMember],[17,$.CompletionItemKind.Keyword],[27,$.CompletionItemKind.Snippet],[18,$.CompletionItemKind.Text],[19,$.CompletionItemKind.Color],[20,$.CompletionItemKind.File],[21,$.CompletionItemKind.Reference],[23,$.CompletionItemKind.Folder],[10,$.CompletionItemKind.Event],[11,$.CompletionItemKind.Operator],[24,$.CompletionItemKind.TypeParameter],[25,$.CompletionItemKind.User],[26,$.CompletionItemKind.Issue]]);function Re(Ve){return J.get(Ve)??$.CompletionItemKind.Property}we.to=Re})(z||(e.CompletionItemKind=z={}));var G;(function(we){function Me(oe,J){const Re=new $.$XM(oe.label);return Re.insertText=oe.insertText,Re.kind=z.to(oe.kind),Re.tags=oe.tags?.map(j.to),Re.detail=oe.detail,Re.documentation=M.$Zk(oe.documentation)?ie.to(oe.documentation):oe.documentation,Re.sortText=oe.sortText,Re.filterText=oe.filterText,Re.preselect=oe.preselect,Re.commitCharacters=oe.commitCharacters,o.$At.isIRange(oe.range)?Re.range=y.to(oe.range):typeof oe.range=="object"&&(Re.range={inserting:y.to(oe.range.insert),replacing:y.to(oe.range.replace)}),Re.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?Re.insertText=new $.$AM(oe.insertText):(Re.insertText=oe.insertText,Re.textEdit=Re.range instanceof $.$rM?new $.$wM(Re.range,Re.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Re.additionalTextEdits=oe.additionalTextEdits.map(Ve=>re.to(Ve))),Re.command=J&&oe.command?J.fromInternal(oe.command):void 0,Re}we.to=Me})(G||(e.CompletionItem=G={}));var H;(function(we){function Me(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}we.from=Me;function oe(J){return{label:J.label,documentation:M.$Zk(J.documentation)?ie.to(J.documentation):J.documentation}}we.to=oe})(H||(e.ParameterInformation=H={}));var te;(function(we){function Me(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}we.from=Me;function oe(J){return{label:J.label,documentation:M.$Zk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}we.to=oe})(te||(e.SignatureInformation=te={}));var ne;(function(we){function Me(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(te.from):[]}}we.from=Me;function oe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(te.to):[]}}we.to=oe})(ne||(e.SignatureHelp=ne={}));var Oe;(function(we){function Me(oe,J){const Re=new $.$WM(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,oe)),J.kind&&He.to(J.kind));return Re.textEdits=J.textEdits&&J.textEdits.map(re.to),Re.tooltip=M.$Zk(J.tooltip)?ie.to(J.tooltip):J.tooltip,Re.paddingLeft=J.paddingLeft,Re.paddingRight=J.paddingRight,Re}we.to=Me})(Oe||(e.InlayHint=Oe={}));var Be;(function(we){function Me(oe,J){const Re=new $.$VM(J.label);return Re.tooltip=M.$Zk(J.tooltip)?ie.to(J.tooltip):J.tooltip,n.Command.is(J.command)&&(Re.command=oe.fromInternal(J.command)),J.location&&(Re.location=fe.to(J.location)),Re}we.to=Me})(Be||(e.InlayHintLabelPart=Be={}));var He;(function(we){function Me(J){return J}we.from=Me;function oe(J){return J}we.to=oe})(He||(e.InlayHintKind=He={}));var _e;(function(we){function Me(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}we.from=Me;function oe(J){let Re;if(J.url)try{Re=typeof J.url=="string"?r.URI.parse(J.url,!0):r.URI.revive(J.url)}catch{}return new $.$3M(y.to(J.range),Re)}we.to=oe})(_e||(e.DocumentLink=_e={}));var xe;(function(we){function Me(J){const Re=new $.$6M(J.label);return J.textEdit&&(Re.textEdit=re.to(J.textEdit)),J.additionalTextEdits&&(Re.additionalTextEdits=J.additionalTextEdits.map(Ve=>re.to(Ve))),Re}we.to=Me;function oe(J){return{label:J.label,textEdit:J.textEdit?re.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Re=>re.from(Re)):void 0}}we.from=oe})(xe||(e.ColorPresentation=xe={}));var et;(function(we){function Me(J){return new $.$4M(J[0],J[1],J[2],J[3])}we.to=Me;function oe(J){return[J.red,J.green,J.blue,J.alpha]}we.from=oe})(et||(e.Color=et={}));var tt;(function(we){function Me(J){return{range:y.from(J.range)}}we.from=Me;function oe(J){return new $.$MM(y.to(J.range))}we.to=oe})(tt||(e.SelectionRange=tt={}));var it;(function(we){function Me(oe){switch(oe){case 2:return $.TextDocumentSaveReason.AfterDelay;case 1:return $.TextDocumentSaveReason.Manual;case 3:case 4:return $.TextDocumentSaveReason.FocusOut}}we.to=Me})(it||(e.TextDocumentSaveReason=it={}));var at;(function(we){function Me(J){switch(J){case $.TextEditorLineNumbersStyle.Off:return 0;case $.TextEditorLineNumbersStyle.Relative:return 2;case $.TextEditorLineNumbersStyle.Interval:return 3;case $.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Me;function oe(J){switch(J){case 0:return $.TextEditorLineNumbersStyle.Off;case 2:return $.TextEditorLineNumbersStyle.Relative;case 3:return $.TextEditorLineNumbersStyle.Interval;case 1:default:return $.TextEditorLineNumbersStyle.On}}we.to=oe})(at||(e.TextEditorLineNumbersStyle=at={}));var mt;(function(we){function Me(J){if(J===$.EndOfLine.CRLF)return 1;if(J===$.EndOfLine.LF)return 0}we.from=Me;function oe(J){if(J===1)return $.EndOfLine.CRLF;if(J===0)return $.EndOfLine.LF}we.to=oe})(mt||(e.EndOfLine=mt={}));var Ue;(function(we){function Me(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case $.ProgressLocation.SourceControl:return 3;case $.ProgressLocation.Window:return 10;case $.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Me})(Ue||(e.ProgressLocation=Ue={}));var rt;(function(we){function Me(J){const Re={start:J.start+1,end:J.end+1};return J.kind&&(Re.kind=Y.from(J.kind)),Re}we.from=Me;function oe(J){const Re={start:J.start-1,end:J.end-1};return J.kind&&(Re.kind=Y.to(J.kind)),Re}we.to=oe})(rt||(e.FoldingRange=rt={}));var Y;(function(we){function Me(J){if(J)switch(J){case $.FoldingRangeKind.Comment:return n.$zu.Comment;case $.FoldingRangeKind.Imports:return n.$zu.Imports;case $.FoldingRangeKind.Region:return n.$zu.Region}}we.from=Me;function oe(J){if(J)switch(J.value){case n.$zu.Comment.value:return $.FoldingRangeKind.Comment;case n.$zu.Imports.value:return $.FoldingRangeKind.Imports;case n.$zu.Region.value:return $.FoldingRangeKind.Region}}we.to=oe})(Y||(e.FoldingRangeKind=Y={}));var Z;(function(we){function Me(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?y.from(oe.selection):void 0,override:typeof oe.override=="boolean"?u.$AF.id:void 0}}we.from=Me})(Z||(e.TextEditorOpenOptions=Z={}));var me;(function(we){function Me(Ve){return Ve instanceof $.$oN?Ve.toJSON():typeof Ve=="string"?Ve:oe(Ve)||J(Ve)?new $.$oN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}we.from=Me;function oe(Ve){const Xe=Ve;return Xe?r.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Ve){const Xe=Ve;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Re(Ve){return typeof Ve=="string"?Ve:new $.$oN(r.URI.revive(Ve.baseUri),Ve.pattern)}we.to=Re})(me||(e.GlobPattern=me={}));var Ge;(function(we){function Me(oe){if(oe){if(Array.isArray(oe))return oe.map(Me);if(typeof oe=="string")return oe;{const J=oe;return{language:J.language,scheme:J.scheme,pattern:me.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}we.from=Me})(Ge||(e.LanguageSelector=Ge={}));var be;(function(we){function Me(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Re=>Array.isArray(Re)&&Re.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&r.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Xe=>Xe instanceof $.$rM)))}we.is=Me;function oe(J){return{documents:J.documents.map(Re=>Re.map(Ve=>({uri:r.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Xe=>y.from(Xe))})))}}we.from=oe})(be||(e.MappedEditsContext=be={}));var st;(function(we){function Me(J){return{start:J.start,end:J.end}}we.from=Me;function oe(J){return new $.$RN(J.start,J.end)}we.to=oe})(st||(e.NotebookRange=st={}));var dt;(function(we){function Me(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}we.to=Me;function oe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}we.from=oe})(dt||(e.NotebookCellExecutionSummary=dt={}));var Pt;(function(we){function Me(oe){if(oe===w.NotebookCellExecutionState.Unconfirmed)return $.NotebookCellExecutionState.Pending;if(oe===w.NotebookCellExecutionState.Pending)return;if(oe===w.NotebookCellExecutionState.Executing)return $.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}we.to=Me})(Pt||(e.NotebookCellExecutionState=Pt={}));var Vt;(function(we){function Me(J){switch(J){case $.NotebookCellKind.Markup:return w.CellKind.Markup;case $.NotebookCellKind.Code:default:return w.CellKind.Code}}we.from=Me;function oe(J){switch(J){case w.CellKind.Markup:return $.NotebookCellKind.Markup;case w.CellKind.Code:default:return $.NotebookCellKind.Code}}we.to=oe})(Vt||(e.NotebookCellKind=Vt={}));var Qt;(function(we){function Me(J){const Re={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)$.$SN.validate(Ve),Re.cells.push(ii.from(Ve));return Re}we.from=Me;function oe(J){const Re=new $.$TN(J.cells.map(ii.to));return(0,s.$ng)(J.metadata)||(Re.metadata=J.metadata),Re}we.to=oe})(Qt||(e.NotebookData=Qt={}));var ii;(function(we){function Me(J){return{cellKind:Vt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Et.from):[]}}we.from=Me;function oe(J){return new $.$SN(Vt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Et.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}we.to=oe})(ii||(e.NotebookCellData=ii={}));var Xt;(function(we){function Me(J){return{mime:J.mime,valueBytes:O.$Je.wrap(J.data)}}we.from=Me;function oe(J){return new $.$UN(J.valueBytes.buffer,J.mime)}we.to=oe})(Xt||(e.NotebookCellOutputItem=Xt={}));var Et;(function(we){function Me(J){return{outputId:J.id,items:J.items.map(Xt.from),metadata:J.metadata}}we.from=Me;function oe(J){const Re=J.items.map(Xt.to);return new $.$VN(Re,J.outputId,J.metadata)}we.to=oe})(Et||(e.NotebookCellOutput=Et={}));var Zt;(function(we){function Me(Re){return J(Re)?{include:me.from(Re.include)??void 0,exclude:me.from(Re.exclude)??void 0}:me.from(Re)??void 0}we.from=Me;function oe(Re){return J(Re)?{include:me.to(Re.include),exclude:me.to(Re.exclude)}:me.to(Re)}we.to=oe;function J(Re){const Ve=Re;return Ve?!(0,s.$jg)(Ve.include)&&!(0,s.$jg)(Ve.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Yt;(function(we){function Me(oe,J,Re){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===$.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,Re),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}we.from=Me})(Yt||(e.NotebookStatusBarItem=Yt={}));var Ze;(function(we){function Me(oe,J,Re){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:J.toInternal(Ve,Re),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}we.from=Me})(Ze||(e.NotebookKernelSourceAction=Ze={}));var si;(function(we){function Me(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}we.from=Me})(si||(e.NotebookDocumentContentOptions=si={}));var Ht;(function(we){function Me(J){return{uri:J.uri,provides:J.provides}}we.from=Me;function oe(J){return new $.$XN(r.URI.revive(J.uri),J.provides)}we.to=oe})(Ht||(e.NotebookRendererScript=Ht={}));var ht;(function(we){function Me(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}we.from=Me;function oe(J){const Re=new $.$4N(typeof J.message=="string"?J.message:ie.to(J.message));return Re.actualOutput=J.actual,Re.expectedOutput=J.expected,Re.contextValue=J.contextValue,Re.location=J.location?fe.to(J.location):void 0,Re}we.to=oe})(ht||(e.TestMessage=ht={}));var ft;(function(we){we.namespace=l.$eL,we.denamespace=l.$fL})(ft||(e.TestTag=ft={}));var xt;(function(we){function Me(J){const Re=(0,c.$NO)(J).controllerId;return{extId:a.$_K.fromExtHostTestItem(J,Re).toString(),label:J.label,uri:r.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>ft.namespace(Re,Ve.id)),range:o.$At.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}we.from=Me;function oe(J){return{parent:void 0,error:void 0,id:a.$_K.fromString(J.extId).localId,label:J.label,uri:r.URI.revive(J.uri),tags:(J.tags||[]).map(Re=>{const{tagId:Ve}=ft.denamespace(Re);return new $.$5N(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}we.toPlain=oe})(xt||(e.TestItem=xt={})),function(we){function Me(J){return{id:J.id}}we.from=Me;function oe(J){return new $.$5N(J.id)}we.to=oe}(ft||(e.TestTag=ft={}));var Kt;(function(we){const Me=(J,Re)=>{const Ve=J.value;if(!Ve)return;const Xe={...xt.toPlain(Ve.item),parent:Re,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Me(qe,Xe);ut&&Xe.children.push(ut)}return Xe};function oe(J){const Re=new d.$GO;for(const qe of J.items)Re.insert(a.$_K.fromString(qe.item.extId).path,qe);const Ve=[Re.nodes],Xe=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Xe.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Xe.map(qe=>Me(qe)).filter(s.$ig)}}we.to=oe})(Kt||(e.TestResults=Kt={}));var Ft;(function(we){function Me(Ve){return{covered:Ve.covered,total:Ve.total}}function oe(Ve){return"line"in Ve?k.from(Ve):y.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:oe(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&oe(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:oe(Ve.location)}}we.fromDetails=J;function Re(Ve,Xe,qe){return $.$7N(qe.statementCoverage),$.$7N(qe.branchCoverage),$.$7N(qe.declarationCoverage),{id:Xe,uri:qe.uri,statement:Me(qe.statementCoverage),branch:qe.branchCoverage&&Me(qe.branchCoverage),declaration:qe.declarationCoverage&&Me(qe.declarationCoverage),testId:qe instanceof $.$8N&&qe.testItem?a.$_K.fromExtHostTestItem(qe.testItem,Ve).toString():void 0}}we.fromFile=Re})(Ft||(e.TestCoverage=Ft={}));var gt;(function(we){function Me(oe){switch(oe){case 1:return $.CodeActionTriggerKind.Invoke;case 2:return $.CodeActionTriggerKind.Automatic}}we.to=Me})(gt||(e.CodeActionTriggerKind=gt={}));var Bt;(function(we){function Me(J){const Re=new $.$_N(Te.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Re._sessionId=J._sessionId,Re._itemId=J._itemId,Re}we.to=Me;function oe(J,Re,Ve){if(Re=Re??J._sessionId,Ve=Ve??J._itemId,Re===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Ve,kind:Te.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(T.from)}}we.from=oe})(Bt||(e.TypeHierarchyItem=Bt={}));var _t;(function(we){function Me(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}we.from=Me})(_t||(e.ViewBadge=_t={}));var zt;(function(we){function Me(Ve,Xe,qe){const ut=Xe.fileData;return ut?new $.$gN(new $.$hN(ut.name,r.URI.revive(ut.uri),ut.id,(0,F.$db)(()=>qe(ut.id)))):Ve===N.$Ws.uriList&&Xe.uriListData?new $.$fN(Re(Xe.uriListData)):new $.$fN(Xe.asString)}we.to=Me;async function oe(Ve,Xe){const qe=await Xe.asString();if(Ve===N.$Ws.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Xe.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}we.from=oe;function J(Ve){return R.$eu.split(Ve).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return r.URI.parse(Xe)}catch{}return Xe})}function Re(Ve){return R.$eu.create(Ve.map(Xe=>typeof Xe=="string"?Xe:r.URI.revive(Xe)))}})(zt||(e.DataTransferItem=zt={}));var Qe;(function(we){function Me(J,Re){const Ve=J.items.map(([Xe,qe])=>[Xe,zt.to(Xe,qe,Re)]);return new $.$iN(Ve)}we.toDataTransfer=Me;async function oe(J){const Re={items:[]},Ve=[];for(const[Xe,qe]of J)Ve.push((async()=>{Re.items.push([Xe,await zt.from(Xe,qe)])})());return await Promise.all(Ve),Re}we.from=oe})(Qe||(e.DataTransfer=Qe={}));var ui;(function(we){function Me(J,Re){return{kind:"reply",agentId:J.participant??Re?.agentId??"",subCommand:J.command??Re?.command,message:J.prompt,title:J.label}}we.from=Me;function oe(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}we.to=oe})(ui||(e.ChatFollowup=ui={}));var Jt;(function(we){function Me(J){switch(J.role){case 0:return new $.$AO($.LanguageModelChatMessageRole.System,J.content);case 1:return new $.$AO($.LanguageModelChatMessageRole.User,J.content);case 2:return new $.$AO($.LanguageModelChatMessageRole.Assistant,J.content)}}we.to=Me;function oe(J){switch(J.role){case $.LanguageModelChatMessageRole.System:return{role:0,content:J.content};case $.LanguageModelChatMessageRole.User:return{role:1,content:J.content};case $.LanguageModelChatMessageRole.Assistant:return{role:2,content:J.content}}}we.from=oe})(Jt||(e.LanguageModelChatMessage=Jt={}));var Ut;(function(we){function Me(J){return{kind:"markdownContent",content:ie.from(J.value)}}we.from=Me;function oe(J){return new $.$mO(ie.to(J.content))}we.to=oe})(Ut||(e.ChatResponseMarkdownPart=Ut={}));var wt;(function(we){function Me(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}we.from=Me;function oe(J){return new $.$nO(ie.to(J.content),J.vulnerabilities)}we.to=oe})(wt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=wt={}));var jt;(function(we){function Me(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}we.from=Me;function oe(J){return new $.$oO(J.agentId,J.command)}we.to=oe})(jt||(e.ChatResponseDetectedParticipantPart=jt={}));var Rt;(function(we){function Me(oe){return{kind:"confirmation",title:oe.title,message:oe.message,data:oe.data}}we.from=Me})(Rt||(e.ChatResponseConfirmationPart=Rt={}));var Mt;(function(we){function Me(J){const{value:Re,baseUri:Ve}=J;function Xe(qe,ut){return qe.map(yt=>{const Tt=r.URI.joinPath(ut,yt.name);return{label:yt.name,uri:Tt,children:yt.children&&Xe(yt.children,Tt)}})}return{kind:"treeData",treeData:{label:(0,v.$$g)(Ve),uri:Ve,children:Xe(Re,Ve)}}}we.from=Me;function oe(J){const Re=(0,D.$0h)(J.treeData);function Ve(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Xe=Re.uri,qe=Re.children?Ve(Re.children):[];return new $.$qO(qe,Xe)}we.to=oe})(Mt||(e.ChatResponseFilesPart=Mt={}));var ei;(function(we){function Me(J){const Re=Ve=>r.URI.isUri(Ve);return{kind:"inlineReference",name:J.title,inlineReference:Re(J.value)?J.value:h.from(J.value)}}we.from=Me;function oe(J){const Re=(0,D.$0h)(J);return new $.$rO(r.URI.isUri(Re.inlineReference)?Re.inlineReference:h.to(Re.inlineReference),J.name)}we.to=oe})(ei||(e.ChatResponseAnchorPart=ei={}));var Wt;(function(we){function Me(J){return{kind:"progressMessage",content:ie.from(J.value)}}we.from=Me;function oe(J){return new $.$sO(J.content.value)}we.to=oe})(Wt||(e.ChatResponseProgressPart=Wt={}));var oi;(function(we){function Me(J){return{kind:"warning",content:ie.from(J.value)}}we.from=Me;function oe(J){return new $.$uO(J.content.value)}we.to=oe})(oi||(e.ChatResponseWarningPart=oi={}));var Ot;(function(we){function Me(oe){return{kind:"progressTask",content:ie.from(oe.value)}}we.from=Me})(Ot||(e.ChatTask=Ot={}));var qt;(function(we){function Me(oe){return{kind:"progressTaskResult",content:typeof oe=="string"?ie.from(oe):void 0}}we.from=Me})(qt||(e.ChatTaskResult=qt={}));var At;(function(we){function Me(J,Re,Ve){return{kind:"command",command:Re.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}we.from=Me;function oe(J,Re){return new $.$vO(Re.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}we.to=oe})(At||(e.ChatResponseCommandButtonPart=At={}));var St;(function(we){function Me(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Re=>re.from(Re))}}we.from=Me;function oe(J){return new $.$xO(r.URI.revive(J.uri),J.edits.map(Re=>re.to(Re)))}we.to=oe})(St||(e.ChatResponseTextEditPart=St={}));var $t;(function(we){function Me(J){const Re=f.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:r.URI.isUri(J.iconPath)?{light:r.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&r.URI.isUri(J.iconPath.light)&&r.URI.isUri(J.iconPath.dark)?{light:r.URI.revive(J.iconPath.light),dark:r.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:r.URI.isUri(J.value.value)||!J.value.value?J.value.value:h.from(J.value.value)},iconPath:Re}:{kind:"reference",reference:r.URI.isUri(J.value)?J.value:h.from(J.value),iconPath:Re}}we.from=Me;function oe(J){const Re=(0,D.$0h)(J),Ve=Xe=>r.URI.isUri(Xe)?Xe:h.to(Xe);return new $.$wO("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&Ve(Re.reference.value)}:Ve(Re.reference))}we.to=oe})($t||(e.ChatResponseReferencePart=$t={}));var Dt;(function(we){function Me(Re,Ve,Xe){return Re instanceof $.$mO?Ut.from(Re):Re instanceof $.$rO?ei.from(Re):Re instanceof $.$wO?$t.from(Re):Re instanceof $.$sO?Wt.from(Re):Re instanceof $.$qO?Mt.from(Re):Re instanceof $.$vO?At.from(Re,Ve,Xe):Re instanceof $.$xO?St.from(Re):Re instanceof $.$nO?wt.from(Re):Re instanceof $.$oO?jt.from(Re):Re instanceof $.$uO?oi.from(Re):{kind:"markdownContent",content:ie.from("")}}we.from=Me;function oe(Re,Ve){switch(Re.kind){case"reference":return $t.to(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Re,Ve)}}we.to=oe;function J(Re,Ve){switch(Re.kind){case"markdownContent":return Ut.to(Re);case"inlineReference":return ei.to(Re);case"progressMessage":return;case"treeData":return Mt.to(Re);case"command":return At.to(Re,Ve)}}we.toContent=J})(Dt||(e.ChatResponsePart=Dt={}));var ai;(function(we){function Me(oe){return{prompt:oe.message,command:oe.command,attempt:oe.attempt??0,enableCommandDetection:oe.enableCommandDetection??!0,references:oe.variables.variables.map(fi.to),location:kt.to(oe.location),acceptedConfirmationData:oe.acceptedConfirmationData,rejectedConfirmationData:oe.rejectedConfirmationData}}we.to=Me})(ai||(e.ChatAgentRequest=ai={}));var kt;(function(we){function Me(oe){switch(oe){case i.ChatAgentLocation.Notebook:return $.ChatLocation.Notebook;case i.ChatAgentLocation.Terminal:return $.ChatLocation.Terminal;case i.ChatAgentLocation.Panel:return $.ChatLocation.Panel;case i.ChatAgentLocation.Editor:return $.ChatLocation.Editor}}we.to=Me})(kt||(e.ChatLocation=kt={}));var fi;(function(we){function Me(oe){const J=oe.value;if(!J)throw new Error("Invalid value reference");return{id:oe.id,name:oe.name,range:oe.range&&[oe.range.start,oe.range.endExclusive],value:(0,r.$vc)(J)?r.URI.revive(J):J,modelDescription:oe.modelDescription}}we.to=Me})(fi||(e.ChatAgentValueReference=fi={}));var ni;(function(we){function Me(oe,J,Re){return{id:oe.id,label:oe.label,value:oe.values[0].value,insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation,command:J.toInternal(oe.command,Re)}}we.from=Me})(ni||(e.ChatAgentCompletionItem=ni={}));var $i;(function(we){function Me(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}we.to=Me})($i||(e.ChatAgentResult=$i={}));var li;(function(we){function Me(oe,J,Re){if(J.action.kind==="vote")return;const Ve=$i.to(oe);if(J.action.kind==="command"){const Xe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Re.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ui.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}we.to=Me})(li||(e.ChatAgentUserActionEvent=li={}));var bi;(function(we){function Me(oe,J,Re){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:J.toInternal(oe,Re)}we.from=Me})(bi||(e.TerminalQuickFix=bi={}));var It;(function(we){function Me(oe){return{kind:Ei.to(oe.kind)}}we.to=Me})(It||(e.PartialAcceptInfo=It={}));var Ei;(function(we){function Me(oe){switch(oe){case 0:return $.PartialAcceptTriggerKind.Word;case 1:return $.PartialAcceptTriggerKind.Line;case 2:return $.PartialAcceptTriggerKind.Suggest;default:return $.PartialAcceptTriggerKind.Unknown}}we.to=Me})(Ei||(e.PartialAcceptTriggerKind=Ei={}));var ri;(function(we){function Me(oe,J){return{id:J,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}we.from=Me})(ri||(e.DebugTreeItem=ri={}))}),define(ke[263],Se([1,0,4,17,8,34]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=void 0;let M=class{constructor(m,D){this.a=m.getProxy(C.$nM.MainThreadBulkEdits),this.b={getTextDocumentVersion:N=>D.getDocument(N)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,D,N){const S=new F.$Hw(R.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,N?.isRefactoring??!1)}};e.$rmc=M,e.$rmc=M=Je([We(0,O.$RO)],M)}),define(ke[264],Se([1,0,18,11,44,5,42,6,66,15,2,21,4,8,7,225,25]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=void 0;class o{constructor(u,i,w,a,l){this.j=u,this.k=i,this.l=w,this.m=a,this.n=l,this.b=m.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(a){if(u.c){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,a),l}};const u=this;this.b.reset();const w=(a,l)=>{if(typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),l){const g=this.l.$handleProgressChunk(this.k.requestId,a),$={report:b=>{g?.then(y=>{y&&(f.$RM.isMarkdownString(b.value)?this.l.$handleProgressChunk(this.k.requestId,v.ChatResponseWarningPart.from(b),y):this.l.$handleProgressChunk(this.k.requestId,v.ChatResponseReferencePart.from(b),y))})}};Promise.all([g,l?.($)]).then(([b,y])=>{b!==void 0&&y!==void 0&&this.l.$handleProgressChunk(this.k.requestId,v.ChatTaskResult.from(y),b)})}else this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){i(this.markdown);const l=new f.$mO(a),g=v.ChatResponseMarkdownPart.from(l);return w(g),this},markdownWithVulnerabilities(a,l){i(this.markdown),l&&(0,r.$OG)(u.j,"chatParticipantAdditions");const g=new f.$nO(a,l),$=v.ChatResponseMarkdownWithVulnerabilitiesPart.from(g);return w($),this},filetree(a,l){i(this.filetree);const g=new f.$qO(a,l),$=v.ChatResponseFilesPart.from(g);return w($),this},anchor(a,l){i(this.anchor);const g=new f.$rO(a,l),$=v.ChatResponseAnchorPart.from(g);return w($),this},button(a){i(this.anchor);const l=new f.$vO(a),g=v.ChatResponseCommandButtonPart.from(l,u.m,u.n);return w(g),this},progress(a,l){i(this.progress);const g=new f.$tO(a,l),$=l?v.ChatTask.from(g):v.ChatResponseProgressPart.from(g);return w($,l),this},warning(a){i(this.progress),(0,r.$OG)(u.j,"chatParticipantAdditions");const l=new f.$uO(a),g=v.ChatResponseWarningPart.from(l);return w(g),this},reference(a,l){if(i(this.reference),"variableName"in a&&(0,r.$OG)(u.j,"chatParticipantAdditions"),"variableName"in a&&!a.value){const g=u.k.variables.variables.find($=>$.name===a.variableName);if(g){let $;if(g.references?.length)$=g.references.map(b=>({kind:"reference",reference:{variableName:a.variableName,value:b.reference}}));else{const b=new f.$wO(a,l);$=[v.ChatResponseReferencePart.from(b)]}return $.forEach(b=>w(b)),this}}else{const g=new f.$wO(a,l),$=v.ChatResponseReferencePart.from(g);w($)}return this},textEdit(a,l){i(this.textEdit),(0,r.$OG)(u.j,"chatParticipantAdditions");const g=new f.$xO(a,l),$=v.ChatResponseTextEditPart.from(g);return w($),this},detectedParticipant(a,l){i(this.detectedParticipant),(0,r.$OG)(u.j,"chatParticipantAdditions");const g=new f.$oO(a,l),$=v.ChatResponseDetectedParticipantPart.from(g);return w($),this},confirmation(a,l,g){i(this.confirmation),(0,r.$OG)(u.j,"chatParticipantAdditions");const $=new f.$pO(a,l,g),b=v.ChatResponseConfirmationPart.from($);return w(b),this},push(a){if(i(this.push),(a instanceof f.$xO||a instanceof f.$nO||a instanceof f.$oO||a instanceof f.$uO||a instanceof f.$pO)&&(0,r.$OG)(u.j,"chatParticipantAdditions"),a instanceof f.$wO)this.reference(a.value,a.iconPath);else{const l=v.ChatResponsePart.from(a,u.m,u.n);w(l)}return this}}}return this.g}}class n extends p.$Uc{static{this.b=0}constructor(u,i,w){super(),this.n=i,this.s=w,this.c=new Map,this.j=this.B(new p.$4c),this.m=this.B(new p.$4c),this.g=u.getProxy(d.$nM.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,i,w){const a=n.b++,l=new t(u,i,this.g,a,w);return this.c.set(a,l),this.g.$registerAgent(a,u.identifier,i,{},void 0),l.apiAgent}createDynamicChatAgent(u,i,w,a){const l=n.b++,g=new t(u,i,this.g,l,a);return this.c.set(l,g),this.g.$registerAgent(l,u.identifier,i,{isSticky:!0},w),g.apiAgent}async $invokeAgent(u,i,w,a){const l=this.c.get(u);if(!l)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let g=this.j.get(i.sessionId);g||(g=new p.$Tc,this.j.set(i.sessionId,g));const $=new o(l.extension,i,this.g,this.s.converter,g);try{const b=await this.t(i.agentId,w),y=l.invoke(v.ChatAgentRequest.to(i),{history:b},$.apiObject,a);return await(0,O.$oh)(Promise.resolve(y).then(h=>{if(h?.metadata)try{JSON.stringify(h.metadata)}catch(k){const I=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.n.error(`[${l.extension.identifier.value}] [@${l.id}] ${I}`,l.extension),{errorDetails:{message:I},timings:$.timings}}let E;return h?.errorDetails&&(E={...h.errorDetails,responseIsIncomplete:!0}),{errorDetails:E,timings:$.timings,metadata:h?.metadata}}),a)}catch(b){return this.n.error(b,l.extension),{errorDetails:{message:(0,R.$lj)(b),responseIsIncomplete:!0}}}finally{$.close()}}async t(u,i){const w=[];for(const a of i.history){const l=v.ChatAgentResult.to(a.result),g=u===a.request.agentId?l:{...l,metadata:void 0};w.push(new f.$yO(a.request.message,a.request.command,a.request.variables.variables.map(v.ChatAgentValueReference.to),a.request.agentId));const $=(0,C.$Hb)(a.response.map(b=>v.ChatResponsePart.toContent(b,this.s.converter)));w.push(new f.$zO($,g,a.request.agentId,a.request.command))}return w}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,i,w,a,l){const g=this.c.get(i);if(!g)return Promise.resolve([]);const $=await this.t(g.id,a),b=v.ChatAgentResult.to(w);return(await g.provideFollowups(b,{history:$},l)).filter(y=>{const h=!y.participant||M.Iterable.some(this.c.values(),E=>E.id===y.participant&&S.$Vm.equals(E.extension.identifier,g.extension.identifier));return h||this.n.warn(`[@${g.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),h}).map(y=>v.ChatFollowup.from(y,u))}$acceptFeedback(u,i,w,a){const l=this.c.get(u);if(!l)return;const g=v.ChatAgentResult.to(i);let $;switch(w){case s.ChatAgentVoteDirection.Down:$=f.ChatResultFeedbackKind.Unhelpful;break;case s.ChatAgentVoteDirection.Up:$=f.ChatResultFeedbackKind.Helpful;break}l.acceptFeedback(Object.freeze(a?{result:g,kind:$,reportIssue:a}:{result:g,kind:$}))}$acceptAction(u,i,w){const a=this.c.get(u);if(!a||w.action.kind==="vote")return;const l=v.ChatAgentUserActionEvent.to(i,w,this.s.converter);l&&a.acceptAction(Object.freeze(l))}async $invokeCompletionProvider(u,i,w){const a=this.c.get(u);if(!a)return[];let l=this.m.get(u);return l?l.clear():(l=new p.$Tc,this.m.set(u,l)),(await a.invokeCompletionProvider(i,w)).map($=>v.ChatAgentCompletionItem.from($,this.s.converter,l))}async $provideWelcomeMessage(u,i,w){const a=this.c.get(u);if(a)return await a.provideWelcomeMessage(v.ChatLocation.to(i),w)}async $provideSampleQuestions(u,i,w){const a=this.c.get(u);if(a)return(await a.provideSampleQuestions(v.ChatLocation.to(i),w)).map(l=>v.ChatFollowup.from(l,void 0))}}e.$smc=n;class t{constructor(u,i,w,a,l){this.extension=u,this.id=i,this.w=w,this.x=a,this.y=l,this.m=new F.$he,this.n=new F.$he}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,i){return this.q?await this.q.provider.provideCompletionItems(u,i)??[]:[]}async provideFollowups(u,i,w){if(!this.b)return[];const a=await this.b.provideFollowups(u,i,w);return a?a.filter(l=>!(l&&"commandId"in l)).filter(l=>!(l&&"message"in l)):[]}async provideWelcomeMessage(u,i){if(!this.s)return[];const w=await this.s.provideWelcomeMessage(u,i);return w?w.map(a=>typeof a=="string"?a:v.MarkdownString.from(a)):[]}async provideSampleQuestions(u,i){if(!this.s||!this.s.provideSampleQuestions)return[];const w=await this.s.provideSampleQuestions(u,i);return w||[]}get apiAgent(){let u=!1,i=!1;const w=()=>{u||i||(i=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof N.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof f.$mN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:v.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),i=!1}))},a=this;return{get id(){return a.id},get iconPath(){return a.c},set iconPath(l){a.c=l,w()},get requestHandler(){return a.y},set requestHandler(l){(0,D.$kg)(typeof l=="function","Invalid request handler"),a.y=l},get followupProvider(){return a.b},set followupProvider(l){a.b=l,w()},get isDefault(){return(0,r.$OG)(a.extension,"defaultChatParticipant"),a.d},set isDefault(l){(0,r.$OG)(a.extension,"defaultChatParticipant"),a.d=l,w()},get helpTextPrefix(){return(0,r.$OG)(a.extension,"defaultChatParticipant"),a.g},set helpTextPrefix(l){(0,r.$OG)(a.extension,"defaultChatParticipant"),a.g=l,w()},get helpTextVariablesPrefix(){return(0,r.$OG)(a.extension,"defaultChatParticipant"),a.j},set helpTextVariablesPrefix(l){(0,r.$OG)(a.extension,"defaultChatParticipant"),a.j=l,w()},get helpTextPostfix(){return(0,r.$OG)(a.extension,"defaultChatParticipant"),a.k},set helpTextPostfix(l){(0,r.$OG)(a.extension,"defaultChatParticipant"),a.k=l,w()},get isSecondary(){return(0,r.$OG)(a.extension,"defaultChatParticipant"),a.l},set isSecondary(l){(0,r.$OG)(a.extension,"defaultChatParticipant"),a.l=l,w()},get supportIssueReporting(){return(0,r.$OG)(a.extension,"chatParticipantAdditions"),a.o},set supportIssueReporting(l){(0,r.$OG)(a.extension,"chatParticipantAdditions"),a.o=l,w()},get onDidReceiveFeedback(){return a.m.event},set participantVariableProvider(l){if((0,r.$OG)(a.extension,"chatParticipantAdditions"),a.q=l,l){if(!l.triggerCharacters.length)throw new Error("triggerCharacters are required");a.w.$registerAgentCompletionsProvider(a.x,l.triggerCharacters)}else a.w.$unregisterAgentCompletionsProvider(a.x)},get participantVariableProvider(){return(0,r.$OG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(l){(0,r.$OG)(a.extension,"defaultChatParticipant"),a.s=l,w()},get welcomeMessageProvider(){return(0,r.$OG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,r.$NG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(l){a.t=l,w()},get requester(){return a.t},set supportsSlowReferences(l){a.u=l,w()},get supportsSlowReferences(){return a.u},dispose(){u=!0,a.b=void 0,a.m.dispose(),a.w.$unregisterAgent(a.x)}}}invoke(u,i,w,a){return this.y(u,i,w,a)}}}),define(ke[265],Se([1,0,14,6,4,8,7,25]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0;class m{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(R.$nM.MainThreadChatVariables)}async $resolveVariable(S,d,v,f){const s=this.b.get(S);if(s)try{if(s.resolver.resolve2){(0,p.$OG)(s.extension,"chatParticipantAdditions");const r=new D(d,this.c),o=await s.resolver.resolve2(s.data.name,{prompt:v},r.apiObject,f);if(o&&o[0])return o[0].value}else{const r=await s.resolver.resolve(s.data.name,{prompt:v},f);if(r&&r[0])return r[0].value}}catch(r){(0,C.$2)(r)}}registerVariableResolver(S,d,v,f,s,r,o){const n=m.a++;return this.b.set(n,{extension:S,data:{id:d,name:v,description:f,modelDescription:s},resolver:o}),this.c.$registerVariable(n,{id:d,name:v,description:f,modelDescription:s,isSlow:r}),(0,O.$Sc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}}e.$tmc=m;class D{constructor(S,d){this.c=S,this.d=d,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let d=function(f){if(S.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,f),s}};const S=this,v=f=>{this.d.$handleProgressChunk(this.c,f)};this.b={progress(f){d(this.progress);const s=new M.$sO(f),r=F.ChatResponseProgressPart.from(s);return v(r),this},reference(f){d(this.reference);const s=new M.$wO(f),r=F.ChatResponseReferencePart.from(s);return v(r),this},push(f){return d(this.push),f instanceof M.$wO?v(F.ChatResponseReferencePart.from(f)):f instanceof M.$sO&&v(F.ChatResponseProgressPart.from(f)),this}}}return this.b}}}),define(ke[266],Se([1,0,11,69,5,6,2,89,21,8,7,4,25]),function(he,e,C,O,R,F,M,p,m,D,N,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=v;function v(f,s,r){const o=f.getProxy(S.$nM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Xm,s.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const y=this.b.get(b.handle);return y?y.value:b}else if(b&&b.$mid===7){const y=b,h=this.b.get(y.commentControlHandle);if(!h)return y;const E=h.getCommentThread(y.commentThreadHandle);return E?E.value:y}else if(b&&(b.$mid===9||b.$mid===8)){const y=this.b.get(b.thread.commentControlHandle);if(!y)return b;const h=y.getCommentThread(b.thread.commentThreadHandle);return h?b.$mid===8?h.value:{thread:h.value,text:b.text}:b}else if(b&&b.$mid===10){const y=this.b.get(b.thread.commentControlHandle);if(!y)return b;const h=y.getCommentThread(b.thread.commentThreadHandle);if(!h)return b;const E=b.commentUniqueId,k=h.getCommentByUniqueId(E);return k||b}else if(b&&b.$mid===11){const y=this.b.get(b.thread.commentControlHandle);if(!y)return b;const h=y.getCommentThread(b.thread.commentThreadHandle);if(!h)return b;const E=b.text,k=b.commentUniqueId,I=h.getCommentByUniqueId(k);return I?(typeof I.body=="string"?I.body=E:I.body=new N.$RM(E),I):b}return b}})}createCommentController(b,y,h){const E=n.a++,k=new c(b,E,y,h);this.b.set(k.handle,k);const I=this.c.get(b.identifier)||[];return I.push(k),this.c.set(b.identifier,I),k.value}async $createCommentThreadTemplate(b,y,h,E){const k=this.b.get(b);k&&k.$createCommentThreadTemplate(y,h,E)}async $setActiveComment(b,y){const h=this.b.get(b);h&&h.$setActiveComment(y??void 0)}async $updateCommentThreadTemplate(b,y,h){const E=this.b.get(b);E&&E.$updateCommentThreadTemplate(y,h)}$deleteCommentThread(b,y){this.b.get(b)?.$deleteCommentThread(y)}async $provideCommentingRanges(b,y,h){const E=this.b.get(b);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const k=await r.ensureDocumentData(M.URI.revive(y));return(0,C.$sh)(async()=>{const I=await E.commentingRangeProvider.provideCommentingRanges(k.document,h);let P;return Array.isArray(I)?P={ranges:I,fileComments:!1}:I?P={ranges:I.ranges||[],fileComments:I.fileComments||!1}:P=I??void 0,P}).then(I=>{let P;return I&&(P={ranges:I.ranges.map(V=>D.Range.from(V)),fileComments:I.fileComments}),P})}$toggleReaction(b,y,h,E,k){const I=this.b.get(b);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,C.$sh)(()=>{const P=I.getCommentThread(y);if(P){const V=P.getCommentByUniqueId(E.uniqueIdInThread);if(I!==void 0&&V&&I.reactionHandler)return I.reactionHandler(V,w(k))}return Promise.resolve(void 0)})}}class t{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,typeof b=="object"?((0,d.$OG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=b.resolved,this.b.applicability=b.applicability):this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,y,h,E,k,I,P,V,W){this.m=y,this.n=h,this.o=E,this.p=k,this.q=I,this.extensionDescription=P,this.r=V,this.handle=t.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$he,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Vc,this.l.value=new F.$Tc,this.n===void 0&&(this.n=`${b}.${this.handle}`),o.$createCommentThread(y,this.handle,this.n,this.o,D.Range.from(this.p),P.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{o.$deleteCommentThread(y,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(A){q.range=A},get comments(){return q.comments},set comments(A){q.comments=A},get collapsibleState(){return q.collapsibleState},set collapsibleState(A){q.collapsibleState=A},get canReply(){return q.canReply},set canReply(A){q.canReply=A},get contextValue(){return q.contextValue},set contextValue(A){q.contextValue=A},get label(){return q.label},set label(A){q.label=A},get state(){return q.state},set state(A){q.state=A},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Tc);const b=h=>Object.prototype.hasOwnProperty.call(this.b,h),y={};b("range")&&(y.range=D.Range.from(this.p)),b("label")&&(y.label=this.label),b("contextValue")&&(y.contextValue=this.contextValue??null),b("comments")&&(y.comments=this.q.map(h=>u(this,h,this.k,this.extensionDescription))),b("collapsibleState")&&(y.collapseState=a(this.g)),b("canReply")&&(y.canReply=this.canReply),b("state")&&(y.state=l(this.h)),b("applicability")&&(y.applicability=g(this.h)),b("isTemplate")&&(y.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(b){for(const y of this.k){const h=y[0],E=y[1];if(b===E)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Je([(0,O.$6h)(100)],t.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,d.$OG)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,d.$OG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,d.$OG)(this.h,"activeComment"),this.f}constructor(b,y,h,E){this.h=b,this.i=y,this.j=h,this.k=E,this.a=new Map,o.$registerCommentController(this.handle,h,E,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(I){k.options=I},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(I){k.commentingRangeProvider=I},get reactionHandler(){return k.reactionHandler},set reactionHandler(I){k.reactionHandler=I},get activeCommentThread(){return k.activeCommentThread},createCommentThread(I,P,V){return k.createCommentThread(I,P,V).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(b,y,h){y===void 0&&(0,d.$OG)(this.h,"fileComments");const E=new t(this.id,this.handle,void 0,b,y,h,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const y=this.a.get(b.commentThreadHandle);y&&(this.e=b.uniqueIdInThread?y.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=y)}$createCommentThreadTemplate(b,y,h){const E=new t(this.id,this.handle,void 0,M.URI.revive(b),D.Range.to(y),[],this.h,!0,h);return E.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate(b,y){const h=this.a.get(b);h&&(h.range=D.Range.to(y))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function u($,b,y,h){let E=y.get(b);return E||(E=++$.commentHandle,y.set(b,E)),b.state!==void 0&&(0,d.$OG)(h,"commentsDraftState"),b.reactions?.some(k=>k.reactors!==void 0)&&(0,d.$OG)(h,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:E,body:typeof b.body=="string"?b.body:D.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(k=>i(k)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function i($){return{label:$.label,iconPath:$.iconPath?D.$QO($.iconPath):void 0,count:$.count,hasReacted:$.authorHasReacted,reactors:$.reactors&&$.reactors.length>0&&typeof $.reactors[0]!="string"?$.reactors.map(b=>b.name):$.reactors}}function w($){return{label:$.label||"",count:$.count||0,iconPath:$.iconPath?M.URI.revive($.iconPath):"",authorHasReacted:$.hasReacted||!1,reactors:$.reactors?.map(b=>({name:b}))}}function a($){if($!==void 0)switch($){case N.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function l($){let b;if(typeof $=="object"?b=$.resolved:b=$,b!==void 0)switch(b){case N.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function g($){let b;if(typeof $=="object"&&(b=$.applicability),b!==void 0)switch(b){case N.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case N.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(ke[267],Se([1,0,20,73,6,16,24,2,8,64,76,4,7]),function(he,e,C,O,R,F,M,p,m,D,N,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0;class v{constructor(w,a){this.document=w,this.b=a,this.a=1,this.c=new N.$dmc("custom documents")}addEdit(w){return this.c.add([w])}async undo(w,a){await this.f(w).undo(),a||this.disposeBackup()}async redo(w,a){await this.f(w).redo(),a||this.disposeBackup()}disposeEdits(w){for(const a of w)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const w=u(this.document.uri)+this.a++;return(0,M.$bh)(this.b,w)}updateBackup(w){this.d?.delete(),this.d=w}disposeBackup(){this.d?.delete(),this.d=void 0}f(w){const a=this.c.get(w,0);if(!a)throw new Error("No edit found");return a}}class f{constructor(){this.a=new Map}get(w,a){return this.a.get(this.b(w,a))}add(w,a,l){const g=this.b(w,a.uri);if(this.a.has(g))throw new Error(`Document already exists for viewType:${w} resource:${a.uri}`);const $=new v(a,l);return this.a.set(g,$),$}delete(w,a){const l=this.b(w,a.uri);this.a.delete(l)}b(w,a){return`${w}@@@${a}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class r{constructor(){this.a=new Map}addTextProvider(w,a,l){return this.b(w,{type:0,extension:a,provider:l})}addCustomProvider(w,a,l){return this.b(w,{type:1,extension:a,provider:l})}get(w){return this.a.get(w)}b(w,a){if(this.a.has(w))throw new Error(`Provider for viewType:${w} already registered`);return this.a.set(w,a),new d.$pM(()=>this.a.delete(w))}}class o{constructor(w,a,l,g,$){this.d=a,this.f=l,this.g=g,this.h=$,this.b=new r,this.c=new f,this.a=w.getProxy(S.$nM.MainThreadCustomEditors)}registerCustomEditorProvider(w,a,l,g){const $=new R.$Tc;return t(l)?($.add(this.b.addTextProvider(a,w,l)),this.a.$registerTextEditorProvider((0,D.$Mmc)(w),a,g.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,D.$Kmc)(w))):($.add(this.b.addCustomProvider(a,w,l)),n(l)&&$.add(l.onDidChangeCustomDocument(b=>{const y=this.i(a,b.document.uri);if(c(b)){const h=y.addEdit(b);this.a.$onDidEdit(b.document.uri,a,h,b.label)}else this.a.$onContentChange(b.document.uri,a)})),this.a.$registerCustomEditorProvider((0,D.$Mmc)(w),a,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,D.$Kmc)(w))),d.$pM.from($,new d.$pM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(w,a,l,g,$){const b=this.b.get(a);if(!b)throw new Error(`No provider found for '${a}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${a}'`);const y=p.URI.revive(w),h=await b.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:g?.buffer},$);let E;return n(b.provider)&&this.f&&(E=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(a,h,E),{editable:n(b.provider)}}async $disposeCustomDocument(w,a){const l=this.b.get(a);if(!l)throw new Error(`No provider found for '${a}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${a}'`);const g=p.URI.revive(w),{document:$}=this.i(a,g);this.c.delete(a,$),$.dispose()}async $resolveCustomEditor(w,a,l,g,$,b){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const h=m.ViewColumn.to($),E=this.g.createNewWebview(a,g.contentOptions,y.extension),k=this.h.createNewWebviewPanel(a,l,g.title,h,g.options,E,g.active),I=p.URI.revive(w);switch(y.type){case 1:{const{document:P}=this.i(l,I);return y.provider.resolveCustomEditor(P,k,b)}case 0:{const P=this.d.getDocument(I);return y.provider.resolveCustomTextEditor(P,k,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(w,a,l){this.i(a,w).disposeEdits(l)}async $onMoveCustomEditor(w,a,l){const g=this.b.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const $=this.h.getWebviewPanel(w);if(!$)throw new Error("No webview found");const b=p.URI.revive(a),y=this.d.getDocument(b);await g.provider.moveCustomTextEditor(y,$,C.CancellationToken.None)}async $undo(w,a,l,g){return this.i(a,w).undo(l,g)}async $redo(w,a,l,g){return this.i(a,w).redo(l,g)}async $revert(w,a,l){const g=this.i(a,w);await this.j(a).revertCustomDocument(g.document,l),g.disposeBackup()}async $onSave(w,a,l){const g=this.i(a,w);await this.j(a).saveCustomDocument(g.document,l),g.disposeBackup()}async $onSaveAs(w,a,l,g){const $=this.i(a,w);return this.j(a).saveCustomDocumentAs($.document,p.URI.revive(l),g)}async $backup(w,a,l){const g=this.i(a,w),b=await this.j(a).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},l);return g.updateBackup(b),b.id}i(w,a){const l=this.c.get(w,p.URI.revive(a));if(!l)throw new Error("No custom document found");return l}j(w){const l=this.b.get(w)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$Pmc=o;function n(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function u(i){const w=i.scheme===F.Schemas.file||i.scheme===F.Schemas.untitled?i.fsPath:i.toString();return(0,O.$oj)(w)+""}}),define(ke[268],Se([1,0,172,101,2,4,7,8,5,12,28,47]),function(he,e,C,O,R,F,M,p,m,D,N,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=e.$kmc=void 0;class v{#e;#t;#i;constructor(r,o,n,t,c,u,i,w){this.d=r,this.e=o,this.f=n,this.g=t,this.h=c,this.c=!1,this.f=Math.max(t,n),this.#i=new N.$Ac(a=>u.getComparisonKey(a)),this.#e=i,this.#t=w}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(r,o){if(!r){this.clear();return}this.j();let n=[];if(R.URI.isUri(r)){if(!o){this.delete(r);return}this.#i.set(r,o.slice()),n=[r]}else if(Array.isArray(r)){n=[];let u;r=[...r].sort(v.k);for(const i of r){const[w,a]=i;if((!u||w.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=w,n.push(w),this.#i.set(w,[])),a)this.#i.get(w)?.push(...a);else{const l=this.#i.get(w);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const t=[];let c=0;for(const u of n){let i=[];const w=this.#i.get(u);if(w)if(w.length>this.g){i=[];const a=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const g of w)if(g.severity===a[l]&&i.push({...p.Diagnostic.from(g),modelVersionId:this.h(u)})===this.g)break e;i.push({severity:O.MarkerSeverity.Info,message:(0,C.localize)(0,null,w.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=w.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(u)}));if(t.push([u,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,t)}delete(r){this.j(),this.#t.fire([r]),this.#i.delete(r),this.#e?.$changeMany(this.e,[[r,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(r,o){this.j();for(const[n,t]of this)r.call(o,n,t,this)}*[Symbol.iterator](){this.j();for(const r of this.#i.keys())yield[r,this.get(r)]}get(r){this.j();const o=this.#i.get(r);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(r){return this.j(),Array.isArray(this.#i.get(r))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(r,o){return r[0].toString()<o[0].toString()?-1:r[0].toString()>o[0].toString()?1:0}}e.$kmc=v;let f=class{static{d=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*d.d}static _mapper(r){const o=new N.$Ac;for(const n of r)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(r,o,n,t){this.j=o,this.k=n,this.l=t,this.g=new Map,this.h=new m.$le({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,d._mapper),this.f=r.getProxy(F.$nM.MainThreadDiagnostics)}createDiagnosticCollection(r,o){const{g:n,f:t,h:c,j:u,k:i,l:w}=this,a=new class{$changeMany($,b){t.$changeMany($,b),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,$,b.length===0?"CLEARING":b)}$clear($){t.$clear($),u.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,$)}dispose(){t.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+d.c++,l=o;else if(!n.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+d.c++;while(n.has(l))}return new class extends v{constructor(){super(o,l,d.e,d.d,$=>w.getDocument($)?.version,i.extUri,a,c),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(r){if(r)return this.m(r);{const o=new Map,n=[];for(const t of this.g.values())t.forEach((c,u)=>{let i=o.get(c.toString());typeof i>"u"&&(i=n.length,o.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...u)});return n}}m(r){let o=[];for(const n of this.g.values())n.has(r)&&(o=o.concat(n.get(r)));return o}$acceptMarkersChange(r){if(!this.n){const o="_generated_mirror",n=new v(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of r)this.n.set(R.URI.revive(o),n.map(p.Diagnostic.to))}};e.$lmc=f,e.$lmc=f=d=Je([We(1,D.$7j),We(2,S.$jmc)],f)}),define(ke[269],Se([1,0,2,14,7,8,200,34]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tnc=void 0;class m{constructor(N,S,d,v={timeout:1500,errors:3}){this.c=N,this.d=S,this.f=d,this.g=v,this.a=new M.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(N){return(S,d,v)=>{const s={dispose:this.a.push([S,d,N])};return Array.isArray(v)&&v.push(s),s}}async $participateInSave(N,S){const d=C.URI.revive(N);let v=!1;const f=setTimeout(()=>v=!0,this.g.timeout),s=[];try{for(const r of[...this.a]){if(v)break;const o=this.d.getDocument(d),n=await this.h(r,{document:o,reason:F.TextDocumentSaveReason.to(S)});s.push(n)}}finally{clearTimeout(f)}return s}h([N,S,d],v){const f=this.b.get(N);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(d,N,S,v).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const r=this.b.get(N);this.b.set(N,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(N,S,d,v){const f=[],s=Date.now(),{document:r,reason:o}=v,{version:n}=r,t=Object.freeze({document:r,reason:o,waitUntil(c){if(Object.isFrozen(f))throw(0,O.$8)("waitUntil can not be called async");f.push(Promise.resolve(c))}});try{S.apply(d,[t])}catch(c){return Promise.reject(c)}return Object.freeze(f),new Promise((c,u)=>{const i=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(f).then(w=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${N.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(i),c(w)}).catch(w=>{clearTimeout(i),u(w)})}).then(c=>{const u={edits:[]};for(const i of c)if(Array.isArray(i)&&i.every(w=>w instanceof R.$wM))for(const{newText:w,newEol:a,range:l}of i)u.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:l&&F.Range.from(l),text:w,eol:a&&F.EndOfLine.from(a)}});if(u.edits.length!==0)return n===r.version?this.f.$tryApplyWorkspaceEdit(new p.$Hw(u)):Promise.reject(new Error("concurrent_edits"))})}}e.$tnc=m}),define(ke[270],Se([1,0,5,6,2,4,113,8,15,26,7]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class S{constructor(v,f){this.a=new C.$he,this.b=new C.$he,this.c=new C.$he,this.d=new C.$he,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=v.getProxy(F.$nM.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(s=>{for(const r of s)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const r of s)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const f=this.g.getDocument(v);if(f)return f}getDocument(v){const f=this.getDocumentData(v);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return f.document}ensureDocumentData(v){const f=this.g.getDocument(v);if(f)return Promise.resolve(f);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(r=>{this.h.delete(v.toString());const o=R.URI.revive(r);return(0,m.$lg)(this.g.getDocument(o))},r=>(this.h.delete(v.toString()),Promise.reject(r))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then(f=>R.URI.revive(f))}$acceptModelLanguageChanged(v,f){const s=R.URI.revive(v),r=this.g.getDocument(s);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(f),this.a.fire(r.document)}$acceptModelSaved(v){const f=R.URI.revive(v),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,f){const s=R.URI.revive(v),r=this.g.getDocument(s);if(!r)throw new Error("unknown document");r._acceptIsDirty(f),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,f,s){const r=R.URI.revive(v),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(s),o.onEvents(f);let n;f.isUndoing?n=N.TextDocumentChangeReason.Undo:f.isRedoing&&(n=N.TextDocumentChangeReason.Redo),this.c.fire((0,D.$8n)({document:o.document,contentChanges:f.changes.map(t=>({range:p.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:n}))}setWordDefinitionFor(v,f){(0,M.$TO)(v,f)}}e.$mmc=S}),define(ke[67],Se([1,0,271,5,15,2,3,4,17,8,7]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=e.$Qmc=void 0,e.$Qmc=(0,M.$Ai)("IExtHostEditorTabs");class S{constructor(r,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,o={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new N.$aO(F.URI.revive(this.b.input.uri));case 2:return new N.$bO(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new N.$cO(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new N.$dO(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new N.$eO(this.b.input.viewType);case 4:return new N.$fO(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new N.$gO(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new N.$hO;case 9:return new N.$iO(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new N.$jO;case 11:return new N.$kO(this.b.input.diffEditors.map(r=>new N.$bO(F.URI.revive(r.original),F.URI.revive(r.modified))));default:return}}}class d{constructor(r,o){this.c=[],this.d="",this.b=r,this.e=o;for(const n of r.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,o={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return D.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(n=>n.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const n=new S(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,n),r.tabDto.isActive&&(this.d=n.tabId),n}else if(r.kind===1){const n=this.c.splice(r.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(r.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,n),n}const o=this.c.find(n=>n.tabId===r.tabDto.id);if(!o)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(r.tabDto),o}activeTabId(){return this.d}}let v=class{constructor(r){this.b=new O.$he,this.c=new O.$he,this.e=[],this.a=r.getProxy(p.$nM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,o={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(n=>n.apiObject))},get activeTabGroup(){const n=r.d;return(0,R.$lg)(r.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,t)=>{const c=Array.isArray(n)?n:[n];return c.length?f(c[0])?this.j(c,t):this.i(c,t):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(r){const o=new Set(this.e.map(a=>a.groupId)),n=new Set(r.map(a=>a.groupId)),t=(0,C.$L)(o,n),c=this.e.filter(a=>t.removed.includes(a.groupId)).map(a=>a.apiObject),u=[],i=[];this.e=r.map(a=>{const l=new d(a,()=>this.d);return t.added.includes(l.groupId)?u.push(l.apiObject):i.push(l.apiObject),l});const w=(0,R.$lg)(r.find(a=>a.isActive===!0)?.groupId);w!==void 0&&this.d!==w&&(this.d=w),this.c.fire(Object.freeze({opened:u,closed:c,changed:i}))}$acceptTabGroupUpdate(r){const o=this.e.find(n=>n.groupId===r.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const o=this.e.find(t=>t.groupId===r.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(r){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===r)return n}h(r){return this.e.find(o=>o.apiObject===r)}async i(r,o){const n=[];for(const t of r){const c=this.g(t);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,o)}async j(r,o){const n=[];for(const t of r){const c=this.h(t);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,o)}};e.$Rmc=v,e.$Rmc=v=Je([We(0,m.$RO)],v);function f(s){return s.tabs!==void 0}}),define(ke[272],Se([1,0,2,4,6,7,8,314,13,22,25,55]),function(he,e,C,O,R,F,M,p,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wnc=void 0;class d{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const r=this.a.indexOf(s);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),r=[];let o,n,t=14,c=14;for(const u of s){let i=o?(0,m.$Df)(o,u):0;for(i===0?n=1:n=c;i<u.length;i++)i+1===u.length?(t=c,c=9):c+=1,r.push([n,u.toUpperCase().charCodeAt(i),c]),r.push([n,u.toLowerCase().charCodeAt(i),c]),n=c;o=u,c=t}r.push([9,58,10]),r.push([10,47,12]),this.b=new p.$W2(r)}}provideDocumentLinks(s){this.c();const r=[],o=p.$X2.computeLinks({getLineContent(n){return s.lineAt(n-1).text},getLineCount(){return s.lineCount}},this.b);for(const n of o){const t=M.DocumentLink.to(n);t.target&&r.push(t)}return r}}class v{constructor(s,r){this.i=r,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(O.$nM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,r,o,n={}){if(v.j(o),this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const t=this.h++;this.b.add(r),this.d.add(r),this.c.set(t,o);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof o.copy=="function"&&(c+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,N.$OG)(s,"fsChunks"),c+=4);let u;n.isReadonly&&(0,S.$Zk)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,r,c,u).catch(w=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${r}`),console.error(w)});const i=o.onDidChangeFile(w=>{const a=[];for(const l of w){const{uri:g,type:$}=l;if(g.scheme!==r)continue;let b;switch($){case F.FileChangeType.Changed:b=0;break;case F.FileChangeType.Created:b=1;break;case F.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:g,type:b})}this.a.$onFileSystemChange(t,a)});return(0,R.$Sc)(()=>{i.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:r,ctime:o,mtime:n,size:t,permissions:c}=s;return{type:r,ctime:o,mtime:n,size:t,permissions:c}}$stat(s,r){return Promise.resolve(this.l(s).stat(C.URI.revive(r))).then(o=>v.k(o))}$readdir(s,r){return Promise.resolve(this.l(s).readDirectory(C.URI.revive(r)))}$readFile(s,r){return Promise.resolve(this.l(s).readFile(C.URI.revive(r))).then(o=>D.$Je.wrap(o))}$writeFile(s,r,o,n){return Promise.resolve(this.l(s).writeFile(C.URI.revive(r),o.buffer,n))}$delete(s,r,o){return Promise.resolve(this.l(s).delete(C.URI.revive(r),o))}$rename(s,r,o,n){return Promise.resolve(this.l(s).rename(C.URI.revive(r),C.URI.revive(o),n))}$copy(s,r,o,n){const t=this.l(s);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(C.URI.revive(r),C.URI.revive(o),n))}$mkdir(s,r){return Promise.resolve(this.l(s).createDirectory(C.URI.revive(r)))}$watch(s,r,o,n){const t=this.l(s).watch(C.URI.revive(o),n);this.f.set(r,t)}$unwatch(s,r){const o=this.f.get(r);o&&(o.dispose(),this.f.delete(r))}$open(s,r,o){const n=this.l(s);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(C.URI.revive(r),o))}$close(s,r){const o=this.l(s);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(r))}$read(s,r,o,n){const t=this.l(s);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const c=D.$Je.alloc(n);return Promise.resolve(t.read(r,o,c.buffer,0,n)).then(u=>c.slice(0,u))}$write(s,r,o,n){const t=this.l(s);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(r,o,n.buffer,0,n.byteLength))}l(s){const r=this.c.get(s);if(!r){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return r}}e.$wnc=v}),define(ke[273],Se([1,0,5,37,2,4,8,7,43]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=void 0;class D{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,f,s,r,o,n){this.a=Math.random(),this.b=new C.$he,this.c=new C.$he,this.d=new C.$he,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const t=(0,O.$uk)(o),c=typeof o=="string",u=n?.correlate,i=r(w=>{if(!(typeof w.session=="number"&&w.session!==this.a)&&!(u&&typeof w.session>"u")){if(!n?.ignoreCreateEvents)for(const a of w.created){const l=R.URI.revive(a);t(l.fsPath)&&(!c||f.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const a of w.changed){const l=R.URI.revive(a);t(l.fsPath)&&(!c||f.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const a of w.deleted){const l=R.URI.revive(a);t(l.fsPath)&&(!c||f.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=p.$pM.from(this.i(v,s,o,n,n?.correlate),this.b,this.c,this.d,i)}i(v,f,s,r,o){const n=p.$pM.from();if(typeof s=="string"||r?.ignoreChangeEvents&&r?.ignoreCreateEvents&&r?.ignoreDeleteEvents)return n;const t=v.getProxy(F.$nM.MainThreadFileSystemEventService);let c=!1;(s.pattern.includes(O.$qk)||s.pattern.includes(O.$rk))&&(c=!0);let u;return o&&(r?.ignoreChangeEvents||r?.ignoreCreateEvents||r?.ignoreDeleteEvents)&&(u=14,r?.ignoreChangeEvents&&(u&=-3),r?.ignoreCreateEvents&&(u&=-5),r?.ignoreDeleteEvents&&(u&=-9)),t.$watch(f.identifier.value,this.a,s.baseUri,{recursive:c,excludes:r?.excludes??[],filter:u},!!o),p.$pM.from({dispose:()=>t.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class N{constructor(v){this.a=v,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(R.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(v,f,s){this.j=v,this.k=f,this.l=s,this.a=new C.$he,this.b=new C.$he,this.c=new C.$he,this.d=new C.$he,this.g=new C.$je,this.h=new C.$je,this.i=new C.$je,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,f,s,r){return new D(this.j,v,f,this.a.event,M.GlobPattern.from(s),r)}$onFileEvent(v){this.a.fire(new N(v))}$onDidRunFileOperation(v,f){switch(v){case 2:this.b.fire(Object.freeze({files:f.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(s=>R.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(s=>R.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,f){return(s,r,o)=>{const n=function(c){s.call(r,c)};return n.extension=v,f.event(n,void 0,o)}}async $onWillRunFileOperation(v,f,s,r){switch(v){case 2:return await this.n(this.g,{files:f.map(o=>({oldUri:R.URI.revive(o.source),newUri:R.URI.revive(o.target)}))},s,r);case 1:return await this.n(this.i,{files:f.map(o=>R.URI.revive(o.target))},s,r);case 0:case 3:return await this.n(this.h,{files:f.map(o=>R.URI.revive(o.target))},s,r)}}async n(v,f,s,r){const o=new Set,n=[];if(await v.fireAsync(f,r,async(c,u)=>{const i=Date.now(),w=await Promise.resolve(c);w instanceof p.$zM&&(n.push([u.extension,w]),o.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",u.extension.identifier)}),r.isCancellationRequested||n.length===0)return;const t={edits:[]};for(const[,c]of n){const{edits:u}=M.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});t.edits=t.edits.concat(u)}return{edit:t,extensionNames:Array.from(o)}}}e.$xnc=S}),define(ke[274],Se([1,0,18,11,20,14,91,6,26,66,13,15,2,30,315,89,98,174,21,8,7,25,76,4]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c,u,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;class a{constructor(j,z){this.d=j,this.e=z}async provideDocumentSymbols(j,z){const G=this.d.getDocument(j),H=await this.e.provideDocumentSymbols(G,z);if(!(0,C.$Kb)(H))return H[0]instanceof c.$JM?H.map(t.DocumentSymbol.from):a.f(H)}static f(j){j=j.slice(0).sort((H,te)=>{let ne=H.location.range.start.compareTo(te.location.range.start);return ne===0&&(ne=te.location.range.end.compareTo(H.location.range.end)),ne});const z=[],G=[];for(const H of j){const te={name:H.name||"!!MISSING: name!!",kind:t.SymbolKind.from(H.kind),tags:H.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:t.Range.from(H.location.range),selectionRange:t.Range.from(H.location.range),children:[]};for(;;){if(G.length===0){G.push(te),z.push(te);break}const ne=G[G.length-1];if(v.$At.containsRange(ne.range,te.range)&&!v.$At.equalsRange(ne.range,te.range)){ne.children?.push(te),G.push(te);break}G.pop()}}return z}}class l{constructor(j,z,G,H,te,ne){this.f=j,this.g=z,this.h=G,this.j=H,this.k=te,this.l=ne,this.d=new i.$dmc("CodeLens"),this.e=new Map}async provideCodeLenses(j,z){const G=this.f.getDocument(j),H=await this.h.provideCodeLenses(G,z);if(!H||z.isCancellationRequested)return;const te=this.d.add(H),ne=new p.$Tc;this.e.set(te,ne);const Oe={cacheId:te,lenses:[]};for(let Be=0;Be<H.length;Be++)Oe.lenses.push({cacheId:[te,Be],range:t.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,ne)});return Oe}async resolveCodeLens(j,z){const G=j.cacheId&&this.d.get(...j.cacheId);if(!G)return;let H;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?H=G:H=await this.h.resolveCodeLens(G,z),H||(H=G),z.isCancellationRequested)return;const te=j.cacheId&&this.e.get(j.cacheId[0]);if(te){if(!H.command){const ne=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ne),this.l.error(ne);return}return j.command=this.g.toInternal(H.command,te),j}}releaseCodeLenses(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}}function g(je){return Array.isArray(je)?je.map(t.DefinitionLink.from):je?[t.DefinitionLink.from(je)]:[]}class ${constructor(j,z){this.d=j,this.e=z}async provideDefinition(j,z,G){const H=this.d.getDocument(j),te=t.Position.to(z),ne=await this.e.provideDefinition(H,te,G);return g(ne)}}class b{constructor(j,z){this.d=j,this.e=z}async provideDeclaration(j,z,G){const H=this.d.getDocument(j),te=t.Position.to(z),ne=await this.e.provideDeclaration(H,te,G);return g(ne)}}class y{constructor(j,z){this.d=j,this.e=z}async provideImplementation(j,z,G){const H=this.d.getDocument(j),te=t.Position.to(z),ne=await this.e.provideImplementation(H,te,G);return g(ne)}}class h{constructor(j,z){this.d=j,this.e=z}async provideTypeDefinition(j,z,G){const H=this.d.getDocument(j),te=t.Position.to(z),ne=await this.e.provideTypeDefinition(H,te,G);return g(ne)}}class E{static{this.f=10}constructor(j,z){this.g=j,this.h=z,this.d=0,this.e=new Map}async provideHover(j,z,G,H){const te=this.g.getDocument(j),ne=t.Position.to(z);let Oe;if(G&&G.verbosityRequest){const xe=G.verbosityRequest.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:G.verbosityRequest.action,previousHover:et};Oe=await this.h.provideHover(te,ne,H,tt)}else Oe=await this.h.provideHover(te,ne,H);if(!Oe||(0,C.$Kb)(Oe.contents))return;Oe.range||(Oe.range=te.getWordRangeAtPosition(ne)),Oe.range||(Oe.range=new c.$rM(ne,ne));const Be=t.Hover.from(Oe),He=this.d;if(this.e.size===E.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(He,Oe),this.d+=1,{...Be,id:He}}releaseHover(j){this.e.delete(j)}}class k{constructor(j,z){this.d=j,this.e=z}async provideEvaluatableExpression(j,z,G){const H=this.d.getDocument(j),te=t.Position.to(z),ne=await this.e.provideEvaluatableExpression(H,te,G);if(ne)return t.EvaluatableExpression.from(ne)}}class I{constructor(j,z){this.d=j,this.e=z}async provideInlineValues(j,z,G,H){const te=this.d.getDocument(j),ne=await this.e.provideInlineValues(te,t.Range.to(z),t.InlineValueContext.to(G),H);if(Array.isArray(ne))return ne.map(Oe=>t.InlineValue.from(Oe))}}class P{constructor(j,z){this.d=j,this.e=z}async provideDocumentHighlights(j,z,G){const H=this.d.getDocument(j),te=t.Position.to(z),ne=await this.e.provideDocumentHighlights(H,te,G);if(Array.isArray(ne))return ne.map(t.DocumentHighlight.from)}}class V{constructor(j,z){this.d=j,this.e=z}async provideMultiDocumentHighlights(j,z,G,H){const te=this.d.getDocument(j),ne=G.map(He=>this.d.getDocument(He)),Oe=t.Position.to(z),Be=await this.e.provideMultiDocumentHighlights(te,Oe,ne,H);if(Array.isArray(Be))return Be.map(t.MultiDocumentHighlight.from)}}class W{constructor(j,z){this.d=j,this.e=z}async provideLinkedEditingRanges(j,z,G){const H=this.d.getDocument(j),te=t.Position.to(z),ne=await this.e.provideLinkedEditingRanges(H,te,G);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,C.$Hb)(ne.ranges.map(t.Range.from)),wordPattern:ne.wordPattern}}}class q{constructor(j,z){this.d=j,this.e=z}async provideReferences(j,z,G,H){const te=this.d.getDocument(j),ne=t.Position.to(z),Oe=await this.e.provideReferences(te,ne,G,H);if(Array.isArray(Oe))return Oe.map(t.location.from)}}class A{static{this.d=1e3}constructor(j,z,G,H,te,ne,Oe){this.g=j,this.h=z,this.j=G,this.k=H,this.l=te,this.m=ne,this.n=Oe,this.e=new i.$dmc("CodeAction"),this.f=new Map}async provideCodeActions(j,z,G,H){const te=this.g.getDocument(j),ne=f.$Ct.isISelection(z)?t.Selection.to(z):t.Range.to(z),Oe=[];for(const tt of this.j.getDiagnostics(j))if(ne.intersection(tt.range)&&Oe.push(tt)>A.d)break;const Be={diagnostics:Oe,only:G.only?new c.$LM(G.only):void 0,triggerKind:t.CodeActionTriggerKind.to(G.trigger)},He=await this.k.provideCodeActions(te,ne,Be,H);if(!(0,C.$Lb)(He)||H.isCancellationRequested)return;const _e=this.e.add(He),xe=new p.$Tc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<He.length;tt++){const it=He[tt];if(it)if(A.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,xe)});else{Be.only&&(it.kind?Be.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=it.ranges??[];et.push({cacheId:[_e,tt],title:it.title,command:it.command&&this.h.toInternal(it.command,xe),diagnostics:it.diagnostics&&it.diagnostics.map(t.Diagnostic.from),edit:it.edit&&t.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,u.$NG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,u.$NG)(this.m,"codeActionRanges")?(0,C.$Hb)(at.map(t.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(j,z){const[G,H]=j,te=this.e.get(G,H);if(!te||A.o(te))return{};if(!this.k.resolveCodeAction)return{};const ne=await this.k.resolveCodeAction(te,z)??te;let Oe;ne.edit&&(Oe=t.WorkspaceEdit.from(ne.edit,void 0));let Be;if(ne.command){const He=this.f.get(G);He&&(Be=this.h.toInternal(ne.command,He))}return{edit:Oe,command:Be}}releaseCodeActions(j){this.f.get(j)?.dispose(),this.f.delete(j),this.e.delete(j)}static o(j){return typeof j.command=="string"&&typeof j.title=="string"}}class U{constructor(j,z,G,H,te){this.e=j,this.f=z,this.g=G,this.h=H,this.j=te,this.d=new i.$dmc("DocumentPasteEdit")}async prepareDocumentPaste(j,z,G,H){if(!this.g.prepareDocumentPaste)return;const te=this.f.getDocument(j),ne=z.map(He=>t.Range.to(He)),Oe=t.DataTransfer.toDataTransfer(G,()=>{throw new F.$$});if(await this.g.prepareDocumentPaste(te,ne,Oe,H),H.isCancellationRequested)return;const Be=Array.from(Oe).filter(([,He])=>!(He instanceof c.$fN));return t.DataTransfer.from(Be)}async providePasteEdits(j,z,G,H,te,ne){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(z),Be=G.map(et=>t.Range.to(et)),He=t.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolvePasteFileData(this.h,j,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,Be,He,{only:te.only?new c.$kN(te.only):void 0,triggerKind:te.triggerKind},ne);if(!_e||ne.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?t.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(j,z){const[G,H]=j,te=this.d.get(G,H);if(!te||!this.g.resolveDocumentPasteEdit)return{};const ne=await this.g.resolveDocumentPasteEdit(te,z)??te;return{additionalEdit:ne.additionalEdit?t.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releasePasteEdits(j){this.d.delete(j)}}class K{constructor(j,z){this.d=j,this.e=z}async provideDocumentFormattingEdits(j,z,G){const H=this.d.getDocument(j),te=await this.e.provideDocumentFormattingEdits(H,z,G);if(Array.isArray(te))return te.map(t.TextEdit.from)}}class ie{constructor(j,z){this.d=j,this.e=z}async provideDocumentRangeFormattingEdits(j,z,G,H){const te=this.d.getDocument(j),ne=t.Range.to(z),Oe=await this.e.provideDocumentRangeFormattingEdits(te,ne,G,H);if(Array.isArray(Oe))return Oe.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(j,z,G,H){(0,S.$kg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const te=this.d.getDocument(j),ne=z.map(t.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(te,ne,G,H);if(Array.isArray(Oe))return Oe.map(t.TextEdit.from)}}class ce{constructor(j,z){this.d=j,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,z,G,H,te){const ne=this.d.getDocument(j),Oe=t.Position.to(z),Be=await this.e.provideOnTypeFormattingEdits(ne,Oe,G,H,te);if(Array.isArray(Be))return Be.map(t.TextEdit.from)}}class ve{constructor(j,z){this.e=j,this.f=z,this.d=new i.$dmc("WorkspaceSymbols")}async provideWorkspaceSymbols(j,z){const G=await this.e.provideWorkspaceSymbols(j,z);if(!(0,C.$Lb)(G))return{symbols:[]};const H=this.d.add(G),te={cacheId:H,symbols:[]};for(let ne=0;ne<G.length;ne++){const Oe=G[ne];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}te.symbols.push({...t.WorkspaceSymbol.from(Oe),cacheId:[H,ne]})}return te}async resolveWorkspaceSymbol(j,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!j.cacheId)return j;const G=this.d.get(...j.cacheId);if(G){const H=await this.e.resolveWorkspaceSymbol(G,z);return H&&(0,m.$0n)(j,t.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(j){this.d.delete(j)}}class Ee{static supportsResolving(j){return typeof j.prepareRename=="function"}constructor(j,z,G){this.d=j,this.e=z,this.f=G}async provideRenameEdits(j,z,G,H){const te=this.d.getDocument(j),ne=t.Position.to(z);try{const Oe=await this.e.provideRenameEdits(te,ne,G,H);return Oe?t.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Be=Ee.g(Oe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(j,z,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(j),te=t.Position.to(z);try{const ne=await this.e.prepareRename(H,te,G);let Oe,Be;if(c.$rM.isRange(ne)?(Oe=ne,Be=H.getText(ne)):(0,S.$cg)(ne)&&(Oe=ne.range,Be=ne.placeholder),!Oe||!Be)return;if(Oe.start.line>te.line||Oe.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Oe),text:Be}}catch(ne){const Oe=Ee.g(ne);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(ne)}}static g(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ge{static{this.d={[s.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[s.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(j,z,G){this.e=j,this.f=z,this.g=G}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(j,z,G,H){const te=this.e.getDocument(j),ne=t.Range.to(z);try{const Oe=ge.d[G],Be=await this.f.provideNewSymbolNames(te,ne,Oe,H);return Be?Be.map(He=>typeof He=="string"?{newSymbolName:He}:{newSymbolName:He.newSymbolName,tags:He.tags}):void 0}catch(Oe){this.g.error(ge.h(Oe)??JSON.stringify(Oe,null,"	"));return}}static h(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class ue{constructor(j,z){this.resultId=j,this.tokens=z}}class Ce{constructor(j,z){this.f=j,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(j,z,G){const H=this.f.getDocument(j),te=z!==0?this.d.get(z):null;let ne=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,te.resultId,G):await this.g.provideDocumentSemanticTokens(H,G);return te&&this.d.delete(z),ne?(ne=Ce.h(ne),this.o(Ce.n(te,ne),ne)):null}async releaseDocumentSemanticColoring(j){this.d.delete(j)}static h(j){return Ce.j(j)?Ce.k(j)?j:new c.$KN(new Uint32Array(j.data),j.resultId):Ce.l(j)?Ce.m(j)?j:new c.$MN(j.edits.map(z=>new c.$LN(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),j.resultId):j}static j(j){return j&&!!j.data}static k(j){return j.data instanceof Uint32Array}static l(j){return j&&Array.isArray(j.edits)}static m(j){for(const z of j.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(j,z){if(!Ce.j(z)||!j||!j.tokens)return z;const G=j.tokens,H=G.length,te=z.data,ne=te.length;let Oe=0;const Be=Math.min(H,ne);for(;Oe<Be&&G[Oe]===te[Oe];)Oe++;if(Oe===H&&Oe===ne)return new c.$MN([],z.resultId);let He=0;const _e=Be-Oe;for(;He<_e&&G[H-He-1]===te[ne-He-1];)He++;return new c.$MN([{start:Oe,deleteCount:H-Oe-He,data:te.subarray(Oe,ne-He)}],z.resultId)}o(j,z){if(Ce.j(j)){const G=this.e++;return this.d.set(G,new ue(j.resultId,j.data)),(0,r.$Nbb)({id:G,type:"full",data:j.data})}if(Ce.l(j)){const G=this.e++;return Ce.j(z)?this.d.set(G,new ue(z.resultId,z.data)):this.d.set(G,new ue(j.resultId)),(0,r.$Nbb)({id:G,type:"delta",deltas:(j.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class re{constructor(j,z){this.d=j,this.e=z}async provideDocumentRangeSemanticTokens(j,z,G){const H=this.d.getDocument(j),te=await this.e.provideDocumentRangeSemanticTokens(H,t.Range.to(z),G);return te?this.f(te):null}f(j){return(0,r.$Nbb)({id:0,type:"full",data:j.data})}}class Ne{static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}constructor(j,z,G,H,te){this.f=j,this.g=z,this.h=G,this.j=H,this.k=te,this.d=new i.$dmc("CompletionItem"),this.e=new Map}async provideCompletionItems(j,z,G,H){const te=this.f.getDocument(j),ne=t.Position.to(z),Oe=te.getWordRangeAtPosition(ne)||new c.$rM(ne,ne),Be=Oe.with({end:ne}),He=new D.$be,_e=await this.h.provideCompletionItems(te,ne,H,t.CompletionContext.to(G));if(!_e||H.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$YM(_e):_e,et=Ne.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new p.$Tc;this.e.set(et,tt);const it=[],at={x:et,b:it,a:{replace:t.Range.from(Oe),insert:t.Range.from(Be)},c:xe.isIncomplete||void 0,d:He.elapsed()};for(let mt=0;mt<xe.items.length;mt++){const Ue=xe.items[mt],rt=this.l(Ue,[et,mt],Be,Oe);it.push(rt)}return at}async resolveCompletionItem(j,z){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...j);if(!G)return;const H=this.l(G,j),te=await this.h.resolveCompletionItem(G,z);if(!te)return;const ne=this.l(te,j);return(H.h!==ne.h||H.i!==ne.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==ne.n||H.o!==ne.o||!(0,m.$$n)(H.p,ne.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:ne.d,c:ne.c,l:ne.l,h:ne.h,i:ne.i,n:ne.n,o:ne.o,p:ne.p}}releaseCompletionItems(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,z,G,H){const te=this.e.get(z[0]);if(!te)throw Error("DisposableStore is missing...");const ne=this.g.toInternal(j.command,te),Oe={x:z,a:j.label,b:j.kind!==void 0?t.CompletionItemKind.from(j.kind):void 0,m:j.tags&&j.tags.map(t.CompletionItemTag.from),c:j.detail,d:typeof j.documentation>"u"?void 0:t.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters?.join(""),l:j.additionalTextEdits&&j.additionalTextEdits.map(t.TextEdit.from),n:ne?.$ident,o:ne?.id,p:ne?.$ident?void 0:ne?.arguments};j.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=j.textEdit.newText):typeof j.insertText=="string"?Oe.h=j.insertText:j.insertText instanceof c.$AM&&(Oe.h=j.insertText.value,Oe.i|=4);let Be;return j.textEdit?Be=j.textEdit.range:j.range&&(Be=j.range),c.$rM.isRange(Be)?Oe.j=t.Range.from(Be):Be&&(!G?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Oe.j={insert:t.Range.from(Be.inserting),replace:t.Range.from(Be.replacing)}),Oe}}class Te{async provideInlineCompletions(j,z,G,H){}disposeCompletions(j){}handleDidShowCompletionItem(j,z,G){}handlePartialAccept(j,z,G,H){}}class T extends Te{constructor(j,z,G,H){super(),this.f=j,this.g=z,this.h=G,this.j=H,this.d=new pe,this.e=(0,u.$NG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,u.$NG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(j,z,G,H){const te=this.g.getDocument(j),ne=t.Position.to(z),Oe=await this.h.provideInlineCompletionItems(te,ne,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:t.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},H);if(!Oe||H.isCancellationRequested)return;const Be=Array.isArray(Oe)?Oe:Oe.items,He=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,it)=>{let at;tt.command&&(xe||(xe=new p.$Tc),at=this.j.toInternal(tt.command,xe));const mt=tt.insertText;return{insertText:typeof mt=="string"?mt:{snippet:mt.value},filterText:tt.filterText,range:tt.range?t.Range.from(tt.range):void 0,command:at,idx:it,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:He.map(tt=>(xe||(xe=new p.$Tc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(j){this.d.disposeReferenceId(j)?.dispose()}handleDidShowCompletionItem(j,z,G){const H=this.d.get(j)?.items[z];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,G)}handlePartialAccept(j,z,G,H){const te=this.d.get(j)?.items[z];te&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(te,G),this.h.handleDidPartiallyAcceptCompletionItem(te,t.PartialAcceptInfo.to(H)))}}class X{async provideInlineEdits(j,z,G){const H=this.f.getDocument(j),te=await this.g.provideInlineEdit(H,{triggerKind:this.e[z.triggerKind]},G);if(!te||G.isCancellationRequested)return;let ne;const Oe=this.d.createReferenceId({dispose(){ne?.dispose()},item:te});let Be;te.accepted&&(ne||(ne=new p.$Tc),Be=this.h.toInternal(te.accepted,ne));let He;return te.rejected&&(ne||(ne=new p.$Tc),He=this.h.toInternal(te.rejected,ne)),{pid:Oe,text:te.text,range:t.Range.from(te.range),accepted:Be,rejected:He}}disposeEdit(j){this.d.disposeReferenceId(j)?.dispose()}constructor(j,z,G,H){this.f=z,this.g=G,this.h=H,this.d=new pe,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class pe{constructor(){this.d=new Map,this.e=1}createReferenceId(j){const z=this.e++;return this.d.set(z,j),z}disposeReferenceId(j){const z=this.d.get(j);return this.d.delete(j),z}get(j){return this.d.get(j)}}class Ie{constructor(j,z){this.e=j,this.f=z,this.d=new i.$dmc("SignatureHelp")}async provideSignatureHelp(j,z,G,H){const te=this.e.getDocument(j),ne=t.Position.to(z),Oe=this.g(G),Be=await this.f.provideSignatureHelp(te,ne,H,Oe);if(Be){const He=this.d.add([Be]);return{...t.SignatureHelp.from(Be),id:He}}}g(j){let z;if(j.activeSignatureHelp){const G=t.SignatureHelp.to(j.activeSignatureHelp),H=this.d.get(j.activeSignatureHelp.id,0);H?(z=H,z.activeSignature=G.activeSignature,z.activeParameter=G.activeParameter):z=G}return{...j,activeSignatureHelp:z}}releaseSignatureHelp(j){this.d.delete(j)}}class ye{constructor(j,z,G,H,te){this.f=j,this.g=z,this.h=G,this.j=H,this.k=te,this.d=new i.$dmc("InlayHints"),this.e=new Map}async provideInlayHints(j,z,G){const H=this.f.getDocument(j),te=t.Range.to(z),ne=await this.h.provideInlayHints(H,te,G);if(!Array.isArray(ne)||ne.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(G.isCancellationRequested)return;const Oe=this.d.add(ne);this.e.set(Oe,new p.$Tc);const Be={hints:[],cacheId:Oe};for(let He=0;He<ne.length;He++)this.l(ne[He],te)&&Be.hints.push(this.m(ne[He],[Oe,He]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),Be}async resolveInlayHint(j,z){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...j);if(!G)return;const H=await this.h.resolveInlayHint(G,z);if(H&&this.l(H))return this.m(H,j)}releaseHints(j){this.e.get(j)?.dispose(),this.e.delete(j),this.d.delete(j)}l(j,z){return j.label.length===0||Array.isArray(j.label)&&j.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",j),!1):!(z&&!z.contains(j.position))}m(j,z){const G=this.e.get(z[0]);if(!G)throw Error("DisposableStore is missing...");const H={label:"",cacheId:z,tooltip:t.MarkdownString.fromStrict(j.tooltip),position:t.Position.from(j.position),textEdits:j.textEdits&&j.textEdits.map(t.TextEdit.from),kind:j.kind&&t.InlayHintKind.from(j.kind),paddingLeft:j.paddingLeft,paddingRight:j.paddingRight};if(typeof j.label=="string")H.label=j.label;else{const te=[];H.label=te;for(const ne of j.label){if(!ne.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:ne.value,tooltip:t.MarkdownString.fromStrict(ne.tooltip)};c.$BM.isLocation(ne.location)&&(Oe.location=t.location.from(ne.location)),ne.command&&(Oe.command=this.g.toInternal(ne.command,G)),te.push(Oe)}}return H}}class $e{constructor(j,z){this.e=j,this.f=z,this.d=new i.$dmc("DocumentLink")}async provideLinks(j,z){const G=this.e.getDocument(j),H=await this.f.provideDocumentLinks(G,z);if(!(!Array.isArray(H)||H.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter($e.g).map(t.DocumentLink.from)};{const te=this.d.add(H),ne={links:[],cacheId:te};for(let Oe=0;Oe<H.length;Oe++){if(!$e.g(H[Oe]))continue;const Be=t.DocumentLink.from(H[Oe]);Be.cacheId=[te,Oe],ne.links.push(Be)}return ne}}}static g(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,z){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...j);if(!G)return;const H=await this.f.resolveDocumentLink(G,z);if(!(!H||!$e.g(H)))return t.DocumentLink.from(H)}releaseLinks(j){this.d.delete(j)}}class fe{constructor(j,z){this.d=j,this.e=z}async provideColors(j,z){const G=this.d.getDocument(j),H=await this.e.provideDocumentColors(G,z);return Array.isArray(H)?H.map(ne=>({color:t.Color.from(ne.color),range:t.Range.from(ne.range)})):[]}async provideColorPresentations(j,z,G){const H=this.d.getDocument(j),te=t.Range.to(z.range),ne=t.Color.to(z.color),Oe=await this.e.provideColorPresentations(ne,{document:H,range:te},G);if(Array.isArray(Oe))return Oe.map(t.ColorPresentation.from)}}class Q{constructor(j,z){this.d=j,this.e=z}async provideFoldingRanges(j,z,G){const H=this.d.getDocument(j),te=await this.e.provideFoldingRanges(H,z,G);if(Array.isArray(te))return te.map(t.FoldingRange.from)}}class x{constructor(j,z,G){this.d=j,this.e=z,this.f=G}async provideSelectionRanges(j,z,G){const H=this.d.getDocument(j),te=z.map(t.Position.to),ne=await this.e.provideSelectionRanges(H,te,G);if(!(0,C.$Lb)(ne))return[];if(ne.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Be=0;Be<te.length;Be++){const He=[];Oe.push(He);let _e=te[Be],xe=ne[Be];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(He.push(t.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Oe}}class le{constructor(j,z){this.f=j,this.g=z,this.d=new M.$WO(""),this.e=new Map}async prepareSession(j,z,G){const H=this.f.getDocument(j),te=t.Position.to(z),ne=await this.g.prepareCallHierarchy(H,te,G);if(!ne)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Oe,Be)):[this.h(Oe,ne)]}async provideCallsTo(j,z,G){const H=this.j(j,z);if(!H)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(H,G);if(te)return te.map(ne=>({from:this.h(j,ne.from),fromRanges:ne.fromRanges.map(Oe=>t.Range.from(Oe))}))}async provideCallsFrom(j,z,G){const H=this.j(j,z);if(!H)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(H,G);if(te)return te.map(ne=>({to:this.h(j,ne.to),fromRanges:ne.fromRanges.map(Oe=>t.Range.from(Oe))}))}releaseSession(j){this.e.delete(j)}h(j,z){const G=this.e.get(j),H=t.CallHierarchyItem.from(z,j,G.size.toString(36));return G.set(H._itemId,z),H}j(j,z){return this.e.get(j)?.get(z)}}class ae{constructor(j,z){this.f=j,this.g=z,this.d=new M.$WO(""),this.e=new Map}async prepareSession(j,z,G){const H=this.f.getDocument(j),te=t.Position.to(z),ne=await this.g.prepareTypeHierarchy(H,te,G);if(!ne)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Oe,Be)):[this.h(Oe,ne)]}async provideSupertypes(j,z,G){const H=this.j(j,z);if(!H)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(H,G);if(te)return te.map(ne=>this.h(j,ne))}async provideSubtypes(j,z,G){const H=this.j(j,z);if(!H)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(H,G);if(te)return te.map(ne=>this.h(j,ne))}releaseSession(j){this.e.delete(j)}h(j,z){const G=this.e.get(j),H=t.TypeHierarchyItem.from(z,j,G.size.toString(36));return G.set(H._itemId,z),H}j(j,z){return this.e.get(j)?.get(z)}}class Fe{constructor(j,z,G,H,te){this.e=j,this.f=z,this.g=G,this.h=H,this.j=te,this.d=new i.$dmc("DocumentDropEdit")}async provideDocumentOnDropEdits(j,z,G,H,te){const ne=this.f.getDocument(z),Oe=t.Position.to(G),Be=t.DataTransfer.toDataTransfer(H,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,j,et)).buffer),He=await this.g.provideDocumentDropEdits(ne,Oe,Be,te);if(!He)return;const _e=(0,C.$2b)(He),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,o.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?t.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(j,z){const[G,H]=j,te=this.d.get(G,H);if(!te||!this.g.resolveDocumentDropEdit)return{};const ne=await this.g.resolveDocumentDropEdit(te,z)??te;return{additionalEdit:ne.additionalEdit?t.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releaseDropEdits(j){this.d.delete(j)}}class de{constructor(j,z){this.d=j,this.e=z}async provideMappedEdits(j,z,G,H){const te=d.URI.revive(j),ne=this.d.getDocument(te),Oe=G.documents.map(_e=>_e.map(xe=>({uri:d.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>t.Range.to(et))}))),Be={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(ne,z,Be,H);return He?t.WorkspaceEdit.from(He):null}}class Pe{constructor(j,z){this.adapter=j,this.extension=z}}class Ae{static{this.d=0}constructor(j,z,G,H,te,ne,Oe,Be){this.g=z,this.h=G,this.j=H,this.k=te,this.l=ne,this.m=Oe,this.n=Be,this.f=new Map,this.e=j.getProxy(w.$nM.MainThreadLanguageFeatures)}o(j,z){return t.DocumentSelector.from(j,this.g,z)}p(j){return new c.$pM(()=>{this.f.delete(j),this.e.$unregister(j)})}q(){return Ae.d++}async s(j,z,G,H,te,ne=!1){const Oe=this.f.get(j);if(!Oe||!(Oe.adapter instanceof z))return H;const Be=Date.now();ne||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const He=G(Oe.adapter,Oe.extension);return Promise.resolve(He).catch(_e=>{(0,F.$4)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{ne||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(te)?(0,O.$ph)(He,te):He}t(j,z){const G=this.q();return this.f.set(G,new Pe(j,z)),G}static u(j){return j.displayName||j.name}static w(j){return j.identifier.value}registerDocumentSymbolProvider(j,z,G,H){const te=this.t(new a(this.h,G),j),ne=H&&H.label||Ae.u(j);return this.e.$registerDocumentSymbolProvider(te,this.o(z,j),ne),this.p(te)}$provideDocumentSymbols(j,z,G){return this.s(j,a,H=>H.provideDocumentSymbols(d.URI.revive(z),G),void 0,G)}registerCodeLensProvider(j,z,G){const H=this.q(),te=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Pe(new l(this.h,this.j.converter,G,j,this.n,this.l),j)),this.e.$registerCodeLensSupport(H,this.o(z,j),te);let ne=this.p(H);if(te!==void 0){const Oe=G.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(te));ne=c.$pM.from(ne,Oe)}return ne}$provideCodeLenses(j,z,G){return this.s(j,l,H=>H.provideCodeLenses(d.URI.revive(z),G),void 0,G)}$resolveCodeLens(j,z,G){return this.s(j,l,H=>H.resolveCodeLens(z,G),void 0,void 0)}$releaseCodeLenses(j,z){this.s(j,l,G=>Promise.resolve(G.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(j,z,G){const H=this.t(new $(this.h,G),j);return this.e.$registerDefinitionSupport(H,this.o(z,j)),this.p(H)}$provideDefinition(j,z,G,H){return this.s(j,$,te=>te.provideDefinition(d.URI.revive(z),G,H),[],H)}registerDeclarationProvider(j,z,G){const H=this.t(new b(this.h,G),j);return this.e.$registerDeclarationSupport(H,this.o(z,j)),this.p(H)}$provideDeclaration(j,z,G,H){return this.s(j,b,te=>te.provideDeclaration(d.URI.revive(z),G,H),[],H)}registerImplementationProvider(j,z,G){const H=this.t(new y(this.h,G),j);return this.e.$registerImplementationSupport(H,this.o(z,j)),this.p(H)}$provideImplementation(j,z,G,H){return this.s(j,y,te=>te.provideImplementation(d.URI.revive(z),G,H),[],H)}registerTypeDefinitionProvider(j,z,G){const H=this.t(new h(this.h,G),j);return this.e.$registerTypeDefinitionSupport(H,this.o(z,j)),this.p(H)}$provideTypeDefinition(j,z,G,H){return this.s(j,h,te=>te.provideTypeDefinition(d.URI.revive(z),G,H),[],H)}registerHoverProvider(j,z,G,H){const te=this.t(new E(this.h,G),j);return this.e.$registerHoverProvider(te,this.o(z,j)),this.p(te)}$provideHover(j,z,G,H,te){return this.s(j,E,ne=>ne.provideHover(d.URI.revive(z),G,H,te),void 0,te)}$releaseHover(j,z){this.s(j,E,G=>Promise.resolve(G.releaseHover(z)),void 0,void 0)}registerEvaluatableExpressionProvider(j,z,G,H){const te=this.t(new k(this.h,G),j);return this.e.$registerEvaluatableExpressionProvider(te,this.o(z,j)),this.p(te)}$provideEvaluatableExpression(j,z,G,H){return this.s(j,k,te=>te.provideEvaluatableExpression(d.URI.revive(z),G,H),void 0,H)}registerInlineValuesProvider(j,z,G,H){const te=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,ne=this.t(new I(this.h,G),j);this.e.$registerInlineValuesProvider(ne,this.o(z,j),te);let Oe=this.p(ne);if(te!==void 0){const Be=G.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(te));Oe=c.$pM.from(Oe,Be)}return Oe}$provideInlineValues(j,z,G,H,te){return this.s(j,I,ne=>ne.provideInlineValues(d.URI.revive(z),G,H,te),void 0,te)}registerDocumentHighlightProvider(j,z,G){const H=this.t(new P(this.h,G),j);return this.e.$registerDocumentHighlightProvider(H,this.o(z,j)),this.p(H)}registerMultiDocumentHighlightProvider(j,z,G){const H=this.t(new V(this.h,G),j);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(z,j)),this.p(H)}$provideDocumentHighlights(j,z,G,H){return this.s(j,P,te=>te.provideDocumentHighlights(d.URI.revive(z),G,H),void 0,H)}$provideMultiDocumentHighlights(j,z,G,H,te){return this.s(j,V,ne=>ne.provideMultiDocumentHighlights(d.URI.revive(z),G,H.map(Oe=>d.URI.revive(Oe)),te),void 0,te)}registerLinkedEditingRangeProvider(j,z,G){const H=this.t(new W(this.h,G),j);return this.e.$registerLinkedEditingRangeProvider(H,this.o(z,j)),this.p(H)}$provideLinkedEditingRanges(j,z,G,H){return this.s(j,W,async te=>{const ne=await te.provideLinkedEditingRanges(d.URI.revive(z),G,H);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?Ae.y(ne.wordPattern):void 0}},void 0,H)}registerReferenceProvider(j,z,G){const H=this.t(new q(this.h,G),j);return this.e.$registerReferenceSupport(H,this.o(z,j)),this.p(H)}$provideReferences(j,z,G,H,te){return this.s(j,q,ne=>ne.provideReferences(d.URI.revive(z),G,H,te),void 0,te)}registerCodeActionProvider(j,z,G,H){const te=new p.$Tc,ne=this.t(new A(this.h,this.j.converter,this.k,G,this.l,j,this.m),j);return this.e.$registerCodeActionSupport(ne,this.o(z,j),{providedKinds:H?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:H?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,te)}))},Ae.u(j),Ae.w(j),!!G.resolveCodeAction),te.add(this.p(ne)),te}$provideCodeActions(j,z,G,H,te){return this.s(j,A,ne=>ne.provideCodeActions(d.URI.revive(z),G,H,te),void 0,te)}$resolveCodeAction(j,z,G){return this.s(j,A,H=>H.resolveCodeAction(z,G),{},void 0)}$releaseCodeActions(j,z){this.s(j,A,G=>Promise.resolve(G.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(j,z,G){const H=this.t(new K(this.h,G),j);return this.e.$registerDocumentFormattingSupport(H,this.o(z,j),j.identifier,j.displayName||j.name),this.p(H)}$provideDocumentFormattingEdits(j,z,G,H){return this.s(j,K,te=>te.provideDocumentFormattingEdits(d.URI.revive(z),G,H),void 0,H)}registerDocumentRangeFormattingEditProvider(j,z,G){const H=typeof G.provideDocumentRangesFormattingEdits=="function",te=this.t(new ie(this.h,G),j);return this.e.$registerRangeFormattingSupport(te,this.o(z,j),j.identifier,j.displayName||j.name,H),this.p(te)}$provideDocumentRangeFormattingEdits(j,z,G,H,te){return this.s(j,ie,ne=>ne.provideDocumentRangeFormattingEdits(d.URI.revive(z),G,H,te),void 0,te)}$provideDocumentRangesFormattingEdits(j,z,G,H,te){return this.s(j,ie,ne=>ne.provideDocumentRangesFormattingEdits(d.URI.revive(z),G,H,te),void 0,te)}registerOnTypeFormattingEditProvider(j,z,G,H){const te=this.t(new ce(this.h,G),j);return this.e.$registerOnTypeFormattingSupport(te,this.o(z,j),H,j.identifier),this.p(te)}$provideOnTypeFormattingEdits(j,z,G,H,te,ne){return this.s(j,ce,Oe=>Oe.provideOnTypeFormattingEdits(d.URI.revive(z),G,H,te,ne),void 0,ne)}registerWorkspaceSymbolProvider(j,z){const G=this.t(new ve(z,this.l),j);return this.e.$registerNavigateTypeSupport(G,typeof z.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(j,z,G){return this.s(j,ve,H=>H.provideWorkspaceSymbols(z,G),{symbols:[]},G)}$resolveWorkspaceSymbol(j,z,G){return this.s(j,ve,H=>H.resolveWorkspaceSymbol(z,G),void 0,void 0)}$releaseWorkspaceSymbols(j,z){this.s(j,ve,G=>G.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(j,z,G){const H=this.t(new Ee(this.h,G,this.l),j);return this.e.$registerRenameSupport(H,this.o(z,j),Ee.supportsResolving(G)),this.p(H)}$provideRenameEdits(j,z,G,H,te){return this.s(j,Ee,ne=>ne.provideRenameEdits(d.URI.revive(z),G,H,te),void 0,te)}$resolveRenameLocation(j,z,G,H){return this.s(j,Ee,te=>te.resolveRenameLocation(d.URI.revive(z),G,H),void 0,H)}registerNewSymbolNamesProvider(j,z,G){const H=this.t(new ge(this.h,G,this.l),j);return this.e.$registerNewSymbolNamesProvider(H,this.o(z,j)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(j){return this.s(j,ge,z=>z.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(j,z,G,H,te){return this.s(j,ge,ne=>ne.provideNewSymbolNames(d.URI.revive(z),G,H,te),void 0,te)}registerDocumentSemanticTokensProvider(j,z,G,H){const te=this.t(new Ce(this.h,G),j),ne=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(z,j),H,ne);let Oe=this.p(te);if(ne){const Be=G.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(ne));Oe=c.$pM.from(Oe,Be)}return Oe}$provideDocumentSemanticTokens(j,z,G,H){return this.s(j,Ce,te=>te.provideDocumentSemanticTokens(d.URI.revive(z),G,H),null,H)}$releaseDocumentSemanticTokens(j,z){this.s(j,Ce,G=>G.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(j,z,G,H){const te=this.t(new re(this.h,G),j);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(z,j),H),this.p(te)}$provideDocumentRangeSemanticTokens(j,z,G,H){return this.s(j,re,te=>te.provideDocumentRangeSemanticTokens(d.URI.revive(z),G,H),null,H)}registerCompletionItemProvider(j,z,G,H){const te=this.t(new Ne(this.h,this.j.converter,G,this.m,j),j);return this.e.$registerCompletionsProvider(te,this.o(z,j),H,Ne.supportsResolving(G),j.identifier),this.p(te)}$provideCompletionItems(j,z,G,H,te){return this.s(j,Ne,ne=>ne.provideCompletionItems(d.URI.revive(z),G,H,te),void 0,te)}$resolveCompletionItem(j,z,G){return this.s(j,Ne,H=>H.resolveCompletionItem(z,G),void 0,G)}$releaseCompletionItems(j,z){this.s(j,Ne,G=>G.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(j,z,G,H){const te=new T(j,this.h,G,this.j.converter),ne=this.t(te,j);return this.e.$registerInlineCompletionsSupport(ne,this.o(z,j),te.supportsHandleEvents,n.$Vm.toKey(j.identifier.value),H?.yieldTo?.map(Oe=>n.$Vm.toKey(Oe))||[]),this.p(ne)}$provideInlineCompletions(j,z,G,H,te){return this.s(j,Te,ne=>ne.provideInlineCompletions(d.URI.revive(z),G,H,te),void 0,te)}$handleInlineCompletionDidShow(j,z,G,H){this.s(j,Te,async te=>{te.handleDidShowCompletionItem(z,G,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(j,z,G,H,te){this.s(j,Te,async ne=>{ne.handlePartialAccept(z,G,H,te)},void 0,void 0)}$freeInlineCompletionsList(j,z){this.s(j,Te,async G=>{G.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(j,z,G){const H=new X(j,this.h,G,this.j.converter),te=this.t(H,j);return this.e.$registerInlineEditProvider(te,this.o(z,j),j.identifier),this.p(te)}$provideInlineEdit(j,z,G,H){return this.s(j,X,te=>te.provideInlineEdits(d.URI.revive(z),G,H),void 0,H)}$freeInlineEdit(j,z){this.s(j,X,async G=>{G.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(j,z,G,H){const te=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,ne=this.t(new Ie(this.h,G),j);return this.e.$registerSignatureHelpProvider(ne,this.o(z,j),te),this.p(ne)}$provideSignatureHelp(j,z,G,H,te){return this.s(j,Ie,ne=>ne.provideSignatureHelp(d.URI.revive(z),G,H,te),void 0,te)}$releaseSignatureHelp(j,z){this.s(j,Ie,G=>G.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(j,z,G){const H=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new ye(this.h,this.j.converter,G,this.l,j),j);this.e.$registerInlayHintsProvider(te,this.o(z,j),typeof G.resolveInlayHint=="function",H,Ae.u(j));let ne=this.p(te);if(H!==void 0){const Oe=G.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));ne=c.$pM.from(ne,Oe)}return ne}$provideInlayHints(j,z,G,H){return this.s(j,ye,te=>te.provideInlayHints(d.URI.revive(z),G,H),void 0,H)}$resolveInlayHint(j,z,G){return this.s(j,ye,H=>H.resolveInlayHint(z,G),void 0,G)}$releaseInlayHints(j,z){this.s(j,ye,G=>G.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(j,z,G){const H=this.t(new $e(this.h,G),j);return this.e.$registerDocumentLinkProvider(H,this.o(z,j),typeof G.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(j,z,G){return this.s(j,$e,H=>H.provideLinks(d.URI.revive(z),G),void 0,G,z.scheme==="output")}$resolveDocumentLink(j,z,G){return this.s(j,$e,H=>H.resolveLink(z,G),void 0,void 0,!0)}$releaseDocumentLinks(j,z){this.s(j,$e,G=>G.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(j,z,G){const H=this.t(new fe(this.h,G),j);return this.e.$registerDocumentColorProvider(H,this.o(z,j)),this.p(H)}$provideDocumentColors(j,z,G){return this.s(j,fe,H=>H.provideColors(d.URI.revive(z),G),[],G)}$provideColorPresentations(j,z,G,H){return this.s(j,fe,te=>te.provideColorPresentations(d.URI.revive(z),G,H),void 0,H)}registerFoldingRangeProvider(j,z,G){const H=this.q(),te=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Pe(new Q(this.h,G),j)),this.e.$registerFoldingRangeProvider(H,this.o(z,j),j.identifier,te);let ne=this.p(H);if(te!==void 0){const Oe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));ne=c.$pM.from(ne,Oe)}return ne}$provideFoldingRanges(j,z,G,H){return this.s(j,Q,te=>te.provideFoldingRanges(d.URI.revive(z),G,H),void 0,H)}registerSelectionRangeProvider(j,z,G){const H=this.t(new x(this.h,G,this.l),j);return this.e.$registerSelectionRangeProvider(H,this.o(z,j)),this.p(H)}$provideSelectionRanges(j,z,G,H){return this.s(j,x,te=>te.provideSelectionRanges(d.URI.revive(z),G,H),[],H)}registerCallHierarchyProvider(j,z,G){const H=this.t(new le(this.h,G),j);return this.e.$registerCallHierarchyProvider(H,this.o(z,j)),this.p(H)}$prepareCallHierarchy(j,z,G,H){return this.s(j,le,te=>Promise.resolve(te.prepareSession(d.URI.revive(z),G,H)),void 0,H)}$provideCallHierarchyIncomingCalls(j,z,G,H){return this.s(j,le,te=>te.provideCallsTo(z,G,H),void 0,H)}$provideCallHierarchyOutgoingCalls(j,z,G,H){return this.s(j,le,te=>te.provideCallsFrom(z,G,H),void 0,H)}$releaseCallHierarchy(j,z){this.s(j,le,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(j,z,G){const H=this.t(new ae(this.h,G),j);return this.e.$registerTypeHierarchyProvider(H,this.o(z,j)),this.p(H)}$prepareTypeHierarchy(j,z,G,H){return this.s(j,ae,te=>Promise.resolve(te.prepareSession(d.URI.revive(z),G,H)),void 0,H)}$provideTypeHierarchySupertypes(j,z,G,H){return this.s(j,ae,te=>te.provideSupertypes(z,G,H),void 0,H)}$provideTypeHierarchySubtypes(j,z,G,H){return this.s(j,ae,te=>te.provideSubtypes(z,G,H),void 0,H)}$releaseTypeHierarchy(j,z){this.s(j,ae,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(j,z,G,H){const te=this.q();return this.f.set(te,new Pe(new Fe(this.e,this.h,G,te,j),j)),this.e.$registerDocumentOnDropEditProvider(te,this.o(z,j),(0,u.$NG)(j,"documentPaste")&&H?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(te)}$provideDocumentOnDropEdits(j,z,G,H,te,ne){return this.s(j,Fe,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(z,d.URI.revive(G),H,te,ne)),void 0,void 0)}$resolveDropEdit(j,z,G){return this.s(j,Fe,H=>H.resolveDropEdit(z,G),{},void 0)}$releaseDropEdits(j,z){this.s(j,Fe,G=>Promise.resolve(G.releaseDropEdits(z)),void 0,void 0)}registerMappedEditsProvider(j,z,G){const H=this.t(new de(this.h,G),j);return this.e.$registerMappedEditsProvider(H,this.o(z,j)),this.p(H)}$provideMappedEdits(j,z,G,H,te){return this.s(j,de,ne=>Promise.resolve(ne.provideMappedEdits(z,G,H,te)),null,te)}registerDocumentPasteEditProvider(j,z,G,H){const te=this.q();return this.f.set(te,new Pe(new U(this.e,this.h,G,te,j),j)),this.e.$registerPasteEditProvider(te,this.o(z,j),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(ne=>ne.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(te)}$prepareDocumentPaste(j,z,G,H,te){return this.s(j,U,ne=>ne.prepareDocumentPaste(d.URI.revive(z),G,H,te),void 0,te)}$providePasteEdits(j,z,G,H,te,ne,Oe){return this.s(j,U,Be=>Be.providePasteEdits(z,d.URI.revive(G),H,te,ne,Oe),void 0,Oe)}$resolvePasteEdit(j,z,G){return this.s(j,U,H=>H.resolvePasteEdit(z,G),{},void 0)}$releasePasteEdits(j,z){this.s(j,U,G=>Promise.resolve(G.releasePasteEdits(z)),void 0,void 0)}static y(j){return{pattern:j.source,flags:j.flags}}static z(j){return{decreaseIndentPattern:Ae.y(j.decreaseIndentPattern),increaseIndentPattern:Ae.y(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Ae.y(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Ae.y(j.unIndentedLinePattern):void 0}}static B(j){return{beforeText:Ae.y(j.beforeText),afterText:j.afterText?Ae.y(j.afterText):void 0,previousLineText:j.previousLineText?Ae.y(j.previousLineText):void 0,action:j.action}}static C(j){return j.map(Ae.B)}static D(j){return{open:j.open,close:j.close,notIn:j.notIn?j.notIn.map(z=>c.SyntaxTokenType.toString(z)):void 0}}static E(j){return j.map(Ae.D)}setLanguageConfiguration(j,z,G){const{wordPattern:H}=G;if(H&&(0,N.$nf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(z,H):this.h.setWordDefinitionFor(z,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const te=this.q(),ne={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Ae.y(G.wordPattern):void 0,indentationRules:G.indentationRules?Ae.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Ae.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Ae.E(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(te,z,ne),this.p(te)}$setWordDefinitions(j){for(const z of j)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$nmc=Ae}),define(ke[90],Se([1,0,11,20,14,5,42,6,175,21,3,12,103,4,86,17,8,7,108,25]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=e.$7mc=void 0,e.$7mc=(0,N.$Ai)("IExtHostLanguageModels");class u{constructor(l,g){this.option=l,this.stream=new C.$4h,this.stream=g??new C.$4h}}class i{constructor(){this.a=new Map,this.b=new C.$4h,this.c=!1,this.d=!1;const l=this;this.apiObject={text:l.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let g=this.a.get(l.index);g||(this.a.size===0?g=new u(l.index,this.b):g=new u(l.index),this.a.set(l.index,g)),g.stream.emitOne(l.part)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const g of this.f())g.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let w=class{static{c=this}static{this.a=1}constructor(l,g,$){this.j=g,this.k=$,this.c=new F.$he,this.d=new F.$he,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new D.$Xm,this.i=new Map,this.r=new Set,this.b=l.getProxy(v.$nM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,g,$,b){const y=c.a++;this.f.set(y,{extension:l.identifier,provider:$,languageModelId:g});let h;b.auth&&(h={providerLabel:l.displayName||l.name,accountLabel:typeof b.auth=="object"?b.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${D.$Vm.toKey(l.identifier)}/${y}/${g}`,{extension:l.identifier,id:g,vendor:b.vendor??D.$Vm.toKey(l.identifier),name:b.name??"",family:b.family??"",version:b.version,maxInputTokens:b.maxInputTokens??b.tokens,maxOutputTokens:b.maxOutputTokens??b.tokens,auth:h,targetExtensions:b.extensions});const E=$.onDidReceiveLanguageModelResponse2?.(({extensionId:k,participant:I,tokenCount:P})=>{this.b.$whenLanguageModelChatRequestMade(g,new D.$Vm(k),I,P)});return(0,p.$Sc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),E?.dispose()})}async $provideLanguageModelResponse(l,g,$,b,y,h){const E=this.f.get(l);if(!E)return;const k=new d.$jw(async I=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${E.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:I.index,part:I.part})});return E.provider.provideLanguageModelResponse(b.map(r.LanguageModelChatMessage.to),y,D.$Vm.toKey($),k,h)}$provideTokenLength(l,g,$){const b=this.f.get(l);return b?Promise.resolve(b.provider.provideTokenCount(g,$)):Promise.resolve(0)}$acceptChatModelMetadata(l){if(l.added)for(const{identifier:g,metadata:$}of l.added)this.g.set(g,{metadata:$,apiObjects:new D.$Xm});if(l.removed)for(const g of l.removed){this.g.delete(g);for(const[$,b]of this.i)b.languageModelId===g&&(b.res.reject(new R.$5),this.i.delete($))}l.added?.forEach(g=>this.p(g.metadata)),this.d.fire(void 0)}async selectLanguageModels(l,g){const $=await this.b.$selectChatModels({...g,extension:l.identifier}),b=[],y=this;for(const h of $){const E=this.g.get(h);if(!E)continue;let k=E.apiObjects.get(l.identifier);k||(k={id:h,vendor:E.metadata.vendor,family:E.metadata.family,version:E.metadata.version,name:E.metadata.name,maxInputTokens:E.metadata.maxInputTokens,countTokens(I,P){if(!y.g.has(h))throw o.$EO.NotFound(h);return y.q(h,I,P??O.CancellationToken.None)},sendRequest(I,P,V){if(!y.g.has(h))throw o.$EO.NotFound(h);return y.l(l,h,I,P??{},V??O.CancellationToken.None)}},Object.freeze(k),E.apiObjects.set(l.identifier,k)),b.push(k)}return b}async l(l,g,$,b,y){const h=this.m(l,$),E=l.identifier,k=this.g.get(g)?.metadata;if(!k||!this.g.has(g))throw o.$EO.NotFound(`Language model '${g}' is unknown.`);if(this.o(E,k)&&(!await this.n(l,{identifier:k.extension,displayName:k.auth.providerLabel},b.justification,!1)||!this.h.get(E)?.has(k.extension)))throw o.$EO.NoPermissions(`Language model '${g}' cannot be used by '${E.value}'.`);const I=Math.random()*1e6|0,P=this.b.$fetchResponse(E,g,I,h,b.modelOptions??{},y),V=new C.$zh,W=new i;this.i.set(I,{languageModelId:g,res:W});let q;if(P.catch(A=>{V.isOpen()?W.reject(A):q=A}).finally(()=>{this.i.delete(I),W.resolve(),V.open()}),await V.wait(),q)throw q.name===o.$EO.name?q:new o.$EO(`Language model '${g}' errored, check cause for more details`,"Unknown",q);return W.apiObject}m(l,g){const $=[];for(const b of g)b.role===o.LanguageModelChatMessageRole.System&&(0,t.$OG)(l,"languageModelSystem"),$.push(r.LanguageModelChatMessage.from(b));return $}async $handleResponseFragment(l,g){const $=this.i.get(l);$&&$.res.handleFragment(g)}async n(l,g,$,b){const y=n.$pL+g.identifier.value;if(await this.k.getSession(l,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:g.identifier,enabled:!0}]),!0;if(b)return!1;try{const E=$?(0,m.localize)(0,null,g.displayName,$):void 0;return await this.k.getSession(l,y,[],{forceNewSession:{detail:E}}),this.$updateModelAccesslist([{from:l.identifier,to:g.identifier,enabled:!0}]),!0}catch{return!1}}o(l,g){return!!g.auth&&!D.$Vm.equals(g.extension,l)}async p(l){for(const g of this.r)try{await this.n(g,{identifier:l.extension,displayName:""},void 0,!0)}catch($){this.j.error("Fake Auth request failed"),this.j.error($)}}async q(l,g,$){if(!this.g.get(l))throw o.$EO.NotFound(`Language model '${l}' is unknown.`);const y=M.Iterable.find(this.f.values(),h=>h.languageModelId===l);return y?y.provider.provideTokenCount(g,$):this.b.$countTokens(l,typeof g=="string"?g:r.LanguageModelChatMessage.from(g),$)}$updateModelAccesslist(l){const g=new Array;for(const{from:$,to:b,enabled:y}of l){const h=this.h.get($)??new D.$Wm;if(h.has(b)!==y){y?h.add(b):h.delete(b),this.h.set($,h);const k={from:$,to:b};g.push(k),this.c.fire(k)}}}createLanguageModelAccessInformation(l){this.r.add(l);const g=this,$=F.Event.signal(F.Event.filter(this.c.event,y=>D.$Vm.equals(y.from,l.identifier))),b=F.Event.signal(this.d.event);return{get onDidChange(){return F.Event.any($,b)},canSendRequest(y){let h;e:for(const[k,I]of g.g)for(const P of I.apiObjects.values())if(P===y){h=I.metadata;break e}if(!h)return;if(!g.o(l.identifier,h))return!0;const E=g.h.get(l.identifier);if(E)return E.has(h.extension)}}}};e.$8mc=w,e.$8mc=w=c=Je([We(0,s.$RO),We(1,S.$7j),We(2,f.$pmc)],w)}),define(ke[275],Se([1,0,4,8,7,32,11,6,25]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;class D{constructor(S,d,v,f){this.c=d,this.d=v,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(C.$nM.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,d){await this.a.$changeLanguage(S,d);const v=this.c.getDocumentData(S);if(!v)throw new Error(`document '${S.toString()}' NOT found`);return v.document}async tokenAtPosition(S,d){const v=S.version,f=O.Position.from(d),s=await this.a.$tokensAtPosition(S.uri,f),r={type:R.StandardTokenType.Other,range:S.getWordRangeAtPosition(d)??new R.$rM(d.line,d.character,d.line,d.character)};if(!s)return r;const o={range:O.Range.to(s.range),type:O.TokenType.to(s.type)};return!o.range.contains(d)||v!==S.version?r:o}createLanguageStatusItem(S,d,v){const f=this.f++,s=this.a,r=this.g,o=`${S.identifier.value}/${d}`;if(r.has(o))throw new Error(`LanguageStatusItem with id '${d}' ALREADY exists`);r.add(o);const n={selector:v,id:d,name:S.displayName??S.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const c=new p.$Tc,u=()=>{if(t?.dispose(),!r.has(o)){console.warn(`LanguageStatusItem (${d}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,M.$Ch)(()=>{c.clear(),this.a.$setLanguageStatus(f,{id:o,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===R.LanguageStatusSeverity.Error?F.default.Error:n.severity===R.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),t?.dispose(),s.$removeLanguageStatus(f),r.delete(o)},get id(){return n.id},get name(){return n.name},set name(w){n.name=w,u()},get selector(){return n.selector},set selector(w){n.selector=w,u()},get text(){return n.text},set text(w){n.text=w,u()},set text2(w){(0,m.$OG)(S,"languageStatusText"),n.text=w,u()},get text2(){return(0,m.$OG)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(w){n.detail=w,u()},get severity(){return n.severity},set severity(w){n.severity=w,u()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(w){n.accessibilityInformation=w,u()},get command(){return n.command},set command(w){n.command=w,u()},get busy(){return n.busy},set busy(w){n.busy=w,u()}};return u(),i}}e.$Mnc=D}),define(ke[276],Se([1,0,16,2,8,7,85]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=e.$ync=void 0;class p{constructor(S,d,v,f){this.start=S,this.deletedCount=d,this.deletedItems=v,this.items=f}asApiEvent(){return{range:new F.$RN(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,d,v){this.notebook=S,this.h=d,this.j=v,this.handle=v.handle,this.uri=O.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(R.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,d=this.h.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:d.document,get mime(){return S.g},set mime(f){S.g=f},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(v)}return this.f}setOutputs(S){this.a=S.map(R.NotebookCellOutput.to)}setOutputItems(S,d,v){const f=v.map(R.NotebookCellOutputItem.to),s=this.a.find(r=>r.id===S);if(s&&(d||(s.items.length=0),s.items.push(...f),s.items.length>1&&s.items.every(r=>M.$jK(r.mime)))){const r=new Map,o=[];s.items.forEach(n=>{let t;r.has(n.mime)?t=r.get(n.mime):(t=[],r.set(n.mime,t),o.push(n.mime)),t.push(n.data)}),s.items.length=0,o.forEach(n=>{const t=M.$kK(r.get(n));s.items.push({mime:n,data:t.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$ync=m;class D{static{this.a=0}constructor(S,d,v,f,s){this.k=S,this.l=d,this.m=v,this.uri=f,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,d={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===C.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(v){return v=S.n(v),S.b[v].apiCell},getCells(v){return(v?S.p(v):S.b).map(s=>s.apiCell)},save(){return S.q()}};this.e=Object.freeze(d)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,d,v){this.g=S.versionId,this.h=d,this.acceptDocumentPropertiesChanged({metadata:v});const f={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},s=[];for(const o of S.rawEvents)o.kind===M.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,f.contentChanges):o.kind===M.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,f.contentChanges):o.kind===M.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),s.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),s.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),s.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===M.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),s.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),s.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const r=new Map;for(let o=0;o<s.length;o++){const n=s[o],t=r.get(n.cell);if(t===void 0){const c=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});r.set(n.cell,c-1)}else f.cellChanges[t]={...f.cellChanges[t],...n}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let d=S.start|0,v=S.end|0;return d<0&&(d=0),v>this.b.length&&(v=this.b.length),S.with({start:d,end:v})}p(S){S=this.o(S);const d=[];for(let v=S.start;v<S.end;v++)d.push(this.b[v]);return d}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,d,v){if(this.j)return;const f=[],s=[],r=[];if(S.reverse().forEach(o=>{const t=o[2].map(i=>{const w=new m(this,this.l,i);return d||s.push(m.asModelAddData(i)),w}),c=new p(o[0],o[1],[],t),u=this.b.splice(o[0],o[1],...t);for(const i of u)r.push(i.uri),c.deletedItems.push(i.apiCell);f.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:r}),v)for(const o of f)v.push(o.asApiEvent())}s(S,d,v,f){const s=this.b.splice(S,d);this.b.splice(v,0,...s);const r=[new p(S,d,s.map(o=>o.apiCell),[]),new p(v,0,[],s)];for(const o of r)f.push(o.asApiEvent())}t(S,d){this.b[S].setOutputs(d)}u(S,d,v,f){this.b[S].setOutputItems(d,v,f)}v(S,d){const v=this.b[S];v.apiCell.document.languageId!==d&&this.m.$acceptModelLanguageChanged(v.uri,d)}w(S,d){const v=this.b[S];v.apiCell.mime=d}x(S,d){this.b[S].setMetadata(d)}y(S,d){this.b[S].setInternalMetadata(d)}getCellFromApiCell(S){return this.b.find(d=>d.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(d=>d.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$znc=D}),define(ke[277],Se([1,0,5,2,8,7,34]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0;class p{constructor(D,N,S,d={timeout:1500,errors:3}){this.b=D,this.c=N,this.d=S,this.f=d,this.a=new C.$je}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(N,S,d)=>{const v=function(s){N.call(S,s)};return v.extension=D,this.a.event(v,void 0,d)}}async $participateInSave(D,N,S){const d=O.URI.revive(D),v=this.c.getNotebookDocument(d);if(!v)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:R.TextDocumentSaveReason.to(N)},S,async(r,o)=>{const n=Date.now(),t=await await Promise.resolve(r);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!S.isCancellationRequested&&t&&(t instanceof F.$zM?f.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(f.length===0)return!0;const s={edits:[]};for(const r of f){const{edits:o}=R.WorkspaceEdit.from(r);s.edits=s.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(new M.$Hw(s))}}e.$Onc=p}),define(ke[114],Se([1,0,14,8,7]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,m,D,N,S,d){this.id=p,this.f=m,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=N,this.c=d}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(m){this.selections=[m]},get selections(){return p.a},set selections(m){if(!Array.isArray(m)||!m.every(R.$RN.isNotebookRange))throw(0,C.$7)("selections");p.a=m,p.g(m)},get visibleRanges(){return p.b},revealRange(m,D){p.f.$tryRevealRange(p.id,O.NotebookRange.from(m),D??R.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(O.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$Anc=F}),define(ke[278],Se([1,0,5,12,8]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=void 0;let F=class{constructor(p,m){this.c=p,this.d=m,this.a=new C.$he,this.b=new C.$he,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,m);const D=this.d.getEditorById(p);m.visibleRanges&&D._acceptVisibleRanges(m.visibleRanges.ranges.map(R.NotebookRange.to)),m.selections&&D._acceptSelections(m.selections.selections.map(R.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const m in p)this.d.getEditorById(m)._acceptViewColumn(R.ViewColumn.to(p[m]))}};e.$Qnc=F,e.$Qnc=F=Je([We(0,O.$7j)],F)}),define(ke[279],Se([1,0,5,4,114]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=void 0;class F{constructor(p,m){this.c=m,this.a=new Map,this.b=p.getProxy(O.$nM.MainThreadNotebookRenderers)}$postRendererMessage(p,m,D){const N=this.c.getEditorById(p);this.a.get(m)?.fire({editor:N.apiEditor,message:D})}createRendererMessaging(p,m){if(!p.contributes?.notebookRenderer?.some(N=>N.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(N,S,d)=>this.d(m).event(N,S,d),postMessage:(N,S)=>{R.$Anc.apiEditorsToExtHost.has(N)&&([N,S]=[S,N]);const d=S&&R.$Anc.apiEditorsToExtHost.get(S);return this.b.$postMessage(d?.id,m,N)}}}d(p){let m=this.a.get(p);return m||(m=new C.$he({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(p)}}),this.a.set(p,m),m)}}e.$Tnc=F}),define(ke[280],Se([1,0,8,103,20,69,14]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xnc=void 0;class p{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,d,v){const f=this.b++,{title:s,location:r,cancellable:o}=d,n={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(f,{location:C.ProgressLocation.from(r),title:s,source:n,cancellable:o},S.isUnderDevelopment?void 0:S.identifier.value).catch(M.$2),this.d(f,v,!!o)}d(S,d,v){let f;v&&(f=new R.$se,this.c.set(S,f));const s=o=>{this.a.$progressEnd(o),this.c.delete(o),f?.dispose()};let r;try{r=d(new D(this.a,S),v&&f?f.token:R.CancellationToken.None)}catch(o){throw s(S),o}return r.then(o=>s(S),o=>s(S)),r}$acceptProgressCanceled(S){const d=this.c.get(S);d&&(d.cancel(),this.c.delete(S))}}e.$Xnc=p;function m(N,S){return N.message=S.message,typeof S.increment=="number"&&(typeof N.increment=="number"?N.increment+=S.increment:N.increment=S.increment),N}class D extends O.$jw{constructor(S,d){super(v=>this.throttledReport(v)),this.c=S,this.d=d}throttledReport(S){this.c.$progressReport(this.d,S)}}Je([(0,F.$7h)(100,(N,S)=>m(N,S),()=>Object.create(null))],D.prototype,"throttledReport",null)}),define(ke[281],Se([1,0,2,4,11,8]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=void 0;class M{static{this.a=0}constructor(m,D){this.d=D,this.c=new Map,this.b=m.getProxy(O.$nM.MainThreadQuickDiff)}$provideOriginalResource(m,D,N){const S=C.URI.revive(D),d=this.c.get(m);return d?(0,R.$sh)(()=>d.provideOriginalResource(S,N)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(m,D,N,S){const d=M.a++;return this.c.set(d,D),this.b.$registerQuickDiffProvider(d,F.DocumentSelector.from(m,this.d),N,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(d),this.c.delete(d)}}}}e.$Ync=M}),define(ke[282],Se([1,0,20,5,6,4,2,7,14,18,32,36,25,8]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=f;function f(s,r,o){const n=s.getProxy(F.$nM.MainThreadQuickOpen);class t{constructor(b,y){this.e=new Map,this.f=0,this.a=b,this.b=y}showQuickPick(b,y,h,E=C.CancellationToken.None){this.c=void 0;const k=Promise.resolve(y),I=++this.f,P=n.$show(I,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},E),V={},W=P.then(()=>V);return Promise.race([W,k]).then(q=>{if(q===V)return;const A=(0,d.$NG)(b,"quickPickItemTooltip");return k.then(U=>{const K=[];for(let ie=0;ie<U.length;ie++){const ce=U[ie];if(typeof ce=="string")K.push({label:ce,handle:ie});else if(ce.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ce.label});else{ce.tooltip&&!A&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const ve=ce.iconPath?a(ce.iconPath):void 0;K.push({label:ce.label,iconPath:ve?.iconPath,iconClass:ve?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:A?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ie})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ie=>{h.onDidSelectItem(U[ie])}),n.$setItems(I,K),P.then(ie=>{if(typeof ie=="number")return U[ie];if(Array.isArray(ie))return ie.map(ce=>U[ce])})})}).then(void 0,q=>{if(!(0,m.$4)(q))return n.$setError(I,q),Promise.reject(q)})}$onItemSelected(b){this.c?.(b)}showInput(b,y=C.CancellationToken.None){return this.d=b?.validateInput,n.$input(b,typeof this.d=="function",y).then(void 0,h=>{if(!(0,m.$4)(h))return Promise.reject(h)})}async $validateInput(b){if(!this.d)return;const y=await this.d(b);if(!y||typeof y=="string")return y;let h;switch(y.severity){case p.InputBoxValidationSeverity.Info:h=N.default.Info;break;case p.InputBoxValidationSeverity.Warning:h=N.default.Warning;break;case p.InputBoxValidationSeverity.Error:h=N.default.Error;break;default:h=y.message?N.default.Error:N.default.Ignore;break}return{content:y.message,severity:h}}async showWorkspaceFolderPick(b,y=C.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!h)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(k=>k.uri.toString()===h.uri.toString())}createQuickPick(b){const y=new l(b,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(b){const y=new g(b,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(b,y){this.e.get(b)?._fireDidChangeValue(y)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,y){const h=this.e.get(b);h instanceof l&&h._fireDidChangeActive(y)}$onDidChangeSelection(b,y){const h=this.e.get(b);h instanceof l&&h._fireDidChangeSelection(y)}$onDidTriggerButton(b,y){this.e.get(b)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(b,y,h){const E=this.e.get(b);E instanceof l&&E._fireDidTriggerItemButton(y,h)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class c{static{this.a=1}constructor(b,y){this.x=b,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$he,this.q=new O.$he,this.r=new O.$he,this.s=new O.$he,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((y,h)=>{const E=y===p.$ON.Back?-1:h;this.o.set(E,y)}),this.z({buttons:b.map((y,h)=>({...a(y.iconPath),tooltip:y.tooltip,handle:y===p.$ON.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const y=this.o.get(b);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(b){if(!this.v){for(const y of Object.keys(b)){const h=b[y];this.u[y]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function u($){if($ instanceof p.$mN)return{id:$.id};const b=w($),y=i($);return{dark:typeof b=="string"?M.URI.file(b):b,light:typeof y=="string"?M.URI.file(y):y}}function i($){return typeof $=="object"&&"light"in $?$.light:$}function w($){return typeof $=="object"&&"dark"in $?$.dark:$}function a($){const b=u($);let y,h;return"id"in b?h=S.ThemeIcon.asClassName(b):y=b,{iconPath:y,iconClass:h}}class l extends c{constructor(b,y){super(b.identifier,y),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$he,this.L=[],this.M=new O.$he,this.N=new O.$he,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((E,k)=>{this.C.set(k,E),this.D.set(E,k)});const y=(0,d.$NG)(this.O,"quickPickItemTooltip"),h=[];for(let E=0;E<b.length;E++){const k=b[E];if(k.kind===p.QuickPickItemKind.Separator)h.push({type:"separator",label:k.label});else{k.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=k.iconPath?a(k.iconPath):void 0;h.push({handle:E,label:k.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:y?v.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((P,V)=>({...a(P.iconPath),tooltip:P.tooltip,handle:V}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(b){const y=(0,D.$Hb)(b.map(h=>this.C.get(h)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(b){const y=(0,D.$Hb)(b.map(h=>this.C.get(h)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(b,y){const h=this.C.get(b);if(!h||!h.buttons||!h.buttons.length)return;const E=h.buttons[y];E&&this.N.fire({button:E,item:h})}}class g extends c{constructor(b,y){super(b.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:N.default.Error}):this.z({validationMessage:b.message,severity:b.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new t(r,o)}}),define(ke[283],Se([1,0,2,5,69,6,11,4,18,149,12,21,36,8,25,16,23]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=e.$1nc=void 0;function n(I){return I instanceof C.URI}function t(I,P){return I.scheme===s.Schemas.file&&P.scheme===s.Schemas.file&&r.$k?I.toString()===P.toString():I.toString().toLowerCase()===P.toString().toLowerCase()}function c(I){if(I)return typeof I.iconPath=="string"?C.URI.file(I.iconPath):C.URI.isUri(I.iconPath)||d.ThemeIcon.isThemeIcon(I.iconPath)?I.iconPath:void 0}function u(I){if(I.icon){if(C.URI.isUri(I.icon))return I.icon;if(d.ThemeIcon.isThemeIcon(I.icon))return I.icon;{const P=I.icon;return{light:P.light,dark:P.dark}}}else return}function i(I,P){if(!I.iconPath&&!P.iconPath)return 0;if(I.iconPath){if(!P.iconPath)return 1}else return-1;const V=typeof I.iconPath=="string"?I.iconPath:C.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id,W=typeof P.iconPath=="string"?P.iconPath:C.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,D.$wr)(V,W)}function w(I,P){let V=0;if(I.strikeThrough!==P.strikeThrough)return I.strikeThrough?1:-1;if(I.faded!==P.faded)return I.faded?1:-1;if(I.tooltip!==P.tooltip)return(I.tooltip||"").localeCompare(P.tooltip||"");if(V=i(I,P),V!==0)return V;if(I.light&&P.light)V=i(I.light,P.light);else{if(I.light)return 1;if(P.light)return-1}if(V!==0)return V;if(I.dark&&P.dark)V=i(I.dark,P.dark);else{if(I.dark)return 1;if(P.dark)return-1}return V}function a(I,P){if(I.command!==P.command)return I.command<P.command?-1:1;if(I.title!==P.title)return I.title<P.title?-1:1;if(I.tooltip!==P.tooltip){if(I.tooltip!==void 0&&P.tooltip!==void 0)return I.tooltip<P.tooltip?-1:1;if(I.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(I.arguments===P.arguments)return 0;if(I.arguments)if(P.arguments){if(I.arguments.length!==P.arguments.length)return I.arguments.length-P.arguments.length}else return 1;else return-1;for(let V=0;V<I.arguments.length;V++){const W=I.arguments[V],q=P.arguments[V];if(W!==q&&!(n(W)&&n(q)&&t(W,q)))return W<q?-1:1}return 0}function l(I,P){let V=(0,D.$wr)(I.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(V!==0)return V;if(I.command&&P.command)V=a(I.command,P.command);else{if(I.command)return 1;if(P.command)return-1}if(V!==0)return V;if(I.decorations&&P.decorations)V=w(I.decorations,P.decorations);else{if(I.decorations)return 1;if(P.decorations)return-1}if(I.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)V=(0,D.$wr)(I.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(I.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(I.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)V=(0,D.$wr)(I.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(I.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return V}function g(I,P){for(let V=0;V<I.length;V++)if(I[V]!==P[V])return!1;return!0}function $(I,P){return I.command===P.command&&I.title===P.title&&I.tooltip===P.tooltip&&(I.arguments&&P.arguments?g(I.arguments,P.arguments):I.arguments===P.arguments)}function b(I,P){return(0,m.$ub)(I,P,$)}class y{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,f.$OG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,f.$OG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,f.$OG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,V,W,q,A){this.k=P,this.l=q,this.m=A,this.d="",this.e=new O.$he,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(P,V){(0,f.$OG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,V)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$1nc=y;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,V,W,q,A,U,K){this.q=P,this.s=V,this.t=W,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=U,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$he,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$he,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,V){const W=this.h.get(P);return W?(0,M.$sh)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(l),W=(0,m.$Db)(this.o,P,l).map(U=>{const K=U.toInsert.map(ie=>{const ce=this.e++;this.g.set(ce,ie);const ve=ie.resourceUri;let Ee;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const fe=new F.$Tc;Ee=this.s.converter.toInternal(ie.command,fe),this.j.set(ce,fe)}else this.h.set(ce,ie.command);const ge=(0,f.$NG)(this.w,"scmMultiDiffEditor"),ue=ge?ie.multiDiffEditorOriginalUri:void 0,Ce=ge?ie.multiFileDiffEditorModifiedUri:void 0,re=c(ie.decorations),Ne=ie.decorations&&c(ie.decorations.light)||re,Te=ie.decorations&&c(ie.decorations.dark)||re,T=[Ne,Te],X=ie.decorations&&ie.decorations.tooltip||"",pe=ie.decorations&&!!ie.decorations.strikeThrough,Ie=ie.decorations&&!!ie.decorations.faded,ye=ie.contextValue||"";return{rawResource:[ce,ve,T,X,pe,Ie,ye,Ee,ue,Ce],handle:ce}});return{start:U.start,deleteCount:U.deleteCount,toInsert:K}}),q=W.map(({start:U,deleteCount:K,toInsert:ie})=>[U,K,ie.map(ce=>ce.rawResource)]),A=W.reverse();for(const{start:U,deleteCount:K,toInsert:ie}of A){const ce=ie.map(Ee=>Ee.handle),ve=this.n.splice(U,K,...ce);for(const Ee of ve)this.g.delete(Ee),this.h.delete(Ee),this.j.get(Ee)?.dispose(),this.j.delete(Ee)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let V;(0,f.$NG)(this.x,"quickDiffProvider")&&(V=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:V})}get historyProvider(){return(0,f.$OG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,f.$OG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new F.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new F.$Tc,this.o=P;const V=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,f.$OG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,f.$OG)(this.x,"scmActionButton"),this.p.value=new F.$Tc,this.q=P;const V=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&b(this.t,P))return;this.s.value=new F.$Tc,this.t=P;const V=(P||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(P,V,W,q,A,U,K){this.x=P,this.y=q,this.z=A,this.A=U,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Vc,this.m=void 0,this.n=new F.$Vc,this.o=void 0,this.p=new F.$Vc,this.s=new F.$Vc,this.t=void 0,this.u=!1,this.v=new O.$he,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=W;const ie=C.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new y(P,V,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,A,U,K,ie)}createResourceGroup(P,V,W){const q=(0,f.$NG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,A=new h(this.#e,this.y,this.w,P,V,q,this.x),U=O.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,U),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const P=[],V=[];for(const[W,q]of this.C){q.dispose();const A=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});O.Event.once(W.onDidDispose)(()=>{this.D.delete(W),A.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),P.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const U=W._takeResourceStateSnapshot();U.length>0&&V.push([W.handle,U]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,P,V),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&P.push([V.handle,W])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$6h)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$6h)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new S.$Xm,this.j=new O.$he,this.e=P.getProxy(p.$nM.MainThreadSCM),this.f=P.getProxy(p.$nM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const U=this.g.get(A.sourceControlHandle);if(!U)return A;const K=U.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const U=this.g.get(A.sourceControlHandle);return U?U.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const U=this.g.get(A.handle);return U||A}return A}})}createSourceControl(P,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const A=o.d++,U=new E(P,this.m,this.e,this.l,V,W,q);this.g.set(A,U);const K=this.h.get(P.identifier)||[];return K.push(U),this.h.set(P.identifier,K),U}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const V=this.h.get(P.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(P,V,W){const q=C.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const A=this.g.get(P);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$sh)(()=>A.quickDiffProvider.provideOriginalResource(q,W)).then(U=>U||null)}$onInputBoxValueChange(P,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const W=this.g.get(P);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(P,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,V,W);const A=this.g.get(P);if(!A)return Promise.resolve(void 0);const U=A.getResourceGroup(V);return U?U.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(P,V,W){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$sh)(()=>q.inputBox.validateInput(V,W)).then(A=>{if(!A)return Promise.resolve(void 0);const U=v.MarkdownString.fromStrict(A.message);return U?Promise.resolve([U,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,V,W,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(P,V,W,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(V,W,q))?.map(K=>({...K,icon:u(K)}))??void 0}async $provideHistoryItemSummary(P,V,W,q){const A=this.g.get(P)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const U=await A.provideHistoryItemSummary(V,W,q);return U?{...U,icon:u(U)}:void 0}async $provideHistoryItemChanges(P,V,W,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$2nc=k,e.$2nc=k=o=Je([We(3,N.$7j)],k)}),define(ke[284],Se([1,0,4,8,2]),function(he,e,C,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3nc=void 0;class F{static{this.a=0}constructor(p,m){this.d=m,this.c=new Map,this.b=p.getProxy(C.$nM.MainThreadShare)}async $provideShare(p,m,D){return await this.c.get(p)?.provideShare({selection:O.Range.to(m.selection),resourceUri:R.URI.revive(m.resourceUri)},D)??void 0}registerShareProvider(p,m){const D=F.a++;return this.c.set(D,m),this.b.$registerShareProvider(D,O.DocumentSelector.from(p,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(D),this.c.delete(D)}}}}e.$3nc=F}),define(ke[285],Se([1,0,7,4,178,6,8,15]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=e.$5nc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$nN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$nN("statusBarItem.warningForeground")]])}#e;#t;constructor(d,v,f,s,r,o=C.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new F.$Tc,this.#e=d,this.#t=v,r&&s){this.c=(0,C.$2M)(s.identifier,r);const t=f.get(this.c);t&&(o=t.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,n=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String(m.a++);this.e=s,this.f=r,this.g=o,this.h=this.u(n)}u(d){if((0,p.$eg)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(d){this.k=d,this.v()}set name(d){this.m=d,this.v()}set tooltip(d){this.l=d,this.v()}set color(d){this.n=d,this.v()}set backgroundColor(d){d&&!m.b.has(d.id)&&(d=void 0),this.o=d,this.v()}set command(d){this.r?.fromApi!==d&&(this.p&&this.q.add(this.p),this.p=new F.$Tc,typeof d=="string"?this.r={fromApi:d,internal:this.#t.toInternal({title:"",command:d},this.p)}:d?this.r={fromApi:d,internal:this.#t.toInternal(d,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(d){this.t=d,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let d;this.e?this.f?d=`${this.e.identifier.value}.${this.f}`:d=this.e.identifier.value:d=this.f;let v;this.m?v=this.m:v=(0,R.localize)(0,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=m.b.get(this.o.id));const s=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,d,this.e?.identifier.value,v,this.k,s,this.r?.internal,f,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$5nc=m;class D{constructor(d){this.b=[],this.a=d.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(d){const v={message:d};return this.b.unshift(v),this.c(),new C.$pM(()=>{const f=this.b.indexOf(v);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class N{constructor(d,v){this.e=new Map,this.a=d.getProxy(O.$nM.MainThreadStatusBar),this.b=v,this.c=new D(this)}$acceptStaticEntries(d){for(const v of d)this.e.set(v.entryId,v)}createStatusBarEntry(d,v,f,s){return new m(this.a,this.b,this.e,d,v,f,s)}setStatusBarMessage(d,v){const f=this.c.setMessage(d);let s;return typeof v=="number"?s=setTimeout(()=>f.dispose(),v):typeof v<"u"&&v.then(()=>f.dispose(),()=>f.dispose()),new C.$pM(()=>{f.dispose(),clearTimeout(s)})}}e.$6nc=N}),define(ke[115],Se([1,0,30,107,52,77,62,8,2]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=e.$5O=e.$4O=void 0;const D=(t,c,u,i)=>{let w=c;return{enumerable:!0,configurable:!1,get(){return w},set(a){if(!u(w,a)){const l=w;w=a,t.listener?.(i(a,l))}}}},N=(t,c)=>t===c,S={range:(t,c)=>t===c?!0:!t||!c?!1:t.isEqual(c),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(t,c)=>!(t.length!==c.length||t.some(u=>!c.find(i=>u.id===i.id)))},d=t=>c=>({op:4,update:t(c)}),v=(t,c)=>({range:(()=>{let u;const i=d(w=>({range:C.$At.lift(p.Range.from(w))}));return{enumerable:!0,configurable:!1,get(){return u},set(w){t.listener?.({op:6}),S.range(u,w)||(u=w,t.listener?.(i(w)))}}})(),label:D(t,c,S.label,d(u=>({label:u}))),description:D(t,void 0,S.description,d(u=>({description:u}))),sortText:D(t,void 0,S.sortText,d(u=>({sortText:u}))),canResolveChildren:D(t,!1,S.canResolveChildren,u=>({op:2,state:u})),busy:D(t,!1,S.busy,d(u=>({busy:u}))),error:D(t,void 0,S.error,d(u=>({error:p.MarkdownString.fromStrict(u)||null}))),tags:D(t,[],S.tags,(u,i)=>({op:1,new:u.map(p.TestTag.from),old:i.map(p.TestTag.from)}))}),f=t=>{const c=R.$_K.fromString(t.extId),u=new r(c.controllerId,c.localId,t.label,m.URI.revive(t.uri)||void 0);return u.range=p.Range.to(t.range||void 0),u.description=t.description||void 0,u.sortText=t.sortText||void 0,u.tags=t.tags.map(i=>p.TestTag.to({id:(0,M.$fL)(i).tagId})),u},s=t=>{let c;for(const u of t.tests){const i=f(u.item);(0,O.$NO)(i).parent=c,c=i}return c};e.$4O=s;class r{constructor(c,u,i,w){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const a=(0,O.$MO)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:w,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof o?void 0:a.parent}},children:{value:(0,F.$LO)(a,O.$NO,r),enumerable:!0,writable:!1},...v(a,i)})}}e.$5O=r;class o extends r{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.$6O=o;class n extends F.$HO{constructor(c,u,i){super({controllerId:c,getDocumentVersion:w=>w&&i.getDocument(w)?.version,getApiFor:O.$NO,getChildren:w=>w.children,root:new o(c,u),toITestItem:p.TestItem.from})}}e.$7O=n}),define(ke[35],Se([1,0,15,7,8,26,4,18,12,45,30,94,2,6,3,17,115,22,34,44,66,59,63,33]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c,u,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=void 0;let a=class{#e;#t;#i;constructor(h,E,k){this.b=new Map,this.c=new Map,this.#e=h.getProxy(M.$nM.MainThreadCommands),this.d=E,this.#i=k,this.#t=h.getProxy(M.$nM.MainThreadTelemetry),this.converter=new l(this,I=>{const P=this.c.get(I);return P?.result===$.Void?P:void 0},E),this.f=[{processArgument(I){return(0,D.$0h)(I)}},{processArgument(I){return(0,F.$9n)(I,function(P){if(N.$At.isIRange(P))return R.Range.to(P);if(S.$zt.isIPosition(P))return R.Position.to(P);if(N.$At.isIRange(P.range)&&d.URI.isUri(P.uri))return R.location.to(P);if(P instanceof o.$Je)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const E=this.registerCommand(!1,h.id,async(...k)=>{const I=h.args.map((V,W)=>{if(!V.validate(k[W]))throw new Error(`Invalid argument '${V.name}' when running '${h.id}', received: ${typeof k[W]=="object"?JSON.stringify(k[W],null,"	"):k[W]} `);return V.convert(k[W])}),P=await this.executeCommand(h.internalId,...I);return h.result.convert(P,k,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new O.$pM(()=>{E.dispose(),this.c.delete(h.id)})}registerCommand(h,E,k,I,P,V){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:k,thisArg:I,metadata:P,extension:V}),h&&this.#e.$registerCommand(E),new O.$pM(()=>{this.b.delete(E)&&h&&this.#e.$unregisterCommand(E)})}executeCommand(h,...E){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,E,!0)}async g(h,E,k){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,E,!1);{let I=!1;const P=(0,F.$9n)(E,function(V){if(V instanceof O.$qM)return R.Position.from(V);if(V instanceof O.$rM)return R.Range.from(V);if(V instanceof O.$BM)return R.location.from(V);if(O.$RN.isNotebookRange(V))return R.NotebookRange.from(V);if(V instanceof ArrayBuffer)return I=!0,o.$Je.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return I=!0,o.$Je.wrap(V);if(V instanceof o.$Je)return I=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(h,I?new n.$Hw(P):P,k);return(0,D.$0h)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(h,E,!1);throw V}}}async h(h,E,k){const I=this.b.get(h);if(!I)throw new Error("Unknown command");const{callback:P,thisArg:V,metadata:W}=I;if(W?.args)for(let A=0;A<W.args.length;A++)try{(0,C.$rg)(E[A],W.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${W.args[A].name}' - ${W.args[A].description}`)}const q=c.$be.create();try{return await P.apply(V,E)}catch(A){if(h===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...E);U&&(h=U.command)}if(this.d.error(A,h,I.extension?.identifier),!k)throw A;if(I.extension?.identifier){const U=this.#i.onExtensionError(I.extension.identifier,A);this.d.trace("forwarded error to extension?",U,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$lj)(A)),this.id=h,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,h,q.elapsed())}}j(h,E,k){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new u.$lp(E),duration:k})}$executeContributedCommand(h,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const k=this.b.get(h);return k?(E=E.map(I=>this.f.reduce((P,V)=>V.processArgument(P,k.extension?.identifier),I)),this.h(h,E,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(E=>(h&&(E=E.filter(k=>k[0]!=="_")),E))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[E,k]of this.b){const{metadata:I}=k;I&&(h[E]=I)}return Promise.resolve(h)}};e.$aP=a,e.$aP=a=Je([We(0,s.$RO),We(1,m.$7j),We(2,i.$_O)],a),e.$bP=(0,f.$Ai)("IExtHostCommands");class l{constructor(h,E,k){this.d=h,this.f=E,this.g=k,this.delegatingCommandId=`__vsc${(0,w.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,E){if(!h)return;const k={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return k;const I=this.f(h.command);if(I)k.id=I.internalId,k.arguments=I.args.map((P,V)=>P.convert(h.arguments&&h.arguments[V]));else if((0,p.$Lb)(h.arguments)){const P=`${h.command} /${++this.c}`;this.b.set(P,h),E.add((0,v.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),k.$ident=P,k.id=this.delegatingCommandId,k.arguments=[P],this.g.trace("CommandsConverter#CREATE",h.command,P)}return k}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const E=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$cP=l;class g{static{this.Uri=new g("uri","Uri of a text document",h=>d.URI.isUri(h),h=>h)}static{this.Position=new g("position","A position in a text document",h=>O.$qM.isPosition(h),R.Position.from)}static{this.Range=new g("range","A range in a text document",h=>O.$rM.isRange(h),R.Range.from)}static{this.Selection=new g("selection","A selection in a text document",h=>O.$sM.isSelection(h),R.Selection.from)}static{this.Number=new g("number","",h=>typeof h=="number",h=>h)}static{this.String=new g("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=g.Arr(g.String)}static Arr(h){return new g(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,E=>Array.isArray(E)&&E.every(k=>h.validate(k)),E=>E.map(k=>h.convert(k)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",h=>h instanceof O.$NM,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",h=>h instanceof O.$_N,R.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VS Code TestItem",h=>h instanceof r.$5O,R.TestItem.from)}constructor(h,E,k,I){this.name=h,this.description=E,this.validate=k,this.convert=I}optional(){return new g(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,E){return new g(h??this.name,E??this.description,this.validate,this.convert)}}e.$dP=g;class ${static{this.Void=new $("no result",h=>h)}constructor(h,E){this.description=h,this.convert=E}}e.$eP=$;class b{constructor(h,E,k,I,P){this.id=h,this.internalId=E,this.description=k,this.args=I,this.result=P}}e.$fP=b}),define(ke[286],Se([1,0,18,16,2,89,98,31,35,8,7]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0;const S=[new m.$fP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to an array of DocumentHighlight-instances.",v(D.DocumentHighlight.to))),new m.$fP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$dP.Uri],new m.$eP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,r)=>{if((0,C.$Kb)(s))return;class o extends N.$IM{static to(t){const c=new o(t.name,D.SymbolKind.to(t.kind),t.containerName||"",new N.$BM(r[0],D.Range.to(t.range)));return c.detail=t.detail,c.range=c.location.range,c.selectionRange=D.Range.to(t.selectionRange),c.children=t.children?t.children.map(o.to):[],c}}return s.map(o.to)})),new m.$fP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$dP.Uri,new m.$dP("options","Formatting options",s=>!0,s=>s)],new m.$eP("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new m.$fP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$dP.Uri,m.$dP.Range,new m.$dP("options","Formatting options",s=>!0,s=>s)],new m.$eP("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new m.$fP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$dP.Uri,m.$dP.Position,new m.$dP("ch","Trigger character",s=>typeof s=="string",s=>s),new m.$dP("options","Formatting options",s=>!0,s=>s)],new m.$eP("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new m.$fP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$fP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$fP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$fP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$fP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to an array of Location-instances.",v(D.location.to))),new m.$fP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to an array of Hover-instances.",v(D.Hover.to))),new m.$fP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$dP.Uri,new m.$dP("position","A position in a text document",s=>Array.isArray(s)&&s.every(r=>N.$qM.isPosition(r)),s=>s.map(D.Position.from))],new m.$eP("A promise that resolves to an array of ranges.",s=>s.map(r=>{let o;for(const n of r.reverse())o=new N.$MM(D.Range.to(n),o);return o}))),new m.$fP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$dP.String.with("query","Search string")],new m.$eP("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(D.WorkspaceSymbol.to))),new m.$fP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(D.CallHierarchyItem.to))),new m.$fP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$dP.CallHierarchyItem],new m.$eP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(D.CallHierarchyIncomingCall.to))),new m.$fP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$dP.CallHierarchyItem],new m.$eP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(D.CallHierarchyOutgoingCall.to))),new m.$fP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:D.Range.to(s.range),placeholder:s.text}})),new m.$fP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$dP.Uri,m.$dP.Position,m.$dP.String.with("newName","The new symbol name")],new m.$eP("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return D.WorkspaceEdit.to(s)}})),new m.$fP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$dP.Uri,m.$dP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$eP("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(D.DocumentLink.to))),new m.$fP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$dP.Uri],new m.$eP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$IN(s.tokenTypes,s.tokenModifiers)})),new m.$fP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$dP.Uri],new m.$eP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const r=(0,M.$Obb)(s);if(r.type==="full")return new N.$KN(r.data,void 0)})),new m.$fP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$dP.Uri,m.$dP.Range.optional()],new m.$eP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$IN(s.tokenTypes,s.tokenModifiers)})),new m.$fP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$dP.Uri,m.$dP.Range],new m.$eP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const r=(0,M.$Obb)(s);if(r.type==="full")return new N.$KN(r.data,void 0)})),new m.$fP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$dP.Uri,m.$dP.Position,m.$dP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$dP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$eP("A promise that resolves to a CompletionList-instance.",(s,r,o)=>{if(!s)return new N.$YM([]);const n=s.suggestions.map(t=>D.CompletionItem.to(t,o));return new N.$YM(n,s.incomplete)})),new m.$fP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$dP.Uri,m.$dP.Position,m.$dP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$eP("A promise that resolves to SignatureHelp.",s=>{if(s)return D.SignatureHelp.to(s)})),new m.$fP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$dP.Uri,m.$dP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$eP("A promise that resolves to an array of CodeLens-instances.",(s,r,o)=>v(n=>new N.$QM(D.Range.to(n.range),n.command&&o.fromInternal(n.command)))(s))),new m.$fP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$dP.Uri,new m.$dP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>N.$rM.isRange(s),s=>N.$sM.isSelection(s)?D.Selection.from(s):D.Range.from(s)),m.$dP.String.with("kind","Code action kind to return code actions for").optional(),m.$dP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$eP("A promise that resolves to an array of Command-instances.",(s,r,o)=>v(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const t=new N.$KM(n.title,n.kind?new N.$LM(n.kind):void 0);return n.edit&&(t.edit=D.WorkspaceEdit.to(n.edit)),n.command&&(t.command=o.fromInternal(n.command)),t.isPreferred=n.isPreferred,t}})(s))),new m.$fP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$dP.Uri],new m.$eP("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(r=>new N.$5M(D.Range.to(r.range),D.Color.to(r.color))):[])),new m.$fP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$dP("color","The color to show and insert",s=>s instanceof N.$4M,D.Color.from),new m.$dP("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:D.Range.from(s.range)}))],new m.$eP("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(D.ColorPresentation.to):[])),new m.$fP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$dP.Uri,m.$dP.Range],new m.$eP("A promise that resolves to an array of Inlay objects",(s,r,o)=>s.map(D.InlayHint.to.bind(void 0,o)))),new m.$fP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$dP.Uri],new m.$eP("A promise that resolves to an array of FoldingRange objects",(s,r)=>{if(s)return s.map(D.FoldingRange.to)})),new m.$fP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$eP("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(r=>D.NotebookExclusiveDocumentPattern.to(r))})))),new m.$fP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$dP.Uri,m.$dP.Range,new m.$dP("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof N.$rM,s=>D.InlineValueContext.from(s))],new m.$eP("A promise that resolves to an array of InlineValue objects",s=>s.map(D.InlineValue.to))),new m.$fP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$dP("uriOrString","Uri-instance or string (only http/https)",s=>R.URI.isUri(s)||typeof s=="string"&&(0,O.$Kg)(s,O.Schemas.http,O.Schemas.https),s=>s),new m.$dP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional(),m.$dP.String.with("label","").optional()],m.$eP.Void),new m.$fP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$dP.Uri.with("resource","Resource to open"),m.$dP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$dP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional()],m.$eP.Void),new m.$fP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$dP.Uri.with("left","Left-hand side resource of the diff editor"),m.$dP.Uri.with("right","Right-hand side resource of the diff editor"),m.$dP.String.with("title","Human readable title for the diff editor").optional(),new m.$dP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)]).optional()],m.$eP.Void),new m.$fP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$dP.String.with("title","Human readable title for the changes editor"),new m.$dP("resourceList","List of resources to compare",s=>{for(const r of s){if(r.length!==3)return!1;const[o,n,t]=r;if(!R.URI.isUri(o)||!R.URI.isUri(n)&&n!==void 0&&n!==null||!R.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},s=>s)],m.$eP.Void),new m.$fP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$dP.Uri,m.$dP.Position],new m.$eP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new m.$fP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$dP.TypeHierarchyItem],new m.$eP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new m.$fP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$dP.TypeHierarchyItem],new m.$eP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new m.$fP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$dP.TestItem],m.$eP.Void),new m.$fP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$dP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$eP.Void),new m.$fP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$dP.String.with("name","The context key name"),new m.$dP("value","The context key value",()=>!0,s=>s)],m.$eP.Void),new m.$fP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$dP.Uri,m.$dP.StringArray,new m.$dP("MappedEditsContext","Mapped Edits Context",s=>D.MappedEditsContext.is(s),s=>D.MappedEditsContext.from(s))],new m.$eP("A promise that resolves to a workspace edit or null",s=>s?D.WorkspaceEdit.to(s):null)),new m.$fP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$dP("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?D.Range.from(s.initialRange):void 0,initialSelection:N.$sM.isSelection(s.initialSelection)?D.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?D.Position.from(s.position):void 0}})],m.$eP.Void)];class d{static register(r){S.forEach(r.registerApiCommand,r),this.a(r)}static a(r){r.registerCommand(!1,"_validateWhenClauses",p.$zj)}}e.$omc=d;function v(s){return r=>{if(Array.isArray(r))return r.map(s)}}function f(s){if(!Array.isArray(s))return;const r=[];for(const o of s)F.$vu(o)?r.push(D.DefinitionLink.to(o)):r.push(D.location.to(o));return r}}),define(ke[287],Se([1,0,2,35]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=void 0;class R{constructor(M,p,m,D,N){this.a=p,this.b=m,this.c=D;const S=new O.$fP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$dP("showOptions","Show Options",d=>!0,d=>d),new O.$dP("resource","Interactive resource Uri",d=>!0,d=>d),new O.$dP("controllerId","Notebook controller Id",d=>!0,d=>d),new O.$dP("title","Interactive editor title",d=>!0,d=>d)],new O.$eP("Notebook and input URI",d=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",d.notebookEditorId),d.notebookEditorId!==void 0){const v=this.a.getEditorById(d.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:C.URI.revive(d.notebookUri),inputUri:C.URI.revive(d.inputUri),notebookEditor:v.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",d.notebookUri,d.inputUri),{notebookUri:C.URI.revive(d.notebookUri),inputUri:C.URI.revive(d.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(M,p,m,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:m,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$Knc=R}),define(ke[288],Se([1,0,18,11,20,5,6,28,2,21,12,4,35,8,7,78,229,25,34,230]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0,e.$Snc=g;let c=class{constructor(b,y,h,E,k){this.m=y,this.n=h,this.o=E,this.q=k,this.b=new p.$Ac,this.c=new p.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$he,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=b.getProxy(S.$nM.MainThreadNotebookKernels);const I=new d.$fP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new d.$dP("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],d.$eP.Void),P=new d.$fP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[d.$dP.Uri],new d.$eP("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(I),this.o.registerApiCommand(P)}createNotebookController(b,y,h,E,k,I){for(const re of this.j.values())if(re.controller.id===y&&D.$Vm.equals(b.identifier,re.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const P=this.k++,V=this;this.q.trace(`NotebookController[${P}], CREATED by ${b.identifier.value}, ${y}`);const W=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${b.identifier}'`);let q=!1;const A=new F.$he,U=new F.$he,K={id:g(b.identifier,y),notebookType:h,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:E||b.identifier.value,preloads:I?I.map(v.NotebookRendererScript.from):[]};let ie=k??W,ce,ve;this.a.$addKernel(P,K).catch(re=>{console.log(re),q=!0});let Ee=0;const ge=()=>{if(q)return;const re=++Ee;Promise.resolve().then(()=>{re===Ee&&this.a.$updateKernel(P,K)})},ue=new p.$Ac,Ce={get id(){return y},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(re){K.label=re??b.displayName??b.name,ge()},get detail(){return K.detail??""},set detail(re){K.detail=re,ge()},get description(){return K.description??""},set description(re){K.description=re,ge()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(re){K.supportedLanguages=re,ge()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(re){K.supportsExecutionOrder=re,ge()},get rendererScripts(){return K.preloads?K.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(re){ie=re??W},get interruptHandler(){return ce},set interruptHandler(re){ce=re,K.supportsInterrupt=!!re,ge()},set variableProvider(re){(0,o.$OG)(b,"notebookVariableProvider"),ve=re,K.hasVariableProvider=!!re,re?.onDidChangeVariables(Ne=>V.a.$variablesUpdated(Ne.uri)),ge()},get variableProvider(){return ve},createNotebookCellExecution(re){if(q)throw new Error("notebook controller is DISPOSED");if(!ue.has(re.notebook.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return V._createNotebookCellExecution(re,g(b.identifier,this.id))},createNotebookExecution(re){if((0,o.$OG)(b,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ue.has(re.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return V._createNotebookExecution(re,g(b.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),A.dispose(),U.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(re,Ne){Ne===f.NotebookControllerAffinity2.Hidden&&(0,o.$OG)(b,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(P,re.uri,Ne)},onDidReceiveMessage:U.event,postMessage(re,Ne){return(0,o.$OG)(b,"notebookMessaging"),V.a.$postMessage(P,Ne&&V.n.getIdByEditor(Ne),re)},asWebviewUri(re){return(0,o.$OG)(b,"notebookMessaging"),(0,s.$sBb)(re,V.m.remote)}};return this.j.set(P,{extensionId:b.identifier,controller:Ce,onDidReceiveMessage:U,onDidChangeSelection:A,associatedNotebooks:ue}),Ce}getIdByController(b){for(const[y,h]of this.j)if(h.controller===b)return g(h.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,y){const h=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(h,y);const k={dispose:()=>{this.f.delete(h),E.a.$removeKernelDetectionTask(h)}};return this.f.set(h,k),k}registerKernelSourceActionProvider(b,y,h){const E=this.i++,k=typeof h.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,I=this;this.h.set(E,h),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,y);let P;return k!==void 0&&(P=h.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(E),I.a.$removeKernelSourceActionProvider(E,E),P?.dispose()}}}async $provideKernelSourceActions(b,y){const h=this.h.get(b);if(h){const E=new M.$Tc;return(await h.provideNotebookKernelSourceActions(y)??[]).map(I=>v.NotebookKernelSourceAction.from(I,this.o.converter,E))}return[]}$acceptNotebookAssociation(b,y,h){const E=this.j.get(b);if(E){const k=this.n.getNotebookDocument(m.URI.revive(y));h?E.associatedNotebooks.set(k.uri,!0):E.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,k.uri.toString(),h),E.onDidChangeSelection.fire({selected:h,notebook:k.apiNotebook})}}async $executeCells(b,y,h){const E=this.j.get(b);if(!E)return;const k=this.n.getNotebookDocument(m.URI.revive(y)),I=[];for(const P of h){const V=k.getCell(P);V&&I.push(V.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,k.uri.toString(),I.length),await E.controller.executeHandler.call(E.controller,I,k.apiNotebook,E.controller)}catch(P){this.q.error(`NotebookController[${b}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(b,y,h){const E=this.j.get(b);if(!E)return;const k=this.n.getNotebookDocument(m.URI.revive(y));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,k.apiNotebook);else for(const I of h){const P=k.getCell(I);P&&this.b.get(P.uri)?.cancel()}if(E.controller.interruptHandler){const I=this.c.get(k.uri);this.c.delete(k.uri),h.length&&Array.isArray(I)&&I.length&&I.forEach(P=>P.dispose())}}async $provideVariables(b,y,h,E,k,I,P){const V=this.j.get(b);if(!V)return;const W=this.n.getNotebookDocument(m.URI.revive(h)),q=V.controller.variableProvider;if(!q)return;let A;if(E!==void 0){if(A=this.s[E],!A)return}else this.s={};const U=k==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(W.apiNotebook,A,U,I,P);let ie=0;for await(const ce of K){if(P.isCancellationRequested)return;const ve={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,interfaces:ce.variable.interfaces,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ve.id]=ce.variable,this.a.$receiveVariable(y,ve),ie++>=t.$_ib)return}}$acceptKernelMessageFromRenderer(b,y,h){const E=this.j.get(b);if(!E)return;const k=this.n.getEditorById(y);E.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:h}))}$cellExecutionChanged(b,y,h){const k=this.n.getNotebookDocument(m.URI.revive(b)).getCell(y);if(k){const I=h?v.NotebookCellExecutionState.to(h):f.NotebookCellExecutionState.Idle;I!==void 0&&this.l.fire({cell:k.apiCell,state:I})}}_createNotebookCellExecution(b,y){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const k=new i(y,E,this.a);this.b.set(E.uri,k);const I=k.onDidChangeState(()=>{k.state===u.Resolved&&(k.dispose(),I.dispose(),this.b.delete(E.uri))});return k.asApiObject()}_createNotebookExecution(b,y){const h=this.n.getNotebookDocument(b.uri),E=b.getCells().find(P=>{const V=h.getCellFromApiCell(P);return V&&this.b.has(V.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const k=new a(y,h,this.a),I=k.onDidChangeState(()=>{k.state===w.Resolved&&(k.dispose(),I.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[k,I]),k.asApiObject()}};e.$Rnc=c,e.$Rnc=c=Je([We(4,N.$7j)],c);var u;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(u||(u={}));class i extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(b,y,h){super(),this.m=y,this.n=h,this.b=i.a++,this.c=new F.$he,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new R.$se),this.h=new l(10,E=>this.s(E)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,b,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(b){await this.h.addItem(b)}async s(b){const y=Array.isArray(b)?b:[b];return this.n.$updateExecution(this.b,new n.$Hw(y))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(b){let y=this.m;if(b&&(y=this.m.notebook.getCellFromApiCell(b)),!y)throw new Error("INVALID cell");return y.handle}y(b){return b.map(y=>{const h=f.$VN.ensureUniqueMimeTypes(y.items,!0);return h===y.items?v.NotebookCellOutput.from(y):v.NotebookCellOutput.from({items:h,id:y.id,metadata:y.metadata})})}async z(b,y,h){const E=this.w(y),k=this.y((0,C.$2b)(b));return this.r({editType:r.CellExecutionUpdateType.Output,cellHandle:E,append:h,outputs:k})}async C(b,y,h){return b=f.$VN.ensureUniqueMimeTypes((0,C.$2b)(b),!0),this.r({editType:r.CellExecutionUpdateType.OutputItems,items:b.map(v.NotebookCellOutputItem.from),outputId:y.id,append:h})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.m.apiCell},get executionOrder(){return b.j},set executionOrder(h){b.j=h,b.s([{editType:r.CellExecutionUpdateType.ExecutionState,executionOrder:b.j}])},start(h){if(b.f===u.Resolved||b.f===u.Started)throw new Error("Cannot call start again");b.f=u.Started,b.c.fire(),b.s({editType:r.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,E,k){if(b.f===u.Resolved)throw new Error("Cannot call resolve twice");b.f=u.Resolved,b.c.fire(),b.h.flush();const I=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;b.n.$completeExecution(b.b,new n.$Hw({runEndTime:E,lastRunSuccess:h,error:I}))},clearOutput(h){return b.t(),b.z([],h,!1)},appendOutput(h,E){return b.t(),b.z(h,E,!0)},replaceOutput(h,E){return b.t(),b.z(h,E,!1)},appendOutputItems(h,E){return b.t(),b.C(h,E,!0)},replaceOutputItems(h,E){return b.t(),b.C(h,E,!1)}})}}var w;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(w||(w={}));class a extends M.$Uc{static{this.a=0}get state(){return this.f}constructor(b,y,h){super(),this.h=y,this.j=h,this.b=a.a++,this.c=new F.$he,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new R.$se),this.j.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===w.Resolved||this.f===w.Started)throw new Error("Cannot call start again");this.f=w.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===w.Resolved)throw new Error("Cannot call resolve twice");this.f=w.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(b,y){this.f=b,this.g=y,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new O.$Xh,this.b=Date.now(),(0,O.$Bh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>b.complete())}}function g($,b){return`${$.value}/${b}`}}),define(ke[53],Se([1,0,5,4,3,2,17,6,7,180,14,208,20,33,209,36,11,8,35]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=e.$5mc=e.$4mc=e.$3mc=void 0,e.$3mc=(0,R.$Ai)("IExtHostTerminalService");class t extends p.$Uc{constructor(h,E,k,I){super(),this.u=h,this._id=E,this.w=k,this.y=I,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new C.$he),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(V,W=!0){P.C(),P.u.$sendText(P._id,V,W)},show(V){P.C(),P.u.$show(P._id,V)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(h,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??E?.cwd??void 0,env:h.env??void 0,icon:g(h.iconPath)??void 0,color:s.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(h.location,E?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,E,k,I,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:I,color:s.ThemeColor.isThemeColor(P)?P.id:void 0,location:E?.location||this.z(h,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(h,E){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in h?{viewColumn:o.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.y=h}setExitStatus(h,E){this.j=Object.freeze({code:h,reason:E})}setDimensions(h,E){return h===this.f&&E===this.h||h===0||E===0?!1:(this.f=h,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(h){this.n=h}_setProcessId(h){this.g?(this.g(h),this.g=void 0):this.b.then(E=>{E!==h&&(this.b=Promise.resolve(h))})}}e.$4mc=t;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new C.$he,this.onProcessData=this.a.event,this.b=new C.$he,this.d=new C.$he,this.onDidChangeProperty=this.d.event,this.f=new C.$he,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,E){this.g.setDimensions?.({columns:h,rows:E})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,i=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,E,k){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$he,this.onDidCloseTerminal=this.H.event,this.I=new C.$he,this.onDidOpenTerminal=this.I.event,this.J=new C.$he,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$he,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$he,this.onDidChangeTerminalState=this.M.event,this.N=new C.$he,this.onDidChangeShell=this.N.event,this.O=new C.$he({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$he({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(O.$nM.MainThreadTerminalService),this.y=new f.$qwb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:I=>{const P=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(I?.$mid){case 15:return P(I);default:{if(Array.isArray(I))for(let V=0;V<I.length&&I[V].$mid===15;V++)I[V]=P(I[V]);return I}}}}),this.B({dispose:()=>{for(const[I,P]of this.g)P.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,E){const k=new t(this.a,(0,v.$Wg)(),h,h.name),I=new c(h.pty);return k.createExtensionTerminal(h.location,E,this.R(h,E).resolvedExtHostIdentifier,g(h.iconPath),$(h.color)).then(P=>{const V=this.S(P,I);this.h[P]=V}),this.f.push(k),k.value}R(h,E){if(E=E||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const k=h.location.parentTerminal;if(k){const I=this.f.find(P=>P.value===k);I&&(E.resolvedExtHostIdentifier=I._id)}}else h.location&&typeof h.location!="object"?E.location=h.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(h,E){if(!this.getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const I=new c(E),P=this.S(h,I);this.h[h]=P}async $acceptActiveTerminalChanged(h){const E=this.b;if(h===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(h);k&&(this.b=k,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,E){const k=this.getTerminalById(h);k&&this.O.fire({terminal:k.value,data:E})}async $acceptTerminalDimensions(h,E,k){const I=this.getTerminalById(h);I&&I.setDimensions(E,k)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(h,E){const k=this.getTerminalById(h);k&&this.P.fire({terminal:k.value,...E})}async $acceptTerminalMaximumDimensions(h,E,k){this.g.get(h)?.resize(E,k)}async $acceptTerminalTitleChange(h,E){const k=this.getTerminalById(h);k&&(k.name=E)}async $acceptTerminalClosed(h,E,k){const I=this.X(this.f,h);if(I!==null){const P=this.f.splice(I,1)[0];P.setExitStatus(E,k),this.H.fire(P.value)}}$acceptTerminalOpened(h,E,k,I){if(E){const W=this.X(this.f,E);if(W!==null){this.f[W]._id=h,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const P={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:F.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},V=new t(this.a,h,P,k);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(h,E){this.getTerminalById(h)?._setProcessId(E)}async $startExtensionTerminal(h,E){const k=this.getTerminalById(h);if(!k)return{message:(0,D.localize)(0,null,h)};k.isOpen||await new Promise(P=>{const V=this.onDidOpenTerminal(async W=>{W===k.value&&(V.dispose(),P())})});const I=this.g.get(h);I?I.startSendingEvents(E):this.j[h]={initialDimensions:E}}S(h,E){const k=new p.$Tc;k.add(E.onProcessReady(P=>this.a.$sendProcessReady(h,P.pid,P.cwd,P.windowsPty))),k.add(E.onDidChangeProperty(P=>this.a.$sendProcessProperty(h,P))),this.y.startBuffering(h,E.onProcessData),k.add(E.onProcessExit(P=>this.U(h,P))),this.g.set(h,E);const I=this.j[h];return I&&E instanceof c&&(E.startSendingEvents(I.initialDimensions),delete this.j[h]),k}$acceptProcessAckDataEvent(h,E){this.g.get(h)?.acknowledgeDataEvent(E)}$acceptProcessInput(h,E){this.g.get(h)?.input(E)}$acceptTerminalInteraction(h){const E=this.getTerminalById(h);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(h,E){this.getTerminalById(h)?.setSelection(E)}$acceptProcessResize(h,E,k){try{this.g.get(h)?.resize(E,k)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(h,E){this.g.get(h)?.shutdown(E)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(E=>this.a.$sendProcessProperty(h,{type:"cwd",value:E}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$pM(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,E,k){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,k),this.a.$registerProfileProvider(E,h.identifier.value),new m.$pM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(h,E,k){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,k),this.a.$registerQuickFixProvider(h,E),new m.$pM(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,E){const k=new d.$se().token;if(k.isCancellationRequested)return;const I=this.D.get(h);if(!I)return;const P=await I.provideTerminalQuickFixes(E,k);if(P===null||Array.isArray(P)&&P.length===0)return;const V=new p.$Tc;if(this.w.value=V,!Array.isArray(P))return P?o.TerminalQuickFix.from(P,this.Q.converter,V):void 0;const W=[];for(const q of P){const A=o.TerminalQuickFix.from(q,this.Q.converter,V);A&&W.push(A)}return W}async $createContributedProfileTerminal(h,E){const k=new d.$se().token;let I=await this.C.get(h)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,E);return}this.createTerminalFromOptions(I.options,E)}}async $provideLinks(h,E){const k=this.getTerminalById(h);if(!k)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const P=new d.$se;this.G.set(h,P);const V=[],W={terminal:k.value,line:E},q=[];for(const K of this.z)q.push(r.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const ce=await K.provideTerminalLinks(W,P.token)||[];P.token.isCancellationRequested||ie({provider:K,links:ce})}));const A=await Promise.all(q);if(P.token.isCancellationRequested)return[];const U=new Map;for(const K of A)K&&K.links.length>0&&V.push(...K.links.map(ie=>{const ce={id:u++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return U.set(ce.id,{provider:K.provider,link:ie}),ce}));return this.F.set(h,U),V}$activateLink(h,E){const k=this.F.get(h)?.get(E);k&&k.provider.handleTerminalLink(k.link)}U(h,E){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const k=this.h[h];k&&(k.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,E)}getTerminalById(h){return this.W(this.f,h)}getTerminalIdByApiObject(h){const E=this.f.findIndex(k=>k.value===h);return E>=0?E:null}W(h,E){const k=this.X(h,E);return k!==null?h[k]:null}X(h,E){const k=h.findIndex(I=>I._id===E);return k>=0?k:null}getEnvironmentVariableCollection(h){let E=this.n.get(h.identifier.value);return E||(E=new w,this.Z(h.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(h,E){const k=(0,S.$rs)(E.map),I=(0,S.$ss)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(h,E.persistent,k.length===0?void 0:k,I)}$initEnvironmentVariableCollections(h){h.forEach(E=>{const k=E[0],I=new w(E[1]);this.Z(k,I)})}$acceptDefaultProfile(h,E){const k=this.s;this.s=h,this.u=E,k?.path!==h.path&&this.N.fire(h.path)}Z(h,E){this.n.set(h,E),E.onDidChangeCollection(()=>{this.Y(h,E)})}};e.$5mc=i,e.$5mc=i=Je([We(1,n.$bP),We(2,M.$RO)],i);class w{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$he,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const E=this.h(h);let k=this.a.get(E);return k||(k=new a(this,h),this.a.set(E,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(h,E,k,I){this.f(h,{value:E,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:I})}append(h,E,k,I){this.f(h,{value:E,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:I})}prepend(h,E,k,I){this.f(h,{value:E,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:I})}f(h,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(h,E.scope),I=this.map.get(k),P=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==E.value||I.type!==E.type||I.options?.applyAtProcessCreation!==P.applyAtProcessCreation||I.options?.applyAtShellIntegration!==P.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const V=this.g(h,E.scope),W={variable:h,...E,options:P};this.map.set(V,W),this.d.fire()}}get(h,E){const k=this.g(h,E),I=this.map.get(k);return I?b(I):void 0}g(h,E){const k=this.h(E);return k.length?`${h}:::${k}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const E=new Map;for(const[k,I]of this.map)this.h(I.scope)===this.h(h)&&E.set(I.variable,b(I));return E}delete(h,E){const k=this.g(h,E);this.map.delete(k),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[E,k]of this.map)k.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(E);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,E){const k=this.h(E),I=this.descriptionMap.get(k);if(!I||I.description!==h){let P;typeof h=="string"?P=h:P=h?.value.split(`

`)[0];const V={description:P,scope:E};this.descriptionMap.set(k,V),this.d.fire()}}getDescription(h){const E=this.h(h);return this.descriptionMap.get(E)?.description}k(h){const E=this.h(h);this.descriptionMap.delete(E)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,E){this.b=h,this.d=E,this.a=new C.$he}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,E,k){this.b.replace(h,E,k,this.d)}append(h,E,k){this.b.append(h,E,k,this.d)}prepend(h,E,k){this.b.prepend(h,E,k,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,E){this.b.getVariableMap(this.d).forEach((k,I)=>h.call(E,I,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends i{constructor(h,E){super(!1,h,E)}createTerminal(h,E,k){throw new N.$_}createTerminalFromOptions(h,E){throw new N.$_}};e.$6mc=l,e.$6mc=l=Je([We(0,n.$bP),We(1,M.$RO)],l);function g(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function $(y){return s.ThemeColor.isThemeColor(y)?y:void 0}function b(y){const h={...y};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(ke[116],Se([1,0,7,6,3,4,17,53,5,2,11]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=e.$0nc=void 0,e.$0nc=(0,R.$Ai)("IExtHostTerminalShellIntegration");let S=class extends O.$Uc{constructor(r,o){super(),this.h=o,this.b=new Map,this.c=new m.$he,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$he,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$he,this.onDidEndTerminalShellExecution=this.g.event,this.a=r.getProxy(F.$nM.MainThreadTerminalShellIntegration),this.B((0,O.$Sc)(()=>{for(const[n,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(r){const o=this.h.getTerminalById(r);if(!o)return;const n=o.value;let t=this.b.get(r);t||(t=new d(o.value,this.f),this.b.set(r,t),t.store.add(o.onWillDispose(()=>this.b.get(r)?.dispose())),t.store.add(t.onDidRequestShellExecution(c=>this.a.$executeCommand(r,c))),t.store.add(t.onDidRequestEndExecution(c=>this.g.fire(c))),t.store.add(t.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),o.shellIntegration=t.value),this.c.fire({terminal:n,shellIntegration:t.value})}$shellExecutionStart(r,o,n,t,c){this.b.has(r)||this.$shellIntegrationChange(r);const u={value:o,confidence:n,isTrusted:t};this.b.get(r)?.startShellExecution(u,c)}$shellExecutionEnd(r,o,n,t,c){const u={value:o,confidence:n,isTrusted:t};this.b.get(r)?.endShellExecution(u,c)}$shellExecutionData(r,o){this.b.get(r)?.emitData(o)}$cwdChange(r,o){this.b.get(r)?.setCwd((0,D.$vc)(o)?D.URI.revive(o):o)}$closeTerminal(r){this.b.get(r)?.dispose(),this.b.delete(r)}};e.$$nc=S,e.$$nc=S=Je([We(0,M.$RO),We(1,p.$3mc)],S);class d extends O.$Uc{get currentExecution(){return this.a}constructor(r,o){super(),this.j=r,this.m=o,this.b=!1,this.store=this.B(new O.$Tc),this.f=this.B(new m.$he),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$he),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$he),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(t,c){let u=t;c&&(u+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(u);const i={value:u,confidence:C.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},w=n.startShellExecution(i,n.c,!0).value;return n.b=!0,w}}}startShellExecution(r,o,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new v(r,o);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(r){this.currentExecution?.emitData(r)}endShellExecution(r,o){this.a&&(this.a.endExecution(r),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:o}),this.a=void 0)}setCwd(r){let o=!1;D.URI.isUri(this.c)?o=!D.URI.isUri(r)||this.c.toString()!==r.toString():this.c!==r&&(o=!0),o&&(this.c=r,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class v{constructor(r,o){this.c=r,this.cwd=o,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return N.$1h.EMPTY;this.a=new f}return this.a.createIterable()}emitData(r){this.a?.emitData(r)}endExecution(r){r&&(this.c=r),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends O.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new N.$zh);const r=this.a;return new N.$1h(async n=>{this.b.push(n),await r.wait()})}emitData(r){for(const o of this.b)o.emitOne(r)}endExecution(){this.a?.open(),this.a=void 0}}}),define(ke[289],Se([1,0,11,22,20,5,262,73,6,15,33,12,4,17,115,8,7,52,77,62,25]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=e.$boc=e.$aoc=e.$_nc=void 0;let u=class extends m.$Uc{constructor(V,W,q,A){super(),this.w=A,this.f=this.B(new F.$he),this.g=new Map,this.s=this.B(new F.$he),this.onResultsChanged=this.f.event,this.results=[],this.h=V.getProxy(d.$nM.MainThreadTesting),this.m=new h(this.h),this.j=new l(this.h,W),q.registerArgumentProcessor({processArgument:U=>{switch(U?.$mid){case 16:{const K=U,ie=K.tests[K.tests.length-1].item.extId;return this.g.get(o.$_K.root(ie))?.collection.tree.get(ie)?.actual??(0,f.$4O)(U)}case 18:{const{test:K,message:ie}=U,ce=K.item.extId;return{test:this.g.get(o.$_K.root(ce))?.collection.tree.get(ce)?.actual??(0,f.$4O)({$mid:16,tests:[K]}),message:s.TestMessage.to(ie)}}default:return U}}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const U=await q.executeCommand("_testing.getExplorerSelection"),K=ie=>{const ce=this.g.get(o.$_K.root(ie));if(ce)return o.$_K.isRoot(ie)?ce.controller:ce.collection.tree.get(ie)?.actual};return{include:U?.include.map(K).filter(D.$ig)||[],exclude:U?.exclude.map(K).filter(D.$ig)||[]}})}createTestController(V,W,q,A){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const U=new m.$Tc,K=U.add(new f.$7O(W,q,this.w));K.root.label=q;const ie=new Map,ce=new Set,ve=this.h,Ee={items:K.root.children,get label(){return q},set label(ue){q=ue,K.root.label=ue,ve.$updateController(W,{label:q})},get refreshHandler(){return A},set refreshHandler(ue){A=ue,ve.$updateController(W,{canRefresh:!!ue})},get id(){return W},createRunProfile:(ue,Ce,re,Ne,Te,T)=>{let X=(0,p.$oj)(ue);for(;ie.has(X);)X++;return new k(this.h,ie,ce,this.s.event,W,X,ue,Ce,re,Ne,Te,T)},createTestItem(ue,Ce,re){return new f.$5O(W,ue,Ce,re)},createTestRun:(ue,Ce,re=!0)=>this.j.createTestRun(V,W,K,ue,Ce,re),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const Ce=ue instanceof Array?ue:[ue];this.h.$markTestRetired(Ce.map(re=>o.$_K.fromExtHostTestItem(re,W).toString()))}},set resolveHandler(ue){K.resolveHandler=ue},get resolveHandler(){return K.resolveHandler},dispose:()=>{U.dispose()}};ve.$registerTestController(W,q,!!A),U.add((0,m.$Sc)(()=>ve.$unregisterTestController(W)));const ge={controller:Ee,collection:K,profiles:ie,extension:V,activeProfiles:ce};return this.g.set(W,ge),U.add((0,m.$Sc)(()=>this.g.delete(W))),U.add(K.onDidGenerateDiff(ue=>ve.$publishDiff(W,ue.map(t.TestsDiffOp.serialize)))),Ee}createTestObserver(){return this.m.checkout()}async runTests(V,W=R.CancellationToken.None){const q=g(V);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const A=this.g.get(q.controllerId);if(!A)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:V.preserveFocus??!0,targets:[{testIds:V.include?.map(U=>o.$_K.fromExtHostTestItem(U,A.collection.root.id).toString())??[A.collection.root.id],profileGroup:I[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:V.exclude?.map(U=>U.id)},W)}$syncTests(){for(const{collection:V}of this.g.values())V.flushDiff();return Promise.resolve()}async $getCoverageDetails(V,W){return(await this.j.getCoverageDetails(V,W))?.map(s.TestCoverage.fromDetails)}async $disposeRun(V){this.j.disposeTestRun(V)}$configureRunProfile(V,W){this.g.get(V)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(V){const W=new Map;for(const[q,A]of Object.entries(V)){const U=this.g.get(q);if(!U)continue;const K=new Map,ie=A.filter(ve=>!U.activeProfiles.has(ve)),ce=[...U.activeProfiles].filter(ve=>!A.includes(ve));for(const ve of ie)K.set(ve,!0),U.activeProfiles.add(ve);for(const ve of ce)K.set(ve,!1),U.activeProfiles.delete(ve);K.size&&W.set(q,K)}this.s.fire(W)}async $refreshTests(V,W){await this.g.get(V)?.controller.refreshHandler?.(W)}$publishTestResults(V){this.results=Object.freeze(V.map(s.TestResults.to).concat(this.results).sort((W,q)=>q.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(V,W){const q=this.g.get(o.$_K.fromString(V).controllerId)?.collection;q&&(await q.expand(V,W<0?1/0:W),q.flushDiff())}$acceptDiff(V){this.m.applyDiff(V.map(W=>t.TestsDiffOp.deserialize({asCanonicalUri:q=>q},W)))}async $runControllerTests(V,W){return Promise.all(V.map(q=>this.y(q,!1,W)))}async $startContinuousRun(V,W){const q=new R.$se(W),A=await Promise.all(V.map(U=>this.y(U,!0,q.token)));return!W.isCancellationRequested&&!A.some(U=>U.error)&&await new Promise(U=>W.onCancellationRequested(U)),q.dispose(!0),A}async y(V,W,q){const A=this.g.get(V.controllerId);if(!A)return{};const{collection:U,profiles:K,extension:ie}=A,ce=K.get(V.profileId);if(!ce)return{};const ve=V.testIds.map(Ce=>U.tree.get(Ce)).filter(D.$ig),Ee=V.excludeExtIds.map(Ce=>A.collection.tree.get(Ce)).filter(D.$ig).filter(Ce=>ve.some(re=>re.fullId.compare(Ce.fullId)===2));if(!ve.length)return{};const ge=new r.$3N(ve.some(Ce=>Ce.actual instanceof f.$6O)?void 0:ve.map(Ce=>Ce.actual),Ee.map(Ce=>Ce.actual),ce,W),ue=(0,t.$cL)(V)&&this.j.prepareForMainThreadTestRun(ie,ge,$.fromInternal(V,A.collection),ce,q);try{return await ce.runHandler(ge,q),{}}catch(Ce){return{error:String(Ce)}}finally{ue&&ue.hasRunningTasks&&!q.isCancellationRequested&&await F.Event.toPromise(ue.onEnd)}}$cancelExtensionTestRun(V){V===void 0?this.j.cancelAllRuns():this.j.cancelRunById(V)}};e.$_nc=u,e.$_nc=u=Je([We(0,v.$RO),We(1,S.$7j)],u);const i=1e4;var w;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(w||(w={}));class a extends m.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(V,W,q,A,U,K){super(),this.y=V,this.z=W,this.C=q,this.D=A,this.F=U,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new F.$he),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$se(K));const ie=this.B(new C.$Mh(()=>this.G(),i));this.B(this.j.token.onCancellationRequested(()=>ie.schedule()));const ce=new F.$he;this.s=ce.event,this.B((0,m.$Sc)(()=>{ce.fire(),ce.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.G()}getCoverageDetails(V,W){const[,q]=o.$_K.fromString(V).path,A=this.w.get(V);if(!A)return[];const U=this.g.get(q);if(!U)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(U.run,A,W)??[]}createRun(V){const W=this.y.id,q=this.y.controllerId,A=(0,N.$Wg)(),U=Ee=>(ge,...ue)=>{if(ie){this.C.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ge)&&(this.I(ge),Ee(ge,...ue))},K=(Ee,ge)=>{const ue=ge instanceof Array?ge.map(s.TestMessage.from):[s.TestMessage.from(ge)];if(Ee.uri&&Ee.range){const Ce={range:s.Range.from(Ee.range),uri:Ee.uri};for(const re of ue)re.location=re.location||Ce}this.z.$appendTestMessagesInRun(W,A,o.$_K.fromExtHostTestItem(Ee,q).toString(),ue)};let ie=!1;const ce=new Map,ve={isPersisted:this.y.isPersisted,token:this.j.token,name:V,onDidDispose:this.s,addCoverage:Ee=>{if(ie)return;const ge=Ee instanceof r.$8N?Ee.testItem:void 0;let ue;if(ge){if((0,c.$OG)(this.F,"attributableCoverage"),!this.y.isIncluded(ge))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.I(ge),ue=ce.get(ge),ue===void 0&&(ue=ce.size,ce.set(ge,ue))}const Ce=Ee.uri.toString(),re=new o.$_K(ue!==void 0?[W,A,Ce,String(ue)]:[W,A,Ce]).toString();this.w.set(re,Ee),this.z.$appendCoverage(W,A,s.TestCoverage.fromFile(q,re,Ee))},enqueued:U(Ee=>{this.z.$updateTestStateInRun(W,A,o.$_K.fromExtHostTestItem(Ee,q).toString(),1)}),skipped:U(Ee=>{this.z.$updateTestStateInRun(W,A,o.$_K.fromExtHostTestItem(Ee,q).toString(),5)}),started:U(Ee=>{this.z.$updateTestStateInRun(W,A,o.$_K.fromExtHostTestItem(Ee,q).toString(),2)}),errored:U((Ee,ge,ue)=>{K(Ee,ge),this.z.$updateTestStateInRun(W,A,o.$_K.fromExtHostTestItem(Ee,q).toString(),6,ue)}),failed:U((Ee,ge,ue)=>{K(Ee,ge),this.z.$updateTestStateInRun(W,A,o.$_K.fromExtHostTestItem(Ee,q).toString(),4,ue)}),passed:U((Ee,ge)=>{this.z.$updateTestStateInRun(W,A,o.$_K.fromExtHostTestItem(Ee,this.y.controllerId).toString(),3,ge)}),appendOutput:(Ee,ge,ue)=>{ie||(ue&&(this.y.isIncluded(ue)?this.I(ue):ue=void 0),this.z.$appendOutputToRun(W,A,O.$Je.fromString(Ee),ge&&s.location.from(ge),ue&&o.$_K.fromExtHostTestItem(ue,q).toString()))},end:()=>{ie||(ie=!0,ce.clear(),this.z.$finishedTestRunTask(W,A),--this.f||this.H())}};return this.f++,this.g.set(A,{run:ve}),this.z.$startedTestRunTask(W,{id:A,name:V,running:!0}),ve}G(){for(const{run:V}of this.g.values())V.end()}H(){this.c!==2&&(this.c=2,this.m.fire())}I(V){if(!(V instanceof f.$5O))throw new n.$JO(V.id);if(this.h.has(o.$_K.fromExtHostTestItem(V,this.y.controllerId).toString()))return;const W=[],q=this.y.colllection.root;for(;;){const A=s.TestItem.from(V);if(W.unshift(A),this.h.has(A.extId)||(this.h.add(A.extId),V===q))break;V=V.parent||q}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.H(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(V,W){this.g=V,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(V,W){const q=o.$_K.root(V);return this.f.get(q)?.getCoverageDetails(V,W)||[]}disposeTestRun(V){this.f.get(V)?.dispose(),this.f.delete(V);for(const[W,{id:q}]of this.c)q===V&&this.c.delete(W)}prepareForMainThreadTestRun(V,W,q,A,U){return this.j(W,q,A,V,U)}cancelRunById(V){this.f.get(V)?.cancel()}cancelAllRuns(){for(const V of this.c.values())V.cancel()}createTestRun(V,W,q,A,U,K){const ie=this.c.get(A);if(ie)return ie.createRun(U);const ce=$.fromPublic(W,q,A,K),ve=g(A);this.g.$startedExtensionTestRun({controllerId:W,continuous:!!A.continuous,profile:ve&&{group:I[ve.kind],id:ve.profileId},exclude:A.exclude?.map(ge=>o.$_K.fromExtHostTestItem(ge,q.root.id).toString())??[],id:ce.id,include:A.include?.map(ge=>o.$_K.fromExtHostTestItem(ge,q.root.id).toString())??[q.root.id],preserveFocus:A.preserveFocus??!0,persist:K});const Ee=this.j(A,ce,A.profile,V);return F.Event.once(Ee.onEnd)(()=>{this.g.$finishedExtensionTestRun(ce.id)}),Ee.createRun(U)}j(V,W,q,A,U){const K=new a(W,this.g,this.h,q,A,U);return this.c.set(V,K),this.f.set(K.id,K),K}}e.$aoc=l;const g=P=>{if(P.profile){if(!(P.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class ${static fromPublic(V,W,q,A){return new $(V,(0,N.$Wg)(),q.include?.map(U=>o.$_K.fromExtHostTestItem(U,V).toString())??[V],q.exclude?.map(U=>o.$_K.fromExtHostTestItem(U,V).toString())??[],A,W)}static fromInternal(V,W){return new $(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,W)}constructor(V,W,q,A,U,K){this.controllerId=V,this.id=W,this.isPersisted=U,this.colllection=K,this.c=q.map(ie=>ie+"\0"),this.f=A.map(ie=>ie+"\0")}isIncluded(V){const W=o.$_K.fromExtHostTestItem(V,this.controllerId).toString()+"\0";for(const q of this.f)if(W===q||W.startsWith(q))return!1;for(const q of this.c)if(W===q||W.startsWith(q))return!0;return!1}}e.$boc=$;class b{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(V){this.j=V,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(V){this.c.add(V)}update(V){Object.assign(V.revived,s.TestItem.toPlain(V.item)),this.c.has(V)||this.f.add(V)}remove(V){if(this.c.has(V)){this.c.delete(V);return}this.f.delete(V);const W=o.$_K.parentId(V.item.extId);if(W&&this.h.has(W.toString())){this.h.add(V.item.extId);return}this.g.add(V)}getChangeEvent(){const{c:V,f:W,g:q}=this;return{get added(){return[...V].map(A=>A.revived)},get updated(){return[...W].map(A=>A.revived)},get removed(){return[...q].map(A=>A.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends t.$iL{constructor(){super(...arguments),this.s=new F.$he,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(V){return this.f.get(V)}getMirroredTestDataByReference(V){return this.f.get(V.id)}w(V,W){return{...V,revived:s.TestItem.toPlain(V.item),depth:W?W.depth+1:0,children:new Set}}v(){return new b(this.s)}}class h{constructor(V){this.f=V}checkout(){this.c||(this.c=this.g());const V=this.c;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(W=>W.revived)},dispose:(0,M.$db)(()=>{--V.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(V){return this.c?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.c?.tests.apply(V)}g(){const V=new y({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:V}}}const E=(P,V,W,q)=>{W?Object.assign(W,q):V.$updateTestRunConfig(P.controllerId,P.profileId,q)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(V){V!==this.f&&(this.f=V,E(this,this.#e,this.#n,{label:V}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(V){V!==this.g&&(this.g=V,E(this,this.#e,this.#n,{supportsContinuousRun:V}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(V){V!==this.isDefault&&(V?this.#t.add(this.profileId):this.#t.delete(this.profileId),E(this,this.#e,this.#n,{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,E(this,this.#e,this.#n,{tag:V?s.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this.c}set configureHandler(V){V!==this.c&&(this.c=V,E(this,this.#e,this.#n,{hasConfigurationHandler:!!V}))}get onDidChangeDefault(){return F.Event.chain(this.#i,V=>V.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(D.$ig))}constructor(V,W,q,A,U,K,ie,ce,ve,Ee=!1,ge=void 0,ue=!1){this.controllerId=U,this.profileId=K,this.f=ie,this.kind=ce,this.runHandler=ve,this._tag=ge,this.g=ue,this.#e=V,this.#s=W,this.#t=q,this.#i=A,W.set(K,this);const Ce=I[ce];if(typeof Ce!="number")throw new Error(`Unknown TestRunProfile.group ${ce}`);Ee&&q.add(K),this.#n={profileId:K,controllerId:U,tag:ge?s.TestTag.namespace(this.controllerId,ge.id):null,label:ie,group:Ce,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$coc=k;const I={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(ke[117],Se([1,0,57,14,91,8,7]),function(he,e,C,O,R,F,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=e.$YO=void 0;class p{static{this.c=new R.$WO("TextEditorDecorationType")}constructor(d,v,f){const s=p.c.nextId();d.$registerTextEditorDecorationType(v.identifier,s,F.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:s,dispose(){d.$removeTextEditorDecorationType(s)}})}}e.$YO=p;class m{constructor(d,v){this.g=[],this.h=void 0,this.j=!1,this.c=d,this.d=d.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(d,v){this.k();let f=null;if(d instanceof M.$qM)f=new M.$rM(d,d);else if(d instanceof M.$rM)f=d;else throw new Error("Unrecognized location");this.l(f,v,!1)}insert(d,v){this.k(),this.l(new M.$rM(d,d),v,!0)}delete(d){this.k();let v=null;if(d instanceof M.$rM)v=d;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(d,v,f){const s=this.c.validateRange(d);this.g.push({range:s,text:v,forceMoveMarkers:f})}setEndOfLine(d){if(this.k(),d!==M.EndOfLine.LF&&d!==M.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=d}}class D{constructor(d,v,f,s){this.c=d,this.d=v,this._accept(f),this.e=s;const r=this;this.value={get tabSize(){return r.f},set tabSize(o){r.n(o)},get indentSize(){return r.g},set indentSize(o){r.p(o)},get insertSpaces(){return r.j},set insertSpaces(o){r.s(o)},get cursorStyle(){return r.k},set cursorStyle(o){r.t(o)},get lineNumbers(){return r.l},set lineNumbers(o){r.u(o)}}}_accept(d){this.f=d.tabSize,this.g=d.indentSize,this.h=d.originalIndentSize,this.j=d.insertSpaces,this.k=d.cursorStyle,this.l=F.TextEditorLineNumbersStyle.to(d.lineNumbers)}m(d){if(d==="auto")return"auto";if(typeof d=="number"){const v=Math.floor(d);return v>0?v:null}if(typeof d=="string"){const v=parseInt(d,10);return isNaN(v)?null:v>0?v:null}return null}n(d){const v=this.m(d);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(d){if(d==="tabSize")return"tabSize";if(typeof d=="number"){const v=Math.floor(d);return v>0?v:null}if(typeof d=="string"){const v=parseInt(d,10);return isNaN(v)?null:v>0?v:null}return null}p(d){const v=this.o(d);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(d){return d==="auto"?"auto":d==="false"?!1:!!d}s(d){const v=this.q(d);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(d){this.k!==d&&(this.k=d,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:d})))}u(d){this.l!==d&&(this.l=d,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(d)})))}assign(d){const v={};let f=!1;if(typeof d.tabSize<"u"){const s=this.m(d.tabSize);s==="auto"?(f=!0,v.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,f=!0,v.tabSize=s)}if(typeof d.indentSize<"u"){const s=this.o(d.indentSize);s==="tabSize"?(f=!0,v.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,f=!0,v.indentSize=s)}if(typeof d.insertSpaces<"u"){const s=this.q(d.insertSpaces);s==="auto"?(f=!0,v.insertSpaces=s):this.j!==s&&(this.j=s,f=!0,v.insertSpaces=s)}typeof d.cursorStyle<"u"&&this.k!==d.cursorStyle&&(this.k=d.cursorStyle,f=!0,v.cursorStyle=d.cursorStyle),typeof d.lineNumbers<"u"&&this.l!==d.lineNumbers&&(this.l=d.lineNumbers,f=!0,v.lineNumbers=F.TextEditorLineNumbersStyle.from(d.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(d,v){v.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${d}' failed:'`),this.e.warn(f)})}}e.$ZO=D;class N{constructor(d,v,f,s,r,o,n,t){this.id=d,this.j=v,this.k=f,this.g=!1,this.h=new Set,this.c=r,this.d=new D(this.j,this.id,o,f),this.e=n,this.f=t;const c=this;this.value=Object.freeze({get document(){return s.value},set document(u){throw new O.$9("document")},get selection(){return c.c&&c.c[0]},set selection(u){if(!(u instanceof M.$sM))throw(0,O.$7)("selection");c.c=[u],c.l()},get selections(){return c.c},set selections(u){if(!Array.isArray(u)||u.some(i=>!(i instanceof M.$sM)))throw(0,O.$7)("selections");c.c=u,c.l()},get visibleRanges(){return c.e},set visibleRanges(u){throw new O.$9("visibleRanges")},get options(){return c.d.value},set options(u){c.g||c.d.assign(u)},get viewColumn(){return c.f},set viewColumn(u){throw new O.$9("viewColumn")},edit(u,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const w=new m(s.value,i);return u(w),c.m(w)},insertSnippet(u,i,w={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=c.c.map(l=>F.Range.from(l));else if(i instanceof M.$qM){const{lineNumber:l,column:g}=F.Position.from(i);a=[{startLineNumber:l,startColumn:g,endLineNumber:l,endColumn:g}]}else if(i instanceof M.$rM)a=[F.Range.from(i)];else{a=[];for(const l of i)if(l instanceof M.$rM)a.push(F.Range.from(l));else{const{lineNumber:g,column:$}=F.Position.from(l);a.push({startLineNumber:g,startColumn:$,endLineNumber:g,endColumn:$})}}return v.$tryInsertSnippet(d,s.value.version,u.value,a,w)},setDecorations(u,i){const w=i.length===0;w&&!c.h.has(u.key)||(w?c.h.delete(u.key):c.h.add(u.key),c.n(()=>{if(F.$OO(i))return v.$trySetDecorations(d,u.key,F.$PO(i));{const a=new Array(4*i.length);for(let l=0,g=i.length;l<g;l++){const $=i[l];a[4*l]=$.start.line+1,a[4*l+1]=$.start.character+1,a[4*l+2]=$.end.line+1,a[4*l+3]=$.end.character+1}return v.$trySetDecorationsFast(d,u.key,a)}}))},revealRange(u,i){c.n(()=>v.$tryRevealRange(d,F.Range.from(u),i||M.TextEditorRevealType.Default))},show(u){v.$tryShowEditor(d,F.ViewColumn.from(u))},hide(){v.$tryHideEditor(d)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(d){(0,C.ok)(!this.g),this.d._accept(d)}_acceptVisibleRanges(d){(0,C.ok)(!this.g),this.e=d}_acceptViewColumn(d){(0,C.ok)(!this.g),this.f=d}_acceptSelections(d){(0,C.ok)(!this.g),this.c=d}async l(){const d=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,d)),this.value}m(d){const v=d.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const f=v.edits.map(r=>r.range);f.sort((r,o)=>r.end.line===o.end.line?r.end.character===o.end.character?r.start.line===o.start.line?r.start.character-o.start.character:r.start.line-o.start.line:r.end.character-o.end.character:r.end.line-o.end.line);for(let r=0,o=f.length-1;r<o;r++){const n=f[r].end;if(f[r+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=v.edits.map(r=>({range:F.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,s,{setEndOfLine:typeof v.setEndOfLine=="number"?F.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(d){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$1O=N}),define(ke[68],Se([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3O=e.$2O=void 0;class o{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,u){this.h=c,this.i=u,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new O.$he,this.e=new O.$he,this.f=new O.$he,this.g=new O.$he,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],i=[],w=[];if(c.removedDocuments)for(const a of c.removedDocuments){const l=F.URI.revive(a),g=this.c.get(l);g?.unref()&&(this.c.delete(l),u.push(g.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const l=F.URI.revive(a.uri);let g=this.c.get(l);if(g&&l.scheme!==f.Schemas.vscodeNotebookCell&&l.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);g||(g=new o(new m.$UO(this.h.getProxy(p.$nM.MainThreadDocuments),l,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(l,g),i.push(g.value)),g.ref()}if(c.removedEditors)for(const a of c.removedEditors){const l=this.b.get(a);this.b.delete(a),l&&w.push(l)}if(c.addedEditors)for(const a of c.addedEditors){const l=F.URI.revive(a.documentUri);C.ok(this.c.has(l),`document '${l}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const g=this.c.get(l).value,$=new N.$1O(a.id,this.h.getProxy(p.$nM.MainThreadTextEditors),this.i,new r.$V(()=>g.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(b=>S.Range.to(b)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,$)}c.newActiveEditor!==void 0&&(C.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,R.$Pc)(u),(0,R.$Pc)(w),c.removedDocuments&&this.e.fire(u),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const u=this.b.get(this.a);return c?u:u?.value}allEditors(){return[...this.b.values()]}};e.$2O=n,e.$2O=n=Je([We(0,D.$RO),We(1,d.$7j)],n),e.$3O=(0,M.$Ai)("IExtHostDocumentsAndEditors")}),define(ke[290],Se([1,0,18,5,4,117,8,7]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class m{constructor(N,S){this.i=S,this.a=new O.$he,this.b=new O.$he,this.c=new O.$he,this.d=new O.$he,this.f=new O.$he,this.g=new O.$he,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(R.$nM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(d=>this.g.fire(d)),this.i.onDidChangeActiveTextEditor(d=>this.f.fire(d))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const S=this.i.allEditors();return N?S:S.map(d=>d.value)}async showTextDocument(N,S,d){let v;typeof S=="number"?v={position:M.ViewColumn.from(S),preserveFocus:d}:typeof S=="object"?v={position:M.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?M.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:v={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(N.uri,v),s=f&&this.i.getEditor(f);if(s)return s.value;throw f?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,S){return new F.$YO(this.h,N,S).value}$acceptEditorPropertiesChanged(N,S){const d=this.i.getEditor(N);if(!d)throw new Error("unknown text editor");if(S.options&&d._acceptOptions(S.options),S.selections){const v=S.selections.selections.map(M.Selection.to);d._acceptSelections(v)}if(S.visibleRanges){const v=C.$Hb(S.visibleRanges.map(M.Range.to));d._acceptVisibleRanges(v)}if(S.options&&this.b.fire({textEditor:d.value,options:{...S.options,lineNumbers:M.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const v=p.TextEditorSelectionChangeKind.fromValue(S.selections.source),f=S.selections.selections.map(M.Selection.to);this.a.fire({textEditor:d.value,selections:f,kind:v})}if(S.visibleRanges){const v=C.$Hb(S.visibleRanges.map(M.Range.to));this.c.fire({textEditor:d.value,visibleRanges:v})}}$acceptEditorPositionData(N){for(const S in N){const d=this.i.getEditor(S);if(!d)throw new Error("Unknown text editor");const v=M.ViewColumn.to(N[S]);d.value.viewColumn!==v&&(d._acceptViewColumn(v),this.d.fire({textEditor:d.value,viewColumn:v}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.$vmc=m}),define(ke[291],Se([1,0,2,3,4,6,7,8,21,15]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=e.$eoc=void 0,e.$eoc=(0,O.$Ai)("IExtHostTimeline");class N{constructor(v,f){this.b=new Map,this.c=new Map,this.a=v.getProxy(R.$nM.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(s,r)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&m.$Vm.equals(r,this.b.get(s.source)?.extension)){const o=s.uri===void 0?void 0:C.URI.revive(s.uri);return this.c.get(s.source)?.get(S(o))?.get(s.handle)}else return;return s}})}async $getTimeline(v,f,s,r){return this.b.get(v)?.provider.provideTimeline(C.URI.revive(f),s,r)}registerTimelineProvider(v,f,s,r){const o=new F.$Tc,n=this.d(f.id,r,o).bind(this);let t;f.onDidChange&&(t=f.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:f.id}),this));const c=this.c;return this.f({...f,scheme:v,onDidChange:void 0,async provideTimeline(u,i,w){i?.resetCache&&(o.clear(),c.get(f.id)?.clear());const a=await f.provideTimeline(u,i,w);if(a==null)return;const l=n(u,i);return{...a,source:f.id,items:a.items.map(l)}},dispose(){for(const u of c.values())u.get(f.id)?.clear();t?.dispose(),o.dispose()}},s)}d(v,f,s){return(r,o)=>{let n;if(o?.cacheResults){let t=this.c.get(v);t===void 0&&(t=new Map,this.c.set(v,t));const c=S(r);n=t.get(c),n===void 0&&(n=new Map,t.set(c,n))}return t=>{const{iconPath:c,...u}=t,i=`${v}|${t.id??t.timestamp}`;n?.set(i,t);let w,a,l;t.iconPath&&(c instanceof M.$mN?l={id:c.id,color:c.color}:C.URI.isUri(c)?(w=c,a=c):{light:w,dark:a}=c);let g;return M.$RM.isMarkdownString(u.tooltip)?g=p.MarkdownString.from(u.tooltip):(0,D.$ag)(u.tooltip)?g=u.tooltip:M.$RM.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),g=p.MarkdownString.from(u.detail)):(0,D.$ag)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),g=u.detail),{...u,id:u.id??void 0,handle:i,source:v,command:t.command?f.toInternal(t.command,s):void 0,icon:w,iconDark:a,themeIcon:l,tooltip:g,accessibilityInformation:t.accessibilityInformation}}}}f(v,f){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:f}),(0,F.$Sc)(()=>{for(const r of this.c.values())r.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$foc=N;function S(d){return d?.toString()}}),define(ke[292],Se([1,0,181,24,2,5,6,222,11,7,15,18,8,55,20,143,25]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=void 0;function o(c,u){if((0,N.$ag)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(w=>w.length===2&&typeof w[0]=="number"&&typeof w[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends M.$Uc{constructor(u,i,w){super(),this.f=u,this.g=i,this.h=w,this.a=new Map,this.b=new s.$W0;function a(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>a(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(g=>a(g)?this.r(g):g):l})}registerTreeDataProvider(u,i,w){const a=this.createTreeView(u,{treeDataProvider:i},w);return{dispose:()=>a.dispose()}}createTreeView(u,i,w){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],g=!!i.dragAndDropController?.handleDrag,$=!!i.dragAndDropController?.handleDrop,b=this.m(u,i,w),y={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:a,dragMimeTypes:l,hasHandleDrag:g,hasHandleDrop:$,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(u,y),E={get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get activeItem(){return(0,r.$OG)(w,"treeViewActiveItem"),b.focusedElement},get onDidChangeActiveItem(){return(0,r.$OG)(w,"treeViewActiveItem"),b.onDidChangeActiveItem},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get onDidChangeCheckboxState(){return b.onDidChangeCheckboxState},get message(){return b.message},set message(k){(0,v.$Zk)(k)&&(0,r.$OG)(w,"treeViewMarkdownMessage"),b.message=k},get title(){return b.title},set title(k){b.title=k},get description(){return b.description},set description(k){b.description=k},get badge(){return b.badge},set badge(k){k!==void 0&&D.ViewBadge.isViewBadge(k)?b.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(b.badge=void 0)},reveal:(k,I)=>b.reveal(k,I),dispose:async()=>{await h,this.a.delete(u),b.dispose()}};return this.B(E),E}$getChildren(u,i){const w=this.a.get(u);return w?w.getChildren(i):Promise.reject(new p.$$F(u))}async $handleDrop(u,i,w,a,l,g,$,b){const y=this.a.get(u);if(!y)return Promise.reject(new p.$$F(u));const h=d.DataTransfer.toDataTransfer(w,async E=>(await this.f.$resolveDropFileData(u,i,E)).buffer);return $===u&&b&&await this.j(h,y,b,l,g),y.onDrop(h,a,l)}async j(u,i,w,a,l){const g=this.b.removeDragOperationTransfer(l);if(g)(await g)?.forEach(($,b)=>{$&&u.set(b,$)});else if(l&&i.handleDrag){const $=i.handleDrag(w,u,a);this.b.addDragOperationTransfer(l,$),await $}return u}async $handleDrag(u,i,w,a){const l=this.a.get(u);if(!l)return Promise.reject(new p.$$F(u));const g=await this.j(new D.$iN,l,i,a,w);if(!(!g||a.isCancellationRequested))return d.DataTransfer.from(g)}async $hasResolve(u){const i=this.a.get(u);if(!i)throw new p.$$F(u);return i.hasResolve}$resolve(u,i,w){const a=this.a.get(u);if(!a)throw new p.$$F(u);return a.resolveTreeItem(i,w)}$setExpanded(u,i,w){const a=this.a.get(u);if(!a)throw new p.$$F(u);a.setExpanded(i,w)}$setSelectionAndFocus(u,i,w){const a=this.a.get(u);if(!a)throw new p.$$F(u);a.setSelectionAndFocus(i,w)}$setVisible(u,i){const w=this.a.get(u);if(!w){if(!i)return;throw new p.$$F(u)}w.setVisible(i)}$changeCheckboxState(u,i){const w=this.a.get(u);if(!w)throw new p.$$F(u);w.setCheckboxState(i)}m(u,i,w){const a=this.B(new t(u,i,this.f,this.g.converter,this.h,w));return this.a.set(u,a),a}r(u){const i=this.a.get(u.$treeViewId);return i&&"$treeItemHandle"in u?i.getExtensionElement(u.$treeItemHandle):i&&"$focusedTreeItem"in u&&u.$focusedTreeItem?i.focusedElement:null}}e.$goc=n;class t extends M.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,N.$jg)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,i,w,a,l,g){if(super(),this.I=u,this.J=w,this.L=a,this.M=l,this.N=g,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$he),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$he),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$he),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$he),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$he),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$he),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$he),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$se,g.contributes&&g.contributes.views)for(const h in g.contributes.views)for(const E of g.contributes.views[h])E.id===u&&(this.P=E.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>{Array.isArray(h)&&h.length===0||this.F.fire({message:!1,element:h})}));let $,b;const y=F.Event.debounce(this.F.event,(h,E)=>(h||(h={message:!1,elements:[]}),E.element!==!1&&($||($=new Promise(k=>b=k),this.G=this.G.then(()=>$)),Array.isArray(E.element)?h.elements.push(...E.element):h.elements.push(E.element)),E.message&&(h.message=!0),h),200,!0);this.B(y(({message:h,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const k=b;return $=null,this.$(E).then(()=>k())})),h&&this.J.$setMessage(this.I,d.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const i=u?this.getExtensionElement(u):void 0;if(u&&!i)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let w=this.X(u);return w||(w=await this.Y(i)),w?w.map(a=>a.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,i){i=i||{select:!0,focus:!1};const w=(0,N.$jg)(i.select)?!0:i.select,a=(0,N.$jg)(i.focus)?!1:i.focus,l=(0,N.$jg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(g=>this.W(u,g[g.length-1]).then($=>this.J.$reveal(this.I,{item:$.item,parentChain:g.map(b=>b.item)},{select:w,focus:a,expand:l})),g=>this.M.error(g)):this.J.$reveal(this.I,void 0,{select:w,focus:a,expand:l})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=d.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,i){const w=this.getExtensionElement(u);w&&(i?this.u.fire(Object.freeze({element:w})):this.w.fire(Object.freeze({element:w})))}setSelectionAndFocus(u,i){const w=!(0,S.$ub)(this.s,u);this.s=u;const a=this.t!==i;this.t=i,w&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const i=(await Promise.all(u.map(async w=>{const a=this.getExtensionElement(w.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:w.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(w=>w!==void 0);i.forEach(w=>{w.treeItem.checkboxState=w.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(w=>[w.extensionItem,w.newState])})}async handleDrag(u,i,w){const a=[];for(const l of u){const g=this.getExtensionElement(l);g&&a.push(g)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,i,w),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,i,w){const a=i?this.getExtensionElement(i):void 0;if(!(!a&&i||!this.g?.handleDrop))return(0,m.$sh)(()=>this.g?.handleDrop?this.g.handleDrop(a,u,w):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,i){if(!this.f.resolveTreeItem)return;const w=this.j.get(u);if(w){const a=this.m.get(w);if(a){const l=await this.f.resolveTreeItem(a.extensionItem,w,i)??a.extensionItem;return this.hb(l),a.item.tooltip=this.eb(l.tooltip),a.item.command=this.fb(a.disposableStore,l.command),a.item}}}S(u){return this.U(u).then(i=>i?this.S(i).then(w=>this.W(i,w[w.length-1]).then(a=>(w.push(a),w))):Promise.resolve([]))}U(u){const i=this.m.get(u);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,m.$sh)(()=>this.f.getParent(u))}W(u,i){const w=this.m.get(u);return w?Promise.resolve(w):(0,m.$sh)(()=>this.f.getTreeItem(u)).then(a=>this.kb(u,a,i,!0)).then(a=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(a);if(l){const g=this.m.get(l);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let i;if(typeof u=="string"){const w=this.getExtensionElement(u);i=w?this.m.get(w):void 0}else i=u;return i&&i.children||void 0}return this.h}async Y(u){this.rb(u);const i=new f.$se(this.Z.token);try{const w=u?this.m.get(u):void 0,a=await this.f.getChildren(u);if(i.token.isCancellationRequested)return;const l=(0,S.$Hb)(a||[]),g=await Promise.all((0,S.$Hb)(l).map(b=>this.f.getTreeItem(b)));if(i.token.isCancellationRequested)return;const $=g.map((b,y)=>b?this.db(l[y],b,w):null);return(0,S.$Hb)($)}finally{i.dispose()}}$(u){if(u.some(w=>!w))return this.Z.dispose(!0),this.Z=new f.$se,this.tb(),this.J.$refresh(this.I);{const w=this.ab(u);if(w.length)return this.bb(w)}return Promise.resolve(void 0)}ab(u){const i=new Set,w=u.map(l=>this.m.get(l));for(const l of w)if(l&&!i.has(l.item.handle)){let g=l;for(;g&&g.parent&&w.findIndex($=>g&&g.parent&&$&&$.item.handle===g.parent.item.handle)===-1;){const $=this.j.get(g.parent.item.handle);g=$?this.m.get($):void 0}g&&!g.parent&&i.add(l.item.handle)}const a=[];return i.forEach(l=>{const g=this.j.get(l);if(g){const $=this.m.get(g);$&&(!$.parent||!i.has($.parent.item.handle))&&a.push(l)}}),a}bb(u){const i={};return Promise.all(u.map(w=>this.cb(w).then(a=>{a&&(i[w]=a.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(u){const i=this.getExtensionElement(u);if(i){const w=this.m.get(i);if(w)return this.rb(i),(0,m.$sh)(()=>this.f.getTreeItem(i)).then(a=>{if(a){const l=this.ib(i,a,w.parent);return this.pb(i,l,w,w.parent),w.dispose(),l}return null})}return Promise.resolve(null)}db(u,i,w){const a=this.ib(u,i,w);if(i.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,i.id));return this.ob(u,a),this.qb(a,w),a}eb(u){return D.$RM.isMarkdownString(u)?d.MarkdownString.from(u):u}fb(u,i){return i?{...this.L.toInternal(i,u),originalId:i.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let i,w,a;return typeof u.checkboxState=="number"?i=u.checkboxState:(i=u.checkboxState.state,w=u.checkboxState.tooltip,a=u.checkboxState.accessibilityInformation),{isChecked:i===D.TreeItemCheckboxState.Checked,tooltip:w,accessibilityInformation:a}}hb(u){if(!D.$dN.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,i,w){this.hb(i);const a=this.B(new M.$Tc),l=this.kb(u,i,w),g=this.lb(i);return{item:{handle:l,parentHandle:w?w.item.handle:void 0,label:o(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(a,i.command),contextValue:i.contextValue,icon:g,iconDark:this.mb(i)||g,themeIcon:this.jb(i),collapsibleState:(0,N.$jg)(i.collapsibleState)?D.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:w,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(u){return u.iconPath instanceof D.$mN?u.iconPath:void 0}kb(u,{id:i,label:w,resourceUri:a},l,g){if(i)return`${t.b}/${i}`;const $=o(w,this.N),b=l?l.item.handle:t.a;let y=$?$.label:a?(0,O.$$g)(a):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const h=this.m.has(u)?this.m.get(u).item.handle:void 0,E=this.X(l)||[];let k,I=0;do{if(k=`${b}/${I}:${y}`,g||!this.j.has(k)||h===k)break;I++}while(I<=E.length);return k}lb(u){if(u.iconPath&&!(u.iconPath instanceof D.$mN))return typeof u.iconPath=="string"||R.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof D.$mN)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return R.URI.isUri(u)?u:R.URI.file(u)}ob(u,i){this.j.set(i.item.handle,u),this.m.set(u,i)}pb(u,i,w,a){this.j.delete(i.item.handle),this.m.delete(u),i.item.handle!==w.item.handle&&this.j.delete(w.item.handle),this.ob(u,i);const l=this.X(a)||[],g=l.filter($=>$.item.handle===w.item.handle)[0];g&&l.splice(l.indexOf(g),1,i)}qb(u,i){i?(i.children||(i.children=[]),i.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const i=this.m.get(u);if(i){if(i.children)for(const w of i.children){const a=this.j.get(w.item.handle);a&&this.sb(a)}i.children=void 0}}else this.tb()}sb(u){const i=this.m.get(u);if(i){if(i.children)for(const w of i.children){const a=this.j.get(w.item.handle);a&&this.sb(a)}this.m.delete(u),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[293],Se([1,0,5,6,2,33,8,64,4,7]),function(he,e,C,O,R,F,M,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Omc=void 0;class N extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(f,s,r,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new C.$he),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$he),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=s,this.#n=r,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,R.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(f){this.#l||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#u=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:M.ViewColumn.from(f),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends O.$Uc{static c(){return(0,F.$Wg)()}constructor(f,s,r){super(),this.j=s,this.m=r,this.g=new Map,this.h=new Map,this.f=f.getProxy(m.$nM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,s,r,o,n={}){const t=typeof o=="object"?o.viewColumn:o,c={viewColumn:M.ViewColumn.from(t),preserveFocus:typeof o=="object"&&!!o.preserveFocus},u=(0,p.$Kmc)(f),i=S.c();this.f.$createWebviewPanel((0,p.$Mmc)(f),i,s,{title:r,panelOptions:d(n),webviewOptions:(0,p.$Nmc)(f,this.m,n),serializeBuffersForPostMessage:u},c);const w=this.j.createNewWebview(i,n,f);return this.createNewWebviewPanel(i,s,r,t,n,w,!0)}$onDidChangeWebviewPanelViewStates(f){const s=Object.keys(f);s.sort((r,o)=>{const n=f[r],t=f[o];return n.active?1:t.active?-1:+n.visible-+t.visible});for(const r of s){const o=this.getWebviewPanel(r);if(!o)continue;const n=f[r];o._updateViewState({active:n.active,visible:n.visible,viewColumn:M.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,s,r){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:r,extension:f}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,p.$Kmc)(f)}),new D.$pM(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(f,s,r,o){const n=this.h.get(s);if(!n)throw new Error(`No serializer found for '${s}'`);const{serializer:t,extension:c}=n,u=this.j.createNewWebview(f,r.webviewOptions,c),i=this.createNewWebviewPanel(f,s,r.title,o,r.panelOptions,u,r.active);await t.deserializeWebviewPanel(i,r.state)}createNewWebviewPanel(f,s,r,o,n,t,c){const u=new N(f,this.f,t,{viewType:s,title:r,viewColumn:o,panelOptions:n,active:c});return this.g.set(f,u),u}getWebviewPanel(f){return this.g.get(f)}}e.$Omc=S;function d(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(ke[294],Se([1,0,5,6,64,8,4,7]),function(he,e,C,O,R,F,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$joc=void 0;class m extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,d,v,f,s,r){super(),this.#s=!1,this.#u=this.B(new C.$he),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new C.$he),this.onDidDispose=this.#l.event,this.#i=v,this.#a=f,this.#e=S,this.#t=d,this.#n=s,this.#r=r}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=F.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class D{constructor(S,d){this.d=d,this.b=new Map,this.c=new Map,this.a=S.getProxy(M.$nM.MainThreadWebviewViews)}registerWebviewViewProvider(S,d,v,f){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:v,extension:S}),this.a.$registerWebviewViewProvider((0,R.$Mmc)(S),d,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$Kmc)(S)}),new p.$pM(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(S,d,v,f,s){const r=this.b.get(d);if(!r)throw new Error(`No view provider found for '${d}'`);const{provider:o,extension:n}=r,t=this.d.createNewWebview(S,{},n),c=new m(S,this.a,d,v,t,!0);this.c.set(S,c),await o.resolveWebviewView(c,{state:f},s)}async $onDidChangeWebviewViewVisibility(S,d){this.e(S)._setVisible(d)}async $disposeWebviewView(S){const d=this.e(S);this.c.delete(S),d.dispose(),this.d.deleteWebview(S)}e(S){const d=this.c.get(S);if(!d)throw new Error("No webview found");return d}}e.$joc=D}),define(ke[295],Se([1,0,5,29,31,3]),function(he,e,C,O,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JL=e.$IL=e.OutputChannelUpdateMode=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=void 0,e.$vL="text/x-code-output",e.$wL="output",e.$xL="Log",e.$yL="text/x-code-log-output",e.$zL="log",e.$AL="workbench.panel.output",e.$BL=new R.$Rj("inOutput",!1),e.$CL=new R.$Rj("activeLogOutput",!1),e.$DL=new R.$Rj("activeLogOutput.levelSettable",!1),e.$EL=new R.$Rj("activeLogOutput.level",""),e.$FL=new R.$Rj("activeLogOutput.levelIsDefault",!1),e.$GL=new R.$Rj("outputView.scrollLock",!1),e.$HL=(0,F.$Ai)("outputService");var M;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$IL={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new C.$he,this.onDidRegisterChannel=this.b.event,this.c=new C.$he,this.onDidRemoveChannel=this.c.event}registerChannel(D){this.a.has(D.id)||(this.a.set(D.id,D),this.b.fire(D.id))}getChannels(){const D=[];return this.a.forEach(N=>D.push(N)),D}getChannel(D){return this.a.get(D)}removeChannel(D){this.a.delete(D),this.c.fire(D)}}O.$ho.add(e.$IL.OutputChannels,new p),e.$JL=new R.$Rj("activeOutputChannel","")}),define(ke[118],Se([1,0,4,3,17,21,12,295,65,27,47,147,22,15,38,5,6]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=void 0;class o extends M.$ak{get disposed(){return this.n}constructor(u,i,w,a,l){super(),this.id=u,this.name=i,this.r=w,this.s=a,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(w.getLevel()),this.B(w.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,u)}replace(u){const i=this.m;this.info(u),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(u,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:i))}hide(){this.s.$close(this.id)}g(u,i){this.m+=d.$Je.fromString(i).byteLength,(0,M.log)(this.r,u,i),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(u){this.append(u)}}let t=class{constructor(u,i,w,a,l,g){this.i=i,this.j=w,this.k=a,this.l=l,this.m=g,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(C.$nM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.$8m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[i,w]of this.g)w.visible=i===this.h}createOutputChannel(u,i,w){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,l=(0,v.$ag)(i)?i:void 0;if((0,v.$ag)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const $=this.i.environment.extensionLogLevel?.find(([y])=>F.$Vm.equals(w.identifier,y))?.[1];$&&(g=(0,M.$lk)($));const b=a?this.o(u,g,w):this.n(u,l,w);return b.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),a?this.r(u,g??this.m.getLevel(),b):this.q(u,b)}async n(u,i,w){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,l=this.k.extUri.joinPath(a,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(u,l,i,w.identifier.value);return new o($,u,g,this.a,w)}async o(u,i,w){const a=await this.p(w),l=u.replace(/[\\/:\*\?"<>\|]/g,""),g=this.k.extUri.joinPath(a,`${l}.log`),$=`${w.identifier.value}.${l}`,b=this.l.createLogger(g,{id:$,name:u,logLevel:i,extensionId:w.identifier.value});return new n($,u,b,this.a,w)}p(u){let i=this.d.get(u.identifier.value);if(!i){const w=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(w)}catch(a){if((0,f.$kl)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}return w})())}return i}q(u,i){let w=!1;const a=()=>{if(w)throw new Error("Channel has been closed")};return{get name(){return u},append(l){a(),i.then(g=>g.append(l))},appendLine(l){a(),i.then(g=>g.appendLine(l))},clear(){a(),i.then(l=>l.clear())},replace(l){a(),i.then(g=>g.replace(l))},show(l,g){a(),i.then($=>$.show(l,g))},hide(){a(),i.then(l=>l.hide())},dispose(){w=!0,i.then(l=>l.dispose())}}}r(u,i,w){const a=new r.$Tc,l=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},g=a.add(new s.$he);function $(b){i=b,g.fire(b)}return w.then(b=>{a.add(b),b.logLevel!==i&&$(b.logLevel),a.add(b.onDidChangeLogLevel(y=>$(y)))}),{...this.q(u,w),get logLevel(){return i},onDidChangeLogLevel:g.event,trace(b,...y){l(),w.then(h=>h.trace(b,...y))},debug(b,...y){l(),w.then(h=>h.debug(b,...y))},info(b,...y){l(),w.then(h=>h.info(b,...y))},warn(b,...y){l(),w.then(h=>h.warn(b,...y))},error(b,...y){l(),w.then(h=>h.error(b,...y))},dispose(){a.dispose()}}}};e.$Unc=t,e.$Unc=t=Je([We(0,R.$RO),We(1,D.$8O),We(2,m.$Gmc),We(3,N.$jmc),We(4,M.$8j),We(5,M.$7j)],t),e.$Vnc=(0,O.$Ai)("IExtHostOutputService")}),define(ke[119],Se([1,0,3,11]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$kn=(0,C.$Ai)("remoteAgentService"),e.$ln=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let F=1/0;for(let p=0;p<this.maxSampleCount;p++){const m=await R.getRoundTripTime();if(m===void 0)return;F=Math.min(F,m/2),await(0,O.$Bh)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(F):M=this.initial.reduce((p,m)=>p+m,0)/this.initial.length,this.lastMeasurement={initial:M,current:F,average:this.average.reduce((p,m)=>p+m,0)/this.average.length,high:typeof M>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[296],Se([1,0,184,51,29,46,50,6,5,119,23,26,11]),function(he,e,C,O,R,F,M,p,m,D,N,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gb=e.$7gb=e.$6gb=e.$5gb=e.$4gb=e.$3gb=e.$2gb=void 0,e.$2gb=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$3gb=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$4gb=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$5gb=Object.freeze({id:"problems",title:(0,C.localize)(3,null),type:"object",order:101}),e.$6gb={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new m.$he,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const f=new v;R.$ho.add(e.$6gb.ConfigurationMigration,f);let s=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const u of c.added)await this.f(u,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(c=>this.g(c,n?.uri))])}async g(n,t){const c=this.a.inspect(n.key,{resource:t}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,w]of u){const a=c[i];if(!a)continue;const l=[];if(a.value!==void 0){const g=await this.h(n,i,a.value,t,void 0);for(const $ of g??[])l.push([$,[]])}for(const{identifiers:g,value:$}of a.overrides??[])if($!==void 0){const b=await this.h(n,i,$,t,g);for(const y of b??[])l.push([y,g])}l.length&&await Promise.allSettled(l.map(async([[g,$],b])=>this.a.updateValue(g,$.value,{resource:t,overrideIdentifiers:b},w)))}}async h(n,t,c,u,i){const w=l=>{const $=this.a.inspect(l,{resource:u})[t];if($)return i?$.overrides?.find(({identifiers:b})=>(0,S.$$n)(b,i))?.value:$.value},a=await n.migrateFn(c,w);return Array.isArray(a)?a:[[n.key,a]]}};e.$7gb=s,e.$7gb=s=Je([We(0,M.$7i),We(1,F.$Ji)],s);let r=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new d.$Xh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!N.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$ho.as(O.$mo.Configuration).registerConfiguration({...e.$4gb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(4,null)},default:[],markdownDescription:(0,C.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(6,null),scope:2}}})}};e.$8gb=r,e.$8gb=r=Je([We(0,D.$kn)],r)}),define(ke[297],Se([1,0,37,16,19,24,193,296,51,3,29]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$0gb=e.$9gb=void 0,e.$$gb=s,e.$_gb=r,e.$9gb=(0,D.$Ai)("editorResolverService"),e.$0gb="workbench.editorAssociations";const S=N.$ho.as(m.$mo.Configuration),d={...p.$3gb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(d);var v;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(v||(e.RegisteredEditorPriority=v={}));var f;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function s(o){switch(o){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}function r(o,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const u=typeof o=="string"&&o.indexOf(R.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,F.$$g)(n);return C.$tk(typeof o=="string"?o.toLowerCase():o,u.toLowerCase())}}),define(ke[298],Se([1,0,49,16,19,23,24,2,3,214,46,236,119]),function(he,e,C,O,R,F,M,p,m,D,N,S,d){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=void 0,e.$2L=(0,m.$Ai)("pathService");let f=v=class{constructor(r,o,n,t){this.d=r,this.e=o,this.f=n,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??r})()}hasValidBasename(r,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(t=>this.h(r,t,o)):this.h(r,o,n)}h(r,o,n){return r.scheme===O.Schemas.file||r.scheme===O.Schemas.vscodeRemote?(0,C.$xg)(n??(0,M.$$g)(r),o===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(r,o){if(r.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,D.$YL)(o.getWorkspace());if(n)return n;const t=o.getWorkspace().folders[0];if(t)return t.uri.scheme;const c=o.getWorkspace().configuration;return c?c.scheme:O.Schemas.file}userHome(r){return r?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(r=>r===1?R.$fc:R.$gc)}async fileURI(r){let o="";if(await this.a===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const t=r.indexOf("/",2);t===-1?(o=r.substring(2),r="/"):(o=r.substring(2,t),r=r.substring(t)||"/")}return p.URI.from({scheme:O.Schemas.file,authority:o,path:r,query:"",fragment:""})}};e.$3L=f,e.$3L=f=v=Je([We(1,d.$kn),We(2,S.$KL),We(3,N.$Ji)],f)}),define(ke[120],Se([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$uK=e.$tK=void 0;class C{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new C(0,0)}with(M){return new C(0,0)}}e.$tK=C;class O{constructor(M,p,m,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(M,p),this.end=new C(m,D)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new O(0,0,0,0)}with(M){return new O(0,0,0,0)}}e.$uK=O;var R;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(ke[48],Se([1,0,18,37,26,49,13,3,19,14,120,11]),function(he,e,C,O,R,F,M,p,m,D,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TK=e.$RK=e.$KK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$HK=e.$GK=e.$FK=e.$EK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.TextSearchCompleteMessageType=void 0,e.$BK=o,e.$CK=n,e.$DK=t,e.$IK=b,e.$JK=y,e.$LK=k,e.$MK=I,e.$NK=P,e.$OK=V,e.$PK=W,e.$QK=q,e.$SK=U,e.$UK=ce,e.$VK=ve,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.$vK="workbench.view.search",e.$wK="workbench.panel.search",e.$xK="workbench.view.search",e.$yK="search-result",e.$zK="search.exclude";const d="\u27EA ",v=" characters skipped \u27EB",f=(d.length+v.length+5)*2;e.$AK=(0,p.$Ai)("searchService");var s;(function(ge){ge[ge.file=0]="file",ge[ge.text=1]="text",ge[ge.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var r;(function(ge){ge[ge.File=1]="File",ge[ge.Text=2]="Text",ge[ge.aiText=3]="aiText"})(r||(e.QueryType=r={}));function o(ge){return!!ge.preview}function n(ge){return!!ge.resource}function t(ge){return!!ge.message}var c;(function(ge){ge[ge.Normal=0]="Normal",ge[ge.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor(ue){this.resource=ue,this.results=[]}}e.$EK=u;class i{constructor(ue,Ce,re,Ne){this.ranges=Ce,this.webviewIndex=Ne;const Te=Array.isArray(Ce)?Ce:[Ce];if(re&&re.matchLines===1&&w(Te)){ue=(0,M.$6f)(ue,re.matchLines);let T="",X=0,pe=0;const Ie=Math.floor(re.charsPerLine/5),ye=[];for(const $e of Te){const fe=Math.max($e.startColumn-Ie,0),Q=$e.startColumn+re.charsPerLine;if(fe>pe+Ie+f){const x=d+(fe-pe)+v;T+=x+ue.slice(fe,Q),X+=fe-(pe+x.length)}else T+=ue.slice(pe,Q);ye.push(new l(0,$e.startColumn-X,$e.endColumn-X)),pe=Q}this.preview={text:T,matches:Array.isArray(this.ranges)?ye:ye[0]}}else{const T=Array.isArray(Ce)?Ce[0].startLineNumber:Ce.startLineNumber;this.preview={text:ue,matches:(0,C.$1b)(Ce,X=>new a(X.startLineNumber-T,X.startColumn,X.endLineNumber-T,X.endColumn))}}}}e.$FK=i;function w(ge){const ue=ge[0].startLineNumber;for(const Ce of ge)if(Ce.startLineNumber!==ue||Ce.endLineNumber!==ue)return!1;return!0}class a{constructor(ue,Ce,re,Ne){this.startLineNumber=ue,this.startColumn=Ce,this.endLineNumber=re,this.endColumn=Ne}}e.$GK=a;class l extends a{constructor(ue,Ce,re){super(ue,Ce,ue,re)}}e.$HK=l;var g;(function(ge){ge.List="list",ge.Tree="tree"})(g||(e.ViewMode=g={}));var $;(function(ge){ge.Default="default",ge.FileNames="fileNames",ge.Type="type",ge.Modified="modified",ge.CountDescending="countDescending",ge.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function b(ge,ue=!0){const Ce=ge&&ge.files&&ge.files.exclude,re=ue&&ge&&ge.search&&ge.search.exclude;if(!Ce&&!re)return;if(!Ce||!re)return Ce||re;let Ne=Object.create(null);return Ne=R.$0n(Ne,R.$7n(Ce)),Ne=R.$0n(Ne,R.$7n(re),!0),Ne}function y(ge,ue){return ge.excludePattern&&O.$tk(ge.excludePattern,ue)?!1:ge.includePattern||ge.usingSearchPaths?ge.includePattern&&O.$tk(ge.includePattern,ue)?!0:ge.usingSearchPaths?!!ge.folderQueries&&ge.folderQueries.some(Ce=>{const re=Ce.folder.fsPath;if(F.$zg(ue,re)){const Ne=m.$lc(re,ue);return!Ce.includePattern||!!O.$tk(Ce.includePattern,Ne)}else return!1}):!1:!0}var h;(function(ge){ge[ge.unknownEncoding=1]="unknownEncoding",ge[ge.regexParseError=2]="regexParseError",ge[ge.globParseError=3]="globParseError",ge[ge.invalidLiteral=4]="invalidLiteral",ge[ge.rgProcessError=5]="rgProcessError",ge[ge.other=6]="other",ge[ge.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class E extends Error{constructor(ue,Ce){super(ue),this.code=Ce}}e.$KK=E;function k(ge){const ue=ge.message;if((0,D.$4)(ge))return new E(ue,h.canceled);try{const Ce=JSON.parse(ue);return new E(Ce.message,Ce.code)}catch{return new E(ue,h.other)}}function I(ge){const ue={message:ge.message,code:ge.code};return new Error(JSON.stringify(ue))}function P(ge){return ge.type==="error"?!0:ge.type==="success"}function V(ge){return ge.type==="success"}function W(ge){return!!ge.path}function q(ge,ue,Ce=!0){const re=ge.searchPath?ge.searchPath:ge.relativePath;return Ce?(0,M.$3f)(re,ue):O.$tk(ue,re)}class A{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$RK=A;function U(ge,ue){const Ce={...ge||{},...ue||{}};return Object.keys(Ce).filter(re=>{const Ne=Ce[re];return typeof Ne=="boolean"&&Ne})}class K{constructor(ue,Ce){this.c=null,this.a={...ue.excludePattern||{},...Ce.excludePattern||{}},this.b=O.$uk(this.a);let re=ue.includePattern;Ce.includePattern&&(re?re={...re,...Ce.includePattern}:re=Ce.includePattern),re&&(this.c=O.$uk(re))}matchesExcludesSync(ue,Ce,re){return!!(this.b&&this.b(ue,Ce,re))}includedInQuerySync(ue,Ce,re){return!(this.b&&this.b(ue,Ce,re)||this.c&&!this.c(ue,Ce,re))}includedInQuery(ue,Ce,re){const Ne=this.b(ue,Ce,re),Te=()=>this.c?!!this.c(ue,Ce,re):!0;return(0,S.$mh)(Ne)?Ne.then(T=>T?!1:Te()):Te()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$TK=K;function ie(ge){for(const ue in ge)if(typeof ge[ue]!="boolean")return!0;return!1}function ce(ge){if(!ge)return;let ue;return Ce=>(ue||(ue=(ge()||Promise.resolve([])).then(re=>re?Ee(re):{})),ue.then(re=>!!re[Ce]))}function ve(ge){if(!ge)return;let ue;return Ce=>{if(!ue){const re=ge();ue=re?Ee(re):{}}return!!ue[Ce]}}function Ee(ge){const ue={};for(const Ce of ge)ue[Ce]=!0;return ue}}),define(ke[39],Se([1,0,18,11,20,5,6,54,16,129,24,13,2,183,3,12,202,46,47,27,17,8,7,61,48,4,45]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c,u,i,w,a,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$Amc=void 0;function $(V,W,q){return new N.$3g(A=>E(A,q)).isEqual(V,W)}function b(V,W,q){return $(V.uri,W.uri,q)?0:(0,S.$uf)(V.uri.toString(),W.uri.toString())}function y(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:$(V.uri,W.uri,q)?(0,S.$uf)(V.name,W.name):(0,S.$uf)(V.uri.toString(),W.uri.toString())}function h(V,W,q,A){const U=V.slice(0).sort((ie,ce)=>q(ie,ce,A)),K=W.slice(0).sort((ie,ce)=>q(ie,ce,A));return(0,C.$Eb)(U,K,(ie,ce)=>q(ie,ce,A))}function E(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class k extends o.$Ti{static toExtHostWorkspace(W,q,A,U){if(!W)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:ce,configuration:ve,transient:Ee,isUntitled:ge}=W,ue=[],Ce=q;q?ce.forEach((T,X)=>{const pe=d.URI.revive(T.uri),Ie=k.o(A||q,pe,U);Ie?(Ie.name=T.name,Ie.index=T.index,ue.push(Ie)):ue.push({uri:pe,name:T.name,index:X})}):ue.push(...ce.map(({uri:T,name:X,index:pe})=>({uri:d.URI.revive(T),name:X,index:pe}))),ue.sort((T,X)=>T.index<X.index?-1:1);const re=new k(K,ie,ue,!!Ee,ve?d.URI.revive(ve):null,!!ge,T=>E(T,U)),{added:Ne,removed:Te}=h(Ce?Ce.workspaceFolders:[],re.workspaceFolders,b,U);return{workspace:re,added:Ne,removed:Te}}static o(W,q,A){for(let U=0;U<W.folders.length;U++){const K=W.workspaceFolders[U];if($(K.uri,q,A))return K}}constructor(W,q,A,U,K,ie,ce){super(W,A.map(ve=>new o.$Ui(ve)),U,K,ce),this.t=q,this.u=ie,this.q=[],this.s=p.$Gi.forUris(ce),A.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,N.$ah)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let I=class{constructor(W,q,A,U,K){this.c=new F.$he,this.onDidChangeWorkspace=this.c.event,this.g=new F.$he,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new F.$je,this.C=new Map,this.h=U,this.s=A,this.t=K,this.j=new D.$Hm,this.k=new O.$zh,this.o=W.getProxy(l.$nM.MainThreadWorkspace),this.q=W.getProxy(l.$nM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?d.URI.revive(ie.configuration):null,!!ie.isUntitled,ce=>E(ce,A)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?d.URI.from({scheme:m.Schemas.untitled,path:(0,N.$$g)((0,N.$ah)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,A,...U){const K=[];if(Array.isArray(U)&&U.forEach(ge=>{d.URI.isUri(ge.uri)&&!K.some(ue=>$(ue.uri,ge.uri,this.s))&&K.push({uri:ge.uri,name:ge.name||(0,N.$0g)(ge.uri)})}),this.n||[q,A].some(ge=>typeof ge!="number"||ge<0)||A===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+A>ie.length)return!1;const ce=ie.slice(0);ce.splice(q,A,...K.map(ge=>({uri:ge.uri,name:ge.name||(0,N.$0g)(ge.uri),index:void 0})));for(let ge=0;ge<ce.length;ge++){const ue=ce[ge];if(ce.some((Ce,re)=>re!==ge&&$(ue.uri,Ce.uri,this.s)))return!1}ce.forEach((ge,ue)=>ge.index=ue);const{added:ve,removed:Ee}=h(ie,ce,y,this.s);if(ve.length===0&&Ee.length===0)return!1;if(this.o){const ge=W.displayName||W.name;this.o.$updateWorkspaceFolders(ge,q,A,K).then(void 0,ue=>{this.n=void 0;const Ce={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(r.Severity.Error,(0,v.localize)(0,null,ge,ue.toString()),Ce,[])})}return this.y(ce),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let A,U="";if(typeof W=="string"?(A=d.URI.file(W),U=W):typeof W<"u"&&(A=W,U=W.fsPath),!A)return U;const K=this.getWorkspaceFolder(A,!0);if(!K)return U;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,N.$dh)(K.uri,A);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(W){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:A,removed:U}=k.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:U}))}findFiles(W,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ie="",ce=!0;return q===null?ce=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(W,void 0,{exclude:ie,maxResults:A,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(W,q={},A,U=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,W,q,U)}async z(W,q,A,U=R.CancellationToken.None){if(U&&U.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,ie={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ve,folder:Ee}=P(u.GlobPattern.from(W));ce=Ee,ie.includePattern=ve}else{const{includePattern:ve,folder:Ee}=P(u.GlobPattern.from(q));ce=Ee,ie.filePattern=ve}return this.o.$startFileSearch(ce??null,ie,U).then(ve=>Array.isArray(ve)?ve.map(Ee=>d.URI.revive(Ee)):[])}async findTextInFiles(W,q,A,U,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),ce=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ve,folder:Ee}=P(u.GlobPattern.from(q.include)),ge=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,ue={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ce,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ve,excludePattern:ge},Ce=!1;if(this.u[ie]=re=>{if(Ce)return;const Ne=d.URI.revive(re.resource);re.results.forEach(Te=>{const T=(0,g.$0h)(Te);(0,a.$BK)(T)?A({uri:Ne,preview:{text:T.preview.text,matches:(0,C.$1b)(T.preview.matches,X=>new i.$rM(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))},ranges:(0,C.$1b)(T.ranges,X=>new i.$rM(X.startLineNumber,X.startColumn,X.endLineNumber,X.endColumn))}):A({uri:Ne,text:T.text,lineNumber:T.lineNumber})})},K.isCancellationRequested)return{};try{const re=await this.o.$startTextSearch(W,Ee??null,ue,ie,K);return delete this.u[ie],re||{}}catch(re){throw delete this.u[ie],re}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return d.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return d.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const A=this.t.transformOutgoingScheme(W),U=this.A++;return this.o.$registerEditSessionIdentityProvider(U,A),(0,M.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const A=await this.resolveWorkspaceFolder(d.URI.revive(W));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const U=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!U),!U)return;const K=await U.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(W,q,A,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const K=await this.resolveWorkspaceFolder(d.URI.revive(W));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const ce=await ie.provideEditSessionIdentityMatch?.(q,A,U);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(q,A,U)=>{const K=function(ce){q.call(A,ce)};return K.extension=W,this.B.event(K,void 0,U)}}async $onWillCreateEditSessionIdentity(W,q,A){const U=await this.resolveWorkspaceFolder(d.URI.revive(W));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:U},q,async(K,ie)=>{const ce=Date.now();await Promise.resolve(K),Date.now()-ce>A&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const A=this.t.transformOutgoingScheme(W),U=this.A++;return this.o.$registerCanonicalUriProvider(U,A),(0,M.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(W,q,A){const U=this.C.get(W.scheme);if(!U)return;const K=await U.provideCanonicalUri?.(d.URI.revive(W),q,A);if(K)return K}async $provideCanonicalUri(W,q,A){return this.provideCanonicalUri(d.URI.revive(W),{targetScheme:q},A)}};e.$Amc=I,e.$Amc=I=Je([We(0,c.$RO),We(1,t.$8O),We(2,n.$jmc),We(3,s.$7j),We(4,w.$ymc)],I),e.$Bmc=(0,f.$Ai)("IExtHostWorkspace");function P(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=d.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(ke[40],Se([1,0,26,5,39,4,7,203,51,15,11,3,17,12,2]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=e.$Dmc=e.$Cmc=void 0;function s(w,a){if(a){const l=a.split(".");let g=w;for(let $=0;g&&$<l.length;$++)g=g[l[$]];return g}}function r(w){return w instanceof f.URI}function o(w){return w&&w.uri instanceof f.URI&&w.languageId&&typeof w.languageId=="string"}function n(w){return w&&!w.uri&&w.languageId&&typeof w.languageId=="string"}function t(w){return w&&w.uri instanceof f.URI&&(!w.name||typeof w.name=="string")&&(!w.index||typeof w.index=="number")}function c(w){if(r(w))return{resource:w};if(o(w))return{resource:w.uri,overrideIdentifier:w.languageId};if(n(w))return{overrideIdentifier:w.languageId};if(t(w))return{resource:w.uri};if(w===null)return{resource:null}}let u=class{constructor(a,l,g){this.a=a.getProxy(F.$nM.MainThreadConfiguration),this.c=l,this.b=g,this.d=new N.$zh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,l){this.getConfigProvider().then(g=>g.$acceptConfigurationChanged(a,l))}};e.$Cmc=u,e.$Cmc=u=Je([We(0,d.$RO),We(1,R.$Bmc),We(2,v.$7j)],u);class i{constructor(a,l,g,$){this.a=new O.$he,this.b=a,this.f=$,this.c=l,this.e=p.$Fo.parse(g,$),this.d=this.k(g.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,l){const g={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Fo.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(l,g))}getConfiguration(a,l,g){const $=c(l)||{},b=this.g(a?s(this.e.getValue(void 0,$,this.c.workspace),a):this.e.getValue(void 0,$,this.c.workspace));a&&this.h(a,$,g?.identifier);function y(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(E){return typeof s(b,E)<"u"},get:(E,k)=>{this.h(a?`${a}.${E}`:E,$,g?.identifier);let I=s(b,E);if(typeof I>"u")I=k;else{let P;const V=(W,q)=>{if((0,D.$cg)(W)){let A;const U=()=>{P=P||(0,C.$7n)(b),A=A||s(P,q)};return new Proxy(W,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return U(),()=>A;if(P)return A=A||s(P,q),A[ie];const ce=K[ie];return typeof ie=="string"?V(ce,`${q}.${ie}`):ce},set:(K,ie,ce)=>(U(),A&&(A[ie]=ce),!0),deleteProperty:(K,ie)=>(U(),A&&delete A[ie],!0),defineProperty:(K,ie,ce)=>(U(),A&&Object.defineProperty(A,ie,ce),!0)})}return Array.isArray(W)?(0,C.$7n)(W):W};I=V(I,E)}return I},update:(E,k,I,P)=>{E=a?`${a}.${E}`:E;const V=y(I);return k!==void 0?this.b.$updateConfigurationOption(V,E,k,$,P):this.b.$removeConfigurationOption(V,E,$,P)},inspect:E=>{E=a?`${a}.${E}`:E;const k=this.e.inspect(E,$,this.c.workspace);if(k)return{key:E,defaultValue:(0,C.$7n)(k.policy?.value??k.default?.value),globalValue:(0,C.$7n)(k.user?.value??k.application?.value),workspaceValue:(0,C.$7n)(k.workspace?.value),workspaceFolderValue:(0,C.$7n)(k.workspaceFolder?.value),defaultLanguageValue:(0,C.$7n)(k.default?.override),globalLanguageValue:(0,C.$7n)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,C.$7n)(k.workspace?.override),workspaceFolderLanguageValue:(0,C.$7n)(k.workspaceFolder?.override),languageIds:(0,C.$7n)(k.overrideIdentifiers)}}};return typeof b=="object"&&(0,C.$0n)(h,b,!1),Object.freeze(h)}g(a){const l=g=>(0,D.$cg)(g)?new Proxy(g,{get:($,b)=>l($[b]),set:($,b,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:($,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:($,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):g;return l(a)}h(a,l,g){const $=m.$wo.test(a)?4:this.d.get(a),b=g?`[${g.value}] `:"";if($===4){typeof l?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){l?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,l){const g=new p.$Ho(a,l,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:($,b)=>g.affectsConfiguration($,c(b))})}k(a){return a.reduce((l,g)=>(l.set(g[0],g[1]),l),new Map)}}e.$Dmc=i,e.$Emc=(0,S.$Ai)("IExtHostConfiguration")}),define(ke[121],Se([1,0,2,11,5,4,7,39,68,40,20,53,17,27,3,16,23,12,80,241,14]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=e.$8nc=e.$7nc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(u||(u={}));var i;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(i||(i={}));var w;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(w||(w={}));var a;(function(V){function W(U){if(U){const K=U;return K&&!!K.process}else return!1}V.is=W;function q(U){if(U==null)return;const K={process:U.process,args:U.args};return U.options&&(K.options=w.from(U.options)),K}V.from=q;function A(U){if(U!=null)return new M.$_M(U.process,U.args,U.options)}V.to=A})(a||(a={}));var l;(function(V){function W(A){if(A!=null)return A}V.from=W;function q(A){if(A!=null)return A}V.to=q})(l||(l={}));var g;(function(V){function W(U){if(U){const K=U;return K&&(!!K.commandLine||!!K.command)}else return!1}V.is=W;function q(U){if(U==null)return;const K={};return U.commandLine!==void 0?K.commandLine=U.commandLine:(K.command=U.command,K.args=U.args),U.options&&(K.options=l.from(U.options)),K}V.from=q;function A(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new M.$aN(U.commandLine,U.options):new M.$aN(U.command,U.args?U.args:[],U.options)}V.to=A})(g||(g={}));var $;(function(V){function W(U){if(U){const K=U;return K&&K.customExecution==="customExecution"}else return!1}V.is=W;function q(U){return{customExecution:"customExecution"}}V.from=q;function A(U,K){return K.get(U)}V.to=A})($||(e.CustomExecutionDTO=$={}));var b;(function(V){function W(q,A){let U;return q.scope!==void 0&&typeof q.scope!="number"?U=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&A&&A.workspaceFile?U=A.workspaceFile:U=t.$nI),{id:q._id,workspaceFolder:U}}V.from=W})(b||(e.TaskHandleDTO=b={}));var y;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(y||(y={}));var h;(function(V){function W(U,K){if(U==null)return[];const ie=[];for(const ce of U){const ve=q(ce,K);ve&&ie.push(ve)}return ie}V.fromMany=W;function q(U,K){if(U==null)return;let ie;U.execution instanceof M.$_M?ie=a.from(U.execution):U.execution instanceof M.$aN?ie=g.from(U.execution):U.execution&&U.execution instanceof M.$bN&&(ie=$.from(U.execution));const ce=u.from(U.definition);let ve;return U.scope?typeof U.scope=="number"?ve=U.scope:ve=U.scope.uri:ve=M.TaskScope.Workspace,!ce||!ve?void 0:{_id:U._id,definition:ce,name:U.name,source:{extensionId:K.identifier.value,label:U.source,scope:ve},execution:ie,isBackground:U.isBackground,group:y.from(U.group),presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}V.from=q;async function A(U,K,ie){if(U==null)return;let ce;a.is(U.execution)?ce=a.to(U.execution):g.is(U.execution)?ce=g.to(U.execution):$.is(U.execution)&&(ce=$.to(U._id,ie));const ve=u.to(U.definition);let Ee;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Ee=U.source.scope:Ee=await K.resolveWorkspaceFolder(C.URI.revive(U.source.scope)):Ee=M.TaskScope.Workspace),!ve||!Ee)return;const ge=new M.$cN(ve,Ee,U.name,U.source.label,ce,U.problemMatchers);return U.isBackground!==void 0&&(ge.isBackground=U.isBackground),U.group!==void 0&&(ge.group=M.$$M.from(U.group._id),ge.group&&U.group.isDefault&&(ge.group=new M.$$M(ge.group.id,ge.group.label),U.group.isDefault===!0&&(ge.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ge.presentationOptions=i.to(U.presentationOptions)),U._id&&(ge._id=U._id),U.detail&&(ge.detail=U.detail),ge}V.to=A})(h||(e.TaskDTO=h={}));var E;(function(V){function W(A){return A}V.from=W;function q(A){if(A)return Object.assign(Object.create(null),A)}V.to=q})(E||(E={}));class k{#e;constructor(W,q,A){this._id=q,this.a=A,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let I=class{constructor(W,q,A,U,K,ie,ce,ve){this.q=new R.$he,this.r=new R.$he,this.s=new R.$he,this.u=new R.$he,this.a=W.getProxy(F.$nM.MainThreadTask),this.b=A,this.c=U,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,A){if(!A)return new M.$pM(()=>{});const U=this.x();return this.j.set(U,{type:q,provider:A,extension:W}),this.a.$registerTaskProvider(U,q),new M.$pM(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(E.from(W)).then(async q=>{const A=[];for(const U of q){const K=await h.to(U,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,A){const U=this.m.get(W.id);U&&(this.o.set(W.id,U),this.e.attachPtyToTerminal(q,await U.callback(A))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));const U=[],K=(0,O.$sh)(()=>A.provider.provideTasks(N.CancellationToken.None)).then(ie=>this.v(q,U,A,ie));return new Promise(ie=>{K.then(ce=>{Promise.all(U).then(()=>{ie(ce)})})})}async $resolveTask(W,q){const A=this.j.get(W);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const U=await h.to(q,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(U,N.CancellationToken.None);if(!K)return;this.A(K,A);const ie=h.from(K,A.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(W,q,A){const U=await this.a.$createTaskId(W);!A&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,q.execution)),this.m.set(U,q.execution)}async z(W,q){if(typeof W=="string"){const K=this.l.get(W);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(W.id);if(A)return A;let U;return q?U=Promise.resolve(new k(this,W.id,q)):U=h.to(W.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,W.id,K)}),this.l.set(W.id,U),U.then(K=>(this.k.set(W.id,K),K))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const A=this.n.values();let U=A.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=A.next()}};e.$7nc=I,e.$7nc=I=Je([We(0,d.$RO),We(1,v.$8O),We(2,p.$Bmc),We(3,m.$3O),We(4,D.$Emc),We(5,S.$3mc),We(6,o.$7j),We(7,n.$fmc)],I);let P=class extends I{constructor(W,q,A,U,K,ie,ce,ve){super(W,q,A,U,K,ie,ce,ve),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:r.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=h.from(q,W);if(A===void 0)throw new Error("Task is not valid");if($.is(A.execution))await this.y(A,q,!1);else throw new c.$_;const U=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),U}v(W,q,A,U){const K=[];if(U)for(const ie of U){if(this.A(ie,A),!ie.definition||!W[ie.definition.type]){const ve=ie.source?ie.source:"No task source";this.f.warn(`The task [${ve}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=h.from(ie,A.extension);ce&&$.is(ce.execution)?(K.push(ce),q.push(this.y(ce,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(W){if($.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,A){}};e.$8nc=P,e.$8nc=P=Je([We(0,d.$RO),We(1,v.$8O),We(2,p.$Bmc),We(3,m.$3O),We(4,D.$Emc),We(5,S.$3mc),We(6,o.$7j),We(7,n.$fmc)],P),e.$9nc=(0,f.$Ai)("IExtHostTask")}),define(ke[299],Se([1,0,48,30]),function(he,e,C,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3K=void 0,e.$2K=R,e.$4K=F;function R(M){return"cellResults"in M}e.$3K="rawCell#";function F(M,p){let m=-1;const D=[];let N=[];return M.forEach(d=>{d.range.startLineNumber!==m&&N.length>0&&(D.push([...N]),N=[]),N.push(d),m=d.range.endLineNumber}),N.length>0&&D.push([...N]),D.map(d=>{const v=[],f=d[0].range.startLineNumber,s=d[d.length-1].range.endLineNumber;for(let r=f;r<=s;r++)v.push(p.getLineContent(r));return new C.$FK(v.join(`
`)+`
`,d.map(r=>new O.$At(r.range.startLineNumber-1,r.range.startColumn-1,r.range.endLineNumber-1,r.range.endColumn-1)))})}}),define(ke[300],Se([1,0,177,22,5,6,28,13,15,2,38,76,4,35,8,7,34,276,114,26,16,231,299,297]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c,u,i,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(g=>g.apiEditor)}constructor(g,$,b,y,h,E){this.q=b,this.r=y,this.s=h,this.t=E,this.f=new Map,this.g=new M.$Ac,this.h=new Map,this.j=new R.$he,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$he,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$he,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$he,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$dmc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=g.getProxy(d.$nM.MainThreadNotebook),this.c=g.getProxy(d.$nM.MainThreadNotebookDocuments),this.d=g.getProxy(d.$nM.MainThreadNotebookEditors),this.i=$.converter,$.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const I=k.notebookEditor?.notebookUri,P=k.cell.handle,W=this.g.get(I)?.getCell(P);if(W)return W.apiCell}if(k&&k.$mid===14){const I=k.uri,P=this.g.get(I);if(P)return P.apiNotebook}return k}}),a.B($)}getEditorById(g){const $=this.h.get(g);if(!$)throw new Error(`unknown text editor: ${g}. known editors: ${[...this.h.keys()]} `);return $}getIdByEditor(g){for(const[$,b]of this.h)if(b.apiEditor===g)return $}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(g,$){const b=this.g.get(g);if(!b&&!$)throw new Error(`NO notebook document for '${g}'`);return b}static u(g,$){if(!$)return;const b=$.filenamePattern.map(y=>f.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if($.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${$.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:$.displayName,filenamePattern:b,exclusive:$.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,$,b){const y=a.a++,h=typeof b.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(y,b),this.b.$registerNotebookCellStatusBarItemProvider(y,h,$);let E;return h!==void 0&&(E=b.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(h))),new s.$pM(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,h),E?.dispose()})}async createNotebookDocument(g){const $=await this.c.$tryCreateNotebook({viewType:g.viewType,content:g.content&&f.NotebookData.from(g.content)});return D.URI.revive($)}async openNotebookDocument(g){const $=this.g.get(g);if($)return $.apiNotebook;const b=await this.c.$tryOpenNotebook(g),y=this.g.get(D.URI.revive(b));return(0,m.$lg)(y?.apiNotebook)}async showNotebookDocument(g,$){D.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let b;typeof $=="object"?b={position:f.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selections:$.selections&&$.selections.map(f.NotebookRange.from),pinned:typeof $.preview=="boolean"?!$.preview:void 0}:b={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument(g.uri,g.notebookType,b),h=y&&this.h.get(y)?.apiEditor;if(h)return h;throw y?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,$,b,y){const h=this.f.get(g),E=D.URI.revive($),k=this.g.get(E);if(!k||!h)return;const I=k.getCellFromIndex(b);if(!I)return;const P=await h.provideCellStatusBarItems(I.apiCell,y);if(!P)return;const V=new F.$Tc,W=this.p.add([V]),A=(Array.isArray(P)?P:[P]).map(U=>f.NotebookStatusBarItem.from(U,this.i,V));return{cacheId:W,items:A}}$releaseNotebookCellStatusBarItems(g){this.p.delete(g)}registerNotebookSerializer(g,$,b,y,h){if((0,p.$$e)($))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:$,serializer:b,options:y}),this.b.$registerNotebookSerializer(E,{id:g.identifier,location:g.extensionLocation},$,f.NotebookDocumentContentOptions.from(y),a.u(g,h)),(0,F.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(g,$,b){const y=this.x.get(g);if(!y)throw new Error("NO serializer found");const h=await y.serializer.deserializeNotebook($.buffer,b);return new r.$Hw(f.NotebookData.from(h))}async $notebookToData(g,$,b){const y=this.x.get(g);if(!y)throw new Error("NO serializer found");const h=await y.serializer.serializeNotebook(f.NotebookData.to($.value),b);return O.$Je.wrap(h)}async $saveNotebook(g,$,b,y,h){const E=D.URI.revive($),k=this.x.get(g);if(!k)throw new Error("NO serializer found");const I=this.g.get(E);if(!I)throw new Error("Document NOT found");if(I.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new N.$pl((0,C.localize)(0,null,this.z(E)),6);const P={metadata:(0,t.$co)(I.apiNotebook.metadata,U=>!(k.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of I.apiNotebook.getCells()){const K=new s.$SN(U.kind,U.document.getText(),U.document.languageId,U.mime,k.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);K.metadata=(0,t.$co)(U.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),P.cells.push(K)}await this.y(E,y);const V=await k.serializer.serializeNotebook(P,h);await this.s.value.writeFile(E,V);const W=this.s.getFileSystemProviderExtUri(E.scheme),q=await this.s.value.stat(E);return{name:W.basename(E),isFile:(q.type&N.FileType.File)!==0,isDirectory:(q.type&N.FileType.Directory)!==0,isSymbolicLink:(q.type&N.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&N.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((q.permissions??0)&N.FilePermission.Locked),etag:N.$Al({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(g,$,b,y,h){const E=this.x.get(g)?.serializer;if(!E)return{limitHit:!1,results:[]};const k=new M.$Bc;await(async(q,A,U)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const ce={_reason:U._reason,folderQueries:U.folderQueries,includePattern:U.includePattern,excludePattern:U.excludePattern,maxResults:U.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(ce,A,ve=>{ve.forEach(Ee=>{k.has(Ee)||y.some(ue=>K.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(Ce=>(0,w.$_gb)(Ce,Ee)))||k.add(Ee)})}).catch(ve=>{if(ve.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ve})}))))})(b,h,$);const P=new M.$Ac;let V=!1;const W=Array.from(k).map(async q=>{const A=[];try{if(h.isCancellationRequested)return;if($.maxResults&&[...P.values()].reduce((ce,ve)=>ce+ve.cellResults.length,0)>$.maxResults){V=!0;return}const U=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ve=>U.push({input:ve.document.getText(),outputs:ve.outputs.flatMap(Ee=>Ee.items.map(ge=>ge.data.toString()))}));else{const ce=await this.s.value.readFile(q),ve=O.$Je.fromString(ce.toString()),Ee=await E.deserializeNotebook(ve.buffer,h);if(h.isCancellationRequested)return;f.NotebookData.from(Ee).cells.forEach(ue=>U.push({input:ue.source,outputs:ue.outputs.flatMap(Ce=>Ce.items.map(re=>re.valueBytes.toString()))}))}if(h.isCancellationRequested)return;U.forEach((ce,ve)=>{const Ee=$.contentPattern.pattern,ge=new u.$XXb(ce.input,void 0,ce.outputs),ue=ge.findInInputs(Ee),Ce=ge.findInOutputs(Ee),re=Ce.flatMap(Ne=>(0,i.$4K)(Ne.matches,Ne.textBuffer)).map((Ne,Te)=>(Ne.webviewIndex=Te,Ne));if(ue.length>0||Ce.length>0){const Ne={index:ve,contentResults:(0,i.$4K)(ue,ge.inputTextBuffer),webviewResults:re};A.push(Ne)}});const ie={resource:q,cellResults:A};P.set(q,ie);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...P.values()]}}async y(g,$){const b=await this.s.value.stat(g);if(typeof $?.mtime=="number"&&typeof $.etag=="string"&&$.etag!==N.$zl&&typeof b.mtime=="number"&&typeof b.size=="number"&&$.mtime<b.mtime&&$.etag!==N.$Al({mtime:$.mtime,size:b.size}))throw new N.$pl((0,C.localize)(1,null),3,$)}z(g){return g.scheme===c.Schemas.file?g.fsPath:g.toString()}A(g,$,b){if(this.h.has($))throw new Error(`editor with id ALREADY EXSIST: ${$}`);const y=new n.$Anc($,this.d,g,b.visibleRanges.map(f.NotebookRange.to),b.selections.map(f.NotebookRange.to),typeof b.viewColumn=="number"?f.ViewColumn.to(b.viewColumn):void 0);this.h.set($,y)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const b of g.value.removedDocuments){const y=D.URI.revive(b),h=this.g.get(y);h&&(h.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(h.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===y.toString()&&this.h.delete(E.id)}if(g.value.addedDocuments){const b=[];for(const y of g.value.addedDocuments){const h=D.URI.revive(y.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const E=new o.$znc(this.c,this.q,this.r,h,y);b.push(...y.cells.map(k=>o.$ync.asModelAddData(k))),this.g.get(h)?.dispose(),this.g.set(h,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(E.apiNotebook)}}if(g.value.addedEditors)for(const b of g.value.addedEditors){if(this.h.has(b.id))return;const y=D.URI.revive(b.documentUri),h=this.g.get(y);h&&this.A(h,b.id,b)}const $=[];if(g.value.removedEditors)for(const b of g.value.removedEditors){const y=this.h.get(b);y&&(this.h.delete(b),this.k?.id===y.id&&(this.k=void 0),$.push(y))}if(g.value.visibleEditors){this.l=g.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const b=new Set;this.l.forEach(y=>b.add(y.id));for(const y of this.h.values()){const h=b.has(y.id);y._acceptVisibility(h)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this.k=void 0:g.value.newActiveEditor&&(this.h.get(g.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${g.value.newActiveEditor}`),this.k=this.h.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(g){const $=v.$dP.String.with("notebookType","A notebook type"),b=new v.$fP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[$,new v.$dP("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>O.$Je.wrap(h))],new v.$eP("Notebook Data",h=>f.NotebookData.to(h.value))),y=new v.$fP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[$,new v.$dP("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new r.$Hw(f.NotebookData.from(h)))],new v.$eP("Bytes",h=>h.buffer));g.registerApiCommand(b),g.registerApiCommand(y)}}e.$Jnc=a}),define(ke[301],Se([1,0,19,20,44,37,24,66,48]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=void 0;class D{constructor(d,v,f){this.k=d,this.l=v,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=d.filePattern,this.b=d.includePattern&&F.$uk(d.includePattern),this.c=d.maxResults||void 0,this.d=d.exists,this.h=new Set,this.j=d.excludePattern&&F.$uk(d.excludePattern)}cancel(){this.g=!0,this.h.forEach(d=>d.cancel()),this.h=new Set}search(d){const v=this.k.folderQueries||[];return new Promise((f,s)=>{const r=o=>{this.f++,d(o)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),t=C.$nc(n);this.j&&this.j(n,t)||this.v(r,{base:o,basename:t})}),Promise.all(v.map(o=>this.p(o,r))).then(o=>{f({limitHit:this.e,stats:o[0]||void 0})},o=>{s(new Error((0,R.$lj)(o)))})})}async p(d,v){const f=new O.$se,s=this.q(d),r=this.r(),o=new m.$TK(this.k,d),n=!o.hasSiblingExcludeClauses();let t;try{this.h.add(f),t=p.$be.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,f.token),u=t.elapsed(),i=p.$be.create();return this.g&&!this.e||(c&&c.forEach(w=>{const a=C.$gc.relative(d.folder.path,w.path);if(n){const l=C.$nc(w.path);this.v(v,{base:d.folder,relativePath:a,basename:l});return}this.s(r,d.folder,a,v)}),this.g&&!this.e)?null:(this.u(r,o,v),{providerTime:u,postProcessTime:i.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(d){const v=(0,m.$SK)(this.k.includePattern,d.includePattern),f=(0,m.$SK)(this.k.excludePattern,d.excludePattern);return{folder:d.folder,excludes:f,includes:v,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}s({pathToEntries:d},v,f,s){if(f===this.a){const o=C.$nc(this.a);this.v(s,{base:v,relativePath:this.a,basename:o})}function r(o){const n=C.$nc(o),t=C.$mc(o);let c=d[t];c||(c=d[t]=[],r(t)),c.push({base:v,relativePath:o,basename:n})}r(f)}u({rootEntries:d,pathToEntries:v},f,s){const r=this,o=this.a;function n(t){const c=(0,m.$VK)(()=>t.map(u=>u.basename));for(let u=0,i=t.length;u<i;u++){const w=t[u],{relativePath:a,basename:l}=w;if(f.matchesExcludesSync(a,l,o!==l?c:void 0))continue;const g=v[a];if(g)n(g);else{if(a===o)continue;r.v(s,w)}if(r.e)break}}n(d)}v(d,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||d(v))}}class N{constructor(){this.b=new Map}static{this.a=512}fileSearch(d,v,f,s){const r=this.c(d.cacheKey),o=new D(d,v,r&&r.token);let n=0;const t=c=>{n+=c.length,f(c.map(u=>this.d(u)))};return this.e(o,N.a,t,s).then(c=>({limitHit:c.limitHit,stats:c.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}:void 0,messages:[]}))}clearCache(d){this.c(d)?.cancel()}c(d){if(d)return this.b.has(d)||this.b.set(d,new O.$se),this.b.get(d)}d(d){return d.relativePath?{resource:M.$bh(d.base,d.relativePath)}:{resource:d.base}}e(d,v,f,s){const r=s.onCancellationRequested(()=>{d.cancel()}),o=t=>{t&&(n.push(t),v>0&&n.length>=v&&(f(n),n=[]))};let n=[];return d.search(o).then(t=>(n.length&&f(n),r.dispose(),t),t=>(n.length&&f(n),r.dispose(),Promise.reject(t)))}}e.$Bnc=N}),define(ke[302],Se([1,0,18,271,37,97,28,16,19,24,13,15,2,96,195,50,12,46,109,298,48]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=void 0,e.$5L=y;let u=class{constructor(E,k,I,P,V){this.a=E,this.b=k,this.c=I,this.d=P,this.e=V}text(E,k,I={}){E=this.f(E,I);const P=this.a.getValue(),V=k&&k.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(k?.map(o.$Vi),I),type:2,contentPattern:E,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:P.search.usePCRE2||V||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(E,k){const I=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const P={...E,wordSeparators:I.editor.wordSeparators};return this.j(E,k)&&(P.isCaseSensitive=!0),this.k(E)&&(P.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),P}file(E,k={}){return{...this.h(E,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(E,k){return E?(E=Array.isArray(E)?E.map(g):g(E),k?this.parseSearchPaths(E):{pattern:w(...Array.isArray(E)?E:[E])}):{}}h(E=[],k={}){const I=this.g(k.includePattern,k.expandPatterns),P=this.g(k.excludePattern,k.expandPatterns),V=E.length>1,W=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(U=>this.q(U,k,P)):E.map(U=>this.r(U,k,P,V))).filter(U=>!!U),q={_reason:k._reason,folderQueries:W,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:P.pattern,includePattern:I.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const U=C.$Hb(this.c.groups.flatMap(ce=>ce.editors.map(ve=>ve.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const K=U.filter(ce=>(0,c.$JK)(q,ce.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const A=k.extraFileResources&&k.extraFileResources.filter(U=>(0,c.$JK)(q,U.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(E){const k=[],I=new M.$Ac,P={};let V=!1;return E.forEach(W=>{if(W.scheme===p.Schemas.walkThrough)return;if((0,D.$fh)(W)){const A=this.b.getWorkspaceFolder(W)?.uri??W.with({path:m.$mc(W.fsPath)});let U=I.get(A);U||(V=!0,U={folder:A,includePattern:{}},k.push(U),I.set(A,U));const K=m.$lc(A.fsPath,W.fsPath);(0,S.$lg)(U.includePattern)[K.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,P[W.fsPath]=!0)}),{folderQueries:k,includePattern:P,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(E,k){if(k.isSmartCase){if(E.isRegExp){if(N.$4f(E.pattern,!0))return!0}else if(N.$4f(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,v.$WC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const k=ie=>m.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(E)?E:a(E)).map(ie=>{const ce=this.e.resolvedUserHome;return ce?(0,F.$Mw)(ie,ce.scheme===p.Schemas.file?ce.fsPath:ce.path):ie}),V=O.$K(P,ie=>k(ie)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(ie=>N.$jf(ie,"/")).map(ie=>N.$jf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),l(ie))),q={},A=this.m(V.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const U=W.flat(),K=w(...U);return K&&(q.pattern=K),q}l(E,k){return k.disregardExcludeSettings?void 0:(0,c.$IK)(E,!k.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const k=E.flatMap(P=>{let{pathPortion:V,globPortion:W}=i(P);return W&&(W=$(W)),this.n(V).flatMap(A=>this.o(A,W))}),I=new Map;return k.forEach(P=>{const V=P.searchPath.toString(),W=I.get(V);W?P.pattern&&(W.pattern=W.pattern||{},W.pattern[P.pattern]=!0):I.set(V,{searchPath:P.searchPath,pattern:P.pattern?w(P.pattern):void 0})}),Array.from(I.values())}n(E){if(m.$ic(E)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==p.Schemas.file?[{searchPath:k[0].uri.with({path:E})}]:[{searchPath:d.URI.file(m.$hc(E))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(E=g(E),E.startsWith("../")||E===".."){const P=m.$gc.resolve(k.path,E);return[{searchPath:k.with({path:P})}]}const I=$(E);return[{searchPath:k,pattern:I}]}else{if(E==="./"||E===".\\")return[];{const k=E.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(V=>{const W=k.match(new RegExp(`^${N.$df(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(S.$ig);if(P.length)return P.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&$(W)}});{const V=E.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:E,q=f.localize(0,null,W);throw new Error(q)}}}}o(E,k){const I=E.pattern&&k?`${E.pattern}/${k}`:E.pattern||k,P=[{searchPath:E.searchPath,pattern:I}];return I&&!I.endsWith("**")&&P.push({searchPath:E.searchPath,pattern:I+"/**"}),P}q(E,k,I){const P=this.r((0,o.$Vi)(E.searchPath),k,I,!1);return P?{...P,includePattern:E.pattern}:null}r(E,k,I,P){let V;const W=d.URI.isUri(E)?E:E.uri;if(I.searchPaths){const ie=I.searchPaths.filter(ce=>(0,D.$7g)(ce.searchPath,W))[0];if(ie&&!ie.pattern)return null;ie&&(V=ie.pattern)}const q=this.a.getValue({resource:W}),U={...this.l(q,k)||{},...V||{}},K=d.URI.isUri(E)?(0,D.$$g)(E):E.name;return{folder:W,folderName:P?K:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!q.search.followSymlinks}}};e.$4L=u,e.$4L=u=Je([We(0,s.$7i),We(1,o.$Ji),We(2,n.$5D),We(3,r.$7j),We(4,t.$2L)],u);function i(h){const E=h.match(/[\*\{\}\(\)\[\]\?]/);if(E){const k=E.index,I=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(I){let P=h.substr(0,I.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:h.substr((I.index||0)+1)}}}return{pathPortion:h}}function w(...h){return h.length?h.reduce((E,k)=>(E[k]=!0,E),Object.create(null)):void 0}function a(h){return R.$sk(h,",").map(E=>E.trim()).filter(E=>!!E.length)}function l(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function g(h){return h.replace(/\\/g,"/")}function $(h){return g(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(h){return h.replace(/([?*[\]])/g,"[$1]")}function y(h,E){h=C.$Mb(h,P=>P.toString());const k=[],I=E.getWorkspace();return h&&h.forEach(P=>{let V;if(E.getWorkbenchState()===2)V=(0,D.$dh)(I.folders[0].uri,P),V&&V!=="."&&(V="./"+V);else{const W=E.getWorkspaceFolder(P);if(W){const q=W.name;if(I.folders.filter(U=>U.name===q).length===1){const U=(0,D.$dh)(W.uri,P);U===""?V=`./${W.name}`:V=`./${W.name}/${U}`}else V=P.fsPath}}V&&k.push(b(V))}),k}}),define(ke[303],Se([1,0,24,2,20,14,3,302,48,46,11]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9wb=d,e.$0wb=s;const S=7e3;function d(r,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const t=[],c=[];for(const g of n)if(/^workspaceContains:/.test(g)){const $=g.substr(18);$.indexOf("*")>=0||$.indexOf("?")>=0||r.forceUsingSearch?c.push($):t.push($)}if(t.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:u,resolve:i}=(0,N.$th)(),w=g=>i({activationEvent:g}),a=Promise.all(t.map(g=>v(r,g,w))).then(()=>{}),l=f(r,o.identifier,c,w);return Promise.all([a,l]).then(()=>{i(void 0)}),u}async function v(r,o,n){for(const t of r.folders)if(await r.exists(C.$bh(O.URI.revive(t),o))){n(`workspaceContains:${o}`);return}}async function f(r,o,n,t){if(n.length===0)return Promise.resolve(void 0);const c=new R.$se,u=r.checkExists(r.folders,n,c.token),i=setTimeout(async()=>{c.cancel(),r.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},S);let w=!1;try{w=await u}catch(a){F.$4(a)||F.$1(a)}c.dispose(),clearTimeout(i),w&&t(`workspaceContains:${n.join(",")}`)}function s(r,o,n,t){const c=r.get(M.$zi),u=r.get(m.$AK),w=c.createInstance(p.$4L).file(o.map(a=>(0,D.$Vi)(O.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return u.fileSearch(w,t).then(a=>!!a.limitHit,a=>F.$4(a)?!1:Promise.reject(a))}}),define(ke[41],Se([1,0,173,19,60,24,11,6,54,2,12,4,40,237,84,39,25,110,14,21,22,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,23,82]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c,u,i,w,a,l,g,$,b,y,h,E,k,I,P,V,W,q,A,U,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=e.$gnc=e.$fnc=e.$enc=e.$dnc=void 0,e.$dnc=(0,a.$Ai)("IHostUtils");let ce=ie=class extends p.$Uc{constructor(T,X,pe,Ie,ye,$e,fe,Q,x,le,ae,Fe,de){super(),this.Y=Fe,this.Z=de,this.a=this.B(new k.$he),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=X,this.g=pe,this.f=fe,this.j=Ie,this.m=ye,this.s=$e,this.t=x,this.u=le,this.w=ae,this.y=this.g.getProxy(S.$nM.MainThreadWorkspace),this.z=this.g.getProxy(S.$nM.MainThreadTelemetry),this.C=this.g.getProxy(S.$nM.MainThreadExtensionService),this.D=new M.$zh,this.F=new M.$zh,this.G=new M.$zh,this.H=new M.$zh,this.I=new Ne(this.f.extensions.activationEvents),this.L=new o.$Qac(this.I,this.f.extensions.allExtensions);const Pe=new t.$Wm(this.f.extensions.myExtensions);this.J=new o.$Qac(this.I,Ce(this.L,Pe)),U.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ge(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ge(this.J)}`)),this.M=new f.$Ymc(this.g,this.s),this.N=new P.$9mc(this.g),this.O=Q,this.h=T.createChild(new b.$yi([f.$Zmc,this.M],[P.$0mc,this.N])),this.P=this.B(new v.$Xmc(this.J,this.L,{onExtensionActivationError:(Ae,je,j)=>{this.C.$onExtensionActivationError(Ae,n.$3(je),j)},actualActivateExtension:async(Ae,je)=>{if(o.$Qac.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,je),new v.$Wmc;const j=this.J.getExtensionDescription(Ae);return this.fb(j,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(T){n.$1(T)}}async $(){this.O.onWillDeactivateAll();let T=[];try{T=this.J.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this.eb(ye))}catch{}await Promise.all(T)}terminate(T,X=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${T}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const pe=this.$();Promise.race([(0,M.$Bh)(5e3),pe]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.s.info(`Extension host exiting with code ${X}`),this.s.flush(),this.s.dispose(),this.c.exit(X)})}isActivated(T){return this.G.isOpen()?this.P.isActivated(T):!1}async getExtension(T){const X=await this.C.$getExtension(T);return X&&{...X,identifier:new t.$Vm(X.identifier.value),extensionLocation:D.URI.revive(X.extensionLocation)}}ab(T,X){return this.P.activateByEvent(T,X)}bb(T,X){return this.P.activateById(T,X)}activateByIdWithErrors(T,X){return this.bb(T,X).then(()=>{const pe=this.P.getActivatedExtension(T);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(T=>this.J)}getExtensionExports(T){if(this.G.isOpen())return this.P.getActivatedExtension(T).exports;try{return this.P.getActivatedExtension(T).exports}catch{return null}}async cb(T){if(T.scheme===W.Schemas.file&&this.c.fsRealpath){const X=T.fsPath;this.R.has(X)||this.R.set(X,this.c.fsRealpath(X));const pe=await this.R.get(X);return D.URI.file(pe)}return T}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(T=>new re(T))),this.Q}async db(T){const X=m.$Gi.forUris(pe=>F.$5g.ignorePathCasing(pe));return await Promise.all(T.map(async pe=>{if(this.wb(pe)){const Ie=await this.cb(pe.extensionLocation);X.set(Ie,pe)}})),X}eb(T){let X=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(T))return X;const pe=this.P.getActivatedExtension(T);if(!pe)return X;try{typeof pe.module.deactivate=="function"&&(X=Promise.resolve(pe.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${T.value}':`),this.s.error(Ie)}try{(0,p.$Pc)(pe.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${T.value}':`),this.s.error(Ie)}return X}async fb(T,X){return this.f.remote.isRemote?this.C.$onWillActivateExtension(T.identifier):await this.C.$onWillActivateExtension(T.identifier),this.hb(T,X).then(pe=>{const Ie=pe.activationTimes;return this.C.$onDidActivateExtension(T.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,X),this.gb(T,X,"success",Ie),pe},pe=>{throw this.gb(T,X,"failure"),pe})}gb(T,X,pe,Ie){const ye=Ee(T,X);this.z.$publicLog2("extensionActivationTimes",{...ye,...Ie||{},outcome:pe})}hb(T,X){const pe=Ee(T,X);this.z.$publicLog2("activatePlugin",pe);const Ie=this.wb(T);if(!Ie)return Promise.resolve(new v.$Vmc(v.$Smc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${T.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${T.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.s.flush();const ye=new v.$Tmc(X.startup);return Promise.all([this.xb(T,(0,F.$bh)(T.extensionLocation,Ie),ye),this.ib(T)]).then($e=>(R.mark(`code/extHost/willActivateExtension/${T.identifier.value}`),ie.jb(this.s,T.identifier,$e[0],$e[1],ye))).then($e=>(R.mark(`code/extHost/didActivateExtension/${T.identifier.value}`),$e))}ib(T){const X=this.Z.createLanguageModelAccessInformation(T),pe=new u.$2mc(T,this.M),Ie=new u.$1mc(T.identifier.value,!1,this.M),ye=new V.$$mc(T,this.N),$e=T.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,fe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${T.identifier.value}`),Promise.all([pe.whenReady,Ie.whenReady,this.O.whenReady]).then(()=>{const Q=this;let x,le;const ae=(0,r.$NG)(T,"ipc")?this.f.messagePorts?.get(t.$Vm.toKey(T.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:Ie,secrets:ye,subscriptions:[],get languageModelAccessInformation(){return X},get extensionUri(){return T.extensionLocation},get extensionPath(){return T.extensionLocation.fsPath},asAbsolutePath(Fe){return O.$jc(T.extensionLocation.fsPath,Fe)},get storagePath(){return Q.O.workspaceValue(T)?.fsPath},get globalStoragePath(){return Q.O.globalValue(T).fsPath},get logPath(){return O.$jc(Q.f.logsLocation.fsPath,T.identifier.value)},get logUri(){return D.URI.joinPath(Q.f.logsLocation,T.identifier.value)},get storageUri(){return Q.O.workspaceValue(T)},get globalStorageUri(){return Q.O.globalValue(T)},get extensionMode(){return $e},get extension(){return x===void 0&&(x=new ue(Q,T.identifier,T,fe,!1)),x},get extensionRuntime(){return(0,r.$OG)(T,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(T)},get messagePassingProtocol(){if(!le){if(!ae)return;const Fe=k.Event.buffer(k.Event.fromDOMEventEmitter(ae,"message",de=>de.data));ae.start(),le={onDidReceiveMessage:Fe,postMessage:ae.postMessage.bind(ae)}}return le}})})}static jb(T,X,pe,Ie,ye){return pe=pe||{activate:void 0,deactivate:void 0},this.kb(T,X,pe,Ie,ye).then($e=>new v.$Umc(!1,null,ye.build(),pe,$e,Ie.subscriptions))}static kb(T,X,pe,Ie,ye){if(typeof pe.activate=="function")try{ye.activateCallStart(),T.trace(`ExtensionService#_callActivateOptional ${X.value}`);const $e=typeof global=="object"?global:self,fe=pe.activate.apply($e,[Ie]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(fe).then(Q=>(ye.activateResolveStop(),Q))}catch($e){return Promise.reject($e)}else return Promise.resolve(pe)}lb(T,X){this.bb(T.identifier,{startup:!1,extensionId:T.identifier,activationEvent:X}).then(void 0,pe=>{this.s.error(pe)})}mb(T,X=0){const Ie=Date.now();(0,U.$B)(()=>{for(let ye=X;ye<T.length;ye+=1){const $e=T[ye];for(const fe of $e.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Ie>50){this.mb(T,ye);break}else this.lb($e,fe)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(T=>{const X=T.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.J.getAllExtensionDescriptions();if(X)this.mb(pe);else for(const Ie of pe)if(Ie.activationEvents)for(const ye of Ie.activationEvents)ye==="onStartupFinished"&&this.lb(Ie,ye)})}ob(){const T=this.ab("*",!0).then(void 0,$e=>{this.s.error($e)});this.B(this.j.onDidChangeWorkspace($e=>this.pb($e.added)));const X=this.j.workspace?this.j.workspace.folders:[],pe=this.pb(X),Ie=this.rb(),ye=Promise.all([Ie,T,pe]).then(()=>{});return Promise.race([ye,(0,M.$Bh)(1e4)]).then(()=>{this.nb()}),ye}pb(T){return T.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(X=>this.qb(T,X))).then(()=>{})}async qb(T,X){if(this.isActivated(X.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:T.map($e=>$e.uri),forceUsingSearch:pe||!this.c.fsExists,exists:$e=>this.c.fsExists($e.fsPath),checkExists:($e,fe,Q)=>this.y.$checkExists($e,fe,Q)},ye=await(0,I.$9wb)(Ie,X);if(ye)return this.bb(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:ye.activationEvent}).then(void 0,$e=>this.s.error($e))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(T){throw console.error(T),T}}async sb(){const{extensionDevelopmentLocationURI:T,extensionTestsLocationURI:X}=this.f.environment;if(!T||!X)throw new Error(C.localize(0,null));const pe=await this.xb(null,X,new v.$Tmc(!1));if(!pe||typeof pe.run!="function")throw new Error(C.localize(1,null,X.toString()));return new Promise((Ie,ye)=>{const $e=(x,le)=>{x?(U.$t&&this.s.error("Test runner called back with error",x),ye(x)):(U.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof le=="number"&&le>0?1:0))},fe=(0,F.$2g)(X),Q=pe.run(fe,$e);Q&&Q.then&&Q.then(()=>{U.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(x=>{U.$t&&this.s.error("Test runner finished with error",x),ye(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$Bh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(T,X){return this.S[T]=X,(0,p.$Sc)(()=>{delete this.S[T]})}async getRemoteExecServer(T){const{resolver:X}=await this.ub(T);return X?.resolveExecServer?.(T,{resolveAttempt:0})}async ub(T){const X=T.indexOf("+");if(X===-1)throw new i.$vM("Not an authority that can be resolved!",w.RemoteAuthorityResolverErrorCode.InvalidAuthority);const pe=T.substr(0,X);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.S[pe]}}async $resolveAuthority(T,X){const pe=A.$be.create(!1),Ie=()=>`[resolveAuthority(${(0,w.$Pl)(T)},${X})][${pe.elapsed()}ms] `,ye=z=>this.s.info(`${Ie()}${z}`),$e=z=>this.s.warn(`${Ie()}${z}`),fe=(z,G=void 0)=>this.s.error(`${Ie()}${z}`,G),Q=z=>{if(z instanceof i.$vM)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},x=async z=>{ye(`activating resolver for ${z}...`);const{resolver:G,authorityPrefix:H}=await this.ub(z);if(!G)throw fe(`no resolver for ${H}`),new i.$vM(`No remote extension installed to resolve ${H}.`,w.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:G,authorityPrefix:H,remoteAuthority:z}},le=T.split(/@|%40/g).reverse();ye(`activating remote resolvers ${le.join(" -> ")}`);let ae;try{ae=await Promise.all(le.map(x)).catch(async z=>{if(!(z instanceof i.$vM)||z._code!==w.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return $e(`resolving nested authorities failed: ${z.message}`),[await x(T)]})}catch(z){return Q(z)}const Fe=new M.$Lh;Fe.cancelAndSet(()=>ye("waiting..."),1e3);let de,Pe;for(const[z,{authorityPrefix:G,resolver:H,remoteAuthority:te}]of ae.entries())try{if(z===ae.length-1)ye("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${G}`),de=await H.resolve(te,{resolveAttempt:X,execServer:Pe}),R.mark(`code/extHost/didResolveAuthorityOK/${G}`),ye("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,i.$uM.isManagedResolvedAuthority(de)?de:void 0));else{if(ye(`invoking resolveExecServer() for ${te}`),R.mark(`code/extHost/willResolveExecServer/${G}`),Pe=await H.resolveExecServer?.(te,{resolveAttempt:X,execServer:Pe}),!Pe)throw new i.$vM(`Exec server was not available for ${te}`,w.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${G}`)}}catch(ne){return R.mark(`code/extHost/didResolveAuthorityError/${G}`),fe("returned an error",ne),Fe.dispose(),Q(ne)}Fe.dispose();const Ae={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};ye(`returned ${i.$uM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let j;if(i.$uM.isManagedResolvedAuthority(de)){const z=X;this.Y.setFactory(z,de.makeConnection),j={authority:T,connectTo:new w.$Ml(z),connectionToken:de.connectionToken}}else j={authority:T,connectTo:new w.$Nl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:j,options:je,tunnelInformation:Ae}}}async $getCanonicalURI(T,X){this.s.info(`$getCanonicalURI invoked for authority (${(0,w.$Pl)(T)})`);const{resolver:pe}=await this.ub(T);if(!pe)return null;const Ie=D.URI.revive(X);if(typeof pe.getCanonicalURI>"u")return Ie;const ye=await(0,M.$sh)(()=>pe.getCanonicalURI(Ie));return ye||Ie}async $startExtensionHost(T){T.toAdd.forEach($e=>$e.extensionLocation=D.URI.revive($e.extensionLocation));const{globalRegistry:X,myExtensions:pe}=ve(this.I,this.L,this.J,T),Ie=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(X.getAllExtensionDescriptions()),this.J.set(pe),U.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ge(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ge(this.J)}`)),this.tb()}$activateByEvent(T,X){return X===1?this.D.wait().then(pe=>this.ab(T,!1)):this.G.wait().then(pe=>this.ab(T,!1))}async $activate(T,X){return await this.G.wait(),this.J.getExtensionDescription(T)?(await this.bb(T,X),!0):!1}async $deltaExtensions(T){T.toAdd.forEach($e=>$e.extensionLocation=D.URI.revive($e.extensionLocation));const{globalRegistry:X,myExtensions:pe}=ve(this.I,this.L,this.J,T),Ie=await this.db(pe);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(X.getAllExtensionDescriptions()),this.J.set(pe),U.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ge(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ge(this.J)}`)),Promise.resolve(void 0)}async $test_latency(T){return T}async $test_up(T){return T.byteLength}async $test_down(T){const X=c.$Je.alloc(T),pe=Math.random()%256;for(let Ie=0;Ie<T;Ie++)X.writeUInt8(pe,Ie);return X}async $updateRemoteConnectionData(T){this.X=T,this.a.fire()}};e.$enc=ce,e.$enc=ce=ie=Je([We(0,a.$zi),We(1,e.$dnc),We(2,$.$RO),We(3,s.$Bmc),We(4,d.$Emc),We(5,N.$7j),We(6,l.$8O),We(7,g.$Hmc),We(8,y.$_Db),We(9,h.$3mc),We(10,q.$anc),We(11,K.$bnc),We(12,E.$7mc)],ce);function ve(Te,T,X,pe){Te.addActivationEvents(pe.addActivationEvents);const Ie=new o.$Qac(Te,T.getAllExtensionDescriptions());Ie.deltaExtensions(pe.toAdd,pe.toRemove);const ye=new t.$Wm(X.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of pe.myToRemove)ye.delete(fe);for(const fe of pe.myToAdd)ye.add(fe);const $e=Ce(Ie,ye);return{globalRegistry:Ie,myExtensions:$e}}function Ee(Te,T){return{id:Te.identifier.value,name:Te.name,extensionVersion:Te.version,publisherDisplayName:Te.publisher,activationEvents:Te.activationEvents?Te.activationEvents.join(","):null,isBuiltin:Te.isBuiltin,reason:T.activationEvent,reasonId:T.extensionId.value}}function ge(Te){return Te.getAllExtensionDescriptions().map(T=>T.identifier.value).join(",")}e.$fnc=(0,a.$Ai)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(T,X,pe,Ie,ye){this.#e=T,this.#t=X,this.#i=pe.identifier,this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=O.$hc((0,F.$2g)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=Ie,this.isFromDifferentExtensionHost=ye}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$gnc=ue;function Ce(Te,T){return Te.getAllExtensionDescriptions().filter(X=>T.has(X.identifier))}class re{constructor(T){this.a=T}setSearchTree(T){this.a=T}findSubstr(T){return this.a.findSubstr(T)}forEach(T){return this.a.forEach(T)}}e.$hnc=re;class Ne{constructor(T){this.a=new t.$Xm,this.addActivationEvents(T)}readActivationEvents(T){return this.a.get(T.identifier)??[]}addActivationEvents(T){for(const X of Object.keys(T))this.a.set(X,T[X])}}}),define(ke[304],Se([1,0,60,2,4,40,25,21,17,27,3,41,12,13]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;let s=class{constructor(c,u,i,w,a,l,g){this.c=c,this.d=u,this.e=i,this.f=w,this.g=a,this.h=l,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new o(this.c,u,this.d,c,this.i)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,u,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this.a.set(u,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(u=>c.alternativeModuleName(u))}};e.$qoc=s,e.$qoc=s=Je([We(2,N.$zi),We(3,F.$Emc),We(4,S.$fnc),We(5,D.$8O),We(6,d.$7j)],s);let r=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&f.a.size){const u=(0,v.$df)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",w=`@${i}+\\/${i}+|${i}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${a}\\/)(${w})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const u=this.b.exec(this.c(c));if(!u)return;const[,i,w,a]=u,l=f.a.get(w);if(l!==void 0)return console.warn(`${w} as been renamed to ${l}, please update your imports`),i+l+a}c(c){return c.replace(/\\/g,"/")}};r=f=Je([We(0,D.$8O)],r);class o{constructor(c,u,i,w,a){this.c=c,this.d=u,this.e=i,this.f=w,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Xm}load(c,u){const i=this.d.findSubstr(u);if(i){let w=this.a.get(i.identifier);return w||(w=this.c(i,this.e,this.f),this.a.set(i.identifier,w)),w}if(!this.b){let w="";this.d.forEach((a,l)=>w+=`	${l} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${w}`),this.b=this.c(M.$IG,this.e,this.f)}return this.b}}let n=class{constructor(c,u,i){this.e=c,this.f=u,this.nodeModuleName=["open","opn"],this.d=i.getProxy(R.$nM.MainThreadTelemetry);const w=i.getProxy(R.$nM.MainThreadWindow);this.c=(a,l)=>{const g=O.URI.parse(a);return l?this.g(a,l):g.scheme==="http"||g.scheme==="https"?w.$openUri(g,a,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?w.$openUri(g,a,{}):this.g(a,l)}}load(c,u,i){const w=this.e.findSubstr(u);return w&&(this.a=w.identifier.value,this.h()),this.b=i(c),this.c}g(c,u){return this.i(),this.b(c,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,m.$RO)],n)}),define(ke[122],Se([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=e.$inc=void 0,e.$inc=(0,M.$Ai)("IExtHostVariableResolverProvider");class f extends d.$VP{constructor(o,n,t,c,u,i,w){function a(){if(t){const l=t.activeEditor();if(l)return l.document.uri;const g=c.tabGroups.all.find($=>$.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof N.$bO||g.input instanceof N.$gO)return g.input.modified;if(g.input instanceof N.$aO||g.input instanceof N.$fO||g.input instanceof N.$dO)return g.input.uri}}}super({getFolderUri:l=>{const g=i.folders.filter($=>$.name===l);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,g)=>u.getConfiguration(void 0,l).get(g),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=a();if(l)return R.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=a();if(l){const g=n.getWorkspaceFolder(l);if(g)return R.$hc(g.uri.fsPath)}}},getSelectedText:()=>{if(t){const l=t.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(t){const l=t.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,w?Promise.resolve(w):void 0,Promise.resolve(F.env))}}let s=class extends O.$Uc{constructor(o,n,t,c,u){super(),this.b=o,this.c=n,this.g=t,this.h=c,this.j=u,this.a=new C.$V(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,i,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$jnc=s,e.$jnc=s=Je([We(0,D.$fnc),We(1,S.$Bmc),We(2,p.$3O),We(3,v.$Emc),We(4,m.$Qmc)],s)}),define(ke[123],Se([1,0,11,5,2,21,3,4,67,41,17,7,39,226,228,40,122,6,36,35,8,18]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$onc=e.$nnc=e.$mnc=e.$lnc=e.$knc=void 0,e.$knc=(0,M.$Ai)("IExtHostDebugService");let i=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(y,h,E,k,I,P,V){this.N=h,this.O=E,this.P=k,this.Q=I,this.R=P,this.S=V,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$he,this.o=new O.$he,this.q=new O.$he,this.w=new O.$he,this.l=y.getProxy(p.$nM.MainThreadDebugService),this.A=new O.$he,this.C=new O.$he,this.y=new a(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(q=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(y,h){const E=this.W(h);if(!E)return;const k=await this.H.get(y)?.getTreeItem?.(E);return k?this.U(y,k):void 0}registerDebugVisualizationTree(y,h,E){const k=F.$Vm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.H.set(I,E),this.l.$registerDebugVisualizerTree(I,!!E.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(I),this.H.delete(h)})}async $getVisualizerTreeItemChildren(y,h){const E=this.J.get(h)?.item;return E?(await this.H.get(y)?.getChildren?.(E))?.map(I=>this.U(y,I))||[]:[]}async $editVisualizerTreeItem(y,h){const E=this.J.get(y);if(!E)return;const k=await this.H.get(E.provider)?.editItem?.(E.item,h);return this.U(E.provider,k||E.item)}$disposeVisualizedTree(y){const h=this.J.get(y);if(!h)return;const E=[h.children];for(const k of E)if(k)for(const I of k)E.push(this.J.get(I)?.children),this.J.delete(I)}U(y,h){let E=this.I.get(h);return E||(E=this.F++,this.I.set(h,E),this.J.set(E,{provider:y,item:h})),c.DebugTreeItem.from(h,E)}asDebugSourceUri(y,h){const E=y;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let k=`debug:${encodeURIComponent(E.path||"")}`,I="?";return h&&(k+=`${I}session=${encodeURIComponent(h.id)}`,I="&"),k+=`${I}ref=${E.sourceReference}`,R.URI.parse(k)}else{if(E.path)return R.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(y){const h=[];for(const E of y.getAllExtensionDescriptions())if(E.contributes){const k=E.contributes.debuggers;if(k&&k.length>0)for(const I of k)(0,f.$DH)(I)&&h.push(I.type)}this.l.$registerDebugTypes(h)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const y=[];return this.z.forEach(h=>y.push(h)),y}async $resolveDebugVisualizer(y,h){const E=this.L.get(y);if(!E)throw new Error(`No debug visualizer found with id '${y}'`);let{v:k,provider:I,extensionId:P}=E;if(k.visualization||(k=await I.resolveDebugVisualization?.(k,h)||k,E.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${I}'`);return this.kb(P,k.visualization)}async $executeDebugVisualizerCommand(y){const h=this.L.get(y);if(!h)throw new Error(`No debug visualizer found with id '${y}'`);const E=h.v.visualization;E&&"command"in E&&this.S.executeCommand(E.command,...E.arguments||[])}W(y){const h=this.m.get(y.sessionId);return h&&{session:h.api,variable:y.variable,containerId:y.containerId,frameId:y.frameId,threadId:y.threadId}}async $provideDebugVisualizers(y,h,E,k){const I=this.W(E),P=this.jb(y,h),V=this.G.get(P);if(!I||!V)return[];const W=await V.provideDebugVisualization(I,k);return W?W.map(q=>{const A=++this.M;this.L.set(A,{v:q,provider:V,extensionId:y});const U=q.iconPath?this.lb(q.iconPath):void 0;return{id:A,name:q.name,iconClass:U?.iconClass,iconPath:U?.iconPath,visualization:this.kb(y,q.visualization)}}):[]}$disposeDebugVisualizers(y){for(const h of y)this.L.delete(h)}registerDebugVisualizationProvider(y,h,E){if(!y.contributes?.debugVisualizers?.some(P=>P.id===h))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${h})`);const k=F.$Vm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.G.set(I,E),this.l.$registerDebugVisualizer(k,h),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,h),this.G.delete(h)})}addBreakpoints(y){const h=y.filter(I=>{const P=I.id;return this.z.has(P)?!1:(this.z.set(P,I),!0)});this.gb(h,[],[]);const E=[],k=new Map;for(const I of h)if(I instanceof S.$rN){let P=k.get(I.location.uri.toString());P||(P={type:"sourceMulti",uri:I.location.uri,lines:[]},k.set(I.location.uri.toString(),P),E.push(P)),P.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character,mode:I.mode})}else I instanceof S.$sN&&E.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName,mode:I.mode});return this.l.$registerBreakpoints(E)}removeBreakpoints(y){const h=y.filter(P=>this.z.delete(P.id));this.gb([],h,[]);const E=h.filter(P=>P instanceof S.$rN).map(P=>P.id),k=h.filter(P=>P instanceof S.$sN).map(P=>P.id),I=h.filter(P=>P instanceof S.$tN).map(P=>P.id);return this.l.$unregisterBreakpoints(E,k,I)}startDebugging(y,h,E){return this.l.$startDebugging(y?y.uri:void 0,h,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(y){return this.l.$stopDebugging(y?y.id:void 0)}registerDebugConfigurationProvider(y,h,E){if(!h)return new S.$pM(()=>{});const k=this.d++;return this.f.push({type:y,handle:k,provider:h}),this.l.$registerDebugConfigurationProvider(y,E,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,k),new S.$pM(()=>{this.f=this.f.filter(I=>I.provider!==h),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(y,h,E){if(!E)return new S.$pM(()=>{});if(!this.cb(y,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.$(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:h,handle:k,factory:E}),this.l.$registerDebugAdapterDescriptorFactory(h,k),new S.$pM(()=>{this.h=this.h.filter(I=>I.factory!==E),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(y,h){if(!h)return new S.$pM(()=>{});const E=this.j++;return this.k.push({type:y,handle:E,factory:h}),new S.$pM(()=>{this.k=this.k.filter(k=>k.factory!==h)})}async $runInTerminal(y,h){return Promise.resolve(void 0)}async $substituteVariables(y,h){let E;const k=await this.ib(y);return k&&(E={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(E,h)}X(y,h){if(y.type==="implementation")return new g(y.implementation)}Y(){}async $startDASession(y,h){const E=this,k=await this.hb(h);return this.eb(this.$(k.type),k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const P=this.Z(I),V=this.X(P,k);if(!V)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const W=V;return this.D.set(y,W),this.db(k).then(q=>(q&&this.E.set(y,q),W.onMessage(async A=>{if(A.type==="request"&&A.command==="handshake"){const U=A,K={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ie=await this.K.sign(U.arguments.value);K.body={signature:ie},W.sendResponse(K)}else throw new Error("no signer")}catch(ie){K.success=!1,K.message=ie.message,W.sendResponse(K)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(A),A=(0,f.$IH)(A,!0),E.l.$acceptDAMessage(y,A)}),W.onError(A=>{q&&q.onError&&q.onError(A),this.l.$acceptDAError(y,A.name,A.message,A.stack)}),W.onExit(A=>{q&&q.onExit&&q.onExit(A??void 0,void 0),this.l.$acceptDAExit(y,A??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),W.startSession()))})}$sendDAMessage(y,h){h=(0,f.$HH)(h,!1);const E=this.E.get(y);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(h),this.D.get(y)?.sendMessage(h)}$stopDASession(y){const h=this.E.get(y);this.E.delete(y),h&&h.onWillStopSession&&h.onWillStopSession();const E=this.D.get(y);return this.D.delete(y),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(y){const h=[],E=[],k=[];if(y.added)for(const I of y.added){const P=I.id;if(P&&!this.z.has(P)){let V;if(I.type==="function")V=new S.$sN(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode);else if(I.type==="data")V=new S.$tN(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage,I.mode);else{const W=R.URI.revive(I.uri);V=new S.$rN(new S.$BM(W,new S.$qM(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode)}(0,S.$pN)(V,P),this.z.set(P,V),h.push(V)}}if(y.removed)for(const I of y.removed){const P=this.z.get(I);P&&(this.z.delete(I),E.push(P))}if(y.changed){for(const I of y.changed)if(I.id){const P=this.z.get(I.id);if(P){if(P instanceof S.$sN&&I.type==="function"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.functionName=I.functionName}else if(P instanceof S.$rN&&I.type==="source"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.location=new S.$BM(R.URI.revive(I.uri),new S.$qM(I.line,I.character))}k.push(P)}}}this.gb(h,E,k)}async $acceptStackFrameFocus(y){let h;if(y){const E=await this.hb(y.sessionId);y.kind==="thread"?h=new S.$zN(E.api,y.threadId):h=new S.$yN(E.api,y.threadId,y.frameId)}this.B=h,this.C.fire(this.B)}$provideDebugConfigurations(y,h,E){return(0,C.$sh)(async()=>{const k=this.bb(y);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.ib(h);return k.provideDebugConfigurations(I,E)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(y,h,E,k){return(0,C.$sh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(h);return I.resolveDebugConfiguration(P,E,k)})}$resolveDebugConfigurationWithSubstitutedVariables(y,h,E,k){return(0,C.$sh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(h);return I.resolveDebugConfigurationWithSubstitutedVariables(P,E,k)})}async $provideDebugAdapter(y,h){const E=this.ab(y);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(h);return this.eb(E,k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(I)})}async $acceptDebugSessionStarted(y){const h=await this.hb(y);this.n.fire(h.api)}async $acceptDebugSessionTerminated(y){const h=await this.hb(y);h&&(this.o.fire(h.api),this.m.delete(h.id))}async $acceptDebugSessionActiveChanged(y){this.u=y?await this.hb(y):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(y,h){(await this.hb(y))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(y,h){const k={session:(await this.hb(y)).api,event:h.event,body:h.body};this.w.fire(k)}Z(y){if(y instanceof S.$uN)return{type:"executable",command:y.command,args:y.args,options:y.options};if(y instanceof S.$vN)return{type:"server",port:y.port,host:y.host};if(y instanceof S.$wN)return{type:"pipeServer",path:y.path};if(y instanceof S.$xN)return{type:"implementation",implementation:y.implementation};throw new Error("convertToDto unexpected type")}$(y){const h=this.h.filter(E=>E.type===y);if(h.length>0)return h[0].factory}ab(y){const h=this.h.filter(E=>E.handle===y);if(h.length>0)return h[0].factory}bb(y){const h=this.f.filter(E=>E.handle===y);if(h.length>0)return h[0].provider}cb(y,h){if(y.contributes){const E=y.contributes.debuggers;if(E&&E.length>0){for(const k of E)if(k.label&&k.type&&k.type===h)return!0}}return!1}db(y){const E=y.configuration.type,k=this.k.filter(I=>I.type===E||I.type==="*").map(I=>(0,C.$sh)(()=>I.factory.createDebugAdapterTracker(y.api)).then(P=>P,P=>null));return Promise.race([Promise.all(k).then(I=>{const P=(0,u.$Hb)(I);if(P.length>0)return new l(P)}),new Promise(I=>setTimeout(()=>I(void 0),1e3))]).catch(I=>{})}async eb(y,h){const E=h.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new S.$vN(E));if(y){const I=await this.O.getExtensionRegistry();return(0,C.$sh)(()=>y.createDebugAdapterDescriptor(h.api,this.fb(h,I))).then(P=>{if(P)return P})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(h,k))}fb(y,h){}gb(y,h,E){(y.length>0||h.length>0||E.length>0)&&this.A.fire(Object.freeze({added:y,removed:h,changed:E}))}async hb(y){if(y)if(typeof y=="string"){const h=this.m.get(y);if(h)return h}else{let h=this.m.get(y.id);if(!h){const E=await this.ib(y.folderUri),k=y.parent?this.m.get(y.parent):void 0;h=new w(this.l,y.id,y.type,y.name,E,y.configuration,k?.api),this.m.set(h.id,h),this.l.$sessionCached(h.id)}return h}throw new Error("cannot find session")}ib(y){if(y){const h=R.URI.revive(y);return this.N.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}jb(y,h){return`${y}\0${h}`}kb(y,h){if(h){if("title"in h&&"command"in h)return{type:0};if("treeId"in h)return{type:1,id:`${y}\0${h.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(y){const h=this.mb(y);let E,k;return"id"in h?k=n.ThemeIcon.asClassName(h):E=h,{iconPath:E,iconClass:k}}mb(y){if(y instanceof S.$mN)return{id:y.id};const h=typeof y=="object"&&"dark"in y?y.dark:y,E=typeof y=="object"&&"light"in y?y.light:y;return{dark:typeof h=="string"?R.URI.file(h):h,light:typeof E=="string"?R.URI.file(E):E}}};e.$lnc=i,e.$lnc=i=Je([We(0,N.$RO),We(1,d.$Bmc),We(2,D.$fnc),We(3,s.$Emc),We(4,m.$Qmc),We(5,r.$inc),We(6,t.$bP)],i);class w{constructor(y,h,E,k,I,P,V){this.f=y,this.g=h,this.h=E,this.j=k,this.k=I,this.l=P,this.m=V}get api(){const y=this;return this.d??=Object.freeze({id:y.g,type:y.h,get name(){return y.j},set name(h){y.j=h,y.f.$setDebugSessionName(y.g,h)},parentSession:y.m,workspaceFolder:y.k,configuration:y.l,customRequest(h,E){return y.f.$customDebugAdapterRequest(y.g,h,E)},getDebugProtocolBreakpoint(h){return y.f.$getDebugProtocolBreakpoint(y.g,h.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(y){this.j=y}get configuration(){return this.l}}e.$mnc=w;class a{constructor(y){this.value=Object.freeze({append(h){y.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$nnc=a;class l{constructor(y){this.d=y}onWillStartSession(){this.d.forEach(y=>y.onWillStartSession?y.onWillStartSession():void 0)}onWillReceiveMessage(y){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(y):void 0)}onDidSendMessage(y){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(y):void 0)}onWillStopSession(){this.d.forEach(y=>y.onWillStopSession?y.onWillStopSession():void 0)}onError(y){this.d.forEach(h=>h.onError?h.onError(y):void 0)}onExit(y,h){this.d.forEach(E=>E.onExit?E.onExit(y,h):void 0)}}class g extends v.$Dsb{constructor(y){super(),this.h=y,y.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(y){this.h.handleMessage(y)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let $=class extends i{constructor(y,h,E,k,I,P,V){super(y,h,E,k,I,P,V)}};e.$onc=$,e.$onc=$=Je([We(0,N.$RO),We(1,d.$Bmc),We(2,D.$fnc),We(3,s.$Emc),We(4,m.$Qmc),We(5,r.$inc),We(6,t.$bP)],$)}),define(ke[305],Se([1,0,14,60,2,4,255,12,56,72,27,199,17,61,41,63]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=e.$roc=void 0;class r{static async installEarlyHandler(t){Error.stackTraceLimit=100;const c=t.get(p.$7j),i=t.get(d.$RO).getProxy(F.$nM.MainThreadErrors);C.setUnexpectedErrorHandler(w=>{c.error(w);const a=C.$3(w);i.$onUnexpectedError(a)})}static async installFullHandler(t){const c=t.get(p.$7j),u=t.get(d.$RO),i=t.get(f.$fnc),w=t.get(s.$_O),a=u.getProxy(F.$nM.MainThreadExtensionService),l=u.getProxy(F.$nM.MainThreadErrors),g=await i.getExtensionPathIndex(),$=new WeakMap;function b(E,k){if($.has(E))return $.get(E).stack;let I="",P,V;for(const q of k)I+=`
	at ${q.toString()}`,V=q.getFileName(),!P&&V&&(P=g.findSubstr(R.URI.file(V)));const W=`${E.name||"Error"}: ${E.message||""}${I}`;return $.set(E,{extensionIdentifier:P?.identifier,stack:W}),W}const y=Symbol("prepareStackTrace wrapped");let h=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(E){if(E===b||!E||E[y]){h=E||b;return}h=function(k,I){return b(k,I),E.call(Error,k,I)},Object.assign(h,{[y]:!0})}}),C.setUnexpectedErrorHandler(E=>{c.error(E);const k=C.$3(E),I=$.get(E);if(!I?.extensionIdentifier){l.$onUnexpectedError(k);return}a.$onExtensionRuntimeError(I.extensionIdentifier,k);const P=w.onExtensionError(I.extensionIdentifier,E);c.trace("forwarded error to extension?",P,I)})}}e.$roc=r;class o{constructor(t,c,u,i,w){this.a=u,this.b=new M.$Yac(t,null,i),c=o.e(c,this.b);const a=new D.$yi(...(0,m.$Es)());a.set(N.$8O,{_serviceBrand:void 0,...c,messagePorts:w}),a.set(d.$RO,new d.$SO(this.b)),a.set(v.$ymc,new v.$zmc(i)),a.set(f.$dnc,u);const l=new S.$ir(a,!0);l.invokeFunction(r.installEarlyHandler),this.d=l.invokeFunction(g=>g.get(p.$7j)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=l.invokeFunction(g=>g.get(f.$fnc)),this.c.initialize(),l.invokeFunction(r.installFullHandler)}async asBrowserUri(t){const c=this.b.getProxy(F.$nM.MainThreadExtensionService);return R.URI.revive(await c.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,c){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=R.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=R.URI.revive(c.transformIncomingURIs(t.environment.appRoot));const u=t.environment.extensionDevelopmentLocationURI;return u&&(t.environment.extensionDevelopmentLocationURI=u.map(i=>R.URI.revive(c.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=R.URI.revive(c.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=R.URI.revive(c.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=R.URI.revive(c.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=R.URI.revive(c.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=R.URI.revive(c.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=R.URI.revive(c.transformIncomingURIs(t.logsLocation)),t.workspace=c.transformIncomingURIs(t.workspace),t}}e.$soc=o}),define(ke[306],Se([1,0,18,11,20,44,16,19,24,2,48]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=e.$Dnc=e.$Cnc=void 0,e.$Enc=s;class S{constructor(n,t,c){this.d=n,this.e=t,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,t){const c=this.g.folderQueries||[],u=new R.$se(t);return new Promise((i,w)=>{this.a=new v(n);let a=!1;const l=(g,$)=>{if(!a&&!this.b){const b=this.h(g);s(g)&&typeof this.g.maxResults=="number"&&this.c+b>this.g.maxResults&&(this.b=!0,a=!0,u.cancel(),g=this.j(g,this.g.maxResults-this.c));const y=this.h(g);this.c+=y,(y>0||!s(g))&&this.a.add(g,$)}};Promise.all(c.map((g,$)=>this.k(g,b=>l(b,$),u.token))).then(g=>{u.dispose(),this.a.flush();const $=g.some(b=>!!b&&!!b.limitHit);i({limitHit:this.b||$,messages:g.flatMap(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[]),stats:{type:this.f}})},g=>{u.dispose();const $=(0,F.$lj)(g);w(new Error($))})})}h(n){return s(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,t){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],u=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,t),preview:{matches:u.slice(0,t),text:n.preview.text},uri:n.uri}}async k(n,t,c){const u=new N.$TK(this.g,n),i=[],w={report:g=>{if(!this.l(g))return;const $=n.folder.scheme===M.Schemas.file?(0,N.$UK)(()=>this.e.readdir(m.$ah(g.uri))):void 0,b=m.$dh(n.folder,g.uri);if(b){const y=u.includedInQuery(b,p.$nc(b),$);(0,O.$mh)(y)?i.push(y.then(h=>{h&&t(g)})):y&&t(g)}}},a=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,w,c):l=await this.d.provider.provideTextSearchResults(d(this.d.query.contentPattern),a,w,c),i.length&&await Promise.all(i),l}l(n){if(s(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const t=(0,N.$SK)(this.g.includePattern,n.includePattern),c=(0,N.$SK)(this.g.excludePattern,n.excludePattern),u={folder:D.URI.from(n.folder),excludes:c,includes:t,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(u.usePCRE2=this.g.usePCRE2),u}}e.$Cnc=S;function d(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new r(512,t=>this.g(t))}add(n,t){this.d&&(this.b!==t||!m.$7g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:n.uri,results:[]}),this.d.results.push(f(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Dnc=v;function f(o){return s(o)?{preview:{matches:(0,C.$1b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,C.$1b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function s(o){return!!o.preview}class r{static{this.a=4e3}static{this.b=50}constructor(n,t){this.g=n,this.h=t,this.c=0,this.d=[],this.e=0}addItem(n,t){n&&this.j(n,t)}addItems(n,t){n&&this.k(n,t)}j(n,t){this.d.push(n),this.e+=t,this.l()}k(n,t){this.d=this.d.concat(n),this.e+=t,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Fnc=r}),define(ke[124],Se([1,0,6,4,3,301,17,61,12,2,306]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=e.$Gnc=void 0,e.$Inc=d,e.$Gnc=(0,R.$Ai)("IExtHostSearch");let S=class{constructor(s,r,o){this.n=s,this.o=r,this.q=o,this.c=this.n.getProxy(O.$nM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new F.$Bnc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,r){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const o=this.d++;return this.e.set(o,r),this.c.$registerTextSearchProvider(o,this.s(s)),(0,C.$Sc)(()=>{this.g.delete(s),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(s,r){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const o=this.d++;return this.h.set(o,r),this.c.$registerAITextSearchProvider(o,this.s(s)),(0,C.$Sc)(()=>{this.i.delete(s),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(s,r){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const o=this.d++;return this.j.set(o,r),this.c.$registerFileSearchProvider(o,this.s(s)),(0,C.$Sc)(()=>{this.k.delete(s),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(s,r,o,n){const t=d(o),c=this.j.get(s);if(c)return this.l.fileSearch(t,c,u=>{this.c.$handleFileMatch(s,r,u.map(i=>i.resource))},n);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,r,o){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,r,o,n){const t=this.e.get(s);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=d(o);return this.t(c,t).search(i=>this.c.$handleTextMatch(s,r,i),n)}$provideAITextSearchResults(s,r,o,n){const t=this.h.get(s);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=d(o);return this.v(c,t).search(i=>this.c.$handleTextMatch(s,r,i),n)}$enableExtensionHostSearch(){}t(s,r){return new N.$Cnc({query:s,provider:r},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(s,r){return new N.$Cnc({query:s,provider:r},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$Hnc=S,e.$Hnc=S=Je([We(0,M.$RO),We(1,p.$ymc),We(2,m.$7j)],S);function d(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(v),extraFileResources:f.extraFileResources&&f.extraFileResources.map(s=>D.URI.revive(s))}}function v(f){return{...f,folder:D.URI.revive(f.folder)}}}),define(ke[307],Se([1,0,20,14,5,6,16,32,2,158,154,141,95,21,38,12,58,59,213,4,258,286,80,86,263,264,265,243,232,35,266,40,267,123,112,268,245,259,269,270,68,67,246,260,41,272,65,273,47,27,287,247,274,90,275,81,82,249,300,277,219,278,288,279,118,250,280,281,282,17,283,124,83,284,251,285,84,87,121,63,53,116,289,290,261,291,292,88,8,7,252,61,253,64,293,294,111,39,227,79,25,120]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c,u,i,w,a,l,g,$,b,y,h,E,k,I,P,V,W,q,A,U,K,ie,ce,ve,Ee,ge,ue,Ce,re,Ne,Te,T,X,pe,Ie,ye,$e,fe,Q,x,le,ae,Fe,de,Pe,Ae,je,j,z,G,H,te,ne,Oe,Be,He,_e,xe,et,tt,it,at,mt,Ue,rt,Y,Z,me,Ge,be,st,dt,Pt,Vt,Qt,ii,Xt,Et,Zt,Yt,Ze,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=Ht;function Ht(ht){const ft=ht.get(Ne.$8O),xt=ht.get(re.$jmc),Kt=ht.get(ue.$Gmc),Ft=ht.get(Ee.$fnc),gt=ht.get(Et.$Bmc),Bt=ht.get(tt.$_O),_t=ht.get(E.$Emc),zt=ht.get(dt.$ymc),Qe=ht.get(G.$RO),ui=ht.get(_e.$Zmc),Jt=ht.get(xe.$Hmc),Ut=ht.get(s.$8j),wt=ht.get(s.$7j),jt=ht.get(me.$_Db),Rt=ht.get(i.$fmc),Mt=ht.get(Xt.$loc),ei=ht.get(ne.$0mc),Wt=ht.get(ie.$Qmc),oi=ht.get($e.$bnc),Ot=ht.get(w.$pmc),qt=ht.get(pe.$7mc);Qe.set(t.$oM.ExtHostFileSystemInfo,xt),Qe.set(t.$oM.ExtHostLogLevelServiceShape,Ut),Qe.set(t.$oM.ExtHostWorkspace,gt),Qe.set(t.$oM.ExtHostConfiguration,_t),Qe.set(t.$oM.ExtHostExtensionService,Ft),Qe.set(t.$oM.ExtHostStorage,ui),Qe.set(t.$oM.ExtHostTunnelService,jt),Qe.set(t.$oM.ExtHostWindow,Mt),Qe.set(t.$oM.ExtHostSecretState,ei),Qe.set(t.$oM.ExtHostTelemetry,Bt),Qe.set(t.$oM.ExtHostEditorTabs,Wt),Qe.set(t.$oM.ExtHostManagedSockets,oi),Qe.set(t.$oM.ExtHostAuthentication,Ot),Qe.set(t.$oM.ExtHostChatProvider,qt);const At=Qe.set(t.$oM.ExtHostDecorations,ht.get(P.$qnc)),St=Qe.set(t.$oM.ExtHostDocumentsAndEditors,ht.get(K.$3O)),$t=Qe.set(t.$oM.ExtHostCommands,ht.get(y.$bP)),Dt=Qe.set(t.$oM.ExtHostTerminalService,ht.get(it.$3mc)),ai=Qe.set(t.$oM.ExtHostTerminalShellIntegration,ht.get(at.$0nc)),kt=Qe.set(t.$oM.ExtHostDebugService,ht.get(I.$knc)),fi=Qe.set(t.$oM.ExtHostSearch,ht.get(te.$Gnc)),ni=Qe.set(t.$oM.ExtHostTask,ht.get(et.$9nc)),$i=Qe.set(t.$oM.ExtHostOutputService,ht.get(Pe.$Vnc)),li=Qe.set(t.$oM.ExtHostLocalization,ht.get(ye.$anc)),bi=Qe.set(t.$oM.ExtHostUrls,new Pt.$ioc(Qe)),It=Qe.set(t.$oM.ExtHostDocuments,new U.$mmc(Qe,St)),Ei=Qe.set(t.$oM.ExtHostDocumentContentProviders,new q.$snc(Qe,St,wt)),ri=Qe.set(t.$oM.ExtHostDocumentSaveParticipant,new A.$tnc(wt,It,Qe.getProxy(t.$nM.MainThreadBulkEdits))),we=Qe.set(t.$oM.ExtHostNotebook,new Q.$Jnc(Qe,$t,St,It,Kt,fi)),Me=Qe.set(t.$oM.ExtHostNotebookDocuments,new le.$Pnc(we)),oe=Qe.set(t.$oM.ExtHostNotebookEditors,new ae.$Qnc(wt,we)),J=Qe.set(t.$oM.ExtHostNotebookKernels,new Fe.$Rnc(Qe,ft,we,$t,wt)),Re=Qe.set(t.$oM.ExtHostNotebookRenderers,new de.$Tnc(Qe,we)),Ve=Qe.set(t.$oM.ExtHostNotebookDocumentSaveParticipant,new x.$Onc(wt,we,Qe.getProxy(t.$nM.MainThreadBulkEdits))),Xe=Qe.set(t.$oM.ExtHostEditors,new Ue.$vmc(Qe,St)),qe=Qe.set(t.$oM.ExtHostTreeViews,new Z.$goc(Qe.getProxy(t.$nM.MainThreadTreeViews),$t,wt)),ut=Qe.set(t.$oM.ExtHostEditorInsets,new b.$wmc(Qe.getProxy(t.$nM.MainThreadEditorInsets),Xe,ft.remote)),yt=Qe.set(t.$oM.ExtHostDiagnostics,new V.$lmc(Qe,wt,xt,St)),Tt=Qe.set(t.$oM.ExtHostLanguages,new Ie.$Mnc(Qe,It,$t.converter,zt)),ct=Qe.set(t.$oM.ExtHostLanguageFeatures,new X.$nmc(Qe,zt,It,$t,yt,wt,Rt,Bt)),Nt=Qe.set(t.$oM.ExtHostFileSystem,new ge.$wnc(Qe,ct)),Lt=Qe.set(t.$oM.ExtHostFileSystemEventService,new Ce.$xnc(Qe,wt,St)),Di=Qe.set(t.$oM.ExtHostQuickOpen,(0,z.$Znc)(Qe,gt,$t)),Ii=Qe.set(t.$oM.ExtHostSCM,new H.$2nc(Qe,$t,It,wt)),Ji=Qe.set(t.$oM.ExtHostQuickDiff,new j.$Ync(Qe,zt)),Oi=Qe.set(t.$oM.ExtHostShare,new Oe.$3nc(Qe,zt)),Ni=Qe.set(t.$oM.ExtHostComments,(0,h.$xmc)(Qe,$t,It)),Ci=Qe.set(t.$oM.ExtHostProgress,new je.$Xnc(Qe.getProxy(t.$nM.MainThreadProgress))),Fi=Qe.set(t.$oM.ExtHostLabelService,new T.$Lnc(Qe)),Ti=Qe.set(t.$oM.ExtHostTheming,new rt.$doc(Qe)),Qi=Qe.set(t.$oM.ExtHostTimeline,new Y.$foc(Qe,$t)),Li=Qe.set(t.$oM.ExtHostWebviews,new Vt.$Lmc(Qe,ft.remote,gt,wt,Rt)),Pi=Qe.set(t.$oM.ExtHostWebviewPanels,new Qt.$Omc(Qe,Li,gt)),zi=Qe.set(t.$oM.ExtHostCustomEditors,new k.$Pmc(Qe,It,Jt,Li,Pi)),Ui=Qe.set(t.$oM.ExtHostWebviewViews,new ii.$joc(Qe,Li)),vi=Qe.set(t.$oM.ExtHostTesting,new mt.$_nc(Qe,wt,$t,St)),Xi=Qe.set(t.$oM.ExtHostUriOpeners,new st.$hoc(Qe)),Zi=Qe.set(t.$oM.ExtHostProfileContentHandlers,new Ae.$Wnc(Qe));Qe.set(t.$oM.ExtHostInteractive,new Te.$Knc(Qe,we,St,$t,wt));const Ri=Qe.set(t.$oM.ExtHostChatAgents2,new l.$smc(Qe,wt,$t)),Yi=Qe.set(t.$oM.ExtHostChatVariables,new g.$tmc(Qe)),ji=Qe.set(t.$oM.ExtHostAiRelatedInformation,new c.$emc(Qe)),gn=Qe.set(t.$oM.ExtHostAiEmbeddingVector,new ve.$vnc(Qe)),xi=Qe.set(t.$oM.ExtHostStatusBar,new He.$6nc(Qe,$t.converter)),Bi=Qe.set(t.$oM.ExtHostSpeech,new Be.$4nc(Qe)),pi=Qe.set(t.$oM.ExtHostEmbeddings,new ce.$unc(Qe)),mn=Object.values(t.$oM);Qe.assertRegistered(mn);const $n=new a.$rmc(Qe,St),_i=new $.$umc(Qe),Vi=new fe.$Nnc(Qe,wt),Ai=new W.$rnc(Qe);return u.$omc.register($t),function(ze,hi,Wi){function nt(_){return(se,Le,ot)=>{const vt=_(Ct=>{try{se.call(Le,Ct)}catch(Si){O.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Bt.onExtensionError(ze.identifier,Si)}});return ot?.push(vt),vt}}const bt=function(){let _=!ze.isUnderDevelopment;function se(){_||(wt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(ot){if(Array.isArray(ot))ot.forEach(Le);else if(typeof ot=="string")se();else{const vt=ot;typeof vt.scheme>"u"&&se(),typeof vt.exclusive=="boolean"&&(0,Ze.$OG)(ze,"documentFiltersExclusive")}return ot}}(),en={getSession(_,se,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ze.$OG)(ze,"authLearnMore"),Ot.getSession(ze,_,se,Le)},getSessions(_,se){return(0,Ze.$OG)(ze,"authGetSessions"),Ot.getSessions(ze,_,se)},async hasSession(_,se){return(0,Ze.$OG)(ze,"authSession"),!!await Ot.getSession(ze,_,se,{silent:!0})},get onDidChangeSessions(){return nt(Ot.onDidChangeSessions)},registerAuthenticationProvider(_,se,Le,ot){return Ot.registerAuthenticationProvider(_,se,Le,ot)}},gi={registerCommand(_,se,Le){return $t.registerCommand(!0,_,se,Le,void 0,ze)},registerTextEditorCommand(_,se,Le){return $t.registerCommand(!0,_,(...ot)=>{const vt=Xe.getActiveTextEditor();if(!vt){wt.warn("Cannot execute "+_+" because there is no active text editor.");return}return vt.edit(Ct=>{se.apply(Le,[vt,Ct,...ot])}).then(Ct=>{Ct||wt.warn("Edits from command "+_+" were not applied.")},Ct=>{wt.warn("An error occurred while running command "+_,Ct)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,se,Le)=>((0,Ze.$OG)(ze,"diffCommand"),$t.registerCommand(!0,_,async(...ot)=>{const vt=St.activeEditor(!0);if(!vt){wt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Ct=await Xe.getDiffInformation(vt.id);se.apply(Le,[Ct,...ot])},void 0,void 0,ze)),executeCommand(_,...se){return $t.executeCommand(_,...se)},getCommands(_=!1){return $t.getCommands(_)}},ki={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return nt(Dt.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$OG)(ze,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$OG)(ze,"telemetry"),nt(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$$O)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,se){return tt.$0O.validateSender(_),Bt.instantiateLogger(ze,_,se)},openExternal(_,se){return Mt.openUri(_,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:se?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===ft.environment.appUriScheme)return bi.createAppUri(_);try{return await Mt.asExternalUri(_,{allowTunneling:!!ft.remote.authority})}catch(se){if((0,M.$Jg)(_,M.Schemas.http)||(0,M.$Jg)(_,M.Schemas.https))return _;throw se}},get remoteName(){return(0,r.$Mm)(ft.remote.authority)},get remoteAuthority(){return(0,Ze.$OG)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return nt(wt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$OG)(ze,"resolvers"),ft.quality},get appCommit(){return(0,Ze.$OG)(ze,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(ki);const pn={createTestController(_,se,Le){return vi.createTestController(ze,_,se,Le)},createTestObserver(){return(0,Ze.$OG)(ze,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ze.$OG)(ze,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$OG)(ze,"testObserver"),nt(vi.onResultsChanged)},get testResults(){return(0,Ze.$OG)(ze,"testObserver"),vi.results}},ti=ft.remote.isRemote?be.ExtensionKind.Workspace:be.ExtensionKind.UI,Mi={getExtension(_,se){(0,Ze.$NG)(ze,"extensionsAny")||(se=!1);const Le=hi.mine.getExtensionDescription(_);if(Le)return new Ee.$gnc(Ft,ze.identifier,Le,ti,!1);if(se){const ot=hi.all.getExtensionDescription(_);if(ot)return new Ee.$gnc(Ft,ze.identifier,ot,ti,!0)}},get all(){const _=[];for(const se of hi.mine.getAllExtensionDescriptions())_.push(new Ee.$gnc(Ft,ze.identifier,se,ti,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$OG)(ze,"extensionsAny");const _=new v.$Wm(hi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),se=[];for(const Le of hi.all.getAllExtensionDescriptions()){const ot=!_.has(Le.identifier);se.push(new Ee.$gnc(Ft,ze.identifier,Le,ti,ot))}return se},get onDidChange(){return(0,Ze.$NG)(ze,"extensionsAny")?nt(R.Event.any(hi.mine.onDidChange,hi.all.onDidChange)):nt(hi.mine.onDidChange)}},tn={createDiagnosticCollection(_){return yt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(yt.onDidChangeDiagnostics)},getDiagnostics:_=>yt.getDiagnostics(_),getLanguages(){return Tt.getLanguages()},setTextDocumentLanguage(_,se){return Tt.changeLanguage(_.uri,se)},match(_,se){const Le=Ge.LanguageSelector.from(_);let ot;return(0,N.$iu)(Le)&&(ot=we.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Ct=>Ct.document===se))?.apiNotebook),(0,N.$hu)(Le,se.uri,se.languageId,!0,ot?.uri,ot?.notebookType)},registerCodeActionsProvider(_,se,Le){return ct.registerCodeActionProvider(ze,bt(_),se,Le)},registerDocumentPasteEditProvider(_,se,Le){return(0,Ze.$OG)(ze,"documentPaste"),ct.registerDocumentPasteEditProvider(ze,bt(_),se,Le)},registerCodeLensProvider(_,se){return ct.registerCodeLensProvider(ze,bt(_),se)},registerDefinitionProvider(_,se){return ct.registerDefinitionProvider(ze,bt(_),se)},registerDeclarationProvider(_,se){return ct.registerDeclarationProvider(ze,bt(_),se)},registerImplementationProvider(_,se){return ct.registerImplementationProvider(ze,bt(_),se)},registerTypeDefinitionProvider(_,se){return ct.registerTypeDefinitionProvider(ze,bt(_),se)},registerHoverProvider(_,se){return ct.registerHoverProvider(ze,bt(_),se,ze.identifier)},registerEvaluatableExpressionProvider(_,se){return ct.registerEvaluatableExpressionProvider(ze,bt(_),se,ze.identifier)},registerInlineValuesProvider(_,se){return ct.registerInlineValuesProvider(ze,bt(_),se,ze.identifier)},registerDocumentHighlightProvider(_,se){return ct.registerDocumentHighlightProvider(ze,bt(_),se)},registerMultiDocumentHighlightProvider(_,se){return ct.registerMultiDocumentHighlightProvider(ze,bt(_),se)},registerLinkedEditingRangeProvider(_,se){return ct.registerLinkedEditingRangeProvider(ze,bt(_),se)},registerReferenceProvider(_,se){return ct.registerReferenceProvider(ze,bt(_),se)},registerRenameProvider(_,se){return ct.registerRenameProvider(ze,bt(_),se)},registerNewSymbolNamesProvider(_,se){return(0,Ze.$OG)(ze,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(ze,bt(_),se)},registerDocumentSymbolProvider(_,se,Le){return ct.registerDocumentSymbolProvider(ze,bt(_),se,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,se){return ct.registerDocumentFormattingEditProvider(ze,bt(_),se)},registerDocumentRangeFormattingEditProvider(_,se){return ct.registerDocumentRangeFormattingEditProvider(ze,bt(_),se)},registerOnTypeFormattingEditProvider(_,se,Le,...ot){return ct.registerOnTypeFormattingEditProvider(ze,bt(_),se,[Le].concat(ot))},registerDocumentSemanticTokensProvider(_,se,Le){return ct.registerDocumentSemanticTokensProvider(ze,bt(_),se,Le)},registerDocumentRangeSemanticTokensProvider(_,se,Le){return ct.registerDocumentRangeSemanticTokensProvider(ze,bt(_),se,Le)},registerSignatureHelpProvider(_,se,Le,...ot){return typeof Le=="object"?ct.registerSignatureHelpProvider(ze,bt(_),se,Le):ct.registerSignatureHelpProvider(ze,bt(_),se,typeof Le>"u"?[]:[Le,...ot])},registerCompletionItemProvider(_,se,...Le){return ct.registerCompletionItemProvider(ze,bt(_),se,Le)},registerInlineCompletionItemProvider(_,se,Le){return se.handleDidShowCompletionItem&&(0,Ze.$OG)(ze,"inlineCompletionsAdditions"),se.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$OG)(ze,"inlineCompletionsAdditions"),Le&&(0,Ze.$OG)(ze,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(ze,bt(_),se,Le)},registerInlineEditProvider(_,se){return(0,Ze.$OG)(ze,"inlineEdit"),ct.registerInlineEditProvider(ze,bt(_),se)},registerDocumentLinkProvider(_,se){return ct.registerDocumentLinkProvider(ze,bt(_),se)},registerColorProvider(_,se){return ct.registerColorProvider(ze,bt(_),se)},registerFoldingRangeProvider(_,se){return ct.registerFoldingRangeProvider(ze,bt(_),se)},registerSelectionRangeProvider(_,se){return ct.registerSelectionRangeProvider(ze,_,se)},registerCallHierarchyProvider(_,se){return ct.registerCallHierarchyProvider(ze,_,se)},registerTypeHierarchyProvider(_,se){return ct.registerTypeHierarchyProvider(ze,_,se)},setLanguageConfiguration:(_,se)=>ct.setLanguageConfiguration(ze,_,se),getTokenInformationAtPosition(_,se){return(0,Ze.$OG)(ze,"tokenInformation"),Tt.tokenAtPosition(_,se)},registerInlayHintsProvider(_,se){return ct.registerInlayHintsProvider(ze,_,se)},createLanguageStatusItem(_,se){return Tt.createLanguageStatusItem(ze,_,se)},registerDocumentDropEditProvider(_,se,Le){return ct.registerDocumentOnDropEditProvider(ze,_,se,(0,Ze.$NG)(ze,"documentPaste")?Le:void 0)}},nn={get activeTextEditor(){return Xe.getActiveTextEditor()},get visibleTextEditors(){return Xe.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(_,se,Le){m.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&Rt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await(m.URI.isUri(_)?Promise.resolve(qi.openTextDocument(_)):Promise.resolve(_));return Xe.showTextDocument(ot,se,Le)},createTextEditorDecorationType(_){return Xe.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,se,Le){return nt(Xe.onDidChangeActiveTextEditor)(_,se,Le)},onDidChangeVisibleTextEditors(_,se,Le){return nt(Xe.onDidChangeVisibleTextEditors)(_,se,Le)},onDidChangeTextEditorSelection(_,se,Le){return nt(Xe.onDidChangeTextEditorSelection)(_,se,Le)},onDidChangeTextEditorOptions(_,se,Le){return nt(Xe.onDidChangeTextEditorOptions)(_,se,Le)},onDidChangeTextEditorVisibleRanges(_,se,Le){return nt(Xe.onDidChangeTextEditorVisibleRanges)(_,se,Le)},onDidChangeTextEditorViewColumn(_,se,Le){return nt(Xe.onDidChangeTextEditorViewColumn)(_,se,Le)},onDidCloseTerminal(_,se,Le){return nt(Dt.onDidCloseTerminal)(_,se,Le)},onDidOpenTerminal(_,se,Le){return nt(Dt.onDidOpenTerminal)(_,se,Le)},onDidChangeActiveTerminal(_,se,Le){return nt(Dt.onDidChangeActiveTerminal)(_,se,Le)},onDidChangeTerminalDimensions(_,se,Le){return(0,Ze.$OG)(ze,"terminalDimensions"),nt(Dt.onDidChangeTerminalDimensions)(_,se,Le)},onDidChangeTerminalState(_,se,Le){return nt(Dt.onDidChangeTerminalState)(_,se,Le)},onDidWriteTerminalData(_,se,Le){return(0,Ze.$OG)(ze,"terminalDataWriteEvent"),nt(Dt.onDidWriteTerminalData)(_,se,Le)},onDidExecuteTerminalCommand(_,se,Le){return(0,Ze.$OG)(ze,"terminalExecuteCommandEvent"),nt(Dt.onDidExecuteTerminalCommand)(_,se,Le)},onDidChangeTerminalShellIntegration(_,se,Le){return(0,Ze.$OG)(ze,"terminalShellIntegration"),nt(ai.onDidChangeTerminalShellIntegration)(_,se,Le)},onDidStartTerminalShellExecution(_,se,Le){return(0,Ze.$OG)(ze,"terminalShellIntegration"),nt(ai.onDidStartTerminalShellExecution)(_,se,Le)},onDidEndTerminalShellExecution(_,se,Le){return(0,Ze.$OG)(ze,"terminalShellIntegration"),nt(ai.onDidEndTerminalShellExecution)(_,se,Le)},get state(){return Mt.getState()},onDidChangeWindowState(_,se,Le){return nt(Mt.onDidChangeWindowState)(_,se,Le)},showInformationMessage(_,...se){return Vi.showMessage(ze,p.default.Info,_,se[0],se.slice(1))},showWarningMessage(_,...se){return Vi.showMessage(ze,p.default.Warning,_,se[0],se.slice(1))},showErrorMessage(_,...se){return Vi.showMessage(ze,p.default.Error,_,se[0],se.slice(1))},showQuickPick(_,se,Le){return Di.showQuickPick(ze,_,se,Le)},showWorkspaceFolderPick(_){return Di.showWorkspaceFolderPick(_)},showInputBox(_,se){return Di.showInput(_,se)},showOpenDialog(_){return Ai.showOpenDialog(ze,_)},showSaveDialog(_){return Ai.showSaveDialog(_)},createStatusBarItem(_,se,Le){let ot,vt,Ct;return typeof _=="string"?(ot=_,vt=se,Ct=Le):(vt=_,Ct=se),xi.createStatusBarEntry(ze,ot,vt,Ct)},setStatusBarMessage(_,se){return xi.setStatusBarMessage(_,se)},withScmProgress(_){return Rt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ci.withProgress(ze,{location:be.ProgressLocation.SourceControl},(se,Le)=>_({report(ot){}}))},withProgress(_,se){return Ci.withProgress(ze,_,se)},createOutputChannel(_,se){return $i.createOutputChannel(_,se,ze)},createWebviewPanel(_,se,Le,ot){return Pi.createWebviewPanel(ze,_,se,Le,ot)},createWebviewTextEditorInset(_,se,Le,ot){return(0,Ze.$OG)(ze,"editorInsets"),ut.createWebviewEditorInset(_,se,Le,ot,ze)},createTerminal(_,se,Le){return typeof _=="object"?"pty"in _?Dt.createExtensionTerminal(_):Dt.createTerminalFromOptions(_):Dt.createTerminal(_,se,Le)},registerTerminalLinkProvider(_){return Dt.registerLinkProvider(_)},registerTerminalProfileProvider(_,se){return Dt.registerProfileProvider(ze,_,se)},registerTerminalQuickFixProvider(_,se){return(0,Ze.$OG)(ze,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(_,ze.identifier.value,se)},registerTreeDataProvider(_,se){return qe.registerTreeDataProvider(_,se,ze)},createTreeView(_,se){return qe.createTreeView(_,se,ze)},registerWebviewPanelSerializer:(_,se)=>Pi.registerWebviewPanelSerializer(ze,_,se),registerCustomEditorProvider:(_,se,Le={})=>zi.registerCustomEditorProvider(ze,_,se,Le),registerFileDecorationProvider(_){return At.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return bi.registerUriHandler(ze,_)},createQuickPick(){return Di.createQuickPick(ze)},createInputBox(){return Di.createInputBox(ze)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(_,se,Le){return nt(Ti.onDidChangeActiveColorTheme)(_,se,Le)},registerWebviewViewProvider(_,se,Le){return Ui.registerWebviewViewProvider(ze,_,se,Le?.webviewOptions)},get activeNotebookEditor(){return we.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,se,Le){return nt(we.onDidChangeActiveNotebookEditor)(_,se,Le)},get visibleNotebookEditors(){return we.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(we.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,se,Le){return nt(oe.onDidChangeNotebookEditorSelection)(_,se,Le)},onDidChangeNotebookEditorVisibleRanges(_,se,Le){return nt(oe.onDidChangeNotebookEditorVisibleRanges)(_,se,Le)},showNotebookDocument(_,se){return we.showNotebookDocument(_,se)},registerExternalUriOpener(_,se,Le){return(0,Ze.$OG)(ze,"externalUriOpener"),Xi.registerExternalUriOpener(ze.identifier,_,se,Le)},registerProfileContentHandler(_,se){return(0,Ze.$OG)(ze,"profileContentHandlers"),Zi.registerProfileContentHandler(ze,_,se)},registerQuickDiffProvider(_,se,Le,ot){return(0,Ze.$OG)(ze,"quickDiffProvider"),Ji.registerQuickDiffProvider(bt(_),se,Le,ot)},get tabGroups(){return Wt.tabGroups},registerShareProvider(_,se){return(0,Ze.$OG)(ze,"shareProvider"),Oi.registerShareProvider(bt(_),se)}},qi={get rootPath(){return Rt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(_){throw new O.$9("rootPath")},getWorkspaceFolder(_){return gt.getWorkspaceFolder(_)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(_){throw new O.$9("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(_){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(_,se,...Le)=>gt.updateWorkspaceFolders(ze,_,se||0,...Le),onDidChangeWorkspaceFolders:function(_,se,Le){return nt(gt.onDidChangeWorkspace)(_,se,Le)},asRelativePath:(_,se)=>gt.getRelativePath(_,se),findFiles:(_,se,Le,ot)=>gt.findFiles(_,se,Le,ze.identifier,ot),findFiles2:(_,se,Le)=>((0,Ze.$OG)(ze,"findFiles2"),gt.findFiles2(_,se,ze.identifier,Le)),findTextInFiles:(_,se,Le,ot)=>{(0,Ze.$OG)(ze,"findTextInFiles");let vt,Ct;return typeof se=="object"?(vt=se,Ct=Le):(vt={},Ct=se,ot=Le),gt.findTextInFiles(_,vt||{},Ct,ze.identifier,ot)},save:_=>gt.save(_),saveAs:_=>gt.saveAs(_),saveAll:_=>gt.saveAll(_),applyEdit(_,se){return $n.applyWorkspaceEdit(_,ze,se)},createFileSystemWatcher:(_,se,Le,ot)=>{let vt;return typeof se=="boolean"?vt={ignoreCreateEvents:!!se,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!ot,correlate:!1}:se&&((0,Ze.$OG)(ze,"createFileSystemWatcher"),vt={...se,correlate:!0}),Lt.createFileSystemWatcher(gt,ze,_,vt)},get textDocuments(){return It.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new O.$9("textDocuments")},openTextDocument(_){let se;const Le=_;if(typeof _=="string")se=Promise.resolve(m.URI.file(_));else if(m.URI.isUri(_))se=Promise.resolve(_);else if(!Le||typeof Le=="object")se=It.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return se.then(ot=>(ot.scheme===M.Schemas.vscodeRemote&&!ot.authority&&Rt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),It.ensureDocumentData(ot).then(vt=>vt.document)))},onDidOpenTextDocument:(_,se,Le)=>nt(It.onDidAddDocument)(_,se,Le),onDidCloseTextDocument:(_,se,Le)=>nt(It.onDidRemoveDocument)(_,se,Le),onDidChangeTextDocument:(_,se,Le)=>nt(It.onDidChangeDocument)(_,se,Le),onDidSaveTextDocument:(_,se,Le)=>nt(It.onDidSaveDocument)(_,se,Le),onWillSaveTextDocument:(_,se,Le)=>nt(ri.getOnWillSaveTextDocumentEvent(ze))(_,se,Le),get notebookDocuments(){return we.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,se){let Le;if(m.URI.isUri(_))Le=_,await we.openNotebookDocument(_);else if(typeof _=="string")Le=m.URI.revive(await we.createNotebookDocument({viewType:_,content:se}));else throw new Error("Invalid arguments");return we.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,se,Le){return nt(Me.onDidSaveNotebookDocument)(_,se,Le)},onDidChangeNotebookDocument(_,se,Le){return nt(Me.onDidChangeNotebookDocument)(_,se,Le)},onWillSaveNotebookDocument(_,se,Le){return nt(Ve.getOnWillSaveNotebookDocumentEvent(ze))(_,se,Le)},get onDidOpenNotebookDocument(){return nt(we.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(we.onDidCloseNotebookDocument)},registerNotebookSerializer(_,se,Le,ot){return we.registerNotebookSerializer(ze,_,se,Le,(0,Ze.$NG)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(_,se,Le)=>nt(Wi.onDidChangeConfiguration)(_,se,Le),getConfiguration(_,se){return se=arguments.length===1?void 0:se,Wi.getConfiguration(_,se,ze)},registerTextDocumentContentProvider(_,se){return Ei.registerTextDocumentContentProvider(_,se)},registerTaskProvider:(_,se)=>(Rt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ni.registerTaskProvider(ze,_,se)),registerFileSystemProvider(_,se,Le){return(0,F.$Rc)(Nt.registerFileSystemProvider(ze,_,se,Le),Kt.addFileSystemProvider(_,se,Le))},get fs(){return Kt.value},registerFileSearchProvider:(_,se)=>((0,Ze.$OG)(ze,"fileSearchProvider"),fi.registerFileSearchProvider(_,se)),registerTextSearchProvider:(_,se)=>((0,Ze.$OG)(ze,"textSearchProvider"),fi.registerTextSearchProvider(_,se)),registerAITextSearchProvider:(_,se)=>((0,Ze.$OG)(ze,"aiTextSearchProvider"),(0,Ze.$OG)(ze,"textSearchProvider"),fi.registerAITextSearchProvider(_,se)),registerRemoteAuthorityResolver:(_,se)=>((0,Ze.$OG)(ze,"resolvers"),Ft.registerRemoteAuthorityResolver(_,se)),registerResourceLabelFormatter:_=>((0,Ze.$OG)(ze,"resolvers"),Fi.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$OG)(ze,"resolvers"),Ft.getRemoteExecServer(_)),onDidCreateFiles:(_,se,Le)=>nt(Lt.onDidCreateFile)(_,se,Le),onDidDeleteFiles:(_,se,Le)=>nt(Lt.onDidDeleteFile)(_,se,Le),onDidRenameFiles:(_,se,Le)=>nt(Lt.onDidRenameFile)(_,se,Le),onWillCreateFiles:(_,se,Le)=>nt(Lt.getOnWillCreateFileEvent(ze))(_,se,Le),onWillDeleteFiles:(_,se,Le)=>nt(Lt.getOnWillDeleteFileEvent(ze))(_,se,Le),onWillRenameFiles:(_,se,Le)=>nt(Lt.getOnWillRenameFileEvent(ze))(_,se,Le),openTunnel:_=>((0,Ze.$OG)(ze,"tunnels"),jt.openTunnel(ze,_).then(se=>{if(!se)throw new Error("cannot open tunnel");return se})),get tunnels(){return(0,Ze.$OG)(ze,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(_,se,Le)=>((0,Ze.$OG)(ze,"tunnels"),nt(jt.onDidChangeTunnels)(_,se,Le)),registerPortAttributesProvider:(_,se)=>((0,Ze.$OG)(ze,"portsAttributes"),jt.registerPortsAttributesProvider(_,se)),registerTunnelProvider:(_,se)=>((0,Ze.$OG)(ze,"tunnelFactory"),jt.registerTunnelProvider(_,se)),registerTimelineProvider:(_,se)=>((0,Ze.$OG)(ze,"timeline"),Qi.registerTimelineProvider(_,se,ze.identifier,$t.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:_=>((0,Ze.$OG)(ze,"workspaceTrust"),gt.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,se,Le)=>nt(gt.onDidGrantWorkspaceTrust)(_,se,Le),registerEditSessionIdentityProvider:(_,se)=>((0,Ze.$OG)(ze,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(_,se)),onWillCreateEditSessionIdentity:(_,se,Le)=>((0,Ze.$OG)(ze,"editSessionIdentityProvider"),nt(gt.getOnWillCreateEditSessionIdentityEvent(ze))(_,se,Le)),registerCanonicalUriProvider:(_,se)=>((0,Ze.$OG)(ze,"canonicalUriProvider"),gt.registerCanonicalUriProvider(_,se)),getCanonicalUri:(_,se,Le)=>((0,Ze.$OG)(ze,"canonicalUriProvider"),gt.provideCanonicalUri(_,se,Le))},rn={get inputBox(){return Rt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ii.getLastInputBox(ze)},createSourceControl(_,se,Le){return Ii.createSourceControl(ze,_,se,Le)}},wn={createCommentController(_,se){return Ni.createCommentController(ze,_,se)}},sn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(_,se){return(0,Ze.$OG)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,_,se)},registerDebugVisualizationTreeProvider(_,se){return(0,Ze.$OG)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,_,se)},onDidStartDebugSession(_,se,Le){return nt(kt.onDidStartDebugSession)(_,se,Le)},onDidTerminateDebugSession(_,se,Le){return nt(kt.onDidTerminateDebugSession)(_,se,Le)},onDidChangeActiveDebugSession(_,se,Le){return nt(kt.onDidChangeActiveDebugSession)(_,se,Le)},onDidReceiveDebugSessionCustomEvent(_,se,Le){return nt(kt.onDidReceiveDebugSessionCustomEvent)(_,se,Le)},onDidChangeBreakpoints(_,se,Le){return nt(kt.onDidChangeBreakpoints)(_,se,Le)},onDidChangeActiveStackItem(_,se,Le){return nt(kt.onDidChangeActiveStackItem)(_,se,Le)},registerDebugConfigurationProvider(_,se,Le){return kt.registerDebugConfigurationProvider(_,se,Le||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,se){return kt.registerDebugAdapterDescriptorFactory(ze,_,se)},registerDebugAdapterTrackerFactory(_,se){return kt.registerDebugAdapterTrackerFactory(_,se)},startDebugging(_,se,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(_,se,{parentSession:Le}):kt.startDebugging(_,se,Le||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,se){return kt.asDebugSourceUri(_,se)}},on={registerTaskProvider:(_,se)=>ni.registerTaskProvider(ze,_,se),fetchTasks:_=>ni.fetchTasks(_),executeTask:_=>ni.executeTask(ze,_),get taskExecutions(){return ni.taskExecutions},onDidStartTask:(_,se,Le)=>nt(ni.onDidStartTask)(_,se,Le),onDidEndTask:(_,se,Le)=>nt(ni.onDidEndTask)(_,se,Le),onDidStartTaskProcess:(_,se,Le)=>nt(ni.onDidStartTaskProcess)(_,se,Le),onDidEndTaskProcess:(_,se,Le)=>nt(ni.onDidEndTaskProcess)(_,se,Le)},bn={createNotebookController(_,se,Le,ot,vt){return J.createNotebookController(ze,_,se,Le,ot,(0,Ze.$NG)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(_,se)=>we.registerNotebookCellStatusBarItemProvider(ze,_,se),createRendererMessaging(_){return Re.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$OG)(ze,"notebookKernelSource"),J.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,se){return(0,Ze.$OG)(ze,"notebookKernelSource"),J.registerKernelSourceActionProvider(ze,_,se)},onDidChangeNotebookCellExecutionState(_,se,Le){return(0,Ze.$OG)(ze,"notebookCellExecutionState"),nt(J.onDidChangeNotebookCellExecutionState)(_,se,Le)}},vn={t(..._){if(typeof _[0]=="string"){const se=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return li.getMessage(ze.identifier.value,{message:se,args:Le})}return li.getMessage(ze.identifier.value,_[0])},get bundle(){return li.getBundle(ze.identifier.value)},get uri(){return li.getBundleUri(ze.identifier.value)}},an={_version:1,transferActiveChat(_){return(0,Ze.$OG)(ze,"interactive"),Ri.transferActiveChat(_)}},Gi={getRelatedInformation(_,se){return(0,Ze.$OG)(ze,"aiRelatedInformation"),ji.getRelatedInformation(ze,_,se)},registerRelatedInformationProvider(_,se){return(0,Ze.$OG)(ze,"aiRelatedInformation"),ji.registerRelatedInformationProvider(ze,_,se)},registerEmbeddingVectorProvider(_,se){return(0,Ze.$OG)(ze,"aiRelatedInformation"),gn.registerEmbeddingVectorProvider(ze,_,se)}},cn={_version:1,registerChatResponseProvider(_,se,Le){return(0,Ze.$OG)(ze,"chatProvider"),qt.registerLanguageModel(ze,_,se,Le)},registerChatVariableResolver(_,se,Le,ot,vt,Ct){return(0,Ze.$OG)(ze,"chatVariableResolver"),Yi.registerVariableResolver(ze,_,se,Le,ot,vt,Ct)},registerMappedEditsProvider(_,se){return(0,Ze.$OG)(ze,"mappedEditsProvider"),ct.registerMappedEditsProvider(ze,_,se)},createChatParticipant(_,se){return Ri.createChatAgent(ze,_,se)},createDynamicChatParticipant(_,se,Le){return(0,Ze.$OG)(ze,"chatParticipantAdditions"),Ri.createDynamicChatAgent(ze,_,se,Le)}},un={selectChatModels:_=>ft.quality==="stable"?(console.warn(`[${v.$Vm.toKey(ze.identifier)}] This API is disabled in '${ft.environment.appName}'-stable.`),Promise.resolve([])):qt.selectLanguageModels(ze,_??{}),onDidChangeChatModels:(_,se,Le)=>ft.quality==="stable"?(console.warn(`[${v.$Vm.toKey(ze.identifier)}] This API is disabled in '${ft.environment.appName}'-stable.`),R.Event.None(_,se,Le)):qt.onDidChangeProviders(_,se,Le),get embeddingModels(){return(0,Ze.$OG)(ze,"embeddings"),pi.embeddingsModels},onDidChangeEmbeddingModels:(_,se,Le)=>((0,Ze.$OG)(ze,"embeddings"),pi.onDidChange(_,se,Le)),registerEmbeddingsProvider(_,se){return(0,Ze.$OG)(ze,"embeddings"),pi.registerEmbeddingsProvider(ze,_,se)},async computeEmbeddings(_,se,Le){return(0,Ze.$OG)(ze,"embeddings"),pi.computeEmbeddings(_,se,Le)}},ln={registerSpeechProvider(_,se){return(0,Ze.$OG)(ze,"speech"),Bi.registerProvider(ze.identifier,_,se)}};return{version:ft.version,ai:Gi,authentication:en,commands:gi,comments:wn,chat:cn,debug:sn,env:ki,extensions:Mi,interactive:an,l10n:vn,languages:tn,lm:un,notebooks:bn,scm:rn,speech:ln,tasks:on,tests:pn,window:nn,workspace:qi,Breakpoint:be.$qN,TerminalOutputAnchor:be.TerminalOutputAnchor,ChatResultFeedbackKind:be.ChatResultFeedbackKind,ChatVariableLevel:be.ChatVariableLevel,ChatCompletionItem:be.$lO,CallHierarchyIncomingCall:be.$OM,CallHierarchyItem:be.$NM,CallHierarchyOutgoingCall:be.$PM,CancellationError:O.$5,CancellationTokenSource:C.$se,CandidatePortSource:t.CandidatePortSource,CodeAction:be.$KM,CodeActionKind:be.$LM,CodeActionTriggerKind:be.CodeActionTriggerKind,CodeLens:be.$QM,Color:be.$4M,ColorInformation:be.$5M,ColorPresentation:be.$6M,ColorThemeKind:be.ColorThemeKind,CommentMode:be.CommentMode,CommentState:be.CommentState,CommentThreadCollapsibleState:be.CommentThreadCollapsibleState,CommentThreadState:be.CommentThreadState,CommentThreadApplicability:be.CommentThreadApplicability,CompletionItem:be.$XM,CompletionItemKind:be.CompletionItemKind,CompletionItemTag:be.CompletionItemTag,CompletionList:be.$YM,CompletionTriggerKind:be.CompletionTriggerKind,ConfigurationTarget:be.ConfigurationTarget,CustomExecution:be.$bN,DebugAdapterExecutable:be.$uN,DebugAdapterInlineImplementation:be.$xN,DebugAdapterNamedPipeServer:be.$wN,DebugAdapterServer:be.$vN,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:be.DebugConsoleMode,DebugVisualization:be.$NN,DecorationRangeBehavior:be.DecorationRangeBehavior,Diagnostic:be.$DM,DiagnosticRelatedInformation:be.$CM,DiagnosticSeverity:be.DiagnosticSeverity,DiagnosticTag:be.DiagnosticTag,Disposable:be.$pM,DocumentHighlight:be.$GM,DocumentHighlightKind:be.DocumentHighlightKind,MultiDocumentHighlight:be.$HM,DocumentLink:be.$3M,DocumentSymbol:be.$JM,EndOfLine:be.EndOfLine,EnvironmentVariableMutatorType:be.EnvironmentVariableMutatorType,EvaluatableExpression:be.$AN,InlineValueText:be.$BN,InlineValueVariableLookup:be.$CN,InlineValueEvaluatableExpression:be.$DN,InlineCompletionTriggerKind:be.InlineCompletionTriggerKind,EventEmitter:R.$he,ExtensionKind:be.ExtensionKind,ExtensionMode:be.ExtensionMode,ExternalUriOpenerPriority:be.ExternalUriOpenerPriority,FileChangeType:be.FileChangeType,FileDecoration:be.$PN,FileDecoration2:be.$PN,FileSystemError:be.$GN,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:be.$HN,FoldingRangeKind:be.FoldingRangeKind,FunctionBreakpoint:be.$sN,InlineCompletionItem:be.$ZM,InlineCompletionList:be.$1M,Hover:be.$EM,VerboseHover:be.$FM,HoverVerbosityAction:be.HoverVerbosityAction,IndentAction:S.IndentAction,Location:be.$BM,MarkdownString:be.$RM,OverviewRulerLane:d.OverviewRulerLane,ParameterInformation:be.$SM,PortAutoForwardAction:be.PortAutoForwardAction,Position:be.$qM,ProcessExecution:be.$_M,ProgressLocation:be.ProgressLocation,QuickInputButtons:be.$ON,Range:be.$rM,RelativePattern:be.$oN,Selection:be.$sM,SelectionRange:be.$MM,SemanticTokens:be.$KN,SemanticTokensBuilder:be.$JN,SemanticTokensEdit:be.$LN,SemanticTokensEdits:be.$MN,SemanticTokensLegend:be.$IN,ShellExecution:be.$aN,ShellQuoting:be.ShellQuoting,SignatureHelp:be.$UM,SignatureHelpTriggerKind:be.SignatureHelpTriggerKind,SignatureInformation:be.$TM,SnippetString:be.$AM,SourceBreakpoint:be.$rN,StandardTokenType:be.StandardTokenType,StatusBarAlignment:be.StatusBarAlignment,SymbolInformation:be.$IM,SymbolKind:be.SymbolKind,SymbolTag:be.SymbolTag,Task:be.$cN,TaskGroup:be.$$M,TaskPanelKind:be.TaskPanelKind,TaskRevealKind:be.TaskRevealKind,TaskScope:be.TaskScope,TerminalLink:be.$7M,TerminalQuickFixTerminalCommand:be.$9M,TerminalQuickFixOpener:be.$8M,TerminalLocation:be.TerminalLocation,TerminalProfile:be.$0M,TerminalExitReason:be.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:be.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:be.TextDocumentSaveReason,TextEdit:be.$wM,SnippetTextEdit:be.$yM,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:be.TextEditorLineNumbersStyle,TextEditorRevealType:be.TextEditorRevealType,TextEditorSelectionChangeKind:be.TextEditorSelectionChangeKind,SyntaxTokenType:be.SyntaxTokenType,TextDocumentChangeReason:be.TextDocumentChangeReason,ThemeColor:be.$nN,ThemeIcon:be.$mN,TreeItem:be.$dN,TreeItemCheckboxState:be.TreeItemCheckboxState,TreeItemCollapsibleState:be.TreeItemCollapsibleState,TypeHierarchyItem:be.$_N,UIKind:Yt.UIKind,Uri:m.URI,ViewColumn:be.ViewColumn,WorkspaceEdit:be.$zM,DocumentPasteTriggerKind:be.DocumentPasteTriggerKind,DocumentDropEdit:be.$jN,DocumentDropOrPasteEditKind:be.$kN,DocumentPasteEdit:be.$lN,InlayHint:be.$WM,InlayHintLabelPart:be.$VM,InlayHintKind:be.InlayHintKind,RemoteAuthorityResolverError:be.$vM,ResolvedAuthority:be.$tM,ManagedResolvedAuthority:be.$uM,SourceControlInputBoxValidationType:be.SourceControlInputBoxValidationType,ExtensionRuntime:be.ExtensionRuntime,TimelineItem:be.$ZN,NotebookRange:be.$RN,NotebookCellKind:be.NotebookCellKind,NotebookCellExecutionState:be.NotebookCellExecutionState,NotebookCellData:be.$SN,NotebookData:be.$TN,NotebookRendererScript:be.$XN,NotebookCellStatusBarAlignment:be.NotebookCellStatusBarAlignment,NotebookEditorRevealType:be.NotebookEditorRevealType,NotebookCellOutput:be.$VN,NotebookCellOutputItem:be.$UN,NotebookCellStatusBarItem:be.$WN,NotebookControllerAffinity:be.NotebookControllerAffinity,NotebookControllerAffinity2:be.NotebookControllerAffinity2,NotebookEdit:be.$xM,NotebookKernelSourceAction:be.$YN,NotebookVariablesRequestKind:be.NotebookVariablesRequestKind,PortAttributes:be.$2N,LinkedEditingRanges:be.$1N,TestResultState:be.TestResultState,TestRunRequest:be.$3N,TestMessage:be.$4N,TestTag:be.$5N,TestRunProfileKind:be.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:be.$iN,DataTransferItem:be.$eN,TestCoverageCount:be.$6N,FileCoverage:be.$8N,FileCoverage2:be.$8N,StatementCoverage:be.$9N,BranchCoverage:be.$0N,DeclarationCoverage:be.$$N,WorkspaceTrustState:be.WorkspaceTrustState,LanguageStatusSeverity:be.LanguageStatusSeverity,QuickPickItemKind:be.QuickPickItemKind,InputBoxValidationSeverity:be.InputBoxValidationSeverity,TabInputText:be.$aO,TabInputTextDiff:be.$bO,TabInputTextMerge:be.$cO,TabInputCustom:be.$dO,TabInputNotebook:be.$fO,TabInputNotebookDiff:be.$gO,TabInputWebview:be.$eO,TabInputTerminal:be.$hO,TabInputInteractiveWindow:be.$iO,TabInputChat:be.$jO,TabInputTextMultiDiff:be.$kO,TelemetryTrustedValue:o.$lp,LogLevel:s.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:be.InteractiveSessionVoteDirection,ChatCopyKind:be.ChatCopyKind,InteractiveEditorResponseFeedbackKind:be.InteractiveEditorResponseFeedbackKind,DebugStackFrame:be.$yN,DebugThread:be.$zN,RelatedInformationType:be.RelatedInformationType,SpeechToTextStatus:be.SpeechToTextStatus,TextToSpeechStatus:be.TextToSpeechStatus,PartialAcceptTriggerKind:be.PartialAcceptTriggerKind,KeywordRecognitionStatus:be.KeywordRecognitionStatus,ChatResponseMarkdownPart:be.$mO,ChatResponseFileTreePart:be.$qO,ChatResponseAnchorPart:be.$rO,ChatResponseProgressPart:be.$sO,ChatResponseProgressPart2:be.$tO,ChatResponseReferencePart:be.$wO,ChatResponseWarningPart:be.$uO,ChatResponseTextEditPart:be.$xO,ChatResponseMarkdownWithVulnerabilitiesPart:be.$nO,ChatResponseCommandButtonPart:be.$vO,ChatResponseDetectedParticipantPart:be.$oO,ChatResponseConfirmationPart:be.$pO,ChatRequestTurn:be.$yO,ChatResponseTurn:be.$zO,ChatLocation:be.ChatLocation,LanguageModelChatMessageRole:be.LanguageModelChatMessageRole,LanguageModelChatMessage:be.$AO,LanguageModelChatMessage2:be.$AO,LanguageModelChatSystemMessage:be.$BO,LanguageModelChatUserMessage:be.$CO,LanguageModelChatAssistantMessage:be.$DO,LanguageModelError:be.$EO,NewSymbolName:be.$FN,NewSymbolNameTag:be.NewSymbolNameTag,NewSymbolNameTriggerKind:be.NewSymbolNameTriggerKind,InlineEdit:be.$FO,InlineEditTriggerKind:be.InlineEditTriggerKind}}}}),define(ke[308],Se([1,0,56,118,39,112,40,35,68,53,121,123,124,84,88,80,111,65,47,83,63,67,248,12,122,81,82,86,90,116]),function(he,e,C,O,R,F,M,p,m,D,N,S,d,v,f,s,r,o,n,t,c,u,i,w,a,l,g,$,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Ds)(l.$anc,l.$_mc,1),(0,C.$Ds)(w.$8j,i.$noc,1),(0,C.$Ds)(s.$fmc,s.$gmc,1),(0,C.$Ds)(p.$bP,p.$aP,0),(0,C.$Ds)($.$pmc,$.$qmc,0),(0,C.$Ds)(b.$7mc,b.$8mc,0),(0,C.$Ds)(M.$Emc,M.$Cmc,0),(0,C.$Ds)(o.$Gmc,o.$Fmc,0),(0,C.$Ds)(S.$knc,S.$onc,0),(0,C.$Ds)(F.$qnc,F.$pnc,0),(0,C.$Ds)(m.$3O,m.$2O,0),(0,C.$Ds)(g.$bnc,g.$cnc,0),(0,C.$Ds)(n.$jmc,n.$imc,0),(0,C.$Ds)(O.$Vnc,O.$Unc,1),(0,C.$Ds)(d.$Gnc,d.$Hnc,0),(0,C.$Ds)(v.$Zmc,v.$Ymc,0),(0,C.$Ds)(N.$9nc,N.$8nc,0),(0,C.$Ds)(D.$3mc,D.$6mc,0),(0,C.$Ds)(y.$0nc,y.$$nc,0),(0,C.$Ds)(f.$_Db,f.$aEb,0),(0,C.$Ds)(r.$loc,r.$koc,0),(0,C.$Ds)(R.$Bmc,R.$Amc,0),(0,C.$Ds)(t.$0mc,t.$9mc,0),(0,C.$Ds)(c.$_O,c.$9O,0),(0,C.$Ds)(u.$Qmc,u.$Rmc,0),(0,C.$Ds)(a.$inc,a.$jnc,0)}),define(ke[309],Se([1,0,307,41,2,304,7,11,254]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xqc=void 0;class D extends F.$qoc{j(){}getModule(v,f){for(const s of this.b){const r=s(v);if(r){v=r;break}}if(this.a.has(v))return this.a.get(v).load(v,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends O.$enc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$wqc);const v=this.h.invokeFunction(C.$moc);this.r=this.h.createInstance(D,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(v){return v.browser}async xb(v,f,s){f=f.with({path:S(f.path,".js")});const r=v?.identifier.value;r&&performance.mark(`code/extHost/willFetchExtensionCode/${r}`);const o=R.URI.revive(await this.C.$asBrowserUri(f)),n=await fetch(o.toString(!0));if(r&&performance.mark(`code/extHost/didFetchExtensionCode/${r}`),n.status!==200)throw new Error(n.statusText);const t=await n.text(),c=`${f.toString(!0)}#vscode-extension`,u=`${t}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",u)}catch(g){throw console.error(r?`Loading code for extension ${r} failed: ${g.message}`:`Loading code failed: ${g.message}`),console.error(`${f.toString(!0)}${typeof g.line=="number"?` line ${g.line}`:""}${typeof g.column=="number"?` column ${g.column}`:""}`),console.error(g),g}v&&await this.w.initializeLocalizedMessages(v);const w={},a={exports:w},l=g=>{const $=this.r.getModule(g,f);if($===void 0)throw new Error(`Cannot load module '${g}'`);return $};try{return s.codeLoadingStart(),r&&performance.mark(`code/extHost/willLoadExtensionCode/${r}`),i(a,w,l),a.exports!==w?a.exports:w}finally{r&&performance.mark(`code/extHost/didLoadExtensionCode/${r}`),s.codeLoadingStop()}}async $setRemoteEnvironment(v){}async Bb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+v;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,p.$Bh)(10)}}e.$xqc=N;function S(d,v){return d.endsWith(v)?d:d+v}}),define(ke[310],Se([1,0,71,56,12,41,217,87,309]),function(he,e,C,O,R,F,M,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$Ds)(R.$7j,new C.$xi(M.$poc,[!0],!0)),(0,O.$Ds)(F.$fnc,m.$xqc,0),(0,O.$Ds)(p.$Hmc,p.$Imc,0)}),define(ke[316],Se([1,0,22,5,79,305,256,19,60,16,2,308,310]),function(he,e,C,O,R,F,M,p,m,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=u;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const d=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(i){return/^(file|vscode-remote):/i.test(i)}const f=fetch.bind(self);function s(i){self.fetch=async function(w,a){return w instanceof Request||v(String(w))&&(w=(await i(N.URI.parse(String(w)))).toString(!0)),f(w,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(w,a,l,g,$){(async()=>(v(a.toString())&&(a=(await i(N.URI.parse(a.toString()))).toString(!0)),super.open(w,a,l??!0,g,$)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(w,a){if(/^file:/i.test(w.toString()))w=D.$Ug.uriToBrowserUri(N.URI.parse(w.toString())).toString(!0);else if(/^vscode-remote:/i.test(w.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const g=`(${function(h){function E(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const k=fetch.bind(self);self.fetch=function(P,V){return P instanceof Request?k(P,V):k(E(P),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,V,W,q,A){return super.open(P,E(V),W??!0,q,A)}};const I=importScripts.bind(self);self.importScripts=(...P)=>{I(...P.map(E))},I(h)}.toString()}('${w}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$nc(w.toString())}`;const $=new Blob([g],{type:"application/javascript"}),b=URL.createObjectURL($);return new i(b,a)}}else self.Worker=class extends M.$yqc{constructor(i,w){super(d,i,{name:p.$nc(i.toString()),...w})}};const r=new class{constructor(){this.pid=void 0}exit(i){S()}};class o{constructor(){const w=new MessageChannel,a=new O.$he;let l=!1;d(w.port2,[w.port2]),w.port1.onmessage=g=>{const{data:$}=g;if(!($ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",$);return}const b=C.$Je.wrap(new Uint8Array($,0,$.byteLength));if((0,R.$5m)(b,2)){l=!0,t("received terminate message from renderer");return}a.fire(b)},this.protocol={onMessage:a.event,send:g=>{if(!l){const $=g.buffer.buffer.slice(g.buffer.byteOffset,g.buffer.byteOffset+g.buffer.byteLength);w.port1.postMessage($,[$])}}}}}function n(i){return new Promise(w=>{const a=i.onMessage(l=>{a.dispose();const g=JSON.parse(l.toString());i.send((0,R.$4m)(0)),w({protocol:i,initData:g})});i.send((0,R.$4m)(1))})}let t=i=>S();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function u(){m.mark("code/extHost/willConnectToRenderer");const i=new o;return{onmessage(w){c(w)&&n(i.protocol).then(a=>{m.mark("code/extHost/didWaitForInitData");const l=new F.$soc(a.protocol,a.initData,r,null,w.data);s(g=>l.asBrowserUri(g)),t=g=>l.terminate(g)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f209ce35ef894bd32c12057724e8d1f1139c433f/core/vs/workbench/api/worker/extensionHostWorker.js.map
